/* ------------------------------------------------------------------------

   unicodedatabase -- The Unicode 3.0 data base.

   Data was extracted from the Unicode 3.0 UnicodeData.txt file.

Written by Marc-Andre Lemburg (mal@lemburg.com).

(c) Copyright CNRI, All Rights Reserved. NO WARRANTY.

   ------------------------------------------------------------------------ */

#include "unicodedatabase.h"

/* --- Unicode category names --------------------------------------------- */

const char *_PyUnicode_CategoryNames[32] = {

    "Cn", /*  Not assigned (also see below) */

    /* Normative Categories */

    "Lu", /* Letter, Uppercase */
    "Ll", /* Letter, Lowercase */
    "Lt", /* Letter, Titlecase */
    "Mn", /* Mark, Non-Spacing */
    "Mc", /* Mark, Spacing Combining */
    "Me", /* Mark, Enclosing */
    "Nd", /* Number, Decimal Digit */
    "Nl", /* Number, Letter */
    "No", /* Number, Other */
    "Zs", /* Separator, Space */
    "Zl", /* Separator, Line */
    "Zp", /* Separator, Paragraph */
    "Cc", /* Other, Control */
    "Cf", /* Other, Format */
    "Cs", /* Other, Surrogate */
    "Co", /* Other, Private Use */
    "Cn", /* Other, Not Assigned (no characters in the file
	     have this property) */

     /* Informative Categories */

    "Lm", /* Letter, Modifier */
    "Lo", /* Letter, Other */
    "Pc", /* Punctuation, Connector */
    "Pd", /* Punctuation, Dash */
    "Ps", /* Punctuation, Open */
    "Pe", /* Punctuation, Close */
    "Pi", /* Punctuation, Initial quote (may behave like Ps or Pe 
	     depending on usage) */
    "Pf", /* Punctuation, Final quote (may behave like Ps or Pe 
	     depending on usage) */
    "Po", /* Punctuation, Other */
    "Sm", /* Symbol, Math */
    "Sc", /* Symbol, Currency */
    "Sk", /* Symbol, Modifier */
    "So", /* Symbol, Other */

    0  /* Sentinel */
};

const char *_PyUnicode_BidirectionalNames[21] = {

    "",	 /*  Undefined (added so that the 0 index maps to undefined) */
    
    "L", /* Left-to-Right */
    "LRE", /* Left-to-Right Embedding */
    "LRO", /* Left-to-Right Override */
    "R", /* Right-to-Left */
    "AL", /* Right-to-Left Arabic */
    "RLE", /* Right-to-Left Embedding */
    "RLO", /* Right-to-Left Override */
    "PDF", /* Pop Directional Format */
    "EN", /* European Number */
    "ES", /* European Number Separator */
    "ET", /* European Number Terminator */
    "AN", /* Arabic Number */
    "CS", /* Common Number Separator */
    "NSM", /* Non-Spacing Mark */
    "BN", /* Boundary Neutral */
    "B", /* Paragraph Separator */
    "S", /* Segment Separator */
    "WS", /* Whitespace */
    "ON", /* Other Neutrals */
    
    0  /* Sentinel */
};

/* --- Unicode Database Pages --------------------------------------------- */

const _PyUnicode_DatabaseRecord _PyUnicode_Database_0[4096] = {
    
/* U+0000 */ { 13, 0, 15, 0, 0 },
/* U+0001 */ { 13, 0, 15, 0, 0 },
/* U+0002 */ { 13, 0, 15, 0, 0 },
/* U+0003 */ { 13, 0, 15, 0, 0 },
/* U+0004 */ { 13, 0, 15, 0, 0 },
/* U+0005 */ { 13, 0, 15, 0, 0 },
/* U+0006 */ { 13, 0, 15, 0, 0 },
/* U+0007 */ { 13, 0, 15, 0, 0 },
/* U+0008 */ { 13, 0, 15, 0, 0 },
/* U+0009 */ { 13, 0, 17, 0, 0 },
/* U+000a */ { 13, 0, 16, 0, 0 },
/* U+000b */ { 13, 0, 17, 0, 0 },
/* U+000c */ { 13, 0, 18, 0, 0 },
/* U+000d */ { 13, 0, 16, 0, 0 },
/* U+000e */ { 13, 0, 15, 0, 0 },
/* U+000f */ { 13, 0, 15, 0, 0 },
/* U+0010 */ { 13, 0, 15, 0, 0 },
/* U+0011 */ { 13, 0, 15, 0, 0 },
/* U+0012 */ { 13, 0, 15, 0, 0 },
/* U+0013 */ { 13, 0, 15, 0, 0 },
/* U+0014 */ { 13, 0, 15, 0, 0 },
/* U+0015 */ { 13, 0, 15, 0, 0 },
/* U+0016 */ { 13, 0, 15, 0, 0 },
/* U+0017 */ { 13, 0, 15, 0, 0 },
/* U+0018 */ { 13, 0, 15, 0, 0 },
/* U+0019 */ { 13, 0, 15, 0, 0 },
/* U+001a */ { 13, 0, 15, 0, 0 },
/* U+001b */ { 13, 0, 15, 0, 0 },
/* U+001c */ { 13, 0, 16, 0, 0 },
/* U+001d */ { 13, 0, 16, 0, 0 },
/* U+001e */ { 13, 0, 16, 0, 0 },
/* U+001f */ { 13, 0, 17, 0, 0 },
/* U+0020 */ { 10, 0, 18, 0, 0 },
/* U+0021 */ { 26, 0, 19, 0, 0 },
/* U+0022 */ { 26, 0, 19, 0, 0 },
/* U+0023 */ { 26, 0, 11, 0, 0 },
/* U+0024 */ { 28, 0, 11, 0, 0 },
/* U+0025 */ { 26, 0, 11, 0, 0 },
/* U+0026 */ { 26, 0, 19, 0, 0 },
/* U+0027 */ { 26, 0, 19, 0, 0 },
/* U+0028 */ { 22, 0, 19, 1, 0 },
/* U+0029 */ { 23, 0, 19, 1, 0 },
/* U+002a */ { 26, 0, 19, 0, 0 },
/* U+002b */ { 27, 0, 11, 0, 0 },
/* U+002c */ { 26, 0, 13, 0, 0 },
/* U+002d */ { 21, 0, 11, 0, 0 },
/* U+002e */ { 26, 0, 13, 0, 0 },
/* U+002f */ { 26, 0, 10, 0, 0 },
/* U+0030 */ { 7, 0, 9, 0, 0 },
/* U+0031 */ { 7, 0, 9, 0, 0 },
/* U+0032 */ { 7, 0, 9, 0, 0 },
/* U+0033 */ { 7, 0, 9, 0, 0 },
/* U+0034 */ { 7, 0, 9, 0, 0 },
/* U+0035 */ { 7, 0, 9, 0, 0 },
/* U+0036 */ { 7, 0, 9, 0, 0 },
/* U+0037 */ { 7, 0, 9, 0, 0 },
/* U+0038 */ { 7, 0, 9, 0, 0 },
/* U+0039 */ { 7, 0, 9, 0, 0 },
/* U+003a */ { 26, 0, 13, 0, 0 },
/* U+003b */ { 26, 0, 19, 0, 0 },
/* U+003c */ { 27, 0, 19, 1, 0 },
/* U+003d */ { 27, 0, 19, 0, 0 },
/* U+003e */ { 27, 0, 19, 1, 0 },
/* U+003f */ { 26, 0, 19, 0, 0 },
/* U+0040 */ { 26, 0, 19, 0, 0 },
/* U+0041 */ { 1, 0, 1, 0, 0 },
/* U+0042 */ { 1, 0, 1, 0, 0 },
/* U+0043 */ { 1, 0, 1, 0, 0 },
/* U+0044 */ { 1, 0, 1, 0, 0 },
/* U+0045 */ { 1, 0, 1, 0, 0 },
/* U+0046 */ { 1, 0, 1, 0, 0 },
/* U+0047 */ { 1, 0, 1, 0, 0 },
/* U+0048 */ { 1, 0, 1, 0, 0 },
/* U+0049 */ { 1, 0, 1, 0, 0 },
/* U+004a */ { 1, 0, 1, 0, 0 },
/* U+004b */ { 1, 0, 1, 0, 0 },
/* U+004c */ { 1, 0, 1, 0, 0 },
/* U+004d */ { 1, 0, 1, 0, 0 },
/* U+004e */ { 1, 0, 1, 0, 0 },
/* U+004f */ { 1, 0, 1, 0, 0 },
/* U+0050 */ { 1, 0, 1, 0, 0 },
/* U+0051 */ { 1, 0, 1, 0, 0 },
/* U+0052 */ { 1, 0, 1, 0, 0 },
/* U+0053 */ { 1, 0, 1, 0, 0 },
/* U+0054 */ { 1, 0, 1, 0, 0 },
/* U+0055 */ { 1, 0, 1, 0, 0 },
/* U+0056 */ { 1, 0, 1, 0, 0 },
/* U+0057 */ { 1, 0, 1, 0, 0 },
/* U+0058 */ { 1, 0, 1, 0, 0 },
/* U+0059 */ { 1, 0, 1, 0, 0 },
/* U+005a */ { 1, 0, 1, 0, 0 },
/* U+005b */ { 22, 0, 19, 1, 0 },
/* U+005c */ { 26, 0, 19, 0, 0 },
/* U+005d */ { 23, 0, 19, 1, 0 },
/* U+005e */ { 29, 0, 19, 0, 0 },
/* U+005f */ { 20, 0, 19, 0, 0 },
/* U+0060 */ { 29, 0, 19, 0, 0 },
/* U+0061 */ { 2, 0, 1, 0, 0 },
/* U+0062 */ { 2, 0, 1, 0, 0 },
/* U+0063 */ { 2, 0, 1, 0, 0 },
/* U+0064 */ { 2, 0, 1, 0, 0 },
/* U+0065 */ { 2, 0, 1, 0, 0 },
/* U+0066 */ { 2, 0, 1, 0, 0 },
/* U+0067 */ { 2, 0, 1, 0, 0 },
/* U+0068 */ { 2, 0, 1, 0, 0 },
/* U+0069 */ { 2, 0, 1, 0, 0 },
/* U+006a */ { 2, 0, 1, 0, 0 },
/* U+006b */ { 2, 0, 1, 0, 0 },
/* U+006c */ { 2, 0, 1, 0, 0 },
/* U+006d */ { 2, 0, 1, 0, 0 },
/* U+006e */ { 2, 0, 1, 0, 0 },
/* U+006f */ { 2, 0, 1, 0, 0 },
/* U+0070 */ { 2, 0, 1, 0, 0 },
/* U+0071 */ { 2, 0, 1, 0, 0 },
/* U+0072 */ { 2, 0, 1, 0, 0 },
/* U+0073 */ { 2, 0, 1, 0, 0 },
/* U+0074 */ { 2, 0, 1, 0, 0 },
/* U+0075 */ { 2, 0, 1, 0, 0 },
/* U+0076 */ { 2, 0, 1, 0, 0 },
/* U+0077 */ { 2, 0, 1, 0, 0 },
/* U+0078 */ { 2, 0, 1, 0, 0 },
/* U+0079 */ { 2, 0, 1, 0, 0 },
/* U+007a */ { 2, 0, 1, 0, 0 },
/* U+007b */ { 22, 0, 19, 1, 0 },
/* U+007c */ { 27, 0, 19, 0, 0 },
/* U+007d */ { 23, 0, 19, 1, 0 },
/* U+007e */ { 27, 0, 19, 0, 0 },
/* U+007f */ { 13, 0, 15, 0, 0 },
/* U+0080 */ { 13, 0, 15, 0, 0 },
/* U+0081 */ { 13, 0, 15, 0, 0 },
/* U+0082 */ { 13, 0, 15, 0, 0 },
/* U+0083 */ { 13, 0, 15, 0, 0 },
/* U+0084 */ { 13, 0, 15, 0, 0 },
/* U+0085 */ { 13, 0, 16, 0, 0 },
/* U+0086 */ { 13, 0, 15, 0, 0 },
/* U+0087 */ { 13, 0, 15, 0, 0 },
/* U+0088 */ { 13, 0, 15, 0, 0 },
/* U+0089 */ { 13, 0, 15, 0, 0 },
/* U+008a */ { 13, 0, 15, 0, 0 },
/* U+008b */ { 13, 0, 15, 0, 0 },
/* U+008c */ { 13, 0, 15, 0, 0 },
/* U+008d */ { 13, 0, 15, 0, 0 },
/* U+008e */ { 13, 0, 15, 0, 0 },
/* U+008f */ { 13, 0, 15, 0, 0 },
/* U+0090 */ { 13, 0, 15, 0, 0 },
/* U+0091 */ { 13, 0, 15, 0, 0 },
/* U+0092 */ { 13, 0, 15, 0, 0 },
/* U+0093 */ { 13, 0, 15, 0, 0 },
/* U+0094 */ { 13, 0, 15, 0, 0 },
/* U+0095 */ { 13, 0, 15, 0, 0 },
/* U+0096 */ { 13, 0, 15, 0, 0 },
/* U+0097 */ { 13, 0, 15, 0, 0 },
/* U+0098 */ { 13, 0, 15, 0, 0 },
/* U+0099 */ { 13, 0, 15, 0, 0 },
/* U+009a */ { 13, 0, 15, 0, 0 },
/* U+009b */ { 13, 0, 15, 0, 0 },
/* U+009c */ { 13, 0, 15, 0, 0 },
/* U+009d */ { 13, 0, 15, 0, 0 },
/* U+009e */ { 13, 0, 15, 0, 0 },
/* U+009f */ { 13, 0, 15, 0, 0 },
/* U+00a0 */ { 10, 0, 13, 0, "<noBreak> 0020" },
/* U+00a1 */ { 26, 0, 19, 0, 0 },
/* U+00a2 */ { 28, 0, 11, 0, 0 },
/* U+00a3 */ { 28, 0, 11, 0, 0 },
/* U+00a4 */ { 28, 0, 11, 0, 0 },
/* U+00a5 */ { 28, 0, 11, 0, 0 },
/* U+00a6 */ { 30, 0, 19, 0, 0 },
/* U+00a7 */ { 30, 0, 19, 0, 0 },
/* U+00a8 */ { 29, 0, 19, 0, "<compat> 0020 0308" },
/* U+00a9 */ { 30, 0, 19, 0, 0 },
/* U+00aa */ { 2, 0, 1, 0, "<super> 0061" },
/* U+00ab */ { 24, 0, 19, 1, 0 },
/* U+00ac */ { 27, 0, 19, 0, 0 },
/* U+00ad */ { 21, 0, 19, 0, 0 },
/* U+00ae */ { 30, 0, 19, 0, 0 },
/* U+00af */ { 29, 0, 19, 0, "<compat> 0020 0304" },
/* U+00b0 */ { 30, 0, 11, 0, 0 },
/* U+00b1 */ { 27, 0, 11, 0, 0 },
/* U+00b2 */ { 9, 0, 9, 0, "<super> 0032" },
/* U+00b3 */ { 9, 0, 9, 0, "<super> 0033" },
/* U+00b4 */ { 29, 0, 19, 0, "<compat> 0020 0301" },
/* U+00b5 */ { 2, 0, 1, 0, "<compat> 03BC" },
/* U+00b6 */ { 30, 0, 19, 0, 0 },
/* U+00b7 */ { 26, 0, 19, 0, 0 },
/* U+00b8 */ { 29, 0, 19, 0, "<compat> 0020 0327" },
/* U+00b9 */ { 9, 0, 9, 0, "<super> 0031" },
/* U+00ba */ { 2, 0, 1, 0, "<super> 006F" },
/* U+00bb */ { 25, 0, 19, 1, 0 },
/* U+00bc */ { 9, 0, 19, 0, "<fraction> 0031 2044 0034" },
/* U+00bd */ { 9, 0, 19, 0, "<fraction> 0031 2044 0032" },
/* U+00be */ { 9, 0, 19, 0, "<fraction> 0033 2044 0034" },
/* U+00bf */ { 26, 0, 19, 0, 0 },
/* U+00c0 */ { 1, 0, 1, 0, "0041 0300" },
/* U+00c1 */ { 1, 0, 1, 0, "0041 0301" },
/* U+00c2 */ { 1, 0, 1, 0, "0041 0302" },
/* U+00c3 */ { 1, 0, 1, 0, "0041 0303" },
/* U+00c4 */ { 1, 0, 1, 0, "0041 0308" },
/* U+00c5 */ { 1, 0, 1, 0, "0041 030A" },
/* U+00c6 */ { 1, 0, 1, 0, 0 },
/* U+00c7 */ { 1, 0, 1, 0, "0043 0327" },
/* U+00c8 */ { 1, 0, 1, 0, "0045 0300" },
/* U+00c9 */ { 1, 0, 1, 0, "0045 0301" },
/* U+00ca */ { 1, 0, 1, 0, "0045 0302" },
/* U+00cb */ { 1, 0, 1, 0, "0045 0308" },
/* U+00cc */ { 1, 0, 1, 0, "0049 0300" },
/* U+00cd */ { 1, 0, 1, 0, "0049 0301" },
/* U+00ce */ { 1, 0, 1, 0, "0049 0302" },
/* U+00cf */ { 1, 0, 1, 0, "0049 0308" },
/* U+00d0 */ { 1, 0, 1, 0, 0 },
/* U+00d1 */ { 1, 0, 1, 0, "004E 0303" },
/* U+00d2 */ { 1, 0, 1, 0, "004F 0300" },
/* U+00d3 */ { 1, 0, 1, 0, "004F 0301" },
/* U+00d4 */ { 1, 0, 1, 0, "004F 0302" },
/* U+00d5 */ { 1, 0, 1, 0, "004F 0303" },
/* U+00d6 */ { 1, 0, 1, 0, "004F 0308" },
/* U+00d7 */ { 27, 0, 19, 0, 0 },
/* U+00d8 */ { 1, 0, 1, 0, 0 },
/* U+00d9 */ { 1, 0, 1, 0, "0055 0300" },
/* U+00da */ { 1, 0, 1, 0, "0055 0301" },
/* U+00db */ { 1, 0, 1, 0, "0055 0302" },
/* U+00dc */ { 1, 0, 1, 0, "0055 0308" },
/* U+00dd */ { 1, 0, 1, 0, "0059 0301" },
/* U+00de */ { 1, 0, 1, 0, 0 },
/* U+00df */ { 2, 0, 1, 0, 0 },
/* U+00e0 */ { 2, 0, 1, 0, "0061 0300" },
/* U+00e1 */ { 2, 0, 1, 0, "0061 0301" },
/* U+00e2 */ { 2, 0, 1, 0, "0061 0302" },
/* U+00e3 */ { 2, 0, 1, 0, "0061 0303" },
/* U+00e4 */ { 2, 0, 1, 0, "0061 0308" },
/* U+00e5 */ { 2, 0, 1, 0, "0061 030A" },
/* U+00e6 */ { 2, 0, 1, 0, 0 },
/* U+00e7 */ { 2, 0, 1, 0, "0063 0327" },
/* U+00e8 */ { 2, 0, 1, 0, "0065 0300" },
/* U+00e9 */ { 2, 0, 1, 0, "0065 0301" },
/* U+00ea */ { 2, 0, 1, 0, "0065 0302" },
/* U+00eb */ { 2, 0, 1, 0, "0065 0308" },
/* U+00ec */ { 2, 0, 1, 0, "0069 0300" },
/* U+00ed */ { 2, 0, 1, 0, "0069 0301" },
/* U+00ee */ { 2, 0, 1, 0, "0069 0302" },
/* U+00ef */ { 2, 0, 1, 0, "0069 0308" },
/* U+00f0 */ { 2, 0, 1, 0, 0 },
/* U+00f1 */ { 2, 0, 1, 0, "006E 0303" },
/* U+00f2 */ { 2, 0, 1, 0, "006F 0300" },
/* U+00f3 */ { 2, 0, 1, 0, "006F 0301" },
/* U+00f4 */ { 2, 0, 1, 0, "006F 0302" },
/* U+00f5 */ { 2, 0, 1, 0, "006F 0303" },
/* U+00f6 */ { 2, 0, 1, 0, "006F 0308" },
/* U+00f7 */ { 27, 0, 19, 0, 0 },
/* U+00f8 */ { 2, 0, 1, 0, 0 },
/* U+00f9 */ { 2, 0, 1, 0, "0075 0300" },
/* U+00fa */ { 2, 0, 1, 0, "0075 0301" },
/* U+00fb */ { 2, 0, 1, 0, "0075 0302" },
/* U+00fc */ { 2, 0, 1, 0, "0075 0308" },
/* U+00fd */ { 2, 0, 1, 0, "0079 0301" },
/* U+00fe */ { 2, 0, 1, 0, 0 },
/* U+00ff */ { 2, 0, 1, 0, "0079 0308" },
/* U+0100 */ { 1, 0, 1, 0, "0041 0304" },
/* U+0101 */ { 2, 0, 1, 0, "0061 0304" },
/* U+0102 */ { 1, 0, 1, 0, "0041 0306" },
/* U+0103 */ { 2, 0, 1, 0, "0061 0306" },
/* U+0104 */ { 1, 0, 1, 0, "0041 0328" },
/* U+0105 */ { 2, 0, 1, 0, "0061 0328" },
/* U+0106 */ { 1, 0, 1, 0, "0043 0301" },
/* U+0107 */ { 2, 0, 1, 0, "0063 0301" },
/* U+0108 */ { 1, 0, 1, 0, "0043 0302" },
/* U+0109 */ { 2, 0, 1, 0, "0063 0302" },
/* U+010a */ { 1, 0, 1, 0, "0043 0307" },
/* U+010b */ { 2, 0, 1, 0, "0063 0307" },
/* U+010c */ { 1, 0, 1, 0, "0043 030C" },
/* U+010d */ { 2, 0, 1, 0, "0063 030C" },
/* U+010e */ { 1, 0, 1, 0, "0044 030C" },
/* U+010f */ { 2, 0, 1, 0, "0064 030C" },
/* U+0110 */ { 1, 0, 1, 0, 0 },
/* U+0111 */ { 2, 0, 1, 0, 0 },
/* U+0112 */ { 1, 0, 1, 0, "0045 0304" },
/* U+0113 */ { 2, 0, 1, 0, "0065 0304" },
/* U+0114 */ { 1, 0, 1, 0, "0045 0306" },
/* U+0115 */ { 2, 0, 1, 0, "0065 0306" },
/* U+0116 */ { 1, 0, 1, 0, "0045 0307" },
/* U+0117 */ { 2, 0, 1, 0, "0065 0307" },
/* U+0118 */ { 1, 0, 1, 0, "0045 0328" },
/* U+0119 */ { 2, 0, 1, 0, "0065 0328" },
/* U+011a */ { 1, 0, 1, 0, "0045 030C" },
/* U+011b */ { 2, 0, 1, 0, "0065 030C" },
/* U+011c */ { 1, 0, 1, 0, "0047 0302" },
/* U+011d */ { 2, 0, 1, 0, "0067 0302" },
/* U+011e */ { 1, 0, 1, 0, "0047 0306" },
/* U+011f */ { 2, 0, 1, 0, "0067 0306" },
/* U+0120 */ { 1, 0, 1, 0, "0047 0307" },
/* U+0121 */ { 2, 0, 1, 0, "0067 0307" },
/* U+0122 */ { 1, 0, 1, 0, "0047 0327" },
/* U+0123 */ { 2, 0, 1, 0, "0067 0327" },
/* U+0124 */ { 1, 0, 1, 0, "0048 0302" },
/* U+0125 */ { 2, 0, 1, 0, "0068 0302" },
/* U+0126 */ { 1, 0, 1, 0, 0 },
/* U+0127 */ { 2, 0, 1, 0, 0 },
/* U+0128 */ { 1, 0, 1, 0, "0049 0303" },
/* U+0129 */ { 2, 0, 1, 0, "0069 0303" },
/* U+012a */ { 1, 0, 1, 0, "0049 0304" },
/* U+012b */ { 2, 0, 1, 0, "0069 0304" },
/* U+012c */ { 1, 0, 1, 0, "0049 0306" },
/* U+012d */ { 2, 0, 1, 0, "0069 0306" },
/* U+012e */ { 1, 0, 1, 0, "0049 0328" },
/* U+012f */ { 2, 0, 1, 0, "0069 0328" },
/* U+0130 */ { 1, 0, 1, 0, "0049 0307" },
/* U+0131 */ { 2, 0, 1, 0, 0 },
/* U+0132 */ { 1, 0, 1, 0, "<compat> 0049 004A" },
/* U+0133 */ { 2, 0, 1, 0, "<compat> 0069 006A" },
/* U+0134 */ { 1, 0, 1, 0, "004A 0302" },
/* U+0135 */ { 2, 0, 1, 0, "006A 0302" },
/* U+0136 */ { 1, 0, 1, 0, "004B 0327" },
/* U+0137 */ { 2, 0, 1, 0, "006B 0327" },
/* U+0138 */ { 2, 0, 1, 0, 0 },
/* U+0139 */ { 1, 0, 1, 0, "004C 0301" },
/* U+013a */ { 2, 0, 1, 0, "006C 0301" },
/* U+013b */ { 1, 0, 1, 0, "004C 0327" },
/* U+013c */ { 2, 0, 1, 0, "006C 0327" },
/* U+013d */ { 1, 0, 1, 0, "004C 030C" },
/* U+013e */ { 2, 0, 1, 0, "006C 030C" },
/* U+013f */ { 1, 0, 1, 0, "<compat> 004C 00B7" },
/* U+0140 */ { 2, 0, 1, 0, "<compat> 006C 00B7" },
/* U+0141 */ { 1, 0, 1, 0, 0 },
/* U+0142 */ { 2, 0, 1, 0, 0 },
/* U+0143 */ { 1, 0, 1, 0, "004E 0301" },
/* U+0144 */ { 2, 0, 1, 0, "006E 0301" },
/* U+0145 */ { 1, 0, 1, 0, "004E 0327" },
/* U+0146 */ { 2, 0, 1, 0, "006E 0327" },
/* U+0147 */ { 1, 0, 1, 0, "004E 030C" },
/* U+0148 */ { 2, 0, 1, 0, "006E 030C" },
/* U+0149 */ { 2, 0, 1, 0, "<compat> 02BC 006E" },
/* U+014a */ { 1, 0, 1, 0, 0 },
/* U+014b */ { 2, 0, 1, 0, 0 },
/* U+014c */ { 1, 0, 1, 0, "004F 0304" },
/* U+014d */ { 2, 0, 1, 0, "006F 0304" },
/* U+014e */ { 1, 0, 1, 0, "004F 0306" },
/* U+014f */ { 2, 0, 1, 0, "006F 0306" },
/* U+0150 */ { 1, 0, 1, 0, "004F 030B" },
/* U+0151 */ { 2, 0, 1, 0, "006F 030B" },
/* U+0152 */ { 1, 0, 1, 0, 0 },
/* U+0153 */ { 2, 0, 1, 0, 0 },
/* U+0154 */ { 1, 0, 1, 0, "0052 0301" },
/* U+0155 */ { 2, 0, 1, 0, "0072 0301" },
/* U+0156 */ { 1, 0, 1, 0, "0052 0327" },
/* U+0157 */ { 2, 0, 1, 0, "0072 0327" },
/* U+0158 */ { 1, 0, 1, 0, "0052 030C" },
/* U+0159 */ { 2, 0, 1, 0, "0072 030C" },
/* U+015a */ { 1, 0, 1, 0, "0053 0301" },
/* U+015b */ { 2, 0, 1, 0, "0073 0301" },
/* U+015c */ { 1, 0, 1, 0, "0053 0302" },
/* U+015d */ { 2, 0, 1, 0, "0073 0302" },
/* U+015e */ { 1, 0, 1, 0, "0053 0327" },
/* U+015f */ { 2, 0, 1, 0, "0073 0327" },
/* U+0160 */ { 1, 0, 1, 0, "0053 030C" },
/* U+0161 */ { 2, 0, 1, 0, "0073 030C" },
/* U+0162 */ { 1, 0, 1, 0, "0054 0327" },
/* U+0163 */ { 2, 0, 1, 0, "0074 0327" },
/* U+0164 */ { 1, 0, 1, 0, "0054 030C" },
/* U+0165 */ { 2, 0, 1, 0, "0074 030C" },
/* U+0166 */ { 1, 0, 1, 0, 0 },
/* U+0167 */ { 2, 0, 1, 0, 0 },
/* U+0168 */ { 1, 0, 1, 0, "0055 0303" },
/* U+0169 */ { 2, 0, 1, 0, "0075 0303" },
/* U+016a */ { 1, 0, 1, 0, "0055 0304" },
/* U+016b */ { 2, 0, 1, 0, "0075 0304" },
/* U+016c */ { 1, 0, 1, 0, "0055 0306" },
/* U+016d */ { 2, 0, 1, 0, "0075 0306" },
/* U+016e */ { 1, 0, 1, 0, "0055 030A" },
/* U+016f */ { 2, 0, 1, 0, "0075 030A" },
/* U+0170 */ { 1, 0, 1, 0, "0055 030B" },
/* U+0171 */ { 2, 0, 1, 0, "0075 030B" },
/* U+0172 */ { 1, 0, 1, 0, "0055 0328" },
/* U+0173 */ { 2, 0, 1, 0, "0075 0328" },
/* U+0174 */ { 1, 0, 1, 0, "0057 0302" },
/* U+0175 */ { 2, 0, 1, 0, "0077 0302" },
/* U+0176 */ { 1, 0, 1, 0, "0059 0302" },
/* U+0177 */ { 2, 0, 1, 0, "0079 0302" },
/* U+0178 */ { 1, 0, 1, 0, "0059 0308" },
/* U+0179 */ { 1, 0, 1, 0, "005A 0301" },
/* U+017a */ { 2, 0, 1, 0, "007A 0301" },
/* U+017b */ { 1, 0, 1, 0, "005A 0307" },
/* U+017c */ { 2, 0, 1, 0, "007A 0307" },
/* U+017d */ { 1, 0, 1, 0, "005A 030C" },
/* U+017e */ { 2, 0, 1, 0, "007A 030C" },
/* U+017f */ { 2, 0, 1, 0, "<compat> 0073" },
/* U+0180 */ { 2, 0, 1, 0, 0 },
/* U+0181 */ { 1, 0, 1, 0, 0 },
/* U+0182 */ { 1, 0, 1, 0, 0 },
/* U+0183 */ { 2, 0, 1, 0, 0 },
/* U+0184 */ { 1, 0, 1, 0, 0 },
/* U+0185 */ { 2, 0, 1, 0, 0 },
/* U+0186 */ { 1, 0, 1, 0, 0 },
/* U+0187 */ { 1, 0, 1, 0, 0 },
/* U+0188 */ { 2, 0, 1, 0, 0 },
/* U+0189 */ { 1, 0, 1, 0, 0 },
/* U+018a */ { 1, 0, 1, 0, 0 },
/* U+018b */ { 1, 0, 1, 0, 0 },
/* U+018c */ { 2, 0, 1, 0, 0 },
/* U+018d */ { 2, 0, 1, 0, 0 },
/* U+018e */ { 1, 0, 1, 0, 0 },
/* U+018f */ { 1, 0, 1, 0, 0 },
/* U+0190 */ { 1, 0, 1, 0, 0 },
/* U+0191 */ { 1, 0, 1, 0, 0 },
/* U+0192 */ { 2, 0, 1, 0, 0 },
/* U+0193 */ { 1, 0, 1, 0, 0 },
/* U+0194 */ { 1, 0, 1, 0, 0 },
/* U+0195 */ { 2, 0, 1, 0, 0 },
/* U+0196 */ { 1, 0, 1, 0, 0 },
/* U+0197 */ { 1, 0, 1, 0, 0 },
/* U+0198 */ { 1, 0, 1, 0, 0 },
/* U+0199 */ { 2, 0, 1, 0, 0 },
/* U+019a */ { 2, 0, 1, 0, 0 },
/* U+019b */ { 2, 0, 1, 0, 0 },
/* U+019c */ { 1, 0, 1, 0, 0 },
/* U+019d */ { 1, 0, 1, 0, 0 },
/* U+019e */ { 2, 0, 1, 0, 0 },
/* U+019f */ { 1, 0, 1, 0, 0 },
/* U+01a0 */ { 1, 0, 1, 0, "004F 031B" },
/* U+01a1 */ { 2, 0, 1, 0, "006F 031B" },
/* U+01a2 */ { 1, 0, 1, 0, 0 },
/* U+01a3 */ { 2, 0, 1, 0, 0 },
/* U+01a4 */ { 1, 0, 1, 0, 0 },
/* U+01a5 */ { 2, 0, 1, 0, 0 },
/* U+01a6 */ { 1, 0, 1, 0, 0 },
/* U+01a7 */ { 1, 0, 1, 0, 0 },
/* U+01a8 */ { 2, 0, 1, 0, 0 },
/* U+01a9 */ { 1, 0, 1, 0, 0 },
/* U+01aa */ { 2, 0, 1, 0, 0 },
/* U+01ab */ { 2, 0, 1, 0, 0 },
/* U+01ac */ { 1, 0, 1, 0, 0 },
/* U+01ad */ { 2, 0, 1, 0, 0 },
/* U+01ae */ { 1, 0, 1, 0, 0 },
/* U+01af */ { 1, 0, 1, 0, "0055 031B" },
/* U+01b0 */ { 2, 0, 1, 0, "0075 031B" },
/* U+01b1 */ { 1, 0, 1, 0, 0 },
/* U+01b2 */ { 1, 0, 1, 0, 0 },
/* U+01b3 */ { 1, 0, 1, 0, 0 },
/* U+01b4 */ { 2, 0, 1, 0, 0 },
/* U+01b5 */ { 1, 0, 1, 0, 0 },
/* U+01b6 */ { 2, 0, 1, 0, 0 },
/* U+01b7 */ { 1, 0, 1, 0, 0 },
/* U+01b8 */ { 1, 0, 1, 0, 0 },
/* U+01b9 */ { 2, 0, 1, 0, 0 },
/* U+01ba */ { 2, 0, 1, 0, 0 },
/* U+01bb */ { 19, 0, 1, 0, 0 },
/* U+01bc */ { 1, 0, 1, 0, 0 },
/* U+01bd */ { 2, 0, 1, 0, 0 },
/* U+01be */ { 2, 0, 1, 0, 0 },
/* U+01bf */ { 2, 0, 1, 0, 0 },
/* U+01c0 */ { 19, 0, 1, 0, 0 },
/* U+01c1 */ { 19, 0, 1, 0, 0 },
/* U+01c2 */ { 19, 0, 1, 0, 0 },
/* U+01c3 */ { 19, 0, 1, 0, 0 },
/* U+01c4 */ { 1, 0, 1, 0, "<compat> 0044 017D" },
/* U+01c5 */ { 3, 0, 1, 0, "<compat> 0044 017E" },
/* U+01c6 */ { 2, 0, 1, 0, "<compat> 0064 017E" },
/* U+01c7 */ { 1, 0, 1, 0, "<compat> 004C 004A" },
/* U+01c8 */ { 3, 0, 1, 0, "<compat> 004C 006A" },
/* U+01c9 */ { 2, 0, 1, 0, "<compat> 006C 006A" },
/* U+01ca */ { 1, 0, 1, 0, "<compat> 004E 004A" },
/* U+01cb */ { 3, 0, 1, 0, "<compat> 004E 006A" },
/* U+01cc */ { 2, 0, 1, 0, "<compat> 006E 006A" },
/* U+01cd */ { 1, 0, 1, 0, "0041 030C" },
/* U+01ce */ { 2, 0, 1, 0, "0061 030C" },
/* U+01cf */ { 1, 0, 1, 0, "0049 030C" },
/* U+01d0 */ { 2, 0, 1, 0, "0069 030C" },
/* U+01d1 */ { 1, 0, 1, 0, "004F 030C" },
/* U+01d2 */ { 2, 0, 1, 0, "006F 030C" },
/* U+01d3 */ { 1, 0, 1, 0, "0055 030C" },
/* U+01d4 */ { 2, 0, 1, 0, "0075 030C" },
/* U+01d5 */ { 1, 0, 1, 0, "00DC 0304" },
/* U+01d6 */ { 2, 0, 1, 0, "00FC 0304" },
/* U+01d7 */ { 1, 0, 1, 0, "00DC 0301" },
/* U+01d8 */ { 2, 0, 1, 0, "00FC 0301" },
/* U+01d9 */ { 1, 0, 1, 0, "00DC 030C" },
/* U+01da */ { 2, 0, 1, 0, "00FC 030C" },
/* U+01db */ { 1, 0, 1, 0, "00DC 0300" },
/* U+01dc */ { 2, 0, 1, 0, "00FC 0300" },
/* U+01dd */ { 2, 0, 1, 0, 0 },
/* U+01de */ { 1, 0, 1, 0, "00C4 0304" },
/* U+01df */ { 2, 0, 1, 0, "00E4 0304" },
/* U+01e0 */ { 1, 0, 1, 0, "0226 0304" },
/* U+01e1 */ { 2, 0, 1, 0, "0227 0304" },
/* U+01e2 */ { 1, 0, 1, 0, "00C6 0304" },
/* U+01e3 */ { 2, 0, 1, 0, "00E6 0304" },
/* U+01e4 */ { 1, 0, 1, 0, 0 },
/* U+01e5 */ { 2, 0, 1, 0, 0 },
/* U+01e6 */ { 1, 0, 1, 0, "0047 030C" },
/* U+01e7 */ { 2, 0, 1, 0, "0067 030C" },
/* U+01e8 */ { 1, 0, 1, 0, "004B 030C" },
/* U+01e9 */ { 2, 0, 1, 0, "006B 030C" },
/* U+01ea */ { 1, 0, 1, 0, "004F 0328" },
/* U+01eb */ { 2, 0, 1, 0, "006F 0328" },
/* U+01ec */ { 1, 0, 1, 0, "01EA 0304" },
/* U+01ed */ { 2, 0, 1, 0, "01EB 0304" },
/* U+01ee */ { 1, 0, 1, 0, "01B7 030C" },
/* U+01ef */ { 2, 0, 1, 0, "0292 030C" },
/* U+01f0 */ { 2, 0, 1, 0, "006A 030C" },
/* U+01f1 */ { 1, 0, 1, 0, "<compat> 0044 005A" },
/* U+01f2 */ { 3, 0, 1, 0, "<compat> 0044 007A" },
/* U+01f3 */ { 2, 0, 1, 0, "<compat> 0064 007A" },
/* U+01f4 */ { 1, 0, 1, 0, "0047 0301" },
/* U+01f5 */ { 2, 0, 1, 0, "0067 0301" },
/* U+01f6 */ { 1, 0, 1, 0, 0 },
/* U+01f7 */ { 1, 0, 1, 0, 0 },
/* U+01f8 */ { 1, 0, 1, 0, "004E 0300" },
/* U+01f9 */ { 2, 0, 1, 0, "006E 0300" },
/* U+01fa */ { 1, 0, 1, 0, "00C5 0301" },
/* U+01fb */ { 2, 0, 1, 0, "00E5 0301" },
/* U+01fc */ { 1, 0, 1, 0, "00C6 0301" },
/* U+01fd */ { 2, 0, 1, 0, "00E6 0301" },
/* U+01fe */ { 1, 0, 1, 0, "00D8 0301" },
/* U+01ff */ { 2, 0, 1, 0, "00F8 0301" },
/* U+0200 */ { 1, 0, 1, 0, "0041 030F" },
/* U+0201 */ { 2, 0, 1, 0, "0061 030F" },
/* U+0202 */ { 1, 0, 1, 0, "0041 0311" },
/* U+0203 */ { 2, 0, 1, 0, "0061 0311" },
/* U+0204 */ { 1, 0, 1, 0, "0045 030F" },
/* U+0205 */ { 2, 0, 1, 0, "0065 030F" },
/* U+0206 */ { 1, 0, 1, 0, "0045 0311" },
/* U+0207 */ { 2, 0, 1, 0, "0065 0311" },
/* U+0208 */ { 1, 0, 1, 0, "0049 030F" },
/* U+0209 */ { 2, 0, 1, 0, "0069 030F" },
/* U+020a */ { 1, 0, 1, 0, "0049 0311" },
/* U+020b */ { 2, 0, 1, 0, "0069 0311" },
/* U+020c */ { 1, 0, 1, 0, "004F 030F" },
/* U+020d */ { 2, 0, 1, 0, "006F 030F" },
/* U+020e */ { 1, 0, 1, 0, "004F 0311" },
/* U+020f */ { 2, 0, 1, 0, "006F 0311" },
/* U+0210 */ { 1, 0, 1, 0, "0052 030F" },
/* U+0211 */ { 2, 0, 1, 0, "0072 030F" },
/* U+0212 */ { 1, 0, 1, 0, "0052 0311" },
/* U+0213 */ { 2, 0, 1, 0, "0072 0311" },
/* U+0214 */ { 1, 0, 1, 0, "0055 030F" },
/* U+0215 */ { 2, 0, 1, 0, "0075 030F" },
/* U+0216 */ { 1, 0, 1, 0, "0055 0311" },
/* U+0217 */ { 2, 0, 1, 0, "0075 0311" },
/* U+0218 */ { 1, 0, 1, 0, "0053 0326" },
/* U+0219 */ { 2, 0, 1, 0, "0073 0326" },
/* U+021a */ { 1, 0, 1, 0, "0054 0326" },
/* U+021b */ { 2, 0, 1, 0, "0074 0326" },
/* U+021c */ { 1, 0, 1, 0, 0 },
/* U+021d */ { 2, 0, 1, 0, 0 },
/* U+021e */ { 1, 0, 1, 0, "0048 030C" },
/* U+021f */ { 2, 0, 1, 0, "0068 030C" },
/* U+0220 */ { 0, 0, 0, 0, 0 },
/* U+0221 */ { 0, 0, 0, 0, 0 },
/* U+0222 */ { 1, 0, 1, 0, 0 },
/* U+0223 */ { 2, 0, 1, 0, 0 },
/* U+0224 */ { 1, 0, 1, 0, 0 },
/* U+0225 */ { 2, 0, 1, 0, 0 },
/* U+0226 */ { 1, 0, 1, 0, "0041 0307" },
/* U+0227 */ { 2, 0, 1, 0, "0061 0307" },
/* U+0228 */ { 1, 0, 1, 0, "0045 0327" },
/* U+0229 */ { 2, 0, 1, 0, "0065 0327" },
/* U+022a */ { 1, 0, 1, 0, "00D6 0304" },
/* U+022b */ { 2, 0, 1, 0, "00F6 0304" },
/* U+022c */ { 1, 0, 1, 0, "00D5 0304" },
/* U+022d */ { 2, 0, 1, 0, "00F5 0304" },
/* U+022e */ { 1, 0, 1, 0, "004F 0307" },
/* U+022f */ { 2, 0, 1, 0, "006F 0307" },
/* U+0230 */ { 1, 0, 1, 0, "022E 0304" },
/* U+0231 */ { 2, 0, 1, 0, "022F 0304" },
/* U+0232 */ { 1, 0, 1, 0, "0059 0304" },
/* U+0233 */ { 2, 0, 1, 0, "0079 0304" },
/* U+0234 */ { 0, 0, 0, 0, 0 },
/* U+0235 */ { 0, 0, 0, 0, 0 },
/* U+0236 */ { 0, 0, 0, 0, 0 },
/* U+0237 */ { 0, 0, 0, 0, 0 },
/* U+0238 */ { 0, 0, 0, 0, 0 },
/* U+0239 */ { 0, 0, 0, 0, 0 },
/* U+023a */ { 0, 0, 0, 0, 0 },
/* U+023b */ { 0, 0, 0, 0, 0 },
/* U+023c */ { 0, 0, 0, 0, 0 },
/* U+023d */ { 0, 0, 0, 0, 0 },
/* U+023e */ { 0, 0, 0, 0, 0 },
/* U+023f */ { 0, 0, 0, 0, 0 },
/* U+0240 */ { 0, 0, 0, 0, 0 },
/* U+0241 */ { 0, 0, 0, 0, 0 },
/* U+0242 */ { 0, 0, 0, 0, 0 },
/* U+0243 */ { 0, 0, 0, 0, 0 },
/* U+0244 */ { 0, 0, 0, 0, 0 },
/* U+0245 */ { 0, 0, 0, 0, 0 },
/* U+0246 */ { 0, 0, 0, 0, 0 },
/* U+0247 */ { 0, 0, 0, 0, 0 },
/* U+0248 */ { 0, 0, 0, 0, 0 },
/* U+0249 */ { 0, 0, 0, 0, 0 },
/* U+024a */ { 0, 0, 0, 0, 0 },
/* U+024b */ { 0, 0, 0, 0, 0 },
/* U+024c */ { 0, 0, 0, 0, 0 },
/* U+024d */ { 0, 0, 0, 0, 0 },
/* U+024e */ { 0, 0, 0, 0, 0 },
/* U+024f */ { 0, 0, 0, 0, 0 },
/* U+0250 */ { 2, 0, 1, 0, 0 },
/* U+0251 */ { 2, 0, 1, 0, 0 },
/* U+0252 */ { 2, 0, 1, 0, 0 },
/* U+0253 */ { 2, 0, 1, 0, 0 },
/* U+0254 */ { 2, 0, 1, 0, 0 },
/* U+0255 */ { 2, 0, 1, 0, 0 },
/* U+0256 */ { 2, 0, 1, 0, 0 },
/* U+0257 */ { 2, 0, 1, 0, 0 },
/* U+0258 */ { 2, 0, 1, 0, 0 },
/* U+0259 */ { 2, 0, 1, 0, 0 },
/* U+025a */ { 2, 0, 1, 0, 0 },
/* U+025b */ { 2, 0, 1, 0, 0 },
/* U+025c */ { 2, 0, 1, 0, 0 },
/* U+025d */ { 2, 0, 1, 0, 0 },
/* U+025e */ { 2, 0, 1, 0, 0 },
/* U+025f */ { 2, 0, 1, 0, 0 },
/* U+0260 */ { 2, 0, 1, 0, 0 },
/* U+0261 */ { 2, 0, 1, 0, 0 },
/* U+0262 */ { 2, 0, 1, 0, 0 },
/* U+0263 */ { 2, 0, 1, 0, 0 },
/* U+0264 */ { 2, 0, 1, 0, 0 },
/* U+0265 */ { 2, 0, 1, 0, 0 },
/* U+0266 */ { 2, 0, 1, 0, 0 },
/* U+0267 */ { 2, 0, 1, 0, 0 },
/* U+0268 */ { 2, 0, 1, 0, 0 },
/* U+0269 */ { 2, 0, 1, 0, 0 },
/* U+026a */ { 2, 0, 1, 0, 0 },
/* U+026b */ { 2, 0, 1, 0, 0 },
/* U+026c */ { 2, 0, 1, 0, 0 },
/* U+026d */ { 2, 0, 1, 0, 0 },
/* U+026e */ { 2, 0, 1, 0, 0 },
/* U+026f */ { 2, 0, 1, 0, 0 },
/* U+0270 */ { 2, 0, 1, 0, 0 },
/* U+0271 */ { 2, 0, 1, 0, 0 },
/* U+0272 */ { 2, 0, 1, 0, 0 },
/* U+0273 */ { 2, 0, 1, 0, 0 },
/* U+0274 */ { 2, 0, 1, 0, 0 },
/* U+0275 */ { 2, 0, 1, 0, 0 },
/* U+0276 */ { 2, 0, 1, 0, 0 },
/* U+0277 */ { 2, 0, 1, 0, 0 },
/* U+0278 */ { 2, 0, 1, 0, 0 },
/* U+0279 */ { 2, 0, 1, 0, 0 },
/* U+027a */ { 2, 0, 1, 0, 0 },
/* U+027b */ { 2, 0, 1, 0, 0 },
/* U+027c */ { 2, 0, 1, 0, 0 },
/* U+027d */ { 2, 0, 1, 0, 0 },
/* U+027e */ { 2, 0, 1, 0, 0 },
/* U+027f */ { 2, 0, 1, 0, 0 },
/* U+0280 */ { 2, 0, 1, 0, 0 },
/* U+0281 */ { 2, 0, 1, 0, 0 },
/* U+0282 */ { 2, 0, 1, 0, 0 },
/* U+0283 */ { 2, 0, 1, 0, 0 },
/* U+0284 */ { 2, 0, 1, 0, 0 },
/* U+0285 */ { 2, 0, 1, 0, 0 },
/* U+0286 */ { 2, 0, 1, 0, 0 },
/* U+0287 */ { 2, 0, 1, 0, 0 },
/* U+0288 */ { 2, 0, 1, 0, 0 },
/* U+0289 */ { 2, 0, 1, 0, 0 },
/* U+028a */ { 2, 0, 1, 0, 0 },
/* U+028b */ { 2, 0, 1, 0, 0 },
/* U+028c */ { 2, 0, 1, 0, 0 },
/* U+028d */ { 2, 0, 1, 0, 0 },
/* U+028e */ { 2, 0, 1, 0, 0 },
/* U+028f */ { 2, 0, 1, 0, 0 },
/* U+0290 */ { 2, 0, 1, 0, 0 },
/* U+0291 */ { 2, 0, 1, 0, 0 },
/* U+0292 */ { 2, 0, 1, 0, 0 },
/* U+0293 */ { 2, 0, 1, 0, 0 },
/* U+0294 */ { 2, 0, 1, 0, 0 },
/* U+0295 */ { 2, 0, 1, 0, 0 },
/* U+0296 */ { 2, 0, 1, 0, 0 },
/* U+0297 */ { 2, 0, 1, 0, 0 },
/* U+0298 */ { 2, 0, 1, 0, 0 },
/* U+0299 */ { 2, 0, 1, 0, 0 },
/* U+029a */ { 2, 0, 1, 0, 0 },
/* U+029b */ { 2, 0, 1, 0, 0 },
/* U+029c */ { 2, 0, 1, 0, 0 },
/* U+029d */ { 2, 0, 1, 0, 0 },
/* U+029e */ { 2, 0, 1, 0, 0 },
/* U+029f */ { 2, 0, 1, 0, 0 },
/* U+02a0 */ { 2, 0, 1, 0, 0 },
/* U+02a1 */ { 2, 0, 1, 0, 0 },
/* U+02a2 */ { 2, 0, 1, 0, 0 },
/* U+02a3 */ { 2, 0, 1, 0, 0 },
/* U+02a4 */ { 2, 0, 1, 0, 0 },
/* U+02a5 */ { 2, 0, 1, 0, 0 },
/* U+02a6 */ { 2, 0, 1, 0, 0 },
/* U+02a7 */ { 2, 0, 1, 0, 0 },
/* U+02a8 */ { 2, 0, 1, 0, 0 },
/* U+02a9 */ { 2, 0, 1, 0, 0 },
/* U+02aa */ { 2, 0, 1, 0, 0 },
/* U+02ab */ { 2, 0, 1, 0, 0 },
/* U+02ac */ { 2, 0, 1, 0, 0 },
/* U+02ad */ { 2, 0, 1, 0, 0 },
/* U+02ae */ { 0, 0, 0, 0, 0 },
/* U+02af */ { 0, 0, 0, 0, 0 },
/* U+02b0 */ { 18, 0, 1, 0, "<super> 0068" },
/* U+02b1 */ { 18, 0, 1, 0, "<super> 0266" },
/* U+02b2 */ { 18, 0, 1, 0, "<super> 006A" },
/* U+02b3 */ { 18, 0, 1, 0, "<super> 0072" },
/* U+02b4 */ { 18, 0, 1, 0, "<super> 0279" },
/* U+02b5 */ { 18, 0, 1, 0, "<super> 027B" },
/* U+02b6 */ { 18, 0, 1, 0, "<super> 0281" },
/* U+02b7 */ { 18, 0, 1, 0, "<super> 0077" },
/* U+02b8 */ { 18, 0, 1, 0, "<super> 0079" },
/* U+02b9 */ { 29, 0, 19, 0, 0 },
/* U+02ba */ { 29, 0, 19, 0, 0 },
/* U+02bb */ { 18, 0, 1, 0, 0 },
/* U+02bc */ { 18, 0, 1, 0, 0 },
/* U+02bd */ { 18, 0, 1, 0, 0 },
/* U+02be */ { 18, 0, 1, 0, 0 },
/* U+02bf */ { 18, 0, 1, 0, 0 },
/* U+02c0 */ { 18, 0, 1, 0, 0 },
/* U+02c1 */ { 18, 0, 1, 0, 0 },
/* U+02c2 */ { 29, 0, 19, 0, 0 },
/* U+02c3 */ { 29, 0, 19, 0, 0 },
/* U+02c4 */ { 29, 0, 19, 0, 0 },
/* U+02c5 */ { 29, 0, 19, 0, 0 },
/* U+02c6 */ { 29, 0, 19, 0, 0 },
/* U+02c7 */ { 29, 0, 19, 0, 0 },
/* U+02c8 */ { 29, 0, 19, 0, 0 },
/* U+02c9 */ { 29, 0, 19, 0, 0 },
/* U+02ca */ { 29, 0, 19, 0, 0 },
/* U+02cb */ { 29, 0, 19, 0, 0 },
/* U+02cc */ { 29, 0, 19, 0, 0 },
/* U+02cd */ { 29, 0, 19, 0, 0 },
/* U+02ce */ { 29, 0, 19, 0, 0 },
/* U+02cf */ { 29, 0, 19, 0, 0 },
/* U+02d0 */ { 18, 0, 1, 0, 0 },
/* U+02d1 */ { 18, 0, 1, 0, 0 },
/* U+02d2 */ { 29, 0, 19, 0, 0 },
/* U+02d3 */ { 29, 0, 19, 0, 0 },
/* U+02d4 */ { 29, 0, 19, 0, 0 },
/* U+02d5 */ { 29, 0, 19, 0, 0 },
/* U+02d6 */ { 29, 0, 19, 0, 0 },
/* U+02d7 */ { 29, 0, 19, 0, 0 },
/* U+02d8 */ { 29, 0, 19, 0, "<compat> 0020 0306" },
/* U+02d9 */ { 29, 0, 19, 0, "<compat> 0020 0307" },
/* U+02da */ { 29, 0, 19, 0, "<compat> 0020 030A" },
/* U+02db */ { 29, 0, 19, 0, "<compat> 0020 0328" },
/* U+02dc */ { 29, 0, 19, 0, "<compat> 0020 0303" },
/* U+02dd */ { 29, 0, 19, 0, "<compat> 0020 030B" },
/* U+02de */ { 29, 0, 19, 0, 0 },
/* U+02df */ { 29, 0, 19, 0, 0 },
/* U+02e0 */ { 18, 0, 1, 0, "<super> 0263" },
/* U+02e1 */ { 18, 0, 1, 0, "<super> 006C" },
/* U+02e2 */ { 18, 0, 1, 0, "<super> 0073" },
/* U+02e3 */ { 18, 0, 1, 0, "<super> 0078" },
/* U+02e4 */ { 18, 0, 1, 0, "<super> 0295" },
/* U+02e5 */ { 29, 0, 19, 0, 0 },
/* U+02e6 */ { 29, 0, 19, 0, 0 },
/* U+02e7 */ { 29, 0, 19, 0, 0 },
/* U+02e8 */ { 29, 0, 19, 0, 0 },
/* U+02e9 */ { 29, 0, 19, 0, 0 },
/* U+02ea */ { 29, 0, 19, 0, 0 },
/* U+02eb */ { 29, 0, 19, 0, 0 },
/* U+02ec */ { 29, 0, 19, 0, 0 },
/* U+02ed */ { 29, 0, 19, 0, 0 },
/* U+02ee */ { 18, 0, 1, 0, 0 },
/* U+02ef */ { 0, 0, 0, 0, 0 },
/* U+02f0 */ { 0, 0, 0, 0, 0 },
/* U+02f1 */ { 0, 0, 0, 0, 0 },
/* U+02f2 */ { 0, 0, 0, 0, 0 },
/* U+02f3 */ { 0, 0, 0, 0, 0 },
/* U+02f4 */ { 0, 0, 0, 0, 0 },
/* U+02f5 */ { 0, 0, 0, 0, 0 },
/* U+02f6 */ { 0, 0, 0, 0, 0 },
/* U+02f7 */ { 0, 0, 0, 0, 0 },
/* U+02f8 */ { 0, 0, 0, 0, 0 },
/* U+02f9 */ { 0, 0, 0, 0, 0 },
/* U+02fa */ { 0, 0, 0, 0, 0 },
/* U+02fb */ { 0, 0, 0, 0, 0 },
/* U+02fc */ { 0, 0, 0, 0, 0 },
/* U+02fd */ { 0, 0, 0, 0, 0 },
/* U+02fe */ { 0, 0, 0, 0, 0 },
/* U+02ff */ { 0, 0, 0, 0, 0 },
/* U+0300 */ { 4, 230, 14, 0, 0 },
/* U+0301 */ { 4, 230, 14, 0, 0 },
/* U+0302 */ { 4, 230, 14, 0, 0 },
/* U+0303 */ { 4, 230, 14, 0, 0 },
/* U+0304 */ { 4, 230, 14, 0, 0 },
/* U+0305 */ { 4, 230, 14, 0, 0 },
/* U+0306 */ { 4, 230, 14, 0, 0 },
/* U+0307 */ { 4, 230, 14, 0, 0 },
/* U+0308 */ { 4, 230, 14, 0, 0 },
/* U+0309 */ { 4, 230, 14, 0, 0 },
/* U+030a */ { 4, 230, 14, 0, 0 },
/* U+030b */ { 4, 230, 14, 0, 0 },
/* U+030c */ { 4, 230, 14, 0, 0 },
/* U+030d */ { 4, 230, 14, 0, 0 },
/* U+030e */ { 4, 230, 14, 0, 0 },
/* U+030f */ { 4, 230, 14, 0, 0 },
/* U+0310 */ { 4, 230, 14, 0, 0 },
/* U+0311 */ { 4, 230, 14, 0, 0 },
/* U+0312 */ { 4, 230, 14, 0, 0 },
/* U+0313 */ { 4, 230, 14, 0, 0 },
/* U+0314 */ { 4, 230, 14, 0, 0 },
/* U+0315 */ { 4, 232, 14, 0, 0 },
/* U+0316 */ { 4, 220, 14, 0, 0 },
/* U+0317 */ { 4, 220, 14, 0, 0 },
/* U+0318 */ { 4, 220, 14, 0, 0 },
/* U+0319 */ { 4, 220, 14, 0, 0 },
/* U+031a */ { 4, 232, 14, 0, 0 },
/* U+031b */ { 4, 216, 14, 0, 0 },
/* U+031c */ { 4, 220, 14, 0, 0 },
/* U+031d */ { 4, 220, 14, 0, 0 },
/* U+031e */ { 4, 220, 14, 0, 0 },
/* U+031f */ { 4, 220, 14, 0, 0 },
/* U+0320 */ { 4, 220, 14, 0, 0 },
/* U+0321 */ { 4, 202, 14, 0, 0 },
/* U+0322 */ { 4, 202, 14, 0, 0 },
/* U+0323 */ { 4, 220, 14, 0, 0 },
/* U+0324 */ { 4, 220, 14, 0, 0 },
/* U+0325 */ { 4, 220, 14, 0, 0 },
/* U+0326 */ { 4, 220, 14, 0, 0 },
/* U+0327 */ { 4, 202, 14, 0, 0 },
/* U+0328 */ { 4, 202, 14, 0, 0 },
/* U+0329 */ { 4, 220, 14, 0, 0 },
/* U+032a */ { 4, 220, 14, 0, 0 },
/* U+032b */ { 4, 220, 14, 0, 0 },
/* U+032c */ { 4, 220, 14, 0, 0 },
/* U+032d */ { 4, 220, 14, 0, 0 },
/* U+032e */ { 4, 220, 14, 0, 0 },
/* U+032f */ { 4, 220, 14, 0, 0 },
/* U+0330 */ { 4, 220, 14, 0, 0 },
/* U+0331 */ { 4, 220, 14, 0, 0 },
/* U+0332 */ { 4, 220, 14, 0, 0 },
/* U+0333 */ { 4, 220, 14, 0, 0 },
/* U+0334 */ { 4, 1, 14, 0, 0 },
/* U+0335 */ { 4, 1, 14, 0, 0 },
/* U+0336 */ { 4, 1, 14, 0, 0 },
/* U+0337 */ { 4, 1, 14, 0, 0 },
/* U+0338 */ { 4, 1, 14, 0, 0 },
/* U+0339 */ { 4, 220, 14, 0, 0 },
/* U+033a */ { 4, 220, 14, 0, 0 },
/* U+033b */ { 4, 220, 14, 0, 0 },
/* U+033c */ { 4, 220, 14, 0, 0 },
/* U+033d */ { 4, 230, 14, 0, 0 },
/* U+033e */ { 4, 230, 14, 0, 0 },
/* U+033f */ { 4, 230, 14, 0, 0 },
/* U+0340 */ { 4, 230, 14, 0, "0300" },
/* U+0341 */ { 4, 230, 14, 0, "0301" },
/* U+0342 */ { 4, 230, 14, 0, 0 },
/* U+0343 */ { 4, 230, 14, 0, "0313" },
/* U+0344 */ { 4, 230, 14, 0, "0308 0301" },
/* U+0345 */ { 4, 240, 14, 0, 0 },
/* U+0346 */ { 4, 230, 14, 0, 0 },
/* U+0347 */ { 4, 220, 14, 0, 0 },
/* U+0348 */ { 4, 220, 14, 0, 0 },
/* U+0349 */ { 4, 220, 14, 0, 0 },
/* U+034a */ { 4, 230, 14, 0, 0 },
/* U+034b */ { 4, 230, 14, 0, 0 },
/* U+034c */ { 4, 230, 14, 0, 0 },
/* U+034d */ { 4, 220, 14, 0, 0 },
/* U+034e */ { 4, 220, 14, 0, 0 },
/* U+034f */ { 0, 0, 0, 0, 0 },
/* U+0350 */ { 0, 0, 0, 0, 0 },
/* U+0351 */ { 0, 0, 0, 0, 0 },
/* U+0352 */ { 0, 0, 0, 0, 0 },
/* U+0353 */ { 0, 0, 0, 0, 0 },
/* U+0354 */ { 0, 0, 0, 0, 0 },
/* U+0355 */ { 0, 0, 0, 0, 0 },
/* U+0356 */ { 0, 0, 0, 0, 0 },
/* U+0357 */ { 0, 0, 0, 0, 0 },
/* U+0358 */ { 0, 0, 0, 0, 0 },
/* U+0359 */ { 0, 0, 0, 0, 0 },
/* U+035a */ { 0, 0, 0, 0, 0 },
/* U+035b */ { 0, 0, 0, 0, 0 },
/* U+035c */ { 0, 0, 0, 0, 0 },
/* U+035d */ { 0, 0, 0, 0, 0 },
/* U+035e */ { 0, 0, 0, 0, 0 },
/* U+035f */ { 0, 0, 0, 0, 0 },
/* U+0360 */ { 4, 234, 14, 0, 0 },
/* U+0361 */ { 4, 234, 14, 0, 0 },
/* U+0362 */ { 4, 233, 14, 0, 0 },
/* U+0363 */ { 0, 0, 0, 0, 0 },
/* U+0364 */ { 0, 0, 0, 0, 0 },
/* U+0365 */ { 0, 0, 0, 0, 0 },
/* U+0366 */ { 0, 0, 0, 0, 0 },
/* U+0367 */ { 0, 0, 0, 0, 0 },
/* U+0368 */ { 0, 0, 0, 0, 0 },
/* U+0369 */ { 0, 0, 0, 0, 0 },
/* U+036a */ { 0, 0, 0, 0, 0 },
/* U+036b */ { 0, 0, 0, 0, 0 },
/* U+036c */ { 0, 0, 0, 0, 0 },
/* U+036d */ { 0, 0, 0, 0, 0 },
/* U+036e */ { 0, 0, 0, 0, 0 },
/* U+036f */ { 0, 0, 0, 0, 0 },
/* U+0370 */ { 0, 0, 0, 0, 0 },
/* U+0371 */ { 0, 0, 0, 0, 0 },
/* U+0372 */ { 0, 0, 0, 0, 0 },
/* U+0373 */ { 0, 0, 0, 0, 0 },
/* U+0374 */ { 29, 0, 19, 0, "02B9" },
/* U+0375 */ { 29, 0, 19, 0, 0 },
/* U+0376 */ { 0, 0, 0, 0, 0 },
/* U+0377 */ { 0, 0, 0, 0, 0 },
/* U+0378 */ { 0, 0, 0, 0, 0 },
/* U+0379 */ { 0, 0, 0, 0, 0 },
/* U+037a */ { 18, 0, 1, 0, "<compat> 0020 0345" },
/* U+037b */ { 0, 0, 0, 0, 0 },
/* U+037c */ { 0, 0, 0, 0, 0 },
/* U+037d */ { 0, 0, 0, 0, 0 },
/* U+037e */ { 26, 0, 19, 0, "003B" },
/* U+037f */ { 0, 0, 0, 0, 0 },
/* U+0380 */ { 0, 0, 0, 0, 0 },
/* U+0381 */ { 0, 0, 0, 0, 0 },
/* U+0382 */ { 0, 0, 0, 0, 0 },
/* U+0383 */ { 0, 0, 0, 0, 0 },
/* U+0384 */ { 29, 0, 19, 0, "<compat> 0020 0301" },
/* U+0385 */ { 29, 0, 19, 0, "00A8 0301" },
/* U+0386 */ { 1, 0, 1, 0, "0391 0301" },
/* U+0387 */ { 26, 0, 19, 0, "00B7" },
/* U+0388 */ { 1, 0, 1, 0, "0395 0301" },
/* U+0389 */ { 1, 0, 1, 0, "0397 0301" },
/* U+038a */ { 1, 0, 1, 0, "0399 0301" },
/* U+038b */ { 0, 0, 0, 0, 0 },
/* U+038c */ { 1, 0, 1, 0, "039F 0301" },
/* U+038d */ { 0, 0, 0, 0, 0 },
/* U+038e */ { 1, 0, 1, 0, "03A5 0301" },
/* U+038f */ { 1, 0, 1, 0, "03A9 0301" },
/* U+0390 */ { 2, 0, 1, 0, "03CA 0301" },
/* U+0391 */ { 1, 0, 1, 0, 0 },
/* U+0392 */ { 1, 0, 1, 0, 0 },
/* U+0393 */ { 1, 0, 1, 0, 0 },
/* U+0394 */ { 1, 0, 1, 0, 0 },
/* U+0395 */ { 1, 0, 1, 0, 0 },
/* U+0396 */ { 1, 0, 1, 0, 0 },
/* U+0397 */ { 1, 0, 1, 0, 0 },
/* U+0398 */ { 1, 0, 1, 0, 0 },
/* U+0399 */ { 1, 0, 1, 0, 0 },
/* U+039a */ { 1, 0, 1, 0, 0 },
/* U+039b */ { 1, 0, 1, 0, 0 },
/* U+039c */ { 1, 0, 1, 0, 0 },
/* U+039d */ { 1, 0, 1, 0, 0 },
/* U+039e */ { 1, 0, 1, 0, 0 },
/* U+039f */ { 1, 0, 1, 0, 0 },
/* U+03a0 */ { 1, 0, 1, 0, 0 },
/* U+03a1 */ { 1, 0, 1, 0, 0 },
/* U+03a2 */ { 0, 0, 0, 0, 0 },
/* U+03a3 */ { 1, 0, 1, 0, 0 },
/* U+03a4 */ { 1, 0, 1, 0, 0 },
/* U+03a5 */ { 1, 0, 1, 0, 0 },
/* U+03a6 */ { 1, 0, 1, 0, 0 },
/* U+03a7 */ { 1, 0, 1, 0, 0 },
/* U+03a8 */ { 1, 0, 1, 0, 0 },
/* U+03a9 */ { 1, 0, 1, 0, 0 },
/* U+03aa */ { 1, 0, 1, 0, "0399 0308" },
/* U+03ab */ { 1, 0, 1, 0, "03A5 0308" },
/* U+03ac */ { 2, 0, 1, 0, "03B1 0301" },
/* U+03ad */ { 2, 0, 1, 0, "03B5 0301" },
/* U+03ae */ { 2, 0, 1, 0, "03B7 0301" },
/* U+03af */ { 2, 0, 1, 0, "03B9 0301" },
/* U+03b0 */ { 2, 0, 1, 0, "03CB 0301" },
/* U+03b1 */ { 2, 0, 1, 0, 0 },
/* U+03b2 */ { 2, 0, 1, 0, 0 },
/* U+03b3 */ { 2, 0, 1, 0, 0 },
/* U+03b4 */ { 2, 0, 1, 0, 0 },
/* U+03b5 */ { 2, 0, 1, 0, 0 },
/* U+03b6 */ { 2, 0, 1, 0, 0 },
/* U+03b7 */ { 2, 0, 1, 0, 0 },
/* U+03b8 */ { 2, 0, 1, 0, 0 },
/* U+03b9 */ { 2, 0, 1, 0, 0 },
/* U+03ba */ { 2, 0, 1, 0, 0 },
/* U+03bb */ { 2, 0, 1, 0, 0 },
/* U+03bc */ { 2, 0, 1, 0, 0 },
/* U+03bd */ { 2, 0, 1, 0, 0 },
/* U+03be */ { 2, 0, 1, 0, 0 },
/* U+03bf */ { 2, 0, 1, 0, 0 },
/* U+03c0 */ { 2, 0, 1, 0, 0 },
/* U+03c1 */ { 2, 0, 1, 0, 0 },
/* U+03c2 */ { 2, 0, 1, 0, 0 },
/* U+03c3 */ { 2, 0, 1, 0, 0 },
/* U+03c4 */ { 2, 0, 1, 0, 0 },
/* U+03c5 */ { 2, 0, 1, 0, 0 },
/* U+03c6 */ { 2, 0, 1, 0, 0 },
/* U+03c7 */ { 2, 0, 1, 0, 0 },
/* U+03c8 */ { 2, 0, 1, 0, 0 },
/* U+03c9 */ { 2, 0, 1, 0, 0 },
/* U+03ca */ { 2, 0, 1, 0, "03B9 0308" },
/* U+03cb */ { 2, 0, 1, 0, "03C5 0308" },
/* U+03cc */ { 2, 0, 1, 0, "03BF 0301" },
/* U+03cd */ { 2, 0, 1, 0, "03C5 0301" },
/* U+03ce */ { 2, 0, 1, 0, "03C9 0301" },
/* U+03cf */ { 0, 0, 0, 0, 0 },
/* U+03d0 */ { 2, 0, 1, 0, "<compat> 03B2" },
/* U+03d1 */ { 2, 0, 1, 0, "<compat> 03B8" },
/* U+03d2 */ { 1, 0, 1, 0, "<compat> 03A5" },
/* U+03d3 */ { 1, 0, 1, 0, "03D2 0301" },
/* U+03d4 */ { 1, 0, 1, 0, "03D2 0308" },
/* U+03d5 */ { 2, 0, 1, 0, "<compat> 03C6" },
/* U+03d6 */ { 2, 0, 1, 0, "<compat> 03C0" },
/* U+03d7 */ { 2, 0, 1, 0, 0 },
/* U+03d8 */ { 0, 0, 0, 0, 0 },
/* U+03d9 */ { 0, 0, 0, 0, 0 },
/* U+03da */ { 1, 0, 1, 0, 0 },
/* U+03db */ { 2, 0, 1, 0, 0 },
/* U+03dc */ { 1, 0, 1, 0, 0 },
/* U+03dd */ { 2, 0, 1, 0, 0 },
/* U+03de */ { 1, 0, 1, 0, 0 },
/* U+03df */ { 2, 0, 1, 0, 0 },
/* U+03e0 */ { 1, 0, 1, 0, 0 },
/* U+03e1 */ { 2, 0, 1, 0, 0 },
/* U+03e2 */ { 1, 0, 1, 0, 0 },
/* U+03e3 */ { 2, 0, 1, 0, 0 },
/* U+03e4 */ { 1, 0, 1, 0, 0 },
/* U+03e5 */ { 2, 0, 1, 0, 0 },
/* U+03e6 */ { 1, 0, 1, 0, 0 },
/* U+03e7 */ { 2, 0, 1, 0, 0 },
/* U+03e8 */ { 1, 0, 1, 0, 0 },
/* U+03e9 */ { 2, 0, 1, 0, 0 },
/* U+03ea */ { 1, 0, 1, 0, 0 },
/* U+03eb */ { 2, 0, 1, 0, 0 },
/* U+03ec */ { 1, 0, 1, 0, 0 },
/* U+03ed */ { 2, 0, 1, 0, 0 },
/* U+03ee */ { 1, 0, 1, 0, 0 },
/* U+03ef */ { 2, 0, 1, 0, 0 },
/* U+03f0 */ { 2, 0, 1, 0, "<compat> 03BA" },
/* U+03f1 */ { 2, 0, 1, 0, "<compat> 03C1" },
/* U+03f2 */ { 2, 0, 1, 0, "<compat> 03C2" },
/* U+03f3 */ { 2, 0, 1, 0, 0 },
/* U+03f4 */ { 0, 0, 0, 0, 0 },
/* U+03f5 */ { 0, 0, 0, 0, 0 },
/* U+03f6 */ { 0, 0, 0, 0, 0 },
/* U+03f7 */ { 0, 0, 0, 0, 0 },
/* U+03f8 */ { 0, 0, 0, 0, 0 },
/* U+03f9 */ { 0, 0, 0, 0, 0 },
/* U+03fa */ { 0, 0, 0, 0, 0 },
/* U+03fb */ { 0, 0, 0, 0, 0 },
/* U+03fc */ { 0, 0, 0, 0, 0 },
/* U+03fd */ { 0, 0, 0, 0, 0 },
/* U+03fe */ { 0, 0, 0, 0, 0 },
/* U+03ff */ { 0, 0, 0, 0, 0 },
/* U+0400 */ { 1, 0, 1, 0, "0415 0300" },
/* U+0401 */ { 1, 0, 1, 0, "0415 0308" },
/* U+0402 */ { 1, 0, 1, 0, 0 },
/* U+0403 */ { 1, 0, 1, 0, "0413 0301" },
/* U+0404 */ { 1, 0, 1, 0, 0 },
/* U+0405 */ { 1, 0, 1, 0, 0 },
/* U+0406 */ { 1, 0, 1, 0, 0 },
/* U+0407 */ { 1, 0, 1, 0, "0406 0308" },
/* U+0408 */ { 1, 0, 1, 0, 0 },
/* U+0409 */ { 1, 0, 1, 0, 0 },
/* U+040a */ { 1, 0, 1, 0, 0 },
/* U+040b */ { 1, 0, 1, 0, 0 },
/* U+040c */ { 1, 0, 1, 0, "041A 0301" },
/* U+040d */ { 1, 0, 1, 0, "0418 0300" },
/* U+040e */ { 1, 0, 1, 0, "0423 0306" },
/* U+040f */ { 1, 0, 1, 0, 0 },
/* U+0410 */ { 1, 0, 1, 0, 0 },
/* U+0411 */ { 1, 0, 1, 0, 0 },
/* U+0412 */ { 1, 0, 1, 0, 0 },
/* U+0413 */ { 1, 0, 1, 0, 0 },
/* U+0414 */ { 1, 0, 1, 0, 0 },
/* U+0415 */ { 1, 0, 1, 0, 0 },
/* U+0416 */ { 1, 0, 1, 0, 0 },
/* U+0417 */ { 1, 0, 1, 0, 0 },
/* U+0418 */ { 1, 0, 1, 0, 0 },
/* U+0419 */ { 1, 0, 1, 0, "0418 0306" },
/* U+041a */ { 1, 0, 1, 0, 0 },
/* U+041b */ { 1, 0, 1, 0, 0 },
/* U+041c */ { 1, 0, 1, 0, 0 },
/* U+041d */ { 1, 0, 1, 0, 0 },
/* U+041e */ { 1, 0, 1, 0, 0 },
/* U+041f */ { 1, 0, 1, 0, 0 },
/* U+0420 */ { 1, 0, 1, 0, 0 },
/* U+0421 */ { 1, 0, 1, 0, 0 },
/* U+0422 */ { 1, 0, 1, 0, 0 },
/* U+0423 */ { 1, 0, 1, 0, 0 },
/* U+0424 */ { 1, 0, 1, 0, 0 },
/* U+0425 */ { 1, 0, 1, 0, 0 },
/* U+0426 */ { 1, 0, 1, 0, 0 },
/* U+0427 */ { 1, 0, 1, 0, 0 },
/* U+0428 */ { 1, 0, 1, 0, 0 },
/* U+0429 */ { 1, 0, 1, 0, 0 },
/* U+042a */ { 1, 0, 1, 0, 0 },
/* U+042b */ { 1, 0, 1, 0, 0 },
/* U+042c */ { 1, 0, 1, 0, 0 },
/* U+042d */ { 1, 0, 1, 0, 0 },
/* U+042e */ { 1, 0, 1, 0, 0 },
/* U+042f */ { 1, 0, 1, 0, 0 },
/* U+0430 */ { 2, 0, 1, 0, 0 },
/* U+0431 */ { 2, 0, 1, 0, 0 },
/* U+0432 */ { 2, 0, 1, 0, 0 },
/* U+0433 */ { 2, 0, 1, 0, 0 },
/* U+0434 */ { 2, 0, 1, 0, 0 },
/* U+0435 */ { 2, 0, 1, 0, 0 },
/* U+0436 */ { 2, 0, 1, 0, 0 },
/* U+0437 */ { 2, 0, 1, 0, 0 },
/* U+0438 */ { 2, 0, 1, 0, 0 },
/* U+0439 */ { 2, 0, 1, 0, "0438 0306" },
/* U+043a */ { 2, 0, 1, 0, 0 },
/* U+043b */ { 2, 0, 1, 0, 0 },
/* U+043c */ { 2, 0, 1, 0, 0 },
/* U+043d */ { 2, 0, 1, 0, 0 },
/* U+043e */ { 2, 0, 1, 0, 0 },
/* U+043f */ { 2, 0, 1, 0, 0 },
/* U+0440 */ { 2, 0, 1, 0, 0 },
/* U+0441 */ { 2, 0, 1, 0, 0 },
/* U+0442 */ { 2, 0, 1, 0, 0 },
/* U+0443 */ { 2, 0, 1, 0, 0 },
/* U+0444 */ { 2, 0, 1, 0, 0 },
/* U+0445 */ { 2, 0, 1, 0, 0 },
/* U+0446 */ { 2, 0, 1, 0, 0 },
/* U+0447 */ { 2, 0, 1, 0, 0 },
/* U+0448 */ { 2, 0, 1, 0, 0 },
/* U+0449 */ { 2, 0, 1, 0, 0 },
/* U+044a */ { 2, 0, 1, 0, 0 },
/* U+044b */ { 2, 0, 1, 0, 0 },
/* U+044c */ { 2, 0, 1, 0, 0 },
/* U+044d */ { 2, 0, 1, 0, 0 },
/* U+044e */ { 2, 0, 1, 0, 0 },
/* U+044f */ { 2, 0, 1, 0, 0 },
/* U+0450 */ { 2, 0, 1, 0, "0435 0300" },
/* U+0451 */ { 2, 0, 1, 0, "0435 0308" },
/* U+0452 */ { 2, 0, 1, 0, 0 },
/* U+0453 */ { 2, 0, 1, 0, "0433 0301" },
/* U+0454 */ { 2, 0, 1, 0, 0 },
/* U+0455 */ { 2, 0, 1, 0, 0 },
/* U+0456 */ { 2, 0, 1, 0, 0 },
/* U+0457 */ { 2, 0, 1, 0, "0456 0308" },
/* U+0458 */ { 2, 0, 1, 0, 0 },
/* U+0459 */ { 2, 0, 1, 0, 0 },
/* U+045a */ { 2, 0, 1, 0, 0 },
/* U+045b */ { 2, 0, 1, 0, 0 },
/* U+045c */ { 2, 0, 1, 0, "043A 0301" },
/* U+045d */ { 2, 0, 1, 0, "0438 0300" },
/* U+045e */ { 2, 0, 1, 0, "0443 0306" },
/* U+045f */ { 2, 0, 1, 0, 0 },
/* U+0460 */ { 1, 0, 1, 0, 0 },
/* U+0461 */ { 2, 0, 1, 0, 0 },
/* U+0462 */ { 1, 0, 1, 0, 0 },
/* U+0463 */ { 2, 0, 1, 0, 0 },
/* U+0464 */ { 1, 0, 1, 0, 0 },
/* U+0465 */ { 2, 0, 1, 0, 0 },
/* U+0466 */ { 1, 0, 1, 0, 0 },
/* U+0467 */ { 2, 0, 1, 0, 0 },
/* U+0468 */ { 1, 0, 1, 0, 0 },
/* U+0469 */ { 2, 0, 1, 0, 0 },
/* U+046a */ { 1, 0, 1, 0, 0 },
/* U+046b */ { 2, 0, 1, 0, 0 },
/* U+046c */ { 1, 0, 1, 0, 0 },
/* U+046d */ { 2, 0, 1, 0, 0 },
/* U+046e */ { 1, 0, 1, 0, 0 },
/* U+046f */ { 2, 0, 1, 0, 0 },
/* U+0470 */ { 1, 0, 1, 0, 0 },
/* U+0471 */ { 2, 0, 1, 0, 0 },
/* U+0472 */ { 1, 0, 1, 0, 0 },
/* U+0473 */ { 2, 0, 1, 0, 0 },
/* U+0474 */ { 1, 0, 1, 0, 0 },
/* U+0475 */ { 2, 0, 1, 0, 0 },
/* U+0476 */ { 1, 0, 1, 0, "0474 030F" },
/* U+0477 */ { 2, 0, 1, 0, "0475 030F" },
/* U+0478 */ { 1, 0, 1, 0, 0 },
/* U+0479 */ { 2, 0, 1, 0, 0 },
/* U+047a */ { 1, 0, 1, 0, 0 },
/* U+047b */ { 2, 0, 1, 0, 0 },
/* U+047c */ { 1, 0, 1, 0, 0 },
/* U+047d */ { 2, 0, 1, 0, 0 },
/* U+047e */ { 1, 0, 1, 0, 0 },
/* U+047f */ { 2, 0, 1, 0, 0 },
/* U+0480 */ { 1, 0, 1, 0, 0 },
/* U+0481 */ { 2, 0, 1, 0, 0 },
/* U+0482 */ { 30, 0, 1, 0, 0 },
/* U+0483 */ { 4, 230, 14, 0, 0 },
/* U+0484 */ { 4, 230, 14, 0, 0 },
/* U+0485 */ { 4, 230, 14, 0, 0 },
/* U+0486 */ { 4, 230, 14, 0, 0 },
/* U+0487 */ { 0, 0, 0, 0, 0 },
/* U+0488 */ { 6, 0, 14, 0, 0 },
/* U+0489 */ { 6, 0, 14, 0, 0 },
/* U+048a */ { 0, 0, 0, 0, 0 },
/* U+048b */ { 0, 0, 0, 0, 0 },
/* U+048c */ { 1, 0, 1, 0, 0 },
/* U+048d */ { 2, 0, 1, 0, 0 },
/* U+048e */ { 1, 0, 1, 0, 0 },
/* U+048f */ { 2, 0, 1, 0, 0 },
/* U+0490 */ { 1, 0, 1, 0, 0 },
/* U+0491 */ { 2, 0, 1, 0, 0 },
/* U+0492 */ { 1, 0, 1, 0, 0 },
/* U+0493 */ { 2, 0, 1, 0, 0 },
/* U+0494 */ { 1, 0, 1, 0, 0 },
/* U+0495 */ { 2, 0, 1, 0, 0 },
/* U+0496 */ { 1, 0, 1, 0, 0 },
/* U+0497 */ { 2, 0, 1, 0, 0 },
/* U+0498 */ { 1, 0, 1, 0, 0 },
/* U+0499 */ { 2, 0, 1, 0, 0 },
/* U+049a */ { 1, 0, 1, 0, 0 },
/* U+049b */ { 2, 0, 1, 0, 0 },
/* U+049c */ { 1, 0, 1, 0, 0 },
/* U+049d */ { 2, 0, 1, 0, 0 },
/* U+049e */ { 1, 0, 1, 0, 0 },
/* U+049f */ { 2, 0, 1, 0, 0 },
/* U+04a0 */ { 1, 0, 1, 0, 0 },
/* U+04a1 */ { 2, 0, 1, 0, 0 },
/* U+04a2 */ { 1, 0, 1, 0, 0 },
/* U+04a3 */ { 2, 0, 1, 0, 0 },
/* U+04a4 */ { 1, 0, 1, 0, 0 },
/* U+04a5 */ { 2, 0, 1, 0, 0 },
/* U+04a6 */ { 1, 0, 1, 0, 0 },
/* U+04a7 */ { 2, 0, 1, 0, 0 },
/* U+04a8 */ { 1, 0, 1, 0, 0 },
/* U+04a9 */ { 2, 0, 1, 0, 0 },
/* U+04aa */ { 1, 0, 1, 0, 0 },
/* U+04ab */ { 2, 0, 1, 0, 0 },
/* U+04ac */ { 1, 0, 1, 0, 0 },
/* U+04ad */ { 2, 0, 1, 0, 0 },
/* U+04ae */ { 1, 0, 1, 0, 0 },
/* U+04af */ { 2, 0, 1, 0, 0 },
/* U+04b0 */ { 1, 0, 1, 0, 0 },
/* U+04b1 */ { 2, 0, 1, 0, 0 },
/* U+04b2 */ { 1, 0, 1, 0, 0 },
/* U+04b3 */ { 2, 0, 1, 0, 0 },
/* U+04b4 */ { 1, 0, 1, 0, 0 },
/* U+04b5 */ { 2, 0, 1, 0, 0 },
/* U+04b6 */ { 1, 0, 1, 0, 0 },
/* U+04b7 */ { 2, 0, 1, 0, 0 },
/* U+04b8 */ { 1, 0, 1, 0, 0 },
/* U+04b9 */ { 2, 0, 1, 0, 0 },
/* U+04ba */ { 1, 0, 1, 0, 0 },
/* U+04bb */ { 2, 0, 1, 0, 0 },
/* U+04bc */ { 1, 0, 1, 0, 0 },
/* U+04bd */ { 2, 0, 1, 0, 0 },
/* U+04be */ { 1, 0, 1, 0, 0 },
/* U+04bf */ { 2, 0, 1, 0, 0 },
/* U+04c0 */ { 1, 0, 1, 0, 0 },
/* U+04c1 */ { 1, 0, 1, 0, "0416 0306" },
/* U+04c2 */ { 2, 0, 1, 0, "0436 0306" },
/* U+04c3 */ { 1, 0, 1, 0, 0 },
/* U+04c4 */ { 2, 0, 1, 0, 0 },
/* U+04c5 */ { 0, 0, 0, 0, 0 },
/* U+04c6 */ { 0, 0, 0, 0, 0 },
/* U+04c7 */ { 1, 0, 1, 0, 0 },
/* U+04c8 */ { 2, 0, 1, 0, 0 },
/* U+04c9 */ { 0, 0, 0, 0, 0 },
/* U+04ca */ { 0, 0, 0, 0, 0 },
/* U+04cb */ { 1, 0, 1, 0, 0 },
/* U+04cc */ { 2, 0, 1, 0, 0 },
/* U+04cd */ { 0, 0, 0, 0, 0 },
/* U+04ce */ { 0, 0, 0, 0, 0 },
/* U+04cf */ { 0, 0, 0, 0, 0 },
/* U+04d0 */ { 1, 0, 1, 0, "0410 0306" },
/* U+04d1 */ { 2, 0, 1, 0, "0430 0306" },
/* U+04d2 */ { 1, 0, 1, 0, "0410 0308" },
/* U+04d3 */ { 2, 0, 1, 0, "0430 0308" },
/* U+04d4 */ { 1, 0, 1, 0, 0 },
/* U+04d5 */ { 2, 0, 1, 0, 0 },
/* U+04d6 */ { 1, 0, 1, 0, "0415 0306" },
/* U+04d7 */ { 2, 0, 1, 0, "0435 0306" },
/* U+04d8 */ { 1, 0, 1, 0, 0 },
/* U+04d9 */ { 2, 0, 1, 0, 0 },
/* U+04da */ { 1, 0, 1, 0, "04D8 0308" },
/* U+04db */ { 2, 0, 1, 0, "04D9 0308" },
/* U+04dc */ { 1, 0, 1, 0, "0416 0308" },
/* U+04dd */ { 2, 0, 1, 0, "0436 0308" },
/* U+04de */ { 1, 0, 1, 0, "0417 0308" },
/* U+04df */ { 2, 0, 1, 0, "0437 0308" },
/* U+04e0 */ { 1, 0, 1, 0, 0 },
/* U+04e1 */ { 2, 0, 1, 0, 0 },
/* U+04e2 */ { 1, 0, 1, 0, "0418 0304" },
/* U+04e3 */ { 2, 0, 1, 0, "0438 0304" },
/* U+04e4 */ { 1, 0, 1, 0, "0418 0308" },
/* U+04e5 */ { 2, 0, 1, 0, "0438 0308" },
/* U+04e6 */ { 1, 0, 1, 0, "041E 0308" },
/* U+04e7 */ { 2, 0, 1, 0, "043E 0308" },
/* U+04e8 */ { 1, 0, 1, 0, 0 },
/* U+04e9 */ { 2, 0, 1, 0, 0 },
/* U+04ea */ { 1, 0, 1, 0, "04E8 0308" },
/* U+04eb */ { 2, 0, 1, 0, "04E9 0308" },
/* U+04ec */ { 1, 0, 1, 0, "042D 0308" },
/* U+04ed */ { 2, 0, 1, 0, "044D 0308" },
/* U+04ee */ { 1, 0, 1, 0, "0423 0304" },
/* U+04ef */ { 2, 0, 1, 0, "0443 0304" },
/* U+04f0 */ { 1, 0, 1, 0, "0423 0308" },
/* U+04f1 */ { 2, 0, 1, 0, "0443 0308" },
/* U+04f2 */ { 1, 0, 1, 0, "0423 030B" },
/* U+04f3 */ { 2, 0, 1, 0, "0443 030B" },
/* U+04f4 */ { 1, 0, 1, 0, "0427 0308" },
/* U+04f5 */ { 2, 0, 1, 0, "0447 0308" },
/* U+04f6 */ { 0, 0, 0, 0, 0 },
/* U+04f7 */ { 0, 0, 0, 0, 0 },
/* U+04f8 */ { 1, 0, 1, 0, "042B 0308" },
/* U+04f9 */ { 2, 0, 1, 0, "044B 0308" },
/* U+04fa */ { 0, 0, 0, 0, 0 },
/* U+04fb */ { 0, 0, 0, 0, 0 },
/* U+04fc */ { 0, 0, 0, 0, 0 },
/* U+04fd */ { 0, 0, 0, 0, 0 },
/* U+04fe */ { 0, 0, 0, 0, 0 },
/* U+04ff */ { 0, 0, 0, 0, 0 },
/* U+0500 */ { 0, 0, 0, 0, 0 },
/* U+0501 */ { 0, 0, 0, 0, 0 },
/* U+0502 */ { 0, 0, 0, 0, 0 },
/* U+0503 */ { 0, 0, 0, 0, 0 },
/* U+0504 */ { 0, 0, 0, 0, 0 },
/* U+0505 */ { 0, 0, 0, 0, 0 },
/* U+0506 */ { 0, 0, 0, 0, 0 },
/* U+0507 */ { 0, 0, 0, 0, 0 },
/* U+0508 */ { 0, 0, 0, 0, 0 },
/* U+0509 */ { 0, 0, 0, 0, 0 },
/* U+050a */ { 0, 0, 0, 0, 0 },
/* U+050b */ { 0, 0, 0, 0, 0 },
/* U+050c */ { 0, 0, 0, 0, 0 },
/* U+050d */ { 0, 0, 0, 0, 0 },
/* U+050e */ { 0, 0, 0, 0, 0 },
/* U+050f */ { 0, 0, 0, 0, 0 },
/* U+0510 */ { 0, 0, 0, 0, 0 },
/* U+0511 */ { 0, 0, 0, 0, 0 },
/* U+0512 */ { 0, 0, 0, 0, 0 },
/* U+0513 */ { 0, 0, 0, 0, 0 },
/* U+0514 */ { 0, 0, 0, 0, 0 },
/* U+0515 */ { 0, 0, 0, 0, 0 },
/* U+0516 */ { 0, 0, 0, 0, 0 },
/* U+0517 */ { 0, 0, 0, 0, 0 },
/* U+0518 */ { 0, 0, 0, 0, 0 },
/* U+0519 */ { 0, 0, 0, 0, 0 },
/* U+051a */ { 0, 0, 0, 0, 0 },
/* U+051b */ { 0, 0, 0, 0, 0 },
/* U+051c */ { 0, 0, 0, 0, 0 },
/* U+051d */ { 0, 0, 0, 0, 0 },
/* U+051e */ { 0, 0, 0, 0, 0 },
/* U+051f */ { 0, 0, 0, 0, 0 },
/* U+0520 */ { 0, 0, 0, 0, 0 },
/* U+0521 */ { 0, 0, 0, 0, 0 },
/* U+0522 */ { 0, 0, 0, 0, 0 },
/* U+0523 */ { 0, 0, 0, 0, 0 },
/* U+0524 */ { 0, 0, 0, 0, 0 },
/* U+0525 */ { 0, 0, 0, 0, 0 },
/* U+0526 */ { 0, 0, 0, 0, 0 },
/* U+0527 */ { 0, 0, 0, 0, 0 },
/* U+0528 */ { 0, 0, 0, 0, 0 },
/* U+0529 */ { 0, 0, 0, 0, 0 },
/* U+052a */ { 0, 0, 0, 0, 0 },
/* U+052b */ { 0, 0, 0, 0, 0 },
/* U+052c */ { 0, 0, 0, 0, 0 },
/* U+052d */ { 0, 0, 0, 0, 0 },
/* U+052e */ { 0, 0, 0, 0, 0 },
/* U+052f */ { 0, 0, 0, 0, 0 },
/* U+0530 */ { 0, 0, 0, 0, 0 },
/* U+0531 */ { 1, 0, 1, 0, 0 },
/* U+0532 */ { 1, 0, 1, 0, 0 },
/* U+0533 */ { 1, 0, 1, 0, 0 },
/* U+0534 */ { 1, 0, 1, 0, 0 },
/* U+0535 */ { 1, 0, 1, 0, 0 },
/* U+0536 */ { 1, 0, 1, 0, 0 },
/* U+0537 */ { 1, 0, 1, 0, 0 },
/* U+0538 */ { 1, 0, 1, 0, 0 },
/* U+0539 */ { 1, 0, 1, 0, 0 },
/* U+053a */ { 1, 0, 1, 0, 0 },
/* U+053b */ { 1, 0, 1, 0, 0 },
/* U+053c */ { 1, 0, 1, 0, 0 },
/* U+053d */ { 1, 0, 1, 0, 0 },
/* U+053e */ { 1, 0, 1, 0, 0 },
/* U+053f */ { 1, 0, 1, 0, 0 },
/* U+0540 */ { 1, 0, 1, 0, 0 },
/* U+0541 */ { 1, 0, 1, 0, 0 },
/* U+0542 */ { 1, 0, 1, 0, 0 },
/* U+0543 */ { 1, 0, 1, 0, 0 },
/* U+0544 */ { 1, 0, 1, 0, 0 },
/* U+0545 */ { 1, 0, 1, 0, 0 },
/* U+0546 */ { 1, 0, 1, 0, 0 },
/* U+0547 */ { 1, 0, 1, 0, 0 },
/* U+0548 */ { 1, 0, 1, 0, 0 },
/* U+0549 */ { 1, 0, 1, 0, 0 },
/* U+054a */ { 1, 0, 1, 0, 0 },
/* U+054b */ { 1, 0, 1, 0, 0 },
/* U+054c */ { 1, 0, 1, 0, 0 },
/* U+054d */ { 1, 0, 1, 0, 0 },
/* U+054e */ { 1, 0, 1, 0, 0 },
/* U+054f */ { 1, 0, 1, 0, 0 },
/* U+0550 */ { 1, 0, 1, 0, 0 },
/* U+0551 */ { 1, 0, 1, 0, 0 },
/* U+0552 */ { 1, 0, 1, 0, 0 },
/* U+0553 */ { 1, 0, 1, 0, 0 },
/* U+0554 */ { 1, 0, 1, 0, 0 },
/* U+0555 */ { 1, 0, 1, 0, 0 },
/* U+0556 */ { 1, 0, 1, 0, 0 },
/* U+0557 */ { 0, 0, 0, 0, 0 },
/* U+0558 */ { 0, 0, 0, 0, 0 },
/* U+0559 */ { 18, 0, 1, 0, 0 },
/* U+055a */ { 26, 0, 1, 0, 0 },
/* U+055b */ { 26, 0, 1, 0, 0 },
/* U+055c */ { 26, 0, 1, 0, 0 },
/* U+055d */ { 26, 0, 1, 0, 0 },
/* U+055e */ { 26, 0, 1, 0, 0 },
/* U+055f */ { 26, 0, 1, 0, 0 },
/* U+0560 */ { 0, 0, 0, 0, 0 },
/* U+0561 */ { 2, 0, 1, 0, 0 },
/* U+0562 */ { 2, 0, 1, 0, 0 },
/* U+0563 */ { 2, 0, 1, 0, 0 },
/* U+0564 */ { 2, 0, 1, 0, 0 },
/* U+0565 */ { 2, 0, 1, 0, 0 },
/* U+0566 */ { 2, 0, 1, 0, 0 },
/* U+0567 */ { 2, 0, 1, 0, 0 },
/* U+0568 */ { 2, 0, 1, 0, 0 },
/* U+0569 */ { 2, 0, 1, 0, 0 },
/* U+056a */ { 2, 0, 1, 0, 0 },
/* U+056b */ { 2, 0, 1, 0, 0 },
/* U+056c */ { 2, 0, 1, 0, 0 },
/* U+056d */ { 2, 0, 1, 0, 0 },
/* U+056e */ { 2, 0, 1, 0, 0 },
/* U+056f */ { 2, 0, 1, 0, 0 },
/* U+0570 */ { 2, 0, 1, 0, 0 },
/* U+0571 */ { 2, 0, 1, 0, 0 },
/* U+0572 */ { 2, 0, 1, 0, 0 },
/* U+0573 */ { 2, 0, 1, 0, 0 },
/* U+0574 */ { 2, 0, 1, 0, 0 },
/* U+0575 */ { 2, 0, 1, 0, 0 },
/* U+0576 */ { 2, 0, 1, 0, 0 },
/* U+0577 */ { 2, 0, 1, 0, 0 },
/* U+0578 */ { 2, 0, 1, 0, 0 },
/* U+0579 */ { 2, 0, 1, 0, 0 },
/* U+057a */ { 2, 0, 1, 0, 0 },
/* U+057b */ { 2, 0, 1, 0, 0 },
/* U+057c */ { 2, 0, 1, 0, 0 },
/* U+057d */ { 2, 0, 1, 0, 0 },
/* U+057e */ { 2, 0, 1, 0, 0 },
/* U+057f */ { 2, 0, 1, 0, 0 },
/* U+0580 */ { 2, 0, 1, 0, 0 },
/* U+0581 */ { 2, 0, 1, 0, 0 },
/* U+0582 */ { 2, 0, 1, 0, 0 },
/* U+0583 */ { 2, 0, 1, 0, 0 },
/* U+0584 */ { 2, 0, 1, 0, 0 },
/* U+0585 */ { 2, 0, 1, 0, 0 },
/* U+0586 */ { 2, 0, 1, 0, 0 },
/* U+0587 */ { 2, 0, 1, 0, "<compat> 0565 0582" },
/* U+0588 */ { 0, 0, 0, 0, 0 },
/* U+0589 */ { 26, 0, 1, 0, 0 },
/* U+058a */ { 21, 0, 19, 0, 0 },
/* U+058b */ { 0, 0, 0, 0, 0 },
/* U+058c */ { 0, 0, 0, 0, 0 },
/* U+058d */ { 0, 0, 0, 0, 0 },
/* U+058e */ { 0, 0, 0, 0, 0 },
/* U+058f */ { 0, 0, 0, 0, 0 },
/* U+0590 */ { 0, 0, 0, 0, 0 },
/* U+0591 */ { 4, 220, 14, 0, 0 },
/* U+0592 */ { 4, 230, 14, 0, 0 },
/* U+0593 */ { 4, 230, 14, 0, 0 },
/* U+0594 */ { 4, 230, 14, 0, 0 },
/* U+0595 */ { 4, 230, 14, 0, 0 },
/* U+0596 */ { 4, 220, 14, 0, 0 },
/* U+0597 */ { 4, 230, 14, 0, 0 },
/* U+0598 */ { 4, 230, 14, 0, 0 },
/* U+0599 */ { 4, 230, 14, 0, 0 },
/* U+059a */ { 4, 222, 14, 0, 0 },
/* U+059b */ { 4, 220, 14, 0, 0 },
/* U+059c */ { 4, 230, 14, 0, 0 },
/* U+059d */ { 4, 230, 14, 0, 0 },
/* U+059e */ { 4, 230, 14, 0, 0 },
/* U+059f */ { 4, 230, 14, 0, 0 },
/* U+05a0 */ { 4, 230, 14, 0, 0 },
/* U+05a1 */ { 4, 230, 14, 0, 0 },
/* U+05a2 */ { 0, 0, 0, 0, 0 },
/* U+05a3 */ { 4, 220, 14, 0, 0 },
/* U+05a4 */ { 4, 220, 14, 0, 0 },
/* U+05a5 */ { 4, 220, 14, 0, 0 },
/* U+05a6 */ { 4, 220, 14, 0, 0 },
/* U+05a7 */ { 4, 220, 14, 0, 0 },
/* U+05a8 */ { 4, 230, 14, 0, 0 },
/* U+05a9 */ { 4, 230, 14, 0, 0 },
/* U+05aa */ { 4, 220, 14, 0, 0 },
/* U+05ab */ { 4, 230, 14, 0, 0 },
/* U+05ac */ { 4, 230, 14, 0, 0 },
/* U+05ad */ { 4, 222, 14, 0, 0 },
/* U+05ae */ { 4, 228, 14, 0, 0 },
/* U+05af */ { 4, 230, 14, 0, 0 },
/* U+05b0 */ { 4, 10, 14, 0, 0 },
/* U+05b1 */ { 4, 11, 14, 0, 0 },
/* U+05b2 */ { 4, 12, 14, 0, 0 },
/* U+05b3 */ { 4, 13, 14, 0, 0 },
/* U+05b4 */ { 4, 14, 14, 0, 0 },
/* U+05b5 */ { 4, 15, 14, 0, 0 },
/* U+05b6 */ { 4, 16, 14, 0, 0 },
/* U+05b7 */ { 4, 17, 14, 0, 0 },
/* U+05b8 */ { 4, 18, 14, 0, 0 },
/* U+05b9 */ { 4, 19, 14, 0, 0 },
/* U+05ba */ { 0, 0, 0, 0, 0 },
/* U+05bb */ { 4, 20, 14, 0, 0 },
/* U+05bc */ { 4, 21, 14, 0, 0 },
/* U+05bd */ { 4, 22, 14, 0, 0 },
/* U+05be */ { 26, 0, 4, 0, 0 },
/* U+05bf */ { 4, 23, 14, 0, 0 },
/* U+05c0 */ { 26, 0, 4, 0, 0 },
/* U+05c1 */ { 4, 24, 14, 0, 0 },
/* U+05c2 */ { 4, 25, 14, 0, 0 },
/* U+05c3 */ { 26, 0, 4, 0, 0 },
/* U+05c4 */ { 4, 230, 14, 0, 0 },
/* U+05c5 */ { 0, 0, 0, 0, 0 },
/* U+05c6 */ { 0, 0, 0, 0, 0 },
/* U+05c7 */ { 0, 0, 0, 0, 0 },
/* U+05c8 */ { 0, 0, 0, 0, 0 },
/* U+05c9 */ { 0, 0, 0, 0, 0 },
/* U+05ca */ { 0, 0, 0, 0, 0 },
/* U+05cb */ { 0, 0, 0, 0, 0 },
/* U+05cc */ { 0, 0, 0, 0, 0 },
/* U+05cd */ { 0, 0, 0, 0, 0 },
/* U+05ce */ { 0, 0, 0, 0, 0 },
/* U+05cf */ { 0, 0, 0, 0, 0 },
/* U+05d0 */ { 19, 0, 4, 0, 0 },
/* U+05d1 */ { 19, 0, 4, 0, 0 },
/* U+05d2 */ { 19, 0, 4, 0, 0 },
/* U+05d3 */ { 19, 0, 4, 0, 0 },
/* U+05d4 */ { 19, 0, 4, 0, 0 },
/* U+05d5 */ { 19, 0, 4, 0, 0 },
/* U+05d6 */ { 19, 0, 4, 0, 0 },
/* U+05d7 */ { 19, 0, 4, 0, 0 },
/* U+05d8 */ { 19, 0, 4, 0, 0 },
/* U+05d9 */ { 19, 0, 4, 0, 0 },
/* U+05da */ { 19, 0, 4, 0, 0 },
/* U+05db */ { 19, 0, 4, 0, 0 },
/* U+05dc */ { 19, 0, 4, 0, 0 },
/* U+05dd */ { 19, 0, 4, 0, 0 },
/* U+05de */ { 19, 0, 4, 0, 0 },
/* U+05df */ { 19, 0, 4, 0, 0 },
/* U+05e0 */ { 19, 0, 4, 0, 0 },
/* U+05e1 */ { 19, 0, 4, 0, 0 },
/* U+05e2 */ { 19, 0, 4, 0, 0 },
/* U+05e3 */ { 19, 0, 4, 0, 0 },
/* U+05e4 */ { 19, 0, 4, 0, 0 },
/* U+05e5 */ { 19, 0, 4, 0, 0 },
/* U+05e6 */ { 19, 0, 4, 0, 0 },
/* U+05e7 */ { 19, 0, 4, 0, 0 },
/* U+05e8 */ { 19, 0, 4, 0, 0 },
/* U+05e9 */ { 19, 0, 4, 0, 0 },
/* U+05ea */ { 19, 0, 4, 0, 0 },
/* U+05eb */ { 0, 0, 0, 0, 0 },
/* U+05ec */ { 0, 0, 0, 0, 0 },
/* U+05ed */ { 0, 0, 0, 0, 0 },
/* U+05ee */ { 0, 0, 0, 0, 0 },
/* U+05ef */ { 0, 0, 0, 0, 0 },
/* U+05f0 */ { 19, 0, 4, 0, 0 },
/* U+05f1 */ { 19, 0, 4, 0, 0 },
/* U+05f2 */ { 19, 0, 4, 0, 0 },
/* U+05f3 */ { 26, 0, 4, 0, 0 },
/* U+05f4 */ { 26, 0, 4, 0, 0 },
/* U+05f5 */ { 0, 0, 0, 0, 0 },
/* U+05f6 */ { 0, 0, 0, 0, 0 },
/* U+05f7 */ { 0, 0, 0, 0, 0 },
/* U+05f8 */ { 0, 0, 0, 0, 0 },
/* U+05f9 */ { 0, 0, 0, 0, 0 },
/* U+05fa */ { 0, 0, 0, 0, 0 },
/* U+05fb */ { 0, 0, 0, 0, 0 },
/* U+05fc */ { 0, 0, 0, 0, 0 },
/* U+05fd */ { 0, 0, 0, 0, 0 },
/* U+05fe */ { 0, 0, 0, 0, 0 },
/* U+05ff */ { 0, 0, 0, 0, 0 },
/* U+0600 */ { 0, 0, 0, 0, 0 },
/* U+0601 */ { 0, 0, 0, 0, 0 },
/* U+0602 */ { 0, 0, 0, 0, 0 },
/* U+0603 */ { 0, 0, 0, 0, 0 },
/* U+0604 */ { 0, 0, 0, 0, 0 },
/* U+0605 */ { 0, 0, 0, 0, 0 },
/* U+0606 */ { 0, 0, 0, 0, 0 },
/* U+0607 */ { 0, 0, 0, 0, 0 },
/* U+0608 */ { 0, 0, 0, 0, 0 },
/* U+0609 */ { 0, 0, 0, 0, 0 },
/* U+060a */ { 0, 0, 0, 0, 0 },
/* U+060b */ { 0, 0, 0, 0, 0 },
/* U+060c */ { 26, 0, 13, 0, 0 },
/* U+060d */ { 0, 0, 0, 0, 0 },
/* U+060e */ { 0, 0, 0, 0, 0 },
/* U+060f */ { 0, 0, 0, 0, 0 },
/* U+0610 */ { 0, 0, 0, 0, 0 },
/* U+0611 */ { 0, 0, 0, 0, 0 },
/* U+0612 */ { 0, 0, 0, 0, 0 },
/* U+0613 */ { 0, 0, 0, 0, 0 },
/* U+0614 */ { 0, 0, 0, 0, 0 },
/* U+0615 */ { 0, 0, 0, 0, 0 },
/* U+0616 */ { 0, 0, 0, 0, 0 },
/* U+0617 */ { 0, 0, 0, 0, 0 },
/* U+0618 */ { 0, 0, 0, 0, 0 },
/* U+0619 */ { 0, 0, 0, 0, 0 },
/* U+061a */ { 0, 0, 0, 0, 0 },
/* U+061b */ { 26, 0, 5, 0, 0 },
/* U+061c */ { 0, 0, 0, 0, 0 },
/* U+061d */ { 0, 0, 0, 0, 0 },
/* U+061e */ { 0, 0, 0, 0, 0 },
/* U+061f */ { 26, 0, 5, 0, 0 },
/* U+0620 */ { 0, 0, 0, 0, 0 },
/* U+0621 */ { 19, 0, 5, 0, 0 },
/* U+0622 */ { 19, 0, 5, 0, "0627 0653" },
/* U+0623 */ { 19, 0, 5, 0, "0627 0654" },
/* U+0624 */ { 19, 0, 5, 0, "0648 0654" },
/* U+0625 */ { 19, 0, 5, 0, "0627 0655" },
/* U+0626 */ { 19, 0, 5, 0, "064A 0654" },
/* U+0627 */ { 19, 0, 5, 0, 0 },
/* U+0628 */ { 19, 0, 5, 0, 0 },
/* U+0629 */ { 19, 0, 5, 0, 0 },
/* U+062a */ { 19, 0, 5, 0, 0 },
/* U+062b */ { 19, 0, 5, 0, 0 },
/* U+062c */ { 19, 0, 5, 0, 0 },
/* U+062d */ { 19, 0, 5, 0, 0 },
/* U+062e */ { 19, 0, 5, 0, 0 },
/* U+062f */ { 19, 0, 5, 0, 0 },
/* U+0630 */ { 19, 0, 5, 0, 0 },
/* U+0631 */ { 19, 0, 5, 0, 0 },
/* U+0632 */ { 19, 0, 5, 0, 0 },
/* U+0633 */ { 19, 0, 5, 0, 0 },
/* U+0634 */ { 19, 0, 5, 0, 0 },
/* U+0635 */ { 19, 0, 5, 0, 0 },
/* U+0636 */ { 19, 0, 5, 0, 0 },
/* U+0637 */ { 19, 0, 5, 0, 0 },
/* U+0638 */ { 19, 0, 5, 0, 0 },
/* U+0639 */ { 19, 0, 5, 0, 0 },
/* U+063a */ { 19, 0, 5, 0, 0 },
/* U+063b */ { 0, 0, 0, 0, 0 },
/* U+063c */ { 0, 0, 0, 0, 0 },
/* U+063d */ { 0, 0, 0, 0, 0 },
/* U+063e */ { 0, 0, 0, 0, 0 },
/* U+063f */ { 0, 0, 0, 0, 0 },
/* U+0640 */ { 18, 0, 5, 0, 0 },
/* U+0641 */ { 19, 0, 5, 0, 0 },
/* U+0642 */ { 19, 0, 5, 0, 0 },
/* U+0643 */ { 19, 0, 5, 0, 0 },
/* U+0644 */ { 19, 0, 5, 0, 0 },
/* U+0645 */ { 19, 0, 5, 0, 0 },
/* U+0646 */ { 19, 0, 5, 0, 0 },
/* U+0647 */ { 19, 0, 5, 0, 0 },
/* U+0648 */ { 19, 0, 5, 0, 0 },
/* U+0649 */ { 19, 0, 5, 0, 0 },
/* U+064a */ { 19, 0, 5, 0, 0 },
/* U+064b */ { 4, 27, 14, 0, 0 },
/* U+064c */ { 4, 28, 14, 0, 0 },
/* U+064d */ { 4, 29, 14, 0, 0 },
/* U+064e */ { 4, 30, 14, 0, 0 },
/* U+064f */ { 4, 31, 14, 0, 0 },
/* U+0650 */ { 4, 32, 14, 0, 0 },
/* U+0651 */ { 4, 33, 14, 0, 0 },
/* U+0652 */ { 4, 34, 14, 0, 0 },
/* U+0653 */ { 4, 230, 14, 0, 0 },
/* U+0654 */ { 4, 230, 14, 0, 0 },
/* U+0655 */ { 4, 220, 14, 0, 0 },
/* U+0656 */ { 0, 0, 0, 0, 0 },
/* U+0657 */ { 0, 0, 0, 0, 0 },
/* U+0658 */ { 0, 0, 0, 0, 0 },
/* U+0659 */ { 0, 0, 0, 0, 0 },
/* U+065a */ { 0, 0, 0, 0, 0 },
/* U+065b */ { 0, 0, 0, 0, 0 },
/* U+065c */ { 0, 0, 0, 0, 0 },
/* U+065d */ { 0, 0, 0, 0, 0 },
/* U+065e */ { 0, 0, 0, 0, 0 },
/* U+065f */ { 0, 0, 0, 0, 0 },
/* U+0660 */ { 7, 0, 12, 0, 0 },
/* U+0661 */ { 7, 0, 12, 0, 0 },
/* U+0662 */ { 7, 0, 12, 0, 0 },
/* U+0663 */ { 7, 0, 12, 0, 0 },
/* U+0664 */ { 7, 0, 12, 0, 0 },
/* U+0665 */ { 7, 0, 12, 0, 0 },
/* U+0666 */ { 7, 0, 12, 0, 0 },
/* U+0667 */ { 7, 0, 12, 0, 0 },
/* U+0668 */ { 7, 0, 12, 0, 0 },
/* U+0669 */ { 7, 0, 12, 0, 0 },
/* U+066a */ { 26, 0, 11, 0, 0 },
/* U+066b */ { 26, 0, 12, 0, 0 },
/* U+066c */ { 26, 0, 12, 0, 0 },
/* U+066d */ { 26, 0, 5, 0, 0 },
/* U+066e */ { 0, 0, 0, 0, 0 },
/* U+066f */ { 0, 0, 0, 0, 0 },
/* U+0670 */ { 4, 35, 14, 0, 0 },
/* U+0671 */ { 19, 0, 5, 0, 0 },
/* U+0672 */ { 19, 0, 5, 0, 0 },
/* U+0673 */ { 19, 0, 5, 0, 0 },
/* U+0674 */ { 19, 0, 5, 0, 0 },
/* U+0675 */ { 19, 0, 5, 0, "<compat> 0627 0674" },
/* U+0676 */ { 19, 0, 5, 0, "<compat> 0648 0674" },
/* U+0677 */ { 19, 0, 5, 0, "<compat> 06C7 0674" },
/* U+0678 */ { 19, 0, 5, 0, "<compat> 064A 0674" },
/* U+0679 */ { 19, 0, 5, 0, 0 },
/* U+067a */ { 19, 0, 5, 0, 0 },
/* U+067b */ { 19, 0, 5, 0, 0 },
/* U+067c */ { 19, 0, 5, 0, 0 },
/* U+067d */ { 19, 0, 5, 0, 0 },
/* U+067e */ { 19, 0, 5, 0, 0 },
/* U+067f */ { 19, 0, 5, 0, 0 },
/* U+0680 */ { 19, 0, 5, 0, 0 },
/* U+0681 */ { 19, 0, 5, 0, 0 },
/* U+0682 */ { 19, 0, 5, 0, 0 },
/* U+0683 */ { 19, 0, 5, 0, 0 },
/* U+0684 */ { 19, 0, 5, 0, 0 },
/* U+0685 */ { 19, 0, 5, 0, 0 },
/* U+0686 */ { 19, 0, 5, 0, 0 },
/* U+0687 */ { 19, 0, 5, 0, 0 },
/* U+0688 */ { 19, 0, 5, 0, 0 },
/* U+0689 */ { 19, 0, 5, 0, 0 },
/* U+068a */ { 19, 0, 5, 0, 0 },
/* U+068b */ { 19, 0, 5, 0, 0 },
/* U+068c */ { 19, 0, 5, 0, 0 },
/* U+068d */ { 19, 0, 5, 0, 0 },
/* U+068e */ { 19, 0, 5, 0, 0 },
/* U+068f */ { 19, 0, 5, 0, 0 },
/* U+0690 */ { 19, 0, 5, 0, 0 },
/* U+0691 */ { 19, 0, 5, 0, 0 },
/* U+0692 */ { 19, 0, 5, 0, 0 },
/* U+0693 */ { 19, 0, 5, 0, 0 },
/* U+0694 */ { 19, 0, 5, 0, 0 },
/* U+0695 */ { 19, 0, 5, 0, 0 },
/* U+0696 */ { 19, 0, 5, 0, 0 },
/* U+0697 */ { 19, 0, 5, 0, 0 },
/* U+0698 */ { 19, 0, 5, 0, 0 },
/* U+0699 */ { 19, 0, 5, 0, 0 },
/* U+069a */ { 19, 0, 5, 0, 0 },
/* U+069b */ { 19, 0, 5, 0, 0 },
/* U+069c */ { 19, 0, 5, 0, 0 },
/* U+069d */ { 19, 0, 5, 0, 0 },
/* U+069e */ { 19, 0, 5, 0, 0 },
/* U+069f */ { 19, 0, 5, 0, 0 },
/* U+06a0 */ { 19, 0, 5, 0, 0 },
/* U+06a1 */ { 19, 0, 5, 0, 0 },
/* U+06a2 */ { 19, 0, 5, 0, 0 },
/* U+06a3 */ { 19, 0, 5, 0, 0 },
/* U+06a4 */ { 19, 0, 5, 0, 0 },
/* U+06a5 */ { 19, 0, 5, 0, 0 },
/* U+06a6 */ { 19, 0, 5, 0, 0 },
/* U+06a7 */ { 19, 0, 5, 0, 0 },
/* U+06a8 */ { 19, 0, 5, 0, 0 },
/* U+06a9 */ { 19, 0, 5, 0, 0 },
/* U+06aa */ { 19, 0, 5, 0, 0 },
/* U+06ab */ { 19, 0, 5, 0, 0 },
/* U+06ac */ { 19, 0, 5, 0, 0 },
/* U+06ad */ { 19, 0, 5, 0, 0 },
/* U+06ae */ { 19, 0, 5, 0, 0 },
/* U+06af */ { 19, 0, 5, 0, 0 },
/* U+06b0 */ { 19, 0, 5, 0, 0 },
/* U+06b1 */ { 19, 0, 5, 0, 0 },
/* U+06b2 */ { 19, 0, 5, 0, 0 },
/* U+06b3 */ { 19, 0, 5, 0, 0 },
/* U+06b4 */ { 19, 0, 5, 0, 0 },
/* U+06b5 */ { 19, 0, 5, 0, 0 },
/* U+06b6 */ { 19, 0, 5, 0, 0 },
/* U+06b7 */ { 19, 0, 5, 0, 0 },
/* U+06b8 */ { 19, 0, 5, 0, 0 },
/* U+06b9 */ { 19, 0, 5, 0, 0 },
/* U+06ba */ { 19, 0, 5, 0, 0 },
/* U+06bb */ { 19, 0, 5, 0, 0 },
/* U+06bc */ { 19, 0, 5, 0, 0 },
/* U+06bd */ { 19, 0, 5, 0, 0 },
/* U+06be */ { 19, 0, 5, 0, 0 },
/* U+06bf */ { 19, 0, 5, 0, 0 },
/* U+06c0 */ { 19, 0, 5, 0, "06D5 0654" },
/* U+06c1 */ { 19, 0, 5, 0, 0 },
/* U+06c2 */ { 19, 0, 5, 0, "06C1 0654" },
/* U+06c3 */ { 19, 0, 5, 0, 0 },
/* U+06c4 */ { 19, 0, 5, 0, 0 },
/* U+06c5 */ { 19, 0, 5, 0, 0 },
/* U+06c6 */ { 19, 0, 5, 0, 0 },
/* U+06c7 */ { 19, 0, 5, 0, 0 },
/* U+06c8 */ { 19, 0, 5, 0, 0 },
/* U+06c9 */ { 19, 0, 5, 0, 0 },
/* U+06ca */ { 19, 0, 5, 0, 0 },
/* U+06cb */ { 19, 0, 5, 0, 0 },
/* U+06cc */ { 19, 0, 5, 0, 0 },
/* U+06cd */ { 19, 0, 5, 0, 0 },
/* U+06ce */ { 19, 0, 5, 0, 0 },
/* U+06cf */ { 19, 0, 5, 0, 0 },
/* U+06d0 */ { 19, 0, 5, 0, 0 },
/* U+06d1 */ { 19, 0, 5, 0, 0 },
/* U+06d2 */ { 19, 0, 5, 0, 0 },
/* U+06d3 */ { 19, 0, 5, 0, "06D2 0654" },
/* U+06d4 */ { 26, 0, 5, 0, 0 },
/* U+06d5 */ { 19, 0, 5, 0, 0 },
/* U+06d6 */ { 4, 230, 14, 0, 0 },
/* U+06d7 */ { 4, 230, 14, 0, 0 },
/* U+06d8 */ { 4, 230, 14, 0, 0 },
/* U+06d9 */ { 4, 230, 14, 0, 0 },
/* U+06da */ { 4, 230, 14, 0, 0 },
/* U+06db */ { 4, 230, 14, 0, 0 },
/* U+06dc */ { 4, 230, 14, 0, 0 },
/* U+06dd */ { 6, 0, 14, 0, 0 },
/* U+06de */ { 6, 0, 14, 0, 0 },
/* U+06df */ { 4, 230, 14, 0, 0 },
/* U+06e0 */ { 4, 230, 14, 0, 0 },
/* U+06e1 */ { 4, 230, 14, 0, 0 },
/* U+06e2 */ { 4, 230, 14, 0, 0 },
/* U+06e3 */ { 4, 220, 14, 0, 0 },
/* U+06e4 */ { 4, 230, 14, 0, 0 },
/* U+06e5 */ { 18, 0, 5, 0, 0 },
/* U+06e6 */ { 18, 0, 5, 0, 0 },
/* U+06e7 */ { 4, 230, 14, 0, 0 },
/* U+06e8 */ { 4, 230, 14, 0, 0 },
/* U+06e9 */ { 30, 0, 19, 0, 0 },
/* U+06ea */ { 4, 220, 14, 0, 0 },
/* U+06eb */ { 4, 230, 14, 0, 0 },
/* U+06ec */ { 4, 230, 14, 0, 0 },
/* U+06ed */ { 4, 220, 14, 0, 0 },
/* U+06ee */ { 0, 0, 0, 0, 0 },
/* U+06ef */ { 0, 0, 0, 0, 0 },
/* U+06f0 */ { 7, 0, 9, 0, 0 },
/* U+06f1 */ { 7, 0, 9, 0, 0 },
/* U+06f2 */ { 7, 0, 9, 0, 0 },
/* U+06f3 */ { 7, 0, 9, 0, 0 },
/* U+06f4 */ { 7, 0, 9, 0, 0 },
/* U+06f5 */ { 7, 0, 9, 0, 0 },
/* U+06f6 */ { 7, 0, 9, 0, 0 },
/* U+06f7 */ { 7, 0, 9, 0, 0 },
/* U+06f8 */ { 7, 0, 9, 0, 0 },
/* U+06f9 */ { 7, 0, 9, 0, 0 },
/* U+06fa */ { 19, 0, 5, 0, 0 },
/* U+06fb */ { 19, 0, 5, 0, 0 },
/* U+06fc */ { 19, 0, 5, 0, 0 },
/* U+06fd */ { 30, 0, 5, 0, 0 },
/* U+06fe */ { 30, 0, 5, 0, 0 },
/* U+06ff */ { 0, 0, 0, 0, 0 },
/* U+0700 */ { 26, 0, 5, 0, 0 },
/* U+0701 */ { 26, 0, 5, 0, 0 },
/* U+0702 */ { 26, 0, 5, 0, 0 },
/* U+0703 */ { 26, 0, 5, 0, 0 },
/* U+0704 */ { 26, 0, 5, 0, 0 },
/* U+0705 */ { 26, 0, 5, 0, 0 },
/* U+0706 */ { 26, 0, 5, 0, 0 },
/* U+0707 */ { 26, 0, 5, 0, 0 },
/* U+0708 */ { 26, 0, 5, 0, 0 },
/* U+0709 */ { 26, 0, 5, 0, 0 },
/* U+070a */ { 26, 0, 5, 0, 0 },
/* U+070b */ { 26, 0, 5, 0, 0 },
/* U+070c */ { 26, 0, 5, 0, 0 },
/* U+070d */ { 26, 0, 5, 0, 0 },
/* U+070e */ { 0, 0, 0, 0, 0 },
/* U+070f */ { 14, 0, 15, 0, 0 },
/* U+0710 */ { 19, 0, 5, 0, 0 },
/* U+0711 */ { 4, 36, 14, 0, 0 },
/* U+0712 */ { 19, 0, 5, 0, 0 },
/* U+0713 */ { 19, 0, 5, 0, 0 },
/* U+0714 */ { 19, 0, 5, 0, 0 },
/* U+0715 */ { 19, 0, 5, 0, 0 },
/* U+0716 */ { 19, 0, 5, 0, 0 },
/* U+0717 */ { 19, 0, 5, 0, 0 },
/* U+0718 */ { 19, 0, 5, 0, 0 },
/* U+0719 */ { 19, 0, 5, 0, 0 },
/* U+071a */ { 19, 0, 5, 0, 0 },
/* U+071b */ { 19, 0, 5, 0, 0 },
/* U+071c */ { 19, 0, 5, 0, 0 },
/* U+071d */ { 19, 0, 5, 0, 0 },
/* U+071e */ { 19, 0, 5, 0, 0 },
/* U+071f */ { 19, 0, 5, 0, 0 },
/* U+0720 */ { 19, 0, 5, 0, 0 },
/* U+0721 */ { 19, 0, 5, 0, 0 },
/* U+0722 */ { 19, 0, 5, 0, 0 },
/* U+0723 */ { 19, 0, 5, 0, 0 },
/* U+0724 */ { 19, 0, 5, 0, 0 },
/* U+0725 */ { 19, 0, 5, 0, 0 },
/* U+0726 */ { 19, 0, 5, 0, 0 },
/* U+0727 */ { 19, 0, 5, 0, 0 },
/* U+0728 */ { 19, 0, 5, 0, 0 },
/* U+0729 */ { 19, 0, 5, 0, 0 },
/* U+072a */ { 19, 0, 5, 0, 0 },
/* U+072b */ { 19, 0, 5, 0, 0 },
/* U+072c */ { 19, 0, 5, 0, 0 },
/* U+072d */ { 0, 0, 0, 0, 0 },
/* U+072e */ { 0, 0, 0, 0, 0 },
/* U+072f */ { 0, 0, 0, 0, 0 },
/* U+0730 */ { 4, 230, 14, 0, 0 },
/* U+0731 */ { 4, 220, 14, 0, 0 },
/* U+0732 */ { 4, 230, 14, 0, 0 },
/* U+0733 */ { 4, 230, 14, 0, 0 },
/* U+0734 */ { 4, 220, 14, 0, 0 },
/* U+0735 */ { 4, 230, 14, 0, 0 },
/* U+0736 */ { 4, 230, 14, 0, 0 },
/* U+0737 */ { 4, 220, 14, 0, 0 },
/* U+0738 */ { 4, 220, 14, 0, 0 },
/* U+0739 */ { 4, 220, 14, 0, 0 },
/* U+073a */ { 4, 230, 14, 0, 0 },
/* U+073b */ { 4, 220, 14, 0, 0 },
/* U+073c */ { 4, 220, 14, 0, 0 },
/* U+073d */ { 4, 230, 14, 0, 0 },
/* U+073e */ { 4, 220, 14, 0, 0 },
/* U+073f */ { 4, 230, 14, 0, 0 },
/* U+0740 */ { 4, 230, 14, 0, 0 },
/* U+0741 */ { 4, 230, 14, 0, 0 },
/* U+0742 */ { 4, 220, 14, 0, 0 },
/* U+0743 */ { 4, 230, 14, 0, 0 },
/* U+0744 */ { 4, 220, 14, 0, 0 },
/* U+0745 */ { 4, 230, 14, 0, 0 },
/* U+0746 */ { 4, 220, 14, 0, 0 },
/* U+0747 */ { 4, 230, 14, 0, 0 },
/* U+0748 */ { 4, 220, 14, 0, 0 },
/* U+0749 */ { 4, 230, 14, 0, 0 },
/* U+074a */ { 4, 230, 14, 0, 0 },
/* U+074b */ { 0, 0, 0, 0, 0 },
/* U+074c */ { 0, 0, 0, 0, 0 },
/* U+074d */ { 0, 0, 0, 0, 0 },
/* U+074e */ { 0, 0, 0, 0, 0 },
/* U+074f */ { 0, 0, 0, 0, 0 },
/* U+0750 */ { 0, 0, 0, 0, 0 },
/* U+0751 */ { 0, 0, 0, 0, 0 },
/* U+0752 */ { 0, 0, 0, 0, 0 },
/* U+0753 */ { 0, 0, 0, 0, 0 },
/* U+0754 */ { 0, 0, 0, 0, 0 },
/* U+0755 */ { 0, 0, 0, 0, 0 },
/* U+0756 */ { 0, 0, 0, 0, 0 },
/* U+0757 */ { 0, 0, 0, 0, 0 },
/* U+0758 */ { 0, 0, 0, 0, 0 },
/* U+0759 */ { 0, 0, 0, 0, 0 },
/* U+075a */ { 0, 0, 0, 0, 0 },
/* U+075b */ { 0, 0, 0, 0, 0 },
/* U+075c */ { 0, 0, 0, 0, 0 },
/* U+075d */ { 0, 0, 0, 0, 0 },
/* U+075e */ { 0, 0, 0, 0, 0 },
/* U+075f */ { 0, 0, 0, 0, 0 },
/* U+0760 */ { 0, 0, 0, 0, 0 },
/* U+0761 */ { 0, 0, 0, 0, 0 },
/* U+0762 */ { 0, 0, 0, 0, 0 },
/* U+0763 */ { 0, 0, 0, 0, 0 },
/* U+0764 */ { 0, 0, 0, 0, 0 },
/* U+0765 */ { 0, 0, 0, 0, 0 },
/* U+0766 */ { 0, 0, 0, 0, 0 },
/* U+0767 */ { 0, 0, 0, 0, 0 },
/* U+0768 */ { 0, 0, 0, 0, 0 },
/* U+0769 */ { 0, 0, 0, 0, 0 },
/* U+076a */ { 0, 0, 0, 0, 0 },
/* U+076b */ { 0, 0, 0, 0, 0 },
/* U+076c */ { 0, 0, 0, 0, 0 },
/* U+076d */ { 0, 0, 0, 0, 0 },
/* U+076e */ { 0, 0, 0, 0, 0 },
/* U+076f */ { 0, 0, 0, 0, 0 },
/* U+0770 */ { 0, 0, 0, 0, 0 },
/* U+0771 */ { 0, 0, 0, 0, 0 },
/* U+0772 */ { 0, 0, 0, 0, 0 },
/* U+0773 */ { 0, 0, 0, 0, 0 },
/* U+0774 */ { 0, 0, 0, 0, 0 },
/* U+0775 */ { 0, 0, 0, 0, 0 },
/* U+0776 */ { 0, 0, 0, 0, 0 },
/* U+0777 */ { 0, 0, 0, 0, 0 },
/* U+0778 */ { 0, 0, 0, 0, 0 },
/* U+0779 */ { 0, 0, 0, 0, 0 },
/* U+077a */ { 0, 0, 0, 0, 0 },
/* U+077b */ { 0, 0, 0, 0, 0 },
/* U+077c */ { 0, 0, 0, 0, 0 },
/* U+077d */ { 0, 0, 0, 0, 0 },
/* U+077e */ { 0, 0, 0, 0, 0 },
/* U+077f */ { 0, 0, 0, 0, 0 },
/* U+0780 */ { 19, 0, 5, 0, 0 },
/* U+0781 */ { 19, 0, 5, 0, 0 },
/* U+0782 */ { 19, 0, 5, 0, 0 },
/* U+0783 */ { 19, 0, 5, 0, 0 },
/* U+0784 */ { 19, 0, 5, 0, 0 },
/* U+0785 */ { 19, 0, 5, 0, 0 },
/* U+0786 */ { 19, 0, 5, 0, 0 },
/* U+0787 */ { 19, 0, 5, 0, 0 },
/* U+0788 */ { 19, 0, 5, 0, 0 },
/* U+0789 */ { 19, 0, 5, 0, 0 },
/* U+078a */ { 19, 0, 5, 0, 0 },
/* U+078b */ { 19, 0, 5, 0, 0 },
/* U+078c */ { 19, 0, 5, 0, 0 },
/* U+078d */ { 19, 0, 5, 0, 0 },
/* U+078e */ { 19, 0, 5, 0, 0 },
/* U+078f */ { 19, 0, 5, 0, 0 },
/* U+0790 */ { 19, 0, 5, 0, 0 },
/* U+0791 */ { 19, 0, 5, 0, 0 },
/* U+0792 */ { 19, 0, 5, 0, 0 },
/* U+0793 */ { 19, 0, 5, 0, 0 },
/* U+0794 */ { 19, 0, 5, 0, 0 },
/* U+0795 */ { 19, 0, 5, 0, 0 },
/* U+0796 */ { 19, 0, 5, 0, 0 },
/* U+0797 */ { 19, 0, 5, 0, 0 },
/* U+0798 */ { 19, 0, 5, 0, 0 },
/* U+0799 */ { 19, 0, 5, 0, 0 },
/* U+079a */ { 19, 0, 5, 0, 0 },
/* U+079b */ { 19, 0, 5, 0, 0 },
/* U+079c */ { 19, 0, 5, 0, 0 },
/* U+079d */ { 19, 0, 5, 0, 0 },
/* U+079e */ { 19, 0, 5, 0, 0 },
/* U+079f */ { 19, 0, 5, 0, 0 },
/* U+07a0 */ { 19, 0, 5, 0, 0 },
/* U+07a1 */ { 19, 0, 5, 0, 0 },
/* U+07a2 */ { 19, 0, 5, 0, 0 },
/* U+07a3 */ { 19, 0, 5, 0, 0 },
/* U+07a4 */ { 19, 0, 5, 0, 0 },
/* U+07a5 */ { 19, 0, 5, 0, 0 },
/* U+07a6 */ { 4, 0, 14, 0, 0 },
/* U+07a7 */ { 4, 0, 14, 0, 0 },
/* U+07a8 */ { 4, 0, 14, 0, 0 },
/* U+07a9 */ { 4, 0, 14, 0, 0 },
/* U+07aa */ { 4, 0, 14, 0, 0 },
/* U+07ab */ { 4, 0, 14, 0, 0 },
/* U+07ac */ { 4, 0, 14, 0, 0 },
/* U+07ad */ { 4, 0, 14, 0, 0 },
/* U+07ae */ { 4, 0, 14, 0, 0 },
/* U+07af */ { 4, 0, 14, 0, 0 },
/* U+07b0 */ { 4, 0, 14, 0, 0 },
/* U+07b1 */ { 0, 0, 0, 0, 0 },
/* U+07b2 */ { 0, 0, 0, 0, 0 },
/* U+07b3 */ { 0, 0, 0, 0, 0 },
/* U+07b4 */ { 0, 0, 0, 0, 0 },
/* U+07b5 */ { 0, 0, 0, 0, 0 },
/* U+07b6 */ { 0, 0, 0, 0, 0 },
/* U+07b7 */ { 0, 0, 0, 0, 0 },
/* U+07b8 */ { 0, 0, 0, 0, 0 },
/* U+07b9 */ { 0, 0, 0, 0, 0 },
/* U+07ba */ { 0, 0, 0, 0, 0 },
/* U+07bb */ { 0, 0, 0, 0, 0 },
/* U+07bc */ { 0, 0, 0, 0, 0 },
/* U+07bd */ { 0, 0, 0, 0, 0 },
/* U+07be */ { 0, 0, 0, 0, 0 },
/* U+07bf */ { 0, 0, 0, 0, 0 },
/* U+07c0 */ { 0, 0, 0, 0, 0 },
/* U+07c1 */ { 0, 0, 0, 0, 0 },
/* U+07c2 */ { 0, 0, 0, 0, 0 },
/* U+07c3 */ { 0, 0, 0, 0, 0 },
/* U+07c4 */ { 0, 0, 0, 0, 0 },
/* U+07c5 */ { 0, 0, 0, 0, 0 },
/* U+07c6 */ { 0, 0, 0, 0, 0 },
/* U+07c7 */ { 0, 0, 0, 0, 0 },
/* U+07c8 */ { 0, 0, 0, 0, 0 },
/* U+07c9 */ { 0, 0, 0, 0, 0 },
/* U+07ca */ { 0, 0, 0, 0, 0 },
/* U+07cb */ { 0, 0, 0, 0, 0 },
/* U+07cc */ { 0, 0, 0, 0, 0 },
/* U+07cd */ { 0, 0, 0, 0, 0 },
/* U+07ce */ { 0, 0, 0, 0, 0 },
/* U+07cf */ { 0, 0, 0, 0, 0 },
/* U+07d0 */ { 0, 0, 0, 0, 0 },
/* U+07d1 */ { 0, 0, 0, 0, 0 },
/* U+07d2 */ { 0, 0, 0, 0, 0 },
/* U+07d3 */ { 0, 0, 0, 0, 0 },
/* U+07d4 */ { 0, 0, 0, 0, 0 },
/* U+07d5 */ { 0, 0, 0, 0, 0 },
/* U+07d6 */ { 0, 0, 0, 0, 0 },
/* U+07d7 */ { 0, 0, 0, 0, 0 },
/* U+07d8 */ { 0, 0, 0, 0, 0 },
/* U+07d9 */ { 0, 0, 0, 0, 0 },
/* U+07da */ { 0, 0, 0, 0, 0 },
/* U+07db */ { 0, 0, 0, 0, 0 },
/* U+07dc */ { 0, 0, 0, 0, 0 },
/* U+07dd */ { 0, 0, 0, 0, 0 },
/* U+07de */ { 0, 0, 0, 0, 0 },
/* U+07df */ { 0, 0, 0, 0, 0 },
/* U+07e0 */ { 0, 0, 0, 0, 0 },
/* U+07e1 */ { 0, 0, 0, 0, 0 },
/* U+07e2 */ { 0, 0, 0, 0, 0 },
/* U+07e3 */ { 0, 0, 0, 0, 0 },
/* U+07e4 */ { 0, 0, 0, 0, 0 },
/* U+07e5 */ { 0, 0, 0, 0, 0 },
/* U+07e6 */ { 0, 0, 0, 0, 0 },
/* U+07e7 */ { 0, 0, 0, 0, 0 },
/* U+07e8 */ { 0, 0, 0, 0, 0 },
/* U+07e9 */ { 0, 0, 0, 0, 0 },
/* U+07ea */ { 0, 0, 0, 0, 0 },
/* U+07eb */ { 0, 0, 0, 0, 0 },
/* U+07ec */ { 0, 0, 0, 0, 0 },
/* U+07ed */ { 0, 0, 0, 0, 0 },
/* U+07ee */ { 0, 0, 0, 0, 0 },
/* U+07ef */ { 0, 0, 0, 0, 0 },
/* U+07f0 */ { 0, 0, 0, 0, 0 },
/* U+07f1 */ { 0, 0, 0, 0, 0 },
/* U+07f2 */ { 0, 0, 0, 0, 0 },
/* U+07f3 */ { 0, 0, 0, 0, 0 },
/* U+07f4 */ { 0, 0, 0, 0, 0 },
/* U+07f5 */ { 0, 0, 0, 0, 0 },
/* U+07f6 */ { 0, 0, 0, 0, 0 },
/* U+07f7 */ { 0, 0, 0, 0, 0 },
/* U+07f8 */ { 0, 0, 0, 0, 0 },
/* U+07f9 */ { 0, 0, 0, 0, 0 },
/* U+07fa */ { 0, 0, 0, 0, 0 },
/* U+07fb */ { 0, 0, 0, 0, 0 },
/* U+07fc */ { 0, 0, 0, 0, 0 },
/* U+07fd */ { 0, 0, 0, 0, 0 },
/* U+07fe */ { 0, 0, 0, 0, 0 },
/* U+07ff */ { 0, 0, 0, 0, 0 },
/* U+0800 */ { 0, 0, 0, 0, 0 },
/* U+0801 */ { 0, 0, 0, 0, 0 },
/* U+0802 */ { 0, 0, 0, 0, 0 },
/* U+0803 */ { 0, 0, 0, 0, 0 },
/* U+0804 */ { 0, 0, 0, 0, 0 },
/* U+0805 */ { 0, 0, 0, 0, 0 },
/* U+0806 */ { 0, 0, 0, 0, 0 },
/* U+0807 */ { 0, 0, 0, 0, 0 },
/* U+0808 */ { 0, 0, 0, 0, 0 },
/* U+0809 */ { 0, 0, 0, 0, 0 },
/* U+080a */ { 0, 0, 0, 0, 0 },
/* U+080b */ { 0, 0, 0, 0, 0 },
/* U+080c */ { 0, 0, 0, 0, 0 },
/* U+080d */ { 0, 0, 0, 0, 0 },
/* U+080e */ { 0, 0, 0, 0, 0 },
/* U+080f */ { 0, 0, 0, 0, 0 },
/* U+0810 */ { 0, 0, 0, 0, 0 },
/* U+0811 */ { 0, 0, 0, 0, 0 },
/* U+0812 */ { 0, 0, 0, 0, 0 },
/* U+0813 */ { 0, 0, 0, 0, 0 },
/* U+0814 */ { 0, 0, 0, 0, 0 },
/* U+0815 */ { 0, 0, 0, 0, 0 },
/* U+0816 */ { 0, 0, 0, 0, 0 },
/* U+0817 */ { 0, 0, 0, 0, 0 },
/* U+0818 */ { 0, 0, 0, 0, 0 },
/* U+0819 */ { 0, 0, 0, 0, 0 },
/* U+081a */ { 0, 0, 0, 0, 0 },
/* U+081b */ { 0, 0, 0, 0, 0 },
/* U+081c */ { 0, 0, 0, 0, 0 },
/* U+081d */ { 0, 0, 0, 0, 0 },
/* U+081e */ { 0, 0, 0, 0, 0 },
/* U+081f */ { 0, 0, 0, 0, 0 },
/* U+0820 */ { 0, 0, 0, 0, 0 },
/* U+0821 */ { 0, 0, 0, 0, 0 },
/* U+0822 */ { 0, 0, 0, 0, 0 },
/* U+0823 */ { 0, 0, 0, 0, 0 },
/* U+0824 */ { 0, 0, 0, 0, 0 },
/* U+0825 */ { 0, 0, 0, 0, 0 },
/* U+0826 */ { 0, 0, 0, 0, 0 },
/* U+0827 */ { 0, 0, 0, 0, 0 },
/* U+0828 */ { 0, 0, 0, 0, 0 },
/* U+0829 */ { 0, 0, 0, 0, 0 },
/* U+082a */ { 0, 0, 0, 0, 0 },
/* U+082b */ { 0, 0, 0, 0, 0 },
/* U+082c */ { 0, 0, 0, 0, 0 },
/* U+082d */ { 0, 0, 0, 0, 0 },
/* U+082e */ { 0, 0, 0, 0, 0 },
/* U+082f */ { 0, 0, 0, 0, 0 },
/* U+0830 */ { 0, 0, 0, 0, 0 },
/* U+0831 */ { 0, 0, 0, 0, 0 },
/* U+0832 */ { 0, 0, 0, 0, 0 },
/* U+0833 */ { 0, 0, 0, 0, 0 },
/* U+0834 */ { 0, 0, 0, 0, 0 },
/* U+0835 */ { 0, 0, 0, 0, 0 },
/* U+0836 */ { 0, 0, 0, 0, 0 },
/* U+0837 */ { 0, 0, 0, 0, 0 },
/* U+0838 */ { 0, 0, 0, 0, 0 },
/* U+0839 */ { 0, 0, 0, 0, 0 },
/* U+083a */ { 0, 0, 0, 0, 0 },
/* U+083b */ { 0, 0, 0, 0, 0 },
/* U+083c */ { 0, 0, 0, 0, 0 },
/* U+083d */ { 0, 0, 0, 0, 0 },
/* U+083e */ { 0, 0, 0, 0, 0 },
/* U+083f */ { 0, 0, 0, 0, 0 },
/* U+0840 */ { 0, 0, 0, 0, 0 },
/* U+0841 */ { 0, 0, 0, 0, 0 },
/* U+0842 */ { 0, 0, 0, 0, 0 },
/* U+0843 */ { 0, 0, 0, 0, 0 },
/* U+0844 */ { 0, 0, 0, 0, 0 },
/* U+0845 */ { 0, 0, 0, 0, 0 },
/* U+0846 */ { 0, 0, 0, 0, 0 },
/* U+0847 */ { 0, 0, 0, 0, 0 },
/* U+0848 */ { 0, 0, 0, 0, 0 },
/* U+0849 */ { 0, 0, 0, 0, 0 },
/* U+084a */ { 0, 0, 0, 0, 0 },
/* U+084b */ { 0, 0, 0, 0, 0 },
/* U+084c */ { 0, 0, 0, 0, 0 },
/* U+084d */ { 0, 0, 0, 0, 0 },
/* U+084e */ { 0, 0, 0, 0, 0 },
/* U+084f */ { 0, 0, 0, 0, 0 },
/* U+0850 */ { 0, 0, 0, 0, 0 },
/* U+0851 */ { 0, 0, 0, 0, 0 },
/* U+0852 */ { 0, 0, 0, 0, 0 },
/* U+0853 */ { 0, 0, 0, 0, 0 },
/* U+0854 */ { 0, 0, 0, 0, 0 },
/* U+0855 */ { 0, 0, 0, 0, 0 },
/* U+0856 */ { 0, 0, 0, 0, 0 },
/* U+0857 */ { 0, 0, 0, 0, 0 },
/* U+0858 */ { 0, 0, 0, 0, 0 },
/* U+0859 */ { 0, 0, 0, 0, 0 },
/* U+085a */ { 0, 0, 0, 0, 0 },
/* U+085b */ { 0, 0, 0, 0, 0 },
/* U+085c */ { 0, 0, 0, 0, 0 },
/* U+085d */ { 0, 0, 0, 0, 0 },
/* U+085e */ { 0, 0, 0, 0, 0 },
/* U+085f */ { 0, 0, 0, 0, 0 },
/* U+0860 */ { 0, 0, 0, 0, 0 },
/* U+0861 */ { 0, 0, 0, 0, 0 },
/* U+0862 */ { 0, 0, 0, 0, 0 },
/* U+0863 */ { 0, 0, 0, 0, 0 },
/* U+0864 */ { 0, 0, 0, 0, 0 },
/* U+0865 */ { 0, 0, 0, 0, 0 },
/* U+0866 */ { 0, 0, 0, 0, 0 },
/* U+0867 */ { 0, 0, 0, 0, 0 },
/* U+0868 */ { 0, 0, 0, 0, 0 },
/* U+0869 */ { 0, 0, 0, 0, 0 },
/* U+086a */ { 0, 0, 0, 0, 0 },
/* U+086b */ { 0, 0, 0, 0, 0 },
/* U+086c */ { 0, 0, 0, 0, 0 },
/* U+086d */ { 0, 0, 0, 0, 0 },
/* U+086e */ { 0, 0, 0, 0, 0 },
/* U+086f */ { 0, 0, 0, 0, 0 },
/* U+0870 */ { 0, 0, 0, 0, 0 },
/* U+0871 */ { 0, 0, 0, 0, 0 },
/* U+0872 */ { 0, 0, 0, 0, 0 },
/* U+0873 */ { 0, 0, 0, 0, 0 },
/* U+0874 */ { 0, 0, 0, 0, 0 },
/* U+0875 */ { 0, 0, 0, 0, 0 },
/* U+0876 */ { 0, 0, 0, 0, 0 },
/* U+0877 */ { 0, 0, 0, 0, 0 },
/* U+0878 */ { 0, 0, 0, 0, 0 },
/* U+0879 */ { 0, 0, 0, 0, 0 },
/* U+087a */ { 0, 0, 0, 0, 0 },
/* U+087b */ { 0, 0, 0, 0, 0 },
/* U+087c */ { 0, 0, 0, 0, 0 },
/* U+087d */ { 0, 0, 0, 0, 0 },
/* U+087e */ { 0, 0, 0, 0, 0 },
/* U+087f */ { 0, 0, 0, 0, 0 },
/* U+0880 */ { 0, 0, 0, 0, 0 },
/* U+0881 */ { 0, 0, 0, 0, 0 },
/* U+0882 */ { 0, 0, 0, 0, 0 },
/* U+0883 */ { 0, 0, 0, 0, 0 },
/* U+0884 */ { 0, 0, 0, 0, 0 },
/* U+0885 */ { 0, 0, 0, 0, 0 },
/* U+0886 */ { 0, 0, 0, 0, 0 },
/* U+0887 */ { 0, 0, 0, 0, 0 },
/* U+0888 */ { 0, 0, 0, 0, 0 },
/* U+0889 */ { 0, 0, 0, 0, 0 },
/* U+088a */ { 0, 0, 0, 0, 0 },
/* U+088b */ { 0, 0, 0, 0, 0 },
/* U+088c */ { 0, 0, 0, 0, 0 },
/* U+088d */ { 0, 0, 0, 0, 0 },
/* U+088e */ { 0, 0, 0, 0, 0 },
/* U+088f */ { 0, 0, 0, 0, 0 },
/* U+0890 */ { 0, 0, 0, 0, 0 },
/* U+0891 */ { 0, 0, 0, 0, 0 },
/* U+0892 */ { 0, 0, 0, 0, 0 },
/* U+0893 */ { 0, 0, 0, 0, 0 },
/* U+0894 */ { 0, 0, 0, 0, 0 },
/* U+0895 */ { 0, 0, 0, 0, 0 },
/* U+0896 */ { 0, 0, 0, 0, 0 },
/* U+0897 */ { 0, 0, 0, 0, 0 },
/* U+0898 */ { 0, 0, 0, 0, 0 },
/* U+0899 */ { 0, 0, 0, 0, 0 },
/* U+089a */ { 0, 0, 0, 0, 0 },
/* U+089b */ { 0, 0, 0, 0, 0 },
/* U+089c */ { 0, 0, 0, 0, 0 },
/* U+089d */ { 0, 0, 0, 0, 0 },
/* U+089e */ { 0, 0, 0, 0, 0 },
/* U+089f */ { 0, 0, 0, 0, 0 },
/* U+08a0 */ { 0, 0, 0, 0, 0 },
/* U+08a1 */ { 0, 0, 0, 0, 0 },
/* U+08a2 */ { 0, 0, 0, 0, 0 },
/* U+08a3 */ { 0, 0, 0, 0, 0 },
/* U+08a4 */ { 0, 0, 0, 0, 0 },
/* U+08a5 */ { 0, 0, 0, 0, 0 },
/* U+08a6 */ { 0, 0, 0, 0, 0 },
/* U+08a7 */ { 0, 0, 0, 0, 0 },
/* U+08a8 */ { 0, 0, 0, 0, 0 },
/* U+08a9 */ { 0, 0, 0, 0, 0 },
/* U+08aa */ { 0, 0, 0, 0, 0 },
/* U+08ab */ { 0, 0, 0, 0, 0 },
/* U+08ac */ { 0, 0, 0, 0, 0 },
/* U+08ad */ { 0, 0, 0, 0, 0 },
/* U+08ae */ { 0, 0, 0, 0, 0 },
/* U+08af */ { 0, 0, 0, 0, 0 },
/* U+08b0 */ { 0, 0, 0, 0, 0 },
/* U+08b1 */ { 0, 0, 0, 0, 0 },
/* U+08b2 */ { 0, 0, 0, 0, 0 },
/* U+08b3 */ { 0, 0, 0, 0, 0 },
/* U+08b4 */ { 0, 0, 0, 0, 0 },
/* U+08b5 */ { 0, 0, 0, 0, 0 },
/* U+08b6 */ { 0, 0, 0, 0, 0 },
/* U+08b7 */ { 0, 0, 0, 0, 0 },
/* U+08b8 */ { 0, 0, 0, 0, 0 },
/* U+08b9 */ { 0, 0, 0, 0, 0 },
/* U+08ba */ { 0, 0, 0, 0, 0 },
/* U+08bb */ { 0, 0, 0, 0, 0 },
/* U+08bc */ { 0, 0, 0, 0, 0 },
/* U+08bd */ { 0, 0, 0, 0, 0 },
/* U+08be */ { 0, 0, 0, 0, 0 },
/* U+08bf */ { 0, 0, 0, 0, 0 },
/* U+08c0 */ { 0, 0, 0, 0, 0 },
/* U+08c1 */ { 0, 0, 0, 0, 0 },
/* U+08c2 */ { 0, 0, 0, 0, 0 },
/* U+08c3 */ { 0, 0, 0, 0, 0 },
/* U+08c4 */ { 0, 0, 0, 0, 0 },
/* U+08c5 */ { 0, 0, 0, 0, 0 },
/* U+08c6 */ { 0, 0, 0, 0, 0 },
/* U+08c7 */ { 0, 0, 0, 0, 0 },
/* U+08c8 */ { 0, 0, 0, 0, 0 },
/* U+08c9 */ { 0, 0, 0, 0, 0 },
/* U+08ca */ { 0, 0, 0, 0, 0 },
/* U+08cb */ { 0, 0, 0, 0, 0 },
/* U+08cc */ { 0, 0, 0, 0, 0 },
/* U+08cd */ { 0, 0, 0, 0, 0 },
/* U+08ce */ { 0, 0, 0, 0, 0 },
/* U+08cf */ { 0, 0, 0, 0, 0 },
/* U+08d0 */ { 0, 0, 0, 0, 0 },
/* U+08d1 */ { 0, 0, 0, 0, 0 },
/* U+08d2 */ { 0, 0, 0, 0, 0 },
/* U+08d3 */ { 0, 0, 0, 0, 0 },
/* U+08d4 */ { 0, 0, 0, 0, 0 },
/* U+08d5 */ { 0, 0, 0, 0, 0 },
/* U+08d6 */ { 0, 0, 0, 0, 0 },
/* U+08d7 */ { 0, 0, 0, 0, 0 },
/* U+08d8 */ { 0, 0, 0, 0, 0 },
/* U+08d9 */ { 0, 0, 0, 0, 0 },
/* U+08da */ { 0, 0, 0, 0, 0 },
/* U+08db */ { 0, 0, 0, 0, 0 },
/* U+08dc */ { 0, 0, 0, 0, 0 },
/* U+08dd */ { 0, 0, 0, 0, 0 },
/* U+08de */ { 0, 0, 0, 0, 0 },
/* U+08df */ { 0, 0, 0, 0, 0 },
/* U+08e0 */ { 0, 0, 0, 0, 0 },
/* U+08e1 */ { 0, 0, 0, 0, 0 },
/* U+08e2 */ { 0, 0, 0, 0, 0 },
/* U+08e3 */ { 0, 0, 0, 0, 0 },
/* U+08e4 */ { 0, 0, 0, 0, 0 },
/* U+08e5 */ { 0, 0, 0, 0, 0 },
/* U+08e6 */ { 0, 0, 0, 0, 0 },
/* U+08e7 */ { 0, 0, 0, 0, 0 },
/* U+08e8 */ { 0, 0, 0, 0, 0 },
/* U+08e9 */ { 0, 0, 0, 0, 0 },
/* U+08ea */ { 0, 0, 0, 0, 0 },
/* U+08eb */ { 0, 0, 0, 0, 0 },
/* U+08ec */ { 0, 0, 0, 0, 0 },
/* U+08ed */ { 0, 0, 0, 0, 0 },
/* U+08ee */ { 0, 0, 0, 0, 0 },
/* U+08ef */ { 0, 0, 0, 0, 0 },
/* U+08f0 */ { 0, 0, 0, 0, 0 },
/* U+08f1 */ { 0, 0, 0, 0, 0 },
/* U+08f2 */ { 0, 0, 0, 0, 0 },
/* U+08f3 */ { 0, 0, 0, 0, 0 },
/* U+08f4 */ { 0, 0, 0, 0, 0 },
/* U+08f5 */ { 0, 0, 0, 0, 0 },
/* U+08f6 */ { 0, 0, 0, 0, 0 },
/* U+08f7 */ { 0, 0, 0, 0, 0 },
/* U+08f8 */ { 0, 0, 0, 0, 0 },
/* U+08f9 */ { 0, 0, 0, 0, 0 },
/* U+08fa */ { 0, 0, 0, 0, 0 },
/* U+08fb */ { 0, 0, 0, 0, 0 },
/* U+08fc */ { 0, 0, 0, 0, 0 },
/* U+08fd */ { 0, 0, 0, 0, 0 },
/* U+08fe */ { 0, 0, 0, 0, 0 },
/* U+08ff */ { 0, 0, 0, 0, 0 },
/* U+0900 */ { 0, 0, 0, 0, 0 },
/* U+0901 */ { 4, 0, 14, 0, 0 },
/* U+0902 */ { 4, 0, 14, 0, 0 },
/* U+0903 */ { 5, 0, 1, 0, 0 },
/* U+0904 */ { 0, 0, 0, 0, 0 },
/* U+0905 */ { 19, 0, 1, 0, 0 },
/* U+0906 */ { 19, 0, 1, 0, 0 },
/* U+0907 */ { 19, 0, 1, 0, 0 },
/* U+0908 */ { 19, 0, 1, 0, 0 },
/* U+0909 */ { 19, 0, 1, 0, 0 },
/* U+090a */ { 19, 0, 1, 0, 0 },
/* U+090b */ { 19, 0, 1, 0, 0 },
/* U+090c */ { 19, 0, 1, 0, 0 },
/* U+090d */ { 19, 0, 1, 0, 0 },
/* U+090e */ { 19, 0, 1, 0, 0 },
/* U+090f */ { 19, 0, 1, 0, 0 },
/* U+0910 */ { 19, 0, 1, 0, 0 },
/* U+0911 */ { 19, 0, 1, 0, 0 },
/* U+0912 */ { 19, 0, 1, 0, 0 },
/* U+0913 */ { 19, 0, 1, 0, 0 },
/* U+0914 */ { 19, 0, 1, 0, 0 },
/* U+0915 */ { 19, 0, 1, 0, 0 },
/* U+0916 */ { 19, 0, 1, 0, 0 },
/* U+0917 */ { 19, 0, 1, 0, 0 },
/* U+0918 */ { 19, 0, 1, 0, 0 },
/* U+0919 */ { 19, 0, 1, 0, 0 },
/* U+091a */ { 19, 0, 1, 0, 0 },
/* U+091b */ { 19, 0, 1, 0, 0 },
/* U+091c */ { 19, 0, 1, 0, 0 },
/* U+091d */ { 19, 0, 1, 0, 0 },
/* U+091e */ { 19, 0, 1, 0, 0 },
/* U+091f */ { 19, 0, 1, 0, 0 },
/* U+0920 */ { 19, 0, 1, 0, 0 },
/* U+0921 */ { 19, 0, 1, 0, 0 },
/* U+0922 */ { 19, 0, 1, 0, 0 },
/* U+0923 */ { 19, 0, 1, 0, 0 },
/* U+0924 */ { 19, 0, 1, 0, 0 },
/* U+0925 */ { 19, 0, 1, 0, 0 },
/* U+0926 */ { 19, 0, 1, 0, 0 },
/* U+0927 */ { 19, 0, 1, 0, 0 },
/* U+0928 */ { 19, 0, 1, 0, 0 },
/* U+0929 */ { 19, 0, 1, 0, "0928 093C" },
/* U+092a */ { 19, 0, 1, 0, 0 },
/* U+092b */ { 19, 0, 1, 0, 0 },
/* U+092c */ { 19, 0, 1, 0, 0 },
/* U+092d */ { 19, 0, 1, 0, 0 },
/* U+092e */ { 19, 0, 1, 0, 0 },
/* U+092f */ { 19, 0, 1, 0, 0 },
/* U+0930 */ { 19, 0, 1, 0, 0 },
/* U+0931 */ { 19, 0, 1, 0, "0930 093C" },
/* U+0932 */ { 19, 0, 1, 0, 0 },
/* U+0933 */ { 19, 0, 1, 0, 0 },
/* U+0934 */ { 19, 0, 1, 0, "0933 093C" },
/* U+0935 */ { 19, 0, 1, 0, 0 },
/* U+0936 */ { 19, 0, 1, 0, 0 },
/* U+0937 */ { 19, 0, 1, 0, 0 },
/* U+0938 */ { 19, 0, 1, 0, 0 },
/* U+0939 */ { 19, 0, 1, 0, 0 },
/* U+093a */ { 0, 0, 0, 0, 0 },
/* U+093b */ { 0, 0, 0, 0, 0 },
/* U+093c */ { 4, 7, 14, 0, 0 },
/* U+093d */ { 19, 0, 1, 0, 0 },
/* U+093e */ { 5, 0, 1, 0, 0 },
/* U+093f */ { 5, 0, 1, 0, 0 },
/* U+0940 */ { 5, 0, 1, 0, 0 },
/* U+0941 */ { 4, 0, 14, 0, 0 },
/* U+0942 */ { 4, 0, 14, 0, 0 },
/* U+0943 */ { 4, 0, 14, 0, 0 },
/* U+0944 */ { 4, 0, 14, 0, 0 },
/* U+0945 */ { 4, 0, 14, 0, 0 },
/* U+0946 */ { 4, 0, 14, 0, 0 },
/* U+0947 */ { 4, 0, 14, 0, 0 },
/* U+0948 */ { 4, 0, 14, 0, 0 },
/* U+0949 */ { 5, 0, 1, 0, 0 },
/* U+094a */ { 5, 0, 1, 0, 0 },
/* U+094b */ { 5, 0, 1, 0, 0 },
/* U+094c */ { 5, 0, 1, 0, 0 },
/* U+094d */ { 4, 9, 14, 0, 0 },
/* U+094e */ { 0, 0, 0, 0, 0 },
/* U+094f */ { 0, 0, 0, 0, 0 },
/* U+0950 */ { 19, 0, 1, 0, 0 },
/* U+0951 */ { 4, 230, 14, 0, 0 },
/* U+0952 */ { 4, 220, 14, 0, 0 },
/* U+0953 */ { 4, 230, 14, 0, 0 },
/* U+0954 */ { 4, 230, 14, 0, 0 },
/* U+0955 */ { 0, 0, 0, 0, 0 },
/* U+0956 */ { 0, 0, 0, 0, 0 },
/* U+0957 */ { 0, 0, 0, 0, 0 },
/* U+0958 */ { 19, 0, 1, 0, "0915 093C" },
/* U+0959 */ { 19, 0, 1, 0, "0916 093C" },
/* U+095a */ { 19, 0, 1, 0, "0917 093C" },
/* U+095b */ { 19, 0, 1, 0, "091C 093C" },
/* U+095c */ { 19, 0, 1, 0, "0921 093C" },
/* U+095d */ { 19, 0, 1, 0, "0922 093C" },
/* U+095e */ { 19, 0, 1, 0, "092B 093C" },
/* U+095f */ { 19, 0, 1, 0, "092F 093C" },
/* U+0960 */ { 19, 0, 1, 0, 0 },
/* U+0961 */ { 19, 0, 1, 0, 0 },
/* U+0962 */ { 4, 0, 14, 0, 0 },
/* U+0963 */ { 4, 0, 14, 0, 0 },
/* U+0964 */ { 26, 0, 1, 0, 0 },
/* U+0965 */ { 26, 0, 1, 0, 0 },
/* U+0966 */ { 7, 0, 1, 0, 0 },
/* U+0967 */ { 7, 0, 1, 0, 0 },
/* U+0968 */ { 7, 0, 1, 0, 0 },
/* U+0969 */ { 7, 0, 1, 0, 0 },
/* U+096a */ { 7, 0, 1, 0, 0 },
/* U+096b */ { 7, 0, 1, 0, 0 },
/* U+096c */ { 7, 0, 1, 0, 0 },
/* U+096d */ { 7, 0, 1, 0, 0 },
/* U+096e */ { 7, 0, 1, 0, 0 },
/* U+096f */ { 7, 0, 1, 0, 0 },
/* U+0970 */ { 26, 0, 1, 0, 0 },
/* U+0971 */ { 0, 0, 0, 0, 0 },
/* U+0972 */ { 0, 0, 0, 0, 0 },
/* U+0973 */ { 0, 0, 0, 0, 0 },
/* U+0974 */ { 0, 0, 0, 0, 0 },
/* U+0975 */ { 0, 0, 0, 0, 0 },
/* U+0976 */ { 0, 0, 0, 0, 0 },
/* U+0977 */ { 0, 0, 0, 0, 0 },
/* U+0978 */ { 0, 0, 0, 0, 0 },
/* U+0979 */ { 0, 0, 0, 0, 0 },
/* U+097a */ { 0, 0, 0, 0, 0 },
/* U+097b */ { 0, 0, 0, 0, 0 },
/* U+097c */ { 0, 0, 0, 0, 0 },
/* U+097d */ { 0, 0, 0, 0, 0 },
/* U+097e */ { 0, 0, 0, 0, 0 },
/* U+097f */ { 0, 0, 0, 0, 0 },
/* U+0980 */ { 0, 0, 0, 0, 0 },
/* U+0981 */ { 4, 0, 14, 0, 0 },
/* U+0982 */ { 5, 0, 1, 0, 0 },
/* U+0983 */ { 5, 0, 1, 0, 0 },
/* U+0984 */ { 0, 0, 0, 0, 0 },
/* U+0985 */ { 19, 0, 1, 0, 0 },
/* U+0986 */ { 19, 0, 1, 0, 0 },
/* U+0987 */ { 19, 0, 1, 0, 0 },
/* U+0988 */ { 19, 0, 1, 0, 0 },
/* U+0989 */ { 19, 0, 1, 0, 0 },
/* U+098a */ { 19, 0, 1, 0, 0 },
/* U+098b */ { 19, 0, 1, 0, 0 },
/* U+098c */ { 19, 0, 1, 0, 0 },
/* U+098d */ { 0, 0, 0, 0, 0 },
/* U+098e */ { 0, 0, 0, 0, 0 },
/* U+098f */ { 19, 0, 1, 0, 0 },
/* U+0990 */ { 19, 0, 1, 0, 0 },
/* U+0991 */ { 0, 0, 0, 0, 0 },
/* U+0992 */ { 0, 0, 0, 0, 0 },
/* U+0993 */ { 19, 0, 1, 0, 0 },
/* U+0994 */ { 19, 0, 1, 0, 0 },
/* U+0995 */ { 19, 0, 1, 0, 0 },
/* U+0996 */ { 19, 0, 1, 0, 0 },
/* U+0997 */ { 19, 0, 1, 0, 0 },
/* U+0998 */ { 19, 0, 1, 0, 0 },
/* U+0999 */ { 19, 0, 1, 0, 0 },
/* U+099a */ { 19, 0, 1, 0, 0 },
/* U+099b */ { 19, 0, 1, 0, 0 },
/* U+099c */ { 19, 0, 1, 0, 0 },
/* U+099d */ { 19, 0, 1, 0, 0 },
/* U+099e */ { 19, 0, 1, 0, 0 },
/* U+099f */ { 19, 0, 1, 0, 0 },
/* U+09a0 */ { 19, 0, 1, 0, 0 },
/* U+09a1 */ { 19, 0, 1, 0, 0 },
/* U+09a2 */ { 19, 0, 1, 0, 0 },
/* U+09a3 */ { 19, 0, 1, 0, 0 },
/* U+09a4 */ { 19, 0, 1, 0, 0 },
/* U+09a5 */ { 19, 0, 1, 0, 0 },
/* U+09a6 */ { 19, 0, 1, 0, 0 },
/* U+09a7 */ { 19, 0, 1, 0, 0 },
/* U+09a8 */ { 19, 0, 1, 0, 0 },
/* U+09a9 */ { 0, 0, 0, 0, 0 },
/* U+09aa */ { 19, 0, 1, 0, 0 },
/* U+09ab */ { 19, 0, 1, 0, 0 },
/* U+09ac */ { 19, 0, 1, 0, 0 },
/* U+09ad */ { 19, 0, 1, 0, 0 },
/* U+09ae */ { 19, 0, 1, 0, 0 },
/* U+09af */ { 19, 0, 1, 0, 0 },
/* U+09b0 */ { 19, 0, 1, 0, 0 },
/* U+09b1 */ { 0, 0, 0, 0, 0 },
/* U+09b2 */ { 19, 0, 1, 0, 0 },
/* U+09b3 */ { 0, 0, 0, 0, 0 },
/* U+09b4 */ { 0, 0, 0, 0, 0 },
/* U+09b5 */ { 0, 0, 0, 0, 0 },
/* U+09b6 */ { 19, 0, 1, 0, 0 },
/* U+09b7 */ { 19, 0, 1, 0, 0 },
/* U+09b8 */ { 19, 0, 1, 0, 0 },
/* U+09b9 */ { 19, 0, 1, 0, 0 },
/* U+09ba */ { 0, 0, 0, 0, 0 },
/* U+09bb */ { 0, 0, 0, 0, 0 },
/* U+09bc */ { 4, 7, 14, 0, 0 },
/* U+09bd */ { 0, 0, 0, 0, 0 },
/* U+09be */ { 5, 0, 1, 0, 0 },
/* U+09bf */ { 5, 0, 1, 0, 0 },
/* U+09c0 */ { 5, 0, 1, 0, 0 },
/* U+09c1 */ { 4, 0, 14, 0, 0 },
/* U+09c2 */ { 4, 0, 14, 0, 0 },
/* U+09c3 */ { 4, 0, 14, 0, 0 },
/* U+09c4 */ { 4, 0, 14, 0, 0 },
/* U+09c5 */ { 0, 0, 0, 0, 0 },
/* U+09c6 */ { 0, 0, 0, 0, 0 },
/* U+09c7 */ { 5, 0, 1, 0, 0 },
/* U+09c8 */ { 5, 0, 1, 0, 0 },
/* U+09c9 */ { 0, 0, 0, 0, 0 },
/* U+09ca */ { 0, 0, 0, 0, 0 },
/* U+09cb */ { 5, 0, 1, 0, "09C7 09BE" },
/* U+09cc */ { 5, 0, 1, 0, "09C7 09D7" },
/* U+09cd */ { 4, 9, 14, 0, 0 },
/* U+09ce */ { 0, 0, 0, 0, 0 },
/* U+09cf */ { 0, 0, 0, 0, 0 },
/* U+09d0 */ { 0, 0, 0, 0, 0 },
/* U+09d1 */ { 0, 0, 0, 0, 0 },
/* U+09d2 */ { 0, 0, 0, 0, 0 },
/* U+09d3 */ { 0, 0, 0, 0, 0 },
/* U+09d4 */ { 0, 0, 0, 0, 0 },
/* U+09d5 */ { 0, 0, 0, 0, 0 },
/* U+09d6 */ { 0, 0, 0, 0, 0 },
/* U+09d7 */ { 5, 0, 1, 0, 0 },
/* U+09d8 */ { 0, 0, 0, 0, 0 },
/* U+09d9 */ { 0, 0, 0, 0, 0 },
/* U+09da */ { 0, 0, 0, 0, 0 },
/* U+09db */ { 0, 0, 0, 0, 0 },
/* U+09dc */ { 19, 0, 1, 0, "09A1 09BC" },
/* U+09dd */ { 19, 0, 1, 0, "09A2 09BC" },
/* U+09de */ { 0, 0, 0, 0, 0 },
/* U+09df */ { 19, 0, 1, 0, "09AF 09BC" },
/* U+09e0 */ { 19, 0, 1, 0, 0 },
/* U+09e1 */ { 19, 0, 1, 0, 0 },
/* U+09e2 */ { 4, 0, 14, 0, 0 },
/* U+09e3 */ { 4, 0, 14, 0, 0 },
/* U+09e4 */ { 0, 0, 0, 0, 0 },
/* U+09e5 */ { 0, 0, 0, 0, 0 },
/* U+09e6 */ { 7, 0, 1, 0, 0 },
/* U+09e7 */ { 7, 0, 1, 0, 0 },
/* U+09e8 */ { 7, 0, 1, 0, 0 },
/* U+09e9 */ { 7, 0, 1, 0, 0 },
/* U+09ea */ { 7, 0, 1, 0, 0 },
/* U+09eb */ { 7, 0, 1, 0, 0 },
/* U+09ec */ { 7, 0, 1, 0, 0 },
/* U+09ed */ { 7, 0, 1, 0, 0 },
/* U+09ee */ { 7, 0, 1, 0, 0 },
/* U+09ef */ { 7, 0, 1, 0, 0 },
/* U+09f0 */ { 19, 0, 1, 0, 0 },
/* U+09f1 */ { 19, 0, 1, 0, 0 },
/* U+09f2 */ { 28, 0, 11, 0, 0 },
/* U+09f3 */ { 28, 0, 11, 0, 0 },
/* U+09f4 */ { 9, 0, 1, 0, 0 },
/* U+09f5 */ { 9, 0, 1, 0, 0 },
/* U+09f6 */ { 9, 0, 1, 0, 0 },
/* U+09f7 */ { 9, 0, 1, 0, 0 },
/* U+09f8 */ { 9, 0, 1, 0, 0 },
/* U+09f9 */ { 9, 0, 1, 0, 0 },
/* U+09fa */ { 30, 0, 1, 0, 0 },
/* U+09fb */ { 0, 0, 0, 0, 0 },
/* U+09fc */ { 0, 0, 0, 0, 0 },
/* U+09fd */ { 0, 0, 0, 0, 0 },
/* U+09fe */ { 0, 0, 0, 0, 0 },
/* U+09ff */ { 0, 0, 0, 0, 0 },
/* U+0a00 */ { 0, 0, 0, 0, 0 },
/* U+0a01 */ { 0, 0, 0, 0, 0 },
/* U+0a02 */ { 4, 0, 14, 0, 0 },
/* U+0a03 */ { 0, 0, 0, 0, 0 },
/* U+0a04 */ { 0, 0, 0, 0, 0 },
/* U+0a05 */ { 19, 0, 1, 0, 0 },
/* U+0a06 */ { 19, 0, 1, 0, 0 },
/* U+0a07 */ { 19, 0, 1, 0, 0 },
/* U+0a08 */ { 19, 0, 1, 0, 0 },
/* U+0a09 */ { 19, 0, 1, 0, 0 },
/* U+0a0a */ { 19, 0, 1, 0, 0 },
/* U+0a0b */ { 0, 0, 0, 0, 0 },
/* U+0a0c */ { 0, 0, 0, 0, 0 },
/* U+0a0d */ { 0, 0, 0, 0, 0 },
/* U+0a0e */ { 0, 0, 0, 0, 0 },
/* U+0a0f */ { 19, 0, 1, 0, 0 },
/* U+0a10 */ { 19, 0, 1, 0, 0 },
/* U+0a11 */ { 0, 0, 0, 0, 0 },
/* U+0a12 */ { 0, 0, 0, 0, 0 },
/* U+0a13 */ { 19, 0, 1, 0, 0 },
/* U+0a14 */ { 19, 0, 1, 0, 0 },
/* U+0a15 */ { 19, 0, 1, 0, 0 },
/* U+0a16 */ { 19, 0, 1, 0, 0 },
/* U+0a17 */ { 19, 0, 1, 0, 0 },
/* U+0a18 */ { 19, 0, 1, 0, 0 },
/* U+0a19 */ { 19, 0, 1, 0, 0 },
/* U+0a1a */ { 19, 0, 1, 0, 0 },
/* U+0a1b */ { 19, 0, 1, 0, 0 },
/* U+0a1c */ { 19, 0, 1, 0, 0 },
/* U+0a1d */ { 19, 0, 1, 0, 0 },
/* U+0a1e */ { 19, 0, 1, 0, 0 },
/* U+0a1f */ { 19, 0, 1, 0, 0 },
/* U+0a20 */ { 19, 0, 1, 0, 0 },
/* U+0a21 */ { 19, 0, 1, 0, 0 },
/* U+0a22 */ { 19, 0, 1, 0, 0 },
/* U+0a23 */ { 19, 0, 1, 0, 0 },
/* U+0a24 */ { 19, 0, 1, 0, 0 },
/* U+0a25 */ { 19, 0, 1, 0, 0 },
/* U+0a26 */ { 19, 0, 1, 0, 0 },
/* U+0a27 */ { 19, 0, 1, 0, 0 },
/* U+0a28 */ { 19, 0, 1, 0, 0 },
/* U+0a29 */ { 0, 0, 0, 0, 0 },
/* U+0a2a */ { 19, 0, 1, 0, 0 },
/* U+0a2b */ { 19, 0, 1, 0, 0 },
/* U+0a2c */ { 19, 0, 1, 0, 0 },
/* U+0a2d */ { 19, 0, 1, 0, 0 },
/* U+0a2e */ { 19, 0, 1, 0, 0 },
/* U+0a2f */ { 19, 0, 1, 0, 0 },
/* U+0a30 */ { 19, 0, 1, 0, 0 },
/* U+0a31 */ { 0, 0, 0, 0, 0 },
/* U+0a32 */ { 19, 0, 1, 0, 0 },
/* U+0a33 */ { 19, 0, 1, 0, "0A32 0A3C" },
/* U+0a34 */ { 0, 0, 0, 0, 0 },
/* U+0a35 */ { 19, 0, 1, 0, 0 },
/* U+0a36 */ { 19, 0, 1, 0, "0A38 0A3C" },
/* U+0a37 */ { 0, 0, 0, 0, 0 },
/* U+0a38 */ { 19, 0, 1, 0, 0 },
/* U+0a39 */ { 19, 0, 1, 0, 0 },
/* U+0a3a */ { 0, 0, 0, 0, 0 },
/* U+0a3b */ { 0, 0, 0, 0, 0 },
/* U+0a3c */ { 4, 7, 14, 0, 0 },
/* U+0a3d */ { 0, 0, 0, 0, 0 },
/* U+0a3e */ { 5, 0, 1, 0, 0 },
/* U+0a3f */ { 5, 0, 1, 0, 0 },
/* U+0a40 */ { 5, 0, 1, 0, 0 },
/* U+0a41 */ { 4, 0, 14, 0, 0 },
/* U+0a42 */ { 4, 0, 14, 0, 0 },
/* U+0a43 */ { 0, 0, 0, 0, 0 },
/* U+0a44 */ { 0, 0, 0, 0, 0 },
/* U+0a45 */ { 0, 0, 0, 0, 0 },
/* U+0a46 */ { 0, 0, 0, 0, 0 },
/* U+0a47 */ { 4, 0, 14, 0, 0 },
/* U+0a48 */ { 4, 0, 14, 0, 0 },
/* U+0a49 */ { 0, 0, 0, 0, 0 },
/* U+0a4a */ { 0, 0, 0, 0, 0 },
/* U+0a4b */ { 4, 0, 14, 0, 0 },
/* U+0a4c */ { 4, 0, 14, 0, 0 },
/* U+0a4d */ { 4, 9, 14, 0, 0 },
/* U+0a4e */ { 0, 0, 0, 0, 0 },
/* U+0a4f */ { 0, 0, 0, 0, 0 },
/* U+0a50 */ { 0, 0, 0, 0, 0 },
/* U+0a51 */ { 0, 0, 0, 0, 0 },
/* U+0a52 */ { 0, 0, 0, 0, 0 },
/* U+0a53 */ { 0, 0, 0, 0, 0 },
/* U+0a54 */ { 0, 0, 0, 0, 0 },
/* U+0a55 */ { 0, 0, 0, 0, 0 },
/* U+0a56 */ { 0, 0, 0, 0, 0 },
/* U+0a57 */ { 0, 0, 0, 0, 0 },
/* U+0a58 */ { 0, 0, 0, 0, 0 },
/* U+0a59 */ { 19, 0, 1, 0, "0A16 0A3C" },
/* U+0a5a */ { 19, 0, 1, 0, "0A17 0A3C" },
/* U+0a5b */ { 19, 0, 1, 0, "0A1C 0A3C" },
/* U+0a5c */ { 19, 0, 1, 0, 0 },
/* U+0a5d */ { 0, 0, 0, 0, 0 },
/* U+0a5e */ { 19, 0, 1, 0, "0A2B 0A3C" },
/* U+0a5f */ { 0, 0, 0, 0, 0 },
/* U+0a60 */ { 0, 0, 0, 0, 0 },
/* U+0a61 */ { 0, 0, 0, 0, 0 },
/* U+0a62 */ { 0, 0, 0, 0, 0 },
/* U+0a63 */ { 0, 0, 0, 0, 0 },
/* U+0a64 */ { 0, 0, 0, 0, 0 },
/* U+0a65 */ { 0, 0, 0, 0, 0 },
/* U+0a66 */ { 7, 0, 1, 0, 0 },
/* U+0a67 */ { 7, 0, 1, 0, 0 },
/* U+0a68 */ { 7, 0, 1, 0, 0 },
/* U+0a69 */ { 7, 0, 1, 0, 0 },
/* U+0a6a */ { 7, 0, 1, 0, 0 },
/* U+0a6b */ { 7, 0, 1, 0, 0 },
/* U+0a6c */ { 7, 0, 1, 0, 0 },
/* U+0a6d */ { 7, 0, 1, 0, 0 },
/* U+0a6e */ { 7, 0, 1, 0, 0 },
/* U+0a6f */ { 7, 0, 1, 0, 0 },
/* U+0a70 */ { 4, 0, 14, 0, 0 },
/* U+0a71 */ { 4, 0, 14, 0, 0 },
/* U+0a72 */ { 19, 0, 1, 0, 0 },
/* U+0a73 */ { 19, 0, 1, 0, 0 },
/* U+0a74 */ { 19, 0, 1, 0, 0 },
/* U+0a75 */ { 0, 0, 0, 0, 0 },
/* U+0a76 */ { 0, 0, 0, 0, 0 },
/* U+0a77 */ { 0, 0, 0, 0, 0 },
/* U+0a78 */ { 0, 0, 0, 0, 0 },
/* U+0a79 */ { 0, 0, 0, 0, 0 },
/* U+0a7a */ { 0, 0, 0, 0, 0 },
/* U+0a7b */ { 0, 0, 0, 0, 0 },
/* U+0a7c */ { 0, 0, 0, 0, 0 },
/* U+0a7d */ { 0, 0, 0, 0, 0 },
/* U+0a7e */ { 0, 0, 0, 0, 0 },
/* U+0a7f */ { 0, 0, 0, 0, 0 },
/* U+0a80 */ { 0, 0, 0, 0, 0 },
/* U+0a81 */ { 4, 0, 14, 0, 0 },
/* U+0a82 */ { 4, 0, 14, 0, 0 },
/* U+0a83 */ { 5, 0, 1, 0, 0 },
/* U+0a84 */ { 0, 0, 0, 0, 0 },
/* U+0a85 */ { 19, 0, 1, 0, 0 },
/* U+0a86 */ { 19, 0, 1, 0, 0 },
/* U+0a87 */ { 19, 0, 1, 0, 0 },
/* U+0a88 */ { 19, 0, 1, 0, 0 },
/* U+0a89 */ { 19, 0, 1, 0, 0 },
/* U+0a8a */ { 19, 0, 1, 0, 0 },
/* U+0a8b */ { 19, 0, 1, 0, 0 },
/* U+0a8c */ { 0, 0, 0, 0, 0 },
/* U+0a8d */ { 19, 0, 1, 0, 0 },
/* U+0a8e */ { 0, 0, 0, 0, 0 },
/* U+0a8f */ { 19, 0, 1, 0, 0 },
/* U+0a90 */ { 19, 0, 1, 0, 0 },
/* U+0a91 */ { 19, 0, 1, 0, 0 },
/* U+0a92 */ { 0, 0, 0, 0, 0 },
/* U+0a93 */ { 19, 0, 1, 0, 0 },
/* U+0a94 */ { 19, 0, 1, 0, 0 },
/* U+0a95 */ { 19, 0, 1, 0, 0 },
/* U+0a96 */ { 19, 0, 1, 0, 0 },
/* U+0a97 */ { 19, 0, 1, 0, 0 },
/* U+0a98 */ { 19, 0, 1, 0, 0 },
/* U+0a99 */ { 19, 0, 1, 0, 0 },
/* U+0a9a */ { 19, 0, 1, 0, 0 },
/* U+0a9b */ { 19, 0, 1, 0, 0 },
/* U+0a9c */ { 19, 0, 1, 0, 0 },
/* U+0a9d */ { 19, 0, 1, 0, 0 },
/* U+0a9e */ { 19, 0, 1, 0, 0 },
/* U+0a9f */ { 19, 0, 1, 0, 0 },
/* U+0aa0 */ { 19, 0, 1, 0, 0 },
/* U+0aa1 */ { 19, 0, 1, 0, 0 },
/* U+0aa2 */ { 19, 0, 1, 0, 0 },
/* U+0aa3 */ { 19, 0, 1, 0, 0 },
/* U+0aa4 */ { 19, 0, 1, 0, 0 },
/* U+0aa5 */ { 19, 0, 1, 0, 0 },
/* U+0aa6 */ { 19, 0, 1, 0, 0 },
/* U+0aa7 */ { 19, 0, 1, 0, 0 },
/* U+0aa8 */ { 19, 0, 1, 0, 0 },
/* U+0aa9 */ { 0, 0, 0, 0, 0 },
/* U+0aaa */ { 19, 0, 1, 0, 0 },
/* U+0aab */ { 19, 0, 1, 0, 0 },
/* U+0aac */ { 19, 0, 1, 0, 0 },
/* U+0aad */ { 19, 0, 1, 0, 0 },
/* U+0aae */ { 19, 0, 1, 0, 0 },
/* U+0aaf */ { 19, 0, 1, 0, 0 },
/* U+0ab0 */ { 19, 0, 1, 0, 0 },
/* U+0ab1 */ { 0, 0, 0, 0, 0 },
/* U+0ab2 */ { 19, 0, 1, 0, 0 },
/* U+0ab3 */ { 19, 0, 1, 0, 0 },
/* U+0ab4 */ { 0, 0, 0, 0, 0 },
/* U+0ab5 */ { 19, 0, 1, 0, 0 },
/* U+0ab6 */ { 19, 0, 1, 0, 0 },
/* U+0ab7 */ { 19, 0, 1, 0, 0 },
/* U+0ab8 */ { 19, 0, 1, 0, 0 },
/* U+0ab9 */ { 19, 0, 1, 0, 0 },
/* U+0aba */ { 0, 0, 0, 0, 0 },
/* U+0abb */ { 0, 0, 0, 0, 0 },
/* U+0abc */ { 4, 7, 14, 0, 0 },
/* U+0abd */ { 19, 0, 1, 0, 0 },
/* U+0abe */ { 5, 0, 1, 0, 0 },
/* U+0abf */ { 5, 0, 1, 0, 0 },
/* U+0ac0 */ { 5, 0, 1, 0, 0 },
/* U+0ac1 */ { 4, 0, 14, 0, 0 },
/* U+0ac2 */ { 4, 0, 14, 0, 0 },
/* U+0ac3 */ { 4, 0, 14, 0, 0 },
/* U+0ac4 */ { 4, 0, 14, 0, 0 },
/* U+0ac5 */ { 4, 0, 14, 0, 0 },
/* U+0ac6 */ { 0, 0, 0, 0, 0 },
/* U+0ac7 */ { 4, 0, 14, 0, 0 },
/* U+0ac8 */ { 4, 0, 14, 0, 0 },
/* U+0ac9 */ { 5, 0, 1, 0, 0 },
/* U+0aca */ { 0, 0, 0, 0, 0 },
/* U+0acb */ { 5, 0, 1, 0, 0 },
/* U+0acc */ { 5, 0, 1, 0, 0 },
/* U+0acd */ { 4, 9, 14, 0, 0 },
/* U+0ace */ { 0, 0, 0, 0, 0 },
/* U+0acf */ { 0, 0, 0, 0, 0 },
/* U+0ad0 */ { 19, 0, 1, 0, 0 },
/* U+0ad1 */ { 0, 0, 0, 0, 0 },
/* U+0ad2 */ { 0, 0, 0, 0, 0 },
/* U+0ad3 */ { 0, 0, 0, 0, 0 },
/* U+0ad4 */ { 0, 0, 0, 0, 0 },
/* U+0ad5 */ { 0, 0, 0, 0, 0 },
/* U+0ad6 */ { 0, 0, 0, 0, 0 },
/* U+0ad7 */ { 0, 0, 0, 0, 0 },
/* U+0ad8 */ { 0, 0, 0, 0, 0 },
/* U+0ad9 */ { 0, 0, 0, 0, 0 },
/* U+0ada */ { 0, 0, 0, 0, 0 },
/* U+0adb */ { 0, 0, 0, 0, 0 },
/* U+0adc */ { 0, 0, 0, 0, 0 },
/* U+0add */ { 0, 0, 0, 0, 0 },
/* U+0ade */ { 0, 0, 0, 0, 0 },
/* U+0adf */ { 0, 0, 0, 0, 0 },
/* U+0ae0 */ { 19, 0, 1, 0, 0 },
/* U+0ae1 */ { 0, 0, 0, 0, 0 },
/* U+0ae2 */ { 0, 0, 0, 0, 0 },
/* U+0ae3 */ { 0, 0, 0, 0, 0 },
/* U+0ae4 */ { 0, 0, 0, 0, 0 },
/* U+0ae5 */ { 0, 0, 0, 0, 0 },
/* U+0ae6 */ { 7, 0, 1, 0, 0 },
/* U+0ae7 */ { 7, 0, 1, 0, 0 },
/* U+0ae8 */ { 7, 0, 1, 0, 0 },
/* U+0ae9 */ { 7, 0, 1, 0, 0 },
/* U+0aea */ { 7, 0, 1, 0, 0 },
/* U+0aeb */ { 7, 0, 1, 0, 0 },
/* U+0aec */ { 7, 0, 1, 0, 0 },
/* U+0aed */ { 7, 0, 1, 0, 0 },
/* U+0aee */ { 7, 0, 1, 0, 0 },
/* U+0aef */ { 7, 0, 1, 0, 0 },
/* U+0af0 */ { 0, 0, 0, 0, 0 },
/* U+0af1 */ { 0, 0, 0, 0, 0 },
/* U+0af2 */ { 0, 0, 0, 0, 0 },
/* U+0af3 */ { 0, 0, 0, 0, 0 },
/* U+0af4 */ { 0, 0, 0, 0, 0 },
/* U+0af5 */ { 0, 0, 0, 0, 0 },
/* U+0af6 */ { 0, 0, 0, 0, 0 },
/* U+0af7 */ { 0, 0, 0, 0, 0 },
/* U+0af8 */ { 0, 0, 0, 0, 0 },
/* U+0af9 */ { 0, 0, 0, 0, 0 },
/* U+0afa */ { 0, 0, 0, 0, 0 },
/* U+0afb */ { 0, 0, 0, 0, 0 },
/* U+0afc */ { 0, 0, 0, 0, 0 },
/* U+0afd */ { 0, 0, 0, 0, 0 },
/* U+0afe */ { 0, 0, 0, 0, 0 },
/* U+0aff */ { 0, 0, 0, 0, 0 },
/* U+0b00 */ { 0, 0, 0, 0, 0 },
/* U+0b01 */ { 4, 0, 14, 0, 0 },
/* U+0b02 */ { 5, 0, 1, 0, 0 },
/* U+0b03 */ { 5, 0, 1, 0, 0 },
/* U+0b04 */ { 0, 0, 0, 0, 0 },
/* U+0b05 */ { 19, 0, 1, 0, 0 },
/* U+0b06 */ { 19, 0, 1, 0, 0 },
/* U+0b07 */ { 19, 0, 1, 0, 0 },
/* U+0b08 */ { 19, 0, 1, 0, 0 },
/* U+0b09 */ { 19, 0, 1, 0, 0 },
/* U+0b0a */ { 19, 0, 1, 0, 0 },
/* U+0b0b */ { 19, 0, 1, 0, 0 },
/* U+0b0c */ { 19, 0, 1, 0, 0 },
/* U+0b0d */ { 0, 0, 0, 0, 0 },
/* U+0b0e */ { 0, 0, 0, 0, 0 },
/* U+0b0f */ { 19, 0, 1, 0, 0 },
/* U+0b10 */ { 19, 0, 1, 0, 0 },
/* U+0b11 */ { 0, 0, 0, 0, 0 },
/* U+0b12 */ { 0, 0, 0, 0, 0 },
/* U+0b13 */ { 19, 0, 1, 0, 0 },
/* U+0b14 */ { 19, 0, 1, 0, 0 },
/* U+0b15 */ { 19, 0, 1, 0, 0 },
/* U+0b16 */ { 19, 0, 1, 0, 0 },
/* U+0b17 */ { 19, 0, 1, 0, 0 },
/* U+0b18 */ { 19, 0, 1, 0, 0 },
/* U+0b19 */ { 19, 0, 1, 0, 0 },
/* U+0b1a */ { 19, 0, 1, 0, 0 },
/* U+0b1b */ { 19, 0, 1, 0, 0 },
/* U+0b1c */ { 19, 0, 1, 0, 0 },
/* U+0b1d */ { 19, 0, 1, 0, 0 },
/* U+0b1e */ { 19, 0, 1, 0, 0 },
/* U+0b1f */ { 19, 0, 1, 0, 0 },
/* U+0b20 */ { 19, 0, 1, 0, 0 },
/* U+0b21 */ { 19, 0, 1, 0, 0 },
/* U+0b22 */ { 19, 0, 1, 0, 0 },
/* U+0b23 */ { 19, 0, 1, 0, 0 },
/* U+0b24 */ { 19, 0, 1, 0, 0 },
/* U+0b25 */ { 19, 0, 1, 0, 0 },
/* U+0b26 */ { 19, 0, 1, 0, 0 },
/* U+0b27 */ { 19, 0, 1, 0, 0 },
/* U+0b28 */ { 19, 0, 1, 0, 0 },
/* U+0b29 */ { 0, 0, 0, 0, 0 },
/* U+0b2a */ { 19, 0, 1, 0, 0 },
/* U+0b2b */ { 19, 0, 1, 0, 0 },
/* U+0b2c */ { 19, 0, 1, 0, 0 },
/* U+0b2d */ { 19, 0, 1, 0, 0 },
/* U+0b2e */ { 19, 0, 1, 0, 0 },
/* U+0b2f */ { 19, 0, 1, 0, 0 },
/* U+0b30 */ { 19, 0, 1, 0, 0 },
/* U+0b31 */ { 0, 0, 0, 0, 0 },
/* U+0b32 */ { 19, 0, 1, 0, 0 },
/* U+0b33 */ { 19, 0, 1, 0, 0 },
/* U+0b34 */ { 0, 0, 0, 0, 0 },
/* U+0b35 */ { 0, 0, 0, 0, 0 },
/* U+0b36 */ { 19, 0, 1, 0, 0 },
/* U+0b37 */ { 19, 0, 1, 0, 0 },
/* U+0b38 */ { 19, 0, 1, 0, 0 },
/* U+0b39 */ { 19, 0, 1, 0, 0 },
/* U+0b3a */ { 0, 0, 0, 0, 0 },
/* U+0b3b */ { 0, 0, 0, 0, 0 },
/* U+0b3c */ { 4, 7, 14, 0, 0 },
/* U+0b3d */ { 19, 0, 1, 0, 0 },
/* U+0b3e */ { 5, 0, 1, 0, 0 },
/* U+0b3f */ { 4, 0, 14, 0, 0 },
/* U+0b40 */ { 5, 0, 1, 0, 0 },
/* U+0b41 */ { 4, 0, 14, 0, 0 },
/* U+0b42 */ { 4, 0, 14, 0, 0 },
/* U+0b43 */ { 4, 0, 14, 0, 0 },
/* U+0b44 */ { 0, 0, 0, 0, 0 },
/* U+0b45 */ { 0, 0, 0, 0, 0 },
/* U+0b46 */ { 0, 0, 0, 0, 0 },
/* U+0b47 */ { 5, 0, 1, 0, 0 },
/* U+0b48 */ { 5, 0, 1, 0, "0B47 0B56" },
/* U+0b49 */ { 0, 0, 0, 0, 0 },
/* U+0b4a */ { 0, 0, 0, 0, 0 },
/* U+0b4b */ { 5, 0, 1, 0, "0B47 0B3E" },
/* U+0b4c */ { 5, 0, 1, 0, "0B47 0B57" },
/* U+0b4d */ { 4, 9, 14, 0, 0 },
/* U+0b4e */ { 0, 0, 0, 0, 0 },
/* U+0b4f */ { 0, 0, 0, 0, 0 },
/* U+0b50 */ { 0, 0, 0, 0, 0 },
/* U+0b51 */ { 0, 0, 0, 0, 0 },
/* U+0b52 */ { 0, 0, 0, 0, 0 },
/* U+0b53 */ { 0, 0, 0, 0, 0 },
/* U+0b54 */ { 0, 0, 0, 0, 0 },
/* U+0b55 */ { 0, 0, 0, 0, 0 },
/* U+0b56 */ { 4, 0, 14, 0, 0 },
/* U+0b57 */ { 5, 0, 1, 0, 0 },
/* U+0b58 */ { 0, 0, 0, 0, 0 },
/* U+0b59 */ { 0, 0, 0, 0, 0 },
/* U+0b5a */ { 0, 0, 0, 0, 0 },
/* U+0b5b */ { 0, 0, 0, 0, 0 },
/* U+0b5c */ { 19, 0, 1, 0, "0B21 0B3C" },
/* U+0b5d */ { 19, 0, 1, 0, "0B22 0B3C" },
/* U+0b5e */ { 0, 0, 0, 0, 0 },
/* U+0b5f */ { 19, 0, 1, 0, 0 },
/* U+0b60 */ { 19, 0, 1, 0, 0 },
/* U+0b61 */ { 19, 0, 1, 0, 0 },
/* U+0b62 */ { 0, 0, 0, 0, 0 },
/* U+0b63 */ { 0, 0, 0, 0, 0 },
/* U+0b64 */ { 0, 0, 0, 0, 0 },
/* U+0b65 */ { 0, 0, 0, 0, 0 },
/* U+0b66 */ { 7, 0, 1, 0, 0 },
/* U+0b67 */ { 7, 0, 1, 0, 0 },
/* U+0b68 */ { 7, 0, 1, 0, 0 },
/* U+0b69 */ { 7, 0, 1, 0, 0 },
/* U+0b6a */ { 7, 0, 1, 0, 0 },
/* U+0b6b */ { 7, 0, 1, 0, 0 },
/* U+0b6c */ { 7, 0, 1, 0, 0 },
/* U+0b6d */ { 7, 0, 1, 0, 0 },
/* U+0b6e */ { 7, 0, 1, 0, 0 },
/* U+0b6f */ { 7, 0, 1, 0, 0 },
/* U+0b70 */ { 30, 0, 1, 0, 0 },
/* U+0b71 */ { 0, 0, 0, 0, 0 },
/* U+0b72 */ { 0, 0, 0, 0, 0 },
/* U+0b73 */ { 0, 0, 0, 0, 0 },
/* U+0b74 */ { 0, 0, 0, 0, 0 },
/* U+0b75 */ { 0, 0, 0, 0, 0 },
/* U+0b76 */ { 0, 0, 0, 0, 0 },
/* U+0b77 */ { 0, 0, 0, 0, 0 },
/* U+0b78 */ { 0, 0, 0, 0, 0 },
/* U+0b79 */ { 0, 0, 0, 0, 0 },
/* U+0b7a */ { 0, 0, 0, 0, 0 },
/* U+0b7b */ { 0, 0, 0, 0, 0 },
/* U+0b7c */ { 0, 0, 0, 0, 0 },
/* U+0b7d */ { 0, 0, 0, 0, 0 },
/* U+0b7e */ { 0, 0, 0, 0, 0 },
/* U+0b7f */ { 0, 0, 0, 0, 0 },
/* U+0b80 */ { 0, 0, 0, 0, 0 },
/* U+0b81 */ { 0, 0, 0, 0, 0 },
/* U+0b82 */ { 4, 0, 14, 0, 0 },
/* U+0b83 */ { 5, 0, 1, 0, 0 },
/* U+0b84 */ { 0, 0, 0, 0, 0 },
/* U+0b85 */ { 19, 0, 1, 0, 0 },
/* U+0b86 */ { 19, 0, 1, 0, 0 },
/* U+0b87 */ { 19, 0, 1, 0, 0 },
/* U+0b88 */ { 19, 0, 1, 0, 0 },
/* U+0b89 */ { 19, 0, 1, 0, 0 },
/* U+0b8a */ { 19, 0, 1, 0, 0 },
/* U+0b8b */ { 0, 0, 0, 0, 0 },
/* U+0b8c */ { 0, 0, 0, 0, 0 },
/* U+0b8d */ { 0, 0, 0, 0, 0 },
/* U+0b8e */ { 19, 0, 1, 0, 0 },
/* U+0b8f */ { 19, 0, 1, 0, 0 },
/* U+0b90 */ { 19, 0, 1, 0, 0 },
/* U+0b91 */ { 0, 0, 0, 0, 0 },
/* U+0b92 */ { 19, 0, 1, 0, 0 },
/* U+0b93 */ { 19, 0, 1, 0, 0 },
/* U+0b94 */ { 19, 0, 1, 0, "0B92 0BD7" },
/* U+0b95 */ { 19, 0, 1, 0, 0 },
/* U+0b96 */ { 0, 0, 0, 0, 0 },
/* U+0b97 */ { 0, 0, 0, 0, 0 },
/* U+0b98 */ { 0, 0, 0, 0, 0 },
/* U+0b99 */ { 19, 0, 1, 0, 0 },
/* U+0b9a */ { 19, 0, 1, 0, 0 },
/* U+0b9b */ { 0, 0, 0, 0, 0 },
/* U+0b9c */ { 19, 0, 1, 0, 0 },
/* U+0b9d */ { 0, 0, 0, 0, 0 },
/* U+0b9e */ { 19, 0, 1, 0, 0 },
/* U+0b9f */ { 19, 0, 1, 0, 0 },
/* U+0ba0 */ { 0, 0, 0, 0, 0 },
/* U+0ba1 */ { 0, 0, 0, 0, 0 },
/* U+0ba2 */ { 0, 0, 0, 0, 0 },
/* U+0ba3 */ { 19, 0, 1, 0, 0 },
/* U+0ba4 */ { 19, 0, 1, 0, 0 },
/* U+0ba5 */ { 0, 0, 0, 0, 0 },
/* U+0ba6 */ { 0, 0, 0, 0, 0 },
/* U+0ba7 */ { 0, 0, 0, 0, 0 },
/* U+0ba8 */ { 19, 0, 1, 0, 0 },
/* U+0ba9 */ { 19, 0, 1, 0, 0 },
/* U+0baa */ { 19, 0, 1, 0, 0 },
/* U+0bab */ { 0, 0, 0, 0, 0 },
/* U+0bac */ { 0, 0, 0, 0, 0 },
/* U+0bad */ { 0, 0, 0, 0, 0 },
/* U+0bae */ { 19, 0, 1, 0, 0 },
/* U+0baf */ { 19, 0, 1, 0, 0 },
/* U+0bb0 */ { 19, 0, 1, 0, 0 },
/* U+0bb1 */ { 19, 0, 1, 0, 0 },
/* U+0bb2 */ { 19, 0, 1, 0, 0 },
/* U+0bb3 */ { 19, 0, 1, 0, 0 },
/* U+0bb4 */ { 19, 0, 1, 0, 0 },
/* U+0bb5 */ { 19, 0, 1, 0, 0 },
/* U+0bb6 */ { 0, 0, 0, 0, 0 },
/* U+0bb7 */ { 19, 0, 1, 0, 0 },
/* U+0bb8 */ { 19, 0, 1, 0, 0 },
/* U+0bb9 */ { 19, 0, 1, 0, 0 },
/* U+0bba */ { 0, 0, 0, 0, 0 },
/* U+0bbb */ { 0, 0, 0, 0, 0 },
/* U+0bbc */ { 0, 0, 0, 0, 0 },
/* U+0bbd */ { 0, 0, 0, 0, 0 },
/* U+0bbe */ { 5, 0, 1, 0, 0 },
/* U+0bbf */ { 5, 0, 1, 0, 0 },
/* U+0bc0 */ { 4, 0, 14, 0, 0 },
/* U+0bc1 */ { 5, 0, 1, 0, 0 },
/* U+0bc2 */ { 5, 0, 1, 0, 0 },
/* U+0bc3 */ { 0, 0, 0, 0, 0 },
/* U+0bc4 */ { 0, 0, 0, 0, 0 },
/* U+0bc5 */ { 0, 0, 0, 0, 0 },
/* U+0bc6 */ { 5, 0, 1, 0, 0 },
/* U+0bc7 */ { 5, 0, 1, 0, 0 },
/* U+0bc8 */ { 5, 0, 1, 0, 0 },
/* U+0bc9 */ { 0, 0, 0, 0, 0 },
/* U+0bca */ { 5, 0, 1, 0, "0BC6 0BBE" },
/* U+0bcb */ { 5, 0, 1, 0, "0BC7 0BBE" },
/* U+0bcc */ { 5, 0, 1, 0, "0BC6 0BD7" },
/* U+0bcd */ { 4, 9, 14, 0, 0 },
/* U+0bce */ { 0, 0, 0, 0, 0 },
/* U+0bcf */ { 0, 0, 0, 0, 0 },
/* U+0bd0 */ { 0, 0, 0, 0, 0 },
/* U+0bd1 */ { 0, 0, 0, 0, 0 },
/* U+0bd2 */ { 0, 0, 0, 0, 0 },
/* U+0bd3 */ { 0, 0, 0, 0, 0 },
/* U+0bd4 */ { 0, 0, 0, 0, 0 },
/* U+0bd5 */ { 0, 0, 0, 0, 0 },
/* U+0bd6 */ { 0, 0, 0, 0, 0 },
/* U+0bd7 */ { 5, 0, 1, 0, 0 },
/* U+0bd8 */ { 0, 0, 0, 0, 0 },
/* U+0bd9 */ { 0, 0, 0, 0, 0 },
/* U+0bda */ { 0, 0, 0, 0, 0 },
/* U+0bdb */ { 0, 0, 0, 0, 0 },
/* U+0bdc */ { 0, 0, 0, 0, 0 },
/* U+0bdd */ { 0, 0, 0, 0, 0 },
/* U+0bde */ { 0, 0, 0, 0, 0 },
/* U+0bdf */ { 0, 0, 0, 0, 0 },
/* U+0be0 */ { 0, 0, 0, 0, 0 },
/* U+0be1 */ { 0, 0, 0, 0, 0 },
/* U+0be2 */ { 0, 0, 0, 0, 0 },
/* U+0be3 */ { 0, 0, 0, 0, 0 },
/* U+0be4 */ { 0, 0, 0, 0, 0 },
/* U+0be5 */ { 0, 0, 0, 0, 0 },
/* U+0be6 */ { 0, 0, 0, 0, 0 },
/* U+0be7 */ { 7, 0, 1, 0, 0 },
/* U+0be8 */ { 7, 0, 1, 0, 0 },
/* U+0be9 */ { 7, 0, 1, 0, 0 },
/* U+0bea */ { 7, 0, 1, 0, 0 },
/* U+0beb */ { 7, 0, 1, 0, 0 },
/* U+0bec */ { 7, 0, 1, 0, 0 },
/* U+0bed */ { 7, 0, 1, 0, 0 },
/* U+0bee */ { 7, 0, 1, 0, 0 },
/* U+0bef */ { 7, 0, 1, 0, 0 },
/* U+0bf0 */ { 9, 0, 1, 0, 0 },
/* U+0bf1 */ { 9, 0, 1, 0, 0 },
/* U+0bf2 */ { 9, 0, 1, 0, 0 },
/* U+0bf3 */ { 0, 0, 0, 0, 0 },
/* U+0bf4 */ { 0, 0, 0, 0, 0 },
/* U+0bf5 */ { 0, 0, 0, 0, 0 },
/* U+0bf6 */ { 0, 0, 0, 0, 0 },
/* U+0bf7 */ { 0, 0, 0, 0, 0 },
/* U+0bf8 */ { 0, 0, 0, 0, 0 },
/* U+0bf9 */ { 0, 0, 0, 0, 0 },
/* U+0bfa */ { 0, 0, 0, 0, 0 },
/* U+0bfb */ { 0, 0, 0, 0, 0 },
/* U+0bfc */ { 0, 0, 0, 0, 0 },
/* U+0bfd */ { 0, 0, 0, 0, 0 },
/* U+0bfe */ { 0, 0, 0, 0, 0 },
/* U+0bff */ { 0, 0, 0, 0, 0 },
/* U+0c00 */ { 0, 0, 0, 0, 0 },
/* U+0c01 */ { 5, 0, 1, 0, 0 },
/* U+0c02 */ { 5, 0, 1, 0, 0 },
/* U+0c03 */ { 5, 0, 1, 0, 0 },
/* U+0c04 */ { 0, 0, 0, 0, 0 },
/* U+0c05 */ { 19, 0, 1, 0, 0 },
/* U+0c06 */ { 19, 0, 1, 0, 0 },
/* U+0c07 */ { 19, 0, 1, 0, 0 },
/* U+0c08 */ { 19, 0, 1, 0, 0 },
/* U+0c09 */ { 19, 0, 1, 0, 0 },
/* U+0c0a */ { 19, 0, 1, 0, 0 },
/* U+0c0b */ { 19, 0, 1, 0, 0 },
/* U+0c0c */ { 19, 0, 1, 0, 0 },
/* U+0c0d */ { 0, 0, 0, 0, 0 },
/* U+0c0e */ { 19, 0, 1, 0, 0 },
/* U+0c0f */ { 19, 0, 1, 0, 0 },
/* U+0c10 */ { 19, 0, 1, 0, 0 },
/* U+0c11 */ { 0, 0, 0, 0, 0 },
/* U+0c12 */ { 19, 0, 1, 0, 0 },
/* U+0c13 */ { 19, 0, 1, 0, 0 },
/* U+0c14 */ { 19, 0, 1, 0, 0 },
/* U+0c15 */ { 19, 0, 1, 0, 0 },
/* U+0c16 */ { 19, 0, 1, 0, 0 },
/* U+0c17 */ { 19, 0, 1, 0, 0 },
/* U+0c18 */ { 19, 0, 1, 0, 0 },
/* U+0c19 */ { 19, 0, 1, 0, 0 },
/* U+0c1a */ { 19, 0, 1, 0, 0 },
/* U+0c1b */ { 19, 0, 1, 0, 0 },
/* U+0c1c */ { 19, 0, 1, 0, 0 },
/* U+0c1d */ { 19, 0, 1, 0, 0 },
/* U+0c1e */ { 19, 0, 1, 0, 0 },
/* U+0c1f */ { 19, 0, 1, 0, 0 },
/* U+0c20 */ { 19, 0, 1, 0, 0 },
/* U+0c21 */ { 19, 0, 1, 0, 0 },
/* U+0c22 */ { 19, 0, 1, 0, 0 },
/* U+0c23 */ { 19, 0, 1, 0, 0 },
/* U+0c24 */ { 19, 0, 1, 0, 0 },
/* U+0c25 */ { 19, 0, 1, 0, 0 },
/* U+0c26 */ { 19, 0, 1, 0, 0 },
/* U+0c27 */ { 19, 0, 1, 0, 0 },
/* U+0c28 */ { 19, 0, 1, 0, 0 },
/* U+0c29 */ { 0, 0, 0, 0, 0 },
/* U+0c2a */ { 19, 0, 1, 0, 0 },
/* U+0c2b */ { 19, 0, 1, 0, 0 },
/* U+0c2c */ { 19, 0, 1, 0, 0 },
/* U+0c2d */ { 19, 0, 1, 0, 0 },
/* U+0c2e */ { 19, 0, 1, 0, 0 },
/* U+0c2f */ { 19, 0, 1, 0, 0 },
/* U+0c30 */ { 19, 0, 1, 0, 0 },
/* U+0c31 */ { 19, 0, 1, 0, 0 },
/* U+0c32 */ { 19, 0, 1, 0, 0 },
/* U+0c33 */ { 19, 0, 1, 0, 0 },
/* U+0c34 */ { 0, 0, 0, 0, 0 },
/* U+0c35 */ { 19, 0, 1, 0, 0 },
/* U+0c36 */ { 19, 0, 1, 0, 0 },
/* U+0c37 */ { 19, 0, 1, 0, 0 },
/* U+0c38 */ { 19, 0, 1, 0, 0 },
/* U+0c39 */ { 19, 0, 1, 0, 0 },
/* U+0c3a */ { 0, 0, 0, 0, 0 },
/* U+0c3b */ { 0, 0, 0, 0, 0 },
/* U+0c3c */ { 0, 0, 0, 0, 0 },
/* U+0c3d */ { 0, 0, 0, 0, 0 },
/* U+0c3e */ { 4, 0, 14, 0, 0 },
/* U+0c3f */ { 4, 0, 14, 0, 0 },
/* U+0c40 */ { 4, 0, 14, 0, 0 },
/* U+0c41 */ { 5, 0, 1, 0, 0 },
/* U+0c42 */ { 5, 0, 1, 0, 0 },
/* U+0c43 */ { 5, 0, 1, 0, 0 },
/* U+0c44 */ { 5, 0, 1, 0, 0 },
/* U+0c45 */ { 0, 0, 0, 0, 0 },
/* U+0c46 */ { 4, 0, 14, 0, 0 },
/* U+0c47 */ { 4, 0, 14, 0, 0 },
/* U+0c48 */ { 4, 0, 14, 0, "0C46 0C56" },
/* U+0c49 */ { 0, 0, 0, 0, 0 },
/* U+0c4a */ { 4, 0, 14, 0, 0 },
/* U+0c4b */ { 4, 0, 14, 0, 0 },
/* U+0c4c */ { 4, 0, 14, 0, 0 },
/* U+0c4d */ { 4, 9, 14, 0, 0 },
/* U+0c4e */ { 0, 0, 0, 0, 0 },
/* U+0c4f */ { 0, 0, 0, 0, 0 },
/* U+0c50 */ { 0, 0, 0, 0, 0 },
/* U+0c51 */ { 0, 0, 0, 0, 0 },
/* U+0c52 */ { 0, 0, 0, 0, 0 },
/* U+0c53 */ { 0, 0, 0, 0, 0 },
/* U+0c54 */ { 0, 0, 0, 0, 0 },
/* U+0c55 */ { 4, 84, 14, 0, 0 },
/* U+0c56 */ { 4, 91, 14, 0, 0 },
/* U+0c57 */ { 0, 0, 0, 0, 0 },
/* U+0c58 */ { 0, 0, 0, 0, 0 },
/* U+0c59 */ { 0, 0, 0, 0, 0 },
/* U+0c5a */ { 0, 0, 0, 0, 0 },
/* U+0c5b */ { 0, 0, 0, 0, 0 },
/* U+0c5c */ { 0, 0, 0, 0, 0 },
/* U+0c5d */ { 0, 0, 0, 0, 0 },
/* U+0c5e */ { 0, 0, 0, 0, 0 },
/* U+0c5f */ { 0, 0, 0, 0, 0 },
/* U+0c60 */ { 19, 0, 1, 0, 0 },
/* U+0c61 */ { 19, 0, 1, 0, 0 },
/* U+0c62 */ { 0, 0, 0, 0, 0 },
/* U+0c63 */ { 0, 0, 0, 0, 0 },
/* U+0c64 */ { 0, 0, 0, 0, 0 },
/* U+0c65 */ { 0, 0, 0, 0, 0 },
/* U+0c66 */ { 7, 0, 1, 0, 0 },
/* U+0c67 */ { 7, 0, 1, 0, 0 },
/* U+0c68 */ { 7, 0, 1, 0, 0 },
/* U+0c69 */ { 7, 0, 1, 0, 0 },
/* U+0c6a */ { 7, 0, 1, 0, 0 },
/* U+0c6b */ { 7, 0, 1, 0, 0 },
/* U+0c6c */ { 7, 0, 1, 0, 0 },
/* U+0c6d */ { 7, 0, 1, 0, 0 },
/* U+0c6e */ { 7, 0, 1, 0, 0 },
/* U+0c6f */ { 7, 0, 1, 0, 0 },
/* U+0c70 */ { 0, 0, 0, 0, 0 },
/* U+0c71 */ { 0, 0, 0, 0, 0 },
/* U+0c72 */ { 0, 0, 0, 0, 0 },
/* U+0c73 */ { 0, 0, 0, 0, 0 },
/* U+0c74 */ { 0, 0, 0, 0, 0 },
/* U+0c75 */ { 0, 0, 0, 0, 0 },
/* U+0c76 */ { 0, 0, 0, 0, 0 },
/* U+0c77 */ { 0, 0, 0, 0, 0 },
/* U+0c78 */ { 0, 0, 0, 0, 0 },
/* U+0c79 */ { 0, 0, 0, 0, 0 },
/* U+0c7a */ { 0, 0, 0, 0, 0 },
/* U+0c7b */ { 0, 0, 0, 0, 0 },
/* U+0c7c */ { 0, 0, 0, 0, 0 },
/* U+0c7d */ { 0, 0, 0, 0, 0 },
/* U+0c7e */ { 0, 0, 0, 0, 0 },
/* U+0c7f */ { 0, 0, 0, 0, 0 },
/* U+0c80 */ { 0, 0, 0, 0, 0 },
/* U+0c81 */ { 0, 0, 0, 0, 0 },
/* U+0c82 */ { 5, 0, 1, 0, 0 },
/* U+0c83 */ { 5, 0, 1, 0, 0 },
/* U+0c84 */ { 0, 0, 0, 0, 0 },
/* U+0c85 */ { 19, 0, 1, 0, 0 },
/* U+0c86 */ { 19, 0, 1, 0, 0 },
/* U+0c87 */ { 19, 0, 1, 0, 0 },
/* U+0c88 */ { 19, 0, 1, 0, 0 },
/* U+0c89 */ { 19, 0, 1, 0, 0 },
/* U+0c8a */ { 19, 0, 1, 0, 0 },
/* U+0c8b */ { 19, 0, 1, 0, 0 },
/* U+0c8c */ { 19, 0, 1, 0, 0 },
/* U+0c8d */ { 0, 0, 0, 0, 0 },
/* U+0c8e */ { 19, 0, 1, 0, 0 },
/* U+0c8f */ { 19, 0, 1, 0, 0 },
/* U+0c90 */ { 19, 0, 1, 0, 0 },
/* U+0c91 */ { 0, 0, 0, 0, 0 },
/* U+0c92 */ { 19, 0, 1, 0, 0 },
/* U+0c93 */ { 19, 0, 1, 0, 0 },
/* U+0c94 */ { 19, 0, 1, 0, 0 },
/* U+0c95 */ { 19, 0, 1, 0, 0 },
/* U+0c96 */ { 19, 0, 1, 0, 0 },
/* U+0c97 */ { 19, 0, 1, 0, 0 },
/* U+0c98 */ { 19, 0, 1, 0, 0 },
/* U+0c99 */ { 19, 0, 1, 0, 0 },
/* U+0c9a */ { 19, 0, 1, 0, 0 },
/* U+0c9b */ { 19, 0, 1, 0, 0 },
/* U+0c9c */ { 19, 0, 1, 0, 0 },
/* U+0c9d */ { 19, 0, 1, 0, 0 },
/* U+0c9e */ { 19, 0, 1, 0, 0 },
/* U+0c9f */ { 19, 0, 1, 0, 0 },
/* U+0ca0 */ { 19, 0, 1, 0, 0 },
/* U+0ca1 */ { 19, 0, 1, 0, 0 },
/* U+0ca2 */ { 19, 0, 1, 0, 0 },
/* U+0ca3 */ { 19, 0, 1, 0, 0 },
/* U+0ca4 */ { 19, 0, 1, 0, 0 },
/* U+0ca5 */ { 19, 0, 1, 0, 0 },
/* U+0ca6 */ { 19, 0, 1, 0, 0 },
/* U+0ca7 */ { 19, 0, 1, 0, 0 },
/* U+0ca8 */ { 19, 0, 1, 0, 0 },
/* U+0ca9 */ { 0, 0, 0, 0, 0 },
/* U+0caa */ { 19, 0, 1, 0, 0 },
/* U+0cab */ { 19, 0, 1, 0, 0 },
/* U+0cac */ { 19, 0, 1, 0, 0 },
/* U+0cad */ { 19, 0, 1, 0, 0 },
/* U+0cae */ { 19, 0, 1, 0, 0 },
/* U+0caf */ { 19, 0, 1, 0, 0 },
/* U+0cb0 */ { 19, 0, 1, 0, 0 },
/* U+0cb1 */ { 19, 0, 1, 0, 0 },
/* U+0cb2 */ { 19, 0, 1, 0, 0 },
/* U+0cb3 */ { 19, 0, 1, 0, 0 },
/* U+0cb4 */ { 0, 0, 0, 0, 0 },
/* U+0cb5 */ { 19, 0, 1, 0, 0 },
/* U+0cb6 */ { 19, 0, 1, 0, 0 },
/* U+0cb7 */ { 19, 0, 1, 0, 0 },
/* U+0cb8 */ { 19, 0, 1, 0, 0 },
/* U+0cb9 */ { 19, 0, 1, 0, 0 },
/* U+0cba */ { 0, 0, 0, 0, 0 },
/* U+0cbb */ { 0, 0, 0, 0, 0 },
/* U+0cbc */ { 0, 0, 0, 0, 0 },
/* U+0cbd */ { 0, 0, 0, 0, 0 },
/* U+0cbe */ { 5, 0, 1, 0, 0 },
/* U+0cbf */ { 4, 0, 14, 0, 0 },
/* U+0cc0 */ { 5, 0, 1, 0, "0CBF 0CD5" },
/* U+0cc1 */ { 5, 0, 1, 0, 0 },
/* U+0cc2 */ { 5, 0, 1, 0, 0 },
/* U+0cc3 */ { 5, 0, 1, 0, 0 },
/* U+0cc4 */ { 5, 0, 1, 0, 0 },
/* U+0cc5 */ { 0, 0, 0, 0, 0 },
/* U+0cc6 */ { 4, 0, 14, 0, 0 },
/* U+0cc7 */ { 5, 0, 1, 0, "0CC6 0CD5" },
/* U+0cc8 */ { 5, 0, 1, 0, "0CC6 0CD6" },
/* U+0cc9 */ { 0, 0, 0, 0, 0 },
/* U+0cca */ { 5, 0, 1, 0, "0CC6 0CC2" },
/* U+0ccb */ { 5, 0, 1, 0, "0CCA 0CD5" },
/* U+0ccc */ { 4, 0, 14, 0, 0 },
/* U+0ccd */ { 4, 9, 14, 0, 0 },
/* U+0cce */ { 0, 0, 0, 0, 0 },
/* U+0ccf */ { 0, 0, 0, 0, 0 },
/* U+0cd0 */ { 0, 0, 0, 0, 0 },
/* U+0cd1 */ { 0, 0, 0, 0, 0 },
/* U+0cd2 */ { 0, 0, 0, 0, 0 },
/* U+0cd3 */ { 0, 0, 0, 0, 0 },
/* U+0cd4 */ { 0, 0, 0, 0, 0 },
/* U+0cd5 */ { 5, 0, 1, 0, 0 },
/* U+0cd6 */ { 5, 0, 1, 0, 0 },
/* U+0cd7 */ { 0, 0, 0, 0, 0 },
/* U+0cd8 */ { 0, 0, 0, 0, 0 },
/* U+0cd9 */ { 0, 0, 0, 0, 0 },
/* U+0cda */ { 0, 0, 0, 0, 0 },
/* U+0cdb */ { 0, 0, 0, 0, 0 },
/* U+0cdc */ { 0, 0, 0, 0, 0 },
/* U+0cdd */ { 0, 0, 0, 0, 0 },
/* U+0cde */ { 19, 0, 1, 0, 0 },
/* U+0cdf */ { 0, 0, 0, 0, 0 },
/* U+0ce0 */ { 19, 0, 1, 0, 0 },
/* U+0ce1 */ { 19, 0, 1, 0, 0 },
/* U+0ce2 */ { 0, 0, 0, 0, 0 },
/* U+0ce3 */ { 0, 0, 0, 0, 0 },
/* U+0ce4 */ { 0, 0, 0, 0, 0 },
/* U+0ce5 */ { 0, 0, 0, 0, 0 },
/* U+0ce6 */ { 7, 0, 1, 0, 0 },
/* U+0ce7 */ { 7, 0, 1, 0, 0 },
/* U+0ce8 */ { 7, 0, 1, 0, 0 },
/* U+0ce9 */ { 7, 0, 1, 0, 0 },
/* U+0cea */ { 7, 0, 1, 0, 0 },
/* U+0ceb */ { 7, 0, 1, 0, 0 },
/* U+0cec */ { 7, 0, 1, 0, 0 },
/* U+0ced */ { 7, 0, 1, 0, 0 },
/* U+0cee */ { 7, 0, 1, 0, 0 },
/* U+0cef */ { 7, 0, 1, 0, 0 },
/* U+0cf0 */ { 0, 0, 0, 0, 0 },
/* U+0cf1 */ { 0, 0, 0, 0, 0 },
/* U+0cf2 */ { 0, 0, 0, 0, 0 },
/* U+0cf3 */ { 0, 0, 0, 0, 0 },
/* U+0cf4 */ { 0, 0, 0, 0, 0 },
/* U+0cf5 */ { 0, 0, 0, 0, 0 },
/* U+0cf6 */ { 0, 0, 0, 0, 0 },
/* U+0cf7 */ { 0, 0, 0, 0, 0 },
/* U+0cf8 */ { 0, 0, 0, 0, 0 },
/* U+0cf9 */ { 0, 0, 0, 0, 0 },
/* U+0cfa */ { 0, 0, 0, 0, 0 },
/* U+0cfb */ { 0, 0, 0, 0, 0 },
/* U+0cfc */ { 0, 0, 0, 0, 0 },
/* U+0cfd */ { 0, 0, 0, 0, 0 },
/* U+0cfe */ { 0, 0, 0, 0, 0 },
/* U+0cff */ { 0, 0, 0, 0, 0 },
/* U+0d00 */ { 0, 0, 0, 0, 0 },
/* U+0d01 */ { 0, 0, 0, 0, 0 },
/* U+0d02 */ { 5, 0, 1, 0, 0 },
/* U+0d03 */ { 5, 0, 1, 0, 0 },
/* U+0d04 */ { 0, 0, 0, 0, 0 },
/* U+0d05 */ { 19, 0, 1, 0, 0 },
/* U+0d06 */ { 19, 0, 1, 0, 0 },
/* U+0d07 */ { 19, 0, 1, 0, 0 },
/* U+0d08 */ { 19, 0, 1, 0, 0 },
/* U+0d09 */ { 19, 0, 1, 0, 0 },
/* U+0d0a */ { 19, 0, 1, 0, 0 },
/* U+0d0b */ { 19, 0, 1, 0, 0 },
/* U+0d0c */ { 19, 0, 1, 0, 0 },
/* U+0d0d */ { 0, 0, 0, 0, 0 },
/* U+0d0e */ { 19, 0, 1, 0, 0 },
/* U+0d0f */ { 19, 0, 1, 0, 0 },
/* U+0d10 */ { 19, 0, 1, 0, 0 },
/* U+0d11 */ { 0, 0, 0, 0, 0 },
/* U+0d12 */ { 19, 0, 1, 0, 0 },
/* U+0d13 */ { 19, 0, 1, 0, 0 },
/* U+0d14 */ { 19, 0, 1, 0, 0 },
/* U+0d15 */ { 19, 0, 1, 0, 0 },
/* U+0d16 */ { 19, 0, 1, 0, 0 },
/* U+0d17 */ { 19, 0, 1, 0, 0 },
/* U+0d18 */ { 19, 0, 1, 0, 0 },
/* U+0d19 */ { 19, 0, 1, 0, 0 },
/* U+0d1a */ { 19, 0, 1, 0, 0 },
/* U+0d1b */ { 19, 0, 1, 0, 0 },
/* U+0d1c */ { 19, 0, 1, 0, 0 },
/* U+0d1d */ { 19, 0, 1, 0, 0 },
/* U+0d1e */ { 19, 0, 1, 0, 0 },
/* U+0d1f */ { 19, 0, 1, 0, 0 },
/* U+0d20 */ { 19, 0, 1, 0, 0 },
/* U+0d21 */ { 19, 0, 1, 0, 0 },
/* U+0d22 */ { 19, 0, 1, 0, 0 },
/* U+0d23 */ { 19, 0, 1, 0, 0 },
/* U+0d24 */ { 19, 0, 1, 0, 0 },
/* U+0d25 */ { 19, 0, 1, 0, 0 },
/* U+0d26 */ { 19, 0, 1, 0, 0 },
/* U+0d27 */ { 19, 0, 1, 0, 0 },
/* U+0d28 */ { 19, 0, 1, 0, 0 },
/* U+0d29 */ { 0, 0, 0, 0, 0 },
/* U+0d2a */ { 19, 0, 1, 0, 0 },
/* U+0d2b */ { 19, 0, 1, 0, 0 },
/* U+0d2c */ { 19, 0, 1, 0, 0 },
/* U+0d2d */ { 19, 0, 1, 0, 0 },
/* U+0d2e */ { 19, 0, 1, 0, 0 },
/* U+0d2f */ { 19, 0, 1, 0, 0 },
/* U+0d30 */ { 19, 0, 1, 0, 0 },
/* U+0d31 */ { 19, 0, 1, 0, 0 },
/* U+0d32 */ { 19, 0, 1, 0, 0 },
/* U+0d33 */ { 19, 0, 1, 0, 0 },
/* U+0d34 */ { 19, 0, 1, 0, 0 },
/* U+0d35 */ { 19, 0, 1, 0, 0 },
/* U+0d36 */ { 19, 0, 1, 0, 0 },
/* U+0d37 */ { 19, 0, 1, 0, 0 },
/* U+0d38 */ { 19, 0, 1, 0, 0 },
/* U+0d39 */ { 19, 0, 1, 0, 0 },
/* U+0d3a */ { 0, 0, 0, 0, 0 },
/* U+0d3b */ { 0, 0, 0, 0, 0 },
/* U+0d3c */ { 0, 0, 0, 0, 0 },
/* U+0d3d */ { 0, 0, 0, 0, 0 },
/* U+0d3e */ { 5, 0, 1, 0, 0 },
/* U+0d3f */ { 5, 0, 1, 0, 0 },
/* U+0d40 */ { 5, 0, 1, 0, 0 },
/* U+0d41 */ { 4, 0, 14, 0, 0 },
/* U+0d42 */ { 4, 0, 14, 0, 0 },
/* U+0d43 */ { 4, 0, 14, 0, 0 },
/* U+0d44 */ { 0, 0, 0, 0, 0 },
/* U+0d45 */ { 0, 0, 0, 0, 0 },
/* U+0d46 */ { 5, 0, 1, 0, 0 },
/* U+0d47 */ { 5, 0, 1, 0, 0 },
/* U+0d48 */ { 5, 0, 1, 0, 0 },
/* U+0d49 */ { 0, 0, 0, 0, 0 },
/* U+0d4a */ { 5, 0, 1, 0, "0D46 0D3E" },
/* U+0d4b */ { 5, 0, 1, 0, "0D47 0D3E" },
/* U+0d4c */ { 5, 0, 1, 0, "0D46 0D57" },
/* U+0d4d */ { 4, 9, 14, 0, 0 },
/* U+0d4e */ { 0, 0, 0, 0, 0 },
/* U+0d4f */ { 0, 0, 0, 0, 0 },
/* U+0d50 */ { 0, 0, 0, 0, 0 },
/* U+0d51 */ { 0, 0, 0, 0, 0 },
/* U+0d52 */ { 0, 0, 0, 0, 0 },
/* U+0d53 */ { 0, 0, 0, 0, 0 },
/* U+0d54 */ { 0, 0, 0, 0, 0 },
/* U+0d55 */ { 0, 0, 0, 0, 0 },
/* U+0d56 */ { 0, 0, 0, 0, 0 },
/* U+0d57 */ { 5, 0, 1, 0, 0 },
/* U+0d58 */ { 0, 0, 0, 0, 0 },
/* U+0d59 */ { 0, 0, 0, 0, 0 },
/* U+0d5a */ { 0, 0, 0, 0, 0 },
/* U+0d5b */ { 0, 0, 0, 0, 0 },
/* U+0d5c */ { 0, 0, 0, 0, 0 },
/* U+0d5d */ { 0, 0, 0, 0, 0 },
/* U+0d5e */ { 0, 0, 0, 0, 0 },
/* U+0d5f */ { 0, 0, 0, 0, 0 },
/* U+0d60 */ { 19, 0, 1, 0, 0 },
/* U+0d61 */ { 19, 0, 1, 0, 0 },
/* U+0d62 */ { 0, 0, 0, 0, 0 },
/* U+0d63 */ { 0, 0, 0, 0, 0 },
/* U+0d64 */ { 0, 0, 0, 0, 0 },
/* U+0d65 */ { 0, 0, 0, 0, 0 },
/* U+0d66 */ { 7, 0, 1, 0, 0 },
/* U+0d67 */ { 7, 0, 1, 0, 0 },
/* U+0d68 */ { 7, 0, 1, 0, 0 },
/* U+0d69 */ { 7, 0, 1, 0, 0 },
/* U+0d6a */ { 7, 0, 1, 0, 0 },
/* U+0d6b */ { 7, 0, 1, 0, 0 },
/* U+0d6c */ { 7, 0, 1, 0, 0 },
/* U+0d6d */ { 7, 0, 1, 0, 0 },
/* U+0d6e */ { 7, 0, 1, 0, 0 },
/* U+0d6f */ { 7, 0, 1, 0, 0 },
/* U+0d70 */ { 0, 0, 0, 0, 0 },
/* U+0d71 */ { 0, 0, 0, 0, 0 },
/* U+0d72 */ { 0, 0, 0, 0, 0 },
/* U+0d73 */ { 0, 0, 0, 0, 0 },
/* U+0d74 */ { 0, 0, 0, 0, 0 },
/* U+0d75 */ { 0, 0, 0, 0, 0 },
/* U+0d76 */ { 0, 0, 0, 0, 0 },
/* U+0d77 */ { 0, 0, 0, 0, 0 },
/* U+0d78 */ { 0, 0, 0, 0, 0 },
/* U+0d79 */ { 0, 0, 0, 0, 0 },
/* U+0d7a */ { 0, 0, 0, 0, 0 },
/* U+0d7b */ { 0, 0, 0, 0, 0 },
/* U+0d7c */ { 0, 0, 0, 0, 0 },
/* U+0d7d */ { 0, 0, 0, 0, 0 },
/* U+0d7e */ { 0, 0, 0, 0, 0 },
/* U+0d7f */ { 0, 0, 0, 0, 0 },
/* U+0d80 */ { 0, 0, 0, 0, 0 },
/* U+0d81 */ { 0, 0, 0, 0, 0 },
/* U+0d82 */ { 5, 0, 1, 0, 0 },
/* U+0d83 */ { 5, 0, 1, 0, 0 },
/* U+0d84 */ { 0, 0, 0, 0, 0 },
/* U+0d85 */ { 19, 0, 1, 0, 0 },
/* U+0d86 */ { 19, 0, 1, 0, 0 },
/* U+0d87 */ { 19, 0, 1, 0, 0 },
/* U+0d88 */ { 19, 0, 1, 0, 0 },
/* U+0d89 */ { 19, 0, 1, 0, 0 },
/* U+0d8a */ { 19, 0, 1, 0, 0 },
/* U+0d8b */ { 19, 0, 1, 0, 0 },
/* U+0d8c */ { 19, 0, 1, 0, 0 },
/* U+0d8d */ { 19, 0, 1, 0, 0 },
/* U+0d8e */ { 19, 0, 1, 0, 0 },
/* U+0d8f */ { 19, 0, 1, 0, 0 },
/* U+0d90 */ { 19, 0, 1, 0, 0 },
/* U+0d91 */ { 19, 0, 1, 0, 0 },
/* U+0d92 */ { 19, 0, 1, 0, 0 },
/* U+0d93 */ { 19, 0, 1, 0, 0 },
/* U+0d94 */ { 19, 0, 1, 0, 0 },
/* U+0d95 */ { 19, 0, 1, 0, 0 },
/* U+0d96 */ { 19, 0, 1, 0, 0 },
/* U+0d97 */ { 0, 0, 0, 0, 0 },
/* U+0d98 */ { 0, 0, 0, 0, 0 },
/* U+0d99 */ { 0, 0, 0, 0, 0 },
/* U+0d9a */ { 19, 0, 1, 0, 0 },
/* U+0d9b */ { 19, 0, 1, 0, 0 },
/* U+0d9c */ { 19, 0, 1, 0, 0 },
/* U+0d9d */ { 19, 0, 1, 0, 0 },
/* U+0d9e */ { 19, 0, 1, 0, 0 },
/* U+0d9f */ { 19, 0, 1, 0, 0 },
/* U+0da0 */ { 19, 0, 1, 0, 0 },
/* U+0da1 */ { 19, 0, 1, 0, 0 },
/* U+0da2 */ { 19, 0, 1, 0, 0 },
/* U+0da3 */ { 19, 0, 1, 0, 0 },
/* U+0da4 */ { 19, 0, 1, 0, 0 },
/* U+0da5 */ { 19, 0, 1, 0, 0 },
/* U+0da6 */ { 19, 0, 1, 0, 0 },
/* U+0da7 */ { 19, 0, 1, 0, 0 },
/* U+0da8 */ { 19, 0, 1, 0, 0 },
/* U+0da9 */ { 19, 0, 1, 0, 0 },
/* U+0daa */ { 19, 0, 1, 0, 0 },
/* U+0dab */ { 19, 0, 1, 0, 0 },
/* U+0dac */ { 19, 0, 1, 0, 0 },
/* U+0dad */ { 19, 0, 1, 0, 0 },
/* U+0dae */ { 19, 0, 1, 0, 0 },
/* U+0daf */ { 19, 0, 1, 0, 0 },
/* U+0db0 */ { 19, 0, 1, 0, 0 },
/* U+0db1 */ { 19, 0, 1, 0, 0 },
/* U+0db2 */ { 0, 0, 0, 0, 0 },
/* U+0db3 */ { 19, 0, 1, 0, 0 },
/* U+0db4 */ { 19, 0, 1, 0, 0 },
/* U+0db5 */ { 19, 0, 1, 0, 0 },
/* U+0db6 */ { 19, 0, 1, 0, 0 },
/* U+0db7 */ { 19, 0, 1, 0, 0 },
/* U+0db8 */ { 19, 0, 1, 0, 0 },
/* U+0db9 */ { 19, 0, 1, 0, 0 },
/* U+0dba */ { 19, 0, 1, 0, 0 },
/* U+0dbb */ { 19, 0, 1, 0, 0 },
/* U+0dbc */ { 0, 0, 0, 0, 0 },
/* U+0dbd */ { 19, 0, 1, 0, 0 },
/* U+0dbe */ { 0, 0, 0, 0, 0 },
/* U+0dbf */ { 0, 0, 0, 0, 0 },
/* U+0dc0 */ { 19, 0, 1, 0, 0 },
/* U+0dc1 */ { 19, 0, 1, 0, 0 },
/* U+0dc2 */ { 19, 0, 1, 0, 0 },
/* U+0dc3 */ { 19, 0, 1, 0, 0 },
/* U+0dc4 */ { 19, 0, 1, 0, 0 },
/* U+0dc5 */ { 19, 0, 1, 0, 0 },
/* U+0dc6 */ { 19, 0, 1, 0, 0 },
/* U+0dc7 */ { 0, 0, 0, 0, 0 },
/* U+0dc8 */ { 0, 0, 0, 0, 0 },
/* U+0dc9 */ { 0, 0, 0, 0, 0 },
/* U+0dca */ { 4, 9, 14, 0, 0 },
/* U+0dcb */ { 0, 0, 0, 0, 0 },
/* U+0dcc */ { 0, 0, 0, 0, 0 },
/* U+0dcd */ { 0, 0, 0, 0, 0 },
/* U+0dce */ { 0, 0, 0, 0, 0 },
/* U+0dcf */ { 5, 0, 1, 0, 0 },
/* U+0dd0 */ { 5, 0, 1, 0, 0 },
/* U+0dd1 */ { 5, 0, 1, 0, 0 },
/* U+0dd2 */ { 4, 0, 14, 0, 0 },
/* U+0dd3 */ { 4, 0, 14, 0, 0 },
/* U+0dd4 */ { 4, 0, 14, 0, 0 },
/* U+0dd5 */ { 0, 0, 0, 0, 0 },
/* U+0dd6 */ { 4, 0, 14, 0, 0 },
/* U+0dd7 */ { 0, 0, 0, 0, 0 },
/* U+0dd8 */ { 5, 0, 1, 0, 0 },
/* U+0dd9 */ { 5, 0, 1, 0, 0 },
/* U+0dda */ { 5, 0, 1, 0, "0DD9 0DCA" },
/* U+0ddb */ { 5, 0, 1, 0, 0 },
/* U+0ddc */ { 5, 0, 1, 0, "0DD9 0DCF" },
/* U+0ddd */ { 5, 0, 1, 0, "0DDC 0DCA" },
/* U+0dde */ { 5, 0, 1, 0, "0DD9 0DDF" },
/* U+0ddf */ { 5, 0, 1, 0, 0 },
/* U+0de0 */ { 0, 0, 0, 0, 0 },
/* U+0de1 */ { 0, 0, 0, 0, 0 },
/* U+0de2 */ { 0, 0, 0, 0, 0 },
/* U+0de3 */ { 0, 0, 0, 0, 0 },
/* U+0de4 */ { 0, 0, 0, 0, 0 },
/* U+0de5 */ { 0, 0, 0, 0, 0 },
/* U+0de6 */ { 0, 0, 0, 0, 0 },
/* U+0de7 */ { 0, 0, 0, 0, 0 },
/* U+0de8 */ { 0, 0, 0, 0, 0 },
/* U+0de9 */ { 0, 0, 0, 0, 0 },
/* U+0dea */ { 0, 0, 0, 0, 0 },
/* U+0deb */ { 0, 0, 0, 0, 0 },
/* U+0dec */ { 0, 0, 0, 0, 0 },
/* U+0ded */ { 0, 0, 0, 0, 0 },
/* U+0dee */ { 0, 0, 0, 0, 0 },
/* U+0def */ { 0, 0, 0, 0, 0 },
/* U+0df0 */ { 0, 0, 0, 0, 0 },
/* U+0df1 */ { 0, 0, 0, 0, 0 },
/* U+0df2 */ { 5, 0, 1, 0, 0 },
/* U+0df3 */ { 5, 0, 1, 0, 0 },
/* U+0df4 */ { 26, 0, 1, 0, 0 },
/* U+0df5 */ { 0, 0, 0, 0, 0 },
/* U+0df6 */ { 0, 0, 0, 0, 0 },
/* U+0df7 */ { 0, 0, 0, 0, 0 },
/* U+0df8 */ { 0, 0, 0, 0, 0 },
/* U+0df9 */ { 0, 0, 0, 0, 0 },
/* U+0dfa */ { 0, 0, 0, 0, 0 },
/* U+0dfb */ { 0, 0, 0, 0, 0 },
/* U+0dfc */ { 0, 0, 0, 0, 0 },
/* U+0dfd */ { 0, 0, 0, 0, 0 },
/* U+0dfe */ { 0, 0, 0, 0, 0 },
/* U+0dff */ { 0, 0, 0, 0, 0 },
/* U+0e00 */ { 0, 0, 0, 0, 0 },
/* U+0e01 */ { 19, 0, 1, 0, 0 },
/* U+0e02 */ { 19, 0, 1, 0, 0 },
/* U+0e03 */ { 19, 0, 1, 0, 0 },
/* U+0e04 */ { 19, 0, 1, 0, 0 },
/* U+0e05 */ { 19, 0, 1, 0, 0 },
/* U+0e06 */ { 19, 0, 1, 0, 0 },
/* U+0e07 */ { 19, 0, 1, 0, 0 },
/* U+0e08 */ { 19, 0, 1, 0, 0 },
/* U+0e09 */ { 19, 0, 1, 0, 0 },
/* U+0e0a */ { 19, 0, 1, 0, 0 },
/* U+0e0b */ { 19, 0, 1, 0, 0 },
/* U+0e0c */ { 19, 0, 1, 0, 0 },
/* U+0e0d */ { 19, 0, 1, 0, 0 },
/* U+0e0e */ { 19, 0, 1, 0, 0 },
/* U+0e0f */ { 19, 0, 1, 0, 0 },
/* U+0e10 */ { 19, 0, 1, 0, 0 },
/* U+0e11 */ { 19, 0, 1, 0, 0 },
/* U+0e12 */ { 19, 0, 1, 0, 0 },
/* U+0e13 */ { 19, 0, 1, 0, 0 },
/* U+0e14 */ { 19, 0, 1, 0, 0 },
/* U+0e15 */ { 19, 0, 1, 0, 0 },
/* U+0e16 */ { 19, 0, 1, 0, 0 },
/* U+0e17 */ { 19, 0, 1, 0, 0 },
/* U+0e18 */ { 19, 0, 1, 0, 0 },
/* U+0e19 */ { 19, 0, 1, 0, 0 },
/* U+0e1a */ { 19, 0, 1, 0, 0 },
/* U+0e1b */ { 19, 0, 1, 0, 0 },
/* U+0e1c */ { 19, 0, 1, 0, 0 },
/* U+0e1d */ { 19, 0, 1, 0, 0 },
/* U+0e1e */ { 19, 0, 1, 0, 0 },
/* U+0e1f */ { 19, 0, 1, 0, 0 },
/* U+0e20 */ { 19, 0, 1, 0, 0 },
/* U+0e21 */ { 19, 0, 1, 0, 0 },
/* U+0e22 */ { 19, 0, 1, 0, 0 },
/* U+0e23 */ { 19, 0, 1, 0, 0 },
/* U+0e24 */ { 19, 0, 1, 0, 0 },
/* U+0e25 */ { 19, 0, 1, 0, 0 },
/* U+0e26 */ { 19, 0, 1, 0, 0 },
/* U+0e27 */ { 19, 0, 1, 0, 0 },
/* U+0e28 */ { 19, 0, 1, 0, 0 },
/* U+0e29 */ { 19, 0, 1, 0, 0 },
/* U+0e2a */ { 19, 0, 1, 0, 0 },
/* U+0e2b */ { 19, 0, 1, 0, 0 },
/* U+0e2c */ { 19, 0, 1, 0, 0 },
/* U+0e2d */ { 19, 0, 1, 0, 0 },
/* U+0e2e */ { 19, 0, 1, 0, 0 },
/* U+0e2f */ { 19, 0, 1, 0, 0 },
/* U+0e30 */ { 19, 0, 1, 0, 0 },
/* U+0e31 */ { 4, 0, 14, 0, 0 },
/* U+0e32 */ { 19, 0, 1, 0, 0 },
/* U+0e33 */ { 19, 0, 1, 0, "<compat> 0E4D 0E32" },
/* U+0e34 */ { 4, 0, 14, 0, 0 },
/* U+0e35 */ { 4, 0, 14, 0, 0 },
/* U+0e36 */ { 4, 0, 14, 0, 0 },
/* U+0e37 */ { 4, 0, 14, 0, 0 },
/* U+0e38 */ { 4, 103, 14, 0, 0 },
/* U+0e39 */ { 4, 103, 14, 0, 0 },
/* U+0e3a */ { 4, 9, 14, 0, 0 },
/* U+0e3b */ { 0, 0, 0, 0, 0 },
/* U+0e3c */ { 0, 0, 0, 0, 0 },
/* U+0e3d */ { 0, 0, 0, 0, 0 },
/* U+0e3e */ { 0, 0, 0, 0, 0 },
/* U+0e3f */ { 28, 0, 11, 0, 0 },
/* U+0e40 */ { 19, 0, 1, 0, 0 },
/* U+0e41 */ { 19, 0, 1, 0, 0 },
/* U+0e42 */ { 19, 0, 1, 0, 0 },
/* U+0e43 */ { 19, 0, 1, 0, 0 },
/* U+0e44 */ { 19, 0, 1, 0, 0 },
/* U+0e45 */ { 19, 0, 1, 0, 0 },
/* U+0e46 */ { 18, 0, 1, 0, 0 },
/* U+0e47 */ { 4, 0, 14, 0, 0 },
/* U+0e48 */ { 4, 107, 14, 0, 0 },
/* U+0e49 */ { 4, 107, 14, 0, 0 },
/* U+0e4a */ { 4, 107, 14, 0, 0 },
/* U+0e4b */ { 4, 107, 14, 0, 0 },
/* U+0e4c */ { 4, 0, 14, 0, 0 },
/* U+0e4d */ { 4, 0, 14, 0, 0 },
/* U+0e4e */ { 4, 0, 14, 0, 0 },
/* U+0e4f */ { 26, 0, 1, 0, 0 },
/* U+0e50 */ { 7, 0, 1, 0, 0 },
/* U+0e51 */ { 7, 0, 1, 0, 0 },
/* U+0e52 */ { 7, 0, 1, 0, 0 },
/* U+0e53 */ { 7, 0, 1, 0, 0 },
/* U+0e54 */ { 7, 0, 1, 0, 0 },
/* U+0e55 */ { 7, 0, 1, 0, 0 },
/* U+0e56 */ { 7, 0, 1, 0, 0 },
/* U+0e57 */ { 7, 0, 1, 0, 0 },
/* U+0e58 */ { 7, 0, 1, 0, 0 },
/* U+0e59 */ { 7, 0, 1, 0, 0 },
/* U+0e5a */ { 26, 0, 1, 0, 0 },
/* U+0e5b */ { 26, 0, 1, 0, 0 },
/* U+0e5c */ { 0, 0, 0, 0, 0 },
/* U+0e5d */ { 0, 0, 0, 0, 0 },
/* U+0e5e */ { 0, 0, 0, 0, 0 },
/* U+0e5f */ { 0, 0, 0, 0, 0 },
/* U+0e60 */ { 0, 0, 0, 0, 0 },
/* U+0e61 */ { 0, 0, 0, 0, 0 },
/* U+0e62 */ { 0, 0, 0, 0, 0 },
/* U+0e63 */ { 0, 0, 0, 0, 0 },
/* U+0e64 */ { 0, 0, 0, 0, 0 },
/* U+0e65 */ { 0, 0, 0, 0, 0 },
/* U+0e66 */ { 0, 0, 0, 0, 0 },
/* U+0e67 */ { 0, 0, 0, 0, 0 },
/* U+0e68 */ { 0, 0, 0, 0, 0 },
/* U+0e69 */ { 0, 0, 0, 0, 0 },
/* U+0e6a */ { 0, 0, 0, 0, 0 },
/* U+0e6b */ { 0, 0, 0, 0, 0 },
/* U+0e6c */ { 0, 0, 0, 0, 0 },
/* U+0e6d */ { 0, 0, 0, 0, 0 },
/* U+0e6e */ { 0, 0, 0, 0, 0 },
/* U+0e6f */ { 0, 0, 0, 0, 0 },
/* U+0e70 */ { 0, 0, 0, 0, 0 },
/* U+0e71 */ { 0, 0, 0, 0, 0 },
/* U+0e72 */ { 0, 0, 0, 0, 0 },
/* U+0e73 */ { 0, 0, 0, 0, 0 },
/* U+0e74 */ { 0, 0, 0, 0, 0 },
/* U+0e75 */ { 0, 0, 0, 0, 0 },
/* U+0e76 */ { 0, 0, 0, 0, 0 },
/* U+0e77 */ { 0, 0, 0, 0, 0 },
/* U+0e78 */ { 0, 0, 0, 0, 0 },
/* U+0e79 */ { 0, 0, 0, 0, 0 },
/* U+0e7a */ { 0, 0, 0, 0, 0 },
/* U+0e7b */ { 0, 0, 0, 0, 0 },
/* U+0e7c */ { 0, 0, 0, 0, 0 },
/* U+0e7d */ { 0, 0, 0, 0, 0 },
/* U+0e7e */ { 0, 0, 0, 0, 0 },
/* U+0e7f */ { 0, 0, 0, 0, 0 },
/* U+0e80 */ { 0, 0, 0, 0, 0 },
/* U+0e81 */ { 19, 0, 1, 0, 0 },
/* U+0e82 */ { 19, 0, 1, 0, 0 },
/* U+0e83 */ { 0, 0, 0, 0, 0 },
/* U+0e84 */ { 19, 0, 1, 0, 0 },
/* U+0e85 */ { 0, 0, 0, 0, 0 },
/* U+0e86 */ { 0, 0, 0, 0, 0 },
/* U+0e87 */ { 19, 0, 1, 0, 0 },
/* U+0e88 */ { 19, 0, 1, 0, 0 },
/* U+0e89 */ { 0, 0, 0, 0, 0 },
/* U+0e8a */ { 19, 0, 1, 0, 0 },
/* U+0e8b */ { 0, 0, 0, 0, 0 },
/* U+0e8c */ { 0, 0, 0, 0, 0 },
/* U+0e8d */ { 19, 0, 1, 0, 0 },
/* U+0e8e */ { 0, 0, 0, 0, 0 },
/* U+0e8f */ { 0, 0, 0, 0, 0 },
/* U+0e90 */ { 0, 0, 0, 0, 0 },
/* U+0e91 */ { 0, 0, 0, 0, 0 },
/* U+0e92 */ { 0, 0, 0, 0, 0 },
/* U+0e93 */ { 0, 0, 0, 0, 0 },
/* U+0e94 */ { 19, 0, 1, 0, 0 },
/* U+0e95 */ { 19, 0, 1, 0, 0 },
/* U+0e96 */ { 19, 0, 1, 0, 0 },
/* U+0e97 */ { 19, 0, 1, 0, 0 },
/* U+0e98 */ { 0, 0, 0, 0, 0 },
/* U+0e99 */ { 19, 0, 1, 0, 0 },
/* U+0e9a */ { 19, 0, 1, 0, 0 },
/* U+0e9b */ { 19, 0, 1, 0, 0 },
/* U+0e9c */ { 19, 0, 1, 0, 0 },
/* U+0e9d */ { 19, 0, 1, 0, 0 },
/* U+0e9e */ { 19, 0, 1, 0, 0 },
/* U+0e9f */ { 19, 0, 1, 0, 0 },
/* U+0ea0 */ { 0, 0, 0, 0, 0 },
/* U+0ea1 */ { 19, 0, 1, 0, 0 },
/* U+0ea2 */ { 19, 0, 1, 0, 0 },
/* U+0ea3 */ { 19, 0, 1, 0, 0 },
/* U+0ea4 */ { 0, 0, 0, 0, 0 },
/* U+0ea5 */ { 19, 0, 1, 0, 0 },
/* U+0ea6 */ { 0, 0, 0, 0, 0 },
/* U+0ea7 */ { 19, 0, 1, 0, 0 },
/* U+0ea8 */ { 0, 0, 0, 0, 0 },
/* U+0ea9 */ { 0, 0, 0, 0, 0 },
/* U+0eaa */ { 19, 0, 1, 0, 0 },
/* U+0eab */ { 19, 0, 1, 0, 0 },
/* U+0eac */ { 0, 0, 0, 0, 0 },
/* U+0ead */ { 19, 0, 1, 0, 0 },
/* U+0eae */ { 19, 0, 1, 0, 0 },
/* U+0eaf */ { 19, 0, 1, 0, 0 },
/* U+0eb0 */ { 19, 0, 1, 0, 0 },
/* U+0eb1 */ { 4, 0, 14, 0, 0 },
/* U+0eb2 */ { 19, 0, 1, 0, 0 },
/* U+0eb3 */ { 19, 0, 1, 0, "<compat> 0ECD 0EB2" },
/* U+0eb4 */ { 4, 0, 14, 0, 0 },
/* U+0eb5 */ { 4, 0, 14, 0, 0 },
/* U+0eb6 */ { 4, 0, 14, 0, 0 },
/* U+0eb7 */ { 4, 0, 14, 0, 0 },
/* U+0eb8 */ { 4, 118, 14, 0, 0 },
/* U+0eb9 */ { 4, 118, 14, 0, 0 },
/* U+0eba */ { 0, 0, 0, 0, 0 },
/* U+0ebb */ { 4, 0, 14, 0, 0 },
/* U+0ebc */ { 4, 0, 14, 0, 0 },
/* U+0ebd */ { 19, 0, 1, 0, 0 },
/* U+0ebe */ { 0, 0, 0, 0, 0 },
/* U+0ebf */ { 0, 0, 0, 0, 0 },
/* U+0ec0 */ { 19, 0, 1, 0, 0 },
/* U+0ec1 */ { 19, 0, 1, 0, 0 },
/* U+0ec2 */ { 19, 0, 1, 0, 0 },
/* U+0ec3 */ { 19, 0, 1, 0, 0 },
/* U+0ec4 */ { 19, 0, 1, 0, 0 },
/* U+0ec5 */ { 0, 0, 0, 0, 0 },
/* U+0ec6 */ { 18, 0, 1, 0, 0 },
/* U+0ec7 */ { 0, 0, 0, 0, 0 },
/* U+0ec8 */ { 4, 122, 14, 0, 0 },
/* U+0ec9 */ { 4, 122, 14, 0, 0 },
/* U+0eca */ { 4, 122, 14, 0, 0 },
/* U+0ecb */ { 4, 122, 14, 0, 0 },
/* U+0ecc */ { 4, 0, 14, 0, 0 },
/* U+0ecd */ { 4, 0, 14, 0, 0 },
/* U+0ece */ { 0, 0, 0, 0, 0 },
/* U+0ecf */ { 0, 0, 0, 0, 0 },
/* U+0ed0 */ { 7, 0, 1, 0, 0 },
/* U+0ed1 */ { 7, 0, 1, 0, 0 },
/* U+0ed2 */ { 7, 0, 1, 0, 0 },
/* U+0ed3 */ { 7, 0, 1, 0, 0 },
/* U+0ed4 */ { 7, 0, 1, 0, 0 },
/* U+0ed5 */ { 7, 0, 1, 0, 0 },
/* U+0ed6 */ { 7, 0, 1, 0, 0 },
/* U+0ed7 */ { 7, 0, 1, 0, 0 },
/* U+0ed8 */ { 7, 0, 1, 0, 0 },
/* U+0ed9 */ { 7, 0, 1, 0, 0 },
/* U+0eda */ { 0, 0, 0, 0, 0 },
/* U+0edb */ { 0, 0, 0, 0, 0 },
/* U+0edc */ { 19, 0, 1, 0, "<compat> 0EAB 0E99" },
/* U+0edd */ { 19, 0, 1, 0, "<compat> 0EAB 0EA1" },
/* U+0ede */ { 0, 0, 0, 0, 0 },
/* U+0edf */ { 0, 0, 0, 0, 0 },
/* U+0ee0 */ { 0, 0, 0, 0, 0 },
/* U+0ee1 */ { 0, 0, 0, 0, 0 },
/* U+0ee2 */ { 0, 0, 0, 0, 0 },
/* U+0ee3 */ { 0, 0, 0, 0, 0 },
/* U+0ee4 */ { 0, 0, 0, 0, 0 },
/* U+0ee5 */ { 0, 0, 0, 0, 0 },
/* U+0ee6 */ { 0, 0, 0, 0, 0 },
/* U+0ee7 */ { 0, 0, 0, 0, 0 },
/* U+0ee8 */ { 0, 0, 0, 0, 0 },
/* U+0ee9 */ { 0, 0, 0, 0, 0 },
/* U+0eea */ { 0, 0, 0, 0, 0 },
/* U+0eeb */ { 0, 0, 0, 0, 0 },
/* U+0eec */ { 0, 0, 0, 0, 0 },
/* U+0eed */ { 0, 0, 0, 0, 0 },
/* U+0eee */ { 0, 0, 0, 0, 0 },
/* U+0eef */ { 0, 0, 0, 0, 0 },
/* U+0ef0 */ { 0, 0, 0, 0, 0 },
/* U+0ef1 */ { 0, 0, 0, 0, 0 },
/* U+0ef2 */ { 0, 0, 0, 0, 0 },
/* U+0ef3 */ { 0, 0, 0, 0, 0 },
/* U+0ef4 */ { 0, 0, 0, 0, 0 },
/* U+0ef5 */ { 0, 0, 0, 0, 0 },
/* U+0ef6 */ { 0, 0, 0, 0, 0 },
/* U+0ef7 */ { 0, 0, 0, 0, 0 },
/* U+0ef8 */ { 0, 0, 0, 0, 0 },
/* U+0ef9 */ { 0, 0, 0, 0, 0 },
/* U+0efa */ { 0, 0, 0, 0, 0 },
/* U+0efb */ { 0, 0, 0, 0, 0 },
/* U+0efc */ { 0, 0, 0, 0, 0 },
/* U+0efd */ { 0, 0, 0, 0, 0 },
/* U+0efe */ { 0, 0, 0, 0, 0 },
/* U+0eff */ { 0, 0, 0, 0, 0 },
/* U+0f00 */ { 19, 0, 1, 0, 0 },
/* U+0f01 */ { 30, 0, 1, 0, 0 },
/* U+0f02 */ { 30, 0, 1, 0, 0 },
/* U+0f03 */ { 30, 0, 1, 0, 0 },
/* U+0f04 */ { 26, 0, 1, 0, 0 },
/* U+0f05 */ { 26, 0, 1, 0, 0 },
/* U+0f06 */ { 26, 0, 1, 0, 0 },
/* U+0f07 */ { 26, 0, 1, 0, 0 },
/* U+0f08 */ { 26, 0, 1, 0, 0 },
/* U+0f09 */ { 26, 0, 1, 0, 0 },
/* U+0f0a */ { 26, 0, 1, 0, 0 },
/* U+0f0b */ { 26, 0, 1, 0, 0 },
/* U+0f0c */ { 26, 0, 1, 0, "<noBreak> 0F0B" },
/* U+0f0d */ { 26, 0, 1, 0, 0 },
/* U+0f0e */ { 26, 0, 1, 0, 0 },
/* U+0f0f */ { 26, 0, 1, 0, 0 },
/* U+0f10 */ { 26, 0, 1, 0, 0 },
/* U+0f11 */ { 26, 0, 1, 0, 0 },
/* U+0f12 */ { 26, 0, 1, 0, 0 },
/* U+0f13 */ { 30, 0, 1, 0, 0 },
/* U+0f14 */ { 30, 0, 1, 0, 0 },
/* U+0f15 */ { 30, 0, 1, 0, 0 },
/* U+0f16 */ { 30, 0, 1, 0, 0 },
/* U+0f17 */ { 30, 0, 1, 0, 0 },
/* U+0f18 */ { 4, 220, 14, 0, 0 },
/* U+0f19 */ { 4, 220, 14, 0, 0 },
/* U+0f1a */ { 30, 0, 1, 0, 0 },
/* U+0f1b */ { 30, 0, 1, 0, 0 },
/* U+0f1c */ { 30, 0, 1, 0, 0 },
/* U+0f1d */ { 30, 0, 1, 0, 0 },
/* U+0f1e */ { 30, 0, 1, 0, 0 },
/* U+0f1f */ { 30, 0, 1, 0, 0 },
/* U+0f20 */ { 7, 0, 1, 0, 0 },
/* U+0f21 */ { 7, 0, 1, 0, 0 },
/* U+0f22 */ { 7, 0, 1, 0, 0 },
/* U+0f23 */ { 7, 0, 1, 0, 0 },
/* U+0f24 */ { 7, 0, 1, 0, 0 },
/* U+0f25 */ { 7, 0, 1, 0, 0 },
/* U+0f26 */ { 7, 0, 1, 0, 0 },
/* U+0f27 */ { 7, 0, 1, 0, 0 },
/* U+0f28 */ { 7, 0, 1, 0, 0 },
/* U+0f29 */ { 7, 0, 1, 0, 0 },
/* U+0f2a */ { 9, 0, 1, 0, 0 },
/* U+0f2b */ { 9, 0, 1, 0, 0 },
/* U+0f2c */ { 9, 0, 1, 0, 0 },
/* U+0f2d */ { 9, 0, 1, 0, 0 },
/* U+0f2e */ { 9, 0, 1, 0, 0 },
/* U+0f2f */ { 9, 0, 1, 0, 0 },
/* U+0f30 */ { 9, 0, 1, 0, 0 },
/* U+0f31 */ { 9, 0, 1, 0, 0 },
/* U+0f32 */ { 9, 0, 1, 0, 0 },
/* U+0f33 */ { 9, 0, 1, 0, 0 },
/* U+0f34 */ { 30, 0, 1, 0, 0 },
/* U+0f35 */ { 4, 220, 14, 0, 0 },
/* U+0f36 */ { 30, 0, 1, 0, 0 },
/* U+0f37 */ { 4, 220, 14, 0, 0 },
/* U+0f38 */ { 30, 0, 1, 0, 0 },
/* U+0f39 */ { 4, 216, 14, 0, 0 },
/* U+0f3a */ { 22, 0, 19, 0, 0 },
/* U+0f3b */ { 23, 0, 19, 0, 0 },
/* U+0f3c */ { 22, 0, 19, 0, 0 },
/* U+0f3d */ { 23, 0, 19, 0, 0 },
/* U+0f3e */ { 5, 0, 1, 0, 0 },
/* U+0f3f */ { 5, 0, 1, 0, 0 },
/* U+0f40 */ { 19, 0, 1, 0, 0 },
/* U+0f41 */ { 19, 0, 1, 0, 0 },
/* U+0f42 */ { 19, 0, 1, 0, 0 },
/* U+0f43 */ { 19, 0, 1, 0, "0F42 0FB7" },
/* U+0f44 */ { 19, 0, 1, 0, 0 },
/* U+0f45 */ { 19, 0, 1, 0, 0 },
/* U+0f46 */ { 19, 0, 1, 0, 0 },
/* U+0f47 */ { 19, 0, 1, 0, 0 },
/* U+0f48 */ { 0, 0, 0, 0, 0 },
/* U+0f49 */ { 19, 0, 1, 0, 0 },
/* U+0f4a */ { 19, 0, 1, 0, 0 },
/* U+0f4b */ { 19, 0, 1, 0, 0 },
/* U+0f4c */ { 19, 0, 1, 0, 0 },
/* U+0f4d */ { 19, 0, 1, 0, "0F4C 0FB7" },
/* U+0f4e */ { 19, 0, 1, 0, 0 },
/* U+0f4f */ { 19, 0, 1, 0, 0 },
/* U+0f50 */ { 19, 0, 1, 0, 0 },
/* U+0f51 */ { 19, 0, 1, 0, 0 },
/* U+0f52 */ { 19, 0, 1, 0, "0F51 0FB7" },
/* U+0f53 */ { 19, 0, 1, 0, 0 },
/* U+0f54 */ { 19, 0, 1, 0, 0 },
/* U+0f55 */ { 19, 0, 1, 0, 0 },
/* U+0f56 */ { 19, 0, 1, 0, 0 },
/* U+0f57 */ { 19, 0, 1, 0, "0F56 0FB7" },
/* U+0f58 */ { 19, 0, 1, 0, 0 },
/* U+0f59 */ { 19, 0, 1, 0, 0 },
/* U+0f5a */ { 19, 0, 1, 0, 0 },
/* U+0f5b */ { 19, 0, 1, 0, 0 },
/* U+0f5c */ { 19, 0, 1, 0, "0F5B 0FB7" },
/* U+0f5d */ { 19, 0, 1, 0, 0 },
/* U+0f5e */ { 19, 0, 1, 0, 0 },
/* U+0f5f */ { 19, 0, 1, 0, 0 },
/* U+0f60 */ { 19, 0, 1, 0, 0 },
/* U+0f61 */ { 19, 0, 1, 0, 0 },
/* U+0f62 */ { 19, 0, 1, 0, 0 },
/* U+0f63 */ { 19, 0, 1, 0, 0 },
/* U+0f64 */ { 19, 0, 1, 0, 0 },
/* U+0f65 */ { 19, 0, 1, 0, 0 },
/* U+0f66 */ { 19, 0, 1, 0, 0 },
/* U+0f67 */ { 19, 0, 1, 0, 0 },
/* U+0f68 */ { 19, 0, 1, 0, 0 },
/* U+0f69 */ { 19, 0, 1, 0, "0F40 0FB5" },
/* U+0f6a */ { 19, 0, 1, 0, 0 },
/* U+0f6b */ { 0, 0, 0, 0, 0 },
/* U+0f6c */ { 0, 0, 0, 0, 0 },
/* U+0f6d */ { 0, 0, 0, 0, 0 },
/* U+0f6e */ { 0, 0, 0, 0, 0 },
/* U+0f6f */ { 0, 0, 0, 0, 0 },
/* U+0f70 */ { 0, 0, 0, 0, 0 },
/* U+0f71 */ { 4, 129, 14, 0, 0 },
/* U+0f72 */ { 4, 130, 14, 0, 0 },
/* U+0f73 */ { 4, 0, 14, 0, "0F71 0F72" },
/* U+0f74 */ { 4, 132, 14, 0, 0 },
/* U+0f75 */ { 4, 0, 14, 0, "0F71 0F74" },
/* U+0f76 */ { 4, 0, 14, 0, "0FB2 0F80" },
/* U+0f77 */ { 4, 0, 14, 0, "<compat> 0FB2 0F81" },
/* U+0f78 */ { 4, 0, 14, 0, "0FB3 0F80" },
/* U+0f79 */ { 4, 0, 14, 0, "<compat> 0FB3 0F81" },
/* U+0f7a */ { 4, 130, 14, 0, 0 },
/* U+0f7b */ { 4, 130, 14, 0, 0 },
/* U+0f7c */ { 4, 130, 14, 0, 0 },
/* U+0f7d */ { 4, 130, 14, 0, 0 },
/* U+0f7e */ { 4, 0, 14, 0, 0 },
/* U+0f7f */ { 5, 0, 1, 0, 0 },
/* U+0f80 */ { 4, 130, 14, 0, 0 },
/* U+0f81 */ { 4, 0, 14, 0, "0F71 0F80" },
/* U+0f82 */ { 4, 230, 14, 0, 0 },
/* U+0f83 */ { 4, 230, 14, 0, 0 },
/* U+0f84 */ { 4, 9, 14, 0, 0 },
/* U+0f85 */ { 26, 0, 1, 0, 0 },
/* U+0f86 */ { 4, 230, 14, 0, 0 },
/* U+0f87 */ { 4, 230, 14, 0, 0 },
/* U+0f88 */ { 19, 0, 1, 0, 0 },
/* U+0f89 */ { 19, 0, 1, 0, 0 },
/* U+0f8a */ { 19, 0, 1, 0, 0 },
/* U+0f8b */ { 19, 0, 1, 0, 0 },
/* U+0f8c */ { 0, 0, 0, 0, 0 },
/* U+0f8d */ { 0, 0, 0, 0, 0 },
/* U+0f8e */ { 0, 0, 0, 0, 0 },
/* U+0f8f */ { 0, 0, 0, 0, 0 },
/* U+0f90 */ { 4, 0, 14, 0, 0 },
/* U+0f91 */ { 4, 0, 14, 0, 0 },
/* U+0f92 */ { 4, 0, 14, 0, 0 },
/* U+0f93 */ { 4, 0, 14, 0, "0F92 0FB7" },
/* U+0f94 */ { 4, 0, 14, 0, 0 },
/* U+0f95 */ { 4, 0, 14, 0, 0 },
/* U+0f96 */ { 4, 0, 14, 0, 0 },
/* U+0f97 */ { 4, 0, 14, 0, 0 },
/* U+0f98 */ { 0, 0, 0, 0, 0 },
/* U+0f99 */ { 4, 0, 14, 0, 0 },
/* U+0f9a */ { 4, 0, 14, 0, 0 },
/* U+0f9b */ { 4, 0, 14, 0, 0 },
/* U+0f9c */ { 4, 0, 14, 0, 0 },
/* U+0f9d */ { 4, 0, 14, 0, "0F9C 0FB7" },
/* U+0f9e */ { 4, 0, 14, 0, 0 },
/* U+0f9f */ { 4, 0, 14, 0, 0 },
/* U+0fa0 */ { 4, 0, 14, 0, 0 },
/* U+0fa1 */ { 4, 0, 14, 0, 0 },
/* U+0fa2 */ { 4, 0, 14, 0, "0FA1 0FB7" },
/* U+0fa3 */ { 4, 0, 14, 0, 0 },
/* U+0fa4 */ { 4, 0, 14, 0, 0 },
/* U+0fa5 */ { 4, 0, 14, 0, 0 },
/* U+0fa6 */ { 4, 0, 14, 0, 0 },
/* U+0fa7 */ { 4, 0, 14, 0, "0FA6 0FB7" },
/* U+0fa8 */ { 4, 0, 14, 0, 0 },
/* U+0fa9 */ { 4, 0, 14, 0, 0 },
/* U+0faa */ { 4, 0, 14, 0, 0 },
/* U+0fab */ { 4, 0, 14, 0, 0 },
/* U+0fac */ { 4, 0, 14, 0, "0FAB 0FB7" },
/* U+0fad */ { 4, 0, 14, 0, 0 },
/* U+0fae */ { 4, 0, 14, 0, 0 },
/* U+0faf */ { 4, 0, 14, 0, 0 },
/* U+0fb0 */ { 4, 0, 14, 0, 0 },
/* U+0fb1 */ { 4, 0, 14, 0, 0 },
/* U+0fb2 */ { 4, 0, 14, 0, 0 },
/* U+0fb3 */ { 4, 0, 14, 0, 0 },
/* U+0fb4 */ { 4, 0, 14, 0, 0 },
/* U+0fb5 */ { 4, 0, 14, 0, 0 },
/* U+0fb6 */ { 4, 0, 14, 0, 0 },
/* U+0fb7 */ { 4, 0, 14, 0, 0 },
/* U+0fb8 */ { 4, 0, 14, 0, 0 },
/* U+0fb9 */ { 4, 0, 14, 0, "0F90 0FB5" },
/* U+0fba */ { 4, 0, 14, 0, 0 },
/* U+0fbb */ { 4, 0, 14, 0, 0 },
/* U+0fbc */ { 4, 0, 14, 0, 0 },
/* U+0fbd */ { 0, 0, 0, 0, 0 },
/* U+0fbe */ { 30, 0, 1, 0, 0 },
/* U+0fbf */ { 30, 0, 1, 0, 0 },
/* U+0fc0 */ { 30, 0, 1, 0, 0 },
/* U+0fc1 */ { 30, 0, 1, 0, 0 },
/* U+0fc2 */ { 30, 0, 1, 0, 0 },
/* U+0fc3 */ { 30, 0, 1, 0, 0 },
/* U+0fc4 */ { 30, 0, 1, 0, 0 },
/* U+0fc5 */ { 30, 0, 1, 0, 0 },
/* U+0fc6 */ { 4, 220, 14, 0, 0 },
/* U+0fc7 */ { 30, 0, 1, 0, 0 },
/* U+0fc8 */ { 30, 0, 1, 0, 0 },
/* U+0fc9 */ { 30, 0, 1, 0, 0 },
/* U+0fca */ { 30, 0, 1, 0, 0 },
/* U+0fcb */ { 30, 0, 1, 0, 0 },
/* U+0fcc */ { 30, 0, 1, 0, 0 },
/* U+0fcd */ { 0, 0, 0, 0, 0 },
/* U+0fce */ { 0, 0, 0, 0, 0 },
/* U+0fcf */ { 30, 0, 1, 0, 0 },
/* U+0fd0 */ { 0, 0, 0, 0, 0 },
/* U+0fd1 */ { 0, 0, 0, 0, 0 },
/* U+0fd2 */ { 0, 0, 0, 0, 0 },
/* U+0fd3 */ { 0, 0, 0, 0, 0 },
/* U+0fd4 */ { 0, 0, 0, 0, 0 },
/* U+0fd5 */ { 0, 0, 0, 0, 0 },
/* U+0fd6 */ { 0, 0, 0, 0, 0 },
/* U+0fd7 */ { 0, 0, 0, 0, 0 },
/* U+0fd8 */ { 0, 0, 0, 0, 0 },
/* U+0fd9 */ { 0, 0, 0, 0, 0 },
/* U+0fda */ { 0, 0, 0, 0, 0 },
/* U+0fdb */ { 0, 0, 0, 0, 0 },
/* U+0fdc */ { 0, 0, 0, 0, 0 },
/* U+0fdd */ { 0, 0, 0, 0, 0 },
/* U+0fde */ { 0, 0, 0, 0, 0 },
/* U+0fdf */ { 0, 0, 0, 0, 0 },
/* U+0fe0 */ { 0, 0, 0, 0, 0 },
/* U+0fe1 */ { 0, 0, 0, 0, 0 },
/* U+0fe2 */ { 0, 0, 0, 0, 0 },
/* U+0fe3 */ { 0, 0, 0, 0, 0 },
/* U+0fe4 */ { 0, 0, 0, 0, 0 },
/* U+0fe5 */ { 0, 0, 0, 0, 0 },
/* U+0fe6 */ { 0, 0, 0, 0, 0 },
/* U+0fe7 */ { 0, 0, 0, 0, 0 },
/* U+0fe8 */ { 0, 0, 0, 0, 0 },
/* U+0fe9 */ { 0, 0, 0, 0, 0 },
/* U+0fea */ { 0, 0, 0, 0, 0 },
/* U+0feb */ { 0, 0, 0, 0, 0 },
/* U+0fec */ { 0, 0, 0, 0, 0 },
/* U+0fed */ { 0, 0, 0, 0, 0 },
/* U+0fee */ { 0, 0, 0, 0, 0 },
/* U+0fef */ { 0, 0, 0, 0, 0 },
/* U+0ff0 */ { 0, 0, 0, 0, 0 },
/* U+0ff1 */ { 0, 0, 0, 0, 0 },
/* U+0ff2 */ { 0, 0, 0, 0, 0 },
/* U+0ff3 */ { 0, 0, 0, 0, 0 },
/* U+0ff4 */ { 0, 0, 0, 0, 0 },
/* U+0ff5 */ { 0, 0, 0, 0, 0 },
/* U+0ff6 */ { 0, 0, 0, 0, 0 },
/* U+0ff7 */ { 0, 0, 0, 0, 0 },
/* U+0ff8 */ { 0, 0, 0, 0, 0 },
/* U+0ff9 */ { 0, 0, 0, 0, 0 },
/* U+0ffa */ { 0, 0, 0, 0, 0 },
/* U+0ffb */ { 0, 0, 0, 0, 0 },
/* U+0ffc */ { 0, 0, 0, 0, 0 },
/* U+0ffd */ { 0, 0, 0, 0, 0 },
/* U+0ffe */ { 0, 0, 0, 0, 0 },
/* U+0fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_1[4096] = {
    
/* U+1000 */ { 19, 0, 1, 0, 0 },
/* U+1001 */ { 19, 0, 1, 0, 0 },
/* U+1002 */ { 19, 0, 1, 0, 0 },
/* U+1003 */ { 19, 0, 1, 0, 0 },
/* U+1004 */ { 19, 0, 1, 0, 0 },
/* U+1005 */ { 19, 0, 1, 0, 0 },
/* U+1006 */ { 19, 0, 1, 0, 0 },
/* U+1007 */ { 19, 0, 1, 0, 0 },
/* U+1008 */ { 19, 0, 1, 0, 0 },
/* U+1009 */ { 19, 0, 1, 0, 0 },
/* U+100a */ { 19, 0, 1, 0, 0 },
/* U+100b */ { 19, 0, 1, 0, 0 },
/* U+100c */ { 19, 0, 1, 0, 0 },
/* U+100d */ { 19, 0, 1, 0, 0 },
/* U+100e */ { 19, 0, 1, 0, 0 },
/* U+100f */ { 19, 0, 1, 0, 0 },
/* U+1010 */ { 19, 0, 1, 0, 0 },
/* U+1011 */ { 19, 0, 1, 0, 0 },
/* U+1012 */ { 19, 0, 1, 0, 0 },
/* U+1013 */ { 19, 0, 1, 0, 0 },
/* U+1014 */ { 19, 0, 1, 0, 0 },
/* U+1015 */ { 19, 0, 1, 0, 0 },
/* U+1016 */ { 19, 0, 1, 0, 0 },
/* U+1017 */ { 19, 0, 1, 0, 0 },
/* U+1018 */ { 19, 0, 1, 0, 0 },
/* U+1019 */ { 19, 0, 1, 0, 0 },
/* U+101a */ { 19, 0, 1, 0, 0 },
/* U+101b */ { 19, 0, 1, 0, 0 },
/* U+101c */ { 19, 0, 1, 0, 0 },
/* U+101d */ { 19, 0, 1, 0, 0 },
/* U+101e */ { 19, 0, 1, 0, 0 },
/* U+101f */ { 19, 0, 1, 0, 0 },
/* U+1020 */ { 19, 0, 1, 0, 0 },
/* U+1021 */ { 19, 0, 1, 0, 0 },
/* U+1022 */ { 0, 0, 0, 0, 0 },
/* U+1023 */ { 19, 0, 1, 0, 0 },
/* U+1024 */ { 19, 0, 1, 0, 0 },
/* U+1025 */ { 19, 0, 1, 0, 0 },
/* U+1026 */ { 19, 0, 1, 0, "1025 102E" },
/* U+1027 */ { 19, 0, 1, 0, 0 },
/* U+1028 */ { 0, 0, 0, 0, 0 },
/* U+1029 */ { 19, 0, 1, 0, 0 },
/* U+102a */ { 19, 0, 1, 0, 0 },
/* U+102b */ { 0, 0, 0, 0, 0 },
/* U+102c */ { 5, 0, 1, 0, 0 },
/* U+102d */ { 4, 0, 14, 0, 0 },
/* U+102e */ { 4, 0, 14, 0, 0 },
/* U+102f */ { 4, 0, 14, 0, 0 },
/* U+1030 */ { 4, 0, 14, 0, 0 },
/* U+1031 */ { 5, 0, 1, 0, 0 },
/* U+1032 */ { 4, 0, 14, 0, 0 },
/* U+1033 */ { 0, 0, 0, 0, 0 },
/* U+1034 */ { 0, 0, 0, 0, 0 },
/* U+1035 */ { 0, 0, 0, 0, 0 },
/* U+1036 */ { 4, 0, 14, 0, 0 },
/* U+1037 */ { 4, 7, 14, 0, 0 },
/* U+1038 */ { 5, 0, 1, 0, 0 },
/* U+1039 */ { 4, 9, 14, 0, 0 },
/* U+103a */ { 0, 0, 0, 0, 0 },
/* U+103b */ { 0, 0, 0, 0, 0 },
/* U+103c */ { 0, 0, 0, 0, 0 },
/* U+103d */ { 0, 0, 0, 0, 0 },
/* U+103e */ { 0, 0, 0, 0, 0 },
/* U+103f */ { 0, 0, 0, 0, 0 },
/* U+1040 */ { 7, 0, 1, 0, 0 },
/* U+1041 */ { 7, 0, 1, 0, 0 },
/* U+1042 */ { 7, 0, 1, 0, 0 },
/* U+1043 */ { 7, 0, 1, 0, 0 },
/* U+1044 */ { 7, 0, 1, 0, 0 },
/* U+1045 */ { 7, 0, 1, 0, 0 },
/* U+1046 */ { 7, 0, 1, 0, 0 },
/* U+1047 */ { 7, 0, 1, 0, 0 },
/* U+1048 */ { 7, 0, 1, 0, 0 },
/* U+1049 */ { 7, 0, 1, 0, 0 },
/* U+104a */ { 26, 0, 1, 0, 0 },
/* U+104b */ { 26, 0, 1, 0, 0 },
/* U+104c */ { 26, 0, 1, 0, 0 },
/* U+104d */ { 26, 0, 1, 0, 0 },
/* U+104e */ { 26, 0, 1, 0, 0 },
/* U+104f */ { 26, 0, 1, 0, 0 },
/* U+1050 */ { 19, 0, 1, 0, 0 },
/* U+1051 */ { 19, 0, 1, 0, 0 },
/* U+1052 */ { 19, 0, 1, 0, 0 },
/* U+1053 */ { 19, 0, 1, 0, 0 },
/* U+1054 */ { 19, 0, 1, 0, 0 },
/* U+1055 */ { 19, 0, 1, 0, 0 },
/* U+1056 */ { 5, 0, 1, 0, 0 },
/* U+1057 */ { 5, 0, 1, 0, 0 },
/* U+1058 */ { 4, 0, 14, 0, 0 },
/* U+1059 */ { 4, 0, 14, 0, 0 },
/* U+105a */ { 0, 0, 0, 0, 0 },
/* U+105b */ { 0, 0, 0, 0, 0 },
/* U+105c */ { 0, 0, 0, 0, 0 },
/* U+105d */ { 0, 0, 0, 0, 0 },
/* U+105e */ { 0, 0, 0, 0, 0 },
/* U+105f */ { 0, 0, 0, 0, 0 },
/* U+1060 */ { 0, 0, 0, 0, 0 },
/* U+1061 */ { 0, 0, 0, 0, 0 },
/* U+1062 */ { 0, 0, 0, 0, 0 },
/* U+1063 */ { 0, 0, 0, 0, 0 },
/* U+1064 */ { 0, 0, 0, 0, 0 },
/* U+1065 */ { 0, 0, 0, 0, 0 },
/* U+1066 */ { 0, 0, 0, 0, 0 },
/* U+1067 */ { 0, 0, 0, 0, 0 },
/* U+1068 */ { 0, 0, 0, 0, 0 },
/* U+1069 */ { 0, 0, 0, 0, 0 },
/* U+106a */ { 0, 0, 0, 0, 0 },
/* U+106b */ { 0, 0, 0, 0, 0 },
/* U+106c */ { 0, 0, 0, 0, 0 },
/* U+106d */ { 0, 0, 0, 0, 0 },
/* U+106e */ { 0, 0, 0, 0, 0 },
/* U+106f */ { 0, 0, 0, 0, 0 },
/* U+1070 */ { 0, 0, 0, 0, 0 },
/* U+1071 */ { 0, 0, 0, 0, 0 },
/* U+1072 */ { 0, 0, 0, 0, 0 },
/* U+1073 */ { 0, 0, 0, 0, 0 },
/* U+1074 */ { 0, 0, 0, 0, 0 },
/* U+1075 */ { 0, 0, 0, 0, 0 },
/* U+1076 */ { 0, 0, 0, 0, 0 },
/* U+1077 */ { 0, 0, 0, 0, 0 },
/* U+1078 */ { 0, 0, 0, 0, 0 },
/* U+1079 */ { 0, 0, 0, 0, 0 },
/* U+107a */ { 0, 0, 0, 0, 0 },
/* U+107b */ { 0, 0, 0, 0, 0 },
/* U+107c */ { 0, 0, 0, 0, 0 },
/* U+107d */ { 0, 0, 0, 0, 0 },
/* U+107e */ { 0, 0, 0, 0, 0 },
/* U+107f */ { 0, 0, 0, 0, 0 },
/* U+1080 */ { 0, 0, 0, 0, 0 },
/* U+1081 */ { 0, 0, 0, 0, 0 },
/* U+1082 */ { 0, 0, 0, 0, 0 },
/* U+1083 */ { 0, 0, 0, 0, 0 },
/* U+1084 */ { 0, 0, 0, 0, 0 },
/* U+1085 */ { 0, 0, 0, 0, 0 },
/* U+1086 */ { 0, 0, 0, 0, 0 },
/* U+1087 */ { 0, 0, 0, 0, 0 },
/* U+1088 */ { 0, 0, 0, 0, 0 },
/* U+1089 */ { 0, 0, 0, 0, 0 },
/* U+108a */ { 0, 0, 0, 0, 0 },
/* U+108b */ { 0, 0, 0, 0, 0 },
/* U+108c */ { 0, 0, 0, 0, 0 },
/* U+108d */ { 0, 0, 0, 0, 0 },
/* U+108e */ { 0, 0, 0, 0, 0 },
/* U+108f */ { 0, 0, 0, 0, 0 },
/* U+1090 */ { 0, 0, 0, 0, 0 },
/* U+1091 */ { 0, 0, 0, 0, 0 },
/* U+1092 */ { 0, 0, 0, 0, 0 },
/* U+1093 */ { 0, 0, 0, 0, 0 },
/* U+1094 */ { 0, 0, 0, 0, 0 },
/* U+1095 */ { 0, 0, 0, 0, 0 },
/* U+1096 */ { 0, 0, 0, 0, 0 },
/* U+1097 */ { 0, 0, 0, 0, 0 },
/* U+1098 */ { 0, 0, 0, 0, 0 },
/* U+1099 */ { 0, 0, 0, 0, 0 },
/* U+109a */ { 0, 0, 0, 0, 0 },
/* U+109b */ { 0, 0, 0, 0, 0 },
/* U+109c */ { 0, 0, 0, 0, 0 },
/* U+109d */ { 0, 0, 0, 0, 0 },
/* U+109e */ { 0, 0, 0, 0, 0 },
/* U+109f */ { 0, 0, 0, 0, 0 },
/* U+10a0 */ { 1, 0, 1, 0, 0 },
/* U+10a1 */ { 1, 0, 1, 0, 0 },
/* U+10a2 */ { 1, 0, 1, 0, 0 },
/* U+10a3 */ { 1, 0, 1, 0, 0 },
/* U+10a4 */ { 1, 0, 1, 0, 0 },
/* U+10a5 */ { 1, 0, 1, 0, 0 },
/* U+10a6 */ { 1, 0, 1, 0, 0 },
/* U+10a7 */ { 1, 0, 1, 0, 0 },
/* U+10a8 */ { 1, 0, 1, 0, 0 },
/* U+10a9 */ { 1, 0, 1, 0, 0 },
/* U+10aa */ { 1, 0, 1, 0, 0 },
/* U+10ab */ { 1, 0, 1, 0, 0 },
/* U+10ac */ { 1, 0, 1, 0, 0 },
/* U+10ad */ { 1, 0, 1, 0, 0 },
/* U+10ae */ { 1, 0, 1, 0, 0 },
/* U+10af */ { 1, 0, 1, 0, 0 },
/* U+10b0 */ { 1, 0, 1, 0, 0 },
/* U+10b1 */ { 1, 0, 1, 0, 0 },
/* U+10b2 */ { 1, 0, 1, 0, 0 },
/* U+10b3 */ { 1, 0, 1, 0, 0 },
/* U+10b4 */ { 1, 0, 1, 0, 0 },
/* U+10b5 */ { 1, 0, 1, 0, 0 },
/* U+10b6 */ { 1, 0, 1, 0, 0 },
/* U+10b7 */ { 1, 0, 1, 0, 0 },
/* U+10b8 */ { 1, 0, 1, 0, 0 },
/* U+10b9 */ { 1, 0, 1, 0, 0 },
/* U+10ba */ { 1, 0, 1, 0, 0 },
/* U+10bb */ { 1, 0, 1, 0, 0 },
/* U+10bc */ { 1, 0, 1, 0, 0 },
/* U+10bd */ { 1, 0, 1, 0, 0 },
/* U+10be */ { 1, 0, 1, 0, 0 },
/* U+10bf */ { 1, 0, 1, 0, 0 },
/* U+10c0 */ { 1, 0, 1, 0, 0 },
/* U+10c1 */ { 1, 0, 1, 0, 0 },
/* U+10c2 */ { 1, 0, 1, 0, 0 },
/* U+10c3 */ { 1, 0, 1, 0, 0 },
/* U+10c4 */ { 1, 0, 1, 0, 0 },
/* U+10c5 */ { 1, 0, 1, 0, 0 },
/* U+10c6 */ { 0, 0, 0, 0, 0 },
/* U+10c7 */ { 0, 0, 0, 0, 0 },
/* U+10c8 */ { 0, 0, 0, 0, 0 },
/* U+10c9 */ { 0, 0, 0, 0, 0 },
/* U+10ca */ { 0, 0, 0, 0, 0 },
/* U+10cb */ { 0, 0, 0, 0, 0 },
/* U+10cc */ { 0, 0, 0, 0, 0 },
/* U+10cd */ { 0, 0, 0, 0, 0 },
/* U+10ce */ { 0, 0, 0, 0, 0 },
/* U+10cf */ { 0, 0, 0, 0, 0 },
/* U+10d0 */ { 19, 0, 1, 0, 0 },
/* U+10d1 */ { 19, 0, 1, 0, 0 },
/* U+10d2 */ { 19, 0, 1, 0, 0 },
/* U+10d3 */ { 19, 0, 1, 0, 0 },
/* U+10d4 */ { 19, 0, 1, 0, 0 },
/* U+10d5 */ { 19, 0, 1, 0, 0 },
/* U+10d6 */ { 19, 0, 1, 0, 0 },
/* U+10d7 */ { 19, 0, 1, 0, 0 },
/* U+10d8 */ { 19, 0, 1, 0, 0 },
/* U+10d9 */ { 19, 0, 1, 0, 0 },
/* U+10da */ { 19, 0, 1, 0, 0 },
/* U+10db */ { 19, 0, 1, 0, 0 },
/* U+10dc */ { 19, 0, 1, 0, 0 },
/* U+10dd */ { 19, 0, 1, 0, 0 },
/* U+10de */ { 19, 0, 1, 0, 0 },
/* U+10df */ { 19, 0, 1, 0, 0 },
/* U+10e0 */ { 19, 0, 1, 0, 0 },
/* U+10e1 */ { 19, 0, 1, 0, 0 },
/* U+10e2 */ { 19, 0, 1, 0, 0 },
/* U+10e3 */ { 19, 0, 1, 0, 0 },
/* U+10e4 */ { 19, 0, 1, 0, 0 },
/* U+10e5 */ { 19, 0, 1, 0, 0 },
/* U+10e6 */ { 19, 0, 1, 0, 0 },
/* U+10e7 */ { 19, 0, 1, 0, 0 },
/* U+10e8 */ { 19, 0, 1, 0, 0 },
/* U+10e9 */ { 19, 0, 1, 0, 0 },
/* U+10ea */ { 19, 0, 1, 0, 0 },
/* U+10eb */ { 19, 0, 1, 0, 0 },
/* U+10ec */ { 19, 0, 1, 0, 0 },
/* U+10ed */ { 19, 0, 1, 0, 0 },
/* U+10ee */ { 19, 0, 1, 0, 0 },
/* U+10ef */ { 19, 0, 1, 0, 0 },
/* U+10f0 */ { 19, 0, 1, 0, 0 },
/* U+10f1 */ { 19, 0, 1, 0, 0 },
/* U+10f2 */ { 19, 0, 1, 0, 0 },
/* U+10f3 */ { 19, 0, 1, 0, 0 },
/* U+10f4 */ { 19, 0, 1, 0, 0 },
/* U+10f5 */ { 19, 0, 1, 0, 0 },
/* U+10f6 */ { 19, 0, 1, 0, 0 },
/* U+10f7 */ { 0, 0, 0, 0, 0 },
/* U+10f8 */ { 0, 0, 0, 0, 0 },
/* U+10f9 */ { 0, 0, 0, 0, 0 },
/* U+10fa */ { 0, 0, 0, 0, 0 },
/* U+10fb */ { 26, 0, 1, 0, 0 },
/* U+10fc */ { 0, 0, 0, 0, 0 },
/* U+10fd */ { 0, 0, 0, 0, 0 },
/* U+10fe */ { 0, 0, 0, 0, 0 },
/* U+10ff */ { 0, 0, 0, 0, 0 },
/* U+1100 */ { 19, 0, 1, 0, 0 },
/* U+1101 */ { 19, 0, 1, 0, 0 },
/* U+1102 */ { 19, 0, 1, 0, 0 },
/* U+1103 */ { 19, 0, 1, 0, 0 },
/* U+1104 */ { 19, 0, 1, 0, 0 },
/* U+1105 */ { 19, 0, 1, 0, 0 },
/* U+1106 */ { 19, 0, 1, 0, 0 },
/* U+1107 */ { 19, 0, 1, 0, 0 },
/* U+1108 */ { 19, 0, 1, 0, 0 },
/* U+1109 */ { 19, 0, 1, 0, 0 },
/* U+110a */ { 19, 0, 1, 0, 0 },
/* U+110b */ { 19, 0, 1, 0, 0 },
/* U+110c */ { 19, 0, 1, 0, 0 },
/* U+110d */ { 19, 0, 1, 0, 0 },
/* U+110e */ { 19, 0, 1, 0, 0 },
/* U+110f */ { 19, 0, 1, 0, 0 },
/* U+1110 */ { 19, 0, 1, 0, 0 },
/* U+1111 */ { 19, 0, 1, 0, 0 },
/* U+1112 */ { 19, 0, 1, 0, 0 },
/* U+1113 */ { 19, 0, 1, 0, 0 },
/* U+1114 */ { 19, 0, 1, 0, 0 },
/* U+1115 */ { 19, 0, 1, 0, 0 },
/* U+1116 */ { 19, 0, 1, 0, 0 },
/* U+1117 */ { 19, 0, 1, 0, 0 },
/* U+1118 */ { 19, 0, 1, 0, 0 },
/* U+1119 */ { 19, 0, 1, 0, 0 },
/* U+111a */ { 19, 0, 1, 0, 0 },
/* U+111b */ { 19, 0, 1, 0, 0 },
/* U+111c */ { 19, 0, 1, 0, 0 },
/* U+111d */ { 19, 0, 1, 0, 0 },
/* U+111e */ { 19, 0, 1, 0, 0 },
/* U+111f */ { 19, 0, 1, 0, 0 },
/* U+1120 */ { 19, 0, 1, 0, 0 },
/* U+1121 */ { 19, 0, 1, 0, 0 },
/* U+1122 */ { 19, 0, 1, 0, 0 },
/* U+1123 */ { 19, 0, 1, 0, 0 },
/* U+1124 */ { 19, 0, 1, 0, 0 },
/* U+1125 */ { 19, 0, 1, 0, 0 },
/* U+1126 */ { 19, 0, 1, 0, 0 },
/* U+1127 */ { 19, 0, 1, 0, 0 },
/* U+1128 */ { 19, 0, 1, 0, 0 },
/* U+1129 */ { 19, 0, 1, 0, 0 },
/* U+112a */ { 19, 0, 1, 0, 0 },
/* U+112b */ { 19, 0, 1, 0, 0 },
/* U+112c */ { 19, 0, 1, 0, 0 },
/* U+112d */ { 19, 0, 1, 0, 0 },
/* U+112e */ { 19, 0, 1, 0, 0 },
/* U+112f */ { 19, 0, 1, 0, 0 },
/* U+1130 */ { 19, 0, 1, 0, 0 },
/* U+1131 */ { 19, 0, 1, 0, 0 },
/* U+1132 */ { 19, 0, 1, 0, 0 },
/* U+1133 */ { 19, 0, 1, 0, 0 },
/* U+1134 */ { 19, 0, 1, 0, 0 },
/* U+1135 */ { 19, 0, 1, 0, 0 },
/* U+1136 */ { 19, 0, 1, 0, 0 },
/* U+1137 */ { 19, 0, 1, 0, 0 },
/* U+1138 */ { 19, 0, 1, 0, 0 },
/* U+1139 */ { 19, 0, 1, 0, 0 },
/* U+113a */ { 19, 0, 1, 0, 0 },
/* U+113b */ { 19, 0, 1, 0, 0 },
/* U+113c */ { 19, 0, 1, 0, 0 },
/* U+113d */ { 19, 0, 1, 0, 0 },
/* U+113e */ { 19, 0, 1, 0, 0 },
/* U+113f */ { 19, 0, 1, 0, 0 },
/* U+1140 */ { 19, 0, 1, 0, 0 },
/* U+1141 */ { 19, 0, 1, 0, 0 },
/* U+1142 */ { 19, 0, 1, 0, 0 },
/* U+1143 */ { 19, 0, 1, 0, 0 },
/* U+1144 */ { 19, 0, 1, 0, 0 },
/* U+1145 */ { 19, 0, 1, 0, 0 },
/* U+1146 */ { 19, 0, 1, 0, 0 },
/* U+1147 */ { 19, 0, 1, 0, 0 },
/* U+1148 */ { 19, 0, 1, 0, 0 },
/* U+1149 */ { 19, 0, 1, 0, 0 },
/* U+114a */ { 19, 0, 1, 0, 0 },
/* U+114b */ { 19, 0, 1, 0, 0 },
/* U+114c */ { 19, 0, 1, 0, 0 },
/* U+114d */ { 19, 0, 1, 0, 0 },
/* U+114e */ { 19, 0, 1, 0, 0 },
/* U+114f */ { 19, 0, 1, 0, 0 },
/* U+1150 */ { 19, 0, 1, 0, 0 },
/* U+1151 */ { 19, 0, 1, 0, 0 },
/* U+1152 */ { 19, 0, 1, 0, 0 },
/* U+1153 */ { 19, 0, 1, 0, 0 },
/* U+1154 */ { 19, 0, 1, 0, 0 },
/* U+1155 */ { 19, 0, 1, 0, 0 },
/* U+1156 */ { 19, 0, 1, 0, 0 },
/* U+1157 */ { 19, 0, 1, 0, 0 },
/* U+1158 */ { 19, 0, 1, 0, 0 },
/* U+1159 */ { 19, 0, 1, 0, 0 },
/* U+115a */ { 0, 0, 0, 0, 0 },
/* U+115b */ { 0, 0, 0, 0, 0 },
/* U+115c */ { 0, 0, 0, 0, 0 },
/* U+115d */ { 0, 0, 0, 0, 0 },
/* U+115e */ { 0, 0, 0, 0, 0 },
/* U+115f */ { 19, 0, 1, 0, 0 },
/* U+1160 */ { 19, 0, 1, 0, 0 },
/* U+1161 */ { 19, 0, 1, 0, 0 },
/* U+1162 */ { 19, 0, 1, 0, 0 },
/* U+1163 */ { 19, 0, 1, 0, 0 },
/* U+1164 */ { 19, 0, 1, 0, 0 },
/* U+1165 */ { 19, 0, 1, 0, 0 },
/* U+1166 */ { 19, 0, 1, 0, 0 },
/* U+1167 */ { 19, 0, 1, 0, 0 },
/* U+1168 */ { 19, 0, 1, 0, 0 },
/* U+1169 */ { 19, 0, 1, 0, 0 },
/* U+116a */ { 19, 0, 1, 0, 0 },
/* U+116b */ { 19, 0, 1, 0, 0 },
/* U+116c */ { 19, 0, 1, 0, 0 },
/* U+116d */ { 19, 0, 1, 0, 0 },
/* U+116e */ { 19, 0, 1, 0, 0 },
/* U+116f */ { 19, 0, 1, 0, 0 },
/* U+1170 */ { 19, 0, 1, 0, 0 },
/* U+1171 */ { 19, 0, 1, 0, 0 },
/* U+1172 */ { 19, 0, 1, 0, 0 },
/* U+1173 */ { 19, 0, 1, 0, 0 },
/* U+1174 */ { 19, 0, 1, 0, 0 },
/* U+1175 */ { 19, 0, 1, 0, 0 },
/* U+1176 */ { 19, 0, 1, 0, 0 },
/* U+1177 */ { 19, 0, 1, 0, 0 },
/* U+1178 */ { 19, 0, 1, 0, 0 },
/* U+1179 */ { 19, 0, 1, 0, 0 },
/* U+117a */ { 19, 0, 1, 0, 0 },
/* U+117b */ { 19, 0, 1, 0, 0 },
/* U+117c */ { 19, 0, 1, 0, 0 },
/* U+117d */ { 19, 0, 1, 0, 0 },
/* U+117e */ { 19, 0, 1, 0, 0 },
/* U+117f */ { 19, 0, 1, 0, 0 },
/* U+1180 */ { 19, 0, 1, 0, 0 },
/* U+1181 */ { 19, 0, 1, 0, 0 },
/* U+1182 */ { 19, 0, 1, 0, 0 },
/* U+1183 */ { 19, 0, 1, 0, 0 },
/* U+1184 */ { 19, 0, 1, 0, 0 },
/* U+1185 */ { 19, 0, 1, 0, 0 },
/* U+1186 */ { 19, 0, 1, 0, 0 },
/* U+1187 */ { 19, 0, 1, 0, 0 },
/* U+1188 */ { 19, 0, 1, 0, 0 },
/* U+1189 */ { 19, 0, 1, 0, 0 },
/* U+118a */ { 19, 0, 1, 0, 0 },
/* U+118b */ { 19, 0, 1, 0, 0 },
/* U+118c */ { 19, 0, 1, 0, 0 },
/* U+118d */ { 19, 0, 1, 0, 0 },
/* U+118e */ { 19, 0, 1, 0, 0 },
/* U+118f */ { 19, 0, 1, 0, 0 },
/* U+1190 */ { 19, 0, 1, 0, 0 },
/* U+1191 */ { 19, 0, 1, 0, 0 },
/* U+1192 */ { 19, 0, 1, 0, 0 },
/* U+1193 */ { 19, 0, 1, 0, 0 },
/* U+1194 */ { 19, 0, 1, 0, 0 },
/* U+1195 */ { 19, 0, 1, 0, 0 },
/* U+1196 */ { 19, 0, 1, 0, 0 },
/* U+1197 */ { 19, 0, 1, 0, 0 },
/* U+1198 */ { 19, 0, 1, 0, 0 },
/* U+1199 */ { 19, 0, 1, 0, 0 },
/* U+119a */ { 19, 0, 1, 0, 0 },
/* U+119b */ { 19, 0, 1, 0, 0 },
/* U+119c */ { 19, 0, 1, 0, 0 },
/* U+119d */ { 19, 0, 1, 0, 0 },
/* U+119e */ { 19, 0, 1, 0, 0 },
/* U+119f */ { 19, 0, 1, 0, 0 },
/* U+11a0 */ { 19, 0, 1, 0, 0 },
/* U+11a1 */ { 19, 0, 1, 0, 0 },
/* U+11a2 */ { 19, 0, 1, 0, 0 },
/* U+11a3 */ { 0, 0, 0, 0, 0 },
/* U+11a4 */ { 0, 0, 0, 0, 0 },
/* U+11a5 */ { 0, 0, 0, 0, 0 },
/* U+11a6 */ { 0, 0, 0, 0, 0 },
/* U+11a7 */ { 0, 0, 0, 0, 0 },
/* U+11a8 */ { 19, 0, 1, 0, 0 },
/* U+11a9 */ { 19, 0, 1, 0, 0 },
/* U+11aa */ { 19, 0, 1, 0, 0 },
/* U+11ab */ { 19, 0, 1, 0, 0 },
/* U+11ac */ { 19, 0, 1, 0, 0 },
/* U+11ad */ { 19, 0, 1, 0, 0 },
/* U+11ae */ { 19, 0, 1, 0, 0 },
/* U+11af */ { 19, 0, 1, 0, 0 },
/* U+11b0 */ { 19, 0, 1, 0, 0 },
/* U+11b1 */ { 19, 0, 1, 0, 0 },
/* U+11b2 */ { 19, 0, 1, 0, 0 },
/* U+11b3 */ { 19, 0, 1, 0, 0 },
/* U+11b4 */ { 19, 0, 1, 0, 0 },
/* U+11b5 */ { 19, 0, 1, 0, 0 },
/* U+11b6 */ { 19, 0, 1, 0, 0 },
/* U+11b7 */ { 19, 0, 1, 0, 0 },
/* U+11b8 */ { 19, 0, 1, 0, 0 },
/* U+11b9 */ { 19, 0, 1, 0, 0 },
/* U+11ba */ { 19, 0, 1, 0, 0 },
/* U+11bb */ { 19, 0, 1, 0, 0 },
/* U+11bc */ { 19, 0, 1, 0, 0 },
/* U+11bd */ { 19, 0, 1, 0, 0 },
/* U+11be */ { 19, 0, 1, 0, 0 },
/* U+11bf */ { 19, 0, 1, 0, 0 },
/* U+11c0 */ { 19, 0, 1, 0, 0 },
/* U+11c1 */ { 19, 0, 1, 0, 0 },
/* U+11c2 */ { 19, 0, 1, 0, 0 },
/* U+11c3 */ { 19, 0, 1, 0, 0 },
/* U+11c4 */ { 19, 0, 1, 0, 0 },
/* U+11c5 */ { 19, 0, 1, 0, 0 },
/* U+11c6 */ { 19, 0, 1, 0, 0 },
/* U+11c7 */ { 19, 0, 1, 0, 0 },
/* U+11c8 */ { 19, 0, 1, 0, 0 },
/* U+11c9 */ { 19, 0, 1, 0, 0 },
/* U+11ca */ { 19, 0, 1, 0, 0 },
/* U+11cb */ { 19, 0, 1, 0, 0 },
/* U+11cc */ { 19, 0, 1, 0, 0 },
/* U+11cd */ { 19, 0, 1, 0, 0 },
/* U+11ce */ { 19, 0, 1, 0, 0 },
/* U+11cf */ { 19, 0, 1, 0, 0 },
/* U+11d0 */ { 19, 0, 1, 0, 0 },
/* U+11d1 */ { 19, 0, 1, 0, 0 },
/* U+11d2 */ { 19, 0, 1, 0, 0 },
/* U+11d3 */ { 19, 0, 1, 0, 0 },
/* U+11d4 */ { 19, 0, 1, 0, 0 },
/* U+11d5 */ { 19, 0, 1, 0, 0 },
/* U+11d6 */ { 19, 0, 1, 0, 0 },
/* U+11d7 */ { 19, 0, 1, 0, 0 },
/* U+11d8 */ { 19, 0, 1, 0, 0 },
/* U+11d9 */ { 19, 0, 1, 0, 0 },
/* U+11da */ { 19, 0, 1, 0, 0 },
/* U+11db */ { 19, 0, 1, 0, 0 },
/* U+11dc */ { 19, 0, 1, 0, 0 },
/* U+11dd */ { 19, 0, 1, 0, 0 },
/* U+11de */ { 19, 0, 1, 0, 0 },
/* U+11df */ { 19, 0, 1, 0, 0 },
/* U+11e0 */ { 19, 0, 1, 0, 0 },
/* U+11e1 */ { 19, 0, 1, 0, 0 },
/* U+11e2 */ { 19, 0, 1, 0, 0 },
/* U+11e3 */ { 19, 0, 1, 0, 0 },
/* U+11e4 */ { 19, 0, 1, 0, 0 },
/* U+11e5 */ { 19, 0, 1, 0, 0 },
/* U+11e6 */ { 19, 0, 1, 0, 0 },
/* U+11e7 */ { 19, 0, 1, 0, 0 },
/* U+11e8 */ { 19, 0, 1, 0, 0 },
/* U+11e9 */ { 19, 0, 1, 0, 0 },
/* U+11ea */ { 19, 0, 1, 0, 0 },
/* U+11eb */ { 19, 0, 1, 0, 0 },
/* U+11ec */ { 19, 0, 1, 0, 0 },
/* U+11ed */ { 19, 0, 1, 0, 0 },
/* U+11ee */ { 19, 0, 1, 0, 0 },
/* U+11ef */ { 19, 0, 1, 0, 0 },
/* U+11f0 */ { 19, 0, 1, 0, 0 },
/* U+11f1 */ { 19, 0, 1, 0, 0 },
/* U+11f2 */ { 19, 0, 1, 0, 0 },
/* U+11f3 */ { 19, 0, 1, 0, 0 },
/* U+11f4 */ { 19, 0, 1, 0, 0 },
/* U+11f5 */ { 19, 0, 1, 0, 0 },
/* U+11f6 */ { 19, 0, 1, 0, 0 },
/* U+11f7 */ { 19, 0, 1, 0, 0 },
/* U+11f8 */ { 19, 0, 1, 0, 0 },
/* U+11f9 */ { 19, 0, 1, 0, 0 },
/* U+11fa */ { 0, 0, 0, 0, 0 },
/* U+11fb */ { 0, 0, 0, 0, 0 },
/* U+11fc */ { 0, 0, 0, 0, 0 },
/* U+11fd */ { 0, 0, 0, 0, 0 },
/* U+11fe */ { 0, 0, 0, 0, 0 },
/* U+11ff */ { 0, 0, 0, 0, 0 },
/* U+1200 */ { 19, 0, 1, 0, 0 },
/* U+1201 */ { 19, 0, 1, 0, 0 },
/* U+1202 */ { 19, 0, 1, 0, 0 },
/* U+1203 */ { 19, 0, 1, 0, 0 },
/* U+1204 */ { 19, 0, 1, 0, 0 },
/* U+1205 */ { 19, 0, 1, 0, 0 },
/* U+1206 */ { 19, 0, 1, 0, 0 },
/* U+1207 */ { 0, 0, 0, 0, 0 },
/* U+1208 */ { 19, 0, 1, 0, 0 },
/* U+1209 */ { 19, 0, 1, 0, 0 },
/* U+120a */ { 19, 0, 1, 0, 0 },
/* U+120b */ { 19, 0, 1, 0, 0 },
/* U+120c */ { 19, 0, 1, 0, 0 },
/* U+120d */ { 19, 0, 1, 0, 0 },
/* U+120e */ { 19, 0, 1, 0, 0 },
/* U+120f */ { 19, 0, 1, 0, 0 },
/* U+1210 */ { 19, 0, 1, 0, 0 },
/* U+1211 */ { 19, 0, 1, 0, 0 },
/* U+1212 */ { 19, 0, 1, 0, 0 },
/* U+1213 */ { 19, 0, 1, 0, 0 },
/* U+1214 */ { 19, 0, 1, 0, 0 },
/* U+1215 */ { 19, 0, 1, 0, 0 },
/* U+1216 */ { 19, 0, 1, 0, 0 },
/* U+1217 */ { 19, 0, 1, 0, 0 },
/* U+1218 */ { 19, 0, 1, 0, 0 },
/* U+1219 */ { 19, 0, 1, 0, 0 },
/* U+121a */ { 19, 0, 1, 0, 0 },
/* U+121b */ { 19, 0, 1, 0, 0 },
/* U+121c */ { 19, 0, 1, 0, 0 },
/* U+121d */ { 19, 0, 1, 0, 0 },
/* U+121e */ { 19, 0, 1, 0, 0 },
/* U+121f */ { 19, 0, 1, 0, 0 },
/* U+1220 */ { 19, 0, 1, 0, 0 },
/* U+1221 */ { 19, 0, 1, 0, 0 },
/* U+1222 */ { 19, 0, 1, 0, 0 },
/* U+1223 */ { 19, 0, 1, 0, 0 },
/* U+1224 */ { 19, 0, 1, 0, 0 },
/* U+1225 */ { 19, 0, 1, 0, 0 },
/* U+1226 */ { 19, 0, 1, 0, 0 },
/* U+1227 */ { 19, 0, 1, 0, 0 },
/* U+1228 */ { 19, 0, 1, 0, 0 },
/* U+1229 */ { 19, 0, 1, 0, 0 },
/* U+122a */ { 19, 0, 1, 0, 0 },
/* U+122b */ { 19, 0, 1, 0, 0 },
/* U+122c */ { 19, 0, 1, 0, 0 },
/* U+122d */ { 19, 0, 1, 0, 0 },
/* U+122e */ { 19, 0, 1, 0, 0 },
/* U+122f */ { 19, 0, 1, 0, 0 },
/* U+1230 */ { 19, 0, 1, 0, 0 },
/* U+1231 */ { 19, 0, 1, 0, 0 },
/* U+1232 */ { 19, 0, 1, 0, 0 },
/* U+1233 */ { 19, 0, 1, 0, 0 },
/* U+1234 */ { 19, 0, 1, 0, 0 },
/* U+1235 */ { 19, 0, 1, 0, 0 },
/* U+1236 */ { 19, 0, 1, 0, 0 },
/* U+1237 */ { 19, 0, 1, 0, 0 },
/* U+1238 */ { 19, 0, 1, 0, 0 },
/* U+1239 */ { 19, 0, 1, 0, 0 },
/* U+123a */ { 19, 0, 1, 0, 0 },
/* U+123b */ { 19, 0, 1, 0, 0 },
/* U+123c */ { 19, 0, 1, 0, 0 },
/* U+123d */ { 19, 0, 1, 0, 0 },
/* U+123e */ { 19, 0, 1, 0, 0 },
/* U+123f */ { 19, 0, 1, 0, 0 },
/* U+1240 */ { 19, 0, 1, 0, 0 },
/* U+1241 */ { 19, 0, 1, 0, 0 },
/* U+1242 */ { 19, 0, 1, 0, 0 },
/* U+1243 */ { 19, 0, 1, 0, 0 },
/* U+1244 */ { 19, 0, 1, 0, 0 },
/* U+1245 */ { 19, 0, 1, 0, 0 },
/* U+1246 */ { 19, 0, 1, 0, 0 },
/* U+1247 */ { 0, 0, 0, 0, 0 },
/* U+1248 */ { 19, 0, 1, 0, 0 },
/* U+1249 */ { 0, 0, 0, 0, 0 },
/* U+124a */ { 19, 0, 1, 0, 0 },
/* U+124b */ { 19, 0, 1, 0, 0 },
/* U+124c */ { 19, 0, 1, 0, 0 },
/* U+124d */ { 19, 0, 1, 0, 0 },
/* U+124e */ { 0, 0, 0, 0, 0 },
/* U+124f */ { 0, 0, 0, 0, 0 },
/* U+1250 */ { 19, 0, 1, 0, 0 },
/* U+1251 */ { 19, 0, 1, 0, 0 },
/* U+1252 */ { 19, 0, 1, 0, 0 },
/* U+1253 */ { 19, 0, 1, 0, 0 },
/* U+1254 */ { 19, 0, 1, 0, 0 },
/* U+1255 */ { 19, 0, 1, 0, 0 },
/* U+1256 */ { 19, 0, 1, 0, 0 },
/* U+1257 */ { 0, 0, 0, 0, 0 },
/* U+1258 */ { 19, 0, 1, 0, 0 },
/* U+1259 */ { 0, 0, 0, 0, 0 },
/* U+125a */ { 19, 0, 1, 0, 0 },
/* U+125b */ { 19, 0, 1, 0, 0 },
/* U+125c */ { 19, 0, 1, 0, 0 },
/* U+125d */ { 19, 0, 1, 0, 0 },
/* U+125e */ { 0, 0, 0, 0, 0 },
/* U+125f */ { 0, 0, 0, 0, 0 },
/* U+1260 */ { 19, 0, 1, 0, 0 },
/* U+1261 */ { 19, 0, 1, 0, 0 },
/* U+1262 */ { 19, 0, 1, 0, 0 },
/* U+1263 */ { 19, 0, 1, 0, 0 },
/* U+1264 */ { 19, 0, 1, 0, 0 },
/* U+1265 */ { 19, 0, 1, 0, 0 },
/* U+1266 */ { 19, 0, 1, 0, 0 },
/* U+1267 */ { 19, 0, 1, 0, 0 },
/* U+1268 */ { 19, 0, 1, 0, 0 },
/* U+1269 */ { 19, 0, 1, 0, 0 },
/* U+126a */ { 19, 0, 1, 0, 0 },
/* U+126b */ { 19, 0, 1, 0, 0 },
/* U+126c */ { 19, 0, 1, 0, 0 },
/* U+126d */ { 19, 0, 1, 0, 0 },
/* U+126e */ { 19, 0, 1, 0, 0 },
/* U+126f */ { 19, 0, 1, 0, 0 },
/* U+1270 */ { 19, 0, 1, 0, 0 },
/* U+1271 */ { 19, 0, 1, 0, 0 },
/* U+1272 */ { 19, 0, 1, 0, 0 },
/* U+1273 */ { 19, 0, 1, 0, 0 },
/* U+1274 */ { 19, 0, 1, 0, 0 },
/* U+1275 */ { 19, 0, 1, 0, 0 },
/* U+1276 */ { 19, 0, 1, 0, 0 },
/* U+1277 */ { 19, 0, 1, 0, 0 },
/* U+1278 */ { 19, 0, 1, 0, 0 },
/* U+1279 */ { 19, 0, 1, 0, 0 },
/* U+127a */ { 19, 0, 1, 0, 0 },
/* U+127b */ { 19, 0, 1, 0, 0 },
/* U+127c */ { 19, 0, 1, 0, 0 },
/* U+127d */ { 19, 0, 1, 0, 0 },
/* U+127e */ { 19, 0, 1, 0, 0 },
/* U+127f */ { 19, 0, 1, 0, 0 },
/* U+1280 */ { 19, 0, 1, 0, 0 },
/* U+1281 */ { 19, 0, 1, 0, 0 },
/* U+1282 */ { 19, 0, 1, 0, 0 },
/* U+1283 */ { 19, 0, 1, 0, 0 },
/* U+1284 */ { 19, 0, 1, 0, 0 },
/* U+1285 */ { 19, 0, 1, 0, 0 },
/* U+1286 */ { 19, 0, 1, 0, 0 },
/* U+1287 */ { 0, 0, 0, 0, 0 },
/* U+1288 */ { 19, 0, 1, 0, 0 },
/* U+1289 */ { 0, 0, 0, 0, 0 },
/* U+128a */ { 19, 0, 1, 0, 0 },
/* U+128b */ { 19, 0, 1, 0, 0 },
/* U+128c */ { 19, 0, 1, 0, 0 },
/* U+128d */ { 19, 0, 1, 0, 0 },
/* U+128e */ { 0, 0, 0, 0, 0 },
/* U+128f */ { 0, 0, 0, 0, 0 },
/* U+1290 */ { 19, 0, 1, 0, 0 },
/* U+1291 */ { 19, 0, 1, 0, 0 },
/* U+1292 */ { 19, 0, 1, 0, 0 },
/* U+1293 */ { 19, 0, 1, 0, 0 },
/* U+1294 */ { 19, 0, 1, 0, 0 },
/* U+1295 */ { 19, 0, 1, 0, 0 },
/* U+1296 */ { 19, 0, 1, 0, 0 },
/* U+1297 */ { 19, 0, 1, 0, 0 },
/* U+1298 */ { 19, 0, 1, 0, 0 },
/* U+1299 */ { 19, 0, 1, 0, 0 },
/* U+129a */ { 19, 0, 1, 0, 0 },
/* U+129b */ { 19, 0, 1, 0, 0 },
/* U+129c */ { 19, 0, 1, 0, 0 },
/* U+129d */ { 19, 0, 1, 0, 0 },
/* U+129e */ { 19, 0, 1, 0, 0 },
/* U+129f */ { 19, 0, 1, 0, 0 },
/* U+12a0 */ { 19, 0, 1, 0, 0 },
/* U+12a1 */ { 19, 0, 1, 0, 0 },
/* U+12a2 */ { 19, 0, 1, 0, 0 },
/* U+12a3 */ { 19, 0, 1, 0, 0 },
/* U+12a4 */ { 19, 0, 1, 0, 0 },
/* U+12a5 */ { 19, 0, 1, 0, 0 },
/* U+12a6 */ { 19, 0, 1, 0, 0 },
/* U+12a7 */ { 19, 0, 1, 0, 0 },
/* U+12a8 */ { 19, 0, 1, 0, 0 },
/* U+12a9 */ { 19, 0, 1, 0, 0 },
/* U+12aa */ { 19, 0, 1, 0, 0 },
/* U+12ab */ { 19, 0, 1, 0, 0 },
/* U+12ac */ { 19, 0, 1, 0, 0 },
/* U+12ad */ { 19, 0, 1, 0, 0 },
/* U+12ae */ { 19, 0, 1, 0, 0 },
/* U+12af */ { 0, 0, 0, 0, 0 },
/* U+12b0 */ { 19, 0, 1, 0, 0 },
/* U+12b1 */ { 0, 0, 0, 0, 0 },
/* U+12b2 */ { 19, 0, 1, 0, 0 },
/* U+12b3 */ { 19, 0, 1, 0, 0 },
/* U+12b4 */ { 19, 0, 1, 0, 0 },
/* U+12b5 */ { 19, 0, 1, 0, 0 },
/* U+12b6 */ { 0, 0, 0, 0, 0 },
/* U+12b7 */ { 0, 0, 0, 0, 0 },
/* U+12b8 */ { 19, 0, 1, 0, 0 },
/* U+12b9 */ { 19, 0, 1, 0, 0 },
/* U+12ba */ { 19, 0, 1, 0, 0 },
/* U+12bb */ { 19, 0, 1, 0, 0 },
/* U+12bc */ { 19, 0, 1, 0, 0 },
/* U+12bd */ { 19, 0, 1, 0, 0 },
/* U+12be */ { 19, 0, 1, 0, 0 },
/* U+12bf */ { 0, 0, 0, 0, 0 },
/* U+12c0 */ { 19, 0, 1, 0, 0 },
/* U+12c1 */ { 0, 0, 0, 0, 0 },
/* U+12c2 */ { 19, 0, 1, 0, 0 },
/* U+12c3 */ { 19, 0, 1, 0, 0 },
/* U+12c4 */ { 19, 0, 1, 0, 0 },
/* U+12c5 */ { 19, 0, 1, 0, 0 },
/* U+12c6 */ { 0, 0, 0, 0, 0 },
/* U+12c7 */ { 0, 0, 0, 0, 0 },
/* U+12c8 */ { 19, 0, 1, 0, 0 },
/* U+12c9 */ { 19, 0, 1, 0, 0 },
/* U+12ca */ { 19, 0, 1, 0, 0 },
/* U+12cb */ { 19, 0, 1, 0, 0 },
/* U+12cc */ { 19, 0, 1, 0, 0 },
/* U+12cd */ { 19, 0, 1, 0, 0 },
/* U+12ce */ { 19, 0, 1, 0, 0 },
/* U+12cf */ { 0, 0, 0, 0, 0 },
/* U+12d0 */ { 19, 0, 1, 0, 0 },
/* U+12d1 */ { 19, 0, 1, 0, 0 },
/* U+12d2 */ { 19, 0, 1, 0, 0 },
/* U+12d3 */ { 19, 0, 1, 0, 0 },
/* U+12d4 */ { 19, 0, 1, 0, 0 },
/* U+12d5 */ { 19, 0, 1, 0, 0 },
/* U+12d6 */ { 19, 0, 1, 0, 0 },
/* U+12d7 */ { 0, 0, 0, 0, 0 },
/* U+12d8 */ { 19, 0, 1, 0, 0 },
/* U+12d9 */ { 19, 0, 1, 0, 0 },
/* U+12da */ { 19, 0, 1, 0, 0 },
/* U+12db */ { 19, 0, 1, 0, 0 },
/* U+12dc */ { 19, 0, 1, 0, 0 },
/* U+12dd */ { 19, 0, 1, 0, 0 },
/* U+12de */ { 19, 0, 1, 0, 0 },
/* U+12df */ { 19, 0, 1, 0, 0 },
/* U+12e0 */ { 19, 0, 1, 0, 0 },
/* U+12e1 */ { 19, 0, 1, 0, 0 },
/* U+12e2 */ { 19, 0, 1, 0, 0 },
/* U+12e3 */ { 19, 0, 1, 0, 0 },
/* U+12e4 */ { 19, 0, 1, 0, 0 },
/* U+12e5 */ { 19, 0, 1, 0, 0 },
/* U+12e6 */ { 19, 0, 1, 0, 0 },
/* U+12e7 */ { 19, 0, 1, 0, 0 },
/* U+12e8 */ { 19, 0, 1, 0, 0 },
/* U+12e9 */ { 19, 0, 1, 0, 0 },
/* U+12ea */ { 19, 0, 1, 0, 0 },
/* U+12eb */ { 19, 0, 1, 0, 0 },
/* U+12ec */ { 19, 0, 1, 0, 0 },
/* U+12ed */ { 19, 0, 1, 0, 0 },
/* U+12ee */ { 19, 0, 1, 0, 0 },
/* U+12ef */ { 0, 0, 0, 0, 0 },
/* U+12f0 */ { 19, 0, 1, 0, 0 },
/* U+12f1 */ { 19, 0, 1, 0, 0 },
/* U+12f2 */ { 19, 0, 1, 0, 0 },
/* U+12f3 */ { 19, 0, 1, 0, 0 },
/* U+12f4 */ { 19, 0, 1, 0, 0 },
/* U+12f5 */ { 19, 0, 1, 0, 0 },
/* U+12f6 */ { 19, 0, 1, 0, 0 },
/* U+12f7 */ { 19, 0, 1, 0, 0 },
/* U+12f8 */ { 19, 0, 1, 0, 0 },
/* U+12f9 */ { 19, 0, 1, 0, 0 },
/* U+12fa */ { 19, 0, 1, 0, 0 },
/* U+12fb */ { 19, 0, 1, 0, 0 },
/* U+12fc */ { 19, 0, 1, 0, 0 },
/* U+12fd */ { 19, 0, 1, 0, 0 },
/* U+12fe */ { 19, 0, 1, 0, 0 },
/* U+12ff */ { 19, 0, 1, 0, 0 },
/* U+1300 */ { 19, 0, 1, 0, 0 },
/* U+1301 */ { 19, 0, 1, 0, 0 },
/* U+1302 */ { 19, 0, 1, 0, 0 },
/* U+1303 */ { 19, 0, 1, 0, 0 },
/* U+1304 */ { 19, 0, 1, 0, 0 },
/* U+1305 */ { 19, 0, 1, 0, 0 },
/* U+1306 */ { 19, 0, 1, 0, 0 },
/* U+1307 */ { 19, 0, 1, 0, 0 },
/* U+1308 */ { 19, 0, 1, 0, 0 },
/* U+1309 */ { 19, 0, 1, 0, 0 },
/* U+130a */ { 19, 0, 1, 0, 0 },
/* U+130b */ { 19, 0, 1, 0, 0 },
/* U+130c */ { 19, 0, 1, 0, 0 },
/* U+130d */ { 19, 0, 1, 0, 0 },
/* U+130e */ { 19, 0, 1, 0, 0 },
/* U+130f */ { 0, 0, 0, 0, 0 },
/* U+1310 */ { 19, 0, 1, 0, 0 },
/* U+1311 */ { 0, 0, 0, 0, 0 },
/* U+1312 */ { 19, 0, 1, 0, 0 },
/* U+1313 */ { 19, 0, 1, 0, 0 },
/* U+1314 */ { 19, 0, 1, 0, 0 },
/* U+1315 */ { 19, 0, 1, 0, 0 },
/* U+1316 */ { 0, 0, 0, 0, 0 },
/* U+1317 */ { 0, 0, 0, 0, 0 },
/* U+1318 */ { 19, 0, 1, 0, 0 },
/* U+1319 */ { 19, 0, 1, 0, 0 },
/* U+131a */ { 19, 0, 1, 0, 0 },
/* U+131b */ { 19, 0, 1, 0, 0 },
/* U+131c */ { 19, 0, 1, 0, 0 },
/* U+131d */ { 19, 0, 1, 0, 0 },
/* U+131e */ { 19, 0, 1, 0, 0 },
/* U+131f */ { 0, 0, 0, 0, 0 },
/* U+1320 */ { 19, 0, 1, 0, 0 },
/* U+1321 */ { 19, 0, 1, 0, 0 },
/* U+1322 */ { 19, 0, 1, 0, 0 },
/* U+1323 */ { 19, 0, 1, 0, 0 },
/* U+1324 */ { 19, 0, 1, 0, 0 },
/* U+1325 */ { 19, 0, 1, 0, 0 },
/* U+1326 */ { 19, 0, 1, 0, 0 },
/* U+1327 */ { 19, 0, 1, 0, 0 },
/* U+1328 */ { 19, 0, 1, 0, 0 },
/* U+1329 */ { 19, 0, 1, 0, 0 },
/* U+132a */ { 19, 0, 1, 0, 0 },
/* U+132b */ { 19, 0, 1, 0, 0 },
/* U+132c */ { 19, 0, 1, 0, 0 },
/* U+132d */ { 19, 0, 1, 0, 0 },
/* U+132e */ { 19, 0, 1, 0, 0 },
/* U+132f */ { 19, 0, 1, 0, 0 },
/* U+1330 */ { 19, 0, 1, 0, 0 },
/* U+1331 */ { 19, 0, 1, 0, 0 },
/* U+1332 */ { 19, 0, 1, 0, 0 },
/* U+1333 */ { 19, 0, 1, 0, 0 },
/* U+1334 */ { 19, 0, 1, 0, 0 },
/* U+1335 */ { 19, 0, 1, 0, 0 },
/* U+1336 */ { 19, 0, 1, 0, 0 },
/* U+1337 */ { 19, 0, 1, 0, 0 },
/* U+1338 */ { 19, 0, 1, 0, 0 },
/* U+1339 */ { 19, 0, 1, 0, 0 },
/* U+133a */ { 19, 0, 1, 0, 0 },
/* U+133b */ { 19, 0, 1, 0, 0 },
/* U+133c */ { 19, 0, 1, 0, 0 },
/* U+133d */ { 19, 0, 1, 0, 0 },
/* U+133e */ { 19, 0, 1, 0, 0 },
/* U+133f */ { 19, 0, 1, 0, 0 },
/* U+1340 */ { 19, 0, 1, 0, 0 },
/* U+1341 */ { 19, 0, 1, 0, 0 },
/* U+1342 */ { 19, 0, 1, 0, 0 },
/* U+1343 */ { 19, 0, 1, 0, 0 },
/* U+1344 */ { 19, 0, 1, 0, 0 },
/* U+1345 */ { 19, 0, 1, 0, 0 },
/* U+1346 */ { 19, 0, 1, 0, 0 },
/* U+1347 */ { 0, 0, 0, 0, 0 },
/* U+1348 */ { 19, 0, 1, 0, 0 },
/* U+1349 */ { 19, 0, 1, 0, 0 },
/* U+134a */ { 19, 0, 1, 0, 0 },
/* U+134b */ { 19, 0, 1, 0, 0 },
/* U+134c */ { 19, 0, 1, 0, 0 },
/* U+134d */ { 19, 0, 1, 0, 0 },
/* U+134e */ { 19, 0, 1, 0, 0 },
/* U+134f */ { 19, 0, 1, 0, 0 },
/* U+1350 */ { 19, 0, 1, 0, 0 },
/* U+1351 */ { 19, 0, 1, 0, 0 },
/* U+1352 */ { 19, 0, 1, 0, 0 },
/* U+1353 */ { 19, 0, 1, 0, 0 },
/* U+1354 */ { 19, 0, 1, 0, 0 },
/* U+1355 */ { 19, 0, 1, 0, 0 },
/* U+1356 */ { 19, 0, 1, 0, 0 },
/* U+1357 */ { 19, 0, 1, 0, 0 },
/* U+1358 */ { 19, 0, 1, 0, 0 },
/* U+1359 */ { 19, 0, 1, 0, 0 },
/* U+135a */ { 19, 0, 1, 0, 0 },
/* U+135b */ { 0, 0, 0, 0, 0 },
/* U+135c */ { 0, 0, 0, 0, 0 },
/* U+135d */ { 0, 0, 0, 0, 0 },
/* U+135e */ { 0, 0, 0, 0, 0 },
/* U+135f */ { 0, 0, 0, 0, 0 },
/* U+1360 */ { 0, 0, 0, 0, 0 },
/* U+1361 */ { 26, 0, 1, 0, 0 },
/* U+1362 */ { 26, 0, 1, 0, 0 },
/* U+1363 */ { 26, 0, 1, 0, 0 },
/* U+1364 */ { 26, 0, 1, 0, 0 },
/* U+1365 */ { 26, 0, 1, 0, 0 },
/* U+1366 */ { 26, 0, 1, 0, 0 },
/* U+1367 */ { 26, 0, 1, 0, 0 },
/* U+1368 */ { 26, 0, 1, 0, 0 },
/* U+1369 */ { 7, 0, 1, 0, 0 },
/* U+136a */ { 7, 0, 1, 0, 0 },
/* U+136b */ { 7, 0, 1, 0, 0 },
/* U+136c */ { 7, 0, 1, 0, 0 },
/* U+136d */ { 7, 0, 1, 0, 0 },
/* U+136e */ { 7, 0, 1, 0, 0 },
/* U+136f */ { 7, 0, 1, 0, 0 },
/* U+1370 */ { 7, 0, 1, 0, 0 },
/* U+1371 */ { 7, 0, 1, 0, 0 },
/* U+1372 */ { 9, 0, 1, 0, 0 },
/* U+1373 */ { 9, 0, 1, 0, 0 },
/* U+1374 */ { 9, 0, 1, 0, 0 },
/* U+1375 */ { 9, 0, 1, 0, 0 },
/* U+1376 */ { 9, 0, 1, 0, 0 },
/* U+1377 */ { 9, 0, 1, 0, 0 },
/* U+1378 */ { 9, 0, 1, 0, 0 },
/* U+1379 */ { 9, 0, 1, 0, 0 },
/* U+137a */ { 9, 0, 1, 0, 0 },
/* U+137b */ { 9, 0, 1, 0, 0 },
/* U+137c */ { 9, 0, 1, 0, 0 },
/* U+137d */ { 0, 0, 0, 0, 0 },
/* U+137e */ { 0, 0, 0, 0, 0 },
/* U+137f */ { 0, 0, 0, 0, 0 },
/* U+1380 */ { 0, 0, 0, 0, 0 },
/* U+1381 */ { 0, 0, 0, 0, 0 },
/* U+1382 */ { 0, 0, 0, 0, 0 },
/* U+1383 */ { 0, 0, 0, 0, 0 },
/* U+1384 */ { 0, 0, 0, 0, 0 },
/* U+1385 */ { 0, 0, 0, 0, 0 },
/* U+1386 */ { 0, 0, 0, 0, 0 },
/* U+1387 */ { 0, 0, 0, 0, 0 },
/* U+1388 */ { 0, 0, 0, 0, 0 },
/* U+1389 */ { 0, 0, 0, 0, 0 },
/* U+138a */ { 0, 0, 0, 0, 0 },
/* U+138b */ { 0, 0, 0, 0, 0 },
/* U+138c */ { 0, 0, 0, 0, 0 },
/* U+138d */ { 0, 0, 0, 0, 0 },
/* U+138e */ { 0, 0, 0, 0, 0 },
/* U+138f */ { 0, 0, 0, 0, 0 },
/* U+1390 */ { 0, 0, 0, 0, 0 },
/* U+1391 */ { 0, 0, 0, 0, 0 },
/* U+1392 */ { 0, 0, 0, 0, 0 },
/* U+1393 */ { 0, 0, 0, 0, 0 },
/* U+1394 */ { 0, 0, 0, 0, 0 },
/* U+1395 */ { 0, 0, 0, 0, 0 },
/* U+1396 */ { 0, 0, 0, 0, 0 },
/* U+1397 */ { 0, 0, 0, 0, 0 },
/* U+1398 */ { 0, 0, 0, 0, 0 },
/* U+1399 */ { 0, 0, 0, 0, 0 },
/* U+139a */ { 0, 0, 0, 0, 0 },
/* U+139b */ { 0, 0, 0, 0, 0 },
/* U+139c */ { 0, 0, 0, 0, 0 },
/* U+139d */ { 0, 0, 0, 0, 0 },
/* U+139e */ { 0, 0, 0, 0, 0 },
/* U+139f */ { 0, 0, 0, 0, 0 },
/* U+13a0 */ { 19, 0, 1, 0, 0 },
/* U+13a1 */ { 19, 0, 1, 0, 0 },
/* U+13a2 */ { 19, 0, 1, 0, 0 },
/* U+13a3 */ { 19, 0, 1, 0, 0 },
/* U+13a4 */ { 19, 0, 1, 0, 0 },
/* U+13a5 */ { 19, 0, 1, 0, 0 },
/* U+13a6 */ { 19, 0, 1, 0, 0 },
/* U+13a7 */ { 19, 0, 1, 0, 0 },
/* U+13a8 */ { 19, 0, 1, 0, 0 },
/* U+13a9 */ { 19, 0, 1, 0, 0 },
/* U+13aa */ { 19, 0, 1, 0, 0 },
/* U+13ab */ { 19, 0, 1, 0, 0 },
/* U+13ac */ { 19, 0, 1, 0, 0 },
/* U+13ad */ { 19, 0, 1, 0, 0 },
/* U+13ae */ { 19, 0, 1, 0, 0 },
/* U+13af */ { 19, 0, 1, 0, 0 },
/* U+13b0 */ { 19, 0, 1, 0, 0 },
/* U+13b1 */ { 19, 0, 1, 0, 0 },
/* U+13b2 */ { 19, 0, 1, 0, 0 },
/* U+13b3 */ { 19, 0, 1, 0, 0 },
/* U+13b4 */ { 19, 0, 1, 0, 0 },
/* U+13b5 */ { 19, 0, 1, 0, 0 },
/* U+13b6 */ { 19, 0, 1, 0, 0 },
/* U+13b7 */ { 19, 0, 1, 0, 0 },
/* U+13b8 */ { 19, 0, 1, 0, 0 },
/* U+13b9 */ { 19, 0, 1, 0, 0 },
/* U+13ba */ { 19, 0, 1, 0, 0 },
/* U+13bb */ { 19, 0, 1, 0, 0 },
/* U+13bc */ { 19, 0, 1, 0, 0 },
/* U+13bd */ { 19, 0, 1, 0, 0 },
/* U+13be */ { 19, 0, 1, 0, 0 },
/* U+13bf */ { 19, 0, 1, 0, 0 },
/* U+13c0 */ { 19, 0, 1, 0, 0 },
/* U+13c1 */ { 19, 0, 1, 0, 0 },
/* U+13c2 */ { 19, 0, 1, 0, 0 },
/* U+13c3 */ { 19, 0, 1, 0, 0 },
/* U+13c4 */ { 19, 0, 1, 0, 0 },
/* U+13c5 */ { 19, 0, 1, 0, 0 },
/* U+13c6 */ { 19, 0, 1, 0, 0 },
/* U+13c7 */ { 19, 0, 1, 0, 0 },
/* U+13c8 */ { 19, 0, 1, 0, 0 },
/* U+13c9 */ { 19, 0, 1, 0, 0 },
/* U+13ca */ { 19, 0, 1, 0, 0 },
/* U+13cb */ { 19, 0, 1, 0, 0 },
/* U+13cc */ { 19, 0, 1, 0, 0 },
/* U+13cd */ { 19, 0, 1, 0, 0 },
/* U+13ce */ { 19, 0, 1, 0, 0 },
/* U+13cf */ { 19, 0, 1, 0, 0 },
/* U+13d0 */ { 19, 0, 1, 0, 0 },
/* U+13d1 */ { 19, 0, 1, 0, 0 },
/* U+13d2 */ { 19, 0, 1, 0, 0 },
/* U+13d3 */ { 19, 0, 1, 0, 0 },
/* U+13d4 */ { 19, 0, 1, 0, 0 },
/* U+13d5 */ { 19, 0, 1, 0, 0 },
/* U+13d6 */ { 19, 0, 1, 0, 0 },
/* U+13d7 */ { 19, 0, 1, 0, 0 },
/* U+13d8 */ { 19, 0, 1, 0, 0 },
/* U+13d9 */ { 19, 0, 1, 0, 0 },
/* U+13da */ { 19, 0, 1, 0, 0 },
/* U+13db */ { 19, 0, 1, 0, 0 },
/* U+13dc */ { 19, 0, 1, 0, 0 },
/* U+13dd */ { 19, 0, 1, 0, 0 },
/* U+13de */ { 19, 0, 1, 0, 0 },
/* U+13df */ { 19, 0, 1, 0, 0 },
/* U+13e0 */ { 19, 0, 1, 0, 0 },
/* U+13e1 */ { 19, 0, 1, 0, 0 },
/* U+13e2 */ { 19, 0, 1, 0, 0 },
/* U+13e3 */ { 19, 0, 1, 0, 0 },
/* U+13e4 */ { 19, 0, 1, 0, 0 },
/* U+13e5 */ { 19, 0, 1, 0, 0 },
/* U+13e6 */ { 19, 0, 1, 0, 0 },
/* U+13e7 */ { 19, 0, 1, 0, 0 },
/* U+13e8 */ { 19, 0, 1, 0, 0 },
/* U+13e9 */ { 19, 0, 1, 0, 0 },
/* U+13ea */ { 19, 0, 1, 0, 0 },
/* U+13eb */ { 19, 0, 1, 0, 0 },
/* U+13ec */ { 19, 0, 1, 0, 0 },
/* U+13ed */ { 19, 0, 1, 0, 0 },
/* U+13ee */ { 19, 0, 1, 0, 0 },
/* U+13ef */ { 19, 0, 1, 0, 0 },
/* U+13f0 */ { 19, 0, 1, 0, 0 },
/* U+13f1 */ { 19, 0, 1, 0, 0 },
/* U+13f2 */ { 19, 0, 1, 0, 0 },
/* U+13f3 */ { 19, 0, 1, 0, 0 },
/* U+13f4 */ { 19, 0, 1, 0, 0 },
/* U+13f5 */ { 0, 0, 0, 0, 0 },
/* U+13f6 */ { 0, 0, 0, 0, 0 },
/* U+13f7 */ { 0, 0, 0, 0, 0 },
/* U+13f8 */ { 0, 0, 0, 0, 0 },
/* U+13f9 */ { 0, 0, 0, 0, 0 },
/* U+13fa */ { 0, 0, 0, 0, 0 },
/* U+13fb */ { 0, 0, 0, 0, 0 },
/* U+13fc */ { 0, 0, 0, 0, 0 },
/* U+13fd */ { 0, 0, 0, 0, 0 },
/* U+13fe */ { 0, 0, 0, 0, 0 },
/* U+13ff */ { 0, 0, 0, 0, 0 },
/* U+1400 */ { 0, 0, 0, 0, 0 },
/* U+1401 */ { 19, 0, 1, 0, 0 },
/* U+1402 */ { 19, 0, 1, 0, 0 },
/* U+1403 */ { 19, 0, 1, 0, 0 },
/* U+1404 */ { 19, 0, 1, 0, 0 },
/* U+1405 */ { 19, 0, 1, 0, 0 },
/* U+1406 */ { 19, 0, 1, 0, 0 },
/* U+1407 */ { 19, 0, 1, 0, 0 },
/* U+1408 */ { 19, 0, 1, 0, 0 },
/* U+1409 */ { 19, 0, 1, 0, 0 },
/* U+140a */ { 19, 0, 1, 0, 0 },
/* U+140b */ { 19, 0, 1, 0, 0 },
/* U+140c */ { 19, 0, 1, 0, 0 },
/* U+140d */ { 19, 0, 1, 0, 0 },
/* U+140e */ { 19, 0, 1, 0, 0 },
/* U+140f */ { 19, 0, 1, 0, 0 },
/* U+1410 */ { 19, 0, 1, 0, 0 },
/* U+1411 */ { 19, 0, 1, 0, 0 },
/* U+1412 */ { 19, 0, 1, 0, 0 },
/* U+1413 */ { 19, 0, 1, 0, 0 },
/* U+1414 */ { 19, 0, 1, 0, 0 },
/* U+1415 */ { 19, 0, 1, 0, 0 },
/* U+1416 */ { 19, 0, 1, 0, 0 },
/* U+1417 */ { 19, 0, 1, 0, 0 },
/* U+1418 */ { 19, 0, 1, 0, 0 },
/* U+1419 */ { 19, 0, 1, 0, 0 },
/* U+141a */ { 19, 0, 1, 0, 0 },
/* U+141b */ { 19, 0, 1, 0, 0 },
/* U+141c */ { 19, 0, 1, 0, 0 },
/* U+141d */ { 19, 0, 1, 0, 0 },
/* U+141e */ { 19, 0, 1, 0, 0 },
/* U+141f */ { 19, 0, 1, 0, 0 },
/* U+1420 */ { 19, 0, 1, 0, 0 },
/* U+1421 */ { 19, 0, 1, 0, 0 },
/* U+1422 */ { 19, 0, 1, 0, 0 },
/* U+1423 */ { 19, 0, 1, 0, 0 },
/* U+1424 */ { 19, 0, 1, 0, 0 },
/* U+1425 */ { 19, 0, 1, 0, 0 },
/* U+1426 */ { 19, 0, 1, 0, 0 },
/* U+1427 */ { 19, 0, 1, 0, 0 },
/* U+1428 */ { 19, 0, 1, 0, 0 },
/* U+1429 */ { 19, 0, 1, 0, 0 },
/* U+142a */ { 19, 0, 1, 0, 0 },
/* U+142b */ { 19, 0, 1, 0, 0 },
/* U+142c */ { 19, 0, 1, 0, 0 },
/* U+142d */ { 19, 0, 1, 0, 0 },
/* U+142e */ { 19, 0, 1, 0, 0 },
/* U+142f */ { 19, 0, 1, 0, 0 },
/* U+1430 */ { 19, 0, 1, 0, 0 },
/* U+1431 */ { 19, 0, 1, 0, 0 },
/* U+1432 */ { 19, 0, 1, 0, 0 },
/* U+1433 */ { 19, 0, 1, 0, 0 },
/* U+1434 */ { 19, 0, 1, 0, 0 },
/* U+1435 */ { 19, 0, 1, 0, 0 },
/* U+1436 */ { 19, 0, 1, 0, 0 },
/* U+1437 */ { 19, 0, 1, 0, 0 },
/* U+1438 */ { 19, 0, 1, 0, 0 },
/* U+1439 */ { 19, 0, 1, 0, 0 },
/* U+143a */ { 19, 0, 1, 0, 0 },
/* U+143b */ { 19, 0, 1, 0, 0 },
/* U+143c */ { 19, 0, 1, 0, 0 },
/* U+143d */ { 19, 0, 1, 0, 0 },
/* U+143e */ { 19, 0, 1, 0, 0 },
/* U+143f */ { 19, 0, 1, 0, 0 },
/* U+1440 */ { 19, 0, 1, 0, 0 },
/* U+1441 */ { 19, 0, 1, 0, 0 },
/* U+1442 */ { 19, 0, 1, 0, 0 },
/* U+1443 */ { 19, 0, 1, 0, 0 },
/* U+1444 */ { 19, 0, 1, 0, 0 },
/* U+1445 */ { 19, 0, 1, 0, 0 },
/* U+1446 */ { 19, 0, 1, 0, 0 },
/* U+1447 */ { 19, 0, 1, 0, 0 },
/* U+1448 */ { 19, 0, 1, 0, 0 },
/* U+1449 */ { 19, 0, 1, 0, 0 },
/* U+144a */ { 19, 0, 1, 0, 0 },
/* U+144b */ { 19, 0, 1, 0, 0 },
/* U+144c */ { 19, 0, 1, 0, 0 },
/* U+144d */ { 19, 0, 1, 0, 0 },
/* U+144e */ { 19, 0, 1, 0, 0 },
/* U+144f */ { 19, 0, 1, 0, 0 },
/* U+1450 */ { 19, 0, 1, 0, 0 },
/* U+1451 */ { 19, 0, 1, 0, 0 },
/* U+1452 */ { 19, 0, 1, 0, 0 },
/* U+1453 */ { 19, 0, 1, 0, 0 },
/* U+1454 */ { 19, 0, 1, 0, 0 },
/* U+1455 */ { 19, 0, 1, 0, 0 },
/* U+1456 */ { 19, 0, 1, 0, 0 },
/* U+1457 */ { 19, 0, 1, 0, 0 },
/* U+1458 */ { 19, 0, 1, 0, 0 },
/* U+1459 */ { 19, 0, 1, 0, 0 },
/* U+145a */ { 19, 0, 1, 0, 0 },
/* U+145b */ { 19, 0, 1, 0, 0 },
/* U+145c */ { 19, 0, 1, 0, 0 },
/* U+145d */ { 19, 0, 1, 0, 0 },
/* U+145e */ { 19, 0, 1, 0, 0 },
/* U+145f */ { 19, 0, 1, 0, 0 },
/* U+1460 */ { 19, 0, 1, 0, 0 },
/* U+1461 */ { 19, 0, 1, 0, 0 },
/* U+1462 */ { 19, 0, 1, 0, 0 },
/* U+1463 */ { 19, 0, 1, 0, 0 },
/* U+1464 */ { 19, 0, 1, 0, 0 },
/* U+1465 */ { 19, 0, 1, 0, 0 },
/* U+1466 */ { 19, 0, 1, 0, 0 },
/* U+1467 */ { 19, 0, 1, 0, 0 },
/* U+1468 */ { 19, 0, 1, 0, 0 },
/* U+1469 */ { 19, 0, 1, 0, 0 },
/* U+146a */ { 19, 0, 1, 0, 0 },
/* U+146b */ { 19, 0, 1, 0, 0 },
/* U+146c */ { 19, 0, 1, 0, 0 },
/* U+146d */ { 19, 0, 1, 0, 0 },
/* U+146e */ { 19, 0, 1, 0, 0 },
/* U+146f */ { 19, 0, 1, 0, 0 },
/* U+1470 */ { 19, 0, 1, 0, 0 },
/* U+1471 */ { 19, 0, 1, 0, 0 },
/* U+1472 */ { 19, 0, 1, 0, 0 },
/* U+1473 */ { 19, 0, 1, 0, 0 },
/* U+1474 */ { 19, 0, 1, 0, 0 },
/* U+1475 */ { 19, 0, 1, 0, 0 },
/* U+1476 */ { 19, 0, 1, 0, 0 },
/* U+1477 */ { 19, 0, 1, 0, 0 },
/* U+1478 */ { 19, 0, 1, 0, 0 },
/* U+1479 */ { 19, 0, 1, 0, 0 },
/* U+147a */ { 19, 0, 1, 0, 0 },
/* U+147b */ { 19, 0, 1, 0, 0 },
/* U+147c */ { 19, 0, 1, 0, 0 },
/* U+147d */ { 19, 0, 1, 0, 0 },
/* U+147e */ { 19, 0, 1, 0, 0 },
/* U+147f */ { 19, 0, 1, 0, 0 },
/* U+1480 */ { 19, 0, 1, 0, 0 },
/* U+1481 */ { 19, 0, 1, 0, 0 },
/* U+1482 */ { 19, 0, 1, 0, 0 },
/* U+1483 */ { 19, 0, 1, 0, 0 },
/* U+1484 */ { 19, 0, 1, 0, 0 },
/* U+1485 */ { 19, 0, 1, 0, 0 },
/* U+1486 */ { 19, 0, 1, 0, 0 },
/* U+1487 */ { 19, 0, 1, 0, 0 },
/* U+1488 */ { 19, 0, 1, 0, 0 },
/* U+1489 */ { 19, 0, 1, 0, 0 },
/* U+148a */ { 19, 0, 1, 0, 0 },
/* U+148b */ { 19, 0, 1, 0, 0 },
/* U+148c */ { 19, 0, 1, 0, 0 },
/* U+148d */ { 19, 0, 1, 0, 0 },
/* U+148e */ { 19, 0, 1, 0, 0 },
/* U+148f */ { 19, 0, 1, 0, 0 },
/* U+1490 */ { 19, 0, 1, 0, 0 },
/* U+1491 */ { 19, 0, 1, 0, 0 },
/* U+1492 */ { 19, 0, 1, 0, 0 },
/* U+1493 */ { 19, 0, 1, 0, 0 },
/* U+1494 */ { 19, 0, 1, 0, 0 },
/* U+1495 */ { 19, 0, 1, 0, 0 },
/* U+1496 */ { 19, 0, 1, 0, 0 },
/* U+1497 */ { 19, 0, 1, 0, 0 },
/* U+1498 */ { 19, 0, 1, 0, 0 },
/* U+1499 */ { 19, 0, 1, 0, 0 },
/* U+149a */ { 19, 0, 1, 0, 0 },
/* U+149b */ { 19, 0, 1, 0, 0 },
/* U+149c */ { 19, 0, 1, 0, 0 },
/* U+149d */ { 19, 0, 1, 0, 0 },
/* U+149e */ { 19, 0, 1, 0, 0 },
/* U+149f */ { 19, 0, 1, 0, 0 },
/* U+14a0 */ { 19, 0, 1, 0, 0 },
/* U+14a1 */ { 19, 0, 1, 0, 0 },
/* U+14a2 */ { 19, 0, 1, 0, 0 },
/* U+14a3 */ { 19, 0, 1, 0, 0 },
/* U+14a4 */ { 19, 0, 1, 0, 0 },
/* U+14a5 */ { 19, 0, 1, 0, 0 },
/* U+14a6 */ { 19, 0, 1, 0, 0 },
/* U+14a7 */ { 19, 0, 1, 0, 0 },
/* U+14a8 */ { 19, 0, 1, 0, 0 },
/* U+14a9 */ { 19, 0, 1, 0, 0 },
/* U+14aa */ { 19, 0, 1, 0, 0 },
/* U+14ab */ { 19, 0, 1, 0, 0 },
/* U+14ac */ { 19, 0, 1, 0, 0 },
/* U+14ad */ { 19, 0, 1, 0, 0 },
/* U+14ae */ { 19, 0, 1, 0, 0 },
/* U+14af */ { 19, 0, 1, 0, 0 },
/* U+14b0 */ { 19, 0, 1, 0, 0 },
/* U+14b1 */ { 19, 0, 1, 0, 0 },
/* U+14b2 */ { 19, 0, 1, 0, 0 },
/* U+14b3 */ { 19, 0, 1, 0, 0 },
/* U+14b4 */ { 19, 0, 1, 0, 0 },
/* U+14b5 */ { 19, 0, 1, 0, 0 },
/* U+14b6 */ { 19, 0, 1, 0, 0 },
/* U+14b7 */ { 19, 0, 1, 0, 0 },
/* U+14b8 */ { 19, 0, 1, 0, 0 },
/* U+14b9 */ { 19, 0, 1, 0, 0 },
/* U+14ba */ { 19, 0, 1, 0, 0 },
/* U+14bb */ { 19, 0, 1, 0, 0 },
/* U+14bc */ { 19, 0, 1, 0, 0 },
/* U+14bd */ { 19, 0, 1, 0, 0 },
/* U+14be */ { 19, 0, 1, 0, 0 },
/* U+14bf */ { 19, 0, 1, 0, 0 },
/* U+14c0 */ { 19, 0, 1, 0, 0 },
/* U+14c1 */ { 19, 0, 1, 0, 0 },
/* U+14c2 */ { 19, 0, 1, 0, 0 },
/* U+14c3 */ { 19, 0, 1, 0, 0 },
/* U+14c4 */ { 19, 0, 1, 0, 0 },
/* U+14c5 */ { 19, 0, 1, 0, 0 },
/* U+14c6 */ { 19, 0, 1, 0, 0 },
/* U+14c7 */ { 19, 0, 1, 0, 0 },
/* U+14c8 */ { 19, 0, 1, 0, 0 },
/* U+14c9 */ { 19, 0, 1, 0, 0 },
/* U+14ca */ { 19, 0, 1, 0, 0 },
/* U+14cb */ { 19, 0, 1, 0, 0 },
/* U+14cc */ { 19, 0, 1, 0, 0 },
/* U+14cd */ { 19, 0, 1, 0, 0 },
/* U+14ce */ { 19, 0, 1, 0, 0 },
/* U+14cf */ { 19, 0, 1, 0, 0 },
/* U+14d0 */ { 19, 0, 1, 0, 0 },
/* U+14d1 */ { 19, 0, 1, 0, 0 },
/* U+14d2 */ { 19, 0, 1, 0, 0 },
/* U+14d3 */ { 19, 0, 1, 0, 0 },
/* U+14d4 */ { 19, 0, 1, 0, 0 },
/* U+14d5 */ { 19, 0, 1, 0, 0 },
/* U+14d6 */ { 19, 0, 1, 0, 0 },
/* U+14d7 */ { 19, 0, 1, 0, 0 },
/* U+14d8 */ { 19, 0, 1, 0, 0 },
/* U+14d9 */ { 19, 0, 1, 0, 0 },
/* U+14da */ { 19, 0, 1, 0, 0 },
/* U+14db */ { 19, 0, 1, 0, 0 },
/* U+14dc */ { 19, 0, 1, 0, 0 },
/* U+14dd */ { 19, 0, 1, 0, 0 },
/* U+14de */ { 19, 0, 1, 0, 0 },
/* U+14df */ { 19, 0, 1, 0, 0 },
/* U+14e0 */ { 19, 0, 1, 0, 0 },
/* U+14e1 */ { 19, 0, 1, 0, 0 },
/* U+14e2 */ { 19, 0, 1, 0, 0 },
/* U+14e3 */ { 19, 0, 1, 0, 0 },
/* U+14e4 */ { 19, 0, 1, 0, 0 },
/* U+14e5 */ { 19, 0, 1, 0, 0 },
/* U+14e6 */ { 19, 0, 1, 0, 0 },
/* U+14e7 */ { 19, 0, 1, 0, 0 },
/* U+14e8 */ { 19, 0, 1, 0, 0 },
/* U+14e9 */ { 19, 0, 1, 0, 0 },
/* U+14ea */ { 19, 0, 1, 0, 0 },
/* U+14eb */ { 19, 0, 1, 0, 0 },
/* U+14ec */ { 19, 0, 1, 0, 0 },
/* U+14ed */ { 19, 0, 1, 0, 0 },
/* U+14ee */ { 19, 0, 1, 0, 0 },
/* U+14ef */ { 19, 0, 1, 0, 0 },
/* U+14f0 */ { 19, 0, 1, 0, 0 },
/* U+14f1 */ { 19, 0, 1, 0, 0 },
/* U+14f2 */ { 19, 0, 1, 0, 0 },
/* U+14f3 */ { 19, 0, 1, 0, 0 },
/* U+14f4 */ { 19, 0, 1, 0, 0 },
/* U+14f5 */ { 19, 0, 1, 0, 0 },
/* U+14f6 */ { 19, 0, 1, 0, 0 },
/* U+14f7 */ { 19, 0, 1, 0, 0 },
/* U+14f8 */ { 19, 0, 1, 0, 0 },
/* U+14f9 */ { 19, 0, 1, 0, 0 },
/* U+14fa */ { 19, 0, 1, 0, 0 },
/* U+14fb */ { 19, 0, 1, 0, 0 },
/* U+14fc */ { 19, 0, 1, 0, 0 },
/* U+14fd */ { 19, 0, 1, 0, 0 },
/* U+14fe */ { 19, 0, 1, 0, 0 },
/* U+14ff */ { 19, 0, 1, 0, 0 },
/* U+1500 */ { 19, 0, 1, 0, 0 },
/* U+1501 */ { 19, 0, 1, 0, 0 },
/* U+1502 */ { 19, 0, 1, 0, 0 },
/* U+1503 */ { 19, 0, 1, 0, 0 },
/* U+1504 */ { 19, 0, 1, 0, 0 },
/* U+1505 */ { 19, 0, 1, 0, 0 },
/* U+1506 */ { 19, 0, 1, 0, 0 },
/* U+1507 */ { 19, 0, 1, 0, 0 },
/* U+1508 */ { 19, 0, 1, 0, 0 },
/* U+1509 */ { 19, 0, 1, 0, 0 },
/* U+150a */ { 19, 0, 1, 0, 0 },
/* U+150b */ { 19, 0, 1, 0, 0 },
/* U+150c */ { 19, 0, 1, 0, 0 },
/* U+150d */ { 19, 0, 1, 0, 0 },
/* U+150e */ { 19, 0, 1, 0, 0 },
/* U+150f */ { 19, 0, 1, 0, 0 },
/* U+1510 */ { 19, 0, 1, 0, 0 },
/* U+1511 */ { 19, 0, 1, 0, 0 },
/* U+1512 */ { 19, 0, 1, 0, 0 },
/* U+1513 */ { 19, 0, 1, 0, 0 },
/* U+1514 */ { 19, 0, 1, 0, 0 },
/* U+1515 */ { 19, 0, 1, 0, 0 },
/* U+1516 */ { 19, 0, 1, 0, 0 },
/* U+1517 */ { 19, 0, 1, 0, 0 },
/* U+1518 */ { 19, 0, 1, 0, 0 },
/* U+1519 */ { 19, 0, 1, 0, 0 },
/* U+151a */ { 19, 0, 1, 0, 0 },
/* U+151b */ { 19, 0, 1, 0, 0 },
/* U+151c */ { 19, 0, 1, 0, 0 },
/* U+151d */ { 19, 0, 1, 0, 0 },
/* U+151e */ { 19, 0, 1, 0, 0 },
/* U+151f */ { 19, 0, 1, 0, 0 },
/* U+1520 */ { 19, 0, 1, 0, 0 },
/* U+1521 */ { 19, 0, 1, 0, 0 },
/* U+1522 */ { 19, 0, 1, 0, 0 },
/* U+1523 */ { 19, 0, 1, 0, 0 },
/* U+1524 */ { 19, 0, 1, 0, 0 },
/* U+1525 */ { 19, 0, 1, 0, 0 },
/* U+1526 */ { 19, 0, 1, 0, 0 },
/* U+1527 */ { 19, 0, 1, 0, 0 },
/* U+1528 */ { 19, 0, 1, 0, 0 },
/* U+1529 */ { 19, 0, 1, 0, 0 },
/* U+152a */ { 19, 0, 1, 0, 0 },
/* U+152b */ { 19, 0, 1, 0, 0 },
/* U+152c */ { 19, 0, 1, 0, 0 },
/* U+152d */ { 19, 0, 1, 0, 0 },
/* U+152e */ { 19, 0, 1, 0, 0 },
/* U+152f */ { 19, 0, 1, 0, 0 },
/* U+1530 */ { 19, 0, 1, 0, 0 },
/* U+1531 */ { 19, 0, 1, 0, 0 },
/* U+1532 */ { 19, 0, 1, 0, 0 },
/* U+1533 */ { 19, 0, 1, 0, 0 },
/* U+1534 */ { 19, 0, 1, 0, 0 },
/* U+1535 */ { 19, 0, 1, 0, 0 },
/* U+1536 */ { 19, 0, 1, 0, 0 },
/* U+1537 */ { 19, 0, 1, 0, 0 },
/* U+1538 */ { 19, 0, 1, 0, 0 },
/* U+1539 */ { 19, 0, 1, 0, 0 },
/* U+153a */ { 19, 0, 1, 0, 0 },
/* U+153b */ { 19, 0, 1, 0, 0 },
/* U+153c */ { 19, 0, 1, 0, 0 },
/* U+153d */ { 19, 0, 1, 0, 0 },
/* U+153e */ { 19, 0, 1, 0, 0 },
/* U+153f */ { 19, 0, 1, 0, 0 },
/* U+1540 */ { 19, 0, 1, 0, 0 },
/* U+1541 */ { 19, 0, 1, 0, 0 },
/* U+1542 */ { 19, 0, 1, 0, 0 },
/* U+1543 */ { 19, 0, 1, 0, 0 },
/* U+1544 */ { 19, 0, 1, 0, 0 },
/* U+1545 */ { 19, 0, 1, 0, 0 },
/* U+1546 */ { 19, 0, 1, 0, 0 },
/* U+1547 */ { 19, 0, 1, 0, 0 },
/* U+1548 */ { 19, 0, 1, 0, 0 },
/* U+1549 */ { 19, 0, 1, 0, 0 },
/* U+154a */ { 19, 0, 1, 0, 0 },
/* U+154b */ { 19, 0, 1, 0, 0 },
/* U+154c */ { 19, 0, 1, 0, 0 },
/* U+154d */ { 19, 0, 1, 0, 0 },
/* U+154e */ { 19, 0, 1, 0, 0 },
/* U+154f */ { 19, 0, 1, 0, 0 },
/* U+1550 */ { 19, 0, 1, 0, 0 },
/* U+1551 */ { 19, 0, 1, 0, 0 },
/* U+1552 */ { 19, 0, 1, 0, 0 },
/* U+1553 */ { 19, 0, 1, 0, 0 },
/* U+1554 */ { 19, 0, 1, 0, 0 },
/* U+1555 */ { 19, 0, 1, 0, 0 },
/* U+1556 */ { 19, 0, 1, 0, 0 },
/* U+1557 */ { 19, 0, 1, 0, 0 },
/* U+1558 */ { 19, 0, 1, 0, 0 },
/* U+1559 */ { 19, 0, 1, 0, 0 },
/* U+155a */ { 19, 0, 1, 0, 0 },
/* U+155b */ { 19, 0, 1, 0, 0 },
/* U+155c */ { 19, 0, 1, 0, 0 },
/* U+155d */ { 19, 0, 1, 0, 0 },
/* U+155e */ { 19, 0, 1, 0, 0 },
/* U+155f */ { 19, 0, 1, 0, 0 },
/* U+1560 */ { 19, 0, 1, 0, 0 },
/* U+1561 */ { 19, 0, 1, 0, 0 },
/* U+1562 */ { 19, 0, 1, 0, 0 },
/* U+1563 */ { 19, 0, 1, 0, 0 },
/* U+1564 */ { 19, 0, 1, 0, 0 },
/* U+1565 */ { 19, 0, 1, 0, 0 },
/* U+1566 */ { 19, 0, 1, 0, 0 },
/* U+1567 */ { 19, 0, 1, 0, 0 },
/* U+1568 */ { 19, 0, 1, 0, 0 },
/* U+1569 */ { 19, 0, 1, 0, 0 },
/* U+156a */ { 19, 0, 1, 0, 0 },
/* U+156b */ { 19, 0, 1, 0, 0 },
/* U+156c */ { 19, 0, 1, 0, 0 },
/* U+156d */ { 19, 0, 1, 0, 0 },
/* U+156e */ { 19, 0, 1, 0, 0 },
/* U+156f */ { 19, 0, 1, 0, 0 },
/* U+1570 */ { 19, 0, 1, 0, 0 },
/* U+1571 */ { 19, 0, 1, 0, 0 },
/* U+1572 */ { 19, 0, 1, 0, 0 },
/* U+1573 */ { 19, 0, 1, 0, 0 },
/* U+1574 */ { 19, 0, 1, 0, 0 },
/* U+1575 */ { 19, 0, 1, 0, 0 },
/* U+1576 */ { 19, 0, 1, 0, 0 },
/* U+1577 */ { 19, 0, 1, 0, 0 },
/* U+1578 */ { 19, 0, 1, 0, 0 },
/* U+1579 */ { 19, 0, 1, 0, 0 },
/* U+157a */ { 19, 0, 1, 0, 0 },
/* U+157b */ { 19, 0, 1, 0, 0 },
/* U+157c */ { 19, 0, 1, 0, 0 },
/* U+157d */ { 19, 0, 1, 0, 0 },
/* U+157e */ { 19, 0, 1, 0, 0 },
/* U+157f */ { 19, 0, 1, 0, 0 },
/* U+1580 */ { 19, 0, 1, 0, 0 },
/* U+1581 */ { 19, 0, 1, 0, 0 },
/* U+1582 */ { 19, 0, 1, 0, 0 },
/* U+1583 */ { 19, 0, 1, 0, 0 },
/* U+1584 */ { 19, 0, 1, 0, 0 },
/* U+1585 */ { 19, 0, 1, 0, 0 },
/* U+1586 */ { 19, 0, 1, 0, 0 },
/* U+1587 */ { 19, 0, 1, 0, 0 },
/* U+1588 */ { 19, 0, 1, 0, 0 },
/* U+1589 */ { 19, 0, 1, 0, 0 },
/* U+158a */ { 19, 0, 1, 0, 0 },
/* U+158b */ { 19, 0, 1, 0, 0 },
/* U+158c */ { 19, 0, 1, 0, 0 },
/* U+158d */ { 19, 0, 1, 0, 0 },
/* U+158e */ { 19, 0, 1, 0, 0 },
/* U+158f */ { 19, 0, 1, 0, 0 },
/* U+1590 */ { 19, 0, 1, 0, 0 },
/* U+1591 */ { 19, 0, 1, 0, 0 },
/* U+1592 */ { 19, 0, 1, 0, 0 },
/* U+1593 */ { 19, 0, 1, 0, 0 },
/* U+1594 */ { 19, 0, 1, 0, 0 },
/* U+1595 */ { 19, 0, 1, 0, 0 },
/* U+1596 */ { 19, 0, 1, 0, 0 },
/* U+1597 */ { 19, 0, 1, 0, 0 },
/* U+1598 */ { 19, 0, 1, 0, 0 },
/* U+1599 */ { 19, 0, 1, 0, 0 },
/* U+159a */ { 19, 0, 1, 0, 0 },
/* U+159b */ { 19, 0, 1, 0, 0 },
/* U+159c */ { 19, 0, 1, 0, 0 },
/* U+159d */ { 19, 0, 1, 0, 0 },
/* U+159e */ { 19, 0, 1, 0, 0 },
/* U+159f */ { 19, 0, 1, 0, 0 },
/* U+15a0 */ { 19, 0, 1, 0, 0 },
/* U+15a1 */ { 19, 0, 1, 0, 0 },
/* U+15a2 */ { 19, 0, 1, 0, 0 },
/* U+15a3 */ { 19, 0, 1, 0, 0 },
/* U+15a4 */ { 19, 0, 1, 0, 0 },
/* U+15a5 */ { 19, 0, 1, 0, 0 },
/* U+15a6 */ { 19, 0, 1, 0, 0 },
/* U+15a7 */ { 19, 0, 1, 0, 0 },
/* U+15a8 */ { 19, 0, 1, 0, 0 },
/* U+15a9 */ { 19, 0, 1, 0, 0 },
/* U+15aa */ { 19, 0, 1, 0, 0 },
/* U+15ab */ { 19, 0, 1, 0, 0 },
/* U+15ac */ { 19, 0, 1, 0, 0 },
/* U+15ad */ { 19, 0, 1, 0, 0 },
/* U+15ae */ { 19, 0, 1, 0, 0 },
/* U+15af */ { 19, 0, 1, 0, 0 },
/* U+15b0 */ { 19, 0, 1, 0, 0 },
/* U+15b1 */ { 19, 0, 1, 0, 0 },
/* U+15b2 */ { 19, 0, 1, 0, 0 },
/* U+15b3 */ { 19, 0, 1, 0, 0 },
/* U+15b4 */ { 19, 0, 1, 0, 0 },
/* U+15b5 */ { 19, 0, 1, 0, 0 },
/* U+15b6 */ { 19, 0, 1, 0, 0 },
/* U+15b7 */ { 19, 0, 1, 0, 0 },
/* U+15b8 */ { 19, 0, 1, 0, 0 },
/* U+15b9 */ { 19, 0, 1, 0, 0 },
/* U+15ba */ { 19, 0, 1, 0, 0 },
/* U+15bb */ { 19, 0, 1, 0, 0 },
/* U+15bc */ { 19, 0, 1, 0, 0 },
/* U+15bd */ { 19, 0, 1, 0, 0 },
/* U+15be */ { 19, 0, 1, 0, 0 },
/* U+15bf */ { 19, 0, 1, 0, 0 },
/* U+15c0 */ { 19, 0, 1, 0, 0 },
/* U+15c1 */ { 19, 0, 1, 0, 0 },
/* U+15c2 */ { 19, 0, 1, 0, 0 },
/* U+15c3 */ { 19, 0, 1, 0, 0 },
/* U+15c4 */ { 19, 0, 1, 0, 0 },
/* U+15c5 */ { 19, 0, 1, 0, 0 },
/* U+15c6 */ { 19, 0, 1, 0, 0 },
/* U+15c7 */ { 19, 0, 1, 0, 0 },
/* U+15c8 */ { 19, 0, 1, 0, 0 },
/* U+15c9 */ { 19, 0, 1, 0, 0 },
/* U+15ca */ { 19, 0, 1, 0, 0 },
/* U+15cb */ { 19, 0, 1, 0, 0 },
/* U+15cc */ { 19, 0, 1, 0, 0 },
/* U+15cd */ { 19, 0, 1, 0, 0 },
/* U+15ce */ { 19, 0, 1, 0, 0 },
/* U+15cf */ { 19, 0, 1, 0, 0 },
/* U+15d0 */ { 19, 0, 1, 0, 0 },
/* U+15d1 */ { 19, 0, 1, 0, 0 },
/* U+15d2 */ { 19, 0, 1, 0, 0 },
/* U+15d3 */ { 19, 0, 1, 0, 0 },
/* U+15d4 */ { 19, 0, 1, 0, 0 },
/* U+15d5 */ { 19, 0, 1, 0, 0 },
/* U+15d6 */ { 19, 0, 1, 0, 0 },
/* U+15d7 */ { 19, 0, 1, 0, 0 },
/* U+15d8 */ { 19, 0, 1, 0, 0 },
/* U+15d9 */ { 19, 0, 1, 0, 0 },
/* U+15da */ { 19, 0, 1, 0, 0 },
/* U+15db */ { 19, 0, 1, 0, 0 },
/* U+15dc */ { 19, 0, 1, 0, 0 },
/* U+15dd */ { 19, 0, 1, 0, 0 },
/* U+15de */ { 19, 0, 1, 0, 0 },
/* U+15df */ { 19, 0, 1, 0, 0 },
/* U+15e0 */ { 19, 0, 1, 0, 0 },
/* U+15e1 */ { 19, 0, 1, 0, 0 },
/* U+15e2 */ { 19, 0, 1, 0, 0 },
/* U+15e3 */ { 19, 0, 1, 0, 0 },
/* U+15e4 */ { 19, 0, 1, 0, 0 },
/* U+15e5 */ { 19, 0, 1, 0, 0 },
/* U+15e6 */ { 19, 0, 1, 0, 0 },
/* U+15e7 */ { 19, 0, 1, 0, 0 },
/* U+15e8 */ { 19, 0, 1, 0, 0 },
/* U+15e9 */ { 19, 0, 1, 0, 0 },
/* U+15ea */ { 19, 0, 1, 0, 0 },
/* U+15eb */ { 19, 0, 1, 0, 0 },
/* U+15ec */ { 19, 0, 1, 0, 0 },
/* U+15ed */ { 19, 0, 1, 0, 0 },
/* U+15ee */ { 19, 0, 1, 0, 0 },
/* U+15ef */ { 19, 0, 1, 0, 0 },
/* U+15f0 */ { 19, 0, 1, 0, 0 },
/* U+15f1 */ { 19, 0, 1, 0, 0 },
/* U+15f2 */ { 19, 0, 1, 0, 0 },
/* U+15f3 */ { 19, 0, 1, 0, 0 },
/* U+15f4 */ { 19, 0, 1, 0, 0 },
/* U+15f5 */ { 19, 0, 1, 0, 0 },
/* U+15f6 */ { 19, 0, 1, 0, 0 },
/* U+15f7 */ { 19, 0, 1, 0, 0 },
/* U+15f8 */ { 19, 0, 1, 0, 0 },
/* U+15f9 */ { 19, 0, 1, 0, 0 },
/* U+15fa */ { 19, 0, 1, 0, 0 },
/* U+15fb */ { 19, 0, 1, 0, 0 },
/* U+15fc */ { 19, 0, 1, 0, 0 },
/* U+15fd */ { 19, 0, 1, 0, 0 },
/* U+15fe */ { 19, 0, 1, 0, 0 },
/* U+15ff */ { 19, 0, 1, 0, 0 },
/* U+1600 */ { 19, 0, 1, 0, 0 },
/* U+1601 */ { 19, 0, 1, 0, 0 },
/* U+1602 */ { 19, 0, 1, 0, 0 },
/* U+1603 */ { 19, 0, 1, 0, 0 },
/* U+1604 */ { 19, 0, 1, 0, 0 },
/* U+1605 */ { 19, 0, 1, 0, 0 },
/* U+1606 */ { 19, 0, 1, 0, 0 },
/* U+1607 */ { 19, 0, 1, 0, 0 },
/* U+1608 */ { 19, 0, 1, 0, 0 },
/* U+1609 */ { 19, 0, 1, 0, 0 },
/* U+160a */ { 19, 0, 1, 0, 0 },
/* U+160b */ { 19, 0, 1, 0, 0 },
/* U+160c */ { 19, 0, 1, 0, 0 },
/* U+160d */ { 19, 0, 1, 0, 0 },
/* U+160e */ { 19, 0, 1, 0, 0 },
/* U+160f */ { 19, 0, 1, 0, 0 },
/* U+1610 */ { 19, 0, 1, 0, 0 },
/* U+1611 */ { 19, 0, 1, 0, 0 },
/* U+1612 */ { 19, 0, 1, 0, 0 },
/* U+1613 */ { 19, 0, 1, 0, 0 },
/* U+1614 */ { 19, 0, 1, 0, 0 },
/* U+1615 */ { 19, 0, 1, 0, 0 },
/* U+1616 */ { 19, 0, 1, 0, 0 },
/* U+1617 */ { 19, 0, 1, 0, 0 },
/* U+1618 */ { 19, 0, 1, 0, 0 },
/* U+1619 */ { 19, 0, 1, 0, 0 },
/* U+161a */ { 19, 0, 1, 0, 0 },
/* U+161b */ { 19, 0, 1, 0, 0 },
/* U+161c */ { 19, 0, 1, 0, 0 },
/* U+161d */ { 19, 0, 1, 0, 0 },
/* U+161e */ { 19, 0, 1, 0, 0 },
/* U+161f */ { 19, 0, 1, 0, 0 },
/* U+1620 */ { 19, 0, 1, 0, 0 },
/* U+1621 */ { 19, 0, 1, 0, 0 },
/* U+1622 */ { 19, 0, 1, 0, 0 },
/* U+1623 */ { 19, 0, 1, 0, 0 },
/* U+1624 */ { 19, 0, 1, 0, 0 },
/* U+1625 */ { 19, 0, 1, 0, 0 },
/* U+1626 */ { 19, 0, 1, 0, 0 },
/* U+1627 */ { 19, 0, 1, 0, 0 },
/* U+1628 */ { 19, 0, 1, 0, 0 },
/* U+1629 */ { 19, 0, 1, 0, 0 },
/* U+162a */ { 19, 0, 1, 0, 0 },
/* U+162b */ { 19, 0, 1, 0, 0 },
/* U+162c */ { 19, 0, 1, 0, 0 },
/* U+162d */ { 19, 0, 1, 0, 0 },
/* U+162e */ { 19, 0, 1, 0, 0 },
/* U+162f */ { 19, 0, 1, 0, 0 },
/* U+1630 */ { 19, 0, 1, 0, 0 },
/* U+1631 */ { 19, 0, 1, 0, 0 },
/* U+1632 */ { 19, 0, 1, 0, 0 },
/* U+1633 */ { 19, 0, 1, 0, 0 },
/* U+1634 */ { 19, 0, 1, 0, 0 },
/* U+1635 */ { 19, 0, 1, 0, 0 },
/* U+1636 */ { 19, 0, 1, 0, 0 },
/* U+1637 */ { 19, 0, 1, 0, 0 },
/* U+1638 */ { 19, 0, 1, 0, 0 },
/* U+1639 */ { 19, 0, 1, 0, 0 },
/* U+163a */ { 19, 0, 1, 0, 0 },
/* U+163b */ { 19, 0, 1, 0, 0 },
/* U+163c */ { 19, 0, 1, 0, 0 },
/* U+163d */ { 19, 0, 1, 0, 0 },
/* U+163e */ { 19, 0, 1, 0, 0 },
/* U+163f */ { 19, 0, 1, 0, 0 },
/* U+1640 */ { 19, 0, 1, 0, 0 },
/* U+1641 */ { 19, 0, 1, 0, 0 },
/* U+1642 */ { 19, 0, 1, 0, 0 },
/* U+1643 */ { 19, 0, 1, 0, 0 },
/* U+1644 */ { 19, 0, 1, 0, 0 },
/* U+1645 */ { 19, 0, 1, 0, 0 },
/* U+1646 */ { 19, 0, 1, 0, 0 },
/* U+1647 */ { 19, 0, 1, 0, 0 },
/* U+1648 */ { 19, 0, 1, 0, 0 },
/* U+1649 */ { 19, 0, 1, 0, 0 },
/* U+164a */ { 19, 0, 1, 0, 0 },
/* U+164b */ { 19, 0, 1, 0, 0 },
/* U+164c */ { 19, 0, 1, 0, 0 },
/* U+164d */ { 19, 0, 1, 0, 0 },
/* U+164e */ { 19, 0, 1, 0, 0 },
/* U+164f */ { 19, 0, 1, 0, 0 },
/* U+1650 */ { 19, 0, 1, 0, 0 },
/* U+1651 */ { 19, 0, 1, 0, 0 },
/* U+1652 */ { 19, 0, 1, 0, 0 },
/* U+1653 */ { 19, 0, 1, 0, 0 },
/* U+1654 */ { 19, 0, 1, 0, 0 },
/* U+1655 */ { 19, 0, 1, 0, 0 },
/* U+1656 */ { 19, 0, 1, 0, 0 },
/* U+1657 */ { 19, 0, 1, 0, 0 },
/* U+1658 */ { 19, 0, 1, 0, 0 },
/* U+1659 */ { 19, 0, 1, 0, 0 },
/* U+165a */ { 19, 0, 1, 0, 0 },
/* U+165b */ { 19, 0, 1, 0, 0 },
/* U+165c */ { 19, 0, 1, 0, 0 },
/* U+165d */ { 19, 0, 1, 0, 0 },
/* U+165e */ { 19, 0, 1, 0, 0 },
/* U+165f */ { 19, 0, 1, 0, 0 },
/* U+1660 */ { 19, 0, 1, 0, 0 },
/* U+1661 */ { 19, 0, 1, 0, 0 },
/* U+1662 */ { 19, 0, 1, 0, 0 },
/* U+1663 */ { 19, 0, 1, 0, 0 },
/* U+1664 */ { 19, 0, 1, 0, 0 },
/* U+1665 */ { 19, 0, 1, 0, 0 },
/* U+1666 */ { 19, 0, 1, 0, 0 },
/* U+1667 */ { 19, 0, 1, 0, 0 },
/* U+1668 */ { 19, 0, 1, 0, 0 },
/* U+1669 */ { 19, 0, 1, 0, 0 },
/* U+166a */ { 19, 0, 1, 0, 0 },
/* U+166b */ { 19, 0, 1, 0, 0 },
/* U+166c */ { 19, 0, 1, 0, 0 },
/* U+166d */ { 26, 0, 1, 0, 0 },
/* U+166e */ { 26, 0, 1, 0, 0 },
/* U+166f */ { 19, 0, 1, 0, 0 },
/* U+1670 */ { 19, 0, 1, 0, 0 },
/* U+1671 */ { 19, 0, 1, 0, 0 },
/* U+1672 */ { 19, 0, 1, 0, 0 },
/* U+1673 */ { 19, 0, 1, 0, 0 },
/* U+1674 */ { 19, 0, 1, 0, 0 },
/* U+1675 */ { 19, 0, 1, 0, 0 },
/* U+1676 */ { 19, 0, 1, 0, 0 },
/* U+1677 */ { 0, 0, 0, 0, 0 },
/* U+1678 */ { 0, 0, 0, 0, 0 },
/* U+1679 */ { 0, 0, 0, 0, 0 },
/* U+167a */ { 0, 0, 0, 0, 0 },
/* U+167b */ { 0, 0, 0, 0, 0 },
/* U+167c */ { 0, 0, 0, 0, 0 },
/* U+167d */ { 0, 0, 0, 0, 0 },
/* U+167e */ { 0, 0, 0, 0, 0 },
/* U+167f */ { 0, 0, 0, 0, 0 },
/* U+1680 */ { 10, 0, 18, 0, 0 },
/* U+1681 */ { 19, 0, 1, 0, 0 },
/* U+1682 */ { 19, 0, 1, 0, 0 },
/* U+1683 */ { 19, 0, 1, 0, 0 },
/* U+1684 */ { 19, 0, 1, 0, 0 },
/* U+1685 */ { 19, 0, 1, 0, 0 },
/* U+1686 */ { 19, 0, 1, 0, 0 },
/* U+1687 */ { 19, 0, 1, 0, 0 },
/* U+1688 */ { 19, 0, 1, 0, 0 },
/* U+1689 */ { 19, 0, 1, 0, 0 },
/* U+168a */ { 19, 0, 1, 0, 0 },
/* U+168b */ { 19, 0, 1, 0, 0 },
/* U+168c */ { 19, 0, 1, 0, 0 },
/* U+168d */ { 19, 0, 1, 0, 0 },
/* U+168e */ { 19, 0, 1, 0, 0 },
/* U+168f */ { 19, 0, 1, 0, 0 },
/* U+1690 */ { 19, 0, 1, 0, 0 },
/* U+1691 */ { 19, 0, 1, 0, 0 },
/* U+1692 */ { 19, 0, 1, 0, 0 },
/* U+1693 */ { 19, 0, 1, 0, 0 },
/* U+1694 */ { 19, 0, 1, 0, 0 },
/* U+1695 */ { 19, 0, 1, 0, 0 },
/* U+1696 */ { 19, 0, 1, 0, 0 },
/* U+1697 */ { 19, 0, 1, 0, 0 },
/* U+1698 */ { 19, 0, 1, 0, 0 },
/* U+1699 */ { 19, 0, 1, 0, 0 },
/* U+169a */ { 19, 0, 1, 0, 0 },
/* U+169b */ { 22, 0, 19, 0, 0 },
/* U+169c */ { 23, 0, 19, 0, 0 },
/* U+169d */ { 0, 0, 0, 0, 0 },
/* U+169e */ { 0, 0, 0, 0, 0 },
/* U+169f */ { 0, 0, 0, 0, 0 },
/* U+16a0 */ { 19, 0, 1, 0, 0 },
/* U+16a1 */ { 19, 0, 1, 0, 0 },
/* U+16a2 */ { 19, 0, 1, 0, 0 },
/* U+16a3 */ { 19, 0, 1, 0, 0 },
/* U+16a4 */ { 19, 0, 1, 0, 0 },
/* U+16a5 */ { 19, 0, 1, 0, 0 },
/* U+16a6 */ { 19, 0, 1, 0, 0 },
/* U+16a7 */ { 19, 0, 1, 0, 0 },
/* U+16a8 */ { 19, 0, 1, 0, 0 },
/* U+16a9 */ { 19, 0, 1, 0, 0 },
/* U+16aa */ { 19, 0, 1, 0, 0 },
/* U+16ab */ { 19, 0, 1, 0, 0 },
/* U+16ac */ { 19, 0, 1, 0, 0 },
/* U+16ad */ { 19, 0, 1, 0, 0 },
/* U+16ae */ { 19, 0, 1, 0, 0 },
/* U+16af */ { 19, 0, 1, 0, 0 },
/* U+16b0 */ { 19, 0, 1, 0, 0 },
/* U+16b1 */ { 19, 0, 1, 0, 0 },
/* U+16b2 */ { 19, 0, 1, 0, 0 },
/* U+16b3 */ { 19, 0, 1, 0, 0 },
/* U+16b4 */ { 19, 0, 1, 0, 0 },
/* U+16b5 */ { 19, 0, 1, 0, 0 },
/* U+16b6 */ { 19, 0, 1, 0, 0 },
/* U+16b7 */ { 19, 0, 1, 0, 0 },
/* U+16b8 */ { 19, 0, 1, 0, 0 },
/* U+16b9 */ { 19, 0, 1, 0, 0 },
/* U+16ba */ { 19, 0, 1, 0, 0 },
/* U+16bb */ { 19, 0, 1, 0, 0 },
/* U+16bc */ { 19, 0, 1, 0, 0 },
/* U+16bd */ { 19, 0, 1, 0, 0 },
/* U+16be */ { 19, 0, 1, 0, 0 },
/* U+16bf */ { 19, 0, 1, 0, 0 },
/* U+16c0 */ { 19, 0, 1, 0, 0 },
/* U+16c1 */ { 19, 0, 1, 0, 0 },
/* U+16c2 */ { 19, 0, 1, 0, 0 },
/* U+16c3 */ { 19, 0, 1, 0, 0 },
/* U+16c4 */ { 19, 0, 1, 0, 0 },
/* U+16c5 */ { 19, 0, 1, 0, 0 },
/* U+16c6 */ { 19, 0, 1, 0, 0 },
/* U+16c7 */ { 19, 0, 1, 0, 0 },
/* U+16c8 */ { 19, 0, 1, 0, 0 },
/* U+16c9 */ { 19, 0, 1, 0, 0 },
/* U+16ca */ { 19, 0, 1, 0, 0 },
/* U+16cb */ { 19, 0, 1, 0, 0 },
/* U+16cc */ { 19, 0, 1, 0, 0 },
/* U+16cd */ { 19, 0, 1, 0, 0 },
/* U+16ce */ { 19, 0, 1, 0, 0 },
/* U+16cf */ { 19, 0, 1, 0, 0 },
/* U+16d0 */ { 19, 0, 1, 0, 0 },
/* U+16d1 */ { 19, 0, 1, 0, 0 },
/* U+16d2 */ { 19, 0, 1, 0, 0 },
/* U+16d3 */ { 19, 0, 1, 0, 0 },
/* U+16d4 */ { 19, 0, 1, 0, 0 },
/* U+16d5 */ { 19, 0, 1, 0, 0 },
/* U+16d6 */ { 19, 0, 1, 0, 0 },
/* U+16d7 */ { 19, 0, 1, 0, 0 },
/* U+16d8 */ { 19, 0, 1, 0, 0 },
/* U+16d9 */ { 19, 0, 1, 0, 0 },
/* U+16da */ { 19, 0, 1, 0, 0 },
/* U+16db */ { 19, 0, 1, 0, 0 },
/* U+16dc */ { 19, 0, 1, 0, 0 },
/* U+16dd */ { 19, 0, 1, 0, 0 },
/* U+16de */ { 19, 0, 1, 0, 0 },
/* U+16df */ { 19, 0, 1, 0, 0 },
/* U+16e0 */ { 19, 0, 1, 0, 0 },
/* U+16e1 */ { 19, 0, 1, 0, 0 },
/* U+16e2 */ { 19, 0, 1, 0, 0 },
/* U+16e3 */ { 19, 0, 1, 0, 0 },
/* U+16e4 */ { 19, 0, 1, 0, 0 },
/* U+16e5 */ { 19, 0, 1, 0, 0 },
/* U+16e6 */ { 19, 0, 1, 0, 0 },
/* U+16e7 */ { 19, 0, 1, 0, 0 },
/* U+16e8 */ { 19, 0, 1, 0, 0 },
/* U+16e9 */ { 19, 0, 1, 0, 0 },
/* U+16ea */ { 19, 0, 1, 0, 0 },
/* U+16eb */ { 26, 0, 1, 0, 0 },
/* U+16ec */ { 26, 0, 1, 0, 0 },
/* U+16ed */ { 26, 0, 1, 0, 0 },
/* U+16ee */ { 9, 0, 1, 0, 0 },
/* U+16ef */ { 9, 0, 1, 0, 0 },
/* U+16f0 */ { 9, 0, 1, 0, 0 },
/* U+16f1 */ { 0, 0, 0, 0, 0 },
/* U+16f2 */ { 0, 0, 0, 0, 0 },
/* U+16f3 */ { 0, 0, 0, 0, 0 },
/* U+16f4 */ { 0, 0, 0, 0, 0 },
/* U+16f5 */ { 0, 0, 0, 0, 0 },
/* U+16f6 */ { 0, 0, 0, 0, 0 },
/* U+16f7 */ { 0, 0, 0, 0, 0 },
/* U+16f8 */ { 0, 0, 0, 0, 0 },
/* U+16f9 */ { 0, 0, 0, 0, 0 },
/* U+16fa */ { 0, 0, 0, 0, 0 },
/* U+16fb */ { 0, 0, 0, 0, 0 },
/* U+16fc */ { 0, 0, 0, 0, 0 },
/* U+16fd */ { 0, 0, 0, 0, 0 },
/* U+16fe */ { 0, 0, 0, 0, 0 },
/* U+16ff */ { 0, 0, 0, 0, 0 },
/* U+1700 */ { 0, 0, 0, 0, 0 },
/* U+1701 */ { 0, 0, 0, 0, 0 },
/* U+1702 */ { 0, 0, 0, 0, 0 },
/* U+1703 */ { 0, 0, 0, 0, 0 },
/* U+1704 */ { 0, 0, 0, 0, 0 },
/* U+1705 */ { 0, 0, 0, 0, 0 },
/* U+1706 */ { 0, 0, 0, 0, 0 },
/* U+1707 */ { 0, 0, 0, 0, 0 },
/* U+1708 */ { 0, 0, 0, 0, 0 },
/* U+1709 */ { 0, 0, 0, 0, 0 },
/* U+170a */ { 0, 0, 0, 0, 0 },
/* U+170b */ { 0, 0, 0, 0, 0 },
/* U+170c */ { 0, 0, 0, 0, 0 },
/* U+170d */ { 0, 0, 0, 0, 0 },
/* U+170e */ { 0, 0, 0, 0, 0 },
/* U+170f */ { 0, 0, 0, 0, 0 },
/* U+1710 */ { 0, 0, 0, 0, 0 },
/* U+1711 */ { 0, 0, 0, 0, 0 },
/* U+1712 */ { 0, 0, 0, 0, 0 },
/* U+1713 */ { 0, 0, 0, 0, 0 },
/* U+1714 */ { 0, 0, 0, 0, 0 },
/* U+1715 */ { 0, 0, 0, 0, 0 },
/* U+1716 */ { 0, 0, 0, 0, 0 },
/* U+1717 */ { 0, 0, 0, 0, 0 },
/* U+1718 */ { 0, 0, 0, 0, 0 },
/* U+1719 */ { 0, 0, 0, 0, 0 },
/* U+171a */ { 0, 0, 0, 0, 0 },
/* U+171b */ { 0, 0, 0, 0, 0 },
/* U+171c */ { 0, 0, 0, 0, 0 },
/* U+171d */ { 0, 0, 0, 0, 0 },
/* U+171e */ { 0, 0, 0, 0, 0 },
/* U+171f */ { 0, 0, 0, 0, 0 },
/* U+1720 */ { 0, 0, 0, 0, 0 },
/* U+1721 */ { 0, 0, 0, 0, 0 },
/* U+1722 */ { 0, 0, 0, 0, 0 },
/* U+1723 */ { 0, 0, 0, 0, 0 },
/* U+1724 */ { 0, 0, 0, 0, 0 },
/* U+1725 */ { 0, 0, 0, 0, 0 },
/* U+1726 */ { 0, 0, 0, 0, 0 },
/* U+1727 */ { 0, 0, 0, 0, 0 },
/* U+1728 */ { 0, 0, 0, 0, 0 },
/* U+1729 */ { 0, 0, 0, 0, 0 },
/* U+172a */ { 0, 0, 0, 0, 0 },
/* U+172b */ { 0, 0, 0, 0, 0 },
/* U+172c */ { 0, 0, 0, 0, 0 },
/* U+172d */ { 0, 0, 0, 0, 0 },
/* U+172e */ { 0, 0, 0, 0, 0 },
/* U+172f */ { 0, 0, 0, 0, 0 },
/* U+1730 */ { 0, 0, 0, 0, 0 },
/* U+1731 */ { 0, 0, 0, 0, 0 },
/* U+1732 */ { 0, 0, 0, 0, 0 },
/* U+1733 */ { 0, 0, 0, 0, 0 },
/* U+1734 */ { 0, 0, 0, 0, 0 },
/* U+1735 */ { 0, 0, 0, 0, 0 },
/* U+1736 */ { 0, 0, 0, 0, 0 },
/* U+1737 */ { 0, 0, 0, 0, 0 },
/* U+1738 */ { 0, 0, 0, 0, 0 },
/* U+1739 */ { 0, 0, 0, 0, 0 },
/* U+173a */ { 0, 0, 0, 0, 0 },
/* U+173b */ { 0, 0, 0, 0, 0 },
/* U+173c */ { 0, 0, 0, 0, 0 },
/* U+173d */ { 0, 0, 0, 0, 0 },
/* U+173e */ { 0, 0, 0, 0, 0 },
/* U+173f */ { 0, 0, 0, 0, 0 },
/* U+1740 */ { 0, 0, 0, 0, 0 },
/* U+1741 */ { 0, 0, 0, 0, 0 },
/* U+1742 */ { 0, 0, 0, 0, 0 },
/* U+1743 */ { 0, 0, 0, 0, 0 },
/* U+1744 */ { 0, 0, 0, 0, 0 },
/* U+1745 */ { 0, 0, 0, 0, 0 },
/* U+1746 */ { 0, 0, 0, 0, 0 },
/* U+1747 */ { 0, 0, 0, 0, 0 },
/* U+1748 */ { 0, 0, 0, 0, 0 },
/* U+1749 */ { 0, 0, 0, 0, 0 },
/* U+174a */ { 0, 0, 0, 0, 0 },
/* U+174b */ { 0, 0, 0, 0, 0 },
/* U+174c */ { 0, 0, 0, 0, 0 },
/* U+174d */ { 0, 0, 0, 0, 0 },
/* U+174e */ { 0, 0, 0, 0, 0 },
/* U+174f */ { 0, 0, 0, 0, 0 },
/* U+1750 */ { 0, 0, 0, 0, 0 },
/* U+1751 */ { 0, 0, 0, 0, 0 },
/* U+1752 */ { 0, 0, 0, 0, 0 },
/* U+1753 */ { 0, 0, 0, 0, 0 },
/* U+1754 */ { 0, 0, 0, 0, 0 },
/* U+1755 */ { 0, 0, 0, 0, 0 },
/* U+1756 */ { 0, 0, 0, 0, 0 },
/* U+1757 */ { 0, 0, 0, 0, 0 },
/* U+1758 */ { 0, 0, 0, 0, 0 },
/* U+1759 */ { 0, 0, 0, 0, 0 },
/* U+175a */ { 0, 0, 0, 0, 0 },
/* U+175b */ { 0, 0, 0, 0, 0 },
/* U+175c */ { 0, 0, 0, 0, 0 },
/* U+175d */ { 0, 0, 0, 0, 0 },
/* U+175e */ { 0, 0, 0, 0, 0 },
/* U+175f */ { 0, 0, 0, 0, 0 },
/* U+1760 */ { 0, 0, 0, 0, 0 },
/* U+1761 */ { 0, 0, 0, 0, 0 },
/* U+1762 */ { 0, 0, 0, 0, 0 },
/* U+1763 */ { 0, 0, 0, 0, 0 },
/* U+1764 */ { 0, 0, 0, 0, 0 },
/* U+1765 */ { 0, 0, 0, 0, 0 },
/* U+1766 */ { 0, 0, 0, 0, 0 },
/* U+1767 */ { 0, 0, 0, 0, 0 },
/* U+1768 */ { 0, 0, 0, 0, 0 },
/* U+1769 */ { 0, 0, 0, 0, 0 },
/* U+176a */ { 0, 0, 0, 0, 0 },
/* U+176b */ { 0, 0, 0, 0, 0 },
/* U+176c */ { 0, 0, 0, 0, 0 },
/* U+176d */ { 0, 0, 0, 0, 0 },
/* U+176e */ { 0, 0, 0, 0, 0 },
/* U+176f */ { 0, 0, 0, 0, 0 },
/* U+1770 */ { 0, 0, 0, 0, 0 },
/* U+1771 */ { 0, 0, 0, 0, 0 },
/* U+1772 */ { 0, 0, 0, 0, 0 },
/* U+1773 */ { 0, 0, 0, 0, 0 },
/* U+1774 */ { 0, 0, 0, 0, 0 },
/* U+1775 */ { 0, 0, 0, 0, 0 },
/* U+1776 */ { 0, 0, 0, 0, 0 },
/* U+1777 */ { 0, 0, 0, 0, 0 },
/* U+1778 */ { 0, 0, 0, 0, 0 },
/* U+1779 */ { 0, 0, 0, 0, 0 },
/* U+177a */ { 0, 0, 0, 0, 0 },
/* U+177b */ { 0, 0, 0, 0, 0 },
/* U+177c */ { 0, 0, 0, 0, 0 },
/* U+177d */ { 0, 0, 0, 0, 0 },
/* U+177e */ { 0, 0, 0, 0, 0 },
/* U+177f */ { 0, 0, 0, 0, 0 },
/* U+1780 */ { 19, 0, 1, 0, 0 },
/* U+1781 */ { 19, 0, 1, 0, 0 },
/* U+1782 */ { 19, 0, 1, 0, 0 },
/* U+1783 */ { 19, 0, 1, 0, 0 },
/* U+1784 */ { 19, 0, 1, 0, 0 },
/* U+1785 */ { 19, 0, 1, 0, 0 },
/* U+1786 */ { 19, 0, 1, 0, 0 },
/* U+1787 */ { 19, 0, 1, 0, 0 },
/* U+1788 */ { 19, 0, 1, 0, 0 },
/* U+1789 */ { 19, 0, 1, 0, 0 },
/* U+178a */ { 19, 0, 1, 0, 0 },
/* U+178b */ { 19, 0, 1, 0, 0 },
/* U+178c */ { 19, 0, 1, 0, 0 },
/* U+178d */ { 19, 0, 1, 0, 0 },
/* U+178e */ { 19, 0, 1, 0, 0 },
/* U+178f */ { 19, 0, 1, 0, 0 },
/* U+1790 */ { 19, 0, 1, 0, 0 },
/* U+1791 */ { 19, 0, 1, 0, 0 },
/* U+1792 */ { 19, 0, 1, 0, 0 },
/* U+1793 */ { 19, 0, 1, 0, 0 },
/* U+1794 */ { 19, 0, 1, 0, 0 },
/* U+1795 */ { 19, 0, 1, 0, 0 },
/* U+1796 */ { 19, 0, 1, 0, 0 },
/* U+1797 */ { 19, 0, 1, 0, 0 },
/* U+1798 */ { 19, 0, 1, 0, 0 },
/* U+1799 */ { 19, 0, 1, 0, 0 },
/* U+179a */ { 19, 0, 1, 0, 0 },
/* U+179b */ { 19, 0, 1, 0, 0 },
/* U+179c */ { 19, 0, 1, 0, 0 },
/* U+179d */ { 19, 0, 1, 0, 0 },
/* U+179e */ { 19, 0, 1, 0, 0 },
/* U+179f */ { 19, 0, 1, 0, 0 },
/* U+17a0 */ { 19, 0, 1, 0, 0 },
/* U+17a1 */ { 19, 0, 1, 0, 0 },
/* U+17a2 */ { 19, 0, 1, 0, 0 },
/* U+17a3 */ { 19, 0, 1, 0, 0 },
/* U+17a4 */ { 19, 0, 1, 0, 0 },
/* U+17a5 */ { 19, 0, 1, 0, 0 },
/* U+17a6 */ { 19, 0, 1, 0, 0 },
/* U+17a7 */ { 19, 0, 1, 0, 0 },
/* U+17a8 */ { 19, 0, 1, 0, 0 },
/* U+17a9 */ { 19, 0, 1, 0, 0 },
/* U+17aa */ { 19, 0, 1, 0, 0 },
/* U+17ab */ { 19, 0, 1, 0, 0 },
/* U+17ac */ { 19, 0, 1, 0, 0 },
/* U+17ad */ { 19, 0, 1, 0, 0 },
/* U+17ae */ { 19, 0, 1, 0, 0 },
/* U+17af */ { 19, 0, 1, 0, 0 },
/* U+17b0 */ { 19, 0, 1, 0, 0 },
/* U+17b1 */ { 19, 0, 1, 0, 0 },
/* U+17b2 */ { 19, 0, 1, 0, 0 },
/* U+17b3 */ { 19, 0, 1, 0, 0 },
/* U+17b4 */ { 5, 0, 1, 0, 0 },
/* U+17b5 */ { 5, 0, 1, 0, 0 },
/* U+17b6 */ { 5, 0, 1, 0, 0 },
/* U+17b7 */ { 4, 0, 14, 0, 0 },
/* U+17b8 */ { 4, 0, 14, 0, 0 },
/* U+17b9 */ { 4, 0, 14, 0, 0 },
/* U+17ba */ { 4, 0, 14, 0, 0 },
/* U+17bb */ { 4, 0, 14, 0, 0 },
/* U+17bc */ { 4, 0, 14, 0, 0 },
/* U+17bd */ { 4, 0, 14, 0, 0 },
/* U+17be */ { 5, 0, 1, 0, 0 },
/* U+17bf */ { 5, 0, 1, 0, 0 },
/* U+17c0 */ { 5, 0, 1, 0, 0 },
/* U+17c1 */ { 5, 0, 1, 0, 0 },
/* U+17c2 */ { 5, 0, 1, 0, 0 },
/* U+17c3 */ { 5, 0, 1, 0, 0 },
/* U+17c4 */ { 5, 0, 1, 0, 0 },
/* U+17c5 */ { 5, 0, 1, 0, 0 },
/* U+17c6 */ { 4, 0, 14, 0, 0 },
/* U+17c7 */ { 5, 0, 1, 0, 0 },
/* U+17c8 */ { 5, 0, 1, 0, 0 },
/* U+17c9 */ { 4, 0, 14, 0, 0 },
/* U+17ca */ { 4, 0, 14, 0, 0 },
/* U+17cb */ { 4, 0, 14, 0, 0 },
/* U+17cc */ { 4, 0, 14, 0, 0 },
/* U+17cd */ { 4, 0, 14, 0, 0 },
/* U+17ce */ { 4, 0, 14, 0, 0 },
/* U+17cf */ { 4, 0, 14, 0, 0 },
/* U+17d0 */ { 4, 0, 14, 0, 0 },
/* U+17d1 */ { 4, 0, 14, 0, 0 },
/* U+17d2 */ { 4, 9, 14, 0, 0 },
/* U+17d3 */ { 4, 0, 14, 0, 0 },
/* U+17d4 */ { 26, 0, 1, 0, 0 },
/* U+17d5 */ { 26, 0, 1, 0, 0 },
/* U+17d6 */ { 26, 0, 1, 0, 0 },
/* U+17d7 */ { 26, 0, 1, 0, 0 },
/* U+17d8 */ { 26, 0, 1, 0, 0 },
/* U+17d9 */ { 26, 0, 1, 0, 0 },
/* U+17da */ { 26, 0, 1, 0, 0 },
/* U+17db */ { 28, 0, 11, 0, 0 },
/* U+17dc */ { 26, 0, 1, 0, 0 },
/* U+17dd */ { 0, 0, 0, 0, 0 },
/* U+17de */ { 0, 0, 0, 0, 0 },
/* U+17df */ { 0, 0, 0, 0, 0 },
/* U+17e0 */ { 7, 0, 1, 0, 0 },
/* U+17e1 */ { 7, 0, 1, 0, 0 },
/* U+17e2 */ { 7, 0, 1, 0, 0 },
/* U+17e3 */ { 7, 0, 1, 0, 0 },
/* U+17e4 */ { 7, 0, 1, 0, 0 },
/* U+17e5 */ { 7, 0, 1, 0, 0 },
/* U+17e6 */ { 7, 0, 1, 0, 0 },
/* U+17e7 */ { 7, 0, 1, 0, 0 },
/* U+17e8 */ { 7, 0, 1, 0, 0 },
/* U+17e9 */ { 7, 0, 1, 0, 0 },
/* U+17ea */ { 0, 0, 0, 0, 0 },
/* U+17eb */ { 0, 0, 0, 0, 0 },
/* U+17ec */ { 0, 0, 0, 0, 0 },
/* U+17ed */ { 0, 0, 0, 0, 0 },
/* U+17ee */ { 0, 0, 0, 0, 0 },
/* U+17ef */ { 0, 0, 0, 0, 0 },
/* U+17f0 */ { 0, 0, 0, 0, 0 },
/* U+17f1 */ { 0, 0, 0, 0, 0 },
/* U+17f2 */ { 0, 0, 0, 0, 0 },
/* U+17f3 */ { 0, 0, 0, 0, 0 },
/* U+17f4 */ { 0, 0, 0, 0, 0 },
/* U+17f5 */ { 0, 0, 0, 0, 0 },
/* U+17f6 */ { 0, 0, 0, 0, 0 },
/* U+17f7 */ { 0, 0, 0, 0, 0 },
/* U+17f8 */ { 0, 0, 0, 0, 0 },
/* U+17f9 */ { 0, 0, 0, 0, 0 },
/* U+17fa */ { 0, 0, 0, 0, 0 },
/* U+17fb */ { 0, 0, 0, 0, 0 },
/* U+17fc */ { 0, 0, 0, 0, 0 },
/* U+17fd */ { 0, 0, 0, 0, 0 },
/* U+17fe */ { 0, 0, 0, 0, 0 },
/* U+17ff */ { 0, 0, 0, 0, 0 },
/* U+1800 */ { 26, 0, 19, 0, 0 },
/* U+1801 */ { 26, 0, 19, 0, 0 },
/* U+1802 */ { 26, 0, 19, 0, 0 },
/* U+1803 */ { 26, 0, 19, 0, 0 },
/* U+1804 */ { 26, 0, 19, 0, 0 },
/* U+1805 */ { 26, 0, 19, 0, 0 },
/* U+1806 */ { 21, 0, 19, 0, 0 },
/* U+1807 */ { 26, 0, 19, 0, 0 },
/* U+1808 */ { 26, 0, 19, 0, 0 },
/* U+1809 */ { 26, 0, 19, 0, 0 },
/* U+180a */ { 26, 0, 19, 0, 0 },
/* U+180b */ { 14, 0, 15, 0, 0 },
/* U+180c */ { 14, 0, 15, 0, 0 },
/* U+180d */ { 14, 0, 15, 0, 0 },
/* U+180e */ { 14, 0, 15, 0, 0 },
/* U+180f */ { 0, 0, 0, 0, 0 },
/* U+1810 */ { 7, 0, 1, 0, 0 },
/* U+1811 */ { 7, 0, 1, 0, 0 },
/* U+1812 */ { 7, 0, 1, 0, 0 },
/* U+1813 */ { 7, 0, 1, 0, 0 },
/* U+1814 */ { 7, 0, 1, 0, 0 },
/* U+1815 */ { 7, 0, 1, 0, 0 },
/* U+1816 */ { 7, 0, 1, 0, 0 },
/* U+1817 */ { 7, 0, 1, 0, 0 },
/* U+1818 */ { 7, 0, 1, 0, 0 },
/* U+1819 */ { 7, 0, 1, 0, 0 },
/* U+181a */ { 0, 0, 0, 0, 0 },
/* U+181b */ { 0, 0, 0, 0, 0 },
/* U+181c */ { 0, 0, 0, 0, 0 },
/* U+181d */ { 0, 0, 0, 0, 0 },
/* U+181e */ { 0, 0, 0, 0, 0 },
/* U+181f */ { 0, 0, 0, 0, 0 },
/* U+1820 */ { 19, 0, 1, 0, 0 },
/* U+1821 */ { 19, 0, 1, 0, 0 },
/* U+1822 */ { 19, 0, 1, 0, 0 },
/* U+1823 */ { 19, 0, 1, 0, 0 },
/* U+1824 */ { 19, 0, 1, 0, 0 },
/* U+1825 */ { 19, 0, 1, 0, 0 },
/* U+1826 */ { 19, 0, 1, 0, 0 },
/* U+1827 */ { 19, 0, 1, 0, 0 },
/* U+1828 */ { 19, 0, 1, 0, 0 },
/* U+1829 */ { 19, 0, 1, 0, 0 },
/* U+182a */ { 19, 0, 1, 0, 0 },
/* U+182b */ { 19, 0, 1, 0, 0 },
/* U+182c */ { 19, 0, 1, 0, 0 },
/* U+182d */ { 19, 0, 1, 0, 0 },
/* U+182e */ { 19, 0, 1, 0, 0 },
/* U+182f */ { 19, 0, 1, 0, 0 },
/* U+1830 */ { 19, 0, 1, 0, 0 },
/* U+1831 */ { 19, 0, 1, 0, 0 },
/* U+1832 */ { 19, 0, 1, 0, 0 },
/* U+1833 */ { 19, 0, 1, 0, 0 },
/* U+1834 */ { 19, 0, 1, 0, 0 },
/* U+1835 */ { 19, 0, 1, 0, 0 },
/* U+1836 */ { 19, 0, 1, 0, 0 },
/* U+1837 */ { 19, 0, 1, 0, 0 },
/* U+1838 */ { 19, 0, 1, 0, 0 },
/* U+1839 */ { 19, 0, 1, 0, 0 },
/* U+183a */ { 19, 0, 1, 0, 0 },
/* U+183b */ { 19, 0, 1, 0, 0 },
/* U+183c */ { 19, 0, 1, 0, 0 },
/* U+183d */ { 19, 0, 1, 0, 0 },
/* U+183e */ { 19, 0, 1, 0, 0 },
/* U+183f */ { 19, 0, 1, 0, 0 },
/* U+1840 */ { 19, 0, 1, 0, 0 },
/* U+1841 */ { 19, 0, 1, 0, 0 },
/* U+1842 */ { 19, 0, 1, 0, 0 },
/* U+1843 */ { 18, 0, 1, 0, 0 },
/* U+1844 */ { 19, 0, 1, 0, 0 },
/* U+1845 */ { 19, 0, 1, 0, 0 },
/* U+1846 */ { 19, 0, 1, 0, 0 },
/* U+1847 */ { 19, 0, 1, 0, 0 },
/* U+1848 */ { 19, 0, 1, 0, 0 },
/* U+1849 */ { 19, 0, 1, 0, 0 },
/* U+184a */ { 19, 0, 1, 0, 0 },
/* U+184b */ { 19, 0, 1, 0, 0 },
/* U+184c */ { 19, 0, 1, 0, 0 },
/* U+184d */ { 19, 0, 1, 0, 0 },
/* U+184e */ { 19, 0, 1, 0, 0 },
/* U+184f */ { 19, 0, 1, 0, 0 },
/* U+1850 */ { 19, 0, 1, 0, 0 },
/* U+1851 */ { 19, 0, 1, 0, 0 },
/* U+1852 */ { 19, 0, 1, 0, 0 },
/* U+1853 */ { 19, 0, 1, 0, 0 },
/* U+1854 */ { 19, 0, 1, 0, 0 },
/* U+1855 */ { 19, 0, 1, 0, 0 },
/* U+1856 */ { 19, 0, 1, 0, 0 },
/* U+1857 */ { 19, 0, 1, 0, 0 },
/* U+1858 */ { 19, 0, 1, 0, 0 },
/* U+1859 */ { 19, 0, 1, 0, 0 },
/* U+185a */ { 19, 0, 1, 0, 0 },
/* U+185b */ { 19, 0, 1, 0, 0 },
/* U+185c */ { 19, 0, 1, 0, 0 },
/* U+185d */ { 19, 0, 1, 0, 0 },
/* U+185e */ { 19, 0, 1, 0, 0 },
/* U+185f */ { 19, 0, 1, 0, 0 },
/* U+1860 */ { 19, 0, 1, 0, 0 },
/* U+1861 */ { 19, 0, 1, 0, 0 },
/* U+1862 */ { 19, 0, 1, 0, 0 },
/* U+1863 */ { 19, 0, 1, 0, 0 },
/* U+1864 */ { 19, 0, 1, 0, 0 },
/* U+1865 */ { 19, 0, 1, 0, 0 },
/* U+1866 */ { 19, 0, 1, 0, 0 },
/* U+1867 */ { 19, 0, 1, 0, 0 },
/* U+1868 */ { 19, 0, 1, 0, 0 },
/* U+1869 */ { 19, 0, 1, 0, 0 },
/* U+186a */ { 19, 0, 1, 0, 0 },
/* U+186b */ { 19, 0, 1, 0, 0 },
/* U+186c */ { 19, 0, 1, 0, 0 },
/* U+186d */ { 19, 0, 1, 0, 0 },
/* U+186e */ { 19, 0, 1, 0, 0 },
/* U+186f */ { 19, 0, 1, 0, 0 },
/* U+1870 */ { 19, 0, 1, 0, 0 },
/* U+1871 */ { 19, 0, 1, 0, 0 },
/* U+1872 */ { 19, 0, 1, 0, 0 },
/* U+1873 */ { 19, 0, 1, 0, 0 },
/* U+1874 */ { 19, 0, 1, 0, 0 },
/* U+1875 */ { 19, 0, 1, 0, 0 },
/* U+1876 */ { 19, 0, 1, 0, 0 },
/* U+1877 */ { 19, 0, 1, 0, 0 },
/* U+1878 */ { 0, 0, 0, 0, 0 },
/* U+1879 */ { 0, 0, 0, 0, 0 },
/* U+187a */ { 0, 0, 0, 0, 0 },
/* U+187b */ { 0, 0, 0, 0, 0 },
/* U+187c */ { 0, 0, 0, 0, 0 },
/* U+187d */ { 0, 0, 0, 0, 0 },
/* U+187e */ { 0, 0, 0, 0, 0 },
/* U+187f */ { 0, 0, 0, 0, 0 },
/* U+1880 */ { 19, 0, 1, 0, 0 },
/* U+1881 */ { 19, 0, 1, 0, 0 },
/* U+1882 */ { 19, 0, 1, 0, 0 },
/* U+1883 */ { 19, 0, 1, 0, 0 },
/* U+1884 */ { 19, 0, 1, 0, 0 },
/* U+1885 */ { 19, 0, 1, 0, 0 },
/* U+1886 */ { 19, 0, 1, 0, 0 },
/* U+1887 */ { 19, 0, 1, 0, 0 },
/* U+1888 */ { 19, 0, 1, 0, 0 },
/* U+1889 */ { 19, 0, 1, 0, 0 },
/* U+188a */ { 19, 0, 1, 0, 0 },
/* U+188b */ { 19, 0, 1, 0, 0 },
/* U+188c */ { 19, 0, 1, 0, 0 },
/* U+188d */ { 19, 0, 1, 0, 0 },
/* U+188e */ { 19, 0, 1, 0, 0 },
/* U+188f */ { 19, 0, 1, 0, 0 },
/* U+1890 */ { 19, 0, 1, 0, 0 },
/* U+1891 */ { 19, 0, 1, 0, 0 },
/* U+1892 */ { 19, 0, 1, 0, 0 },
/* U+1893 */ { 19, 0, 1, 0, 0 },
/* U+1894 */ { 19, 0, 1, 0, 0 },
/* U+1895 */ { 19, 0, 1, 0, 0 },
/* U+1896 */ { 19, 0, 1, 0, 0 },
/* U+1897 */ { 19, 0, 1, 0, 0 },
/* U+1898 */ { 19, 0, 1, 0, 0 },
/* U+1899 */ { 19, 0, 1, 0, 0 },
/* U+189a */ { 19, 0, 1, 0, 0 },
/* U+189b */ { 19, 0, 1, 0, 0 },
/* U+189c */ { 19, 0, 1, 0, 0 },
/* U+189d */ { 19, 0, 1, 0, 0 },
/* U+189e */ { 19, 0, 1, 0, 0 },
/* U+189f */ { 19, 0, 1, 0, 0 },
/* U+18a0 */ { 19, 0, 1, 0, 0 },
/* U+18a1 */ { 19, 0, 1, 0, 0 },
/* U+18a2 */ { 19, 0, 1, 0, 0 },
/* U+18a3 */ { 19, 0, 1, 0, 0 },
/* U+18a4 */ { 19, 0, 1, 0, 0 },
/* U+18a5 */ { 19, 0, 1, 0, 0 },
/* U+18a6 */ { 19, 0, 1, 0, 0 },
/* U+18a7 */ { 19, 0, 1, 0, 0 },
/* U+18a8 */ { 19, 0, 1, 0, 0 },
/* U+18a9 */ { 4, 228, 14, 0, 0 },
/* U+18aa */ { 0, 0, 0, 0, 0 },
/* U+18ab */ { 0, 0, 0, 0, 0 },
/* U+18ac */ { 0, 0, 0, 0, 0 },
/* U+18ad */ { 0, 0, 0, 0, 0 },
/* U+18ae */ { 0, 0, 0, 0, 0 },
/* U+18af */ { 0, 0, 0, 0, 0 },
/* U+18b0 */ { 0, 0, 0, 0, 0 },
/* U+18b1 */ { 0, 0, 0, 0, 0 },
/* U+18b2 */ { 0, 0, 0, 0, 0 },
/* U+18b3 */ { 0, 0, 0, 0, 0 },
/* U+18b4 */ { 0, 0, 0, 0, 0 },
/* U+18b5 */ { 0, 0, 0, 0, 0 },
/* U+18b6 */ { 0, 0, 0, 0, 0 },
/* U+18b7 */ { 0, 0, 0, 0, 0 },
/* U+18b8 */ { 0, 0, 0, 0, 0 },
/* U+18b9 */ { 0, 0, 0, 0, 0 },
/* U+18ba */ { 0, 0, 0, 0, 0 },
/* U+18bb */ { 0, 0, 0, 0, 0 },
/* U+18bc */ { 0, 0, 0, 0, 0 },
/* U+18bd */ { 0, 0, 0, 0, 0 },
/* U+18be */ { 0, 0, 0, 0, 0 },
/* U+18bf */ { 0, 0, 0, 0, 0 },
/* U+18c0 */ { 0, 0, 0, 0, 0 },
/* U+18c1 */ { 0, 0, 0, 0, 0 },
/* U+18c2 */ { 0, 0, 0, 0, 0 },
/* U+18c3 */ { 0, 0, 0, 0, 0 },
/* U+18c4 */ { 0, 0, 0, 0, 0 },
/* U+18c5 */ { 0, 0, 0, 0, 0 },
/* U+18c6 */ { 0, 0, 0, 0, 0 },
/* U+18c7 */ { 0, 0, 0, 0, 0 },
/* U+18c8 */ { 0, 0, 0, 0, 0 },
/* U+18c9 */ { 0, 0, 0, 0, 0 },
/* U+18ca */ { 0, 0, 0, 0, 0 },
/* U+18cb */ { 0, 0, 0, 0, 0 },
/* U+18cc */ { 0, 0, 0, 0, 0 },
/* U+18cd */ { 0, 0, 0, 0, 0 },
/* U+18ce */ { 0, 0, 0, 0, 0 },
/* U+18cf */ { 0, 0, 0, 0, 0 },
/* U+18d0 */ { 0, 0, 0, 0, 0 },
/* U+18d1 */ { 0, 0, 0, 0, 0 },
/* U+18d2 */ { 0, 0, 0, 0, 0 },
/* U+18d3 */ { 0, 0, 0, 0, 0 },
/* U+18d4 */ { 0, 0, 0, 0, 0 },
/* U+18d5 */ { 0, 0, 0, 0, 0 },
/* U+18d6 */ { 0, 0, 0, 0, 0 },
/* U+18d7 */ { 0, 0, 0, 0, 0 },
/* U+18d8 */ { 0, 0, 0, 0, 0 },
/* U+18d9 */ { 0, 0, 0, 0, 0 },
/* U+18da */ { 0, 0, 0, 0, 0 },
/* U+18db */ { 0, 0, 0, 0, 0 },
/* U+18dc */ { 0, 0, 0, 0, 0 },
/* U+18dd */ { 0, 0, 0, 0, 0 },
/* U+18de */ { 0, 0, 0, 0, 0 },
/* U+18df */ { 0, 0, 0, 0, 0 },
/* U+18e0 */ { 0, 0, 0, 0, 0 },
/* U+18e1 */ { 0, 0, 0, 0, 0 },
/* U+18e2 */ { 0, 0, 0, 0, 0 },
/* U+18e3 */ { 0, 0, 0, 0, 0 },
/* U+18e4 */ { 0, 0, 0, 0, 0 },
/* U+18e5 */ { 0, 0, 0, 0, 0 },
/* U+18e6 */ { 0, 0, 0, 0, 0 },
/* U+18e7 */ { 0, 0, 0, 0, 0 },
/* U+18e8 */ { 0, 0, 0, 0, 0 },
/* U+18e9 */ { 0, 0, 0, 0, 0 },
/* U+18ea */ { 0, 0, 0, 0, 0 },
/* U+18eb */ { 0, 0, 0, 0, 0 },
/* U+18ec */ { 0, 0, 0, 0, 0 },
/* U+18ed */ { 0, 0, 0, 0, 0 },
/* U+18ee */ { 0, 0, 0, 0, 0 },
/* U+18ef */ { 0, 0, 0, 0, 0 },
/* U+18f0 */ { 0, 0, 0, 0, 0 },
/* U+18f1 */ { 0, 0, 0, 0, 0 },
/* U+18f2 */ { 0, 0, 0, 0, 0 },
/* U+18f3 */ { 0, 0, 0, 0, 0 },
/* U+18f4 */ { 0, 0, 0, 0, 0 },
/* U+18f5 */ { 0, 0, 0, 0, 0 },
/* U+18f6 */ { 0, 0, 0, 0, 0 },
/* U+18f7 */ { 0, 0, 0, 0, 0 },
/* U+18f8 */ { 0, 0, 0, 0, 0 },
/* U+18f9 */ { 0, 0, 0, 0, 0 },
/* U+18fa */ { 0, 0, 0, 0, 0 },
/* U+18fb */ { 0, 0, 0, 0, 0 },
/* U+18fc */ { 0, 0, 0, 0, 0 },
/* U+18fd */ { 0, 0, 0, 0, 0 },
/* U+18fe */ { 0, 0, 0, 0, 0 },
/* U+18ff */ { 0, 0, 0, 0, 0 },
/* U+1900 */ { 0, 0, 0, 0, 0 },
/* U+1901 */ { 0, 0, 0, 0, 0 },
/* U+1902 */ { 0, 0, 0, 0, 0 },
/* U+1903 */ { 0, 0, 0, 0, 0 },
/* U+1904 */ { 0, 0, 0, 0, 0 },
/* U+1905 */ { 0, 0, 0, 0, 0 },
/* U+1906 */ { 0, 0, 0, 0, 0 },
/* U+1907 */ { 0, 0, 0, 0, 0 },
/* U+1908 */ { 0, 0, 0, 0, 0 },
/* U+1909 */ { 0, 0, 0, 0, 0 },
/* U+190a */ { 0, 0, 0, 0, 0 },
/* U+190b */ { 0, 0, 0, 0, 0 },
/* U+190c */ { 0, 0, 0, 0, 0 },
/* U+190d */ { 0, 0, 0, 0, 0 },
/* U+190e */ { 0, 0, 0, 0, 0 },
/* U+190f */ { 0, 0, 0, 0, 0 },
/* U+1910 */ { 0, 0, 0, 0, 0 },
/* U+1911 */ { 0, 0, 0, 0, 0 },
/* U+1912 */ { 0, 0, 0, 0, 0 },
/* U+1913 */ { 0, 0, 0, 0, 0 },
/* U+1914 */ { 0, 0, 0, 0, 0 },
/* U+1915 */ { 0, 0, 0, 0, 0 },
/* U+1916 */ { 0, 0, 0, 0, 0 },
/* U+1917 */ { 0, 0, 0, 0, 0 },
/* U+1918 */ { 0, 0, 0, 0, 0 },
/* U+1919 */ { 0, 0, 0, 0, 0 },
/* U+191a */ { 0, 0, 0, 0, 0 },
/* U+191b */ { 0, 0, 0, 0, 0 },
/* U+191c */ { 0, 0, 0, 0, 0 },
/* U+191d */ { 0, 0, 0, 0, 0 },
/* U+191e */ { 0, 0, 0, 0, 0 },
/* U+191f */ { 0, 0, 0, 0, 0 },
/* U+1920 */ { 0, 0, 0, 0, 0 },
/* U+1921 */ { 0, 0, 0, 0, 0 },
/* U+1922 */ { 0, 0, 0, 0, 0 },
/* U+1923 */ { 0, 0, 0, 0, 0 },
/* U+1924 */ { 0, 0, 0, 0, 0 },
/* U+1925 */ { 0, 0, 0, 0, 0 },
/* U+1926 */ { 0, 0, 0, 0, 0 },
/* U+1927 */ { 0, 0, 0, 0, 0 },
/* U+1928 */ { 0, 0, 0, 0, 0 },
/* U+1929 */ { 0, 0, 0, 0, 0 },
/* U+192a */ { 0, 0, 0, 0, 0 },
/* U+192b */ { 0, 0, 0, 0, 0 },
/* U+192c */ { 0, 0, 0, 0, 0 },
/* U+192d */ { 0, 0, 0, 0, 0 },
/* U+192e */ { 0, 0, 0, 0, 0 },
/* U+192f */ { 0, 0, 0, 0, 0 },
/* U+1930 */ { 0, 0, 0, 0, 0 },
/* U+1931 */ { 0, 0, 0, 0, 0 },
/* U+1932 */ { 0, 0, 0, 0, 0 },
/* U+1933 */ { 0, 0, 0, 0, 0 },
/* U+1934 */ { 0, 0, 0, 0, 0 },
/* U+1935 */ { 0, 0, 0, 0, 0 },
/* U+1936 */ { 0, 0, 0, 0, 0 },
/* U+1937 */ { 0, 0, 0, 0, 0 },
/* U+1938 */ { 0, 0, 0, 0, 0 },
/* U+1939 */ { 0, 0, 0, 0, 0 },
/* U+193a */ { 0, 0, 0, 0, 0 },
/* U+193b */ { 0, 0, 0, 0, 0 },
/* U+193c */ { 0, 0, 0, 0, 0 },
/* U+193d */ { 0, 0, 0, 0, 0 },
/* U+193e */ { 0, 0, 0, 0, 0 },
/* U+193f */ { 0, 0, 0, 0, 0 },
/* U+1940 */ { 0, 0, 0, 0, 0 },
/* U+1941 */ { 0, 0, 0, 0, 0 },
/* U+1942 */ { 0, 0, 0, 0, 0 },
/* U+1943 */ { 0, 0, 0, 0, 0 },
/* U+1944 */ { 0, 0, 0, 0, 0 },
/* U+1945 */ { 0, 0, 0, 0, 0 },
/* U+1946 */ { 0, 0, 0, 0, 0 },
/* U+1947 */ { 0, 0, 0, 0, 0 },
/* U+1948 */ { 0, 0, 0, 0, 0 },
/* U+1949 */ { 0, 0, 0, 0, 0 },
/* U+194a */ { 0, 0, 0, 0, 0 },
/* U+194b */ { 0, 0, 0, 0, 0 },
/* U+194c */ { 0, 0, 0, 0, 0 },
/* U+194d */ { 0, 0, 0, 0, 0 },
/* U+194e */ { 0, 0, 0, 0, 0 },
/* U+194f */ { 0, 0, 0, 0, 0 },
/* U+1950 */ { 0, 0, 0, 0, 0 },
/* U+1951 */ { 0, 0, 0, 0, 0 },
/* U+1952 */ { 0, 0, 0, 0, 0 },
/* U+1953 */ { 0, 0, 0, 0, 0 },
/* U+1954 */ { 0, 0, 0, 0, 0 },
/* U+1955 */ { 0, 0, 0, 0, 0 },
/* U+1956 */ { 0, 0, 0, 0, 0 },
/* U+1957 */ { 0, 0, 0, 0, 0 },
/* U+1958 */ { 0, 0, 0, 0, 0 },
/* U+1959 */ { 0, 0, 0, 0, 0 },
/* U+195a */ { 0, 0, 0, 0, 0 },
/* U+195b */ { 0, 0, 0, 0, 0 },
/* U+195c */ { 0, 0, 0, 0, 0 },
/* U+195d */ { 0, 0, 0, 0, 0 },
/* U+195e */ { 0, 0, 0, 0, 0 },
/* U+195f */ { 0, 0, 0, 0, 0 },
/* U+1960 */ { 0, 0, 0, 0, 0 },
/* U+1961 */ { 0, 0, 0, 0, 0 },
/* U+1962 */ { 0, 0, 0, 0, 0 },
/* U+1963 */ { 0, 0, 0, 0, 0 },
/* U+1964 */ { 0, 0, 0, 0, 0 },
/* U+1965 */ { 0, 0, 0, 0, 0 },
/* U+1966 */ { 0, 0, 0, 0, 0 },
/* U+1967 */ { 0, 0, 0, 0, 0 },
/* U+1968 */ { 0, 0, 0, 0, 0 },
/* U+1969 */ { 0, 0, 0, 0, 0 },
/* U+196a */ { 0, 0, 0, 0, 0 },
/* U+196b */ { 0, 0, 0, 0, 0 },
/* U+196c */ { 0, 0, 0, 0, 0 },
/* U+196d */ { 0, 0, 0, 0, 0 },
/* U+196e */ { 0, 0, 0, 0, 0 },
/* U+196f */ { 0, 0, 0, 0, 0 },
/* U+1970 */ { 0, 0, 0, 0, 0 },
/* U+1971 */ { 0, 0, 0, 0, 0 },
/* U+1972 */ { 0, 0, 0, 0, 0 },
/* U+1973 */ { 0, 0, 0, 0, 0 },
/* U+1974 */ { 0, 0, 0, 0, 0 },
/* U+1975 */ { 0, 0, 0, 0, 0 },
/* U+1976 */ { 0, 0, 0, 0, 0 },
/* U+1977 */ { 0, 0, 0, 0, 0 },
/* U+1978 */ { 0, 0, 0, 0, 0 },
/* U+1979 */ { 0, 0, 0, 0, 0 },
/* U+197a */ { 0, 0, 0, 0, 0 },
/* U+197b */ { 0, 0, 0, 0, 0 },
/* U+197c */ { 0, 0, 0, 0, 0 },
/* U+197d */ { 0, 0, 0, 0, 0 },
/* U+197e */ { 0, 0, 0, 0, 0 },
/* U+197f */ { 0, 0, 0, 0, 0 },
/* U+1980 */ { 0, 0, 0, 0, 0 },
/* U+1981 */ { 0, 0, 0, 0, 0 },
/* U+1982 */ { 0, 0, 0, 0, 0 },
/* U+1983 */ { 0, 0, 0, 0, 0 },
/* U+1984 */ { 0, 0, 0, 0, 0 },
/* U+1985 */ { 0, 0, 0, 0, 0 },
/* U+1986 */ { 0, 0, 0, 0, 0 },
/* U+1987 */ { 0, 0, 0, 0, 0 },
/* U+1988 */ { 0, 0, 0, 0, 0 },
/* U+1989 */ { 0, 0, 0, 0, 0 },
/* U+198a */ { 0, 0, 0, 0, 0 },
/* U+198b */ { 0, 0, 0, 0, 0 },
/* U+198c */ { 0, 0, 0, 0, 0 },
/* U+198d */ { 0, 0, 0, 0, 0 },
/* U+198e */ { 0, 0, 0, 0, 0 },
/* U+198f */ { 0, 0, 0, 0, 0 },
/* U+1990 */ { 0, 0, 0, 0, 0 },
/* U+1991 */ { 0, 0, 0, 0, 0 },
/* U+1992 */ { 0, 0, 0, 0, 0 },
/* U+1993 */ { 0, 0, 0, 0, 0 },
/* U+1994 */ { 0, 0, 0, 0, 0 },
/* U+1995 */ { 0, 0, 0, 0, 0 },
/* U+1996 */ { 0, 0, 0, 0, 0 },
/* U+1997 */ { 0, 0, 0, 0, 0 },
/* U+1998 */ { 0, 0, 0, 0, 0 },
/* U+1999 */ { 0, 0, 0, 0, 0 },
/* U+199a */ { 0, 0, 0, 0, 0 },
/* U+199b */ { 0, 0, 0, 0, 0 },
/* U+199c */ { 0, 0, 0, 0, 0 },
/* U+199d */ { 0, 0, 0, 0, 0 },
/* U+199e */ { 0, 0, 0, 0, 0 },
/* U+199f */ { 0, 0, 0, 0, 0 },
/* U+19a0 */ { 0, 0, 0, 0, 0 },
/* U+19a1 */ { 0, 0, 0, 0, 0 },
/* U+19a2 */ { 0, 0, 0, 0, 0 },
/* U+19a3 */ { 0, 0, 0, 0, 0 },
/* U+19a4 */ { 0, 0, 0, 0, 0 },
/* U+19a5 */ { 0, 0, 0, 0, 0 },
/* U+19a6 */ { 0, 0, 0, 0, 0 },
/* U+19a7 */ { 0, 0, 0, 0, 0 },
/* U+19a8 */ { 0, 0, 0, 0, 0 },
/* U+19a9 */ { 0, 0, 0, 0, 0 },
/* U+19aa */ { 0, 0, 0, 0, 0 },
/* U+19ab */ { 0, 0, 0, 0, 0 },
/* U+19ac */ { 0, 0, 0, 0, 0 },
/* U+19ad */ { 0, 0, 0, 0, 0 },
/* U+19ae */ { 0, 0, 0, 0, 0 },
/* U+19af */ { 0, 0, 0, 0, 0 },
/* U+19b0 */ { 0, 0, 0, 0, 0 },
/* U+19b1 */ { 0, 0, 0, 0, 0 },
/* U+19b2 */ { 0, 0, 0, 0, 0 },
/* U+19b3 */ { 0, 0, 0, 0, 0 },
/* U+19b4 */ { 0, 0, 0, 0, 0 },
/* U+19b5 */ { 0, 0, 0, 0, 0 },
/* U+19b6 */ { 0, 0, 0, 0, 0 },
/* U+19b7 */ { 0, 0, 0, 0, 0 },
/* U+19b8 */ { 0, 0, 0, 0, 0 },
/* U+19b9 */ { 0, 0, 0, 0, 0 },
/* U+19ba */ { 0, 0, 0, 0, 0 },
/* U+19bb */ { 0, 0, 0, 0, 0 },
/* U+19bc */ { 0, 0, 0, 0, 0 },
/* U+19bd */ { 0, 0, 0, 0, 0 },
/* U+19be */ { 0, 0, 0, 0, 0 },
/* U+19bf */ { 0, 0, 0, 0, 0 },
/* U+19c0 */ { 0, 0, 0, 0, 0 },
/* U+19c1 */ { 0, 0, 0, 0, 0 },
/* U+19c2 */ { 0, 0, 0, 0, 0 },
/* U+19c3 */ { 0, 0, 0, 0, 0 },
/* U+19c4 */ { 0, 0, 0, 0, 0 },
/* U+19c5 */ { 0, 0, 0, 0, 0 },
/* U+19c6 */ { 0, 0, 0, 0, 0 },
/* U+19c7 */ { 0, 0, 0, 0, 0 },
/* U+19c8 */ { 0, 0, 0, 0, 0 },
/* U+19c9 */ { 0, 0, 0, 0, 0 },
/* U+19ca */ { 0, 0, 0, 0, 0 },
/* U+19cb */ { 0, 0, 0, 0, 0 },
/* U+19cc */ { 0, 0, 0, 0, 0 },
/* U+19cd */ { 0, 0, 0, 0, 0 },
/* U+19ce */ { 0, 0, 0, 0, 0 },
/* U+19cf */ { 0, 0, 0, 0, 0 },
/* U+19d0 */ { 0, 0, 0, 0, 0 },
/* U+19d1 */ { 0, 0, 0, 0, 0 },
/* U+19d2 */ { 0, 0, 0, 0, 0 },
/* U+19d3 */ { 0, 0, 0, 0, 0 },
/* U+19d4 */ { 0, 0, 0, 0, 0 },
/* U+19d5 */ { 0, 0, 0, 0, 0 },
/* U+19d6 */ { 0, 0, 0, 0, 0 },
/* U+19d7 */ { 0, 0, 0, 0, 0 },
/* U+19d8 */ { 0, 0, 0, 0, 0 },
/* U+19d9 */ { 0, 0, 0, 0, 0 },
/* U+19da */ { 0, 0, 0, 0, 0 },
/* U+19db */ { 0, 0, 0, 0, 0 },
/* U+19dc */ { 0, 0, 0, 0, 0 },
/* U+19dd */ { 0, 0, 0, 0, 0 },
/* U+19de */ { 0, 0, 0, 0, 0 },
/* U+19df */ { 0, 0, 0, 0, 0 },
/* U+19e0 */ { 0, 0, 0, 0, 0 },
/* U+19e1 */ { 0, 0, 0, 0, 0 },
/* U+19e2 */ { 0, 0, 0, 0, 0 },
/* U+19e3 */ { 0, 0, 0, 0, 0 },
/* U+19e4 */ { 0, 0, 0, 0, 0 },
/* U+19e5 */ { 0, 0, 0, 0, 0 },
/* U+19e6 */ { 0, 0, 0, 0, 0 },
/* U+19e7 */ { 0, 0, 0, 0, 0 },
/* U+19e8 */ { 0, 0, 0, 0, 0 },
/* U+19e9 */ { 0, 0, 0, 0, 0 },
/* U+19ea */ { 0, 0, 0, 0, 0 },
/* U+19eb */ { 0, 0, 0, 0, 0 },
/* U+19ec */ { 0, 0, 0, 0, 0 },
/* U+19ed */ { 0, 0, 0, 0, 0 },
/* U+19ee */ { 0, 0, 0, 0, 0 },
/* U+19ef */ { 0, 0, 0, 0, 0 },
/* U+19f0 */ { 0, 0, 0, 0, 0 },
/* U+19f1 */ { 0, 0, 0, 0, 0 },
/* U+19f2 */ { 0, 0, 0, 0, 0 },
/* U+19f3 */ { 0, 0, 0, 0, 0 },
/* U+19f4 */ { 0, 0, 0, 0, 0 },
/* U+19f5 */ { 0, 0, 0, 0, 0 },
/* U+19f6 */ { 0, 0, 0, 0, 0 },
/* U+19f7 */ { 0, 0, 0, 0, 0 },
/* U+19f8 */ { 0, 0, 0, 0, 0 },
/* U+19f9 */ { 0, 0, 0, 0, 0 },
/* U+19fa */ { 0, 0, 0, 0, 0 },
/* U+19fb */ { 0, 0, 0, 0, 0 },
/* U+19fc */ { 0, 0, 0, 0, 0 },
/* U+19fd */ { 0, 0, 0, 0, 0 },
/* U+19fe */ { 0, 0, 0, 0, 0 },
/* U+19ff */ { 0, 0, 0, 0, 0 },
/* U+1a00 */ { 0, 0, 0, 0, 0 },
/* U+1a01 */ { 0, 0, 0, 0, 0 },
/* U+1a02 */ { 0, 0, 0, 0, 0 },
/* U+1a03 */ { 0, 0, 0, 0, 0 },
/* U+1a04 */ { 0, 0, 0, 0, 0 },
/* U+1a05 */ { 0, 0, 0, 0, 0 },
/* U+1a06 */ { 0, 0, 0, 0, 0 },
/* U+1a07 */ { 0, 0, 0, 0, 0 },
/* U+1a08 */ { 0, 0, 0, 0, 0 },
/* U+1a09 */ { 0, 0, 0, 0, 0 },
/* U+1a0a */ { 0, 0, 0, 0, 0 },
/* U+1a0b */ { 0, 0, 0, 0, 0 },
/* U+1a0c */ { 0, 0, 0, 0, 0 },
/* U+1a0d */ { 0, 0, 0, 0, 0 },
/* U+1a0e */ { 0, 0, 0, 0, 0 },
/* U+1a0f */ { 0, 0, 0, 0, 0 },
/* U+1a10 */ { 0, 0, 0, 0, 0 },
/* U+1a11 */ { 0, 0, 0, 0, 0 },
/* U+1a12 */ { 0, 0, 0, 0, 0 },
/* U+1a13 */ { 0, 0, 0, 0, 0 },
/* U+1a14 */ { 0, 0, 0, 0, 0 },
/* U+1a15 */ { 0, 0, 0, 0, 0 },
/* U+1a16 */ { 0, 0, 0, 0, 0 },
/* U+1a17 */ { 0, 0, 0, 0, 0 },
/* U+1a18 */ { 0, 0, 0, 0, 0 },
/* U+1a19 */ { 0, 0, 0, 0, 0 },
/* U+1a1a */ { 0, 0, 0, 0, 0 },
/* U+1a1b */ { 0, 0, 0, 0, 0 },
/* U+1a1c */ { 0, 0, 0, 0, 0 },
/* U+1a1d */ { 0, 0, 0, 0, 0 },
/* U+1a1e */ { 0, 0, 0, 0, 0 },
/* U+1a1f */ { 0, 0, 0, 0, 0 },
/* U+1a20 */ { 0, 0, 0, 0, 0 },
/* U+1a21 */ { 0, 0, 0, 0, 0 },
/* U+1a22 */ { 0, 0, 0, 0, 0 },
/* U+1a23 */ { 0, 0, 0, 0, 0 },
/* U+1a24 */ { 0, 0, 0, 0, 0 },
/* U+1a25 */ { 0, 0, 0, 0, 0 },
/* U+1a26 */ { 0, 0, 0, 0, 0 },
/* U+1a27 */ { 0, 0, 0, 0, 0 },
/* U+1a28 */ { 0, 0, 0, 0, 0 },
/* U+1a29 */ { 0, 0, 0, 0, 0 },
/* U+1a2a */ { 0, 0, 0, 0, 0 },
/* U+1a2b */ { 0, 0, 0, 0, 0 },
/* U+1a2c */ { 0, 0, 0, 0, 0 },
/* U+1a2d */ { 0, 0, 0, 0, 0 },
/* U+1a2e */ { 0, 0, 0, 0, 0 },
/* U+1a2f */ { 0, 0, 0, 0, 0 },
/* U+1a30 */ { 0, 0, 0, 0, 0 },
/* U+1a31 */ { 0, 0, 0, 0, 0 },
/* U+1a32 */ { 0, 0, 0, 0, 0 },
/* U+1a33 */ { 0, 0, 0, 0, 0 },
/* U+1a34 */ { 0, 0, 0, 0, 0 },
/* U+1a35 */ { 0, 0, 0, 0, 0 },
/* U+1a36 */ { 0, 0, 0, 0, 0 },
/* U+1a37 */ { 0, 0, 0, 0, 0 },
/* U+1a38 */ { 0, 0, 0, 0, 0 },
/* U+1a39 */ { 0, 0, 0, 0, 0 },
/* U+1a3a */ { 0, 0, 0, 0, 0 },
/* U+1a3b */ { 0, 0, 0, 0, 0 },
/* U+1a3c */ { 0, 0, 0, 0, 0 },
/* U+1a3d */ { 0, 0, 0, 0, 0 },
/* U+1a3e */ { 0, 0, 0, 0, 0 },
/* U+1a3f */ { 0, 0, 0, 0, 0 },
/* U+1a40 */ { 0, 0, 0, 0, 0 },
/* U+1a41 */ { 0, 0, 0, 0, 0 },
/* U+1a42 */ { 0, 0, 0, 0, 0 },
/* U+1a43 */ { 0, 0, 0, 0, 0 },
/* U+1a44 */ { 0, 0, 0, 0, 0 },
/* U+1a45 */ { 0, 0, 0, 0, 0 },
/* U+1a46 */ { 0, 0, 0, 0, 0 },
/* U+1a47 */ { 0, 0, 0, 0, 0 },
/* U+1a48 */ { 0, 0, 0, 0, 0 },
/* U+1a49 */ { 0, 0, 0, 0, 0 },
/* U+1a4a */ { 0, 0, 0, 0, 0 },
/* U+1a4b */ { 0, 0, 0, 0, 0 },
/* U+1a4c */ { 0, 0, 0, 0, 0 },
/* U+1a4d */ { 0, 0, 0, 0, 0 },
/* U+1a4e */ { 0, 0, 0, 0, 0 },
/* U+1a4f */ { 0, 0, 0, 0, 0 },
/* U+1a50 */ { 0, 0, 0, 0, 0 },
/* U+1a51 */ { 0, 0, 0, 0, 0 },
/* U+1a52 */ { 0, 0, 0, 0, 0 },
/* U+1a53 */ { 0, 0, 0, 0, 0 },
/* U+1a54 */ { 0, 0, 0, 0, 0 },
/* U+1a55 */ { 0, 0, 0, 0, 0 },
/* U+1a56 */ { 0, 0, 0, 0, 0 },
/* U+1a57 */ { 0, 0, 0, 0, 0 },
/* U+1a58 */ { 0, 0, 0, 0, 0 },
/* U+1a59 */ { 0, 0, 0, 0, 0 },
/* U+1a5a */ { 0, 0, 0, 0, 0 },
/* U+1a5b */ { 0, 0, 0, 0, 0 },
/* U+1a5c */ { 0, 0, 0, 0, 0 },
/* U+1a5d */ { 0, 0, 0, 0, 0 },
/* U+1a5e */ { 0, 0, 0, 0, 0 },
/* U+1a5f */ { 0, 0, 0, 0, 0 },
/* U+1a60 */ { 0, 0, 0, 0, 0 },
/* U+1a61 */ { 0, 0, 0, 0, 0 },
/* U+1a62 */ { 0, 0, 0, 0, 0 },
/* U+1a63 */ { 0, 0, 0, 0, 0 },
/* U+1a64 */ { 0, 0, 0, 0, 0 },
/* U+1a65 */ { 0, 0, 0, 0, 0 },
/* U+1a66 */ { 0, 0, 0, 0, 0 },
/* U+1a67 */ { 0, 0, 0, 0, 0 },
/* U+1a68 */ { 0, 0, 0, 0, 0 },
/* U+1a69 */ { 0, 0, 0, 0, 0 },
/* U+1a6a */ { 0, 0, 0, 0, 0 },
/* U+1a6b */ { 0, 0, 0, 0, 0 },
/* U+1a6c */ { 0, 0, 0, 0, 0 },
/* U+1a6d */ { 0, 0, 0, 0, 0 },
/* U+1a6e */ { 0, 0, 0, 0, 0 },
/* U+1a6f */ { 0, 0, 0, 0, 0 },
/* U+1a70 */ { 0, 0, 0, 0, 0 },
/* U+1a71 */ { 0, 0, 0, 0, 0 },
/* U+1a72 */ { 0, 0, 0, 0, 0 },
/* U+1a73 */ { 0, 0, 0, 0, 0 },
/* U+1a74 */ { 0, 0, 0, 0, 0 },
/* U+1a75 */ { 0, 0, 0, 0, 0 },
/* U+1a76 */ { 0, 0, 0, 0, 0 },
/* U+1a77 */ { 0, 0, 0, 0, 0 },
/* U+1a78 */ { 0, 0, 0, 0, 0 },
/* U+1a79 */ { 0, 0, 0, 0, 0 },
/* U+1a7a */ { 0, 0, 0, 0, 0 },
/* U+1a7b */ { 0, 0, 0, 0, 0 },
/* U+1a7c */ { 0, 0, 0, 0, 0 },
/* U+1a7d */ { 0, 0, 0, 0, 0 },
/* U+1a7e */ { 0, 0, 0, 0, 0 },
/* U+1a7f */ { 0, 0, 0, 0, 0 },
/* U+1a80 */ { 0, 0, 0, 0, 0 },
/* U+1a81 */ { 0, 0, 0, 0, 0 },
/* U+1a82 */ { 0, 0, 0, 0, 0 },
/* U+1a83 */ { 0, 0, 0, 0, 0 },
/* U+1a84 */ { 0, 0, 0, 0, 0 },
/* U+1a85 */ { 0, 0, 0, 0, 0 },
/* U+1a86 */ { 0, 0, 0, 0, 0 },
/* U+1a87 */ { 0, 0, 0, 0, 0 },
/* U+1a88 */ { 0, 0, 0, 0, 0 },
/* U+1a89 */ { 0, 0, 0, 0, 0 },
/* U+1a8a */ { 0, 0, 0, 0, 0 },
/* U+1a8b */ { 0, 0, 0, 0, 0 },
/* U+1a8c */ { 0, 0, 0, 0, 0 },
/* U+1a8d */ { 0, 0, 0, 0, 0 },
/* U+1a8e */ { 0, 0, 0, 0, 0 },
/* U+1a8f */ { 0, 0, 0, 0, 0 },
/* U+1a90 */ { 0, 0, 0, 0, 0 },
/* U+1a91 */ { 0, 0, 0, 0, 0 },
/* U+1a92 */ { 0, 0, 0, 0, 0 },
/* U+1a93 */ { 0, 0, 0, 0, 0 },
/* U+1a94 */ { 0, 0, 0, 0, 0 },
/* U+1a95 */ { 0, 0, 0, 0, 0 },
/* U+1a96 */ { 0, 0, 0, 0, 0 },
/* U+1a97 */ { 0, 0, 0, 0, 0 },
/* U+1a98 */ { 0, 0, 0, 0, 0 },
/* U+1a99 */ { 0, 0, 0, 0, 0 },
/* U+1a9a */ { 0, 0, 0, 0, 0 },
/* U+1a9b */ { 0, 0, 0, 0, 0 },
/* U+1a9c */ { 0, 0, 0, 0, 0 },
/* U+1a9d */ { 0, 0, 0, 0, 0 },
/* U+1a9e */ { 0, 0, 0, 0, 0 },
/* U+1a9f */ { 0, 0, 0, 0, 0 },
/* U+1aa0 */ { 0, 0, 0, 0, 0 },
/* U+1aa1 */ { 0, 0, 0, 0, 0 },
/* U+1aa2 */ { 0, 0, 0, 0, 0 },
/* U+1aa3 */ { 0, 0, 0, 0, 0 },
/* U+1aa4 */ { 0, 0, 0, 0, 0 },
/* U+1aa5 */ { 0, 0, 0, 0, 0 },
/* U+1aa6 */ { 0, 0, 0, 0, 0 },
/* U+1aa7 */ { 0, 0, 0, 0, 0 },
/* U+1aa8 */ { 0, 0, 0, 0, 0 },
/* U+1aa9 */ { 0, 0, 0, 0, 0 },
/* U+1aaa */ { 0, 0, 0, 0, 0 },
/* U+1aab */ { 0, 0, 0, 0, 0 },
/* U+1aac */ { 0, 0, 0, 0, 0 },
/* U+1aad */ { 0, 0, 0, 0, 0 },
/* U+1aae */ { 0, 0, 0, 0, 0 },
/* U+1aaf */ { 0, 0, 0, 0, 0 },
/* U+1ab0 */ { 0, 0, 0, 0, 0 },
/* U+1ab1 */ { 0, 0, 0, 0, 0 },
/* U+1ab2 */ { 0, 0, 0, 0, 0 },
/* U+1ab3 */ { 0, 0, 0, 0, 0 },
/* U+1ab4 */ { 0, 0, 0, 0, 0 },
/* U+1ab5 */ { 0, 0, 0, 0, 0 },
/* U+1ab6 */ { 0, 0, 0, 0, 0 },
/* U+1ab7 */ { 0, 0, 0, 0, 0 },
/* U+1ab8 */ { 0, 0, 0, 0, 0 },
/* U+1ab9 */ { 0, 0, 0, 0, 0 },
/* U+1aba */ { 0, 0, 0, 0, 0 },
/* U+1abb */ { 0, 0, 0, 0, 0 },
/* U+1abc */ { 0, 0, 0, 0, 0 },
/* U+1abd */ { 0, 0, 0, 0, 0 },
/* U+1abe */ { 0, 0, 0, 0, 0 },
/* U+1abf */ { 0, 0, 0, 0, 0 },
/* U+1ac0 */ { 0, 0, 0, 0, 0 },
/* U+1ac1 */ { 0, 0, 0, 0, 0 },
/* U+1ac2 */ { 0, 0, 0, 0, 0 },
/* U+1ac3 */ { 0, 0, 0, 0, 0 },
/* U+1ac4 */ { 0, 0, 0, 0, 0 },
/* U+1ac5 */ { 0, 0, 0, 0, 0 },
/* U+1ac6 */ { 0, 0, 0, 0, 0 },
/* U+1ac7 */ { 0, 0, 0, 0, 0 },
/* U+1ac8 */ { 0, 0, 0, 0, 0 },
/* U+1ac9 */ { 0, 0, 0, 0, 0 },
/* U+1aca */ { 0, 0, 0, 0, 0 },
/* U+1acb */ { 0, 0, 0, 0, 0 },
/* U+1acc */ { 0, 0, 0, 0, 0 },
/* U+1acd */ { 0, 0, 0, 0, 0 },
/* U+1ace */ { 0, 0, 0, 0, 0 },
/* U+1acf */ { 0, 0, 0, 0, 0 },
/* U+1ad0 */ { 0, 0, 0, 0, 0 },
/* U+1ad1 */ { 0, 0, 0, 0, 0 },
/* U+1ad2 */ { 0, 0, 0, 0, 0 },
/* U+1ad3 */ { 0, 0, 0, 0, 0 },
/* U+1ad4 */ { 0, 0, 0, 0, 0 },
/* U+1ad5 */ { 0, 0, 0, 0, 0 },
/* U+1ad6 */ { 0, 0, 0, 0, 0 },
/* U+1ad7 */ { 0, 0, 0, 0, 0 },
/* U+1ad8 */ { 0, 0, 0, 0, 0 },
/* U+1ad9 */ { 0, 0, 0, 0, 0 },
/* U+1ada */ { 0, 0, 0, 0, 0 },
/* U+1adb */ { 0, 0, 0, 0, 0 },
/* U+1adc */ { 0, 0, 0, 0, 0 },
/* U+1add */ { 0, 0, 0, 0, 0 },
/* U+1ade */ { 0, 0, 0, 0, 0 },
/* U+1adf */ { 0, 0, 0, 0, 0 },
/* U+1ae0 */ { 0, 0, 0, 0, 0 },
/* U+1ae1 */ { 0, 0, 0, 0, 0 },
/* U+1ae2 */ { 0, 0, 0, 0, 0 },
/* U+1ae3 */ { 0, 0, 0, 0, 0 },
/* U+1ae4 */ { 0, 0, 0, 0, 0 },
/* U+1ae5 */ { 0, 0, 0, 0, 0 },
/* U+1ae6 */ { 0, 0, 0, 0, 0 },
/* U+1ae7 */ { 0, 0, 0, 0, 0 },
/* U+1ae8 */ { 0, 0, 0, 0, 0 },
/* U+1ae9 */ { 0, 0, 0, 0, 0 },
/* U+1aea */ { 0, 0, 0, 0, 0 },
/* U+1aeb */ { 0, 0, 0, 0, 0 },
/* U+1aec */ { 0, 0, 0, 0, 0 },
/* U+1aed */ { 0, 0, 0, 0, 0 },
/* U+1aee */ { 0, 0, 0, 0, 0 },
/* U+1aef */ { 0, 0, 0, 0, 0 },
/* U+1af0 */ { 0, 0, 0, 0, 0 },
/* U+1af1 */ { 0, 0, 0, 0, 0 },
/* U+1af2 */ { 0, 0, 0, 0, 0 },
/* U+1af3 */ { 0, 0, 0, 0, 0 },
/* U+1af4 */ { 0, 0, 0, 0, 0 },
/* U+1af5 */ { 0, 0, 0, 0, 0 },
/* U+1af6 */ { 0, 0, 0, 0, 0 },
/* U+1af7 */ { 0, 0, 0, 0, 0 },
/* U+1af8 */ { 0, 0, 0, 0, 0 },
/* U+1af9 */ { 0, 0, 0, 0, 0 },
/* U+1afa */ { 0, 0, 0, 0, 0 },
/* U+1afb */ { 0, 0, 0, 0, 0 },
/* U+1afc */ { 0, 0, 0, 0, 0 },
/* U+1afd */ { 0, 0, 0, 0, 0 },
/* U+1afe */ { 0, 0, 0, 0, 0 },
/* U+1aff */ { 0, 0, 0, 0, 0 },
/* U+1b00 */ { 0, 0, 0, 0, 0 },
/* U+1b01 */ { 0, 0, 0, 0, 0 },
/* U+1b02 */ { 0, 0, 0, 0, 0 },
/* U+1b03 */ { 0, 0, 0, 0, 0 },
/* U+1b04 */ { 0, 0, 0, 0, 0 },
/* U+1b05 */ { 0, 0, 0, 0, 0 },
/* U+1b06 */ { 0, 0, 0, 0, 0 },
/* U+1b07 */ { 0, 0, 0, 0, 0 },
/* U+1b08 */ { 0, 0, 0, 0, 0 },
/* U+1b09 */ { 0, 0, 0, 0, 0 },
/* U+1b0a */ { 0, 0, 0, 0, 0 },
/* U+1b0b */ { 0, 0, 0, 0, 0 },
/* U+1b0c */ { 0, 0, 0, 0, 0 },
/* U+1b0d */ { 0, 0, 0, 0, 0 },
/* U+1b0e */ { 0, 0, 0, 0, 0 },
/* U+1b0f */ { 0, 0, 0, 0, 0 },
/* U+1b10 */ { 0, 0, 0, 0, 0 },
/* U+1b11 */ { 0, 0, 0, 0, 0 },
/* U+1b12 */ { 0, 0, 0, 0, 0 },
/* U+1b13 */ { 0, 0, 0, 0, 0 },
/* U+1b14 */ { 0, 0, 0, 0, 0 },
/* U+1b15 */ { 0, 0, 0, 0, 0 },
/* U+1b16 */ { 0, 0, 0, 0, 0 },
/* U+1b17 */ { 0, 0, 0, 0, 0 },
/* U+1b18 */ { 0, 0, 0, 0, 0 },
/* U+1b19 */ { 0, 0, 0, 0, 0 },
/* U+1b1a */ { 0, 0, 0, 0, 0 },
/* U+1b1b */ { 0, 0, 0, 0, 0 },
/* U+1b1c */ { 0, 0, 0, 0, 0 },
/* U+1b1d */ { 0, 0, 0, 0, 0 },
/* U+1b1e */ { 0, 0, 0, 0, 0 },
/* U+1b1f */ { 0, 0, 0, 0, 0 },
/* U+1b20 */ { 0, 0, 0, 0, 0 },
/* U+1b21 */ { 0, 0, 0, 0, 0 },
/* U+1b22 */ { 0, 0, 0, 0, 0 },
/* U+1b23 */ { 0, 0, 0, 0, 0 },
/* U+1b24 */ { 0, 0, 0, 0, 0 },
/* U+1b25 */ { 0, 0, 0, 0, 0 },
/* U+1b26 */ { 0, 0, 0, 0, 0 },
/* U+1b27 */ { 0, 0, 0, 0, 0 },
/* U+1b28 */ { 0, 0, 0, 0, 0 },
/* U+1b29 */ { 0, 0, 0, 0, 0 },
/* U+1b2a */ { 0, 0, 0, 0, 0 },
/* U+1b2b */ { 0, 0, 0, 0, 0 },
/* U+1b2c */ { 0, 0, 0, 0, 0 },
/* U+1b2d */ { 0, 0, 0, 0, 0 },
/* U+1b2e */ { 0, 0, 0, 0, 0 },
/* U+1b2f */ { 0, 0, 0, 0, 0 },
/* U+1b30 */ { 0, 0, 0, 0, 0 },
/* U+1b31 */ { 0, 0, 0, 0, 0 },
/* U+1b32 */ { 0, 0, 0, 0, 0 },
/* U+1b33 */ { 0, 0, 0, 0, 0 },
/* U+1b34 */ { 0, 0, 0, 0, 0 },
/* U+1b35 */ { 0, 0, 0, 0, 0 },
/* U+1b36 */ { 0, 0, 0, 0, 0 },
/* U+1b37 */ { 0, 0, 0, 0, 0 },
/* U+1b38 */ { 0, 0, 0, 0, 0 },
/* U+1b39 */ { 0, 0, 0, 0, 0 },
/* U+1b3a */ { 0, 0, 0, 0, 0 },
/* U+1b3b */ { 0, 0, 0, 0, 0 },
/* U+1b3c */ { 0, 0, 0, 0, 0 },
/* U+1b3d */ { 0, 0, 0, 0, 0 },
/* U+1b3e */ { 0, 0, 0, 0, 0 },
/* U+1b3f */ { 0, 0, 0, 0, 0 },
/* U+1b40 */ { 0, 0, 0, 0, 0 },
/* U+1b41 */ { 0, 0, 0, 0, 0 },
/* U+1b42 */ { 0, 0, 0, 0, 0 },
/* U+1b43 */ { 0, 0, 0, 0, 0 },
/* U+1b44 */ { 0, 0, 0, 0, 0 },
/* U+1b45 */ { 0, 0, 0, 0, 0 },
/* U+1b46 */ { 0, 0, 0, 0, 0 },
/* U+1b47 */ { 0, 0, 0, 0, 0 },
/* U+1b48 */ { 0, 0, 0, 0, 0 },
/* U+1b49 */ { 0, 0, 0, 0, 0 },
/* U+1b4a */ { 0, 0, 0, 0, 0 },
/* U+1b4b */ { 0, 0, 0, 0, 0 },
/* U+1b4c */ { 0, 0, 0, 0, 0 },
/* U+1b4d */ { 0, 0, 0, 0, 0 },
/* U+1b4e */ { 0, 0, 0, 0, 0 },
/* U+1b4f */ { 0, 0, 0, 0, 0 },
/* U+1b50 */ { 0, 0, 0, 0, 0 },
/* U+1b51 */ { 0, 0, 0, 0, 0 },
/* U+1b52 */ { 0, 0, 0, 0, 0 },
/* U+1b53 */ { 0, 0, 0, 0, 0 },
/* U+1b54 */ { 0, 0, 0, 0, 0 },
/* U+1b55 */ { 0, 0, 0, 0, 0 },
/* U+1b56 */ { 0, 0, 0, 0, 0 },
/* U+1b57 */ { 0, 0, 0, 0, 0 },
/* U+1b58 */ { 0, 0, 0, 0, 0 },
/* U+1b59 */ { 0, 0, 0, 0, 0 },
/* U+1b5a */ { 0, 0, 0, 0, 0 },
/* U+1b5b */ { 0, 0, 0, 0, 0 },
/* U+1b5c */ { 0, 0, 0, 0, 0 },
/* U+1b5d */ { 0, 0, 0, 0, 0 },
/* U+1b5e */ { 0, 0, 0, 0, 0 },
/* U+1b5f */ { 0, 0, 0, 0, 0 },
/* U+1b60 */ { 0, 0, 0, 0, 0 },
/* U+1b61 */ { 0, 0, 0, 0, 0 },
/* U+1b62 */ { 0, 0, 0, 0, 0 },
/* U+1b63 */ { 0, 0, 0, 0, 0 },
/* U+1b64 */ { 0, 0, 0, 0, 0 },
/* U+1b65 */ { 0, 0, 0, 0, 0 },
/* U+1b66 */ { 0, 0, 0, 0, 0 },
/* U+1b67 */ { 0, 0, 0, 0, 0 },
/* U+1b68 */ { 0, 0, 0, 0, 0 },
/* U+1b69 */ { 0, 0, 0, 0, 0 },
/* U+1b6a */ { 0, 0, 0, 0, 0 },
/* U+1b6b */ { 0, 0, 0, 0, 0 },
/* U+1b6c */ { 0, 0, 0, 0, 0 },
/* U+1b6d */ { 0, 0, 0, 0, 0 },
/* U+1b6e */ { 0, 0, 0, 0, 0 },
/* U+1b6f */ { 0, 0, 0, 0, 0 },
/* U+1b70 */ { 0, 0, 0, 0, 0 },
/* U+1b71 */ { 0, 0, 0, 0, 0 },
/* U+1b72 */ { 0, 0, 0, 0, 0 },
/* U+1b73 */ { 0, 0, 0, 0, 0 },
/* U+1b74 */ { 0, 0, 0, 0, 0 },
/* U+1b75 */ { 0, 0, 0, 0, 0 },
/* U+1b76 */ { 0, 0, 0, 0, 0 },
/* U+1b77 */ { 0, 0, 0, 0, 0 },
/* U+1b78 */ { 0, 0, 0, 0, 0 },
/* U+1b79 */ { 0, 0, 0, 0, 0 },
/* U+1b7a */ { 0, 0, 0, 0, 0 },
/* U+1b7b */ { 0, 0, 0, 0, 0 },
/* U+1b7c */ { 0, 0, 0, 0, 0 },
/* U+1b7d */ { 0, 0, 0, 0, 0 },
/* U+1b7e */ { 0, 0, 0, 0, 0 },
/* U+1b7f */ { 0, 0, 0, 0, 0 },
/* U+1b80 */ { 0, 0, 0, 0, 0 },
/* U+1b81 */ { 0, 0, 0, 0, 0 },
/* U+1b82 */ { 0, 0, 0, 0, 0 },
/* U+1b83 */ { 0, 0, 0, 0, 0 },
/* U+1b84 */ { 0, 0, 0, 0, 0 },
/* U+1b85 */ { 0, 0, 0, 0, 0 },
/* U+1b86 */ { 0, 0, 0, 0, 0 },
/* U+1b87 */ { 0, 0, 0, 0, 0 },
/* U+1b88 */ { 0, 0, 0, 0, 0 },
/* U+1b89 */ { 0, 0, 0, 0, 0 },
/* U+1b8a */ { 0, 0, 0, 0, 0 },
/* U+1b8b */ { 0, 0, 0, 0, 0 },
/* U+1b8c */ { 0, 0, 0, 0, 0 },
/* U+1b8d */ { 0, 0, 0, 0, 0 },
/* U+1b8e */ { 0, 0, 0, 0, 0 },
/* U+1b8f */ { 0, 0, 0, 0, 0 },
/* U+1b90 */ { 0, 0, 0, 0, 0 },
/* U+1b91 */ { 0, 0, 0, 0, 0 },
/* U+1b92 */ { 0, 0, 0, 0, 0 },
/* U+1b93 */ { 0, 0, 0, 0, 0 },
/* U+1b94 */ { 0, 0, 0, 0, 0 },
/* U+1b95 */ { 0, 0, 0, 0, 0 },
/* U+1b96 */ { 0, 0, 0, 0, 0 },
/* U+1b97 */ { 0, 0, 0, 0, 0 },
/* U+1b98 */ { 0, 0, 0, 0, 0 },
/* U+1b99 */ { 0, 0, 0, 0, 0 },
/* U+1b9a */ { 0, 0, 0, 0, 0 },
/* U+1b9b */ { 0, 0, 0, 0, 0 },
/* U+1b9c */ { 0, 0, 0, 0, 0 },
/* U+1b9d */ { 0, 0, 0, 0, 0 },
/* U+1b9e */ { 0, 0, 0, 0, 0 },
/* U+1b9f */ { 0, 0, 0, 0, 0 },
/* U+1ba0 */ { 0, 0, 0, 0, 0 },
/* U+1ba1 */ { 0, 0, 0, 0, 0 },
/* U+1ba2 */ { 0, 0, 0, 0, 0 },
/* U+1ba3 */ { 0, 0, 0, 0, 0 },
/* U+1ba4 */ { 0, 0, 0, 0, 0 },
/* U+1ba5 */ { 0, 0, 0, 0, 0 },
/* U+1ba6 */ { 0, 0, 0, 0, 0 },
/* U+1ba7 */ { 0, 0, 0, 0, 0 },
/* U+1ba8 */ { 0, 0, 0, 0, 0 },
/* U+1ba9 */ { 0, 0, 0, 0, 0 },
/* U+1baa */ { 0, 0, 0, 0, 0 },
/* U+1bab */ { 0, 0, 0, 0, 0 },
/* U+1bac */ { 0, 0, 0, 0, 0 },
/* U+1bad */ { 0, 0, 0, 0, 0 },
/* U+1bae */ { 0, 0, 0, 0, 0 },
/* U+1baf */ { 0, 0, 0, 0, 0 },
/* U+1bb0 */ { 0, 0, 0, 0, 0 },
/* U+1bb1 */ { 0, 0, 0, 0, 0 },
/* U+1bb2 */ { 0, 0, 0, 0, 0 },
/* U+1bb3 */ { 0, 0, 0, 0, 0 },
/* U+1bb4 */ { 0, 0, 0, 0, 0 },
/* U+1bb5 */ { 0, 0, 0, 0, 0 },
/* U+1bb6 */ { 0, 0, 0, 0, 0 },
/* U+1bb7 */ { 0, 0, 0, 0, 0 },
/* U+1bb8 */ { 0, 0, 0, 0, 0 },
/* U+1bb9 */ { 0, 0, 0, 0, 0 },
/* U+1bba */ { 0, 0, 0, 0, 0 },
/* U+1bbb */ { 0, 0, 0, 0, 0 },
/* U+1bbc */ { 0, 0, 0, 0, 0 },
/* U+1bbd */ { 0, 0, 0, 0, 0 },
/* U+1bbe */ { 0, 0, 0, 0, 0 },
/* U+1bbf */ { 0, 0, 0, 0, 0 },
/* U+1bc0 */ { 0, 0, 0, 0, 0 },
/* U+1bc1 */ { 0, 0, 0, 0, 0 },
/* U+1bc2 */ { 0, 0, 0, 0, 0 },
/* U+1bc3 */ { 0, 0, 0, 0, 0 },
/* U+1bc4 */ { 0, 0, 0, 0, 0 },
/* U+1bc5 */ { 0, 0, 0, 0, 0 },
/* U+1bc6 */ { 0, 0, 0, 0, 0 },
/* U+1bc7 */ { 0, 0, 0, 0, 0 },
/* U+1bc8 */ { 0, 0, 0, 0, 0 },
/* U+1bc9 */ { 0, 0, 0, 0, 0 },
/* U+1bca */ { 0, 0, 0, 0, 0 },
/* U+1bcb */ { 0, 0, 0, 0, 0 },
/* U+1bcc */ { 0, 0, 0, 0, 0 },
/* U+1bcd */ { 0, 0, 0, 0, 0 },
/* U+1bce */ { 0, 0, 0, 0, 0 },
/* U+1bcf */ { 0, 0, 0, 0, 0 },
/* U+1bd0 */ { 0, 0, 0, 0, 0 },
/* U+1bd1 */ { 0, 0, 0, 0, 0 },
/* U+1bd2 */ { 0, 0, 0, 0, 0 },
/* U+1bd3 */ { 0, 0, 0, 0, 0 },
/* U+1bd4 */ { 0, 0, 0, 0, 0 },
/* U+1bd5 */ { 0, 0, 0, 0, 0 },
/* U+1bd6 */ { 0, 0, 0, 0, 0 },
/* U+1bd7 */ { 0, 0, 0, 0, 0 },
/* U+1bd8 */ { 0, 0, 0, 0, 0 },
/* U+1bd9 */ { 0, 0, 0, 0, 0 },
/* U+1bda */ { 0, 0, 0, 0, 0 },
/* U+1bdb */ { 0, 0, 0, 0, 0 },
/* U+1bdc */ { 0, 0, 0, 0, 0 },
/* U+1bdd */ { 0, 0, 0, 0, 0 },
/* U+1bde */ { 0, 0, 0, 0, 0 },
/* U+1bdf */ { 0, 0, 0, 0, 0 },
/* U+1be0 */ { 0, 0, 0, 0, 0 },
/* U+1be1 */ { 0, 0, 0, 0, 0 },
/* U+1be2 */ { 0, 0, 0, 0, 0 },
/* U+1be3 */ { 0, 0, 0, 0, 0 },
/* U+1be4 */ { 0, 0, 0, 0, 0 },
/* U+1be5 */ { 0, 0, 0, 0, 0 },
/* U+1be6 */ { 0, 0, 0, 0, 0 },
/* U+1be7 */ { 0, 0, 0, 0, 0 },
/* U+1be8 */ { 0, 0, 0, 0, 0 },
/* U+1be9 */ { 0, 0, 0, 0, 0 },
/* U+1bea */ { 0, 0, 0, 0, 0 },
/* U+1beb */ { 0, 0, 0, 0, 0 },
/* U+1bec */ { 0, 0, 0, 0, 0 },
/* U+1bed */ { 0, 0, 0, 0, 0 },
/* U+1bee */ { 0, 0, 0, 0, 0 },
/* U+1bef */ { 0, 0, 0, 0, 0 },
/* U+1bf0 */ { 0, 0, 0, 0, 0 },
/* U+1bf1 */ { 0, 0, 0, 0, 0 },
/* U+1bf2 */ { 0, 0, 0, 0, 0 },
/* U+1bf3 */ { 0, 0, 0, 0, 0 },
/* U+1bf4 */ { 0, 0, 0, 0, 0 },
/* U+1bf5 */ { 0, 0, 0, 0, 0 },
/* U+1bf6 */ { 0, 0, 0, 0, 0 },
/* U+1bf7 */ { 0, 0, 0, 0, 0 },
/* U+1bf8 */ { 0, 0, 0, 0, 0 },
/* U+1bf9 */ { 0, 0, 0, 0, 0 },
/* U+1bfa */ { 0, 0, 0, 0, 0 },
/* U+1bfb */ { 0, 0, 0, 0, 0 },
/* U+1bfc */ { 0, 0, 0, 0, 0 },
/* U+1bfd */ { 0, 0, 0, 0, 0 },
/* U+1bfe */ { 0, 0, 0, 0, 0 },
/* U+1bff */ { 0, 0, 0, 0, 0 },
/* U+1c00 */ { 0, 0, 0, 0, 0 },
/* U+1c01 */ { 0, 0, 0, 0, 0 },
/* U+1c02 */ { 0, 0, 0, 0, 0 },
/* U+1c03 */ { 0, 0, 0, 0, 0 },
/* U+1c04 */ { 0, 0, 0, 0, 0 },
/* U+1c05 */ { 0, 0, 0, 0, 0 },
/* U+1c06 */ { 0, 0, 0, 0, 0 },
/* U+1c07 */ { 0, 0, 0, 0, 0 },
/* U+1c08 */ { 0, 0, 0, 0, 0 },
/* U+1c09 */ { 0, 0, 0, 0, 0 },
/* U+1c0a */ { 0, 0, 0, 0, 0 },
/* U+1c0b */ { 0, 0, 0, 0, 0 },
/* U+1c0c */ { 0, 0, 0, 0, 0 },
/* U+1c0d */ { 0, 0, 0, 0, 0 },
/* U+1c0e */ { 0, 0, 0, 0, 0 },
/* U+1c0f */ { 0, 0, 0, 0, 0 },
/* U+1c10 */ { 0, 0, 0, 0, 0 },
/* U+1c11 */ { 0, 0, 0, 0, 0 },
/* U+1c12 */ { 0, 0, 0, 0, 0 },
/* U+1c13 */ { 0, 0, 0, 0, 0 },
/* U+1c14 */ { 0, 0, 0, 0, 0 },
/* U+1c15 */ { 0, 0, 0, 0, 0 },
/* U+1c16 */ { 0, 0, 0, 0, 0 },
/* U+1c17 */ { 0, 0, 0, 0, 0 },
/* U+1c18 */ { 0, 0, 0, 0, 0 },
/* U+1c19 */ { 0, 0, 0, 0, 0 },
/* U+1c1a */ { 0, 0, 0, 0, 0 },
/* U+1c1b */ { 0, 0, 0, 0, 0 },
/* U+1c1c */ { 0, 0, 0, 0, 0 },
/* U+1c1d */ { 0, 0, 0, 0, 0 },
/* U+1c1e */ { 0, 0, 0, 0, 0 },
/* U+1c1f */ { 0, 0, 0, 0, 0 },
/* U+1c20 */ { 0, 0, 0, 0, 0 },
/* U+1c21 */ { 0, 0, 0, 0, 0 },
/* U+1c22 */ { 0, 0, 0, 0, 0 },
/* U+1c23 */ { 0, 0, 0, 0, 0 },
/* U+1c24 */ { 0, 0, 0, 0, 0 },
/* U+1c25 */ { 0, 0, 0, 0, 0 },
/* U+1c26 */ { 0, 0, 0, 0, 0 },
/* U+1c27 */ { 0, 0, 0, 0, 0 },
/* U+1c28 */ { 0, 0, 0, 0, 0 },
/* U+1c29 */ { 0, 0, 0, 0, 0 },
/* U+1c2a */ { 0, 0, 0, 0, 0 },
/* U+1c2b */ { 0, 0, 0, 0, 0 },
/* U+1c2c */ { 0, 0, 0, 0, 0 },
/* U+1c2d */ { 0, 0, 0, 0, 0 },
/* U+1c2e */ { 0, 0, 0, 0, 0 },
/* U+1c2f */ { 0, 0, 0, 0, 0 },
/* U+1c30 */ { 0, 0, 0, 0, 0 },
/* U+1c31 */ { 0, 0, 0, 0, 0 },
/* U+1c32 */ { 0, 0, 0, 0, 0 },
/* U+1c33 */ { 0, 0, 0, 0, 0 },
/* U+1c34 */ { 0, 0, 0, 0, 0 },
/* U+1c35 */ { 0, 0, 0, 0, 0 },
/* U+1c36 */ { 0, 0, 0, 0, 0 },
/* U+1c37 */ { 0, 0, 0, 0, 0 },
/* U+1c38 */ { 0, 0, 0, 0, 0 },
/* U+1c39 */ { 0, 0, 0, 0, 0 },
/* U+1c3a */ { 0, 0, 0, 0, 0 },
/* U+1c3b */ { 0, 0, 0, 0, 0 },
/* U+1c3c */ { 0, 0, 0, 0, 0 },
/* U+1c3d */ { 0, 0, 0, 0, 0 },
/* U+1c3e */ { 0, 0, 0, 0, 0 },
/* U+1c3f */ { 0, 0, 0, 0, 0 },
/* U+1c40 */ { 0, 0, 0, 0, 0 },
/* U+1c41 */ { 0, 0, 0, 0, 0 },
/* U+1c42 */ { 0, 0, 0, 0, 0 },
/* U+1c43 */ { 0, 0, 0, 0, 0 },
/* U+1c44 */ { 0, 0, 0, 0, 0 },
/* U+1c45 */ { 0, 0, 0, 0, 0 },
/* U+1c46 */ { 0, 0, 0, 0, 0 },
/* U+1c47 */ { 0, 0, 0, 0, 0 },
/* U+1c48 */ { 0, 0, 0, 0, 0 },
/* U+1c49 */ { 0, 0, 0, 0, 0 },
/* U+1c4a */ { 0, 0, 0, 0, 0 },
/* U+1c4b */ { 0, 0, 0, 0, 0 },
/* U+1c4c */ { 0, 0, 0, 0, 0 },
/* U+1c4d */ { 0, 0, 0, 0, 0 },
/* U+1c4e */ { 0, 0, 0, 0, 0 },
/* U+1c4f */ { 0, 0, 0, 0, 0 },
/* U+1c50 */ { 0, 0, 0, 0, 0 },
/* U+1c51 */ { 0, 0, 0, 0, 0 },
/* U+1c52 */ { 0, 0, 0, 0, 0 },
/* U+1c53 */ { 0, 0, 0, 0, 0 },
/* U+1c54 */ { 0, 0, 0, 0, 0 },
/* U+1c55 */ { 0, 0, 0, 0, 0 },
/* U+1c56 */ { 0, 0, 0, 0, 0 },
/* U+1c57 */ { 0, 0, 0, 0, 0 },
/* U+1c58 */ { 0, 0, 0, 0, 0 },
/* U+1c59 */ { 0, 0, 0, 0, 0 },
/* U+1c5a */ { 0, 0, 0, 0, 0 },
/* U+1c5b */ { 0, 0, 0, 0, 0 },
/* U+1c5c */ { 0, 0, 0, 0, 0 },
/* U+1c5d */ { 0, 0, 0, 0, 0 },
/* U+1c5e */ { 0, 0, 0, 0, 0 },
/* U+1c5f */ { 0, 0, 0, 0, 0 },
/* U+1c60 */ { 0, 0, 0, 0, 0 },
/* U+1c61 */ { 0, 0, 0, 0, 0 },
/* U+1c62 */ { 0, 0, 0, 0, 0 },
/* U+1c63 */ { 0, 0, 0, 0, 0 },
/* U+1c64 */ { 0, 0, 0, 0, 0 },
/* U+1c65 */ { 0, 0, 0, 0, 0 },
/* U+1c66 */ { 0, 0, 0, 0, 0 },
/* U+1c67 */ { 0, 0, 0, 0, 0 },
/* U+1c68 */ { 0, 0, 0, 0, 0 },
/* U+1c69 */ { 0, 0, 0, 0, 0 },
/* U+1c6a */ { 0, 0, 0, 0, 0 },
/* U+1c6b */ { 0, 0, 0, 0, 0 },
/* U+1c6c */ { 0, 0, 0, 0, 0 },
/* U+1c6d */ { 0, 0, 0, 0, 0 },
/* U+1c6e */ { 0, 0, 0, 0, 0 },
/* U+1c6f */ { 0, 0, 0, 0, 0 },
/* U+1c70 */ { 0, 0, 0, 0, 0 },
/* U+1c71 */ { 0, 0, 0, 0, 0 },
/* U+1c72 */ { 0, 0, 0, 0, 0 },
/* U+1c73 */ { 0, 0, 0, 0, 0 },
/* U+1c74 */ { 0, 0, 0, 0, 0 },
/* U+1c75 */ { 0, 0, 0, 0, 0 },
/* U+1c76 */ { 0, 0, 0, 0, 0 },
/* U+1c77 */ { 0, 0, 0, 0, 0 },
/* U+1c78 */ { 0, 0, 0, 0, 0 },
/* U+1c79 */ { 0, 0, 0, 0, 0 },
/* U+1c7a */ { 0, 0, 0, 0, 0 },
/* U+1c7b */ { 0, 0, 0, 0, 0 },
/* U+1c7c */ { 0, 0, 0, 0, 0 },
/* U+1c7d */ { 0, 0, 0, 0, 0 },
/* U+1c7e */ { 0, 0, 0, 0, 0 },
/* U+1c7f */ { 0, 0, 0, 0, 0 },
/* U+1c80 */ { 0, 0, 0, 0, 0 },
/* U+1c81 */ { 0, 0, 0, 0, 0 },
/* U+1c82 */ { 0, 0, 0, 0, 0 },
/* U+1c83 */ { 0, 0, 0, 0, 0 },
/* U+1c84 */ { 0, 0, 0, 0, 0 },
/* U+1c85 */ { 0, 0, 0, 0, 0 },
/* U+1c86 */ { 0, 0, 0, 0, 0 },
/* U+1c87 */ { 0, 0, 0, 0, 0 },
/* U+1c88 */ { 0, 0, 0, 0, 0 },
/* U+1c89 */ { 0, 0, 0, 0, 0 },
/* U+1c8a */ { 0, 0, 0, 0, 0 },
/* U+1c8b */ { 0, 0, 0, 0, 0 },
/* U+1c8c */ { 0, 0, 0, 0, 0 },
/* U+1c8d */ { 0, 0, 0, 0, 0 },
/* U+1c8e */ { 0, 0, 0, 0, 0 },
/* U+1c8f */ { 0, 0, 0, 0, 0 },
/* U+1c90 */ { 0, 0, 0, 0, 0 },
/* U+1c91 */ { 0, 0, 0, 0, 0 },
/* U+1c92 */ { 0, 0, 0, 0, 0 },
/* U+1c93 */ { 0, 0, 0, 0, 0 },
/* U+1c94 */ { 0, 0, 0, 0, 0 },
/* U+1c95 */ { 0, 0, 0, 0, 0 },
/* U+1c96 */ { 0, 0, 0, 0, 0 },
/* U+1c97 */ { 0, 0, 0, 0, 0 },
/* U+1c98 */ { 0, 0, 0, 0, 0 },
/* U+1c99 */ { 0, 0, 0, 0, 0 },
/* U+1c9a */ { 0, 0, 0, 0, 0 },
/* U+1c9b */ { 0, 0, 0, 0, 0 },
/* U+1c9c */ { 0, 0, 0, 0, 0 },
/* U+1c9d */ { 0, 0, 0, 0, 0 },
/* U+1c9e */ { 0, 0, 0, 0, 0 },
/* U+1c9f */ { 0, 0, 0, 0, 0 },
/* U+1ca0 */ { 0, 0, 0, 0, 0 },
/* U+1ca1 */ { 0, 0, 0, 0, 0 },
/* U+1ca2 */ { 0, 0, 0, 0, 0 },
/* U+1ca3 */ { 0, 0, 0, 0, 0 },
/* U+1ca4 */ { 0, 0, 0, 0, 0 },
/* U+1ca5 */ { 0, 0, 0, 0, 0 },
/* U+1ca6 */ { 0, 0, 0, 0, 0 },
/* U+1ca7 */ { 0, 0, 0, 0, 0 },
/* U+1ca8 */ { 0, 0, 0, 0, 0 },
/* U+1ca9 */ { 0, 0, 0, 0, 0 },
/* U+1caa */ { 0, 0, 0, 0, 0 },
/* U+1cab */ { 0, 0, 0, 0, 0 },
/* U+1cac */ { 0, 0, 0, 0, 0 },
/* U+1cad */ { 0, 0, 0, 0, 0 },
/* U+1cae */ { 0, 0, 0, 0, 0 },
/* U+1caf */ { 0, 0, 0, 0, 0 },
/* U+1cb0 */ { 0, 0, 0, 0, 0 },
/* U+1cb1 */ { 0, 0, 0, 0, 0 },
/* U+1cb2 */ { 0, 0, 0, 0, 0 },
/* U+1cb3 */ { 0, 0, 0, 0, 0 },
/* U+1cb4 */ { 0, 0, 0, 0, 0 },
/* U+1cb5 */ { 0, 0, 0, 0, 0 },
/* U+1cb6 */ { 0, 0, 0, 0, 0 },
/* U+1cb7 */ { 0, 0, 0, 0, 0 },
/* U+1cb8 */ { 0, 0, 0, 0, 0 },
/* U+1cb9 */ { 0, 0, 0, 0, 0 },
/* U+1cba */ { 0, 0, 0, 0, 0 },
/* U+1cbb */ { 0, 0, 0, 0, 0 },
/* U+1cbc */ { 0, 0, 0, 0, 0 },
/* U+1cbd */ { 0, 0, 0, 0, 0 },
/* U+1cbe */ { 0, 0, 0, 0, 0 },
/* U+1cbf */ { 0, 0, 0, 0, 0 },
/* U+1cc0 */ { 0, 0, 0, 0, 0 },
/* U+1cc1 */ { 0, 0, 0, 0, 0 },
/* U+1cc2 */ { 0, 0, 0, 0, 0 },
/* U+1cc3 */ { 0, 0, 0, 0, 0 },
/* U+1cc4 */ { 0, 0, 0, 0, 0 },
/* U+1cc5 */ { 0, 0, 0, 0, 0 },
/* U+1cc6 */ { 0, 0, 0, 0, 0 },
/* U+1cc7 */ { 0, 0, 0, 0, 0 },
/* U+1cc8 */ { 0, 0, 0, 0, 0 },
/* U+1cc9 */ { 0, 0, 0, 0, 0 },
/* U+1cca */ { 0, 0, 0, 0, 0 },
/* U+1ccb */ { 0, 0, 0, 0, 0 },
/* U+1ccc */ { 0, 0, 0, 0, 0 },
/* U+1ccd */ { 0, 0, 0, 0, 0 },
/* U+1cce */ { 0, 0, 0, 0, 0 },
/* U+1ccf */ { 0, 0, 0, 0, 0 },
/* U+1cd0 */ { 0, 0, 0, 0, 0 },
/* U+1cd1 */ { 0, 0, 0, 0, 0 },
/* U+1cd2 */ { 0, 0, 0, 0, 0 },
/* U+1cd3 */ { 0, 0, 0, 0, 0 },
/* U+1cd4 */ { 0, 0, 0, 0, 0 },
/* U+1cd5 */ { 0, 0, 0, 0, 0 },
/* U+1cd6 */ { 0, 0, 0, 0, 0 },
/* U+1cd7 */ { 0, 0, 0, 0, 0 },
/* U+1cd8 */ { 0, 0, 0, 0, 0 },
/* U+1cd9 */ { 0, 0, 0, 0, 0 },
/* U+1cda */ { 0, 0, 0, 0, 0 },
/* U+1cdb */ { 0, 0, 0, 0, 0 },
/* U+1cdc */ { 0, 0, 0, 0, 0 },
/* U+1cdd */ { 0, 0, 0, 0, 0 },
/* U+1cde */ { 0, 0, 0, 0, 0 },
/* U+1cdf */ { 0, 0, 0, 0, 0 },
/* U+1ce0 */ { 0, 0, 0, 0, 0 },
/* U+1ce1 */ { 0, 0, 0, 0, 0 },
/* U+1ce2 */ { 0, 0, 0, 0, 0 },
/* U+1ce3 */ { 0, 0, 0, 0, 0 },
/* U+1ce4 */ { 0, 0, 0, 0, 0 },
/* U+1ce5 */ { 0, 0, 0, 0, 0 },
/* U+1ce6 */ { 0, 0, 0, 0, 0 },
/* U+1ce7 */ { 0, 0, 0, 0, 0 },
/* U+1ce8 */ { 0, 0, 0, 0, 0 },
/* U+1ce9 */ { 0, 0, 0, 0, 0 },
/* U+1cea */ { 0, 0, 0, 0, 0 },
/* U+1ceb */ { 0, 0, 0, 0, 0 },
/* U+1cec */ { 0, 0, 0, 0, 0 },
/* U+1ced */ { 0, 0, 0, 0, 0 },
/* U+1cee */ { 0, 0, 0, 0, 0 },
/* U+1cef */ { 0, 0, 0, 0, 0 },
/* U+1cf0 */ { 0, 0, 0, 0, 0 },
/* U+1cf1 */ { 0, 0, 0, 0, 0 },
/* U+1cf2 */ { 0, 0, 0, 0, 0 },
/* U+1cf3 */ { 0, 0, 0, 0, 0 },
/* U+1cf4 */ { 0, 0, 0, 0, 0 },
/* U+1cf5 */ { 0, 0, 0, 0, 0 },
/* U+1cf6 */ { 0, 0, 0, 0, 0 },
/* U+1cf7 */ { 0, 0, 0, 0, 0 },
/* U+1cf8 */ { 0, 0, 0, 0, 0 },
/* U+1cf9 */ { 0, 0, 0, 0, 0 },
/* U+1cfa */ { 0, 0, 0, 0, 0 },
/* U+1cfb */ { 0, 0, 0, 0, 0 },
/* U+1cfc */ { 0, 0, 0, 0, 0 },
/* U+1cfd */ { 0, 0, 0, 0, 0 },
/* U+1cfe */ { 0, 0, 0, 0, 0 },
/* U+1cff */ { 0, 0, 0, 0, 0 },
/* U+1d00 */ { 0, 0, 0, 0, 0 },
/* U+1d01 */ { 0, 0, 0, 0, 0 },
/* U+1d02 */ { 0, 0, 0, 0, 0 },
/* U+1d03 */ { 0, 0, 0, 0, 0 },
/* U+1d04 */ { 0, 0, 0, 0, 0 },
/* U+1d05 */ { 0, 0, 0, 0, 0 },
/* U+1d06 */ { 0, 0, 0, 0, 0 },
/* U+1d07 */ { 0, 0, 0, 0, 0 },
/* U+1d08 */ { 0, 0, 0, 0, 0 },
/* U+1d09 */ { 0, 0, 0, 0, 0 },
/* U+1d0a */ { 0, 0, 0, 0, 0 },
/* U+1d0b */ { 0, 0, 0, 0, 0 },
/* U+1d0c */ { 0, 0, 0, 0, 0 },
/* U+1d0d */ { 0, 0, 0, 0, 0 },
/* U+1d0e */ { 0, 0, 0, 0, 0 },
/* U+1d0f */ { 0, 0, 0, 0, 0 },
/* U+1d10 */ { 0, 0, 0, 0, 0 },
/* U+1d11 */ { 0, 0, 0, 0, 0 },
/* U+1d12 */ { 0, 0, 0, 0, 0 },
/* U+1d13 */ { 0, 0, 0, 0, 0 },
/* U+1d14 */ { 0, 0, 0, 0, 0 },
/* U+1d15 */ { 0, 0, 0, 0, 0 },
/* U+1d16 */ { 0, 0, 0, 0, 0 },
/* U+1d17 */ { 0, 0, 0, 0, 0 },
/* U+1d18 */ { 0, 0, 0, 0, 0 },
/* U+1d19 */ { 0, 0, 0, 0, 0 },
/* U+1d1a */ { 0, 0, 0, 0, 0 },
/* U+1d1b */ { 0, 0, 0, 0, 0 },
/* U+1d1c */ { 0, 0, 0, 0, 0 },
/* U+1d1d */ { 0, 0, 0, 0, 0 },
/* U+1d1e */ { 0, 0, 0, 0, 0 },
/* U+1d1f */ { 0, 0, 0, 0, 0 },
/* U+1d20 */ { 0, 0, 0, 0, 0 },
/* U+1d21 */ { 0, 0, 0, 0, 0 },
/* U+1d22 */ { 0, 0, 0, 0, 0 },
/* U+1d23 */ { 0, 0, 0, 0, 0 },
/* U+1d24 */ { 0, 0, 0, 0, 0 },
/* U+1d25 */ { 0, 0, 0, 0, 0 },
/* U+1d26 */ { 0, 0, 0, 0, 0 },
/* U+1d27 */ { 0, 0, 0, 0, 0 },
/* U+1d28 */ { 0, 0, 0, 0, 0 },
/* U+1d29 */ { 0, 0, 0, 0, 0 },
/* U+1d2a */ { 0, 0, 0, 0, 0 },
/* U+1d2b */ { 0, 0, 0, 0, 0 },
/* U+1d2c */ { 0, 0, 0, 0, 0 },
/* U+1d2d */ { 0, 0, 0, 0, 0 },
/* U+1d2e */ { 0, 0, 0, 0, 0 },
/* U+1d2f */ { 0, 0, 0, 0, 0 },
/* U+1d30 */ { 0, 0, 0, 0, 0 },
/* U+1d31 */ { 0, 0, 0, 0, 0 },
/* U+1d32 */ { 0, 0, 0, 0, 0 },
/* U+1d33 */ { 0, 0, 0, 0, 0 },
/* U+1d34 */ { 0, 0, 0, 0, 0 },
/* U+1d35 */ { 0, 0, 0, 0, 0 },
/* U+1d36 */ { 0, 0, 0, 0, 0 },
/* U+1d37 */ { 0, 0, 0, 0, 0 },
/* U+1d38 */ { 0, 0, 0, 0, 0 },
/* U+1d39 */ { 0, 0, 0, 0, 0 },
/* U+1d3a */ { 0, 0, 0, 0, 0 },
/* U+1d3b */ { 0, 0, 0, 0, 0 },
/* U+1d3c */ { 0, 0, 0, 0, 0 },
/* U+1d3d */ { 0, 0, 0, 0, 0 },
/* U+1d3e */ { 0, 0, 0, 0, 0 },
/* U+1d3f */ { 0, 0, 0, 0, 0 },
/* U+1d40 */ { 0, 0, 0, 0, 0 },
/* U+1d41 */ { 0, 0, 0, 0, 0 },
/* U+1d42 */ { 0, 0, 0, 0, 0 },
/* U+1d43 */ { 0, 0, 0, 0, 0 },
/* U+1d44 */ { 0, 0, 0, 0, 0 },
/* U+1d45 */ { 0, 0, 0, 0, 0 },
/* U+1d46 */ { 0, 0, 0, 0, 0 },
/* U+1d47 */ { 0, 0, 0, 0, 0 },
/* U+1d48 */ { 0, 0, 0, 0, 0 },
/* U+1d49 */ { 0, 0, 0, 0, 0 },
/* U+1d4a */ { 0, 0, 0, 0, 0 },
/* U+1d4b */ { 0, 0, 0, 0, 0 },
/* U+1d4c */ { 0, 0, 0, 0, 0 },
/* U+1d4d */ { 0, 0, 0, 0, 0 },
/* U+1d4e */ { 0, 0, 0, 0, 0 },
/* U+1d4f */ { 0, 0, 0, 0, 0 },
/* U+1d50 */ { 0, 0, 0, 0, 0 },
/* U+1d51 */ { 0, 0, 0, 0, 0 },
/* U+1d52 */ { 0, 0, 0, 0, 0 },
/* U+1d53 */ { 0, 0, 0, 0, 0 },
/* U+1d54 */ { 0, 0, 0, 0, 0 },
/* U+1d55 */ { 0, 0, 0, 0, 0 },
/* U+1d56 */ { 0, 0, 0, 0, 0 },
/* U+1d57 */ { 0, 0, 0, 0, 0 },
/* U+1d58 */ { 0, 0, 0, 0, 0 },
/* U+1d59 */ { 0, 0, 0, 0, 0 },
/* U+1d5a */ { 0, 0, 0, 0, 0 },
/* U+1d5b */ { 0, 0, 0, 0, 0 },
/* U+1d5c */ { 0, 0, 0, 0, 0 },
/* U+1d5d */ { 0, 0, 0, 0, 0 },
/* U+1d5e */ { 0, 0, 0, 0, 0 },
/* U+1d5f */ { 0, 0, 0, 0, 0 },
/* U+1d60 */ { 0, 0, 0, 0, 0 },
/* U+1d61 */ { 0, 0, 0, 0, 0 },
/* U+1d62 */ { 0, 0, 0, 0, 0 },
/* U+1d63 */ { 0, 0, 0, 0, 0 },
/* U+1d64 */ { 0, 0, 0, 0, 0 },
/* U+1d65 */ { 0, 0, 0, 0, 0 },
/* U+1d66 */ { 0, 0, 0, 0, 0 },
/* U+1d67 */ { 0, 0, 0, 0, 0 },
/* U+1d68 */ { 0, 0, 0, 0, 0 },
/* U+1d69 */ { 0, 0, 0, 0, 0 },
/* U+1d6a */ { 0, 0, 0, 0, 0 },
/* U+1d6b */ { 0, 0, 0, 0, 0 },
/* U+1d6c */ { 0, 0, 0, 0, 0 },
/* U+1d6d */ { 0, 0, 0, 0, 0 },
/* U+1d6e */ { 0, 0, 0, 0, 0 },
/* U+1d6f */ { 0, 0, 0, 0, 0 },
/* U+1d70 */ { 0, 0, 0, 0, 0 },
/* U+1d71 */ { 0, 0, 0, 0, 0 },
/* U+1d72 */ { 0, 0, 0, 0, 0 },
/* U+1d73 */ { 0, 0, 0, 0, 0 },
/* U+1d74 */ { 0, 0, 0, 0, 0 },
/* U+1d75 */ { 0, 0, 0, 0, 0 },
/* U+1d76 */ { 0, 0, 0, 0, 0 },
/* U+1d77 */ { 0, 0, 0, 0, 0 },
/* U+1d78 */ { 0, 0, 0, 0, 0 },
/* U+1d79 */ { 0, 0, 0, 0, 0 },
/* U+1d7a */ { 0, 0, 0, 0, 0 },
/* U+1d7b */ { 0, 0, 0, 0, 0 },
/* U+1d7c */ { 0, 0, 0, 0, 0 },
/* U+1d7d */ { 0, 0, 0, 0, 0 },
/* U+1d7e */ { 0, 0, 0, 0, 0 },
/* U+1d7f */ { 0, 0, 0, 0, 0 },
/* U+1d80 */ { 0, 0, 0, 0, 0 },
/* U+1d81 */ { 0, 0, 0, 0, 0 },
/* U+1d82 */ { 0, 0, 0, 0, 0 },
/* U+1d83 */ { 0, 0, 0, 0, 0 },
/* U+1d84 */ { 0, 0, 0, 0, 0 },
/* U+1d85 */ { 0, 0, 0, 0, 0 },
/* U+1d86 */ { 0, 0, 0, 0, 0 },
/* U+1d87 */ { 0, 0, 0, 0, 0 },
/* U+1d88 */ { 0, 0, 0, 0, 0 },
/* U+1d89 */ { 0, 0, 0, 0, 0 },
/* U+1d8a */ { 0, 0, 0, 0, 0 },
/* U+1d8b */ { 0, 0, 0, 0, 0 },
/* U+1d8c */ { 0, 0, 0, 0, 0 },
/* U+1d8d */ { 0, 0, 0, 0, 0 },
/* U+1d8e */ { 0, 0, 0, 0, 0 },
/* U+1d8f */ { 0, 0, 0, 0, 0 },
/* U+1d90 */ { 0, 0, 0, 0, 0 },
/* U+1d91 */ { 0, 0, 0, 0, 0 },
/* U+1d92 */ { 0, 0, 0, 0, 0 },
/* U+1d93 */ { 0, 0, 0, 0, 0 },
/* U+1d94 */ { 0, 0, 0, 0, 0 },
/* U+1d95 */ { 0, 0, 0, 0, 0 },
/* U+1d96 */ { 0, 0, 0, 0, 0 },
/* U+1d97 */ { 0, 0, 0, 0, 0 },
/* U+1d98 */ { 0, 0, 0, 0, 0 },
/* U+1d99 */ { 0, 0, 0, 0, 0 },
/* U+1d9a */ { 0, 0, 0, 0, 0 },
/* U+1d9b */ { 0, 0, 0, 0, 0 },
/* U+1d9c */ { 0, 0, 0, 0, 0 },
/* U+1d9d */ { 0, 0, 0, 0, 0 },
/* U+1d9e */ { 0, 0, 0, 0, 0 },
/* U+1d9f */ { 0, 0, 0, 0, 0 },
/* U+1da0 */ { 0, 0, 0, 0, 0 },
/* U+1da1 */ { 0, 0, 0, 0, 0 },
/* U+1da2 */ { 0, 0, 0, 0, 0 },
/* U+1da3 */ { 0, 0, 0, 0, 0 },
/* U+1da4 */ { 0, 0, 0, 0, 0 },
/* U+1da5 */ { 0, 0, 0, 0, 0 },
/* U+1da6 */ { 0, 0, 0, 0, 0 },
/* U+1da7 */ { 0, 0, 0, 0, 0 },
/* U+1da8 */ { 0, 0, 0, 0, 0 },
/* U+1da9 */ { 0, 0, 0, 0, 0 },
/* U+1daa */ { 0, 0, 0, 0, 0 },
/* U+1dab */ { 0, 0, 0, 0, 0 },
/* U+1dac */ { 0, 0, 0, 0, 0 },
/* U+1dad */ { 0, 0, 0, 0, 0 },
/* U+1dae */ { 0, 0, 0, 0, 0 },
/* U+1daf */ { 0, 0, 0, 0, 0 },
/* U+1db0 */ { 0, 0, 0, 0, 0 },
/* U+1db1 */ { 0, 0, 0, 0, 0 },
/* U+1db2 */ { 0, 0, 0, 0, 0 },
/* U+1db3 */ { 0, 0, 0, 0, 0 },
/* U+1db4 */ { 0, 0, 0, 0, 0 },
/* U+1db5 */ { 0, 0, 0, 0, 0 },
/* U+1db6 */ { 0, 0, 0, 0, 0 },
/* U+1db7 */ { 0, 0, 0, 0, 0 },
/* U+1db8 */ { 0, 0, 0, 0, 0 },
/* U+1db9 */ { 0, 0, 0, 0, 0 },
/* U+1dba */ { 0, 0, 0, 0, 0 },
/* U+1dbb */ { 0, 0, 0, 0, 0 },
/* U+1dbc */ { 0, 0, 0, 0, 0 },
/* U+1dbd */ { 0, 0, 0, 0, 0 },
/* U+1dbe */ { 0, 0, 0, 0, 0 },
/* U+1dbf */ { 0, 0, 0, 0, 0 },
/* U+1dc0 */ { 0, 0, 0, 0, 0 },
/* U+1dc1 */ { 0, 0, 0, 0, 0 },
/* U+1dc2 */ { 0, 0, 0, 0, 0 },
/* U+1dc3 */ { 0, 0, 0, 0, 0 },
/* U+1dc4 */ { 0, 0, 0, 0, 0 },
/* U+1dc5 */ { 0, 0, 0, 0, 0 },
/* U+1dc6 */ { 0, 0, 0, 0, 0 },
/* U+1dc7 */ { 0, 0, 0, 0, 0 },
/* U+1dc8 */ { 0, 0, 0, 0, 0 },
/* U+1dc9 */ { 0, 0, 0, 0, 0 },
/* U+1dca */ { 0, 0, 0, 0, 0 },
/* U+1dcb */ { 0, 0, 0, 0, 0 },
/* U+1dcc */ { 0, 0, 0, 0, 0 },
/* U+1dcd */ { 0, 0, 0, 0, 0 },
/* U+1dce */ { 0, 0, 0, 0, 0 },
/* U+1dcf */ { 0, 0, 0, 0, 0 },
/* U+1dd0 */ { 0, 0, 0, 0, 0 },
/* U+1dd1 */ { 0, 0, 0, 0, 0 },
/* U+1dd2 */ { 0, 0, 0, 0, 0 },
/* U+1dd3 */ { 0, 0, 0, 0, 0 },
/* U+1dd4 */ { 0, 0, 0, 0, 0 },
/* U+1dd5 */ { 0, 0, 0, 0, 0 },
/* U+1dd6 */ { 0, 0, 0, 0, 0 },
/* U+1dd7 */ { 0, 0, 0, 0, 0 },
/* U+1dd8 */ { 0, 0, 0, 0, 0 },
/* U+1dd9 */ { 0, 0, 0, 0, 0 },
/* U+1dda */ { 0, 0, 0, 0, 0 },
/* U+1ddb */ { 0, 0, 0, 0, 0 },
/* U+1ddc */ { 0, 0, 0, 0, 0 },
/* U+1ddd */ { 0, 0, 0, 0, 0 },
/* U+1dde */ { 0, 0, 0, 0, 0 },
/* U+1ddf */ { 0, 0, 0, 0, 0 },
/* U+1de0 */ { 0, 0, 0, 0, 0 },
/* U+1de1 */ { 0, 0, 0, 0, 0 },
/* U+1de2 */ { 0, 0, 0, 0, 0 },
/* U+1de3 */ { 0, 0, 0, 0, 0 },
/* U+1de4 */ { 0, 0, 0, 0, 0 },
/* U+1de5 */ { 0, 0, 0, 0, 0 },
/* U+1de6 */ { 0, 0, 0, 0, 0 },
/* U+1de7 */ { 0, 0, 0, 0, 0 },
/* U+1de8 */ { 0, 0, 0, 0, 0 },
/* U+1de9 */ { 0, 0, 0, 0, 0 },
/* U+1dea */ { 0, 0, 0, 0, 0 },
/* U+1deb */ { 0, 0, 0, 0, 0 },
/* U+1dec */ { 0, 0, 0, 0, 0 },
/* U+1ded */ { 0, 0, 0, 0, 0 },
/* U+1dee */ { 0, 0, 0, 0, 0 },
/* U+1def */ { 0, 0, 0, 0, 0 },
/* U+1df0 */ { 0, 0, 0, 0, 0 },
/* U+1df1 */ { 0, 0, 0, 0, 0 },
/* U+1df2 */ { 0, 0, 0, 0, 0 },
/* U+1df3 */ { 0, 0, 0, 0, 0 },
/* U+1df4 */ { 0, 0, 0, 0, 0 },
/* U+1df5 */ { 0, 0, 0, 0, 0 },
/* U+1df6 */ { 0, 0, 0, 0, 0 },
/* U+1df7 */ { 0, 0, 0, 0, 0 },
/* U+1df8 */ { 0, 0, 0, 0, 0 },
/* U+1df9 */ { 0, 0, 0, 0, 0 },
/* U+1dfa */ { 0, 0, 0, 0, 0 },
/* U+1dfb */ { 0, 0, 0, 0, 0 },
/* U+1dfc */ { 0, 0, 0, 0, 0 },
/* U+1dfd */ { 0, 0, 0, 0, 0 },
/* U+1dfe */ { 0, 0, 0, 0, 0 },
/* U+1dff */ { 0, 0, 0, 0, 0 },
/* U+1e00 */ { 1, 0, 1, 0, "0041 0325" },
/* U+1e01 */ { 2, 0, 1, 0, "0061 0325" },
/* U+1e02 */ { 1, 0, 1, 0, "0042 0307" },
/* U+1e03 */ { 2, 0, 1, 0, "0062 0307" },
/* U+1e04 */ { 1, 0, 1, 0, "0042 0323" },
/* U+1e05 */ { 2, 0, 1, 0, "0062 0323" },
/* U+1e06 */ { 1, 0, 1, 0, "0042 0331" },
/* U+1e07 */ { 2, 0, 1, 0, "0062 0331" },
/* U+1e08 */ { 1, 0, 1, 0, "00C7 0301" },
/* U+1e09 */ { 2, 0, 1, 0, "00E7 0301" },
/* U+1e0a */ { 1, 0, 1, 0, "0044 0307" },
/* U+1e0b */ { 2, 0, 1, 0, "0064 0307" },
/* U+1e0c */ { 1, 0, 1, 0, "0044 0323" },
/* U+1e0d */ { 2, 0, 1, 0, "0064 0323" },
/* U+1e0e */ { 1, 0, 1, 0, "0044 0331" },
/* U+1e0f */ { 2, 0, 1, 0, "0064 0331" },
/* U+1e10 */ { 1, 0, 1, 0, "0044 0327" },
/* U+1e11 */ { 2, 0, 1, 0, "0064 0327" },
/* U+1e12 */ { 1, 0, 1, 0, "0044 032D" },
/* U+1e13 */ { 2, 0, 1, 0, "0064 032D" },
/* U+1e14 */ { 1, 0, 1, 0, "0112 0300" },
/* U+1e15 */ { 2, 0, 1, 0, "0113 0300" },
/* U+1e16 */ { 1, 0, 1, 0, "0112 0301" },
/* U+1e17 */ { 2, 0, 1, 0, "0113 0301" },
/* U+1e18 */ { 1, 0, 1, 0, "0045 032D" },
/* U+1e19 */ { 2, 0, 1, 0, "0065 032D" },
/* U+1e1a */ { 1, 0, 1, 0, "0045 0330" },
/* U+1e1b */ { 2, 0, 1, 0, "0065 0330" },
/* U+1e1c */ { 1, 0, 1, 0, "0228 0306" },
/* U+1e1d */ { 2, 0, 1, 0, "0229 0306" },
/* U+1e1e */ { 1, 0, 1, 0, "0046 0307" },
/* U+1e1f */ { 2, 0, 1, 0, "0066 0307" },
/* U+1e20 */ { 1, 0, 1, 0, "0047 0304" },
/* U+1e21 */ { 2, 0, 1, 0, "0067 0304" },
/* U+1e22 */ { 1, 0, 1, 0, "0048 0307" },
/* U+1e23 */ { 2, 0, 1, 0, "0068 0307" },
/* U+1e24 */ { 1, 0, 1, 0, "0048 0323" },
/* U+1e25 */ { 2, 0, 1, 0, "0068 0323" },
/* U+1e26 */ { 1, 0, 1, 0, "0048 0308" },
/* U+1e27 */ { 2, 0, 1, 0, "0068 0308" },
/* U+1e28 */ { 1, 0, 1, 0, "0048 0327" },
/* U+1e29 */ { 2, 0, 1, 0, "0068 0327" },
/* U+1e2a */ { 1, 0, 1, 0, "0048 032E" },
/* U+1e2b */ { 2, 0, 1, 0, "0068 032E" },
/* U+1e2c */ { 1, 0, 1, 0, "0049 0330" },
/* U+1e2d */ { 2, 0, 1, 0, "0069 0330" },
/* U+1e2e */ { 1, 0, 1, 0, "00CF 0301" },
/* U+1e2f */ { 2, 0, 1, 0, "00EF 0301" },
/* U+1e30 */ { 1, 0, 1, 0, "004B 0301" },
/* U+1e31 */ { 2, 0, 1, 0, "006B 0301" },
/* U+1e32 */ { 1, 0, 1, 0, "004B 0323" },
/* U+1e33 */ { 2, 0, 1, 0, "006B 0323" },
/* U+1e34 */ { 1, 0, 1, 0, "004B 0331" },
/* U+1e35 */ { 2, 0, 1, 0, "006B 0331" },
/* U+1e36 */ { 1, 0, 1, 0, "004C 0323" },
/* U+1e37 */ { 2, 0, 1, 0, "006C 0323" },
/* U+1e38 */ { 1, 0, 1, 0, "1E36 0304" },
/* U+1e39 */ { 2, 0, 1, 0, "1E37 0304" },
/* U+1e3a */ { 1, 0, 1, 0, "004C 0331" },
/* U+1e3b */ { 2, 0, 1, 0, "006C 0331" },
/* U+1e3c */ { 1, 0, 1, 0, "004C 032D" },
/* U+1e3d */ { 2, 0, 1, 0, "006C 032D" },
/* U+1e3e */ { 1, 0, 1, 0, "004D 0301" },
/* U+1e3f */ { 2, 0, 1, 0, "006D 0301" },
/* U+1e40 */ { 1, 0, 1, 0, "004D 0307" },
/* U+1e41 */ { 2, 0, 1, 0, "006D 0307" },
/* U+1e42 */ { 1, 0, 1, 0, "004D 0323" },
/* U+1e43 */ { 2, 0, 1, 0, "006D 0323" },
/* U+1e44 */ { 1, 0, 1, 0, "004E 0307" },
/* U+1e45 */ { 2, 0, 1, 0, "006E 0307" },
/* U+1e46 */ { 1, 0, 1, 0, "004E 0323" },
/* U+1e47 */ { 2, 0, 1, 0, "006E 0323" },
/* U+1e48 */ { 1, 0, 1, 0, "004E 0331" },
/* U+1e49 */ { 2, 0, 1, 0, "006E 0331" },
/* U+1e4a */ { 1, 0, 1, 0, "004E 032D" },
/* U+1e4b */ { 2, 0, 1, 0, "006E 032D" },
/* U+1e4c */ { 1, 0, 1, 0, "00D5 0301" },
/* U+1e4d */ { 2, 0, 1, 0, "00F5 0301" },
/* U+1e4e */ { 1, 0, 1, 0, "00D5 0308" },
/* U+1e4f */ { 2, 0, 1, 0, "00F5 0308" },
/* U+1e50 */ { 1, 0, 1, 0, "014C 0300" },
/* U+1e51 */ { 2, 0, 1, 0, "014D 0300" },
/* U+1e52 */ { 1, 0, 1, 0, "014C 0301" },
/* U+1e53 */ { 2, 0, 1, 0, "014D 0301" },
/* U+1e54 */ { 1, 0, 1, 0, "0050 0301" },
/* U+1e55 */ { 2, 0, 1, 0, "0070 0301" },
/* U+1e56 */ { 1, 0, 1, 0, "0050 0307" },
/* U+1e57 */ { 2, 0, 1, 0, "0070 0307" },
/* U+1e58 */ { 1, 0, 1, 0, "0052 0307" },
/* U+1e59 */ { 2, 0, 1, 0, "0072 0307" },
/* U+1e5a */ { 1, 0, 1, 0, "0052 0323" },
/* U+1e5b */ { 2, 0, 1, 0, "0072 0323" },
/* U+1e5c */ { 1, 0, 1, 0, "1E5A 0304" },
/* U+1e5d */ { 2, 0, 1, 0, "1E5B 0304" },
/* U+1e5e */ { 1, 0, 1, 0, "0052 0331" },
/* U+1e5f */ { 2, 0, 1, 0, "0072 0331" },
/* U+1e60 */ { 1, 0, 1, 0, "0053 0307" },
/* U+1e61 */ { 2, 0, 1, 0, "0073 0307" },
/* U+1e62 */ { 1, 0, 1, 0, "0053 0323" },
/* U+1e63 */ { 2, 0, 1, 0, "0073 0323" },
/* U+1e64 */ { 1, 0, 1, 0, "015A 0307" },
/* U+1e65 */ { 2, 0, 1, 0, "015B 0307" },
/* U+1e66 */ { 1, 0, 1, 0, "0160 0307" },
/* U+1e67 */ { 2, 0, 1, 0, "0161 0307" },
/* U+1e68 */ { 1, 0, 1, 0, "1E62 0307" },
/* U+1e69 */ { 2, 0, 1, 0, "1E63 0307" },
/* U+1e6a */ { 1, 0, 1, 0, "0054 0307" },
/* U+1e6b */ { 2, 0, 1, 0, "0074 0307" },
/* U+1e6c */ { 1, 0, 1, 0, "0054 0323" },
/* U+1e6d */ { 2, 0, 1, 0, "0074 0323" },
/* U+1e6e */ { 1, 0, 1, 0, "0054 0331" },
/* U+1e6f */ { 2, 0, 1, 0, "0074 0331" },
/* U+1e70 */ { 1, 0, 1, 0, "0054 032D" },
/* U+1e71 */ { 2, 0, 1, 0, "0074 032D" },
/* U+1e72 */ { 1, 0, 1, 0, "0055 0324" },
/* U+1e73 */ { 2, 0, 1, 0, "0075 0324" },
/* U+1e74 */ { 1, 0, 1, 0, "0055 0330" },
/* U+1e75 */ { 2, 0, 1, 0, "0075 0330" },
/* U+1e76 */ { 1, 0, 1, 0, "0055 032D" },
/* U+1e77 */ { 2, 0, 1, 0, "0075 032D" },
/* U+1e78 */ { 1, 0, 1, 0, "0168 0301" },
/* U+1e79 */ { 2, 0, 1, 0, "0169 0301" },
/* U+1e7a */ { 1, 0, 1, 0, "016A 0308" },
/* U+1e7b */ { 2, 0, 1, 0, "016B 0308" },
/* U+1e7c */ { 1, 0, 1, 0, "0056 0303" },
/* U+1e7d */ { 2, 0, 1, 0, "0076 0303" },
/* U+1e7e */ { 1, 0, 1, 0, "0056 0323" },
/* U+1e7f */ { 2, 0, 1, 0, "0076 0323" },
/* U+1e80 */ { 1, 0, 1, 0, "0057 0300" },
/* U+1e81 */ { 2, 0, 1, 0, "0077 0300" },
/* U+1e82 */ { 1, 0, 1, 0, "0057 0301" },
/* U+1e83 */ { 2, 0, 1, 0, "0077 0301" },
/* U+1e84 */ { 1, 0, 1, 0, "0057 0308" },
/* U+1e85 */ { 2, 0, 1, 0, "0077 0308" },
/* U+1e86 */ { 1, 0, 1, 0, "0057 0307" },
/* U+1e87 */ { 2, 0, 1, 0, "0077 0307" },
/* U+1e88 */ { 1, 0, 1, 0, "0057 0323" },
/* U+1e89 */ { 2, 0, 1, 0, "0077 0323" },
/* U+1e8a */ { 1, 0, 1, 0, "0058 0307" },
/* U+1e8b */ { 2, 0, 1, 0, "0078 0307" },
/* U+1e8c */ { 1, 0, 1, 0, "0058 0308" },
/* U+1e8d */ { 2, 0, 1, 0, "0078 0308" },
/* U+1e8e */ { 1, 0, 1, 0, "0059 0307" },
/* U+1e8f */ { 2, 0, 1, 0, "0079 0307" },
/* U+1e90 */ { 1, 0, 1, 0, "005A 0302" },
/* U+1e91 */ { 2, 0, 1, 0, "007A 0302" },
/* U+1e92 */ { 1, 0, 1, 0, "005A 0323" },
/* U+1e93 */ { 2, 0, 1, 0, "007A 0323" },
/* U+1e94 */ { 1, 0, 1, 0, "005A 0331" },
/* U+1e95 */ { 2, 0, 1, 0, "007A 0331" },
/* U+1e96 */ { 2, 0, 1, 0, "0068 0331" },
/* U+1e97 */ { 2, 0, 1, 0, "0074 0308" },
/* U+1e98 */ { 2, 0, 1, 0, "0077 030A" },
/* U+1e99 */ { 2, 0, 1, 0, "0079 030A" },
/* U+1e9a */ { 2, 0, 1, 0, "<compat> 0061 02BE" },
/* U+1e9b */ { 2, 0, 1, 0, "017F 0307" },
/* U+1e9c */ { 0, 0, 0, 0, 0 },
/* U+1e9d */ { 0, 0, 0, 0, 0 },
/* U+1e9e */ { 0, 0, 0, 0, 0 },
/* U+1e9f */ { 0, 0, 0, 0, 0 },
/* U+1ea0 */ { 1, 0, 1, 0, "0041 0323" },
/* U+1ea1 */ { 2, 0, 1, 0, "0061 0323" },
/* U+1ea2 */ { 1, 0, 1, 0, "0041 0309" },
/* U+1ea3 */ { 2, 0, 1, 0, "0061 0309" },
/* U+1ea4 */ { 1, 0, 1, 0, "00C2 0301" },
/* U+1ea5 */ { 2, 0, 1, 0, "00E2 0301" },
/* U+1ea6 */ { 1, 0, 1, 0, "00C2 0300" },
/* U+1ea7 */ { 2, 0, 1, 0, "00E2 0300" },
/* U+1ea8 */ { 1, 0, 1, 0, "00C2 0309" },
/* U+1ea9 */ { 2, 0, 1, 0, "00E2 0309" },
/* U+1eaa */ { 1, 0, 1, 0, "00C2 0303" },
/* U+1eab */ { 2, 0, 1, 0, "00E2 0303" },
/* U+1eac */ { 1, 0, 1, 0, "1EA0 0302" },
/* U+1ead */ { 2, 0, 1, 0, "1EA1 0302" },
/* U+1eae */ { 1, 0, 1, 0, "0102 0301" },
/* U+1eaf */ { 2, 0, 1, 0, "0103 0301" },
/* U+1eb0 */ { 1, 0, 1, 0, "0102 0300" },
/* U+1eb1 */ { 2, 0, 1, 0, "0103 0300" },
/* U+1eb2 */ { 1, 0, 1, 0, "0102 0309" },
/* U+1eb3 */ { 2, 0, 1, 0, "0103 0309" },
/* U+1eb4 */ { 1, 0, 1, 0, "0102 0303" },
/* U+1eb5 */ { 2, 0, 1, 0, "0103 0303" },
/* U+1eb6 */ { 1, 0, 1, 0, "1EA0 0306" },
/* U+1eb7 */ { 2, 0, 1, 0, "1EA1 0306" },
/* U+1eb8 */ { 1, 0, 1, 0, "0045 0323" },
/* U+1eb9 */ { 2, 0, 1, 0, "0065 0323" },
/* U+1eba */ { 1, 0, 1, 0, "0045 0309" },
/* U+1ebb */ { 2, 0, 1, 0, "0065 0309" },
/* U+1ebc */ { 1, 0, 1, 0, "0045 0303" },
/* U+1ebd */ { 2, 0, 1, 0, "0065 0303" },
/* U+1ebe */ { 1, 0, 1, 0, "00CA 0301" },
/* U+1ebf */ { 2, 0, 1, 0, "00EA 0301" },
/* U+1ec0 */ { 1, 0, 1, 0, "00CA 0300" },
/* U+1ec1 */ { 2, 0, 1, 0, "00EA 0300" },
/* U+1ec2 */ { 1, 0, 1, 0, "00CA 0309" },
/* U+1ec3 */ { 2, 0, 1, 0, "00EA 0309" },
/* U+1ec4 */ { 1, 0, 1, 0, "00CA 0303" },
/* U+1ec5 */ { 2, 0, 1, 0, "00EA 0303" },
/* U+1ec6 */ { 1, 0, 1, 0, "1EB8 0302" },
/* U+1ec7 */ { 2, 0, 1, 0, "1EB9 0302" },
/* U+1ec8 */ { 1, 0, 1, 0, "0049 0309" },
/* U+1ec9 */ { 2, 0, 1, 0, "0069 0309" },
/* U+1eca */ { 1, 0, 1, 0, "0049 0323" },
/* U+1ecb */ { 2, 0, 1, 0, "0069 0323" },
/* U+1ecc */ { 1, 0, 1, 0, "004F 0323" },
/* U+1ecd */ { 2, 0, 1, 0, "006F 0323" },
/* U+1ece */ { 1, 0, 1, 0, "004F 0309" },
/* U+1ecf */ { 2, 0, 1, 0, "006F 0309" },
/* U+1ed0 */ { 1, 0, 1, 0, "00D4 0301" },
/* U+1ed1 */ { 2, 0, 1, 0, "00F4 0301" },
/* U+1ed2 */ { 1, 0, 1, 0, "00D4 0300" },
/* U+1ed3 */ { 2, 0, 1, 0, "00F4 0300" },
/* U+1ed4 */ { 1, 0, 1, 0, "00D4 0309" },
/* U+1ed5 */ { 2, 0, 1, 0, "00F4 0309" },
/* U+1ed6 */ { 1, 0, 1, 0, "00D4 0303" },
/* U+1ed7 */ { 2, 0, 1, 0, "00F4 0303" },
/* U+1ed8 */ { 1, 0, 1, 0, "1ECC 0302" },
/* U+1ed9 */ { 2, 0, 1, 0, "1ECD 0302" },
/* U+1eda */ { 1, 0, 1, 0, "01A0 0301" },
/* U+1edb */ { 2, 0, 1, 0, "01A1 0301" },
/* U+1edc */ { 1, 0, 1, 0, "01A0 0300" },
/* U+1edd */ { 2, 0, 1, 0, "01A1 0300" },
/* U+1ede */ { 1, 0, 1, 0, "01A0 0309" },
/* U+1edf */ { 2, 0, 1, 0, "01A1 0309" },
/* U+1ee0 */ { 1, 0, 1, 0, "01A0 0303" },
/* U+1ee1 */ { 2, 0, 1, 0, "01A1 0303" },
/* U+1ee2 */ { 1, 0, 1, 0, "01A0 0323" },
/* U+1ee3 */ { 2, 0, 1, 0, "01A1 0323" },
/* U+1ee4 */ { 1, 0, 1, 0, "0055 0323" },
/* U+1ee5 */ { 2, 0, 1, 0, "0075 0323" },
/* U+1ee6 */ { 1, 0, 1, 0, "0055 0309" },
/* U+1ee7 */ { 2, 0, 1, 0, "0075 0309" },
/* U+1ee8 */ { 1, 0, 1, 0, "01AF 0301" },
/* U+1ee9 */ { 2, 0, 1, 0, "01B0 0301" },
/* U+1eea */ { 1, 0, 1, 0, "01AF 0300" },
/* U+1eeb */ { 2, 0, 1, 0, "01B0 0300" },
/* U+1eec */ { 1, 0, 1, 0, "01AF 0309" },
/* U+1eed */ { 2, 0, 1, 0, "01B0 0309" },
/* U+1eee */ { 1, 0, 1, 0, "01AF 0303" },
/* U+1eef */ { 2, 0, 1, 0, "01B0 0303" },
/* U+1ef0 */ { 1, 0, 1, 0, "01AF 0323" },
/* U+1ef1 */ { 2, 0, 1, 0, "01B0 0323" },
/* U+1ef2 */ { 1, 0, 1, 0, "0059 0300" },
/* U+1ef3 */ { 2, 0, 1, 0, "0079 0300" },
/* U+1ef4 */ { 1, 0, 1, 0, "0059 0323" },
/* U+1ef5 */ { 2, 0, 1, 0, "0079 0323" },
/* U+1ef6 */ { 1, 0, 1, 0, "0059 0309" },
/* U+1ef7 */ { 2, 0, 1, 0, "0079 0309" },
/* U+1ef8 */ { 1, 0, 1, 0, "0059 0303" },
/* U+1ef9 */ { 2, 0, 1, 0, "0079 0303" },
/* U+1efa */ { 0, 0, 0, 0, 0 },
/* U+1efb */ { 0, 0, 0, 0, 0 },
/* U+1efc */ { 0, 0, 0, 0, 0 },
/* U+1efd */ { 0, 0, 0, 0, 0 },
/* U+1efe */ { 0, 0, 0, 0, 0 },
/* U+1eff */ { 0, 0, 0, 0, 0 },
/* U+1f00 */ { 2, 0, 1, 0, "03B1 0313" },
/* U+1f01 */ { 2, 0, 1, 0, "03B1 0314" },
/* U+1f02 */ { 2, 0, 1, 0, "1F00 0300" },
/* U+1f03 */ { 2, 0, 1, 0, "1F01 0300" },
/* U+1f04 */ { 2, 0, 1, 0, "1F00 0301" },
/* U+1f05 */ { 2, 0, 1, 0, "1F01 0301" },
/* U+1f06 */ { 2, 0, 1, 0, "1F00 0342" },
/* U+1f07 */ { 2, 0, 1, 0, "1F01 0342" },
/* U+1f08 */ { 1, 0, 1, 0, "0391 0313" },
/* U+1f09 */ { 1, 0, 1, 0, "0391 0314" },
/* U+1f0a */ { 1, 0, 1, 0, "1F08 0300" },
/* U+1f0b */ { 1, 0, 1, 0, "1F09 0300" },
/* U+1f0c */ { 1, 0, 1, 0, "1F08 0301" },
/* U+1f0d */ { 1, 0, 1, 0, "1F09 0301" },
/* U+1f0e */ { 1, 0, 1, 0, "1F08 0342" },
/* U+1f0f */ { 1, 0, 1, 0, "1F09 0342" },
/* U+1f10 */ { 2, 0, 1, 0, "03B5 0313" },
/* U+1f11 */ { 2, 0, 1, 0, "03B5 0314" },
/* U+1f12 */ { 2, 0, 1, 0, "1F10 0300" },
/* U+1f13 */ { 2, 0, 1, 0, "1F11 0300" },
/* U+1f14 */ { 2, 0, 1, 0, "1F10 0301" },
/* U+1f15 */ { 2, 0, 1, 0, "1F11 0301" },
/* U+1f16 */ { 0, 0, 0, 0, 0 },
/* U+1f17 */ { 0, 0, 0, 0, 0 },
/* U+1f18 */ { 1, 0, 1, 0, "0395 0313" },
/* U+1f19 */ { 1, 0, 1, 0, "0395 0314" },
/* U+1f1a */ { 1, 0, 1, 0, "1F18 0300" },
/* U+1f1b */ { 1, 0, 1, 0, "1F19 0300" },
/* U+1f1c */ { 1, 0, 1, 0, "1F18 0301" },
/* U+1f1d */ { 1, 0, 1, 0, "1F19 0301" },
/* U+1f1e */ { 0, 0, 0, 0, 0 },
/* U+1f1f */ { 0, 0, 0, 0, 0 },
/* U+1f20 */ { 2, 0, 1, 0, "03B7 0313" },
/* U+1f21 */ { 2, 0, 1, 0, "03B7 0314" },
/* U+1f22 */ { 2, 0, 1, 0, "1F20 0300" },
/* U+1f23 */ { 2, 0, 1, 0, "1F21 0300" },
/* U+1f24 */ { 2, 0, 1, 0, "1F20 0301" },
/* U+1f25 */ { 2, 0, 1, 0, "1F21 0301" },
/* U+1f26 */ { 2, 0, 1, 0, "1F20 0342" },
/* U+1f27 */ { 2, 0, 1, 0, "1F21 0342" },
/* U+1f28 */ { 1, 0, 1, 0, "0397 0313" },
/* U+1f29 */ { 1, 0, 1, 0, "0397 0314" },
/* U+1f2a */ { 1, 0, 1, 0, "1F28 0300" },
/* U+1f2b */ { 1, 0, 1, 0, "1F29 0300" },
/* U+1f2c */ { 1, 0, 1, 0, "1F28 0301" },
/* U+1f2d */ { 1, 0, 1, 0, "1F29 0301" },
/* U+1f2e */ { 1, 0, 1, 0, "1F28 0342" },
/* U+1f2f */ { 1, 0, 1, 0, "1F29 0342" },
/* U+1f30 */ { 2, 0, 1, 0, "03B9 0313" },
/* U+1f31 */ { 2, 0, 1, 0, "03B9 0314" },
/* U+1f32 */ { 2, 0, 1, 0, "1F30 0300" },
/* U+1f33 */ { 2, 0, 1, 0, "1F31 0300" },
/* U+1f34 */ { 2, 0, 1, 0, "1F30 0301" },
/* U+1f35 */ { 2, 0, 1, 0, "1F31 0301" },
/* U+1f36 */ { 2, 0, 1, 0, "1F30 0342" },
/* U+1f37 */ { 2, 0, 1, 0, "1F31 0342" },
/* U+1f38 */ { 1, 0, 1, 0, "0399 0313" },
/* U+1f39 */ { 1, 0, 1, 0, "0399 0314" },
/* U+1f3a */ { 1, 0, 1, 0, "1F38 0300" },
/* U+1f3b */ { 1, 0, 1, 0, "1F39 0300" },
/* U+1f3c */ { 1, 0, 1, 0, "1F38 0301" },
/* U+1f3d */ { 1, 0, 1, 0, "1F39 0301" },
/* U+1f3e */ { 1, 0, 1, 0, "1F38 0342" },
/* U+1f3f */ { 1, 0, 1, 0, "1F39 0342" },
/* U+1f40 */ { 2, 0, 1, 0, "03BF 0313" },
/* U+1f41 */ { 2, 0, 1, 0, "03BF 0314" },
/* U+1f42 */ { 2, 0, 1, 0, "1F40 0300" },
/* U+1f43 */ { 2, 0, 1, 0, "1F41 0300" },
/* U+1f44 */ { 2, 0, 1, 0, "1F40 0301" },
/* U+1f45 */ { 2, 0, 1, 0, "1F41 0301" },
/* U+1f46 */ { 0, 0, 0, 0, 0 },
/* U+1f47 */ { 0, 0, 0, 0, 0 },
/* U+1f48 */ { 1, 0, 1, 0, "039F 0313" },
/* U+1f49 */ { 1, 0, 1, 0, "039F 0314" },
/* U+1f4a */ { 1, 0, 1, 0, "1F48 0300" },
/* U+1f4b */ { 1, 0, 1, 0, "1F49 0300" },
/* U+1f4c */ { 1, 0, 1, 0, "1F48 0301" },
/* U+1f4d */ { 1, 0, 1, 0, "1F49 0301" },
/* U+1f4e */ { 0, 0, 0, 0, 0 },
/* U+1f4f */ { 0, 0, 0, 0, 0 },
/* U+1f50 */ { 2, 0, 1, 0, "03C5 0313" },
/* U+1f51 */ { 2, 0, 1, 0, "03C5 0314" },
/* U+1f52 */ { 2, 0, 1, 0, "1F50 0300" },
/* U+1f53 */ { 2, 0, 1, 0, "1F51 0300" },
/* U+1f54 */ { 2, 0, 1, 0, "1F50 0301" },
/* U+1f55 */ { 2, 0, 1, 0, "1F51 0301" },
/* U+1f56 */ { 2, 0, 1, 0, "1F50 0342" },
/* U+1f57 */ { 2, 0, 1, 0, "1F51 0342" },
/* U+1f58 */ { 0, 0, 0, 0, 0 },
/* U+1f59 */ { 1, 0, 1, 0, "03A5 0314" },
/* U+1f5a */ { 0, 0, 0, 0, 0 },
/* U+1f5b */ { 1, 0, 1, 0, "1F59 0300" },
/* U+1f5c */ { 0, 0, 0, 0, 0 },
/* U+1f5d */ { 1, 0, 1, 0, "1F59 0301" },
/* U+1f5e */ { 0, 0, 0, 0, 0 },
/* U+1f5f */ { 1, 0, 1, 0, "1F59 0342" },
/* U+1f60 */ { 2, 0, 1, 0, "03C9 0313" },
/* U+1f61 */ { 2, 0, 1, 0, "03C9 0314" },
/* U+1f62 */ { 2, 0, 1, 0, "1F60 0300" },
/* U+1f63 */ { 2, 0, 1, 0, "1F61 0300" },
/* U+1f64 */ { 2, 0, 1, 0, "1F60 0301" },
/* U+1f65 */ { 2, 0, 1, 0, "1F61 0301" },
/* U+1f66 */ { 2, 0, 1, 0, "1F60 0342" },
/* U+1f67 */ { 2, 0, 1, 0, "1F61 0342" },
/* U+1f68 */ { 1, 0, 1, 0, "03A9 0313" },
/* U+1f69 */ { 1, 0, 1, 0, "03A9 0314" },
/* U+1f6a */ { 1, 0, 1, 0, "1F68 0300" },
/* U+1f6b */ { 1, 0, 1, 0, "1F69 0300" },
/* U+1f6c */ { 1, 0, 1, 0, "1F68 0301" },
/* U+1f6d */ { 1, 0, 1, 0, "1F69 0301" },
/* U+1f6e */ { 1, 0, 1, 0, "1F68 0342" },
/* U+1f6f */ { 1, 0, 1, 0, "1F69 0342" },
/* U+1f70 */ { 2, 0, 1, 0, "03B1 0300" },
/* U+1f71 */ { 2, 0, 1, 0, "03AC" },
/* U+1f72 */ { 2, 0, 1, 0, "03B5 0300" },
/* U+1f73 */ { 2, 0, 1, 0, "03AD" },
/* U+1f74 */ { 2, 0, 1, 0, "03B7 0300" },
/* U+1f75 */ { 2, 0, 1, 0, "03AE" },
/* U+1f76 */ { 2, 0, 1, 0, "03B9 0300" },
/* U+1f77 */ { 2, 0, 1, 0, "03AF" },
/* U+1f78 */ { 2, 0, 1, 0, "03BF 0300" },
/* U+1f79 */ { 2, 0, 1, 0, "03CC" },
/* U+1f7a */ { 2, 0, 1, 0, "03C5 0300" },
/* U+1f7b */ { 2, 0, 1, 0, "03CD" },
/* U+1f7c */ { 2, 0, 1, 0, "03C9 0300" },
/* U+1f7d */ { 2, 0, 1, 0, "03CE" },
/* U+1f7e */ { 0, 0, 0, 0, 0 },
/* U+1f7f */ { 0, 0, 0, 0, 0 },
/* U+1f80 */ { 2, 0, 1, 0, "1F00 0345" },
/* U+1f81 */ { 2, 0, 1, 0, "1F01 0345" },
/* U+1f82 */ { 2, 0, 1, 0, "1F02 0345" },
/* U+1f83 */ { 2, 0, 1, 0, "1F03 0345" },
/* U+1f84 */ { 2, 0, 1, 0, "1F04 0345" },
/* U+1f85 */ { 2, 0, 1, 0, "1F05 0345" },
/* U+1f86 */ { 2, 0, 1, 0, "1F06 0345" },
/* U+1f87 */ { 2, 0, 1, 0, "1F07 0345" },
/* U+1f88 */ { 3, 0, 1, 0, "1F08 0345" },
/* U+1f89 */ { 3, 0, 1, 0, "1F09 0345" },
/* U+1f8a */ { 3, 0, 1, 0, "1F0A 0345" },
/* U+1f8b */ { 3, 0, 1, 0, "1F0B 0345" },
/* U+1f8c */ { 3, 0, 1, 0, "1F0C 0345" },
/* U+1f8d */ { 3, 0, 1, 0, "1F0D 0345" },
/* U+1f8e */ { 3, 0, 1, 0, "1F0E 0345" },
/* U+1f8f */ { 3, 0, 1, 0, "1F0F 0345" },
/* U+1f90 */ { 2, 0, 1, 0, "1F20 0345" },
/* U+1f91 */ { 2, 0, 1, 0, "1F21 0345" },
/* U+1f92 */ { 2, 0, 1, 0, "1F22 0345" },
/* U+1f93 */ { 2, 0, 1, 0, "1F23 0345" },
/* U+1f94 */ { 2, 0, 1, 0, "1F24 0345" },
/* U+1f95 */ { 2, 0, 1, 0, "1F25 0345" },
/* U+1f96 */ { 2, 0, 1, 0, "1F26 0345" },
/* U+1f97 */ { 2, 0, 1, 0, "1F27 0345" },
/* U+1f98 */ { 3, 0, 1, 0, "1F28 0345" },
/* U+1f99 */ { 3, 0, 1, 0, "1F29 0345" },
/* U+1f9a */ { 3, 0, 1, 0, "1F2A 0345" },
/* U+1f9b */ { 3, 0, 1, 0, "1F2B 0345" },
/* U+1f9c */ { 3, 0, 1, 0, "1F2C 0345" },
/* U+1f9d */ { 3, 0, 1, 0, "1F2D 0345" },
/* U+1f9e */ { 3, 0, 1, 0, "1F2E 0345" },
/* U+1f9f */ { 3, 0, 1, 0, "1F2F 0345" },
/* U+1fa0 */ { 2, 0, 1, 0, "1F60 0345" },
/* U+1fa1 */ { 2, 0, 1, 0, "1F61 0345" },
/* U+1fa2 */ { 2, 0, 1, 0, "1F62 0345" },
/* U+1fa3 */ { 2, 0, 1, 0, "1F63 0345" },
/* U+1fa4 */ { 2, 0, 1, 0, "1F64 0345" },
/* U+1fa5 */ { 2, 0, 1, 0, "1F65 0345" },
/* U+1fa6 */ { 2, 0, 1, 0, "1F66 0345" },
/* U+1fa7 */ { 2, 0, 1, 0, "1F67 0345" },
/* U+1fa8 */ { 3, 0, 1, 0, "1F68 0345" },
/* U+1fa9 */ { 3, 0, 1, 0, "1F69 0345" },
/* U+1faa */ { 3, 0, 1, 0, "1F6A 0345" },
/* U+1fab */ { 3, 0, 1, 0, "1F6B 0345" },
/* U+1fac */ { 3, 0, 1, 0, "1F6C 0345" },
/* U+1fad */ { 3, 0, 1, 0, "1F6D 0345" },
/* U+1fae */ { 3, 0, 1, 0, "1F6E 0345" },
/* U+1faf */ { 3, 0, 1, 0, "1F6F 0345" },
/* U+1fb0 */ { 2, 0, 1, 0, "03B1 0306" },
/* U+1fb1 */ { 2, 0, 1, 0, "03B1 0304" },
/* U+1fb2 */ { 2, 0, 1, 0, "1F70 0345" },
/* U+1fb3 */ { 2, 0, 1, 0, "03B1 0345" },
/* U+1fb4 */ { 2, 0, 1, 0, "03AC 0345" },
/* U+1fb5 */ { 0, 0, 0, 0, 0 },
/* U+1fb6 */ { 2, 0, 1, 0, "03B1 0342" },
/* U+1fb7 */ { 2, 0, 1, 0, "1FB6 0345" },
/* U+1fb8 */ { 1, 0, 1, 0, "0391 0306" },
/* U+1fb9 */ { 1, 0, 1, 0, "0391 0304" },
/* U+1fba */ { 1, 0, 1, 0, "0391 0300" },
/* U+1fbb */ { 1, 0, 1, 0, "0386" },
/* U+1fbc */ { 3, 0, 1, 0, "0391 0345" },
/* U+1fbd */ { 29, 0, 19, 0, "<compat> 0020 0313" },
/* U+1fbe */ { 2, 0, 1, 0, "03B9" },
/* U+1fbf */ { 29, 0, 19, 0, "<compat> 0020 0313" },
/* U+1fc0 */ { 29, 0, 19, 0, "<compat> 0020 0342" },
/* U+1fc1 */ { 29, 0, 19, 0, "00A8 0342" },
/* U+1fc2 */ { 2, 0, 1, 0, "1F74 0345" },
/* U+1fc3 */ { 2, 0, 1, 0, "03B7 0345" },
/* U+1fc4 */ { 2, 0, 1, 0, "03AE 0345" },
/* U+1fc5 */ { 0, 0, 0, 0, 0 },
/* U+1fc6 */ { 2, 0, 1, 0, "03B7 0342" },
/* U+1fc7 */ { 2, 0, 1, 0, "1FC6 0345" },
/* U+1fc8 */ { 1, 0, 1, 0, "0395 0300" },
/* U+1fc9 */ { 1, 0, 1, 0, "0388" },
/* U+1fca */ { 1, 0, 1, 0, "0397 0300" },
/* U+1fcb */ { 1, 0, 1, 0, "0389" },
/* U+1fcc */ { 3, 0, 1, 0, "0397 0345" },
/* U+1fcd */ { 29, 0, 19, 0, "1FBF 0300" },
/* U+1fce */ { 29, 0, 19, 0, "1FBF 0301" },
/* U+1fcf */ { 29, 0, 19, 0, "1FBF 0342" },
/* U+1fd0 */ { 2, 0, 1, 0, "03B9 0306" },
/* U+1fd1 */ { 2, 0, 1, 0, "03B9 0304" },
/* U+1fd2 */ { 2, 0, 1, 0, "03CA 0300" },
/* U+1fd3 */ { 2, 0, 1, 0, "0390" },
/* U+1fd4 */ { 0, 0, 0, 0, 0 },
/* U+1fd5 */ { 0, 0, 0, 0, 0 },
/* U+1fd6 */ { 2, 0, 1, 0, "03B9 0342" },
/* U+1fd7 */ { 2, 0, 1, 0, "03CA 0342" },
/* U+1fd8 */ { 1, 0, 1, 0, "0399 0306" },
/* U+1fd9 */ { 1, 0, 1, 0, "0399 0304" },
/* U+1fda */ { 1, 0, 1, 0, "0399 0300" },
/* U+1fdb */ { 1, 0, 1, 0, "038A" },
/* U+1fdc */ { 0, 0, 0, 0, 0 },
/* U+1fdd */ { 29, 0, 19, 0, "1FFE 0300" },
/* U+1fde */ { 29, 0, 19, 0, "1FFE 0301" },
/* U+1fdf */ { 29, 0, 19, 0, "1FFE 0342" },
/* U+1fe0 */ { 2, 0, 1, 0, "03C5 0306" },
/* U+1fe1 */ { 2, 0, 1, 0, "03C5 0304" },
/* U+1fe2 */ { 2, 0, 1, 0, "03CB 0300" },
/* U+1fe3 */ { 2, 0, 1, 0, "03B0" },
/* U+1fe4 */ { 2, 0, 1, 0, "03C1 0313" },
/* U+1fe5 */ { 2, 0, 1, 0, "03C1 0314" },
/* U+1fe6 */ { 2, 0, 1, 0, "03C5 0342" },
/* U+1fe7 */ { 2, 0, 1, 0, "03CB 0342" },
/* U+1fe8 */ { 1, 0, 1, 0, "03A5 0306" },
/* U+1fe9 */ { 1, 0, 1, 0, "03A5 0304" },
/* U+1fea */ { 1, 0, 1, 0, "03A5 0300" },
/* U+1feb */ { 1, 0, 1, 0, "038E" },
/* U+1fec */ { 1, 0, 1, 0, "03A1 0314" },
/* U+1fed */ { 29, 0, 19, 0, "00A8 0300" },
/* U+1fee */ { 29, 0, 19, 0, "0385" },
/* U+1fef */ { 29, 0, 19, 0, "0060" },
/* U+1ff0 */ { 0, 0, 0, 0, 0 },
/* U+1ff1 */ { 0, 0, 0, 0, 0 },
/* U+1ff2 */ { 2, 0, 1, 0, "1F7C 0345" },
/* U+1ff3 */ { 2, 0, 1, 0, "03C9 0345" },
/* U+1ff4 */ { 2, 0, 1, 0, "03CE 0345" },
/* U+1ff5 */ { 0, 0, 0, 0, 0 },
/* U+1ff6 */ { 2, 0, 1, 0, "03C9 0342" },
/* U+1ff7 */ { 2, 0, 1, 0, "1FF6 0345" },
/* U+1ff8 */ { 1, 0, 1, 0, "039F 0300" },
/* U+1ff9 */ { 1, 0, 1, 0, "038C" },
/* U+1ffa */ { 1, 0, 1, 0, "03A9 0300" },
/* U+1ffb */ { 1, 0, 1, 0, "038F" },
/* U+1ffc */ { 3, 0, 1, 0, "03A9 0345" },
/* U+1ffd */ { 29, 0, 19, 0, "00B4" },
/* U+1ffe */ { 29, 0, 19, 0, "<compat> 0020 0314" },
/* U+1fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_2[4096] = {
    
/* U+2000 */ { 10, 0, 18, 0, "2002" },
/* U+2001 */ { 10, 0, 18, 0, "2003" },
/* U+2002 */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+2003 */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+2004 */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+2005 */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+2006 */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+2007 */ { 10, 0, 18, 0, "<noBreak> 0020" },
/* U+2008 */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+2009 */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+200a */ { 10, 0, 18, 0, "<compat> 0020" },
/* U+200b */ { 10, 0, 15, 0, 0 },
/* U+200c */ { 14, 0, 15, 0, 0 },
/* U+200d */ { 14, 0, 15, 0, 0 },
/* U+200e */ { 14, 0, 1, 0, 0 },
/* U+200f */ { 14, 0, 4, 0, 0 },
/* U+2010 */ { 21, 0, 19, 0, 0 },
/* U+2011 */ { 21, 0, 19, 0, "<noBreak> 2010" },
/* U+2012 */ { 21, 0, 19, 0, 0 },
/* U+2013 */ { 21, 0, 19, 0, 0 },
/* U+2014 */ { 21, 0, 19, 0, 0 },
/* U+2015 */ { 21, 0, 19, 0, 0 },
/* U+2016 */ { 26, 0, 19, 0, 0 },
/* U+2017 */ { 26, 0, 19, 0, "<compat> 0020 0333" },
/* U+2018 */ { 24, 0, 19, 0, 0 },
/* U+2019 */ { 25, 0, 19, 0, 0 },
/* U+201a */ { 22, 0, 19, 0, 0 },
/* U+201b */ { 24, 0, 19, 0, 0 },
/* U+201c */ { 24, 0, 19, 0, 0 },
/* U+201d */ { 25, 0, 19, 0, 0 },
/* U+201e */ { 22, 0, 19, 0, 0 },
/* U+201f */ { 24, 0, 19, 0, 0 },
/* U+2020 */ { 26, 0, 19, 0, 0 },
/* U+2021 */ { 26, 0, 19, 0, 0 },
/* U+2022 */ { 26, 0, 19, 0, 0 },
/* U+2023 */ { 26, 0, 19, 0, 0 },
/* U+2024 */ { 26, 0, 19, 0, "<compat> 002E" },
/* U+2025 */ { 26, 0, 19, 0, "<compat> 002E 002E" },
/* U+2026 */ { 26, 0, 19, 0, "<compat> 002E 002E 002E" },
/* U+2027 */ { 26, 0, 19, 0, 0 },
/* U+2028 */ { 11, 0, 18, 0, 0 },
/* U+2029 */ { 12, 0, 16, 0, 0 },
/* U+202a */ { 14, 0, 2, 0, 0 },
/* U+202b */ { 14, 0, 6, 0, 0 },
/* U+202c */ { 14, 0, 8, 0, 0 },
/* U+202d */ { 14, 0, 3, 0, 0 },
/* U+202e */ { 14, 0, 7, 0, 0 },
/* U+202f */ { 10, 0, 18, 0, "<noBreak> 0020" },
/* U+2030 */ { 26, 0, 11, 0, 0 },
/* U+2031 */ { 26, 0, 11, 0, 0 },
/* U+2032 */ { 26, 0, 11, 0, 0 },
/* U+2033 */ { 26, 0, 11, 0, "<compat> 2032 2032" },
/* U+2034 */ { 26, 0, 11, 0, "<compat> 2032 2032 2032" },
/* U+2035 */ { 26, 0, 19, 0, 0 },
/* U+2036 */ { 26, 0, 19, 0, "<compat> 2035 2035" },
/* U+2037 */ { 26, 0, 19, 0, "<compat> 2035 2035 2035" },
/* U+2038 */ { 26, 0, 19, 0, 0 },
/* U+2039 */ { 24, 0, 19, 1, 0 },
/* U+203a */ { 25, 0, 19, 1, 0 },
/* U+203b */ { 26, 0, 19, 0, 0 },
/* U+203c */ { 26, 0, 19, 0, "<compat> 0021 0021" },
/* U+203d */ { 26, 0, 19, 0, 0 },
/* U+203e */ { 26, 0, 19, 0, "<compat> 0020 0305" },
/* U+203f */ { 20, 0, 19, 0, 0 },
/* U+2040 */ { 20, 0, 19, 0, 0 },
/* U+2041 */ { 26, 0, 19, 0, 0 },
/* U+2042 */ { 26, 0, 19, 0, 0 },
/* U+2043 */ { 26, 0, 19, 0, 0 },
/* U+2044 */ { 27, 0, 19, 0, 0 },
/* U+2045 */ { 22, 0, 19, 1, 0 },
/* U+2046 */ { 23, 0, 19, 1, 0 },
/* U+2047 */ { 0, 0, 0, 0, 0 },
/* U+2048 */ { 26, 0, 19, 0, "<compat> 003F 0021" },
/* U+2049 */ { 26, 0, 19, 0, "<compat> 0021 003F" },
/* U+204a */ { 26, 0, 19, 0, 0 },
/* U+204b */ { 26, 0, 19, 0, 0 },
/* U+204c */ { 26, 0, 19, 0, 0 },
/* U+204d */ { 26, 0, 19, 0, 0 },
/* U+204e */ { 0, 0, 0, 0, 0 },
/* U+204f */ { 0, 0, 0, 0, 0 },
/* U+2050 */ { 0, 0, 0, 0, 0 },
/* U+2051 */ { 0, 0, 0, 0, 0 },
/* U+2052 */ { 0, 0, 0, 0, 0 },
/* U+2053 */ { 0, 0, 0, 0, 0 },
/* U+2054 */ { 0, 0, 0, 0, 0 },
/* U+2055 */ { 0, 0, 0, 0, 0 },
/* U+2056 */ { 0, 0, 0, 0, 0 },
/* U+2057 */ { 0, 0, 0, 0, 0 },
/* U+2058 */ { 0, 0, 0, 0, 0 },
/* U+2059 */ { 0, 0, 0, 0, 0 },
/* U+205a */ { 0, 0, 0, 0, 0 },
/* U+205b */ { 0, 0, 0, 0, 0 },
/* U+205c */ { 0, 0, 0, 0, 0 },
/* U+205d */ { 0, 0, 0, 0, 0 },
/* U+205e */ { 0, 0, 0, 0, 0 },
/* U+205f */ { 0, 0, 0, 0, 0 },
/* U+2060 */ { 0, 0, 0, 0, 0 },
/* U+2061 */ { 0, 0, 0, 0, 0 },
/* U+2062 */ { 0, 0, 0, 0, 0 },
/* U+2063 */ { 0, 0, 0, 0, 0 },
/* U+2064 */ { 0, 0, 0, 0, 0 },
/* U+2065 */ { 0, 0, 0, 0, 0 },
/* U+2066 */ { 0, 0, 0, 0, 0 },
/* U+2067 */ { 0, 0, 0, 0, 0 },
/* U+2068 */ { 0, 0, 0, 0, 0 },
/* U+2069 */ { 0, 0, 0, 0, 0 },
/* U+206a */ { 14, 0, 15, 0, 0 },
/* U+206b */ { 14, 0, 15, 0, 0 },
/* U+206c */ { 14, 0, 15, 0, 0 },
/* U+206d */ { 14, 0, 15, 0, 0 },
/* U+206e */ { 14, 0, 15, 0, 0 },
/* U+206f */ { 14, 0, 15, 0, 0 },
/* U+2070 */ { 9, 0, 9, 0, "<super> 0030" },
/* U+2071 */ { 0, 0, 0, 0, 0 },
/* U+2072 */ { 0, 0, 0, 0, 0 },
/* U+2073 */ { 0, 0, 0, 0, 0 },
/* U+2074 */ { 9, 0, 9, 0, "<super> 0034" },
/* U+2075 */ { 9, 0, 9, 0, "<super> 0035" },
/* U+2076 */ { 9, 0, 9, 0, "<super> 0036" },
/* U+2077 */ { 9, 0, 9, 0, "<super> 0037" },
/* U+2078 */ { 9, 0, 9, 0, "<super> 0038" },
/* U+2079 */ { 9, 0, 9, 0, "<super> 0039" },
/* U+207a */ { 27, 0, 11, 0, "<super> 002B" },
/* U+207b */ { 27, 0, 11, 0, "<super> 2212" },
/* U+207c */ { 27, 0, 19, 0, "<super> 003D" },
/* U+207d */ { 22, 0, 19, 1, "<super> 0028" },
/* U+207e */ { 23, 0, 19, 1, "<super> 0029" },
/* U+207f */ { 2, 0, 1, 0, "<super> 006E" },
/* U+2080 */ { 9, 0, 9, 0, "<sub> 0030" },
/* U+2081 */ { 9, 0, 9, 0, "<sub> 0031" },
/* U+2082 */ { 9, 0, 9, 0, "<sub> 0032" },
/* U+2083 */ { 9, 0, 9, 0, "<sub> 0033" },
/* U+2084 */ { 9, 0, 9, 0, "<sub> 0034" },
/* U+2085 */ { 9, 0, 9, 0, "<sub> 0035" },
/* U+2086 */ { 9, 0, 9, 0, "<sub> 0036" },
/* U+2087 */ { 9, 0, 9, 0, "<sub> 0037" },
/* U+2088 */ { 9, 0, 9, 0, "<sub> 0038" },
/* U+2089 */ { 9, 0, 9, 0, "<sub> 0039" },
/* U+208a */ { 27, 0, 11, 0, "<sub> 002B" },
/* U+208b */ { 27, 0, 11, 0, "<sub> 2212" },
/* U+208c */ { 27, 0, 19, 0, "<sub> 003D" },
/* U+208d */ { 22, 0, 19, 1, "<sub> 0028" },
/* U+208e */ { 23, 0, 19, 1, "<sub> 0029" },
/* U+208f */ { 0, 0, 0, 0, 0 },
/* U+2090 */ { 0, 0, 0, 0, 0 },
/* U+2091 */ { 0, 0, 0, 0, 0 },
/* U+2092 */ { 0, 0, 0, 0, 0 },
/* U+2093 */ { 0, 0, 0, 0, 0 },
/* U+2094 */ { 0, 0, 0, 0, 0 },
/* U+2095 */ { 0, 0, 0, 0, 0 },
/* U+2096 */ { 0, 0, 0, 0, 0 },
/* U+2097 */ { 0, 0, 0, 0, 0 },
/* U+2098 */ { 0, 0, 0, 0, 0 },
/* U+2099 */ { 0, 0, 0, 0, 0 },
/* U+209a */ { 0, 0, 0, 0, 0 },
/* U+209b */ { 0, 0, 0, 0, 0 },
/* U+209c */ { 0, 0, 0, 0, 0 },
/* U+209d */ { 0, 0, 0, 0, 0 },
/* U+209e */ { 0, 0, 0, 0, 0 },
/* U+209f */ { 0, 0, 0, 0, 0 },
/* U+20a0 */ { 28, 0, 11, 0, 0 },
/* U+20a1 */ { 28, 0, 11, 0, 0 },
/* U+20a2 */ { 28, 0, 11, 0, 0 },
/* U+20a3 */ { 28, 0, 11, 0, 0 },
/* U+20a4 */ { 28, 0, 11, 0, 0 },
/* U+20a5 */ { 28, 0, 11, 0, 0 },
/* U+20a6 */ { 28, 0, 11, 0, 0 },
/* U+20a7 */ { 28, 0, 11, 0, 0 },
/* U+20a8 */ { 28, 0, 11, 0, "<compat> 0052 0073" },
/* U+20a9 */ { 28, 0, 11, 0, 0 },
/* U+20aa */ { 28, 0, 11, 0, 0 },
/* U+20ab */ { 28, 0, 11, 0, 0 },
/* U+20ac */ { 28, 0, 11, 0, 0 },
/* U+20ad */ { 28, 0, 11, 0, 0 },
/* U+20ae */ { 28, 0, 11, 0, 0 },
/* U+20af */ { 28, 0, 11, 0, 0 },
/* U+20b0 */ { 0, 0, 0, 0, 0 },
/* U+20b1 */ { 0, 0, 0, 0, 0 },
/* U+20b2 */ { 0, 0, 0, 0, 0 },
/* U+20b3 */ { 0, 0, 0, 0, 0 },
/* U+20b4 */ { 0, 0, 0, 0, 0 },
/* U+20b5 */ { 0, 0, 0, 0, 0 },
/* U+20b6 */ { 0, 0, 0, 0, 0 },
/* U+20b7 */ { 0, 0, 0, 0, 0 },
/* U+20b8 */ { 0, 0, 0, 0, 0 },
/* U+20b9 */ { 0, 0, 0, 0, 0 },
/* U+20ba */ { 0, 0, 0, 0, 0 },
/* U+20bb */ { 0, 0, 0, 0, 0 },
/* U+20bc */ { 0, 0, 0, 0, 0 },
/* U+20bd */ { 0, 0, 0, 0, 0 },
/* U+20be */ { 0, 0, 0, 0, 0 },
/* U+20bf */ { 0, 0, 0, 0, 0 },
/* U+20c0 */ { 0, 0, 0, 0, 0 },
/* U+20c1 */ { 0, 0, 0, 0, 0 },
/* U+20c2 */ { 0, 0, 0, 0, 0 },
/* U+20c3 */ { 0, 0, 0, 0, 0 },
/* U+20c4 */ { 0, 0, 0, 0, 0 },
/* U+20c5 */ { 0, 0, 0, 0, 0 },
/* U+20c6 */ { 0, 0, 0, 0, 0 },
/* U+20c7 */ { 0, 0, 0, 0, 0 },
/* U+20c8 */ { 0, 0, 0, 0, 0 },
/* U+20c9 */ { 0, 0, 0, 0, 0 },
/* U+20ca */ { 0, 0, 0, 0, 0 },
/* U+20cb */ { 0, 0, 0, 0, 0 },
/* U+20cc */ { 0, 0, 0, 0, 0 },
/* U+20cd */ { 0, 0, 0, 0, 0 },
/* U+20ce */ { 0, 0, 0, 0, 0 },
/* U+20cf */ { 0, 0, 0, 0, 0 },
/* U+20d0 */ { 4, 230, 14, 0, 0 },
/* U+20d1 */ { 4, 230, 14, 0, 0 },
/* U+20d2 */ { 4, 1, 14, 0, 0 },
/* U+20d3 */ { 4, 1, 14, 0, 0 },
/* U+20d4 */ { 4, 230, 14, 0, 0 },
/* U+20d5 */ { 4, 230, 14, 0, 0 },
/* U+20d6 */ { 4, 230, 14, 0, 0 },
/* U+20d7 */ { 4, 230, 14, 0, 0 },
/* U+20d8 */ { 4, 1, 14, 0, 0 },
/* U+20d9 */ { 4, 1, 14, 0, 0 },
/* U+20da */ { 4, 1, 14, 0, 0 },
/* U+20db */ { 4, 230, 14, 0, 0 },
/* U+20dc */ { 4, 230, 14, 0, 0 },
/* U+20dd */ { 6, 0, 14, 0, 0 },
/* U+20de */ { 6, 0, 14, 0, 0 },
/* U+20df */ { 6, 0, 14, 0, 0 },
/* U+20e0 */ { 6, 0, 14, 0, 0 },
/* U+20e1 */ { 4, 230, 14, 0, 0 },
/* U+20e2 */ { 6, 0, 14, 0, 0 },
/* U+20e3 */ { 6, 0, 14, 0, 0 },
/* U+20e4 */ { 0, 0, 0, 0, 0 },
/* U+20e5 */ { 0, 0, 0, 0, 0 },
/* U+20e6 */ { 0, 0, 0, 0, 0 },
/* U+20e7 */ { 0, 0, 0, 0, 0 },
/* U+20e8 */ { 0, 0, 0, 0, 0 },
/* U+20e9 */ { 0, 0, 0, 0, 0 },
/* U+20ea */ { 0, 0, 0, 0, 0 },
/* U+20eb */ { 0, 0, 0, 0, 0 },
/* U+20ec */ { 0, 0, 0, 0, 0 },
/* U+20ed */ { 0, 0, 0, 0, 0 },
/* U+20ee */ { 0, 0, 0, 0, 0 },
/* U+20ef */ { 0, 0, 0, 0, 0 },
/* U+20f0 */ { 0, 0, 0, 0, 0 },
/* U+20f1 */ { 0, 0, 0, 0, 0 },
/* U+20f2 */ { 0, 0, 0, 0, 0 },
/* U+20f3 */ { 0, 0, 0, 0, 0 },
/* U+20f4 */ { 0, 0, 0, 0, 0 },
/* U+20f5 */ { 0, 0, 0, 0, 0 },
/* U+20f6 */ { 0, 0, 0, 0, 0 },
/* U+20f7 */ { 0, 0, 0, 0, 0 },
/* U+20f8 */ { 0, 0, 0, 0, 0 },
/* U+20f9 */ { 0, 0, 0, 0, 0 },
/* U+20fa */ { 0, 0, 0, 0, 0 },
/* U+20fb */ { 0, 0, 0, 0, 0 },
/* U+20fc */ { 0, 0, 0, 0, 0 },
/* U+20fd */ { 0, 0, 0, 0, 0 },
/* U+20fe */ { 0, 0, 0, 0, 0 },
/* U+20ff */ { 0, 0, 0, 0, 0 },
/* U+2100 */ { 30, 0, 19, 0, "<compat> 0061 002F 0063" },
/* U+2101 */ { 30, 0, 19, 0, "<compat> 0061 002F 0073" },
/* U+2102 */ { 1, 0, 1, 0, "<font> 0043" },
/* U+2103 */ { 30, 0, 19, 0, "<compat> 00B0 0043" },
/* U+2104 */ { 30, 0, 19, 0, 0 },
/* U+2105 */ { 30, 0, 19, 0, "<compat> 0063 002F 006F" },
/* U+2106 */ { 30, 0, 19, 0, "<compat> 0063 002F 0075" },
/* U+2107 */ { 1, 0, 1, 0, "<compat> 0190" },
/* U+2108 */ { 30, 0, 19, 0, 0 },
/* U+2109 */ { 30, 0, 19, 0, "<compat> 00B0 0046" },
/* U+210a */ { 2, 0, 1, 0, "<font> 0067" },
/* U+210b */ { 1, 0, 1, 0, "<font> 0048" },
/* U+210c */ { 1, 0, 1, 0, "<font> 0048" },
/* U+210d */ { 1, 0, 1, 0, "<font> 0048" },
/* U+210e */ { 2, 0, 1, 0, "<font> 0068" },
/* U+210f */ { 2, 0, 1, 0, "<font> 0127" },
/* U+2110 */ { 1, 0, 1, 0, "<font> 0049" },
/* U+2111 */ { 1, 0, 1, 0, "<font> 0049" },
/* U+2112 */ { 1, 0, 1, 0, "<font> 004C" },
/* U+2113 */ { 2, 0, 1, 0, "<font> 006C" },
/* U+2114 */ { 30, 0, 19, 0, 0 },
/* U+2115 */ { 1, 0, 1, 0, "<font> 004E" },
/* U+2116 */ { 30, 0, 19, 0, "<compat> 004E 006F" },
/* U+2117 */ { 30, 0, 19, 0, 0 },
/* U+2118 */ { 30, 0, 19, 0, 0 },
/* U+2119 */ { 1, 0, 1, 0, "<font> 0050" },
/* U+211a */ { 1, 0, 1, 0, "<font> 0051" },
/* U+211b */ { 1, 0, 1, 0, "<font> 0052" },
/* U+211c */ { 1, 0, 1, 0, "<font> 0052" },
/* U+211d */ { 1, 0, 1, 0, "<font> 0052" },
/* U+211e */ { 30, 0, 19, 0, 0 },
/* U+211f */ { 30, 0, 19, 0, 0 },
/* U+2120 */ { 30, 0, 19, 0, "<super> 0053 004D" },
/* U+2121 */ { 30, 0, 19, 0, "<compat> 0054 0045 004C" },
/* U+2122 */ { 30, 0, 19, 0, "<super> 0054 004D" },
/* U+2123 */ { 30, 0, 19, 0, 0 },
/* U+2124 */ { 1, 0, 1, 0, "<font> 005A" },
/* U+2125 */ { 30, 0, 19, 0, 0 },
/* U+2126 */ { 1, 0, 1, 0, "03A9" },
/* U+2127 */ { 30, 0, 19, 0, 0 },
/* U+2128 */ { 1, 0, 1, 0, "<font> 005A" },
/* U+2129 */ { 30, 0, 19, 0, 0 },
/* U+212a */ { 1, 0, 1, 0, "004B" },
/* U+212b */ { 1, 0, 1, 0, "00C5" },
/* U+212c */ { 1, 0, 1, 0, "<font> 0042" },
/* U+212d */ { 1, 0, 1, 0, "<font> 0043" },
/* U+212e */ { 30, 0, 11, 0, 0 },
/* U+212f */ { 2, 0, 1, 0, "<font> 0065" },
/* U+2130 */ { 1, 0, 1, 0, "<font> 0045" },
/* U+2131 */ { 1, 0, 1, 0, "<font> 0046" },
/* U+2132 */ { 30, 0, 19, 0, 0 },
/* U+2133 */ { 1, 0, 1, 0, "<font> 004D" },
/* U+2134 */ { 2, 0, 1, 0, "<font> 006F" },
/* U+2135 */ { 19, 0, 1, 0, "<compat> 05D0" },
/* U+2136 */ { 19, 0, 1, 0, "<compat> 05D1" },
/* U+2137 */ { 19, 0, 1, 0, "<compat> 05D2" },
/* U+2138 */ { 19, 0, 1, 0, "<compat> 05D3" },
/* U+2139 */ { 2, 0, 1, 0, "<font> 0069" },
/* U+213a */ { 30, 0, 19, 0, 0 },
/* U+213b */ { 0, 0, 0, 0, 0 },
/* U+213c */ { 0, 0, 0, 0, 0 },
/* U+213d */ { 0, 0, 0, 0, 0 },
/* U+213e */ { 0, 0, 0, 0, 0 },
/* U+213f */ { 0, 0, 0, 0, 0 },
/* U+2140 */ { 0, 0, 0, 0, 0 },
/* U+2141 */ { 0, 0, 0, 0, 0 },
/* U+2142 */ { 0, 0, 0, 0, 0 },
/* U+2143 */ { 0, 0, 0, 0, 0 },
/* U+2144 */ { 0, 0, 0, 0, 0 },
/* U+2145 */ { 0, 0, 0, 0, 0 },
/* U+2146 */ { 0, 0, 0, 0, 0 },
/* U+2147 */ { 0, 0, 0, 0, 0 },
/* U+2148 */ { 0, 0, 0, 0, 0 },
/* U+2149 */ { 0, 0, 0, 0, 0 },
/* U+214a */ { 0, 0, 0, 0, 0 },
/* U+214b */ { 0, 0, 0, 0, 0 },
/* U+214c */ { 0, 0, 0, 0, 0 },
/* U+214d */ { 0, 0, 0, 0, 0 },
/* U+214e */ { 0, 0, 0, 0, 0 },
/* U+214f */ { 0, 0, 0, 0, 0 },
/* U+2150 */ { 0, 0, 0, 0, 0 },
/* U+2151 */ { 0, 0, 0, 0, 0 },
/* U+2152 */ { 0, 0, 0, 0, 0 },
/* U+2153 */ { 9, 0, 19, 0, "<fraction> 0031 2044 0033" },
/* U+2154 */ { 9, 0, 19, 0, "<fraction> 0032 2044 0033" },
/* U+2155 */ { 9, 0, 19, 0, "<fraction> 0031 2044 0035" },
/* U+2156 */ { 9, 0, 19, 0, "<fraction> 0032 2044 0035" },
/* U+2157 */ { 9, 0, 19, 0, "<fraction> 0033 2044 0035" },
/* U+2158 */ { 9, 0, 19, 0, "<fraction> 0034 2044 0035" },
/* U+2159 */ { 9, 0, 19, 0, "<fraction> 0031 2044 0036" },
/* U+215a */ { 9, 0, 19, 0, "<fraction> 0035 2044 0036" },
/* U+215b */ { 9, 0, 19, 0, "<fraction> 0031 2044 0038" },
/* U+215c */ { 9, 0, 19, 0, "<fraction> 0033 2044 0038" },
/* U+215d */ { 9, 0, 19, 0, "<fraction> 0035 2044 0038" },
/* U+215e */ { 9, 0, 19, 0, "<fraction> 0037 2044 0038" },
/* U+215f */ { 9, 0, 19, 0, "<fraction> 0031 2044" },
/* U+2160 */ { 8, 0, 1, 0, "<compat> 0049" },
/* U+2161 */ { 8, 0, 1, 0, "<compat> 0049 0049" },
/* U+2162 */ { 8, 0, 1, 0, "<compat> 0049 0049 0049" },
/* U+2163 */ { 8, 0, 1, 0, "<compat> 0049 0056" },
/* U+2164 */ { 8, 0, 1, 0, "<compat> 0056" },
/* U+2165 */ { 8, 0, 1, 0, "<compat> 0056 0049" },
/* U+2166 */ { 8, 0, 1, 0, "<compat> 0056 0049 0049" },
/* U+2167 */ { 8, 0, 1, 0, "<compat> 0056 0049 0049 0049" },
/* U+2168 */ { 8, 0, 1, 0, "<compat> 0049 0058" },
/* U+2169 */ { 8, 0, 1, 0, "<compat> 0058" },
/* U+216a */ { 8, 0, 1, 0, "<compat> 0058 0049" },
/* U+216b */ { 8, 0, 1, 0, "<compat> 0058 0049 0049" },
/* U+216c */ { 8, 0, 1, 0, "<compat> 004C" },
/* U+216d */ { 8, 0, 1, 0, "<compat> 0043" },
/* U+216e */ { 8, 0, 1, 0, "<compat> 0044" },
/* U+216f */ { 8, 0, 1, 0, "<compat> 004D" },
/* U+2170 */ { 8, 0, 1, 0, "<compat> 0069" },
/* U+2171 */ { 8, 0, 1, 0, "<compat> 0069 0069" },
/* U+2172 */ { 8, 0, 1, 0, "<compat> 0069 0069 0069" },
/* U+2173 */ { 8, 0, 1, 0, "<compat> 0069 0076" },
/* U+2174 */ { 8, 0, 1, 0, "<compat> 0076" },
/* U+2175 */ { 8, 0, 1, 0, "<compat> 0076 0069" },
/* U+2176 */ { 8, 0, 1, 0, "<compat> 0076 0069 0069" },
/* U+2177 */ { 8, 0, 1, 0, "<compat> 0076 0069 0069 0069" },
/* U+2178 */ { 8, 0, 1, 0, "<compat> 0069 0078" },
/* U+2179 */ { 8, 0, 1, 0, "<compat> 0078" },
/* U+217a */ { 8, 0, 1, 0, "<compat> 0078 0069" },
/* U+217b */ { 8, 0, 1, 0, "<compat> 0078 0069 0069" },
/* U+217c */ { 8, 0, 1, 0, "<compat> 006C" },
/* U+217d */ { 8, 0, 1, 0, "<compat> 0063" },
/* U+217e */ { 8, 0, 1, 0, "<compat> 0064" },
/* U+217f */ { 8, 0, 1, 0, "<compat> 006D" },
/* U+2180 */ { 8, 0, 1, 0, 0 },
/* U+2181 */ { 8, 0, 1, 0, 0 },
/* U+2182 */ { 8, 0, 1, 0, 0 },
/* U+2183 */ { 8, 0, 1, 0, 0 },
/* U+2184 */ { 0, 0, 0, 0, 0 },
/* U+2185 */ { 0, 0, 0, 0, 0 },
/* U+2186 */ { 0, 0, 0, 0, 0 },
/* U+2187 */ { 0, 0, 0, 0, 0 },
/* U+2188 */ { 0, 0, 0, 0, 0 },
/* U+2189 */ { 0, 0, 0, 0, 0 },
/* U+218a */ { 0, 0, 0, 0, 0 },
/* U+218b */ { 0, 0, 0, 0, 0 },
/* U+218c */ { 0, 0, 0, 0, 0 },
/* U+218d */ { 0, 0, 0, 0, 0 },
/* U+218e */ { 0, 0, 0, 0, 0 },
/* U+218f */ { 0, 0, 0, 0, 0 },
/* U+2190 */ { 27, 0, 19, 0, 0 },
/* U+2191 */ { 27, 0, 19, 0, 0 },
/* U+2192 */ { 27, 0, 19, 0, 0 },
/* U+2193 */ { 27, 0, 19, 0, 0 },
/* U+2194 */ { 27, 0, 19, 0, 0 },
/* U+2195 */ { 30, 0, 19, 0, 0 },
/* U+2196 */ { 30, 0, 19, 0, 0 },
/* U+2197 */ { 30, 0, 19, 0, 0 },
/* U+2198 */ { 30, 0, 19, 0, 0 },
/* U+2199 */ { 30, 0, 19, 0, 0 },
/* U+219a */ { 27, 0, 19, 0, "2190 0338" },
/* U+219b */ { 27, 0, 19, 0, "2192 0338" },
/* U+219c */ { 30, 0, 19, 0, 0 },
/* U+219d */ { 30, 0, 19, 0, 0 },
/* U+219e */ { 30, 0, 19, 0, 0 },
/* U+219f */ { 30, 0, 19, 0, 0 },
/* U+21a0 */ { 27, 0, 19, 0, 0 },
/* U+21a1 */ { 30, 0, 19, 0, 0 },
/* U+21a2 */ { 30, 0, 19, 0, 0 },
/* U+21a3 */ { 27, 0, 19, 0, 0 },
/* U+21a4 */ { 30, 0, 19, 0, 0 },
/* U+21a5 */ { 30, 0, 19, 0, 0 },
/* U+21a6 */ { 27, 0, 19, 0, 0 },
/* U+21a7 */ { 30, 0, 19, 0, 0 },
/* U+21a8 */ { 30, 0, 19, 0, 0 },
/* U+21a9 */ { 30, 0, 19, 0, 0 },
/* U+21aa */ { 30, 0, 19, 0, 0 },
/* U+21ab */ { 30, 0, 19, 0, 0 },
/* U+21ac */ { 30, 0, 19, 0, 0 },
/* U+21ad */ { 30, 0, 19, 0, 0 },
/* U+21ae */ { 27, 0, 19, 0, "2194 0338" },
/* U+21af */ { 30, 0, 19, 0, 0 },
/* U+21b0 */ { 30, 0, 19, 0, 0 },
/* U+21b1 */ { 30, 0, 19, 0, 0 },
/* U+21b2 */ { 30, 0, 19, 0, 0 },
/* U+21b3 */ { 30, 0, 19, 0, 0 },
/* U+21b4 */ { 30, 0, 19, 0, 0 },
/* U+21b5 */ { 30, 0, 19, 0, 0 },
/* U+21b6 */ { 30, 0, 19, 0, 0 },
/* U+21b7 */ { 30, 0, 19, 0, 0 },
/* U+21b8 */ { 30, 0, 19, 0, 0 },
/* U+21b9 */ { 30, 0, 19, 0, 0 },
/* U+21ba */ { 30, 0, 19, 0, 0 },
/* U+21bb */ { 30, 0, 19, 0, 0 },
/* U+21bc */ { 30, 0, 19, 0, 0 },
/* U+21bd */ { 30, 0, 19, 0, 0 },
/* U+21be */ { 30, 0, 19, 0, 0 },
/* U+21bf */ { 30, 0, 19, 0, 0 },
/* U+21c0 */ { 30, 0, 19, 0, 0 },
/* U+21c1 */ { 30, 0, 19, 0, 0 },
/* U+21c2 */ { 30, 0, 19, 0, 0 },
/* U+21c3 */ { 30, 0, 19, 0, 0 },
/* U+21c4 */ { 30, 0, 19, 0, 0 },
/* U+21c5 */ { 30, 0, 19, 0, 0 },
/* U+21c6 */ { 30, 0, 19, 0, 0 },
/* U+21c7 */ { 30, 0, 19, 0, 0 },
/* U+21c8 */ { 30, 0, 19, 0, 0 },
/* U+21c9 */ { 30, 0, 19, 0, 0 },
/* U+21ca */ { 30, 0, 19, 0, 0 },
/* U+21cb */ { 30, 0, 19, 0, 0 },
/* U+21cc */ { 30, 0, 19, 0, 0 },
/* U+21cd */ { 30, 0, 19, 0, "21D0 0338" },
/* U+21ce */ { 27, 0, 19, 0, "21D4 0338" },
/* U+21cf */ { 27, 0, 19, 0, "21D2 0338" },
/* U+21d0 */ { 30, 0, 19, 0, 0 },
/* U+21d1 */ { 30, 0, 19, 0, 0 },
/* U+21d2 */ { 27, 0, 19, 0, 0 },
/* U+21d3 */ { 30, 0, 19, 0, 0 },
/* U+21d4 */ { 27, 0, 19, 0, 0 },
/* U+21d5 */ { 30, 0, 19, 0, 0 },
/* U+21d6 */ { 30, 0, 19, 0, 0 },
/* U+21d7 */ { 30, 0, 19, 0, 0 },
/* U+21d8 */ { 30, 0, 19, 0, 0 },
/* U+21d9 */ { 30, 0, 19, 0, 0 },
/* U+21da */ { 30, 0, 19, 0, 0 },
/* U+21db */ { 30, 0, 19, 0, 0 },
/* U+21dc */ { 30, 0, 19, 0, 0 },
/* U+21dd */ { 30, 0, 19, 0, 0 },
/* U+21de */ { 30, 0, 19, 0, 0 },
/* U+21df */ { 30, 0, 19, 0, 0 },
/* U+21e0 */ { 30, 0, 19, 0, 0 },
/* U+21e1 */ { 30, 0, 19, 0, 0 },
/* U+21e2 */ { 30, 0, 19, 0, 0 },
/* U+21e3 */ { 30, 0, 19, 0, 0 },
/* U+21e4 */ { 30, 0, 19, 0, 0 },
/* U+21e5 */ { 30, 0, 19, 0, 0 },
/* U+21e6 */ { 30, 0, 19, 0, 0 },
/* U+21e7 */ { 30, 0, 19, 0, 0 },
/* U+21e8 */ { 30, 0, 19, 0, 0 },
/* U+21e9 */ { 30, 0, 19, 0, 0 },
/* U+21ea */ { 30, 0, 19, 0, 0 },
/* U+21eb */ { 30, 0, 19, 0, 0 },
/* U+21ec */ { 30, 0, 19, 0, 0 },
/* U+21ed */ { 30, 0, 19, 0, 0 },
/* U+21ee */ { 30, 0, 19, 0, 0 },
/* U+21ef */ { 30, 0, 19, 0, 0 },
/* U+21f0 */ { 30, 0, 19, 0, 0 },
/* U+21f1 */ { 30, 0, 19, 0, 0 },
/* U+21f2 */ { 30, 0, 19, 0, 0 },
/* U+21f3 */ { 30, 0, 19, 0, 0 },
/* U+21f4 */ { 0, 0, 0, 0, 0 },
/* U+21f5 */ { 0, 0, 0, 0, 0 },
/* U+21f6 */ { 0, 0, 0, 0, 0 },
/* U+21f7 */ { 0, 0, 0, 0, 0 },
/* U+21f8 */ { 0, 0, 0, 0, 0 },
/* U+21f9 */ { 0, 0, 0, 0, 0 },
/* U+21fa */ { 0, 0, 0, 0, 0 },
/* U+21fb */ { 0, 0, 0, 0, 0 },
/* U+21fc */ { 0, 0, 0, 0, 0 },
/* U+21fd */ { 0, 0, 0, 0, 0 },
/* U+21fe */ { 0, 0, 0, 0, 0 },
/* U+21ff */ { 0, 0, 0, 0, 0 },
/* U+2200 */ { 27, 0, 19, 0, 0 },
/* U+2201 */ { 27, 0, 19, 1, 0 },
/* U+2202 */ { 27, 0, 19, 1, 0 },
/* U+2203 */ { 27, 0, 19, 1, 0 },
/* U+2204 */ { 27, 0, 19, 1, "2203 0338" },
/* U+2205 */ { 27, 0, 19, 0, 0 },
/* U+2206 */ { 27, 0, 19, 0, 0 },
/* U+2207 */ { 27, 0, 19, 0, 0 },
/* U+2208 */ { 27, 0, 19, 1, 0 },
/* U+2209 */ { 27, 0, 19, 1, "2208 0338" },
/* U+220a */ { 27, 0, 19, 1, 0 },
/* U+220b */ { 27, 0, 19, 1, 0 },
/* U+220c */ { 27, 0, 19, 1, "220B 0338" },
/* U+220d */ { 27, 0, 19, 1, 0 },
/* U+220e */ { 27, 0, 19, 0, 0 },
/* U+220f */ { 27, 0, 19, 0, 0 },
/* U+2210 */ { 27, 0, 19, 0, 0 },
/* U+2211 */ { 27, 0, 19, 1, 0 },
/* U+2212 */ { 27, 0, 11, 0, 0 },
/* U+2213 */ { 27, 0, 11, 0, 0 },
/* U+2214 */ { 27, 0, 19, 0, 0 },
/* U+2215 */ { 27, 0, 19, 1, 0 },
/* U+2216 */ { 27, 0, 19, 1, 0 },
/* U+2217 */ { 27, 0, 19, 0, 0 },
/* U+2218 */ { 27, 0, 19, 0, 0 },
/* U+2219 */ { 27, 0, 19, 0, 0 },
/* U+221a */ { 27, 0, 19, 1, 0 },
/* U+221b */ { 27, 0, 19, 1, 0 },
/* U+221c */ { 27, 0, 19, 1, 0 },
/* U+221d */ { 27, 0, 19, 1, 0 },
/* U+221e */ { 27, 0, 19, 0, 0 },
/* U+221f */ { 27, 0, 19, 1, 0 },
/* U+2220 */ { 27, 0, 19, 1, 0 },
/* U+2221 */ { 27, 0, 19, 1, 0 },
/* U+2222 */ { 27, 0, 19, 1, 0 },
/* U+2223 */ { 27, 0, 19, 0, 0 },
/* U+2224 */ { 27, 0, 19, 1, "2223 0338" },
/* U+2225 */ { 27, 0, 19, 0, 0 },
/* U+2226 */ { 27, 0, 19, 1, "2225 0338" },
/* U+2227 */ { 27, 0, 19, 0, 0 },
/* U+2228 */ { 27, 0, 19, 0, 0 },
/* U+2229 */ { 27, 0, 19, 0, 0 },
/* U+222a */ { 27, 0, 19, 0, 0 },
/* U+222b */ { 27, 0, 19, 1, 0 },
/* U+222c */ { 27, 0, 19, 1, "<compat> 222B 222B" },
/* U+222d */ { 27, 0, 19, 1, "<compat> 222B 222B 222B" },
/* U+222e */ { 27, 0, 19, 1, 0 },
/* U+222f */ { 27, 0, 19, 1, "<compat> 222E 222E" },
/* U+2230 */ { 27, 0, 19, 1, "<compat> 222E 222E 222E" },
/* U+2231 */ { 27, 0, 19, 1, 0 },
/* U+2232 */ { 27, 0, 19, 1, 0 },
/* U+2233 */ { 27, 0, 19, 1, 0 },
/* U+2234 */ { 27, 0, 19, 0, 0 },
/* U+2235 */ { 27, 0, 19, 0, 0 },
/* U+2236 */ { 27, 0, 19, 0, 0 },
/* U+2237 */ { 27, 0, 19, 0, 0 },
/* U+2238 */ { 27, 0, 19, 0, 0 },
/* U+2239 */ { 27, 0, 19, 1, 0 },
/* U+223a */ { 27, 0, 19, 0, 0 },
/* U+223b */ { 27, 0, 19, 1, 0 },
/* U+223c */ { 27, 0, 19, 1, 0 },
/* U+223d */ { 27, 0, 19, 1, 0 },
/* U+223e */ { 27, 0, 19, 1, 0 },
/* U+223f */ { 27, 0, 19, 1, 0 },
/* U+2240 */ { 27, 0, 19, 1, 0 },
/* U+2241 */ { 27, 0, 19, 1, "223C 0338" },
/* U+2242 */ { 27, 0, 19, 1, 0 },
/* U+2243 */ { 27, 0, 19, 1, 0 },
/* U+2244 */ { 27, 0, 19, 1, "2243 0338" },
/* U+2245 */ { 27, 0, 19, 1, 0 },
/* U+2246 */ { 27, 0, 19, 1, 0 },
/* U+2247 */ { 27, 0, 19, 1, "2245 0338" },
/* U+2248 */ { 27, 0, 19, 1, 0 },
/* U+2249 */ { 27, 0, 19, 1, "2248 0338" },
/* U+224a */ { 27, 0, 19, 1, 0 },
/* U+224b */ { 27, 0, 19, 1, 0 },
/* U+224c */ { 27, 0, 19, 1, 0 },
/* U+224d */ { 27, 0, 19, 0, 0 },
/* U+224e */ { 27, 0, 19, 0, 0 },
/* U+224f */ { 27, 0, 19, 0, 0 },
/* U+2250 */ { 27, 0, 19, 0, 0 },
/* U+2251 */ { 27, 0, 19, 0, 0 },
/* U+2252 */ { 27, 0, 19, 1, 0 },
/* U+2253 */ { 27, 0, 19, 1, 0 },
/* U+2254 */ { 27, 0, 19, 1, 0 },
/* U+2255 */ { 27, 0, 19, 1, 0 },
/* U+2256 */ { 27, 0, 19, 0, 0 },
/* U+2257 */ { 27, 0, 19, 0, 0 },
/* U+2258 */ { 27, 0, 19, 0, 0 },
/* U+2259 */ { 27, 0, 19, 0, 0 },
/* U+225a */ { 27, 0, 19, 0, 0 },
/* U+225b */ { 27, 0, 19, 0, 0 },
/* U+225c */ { 27, 0, 19, 0, 0 },
/* U+225d */ { 27, 0, 19, 0, 0 },
/* U+225e */ { 27, 0, 19, 0, 0 },
/* U+225f */ { 27, 0, 19, 1, 0 },
/* U+2260 */ { 27, 0, 19, 1, "003D 0338" },
/* U+2261 */ { 27, 0, 19, 0, 0 },
/* U+2262 */ { 27, 0, 19, 1, "2261 0338" },
/* U+2263 */ { 27, 0, 19, 0, 0 },
/* U+2264 */ { 27, 0, 19, 1, 0 },
/* U+2265 */ { 27, 0, 19, 1, 0 },
/* U+2266 */ { 27, 0, 19, 1, 0 },
/* U+2267 */ { 27, 0, 19, 1, 0 },
/* U+2268 */ { 27, 0, 19, 1, 0 },
/* U+2269 */ { 27, 0, 19, 1, 0 },
/* U+226a */ { 27, 0, 19, 1, 0 },
/* U+226b */ { 27, 0, 19, 1, 0 },
/* U+226c */ { 27, 0, 19, 0, 0 },
/* U+226d */ { 27, 0, 19, 0, "224D 0338" },
/* U+226e */ { 27, 0, 19, 1, "003C 0338" },
/* U+226f */ { 27, 0, 19, 1, "003E 0338" },
/* U+2270 */ { 27, 0, 19, 1, "2264 0338" },
/* U+2271 */ { 27, 0, 19, 1, "2265 0338" },
/* U+2272 */ { 27, 0, 19, 1, 0 },
/* U+2273 */ { 27, 0, 19, 1, 0 },
/* U+2274 */ { 27, 0, 19, 1, "2272 0338" },
/* U+2275 */ { 27, 0, 19, 1, "2273 0338" },
/* U+2276 */ { 27, 0, 19, 1, 0 },
/* U+2277 */ { 27, 0, 19, 1, 0 },
/* U+2278 */ { 27, 0, 19, 1, "2276 0338" },
/* U+2279 */ { 27, 0, 19, 1, "2277 0338" },
/* U+227a */ { 27, 0, 19, 1, 0 },
/* U+227b */ { 27, 0, 19, 1, 0 },
/* U+227c */ { 27, 0, 19, 1, 0 },
/* U+227d */ { 27, 0, 19, 1, 0 },
/* U+227e */ { 27, 0, 19, 1, 0 },
/* U+227f */ { 27, 0, 19, 1, 0 },
/* U+2280 */ { 27, 0, 19, 1, "227A 0338" },
/* U+2281 */ { 27, 0, 19, 1, "227B 0338" },
/* U+2282 */ { 27, 0, 19, 1, 0 },
/* U+2283 */ { 27, 0, 19, 1, 0 },
/* U+2284 */ { 27, 0, 19, 1, "2282 0338" },
/* U+2285 */ { 27, 0, 19, 1, "2283 0338" },
/* U+2286 */ { 27, 0, 19, 1, 0 },
/* U+2287 */ { 27, 0, 19, 1, 0 },
/* U+2288 */ { 27, 0, 19, 1, "2286 0338" },
/* U+2289 */ { 27, 0, 19, 1, "2287 0338" },
/* U+228a */ { 27, 0, 19, 1, 0 },
/* U+228b */ { 27, 0, 19, 1, 0 },
/* U+228c */ { 27, 0, 19, 1, 0 },
/* U+228d */ { 27, 0, 19, 0, 0 },
/* U+228e */ { 27, 0, 19, 0, 0 },
/* U+228f */ { 27, 0, 19, 1, 0 },
/* U+2290 */ { 27, 0, 19, 1, 0 },
/* U+2291 */ { 27, 0, 19, 1, 0 },
/* U+2292 */ { 27, 0, 19, 1, 0 },
/* U+2293 */ { 27, 0, 19, 0, 0 },
/* U+2294 */ { 27, 0, 19, 0, 0 },
/* U+2295 */ { 27, 0, 19, 0, 0 },
/* U+2296 */ { 27, 0, 19, 0, 0 },
/* U+2297 */ { 27, 0, 19, 0, 0 },
/* U+2298 */ { 27, 0, 19, 1, 0 },
/* U+2299 */ { 27, 0, 19, 0, 0 },
/* U+229a */ { 27, 0, 19, 0, 0 },
/* U+229b */ { 27, 0, 19, 0, 0 },
/* U+229c */ { 27, 0, 19, 0, 0 },
/* U+229d */ { 27, 0, 19, 0, 0 },
/* U+229e */ { 27, 0, 19, 0, 0 },
/* U+229f */ { 27, 0, 19, 0, 0 },
/* U+22a0 */ { 27, 0, 19, 0, 0 },
/* U+22a1 */ { 27, 0, 19, 0, 0 },
/* U+22a2 */ { 27, 0, 19, 1, 0 },
/* U+22a3 */ { 27, 0, 19, 1, 0 },
/* U+22a4 */ { 27, 0, 19, 0, 0 },
/* U+22a5 */ { 27, 0, 19, 0, 0 },
/* U+22a6 */ { 27, 0, 19, 1, 0 },
/* U+22a7 */ { 27, 0, 19, 1, 0 },
/* U+22a8 */ { 27, 0, 19, 1, 0 },
/* U+22a9 */ { 27, 0, 19, 1, 0 },
/* U+22aa */ { 27, 0, 19, 1, 0 },
/* U+22ab */ { 27, 0, 19, 1, 0 },
/* U+22ac */ { 27, 0, 19, 1, "22A2 0338" },
/* U+22ad */ { 27, 0, 19, 1, "22A8 0338" },
/* U+22ae */ { 27, 0, 19, 1, "22A9 0338" },
/* U+22af */ { 27, 0, 19, 1, "22AB 0338" },
/* U+22b0 */ { 27, 0, 19, 1, 0 },
/* U+22b1 */ { 27, 0, 19, 1, 0 },
/* U+22b2 */ { 27, 0, 19, 1, 0 },
/* U+22b3 */ { 27, 0, 19, 1, 0 },
/* U+22b4 */ { 27, 0, 19, 1, 0 },
/* U+22b5 */ { 27, 0, 19, 1, 0 },
/* U+22b6 */ { 27, 0, 19, 1, 0 },
/* U+22b7 */ { 27, 0, 19, 1, 0 },
/* U+22b8 */ { 27, 0, 19, 1, 0 },
/* U+22b9 */ { 27, 0, 19, 0, 0 },
/* U+22ba */ { 27, 0, 19, 0, 0 },
/* U+22bb */ { 27, 0, 19, 0, 0 },
/* U+22bc */ { 27, 0, 19, 0, 0 },
/* U+22bd */ { 27, 0, 19, 0, 0 },
/* U+22be */ { 27, 0, 19, 1, 0 },
/* U+22bf */ { 27, 0, 19, 1, 0 },
/* U+22c0 */ { 27, 0, 19, 0, 0 },
/* U+22c1 */ { 27, 0, 19, 0, 0 },
/* U+22c2 */ { 27, 0, 19, 0, 0 },
/* U+22c3 */ { 27, 0, 19, 0, 0 },
/* U+22c4 */ { 27, 0, 19, 0, 0 },
/* U+22c5 */ { 27, 0, 19, 0, 0 },
/* U+22c6 */ { 27, 0, 19, 0, 0 },
/* U+22c7 */ { 27, 0, 19, 0, 0 },
/* U+22c8 */ { 27, 0, 19, 0, 0 },
/* U+22c9 */ { 27, 0, 19, 1, 0 },
/* U+22ca */ { 27, 0, 19, 1, 0 },
/* U+22cb */ { 27, 0, 19, 1, 0 },
/* U+22cc */ { 27, 0, 19, 1, 0 },
/* U+22cd */ { 27, 0, 19, 1, 0 },
/* U+22ce */ { 27, 0, 19, 0, 0 },
/* U+22cf */ { 27, 0, 19, 0, 0 },
/* U+22d0 */ { 27, 0, 19, 1, 0 },
/* U+22d1 */ { 27, 0, 19, 1, 0 },
/* U+22d2 */ { 27, 0, 19, 0, 0 },
/* U+22d3 */ { 27, 0, 19, 0, 0 },
/* U+22d4 */ { 27, 0, 19, 0, 0 },
/* U+22d5 */ { 27, 0, 19, 0, 0 },
/* U+22d6 */ { 27, 0, 19, 1, 0 },
/* U+22d7 */ { 27, 0, 19, 1, 0 },
/* U+22d8 */ { 27, 0, 19, 1, 0 },
/* U+22d9 */ { 27, 0, 19, 1, 0 },
/* U+22da */ { 27, 0, 19, 1, 0 },
/* U+22db */ { 27, 0, 19, 1, 0 },
/* U+22dc */ { 27, 0, 19, 1, 0 },
/* U+22dd */ { 27, 0, 19, 1, 0 },
/* U+22de */ { 27, 0, 19, 1, 0 },
/* U+22df */ { 27, 0, 19, 1, 0 },
/* U+22e0 */ { 27, 0, 19, 1, "227C 0338" },
/* U+22e1 */ { 27, 0, 19, 1, "227D 0338" },
/* U+22e2 */ { 27, 0, 19, 1, "2291 0338" },
/* U+22e3 */ { 27, 0, 19, 1, "2292 0338" },
/* U+22e4 */ { 27, 0, 19, 1, 0 },
/* U+22e5 */ { 27, 0, 19, 1, 0 },
/* U+22e6 */ { 27, 0, 19, 1, 0 },
/* U+22e7 */ { 27, 0, 19, 1, 0 },
/* U+22e8 */ { 27, 0, 19, 1, 0 },
/* U+22e9 */ { 27, 0, 19, 1, 0 },
/* U+22ea */ { 27, 0, 19, 1, "22B2 0338" },
/* U+22eb */ { 27, 0, 19, 1, "22B3 0338" },
/* U+22ec */ { 27, 0, 19, 1, "22B4 0338" },
/* U+22ed */ { 27, 0, 19, 1, "22B5 0338" },
/* U+22ee */ { 27, 0, 19, 0, 0 },
/* U+22ef */ { 27, 0, 19, 0, 0 },
/* U+22f0 */ { 27, 0, 19, 1, 0 },
/* U+22f1 */ { 27, 0, 19, 1, 0 },
/* U+22f2 */ { 0, 0, 0, 0, 0 },
/* U+22f3 */ { 0, 0, 0, 0, 0 },
/* U+22f4 */ { 0, 0, 0, 0, 0 },
/* U+22f5 */ { 0, 0, 0, 0, 0 },
/* U+22f6 */ { 0, 0, 0, 0, 0 },
/* U+22f7 */ { 0, 0, 0, 0, 0 },
/* U+22f8 */ { 0, 0, 0, 0, 0 },
/* U+22f9 */ { 0, 0, 0, 0, 0 },
/* U+22fa */ { 0, 0, 0, 0, 0 },
/* U+22fb */ { 0, 0, 0, 0, 0 },
/* U+22fc */ { 0, 0, 0, 0, 0 },
/* U+22fd */ { 0, 0, 0, 0, 0 },
/* U+22fe */ { 0, 0, 0, 0, 0 },
/* U+22ff */ { 0, 0, 0, 0, 0 },
/* U+2300 */ { 30, 0, 19, 0, 0 },
/* U+2301 */ { 30, 0, 19, 0, 0 },
/* U+2302 */ { 30, 0, 19, 0, 0 },
/* U+2303 */ { 30, 0, 19, 0, 0 },
/* U+2304 */ { 30, 0, 19, 0, 0 },
/* U+2305 */ { 30, 0, 19, 0, 0 },
/* U+2306 */ { 30, 0, 19, 0, 0 },
/* U+2307 */ { 30, 0, 19, 0, 0 },
/* U+2308 */ { 27, 0, 19, 1, 0 },
/* U+2309 */ { 27, 0, 19, 1, 0 },
/* U+230a */ { 27, 0, 19, 1, 0 },
/* U+230b */ { 27, 0, 19, 1, 0 },
/* U+230c */ { 30, 0, 19, 0, 0 },
/* U+230d */ { 30, 0, 19, 0, 0 },
/* U+230e */ { 30, 0, 19, 0, 0 },
/* U+230f */ { 30, 0, 19, 0, 0 },
/* U+2310 */ { 30, 0, 19, 0, 0 },
/* U+2311 */ { 30, 0, 19, 0, 0 },
/* U+2312 */ { 30, 0, 19, 0, 0 },
/* U+2313 */ { 30, 0, 19, 0, 0 },
/* U+2314 */ { 30, 0, 19, 0, 0 },
/* U+2315 */ { 30, 0, 19, 0, 0 },
/* U+2316 */ { 30, 0, 19, 0, 0 },
/* U+2317 */ { 30, 0, 19, 0, 0 },
/* U+2318 */ { 30, 0, 19, 0, 0 },
/* U+2319 */ { 30, 0, 19, 0, 0 },
/* U+231a */ { 30, 0, 19, 0, 0 },
/* U+231b */ { 30, 0, 19, 0, 0 },
/* U+231c */ { 30, 0, 19, 0, 0 },
/* U+231d */ { 30, 0, 19, 0, 0 },
/* U+231e */ { 30, 0, 19, 0, 0 },
/* U+231f */ { 30, 0, 19, 0, 0 },
/* U+2320 */ { 27, 0, 19, 1, 0 },
/* U+2321 */ { 27, 0, 19, 1, 0 },
/* U+2322 */ { 30, 0, 19, 0, 0 },
/* U+2323 */ { 30, 0, 19, 0, 0 },
/* U+2324 */ { 30, 0, 19, 0, 0 },
/* U+2325 */ { 30, 0, 19, 0, 0 },
/* U+2326 */ { 30, 0, 19, 0, 0 },
/* U+2327 */ { 30, 0, 19, 0, 0 },
/* U+2328 */ { 30, 0, 19, 0, 0 },
/* U+2329 */ { 22, 0, 19, 1, "3008" },
/* U+232a */ { 23, 0, 19, 1, "3009" },
/* U+232b */ { 30, 0, 19, 0, 0 },
/* U+232c */ { 30, 0, 19, 0, 0 },
/* U+232d */ { 30, 0, 19, 0, 0 },
/* U+232e */ { 30, 0, 19, 0, 0 },
/* U+232f */ { 30, 0, 19, 0, 0 },
/* U+2330 */ { 30, 0, 19, 0, 0 },
/* U+2331 */ { 30, 0, 19, 0, 0 },
/* U+2332 */ { 30, 0, 19, 0, 0 },
/* U+2333 */ { 30, 0, 19, 0, 0 },
/* U+2334 */ { 30, 0, 19, 0, 0 },
/* U+2335 */ { 30, 0, 19, 0, 0 },
/* U+2336 */ { 30, 0, 1, 0, 0 },
/* U+2337 */ { 30, 0, 1, 0, 0 },
/* U+2338 */ { 30, 0, 1, 0, 0 },
/* U+2339 */ { 30, 0, 1, 0, 0 },
/* U+233a */ { 30, 0, 1, 0, 0 },
/* U+233b */ { 30, 0, 1, 0, 0 },
/* U+233c */ { 30, 0, 1, 0, 0 },
/* U+233d */ { 30, 0, 1, 0, 0 },
/* U+233e */ { 30, 0, 1, 0, 0 },
/* U+233f */ { 30, 0, 1, 0, 0 },
/* U+2340 */ { 30, 0, 1, 0, 0 },
/* U+2341 */ { 30, 0, 1, 0, 0 },
/* U+2342 */ { 30, 0, 1, 0, 0 },
/* U+2343 */ { 30, 0, 1, 0, 0 },
/* U+2344 */ { 30, 0, 1, 0, 0 },
/* U+2345 */ { 30, 0, 1, 0, 0 },
/* U+2346 */ { 30, 0, 1, 0, 0 },
/* U+2347 */ { 30, 0, 1, 0, 0 },
/* U+2348 */ { 30, 0, 1, 0, 0 },
/* U+2349 */ { 30, 0, 1, 0, 0 },
/* U+234a */ { 30, 0, 1, 0, 0 },
/* U+234b */ { 30, 0, 1, 0, 0 },
/* U+234c */ { 30, 0, 1, 0, 0 },
/* U+234d */ { 30, 0, 1, 0, 0 },
/* U+234e */ { 30, 0, 1, 0, 0 },
/* U+234f */ { 30, 0, 1, 0, 0 },
/* U+2350 */ { 30, 0, 1, 0, 0 },
/* U+2351 */ { 30, 0, 1, 0, 0 },
/* U+2352 */ { 30, 0, 1, 0, 0 },
/* U+2353 */ { 30, 0, 1, 0, 0 },
/* U+2354 */ { 30, 0, 1, 0, 0 },
/* U+2355 */ { 30, 0, 1, 0, 0 },
/* U+2356 */ { 30, 0, 1, 0, 0 },
/* U+2357 */ { 30, 0, 1, 0, 0 },
/* U+2358 */ { 30, 0, 1, 0, 0 },
/* U+2359 */ { 30, 0, 1, 0, 0 },
/* U+235a */ { 30, 0, 1, 0, 0 },
/* U+235b */ { 30, 0, 1, 0, 0 },
/* U+235c */ { 30, 0, 1, 0, 0 },
/* U+235d */ { 30, 0, 1, 0, 0 },
/* U+235e */ { 30, 0, 1, 0, 0 },
/* U+235f */ { 30, 0, 1, 0, 0 },
/* U+2360 */ { 30, 0, 1, 0, 0 },
/* U+2361 */ { 30, 0, 1, 0, 0 },
/* U+2362 */ { 30, 0, 1, 0, 0 },
/* U+2363 */ { 30, 0, 1, 0, 0 },
/* U+2364 */ { 30, 0, 1, 0, 0 },
/* U+2365 */ { 30, 0, 1, 0, 0 },
/* U+2366 */ { 30, 0, 1, 0, 0 },
/* U+2367 */ { 30, 0, 1, 0, 0 },
/* U+2368 */ { 30, 0, 1, 0, 0 },
/* U+2369 */ { 30, 0, 1, 0, 0 },
/* U+236a */ { 30, 0, 1, 0, 0 },
/* U+236b */ { 30, 0, 1, 0, 0 },
/* U+236c */ { 30, 0, 1, 0, 0 },
/* U+236d */ { 30, 0, 1, 0, 0 },
/* U+236e */ { 30, 0, 1, 0, 0 },
/* U+236f */ { 30, 0, 1, 0, 0 },
/* U+2370 */ { 30, 0, 1, 0, 0 },
/* U+2371 */ { 30, 0, 1, 0, 0 },
/* U+2372 */ { 30, 0, 1, 0, 0 },
/* U+2373 */ { 30, 0, 1, 0, 0 },
/* U+2374 */ { 30, 0, 1, 0, 0 },
/* U+2375 */ { 30, 0, 1, 0, 0 },
/* U+2376 */ { 30, 0, 1, 0, 0 },
/* U+2377 */ { 30, 0, 1, 0, 0 },
/* U+2378 */ { 30, 0, 1, 0, 0 },
/* U+2379 */ { 30, 0, 1, 0, 0 },
/* U+237a */ { 30, 0, 1, 0, 0 },
/* U+237b */ { 30, 0, 19, 0, 0 },
/* U+237c */ { 0, 0, 0, 0, 0 },
/* U+237d */ { 30, 0, 19, 0, 0 },
/* U+237e */ { 30, 0, 19, 0, 0 },
/* U+237f */ { 30, 0, 19, 0, 0 },
/* U+2380 */ { 30, 0, 19, 0, 0 },
/* U+2381 */ { 30, 0, 19, 0, 0 },
/* U+2382 */ { 30, 0, 19, 0, 0 },
/* U+2383 */ { 30, 0, 19, 0, 0 },
/* U+2384 */ { 30, 0, 19, 0, 0 },
/* U+2385 */ { 30, 0, 19, 0, 0 },
/* U+2386 */ { 30, 0, 19, 0, 0 },
/* U+2387 */ { 30, 0, 19, 0, 0 },
/* U+2388 */ { 30, 0, 19, 0, 0 },
/* U+2389 */ { 30, 0, 19, 0, 0 },
/* U+238a */ { 30, 0, 19, 0, 0 },
/* U+238b */ { 30, 0, 19, 0, 0 },
/* U+238c */ { 30, 0, 19, 0, 0 },
/* U+238d */ { 30, 0, 19, 0, 0 },
/* U+238e */ { 30, 0, 19, 0, 0 },
/* U+238f */ { 30, 0, 19, 0, 0 },
/* U+2390 */ { 30, 0, 19, 0, 0 },
/* U+2391 */ { 30, 0, 19, 0, 0 },
/* U+2392 */ { 30, 0, 19, 0, 0 },
/* U+2393 */ { 30, 0, 19, 0, 0 },
/* U+2394 */ { 30, 0, 19, 0, 0 },
/* U+2395 */ { 30, 0, 1, 0, 0 },
/* U+2396 */ { 30, 0, 19, 0, 0 },
/* U+2397 */ { 30, 0, 19, 0, 0 },
/* U+2398 */ { 30, 0, 19, 0, 0 },
/* U+2399 */ { 30, 0, 19, 0, 0 },
/* U+239a */ { 30, 0, 19, 0, 0 },
/* U+239b */ { 0, 0, 0, 0, 0 },
/* U+239c */ { 0, 0, 0, 0, 0 },
/* U+239d */ { 0, 0, 0, 0, 0 },
/* U+239e */ { 0, 0, 0, 0, 0 },
/* U+239f */ { 0, 0, 0, 0, 0 },
/* U+23a0 */ { 0, 0, 0, 0, 0 },
/* U+23a1 */ { 0, 0, 0, 0, 0 },
/* U+23a2 */ { 0, 0, 0, 0, 0 },
/* U+23a3 */ { 0, 0, 0, 0, 0 },
/* U+23a4 */ { 0, 0, 0, 0, 0 },
/* U+23a5 */ { 0, 0, 0, 0, 0 },
/* U+23a6 */ { 0, 0, 0, 0, 0 },
/* U+23a7 */ { 0, 0, 0, 0, 0 },
/* U+23a8 */ { 0, 0, 0, 0, 0 },
/* U+23a9 */ { 0, 0, 0, 0, 0 },
/* U+23aa */ { 0, 0, 0, 0, 0 },
/* U+23ab */ { 0, 0, 0, 0, 0 },
/* U+23ac */ { 0, 0, 0, 0, 0 },
/* U+23ad */ { 0, 0, 0, 0, 0 },
/* U+23ae */ { 0, 0, 0, 0, 0 },
/* U+23af */ { 0, 0, 0, 0, 0 },
/* U+23b0 */ { 0, 0, 0, 0, 0 },
/* U+23b1 */ { 0, 0, 0, 0, 0 },
/* U+23b2 */ { 0, 0, 0, 0, 0 },
/* U+23b3 */ { 0, 0, 0, 0, 0 },
/* U+23b4 */ { 0, 0, 0, 0, 0 },
/* U+23b5 */ { 0, 0, 0, 0, 0 },
/* U+23b6 */ { 0, 0, 0, 0, 0 },
/* U+23b7 */ { 0, 0, 0, 0, 0 },
/* U+23b8 */ { 0, 0, 0, 0, 0 },
/* U+23b9 */ { 0, 0, 0, 0, 0 },
/* U+23ba */ { 0, 0, 0, 0, 0 },
/* U+23bb */ { 0, 0, 0, 0, 0 },
/* U+23bc */ { 0, 0, 0, 0, 0 },
/* U+23bd */ { 0, 0, 0, 0, 0 },
/* U+23be */ { 0, 0, 0, 0, 0 },
/* U+23bf */ { 0, 0, 0, 0, 0 },
/* U+23c0 */ { 0, 0, 0, 0, 0 },
/* U+23c1 */ { 0, 0, 0, 0, 0 },
/* U+23c2 */ { 0, 0, 0, 0, 0 },
/* U+23c3 */ { 0, 0, 0, 0, 0 },
/* U+23c4 */ { 0, 0, 0, 0, 0 },
/* U+23c5 */ { 0, 0, 0, 0, 0 },
/* U+23c6 */ { 0, 0, 0, 0, 0 },
/* U+23c7 */ { 0, 0, 0, 0, 0 },
/* U+23c8 */ { 0, 0, 0, 0, 0 },
/* U+23c9 */ { 0, 0, 0, 0, 0 },
/* U+23ca */ { 0, 0, 0, 0, 0 },
/* U+23cb */ { 0, 0, 0, 0, 0 },
/* U+23cc */ { 0, 0, 0, 0, 0 },
/* U+23cd */ { 0, 0, 0, 0, 0 },
/* U+23ce */ { 0, 0, 0, 0, 0 },
/* U+23cf */ { 0, 0, 0, 0, 0 },
/* U+23d0 */ { 0, 0, 0, 0, 0 },
/* U+23d1 */ { 0, 0, 0, 0, 0 },
/* U+23d2 */ { 0, 0, 0, 0, 0 },
/* U+23d3 */ { 0, 0, 0, 0, 0 },
/* U+23d4 */ { 0, 0, 0, 0, 0 },
/* U+23d5 */ { 0, 0, 0, 0, 0 },
/* U+23d6 */ { 0, 0, 0, 0, 0 },
/* U+23d7 */ { 0, 0, 0, 0, 0 },
/* U+23d8 */ { 0, 0, 0, 0, 0 },
/* U+23d9 */ { 0, 0, 0, 0, 0 },
/* U+23da */ { 0, 0, 0, 0, 0 },
/* U+23db */ { 0, 0, 0, 0, 0 },
/* U+23dc */ { 0, 0, 0, 0, 0 },
/* U+23dd */ { 0, 0, 0, 0, 0 },
/* U+23de */ { 0, 0, 0, 0, 0 },
/* U+23df */ { 0, 0, 0, 0, 0 },
/* U+23e0 */ { 0, 0, 0, 0, 0 },
/* U+23e1 */ { 0, 0, 0, 0, 0 },
/* U+23e2 */ { 0, 0, 0, 0, 0 },
/* U+23e3 */ { 0, 0, 0, 0, 0 },
/* U+23e4 */ { 0, 0, 0, 0, 0 },
/* U+23e5 */ { 0, 0, 0, 0, 0 },
/* U+23e6 */ { 0, 0, 0, 0, 0 },
/* U+23e7 */ { 0, 0, 0, 0, 0 },
/* U+23e8 */ { 0, 0, 0, 0, 0 },
/* U+23e9 */ { 0, 0, 0, 0, 0 },
/* U+23ea */ { 0, 0, 0, 0, 0 },
/* U+23eb */ { 0, 0, 0, 0, 0 },
/* U+23ec */ { 0, 0, 0, 0, 0 },
/* U+23ed */ { 0, 0, 0, 0, 0 },
/* U+23ee */ { 0, 0, 0, 0, 0 },
/* U+23ef */ { 0, 0, 0, 0, 0 },
/* U+23f0 */ { 0, 0, 0, 0, 0 },
/* U+23f1 */ { 0, 0, 0, 0, 0 },
/* U+23f2 */ { 0, 0, 0, 0, 0 },
/* U+23f3 */ { 0, 0, 0, 0, 0 },
/* U+23f4 */ { 0, 0, 0, 0, 0 },
/* U+23f5 */ { 0, 0, 0, 0, 0 },
/* U+23f6 */ { 0, 0, 0, 0, 0 },
/* U+23f7 */ { 0, 0, 0, 0, 0 },
/* U+23f8 */ { 0, 0, 0, 0, 0 },
/* U+23f9 */ { 0, 0, 0, 0, 0 },
/* U+23fa */ { 0, 0, 0, 0, 0 },
/* U+23fb */ { 0, 0, 0, 0, 0 },
/* U+23fc */ { 0, 0, 0, 0, 0 },
/* U+23fd */ { 0, 0, 0, 0, 0 },
/* U+23fe */ { 0, 0, 0, 0, 0 },
/* U+23ff */ { 0, 0, 0, 0, 0 },
/* U+2400 */ { 30, 0, 19, 0, 0 },
/* U+2401 */ { 30, 0, 19, 0, 0 },
/* U+2402 */ { 30, 0, 19, 0, 0 },
/* U+2403 */ { 30, 0, 19, 0, 0 },
/* U+2404 */ { 30, 0, 19, 0, 0 },
/* U+2405 */ { 30, 0, 19, 0, 0 },
/* U+2406 */ { 30, 0, 19, 0, 0 },
/* U+2407 */ { 30, 0, 19, 0, 0 },
/* U+2408 */ { 30, 0, 19, 0, 0 },
/* U+2409 */ { 30, 0, 19, 0, 0 },
/* U+240a */ { 30, 0, 19, 0, 0 },
/* U+240b */ { 30, 0, 19, 0, 0 },
/* U+240c */ { 30, 0, 19, 0, 0 },
/* U+240d */ { 30, 0, 19, 0, 0 },
/* U+240e */ { 30, 0, 19, 0, 0 },
/* U+240f */ { 30, 0, 19, 0, 0 },
/* U+2410 */ { 30, 0, 19, 0, 0 },
/* U+2411 */ { 30, 0, 19, 0, 0 },
/* U+2412 */ { 30, 0, 19, 0, 0 },
/* U+2413 */ { 30, 0, 19, 0, 0 },
/* U+2414 */ { 30, 0, 19, 0, 0 },
/* U+2415 */ { 30, 0, 19, 0, 0 },
/* U+2416 */ { 30, 0, 19, 0, 0 },
/* U+2417 */ { 30, 0, 19, 0, 0 },
/* U+2418 */ { 30, 0, 19, 0, 0 },
/* U+2419 */ { 30, 0, 19, 0, 0 },
/* U+241a */ { 30, 0, 19, 0, 0 },
/* U+241b */ { 30, 0, 19, 0, 0 },
/* U+241c */ { 30, 0, 19, 0, 0 },
/* U+241d */ { 30, 0, 19, 0, 0 },
/* U+241e */ { 30, 0, 19, 0, 0 },
/* U+241f */ { 30, 0, 19, 0, 0 },
/* U+2420 */ { 30, 0, 19, 0, 0 },
/* U+2421 */ { 30, 0, 19, 0, 0 },
/* U+2422 */ { 30, 0, 19, 0, 0 },
/* U+2423 */ { 30, 0, 19, 0, 0 },
/* U+2424 */ { 30, 0, 19, 0, 0 },
/* U+2425 */ { 30, 0, 19, 0, 0 },
/* U+2426 */ { 30, 0, 19, 0, 0 },
/* U+2427 */ { 0, 0, 0, 0, 0 },
/* U+2428 */ { 0, 0, 0, 0, 0 },
/* U+2429 */ { 0, 0, 0, 0, 0 },
/* U+242a */ { 0, 0, 0, 0, 0 },
/* U+242b */ { 0, 0, 0, 0, 0 },
/* U+242c */ { 0, 0, 0, 0, 0 },
/* U+242d */ { 0, 0, 0, 0, 0 },
/* U+242e */ { 0, 0, 0, 0, 0 },
/* U+242f */ { 0, 0, 0, 0, 0 },
/* U+2430 */ { 0, 0, 0, 0, 0 },
/* U+2431 */ { 0, 0, 0, 0, 0 },
/* U+2432 */ { 0, 0, 0, 0, 0 },
/* U+2433 */ { 0, 0, 0, 0, 0 },
/* U+2434 */ { 0, 0, 0, 0, 0 },
/* U+2435 */ { 0, 0, 0, 0, 0 },
/* U+2436 */ { 0, 0, 0, 0, 0 },
/* U+2437 */ { 0, 0, 0, 0, 0 },
/* U+2438 */ { 0, 0, 0, 0, 0 },
/* U+2439 */ { 0, 0, 0, 0, 0 },
/* U+243a */ { 0, 0, 0, 0, 0 },
/* U+243b */ { 0, 0, 0, 0, 0 },
/* U+243c */ { 0, 0, 0, 0, 0 },
/* U+243d */ { 0, 0, 0, 0, 0 },
/* U+243e */ { 0, 0, 0, 0, 0 },
/* U+243f */ { 0, 0, 0, 0, 0 },
/* U+2440 */ { 30, 0, 19, 0, 0 },
/* U+2441 */ { 30, 0, 19, 0, 0 },
/* U+2442 */ { 30, 0, 19, 0, 0 },
/* U+2443 */ { 30, 0, 19, 0, 0 },
/* U+2444 */ { 30, 0, 19, 0, 0 },
/* U+2445 */ { 30, 0, 19, 0, 0 },
/* U+2446 */ { 30, 0, 19, 0, 0 },
/* U+2447 */ { 30, 0, 19, 0, 0 },
/* U+2448 */ { 30, 0, 19, 0, 0 },
/* U+2449 */ { 30, 0, 19, 0, 0 },
/* U+244a */ { 30, 0, 19, 0, 0 },
/* U+244b */ { 0, 0, 0, 0, 0 },
/* U+244c */ { 0, 0, 0, 0, 0 },
/* U+244d */ { 0, 0, 0, 0, 0 },
/* U+244e */ { 0, 0, 0, 0, 0 },
/* U+244f */ { 0, 0, 0, 0, 0 },
/* U+2450 */ { 0, 0, 0, 0, 0 },
/* U+2451 */ { 0, 0, 0, 0, 0 },
/* U+2452 */ { 0, 0, 0, 0, 0 },
/* U+2453 */ { 0, 0, 0, 0, 0 },
/* U+2454 */ { 0, 0, 0, 0, 0 },
/* U+2455 */ { 0, 0, 0, 0, 0 },
/* U+2456 */ { 0, 0, 0, 0, 0 },
/* U+2457 */ { 0, 0, 0, 0, 0 },
/* U+2458 */ { 0, 0, 0, 0, 0 },
/* U+2459 */ { 0, 0, 0, 0, 0 },
/* U+245a */ { 0, 0, 0, 0, 0 },
/* U+245b */ { 0, 0, 0, 0, 0 },
/* U+245c */ { 0, 0, 0, 0, 0 },
/* U+245d */ { 0, 0, 0, 0, 0 },
/* U+245e */ { 0, 0, 0, 0, 0 },
/* U+245f */ { 0, 0, 0, 0, 0 },
/* U+2460 */ { 9, 0, 9, 0, "<circle> 0031" },
/* U+2461 */ { 9, 0, 9, 0, "<circle> 0032" },
/* U+2462 */ { 9, 0, 9, 0, "<circle> 0033" },
/* U+2463 */ { 9, 0, 9, 0, "<circle> 0034" },
/* U+2464 */ { 9, 0, 9, 0, "<circle> 0035" },
/* U+2465 */ { 9, 0, 9, 0, "<circle> 0036" },
/* U+2466 */ { 9, 0, 9, 0, "<circle> 0037" },
/* U+2467 */ { 9, 0, 9, 0, "<circle> 0038" },
/* U+2468 */ { 9, 0, 9, 0, "<circle> 0039" },
/* U+2469 */ { 9, 0, 9, 0, "<circle> 0031 0030" },
/* U+246a */ { 9, 0, 9, 0, "<circle> 0031 0031" },
/* U+246b */ { 9, 0, 9, 0, "<circle> 0031 0032" },
/* U+246c */ { 9, 0, 9, 0, "<circle> 0031 0033" },
/* U+246d */ { 9, 0, 9, 0, "<circle> 0031 0034" },
/* U+246e */ { 9, 0, 9, 0, "<circle> 0031 0035" },
/* U+246f */ { 9, 0, 9, 0, "<circle> 0031 0036" },
/* U+2470 */ { 9, 0, 9, 0, "<circle> 0031 0037" },
/* U+2471 */ { 9, 0, 9, 0, "<circle> 0031 0038" },
/* U+2472 */ { 9, 0, 9, 0, "<circle> 0031 0039" },
/* U+2473 */ { 9, 0, 9, 0, "<circle> 0032 0030" },
/* U+2474 */ { 9, 0, 9, 0, "<compat> 0028 0031 0029" },
/* U+2475 */ { 9, 0, 9, 0, "<compat> 0028 0032 0029" },
/* U+2476 */ { 9, 0, 9, 0, "<compat> 0028 0033 0029" },
/* U+2477 */ { 9, 0, 9, 0, "<compat> 0028 0034 0029" },
/* U+2478 */ { 9, 0, 9, 0, "<compat> 0028 0035 0029" },
/* U+2479 */ { 9, 0, 9, 0, "<compat> 0028 0036 0029" },
/* U+247a */ { 9, 0, 9, 0, "<compat> 0028 0037 0029" },
/* U+247b */ { 9, 0, 9, 0, "<compat> 0028 0038 0029" },
/* U+247c */ { 9, 0, 9, 0, "<compat> 0028 0039 0029" },
/* U+247d */ { 9, 0, 9, 0, "<compat> 0028 0031 0030 0029" },
/* U+247e */ { 9, 0, 9, 0, "<compat> 0028 0031 0031 0029" },
/* U+247f */ { 9, 0, 9, 0, "<compat> 0028 0031 0032 0029" },
/* U+2480 */ { 9, 0, 9, 0, "<compat> 0028 0031 0033 0029" },
/* U+2481 */ { 9, 0, 9, 0, "<compat> 0028 0031 0034 0029" },
/* U+2482 */ { 9, 0, 9, 0, "<compat> 0028 0031 0035 0029" },
/* U+2483 */ { 9, 0, 9, 0, "<compat> 0028 0031 0036 0029" },
/* U+2484 */ { 9, 0, 9, 0, "<compat> 0028 0031 0037 0029" },
/* U+2485 */ { 9, 0, 9, 0, "<compat> 0028 0031 0038 0029" },
/* U+2486 */ { 9, 0, 9, 0, "<compat> 0028 0031 0039 0029" },
/* U+2487 */ { 9, 0, 9, 0, "<compat> 0028 0032 0030 0029" },
/* U+2488 */ { 9, 0, 9, 0, "<compat> 0031 002E" },
/* U+2489 */ { 9, 0, 9, 0, "<compat> 0032 002E" },
/* U+248a */ { 9, 0, 9, 0, "<compat> 0033 002E" },
/* U+248b */ { 9, 0, 9, 0, "<compat> 0034 002E" },
/* U+248c */ { 9, 0, 9, 0, "<compat> 0035 002E" },
/* U+248d */ { 9, 0, 9, 0, "<compat> 0036 002E" },
/* U+248e */ { 9, 0, 9, 0, "<compat> 0037 002E" },
/* U+248f */ { 9, 0, 9, 0, "<compat> 0038 002E" },
/* U+2490 */ { 9, 0, 9, 0, "<compat> 0039 002E" },
/* U+2491 */ { 9, 0, 9, 0, "<compat> 0031 0030 002E" },
/* U+2492 */ { 9, 0, 9, 0, "<compat> 0031 0031 002E" },
/* U+2493 */ { 9, 0, 9, 0, "<compat> 0031 0032 002E" },
/* U+2494 */ { 9, 0, 9, 0, "<compat> 0031 0033 002E" },
/* U+2495 */ { 9, 0, 9, 0, "<compat> 0031 0034 002E" },
/* U+2496 */ { 9, 0, 9, 0, "<compat> 0031 0035 002E" },
/* U+2497 */ { 9, 0, 9, 0, "<compat> 0031 0036 002E" },
/* U+2498 */ { 9, 0, 9, 0, "<compat> 0031 0037 002E" },
/* U+2499 */ { 9, 0, 9, 0, "<compat> 0031 0038 002E" },
/* U+249a */ { 9, 0, 9, 0, "<compat> 0031 0039 002E" },
/* U+249b */ { 9, 0, 9, 0, "<compat> 0032 0030 002E" },
/* U+249c */ { 30, 0, 1, 0, "<compat> 0028 0061 0029" },
/* U+249d */ { 30, 0, 1, 0, "<compat> 0028 0062 0029" },
/* U+249e */ { 30, 0, 1, 0, "<compat> 0028 0063 0029" },
/* U+249f */ { 30, 0, 1, 0, "<compat> 0028 0064 0029" },
/* U+24a0 */ { 30, 0, 1, 0, "<compat> 0028 0065 0029" },
/* U+24a1 */ { 30, 0, 1, 0, "<compat> 0028 0066 0029" },
/* U+24a2 */ { 30, 0, 1, 0, "<compat> 0028 0067 0029" },
/* U+24a3 */ { 30, 0, 1, 0, "<compat> 0028 0068 0029" },
/* U+24a4 */ { 30, 0, 1, 0, "<compat> 0028 0069 0029" },
/* U+24a5 */ { 30, 0, 1, 0, "<compat> 0028 006A 0029" },
/* U+24a6 */ { 30, 0, 1, 0, "<compat> 0028 006B 0029" },
/* U+24a7 */ { 30, 0, 1, 0, "<compat> 0028 006C 0029" },
/* U+24a8 */ { 30, 0, 1, 0, "<compat> 0028 006D 0029" },
/* U+24a9 */ { 30, 0, 1, 0, "<compat> 0028 006E 0029" },
/* U+24aa */ { 30, 0, 1, 0, "<compat> 0028 006F 0029" },
/* U+24ab */ { 30, 0, 1, 0, "<compat> 0028 0070 0029" },
/* U+24ac */ { 30, 0, 1, 0, "<compat> 0028 0071 0029" },
/* U+24ad */ { 30, 0, 1, 0, "<compat> 0028 0072 0029" },
/* U+24ae */ { 30, 0, 1, 0, "<compat> 0028 0073 0029" },
/* U+24af */ { 30, 0, 1, 0, "<compat> 0028 0074 0029" },
/* U+24b0 */ { 30, 0, 1, 0, "<compat> 0028 0075 0029" },
/* U+24b1 */ { 30, 0, 1, 0, "<compat> 0028 0076 0029" },
/* U+24b2 */ { 30, 0, 1, 0, "<compat> 0028 0077 0029" },
/* U+24b3 */ { 30, 0, 1, 0, "<compat> 0028 0078 0029" },
/* U+24b4 */ { 30, 0, 1, 0, "<compat> 0028 0079 0029" },
/* U+24b5 */ { 30, 0, 1, 0, "<compat> 0028 007A 0029" },
/* U+24b6 */ { 30, 0, 1, 0, "<circle> 0041" },
/* U+24b7 */ { 30, 0, 1, 0, "<circle> 0042" },
/* U+24b8 */ { 30, 0, 1, 0, "<circle> 0043" },
/* U+24b9 */ { 30, 0, 1, 0, "<circle> 0044" },
/* U+24ba */ { 30, 0, 1, 0, "<circle> 0045" },
/* U+24bb */ { 30, 0, 1, 0, "<circle> 0046" },
/* U+24bc */ { 30, 0, 1, 0, "<circle> 0047" },
/* U+24bd */ { 30, 0, 1, 0, "<circle> 0048" },
/* U+24be */ { 30, 0, 1, 0, "<circle> 0049" },
/* U+24bf */ { 30, 0, 1, 0, "<circle> 004A" },
/* U+24c0 */ { 30, 0, 1, 0, "<circle> 004B" },
/* U+24c1 */ { 30, 0, 1, 0, "<circle> 004C" },
/* U+24c2 */ { 30, 0, 1, 0, "<circle> 004D" },
/* U+24c3 */ { 30, 0, 1, 0, "<circle> 004E" },
/* U+24c4 */ { 30, 0, 1, 0, "<circle> 004F" },
/* U+24c5 */ { 30, 0, 1, 0, "<circle> 0050" },
/* U+24c6 */ { 30, 0, 1, 0, "<circle> 0051" },
/* U+24c7 */ { 30, 0, 1, 0, "<circle> 0052" },
/* U+24c8 */ { 30, 0, 1, 0, "<circle> 0053" },
/* U+24c9 */ { 30, 0, 1, 0, "<circle> 0054" },
/* U+24ca */ { 30, 0, 1, 0, "<circle> 0055" },
/* U+24cb */ { 30, 0, 1, 0, "<circle> 0056" },
/* U+24cc */ { 30, 0, 1, 0, "<circle> 0057" },
/* U+24cd */ { 30, 0, 1, 0, "<circle> 0058" },
/* U+24ce */ { 30, 0, 1, 0, "<circle> 0059" },
/* U+24cf */ { 30, 0, 1, 0, "<circle> 005A" },
/* U+24d0 */ { 30, 0, 1, 0, "<circle> 0061" },
/* U+24d1 */ { 30, 0, 1, 0, "<circle> 0062" },
/* U+24d2 */ { 30, 0, 1, 0, "<circle> 0063" },
/* U+24d3 */ { 30, 0, 1, 0, "<circle> 0064" },
/* U+24d4 */ { 30, 0, 1, 0, "<circle> 0065" },
/* U+24d5 */ { 30, 0, 1, 0, "<circle> 0066" },
/* U+24d6 */ { 30, 0, 1, 0, "<circle> 0067" },
/* U+24d7 */ { 30, 0, 1, 0, "<circle> 0068" },
/* U+24d8 */ { 30, 0, 1, 0, "<circle> 0069" },
/* U+24d9 */ { 30, 0, 1, 0, "<circle> 006A" },
/* U+24da */ { 30, 0, 1, 0, "<circle> 006B" },
/* U+24db */ { 30, 0, 1, 0, "<circle> 006C" },
/* U+24dc */ { 30, 0, 1, 0, "<circle> 006D" },
/* U+24dd */ { 30, 0, 1, 0, "<circle> 006E" },
/* U+24de */ { 30, 0, 1, 0, "<circle> 006F" },
/* U+24df */ { 30, 0, 1, 0, "<circle> 0070" },
/* U+24e0 */ { 30, 0, 1, 0, "<circle> 0071" },
/* U+24e1 */ { 30, 0, 1, 0, "<circle> 0072" },
/* U+24e2 */ { 30, 0, 1, 0, "<circle> 0073" },
/* U+24e3 */ { 30, 0, 1, 0, "<circle> 0074" },
/* U+24e4 */ { 30, 0, 1, 0, "<circle> 0075" },
/* U+24e5 */ { 30, 0, 1, 0, "<circle> 0076" },
/* U+24e6 */ { 30, 0, 1, 0, "<circle> 0077" },
/* U+24e7 */ { 30, 0, 1, 0, "<circle> 0078" },
/* U+24e8 */ { 30, 0, 1, 0, "<circle> 0079" },
/* U+24e9 */ { 30, 0, 1, 0, "<circle> 007A" },
/* U+24ea */ { 9, 0, 9, 0, "<circle> 0030" },
/* U+24eb */ { 0, 0, 0, 0, 0 },
/* U+24ec */ { 0, 0, 0, 0, 0 },
/* U+24ed */ { 0, 0, 0, 0, 0 },
/* U+24ee */ { 0, 0, 0, 0, 0 },
/* U+24ef */ { 0, 0, 0, 0, 0 },
/* U+24f0 */ { 0, 0, 0, 0, 0 },
/* U+24f1 */ { 0, 0, 0, 0, 0 },
/* U+24f2 */ { 0, 0, 0, 0, 0 },
/* U+24f3 */ { 0, 0, 0, 0, 0 },
/* U+24f4 */ { 0, 0, 0, 0, 0 },
/* U+24f5 */ { 0, 0, 0, 0, 0 },
/* U+24f6 */ { 0, 0, 0, 0, 0 },
/* U+24f7 */ { 0, 0, 0, 0, 0 },
/* U+24f8 */ { 0, 0, 0, 0, 0 },
/* U+24f9 */ { 0, 0, 0, 0, 0 },
/* U+24fa */ { 0, 0, 0, 0, 0 },
/* U+24fb */ { 0, 0, 0, 0, 0 },
/* U+24fc */ { 0, 0, 0, 0, 0 },
/* U+24fd */ { 0, 0, 0, 0, 0 },
/* U+24fe */ { 0, 0, 0, 0, 0 },
/* U+24ff */ { 0, 0, 0, 0, 0 },
/* U+2500 */ { 30, 0, 19, 0, 0 },
/* U+2501 */ { 30, 0, 19, 0, 0 },
/* U+2502 */ { 30, 0, 19, 0, 0 },
/* U+2503 */ { 30, 0, 19, 0, 0 },
/* U+2504 */ { 30, 0, 19, 0, 0 },
/* U+2505 */ { 30, 0, 19, 0, 0 },
/* U+2506 */ { 30, 0, 19, 0, 0 },
/* U+2507 */ { 30, 0, 19, 0, 0 },
/* U+2508 */ { 30, 0, 19, 0, 0 },
/* U+2509 */ { 30, 0, 19, 0, 0 },
/* U+250a */ { 30, 0, 19, 0, 0 },
/* U+250b */ { 30, 0, 19, 0, 0 },
/* U+250c */ { 30, 0, 19, 0, 0 },
/* U+250d */ { 30, 0, 19, 0, 0 },
/* U+250e */ { 30, 0, 19, 0, 0 },
/* U+250f */ { 30, 0, 19, 0, 0 },
/* U+2510 */ { 30, 0, 19, 0, 0 },
/* U+2511 */ { 30, 0, 19, 0, 0 },
/* U+2512 */ { 30, 0, 19, 0, 0 },
/* U+2513 */ { 30, 0, 19, 0, 0 },
/* U+2514 */ { 30, 0, 19, 0, 0 },
/* U+2515 */ { 30, 0, 19, 0, 0 },
/* U+2516 */ { 30, 0, 19, 0, 0 },
/* U+2517 */ { 30, 0, 19, 0, 0 },
/* U+2518 */ { 30, 0, 19, 0, 0 },
/* U+2519 */ { 30, 0, 19, 0, 0 },
/* U+251a */ { 30, 0, 19, 0, 0 },
/* U+251b */ { 30, 0, 19, 0, 0 },
/* U+251c */ { 30, 0, 19, 0, 0 },
/* U+251d */ { 30, 0, 19, 0, 0 },
/* U+251e */ { 30, 0, 19, 0, 0 },
/* U+251f */ { 30, 0, 19, 0, 0 },
/* U+2520 */ { 30, 0, 19, 0, 0 },
/* U+2521 */ { 30, 0, 19, 0, 0 },
/* U+2522 */ { 30, 0, 19, 0, 0 },
/* U+2523 */ { 30, 0, 19, 0, 0 },
/* U+2524 */ { 30, 0, 19, 0, 0 },
/* U+2525 */ { 30, 0, 19, 0, 0 },
/* U+2526 */ { 30, 0, 19, 0, 0 },
/* U+2527 */ { 30, 0, 19, 0, 0 },
/* U+2528 */ { 30, 0, 19, 0, 0 },
/* U+2529 */ { 30, 0, 19, 0, 0 },
/* U+252a */ { 30, 0, 19, 0, 0 },
/* U+252b */ { 30, 0, 19, 0, 0 },
/* U+252c */ { 30, 0, 19, 0, 0 },
/* U+252d */ { 30, 0, 19, 0, 0 },
/* U+252e */ { 30, 0, 19, 0, 0 },
/* U+252f */ { 30, 0, 19, 0, 0 },
/* U+2530 */ { 30, 0, 19, 0, 0 },
/* U+2531 */ { 30, 0, 19, 0, 0 },
/* U+2532 */ { 30, 0, 19, 0, 0 },
/* U+2533 */ { 30, 0, 19, 0, 0 },
/* U+2534 */ { 30, 0, 19, 0, 0 },
/* U+2535 */ { 30, 0, 19, 0, 0 },
/* U+2536 */ { 30, 0, 19, 0, 0 },
/* U+2537 */ { 30, 0, 19, 0, 0 },
/* U+2538 */ { 30, 0, 19, 0, 0 },
/* U+2539 */ { 30, 0, 19, 0, 0 },
/* U+253a */ { 30, 0, 19, 0, 0 },
/* U+253b */ { 30, 0, 19, 0, 0 },
/* U+253c */ { 30, 0, 19, 0, 0 },
/* U+253d */ { 30, 0, 19, 0, 0 },
/* U+253e */ { 30, 0, 19, 0, 0 },
/* U+253f */ { 30, 0, 19, 0, 0 },
/* U+2540 */ { 30, 0, 19, 0, 0 },
/* U+2541 */ { 30, 0, 19, 0, 0 },
/* U+2542 */ { 30, 0, 19, 0, 0 },
/* U+2543 */ { 30, 0, 19, 0, 0 },
/* U+2544 */ { 30, 0, 19, 0, 0 },
/* U+2545 */ { 30, 0, 19, 0, 0 },
/* U+2546 */ { 30, 0, 19, 0, 0 },
/* U+2547 */ { 30, 0, 19, 0, 0 },
/* U+2548 */ { 30, 0, 19, 0, 0 },
/* U+2549 */ { 30, 0, 19, 0, 0 },
/* U+254a */ { 30, 0, 19, 0, 0 },
/* U+254b */ { 30, 0, 19, 0, 0 },
/* U+254c */ { 30, 0, 19, 0, 0 },
/* U+254d */ { 30, 0, 19, 0, 0 },
/* U+254e */ { 30, 0, 19, 0, 0 },
/* U+254f */ { 30, 0, 19, 0, 0 },
/* U+2550 */ { 30, 0, 19, 0, 0 },
/* U+2551 */ { 30, 0, 19, 0, 0 },
/* U+2552 */ { 30, 0, 19, 0, 0 },
/* U+2553 */ { 30, 0, 19, 0, 0 },
/* U+2554 */ { 30, 0, 19, 0, 0 },
/* U+2555 */ { 30, 0, 19, 0, 0 },
/* U+2556 */ { 30, 0, 19, 0, 0 },
/* U+2557 */ { 30, 0, 19, 0, 0 },
/* U+2558 */ { 30, 0, 19, 0, 0 },
/* U+2559 */ { 30, 0, 19, 0, 0 },
/* U+255a */ { 30, 0, 19, 0, 0 },
/* U+255b */ { 30, 0, 19, 0, 0 },
/* U+255c */ { 30, 0, 19, 0, 0 },
/* U+255d */ { 30, 0, 19, 0, 0 },
/* U+255e */ { 30, 0, 19, 0, 0 },
/* U+255f */ { 30, 0, 19, 0, 0 },
/* U+2560 */ { 30, 0, 19, 0, 0 },
/* U+2561 */ { 30, 0, 19, 0, 0 },
/* U+2562 */ { 30, 0, 19, 0, 0 },
/* U+2563 */ { 30, 0, 19, 0, 0 },
/* U+2564 */ { 30, 0, 19, 0, 0 },
/* U+2565 */ { 30, 0, 19, 0, 0 },
/* U+2566 */ { 30, 0, 19, 0, 0 },
/* U+2567 */ { 30, 0, 19, 0, 0 },
/* U+2568 */ { 30, 0, 19, 0, 0 },
/* U+2569 */ { 30, 0, 19, 0, 0 },
/* U+256a */ { 30, 0, 19, 0, 0 },
/* U+256b */ { 30, 0, 19, 0, 0 },
/* U+256c */ { 30, 0, 19, 0, 0 },
/* U+256d */ { 30, 0, 19, 0, 0 },
/* U+256e */ { 30, 0, 19, 0, 0 },
/* U+256f */ { 30, 0, 19, 0, 0 },
/* U+2570 */ { 30, 0, 19, 0, 0 },
/* U+2571 */ { 30, 0, 19, 0, 0 },
/* U+2572 */ { 30, 0, 19, 0, 0 },
/* U+2573 */ { 30, 0, 19, 0, 0 },
/* U+2574 */ { 30, 0, 19, 0, 0 },
/* U+2575 */ { 30, 0, 19, 0, 0 },
/* U+2576 */ { 30, 0, 19, 0, 0 },
/* U+2577 */ { 30, 0, 19, 0, 0 },
/* U+2578 */ { 30, 0, 19, 0, 0 },
/* U+2579 */ { 30, 0, 19, 0, 0 },
/* U+257a */ { 30, 0, 19, 0, 0 },
/* U+257b */ { 30, 0, 19, 0, 0 },
/* U+257c */ { 30, 0, 19, 0, 0 },
/* U+257d */ { 30, 0, 19, 0, 0 },
/* U+257e */ { 30, 0, 19, 0, 0 },
/* U+257f */ { 30, 0, 19, 0, 0 },
/* U+2580 */ { 30, 0, 19, 0, 0 },
/* U+2581 */ { 30, 0, 19, 0, 0 },
/* U+2582 */ { 30, 0, 19, 0, 0 },
/* U+2583 */ { 30, 0, 19, 0, 0 },
/* U+2584 */ { 30, 0, 19, 0, 0 },
/* U+2585 */ { 30, 0, 19, 0, 0 },
/* U+2586 */ { 30, 0, 19, 0, 0 },
/* U+2587 */ { 30, 0, 19, 0, 0 },
/* U+2588 */ { 30, 0, 19, 0, 0 },
/* U+2589 */ { 30, 0, 19, 0, 0 },
/* U+258a */ { 30, 0, 19, 0, 0 },
/* U+258b */ { 30, 0, 19, 0, 0 },
/* U+258c */ { 30, 0, 19, 0, 0 },
/* U+258d */ { 30, 0, 19, 0, 0 },
/* U+258e */ { 30, 0, 19, 0, 0 },
/* U+258f */ { 30, 0, 19, 0, 0 },
/* U+2590 */ { 30, 0, 19, 0, 0 },
/* U+2591 */ { 30, 0, 19, 0, 0 },
/* U+2592 */ { 30, 0, 19, 0, 0 },
/* U+2593 */ { 30, 0, 19, 0, 0 },
/* U+2594 */ { 30, 0, 19, 0, 0 },
/* U+2595 */ { 30, 0, 19, 0, 0 },
/* U+2596 */ { 0, 0, 0, 0, 0 },
/* U+2597 */ { 0, 0, 0, 0, 0 },
/* U+2598 */ { 0, 0, 0, 0, 0 },
/* U+2599 */ { 0, 0, 0, 0, 0 },
/* U+259a */ { 0, 0, 0, 0, 0 },
/* U+259b */ { 0, 0, 0, 0, 0 },
/* U+259c */ { 0, 0, 0, 0, 0 },
/* U+259d */ { 0, 0, 0, 0, 0 },
/* U+259e */ { 0, 0, 0, 0, 0 },
/* U+259f */ { 0, 0, 0, 0, 0 },
/* U+25a0 */ { 30, 0, 19, 0, 0 },
/* U+25a1 */ { 30, 0, 19, 0, 0 },
/* U+25a2 */ { 30, 0, 19, 0, 0 },
/* U+25a3 */ { 30, 0, 19, 0, 0 },
/* U+25a4 */ { 30, 0, 19, 0, 0 },
/* U+25a5 */ { 30, 0, 19, 0, 0 },
/* U+25a6 */ { 30, 0, 19, 0, 0 },
/* U+25a7 */ { 30, 0, 19, 0, 0 },
/* U+25a8 */ { 30, 0, 19, 0, 0 },
/* U+25a9 */ { 30, 0, 19, 0, 0 },
/* U+25aa */ { 30, 0, 19, 0, 0 },
/* U+25ab */ { 30, 0, 19, 0, 0 },
/* U+25ac */ { 30, 0, 19, 0, 0 },
/* U+25ad */ { 30, 0, 19, 0, 0 },
/* U+25ae */ { 30, 0, 19, 0, 0 },
/* U+25af */ { 30, 0, 19, 0, 0 },
/* U+25b0 */ { 30, 0, 19, 0, 0 },
/* U+25b1 */ { 30, 0, 19, 0, 0 },
/* U+25b2 */ { 30, 0, 19, 0, 0 },
/* U+25b3 */ { 30, 0, 19, 0, 0 },
/* U+25b4 */ { 30, 0, 19, 0, 0 },
/* U+25b5 */ { 30, 0, 19, 0, 0 },
/* U+25b6 */ { 30, 0, 19, 0, 0 },
/* U+25b7 */ { 27, 0, 19, 0, 0 },
/* U+25b8 */ { 30, 0, 19, 0, 0 },
/* U+25b9 */ { 30, 0, 19, 0, 0 },
/* U+25ba */ { 30, 0, 19, 0, 0 },
/* U+25bb */ { 30, 0, 19, 0, 0 },
/* U+25bc */ { 30, 0, 19, 0, 0 },
/* U+25bd */ { 30, 0, 19, 0, 0 },
/* U+25be */ { 30, 0, 19, 0, 0 },
/* U+25bf */ { 30, 0, 19, 0, 0 },
/* U+25c0 */ { 30, 0, 19, 0, 0 },
/* U+25c1 */ { 27, 0, 19, 0, 0 },
/* U+25c2 */ { 30, 0, 19, 0, 0 },
/* U+25c3 */ { 30, 0, 19, 0, 0 },
/* U+25c4 */ { 30, 0, 19, 0, 0 },
/* U+25c5 */ { 30, 0, 19, 0, 0 },
/* U+25c6 */ { 30, 0, 19, 0, 0 },
/* U+25c7 */ { 30, 0, 19, 0, 0 },
/* U+25c8 */ { 30, 0, 19, 0, 0 },
/* U+25c9 */ { 30, 0, 19, 0, 0 },
/* U+25ca */ { 30, 0, 19, 0, 0 },
/* U+25cb */ { 30, 0, 19, 0, 0 },
/* U+25cc */ { 30, 0, 19, 0, 0 },
/* U+25cd */ { 30, 0, 19, 0, 0 },
/* U+25ce */ { 30, 0, 19, 0, 0 },
/* U+25cf */ { 30, 0, 19, 0, 0 },
/* U+25d0 */ { 30, 0, 19, 0, 0 },
/* U+25d1 */ { 30, 0, 19, 0, 0 },
/* U+25d2 */ { 30, 0, 19, 0, 0 },
/* U+25d3 */ { 30, 0, 19, 0, 0 },
/* U+25d4 */ { 30, 0, 19, 0, 0 },
/* U+25d5 */ { 30, 0, 19, 0, 0 },
/* U+25d6 */ { 30, 0, 19, 0, 0 },
/* U+25d7 */ { 30, 0, 19, 0, 0 },
/* U+25d8 */ { 30, 0, 19, 0, 0 },
/* U+25d9 */ { 30, 0, 19, 0, 0 },
/* U+25da */ { 30, 0, 19, 0, 0 },
/* U+25db */ { 30, 0, 19, 0, 0 },
/* U+25dc */ { 30, 0, 19, 0, 0 },
/* U+25dd */ { 30, 0, 19, 0, 0 },
/* U+25de */ { 30, 0, 19, 0, 0 },
/* U+25df */ { 30, 0, 19, 0, 0 },
/* U+25e0 */ { 30, 0, 19, 0, 0 },
/* U+25e1 */ { 30, 0, 19, 0, 0 },
/* U+25e2 */ { 30, 0, 19, 0, 0 },
/* U+25e3 */ { 30, 0, 19, 0, 0 },
/* U+25e4 */ { 30, 0, 19, 0, 0 },
/* U+25e5 */ { 30, 0, 19, 0, 0 },
/* U+25e6 */ { 30, 0, 19, 0, 0 },
/* U+25e7 */ { 30, 0, 19, 0, 0 },
/* U+25e8 */ { 30, 0, 19, 0, 0 },
/* U+25e9 */ { 30, 0, 19, 0, 0 },
/* U+25ea */ { 30, 0, 19, 0, 0 },
/* U+25eb */ { 30, 0, 19, 0, 0 },
/* U+25ec */ { 30, 0, 19, 0, 0 },
/* U+25ed */ { 30, 0, 19, 0, 0 },
/* U+25ee */ { 30, 0, 19, 0, 0 },
/* U+25ef */ { 30, 0, 19, 0, 0 },
/* U+25f0 */ { 30, 0, 19, 0, 0 },
/* U+25f1 */ { 30, 0, 19, 0, 0 },
/* U+25f2 */ { 30, 0, 19, 0, 0 },
/* U+25f3 */ { 30, 0, 19, 0, 0 },
/* U+25f4 */ { 30, 0, 19, 0, 0 },
/* U+25f5 */ { 30, 0, 19, 0, 0 },
/* U+25f6 */ { 30, 0, 19, 0, 0 },
/* U+25f7 */ { 30, 0, 19, 0, 0 },
/* U+25f8 */ { 0, 0, 0, 0, 0 },
/* U+25f9 */ { 0, 0, 0, 0, 0 },
/* U+25fa */ { 0, 0, 0, 0, 0 },
/* U+25fb */ { 0, 0, 0, 0, 0 },
/* U+25fc */ { 0, 0, 0, 0, 0 },
/* U+25fd */ { 0, 0, 0, 0, 0 },
/* U+25fe */ { 0, 0, 0, 0, 0 },
/* U+25ff */ { 0, 0, 0, 0, 0 },
/* U+2600 */ { 30, 0, 19, 0, 0 },
/* U+2601 */ { 30, 0, 19, 0, 0 },
/* U+2602 */ { 30, 0, 19, 0, 0 },
/* U+2603 */ { 30, 0, 19, 0, 0 },
/* U+2604 */ { 30, 0, 19, 0, 0 },
/* U+2605 */ { 30, 0, 19, 0, 0 },
/* U+2606 */ { 30, 0, 19, 0, 0 },
/* U+2607 */ { 30, 0, 19, 0, 0 },
/* U+2608 */ { 30, 0, 19, 0, 0 },
/* U+2609 */ { 30, 0, 19, 0, 0 },
/* U+260a */ { 30, 0, 19, 0, 0 },
/* U+260b */ { 30, 0, 19, 0, 0 },
/* U+260c */ { 30, 0, 19, 0, 0 },
/* U+260d */ { 30, 0, 19, 0, 0 },
/* U+260e */ { 30, 0, 19, 0, 0 },
/* U+260f */ { 30, 0, 19, 0, 0 },
/* U+2610 */ { 30, 0, 19, 0, 0 },
/* U+2611 */ { 30, 0, 19, 0, 0 },
/* U+2612 */ { 30, 0, 19, 0, 0 },
/* U+2613 */ { 30, 0, 19, 0, 0 },
/* U+2614 */ { 0, 0, 0, 0, 0 },
/* U+2615 */ { 0, 0, 0, 0, 0 },
/* U+2616 */ { 0, 0, 0, 0, 0 },
/* U+2617 */ { 0, 0, 0, 0, 0 },
/* U+2618 */ { 0, 0, 0, 0, 0 },
/* U+2619 */ { 30, 0, 19, 0, 0 },
/* U+261a */ { 30, 0, 19, 0, 0 },
/* U+261b */ { 30, 0, 19, 0, 0 },
/* U+261c */ { 30, 0, 19, 0, 0 },
/* U+261d */ { 30, 0, 19, 0, 0 },
/* U+261e */ { 30, 0, 19, 0, 0 },
/* U+261f */ { 30, 0, 19, 0, 0 },
/* U+2620 */ { 30, 0, 19, 0, 0 },
/* U+2621 */ { 30, 0, 19, 0, 0 },
/* U+2622 */ { 30, 0, 19, 0, 0 },
/* U+2623 */ { 30, 0, 19, 0, 0 },
/* U+2624 */ { 30, 0, 19, 0, 0 },
/* U+2625 */ { 30, 0, 19, 0, 0 },
/* U+2626 */ { 30, 0, 19, 0, 0 },
/* U+2627 */ { 30, 0, 19, 0, 0 },
/* U+2628 */ { 30, 0, 19, 0, 0 },
/* U+2629 */ { 30, 0, 19, 0, 0 },
/* U+262a */ { 30, 0, 19, 0, 0 },
/* U+262b */ { 30, 0, 19, 0, 0 },
/* U+262c */ { 30, 0, 19, 0, 0 },
/* U+262d */ { 30, 0, 19, 0, 0 },
/* U+262e */ { 30, 0, 19, 0, 0 },
/* U+262f */ { 30, 0, 19, 0, 0 },
/* U+2630 */ { 30, 0, 19, 0, 0 },
/* U+2631 */ { 30, 0, 19, 0, 0 },
/* U+2632 */ { 30, 0, 19, 0, 0 },
/* U+2633 */ { 30, 0, 19, 0, 0 },
/* U+2634 */ { 30, 0, 19, 0, 0 },
/* U+2635 */ { 30, 0, 19, 0, 0 },
/* U+2636 */ { 30, 0, 19, 0, 0 },
/* U+2637 */ { 30, 0, 19, 0, 0 },
/* U+2638 */ { 30, 0, 19, 0, 0 },
/* U+2639 */ { 30, 0, 19, 0, 0 },
/* U+263a */ { 30, 0, 19, 0, 0 },
/* U+263b */ { 30, 0, 19, 0, 0 },
/* U+263c */ { 30, 0, 19, 0, 0 },
/* U+263d */ { 30, 0, 19, 0, 0 },
/* U+263e */ { 30, 0, 19, 0, 0 },
/* U+263f */ { 30, 0, 19, 0, 0 },
/* U+2640 */ { 30, 0, 19, 0, 0 },
/* U+2641 */ { 30, 0, 19, 0, 0 },
/* U+2642 */ { 30, 0, 19, 0, 0 },
/* U+2643 */ { 30, 0, 19, 0, 0 },
/* U+2644 */ { 30, 0, 19, 0, 0 },
/* U+2645 */ { 30, 0, 19, 0, 0 },
/* U+2646 */ { 30, 0, 19, 0, 0 },
/* U+2647 */ { 30, 0, 19, 0, 0 },
/* U+2648 */ { 30, 0, 19, 0, 0 },
/* U+2649 */ { 30, 0, 19, 0, 0 },
/* U+264a */ { 30, 0, 19, 0, 0 },
/* U+264b */ { 30, 0, 19, 0, 0 },
/* U+264c */ { 30, 0, 19, 0, 0 },
/* U+264d */ { 30, 0, 19, 0, 0 },
/* U+264e */ { 30, 0, 19, 0, 0 },
/* U+264f */ { 30, 0, 19, 0, 0 },
/* U+2650 */ { 30, 0, 19, 0, 0 },
/* U+2651 */ { 30, 0, 19, 0, 0 },
/* U+2652 */ { 30, 0, 19, 0, 0 },
/* U+2653 */ { 30, 0, 19, 0, 0 },
/* U+2654 */ { 30, 0, 19, 0, 0 },
/* U+2655 */ { 30, 0, 19, 0, 0 },
/* U+2656 */ { 30, 0, 19, 0, 0 },
/* U+2657 */ { 30, 0, 19, 0, 0 },
/* U+2658 */ { 30, 0, 19, 0, 0 },
/* U+2659 */ { 30, 0, 19, 0, 0 },
/* U+265a */ { 30, 0, 19, 0, 0 },
/* U+265b */ { 30, 0, 19, 0, 0 },
/* U+265c */ { 30, 0, 19, 0, 0 },
/* U+265d */ { 30, 0, 19, 0, 0 },
/* U+265e */ { 30, 0, 19, 0, 0 },
/* U+265f */ { 30, 0, 19, 0, 0 },
/* U+2660 */ { 30, 0, 19, 0, 0 },
/* U+2661 */ { 30, 0, 19, 0, 0 },
/* U+2662 */ { 30, 0, 19, 0, 0 },
/* U+2663 */ { 30, 0, 19, 0, 0 },
/* U+2664 */ { 30, 0, 19, 0, 0 },
/* U+2665 */ { 30, 0, 19, 0, 0 },
/* U+2666 */ { 30, 0, 19, 0, 0 },
/* U+2667 */ { 30, 0, 19, 0, 0 },
/* U+2668 */ { 30, 0, 19, 0, 0 },
/* U+2669 */ { 30, 0, 19, 0, 0 },
/* U+266a */ { 30, 0, 19, 0, 0 },
/* U+266b */ { 30, 0, 19, 0, 0 },
/* U+266c */ { 30, 0, 19, 0, 0 },
/* U+266d */ { 30, 0, 19, 0, 0 },
/* U+266e */ { 30, 0, 19, 0, 0 },
/* U+266f */ { 27, 0, 19, 0, 0 },
/* U+2670 */ { 30, 0, 19, 0, 0 },
/* U+2671 */ { 30, 0, 19, 0, 0 },
/* U+2672 */ { 0, 0, 0, 0, 0 },
/* U+2673 */ { 0, 0, 0, 0, 0 },
/* U+2674 */ { 0, 0, 0, 0, 0 },
/* U+2675 */ { 0, 0, 0, 0, 0 },
/* U+2676 */ { 0, 0, 0, 0, 0 },
/* U+2677 */ { 0, 0, 0, 0, 0 },
/* U+2678 */ { 0, 0, 0, 0, 0 },
/* U+2679 */ { 0, 0, 0, 0, 0 },
/* U+267a */ { 0, 0, 0, 0, 0 },
/* U+267b */ { 0, 0, 0, 0, 0 },
/* U+267c */ { 0, 0, 0, 0, 0 },
/* U+267d */ { 0, 0, 0, 0, 0 },
/* U+267e */ { 0, 0, 0, 0, 0 },
/* U+267f */ { 0, 0, 0, 0, 0 },
/* U+2680 */ { 0, 0, 0, 0, 0 },
/* U+2681 */ { 0, 0, 0, 0, 0 },
/* U+2682 */ { 0, 0, 0, 0, 0 },
/* U+2683 */ { 0, 0, 0, 0, 0 },
/* U+2684 */ { 0, 0, 0, 0, 0 },
/* U+2685 */ { 0, 0, 0, 0, 0 },
/* U+2686 */ { 0, 0, 0, 0, 0 },
/* U+2687 */ { 0, 0, 0, 0, 0 },
/* U+2688 */ { 0, 0, 0, 0, 0 },
/* U+2689 */ { 0, 0, 0, 0, 0 },
/* U+268a */ { 0, 0, 0, 0, 0 },
/* U+268b */ { 0, 0, 0, 0, 0 },
/* U+268c */ { 0, 0, 0, 0, 0 },
/* U+268d */ { 0, 0, 0, 0, 0 },
/* U+268e */ { 0, 0, 0, 0, 0 },
/* U+268f */ { 0, 0, 0, 0, 0 },
/* U+2690 */ { 0, 0, 0, 0, 0 },
/* U+2691 */ { 0, 0, 0, 0, 0 },
/* U+2692 */ { 0, 0, 0, 0, 0 },
/* U+2693 */ { 0, 0, 0, 0, 0 },
/* U+2694 */ { 0, 0, 0, 0, 0 },
/* U+2695 */ { 0, 0, 0, 0, 0 },
/* U+2696 */ { 0, 0, 0, 0, 0 },
/* U+2697 */ { 0, 0, 0, 0, 0 },
/* U+2698 */ { 0, 0, 0, 0, 0 },
/* U+2699 */ { 0, 0, 0, 0, 0 },
/* U+269a */ { 0, 0, 0, 0, 0 },
/* U+269b */ { 0, 0, 0, 0, 0 },
/* U+269c */ { 0, 0, 0, 0, 0 },
/* U+269d */ { 0, 0, 0, 0, 0 },
/* U+269e */ { 0, 0, 0, 0, 0 },
/* U+269f */ { 0, 0, 0, 0, 0 },
/* U+26a0 */ { 0, 0, 0, 0, 0 },
/* U+26a1 */ { 0, 0, 0, 0, 0 },
/* U+26a2 */ { 0, 0, 0, 0, 0 },
/* U+26a3 */ { 0, 0, 0, 0, 0 },
/* U+26a4 */ { 0, 0, 0, 0, 0 },
/* U+26a5 */ { 0, 0, 0, 0, 0 },
/* U+26a6 */ { 0, 0, 0, 0, 0 },
/* U+26a7 */ { 0, 0, 0, 0, 0 },
/* U+26a8 */ { 0, 0, 0, 0, 0 },
/* U+26a9 */ { 0, 0, 0, 0, 0 },
/* U+26aa */ { 0, 0, 0, 0, 0 },
/* U+26ab */ { 0, 0, 0, 0, 0 },
/* U+26ac */ { 0, 0, 0, 0, 0 },
/* U+26ad */ { 0, 0, 0, 0, 0 },
/* U+26ae */ { 0, 0, 0, 0, 0 },
/* U+26af */ { 0, 0, 0, 0, 0 },
/* U+26b0 */ { 0, 0, 0, 0, 0 },
/* U+26b1 */ { 0, 0, 0, 0, 0 },
/* U+26b2 */ { 0, 0, 0, 0, 0 },
/* U+26b3 */ { 0, 0, 0, 0, 0 },
/* U+26b4 */ { 0, 0, 0, 0, 0 },
/* U+26b5 */ { 0, 0, 0, 0, 0 },
/* U+26b6 */ { 0, 0, 0, 0, 0 },
/* U+26b7 */ { 0, 0, 0, 0, 0 },
/* U+26b8 */ { 0, 0, 0, 0, 0 },
/* U+26b9 */ { 0, 0, 0, 0, 0 },
/* U+26ba */ { 0, 0, 0, 0, 0 },
/* U+26bb */ { 0, 0, 0, 0, 0 },
/* U+26bc */ { 0, 0, 0, 0, 0 },
/* U+26bd */ { 0, 0, 0, 0, 0 },
/* U+26be */ { 0, 0, 0, 0, 0 },
/* U+26bf */ { 0, 0, 0, 0, 0 },
/* U+26c0 */ { 0, 0, 0, 0, 0 },
/* U+26c1 */ { 0, 0, 0, 0, 0 },
/* U+26c2 */ { 0, 0, 0, 0, 0 },
/* U+26c3 */ { 0, 0, 0, 0, 0 },
/* U+26c4 */ { 0, 0, 0, 0, 0 },
/* U+26c5 */ { 0, 0, 0, 0, 0 },
/* U+26c6 */ { 0, 0, 0, 0, 0 },
/* U+26c7 */ { 0, 0, 0, 0, 0 },
/* U+26c8 */ { 0, 0, 0, 0, 0 },
/* U+26c9 */ { 0, 0, 0, 0, 0 },
/* U+26ca */ { 0, 0, 0, 0, 0 },
/* U+26cb */ { 0, 0, 0, 0, 0 },
/* U+26cc */ { 0, 0, 0, 0, 0 },
/* U+26cd */ { 0, 0, 0, 0, 0 },
/* U+26ce */ { 0, 0, 0, 0, 0 },
/* U+26cf */ { 0, 0, 0, 0, 0 },
/* U+26d0 */ { 0, 0, 0, 0, 0 },
/* U+26d1 */ { 0, 0, 0, 0, 0 },
/* U+26d2 */ { 0, 0, 0, 0, 0 },
/* U+26d3 */ { 0, 0, 0, 0, 0 },
/* U+26d4 */ { 0, 0, 0, 0, 0 },
/* U+26d5 */ { 0, 0, 0, 0, 0 },
/* U+26d6 */ { 0, 0, 0, 0, 0 },
/* U+26d7 */ { 0, 0, 0, 0, 0 },
/* U+26d8 */ { 0, 0, 0, 0, 0 },
/* U+26d9 */ { 0, 0, 0, 0, 0 },
/* U+26da */ { 0, 0, 0, 0, 0 },
/* U+26db */ { 0, 0, 0, 0, 0 },
/* U+26dc */ { 0, 0, 0, 0, 0 },
/* U+26dd */ { 0, 0, 0, 0, 0 },
/* U+26de */ { 0, 0, 0, 0, 0 },
/* U+26df */ { 0, 0, 0, 0, 0 },
/* U+26e0 */ { 0, 0, 0, 0, 0 },
/* U+26e1 */ { 0, 0, 0, 0, 0 },
/* U+26e2 */ { 0, 0, 0, 0, 0 },
/* U+26e3 */ { 0, 0, 0, 0, 0 },
/* U+26e4 */ { 0, 0, 0, 0, 0 },
/* U+26e5 */ { 0, 0, 0, 0, 0 },
/* U+26e6 */ { 0, 0, 0, 0, 0 },
/* U+26e7 */ { 0, 0, 0, 0, 0 },
/* U+26e8 */ { 0, 0, 0, 0, 0 },
/* U+26e9 */ { 0, 0, 0, 0, 0 },
/* U+26ea */ { 0, 0, 0, 0, 0 },
/* U+26eb */ { 0, 0, 0, 0, 0 },
/* U+26ec */ { 0, 0, 0, 0, 0 },
/* U+26ed */ { 0, 0, 0, 0, 0 },
/* U+26ee */ { 0, 0, 0, 0, 0 },
/* U+26ef */ { 0, 0, 0, 0, 0 },
/* U+26f0 */ { 0, 0, 0, 0, 0 },
/* U+26f1 */ { 0, 0, 0, 0, 0 },
/* U+26f2 */ { 0, 0, 0, 0, 0 },
/* U+26f3 */ { 0, 0, 0, 0, 0 },
/* U+26f4 */ { 0, 0, 0, 0, 0 },
/* U+26f5 */ { 0, 0, 0, 0, 0 },
/* U+26f6 */ { 0, 0, 0, 0, 0 },
/* U+26f7 */ { 0, 0, 0, 0, 0 },
/* U+26f8 */ { 0, 0, 0, 0, 0 },
/* U+26f9 */ { 0, 0, 0, 0, 0 },
/* U+26fa */ { 0, 0, 0, 0, 0 },
/* U+26fb */ { 0, 0, 0, 0, 0 },
/* U+26fc */ { 0, 0, 0, 0, 0 },
/* U+26fd */ { 0, 0, 0, 0, 0 },
/* U+26fe */ { 0, 0, 0, 0, 0 },
/* U+26ff */ { 0, 0, 0, 0, 0 },
/* U+2700 */ { 0, 0, 0, 0, 0 },
/* U+2701 */ { 30, 0, 19, 0, 0 },
/* U+2702 */ { 30, 0, 19, 0, 0 },
/* U+2703 */ { 30, 0, 19, 0, 0 },
/* U+2704 */ { 30, 0, 19, 0, 0 },
/* U+2705 */ { 0, 0, 0, 0, 0 },
/* U+2706 */ { 30, 0, 19, 0, 0 },
/* U+2707 */ { 30, 0, 19, 0, 0 },
/* U+2708 */ { 30, 0, 19, 0, 0 },
/* U+2709 */ { 30, 0, 19, 0, 0 },
/* U+270a */ { 0, 0, 0, 0, 0 },
/* U+270b */ { 0, 0, 0, 0, 0 },
/* U+270c */ { 30, 0, 19, 0, 0 },
/* U+270d */ { 30, 0, 19, 0, 0 },
/* U+270e */ { 30, 0, 19, 0, 0 },
/* U+270f */ { 30, 0, 19, 0, 0 },
/* U+2710 */ { 30, 0, 19, 0, 0 },
/* U+2711 */ { 30, 0, 19, 0, 0 },
/* U+2712 */ { 30, 0, 19, 0, 0 },
/* U+2713 */ { 30, 0, 19, 0, 0 },
/* U+2714 */ { 30, 0, 19, 0, 0 },
/* U+2715 */ { 30, 0, 19, 0, 0 },
/* U+2716 */ { 30, 0, 19, 0, 0 },
/* U+2717 */ { 30, 0, 19, 0, 0 },
/* U+2718 */ { 30, 0, 19, 0, 0 },
/* U+2719 */ { 30, 0, 19, 0, 0 },
/* U+271a */ { 30, 0, 19, 0, 0 },
/* U+271b */ { 30, 0, 19, 0, 0 },
/* U+271c */ { 30, 0, 19, 0, 0 },
/* U+271d */ { 30, 0, 19, 0, 0 },
/* U+271e */ { 30, 0, 19, 0, 0 },
/* U+271f */ { 30, 0, 19, 0, 0 },
/* U+2720 */ { 30, 0, 19, 0, 0 },
/* U+2721 */ { 30, 0, 19, 0, 0 },
/* U+2722 */ { 30, 0, 19, 0, 0 },
/* U+2723 */ { 30, 0, 19, 0, 0 },
/* U+2724 */ { 30, 0, 19, 0, 0 },
/* U+2725 */ { 30, 0, 19, 0, 0 },
/* U+2726 */ { 30, 0, 19, 0, 0 },
/* U+2727 */ { 30, 0, 19, 0, 0 },
/* U+2728 */ { 0, 0, 0, 0, 0 },
/* U+2729 */ { 30, 0, 19, 0, 0 },
/* U+272a */ { 30, 0, 19, 0, 0 },
/* U+272b */ { 30, 0, 19, 0, 0 },
/* U+272c */ { 30, 0, 19, 0, 0 },
/* U+272d */ { 30, 0, 19, 0, 0 },
/* U+272e */ { 30, 0, 19, 0, 0 },
/* U+272f */ { 30, 0, 19, 0, 0 },
/* U+2730 */ { 30, 0, 19, 0, 0 },
/* U+2731 */ { 30, 0, 19, 0, 0 },
/* U+2732 */ { 30, 0, 19, 0, 0 },
/* U+2733 */ { 30, 0, 19, 0, 0 },
/* U+2734 */ { 30, 0, 19, 0, 0 },
/* U+2735 */ { 30, 0, 19, 0, 0 },
/* U+2736 */ { 30, 0, 19, 0, 0 },
/* U+2737 */ { 30, 0, 19, 0, 0 },
/* U+2738 */ { 30, 0, 19, 0, 0 },
/* U+2739 */ { 30, 0, 19, 0, 0 },
/* U+273a */ { 30, 0, 19, 0, 0 },
/* U+273b */ { 30, 0, 19, 0, 0 },
/* U+273c */ { 30, 0, 19, 0, 0 },
/* U+273d */ { 30, 0, 19, 0, 0 },
/* U+273e */ { 30, 0, 19, 0, 0 },
/* U+273f */ { 30, 0, 19, 0, 0 },
/* U+2740 */ { 30, 0, 19, 0, 0 },
/* U+2741 */ { 30, 0, 19, 0, 0 },
/* U+2742 */ { 30, 0, 19, 0, 0 },
/* U+2743 */ { 30, 0, 19, 0, 0 },
/* U+2744 */ { 30, 0, 19, 0, 0 },
/* U+2745 */ { 30, 0, 19, 0, 0 },
/* U+2746 */ { 30, 0, 19, 0, 0 },
/* U+2747 */ { 30, 0, 19, 0, 0 },
/* U+2748 */ { 30, 0, 19, 0, 0 },
/* U+2749 */ { 30, 0, 19, 0, 0 },
/* U+274a */ { 30, 0, 19, 0, 0 },
/* U+274b */ { 30, 0, 19, 0, 0 },
/* U+274c */ { 0, 0, 0, 0, 0 },
/* U+274d */ { 30, 0, 19, 0, 0 },
/* U+274e */ { 0, 0, 0, 0, 0 },
/* U+274f */ { 30, 0, 19, 0, 0 },
/* U+2750 */ { 30, 0, 19, 0, 0 },
/* U+2751 */ { 30, 0, 19, 0, 0 },
/* U+2752 */ { 30, 0, 19, 0, 0 },
/* U+2753 */ { 0, 0, 0, 0, 0 },
/* U+2754 */ { 0, 0, 0, 0, 0 },
/* U+2755 */ { 0, 0, 0, 0, 0 },
/* U+2756 */ { 30, 0, 19, 0, 0 },
/* U+2757 */ { 0, 0, 0, 0, 0 },
/* U+2758 */ { 30, 0, 19, 0, 0 },
/* U+2759 */ { 30, 0, 19, 0, 0 },
/* U+275a */ { 30, 0, 19, 0, 0 },
/* U+275b */ { 30, 0, 19, 0, 0 },
/* U+275c */ { 30, 0, 19, 0, 0 },
/* U+275d */ { 30, 0, 19, 0, 0 },
/* U+275e */ { 30, 0, 19, 0, 0 },
/* U+275f */ { 0, 0, 0, 0, 0 },
/* U+2760 */ { 0, 0, 0, 0, 0 },
/* U+2761 */ { 30, 0, 19, 0, 0 },
/* U+2762 */ { 30, 0, 19, 0, 0 },
/* U+2763 */ { 30, 0, 19, 0, 0 },
/* U+2764 */ { 30, 0, 19, 0, 0 },
/* U+2765 */ { 30, 0, 19, 0, 0 },
/* U+2766 */ { 30, 0, 19, 0, 0 },
/* U+2767 */ { 30, 0, 19, 0, 0 },
/* U+2768 */ { 0, 0, 0, 0, 0 },
/* U+2769 */ { 0, 0, 0, 0, 0 },
/* U+276a */ { 0, 0, 0, 0, 0 },
/* U+276b */ { 0, 0, 0, 0, 0 },
/* U+276c */ { 0, 0, 0, 0, 0 },
/* U+276d */ { 0, 0, 0, 0, 0 },
/* U+276e */ { 0, 0, 0, 0, 0 },
/* U+276f */ { 0, 0, 0, 0, 0 },
/* U+2770 */ { 0, 0, 0, 0, 0 },
/* U+2771 */ { 0, 0, 0, 0, 0 },
/* U+2772 */ { 0, 0, 0, 0, 0 },
/* U+2773 */ { 0, 0, 0, 0, 0 },
/* U+2774 */ { 0, 0, 0, 0, 0 },
/* U+2775 */ { 0, 0, 0, 0, 0 },
/* U+2776 */ { 9, 0, 19, 0, 0 },
/* U+2777 */ { 9, 0, 19, 0, 0 },
/* U+2778 */ { 9, 0, 19, 0, 0 },
/* U+2779 */ { 9, 0, 19, 0, 0 },
/* U+277a */ { 9, 0, 19, 0, 0 },
/* U+277b */ { 9, 0, 19, 0, 0 },
/* U+277c */ { 9, 0, 19, 0, 0 },
/* U+277d */ { 9, 0, 19, 0, 0 },
/* U+277e */ { 9, 0, 19, 0, 0 },
/* U+277f */ { 9, 0, 19, 0, 0 },
/* U+2780 */ { 9, 0, 19, 0, 0 },
/* U+2781 */ { 9, 0, 19, 0, 0 },
/* U+2782 */ { 9, 0, 19, 0, 0 },
/* U+2783 */ { 9, 0, 19, 0, 0 },
/* U+2784 */ { 9, 0, 19, 0, 0 },
/* U+2785 */ { 9, 0, 19, 0, 0 },
/* U+2786 */ { 9, 0, 19, 0, 0 },
/* U+2787 */ { 9, 0, 19, 0, 0 },
/* U+2788 */ { 9, 0, 19, 0, 0 },
/* U+2789 */ { 9, 0, 19, 0, 0 },
/* U+278a */ { 9, 0, 19, 0, 0 },
/* U+278b */ { 9, 0, 19, 0, 0 },
/* U+278c */ { 9, 0, 19, 0, 0 },
/* U+278d */ { 9, 0, 19, 0, 0 },
/* U+278e */ { 9, 0, 19, 0, 0 },
/* U+278f */ { 9, 0, 19, 0, 0 },
/* U+2790 */ { 9, 0, 19, 0, 0 },
/* U+2791 */ { 9, 0, 19, 0, 0 },
/* U+2792 */ { 9, 0, 19, 0, 0 },
/* U+2793 */ { 9, 0, 19, 0, 0 },
/* U+2794 */ { 30, 0, 19, 0, 0 },
/* U+2795 */ { 0, 0, 0, 0, 0 },
/* U+2796 */ { 0, 0, 0, 0, 0 },
/* U+2797 */ { 0, 0, 0, 0, 0 },
/* U+2798 */ { 30, 0, 19, 0, 0 },
/* U+2799 */ { 30, 0, 19, 0, 0 },
/* U+279a */ { 30, 0, 19, 0, 0 },
/* U+279b */ { 30, 0, 19, 0, 0 },
/* U+279c */ { 30, 0, 19, 0, 0 },
/* U+279d */ { 30, 0, 19, 0, 0 },
/* U+279e */ { 30, 0, 19, 0, 0 },
/* U+279f */ { 30, 0, 19, 0, 0 },
/* U+27a0 */ { 30, 0, 19, 0, 0 },
/* U+27a1 */ { 30, 0, 19, 0, 0 },
/* U+27a2 */ { 30, 0, 19, 0, 0 },
/* U+27a3 */ { 30, 0, 19, 0, 0 },
/* U+27a4 */ { 30, 0, 19, 0, 0 },
/* U+27a5 */ { 30, 0, 19, 0, 0 },
/* U+27a6 */ { 30, 0, 19, 0, 0 },
/* U+27a7 */ { 30, 0, 19, 0, 0 },
/* U+27a8 */ { 30, 0, 19, 0, 0 },
/* U+27a9 */ { 30, 0, 19, 0, 0 },
/* U+27aa */ { 30, 0, 19, 0, 0 },
/* U+27ab */ { 30, 0, 19, 0, 0 },
/* U+27ac */ { 30, 0, 19, 0, 0 },
/* U+27ad */ { 30, 0, 19, 0, 0 },
/* U+27ae */ { 30, 0, 19, 0, 0 },
/* U+27af */ { 30, 0, 19, 0, 0 },
/* U+27b0 */ { 0, 0, 0, 0, 0 },
/* U+27b1 */ { 30, 0, 19, 0, 0 },
/* U+27b2 */ { 30, 0, 19, 0, 0 },
/* U+27b3 */ { 30, 0, 19, 0, 0 },
/* U+27b4 */ { 30, 0, 19, 0, 0 },
/* U+27b5 */ { 30, 0, 19, 0, 0 },
/* U+27b6 */ { 30, 0, 19, 0, 0 },
/* U+27b7 */ { 30, 0, 19, 0, 0 },
/* U+27b8 */ { 30, 0, 19, 0, 0 },
/* U+27b9 */ { 30, 0, 19, 0, 0 },
/* U+27ba */ { 30, 0, 19, 0, 0 },
/* U+27bb */ { 30, 0, 19, 0, 0 },
/* U+27bc */ { 30, 0, 19, 0, 0 },
/* U+27bd */ { 30, 0, 19, 0, 0 },
/* U+27be */ { 30, 0, 19, 0, 0 },
/* U+27bf */ { 0, 0, 0, 0, 0 },
/* U+27c0 */ { 0, 0, 0, 0, 0 },
/* U+27c1 */ { 0, 0, 0, 0, 0 },
/* U+27c2 */ { 0, 0, 0, 0, 0 },
/* U+27c3 */ { 0, 0, 0, 0, 0 },
/* U+27c4 */ { 0, 0, 0, 0, 0 },
/* U+27c5 */ { 0, 0, 0, 0, 0 },
/* U+27c6 */ { 0, 0, 0, 0, 0 },
/* U+27c7 */ { 0, 0, 0, 0, 0 },
/* U+27c8 */ { 0, 0, 0, 0, 0 },
/* U+27c9 */ { 0, 0, 0, 0, 0 },
/* U+27ca */ { 0, 0, 0, 0, 0 },
/* U+27cb */ { 0, 0, 0, 0, 0 },
/* U+27cc */ { 0, 0, 0, 0, 0 },
/* U+27cd */ { 0, 0, 0, 0, 0 },
/* U+27ce */ { 0, 0, 0, 0, 0 },
/* U+27cf */ { 0, 0, 0, 0, 0 },
/* U+27d0 */ { 0, 0, 0, 0, 0 },
/* U+27d1 */ { 0, 0, 0, 0, 0 },
/* U+27d2 */ { 0, 0, 0, 0, 0 },
/* U+27d3 */ { 0, 0, 0, 0, 0 },
/* U+27d4 */ { 0, 0, 0, 0, 0 },
/* U+27d5 */ { 0, 0, 0, 0, 0 },
/* U+27d6 */ { 0, 0, 0, 0, 0 },
/* U+27d7 */ { 0, 0, 0, 0, 0 },
/* U+27d8 */ { 0, 0, 0, 0, 0 },
/* U+27d9 */ { 0, 0, 0, 0, 0 },
/* U+27da */ { 0, 0, 0, 0, 0 },
/* U+27db */ { 0, 0, 0, 0, 0 },
/* U+27dc */ { 0, 0, 0, 0, 0 },
/* U+27dd */ { 0, 0, 0, 0, 0 },
/* U+27de */ { 0, 0, 0, 0, 0 },
/* U+27df */ { 0, 0, 0, 0, 0 },
/* U+27e0 */ { 0, 0, 0, 0, 0 },
/* U+27e1 */ { 0, 0, 0, 0, 0 },
/* U+27e2 */ { 0, 0, 0, 0, 0 },
/* U+27e3 */ { 0, 0, 0, 0, 0 },
/* U+27e4 */ { 0, 0, 0, 0, 0 },
/* U+27e5 */ { 0, 0, 0, 0, 0 },
/* U+27e6 */ { 0, 0, 0, 0, 0 },
/* U+27e7 */ { 0, 0, 0, 0, 0 },
/* U+27e8 */ { 0, 0, 0, 0, 0 },
/* U+27e9 */ { 0, 0, 0, 0, 0 },
/* U+27ea */ { 0, 0, 0, 0, 0 },
/* U+27eb */ { 0, 0, 0, 0, 0 },
/* U+27ec */ { 0, 0, 0, 0, 0 },
/* U+27ed */ { 0, 0, 0, 0, 0 },
/* U+27ee */ { 0, 0, 0, 0, 0 },
/* U+27ef */ { 0, 0, 0, 0, 0 },
/* U+27f0 */ { 0, 0, 0, 0, 0 },
/* U+27f1 */ { 0, 0, 0, 0, 0 },
/* U+27f2 */ { 0, 0, 0, 0, 0 },
/* U+27f3 */ { 0, 0, 0, 0, 0 },
/* U+27f4 */ { 0, 0, 0, 0, 0 },
/* U+27f5 */ { 0, 0, 0, 0, 0 },
/* U+27f6 */ { 0, 0, 0, 0, 0 },
/* U+27f7 */ { 0, 0, 0, 0, 0 },
/* U+27f8 */ { 0, 0, 0, 0, 0 },
/* U+27f9 */ { 0, 0, 0, 0, 0 },
/* U+27fa */ { 0, 0, 0, 0, 0 },
/* U+27fb */ { 0, 0, 0, 0, 0 },
/* U+27fc */ { 0, 0, 0, 0, 0 },
/* U+27fd */ { 0, 0, 0, 0, 0 },
/* U+27fe */ { 0, 0, 0, 0, 0 },
/* U+27ff */ { 0, 0, 0, 0, 0 },
/* U+2800 */ { 30, 0, 19, 0, 0 },
/* U+2801 */ { 30, 0, 19, 0, 0 },
/* U+2802 */ { 30, 0, 19, 0, 0 },
/* U+2803 */ { 30, 0, 19, 0, 0 },
/* U+2804 */ { 30, 0, 19, 0, 0 },
/* U+2805 */ { 30, 0, 19, 0, 0 },
/* U+2806 */ { 30, 0, 19, 0, 0 },
/* U+2807 */ { 30, 0, 19, 0, 0 },
/* U+2808 */ { 30, 0, 19, 0, 0 },
/* U+2809 */ { 30, 0, 19, 0, 0 },
/* U+280a */ { 30, 0, 19, 0, 0 },
/* U+280b */ { 30, 0, 19, 0, 0 },
/* U+280c */ { 30, 0, 19, 0, 0 },
/* U+280d */ { 30, 0, 19, 0, 0 },
/* U+280e */ { 30, 0, 19, 0, 0 },
/* U+280f */ { 30, 0, 19, 0, 0 },
/* U+2810 */ { 30, 0, 19, 0, 0 },
/* U+2811 */ { 30, 0, 19, 0, 0 },
/* U+2812 */ { 30, 0, 19, 0, 0 },
/* U+2813 */ { 30, 0, 19, 0, 0 },
/* U+2814 */ { 30, 0, 19, 0, 0 },
/* U+2815 */ { 30, 0, 19, 0, 0 },
/* U+2816 */ { 30, 0, 19, 0, 0 },
/* U+2817 */ { 30, 0, 19, 0, 0 },
/* U+2818 */ { 30, 0, 19, 0, 0 },
/* U+2819 */ { 30, 0, 19, 0, 0 },
/* U+281a */ { 30, 0, 19, 0, 0 },
/* U+281b */ { 30, 0, 19, 0, 0 },
/* U+281c */ { 30, 0, 19, 0, 0 },
/* U+281d */ { 30, 0, 19, 0, 0 },
/* U+281e */ { 30, 0, 19, 0, 0 },
/* U+281f */ { 30, 0, 19, 0, 0 },
/* U+2820 */ { 30, 0, 19, 0, 0 },
/* U+2821 */ { 30, 0, 19, 0, 0 },
/* U+2822 */ { 30, 0, 19, 0, 0 },
/* U+2823 */ { 30, 0, 19, 0, 0 },
/* U+2824 */ { 30, 0, 19, 0, 0 },
/* U+2825 */ { 30, 0, 19, 0, 0 },
/* U+2826 */ { 30, 0, 19, 0, 0 },
/* U+2827 */ { 30, 0, 19, 0, 0 },
/* U+2828 */ { 30, 0, 19, 0, 0 },
/* U+2829 */ { 30, 0, 19, 0, 0 },
/* U+282a */ { 30, 0, 19, 0, 0 },
/* U+282b */ { 30, 0, 19, 0, 0 },
/* U+282c */ { 30, 0, 19, 0, 0 },
/* U+282d */ { 30, 0, 19, 0, 0 },
/* U+282e */ { 30, 0, 19, 0, 0 },
/* U+282f */ { 30, 0, 19, 0, 0 },
/* U+2830 */ { 30, 0, 19, 0, 0 },
/* U+2831 */ { 30, 0, 19, 0, 0 },
/* U+2832 */ { 30, 0, 19, 0, 0 },
/* U+2833 */ { 30, 0, 19, 0, 0 },
/* U+2834 */ { 30, 0, 19, 0, 0 },
/* U+2835 */ { 30, 0, 19, 0, 0 },
/* U+2836 */ { 30, 0, 19, 0, 0 },
/* U+2837 */ { 30, 0, 19, 0, 0 },
/* U+2838 */ { 30, 0, 19, 0, 0 },
/* U+2839 */ { 30, 0, 19, 0, 0 },
/* U+283a */ { 30, 0, 19, 0, 0 },
/* U+283b */ { 30, 0, 19, 0, 0 },
/* U+283c */ { 30, 0, 19, 0, 0 },
/* U+283d */ { 30, 0, 19, 0, 0 },
/* U+283e */ { 30, 0, 19, 0, 0 },
/* U+283f */ { 30, 0, 19, 0, 0 },
/* U+2840 */ { 30, 0, 19, 0, 0 },
/* U+2841 */ { 30, 0, 19, 0, 0 },
/* U+2842 */ { 30, 0, 19, 0, 0 },
/* U+2843 */ { 30, 0, 19, 0, 0 },
/* U+2844 */ { 30, 0, 19, 0, 0 },
/* U+2845 */ { 30, 0, 19, 0, 0 },
/* U+2846 */ { 30, 0, 19, 0, 0 },
/* U+2847 */ { 30, 0, 19, 0, 0 },
/* U+2848 */ { 30, 0, 19, 0, 0 },
/* U+2849 */ { 30, 0, 19, 0, 0 },
/* U+284a */ { 30, 0, 19, 0, 0 },
/* U+284b */ { 30, 0, 19, 0, 0 },
/* U+284c */ { 30, 0, 19, 0, 0 },
/* U+284d */ { 30, 0, 19, 0, 0 },
/* U+284e */ { 30, 0, 19, 0, 0 },
/* U+284f */ { 30, 0, 19, 0, 0 },
/* U+2850 */ { 30, 0, 19, 0, 0 },
/* U+2851 */ { 30, 0, 19, 0, 0 },
/* U+2852 */ { 30, 0, 19, 0, 0 },
/* U+2853 */ { 30, 0, 19, 0, 0 },
/* U+2854 */ { 30, 0, 19, 0, 0 },
/* U+2855 */ { 30, 0, 19, 0, 0 },
/* U+2856 */ { 30, 0, 19, 0, 0 },
/* U+2857 */ { 30, 0, 19, 0, 0 },
/* U+2858 */ { 30, 0, 19, 0, 0 },
/* U+2859 */ { 30, 0, 19, 0, 0 },
/* U+285a */ { 30, 0, 19, 0, 0 },
/* U+285b */ { 30, 0, 19, 0, 0 },
/* U+285c */ { 30, 0, 19, 0, 0 },
/* U+285d */ { 30, 0, 19, 0, 0 },
/* U+285e */ { 30, 0, 19, 0, 0 },
/* U+285f */ { 30, 0, 19, 0, 0 },
/* U+2860 */ { 30, 0, 19, 0, 0 },
/* U+2861 */ { 30, 0, 19, 0, 0 },
/* U+2862 */ { 30, 0, 19, 0, 0 },
/* U+2863 */ { 30, 0, 19, 0, 0 },
/* U+2864 */ { 30, 0, 19, 0, 0 },
/* U+2865 */ { 30, 0, 19, 0, 0 },
/* U+2866 */ { 30, 0, 19, 0, 0 },
/* U+2867 */ { 30, 0, 19, 0, 0 },
/* U+2868 */ { 30, 0, 19, 0, 0 },
/* U+2869 */ { 30, 0, 19, 0, 0 },
/* U+286a */ { 30, 0, 19, 0, 0 },
/* U+286b */ { 30, 0, 19, 0, 0 },
/* U+286c */ { 30, 0, 19, 0, 0 },
/* U+286d */ { 30, 0, 19, 0, 0 },
/* U+286e */ { 30, 0, 19, 0, 0 },
/* U+286f */ { 30, 0, 19, 0, 0 },
/* U+2870 */ { 30, 0, 19, 0, 0 },
/* U+2871 */ { 30, 0, 19, 0, 0 },
/* U+2872 */ { 30, 0, 19, 0, 0 },
/* U+2873 */ { 30, 0, 19, 0, 0 },
/* U+2874 */ { 30, 0, 19, 0, 0 },
/* U+2875 */ { 30, 0, 19, 0, 0 },
/* U+2876 */ { 30, 0, 19, 0, 0 },
/* U+2877 */ { 30, 0, 19, 0, 0 },
/* U+2878 */ { 30, 0, 19, 0, 0 },
/* U+2879 */ { 30, 0, 19, 0, 0 },
/* U+287a */ { 30, 0, 19, 0, 0 },
/* U+287b */ { 30, 0, 19, 0, 0 },
/* U+287c */ { 30, 0, 19, 0, 0 },
/* U+287d */ { 30, 0, 19, 0, 0 },
/* U+287e */ { 30, 0, 19, 0, 0 },
/* U+287f */ { 30, 0, 19, 0, 0 },
/* U+2880 */ { 30, 0, 19, 0, 0 },
/* U+2881 */ { 30, 0, 19, 0, 0 },
/* U+2882 */ { 30, 0, 19, 0, 0 },
/* U+2883 */ { 30, 0, 19, 0, 0 },
/* U+2884 */ { 30, 0, 19, 0, 0 },
/* U+2885 */ { 30, 0, 19, 0, 0 },
/* U+2886 */ { 30, 0, 19, 0, 0 },
/* U+2887 */ { 30, 0, 19, 0, 0 },
/* U+2888 */ { 30, 0, 19, 0, 0 },
/* U+2889 */ { 30, 0, 19, 0, 0 },
/* U+288a */ { 30, 0, 19, 0, 0 },
/* U+288b */ { 30, 0, 19, 0, 0 },
/* U+288c */ { 30, 0, 19, 0, 0 },
/* U+288d */ { 30, 0, 19, 0, 0 },
/* U+288e */ { 30, 0, 19, 0, 0 },
/* U+288f */ { 30, 0, 19, 0, 0 },
/* U+2890 */ { 30, 0, 19, 0, 0 },
/* U+2891 */ { 30, 0, 19, 0, 0 },
/* U+2892 */ { 30, 0, 19, 0, 0 },
/* U+2893 */ { 30, 0, 19, 0, 0 },
/* U+2894 */ { 30, 0, 19, 0, 0 },
/* U+2895 */ { 30, 0, 19, 0, 0 },
/* U+2896 */ { 30, 0, 19, 0, 0 },
/* U+2897 */ { 30, 0, 19, 0, 0 },
/* U+2898 */ { 30, 0, 19, 0, 0 },
/* U+2899 */ { 30, 0, 19, 0, 0 },
/* U+289a */ { 30, 0, 19, 0, 0 },
/* U+289b */ { 30, 0, 19, 0, 0 },
/* U+289c */ { 30, 0, 19, 0, 0 },
/* U+289d */ { 30, 0, 19, 0, 0 },
/* U+289e */ { 30, 0, 19, 0, 0 },
/* U+289f */ { 30, 0, 19, 0, 0 },
/* U+28a0 */ { 30, 0, 19, 0, 0 },
/* U+28a1 */ { 30, 0, 19, 0, 0 },
/* U+28a2 */ { 30, 0, 19, 0, 0 },
/* U+28a3 */ { 30, 0, 19, 0, 0 },
/* U+28a4 */ { 30, 0, 19, 0, 0 },
/* U+28a5 */ { 30, 0, 19, 0, 0 },
/* U+28a6 */ { 30, 0, 19, 0, 0 },
/* U+28a7 */ { 30, 0, 19, 0, 0 },
/* U+28a8 */ { 30, 0, 19, 0, 0 },
/* U+28a9 */ { 30, 0, 19, 0, 0 },
/* U+28aa */ { 30, 0, 19, 0, 0 },
/* U+28ab */ { 30, 0, 19, 0, 0 },
/* U+28ac */ { 30, 0, 19, 0, 0 },
/* U+28ad */ { 30, 0, 19, 0, 0 },
/* U+28ae */ { 30, 0, 19, 0, 0 },
/* U+28af */ { 30, 0, 19, 0, 0 },
/* U+28b0 */ { 30, 0, 19, 0, 0 },
/* U+28b1 */ { 30, 0, 19, 0, 0 },
/* U+28b2 */ { 30, 0, 19, 0, 0 },
/* U+28b3 */ { 30, 0, 19, 0, 0 },
/* U+28b4 */ { 30, 0, 19, 0, 0 },
/* U+28b5 */ { 30, 0, 19, 0, 0 },
/* U+28b6 */ { 30, 0, 19, 0, 0 },
/* U+28b7 */ { 30, 0, 19, 0, 0 },
/* U+28b8 */ { 30, 0, 19, 0, 0 },
/* U+28b9 */ { 30, 0, 19, 0, 0 },
/* U+28ba */ { 30, 0, 19, 0, 0 },
/* U+28bb */ { 30, 0, 19, 0, 0 },
/* U+28bc */ { 30, 0, 19, 0, 0 },
/* U+28bd */ { 30, 0, 19, 0, 0 },
/* U+28be */ { 30, 0, 19, 0, 0 },
/* U+28bf */ { 30, 0, 19, 0, 0 },
/* U+28c0 */ { 30, 0, 19, 0, 0 },
/* U+28c1 */ { 30, 0, 19, 0, 0 },
/* U+28c2 */ { 30, 0, 19, 0, 0 },
/* U+28c3 */ { 30, 0, 19, 0, 0 },
/* U+28c4 */ { 30, 0, 19, 0, 0 },
/* U+28c5 */ { 30, 0, 19, 0, 0 },
/* U+28c6 */ { 30, 0, 19, 0, 0 },
/* U+28c7 */ { 30, 0, 19, 0, 0 },
/* U+28c8 */ { 30, 0, 19, 0, 0 },
/* U+28c9 */ { 30, 0, 19, 0, 0 },
/* U+28ca */ { 30, 0, 19, 0, 0 },
/* U+28cb */ { 30, 0, 19, 0, 0 },
/* U+28cc */ { 30, 0, 19, 0, 0 },
/* U+28cd */ { 30, 0, 19, 0, 0 },
/* U+28ce */ { 30, 0, 19, 0, 0 },
/* U+28cf */ { 30, 0, 19, 0, 0 },
/* U+28d0 */ { 30, 0, 19, 0, 0 },
/* U+28d1 */ { 30, 0, 19, 0, 0 },
/* U+28d2 */ { 30, 0, 19, 0, 0 },
/* U+28d3 */ { 30, 0, 19, 0, 0 },
/* U+28d4 */ { 30, 0, 19, 0, 0 },
/* U+28d5 */ { 30, 0, 19, 0, 0 },
/* U+28d6 */ { 30, 0, 19, 0, 0 },
/* U+28d7 */ { 30, 0, 19, 0, 0 },
/* U+28d8 */ { 30, 0, 19, 0, 0 },
/* U+28d9 */ { 30, 0, 19, 0, 0 },
/* U+28da */ { 30, 0, 19, 0, 0 },
/* U+28db */ { 30, 0, 19, 0, 0 },
/* U+28dc */ { 30, 0, 19, 0, 0 },
/* U+28dd */ { 30, 0, 19, 0, 0 },
/* U+28de */ { 30, 0, 19, 0, 0 },
/* U+28df */ { 30, 0, 19, 0, 0 },
/* U+28e0 */ { 30, 0, 19, 0, 0 },
/* U+28e1 */ { 30, 0, 19, 0, 0 },
/* U+28e2 */ { 30, 0, 19, 0, 0 },
/* U+28e3 */ { 30, 0, 19, 0, 0 },
/* U+28e4 */ { 30, 0, 19, 0, 0 },
/* U+28e5 */ { 30, 0, 19, 0, 0 },
/* U+28e6 */ { 30, 0, 19, 0, 0 },
/* U+28e7 */ { 30, 0, 19, 0, 0 },
/* U+28e8 */ { 30, 0, 19, 0, 0 },
/* U+28e9 */ { 30, 0, 19, 0, 0 },
/* U+28ea */ { 30, 0, 19, 0, 0 },
/* U+28eb */ { 30, 0, 19, 0, 0 },
/* U+28ec */ { 30, 0, 19, 0, 0 },
/* U+28ed */ { 30, 0, 19, 0, 0 },
/* U+28ee */ { 30, 0, 19, 0, 0 },
/* U+28ef */ { 30, 0, 19, 0, 0 },
/* U+28f0 */ { 30, 0, 19, 0, 0 },
/* U+28f1 */ { 30, 0, 19, 0, 0 },
/* U+28f2 */ { 30, 0, 19, 0, 0 },
/* U+28f3 */ { 30, 0, 19, 0, 0 },
/* U+28f4 */ { 30, 0, 19, 0, 0 },
/* U+28f5 */ { 30, 0, 19, 0, 0 },
/* U+28f6 */ { 30, 0, 19, 0, 0 },
/* U+28f7 */ { 30, 0, 19, 0, 0 },
/* U+28f8 */ { 30, 0, 19, 0, 0 },
/* U+28f9 */ { 30, 0, 19, 0, 0 },
/* U+28fa */ { 30, 0, 19, 0, 0 },
/* U+28fb */ { 30, 0, 19, 0, 0 },
/* U+28fc */ { 30, 0, 19, 0, 0 },
/* U+28fd */ { 30, 0, 19, 0, 0 },
/* U+28fe */ { 30, 0, 19, 0, 0 },
/* U+28ff */ { 30, 0, 19, 0, 0 },
/* U+2900 */ { 0, 0, 0, 0, 0 },
/* U+2901 */ { 0, 0, 0, 0, 0 },
/* U+2902 */ { 0, 0, 0, 0, 0 },
/* U+2903 */ { 0, 0, 0, 0, 0 },
/* U+2904 */ { 0, 0, 0, 0, 0 },
/* U+2905 */ { 0, 0, 0, 0, 0 },
/* U+2906 */ { 0, 0, 0, 0, 0 },
/* U+2907 */ { 0, 0, 0, 0, 0 },
/* U+2908 */ { 0, 0, 0, 0, 0 },
/* U+2909 */ { 0, 0, 0, 0, 0 },
/* U+290a */ { 0, 0, 0, 0, 0 },
/* U+290b */ { 0, 0, 0, 0, 0 },
/* U+290c */ { 0, 0, 0, 0, 0 },
/* U+290d */ { 0, 0, 0, 0, 0 },
/* U+290e */ { 0, 0, 0, 0, 0 },
/* U+290f */ { 0, 0, 0, 0, 0 },
/* U+2910 */ { 0, 0, 0, 0, 0 },
/* U+2911 */ { 0, 0, 0, 0, 0 },
/* U+2912 */ { 0, 0, 0, 0, 0 },
/* U+2913 */ { 0, 0, 0, 0, 0 },
/* U+2914 */ { 0, 0, 0, 0, 0 },
/* U+2915 */ { 0, 0, 0, 0, 0 },
/* U+2916 */ { 0, 0, 0, 0, 0 },
/* U+2917 */ { 0, 0, 0, 0, 0 },
/* U+2918 */ { 0, 0, 0, 0, 0 },
/* U+2919 */ { 0, 0, 0, 0, 0 },
/* U+291a */ { 0, 0, 0, 0, 0 },
/* U+291b */ { 0, 0, 0, 0, 0 },
/* U+291c */ { 0, 0, 0, 0, 0 },
/* U+291d */ { 0, 0, 0, 0, 0 },
/* U+291e */ { 0, 0, 0, 0, 0 },
/* U+291f */ { 0, 0, 0, 0, 0 },
/* U+2920 */ { 0, 0, 0, 0, 0 },
/* U+2921 */ { 0, 0, 0, 0, 0 },
/* U+2922 */ { 0, 0, 0, 0, 0 },
/* U+2923 */ { 0, 0, 0, 0, 0 },
/* U+2924 */ { 0, 0, 0, 0, 0 },
/* U+2925 */ { 0, 0, 0, 0, 0 },
/* U+2926 */ { 0, 0, 0, 0, 0 },
/* U+2927 */ { 0, 0, 0, 0, 0 },
/* U+2928 */ { 0, 0, 0, 0, 0 },
/* U+2929 */ { 0, 0, 0, 0, 0 },
/* U+292a */ { 0, 0, 0, 0, 0 },
/* U+292b */ { 0, 0, 0, 0, 0 },
/* U+292c */ { 0, 0, 0, 0, 0 },
/* U+292d */ { 0, 0, 0, 0, 0 },
/* U+292e */ { 0, 0, 0, 0, 0 },
/* U+292f */ { 0, 0, 0, 0, 0 },
/* U+2930 */ { 0, 0, 0, 0, 0 },
/* U+2931 */ { 0, 0, 0, 0, 0 },
/* U+2932 */ { 0, 0, 0, 0, 0 },
/* U+2933 */ { 0, 0, 0, 0, 0 },
/* U+2934 */ { 0, 0, 0, 0, 0 },
/* U+2935 */ { 0, 0, 0, 0, 0 },
/* U+2936 */ { 0, 0, 0, 0, 0 },
/* U+2937 */ { 0, 0, 0, 0, 0 },
/* U+2938 */ { 0, 0, 0, 0, 0 },
/* U+2939 */ { 0, 0, 0, 0, 0 },
/* U+293a */ { 0, 0, 0, 0, 0 },
/* U+293b */ { 0, 0, 0, 0, 0 },
/* U+293c */ { 0, 0, 0, 0, 0 },
/* U+293d */ { 0, 0, 0, 0, 0 },
/* U+293e */ { 0, 0, 0, 0, 0 },
/* U+293f */ { 0, 0, 0, 0, 0 },
/* U+2940 */ { 0, 0, 0, 0, 0 },
/* U+2941 */ { 0, 0, 0, 0, 0 },
/* U+2942 */ { 0, 0, 0, 0, 0 },
/* U+2943 */ { 0, 0, 0, 0, 0 },
/* U+2944 */ { 0, 0, 0, 0, 0 },
/* U+2945 */ { 0, 0, 0, 0, 0 },
/* U+2946 */ { 0, 0, 0, 0, 0 },
/* U+2947 */ { 0, 0, 0, 0, 0 },
/* U+2948 */ { 0, 0, 0, 0, 0 },
/* U+2949 */ { 0, 0, 0, 0, 0 },
/* U+294a */ { 0, 0, 0, 0, 0 },
/* U+294b */ { 0, 0, 0, 0, 0 },
/* U+294c */ { 0, 0, 0, 0, 0 },
/* U+294d */ { 0, 0, 0, 0, 0 },
/* U+294e */ { 0, 0, 0, 0, 0 },
/* U+294f */ { 0, 0, 0, 0, 0 },
/* U+2950 */ { 0, 0, 0, 0, 0 },
/* U+2951 */ { 0, 0, 0, 0, 0 },
/* U+2952 */ { 0, 0, 0, 0, 0 },
/* U+2953 */ { 0, 0, 0, 0, 0 },
/* U+2954 */ { 0, 0, 0, 0, 0 },
/* U+2955 */ { 0, 0, 0, 0, 0 },
/* U+2956 */ { 0, 0, 0, 0, 0 },
/* U+2957 */ { 0, 0, 0, 0, 0 },
/* U+2958 */ { 0, 0, 0, 0, 0 },
/* U+2959 */ { 0, 0, 0, 0, 0 },
/* U+295a */ { 0, 0, 0, 0, 0 },
/* U+295b */ { 0, 0, 0, 0, 0 },
/* U+295c */ { 0, 0, 0, 0, 0 },
/* U+295d */ { 0, 0, 0, 0, 0 },
/* U+295e */ { 0, 0, 0, 0, 0 },
/* U+295f */ { 0, 0, 0, 0, 0 },
/* U+2960 */ { 0, 0, 0, 0, 0 },
/* U+2961 */ { 0, 0, 0, 0, 0 },
/* U+2962 */ { 0, 0, 0, 0, 0 },
/* U+2963 */ { 0, 0, 0, 0, 0 },
/* U+2964 */ { 0, 0, 0, 0, 0 },
/* U+2965 */ { 0, 0, 0, 0, 0 },
/* U+2966 */ { 0, 0, 0, 0, 0 },
/* U+2967 */ { 0, 0, 0, 0, 0 },
/* U+2968 */ { 0, 0, 0, 0, 0 },
/* U+2969 */ { 0, 0, 0, 0, 0 },
/* U+296a */ { 0, 0, 0, 0, 0 },
/* U+296b */ { 0, 0, 0, 0, 0 },
/* U+296c */ { 0, 0, 0, 0, 0 },
/* U+296d */ { 0, 0, 0, 0, 0 },
/* U+296e */ { 0, 0, 0, 0, 0 },
/* U+296f */ { 0, 0, 0, 0, 0 },
/* U+2970 */ { 0, 0, 0, 0, 0 },
/* U+2971 */ { 0, 0, 0, 0, 0 },
/* U+2972 */ { 0, 0, 0, 0, 0 },
/* U+2973 */ { 0, 0, 0, 0, 0 },
/* U+2974 */ { 0, 0, 0, 0, 0 },
/* U+2975 */ { 0, 0, 0, 0, 0 },
/* U+2976 */ { 0, 0, 0, 0, 0 },
/* U+2977 */ { 0, 0, 0, 0, 0 },
/* U+2978 */ { 0, 0, 0, 0, 0 },
/* U+2979 */ { 0, 0, 0, 0, 0 },
/* U+297a */ { 0, 0, 0, 0, 0 },
/* U+297b */ { 0, 0, 0, 0, 0 },
/* U+297c */ { 0, 0, 0, 0, 0 },
/* U+297d */ { 0, 0, 0, 0, 0 },
/* U+297e */ { 0, 0, 0, 0, 0 },
/* U+297f */ { 0, 0, 0, 0, 0 },
/* U+2980 */ { 0, 0, 0, 0, 0 },
/* U+2981 */ { 0, 0, 0, 0, 0 },
/* U+2982 */ { 0, 0, 0, 0, 0 },
/* U+2983 */ { 0, 0, 0, 0, 0 },
/* U+2984 */ { 0, 0, 0, 0, 0 },
/* U+2985 */ { 0, 0, 0, 0, 0 },
/* U+2986 */ { 0, 0, 0, 0, 0 },
/* U+2987 */ { 0, 0, 0, 0, 0 },
/* U+2988 */ { 0, 0, 0, 0, 0 },
/* U+2989 */ { 0, 0, 0, 0, 0 },
/* U+298a */ { 0, 0, 0, 0, 0 },
/* U+298b */ { 0, 0, 0, 0, 0 },
/* U+298c */ { 0, 0, 0, 0, 0 },
/* U+298d */ { 0, 0, 0, 0, 0 },
/* U+298e */ { 0, 0, 0, 0, 0 },
/* U+298f */ { 0, 0, 0, 0, 0 },
/* U+2990 */ { 0, 0, 0, 0, 0 },
/* U+2991 */ { 0, 0, 0, 0, 0 },
/* U+2992 */ { 0, 0, 0, 0, 0 },
/* U+2993 */ { 0, 0, 0, 0, 0 },
/* U+2994 */ { 0, 0, 0, 0, 0 },
/* U+2995 */ { 0, 0, 0, 0, 0 },
/* U+2996 */ { 0, 0, 0, 0, 0 },
/* U+2997 */ { 0, 0, 0, 0, 0 },
/* U+2998 */ { 0, 0, 0, 0, 0 },
/* U+2999 */ { 0, 0, 0, 0, 0 },
/* U+299a */ { 0, 0, 0, 0, 0 },
/* U+299b */ { 0, 0, 0, 0, 0 },
/* U+299c */ { 0, 0, 0, 0, 0 },
/* U+299d */ { 0, 0, 0, 0, 0 },
/* U+299e */ { 0, 0, 0, 0, 0 },
/* U+299f */ { 0, 0, 0, 0, 0 },
/* U+29a0 */ { 0, 0, 0, 0, 0 },
/* U+29a1 */ { 0, 0, 0, 0, 0 },
/* U+29a2 */ { 0, 0, 0, 0, 0 },
/* U+29a3 */ { 0, 0, 0, 0, 0 },
/* U+29a4 */ { 0, 0, 0, 0, 0 },
/* U+29a5 */ { 0, 0, 0, 0, 0 },
/* U+29a6 */ { 0, 0, 0, 0, 0 },
/* U+29a7 */ { 0, 0, 0, 0, 0 },
/* U+29a8 */ { 0, 0, 0, 0, 0 },
/* U+29a9 */ { 0, 0, 0, 0, 0 },
/* U+29aa */ { 0, 0, 0, 0, 0 },
/* U+29ab */ { 0, 0, 0, 0, 0 },
/* U+29ac */ { 0, 0, 0, 0, 0 },
/* U+29ad */ { 0, 0, 0, 0, 0 },
/* U+29ae */ { 0, 0, 0, 0, 0 },
/* U+29af */ { 0, 0, 0, 0, 0 },
/* U+29b0 */ { 0, 0, 0, 0, 0 },
/* U+29b1 */ { 0, 0, 0, 0, 0 },
/* U+29b2 */ { 0, 0, 0, 0, 0 },
/* U+29b3 */ { 0, 0, 0, 0, 0 },
/* U+29b4 */ { 0, 0, 0, 0, 0 },
/* U+29b5 */ { 0, 0, 0, 0, 0 },
/* U+29b6 */ { 0, 0, 0, 0, 0 },
/* U+29b7 */ { 0, 0, 0, 0, 0 },
/* U+29b8 */ { 0, 0, 0, 0, 0 },
/* U+29b9 */ { 0, 0, 0, 0, 0 },
/* U+29ba */ { 0, 0, 0, 0, 0 },
/* U+29bb */ { 0, 0, 0, 0, 0 },
/* U+29bc */ { 0, 0, 0, 0, 0 },
/* U+29bd */ { 0, 0, 0, 0, 0 },
/* U+29be */ { 0, 0, 0, 0, 0 },
/* U+29bf */ { 0, 0, 0, 0, 0 },
/* U+29c0 */ { 0, 0, 0, 0, 0 },
/* U+29c1 */ { 0, 0, 0, 0, 0 },
/* U+29c2 */ { 0, 0, 0, 0, 0 },
/* U+29c3 */ { 0, 0, 0, 0, 0 },
/* U+29c4 */ { 0, 0, 0, 0, 0 },
/* U+29c5 */ { 0, 0, 0, 0, 0 },
/* U+29c6 */ { 0, 0, 0, 0, 0 },
/* U+29c7 */ { 0, 0, 0, 0, 0 },
/* U+29c8 */ { 0, 0, 0, 0, 0 },
/* U+29c9 */ { 0, 0, 0, 0, 0 },
/* U+29ca */ { 0, 0, 0, 0, 0 },
/* U+29cb */ { 0, 0, 0, 0, 0 },
/* U+29cc */ { 0, 0, 0, 0, 0 },
/* U+29cd */ { 0, 0, 0, 0, 0 },
/* U+29ce */ { 0, 0, 0, 0, 0 },
/* U+29cf */ { 0, 0, 0, 0, 0 },
/* U+29d0 */ { 0, 0, 0, 0, 0 },
/* U+29d1 */ { 0, 0, 0, 0, 0 },
/* U+29d2 */ { 0, 0, 0, 0, 0 },
/* U+29d3 */ { 0, 0, 0, 0, 0 },
/* U+29d4 */ { 0, 0, 0, 0, 0 },
/* U+29d5 */ { 0, 0, 0, 0, 0 },
/* U+29d6 */ { 0, 0, 0, 0, 0 },
/* U+29d7 */ { 0, 0, 0, 0, 0 },
/* U+29d8 */ { 0, 0, 0, 0, 0 },
/* U+29d9 */ { 0, 0, 0, 0, 0 },
/* U+29da */ { 0, 0, 0, 0, 0 },
/* U+29db */ { 0, 0, 0, 0, 0 },
/* U+29dc */ { 0, 0, 0, 0, 0 },
/* U+29dd */ { 0, 0, 0, 0, 0 },
/* U+29de */ { 0, 0, 0, 0, 0 },
/* U+29df */ { 0, 0, 0, 0, 0 },
/* U+29e0 */ { 0, 0, 0, 0, 0 },
/* U+29e1 */ { 0, 0, 0, 0, 0 },
/* U+29e2 */ { 0, 0, 0, 0, 0 },
/* U+29e3 */ { 0, 0, 0, 0, 0 },
/* U+29e4 */ { 0, 0, 0, 0, 0 },
/* U+29e5 */ { 0, 0, 0, 0, 0 },
/* U+29e6 */ { 0, 0, 0, 0, 0 },
/* U+29e7 */ { 0, 0, 0, 0, 0 },
/* U+29e8 */ { 0, 0, 0, 0, 0 },
/* U+29e9 */ { 0, 0, 0, 0, 0 },
/* U+29ea */ { 0, 0, 0, 0, 0 },
/* U+29eb */ { 0, 0, 0, 0, 0 },
/* U+29ec */ { 0, 0, 0, 0, 0 },
/* U+29ed */ { 0, 0, 0, 0, 0 },
/* U+29ee */ { 0, 0, 0, 0, 0 },
/* U+29ef */ { 0, 0, 0, 0, 0 },
/* U+29f0 */ { 0, 0, 0, 0, 0 },
/* U+29f1 */ { 0, 0, 0, 0, 0 },
/* U+29f2 */ { 0, 0, 0, 0, 0 },
/* U+29f3 */ { 0, 0, 0, 0, 0 },
/* U+29f4 */ { 0, 0, 0, 0, 0 },
/* U+29f5 */ { 0, 0, 0, 0, 0 },
/* U+29f6 */ { 0, 0, 0, 0, 0 },
/* U+29f7 */ { 0, 0, 0, 0, 0 },
/* U+29f8 */ { 0, 0, 0, 0, 0 },
/* U+29f9 */ { 0, 0, 0, 0, 0 },
/* U+29fa */ { 0, 0, 0, 0, 0 },
/* U+29fb */ { 0, 0, 0, 0, 0 },
/* U+29fc */ { 0, 0, 0, 0, 0 },
/* U+29fd */ { 0, 0, 0, 0, 0 },
/* U+29fe */ { 0, 0, 0, 0, 0 },
/* U+29ff */ { 0, 0, 0, 0, 0 },
/* U+2a00 */ { 0, 0, 0, 0, 0 },
/* U+2a01 */ { 0, 0, 0, 0, 0 },
/* U+2a02 */ { 0, 0, 0, 0, 0 },
/* U+2a03 */ { 0, 0, 0, 0, 0 },
/* U+2a04 */ { 0, 0, 0, 0, 0 },
/* U+2a05 */ { 0, 0, 0, 0, 0 },
/* U+2a06 */ { 0, 0, 0, 0, 0 },
/* U+2a07 */ { 0, 0, 0, 0, 0 },
/* U+2a08 */ { 0, 0, 0, 0, 0 },
/* U+2a09 */ { 0, 0, 0, 0, 0 },
/* U+2a0a */ { 0, 0, 0, 0, 0 },
/* U+2a0b */ { 0, 0, 0, 0, 0 },
/* U+2a0c */ { 0, 0, 0, 0, 0 },
/* U+2a0d */ { 0, 0, 0, 0, 0 },
/* U+2a0e */ { 0, 0, 0, 0, 0 },
/* U+2a0f */ { 0, 0, 0, 0, 0 },
/* U+2a10 */ { 0, 0, 0, 0, 0 },
/* U+2a11 */ { 0, 0, 0, 0, 0 },
/* U+2a12 */ { 0, 0, 0, 0, 0 },
/* U+2a13 */ { 0, 0, 0, 0, 0 },
/* U+2a14 */ { 0, 0, 0, 0, 0 },
/* U+2a15 */ { 0, 0, 0, 0, 0 },
/* U+2a16 */ { 0, 0, 0, 0, 0 },
/* U+2a17 */ { 0, 0, 0, 0, 0 },
/* U+2a18 */ { 0, 0, 0, 0, 0 },
/* U+2a19 */ { 0, 0, 0, 0, 0 },
/* U+2a1a */ { 0, 0, 0, 0, 0 },
/* U+2a1b */ { 0, 0, 0, 0, 0 },
/* U+2a1c */ { 0, 0, 0, 0, 0 },
/* U+2a1d */ { 0, 0, 0, 0, 0 },
/* U+2a1e */ { 0, 0, 0, 0, 0 },
/* U+2a1f */ { 0, 0, 0, 0, 0 },
/* U+2a20 */ { 0, 0, 0, 0, 0 },
/* U+2a21 */ { 0, 0, 0, 0, 0 },
/* U+2a22 */ { 0, 0, 0, 0, 0 },
/* U+2a23 */ { 0, 0, 0, 0, 0 },
/* U+2a24 */ { 0, 0, 0, 0, 0 },
/* U+2a25 */ { 0, 0, 0, 0, 0 },
/* U+2a26 */ { 0, 0, 0, 0, 0 },
/* U+2a27 */ { 0, 0, 0, 0, 0 },
/* U+2a28 */ { 0, 0, 0, 0, 0 },
/* U+2a29 */ { 0, 0, 0, 0, 0 },
/* U+2a2a */ { 0, 0, 0, 0, 0 },
/* U+2a2b */ { 0, 0, 0, 0, 0 },
/* U+2a2c */ { 0, 0, 0, 0, 0 },
/* U+2a2d */ { 0, 0, 0, 0, 0 },
/* U+2a2e */ { 0, 0, 0, 0, 0 },
/* U+2a2f */ { 0, 0, 0, 0, 0 },
/* U+2a30 */ { 0, 0, 0, 0, 0 },
/* U+2a31 */ { 0, 0, 0, 0, 0 },
/* U+2a32 */ { 0, 0, 0, 0, 0 },
/* U+2a33 */ { 0, 0, 0, 0, 0 },
/* U+2a34 */ { 0, 0, 0, 0, 0 },
/* U+2a35 */ { 0, 0, 0, 0, 0 },
/* U+2a36 */ { 0, 0, 0, 0, 0 },
/* U+2a37 */ { 0, 0, 0, 0, 0 },
/* U+2a38 */ { 0, 0, 0, 0, 0 },
/* U+2a39 */ { 0, 0, 0, 0, 0 },
/* U+2a3a */ { 0, 0, 0, 0, 0 },
/* U+2a3b */ { 0, 0, 0, 0, 0 },
/* U+2a3c */ { 0, 0, 0, 0, 0 },
/* U+2a3d */ { 0, 0, 0, 0, 0 },
/* U+2a3e */ { 0, 0, 0, 0, 0 },
/* U+2a3f */ { 0, 0, 0, 0, 0 },
/* U+2a40 */ { 0, 0, 0, 0, 0 },
/* U+2a41 */ { 0, 0, 0, 0, 0 },
/* U+2a42 */ { 0, 0, 0, 0, 0 },
/* U+2a43 */ { 0, 0, 0, 0, 0 },
/* U+2a44 */ { 0, 0, 0, 0, 0 },
/* U+2a45 */ { 0, 0, 0, 0, 0 },
/* U+2a46 */ { 0, 0, 0, 0, 0 },
/* U+2a47 */ { 0, 0, 0, 0, 0 },
/* U+2a48 */ { 0, 0, 0, 0, 0 },
/* U+2a49 */ { 0, 0, 0, 0, 0 },
/* U+2a4a */ { 0, 0, 0, 0, 0 },
/* U+2a4b */ { 0, 0, 0, 0, 0 },
/* U+2a4c */ { 0, 0, 0, 0, 0 },
/* U+2a4d */ { 0, 0, 0, 0, 0 },
/* U+2a4e */ { 0, 0, 0, 0, 0 },
/* U+2a4f */ { 0, 0, 0, 0, 0 },
/* U+2a50 */ { 0, 0, 0, 0, 0 },
/* U+2a51 */ { 0, 0, 0, 0, 0 },
/* U+2a52 */ { 0, 0, 0, 0, 0 },
/* U+2a53 */ { 0, 0, 0, 0, 0 },
/* U+2a54 */ { 0, 0, 0, 0, 0 },
/* U+2a55 */ { 0, 0, 0, 0, 0 },
/* U+2a56 */ { 0, 0, 0, 0, 0 },
/* U+2a57 */ { 0, 0, 0, 0, 0 },
/* U+2a58 */ { 0, 0, 0, 0, 0 },
/* U+2a59 */ { 0, 0, 0, 0, 0 },
/* U+2a5a */ { 0, 0, 0, 0, 0 },
/* U+2a5b */ { 0, 0, 0, 0, 0 },
/* U+2a5c */ { 0, 0, 0, 0, 0 },
/* U+2a5d */ { 0, 0, 0, 0, 0 },
/* U+2a5e */ { 0, 0, 0, 0, 0 },
/* U+2a5f */ { 0, 0, 0, 0, 0 },
/* U+2a60 */ { 0, 0, 0, 0, 0 },
/* U+2a61 */ { 0, 0, 0, 0, 0 },
/* U+2a62 */ { 0, 0, 0, 0, 0 },
/* U+2a63 */ { 0, 0, 0, 0, 0 },
/* U+2a64 */ { 0, 0, 0, 0, 0 },
/* U+2a65 */ { 0, 0, 0, 0, 0 },
/* U+2a66 */ { 0, 0, 0, 0, 0 },
/* U+2a67 */ { 0, 0, 0, 0, 0 },
/* U+2a68 */ { 0, 0, 0, 0, 0 },
/* U+2a69 */ { 0, 0, 0, 0, 0 },
/* U+2a6a */ { 0, 0, 0, 0, 0 },
/* U+2a6b */ { 0, 0, 0, 0, 0 },
/* U+2a6c */ { 0, 0, 0, 0, 0 },
/* U+2a6d */ { 0, 0, 0, 0, 0 },
/* U+2a6e */ { 0, 0, 0, 0, 0 },
/* U+2a6f */ { 0, 0, 0, 0, 0 },
/* U+2a70 */ { 0, 0, 0, 0, 0 },
/* U+2a71 */ { 0, 0, 0, 0, 0 },
/* U+2a72 */ { 0, 0, 0, 0, 0 },
/* U+2a73 */ { 0, 0, 0, 0, 0 },
/* U+2a74 */ { 0, 0, 0, 0, 0 },
/* U+2a75 */ { 0, 0, 0, 0, 0 },
/* U+2a76 */ { 0, 0, 0, 0, 0 },
/* U+2a77 */ { 0, 0, 0, 0, 0 },
/* U+2a78 */ { 0, 0, 0, 0, 0 },
/* U+2a79 */ { 0, 0, 0, 0, 0 },
/* U+2a7a */ { 0, 0, 0, 0, 0 },
/* U+2a7b */ { 0, 0, 0, 0, 0 },
/* U+2a7c */ { 0, 0, 0, 0, 0 },
/* U+2a7d */ { 0, 0, 0, 0, 0 },
/* U+2a7e */ { 0, 0, 0, 0, 0 },
/* U+2a7f */ { 0, 0, 0, 0, 0 },
/* U+2a80 */ { 0, 0, 0, 0, 0 },
/* U+2a81 */ { 0, 0, 0, 0, 0 },
/* U+2a82 */ { 0, 0, 0, 0, 0 },
/* U+2a83 */ { 0, 0, 0, 0, 0 },
/* U+2a84 */ { 0, 0, 0, 0, 0 },
/* U+2a85 */ { 0, 0, 0, 0, 0 },
/* U+2a86 */ { 0, 0, 0, 0, 0 },
/* U+2a87 */ { 0, 0, 0, 0, 0 },
/* U+2a88 */ { 0, 0, 0, 0, 0 },
/* U+2a89 */ { 0, 0, 0, 0, 0 },
/* U+2a8a */ { 0, 0, 0, 0, 0 },
/* U+2a8b */ { 0, 0, 0, 0, 0 },
/* U+2a8c */ { 0, 0, 0, 0, 0 },
/* U+2a8d */ { 0, 0, 0, 0, 0 },
/* U+2a8e */ { 0, 0, 0, 0, 0 },
/* U+2a8f */ { 0, 0, 0, 0, 0 },
/* U+2a90 */ { 0, 0, 0, 0, 0 },
/* U+2a91 */ { 0, 0, 0, 0, 0 },
/* U+2a92 */ { 0, 0, 0, 0, 0 },
/* U+2a93 */ { 0, 0, 0, 0, 0 },
/* U+2a94 */ { 0, 0, 0, 0, 0 },
/* U+2a95 */ { 0, 0, 0, 0, 0 },
/* U+2a96 */ { 0, 0, 0, 0, 0 },
/* U+2a97 */ { 0, 0, 0, 0, 0 },
/* U+2a98 */ { 0, 0, 0, 0, 0 },
/* U+2a99 */ { 0, 0, 0, 0, 0 },
/* U+2a9a */ { 0, 0, 0, 0, 0 },
/* U+2a9b */ { 0, 0, 0, 0, 0 },
/* U+2a9c */ { 0, 0, 0, 0, 0 },
/* U+2a9d */ { 0, 0, 0, 0, 0 },
/* U+2a9e */ { 0, 0, 0, 0, 0 },
/* U+2a9f */ { 0, 0, 0, 0, 0 },
/* U+2aa0 */ { 0, 0, 0, 0, 0 },
/* U+2aa1 */ { 0, 0, 0, 0, 0 },
/* U+2aa2 */ { 0, 0, 0, 0, 0 },
/* U+2aa3 */ { 0, 0, 0, 0, 0 },
/* U+2aa4 */ { 0, 0, 0, 0, 0 },
/* U+2aa5 */ { 0, 0, 0, 0, 0 },
/* U+2aa6 */ { 0, 0, 0, 0, 0 },
/* U+2aa7 */ { 0, 0, 0, 0, 0 },
/* U+2aa8 */ { 0, 0, 0, 0, 0 },
/* U+2aa9 */ { 0, 0, 0, 0, 0 },
/* U+2aaa */ { 0, 0, 0, 0, 0 },
/* U+2aab */ { 0, 0, 0, 0, 0 },
/* U+2aac */ { 0, 0, 0, 0, 0 },
/* U+2aad */ { 0, 0, 0, 0, 0 },
/* U+2aae */ { 0, 0, 0, 0, 0 },
/* U+2aaf */ { 0, 0, 0, 0, 0 },
/* U+2ab0 */ { 0, 0, 0, 0, 0 },
/* U+2ab1 */ { 0, 0, 0, 0, 0 },
/* U+2ab2 */ { 0, 0, 0, 0, 0 },
/* U+2ab3 */ { 0, 0, 0, 0, 0 },
/* U+2ab4 */ { 0, 0, 0, 0, 0 },
/* U+2ab5 */ { 0, 0, 0, 0, 0 },
/* U+2ab6 */ { 0, 0, 0, 0, 0 },
/* U+2ab7 */ { 0, 0, 0, 0, 0 },
/* U+2ab8 */ { 0, 0, 0, 0, 0 },
/* U+2ab9 */ { 0, 0, 0, 0, 0 },
/* U+2aba */ { 0, 0, 0, 0, 0 },
/* U+2abb */ { 0, 0, 0, 0, 0 },
/* U+2abc */ { 0, 0, 0, 0, 0 },
/* U+2abd */ { 0, 0, 0, 0, 0 },
/* U+2abe */ { 0, 0, 0, 0, 0 },
/* U+2abf */ { 0, 0, 0, 0, 0 },
/* U+2ac0 */ { 0, 0, 0, 0, 0 },
/* U+2ac1 */ { 0, 0, 0, 0, 0 },
/* U+2ac2 */ { 0, 0, 0, 0, 0 },
/* U+2ac3 */ { 0, 0, 0, 0, 0 },
/* U+2ac4 */ { 0, 0, 0, 0, 0 },
/* U+2ac5 */ { 0, 0, 0, 0, 0 },
/* U+2ac6 */ { 0, 0, 0, 0, 0 },
/* U+2ac7 */ { 0, 0, 0, 0, 0 },
/* U+2ac8 */ { 0, 0, 0, 0, 0 },
/* U+2ac9 */ { 0, 0, 0, 0, 0 },
/* U+2aca */ { 0, 0, 0, 0, 0 },
/* U+2acb */ { 0, 0, 0, 0, 0 },
/* U+2acc */ { 0, 0, 0, 0, 0 },
/* U+2acd */ { 0, 0, 0, 0, 0 },
/* U+2ace */ { 0, 0, 0, 0, 0 },
/* U+2acf */ { 0, 0, 0, 0, 0 },
/* U+2ad0 */ { 0, 0, 0, 0, 0 },
/* U+2ad1 */ { 0, 0, 0, 0, 0 },
/* U+2ad2 */ { 0, 0, 0, 0, 0 },
/* U+2ad3 */ { 0, 0, 0, 0, 0 },
/* U+2ad4 */ { 0, 0, 0, 0, 0 },
/* U+2ad5 */ { 0, 0, 0, 0, 0 },
/* U+2ad6 */ { 0, 0, 0, 0, 0 },
/* U+2ad7 */ { 0, 0, 0, 0, 0 },
/* U+2ad8 */ { 0, 0, 0, 0, 0 },
/* U+2ad9 */ { 0, 0, 0, 0, 0 },
/* U+2ada */ { 0, 0, 0, 0, 0 },
/* U+2adb */ { 0, 0, 0, 0, 0 },
/* U+2adc */ { 0, 0, 0, 0, 0 },
/* U+2add */ { 0, 0, 0, 0, 0 },
/* U+2ade */ { 0, 0, 0, 0, 0 },
/* U+2adf */ { 0, 0, 0, 0, 0 },
/* U+2ae0 */ { 0, 0, 0, 0, 0 },
/* U+2ae1 */ { 0, 0, 0, 0, 0 },
/* U+2ae2 */ { 0, 0, 0, 0, 0 },
/* U+2ae3 */ { 0, 0, 0, 0, 0 },
/* U+2ae4 */ { 0, 0, 0, 0, 0 },
/* U+2ae5 */ { 0, 0, 0, 0, 0 },
/* U+2ae6 */ { 0, 0, 0, 0, 0 },
/* U+2ae7 */ { 0, 0, 0, 0, 0 },
/* U+2ae8 */ { 0, 0, 0, 0, 0 },
/* U+2ae9 */ { 0, 0, 0, 0, 0 },
/* U+2aea */ { 0, 0, 0, 0, 0 },
/* U+2aeb */ { 0, 0, 0, 0, 0 },
/* U+2aec */ { 0, 0, 0, 0, 0 },
/* U+2aed */ { 0, 0, 0, 0, 0 },
/* U+2aee */ { 0, 0, 0, 0, 0 },
/* U+2aef */ { 0, 0, 0, 0, 0 },
/* U+2af0 */ { 0, 0, 0, 0, 0 },
/* U+2af1 */ { 0, 0, 0, 0, 0 },
/* U+2af2 */ { 0, 0, 0, 0, 0 },
/* U+2af3 */ { 0, 0, 0, 0, 0 },
/* U+2af4 */ { 0, 0, 0, 0, 0 },
/* U+2af5 */ { 0, 0, 0, 0, 0 },
/* U+2af6 */ { 0, 0, 0, 0, 0 },
/* U+2af7 */ { 0, 0, 0, 0, 0 },
/* U+2af8 */ { 0, 0, 0, 0, 0 },
/* U+2af9 */ { 0, 0, 0, 0, 0 },
/* U+2afa */ { 0, 0, 0, 0, 0 },
/* U+2afb */ { 0, 0, 0, 0, 0 },
/* U+2afc */ { 0, 0, 0, 0, 0 },
/* U+2afd */ { 0, 0, 0, 0, 0 },
/* U+2afe */ { 0, 0, 0, 0, 0 },
/* U+2aff */ { 0, 0, 0, 0, 0 },
/* U+2b00 */ { 0, 0, 0, 0, 0 },
/* U+2b01 */ { 0, 0, 0, 0, 0 },
/* U+2b02 */ { 0, 0, 0, 0, 0 },
/* U+2b03 */ { 0, 0, 0, 0, 0 },
/* U+2b04 */ { 0, 0, 0, 0, 0 },
/* U+2b05 */ { 0, 0, 0, 0, 0 },
/* U+2b06 */ { 0, 0, 0, 0, 0 },
/* U+2b07 */ { 0, 0, 0, 0, 0 },
/* U+2b08 */ { 0, 0, 0, 0, 0 },
/* U+2b09 */ { 0, 0, 0, 0, 0 },
/* U+2b0a */ { 0, 0, 0, 0, 0 },
/* U+2b0b */ { 0, 0, 0, 0, 0 },
/* U+2b0c */ { 0, 0, 0, 0, 0 },
/* U+2b0d */ { 0, 0, 0, 0, 0 },
/* U+2b0e */ { 0, 0, 0, 0, 0 },
/* U+2b0f */ { 0, 0, 0, 0, 0 },
/* U+2b10 */ { 0, 0, 0, 0, 0 },
/* U+2b11 */ { 0, 0, 0, 0, 0 },
/* U+2b12 */ { 0, 0, 0, 0, 0 },
/* U+2b13 */ { 0, 0, 0, 0, 0 },
/* U+2b14 */ { 0, 0, 0, 0, 0 },
/* U+2b15 */ { 0, 0, 0, 0, 0 },
/* U+2b16 */ { 0, 0, 0, 0, 0 },
/* U+2b17 */ { 0, 0, 0, 0, 0 },
/* U+2b18 */ { 0, 0, 0, 0, 0 },
/* U+2b19 */ { 0, 0, 0, 0, 0 },
/* U+2b1a */ { 0, 0, 0, 0, 0 },
/* U+2b1b */ { 0, 0, 0, 0, 0 },
/* U+2b1c */ { 0, 0, 0, 0, 0 },
/* U+2b1d */ { 0, 0, 0, 0, 0 },
/* U+2b1e */ { 0, 0, 0, 0, 0 },
/* U+2b1f */ { 0, 0, 0, 0, 0 },
/* U+2b20 */ { 0, 0, 0, 0, 0 },
/* U+2b21 */ { 0, 0, 0, 0, 0 },
/* U+2b22 */ { 0, 0, 0, 0, 0 },
/* U+2b23 */ { 0, 0, 0, 0, 0 },
/* U+2b24 */ { 0, 0, 0, 0, 0 },
/* U+2b25 */ { 0, 0, 0, 0, 0 },
/* U+2b26 */ { 0, 0, 0, 0, 0 },
/* U+2b27 */ { 0, 0, 0, 0, 0 },
/* U+2b28 */ { 0, 0, 0, 0, 0 },
/* U+2b29 */ { 0, 0, 0, 0, 0 },
/* U+2b2a */ { 0, 0, 0, 0, 0 },
/* U+2b2b */ { 0, 0, 0, 0, 0 },
/* U+2b2c */ { 0, 0, 0, 0, 0 },
/* U+2b2d */ { 0, 0, 0, 0, 0 },
/* U+2b2e */ { 0, 0, 0, 0, 0 },
/* U+2b2f */ { 0, 0, 0, 0, 0 },
/* U+2b30 */ { 0, 0, 0, 0, 0 },
/* U+2b31 */ { 0, 0, 0, 0, 0 },
/* U+2b32 */ { 0, 0, 0, 0, 0 },
/* U+2b33 */ { 0, 0, 0, 0, 0 },
/* U+2b34 */ { 0, 0, 0, 0, 0 },
/* U+2b35 */ { 0, 0, 0, 0, 0 },
/* U+2b36 */ { 0, 0, 0, 0, 0 },
/* U+2b37 */ { 0, 0, 0, 0, 0 },
/* U+2b38 */ { 0, 0, 0, 0, 0 },
/* U+2b39 */ { 0, 0, 0, 0, 0 },
/* U+2b3a */ { 0, 0, 0, 0, 0 },
/* U+2b3b */ { 0, 0, 0, 0, 0 },
/* U+2b3c */ { 0, 0, 0, 0, 0 },
/* U+2b3d */ { 0, 0, 0, 0, 0 },
/* U+2b3e */ { 0, 0, 0, 0, 0 },
/* U+2b3f */ { 0, 0, 0, 0, 0 },
/* U+2b40 */ { 0, 0, 0, 0, 0 },
/* U+2b41 */ { 0, 0, 0, 0, 0 },
/* U+2b42 */ { 0, 0, 0, 0, 0 },
/* U+2b43 */ { 0, 0, 0, 0, 0 },
/* U+2b44 */ { 0, 0, 0, 0, 0 },
/* U+2b45 */ { 0, 0, 0, 0, 0 },
/* U+2b46 */ { 0, 0, 0, 0, 0 },
/* U+2b47 */ { 0, 0, 0, 0, 0 },
/* U+2b48 */ { 0, 0, 0, 0, 0 },
/* U+2b49 */ { 0, 0, 0, 0, 0 },
/* U+2b4a */ { 0, 0, 0, 0, 0 },
/* U+2b4b */ { 0, 0, 0, 0, 0 },
/* U+2b4c */ { 0, 0, 0, 0, 0 },
/* U+2b4d */ { 0, 0, 0, 0, 0 },
/* U+2b4e */ { 0, 0, 0, 0, 0 },
/* U+2b4f */ { 0, 0, 0, 0, 0 },
/* U+2b50 */ { 0, 0, 0, 0, 0 },
/* U+2b51 */ { 0, 0, 0, 0, 0 },
/* U+2b52 */ { 0, 0, 0, 0, 0 },
/* U+2b53 */ { 0, 0, 0, 0, 0 },
/* U+2b54 */ { 0, 0, 0, 0, 0 },
/* U+2b55 */ { 0, 0, 0, 0, 0 },
/* U+2b56 */ { 0, 0, 0, 0, 0 },
/* U+2b57 */ { 0, 0, 0, 0, 0 },
/* U+2b58 */ { 0, 0, 0, 0, 0 },
/* U+2b59 */ { 0, 0, 0, 0, 0 },
/* U+2b5a */ { 0, 0, 0, 0, 0 },
/* U+2b5b */ { 0, 0, 0, 0, 0 },
/* U+2b5c */ { 0, 0, 0, 0, 0 },
/* U+2b5d */ { 0, 0, 0, 0, 0 },
/* U+2b5e */ { 0, 0, 0, 0, 0 },
/* U+2b5f */ { 0, 0, 0, 0, 0 },
/* U+2b60 */ { 0, 0, 0, 0, 0 },
/* U+2b61 */ { 0, 0, 0, 0, 0 },
/* U+2b62 */ { 0, 0, 0, 0, 0 },
/* U+2b63 */ { 0, 0, 0, 0, 0 },
/* U+2b64 */ { 0, 0, 0, 0, 0 },
/* U+2b65 */ { 0, 0, 0, 0, 0 },
/* U+2b66 */ { 0, 0, 0, 0, 0 },
/* U+2b67 */ { 0, 0, 0, 0, 0 },
/* U+2b68 */ { 0, 0, 0, 0, 0 },
/* U+2b69 */ { 0, 0, 0, 0, 0 },
/* U+2b6a */ { 0, 0, 0, 0, 0 },
/* U+2b6b */ { 0, 0, 0, 0, 0 },
/* U+2b6c */ { 0, 0, 0, 0, 0 },
/* U+2b6d */ { 0, 0, 0, 0, 0 },
/* U+2b6e */ { 0, 0, 0, 0, 0 },
/* U+2b6f */ { 0, 0, 0, 0, 0 },
/* U+2b70 */ { 0, 0, 0, 0, 0 },
/* U+2b71 */ { 0, 0, 0, 0, 0 },
/* U+2b72 */ { 0, 0, 0, 0, 0 },
/* U+2b73 */ { 0, 0, 0, 0, 0 },
/* U+2b74 */ { 0, 0, 0, 0, 0 },
/* U+2b75 */ { 0, 0, 0, 0, 0 },
/* U+2b76 */ { 0, 0, 0, 0, 0 },
/* U+2b77 */ { 0, 0, 0, 0, 0 },
/* U+2b78 */ { 0, 0, 0, 0, 0 },
/* U+2b79 */ { 0, 0, 0, 0, 0 },
/* U+2b7a */ { 0, 0, 0, 0, 0 },
/* U+2b7b */ { 0, 0, 0, 0, 0 },
/* U+2b7c */ { 0, 0, 0, 0, 0 },
/* U+2b7d */ { 0, 0, 0, 0, 0 },
/* U+2b7e */ { 0, 0, 0, 0, 0 },
/* U+2b7f */ { 0, 0, 0, 0, 0 },
/* U+2b80 */ { 0, 0, 0, 0, 0 },
/* U+2b81 */ { 0, 0, 0, 0, 0 },
/* U+2b82 */ { 0, 0, 0, 0, 0 },
/* U+2b83 */ { 0, 0, 0, 0, 0 },
/* U+2b84 */ { 0, 0, 0, 0, 0 },
/* U+2b85 */ { 0, 0, 0, 0, 0 },
/* U+2b86 */ { 0, 0, 0, 0, 0 },
/* U+2b87 */ { 0, 0, 0, 0, 0 },
/* U+2b88 */ { 0, 0, 0, 0, 0 },
/* U+2b89 */ { 0, 0, 0, 0, 0 },
/* U+2b8a */ { 0, 0, 0, 0, 0 },
/* U+2b8b */ { 0, 0, 0, 0, 0 },
/* U+2b8c */ { 0, 0, 0, 0, 0 },
/* U+2b8d */ { 0, 0, 0, 0, 0 },
/* U+2b8e */ { 0, 0, 0, 0, 0 },
/* U+2b8f */ { 0, 0, 0, 0, 0 },
/* U+2b90 */ { 0, 0, 0, 0, 0 },
/* U+2b91 */ { 0, 0, 0, 0, 0 },
/* U+2b92 */ { 0, 0, 0, 0, 0 },
/* U+2b93 */ { 0, 0, 0, 0, 0 },
/* U+2b94 */ { 0, 0, 0, 0, 0 },
/* U+2b95 */ { 0, 0, 0, 0, 0 },
/* U+2b96 */ { 0, 0, 0, 0, 0 },
/* U+2b97 */ { 0, 0, 0, 0, 0 },
/* U+2b98 */ { 0, 0, 0, 0, 0 },
/* U+2b99 */ { 0, 0, 0, 0, 0 },
/* U+2b9a */ { 0, 0, 0, 0, 0 },
/* U+2b9b */ { 0, 0, 0, 0, 0 },
/* U+2b9c */ { 0, 0, 0, 0, 0 },
/* U+2b9d */ { 0, 0, 0, 0, 0 },
/* U+2b9e */ { 0, 0, 0, 0, 0 },
/* U+2b9f */ { 0, 0, 0, 0, 0 },
/* U+2ba0 */ { 0, 0, 0, 0, 0 },
/* U+2ba1 */ { 0, 0, 0, 0, 0 },
/* U+2ba2 */ { 0, 0, 0, 0, 0 },
/* U+2ba3 */ { 0, 0, 0, 0, 0 },
/* U+2ba4 */ { 0, 0, 0, 0, 0 },
/* U+2ba5 */ { 0, 0, 0, 0, 0 },
/* U+2ba6 */ { 0, 0, 0, 0, 0 },
/* U+2ba7 */ { 0, 0, 0, 0, 0 },
/* U+2ba8 */ { 0, 0, 0, 0, 0 },
/* U+2ba9 */ { 0, 0, 0, 0, 0 },
/* U+2baa */ { 0, 0, 0, 0, 0 },
/* U+2bab */ { 0, 0, 0, 0, 0 },
/* U+2bac */ { 0, 0, 0, 0, 0 },
/* U+2bad */ { 0, 0, 0, 0, 0 },
/* U+2bae */ { 0, 0, 0, 0, 0 },
/* U+2baf */ { 0, 0, 0, 0, 0 },
/* U+2bb0 */ { 0, 0, 0, 0, 0 },
/* U+2bb1 */ { 0, 0, 0, 0, 0 },
/* U+2bb2 */ { 0, 0, 0, 0, 0 },
/* U+2bb3 */ { 0, 0, 0, 0, 0 },
/* U+2bb4 */ { 0, 0, 0, 0, 0 },
/* U+2bb5 */ { 0, 0, 0, 0, 0 },
/* U+2bb6 */ { 0, 0, 0, 0, 0 },
/* U+2bb7 */ { 0, 0, 0, 0, 0 },
/* U+2bb8 */ { 0, 0, 0, 0, 0 },
/* U+2bb9 */ { 0, 0, 0, 0, 0 },
/* U+2bba */ { 0, 0, 0, 0, 0 },
/* U+2bbb */ { 0, 0, 0, 0, 0 },
/* U+2bbc */ { 0, 0, 0, 0, 0 },
/* U+2bbd */ { 0, 0, 0, 0, 0 },
/* U+2bbe */ { 0, 0, 0, 0, 0 },
/* U+2bbf */ { 0, 0, 0, 0, 0 },
/* U+2bc0 */ { 0, 0, 0, 0, 0 },
/* U+2bc1 */ { 0, 0, 0, 0, 0 },
/* U+2bc2 */ { 0, 0, 0, 0, 0 },
/* U+2bc3 */ { 0, 0, 0, 0, 0 },
/* U+2bc4 */ { 0, 0, 0, 0, 0 },
/* U+2bc5 */ { 0, 0, 0, 0, 0 },
/* U+2bc6 */ { 0, 0, 0, 0, 0 },
/* U+2bc7 */ { 0, 0, 0, 0, 0 },
/* U+2bc8 */ { 0, 0, 0, 0, 0 },
/* U+2bc9 */ { 0, 0, 0, 0, 0 },
/* U+2bca */ { 0, 0, 0, 0, 0 },
/* U+2bcb */ { 0, 0, 0, 0, 0 },
/* U+2bcc */ { 0, 0, 0, 0, 0 },
/* U+2bcd */ { 0, 0, 0, 0, 0 },
/* U+2bce */ { 0, 0, 0, 0, 0 },
/* U+2bcf */ { 0, 0, 0, 0, 0 },
/* U+2bd0 */ { 0, 0, 0, 0, 0 },
/* U+2bd1 */ { 0, 0, 0, 0, 0 },
/* U+2bd2 */ { 0, 0, 0, 0, 0 },
/* U+2bd3 */ { 0, 0, 0, 0, 0 },
/* U+2bd4 */ { 0, 0, 0, 0, 0 },
/* U+2bd5 */ { 0, 0, 0, 0, 0 },
/* U+2bd6 */ { 0, 0, 0, 0, 0 },
/* U+2bd7 */ { 0, 0, 0, 0, 0 },
/* U+2bd8 */ { 0, 0, 0, 0, 0 },
/* U+2bd9 */ { 0, 0, 0, 0, 0 },
/* U+2bda */ { 0, 0, 0, 0, 0 },
/* U+2bdb */ { 0, 0, 0, 0, 0 },
/* U+2bdc */ { 0, 0, 0, 0, 0 },
/* U+2bdd */ { 0, 0, 0, 0, 0 },
/* U+2bde */ { 0, 0, 0, 0, 0 },
/* U+2bdf */ { 0, 0, 0, 0, 0 },
/* U+2be0 */ { 0, 0, 0, 0, 0 },
/* U+2be1 */ { 0, 0, 0, 0, 0 },
/* U+2be2 */ { 0, 0, 0, 0, 0 },
/* U+2be3 */ { 0, 0, 0, 0, 0 },
/* U+2be4 */ { 0, 0, 0, 0, 0 },
/* U+2be5 */ { 0, 0, 0, 0, 0 },
/* U+2be6 */ { 0, 0, 0, 0, 0 },
/* U+2be7 */ { 0, 0, 0, 0, 0 },
/* U+2be8 */ { 0, 0, 0, 0, 0 },
/* U+2be9 */ { 0, 0, 0, 0, 0 },
/* U+2bea */ { 0, 0, 0, 0, 0 },
/* U+2beb */ { 0, 0, 0, 0, 0 },
/* U+2bec */ { 0, 0, 0, 0, 0 },
/* U+2bed */ { 0, 0, 0, 0, 0 },
/* U+2bee */ { 0, 0, 0, 0, 0 },
/* U+2bef */ { 0, 0, 0, 0, 0 },
/* U+2bf0 */ { 0, 0, 0, 0, 0 },
/* U+2bf1 */ { 0, 0, 0, 0, 0 },
/* U+2bf2 */ { 0, 0, 0, 0, 0 },
/* U+2bf3 */ { 0, 0, 0, 0, 0 },
/* U+2bf4 */ { 0, 0, 0, 0, 0 },
/* U+2bf5 */ { 0, 0, 0, 0, 0 },
/* U+2bf6 */ { 0, 0, 0, 0, 0 },
/* U+2bf7 */ { 0, 0, 0, 0, 0 },
/* U+2bf8 */ { 0, 0, 0, 0, 0 },
/* U+2bf9 */ { 0, 0, 0, 0, 0 },
/* U+2bfa */ { 0, 0, 0, 0, 0 },
/* U+2bfb */ { 0, 0, 0, 0, 0 },
/* U+2bfc */ { 0, 0, 0, 0, 0 },
/* U+2bfd */ { 0, 0, 0, 0, 0 },
/* U+2bfe */ { 0, 0, 0, 0, 0 },
/* U+2bff */ { 0, 0, 0, 0, 0 },
/* U+2c00 */ { 0, 0, 0, 0, 0 },
/* U+2c01 */ { 0, 0, 0, 0, 0 },
/* U+2c02 */ { 0, 0, 0, 0, 0 },
/* U+2c03 */ { 0, 0, 0, 0, 0 },
/* U+2c04 */ { 0, 0, 0, 0, 0 },
/* U+2c05 */ { 0, 0, 0, 0, 0 },
/* U+2c06 */ { 0, 0, 0, 0, 0 },
/* U+2c07 */ { 0, 0, 0, 0, 0 },
/* U+2c08 */ { 0, 0, 0, 0, 0 },
/* U+2c09 */ { 0, 0, 0, 0, 0 },
/* U+2c0a */ { 0, 0, 0, 0, 0 },
/* U+2c0b */ { 0, 0, 0, 0, 0 },
/* U+2c0c */ { 0, 0, 0, 0, 0 },
/* U+2c0d */ { 0, 0, 0, 0, 0 },
/* U+2c0e */ { 0, 0, 0, 0, 0 },
/* U+2c0f */ { 0, 0, 0, 0, 0 },
/* U+2c10 */ { 0, 0, 0, 0, 0 },
/* U+2c11 */ { 0, 0, 0, 0, 0 },
/* U+2c12 */ { 0, 0, 0, 0, 0 },
/* U+2c13 */ { 0, 0, 0, 0, 0 },
/* U+2c14 */ { 0, 0, 0, 0, 0 },
/* U+2c15 */ { 0, 0, 0, 0, 0 },
/* U+2c16 */ { 0, 0, 0, 0, 0 },
/* U+2c17 */ { 0, 0, 0, 0, 0 },
/* U+2c18 */ { 0, 0, 0, 0, 0 },
/* U+2c19 */ { 0, 0, 0, 0, 0 },
/* U+2c1a */ { 0, 0, 0, 0, 0 },
/* U+2c1b */ { 0, 0, 0, 0, 0 },
/* U+2c1c */ { 0, 0, 0, 0, 0 },
/* U+2c1d */ { 0, 0, 0, 0, 0 },
/* U+2c1e */ { 0, 0, 0, 0, 0 },
/* U+2c1f */ { 0, 0, 0, 0, 0 },
/* U+2c20 */ { 0, 0, 0, 0, 0 },
/* U+2c21 */ { 0, 0, 0, 0, 0 },
/* U+2c22 */ { 0, 0, 0, 0, 0 },
/* U+2c23 */ { 0, 0, 0, 0, 0 },
/* U+2c24 */ { 0, 0, 0, 0, 0 },
/* U+2c25 */ { 0, 0, 0, 0, 0 },
/* U+2c26 */ { 0, 0, 0, 0, 0 },
/* U+2c27 */ { 0, 0, 0, 0, 0 },
/* U+2c28 */ { 0, 0, 0, 0, 0 },
/* U+2c29 */ { 0, 0, 0, 0, 0 },
/* U+2c2a */ { 0, 0, 0, 0, 0 },
/* U+2c2b */ { 0, 0, 0, 0, 0 },
/* U+2c2c */ { 0, 0, 0, 0, 0 },
/* U+2c2d */ { 0, 0, 0, 0, 0 },
/* U+2c2e */ { 0, 0, 0, 0, 0 },
/* U+2c2f */ { 0, 0, 0, 0, 0 },
/* U+2c30 */ { 0, 0, 0, 0, 0 },
/* U+2c31 */ { 0, 0, 0, 0, 0 },
/* U+2c32 */ { 0, 0, 0, 0, 0 },
/* U+2c33 */ { 0, 0, 0, 0, 0 },
/* U+2c34 */ { 0, 0, 0, 0, 0 },
/* U+2c35 */ { 0, 0, 0, 0, 0 },
/* U+2c36 */ { 0, 0, 0, 0, 0 },
/* U+2c37 */ { 0, 0, 0, 0, 0 },
/* U+2c38 */ { 0, 0, 0, 0, 0 },
/* U+2c39 */ { 0, 0, 0, 0, 0 },
/* U+2c3a */ { 0, 0, 0, 0, 0 },
/* U+2c3b */ { 0, 0, 0, 0, 0 },
/* U+2c3c */ { 0, 0, 0, 0, 0 },
/* U+2c3d */ { 0, 0, 0, 0, 0 },
/* U+2c3e */ { 0, 0, 0, 0, 0 },
/* U+2c3f */ { 0, 0, 0, 0, 0 },
/* U+2c40 */ { 0, 0, 0, 0, 0 },
/* U+2c41 */ { 0, 0, 0, 0, 0 },
/* U+2c42 */ { 0, 0, 0, 0, 0 },
/* U+2c43 */ { 0, 0, 0, 0, 0 },
/* U+2c44 */ { 0, 0, 0, 0, 0 },
/* U+2c45 */ { 0, 0, 0, 0, 0 },
/* U+2c46 */ { 0, 0, 0, 0, 0 },
/* U+2c47 */ { 0, 0, 0, 0, 0 },
/* U+2c48 */ { 0, 0, 0, 0, 0 },
/* U+2c49 */ { 0, 0, 0, 0, 0 },
/* U+2c4a */ { 0, 0, 0, 0, 0 },
/* U+2c4b */ { 0, 0, 0, 0, 0 },
/* U+2c4c */ { 0, 0, 0, 0, 0 },
/* U+2c4d */ { 0, 0, 0, 0, 0 },
/* U+2c4e */ { 0, 0, 0, 0, 0 },
/* U+2c4f */ { 0, 0, 0, 0, 0 },
/* U+2c50 */ { 0, 0, 0, 0, 0 },
/* U+2c51 */ { 0, 0, 0, 0, 0 },
/* U+2c52 */ { 0, 0, 0, 0, 0 },
/* U+2c53 */ { 0, 0, 0, 0, 0 },
/* U+2c54 */ { 0, 0, 0, 0, 0 },
/* U+2c55 */ { 0, 0, 0, 0, 0 },
/* U+2c56 */ { 0, 0, 0, 0, 0 },
/* U+2c57 */ { 0, 0, 0, 0, 0 },
/* U+2c58 */ { 0, 0, 0, 0, 0 },
/* U+2c59 */ { 0, 0, 0, 0, 0 },
/* U+2c5a */ { 0, 0, 0, 0, 0 },
/* U+2c5b */ { 0, 0, 0, 0, 0 },
/* U+2c5c */ { 0, 0, 0, 0, 0 },
/* U+2c5d */ { 0, 0, 0, 0, 0 },
/* U+2c5e */ { 0, 0, 0, 0, 0 },
/* U+2c5f */ { 0, 0, 0, 0, 0 },
/* U+2c60 */ { 0, 0, 0, 0, 0 },
/* U+2c61 */ { 0, 0, 0, 0, 0 },
/* U+2c62 */ { 0, 0, 0, 0, 0 },
/* U+2c63 */ { 0, 0, 0, 0, 0 },
/* U+2c64 */ { 0, 0, 0, 0, 0 },
/* U+2c65 */ { 0, 0, 0, 0, 0 },
/* U+2c66 */ { 0, 0, 0, 0, 0 },
/* U+2c67 */ { 0, 0, 0, 0, 0 },
/* U+2c68 */ { 0, 0, 0, 0, 0 },
/* U+2c69 */ { 0, 0, 0, 0, 0 },
/* U+2c6a */ { 0, 0, 0, 0, 0 },
/* U+2c6b */ { 0, 0, 0, 0, 0 },
/* U+2c6c */ { 0, 0, 0, 0, 0 },
/* U+2c6d */ { 0, 0, 0, 0, 0 },
/* U+2c6e */ { 0, 0, 0, 0, 0 },
/* U+2c6f */ { 0, 0, 0, 0, 0 },
/* U+2c70 */ { 0, 0, 0, 0, 0 },
/* U+2c71 */ { 0, 0, 0, 0, 0 },
/* U+2c72 */ { 0, 0, 0, 0, 0 },
/* U+2c73 */ { 0, 0, 0, 0, 0 },
/* U+2c74 */ { 0, 0, 0, 0, 0 },
/* U+2c75 */ { 0, 0, 0, 0, 0 },
/* U+2c76 */ { 0, 0, 0, 0, 0 },
/* U+2c77 */ { 0, 0, 0, 0, 0 },
/* U+2c78 */ { 0, 0, 0, 0, 0 },
/* U+2c79 */ { 0, 0, 0, 0, 0 },
/* U+2c7a */ { 0, 0, 0, 0, 0 },
/* U+2c7b */ { 0, 0, 0, 0, 0 },
/* U+2c7c */ { 0, 0, 0, 0, 0 },
/* U+2c7d */ { 0, 0, 0, 0, 0 },
/* U+2c7e */ { 0, 0, 0, 0, 0 },
/* U+2c7f */ { 0, 0, 0, 0, 0 },
/* U+2c80 */ { 0, 0, 0, 0, 0 },
/* U+2c81 */ { 0, 0, 0, 0, 0 },
/* U+2c82 */ { 0, 0, 0, 0, 0 },
/* U+2c83 */ { 0, 0, 0, 0, 0 },
/* U+2c84 */ { 0, 0, 0, 0, 0 },
/* U+2c85 */ { 0, 0, 0, 0, 0 },
/* U+2c86 */ { 0, 0, 0, 0, 0 },
/* U+2c87 */ { 0, 0, 0, 0, 0 },
/* U+2c88 */ { 0, 0, 0, 0, 0 },
/* U+2c89 */ { 0, 0, 0, 0, 0 },
/* U+2c8a */ { 0, 0, 0, 0, 0 },
/* U+2c8b */ { 0, 0, 0, 0, 0 },
/* U+2c8c */ { 0, 0, 0, 0, 0 },
/* U+2c8d */ { 0, 0, 0, 0, 0 },
/* U+2c8e */ { 0, 0, 0, 0, 0 },
/* U+2c8f */ { 0, 0, 0, 0, 0 },
/* U+2c90 */ { 0, 0, 0, 0, 0 },
/* U+2c91 */ { 0, 0, 0, 0, 0 },
/* U+2c92 */ { 0, 0, 0, 0, 0 },
/* U+2c93 */ { 0, 0, 0, 0, 0 },
/* U+2c94 */ { 0, 0, 0, 0, 0 },
/* U+2c95 */ { 0, 0, 0, 0, 0 },
/* U+2c96 */ { 0, 0, 0, 0, 0 },
/* U+2c97 */ { 0, 0, 0, 0, 0 },
/* U+2c98 */ { 0, 0, 0, 0, 0 },
/* U+2c99 */ { 0, 0, 0, 0, 0 },
/* U+2c9a */ { 0, 0, 0, 0, 0 },
/* U+2c9b */ { 0, 0, 0, 0, 0 },
/* U+2c9c */ { 0, 0, 0, 0, 0 },
/* U+2c9d */ { 0, 0, 0, 0, 0 },
/* U+2c9e */ { 0, 0, 0, 0, 0 },
/* U+2c9f */ { 0, 0, 0, 0, 0 },
/* U+2ca0 */ { 0, 0, 0, 0, 0 },
/* U+2ca1 */ { 0, 0, 0, 0, 0 },
/* U+2ca2 */ { 0, 0, 0, 0, 0 },
/* U+2ca3 */ { 0, 0, 0, 0, 0 },
/* U+2ca4 */ { 0, 0, 0, 0, 0 },
/* U+2ca5 */ { 0, 0, 0, 0, 0 },
/* U+2ca6 */ { 0, 0, 0, 0, 0 },
/* U+2ca7 */ { 0, 0, 0, 0, 0 },
/* U+2ca8 */ { 0, 0, 0, 0, 0 },
/* U+2ca9 */ { 0, 0, 0, 0, 0 },
/* U+2caa */ { 0, 0, 0, 0, 0 },
/* U+2cab */ { 0, 0, 0, 0, 0 },
/* U+2cac */ { 0, 0, 0, 0, 0 },
/* U+2cad */ { 0, 0, 0, 0, 0 },
/* U+2cae */ { 0, 0, 0, 0, 0 },
/* U+2caf */ { 0, 0, 0, 0, 0 },
/* U+2cb0 */ { 0, 0, 0, 0, 0 },
/* U+2cb1 */ { 0, 0, 0, 0, 0 },
/* U+2cb2 */ { 0, 0, 0, 0, 0 },
/* U+2cb3 */ { 0, 0, 0, 0, 0 },
/* U+2cb4 */ { 0, 0, 0, 0, 0 },
/* U+2cb5 */ { 0, 0, 0, 0, 0 },
/* U+2cb6 */ { 0, 0, 0, 0, 0 },
/* U+2cb7 */ { 0, 0, 0, 0, 0 },
/* U+2cb8 */ { 0, 0, 0, 0, 0 },
/* U+2cb9 */ { 0, 0, 0, 0, 0 },
/* U+2cba */ { 0, 0, 0, 0, 0 },
/* U+2cbb */ { 0, 0, 0, 0, 0 },
/* U+2cbc */ { 0, 0, 0, 0, 0 },
/* U+2cbd */ { 0, 0, 0, 0, 0 },
/* U+2cbe */ { 0, 0, 0, 0, 0 },
/* U+2cbf */ { 0, 0, 0, 0, 0 },
/* U+2cc0 */ { 0, 0, 0, 0, 0 },
/* U+2cc1 */ { 0, 0, 0, 0, 0 },
/* U+2cc2 */ { 0, 0, 0, 0, 0 },
/* U+2cc3 */ { 0, 0, 0, 0, 0 },
/* U+2cc4 */ { 0, 0, 0, 0, 0 },
/* U+2cc5 */ { 0, 0, 0, 0, 0 },
/* U+2cc6 */ { 0, 0, 0, 0, 0 },
/* U+2cc7 */ { 0, 0, 0, 0, 0 },
/* U+2cc8 */ { 0, 0, 0, 0, 0 },
/* U+2cc9 */ { 0, 0, 0, 0, 0 },
/* U+2cca */ { 0, 0, 0, 0, 0 },
/* U+2ccb */ { 0, 0, 0, 0, 0 },
/* U+2ccc */ { 0, 0, 0, 0, 0 },
/* U+2ccd */ { 0, 0, 0, 0, 0 },
/* U+2cce */ { 0, 0, 0, 0, 0 },
/* U+2ccf */ { 0, 0, 0, 0, 0 },
/* U+2cd0 */ { 0, 0, 0, 0, 0 },
/* U+2cd1 */ { 0, 0, 0, 0, 0 },
/* U+2cd2 */ { 0, 0, 0, 0, 0 },
/* U+2cd3 */ { 0, 0, 0, 0, 0 },
/* U+2cd4 */ { 0, 0, 0, 0, 0 },
/* U+2cd5 */ { 0, 0, 0, 0, 0 },
/* U+2cd6 */ { 0, 0, 0, 0, 0 },
/* U+2cd7 */ { 0, 0, 0, 0, 0 },
/* U+2cd8 */ { 0, 0, 0, 0, 0 },
/* U+2cd9 */ { 0, 0, 0, 0, 0 },
/* U+2cda */ { 0, 0, 0, 0, 0 },
/* U+2cdb */ { 0, 0, 0, 0, 0 },
/* U+2cdc */ { 0, 0, 0, 0, 0 },
/* U+2cdd */ { 0, 0, 0, 0, 0 },
/* U+2cde */ { 0, 0, 0, 0, 0 },
/* U+2cdf */ { 0, 0, 0, 0, 0 },
/* U+2ce0 */ { 0, 0, 0, 0, 0 },
/* U+2ce1 */ { 0, 0, 0, 0, 0 },
/* U+2ce2 */ { 0, 0, 0, 0, 0 },
/* U+2ce3 */ { 0, 0, 0, 0, 0 },
/* U+2ce4 */ { 0, 0, 0, 0, 0 },
/* U+2ce5 */ { 0, 0, 0, 0, 0 },
/* U+2ce6 */ { 0, 0, 0, 0, 0 },
/* U+2ce7 */ { 0, 0, 0, 0, 0 },
/* U+2ce8 */ { 0, 0, 0, 0, 0 },
/* U+2ce9 */ { 0, 0, 0, 0, 0 },
/* U+2cea */ { 0, 0, 0, 0, 0 },
/* U+2ceb */ { 0, 0, 0, 0, 0 },
/* U+2cec */ { 0, 0, 0, 0, 0 },
/* U+2ced */ { 0, 0, 0, 0, 0 },
/* U+2cee */ { 0, 0, 0, 0, 0 },
/* U+2cef */ { 0, 0, 0, 0, 0 },
/* U+2cf0 */ { 0, 0, 0, 0, 0 },
/* U+2cf1 */ { 0, 0, 0, 0, 0 },
/* U+2cf2 */ { 0, 0, 0, 0, 0 },
/* U+2cf3 */ { 0, 0, 0, 0, 0 },
/* U+2cf4 */ { 0, 0, 0, 0, 0 },
/* U+2cf5 */ { 0, 0, 0, 0, 0 },
/* U+2cf6 */ { 0, 0, 0, 0, 0 },
/* U+2cf7 */ { 0, 0, 0, 0, 0 },
/* U+2cf8 */ { 0, 0, 0, 0, 0 },
/* U+2cf9 */ { 0, 0, 0, 0, 0 },
/* U+2cfa */ { 0, 0, 0, 0, 0 },
/* U+2cfb */ { 0, 0, 0, 0, 0 },
/* U+2cfc */ { 0, 0, 0, 0, 0 },
/* U+2cfd */ { 0, 0, 0, 0, 0 },
/* U+2cfe */ { 0, 0, 0, 0, 0 },
/* U+2cff */ { 0, 0, 0, 0, 0 },
/* U+2d00 */ { 0, 0, 0, 0, 0 },
/* U+2d01 */ { 0, 0, 0, 0, 0 },
/* U+2d02 */ { 0, 0, 0, 0, 0 },
/* U+2d03 */ { 0, 0, 0, 0, 0 },
/* U+2d04 */ { 0, 0, 0, 0, 0 },
/* U+2d05 */ { 0, 0, 0, 0, 0 },
/* U+2d06 */ { 0, 0, 0, 0, 0 },
/* U+2d07 */ { 0, 0, 0, 0, 0 },
/* U+2d08 */ { 0, 0, 0, 0, 0 },
/* U+2d09 */ { 0, 0, 0, 0, 0 },
/* U+2d0a */ { 0, 0, 0, 0, 0 },
/* U+2d0b */ { 0, 0, 0, 0, 0 },
/* U+2d0c */ { 0, 0, 0, 0, 0 },
/* U+2d0d */ { 0, 0, 0, 0, 0 },
/* U+2d0e */ { 0, 0, 0, 0, 0 },
/* U+2d0f */ { 0, 0, 0, 0, 0 },
/* U+2d10 */ { 0, 0, 0, 0, 0 },
/* U+2d11 */ { 0, 0, 0, 0, 0 },
/* U+2d12 */ { 0, 0, 0, 0, 0 },
/* U+2d13 */ { 0, 0, 0, 0, 0 },
/* U+2d14 */ { 0, 0, 0, 0, 0 },
/* U+2d15 */ { 0, 0, 0, 0, 0 },
/* U+2d16 */ { 0, 0, 0, 0, 0 },
/* U+2d17 */ { 0, 0, 0, 0, 0 },
/* U+2d18 */ { 0, 0, 0, 0, 0 },
/* U+2d19 */ { 0, 0, 0, 0, 0 },
/* U+2d1a */ { 0, 0, 0, 0, 0 },
/* U+2d1b */ { 0, 0, 0, 0, 0 },
/* U+2d1c */ { 0, 0, 0, 0, 0 },
/* U+2d1d */ { 0, 0, 0, 0, 0 },
/* U+2d1e */ { 0, 0, 0, 0, 0 },
/* U+2d1f */ { 0, 0, 0, 0, 0 },
/* U+2d20 */ { 0, 0, 0, 0, 0 },
/* U+2d21 */ { 0, 0, 0, 0, 0 },
/* U+2d22 */ { 0, 0, 0, 0, 0 },
/* U+2d23 */ { 0, 0, 0, 0, 0 },
/* U+2d24 */ { 0, 0, 0, 0, 0 },
/* U+2d25 */ { 0, 0, 0, 0, 0 },
/* U+2d26 */ { 0, 0, 0, 0, 0 },
/* U+2d27 */ { 0, 0, 0, 0, 0 },
/* U+2d28 */ { 0, 0, 0, 0, 0 },
/* U+2d29 */ { 0, 0, 0, 0, 0 },
/* U+2d2a */ { 0, 0, 0, 0, 0 },
/* U+2d2b */ { 0, 0, 0, 0, 0 },
/* U+2d2c */ { 0, 0, 0, 0, 0 },
/* U+2d2d */ { 0, 0, 0, 0, 0 },
/* U+2d2e */ { 0, 0, 0, 0, 0 },
/* U+2d2f */ { 0, 0, 0, 0, 0 },
/* U+2d30 */ { 0, 0, 0, 0, 0 },
/* U+2d31 */ { 0, 0, 0, 0, 0 },
/* U+2d32 */ { 0, 0, 0, 0, 0 },
/* U+2d33 */ { 0, 0, 0, 0, 0 },
/* U+2d34 */ { 0, 0, 0, 0, 0 },
/* U+2d35 */ { 0, 0, 0, 0, 0 },
/* U+2d36 */ { 0, 0, 0, 0, 0 },
/* U+2d37 */ { 0, 0, 0, 0, 0 },
/* U+2d38 */ { 0, 0, 0, 0, 0 },
/* U+2d39 */ { 0, 0, 0, 0, 0 },
/* U+2d3a */ { 0, 0, 0, 0, 0 },
/* U+2d3b */ { 0, 0, 0, 0, 0 },
/* U+2d3c */ { 0, 0, 0, 0, 0 },
/* U+2d3d */ { 0, 0, 0, 0, 0 },
/* U+2d3e */ { 0, 0, 0, 0, 0 },
/* U+2d3f */ { 0, 0, 0, 0, 0 },
/* U+2d40 */ { 0, 0, 0, 0, 0 },
/* U+2d41 */ { 0, 0, 0, 0, 0 },
/* U+2d42 */ { 0, 0, 0, 0, 0 },
/* U+2d43 */ { 0, 0, 0, 0, 0 },
/* U+2d44 */ { 0, 0, 0, 0, 0 },
/* U+2d45 */ { 0, 0, 0, 0, 0 },
/* U+2d46 */ { 0, 0, 0, 0, 0 },
/* U+2d47 */ { 0, 0, 0, 0, 0 },
/* U+2d48 */ { 0, 0, 0, 0, 0 },
/* U+2d49 */ { 0, 0, 0, 0, 0 },
/* U+2d4a */ { 0, 0, 0, 0, 0 },
/* U+2d4b */ { 0, 0, 0, 0, 0 },
/* U+2d4c */ { 0, 0, 0, 0, 0 },
/* U+2d4d */ { 0, 0, 0, 0, 0 },
/* U+2d4e */ { 0, 0, 0, 0, 0 },
/* U+2d4f */ { 0, 0, 0, 0, 0 },
/* U+2d50 */ { 0, 0, 0, 0, 0 },
/* U+2d51 */ { 0, 0, 0, 0, 0 },
/* U+2d52 */ { 0, 0, 0, 0, 0 },
/* U+2d53 */ { 0, 0, 0, 0, 0 },
/* U+2d54 */ { 0, 0, 0, 0, 0 },
/* U+2d55 */ { 0, 0, 0, 0, 0 },
/* U+2d56 */ { 0, 0, 0, 0, 0 },
/* U+2d57 */ { 0, 0, 0, 0, 0 },
/* U+2d58 */ { 0, 0, 0, 0, 0 },
/* U+2d59 */ { 0, 0, 0, 0, 0 },
/* U+2d5a */ { 0, 0, 0, 0, 0 },
/* U+2d5b */ { 0, 0, 0, 0, 0 },
/* U+2d5c */ { 0, 0, 0, 0, 0 },
/* U+2d5d */ { 0, 0, 0, 0, 0 },
/* U+2d5e */ { 0, 0, 0, 0, 0 },
/* U+2d5f */ { 0, 0, 0, 0, 0 },
/* U+2d60 */ { 0, 0, 0, 0, 0 },
/* U+2d61 */ { 0, 0, 0, 0, 0 },
/* U+2d62 */ { 0, 0, 0, 0, 0 },
/* U+2d63 */ { 0, 0, 0, 0, 0 },
/* U+2d64 */ { 0, 0, 0, 0, 0 },
/* U+2d65 */ { 0, 0, 0, 0, 0 },
/* U+2d66 */ { 0, 0, 0, 0, 0 },
/* U+2d67 */ { 0, 0, 0, 0, 0 },
/* U+2d68 */ { 0, 0, 0, 0, 0 },
/* U+2d69 */ { 0, 0, 0, 0, 0 },
/* U+2d6a */ { 0, 0, 0, 0, 0 },
/* U+2d6b */ { 0, 0, 0, 0, 0 },
/* U+2d6c */ { 0, 0, 0, 0, 0 },
/* U+2d6d */ { 0, 0, 0, 0, 0 },
/* U+2d6e */ { 0, 0, 0, 0, 0 },
/* U+2d6f */ { 0, 0, 0, 0, 0 },
/* U+2d70 */ { 0, 0, 0, 0, 0 },
/* U+2d71 */ { 0, 0, 0, 0, 0 },
/* U+2d72 */ { 0, 0, 0, 0, 0 },
/* U+2d73 */ { 0, 0, 0, 0, 0 },
/* U+2d74 */ { 0, 0, 0, 0, 0 },
/* U+2d75 */ { 0, 0, 0, 0, 0 },
/* U+2d76 */ { 0, 0, 0, 0, 0 },
/* U+2d77 */ { 0, 0, 0, 0, 0 },
/* U+2d78 */ { 0, 0, 0, 0, 0 },
/* U+2d79 */ { 0, 0, 0, 0, 0 },
/* U+2d7a */ { 0, 0, 0, 0, 0 },
/* U+2d7b */ { 0, 0, 0, 0, 0 },
/* U+2d7c */ { 0, 0, 0, 0, 0 },
/* U+2d7d */ { 0, 0, 0, 0, 0 },
/* U+2d7e */ { 0, 0, 0, 0, 0 },
/* U+2d7f */ { 0, 0, 0, 0, 0 },
/* U+2d80 */ { 0, 0, 0, 0, 0 },
/* U+2d81 */ { 0, 0, 0, 0, 0 },
/* U+2d82 */ { 0, 0, 0, 0, 0 },
/* U+2d83 */ { 0, 0, 0, 0, 0 },
/* U+2d84 */ { 0, 0, 0, 0, 0 },
/* U+2d85 */ { 0, 0, 0, 0, 0 },
/* U+2d86 */ { 0, 0, 0, 0, 0 },
/* U+2d87 */ { 0, 0, 0, 0, 0 },
/* U+2d88 */ { 0, 0, 0, 0, 0 },
/* U+2d89 */ { 0, 0, 0, 0, 0 },
/* U+2d8a */ { 0, 0, 0, 0, 0 },
/* U+2d8b */ { 0, 0, 0, 0, 0 },
/* U+2d8c */ { 0, 0, 0, 0, 0 },
/* U+2d8d */ { 0, 0, 0, 0, 0 },
/* U+2d8e */ { 0, 0, 0, 0, 0 },
/* U+2d8f */ { 0, 0, 0, 0, 0 },
/* U+2d90 */ { 0, 0, 0, 0, 0 },
/* U+2d91 */ { 0, 0, 0, 0, 0 },
/* U+2d92 */ { 0, 0, 0, 0, 0 },
/* U+2d93 */ { 0, 0, 0, 0, 0 },
/* U+2d94 */ { 0, 0, 0, 0, 0 },
/* U+2d95 */ { 0, 0, 0, 0, 0 },
/* U+2d96 */ { 0, 0, 0, 0, 0 },
/* U+2d97 */ { 0, 0, 0, 0, 0 },
/* U+2d98 */ { 0, 0, 0, 0, 0 },
/* U+2d99 */ { 0, 0, 0, 0, 0 },
/* U+2d9a */ { 0, 0, 0, 0, 0 },
/* U+2d9b */ { 0, 0, 0, 0, 0 },
/* U+2d9c */ { 0, 0, 0, 0, 0 },
/* U+2d9d */ { 0, 0, 0, 0, 0 },
/* U+2d9e */ { 0, 0, 0, 0, 0 },
/* U+2d9f */ { 0, 0, 0, 0, 0 },
/* U+2da0 */ { 0, 0, 0, 0, 0 },
/* U+2da1 */ { 0, 0, 0, 0, 0 },
/* U+2da2 */ { 0, 0, 0, 0, 0 },
/* U+2da3 */ { 0, 0, 0, 0, 0 },
/* U+2da4 */ { 0, 0, 0, 0, 0 },
/* U+2da5 */ { 0, 0, 0, 0, 0 },
/* U+2da6 */ { 0, 0, 0, 0, 0 },
/* U+2da7 */ { 0, 0, 0, 0, 0 },
/* U+2da8 */ { 0, 0, 0, 0, 0 },
/* U+2da9 */ { 0, 0, 0, 0, 0 },
/* U+2daa */ { 0, 0, 0, 0, 0 },
/* U+2dab */ { 0, 0, 0, 0, 0 },
/* U+2dac */ { 0, 0, 0, 0, 0 },
/* U+2dad */ { 0, 0, 0, 0, 0 },
/* U+2dae */ { 0, 0, 0, 0, 0 },
/* U+2daf */ { 0, 0, 0, 0, 0 },
/* U+2db0 */ { 0, 0, 0, 0, 0 },
/* U+2db1 */ { 0, 0, 0, 0, 0 },
/* U+2db2 */ { 0, 0, 0, 0, 0 },
/* U+2db3 */ { 0, 0, 0, 0, 0 },
/* U+2db4 */ { 0, 0, 0, 0, 0 },
/* U+2db5 */ { 0, 0, 0, 0, 0 },
/* U+2db6 */ { 0, 0, 0, 0, 0 },
/* U+2db7 */ { 0, 0, 0, 0, 0 },
/* U+2db8 */ { 0, 0, 0, 0, 0 },
/* U+2db9 */ { 0, 0, 0, 0, 0 },
/* U+2dba */ { 0, 0, 0, 0, 0 },
/* U+2dbb */ { 0, 0, 0, 0, 0 },
/* U+2dbc */ { 0, 0, 0, 0, 0 },
/* U+2dbd */ { 0, 0, 0, 0, 0 },
/* U+2dbe */ { 0, 0, 0, 0, 0 },
/* U+2dbf */ { 0, 0, 0, 0, 0 },
/* U+2dc0 */ { 0, 0, 0, 0, 0 },
/* U+2dc1 */ { 0, 0, 0, 0, 0 },
/* U+2dc2 */ { 0, 0, 0, 0, 0 },
/* U+2dc3 */ { 0, 0, 0, 0, 0 },
/* U+2dc4 */ { 0, 0, 0, 0, 0 },
/* U+2dc5 */ { 0, 0, 0, 0, 0 },
/* U+2dc6 */ { 0, 0, 0, 0, 0 },
/* U+2dc7 */ { 0, 0, 0, 0, 0 },
/* U+2dc8 */ { 0, 0, 0, 0, 0 },
/* U+2dc9 */ { 0, 0, 0, 0, 0 },
/* U+2dca */ { 0, 0, 0, 0, 0 },
/* U+2dcb */ { 0, 0, 0, 0, 0 },
/* U+2dcc */ { 0, 0, 0, 0, 0 },
/* U+2dcd */ { 0, 0, 0, 0, 0 },
/* U+2dce */ { 0, 0, 0, 0, 0 },
/* U+2dcf */ { 0, 0, 0, 0, 0 },
/* U+2dd0 */ { 0, 0, 0, 0, 0 },
/* U+2dd1 */ { 0, 0, 0, 0, 0 },
/* U+2dd2 */ { 0, 0, 0, 0, 0 },
/* U+2dd3 */ { 0, 0, 0, 0, 0 },
/* U+2dd4 */ { 0, 0, 0, 0, 0 },
/* U+2dd5 */ { 0, 0, 0, 0, 0 },
/* U+2dd6 */ { 0, 0, 0, 0, 0 },
/* U+2dd7 */ { 0, 0, 0, 0, 0 },
/* U+2dd8 */ { 0, 0, 0, 0, 0 },
/* U+2dd9 */ { 0, 0, 0, 0, 0 },
/* U+2dda */ { 0, 0, 0, 0, 0 },
/* U+2ddb */ { 0, 0, 0, 0, 0 },
/* U+2ddc */ { 0, 0, 0, 0, 0 },
/* U+2ddd */ { 0, 0, 0, 0, 0 },
/* U+2dde */ { 0, 0, 0, 0, 0 },
/* U+2ddf */ { 0, 0, 0, 0, 0 },
/* U+2de0 */ { 0, 0, 0, 0, 0 },
/* U+2de1 */ { 0, 0, 0, 0, 0 },
/* U+2de2 */ { 0, 0, 0, 0, 0 },
/* U+2de3 */ { 0, 0, 0, 0, 0 },
/* U+2de4 */ { 0, 0, 0, 0, 0 },
/* U+2de5 */ { 0, 0, 0, 0, 0 },
/* U+2de6 */ { 0, 0, 0, 0, 0 },
/* U+2de7 */ { 0, 0, 0, 0, 0 },
/* U+2de8 */ { 0, 0, 0, 0, 0 },
/* U+2de9 */ { 0, 0, 0, 0, 0 },
/* U+2dea */ { 0, 0, 0, 0, 0 },
/* U+2deb */ { 0, 0, 0, 0, 0 },
/* U+2dec */ { 0, 0, 0, 0, 0 },
/* U+2ded */ { 0, 0, 0, 0, 0 },
/* U+2dee */ { 0, 0, 0, 0, 0 },
/* U+2def */ { 0, 0, 0, 0, 0 },
/* U+2df0 */ { 0, 0, 0, 0, 0 },
/* U+2df1 */ { 0, 0, 0, 0, 0 },
/* U+2df2 */ { 0, 0, 0, 0, 0 },
/* U+2df3 */ { 0, 0, 0, 0, 0 },
/* U+2df4 */ { 0, 0, 0, 0, 0 },
/* U+2df5 */ { 0, 0, 0, 0, 0 },
/* U+2df6 */ { 0, 0, 0, 0, 0 },
/* U+2df7 */ { 0, 0, 0, 0, 0 },
/* U+2df8 */ { 0, 0, 0, 0, 0 },
/* U+2df9 */ { 0, 0, 0, 0, 0 },
/* U+2dfa */ { 0, 0, 0, 0, 0 },
/* U+2dfb */ { 0, 0, 0, 0, 0 },
/* U+2dfc */ { 0, 0, 0, 0, 0 },
/* U+2dfd */ { 0, 0, 0, 0, 0 },
/* U+2dfe */ { 0, 0, 0, 0, 0 },
/* U+2dff */ { 0, 0, 0, 0, 0 },
/* U+2e00 */ { 0, 0, 0, 0, 0 },
/* U+2e01 */ { 0, 0, 0, 0, 0 },
/* U+2e02 */ { 0, 0, 0, 0, 0 },
/* U+2e03 */ { 0, 0, 0, 0, 0 },
/* U+2e04 */ { 0, 0, 0, 0, 0 },
/* U+2e05 */ { 0, 0, 0, 0, 0 },
/* U+2e06 */ { 0, 0, 0, 0, 0 },
/* U+2e07 */ { 0, 0, 0, 0, 0 },
/* U+2e08 */ { 0, 0, 0, 0, 0 },
/* U+2e09 */ { 0, 0, 0, 0, 0 },
/* U+2e0a */ { 0, 0, 0, 0, 0 },
/* U+2e0b */ { 0, 0, 0, 0, 0 },
/* U+2e0c */ { 0, 0, 0, 0, 0 },
/* U+2e0d */ { 0, 0, 0, 0, 0 },
/* U+2e0e */ { 0, 0, 0, 0, 0 },
/* U+2e0f */ { 0, 0, 0, 0, 0 },
/* U+2e10 */ { 0, 0, 0, 0, 0 },
/* U+2e11 */ { 0, 0, 0, 0, 0 },
/* U+2e12 */ { 0, 0, 0, 0, 0 },
/* U+2e13 */ { 0, 0, 0, 0, 0 },
/* U+2e14 */ { 0, 0, 0, 0, 0 },
/* U+2e15 */ { 0, 0, 0, 0, 0 },
/* U+2e16 */ { 0, 0, 0, 0, 0 },
/* U+2e17 */ { 0, 0, 0, 0, 0 },
/* U+2e18 */ { 0, 0, 0, 0, 0 },
/* U+2e19 */ { 0, 0, 0, 0, 0 },
/* U+2e1a */ { 0, 0, 0, 0, 0 },
/* U+2e1b */ { 0, 0, 0, 0, 0 },
/* U+2e1c */ { 0, 0, 0, 0, 0 },
/* U+2e1d */ { 0, 0, 0, 0, 0 },
/* U+2e1e */ { 0, 0, 0, 0, 0 },
/* U+2e1f */ { 0, 0, 0, 0, 0 },
/* U+2e20 */ { 0, 0, 0, 0, 0 },
/* U+2e21 */ { 0, 0, 0, 0, 0 },
/* U+2e22 */ { 0, 0, 0, 0, 0 },
/* U+2e23 */ { 0, 0, 0, 0, 0 },
/* U+2e24 */ { 0, 0, 0, 0, 0 },
/* U+2e25 */ { 0, 0, 0, 0, 0 },
/* U+2e26 */ { 0, 0, 0, 0, 0 },
/* U+2e27 */ { 0, 0, 0, 0, 0 },
/* U+2e28 */ { 0, 0, 0, 0, 0 },
/* U+2e29 */ { 0, 0, 0, 0, 0 },
/* U+2e2a */ { 0, 0, 0, 0, 0 },
/* U+2e2b */ { 0, 0, 0, 0, 0 },
/* U+2e2c */ { 0, 0, 0, 0, 0 },
/* U+2e2d */ { 0, 0, 0, 0, 0 },
/* U+2e2e */ { 0, 0, 0, 0, 0 },
/* U+2e2f */ { 0, 0, 0, 0, 0 },
/* U+2e30 */ { 0, 0, 0, 0, 0 },
/* U+2e31 */ { 0, 0, 0, 0, 0 },
/* U+2e32 */ { 0, 0, 0, 0, 0 },
/* U+2e33 */ { 0, 0, 0, 0, 0 },
/* U+2e34 */ { 0, 0, 0, 0, 0 },
/* U+2e35 */ { 0, 0, 0, 0, 0 },
/* U+2e36 */ { 0, 0, 0, 0, 0 },
/* U+2e37 */ { 0, 0, 0, 0, 0 },
/* U+2e38 */ { 0, 0, 0, 0, 0 },
/* U+2e39 */ { 0, 0, 0, 0, 0 },
/* U+2e3a */ { 0, 0, 0, 0, 0 },
/* U+2e3b */ { 0, 0, 0, 0, 0 },
/* U+2e3c */ { 0, 0, 0, 0, 0 },
/* U+2e3d */ { 0, 0, 0, 0, 0 },
/* U+2e3e */ { 0, 0, 0, 0, 0 },
/* U+2e3f */ { 0, 0, 0, 0, 0 },
/* U+2e40 */ { 0, 0, 0, 0, 0 },
/* U+2e41 */ { 0, 0, 0, 0, 0 },
/* U+2e42 */ { 0, 0, 0, 0, 0 },
/* U+2e43 */ { 0, 0, 0, 0, 0 },
/* U+2e44 */ { 0, 0, 0, 0, 0 },
/* U+2e45 */ { 0, 0, 0, 0, 0 },
/* U+2e46 */ { 0, 0, 0, 0, 0 },
/* U+2e47 */ { 0, 0, 0, 0, 0 },
/* U+2e48 */ { 0, 0, 0, 0, 0 },
/* U+2e49 */ { 0, 0, 0, 0, 0 },
/* U+2e4a */ { 0, 0, 0, 0, 0 },
/* U+2e4b */ { 0, 0, 0, 0, 0 },
/* U+2e4c */ { 0, 0, 0, 0, 0 },
/* U+2e4d */ { 0, 0, 0, 0, 0 },
/* U+2e4e */ { 0, 0, 0, 0, 0 },
/* U+2e4f */ { 0, 0, 0, 0, 0 },
/* U+2e50 */ { 0, 0, 0, 0, 0 },
/* U+2e51 */ { 0, 0, 0, 0, 0 },
/* U+2e52 */ { 0, 0, 0, 0, 0 },
/* U+2e53 */ { 0, 0, 0, 0, 0 },
/* U+2e54 */ { 0, 0, 0, 0, 0 },
/* U+2e55 */ { 0, 0, 0, 0, 0 },
/* U+2e56 */ { 0, 0, 0, 0, 0 },
/* U+2e57 */ { 0, 0, 0, 0, 0 },
/* U+2e58 */ { 0, 0, 0, 0, 0 },
/* U+2e59 */ { 0, 0, 0, 0, 0 },
/* U+2e5a */ { 0, 0, 0, 0, 0 },
/* U+2e5b */ { 0, 0, 0, 0, 0 },
/* U+2e5c */ { 0, 0, 0, 0, 0 },
/* U+2e5d */ { 0, 0, 0, 0, 0 },
/* U+2e5e */ { 0, 0, 0, 0, 0 },
/* U+2e5f */ { 0, 0, 0, 0, 0 },
/* U+2e60 */ { 0, 0, 0, 0, 0 },
/* U+2e61 */ { 0, 0, 0, 0, 0 },
/* U+2e62 */ { 0, 0, 0, 0, 0 },
/* U+2e63 */ { 0, 0, 0, 0, 0 },
/* U+2e64 */ { 0, 0, 0, 0, 0 },
/* U+2e65 */ { 0, 0, 0, 0, 0 },
/* U+2e66 */ { 0, 0, 0, 0, 0 },
/* U+2e67 */ { 0, 0, 0, 0, 0 },
/* U+2e68 */ { 0, 0, 0, 0, 0 },
/* U+2e69 */ { 0, 0, 0, 0, 0 },
/* U+2e6a */ { 0, 0, 0, 0, 0 },
/* U+2e6b */ { 0, 0, 0, 0, 0 },
/* U+2e6c */ { 0, 0, 0, 0, 0 },
/* U+2e6d */ { 0, 0, 0, 0, 0 },
/* U+2e6e */ { 0, 0, 0, 0, 0 },
/* U+2e6f */ { 0, 0, 0, 0, 0 },
/* U+2e70 */ { 0, 0, 0, 0, 0 },
/* U+2e71 */ { 0, 0, 0, 0, 0 },
/* U+2e72 */ { 0, 0, 0, 0, 0 },
/* U+2e73 */ { 0, 0, 0, 0, 0 },
/* U+2e74 */ { 0, 0, 0, 0, 0 },
/* U+2e75 */ { 0, 0, 0, 0, 0 },
/* U+2e76 */ { 0, 0, 0, 0, 0 },
/* U+2e77 */ { 0, 0, 0, 0, 0 },
/* U+2e78 */ { 0, 0, 0, 0, 0 },
/* U+2e79 */ { 0, 0, 0, 0, 0 },
/* U+2e7a */ { 0, 0, 0, 0, 0 },
/* U+2e7b */ { 0, 0, 0, 0, 0 },
/* U+2e7c */ { 0, 0, 0, 0, 0 },
/* U+2e7d */ { 0, 0, 0, 0, 0 },
/* U+2e7e */ { 0, 0, 0, 0, 0 },
/* U+2e7f */ { 0, 0, 0, 0, 0 },
/* U+2e80 */ { 30, 0, 19, 0, 0 },
/* U+2e81 */ { 30, 0, 19, 0, 0 },
/* U+2e82 */ { 30, 0, 19, 0, 0 },
/* U+2e83 */ { 30, 0, 19, 0, 0 },
/* U+2e84 */ { 30, 0, 19, 0, 0 },
/* U+2e85 */ { 30, 0, 19, 0, 0 },
/* U+2e86 */ { 30, 0, 19, 0, 0 },
/* U+2e87 */ { 30, 0, 19, 0, 0 },
/* U+2e88 */ { 30, 0, 19, 0, 0 },
/* U+2e89 */ { 30, 0, 19, 0, 0 },
/* U+2e8a */ { 30, 0, 19, 0, 0 },
/* U+2e8b */ { 30, 0, 19, 0, 0 },
/* U+2e8c */ { 30, 0, 19, 0, 0 },
/* U+2e8d */ { 30, 0, 19, 0, 0 },
/* U+2e8e */ { 30, 0, 19, 0, 0 },
/* U+2e8f */ { 30, 0, 19, 0, 0 },
/* U+2e90 */ { 30, 0, 19, 0, 0 },
/* U+2e91 */ { 30, 0, 19, 0, 0 },
/* U+2e92 */ { 30, 0, 19, 0, 0 },
/* U+2e93 */ { 30, 0, 19, 0, 0 },
/* U+2e94 */ { 30, 0, 19, 0, 0 },
/* U+2e95 */ { 30, 0, 19, 0, 0 },
/* U+2e96 */ { 30, 0, 19, 0, 0 },
/* U+2e97 */ { 30, 0, 19, 0, 0 },
/* U+2e98 */ { 30, 0, 19, 0, 0 },
/* U+2e99 */ { 30, 0, 19, 0, 0 },
/* U+2e9a */ { 0, 0, 0, 0, 0 },
/* U+2e9b */ { 30, 0, 19, 0, 0 },
/* U+2e9c */ { 30, 0, 19, 0, 0 },
/* U+2e9d */ { 30, 0, 19, 0, 0 },
/* U+2e9e */ { 30, 0, 19, 0, 0 },
/* U+2e9f */ { 30, 0, 19, 0, "<compat> 6BCD" },
/* U+2ea0 */ { 30, 0, 19, 0, 0 },
/* U+2ea1 */ { 30, 0, 19, 0, 0 },
/* U+2ea2 */ { 30, 0, 19, 0, 0 },
/* U+2ea3 */ { 30, 0, 19, 0, 0 },
/* U+2ea4 */ { 30, 0, 19, 0, 0 },
/* U+2ea5 */ { 30, 0, 19, 0, 0 },
/* U+2ea6 */ { 30, 0, 19, 0, 0 },
/* U+2ea7 */ { 30, 0, 19, 0, 0 },
/* U+2ea8 */ { 30, 0, 19, 0, 0 },
/* U+2ea9 */ { 30, 0, 19, 0, 0 },
/* U+2eaa */ { 30, 0, 19, 0, 0 },
/* U+2eab */ { 30, 0, 19, 0, 0 },
/* U+2eac */ { 30, 0, 19, 0, 0 },
/* U+2ead */ { 30, 0, 19, 0, 0 },
/* U+2eae */ { 30, 0, 19, 0, 0 },
/* U+2eaf */ { 30, 0, 19, 0, 0 },
/* U+2eb0 */ { 30, 0, 19, 0, 0 },
/* U+2eb1 */ { 30, 0, 19, 0, 0 },
/* U+2eb2 */ { 30, 0, 19, 0, 0 },
/* U+2eb3 */ { 30, 0, 19, 0, 0 },
/* U+2eb4 */ { 30, 0, 19, 0, 0 },
/* U+2eb5 */ { 30, 0, 19, 0, 0 },
/* U+2eb6 */ { 30, 0, 19, 0, 0 },
/* U+2eb7 */ { 30, 0, 19, 0, 0 },
/* U+2eb8 */ { 30, 0, 19, 0, 0 },
/* U+2eb9 */ { 30, 0, 19, 0, 0 },
/* U+2eba */ { 30, 0, 19, 0, 0 },
/* U+2ebb */ { 30, 0, 19, 0, 0 },
/* U+2ebc */ { 30, 0, 19, 0, 0 },
/* U+2ebd */ { 30, 0, 19, 0, 0 },
/* U+2ebe */ { 30, 0, 19, 0, 0 },
/* U+2ebf */ { 30, 0, 19, 0, 0 },
/* U+2ec0 */ { 30, 0, 19, 0, 0 },
/* U+2ec1 */ { 30, 0, 19, 0, 0 },
/* U+2ec2 */ { 30, 0, 19, 0, 0 },
/* U+2ec3 */ { 30, 0, 19, 0, 0 },
/* U+2ec4 */ { 30, 0, 19, 0, 0 },
/* U+2ec5 */ { 30, 0, 19, 0, 0 },
/* U+2ec6 */ { 30, 0, 19, 0, 0 },
/* U+2ec7 */ { 30, 0, 19, 0, 0 },
/* U+2ec8 */ { 30, 0, 19, 0, 0 },
/* U+2ec9 */ { 30, 0, 19, 0, 0 },
/* U+2eca */ { 30, 0, 19, 0, 0 },
/* U+2ecb */ { 30, 0, 19, 0, 0 },
/* U+2ecc */ { 30, 0, 19, 0, 0 },
/* U+2ecd */ { 30, 0, 19, 0, 0 },
/* U+2ece */ { 30, 0, 19, 0, 0 },
/* U+2ecf */ { 30, 0, 19, 0, 0 },
/* U+2ed0 */ { 30, 0, 19, 0, 0 },
/* U+2ed1 */ { 30, 0, 19, 0, 0 },
/* U+2ed2 */ { 30, 0, 19, 0, 0 },
/* U+2ed3 */ { 30, 0, 19, 0, 0 },
/* U+2ed4 */ { 30, 0, 19, 0, 0 },
/* U+2ed5 */ { 30, 0, 19, 0, 0 },
/* U+2ed6 */ { 30, 0, 19, 0, 0 },
/* U+2ed7 */ { 30, 0, 19, 0, 0 },
/* U+2ed8 */ { 30, 0, 19, 0, 0 },
/* U+2ed9 */ { 30, 0, 19, 0, 0 },
/* U+2eda */ { 30, 0, 19, 0, 0 },
/* U+2edb */ { 30, 0, 19, 0, 0 },
/* U+2edc */ { 30, 0, 19, 0, 0 },
/* U+2edd */ { 30, 0, 19, 0, 0 },
/* U+2ede */ { 30, 0, 19, 0, 0 },
/* U+2edf */ { 30, 0, 19, 0, 0 },
/* U+2ee0 */ { 30, 0, 19, 0, 0 },
/* U+2ee1 */ { 30, 0, 19, 0, 0 },
/* U+2ee2 */ { 30, 0, 19, 0, 0 },
/* U+2ee3 */ { 30, 0, 19, 0, 0 },
/* U+2ee4 */ { 30, 0, 19, 0, 0 },
/* U+2ee5 */ { 30, 0, 19, 0, 0 },
/* U+2ee6 */ { 30, 0, 19, 0, 0 },
/* U+2ee7 */ { 30, 0, 19, 0, 0 },
/* U+2ee8 */ { 30, 0, 19, 0, 0 },
/* U+2ee9 */ { 30, 0, 19, 0, 0 },
/* U+2eea */ { 30, 0, 19, 0, 0 },
/* U+2eeb */ { 30, 0, 19, 0, 0 },
/* U+2eec */ { 30, 0, 19, 0, 0 },
/* U+2eed */ { 30, 0, 19, 0, 0 },
/* U+2eee */ { 30, 0, 19, 0, 0 },
/* U+2eef */ { 30, 0, 19, 0, 0 },
/* U+2ef0 */ { 30, 0, 19, 0, 0 },
/* U+2ef1 */ { 30, 0, 19, 0, 0 },
/* U+2ef2 */ { 30, 0, 19, 0, 0 },
/* U+2ef3 */ { 30, 0, 19, 0, "<compat> 9F9F" },
/* U+2ef4 */ { 0, 0, 0, 0, 0 },
/* U+2ef5 */ { 0, 0, 0, 0, 0 },
/* U+2ef6 */ { 0, 0, 0, 0, 0 },
/* U+2ef7 */ { 0, 0, 0, 0, 0 },
/* U+2ef8 */ { 0, 0, 0, 0, 0 },
/* U+2ef9 */ { 0, 0, 0, 0, 0 },
/* U+2efa */ { 0, 0, 0, 0, 0 },
/* U+2efb */ { 0, 0, 0, 0, 0 },
/* U+2efc */ { 0, 0, 0, 0, 0 },
/* U+2efd */ { 0, 0, 0, 0, 0 },
/* U+2efe */ { 0, 0, 0, 0, 0 },
/* U+2eff */ { 0, 0, 0, 0, 0 },
/* U+2f00 */ { 30, 0, 19, 0, "<compat> 4E00" },
/* U+2f01 */ { 30, 0, 19, 0, "<compat> 4E28" },
/* U+2f02 */ { 30, 0, 19, 0, "<compat> 4E36" },
/* U+2f03 */ { 30, 0, 19, 0, "<compat> 4E3F" },
/* U+2f04 */ { 30, 0, 19, 0, "<compat> 4E59" },
/* U+2f05 */ { 30, 0, 19, 0, "<compat> 4E85" },
/* U+2f06 */ { 30, 0, 19, 0, "<compat> 4E8C" },
/* U+2f07 */ { 30, 0, 19, 0, "<compat> 4EA0" },
/* U+2f08 */ { 30, 0, 19, 0, "<compat> 4EBA" },
/* U+2f09 */ { 30, 0, 19, 0, "<compat> 513F" },
/* U+2f0a */ { 30, 0, 19, 0, "<compat> 5165" },
/* U+2f0b */ { 30, 0, 19, 0, "<compat> 516B" },
/* U+2f0c */ { 30, 0, 19, 0, "<compat> 5182" },
/* U+2f0d */ { 30, 0, 19, 0, "<compat> 5196" },
/* U+2f0e */ { 30, 0, 19, 0, "<compat> 51AB" },
/* U+2f0f */ { 30, 0, 19, 0, "<compat> 51E0" },
/* U+2f10 */ { 30, 0, 19, 0, "<compat> 51F5" },
/* U+2f11 */ { 30, 0, 19, 0, "<compat> 5200" },
/* U+2f12 */ { 30, 0, 19, 0, "<compat> 529B" },
/* U+2f13 */ { 30, 0, 19, 0, "<compat> 52F9" },
/* U+2f14 */ { 30, 0, 19, 0, "<compat> 5315" },
/* U+2f15 */ { 30, 0, 19, 0, "<compat> 531A" },
/* U+2f16 */ { 30, 0, 19, 0, "<compat> 5338" },
/* U+2f17 */ { 30, 0, 19, 0, "<compat> 5341" },
/* U+2f18 */ { 30, 0, 19, 0, "<compat> 535C" },
/* U+2f19 */ { 30, 0, 19, 0, "<compat> 5369" },
/* U+2f1a */ { 30, 0, 19, 0, "<compat> 5382" },
/* U+2f1b */ { 30, 0, 19, 0, "<compat> 53B6" },
/* U+2f1c */ { 30, 0, 19, 0, "<compat> 53C8" },
/* U+2f1d */ { 30, 0, 19, 0, "<compat> 53E3" },
/* U+2f1e */ { 30, 0, 19, 0, "<compat> 56D7" },
/* U+2f1f */ { 30, 0, 19, 0, "<compat> 571F" },
/* U+2f20 */ { 30, 0, 19, 0, "<compat> 58EB" },
/* U+2f21 */ { 30, 0, 19, 0, "<compat> 5902" },
/* U+2f22 */ { 30, 0, 19, 0, "<compat> 590A" },
/* U+2f23 */ { 30, 0, 19, 0, "<compat> 5915" },
/* U+2f24 */ { 30, 0, 19, 0, "<compat> 5927" },
/* U+2f25 */ { 30, 0, 19, 0, "<compat> 5973" },
/* U+2f26 */ { 30, 0, 19, 0, "<compat> 5B50" },
/* U+2f27 */ { 30, 0, 19, 0, "<compat> 5B80" },
/* U+2f28 */ { 30, 0, 19, 0, "<compat> 5BF8" },
/* U+2f29 */ { 30, 0, 19, 0, "<compat> 5C0F" },
/* U+2f2a */ { 30, 0, 19, 0, "<compat> 5C22" },
/* U+2f2b */ { 30, 0, 19, 0, "<compat> 5C38" },
/* U+2f2c */ { 30, 0, 19, 0, "<compat> 5C6E" },
/* U+2f2d */ { 30, 0, 19, 0, "<compat> 5C71" },
/* U+2f2e */ { 30, 0, 19, 0, "<compat> 5DDB" },
/* U+2f2f */ { 30, 0, 19, 0, "<compat> 5DE5" },
/* U+2f30 */ { 30, 0, 19, 0, "<compat> 5DF1" },
/* U+2f31 */ { 30, 0, 19, 0, "<compat> 5DFE" },
/* U+2f32 */ { 30, 0, 19, 0, "<compat> 5E72" },
/* U+2f33 */ { 30, 0, 19, 0, "<compat> 5E7A" },
/* U+2f34 */ { 30, 0, 19, 0, "<compat> 5E7F" },
/* U+2f35 */ { 30, 0, 19, 0, "<compat> 5EF4" },
/* U+2f36 */ { 30, 0, 19, 0, "<compat> 5EFE" },
/* U+2f37 */ { 30, 0, 19, 0, "<compat> 5F0B" },
/* U+2f38 */ { 30, 0, 19, 0, "<compat> 5F13" },
/* U+2f39 */ { 30, 0, 19, 0, "<compat> 5F50" },
/* U+2f3a */ { 30, 0, 19, 0, "<compat> 5F61" },
/* U+2f3b */ { 30, 0, 19, 0, "<compat> 5F73" },
/* U+2f3c */ { 30, 0, 19, 0, "<compat> 5FC3" },
/* U+2f3d */ { 30, 0, 19, 0, "<compat> 6208" },
/* U+2f3e */ { 30, 0, 19, 0, "<compat> 6236" },
/* U+2f3f */ { 30, 0, 19, 0, "<compat> 624B" },
/* U+2f40 */ { 30, 0, 19, 0, "<compat> 652F" },
/* U+2f41 */ { 30, 0, 19, 0, "<compat> 6534" },
/* U+2f42 */ { 30, 0, 19, 0, "<compat> 6587" },
/* U+2f43 */ { 30, 0, 19, 0, "<compat> 6597" },
/* U+2f44 */ { 30, 0, 19, 0, "<compat> 65A4" },
/* U+2f45 */ { 30, 0, 19, 0, "<compat> 65B9" },
/* U+2f46 */ { 30, 0, 19, 0, "<compat> 65E0" },
/* U+2f47 */ { 30, 0, 19, 0, "<compat> 65E5" },
/* U+2f48 */ { 30, 0, 19, 0, "<compat> 66F0" },
/* U+2f49 */ { 30, 0, 19, 0, "<compat> 6708" },
/* U+2f4a */ { 30, 0, 19, 0, "<compat> 6728" },
/* U+2f4b */ { 30, 0, 19, 0, "<compat> 6B20" },
/* U+2f4c */ { 30, 0, 19, 0, "<compat> 6B62" },
/* U+2f4d */ { 30, 0, 19, 0, "<compat> 6B79" },
/* U+2f4e */ { 30, 0, 19, 0, "<compat> 6BB3" },
/* U+2f4f */ { 30, 0, 19, 0, "<compat> 6BCB" },
/* U+2f50 */ { 30, 0, 19, 0, "<compat> 6BD4" },
/* U+2f51 */ { 30, 0, 19, 0, "<compat> 6BDB" },
/* U+2f52 */ { 30, 0, 19, 0, "<compat> 6C0F" },
/* U+2f53 */ { 30, 0, 19, 0, "<compat> 6C14" },
/* U+2f54 */ { 30, 0, 19, 0, "<compat> 6C34" },
/* U+2f55 */ { 30, 0, 19, 0, "<compat> 706B" },
/* U+2f56 */ { 30, 0, 19, 0, "<compat> 722A" },
/* U+2f57 */ { 30, 0, 19, 0, "<compat> 7236" },
/* U+2f58 */ { 30, 0, 19, 0, "<compat> 723B" },
/* U+2f59 */ { 30, 0, 19, 0, "<compat> 723F" },
/* U+2f5a */ { 30, 0, 19, 0, "<compat> 7247" },
/* U+2f5b */ { 30, 0, 19, 0, "<compat> 7259" },
/* U+2f5c */ { 30, 0, 19, 0, "<compat> 725B" },
/* U+2f5d */ { 30, 0, 19, 0, "<compat> 72AC" },
/* U+2f5e */ { 30, 0, 19, 0, "<compat> 7384" },
/* U+2f5f */ { 30, 0, 19, 0, "<compat> 7389" },
/* U+2f60 */ { 30, 0, 19, 0, "<compat> 74DC" },
/* U+2f61 */ { 30, 0, 19, 0, "<compat> 74E6" },
/* U+2f62 */ { 30, 0, 19, 0, "<compat> 7518" },
/* U+2f63 */ { 30, 0, 19, 0, "<compat> 751F" },
/* U+2f64 */ { 30, 0, 19, 0, "<compat> 7528" },
/* U+2f65 */ { 30, 0, 19, 0, "<compat> 7530" },
/* U+2f66 */ { 30, 0, 19, 0, "<compat> 758B" },
/* U+2f67 */ { 30, 0, 19, 0, "<compat> 7592" },
/* U+2f68 */ { 30, 0, 19, 0, "<compat> 7676" },
/* U+2f69 */ { 30, 0, 19, 0, "<compat> 767D" },
/* U+2f6a */ { 30, 0, 19, 0, "<compat> 76AE" },
/* U+2f6b */ { 30, 0, 19, 0, "<compat> 76BF" },
/* U+2f6c */ { 30, 0, 19, 0, "<compat> 76EE" },
/* U+2f6d */ { 30, 0, 19, 0, "<compat> 77DB" },
/* U+2f6e */ { 30, 0, 19, 0, "<compat> 77E2" },
/* U+2f6f */ { 30, 0, 19, 0, "<compat> 77F3" },
/* U+2f70 */ { 30, 0, 19, 0, "<compat> 793A" },
/* U+2f71 */ { 30, 0, 19, 0, "<compat> 79B8" },
/* U+2f72 */ { 30, 0, 19, 0, "<compat> 79BE" },
/* U+2f73 */ { 30, 0, 19, 0, "<compat> 7A74" },
/* U+2f74 */ { 30, 0, 19, 0, "<compat> 7ACB" },
/* U+2f75 */ { 30, 0, 19, 0, "<compat> 7AF9" },
/* U+2f76 */ { 30, 0, 19, 0, "<compat> 7C73" },
/* U+2f77 */ { 30, 0, 19, 0, "<compat> 7CF8" },
/* U+2f78 */ { 30, 0, 19, 0, "<compat> 7F36" },
/* U+2f79 */ { 30, 0, 19, 0, "<compat> 7F51" },
/* U+2f7a */ { 30, 0, 19, 0, "<compat> 7F8A" },
/* U+2f7b */ { 30, 0, 19, 0, "<compat> 7FBD" },
/* U+2f7c */ { 30, 0, 19, 0, "<compat> 8001" },
/* U+2f7d */ { 30, 0, 19, 0, "<compat> 800C" },
/* U+2f7e */ { 30, 0, 19, 0, "<compat> 8012" },
/* U+2f7f */ { 30, 0, 19, 0, "<compat> 8033" },
/* U+2f80 */ { 30, 0, 19, 0, "<compat> 807F" },
/* U+2f81 */ { 30, 0, 19, 0, "<compat> 8089" },
/* U+2f82 */ { 30, 0, 19, 0, "<compat> 81E3" },
/* U+2f83 */ { 30, 0, 19, 0, "<compat> 81EA" },
/* U+2f84 */ { 30, 0, 19, 0, "<compat> 81F3" },
/* U+2f85 */ { 30, 0, 19, 0, "<compat> 81FC" },
/* U+2f86 */ { 30, 0, 19, 0, "<compat> 820C" },
/* U+2f87 */ { 30, 0, 19, 0, "<compat> 821B" },
/* U+2f88 */ { 30, 0, 19, 0, "<compat> 821F" },
/* U+2f89 */ { 30, 0, 19, 0, "<compat> 826E" },
/* U+2f8a */ { 30, 0, 19, 0, "<compat> 8272" },
/* U+2f8b */ { 30, 0, 19, 0, "<compat> 8278" },
/* U+2f8c */ { 30, 0, 19, 0, "<compat> 864D" },
/* U+2f8d */ { 30, 0, 19, 0, "<compat> 866B" },
/* U+2f8e */ { 30, 0, 19, 0, "<compat> 8840" },
/* U+2f8f */ { 30, 0, 19, 0, "<compat> 884C" },
/* U+2f90 */ { 30, 0, 19, 0, "<compat> 8863" },
/* U+2f91 */ { 30, 0, 19, 0, "<compat> 897E" },
/* U+2f92 */ { 30, 0, 19, 0, "<compat> 898B" },
/* U+2f93 */ { 30, 0, 19, 0, "<compat> 89D2" },
/* U+2f94 */ { 30, 0, 19, 0, "<compat> 8A00" },
/* U+2f95 */ { 30, 0, 19, 0, "<compat> 8C37" },
/* U+2f96 */ { 30, 0, 19, 0, "<compat> 8C46" },
/* U+2f97 */ { 30, 0, 19, 0, "<compat> 8C55" },
/* U+2f98 */ { 30, 0, 19, 0, "<compat> 8C78" },
/* U+2f99 */ { 30, 0, 19, 0, "<compat> 8C9D" },
/* U+2f9a */ { 30, 0, 19, 0, "<compat> 8D64" },
/* U+2f9b */ { 30, 0, 19, 0, "<compat> 8D70" },
/* U+2f9c */ { 30, 0, 19, 0, "<compat> 8DB3" },
/* U+2f9d */ { 30, 0, 19, 0, "<compat> 8EAB" },
/* U+2f9e */ { 30, 0, 19, 0, "<compat> 8ECA" },
/* U+2f9f */ { 30, 0, 19, 0, "<compat> 8F9B" },
/* U+2fa0 */ { 30, 0, 19, 0, "<compat> 8FB0" },
/* U+2fa1 */ { 30, 0, 19, 0, "<compat> 8FB5" },
/* U+2fa2 */ { 30, 0, 19, 0, "<compat> 9091" },
/* U+2fa3 */ { 30, 0, 19, 0, "<compat> 9149" },
/* U+2fa4 */ { 30, 0, 19, 0, "<compat> 91C6" },
/* U+2fa5 */ { 30, 0, 19, 0, "<compat> 91CC" },
/* U+2fa6 */ { 30, 0, 19, 0, "<compat> 91D1" },
/* U+2fa7 */ { 30, 0, 19, 0, "<compat> 9577" },
/* U+2fa8 */ { 30, 0, 19, 0, "<compat> 9580" },
/* U+2fa9 */ { 30, 0, 19, 0, "<compat> 961C" },
/* U+2faa */ { 30, 0, 19, 0, "<compat> 96B6" },
/* U+2fab */ { 30, 0, 19, 0, "<compat> 96B9" },
/* U+2fac */ { 30, 0, 19, 0, "<compat> 96E8" },
/* U+2fad */ { 30, 0, 19, 0, "<compat> 9751" },
/* U+2fae */ { 30, 0, 19, 0, "<compat> 975E" },
/* U+2faf */ { 30, 0, 19, 0, "<compat> 9762" },
/* U+2fb0 */ { 30, 0, 19, 0, "<compat> 9769" },
/* U+2fb1 */ { 30, 0, 19, 0, "<compat> 97CB" },
/* U+2fb2 */ { 30, 0, 19, 0, "<compat> 97ED" },
/* U+2fb3 */ { 30, 0, 19, 0, "<compat> 97F3" },
/* U+2fb4 */ { 30, 0, 19, 0, "<compat> 9801" },
/* U+2fb5 */ { 30, 0, 19, 0, "<compat> 98A8" },
/* U+2fb6 */ { 30, 0, 19, 0, "<compat> 98DB" },
/* U+2fb7 */ { 30, 0, 19, 0, "<compat> 98DF" },
/* U+2fb8 */ { 30, 0, 19, 0, "<compat> 9996" },
/* U+2fb9 */ { 30, 0, 19, 0, "<compat> 9999" },
/* U+2fba */ { 30, 0, 19, 0, "<compat> 99AC" },
/* U+2fbb */ { 30, 0, 19, 0, "<compat> 9AA8" },
/* U+2fbc */ { 30, 0, 19, 0, "<compat> 9AD8" },
/* U+2fbd */ { 30, 0, 19, 0, "<compat> 9ADF" },
/* U+2fbe */ { 30, 0, 19, 0, "<compat> 9B25" },
/* U+2fbf */ { 30, 0, 19, 0, "<compat> 9B2F" },
/* U+2fc0 */ { 30, 0, 19, 0, "<compat> 9B32" },
/* U+2fc1 */ { 30, 0, 19, 0, "<compat> 9B3C" },
/* U+2fc2 */ { 30, 0, 19, 0, "<compat> 9B5A" },
/* U+2fc3 */ { 30, 0, 19, 0, "<compat> 9CE5" },
/* U+2fc4 */ { 30, 0, 19, 0, "<compat> 9E75" },
/* U+2fc5 */ { 30, 0, 19, 0, "<compat> 9E7F" },
/* U+2fc6 */ { 30, 0, 19, 0, "<compat> 9EA5" },
/* U+2fc7 */ { 30, 0, 19, 0, "<compat> 9EBB" },
/* U+2fc8 */ { 30, 0, 19, 0, "<compat> 9EC3" },
/* U+2fc9 */ { 30, 0, 19, 0, "<compat> 9ECD" },
/* U+2fca */ { 30, 0, 19, 0, "<compat> 9ED1" },
/* U+2fcb */ { 30, 0, 19, 0, "<compat> 9EF9" },
/* U+2fcc */ { 30, 0, 19, 0, "<compat> 9EFD" },
/* U+2fcd */ { 30, 0, 19, 0, "<compat> 9F0E" },
/* U+2fce */ { 30, 0, 19, 0, "<compat> 9F13" },
/* U+2fcf */ { 30, 0, 19, 0, "<compat> 9F20" },
/* U+2fd0 */ { 30, 0, 19, 0, "<compat> 9F3B" },
/* U+2fd1 */ { 30, 0, 19, 0, "<compat> 9F4A" },
/* U+2fd2 */ { 30, 0, 19, 0, "<compat> 9F52" },
/* U+2fd3 */ { 30, 0, 19, 0, "<compat> 9F8D" },
/* U+2fd4 */ { 30, 0, 19, 0, "<compat> 9F9C" },
/* U+2fd5 */ { 30, 0, 19, 0, "<compat> 9FA0" },
/* U+2fd6 */ { 0, 0, 0, 0, 0 },
/* U+2fd7 */ { 0, 0, 0, 0, 0 },
/* U+2fd8 */ { 0, 0, 0, 0, 0 },
/* U+2fd9 */ { 0, 0, 0, 0, 0 },
/* U+2fda */ { 0, 0, 0, 0, 0 },
/* U+2fdb */ { 0, 0, 0, 0, 0 },
/* U+2fdc */ { 0, 0, 0, 0, 0 },
/* U+2fdd */ { 0, 0, 0, 0, 0 },
/* U+2fde */ { 0, 0, 0, 0, 0 },
/* U+2fdf */ { 0, 0, 0, 0, 0 },
/* U+2fe0 */ { 0, 0, 0, 0, 0 },
/* U+2fe1 */ { 0, 0, 0, 0, 0 },
/* U+2fe2 */ { 0, 0, 0, 0, 0 },
/* U+2fe3 */ { 0, 0, 0, 0, 0 },
/* U+2fe4 */ { 0, 0, 0, 0, 0 },
/* U+2fe5 */ { 0, 0, 0, 0, 0 },
/* U+2fe6 */ { 0, 0, 0, 0, 0 },
/* U+2fe7 */ { 0, 0, 0, 0, 0 },
/* U+2fe8 */ { 0, 0, 0, 0, 0 },
/* U+2fe9 */ { 0, 0, 0, 0, 0 },
/* U+2fea */ { 0, 0, 0, 0, 0 },
/* U+2feb */ { 0, 0, 0, 0, 0 },
/* U+2fec */ { 0, 0, 0, 0, 0 },
/* U+2fed */ { 0, 0, 0, 0, 0 },
/* U+2fee */ { 0, 0, 0, 0, 0 },
/* U+2fef */ { 0, 0, 0, 0, 0 },
/* U+2ff0 */ { 30, 0, 19, 0, 0 },
/* U+2ff1 */ { 30, 0, 19, 0, 0 },
/* U+2ff2 */ { 30, 0, 19, 0, 0 },
/* U+2ff3 */ { 30, 0, 19, 0, 0 },
/* U+2ff4 */ { 30, 0, 19, 0, 0 },
/* U+2ff5 */ { 30, 0, 19, 0, 0 },
/* U+2ff6 */ { 30, 0, 19, 0, 0 },
/* U+2ff7 */ { 30, 0, 19, 0, 0 },
/* U+2ff8 */ { 30, 0, 19, 0, 0 },
/* U+2ff9 */ { 30, 0, 19, 0, 0 },
/* U+2ffa */ { 30, 0, 19, 0, 0 },
/* U+2ffb */ { 30, 0, 19, 0, 0 },
/* U+2ffc */ { 0, 0, 0, 0, 0 },
/* U+2ffd */ { 0, 0, 0, 0, 0 },
/* U+2ffe */ { 0, 0, 0, 0, 0 },
/* U+2fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_3[4096] = {
    
/* U+3000 */ { 10, 0, 18, 0, "<wide> 0020" },
/* U+3001 */ { 26, 0, 19, 0, 0 },
/* U+3002 */ { 26, 0, 19, 0, 0 },
/* U+3003 */ { 26, 0, 19, 0, 0 },
/* U+3004 */ { 30, 0, 19, 0, 0 },
/* U+3005 */ { 18, 0, 1, 0, 0 },
/* U+3006 */ { 19, 0, 1, 0, 0 },
/* U+3007 */ { 8, 0, 1, 0, 0 },
/* U+3008 */ { 22, 0, 19, 1, 0 },
/* U+3009 */ { 23, 0, 19, 1, 0 },
/* U+300a */ { 22, 0, 19, 1, 0 },
/* U+300b */ { 23, 0, 19, 1, 0 },
/* U+300c */ { 22, 0, 19, 1, 0 },
/* U+300d */ { 23, 0, 19, 1, 0 },
/* U+300e */ { 22, 0, 19, 1, 0 },
/* U+300f */ { 23, 0, 19, 1, 0 },
/* U+3010 */ { 22, 0, 19, 1, 0 },
/* U+3011 */ { 23, 0, 19, 1, 0 },
/* U+3012 */ { 30, 0, 19, 0, 0 },
/* U+3013 */ { 30, 0, 19, 0, 0 },
/* U+3014 */ { 22, 0, 19, 1, 0 },
/* U+3015 */ { 23, 0, 19, 1, 0 },
/* U+3016 */ { 22, 0, 19, 1, 0 },
/* U+3017 */ { 23, 0, 19, 1, 0 },
/* U+3018 */ { 22, 0, 19, 1, 0 },
/* U+3019 */ { 23, 0, 19, 1, 0 },
/* U+301a */ { 22, 0, 19, 1, 0 },
/* U+301b */ { 23, 0, 19, 1, 0 },
/* U+301c */ { 21, 0, 19, 0, 0 },
/* U+301d */ { 22, 0, 19, 0, 0 },
/* U+301e */ { 23, 0, 19, 0, 0 },
/* U+301f */ { 23, 0, 19, 0, 0 },
/* U+3020 */ { 30, 0, 19, 0, 0 },
/* U+3021 */ { 8, 0, 1, 0, 0 },
/* U+3022 */ { 8, 0, 1, 0, 0 },
/* U+3023 */ { 8, 0, 1, 0, 0 },
/* U+3024 */ { 8, 0, 1, 0, 0 },
/* U+3025 */ { 8, 0, 1, 0, 0 },
/* U+3026 */ { 8, 0, 1, 0, 0 },
/* U+3027 */ { 8, 0, 1, 0, 0 },
/* U+3028 */ { 8, 0, 1, 0, 0 },
/* U+3029 */ { 8, 0, 1, 0, 0 },
/* U+302a */ { 4, 218, 14, 0, 0 },
/* U+302b */ { 4, 228, 14, 0, 0 },
/* U+302c */ { 4, 232, 14, 0, 0 },
/* U+302d */ { 4, 222, 14, 0, 0 },
/* U+302e */ { 4, 224, 14, 0, 0 },
/* U+302f */ { 4, 224, 14, 0, 0 },
/* U+3030 */ { 21, 0, 19, 0, 0 },
/* U+3031 */ { 18, 0, 1, 0, 0 },
/* U+3032 */ { 18, 0, 1, 0, 0 },
/* U+3033 */ { 18, 0, 1, 0, 0 },
/* U+3034 */ { 18, 0, 1, 0, 0 },
/* U+3035 */ { 18, 0, 1, 0, 0 },
/* U+3036 */ { 30, 0, 19, 0, "<compat> 3012" },
/* U+3037 */ { 30, 0, 19, 0, 0 },
/* U+3038 */ { 8, 0, 1, 0, "<compat> 5341" },
/* U+3039 */ { 8, 0, 1, 0, "<compat> 5344" },
/* U+303a */ { 8, 0, 1, 0, "<compat> 5345" },
/* U+303b */ { 0, 0, 0, 0, 0 },
/* U+303c */ { 0, 0, 0, 0, 0 },
/* U+303d */ { 0, 0, 0, 0, 0 },
/* U+303e */ { 30, 0, 19, 0, 0 },
/* U+303f */ { 30, 0, 19, 0, 0 },
/* U+3040 */ { 0, 0, 0, 0, 0 },
/* U+3041 */ { 19, 0, 1, 0, 0 },
/* U+3042 */ { 19, 0, 1, 0, 0 },
/* U+3043 */ { 19, 0, 1, 0, 0 },
/* U+3044 */ { 19, 0, 1, 0, 0 },
/* U+3045 */ { 19, 0, 1, 0, 0 },
/* U+3046 */ { 19, 0, 1, 0, 0 },
/* U+3047 */ { 19, 0, 1, 0, 0 },
/* U+3048 */ { 19, 0, 1, 0, 0 },
/* U+3049 */ { 19, 0, 1, 0, 0 },
/* U+304a */ { 19, 0, 1, 0, 0 },
/* U+304b */ { 19, 0, 1, 0, 0 },
/* U+304c */ { 19, 0, 1, 0, "304B 3099" },
/* U+304d */ { 19, 0, 1, 0, 0 },
/* U+304e */ { 19, 0, 1, 0, "304D 3099" },
/* U+304f */ { 19, 0, 1, 0, 0 },
/* U+3050 */ { 19, 0, 1, 0, "304F 3099" },
/* U+3051 */ { 19, 0, 1, 0, 0 },
/* U+3052 */ { 19, 0, 1, 0, "3051 3099" },
/* U+3053 */ { 19, 0, 1, 0, 0 },
/* U+3054 */ { 19, 0, 1, 0, "3053 3099" },
/* U+3055 */ { 19, 0, 1, 0, 0 },
/* U+3056 */ { 19, 0, 1, 0, "3055 3099" },
/* U+3057 */ { 19, 0, 1, 0, 0 },
/* U+3058 */ { 19, 0, 1, 0, "3057 3099" },
/* U+3059 */ { 19, 0, 1, 0, 0 },
/* U+305a */ { 19, 0, 1, 0, "3059 3099" },
/* U+305b */ { 19, 0, 1, 0, 0 },
/* U+305c */ { 19, 0, 1, 0, "305B 3099" },
/* U+305d */ { 19, 0, 1, 0, 0 },
/* U+305e */ { 19, 0, 1, 0, "305D 3099" },
/* U+305f */ { 19, 0, 1, 0, 0 },
/* U+3060 */ { 19, 0, 1, 0, "305F 3099" },
/* U+3061 */ { 19, 0, 1, 0, 0 },
/* U+3062 */ { 19, 0, 1, 0, "3061 3099" },
/* U+3063 */ { 19, 0, 1, 0, 0 },
/* U+3064 */ { 19, 0, 1, 0, 0 },
/* U+3065 */ { 19, 0, 1, 0, "3064 3099" },
/* U+3066 */ { 19, 0, 1, 0, 0 },
/* U+3067 */ { 19, 0, 1, 0, "3066 3099" },
/* U+3068 */ { 19, 0, 1, 0, 0 },
/* U+3069 */ { 19, 0, 1, 0, "3068 3099" },
/* U+306a */ { 19, 0, 1, 0, 0 },
/* U+306b */ { 19, 0, 1, 0, 0 },
/* U+306c */ { 19, 0, 1, 0, 0 },
/* U+306d */ { 19, 0, 1, 0, 0 },
/* U+306e */ { 19, 0, 1, 0, 0 },
/* U+306f */ { 19, 0, 1, 0, 0 },
/* U+3070 */ { 19, 0, 1, 0, "306F 3099" },
/* U+3071 */ { 19, 0, 1, 0, "306F 309A" },
/* U+3072 */ { 19, 0, 1, 0, 0 },
/* U+3073 */ { 19, 0, 1, 0, "3072 3099" },
/* U+3074 */ { 19, 0, 1, 0, "3072 309A" },
/* U+3075 */ { 19, 0, 1, 0, 0 },
/* U+3076 */ { 19, 0, 1, 0, "3075 3099" },
/* U+3077 */ { 19, 0, 1, 0, "3075 309A" },
/* U+3078 */ { 19, 0, 1, 0, 0 },
/* U+3079 */ { 19, 0, 1, 0, "3078 3099" },
/* U+307a */ { 19, 0, 1, 0, "3078 309A" },
/* U+307b */ { 19, 0, 1, 0, 0 },
/* U+307c */ { 19, 0, 1, 0, "307B 3099" },
/* U+307d */ { 19, 0, 1, 0, "307B 309A" },
/* U+307e */ { 19, 0, 1, 0, 0 },
/* U+307f */ { 19, 0, 1, 0, 0 },
/* U+3080 */ { 19, 0, 1, 0, 0 },
/* U+3081 */ { 19, 0, 1, 0, 0 },
/* U+3082 */ { 19, 0, 1, 0, 0 },
/* U+3083 */ { 19, 0, 1, 0, 0 },
/* U+3084 */ { 19, 0, 1, 0, 0 },
/* U+3085 */ { 19, 0, 1, 0, 0 },
/* U+3086 */ { 19, 0, 1, 0, 0 },
/* U+3087 */ { 19, 0, 1, 0, 0 },
/* U+3088 */ { 19, 0, 1, 0, 0 },
/* U+3089 */ { 19, 0, 1, 0, 0 },
/* U+308a */ { 19, 0, 1, 0, 0 },
/* U+308b */ { 19, 0, 1, 0, 0 },
/* U+308c */ { 19, 0, 1, 0, 0 },
/* U+308d */ { 19, 0, 1, 0, 0 },
/* U+308e */ { 19, 0, 1, 0, 0 },
/* U+308f */ { 19, 0, 1, 0, 0 },
/* U+3090 */ { 19, 0, 1, 0, 0 },
/* U+3091 */ { 19, 0, 1, 0, 0 },
/* U+3092 */ { 19, 0, 1, 0, 0 },
/* U+3093 */ { 19, 0, 1, 0, 0 },
/* U+3094 */ { 19, 0, 1, 0, "3046 3099" },
/* U+3095 */ { 0, 0, 0, 0, 0 },
/* U+3096 */ { 0, 0, 0, 0, 0 },
/* U+3097 */ { 0, 0, 0, 0, 0 },
/* U+3098 */ { 0, 0, 0, 0, 0 },
/* U+3099 */ { 4, 8, 14, 0, 0 },
/* U+309a */ { 4, 8, 14, 0, 0 },
/* U+309b */ { 29, 0, 19, 0, "<compat> 0020 3099" },
/* U+309c */ { 29, 0, 19, 0, "<compat> 0020 309A" },
/* U+309d */ { 18, 0, 1, 0, 0 },
/* U+309e */ { 18, 0, 1, 0, "309D 3099" },
/* U+309f */ { 0, 0, 0, 0, 0 },
/* U+30a0 */ { 0, 0, 0, 0, 0 },
/* U+30a1 */ { 19, 0, 1, 0, 0 },
/* U+30a2 */ { 19, 0, 1, 0, 0 },
/* U+30a3 */ { 19, 0, 1, 0, 0 },
/* U+30a4 */ { 19, 0, 1, 0, 0 },
/* U+30a5 */ { 19, 0, 1, 0, 0 },
/* U+30a6 */ { 19, 0, 1, 0, 0 },
/* U+30a7 */ { 19, 0, 1, 0, 0 },
/* U+30a8 */ { 19, 0, 1, 0, 0 },
/* U+30a9 */ { 19, 0, 1, 0, 0 },
/* U+30aa */ { 19, 0, 1, 0, 0 },
/* U+30ab */ { 19, 0, 1, 0, 0 },
/* U+30ac */ { 19, 0, 1, 0, "30AB 3099" },
/* U+30ad */ { 19, 0, 1, 0, 0 },
/* U+30ae */ { 19, 0, 1, 0, "30AD 3099" },
/* U+30af */ { 19, 0, 1, 0, 0 },
/* U+30b0 */ { 19, 0, 1, 0, "30AF 3099" },
/* U+30b1 */ { 19, 0, 1, 0, 0 },
/* U+30b2 */ { 19, 0, 1, 0, "30B1 3099" },
/* U+30b3 */ { 19, 0, 1, 0, 0 },
/* U+30b4 */ { 19, 0, 1, 0, "30B3 3099" },
/* U+30b5 */ { 19, 0, 1, 0, 0 },
/* U+30b6 */ { 19, 0, 1, 0, "30B5 3099" },
/* U+30b7 */ { 19, 0, 1, 0, 0 },
/* U+30b8 */ { 19, 0, 1, 0, "30B7 3099" },
/* U+30b9 */ { 19, 0, 1, 0, 0 },
/* U+30ba */ { 19, 0, 1, 0, "30B9 3099" },
/* U+30bb */ { 19, 0, 1, 0, 0 },
/* U+30bc */ { 19, 0, 1, 0, "30BB 3099" },
/* U+30bd */ { 19, 0, 1, 0, 0 },
/* U+30be */ { 19, 0, 1, 0, "30BD 3099" },
/* U+30bf */ { 19, 0, 1, 0, 0 },
/* U+30c0 */ { 19, 0, 1, 0, "30BF 3099" },
/* U+30c1 */ { 19, 0, 1, 0, 0 },
/* U+30c2 */ { 19, 0, 1, 0, "30C1 3099" },
/* U+30c3 */ { 19, 0, 1, 0, 0 },
/* U+30c4 */ { 19, 0, 1, 0, 0 },
/* U+30c5 */ { 19, 0, 1, 0, "30C4 3099" },
/* U+30c6 */ { 19, 0, 1, 0, 0 },
/* U+30c7 */ { 19, 0, 1, 0, "30C6 3099" },
/* U+30c8 */ { 19, 0, 1, 0, 0 },
/* U+30c9 */ { 19, 0, 1, 0, "30C8 3099" },
/* U+30ca */ { 19, 0, 1, 0, 0 },
/* U+30cb */ { 19, 0, 1, 0, 0 },
/* U+30cc */ { 19, 0, 1, 0, 0 },
/* U+30cd */ { 19, 0, 1, 0, 0 },
/* U+30ce */ { 19, 0, 1, 0, 0 },
/* U+30cf */ { 19, 0, 1, 0, 0 },
/* U+30d0 */ { 19, 0, 1, 0, "30CF 3099" },
/* U+30d1 */ { 19, 0, 1, 0, "30CF 309A" },
/* U+30d2 */ { 19, 0, 1, 0, 0 },
/* U+30d3 */ { 19, 0, 1, 0, "30D2 3099" },
/* U+30d4 */ { 19, 0, 1, 0, "30D2 309A" },
/* U+30d5 */ { 19, 0, 1, 0, 0 },
/* U+30d6 */ { 19, 0, 1, 0, "30D5 3099" },
/* U+30d7 */ { 19, 0, 1, 0, "30D5 309A" },
/* U+30d8 */ { 19, 0, 1, 0, 0 },
/* U+30d9 */ { 19, 0, 1, 0, "30D8 3099" },
/* U+30da */ { 19, 0, 1, 0, "30D8 309A" },
/* U+30db */ { 19, 0, 1, 0, 0 },
/* U+30dc */ { 19, 0, 1, 0, "30DB 3099" },
/* U+30dd */ { 19, 0, 1, 0, "30DB 309A" },
/* U+30de */ { 19, 0, 1, 0, 0 },
/* U+30df */ { 19, 0, 1, 0, 0 },
/* U+30e0 */ { 19, 0, 1, 0, 0 },
/* U+30e1 */ { 19, 0, 1, 0, 0 },
/* U+30e2 */ { 19, 0, 1, 0, 0 },
/* U+30e3 */ { 19, 0, 1, 0, 0 },
/* U+30e4 */ { 19, 0, 1, 0, 0 },
/* U+30e5 */ { 19, 0, 1, 0, 0 },
/* U+30e6 */ { 19, 0, 1, 0, 0 },
/* U+30e7 */ { 19, 0, 1, 0, 0 },
/* U+30e8 */ { 19, 0, 1, 0, 0 },
/* U+30e9 */ { 19, 0, 1, 0, 0 },
/* U+30ea */ { 19, 0, 1, 0, 0 },
/* U+30eb */ { 19, 0, 1, 0, 0 },
/* U+30ec */ { 19, 0, 1, 0, 0 },
/* U+30ed */ { 19, 0, 1, 0, 0 },
/* U+30ee */ { 19, 0, 1, 0, 0 },
/* U+30ef */ { 19, 0, 1, 0, 0 },
/* U+30f0 */ { 19, 0, 1, 0, 0 },
/* U+30f1 */ { 19, 0, 1, 0, 0 },
/* U+30f2 */ { 19, 0, 1, 0, 0 },
/* U+30f3 */ { 19, 0, 1, 0, 0 },
/* U+30f4 */ { 19, 0, 1, 0, "30A6 3099" },
/* U+30f5 */ { 19, 0, 1, 0, 0 },
/* U+30f6 */ { 19, 0, 1, 0, 0 },
/* U+30f7 */ { 19, 0, 1, 0, "30EF 3099" },
/* U+30f8 */ { 19, 0, 1, 0, "30F0 3099" },
/* U+30f9 */ { 19, 0, 1, 0, "30F1 3099" },
/* U+30fa */ { 19, 0, 1, 0, "30F2 3099" },
/* U+30fb */ { 20, 0, 19, 0, 0 },
/* U+30fc */ { 18, 0, 1, 0, 0 },
/* U+30fd */ { 18, 0, 1, 0, 0 },
/* U+30fe */ { 18, 0, 1, 0, "30FD 3099" },
/* U+30ff */ { 0, 0, 0, 0, 0 },
/* U+3100 */ { 0, 0, 0, 0, 0 },
/* U+3101 */ { 0, 0, 0, 0, 0 },
/* U+3102 */ { 0, 0, 0, 0, 0 },
/* U+3103 */ { 0, 0, 0, 0, 0 },
/* U+3104 */ { 0, 0, 0, 0, 0 },
/* U+3105 */ { 19, 0, 1, 0, 0 },
/* U+3106 */ { 19, 0, 1, 0, 0 },
/* U+3107 */ { 19, 0, 1, 0, 0 },
/* U+3108 */ { 19, 0, 1, 0, 0 },
/* U+3109 */ { 19, 0, 1, 0, 0 },
/* U+310a */ { 19, 0, 1, 0, 0 },
/* U+310b */ { 19, 0, 1, 0, 0 },
/* U+310c */ { 19, 0, 1, 0, 0 },
/* U+310d */ { 19, 0, 1, 0, 0 },
/* U+310e */ { 19, 0, 1, 0, 0 },
/* U+310f */ { 19, 0, 1, 0, 0 },
/* U+3110 */ { 19, 0, 1, 0, 0 },
/* U+3111 */ { 19, 0, 1, 0, 0 },
/* U+3112 */ { 19, 0, 1, 0, 0 },
/* U+3113 */ { 19, 0, 1, 0, 0 },
/* U+3114 */ { 19, 0, 1, 0, 0 },
/* U+3115 */ { 19, 0, 1, 0, 0 },
/* U+3116 */ { 19, 0, 1, 0, 0 },
/* U+3117 */ { 19, 0, 1, 0, 0 },
/* U+3118 */ { 19, 0, 1, 0, 0 },
/* U+3119 */ { 19, 0, 1, 0, 0 },
/* U+311a */ { 19, 0, 1, 0, 0 },
/* U+311b */ { 19, 0, 1, 0, 0 },
/* U+311c */ { 19, 0, 1, 0, 0 },
/* U+311d */ { 19, 0, 1, 0, 0 },
/* U+311e */ { 19, 0, 1, 0, 0 },
/* U+311f */ { 19, 0, 1, 0, 0 },
/* U+3120 */ { 19, 0, 1, 0, 0 },
/* U+3121 */ { 19, 0, 1, 0, 0 },
/* U+3122 */ { 19, 0, 1, 0, 0 },
/* U+3123 */ { 19, 0, 1, 0, 0 },
/* U+3124 */ { 19, 0, 1, 0, 0 },
/* U+3125 */ { 19, 0, 1, 0, 0 },
/* U+3126 */ { 19, 0, 1, 0, 0 },
/* U+3127 */ { 19, 0, 1, 0, 0 },
/* U+3128 */ { 19, 0, 1, 0, 0 },
/* U+3129 */ { 19, 0, 1, 0, 0 },
/* U+312a */ { 19, 0, 1, 0, 0 },
/* U+312b */ { 19, 0, 1, 0, 0 },
/* U+312c */ { 19, 0, 1, 0, 0 },
/* U+312d */ { 0, 0, 0, 0, 0 },
/* U+312e */ { 0, 0, 0, 0, 0 },
/* U+312f */ { 0, 0, 0, 0, 0 },
/* U+3130 */ { 0, 0, 0, 0, 0 },
/* U+3131 */ { 19, 0, 1, 0, "<compat> 1100" },
/* U+3132 */ { 19, 0, 1, 0, "<compat> 1101" },
/* U+3133 */ { 19, 0, 1, 0, "<compat> 11AA" },
/* U+3134 */ { 19, 0, 1, 0, "<compat> 1102" },
/* U+3135 */ { 19, 0, 1, 0, "<compat> 11AC" },
/* U+3136 */ { 19, 0, 1, 0, "<compat> 11AD" },
/* U+3137 */ { 19, 0, 1, 0, "<compat> 1103" },
/* U+3138 */ { 19, 0, 1, 0, "<compat> 1104" },
/* U+3139 */ { 19, 0, 1, 0, "<compat> 1105" },
/* U+313a */ { 19, 0, 1, 0, "<compat> 11B0" },
/* U+313b */ { 19, 0, 1, 0, "<compat> 11B1" },
/* U+313c */ { 19, 0, 1, 0, "<compat> 11B2" },
/* U+313d */ { 19, 0, 1, 0, "<compat> 11B3" },
/* U+313e */ { 19, 0, 1, 0, "<compat> 11B4" },
/* U+313f */ { 19, 0, 1, 0, "<compat> 11B5" },
/* U+3140 */ { 19, 0, 1, 0, "<compat> 111A" },
/* U+3141 */ { 19, 0, 1, 0, "<compat> 1106" },
/* U+3142 */ { 19, 0, 1, 0, "<compat> 1107" },
/* U+3143 */ { 19, 0, 1, 0, "<compat> 1108" },
/* U+3144 */ { 19, 0, 1, 0, "<compat> 1121" },
/* U+3145 */ { 19, 0, 1, 0, "<compat> 1109" },
/* U+3146 */ { 19, 0, 1, 0, "<compat> 110A" },
/* U+3147 */ { 19, 0, 1, 0, "<compat> 110B" },
/* U+3148 */ { 19, 0, 1, 0, "<compat> 110C" },
/* U+3149 */ { 19, 0, 1, 0, "<compat> 110D" },
/* U+314a */ { 19, 0, 1, 0, "<compat> 110E" },
/* U+314b */ { 19, 0, 1, 0, "<compat> 110F" },
/* U+314c */ { 19, 0, 1, 0, "<compat> 1110" },
/* U+314d */ { 19, 0, 1, 0, "<compat> 1111" },
/* U+314e */ { 19, 0, 1, 0, "<compat> 1112" },
/* U+314f */ { 19, 0, 1, 0, "<compat> 1161" },
/* U+3150 */ { 19, 0, 1, 0, "<compat> 1162" },
/* U+3151 */ { 19, 0, 1, 0, "<compat> 1163" },
/* U+3152 */ { 19, 0, 1, 0, "<compat> 1164" },
/* U+3153 */ { 19, 0, 1, 0, "<compat> 1165" },
/* U+3154 */ { 19, 0, 1, 0, "<compat> 1166" },
/* U+3155 */ { 19, 0, 1, 0, "<compat> 1167" },
/* U+3156 */ { 19, 0, 1, 0, "<compat> 1168" },
/* U+3157 */ { 19, 0, 1, 0, "<compat> 1169" },
/* U+3158 */ { 19, 0, 1, 0, "<compat> 116A" },
/* U+3159 */ { 19, 0, 1, 0, "<compat> 116B" },
/* U+315a */ { 19, 0, 1, 0, "<compat> 116C" },
/* U+315b */ { 19, 0, 1, 0, "<compat> 116D" },
/* U+315c */ { 19, 0, 1, 0, "<compat> 116E" },
/* U+315d */ { 19, 0, 1, 0, "<compat> 116F" },
/* U+315e */ { 19, 0, 1, 0, "<compat> 1170" },
/* U+315f */ { 19, 0, 1, 0, "<compat> 1171" },
/* U+3160 */ { 19, 0, 1, 0, "<compat> 1172" },
/* U+3161 */ { 19, 0, 1, 0, "<compat> 1173" },
/* U+3162 */ { 19, 0, 1, 0, "<compat> 1174" },
/* U+3163 */ { 19, 0, 1, 0, "<compat> 1175" },
/* U+3164 */ { 19, 0, 1, 0, "<compat> 1160" },
/* U+3165 */ { 19, 0, 1, 0, "<compat> 1114" },
/* U+3166 */ { 19, 0, 1, 0, "<compat> 1115" },
/* U+3167 */ { 19, 0, 1, 0, "<compat> 11C7" },
/* U+3168 */ { 19, 0, 1, 0, "<compat> 11C8" },
/* U+3169 */ { 19, 0, 1, 0, "<compat> 11CC" },
/* U+316a */ { 19, 0, 1, 0, "<compat> 11CE" },
/* U+316b */ { 19, 0, 1, 0, "<compat> 11D3" },
/* U+316c */ { 19, 0, 1, 0, "<compat> 11D7" },
/* U+316d */ { 19, 0, 1, 0, "<compat> 11D9" },
/* U+316e */ { 19, 0, 1, 0, "<compat> 111C" },
/* U+316f */ { 19, 0, 1, 0, "<compat> 11DD" },
/* U+3170 */ { 19, 0, 1, 0, "<compat> 11DF" },
/* U+3171 */ { 19, 0, 1, 0, "<compat> 111D" },
/* U+3172 */ { 19, 0, 1, 0, "<compat> 111E" },
/* U+3173 */ { 19, 0, 1, 0, "<compat> 1120" },
/* U+3174 */ { 19, 0, 1, 0, "<compat> 1122" },
/* U+3175 */ { 19, 0, 1, 0, "<compat> 1123" },
/* U+3176 */ { 19, 0, 1, 0, "<compat> 1127" },
/* U+3177 */ { 19, 0, 1, 0, "<compat> 1129" },
/* U+3178 */ { 19, 0, 1, 0, "<compat> 112B" },
/* U+3179 */ { 19, 0, 1, 0, "<compat> 112C" },
/* U+317a */ { 19, 0, 1, 0, "<compat> 112D" },
/* U+317b */ { 19, 0, 1, 0, "<compat> 112E" },
/* U+317c */ { 19, 0, 1, 0, "<compat> 112F" },
/* U+317d */ { 19, 0, 1, 0, "<compat> 1132" },
/* U+317e */ { 19, 0, 1, 0, "<compat> 1136" },
/* U+317f */ { 19, 0, 1, 0, "<compat> 1140" },
/* U+3180 */ { 19, 0, 1, 0, "<compat> 1147" },
/* U+3181 */ { 19, 0, 1, 0, "<compat> 114C" },
/* U+3182 */ { 19, 0, 1, 0, "<compat> 11F1" },
/* U+3183 */ { 19, 0, 1, 0, "<compat> 11F2" },
/* U+3184 */ { 19, 0, 1, 0, "<compat> 1157" },
/* U+3185 */ { 19, 0, 1, 0, "<compat> 1158" },
/* U+3186 */ { 19, 0, 1, 0, "<compat> 1159" },
/* U+3187 */ { 19, 0, 1, 0, "<compat> 1184" },
/* U+3188 */ { 19, 0, 1, 0, "<compat> 1185" },
/* U+3189 */ { 19, 0, 1, 0, "<compat> 1188" },
/* U+318a */ { 19, 0, 1, 0, "<compat> 1191" },
/* U+318b */ { 19, 0, 1, 0, "<compat> 1192" },
/* U+318c */ { 19, 0, 1, 0, "<compat> 1194" },
/* U+318d */ { 19, 0, 1, 0, "<compat> 119E" },
/* U+318e */ { 19, 0, 1, 0, "<compat> 11A1" },
/* U+318f */ { 0, 0, 0, 0, 0 },
/* U+3190 */ { 30, 0, 1, 0, 0 },
/* U+3191 */ { 30, 0, 1, 0, 0 },
/* U+3192 */ { 9, 0, 1, 0, "<super> 4E00" },
/* U+3193 */ { 9, 0, 1, 0, "<super> 4E8C" },
/* U+3194 */ { 9, 0, 1, 0, "<super> 4E09" },
/* U+3195 */ { 9, 0, 1, 0, "<super> 56DB" },
/* U+3196 */ { 30, 0, 1, 0, "<super> 4E0A" },
/* U+3197 */ { 30, 0, 1, 0, "<super> 4E2D" },
/* U+3198 */ { 30, 0, 1, 0, "<super> 4E0B" },
/* U+3199 */ { 30, 0, 1, 0, "<super> 7532" },
/* U+319a */ { 30, 0, 1, 0, "<super> 4E59" },
/* U+319b */ { 30, 0, 1, 0, "<super> 4E19" },
/* U+319c */ { 30, 0, 1, 0, "<super> 4E01" },
/* U+319d */ { 30, 0, 1, 0, "<super> 5929" },
/* U+319e */ { 30, 0, 1, 0, "<super> 5730" },
/* U+319f */ { 30, 0, 1, 0, "<super> 4EBA" },
/* U+31a0 */ { 19, 0, 1, 0, 0 },
/* U+31a1 */ { 19, 0, 1, 0, 0 },
/* U+31a2 */ { 19, 0, 1, 0, 0 },
/* U+31a3 */ { 19, 0, 1, 0, 0 },
/* U+31a4 */ { 19, 0, 1, 0, 0 },
/* U+31a5 */ { 19, 0, 1, 0, 0 },
/* U+31a6 */ { 19, 0, 1, 0, 0 },
/* U+31a7 */ { 19, 0, 1, 0, 0 },
/* U+31a8 */ { 19, 0, 1, 0, 0 },
/* U+31a9 */ { 19, 0, 1, 0, 0 },
/* U+31aa */ { 19, 0, 1, 0, 0 },
/* U+31ab */ { 19, 0, 1, 0, 0 },
/* U+31ac */ { 19, 0, 1, 0, 0 },
/* U+31ad */ { 19, 0, 1, 0, 0 },
/* U+31ae */ { 19, 0, 1, 0, 0 },
/* U+31af */ { 19, 0, 1, 0, 0 },
/* U+31b0 */ { 19, 0, 1, 0, 0 },
/* U+31b1 */ { 19, 0, 1, 0, 0 },
/* U+31b2 */ { 19, 0, 1, 0, 0 },
/* U+31b3 */ { 19, 0, 1, 0, 0 },
/* U+31b4 */ { 19, 0, 1, 0, 0 },
/* U+31b5 */ { 19, 0, 1, 0, 0 },
/* U+31b6 */ { 19, 0, 1, 0, 0 },
/* U+31b7 */ { 19, 0, 1, 0, 0 },
/* U+31b8 */ { 0, 0, 0, 0, 0 },
/* U+31b9 */ { 0, 0, 0, 0, 0 },
/* U+31ba */ { 0, 0, 0, 0, 0 },
/* U+31bb */ { 0, 0, 0, 0, 0 },
/* U+31bc */ { 0, 0, 0, 0, 0 },
/* U+31bd */ { 0, 0, 0, 0, 0 },
/* U+31be */ { 0, 0, 0, 0, 0 },
/* U+31bf */ { 0, 0, 0, 0, 0 },
/* U+31c0 */ { 0, 0, 0, 0, 0 },
/* U+31c1 */ { 0, 0, 0, 0, 0 },
/* U+31c2 */ { 0, 0, 0, 0, 0 },
/* U+31c3 */ { 0, 0, 0, 0, 0 },
/* U+31c4 */ { 0, 0, 0, 0, 0 },
/* U+31c5 */ { 0, 0, 0, 0, 0 },
/* U+31c6 */ { 0, 0, 0, 0, 0 },
/* U+31c7 */ { 0, 0, 0, 0, 0 },
/* U+31c8 */ { 0, 0, 0, 0, 0 },
/* U+31c9 */ { 0, 0, 0, 0, 0 },
/* U+31ca */ { 0, 0, 0, 0, 0 },
/* U+31cb */ { 0, 0, 0, 0, 0 },
/* U+31cc */ { 0, 0, 0, 0, 0 },
/* U+31cd */ { 0, 0, 0, 0, 0 },
/* U+31ce */ { 0, 0, 0, 0, 0 },
/* U+31cf */ { 0, 0, 0, 0, 0 },
/* U+31d0 */ { 0, 0, 0, 0, 0 },
/* U+31d1 */ { 0, 0, 0, 0, 0 },
/* U+31d2 */ { 0, 0, 0, 0, 0 },
/* U+31d3 */ { 0, 0, 0, 0, 0 },
/* U+31d4 */ { 0, 0, 0, 0, 0 },
/* U+31d5 */ { 0, 0, 0, 0, 0 },
/* U+31d6 */ { 0, 0, 0, 0, 0 },
/* U+31d7 */ { 0, 0, 0, 0, 0 },
/* U+31d8 */ { 0, 0, 0, 0, 0 },
/* U+31d9 */ { 0, 0, 0, 0, 0 },
/* U+31da */ { 0, 0, 0, 0, 0 },
/* U+31db */ { 0, 0, 0, 0, 0 },
/* U+31dc */ { 0, 0, 0, 0, 0 },
/* U+31dd */ { 0, 0, 0, 0, 0 },
/* U+31de */ { 0, 0, 0, 0, 0 },
/* U+31df */ { 0, 0, 0, 0, 0 },
/* U+31e0 */ { 0, 0, 0, 0, 0 },
/* U+31e1 */ { 0, 0, 0, 0, 0 },
/* U+31e2 */ { 0, 0, 0, 0, 0 },
/* U+31e3 */ { 0, 0, 0, 0, 0 },
/* U+31e4 */ { 0, 0, 0, 0, 0 },
/* U+31e5 */ { 0, 0, 0, 0, 0 },
/* U+31e6 */ { 0, 0, 0, 0, 0 },
/* U+31e7 */ { 0, 0, 0, 0, 0 },
/* U+31e8 */ { 0, 0, 0, 0, 0 },
/* U+31e9 */ { 0, 0, 0, 0, 0 },
/* U+31ea */ { 0, 0, 0, 0, 0 },
/* U+31eb */ { 0, 0, 0, 0, 0 },
/* U+31ec */ { 0, 0, 0, 0, 0 },
/* U+31ed */ { 0, 0, 0, 0, 0 },
/* U+31ee */ { 0, 0, 0, 0, 0 },
/* U+31ef */ { 0, 0, 0, 0, 0 },
/* U+31f0 */ { 0, 0, 0, 0, 0 },
/* U+31f1 */ { 0, 0, 0, 0, 0 },
/* U+31f2 */ { 0, 0, 0, 0, 0 },
/* U+31f3 */ { 0, 0, 0, 0, 0 },
/* U+31f4 */ { 0, 0, 0, 0, 0 },
/* U+31f5 */ { 0, 0, 0, 0, 0 },
/* U+31f6 */ { 0, 0, 0, 0, 0 },
/* U+31f7 */ { 0, 0, 0, 0, 0 },
/* U+31f8 */ { 0, 0, 0, 0, 0 },
/* U+31f9 */ { 0, 0, 0, 0, 0 },
/* U+31fa */ { 0, 0, 0, 0, 0 },
/* U+31fb */ { 0, 0, 0, 0, 0 },
/* U+31fc */ { 0, 0, 0, 0, 0 },
/* U+31fd */ { 0, 0, 0, 0, 0 },
/* U+31fe */ { 0, 0, 0, 0, 0 },
/* U+31ff */ { 0, 0, 0, 0, 0 },
/* U+3200 */ { 30, 0, 1, 0, "<compat> 0028 1100 0029" },
/* U+3201 */ { 30, 0, 1, 0, "<compat> 0028 1102 0029" },
/* U+3202 */ { 30, 0, 1, 0, "<compat> 0028 1103 0029" },
/* U+3203 */ { 30, 0, 1, 0, "<compat> 0028 1105 0029" },
/* U+3204 */ { 30, 0, 1, 0, "<compat> 0028 1106 0029" },
/* U+3205 */ { 30, 0, 1, 0, "<compat> 0028 1107 0029" },
/* U+3206 */ { 30, 0, 1, 0, "<compat> 0028 1109 0029" },
/* U+3207 */ { 30, 0, 1, 0, "<compat> 0028 110B 0029" },
/* U+3208 */ { 30, 0, 1, 0, "<compat> 0028 110C 0029" },
/* U+3209 */ { 30, 0, 1, 0, "<compat> 0028 110E 0029" },
/* U+320a */ { 30, 0, 1, 0, "<compat> 0028 110F 0029" },
/* U+320b */ { 30, 0, 1, 0, "<compat> 0028 1110 0029" },
/* U+320c */ { 30, 0, 1, 0, "<compat> 0028 1111 0029" },
/* U+320d */ { 30, 0, 1, 0, "<compat> 0028 1112 0029" },
/* U+320e */ { 30, 0, 1, 0, "<compat> 0028 1100 1161 0029" },
/* U+320f */ { 30, 0, 1, 0, "<compat> 0028 1102 1161 0029" },
/* U+3210 */ { 30, 0, 1, 0, "<compat> 0028 1103 1161 0029" },
/* U+3211 */ { 30, 0, 1, 0, "<compat> 0028 1105 1161 0029" },
/* U+3212 */ { 30, 0, 1, 0, "<compat> 0028 1106 1161 0029" },
/* U+3213 */ { 30, 0, 1, 0, "<compat> 0028 1107 1161 0029" },
/* U+3214 */ { 30, 0, 1, 0, "<compat> 0028 1109 1161 0029" },
/* U+3215 */ { 30, 0, 1, 0, "<compat> 0028 110B 1161 0029" },
/* U+3216 */ { 30, 0, 1, 0, "<compat> 0028 110C 1161 0029" },
/* U+3217 */ { 30, 0, 1, 0, "<compat> 0028 110E 1161 0029" },
/* U+3218 */ { 30, 0, 1, 0, "<compat> 0028 110F 1161 0029" },
/* U+3219 */ { 30, 0, 1, 0, "<compat> 0028 1110 1161 0029" },
/* U+321a */ { 30, 0, 1, 0, "<compat> 0028 1111 1161 0029" },
/* U+321b */ { 30, 0, 1, 0, "<compat> 0028 1112 1161 0029" },
/* U+321c */ { 30, 0, 1, 0, "<compat> 0028 110C 116E 0029" },
/* U+321d */ { 0, 0, 0, 0, 0 },
/* U+321e */ { 0, 0, 0, 0, 0 },
/* U+321f */ { 0, 0, 0, 0, 0 },
/* U+3220 */ { 9, 0, 1, 0, "<compat> 0028 4E00 0029" },
/* U+3221 */ { 9, 0, 1, 0, "<compat> 0028 4E8C 0029" },
/* U+3222 */ { 9, 0, 1, 0, "<compat> 0028 4E09 0029" },
/* U+3223 */ { 9, 0, 1, 0, "<compat> 0028 56DB 0029" },
/* U+3224 */ { 9, 0, 1, 0, "<compat> 0028 4E94 0029" },
/* U+3225 */ { 9, 0, 1, 0, "<compat> 0028 516D 0029" },
/* U+3226 */ { 9, 0, 1, 0, "<compat> 0028 4E03 0029" },
/* U+3227 */ { 9, 0, 1, 0, "<compat> 0028 516B 0029" },
/* U+3228 */ { 9, 0, 1, 0, "<compat> 0028 4E5D 0029" },
/* U+3229 */ { 9, 0, 1, 0, "<compat> 0028 5341 0029" },
/* U+322a */ { 30, 0, 1, 0, "<compat> 0028 6708 0029" },
/* U+322b */ { 30, 0, 1, 0, "<compat> 0028 706B 0029" },
/* U+322c */ { 30, 0, 1, 0, "<compat> 0028 6C34 0029" },
/* U+322d */ { 30, 0, 1, 0, "<compat> 0028 6728 0029" },
/* U+322e */ { 30, 0, 1, 0, "<compat> 0028 91D1 0029" },
/* U+322f */ { 30, 0, 1, 0, "<compat> 0028 571F 0029" },
/* U+3230 */ { 30, 0, 1, 0, "<compat> 0028 65E5 0029" },
/* U+3231 */ { 30, 0, 1, 0, "<compat> 0028 682A 0029" },
/* U+3232 */ { 30, 0, 1, 0, "<compat> 0028 6709 0029" },
/* U+3233 */ { 30, 0, 1, 0, "<compat> 0028 793E 0029" },
/* U+3234 */ { 30, 0, 1, 0, "<compat> 0028 540D 0029" },
/* U+3235 */ { 30, 0, 1, 0, "<compat> 0028 7279 0029" },
/* U+3236 */ { 30, 0, 1, 0, "<compat> 0028 8CA1 0029" },
/* U+3237 */ { 30, 0, 1, 0, "<compat> 0028 795D 0029" },
/* U+3238 */ { 30, 0, 1, 0, "<compat> 0028 52B4 0029" },
/* U+3239 */ { 30, 0, 1, 0, "<compat> 0028 4EE3 0029" },
/* U+323a */ { 30, 0, 1, 0, "<compat> 0028 547C 0029" },
/* U+323b */ { 30, 0, 1, 0, "<compat> 0028 5B66 0029" },
/* U+323c */ { 30, 0, 1, 0, "<compat> 0028 76E3 0029" },
/* U+323d */ { 30, 0, 1, 0, "<compat> 0028 4F01 0029" },
/* U+323e */ { 30, 0, 1, 0, "<compat> 0028 8CC7 0029" },
/* U+323f */ { 30, 0, 1, 0, "<compat> 0028 5354 0029" },
/* U+3240 */ { 30, 0, 1, 0, "<compat> 0028 796D 0029" },
/* U+3241 */ { 30, 0, 1, 0, "<compat> 0028 4F11 0029" },
/* U+3242 */ { 30, 0, 1, 0, "<compat> 0028 81EA 0029" },
/* U+3243 */ { 30, 0, 1, 0, "<compat> 0028 81F3 0029" },
/* U+3244 */ { 0, 0, 0, 0, 0 },
/* U+3245 */ { 0, 0, 0, 0, 0 },
/* U+3246 */ { 0, 0, 0, 0, 0 },
/* U+3247 */ { 0, 0, 0, 0, 0 },
/* U+3248 */ { 0, 0, 0, 0, 0 },
/* U+3249 */ { 0, 0, 0, 0, 0 },
/* U+324a */ { 0, 0, 0, 0, 0 },
/* U+324b */ { 0, 0, 0, 0, 0 },
/* U+324c */ { 0, 0, 0, 0, 0 },
/* U+324d */ { 0, 0, 0, 0, 0 },
/* U+324e */ { 0, 0, 0, 0, 0 },
/* U+324f */ { 0, 0, 0, 0, 0 },
/* U+3250 */ { 0, 0, 0, 0, 0 },
/* U+3251 */ { 0, 0, 0, 0, 0 },
/* U+3252 */ { 0, 0, 0, 0, 0 },
/* U+3253 */ { 0, 0, 0, 0, 0 },
/* U+3254 */ { 0, 0, 0, 0, 0 },
/* U+3255 */ { 0, 0, 0, 0, 0 },
/* U+3256 */ { 0, 0, 0, 0, 0 },
/* U+3257 */ { 0, 0, 0, 0, 0 },
/* U+3258 */ { 0, 0, 0, 0, 0 },
/* U+3259 */ { 0, 0, 0, 0, 0 },
/* U+325a */ { 0, 0, 0, 0, 0 },
/* U+325b */ { 0, 0, 0, 0, 0 },
/* U+325c */ { 0, 0, 0, 0, 0 },
/* U+325d */ { 0, 0, 0, 0, 0 },
/* U+325e */ { 0, 0, 0, 0, 0 },
/* U+325f */ { 0, 0, 0, 0, 0 },
/* U+3260 */ { 30, 0, 1, 0, "<circle> 1100" },
/* U+3261 */ { 30, 0, 1, 0, "<circle> 1102" },
/* U+3262 */ { 30, 0, 1, 0, "<circle> 1103" },
/* U+3263 */ { 30, 0, 1, 0, "<circle> 1105" },
/* U+3264 */ { 30, 0, 1, 0, "<circle> 1106" },
/* U+3265 */ { 30, 0, 1, 0, "<circle> 1107" },
/* U+3266 */ { 30, 0, 1, 0, "<circle> 1109" },
/* U+3267 */ { 30, 0, 1, 0, "<circle> 110B" },
/* U+3268 */ { 30, 0, 1, 0, "<circle> 110C" },
/* U+3269 */ { 30, 0, 1, 0, "<circle> 110E" },
/* U+326a */ { 30, 0, 1, 0, "<circle> 110F" },
/* U+326b */ { 30, 0, 1, 0, "<circle> 1110" },
/* U+326c */ { 30, 0, 1, 0, "<circle> 1111" },
/* U+326d */ { 30, 0, 1, 0, "<circle> 1112" },
/* U+326e */ { 30, 0, 1, 0, "<circle> 1100 1161" },
/* U+326f */ { 30, 0, 1, 0, "<circle> 1102 1161" },
/* U+3270 */ { 30, 0, 1, 0, "<circle> 1103 1161" },
/* U+3271 */ { 30, 0, 1, 0, "<circle> 1105 1161" },
/* U+3272 */ { 30, 0, 1, 0, "<circle> 1106 1161" },
/* U+3273 */ { 30, 0, 1, 0, "<circle> 1107 1161" },
/* U+3274 */ { 30, 0, 1, 0, "<circle> 1109 1161" },
/* U+3275 */ { 30, 0, 1, 0, "<circle> 110B 1161" },
/* U+3276 */ { 30, 0, 1, 0, "<circle> 110C 1161" },
/* U+3277 */ { 30, 0, 1, 0, "<circle> 110E 1161" },
/* U+3278 */ { 30, 0, 1, 0, "<circle> 110F 1161" },
/* U+3279 */ { 30, 0, 1, 0, "<circle> 1110 1161" },
/* U+327a */ { 30, 0, 1, 0, "<circle> 1111 1161" },
/* U+327b */ { 30, 0, 1, 0, "<circle> 1112 1161" },
/* U+327c */ { 0, 0, 0, 0, 0 },
/* U+327d */ { 0, 0, 0, 0, 0 },
/* U+327e */ { 0, 0, 0, 0, 0 },
/* U+327f */ { 30, 0, 1, 0, 0 },
/* U+3280 */ { 9, 0, 1, 0, "<circle> 4E00" },
/* U+3281 */ { 9, 0, 1, 0, "<circle> 4E8C" },
/* U+3282 */ { 9, 0, 1, 0, "<circle> 4E09" },
/* U+3283 */ { 9, 0, 1, 0, "<circle> 56DB" },
/* U+3284 */ { 9, 0, 1, 0, "<circle> 4E94" },
/* U+3285 */ { 9, 0, 1, 0, "<circle> 516D" },
/* U+3286 */ { 9, 0, 1, 0, "<circle> 4E03" },
/* U+3287 */ { 9, 0, 1, 0, "<circle> 516B" },
/* U+3288 */ { 9, 0, 1, 0, "<circle> 4E5D" },
/* U+3289 */ { 9, 0, 1, 0, "<circle> 5341" },
/* U+328a */ { 30, 0, 1, 0, "<circle> 6708" },
/* U+328b */ { 30, 0, 1, 0, "<circle> 706B" },
/* U+328c */ { 30, 0, 1, 0, "<circle> 6C34" },
/* U+328d */ { 30, 0, 1, 0, "<circle> 6728" },
/* U+328e */ { 30, 0, 1, 0, "<circle> 91D1" },
/* U+328f */ { 30, 0, 1, 0, "<circle> 571F" },
/* U+3290 */ { 30, 0, 1, 0, "<circle> 65E5" },
/* U+3291 */ { 30, 0, 1, 0, "<circle> 682A" },
/* U+3292 */ { 30, 0, 1, 0, "<circle> 6709" },
/* U+3293 */ { 30, 0, 1, 0, "<circle> 793E" },
/* U+3294 */ { 30, 0, 1, 0, "<circle> 540D" },
/* U+3295 */ { 30, 0, 1, 0, "<circle> 7279" },
/* U+3296 */ { 30, 0, 1, 0, "<circle> 8CA1" },
/* U+3297 */ { 30, 0, 1, 0, "<circle> 795D" },
/* U+3298 */ { 30, 0, 1, 0, "<circle> 52B4" },
/* U+3299 */ { 30, 0, 1, 0, "<circle> 79D8" },
/* U+329a */ { 30, 0, 1, 0, "<circle> 7537" },
/* U+329b */ { 30, 0, 1, 0, "<circle> 5973" },
/* U+329c */ { 30, 0, 1, 0, "<circle> 9069" },
/* U+329d */ { 30, 0, 1, 0, "<circle> 512A" },
/* U+329e */ { 30, 0, 1, 0, "<circle> 5370" },
/* U+329f */ { 30, 0, 1, 0, "<circle> 6CE8" },
/* U+32a0 */ { 30, 0, 1, 0, "<circle> 9805" },
/* U+32a1 */ { 30, 0, 1, 0, "<circle> 4F11" },
/* U+32a2 */ { 30, 0, 1, 0, "<circle> 5199" },
/* U+32a3 */ { 30, 0, 1, 0, "<circle> 6B63" },
/* U+32a4 */ { 30, 0, 1, 0, "<circle> 4E0A" },
/* U+32a5 */ { 30, 0, 1, 0, "<circle> 4E2D" },
/* U+32a6 */ { 30, 0, 1, 0, "<circle> 4E0B" },
/* U+32a7 */ { 30, 0, 1, 0, "<circle> 5DE6" },
/* U+32a8 */ { 30, 0, 1, 0, "<circle> 53F3" },
/* U+32a9 */ { 30, 0, 1, 0, "<circle> 533B" },
/* U+32aa */ { 30, 0, 1, 0, "<circle> 5B97" },
/* U+32ab */ { 30, 0, 1, 0, "<circle> 5B66" },
/* U+32ac */ { 30, 0, 1, 0, "<circle> 76E3" },
/* U+32ad */ { 30, 0, 1, 0, "<circle> 4F01" },
/* U+32ae */ { 30, 0, 1, 0, "<circle> 8CC7" },
/* U+32af */ { 30, 0, 1, 0, "<circle> 5354" },
/* U+32b0 */ { 30, 0, 1, 0, "<circle> 591C" },
/* U+32b1 */ { 0, 0, 0, 0, 0 },
/* U+32b2 */ { 0, 0, 0, 0, 0 },
/* U+32b3 */ { 0, 0, 0, 0, 0 },
/* U+32b4 */ { 0, 0, 0, 0, 0 },
/* U+32b5 */ { 0, 0, 0, 0, 0 },
/* U+32b6 */ { 0, 0, 0, 0, 0 },
/* U+32b7 */ { 0, 0, 0, 0, 0 },
/* U+32b8 */ { 0, 0, 0, 0, 0 },
/* U+32b9 */ { 0, 0, 0, 0, 0 },
/* U+32ba */ { 0, 0, 0, 0, 0 },
/* U+32bb */ { 0, 0, 0, 0, 0 },
/* U+32bc */ { 0, 0, 0, 0, 0 },
/* U+32bd */ { 0, 0, 0, 0, 0 },
/* U+32be */ { 0, 0, 0, 0, 0 },
/* U+32bf */ { 0, 0, 0, 0, 0 },
/* U+32c0 */ { 30, 0, 1, 0, "<compat> 0031 6708" },
/* U+32c1 */ { 30, 0, 1, 0, "<compat> 0032 6708" },
/* U+32c2 */ { 30, 0, 1, 0, "<compat> 0033 6708" },
/* U+32c3 */ { 30, 0, 1, 0, "<compat> 0034 6708" },
/* U+32c4 */ { 30, 0, 1, 0, "<compat> 0035 6708" },
/* U+32c5 */ { 30, 0, 1, 0, "<compat> 0036 6708" },
/* U+32c6 */ { 30, 0, 1, 0, "<compat> 0037 6708" },
/* U+32c7 */ { 30, 0, 1, 0, "<compat> 0038 6708" },
/* U+32c8 */ { 30, 0, 1, 0, "<compat> 0039 6708" },
/* U+32c9 */ { 30, 0, 1, 0, "<compat> 0031 0030 6708" },
/* U+32ca */ { 30, 0, 1, 0, "<compat> 0031 0031 6708" },
/* U+32cb */ { 30, 0, 1, 0, "<compat> 0031 0032 6708" },
/* U+32cc */ { 0, 0, 0, 0, 0 },
/* U+32cd */ { 0, 0, 0, 0, 0 },
/* U+32ce */ { 0, 0, 0, 0, 0 },
/* U+32cf */ { 0, 0, 0, 0, 0 },
/* U+32d0 */ { 30, 0, 1, 0, "<circle> 30A2" },
/* U+32d1 */ { 30, 0, 1, 0, "<circle> 30A4" },
/* U+32d2 */ { 30, 0, 1, 0, "<circle> 30A6" },
/* U+32d3 */ { 30, 0, 1, 0, "<circle> 30A8" },
/* U+32d4 */ { 30, 0, 1, 0, "<circle> 30AA" },
/* U+32d5 */ { 30, 0, 1, 0, "<circle> 30AB" },
/* U+32d6 */ { 30, 0, 1, 0, "<circle> 30AD" },
/* U+32d7 */ { 30, 0, 1, 0, "<circle> 30AF" },
/* U+32d8 */ { 30, 0, 1, 0, "<circle> 30B1" },
/* U+32d9 */ { 30, 0, 1, 0, "<circle> 30B3" },
/* U+32da */ { 30, 0, 1, 0, "<circle> 30B5" },
/* U+32db */ { 30, 0, 1, 0, "<circle> 30B7" },
/* U+32dc */ { 30, 0, 1, 0, "<circle> 30B9" },
/* U+32dd */ { 30, 0, 1, 0, "<circle> 30BB" },
/* U+32de */ { 30, 0, 1, 0, "<circle> 30BD" },
/* U+32df */ { 30, 0, 1, 0, "<circle> 30BF" },
/* U+32e0 */ { 30, 0, 1, 0, "<circle> 30C1" },
/* U+32e1 */ { 30, 0, 1, 0, "<circle> 30C4" },
/* U+32e2 */ { 30, 0, 1, 0, "<circle> 30C6" },
/* U+32e3 */ { 30, 0, 1, 0, "<circle> 30C8" },
/* U+32e4 */ { 30, 0, 1, 0, "<circle> 30CA" },
/* U+32e5 */ { 30, 0, 1, 0, "<circle> 30CB" },
/* U+32e6 */ { 30, 0, 1, 0, "<circle> 30CC" },
/* U+32e7 */ { 30, 0, 1, 0, "<circle> 30CD" },
/* U+32e8 */ { 30, 0, 1, 0, "<circle> 30CE" },
/* U+32e9 */ { 30, 0, 1, 0, "<circle> 30CF" },
/* U+32ea */ { 30, 0, 1, 0, "<circle> 30D2" },
/* U+32eb */ { 30, 0, 1, 0, "<circle> 30D5" },
/* U+32ec */ { 30, 0, 1, 0, "<circle> 30D8" },
/* U+32ed */ { 30, 0, 1, 0, "<circle> 30DB" },
/* U+32ee */ { 30, 0, 1, 0, "<circle> 30DE" },
/* U+32ef */ { 30, 0, 1, 0, "<circle> 30DF" },
/* U+32f0 */ { 30, 0, 1, 0, "<circle> 30E0" },
/* U+32f1 */ { 30, 0, 1, 0, "<circle> 30E1" },
/* U+32f2 */ { 30, 0, 1, 0, "<circle> 30E2" },
/* U+32f3 */ { 30, 0, 1, 0, "<circle> 30E4" },
/* U+32f4 */ { 30, 0, 1, 0, "<circle> 30E6" },
/* U+32f5 */ { 30, 0, 1, 0, "<circle> 30E8" },
/* U+32f6 */ { 30, 0, 1, 0, "<circle> 30E9" },
/* U+32f7 */ { 30, 0, 1, 0, "<circle> 30EA" },
/* U+32f8 */ { 30, 0, 1, 0, "<circle> 30EB" },
/* U+32f9 */ { 30, 0, 1, 0, "<circle> 30EC" },
/* U+32fa */ { 30, 0, 1, 0, "<circle> 30ED" },
/* U+32fb */ { 30, 0, 1, 0, "<circle> 30EF" },
/* U+32fc */ { 30, 0, 1, 0, "<circle> 30F0" },
/* U+32fd */ { 30, 0, 1, 0, "<circle> 30F1" },
/* U+32fe */ { 30, 0, 1, 0, "<circle> 30F2" },
/* U+32ff */ { 0, 0, 0, 0, 0 },
/* U+3300 */ { 30, 0, 1, 0, "<square> 30A2 30D1 30FC 30C8" },
/* U+3301 */ { 30, 0, 1, 0, "<square> 30A2 30EB 30D5 30A1" },
/* U+3302 */ { 30, 0, 1, 0, "<square> 30A2 30F3 30DA 30A2" },
/* U+3303 */ { 30, 0, 1, 0, "<square> 30A2 30FC 30EB" },
/* U+3304 */ { 30, 0, 1, 0, "<square> 30A4 30CB 30F3 30B0" },
/* U+3305 */ { 30, 0, 1, 0, "<square> 30A4 30F3 30C1" },
/* U+3306 */ { 30, 0, 1, 0, "<square> 30A6 30A9 30F3" },
/* U+3307 */ { 30, 0, 1, 0, "<square> 30A8 30B9 30AF 30FC 30C9" },
/* U+3308 */ { 30, 0, 1, 0, "<square> 30A8 30FC 30AB 30FC" },
/* U+3309 */ { 30, 0, 1, 0, "<square> 30AA 30F3 30B9" },
/* U+330a */ { 30, 0, 1, 0, "<square> 30AA 30FC 30E0" },
/* U+330b */ { 30, 0, 1, 0, "<square> 30AB 30A4 30EA" },
/* U+330c */ { 30, 0, 1, 0, "<square> 30AB 30E9 30C3 30C8" },
/* U+330d */ { 30, 0, 1, 0, "<square> 30AB 30ED 30EA 30FC" },
/* U+330e */ { 30, 0, 1, 0, "<square> 30AC 30ED 30F3" },
/* U+330f */ { 30, 0, 1, 0, "<square> 30AC 30F3 30DE" },
/* U+3310 */ { 30, 0, 1, 0, "<square> 30AE 30AC" },
/* U+3311 */ { 30, 0, 1, 0, "<square> 30AE 30CB 30FC" },
/* U+3312 */ { 30, 0, 1, 0, "<square> 30AD 30E5 30EA 30FC" },
/* U+3313 */ { 30, 0, 1, 0, "<square> 30AE 30EB 30C0 30FC" },
/* U+3314 */ { 30, 0, 1, 0, "<square> 30AD 30ED" },
/* U+3315 */ { 30, 0, 1, 0, "<square> 30AD 30ED 30B0 30E9 30E0" },
/* U+3316 */ { 30, 0, 1, 0, "<square> 30AD 30ED 30E1 30FC 30C8 30EB" },
/* U+3317 */ { 30, 0, 1, 0, "<square> 30AD 30ED 30EF 30C3 30C8" },
/* U+3318 */ { 30, 0, 1, 0, "<square> 30B0 30E9 30E0" },
/* U+3319 */ { 30, 0, 1, 0, "<square> 30B0 30E9 30E0 30C8 30F3" },
/* U+331a */ { 30, 0, 1, 0, "<square> 30AF 30EB 30BC 30A4 30ED" },
/* U+331b */ { 30, 0, 1, 0, "<square> 30AF 30ED 30FC 30CD" },
/* U+331c */ { 30, 0, 1, 0, "<square> 30B1 30FC 30B9" },
/* U+331d */ { 30, 0, 1, 0, "<square> 30B3 30EB 30CA" },
/* U+331e */ { 30, 0, 1, 0, "<square> 30B3 30FC 30DD" },
/* U+331f */ { 30, 0, 1, 0, "<square> 30B5 30A4 30AF 30EB" },
/* U+3320 */ { 30, 0, 1, 0, "<square> 30B5 30F3 30C1 30FC 30E0" },
/* U+3321 */ { 30, 0, 1, 0, "<square> 30B7 30EA 30F3 30B0" },
/* U+3322 */ { 30, 0, 1, 0, "<square> 30BB 30F3 30C1" },
/* U+3323 */ { 30, 0, 1, 0, "<square> 30BB 30F3 30C8" },
/* U+3324 */ { 30, 0, 1, 0, "<square> 30C0 30FC 30B9" },
/* U+3325 */ { 30, 0, 1, 0, "<square> 30C7 30B7" },
/* U+3326 */ { 30, 0, 1, 0, "<square> 30C9 30EB" },
/* U+3327 */ { 30, 0, 1, 0, "<square> 30C8 30F3" },
/* U+3328 */ { 30, 0, 1, 0, "<square> 30CA 30CE" },
/* U+3329 */ { 30, 0, 1, 0, "<square> 30CE 30C3 30C8" },
/* U+332a */ { 30, 0, 1, 0, "<square> 30CF 30A4 30C4" },
/* U+332b */ { 30, 0, 1, 0, "<square> 30D1 30FC 30BB 30F3 30C8" },
/* U+332c */ { 30, 0, 1, 0, "<square> 30D1 30FC 30C4" },
/* U+332d */ { 30, 0, 1, 0, "<square> 30D0 30FC 30EC 30EB" },
/* U+332e */ { 30, 0, 1, 0, "<square> 30D4 30A2 30B9 30C8 30EB" },
/* U+332f */ { 30, 0, 1, 0, "<square> 30D4 30AF 30EB" },
/* U+3330 */ { 30, 0, 1, 0, "<square> 30D4 30B3" },
/* U+3331 */ { 30, 0, 1, 0, "<square> 30D3 30EB" },
/* U+3332 */ { 30, 0, 1, 0, "<square> 30D5 30A1 30E9 30C3 30C9" },
/* U+3333 */ { 30, 0, 1, 0, "<square> 30D5 30A3 30FC 30C8" },
/* U+3334 */ { 30, 0, 1, 0, "<square> 30D6 30C3 30B7 30A7 30EB" },
/* U+3335 */ { 30, 0, 1, 0, "<square> 30D5 30E9 30F3" },
/* U+3336 */ { 30, 0, 1, 0, "<square> 30D8 30AF 30BF 30FC 30EB" },
/* U+3337 */ { 30, 0, 1, 0, "<square> 30DA 30BD" },
/* U+3338 */ { 30, 0, 1, 0, "<square> 30DA 30CB 30D2" },
/* U+3339 */ { 30, 0, 1, 0, "<square> 30D8 30EB 30C4" },
/* U+333a */ { 30, 0, 1, 0, "<square> 30DA 30F3 30B9" },
/* U+333b */ { 30, 0, 1, 0, "<square> 30DA 30FC 30B8" },
/* U+333c */ { 30, 0, 1, 0, "<square> 30D9 30FC 30BF" },
/* U+333d */ { 30, 0, 1, 0, "<square> 30DD 30A4 30F3 30C8" },
/* U+333e */ { 30, 0, 1, 0, "<square> 30DC 30EB 30C8" },
/* U+333f */ { 30, 0, 1, 0, "<square> 30DB 30F3" },
/* U+3340 */ { 30, 0, 1, 0, "<square> 30DD 30F3 30C9" },
/* U+3341 */ { 30, 0, 1, 0, "<square> 30DB 30FC 30EB" },
/* U+3342 */ { 30, 0, 1, 0, "<square> 30DB 30FC 30F3" },
/* U+3343 */ { 30, 0, 1, 0, "<square> 30DE 30A4 30AF 30ED" },
/* U+3344 */ { 30, 0, 1, 0, "<square> 30DE 30A4 30EB" },
/* U+3345 */ { 30, 0, 1, 0, "<square> 30DE 30C3 30CF" },
/* U+3346 */ { 30, 0, 1, 0, "<square> 30DE 30EB 30AF" },
/* U+3347 */ { 30, 0, 1, 0, "<square> 30DE 30F3 30B7 30E7 30F3" },
/* U+3348 */ { 30, 0, 1, 0, "<square> 30DF 30AF 30ED 30F3" },
/* U+3349 */ { 30, 0, 1, 0, "<square> 30DF 30EA" },
/* U+334a */ { 30, 0, 1, 0, "<square> 30DF 30EA 30D0 30FC 30EB" },
/* U+334b */ { 30, 0, 1, 0, "<square> 30E1 30AC" },
/* U+334c */ { 30, 0, 1, 0, "<square> 30E1 30AC 30C8 30F3" },
/* U+334d */ { 30, 0, 1, 0, "<square> 30E1 30FC 30C8 30EB" },
/* U+334e */ { 30, 0, 1, 0, "<square> 30E4 30FC 30C9" },
/* U+334f */ { 30, 0, 1, 0, "<square> 30E4 30FC 30EB" },
/* U+3350 */ { 30, 0, 1, 0, "<square> 30E6 30A2 30F3" },
/* U+3351 */ { 30, 0, 1, 0, "<square> 30EA 30C3 30C8 30EB" },
/* U+3352 */ { 30, 0, 1, 0, "<square> 30EA 30E9" },
/* U+3353 */ { 30, 0, 1, 0, "<square> 30EB 30D4 30FC" },
/* U+3354 */ { 30, 0, 1, 0, "<square> 30EB 30FC 30D6 30EB" },
/* U+3355 */ { 30, 0, 1, 0, "<square> 30EC 30E0" },
/* U+3356 */ { 30, 0, 1, 0, "<square> 30EC 30F3 30C8 30B2 30F3" },
/* U+3357 */ { 30, 0, 1, 0, "<square> 30EF 30C3 30C8" },
/* U+3358 */ { 30, 0, 1, 0, "<compat> 0030 70B9" },
/* U+3359 */ { 30, 0, 1, 0, "<compat> 0031 70B9" },
/* U+335a */ { 30, 0, 1, 0, "<compat> 0032 70B9" },
/* U+335b */ { 30, 0, 1, 0, "<compat> 0033 70B9" },
/* U+335c */ { 30, 0, 1, 0, "<compat> 0034 70B9" },
/* U+335d */ { 30, 0, 1, 0, "<compat> 0035 70B9" },
/* U+335e */ { 30, 0, 1, 0, "<compat> 0036 70B9" },
/* U+335f */ { 30, 0, 1, 0, "<compat> 0037 70B9" },
/* U+3360 */ { 30, 0, 1, 0, "<compat> 0038 70B9" },
/* U+3361 */ { 30, 0, 1, 0, "<compat> 0039 70B9" },
/* U+3362 */ { 30, 0, 1, 0, "<compat> 0031 0030 70B9" },
/* U+3363 */ { 30, 0, 1, 0, "<compat> 0031 0031 70B9" },
/* U+3364 */ { 30, 0, 1, 0, "<compat> 0031 0032 70B9" },
/* U+3365 */ { 30, 0, 1, 0, "<compat> 0031 0033 70B9" },
/* U+3366 */ { 30, 0, 1, 0, "<compat> 0031 0034 70B9" },
/* U+3367 */ { 30, 0, 1, 0, "<compat> 0031 0035 70B9" },
/* U+3368 */ { 30, 0, 1, 0, "<compat> 0031 0036 70B9" },
/* U+3369 */ { 30, 0, 1, 0, "<compat> 0031 0037 70B9" },
/* U+336a */ { 30, 0, 1, 0, "<compat> 0031 0038 70B9" },
/* U+336b */ { 30, 0, 1, 0, "<compat> 0031 0039 70B9" },
/* U+336c */ { 30, 0, 1, 0, "<compat> 0032 0030 70B9" },
/* U+336d */ { 30, 0, 1, 0, "<compat> 0032 0031 70B9" },
/* U+336e */ { 30, 0, 1, 0, "<compat> 0032 0032 70B9" },
/* U+336f */ { 30, 0, 1, 0, "<compat> 0032 0033 70B9" },
/* U+3370 */ { 30, 0, 1, 0, "<compat> 0032 0034 70B9" },
/* U+3371 */ { 30, 0, 1, 0, "<square> 0068 0050 0061" },
/* U+3372 */ { 30, 0, 1, 0, "<square> 0064 0061" },
/* U+3373 */ { 30, 0, 1, 0, "<square> 0041 0055" },
/* U+3374 */ { 30, 0, 1, 0, "<square> 0062 0061 0072" },
/* U+3375 */ { 30, 0, 1, 0, "<square> 006F 0056" },
/* U+3376 */ { 30, 0, 1, 0, "<square> 0070 0063" },
/* U+3377 */ { 0, 0, 0, 0, 0 },
/* U+3378 */ { 0, 0, 0, 0, 0 },
/* U+3379 */ { 0, 0, 0, 0, 0 },
/* U+337a */ { 0, 0, 0, 0, 0 },
/* U+337b */ { 30, 0, 1, 0, "<square> 5E73 6210" },
/* U+337c */ { 30, 0, 1, 0, "<square> 662D 548C" },
/* U+337d */ { 30, 0, 1, 0, "<square> 5927 6B63" },
/* U+337e */ { 30, 0, 1, 0, "<square> 660E 6CBB" },
/* U+337f */ { 30, 0, 1, 0, "<square> 682A 5F0F 4F1A 793E" },
/* U+3380 */ { 30, 0, 1, 0, "<square> 0070 0041" },
/* U+3381 */ { 30, 0, 1, 0, "<square> 006E 0041" },
/* U+3382 */ { 30, 0, 1, 0, "<square> 03BC 0041" },
/* U+3383 */ { 30, 0, 1, 0, "<square> 006D 0041" },
/* U+3384 */ { 30, 0, 1, 0, "<square> 006B 0041" },
/* U+3385 */ { 30, 0, 1, 0, "<square> 004B 0042" },
/* U+3386 */ { 30, 0, 1, 0, "<square> 004D 0042" },
/* U+3387 */ { 30, 0, 1, 0, "<square> 0047 0042" },
/* U+3388 */ { 30, 0, 1, 0, "<square> 0063 0061 006C" },
/* U+3389 */ { 30, 0, 1, 0, "<square> 006B 0063 0061 006C" },
/* U+338a */ { 30, 0, 1, 0, "<square> 0070 0046" },
/* U+338b */ { 30, 0, 1, 0, "<square> 006E 0046" },
/* U+338c */ { 30, 0, 1, 0, "<square> 03BC 0046" },
/* U+338d */ { 30, 0, 1, 0, "<square> 03BC 0067" },
/* U+338e */ { 30, 0, 1, 0, "<square> 006D 0067" },
/* U+338f */ { 30, 0, 1, 0, "<square> 006B 0067" },
/* U+3390 */ { 30, 0, 1, 0, "<square> 0048 007A" },
/* U+3391 */ { 30, 0, 1, 0, "<square> 006B 0048 007A" },
/* U+3392 */ { 30, 0, 1, 0, "<square> 004D 0048 007A" },
/* U+3393 */ { 30, 0, 1, 0, "<square> 0047 0048 007A" },
/* U+3394 */ { 30, 0, 1, 0, "<square> 0054 0048 007A" },
/* U+3395 */ { 30, 0, 1, 0, "<square> 03BC 2113" },
/* U+3396 */ { 30, 0, 1, 0, "<square> 006D 2113" },
/* U+3397 */ { 30, 0, 1, 0, "<square> 0064 2113" },
/* U+3398 */ { 30, 0, 1, 0, "<square> 006B 2113" },
/* U+3399 */ { 30, 0, 1, 0, "<square> 0066 006D" },
/* U+339a */ { 30, 0, 1, 0, "<square> 006E 006D" },
/* U+339b */ { 30, 0, 1, 0, "<square> 03BC 006D" },
/* U+339c */ { 30, 0, 1, 0, "<square> 006D 006D" },
/* U+339d */ { 30, 0, 1, 0, "<square> 0063 006D" },
/* U+339e */ { 30, 0, 1, 0, "<square> 006B 006D" },
/* U+339f */ { 30, 0, 1, 0, "<square> 006D 006D 00B2" },
/* U+33a0 */ { 30, 0, 1, 0, "<square> 0063 006D 00B2" },
/* U+33a1 */ { 30, 0, 1, 0, "<square> 006D 00B2" },
/* U+33a2 */ { 30, 0, 1, 0, "<square> 006B 006D 00B2" },
/* U+33a3 */ { 30, 0, 1, 0, "<square> 006D 006D 00B3" },
/* U+33a4 */ { 30, 0, 1, 0, "<square> 0063 006D 00B3" },
/* U+33a5 */ { 30, 0, 1, 0, "<square> 006D 00B3" },
/* U+33a6 */ { 30, 0, 1, 0, "<square> 006B 006D 00B3" },
/* U+33a7 */ { 30, 0, 1, 0, "<square> 006D 2215 0073" },
/* U+33a8 */ { 30, 0, 1, 0, "<square> 006D 2215 0073 00B2" },
/* U+33a9 */ { 30, 0, 1, 0, "<square> 0050 0061" },
/* U+33aa */ { 30, 0, 1, 0, "<square> 006B 0050 0061" },
/* U+33ab */ { 30, 0, 1, 0, "<square> 004D 0050 0061" },
/* U+33ac */ { 30, 0, 1, 0, "<square> 0047 0050 0061" },
/* U+33ad */ { 30, 0, 1, 0, "<square> 0072 0061 0064" },
/* U+33ae */ { 30, 0, 1, 0, "<square> 0072 0061 0064 2215 0073" },
/* U+33af */ { 30, 0, 1, 0, "<square> 0072 0061 0064 2215 0073 00B2" },
/* U+33b0 */ { 30, 0, 1, 0, "<square> 0070 0073" },
/* U+33b1 */ { 30, 0, 1, 0, "<square> 006E 0073" },
/* U+33b2 */ { 30, 0, 1, 0, "<square> 03BC 0073" },
/* U+33b3 */ { 30, 0, 1, 0, "<square> 006D 0073" },
/* U+33b4 */ { 30, 0, 1, 0, "<square> 0070 0056" },
/* U+33b5 */ { 30, 0, 1, 0, "<square> 006E 0056" },
/* U+33b6 */ { 30, 0, 1, 0, "<square> 03BC 0056" },
/* U+33b7 */ { 30, 0, 1, 0, "<square> 006D 0056" },
/* U+33b8 */ { 30, 0, 1, 0, "<square> 006B 0056" },
/* U+33b9 */ { 30, 0, 1, 0, "<square> 004D 0056" },
/* U+33ba */ { 30, 0, 1, 0, "<square> 0070 0057" },
/* U+33bb */ { 30, 0, 1, 0, "<square> 006E 0057" },
/* U+33bc */ { 30, 0, 1, 0, "<square> 03BC 0057" },
/* U+33bd */ { 30, 0, 1, 0, "<square> 006D 0057" },
/* U+33be */ { 30, 0, 1, 0, "<square> 006B 0057" },
/* U+33bf */ { 30, 0, 1, 0, "<square> 004D 0057" },
/* U+33c0 */ { 30, 0, 1, 0, "<square> 006B 03A9" },
/* U+33c1 */ { 30, 0, 1, 0, "<square> 004D 03A9" },
/* U+33c2 */ { 30, 0, 1, 0, "<square> 0061 002E 006D 002E" },
/* U+33c3 */ { 30, 0, 1, 0, "<square> 0042 0071" },
/* U+33c4 */ { 30, 0, 1, 0, "<square> 0063 0063" },
/* U+33c5 */ { 30, 0, 1, 0, "<square> 0063 0064" },
/* U+33c6 */ { 30, 0, 1, 0, "<square> 0043 2215 006B 0067" },
/* U+33c7 */ { 30, 0, 1, 0, "<square> 0043 006F 002E" },
/* U+33c8 */ { 30, 0, 1, 0, "<square> 0064 0042" },
/* U+33c9 */ { 30, 0, 1, 0, "<square> 0047 0079" },
/* U+33ca */ { 30, 0, 1, 0, "<square> 0068 0061" },
/* U+33cb */ { 30, 0, 1, 0, "<square> 0048 0050" },
/* U+33cc */ { 30, 0, 1, 0, "<square> 0069 006E" },
/* U+33cd */ { 30, 0, 1, 0, "<square> 004B 004B" },
/* U+33ce */ { 30, 0, 1, 0, "<square> 004B 004D" },
/* U+33cf */ { 30, 0, 1, 0, "<square> 006B 0074" },
/* U+33d0 */ { 30, 0, 1, 0, "<square> 006C 006D" },
/* U+33d1 */ { 30, 0, 1, 0, "<square> 006C 006E" },
/* U+33d2 */ { 30, 0, 1, 0, "<square> 006C 006F 0067" },
/* U+33d3 */ { 30, 0, 1, 0, "<square> 006C 0078" },
/* U+33d4 */ { 30, 0, 1, 0, "<square> 006D 0062" },
/* U+33d5 */ { 30, 0, 1, 0, "<square> 006D 0069 006C" },
/* U+33d6 */ { 30, 0, 1, 0, "<square> 006D 006F 006C" },
/* U+33d7 */ { 30, 0, 1, 0, "<square> 0050 0048" },
/* U+33d8 */ { 30, 0, 1, 0, "<square> 0070 002E 006D 002E" },
/* U+33d9 */ { 30, 0, 1, 0, "<square> 0050 0050 004D" },
/* U+33da */ { 30, 0, 1, 0, "<square> 0050 0052" },
/* U+33db */ { 30, 0, 1, 0, "<square> 0073 0072" },
/* U+33dc */ { 30, 0, 1, 0, "<square> 0053 0076" },
/* U+33dd */ { 30, 0, 1, 0, "<square> 0057 0062" },
/* U+33de */ { 0, 0, 0, 0, 0 },
/* U+33df */ { 0, 0, 0, 0, 0 },
/* U+33e0 */ { 30, 0, 1, 0, "<compat> 0031 65E5" },
/* U+33e1 */ { 30, 0, 1, 0, "<compat> 0032 65E5" },
/* U+33e2 */ { 30, 0, 1, 0, "<compat> 0033 65E5" },
/* U+33e3 */ { 30, 0, 1, 0, "<compat> 0034 65E5" },
/* U+33e4 */ { 30, 0, 1, 0, "<compat> 0035 65E5" },
/* U+33e5 */ { 30, 0, 1, 0, "<compat> 0036 65E5" },
/* U+33e6 */ { 30, 0, 1, 0, "<compat> 0037 65E5" },
/* U+33e7 */ { 30, 0, 1, 0, "<compat> 0038 65E5" },
/* U+33e8 */ { 30, 0, 1, 0, "<compat> 0039 65E5" },
/* U+33e9 */ { 30, 0, 1, 0, "<compat> 0031 0030 65E5" },
/* U+33ea */ { 30, 0, 1, 0, "<compat> 0031 0031 65E5" },
/* U+33eb */ { 30, 0, 1, 0, "<compat> 0031 0032 65E5" },
/* U+33ec */ { 30, 0, 1, 0, "<compat> 0031 0033 65E5" },
/* U+33ed */ { 30, 0, 1, 0, "<compat> 0031 0034 65E5" },
/* U+33ee */ { 30, 0, 1, 0, "<compat> 0031 0035 65E5" },
/* U+33ef */ { 30, 0, 1, 0, "<compat> 0031 0036 65E5" },
/* U+33f0 */ { 30, 0, 1, 0, "<compat> 0031 0037 65E5" },
/* U+33f1 */ { 30, 0, 1, 0, "<compat> 0031 0038 65E5" },
/* U+33f2 */ { 30, 0, 1, 0, "<compat> 0031 0039 65E5" },
/* U+33f3 */ { 30, 0, 1, 0, "<compat> 0032 0030 65E5" },
/* U+33f4 */ { 30, 0, 1, 0, "<compat> 0032 0031 65E5" },
/* U+33f5 */ { 30, 0, 1, 0, "<compat> 0032 0032 65E5" },
/* U+33f6 */ { 30, 0, 1, 0, "<compat> 0032 0033 65E5" },
/* U+33f7 */ { 30, 0, 1, 0, "<compat> 0032 0034 65E5" },
/* U+33f8 */ { 30, 0, 1, 0, "<compat> 0032 0035 65E5" },
/* U+33f9 */ { 30, 0, 1, 0, "<compat> 0032 0036 65E5" },
/* U+33fa */ { 30, 0, 1, 0, "<compat> 0032 0037 65E5" },
/* U+33fb */ { 30, 0, 1, 0, "<compat> 0032 0038 65E5" },
/* U+33fc */ { 30, 0, 1, 0, "<compat> 0032 0039 65E5" },
/* U+33fd */ { 30, 0, 1, 0, "<compat> 0033 0030 65E5" },
/* U+33fe */ { 30, 0, 1, 0, "<compat> 0033 0031 65E5" },
/* U+33ff */ { 0, 0, 0, 0, 0 },
/* U+3400 */ { 19, 0, 1, 0, 0 },
/* U+3401 */ { 0, 0, 0, 0, 0 },
/* U+3402 */ { 0, 0, 0, 0, 0 },
/* U+3403 */ { 0, 0, 0, 0, 0 },
/* U+3404 */ { 0, 0, 0, 0, 0 },
/* U+3405 */ { 0, 0, 0, 0, 0 },
/* U+3406 */ { 0, 0, 0, 0, 0 },
/* U+3407 */ { 0, 0, 0, 0, 0 },
/* U+3408 */ { 0, 0, 0, 0, 0 },
/* U+3409 */ { 0, 0, 0, 0, 0 },
/* U+340a */ { 0, 0, 0, 0, 0 },
/* U+340b */ { 0, 0, 0, 0, 0 },
/* U+340c */ { 0, 0, 0, 0, 0 },
/* U+340d */ { 0, 0, 0, 0, 0 },
/* U+340e */ { 0, 0, 0, 0, 0 },
/* U+340f */ { 0, 0, 0, 0, 0 },
/* U+3410 */ { 0, 0, 0, 0, 0 },
/* U+3411 */ { 0, 0, 0, 0, 0 },
/* U+3412 */ { 0, 0, 0, 0, 0 },
/* U+3413 */ { 0, 0, 0, 0, 0 },
/* U+3414 */ { 0, 0, 0, 0, 0 },
/* U+3415 */ { 0, 0, 0, 0, 0 },
/* U+3416 */ { 0, 0, 0, 0, 0 },
/* U+3417 */ { 0, 0, 0, 0, 0 },
/* U+3418 */ { 0, 0, 0, 0, 0 },
/* U+3419 */ { 0, 0, 0, 0, 0 },
/* U+341a */ { 0, 0, 0, 0, 0 },
/* U+341b */ { 0, 0, 0, 0, 0 },
/* U+341c */ { 0, 0, 0, 0, 0 },
/* U+341d */ { 0, 0, 0, 0, 0 },
/* U+341e */ { 0, 0, 0, 0, 0 },
/* U+341f */ { 0, 0, 0, 0, 0 },
/* U+3420 */ { 0, 0, 0, 0, 0 },
/* U+3421 */ { 0, 0, 0, 0, 0 },
/* U+3422 */ { 0, 0, 0, 0, 0 },
/* U+3423 */ { 0, 0, 0, 0, 0 },
/* U+3424 */ { 0, 0, 0, 0, 0 },
/* U+3425 */ { 0, 0, 0, 0, 0 },
/* U+3426 */ { 0, 0, 0, 0, 0 },
/* U+3427 */ { 0, 0, 0, 0, 0 },
/* U+3428 */ { 0, 0, 0, 0, 0 },
/* U+3429 */ { 0, 0, 0, 0, 0 },
/* U+342a */ { 0, 0, 0, 0, 0 },
/* U+342b */ { 0, 0, 0, 0, 0 },
/* U+342c */ { 0, 0, 0, 0, 0 },
/* U+342d */ { 0, 0, 0, 0, 0 },
/* U+342e */ { 0, 0, 0, 0, 0 },
/* U+342f */ { 0, 0, 0, 0, 0 },
/* U+3430 */ { 0, 0, 0, 0, 0 },
/* U+3431 */ { 0, 0, 0, 0, 0 },
/* U+3432 */ { 0, 0, 0, 0, 0 },
/* U+3433 */ { 0, 0, 0, 0, 0 },
/* U+3434 */ { 0, 0, 0, 0, 0 },
/* U+3435 */ { 0, 0, 0, 0, 0 },
/* U+3436 */ { 0, 0, 0, 0, 0 },
/* U+3437 */ { 0, 0, 0, 0, 0 },
/* U+3438 */ { 0, 0, 0, 0, 0 },
/* U+3439 */ { 0, 0, 0, 0, 0 },
/* U+343a */ { 0, 0, 0, 0, 0 },
/* U+343b */ { 0, 0, 0, 0, 0 },
/* U+343c */ { 0, 0, 0, 0, 0 },
/* U+343d */ { 0, 0, 0, 0, 0 },
/* U+343e */ { 0, 0, 0, 0, 0 },
/* U+343f */ { 0, 0, 0, 0, 0 },
/* U+3440 */ { 0, 0, 0, 0, 0 },
/* U+3441 */ { 0, 0, 0, 0, 0 },
/* U+3442 */ { 0, 0, 0, 0, 0 },
/* U+3443 */ { 0, 0, 0, 0, 0 },
/* U+3444 */ { 0, 0, 0, 0, 0 },
/* U+3445 */ { 0, 0, 0, 0, 0 },
/* U+3446 */ { 0, 0, 0, 0, 0 },
/* U+3447 */ { 0, 0, 0, 0, 0 },
/* U+3448 */ { 0, 0, 0, 0, 0 },
/* U+3449 */ { 0, 0, 0, 0, 0 },
/* U+344a */ { 0, 0, 0, 0, 0 },
/* U+344b */ { 0, 0, 0, 0, 0 },
/* U+344c */ { 0, 0, 0, 0, 0 },
/* U+344d */ { 0, 0, 0, 0, 0 },
/* U+344e */ { 0, 0, 0, 0, 0 },
/* U+344f */ { 0, 0, 0, 0, 0 },
/* U+3450 */ { 0, 0, 0, 0, 0 },
/* U+3451 */ { 0, 0, 0, 0, 0 },
/* U+3452 */ { 0, 0, 0, 0, 0 },
/* U+3453 */ { 0, 0, 0, 0, 0 },
/* U+3454 */ { 0, 0, 0, 0, 0 },
/* U+3455 */ { 0, 0, 0, 0, 0 },
/* U+3456 */ { 0, 0, 0, 0, 0 },
/* U+3457 */ { 0, 0, 0, 0, 0 },
/* U+3458 */ { 0, 0, 0, 0, 0 },
/* U+3459 */ { 0, 0, 0, 0, 0 },
/* U+345a */ { 0, 0, 0, 0, 0 },
/* U+345b */ { 0, 0, 0, 0, 0 },
/* U+345c */ { 0, 0, 0, 0, 0 },
/* U+345d */ { 0, 0, 0, 0, 0 },
/* U+345e */ { 0, 0, 0, 0, 0 },
/* U+345f */ { 0, 0, 0, 0, 0 },
/* U+3460 */ { 0, 0, 0, 0, 0 },
/* U+3461 */ { 0, 0, 0, 0, 0 },
/* U+3462 */ { 0, 0, 0, 0, 0 },
/* U+3463 */ { 0, 0, 0, 0, 0 },
/* U+3464 */ { 0, 0, 0, 0, 0 },
/* U+3465 */ { 0, 0, 0, 0, 0 },
/* U+3466 */ { 0, 0, 0, 0, 0 },
/* U+3467 */ { 0, 0, 0, 0, 0 },
/* U+3468 */ { 0, 0, 0, 0, 0 },
/* U+3469 */ { 0, 0, 0, 0, 0 },
/* U+346a */ { 0, 0, 0, 0, 0 },
/* U+346b */ { 0, 0, 0, 0, 0 },
/* U+346c */ { 0, 0, 0, 0, 0 },
/* U+346d */ { 0, 0, 0, 0, 0 },
/* U+346e */ { 0, 0, 0, 0, 0 },
/* U+346f */ { 0, 0, 0, 0, 0 },
/* U+3470 */ { 0, 0, 0, 0, 0 },
/* U+3471 */ { 0, 0, 0, 0, 0 },
/* U+3472 */ { 0, 0, 0, 0, 0 },
/* U+3473 */ { 0, 0, 0, 0, 0 },
/* U+3474 */ { 0, 0, 0, 0, 0 },
/* U+3475 */ { 0, 0, 0, 0, 0 },
/* U+3476 */ { 0, 0, 0, 0, 0 },
/* U+3477 */ { 0, 0, 0, 0, 0 },
/* U+3478 */ { 0, 0, 0, 0, 0 },
/* U+3479 */ { 0, 0, 0, 0, 0 },
/* U+347a */ { 0, 0, 0, 0, 0 },
/* U+347b */ { 0, 0, 0, 0, 0 },
/* U+347c */ { 0, 0, 0, 0, 0 },
/* U+347d */ { 0, 0, 0, 0, 0 },
/* U+347e */ { 0, 0, 0, 0, 0 },
/* U+347f */ { 0, 0, 0, 0, 0 },
/* U+3480 */ { 0, 0, 0, 0, 0 },
/* U+3481 */ { 0, 0, 0, 0, 0 },
/* U+3482 */ { 0, 0, 0, 0, 0 },
/* U+3483 */ { 0, 0, 0, 0, 0 },
/* U+3484 */ { 0, 0, 0, 0, 0 },
/* U+3485 */ { 0, 0, 0, 0, 0 },
/* U+3486 */ { 0, 0, 0, 0, 0 },
/* U+3487 */ { 0, 0, 0, 0, 0 },
/* U+3488 */ { 0, 0, 0, 0, 0 },
/* U+3489 */ { 0, 0, 0, 0, 0 },
/* U+348a */ { 0, 0, 0, 0, 0 },
/* U+348b */ { 0, 0, 0, 0, 0 },
/* U+348c */ { 0, 0, 0, 0, 0 },
/* U+348d */ { 0, 0, 0, 0, 0 },
/* U+348e */ { 0, 0, 0, 0, 0 },
/* U+348f */ { 0, 0, 0, 0, 0 },
/* U+3490 */ { 0, 0, 0, 0, 0 },
/* U+3491 */ { 0, 0, 0, 0, 0 },
/* U+3492 */ { 0, 0, 0, 0, 0 },
/* U+3493 */ { 0, 0, 0, 0, 0 },
/* U+3494 */ { 0, 0, 0, 0, 0 },
/* U+3495 */ { 0, 0, 0, 0, 0 },
/* U+3496 */ { 0, 0, 0, 0, 0 },
/* U+3497 */ { 0, 0, 0, 0, 0 },
/* U+3498 */ { 0, 0, 0, 0, 0 },
/* U+3499 */ { 0, 0, 0, 0, 0 },
/* U+349a */ { 0, 0, 0, 0, 0 },
/* U+349b */ { 0, 0, 0, 0, 0 },
/* U+349c */ { 0, 0, 0, 0, 0 },
/* U+349d */ { 0, 0, 0, 0, 0 },
/* U+349e */ { 0, 0, 0, 0, 0 },
/* U+349f */ { 0, 0, 0, 0, 0 },
/* U+34a0 */ { 0, 0, 0, 0, 0 },
/* U+34a1 */ { 0, 0, 0, 0, 0 },
/* U+34a2 */ { 0, 0, 0, 0, 0 },
/* U+34a3 */ { 0, 0, 0, 0, 0 },
/* U+34a4 */ { 0, 0, 0, 0, 0 },
/* U+34a5 */ { 0, 0, 0, 0, 0 },
/* U+34a6 */ { 0, 0, 0, 0, 0 },
/* U+34a7 */ { 0, 0, 0, 0, 0 },
/* U+34a8 */ { 0, 0, 0, 0, 0 },
/* U+34a9 */ { 0, 0, 0, 0, 0 },
/* U+34aa */ { 0, 0, 0, 0, 0 },
/* U+34ab */ { 0, 0, 0, 0, 0 },
/* U+34ac */ { 0, 0, 0, 0, 0 },
/* U+34ad */ { 0, 0, 0, 0, 0 },
/* U+34ae */ { 0, 0, 0, 0, 0 },
/* U+34af */ { 0, 0, 0, 0, 0 },
/* U+34b0 */ { 0, 0, 0, 0, 0 },
/* U+34b1 */ { 0, 0, 0, 0, 0 },
/* U+34b2 */ { 0, 0, 0, 0, 0 },
/* U+34b3 */ { 0, 0, 0, 0, 0 },
/* U+34b4 */ { 0, 0, 0, 0, 0 },
/* U+34b5 */ { 0, 0, 0, 0, 0 },
/* U+34b6 */ { 0, 0, 0, 0, 0 },
/* U+34b7 */ { 0, 0, 0, 0, 0 },
/* U+34b8 */ { 0, 0, 0, 0, 0 },
/* U+34b9 */ { 0, 0, 0, 0, 0 },
/* U+34ba */ { 0, 0, 0, 0, 0 },
/* U+34bb */ { 0, 0, 0, 0, 0 },
/* U+34bc */ { 0, 0, 0, 0, 0 },
/* U+34bd */ { 0, 0, 0, 0, 0 },
/* U+34be */ { 0, 0, 0, 0, 0 },
/* U+34bf */ { 0, 0, 0, 0, 0 },
/* U+34c0 */ { 0, 0, 0, 0, 0 },
/* U+34c1 */ { 0, 0, 0, 0, 0 },
/* U+34c2 */ { 0, 0, 0, 0, 0 },
/* U+34c3 */ { 0, 0, 0, 0, 0 },
/* U+34c4 */ { 0, 0, 0, 0, 0 },
/* U+34c5 */ { 0, 0, 0, 0, 0 },
/* U+34c6 */ { 0, 0, 0, 0, 0 },
/* U+34c7 */ { 0, 0, 0, 0, 0 },
/* U+34c8 */ { 0, 0, 0, 0, 0 },
/* U+34c9 */ { 0, 0, 0, 0, 0 },
/* U+34ca */ { 0, 0, 0, 0, 0 },
/* U+34cb */ { 0, 0, 0, 0, 0 },
/* U+34cc */ { 0, 0, 0, 0, 0 },
/* U+34cd */ { 0, 0, 0, 0, 0 },
/* U+34ce */ { 0, 0, 0, 0, 0 },
/* U+34cf */ { 0, 0, 0, 0, 0 },
/* U+34d0 */ { 0, 0, 0, 0, 0 },
/* U+34d1 */ { 0, 0, 0, 0, 0 },
/* U+34d2 */ { 0, 0, 0, 0, 0 },
/* U+34d3 */ { 0, 0, 0, 0, 0 },
/* U+34d4 */ { 0, 0, 0, 0, 0 },
/* U+34d5 */ { 0, 0, 0, 0, 0 },
/* U+34d6 */ { 0, 0, 0, 0, 0 },
/* U+34d7 */ { 0, 0, 0, 0, 0 },
/* U+34d8 */ { 0, 0, 0, 0, 0 },
/* U+34d9 */ { 0, 0, 0, 0, 0 },
/* U+34da */ { 0, 0, 0, 0, 0 },
/* U+34db */ { 0, 0, 0, 0, 0 },
/* U+34dc */ { 0, 0, 0, 0, 0 },
/* U+34dd */ { 0, 0, 0, 0, 0 },
/* U+34de */ { 0, 0, 0, 0, 0 },
/* U+34df */ { 0, 0, 0, 0, 0 },
/* U+34e0 */ { 0, 0, 0, 0, 0 },
/* U+34e1 */ { 0, 0, 0, 0, 0 },
/* U+34e2 */ { 0, 0, 0, 0, 0 },
/* U+34e3 */ { 0, 0, 0, 0, 0 },
/* U+34e4 */ { 0, 0, 0, 0, 0 },
/* U+34e5 */ { 0, 0, 0, 0, 0 },
/* U+34e6 */ { 0, 0, 0, 0, 0 },
/* U+34e7 */ { 0, 0, 0, 0, 0 },
/* U+34e8 */ { 0, 0, 0, 0, 0 },
/* U+34e9 */ { 0, 0, 0, 0, 0 },
/* U+34ea */ { 0, 0, 0, 0, 0 },
/* U+34eb */ { 0, 0, 0, 0, 0 },
/* U+34ec */ { 0, 0, 0, 0, 0 },
/* U+34ed */ { 0, 0, 0, 0, 0 },
/* U+34ee */ { 0, 0, 0, 0, 0 },
/* U+34ef */ { 0, 0, 0, 0, 0 },
/* U+34f0 */ { 0, 0, 0, 0, 0 },
/* U+34f1 */ { 0, 0, 0, 0, 0 },
/* U+34f2 */ { 0, 0, 0, 0, 0 },
/* U+34f3 */ { 0, 0, 0, 0, 0 },
/* U+34f4 */ { 0, 0, 0, 0, 0 },
/* U+34f5 */ { 0, 0, 0, 0, 0 },
/* U+34f6 */ { 0, 0, 0, 0, 0 },
/* U+34f7 */ { 0, 0, 0, 0, 0 },
/* U+34f8 */ { 0, 0, 0, 0, 0 },
/* U+34f9 */ { 0, 0, 0, 0, 0 },
/* U+34fa */ { 0, 0, 0, 0, 0 },
/* U+34fb */ { 0, 0, 0, 0, 0 },
/* U+34fc */ { 0, 0, 0, 0, 0 },
/* U+34fd */ { 0, 0, 0, 0, 0 },
/* U+34fe */ { 0, 0, 0, 0, 0 },
/* U+34ff */ { 0, 0, 0, 0, 0 },
/* U+3500 */ { 0, 0, 0, 0, 0 },
/* U+3501 */ { 0, 0, 0, 0, 0 },
/* U+3502 */ { 0, 0, 0, 0, 0 },
/* U+3503 */ { 0, 0, 0, 0, 0 },
/* U+3504 */ { 0, 0, 0, 0, 0 },
/* U+3505 */ { 0, 0, 0, 0, 0 },
/* U+3506 */ { 0, 0, 0, 0, 0 },
/* U+3507 */ { 0, 0, 0, 0, 0 },
/* U+3508 */ { 0, 0, 0, 0, 0 },
/* U+3509 */ { 0, 0, 0, 0, 0 },
/* U+350a */ { 0, 0, 0, 0, 0 },
/* U+350b */ { 0, 0, 0, 0, 0 },
/* U+350c */ { 0, 0, 0, 0, 0 },
/* U+350d */ { 0, 0, 0, 0, 0 },
/* U+350e */ { 0, 0, 0, 0, 0 },
/* U+350f */ { 0, 0, 0, 0, 0 },
/* U+3510 */ { 0, 0, 0, 0, 0 },
/* U+3511 */ { 0, 0, 0, 0, 0 },
/* U+3512 */ { 0, 0, 0, 0, 0 },
/* U+3513 */ { 0, 0, 0, 0, 0 },
/* U+3514 */ { 0, 0, 0, 0, 0 },
/* U+3515 */ { 0, 0, 0, 0, 0 },
/* U+3516 */ { 0, 0, 0, 0, 0 },
/* U+3517 */ { 0, 0, 0, 0, 0 },
/* U+3518 */ { 0, 0, 0, 0, 0 },
/* U+3519 */ { 0, 0, 0, 0, 0 },
/* U+351a */ { 0, 0, 0, 0, 0 },
/* U+351b */ { 0, 0, 0, 0, 0 },
/* U+351c */ { 0, 0, 0, 0, 0 },
/* U+351d */ { 0, 0, 0, 0, 0 },
/* U+351e */ { 0, 0, 0, 0, 0 },
/* U+351f */ { 0, 0, 0, 0, 0 },
/* U+3520 */ { 0, 0, 0, 0, 0 },
/* U+3521 */ { 0, 0, 0, 0, 0 },
/* U+3522 */ { 0, 0, 0, 0, 0 },
/* U+3523 */ { 0, 0, 0, 0, 0 },
/* U+3524 */ { 0, 0, 0, 0, 0 },
/* U+3525 */ { 0, 0, 0, 0, 0 },
/* U+3526 */ { 0, 0, 0, 0, 0 },
/* U+3527 */ { 0, 0, 0, 0, 0 },
/* U+3528 */ { 0, 0, 0, 0, 0 },
/* U+3529 */ { 0, 0, 0, 0, 0 },
/* U+352a */ { 0, 0, 0, 0, 0 },
/* U+352b */ { 0, 0, 0, 0, 0 },
/* U+352c */ { 0, 0, 0, 0, 0 },
/* U+352d */ { 0, 0, 0, 0, 0 },
/* U+352e */ { 0, 0, 0, 0, 0 },
/* U+352f */ { 0, 0, 0, 0, 0 },
/* U+3530 */ { 0, 0, 0, 0, 0 },
/* U+3531 */ { 0, 0, 0, 0, 0 },
/* U+3532 */ { 0, 0, 0, 0, 0 },
/* U+3533 */ { 0, 0, 0, 0, 0 },
/* U+3534 */ { 0, 0, 0, 0, 0 },
/* U+3535 */ { 0, 0, 0, 0, 0 },
/* U+3536 */ { 0, 0, 0, 0, 0 },
/* U+3537 */ { 0, 0, 0, 0, 0 },
/* U+3538 */ { 0, 0, 0, 0, 0 },
/* U+3539 */ { 0, 0, 0, 0, 0 },
/* U+353a */ { 0, 0, 0, 0, 0 },
/* U+353b */ { 0, 0, 0, 0, 0 },
/* U+353c */ { 0, 0, 0, 0, 0 },
/* U+353d */ { 0, 0, 0, 0, 0 },
/* U+353e */ { 0, 0, 0, 0, 0 },
/* U+353f */ { 0, 0, 0, 0, 0 },
/* U+3540 */ { 0, 0, 0, 0, 0 },
/* U+3541 */ { 0, 0, 0, 0, 0 },
/* U+3542 */ { 0, 0, 0, 0, 0 },
/* U+3543 */ { 0, 0, 0, 0, 0 },
/* U+3544 */ { 0, 0, 0, 0, 0 },
/* U+3545 */ { 0, 0, 0, 0, 0 },
/* U+3546 */ { 0, 0, 0, 0, 0 },
/* U+3547 */ { 0, 0, 0, 0, 0 },
/* U+3548 */ { 0, 0, 0, 0, 0 },
/* U+3549 */ { 0, 0, 0, 0, 0 },
/* U+354a */ { 0, 0, 0, 0, 0 },
/* U+354b */ { 0, 0, 0, 0, 0 },
/* U+354c */ { 0, 0, 0, 0, 0 },
/* U+354d */ { 0, 0, 0, 0, 0 },
/* U+354e */ { 0, 0, 0, 0, 0 },
/* U+354f */ { 0, 0, 0, 0, 0 },
/* U+3550 */ { 0, 0, 0, 0, 0 },
/* U+3551 */ { 0, 0, 0, 0, 0 },
/* U+3552 */ { 0, 0, 0, 0, 0 },
/* U+3553 */ { 0, 0, 0, 0, 0 },
/* U+3554 */ { 0, 0, 0, 0, 0 },
/* U+3555 */ { 0, 0, 0, 0, 0 },
/* U+3556 */ { 0, 0, 0, 0, 0 },
/* U+3557 */ { 0, 0, 0, 0, 0 },
/* U+3558 */ { 0, 0, 0, 0, 0 },
/* U+3559 */ { 0, 0, 0, 0, 0 },
/* U+355a */ { 0, 0, 0, 0, 0 },
/* U+355b */ { 0, 0, 0, 0, 0 },
/* U+355c */ { 0, 0, 0, 0, 0 },
/* U+355d */ { 0, 0, 0, 0, 0 },
/* U+355e */ { 0, 0, 0, 0, 0 },
/* U+355f */ { 0, 0, 0, 0, 0 },
/* U+3560 */ { 0, 0, 0, 0, 0 },
/* U+3561 */ { 0, 0, 0, 0, 0 },
/* U+3562 */ { 0, 0, 0, 0, 0 },
/* U+3563 */ { 0, 0, 0, 0, 0 },
/* U+3564 */ { 0, 0, 0, 0, 0 },
/* U+3565 */ { 0, 0, 0, 0, 0 },
/* U+3566 */ { 0, 0, 0, 0, 0 },
/* U+3567 */ { 0, 0, 0, 0, 0 },
/* U+3568 */ { 0, 0, 0, 0, 0 },
/* U+3569 */ { 0, 0, 0, 0, 0 },
/* U+356a */ { 0, 0, 0, 0, 0 },
/* U+356b */ { 0, 0, 0, 0, 0 },
/* U+356c */ { 0, 0, 0, 0, 0 },
/* U+356d */ { 0, 0, 0, 0, 0 },
/* U+356e */ { 0, 0, 0, 0, 0 },
/* U+356f */ { 0, 0, 0, 0, 0 },
/* U+3570 */ { 0, 0, 0, 0, 0 },
/* U+3571 */ { 0, 0, 0, 0, 0 },
/* U+3572 */ { 0, 0, 0, 0, 0 },
/* U+3573 */ { 0, 0, 0, 0, 0 },
/* U+3574 */ { 0, 0, 0, 0, 0 },
/* U+3575 */ { 0, 0, 0, 0, 0 },
/* U+3576 */ { 0, 0, 0, 0, 0 },
/* U+3577 */ { 0, 0, 0, 0, 0 },
/* U+3578 */ { 0, 0, 0, 0, 0 },
/* U+3579 */ { 0, 0, 0, 0, 0 },
/* U+357a */ { 0, 0, 0, 0, 0 },
/* U+357b */ { 0, 0, 0, 0, 0 },
/* U+357c */ { 0, 0, 0, 0, 0 },
/* U+357d */ { 0, 0, 0, 0, 0 },
/* U+357e */ { 0, 0, 0, 0, 0 },
/* U+357f */ { 0, 0, 0, 0, 0 },
/* U+3580 */ { 0, 0, 0, 0, 0 },
/* U+3581 */ { 0, 0, 0, 0, 0 },
/* U+3582 */ { 0, 0, 0, 0, 0 },
/* U+3583 */ { 0, 0, 0, 0, 0 },
/* U+3584 */ { 0, 0, 0, 0, 0 },
/* U+3585 */ { 0, 0, 0, 0, 0 },
/* U+3586 */ { 0, 0, 0, 0, 0 },
/* U+3587 */ { 0, 0, 0, 0, 0 },
/* U+3588 */ { 0, 0, 0, 0, 0 },
/* U+3589 */ { 0, 0, 0, 0, 0 },
/* U+358a */ { 0, 0, 0, 0, 0 },
/* U+358b */ { 0, 0, 0, 0, 0 },
/* U+358c */ { 0, 0, 0, 0, 0 },
/* U+358d */ { 0, 0, 0, 0, 0 },
/* U+358e */ { 0, 0, 0, 0, 0 },
/* U+358f */ { 0, 0, 0, 0, 0 },
/* U+3590 */ { 0, 0, 0, 0, 0 },
/* U+3591 */ { 0, 0, 0, 0, 0 },
/* U+3592 */ { 0, 0, 0, 0, 0 },
/* U+3593 */ { 0, 0, 0, 0, 0 },
/* U+3594 */ { 0, 0, 0, 0, 0 },
/* U+3595 */ { 0, 0, 0, 0, 0 },
/* U+3596 */ { 0, 0, 0, 0, 0 },
/* U+3597 */ { 0, 0, 0, 0, 0 },
/* U+3598 */ { 0, 0, 0, 0, 0 },
/* U+3599 */ { 0, 0, 0, 0, 0 },
/* U+359a */ { 0, 0, 0, 0, 0 },
/* U+359b */ { 0, 0, 0, 0, 0 },
/* U+359c */ { 0, 0, 0, 0, 0 },
/* U+359d */ { 0, 0, 0, 0, 0 },
/* U+359e */ { 0, 0, 0, 0, 0 },
/* U+359f */ { 0, 0, 0, 0, 0 },
/* U+35a0 */ { 0, 0, 0, 0, 0 },
/* U+35a1 */ { 0, 0, 0, 0, 0 },
/* U+35a2 */ { 0, 0, 0, 0, 0 },
/* U+35a3 */ { 0, 0, 0, 0, 0 },
/* U+35a4 */ { 0, 0, 0, 0, 0 },
/* U+35a5 */ { 0, 0, 0, 0, 0 },
/* U+35a6 */ { 0, 0, 0, 0, 0 },
/* U+35a7 */ { 0, 0, 0, 0, 0 },
/* U+35a8 */ { 0, 0, 0, 0, 0 },
/* U+35a9 */ { 0, 0, 0, 0, 0 },
/* U+35aa */ { 0, 0, 0, 0, 0 },
/* U+35ab */ { 0, 0, 0, 0, 0 },
/* U+35ac */ { 0, 0, 0, 0, 0 },
/* U+35ad */ { 0, 0, 0, 0, 0 },
/* U+35ae */ { 0, 0, 0, 0, 0 },
/* U+35af */ { 0, 0, 0, 0, 0 },
/* U+35b0 */ { 0, 0, 0, 0, 0 },
/* U+35b1 */ { 0, 0, 0, 0, 0 },
/* U+35b2 */ { 0, 0, 0, 0, 0 },
/* U+35b3 */ { 0, 0, 0, 0, 0 },
/* U+35b4 */ { 0, 0, 0, 0, 0 },
/* U+35b5 */ { 0, 0, 0, 0, 0 },
/* U+35b6 */ { 0, 0, 0, 0, 0 },
/* U+35b7 */ { 0, 0, 0, 0, 0 },
/* U+35b8 */ { 0, 0, 0, 0, 0 },
/* U+35b9 */ { 0, 0, 0, 0, 0 },
/* U+35ba */ { 0, 0, 0, 0, 0 },
/* U+35bb */ { 0, 0, 0, 0, 0 },
/* U+35bc */ { 0, 0, 0, 0, 0 },
/* U+35bd */ { 0, 0, 0, 0, 0 },
/* U+35be */ { 0, 0, 0, 0, 0 },
/* U+35bf */ { 0, 0, 0, 0, 0 },
/* U+35c0 */ { 0, 0, 0, 0, 0 },
/* U+35c1 */ { 0, 0, 0, 0, 0 },
/* U+35c2 */ { 0, 0, 0, 0, 0 },
/* U+35c3 */ { 0, 0, 0, 0, 0 },
/* U+35c4 */ { 0, 0, 0, 0, 0 },
/* U+35c5 */ { 0, 0, 0, 0, 0 },
/* U+35c6 */ { 0, 0, 0, 0, 0 },
/* U+35c7 */ { 0, 0, 0, 0, 0 },
/* U+35c8 */ { 0, 0, 0, 0, 0 },
/* U+35c9 */ { 0, 0, 0, 0, 0 },
/* U+35ca */ { 0, 0, 0, 0, 0 },
/* U+35cb */ { 0, 0, 0, 0, 0 },
/* U+35cc */ { 0, 0, 0, 0, 0 },
/* U+35cd */ { 0, 0, 0, 0, 0 },
/* U+35ce */ { 0, 0, 0, 0, 0 },
/* U+35cf */ { 0, 0, 0, 0, 0 },
/* U+35d0 */ { 0, 0, 0, 0, 0 },
/* U+35d1 */ { 0, 0, 0, 0, 0 },
/* U+35d2 */ { 0, 0, 0, 0, 0 },
/* U+35d3 */ { 0, 0, 0, 0, 0 },
/* U+35d4 */ { 0, 0, 0, 0, 0 },
/* U+35d5 */ { 0, 0, 0, 0, 0 },
/* U+35d6 */ { 0, 0, 0, 0, 0 },
/* U+35d7 */ { 0, 0, 0, 0, 0 },
/* U+35d8 */ { 0, 0, 0, 0, 0 },
/* U+35d9 */ { 0, 0, 0, 0, 0 },
/* U+35da */ { 0, 0, 0, 0, 0 },
/* U+35db */ { 0, 0, 0, 0, 0 },
/* U+35dc */ { 0, 0, 0, 0, 0 },
/* U+35dd */ { 0, 0, 0, 0, 0 },
/* U+35de */ { 0, 0, 0, 0, 0 },
/* U+35df */ { 0, 0, 0, 0, 0 },
/* U+35e0 */ { 0, 0, 0, 0, 0 },
/* U+35e1 */ { 0, 0, 0, 0, 0 },
/* U+35e2 */ { 0, 0, 0, 0, 0 },
/* U+35e3 */ { 0, 0, 0, 0, 0 },
/* U+35e4 */ { 0, 0, 0, 0, 0 },
/* U+35e5 */ { 0, 0, 0, 0, 0 },
/* U+35e6 */ { 0, 0, 0, 0, 0 },
/* U+35e7 */ { 0, 0, 0, 0, 0 },
/* U+35e8 */ { 0, 0, 0, 0, 0 },
/* U+35e9 */ { 0, 0, 0, 0, 0 },
/* U+35ea */ { 0, 0, 0, 0, 0 },
/* U+35eb */ { 0, 0, 0, 0, 0 },
/* U+35ec */ { 0, 0, 0, 0, 0 },
/* U+35ed */ { 0, 0, 0, 0, 0 },
/* U+35ee */ { 0, 0, 0, 0, 0 },
/* U+35ef */ { 0, 0, 0, 0, 0 },
/* U+35f0 */ { 0, 0, 0, 0, 0 },
/* U+35f1 */ { 0, 0, 0, 0, 0 },
/* U+35f2 */ { 0, 0, 0, 0, 0 },
/* U+35f3 */ { 0, 0, 0, 0, 0 },
/* U+35f4 */ { 0, 0, 0, 0, 0 },
/* U+35f5 */ { 0, 0, 0, 0, 0 },
/* U+35f6 */ { 0, 0, 0, 0, 0 },
/* U+35f7 */ { 0, 0, 0, 0, 0 },
/* U+35f8 */ { 0, 0, 0, 0, 0 },
/* U+35f9 */ { 0, 0, 0, 0, 0 },
/* U+35fa */ { 0, 0, 0, 0, 0 },
/* U+35fb */ { 0, 0, 0, 0, 0 },
/* U+35fc */ { 0, 0, 0, 0, 0 },
/* U+35fd */ { 0, 0, 0, 0, 0 },
/* U+35fe */ { 0, 0, 0, 0, 0 },
/* U+35ff */ { 0, 0, 0, 0, 0 },
/* U+3600 */ { 0, 0, 0, 0, 0 },
/* U+3601 */ { 0, 0, 0, 0, 0 },
/* U+3602 */ { 0, 0, 0, 0, 0 },
/* U+3603 */ { 0, 0, 0, 0, 0 },
/* U+3604 */ { 0, 0, 0, 0, 0 },
/* U+3605 */ { 0, 0, 0, 0, 0 },
/* U+3606 */ { 0, 0, 0, 0, 0 },
/* U+3607 */ { 0, 0, 0, 0, 0 },
/* U+3608 */ { 0, 0, 0, 0, 0 },
/* U+3609 */ { 0, 0, 0, 0, 0 },
/* U+360a */ { 0, 0, 0, 0, 0 },
/* U+360b */ { 0, 0, 0, 0, 0 },
/* U+360c */ { 0, 0, 0, 0, 0 },
/* U+360d */ { 0, 0, 0, 0, 0 },
/* U+360e */ { 0, 0, 0, 0, 0 },
/* U+360f */ { 0, 0, 0, 0, 0 },
/* U+3610 */ { 0, 0, 0, 0, 0 },
/* U+3611 */ { 0, 0, 0, 0, 0 },
/* U+3612 */ { 0, 0, 0, 0, 0 },
/* U+3613 */ { 0, 0, 0, 0, 0 },
/* U+3614 */ { 0, 0, 0, 0, 0 },
/* U+3615 */ { 0, 0, 0, 0, 0 },
/* U+3616 */ { 0, 0, 0, 0, 0 },
/* U+3617 */ { 0, 0, 0, 0, 0 },
/* U+3618 */ { 0, 0, 0, 0, 0 },
/* U+3619 */ { 0, 0, 0, 0, 0 },
/* U+361a */ { 0, 0, 0, 0, 0 },
/* U+361b */ { 0, 0, 0, 0, 0 },
/* U+361c */ { 0, 0, 0, 0, 0 },
/* U+361d */ { 0, 0, 0, 0, 0 },
/* U+361e */ { 0, 0, 0, 0, 0 },
/* U+361f */ { 0, 0, 0, 0, 0 },
/* U+3620 */ { 0, 0, 0, 0, 0 },
/* U+3621 */ { 0, 0, 0, 0, 0 },
/* U+3622 */ { 0, 0, 0, 0, 0 },
/* U+3623 */ { 0, 0, 0, 0, 0 },
/* U+3624 */ { 0, 0, 0, 0, 0 },
/* U+3625 */ { 0, 0, 0, 0, 0 },
/* U+3626 */ { 0, 0, 0, 0, 0 },
/* U+3627 */ { 0, 0, 0, 0, 0 },
/* U+3628 */ { 0, 0, 0, 0, 0 },
/* U+3629 */ { 0, 0, 0, 0, 0 },
/* U+362a */ { 0, 0, 0, 0, 0 },
/* U+362b */ { 0, 0, 0, 0, 0 },
/* U+362c */ { 0, 0, 0, 0, 0 },
/* U+362d */ { 0, 0, 0, 0, 0 },
/* U+362e */ { 0, 0, 0, 0, 0 },
/* U+362f */ { 0, 0, 0, 0, 0 },
/* U+3630 */ { 0, 0, 0, 0, 0 },
/* U+3631 */ { 0, 0, 0, 0, 0 },
/* U+3632 */ { 0, 0, 0, 0, 0 },
/* U+3633 */ { 0, 0, 0, 0, 0 },
/* U+3634 */ { 0, 0, 0, 0, 0 },
/* U+3635 */ { 0, 0, 0, 0, 0 },
/* U+3636 */ { 0, 0, 0, 0, 0 },
/* U+3637 */ { 0, 0, 0, 0, 0 },
/* U+3638 */ { 0, 0, 0, 0, 0 },
/* U+3639 */ { 0, 0, 0, 0, 0 },
/* U+363a */ { 0, 0, 0, 0, 0 },
/* U+363b */ { 0, 0, 0, 0, 0 },
/* U+363c */ { 0, 0, 0, 0, 0 },
/* U+363d */ { 0, 0, 0, 0, 0 },
/* U+363e */ { 0, 0, 0, 0, 0 },
/* U+363f */ { 0, 0, 0, 0, 0 },
/* U+3640 */ { 0, 0, 0, 0, 0 },
/* U+3641 */ { 0, 0, 0, 0, 0 },
/* U+3642 */ { 0, 0, 0, 0, 0 },
/* U+3643 */ { 0, 0, 0, 0, 0 },
/* U+3644 */ { 0, 0, 0, 0, 0 },
/* U+3645 */ { 0, 0, 0, 0, 0 },
/* U+3646 */ { 0, 0, 0, 0, 0 },
/* U+3647 */ { 0, 0, 0, 0, 0 },
/* U+3648 */ { 0, 0, 0, 0, 0 },
/* U+3649 */ { 0, 0, 0, 0, 0 },
/* U+364a */ { 0, 0, 0, 0, 0 },
/* U+364b */ { 0, 0, 0, 0, 0 },
/* U+364c */ { 0, 0, 0, 0, 0 },
/* U+364d */ { 0, 0, 0, 0, 0 },
/* U+364e */ { 0, 0, 0, 0, 0 },
/* U+364f */ { 0, 0, 0, 0, 0 },
/* U+3650 */ { 0, 0, 0, 0, 0 },
/* U+3651 */ { 0, 0, 0, 0, 0 },
/* U+3652 */ { 0, 0, 0, 0, 0 },
/* U+3653 */ { 0, 0, 0, 0, 0 },
/* U+3654 */ { 0, 0, 0, 0, 0 },
/* U+3655 */ { 0, 0, 0, 0, 0 },
/* U+3656 */ { 0, 0, 0, 0, 0 },
/* U+3657 */ { 0, 0, 0, 0, 0 },
/* U+3658 */ { 0, 0, 0, 0, 0 },
/* U+3659 */ { 0, 0, 0, 0, 0 },
/* U+365a */ { 0, 0, 0, 0, 0 },
/* U+365b */ { 0, 0, 0, 0, 0 },
/* U+365c */ { 0, 0, 0, 0, 0 },
/* U+365d */ { 0, 0, 0, 0, 0 },
/* U+365e */ { 0, 0, 0, 0, 0 },
/* U+365f */ { 0, 0, 0, 0, 0 },
/* U+3660 */ { 0, 0, 0, 0, 0 },
/* U+3661 */ { 0, 0, 0, 0, 0 },
/* U+3662 */ { 0, 0, 0, 0, 0 },
/* U+3663 */ { 0, 0, 0, 0, 0 },
/* U+3664 */ { 0, 0, 0, 0, 0 },
/* U+3665 */ { 0, 0, 0, 0, 0 },
/* U+3666 */ { 0, 0, 0, 0, 0 },
/* U+3667 */ { 0, 0, 0, 0, 0 },
/* U+3668 */ { 0, 0, 0, 0, 0 },
/* U+3669 */ { 0, 0, 0, 0, 0 },
/* U+366a */ { 0, 0, 0, 0, 0 },
/* U+366b */ { 0, 0, 0, 0, 0 },
/* U+366c */ { 0, 0, 0, 0, 0 },
/* U+366d */ { 0, 0, 0, 0, 0 },
/* U+366e */ { 0, 0, 0, 0, 0 },
/* U+366f */ { 0, 0, 0, 0, 0 },
/* U+3670 */ { 0, 0, 0, 0, 0 },
/* U+3671 */ { 0, 0, 0, 0, 0 },
/* U+3672 */ { 0, 0, 0, 0, 0 },
/* U+3673 */ { 0, 0, 0, 0, 0 },
/* U+3674 */ { 0, 0, 0, 0, 0 },
/* U+3675 */ { 0, 0, 0, 0, 0 },
/* U+3676 */ { 0, 0, 0, 0, 0 },
/* U+3677 */ { 0, 0, 0, 0, 0 },
/* U+3678 */ { 0, 0, 0, 0, 0 },
/* U+3679 */ { 0, 0, 0, 0, 0 },
/* U+367a */ { 0, 0, 0, 0, 0 },
/* U+367b */ { 0, 0, 0, 0, 0 },
/* U+367c */ { 0, 0, 0, 0, 0 },
/* U+367d */ { 0, 0, 0, 0, 0 },
/* U+367e */ { 0, 0, 0, 0, 0 },
/* U+367f */ { 0, 0, 0, 0, 0 },
/* U+3680 */ { 0, 0, 0, 0, 0 },
/* U+3681 */ { 0, 0, 0, 0, 0 },
/* U+3682 */ { 0, 0, 0, 0, 0 },
/* U+3683 */ { 0, 0, 0, 0, 0 },
/* U+3684 */ { 0, 0, 0, 0, 0 },
/* U+3685 */ { 0, 0, 0, 0, 0 },
/* U+3686 */ { 0, 0, 0, 0, 0 },
/* U+3687 */ { 0, 0, 0, 0, 0 },
/* U+3688 */ { 0, 0, 0, 0, 0 },
/* U+3689 */ { 0, 0, 0, 0, 0 },
/* U+368a */ { 0, 0, 0, 0, 0 },
/* U+368b */ { 0, 0, 0, 0, 0 },
/* U+368c */ { 0, 0, 0, 0, 0 },
/* U+368d */ { 0, 0, 0, 0, 0 },
/* U+368e */ { 0, 0, 0, 0, 0 },
/* U+368f */ { 0, 0, 0, 0, 0 },
/* U+3690 */ { 0, 0, 0, 0, 0 },
/* U+3691 */ { 0, 0, 0, 0, 0 },
/* U+3692 */ { 0, 0, 0, 0, 0 },
/* U+3693 */ { 0, 0, 0, 0, 0 },
/* U+3694 */ { 0, 0, 0, 0, 0 },
/* U+3695 */ { 0, 0, 0, 0, 0 },
/* U+3696 */ { 0, 0, 0, 0, 0 },
/* U+3697 */ { 0, 0, 0, 0, 0 },
/* U+3698 */ { 0, 0, 0, 0, 0 },
/* U+3699 */ { 0, 0, 0, 0, 0 },
/* U+369a */ { 0, 0, 0, 0, 0 },
/* U+369b */ { 0, 0, 0, 0, 0 },
/* U+369c */ { 0, 0, 0, 0, 0 },
/* U+369d */ { 0, 0, 0, 0, 0 },
/* U+369e */ { 0, 0, 0, 0, 0 },
/* U+369f */ { 0, 0, 0, 0, 0 },
/* U+36a0 */ { 0, 0, 0, 0, 0 },
/* U+36a1 */ { 0, 0, 0, 0, 0 },
/* U+36a2 */ { 0, 0, 0, 0, 0 },
/* U+36a3 */ { 0, 0, 0, 0, 0 },
/* U+36a4 */ { 0, 0, 0, 0, 0 },
/* U+36a5 */ { 0, 0, 0, 0, 0 },
/* U+36a6 */ { 0, 0, 0, 0, 0 },
/* U+36a7 */ { 0, 0, 0, 0, 0 },
/* U+36a8 */ { 0, 0, 0, 0, 0 },
/* U+36a9 */ { 0, 0, 0, 0, 0 },
/* U+36aa */ { 0, 0, 0, 0, 0 },
/* U+36ab */ { 0, 0, 0, 0, 0 },
/* U+36ac */ { 0, 0, 0, 0, 0 },
/* U+36ad */ { 0, 0, 0, 0, 0 },
/* U+36ae */ { 0, 0, 0, 0, 0 },
/* U+36af */ { 0, 0, 0, 0, 0 },
/* U+36b0 */ { 0, 0, 0, 0, 0 },
/* U+36b1 */ { 0, 0, 0, 0, 0 },
/* U+36b2 */ { 0, 0, 0, 0, 0 },
/* U+36b3 */ { 0, 0, 0, 0, 0 },
/* U+36b4 */ { 0, 0, 0, 0, 0 },
/* U+36b5 */ { 0, 0, 0, 0, 0 },
/* U+36b6 */ { 0, 0, 0, 0, 0 },
/* U+36b7 */ { 0, 0, 0, 0, 0 },
/* U+36b8 */ { 0, 0, 0, 0, 0 },
/* U+36b9 */ { 0, 0, 0, 0, 0 },
/* U+36ba */ { 0, 0, 0, 0, 0 },
/* U+36bb */ { 0, 0, 0, 0, 0 },
/* U+36bc */ { 0, 0, 0, 0, 0 },
/* U+36bd */ { 0, 0, 0, 0, 0 },
/* U+36be */ { 0, 0, 0, 0, 0 },
/* U+36bf */ { 0, 0, 0, 0, 0 },
/* U+36c0 */ { 0, 0, 0, 0, 0 },
/* U+36c1 */ { 0, 0, 0, 0, 0 },
/* U+36c2 */ { 0, 0, 0, 0, 0 },
/* U+36c3 */ { 0, 0, 0, 0, 0 },
/* U+36c4 */ { 0, 0, 0, 0, 0 },
/* U+36c5 */ { 0, 0, 0, 0, 0 },
/* U+36c6 */ { 0, 0, 0, 0, 0 },
/* U+36c7 */ { 0, 0, 0, 0, 0 },
/* U+36c8 */ { 0, 0, 0, 0, 0 },
/* U+36c9 */ { 0, 0, 0, 0, 0 },
/* U+36ca */ { 0, 0, 0, 0, 0 },
/* U+36cb */ { 0, 0, 0, 0, 0 },
/* U+36cc */ { 0, 0, 0, 0, 0 },
/* U+36cd */ { 0, 0, 0, 0, 0 },
/* U+36ce */ { 0, 0, 0, 0, 0 },
/* U+36cf */ { 0, 0, 0, 0, 0 },
/* U+36d0 */ { 0, 0, 0, 0, 0 },
/* U+36d1 */ { 0, 0, 0, 0, 0 },
/* U+36d2 */ { 0, 0, 0, 0, 0 },
/* U+36d3 */ { 0, 0, 0, 0, 0 },
/* U+36d4 */ { 0, 0, 0, 0, 0 },
/* U+36d5 */ { 0, 0, 0, 0, 0 },
/* U+36d6 */ { 0, 0, 0, 0, 0 },
/* U+36d7 */ { 0, 0, 0, 0, 0 },
/* U+36d8 */ { 0, 0, 0, 0, 0 },
/* U+36d9 */ { 0, 0, 0, 0, 0 },
/* U+36da */ { 0, 0, 0, 0, 0 },
/* U+36db */ { 0, 0, 0, 0, 0 },
/* U+36dc */ { 0, 0, 0, 0, 0 },
/* U+36dd */ { 0, 0, 0, 0, 0 },
/* U+36de */ { 0, 0, 0, 0, 0 },
/* U+36df */ { 0, 0, 0, 0, 0 },
/* U+36e0 */ { 0, 0, 0, 0, 0 },
/* U+36e1 */ { 0, 0, 0, 0, 0 },
/* U+36e2 */ { 0, 0, 0, 0, 0 },
/* U+36e3 */ { 0, 0, 0, 0, 0 },
/* U+36e4 */ { 0, 0, 0, 0, 0 },
/* U+36e5 */ { 0, 0, 0, 0, 0 },
/* U+36e6 */ { 0, 0, 0, 0, 0 },
/* U+36e7 */ { 0, 0, 0, 0, 0 },
/* U+36e8 */ { 0, 0, 0, 0, 0 },
/* U+36e9 */ { 0, 0, 0, 0, 0 },
/* U+36ea */ { 0, 0, 0, 0, 0 },
/* U+36eb */ { 0, 0, 0, 0, 0 },
/* U+36ec */ { 0, 0, 0, 0, 0 },
/* U+36ed */ { 0, 0, 0, 0, 0 },
/* U+36ee */ { 0, 0, 0, 0, 0 },
/* U+36ef */ { 0, 0, 0, 0, 0 },
/* U+36f0 */ { 0, 0, 0, 0, 0 },
/* U+36f1 */ { 0, 0, 0, 0, 0 },
/* U+36f2 */ { 0, 0, 0, 0, 0 },
/* U+36f3 */ { 0, 0, 0, 0, 0 },
/* U+36f4 */ { 0, 0, 0, 0, 0 },
/* U+36f5 */ { 0, 0, 0, 0, 0 },
/* U+36f6 */ { 0, 0, 0, 0, 0 },
/* U+36f7 */ { 0, 0, 0, 0, 0 },
/* U+36f8 */ { 0, 0, 0, 0, 0 },
/* U+36f9 */ { 0, 0, 0, 0, 0 },
/* U+36fa */ { 0, 0, 0, 0, 0 },
/* U+36fb */ { 0, 0, 0, 0, 0 },
/* U+36fc */ { 0, 0, 0, 0, 0 },
/* U+36fd */ { 0, 0, 0, 0, 0 },
/* U+36fe */ { 0, 0, 0, 0, 0 },
/* U+36ff */ { 0, 0, 0, 0, 0 },
/* U+3700 */ { 0, 0, 0, 0, 0 },
/* U+3701 */ { 0, 0, 0, 0, 0 },
/* U+3702 */ { 0, 0, 0, 0, 0 },
/* U+3703 */ { 0, 0, 0, 0, 0 },
/* U+3704 */ { 0, 0, 0, 0, 0 },
/* U+3705 */ { 0, 0, 0, 0, 0 },
/* U+3706 */ { 0, 0, 0, 0, 0 },
/* U+3707 */ { 0, 0, 0, 0, 0 },
/* U+3708 */ { 0, 0, 0, 0, 0 },
/* U+3709 */ { 0, 0, 0, 0, 0 },
/* U+370a */ { 0, 0, 0, 0, 0 },
/* U+370b */ { 0, 0, 0, 0, 0 },
/* U+370c */ { 0, 0, 0, 0, 0 },
/* U+370d */ { 0, 0, 0, 0, 0 },
/* U+370e */ { 0, 0, 0, 0, 0 },
/* U+370f */ { 0, 0, 0, 0, 0 },
/* U+3710 */ { 0, 0, 0, 0, 0 },
/* U+3711 */ { 0, 0, 0, 0, 0 },
/* U+3712 */ { 0, 0, 0, 0, 0 },
/* U+3713 */ { 0, 0, 0, 0, 0 },
/* U+3714 */ { 0, 0, 0, 0, 0 },
/* U+3715 */ { 0, 0, 0, 0, 0 },
/* U+3716 */ { 0, 0, 0, 0, 0 },
/* U+3717 */ { 0, 0, 0, 0, 0 },
/* U+3718 */ { 0, 0, 0, 0, 0 },
/* U+3719 */ { 0, 0, 0, 0, 0 },
/* U+371a */ { 0, 0, 0, 0, 0 },
/* U+371b */ { 0, 0, 0, 0, 0 },
/* U+371c */ { 0, 0, 0, 0, 0 },
/* U+371d */ { 0, 0, 0, 0, 0 },
/* U+371e */ { 0, 0, 0, 0, 0 },
/* U+371f */ { 0, 0, 0, 0, 0 },
/* U+3720 */ { 0, 0, 0, 0, 0 },
/* U+3721 */ { 0, 0, 0, 0, 0 },
/* U+3722 */ { 0, 0, 0, 0, 0 },
/* U+3723 */ { 0, 0, 0, 0, 0 },
/* U+3724 */ { 0, 0, 0, 0, 0 },
/* U+3725 */ { 0, 0, 0, 0, 0 },
/* U+3726 */ { 0, 0, 0, 0, 0 },
/* U+3727 */ { 0, 0, 0, 0, 0 },
/* U+3728 */ { 0, 0, 0, 0, 0 },
/* U+3729 */ { 0, 0, 0, 0, 0 },
/* U+372a */ { 0, 0, 0, 0, 0 },
/* U+372b */ { 0, 0, 0, 0, 0 },
/* U+372c */ { 0, 0, 0, 0, 0 },
/* U+372d */ { 0, 0, 0, 0, 0 },
/* U+372e */ { 0, 0, 0, 0, 0 },
/* U+372f */ { 0, 0, 0, 0, 0 },
/* U+3730 */ { 0, 0, 0, 0, 0 },
/* U+3731 */ { 0, 0, 0, 0, 0 },
/* U+3732 */ { 0, 0, 0, 0, 0 },
/* U+3733 */ { 0, 0, 0, 0, 0 },
/* U+3734 */ { 0, 0, 0, 0, 0 },
/* U+3735 */ { 0, 0, 0, 0, 0 },
/* U+3736 */ { 0, 0, 0, 0, 0 },
/* U+3737 */ { 0, 0, 0, 0, 0 },
/* U+3738 */ { 0, 0, 0, 0, 0 },
/* U+3739 */ { 0, 0, 0, 0, 0 },
/* U+373a */ { 0, 0, 0, 0, 0 },
/* U+373b */ { 0, 0, 0, 0, 0 },
/* U+373c */ { 0, 0, 0, 0, 0 },
/* U+373d */ { 0, 0, 0, 0, 0 },
/* U+373e */ { 0, 0, 0, 0, 0 },
/* U+373f */ { 0, 0, 0, 0, 0 },
/* U+3740 */ { 0, 0, 0, 0, 0 },
/* U+3741 */ { 0, 0, 0, 0, 0 },
/* U+3742 */ { 0, 0, 0, 0, 0 },
/* U+3743 */ { 0, 0, 0, 0, 0 },
/* U+3744 */ { 0, 0, 0, 0, 0 },
/* U+3745 */ { 0, 0, 0, 0, 0 },
/* U+3746 */ { 0, 0, 0, 0, 0 },
/* U+3747 */ { 0, 0, 0, 0, 0 },
/* U+3748 */ { 0, 0, 0, 0, 0 },
/* U+3749 */ { 0, 0, 0, 0, 0 },
/* U+374a */ { 0, 0, 0, 0, 0 },
/* U+374b */ { 0, 0, 0, 0, 0 },
/* U+374c */ { 0, 0, 0, 0, 0 },
/* U+374d */ { 0, 0, 0, 0, 0 },
/* U+374e */ { 0, 0, 0, 0, 0 },
/* U+374f */ { 0, 0, 0, 0, 0 },
/* U+3750 */ { 0, 0, 0, 0, 0 },
/* U+3751 */ { 0, 0, 0, 0, 0 },
/* U+3752 */ { 0, 0, 0, 0, 0 },
/* U+3753 */ { 0, 0, 0, 0, 0 },
/* U+3754 */ { 0, 0, 0, 0, 0 },
/* U+3755 */ { 0, 0, 0, 0, 0 },
/* U+3756 */ { 0, 0, 0, 0, 0 },
/* U+3757 */ { 0, 0, 0, 0, 0 },
/* U+3758 */ { 0, 0, 0, 0, 0 },
/* U+3759 */ { 0, 0, 0, 0, 0 },
/* U+375a */ { 0, 0, 0, 0, 0 },
/* U+375b */ { 0, 0, 0, 0, 0 },
/* U+375c */ { 0, 0, 0, 0, 0 },
/* U+375d */ { 0, 0, 0, 0, 0 },
/* U+375e */ { 0, 0, 0, 0, 0 },
/* U+375f */ { 0, 0, 0, 0, 0 },
/* U+3760 */ { 0, 0, 0, 0, 0 },
/* U+3761 */ { 0, 0, 0, 0, 0 },
/* U+3762 */ { 0, 0, 0, 0, 0 },
/* U+3763 */ { 0, 0, 0, 0, 0 },
/* U+3764 */ { 0, 0, 0, 0, 0 },
/* U+3765 */ { 0, 0, 0, 0, 0 },
/* U+3766 */ { 0, 0, 0, 0, 0 },
/* U+3767 */ { 0, 0, 0, 0, 0 },
/* U+3768 */ { 0, 0, 0, 0, 0 },
/* U+3769 */ { 0, 0, 0, 0, 0 },
/* U+376a */ { 0, 0, 0, 0, 0 },
/* U+376b */ { 0, 0, 0, 0, 0 },
/* U+376c */ { 0, 0, 0, 0, 0 },
/* U+376d */ { 0, 0, 0, 0, 0 },
/* U+376e */ { 0, 0, 0, 0, 0 },
/* U+376f */ { 0, 0, 0, 0, 0 },
/* U+3770 */ { 0, 0, 0, 0, 0 },
/* U+3771 */ { 0, 0, 0, 0, 0 },
/* U+3772 */ { 0, 0, 0, 0, 0 },
/* U+3773 */ { 0, 0, 0, 0, 0 },
/* U+3774 */ { 0, 0, 0, 0, 0 },
/* U+3775 */ { 0, 0, 0, 0, 0 },
/* U+3776 */ { 0, 0, 0, 0, 0 },
/* U+3777 */ { 0, 0, 0, 0, 0 },
/* U+3778 */ { 0, 0, 0, 0, 0 },
/* U+3779 */ { 0, 0, 0, 0, 0 },
/* U+377a */ { 0, 0, 0, 0, 0 },
/* U+377b */ { 0, 0, 0, 0, 0 },
/* U+377c */ { 0, 0, 0, 0, 0 },
/* U+377d */ { 0, 0, 0, 0, 0 },
/* U+377e */ { 0, 0, 0, 0, 0 },
/* U+377f */ { 0, 0, 0, 0, 0 },
/* U+3780 */ { 0, 0, 0, 0, 0 },
/* U+3781 */ { 0, 0, 0, 0, 0 },
/* U+3782 */ { 0, 0, 0, 0, 0 },
/* U+3783 */ { 0, 0, 0, 0, 0 },
/* U+3784 */ { 0, 0, 0, 0, 0 },
/* U+3785 */ { 0, 0, 0, 0, 0 },
/* U+3786 */ { 0, 0, 0, 0, 0 },
/* U+3787 */ { 0, 0, 0, 0, 0 },
/* U+3788 */ { 0, 0, 0, 0, 0 },
/* U+3789 */ { 0, 0, 0, 0, 0 },
/* U+378a */ { 0, 0, 0, 0, 0 },
/* U+378b */ { 0, 0, 0, 0, 0 },
/* U+378c */ { 0, 0, 0, 0, 0 },
/* U+378d */ { 0, 0, 0, 0, 0 },
/* U+378e */ { 0, 0, 0, 0, 0 },
/* U+378f */ { 0, 0, 0, 0, 0 },
/* U+3790 */ { 0, 0, 0, 0, 0 },
/* U+3791 */ { 0, 0, 0, 0, 0 },
/* U+3792 */ { 0, 0, 0, 0, 0 },
/* U+3793 */ { 0, 0, 0, 0, 0 },
/* U+3794 */ { 0, 0, 0, 0, 0 },
/* U+3795 */ { 0, 0, 0, 0, 0 },
/* U+3796 */ { 0, 0, 0, 0, 0 },
/* U+3797 */ { 0, 0, 0, 0, 0 },
/* U+3798 */ { 0, 0, 0, 0, 0 },
/* U+3799 */ { 0, 0, 0, 0, 0 },
/* U+379a */ { 0, 0, 0, 0, 0 },
/* U+379b */ { 0, 0, 0, 0, 0 },
/* U+379c */ { 0, 0, 0, 0, 0 },
/* U+379d */ { 0, 0, 0, 0, 0 },
/* U+379e */ { 0, 0, 0, 0, 0 },
/* U+379f */ { 0, 0, 0, 0, 0 },
/* U+37a0 */ { 0, 0, 0, 0, 0 },
/* U+37a1 */ { 0, 0, 0, 0, 0 },
/* U+37a2 */ { 0, 0, 0, 0, 0 },
/* U+37a3 */ { 0, 0, 0, 0, 0 },
/* U+37a4 */ { 0, 0, 0, 0, 0 },
/* U+37a5 */ { 0, 0, 0, 0, 0 },
/* U+37a6 */ { 0, 0, 0, 0, 0 },
/* U+37a7 */ { 0, 0, 0, 0, 0 },
/* U+37a8 */ { 0, 0, 0, 0, 0 },
/* U+37a9 */ { 0, 0, 0, 0, 0 },
/* U+37aa */ { 0, 0, 0, 0, 0 },
/* U+37ab */ { 0, 0, 0, 0, 0 },
/* U+37ac */ { 0, 0, 0, 0, 0 },
/* U+37ad */ { 0, 0, 0, 0, 0 },
/* U+37ae */ { 0, 0, 0, 0, 0 },
/* U+37af */ { 0, 0, 0, 0, 0 },
/* U+37b0 */ { 0, 0, 0, 0, 0 },
/* U+37b1 */ { 0, 0, 0, 0, 0 },
/* U+37b2 */ { 0, 0, 0, 0, 0 },
/* U+37b3 */ { 0, 0, 0, 0, 0 },
/* U+37b4 */ { 0, 0, 0, 0, 0 },
/* U+37b5 */ { 0, 0, 0, 0, 0 },
/* U+37b6 */ { 0, 0, 0, 0, 0 },
/* U+37b7 */ { 0, 0, 0, 0, 0 },
/* U+37b8 */ { 0, 0, 0, 0, 0 },
/* U+37b9 */ { 0, 0, 0, 0, 0 },
/* U+37ba */ { 0, 0, 0, 0, 0 },
/* U+37bb */ { 0, 0, 0, 0, 0 },
/* U+37bc */ { 0, 0, 0, 0, 0 },
/* U+37bd */ { 0, 0, 0, 0, 0 },
/* U+37be */ { 0, 0, 0, 0, 0 },
/* U+37bf */ { 0, 0, 0, 0, 0 },
/* U+37c0 */ { 0, 0, 0, 0, 0 },
/* U+37c1 */ { 0, 0, 0, 0, 0 },
/* U+37c2 */ { 0, 0, 0, 0, 0 },
/* U+37c3 */ { 0, 0, 0, 0, 0 },
/* U+37c4 */ { 0, 0, 0, 0, 0 },
/* U+37c5 */ { 0, 0, 0, 0, 0 },
/* U+37c6 */ { 0, 0, 0, 0, 0 },
/* U+37c7 */ { 0, 0, 0, 0, 0 },
/* U+37c8 */ { 0, 0, 0, 0, 0 },
/* U+37c9 */ { 0, 0, 0, 0, 0 },
/* U+37ca */ { 0, 0, 0, 0, 0 },
/* U+37cb */ { 0, 0, 0, 0, 0 },
/* U+37cc */ { 0, 0, 0, 0, 0 },
/* U+37cd */ { 0, 0, 0, 0, 0 },
/* U+37ce */ { 0, 0, 0, 0, 0 },
/* U+37cf */ { 0, 0, 0, 0, 0 },
/* U+37d0 */ { 0, 0, 0, 0, 0 },
/* U+37d1 */ { 0, 0, 0, 0, 0 },
/* U+37d2 */ { 0, 0, 0, 0, 0 },
/* U+37d3 */ { 0, 0, 0, 0, 0 },
/* U+37d4 */ { 0, 0, 0, 0, 0 },
/* U+37d5 */ { 0, 0, 0, 0, 0 },
/* U+37d6 */ { 0, 0, 0, 0, 0 },
/* U+37d7 */ { 0, 0, 0, 0, 0 },
/* U+37d8 */ { 0, 0, 0, 0, 0 },
/* U+37d9 */ { 0, 0, 0, 0, 0 },
/* U+37da */ { 0, 0, 0, 0, 0 },
/* U+37db */ { 0, 0, 0, 0, 0 },
/* U+37dc */ { 0, 0, 0, 0, 0 },
/* U+37dd */ { 0, 0, 0, 0, 0 },
/* U+37de */ { 0, 0, 0, 0, 0 },
/* U+37df */ { 0, 0, 0, 0, 0 },
/* U+37e0 */ { 0, 0, 0, 0, 0 },
/* U+37e1 */ { 0, 0, 0, 0, 0 },
/* U+37e2 */ { 0, 0, 0, 0, 0 },
/* U+37e3 */ { 0, 0, 0, 0, 0 },
/* U+37e4 */ { 0, 0, 0, 0, 0 },
/* U+37e5 */ { 0, 0, 0, 0, 0 },
/* U+37e6 */ { 0, 0, 0, 0, 0 },
/* U+37e7 */ { 0, 0, 0, 0, 0 },
/* U+37e8 */ { 0, 0, 0, 0, 0 },
/* U+37e9 */ { 0, 0, 0, 0, 0 },
/* U+37ea */ { 0, 0, 0, 0, 0 },
/* U+37eb */ { 0, 0, 0, 0, 0 },
/* U+37ec */ { 0, 0, 0, 0, 0 },
/* U+37ed */ { 0, 0, 0, 0, 0 },
/* U+37ee */ { 0, 0, 0, 0, 0 },
/* U+37ef */ { 0, 0, 0, 0, 0 },
/* U+37f0 */ { 0, 0, 0, 0, 0 },
/* U+37f1 */ { 0, 0, 0, 0, 0 },
/* U+37f2 */ { 0, 0, 0, 0, 0 },
/* U+37f3 */ { 0, 0, 0, 0, 0 },
/* U+37f4 */ { 0, 0, 0, 0, 0 },
/* U+37f5 */ { 0, 0, 0, 0, 0 },
/* U+37f6 */ { 0, 0, 0, 0, 0 },
/* U+37f7 */ { 0, 0, 0, 0, 0 },
/* U+37f8 */ { 0, 0, 0, 0, 0 },
/* U+37f9 */ { 0, 0, 0, 0, 0 },
/* U+37fa */ { 0, 0, 0, 0, 0 },
/* U+37fb */ { 0, 0, 0, 0, 0 },
/* U+37fc */ { 0, 0, 0, 0, 0 },
/* U+37fd */ { 0, 0, 0, 0, 0 },
/* U+37fe */ { 0, 0, 0, 0, 0 },
/* U+37ff */ { 0, 0, 0, 0, 0 },
/* U+3800 */ { 0, 0, 0, 0, 0 },
/* U+3801 */ { 0, 0, 0, 0, 0 },
/* U+3802 */ { 0, 0, 0, 0, 0 },
/* U+3803 */ { 0, 0, 0, 0, 0 },
/* U+3804 */ { 0, 0, 0, 0, 0 },
/* U+3805 */ { 0, 0, 0, 0, 0 },
/* U+3806 */ { 0, 0, 0, 0, 0 },
/* U+3807 */ { 0, 0, 0, 0, 0 },
/* U+3808 */ { 0, 0, 0, 0, 0 },
/* U+3809 */ { 0, 0, 0, 0, 0 },
/* U+380a */ { 0, 0, 0, 0, 0 },
/* U+380b */ { 0, 0, 0, 0, 0 },
/* U+380c */ { 0, 0, 0, 0, 0 },
/* U+380d */ { 0, 0, 0, 0, 0 },
/* U+380e */ { 0, 0, 0, 0, 0 },
/* U+380f */ { 0, 0, 0, 0, 0 },
/* U+3810 */ { 0, 0, 0, 0, 0 },
/* U+3811 */ { 0, 0, 0, 0, 0 },
/* U+3812 */ { 0, 0, 0, 0, 0 },
/* U+3813 */ { 0, 0, 0, 0, 0 },
/* U+3814 */ { 0, 0, 0, 0, 0 },
/* U+3815 */ { 0, 0, 0, 0, 0 },
/* U+3816 */ { 0, 0, 0, 0, 0 },
/* U+3817 */ { 0, 0, 0, 0, 0 },
/* U+3818 */ { 0, 0, 0, 0, 0 },
/* U+3819 */ { 0, 0, 0, 0, 0 },
/* U+381a */ { 0, 0, 0, 0, 0 },
/* U+381b */ { 0, 0, 0, 0, 0 },
/* U+381c */ { 0, 0, 0, 0, 0 },
/* U+381d */ { 0, 0, 0, 0, 0 },
/* U+381e */ { 0, 0, 0, 0, 0 },
/* U+381f */ { 0, 0, 0, 0, 0 },
/* U+3820 */ { 0, 0, 0, 0, 0 },
/* U+3821 */ { 0, 0, 0, 0, 0 },
/* U+3822 */ { 0, 0, 0, 0, 0 },
/* U+3823 */ { 0, 0, 0, 0, 0 },
/* U+3824 */ { 0, 0, 0, 0, 0 },
/* U+3825 */ { 0, 0, 0, 0, 0 },
/* U+3826 */ { 0, 0, 0, 0, 0 },
/* U+3827 */ { 0, 0, 0, 0, 0 },
/* U+3828 */ { 0, 0, 0, 0, 0 },
/* U+3829 */ { 0, 0, 0, 0, 0 },
/* U+382a */ { 0, 0, 0, 0, 0 },
/* U+382b */ { 0, 0, 0, 0, 0 },
/* U+382c */ { 0, 0, 0, 0, 0 },
/* U+382d */ { 0, 0, 0, 0, 0 },
/* U+382e */ { 0, 0, 0, 0, 0 },
/* U+382f */ { 0, 0, 0, 0, 0 },
/* U+3830 */ { 0, 0, 0, 0, 0 },
/* U+3831 */ { 0, 0, 0, 0, 0 },
/* U+3832 */ { 0, 0, 0, 0, 0 },
/* U+3833 */ { 0, 0, 0, 0, 0 },
/* U+3834 */ { 0, 0, 0, 0, 0 },
/* U+3835 */ { 0, 0, 0, 0, 0 },
/* U+3836 */ { 0, 0, 0, 0, 0 },
/* U+3837 */ { 0, 0, 0, 0, 0 },
/* U+3838 */ { 0, 0, 0, 0, 0 },
/* U+3839 */ { 0, 0, 0, 0, 0 },
/* U+383a */ { 0, 0, 0, 0, 0 },
/* U+383b */ { 0, 0, 0, 0, 0 },
/* U+383c */ { 0, 0, 0, 0, 0 },
/* U+383d */ { 0, 0, 0, 0, 0 },
/* U+383e */ { 0, 0, 0, 0, 0 },
/* U+383f */ { 0, 0, 0, 0, 0 },
/* U+3840 */ { 0, 0, 0, 0, 0 },
/* U+3841 */ { 0, 0, 0, 0, 0 },
/* U+3842 */ { 0, 0, 0, 0, 0 },
/* U+3843 */ { 0, 0, 0, 0, 0 },
/* U+3844 */ { 0, 0, 0, 0, 0 },
/* U+3845 */ { 0, 0, 0, 0, 0 },
/* U+3846 */ { 0, 0, 0, 0, 0 },
/* U+3847 */ { 0, 0, 0, 0, 0 },
/* U+3848 */ { 0, 0, 0, 0, 0 },
/* U+3849 */ { 0, 0, 0, 0, 0 },
/* U+384a */ { 0, 0, 0, 0, 0 },
/* U+384b */ { 0, 0, 0, 0, 0 },
/* U+384c */ { 0, 0, 0, 0, 0 },
/* U+384d */ { 0, 0, 0, 0, 0 },
/* U+384e */ { 0, 0, 0, 0, 0 },
/* U+384f */ { 0, 0, 0, 0, 0 },
/* U+3850 */ { 0, 0, 0, 0, 0 },
/* U+3851 */ { 0, 0, 0, 0, 0 },
/* U+3852 */ { 0, 0, 0, 0, 0 },
/* U+3853 */ { 0, 0, 0, 0, 0 },
/* U+3854 */ { 0, 0, 0, 0, 0 },
/* U+3855 */ { 0, 0, 0, 0, 0 },
/* U+3856 */ { 0, 0, 0, 0, 0 },
/* U+3857 */ { 0, 0, 0, 0, 0 },
/* U+3858 */ { 0, 0, 0, 0, 0 },
/* U+3859 */ { 0, 0, 0, 0, 0 },
/* U+385a */ { 0, 0, 0, 0, 0 },
/* U+385b */ { 0, 0, 0, 0, 0 },
/* U+385c */ { 0, 0, 0, 0, 0 },
/* U+385d */ { 0, 0, 0, 0, 0 },
/* U+385e */ { 0, 0, 0, 0, 0 },
/* U+385f */ { 0, 0, 0, 0, 0 },
/* U+3860 */ { 0, 0, 0, 0, 0 },
/* U+3861 */ { 0, 0, 0, 0, 0 },
/* U+3862 */ { 0, 0, 0, 0, 0 },
/* U+3863 */ { 0, 0, 0, 0, 0 },
/* U+3864 */ { 0, 0, 0, 0, 0 },
/* U+3865 */ { 0, 0, 0, 0, 0 },
/* U+3866 */ { 0, 0, 0, 0, 0 },
/* U+3867 */ { 0, 0, 0, 0, 0 },
/* U+3868 */ { 0, 0, 0, 0, 0 },
/* U+3869 */ { 0, 0, 0, 0, 0 },
/* U+386a */ { 0, 0, 0, 0, 0 },
/* U+386b */ { 0, 0, 0, 0, 0 },
/* U+386c */ { 0, 0, 0, 0, 0 },
/* U+386d */ { 0, 0, 0, 0, 0 },
/* U+386e */ { 0, 0, 0, 0, 0 },
/* U+386f */ { 0, 0, 0, 0, 0 },
/* U+3870 */ { 0, 0, 0, 0, 0 },
/* U+3871 */ { 0, 0, 0, 0, 0 },
/* U+3872 */ { 0, 0, 0, 0, 0 },
/* U+3873 */ { 0, 0, 0, 0, 0 },
/* U+3874 */ { 0, 0, 0, 0, 0 },
/* U+3875 */ { 0, 0, 0, 0, 0 },
/* U+3876 */ { 0, 0, 0, 0, 0 },
/* U+3877 */ { 0, 0, 0, 0, 0 },
/* U+3878 */ { 0, 0, 0, 0, 0 },
/* U+3879 */ { 0, 0, 0, 0, 0 },
/* U+387a */ { 0, 0, 0, 0, 0 },
/* U+387b */ { 0, 0, 0, 0, 0 },
/* U+387c */ { 0, 0, 0, 0, 0 },
/* U+387d */ { 0, 0, 0, 0, 0 },
/* U+387e */ { 0, 0, 0, 0, 0 },
/* U+387f */ { 0, 0, 0, 0, 0 },
/* U+3880 */ { 0, 0, 0, 0, 0 },
/* U+3881 */ { 0, 0, 0, 0, 0 },
/* U+3882 */ { 0, 0, 0, 0, 0 },
/* U+3883 */ { 0, 0, 0, 0, 0 },
/* U+3884 */ { 0, 0, 0, 0, 0 },
/* U+3885 */ { 0, 0, 0, 0, 0 },
/* U+3886 */ { 0, 0, 0, 0, 0 },
/* U+3887 */ { 0, 0, 0, 0, 0 },
/* U+3888 */ { 0, 0, 0, 0, 0 },
/* U+3889 */ { 0, 0, 0, 0, 0 },
/* U+388a */ { 0, 0, 0, 0, 0 },
/* U+388b */ { 0, 0, 0, 0, 0 },
/* U+388c */ { 0, 0, 0, 0, 0 },
/* U+388d */ { 0, 0, 0, 0, 0 },
/* U+388e */ { 0, 0, 0, 0, 0 },
/* U+388f */ { 0, 0, 0, 0, 0 },
/* U+3890 */ { 0, 0, 0, 0, 0 },
/* U+3891 */ { 0, 0, 0, 0, 0 },
/* U+3892 */ { 0, 0, 0, 0, 0 },
/* U+3893 */ { 0, 0, 0, 0, 0 },
/* U+3894 */ { 0, 0, 0, 0, 0 },
/* U+3895 */ { 0, 0, 0, 0, 0 },
/* U+3896 */ { 0, 0, 0, 0, 0 },
/* U+3897 */ { 0, 0, 0, 0, 0 },
/* U+3898 */ { 0, 0, 0, 0, 0 },
/* U+3899 */ { 0, 0, 0, 0, 0 },
/* U+389a */ { 0, 0, 0, 0, 0 },
/* U+389b */ { 0, 0, 0, 0, 0 },
/* U+389c */ { 0, 0, 0, 0, 0 },
/* U+389d */ { 0, 0, 0, 0, 0 },
/* U+389e */ { 0, 0, 0, 0, 0 },
/* U+389f */ { 0, 0, 0, 0, 0 },
/* U+38a0 */ { 0, 0, 0, 0, 0 },
/* U+38a1 */ { 0, 0, 0, 0, 0 },
/* U+38a2 */ { 0, 0, 0, 0, 0 },
/* U+38a3 */ { 0, 0, 0, 0, 0 },
/* U+38a4 */ { 0, 0, 0, 0, 0 },
/* U+38a5 */ { 0, 0, 0, 0, 0 },
/* U+38a6 */ { 0, 0, 0, 0, 0 },
/* U+38a7 */ { 0, 0, 0, 0, 0 },
/* U+38a8 */ { 0, 0, 0, 0, 0 },
/* U+38a9 */ { 0, 0, 0, 0, 0 },
/* U+38aa */ { 0, 0, 0, 0, 0 },
/* U+38ab */ { 0, 0, 0, 0, 0 },
/* U+38ac */ { 0, 0, 0, 0, 0 },
/* U+38ad */ { 0, 0, 0, 0, 0 },
/* U+38ae */ { 0, 0, 0, 0, 0 },
/* U+38af */ { 0, 0, 0, 0, 0 },
/* U+38b0 */ { 0, 0, 0, 0, 0 },
/* U+38b1 */ { 0, 0, 0, 0, 0 },
/* U+38b2 */ { 0, 0, 0, 0, 0 },
/* U+38b3 */ { 0, 0, 0, 0, 0 },
/* U+38b4 */ { 0, 0, 0, 0, 0 },
/* U+38b5 */ { 0, 0, 0, 0, 0 },
/* U+38b6 */ { 0, 0, 0, 0, 0 },
/* U+38b7 */ { 0, 0, 0, 0, 0 },
/* U+38b8 */ { 0, 0, 0, 0, 0 },
/* U+38b9 */ { 0, 0, 0, 0, 0 },
/* U+38ba */ { 0, 0, 0, 0, 0 },
/* U+38bb */ { 0, 0, 0, 0, 0 },
/* U+38bc */ { 0, 0, 0, 0, 0 },
/* U+38bd */ { 0, 0, 0, 0, 0 },
/* U+38be */ { 0, 0, 0, 0, 0 },
/* U+38bf */ { 0, 0, 0, 0, 0 },
/* U+38c0 */ { 0, 0, 0, 0, 0 },
/* U+38c1 */ { 0, 0, 0, 0, 0 },
/* U+38c2 */ { 0, 0, 0, 0, 0 },
/* U+38c3 */ { 0, 0, 0, 0, 0 },
/* U+38c4 */ { 0, 0, 0, 0, 0 },
/* U+38c5 */ { 0, 0, 0, 0, 0 },
/* U+38c6 */ { 0, 0, 0, 0, 0 },
/* U+38c7 */ { 0, 0, 0, 0, 0 },
/* U+38c8 */ { 0, 0, 0, 0, 0 },
/* U+38c9 */ { 0, 0, 0, 0, 0 },
/* U+38ca */ { 0, 0, 0, 0, 0 },
/* U+38cb */ { 0, 0, 0, 0, 0 },
/* U+38cc */ { 0, 0, 0, 0, 0 },
/* U+38cd */ { 0, 0, 0, 0, 0 },
/* U+38ce */ { 0, 0, 0, 0, 0 },
/* U+38cf */ { 0, 0, 0, 0, 0 },
/* U+38d0 */ { 0, 0, 0, 0, 0 },
/* U+38d1 */ { 0, 0, 0, 0, 0 },
/* U+38d2 */ { 0, 0, 0, 0, 0 },
/* U+38d3 */ { 0, 0, 0, 0, 0 },
/* U+38d4 */ { 0, 0, 0, 0, 0 },
/* U+38d5 */ { 0, 0, 0, 0, 0 },
/* U+38d6 */ { 0, 0, 0, 0, 0 },
/* U+38d7 */ { 0, 0, 0, 0, 0 },
/* U+38d8 */ { 0, 0, 0, 0, 0 },
/* U+38d9 */ { 0, 0, 0, 0, 0 },
/* U+38da */ { 0, 0, 0, 0, 0 },
/* U+38db */ { 0, 0, 0, 0, 0 },
/* U+38dc */ { 0, 0, 0, 0, 0 },
/* U+38dd */ { 0, 0, 0, 0, 0 },
/* U+38de */ { 0, 0, 0, 0, 0 },
/* U+38df */ { 0, 0, 0, 0, 0 },
/* U+38e0 */ { 0, 0, 0, 0, 0 },
/* U+38e1 */ { 0, 0, 0, 0, 0 },
/* U+38e2 */ { 0, 0, 0, 0, 0 },
/* U+38e3 */ { 0, 0, 0, 0, 0 },
/* U+38e4 */ { 0, 0, 0, 0, 0 },
/* U+38e5 */ { 0, 0, 0, 0, 0 },
/* U+38e6 */ { 0, 0, 0, 0, 0 },
/* U+38e7 */ { 0, 0, 0, 0, 0 },
/* U+38e8 */ { 0, 0, 0, 0, 0 },
/* U+38e9 */ { 0, 0, 0, 0, 0 },
/* U+38ea */ { 0, 0, 0, 0, 0 },
/* U+38eb */ { 0, 0, 0, 0, 0 },
/* U+38ec */ { 0, 0, 0, 0, 0 },
/* U+38ed */ { 0, 0, 0, 0, 0 },
/* U+38ee */ { 0, 0, 0, 0, 0 },
/* U+38ef */ { 0, 0, 0, 0, 0 },
/* U+38f0 */ { 0, 0, 0, 0, 0 },
/* U+38f1 */ { 0, 0, 0, 0, 0 },
/* U+38f2 */ { 0, 0, 0, 0, 0 },
/* U+38f3 */ { 0, 0, 0, 0, 0 },
/* U+38f4 */ { 0, 0, 0, 0, 0 },
/* U+38f5 */ { 0, 0, 0, 0, 0 },
/* U+38f6 */ { 0, 0, 0, 0, 0 },
/* U+38f7 */ { 0, 0, 0, 0, 0 },
/* U+38f8 */ { 0, 0, 0, 0, 0 },
/* U+38f9 */ { 0, 0, 0, 0, 0 },
/* U+38fa */ { 0, 0, 0, 0, 0 },
/* U+38fb */ { 0, 0, 0, 0, 0 },
/* U+38fc */ { 0, 0, 0, 0, 0 },
/* U+38fd */ { 0, 0, 0, 0, 0 },
/* U+38fe */ { 0, 0, 0, 0, 0 },
/* U+38ff */ { 0, 0, 0, 0, 0 },
/* U+3900 */ { 0, 0, 0, 0, 0 },
/* U+3901 */ { 0, 0, 0, 0, 0 },
/* U+3902 */ { 0, 0, 0, 0, 0 },
/* U+3903 */ { 0, 0, 0, 0, 0 },
/* U+3904 */ { 0, 0, 0, 0, 0 },
/* U+3905 */ { 0, 0, 0, 0, 0 },
/* U+3906 */ { 0, 0, 0, 0, 0 },
/* U+3907 */ { 0, 0, 0, 0, 0 },
/* U+3908 */ { 0, 0, 0, 0, 0 },
/* U+3909 */ { 0, 0, 0, 0, 0 },
/* U+390a */ { 0, 0, 0, 0, 0 },
/* U+390b */ { 0, 0, 0, 0, 0 },
/* U+390c */ { 0, 0, 0, 0, 0 },
/* U+390d */ { 0, 0, 0, 0, 0 },
/* U+390e */ { 0, 0, 0, 0, 0 },
/* U+390f */ { 0, 0, 0, 0, 0 },
/* U+3910 */ { 0, 0, 0, 0, 0 },
/* U+3911 */ { 0, 0, 0, 0, 0 },
/* U+3912 */ { 0, 0, 0, 0, 0 },
/* U+3913 */ { 0, 0, 0, 0, 0 },
/* U+3914 */ { 0, 0, 0, 0, 0 },
/* U+3915 */ { 0, 0, 0, 0, 0 },
/* U+3916 */ { 0, 0, 0, 0, 0 },
/* U+3917 */ { 0, 0, 0, 0, 0 },
/* U+3918 */ { 0, 0, 0, 0, 0 },
/* U+3919 */ { 0, 0, 0, 0, 0 },
/* U+391a */ { 0, 0, 0, 0, 0 },
/* U+391b */ { 0, 0, 0, 0, 0 },
/* U+391c */ { 0, 0, 0, 0, 0 },
/* U+391d */ { 0, 0, 0, 0, 0 },
/* U+391e */ { 0, 0, 0, 0, 0 },
/* U+391f */ { 0, 0, 0, 0, 0 },
/* U+3920 */ { 0, 0, 0, 0, 0 },
/* U+3921 */ { 0, 0, 0, 0, 0 },
/* U+3922 */ { 0, 0, 0, 0, 0 },
/* U+3923 */ { 0, 0, 0, 0, 0 },
/* U+3924 */ { 0, 0, 0, 0, 0 },
/* U+3925 */ { 0, 0, 0, 0, 0 },
/* U+3926 */ { 0, 0, 0, 0, 0 },
/* U+3927 */ { 0, 0, 0, 0, 0 },
/* U+3928 */ { 0, 0, 0, 0, 0 },
/* U+3929 */ { 0, 0, 0, 0, 0 },
/* U+392a */ { 0, 0, 0, 0, 0 },
/* U+392b */ { 0, 0, 0, 0, 0 },
/* U+392c */ { 0, 0, 0, 0, 0 },
/* U+392d */ { 0, 0, 0, 0, 0 },
/* U+392e */ { 0, 0, 0, 0, 0 },
/* U+392f */ { 0, 0, 0, 0, 0 },
/* U+3930 */ { 0, 0, 0, 0, 0 },
/* U+3931 */ { 0, 0, 0, 0, 0 },
/* U+3932 */ { 0, 0, 0, 0, 0 },
/* U+3933 */ { 0, 0, 0, 0, 0 },
/* U+3934 */ { 0, 0, 0, 0, 0 },
/* U+3935 */ { 0, 0, 0, 0, 0 },
/* U+3936 */ { 0, 0, 0, 0, 0 },
/* U+3937 */ { 0, 0, 0, 0, 0 },
/* U+3938 */ { 0, 0, 0, 0, 0 },
/* U+3939 */ { 0, 0, 0, 0, 0 },
/* U+393a */ { 0, 0, 0, 0, 0 },
/* U+393b */ { 0, 0, 0, 0, 0 },
/* U+393c */ { 0, 0, 0, 0, 0 },
/* U+393d */ { 0, 0, 0, 0, 0 },
/* U+393e */ { 0, 0, 0, 0, 0 },
/* U+393f */ { 0, 0, 0, 0, 0 },
/* U+3940 */ { 0, 0, 0, 0, 0 },
/* U+3941 */ { 0, 0, 0, 0, 0 },
/* U+3942 */ { 0, 0, 0, 0, 0 },
/* U+3943 */ { 0, 0, 0, 0, 0 },
/* U+3944 */ { 0, 0, 0, 0, 0 },
/* U+3945 */ { 0, 0, 0, 0, 0 },
/* U+3946 */ { 0, 0, 0, 0, 0 },
/* U+3947 */ { 0, 0, 0, 0, 0 },
/* U+3948 */ { 0, 0, 0, 0, 0 },
/* U+3949 */ { 0, 0, 0, 0, 0 },
/* U+394a */ { 0, 0, 0, 0, 0 },
/* U+394b */ { 0, 0, 0, 0, 0 },
/* U+394c */ { 0, 0, 0, 0, 0 },
/* U+394d */ { 0, 0, 0, 0, 0 },
/* U+394e */ { 0, 0, 0, 0, 0 },
/* U+394f */ { 0, 0, 0, 0, 0 },
/* U+3950 */ { 0, 0, 0, 0, 0 },
/* U+3951 */ { 0, 0, 0, 0, 0 },
/* U+3952 */ { 0, 0, 0, 0, 0 },
/* U+3953 */ { 0, 0, 0, 0, 0 },
/* U+3954 */ { 0, 0, 0, 0, 0 },
/* U+3955 */ { 0, 0, 0, 0, 0 },
/* U+3956 */ { 0, 0, 0, 0, 0 },
/* U+3957 */ { 0, 0, 0, 0, 0 },
/* U+3958 */ { 0, 0, 0, 0, 0 },
/* U+3959 */ { 0, 0, 0, 0, 0 },
/* U+395a */ { 0, 0, 0, 0, 0 },
/* U+395b */ { 0, 0, 0, 0, 0 },
/* U+395c */ { 0, 0, 0, 0, 0 },
/* U+395d */ { 0, 0, 0, 0, 0 },
/* U+395e */ { 0, 0, 0, 0, 0 },
/* U+395f */ { 0, 0, 0, 0, 0 },
/* U+3960 */ { 0, 0, 0, 0, 0 },
/* U+3961 */ { 0, 0, 0, 0, 0 },
/* U+3962 */ { 0, 0, 0, 0, 0 },
/* U+3963 */ { 0, 0, 0, 0, 0 },
/* U+3964 */ { 0, 0, 0, 0, 0 },
/* U+3965 */ { 0, 0, 0, 0, 0 },
/* U+3966 */ { 0, 0, 0, 0, 0 },
/* U+3967 */ { 0, 0, 0, 0, 0 },
/* U+3968 */ { 0, 0, 0, 0, 0 },
/* U+3969 */ { 0, 0, 0, 0, 0 },
/* U+396a */ { 0, 0, 0, 0, 0 },
/* U+396b */ { 0, 0, 0, 0, 0 },
/* U+396c */ { 0, 0, 0, 0, 0 },
/* U+396d */ { 0, 0, 0, 0, 0 },
/* U+396e */ { 0, 0, 0, 0, 0 },
/* U+396f */ { 0, 0, 0, 0, 0 },
/* U+3970 */ { 0, 0, 0, 0, 0 },
/* U+3971 */ { 0, 0, 0, 0, 0 },
/* U+3972 */ { 0, 0, 0, 0, 0 },
/* U+3973 */ { 0, 0, 0, 0, 0 },
/* U+3974 */ { 0, 0, 0, 0, 0 },
/* U+3975 */ { 0, 0, 0, 0, 0 },
/* U+3976 */ { 0, 0, 0, 0, 0 },
/* U+3977 */ { 0, 0, 0, 0, 0 },
/* U+3978 */ { 0, 0, 0, 0, 0 },
/* U+3979 */ { 0, 0, 0, 0, 0 },
/* U+397a */ { 0, 0, 0, 0, 0 },
/* U+397b */ { 0, 0, 0, 0, 0 },
/* U+397c */ { 0, 0, 0, 0, 0 },
/* U+397d */ { 0, 0, 0, 0, 0 },
/* U+397e */ { 0, 0, 0, 0, 0 },
/* U+397f */ { 0, 0, 0, 0, 0 },
/* U+3980 */ { 0, 0, 0, 0, 0 },
/* U+3981 */ { 0, 0, 0, 0, 0 },
/* U+3982 */ { 0, 0, 0, 0, 0 },
/* U+3983 */ { 0, 0, 0, 0, 0 },
/* U+3984 */ { 0, 0, 0, 0, 0 },
/* U+3985 */ { 0, 0, 0, 0, 0 },
/* U+3986 */ { 0, 0, 0, 0, 0 },
/* U+3987 */ { 0, 0, 0, 0, 0 },
/* U+3988 */ { 0, 0, 0, 0, 0 },
/* U+3989 */ { 0, 0, 0, 0, 0 },
/* U+398a */ { 0, 0, 0, 0, 0 },
/* U+398b */ { 0, 0, 0, 0, 0 },
/* U+398c */ { 0, 0, 0, 0, 0 },
/* U+398d */ { 0, 0, 0, 0, 0 },
/* U+398e */ { 0, 0, 0, 0, 0 },
/* U+398f */ { 0, 0, 0, 0, 0 },
/* U+3990 */ { 0, 0, 0, 0, 0 },
/* U+3991 */ { 0, 0, 0, 0, 0 },
/* U+3992 */ { 0, 0, 0, 0, 0 },
/* U+3993 */ { 0, 0, 0, 0, 0 },
/* U+3994 */ { 0, 0, 0, 0, 0 },
/* U+3995 */ { 0, 0, 0, 0, 0 },
/* U+3996 */ { 0, 0, 0, 0, 0 },
/* U+3997 */ { 0, 0, 0, 0, 0 },
/* U+3998 */ { 0, 0, 0, 0, 0 },
/* U+3999 */ { 0, 0, 0, 0, 0 },
/* U+399a */ { 0, 0, 0, 0, 0 },
/* U+399b */ { 0, 0, 0, 0, 0 },
/* U+399c */ { 0, 0, 0, 0, 0 },
/* U+399d */ { 0, 0, 0, 0, 0 },
/* U+399e */ { 0, 0, 0, 0, 0 },
/* U+399f */ { 0, 0, 0, 0, 0 },
/* U+39a0 */ { 0, 0, 0, 0, 0 },
/* U+39a1 */ { 0, 0, 0, 0, 0 },
/* U+39a2 */ { 0, 0, 0, 0, 0 },
/* U+39a3 */ { 0, 0, 0, 0, 0 },
/* U+39a4 */ { 0, 0, 0, 0, 0 },
/* U+39a5 */ { 0, 0, 0, 0, 0 },
/* U+39a6 */ { 0, 0, 0, 0, 0 },
/* U+39a7 */ { 0, 0, 0, 0, 0 },
/* U+39a8 */ { 0, 0, 0, 0, 0 },
/* U+39a9 */ { 0, 0, 0, 0, 0 },
/* U+39aa */ { 0, 0, 0, 0, 0 },
/* U+39ab */ { 0, 0, 0, 0, 0 },
/* U+39ac */ { 0, 0, 0, 0, 0 },
/* U+39ad */ { 0, 0, 0, 0, 0 },
/* U+39ae */ { 0, 0, 0, 0, 0 },
/* U+39af */ { 0, 0, 0, 0, 0 },
/* U+39b0 */ { 0, 0, 0, 0, 0 },
/* U+39b1 */ { 0, 0, 0, 0, 0 },
/* U+39b2 */ { 0, 0, 0, 0, 0 },
/* U+39b3 */ { 0, 0, 0, 0, 0 },
/* U+39b4 */ { 0, 0, 0, 0, 0 },
/* U+39b5 */ { 0, 0, 0, 0, 0 },
/* U+39b6 */ { 0, 0, 0, 0, 0 },
/* U+39b7 */ { 0, 0, 0, 0, 0 },
/* U+39b8 */ { 0, 0, 0, 0, 0 },
/* U+39b9 */ { 0, 0, 0, 0, 0 },
/* U+39ba */ { 0, 0, 0, 0, 0 },
/* U+39bb */ { 0, 0, 0, 0, 0 },
/* U+39bc */ { 0, 0, 0, 0, 0 },
/* U+39bd */ { 0, 0, 0, 0, 0 },
/* U+39be */ { 0, 0, 0, 0, 0 },
/* U+39bf */ { 0, 0, 0, 0, 0 },
/* U+39c0 */ { 0, 0, 0, 0, 0 },
/* U+39c1 */ { 0, 0, 0, 0, 0 },
/* U+39c2 */ { 0, 0, 0, 0, 0 },
/* U+39c3 */ { 0, 0, 0, 0, 0 },
/* U+39c4 */ { 0, 0, 0, 0, 0 },
/* U+39c5 */ { 0, 0, 0, 0, 0 },
/* U+39c6 */ { 0, 0, 0, 0, 0 },
/* U+39c7 */ { 0, 0, 0, 0, 0 },
/* U+39c8 */ { 0, 0, 0, 0, 0 },
/* U+39c9 */ { 0, 0, 0, 0, 0 },
/* U+39ca */ { 0, 0, 0, 0, 0 },
/* U+39cb */ { 0, 0, 0, 0, 0 },
/* U+39cc */ { 0, 0, 0, 0, 0 },
/* U+39cd */ { 0, 0, 0, 0, 0 },
/* U+39ce */ { 0, 0, 0, 0, 0 },
/* U+39cf */ { 0, 0, 0, 0, 0 },
/* U+39d0 */ { 0, 0, 0, 0, 0 },
/* U+39d1 */ { 0, 0, 0, 0, 0 },
/* U+39d2 */ { 0, 0, 0, 0, 0 },
/* U+39d3 */ { 0, 0, 0, 0, 0 },
/* U+39d4 */ { 0, 0, 0, 0, 0 },
/* U+39d5 */ { 0, 0, 0, 0, 0 },
/* U+39d6 */ { 0, 0, 0, 0, 0 },
/* U+39d7 */ { 0, 0, 0, 0, 0 },
/* U+39d8 */ { 0, 0, 0, 0, 0 },
/* U+39d9 */ { 0, 0, 0, 0, 0 },
/* U+39da */ { 0, 0, 0, 0, 0 },
/* U+39db */ { 0, 0, 0, 0, 0 },
/* U+39dc */ { 0, 0, 0, 0, 0 },
/* U+39dd */ { 0, 0, 0, 0, 0 },
/* U+39de */ { 0, 0, 0, 0, 0 },
/* U+39df */ { 0, 0, 0, 0, 0 },
/* U+39e0 */ { 0, 0, 0, 0, 0 },
/* U+39e1 */ { 0, 0, 0, 0, 0 },
/* U+39e2 */ { 0, 0, 0, 0, 0 },
/* U+39e3 */ { 0, 0, 0, 0, 0 },
/* U+39e4 */ { 0, 0, 0, 0, 0 },
/* U+39e5 */ { 0, 0, 0, 0, 0 },
/* U+39e6 */ { 0, 0, 0, 0, 0 },
/* U+39e7 */ { 0, 0, 0, 0, 0 },
/* U+39e8 */ { 0, 0, 0, 0, 0 },
/* U+39e9 */ { 0, 0, 0, 0, 0 },
/* U+39ea */ { 0, 0, 0, 0, 0 },
/* U+39eb */ { 0, 0, 0, 0, 0 },
/* U+39ec */ { 0, 0, 0, 0, 0 },
/* U+39ed */ { 0, 0, 0, 0, 0 },
/* U+39ee */ { 0, 0, 0, 0, 0 },
/* U+39ef */ { 0, 0, 0, 0, 0 },
/* U+39f0 */ { 0, 0, 0, 0, 0 },
/* U+39f1 */ { 0, 0, 0, 0, 0 },
/* U+39f2 */ { 0, 0, 0, 0, 0 },
/* U+39f3 */ { 0, 0, 0, 0, 0 },
/* U+39f4 */ { 0, 0, 0, 0, 0 },
/* U+39f5 */ { 0, 0, 0, 0, 0 },
/* U+39f6 */ { 0, 0, 0, 0, 0 },
/* U+39f7 */ { 0, 0, 0, 0, 0 },
/* U+39f8 */ { 0, 0, 0, 0, 0 },
/* U+39f9 */ { 0, 0, 0, 0, 0 },
/* U+39fa */ { 0, 0, 0, 0, 0 },
/* U+39fb */ { 0, 0, 0, 0, 0 },
/* U+39fc */ { 0, 0, 0, 0, 0 },
/* U+39fd */ { 0, 0, 0, 0, 0 },
/* U+39fe */ { 0, 0, 0, 0, 0 },
/* U+39ff */ { 0, 0, 0, 0, 0 },
/* U+3a00 */ { 0, 0, 0, 0, 0 },
/* U+3a01 */ { 0, 0, 0, 0, 0 },
/* U+3a02 */ { 0, 0, 0, 0, 0 },
/* U+3a03 */ { 0, 0, 0, 0, 0 },
/* U+3a04 */ { 0, 0, 0, 0, 0 },
/* U+3a05 */ { 0, 0, 0, 0, 0 },
/* U+3a06 */ { 0, 0, 0, 0, 0 },
/* U+3a07 */ { 0, 0, 0, 0, 0 },
/* U+3a08 */ { 0, 0, 0, 0, 0 },
/* U+3a09 */ { 0, 0, 0, 0, 0 },
/* U+3a0a */ { 0, 0, 0, 0, 0 },
/* U+3a0b */ { 0, 0, 0, 0, 0 },
/* U+3a0c */ { 0, 0, 0, 0, 0 },
/* U+3a0d */ { 0, 0, 0, 0, 0 },
/* U+3a0e */ { 0, 0, 0, 0, 0 },
/* U+3a0f */ { 0, 0, 0, 0, 0 },
/* U+3a10 */ { 0, 0, 0, 0, 0 },
/* U+3a11 */ { 0, 0, 0, 0, 0 },
/* U+3a12 */ { 0, 0, 0, 0, 0 },
/* U+3a13 */ { 0, 0, 0, 0, 0 },
/* U+3a14 */ { 0, 0, 0, 0, 0 },
/* U+3a15 */ { 0, 0, 0, 0, 0 },
/* U+3a16 */ { 0, 0, 0, 0, 0 },
/* U+3a17 */ { 0, 0, 0, 0, 0 },
/* U+3a18 */ { 0, 0, 0, 0, 0 },
/* U+3a19 */ { 0, 0, 0, 0, 0 },
/* U+3a1a */ { 0, 0, 0, 0, 0 },
/* U+3a1b */ { 0, 0, 0, 0, 0 },
/* U+3a1c */ { 0, 0, 0, 0, 0 },
/* U+3a1d */ { 0, 0, 0, 0, 0 },
/* U+3a1e */ { 0, 0, 0, 0, 0 },
/* U+3a1f */ { 0, 0, 0, 0, 0 },
/* U+3a20 */ { 0, 0, 0, 0, 0 },
/* U+3a21 */ { 0, 0, 0, 0, 0 },
/* U+3a22 */ { 0, 0, 0, 0, 0 },
/* U+3a23 */ { 0, 0, 0, 0, 0 },
/* U+3a24 */ { 0, 0, 0, 0, 0 },
/* U+3a25 */ { 0, 0, 0, 0, 0 },
/* U+3a26 */ { 0, 0, 0, 0, 0 },
/* U+3a27 */ { 0, 0, 0, 0, 0 },
/* U+3a28 */ { 0, 0, 0, 0, 0 },
/* U+3a29 */ { 0, 0, 0, 0, 0 },
/* U+3a2a */ { 0, 0, 0, 0, 0 },
/* U+3a2b */ { 0, 0, 0, 0, 0 },
/* U+3a2c */ { 0, 0, 0, 0, 0 },
/* U+3a2d */ { 0, 0, 0, 0, 0 },
/* U+3a2e */ { 0, 0, 0, 0, 0 },
/* U+3a2f */ { 0, 0, 0, 0, 0 },
/* U+3a30 */ { 0, 0, 0, 0, 0 },
/* U+3a31 */ { 0, 0, 0, 0, 0 },
/* U+3a32 */ { 0, 0, 0, 0, 0 },
/* U+3a33 */ { 0, 0, 0, 0, 0 },
/* U+3a34 */ { 0, 0, 0, 0, 0 },
/* U+3a35 */ { 0, 0, 0, 0, 0 },
/* U+3a36 */ { 0, 0, 0, 0, 0 },
/* U+3a37 */ { 0, 0, 0, 0, 0 },
/* U+3a38 */ { 0, 0, 0, 0, 0 },
/* U+3a39 */ { 0, 0, 0, 0, 0 },
/* U+3a3a */ { 0, 0, 0, 0, 0 },
/* U+3a3b */ { 0, 0, 0, 0, 0 },
/* U+3a3c */ { 0, 0, 0, 0, 0 },
/* U+3a3d */ { 0, 0, 0, 0, 0 },
/* U+3a3e */ { 0, 0, 0, 0, 0 },
/* U+3a3f */ { 0, 0, 0, 0, 0 },
/* U+3a40 */ { 0, 0, 0, 0, 0 },
/* U+3a41 */ { 0, 0, 0, 0, 0 },
/* U+3a42 */ { 0, 0, 0, 0, 0 },
/* U+3a43 */ { 0, 0, 0, 0, 0 },
/* U+3a44 */ { 0, 0, 0, 0, 0 },
/* U+3a45 */ { 0, 0, 0, 0, 0 },
/* U+3a46 */ { 0, 0, 0, 0, 0 },
/* U+3a47 */ { 0, 0, 0, 0, 0 },
/* U+3a48 */ { 0, 0, 0, 0, 0 },
/* U+3a49 */ { 0, 0, 0, 0, 0 },
/* U+3a4a */ { 0, 0, 0, 0, 0 },
/* U+3a4b */ { 0, 0, 0, 0, 0 },
/* U+3a4c */ { 0, 0, 0, 0, 0 },
/* U+3a4d */ { 0, 0, 0, 0, 0 },
/* U+3a4e */ { 0, 0, 0, 0, 0 },
/* U+3a4f */ { 0, 0, 0, 0, 0 },
/* U+3a50 */ { 0, 0, 0, 0, 0 },
/* U+3a51 */ { 0, 0, 0, 0, 0 },
/* U+3a52 */ { 0, 0, 0, 0, 0 },
/* U+3a53 */ { 0, 0, 0, 0, 0 },
/* U+3a54 */ { 0, 0, 0, 0, 0 },
/* U+3a55 */ { 0, 0, 0, 0, 0 },
/* U+3a56 */ { 0, 0, 0, 0, 0 },
/* U+3a57 */ { 0, 0, 0, 0, 0 },
/* U+3a58 */ { 0, 0, 0, 0, 0 },
/* U+3a59 */ { 0, 0, 0, 0, 0 },
/* U+3a5a */ { 0, 0, 0, 0, 0 },
/* U+3a5b */ { 0, 0, 0, 0, 0 },
/* U+3a5c */ { 0, 0, 0, 0, 0 },
/* U+3a5d */ { 0, 0, 0, 0, 0 },
/* U+3a5e */ { 0, 0, 0, 0, 0 },
/* U+3a5f */ { 0, 0, 0, 0, 0 },
/* U+3a60 */ { 0, 0, 0, 0, 0 },
/* U+3a61 */ { 0, 0, 0, 0, 0 },
/* U+3a62 */ { 0, 0, 0, 0, 0 },
/* U+3a63 */ { 0, 0, 0, 0, 0 },
/* U+3a64 */ { 0, 0, 0, 0, 0 },
/* U+3a65 */ { 0, 0, 0, 0, 0 },
/* U+3a66 */ { 0, 0, 0, 0, 0 },
/* U+3a67 */ { 0, 0, 0, 0, 0 },
/* U+3a68 */ { 0, 0, 0, 0, 0 },
/* U+3a69 */ { 0, 0, 0, 0, 0 },
/* U+3a6a */ { 0, 0, 0, 0, 0 },
/* U+3a6b */ { 0, 0, 0, 0, 0 },
/* U+3a6c */ { 0, 0, 0, 0, 0 },
/* U+3a6d */ { 0, 0, 0, 0, 0 },
/* U+3a6e */ { 0, 0, 0, 0, 0 },
/* U+3a6f */ { 0, 0, 0, 0, 0 },
/* U+3a70 */ { 0, 0, 0, 0, 0 },
/* U+3a71 */ { 0, 0, 0, 0, 0 },
/* U+3a72 */ { 0, 0, 0, 0, 0 },
/* U+3a73 */ { 0, 0, 0, 0, 0 },
/* U+3a74 */ { 0, 0, 0, 0, 0 },
/* U+3a75 */ { 0, 0, 0, 0, 0 },
/* U+3a76 */ { 0, 0, 0, 0, 0 },
/* U+3a77 */ { 0, 0, 0, 0, 0 },
/* U+3a78 */ { 0, 0, 0, 0, 0 },
/* U+3a79 */ { 0, 0, 0, 0, 0 },
/* U+3a7a */ { 0, 0, 0, 0, 0 },
/* U+3a7b */ { 0, 0, 0, 0, 0 },
/* U+3a7c */ { 0, 0, 0, 0, 0 },
/* U+3a7d */ { 0, 0, 0, 0, 0 },
/* U+3a7e */ { 0, 0, 0, 0, 0 },
/* U+3a7f */ { 0, 0, 0, 0, 0 },
/* U+3a80 */ { 0, 0, 0, 0, 0 },
/* U+3a81 */ { 0, 0, 0, 0, 0 },
/* U+3a82 */ { 0, 0, 0, 0, 0 },
/* U+3a83 */ { 0, 0, 0, 0, 0 },
/* U+3a84 */ { 0, 0, 0, 0, 0 },
/* U+3a85 */ { 0, 0, 0, 0, 0 },
/* U+3a86 */ { 0, 0, 0, 0, 0 },
/* U+3a87 */ { 0, 0, 0, 0, 0 },
/* U+3a88 */ { 0, 0, 0, 0, 0 },
/* U+3a89 */ { 0, 0, 0, 0, 0 },
/* U+3a8a */ { 0, 0, 0, 0, 0 },
/* U+3a8b */ { 0, 0, 0, 0, 0 },
/* U+3a8c */ { 0, 0, 0, 0, 0 },
/* U+3a8d */ { 0, 0, 0, 0, 0 },
/* U+3a8e */ { 0, 0, 0, 0, 0 },
/* U+3a8f */ { 0, 0, 0, 0, 0 },
/* U+3a90 */ { 0, 0, 0, 0, 0 },
/* U+3a91 */ { 0, 0, 0, 0, 0 },
/* U+3a92 */ { 0, 0, 0, 0, 0 },
/* U+3a93 */ { 0, 0, 0, 0, 0 },
/* U+3a94 */ { 0, 0, 0, 0, 0 },
/* U+3a95 */ { 0, 0, 0, 0, 0 },
/* U+3a96 */ { 0, 0, 0, 0, 0 },
/* U+3a97 */ { 0, 0, 0, 0, 0 },
/* U+3a98 */ { 0, 0, 0, 0, 0 },
/* U+3a99 */ { 0, 0, 0, 0, 0 },
/* U+3a9a */ { 0, 0, 0, 0, 0 },
/* U+3a9b */ { 0, 0, 0, 0, 0 },
/* U+3a9c */ { 0, 0, 0, 0, 0 },
/* U+3a9d */ { 0, 0, 0, 0, 0 },
/* U+3a9e */ { 0, 0, 0, 0, 0 },
/* U+3a9f */ { 0, 0, 0, 0, 0 },
/* U+3aa0 */ { 0, 0, 0, 0, 0 },
/* U+3aa1 */ { 0, 0, 0, 0, 0 },
/* U+3aa2 */ { 0, 0, 0, 0, 0 },
/* U+3aa3 */ { 0, 0, 0, 0, 0 },
/* U+3aa4 */ { 0, 0, 0, 0, 0 },
/* U+3aa5 */ { 0, 0, 0, 0, 0 },
/* U+3aa6 */ { 0, 0, 0, 0, 0 },
/* U+3aa7 */ { 0, 0, 0, 0, 0 },
/* U+3aa8 */ { 0, 0, 0, 0, 0 },
/* U+3aa9 */ { 0, 0, 0, 0, 0 },
/* U+3aaa */ { 0, 0, 0, 0, 0 },
/* U+3aab */ { 0, 0, 0, 0, 0 },
/* U+3aac */ { 0, 0, 0, 0, 0 },
/* U+3aad */ { 0, 0, 0, 0, 0 },
/* U+3aae */ { 0, 0, 0, 0, 0 },
/* U+3aaf */ { 0, 0, 0, 0, 0 },
/* U+3ab0 */ { 0, 0, 0, 0, 0 },
/* U+3ab1 */ { 0, 0, 0, 0, 0 },
/* U+3ab2 */ { 0, 0, 0, 0, 0 },
/* U+3ab3 */ { 0, 0, 0, 0, 0 },
/* U+3ab4 */ { 0, 0, 0, 0, 0 },
/* U+3ab5 */ { 0, 0, 0, 0, 0 },
/* U+3ab6 */ { 0, 0, 0, 0, 0 },
/* U+3ab7 */ { 0, 0, 0, 0, 0 },
/* U+3ab8 */ { 0, 0, 0, 0, 0 },
/* U+3ab9 */ { 0, 0, 0, 0, 0 },
/* U+3aba */ { 0, 0, 0, 0, 0 },
/* U+3abb */ { 0, 0, 0, 0, 0 },
/* U+3abc */ { 0, 0, 0, 0, 0 },
/* U+3abd */ { 0, 0, 0, 0, 0 },
/* U+3abe */ { 0, 0, 0, 0, 0 },
/* U+3abf */ { 0, 0, 0, 0, 0 },
/* U+3ac0 */ { 0, 0, 0, 0, 0 },
/* U+3ac1 */ { 0, 0, 0, 0, 0 },
/* U+3ac2 */ { 0, 0, 0, 0, 0 },
/* U+3ac3 */ { 0, 0, 0, 0, 0 },
/* U+3ac4 */ { 0, 0, 0, 0, 0 },
/* U+3ac5 */ { 0, 0, 0, 0, 0 },
/* U+3ac6 */ { 0, 0, 0, 0, 0 },
/* U+3ac7 */ { 0, 0, 0, 0, 0 },
/* U+3ac8 */ { 0, 0, 0, 0, 0 },
/* U+3ac9 */ { 0, 0, 0, 0, 0 },
/* U+3aca */ { 0, 0, 0, 0, 0 },
/* U+3acb */ { 0, 0, 0, 0, 0 },
/* U+3acc */ { 0, 0, 0, 0, 0 },
/* U+3acd */ { 0, 0, 0, 0, 0 },
/* U+3ace */ { 0, 0, 0, 0, 0 },
/* U+3acf */ { 0, 0, 0, 0, 0 },
/* U+3ad0 */ { 0, 0, 0, 0, 0 },
/* U+3ad1 */ { 0, 0, 0, 0, 0 },
/* U+3ad2 */ { 0, 0, 0, 0, 0 },
/* U+3ad3 */ { 0, 0, 0, 0, 0 },
/* U+3ad4 */ { 0, 0, 0, 0, 0 },
/* U+3ad5 */ { 0, 0, 0, 0, 0 },
/* U+3ad6 */ { 0, 0, 0, 0, 0 },
/* U+3ad7 */ { 0, 0, 0, 0, 0 },
/* U+3ad8 */ { 0, 0, 0, 0, 0 },
/* U+3ad9 */ { 0, 0, 0, 0, 0 },
/* U+3ada */ { 0, 0, 0, 0, 0 },
/* U+3adb */ { 0, 0, 0, 0, 0 },
/* U+3adc */ { 0, 0, 0, 0, 0 },
/* U+3add */ { 0, 0, 0, 0, 0 },
/* U+3ade */ { 0, 0, 0, 0, 0 },
/* U+3adf */ { 0, 0, 0, 0, 0 },
/* U+3ae0 */ { 0, 0, 0, 0, 0 },
/* U+3ae1 */ { 0, 0, 0, 0, 0 },
/* U+3ae2 */ { 0, 0, 0, 0, 0 },
/* U+3ae3 */ { 0, 0, 0, 0, 0 },
/* U+3ae4 */ { 0, 0, 0, 0, 0 },
/* U+3ae5 */ { 0, 0, 0, 0, 0 },
/* U+3ae6 */ { 0, 0, 0, 0, 0 },
/* U+3ae7 */ { 0, 0, 0, 0, 0 },
/* U+3ae8 */ { 0, 0, 0, 0, 0 },
/* U+3ae9 */ { 0, 0, 0, 0, 0 },
/* U+3aea */ { 0, 0, 0, 0, 0 },
/* U+3aeb */ { 0, 0, 0, 0, 0 },
/* U+3aec */ { 0, 0, 0, 0, 0 },
/* U+3aed */ { 0, 0, 0, 0, 0 },
/* U+3aee */ { 0, 0, 0, 0, 0 },
/* U+3aef */ { 0, 0, 0, 0, 0 },
/* U+3af0 */ { 0, 0, 0, 0, 0 },
/* U+3af1 */ { 0, 0, 0, 0, 0 },
/* U+3af2 */ { 0, 0, 0, 0, 0 },
/* U+3af3 */ { 0, 0, 0, 0, 0 },
/* U+3af4 */ { 0, 0, 0, 0, 0 },
/* U+3af5 */ { 0, 0, 0, 0, 0 },
/* U+3af6 */ { 0, 0, 0, 0, 0 },
/* U+3af7 */ { 0, 0, 0, 0, 0 },
/* U+3af8 */ { 0, 0, 0, 0, 0 },
/* U+3af9 */ { 0, 0, 0, 0, 0 },
/* U+3afa */ { 0, 0, 0, 0, 0 },
/* U+3afb */ { 0, 0, 0, 0, 0 },
/* U+3afc */ { 0, 0, 0, 0, 0 },
/* U+3afd */ { 0, 0, 0, 0, 0 },
/* U+3afe */ { 0, 0, 0, 0, 0 },
/* U+3aff */ { 0, 0, 0, 0, 0 },
/* U+3b00 */ { 0, 0, 0, 0, 0 },
/* U+3b01 */ { 0, 0, 0, 0, 0 },
/* U+3b02 */ { 0, 0, 0, 0, 0 },
/* U+3b03 */ { 0, 0, 0, 0, 0 },
/* U+3b04 */ { 0, 0, 0, 0, 0 },
/* U+3b05 */ { 0, 0, 0, 0, 0 },
/* U+3b06 */ { 0, 0, 0, 0, 0 },
/* U+3b07 */ { 0, 0, 0, 0, 0 },
/* U+3b08 */ { 0, 0, 0, 0, 0 },
/* U+3b09 */ { 0, 0, 0, 0, 0 },
/* U+3b0a */ { 0, 0, 0, 0, 0 },
/* U+3b0b */ { 0, 0, 0, 0, 0 },
/* U+3b0c */ { 0, 0, 0, 0, 0 },
/* U+3b0d */ { 0, 0, 0, 0, 0 },
/* U+3b0e */ { 0, 0, 0, 0, 0 },
/* U+3b0f */ { 0, 0, 0, 0, 0 },
/* U+3b10 */ { 0, 0, 0, 0, 0 },
/* U+3b11 */ { 0, 0, 0, 0, 0 },
/* U+3b12 */ { 0, 0, 0, 0, 0 },
/* U+3b13 */ { 0, 0, 0, 0, 0 },
/* U+3b14 */ { 0, 0, 0, 0, 0 },
/* U+3b15 */ { 0, 0, 0, 0, 0 },
/* U+3b16 */ { 0, 0, 0, 0, 0 },
/* U+3b17 */ { 0, 0, 0, 0, 0 },
/* U+3b18 */ { 0, 0, 0, 0, 0 },
/* U+3b19 */ { 0, 0, 0, 0, 0 },
/* U+3b1a */ { 0, 0, 0, 0, 0 },
/* U+3b1b */ { 0, 0, 0, 0, 0 },
/* U+3b1c */ { 0, 0, 0, 0, 0 },
/* U+3b1d */ { 0, 0, 0, 0, 0 },
/* U+3b1e */ { 0, 0, 0, 0, 0 },
/* U+3b1f */ { 0, 0, 0, 0, 0 },
/* U+3b20 */ { 0, 0, 0, 0, 0 },
/* U+3b21 */ { 0, 0, 0, 0, 0 },
/* U+3b22 */ { 0, 0, 0, 0, 0 },
/* U+3b23 */ { 0, 0, 0, 0, 0 },
/* U+3b24 */ { 0, 0, 0, 0, 0 },
/* U+3b25 */ { 0, 0, 0, 0, 0 },
/* U+3b26 */ { 0, 0, 0, 0, 0 },
/* U+3b27 */ { 0, 0, 0, 0, 0 },
/* U+3b28 */ { 0, 0, 0, 0, 0 },
/* U+3b29 */ { 0, 0, 0, 0, 0 },
/* U+3b2a */ { 0, 0, 0, 0, 0 },
/* U+3b2b */ { 0, 0, 0, 0, 0 },
/* U+3b2c */ { 0, 0, 0, 0, 0 },
/* U+3b2d */ { 0, 0, 0, 0, 0 },
/* U+3b2e */ { 0, 0, 0, 0, 0 },
/* U+3b2f */ { 0, 0, 0, 0, 0 },
/* U+3b30 */ { 0, 0, 0, 0, 0 },
/* U+3b31 */ { 0, 0, 0, 0, 0 },
/* U+3b32 */ { 0, 0, 0, 0, 0 },
/* U+3b33 */ { 0, 0, 0, 0, 0 },
/* U+3b34 */ { 0, 0, 0, 0, 0 },
/* U+3b35 */ { 0, 0, 0, 0, 0 },
/* U+3b36 */ { 0, 0, 0, 0, 0 },
/* U+3b37 */ { 0, 0, 0, 0, 0 },
/* U+3b38 */ { 0, 0, 0, 0, 0 },
/* U+3b39 */ { 0, 0, 0, 0, 0 },
/* U+3b3a */ { 0, 0, 0, 0, 0 },
/* U+3b3b */ { 0, 0, 0, 0, 0 },
/* U+3b3c */ { 0, 0, 0, 0, 0 },
/* U+3b3d */ { 0, 0, 0, 0, 0 },
/* U+3b3e */ { 0, 0, 0, 0, 0 },
/* U+3b3f */ { 0, 0, 0, 0, 0 },
/* U+3b40 */ { 0, 0, 0, 0, 0 },
/* U+3b41 */ { 0, 0, 0, 0, 0 },
/* U+3b42 */ { 0, 0, 0, 0, 0 },
/* U+3b43 */ { 0, 0, 0, 0, 0 },
/* U+3b44 */ { 0, 0, 0, 0, 0 },
/* U+3b45 */ { 0, 0, 0, 0, 0 },
/* U+3b46 */ { 0, 0, 0, 0, 0 },
/* U+3b47 */ { 0, 0, 0, 0, 0 },
/* U+3b48 */ { 0, 0, 0, 0, 0 },
/* U+3b49 */ { 0, 0, 0, 0, 0 },
/* U+3b4a */ { 0, 0, 0, 0, 0 },
/* U+3b4b */ { 0, 0, 0, 0, 0 },
/* U+3b4c */ { 0, 0, 0, 0, 0 },
/* U+3b4d */ { 0, 0, 0, 0, 0 },
/* U+3b4e */ { 0, 0, 0, 0, 0 },
/* U+3b4f */ { 0, 0, 0, 0, 0 },
/* U+3b50 */ { 0, 0, 0, 0, 0 },
/* U+3b51 */ { 0, 0, 0, 0, 0 },
/* U+3b52 */ { 0, 0, 0, 0, 0 },
/* U+3b53 */ { 0, 0, 0, 0, 0 },
/* U+3b54 */ { 0, 0, 0, 0, 0 },
/* U+3b55 */ { 0, 0, 0, 0, 0 },
/* U+3b56 */ { 0, 0, 0, 0, 0 },
/* U+3b57 */ { 0, 0, 0, 0, 0 },
/* U+3b58 */ { 0, 0, 0, 0, 0 },
/* U+3b59 */ { 0, 0, 0, 0, 0 },
/* U+3b5a */ { 0, 0, 0, 0, 0 },
/* U+3b5b */ { 0, 0, 0, 0, 0 },
/* U+3b5c */ { 0, 0, 0, 0, 0 },
/* U+3b5d */ { 0, 0, 0, 0, 0 },
/* U+3b5e */ { 0, 0, 0, 0, 0 },
/* U+3b5f */ { 0, 0, 0, 0, 0 },
/* U+3b60 */ { 0, 0, 0, 0, 0 },
/* U+3b61 */ { 0, 0, 0, 0, 0 },
/* U+3b62 */ { 0, 0, 0, 0, 0 },
/* U+3b63 */ { 0, 0, 0, 0, 0 },
/* U+3b64 */ { 0, 0, 0, 0, 0 },
/* U+3b65 */ { 0, 0, 0, 0, 0 },
/* U+3b66 */ { 0, 0, 0, 0, 0 },
/* U+3b67 */ { 0, 0, 0, 0, 0 },
/* U+3b68 */ { 0, 0, 0, 0, 0 },
/* U+3b69 */ { 0, 0, 0, 0, 0 },
/* U+3b6a */ { 0, 0, 0, 0, 0 },
/* U+3b6b */ { 0, 0, 0, 0, 0 },
/* U+3b6c */ { 0, 0, 0, 0, 0 },
/* U+3b6d */ { 0, 0, 0, 0, 0 },
/* U+3b6e */ { 0, 0, 0, 0, 0 },
/* U+3b6f */ { 0, 0, 0, 0, 0 },
/* U+3b70 */ { 0, 0, 0, 0, 0 },
/* U+3b71 */ { 0, 0, 0, 0, 0 },
/* U+3b72 */ { 0, 0, 0, 0, 0 },
/* U+3b73 */ { 0, 0, 0, 0, 0 },
/* U+3b74 */ { 0, 0, 0, 0, 0 },
/* U+3b75 */ { 0, 0, 0, 0, 0 },
/* U+3b76 */ { 0, 0, 0, 0, 0 },
/* U+3b77 */ { 0, 0, 0, 0, 0 },
/* U+3b78 */ { 0, 0, 0, 0, 0 },
/* U+3b79 */ { 0, 0, 0, 0, 0 },
/* U+3b7a */ { 0, 0, 0, 0, 0 },
/* U+3b7b */ { 0, 0, 0, 0, 0 },
/* U+3b7c */ { 0, 0, 0, 0, 0 },
/* U+3b7d */ { 0, 0, 0, 0, 0 },
/* U+3b7e */ { 0, 0, 0, 0, 0 },
/* U+3b7f */ { 0, 0, 0, 0, 0 },
/* U+3b80 */ { 0, 0, 0, 0, 0 },
/* U+3b81 */ { 0, 0, 0, 0, 0 },
/* U+3b82 */ { 0, 0, 0, 0, 0 },
/* U+3b83 */ { 0, 0, 0, 0, 0 },
/* U+3b84 */ { 0, 0, 0, 0, 0 },
/* U+3b85 */ { 0, 0, 0, 0, 0 },
/* U+3b86 */ { 0, 0, 0, 0, 0 },
/* U+3b87 */ { 0, 0, 0, 0, 0 },
/* U+3b88 */ { 0, 0, 0, 0, 0 },
/* U+3b89 */ { 0, 0, 0, 0, 0 },
/* U+3b8a */ { 0, 0, 0, 0, 0 },
/* U+3b8b */ { 0, 0, 0, 0, 0 },
/* U+3b8c */ { 0, 0, 0, 0, 0 },
/* U+3b8d */ { 0, 0, 0, 0, 0 },
/* U+3b8e */ { 0, 0, 0, 0, 0 },
/* U+3b8f */ { 0, 0, 0, 0, 0 },
/* U+3b90 */ { 0, 0, 0, 0, 0 },
/* U+3b91 */ { 0, 0, 0, 0, 0 },
/* U+3b92 */ { 0, 0, 0, 0, 0 },
/* U+3b93 */ { 0, 0, 0, 0, 0 },
/* U+3b94 */ { 0, 0, 0, 0, 0 },
/* U+3b95 */ { 0, 0, 0, 0, 0 },
/* U+3b96 */ { 0, 0, 0, 0, 0 },
/* U+3b97 */ { 0, 0, 0, 0, 0 },
/* U+3b98 */ { 0, 0, 0, 0, 0 },
/* U+3b99 */ { 0, 0, 0, 0, 0 },
/* U+3b9a */ { 0, 0, 0, 0, 0 },
/* U+3b9b */ { 0, 0, 0, 0, 0 },
/* U+3b9c */ { 0, 0, 0, 0, 0 },
/* U+3b9d */ { 0, 0, 0, 0, 0 },
/* U+3b9e */ { 0, 0, 0, 0, 0 },
/* U+3b9f */ { 0, 0, 0, 0, 0 },
/* U+3ba0 */ { 0, 0, 0, 0, 0 },
/* U+3ba1 */ { 0, 0, 0, 0, 0 },
/* U+3ba2 */ { 0, 0, 0, 0, 0 },
/* U+3ba3 */ { 0, 0, 0, 0, 0 },
/* U+3ba4 */ { 0, 0, 0, 0, 0 },
/* U+3ba5 */ { 0, 0, 0, 0, 0 },
/* U+3ba6 */ { 0, 0, 0, 0, 0 },
/* U+3ba7 */ { 0, 0, 0, 0, 0 },
/* U+3ba8 */ { 0, 0, 0, 0, 0 },
/* U+3ba9 */ { 0, 0, 0, 0, 0 },
/* U+3baa */ { 0, 0, 0, 0, 0 },
/* U+3bab */ { 0, 0, 0, 0, 0 },
/* U+3bac */ { 0, 0, 0, 0, 0 },
/* U+3bad */ { 0, 0, 0, 0, 0 },
/* U+3bae */ { 0, 0, 0, 0, 0 },
/* U+3baf */ { 0, 0, 0, 0, 0 },
/* U+3bb0 */ { 0, 0, 0, 0, 0 },
/* U+3bb1 */ { 0, 0, 0, 0, 0 },
/* U+3bb2 */ { 0, 0, 0, 0, 0 },
/* U+3bb3 */ { 0, 0, 0, 0, 0 },
/* U+3bb4 */ { 0, 0, 0, 0, 0 },
/* U+3bb5 */ { 0, 0, 0, 0, 0 },
/* U+3bb6 */ { 0, 0, 0, 0, 0 },
/* U+3bb7 */ { 0, 0, 0, 0, 0 },
/* U+3bb8 */ { 0, 0, 0, 0, 0 },
/* U+3bb9 */ { 0, 0, 0, 0, 0 },
/* U+3bba */ { 0, 0, 0, 0, 0 },
/* U+3bbb */ { 0, 0, 0, 0, 0 },
/* U+3bbc */ { 0, 0, 0, 0, 0 },
/* U+3bbd */ { 0, 0, 0, 0, 0 },
/* U+3bbe */ { 0, 0, 0, 0, 0 },
/* U+3bbf */ { 0, 0, 0, 0, 0 },
/* U+3bc0 */ { 0, 0, 0, 0, 0 },
/* U+3bc1 */ { 0, 0, 0, 0, 0 },
/* U+3bc2 */ { 0, 0, 0, 0, 0 },
/* U+3bc3 */ { 0, 0, 0, 0, 0 },
/* U+3bc4 */ { 0, 0, 0, 0, 0 },
/* U+3bc5 */ { 0, 0, 0, 0, 0 },
/* U+3bc6 */ { 0, 0, 0, 0, 0 },
/* U+3bc7 */ { 0, 0, 0, 0, 0 },
/* U+3bc8 */ { 0, 0, 0, 0, 0 },
/* U+3bc9 */ { 0, 0, 0, 0, 0 },
/* U+3bca */ { 0, 0, 0, 0, 0 },
/* U+3bcb */ { 0, 0, 0, 0, 0 },
/* U+3bcc */ { 0, 0, 0, 0, 0 },
/* U+3bcd */ { 0, 0, 0, 0, 0 },
/* U+3bce */ { 0, 0, 0, 0, 0 },
/* U+3bcf */ { 0, 0, 0, 0, 0 },
/* U+3bd0 */ { 0, 0, 0, 0, 0 },
/* U+3bd1 */ { 0, 0, 0, 0, 0 },
/* U+3bd2 */ { 0, 0, 0, 0, 0 },
/* U+3bd3 */ { 0, 0, 0, 0, 0 },
/* U+3bd4 */ { 0, 0, 0, 0, 0 },
/* U+3bd5 */ { 0, 0, 0, 0, 0 },
/* U+3bd6 */ { 0, 0, 0, 0, 0 },
/* U+3bd7 */ { 0, 0, 0, 0, 0 },
/* U+3bd8 */ { 0, 0, 0, 0, 0 },
/* U+3bd9 */ { 0, 0, 0, 0, 0 },
/* U+3bda */ { 0, 0, 0, 0, 0 },
/* U+3bdb */ { 0, 0, 0, 0, 0 },
/* U+3bdc */ { 0, 0, 0, 0, 0 },
/* U+3bdd */ { 0, 0, 0, 0, 0 },
/* U+3bde */ { 0, 0, 0, 0, 0 },
/* U+3bdf */ { 0, 0, 0, 0, 0 },
/* U+3be0 */ { 0, 0, 0, 0, 0 },
/* U+3be1 */ { 0, 0, 0, 0, 0 },
/* U+3be2 */ { 0, 0, 0, 0, 0 },
/* U+3be3 */ { 0, 0, 0, 0, 0 },
/* U+3be4 */ { 0, 0, 0, 0, 0 },
/* U+3be5 */ { 0, 0, 0, 0, 0 },
/* U+3be6 */ { 0, 0, 0, 0, 0 },
/* U+3be7 */ { 0, 0, 0, 0, 0 },
/* U+3be8 */ { 0, 0, 0, 0, 0 },
/* U+3be9 */ { 0, 0, 0, 0, 0 },
/* U+3bea */ { 0, 0, 0, 0, 0 },
/* U+3beb */ { 0, 0, 0, 0, 0 },
/* U+3bec */ { 0, 0, 0, 0, 0 },
/* U+3bed */ { 0, 0, 0, 0, 0 },
/* U+3bee */ { 0, 0, 0, 0, 0 },
/* U+3bef */ { 0, 0, 0, 0, 0 },
/* U+3bf0 */ { 0, 0, 0, 0, 0 },
/* U+3bf1 */ { 0, 0, 0, 0, 0 },
/* U+3bf2 */ { 0, 0, 0, 0, 0 },
/* U+3bf3 */ { 0, 0, 0, 0, 0 },
/* U+3bf4 */ { 0, 0, 0, 0, 0 },
/* U+3bf5 */ { 0, 0, 0, 0, 0 },
/* U+3bf6 */ { 0, 0, 0, 0, 0 },
/* U+3bf7 */ { 0, 0, 0, 0, 0 },
/* U+3bf8 */ { 0, 0, 0, 0, 0 },
/* U+3bf9 */ { 0, 0, 0, 0, 0 },
/* U+3bfa */ { 0, 0, 0, 0, 0 },
/* U+3bfb */ { 0, 0, 0, 0, 0 },
/* U+3bfc */ { 0, 0, 0, 0, 0 },
/* U+3bfd */ { 0, 0, 0, 0, 0 },
/* U+3bfe */ { 0, 0, 0, 0, 0 },
/* U+3bff */ { 0, 0, 0, 0, 0 },
/* U+3c00 */ { 0, 0, 0, 0, 0 },
/* U+3c01 */ { 0, 0, 0, 0, 0 },
/* U+3c02 */ { 0, 0, 0, 0, 0 },
/* U+3c03 */ { 0, 0, 0, 0, 0 },
/* U+3c04 */ { 0, 0, 0, 0, 0 },
/* U+3c05 */ { 0, 0, 0, 0, 0 },
/* U+3c06 */ { 0, 0, 0, 0, 0 },
/* U+3c07 */ { 0, 0, 0, 0, 0 },
/* U+3c08 */ { 0, 0, 0, 0, 0 },
/* U+3c09 */ { 0, 0, 0, 0, 0 },
/* U+3c0a */ { 0, 0, 0, 0, 0 },
/* U+3c0b */ { 0, 0, 0, 0, 0 },
/* U+3c0c */ { 0, 0, 0, 0, 0 },
/* U+3c0d */ { 0, 0, 0, 0, 0 },
/* U+3c0e */ { 0, 0, 0, 0, 0 },
/* U+3c0f */ { 0, 0, 0, 0, 0 },
/* U+3c10 */ { 0, 0, 0, 0, 0 },
/* U+3c11 */ { 0, 0, 0, 0, 0 },
/* U+3c12 */ { 0, 0, 0, 0, 0 },
/* U+3c13 */ { 0, 0, 0, 0, 0 },
/* U+3c14 */ { 0, 0, 0, 0, 0 },
/* U+3c15 */ { 0, 0, 0, 0, 0 },
/* U+3c16 */ { 0, 0, 0, 0, 0 },
/* U+3c17 */ { 0, 0, 0, 0, 0 },
/* U+3c18 */ { 0, 0, 0, 0, 0 },
/* U+3c19 */ { 0, 0, 0, 0, 0 },
/* U+3c1a */ { 0, 0, 0, 0, 0 },
/* U+3c1b */ { 0, 0, 0, 0, 0 },
/* U+3c1c */ { 0, 0, 0, 0, 0 },
/* U+3c1d */ { 0, 0, 0, 0, 0 },
/* U+3c1e */ { 0, 0, 0, 0, 0 },
/* U+3c1f */ { 0, 0, 0, 0, 0 },
/* U+3c20 */ { 0, 0, 0, 0, 0 },
/* U+3c21 */ { 0, 0, 0, 0, 0 },
/* U+3c22 */ { 0, 0, 0, 0, 0 },
/* U+3c23 */ { 0, 0, 0, 0, 0 },
/* U+3c24 */ { 0, 0, 0, 0, 0 },
/* U+3c25 */ { 0, 0, 0, 0, 0 },
/* U+3c26 */ { 0, 0, 0, 0, 0 },
/* U+3c27 */ { 0, 0, 0, 0, 0 },
/* U+3c28 */ { 0, 0, 0, 0, 0 },
/* U+3c29 */ { 0, 0, 0, 0, 0 },
/* U+3c2a */ { 0, 0, 0, 0, 0 },
/* U+3c2b */ { 0, 0, 0, 0, 0 },
/* U+3c2c */ { 0, 0, 0, 0, 0 },
/* U+3c2d */ { 0, 0, 0, 0, 0 },
/* U+3c2e */ { 0, 0, 0, 0, 0 },
/* U+3c2f */ { 0, 0, 0, 0, 0 },
/* U+3c30 */ { 0, 0, 0, 0, 0 },
/* U+3c31 */ { 0, 0, 0, 0, 0 },
/* U+3c32 */ { 0, 0, 0, 0, 0 },
/* U+3c33 */ { 0, 0, 0, 0, 0 },
/* U+3c34 */ { 0, 0, 0, 0, 0 },
/* U+3c35 */ { 0, 0, 0, 0, 0 },
/* U+3c36 */ { 0, 0, 0, 0, 0 },
/* U+3c37 */ { 0, 0, 0, 0, 0 },
/* U+3c38 */ { 0, 0, 0, 0, 0 },
/* U+3c39 */ { 0, 0, 0, 0, 0 },
/* U+3c3a */ { 0, 0, 0, 0, 0 },
/* U+3c3b */ { 0, 0, 0, 0, 0 },
/* U+3c3c */ { 0, 0, 0, 0, 0 },
/* U+3c3d */ { 0, 0, 0, 0, 0 },
/* U+3c3e */ { 0, 0, 0, 0, 0 },
/* U+3c3f */ { 0, 0, 0, 0, 0 },
/* U+3c40 */ { 0, 0, 0, 0, 0 },
/* U+3c41 */ { 0, 0, 0, 0, 0 },
/* U+3c42 */ { 0, 0, 0, 0, 0 },
/* U+3c43 */ { 0, 0, 0, 0, 0 },
/* U+3c44 */ { 0, 0, 0, 0, 0 },
/* U+3c45 */ { 0, 0, 0, 0, 0 },
/* U+3c46 */ { 0, 0, 0, 0, 0 },
/* U+3c47 */ { 0, 0, 0, 0, 0 },
/* U+3c48 */ { 0, 0, 0, 0, 0 },
/* U+3c49 */ { 0, 0, 0, 0, 0 },
/* U+3c4a */ { 0, 0, 0, 0, 0 },
/* U+3c4b */ { 0, 0, 0, 0, 0 },
/* U+3c4c */ { 0, 0, 0, 0, 0 },
/* U+3c4d */ { 0, 0, 0, 0, 0 },
/* U+3c4e */ { 0, 0, 0, 0, 0 },
/* U+3c4f */ { 0, 0, 0, 0, 0 },
/* U+3c50 */ { 0, 0, 0, 0, 0 },
/* U+3c51 */ { 0, 0, 0, 0, 0 },
/* U+3c52 */ { 0, 0, 0, 0, 0 },
/* U+3c53 */ { 0, 0, 0, 0, 0 },
/* U+3c54 */ { 0, 0, 0, 0, 0 },
/* U+3c55 */ { 0, 0, 0, 0, 0 },
/* U+3c56 */ { 0, 0, 0, 0, 0 },
/* U+3c57 */ { 0, 0, 0, 0, 0 },
/* U+3c58 */ { 0, 0, 0, 0, 0 },
/* U+3c59 */ { 0, 0, 0, 0, 0 },
/* U+3c5a */ { 0, 0, 0, 0, 0 },
/* U+3c5b */ { 0, 0, 0, 0, 0 },
/* U+3c5c */ { 0, 0, 0, 0, 0 },
/* U+3c5d */ { 0, 0, 0, 0, 0 },
/* U+3c5e */ { 0, 0, 0, 0, 0 },
/* U+3c5f */ { 0, 0, 0, 0, 0 },
/* U+3c60 */ { 0, 0, 0, 0, 0 },
/* U+3c61 */ { 0, 0, 0, 0, 0 },
/* U+3c62 */ { 0, 0, 0, 0, 0 },
/* U+3c63 */ { 0, 0, 0, 0, 0 },
/* U+3c64 */ { 0, 0, 0, 0, 0 },
/* U+3c65 */ { 0, 0, 0, 0, 0 },
/* U+3c66 */ { 0, 0, 0, 0, 0 },
/* U+3c67 */ { 0, 0, 0, 0, 0 },
/* U+3c68 */ { 0, 0, 0, 0, 0 },
/* U+3c69 */ { 0, 0, 0, 0, 0 },
/* U+3c6a */ { 0, 0, 0, 0, 0 },
/* U+3c6b */ { 0, 0, 0, 0, 0 },
/* U+3c6c */ { 0, 0, 0, 0, 0 },
/* U+3c6d */ { 0, 0, 0, 0, 0 },
/* U+3c6e */ { 0, 0, 0, 0, 0 },
/* U+3c6f */ { 0, 0, 0, 0, 0 },
/* U+3c70 */ { 0, 0, 0, 0, 0 },
/* U+3c71 */ { 0, 0, 0, 0, 0 },
/* U+3c72 */ { 0, 0, 0, 0, 0 },
/* U+3c73 */ { 0, 0, 0, 0, 0 },
/* U+3c74 */ { 0, 0, 0, 0, 0 },
/* U+3c75 */ { 0, 0, 0, 0, 0 },
/* U+3c76 */ { 0, 0, 0, 0, 0 },
/* U+3c77 */ { 0, 0, 0, 0, 0 },
/* U+3c78 */ { 0, 0, 0, 0, 0 },
/* U+3c79 */ { 0, 0, 0, 0, 0 },
/* U+3c7a */ { 0, 0, 0, 0, 0 },
/* U+3c7b */ { 0, 0, 0, 0, 0 },
/* U+3c7c */ { 0, 0, 0, 0, 0 },
/* U+3c7d */ { 0, 0, 0, 0, 0 },
/* U+3c7e */ { 0, 0, 0, 0, 0 },
/* U+3c7f */ { 0, 0, 0, 0, 0 },
/* U+3c80 */ { 0, 0, 0, 0, 0 },
/* U+3c81 */ { 0, 0, 0, 0, 0 },
/* U+3c82 */ { 0, 0, 0, 0, 0 },
/* U+3c83 */ { 0, 0, 0, 0, 0 },
/* U+3c84 */ { 0, 0, 0, 0, 0 },
/* U+3c85 */ { 0, 0, 0, 0, 0 },
/* U+3c86 */ { 0, 0, 0, 0, 0 },
/* U+3c87 */ { 0, 0, 0, 0, 0 },
/* U+3c88 */ { 0, 0, 0, 0, 0 },
/* U+3c89 */ { 0, 0, 0, 0, 0 },
/* U+3c8a */ { 0, 0, 0, 0, 0 },
/* U+3c8b */ { 0, 0, 0, 0, 0 },
/* U+3c8c */ { 0, 0, 0, 0, 0 },
/* U+3c8d */ { 0, 0, 0, 0, 0 },
/* U+3c8e */ { 0, 0, 0, 0, 0 },
/* U+3c8f */ { 0, 0, 0, 0, 0 },
/* U+3c90 */ { 0, 0, 0, 0, 0 },
/* U+3c91 */ { 0, 0, 0, 0, 0 },
/* U+3c92 */ { 0, 0, 0, 0, 0 },
/* U+3c93 */ { 0, 0, 0, 0, 0 },
/* U+3c94 */ { 0, 0, 0, 0, 0 },
/* U+3c95 */ { 0, 0, 0, 0, 0 },
/* U+3c96 */ { 0, 0, 0, 0, 0 },
/* U+3c97 */ { 0, 0, 0, 0, 0 },
/* U+3c98 */ { 0, 0, 0, 0, 0 },
/* U+3c99 */ { 0, 0, 0, 0, 0 },
/* U+3c9a */ { 0, 0, 0, 0, 0 },
/* U+3c9b */ { 0, 0, 0, 0, 0 },
/* U+3c9c */ { 0, 0, 0, 0, 0 },
/* U+3c9d */ { 0, 0, 0, 0, 0 },
/* U+3c9e */ { 0, 0, 0, 0, 0 },
/* U+3c9f */ { 0, 0, 0, 0, 0 },
/* U+3ca0 */ { 0, 0, 0, 0, 0 },
/* U+3ca1 */ { 0, 0, 0, 0, 0 },
/* U+3ca2 */ { 0, 0, 0, 0, 0 },
/* U+3ca3 */ { 0, 0, 0, 0, 0 },
/* U+3ca4 */ { 0, 0, 0, 0, 0 },
/* U+3ca5 */ { 0, 0, 0, 0, 0 },
/* U+3ca6 */ { 0, 0, 0, 0, 0 },
/* U+3ca7 */ { 0, 0, 0, 0, 0 },
/* U+3ca8 */ { 0, 0, 0, 0, 0 },
/* U+3ca9 */ { 0, 0, 0, 0, 0 },
/* U+3caa */ { 0, 0, 0, 0, 0 },
/* U+3cab */ { 0, 0, 0, 0, 0 },
/* U+3cac */ { 0, 0, 0, 0, 0 },
/* U+3cad */ { 0, 0, 0, 0, 0 },
/* U+3cae */ { 0, 0, 0, 0, 0 },
/* U+3caf */ { 0, 0, 0, 0, 0 },
/* U+3cb0 */ { 0, 0, 0, 0, 0 },
/* U+3cb1 */ { 0, 0, 0, 0, 0 },
/* U+3cb2 */ { 0, 0, 0, 0, 0 },
/* U+3cb3 */ { 0, 0, 0, 0, 0 },
/* U+3cb4 */ { 0, 0, 0, 0, 0 },
/* U+3cb5 */ { 0, 0, 0, 0, 0 },
/* U+3cb6 */ { 0, 0, 0, 0, 0 },
/* U+3cb7 */ { 0, 0, 0, 0, 0 },
/* U+3cb8 */ { 0, 0, 0, 0, 0 },
/* U+3cb9 */ { 0, 0, 0, 0, 0 },
/* U+3cba */ { 0, 0, 0, 0, 0 },
/* U+3cbb */ { 0, 0, 0, 0, 0 },
/* U+3cbc */ { 0, 0, 0, 0, 0 },
/* U+3cbd */ { 0, 0, 0, 0, 0 },
/* U+3cbe */ { 0, 0, 0, 0, 0 },
/* U+3cbf */ { 0, 0, 0, 0, 0 },
/* U+3cc0 */ { 0, 0, 0, 0, 0 },
/* U+3cc1 */ { 0, 0, 0, 0, 0 },
/* U+3cc2 */ { 0, 0, 0, 0, 0 },
/* U+3cc3 */ { 0, 0, 0, 0, 0 },
/* U+3cc4 */ { 0, 0, 0, 0, 0 },
/* U+3cc5 */ { 0, 0, 0, 0, 0 },
/* U+3cc6 */ { 0, 0, 0, 0, 0 },
/* U+3cc7 */ { 0, 0, 0, 0, 0 },
/* U+3cc8 */ { 0, 0, 0, 0, 0 },
/* U+3cc9 */ { 0, 0, 0, 0, 0 },
/* U+3cca */ { 0, 0, 0, 0, 0 },
/* U+3ccb */ { 0, 0, 0, 0, 0 },
/* U+3ccc */ { 0, 0, 0, 0, 0 },
/* U+3ccd */ { 0, 0, 0, 0, 0 },
/* U+3cce */ { 0, 0, 0, 0, 0 },
/* U+3ccf */ { 0, 0, 0, 0, 0 },
/* U+3cd0 */ { 0, 0, 0, 0, 0 },
/* U+3cd1 */ { 0, 0, 0, 0, 0 },
/* U+3cd2 */ { 0, 0, 0, 0, 0 },
/* U+3cd3 */ { 0, 0, 0, 0, 0 },
/* U+3cd4 */ { 0, 0, 0, 0, 0 },
/* U+3cd5 */ { 0, 0, 0, 0, 0 },
/* U+3cd6 */ { 0, 0, 0, 0, 0 },
/* U+3cd7 */ { 0, 0, 0, 0, 0 },
/* U+3cd8 */ { 0, 0, 0, 0, 0 },
/* U+3cd9 */ { 0, 0, 0, 0, 0 },
/* U+3cda */ { 0, 0, 0, 0, 0 },
/* U+3cdb */ { 0, 0, 0, 0, 0 },
/* U+3cdc */ { 0, 0, 0, 0, 0 },
/* U+3cdd */ { 0, 0, 0, 0, 0 },
/* U+3cde */ { 0, 0, 0, 0, 0 },
/* U+3cdf */ { 0, 0, 0, 0, 0 },
/* U+3ce0 */ { 0, 0, 0, 0, 0 },
/* U+3ce1 */ { 0, 0, 0, 0, 0 },
/* U+3ce2 */ { 0, 0, 0, 0, 0 },
/* U+3ce3 */ { 0, 0, 0, 0, 0 },
/* U+3ce4 */ { 0, 0, 0, 0, 0 },
/* U+3ce5 */ { 0, 0, 0, 0, 0 },
/* U+3ce6 */ { 0, 0, 0, 0, 0 },
/* U+3ce7 */ { 0, 0, 0, 0, 0 },
/* U+3ce8 */ { 0, 0, 0, 0, 0 },
/* U+3ce9 */ { 0, 0, 0, 0, 0 },
/* U+3cea */ { 0, 0, 0, 0, 0 },
/* U+3ceb */ { 0, 0, 0, 0, 0 },
/* U+3cec */ { 0, 0, 0, 0, 0 },
/* U+3ced */ { 0, 0, 0, 0, 0 },
/* U+3cee */ { 0, 0, 0, 0, 0 },
/* U+3cef */ { 0, 0, 0, 0, 0 },
/* U+3cf0 */ { 0, 0, 0, 0, 0 },
/* U+3cf1 */ { 0, 0, 0, 0, 0 },
/* U+3cf2 */ { 0, 0, 0, 0, 0 },
/* U+3cf3 */ { 0, 0, 0, 0, 0 },
/* U+3cf4 */ { 0, 0, 0, 0, 0 },
/* U+3cf5 */ { 0, 0, 0, 0, 0 },
/* U+3cf6 */ { 0, 0, 0, 0, 0 },
/* U+3cf7 */ { 0, 0, 0, 0, 0 },
/* U+3cf8 */ { 0, 0, 0, 0, 0 },
/* U+3cf9 */ { 0, 0, 0, 0, 0 },
/* U+3cfa */ { 0, 0, 0, 0, 0 },
/* U+3cfb */ { 0, 0, 0, 0, 0 },
/* U+3cfc */ { 0, 0, 0, 0, 0 },
/* U+3cfd */ { 0, 0, 0, 0, 0 },
/* U+3cfe */ { 0, 0, 0, 0, 0 },
/* U+3cff */ { 0, 0, 0, 0, 0 },
/* U+3d00 */ { 0, 0, 0, 0, 0 },
/* U+3d01 */ { 0, 0, 0, 0, 0 },
/* U+3d02 */ { 0, 0, 0, 0, 0 },
/* U+3d03 */ { 0, 0, 0, 0, 0 },
/* U+3d04 */ { 0, 0, 0, 0, 0 },
/* U+3d05 */ { 0, 0, 0, 0, 0 },
/* U+3d06 */ { 0, 0, 0, 0, 0 },
/* U+3d07 */ { 0, 0, 0, 0, 0 },
/* U+3d08 */ { 0, 0, 0, 0, 0 },
/* U+3d09 */ { 0, 0, 0, 0, 0 },
/* U+3d0a */ { 0, 0, 0, 0, 0 },
/* U+3d0b */ { 0, 0, 0, 0, 0 },
/* U+3d0c */ { 0, 0, 0, 0, 0 },
/* U+3d0d */ { 0, 0, 0, 0, 0 },
/* U+3d0e */ { 0, 0, 0, 0, 0 },
/* U+3d0f */ { 0, 0, 0, 0, 0 },
/* U+3d10 */ { 0, 0, 0, 0, 0 },
/* U+3d11 */ { 0, 0, 0, 0, 0 },
/* U+3d12 */ { 0, 0, 0, 0, 0 },
/* U+3d13 */ { 0, 0, 0, 0, 0 },
/* U+3d14 */ { 0, 0, 0, 0, 0 },
/* U+3d15 */ { 0, 0, 0, 0, 0 },
/* U+3d16 */ { 0, 0, 0, 0, 0 },
/* U+3d17 */ { 0, 0, 0, 0, 0 },
/* U+3d18 */ { 0, 0, 0, 0, 0 },
/* U+3d19 */ { 0, 0, 0, 0, 0 },
/* U+3d1a */ { 0, 0, 0, 0, 0 },
/* U+3d1b */ { 0, 0, 0, 0, 0 },
/* U+3d1c */ { 0, 0, 0, 0, 0 },
/* U+3d1d */ { 0, 0, 0, 0, 0 },
/* U+3d1e */ { 0, 0, 0, 0, 0 },
/* U+3d1f */ { 0, 0, 0, 0, 0 },
/* U+3d20 */ { 0, 0, 0, 0, 0 },
/* U+3d21 */ { 0, 0, 0, 0, 0 },
/* U+3d22 */ { 0, 0, 0, 0, 0 },
/* U+3d23 */ { 0, 0, 0, 0, 0 },
/* U+3d24 */ { 0, 0, 0, 0, 0 },
/* U+3d25 */ { 0, 0, 0, 0, 0 },
/* U+3d26 */ { 0, 0, 0, 0, 0 },
/* U+3d27 */ { 0, 0, 0, 0, 0 },
/* U+3d28 */ { 0, 0, 0, 0, 0 },
/* U+3d29 */ { 0, 0, 0, 0, 0 },
/* U+3d2a */ { 0, 0, 0, 0, 0 },
/* U+3d2b */ { 0, 0, 0, 0, 0 },
/* U+3d2c */ { 0, 0, 0, 0, 0 },
/* U+3d2d */ { 0, 0, 0, 0, 0 },
/* U+3d2e */ { 0, 0, 0, 0, 0 },
/* U+3d2f */ { 0, 0, 0, 0, 0 },
/* U+3d30 */ { 0, 0, 0, 0, 0 },
/* U+3d31 */ { 0, 0, 0, 0, 0 },
/* U+3d32 */ { 0, 0, 0, 0, 0 },
/* U+3d33 */ { 0, 0, 0, 0, 0 },
/* U+3d34 */ { 0, 0, 0, 0, 0 },
/* U+3d35 */ { 0, 0, 0, 0, 0 },
/* U+3d36 */ { 0, 0, 0, 0, 0 },
/* U+3d37 */ { 0, 0, 0, 0, 0 },
/* U+3d38 */ { 0, 0, 0, 0, 0 },
/* U+3d39 */ { 0, 0, 0, 0, 0 },
/* U+3d3a */ { 0, 0, 0, 0, 0 },
/* U+3d3b */ { 0, 0, 0, 0, 0 },
/* U+3d3c */ { 0, 0, 0, 0, 0 },
/* U+3d3d */ { 0, 0, 0, 0, 0 },
/* U+3d3e */ { 0, 0, 0, 0, 0 },
/* U+3d3f */ { 0, 0, 0, 0, 0 },
/* U+3d40 */ { 0, 0, 0, 0, 0 },
/* U+3d41 */ { 0, 0, 0, 0, 0 },
/* U+3d42 */ { 0, 0, 0, 0, 0 },
/* U+3d43 */ { 0, 0, 0, 0, 0 },
/* U+3d44 */ { 0, 0, 0, 0, 0 },
/* U+3d45 */ { 0, 0, 0, 0, 0 },
/* U+3d46 */ { 0, 0, 0, 0, 0 },
/* U+3d47 */ { 0, 0, 0, 0, 0 },
/* U+3d48 */ { 0, 0, 0, 0, 0 },
/* U+3d49 */ { 0, 0, 0, 0, 0 },
/* U+3d4a */ { 0, 0, 0, 0, 0 },
/* U+3d4b */ { 0, 0, 0, 0, 0 },
/* U+3d4c */ { 0, 0, 0, 0, 0 },
/* U+3d4d */ { 0, 0, 0, 0, 0 },
/* U+3d4e */ { 0, 0, 0, 0, 0 },
/* U+3d4f */ { 0, 0, 0, 0, 0 },
/* U+3d50 */ { 0, 0, 0, 0, 0 },
/* U+3d51 */ { 0, 0, 0, 0, 0 },
/* U+3d52 */ { 0, 0, 0, 0, 0 },
/* U+3d53 */ { 0, 0, 0, 0, 0 },
/* U+3d54 */ { 0, 0, 0, 0, 0 },
/* U+3d55 */ { 0, 0, 0, 0, 0 },
/* U+3d56 */ { 0, 0, 0, 0, 0 },
/* U+3d57 */ { 0, 0, 0, 0, 0 },
/* U+3d58 */ { 0, 0, 0, 0, 0 },
/* U+3d59 */ { 0, 0, 0, 0, 0 },
/* U+3d5a */ { 0, 0, 0, 0, 0 },
/* U+3d5b */ { 0, 0, 0, 0, 0 },
/* U+3d5c */ { 0, 0, 0, 0, 0 },
/* U+3d5d */ { 0, 0, 0, 0, 0 },
/* U+3d5e */ { 0, 0, 0, 0, 0 },
/* U+3d5f */ { 0, 0, 0, 0, 0 },
/* U+3d60 */ { 0, 0, 0, 0, 0 },
/* U+3d61 */ { 0, 0, 0, 0, 0 },
/* U+3d62 */ { 0, 0, 0, 0, 0 },
/* U+3d63 */ { 0, 0, 0, 0, 0 },
/* U+3d64 */ { 0, 0, 0, 0, 0 },
/* U+3d65 */ { 0, 0, 0, 0, 0 },
/* U+3d66 */ { 0, 0, 0, 0, 0 },
/* U+3d67 */ { 0, 0, 0, 0, 0 },
/* U+3d68 */ { 0, 0, 0, 0, 0 },
/* U+3d69 */ { 0, 0, 0, 0, 0 },
/* U+3d6a */ { 0, 0, 0, 0, 0 },
/* U+3d6b */ { 0, 0, 0, 0, 0 },
/* U+3d6c */ { 0, 0, 0, 0, 0 },
/* U+3d6d */ { 0, 0, 0, 0, 0 },
/* U+3d6e */ { 0, 0, 0, 0, 0 },
/* U+3d6f */ { 0, 0, 0, 0, 0 },
/* U+3d70 */ { 0, 0, 0, 0, 0 },
/* U+3d71 */ { 0, 0, 0, 0, 0 },
/* U+3d72 */ { 0, 0, 0, 0, 0 },
/* U+3d73 */ { 0, 0, 0, 0, 0 },
/* U+3d74 */ { 0, 0, 0, 0, 0 },
/* U+3d75 */ { 0, 0, 0, 0, 0 },
/* U+3d76 */ { 0, 0, 0, 0, 0 },
/* U+3d77 */ { 0, 0, 0, 0, 0 },
/* U+3d78 */ { 0, 0, 0, 0, 0 },
/* U+3d79 */ { 0, 0, 0, 0, 0 },
/* U+3d7a */ { 0, 0, 0, 0, 0 },
/* U+3d7b */ { 0, 0, 0, 0, 0 },
/* U+3d7c */ { 0, 0, 0, 0, 0 },
/* U+3d7d */ { 0, 0, 0, 0, 0 },
/* U+3d7e */ { 0, 0, 0, 0, 0 },
/* U+3d7f */ { 0, 0, 0, 0, 0 },
/* U+3d80 */ { 0, 0, 0, 0, 0 },
/* U+3d81 */ { 0, 0, 0, 0, 0 },
/* U+3d82 */ { 0, 0, 0, 0, 0 },
/* U+3d83 */ { 0, 0, 0, 0, 0 },
/* U+3d84 */ { 0, 0, 0, 0, 0 },
/* U+3d85 */ { 0, 0, 0, 0, 0 },
/* U+3d86 */ { 0, 0, 0, 0, 0 },
/* U+3d87 */ { 0, 0, 0, 0, 0 },
/* U+3d88 */ { 0, 0, 0, 0, 0 },
/* U+3d89 */ { 0, 0, 0, 0, 0 },
/* U+3d8a */ { 0, 0, 0, 0, 0 },
/* U+3d8b */ { 0, 0, 0, 0, 0 },
/* U+3d8c */ { 0, 0, 0, 0, 0 },
/* U+3d8d */ { 0, 0, 0, 0, 0 },
/* U+3d8e */ { 0, 0, 0, 0, 0 },
/* U+3d8f */ { 0, 0, 0, 0, 0 },
/* U+3d90 */ { 0, 0, 0, 0, 0 },
/* U+3d91 */ { 0, 0, 0, 0, 0 },
/* U+3d92 */ { 0, 0, 0, 0, 0 },
/* U+3d93 */ { 0, 0, 0, 0, 0 },
/* U+3d94 */ { 0, 0, 0, 0, 0 },
/* U+3d95 */ { 0, 0, 0, 0, 0 },
/* U+3d96 */ { 0, 0, 0, 0, 0 },
/* U+3d97 */ { 0, 0, 0, 0, 0 },
/* U+3d98 */ { 0, 0, 0, 0, 0 },
/* U+3d99 */ { 0, 0, 0, 0, 0 },
/* U+3d9a */ { 0, 0, 0, 0, 0 },
/* U+3d9b */ { 0, 0, 0, 0, 0 },
/* U+3d9c */ { 0, 0, 0, 0, 0 },
/* U+3d9d */ { 0, 0, 0, 0, 0 },
/* U+3d9e */ { 0, 0, 0, 0, 0 },
/* U+3d9f */ { 0, 0, 0, 0, 0 },
/* U+3da0 */ { 0, 0, 0, 0, 0 },
/* U+3da1 */ { 0, 0, 0, 0, 0 },
/* U+3da2 */ { 0, 0, 0, 0, 0 },
/* U+3da3 */ { 0, 0, 0, 0, 0 },
/* U+3da4 */ { 0, 0, 0, 0, 0 },
/* U+3da5 */ { 0, 0, 0, 0, 0 },
/* U+3da6 */ { 0, 0, 0, 0, 0 },
/* U+3da7 */ { 0, 0, 0, 0, 0 },
/* U+3da8 */ { 0, 0, 0, 0, 0 },
/* U+3da9 */ { 0, 0, 0, 0, 0 },
/* U+3daa */ { 0, 0, 0, 0, 0 },
/* U+3dab */ { 0, 0, 0, 0, 0 },
/* U+3dac */ { 0, 0, 0, 0, 0 },
/* U+3dad */ { 0, 0, 0, 0, 0 },
/* U+3dae */ { 0, 0, 0, 0, 0 },
/* U+3daf */ { 0, 0, 0, 0, 0 },
/* U+3db0 */ { 0, 0, 0, 0, 0 },
/* U+3db1 */ { 0, 0, 0, 0, 0 },
/* U+3db2 */ { 0, 0, 0, 0, 0 },
/* U+3db3 */ { 0, 0, 0, 0, 0 },
/* U+3db4 */ { 0, 0, 0, 0, 0 },
/* U+3db5 */ { 0, 0, 0, 0, 0 },
/* U+3db6 */ { 0, 0, 0, 0, 0 },
/* U+3db7 */ { 0, 0, 0, 0, 0 },
/* U+3db8 */ { 0, 0, 0, 0, 0 },
/* U+3db9 */ { 0, 0, 0, 0, 0 },
/* U+3dba */ { 0, 0, 0, 0, 0 },
/* U+3dbb */ { 0, 0, 0, 0, 0 },
/* U+3dbc */ { 0, 0, 0, 0, 0 },
/* U+3dbd */ { 0, 0, 0, 0, 0 },
/* U+3dbe */ { 0, 0, 0, 0, 0 },
/* U+3dbf */ { 0, 0, 0, 0, 0 },
/* U+3dc0 */ { 0, 0, 0, 0, 0 },
/* U+3dc1 */ { 0, 0, 0, 0, 0 },
/* U+3dc2 */ { 0, 0, 0, 0, 0 },
/* U+3dc3 */ { 0, 0, 0, 0, 0 },
/* U+3dc4 */ { 0, 0, 0, 0, 0 },
/* U+3dc5 */ { 0, 0, 0, 0, 0 },
/* U+3dc6 */ { 0, 0, 0, 0, 0 },
/* U+3dc7 */ { 0, 0, 0, 0, 0 },
/* U+3dc8 */ { 0, 0, 0, 0, 0 },
/* U+3dc9 */ { 0, 0, 0, 0, 0 },
/* U+3dca */ { 0, 0, 0, 0, 0 },
/* U+3dcb */ { 0, 0, 0, 0, 0 },
/* U+3dcc */ { 0, 0, 0, 0, 0 },
/* U+3dcd */ { 0, 0, 0, 0, 0 },
/* U+3dce */ { 0, 0, 0, 0, 0 },
/* U+3dcf */ { 0, 0, 0, 0, 0 },
/* U+3dd0 */ { 0, 0, 0, 0, 0 },
/* U+3dd1 */ { 0, 0, 0, 0, 0 },
/* U+3dd2 */ { 0, 0, 0, 0, 0 },
/* U+3dd3 */ { 0, 0, 0, 0, 0 },
/* U+3dd4 */ { 0, 0, 0, 0, 0 },
/* U+3dd5 */ { 0, 0, 0, 0, 0 },
/* U+3dd6 */ { 0, 0, 0, 0, 0 },
/* U+3dd7 */ { 0, 0, 0, 0, 0 },
/* U+3dd8 */ { 0, 0, 0, 0, 0 },
/* U+3dd9 */ { 0, 0, 0, 0, 0 },
/* U+3dda */ { 0, 0, 0, 0, 0 },
/* U+3ddb */ { 0, 0, 0, 0, 0 },
/* U+3ddc */ { 0, 0, 0, 0, 0 },
/* U+3ddd */ { 0, 0, 0, 0, 0 },
/* U+3dde */ { 0, 0, 0, 0, 0 },
/* U+3ddf */ { 0, 0, 0, 0, 0 },
/* U+3de0 */ { 0, 0, 0, 0, 0 },
/* U+3de1 */ { 0, 0, 0, 0, 0 },
/* U+3de2 */ { 0, 0, 0, 0, 0 },
/* U+3de3 */ { 0, 0, 0, 0, 0 },
/* U+3de4 */ { 0, 0, 0, 0, 0 },
/* U+3de5 */ { 0, 0, 0, 0, 0 },
/* U+3de6 */ { 0, 0, 0, 0, 0 },
/* U+3de7 */ { 0, 0, 0, 0, 0 },
/* U+3de8 */ { 0, 0, 0, 0, 0 },
/* U+3de9 */ { 0, 0, 0, 0, 0 },
/* U+3dea */ { 0, 0, 0, 0, 0 },
/* U+3deb */ { 0, 0, 0, 0, 0 },
/* U+3dec */ { 0, 0, 0, 0, 0 },
/* U+3ded */ { 0, 0, 0, 0, 0 },
/* U+3dee */ { 0, 0, 0, 0, 0 },
/* U+3def */ { 0, 0, 0, 0, 0 },
/* U+3df0 */ { 0, 0, 0, 0, 0 },
/* U+3df1 */ { 0, 0, 0, 0, 0 },
/* U+3df2 */ { 0, 0, 0, 0, 0 },
/* U+3df3 */ { 0, 0, 0, 0, 0 },
/* U+3df4 */ { 0, 0, 0, 0, 0 },
/* U+3df5 */ { 0, 0, 0, 0, 0 },
/* U+3df6 */ { 0, 0, 0, 0, 0 },
/* U+3df7 */ { 0, 0, 0, 0, 0 },
/* U+3df8 */ { 0, 0, 0, 0, 0 },
/* U+3df9 */ { 0, 0, 0, 0, 0 },
/* U+3dfa */ { 0, 0, 0, 0, 0 },
/* U+3dfb */ { 0, 0, 0, 0, 0 },
/* U+3dfc */ { 0, 0, 0, 0, 0 },
/* U+3dfd */ { 0, 0, 0, 0, 0 },
/* U+3dfe */ { 0, 0, 0, 0, 0 },
/* U+3dff */ { 0, 0, 0, 0, 0 },
/* U+3e00 */ { 0, 0, 0, 0, 0 },
/* U+3e01 */ { 0, 0, 0, 0, 0 },
/* U+3e02 */ { 0, 0, 0, 0, 0 },
/* U+3e03 */ { 0, 0, 0, 0, 0 },
/* U+3e04 */ { 0, 0, 0, 0, 0 },
/* U+3e05 */ { 0, 0, 0, 0, 0 },
/* U+3e06 */ { 0, 0, 0, 0, 0 },
/* U+3e07 */ { 0, 0, 0, 0, 0 },
/* U+3e08 */ { 0, 0, 0, 0, 0 },
/* U+3e09 */ { 0, 0, 0, 0, 0 },
/* U+3e0a */ { 0, 0, 0, 0, 0 },
/* U+3e0b */ { 0, 0, 0, 0, 0 },
/* U+3e0c */ { 0, 0, 0, 0, 0 },
/* U+3e0d */ { 0, 0, 0, 0, 0 },
/* U+3e0e */ { 0, 0, 0, 0, 0 },
/* U+3e0f */ { 0, 0, 0, 0, 0 },
/* U+3e10 */ { 0, 0, 0, 0, 0 },
/* U+3e11 */ { 0, 0, 0, 0, 0 },
/* U+3e12 */ { 0, 0, 0, 0, 0 },
/* U+3e13 */ { 0, 0, 0, 0, 0 },
/* U+3e14 */ { 0, 0, 0, 0, 0 },
/* U+3e15 */ { 0, 0, 0, 0, 0 },
/* U+3e16 */ { 0, 0, 0, 0, 0 },
/* U+3e17 */ { 0, 0, 0, 0, 0 },
/* U+3e18 */ { 0, 0, 0, 0, 0 },
/* U+3e19 */ { 0, 0, 0, 0, 0 },
/* U+3e1a */ { 0, 0, 0, 0, 0 },
/* U+3e1b */ { 0, 0, 0, 0, 0 },
/* U+3e1c */ { 0, 0, 0, 0, 0 },
/* U+3e1d */ { 0, 0, 0, 0, 0 },
/* U+3e1e */ { 0, 0, 0, 0, 0 },
/* U+3e1f */ { 0, 0, 0, 0, 0 },
/* U+3e20 */ { 0, 0, 0, 0, 0 },
/* U+3e21 */ { 0, 0, 0, 0, 0 },
/* U+3e22 */ { 0, 0, 0, 0, 0 },
/* U+3e23 */ { 0, 0, 0, 0, 0 },
/* U+3e24 */ { 0, 0, 0, 0, 0 },
/* U+3e25 */ { 0, 0, 0, 0, 0 },
/* U+3e26 */ { 0, 0, 0, 0, 0 },
/* U+3e27 */ { 0, 0, 0, 0, 0 },
/* U+3e28 */ { 0, 0, 0, 0, 0 },
/* U+3e29 */ { 0, 0, 0, 0, 0 },
/* U+3e2a */ { 0, 0, 0, 0, 0 },
/* U+3e2b */ { 0, 0, 0, 0, 0 },
/* U+3e2c */ { 0, 0, 0, 0, 0 },
/* U+3e2d */ { 0, 0, 0, 0, 0 },
/* U+3e2e */ { 0, 0, 0, 0, 0 },
/* U+3e2f */ { 0, 0, 0, 0, 0 },
/* U+3e30 */ { 0, 0, 0, 0, 0 },
/* U+3e31 */ { 0, 0, 0, 0, 0 },
/* U+3e32 */ { 0, 0, 0, 0, 0 },
/* U+3e33 */ { 0, 0, 0, 0, 0 },
/* U+3e34 */ { 0, 0, 0, 0, 0 },
/* U+3e35 */ { 0, 0, 0, 0, 0 },
/* U+3e36 */ { 0, 0, 0, 0, 0 },
/* U+3e37 */ { 0, 0, 0, 0, 0 },
/* U+3e38 */ { 0, 0, 0, 0, 0 },
/* U+3e39 */ { 0, 0, 0, 0, 0 },
/* U+3e3a */ { 0, 0, 0, 0, 0 },
/* U+3e3b */ { 0, 0, 0, 0, 0 },
/* U+3e3c */ { 0, 0, 0, 0, 0 },
/* U+3e3d */ { 0, 0, 0, 0, 0 },
/* U+3e3e */ { 0, 0, 0, 0, 0 },
/* U+3e3f */ { 0, 0, 0, 0, 0 },
/* U+3e40 */ { 0, 0, 0, 0, 0 },
/* U+3e41 */ { 0, 0, 0, 0, 0 },
/* U+3e42 */ { 0, 0, 0, 0, 0 },
/* U+3e43 */ { 0, 0, 0, 0, 0 },
/* U+3e44 */ { 0, 0, 0, 0, 0 },
/* U+3e45 */ { 0, 0, 0, 0, 0 },
/* U+3e46 */ { 0, 0, 0, 0, 0 },
/* U+3e47 */ { 0, 0, 0, 0, 0 },
/* U+3e48 */ { 0, 0, 0, 0, 0 },
/* U+3e49 */ { 0, 0, 0, 0, 0 },
/* U+3e4a */ { 0, 0, 0, 0, 0 },
/* U+3e4b */ { 0, 0, 0, 0, 0 },
/* U+3e4c */ { 0, 0, 0, 0, 0 },
/* U+3e4d */ { 0, 0, 0, 0, 0 },
/* U+3e4e */ { 0, 0, 0, 0, 0 },
/* U+3e4f */ { 0, 0, 0, 0, 0 },
/* U+3e50 */ { 0, 0, 0, 0, 0 },
/* U+3e51 */ { 0, 0, 0, 0, 0 },
/* U+3e52 */ { 0, 0, 0, 0, 0 },
/* U+3e53 */ { 0, 0, 0, 0, 0 },
/* U+3e54 */ { 0, 0, 0, 0, 0 },
/* U+3e55 */ { 0, 0, 0, 0, 0 },
/* U+3e56 */ { 0, 0, 0, 0, 0 },
/* U+3e57 */ { 0, 0, 0, 0, 0 },
/* U+3e58 */ { 0, 0, 0, 0, 0 },
/* U+3e59 */ { 0, 0, 0, 0, 0 },
/* U+3e5a */ { 0, 0, 0, 0, 0 },
/* U+3e5b */ { 0, 0, 0, 0, 0 },
/* U+3e5c */ { 0, 0, 0, 0, 0 },
/* U+3e5d */ { 0, 0, 0, 0, 0 },
/* U+3e5e */ { 0, 0, 0, 0, 0 },
/* U+3e5f */ { 0, 0, 0, 0, 0 },
/* U+3e60 */ { 0, 0, 0, 0, 0 },
/* U+3e61 */ { 0, 0, 0, 0, 0 },
/* U+3e62 */ { 0, 0, 0, 0, 0 },
/* U+3e63 */ { 0, 0, 0, 0, 0 },
/* U+3e64 */ { 0, 0, 0, 0, 0 },
/* U+3e65 */ { 0, 0, 0, 0, 0 },
/* U+3e66 */ { 0, 0, 0, 0, 0 },
/* U+3e67 */ { 0, 0, 0, 0, 0 },
/* U+3e68 */ { 0, 0, 0, 0, 0 },
/* U+3e69 */ { 0, 0, 0, 0, 0 },
/* U+3e6a */ { 0, 0, 0, 0, 0 },
/* U+3e6b */ { 0, 0, 0, 0, 0 },
/* U+3e6c */ { 0, 0, 0, 0, 0 },
/* U+3e6d */ { 0, 0, 0, 0, 0 },
/* U+3e6e */ { 0, 0, 0, 0, 0 },
/* U+3e6f */ { 0, 0, 0, 0, 0 },
/* U+3e70 */ { 0, 0, 0, 0, 0 },
/* U+3e71 */ { 0, 0, 0, 0, 0 },
/* U+3e72 */ { 0, 0, 0, 0, 0 },
/* U+3e73 */ { 0, 0, 0, 0, 0 },
/* U+3e74 */ { 0, 0, 0, 0, 0 },
/* U+3e75 */ { 0, 0, 0, 0, 0 },
/* U+3e76 */ { 0, 0, 0, 0, 0 },
/* U+3e77 */ { 0, 0, 0, 0, 0 },
/* U+3e78 */ { 0, 0, 0, 0, 0 },
/* U+3e79 */ { 0, 0, 0, 0, 0 },
/* U+3e7a */ { 0, 0, 0, 0, 0 },
/* U+3e7b */ { 0, 0, 0, 0, 0 },
/* U+3e7c */ { 0, 0, 0, 0, 0 },
/* U+3e7d */ { 0, 0, 0, 0, 0 },
/* U+3e7e */ { 0, 0, 0, 0, 0 },
/* U+3e7f */ { 0, 0, 0, 0, 0 },
/* U+3e80 */ { 0, 0, 0, 0, 0 },
/* U+3e81 */ { 0, 0, 0, 0, 0 },
/* U+3e82 */ { 0, 0, 0, 0, 0 },
/* U+3e83 */ { 0, 0, 0, 0, 0 },
/* U+3e84 */ { 0, 0, 0, 0, 0 },
/* U+3e85 */ { 0, 0, 0, 0, 0 },
/* U+3e86 */ { 0, 0, 0, 0, 0 },
/* U+3e87 */ { 0, 0, 0, 0, 0 },
/* U+3e88 */ { 0, 0, 0, 0, 0 },
/* U+3e89 */ { 0, 0, 0, 0, 0 },
/* U+3e8a */ { 0, 0, 0, 0, 0 },
/* U+3e8b */ { 0, 0, 0, 0, 0 },
/* U+3e8c */ { 0, 0, 0, 0, 0 },
/* U+3e8d */ { 0, 0, 0, 0, 0 },
/* U+3e8e */ { 0, 0, 0, 0, 0 },
/* U+3e8f */ { 0, 0, 0, 0, 0 },
/* U+3e90 */ { 0, 0, 0, 0, 0 },
/* U+3e91 */ { 0, 0, 0, 0, 0 },
/* U+3e92 */ { 0, 0, 0, 0, 0 },
/* U+3e93 */ { 0, 0, 0, 0, 0 },
/* U+3e94 */ { 0, 0, 0, 0, 0 },
/* U+3e95 */ { 0, 0, 0, 0, 0 },
/* U+3e96 */ { 0, 0, 0, 0, 0 },
/* U+3e97 */ { 0, 0, 0, 0, 0 },
/* U+3e98 */ { 0, 0, 0, 0, 0 },
/* U+3e99 */ { 0, 0, 0, 0, 0 },
/* U+3e9a */ { 0, 0, 0, 0, 0 },
/* U+3e9b */ { 0, 0, 0, 0, 0 },
/* U+3e9c */ { 0, 0, 0, 0, 0 },
/* U+3e9d */ { 0, 0, 0, 0, 0 },
/* U+3e9e */ { 0, 0, 0, 0, 0 },
/* U+3e9f */ { 0, 0, 0, 0, 0 },
/* U+3ea0 */ { 0, 0, 0, 0, 0 },
/* U+3ea1 */ { 0, 0, 0, 0, 0 },
/* U+3ea2 */ { 0, 0, 0, 0, 0 },
/* U+3ea3 */ { 0, 0, 0, 0, 0 },
/* U+3ea4 */ { 0, 0, 0, 0, 0 },
/* U+3ea5 */ { 0, 0, 0, 0, 0 },
/* U+3ea6 */ { 0, 0, 0, 0, 0 },
/* U+3ea7 */ { 0, 0, 0, 0, 0 },
/* U+3ea8 */ { 0, 0, 0, 0, 0 },
/* U+3ea9 */ { 0, 0, 0, 0, 0 },
/* U+3eaa */ { 0, 0, 0, 0, 0 },
/* U+3eab */ { 0, 0, 0, 0, 0 },
/* U+3eac */ { 0, 0, 0, 0, 0 },
/* U+3ead */ { 0, 0, 0, 0, 0 },
/* U+3eae */ { 0, 0, 0, 0, 0 },
/* U+3eaf */ { 0, 0, 0, 0, 0 },
/* U+3eb0 */ { 0, 0, 0, 0, 0 },
/* U+3eb1 */ { 0, 0, 0, 0, 0 },
/* U+3eb2 */ { 0, 0, 0, 0, 0 },
/* U+3eb3 */ { 0, 0, 0, 0, 0 },
/* U+3eb4 */ { 0, 0, 0, 0, 0 },
/* U+3eb5 */ { 0, 0, 0, 0, 0 },
/* U+3eb6 */ { 0, 0, 0, 0, 0 },
/* U+3eb7 */ { 0, 0, 0, 0, 0 },
/* U+3eb8 */ { 0, 0, 0, 0, 0 },
/* U+3eb9 */ { 0, 0, 0, 0, 0 },
/* U+3eba */ { 0, 0, 0, 0, 0 },
/* U+3ebb */ { 0, 0, 0, 0, 0 },
/* U+3ebc */ { 0, 0, 0, 0, 0 },
/* U+3ebd */ { 0, 0, 0, 0, 0 },
/* U+3ebe */ { 0, 0, 0, 0, 0 },
/* U+3ebf */ { 0, 0, 0, 0, 0 },
/* U+3ec0 */ { 0, 0, 0, 0, 0 },
/* U+3ec1 */ { 0, 0, 0, 0, 0 },
/* U+3ec2 */ { 0, 0, 0, 0, 0 },
/* U+3ec3 */ { 0, 0, 0, 0, 0 },
/* U+3ec4 */ { 0, 0, 0, 0, 0 },
/* U+3ec5 */ { 0, 0, 0, 0, 0 },
/* U+3ec6 */ { 0, 0, 0, 0, 0 },
/* U+3ec7 */ { 0, 0, 0, 0, 0 },
/* U+3ec8 */ { 0, 0, 0, 0, 0 },
/* U+3ec9 */ { 0, 0, 0, 0, 0 },
/* U+3eca */ { 0, 0, 0, 0, 0 },
/* U+3ecb */ { 0, 0, 0, 0, 0 },
/* U+3ecc */ { 0, 0, 0, 0, 0 },
/* U+3ecd */ { 0, 0, 0, 0, 0 },
/* U+3ece */ { 0, 0, 0, 0, 0 },
/* U+3ecf */ { 0, 0, 0, 0, 0 },
/* U+3ed0 */ { 0, 0, 0, 0, 0 },
/* U+3ed1 */ { 0, 0, 0, 0, 0 },
/* U+3ed2 */ { 0, 0, 0, 0, 0 },
/* U+3ed3 */ { 0, 0, 0, 0, 0 },
/* U+3ed4 */ { 0, 0, 0, 0, 0 },
/* U+3ed5 */ { 0, 0, 0, 0, 0 },
/* U+3ed6 */ { 0, 0, 0, 0, 0 },
/* U+3ed7 */ { 0, 0, 0, 0, 0 },
/* U+3ed8 */ { 0, 0, 0, 0, 0 },
/* U+3ed9 */ { 0, 0, 0, 0, 0 },
/* U+3eda */ { 0, 0, 0, 0, 0 },
/* U+3edb */ { 0, 0, 0, 0, 0 },
/* U+3edc */ { 0, 0, 0, 0, 0 },
/* U+3edd */ { 0, 0, 0, 0, 0 },
/* U+3ede */ { 0, 0, 0, 0, 0 },
/* U+3edf */ { 0, 0, 0, 0, 0 },
/* U+3ee0 */ { 0, 0, 0, 0, 0 },
/* U+3ee1 */ { 0, 0, 0, 0, 0 },
/* U+3ee2 */ { 0, 0, 0, 0, 0 },
/* U+3ee3 */ { 0, 0, 0, 0, 0 },
/* U+3ee4 */ { 0, 0, 0, 0, 0 },
/* U+3ee5 */ { 0, 0, 0, 0, 0 },
/* U+3ee6 */ { 0, 0, 0, 0, 0 },
/* U+3ee7 */ { 0, 0, 0, 0, 0 },
/* U+3ee8 */ { 0, 0, 0, 0, 0 },
/* U+3ee9 */ { 0, 0, 0, 0, 0 },
/* U+3eea */ { 0, 0, 0, 0, 0 },
/* U+3eeb */ { 0, 0, 0, 0, 0 },
/* U+3eec */ { 0, 0, 0, 0, 0 },
/* U+3eed */ { 0, 0, 0, 0, 0 },
/* U+3eee */ { 0, 0, 0, 0, 0 },
/* U+3eef */ { 0, 0, 0, 0, 0 },
/* U+3ef0 */ { 0, 0, 0, 0, 0 },
/* U+3ef1 */ { 0, 0, 0, 0, 0 },
/* U+3ef2 */ { 0, 0, 0, 0, 0 },
/* U+3ef3 */ { 0, 0, 0, 0, 0 },
/* U+3ef4 */ { 0, 0, 0, 0, 0 },
/* U+3ef5 */ { 0, 0, 0, 0, 0 },
/* U+3ef6 */ { 0, 0, 0, 0, 0 },
/* U+3ef7 */ { 0, 0, 0, 0, 0 },
/* U+3ef8 */ { 0, 0, 0, 0, 0 },
/* U+3ef9 */ { 0, 0, 0, 0, 0 },
/* U+3efa */ { 0, 0, 0, 0, 0 },
/* U+3efb */ { 0, 0, 0, 0, 0 },
/* U+3efc */ { 0, 0, 0, 0, 0 },
/* U+3efd */ { 0, 0, 0, 0, 0 },
/* U+3efe */ { 0, 0, 0, 0, 0 },
/* U+3eff */ { 0, 0, 0, 0, 0 },
/* U+3f00 */ { 0, 0, 0, 0, 0 },
/* U+3f01 */ { 0, 0, 0, 0, 0 },
/* U+3f02 */ { 0, 0, 0, 0, 0 },
/* U+3f03 */ { 0, 0, 0, 0, 0 },
/* U+3f04 */ { 0, 0, 0, 0, 0 },
/* U+3f05 */ { 0, 0, 0, 0, 0 },
/* U+3f06 */ { 0, 0, 0, 0, 0 },
/* U+3f07 */ { 0, 0, 0, 0, 0 },
/* U+3f08 */ { 0, 0, 0, 0, 0 },
/* U+3f09 */ { 0, 0, 0, 0, 0 },
/* U+3f0a */ { 0, 0, 0, 0, 0 },
/* U+3f0b */ { 0, 0, 0, 0, 0 },
/* U+3f0c */ { 0, 0, 0, 0, 0 },
/* U+3f0d */ { 0, 0, 0, 0, 0 },
/* U+3f0e */ { 0, 0, 0, 0, 0 },
/* U+3f0f */ { 0, 0, 0, 0, 0 },
/* U+3f10 */ { 0, 0, 0, 0, 0 },
/* U+3f11 */ { 0, 0, 0, 0, 0 },
/* U+3f12 */ { 0, 0, 0, 0, 0 },
/* U+3f13 */ { 0, 0, 0, 0, 0 },
/* U+3f14 */ { 0, 0, 0, 0, 0 },
/* U+3f15 */ { 0, 0, 0, 0, 0 },
/* U+3f16 */ { 0, 0, 0, 0, 0 },
/* U+3f17 */ { 0, 0, 0, 0, 0 },
/* U+3f18 */ { 0, 0, 0, 0, 0 },
/* U+3f19 */ { 0, 0, 0, 0, 0 },
/* U+3f1a */ { 0, 0, 0, 0, 0 },
/* U+3f1b */ { 0, 0, 0, 0, 0 },
/* U+3f1c */ { 0, 0, 0, 0, 0 },
/* U+3f1d */ { 0, 0, 0, 0, 0 },
/* U+3f1e */ { 0, 0, 0, 0, 0 },
/* U+3f1f */ { 0, 0, 0, 0, 0 },
/* U+3f20 */ { 0, 0, 0, 0, 0 },
/* U+3f21 */ { 0, 0, 0, 0, 0 },
/* U+3f22 */ { 0, 0, 0, 0, 0 },
/* U+3f23 */ { 0, 0, 0, 0, 0 },
/* U+3f24 */ { 0, 0, 0, 0, 0 },
/* U+3f25 */ { 0, 0, 0, 0, 0 },
/* U+3f26 */ { 0, 0, 0, 0, 0 },
/* U+3f27 */ { 0, 0, 0, 0, 0 },
/* U+3f28 */ { 0, 0, 0, 0, 0 },
/* U+3f29 */ { 0, 0, 0, 0, 0 },
/* U+3f2a */ { 0, 0, 0, 0, 0 },
/* U+3f2b */ { 0, 0, 0, 0, 0 },
/* U+3f2c */ { 0, 0, 0, 0, 0 },
/* U+3f2d */ { 0, 0, 0, 0, 0 },
/* U+3f2e */ { 0, 0, 0, 0, 0 },
/* U+3f2f */ { 0, 0, 0, 0, 0 },
/* U+3f30 */ { 0, 0, 0, 0, 0 },
/* U+3f31 */ { 0, 0, 0, 0, 0 },
/* U+3f32 */ { 0, 0, 0, 0, 0 },
/* U+3f33 */ { 0, 0, 0, 0, 0 },
/* U+3f34 */ { 0, 0, 0, 0, 0 },
/* U+3f35 */ { 0, 0, 0, 0, 0 },
/* U+3f36 */ { 0, 0, 0, 0, 0 },
/* U+3f37 */ { 0, 0, 0, 0, 0 },
/* U+3f38 */ { 0, 0, 0, 0, 0 },
/* U+3f39 */ { 0, 0, 0, 0, 0 },
/* U+3f3a */ { 0, 0, 0, 0, 0 },
/* U+3f3b */ { 0, 0, 0, 0, 0 },
/* U+3f3c */ { 0, 0, 0, 0, 0 },
/* U+3f3d */ { 0, 0, 0, 0, 0 },
/* U+3f3e */ { 0, 0, 0, 0, 0 },
/* U+3f3f */ { 0, 0, 0, 0, 0 },
/* U+3f40 */ { 0, 0, 0, 0, 0 },
/* U+3f41 */ { 0, 0, 0, 0, 0 },
/* U+3f42 */ { 0, 0, 0, 0, 0 },
/* U+3f43 */ { 0, 0, 0, 0, 0 },
/* U+3f44 */ { 0, 0, 0, 0, 0 },
/* U+3f45 */ { 0, 0, 0, 0, 0 },
/* U+3f46 */ { 0, 0, 0, 0, 0 },
/* U+3f47 */ { 0, 0, 0, 0, 0 },
/* U+3f48 */ { 0, 0, 0, 0, 0 },
/* U+3f49 */ { 0, 0, 0, 0, 0 },
/* U+3f4a */ { 0, 0, 0, 0, 0 },
/* U+3f4b */ { 0, 0, 0, 0, 0 },
/* U+3f4c */ { 0, 0, 0, 0, 0 },
/* U+3f4d */ { 0, 0, 0, 0, 0 },
/* U+3f4e */ { 0, 0, 0, 0, 0 },
/* U+3f4f */ { 0, 0, 0, 0, 0 },
/* U+3f50 */ { 0, 0, 0, 0, 0 },
/* U+3f51 */ { 0, 0, 0, 0, 0 },
/* U+3f52 */ { 0, 0, 0, 0, 0 },
/* U+3f53 */ { 0, 0, 0, 0, 0 },
/* U+3f54 */ { 0, 0, 0, 0, 0 },
/* U+3f55 */ { 0, 0, 0, 0, 0 },
/* U+3f56 */ { 0, 0, 0, 0, 0 },
/* U+3f57 */ { 0, 0, 0, 0, 0 },
/* U+3f58 */ { 0, 0, 0, 0, 0 },
/* U+3f59 */ { 0, 0, 0, 0, 0 },
/* U+3f5a */ { 0, 0, 0, 0, 0 },
/* U+3f5b */ { 0, 0, 0, 0, 0 },
/* U+3f5c */ { 0, 0, 0, 0, 0 },
/* U+3f5d */ { 0, 0, 0, 0, 0 },
/* U+3f5e */ { 0, 0, 0, 0, 0 },
/* U+3f5f */ { 0, 0, 0, 0, 0 },
/* U+3f60 */ { 0, 0, 0, 0, 0 },
/* U+3f61 */ { 0, 0, 0, 0, 0 },
/* U+3f62 */ { 0, 0, 0, 0, 0 },
/* U+3f63 */ { 0, 0, 0, 0, 0 },
/* U+3f64 */ { 0, 0, 0, 0, 0 },
/* U+3f65 */ { 0, 0, 0, 0, 0 },
/* U+3f66 */ { 0, 0, 0, 0, 0 },
/* U+3f67 */ { 0, 0, 0, 0, 0 },
/* U+3f68 */ { 0, 0, 0, 0, 0 },
/* U+3f69 */ { 0, 0, 0, 0, 0 },
/* U+3f6a */ { 0, 0, 0, 0, 0 },
/* U+3f6b */ { 0, 0, 0, 0, 0 },
/* U+3f6c */ { 0, 0, 0, 0, 0 },
/* U+3f6d */ { 0, 0, 0, 0, 0 },
/* U+3f6e */ { 0, 0, 0, 0, 0 },
/* U+3f6f */ { 0, 0, 0, 0, 0 },
/* U+3f70 */ { 0, 0, 0, 0, 0 },
/* U+3f71 */ { 0, 0, 0, 0, 0 },
/* U+3f72 */ { 0, 0, 0, 0, 0 },
/* U+3f73 */ { 0, 0, 0, 0, 0 },
/* U+3f74 */ { 0, 0, 0, 0, 0 },
/* U+3f75 */ { 0, 0, 0, 0, 0 },
/* U+3f76 */ { 0, 0, 0, 0, 0 },
/* U+3f77 */ { 0, 0, 0, 0, 0 },
/* U+3f78 */ { 0, 0, 0, 0, 0 },
/* U+3f79 */ { 0, 0, 0, 0, 0 },
/* U+3f7a */ { 0, 0, 0, 0, 0 },
/* U+3f7b */ { 0, 0, 0, 0, 0 },
/* U+3f7c */ { 0, 0, 0, 0, 0 },
/* U+3f7d */ { 0, 0, 0, 0, 0 },
/* U+3f7e */ { 0, 0, 0, 0, 0 },
/* U+3f7f */ { 0, 0, 0, 0, 0 },
/* U+3f80 */ { 0, 0, 0, 0, 0 },
/* U+3f81 */ { 0, 0, 0, 0, 0 },
/* U+3f82 */ { 0, 0, 0, 0, 0 },
/* U+3f83 */ { 0, 0, 0, 0, 0 },
/* U+3f84 */ { 0, 0, 0, 0, 0 },
/* U+3f85 */ { 0, 0, 0, 0, 0 },
/* U+3f86 */ { 0, 0, 0, 0, 0 },
/* U+3f87 */ { 0, 0, 0, 0, 0 },
/* U+3f88 */ { 0, 0, 0, 0, 0 },
/* U+3f89 */ { 0, 0, 0, 0, 0 },
/* U+3f8a */ { 0, 0, 0, 0, 0 },
/* U+3f8b */ { 0, 0, 0, 0, 0 },
/* U+3f8c */ { 0, 0, 0, 0, 0 },
/* U+3f8d */ { 0, 0, 0, 0, 0 },
/* U+3f8e */ { 0, 0, 0, 0, 0 },
/* U+3f8f */ { 0, 0, 0, 0, 0 },
/* U+3f90 */ { 0, 0, 0, 0, 0 },
/* U+3f91 */ { 0, 0, 0, 0, 0 },
/* U+3f92 */ { 0, 0, 0, 0, 0 },
/* U+3f93 */ { 0, 0, 0, 0, 0 },
/* U+3f94 */ { 0, 0, 0, 0, 0 },
/* U+3f95 */ { 0, 0, 0, 0, 0 },
/* U+3f96 */ { 0, 0, 0, 0, 0 },
/* U+3f97 */ { 0, 0, 0, 0, 0 },
/* U+3f98 */ { 0, 0, 0, 0, 0 },
/* U+3f99 */ { 0, 0, 0, 0, 0 },
/* U+3f9a */ { 0, 0, 0, 0, 0 },
/* U+3f9b */ { 0, 0, 0, 0, 0 },
/* U+3f9c */ { 0, 0, 0, 0, 0 },
/* U+3f9d */ { 0, 0, 0, 0, 0 },
/* U+3f9e */ { 0, 0, 0, 0, 0 },
/* U+3f9f */ { 0, 0, 0, 0, 0 },
/* U+3fa0 */ { 0, 0, 0, 0, 0 },
/* U+3fa1 */ { 0, 0, 0, 0, 0 },
/* U+3fa2 */ { 0, 0, 0, 0, 0 },
/* U+3fa3 */ { 0, 0, 0, 0, 0 },
/* U+3fa4 */ { 0, 0, 0, 0, 0 },
/* U+3fa5 */ { 0, 0, 0, 0, 0 },
/* U+3fa6 */ { 0, 0, 0, 0, 0 },
/* U+3fa7 */ { 0, 0, 0, 0, 0 },
/* U+3fa8 */ { 0, 0, 0, 0, 0 },
/* U+3fa9 */ { 0, 0, 0, 0, 0 },
/* U+3faa */ { 0, 0, 0, 0, 0 },
/* U+3fab */ { 0, 0, 0, 0, 0 },
/* U+3fac */ { 0, 0, 0, 0, 0 },
/* U+3fad */ { 0, 0, 0, 0, 0 },
/* U+3fae */ { 0, 0, 0, 0, 0 },
/* U+3faf */ { 0, 0, 0, 0, 0 },
/* U+3fb0 */ { 0, 0, 0, 0, 0 },
/* U+3fb1 */ { 0, 0, 0, 0, 0 },
/* U+3fb2 */ { 0, 0, 0, 0, 0 },
/* U+3fb3 */ { 0, 0, 0, 0, 0 },
/* U+3fb4 */ { 0, 0, 0, 0, 0 },
/* U+3fb5 */ { 0, 0, 0, 0, 0 },
/* U+3fb6 */ { 0, 0, 0, 0, 0 },
/* U+3fb7 */ { 0, 0, 0, 0, 0 },
/* U+3fb8 */ { 0, 0, 0, 0, 0 },
/* U+3fb9 */ { 0, 0, 0, 0, 0 },
/* U+3fba */ { 0, 0, 0, 0, 0 },
/* U+3fbb */ { 0, 0, 0, 0, 0 },
/* U+3fbc */ { 0, 0, 0, 0, 0 },
/* U+3fbd */ { 0, 0, 0, 0, 0 },
/* U+3fbe */ { 0, 0, 0, 0, 0 },
/* U+3fbf */ { 0, 0, 0, 0, 0 },
/* U+3fc0 */ { 0, 0, 0, 0, 0 },
/* U+3fc1 */ { 0, 0, 0, 0, 0 },
/* U+3fc2 */ { 0, 0, 0, 0, 0 },
/* U+3fc3 */ { 0, 0, 0, 0, 0 },
/* U+3fc4 */ { 0, 0, 0, 0, 0 },
/* U+3fc5 */ { 0, 0, 0, 0, 0 },
/* U+3fc6 */ { 0, 0, 0, 0, 0 },
/* U+3fc7 */ { 0, 0, 0, 0, 0 },
/* U+3fc8 */ { 0, 0, 0, 0, 0 },
/* U+3fc9 */ { 0, 0, 0, 0, 0 },
/* U+3fca */ { 0, 0, 0, 0, 0 },
/* U+3fcb */ { 0, 0, 0, 0, 0 },
/* U+3fcc */ { 0, 0, 0, 0, 0 },
/* U+3fcd */ { 0, 0, 0, 0, 0 },
/* U+3fce */ { 0, 0, 0, 0, 0 },
/* U+3fcf */ { 0, 0, 0, 0, 0 },
/* U+3fd0 */ { 0, 0, 0, 0, 0 },
/* U+3fd1 */ { 0, 0, 0, 0, 0 },
/* U+3fd2 */ { 0, 0, 0, 0, 0 },
/* U+3fd3 */ { 0, 0, 0, 0, 0 },
/* U+3fd4 */ { 0, 0, 0, 0, 0 },
/* U+3fd5 */ { 0, 0, 0, 0, 0 },
/* U+3fd6 */ { 0, 0, 0, 0, 0 },
/* U+3fd7 */ { 0, 0, 0, 0, 0 },
/* U+3fd8 */ { 0, 0, 0, 0, 0 },
/* U+3fd9 */ { 0, 0, 0, 0, 0 },
/* U+3fda */ { 0, 0, 0, 0, 0 },
/* U+3fdb */ { 0, 0, 0, 0, 0 },
/* U+3fdc */ { 0, 0, 0, 0, 0 },
/* U+3fdd */ { 0, 0, 0, 0, 0 },
/* U+3fde */ { 0, 0, 0, 0, 0 },
/* U+3fdf */ { 0, 0, 0, 0, 0 },
/* U+3fe0 */ { 0, 0, 0, 0, 0 },
/* U+3fe1 */ { 0, 0, 0, 0, 0 },
/* U+3fe2 */ { 0, 0, 0, 0, 0 },
/* U+3fe3 */ { 0, 0, 0, 0, 0 },
/* U+3fe4 */ { 0, 0, 0, 0, 0 },
/* U+3fe5 */ { 0, 0, 0, 0, 0 },
/* U+3fe6 */ { 0, 0, 0, 0, 0 },
/* U+3fe7 */ { 0, 0, 0, 0, 0 },
/* U+3fe8 */ { 0, 0, 0, 0, 0 },
/* U+3fe9 */ { 0, 0, 0, 0, 0 },
/* U+3fea */ { 0, 0, 0, 0, 0 },
/* U+3feb */ { 0, 0, 0, 0, 0 },
/* U+3fec */ { 0, 0, 0, 0, 0 },
/* U+3fed */ { 0, 0, 0, 0, 0 },
/* U+3fee */ { 0, 0, 0, 0, 0 },
/* U+3fef */ { 0, 0, 0, 0, 0 },
/* U+3ff0 */ { 0, 0, 0, 0, 0 },
/* U+3ff1 */ { 0, 0, 0, 0, 0 },
/* U+3ff2 */ { 0, 0, 0, 0, 0 },
/* U+3ff3 */ { 0, 0, 0, 0, 0 },
/* U+3ff4 */ { 0, 0, 0, 0, 0 },
/* U+3ff5 */ { 0, 0, 0, 0, 0 },
/* U+3ff6 */ { 0, 0, 0, 0, 0 },
/* U+3ff7 */ { 0, 0, 0, 0, 0 },
/* U+3ff8 */ { 0, 0, 0, 0, 0 },
/* U+3ff9 */ { 0, 0, 0, 0, 0 },
/* U+3ffa */ { 0, 0, 0, 0, 0 },
/* U+3ffb */ { 0, 0, 0, 0, 0 },
/* U+3ffc */ { 0, 0, 0, 0, 0 },
/* U+3ffd */ { 0, 0, 0, 0, 0 },
/* U+3ffe */ { 0, 0, 0, 0, 0 },
/* U+3fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_4[4096] = {
    
/* U+4000 */ { 0, 0, 0, 0, 0 },
/* U+4001 */ { 0, 0, 0, 0, 0 },
/* U+4002 */ { 0, 0, 0, 0, 0 },
/* U+4003 */ { 0, 0, 0, 0, 0 },
/* U+4004 */ { 0, 0, 0, 0, 0 },
/* U+4005 */ { 0, 0, 0, 0, 0 },
/* U+4006 */ { 0, 0, 0, 0, 0 },
/* U+4007 */ { 0, 0, 0, 0, 0 },
/* U+4008 */ { 0, 0, 0, 0, 0 },
/* U+4009 */ { 0, 0, 0, 0, 0 },
/* U+400a */ { 0, 0, 0, 0, 0 },
/* U+400b */ { 0, 0, 0, 0, 0 },
/* U+400c */ { 0, 0, 0, 0, 0 },
/* U+400d */ { 0, 0, 0, 0, 0 },
/* U+400e */ { 0, 0, 0, 0, 0 },
/* U+400f */ { 0, 0, 0, 0, 0 },
/* U+4010 */ { 0, 0, 0, 0, 0 },
/* U+4011 */ { 0, 0, 0, 0, 0 },
/* U+4012 */ { 0, 0, 0, 0, 0 },
/* U+4013 */ { 0, 0, 0, 0, 0 },
/* U+4014 */ { 0, 0, 0, 0, 0 },
/* U+4015 */ { 0, 0, 0, 0, 0 },
/* U+4016 */ { 0, 0, 0, 0, 0 },
/* U+4017 */ { 0, 0, 0, 0, 0 },
/* U+4018 */ { 0, 0, 0, 0, 0 },
/* U+4019 */ { 0, 0, 0, 0, 0 },
/* U+401a */ { 0, 0, 0, 0, 0 },
/* U+401b */ { 0, 0, 0, 0, 0 },
/* U+401c */ { 0, 0, 0, 0, 0 },
/* U+401d */ { 0, 0, 0, 0, 0 },
/* U+401e */ { 0, 0, 0, 0, 0 },
/* U+401f */ { 0, 0, 0, 0, 0 },
/* U+4020 */ { 0, 0, 0, 0, 0 },
/* U+4021 */ { 0, 0, 0, 0, 0 },
/* U+4022 */ { 0, 0, 0, 0, 0 },
/* U+4023 */ { 0, 0, 0, 0, 0 },
/* U+4024 */ { 0, 0, 0, 0, 0 },
/* U+4025 */ { 0, 0, 0, 0, 0 },
/* U+4026 */ { 0, 0, 0, 0, 0 },
/* U+4027 */ { 0, 0, 0, 0, 0 },
/* U+4028 */ { 0, 0, 0, 0, 0 },
/* U+4029 */ { 0, 0, 0, 0, 0 },
/* U+402a */ { 0, 0, 0, 0, 0 },
/* U+402b */ { 0, 0, 0, 0, 0 },
/* U+402c */ { 0, 0, 0, 0, 0 },
/* U+402d */ { 0, 0, 0, 0, 0 },
/* U+402e */ { 0, 0, 0, 0, 0 },
/* U+402f */ { 0, 0, 0, 0, 0 },
/* U+4030 */ { 0, 0, 0, 0, 0 },
/* U+4031 */ { 0, 0, 0, 0, 0 },
/* U+4032 */ { 0, 0, 0, 0, 0 },
/* U+4033 */ { 0, 0, 0, 0, 0 },
/* U+4034 */ { 0, 0, 0, 0, 0 },
/* U+4035 */ { 0, 0, 0, 0, 0 },
/* U+4036 */ { 0, 0, 0, 0, 0 },
/* U+4037 */ { 0, 0, 0, 0, 0 },
/* U+4038 */ { 0, 0, 0, 0, 0 },
/* U+4039 */ { 0, 0, 0, 0, 0 },
/* U+403a */ { 0, 0, 0, 0, 0 },
/* U+403b */ { 0, 0, 0, 0, 0 },
/* U+403c */ { 0, 0, 0, 0, 0 },
/* U+403d */ { 0, 0, 0, 0, 0 },
/* U+403e */ { 0, 0, 0, 0, 0 },
/* U+403f */ { 0, 0, 0, 0, 0 },
/* U+4040 */ { 0, 0, 0, 0, 0 },
/* U+4041 */ { 0, 0, 0, 0, 0 },
/* U+4042 */ { 0, 0, 0, 0, 0 },
/* U+4043 */ { 0, 0, 0, 0, 0 },
/* U+4044 */ { 0, 0, 0, 0, 0 },
/* U+4045 */ { 0, 0, 0, 0, 0 },
/* U+4046 */ { 0, 0, 0, 0, 0 },
/* U+4047 */ { 0, 0, 0, 0, 0 },
/* U+4048 */ { 0, 0, 0, 0, 0 },
/* U+4049 */ { 0, 0, 0, 0, 0 },
/* U+404a */ { 0, 0, 0, 0, 0 },
/* U+404b */ { 0, 0, 0, 0, 0 },
/* U+404c */ { 0, 0, 0, 0, 0 },
/* U+404d */ { 0, 0, 0, 0, 0 },
/* U+404e */ { 0, 0, 0, 0, 0 },
/* U+404f */ { 0, 0, 0, 0, 0 },
/* U+4050 */ { 0, 0, 0, 0, 0 },
/* U+4051 */ { 0, 0, 0, 0, 0 },
/* U+4052 */ { 0, 0, 0, 0, 0 },
/* U+4053 */ { 0, 0, 0, 0, 0 },
/* U+4054 */ { 0, 0, 0, 0, 0 },
/* U+4055 */ { 0, 0, 0, 0, 0 },
/* U+4056 */ { 0, 0, 0, 0, 0 },
/* U+4057 */ { 0, 0, 0, 0, 0 },
/* U+4058 */ { 0, 0, 0, 0, 0 },
/* U+4059 */ { 0, 0, 0, 0, 0 },
/* U+405a */ { 0, 0, 0, 0, 0 },
/* U+405b */ { 0, 0, 0, 0, 0 },
/* U+405c */ { 0, 0, 0, 0, 0 },
/* U+405d */ { 0, 0, 0, 0, 0 },
/* U+405e */ { 0, 0, 0, 0, 0 },
/* U+405f */ { 0, 0, 0, 0, 0 },
/* U+4060 */ { 0, 0, 0, 0, 0 },
/* U+4061 */ { 0, 0, 0, 0, 0 },
/* U+4062 */ { 0, 0, 0, 0, 0 },
/* U+4063 */ { 0, 0, 0, 0, 0 },
/* U+4064 */ { 0, 0, 0, 0, 0 },
/* U+4065 */ { 0, 0, 0, 0, 0 },
/* U+4066 */ { 0, 0, 0, 0, 0 },
/* U+4067 */ { 0, 0, 0, 0, 0 },
/* U+4068 */ { 0, 0, 0, 0, 0 },
/* U+4069 */ { 0, 0, 0, 0, 0 },
/* U+406a */ { 0, 0, 0, 0, 0 },
/* U+406b */ { 0, 0, 0, 0, 0 },
/* U+406c */ { 0, 0, 0, 0, 0 },
/* U+406d */ { 0, 0, 0, 0, 0 },
/* U+406e */ { 0, 0, 0, 0, 0 },
/* U+406f */ { 0, 0, 0, 0, 0 },
/* U+4070 */ { 0, 0, 0, 0, 0 },
/* U+4071 */ { 0, 0, 0, 0, 0 },
/* U+4072 */ { 0, 0, 0, 0, 0 },
/* U+4073 */ { 0, 0, 0, 0, 0 },
/* U+4074 */ { 0, 0, 0, 0, 0 },
/* U+4075 */ { 0, 0, 0, 0, 0 },
/* U+4076 */ { 0, 0, 0, 0, 0 },
/* U+4077 */ { 0, 0, 0, 0, 0 },
/* U+4078 */ { 0, 0, 0, 0, 0 },
/* U+4079 */ { 0, 0, 0, 0, 0 },
/* U+407a */ { 0, 0, 0, 0, 0 },
/* U+407b */ { 0, 0, 0, 0, 0 },
/* U+407c */ { 0, 0, 0, 0, 0 },
/* U+407d */ { 0, 0, 0, 0, 0 },
/* U+407e */ { 0, 0, 0, 0, 0 },
/* U+407f */ { 0, 0, 0, 0, 0 },
/* U+4080 */ { 0, 0, 0, 0, 0 },
/* U+4081 */ { 0, 0, 0, 0, 0 },
/* U+4082 */ { 0, 0, 0, 0, 0 },
/* U+4083 */ { 0, 0, 0, 0, 0 },
/* U+4084 */ { 0, 0, 0, 0, 0 },
/* U+4085 */ { 0, 0, 0, 0, 0 },
/* U+4086 */ { 0, 0, 0, 0, 0 },
/* U+4087 */ { 0, 0, 0, 0, 0 },
/* U+4088 */ { 0, 0, 0, 0, 0 },
/* U+4089 */ { 0, 0, 0, 0, 0 },
/* U+408a */ { 0, 0, 0, 0, 0 },
/* U+408b */ { 0, 0, 0, 0, 0 },
/* U+408c */ { 0, 0, 0, 0, 0 },
/* U+408d */ { 0, 0, 0, 0, 0 },
/* U+408e */ { 0, 0, 0, 0, 0 },
/* U+408f */ { 0, 0, 0, 0, 0 },
/* U+4090 */ { 0, 0, 0, 0, 0 },
/* U+4091 */ { 0, 0, 0, 0, 0 },
/* U+4092 */ { 0, 0, 0, 0, 0 },
/* U+4093 */ { 0, 0, 0, 0, 0 },
/* U+4094 */ { 0, 0, 0, 0, 0 },
/* U+4095 */ { 0, 0, 0, 0, 0 },
/* U+4096 */ { 0, 0, 0, 0, 0 },
/* U+4097 */ { 0, 0, 0, 0, 0 },
/* U+4098 */ { 0, 0, 0, 0, 0 },
/* U+4099 */ { 0, 0, 0, 0, 0 },
/* U+409a */ { 0, 0, 0, 0, 0 },
/* U+409b */ { 0, 0, 0, 0, 0 },
/* U+409c */ { 0, 0, 0, 0, 0 },
/* U+409d */ { 0, 0, 0, 0, 0 },
/* U+409e */ { 0, 0, 0, 0, 0 },
/* U+409f */ { 0, 0, 0, 0, 0 },
/* U+40a0 */ { 0, 0, 0, 0, 0 },
/* U+40a1 */ { 0, 0, 0, 0, 0 },
/* U+40a2 */ { 0, 0, 0, 0, 0 },
/* U+40a3 */ { 0, 0, 0, 0, 0 },
/* U+40a4 */ { 0, 0, 0, 0, 0 },
/* U+40a5 */ { 0, 0, 0, 0, 0 },
/* U+40a6 */ { 0, 0, 0, 0, 0 },
/* U+40a7 */ { 0, 0, 0, 0, 0 },
/* U+40a8 */ { 0, 0, 0, 0, 0 },
/* U+40a9 */ { 0, 0, 0, 0, 0 },
/* U+40aa */ { 0, 0, 0, 0, 0 },
/* U+40ab */ { 0, 0, 0, 0, 0 },
/* U+40ac */ { 0, 0, 0, 0, 0 },
/* U+40ad */ { 0, 0, 0, 0, 0 },
/* U+40ae */ { 0, 0, 0, 0, 0 },
/* U+40af */ { 0, 0, 0, 0, 0 },
/* U+40b0 */ { 0, 0, 0, 0, 0 },
/* U+40b1 */ { 0, 0, 0, 0, 0 },
/* U+40b2 */ { 0, 0, 0, 0, 0 },
/* U+40b3 */ { 0, 0, 0, 0, 0 },
/* U+40b4 */ { 0, 0, 0, 0, 0 },
/* U+40b5 */ { 0, 0, 0, 0, 0 },
/* U+40b6 */ { 0, 0, 0, 0, 0 },
/* U+40b7 */ { 0, 0, 0, 0, 0 },
/* U+40b8 */ { 0, 0, 0, 0, 0 },
/* U+40b9 */ { 0, 0, 0, 0, 0 },
/* U+40ba */ { 0, 0, 0, 0, 0 },
/* U+40bb */ { 0, 0, 0, 0, 0 },
/* U+40bc */ { 0, 0, 0, 0, 0 },
/* U+40bd */ { 0, 0, 0, 0, 0 },
/* U+40be */ { 0, 0, 0, 0, 0 },
/* U+40bf */ { 0, 0, 0, 0, 0 },
/* U+40c0 */ { 0, 0, 0, 0, 0 },
/* U+40c1 */ { 0, 0, 0, 0, 0 },
/* U+40c2 */ { 0, 0, 0, 0, 0 },
/* U+40c3 */ { 0, 0, 0, 0, 0 },
/* U+40c4 */ { 0, 0, 0, 0, 0 },
/* U+40c5 */ { 0, 0, 0, 0, 0 },
/* U+40c6 */ { 0, 0, 0, 0, 0 },
/* U+40c7 */ { 0, 0, 0, 0, 0 },
/* U+40c8 */ { 0, 0, 0, 0, 0 },
/* U+40c9 */ { 0, 0, 0, 0, 0 },
/* U+40ca */ { 0, 0, 0, 0, 0 },
/* U+40cb */ { 0, 0, 0, 0, 0 },
/* U+40cc */ { 0, 0, 0, 0, 0 },
/* U+40cd */ { 0, 0, 0, 0, 0 },
/* U+40ce */ { 0, 0, 0, 0, 0 },
/* U+40cf */ { 0, 0, 0, 0, 0 },
/* U+40d0 */ { 0, 0, 0, 0, 0 },
/* U+40d1 */ { 0, 0, 0, 0, 0 },
/* U+40d2 */ { 0, 0, 0, 0, 0 },
/* U+40d3 */ { 0, 0, 0, 0, 0 },
/* U+40d4 */ { 0, 0, 0, 0, 0 },
/* U+40d5 */ { 0, 0, 0, 0, 0 },
/* U+40d6 */ { 0, 0, 0, 0, 0 },
/* U+40d7 */ { 0, 0, 0, 0, 0 },
/* U+40d8 */ { 0, 0, 0, 0, 0 },
/* U+40d9 */ { 0, 0, 0, 0, 0 },
/* U+40da */ { 0, 0, 0, 0, 0 },
/* U+40db */ { 0, 0, 0, 0, 0 },
/* U+40dc */ { 0, 0, 0, 0, 0 },
/* U+40dd */ { 0, 0, 0, 0, 0 },
/* U+40de */ { 0, 0, 0, 0, 0 },
/* U+40df */ { 0, 0, 0, 0, 0 },
/* U+40e0 */ { 0, 0, 0, 0, 0 },
/* U+40e1 */ { 0, 0, 0, 0, 0 },
/* U+40e2 */ { 0, 0, 0, 0, 0 },
/* U+40e3 */ { 0, 0, 0, 0, 0 },
/* U+40e4 */ { 0, 0, 0, 0, 0 },
/* U+40e5 */ { 0, 0, 0, 0, 0 },
/* U+40e6 */ { 0, 0, 0, 0, 0 },
/* U+40e7 */ { 0, 0, 0, 0, 0 },
/* U+40e8 */ { 0, 0, 0, 0, 0 },
/* U+40e9 */ { 0, 0, 0, 0, 0 },
/* U+40ea */ { 0, 0, 0, 0, 0 },
/* U+40eb */ { 0, 0, 0, 0, 0 },
/* U+40ec */ { 0, 0, 0, 0, 0 },
/* U+40ed */ { 0, 0, 0, 0, 0 },
/* U+40ee */ { 0, 0, 0, 0, 0 },
/* U+40ef */ { 0, 0, 0, 0, 0 },
/* U+40f0 */ { 0, 0, 0, 0, 0 },
/* U+40f1 */ { 0, 0, 0, 0, 0 },
/* U+40f2 */ { 0, 0, 0, 0, 0 },
/* U+40f3 */ { 0, 0, 0, 0, 0 },
/* U+40f4 */ { 0, 0, 0, 0, 0 },
/* U+40f5 */ { 0, 0, 0, 0, 0 },
/* U+40f6 */ { 0, 0, 0, 0, 0 },
/* U+40f7 */ { 0, 0, 0, 0, 0 },
/* U+40f8 */ { 0, 0, 0, 0, 0 },
/* U+40f9 */ { 0, 0, 0, 0, 0 },
/* U+40fa */ { 0, 0, 0, 0, 0 },
/* U+40fb */ { 0, 0, 0, 0, 0 },
/* U+40fc */ { 0, 0, 0, 0, 0 },
/* U+40fd */ { 0, 0, 0, 0, 0 },
/* U+40fe */ { 0, 0, 0, 0, 0 },
/* U+40ff */ { 0, 0, 0, 0, 0 },
/* U+4100 */ { 0, 0, 0, 0, 0 },
/* U+4101 */ { 0, 0, 0, 0, 0 },
/* U+4102 */ { 0, 0, 0, 0, 0 },
/* U+4103 */ { 0, 0, 0, 0, 0 },
/* U+4104 */ { 0, 0, 0, 0, 0 },
/* U+4105 */ { 0, 0, 0, 0, 0 },
/* U+4106 */ { 0, 0, 0, 0, 0 },
/* U+4107 */ { 0, 0, 0, 0, 0 },
/* U+4108 */ { 0, 0, 0, 0, 0 },
/* U+4109 */ { 0, 0, 0, 0, 0 },
/* U+410a */ { 0, 0, 0, 0, 0 },
/* U+410b */ { 0, 0, 0, 0, 0 },
/* U+410c */ { 0, 0, 0, 0, 0 },
/* U+410d */ { 0, 0, 0, 0, 0 },
/* U+410e */ { 0, 0, 0, 0, 0 },
/* U+410f */ { 0, 0, 0, 0, 0 },
/* U+4110 */ { 0, 0, 0, 0, 0 },
/* U+4111 */ { 0, 0, 0, 0, 0 },
/* U+4112 */ { 0, 0, 0, 0, 0 },
/* U+4113 */ { 0, 0, 0, 0, 0 },
/* U+4114 */ { 0, 0, 0, 0, 0 },
/* U+4115 */ { 0, 0, 0, 0, 0 },
/* U+4116 */ { 0, 0, 0, 0, 0 },
/* U+4117 */ { 0, 0, 0, 0, 0 },
/* U+4118 */ { 0, 0, 0, 0, 0 },
/* U+4119 */ { 0, 0, 0, 0, 0 },
/* U+411a */ { 0, 0, 0, 0, 0 },
/* U+411b */ { 0, 0, 0, 0, 0 },
/* U+411c */ { 0, 0, 0, 0, 0 },
/* U+411d */ { 0, 0, 0, 0, 0 },
/* U+411e */ { 0, 0, 0, 0, 0 },
/* U+411f */ { 0, 0, 0, 0, 0 },
/* U+4120 */ { 0, 0, 0, 0, 0 },
/* U+4121 */ { 0, 0, 0, 0, 0 },
/* U+4122 */ { 0, 0, 0, 0, 0 },
/* U+4123 */ { 0, 0, 0, 0, 0 },
/* U+4124 */ { 0, 0, 0, 0, 0 },
/* U+4125 */ { 0, 0, 0, 0, 0 },
/* U+4126 */ { 0, 0, 0, 0, 0 },
/* U+4127 */ { 0, 0, 0, 0, 0 },
/* U+4128 */ { 0, 0, 0, 0, 0 },
/* U+4129 */ { 0, 0, 0, 0, 0 },
/* U+412a */ { 0, 0, 0, 0, 0 },
/* U+412b */ { 0, 0, 0, 0, 0 },
/* U+412c */ { 0, 0, 0, 0, 0 },
/* U+412d */ { 0, 0, 0, 0, 0 },
/* U+412e */ { 0, 0, 0, 0, 0 },
/* U+412f */ { 0, 0, 0, 0, 0 },
/* U+4130 */ { 0, 0, 0, 0, 0 },
/* U+4131 */ { 0, 0, 0, 0, 0 },
/* U+4132 */ { 0, 0, 0, 0, 0 },
/* U+4133 */ { 0, 0, 0, 0, 0 },
/* U+4134 */ { 0, 0, 0, 0, 0 },
/* U+4135 */ { 0, 0, 0, 0, 0 },
/* U+4136 */ { 0, 0, 0, 0, 0 },
/* U+4137 */ { 0, 0, 0, 0, 0 },
/* U+4138 */ { 0, 0, 0, 0, 0 },
/* U+4139 */ { 0, 0, 0, 0, 0 },
/* U+413a */ { 0, 0, 0, 0, 0 },
/* U+413b */ { 0, 0, 0, 0, 0 },
/* U+413c */ { 0, 0, 0, 0, 0 },
/* U+413d */ { 0, 0, 0, 0, 0 },
/* U+413e */ { 0, 0, 0, 0, 0 },
/* U+413f */ { 0, 0, 0, 0, 0 },
/* U+4140 */ { 0, 0, 0, 0, 0 },
/* U+4141 */ { 0, 0, 0, 0, 0 },
/* U+4142 */ { 0, 0, 0, 0, 0 },
/* U+4143 */ { 0, 0, 0, 0, 0 },
/* U+4144 */ { 0, 0, 0, 0, 0 },
/* U+4145 */ { 0, 0, 0, 0, 0 },
/* U+4146 */ { 0, 0, 0, 0, 0 },
/* U+4147 */ { 0, 0, 0, 0, 0 },
/* U+4148 */ { 0, 0, 0, 0, 0 },
/* U+4149 */ { 0, 0, 0, 0, 0 },
/* U+414a */ { 0, 0, 0, 0, 0 },
/* U+414b */ { 0, 0, 0, 0, 0 },
/* U+414c */ { 0, 0, 0, 0, 0 },
/* U+414d */ { 0, 0, 0, 0, 0 },
/* U+414e */ { 0, 0, 0, 0, 0 },
/* U+414f */ { 0, 0, 0, 0, 0 },
/* U+4150 */ { 0, 0, 0, 0, 0 },
/* U+4151 */ { 0, 0, 0, 0, 0 },
/* U+4152 */ { 0, 0, 0, 0, 0 },
/* U+4153 */ { 0, 0, 0, 0, 0 },
/* U+4154 */ { 0, 0, 0, 0, 0 },
/* U+4155 */ { 0, 0, 0, 0, 0 },
/* U+4156 */ { 0, 0, 0, 0, 0 },
/* U+4157 */ { 0, 0, 0, 0, 0 },
/* U+4158 */ { 0, 0, 0, 0, 0 },
/* U+4159 */ { 0, 0, 0, 0, 0 },
/* U+415a */ { 0, 0, 0, 0, 0 },
/* U+415b */ { 0, 0, 0, 0, 0 },
/* U+415c */ { 0, 0, 0, 0, 0 },
/* U+415d */ { 0, 0, 0, 0, 0 },
/* U+415e */ { 0, 0, 0, 0, 0 },
/* U+415f */ { 0, 0, 0, 0, 0 },
/* U+4160 */ { 0, 0, 0, 0, 0 },
/* U+4161 */ { 0, 0, 0, 0, 0 },
/* U+4162 */ { 0, 0, 0, 0, 0 },
/* U+4163 */ { 0, 0, 0, 0, 0 },
/* U+4164 */ { 0, 0, 0, 0, 0 },
/* U+4165 */ { 0, 0, 0, 0, 0 },
/* U+4166 */ { 0, 0, 0, 0, 0 },
/* U+4167 */ { 0, 0, 0, 0, 0 },
/* U+4168 */ { 0, 0, 0, 0, 0 },
/* U+4169 */ { 0, 0, 0, 0, 0 },
/* U+416a */ { 0, 0, 0, 0, 0 },
/* U+416b */ { 0, 0, 0, 0, 0 },
/* U+416c */ { 0, 0, 0, 0, 0 },
/* U+416d */ { 0, 0, 0, 0, 0 },
/* U+416e */ { 0, 0, 0, 0, 0 },
/* U+416f */ { 0, 0, 0, 0, 0 },
/* U+4170 */ { 0, 0, 0, 0, 0 },
/* U+4171 */ { 0, 0, 0, 0, 0 },
/* U+4172 */ { 0, 0, 0, 0, 0 },
/* U+4173 */ { 0, 0, 0, 0, 0 },
/* U+4174 */ { 0, 0, 0, 0, 0 },
/* U+4175 */ { 0, 0, 0, 0, 0 },
/* U+4176 */ { 0, 0, 0, 0, 0 },
/* U+4177 */ { 0, 0, 0, 0, 0 },
/* U+4178 */ { 0, 0, 0, 0, 0 },
/* U+4179 */ { 0, 0, 0, 0, 0 },
/* U+417a */ { 0, 0, 0, 0, 0 },
/* U+417b */ { 0, 0, 0, 0, 0 },
/* U+417c */ { 0, 0, 0, 0, 0 },
/* U+417d */ { 0, 0, 0, 0, 0 },
/* U+417e */ { 0, 0, 0, 0, 0 },
/* U+417f */ { 0, 0, 0, 0, 0 },
/* U+4180 */ { 0, 0, 0, 0, 0 },
/* U+4181 */ { 0, 0, 0, 0, 0 },
/* U+4182 */ { 0, 0, 0, 0, 0 },
/* U+4183 */ { 0, 0, 0, 0, 0 },
/* U+4184 */ { 0, 0, 0, 0, 0 },
/* U+4185 */ { 0, 0, 0, 0, 0 },
/* U+4186 */ { 0, 0, 0, 0, 0 },
/* U+4187 */ { 0, 0, 0, 0, 0 },
/* U+4188 */ { 0, 0, 0, 0, 0 },
/* U+4189 */ { 0, 0, 0, 0, 0 },
/* U+418a */ { 0, 0, 0, 0, 0 },
/* U+418b */ { 0, 0, 0, 0, 0 },
/* U+418c */ { 0, 0, 0, 0, 0 },
/* U+418d */ { 0, 0, 0, 0, 0 },
/* U+418e */ { 0, 0, 0, 0, 0 },
/* U+418f */ { 0, 0, 0, 0, 0 },
/* U+4190 */ { 0, 0, 0, 0, 0 },
/* U+4191 */ { 0, 0, 0, 0, 0 },
/* U+4192 */ { 0, 0, 0, 0, 0 },
/* U+4193 */ { 0, 0, 0, 0, 0 },
/* U+4194 */ { 0, 0, 0, 0, 0 },
/* U+4195 */ { 0, 0, 0, 0, 0 },
/* U+4196 */ { 0, 0, 0, 0, 0 },
/* U+4197 */ { 0, 0, 0, 0, 0 },
/* U+4198 */ { 0, 0, 0, 0, 0 },
/* U+4199 */ { 0, 0, 0, 0, 0 },
/* U+419a */ { 0, 0, 0, 0, 0 },
/* U+419b */ { 0, 0, 0, 0, 0 },
/* U+419c */ { 0, 0, 0, 0, 0 },
/* U+419d */ { 0, 0, 0, 0, 0 },
/* U+419e */ { 0, 0, 0, 0, 0 },
/* U+419f */ { 0, 0, 0, 0, 0 },
/* U+41a0 */ { 0, 0, 0, 0, 0 },
/* U+41a1 */ { 0, 0, 0, 0, 0 },
/* U+41a2 */ { 0, 0, 0, 0, 0 },
/* U+41a3 */ { 0, 0, 0, 0, 0 },
/* U+41a4 */ { 0, 0, 0, 0, 0 },
/* U+41a5 */ { 0, 0, 0, 0, 0 },
/* U+41a6 */ { 0, 0, 0, 0, 0 },
/* U+41a7 */ { 0, 0, 0, 0, 0 },
/* U+41a8 */ { 0, 0, 0, 0, 0 },
/* U+41a9 */ { 0, 0, 0, 0, 0 },
/* U+41aa */ { 0, 0, 0, 0, 0 },
/* U+41ab */ { 0, 0, 0, 0, 0 },
/* U+41ac */ { 0, 0, 0, 0, 0 },
/* U+41ad */ { 0, 0, 0, 0, 0 },
/* U+41ae */ { 0, 0, 0, 0, 0 },
/* U+41af */ { 0, 0, 0, 0, 0 },
/* U+41b0 */ { 0, 0, 0, 0, 0 },
/* U+41b1 */ { 0, 0, 0, 0, 0 },
/* U+41b2 */ { 0, 0, 0, 0, 0 },
/* U+41b3 */ { 0, 0, 0, 0, 0 },
/* U+41b4 */ { 0, 0, 0, 0, 0 },
/* U+41b5 */ { 0, 0, 0, 0, 0 },
/* U+41b6 */ { 0, 0, 0, 0, 0 },
/* U+41b7 */ { 0, 0, 0, 0, 0 },
/* U+41b8 */ { 0, 0, 0, 0, 0 },
/* U+41b9 */ { 0, 0, 0, 0, 0 },
/* U+41ba */ { 0, 0, 0, 0, 0 },
/* U+41bb */ { 0, 0, 0, 0, 0 },
/* U+41bc */ { 0, 0, 0, 0, 0 },
/* U+41bd */ { 0, 0, 0, 0, 0 },
/* U+41be */ { 0, 0, 0, 0, 0 },
/* U+41bf */ { 0, 0, 0, 0, 0 },
/* U+41c0 */ { 0, 0, 0, 0, 0 },
/* U+41c1 */ { 0, 0, 0, 0, 0 },
/* U+41c2 */ { 0, 0, 0, 0, 0 },
/* U+41c3 */ { 0, 0, 0, 0, 0 },
/* U+41c4 */ { 0, 0, 0, 0, 0 },
/* U+41c5 */ { 0, 0, 0, 0, 0 },
/* U+41c6 */ { 0, 0, 0, 0, 0 },
/* U+41c7 */ { 0, 0, 0, 0, 0 },
/* U+41c8 */ { 0, 0, 0, 0, 0 },
/* U+41c9 */ { 0, 0, 0, 0, 0 },
/* U+41ca */ { 0, 0, 0, 0, 0 },
/* U+41cb */ { 0, 0, 0, 0, 0 },
/* U+41cc */ { 0, 0, 0, 0, 0 },
/* U+41cd */ { 0, 0, 0, 0, 0 },
/* U+41ce */ { 0, 0, 0, 0, 0 },
/* U+41cf */ { 0, 0, 0, 0, 0 },
/* U+41d0 */ { 0, 0, 0, 0, 0 },
/* U+41d1 */ { 0, 0, 0, 0, 0 },
/* U+41d2 */ { 0, 0, 0, 0, 0 },
/* U+41d3 */ { 0, 0, 0, 0, 0 },
/* U+41d4 */ { 0, 0, 0, 0, 0 },
/* U+41d5 */ { 0, 0, 0, 0, 0 },
/* U+41d6 */ { 0, 0, 0, 0, 0 },
/* U+41d7 */ { 0, 0, 0, 0, 0 },
/* U+41d8 */ { 0, 0, 0, 0, 0 },
/* U+41d9 */ { 0, 0, 0, 0, 0 },
/* U+41da */ { 0, 0, 0, 0, 0 },
/* U+41db */ { 0, 0, 0, 0, 0 },
/* U+41dc */ { 0, 0, 0, 0, 0 },
/* U+41dd */ { 0, 0, 0, 0, 0 },
/* U+41de */ { 0, 0, 0, 0, 0 },
/* U+41df */ { 0, 0, 0, 0, 0 },
/* U+41e0 */ { 0, 0, 0, 0, 0 },
/* U+41e1 */ { 0, 0, 0, 0, 0 },
/* U+41e2 */ { 0, 0, 0, 0, 0 },
/* U+41e3 */ { 0, 0, 0, 0, 0 },
/* U+41e4 */ { 0, 0, 0, 0, 0 },
/* U+41e5 */ { 0, 0, 0, 0, 0 },
/* U+41e6 */ { 0, 0, 0, 0, 0 },
/* U+41e7 */ { 0, 0, 0, 0, 0 },
/* U+41e8 */ { 0, 0, 0, 0, 0 },
/* U+41e9 */ { 0, 0, 0, 0, 0 },
/* U+41ea */ { 0, 0, 0, 0, 0 },
/* U+41eb */ { 0, 0, 0, 0, 0 },
/* U+41ec */ { 0, 0, 0, 0, 0 },
/* U+41ed */ { 0, 0, 0, 0, 0 },
/* U+41ee */ { 0, 0, 0, 0, 0 },
/* U+41ef */ { 0, 0, 0, 0, 0 },
/* U+41f0 */ { 0, 0, 0, 0, 0 },
/* U+41f1 */ { 0, 0, 0, 0, 0 },
/* U+41f2 */ { 0, 0, 0, 0, 0 },
/* U+41f3 */ { 0, 0, 0, 0, 0 },
/* U+41f4 */ { 0, 0, 0, 0, 0 },
/* U+41f5 */ { 0, 0, 0, 0, 0 },
/* U+41f6 */ { 0, 0, 0, 0, 0 },
/* U+41f7 */ { 0, 0, 0, 0, 0 },
/* U+41f8 */ { 0, 0, 0, 0, 0 },
/* U+41f9 */ { 0, 0, 0, 0, 0 },
/* U+41fa */ { 0, 0, 0, 0, 0 },
/* U+41fb */ { 0, 0, 0, 0, 0 },
/* U+41fc */ { 0, 0, 0, 0, 0 },
/* U+41fd */ { 0, 0, 0, 0, 0 },
/* U+41fe */ { 0, 0, 0, 0, 0 },
/* U+41ff */ { 0, 0, 0, 0, 0 },
/* U+4200 */ { 0, 0, 0, 0, 0 },
/* U+4201 */ { 0, 0, 0, 0, 0 },
/* U+4202 */ { 0, 0, 0, 0, 0 },
/* U+4203 */ { 0, 0, 0, 0, 0 },
/* U+4204 */ { 0, 0, 0, 0, 0 },
/* U+4205 */ { 0, 0, 0, 0, 0 },
/* U+4206 */ { 0, 0, 0, 0, 0 },
/* U+4207 */ { 0, 0, 0, 0, 0 },
/* U+4208 */ { 0, 0, 0, 0, 0 },
/* U+4209 */ { 0, 0, 0, 0, 0 },
/* U+420a */ { 0, 0, 0, 0, 0 },
/* U+420b */ { 0, 0, 0, 0, 0 },
/* U+420c */ { 0, 0, 0, 0, 0 },
/* U+420d */ { 0, 0, 0, 0, 0 },
/* U+420e */ { 0, 0, 0, 0, 0 },
/* U+420f */ { 0, 0, 0, 0, 0 },
/* U+4210 */ { 0, 0, 0, 0, 0 },
/* U+4211 */ { 0, 0, 0, 0, 0 },
/* U+4212 */ { 0, 0, 0, 0, 0 },
/* U+4213 */ { 0, 0, 0, 0, 0 },
/* U+4214 */ { 0, 0, 0, 0, 0 },
/* U+4215 */ { 0, 0, 0, 0, 0 },
/* U+4216 */ { 0, 0, 0, 0, 0 },
/* U+4217 */ { 0, 0, 0, 0, 0 },
/* U+4218 */ { 0, 0, 0, 0, 0 },
/* U+4219 */ { 0, 0, 0, 0, 0 },
/* U+421a */ { 0, 0, 0, 0, 0 },
/* U+421b */ { 0, 0, 0, 0, 0 },
/* U+421c */ { 0, 0, 0, 0, 0 },
/* U+421d */ { 0, 0, 0, 0, 0 },
/* U+421e */ { 0, 0, 0, 0, 0 },
/* U+421f */ { 0, 0, 0, 0, 0 },
/* U+4220 */ { 0, 0, 0, 0, 0 },
/* U+4221 */ { 0, 0, 0, 0, 0 },
/* U+4222 */ { 0, 0, 0, 0, 0 },
/* U+4223 */ { 0, 0, 0, 0, 0 },
/* U+4224 */ { 0, 0, 0, 0, 0 },
/* U+4225 */ { 0, 0, 0, 0, 0 },
/* U+4226 */ { 0, 0, 0, 0, 0 },
/* U+4227 */ { 0, 0, 0, 0, 0 },
/* U+4228 */ { 0, 0, 0, 0, 0 },
/* U+4229 */ { 0, 0, 0, 0, 0 },
/* U+422a */ { 0, 0, 0, 0, 0 },
/* U+422b */ { 0, 0, 0, 0, 0 },
/* U+422c */ { 0, 0, 0, 0, 0 },
/* U+422d */ { 0, 0, 0, 0, 0 },
/* U+422e */ { 0, 0, 0, 0, 0 },
/* U+422f */ { 0, 0, 0, 0, 0 },
/* U+4230 */ { 0, 0, 0, 0, 0 },
/* U+4231 */ { 0, 0, 0, 0, 0 },
/* U+4232 */ { 0, 0, 0, 0, 0 },
/* U+4233 */ { 0, 0, 0, 0, 0 },
/* U+4234 */ { 0, 0, 0, 0, 0 },
/* U+4235 */ { 0, 0, 0, 0, 0 },
/* U+4236 */ { 0, 0, 0, 0, 0 },
/* U+4237 */ { 0, 0, 0, 0, 0 },
/* U+4238 */ { 0, 0, 0, 0, 0 },
/* U+4239 */ { 0, 0, 0, 0, 0 },
/* U+423a */ { 0, 0, 0, 0, 0 },
/* U+423b */ { 0, 0, 0, 0, 0 },
/* U+423c */ { 0, 0, 0, 0, 0 },
/* U+423d */ { 0, 0, 0, 0, 0 },
/* U+423e */ { 0, 0, 0, 0, 0 },
/* U+423f */ { 0, 0, 0, 0, 0 },
/* U+4240 */ { 0, 0, 0, 0, 0 },
/* U+4241 */ { 0, 0, 0, 0, 0 },
/* U+4242 */ { 0, 0, 0, 0, 0 },
/* U+4243 */ { 0, 0, 0, 0, 0 },
/* U+4244 */ { 0, 0, 0, 0, 0 },
/* U+4245 */ { 0, 0, 0, 0, 0 },
/* U+4246 */ { 0, 0, 0, 0, 0 },
/* U+4247 */ { 0, 0, 0, 0, 0 },
/* U+4248 */ { 0, 0, 0, 0, 0 },
/* U+4249 */ { 0, 0, 0, 0, 0 },
/* U+424a */ { 0, 0, 0, 0, 0 },
/* U+424b */ { 0, 0, 0, 0, 0 },
/* U+424c */ { 0, 0, 0, 0, 0 },
/* U+424d */ { 0, 0, 0, 0, 0 },
/* U+424e */ { 0, 0, 0, 0, 0 },
/* U+424f */ { 0, 0, 0, 0, 0 },
/* U+4250 */ { 0, 0, 0, 0, 0 },
/* U+4251 */ { 0, 0, 0, 0, 0 },
/* U+4252 */ { 0, 0, 0, 0, 0 },
/* U+4253 */ { 0, 0, 0, 0, 0 },
/* U+4254 */ { 0, 0, 0, 0, 0 },
/* U+4255 */ { 0, 0, 0, 0, 0 },
/* U+4256 */ { 0, 0, 0, 0, 0 },
/* U+4257 */ { 0, 0, 0, 0, 0 },
/* U+4258 */ { 0, 0, 0, 0, 0 },
/* U+4259 */ { 0, 0, 0, 0, 0 },
/* U+425a */ { 0, 0, 0, 0, 0 },
/* U+425b */ { 0, 0, 0, 0, 0 },
/* U+425c */ { 0, 0, 0, 0, 0 },
/* U+425d */ { 0, 0, 0, 0, 0 },
/* U+425e */ { 0, 0, 0, 0, 0 },
/* U+425f */ { 0, 0, 0, 0, 0 },
/* U+4260 */ { 0, 0, 0, 0, 0 },
/* U+4261 */ { 0, 0, 0, 0, 0 },
/* U+4262 */ { 0, 0, 0, 0, 0 },
/* U+4263 */ { 0, 0, 0, 0, 0 },
/* U+4264 */ { 0, 0, 0, 0, 0 },
/* U+4265 */ { 0, 0, 0, 0, 0 },
/* U+4266 */ { 0, 0, 0, 0, 0 },
/* U+4267 */ { 0, 0, 0, 0, 0 },
/* U+4268 */ { 0, 0, 0, 0, 0 },
/* U+4269 */ { 0, 0, 0, 0, 0 },
/* U+426a */ { 0, 0, 0, 0, 0 },
/* U+426b */ { 0, 0, 0, 0, 0 },
/* U+426c */ { 0, 0, 0, 0, 0 },
/* U+426d */ { 0, 0, 0, 0, 0 },
/* U+426e */ { 0, 0, 0, 0, 0 },
/* U+426f */ { 0, 0, 0, 0, 0 },
/* U+4270 */ { 0, 0, 0, 0, 0 },
/* U+4271 */ { 0, 0, 0, 0, 0 },
/* U+4272 */ { 0, 0, 0, 0, 0 },
/* U+4273 */ { 0, 0, 0, 0, 0 },
/* U+4274 */ { 0, 0, 0, 0, 0 },
/* U+4275 */ { 0, 0, 0, 0, 0 },
/* U+4276 */ { 0, 0, 0, 0, 0 },
/* U+4277 */ { 0, 0, 0, 0, 0 },
/* U+4278 */ { 0, 0, 0, 0, 0 },
/* U+4279 */ { 0, 0, 0, 0, 0 },
/* U+427a */ { 0, 0, 0, 0, 0 },
/* U+427b */ { 0, 0, 0, 0, 0 },
/* U+427c */ { 0, 0, 0, 0, 0 },
/* U+427d */ { 0, 0, 0, 0, 0 },
/* U+427e */ { 0, 0, 0, 0, 0 },
/* U+427f */ { 0, 0, 0, 0, 0 },
/* U+4280 */ { 0, 0, 0, 0, 0 },
/* U+4281 */ { 0, 0, 0, 0, 0 },
/* U+4282 */ { 0, 0, 0, 0, 0 },
/* U+4283 */ { 0, 0, 0, 0, 0 },
/* U+4284 */ { 0, 0, 0, 0, 0 },
/* U+4285 */ { 0, 0, 0, 0, 0 },
/* U+4286 */ { 0, 0, 0, 0, 0 },
/* U+4287 */ { 0, 0, 0, 0, 0 },
/* U+4288 */ { 0, 0, 0, 0, 0 },
/* U+4289 */ { 0, 0, 0, 0, 0 },
/* U+428a */ { 0, 0, 0, 0, 0 },
/* U+428b */ { 0, 0, 0, 0, 0 },
/* U+428c */ { 0, 0, 0, 0, 0 },
/* U+428d */ { 0, 0, 0, 0, 0 },
/* U+428e */ { 0, 0, 0, 0, 0 },
/* U+428f */ { 0, 0, 0, 0, 0 },
/* U+4290 */ { 0, 0, 0, 0, 0 },
/* U+4291 */ { 0, 0, 0, 0, 0 },
/* U+4292 */ { 0, 0, 0, 0, 0 },
/* U+4293 */ { 0, 0, 0, 0, 0 },
/* U+4294 */ { 0, 0, 0, 0, 0 },
/* U+4295 */ { 0, 0, 0, 0, 0 },
/* U+4296 */ { 0, 0, 0, 0, 0 },
/* U+4297 */ { 0, 0, 0, 0, 0 },
/* U+4298 */ { 0, 0, 0, 0, 0 },
/* U+4299 */ { 0, 0, 0, 0, 0 },
/* U+429a */ { 0, 0, 0, 0, 0 },
/* U+429b */ { 0, 0, 0, 0, 0 },
/* U+429c */ { 0, 0, 0, 0, 0 },
/* U+429d */ { 0, 0, 0, 0, 0 },
/* U+429e */ { 0, 0, 0, 0, 0 },
/* U+429f */ { 0, 0, 0, 0, 0 },
/* U+42a0 */ { 0, 0, 0, 0, 0 },
/* U+42a1 */ { 0, 0, 0, 0, 0 },
/* U+42a2 */ { 0, 0, 0, 0, 0 },
/* U+42a3 */ { 0, 0, 0, 0, 0 },
/* U+42a4 */ { 0, 0, 0, 0, 0 },
/* U+42a5 */ { 0, 0, 0, 0, 0 },
/* U+42a6 */ { 0, 0, 0, 0, 0 },
/* U+42a7 */ { 0, 0, 0, 0, 0 },
/* U+42a8 */ { 0, 0, 0, 0, 0 },
/* U+42a9 */ { 0, 0, 0, 0, 0 },
/* U+42aa */ { 0, 0, 0, 0, 0 },
/* U+42ab */ { 0, 0, 0, 0, 0 },
/* U+42ac */ { 0, 0, 0, 0, 0 },
/* U+42ad */ { 0, 0, 0, 0, 0 },
/* U+42ae */ { 0, 0, 0, 0, 0 },
/* U+42af */ { 0, 0, 0, 0, 0 },
/* U+42b0 */ { 0, 0, 0, 0, 0 },
/* U+42b1 */ { 0, 0, 0, 0, 0 },
/* U+42b2 */ { 0, 0, 0, 0, 0 },
/* U+42b3 */ { 0, 0, 0, 0, 0 },
/* U+42b4 */ { 0, 0, 0, 0, 0 },
/* U+42b5 */ { 0, 0, 0, 0, 0 },
/* U+42b6 */ { 0, 0, 0, 0, 0 },
/* U+42b7 */ { 0, 0, 0, 0, 0 },
/* U+42b8 */ { 0, 0, 0, 0, 0 },
/* U+42b9 */ { 0, 0, 0, 0, 0 },
/* U+42ba */ { 0, 0, 0, 0, 0 },
/* U+42bb */ { 0, 0, 0, 0, 0 },
/* U+42bc */ { 0, 0, 0, 0, 0 },
/* U+42bd */ { 0, 0, 0, 0, 0 },
/* U+42be */ { 0, 0, 0, 0, 0 },
/* U+42bf */ { 0, 0, 0, 0, 0 },
/* U+42c0 */ { 0, 0, 0, 0, 0 },
/* U+42c1 */ { 0, 0, 0, 0, 0 },
/* U+42c2 */ { 0, 0, 0, 0, 0 },
/* U+42c3 */ { 0, 0, 0, 0, 0 },
/* U+42c4 */ { 0, 0, 0, 0, 0 },
/* U+42c5 */ { 0, 0, 0, 0, 0 },
/* U+42c6 */ { 0, 0, 0, 0, 0 },
/* U+42c7 */ { 0, 0, 0, 0, 0 },
/* U+42c8 */ { 0, 0, 0, 0, 0 },
/* U+42c9 */ { 0, 0, 0, 0, 0 },
/* U+42ca */ { 0, 0, 0, 0, 0 },
/* U+42cb */ { 0, 0, 0, 0, 0 },
/* U+42cc */ { 0, 0, 0, 0, 0 },
/* U+42cd */ { 0, 0, 0, 0, 0 },
/* U+42ce */ { 0, 0, 0, 0, 0 },
/* U+42cf */ { 0, 0, 0, 0, 0 },
/* U+42d0 */ { 0, 0, 0, 0, 0 },
/* U+42d1 */ { 0, 0, 0, 0, 0 },
/* U+42d2 */ { 0, 0, 0, 0, 0 },
/* U+42d3 */ { 0, 0, 0, 0, 0 },
/* U+42d4 */ { 0, 0, 0, 0, 0 },
/* U+42d5 */ { 0, 0, 0, 0, 0 },
/* U+42d6 */ { 0, 0, 0, 0, 0 },
/* U+42d7 */ { 0, 0, 0, 0, 0 },
/* U+42d8 */ { 0, 0, 0, 0, 0 },
/* U+42d9 */ { 0, 0, 0, 0, 0 },
/* U+42da */ { 0, 0, 0, 0, 0 },
/* U+42db */ { 0, 0, 0, 0, 0 },
/* U+42dc */ { 0, 0, 0, 0, 0 },
/* U+42dd */ { 0, 0, 0, 0, 0 },
/* U+42de */ { 0, 0, 0, 0, 0 },
/* U+42df */ { 0, 0, 0, 0, 0 },
/* U+42e0 */ { 0, 0, 0, 0, 0 },
/* U+42e1 */ { 0, 0, 0, 0, 0 },
/* U+42e2 */ { 0, 0, 0, 0, 0 },
/* U+42e3 */ { 0, 0, 0, 0, 0 },
/* U+42e4 */ { 0, 0, 0, 0, 0 },
/* U+42e5 */ { 0, 0, 0, 0, 0 },
/* U+42e6 */ { 0, 0, 0, 0, 0 },
/* U+42e7 */ { 0, 0, 0, 0, 0 },
/* U+42e8 */ { 0, 0, 0, 0, 0 },
/* U+42e9 */ { 0, 0, 0, 0, 0 },
/* U+42ea */ { 0, 0, 0, 0, 0 },
/* U+42eb */ { 0, 0, 0, 0, 0 },
/* U+42ec */ { 0, 0, 0, 0, 0 },
/* U+42ed */ { 0, 0, 0, 0, 0 },
/* U+42ee */ { 0, 0, 0, 0, 0 },
/* U+42ef */ { 0, 0, 0, 0, 0 },
/* U+42f0 */ { 0, 0, 0, 0, 0 },
/* U+42f1 */ { 0, 0, 0, 0, 0 },
/* U+42f2 */ { 0, 0, 0, 0, 0 },
/* U+42f3 */ { 0, 0, 0, 0, 0 },
/* U+42f4 */ { 0, 0, 0, 0, 0 },
/* U+42f5 */ { 0, 0, 0, 0, 0 },
/* U+42f6 */ { 0, 0, 0, 0, 0 },
/* U+42f7 */ { 0, 0, 0, 0, 0 },
/* U+42f8 */ { 0, 0, 0, 0, 0 },
/* U+42f9 */ { 0, 0, 0, 0, 0 },
/* U+42fa */ { 0, 0, 0, 0, 0 },
/* U+42fb */ { 0, 0, 0, 0, 0 },
/* U+42fc */ { 0, 0, 0, 0, 0 },
/* U+42fd */ { 0, 0, 0, 0, 0 },
/* U+42fe */ { 0, 0, 0, 0, 0 },
/* U+42ff */ { 0, 0, 0, 0, 0 },
/* U+4300 */ { 0, 0, 0, 0, 0 },
/* U+4301 */ { 0, 0, 0, 0, 0 },
/* U+4302 */ { 0, 0, 0, 0, 0 },
/* U+4303 */ { 0, 0, 0, 0, 0 },
/* U+4304 */ { 0, 0, 0, 0, 0 },
/* U+4305 */ { 0, 0, 0, 0, 0 },
/* U+4306 */ { 0, 0, 0, 0, 0 },
/* U+4307 */ { 0, 0, 0, 0, 0 },
/* U+4308 */ { 0, 0, 0, 0, 0 },
/* U+4309 */ { 0, 0, 0, 0, 0 },
/* U+430a */ { 0, 0, 0, 0, 0 },
/* U+430b */ { 0, 0, 0, 0, 0 },
/* U+430c */ { 0, 0, 0, 0, 0 },
/* U+430d */ { 0, 0, 0, 0, 0 },
/* U+430e */ { 0, 0, 0, 0, 0 },
/* U+430f */ { 0, 0, 0, 0, 0 },
/* U+4310 */ { 0, 0, 0, 0, 0 },
/* U+4311 */ { 0, 0, 0, 0, 0 },
/* U+4312 */ { 0, 0, 0, 0, 0 },
/* U+4313 */ { 0, 0, 0, 0, 0 },
/* U+4314 */ { 0, 0, 0, 0, 0 },
/* U+4315 */ { 0, 0, 0, 0, 0 },
/* U+4316 */ { 0, 0, 0, 0, 0 },
/* U+4317 */ { 0, 0, 0, 0, 0 },
/* U+4318 */ { 0, 0, 0, 0, 0 },
/* U+4319 */ { 0, 0, 0, 0, 0 },
/* U+431a */ { 0, 0, 0, 0, 0 },
/* U+431b */ { 0, 0, 0, 0, 0 },
/* U+431c */ { 0, 0, 0, 0, 0 },
/* U+431d */ { 0, 0, 0, 0, 0 },
/* U+431e */ { 0, 0, 0, 0, 0 },
/* U+431f */ { 0, 0, 0, 0, 0 },
/* U+4320 */ { 0, 0, 0, 0, 0 },
/* U+4321 */ { 0, 0, 0, 0, 0 },
/* U+4322 */ { 0, 0, 0, 0, 0 },
/* U+4323 */ { 0, 0, 0, 0, 0 },
/* U+4324 */ { 0, 0, 0, 0, 0 },
/* U+4325 */ { 0, 0, 0, 0, 0 },
/* U+4326 */ { 0, 0, 0, 0, 0 },
/* U+4327 */ { 0, 0, 0, 0, 0 },
/* U+4328 */ { 0, 0, 0, 0, 0 },
/* U+4329 */ { 0, 0, 0, 0, 0 },
/* U+432a */ { 0, 0, 0, 0, 0 },
/* U+432b */ { 0, 0, 0, 0, 0 },
/* U+432c */ { 0, 0, 0, 0, 0 },
/* U+432d */ { 0, 0, 0, 0, 0 },
/* U+432e */ { 0, 0, 0, 0, 0 },
/* U+432f */ { 0, 0, 0, 0, 0 },
/* U+4330 */ { 0, 0, 0, 0, 0 },
/* U+4331 */ { 0, 0, 0, 0, 0 },
/* U+4332 */ { 0, 0, 0, 0, 0 },
/* U+4333 */ { 0, 0, 0, 0, 0 },
/* U+4334 */ { 0, 0, 0, 0, 0 },
/* U+4335 */ { 0, 0, 0, 0, 0 },
/* U+4336 */ { 0, 0, 0, 0, 0 },
/* U+4337 */ { 0, 0, 0, 0, 0 },
/* U+4338 */ { 0, 0, 0, 0, 0 },
/* U+4339 */ { 0, 0, 0, 0, 0 },
/* U+433a */ { 0, 0, 0, 0, 0 },
/* U+433b */ { 0, 0, 0, 0, 0 },
/* U+433c */ { 0, 0, 0, 0, 0 },
/* U+433d */ { 0, 0, 0, 0, 0 },
/* U+433e */ { 0, 0, 0, 0, 0 },
/* U+433f */ { 0, 0, 0, 0, 0 },
/* U+4340 */ { 0, 0, 0, 0, 0 },
/* U+4341 */ { 0, 0, 0, 0, 0 },
/* U+4342 */ { 0, 0, 0, 0, 0 },
/* U+4343 */ { 0, 0, 0, 0, 0 },
/* U+4344 */ { 0, 0, 0, 0, 0 },
/* U+4345 */ { 0, 0, 0, 0, 0 },
/* U+4346 */ { 0, 0, 0, 0, 0 },
/* U+4347 */ { 0, 0, 0, 0, 0 },
/* U+4348 */ { 0, 0, 0, 0, 0 },
/* U+4349 */ { 0, 0, 0, 0, 0 },
/* U+434a */ { 0, 0, 0, 0, 0 },
/* U+434b */ { 0, 0, 0, 0, 0 },
/* U+434c */ { 0, 0, 0, 0, 0 },
/* U+434d */ { 0, 0, 0, 0, 0 },
/* U+434e */ { 0, 0, 0, 0, 0 },
/* U+434f */ { 0, 0, 0, 0, 0 },
/* U+4350 */ { 0, 0, 0, 0, 0 },
/* U+4351 */ { 0, 0, 0, 0, 0 },
/* U+4352 */ { 0, 0, 0, 0, 0 },
/* U+4353 */ { 0, 0, 0, 0, 0 },
/* U+4354 */ { 0, 0, 0, 0, 0 },
/* U+4355 */ { 0, 0, 0, 0, 0 },
/* U+4356 */ { 0, 0, 0, 0, 0 },
/* U+4357 */ { 0, 0, 0, 0, 0 },
/* U+4358 */ { 0, 0, 0, 0, 0 },
/* U+4359 */ { 0, 0, 0, 0, 0 },
/* U+435a */ { 0, 0, 0, 0, 0 },
/* U+435b */ { 0, 0, 0, 0, 0 },
/* U+435c */ { 0, 0, 0, 0, 0 },
/* U+435d */ { 0, 0, 0, 0, 0 },
/* U+435e */ { 0, 0, 0, 0, 0 },
/* U+435f */ { 0, 0, 0, 0, 0 },
/* U+4360 */ { 0, 0, 0, 0, 0 },
/* U+4361 */ { 0, 0, 0, 0, 0 },
/* U+4362 */ { 0, 0, 0, 0, 0 },
/* U+4363 */ { 0, 0, 0, 0, 0 },
/* U+4364 */ { 0, 0, 0, 0, 0 },
/* U+4365 */ { 0, 0, 0, 0, 0 },
/* U+4366 */ { 0, 0, 0, 0, 0 },
/* U+4367 */ { 0, 0, 0, 0, 0 },
/* U+4368 */ { 0, 0, 0, 0, 0 },
/* U+4369 */ { 0, 0, 0, 0, 0 },
/* U+436a */ { 0, 0, 0, 0, 0 },
/* U+436b */ { 0, 0, 0, 0, 0 },
/* U+436c */ { 0, 0, 0, 0, 0 },
/* U+436d */ { 0, 0, 0, 0, 0 },
/* U+436e */ { 0, 0, 0, 0, 0 },
/* U+436f */ { 0, 0, 0, 0, 0 },
/* U+4370 */ { 0, 0, 0, 0, 0 },
/* U+4371 */ { 0, 0, 0, 0, 0 },
/* U+4372 */ { 0, 0, 0, 0, 0 },
/* U+4373 */ { 0, 0, 0, 0, 0 },
/* U+4374 */ { 0, 0, 0, 0, 0 },
/* U+4375 */ { 0, 0, 0, 0, 0 },
/* U+4376 */ { 0, 0, 0, 0, 0 },
/* U+4377 */ { 0, 0, 0, 0, 0 },
/* U+4378 */ { 0, 0, 0, 0, 0 },
/* U+4379 */ { 0, 0, 0, 0, 0 },
/* U+437a */ { 0, 0, 0, 0, 0 },
/* U+437b */ { 0, 0, 0, 0, 0 },
/* U+437c */ { 0, 0, 0, 0, 0 },
/* U+437d */ { 0, 0, 0, 0, 0 },
/* U+437e */ { 0, 0, 0, 0, 0 },
/* U+437f */ { 0, 0, 0, 0, 0 },
/* U+4380 */ { 0, 0, 0, 0, 0 },
/* U+4381 */ { 0, 0, 0, 0, 0 },
/* U+4382 */ { 0, 0, 0, 0, 0 },
/* U+4383 */ { 0, 0, 0, 0, 0 },
/* U+4384 */ { 0, 0, 0, 0, 0 },
/* U+4385 */ { 0, 0, 0, 0, 0 },
/* U+4386 */ { 0, 0, 0, 0, 0 },
/* U+4387 */ { 0, 0, 0, 0, 0 },
/* U+4388 */ { 0, 0, 0, 0, 0 },
/* U+4389 */ { 0, 0, 0, 0, 0 },
/* U+438a */ { 0, 0, 0, 0, 0 },
/* U+438b */ { 0, 0, 0, 0, 0 },
/* U+438c */ { 0, 0, 0, 0, 0 },
/* U+438d */ { 0, 0, 0, 0, 0 },
/* U+438e */ { 0, 0, 0, 0, 0 },
/* U+438f */ { 0, 0, 0, 0, 0 },
/* U+4390 */ { 0, 0, 0, 0, 0 },
/* U+4391 */ { 0, 0, 0, 0, 0 },
/* U+4392 */ { 0, 0, 0, 0, 0 },
/* U+4393 */ { 0, 0, 0, 0, 0 },
/* U+4394 */ { 0, 0, 0, 0, 0 },
/* U+4395 */ { 0, 0, 0, 0, 0 },
/* U+4396 */ { 0, 0, 0, 0, 0 },
/* U+4397 */ { 0, 0, 0, 0, 0 },
/* U+4398 */ { 0, 0, 0, 0, 0 },
/* U+4399 */ { 0, 0, 0, 0, 0 },
/* U+439a */ { 0, 0, 0, 0, 0 },
/* U+439b */ { 0, 0, 0, 0, 0 },
/* U+439c */ { 0, 0, 0, 0, 0 },
/* U+439d */ { 0, 0, 0, 0, 0 },
/* U+439e */ { 0, 0, 0, 0, 0 },
/* U+439f */ { 0, 0, 0, 0, 0 },
/* U+43a0 */ { 0, 0, 0, 0, 0 },
/* U+43a1 */ { 0, 0, 0, 0, 0 },
/* U+43a2 */ { 0, 0, 0, 0, 0 },
/* U+43a3 */ { 0, 0, 0, 0, 0 },
/* U+43a4 */ { 0, 0, 0, 0, 0 },
/* U+43a5 */ { 0, 0, 0, 0, 0 },
/* U+43a6 */ { 0, 0, 0, 0, 0 },
/* U+43a7 */ { 0, 0, 0, 0, 0 },
/* U+43a8 */ { 0, 0, 0, 0, 0 },
/* U+43a9 */ { 0, 0, 0, 0, 0 },
/* U+43aa */ { 0, 0, 0, 0, 0 },
/* U+43ab */ { 0, 0, 0, 0, 0 },
/* U+43ac */ { 0, 0, 0, 0, 0 },
/* U+43ad */ { 0, 0, 0, 0, 0 },
/* U+43ae */ { 0, 0, 0, 0, 0 },
/* U+43af */ { 0, 0, 0, 0, 0 },
/* U+43b0 */ { 0, 0, 0, 0, 0 },
/* U+43b1 */ { 0, 0, 0, 0, 0 },
/* U+43b2 */ { 0, 0, 0, 0, 0 },
/* U+43b3 */ { 0, 0, 0, 0, 0 },
/* U+43b4 */ { 0, 0, 0, 0, 0 },
/* U+43b5 */ { 0, 0, 0, 0, 0 },
/* U+43b6 */ { 0, 0, 0, 0, 0 },
/* U+43b7 */ { 0, 0, 0, 0, 0 },
/* U+43b8 */ { 0, 0, 0, 0, 0 },
/* U+43b9 */ { 0, 0, 0, 0, 0 },
/* U+43ba */ { 0, 0, 0, 0, 0 },
/* U+43bb */ { 0, 0, 0, 0, 0 },
/* U+43bc */ { 0, 0, 0, 0, 0 },
/* U+43bd */ { 0, 0, 0, 0, 0 },
/* U+43be */ { 0, 0, 0, 0, 0 },
/* U+43bf */ { 0, 0, 0, 0, 0 },
/* U+43c0 */ { 0, 0, 0, 0, 0 },
/* U+43c1 */ { 0, 0, 0, 0, 0 },
/* U+43c2 */ { 0, 0, 0, 0, 0 },
/* U+43c3 */ { 0, 0, 0, 0, 0 },
/* U+43c4 */ { 0, 0, 0, 0, 0 },
/* U+43c5 */ { 0, 0, 0, 0, 0 },
/* U+43c6 */ { 0, 0, 0, 0, 0 },
/* U+43c7 */ { 0, 0, 0, 0, 0 },
/* U+43c8 */ { 0, 0, 0, 0, 0 },
/* U+43c9 */ { 0, 0, 0, 0, 0 },
/* U+43ca */ { 0, 0, 0, 0, 0 },
/* U+43cb */ { 0, 0, 0, 0, 0 },
/* U+43cc */ { 0, 0, 0, 0, 0 },
/* U+43cd */ { 0, 0, 0, 0, 0 },
/* U+43ce */ { 0, 0, 0, 0, 0 },
/* U+43cf */ { 0, 0, 0, 0, 0 },
/* U+43d0 */ { 0, 0, 0, 0, 0 },
/* U+43d1 */ { 0, 0, 0, 0, 0 },
/* U+43d2 */ { 0, 0, 0, 0, 0 },
/* U+43d3 */ { 0, 0, 0, 0, 0 },
/* U+43d4 */ { 0, 0, 0, 0, 0 },
/* U+43d5 */ { 0, 0, 0, 0, 0 },
/* U+43d6 */ { 0, 0, 0, 0, 0 },
/* U+43d7 */ { 0, 0, 0, 0, 0 },
/* U+43d8 */ { 0, 0, 0, 0, 0 },
/* U+43d9 */ { 0, 0, 0, 0, 0 },
/* U+43da */ { 0, 0, 0, 0, 0 },
/* U+43db */ { 0, 0, 0, 0, 0 },
/* U+43dc */ { 0, 0, 0, 0, 0 },
/* U+43dd */ { 0, 0, 0, 0, 0 },
/* U+43de */ { 0, 0, 0, 0, 0 },
/* U+43df */ { 0, 0, 0, 0, 0 },
/* U+43e0 */ { 0, 0, 0, 0, 0 },
/* U+43e1 */ { 0, 0, 0, 0, 0 },
/* U+43e2 */ { 0, 0, 0, 0, 0 },
/* U+43e3 */ { 0, 0, 0, 0, 0 },
/* U+43e4 */ { 0, 0, 0, 0, 0 },
/* U+43e5 */ { 0, 0, 0, 0, 0 },
/* U+43e6 */ { 0, 0, 0, 0, 0 },
/* U+43e7 */ { 0, 0, 0, 0, 0 },
/* U+43e8 */ { 0, 0, 0, 0, 0 },
/* U+43e9 */ { 0, 0, 0, 0, 0 },
/* U+43ea */ { 0, 0, 0, 0, 0 },
/* U+43eb */ { 0, 0, 0, 0, 0 },
/* U+43ec */ { 0, 0, 0, 0, 0 },
/* U+43ed */ { 0, 0, 0, 0, 0 },
/* U+43ee */ { 0, 0, 0, 0, 0 },
/* U+43ef */ { 0, 0, 0, 0, 0 },
/* U+43f0 */ { 0, 0, 0, 0, 0 },
/* U+43f1 */ { 0, 0, 0, 0, 0 },
/* U+43f2 */ { 0, 0, 0, 0, 0 },
/* U+43f3 */ { 0, 0, 0, 0, 0 },
/* U+43f4 */ { 0, 0, 0, 0, 0 },
/* U+43f5 */ { 0, 0, 0, 0, 0 },
/* U+43f6 */ { 0, 0, 0, 0, 0 },
/* U+43f7 */ { 0, 0, 0, 0, 0 },
/* U+43f8 */ { 0, 0, 0, 0, 0 },
/* U+43f9 */ { 0, 0, 0, 0, 0 },
/* U+43fa */ { 0, 0, 0, 0, 0 },
/* U+43fb */ { 0, 0, 0, 0, 0 },
/* U+43fc */ { 0, 0, 0, 0, 0 },
/* U+43fd */ { 0, 0, 0, 0, 0 },
/* U+43fe */ { 0, 0, 0, 0, 0 },
/* U+43ff */ { 0, 0, 0, 0, 0 },
/* U+4400 */ { 0, 0, 0, 0, 0 },
/* U+4401 */ { 0, 0, 0, 0, 0 },
/* U+4402 */ { 0, 0, 0, 0, 0 },
/* U+4403 */ { 0, 0, 0, 0, 0 },
/* U+4404 */ { 0, 0, 0, 0, 0 },
/* U+4405 */ { 0, 0, 0, 0, 0 },
/* U+4406 */ { 0, 0, 0, 0, 0 },
/* U+4407 */ { 0, 0, 0, 0, 0 },
/* U+4408 */ { 0, 0, 0, 0, 0 },
/* U+4409 */ { 0, 0, 0, 0, 0 },
/* U+440a */ { 0, 0, 0, 0, 0 },
/* U+440b */ { 0, 0, 0, 0, 0 },
/* U+440c */ { 0, 0, 0, 0, 0 },
/* U+440d */ { 0, 0, 0, 0, 0 },
/* U+440e */ { 0, 0, 0, 0, 0 },
/* U+440f */ { 0, 0, 0, 0, 0 },
/* U+4410 */ { 0, 0, 0, 0, 0 },
/* U+4411 */ { 0, 0, 0, 0, 0 },
/* U+4412 */ { 0, 0, 0, 0, 0 },
/* U+4413 */ { 0, 0, 0, 0, 0 },
/* U+4414 */ { 0, 0, 0, 0, 0 },
/* U+4415 */ { 0, 0, 0, 0, 0 },
/* U+4416 */ { 0, 0, 0, 0, 0 },
/* U+4417 */ { 0, 0, 0, 0, 0 },
/* U+4418 */ { 0, 0, 0, 0, 0 },
/* U+4419 */ { 0, 0, 0, 0, 0 },
/* U+441a */ { 0, 0, 0, 0, 0 },
/* U+441b */ { 0, 0, 0, 0, 0 },
/* U+441c */ { 0, 0, 0, 0, 0 },
/* U+441d */ { 0, 0, 0, 0, 0 },
/* U+441e */ { 0, 0, 0, 0, 0 },
/* U+441f */ { 0, 0, 0, 0, 0 },
/* U+4420 */ { 0, 0, 0, 0, 0 },
/* U+4421 */ { 0, 0, 0, 0, 0 },
/* U+4422 */ { 0, 0, 0, 0, 0 },
/* U+4423 */ { 0, 0, 0, 0, 0 },
/* U+4424 */ { 0, 0, 0, 0, 0 },
/* U+4425 */ { 0, 0, 0, 0, 0 },
/* U+4426 */ { 0, 0, 0, 0, 0 },
/* U+4427 */ { 0, 0, 0, 0, 0 },
/* U+4428 */ { 0, 0, 0, 0, 0 },
/* U+4429 */ { 0, 0, 0, 0, 0 },
/* U+442a */ { 0, 0, 0, 0, 0 },
/* U+442b */ { 0, 0, 0, 0, 0 },
/* U+442c */ { 0, 0, 0, 0, 0 },
/* U+442d */ { 0, 0, 0, 0, 0 },
/* U+442e */ { 0, 0, 0, 0, 0 },
/* U+442f */ { 0, 0, 0, 0, 0 },
/* U+4430 */ { 0, 0, 0, 0, 0 },
/* U+4431 */ { 0, 0, 0, 0, 0 },
/* U+4432 */ { 0, 0, 0, 0, 0 },
/* U+4433 */ { 0, 0, 0, 0, 0 },
/* U+4434 */ { 0, 0, 0, 0, 0 },
/* U+4435 */ { 0, 0, 0, 0, 0 },
/* U+4436 */ { 0, 0, 0, 0, 0 },
/* U+4437 */ { 0, 0, 0, 0, 0 },
/* U+4438 */ { 0, 0, 0, 0, 0 },
/* U+4439 */ { 0, 0, 0, 0, 0 },
/* U+443a */ { 0, 0, 0, 0, 0 },
/* U+443b */ { 0, 0, 0, 0, 0 },
/* U+443c */ { 0, 0, 0, 0, 0 },
/* U+443d */ { 0, 0, 0, 0, 0 },
/* U+443e */ { 0, 0, 0, 0, 0 },
/* U+443f */ { 0, 0, 0, 0, 0 },
/* U+4440 */ { 0, 0, 0, 0, 0 },
/* U+4441 */ { 0, 0, 0, 0, 0 },
/* U+4442 */ { 0, 0, 0, 0, 0 },
/* U+4443 */ { 0, 0, 0, 0, 0 },
/* U+4444 */ { 0, 0, 0, 0, 0 },
/* U+4445 */ { 0, 0, 0, 0, 0 },
/* U+4446 */ { 0, 0, 0, 0, 0 },
/* U+4447 */ { 0, 0, 0, 0, 0 },
/* U+4448 */ { 0, 0, 0, 0, 0 },
/* U+4449 */ { 0, 0, 0, 0, 0 },
/* U+444a */ { 0, 0, 0, 0, 0 },
/* U+444b */ { 0, 0, 0, 0, 0 },
/* U+444c */ { 0, 0, 0, 0, 0 },
/* U+444d */ { 0, 0, 0, 0, 0 },
/* U+444e */ { 0, 0, 0, 0, 0 },
/* U+444f */ { 0, 0, 0, 0, 0 },
/* U+4450 */ { 0, 0, 0, 0, 0 },
/* U+4451 */ { 0, 0, 0, 0, 0 },
/* U+4452 */ { 0, 0, 0, 0, 0 },
/* U+4453 */ { 0, 0, 0, 0, 0 },
/* U+4454 */ { 0, 0, 0, 0, 0 },
/* U+4455 */ { 0, 0, 0, 0, 0 },
/* U+4456 */ { 0, 0, 0, 0, 0 },
/* U+4457 */ { 0, 0, 0, 0, 0 },
/* U+4458 */ { 0, 0, 0, 0, 0 },
/* U+4459 */ { 0, 0, 0, 0, 0 },
/* U+445a */ { 0, 0, 0, 0, 0 },
/* U+445b */ { 0, 0, 0, 0, 0 },
/* U+445c */ { 0, 0, 0, 0, 0 },
/* U+445d */ { 0, 0, 0, 0, 0 },
/* U+445e */ { 0, 0, 0, 0, 0 },
/* U+445f */ { 0, 0, 0, 0, 0 },
/* U+4460 */ { 0, 0, 0, 0, 0 },
/* U+4461 */ { 0, 0, 0, 0, 0 },
/* U+4462 */ { 0, 0, 0, 0, 0 },
/* U+4463 */ { 0, 0, 0, 0, 0 },
/* U+4464 */ { 0, 0, 0, 0, 0 },
/* U+4465 */ { 0, 0, 0, 0, 0 },
/* U+4466 */ { 0, 0, 0, 0, 0 },
/* U+4467 */ { 0, 0, 0, 0, 0 },
/* U+4468 */ { 0, 0, 0, 0, 0 },
/* U+4469 */ { 0, 0, 0, 0, 0 },
/* U+446a */ { 0, 0, 0, 0, 0 },
/* U+446b */ { 0, 0, 0, 0, 0 },
/* U+446c */ { 0, 0, 0, 0, 0 },
/* U+446d */ { 0, 0, 0, 0, 0 },
/* U+446e */ { 0, 0, 0, 0, 0 },
/* U+446f */ { 0, 0, 0, 0, 0 },
/* U+4470 */ { 0, 0, 0, 0, 0 },
/* U+4471 */ { 0, 0, 0, 0, 0 },
/* U+4472 */ { 0, 0, 0, 0, 0 },
/* U+4473 */ { 0, 0, 0, 0, 0 },
/* U+4474 */ { 0, 0, 0, 0, 0 },
/* U+4475 */ { 0, 0, 0, 0, 0 },
/* U+4476 */ { 0, 0, 0, 0, 0 },
/* U+4477 */ { 0, 0, 0, 0, 0 },
/* U+4478 */ { 0, 0, 0, 0, 0 },
/* U+4479 */ { 0, 0, 0, 0, 0 },
/* U+447a */ { 0, 0, 0, 0, 0 },
/* U+447b */ { 0, 0, 0, 0, 0 },
/* U+447c */ { 0, 0, 0, 0, 0 },
/* U+447d */ { 0, 0, 0, 0, 0 },
/* U+447e */ { 0, 0, 0, 0, 0 },
/* U+447f */ { 0, 0, 0, 0, 0 },
/* U+4480 */ { 0, 0, 0, 0, 0 },
/* U+4481 */ { 0, 0, 0, 0, 0 },
/* U+4482 */ { 0, 0, 0, 0, 0 },
/* U+4483 */ { 0, 0, 0, 0, 0 },
/* U+4484 */ { 0, 0, 0, 0, 0 },
/* U+4485 */ { 0, 0, 0, 0, 0 },
/* U+4486 */ { 0, 0, 0, 0, 0 },
/* U+4487 */ { 0, 0, 0, 0, 0 },
/* U+4488 */ { 0, 0, 0, 0, 0 },
/* U+4489 */ { 0, 0, 0, 0, 0 },
/* U+448a */ { 0, 0, 0, 0, 0 },
/* U+448b */ { 0, 0, 0, 0, 0 },
/* U+448c */ { 0, 0, 0, 0, 0 },
/* U+448d */ { 0, 0, 0, 0, 0 },
/* U+448e */ { 0, 0, 0, 0, 0 },
/* U+448f */ { 0, 0, 0, 0, 0 },
/* U+4490 */ { 0, 0, 0, 0, 0 },
/* U+4491 */ { 0, 0, 0, 0, 0 },
/* U+4492 */ { 0, 0, 0, 0, 0 },
/* U+4493 */ { 0, 0, 0, 0, 0 },
/* U+4494 */ { 0, 0, 0, 0, 0 },
/* U+4495 */ { 0, 0, 0, 0, 0 },
/* U+4496 */ { 0, 0, 0, 0, 0 },
/* U+4497 */ { 0, 0, 0, 0, 0 },
/* U+4498 */ { 0, 0, 0, 0, 0 },
/* U+4499 */ { 0, 0, 0, 0, 0 },
/* U+449a */ { 0, 0, 0, 0, 0 },
/* U+449b */ { 0, 0, 0, 0, 0 },
/* U+449c */ { 0, 0, 0, 0, 0 },
/* U+449d */ { 0, 0, 0, 0, 0 },
/* U+449e */ { 0, 0, 0, 0, 0 },
/* U+449f */ { 0, 0, 0, 0, 0 },
/* U+44a0 */ { 0, 0, 0, 0, 0 },
/* U+44a1 */ { 0, 0, 0, 0, 0 },
/* U+44a2 */ { 0, 0, 0, 0, 0 },
/* U+44a3 */ { 0, 0, 0, 0, 0 },
/* U+44a4 */ { 0, 0, 0, 0, 0 },
/* U+44a5 */ { 0, 0, 0, 0, 0 },
/* U+44a6 */ { 0, 0, 0, 0, 0 },
/* U+44a7 */ { 0, 0, 0, 0, 0 },
/* U+44a8 */ { 0, 0, 0, 0, 0 },
/* U+44a9 */ { 0, 0, 0, 0, 0 },
/* U+44aa */ { 0, 0, 0, 0, 0 },
/* U+44ab */ { 0, 0, 0, 0, 0 },
/* U+44ac */ { 0, 0, 0, 0, 0 },
/* U+44ad */ { 0, 0, 0, 0, 0 },
/* U+44ae */ { 0, 0, 0, 0, 0 },
/* U+44af */ { 0, 0, 0, 0, 0 },
/* U+44b0 */ { 0, 0, 0, 0, 0 },
/* U+44b1 */ { 0, 0, 0, 0, 0 },
/* U+44b2 */ { 0, 0, 0, 0, 0 },
/* U+44b3 */ { 0, 0, 0, 0, 0 },
/* U+44b4 */ { 0, 0, 0, 0, 0 },
/* U+44b5 */ { 0, 0, 0, 0, 0 },
/* U+44b6 */ { 0, 0, 0, 0, 0 },
/* U+44b7 */ { 0, 0, 0, 0, 0 },
/* U+44b8 */ { 0, 0, 0, 0, 0 },
/* U+44b9 */ { 0, 0, 0, 0, 0 },
/* U+44ba */ { 0, 0, 0, 0, 0 },
/* U+44bb */ { 0, 0, 0, 0, 0 },
/* U+44bc */ { 0, 0, 0, 0, 0 },
/* U+44bd */ { 0, 0, 0, 0, 0 },
/* U+44be */ { 0, 0, 0, 0, 0 },
/* U+44bf */ { 0, 0, 0, 0, 0 },
/* U+44c0 */ { 0, 0, 0, 0, 0 },
/* U+44c1 */ { 0, 0, 0, 0, 0 },
/* U+44c2 */ { 0, 0, 0, 0, 0 },
/* U+44c3 */ { 0, 0, 0, 0, 0 },
/* U+44c4 */ { 0, 0, 0, 0, 0 },
/* U+44c5 */ { 0, 0, 0, 0, 0 },
/* U+44c6 */ { 0, 0, 0, 0, 0 },
/* U+44c7 */ { 0, 0, 0, 0, 0 },
/* U+44c8 */ { 0, 0, 0, 0, 0 },
/* U+44c9 */ { 0, 0, 0, 0, 0 },
/* U+44ca */ { 0, 0, 0, 0, 0 },
/* U+44cb */ { 0, 0, 0, 0, 0 },
/* U+44cc */ { 0, 0, 0, 0, 0 },
/* U+44cd */ { 0, 0, 0, 0, 0 },
/* U+44ce */ { 0, 0, 0, 0, 0 },
/* U+44cf */ { 0, 0, 0, 0, 0 },
/* U+44d0 */ { 0, 0, 0, 0, 0 },
/* U+44d1 */ { 0, 0, 0, 0, 0 },
/* U+44d2 */ { 0, 0, 0, 0, 0 },
/* U+44d3 */ { 0, 0, 0, 0, 0 },
/* U+44d4 */ { 0, 0, 0, 0, 0 },
/* U+44d5 */ { 0, 0, 0, 0, 0 },
/* U+44d6 */ { 0, 0, 0, 0, 0 },
/* U+44d7 */ { 0, 0, 0, 0, 0 },
/* U+44d8 */ { 0, 0, 0, 0, 0 },
/* U+44d9 */ { 0, 0, 0, 0, 0 },
/* U+44da */ { 0, 0, 0, 0, 0 },
/* U+44db */ { 0, 0, 0, 0, 0 },
/* U+44dc */ { 0, 0, 0, 0, 0 },
/* U+44dd */ { 0, 0, 0, 0, 0 },
/* U+44de */ { 0, 0, 0, 0, 0 },
/* U+44df */ { 0, 0, 0, 0, 0 },
/* U+44e0 */ { 0, 0, 0, 0, 0 },
/* U+44e1 */ { 0, 0, 0, 0, 0 },
/* U+44e2 */ { 0, 0, 0, 0, 0 },
/* U+44e3 */ { 0, 0, 0, 0, 0 },
/* U+44e4 */ { 0, 0, 0, 0, 0 },
/* U+44e5 */ { 0, 0, 0, 0, 0 },
/* U+44e6 */ { 0, 0, 0, 0, 0 },
/* U+44e7 */ { 0, 0, 0, 0, 0 },
/* U+44e8 */ { 0, 0, 0, 0, 0 },
/* U+44e9 */ { 0, 0, 0, 0, 0 },
/* U+44ea */ { 0, 0, 0, 0, 0 },
/* U+44eb */ { 0, 0, 0, 0, 0 },
/* U+44ec */ { 0, 0, 0, 0, 0 },
/* U+44ed */ { 0, 0, 0, 0, 0 },
/* U+44ee */ { 0, 0, 0, 0, 0 },
/* U+44ef */ { 0, 0, 0, 0, 0 },
/* U+44f0 */ { 0, 0, 0, 0, 0 },
/* U+44f1 */ { 0, 0, 0, 0, 0 },
/* U+44f2 */ { 0, 0, 0, 0, 0 },
/* U+44f3 */ { 0, 0, 0, 0, 0 },
/* U+44f4 */ { 0, 0, 0, 0, 0 },
/* U+44f5 */ { 0, 0, 0, 0, 0 },
/* U+44f6 */ { 0, 0, 0, 0, 0 },
/* U+44f7 */ { 0, 0, 0, 0, 0 },
/* U+44f8 */ { 0, 0, 0, 0, 0 },
/* U+44f9 */ { 0, 0, 0, 0, 0 },
/* U+44fa */ { 0, 0, 0, 0, 0 },
/* U+44fb */ { 0, 0, 0, 0, 0 },
/* U+44fc */ { 0, 0, 0, 0, 0 },
/* U+44fd */ { 0, 0, 0, 0, 0 },
/* U+44fe */ { 0, 0, 0, 0, 0 },
/* U+44ff */ { 0, 0, 0, 0, 0 },
/* U+4500 */ { 0, 0, 0, 0, 0 },
/* U+4501 */ { 0, 0, 0, 0, 0 },
/* U+4502 */ { 0, 0, 0, 0, 0 },
/* U+4503 */ { 0, 0, 0, 0, 0 },
/* U+4504 */ { 0, 0, 0, 0, 0 },
/* U+4505 */ { 0, 0, 0, 0, 0 },
/* U+4506 */ { 0, 0, 0, 0, 0 },
/* U+4507 */ { 0, 0, 0, 0, 0 },
/* U+4508 */ { 0, 0, 0, 0, 0 },
/* U+4509 */ { 0, 0, 0, 0, 0 },
/* U+450a */ { 0, 0, 0, 0, 0 },
/* U+450b */ { 0, 0, 0, 0, 0 },
/* U+450c */ { 0, 0, 0, 0, 0 },
/* U+450d */ { 0, 0, 0, 0, 0 },
/* U+450e */ { 0, 0, 0, 0, 0 },
/* U+450f */ { 0, 0, 0, 0, 0 },
/* U+4510 */ { 0, 0, 0, 0, 0 },
/* U+4511 */ { 0, 0, 0, 0, 0 },
/* U+4512 */ { 0, 0, 0, 0, 0 },
/* U+4513 */ { 0, 0, 0, 0, 0 },
/* U+4514 */ { 0, 0, 0, 0, 0 },
/* U+4515 */ { 0, 0, 0, 0, 0 },
/* U+4516 */ { 0, 0, 0, 0, 0 },
/* U+4517 */ { 0, 0, 0, 0, 0 },
/* U+4518 */ { 0, 0, 0, 0, 0 },
/* U+4519 */ { 0, 0, 0, 0, 0 },
/* U+451a */ { 0, 0, 0, 0, 0 },
/* U+451b */ { 0, 0, 0, 0, 0 },
/* U+451c */ { 0, 0, 0, 0, 0 },
/* U+451d */ { 0, 0, 0, 0, 0 },
/* U+451e */ { 0, 0, 0, 0, 0 },
/* U+451f */ { 0, 0, 0, 0, 0 },
/* U+4520 */ { 0, 0, 0, 0, 0 },
/* U+4521 */ { 0, 0, 0, 0, 0 },
/* U+4522 */ { 0, 0, 0, 0, 0 },
/* U+4523 */ { 0, 0, 0, 0, 0 },
/* U+4524 */ { 0, 0, 0, 0, 0 },
/* U+4525 */ { 0, 0, 0, 0, 0 },
/* U+4526 */ { 0, 0, 0, 0, 0 },
/* U+4527 */ { 0, 0, 0, 0, 0 },
/* U+4528 */ { 0, 0, 0, 0, 0 },
/* U+4529 */ { 0, 0, 0, 0, 0 },
/* U+452a */ { 0, 0, 0, 0, 0 },
/* U+452b */ { 0, 0, 0, 0, 0 },
/* U+452c */ { 0, 0, 0, 0, 0 },
/* U+452d */ { 0, 0, 0, 0, 0 },
/* U+452e */ { 0, 0, 0, 0, 0 },
/* U+452f */ { 0, 0, 0, 0, 0 },
/* U+4530 */ { 0, 0, 0, 0, 0 },
/* U+4531 */ { 0, 0, 0, 0, 0 },
/* U+4532 */ { 0, 0, 0, 0, 0 },
/* U+4533 */ { 0, 0, 0, 0, 0 },
/* U+4534 */ { 0, 0, 0, 0, 0 },
/* U+4535 */ { 0, 0, 0, 0, 0 },
/* U+4536 */ { 0, 0, 0, 0, 0 },
/* U+4537 */ { 0, 0, 0, 0, 0 },
/* U+4538 */ { 0, 0, 0, 0, 0 },
/* U+4539 */ { 0, 0, 0, 0, 0 },
/* U+453a */ { 0, 0, 0, 0, 0 },
/* U+453b */ { 0, 0, 0, 0, 0 },
/* U+453c */ { 0, 0, 0, 0, 0 },
/* U+453d */ { 0, 0, 0, 0, 0 },
/* U+453e */ { 0, 0, 0, 0, 0 },
/* U+453f */ { 0, 0, 0, 0, 0 },
/* U+4540 */ { 0, 0, 0, 0, 0 },
/* U+4541 */ { 0, 0, 0, 0, 0 },
/* U+4542 */ { 0, 0, 0, 0, 0 },
/* U+4543 */ { 0, 0, 0, 0, 0 },
/* U+4544 */ { 0, 0, 0, 0, 0 },
/* U+4545 */ { 0, 0, 0, 0, 0 },
/* U+4546 */ { 0, 0, 0, 0, 0 },
/* U+4547 */ { 0, 0, 0, 0, 0 },
/* U+4548 */ { 0, 0, 0, 0, 0 },
/* U+4549 */ { 0, 0, 0, 0, 0 },
/* U+454a */ { 0, 0, 0, 0, 0 },
/* U+454b */ { 0, 0, 0, 0, 0 },
/* U+454c */ { 0, 0, 0, 0, 0 },
/* U+454d */ { 0, 0, 0, 0, 0 },
/* U+454e */ { 0, 0, 0, 0, 0 },
/* U+454f */ { 0, 0, 0, 0, 0 },
/* U+4550 */ { 0, 0, 0, 0, 0 },
/* U+4551 */ { 0, 0, 0, 0, 0 },
/* U+4552 */ { 0, 0, 0, 0, 0 },
/* U+4553 */ { 0, 0, 0, 0, 0 },
/* U+4554 */ { 0, 0, 0, 0, 0 },
/* U+4555 */ { 0, 0, 0, 0, 0 },
/* U+4556 */ { 0, 0, 0, 0, 0 },
/* U+4557 */ { 0, 0, 0, 0, 0 },
/* U+4558 */ { 0, 0, 0, 0, 0 },
/* U+4559 */ { 0, 0, 0, 0, 0 },
/* U+455a */ { 0, 0, 0, 0, 0 },
/* U+455b */ { 0, 0, 0, 0, 0 },
/* U+455c */ { 0, 0, 0, 0, 0 },
/* U+455d */ { 0, 0, 0, 0, 0 },
/* U+455e */ { 0, 0, 0, 0, 0 },
/* U+455f */ { 0, 0, 0, 0, 0 },
/* U+4560 */ { 0, 0, 0, 0, 0 },
/* U+4561 */ { 0, 0, 0, 0, 0 },
/* U+4562 */ { 0, 0, 0, 0, 0 },
/* U+4563 */ { 0, 0, 0, 0, 0 },
/* U+4564 */ { 0, 0, 0, 0, 0 },
/* U+4565 */ { 0, 0, 0, 0, 0 },
/* U+4566 */ { 0, 0, 0, 0, 0 },
/* U+4567 */ { 0, 0, 0, 0, 0 },
/* U+4568 */ { 0, 0, 0, 0, 0 },
/* U+4569 */ { 0, 0, 0, 0, 0 },
/* U+456a */ { 0, 0, 0, 0, 0 },
/* U+456b */ { 0, 0, 0, 0, 0 },
/* U+456c */ { 0, 0, 0, 0, 0 },
/* U+456d */ { 0, 0, 0, 0, 0 },
/* U+456e */ { 0, 0, 0, 0, 0 },
/* U+456f */ { 0, 0, 0, 0, 0 },
/* U+4570 */ { 0, 0, 0, 0, 0 },
/* U+4571 */ { 0, 0, 0, 0, 0 },
/* U+4572 */ { 0, 0, 0, 0, 0 },
/* U+4573 */ { 0, 0, 0, 0, 0 },
/* U+4574 */ { 0, 0, 0, 0, 0 },
/* U+4575 */ { 0, 0, 0, 0, 0 },
/* U+4576 */ { 0, 0, 0, 0, 0 },
/* U+4577 */ { 0, 0, 0, 0, 0 },
/* U+4578 */ { 0, 0, 0, 0, 0 },
/* U+4579 */ { 0, 0, 0, 0, 0 },
/* U+457a */ { 0, 0, 0, 0, 0 },
/* U+457b */ { 0, 0, 0, 0, 0 },
/* U+457c */ { 0, 0, 0, 0, 0 },
/* U+457d */ { 0, 0, 0, 0, 0 },
/* U+457e */ { 0, 0, 0, 0, 0 },
/* U+457f */ { 0, 0, 0, 0, 0 },
/* U+4580 */ { 0, 0, 0, 0, 0 },
/* U+4581 */ { 0, 0, 0, 0, 0 },
/* U+4582 */ { 0, 0, 0, 0, 0 },
/* U+4583 */ { 0, 0, 0, 0, 0 },
/* U+4584 */ { 0, 0, 0, 0, 0 },
/* U+4585 */ { 0, 0, 0, 0, 0 },
/* U+4586 */ { 0, 0, 0, 0, 0 },
/* U+4587 */ { 0, 0, 0, 0, 0 },
/* U+4588 */ { 0, 0, 0, 0, 0 },
/* U+4589 */ { 0, 0, 0, 0, 0 },
/* U+458a */ { 0, 0, 0, 0, 0 },
/* U+458b */ { 0, 0, 0, 0, 0 },
/* U+458c */ { 0, 0, 0, 0, 0 },
/* U+458d */ { 0, 0, 0, 0, 0 },
/* U+458e */ { 0, 0, 0, 0, 0 },
/* U+458f */ { 0, 0, 0, 0, 0 },
/* U+4590 */ { 0, 0, 0, 0, 0 },
/* U+4591 */ { 0, 0, 0, 0, 0 },
/* U+4592 */ { 0, 0, 0, 0, 0 },
/* U+4593 */ { 0, 0, 0, 0, 0 },
/* U+4594 */ { 0, 0, 0, 0, 0 },
/* U+4595 */ { 0, 0, 0, 0, 0 },
/* U+4596 */ { 0, 0, 0, 0, 0 },
/* U+4597 */ { 0, 0, 0, 0, 0 },
/* U+4598 */ { 0, 0, 0, 0, 0 },
/* U+4599 */ { 0, 0, 0, 0, 0 },
/* U+459a */ { 0, 0, 0, 0, 0 },
/* U+459b */ { 0, 0, 0, 0, 0 },
/* U+459c */ { 0, 0, 0, 0, 0 },
/* U+459d */ { 0, 0, 0, 0, 0 },
/* U+459e */ { 0, 0, 0, 0, 0 },
/* U+459f */ { 0, 0, 0, 0, 0 },
/* U+45a0 */ { 0, 0, 0, 0, 0 },
/* U+45a1 */ { 0, 0, 0, 0, 0 },
/* U+45a2 */ { 0, 0, 0, 0, 0 },
/* U+45a3 */ { 0, 0, 0, 0, 0 },
/* U+45a4 */ { 0, 0, 0, 0, 0 },
/* U+45a5 */ { 0, 0, 0, 0, 0 },
/* U+45a6 */ { 0, 0, 0, 0, 0 },
/* U+45a7 */ { 0, 0, 0, 0, 0 },
/* U+45a8 */ { 0, 0, 0, 0, 0 },
/* U+45a9 */ { 0, 0, 0, 0, 0 },
/* U+45aa */ { 0, 0, 0, 0, 0 },
/* U+45ab */ { 0, 0, 0, 0, 0 },
/* U+45ac */ { 0, 0, 0, 0, 0 },
/* U+45ad */ { 0, 0, 0, 0, 0 },
/* U+45ae */ { 0, 0, 0, 0, 0 },
/* U+45af */ { 0, 0, 0, 0, 0 },
/* U+45b0 */ { 0, 0, 0, 0, 0 },
/* U+45b1 */ { 0, 0, 0, 0, 0 },
/* U+45b2 */ { 0, 0, 0, 0, 0 },
/* U+45b3 */ { 0, 0, 0, 0, 0 },
/* U+45b4 */ { 0, 0, 0, 0, 0 },
/* U+45b5 */ { 0, 0, 0, 0, 0 },
/* U+45b6 */ { 0, 0, 0, 0, 0 },
/* U+45b7 */ { 0, 0, 0, 0, 0 },
/* U+45b8 */ { 0, 0, 0, 0, 0 },
/* U+45b9 */ { 0, 0, 0, 0, 0 },
/* U+45ba */ { 0, 0, 0, 0, 0 },
/* U+45bb */ { 0, 0, 0, 0, 0 },
/* U+45bc */ { 0, 0, 0, 0, 0 },
/* U+45bd */ { 0, 0, 0, 0, 0 },
/* U+45be */ { 0, 0, 0, 0, 0 },
/* U+45bf */ { 0, 0, 0, 0, 0 },
/* U+45c0 */ { 0, 0, 0, 0, 0 },
/* U+45c1 */ { 0, 0, 0, 0, 0 },
/* U+45c2 */ { 0, 0, 0, 0, 0 },
/* U+45c3 */ { 0, 0, 0, 0, 0 },
/* U+45c4 */ { 0, 0, 0, 0, 0 },
/* U+45c5 */ { 0, 0, 0, 0, 0 },
/* U+45c6 */ { 0, 0, 0, 0, 0 },
/* U+45c7 */ { 0, 0, 0, 0, 0 },
/* U+45c8 */ { 0, 0, 0, 0, 0 },
/* U+45c9 */ { 0, 0, 0, 0, 0 },
/* U+45ca */ { 0, 0, 0, 0, 0 },
/* U+45cb */ { 0, 0, 0, 0, 0 },
/* U+45cc */ { 0, 0, 0, 0, 0 },
/* U+45cd */ { 0, 0, 0, 0, 0 },
/* U+45ce */ { 0, 0, 0, 0, 0 },
/* U+45cf */ { 0, 0, 0, 0, 0 },
/* U+45d0 */ { 0, 0, 0, 0, 0 },
/* U+45d1 */ { 0, 0, 0, 0, 0 },
/* U+45d2 */ { 0, 0, 0, 0, 0 },
/* U+45d3 */ { 0, 0, 0, 0, 0 },
/* U+45d4 */ { 0, 0, 0, 0, 0 },
/* U+45d5 */ { 0, 0, 0, 0, 0 },
/* U+45d6 */ { 0, 0, 0, 0, 0 },
/* U+45d7 */ { 0, 0, 0, 0, 0 },
/* U+45d8 */ { 0, 0, 0, 0, 0 },
/* U+45d9 */ { 0, 0, 0, 0, 0 },
/* U+45da */ { 0, 0, 0, 0, 0 },
/* U+45db */ { 0, 0, 0, 0, 0 },
/* U+45dc */ { 0, 0, 0, 0, 0 },
/* U+45dd */ { 0, 0, 0, 0, 0 },
/* U+45de */ { 0, 0, 0, 0, 0 },
/* U+45df */ { 0, 0, 0, 0, 0 },
/* U+45e0 */ { 0, 0, 0, 0, 0 },
/* U+45e1 */ { 0, 0, 0, 0, 0 },
/* U+45e2 */ { 0, 0, 0, 0, 0 },
/* U+45e3 */ { 0, 0, 0, 0, 0 },
/* U+45e4 */ { 0, 0, 0, 0, 0 },
/* U+45e5 */ { 0, 0, 0, 0, 0 },
/* U+45e6 */ { 0, 0, 0, 0, 0 },
/* U+45e7 */ { 0, 0, 0, 0, 0 },
/* U+45e8 */ { 0, 0, 0, 0, 0 },
/* U+45e9 */ { 0, 0, 0, 0, 0 },
/* U+45ea */ { 0, 0, 0, 0, 0 },
/* U+45eb */ { 0, 0, 0, 0, 0 },
/* U+45ec */ { 0, 0, 0, 0, 0 },
/* U+45ed */ { 0, 0, 0, 0, 0 },
/* U+45ee */ { 0, 0, 0, 0, 0 },
/* U+45ef */ { 0, 0, 0, 0, 0 },
/* U+45f0 */ { 0, 0, 0, 0, 0 },
/* U+45f1 */ { 0, 0, 0, 0, 0 },
/* U+45f2 */ { 0, 0, 0, 0, 0 },
/* U+45f3 */ { 0, 0, 0, 0, 0 },
/* U+45f4 */ { 0, 0, 0, 0, 0 },
/* U+45f5 */ { 0, 0, 0, 0, 0 },
/* U+45f6 */ { 0, 0, 0, 0, 0 },
/* U+45f7 */ { 0, 0, 0, 0, 0 },
/* U+45f8 */ { 0, 0, 0, 0, 0 },
/* U+45f9 */ { 0, 0, 0, 0, 0 },
/* U+45fa */ { 0, 0, 0, 0, 0 },
/* U+45fb */ { 0, 0, 0, 0, 0 },
/* U+45fc */ { 0, 0, 0, 0, 0 },
/* U+45fd */ { 0, 0, 0, 0, 0 },
/* U+45fe */ { 0, 0, 0, 0, 0 },
/* U+45ff */ { 0, 0, 0, 0, 0 },
/* U+4600 */ { 0, 0, 0, 0, 0 },
/* U+4601 */ { 0, 0, 0, 0, 0 },
/* U+4602 */ { 0, 0, 0, 0, 0 },
/* U+4603 */ { 0, 0, 0, 0, 0 },
/* U+4604 */ { 0, 0, 0, 0, 0 },
/* U+4605 */ { 0, 0, 0, 0, 0 },
/* U+4606 */ { 0, 0, 0, 0, 0 },
/* U+4607 */ { 0, 0, 0, 0, 0 },
/* U+4608 */ { 0, 0, 0, 0, 0 },
/* U+4609 */ { 0, 0, 0, 0, 0 },
/* U+460a */ { 0, 0, 0, 0, 0 },
/* U+460b */ { 0, 0, 0, 0, 0 },
/* U+460c */ { 0, 0, 0, 0, 0 },
/* U+460d */ { 0, 0, 0, 0, 0 },
/* U+460e */ { 0, 0, 0, 0, 0 },
/* U+460f */ { 0, 0, 0, 0, 0 },
/* U+4610 */ { 0, 0, 0, 0, 0 },
/* U+4611 */ { 0, 0, 0, 0, 0 },
/* U+4612 */ { 0, 0, 0, 0, 0 },
/* U+4613 */ { 0, 0, 0, 0, 0 },
/* U+4614 */ { 0, 0, 0, 0, 0 },
/* U+4615 */ { 0, 0, 0, 0, 0 },
/* U+4616 */ { 0, 0, 0, 0, 0 },
/* U+4617 */ { 0, 0, 0, 0, 0 },
/* U+4618 */ { 0, 0, 0, 0, 0 },
/* U+4619 */ { 0, 0, 0, 0, 0 },
/* U+461a */ { 0, 0, 0, 0, 0 },
/* U+461b */ { 0, 0, 0, 0, 0 },
/* U+461c */ { 0, 0, 0, 0, 0 },
/* U+461d */ { 0, 0, 0, 0, 0 },
/* U+461e */ { 0, 0, 0, 0, 0 },
/* U+461f */ { 0, 0, 0, 0, 0 },
/* U+4620 */ { 0, 0, 0, 0, 0 },
/* U+4621 */ { 0, 0, 0, 0, 0 },
/* U+4622 */ { 0, 0, 0, 0, 0 },
/* U+4623 */ { 0, 0, 0, 0, 0 },
/* U+4624 */ { 0, 0, 0, 0, 0 },
/* U+4625 */ { 0, 0, 0, 0, 0 },
/* U+4626 */ { 0, 0, 0, 0, 0 },
/* U+4627 */ { 0, 0, 0, 0, 0 },
/* U+4628 */ { 0, 0, 0, 0, 0 },
/* U+4629 */ { 0, 0, 0, 0, 0 },
/* U+462a */ { 0, 0, 0, 0, 0 },
/* U+462b */ { 0, 0, 0, 0, 0 },
/* U+462c */ { 0, 0, 0, 0, 0 },
/* U+462d */ { 0, 0, 0, 0, 0 },
/* U+462e */ { 0, 0, 0, 0, 0 },
/* U+462f */ { 0, 0, 0, 0, 0 },
/* U+4630 */ { 0, 0, 0, 0, 0 },
/* U+4631 */ { 0, 0, 0, 0, 0 },
/* U+4632 */ { 0, 0, 0, 0, 0 },
/* U+4633 */ { 0, 0, 0, 0, 0 },
/* U+4634 */ { 0, 0, 0, 0, 0 },
/* U+4635 */ { 0, 0, 0, 0, 0 },
/* U+4636 */ { 0, 0, 0, 0, 0 },
/* U+4637 */ { 0, 0, 0, 0, 0 },
/* U+4638 */ { 0, 0, 0, 0, 0 },
/* U+4639 */ { 0, 0, 0, 0, 0 },
/* U+463a */ { 0, 0, 0, 0, 0 },
/* U+463b */ { 0, 0, 0, 0, 0 },
/* U+463c */ { 0, 0, 0, 0, 0 },
/* U+463d */ { 0, 0, 0, 0, 0 },
/* U+463e */ { 0, 0, 0, 0, 0 },
/* U+463f */ { 0, 0, 0, 0, 0 },
/* U+4640 */ { 0, 0, 0, 0, 0 },
/* U+4641 */ { 0, 0, 0, 0, 0 },
/* U+4642 */ { 0, 0, 0, 0, 0 },
/* U+4643 */ { 0, 0, 0, 0, 0 },
/* U+4644 */ { 0, 0, 0, 0, 0 },
/* U+4645 */ { 0, 0, 0, 0, 0 },
/* U+4646 */ { 0, 0, 0, 0, 0 },
/* U+4647 */ { 0, 0, 0, 0, 0 },
/* U+4648 */ { 0, 0, 0, 0, 0 },
/* U+4649 */ { 0, 0, 0, 0, 0 },
/* U+464a */ { 0, 0, 0, 0, 0 },
/* U+464b */ { 0, 0, 0, 0, 0 },
/* U+464c */ { 0, 0, 0, 0, 0 },
/* U+464d */ { 0, 0, 0, 0, 0 },
/* U+464e */ { 0, 0, 0, 0, 0 },
/* U+464f */ { 0, 0, 0, 0, 0 },
/* U+4650 */ { 0, 0, 0, 0, 0 },
/* U+4651 */ { 0, 0, 0, 0, 0 },
/* U+4652 */ { 0, 0, 0, 0, 0 },
/* U+4653 */ { 0, 0, 0, 0, 0 },
/* U+4654 */ { 0, 0, 0, 0, 0 },
/* U+4655 */ { 0, 0, 0, 0, 0 },
/* U+4656 */ { 0, 0, 0, 0, 0 },
/* U+4657 */ { 0, 0, 0, 0, 0 },
/* U+4658 */ { 0, 0, 0, 0, 0 },
/* U+4659 */ { 0, 0, 0, 0, 0 },
/* U+465a */ { 0, 0, 0, 0, 0 },
/* U+465b */ { 0, 0, 0, 0, 0 },
/* U+465c */ { 0, 0, 0, 0, 0 },
/* U+465d */ { 0, 0, 0, 0, 0 },
/* U+465e */ { 0, 0, 0, 0, 0 },
/* U+465f */ { 0, 0, 0, 0, 0 },
/* U+4660 */ { 0, 0, 0, 0, 0 },
/* U+4661 */ { 0, 0, 0, 0, 0 },
/* U+4662 */ { 0, 0, 0, 0, 0 },
/* U+4663 */ { 0, 0, 0, 0, 0 },
/* U+4664 */ { 0, 0, 0, 0, 0 },
/* U+4665 */ { 0, 0, 0, 0, 0 },
/* U+4666 */ { 0, 0, 0, 0, 0 },
/* U+4667 */ { 0, 0, 0, 0, 0 },
/* U+4668 */ { 0, 0, 0, 0, 0 },
/* U+4669 */ { 0, 0, 0, 0, 0 },
/* U+466a */ { 0, 0, 0, 0, 0 },
/* U+466b */ { 0, 0, 0, 0, 0 },
/* U+466c */ { 0, 0, 0, 0, 0 },
/* U+466d */ { 0, 0, 0, 0, 0 },
/* U+466e */ { 0, 0, 0, 0, 0 },
/* U+466f */ { 0, 0, 0, 0, 0 },
/* U+4670 */ { 0, 0, 0, 0, 0 },
/* U+4671 */ { 0, 0, 0, 0, 0 },
/* U+4672 */ { 0, 0, 0, 0, 0 },
/* U+4673 */ { 0, 0, 0, 0, 0 },
/* U+4674 */ { 0, 0, 0, 0, 0 },
/* U+4675 */ { 0, 0, 0, 0, 0 },
/* U+4676 */ { 0, 0, 0, 0, 0 },
/* U+4677 */ { 0, 0, 0, 0, 0 },
/* U+4678 */ { 0, 0, 0, 0, 0 },
/* U+4679 */ { 0, 0, 0, 0, 0 },
/* U+467a */ { 0, 0, 0, 0, 0 },
/* U+467b */ { 0, 0, 0, 0, 0 },
/* U+467c */ { 0, 0, 0, 0, 0 },
/* U+467d */ { 0, 0, 0, 0, 0 },
/* U+467e */ { 0, 0, 0, 0, 0 },
/* U+467f */ { 0, 0, 0, 0, 0 },
/* U+4680 */ { 0, 0, 0, 0, 0 },
/* U+4681 */ { 0, 0, 0, 0, 0 },
/* U+4682 */ { 0, 0, 0, 0, 0 },
/* U+4683 */ { 0, 0, 0, 0, 0 },
/* U+4684 */ { 0, 0, 0, 0, 0 },
/* U+4685 */ { 0, 0, 0, 0, 0 },
/* U+4686 */ { 0, 0, 0, 0, 0 },
/* U+4687 */ { 0, 0, 0, 0, 0 },
/* U+4688 */ { 0, 0, 0, 0, 0 },
/* U+4689 */ { 0, 0, 0, 0, 0 },
/* U+468a */ { 0, 0, 0, 0, 0 },
/* U+468b */ { 0, 0, 0, 0, 0 },
/* U+468c */ { 0, 0, 0, 0, 0 },
/* U+468d */ { 0, 0, 0, 0, 0 },
/* U+468e */ { 0, 0, 0, 0, 0 },
/* U+468f */ { 0, 0, 0, 0, 0 },
/* U+4690 */ { 0, 0, 0, 0, 0 },
/* U+4691 */ { 0, 0, 0, 0, 0 },
/* U+4692 */ { 0, 0, 0, 0, 0 },
/* U+4693 */ { 0, 0, 0, 0, 0 },
/* U+4694 */ { 0, 0, 0, 0, 0 },
/* U+4695 */ { 0, 0, 0, 0, 0 },
/* U+4696 */ { 0, 0, 0, 0, 0 },
/* U+4697 */ { 0, 0, 0, 0, 0 },
/* U+4698 */ { 0, 0, 0, 0, 0 },
/* U+4699 */ { 0, 0, 0, 0, 0 },
/* U+469a */ { 0, 0, 0, 0, 0 },
/* U+469b */ { 0, 0, 0, 0, 0 },
/* U+469c */ { 0, 0, 0, 0, 0 },
/* U+469d */ { 0, 0, 0, 0, 0 },
/* U+469e */ { 0, 0, 0, 0, 0 },
/* U+469f */ { 0, 0, 0, 0, 0 },
/* U+46a0 */ { 0, 0, 0, 0, 0 },
/* U+46a1 */ { 0, 0, 0, 0, 0 },
/* U+46a2 */ { 0, 0, 0, 0, 0 },
/* U+46a3 */ { 0, 0, 0, 0, 0 },
/* U+46a4 */ { 0, 0, 0, 0, 0 },
/* U+46a5 */ { 0, 0, 0, 0, 0 },
/* U+46a6 */ { 0, 0, 0, 0, 0 },
/* U+46a7 */ { 0, 0, 0, 0, 0 },
/* U+46a8 */ { 0, 0, 0, 0, 0 },
/* U+46a9 */ { 0, 0, 0, 0, 0 },
/* U+46aa */ { 0, 0, 0, 0, 0 },
/* U+46ab */ { 0, 0, 0, 0, 0 },
/* U+46ac */ { 0, 0, 0, 0, 0 },
/* U+46ad */ { 0, 0, 0, 0, 0 },
/* U+46ae */ { 0, 0, 0, 0, 0 },
/* U+46af */ { 0, 0, 0, 0, 0 },
/* U+46b0 */ { 0, 0, 0, 0, 0 },
/* U+46b1 */ { 0, 0, 0, 0, 0 },
/* U+46b2 */ { 0, 0, 0, 0, 0 },
/* U+46b3 */ { 0, 0, 0, 0, 0 },
/* U+46b4 */ { 0, 0, 0, 0, 0 },
/* U+46b5 */ { 0, 0, 0, 0, 0 },
/* U+46b6 */ { 0, 0, 0, 0, 0 },
/* U+46b7 */ { 0, 0, 0, 0, 0 },
/* U+46b8 */ { 0, 0, 0, 0, 0 },
/* U+46b9 */ { 0, 0, 0, 0, 0 },
/* U+46ba */ { 0, 0, 0, 0, 0 },
/* U+46bb */ { 0, 0, 0, 0, 0 },
/* U+46bc */ { 0, 0, 0, 0, 0 },
/* U+46bd */ { 0, 0, 0, 0, 0 },
/* U+46be */ { 0, 0, 0, 0, 0 },
/* U+46bf */ { 0, 0, 0, 0, 0 },
/* U+46c0 */ { 0, 0, 0, 0, 0 },
/* U+46c1 */ { 0, 0, 0, 0, 0 },
/* U+46c2 */ { 0, 0, 0, 0, 0 },
/* U+46c3 */ { 0, 0, 0, 0, 0 },
/* U+46c4 */ { 0, 0, 0, 0, 0 },
/* U+46c5 */ { 0, 0, 0, 0, 0 },
/* U+46c6 */ { 0, 0, 0, 0, 0 },
/* U+46c7 */ { 0, 0, 0, 0, 0 },
/* U+46c8 */ { 0, 0, 0, 0, 0 },
/* U+46c9 */ { 0, 0, 0, 0, 0 },
/* U+46ca */ { 0, 0, 0, 0, 0 },
/* U+46cb */ { 0, 0, 0, 0, 0 },
/* U+46cc */ { 0, 0, 0, 0, 0 },
/* U+46cd */ { 0, 0, 0, 0, 0 },
/* U+46ce */ { 0, 0, 0, 0, 0 },
/* U+46cf */ { 0, 0, 0, 0, 0 },
/* U+46d0 */ { 0, 0, 0, 0, 0 },
/* U+46d1 */ { 0, 0, 0, 0, 0 },
/* U+46d2 */ { 0, 0, 0, 0, 0 },
/* U+46d3 */ { 0, 0, 0, 0, 0 },
/* U+46d4 */ { 0, 0, 0, 0, 0 },
/* U+46d5 */ { 0, 0, 0, 0, 0 },
/* U+46d6 */ { 0, 0, 0, 0, 0 },
/* U+46d7 */ { 0, 0, 0, 0, 0 },
/* U+46d8 */ { 0, 0, 0, 0, 0 },
/* U+46d9 */ { 0, 0, 0, 0, 0 },
/* U+46da */ { 0, 0, 0, 0, 0 },
/* U+46db */ { 0, 0, 0, 0, 0 },
/* U+46dc */ { 0, 0, 0, 0, 0 },
/* U+46dd */ { 0, 0, 0, 0, 0 },
/* U+46de */ { 0, 0, 0, 0, 0 },
/* U+46df */ { 0, 0, 0, 0, 0 },
/* U+46e0 */ { 0, 0, 0, 0, 0 },
/* U+46e1 */ { 0, 0, 0, 0, 0 },
/* U+46e2 */ { 0, 0, 0, 0, 0 },
/* U+46e3 */ { 0, 0, 0, 0, 0 },
/* U+46e4 */ { 0, 0, 0, 0, 0 },
/* U+46e5 */ { 0, 0, 0, 0, 0 },
/* U+46e6 */ { 0, 0, 0, 0, 0 },
/* U+46e7 */ { 0, 0, 0, 0, 0 },
/* U+46e8 */ { 0, 0, 0, 0, 0 },
/* U+46e9 */ { 0, 0, 0, 0, 0 },
/* U+46ea */ { 0, 0, 0, 0, 0 },
/* U+46eb */ { 0, 0, 0, 0, 0 },
/* U+46ec */ { 0, 0, 0, 0, 0 },
/* U+46ed */ { 0, 0, 0, 0, 0 },
/* U+46ee */ { 0, 0, 0, 0, 0 },
/* U+46ef */ { 0, 0, 0, 0, 0 },
/* U+46f0 */ { 0, 0, 0, 0, 0 },
/* U+46f1 */ { 0, 0, 0, 0, 0 },
/* U+46f2 */ { 0, 0, 0, 0, 0 },
/* U+46f3 */ { 0, 0, 0, 0, 0 },
/* U+46f4 */ { 0, 0, 0, 0, 0 },
/* U+46f5 */ { 0, 0, 0, 0, 0 },
/* U+46f6 */ { 0, 0, 0, 0, 0 },
/* U+46f7 */ { 0, 0, 0, 0, 0 },
/* U+46f8 */ { 0, 0, 0, 0, 0 },
/* U+46f9 */ { 0, 0, 0, 0, 0 },
/* U+46fa */ { 0, 0, 0, 0, 0 },
/* U+46fb */ { 0, 0, 0, 0, 0 },
/* U+46fc */ { 0, 0, 0, 0, 0 },
/* U+46fd */ { 0, 0, 0, 0, 0 },
/* U+46fe */ { 0, 0, 0, 0, 0 },
/* U+46ff */ { 0, 0, 0, 0, 0 },
/* U+4700 */ { 0, 0, 0, 0, 0 },
/* U+4701 */ { 0, 0, 0, 0, 0 },
/* U+4702 */ { 0, 0, 0, 0, 0 },
/* U+4703 */ { 0, 0, 0, 0, 0 },
/* U+4704 */ { 0, 0, 0, 0, 0 },
/* U+4705 */ { 0, 0, 0, 0, 0 },
/* U+4706 */ { 0, 0, 0, 0, 0 },
/* U+4707 */ { 0, 0, 0, 0, 0 },
/* U+4708 */ { 0, 0, 0, 0, 0 },
/* U+4709 */ { 0, 0, 0, 0, 0 },
/* U+470a */ { 0, 0, 0, 0, 0 },
/* U+470b */ { 0, 0, 0, 0, 0 },
/* U+470c */ { 0, 0, 0, 0, 0 },
/* U+470d */ { 0, 0, 0, 0, 0 },
/* U+470e */ { 0, 0, 0, 0, 0 },
/* U+470f */ { 0, 0, 0, 0, 0 },
/* U+4710 */ { 0, 0, 0, 0, 0 },
/* U+4711 */ { 0, 0, 0, 0, 0 },
/* U+4712 */ { 0, 0, 0, 0, 0 },
/* U+4713 */ { 0, 0, 0, 0, 0 },
/* U+4714 */ { 0, 0, 0, 0, 0 },
/* U+4715 */ { 0, 0, 0, 0, 0 },
/* U+4716 */ { 0, 0, 0, 0, 0 },
/* U+4717 */ { 0, 0, 0, 0, 0 },
/* U+4718 */ { 0, 0, 0, 0, 0 },
/* U+4719 */ { 0, 0, 0, 0, 0 },
/* U+471a */ { 0, 0, 0, 0, 0 },
/* U+471b */ { 0, 0, 0, 0, 0 },
/* U+471c */ { 0, 0, 0, 0, 0 },
/* U+471d */ { 0, 0, 0, 0, 0 },
/* U+471e */ { 0, 0, 0, 0, 0 },
/* U+471f */ { 0, 0, 0, 0, 0 },
/* U+4720 */ { 0, 0, 0, 0, 0 },
/* U+4721 */ { 0, 0, 0, 0, 0 },
/* U+4722 */ { 0, 0, 0, 0, 0 },
/* U+4723 */ { 0, 0, 0, 0, 0 },
/* U+4724 */ { 0, 0, 0, 0, 0 },
/* U+4725 */ { 0, 0, 0, 0, 0 },
/* U+4726 */ { 0, 0, 0, 0, 0 },
/* U+4727 */ { 0, 0, 0, 0, 0 },
/* U+4728 */ { 0, 0, 0, 0, 0 },
/* U+4729 */ { 0, 0, 0, 0, 0 },
/* U+472a */ { 0, 0, 0, 0, 0 },
/* U+472b */ { 0, 0, 0, 0, 0 },
/* U+472c */ { 0, 0, 0, 0, 0 },
/* U+472d */ { 0, 0, 0, 0, 0 },
/* U+472e */ { 0, 0, 0, 0, 0 },
/* U+472f */ { 0, 0, 0, 0, 0 },
/* U+4730 */ { 0, 0, 0, 0, 0 },
/* U+4731 */ { 0, 0, 0, 0, 0 },
/* U+4732 */ { 0, 0, 0, 0, 0 },
/* U+4733 */ { 0, 0, 0, 0, 0 },
/* U+4734 */ { 0, 0, 0, 0, 0 },
/* U+4735 */ { 0, 0, 0, 0, 0 },
/* U+4736 */ { 0, 0, 0, 0, 0 },
/* U+4737 */ { 0, 0, 0, 0, 0 },
/* U+4738 */ { 0, 0, 0, 0, 0 },
/* U+4739 */ { 0, 0, 0, 0, 0 },
/* U+473a */ { 0, 0, 0, 0, 0 },
/* U+473b */ { 0, 0, 0, 0, 0 },
/* U+473c */ { 0, 0, 0, 0, 0 },
/* U+473d */ { 0, 0, 0, 0, 0 },
/* U+473e */ { 0, 0, 0, 0, 0 },
/* U+473f */ { 0, 0, 0, 0, 0 },
/* U+4740 */ { 0, 0, 0, 0, 0 },
/* U+4741 */ { 0, 0, 0, 0, 0 },
/* U+4742 */ { 0, 0, 0, 0, 0 },
/* U+4743 */ { 0, 0, 0, 0, 0 },
/* U+4744 */ { 0, 0, 0, 0, 0 },
/* U+4745 */ { 0, 0, 0, 0, 0 },
/* U+4746 */ { 0, 0, 0, 0, 0 },
/* U+4747 */ { 0, 0, 0, 0, 0 },
/* U+4748 */ { 0, 0, 0, 0, 0 },
/* U+4749 */ { 0, 0, 0, 0, 0 },
/* U+474a */ { 0, 0, 0, 0, 0 },
/* U+474b */ { 0, 0, 0, 0, 0 },
/* U+474c */ { 0, 0, 0, 0, 0 },
/* U+474d */ { 0, 0, 0, 0, 0 },
/* U+474e */ { 0, 0, 0, 0, 0 },
/* U+474f */ { 0, 0, 0, 0, 0 },
/* U+4750 */ { 0, 0, 0, 0, 0 },
/* U+4751 */ { 0, 0, 0, 0, 0 },
/* U+4752 */ { 0, 0, 0, 0, 0 },
/* U+4753 */ { 0, 0, 0, 0, 0 },
/* U+4754 */ { 0, 0, 0, 0, 0 },
/* U+4755 */ { 0, 0, 0, 0, 0 },
/* U+4756 */ { 0, 0, 0, 0, 0 },
/* U+4757 */ { 0, 0, 0, 0, 0 },
/* U+4758 */ { 0, 0, 0, 0, 0 },
/* U+4759 */ { 0, 0, 0, 0, 0 },
/* U+475a */ { 0, 0, 0, 0, 0 },
/* U+475b */ { 0, 0, 0, 0, 0 },
/* U+475c */ { 0, 0, 0, 0, 0 },
/* U+475d */ { 0, 0, 0, 0, 0 },
/* U+475e */ { 0, 0, 0, 0, 0 },
/* U+475f */ { 0, 0, 0, 0, 0 },
/* U+4760 */ { 0, 0, 0, 0, 0 },
/* U+4761 */ { 0, 0, 0, 0, 0 },
/* U+4762 */ { 0, 0, 0, 0, 0 },
/* U+4763 */ { 0, 0, 0, 0, 0 },
/* U+4764 */ { 0, 0, 0, 0, 0 },
/* U+4765 */ { 0, 0, 0, 0, 0 },
/* U+4766 */ { 0, 0, 0, 0, 0 },
/* U+4767 */ { 0, 0, 0, 0, 0 },
/* U+4768 */ { 0, 0, 0, 0, 0 },
/* U+4769 */ { 0, 0, 0, 0, 0 },
/* U+476a */ { 0, 0, 0, 0, 0 },
/* U+476b */ { 0, 0, 0, 0, 0 },
/* U+476c */ { 0, 0, 0, 0, 0 },
/* U+476d */ { 0, 0, 0, 0, 0 },
/* U+476e */ { 0, 0, 0, 0, 0 },
/* U+476f */ { 0, 0, 0, 0, 0 },
/* U+4770 */ { 0, 0, 0, 0, 0 },
/* U+4771 */ { 0, 0, 0, 0, 0 },
/* U+4772 */ { 0, 0, 0, 0, 0 },
/* U+4773 */ { 0, 0, 0, 0, 0 },
/* U+4774 */ { 0, 0, 0, 0, 0 },
/* U+4775 */ { 0, 0, 0, 0, 0 },
/* U+4776 */ { 0, 0, 0, 0, 0 },
/* U+4777 */ { 0, 0, 0, 0, 0 },
/* U+4778 */ { 0, 0, 0, 0, 0 },
/* U+4779 */ { 0, 0, 0, 0, 0 },
/* U+477a */ { 0, 0, 0, 0, 0 },
/* U+477b */ { 0, 0, 0, 0, 0 },
/* U+477c */ { 0, 0, 0, 0, 0 },
/* U+477d */ { 0, 0, 0, 0, 0 },
/* U+477e */ { 0, 0, 0, 0, 0 },
/* U+477f */ { 0, 0, 0, 0, 0 },
/* U+4780 */ { 0, 0, 0, 0, 0 },
/* U+4781 */ { 0, 0, 0, 0, 0 },
/* U+4782 */ { 0, 0, 0, 0, 0 },
/* U+4783 */ { 0, 0, 0, 0, 0 },
/* U+4784 */ { 0, 0, 0, 0, 0 },
/* U+4785 */ { 0, 0, 0, 0, 0 },
/* U+4786 */ { 0, 0, 0, 0, 0 },
/* U+4787 */ { 0, 0, 0, 0, 0 },
/* U+4788 */ { 0, 0, 0, 0, 0 },
/* U+4789 */ { 0, 0, 0, 0, 0 },
/* U+478a */ { 0, 0, 0, 0, 0 },
/* U+478b */ { 0, 0, 0, 0, 0 },
/* U+478c */ { 0, 0, 0, 0, 0 },
/* U+478d */ { 0, 0, 0, 0, 0 },
/* U+478e */ { 0, 0, 0, 0, 0 },
/* U+478f */ { 0, 0, 0, 0, 0 },
/* U+4790 */ { 0, 0, 0, 0, 0 },
/* U+4791 */ { 0, 0, 0, 0, 0 },
/* U+4792 */ { 0, 0, 0, 0, 0 },
/* U+4793 */ { 0, 0, 0, 0, 0 },
/* U+4794 */ { 0, 0, 0, 0, 0 },
/* U+4795 */ { 0, 0, 0, 0, 0 },
/* U+4796 */ { 0, 0, 0, 0, 0 },
/* U+4797 */ { 0, 0, 0, 0, 0 },
/* U+4798 */ { 0, 0, 0, 0, 0 },
/* U+4799 */ { 0, 0, 0, 0, 0 },
/* U+479a */ { 0, 0, 0, 0, 0 },
/* U+479b */ { 0, 0, 0, 0, 0 },
/* U+479c */ { 0, 0, 0, 0, 0 },
/* U+479d */ { 0, 0, 0, 0, 0 },
/* U+479e */ { 0, 0, 0, 0, 0 },
/* U+479f */ { 0, 0, 0, 0, 0 },
/* U+47a0 */ { 0, 0, 0, 0, 0 },
/* U+47a1 */ { 0, 0, 0, 0, 0 },
/* U+47a2 */ { 0, 0, 0, 0, 0 },
/* U+47a3 */ { 0, 0, 0, 0, 0 },
/* U+47a4 */ { 0, 0, 0, 0, 0 },
/* U+47a5 */ { 0, 0, 0, 0, 0 },
/* U+47a6 */ { 0, 0, 0, 0, 0 },
/* U+47a7 */ { 0, 0, 0, 0, 0 },
/* U+47a8 */ { 0, 0, 0, 0, 0 },
/* U+47a9 */ { 0, 0, 0, 0, 0 },
/* U+47aa */ { 0, 0, 0, 0, 0 },
/* U+47ab */ { 0, 0, 0, 0, 0 },
/* U+47ac */ { 0, 0, 0, 0, 0 },
/* U+47ad */ { 0, 0, 0, 0, 0 },
/* U+47ae */ { 0, 0, 0, 0, 0 },
/* U+47af */ { 0, 0, 0, 0, 0 },
/* U+47b0 */ { 0, 0, 0, 0, 0 },
/* U+47b1 */ { 0, 0, 0, 0, 0 },
/* U+47b2 */ { 0, 0, 0, 0, 0 },
/* U+47b3 */ { 0, 0, 0, 0, 0 },
/* U+47b4 */ { 0, 0, 0, 0, 0 },
/* U+47b5 */ { 0, 0, 0, 0, 0 },
/* U+47b6 */ { 0, 0, 0, 0, 0 },
/* U+47b7 */ { 0, 0, 0, 0, 0 },
/* U+47b8 */ { 0, 0, 0, 0, 0 },
/* U+47b9 */ { 0, 0, 0, 0, 0 },
/* U+47ba */ { 0, 0, 0, 0, 0 },
/* U+47bb */ { 0, 0, 0, 0, 0 },
/* U+47bc */ { 0, 0, 0, 0, 0 },
/* U+47bd */ { 0, 0, 0, 0, 0 },
/* U+47be */ { 0, 0, 0, 0, 0 },
/* U+47bf */ { 0, 0, 0, 0, 0 },
/* U+47c0 */ { 0, 0, 0, 0, 0 },
/* U+47c1 */ { 0, 0, 0, 0, 0 },
/* U+47c2 */ { 0, 0, 0, 0, 0 },
/* U+47c3 */ { 0, 0, 0, 0, 0 },
/* U+47c4 */ { 0, 0, 0, 0, 0 },
/* U+47c5 */ { 0, 0, 0, 0, 0 },
/* U+47c6 */ { 0, 0, 0, 0, 0 },
/* U+47c7 */ { 0, 0, 0, 0, 0 },
/* U+47c8 */ { 0, 0, 0, 0, 0 },
/* U+47c9 */ { 0, 0, 0, 0, 0 },
/* U+47ca */ { 0, 0, 0, 0, 0 },
/* U+47cb */ { 0, 0, 0, 0, 0 },
/* U+47cc */ { 0, 0, 0, 0, 0 },
/* U+47cd */ { 0, 0, 0, 0, 0 },
/* U+47ce */ { 0, 0, 0, 0, 0 },
/* U+47cf */ { 0, 0, 0, 0, 0 },
/* U+47d0 */ { 0, 0, 0, 0, 0 },
/* U+47d1 */ { 0, 0, 0, 0, 0 },
/* U+47d2 */ { 0, 0, 0, 0, 0 },
/* U+47d3 */ { 0, 0, 0, 0, 0 },
/* U+47d4 */ { 0, 0, 0, 0, 0 },
/* U+47d5 */ { 0, 0, 0, 0, 0 },
/* U+47d6 */ { 0, 0, 0, 0, 0 },
/* U+47d7 */ { 0, 0, 0, 0, 0 },
/* U+47d8 */ { 0, 0, 0, 0, 0 },
/* U+47d9 */ { 0, 0, 0, 0, 0 },
/* U+47da */ { 0, 0, 0, 0, 0 },
/* U+47db */ { 0, 0, 0, 0, 0 },
/* U+47dc */ { 0, 0, 0, 0, 0 },
/* U+47dd */ { 0, 0, 0, 0, 0 },
/* U+47de */ { 0, 0, 0, 0, 0 },
/* U+47df */ { 0, 0, 0, 0, 0 },
/* U+47e0 */ { 0, 0, 0, 0, 0 },
/* U+47e1 */ { 0, 0, 0, 0, 0 },
/* U+47e2 */ { 0, 0, 0, 0, 0 },
/* U+47e3 */ { 0, 0, 0, 0, 0 },
/* U+47e4 */ { 0, 0, 0, 0, 0 },
/* U+47e5 */ { 0, 0, 0, 0, 0 },
/* U+47e6 */ { 0, 0, 0, 0, 0 },
/* U+47e7 */ { 0, 0, 0, 0, 0 },
/* U+47e8 */ { 0, 0, 0, 0, 0 },
/* U+47e9 */ { 0, 0, 0, 0, 0 },
/* U+47ea */ { 0, 0, 0, 0, 0 },
/* U+47eb */ { 0, 0, 0, 0, 0 },
/* U+47ec */ { 0, 0, 0, 0, 0 },
/* U+47ed */ { 0, 0, 0, 0, 0 },
/* U+47ee */ { 0, 0, 0, 0, 0 },
/* U+47ef */ { 0, 0, 0, 0, 0 },
/* U+47f0 */ { 0, 0, 0, 0, 0 },
/* U+47f1 */ { 0, 0, 0, 0, 0 },
/* U+47f2 */ { 0, 0, 0, 0, 0 },
/* U+47f3 */ { 0, 0, 0, 0, 0 },
/* U+47f4 */ { 0, 0, 0, 0, 0 },
/* U+47f5 */ { 0, 0, 0, 0, 0 },
/* U+47f6 */ { 0, 0, 0, 0, 0 },
/* U+47f7 */ { 0, 0, 0, 0, 0 },
/* U+47f8 */ { 0, 0, 0, 0, 0 },
/* U+47f9 */ { 0, 0, 0, 0, 0 },
/* U+47fa */ { 0, 0, 0, 0, 0 },
/* U+47fb */ { 0, 0, 0, 0, 0 },
/* U+47fc */ { 0, 0, 0, 0, 0 },
/* U+47fd */ { 0, 0, 0, 0, 0 },
/* U+47fe */ { 0, 0, 0, 0, 0 },
/* U+47ff */ { 0, 0, 0, 0, 0 },
/* U+4800 */ { 0, 0, 0, 0, 0 },
/* U+4801 */ { 0, 0, 0, 0, 0 },
/* U+4802 */ { 0, 0, 0, 0, 0 },
/* U+4803 */ { 0, 0, 0, 0, 0 },
/* U+4804 */ { 0, 0, 0, 0, 0 },
/* U+4805 */ { 0, 0, 0, 0, 0 },
/* U+4806 */ { 0, 0, 0, 0, 0 },
/* U+4807 */ { 0, 0, 0, 0, 0 },
/* U+4808 */ { 0, 0, 0, 0, 0 },
/* U+4809 */ { 0, 0, 0, 0, 0 },
/* U+480a */ { 0, 0, 0, 0, 0 },
/* U+480b */ { 0, 0, 0, 0, 0 },
/* U+480c */ { 0, 0, 0, 0, 0 },
/* U+480d */ { 0, 0, 0, 0, 0 },
/* U+480e */ { 0, 0, 0, 0, 0 },
/* U+480f */ { 0, 0, 0, 0, 0 },
/* U+4810 */ { 0, 0, 0, 0, 0 },
/* U+4811 */ { 0, 0, 0, 0, 0 },
/* U+4812 */ { 0, 0, 0, 0, 0 },
/* U+4813 */ { 0, 0, 0, 0, 0 },
/* U+4814 */ { 0, 0, 0, 0, 0 },
/* U+4815 */ { 0, 0, 0, 0, 0 },
/* U+4816 */ { 0, 0, 0, 0, 0 },
/* U+4817 */ { 0, 0, 0, 0, 0 },
/* U+4818 */ { 0, 0, 0, 0, 0 },
/* U+4819 */ { 0, 0, 0, 0, 0 },
/* U+481a */ { 0, 0, 0, 0, 0 },
/* U+481b */ { 0, 0, 0, 0, 0 },
/* U+481c */ { 0, 0, 0, 0, 0 },
/* U+481d */ { 0, 0, 0, 0, 0 },
/* U+481e */ { 0, 0, 0, 0, 0 },
/* U+481f */ { 0, 0, 0, 0, 0 },
/* U+4820 */ { 0, 0, 0, 0, 0 },
/* U+4821 */ { 0, 0, 0, 0, 0 },
/* U+4822 */ { 0, 0, 0, 0, 0 },
/* U+4823 */ { 0, 0, 0, 0, 0 },
/* U+4824 */ { 0, 0, 0, 0, 0 },
/* U+4825 */ { 0, 0, 0, 0, 0 },
/* U+4826 */ { 0, 0, 0, 0, 0 },
/* U+4827 */ { 0, 0, 0, 0, 0 },
/* U+4828 */ { 0, 0, 0, 0, 0 },
/* U+4829 */ { 0, 0, 0, 0, 0 },
/* U+482a */ { 0, 0, 0, 0, 0 },
/* U+482b */ { 0, 0, 0, 0, 0 },
/* U+482c */ { 0, 0, 0, 0, 0 },
/* U+482d */ { 0, 0, 0, 0, 0 },
/* U+482e */ { 0, 0, 0, 0, 0 },
/* U+482f */ { 0, 0, 0, 0, 0 },
/* U+4830 */ { 0, 0, 0, 0, 0 },
/* U+4831 */ { 0, 0, 0, 0, 0 },
/* U+4832 */ { 0, 0, 0, 0, 0 },
/* U+4833 */ { 0, 0, 0, 0, 0 },
/* U+4834 */ { 0, 0, 0, 0, 0 },
/* U+4835 */ { 0, 0, 0, 0, 0 },
/* U+4836 */ { 0, 0, 0, 0, 0 },
/* U+4837 */ { 0, 0, 0, 0, 0 },
/* U+4838 */ { 0, 0, 0, 0, 0 },
/* U+4839 */ { 0, 0, 0, 0, 0 },
/* U+483a */ { 0, 0, 0, 0, 0 },
/* U+483b */ { 0, 0, 0, 0, 0 },
/* U+483c */ { 0, 0, 0, 0, 0 },
/* U+483d */ { 0, 0, 0, 0, 0 },
/* U+483e */ { 0, 0, 0, 0, 0 },
/* U+483f */ { 0, 0, 0, 0, 0 },
/* U+4840 */ { 0, 0, 0, 0, 0 },
/* U+4841 */ { 0, 0, 0, 0, 0 },
/* U+4842 */ { 0, 0, 0, 0, 0 },
/* U+4843 */ { 0, 0, 0, 0, 0 },
/* U+4844 */ { 0, 0, 0, 0, 0 },
/* U+4845 */ { 0, 0, 0, 0, 0 },
/* U+4846 */ { 0, 0, 0, 0, 0 },
/* U+4847 */ { 0, 0, 0, 0, 0 },
/* U+4848 */ { 0, 0, 0, 0, 0 },
/* U+4849 */ { 0, 0, 0, 0, 0 },
/* U+484a */ { 0, 0, 0, 0, 0 },
/* U+484b */ { 0, 0, 0, 0, 0 },
/* U+484c */ { 0, 0, 0, 0, 0 },
/* U+484d */ { 0, 0, 0, 0, 0 },
/* U+484e */ { 0, 0, 0, 0, 0 },
/* U+484f */ { 0, 0, 0, 0, 0 },
/* U+4850 */ { 0, 0, 0, 0, 0 },
/* U+4851 */ { 0, 0, 0, 0, 0 },
/* U+4852 */ { 0, 0, 0, 0, 0 },
/* U+4853 */ { 0, 0, 0, 0, 0 },
/* U+4854 */ { 0, 0, 0, 0, 0 },
/* U+4855 */ { 0, 0, 0, 0, 0 },
/* U+4856 */ { 0, 0, 0, 0, 0 },
/* U+4857 */ { 0, 0, 0, 0, 0 },
/* U+4858 */ { 0, 0, 0, 0, 0 },
/* U+4859 */ { 0, 0, 0, 0, 0 },
/* U+485a */ { 0, 0, 0, 0, 0 },
/* U+485b */ { 0, 0, 0, 0, 0 },
/* U+485c */ { 0, 0, 0, 0, 0 },
/* U+485d */ { 0, 0, 0, 0, 0 },
/* U+485e */ { 0, 0, 0, 0, 0 },
/* U+485f */ { 0, 0, 0, 0, 0 },
/* U+4860 */ { 0, 0, 0, 0, 0 },
/* U+4861 */ { 0, 0, 0, 0, 0 },
/* U+4862 */ { 0, 0, 0, 0, 0 },
/* U+4863 */ { 0, 0, 0, 0, 0 },
/* U+4864 */ { 0, 0, 0, 0, 0 },
/* U+4865 */ { 0, 0, 0, 0, 0 },
/* U+4866 */ { 0, 0, 0, 0, 0 },
/* U+4867 */ { 0, 0, 0, 0, 0 },
/* U+4868 */ { 0, 0, 0, 0, 0 },
/* U+4869 */ { 0, 0, 0, 0, 0 },
/* U+486a */ { 0, 0, 0, 0, 0 },
/* U+486b */ { 0, 0, 0, 0, 0 },
/* U+486c */ { 0, 0, 0, 0, 0 },
/* U+486d */ { 0, 0, 0, 0, 0 },
/* U+486e */ { 0, 0, 0, 0, 0 },
/* U+486f */ { 0, 0, 0, 0, 0 },
/* U+4870 */ { 0, 0, 0, 0, 0 },
/* U+4871 */ { 0, 0, 0, 0, 0 },
/* U+4872 */ { 0, 0, 0, 0, 0 },
/* U+4873 */ { 0, 0, 0, 0, 0 },
/* U+4874 */ { 0, 0, 0, 0, 0 },
/* U+4875 */ { 0, 0, 0, 0, 0 },
/* U+4876 */ { 0, 0, 0, 0, 0 },
/* U+4877 */ { 0, 0, 0, 0, 0 },
/* U+4878 */ { 0, 0, 0, 0, 0 },
/* U+4879 */ { 0, 0, 0, 0, 0 },
/* U+487a */ { 0, 0, 0, 0, 0 },
/* U+487b */ { 0, 0, 0, 0, 0 },
/* U+487c */ { 0, 0, 0, 0, 0 },
/* U+487d */ { 0, 0, 0, 0, 0 },
/* U+487e */ { 0, 0, 0, 0, 0 },
/* U+487f */ { 0, 0, 0, 0, 0 },
/* U+4880 */ { 0, 0, 0, 0, 0 },
/* U+4881 */ { 0, 0, 0, 0, 0 },
/* U+4882 */ { 0, 0, 0, 0, 0 },
/* U+4883 */ { 0, 0, 0, 0, 0 },
/* U+4884 */ { 0, 0, 0, 0, 0 },
/* U+4885 */ { 0, 0, 0, 0, 0 },
/* U+4886 */ { 0, 0, 0, 0, 0 },
/* U+4887 */ { 0, 0, 0, 0, 0 },
/* U+4888 */ { 0, 0, 0, 0, 0 },
/* U+4889 */ { 0, 0, 0, 0, 0 },
/* U+488a */ { 0, 0, 0, 0, 0 },
/* U+488b */ { 0, 0, 0, 0, 0 },
/* U+488c */ { 0, 0, 0, 0, 0 },
/* U+488d */ { 0, 0, 0, 0, 0 },
/* U+488e */ { 0, 0, 0, 0, 0 },
/* U+488f */ { 0, 0, 0, 0, 0 },
/* U+4890 */ { 0, 0, 0, 0, 0 },
/* U+4891 */ { 0, 0, 0, 0, 0 },
/* U+4892 */ { 0, 0, 0, 0, 0 },
/* U+4893 */ { 0, 0, 0, 0, 0 },
/* U+4894 */ { 0, 0, 0, 0, 0 },
/* U+4895 */ { 0, 0, 0, 0, 0 },
/* U+4896 */ { 0, 0, 0, 0, 0 },
/* U+4897 */ { 0, 0, 0, 0, 0 },
/* U+4898 */ { 0, 0, 0, 0, 0 },
/* U+4899 */ { 0, 0, 0, 0, 0 },
/* U+489a */ { 0, 0, 0, 0, 0 },
/* U+489b */ { 0, 0, 0, 0, 0 },
/* U+489c */ { 0, 0, 0, 0, 0 },
/* U+489d */ { 0, 0, 0, 0, 0 },
/* U+489e */ { 0, 0, 0, 0, 0 },
/* U+489f */ { 0, 0, 0, 0, 0 },
/* U+48a0 */ { 0, 0, 0, 0, 0 },
/* U+48a1 */ { 0, 0, 0, 0, 0 },
/* U+48a2 */ { 0, 0, 0, 0, 0 },
/* U+48a3 */ { 0, 0, 0, 0, 0 },
/* U+48a4 */ { 0, 0, 0, 0, 0 },
/* U+48a5 */ { 0, 0, 0, 0, 0 },
/* U+48a6 */ { 0, 0, 0, 0, 0 },
/* U+48a7 */ { 0, 0, 0, 0, 0 },
/* U+48a8 */ { 0, 0, 0, 0, 0 },
/* U+48a9 */ { 0, 0, 0, 0, 0 },
/* U+48aa */ { 0, 0, 0, 0, 0 },
/* U+48ab */ { 0, 0, 0, 0, 0 },
/* U+48ac */ { 0, 0, 0, 0, 0 },
/* U+48ad */ { 0, 0, 0, 0, 0 },
/* U+48ae */ { 0, 0, 0, 0, 0 },
/* U+48af */ { 0, 0, 0, 0, 0 },
/* U+48b0 */ { 0, 0, 0, 0, 0 },
/* U+48b1 */ { 0, 0, 0, 0, 0 },
/* U+48b2 */ { 0, 0, 0, 0, 0 },
/* U+48b3 */ { 0, 0, 0, 0, 0 },
/* U+48b4 */ { 0, 0, 0, 0, 0 },
/* U+48b5 */ { 0, 0, 0, 0, 0 },
/* U+48b6 */ { 0, 0, 0, 0, 0 },
/* U+48b7 */ { 0, 0, 0, 0, 0 },
/* U+48b8 */ { 0, 0, 0, 0, 0 },
/* U+48b9 */ { 0, 0, 0, 0, 0 },
/* U+48ba */ { 0, 0, 0, 0, 0 },
/* U+48bb */ { 0, 0, 0, 0, 0 },
/* U+48bc */ { 0, 0, 0, 0, 0 },
/* U+48bd */ { 0, 0, 0, 0, 0 },
/* U+48be */ { 0, 0, 0, 0, 0 },
/* U+48bf */ { 0, 0, 0, 0, 0 },
/* U+48c0 */ { 0, 0, 0, 0, 0 },
/* U+48c1 */ { 0, 0, 0, 0, 0 },
/* U+48c2 */ { 0, 0, 0, 0, 0 },
/* U+48c3 */ { 0, 0, 0, 0, 0 },
/* U+48c4 */ { 0, 0, 0, 0, 0 },
/* U+48c5 */ { 0, 0, 0, 0, 0 },
/* U+48c6 */ { 0, 0, 0, 0, 0 },
/* U+48c7 */ { 0, 0, 0, 0, 0 },
/* U+48c8 */ { 0, 0, 0, 0, 0 },
/* U+48c9 */ { 0, 0, 0, 0, 0 },
/* U+48ca */ { 0, 0, 0, 0, 0 },
/* U+48cb */ { 0, 0, 0, 0, 0 },
/* U+48cc */ { 0, 0, 0, 0, 0 },
/* U+48cd */ { 0, 0, 0, 0, 0 },
/* U+48ce */ { 0, 0, 0, 0, 0 },
/* U+48cf */ { 0, 0, 0, 0, 0 },
/* U+48d0 */ { 0, 0, 0, 0, 0 },
/* U+48d1 */ { 0, 0, 0, 0, 0 },
/* U+48d2 */ { 0, 0, 0, 0, 0 },
/* U+48d3 */ { 0, 0, 0, 0, 0 },
/* U+48d4 */ { 0, 0, 0, 0, 0 },
/* U+48d5 */ { 0, 0, 0, 0, 0 },
/* U+48d6 */ { 0, 0, 0, 0, 0 },
/* U+48d7 */ { 0, 0, 0, 0, 0 },
/* U+48d8 */ { 0, 0, 0, 0, 0 },
/* U+48d9 */ { 0, 0, 0, 0, 0 },
/* U+48da */ { 0, 0, 0, 0, 0 },
/* U+48db */ { 0, 0, 0, 0, 0 },
/* U+48dc */ { 0, 0, 0, 0, 0 },
/* U+48dd */ { 0, 0, 0, 0, 0 },
/* U+48de */ { 0, 0, 0, 0, 0 },
/* U+48df */ { 0, 0, 0, 0, 0 },
/* U+48e0 */ { 0, 0, 0, 0, 0 },
/* U+48e1 */ { 0, 0, 0, 0, 0 },
/* U+48e2 */ { 0, 0, 0, 0, 0 },
/* U+48e3 */ { 0, 0, 0, 0, 0 },
/* U+48e4 */ { 0, 0, 0, 0, 0 },
/* U+48e5 */ { 0, 0, 0, 0, 0 },
/* U+48e6 */ { 0, 0, 0, 0, 0 },
/* U+48e7 */ { 0, 0, 0, 0, 0 },
/* U+48e8 */ { 0, 0, 0, 0, 0 },
/* U+48e9 */ { 0, 0, 0, 0, 0 },
/* U+48ea */ { 0, 0, 0, 0, 0 },
/* U+48eb */ { 0, 0, 0, 0, 0 },
/* U+48ec */ { 0, 0, 0, 0, 0 },
/* U+48ed */ { 0, 0, 0, 0, 0 },
/* U+48ee */ { 0, 0, 0, 0, 0 },
/* U+48ef */ { 0, 0, 0, 0, 0 },
/* U+48f0 */ { 0, 0, 0, 0, 0 },
/* U+48f1 */ { 0, 0, 0, 0, 0 },
/* U+48f2 */ { 0, 0, 0, 0, 0 },
/* U+48f3 */ { 0, 0, 0, 0, 0 },
/* U+48f4 */ { 0, 0, 0, 0, 0 },
/* U+48f5 */ { 0, 0, 0, 0, 0 },
/* U+48f6 */ { 0, 0, 0, 0, 0 },
/* U+48f7 */ { 0, 0, 0, 0, 0 },
/* U+48f8 */ { 0, 0, 0, 0, 0 },
/* U+48f9 */ { 0, 0, 0, 0, 0 },
/* U+48fa */ { 0, 0, 0, 0, 0 },
/* U+48fb */ { 0, 0, 0, 0, 0 },
/* U+48fc */ { 0, 0, 0, 0, 0 },
/* U+48fd */ { 0, 0, 0, 0, 0 },
/* U+48fe */ { 0, 0, 0, 0, 0 },
/* U+48ff */ { 0, 0, 0, 0, 0 },
/* U+4900 */ { 0, 0, 0, 0, 0 },
/* U+4901 */ { 0, 0, 0, 0, 0 },
/* U+4902 */ { 0, 0, 0, 0, 0 },
/* U+4903 */ { 0, 0, 0, 0, 0 },
/* U+4904 */ { 0, 0, 0, 0, 0 },
/* U+4905 */ { 0, 0, 0, 0, 0 },
/* U+4906 */ { 0, 0, 0, 0, 0 },
/* U+4907 */ { 0, 0, 0, 0, 0 },
/* U+4908 */ { 0, 0, 0, 0, 0 },
/* U+4909 */ { 0, 0, 0, 0, 0 },
/* U+490a */ { 0, 0, 0, 0, 0 },
/* U+490b */ { 0, 0, 0, 0, 0 },
/* U+490c */ { 0, 0, 0, 0, 0 },
/* U+490d */ { 0, 0, 0, 0, 0 },
/* U+490e */ { 0, 0, 0, 0, 0 },
/* U+490f */ { 0, 0, 0, 0, 0 },
/* U+4910 */ { 0, 0, 0, 0, 0 },
/* U+4911 */ { 0, 0, 0, 0, 0 },
/* U+4912 */ { 0, 0, 0, 0, 0 },
/* U+4913 */ { 0, 0, 0, 0, 0 },
/* U+4914 */ { 0, 0, 0, 0, 0 },
/* U+4915 */ { 0, 0, 0, 0, 0 },
/* U+4916 */ { 0, 0, 0, 0, 0 },
/* U+4917 */ { 0, 0, 0, 0, 0 },
/* U+4918 */ { 0, 0, 0, 0, 0 },
/* U+4919 */ { 0, 0, 0, 0, 0 },
/* U+491a */ { 0, 0, 0, 0, 0 },
/* U+491b */ { 0, 0, 0, 0, 0 },
/* U+491c */ { 0, 0, 0, 0, 0 },
/* U+491d */ { 0, 0, 0, 0, 0 },
/* U+491e */ { 0, 0, 0, 0, 0 },
/* U+491f */ { 0, 0, 0, 0, 0 },
/* U+4920 */ { 0, 0, 0, 0, 0 },
/* U+4921 */ { 0, 0, 0, 0, 0 },
/* U+4922 */ { 0, 0, 0, 0, 0 },
/* U+4923 */ { 0, 0, 0, 0, 0 },
/* U+4924 */ { 0, 0, 0, 0, 0 },
/* U+4925 */ { 0, 0, 0, 0, 0 },
/* U+4926 */ { 0, 0, 0, 0, 0 },
/* U+4927 */ { 0, 0, 0, 0, 0 },
/* U+4928 */ { 0, 0, 0, 0, 0 },
/* U+4929 */ { 0, 0, 0, 0, 0 },
/* U+492a */ { 0, 0, 0, 0, 0 },
/* U+492b */ { 0, 0, 0, 0, 0 },
/* U+492c */ { 0, 0, 0, 0, 0 },
/* U+492d */ { 0, 0, 0, 0, 0 },
/* U+492e */ { 0, 0, 0, 0, 0 },
/* U+492f */ { 0, 0, 0, 0, 0 },
/* U+4930 */ { 0, 0, 0, 0, 0 },
/* U+4931 */ { 0, 0, 0, 0, 0 },
/* U+4932 */ { 0, 0, 0, 0, 0 },
/* U+4933 */ { 0, 0, 0, 0, 0 },
/* U+4934 */ { 0, 0, 0, 0, 0 },
/* U+4935 */ { 0, 0, 0, 0, 0 },
/* U+4936 */ { 0, 0, 0, 0, 0 },
/* U+4937 */ { 0, 0, 0, 0, 0 },
/* U+4938 */ { 0, 0, 0, 0, 0 },
/* U+4939 */ { 0, 0, 0, 0, 0 },
/* U+493a */ { 0, 0, 0, 0, 0 },
/* U+493b */ { 0, 0, 0, 0, 0 },
/* U+493c */ { 0, 0, 0, 0, 0 },
/* U+493d */ { 0, 0, 0, 0, 0 },
/* U+493e */ { 0, 0, 0, 0, 0 },
/* U+493f */ { 0, 0, 0, 0, 0 },
/* U+4940 */ { 0, 0, 0, 0, 0 },
/* U+4941 */ { 0, 0, 0, 0, 0 },
/* U+4942 */ { 0, 0, 0, 0, 0 },
/* U+4943 */ { 0, 0, 0, 0, 0 },
/* U+4944 */ { 0, 0, 0, 0, 0 },
/* U+4945 */ { 0, 0, 0, 0, 0 },
/* U+4946 */ { 0, 0, 0, 0, 0 },
/* U+4947 */ { 0, 0, 0, 0, 0 },
/* U+4948 */ { 0, 0, 0, 0, 0 },
/* U+4949 */ { 0, 0, 0, 0, 0 },
/* U+494a */ { 0, 0, 0, 0, 0 },
/* U+494b */ { 0, 0, 0, 0, 0 },
/* U+494c */ { 0, 0, 0, 0, 0 },
/* U+494d */ { 0, 0, 0, 0, 0 },
/* U+494e */ { 0, 0, 0, 0, 0 },
/* U+494f */ { 0, 0, 0, 0, 0 },
/* U+4950 */ { 0, 0, 0, 0, 0 },
/* U+4951 */ { 0, 0, 0, 0, 0 },
/* U+4952 */ { 0, 0, 0, 0, 0 },
/* U+4953 */ { 0, 0, 0, 0, 0 },
/* U+4954 */ { 0, 0, 0, 0, 0 },
/* U+4955 */ { 0, 0, 0, 0, 0 },
/* U+4956 */ { 0, 0, 0, 0, 0 },
/* U+4957 */ { 0, 0, 0, 0, 0 },
/* U+4958 */ { 0, 0, 0, 0, 0 },
/* U+4959 */ { 0, 0, 0, 0, 0 },
/* U+495a */ { 0, 0, 0, 0, 0 },
/* U+495b */ { 0, 0, 0, 0, 0 },
/* U+495c */ { 0, 0, 0, 0, 0 },
/* U+495d */ { 0, 0, 0, 0, 0 },
/* U+495e */ { 0, 0, 0, 0, 0 },
/* U+495f */ { 0, 0, 0, 0, 0 },
/* U+4960 */ { 0, 0, 0, 0, 0 },
/* U+4961 */ { 0, 0, 0, 0, 0 },
/* U+4962 */ { 0, 0, 0, 0, 0 },
/* U+4963 */ { 0, 0, 0, 0, 0 },
/* U+4964 */ { 0, 0, 0, 0, 0 },
/* U+4965 */ { 0, 0, 0, 0, 0 },
/* U+4966 */ { 0, 0, 0, 0, 0 },
/* U+4967 */ { 0, 0, 0, 0, 0 },
/* U+4968 */ { 0, 0, 0, 0, 0 },
/* U+4969 */ { 0, 0, 0, 0, 0 },
/* U+496a */ { 0, 0, 0, 0, 0 },
/* U+496b */ { 0, 0, 0, 0, 0 },
/* U+496c */ { 0, 0, 0, 0, 0 },
/* U+496d */ { 0, 0, 0, 0, 0 },
/* U+496e */ { 0, 0, 0, 0, 0 },
/* U+496f */ { 0, 0, 0, 0, 0 },
/* U+4970 */ { 0, 0, 0, 0, 0 },
/* U+4971 */ { 0, 0, 0, 0, 0 },
/* U+4972 */ { 0, 0, 0, 0, 0 },
/* U+4973 */ { 0, 0, 0, 0, 0 },
/* U+4974 */ { 0, 0, 0, 0, 0 },
/* U+4975 */ { 0, 0, 0, 0, 0 },
/* U+4976 */ { 0, 0, 0, 0, 0 },
/* U+4977 */ { 0, 0, 0, 0, 0 },
/* U+4978 */ { 0, 0, 0, 0, 0 },
/* U+4979 */ { 0, 0, 0, 0, 0 },
/* U+497a */ { 0, 0, 0, 0, 0 },
/* U+497b */ { 0, 0, 0, 0, 0 },
/* U+497c */ { 0, 0, 0, 0, 0 },
/* U+497d */ { 0, 0, 0, 0, 0 },
/* U+497e */ { 0, 0, 0, 0, 0 },
/* U+497f */ { 0, 0, 0, 0, 0 },
/* U+4980 */ { 0, 0, 0, 0, 0 },
/* U+4981 */ { 0, 0, 0, 0, 0 },
/* U+4982 */ { 0, 0, 0, 0, 0 },
/* U+4983 */ { 0, 0, 0, 0, 0 },
/* U+4984 */ { 0, 0, 0, 0, 0 },
/* U+4985 */ { 0, 0, 0, 0, 0 },
/* U+4986 */ { 0, 0, 0, 0, 0 },
/* U+4987 */ { 0, 0, 0, 0, 0 },
/* U+4988 */ { 0, 0, 0, 0, 0 },
/* U+4989 */ { 0, 0, 0, 0, 0 },
/* U+498a */ { 0, 0, 0, 0, 0 },
/* U+498b */ { 0, 0, 0, 0, 0 },
/* U+498c */ { 0, 0, 0, 0, 0 },
/* U+498d */ { 0, 0, 0, 0, 0 },
/* U+498e */ { 0, 0, 0, 0, 0 },
/* U+498f */ { 0, 0, 0, 0, 0 },
/* U+4990 */ { 0, 0, 0, 0, 0 },
/* U+4991 */ { 0, 0, 0, 0, 0 },
/* U+4992 */ { 0, 0, 0, 0, 0 },
/* U+4993 */ { 0, 0, 0, 0, 0 },
/* U+4994 */ { 0, 0, 0, 0, 0 },
/* U+4995 */ { 0, 0, 0, 0, 0 },
/* U+4996 */ { 0, 0, 0, 0, 0 },
/* U+4997 */ { 0, 0, 0, 0, 0 },
/* U+4998 */ { 0, 0, 0, 0, 0 },
/* U+4999 */ { 0, 0, 0, 0, 0 },
/* U+499a */ { 0, 0, 0, 0, 0 },
/* U+499b */ { 0, 0, 0, 0, 0 },
/* U+499c */ { 0, 0, 0, 0, 0 },
/* U+499d */ { 0, 0, 0, 0, 0 },
/* U+499e */ { 0, 0, 0, 0, 0 },
/* U+499f */ { 0, 0, 0, 0, 0 },
/* U+49a0 */ { 0, 0, 0, 0, 0 },
/* U+49a1 */ { 0, 0, 0, 0, 0 },
/* U+49a2 */ { 0, 0, 0, 0, 0 },
/* U+49a3 */ { 0, 0, 0, 0, 0 },
/* U+49a4 */ { 0, 0, 0, 0, 0 },
/* U+49a5 */ { 0, 0, 0, 0, 0 },
/* U+49a6 */ { 0, 0, 0, 0, 0 },
/* U+49a7 */ { 0, 0, 0, 0, 0 },
/* U+49a8 */ { 0, 0, 0, 0, 0 },
/* U+49a9 */ { 0, 0, 0, 0, 0 },
/* U+49aa */ { 0, 0, 0, 0, 0 },
/* U+49ab */ { 0, 0, 0, 0, 0 },
/* U+49ac */ { 0, 0, 0, 0, 0 },
/* U+49ad */ { 0, 0, 0, 0, 0 },
/* U+49ae */ { 0, 0, 0, 0, 0 },
/* U+49af */ { 0, 0, 0, 0, 0 },
/* U+49b0 */ { 0, 0, 0, 0, 0 },
/* U+49b1 */ { 0, 0, 0, 0, 0 },
/* U+49b2 */ { 0, 0, 0, 0, 0 },
/* U+49b3 */ { 0, 0, 0, 0, 0 },
/* U+49b4 */ { 0, 0, 0, 0, 0 },
/* U+49b5 */ { 0, 0, 0, 0, 0 },
/* U+49b6 */ { 0, 0, 0, 0, 0 },
/* U+49b7 */ { 0, 0, 0, 0, 0 },
/* U+49b8 */ { 0, 0, 0, 0, 0 },
/* U+49b9 */ { 0, 0, 0, 0, 0 },
/* U+49ba */ { 0, 0, 0, 0, 0 },
/* U+49bb */ { 0, 0, 0, 0, 0 },
/* U+49bc */ { 0, 0, 0, 0, 0 },
/* U+49bd */ { 0, 0, 0, 0, 0 },
/* U+49be */ { 0, 0, 0, 0, 0 },
/* U+49bf */ { 0, 0, 0, 0, 0 },
/* U+49c0 */ { 0, 0, 0, 0, 0 },
/* U+49c1 */ { 0, 0, 0, 0, 0 },
/* U+49c2 */ { 0, 0, 0, 0, 0 },
/* U+49c3 */ { 0, 0, 0, 0, 0 },
/* U+49c4 */ { 0, 0, 0, 0, 0 },
/* U+49c5 */ { 0, 0, 0, 0, 0 },
/* U+49c6 */ { 0, 0, 0, 0, 0 },
/* U+49c7 */ { 0, 0, 0, 0, 0 },
/* U+49c8 */ { 0, 0, 0, 0, 0 },
/* U+49c9 */ { 0, 0, 0, 0, 0 },
/* U+49ca */ { 0, 0, 0, 0, 0 },
/* U+49cb */ { 0, 0, 0, 0, 0 },
/* U+49cc */ { 0, 0, 0, 0, 0 },
/* U+49cd */ { 0, 0, 0, 0, 0 },
/* U+49ce */ { 0, 0, 0, 0, 0 },
/* U+49cf */ { 0, 0, 0, 0, 0 },
/* U+49d0 */ { 0, 0, 0, 0, 0 },
/* U+49d1 */ { 0, 0, 0, 0, 0 },
/* U+49d2 */ { 0, 0, 0, 0, 0 },
/* U+49d3 */ { 0, 0, 0, 0, 0 },
/* U+49d4 */ { 0, 0, 0, 0, 0 },
/* U+49d5 */ { 0, 0, 0, 0, 0 },
/* U+49d6 */ { 0, 0, 0, 0, 0 },
/* U+49d7 */ { 0, 0, 0, 0, 0 },
/* U+49d8 */ { 0, 0, 0, 0, 0 },
/* U+49d9 */ { 0, 0, 0, 0, 0 },
/* U+49da */ { 0, 0, 0, 0, 0 },
/* U+49db */ { 0, 0, 0, 0, 0 },
/* U+49dc */ { 0, 0, 0, 0, 0 },
/* U+49dd */ { 0, 0, 0, 0, 0 },
/* U+49de */ { 0, 0, 0, 0, 0 },
/* U+49df */ { 0, 0, 0, 0, 0 },
/* U+49e0 */ { 0, 0, 0, 0, 0 },
/* U+49e1 */ { 0, 0, 0, 0, 0 },
/* U+49e2 */ { 0, 0, 0, 0, 0 },
/* U+49e3 */ { 0, 0, 0, 0, 0 },
/* U+49e4 */ { 0, 0, 0, 0, 0 },
/* U+49e5 */ { 0, 0, 0, 0, 0 },
/* U+49e6 */ { 0, 0, 0, 0, 0 },
/* U+49e7 */ { 0, 0, 0, 0, 0 },
/* U+49e8 */ { 0, 0, 0, 0, 0 },
/* U+49e9 */ { 0, 0, 0, 0, 0 },
/* U+49ea */ { 0, 0, 0, 0, 0 },
/* U+49eb */ { 0, 0, 0, 0, 0 },
/* U+49ec */ { 0, 0, 0, 0, 0 },
/* U+49ed */ { 0, 0, 0, 0, 0 },
/* U+49ee */ { 0, 0, 0, 0, 0 },
/* U+49ef */ { 0, 0, 0, 0, 0 },
/* U+49f0 */ { 0, 0, 0, 0, 0 },
/* U+49f1 */ { 0, 0, 0, 0, 0 },
/* U+49f2 */ { 0, 0, 0, 0, 0 },
/* U+49f3 */ { 0, 0, 0, 0, 0 },
/* U+49f4 */ { 0, 0, 0, 0, 0 },
/* U+49f5 */ { 0, 0, 0, 0, 0 },
/* U+49f6 */ { 0, 0, 0, 0, 0 },
/* U+49f7 */ { 0, 0, 0, 0, 0 },
/* U+49f8 */ { 0, 0, 0, 0, 0 },
/* U+49f9 */ { 0, 0, 0, 0, 0 },
/* U+49fa */ { 0, 0, 0, 0, 0 },
/* U+49fb */ { 0, 0, 0, 0, 0 },
/* U+49fc */ { 0, 0, 0, 0, 0 },
/* U+49fd */ { 0, 0, 0, 0, 0 },
/* U+49fe */ { 0, 0, 0, 0, 0 },
/* U+49ff */ { 0, 0, 0, 0, 0 },
/* U+4a00 */ { 0, 0, 0, 0, 0 },
/* U+4a01 */ { 0, 0, 0, 0, 0 },
/* U+4a02 */ { 0, 0, 0, 0, 0 },
/* U+4a03 */ { 0, 0, 0, 0, 0 },
/* U+4a04 */ { 0, 0, 0, 0, 0 },
/* U+4a05 */ { 0, 0, 0, 0, 0 },
/* U+4a06 */ { 0, 0, 0, 0, 0 },
/* U+4a07 */ { 0, 0, 0, 0, 0 },
/* U+4a08 */ { 0, 0, 0, 0, 0 },
/* U+4a09 */ { 0, 0, 0, 0, 0 },
/* U+4a0a */ { 0, 0, 0, 0, 0 },
/* U+4a0b */ { 0, 0, 0, 0, 0 },
/* U+4a0c */ { 0, 0, 0, 0, 0 },
/* U+4a0d */ { 0, 0, 0, 0, 0 },
/* U+4a0e */ { 0, 0, 0, 0, 0 },
/* U+4a0f */ { 0, 0, 0, 0, 0 },
/* U+4a10 */ { 0, 0, 0, 0, 0 },
/* U+4a11 */ { 0, 0, 0, 0, 0 },
/* U+4a12 */ { 0, 0, 0, 0, 0 },
/* U+4a13 */ { 0, 0, 0, 0, 0 },
/* U+4a14 */ { 0, 0, 0, 0, 0 },
/* U+4a15 */ { 0, 0, 0, 0, 0 },
/* U+4a16 */ { 0, 0, 0, 0, 0 },
/* U+4a17 */ { 0, 0, 0, 0, 0 },
/* U+4a18 */ { 0, 0, 0, 0, 0 },
/* U+4a19 */ { 0, 0, 0, 0, 0 },
/* U+4a1a */ { 0, 0, 0, 0, 0 },
/* U+4a1b */ { 0, 0, 0, 0, 0 },
/* U+4a1c */ { 0, 0, 0, 0, 0 },
/* U+4a1d */ { 0, 0, 0, 0, 0 },
/* U+4a1e */ { 0, 0, 0, 0, 0 },
/* U+4a1f */ { 0, 0, 0, 0, 0 },
/* U+4a20 */ { 0, 0, 0, 0, 0 },
/* U+4a21 */ { 0, 0, 0, 0, 0 },
/* U+4a22 */ { 0, 0, 0, 0, 0 },
/* U+4a23 */ { 0, 0, 0, 0, 0 },
/* U+4a24 */ { 0, 0, 0, 0, 0 },
/* U+4a25 */ { 0, 0, 0, 0, 0 },
/* U+4a26 */ { 0, 0, 0, 0, 0 },
/* U+4a27 */ { 0, 0, 0, 0, 0 },
/* U+4a28 */ { 0, 0, 0, 0, 0 },
/* U+4a29 */ { 0, 0, 0, 0, 0 },
/* U+4a2a */ { 0, 0, 0, 0, 0 },
/* U+4a2b */ { 0, 0, 0, 0, 0 },
/* U+4a2c */ { 0, 0, 0, 0, 0 },
/* U+4a2d */ { 0, 0, 0, 0, 0 },
/* U+4a2e */ { 0, 0, 0, 0, 0 },
/* U+4a2f */ { 0, 0, 0, 0, 0 },
/* U+4a30 */ { 0, 0, 0, 0, 0 },
/* U+4a31 */ { 0, 0, 0, 0, 0 },
/* U+4a32 */ { 0, 0, 0, 0, 0 },
/* U+4a33 */ { 0, 0, 0, 0, 0 },
/* U+4a34 */ { 0, 0, 0, 0, 0 },
/* U+4a35 */ { 0, 0, 0, 0, 0 },
/* U+4a36 */ { 0, 0, 0, 0, 0 },
/* U+4a37 */ { 0, 0, 0, 0, 0 },
/* U+4a38 */ { 0, 0, 0, 0, 0 },
/* U+4a39 */ { 0, 0, 0, 0, 0 },
/* U+4a3a */ { 0, 0, 0, 0, 0 },
/* U+4a3b */ { 0, 0, 0, 0, 0 },
/* U+4a3c */ { 0, 0, 0, 0, 0 },
/* U+4a3d */ { 0, 0, 0, 0, 0 },
/* U+4a3e */ { 0, 0, 0, 0, 0 },
/* U+4a3f */ { 0, 0, 0, 0, 0 },
/* U+4a40 */ { 0, 0, 0, 0, 0 },
/* U+4a41 */ { 0, 0, 0, 0, 0 },
/* U+4a42 */ { 0, 0, 0, 0, 0 },
/* U+4a43 */ { 0, 0, 0, 0, 0 },
/* U+4a44 */ { 0, 0, 0, 0, 0 },
/* U+4a45 */ { 0, 0, 0, 0, 0 },
/* U+4a46 */ { 0, 0, 0, 0, 0 },
/* U+4a47 */ { 0, 0, 0, 0, 0 },
/* U+4a48 */ { 0, 0, 0, 0, 0 },
/* U+4a49 */ { 0, 0, 0, 0, 0 },
/* U+4a4a */ { 0, 0, 0, 0, 0 },
/* U+4a4b */ { 0, 0, 0, 0, 0 },
/* U+4a4c */ { 0, 0, 0, 0, 0 },
/* U+4a4d */ { 0, 0, 0, 0, 0 },
/* U+4a4e */ { 0, 0, 0, 0, 0 },
/* U+4a4f */ { 0, 0, 0, 0, 0 },
/* U+4a50 */ { 0, 0, 0, 0, 0 },
/* U+4a51 */ { 0, 0, 0, 0, 0 },
/* U+4a52 */ { 0, 0, 0, 0, 0 },
/* U+4a53 */ { 0, 0, 0, 0, 0 },
/* U+4a54 */ { 0, 0, 0, 0, 0 },
/* U+4a55 */ { 0, 0, 0, 0, 0 },
/* U+4a56 */ { 0, 0, 0, 0, 0 },
/* U+4a57 */ { 0, 0, 0, 0, 0 },
/* U+4a58 */ { 0, 0, 0, 0, 0 },
/* U+4a59 */ { 0, 0, 0, 0, 0 },
/* U+4a5a */ { 0, 0, 0, 0, 0 },
/* U+4a5b */ { 0, 0, 0, 0, 0 },
/* U+4a5c */ { 0, 0, 0, 0, 0 },
/* U+4a5d */ { 0, 0, 0, 0, 0 },
/* U+4a5e */ { 0, 0, 0, 0, 0 },
/* U+4a5f */ { 0, 0, 0, 0, 0 },
/* U+4a60 */ { 0, 0, 0, 0, 0 },
/* U+4a61 */ { 0, 0, 0, 0, 0 },
/* U+4a62 */ { 0, 0, 0, 0, 0 },
/* U+4a63 */ { 0, 0, 0, 0, 0 },
/* U+4a64 */ { 0, 0, 0, 0, 0 },
/* U+4a65 */ { 0, 0, 0, 0, 0 },
/* U+4a66 */ { 0, 0, 0, 0, 0 },
/* U+4a67 */ { 0, 0, 0, 0, 0 },
/* U+4a68 */ { 0, 0, 0, 0, 0 },
/* U+4a69 */ { 0, 0, 0, 0, 0 },
/* U+4a6a */ { 0, 0, 0, 0, 0 },
/* U+4a6b */ { 0, 0, 0, 0, 0 },
/* U+4a6c */ { 0, 0, 0, 0, 0 },
/* U+4a6d */ { 0, 0, 0, 0, 0 },
/* U+4a6e */ { 0, 0, 0, 0, 0 },
/* U+4a6f */ { 0, 0, 0, 0, 0 },
/* U+4a70 */ { 0, 0, 0, 0, 0 },
/* U+4a71 */ { 0, 0, 0, 0, 0 },
/* U+4a72 */ { 0, 0, 0, 0, 0 },
/* U+4a73 */ { 0, 0, 0, 0, 0 },
/* U+4a74 */ { 0, 0, 0, 0, 0 },
/* U+4a75 */ { 0, 0, 0, 0, 0 },
/* U+4a76 */ { 0, 0, 0, 0, 0 },
/* U+4a77 */ { 0, 0, 0, 0, 0 },
/* U+4a78 */ { 0, 0, 0, 0, 0 },
/* U+4a79 */ { 0, 0, 0, 0, 0 },
/* U+4a7a */ { 0, 0, 0, 0, 0 },
/* U+4a7b */ { 0, 0, 0, 0, 0 },
/* U+4a7c */ { 0, 0, 0, 0, 0 },
/* U+4a7d */ { 0, 0, 0, 0, 0 },
/* U+4a7e */ { 0, 0, 0, 0, 0 },
/* U+4a7f */ { 0, 0, 0, 0, 0 },
/* U+4a80 */ { 0, 0, 0, 0, 0 },
/* U+4a81 */ { 0, 0, 0, 0, 0 },
/* U+4a82 */ { 0, 0, 0, 0, 0 },
/* U+4a83 */ { 0, 0, 0, 0, 0 },
/* U+4a84 */ { 0, 0, 0, 0, 0 },
/* U+4a85 */ { 0, 0, 0, 0, 0 },
/* U+4a86 */ { 0, 0, 0, 0, 0 },
/* U+4a87 */ { 0, 0, 0, 0, 0 },
/* U+4a88 */ { 0, 0, 0, 0, 0 },
/* U+4a89 */ { 0, 0, 0, 0, 0 },
/* U+4a8a */ { 0, 0, 0, 0, 0 },
/* U+4a8b */ { 0, 0, 0, 0, 0 },
/* U+4a8c */ { 0, 0, 0, 0, 0 },
/* U+4a8d */ { 0, 0, 0, 0, 0 },
/* U+4a8e */ { 0, 0, 0, 0, 0 },
/* U+4a8f */ { 0, 0, 0, 0, 0 },
/* U+4a90 */ { 0, 0, 0, 0, 0 },
/* U+4a91 */ { 0, 0, 0, 0, 0 },
/* U+4a92 */ { 0, 0, 0, 0, 0 },
/* U+4a93 */ { 0, 0, 0, 0, 0 },
/* U+4a94 */ { 0, 0, 0, 0, 0 },
/* U+4a95 */ { 0, 0, 0, 0, 0 },
/* U+4a96 */ { 0, 0, 0, 0, 0 },
/* U+4a97 */ { 0, 0, 0, 0, 0 },
/* U+4a98 */ { 0, 0, 0, 0, 0 },
/* U+4a99 */ { 0, 0, 0, 0, 0 },
/* U+4a9a */ { 0, 0, 0, 0, 0 },
/* U+4a9b */ { 0, 0, 0, 0, 0 },
/* U+4a9c */ { 0, 0, 0, 0, 0 },
/* U+4a9d */ { 0, 0, 0, 0, 0 },
/* U+4a9e */ { 0, 0, 0, 0, 0 },
/* U+4a9f */ { 0, 0, 0, 0, 0 },
/* U+4aa0 */ { 0, 0, 0, 0, 0 },
/* U+4aa1 */ { 0, 0, 0, 0, 0 },
/* U+4aa2 */ { 0, 0, 0, 0, 0 },
/* U+4aa3 */ { 0, 0, 0, 0, 0 },
/* U+4aa4 */ { 0, 0, 0, 0, 0 },
/* U+4aa5 */ { 0, 0, 0, 0, 0 },
/* U+4aa6 */ { 0, 0, 0, 0, 0 },
/* U+4aa7 */ { 0, 0, 0, 0, 0 },
/* U+4aa8 */ { 0, 0, 0, 0, 0 },
/* U+4aa9 */ { 0, 0, 0, 0, 0 },
/* U+4aaa */ { 0, 0, 0, 0, 0 },
/* U+4aab */ { 0, 0, 0, 0, 0 },
/* U+4aac */ { 0, 0, 0, 0, 0 },
/* U+4aad */ { 0, 0, 0, 0, 0 },
/* U+4aae */ { 0, 0, 0, 0, 0 },
/* U+4aaf */ { 0, 0, 0, 0, 0 },
/* U+4ab0 */ { 0, 0, 0, 0, 0 },
/* U+4ab1 */ { 0, 0, 0, 0, 0 },
/* U+4ab2 */ { 0, 0, 0, 0, 0 },
/* U+4ab3 */ { 0, 0, 0, 0, 0 },
/* U+4ab4 */ { 0, 0, 0, 0, 0 },
/* U+4ab5 */ { 0, 0, 0, 0, 0 },
/* U+4ab6 */ { 0, 0, 0, 0, 0 },
/* U+4ab7 */ { 0, 0, 0, 0, 0 },
/* U+4ab8 */ { 0, 0, 0, 0, 0 },
/* U+4ab9 */ { 0, 0, 0, 0, 0 },
/* U+4aba */ { 0, 0, 0, 0, 0 },
/* U+4abb */ { 0, 0, 0, 0, 0 },
/* U+4abc */ { 0, 0, 0, 0, 0 },
/* U+4abd */ { 0, 0, 0, 0, 0 },
/* U+4abe */ { 0, 0, 0, 0, 0 },
/* U+4abf */ { 0, 0, 0, 0, 0 },
/* U+4ac0 */ { 0, 0, 0, 0, 0 },
/* U+4ac1 */ { 0, 0, 0, 0, 0 },
/* U+4ac2 */ { 0, 0, 0, 0, 0 },
/* U+4ac3 */ { 0, 0, 0, 0, 0 },
/* U+4ac4 */ { 0, 0, 0, 0, 0 },
/* U+4ac5 */ { 0, 0, 0, 0, 0 },
/* U+4ac6 */ { 0, 0, 0, 0, 0 },
/* U+4ac7 */ { 0, 0, 0, 0, 0 },
/* U+4ac8 */ { 0, 0, 0, 0, 0 },
/* U+4ac9 */ { 0, 0, 0, 0, 0 },
/* U+4aca */ { 0, 0, 0, 0, 0 },
/* U+4acb */ { 0, 0, 0, 0, 0 },
/* U+4acc */ { 0, 0, 0, 0, 0 },
/* U+4acd */ { 0, 0, 0, 0, 0 },
/* U+4ace */ { 0, 0, 0, 0, 0 },
/* U+4acf */ { 0, 0, 0, 0, 0 },
/* U+4ad0 */ { 0, 0, 0, 0, 0 },
/* U+4ad1 */ { 0, 0, 0, 0, 0 },
/* U+4ad2 */ { 0, 0, 0, 0, 0 },
/* U+4ad3 */ { 0, 0, 0, 0, 0 },
/* U+4ad4 */ { 0, 0, 0, 0, 0 },
/* U+4ad5 */ { 0, 0, 0, 0, 0 },
/* U+4ad6 */ { 0, 0, 0, 0, 0 },
/* U+4ad7 */ { 0, 0, 0, 0, 0 },
/* U+4ad8 */ { 0, 0, 0, 0, 0 },
/* U+4ad9 */ { 0, 0, 0, 0, 0 },
/* U+4ada */ { 0, 0, 0, 0, 0 },
/* U+4adb */ { 0, 0, 0, 0, 0 },
/* U+4adc */ { 0, 0, 0, 0, 0 },
/* U+4add */ { 0, 0, 0, 0, 0 },
/* U+4ade */ { 0, 0, 0, 0, 0 },
/* U+4adf */ { 0, 0, 0, 0, 0 },
/* U+4ae0 */ { 0, 0, 0, 0, 0 },
/* U+4ae1 */ { 0, 0, 0, 0, 0 },
/* U+4ae2 */ { 0, 0, 0, 0, 0 },
/* U+4ae3 */ { 0, 0, 0, 0, 0 },
/* U+4ae4 */ { 0, 0, 0, 0, 0 },
/* U+4ae5 */ { 0, 0, 0, 0, 0 },
/* U+4ae6 */ { 0, 0, 0, 0, 0 },
/* U+4ae7 */ { 0, 0, 0, 0, 0 },
/* U+4ae8 */ { 0, 0, 0, 0, 0 },
/* U+4ae9 */ { 0, 0, 0, 0, 0 },
/* U+4aea */ { 0, 0, 0, 0, 0 },
/* U+4aeb */ { 0, 0, 0, 0, 0 },
/* U+4aec */ { 0, 0, 0, 0, 0 },
/* U+4aed */ { 0, 0, 0, 0, 0 },
/* U+4aee */ { 0, 0, 0, 0, 0 },
/* U+4aef */ { 0, 0, 0, 0, 0 },
/* U+4af0 */ { 0, 0, 0, 0, 0 },
/* U+4af1 */ { 0, 0, 0, 0, 0 },
/* U+4af2 */ { 0, 0, 0, 0, 0 },
/* U+4af3 */ { 0, 0, 0, 0, 0 },
/* U+4af4 */ { 0, 0, 0, 0, 0 },
/* U+4af5 */ { 0, 0, 0, 0, 0 },
/* U+4af6 */ { 0, 0, 0, 0, 0 },
/* U+4af7 */ { 0, 0, 0, 0, 0 },
/* U+4af8 */ { 0, 0, 0, 0, 0 },
/* U+4af9 */ { 0, 0, 0, 0, 0 },
/* U+4afa */ { 0, 0, 0, 0, 0 },
/* U+4afb */ { 0, 0, 0, 0, 0 },
/* U+4afc */ { 0, 0, 0, 0, 0 },
/* U+4afd */ { 0, 0, 0, 0, 0 },
/* U+4afe */ { 0, 0, 0, 0, 0 },
/* U+4aff */ { 0, 0, 0, 0, 0 },
/* U+4b00 */ { 0, 0, 0, 0, 0 },
/* U+4b01 */ { 0, 0, 0, 0, 0 },
/* U+4b02 */ { 0, 0, 0, 0, 0 },
/* U+4b03 */ { 0, 0, 0, 0, 0 },
/* U+4b04 */ { 0, 0, 0, 0, 0 },
/* U+4b05 */ { 0, 0, 0, 0, 0 },
/* U+4b06 */ { 0, 0, 0, 0, 0 },
/* U+4b07 */ { 0, 0, 0, 0, 0 },
/* U+4b08 */ { 0, 0, 0, 0, 0 },
/* U+4b09 */ { 0, 0, 0, 0, 0 },
/* U+4b0a */ { 0, 0, 0, 0, 0 },
/* U+4b0b */ { 0, 0, 0, 0, 0 },
/* U+4b0c */ { 0, 0, 0, 0, 0 },
/* U+4b0d */ { 0, 0, 0, 0, 0 },
/* U+4b0e */ { 0, 0, 0, 0, 0 },
/* U+4b0f */ { 0, 0, 0, 0, 0 },
/* U+4b10 */ { 0, 0, 0, 0, 0 },
/* U+4b11 */ { 0, 0, 0, 0, 0 },
/* U+4b12 */ { 0, 0, 0, 0, 0 },
/* U+4b13 */ { 0, 0, 0, 0, 0 },
/* U+4b14 */ { 0, 0, 0, 0, 0 },
/* U+4b15 */ { 0, 0, 0, 0, 0 },
/* U+4b16 */ { 0, 0, 0, 0, 0 },
/* U+4b17 */ { 0, 0, 0, 0, 0 },
/* U+4b18 */ { 0, 0, 0, 0, 0 },
/* U+4b19 */ { 0, 0, 0, 0, 0 },
/* U+4b1a */ { 0, 0, 0, 0, 0 },
/* U+4b1b */ { 0, 0, 0, 0, 0 },
/* U+4b1c */ { 0, 0, 0, 0, 0 },
/* U+4b1d */ { 0, 0, 0, 0, 0 },
/* U+4b1e */ { 0, 0, 0, 0, 0 },
/* U+4b1f */ { 0, 0, 0, 0, 0 },
/* U+4b20 */ { 0, 0, 0, 0, 0 },
/* U+4b21 */ { 0, 0, 0, 0, 0 },
/* U+4b22 */ { 0, 0, 0, 0, 0 },
/* U+4b23 */ { 0, 0, 0, 0, 0 },
/* U+4b24 */ { 0, 0, 0, 0, 0 },
/* U+4b25 */ { 0, 0, 0, 0, 0 },
/* U+4b26 */ { 0, 0, 0, 0, 0 },
/* U+4b27 */ { 0, 0, 0, 0, 0 },
/* U+4b28 */ { 0, 0, 0, 0, 0 },
/* U+4b29 */ { 0, 0, 0, 0, 0 },
/* U+4b2a */ { 0, 0, 0, 0, 0 },
/* U+4b2b */ { 0, 0, 0, 0, 0 },
/* U+4b2c */ { 0, 0, 0, 0, 0 },
/* U+4b2d */ { 0, 0, 0, 0, 0 },
/* U+4b2e */ { 0, 0, 0, 0, 0 },
/* U+4b2f */ { 0, 0, 0, 0, 0 },
/* U+4b30 */ { 0, 0, 0, 0, 0 },
/* U+4b31 */ { 0, 0, 0, 0, 0 },
/* U+4b32 */ { 0, 0, 0, 0, 0 },
/* U+4b33 */ { 0, 0, 0, 0, 0 },
/* U+4b34 */ { 0, 0, 0, 0, 0 },
/* U+4b35 */ { 0, 0, 0, 0, 0 },
/* U+4b36 */ { 0, 0, 0, 0, 0 },
/* U+4b37 */ { 0, 0, 0, 0, 0 },
/* U+4b38 */ { 0, 0, 0, 0, 0 },
/* U+4b39 */ { 0, 0, 0, 0, 0 },
/* U+4b3a */ { 0, 0, 0, 0, 0 },
/* U+4b3b */ { 0, 0, 0, 0, 0 },
/* U+4b3c */ { 0, 0, 0, 0, 0 },
/* U+4b3d */ { 0, 0, 0, 0, 0 },
/* U+4b3e */ { 0, 0, 0, 0, 0 },
/* U+4b3f */ { 0, 0, 0, 0, 0 },
/* U+4b40 */ { 0, 0, 0, 0, 0 },
/* U+4b41 */ { 0, 0, 0, 0, 0 },
/* U+4b42 */ { 0, 0, 0, 0, 0 },
/* U+4b43 */ { 0, 0, 0, 0, 0 },
/* U+4b44 */ { 0, 0, 0, 0, 0 },
/* U+4b45 */ { 0, 0, 0, 0, 0 },
/* U+4b46 */ { 0, 0, 0, 0, 0 },
/* U+4b47 */ { 0, 0, 0, 0, 0 },
/* U+4b48 */ { 0, 0, 0, 0, 0 },
/* U+4b49 */ { 0, 0, 0, 0, 0 },
/* U+4b4a */ { 0, 0, 0, 0, 0 },
/* U+4b4b */ { 0, 0, 0, 0, 0 },
/* U+4b4c */ { 0, 0, 0, 0, 0 },
/* U+4b4d */ { 0, 0, 0, 0, 0 },
/* U+4b4e */ { 0, 0, 0, 0, 0 },
/* U+4b4f */ { 0, 0, 0, 0, 0 },
/* U+4b50 */ { 0, 0, 0, 0, 0 },
/* U+4b51 */ { 0, 0, 0, 0, 0 },
/* U+4b52 */ { 0, 0, 0, 0, 0 },
/* U+4b53 */ { 0, 0, 0, 0, 0 },
/* U+4b54 */ { 0, 0, 0, 0, 0 },
/* U+4b55 */ { 0, 0, 0, 0, 0 },
/* U+4b56 */ { 0, 0, 0, 0, 0 },
/* U+4b57 */ { 0, 0, 0, 0, 0 },
/* U+4b58 */ { 0, 0, 0, 0, 0 },
/* U+4b59 */ { 0, 0, 0, 0, 0 },
/* U+4b5a */ { 0, 0, 0, 0, 0 },
/* U+4b5b */ { 0, 0, 0, 0, 0 },
/* U+4b5c */ { 0, 0, 0, 0, 0 },
/* U+4b5d */ { 0, 0, 0, 0, 0 },
/* U+4b5e */ { 0, 0, 0, 0, 0 },
/* U+4b5f */ { 0, 0, 0, 0, 0 },
/* U+4b60 */ { 0, 0, 0, 0, 0 },
/* U+4b61 */ { 0, 0, 0, 0, 0 },
/* U+4b62 */ { 0, 0, 0, 0, 0 },
/* U+4b63 */ { 0, 0, 0, 0, 0 },
/* U+4b64 */ { 0, 0, 0, 0, 0 },
/* U+4b65 */ { 0, 0, 0, 0, 0 },
/* U+4b66 */ { 0, 0, 0, 0, 0 },
/* U+4b67 */ { 0, 0, 0, 0, 0 },
/* U+4b68 */ { 0, 0, 0, 0, 0 },
/* U+4b69 */ { 0, 0, 0, 0, 0 },
/* U+4b6a */ { 0, 0, 0, 0, 0 },
/* U+4b6b */ { 0, 0, 0, 0, 0 },
/* U+4b6c */ { 0, 0, 0, 0, 0 },
/* U+4b6d */ { 0, 0, 0, 0, 0 },
/* U+4b6e */ { 0, 0, 0, 0, 0 },
/* U+4b6f */ { 0, 0, 0, 0, 0 },
/* U+4b70 */ { 0, 0, 0, 0, 0 },
/* U+4b71 */ { 0, 0, 0, 0, 0 },
/* U+4b72 */ { 0, 0, 0, 0, 0 },
/* U+4b73 */ { 0, 0, 0, 0, 0 },
/* U+4b74 */ { 0, 0, 0, 0, 0 },
/* U+4b75 */ { 0, 0, 0, 0, 0 },
/* U+4b76 */ { 0, 0, 0, 0, 0 },
/* U+4b77 */ { 0, 0, 0, 0, 0 },
/* U+4b78 */ { 0, 0, 0, 0, 0 },
/* U+4b79 */ { 0, 0, 0, 0, 0 },
/* U+4b7a */ { 0, 0, 0, 0, 0 },
/* U+4b7b */ { 0, 0, 0, 0, 0 },
/* U+4b7c */ { 0, 0, 0, 0, 0 },
/* U+4b7d */ { 0, 0, 0, 0, 0 },
/* U+4b7e */ { 0, 0, 0, 0, 0 },
/* U+4b7f */ { 0, 0, 0, 0, 0 },
/* U+4b80 */ { 0, 0, 0, 0, 0 },
/* U+4b81 */ { 0, 0, 0, 0, 0 },
/* U+4b82 */ { 0, 0, 0, 0, 0 },
/* U+4b83 */ { 0, 0, 0, 0, 0 },
/* U+4b84 */ { 0, 0, 0, 0, 0 },
/* U+4b85 */ { 0, 0, 0, 0, 0 },
/* U+4b86 */ { 0, 0, 0, 0, 0 },
/* U+4b87 */ { 0, 0, 0, 0, 0 },
/* U+4b88 */ { 0, 0, 0, 0, 0 },
/* U+4b89 */ { 0, 0, 0, 0, 0 },
/* U+4b8a */ { 0, 0, 0, 0, 0 },
/* U+4b8b */ { 0, 0, 0, 0, 0 },
/* U+4b8c */ { 0, 0, 0, 0, 0 },
/* U+4b8d */ { 0, 0, 0, 0, 0 },
/* U+4b8e */ { 0, 0, 0, 0, 0 },
/* U+4b8f */ { 0, 0, 0, 0, 0 },
/* U+4b90 */ { 0, 0, 0, 0, 0 },
/* U+4b91 */ { 0, 0, 0, 0, 0 },
/* U+4b92 */ { 0, 0, 0, 0, 0 },
/* U+4b93 */ { 0, 0, 0, 0, 0 },
/* U+4b94 */ { 0, 0, 0, 0, 0 },
/* U+4b95 */ { 0, 0, 0, 0, 0 },
/* U+4b96 */ { 0, 0, 0, 0, 0 },
/* U+4b97 */ { 0, 0, 0, 0, 0 },
/* U+4b98 */ { 0, 0, 0, 0, 0 },
/* U+4b99 */ { 0, 0, 0, 0, 0 },
/* U+4b9a */ { 0, 0, 0, 0, 0 },
/* U+4b9b */ { 0, 0, 0, 0, 0 },
/* U+4b9c */ { 0, 0, 0, 0, 0 },
/* U+4b9d */ { 0, 0, 0, 0, 0 },
/* U+4b9e */ { 0, 0, 0, 0, 0 },
/* U+4b9f */ { 0, 0, 0, 0, 0 },
/* U+4ba0 */ { 0, 0, 0, 0, 0 },
/* U+4ba1 */ { 0, 0, 0, 0, 0 },
/* U+4ba2 */ { 0, 0, 0, 0, 0 },
/* U+4ba3 */ { 0, 0, 0, 0, 0 },
/* U+4ba4 */ { 0, 0, 0, 0, 0 },
/* U+4ba5 */ { 0, 0, 0, 0, 0 },
/* U+4ba6 */ { 0, 0, 0, 0, 0 },
/* U+4ba7 */ { 0, 0, 0, 0, 0 },
/* U+4ba8 */ { 0, 0, 0, 0, 0 },
/* U+4ba9 */ { 0, 0, 0, 0, 0 },
/* U+4baa */ { 0, 0, 0, 0, 0 },
/* U+4bab */ { 0, 0, 0, 0, 0 },
/* U+4bac */ { 0, 0, 0, 0, 0 },
/* U+4bad */ { 0, 0, 0, 0, 0 },
/* U+4bae */ { 0, 0, 0, 0, 0 },
/* U+4baf */ { 0, 0, 0, 0, 0 },
/* U+4bb0 */ { 0, 0, 0, 0, 0 },
/* U+4bb1 */ { 0, 0, 0, 0, 0 },
/* U+4bb2 */ { 0, 0, 0, 0, 0 },
/* U+4bb3 */ { 0, 0, 0, 0, 0 },
/* U+4bb4 */ { 0, 0, 0, 0, 0 },
/* U+4bb5 */ { 0, 0, 0, 0, 0 },
/* U+4bb6 */ { 0, 0, 0, 0, 0 },
/* U+4bb7 */ { 0, 0, 0, 0, 0 },
/* U+4bb8 */ { 0, 0, 0, 0, 0 },
/* U+4bb9 */ { 0, 0, 0, 0, 0 },
/* U+4bba */ { 0, 0, 0, 0, 0 },
/* U+4bbb */ { 0, 0, 0, 0, 0 },
/* U+4bbc */ { 0, 0, 0, 0, 0 },
/* U+4bbd */ { 0, 0, 0, 0, 0 },
/* U+4bbe */ { 0, 0, 0, 0, 0 },
/* U+4bbf */ { 0, 0, 0, 0, 0 },
/* U+4bc0 */ { 0, 0, 0, 0, 0 },
/* U+4bc1 */ { 0, 0, 0, 0, 0 },
/* U+4bc2 */ { 0, 0, 0, 0, 0 },
/* U+4bc3 */ { 0, 0, 0, 0, 0 },
/* U+4bc4 */ { 0, 0, 0, 0, 0 },
/* U+4bc5 */ { 0, 0, 0, 0, 0 },
/* U+4bc6 */ { 0, 0, 0, 0, 0 },
/* U+4bc7 */ { 0, 0, 0, 0, 0 },
/* U+4bc8 */ { 0, 0, 0, 0, 0 },
/* U+4bc9 */ { 0, 0, 0, 0, 0 },
/* U+4bca */ { 0, 0, 0, 0, 0 },
/* U+4bcb */ { 0, 0, 0, 0, 0 },
/* U+4bcc */ { 0, 0, 0, 0, 0 },
/* U+4bcd */ { 0, 0, 0, 0, 0 },
/* U+4bce */ { 0, 0, 0, 0, 0 },
/* U+4bcf */ { 0, 0, 0, 0, 0 },
/* U+4bd0 */ { 0, 0, 0, 0, 0 },
/* U+4bd1 */ { 0, 0, 0, 0, 0 },
/* U+4bd2 */ { 0, 0, 0, 0, 0 },
/* U+4bd3 */ { 0, 0, 0, 0, 0 },
/* U+4bd4 */ { 0, 0, 0, 0, 0 },
/* U+4bd5 */ { 0, 0, 0, 0, 0 },
/* U+4bd6 */ { 0, 0, 0, 0, 0 },
/* U+4bd7 */ { 0, 0, 0, 0, 0 },
/* U+4bd8 */ { 0, 0, 0, 0, 0 },
/* U+4bd9 */ { 0, 0, 0, 0, 0 },
/* U+4bda */ { 0, 0, 0, 0, 0 },
/* U+4bdb */ { 0, 0, 0, 0, 0 },
/* U+4bdc */ { 0, 0, 0, 0, 0 },
/* U+4bdd */ { 0, 0, 0, 0, 0 },
/* U+4bde */ { 0, 0, 0, 0, 0 },
/* U+4bdf */ { 0, 0, 0, 0, 0 },
/* U+4be0 */ { 0, 0, 0, 0, 0 },
/* U+4be1 */ { 0, 0, 0, 0, 0 },
/* U+4be2 */ { 0, 0, 0, 0, 0 },
/* U+4be3 */ { 0, 0, 0, 0, 0 },
/* U+4be4 */ { 0, 0, 0, 0, 0 },
/* U+4be5 */ { 0, 0, 0, 0, 0 },
/* U+4be6 */ { 0, 0, 0, 0, 0 },
/* U+4be7 */ { 0, 0, 0, 0, 0 },
/* U+4be8 */ { 0, 0, 0, 0, 0 },
/* U+4be9 */ { 0, 0, 0, 0, 0 },
/* U+4bea */ { 0, 0, 0, 0, 0 },
/* U+4beb */ { 0, 0, 0, 0, 0 },
/* U+4bec */ { 0, 0, 0, 0, 0 },
/* U+4bed */ { 0, 0, 0, 0, 0 },
/* U+4bee */ { 0, 0, 0, 0, 0 },
/* U+4bef */ { 0, 0, 0, 0, 0 },
/* U+4bf0 */ { 0, 0, 0, 0, 0 },
/* U+4bf1 */ { 0, 0, 0, 0, 0 },
/* U+4bf2 */ { 0, 0, 0, 0, 0 },
/* U+4bf3 */ { 0, 0, 0, 0, 0 },
/* U+4bf4 */ { 0, 0, 0, 0, 0 },
/* U+4bf5 */ { 0, 0, 0, 0, 0 },
/* U+4bf6 */ { 0, 0, 0, 0, 0 },
/* U+4bf7 */ { 0, 0, 0, 0, 0 },
/* U+4bf8 */ { 0, 0, 0, 0, 0 },
/* U+4bf9 */ { 0, 0, 0, 0, 0 },
/* U+4bfa */ { 0, 0, 0, 0, 0 },
/* U+4bfb */ { 0, 0, 0, 0, 0 },
/* U+4bfc */ { 0, 0, 0, 0, 0 },
/* U+4bfd */ { 0, 0, 0, 0, 0 },
/* U+4bfe */ { 0, 0, 0, 0, 0 },
/* U+4bff */ { 0, 0, 0, 0, 0 },
/* U+4c00 */ { 0, 0, 0, 0, 0 },
/* U+4c01 */ { 0, 0, 0, 0, 0 },
/* U+4c02 */ { 0, 0, 0, 0, 0 },
/* U+4c03 */ { 0, 0, 0, 0, 0 },
/* U+4c04 */ { 0, 0, 0, 0, 0 },
/* U+4c05 */ { 0, 0, 0, 0, 0 },
/* U+4c06 */ { 0, 0, 0, 0, 0 },
/* U+4c07 */ { 0, 0, 0, 0, 0 },
/* U+4c08 */ { 0, 0, 0, 0, 0 },
/* U+4c09 */ { 0, 0, 0, 0, 0 },
/* U+4c0a */ { 0, 0, 0, 0, 0 },
/* U+4c0b */ { 0, 0, 0, 0, 0 },
/* U+4c0c */ { 0, 0, 0, 0, 0 },
/* U+4c0d */ { 0, 0, 0, 0, 0 },
/* U+4c0e */ { 0, 0, 0, 0, 0 },
/* U+4c0f */ { 0, 0, 0, 0, 0 },
/* U+4c10 */ { 0, 0, 0, 0, 0 },
/* U+4c11 */ { 0, 0, 0, 0, 0 },
/* U+4c12 */ { 0, 0, 0, 0, 0 },
/* U+4c13 */ { 0, 0, 0, 0, 0 },
/* U+4c14 */ { 0, 0, 0, 0, 0 },
/* U+4c15 */ { 0, 0, 0, 0, 0 },
/* U+4c16 */ { 0, 0, 0, 0, 0 },
/* U+4c17 */ { 0, 0, 0, 0, 0 },
/* U+4c18 */ { 0, 0, 0, 0, 0 },
/* U+4c19 */ { 0, 0, 0, 0, 0 },
/* U+4c1a */ { 0, 0, 0, 0, 0 },
/* U+4c1b */ { 0, 0, 0, 0, 0 },
/* U+4c1c */ { 0, 0, 0, 0, 0 },
/* U+4c1d */ { 0, 0, 0, 0, 0 },
/* U+4c1e */ { 0, 0, 0, 0, 0 },
/* U+4c1f */ { 0, 0, 0, 0, 0 },
/* U+4c20 */ { 0, 0, 0, 0, 0 },
/* U+4c21 */ { 0, 0, 0, 0, 0 },
/* U+4c22 */ { 0, 0, 0, 0, 0 },
/* U+4c23 */ { 0, 0, 0, 0, 0 },
/* U+4c24 */ { 0, 0, 0, 0, 0 },
/* U+4c25 */ { 0, 0, 0, 0, 0 },
/* U+4c26 */ { 0, 0, 0, 0, 0 },
/* U+4c27 */ { 0, 0, 0, 0, 0 },
/* U+4c28 */ { 0, 0, 0, 0, 0 },
/* U+4c29 */ { 0, 0, 0, 0, 0 },
/* U+4c2a */ { 0, 0, 0, 0, 0 },
/* U+4c2b */ { 0, 0, 0, 0, 0 },
/* U+4c2c */ { 0, 0, 0, 0, 0 },
/* U+4c2d */ { 0, 0, 0, 0, 0 },
/* U+4c2e */ { 0, 0, 0, 0, 0 },
/* U+4c2f */ { 0, 0, 0, 0, 0 },
/* U+4c30 */ { 0, 0, 0, 0, 0 },
/* U+4c31 */ { 0, 0, 0, 0, 0 },
/* U+4c32 */ { 0, 0, 0, 0, 0 },
/* U+4c33 */ { 0, 0, 0, 0, 0 },
/* U+4c34 */ { 0, 0, 0, 0, 0 },
/* U+4c35 */ { 0, 0, 0, 0, 0 },
/* U+4c36 */ { 0, 0, 0, 0, 0 },
/* U+4c37 */ { 0, 0, 0, 0, 0 },
/* U+4c38 */ { 0, 0, 0, 0, 0 },
/* U+4c39 */ { 0, 0, 0, 0, 0 },
/* U+4c3a */ { 0, 0, 0, 0, 0 },
/* U+4c3b */ { 0, 0, 0, 0, 0 },
/* U+4c3c */ { 0, 0, 0, 0, 0 },
/* U+4c3d */ { 0, 0, 0, 0, 0 },
/* U+4c3e */ { 0, 0, 0, 0, 0 },
/* U+4c3f */ { 0, 0, 0, 0, 0 },
/* U+4c40 */ { 0, 0, 0, 0, 0 },
/* U+4c41 */ { 0, 0, 0, 0, 0 },
/* U+4c42 */ { 0, 0, 0, 0, 0 },
/* U+4c43 */ { 0, 0, 0, 0, 0 },
/* U+4c44 */ { 0, 0, 0, 0, 0 },
/* U+4c45 */ { 0, 0, 0, 0, 0 },
/* U+4c46 */ { 0, 0, 0, 0, 0 },
/* U+4c47 */ { 0, 0, 0, 0, 0 },
/* U+4c48 */ { 0, 0, 0, 0, 0 },
/* U+4c49 */ { 0, 0, 0, 0, 0 },
/* U+4c4a */ { 0, 0, 0, 0, 0 },
/* U+4c4b */ { 0, 0, 0, 0, 0 },
/* U+4c4c */ { 0, 0, 0, 0, 0 },
/* U+4c4d */ { 0, 0, 0, 0, 0 },
/* U+4c4e */ { 0, 0, 0, 0, 0 },
/* U+4c4f */ { 0, 0, 0, 0, 0 },
/* U+4c50 */ { 0, 0, 0, 0, 0 },
/* U+4c51 */ { 0, 0, 0, 0, 0 },
/* U+4c52 */ { 0, 0, 0, 0, 0 },
/* U+4c53 */ { 0, 0, 0, 0, 0 },
/* U+4c54 */ { 0, 0, 0, 0, 0 },
/* U+4c55 */ { 0, 0, 0, 0, 0 },
/* U+4c56 */ { 0, 0, 0, 0, 0 },
/* U+4c57 */ { 0, 0, 0, 0, 0 },
/* U+4c58 */ { 0, 0, 0, 0, 0 },
/* U+4c59 */ { 0, 0, 0, 0, 0 },
/* U+4c5a */ { 0, 0, 0, 0, 0 },
/* U+4c5b */ { 0, 0, 0, 0, 0 },
/* U+4c5c */ { 0, 0, 0, 0, 0 },
/* U+4c5d */ { 0, 0, 0, 0, 0 },
/* U+4c5e */ { 0, 0, 0, 0, 0 },
/* U+4c5f */ { 0, 0, 0, 0, 0 },
/* U+4c60 */ { 0, 0, 0, 0, 0 },
/* U+4c61 */ { 0, 0, 0, 0, 0 },
/* U+4c62 */ { 0, 0, 0, 0, 0 },
/* U+4c63 */ { 0, 0, 0, 0, 0 },
/* U+4c64 */ { 0, 0, 0, 0, 0 },
/* U+4c65 */ { 0, 0, 0, 0, 0 },
/* U+4c66 */ { 0, 0, 0, 0, 0 },
/* U+4c67 */ { 0, 0, 0, 0, 0 },
/* U+4c68 */ { 0, 0, 0, 0, 0 },
/* U+4c69 */ { 0, 0, 0, 0, 0 },
/* U+4c6a */ { 0, 0, 0, 0, 0 },
/* U+4c6b */ { 0, 0, 0, 0, 0 },
/* U+4c6c */ { 0, 0, 0, 0, 0 },
/* U+4c6d */ { 0, 0, 0, 0, 0 },
/* U+4c6e */ { 0, 0, 0, 0, 0 },
/* U+4c6f */ { 0, 0, 0, 0, 0 },
/* U+4c70 */ { 0, 0, 0, 0, 0 },
/* U+4c71 */ { 0, 0, 0, 0, 0 },
/* U+4c72 */ { 0, 0, 0, 0, 0 },
/* U+4c73 */ { 0, 0, 0, 0, 0 },
/* U+4c74 */ { 0, 0, 0, 0, 0 },
/* U+4c75 */ { 0, 0, 0, 0, 0 },
/* U+4c76 */ { 0, 0, 0, 0, 0 },
/* U+4c77 */ { 0, 0, 0, 0, 0 },
/* U+4c78 */ { 0, 0, 0, 0, 0 },
/* U+4c79 */ { 0, 0, 0, 0, 0 },
/* U+4c7a */ { 0, 0, 0, 0, 0 },
/* U+4c7b */ { 0, 0, 0, 0, 0 },
/* U+4c7c */ { 0, 0, 0, 0, 0 },
/* U+4c7d */ { 0, 0, 0, 0, 0 },
/* U+4c7e */ { 0, 0, 0, 0, 0 },
/* U+4c7f */ { 0, 0, 0, 0, 0 },
/* U+4c80 */ { 0, 0, 0, 0, 0 },
/* U+4c81 */ { 0, 0, 0, 0, 0 },
/* U+4c82 */ { 0, 0, 0, 0, 0 },
/* U+4c83 */ { 0, 0, 0, 0, 0 },
/* U+4c84 */ { 0, 0, 0, 0, 0 },
/* U+4c85 */ { 0, 0, 0, 0, 0 },
/* U+4c86 */ { 0, 0, 0, 0, 0 },
/* U+4c87 */ { 0, 0, 0, 0, 0 },
/* U+4c88 */ { 0, 0, 0, 0, 0 },
/* U+4c89 */ { 0, 0, 0, 0, 0 },
/* U+4c8a */ { 0, 0, 0, 0, 0 },
/* U+4c8b */ { 0, 0, 0, 0, 0 },
/* U+4c8c */ { 0, 0, 0, 0, 0 },
/* U+4c8d */ { 0, 0, 0, 0, 0 },
/* U+4c8e */ { 0, 0, 0, 0, 0 },
/* U+4c8f */ { 0, 0, 0, 0, 0 },
/* U+4c90 */ { 0, 0, 0, 0, 0 },
/* U+4c91 */ { 0, 0, 0, 0, 0 },
/* U+4c92 */ { 0, 0, 0, 0, 0 },
/* U+4c93 */ { 0, 0, 0, 0, 0 },
/* U+4c94 */ { 0, 0, 0, 0, 0 },
/* U+4c95 */ { 0, 0, 0, 0, 0 },
/* U+4c96 */ { 0, 0, 0, 0, 0 },
/* U+4c97 */ { 0, 0, 0, 0, 0 },
/* U+4c98 */ { 0, 0, 0, 0, 0 },
/* U+4c99 */ { 0, 0, 0, 0, 0 },
/* U+4c9a */ { 0, 0, 0, 0, 0 },
/* U+4c9b */ { 0, 0, 0, 0, 0 },
/* U+4c9c */ { 0, 0, 0, 0, 0 },
/* U+4c9d */ { 0, 0, 0, 0, 0 },
/* U+4c9e */ { 0, 0, 0, 0, 0 },
/* U+4c9f */ { 0, 0, 0, 0, 0 },
/* U+4ca0 */ { 0, 0, 0, 0, 0 },
/* U+4ca1 */ { 0, 0, 0, 0, 0 },
/* U+4ca2 */ { 0, 0, 0, 0, 0 },
/* U+4ca3 */ { 0, 0, 0, 0, 0 },
/* U+4ca4 */ { 0, 0, 0, 0, 0 },
/* U+4ca5 */ { 0, 0, 0, 0, 0 },
/* U+4ca6 */ { 0, 0, 0, 0, 0 },
/* U+4ca7 */ { 0, 0, 0, 0, 0 },
/* U+4ca8 */ { 0, 0, 0, 0, 0 },
/* U+4ca9 */ { 0, 0, 0, 0, 0 },
/* U+4caa */ { 0, 0, 0, 0, 0 },
/* U+4cab */ { 0, 0, 0, 0, 0 },
/* U+4cac */ { 0, 0, 0, 0, 0 },
/* U+4cad */ { 0, 0, 0, 0, 0 },
/* U+4cae */ { 0, 0, 0, 0, 0 },
/* U+4caf */ { 0, 0, 0, 0, 0 },
/* U+4cb0 */ { 0, 0, 0, 0, 0 },
/* U+4cb1 */ { 0, 0, 0, 0, 0 },
/* U+4cb2 */ { 0, 0, 0, 0, 0 },
/* U+4cb3 */ { 0, 0, 0, 0, 0 },
/* U+4cb4 */ { 0, 0, 0, 0, 0 },
/* U+4cb5 */ { 0, 0, 0, 0, 0 },
/* U+4cb6 */ { 0, 0, 0, 0, 0 },
/* U+4cb7 */ { 0, 0, 0, 0, 0 },
/* U+4cb8 */ { 0, 0, 0, 0, 0 },
/* U+4cb9 */ { 0, 0, 0, 0, 0 },
/* U+4cba */ { 0, 0, 0, 0, 0 },
/* U+4cbb */ { 0, 0, 0, 0, 0 },
/* U+4cbc */ { 0, 0, 0, 0, 0 },
/* U+4cbd */ { 0, 0, 0, 0, 0 },
/* U+4cbe */ { 0, 0, 0, 0, 0 },
/* U+4cbf */ { 0, 0, 0, 0, 0 },
/* U+4cc0 */ { 0, 0, 0, 0, 0 },
/* U+4cc1 */ { 0, 0, 0, 0, 0 },
/* U+4cc2 */ { 0, 0, 0, 0, 0 },
/* U+4cc3 */ { 0, 0, 0, 0, 0 },
/* U+4cc4 */ { 0, 0, 0, 0, 0 },
/* U+4cc5 */ { 0, 0, 0, 0, 0 },
/* U+4cc6 */ { 0, 0, 0, 0, 0 },
/* U+4cc7 */ { 0, 0, 0, 0, 0 },
/* U+4cc8 */ { 0, 0, 0, 0, 0 },
/* U+4cc9 */ { 0, 0, 0, 0, 0 },
/* U+4cca */ { 0, 0, 0, 0, 0 },
/* U+4ccb */ { 0, 0, 0, 0, 0 },
/* U+4ccc */ { 0, 0, 0, 0, 0 },
/* U+4ccd */ { 0, 0, 0, 0, 0 },
/* U+4cce */ { 0, 0, 0, 0, 0 },
/* U+4ccf */ { 0, 0, 0, 0, 0 },
/* U+4cd0 */ { 0, 0, 0, 0, 0 },
/* U+4cd1 */ { 0, 0, 0, 0, 0 },
/* U+4cd2 */ { 0, 0, 0, 0, 0 },
/* U+4cd3 */ { 0, 0, 0, 0, 0 },
/* U+4cd4 */ { 0, 0, 0, 0, 0 },
/* U+4cd5 */ { 0, 0, 0, 0, 0 },
/* U+4cd6 */ { 0, 0, 0, 0, 0 },
/* U+4cd7 */ { 0, 0, 0, 0, 0 },
/* U+4cd8 */ { 0, 0, 0, 0, 0 },
/* U+4cd9 */ { 0, 0, 0, 0, 0 },
/* U+4cda */ { 0, 0, 0, 0, 0 },
/* U+4cdb */ { 0, 0, 0, 0, 0 },
/* U+4cdc */ { 0, 0, 0, 0, 0 },
/* U+4cdd */ { 0, 0, 0, 0, 0 },
/* U+4cde */ { 0, 0, 0, 0, 0 },
/* U+4cdf */ { 0, 0, 0, 0, 0 },
/* U+4ce0 */ { 0, 0, 0, 0, 0 },
/* U+4ce1 */ { 0, 0, 0, 0, 0 },
/* U+4ce2 */ { 0, 0, 0, 0, 0 },
/* U+4ce3 */ { 0, 0, 0, 0, 0 },
/* U+4ce4 */ { 0, 0, 0, 0, 0 },
/* U+4ce5 */ { 0, 0, 0, 0, 0 },
/* U+4ce6 */ { 0, 0, 0, 0, 0 },
/* U+4ce7 */ { 0, 0, 0, 0, 0 },
/* U+4ce8 */ { 0, 0, 0, 0, 0 },
/* U+4ce9 */ { 0, 0, 0, 0, 0 },
/* U+4cea */ { 0, 0, 0, 0, 0 },
/* U+4ceb */ { 0, 0, 0, 0, 0 },
/* U+4cec */ { 0, 0, 0, 0, 0 },
/* U+4ced */ { 0, 0, 0, 0, 0 },
/* U+4cee */ { 0, 0, 0, 0, 0 },
/* U+4cef */ { 0, 0, 0, 0, 0 },
/* U+4cf0 */ { 0, 0, 0, 0, 0 },
/* U+4cf1 */ { 0, 0, 0, 0, 0 },
/* U+4cf2 */ { 0, 0, 0, 0, 0 },
/* U+4cf3 */ { 0, 0, 0, 0, 0 },
/* U+4cf4 */ { 0, 0, 0, 0, 0 },
/* U+4cf5 */ { 0, 0, 0, 0, 0 },
/* U+4cf6 */ { 0, 0, 0, 0, 0 },
/* U+4cf7 */ { 0, 0, 0, 0, 0 },
/* U+4cf8 */ { 0, 0, 0, 0, 0 },
/* U+4cf9 */ { 0, 0, 0, 0, 0 },
/* U+4cfa */ { 0, 0, 0, 0, 0 },
/* U+4cfb */ { 0, 0, 0, 0, 0 },
/* U+4cfc */ { 0, 0, 0, 0, 0 },
/* U+4cfd */ { 0, 0, 0, 0, 0 },
/* U+4cfe */ { 0, 0, 0, 0, 0 },
/* U+4cff */ { 0, 0, 0, 0, 0 },
/* U+4d00 */ { 0, 0, 0, 0, 0 },
/* U+4d01 */ { 0, 0, 0, 0, 0 },
/* U+4d02 */ { 0, 0, 0, 0, 0 },
/* U+4d03 */ { 0, 0, 0, 0, 0 },
/* U+4d04 */ { 0, 0, 0, 0, 0 },
/* U+4d05 */ { 0, 0, 0, 0, 0 },
/* U+4d06 */ { 0, 0, 0, 0, 0 },
/* U+4d07 */ { 0, 0, 0, 0, 0 },
/* U+4d08 */ { 0, 0, 0, 0, 0 },
/* U+4d09 */ { 0, 0, 0, 0, 0 },
/* U+4d0a */ { 0, 0, 0, 0, 0 },
/* U+4d0b */ { 0, 0, 0, 0, 0 },
/* U+4d0c */ { 0, 0, 0, 0, 0 },
/* U+4d0d */ { 0, 0, 0, 0, 0 },
/* U+4d0e */ { 0, 0, 0, 0, 0 },
/* U+4d0f */ { 0, 0, 0, 0, 0 },
/* U+4d10 */ { 0, 0, 0, 0, 0 },
/* U+4d11 */ { 0, 0, 0, 0, 0 },
/* U+4d12 */ { 0, 0, 0, 0, 0 },
/* U+4d13 */ { 0, 0, 0, 0, 0 },
/* U+4d14 */ { 0, 0, 0, 0, 0 },
/* U+4d15 */ { 0, 0, 0, 0, 0 },
/* U+4d16 */ { 0, 0, 0, 0, 0 },
/* U+4d17 */ { 0, 0, 0, 0, 0 },
/* U+4d18 */ { 0, 0, 0, 0, 0 },
/* U+4d19 */ { 0, 0, 0, 0, 0 },
/* U+4d1a */ { 0, 0, 0, 0, 0 },
/* U+4d1b */ { 0, 0, 0, 0, 0 },
/* U+4d1c */ { 0, 0, 0, 0, 0 },
/* U+4d1d */ { 0, 0, 0, 0, 0 },
/* U+4d1e */ { 0, 0, 0, 0, 0 },
/* U+4d1f */ { 0, 0, 0, 0, 0 },
/* U+4d20 */ { 0, 0, 0, 0, 0 },
/* U+4d21 */ { 0, 0, 0, 0, 0 },
/* U+4d22 */ { 0, 0, 0, 0, 0 },
/* U+4d23 */ { 0, 0, 0, 0, 0 },
/* U+4d24 */ { 0, 0, 0, 0, 0 },
/* U+4d25 */ { 0, 0, 0, 0, 0 },
/* U+4d26 */ { 0, 0, 0, 0, 0 },
/* U+4d27 */ { 0, 0, 0, 0, 0 },
/* U+4d28 */ { 0, 0, 0, 0, 0 },
/* U+4d29 */ { 0, 0, 0, 0, 0 },
/* U+4d2a */ { 0, 0, 0, 0, 0 },
/* U+4d2b */ { 0, 0, 0, 0, 0 },
/* U+4d2c */ { 0, 0, 0, 0, 0 },
/* U+4d2d */ { 0, 0, 0, 0, 0 },
/* U+4d2e */ { 0, 0, 0, 0, 0 },
/* U+4d2f */ { 0, 0, 0, 0, 0 },
/* U+4d30 */ { 0, 0, 0, 0, 0 },
/* U+4d31 */ { 0, 0, 0, 0, 0 },
/* U+4d32 */ { 0, 0, 0, 0, 0 },
/* U+4d33 */ { 0, 0, 0, 0, 0 },
/* U+4d34 */ { 0, 0, 0, 0, 0 },
/* U+4d35 */ { 0, 0, 0, 0, 0 },
/* U+4d36 */ { 0, 0, 0, 0, 0 },
/* U+4d37 */ { 0, 0, 0, 0, 0 },
/* U+4d38 */ { 0, 0, 0, 0, 0 },
/* U+4d39 */ { 0, 0, 0, 0, 0 },
/* U+4d3a */ { 0, 0, 0, 0, 0 },
/* U+4d3b */ { 0, 0, 0, 0, 0 },
/* U+4d3c */ { 0, 0, 0, 0, 0 },
/* U+4d3d */ { 0, 0, 0, 0, 0 },
/* U+4d3e */ { 0, 0, 0, 0, 0 },
/* U+4d3f */ { 0, 0, 0, 0, 0 },
/* U+4d40 */ { 0, 0, 0, 0, 0 },
/* U+4d41 */ { 0, 0, 0, 0, 0 },
/* U+4d42 */ { 0, 0, 0, 0, 0 },
/* U+4d43 */ { 0, 0, 0, 0, 0 },
/* U+4d44 */ { 0, 0, 0, 0, 0 },
/* U+4d45 */ { 0, 0, 0, 0, 0 },
/* U+4d46 */ { 0, 0, 0, 0, 0 },
/* U+4d47 */ { 0, 0, 0, 0, 0 },
/* U+4d48 */ { 0, 0, 0, 0, 0 },
/* U+4d49 */ { 0, 0, 0, 0, 0 },
/* U+4d4a */ { 0, 0, 0, 0, 0 },
/* U+4d4b */ { 0, 0, 0, 0, 0 },
/* U+4d4c */ { 0, 0, 0, 0, 0 },
/* U+4d4d */ { 0, 0, 0, 0, 0 },
/* U+4d4e */ { 0, 0, 0, 0, 0 },
/* U+4d4f */ { 0, 0, 0, 0, 0 },
/* U+4d50 */ { 0, 0, 0, 0, 0 },
/* U+4d51 */ { 0, 0, 0, 0, 0 },
/* U+4d52 */ { 0, 0, 0, 0, 0 },
/* U+4d53 */ { 0, 0, 0, 0, 0 },
/* U+4d54 */ { 0, 0, 0, 0, 0 },
/* U+4d55 */ { 0, 0, 0, 0, 0 },
/* U+4d56 */ { 0, 0, 0, 0, 0 },
/* U+4d57 */ { 0, 0, 0, 0, 0 },
/* U+4d58 */ { 0, 0, 0, 0, 0 },
/* U+4d59 */ { 0, 0, 0, 0, 0 },
/* U+4d5a */ { 0, 0, 0, 0, 0 },
/* U+4d5b */ { 0, 0, 0, 0, 0 },
/* U+4d5c */ { 0, 0, 0, 0, 0 },
/* U+4d5d */ { 0, 0, 0, 0, 0 },
/* U+4d5e */ { 0, 0, 0, 0, 0 },
/* U+4d5f */ { 0, 0, 0, 0, 0 },
/* U+4d60 */ { 0, 0, 0, 0, 0 },
/* U+4d61 */ { 0, 0, 0, 0, 0 },
/* U+4d62 */ { 0, 0, 0, 0, 0 },
/* U+4d63 */ { 0, 0, 0, 0, 0 },
/* U+4d64 */ { 0, 0, 0, 0, 0 },
/* U+4d65 */ { 0, 0, 0, 0, 0 },
/* U+4d66 */ { 0, 0, 0, 0, 0 },
/* U+4d67 */ { 0, 0, 0, 0, 0 },
/* U+4d68 */ { 0, 0, 0, 0, 0 },
/* U+4d69 */ { 0, 0, 0, 0, 0 },
/* U+4d6a */ { 0, 0, 0, 0, 0 },
/* U+4d6b */ { 0, 0, 0, 0, 0 },
/* U+4d6c */ { 0, 0, 0, 0, 0 },
/* U+4d6d */ { 0, 0, 0, 0, 0 },
/* U+4d6e */ { 0, 0, 0, 0, 0 },
/* U+4d6f */ { 0, 0, 0, 0, 0 },
/* U+4d70 */ { 0, 0, 0, 0, 0 },
/* U+4d71 */ { 0, 0, 0, 0, 0 },
/* U+4d72 */ { 0, 0, 0, 0, 0 },
/* U+4d73 */ { 0, 0, 0, 0, 0 },
/* U+4d74 */ { 0, 0, 0, 0, 0 },
/* U+4d75 */ { 0, 0, 0, 0, 0 },
/* U+4d76 */ { 0, 0, 0, 0, 0 },
/* U+4d77 */ { 0, 0, 0, 0, 0 },
/* U+4d78 */ { 0, 0, 0, 0, 0 },
/* U+4d79 */ { 0, 0, 0, 0, 0 },
/* U+4d7a */ { 0, 0, 0, 0, 0 },
/* U+4d7b */ { 0, 0, 0, 0, 0 },
/* U+4d7c */ { 0, 0, 0, 0, 0 },
/* U+4d7d */ { 0, 0, 0, 0, 0 },
/* U+4d7e */ { 0, 0, 0, 0, 0 },
/* U+4d7f */ { 0, 0, 0, 0, 0 },
/* U+4d80 */ { 0, 0, 0, 0, 0 },
/* U+4d81 */ { 0, 0, 0, 0, 0 },
/* U+4d82 */ { 0, 0, 0, 0, 0 },
/* U+4d83 */ { 0, 0, 0, 0, 0 },
/* U+4d84 */ { 0, 0, 0, 0, 0 },
/* U+4d85 */ { 0, 0, 0, 0, 0 },
/* U+4d86 */ { 0, 0, 0, 0, 0 },
/* U+4d87 */ { 0, 0, 0, 0, 0 },
/* U+4d88 */ { 0, 0, 0, 0, 0 },
/* U+4d89 */ { 0, 0, 0, 0, 0 },
/* U+4d8a */ { 0, 0, 0, 0, 0 },
/* U+4d8b */ { 0, 0, 0, 0, 0 },
/* U+4d8c */ { 0, 0, 0, 0, 0 },
/* U+4d8d */ { 0, 0, 0, 0, 0 },
/* U+4d8e */ { 0, 0, 0, 0, 0 },
/* U+4d8f */ { 0, 0, 0, 0, 0 },
/* U+4d90 */ { 0, 0, 0, 0, 0 },
/* U+4d91 */ { 0, 0, 0, 0, 0 },
/* U+4d92 */ { 0, 0, 0, 0, 0 },
/* U+4d93 */ { 0, 0, 0, 0, 0 },
/* U+4d94 */ { 0, 0, 0, 0, 0 },
/* U+4d95 */ { 0, 0, 0, 0, 0 },
/* U+4d96 */ { 0, 0, 0, 0, 0 },
/* U+4d97 */ { 0, 0, 0, 0, 0 },
/* U+4d98 */ { 0, 0, 0, 0, 0 },
/* U+4d99 */ { 0, 0, 0, 0, 0 },
/* U+4d9a */ { 0, 0, 0, 0, 0 },
/* U+4d9b */ { 0, 0, 0, 0, 0 },
/* U+4d9c */ { 0, 0, 0, 0, 0 },
/* U+4d9d */ { 0, 0, 0, 0, 0 },
/* U+4d9e */ { 0, 0, 0, 0, 0 },
/* U+4d9f */ { 0, 0, 0, 0, 0 },
/* U+4da0 */ { 0, 0, 0, 0, 0 },
/* U+4da1 */ { 0, 0, 0, 0, 0 },
/* U+4da2 */ { 0, 0, 0, 0, 0 },
/* U+4da3 */ { 0, 0, 0, 0, 0 },
/* U+4da4 */ { 0, 0, 0, 0, 0 },
/* U+4da5 */ { 0, 0, 0, 0, 0 },
/* U+4da6 */ { 0, 0, 0, 0, 0 },
/* U+4da7 */ { 0, 0, 0, 0, 0 },
/* U+4da8 */ { 0, 0, 0, 0, 0 },
/* U+4da9 */ { 0, 0, 0, 0, 0 },
/* U+4daa */ { 0, 0, 0, 0, 0 },
/* U+4dab */ { 0, 0, 0, 0, 0 },
/* U+4dac */ { 0, 0, 0, 0, 0 },
/* U+4dad */ { 0, 0, 0, 0, 0 },
/* U+4dae */ { 0, 0, 0, 0, 0 },
/* U+4daf */ { 0, 0, 0, 0, 0 },
/* U+4db0 */ { 0, 0, 0, 0, 0 },
/* U+4db1 */ { 0, 0, 0, 0, 0 },
/* U+4db2 */ { 0, 0, 0, 0, 0 },
/* U+4db3 */ { 0, 0, 0, 0, 0 },
/* U+4db4 */ { 0, 0, 0, 0, 0 },
/* U+4db5 */ { 19, 0, 1, 0, 0 },
/* U+4db6 */ { 0, 0, 0, 0, 0 },
/* U+4db7 */ { 0, 0, 0, 0, 0 },
/* U+4db8 */ { 0, 0, 0, 0, 0 },
/* U+4db9 */ { 0, 0, 0, 0, 0 },
/* U+4dba */ { 0, 0, 0, 0, 0 },
/* U+4dbb */ { 0, 0, 0, 0, 0 },
/* U+4dbc */ { 0, 0, 0, 0, 0 },
/* U+4dbd */ { 0, 0, 0, 0, 0 },
/* U+4dbe */ { 0, 0, 0, 0, 0 },
/* U+4dbf */ { 0, 0, 0, 0, 0 },
/* U+4dc0 */ { 0, 0, 0, 0, 0 },
/* U+4dc1 */ { 0, 0, 0, 0, 0 },
/* U+4dc2 */ { 0, 0, 0, 0, 0 },
/* U+4dc3 */ { 0, 0, 0, 0, 0 },
/* U+4dc4 */ { 0, 0, 0, 0, 0 },
/* U+4dc5 */ { 0, 0, 0, 0, 0 },
/* U+4dc6 */ { 0, 0, 0, 0, 0 },
/* U+4dc7 */ { 0, 0, 0, 0, 0 },
/* U+4dc8 */ { 0, 0, 0, 0, 0 },
/* U+4dc9 */ { 0, 0, 0, 0, 0 },
/* U+4dca */ { 0, 0, 0, 0, 0 },
/* U+4dcb */ { 0, 0, 0, 0, 0 },
/* U+4dcc */ { 0, 0, 0, 0, 0 },
/* U+4dcd */ { 0, 0, 0, 0, 0 },
/* U+4dce */ { 0, 0, 0, 0, 0 },
/* U+4dcf */ { 0, 0, 0, 0, 0 },
/* U+4dd0 */ { 0, 0, 0, 0, 0 },
/* U+4dd1 */ { 0, 0, 0, 0, 0 },
/* U+4dd2 */ { 0, 0, 0, 0, 0 },
/* U+4dd3 */ { 0, 0, 0, 0, 0 },
/* U+4dd4 */ { 0, 0, 0, 0, 0 },
/* U+4dd5 */ { 0, 0, 0, 0, 0 },
/* U+4dd6 */ { 0, 0, 0, 0, 0 },
/* U+4dd7 */ { 0, 0, 0, 0, 0 },
/* U+4dd8 */ { 0, 0, 0, 0, 0 },
/* U+4dd9 */ { 0, 0, 0, 0, 0 },
/* U+4dda */ { 0, 0, 0, 0, 0 },
/* U+4ddb */ { 0, 0, 0, 0, 0 },
/* U+4ddc */ { 0, 0, 0, 0, 0 },
/* U+4ddd */ { 0, 0, 0, 0, 0 },
/* U+4dde */ { 0, 0, 0, 0, 0 },
/* U+4ddf */ { 0, 0, 0, 0, 0 },
/* U+4de0 */ { 0, 0, 0, 0, 0 },
/* U+4de1 */ { 0, 0, 0, 0, 0 },
/* U+4de2 */ { 0, 0, 0, 0, 0 },
/* U+4de3 */ { 0, 0, 0, 0, 0 },
/* U+4de4 */ { 0, 0, 0, 0, 0 },
/* U+4de5 */ { 0, 0, 0, 0, 0 },
/* U+4de6 */ { 0, 0, 0, 0, 0 },
/* U+4de7 */ { 0, 0, 0, 0, 0 },
/* U+4de8 */ { 0, 0, 0, 0, 0 },
/* U+4de9 */ { 0, 0, 0, 0, 0 },
/* U+4dea */ { 0, 0, 0, 0, 0 },
/* U+4deb */ { 0, 0, 0, 0, 0 },
/* U+4dec */ { 0, 0, 0, 0, 0 },
/* U+4ded */ { 0, 0, 0, 0, 0 },
/* U+4dee */ { 0, 0, 0, 0, 0 },
/* U+4def */ { 0, 0, 0, 0, 0 },
/* U+4df0 */ { 0, 0, 0, 0, 0 },
/* U+4df1 */ { 0, 0, 0, 0, 0 },
/* U+4df2 */ { 0, 0, 0, 0, 0 },
/* U+4df3 */ { 0, 0, 0, 0, 0 },
/* U+4df4 */ { 0, 0, 0, 0, 0 },
/* U+4df5 */ { 0, 0, 0, 0, 0 },
/* U+4df6 */ { 0, 0, 0, 0, 0 },
/* U+4df7 */ { 0, 0, 0, 0, 0 },
/* U+4df8 */ { 0, 0, 0, 0, 0 },
/* U+4df9 */ { 0, 0, 0, 0, 0 },
/* U+4dfa */ { 0, 0, 0, 0, 0 },
/* U+4dfb */ { 0, 0, 0, 0, 0 },
/* U+4dfc */ { 0, 0, 0, 0, 0 },
/* U+4dfd */ { 0, 0, 0, 0, 0 },
/* U+4dfe */ { 0, 0, 0, 0, 0 },
/* U+4dff */ { 0, 0, 0, 0, 0 },
/* U+4e00 */ { 19, 0, 1, 0, 0 },
/* U+4e01 */ { 0, 0, 0, 0, 0 },
/* U+4e02 */ { 0, 0, 0, 0, 0 },
/* U+4e03 */ { 0, 0, 0, 0, 0 },
/* U+4e04 */ { 0, 0, 0, 0, 0 },
/* U+4e05 */ { 0, 0, 0, 0, 0 },
/* U+4e06 */ { 0, 0, 0, 0, 0 },
/* U+4e07 */ { 0, 0, 0, 0, 0 },
/* U+4e08 */ { 0, 0, 0, 0, 0 },
/* U+4e09 */ { 0, 0, 0, 0, 0 },
/* U+4e0a */ { 0, 0, 0, 0, 0 },
/* U+4e0b */ { 0, 0, 0, 0, 0 },
/* U+4e0c */ { 0, 0, 0, 0, 0 },
/* U+4e0d */ { 0, 0, 0, 0, 0 },
/* U+4e0e */ { 0, 0, 0, 0, 0 },
/* U+4e0f */ { 0, 0, 0, 0, 0 },
/* U+4e10 */ { 0, 0, 0, 0, 0 },
/* U+4e11 */ { 0, 0, 0, 0, 0 },
/* U+4e12 */ { 0, 0, 0, 0, 0 },
/* U+4e13 */ { 0, 0, 0, 0, 0 },
/* U+4e14 */ { 0, 0, 0, 0, 0 },
/* U+4e15 */ { 0, 0, 0, 0, 0 },
/* U+4e16 */ { 0, 0, 0, 0, 0 },
/* U+4e17 */ { 0, 0, 0, 0, 0 },
/* U+4e18 */ { 0, 0, 0, 0, 0 },
/* U+4e19 */ { 0, 0, 0, 0, 0 },
/* U+4e1a */ { 0, 0, 0, 0, 0 },
/* U+4e1b */ { 0, 0, 0, 0, 0 },
/* U+4e1c */ { 0, 0, 0, 0, 0 },
/* U+4e1d */ { 0, 0, 0, 0, 0 },
/* U+4e1e */ { 0, 0, 0, 0, 0 },
/* U+4e1f */ { 0, 0, 0, 0, 0 },
/* U+4e20 */ { 0, 0, 0, 0, 0 },
/* U+4e21 */ { 0, 0, 0, 0, 0 },
/* U+4e22 */ { 0, 0, 0, 0, 0 },
/* U+4e23 */ { 0, 0, 0, 0, 0 },
/* U+4e24 */ { 0, 0, 0, 0, 0 },
/* U+4e25 */ { 0, 0, 0, 0, 0 },
/* U+4e26 */ { 0, 0, 0, 0, 0 },
/* U+4e27 */ { 0, 0, 0, 0, 0 },
/* U+4e28 */ { 0, 0, 0, 0, 0 },
/* U+4e29 */ { 0, 0, 0, 0, 0 },
/* U+4e2a */ { 0, 0, 0, 0, 0 },
/* U+4e2b */ { 0, 0, 0, 0, 0 },
/* U+4e2c */ { 0, 0, 0, 0, 0 },
/* U+4e2d */ { 0, 0, 0, 0, 0 },
/* U+4e2e */ { 0, 0, 0, 0, 0 },
/* U+4e2f */ { 0, 0, 0, 0, 0 },
/* U+4e30 */ { 0, 0, 0, 0, 0 },
/* U+4e31 */ { 0, 0, 0, 0, 0 },
/* U+4e32 */ { 0, 0, 0, 0, 0 },
/* U+4e33 */ { 0, 0, 0, 0, 0 },
/* U+4e34 */ { 0, 0, 0, 0, 0 },
/* U+4e35 */ { 0, 0, 0, 0, 0 },
/* U+4e36 */ { 0, 0, 0, 0, 0 },
/* U+4e37 */ { 0, 0, 0, 0, 0 },
/* U+4e38 */ { 0, 0, 0, 0, 0 },
/* U+4e39 */ { 0, 0, 0, 0, 0 },
/* U+4e3a */ { 0, 0, 0, 0, 0 },
/* U+4e3b */ { 0, 0, 0, 0, 0 },
/* U+4e3c */ { 0, 0, 0, 0, 0 },
/* U+4e3d */ { 0, 0, 0, 0, 0 },
/* U+4e3e */ { 0, 0, 0, 0, 0 },
/* U+4e3f */ { 0, 0, 0, 0, 0 },
/* U+4e40 */ { 0, 0, 0, 0, 0 },
/* U+4e41 */ { 0, 0, 0, 0, 0 },
/* U+4e42 */ { 0, 0, 0, 0, 0 },
/* U+4e43 */ { 0, 0, 0, 0, 0 },
/* U+4e44 */ { 0, 0, 0, 0, 0 },
/* U+4e45 */ { 0, 0, 0, 0, 0 },
/* U+4e46 */ { 0, 0, 0, 0, 0 },
/* U+4e47 */ { 0, 0, 0, 0, 0 },
/* U+4e48 */ { 0, 0, 0, 0, 0 },
/* U+4e49 */ { 0, 0, 0, 0, 0 },
/* U+4e4a */ { 0, 0, 0, 0, 0 },
/* U+4e4b */ { 0, 0, 0, 0, 0 },
/* U+4e4c */ { 0, 0, 0, 0, 0 },
/* U+4e4d */ { 0, 0, 0, 0, 0 },
/* U+4e4e */ { 0, 0, 0, 0, 0 },
/* U+4e4f */ { 0, 0, 0, 0, 0 },
/* U+4e50 */ { 0, 0, 0, 0, 0 },
/* U+4e51 */ { 0, 0, 0, 0, 0 },
/* U+4e52 */ { 0, 0, 0, 0, 0 },
/* U+4e53 */ { 0, 0, 0, 0, 0 },
/* U+4e54 */ { 0, 0, 0, 0, 0 },
/* U+4e55 */ { 0, 0, 0, 0, 0 },
/* U+4e56 */ { 0, 0, 0, 0, 0 },
/* U+4e57 */ { 0, 0, 0, 0, 0 },
/* U+4e58 */ { 0, 0, 0, 0, 0 },
/* U+4e59 */ { 0, 0, 0, 0, 0 },
/* U+4e5a */ { 0, 0, 0, 0, 0 },
/* U+4e5b */ { 0, 0, 0, 0, 0 },
/* U+4e5c */ { 0, 0, 0, 0, 0 },
/* U+4e5d */ { 0, 0, 0, 0, 0 },
/* U+4e5e */ { 0, 0, 0, 0, 0 },
/* U+4e5f */ { 0, 0, 0, 0, 0 },
/* U+4e60 */ { 0, 0, 0, 0, 0 },
/* U+4e61 */ { 0, 0, 0, 0, 0 },
/* U+4e62 */ { 0, 0, 0, 0, 0 },
/* U+4e63 */ { 0, 0, 0, 0, 0 },
/* U+4e64 */ { 0, 0, 0, 0, 0 },
/* U+4e65 */ { 0, 0, 0, 0, 0 },
/* U+4e66 */ { 0, 0, 0, 0, 0 },
/* U+4e67 */ { 0, 0, 0, 0, 0 },
/* U+4e68 */ { 0, 0, 0, 0, 0 },
/* U+4e69 */ { 0, 0, 0, 0, 0 },
/* U+4e6a */ { 0, 0, 0, 0, 0 },
/* U+4e6b */ { 0, 0, 0, 0, 0 },
/* U+4e6c */ { 0, 0, 0, 0, 0 },
/* U+4e6d */ { 0, 0, 0, 0, 0 },
/* U+4e6e */ { 0, 0, 0, 0, 0 },
/* U+4e6f */ { 0, 0, 0, 0, 0 },
/* U+4e70 */ { 0, 0, 0, 0, 0 },
/* U+4e71 */ { 0, 0, 0, 0, 0 },
/* U+4e72 */ { 0, 0, 0, 0, 0 },
/* U+4e73 */ { 0, 0, 0, 0, 0 },
/* U+4e74 */ { 0, 0, 0, 0, 0 },
/* U+4e75 */ { 0, 0, 0, 0, 0 },
/* U+4e76 */ { 0, 0, 0, 0, 0 },
/* U+4e77 */ { 0, 0, 0, 0, 0 },
/* U+4e78 */ { 0, 0, 0, 0, 0 },
/* U+4e79 */ { 0, 0, 0, 0, 0 },
/* U+4e7a */ { 0, 0, 0, 0, 0 },
/* U+4e7b */ { 0, 0, 0, 0, 0 },
/* U+4e7c */ { 0, 0, 0, 0, 0 },
/* U+4e7d */ { 0, 0, 0, 0, 0 },
/* U+4e7e */ { 0, 0, 0, 0, 0 },
/* U+4e7f */ { 0, 0, 0, 0, 0 },
/* U+4e80 */ { 0, 0, 0, 0, 0 },
/* U+4e81 */ { 0, 0, 0, 0, 0 },
/* U+4e82 */ { 0, 0, 0, 0, 0 },
/* U+4e83 */ { 0, 0, 0, 0, 0 },
/* U+4e84 */ { 0, 0, 0, 0, 0 },
/* U+4e85 */ { 0, 0, 0, 0, 0 },
/* U+4e86 */ { 0, 0, 0, 0, 0 },
/* U+4e87 */ { 0, 0, 0, 0, 0 },
/* U+4e88 */ { 0, 0, 0, 0, 0 },
/* U+4e89 */ { 0, 0, 0, 0, 0 },
/* U+4e8a */ { 0, 0, 0, 0, 0 },
/* U+4e8b */ { 0, 0, 0, 0, 0 },
/* U+4e8c */ { 0, 0, 0, 0, 0 },
/* U+4e8d */ { 0, 0, 0, 0, 0 },
/* U+4e8e */ { 0, 0, 0, 0, 0 },
/* U+4e8f */ { 0, 0, 0, 0, 0 },
/* U+4e90 */ { 0, 0, 0, 0, 0 },
/* U+4e91 */ { 0, 0, 0, 0, 0 },
/* U+4e92 */ { 0, 0, 0, 0, 0 },
/* U+4e93 */ { 0, 0, 0, 0, 0 },
/* U+4e94 */ { 0, 0, 0, 0, 0 },
/* U+4e95 */ { 0, 0, 0, 0, 0 },
/* U+4e96 */ { 0, 0, 0, 0, 0 },
/* U+4e97 */ { 0, 0, 0, 0, 0 },
/* U+4e98 */ { 0, 0, 0, 0, 0 },
/* U+4e99 */ { 0, 0, 0, 0, 0 },
/* U+4e9a */ { 0, 0, 0, 0, 0 },
/* U+4e9b */ { 0, 0, 0, 0, 0 },
/* U+4e9c */ { 0, 0, 0, 0, 0 },
/* U+4e9d */ { 0, 0, 0, 0, 0 },
/* U+4e9e */ { 0, 0, 0, 0, 0 },
/* U+4e9f */ { 0, 0, 0, 0, 0 },
/* U+4ea0 */ { 0, 0, 0, 0, 0 },
/* U+4ea1 */ { 0, 0, 0, 0, 0 },
/* U+4ea2 */ { 0, 0, 0, 0, 0 },
/* U+4ea3 */ { 0, 0, 0, 0, 0 },
/* U+4ea4 */ { 0, 0, 0, 0, 0 },
/* U+4ea5 */ { 0, 0, 0, 0, 0 },
/* U+4ea6 */ { 0, 0, 0, 0, 0 },
/* U+4ea7 */ { 0, 0, 0, 0, 0 },
/* U+4ea8 */ { 0, 0, 0, 0, 0 },
/* U+4ea9 */ { 0, 0, 0, 0, 0 },
/* U+4eaa */ { 0, 0, 0, 0, 0 },
/* U+4eab */ { 0, 0, 0, 0, 0 },
/* U+4eac */ { 0, 0, 0, 0, 0 },
/* U+4ead */ { 0, 0, 0, 0, 0 },
/* U+4eae */ { 0, 0, 0, 0, 0 },
/* U+4eaf */ { 0, 0, 0, 0, 0 },
/* U+4eb0 */ { 0, 0, 0, 0, 0 },
/* U+4eb1 */ { 0, 0, 0, 0, 0 },
/* U+4eb2 */ { 0, 0, 0, 0, 0 },
/* U+4eb3 */ { 0, 0, 0, 0, 0 },
/* U+4eb4 */ { 0, 0, 0, 0, 0 },
/* U+4eb5 */ { 0, 0, 0, 0, 0 },
/* U+4eb6 */ { 0, 0, 0, 0, 0 },
/* U+4eb7 */ { 0, 0, 0, 0, 0 },
/* U+4eb8 */ { 0, 0, 0, 0, 0 },
/* U+4eb9 */ { 0, 0, 0, 0, 0 },
/* U+4eba */ { 0, 0, 0, 0, 0 },
/* U+4ebb */ { 0, 0, 0, 0, 0 },
/* U+4ebc */ { 0, 0, 0, 0, 0 },
/* U+4ebd */ { 0, 0, 0, 0, 0 },
/* U+4ebe */ { 0, 0, 0, 0, 0 },
/* U+4ebf */ { 0, 0, 0, 0, 0 },
/* U+4ec0 */ { 0, 0, 0, 0, 0 },
/* U+4ec1 */ { 0, 0, 0, 0, 0 },
/* U+4ec2 */ { 0, 0, 0, 0, 0 },
/* U+4ec3 */ { 0, 0, 0, 0, 0 },
/* U+4ec4 */ { 0, 0, 0, 0, 0 },
/* U+4ec5 */ { 0, 0, 0, 0, 0 },
/* U+4ec6 */ { 0, 0, 0, 0, 0 },
/* U+4ec7 */ { 0, 0, 0, 0, 0 },
/* U+4ec8 */ { 0, 0, 0, 0, 0 },
/* U+4ec9 */ { 0, 0, 0, 0, 0 },
/* U+4eca */ { 0, 0, 0, 0, 0 },
/* U+4ecb */ { 0, 0, 0, 0, 0 },
/* U+4ecc */ { 0, 0, 0, 0, 0 },
/* U+4ecd */ { 0, 0, 0, 0, 0 },
/* U+4ece */ { 0, 0, 0, 0, 0 },
/* U+4ecf */ { 0, 0, 0, 0, 0 },
/* U+4ed0 */ { 0, 0, 0, 0, 0 },
/* U+4ed1 */ { 0, 0, 0, 0, 0 },
/* U+4ed2 */ { 0, 0, 0, 0, 0 },
/* U+4ed3 */ { 0, 0, 0, 0, 0 },
/* U+4ed4 */ { 0, 0, 0, 0, 0 },
/* U+4ed5 */ { 0, 0, 0, 0, 0 },
/* U+4ed6 */ { 0, 0, 0, 0, 0 },
/* U+4ed7 */ { 0, 0, 0, 0, 0 },
/* U+4ed8 */ { 0, 0, 0, 0, 0 },
/* U+4ed9 */ { 0, 0, 0, 0, 0 },
/* U+4eda */ { 0, 0, 0, 0, 0 },
/* U+4edb */ { 0, 0, 0, 0, 0 },
/* U+4edc */ { 0, 0, 0, 0, 0 },
/* U+4edd */ { 0, 0, 0, 0, 0 },
/* U+4ede */ { 0, 0, 0, 0, 0 },
/* U+4edf */ { 0, 0, 0, 0, 0 },
/* U+4ee0 */ { 0, 0, 0, 0, 0 },
/* U+4ee1 */ { 0, 0, 0, 0, 0 },
/* U+4ee2 */ { 0, 0, 0, 0, 0 },
/* U+4ee3 */ { 0, 0, 0, 0, 0 },
/* U+4ee4 */ { 0, 0, 0, 0, 0 },
/* U+4ee5 */ { 0, 0, 0, 0, 0 },
/* U+4ee6 */ { 0, 0, 0, 0, 0 },
/* U+4ee7 */ { 0, 0, 0, 0, 0 },
/* U+4ee8 */ { 0, 0, 0, 0, 0 },
/* U+4ee9 */ { 0, 0, 0, 0, 0 },
/* U+4eea */ { 0, 0, 0, 0, 0 },
/* U+4eeb */ { 0, 0, 0, 0, 0 },
/* U+4eec */ { 0, 0, 0, 0, 0 },
/* U+4eed */ { 0, 0, 0, 0, 0 },
/* U+4eee */ { 0, 0, 0, 0, 0 },
/* U+4eef */ { 0, 0, 0, 0, 0 },
/* U+4ef0 */ { 0, 0, 0, 0, 0 },
/* U+4ef1 */ { 0, 0, 0, 0, 0 },
/* U+4ef2 */ { 0, 0, 0, 0, 0 },
/* U+4ef3 */ { 0, 0, 0, 0, 0 },
/* U+4ef4 */ { 0, 0, 0, 0, 0 },
/* U+4ef5 */ { 0, 0, 0, 0, 0 },
/* U+4ef6 */ { 0, 0, 0, 0, 0 },
/* U+4ef7 */ { 0, 0, 0, 0, 0 },
/* U+4ef8 */ { 0, 0, 0, 0, 0 },
/* U+4ef9 */ { 0, 0, 0, 0, 0 },
/* U+4efa */ { 0, 0, 0, 0, 0 },
/* U+4efb */ { 0, 0, 0, 0, 0 },
/* U+4efc */ { 0, 0, 0, 0, 0 },
/* U+4efd */ { 0, 0, 0, 0, 0 },
/* U+4efe */ { 0, 0, 0, 0, 0 },
/* U+4eff */ { 0, 0, 0, 0, 0 },
/* U+4f00 */ { 0, 0, 0, 0, 0 },
/* U+4f01 */ { 0, 0, 0, 0, 0 },
/* U+4f02 */ { 0, 0, 0, 0, 0 },
/* U+4f03 */ { 0, 0, 0, 0, 0 },
/* U+4f04 */ { 0, 0, 0, 0, 0 },
/* U+4f05 */ { 0, 0, 0, 0, 0 },
/* U+4f06 */ { 0, 0, 0, 0, 0 },
/* U+4f07 */ { 0, 0, 0, 0, 0 },
/* U+4f08 */ { 0, 0, 0, 0, 0 },
/* U+4f09 */ { 0, 0, 0, 0, 0 },
/* U+4f0a */ { 0, 0, 0, 0, 0 },
/* U+4f0b */ { 0, 0, 0, 0, 0 },
/* U+4f0c */ { 0, 0, 0, 0, 0 },
/* U+4f0d */ { 0, 0, 0, 0, 0 },
/* U+4f0e */ { 0, 0, 0, 0, 0 },
/* U+4f0f */ { 0, 0, 0, 0, 0 },
/* U+4f10 */ { 0, 0, 0, 0, 0 },
/* U+4f11 */ { 0, 0, 0, 0, 0 },
/* U+4f12 */ { 0, 0, 0, 0, 0 },
/* U+4f13 */ { 0, 0, 0, 0, 0 },
/* U+4f14 */ { 0, 0, 0, 0, 0 },
/* U+4f15 */ { 0, 0, 0, 0, 0 },
/* U+4f16 */ { 0, 0, 0, 0, 0 },
/* U+4f17 */ { 0, 0, 0, 0, 0 },
/* U+4f18 */ { 0, 0, 0, 0, 0 },
/* U+4f19 */ { 0, 0, 0, 0, 0 },
/* U+4f1a */ { 0, 0, 0, 0, 0 },
/* U+4f1b */ { 0, 0, 0, 0, 0 },
/* U+4f1c */ { 0, 0, 0, 0, 0 },
/* U+4f1d */ { 0, 0, 0, 0, 0 },
/* U+4f1e */ { 0, 0, 0, 0, 0 },
/* U+4f1f */ { 0, 0, 0, 0, 0 },
/* U+4f20 */ { 0, 0, 0, 0, 0 },
/* U+4f21 */ { 0, 0, 0, 0, 0 },
/* U+4f22 */ { 0, 0, 0, 0, 0 },
/* U+4f23 */ { 0, 0, 0, 0, 0 },
/* U+4f24 */ { 0, 0, 0, 0, 0 },
/* U+4f25 */ { 0, 0, 0, 0, 0 },
/* U+4f26 */ { 0, 0, 0, 0, 0 },
/* U+4f27 */ { 0, 0, 0, 0, 0 },
/* U+4f28 */ { 0, 0, 0, 0, 0 },
/* U+4f29 */ { 0, 0, 0, 0, 0 },
/* U+4f2a */ { 0, 0, 0, 0, 0 },
/* U+4f2b */ { 0, 0, 0, 0, 0 },
/* U+4f2c */ { 0, 0, 0, 0, 0 },
/* U+4f2d */ { 0, 0, 0, 0, 0 },
/* U+4f2e */ { 0, 0, 0, 0, 0 },
/* U+4f2f */ { 0, 0, 0, 0, 0 },
/* U+4f30 */ { 0, 0, 0, 0, 0 },
/* U+4f31 */ { 0, 0, 0, 0, 0 },
/* U+4f32 */ { 0, 0, 0, 0, 0 },
/* U+4f33 */ { 0, 0, 0, 0, 0 },
/* U+4f34 */ { 0, 0, 0, 0, 0 },
/* U+4f35 */ { 0, 0, 0, 0, 0 },
/* U+4f36 */ { 0, 0, 0, 0, 0 },
/* U+4f37 */ { 0, 0, 0, 0, 0 },
/* U+4f38 */ { 0, 0, 0, 0, 0 },
/* U+4f39 */ { 0, 0, 0, 0, 0 },
/* U+4f3a */ { 0, 0, 0, 0, 0 },
/* U+4f3b */ { 0, 0, 0, 0, 0 },
/* U+4f3c */ { 0, 0, 0, 0, 0 },
/* U+4f3d */ { 0, 0, 0, 0, 0 },
/* U+4f3e */ { 0, 0, 0, 0, 0 },
/* U+4f3f */ { 0, 0, 0, 0, 0 },
/* U+4f40 */ { 0, 0, 0, 0, 0 },
/* U+4f41 */ { 0, 0, 0, 0, 0 },
/* U+4f42 */ { 0, 0, 0, 0, 0 },
/* U+4f43 */ { 0, 0, 0, 0, 0 },
/* U+4f44 */ { 0, 0, 0, 0, 0 },
/* U+4f45 */ { 0, 0, 0, 0, 0 },
/* U+4f46 */ { 0, 0, 0, 0, 0 },
/* U+4f47 */ { 0, 0, 0, 0, 0 },
/* U+4f48 */ { 0, 0, 0, 0, 0 },
/* U+4f49 */ { 0, 0, 0, 0, 0 },
/* U+4f4a */ { 0, 0, 0, 0, 0 },
/* U+4f4b */ { 0, 0, 0, 0, 0 },
/* U+4f4c */ { 0, 0, 0, 0, 0 },
/* U+4f4d */ { 0, 0, 0, 0, 0 },
/* U+4f4e */ { 0, 0, 0, 0, 0 },
/* U+4f4f */ { 0, 0, 0, 0, 0 },
/* U+4f50 */ { 0, 0, 0, 0, 0 },
/* U+4f51 */ { 0, 0, 0, 0, 0 },
/* U+4f52 */ { 0, 0, 0, 0, 0 },
/* U+4f53 */ { 0, 0, 0, 0, 0 },
/* U+4f54 */ { 0, 0, 0, 0, 0 },
/* U+4f55 */ { 0, 0, 0, 0, 0 },
/* U+4f56 */ { 0, 0, 0, 0, 0 },
/* U+4f57 */ { 0, 0, 0, 0, 0 },
/* U+4f58 */ { 0, 0, 0, 0, 0 },
/* U+4f59 */ { 0, 0, 0, 0, 0 },
/* U+4f5a */ { 0, 0, 0, 0, 0 },
/* U+4f5b */ { 0, 0, 0, 0, 0 },
/* U+4f5c */ { 0, 0, 0, 0, 0 },
/* U+4f5d */ { 0, 0, 0, 0, 0 },
/* U+4f5e */ { 0, 0, 0, 0, 0 },
/* U+4f5f */ { 0, 0, 0, 0, 0 },
/* U+4f60 */ { 0, 0, 0, 0, 0 },
/* U+4f61 */ { 0, 0, 0, 0, 0 },
/* U+4f62 */ { 0, 0, 0, 0, 0 },
/* U+4f63 */ { 0, 0, 0, 0, 0 },
/* U+4f64 */ { 0, 0, 0, 0, 0 },
/* U+4f65 */ { 0, 0, 0, 0, 0 },
/* U+4f66 */ { 0, 0, 0, 0, 0 },
/* U+4f67 */ { 0, 0, 0, 0, 0 },
/* U+4f68 */ { 0, 0, 0, 0, 0 },
/* U+4f69 */ { 0, 0, 0, 0, 0 },
/* U+4f6a */ { 0, 0, 0, 0, 0 },
/* U+4f6b */ { 0, 0, 0, 0, 0 },
/* U+4f6c */ { 0, 0, 0, 0, 0 },
/* U+4f6d */ { 0, 0, 0, 0, 0 },
/* U+4f6e */ { 0, 0, 0, 0, 0 },
/* U+4f6f */ { 0, 0, 0, 0, 0 },
/* U+4f70 */ { 0, 0, 0, 0, 0 },
/* U+4f71 */ { 0, 0, 0, 0, 0 },
/* U+4f72 */ { 0, 0, 0, 0, 0 },
/* U+4f73 */ { 0, 0, 0, 0, 0 },
/* U+4f74 */ { 0, 0, 0, 0, 0 },
/* U+4f75 */ { 0, 0, 0, 0, 0 },
/* U+4f76 */ { 0, 0, 0, 0, 0 },
/* U+4f77 */ { 0, 0, 0, 0, 0 },
/* U+4f78 */ { 0, 0, 0, 0, 0 },
/* U+4f79 */ { 0, 0, 0, 0, 0 },
/* U+4f7a */ { 0, 0, 0, 0, 0 },
/* U+4f7b */ { 0, 0, 0, 0, 0 },
/* U+4f7c */ { 0, 0, 0, 0, 0 },
/* U+4f7d */ { 0, 0, 0, 0, 0 },
/* U+4f7e */ { 0, 0, 0, 0, 0 },
/* U+4f7f */ { 0, 0, 0, 0, 0 },
/* U+4f80 */ { 0, 0, 0, 0, 0 },
/* U+4f81 */ { 0, 0, 0, 0, 0 },
/* U+4f82 */ { 0, 0, 0, 0, 0 },
/* U+4f83 */ { 0, 0, 0, 0, 0 },
/* U+4f84 */ { 0, 0, 0, 0, 0 },
/* U+4f85 */ { 0, 0, 0, 0, 0 },
/* U+4f86 */ { 0, 0, 0, 0, 0 },
/* U+4f87 */ { 0, 0, 0, 0, 0 },
/* U+4f88 */ { 0, 0, 0, 0, 0 },
/* U+4f89 */ { 0, 0, 0, 0, 0 },
/* U+4f8a */ { 0, 0, 0, 0, 0 },
/* U+4f8b */ { 0, 0, 0, 0, 0 },
/* U+4f8c */ { 0, 0, 0, 0, 0 },
/* U+4f8d */ { 0, 0, 0, 0, 0 },
/* U+4f8e */ { 0, 0, 0, 0, 0 },
/* U+4f8f */ { 0, 0, 0, 0, 0 },
/* U+4f90 */ { 0, 0, 0, 0, 0 },
/* U+4f91 */ { 0, 0, 0, 0, 0 },
/* U+4f92 */ { 0, 0, 0, 0, 0 },
/* U+4f93 */ { 0, 0, 0, 0, 0 },
/* U+4f94 */ { 0, 0, 0, 0, 0 },
/* U+4f95 */ { 0, 0, 0, 0, 0 },
/* U+4f96 */ { 0, 0, 0, 0, 0 },
/* U+4f97 */ { 0, 0, 0, 0, 0 },
/* U+4f98 */ { 0, 0, 0, 0, 0 },
/* U+4f99 */ { 0, 0, 0, 0, 0 },
/* U+4f9a */ { 0, 0, 0, 0, 0 },
/* U+4f9b */ { 0, 0, 0, 0, 0 },
/* U+4f9c */ { 0, 0, 0, 0, 0 },
/* U+4f9d */ { 0, 0, 0, 0, 0 },
/* U+4f9e */ { 0, 0, 0, 0, 0 },
/* U+4f9f */ { 0, 0, 0, 0, 0 },
/* U+4fa0 */ { 0, 0, 0, 0, 0 },
/* U+4fa1 */ { 0, 0, 0, 0, 0 },
/* U+4fa2 */ { 0, 0, 0, 0, 0 },
/* U+4fa3 */ { 0, 0, 0, 0, 0 },
/* U+4fa4 */ { 0, 0, 0, 0, 0 },
/* U+4fa5 */ { 0, 0, 0, 0, 0 },
/* U+4fa6 */ { 0, 0, 0, 0, 0 },
/* U+4fa7 */ { 0, 0, 0, 0, 0 },
/* U+4fa8 */ { 0, 0, 0, 0, 0 },
/* U+4fa9 */ { 0, 0, 0, 0, 0 },
/* U+4faa */ { 0, 0, 0, 0, 0 },
/* U+4fab */ { 0, 0, 0, 0, 0 },
/* U+4fac */ { 0, 0, 0, 0, 0 },
/* U+4fad */ { 0, 0, 0, 0, 0 },
/* U+4fae */ { 0, 0, 0, 0, 0 },
/* U+4faf */ { 0, 0, 0, 0, 0 },
/* U+4fb0 */ { 0, 0, 0, 0, 0 },
/* U+4fb1 */ { 0, 0, 0, 0, 0 },
/* U+4fb2 */ { 0, 0, 0, 0, 0 },
/* U+4fb3 */ { 0, 0, 0, 0, 0 },
/* U+4fb4 */ { 0, 0, 0, 0, 0 },
/* U+4fb5 */ { 0, 0, 0, 0, 0 },
/* U+4fb6 */ { 0, 0, 0, 0, 0 },
/* U+4fb7 */ { 0, 0, 0, 0, 0 },
/* U+4fb8 */ { 0, 0, 0, 0, 0 },
/* U+4fb9 */ { 0, 0, 0, 0, 0 },
/* U+4fba */ { 0, 0, 0, 0, 0 },
/* U+4fbb */ { 0, 0, 0, 0, 0 },
/* U+4fbc */ { 0, 0, 0, 0, 0 },
/* U+4fbd */ { 0, 0, 0, 0, 0 },
/* U+4fbe */ { 0, 0, 0, 0, 0 },
/* U+4fbf */ { 0, 0, 0, 0, 0 },
/* U+4fc0 */ { 0, 0, 0, 0, 0 },
/* U+4fc1 */ { 0, 0, 0, 0, 0 },
/* U+4fc2 */ { 0, 0, 0, 0, 0 },
/* U+4fc3 */ { 0, 0, 0, 0, 0 },
/* U+4fc4 */ { 0, 0, 0, 0, 0 },
/* U+4fc5 */ { 0, 0, 0, 0, 0 },
/* U+4fc6 */ { 0, 0, 0, 0, 0 },
/* U+4fc7 */ { 0, 0, 0, 0, 0 },
/* U+4fc8 */ { 0, 0, 0, 0, 0 },
/* U+4fc9 */ { 0, 0, 0, 0, 0 },
/* U+4fca */ { 0, 0, 0, 0, 0 },
/* U+4fcb */ { 0, 0, 0, 0, 0 },
/* U+4fcc */ { 0, 0, 0, 0, 0 },
/* U+4fcd */ { 0, 0, 0, 0, 0 },
/* U+4fce */ { 0, 0, 0, 0, 0 },
/* U+4fcf */ { 0, 0, 0, 0, 0 },
/* U+4fd0 */ { 0, 0, 0, 0, 0 },
/* U+4fd1 */ { 0, 0, 0, 0, 0 },
/* U+4fd2 */ { 0, 0, 0, 0, 0 },
/* U+4fd3 */ { 0, 0, 0, 0, 0 },
/* U+4fd4 */ { 0, 0, 0, 0, 0 },
/* U+4fd5 */ { 0, 0, 0, 0, 0 },
/* U+4fd6 */ { 0, 0, 0, 0, 0 },
/* U+4fd7 */ { 0, 0, 0, 0, 0 },
/* U+4fd8 */ { 0, 0, 0, 0, 0 },
/* U+4fd9 */ { 0, 0, 0, 0, 0 },
/* U+4fda */ { 0, 0, 0, 0, 0 },
/* U+4fdb */ { 0, 0, 0, 0, 0 },
/* U+4fdc */ { 0, 0, 0, 0, 0 },
/* U+4fdd */ { 0, 0, 0, 0, 0 },
/* U+4fde */ { 0, 0, 0, 0, 0 },
/* U+4fdf */ { 0, 0, 0, 0, 0 },
/* U+4fe0 */ { 0, 0, 0, 0, 0 },
/* U+4fe1 */ { 0, 0, 0, 0, 0 },
/* U+4fe2 */ { 0, 0, 0, 0, 0 },
/* U+4fe3 */ { 0, 0, 0, 0, 0 },
/* U+4fe4 */ { 0, 0, 0, 0, 0 },
/* U+4fe5 */ { 0, 0, 0, 0, 0 },
/* U+4fe6 */ { 0, 0, 0, 0, 0 },
/* U+4fe7 */ { 0, 0, 0, 0, 0 },
/* U+4fe8 */ { 0, 0, 0, 0, 0 },
/* U+4fe9 */ { 0, 0, 0, 0, 0 },
/* U+4fea */ { 0, 0, 0, 0, 0 },
/* U+4feb */ { 0, 0, 0, 0, 0 },
/* U+4fec */ { 0, 0, 0, 0, 0 },
/* U+4fed */ { 0, 0, 0, 0, 0 },
/* U+4fee */ { 0, 0, 0, 0, 0 },
/* U+4fef */ { 0, 0, 0, 0, 0 },
/* U+4ff0 */ { 0, 0, 0, 0, 0 },
/* U+4ff1 */ { 0, 0, 0, 0, 0 },
/* U+4ff2 */ { 0, 0, 0, 0, 0 },
/* U+4ff3 */ { 0, 0, 0, 0, 0 },
/* U+4ff4 */ { 0, 0, 0, 0, 0 },
/* U+4ff5 */ { 0, 0, 0, 0, 0 },
/* U+4ff6 */ { 0, 0, 0, 0, 0 },
/* U+4ff7 */ { 0, 0, 0, 0, 0 },
/* U+4ff8 */ { 0, 0, 0, 0, 0 },
/* U+4ff9 */ { 0, 0, 0, 0, 0 },
/* U+4ffa */ { 0, 0, 0, 0, 0 },
/* U+4ffb */ { 0, 0, 0, 0, 0 },
/* U+4ffc */ { 0, 0, 0, 0, 0 },
/* U+4ffd */ { 0, 0, 0, 0, 0 },
/* U+4ffe */ { 0, 0, 0, 0, 0 },
/* U+4fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_5[4096] = {
    
/* U+5000 */ { 0, 0, 0, 0, 0 },
/* U+5001 */ { 0, 0, 0, 0, 0 },
/* U+5002 */ { 0, 0, 0, 0, 0 },
/* U+5003 */ { 0, 0, 0, 0, 0 },
/* U+5004 */ { 0, 0, 0, 0, 0 },
/* U+5005 */ { 0, 0, 0, 0, 0 },
/* U+5006 */ { 0, 0, 0, 0, 0 },
/* U+5007 */ { 0, 0, 0, 0, 0 },
/* U+5008 */ { 0, 0, 0, 0, 0 },
/* U+5009 */ { 0, 0, 0, 0, 0 },
/* U+500a */ { 0, 0, 0, 0, 0 },
/* U+500b */ { 0, 0, 0, 0, 0 },
/* U+500c */ { 0, 0, 0, 0, 0 },
/* U+500d */ { 0, 0, 0, 0, 0 },
/* U+500e */ { 0, 0, 0, 0, 0 },
/* U+500f */ { 0, 0, 0, 0, 0 },
/* U+5010 */ { 0, 0, 0, 0, 0 },
/* U+5011 */ { 0, 0, 0, 0, 0 },
/* U+5012 */ { 0, 0, 0, 0, 0 },
/* U+5013 */ { 0, 0, 0, 0, 0 },
/* U+5014 */ { 0, 0, 0, 0, 0 },
/* U+5015 */ { 0, 0, 0, 0, 0 },
/* U+5016 */ { 0, 0, 0, 0, 0 },
/* U+5017 */ { 0, 0, 0, 0, 0 },
/* U+5018 */ { 0, 0, 0, 0, 0 },
/* U+5019 */ { 0, 0, 0, 0, 0 },
/* U+501a */ { 0, 0, 0, 0, 0 },
/* U+501b */ { 0, 0, 0, 0, 0 },
/* U+501c */ { 0, 0, 0, 0, 0 },
/* U+501d */ { 0, 0, 0, 0, 0 },
/* U+501e */ { 0, 0, 0, 0, 0 },
/* U+501f */ { 0, 0, 0, 0, 0 },
/* U+5020 */ { 0, 0, 0, 0, 0 },
/* U+5021 */ { 0, 0, 0, 0, 0 },
/* U+5022 */ { 0, 0, 0, 0, 0 },
/* U+5023 */ { 0, 0, 0, 0, 0 },
/* U+5024 */ { 0, 0, 0, 0, 0 },
/* U+5025 */ { 0, 0, 0, 0, 0 },
/* U+5026 */ { 0, 0, 0, 0, 0 },
/* U+5027 */ { 0, 0, 0, 0, 0 },
/* U+5028 */ { 0, 0, 0, 0, 0 },
/* U+5029 */ { 0, 0, 0, 0, 0 },
/* U+502a */ { 0, 0, 0, 0, 0 },
/* U+502b */ { 0, 0, 0, 0, 0 },
/* U+502c */ { 0, 0, 0, 0, 0 },
/* U+502d */ { 0, 0, 0, 0, 0 },
/* U+502e */ { 0, 0, 0, 0, 0 },
/* U+502f */ { 0, 0, 0, 0, 0 },
/* U+5030 */ { 0, 0, 0, 0, 0 },
/* U+5031 */ { 0, 0, 0, 0, 0 },
/* U+5032 */ { 0, 0, 0, 0, 0 },
/* U+5033 */ { 0, 0, 0, 0, 0 },
/* U+5034 */ { 0, 0, 0, 0, 0 },
/* U+5035 */ { 0, 0, 0, 0, 0 },
/* U+5036 */ { 0, 0, 0, 0, 0 },
/* U+5037 */ { 0, 0, 0, 0, 0 },
/* U+5038 */ { 0, 0, 0, 0, 0 },
/* U+5039 */ { 0, 0, 0, 0, 0 },
/* U+503a */ { 0, 0, 0, 0, 0 },
/* U+503b */ { 0, 0, 0, 0, 0 },
/* U+503c */ { 0, 0, 0, 0, 0 },
/* U+503d */ { 0, 0, 0, 0, 0 },
/* U+503e */ { 0, 0, 0, 0, 0 },
/* U+503f */ { 0, 0, 0, 0, 0 },
/* U+5040 */ { 0, 0, 0, 0, 0 },
/* U+5041 */ { 0, 0, 0, 0, 0 },
/* U+5042 */ { 0, 0, 0, 0, 0 },
/* U+5043 */ { 0, 0, 0, 0, 0 },
/* U+5044 */ { 0, 0, 0, 0, 0 },
/* U+5045 */ { 0, 0, 0, 0, 0 },
/* U+5046 */ { 0, 0, 0, 0, 0 },
/* U+5047 */ { 0, 0, 0, 0, 0 },
/* U+5048 */ { 0, 0, 0, 0, 0 },
/* U+5049 */ { 0, 0, 0, 0, 0 },
/* U+504a */ { 0, 0, 0, 0, 0 },
/* U+504b */ { 0, 0, 0, 0, 0 },
/* U+504c */ { 0, 0, 0, 0, 0 },
/* U+504d */ { 0, 0, 0, 0, 0 },
/* U+504e */ { 0, 0, 0, 0, 0 },
/* U+504f */ { 0, 0, 0, 0, 0 },
/* U+5050 */ { 0, 0, 0, 0, 0 },
/* U+5051 */ { 0, 0, 0, 0, 0 },
/* U+5052 */ { 0, 0, 0, 0, 0 },
/* U+5053 */ { 0, 0, 0, 0, 0 },
/* U+5054 */ { 0, 0, 0, 0, 0 },
/* U+5055 */ { 0, 0, 0, 0, 0 },
/* U+5056 */ { 0, 0, 0, 0, 0 },
/* U+5057 */ { 0, 0, 0, 0, 0 },
/* U+5058 */ { 0, 0, 0, 0, 0 },
/* U+5059 */ { 0, 0, 0, 0, 0 },
/* U+505a */ { 0, 0, 0, 0, 0 },
/* U+505b */ { 0, 0, 0, 0, 0 },
/* U+505c */ { 0, 0, 0, 0, 0 },
/* U+505d */ { 0, 0, 0, 0, 0 },
/* U+505e */ { 0, 0, 0, 0, 0 },
/* U+505f */ { 0, 0, 0, 0, 0 },
/* U+5060 */ { 0, 0, 0, 0, 0 },
/* U+5061 */ { 0, 0, 0, 0, 0 },
/* U+5062 */ { 0, 0, 0, 0, 0 },
/* U+5063 */ { 0, 0, 0, 0, 0 },
/* U+5064 */ { 0, 0, 0, 0, 0 },
/* U+5065 */ { 0, 0, 0, 0, 0 },
/* U+5066 */ { 0, 0, 0, 0, 0 },
/* U+5067 */ { 0, 0, 0, 0, 0 },
/* U+5068 */ { 0, 0, 0, 0, 0 },
/* U+5069 */ { 0, 0, 0, 0, 0 },
/* U+506a */ { 0, 0, 0, 0, 0 },
/* U+506b */ { 0, 0, 0, 0, 0 },
/* U+506c */ { 0, 0, 0, 0, 0 },
/* U+506d */ { 0, 0, 0, 0, 0 },
/* U+506e */ { 0, 0, 0, 0, 0 },
/* U+506f */ { 0, 0, 0, 0, 0 },
/* U+5070 */ { 0, 0, 0, 0, 0 },
/* U+5071 */ { 0, 0, 0, 0, 0 },
/* U+5072 */ { 0, 0, 0, 0, 0 },
/* U+5073 */ { 0, 0, 0, 0, 0 },
/* U+5074 */ { 0, 0, 0, 0, 0 },
/* U+5075 */ { 0, 0, 0, 0, 0 },
/* U+5076 */ { 0, 0, 0, 0, 0 },
/* U+5077 */ { 0, 0, 0, 0, 0 },
/* U+5078 */ { 0, 0, 0, 0, 0 },
/* U+5079 */ { 0, 0, 0, 0, 0 },
/* U+507a */ { 0, 0, 0, 0, 0 },
/* U+507b */ { 0, 0, 0, 0, 0 },
/* U+507c */ { 0, 0, 0, 0, 0 },
/* U+507d */ { 0, 0, 0, 0, 0 },
/* U+507e */ { 0, 0, 0, 0, 0 },
/* U+507f */ { 0, 0, 0, 0, 0 },
/* U+5080 */ { 0, 0, 0, 0, 0 },
/* U+5081 */ { 0, 0, 0, 0, 0 },
/* U+5082 */ { 0, 0, 0, 0, 0 },
/* U+5083 */ { 0, 0, 0, 0, 0 },
/* U+5084 */ { 0, 0, 0, 0, 0 },
/* U+5085 */ { 0, 0, 0, 0, 0 },
/* U+5086 */ { 0, 0, 0, 0, 0 },
/* U+5087 */ { 0, 0, 0, 0, 0 },
/* U+5088 */ { 0, 0, 0, 0, 0 },
/* U+5089 */ { 0, 0, 0, 0, 0 },
/* U+508a */ { 0, 0, 0, 0, 0 },
/* U+508b */ { 0, 0, 0, 0, 0 },
/* U+508c */ { 0, 0, 0, 0, 0 },
/* U+508d */ { 0, 0, 0, 0, 0 },
/* U+508e */ { 0, 0, 0, 0, 0 },
/* U+508f */ { 0, 0, 0, 0, 0 },
/* U+5090 */ { 0, 0, 0, 0, 0 },
/* U+5091 */ { 0, 0, 0, 0, 0 },
/* U+5092 */ { 0, 0, 0, 0, 0 },
/* U+5093 */ { 0, 0, 0, 0, 0 },
/* U+5094 */ { 0, 0, 0, 0, 0 },
/* U+5095 */ { 0, 0, 0, 0, 0 },
/* U+5096 */ { 0, 0, 0, 0, 0 },
/* U+5097 */ { 0, 0, 0, 0, 0 },
/* U+5098 */ { 0, 0, 0, 0, 0 },
/* U+5099 */ { 0, 0, 0, 0, 0 },
/* U+509a */ { 0, 0, 0, 0, 0 },
/* U+509b */ { 0, 0, 0, 0, 0 },
/* U+509c */ { 0, 0, 0, 0, 0 },
/* U+509d */ { 0, 0, 0, 0, 0 },
/* U+509e */ { 0, 0, 0, 0, 0 },
/* U+509f */ { 0, 0, 0, 0, 0 },
/* U+50a0 */ { 0, 0, 0, 0, 0 },
/* U+50a1 */ { 0, 0, 0, 0, 0 },
/* U+50a2 */ { 0, 0, 0, 0, 0 },
/* U+50a3 */ { 0, 0, 0, 0, 0 },
/* U+50a4 */ { 0, 0, 0, 0, 0 },
/* U+50a5 */ { 0, 0, 0, 0, 0 },
/* U+50a6 */ { 0, 0, 0, 0, 0 },
/* U+50a7 */ { 0, 0, 0, 0, 0 },
/* U+50a8 */ { 0, 0, 0, 0, 0 },
/* U+50a9 */ { 0, 0, 0, 0, 0 },
/* U+50aa */ { 0, 0, 0, 0, 0 },
/* U+50ab */ { 0, 0, 0, 0, 0 },
/* U+50ac */ { 0, 0, 0, 0, 0 },
/* U+50ad */ { 0, 0, 0, 0, 0 },
/* U+50ae */ { 0, 0, 0, 0, 0 },
/* U+50af */ { 0, 0, 0, 0, 0 },
/* U+50b0 */ { 0, 0, 0, 0, 0 },
/* U+50b1 */ { 0, 0, 0, 0, 0 },
/* U+50b2 */ { 0, 0, 0, 0, 0 },
/* U+50b3 */ { 0, 0, 0, 0, 0 },
/* U+50b4 */ { 0, 0, 0, 0, 0 },
/* U+50b5 */ { 0, 0, 0, 0, 0 },
/* U+50b6 */ { 0, 0, 0, 0, 0 },
/* U+50b7 */ { 0, 0, 0, 0, 0 },
/* U+50b8 */ { 0, 0, 0, 0, 0 },
/* U+50b9 */ { 0, 0, 0, 0, 0 },
/* U+50ba */ { 0, 0, 0, 0, 0 },
/* U+50bb */ { 0, 0, 0, 0, 0 },
/* U+50bc */ { 0, 0, 0, 0, 0 },
/* U+50bd */ { 0, 0, 0, 0, 0 },
/* U+50be */ { 0, 0, 0, 0, 0 },
/* U+50bf */ { 0, 0, 0, 0, 0 },
/* U+50c0 */ { 0, 0, 0, 0, 0 },
/* U+50c1 */ { 0, 0, 0, 0, 0 },
/* U+50c2 */ { 0, 0, 0, 0, 0 },
/* U+50c3 */ { 0, 0, 0, 0, 0 },
/* U+50c4 */ { 0, 0, 0, 0, 0 },
/* U+50c5 */ { 0, 0, 0, 0, 0 },
/* U+50c6 */ { 0, 0, 0, 0, 0 },
/* U+50c7 */ { 0, 0, 0, 0, 0 },
/* U+50c8 */ { 0, 0, 0, 0, 0 },
/* U+50c9 */ { 0, 0, 0, 0, 0 },
/* U+50ca */ { 0, 0, 0, 0, 0 },
/* U+50cb */ { 0, 0, 0, 0, 0 },
/* U+50cc */ { 0, 0, 0, 0, 0 },
/* U+50cd */ { 0, 0, 0, 0, 0 },
/* U+50ce */ { 0, 0, 0, 0, 0 },
/* U+50cf */ { 0, 0, 0, 0, 0 },
/* U+50d0 */ { 0, 0, 0, 0, 0 },
/* U+50d1 */ { 0, 0, 0, 0, 0 },
/* U+50d2 */ { 0, 0, 0, 0, 0 },
/* U+50d3 */ { 0, 0, 0, 0, 0 },
/* U+50d4 */ { 0, 0, 0, 0, 0 },
/* U+50d5 */ { 0, 0, 0, 0, 0 },
/* U+50d6 */ { 0, 0, 0, 0, 0 },
/* U+50d7 */ { 0, 0, 0, 0, 0 },
/* U+50d8 */ { 0, 0, 0, 0, 0 },
/* U+50d9 */ { 0, 0, 0, 0, 0 },
/* U+50da */ { 0, 0, 0, 0, 0 },
/* U+50db */ { 0, 0, 0, 0, 0 },
/* U+50dc */ { 0, 0, 0, 0, 0 },
/* U+50dd */ { 0, 0, 0, 0, 0 },
/* U+50de */ { 0, 0, 0, 0, 0 },
/* U+50df */ { 0, 0, 0, 0, 0 },
/* U+50e0 */ { 0, 0, 0, 0, 0 },
/* U+50e1 */ { 0, 0, 0, 0, 0 },
/* U+50e2 */ { 0, 0, 0, 0, 0 },
/* U+50e3 */ { 0, 0, 0, 0, 0 },
/* U+50e4 */ { 0, 0, 0, 0, 0 },
/* U+50e5 */ { 0, 0, 0, 0, 0 },
/* U+50e6 */ { 0, 0, 0, 0, 0 },
/* U+50e7 */ { 0, 0, 0, 0, 0 },
/* U+50e8 */ { 0, 0, 0, 0, 0 },
/* U+50e9 */ { 0, 0, 0, 0, 0 },
/* U+50ea */ { 0, 0, 0, 0, 0 },
/* U+50eb */ { 0, 0, 0, 0, 0 },
/* U+50ec */ { 0, 0, 0, 0, 0 },
/* U+50ed */ { 0, 0, 0, 0, 0 },
/* U+50ee */ { 0, 0, 0, 0, 0 },
/* U+50ef */ { 0, 0, 0, 0, 0 },
/* U+50f0 */ { 0, 0, 0, 0, 0 },
/* U+50f1 */ { 0, 0, 0, 0, 0 },
/* U+50f2 */ { 0, 0, 0, 0, 0 },
/* U+50f3 */ { 0, 0, 0, 0, 0 },
/* U+50f4 */ { 0, 0, 0, 0, 0 },
/* U+50f5 */ { 0, 0, 0, 0, 0 },
/* U+50f6 */ { 0, 0, 0, 0, 0 },
/* U+50f7 */ { 0, 0, 0, 0, 0 },
/* U+50f8 */ { 0, 0, 0, 0, 0 },
/* U+50f9 */ { 0, 0, 0, 0, 0 },
/* U+50fa */ { 0, 0, 0, 0, 0 },
/* U+50fb */ { 0, 0, 0, 0, 0 },
/* U+50fc */ { 0, 0, 0, 0, 0 },
/* U+50fd */ { 0, 0, 0, 0, 0 },
/* U+50fe */ { 0, 0, 0, 0, 0 },
/* U+50ff */ { 0, 0, 0, 0, 0 },
/* U+5100 */ { 0, 0, 0, 0, 0 },
/* U+5101 */ { 0, 0, 0, 0, 0 },
/* U+5102 */ { 0, 0, 0, 0, 0 },
/* U+5103 */ { 0, 0, 0, 0, 0 },
/* U+5104 */ { 0, 0, 0, 0, 0 },
/* U+5105 */ { 0, 0, 0, 0, 0 },
/* U+5106 */ { 0, 0, 0, 0, 0 },
/* U+5107 */ { 0, 0, 0, 0, 0 },
/* U+5108 */ { 0, 0, 0, 0, 0 },
/* U+5109 */ { 0, 0, 0, 0, 0 },
/* U+510a */ { 0, 0, 0, 0, 0 },
/* U+510b */ { 0, 0, 0, 0, 0 },
/* U+510c */ { 0, 0, 0, 0, 0 },
/* U+510d */ { 0, 0, 0, 0, 0 },
/* U+510e */ { 0, 0, 0, 0, 0 },
/* U+510f */ { 0, 0, 0, 0, 0 },
/* U+5110 */ { 0, 0, 0, 0, 0 },
/* U+5111 */ { 0, 0, 0, 0, 0 },
/* U+5112 */ { 0, 0, 0, 0, 0 },
/* U+5113 */ { 0, 0, 0, 0, 0 },
/* U+5114 */ { 0, 0, 0, 0, 0 },
/* U+5115 */ { 0, 0, 0, 0, 0 },
/* U+5116 */ { 0, 0, 0, 0, 0 },
/* U+5117 */ { 0, 0, 0, 0, 0 },
/* U+5118 */ { 0, 0, 0, 0, 0 },
/* U+5119 */ { 0, 0, 0, 0, 0 },
/* U+511a */ { 0, 0, 0, 0, 0 },
/* U+511b */ { 0, 0, 0, 0, 0 },
/* U+511c */ { 0, 0, 0, 0, 0 },
/* U+511d */ { 0, 0, 0, 0, 0 },
/* U+511e */ { 0, 0, 0, 0, 0 },
/* U+511f */ { 0, 0, 0, 0, 0 },
/* U+5120 */ { 0, 0, 0, 0, 0 },
/* U+5121 */ { 0, 0, 0, 0, 0 },
/* U+5122 */ { 0, 0, 0, 0, 0 },
/* U+5123 */ { 0, 0, 0, 0, 0 },
/* U+5124 */ { 0, 0, 0, 0, 0 },
/* U+5125 */ { 0, 0, 0, 0, 0 },
/* U+5126 */ { 0, 0, 0, 0, 0 },
/* U+5127 */ { 0, 0, 0, 0, 0 },
/* U+5128 */ { 0, 0, 0, 0, 0 },
/* U+5129 */ { 0, 0, 0, 0, 0 },
/* U+512a */ { 0, 0, 0, 0, 0 },
/* U+512b */ { 0, 0, 0, 0, 0 },
/* U+512c */ { 0, 0, 0, 0, 0 },
/* U+512d */ { 0, 0, 0, 0, 0 },
/* U+512e */ { 0, 0, 0, 0, 0 },
/* U+512f */ { 0, 0, 0, 0, 0 },
/* U+5130 */ { 0, 0, 0, 0, 0 },
/* U+5131 */ { 0, 0, 0, 0, 0 },
/* U+5132 */ { 0, 0, 0, 0, 0 },
/* U+5133 */ { 0, 0, 0, 0, 0 },
/* U+5134 */ { 0, 0, 0, 0, 0 },
/* U+5135 */ { 0, 0, 0, 0, 0 },
/* U+5136 */ { 0, 0, 0, 0, 0 },
/* U+5137 */ { 0, 0, 0, 0, 0 },
/* U+5138 */ { 0, 0, 0, 0, 0 },
/* U+5139 */ { 0, 0, 0, 0, 0 },
/* U+513a */ { 0, 0, 0, 0, 0 },
/* U+513b */ { 0, 0, 0, 0, 0 },
/* U+513c */ { 0, 0, 0, 0, 0 },
/* U+513d */ { 0, 0, 0, 0, 0 },
/* U+513e */ { 0, 0, 0, 0, 0 },
/* U+513f */ { 0, 0, 0, 0, 0 },
/* U+5140 */ { 0, 0, 0, 0, 0 },
/* U+5141 */ { 0, 0, 0, 0, 0 },
/* U+5142 */ { 0, 0, 0, 0, 0 },
/* U+5143 */ { 0, 0, 0, 0, 0 },
/* U+5144 */ { 0, 0, 0, 0, 0 },
/* U+5145 */ { 0, 0, 0, 0, 0 },
/* U+5146 */ { 0, 0, 0, 0, 0 },
/* U+5147 */ { 0, 0, 0, 0, 0 },
/* U+5148 */ { 0, 0, 0, 0, 0 },
/* U+5149 */ { 0, 0, 0, 0, 0 },
/* U+514a */ { 0, 0, 0, 0, 0 },
/* U+514b */ { 0, 0, 0, 0, 0 },
/* U+514c */ { 0, 0, 0, 0, 0 },
/* U+514d */ { 0, 0, 0, 0, 0 },
/* U+514e */ { 0, 0, 0, 0, 0 },
/* U+514f */ { 0, 0, 0, 0, 0 },
/* U+5150 */ { 0, 0, 0, 0, 0 },
/* U+5151 */ { 0, 0, 0, 0, 0 },
/* U+5152 */ { 0, 0, 0, 0, 0 },
/* U+5153 */ { 0, 0, 0, 0, 0 },
/* U+5154 */ { 0, 0, 0, 0, 0 },
/* U+5155 */ { 0, 0, 0, 0, 0 },
/* U+5156 */ { 0, 0, 0, 0, 0 },
/* U+5157 */ { 0, 0, 0, 0, 0 },
/* U+5158 */ { 0, 0, 0, 0, 0 },
/* U+5159 */ { 0, 0, 0, 0, 0 },
/* U+515a */ { 0, 0, 0, 0, 0 },
/* U+515b */ { 0, 0, 0, 0, 0 },
/* U+515c */ { 0, 0, 0, 0, 0 },
/* U+515d */ { 0, 0, 0, 0, 0 },
/* U+515e */ { 0, 0, 0, 0, 0 },
/* U+515f */ { 0, 0, 0, 0, 0 },
/* U+5160 */ { 0, 0, 0, 0, 0 },
/* U+5161 */ { 0, 0, 0, 0, 0 },
/* U+5162 */ { 0, 0, 0, 0, 0 },
/* U+5163 */ { 0, 0, 0, 0, 0 },
/* U+5164 */ { 0, 0, 0, 0, 0 },
/* U+5165 */ { 0, 0, 0, 0, 0 },
/* U+5166 */ { 0, 0, 0, 0, 0 },
/* U+5167 */ { 0, 0, 0, 0, 0 },
/* U+5168 */ { 0, 0, 0, 0, 0 },
/* U+5169 */ { 0, 0, 0, 0, 0 },
/* U+516a */ { 0, 0, 0, 0, 0 },
/* U+516b */ { 0, 0, 0, 0, 0 },
/* U+516c */ { 0, 0, 0, 0, 0 },
/* U+516d */ { 0, 0, 0, 0, 0 },
/* U+516e */ { 0, 0, 0, 0, 0 },
/* U+516f */ { 0, 0, 0, 0, 0 },
/* U+5170 */ { 0, 0, 0, 0, 0 },
/* U+5171 */ { 0, 0, 0, 0, 0 },
/* U+5172 */ { 0, 0, 0, 0, 0 },
/* U+5173 */ { 0, 0, 0, 0, 0 },
/* U+5174 */ { 0, 0, 0, 0, 0 },
/* U+5175 */ { 0, 0, 0, 0, 0 },
/* U+5176 */ { 0, 0, 0, 0, 0 },
/* U+5177 */ { 0, 0, 0, 0, 0 },
/* U+5178 */ { 0, 0, 0, 0, 0 },
/* U+5179 */ { 0, 0, 0, 0, 0 },
/* U+517a */ { 0, 0, 0, 0, 0 },
/* U+517b */ { 0, 0, 0, 0, 0 },
/* U+517c */ { 0, 0, 0, 0, 0 },
/* U+517d */ { 0, 0, 0, 0, 0 },
/* U+517e */ { 0, 0, 0, 0, 0 },
/* U+517f */ { 0, 0, 0, 0, 0 },
/* U+5180 */ { 0, 0, 0, 0, 0 },
/* U+5181 */ { 0, 0, 0, 0, 0 },
/* U+5182 */ { 0, 0, 0, 0, 0 },
/* U+5183 */ { 0, 0, 0, 0, 0 },
/* U+5184 */ { 0, 0, 0, 0, 0 },
/* U+5185 */ { 0, 0, 0, 0, 0 },
/* U+5186 */ { 0, 0, 0, 0, 0 },
/* U+5187 */ { 0, 0, 0, 0, 0 },
/* U+5188 */ { 0, 0, 0, 0, 0 },
/* U+5189 */ { 0, 0, 0, 0, 0 },
/* U+518a */ { 0, 0, 0, 0, 0 },
/* U+518b */ { 0, 0, 0, 0, 0 },
/* U+518c */ { 0, 0, 0, 0, 0 },
/* U+518d */ { 0, 0, 0, 0, 0 },
/* U+518e */ { 0, 0, 0, 0, 0 },
/* U+518f */ { 0, 0, 0, 0, 0 },
/* U+5190 */ { 0, 0, 0, 0, 0 },
/* U+5191 */ { 0, 0, 0, 0, 0 },
/* U+5192 */ { 0, 0, 0, 0, 0 },
/* U+5193 */ { 0, 0, 0, 0, 0 },
/* U+5194 */ { 0, 0, 0, 0, 0 },
/* U+5195 */ { 0, 0, 0, 0, 0 },
/* U+5196 */ { 0, 0, 0, 0, 0 },
/* U+5197 */ { 0, 0, 0, 0, 0 },
/* U+5198 */ { 0, 0, 0, 0, 0 },
/* U+5199 */ { 0, 0, 0, 0, 0 },
/* U+519a */ { 0, 0, 0, 0, 0 },
/* U+519b */ { 0, 0, 0, 0, 0 },
/* U+519c */ { 0, 0, 0, 0, 0 },
/* U+519d */ { 0, 0, 0, 0, 0 },
/* U+519e */ { 0, 0, 0, 0, 0 },
/* U+519f */ { 0, 0, 0, 0, 0 },
/* U+51a0 */ { 0, 0, 0, 0, 0 },
/* U+51a1 */ { 0, 0, 0, 0, 0 },
/* U+51a2 */ { 0, 0, 0, 0, 0 },
/* U+51a3 */ { 0, 0, 0, 0, 0 },
/* U+51a4 */ { 0, 0, 0, 0, 0 },
/* U+51a5 */ { 0, 0, 0, 0, 0 },
/* U+51a6 */ { 0, 0, 0, 0, 0 },
/* U+51a7 */ { 0, 0, 0, 0, 0 },
/* U+51a8 */ { 0, 0, 0, 0, 0 },
/* U+51a9 */ { 0, 0, 0, 0, 0 },
/* U+51aa */ { 0, 0, 0, 0, 0 },
/* U+51ab */ { 0, 0, 0, 0, 0 },
/* U+51ac */ { 0, 0, 0, 0, 0 },
/* U+51ad */ { 0, 0, 0, 0, 0 },
/* U+51ae */ { 0, 0, 0, 0, 0 },
/* U+51af */ { 0, 0, 0, 0, 0 },
/* U+51b0 */ { 0, 0, 0, 0, 0 },
/* U+51b1 */ { 0, 0, 0, 0, 0 },
/* U+51b2 */ { 0, 0, 0, 0, 0 },
/* U+51b3 */ { 0, 0, 0, 0, 0 },
/* U+51b4 */ { 0, 0, 0, 0, 0 },
/* U+51b5 */ { 0, 0, 0, 0, 0 },
/* U+51b6 */ { 0, 0, 0, 0, 0 },
/* U+51b7 */ { 0, 0, 0, 0, 0 },
/* U+51b8 */ { 0, 0, 0, 0, 0 },
/* U+51b9 */ { 0, 0, 0, 0, 0 },
/* U+51ba */ { 0, 0, 0, 0, 0 },
/* U+51bb */ { 0, 0, 0, 0, 0 },
/* U+51bc */ { 0, 0, 0, 0, 0 },
/* U+51bd */ { 0, 0, 0, 0, 0 },
/* U+51be */ { 0, 0, 0, 0, 0 },
/* U+51bf */ { 0, 0, 0, 0, 0 },
/* U+51c0 */ { 0, 0, 0, 0, 0 },
/* U+51c1 */ { 0, 0, 0, 0, 0 },
/* U+51c2 */ { 0, 0, 0, 0, 0 },
/* U+51c3 */ { 0, 0, 0, 0, 0 },
/* U+51c4 */ { 0, 0, 0, 0, 0 },
/* U+51c5 */ { 0, 0, 0, 0, 0 },
/* U+51c6 */ { 0, 0, 0, 0, 0 },
/* U+51c7 */ { 0, 0, 0, 0, 0 },
/* U+51c8 */ { 0, 0, 0, 0, 0 },
/* U+51c9 */ { 0, 0, 0, 0, 0 },
/* U+51ca */ { 0, 0, 0, 0, 0 },
/* U+51cb */ { 0, 0, 0, 0, 0 },
/* U+51cc */ { 0, 0, 0, 0, 0 },
/* U+51cd */ { 0, 0, 0, 0, 0 },
/* U+51ce */ { 0, 0, 0, 0, 0 },
/* U+51cf */ { 0, 0, 0, 0, 0 },
/* U+51d0 */ { 0, 0, 0, 0, 0 },
/* U+51d1 */ { 0, 0, 0, 0, 0 },
/* U+51d2 */ { 0, 0, 0, 0, 0 },
/* U+51d3 */ { 0, 0, 0, 0, 0 },
/* U+51d4 */ { 0, 0, 0, 0, 0 },
/* U+51d5 */ { 0, 0, 0, 0, 0 },
/* U+51d6 */ { 0, 0, 0, 0, 0 },
/* U+51d7 */ { 0, 0, 0, 0, 0 },
/* U+51d8 */ { 0, 0, 0, 0, 0 },
/* U+51d9 */ { 0, 0, 0, 0, 0 },
/* U+51da */ { 0, 0, 0, 0, 0 },
/* U+51db */ { 0, 0, 0, 0, 0 },
/* U+51dc */ { 0, 0, 0, 0, 0 },
/* U+51dd */ { 0, 0, 0, 0, 0 },
/* U+51de */ { 0, 0, 0, 0, 0 },
/* U+51df */ { 0, 0, 0, 0, 0 },
/* U+51e0 */ { 0, 0, 0, 0, 0 },
/* U+51e1 */ { 0, 0, 0, 0, 0 },
/* U+51e2 */ { 0, 0, 0, 0, 0 },
/* U+51e3 */ { 0, 0, 0, 0, 0 },
/* U+51e4 */ { 0, 0, 0, 0, 0 },
/* U+51e5 */ { 0, 0, 0, 0, 0 },
/* U+51e6 */ { 0, 0, 0, 0, 0 },
/* U+51e7 */ { 0, 0, 0, 0, 0 },
/* U+51e8 */ { 0, 0, 0, 0, 0 },
/* U+51e9 */ { 0, 0, 0, 0, 0 },
/* U+51ea */ { 0, 0, 0, 0, 0 },
/* U+51eb */ { 0, 0, 0, 0, 0 },
/* U+51ec */ { 0, 0, 0, 0, 0 },
/* U+51ed */ { 0, 0, 0, 0, 0 },
/* U+51ee */ { 0, 0, 0, 0, 0 },
/* U+51ef */ { 0, 0, 0, 0, 0 },
/* U+51f0 */ { 0, 0, 0, 0, 0 },
/* U+51f1 */ { 0, 0, 0, 0, 0 },
/* U+51f2 */ { 0, 0, 0, 0, 0 },
/* U+51f3 */ { 0, 0, 0, 0, 0 },
/* U+51f4 */ { 0, 0, 0, 0, 0 },
/* U+51f5 */ { 0, 0, 0, 0, 0 },
/* U+51f6 */ { 0, 0, 0, 0, 0 },
/* U+51f7 */ { 0, 0, 0, 0, 0 },
/* U+51f8 */ { 0, 0, 0, 0, 0 },
/* U+51f9 */ { 0, 0, 0, 0, 0 },
/* U+51fa */ { 0, 0, 0, 0, 0 },
/* U+51fb */ { 0, 0, 0, 0, 0 },
/* U+51fc */ { 0, 0, 0, 0, 0 },
/* U+51fd */ { 0, 0, 0, 0, 0 },
/* U+51fe */ { 0, 0, 0, 0, 0 },
/* U+51ff */ { 0, 0, 0, 0, 0 },
/* U+5200 */ { 0, 0, 0, 0, 0 },
/* U+5201 */ { 0, 0, 0, 0, 0 },
/* U+5202 */ { 0, 0, 0, 0, 0 },
/* U+5203 */ { 0, 0, 0, 0, 0 },
/* U+5204 */ { 0, 0, 0, 0, 0 },
/* U+5205 */ { 0, 0, 0, 0, 0 },
/* U+5206 */ { 0, 0, 0, 0, 0 },
/* U+5207 */ { 0, 0, 0, 0, 0 },
/* U+5208 */ { 0, 0, 0, 0, 0 },
/* U+5209 */ { 0, 0, 0, 0, 0 },
/* U+520a */ { 0, 0, 0, 0, 0 },
/* U+520b */ { 0, 0, 0, 0, 0 },
/* U+520c */ { 0, 0, 0, 0, 0 },
/* U+520d */ { 0, 0, 0, 0, 0 },
/* U+520e */ { 0, 0, 0, 0, 0 },
/* U+520f */ { 0, 0, 0, 0, 0 },
/* U+5210 */ { 0, 0, 0, 0, 0 },
/* U+5211 */ { 0, 0, 0, 0, 0 },
/* U+5212 */ { 0, 0, 0, 0, 0 },
/* U+5213 */ { 0, 0, 0, 0, 0 },
/* U+5214 */ { 0, 0, 0, 0, 0 },
/* U+5215 */ { 0, 0, 0, 0, 0 },
/* U+5216 */ { 0, 0, 0, 0, 0 },
/* U+5217 */ { 0, 0, 0, 0, 0 },
/* U+5218 */ { 0, 0, 0, 0, 0 },
/* U+5219 */ { 0, 0, 0, 0, 0 },
/* U+521a */ { 0, 0, 0, 0, 0 },
/* U+521b */ { 0, 0, 0, 0, 0 },
/* U+521c */ { 0, 0, 0, 0, 0 },
/* U+521d */ { 0, 0, 0, 0, 0 },
/* U+521e */ { 0, 0, 0, 0, 0 },
/* U+521f */ { 0, 0, 0, 0, 0 },
/* U+5220 */ { 0, 0, 0, 0, 0 },
/* U+5221 */ { 0, 0, 0, 0, 0 },
/* U+5222 */ { 0, 0, 0, 0, 0 },
/* U+5223 */ { 0, 0, 0, 0, 0 },
/* U+5224 */ { 0, 0, 0, 0, 0 },
/* U+5225 */ { 0, 0, 0, 0, 0 },
/* U+5226 */ { 0, 0, 0, 0, 0 },
/* U+5227 */ { 0, 0, 0, 0, 0 },
/* U+5228 */ { 0, 0, 0, 0, 0 },
/* U+5229 */ { 0, 0, 0, 0, 0 },
/* U+522a */ { 0, 0, 0, 0, 0 },
/* U+522b */ { 0, 0, 0, 0, 0 },
/* U+522c */ { 0, 0, 0, 0, 0 },
/* U+522d */ { 0, 0, 0, 0, 0 },
/* U+522e */ { 0, 0, 0, 0, 0 },
/* U+522f */ { 0, 0, 0, 0, 0 },
/* U+5230 */ { 0, 0, 0, 0, 0 },
/* U+5231 */ { 0, 0, 0, 0, 0 },
/* U+5232 */ { 0, 0, 0, 0, 0 },
/* U+5233 */ { 0, 0, 0, 0, 0 },
/* U+5234 */ { 0, 0, 0, 0, 0 },
/* U+5235 */ { 0, 0, 0, 0, 0 },
/* U+5236 */ { 0, 0, 0, 0, 0 },
/* U+5237 */ { 0, 0, 0, 0, 0 },
/* U+5238 */ { 0, 0, 0, 0, 0 },
/* U+5239 */ { 0, 0, 0, 0, 0 },
/* U+523a */ { 0, 0, 0, 0, 0 },
/* U+523b */ { 0, 0, 0, 0, 0 },
/* U+523c */ { 0, 0, 0, 0, 0 },
/* U+523d */ { 0, 0, 0, 0, 0 },
/* U+523e */ { 0, 0, 0, 0, 0 },
/* U+523f */ { 0, 0, 0, 0, 0 },
/* U+5240 */ { 0, 0, 0, 0, 0 },
/* U+5241 */ { 0, 0, 0, 0, 0 },
/* U+5242 */ { 0, 0, 0, 0, 0 },
/* U+5243 */ { 0, 0, 0, 0, 0 },
/* U+5244 */ { 0, 0, 0, 0, 0 },
/* U+5245 */ { 0, 0, 0, 0, 0 },
/* U+5246 */ { 0, 0, 0, 0, 0 },
/* U+5247 */ { 0, 0, 0, 0, 0 },
/* U+5248 */ { 0, 0, 0, 0, 0 },
/* U+5249 */ { 0, 0, 0, 0, 0 },
/* U+524a */ { 0, 0, 0, 0, 0 },
/* U+524b */ { 0, 0, 0, 0, 0 },
/* U+524c */ { 0, 0, 0, 0, 0 },
/* U+524d */ { 0, 0, 0, 0, 0 },
/* U+524e */ { 0, 0, 0, 0, 0 },
/* U+524f */ { 0, 0, 0, 0, 0 },
/* U+5250 */ { 0, 0, 0, 0, 0 },
/* U+5251 */ { 0, 0, 0, 0, 0 },
/* U+5252 */ { 0, 0, 0, 0, 0 },
/* U+5253 */ { 0, 0, 0, 0, 0 },
/* U+5254 */ { 0, 0, 0, 0, 0 },
/* U+5255 */ { 0, 0, 0, 0, 0 },
/* U+5256 */ { 0, 0, 0, 0, 0 },
/* U+5257 */ { 0, 0, 0, 0, 0 },
/* U+5258 */ { 0, 0, 0, 0, 0 },
/* U+5259 */ { 0, 0, 0, 0, 0 },
/* U+525a */ { 0, 0, 0, 0, 0 },
/* U+525b */ { 0, 0, 0, 0, 0 },
/* U+525c */ { 0, 0, 0, 0, 0 },
/* U+525d */ { 0, 0, 0, 0, 0 },
/* U+525e */ { 0, 0, 0, 0, 0 },
/* U+525f */ { 0, 0, 0, 0, 0 },
/* U+5260 */ { 0, 0, 0, 0, 0 },
/* U+5261 */ { 0, 0, 0, 0, 0 },
/* U+5262 */ { 0, 0, 0, 0, 0 },
/* U+5263 */ { 0, 0, 0, 0, 0 },
/* U+5264 */ { 0, 0, 0, 0, 0 },
/* U+5265 */ { 0, 0, 0, 0, 0 },
/* U+5266 */ { 0, 0, 0, 0, 0 },
/* U+5267 */ { 0, 0, 0, 0, 0 },
/* U+5268 */ { 0, 0, 0, 0, 0 },
/* U+5269 */ { 0, 0, 0, 0, 0 },
/* U+526a */ { 0, 0, 0, 0, 0 },
/* U+526b */ { 0, 0, 0, 0, 0 },
/* U+526c */ { 0, 0, 0, 0, 0 },
/* U+526d */ { 0, 0, 0, 0, 0 },
/* U+526e */ { 0, 0, 0, 0, 0 },
/* U+526f */ { 0, 0, 0, 0, 0 },
/* U+5270 */ { 0, 0, 0, 0, 0 },
/* U+5271 */ { 0, 0, 0, 0, 0 },
/* U+5272 */ { 0, 0, 0, 0, 0 },
/* U+5273 */ { 0, 0, 0, 0, 0 },
/* U+5274 */ { 0, 0, 0, 0, 0 },
/* U+5275 */ { 0, 0, 0, 0, 0 },
/* U+5276 */ { 0, 0, 0, 0, 0 },
/* U+5277 */ { 0, 0, 0, 0, 0 },
/* U+5278 */ { 0, 0, 0, 0, 0 },
/* U+5279 */ { 0, 0, 0, 0, 0 },
/* U+527a */ { 0, 0, 0, 0, 0 },
/* U+527b */ { 0, 0, 0, 0, 0 },
/* U+527c */ { 0, 0, 0, 0, 0 },
/* U+527d */ { 0, 0, 0, 0, 0 },
/* U+527e */ { 0, 0, 0, 0, 0 },
/* U+527f */ { 0, 0, 0, 0, 0 },
/* U+5280 */ { 0, 0, 0, 0, 0 },
/* U+5281 */ { 0, 0, 0, 0, 0 },
/* U+5282 */ { 0, 0, 0, 0, 0 },
/* U+5283 */ { 0, 0, 0, 0, 0 },
/* U+5284 */ { 0, 0, 0, 0, 0 },
/* U+5285 */ { 0, 0, 0, 0, 0 },
/* U+5286 */ { 0, 0, 0, 0, 0 },
/* U+5287 */ { 0, 0, 0, 0, 0 },
/* U+5288 */ { 0, 0, 0, 0, 0 },
/* U+5289 */ { 0, 0, 0, 0, 0 },
/* U+528a */ { 0, 0, 0, 0, 0 },
/* U+528b */ { 0, 0, 0, 0, 0 },
/* U+528c */ { 0, 0, 0, 0, 0 },
/* U+528d */ { 0, 0, 0, 0, 0 },
/* U+528e */ { 0, 0, 0, 0, 0 },
/* U+528f */ { 0, 0, 0, 0, 0 },
/* U+5290 */ { 0, 0, 0, 0, 0 },
/* U+5291 */ { 0, 0, 0, 0, 0 },
/* U+5292 */ { 0, 0, 0, 0, 0 },
/* U+5293 */ { 0, 0, 0, 0, 0 },
/* U+5294 */ { 0, 0, 0, 0, 0 },
/* U+5295 */ { 0, 0, 0, 0, 0 },
/* U+5296 */ { 0, 0, 0, 0, 0 },
/* U+5297 */ { 0, 0, 0, 0, 0 },
/* U+5298 */ { 0, 0, 0, 0, 0 },
/* U+5299 */ { 0, 0, 0, 0, 0 },
/* U+529a */ { 0, 0, 0, 0, 0 },
/* U+529b */ { 0, 0, 0, 0, 0 },
/* U+529c */ { 0, 0, 0, 0, 0 },
/* U+529d */ { 0, 0, 0, 0, 0 },
/* U+529e */ { 0, 0, 0, 0, 0 },
/* U+529f */ { 0, 0, 0, 0, 0 },
/* U+52a0 */ { 0, 0, 0, 0, 0 },
/* U+52a1 */ { 0, 0, 0, 0, 0 },
/* U+52a2 */ { 0, 0, 0, 0, 0 },
/* U+52a3 */ { 0, 0, 0, 0, 0 },
/* U+52a4 */ { 0, 0, 0, 0, 0 },
/* U+52a5 */ { 0, 0, 0, 0, 0 },
/* U+52a6 */ { 0, 0, 0, 0, 0 },
/* U+52a7 */ { 0, 0, 0, 0, 0 },
/* U+52a8 */ { 0, 0, 0, 0, 0 },
/* U+52a9 */ { 0, 0, 0, 0, 0 },
/* U+52aa */ { 0, 0, 0, 0, 0 },
/* U+52ab */ { 0, 0, 0, 0, 0 },
/* U+52ac */ { 0, 0, 0, 0, 0 },
/* U+52ad */ { 0, 0, 0, 0, 0 },
/* U+52ae */ { 0, 0, 0, 0, 0 },
/* U+52af */ { 0, 0, 0, 0, 0 },
/* U+52b0 */ { 0, 0, 0, 0, 0 },
/* U+52b1 */ { 0, 0, 0, 0, 0 },
/* U+52b2 */ { 0, 0, 0, 0, 0 },
/* U+52b3 */ { 0, 0, 0, 0, 0 },
/* U+52b4 */ { 0, 0, 0, 0, 0 },
/* U+52b5 */ { 0, 0, 0, 0, 0 },
/* U+52b6 */ { 0, 0, 0, 0, 0 },
/* U+52b7 */ { 0, 0, 0, 0, 0 },
/* U+52b8 */ { 0, 0, 0, 0, 0 },
/* U+52b9 */ { 0, 0, 0, 0, 0 },
/* U+52ba */ { 0, 0, 0, 0, 0 },
/* U+52bb */ { 0, 0, 0, 0, 0 },
/* U+52bc */ { 0, 0, 0, 0, 0 },
/* U+52bd */ { 0, 0, 0, 0, 0 },
/* U+52be */ { 0, 0, 0, 0, 0 },
/* U+52bf */ { 0, 0, 0, 0, 0 },
/* U+52c0 */ { 0, 0, 0, 0, 0 },
/* U+52c1 */ { 0, 0, 0, 0, 0 },
/* U+52c2 */ { 0, 0, 0, 0, 0 },
/* U+52c3 */ { 0, 0, 0, 0, 0 },
/* U+52c4 */ { 0, 0, 0, 0, 0 },
/* U+52c5 */ { 0, 0, 0, 0, 0 },
/* U+52c6 */ { 0, 0, 0, 0, 0 },
/* U+52c7 */ { 0, 0, 0, 0, 0 },
/* U+52c8 */ { 0, 0, 0, 0, 0 },
/* U+52c9 */ { 0, 0, 0, 0, 0 },
/* U+52ca */ { 0, 0, 0, 0, 0 },
/* U+52cb */ { 0, 0, 0, 0, 0 },
/* U+52cc */ { 0, 0, 0, 0, 0 },
/* U+52cd */ { 0, 0, 0, 0, 0 },
/* U+52ce */ { 0, 0, 0, 0, 0 },
/* U+52cf */ { 0, 0, 0, 0, 0 },
/* U+52d0 */ { 0, 0, 0, 0, 0 },
/* U+52d1 */ { 0, 0, 0, 0, 0 },
/* U+52d2 */ { 0, 0, 0, 0, 0 },
/* U+52d3 */ { 0, 0, 0, 0, 0 },
/* U+52d4 */ { 0, 0, 0, 0, 0 },
/* U+52d5 */ { 0, 0, 0, 0, 0 },
/* U+52d6 */ { 0, 0, 0, 0, 0 },
/* U+52d7 */ { 0, 0, 0, 0, 0 },
/* U+52d8 */ { 0, 0, 0, 0, 0 },
/* U+52d9 */ { 0, 0, 0, 0, 0 },
/* U+52da */ { 0, 0, 0, 0, 0 },
/* U+52db */ { 0, 0, 0, 0, 0 },
/* U+52dc */ { 0, 0, 0, 0, 0 },
/* U+52dd */ { 0, 0, 0, 0, 0 },
/* U+52de */ { 0, 0, 0, 0, 0 },
/* U+52df */ { 0, 0, 0, 0, 0 },
/* U+52e0 */ { 0, 0, 0, 0, 0 },
/* U+52e1 */ { 0, 0, 0, 0, 0 },
/* U+52e2 */ { 0, 0, 0, 0, 0 },
/* U+52e3 */ { 0, 0, 0, 0, 0 },
/* U+52e4 */ { 0, 0, 0, 0, 0 },
/* U+52e5 */ { 0, 0, 0, 0, 0 },
/* U+52e6 */ { 0, 0, 0, 0, 0 },
/* U+52e7 */ { 0, 0, 0, 0, 0 },
/* U+52e8 */ { 0, 0, 0, 0, 0 },
/* U+52e9 */ { 0, 0, 0, 0, 0 },
/* U+52ea */ { 0, 0, 0, 0, 0 },
/* U+52eb */ { 0, 0, 0, 0, 0 },
/* U+52ec */ { 0, 0, 0, 0, 0 },
/* U+52ed */ { 0, 0, 0, 0, 0 },
/* U+52ee */ { 0, 0, 0, 0, 0 },
/* U+52ef */ { 0, 0, 0, 0, 0 },
/* U+52f0 */ { 0, 0, 0, 0, 0 },
/* U+52f1 */ { 0, 0, 0, 0, 0 },
/* U+52f2 */ { 0, 0, 0, 0, 0 },
/* U+52f3 */ { 0, 0, 0, 0, 0 },
/* U+52f4 */ { 0, 0, 0, 0, 0 },
/* U+52f5 */ { 0, 0, 0, 0, 0 },
/* U+52f6 */ { 0, 0, 0, 0, 0 },
/* U+52f7 */ { 0, 0, 0, 0, 0 },
/* U+52f8 */ { 0, 0, 0, 0, 0 },
/* U+52f9 */ { 0, 0, 0, 0, 0 },
/* U+52fa */ { 0, 0, 0, 0, 0 },
/* U+52fb */ { 0, 0, 0, 0, 0 },
/* U+52fc */ { 0, 0, 0, 0, 0 },
/* U+52fd */ { 0, 0, 0, 0, 0 },
/* U+52fe */ { 0, 0, 0, 0, 0 },
/* U+52ff */ { 0, 0, 0, 0, 0 },
/* U+5300 */ { 0, 0, 0, 0, 0 },
/* U+5301 */ { 0, 0, 0, 0, 0 },
/* U+5302 */ { 0, 0, 0, 0, 0 },
/* U+5303 */ { 0, 0, 0, 0, 0 },
/* U+5304 */ { 0, 0, 0, 0, 0 },
/* U+5305 */ { 0, 0, 0, 0, 0 },
/* U+5306 */ { 0, 0, 0, 0, 0 },
/* U+5307 */ { 0, 0, 0, 0, 0 },
/* U+5308 */ { 0, 0, 0, 0, 0 },
/* U+5309 */ { 0, 0, 0, 0, 0 },
/* U+530a */ { 0, 0, 0, 0, 0 },
/* U+530b */ { 0, 0, 0, 0, 0 },
/* U+530c */ { 0, 0, 0, 0, 0 },
/* U+530d */ { 0, 0, 0, 0, 0 },
/* U+530e */ { 0, 0, 0, 0, 0 },
/* U+530f */ { 0, 0, 0, 0, 0 },
/* U+5310 */ { 0, 0, 0, 0, 0 },
/* U+5311 */ { 0, 0, 0, 0, 0 },
/* U+5312 */ { 0, 0, 0, 0, 0 },
/* U+5313 */ { 0, 0, 0, 0, 0 },
/* U+5314 */ { 0, 0, 0, 0, 0 },
/* U+5315 */ { 0, 0, 0, 0, 0 },
/* U+5316 */ { 0, 0, 0, 0, 0 },
/* U+5317 */ { 0, 0, 0, 0, 0 },
/* U+5318 */ { 0, 0, 0, 0, 0 },
/* U+5319 */ { 0, 0, 0, 0, 0 },
/* U+531a */ { 0, 0, 0, 0, 0 },
/* U+531b */ { 0, 0, 0, 0, 0 },
/* U+531c */ { 0, 0, 0, 0, 0 },
/* U+531d */ { 0, 0, 0, 0, 0 },
/* U+531e */ { 0, 0, 0, 0, 0 },
/* U+531f */ { 0, 0, 0, 0, 0 },
/* U+5320 */ { 0, 0, 0, 0, 0 },
/* U+5321 */ { 0, 0, 0, 0, 0 },
/* U+5322 */ { 0, 0, 0, 0, 0 },
/* U+5323 */ { 0, 0, 0, 0, 0 },
/* U+5324 */ { 0, 0, 0, 0, 0 },
/* U+5325 */ { 0, 0, 0, 0, 0 },
/* U+5326 */ { 0, 0, 0, 0, 0 },
/* U+5327 */ { 0, 0, 0, 0, 0 },
/* U+5328 */ { 0, 0, 0, 0, 0 },
/* U+5329 */ { 0, 0, 0, 0, 0 },
/* U+532a */ { 0, 0, 0, 0, 0 },
/* U+532b */ { 0, 0, 0, 0, 0 },
/* U+532c */ { 0, 0, 0, 0, 0 },
/* U+532d */ { 0, 0, 0, 0, 0 },
/* U+532e */ { 0, 0, 0, 0, 0 },
/* U+532f */ { 0, 0, 0, 0, 0 },
/* U+5330 */ { 0, 0, 0, 0, 0 },
/* U+5331 */ { 0, 0, 0, 0, 0 },
/* U+5332 */ { 0, 0, 0, 0, 0 },
/* U+5333 */ { 0, 0, 0, 0, 0 },
/* U+5334 */ { 0, 0, 0, 0, 0 },
/* U+5335 */ { 0, 0, 0, 0, 0 },
/* U+5336 */ { 0, 0, 0, 0, 0 },
/* U+5337 */ { 0, 0, 0, 0, 0 },
/* U+5338 */ { 0, 0, 0, 0, 0 },
/* U+5339 */ { 0, 0, 0, 0, 0 },
/* U+533a */ { 0, 0, 0, 0, 0 },
/* U+533b */ { 0, 0, 0, 0, 0 },
/* U+533c */ { 0, 0, 0, 0, 0 },
/* U+533d */ { 0, 0, 0, 0, 0 },
/* U+533e */ { 0, 0, 0, 0, 0 },
/* U+533f */ { 0, 0, 0, 0, 0 },
/* U+5340 */ { 0, 0, 0, 0, 0 },
/* U+5341 */ { 0, 0, 0, 0, 0 },
/* U+5342 */ { 0, 0, 0, 0, 0 },
/* U+5343 */ { 0, 0, 0, 0, 0 },
/* U+5344 */ { 0, 0, 0, 0, 0 },
/* U+5345 */ { 0, 0, 0, 0, 0 },
/* U+5346 */ { 0, 0, 0, 0, 0 },
/* U+5347 */ { 0, 0, 0, 0, 0 },
/* U+5348 */ { 0, 0, 0, 0, 0 },
/* U+5349 */ { 0, 0, 0, 0, 0 },
/* U+534a */ { 0, 0, 0, 0, 0 },
/* U+534b */ { 0, 0, 0, 0, 0 },
/* U+534c */ { 0, 0, 0, 0, 0 },
/* U+534d */ { 0, 0, 0, 0, 0 },
/* U+534e */ { 0, 0, 0, 0, 0 },
/* U+534f */ { 0, 0, 0, 0, 0 },
/* U+5350 */ { 0, 0, 0, 0, 0 },
/* U+5351 */ { 0, 0, 0, 0, 0 },
/* U+5352 */ { 0, 0, 0, 0, 0 },
/* U+5353 */ { 0, 0, 0, 0, 0 },
/* U+5354 */ { 0, 0, 0, 0, 0 },
/* U+5355 */ { 0, 0, 0, 0, 0 },
/* U+5356 */ { 0, 0, 0, 0, 0 },
/* U+5357 */ { 0, 0, 0, 0, 0 },
/* U+5358 */ { 0, 0, 0, 0, 0 },
/* U+5359 */ { 0, 0, 0, 0, 0 },
/* U+535a */ { 0, 0, 0, 0, 0 },
/* U+535b */ { 0, 0, 0, 0, 0 },
/* U+535c */ { 0, 0, 0, 0, 0 },
/* U+535d */ { 0, 0, 0, 0, 0 },
/* U+535e */ { 0, 0, 0, 0, 0 },
/* U+535f */ { 0, 0, 0, 0, 0 },
/* U+5360 */ { 0, 0, 0, 0, 0 },
/* U+5361 */ { 0, 0, 0, 0, 0 },
/* U+5362 */ { 0, 0, 0, 0, 0 },
/* U+5363 */ { 0, 0, 0, 0, 0 },
/* U+5364 */ { 0, 0, 0, 0, 0 },
/* U+5365 */ { 0, 0, 0, 0, 0 },
/* U+5366 */ { 0, 0, 0, 0, 0 },
/* U+5367 */ { 0, 0, 0, 0, 0 },
/* U+5368 */ { 0, 0, 0, 0, 0 },
/* U+5369 */ { 0, 0, 0, 0, 0 },
/* U+536a */ { 0, 0, 0, 0, 0 },
/* U+536b */ { 0, 0, 0, 0, 0 },
/* U+536c */ { 0, 0, 0, 0, 0 },
/* U+536d */ { 0, 0, 0, 0, 0 },
/* U+536e */ { 0, 0, 0, 0, 0 },
/* U+536f */ { 0, 0, 0, 0, 0 },
/* U+5370 */ { 0, 0, 0, 0, 0 },
/* U+5371 */ { 0, 0, 0, 0, 0 },
/* U+5372 */ { 0, 0, 0, 0, 0 },
/* U+5373 */ { 0, 0, 0, 0, 0 },
/* U+5374 */ { 0, 0, 0, 0, 0 },
/* U+5375 */ { 0, 0, 0, 0, 0 },
/* U+5376 */ { 0, 0, 0, 0, 0 },
/* U+5377 */ { 0, 0, 0, 0, 0 },
/* U+5378 */ { 0, 0, 0, 0, 0 },
/* U+5379 */ { 0, 0, 0, 0, 0 },
/* U+537a */ { 0, 0, 0, 0, 0 },
/* U+537b */ { 0, 0, 0, 0, 0 },
/* U+537c */ { 0, 0, 0, 0, 0 },
/* U+537d */ { 0, 0, 0, 0, 0 },
/* U+537e */ { 0, 0, 0, 0, 0 },
/* U+537f */ { 0, 0, 0, 0, 0 },
/* U+5380 */ { 0, 0, 0, 0, 0 },
/* U+5381 */ { 0, 0, 0, 0, 0 },
/* U+5382 */ { 0, 0, 0, 0, 0 },
/* U+5383 */ { 0, 0, 0, 0, 0 },
/* U+5384 */ { 0, 0, 0, 0, 0 },
/* U+5385 */ { 0, 0, 0, 0, 0 },
/* U+5386 */ { 0, 0, 0, 0, 0 },
/* U+5387 */ { 0, 0, 0, 0, 0 },
/* U+5388 */ { 0, 0, 0, 0, 0 },
/* U+5389 */ { 0, 0, 0, 0, 0 },
/* U+538a */ { 0, 0, 0, 0, 0 },
/* U+538b */ { 0, 0, 0, 0, 0 },
/* U+538c */ { 0, 0, 0, 0, 0 },
/* U+538d */ { 0, 0, 0, 0, 0 },
/* U+538e */ { 0, 0, 0, 0, 0 },
/* U+538f */ { 0, 0, 0, 0, 0 },
/* U+5390 */ { 0, 0, 0, 0, 0 },
/* U+5391 */ { 0, 0, 0, 0, 0 },
/* U+5392 */ { 0, 0, 0, 0, 0 },
/* U+5393 */ { 0, 0, 0, 0, 0 },
/* U+5394 */ { 0, 0, 0, 0, 0 },
/* U+5395 */ { 0, 0, 0, 0, 0 },
/* U+5396 */ { 0, 0, 0, 0, 0 },
/* U+5397 */ { 0, 0, 0, 0, 0 },
/* U+5398 */ { 0, 0, 0, 0, 0 },
/* U+5399 */ { 0, 0, 0, 0, 0 },
/* U+539a */ { 0, 0, 0, 0, 0 },
/* U+539b */ { 0, 0, 0, 0, 0 },
/* U+539c */ { 0, 0, 0, 0, 0 },
/* U+539d */ { 0, 0, 0, 0, 0 },
/* U+539e */ { 0, 0, 0, 0, 0 },
/* U+539f */ { 0, 0, 0, 0, 0 },
/* U+53a0 */ { 0, 0, 0, 0, 0 },
/* U+53a1 */ { 0, 0, 0, 0, 0 },
/* U+53a2 */ { 0, 0, 0, 0, 0 },
/* U+53a3 */ { 0, 0, 0, 0, 0 },
/* U+53a4 */ { 0, 0, 0, 0, 0 },
/* U+53a5 */ { 0, 0, 0, 0, 0 },
/* U+53a6 */ { 0, 0, 0, 0, 0 },
/* U+53a7 */ { 0, 0, 0, 0, 0 },
/* U+53a8 */ { 0, 0, 0, 0, 0 },
/* U+53a9 */ { 0, 0, 0, 0, 0 },
/* U+53aa */ { 0, 0, 0, 0, 0 },
/* U+53ab */ { 0, 0, 0, 0, 0 },
/* U+53ac */ { 0, 0, 0, 0, 0 },
/* U+53ad */ { 0, 0, 0, 0, 0 },
/* U+53ae */ { 0, 0, 0, 0, 0 },
/* U+53af */ { 0, 0, 0, 0, 0 },
/* U+53b0 */ { 0, 0, 0, 0, 0 },
/* U+53b1 */ { 0, 0, 0, 0, 0 },
/* U+53b2 */ { 0, 0, 0, 0, 0 },
/* U+53b3 */ { 0, 0, 0, 0, 0 },
/* U+53b4 */ { 0, 0, 0, 0, 0 },
/* U+53b5 */ { 0, 0, 0, 0, 0 },
/* U+53b6 */ { 0, 0, 0, 0, 0 },
/* U+53b7 */ { 0, 0, 0, 0, 0 },
/* U+53b8 */ { 0, 0, 0, 0, 0 },
/* U+53b9 */ { 0, 0, 0, 0, 0 },
/* U+53ba */ { 0, 0, 0, 0, 0 },
/* U+53bb */ { 0, 0, 0, 0, 0 },
/* U+53bc */ { 0, 0, 0, 0, 0 },
/* U+53bd */ { 0, 0, 0, 0, 0 },
/* U+53be */ { 0, 0, 0, 0, 0 },
/* U+53bf */ { 0, 0, 0, 0, 0 },
/* U+53c0 */ { 0, 0, 0, 0, 0 },
/* U+53c1 */ { 0, 0, 0, 0, 0 },
/* U+53c2 */ { 0, 0, 0, 0, 0 },
/* U+53c3 */ { 0, 0, 0, 0, 0 },
/* U+53c4 */ { 0, 0, 0, 0, 0 },
/* U+53c5 */ { 0, 0, 0, 0, 0 },
/* U+53c6 */ { 0, 0, 0, 0, 0 },
/* U+53c7 */ { 0, 0, 0, 0, 0 },
/* U+53c8 */ { 0, 0, 0, 0, 0 },
/* U+53c9 */ { 0, 0, 0, 0, 0 },
/* U+53ca */ { 0, 0, 0, 0, 0 },
/* U+53cb */ { 0, 0, 0, 0, 0 },
/* U+53cc */ { 0, 0, 0, 0, 0 },
/* U+53cd */ { 0, 0, 0, 0, 0 },
/* U+53ce */ { 0, 0, 0, 0, 0 },
/* U+53cf */ { 0, 0, 0, 0, 0 },
/* U+53d0 */ { 0, 0, 0, 0, 0 },
/* U+53d1 */ { 0, 0, 0, 0, 0 },
/* U+53d2 */ { 0, 0, 0, 0, 0 },
/* U+53d3 */ { 0, 0, 0, 0, 0 },
/* U+53d4 */ { 0, 0, 0, 0, 0 },
/* U+53d5 */ { 0, 0, 0, 0, 0 },
/* U+53d6 */ { 0, 0, 0, 0, 0 },
/* U+53d7 */ { 0, 0, 0, 0, 0 },
/* U+53d8 */ { 0, 0, 0, 0, 0 },
/* U+53d9 */ { 0, 0, 0, 0, 0 },
/* U+53da */ { 0, 0, 0, 0, 0 },
/* U+53db */ { 0, 0, 0, 0, 0 },
/* U+53dc */ { 0, 0, 0, 0, 0 },
/* U+53dd */ { 0, 0, 0, 0, 0 },
/* U+53de */ { 0, 0, 0, 0, 0 },
/* U+53df */ { 0, 0, 0, 0, 0 },
/* U+53e0 */ { 0, 0, 0, 0, 0 },
/* U+53e1 */ { 0, 0, 0, 0, 0 },
/* U+53e2 */ { 0, 0, 0, 0, 0 },
/* U+53e3 */ { 0, 0, 0, 0, 0 },
/* U+53e4 */ { 0, 0, 0, 0, 0 },
/* U+53e5 */ { 0, 0, 0, 0, 0 },
/* U+53e6 */ { 0, 0, 0, 0, 0 },
/* U+53e7 */ { 0, 0, 0, 0, 0 },
/* U+53e8 */ { 0, 0, 0, 0, 0 },
/* U+53e9 */ { 0, 0, 0, 0, 0 },
/* U+53ea */ { 0, 0, 0, 0, 0 },
/* U+53eb */ { 0, 0, 0, 0, 0 },
/* U+53ec */ { 0, 0, 0, 0, 0 },
/* U+53ed */ { 0, 0, 0, 0, 0 },
/* U+53ee */ { 0, 0, 0, 0, 0 },
/* U+53ef */ { 0, 0, 0, 0, 0 },
/* U+53f0 */ { 0, 0, 0, 0, 0 },
/* U+53f1 */ { 0, 0, 0, 0, 0 },
/* U+53f2 */ { 0, 0, 0, 0, 0 },
/* U+53f3 */ { 0, 0, 0, 0, 0 },
/* U+53f4 */ { 0, 0, 0, 0, 0 },
/* U+53f5 */ { 0, 0, 0, 0, 0 },
/* U+53f6 */ { 0, 0, 0, 0, 0 },
/* U+53f7 */ { 0, 0, 0, 0, 0 },
/* U+53f8 */ { 0, 0, 0, 0, 0 },
/* U+53f9 */ { 0, 0, 0, 0, 0 },
/* U+53fa */ { 0, 0, 0, 0, 0 },
/* U+53fb */ { 0, 0, 0, 0, 0 },
/* U+53fc */ { 0, 0, 0, 0, 0 },
/* U+53fd */ { 0, 0, 0, 0, 0 },
/* U+53fe */ { 0, 0, 0, 0, 0 },
/* U+53ff */ { 0, 0, 0, 0, 0 },
/* U+5400 */ { 0, 0, 0, 0, 0 },
/* U+5401 */ { 0, 0, 0, 0, 0 },
/* U+5402 */ { 0, 0, 0, 0, 0 },
/* U+5403 */ { 0, 0, 0, 0, 0 },
/* U+5404 */ { 0, 0, 0, 0, 0 },
/* U+5405 */ { 0, 0, 0, 0, 0 },
/* U+5406 */ { 0, 0, 0, 0, 0 },
/* U+5407 */ { 0, 0, 0, 0, 0 },
/* U+5408 */ { 0, 0, 0, 0, 0 },
/* U+5409 */ { 0, 0, 0, 0, 0 },
/* U+540a */ { 0, 0, 0, 0, 0 },
/* U+540b */ { 0, 0, 0, 0, 0 },
/* U+540c */ { 0, 0, 0, 0, 0 },
/* U+540d */ { 0, 0, 0, 0, 0 },
/* U+540e */ { 0, 0, 0, 0, 0 },
/* U+540f */ { 0, 0, 0, 0, 0 },
/* U+5410 */ { 0, 0, 0, 0, 0 },
/* U+5411 */ { 0, 0, 0, 0, 0 },
/* U+5412 */ { 0, 0, 0, 0, 0 },
/* U+5413 */ { 0, 0, 0, 0, 0 },
/* U+5414 */ { 0, 0, 0, 0, 0 },
/* U+5415 */ { 0, 0, 0, 0, 0 },
/* U+5416 */ { 0, 0, 0, 0, 0 },
/* U+5417 */ { 0, 0, 0, 0, 0 },
/* U+5418 */ { 0, 0, 0, 0, 0 },
/* U+5419 */ { 0, 0, 0, 0, 0 },
/* U+541a */ { 0, 0, 0, 0, 0 },
/* U+541b */ { 0, 0, 0, 0, 0 },
/* U+541c */ { 0, 0, 0, 0, 0 },
/* U+541d */ { 0, 0, 0, 0, 0 },
/* U+541e */ { 0, 0, 0, 0, 0 },
/* U+541f */ { 0, 0, 0, 0, 0 },
/* U+5420 */ { 0, 0, 0, 0, 0 },
/* U+5421 */ { 0, 0, 0, 0, 0 },
/* U+5422 */ { 0, 0, 0, 0, 0 },
/* U+5423 */ { 0, 0, 0, 0, 0 },
/* U+5424 */ { 0, 0, 0, 0, 0 },
/* U+5425 */ { 0, 0, 0, 0, 0 },
/* U+5426 */ { 0, 0, 0, 0, 0 },
/* U+5427 */ { 0, 0, 0, 0, 0 },
/* U+5428 */ { 0, 0, 0, 0, 0 },
/* U+5429 */ { 0, 0, 0, 0, 0 },
/* U+542a */ { 0, 0, 0, 0, 0 },
/* U+542b */ { 0, 0, 0, 0, 0 },
/* U+542c */ { 0, 0, 0, 0, 0 },
/* U+542d */ { 0, 0, 0, 0, 0 },
/* U+542e */ { 0, 0, 0, 0, 0 },
/* U+542f */ { 0, 0, 0, 0, 0 },
/* U+5430 */ { 0, 0, 0, 0, 0 },
/* U+5431 */ { 0, 0, 0, 0, 0 },
/* U+5432 */ { 0, 0, 0, 0, 0 },
/* U+5433 */ { 0, 0, 0, 0, 0 },
/* U+5434 */ { 0, 0, 0, 0, 0 },
/* U+5435 */ { 0, 0, 0, 0, 0 },
/* U+5436 */ { 0, 0, 0, 0, 0 },
/* U+5437 */ { 0, 0, 0, 0, 0 },
/* U+5438 */ { 0, 0, 0, 0, 0 },
/* U+5439 */ { 0, 0, 0, 0, 0 },
/* U+543a */ { 0, 0, 0, 0, 0 },
/* U+543b */ { 0, 0, 0, 0, 0 },
/* U+543c */ { 0, 0, 0, 0, 0 },
/* U+543d */ { 0, 0, 0, 0, 0 },
/* U+543e */ { 0, 0, 0, 0, 0 },
/* U+543f */ { 0, 0, 0, 0, 0 },
/* U+5440 */ { 0, 0, 0, 0, 0 },
/* U+5441 */ { 0, 0, 0, 0, 0 },
/* U+5442 */ { 0, 0, 0, 0, 0 },
/* U+5443 */ { 0, 0, 0, 0, 0 },
/* U+5444 */ { 0, 0, 0, 0, 0 },
/* U+5445 */ { 0, 0, 0, 0, 0 },
/* U+5446 */ { 0, 0, 0, 0, 0 },
/* U+5447 */ { 0, 0, 0, 0, 0 },
/* U+5448 */ { 0, 0, 0, 0, 0 },
/* U+5449 */ { 0, 0, 0, 0, 0 },
/* U+544a */ { 0, 0, 0, 0, 0 },
/* U+544b */ { 0, 0, 0, 0, 0 },
/* U+544c */ { 0, 0, 0, 0, 0 },
/* U+544d */ { 0, 0, 0, 0, 0 },
/* U+544e */ { 0, 0, 0, 0, 0 },
/* U+544f */ { 0, 0, 0, 0, 0 },
/* U+5450 */ { 0, 0, 0, 0, 0 },
/* U+5451 */ { 0, 0, 0, 0, 0 },
/* U+5452 */ { 0, 0, 0, 0, 0 },
/* U+5453 */ { 0, 0, 0, 0, 0 },
/* U+5454 */ { 0, 0, 0, 0, 0 },
/* U+5455 */ { 0, 0, 0, 0, 0 },
/* U+5456 */ { 0, 0, 0, 0, 0 },
/* U+5457 */ { 0, 0, 0, 0, 0 },
/* U+5458 */ { 0, 0, 0, 0, 0 },
/* U+5459 */ { 0, 0, 0, 0, 0 },
/* U+545a */ { 0, 0, 0, 0, 0 },
/* U+545b */ { 0, 0, 0, 0, 0 },
/* U+545c */ { 0, 0, 0, 0, 0 },
/* U+545d */ { 0, 0, 0, 0, 0 },
/* U+545e */ { 0, 0, 0, 0, 0 },
/* U+545f */ { 0, 0, 0, 0, 0 },
/* U+5460 */ { 0, 0, 0, 0, 0 },
/* U+5461 */ { 0, 0, 0, 0, 0 },
/* U+5462 */ { 0, 0, 0, 0, 0 },
/* U+5463 */ { 0, 0, 0, 0, 0 },
/* U+5464 */ { 0, 0, 0, 0, 0 },
/* U+5465 */ { 0, 0, 0, 0, 0 },
/* U+5466 */ { 0, 0, 0, 0, 0 },
/* U+5467 */ { 0, 0, 0, 0, 0 },
/* U+5468 */ { 0, 0, 0, 0, 0 },
/* U+5469 */ { 0, 0, 0, 0, 0 },
/* U+546a */ { 0, 0, 0, 0, 0 },
/* U+546b */ { 0, 0, 0, 0, 0 },
/* U+546c */ { 0, 0, 0, 0, 0 },
/* U+546d */ { 0, 0, 0, 0, 0 },
/* U+546e */ { 0, 0, 0, 0, 0 },
/* U+546f */ { 0, 0, 0, 0, 0 },
/* U+5470 */ { 0, 0, 0, 0, 0 },
/* U+5471 */ { 0, 0, 0, 0, 0 },
/* U+5472 */ { 0, 0, 0, 0, 0 },
/* U+5473 */ { 0, 0, 0, 0, 0 },
/* U+5474 */ { 0, 0, 0, 0, 0 },
/* U+5475 */ { 0, 0, 0, 0, 0 },
/* U+5476 */ { 0, 0, 0, 0, 0 },
/* U+5477 */ { 0, 0, 0, 0, 0 },
/* U+5478 */ { 0, 0, 0, 0, 0 },
/* U+5479 */ { 0, 0, 0, 0, 0 },
/* U+547a */ { 0, 0, 0, 0, 0 },
/* U+547b */ { 0, 0, 0, 0, 0 },
/* U+547c */ { 0, 0, 0, 0, 0 },
/* U+547d */ { 0, 0, 0, 0, 0 },
/* U+547e */ { 0, 0, 0, 0, 0 },
/* U+547f */ { 0, 0, 0, 0, 0 },
/* U+5480 */ { 0, 0, 0, 0, 0 },
/* U+5481 */ { 0, 0, 0, 0, 0 },
/* U+5482 */ { 0, 0, 0, 0, 0 },
/* U+5483 */ { 0, 0, 0, 0, 0 },
/* U+5484 */ { 0, 0, 0, 0, 0 },
/* U+5485 */ { 0, 0, 0, 0, 0 },
/* U+5486 */ { 0, 0, 0, 0, 0 },
/* U+5487 */ { 0, 0, 0, 0, 0 },
/* U+5488 */ { 0, 0, 0, 0, 0 },
/* U+5489 */ { 0, 0, 0, 0, 0 },
/* U+548a */ { 0, 0, 0, 0, 0 },
/* U+548b */ { 0, 0, 0, 0, 0 },
/* U+548c */ { 0, 0, 0, 0, 0 },
/* U+548d */ { 0, 0, 0, 0, 0 },
/* U+548e */ { 0, 0, 0, 0, 0 },
/* U+548f */ { 0, 0, 0, 0, 0 },
/* U+5490 */ { 0, 0, 0, 0, 0 },
/* U+5491 */ { 0, 0, 0, 0, 0 },
/* U+5492 */ { 0, 0, 0, 0, 0 },
/* U+5493 */ { 0, 0, 0, 0, 0 },
/* U+5494 */ { 0, 0, 0, 0, 0 },
/* U+5495 */ { 0, 0, 0, 0, 0 },
/* U+5496 */ { 0, 0, 0, 0, 0 },
/* U+5497 */ { 0, 0, 0, 0, 0 },
/* U+5498 */ { 0, 0, 0, 0, 0 },
/* U+5499 */ { 0, 0, 0, 0, 0 },
/* U+549a */ { 0, 0, 0, 0, 0 },
/* U+549b */ { 0, 0, 0, 0, 0 },
/* U+549c */ { 0, 0, 0, 0, 0 },
/* U+549d */ { 0, 0, 0, 0, 0 },
/* U+549e */ { 0, 0, 0, 0, 0 },
/* U+549f */ { 0, 0, 0, 0, 0 },
/* U+54a0 */ { 0, 0, 0, 0, 0 },
/* U+54a1 */ { 0, 0, 0, 0, 0 },
/* U+54a2 */ { 0, 0, 0, 0, 0 },
/* U+54a3 */ { 0, 0, 0, 0, 0 },
/* U+54a4 */ { 0, 0, 0, 0, 0 },
/* U+54a5 */ { 0, 0, 0, 0, 0 },
/* U+54a6 */ { 0, 0, 0, 0, 0 },
/* U+54a7 */ { 0, 0, 0, 0, 0 },
/* U+54a8 */ { 0, 0, 0, 0, 0 },
/* U+54a9 */ { 0, 0, 0, 0, 0 },
/* U+54aa */ { 0, 0, 0, 0, 0 },
/* U+54ab */ { 0, 0, 0, 0, 0 },
/* U+54ac */ { 0, 0, 0, 0, 0 },
/* U+54ad */ { 0, 0, 0, 0, 0 },
/* U+54ae */ { 0, 0, 0, 0, 0 },
/* U+54af */ { 0, 0, 0, 0, 0 },
/* U+54b0 */ { 0, 0, 0, 0, 0 },
/* U+54b1 */ { 0, 0, 0, 0, 0 },
/* U+54b2 */ { 0, 0, 0, 0, 0 },
/* U+54b3 */ { 0, 0, 0, 0, 0 },
/* U+54b4 */ { 0, 0, 0, 0, 0 },
/* U+54b5 */ { 0, 0, 0, 0, 0 },
/* U+54b6 */ { 0, 0, 0, 0, 0 },
/* U+54b7 */ { 0, 0, 0, 0, 0 },
/* U+54b8 */ { 0, 0, 0, 0, 0 },
/* U+54b9 */ { 0, 0, 0, 0, 0 },
/* U+54ba */ { 0, 0, 0, 0, 0 },
/* U+54bb */ { 0, 0, 0, 0, 0 },
/* U+54bc */ { 0, 0, 0, 0, 0 },
/* U+54bd */ { 0, 0, 0, 0, 0 },
/* U+54be */ { 0, 0, 0, 0, 0 },
/* U+54bf */ { 0, 0, 0, 0, 0 },
/* U+54c0 */ { 0, 0, 0, 0, 0 },
/* U+54c1 */ { 0, 0, 0, 0, 0 },
/* U+54c2 */ { 0, 0, 0, 0, 0 },
/* U+54c3 */ { 0, 0, 0, 0, 0 },
/* U+54c4 */ { 0, 0, 0, 0, 0 },
/* U+54c5 */ { 0, 0, 0, 0, 0 },
/* U+54c6 */ { 0, 0, 0, 0, 0 },
/* U+54c7 */ { 0, 0, 0, 0, 0 },
/* U+54c8 */ { 0, 0, 0, 0, 0 },
/* U+54c9 */ { 0, 0, 0, 0, 0 },
/* U+54ca */ { 0, 0, 0, 0, 0 },
/* U+54cb */ { 0, 0, 0, 0, 0 },
/* U+54cc */ { 0, 0, 0, 0, 0 },
/* U+54cd */ { 0, 0, 0, 0, 0 },
/* U+54ce */ { 0, 0, 0, 0, 0 },
/* U+54cf */ { 0, 0, 0, 0, 0 },
/* U+54d0 */ { 0, 0, 0, 0, 0 },
/* U+54d1 */ { 0, 0, 0, 0, 0 },
/* U+54d2 */ { 0, 0, 0, 0, 0 },
/* U+54d3 */ { 0, 0, 0, 0, 0 },
/* U+54d4 */ { 0, 0, 0, 0, 0 },
/* U+54d5 */ { 0, 0, 0, 0, 0 },
/* U+54d6 */ { 0, 0, 0, 0, 0 },
/* U+54d7 */ { 0, 0, 0, 0, 0 },
/* U+54d8 */ { 0, 0, 0, 0, 0 },
/* U+54d9 */ { 0, 0, 0, 0, 0 },
/* U+54da */ { 0, 0, 0, 0, 0 },
/* U+54db */ { 0, 0, 0, 0, 0 },
/* U+54dc */ { 0, 0, 0, 0, 0 },
/* U+54dd */ { 0, 0, 0, 0, 0 },
/* U+54de */ { 0, 0, 0, 0, 0 },
/* U+54df */ { 0, 0, 0, 0, 0 },
/* U+54e0 */ { 0, 0, 0, 0, 0 },
/* U+54e1 */ { 0, 0, 0, 0, 0 },
/* U+54e2 */ { 0, 0, 0, 0, 0 },
/* U+54e3 */ { 0, 0, 0, 0, 0 },
/* U+54e4 */ { 0, 0, 0, 0, 0 },
/* U+54e5 */ { 0, 0, 0, 0, 0 },
/* U+54e6 */ { 0, 0, 0, 0, 0 },
/* U+54e7 */ { 0, 0, 0, 0, 0 },
/* U+54e8 */ { 0, 0, 0, 0, 0 },
/* U+54e9 */ { 0, 0, 0, 0, 0 },
/* U+54ea */ { 0, 0, 0, 0, 0 },
/* U+54eb */ { 0, 0, 0, 0, 0 },
/* U+54ec */ { 0, 0, 0, 0, 0 },
/* U+54ed */ { 0, 0, 0, 0, 0 },
/* U+54ee */ { 0, 0, 0, 0, 0 },
/* U+54ef */ { 0, 0, 0, 0, 0 },
/* U+54f0 */ { 0, 0, 0, 0, 0 },
/* U+54f1 */ { 0, 0, 0, 0, 0 },
/* U+54f2 */ { 0, 0, 0, 0, 0 },
/* U+54f3 */ { 0, 0, 0, 0, 0 },
/* U+54f4 */ { 0, 0, 0, 0, 0 },
/* U+54f5 */ { 0, 0, 0, 0, 0 },
/* U+54f6 */ { 0, 0, 0, 0, 0 },
/* U+54f7 */ { 0, 0, 0, 0, 0 },
/* U+54f8 */ { 0, 0, 0, 0, 0 },
/* U+54f9 */ { 0, 0, 0, 0, 0 },
/* U+54fa */ { 0, 0, 0, 0, 0 },
/* U+54fb */ { 0, 0, 0, 0, 0 },
/* U+54fc */ { 0, 0, 0, 0, 0 },
/* U+54fd */ { 0, 0, 0, 0, 0 },
/* U+54fe */ { 0, 0, 0, 0, 0 },
/* U+54ff */ { 0, 0, 0, 0, 0 },
/* U+5500 */ { 0, 0, 0, 0, 0 },
/* U+5501 */ { 0, 0, 0, 0, 0 },
/* U+5502 */ { 0, 0, 0, 0, 0 },
/* U+5503 */ { 0, 0, 0, 0, 0 },
/* U+5504 */ { 0, 0, 0, 0, 0 },
/* U+5505 */ { 0, 0, 0, 0, 0 },
/* U+5506 */ { 0, 0, 0, 0, 0 },
/* U+5507 */ { 0, 0, 0, 0, 0 },
/* U+5508 */ { 0, 0, 0, 0, 0 },
/* U+5509 */ { 0, 0, 0, 0, 0 },
/* U+550a */ { 0, 0, 0, 0, 0 },
/* U+550b */ { 0, 0, 0, 0, 0 },
/* U+550c */ { 0, 0, 0, 0, 0 },
/* U+550d */ { 0, 0, 0, 0, 0 },
/* U+550e */ { 0, 0, 0, 0, 0 },
/* U+550f */ { 0, 0, 0, 0, 0 },
/* U+5510 */ { 0, 0, 0, 0, 0 },
/* U+5511 */ { 0, 0, 0, 0, 0 },
/* U+5512 */ { 0, 0, 0, 0, 0 },
/* U+5513 */ { 0, 0, 0, 0, 0 },
/* U+5514 */ { 0, 0, 0, 0, 0 },
/* U+5515 */ { 0, 0, 0, 0, 0 },
/* U+5516 */ { 0, 0, 0, 0, 0 },
/* U+5517 */ { 0, 0, 0, 0, 0 },
/* U+5518 */ { 0, 0, 0, 0, 0 },
/* U+5519 */ { 0, 0, 0, 0, 0 },
/* U+551a */ { 0, 0, 0, 0, 0 },
/* U+551b */ { 0, 0, 0, 0, 0 },
/* U+551c */ { 0, 0, 0, 0, 0 },
/* U+551d */ { 0, 0, 0, 0, 0 },
/* U+551e */ { 0, 0, 0, 0, 0 },
/* U+551f */ { 0, 0, 0, 0, 0 },
/* U+5520 */ { 0, 0, 0, 0, 0 },
/* U+5521 */ { 0, 0, 0, 0, 0 },
/* U+5522 */ { 0, 0, 0, 0, 0 },
/* U+5523 */ { 0, 0, 0, 0, 0 },
/* U+5524 */ { 0, 0, 0, 0, 0 },
/* U+5525 */ { 0, 0, 0, 0, 0 },
/* U+5526 */ { 0, 0, 0, 0, 0 },
/* U+5527 */ { 0, 0, 0, 0, 0 },
/* U+5528 */ { 0, 0, 0, 0, 0 },
/* U+5529 */ { 0, 0, 0, 0, 0 },
/* U+552a */ { 0, 0, 0, 0, 0 },
/* U+552b */ { 0, 0, 0, 0, 0 },
/* U+552c */ { 0, 0, 0, 0, 0 },
/* U+552d */ { 0, 0, 0, 0, 0 },
/* U+552e */ { 0, 0, 0, 0, 0 },
/* U+552f */ { 0, 0, 0, 0, 0 },
/* U+5530 */ { 0, 0, 0, 0, 0 },
/* U+5531 */ { 0, 0, 0, 0, 0 },
/* U+5532 */ { 0, 0, 0, 0, 0 },
/* U+5533 */ { 0, 0, 0, 0, 0 },
/* U+5534 */ { 0, 0, 0, 0, 0 },
/* U+5535 */ { 0, 0, 0, 0, 0 },
/* U+5536 */ { 0, 0, 0, 0, 0 },
/* U+5537 */ { 0, 0, 0, 0, 0 },
/* U+5538 */ { 0, 0, 0, 0, 0 },
/* U+5539 */ { 0, 0, 0, 0, 0 },
/* U+553a */ { 0, 0, 0, 0, 0 },
/* U+553b */ { 0, 0, 0, 0, 0 },
/* U+553c */ { 0, 0, 0, 0, 0 },
/* U+553d */ { 0, 0, 0, 0, 0 },
/* U+553e */ { 0, 0, 0, 0, 0 },
/* U+553f */ { 0, 0, 0, 0, 0 },
/* U+5540 */ { 0, 0, 0, 0, 0 },
/* U+5541 */ { 0, 0, 0, 0, 0 },
/* U+5542 */ { 0, 0, 0, 0, 0 },
/* U+5543 */ { 0, 0, 0, 0, 0 },
/* U+5544 */ { 0, 0, 0, 0, 0 },
/* U+5545 */ { 0, 0, 0, 0, 0 },
/* U+5546 */ { 0, 0, 0, 0, 0 },
/* U+5547 */ { 0, 0, 0, 0, 0 },
/* U+5548 */ { 0, 0, 0, 0, 0 },
/* U+5549 */ { 0, 0, 0, 0, 0 },
/* U+554a */ { 0, 0, 0, 0, 0 },
/* U+554b */ { 0, 0, 0, 0, 0 },
/* U+554c */ { 0, 0, 0, 0, 0 },
/* U+554d */ { 0, 0, 0, 0, 0 },
/* U+554e */ { 0, 0, 0, 0, 0 },
/* U+554f */ { 0, 0, 0, 0, 0 },
/* U+5550 */ { 0, 0, 0, 0, 0 },
/* U+5551 */ { 0, 0, 0, 0, 0 },
/* U+5552 */ { 0, 0, 0, 0, 0 },
/* U+5553 */ { 0, 0, 0, 0, 0 },
/* U+5554 */ { 0, 0, 0, 0, 0 },
/* U+5555 */ { 0, 0, 0, 0, 0 },
/* U+5556 */ { 0, 0, 0, 0, 0 },
/* U+5557 */ { 0, 0, 0, 0, 0 },
/* U+5558 */ { 0, 0, 0, 0, 0 },
/* U+5559 */ { 0, 0, 0, 0, 0 },
/* U+555a */ { 0, 0, 0, 0, 0 },
/* U+555b */ { 0, 0, 0, 0, 0 },
/* U+555c */ { 0, 0, 0, 0, 0 },
/* U+555d */ { 0, 0, 0, 0, 0 },
/* U+555e */ { 0, 0, 0, 0, 0 },
/* U+555f */ { 0, 0, 0, 0, 0 },
/* U+5560 */ { 0, 0, 0, 0, 0 },
/* U+5561 */ { 0, 0, 0, 0, 0 },
/* U+5562 */ { 0, 0, 0, 0, 0 },
/* U+5563 */ { 0, 0, 0, 0, 0 },
/* U+5564 */ { 0, 0, 0, 0, 0 },
/* U+5565 */ { 0, 0, 0, 0, 0 },
/* U+5566 */ { 0, 0, 0, 0, 0 },
/* U+5567 */ { 0, 0, 0, 0, 0 },
/* U+5568 */ { 0, 0, 0, 0, 0 },
/* U+5569 */ { 0, 0, 0, 0, 0 },
/* U+556a */ { 0, 0, 0, 0, 0 },
/* U+556b */ { 0, 0, 0, 0, 0 },
/* U+556c */ { 0, 0, 0, 0, 0 },
/* U+556d */ { 0, 0, 0, 0, 0 },
/* U+556e */ { 0, 0, 0, 0, 0 },
/* U+556f */ { 0, 0, 0, 0, 0 },
/* U+5570 */ { 0, 0, 0, 0, 0 },
/* U+5571 */ { 0, 0, 0, 0, 0 },
/* U+5572 */ { 0, 0, 0, 0, 0 },
/* U+5573 */ { 0, 0, 0, 0, 0 },
/* U+5574 */ { 0, 0, 0, 0, 0 },
/* U+5575 */ { 0, 0, 0, 0, 0 },
/* U+5576 */ { 0, 0, 0, 0, 0 },
/* U+5577 */ { 0, 0, 0, 0, 0 },
/* U+5578 */ { 0, 0, 0, 0, 0 },
/* U+5579 */ { 0, 0, 0, 0, 0 },
/* U+557a */ { 0, 0, 0, 0, 0 },
/* U+557b */ { 0, 0, 0, 0, 0 },
/* U+557c */ { 0, 0, 0, 0, 0 },
/* U+557d */ { 0, 0, 0, 0, 0 },
/* U+557e */ { 0, 0, 0, 0, 0 },
/* U+557f */ { 0, 0, 0, 0, 0 },
/* U+5580 */ { 0, 0, 0, 0, 0 },
/* U+5581 */ { 0, 0, 0, 0, 0 },
/* U+5582 */ { 0, 0, 0, 0, 0 },
/* U+5583 */ { 0, 0, 0, 0, 0 },
/* U+5584 */ { 0, 0, 0, 0, 0 },
/* U+5585 */ { 0, 0, 0, 0, 0 },
/* U+5586 */ { 0, 0, 0, 0, 0 },
/* U+5587 */ { 0, 0, 0, 0, 0 },
/* U+5588 */ { 0, 0, 0, 0, 0 },
/* U+5589 */ { 0, 0, 0, 0, 0 },
/* U+558a */ { 0, 0, 0, 0, 0 },
/* U+558b */ { 0, 0, 0, 0, 0 },
/* U+558c */ { 0, 0, 0, 0, 0 },
/* U+558d */ { 0, 0, 0, 0, 0 },
/* U+558e */ { 0, 0, 0, 0, 0 },
/* U+558f */ { 0, 0, 0, 0, 0 },
/* U+5590 */ { 0, 0, 0, 0, 0 },
/* U+5591 */ { 0, 0, 0, 0, 0 },
/* U+5592 */ { 0, 0, 0, 0, 0 },
/* U+5593 */ { 0, 0, 0, 0, 0 },
/* U+5594 */ { 0, 0, 0, 0, 0 },
/* U+5595 */ { 0, 0, 0, 0, 0 },
/* U+5596 */ { 0, 0, 0, 0, 0 },
/* U+5597 */ { 0, 0, 0, 0, 0 },
/* U+5598 */ { 0, 0, 0, 0, 0 },
/* U+5599 */ { 0, 0, 0, 0, 0 },
/* U+559a */ { 0, 0, 0, 0, 0 },
/* U+559b */ { 0, 0, 0, 0, 0 },
/* U+559c */ { 0, 0, 0, 0, 0 },
/* U+559d */ { 0, 0, 0, 0, 0 },
/* U+559e */ { 0, 0, 0, 0, 0 },
/* U+559f */ { 0, 0, 0, 0, 0 },
/* U+55a0 */ { 0, 0, 0, 0, 0 },
/* U+55a1 */ { 0, 0, 0, 0, 0 },
/* U+55a2 */ { 0, 0, 0, 0, 0 },
/* U+55a3 */ { 0, 0, 0, 0, 0 },
/* U+55a4 */ { 0, 0, 0, 0, 0 },
/* U+55a5 */ { 0, 0, 0, 0, 0 },
/* U+55a6 */ { 0, 0, 0, 0, 0 },
/* U+55a7 */ { 0, 0, 0, 0, 0 },
/* U+55a8 */ { 0, 0, 0, 0, 0 },
/* U+55a9 */ { 0, 0, 0, 0, 0 },
/* U+55aa */ { 0, 0, 0, 0, 0 },
/* U+55ab */ { 0, 0, 0, 0, 0 },
/* U+55ac */ { 0, 0, 0, 0, 0 },
/* U+55ad */ { 0, 0, 0, 0, 0 },
/* U+55ae */ { 0, 0, 0, 0, 0 },
/* U+55af */ { 0, 0, 0, 0, 0 },
/* U+55b0 */ { 0, 0, 0, 0, 0 },
/* U+55b1 */ { 0, 0, 0, 0, 0 },
/* U+55b2 */ { 0, 0, 0, 0, 0 },
/* U+55b3 */ { 0, 0, 0, 0, 0 },
/* U+55b4 */ { 0, 0, 0, 0, 0 },
/* U+55b5 */ { 0, 0, 0, 0, 0 },
/* U+55b6 */ { 0, 0, 0, 0, 0 },
/* U+55b7 */ { 0, 0, 0, 0, 0 },
/* U+55b8 */ { 0, 0, 0, 0, 0 },
/* U+55b9 */ { 0, 0, 0, 0, 0 },
/* U+55ba */ { 0, 0, 0, 0, 0 },
/* U+55bb */ { 0, 0, 0, 0, 0 },
/* U+55bc */ { 0, 0, 0, 0, 0 },
/* U+55bd */ { 0, 0, 0, 0, 0 },
/* U+55be */ { 0, 0, 0, 0, 0 },
/* U+55bf */ { 0, 0, 0, 0, 0 },
/* U+55c0 */ { 0, 0, 0, 0, 0 },
/* U+55c1 */ { 0, 0, 0, 0, 0 },
/* U+55c2 */ { 0, 0, 0, 0, 0 },
/* U+55c3 */ { 0, 0, 0, 0, 0 },
/* U+55c4 */ { 0, 0, 0, 0, 0 },
/* U+55c5 */ { 0, 0, 0, 0, 0 },
/* U+55c6 */ { 0, 0, 0, 0, 0 },
/* U+55c7 */ { 0, 0, 0, 0, 0 },
/* U+55c8 */ { 0, 0, 0, 0, 0 },
/* U+55c9 */ { 0, 0, 0, 0, 0 },
/* U+55ca */ { 0, 0, 0, 0, 0 },
/* U+55cb */ { 0, 0, 0, 0, 0 },
/* U+55cc */ { 0, 0, 0, 0, 0 },
/* U+55cd */ { 0, 0, 0, 0, 0 },
/* U+55ce */ { 0, 0, 0, 0, 0 },
/* U+55cf */ { 0, 0, 0, 0, 0 },
/* U+55d0 */ { 0, 0, 0, 0, 0 },
/* U+55d1 */ { 0, 0, 0, 0, 0 },
/* U+55d2 */ { 0, 0, 0, 0, 0 },
/* U+55d3 */ { 0, 0, 0, 0, 0 },
/* U+55d4 */ { 0, 0, 0, 0, 0 },
/* U+55d5 */ { 0, 0, 0, 0, 0 },
/* U+55d6 */ { 0, 0, 0, 0, 0 },
/* U+55d7 */ { 0, 0, 0, 0, 0 },
/* U+55d8 */ { 0, 0, 0, 0, 0 },
/* U+55d9 */ { 0, 0, 0, 0, 0 },
/* U+55da */ { 0, 0, 0, 0, 0 },
/* U+55db */ { 0, 0, 0, 0, 0 },
/* U+55dc */ { 0, 0, 0, 0, 0 },
/* U+55dd */ { 0, 0, 0, 0, 0 },
/* U+55de */ { 0, 0, 0, 0, 0 },
/* U+55df */ { 0, 0, 0, 0, 0 },
/* U+55e0 */ { 0, 0, 0, 0, 0 },
/* U+55e1 */ { 0, 0, 0, 0, 0 },
/* U+55e2 */ { 0, 0, 0, 0, 0 },
/* U+55e3 */ { 0, 0, 0, 0, 0 },
/* U+55e4 */ { 0, 0, 0, 0, 0 },
/* U+55e5 */ { 0, 0, 0, 0, 0 },
/* U+55e6 */ { 0, 0, 0, 0, 0 },
/* U+55e7 */ { 0, 0, 0, 0, 0 },
/* U+55e8 */ { 0, 0, 0, 0, 0 },
/* U+55e9 */ { 0, 0, 0, 0, 0 },
/* U+55ea */ { 0, 0, 0, 0, 0 },
/* U+55eb */ { 0, 0, 0, 0, 0 },
/* U+55ec */ { 0, 0, 0, 0, 0 },
/* U+55ed */ { 0, 0, 0, 0, 0 },
/* U+55ee */ { 0, 0, 0, 0, 0 },
/* U+55ef */ { 0, 0, 0, 0, 0 },
/* U+55f0 */ { 0, 0, 0, 0, 0 },
/* U+55f1 */ { 0, 0, 0, 0, 0 },
/* U+55f2 */ { 0, 0, 0, 0, 0 },
/* U+55f3 */ { 0, 0, 0, 0, 0 },
/* U+55f4 */ { 0, 0, 0, 0, 0 },
/* U+55f5 */ { 0, 0, 0, 0, 0 },
/* U+55f6 */ { 0, 0, 0, 0, 0 },
/* U+55f7 */ { 0, 0, 0, 0, 0 },
/* U+55f8 */ { 0, 0, 0, 0, 0 },
/* U+55f9 */ { 0, 0, 0, 0, 0 },
/* U+55fa */ { 0, 0, 0, 0, 0 },
/* U+55fb */ { 0, 0, 0, 0, 0 },
/* U+55fc */ { 0, 0, 0, 0, 0 },
/* U+55fd */ { 0, 0, 0, 0, 0 },
/* U+55fe */ { 0, 0, 0, 0, 0 },
/* U+55ff */ { 0, 0, 0, 0, 0 },
/* U+5600 */ { 0, 0, 0, 0, 0 },
/* U+5601 */ { 0, 0, 0, 0, 0 },
/* U+5602 */ { 0, 0, 0, 0, 0 },
/* U+5603 */ { 0, 0, 0, 0, 0 },
/* U+5604 */ { 0, 0, 0, 0, 0 },
/* U+5605 */ { 0, 0, 0, 0, 0 },
/* U+5606 */ { 0, 0, 0, 0, 0 },
/* U+5607 */ { 0, 0, 0, 0, 0 },
/* U+5608 */ { 0, 0, 0, 0, 0 },
/* U+5609 */ { 0, 0, 0, 0, 0 },
/* U+560a */ { 0, 0, 0, 0, 0 },
/* U+560b */ { 0, 0, 0, 0, 0 },
/* U+560c */ { 0, 0, 0, 0, 0 },
/* U+560d */ { 0, 0, 0, 0, 0 },
/* U+560e */ { 0, 0, 0, 0, 0 },
/* U+560f */ { 0, 0, 0, 0, 0 },
/* U+5610 */ { 0, 0, 0, 0, 0 },
/* U+5611 */ { 0, 0, 0, 0, 0 },
/* U+5612 */ { 0, 0, 0, 0, 0 },
/* U+5613 */ { 0, 0, 0, 0, 0 },
/* U+5614 */ { 0, 0, 0, 0, 0 },
/* U+5615 */ { 0, 0, 0, 0, 0 },
/* U+5616 */ { 0, 0, 0, 0, 0 },
/* U+5617 */ { 0, 0, 0, 0, 0 },
/* U+5618 */ { 0, 0, 0, 0, 0 },
/* U+5619 */ { 0, 0, 0, 0, 0 },
/* U+561a */ { 0, 0, 0, 0, 0 },
/* U+561b */ { 0, 0, 0, 0, 0 },
/* U+561c */ { 0, 0, 0, 0, 0 },
/* U+561d */ { 0, 0, 0, 0, 0 },
/* U+561e */ { 0, 0, 0, 0, 0 },
/* U+561f */ { 0, 0, 0, 0, 0 },
/* U+5620 */ { 0, 0, 0, 0, 0 },
/* U+5621 */ { 0, 0, 0, 0, 0 },
/* U+5622 */ { 0, 0, 0, 0, 0 },
/* U+5623 */ { 0, 0, 0, 0, 0 },
/* U+5624 */ { 0, 0, 0, 0, 0 },
/* U+5625 */ { 0, 0, 0, 0, 0 },
/* U+5626 */ { 0, 0, 0, 0, 0 },
/* U+5627 */ { 0, 0, 0, 0, 0 },
/* U+5628 */ { 0, 0, 0, 0, 0 },
/* U+5629 */ { 0, 0, 0, 0, 0 },
/* U+562a */ { 0, 0, 0, 0, 0 },
/* U+562b */ { 0, 0, 0, 0, 0 },
/* U+562c */ { 0, 0, 0, 0, 0 },
/* U+562d */ { 0, 0, 0, 0, 0 },
/* U+562e */ { 0, 0, 0, 0, 0 },
/* U+562f */ { 0, 0, 0, 0, 0 },
/* U+5630 */ { 0, 0, 0, 0, 0 },
/* U+5631 */ { 0, 0, 0, 0, 0 },
/* U+5632 */ { 0, 0, 0, 0, 0 },
/* U+5633 */ { 0, 0, 0, 0, 0 },
/* U+5634 */ { 0, 0, 0, 0, 0 },
/* U+5635 */ { 0, 0, 0, 0, 0 },
/* U+5636 */ { 0, 0, 0, 0, 0 },
/* U+5637 */ { 0, 0, 0, 0, 0 },
/* U+5638 */ { 0, 0, 0, 0, 0 },
/* U+5639 */ { 0, 0, 0, 0, 0 },
/* U+563a */ { 0, 0, 0, 0, 0 },
/* U+563b */ { 0, 0, 0, 0, 0 },
/* U+563c */ { 0, 0, 0, 0, 0 },
/* U+563d */ { 0, 0, 0, 0, 0 },
/* U+563e */ { 0, 0, 0, 0, 0 },
/* U+563f */ { 0, 0, 0, 0, 0 },
/* U+5640 */ { 0, 0, 0, 0, 0 },
/* U+5641 */ { 0, 0, 0, 0, 0 },
/* U+5642 */ { 0, 0, 0, 0, 0 },
/* U+5643 */ { 0, 0, 0, 0, 0 },
/* U+5644 */ { 0, 0, 0, 0, 0 },
/* U+5645 */ { 0, 0, 0, 0, 0 },
/* U+5646 */ { 0, 0, 0, 0, 0 },
/* U+5647 */ { 0, 0, 0, 0, 0 },
/* U+5648 */ { 0, 0, 0, 0, 0 },
/* U+5649 */ { 0, 0, 0, 0, 0 },
/* U+564a */ { 0, 0, 0, 0, 0 },
/* U+564b */ { 0, 0, 0, 0, 0 },
/* U+564c */ { 0, 0, 0, 0, 0 },
/* U+564d */ { 0, 0, 0, 0, 0 },
/* U+564e */ { 0, 0, 0, 0, 0 },
/* U+564f */ { 0, 0, 0, 0, 0 },
/* U+5650 */ { 0, 0, 0, 0, 0 },
/* U+5651 */ { 0, 0, 0, 0, 0 },
/* U+5652 */ { 0, 0, 0, 0, 0 },
/* U+5653 */ { 0, 0, 0, 0, 0 },
/* U+5654 */ { 0, 0, 0, 0, 0 },
/* U+5655 */ { 0, 0, 0, 0, 0 },
/* U+5656 */ { 0, 0, 0, 0, 0 },
/* U+5657 */ { 0, 0, 0, 0, 0 },
/* U+5658 */ { 0, 0, 0, 0, 0 },
/* U+5659 */ { 0, 0, 0, 0, 0 },
/* U+565a */ { 0, 0, 0, 0, 0 },
/* U+565b */ { 0, 0, 0, 0, 0 },
/* U+565c */ { 0, 0, 0, 0, 0 },
/* U+565d */ { 0, 0, 0, 0, 0 },
/* U+565e */ { 0, 0, 0, 0, 0 },
/* U+565f */ { 0, 0, 0, 0, 0 },
/* U+5660 */ { 0, 0, 0, 0, 0 },
/* U+5661 */ { 0, 0, 0, 0, 0 },
/* U+5662 */ { 0, 0, 0, 0, 0 },
/* U+5663 */ { 0, 0, 0, 0, 0 },
/* U+5664 */ { 0, 0, 0, 0, 0 },
/* U+5665 */ { 0, 0, 0, 0, 0 },
/* U+5666 */ { 0, 0, 0, 0, 0 },
/* U+5667 */ { 0, 0, 0, 0, 0 },
/* U+5668 */ { 0, 0, 0, 0, 0 },
/* U+5669 */ { 0, 0, 0, 0, 0 },
/* U+566a */ { 0, 0, 0, 0, 0 },
/* U+566b */ { 0, 0, 0, 0, 0 },
/* U+566c */ { 0, 0, 0, 0, 0 },
/* U+566d */ { 0, 0, 0, 0, 0 },
/* U+566e */ { 0, 0, 0, 0, 0 },
/* U+566f */ { 0, 0, 0, 0, 0 },
/* U+5670 */ { 0, 0, 0, 0, 0 },
/* U+5671 */ { 0, 0, 0, 0, 0 },
/* U+5672 */ { 0, 0, 0, 0, 0 },
/* U+5673 */ { 0, 0, 0, 0, 0 },
/* U+5674 */ { 0, 0, 0, 0, 0 },
/* U+5675 */ { 0, 0, 0, 0, 0 },
/* U+5676 */ { 0, 0, 0, 0, 0 },
/* U+5677 */ { 0, 0, 0, 0, 0 },
/* U+5678 */ { 0, 0, 0, 0, 0 },
/* U+5679 */ { 0, 0, 0, 0, 0 },
/* U+567a */ { 0, 0, 0, 0, 0 },
/* U+567b */ { 0, 0, 0, 0, 0 },
/* U+567c */ { 0, 0, 0, 0, 0 },
/* U+567d */ { 0, 0, 0, 0, 0 },
/* U+567e */ { 0, 0, 0, 0, 0 },
/* U+567f */ { 0, 0, 0, 0, 0 },
/* U+5680 */ { 0, 0, 0, 0, 0 },
/* U+5681 */ { 0, 0, 0, 0, 0 },
/* U+5682 */ { 0, 0, 0, 0, 0 },
/* U+5683 */ { 0, 0, 0, 0, 0 },
/* U+5684 */ { 0, 0, 0, 0, 0 },
/* U+5685 */ { 0, 0, 0, 0, 0 },
/* U+5686 */ { 0, 0, 0, 0, 0 },
/* U+5687 */ { 0, 0, 0, 0, 0 },
/* U+5688 */ { 0, 0, 0, 0, 0 },
/* U+5689 */ { 0, 0, 0, 0, 0 },
/* U+568a */ { 0, 0, 0, 0, 0 },
/* U+568b */ { 0, 0, 0, 0, 0 },
/* U+568c */ { 0, 0, 0, 0, 0 },
/* U+568d */ { 0, 0, 0, 0, 0 },
/* U+568e */ { 0, 0, 0, 0, 0 },
/* U+568f */ { 0, 0, 0, 0, 0 },
/* U+5690 */ { 0, 0, 0, 0, 0 },
/* U+5691 */ { 0, 0, 0, 0, 0 },
/* U+5692 */ { 0, 0, 0, 0, 0 },
/* U+5693 */ { 0, 0, 0, 0, 0 },
/* U+5694 */ { 0, 0, 0, 0, 0 },
/* U+5695 */ { 0, 0, 0, 0, 0 },
/* U+5696 */ { 0, 0, 0, 0, 0 },
/* U+5697 */ { 0, 0, 0, 0, 0 },
/* U+5698 */ { 0, 0, 0, 0, 0 },
/* U+5699 */ { 0, 0, 0, 0, 0 },
/* U+569a */ { 0, 0, 0, 0, 0 },
/* U+569b */ { 0, 0, 0, 0, 0 },
/* U+569c */ { 0, 0, 0, 0, 0 },
/* U+569d */ { 0, 0, 0, 0, 0 },
/* U+569e */ { 0, 0, 0, 0, 0 },
/* U+569f */ { 0, 0, 0, 0, 0 },
/* U+56a0 */ { 0, 0, 0, 0, 0 },
/* U+56a1 */ { 0, 0, 0, 0, 0 },
/* U+56a2 */ { 0, 0, 0, 0, 0 },
/* U+56a3 */ { 0, 0, 0, 0, 0 },
/* U+56a4 */ { 0, 0, 0, 0, 0 },
/* U+56a5 */ { 0, 0, 0, 0, 0 },
/* U+56a6 */ { 0, 0, 0, 0, 0 },
/* U+56a7 */ { 0, 0, 0, 0, 0 },
/* U+56a8 */ { 0, 0, 0, 0, 0 },
/* U+56a9 */ { 0, 0, 0, 0, 0 },
/* U+56aa */ { 0, 0, 0, 0, 0 },
/* U+56ab */ { 0, 0, 0, 0, 0 },
/* U+56ac */ { 0, 0, 0, 0, 0 },
/* U+56ad */ { 0, 0, 0, 0, 0 },
/* U+56ae */ { 0, 0, 0, 0, 0 },
/* U+56af */ { 0, 0, 0, 0, 0 },
/* U+56b0 */ { 0, 0, 0, 0, 0 },
/* U+56b1 */ { 0, 0, 0, 0, 0 },
/* U+56b2 */ { 0, 0, 0, 0, 0 },
/* U+56b3 */ { 0, 0, 0, 0, 0 },
/* U+56b4 */ { 0, 0, 0, 0, 0 },
/* U+56b5 */ { 0, 0, 0, 0, 0 },
/* U+56b6 */ { 0, 0, 0, 0, 0 },
/* U+56b7 */ { 0, 0, 0, 0, 0 },
/* U+56b8 */ { 0, 0, 0, 0, 0 },
/* U+56b9 */ { 0, 0, 0, 0, 0 },
/* U+56ba */ { 0, 0, 0, 0, 0 },
/* U+56bb */ { 0, 0, 0, 0, 0 },
/* U+56bc */ { 0, 0, 0, 0, 0 },
/* U+56bd */ { 0, 0, 0, 0, 0 },
/* U+56be */ { 0, 0, 0, 0, 0 },
/* U+56bf */ { 0, 0, 0, 0, 0 },
/* U+56c0 */ { 0, 0, 0, 0, 0 },
/* U+56c1 */ { 0, 0, 0, 0, 0 },
/* U+56c2 */ { 0, 0, 0, 0, 0 },
/* U+56c3 */ { 0, 0, 0, 0, 0 },
/* U+56c4 */ { 0, 0, 0, 0, 0 },
/* U+56c5 */ { 0, 0, 0, 0, 0 },
/* U+56c6 */ { 0, 0, 0, 0, 0 },
/* U+56c7 */ { 0, 0, 0, 0, 0 },
/* U+56c8 */ { 0, 0, 0, 0, 0 },
/* U+56c9 */ { 0, 0, 0, 0, 0 },
/* U+56ca */ { 0, 0, 0, 0, 0 },
/* U+56cb */ { 0, 0, 0, 0, 0 },
/* U+56cc */ { 0, 0, 0, 0, 0 },
/* U+56cd */ { 0, 0, 0, 0, 0 },
/* U+56ce */ { 0, 0, 0, 0, 0 },
/* U+56cf */ { 0, 0, 0, 0, 0 },
/* U+56d0 */ { 0, 0, 0, 0, 0 },
/* U+56d1 */ { 0, 0, 0, 0, 0 },
/* U+56d2 */ { 0, 0, 0, 0, 0 },
/* U+56d3 */ { 0, 0, 0, 0, 0 },
/* U+56d4 */ { 0, 0, 0, 0, 0 },
/* U+56d5 */ { 0, 0, 0, 0, 0 },
/* U+56d6 */ { 0, 0, 0, 0, 0 },
/* U+56d7 */ { 0, 0, 0, 0, 0 },
/* U+56d8 */ { 0, 0, 0, 0, 0 },
/* U+56d9 */ { 0, 0, 0, 0, 0 },
/* U+56da */ { 0, 0, 0, 0, 0 },
/* U+56db */ { 0, 0, 0, 0, 0 },
/* U+56dc */ { 0, 0, 0, 0, 0 },
/* U+56dd */ { 0, 0, 0, 0, 0 },
/* U+56de */ { 0, 0, 0, 0, 0 },
/* U+56df */ { 0, 0, 0, 0, 0 },
/* U+56e0 */ { 0, 0, 0, 0, 0 },
/* U+56e1 */ { 0, 0, 0, 0, 0 },
/* U+56e2 */ { 0, 0, 0, 0, 0 },
/* U+56e3 */ { 0, 0, 0, 0, 0 },
/* U+56e4 */ { 0, 0, 0, 0, 0 },
/* U+56e5 */ { 0, 0, 0, 0, 0 },
/* U+56e6 */ { 0, 0, 0, 0, 0 },
/* U+56e7 */ { 0, 0, 0, 0, 0 },
/* U+56e8 */ { 0, 0, 0, 0, 0 },
/* U+56e9 */ { 0, 0, 0, 0, 0 },
/* U+56ea */ { 0, 0, 0, 0, 0 },
/* U+56eb */ { 0, 0, 0, 0, 0 },
/* U+56ec */ { 0, 0, 0, 0, 0 },
/* U+56ed */ { 0, 0, 0, 0, 0 },
/* U+56ee */ { 0, 0, 0, 0, 0 },
/* U+56ef */ { 0, 0, 0, 0, 0 },
/* U+56f0 */ { 0, 0, 0, 0, 0 },
/* U+56f1 */ { 0, 0, 0, 0, 0 },
/* U+56f2 */ { 0, 0, 0, 0, 0 },
/* U+56f3 */ { 0, 0, 0, 0, 0 },
/* U+56f4 */ { 0, 0, 0, 0, 0 },
/* U+56f5 */ { 0, 0, 0, 0, 0 },
/* U+56f6 */ { 0, 0, 0, 0, 0 },
/* U+56f7 */ { 0, 0, 0, 0, 0 },
/* U+56f8 */ { 0, 0, 0, 0, 0 },
/* U+56f9 */ { 0, 0, 0, 0, 0 },
/* U+56fa */ { 0, 0, 0, 0, 0 },
/* U+56fb */ { 0, 0, 0, 0, 0 },
/* U+56fc */ { 0, 0, 0, 0, 0 },
/* U+56fd */ { 0, 0, 0, 0, 0 },
/* U+56fe */ { 0, 0, 0, 0, 0 },
/* U+56ff */ { 0, 0, 0, 0, 0 },
/* U+5700 */ { 0, 0, 0, 0, 0 },
/* U+5701 */ { 0, 0, 0, 0, 0 },
/* U+5702 */ { 0, 0, 0, 0, 0 },
/* U+5703 */ { 0, 0, 0, 0, 0 },
/* U+5704 */ { 0, 0, 0, 0, 0 },
/* U+5705 */ { 0, 0, 0, 0, 0 },
/* U+5706 */ { 0, 0, 0, 0, 0 },
/* U+5707 */ { 0, 0, 0, 0, 0 },
/* U+5708 */ { 0, 0, 0, 0, 0 },
/* U+5709 */ { 0, 0, 0, 0, 0 },
/* U+570a */ { 0, 0, 0, 0, 0 },
/* U+570b */ { 0, 0, 0, 0, 0 },
/* U+570c */ { 0, 0, 0, 0, 0 },
/* U+570d */ { 0, 0, 0, 0, 0 },
/* U+570e */ { 0, 0, 0, 0, 0 },
/* U+570f */ { 0, 0, 0, 0, 0 },
/* U+5710 */ { 0, 0, 0, 0, 0 },
/* U+5711 */ { 0, 0, 0, 0, 0 },
/* U+5712 */ { 0, 0, 0, 0, 0 },
/* U+5713 */ { 0, 0, 0, 0, 0 },
/* U+5714 */ { 0, 0, 0, 0, 0 },
/* U+5715 */ { 0, 0, 0, 0, 0 },
/* U+5716 */ { 0, 0, 0, 0, 0 },
/* U+5717 */ { 0, 0, 0, 0, 0 },
/* U+5718 */ { 0, 0, 0, 0, 0 },
/* U+5719 */ { 0, 0, 0, 0, 0 },
/* U+571a */ { 0, 0, 0, 0, 0 },
/* U+571b */ { 0, 0, 0, 0, 0 },
/* U+571c */ { 0, 0, 0, 0, 0 },
/* U+571d */ { 0, 0, 0, 0, 0 },
/* U+571e */ { 0, 0, 0, 0, 0 },
/* U+571f */ { 0, 0, 0, 0, 0 },
/* U+5720 */ { 0, 0, 0, 0, 0 },
/* U+5721 */ { 0, 0, 0, 0, 0 },
/* U+5722 */ { 0, 0, 0, 0, 0 },
/* U+5723 */ { 0, 0, 0, 0, 0 },
/* U+5724 */ { 0, 0, 0, 0, 0 },
/* U+5725 */ { 0, 0, 0, 0, 0 },
/* U+5726 */ { 0, 0, 0, 0, 0 },
/* U+5727 */ { 0, 0, 0, 0, 0 },
/* U+5728 */ { 0, 0, 0, 0, 0 },
/* U+5729 */ { 0, 0, 0, 0, 0 },
/* U+572a */ { 0, 0, 0, 0, 0 },
/* U+572b */ { 0, 0, 0, 0, 0 },
/* U+572c */ { 0, 0, 0, 0, 0 },
/* U+572d */ { 0, 0, 0, 0, 0 },
/* U+572e */ { 0, 0, 0, 0, 0 },
/* U+572f */ { 0, 0, 0, 0, 0 },
/* U+5730 */ { 0, 0, 0, 0, 0 },
/* U+5731 */ { 0, 0, 0, 0, 0 },
/* U+5732 */ { 0, 0, 0, 0, 0 },
/* U+5733 */ { 0, 0, 0, 0, 0 },
/* U+5734 */ { 0, 0, 0, 0, 0 },
/* U+5735 */ { 0, 0, 0, 0, 0 },
/* U+5736 */ { 0, 0, 0, 0, 0 },
/* U+5737 */ { 0, 0, 0, 0, 0 },
/* U+5738 */ { 0, 0, 0, 0, 0 },
/* U+5739 */ { 0, 0, 0, 0, 0 },
/* U+573a */ { 0, 0, 0, 0, 0 },
/* U+573b */ { 0, 0, 0, 0, 0 },
/* U+573c */ { 0, 0, 0, 0, 0 },
/* U+573d */ { 0, 0, 0, 0, 0 },
/* U+573e */ { 0, 0, 0, 0, 0 },
/* U+573f */ { 0, 0, 0, 0, 0 },
/* U+5740 */ { 0, 0, 0, 0, 0 },
/* U+5741 */ { 0, 0, 0, 0, 0 },
/* U+5742 */ { 0, 0, 0, 0, 0 },
/* U+5743 */ { 0, 0, 0, 0, 0 },
/* U+5744 */ { 0, 0, 0, 0, 0 },
/* U+5745 */ { 0, 0, 0, 0, 0 },
/* U+5746 */ { 0, 0, 0, 0, 0 },
/* U+5747 */ { 0, 0, 0, 0, 0 },
/* U+5748 */ { 0, 0, 0, 0, 0 },
/* U+5749 */ { 0, 0, 0, 0, 0 },
/* U+574a */ { 0, 0, 0, 0, 0 },
/* U+574b */ { 0, 0, 0, 0, 0 },
/* U+574c */ { 0, 0, 0, 0, 0 },
/* U+574d */ { 0, 0, 0, 0, 0 },
/* U+574e */ { 0, 0, 0, 0, 0 },
/* U+574f */ { 0, 0, 0, 0, 0 },
/* U+5750 */ { 0, 0, 0, 0, 0 },
/* U+5751 */ { 0, 0, 0, 0, 0 },
/* U+5752 */ { 0, 0, 0, 0, 0 },
/* U+5753 */ { 0, 0, 0, 0, 0 },
/* U+5754 */ { 0, 0, 0, 0, 0 },
/* U+5755 */ { 0, 0, 0, 0, 0 },
/* U+5756 */ { 0, 0, 0, 0, 0 },
/* U+5757 */ { 0, 0, 0, 0, 0 },
/* U+5758 */ { 0, 0, 0, 0, 0 },
/* U+5759 */ { 0, 0, 0, 0, 0 },
/* U+575a */ { 0, 0, 0, 0, 0 },
/* U+575b */ { 0, 0, 0, 0, 0 },
/* U+575c */ { 0, 0, 0, 0, 0 },
/* U+575d */ { 0, 0, 0, 0, 0 },
/* U+575e */ { 0, 0, 0, 0, 0 },
/* U+575f */ { 0, 0, 0, 0, 0 },
/* U+5760 */ { 0, 0, 0, 0, 0 },
/* U+5761 */ { 0, 0, 0, 0, 0 },
/* U+5762 */ { 0, 0, 0, 0, 0 },
/* U+5763 */ { 0, 0, 0, 0, 0 },
/* U+5764 */ { 0, 0, 0, 0, 0 },
/* U+5765 */ { 0, 0, 0, 0, 0 },
/* U+5766 */ { 0, 0, 0, 0, 0 },
/* U+5767 */ { 0, 0, 0, 0, 0 },
/* U+5768 */ { 0, 0, 0, 0, 0 },
/* U+5769 */ { 0, 0, 0, 0, 0 },
/* U+576a */ { 0, 0, 0, 0, 0 },
/* U+576b */ { 0, 0, 0, 0, 0 },
/* U+576c */ { 0, 0, 0, 0, 0 },
/* U+576d */ { 0, 0, 0, 0, 0 },
/* U+576e */ { 0, 0, 0, 0, 0 },
/* U+576f */ { 0, 0, 0, 0, 0 },
/* U+5770 */ { 0, 0, 0, 0, 0 },
/* U+5771 */ { 0, 0, 0, 0, 0 },
/* U+5772 */ { 0, 0, 0, 0, 0 },
/* U+5773 */ { 0, 0, 0, 0, 0 },
/* U+5774 */ { 0, 0, 0, 0, 0 },
/* U+5775 */ { 0, 0, 0, 0, 0 },
/* U+5776 */ { 0, 0, 0, 0, 0 },
/* U+5777 */ { 0, 0, 0, 0, 0 },
/* U+5778 */ { 0, 0, 0, 0, 0 },
/* U+5779 */ { 0, 0, 0, 0, 0 },
/* U+577a */ { 0, 0, 0, 0, 0 },
/* U+577b */ { 0, 0, 0, 0, 0 },
/* U+577c */ { 0, 0, 0, 0, 0 },
/* U+577d */ { 0, 0, 0, 0, 0 },
/* U+577e */ { 0, 0, 0, 0, 0 },
/* U+577f */ { 0, 0, 0, 0, 0 },
/* U+5780 */ { 0, 0, 0, 0, 0 },
/* U+5781 */ { 0, 0, 0, 0, 0 },
/* U+5782 */ { 0, 0, 0, 0, 0 },
/* U+5783 */ { 0, 0, 0, 0, 0 },
/* U+5784 */ { 0, 0, 0, 0, 0 },
/* U+5785 */ { 0, 0, 0, 0, 0 },
/* U+5786 */ { 0, 0, 0, 0, 0 },
/* U+5787 */ { 0, 0, 0, 0, 0 },
/* U+5788 */ { 0, 0, 0, 0, 0 },
/* U+5789 */ { 0, 0, 0, 0, 0 },
/* U+578a */ { 0, 0, 0, 0, 0 },
/* U+578b */ { 0, 0, 0, 0, 0 },
/* U+578c */ { 0, 0, 0, 0, 0 },
/* U+578d */ { 0, 0, 0, 0, 0 },
/* U+578e */ { 0, 0, 0, 0, 0 },
/* U+578f */ { 0, 0, 0, 0, 0 },
/* U+5790 */ { 0, 0, 0, 0, 0 },
/* U+5791 */ { 0, 0, 0, 0, 0 },
/* U+5792 */ { 0, 0, 0, 0, 0 },
/* U+5793 */ { 0, 0, 0, 0, 0 },
/* U+5794 */ { 0, 0, 0, 0, 0 },
/* U+5795 */ { 0, 0, 0, 0, 0 },
/* U+5796 */ { 0, 0, 0, 0, 0 },
/* U+5797 */ { 0, 0, 0, 0, 0 },
/* U+5798 */ { 0, 0, 0, 0, 0 },
/* U+5799 */ { 0, 0, 0, 0, 0 },
/* U+579a */ { 0, 0, 0, 0, 0 },
/* U+579b */ { 0, 0, 0, 0, 0 },
/* U+579c */ { 0, 0, 0, 0, 0 },
/* U+579d */ { 0, 0, 0, 0, 0 },
/* U+579e */ { 0, 0, 0, 0, 0 },
/* U+579f */ { 0, 0, 0, 0, 0 },
/* U+57a0 */ { 0, 0, 0, 0, 0 },
/* U+57a1 */ { 0, 0, 0, 0, 0 },
/* U+57a2 */ { 0, 0, 0, 0, 0 },
/* U+57a3 */ { 0, 0, 0, 0, 0 },
/* U+57a4 */ { 0, 0, 0, 0, 0 },
/* U+57a5 */ { 0, 0, 0, 0, 0 },
/* U+57a6 */ { 0, 0, 0, 0, 0 },
/* U+57a7 */ { 0, 0, 0, 0, 0 },
/* U+57a8 */ { 0, 0, 0, 0, 0 },
/* U+57a9 */ { 0, 0, 0, 0, 0 },
/* U+57aa */ { 0, 0, 0, 0, 0 },
/* U+57ab */ { 0, 0, 0, 0, 0 },
/* U+57ac */ { 0, 0, 0, 0, 0 },
/* U+57ad */ { 0, 0, 0, 0, 0 },
/* U+57ae */ { 0, 0, 0, 0, 0 },
/* U+57af */ { 0, 0, 0, 0, 0 },
/* U+57b0 */ { 0, 0, 0, 0, 0 },
/* U+57b1 */ { 0, 0, 0, 0, 0 },
/* U+57b2 */ { 0, 0, 0, 0, 0 },
/* U+57b3 */ { 0, 0, 0, 0, 0 },
/* U+57b4 */ { 0, 0, 0, 0, 0 },
/* U+57b5 */ { 0, 0, 0, 0, 0 },
/* U+57b6 */ { 0, 0, 0, 0, 0 },
/* U+57b7 */ { 0, 0, 0, 0, 0 },
/* U+57b8 */ { 0, 0, 0, 0, 0 },
/* U+57b9 */ { 0, 0, 0, 0, 0 },
/* U+57ba */ { 0, 0, 0, 0, 0 },
/* U+57bb */ { 0, 0, 0, 0, 0 },
/* U+57bc */ { 0, 0, 0, 0, 0 },
/* U+57bd */ { 0, 0, 0, 0, 0 },
/* U+57be */ { 0, 0, 0, 0, 0 },
/* U+57bf */ { 0, 0, 0, 0, 0 },
/* U+57c0 */ { 0, 0, 0, 0, 0 },
/* U+57c1 */ { 0, 0, 0, 0, 0 },
/* U+57c2 */ { 0, 0, 0, 0, 0 },
/* U+57c3 */ { 0, 0, 0, 0, 0 },
/* U+57c4 */ { 0, 0, 0, 0, 0 },
/* U+57c5 */ { 0, 0, 0, 0, 0 },
/* U+57c6 */ { 0, 0, 0, 0, 0 },
/* U+57c7 */ { 0, 0, 0, 0, 0 },
/* U+57c8 */ { 0, 0, 0, 0, 0 },
/* U+57c9 */ { 0, 0, 0, 0, 0 },
/* U+57ca */ { 0, 0, 0, 0, 0 },
/* U+57cb */ { 0, 0, 0, 0, 0 },
/* U+57cc */ { 0, 0, 0, 0, 0 },
/* U+57cd */ { 0, 0, 0, 0, 0 },
/* U+57ce */ { 0, 0, 0, 0, 0 },
/* U+57cf */ { 0, 0, 0, 0, 0 },
/* U+57d0 */ { 0, 0, 0, 0, 0 },
/* U+57d1 */ { 0, 0, 0, 0, 0 },
/* U+57d2 */ { 0, 0, 0, 0, 0 },
/* U+57d3 */ { 0, 0, 0, 0, 0 },
/* U+57d4 */ { 0, 0, 0, 0, 0 },
/* U+57d5 */ { 0, 0, 0, 0, 0 },
/* U+57d6 */ { 0, 0, 0, 0, 0 },
/* U+57d7 */ { 0, 0, 0, 0, 0 },
/* U+57d8 */ { 0, 0, 0, 0, 0 },
/* U+57d9 */ { 0, 0, 0, 0, 0 },
/* U+57da */ { 0, 0, 0, 0, 0 },
/* U+57db */ { 0, 0, 0, 0, 0 },
/* U+57dc */ { 0, 0, 0, 0, 0 },
/* U+57dd */ { 0, 0, 0, 0, 0 },
/* U+57de */ { 0, 0, 0, 0, 0 },
/* U+57df */ { 0, 0, 0, 0, 0 },
/* U+57e0 */ { 0, 0, 0, 0, 0 },
/* U+57e1 */ { 0, 0, 0, 0, 0 },
/* U+57e2 */ { 0, 0, 0, 0, 0 },
/* U+57e3 */ { 0, 0, 0, 0, 0 },
/* U+57e4 */ { 0, 0, 0, 0, 0 },
/* U+57e5 */ { 0, 0, 0, 0, 0 },
/* U+57e6 */ { 0, 0, 0, 0, 0 },
/* U+57e7 */ { 0, 0, 0, 0, 0 },
/* U+57e8 */ { 0, 0, 0, 0, 0 },
/* U+57e9 */ { 0, 0, 0, 0, 0 },
/* U+57ea */ { 0, 0, 0, 0, 0 },
/* U+57eb */ { 0, 0, 0, 0, 0 },
/* U+57ec */ { 0, 0, 0, 0, 0 },
/* U+57ed */ { 0, 0, 0, 0, 0 },
/* U+57ee */ { 0, 0, 0, 0, 0 },
/* U+57ef */ { 0, 0, 0, 0, 0 },
/* U+57f0 */ { 0, 0, 0, 0, 0 },
/* U+57f1 */ { 0, 0, 0, 0, 0 },
/* U+57f2 */ { 0, 0, 0, 0, 0 },
/* U+57f3 */ { 0, 0, 0, 0, 0 },
/* U+57f4 */ { 0, 0, 0, 0, 0 },
/* U+57f5 */ { 0, 0, 0, 0, 0 },
/* U+57f6 */ { 0, 0, 0, 0, 0 },
/* U+57f7 */ { 0, 0, 0, 0, 0 },
/* U+57f8 */ { 0, 0, 0, 0, 0 },
/* U+57f9 */ { 0, 0, 0, 0, 0 },
/* U+57fa */ { 0, 0, 0, 0, 0 },
/* U+57fb */ { 0, 0, 0, 0, 0 },
/* U+57fc */ { 0, 0, 0, 0, 0 },
/* U+57fd */ { 0, 0, 0, 0, 0 },
/* U+57fe */ { 0, 0, 0, 0, 0 },
/* U+57ff */ { 0, 0, 0, 0, 0 },
/* U+5800 */ { 0, 0, 0, 0, 0 },
/* U+5801 */ { 0, 0, 0, 0, 0 },
/* U+5802 */ { 0, 0, 0, 0, 0 },
/* U+5803 */ { 0, 0, 0, 0, 0 },
/* U+5804 */ { 0, 0, 0, 0, 0 },
/* U+5805 */ { 0, 0, 0, 0, 0 },
/* U+5806 */ { 0, 0, 0, 0, 0 },
/* U+5807 */ { 0, 0, 0, 0, 0 },
/* U+5808 */ { 0, 0, 0, 0, 0 },
/* U+5809 */ { 0, 0, 0, 0, 0 },
/* U+580a */ { 0, 0, 0, 0, 0 },
/* U+580b */ { 0, 0, 0, 0, 0 },
/* U+580c */ { 0, 0, 0, 0, 0 },
/* U+580d */ { 0, 0, 0, 0, 0 },
/* U+580e */ { 0, 0, 0, 0, 0 },
/* U+580f */ { 0, 0, 0, 0, 0 },
/* U+5810 */ { 0, 0, 0, 0, 0 },
/* U+5811 */ { 0, 0, 0, 0, 0 },
/* U+5812 */ { 0, 0, 0, 0, 0 },
/* U+5813 */ { 0, 0, 0, 0, 0 },
/* U+5814 */ { 0, 0, 0, 0, 0 },
/* U+5815 */ { 0, 0, 0, 0, 0 },
/* U+5816 */ { 0, 0, 0, 0, 0 },
/* U+5817 */ { 0, 0, 0, 0, 0 },
/* U+5818 */ { 0, 0, 0, 0, 0 },
/* U+5819 */ { 0, 0, 0, 0, 0 },
/* U+581a */ { 0, 0, 0, 0, 0 },
/* U+581b */ { 0, 0, 0, 0, 0 },
/* U+581c */ { 0, 0, 0, 0, 0 },
/* U+581d */ { 0, 0, 0, 0, 0 },
/* U+581e */ { 0, 0, 0, 0, 0 },
/* U+581f */ { 0, 0, 0, 0, 0 },
/* U+5820 */ { 0, 0, 0, 0, 0 },
/* U+5821 */ { 0, 0, 0, 0, 0 },
/* U+5822 */ { 0, 0, 0, 0, 0 },
/* U+5823 */ { 0, 0, 0, 0, 0 },
/* U+5824 */ { 0, 0, 0, 0, 0 },
/* U+5825 */ { 0, 0, 0, 0, 0 },
/* U+5826 */ { 0, 0, 0, 0, 0 },
/* U+5827 */ { 0, 0, 0, 0, 0 },
/* U+5828 */ { 0, 0, 0, 0, 0 },
/* U+5829 */ { 0, 0, 0, 0, 0 },
/* U+582a */ { 0, 0, 0, 0, 0 },
/* U+582b */ { 0, 0, 0, 0, 0 },
/* U+582c */ { 0, 0, 0, 0, 0 },
/* U+582d */ { 0, 0, 0, 0, 0 },
/* U+582e */ { 0, 0, 0, 0, 0 },
/* U+582f */ { 0, 0, 0, 0, 0 },
/* U+5830 */ { 0, 0, 0, 0, 0 },
/* U+5831 */ { 0, 0, 0, 0, 0 },
/* U+5832 */ { 0, 0, 0, 0, 0 },
/* U+5833 */ { 0, 0, 0, 0, 0 },
/* U+5834 */ { 0, 0, 0, 0, 0 },
/* U+5835 */ { 0, 0, 0, 0, 0 },
/* U+5836 */ { 0, 0, 0, 0, 0 },
/* U+5837 */ { 0, 0, 0, 0, 0 },
/* U+5838 */ { 0, 0, 0, 0, 0 },
/* U+5839 */ { 0, 0, 0, 0, 0 },
/* U+583a */ { 0, 0, 0, 0, 0 },
/* U+583b */ { 0, 0, 0, 0, 0 },
/* U+583c */ { 0, 0, 0, 0, 0 },
/* U+583d */ { 0, 0, 0, 0, 0 },
/* U+583e */ { 0, 0, 0, 0, 0 },
/* U+583f */ { 0, 0, 0, 0, 0 },
/* U+5840 */ { 0, 0, 0, 0, 0 },
/* U+5841 */ { 0, 0, 0, 0, 0 },
/* U+5842 */ { 0, 0, 0, 0, 0 },
/* U+5843 */ { 0, 0, 0, 0, 0 },
/* U+5844 */ { 0, 0, 0, 0, 0 },
/* U+5845 */ { 0, 0, 0, 0, 0 },
/* U+5846 */ { 0, 0, 0, 0, 0 },
/* U+5847 */ { 0, 0, 0, 0, 0 },
/* U+5848 */ { 0, 0, 0, 0, 0 },
/* U+5849 */ { 0, 0, 0, 0, 0 },
/* U+584a */ { 0, 0, 0, 0, 0 },
/* U+584b */ { 0, 0, 0, 0, 0 },
/* U+584c */ { 0, 0, 0, 0, 0 },
/* U+584d */ { 0, 0, 0, 0, 0 },
/* U+584e */ { 0, 0, 0, 0, 0 },
/* U+584f */ { 0, 0, 0, 0, 0 },
/* U+5850 */ { 0, 0, 0, 0, 0 },
/* U+5851 */ { 0, 0, 0, 0, 0 },
/* U+5852 */ { 0, 0, 0, 0, 0 },
/* U+5853 */ { 0, 0, 0, 0, 0 },
/* U+5854 */ { 0, 0, 0, 0, 0 },
/* U+5855 */ { 0, 0, 0, 0, 0 },
/* U+5856 */ { 0, 0, 0, 0, 0 },
/* U+5857 */ { 0, 0, 0, 0, 0 },
/* U+5858 */ { 0, 0, 0, 0, 0 },
/* U+5859 */ { 0, 0, 0, 0, 0 },
/* U+585a */ { 0, 0, 0, 0, 0 },
/* U+585b */ { 0, 0, 0, 0, 0 },
/* U+585c */ { 0, 0, 0, 0, 0 },
/* U+585d */ { 0, 0, 0, 0, 0 },
/* U+585e */ { 0, 0, 0, 0, 0 },
/* U+585f */ { 0, 0, 0, 0, 0 },
/* U+5860 */ { 0, 0, 0, 0, 0 },
/* U+5861 */ { 0, 0, 0, 0, 0 },
/* U+5862 */ { 0, 0, 0, 0, 0 },
/* U+5863 */ { 0, 0, 0, 0, 0 },
/* U+5864 */ { 0, 0, 0, 0, 0 },
/* U+5865 */ { 0, 0, 0, 0, 0 },
/* U+5866 */ { 0, 0, 0, 0, 0 },
/* U+5867 */ { 0, 0, 0, 0, 0 },
/* U+5868 */ { 0, 0, 0, 0, 0 },
/* U+5869 */ { 0, 0, 0, 0, 0 },
/* U+586a */ { 0, 0, 0, 0, 0 },
/* U+586b */ { 0, 0, 0, 0, 0 },
/* U+586c */ { 0, 0, 0, 0, 0 },
/* U+586d */ { 0, 0, 0, 0, 0 },
/* U+586e */ { 0, 0, 0, 0, 0 },
/* U+586f */ { 0, 0, 0, 0, 0 },
/* U+5870 */ { 0, 0, 0, 0, 0 },
/* U+5871 */ { 0, 0, 0, 0, 0 },
/* U+5872 */ { 0, 0, 0, 0, 0 },
/* U+5873 */ { 0, 0, 0, 0, 0 },
/* U+5874 */ { 0, 0, 0, 0, 0 },
/* U+5875 */ { 0, 0, 0, 0, 0 },
/* U+5876 */ { 0, 0, 0, 0, 0 },
/* U+5877 */ { 0, 0, 0, 0, 0 },
/* U+5878 */ { 0, 0, 0, 0, 0 },
/* U+5879 */ { 0, 0, 0, 0, 0 },
/* U+587a */ { 0, 0, 0, 0, 0 },
/* U+587b */ { 0, 0, 0, 0, 0 },
/* U+587c */ { 0, 0, 0, 0, 0 },
/* U+587d */ { 0, 0, 0, 0, 0 },
/* U+587e */ { 0, 0, 0, 0, 0 },
/* U+587f */ { 0, 0, 0, 0, 0 },
/* U+5880 */ { 0, 0, 0, 0, 0 },
/* U+5881 */ { 0, 0, 0, 0, 0 },
/* U+5882 */ { 0, 0, 0, 0, 0 },
/* U+5883 */ { 0, 0, 0, 0, 0 },
/* U+5884 */ { 0, 0, 0, 0, 0 },
/* U+5885 */ { 0, 0, 0, 0, 0 },
/* U+5886 */ { 0, 0, 0, 0, 0 },
/* U+5887 */ { 0, 0, 0, 0, 0 },
/* U+5888 */ { 0, 0, 0, 0, 0 },
/* U+5889 */ { 0, 0, 0, 0, 0 },
/* U+588a */ { 0, 0, 0, 0, 0 },
/* U+588b */ { 0, 0, 0, 0, 0 },
/* U+588c */ { 0, 0, 0, 0, 0 },
/* U+588d */ { 0, 0, 0, 0, 0 },
/* U+588e */ { 0, 0, 0, 0, 0 },
/* U+588f */ { 0, 0, 0, 0, 0 },
/* U+5890 */ { 0, 0, 0, 0, 0 },
/* U+5891 */ { 0, 0, 0, 0, 0 },
/* U+5892 */ { 0, 0, 0, 0, 0 },
/* U+5893 */ { 0, 0, 0, 0, 0 },
/* U+5894 */ { 0, 0, 0, 0, 0 },
/* U+5895 */ { 0, 0, 0, 0, 0 },
/* U+5896 */ { 0, 0, 0, 0, 0 },
/* U+5897 */ { 0, 0, 0, 0, 0 },
/* U+5898 */ { 0, 0, 0, 0, 0 },
/* U+5899 */ { 0, 0, 0, 0, 0 },
/* U+589a */ { 0, 0, 0, 0, 0 },
/* U+589b */ { 0, 0, 0, 0, 0 },
/* U+589c */ { 0, 0, 0, 0, 0 },
/* U+589d */ { 0, 0, 0, 0, 0 },
/* U+589e */ { 0, 0, 0, 0, 0 },
/* U+589f */ { 0, 0, 0, 0, 0 },
/* U+58a0 */ { 0, 0, 0, 0, 0 },
/* U+58a1 */ { 0, 0, 0, 0, 0 },
/* U+58a2 */ { 0, 0, 0, 0, 0 },
/* U+58a3 */ { 0, 0, 0, 0, 0 },
/* U+58a4 */ { 0, 0, 0, 0, 0 },
/* U+58a5 */ { 0, 0, 0, 0, 0 },
/* U+58a6 */ { 0, 0, 0, 0, 0 },
/* U+58a7 */ { 0, 0, 0, 0, 0 },
/* U+58a8 */ { 0, 0, 0, 0, 0 },
/* U+58a9 */ { 0, 0, 0, 0, 0 },
/* U+58aa */ { 0, 0, 0, 0, 0 },
/* U+58ab */ { 0, 0, 0, 0, 0 },
/* U+58ac */ { 0, 0, 0, 0, 0 },
/* U+58ad */ { 0, 0, 0, 0, 0 },
/* U+58ae */ { 0, 0, 0, 0, 0 },
/* U+58af */ { 0, 0, 0, 0, 0 },
/* U+58b0 */ { 0, 0, 0, 0, 0 },
/* U+58b1 */ { 0, 0, 0, 0, 0 },
/* U+58b2 */ { 0, 0, 0, 0, 0 },
/* U+58b3 */ { 0, 0, 0, 0, 0 },
/* U+58b4 */ { 0, 0, 0, 0, 0 },
/* U+58b5 */ { 0, 0, 0, 0, 0 },
/* U+58b6 */ { 0, 0, 0, 0, 0 },
/* U+58b7 */ { 0, 0, 0, 0, 0 },
/* U+58b8 */ { 0, 0, 0, 0, 0 },
/* U+58b9 */ { 0, 0, 0, 0, 0 },
/* U+58ba */ { 0, 0, 0, 0, 0 },
/* U+58bb */ { 0, 0, 0, 0, 0 },
/* U+58bc */ { 0, 0, 0, 0, 0 },
/* U+58bd */ { 0, 0, 0, 0, 0 },
/* U+58be */ { 0, 0, 0, 0, 0 },
/* U+58bf */ { 0, 0, 0, 0, 0 },
/* U+58c0 */ { 0, 0, 0, 0, 0 },
/* U+58c1 */ { 0, 0, 0, 0, 0 },
/* U+58c2 */ { 0, 0, 0, 0, 0 },
/* U+58c3 */ { 0, 0, 0, 0, 0 },
/* U+58c4 */ { 0, 0, 0, 0, 0 },
/* U+58c5 */ { 0, 0, 0, 0, 0 },
/* U+58c6 */ { 0, 0, 0, 0, 0 },
/* U+58c7 */ { 0, 0, 0, 0, 0 },
/* U+58c8 */ { 0, 0, 0, 0, 0 },
/* U+58c9 */ { 0, 0, 0, 0, 0 },
/* U+58ca */ { 0, 0, 0, 0, 0 },
/* U+58cb */ { 0, 0, 0, 0, 0 },
/* U+58cc */ { 0, 0, 0, 0, 0 },
/* U+58cd */ { 0, 0, 0, 0, 0 },
/* U+58ce */ { 0, 0, 0, 0, 0 },
/* U+58cf */ { 0, 0, 0, 0, 0 },
/* U+58d0 */ { 0, 0, 0, 0, 0 },
/* U+58d1 */ { 0, 0, 0, 0, 0 },
/* U+58d2 */ { 0, 0, 0, 0, 0 },
/* U+58d3 */ { 0, 0, 0, 0, 0 },
/* U+58d4 */ { 0, 0, 0, 0, 0 },
/* U+58d5 */ { 0, 0, 0, 0, 0 },
/* U+58d6 */ { 0, 0, 0, 0, 0 },
/* U+58d7 */ { 0, 0, 0, 0, 0 },
/* U+58d8 */ { 0, 0, 0, 0, 0 },
/* U+58d9 */ { 0, 0, 0, 0, 0 },
/* U+58da */ { 0, 0, 0, 0, 0 },
/* U+58db */ { 0, 0, 0, 0, 0 },
/* U+58dc */ { 0, 0, 0, 0, 0 },
/* U+58dd */ { 0, 0, 0, 0, 0 },
/* U+58de */ { 0, 0, 0, 0, 0 },
/* U+58df */ { 0, 0, 0, 0, 0 },
/* U+58e0 */ { 0, 0, 0, 0, 0 },
/* U+58e1 */ { 0, 0, 0, 0, 0 },
/* U+58e2 */ { 0, 0, 0, 0, 0 },
/* U+58e3 */ { 0, 0, 0, 0, 0 },
/* U+58e4 */ { 0, 0, 0, 0, 0 },
/* U+58e5 */ { 0, 0, 0, 0, 0 },
/* U+58e6 */ { 0, 0, 0, 0, 0 },
/* U+58e7 */ { 0, 0, 0, 0, 0 },
/* U+58e8 */ { 0, 0, 0, 0, 0 },
/* U+58e9 */ { 0, 0, 0, 0, 0 },
/* U+58ea */ { 0, 0, 0, 0, 0 },
/* U+58eb */ { 0, 0, 0, 0, 0 },
/* U+58ec */ { 0, 0, 0, 0, 0 },
/* U+58ed */ { 0, 0, 0, 0, 0 },
/* U+58ee */ { 0, 0, 0, 0, 0 },
/* U+58ef */ { 0, 0, 0, 0, 0 },
/* U+58f0 */ { 0, 0, 0, 0, 0 },
/* U+58f1 */ { 0, 0, 0, 0, 0 },
/* U+58f2 */ { 0, 0, 0, 0, 0 },
/* U+58f3 */ { 0, 0, 0, 0, 0 },
/* U+58f4 */ { 0, 0, 0, 0, 0 },
/* U+58f5 */ { 0, 0, 0, 0, 0 },
/* U+58f6 */ { 0, 0, 0, 0, 0 },
/* U+58f7 */ { 0, 0, 0, 0, 0 },
/* U+58f8 */ { 0, 0, 0, 0, 0 },
/* U+58f9 */ { 0, 0, 0, 0, 0 },
/* U+58fa */ { 0, 0, 0, 0, 0 },
/* U+58fb */ { 0, 0, 0, 0, 0 },
/* U+58fc */ { 0, 0, 0, 0, 0 },
/* U+58fd */ { 0, 0, 0, 0, 0 },
/* U+58fe */ { 0, 0, 0, 0, 0 },
/* U+58ff */ { 0, 0, 0, 0, 0 },
/* U+5900 */ { 0, 0, 0, 0, 0 },
/* U+5901 */ { 0, 0, 0, 0, 0 },
/* U+5902 */ { 0, 0, 0, 0, 0 },
/* U+5903 */ { 0, 0, 0, 0, 0 },
/* U+5904 */ { 0, 0, 0, 0, 0 },
/* U+5905 */ { 0, 0, 0, 0, 0 },
/* U+5906 */ { 0, 0, 0, 0, 0 },
/* U+5907 */ { 0, 0, 0, 0, 0 },
/* U+5908 */ { 0, 0, 0, 0, 0 },
/* U+5909 */ { 0, 0, 0, 0, 0 },
/* U+590a */ { 0, 0, 0, 0, 0 },
/* U+590b */ { 0, 0, 0, 0, 0 },
/* U+590c */ { 0, 0, 0, 0, 0 },
/* U+590d */ { 0, 0, 0, 0, 0 },
/* U+590e */ { 0, 0, 0, 0, 0 },
/* U+590f */ { 0, 0, 0, 0, 0 },
/* U+5910 */ { 0, 0, 0, 0, 0 },
/* U+5911 */ { 0, 0, 0, 0, 0 },
/* U+5912 */ { 0, 0, 0, 0, 0 },
/* U+5913 */ { 0, 0, 0, 0, 0 },
/* U+5914 */ { 0, 0, 0, 0, 0 },
/* U+5915 */ { 0, 0, 0, 0, 0 },
/* U+5916 */ { 0, 0, 0, 0, 0 },
/* U+5917 */ { 0, 0, 0, 0, 0 },
/* U+5918 */ { 0, 0, 0, 0, 0 },
/* U+5919 */ { 0, 0, 0, 0, 0 },
/* U+591a */ { 0, 0, 0, 0, 0 },
/* U+591b */ { 0, 0, 0, 0, 0 },
/* U+591c */ { 0, 0, 0, 0, 0 },
/* U+591d */ { 0, 0, 0, 0, 0 },
/* U+591e */ { 0, 0, 0, 0, 0 },
/* U+591f */ { 0, 0, 0, 0, 0 },
/* U+5920 */ { 0, 0, 0, 0, 0 },
/* U+5921 */ { 0, 0, 0, 0, 0 },
/* U+5922 */ { 0, 0, 0, 0, 0 },
/* U+5923 */ { 0, 0, 0, 0, 0 },
/* U+5924 */ { 0, 0, 0, 0, 0 },
/* U+5925 */ { 0, 0, 0, 0, 0 },
/* U+5926 */ { 0, 0, 0, 0, 0 },
/* U+5927 */ { 0, 0, 0, 0, 0 },
/* U+5928 */ { 0, 0, 0, 0, 0 },
/* U+5929 */ { 0, 0, 0, 0, 0 },
/* U+592a */ { 0, 0, 0, 0, 0 },
/* U+592b */ { 0, 0, 0, 0, 0 },
/* U+592c */ { 0, 0, 0, 0, 0 },
/* U+592d */ { 0, 0, 0, 0, 0 },
/* U+592e */ { 0, 0, 0, 0, 0 },
/* U+592f */ { 0, 0, 0, 0, 0 },
/* U+5930 */ { 0, 0, 0, 0, 0 },
/* U+5931 */ { 0, 0, 0, 0, 0 },
/* U+5932 */ { 0, 0, 0, 0, 0 },
/* U+5933 */ { 0, 0, 0, 0, 0 },
/* U+5934 */ { 0, 0, 0, 0, 0 },
/* U+5935 */ { 0, 0, 0, 0, 0 },
/* U+5936 */ { 0, 0, 0, 0, 0 },
/* U+5937 */ { 0, 0, 0, 0, 0 },
/* U+5938 */ { 0, 0, 0, 0, 0 },
/* U+5939 */ { 0, 0, 0, 0, 0 },
/* U+593a */ { 0, 0, 0, 0, 0 },
/* U+593b */ { 0, 0, 0, 0, 0 },
/* U+593c */ { 0, 0, 0, 0, 0 },
/* U+593d */ { 0, 0, 0, 0, 0 },
/* U+593e */ { 0, 0, 0, 0, 0 },
/* U+593f */ { 0, 0, 0, 0, 0 },
/* U+5940 */ { 0, 0, 0, 0, 0 },
/* U+5941 */ { 0, 0, 0, 0, 0 },
/* U+5942 */ { 0, 0, 0, 0, 0 },
/* U+5943 */ { 0, 0, 0, 0, 0 },
/* U+5944 */ { 0, 0, 0, 0, 0 },
/* U+5945 */ { 0, 0, 0, 0, 0 },
/* U+5946 */ { 0, 0, 0, 0, 0 },
/* U+5947 */ { 0, 0, 0, 0, 0 },
/* U+5948 */ { 0, 0, 0, 0, 0 },
/* U+5949 */ { 0, 0, 0, 0, 0 },
/* U+594a */ { 0, 0, 0, 0, 0 },
/* U+594b */ { 0, 0, 0, 0, 0 },
/* U+594c */ { 0, 0, 0, 0, 0 },
/* U+594d */ { 0, 0, 0, 0, 0 },
/* U+594e */ { 0, 0, 0, 0, 0 },
/* U+594f */ { 0, 0, 0, 0, 0 },
/* U+5950 */ { 0, 0, 0, 0, 0 },
/* U+5951 */ { 0, 0, 0, 0, 0 },
/* U+5952 */ { 0, 0, 0, 0, 0 },
/* U+5953 */ { 0, 0, 0, 0, 0 },
/* U+5954 */ { 0, 0, 0, 0, 0 },
/* U+5955 */ { 0, 0, 0, 0, 0 },
/* U+5956 */ { 0, 0, 0, 0, 0 },
/* U+5957 */ { 0, 0, 0, 0, 0 },
/* U+5958 */ { 0, 0, 0, 0, 0 },
/* U+5959 */ { 0, 0, 0, 0, 0 },
/* U+595a */ { 0, 0, 0, 0, 0 },
/* U+595b */ { 0, 0, 0, 0, 0 },
/* U+595c */ { 0, 0, 0, 0, 0 },
/* U+595d */ { 0, 0, 0, 0, 0 },
/* U+595e */ { 0, 0, 0, 0, 0 },
/* U+595f */ { 0, 0, 0, 0, 0 },
/* U+5960 */ { 0, 0, 0, 0, 0 },
/* U+5961 */ { 0, 0, 0, 0, 0 },
/* U+5962 */ { 0, 0, 0, 0, 0 },
/* U+5963 */ { 0, 0, 0, 0, 0 },
/* U+5964 */ { 0, 0, 0, 0, 0 },
/* U+5965 */ { 0, 0, 0, 0, 0 },
/* U+5966 */ { 0, 0, 0, 0, 0 },
/* U+5967 */ { 0, 0, 0, 0, 0 },
/* U+5968 */ { 0, 0, 0, 0, 0 },
/* U+5969 */ { 0, 0, 0, 0, 0 },
/* U+596a */ { 0, 0, 0, 0, 0 },
/* U+596b */ { 0, 0, 0, 0, 0 },
/* U+596c */ { 0, 0, 0, 0, 0 },
/* U+596d */ { 0, 0, 0, 0, 0 },
/* U+596e */ { 0, 0, 0, 0, 0 },
/* U+596f */ { 0, 0, 0, 0, 0 },
/* U+5970 */ { 0, 0, 0, 0, 0 },
/* U+5971 */ { 0, 0, 0, 0, 0 },
/* U+5972 */ { 0, 0, 0, 0, 0 },
/* U+5973 */ { 0, 0, 0, 0, 0 },
/* U+5974 */ { 0, 0, 0, 0, 0 },
/* U+5975 */ { 0, 0, 0, 0, 0 },
/* U+5976 */ { 0, 0, 0, 0, 0 },
/* U+5977 */ { 0, 0, 0, 0, 0 },
/* U+5978 */ { 0, 0, 0, 0, 0 },
/* U+5979 */ { 0, 0, 0, 0, 0 },
/* U+597a */ { 0, 0, 0, 0, 0 },
/* U+597b */ { 0, 0, 0, 0, 0 },
/* U+597c */ { 0, 0, 0, 0, 0 },
/* U+597d */ { 0, 0, 0, 0, 0 },
/* U+597e */ { 0, 0, 0, 0, 0 },
/* U+597f */ { 0, 0, 0, 0, 0 },
/* U+5980 */ { 0, 0, 0, 0, 0 },
/* U+5981 */ { 0, 0, 0, 0, 0 },
/* U+5982 */ { 0, 0, 0, 0, 0 },
/* U+5983 */ { 0, 0, 0, 0, 0 },
/* U+5984 */ { 0, 0, 0, 0, 0 },
/* U+5985 */ { 0, 0, 0, 0, 0 },
/* U+5986 */ { 0, 0, 0, 0, 0 },
/* U+5987 */ { 0, 0, 0, 0, 0 },
/* U+5988 */ { 0, 0, 0, 0, 0 },
/* U+5989 */ { 0, 0, 0, 0, 0 },
/* U+598a */ { 0, 0, 0, 0, 0 },
/* U+598b */ { 0, 0, 0, 0, 0 },
/* U+598c */ { 0, 0, 0, 0, 0 },
/* U+598d */ { 0, 0, 0, 0, 0 },
/* U+598e */ { 0, 0, 0, 0, 0 },
/* U+598f */ { 0, 0, 0, 0, 0 },
/* U+5990 */ { 0, 0, 0, 0, 0 },
/* U+5991 */ { 0, 0, 0, 0, 0 },
/* U+5992 */ { 0, 0, 0, 0, 0 },
/* U+5993 */ { 0, 0, 0, 0, 0 },
/* U+5994 */ { 0, 0, 0, 0, 0 },
/* U+5995 */ { 0, 0, 0, 0, 0 },
/* U+5996 */ { 0, 0, 0, 0, 0 },
/* U+5997 */ { 0, 0, 0, 0, 0 },
/* U+5998 */ { 0, 0, 0, 0, 0 },
/* U+5999 */ { 0, 0, 0, 0, 0 },
/* U+599a */ { 0, 0, 0, 0, 0 },
/* U+599b */ { 0, 0, 0, 0, 0 },
/* U+599c */ { 0, 0, 0, 0, 0 },
/* U+599d */ { 0, 0, 0, 0, 0 },
/* U+599e */ { 0, 0, 0, 0, 0 },
/* U+599f */ { 0, 0, 0, 0, 0 },
/* U+59a0 */ { 0, 0, 0, 0, 0 },
/* U+59a1 */ { 0, 0, 0, 0, 0 },
/* U+59a2 */ { 0, 0, 0, 0, 0 },
/* U+59a3 */ { 0, 0, 0, 0, 0 },
/* U+59a4 */ { 0, 0, 0, 0, 0 },
/* U+59a5 */ { 0, 0, 0, 0, 0 },
/* U+59a6 */ { 0, 0, 0, 0, 0 },
/* U+59a7 */ { 0, 0, 0, 0, 0 },
/* U+59a8 */ { 0, 0, 0, 0, 0 },
/* U+59a9 */ { 0, 0, 0, 0, 0 },
/* U+59aa */ { 0, 0, 0, 0, 0 },
/* U+59ab */ { 0, 0, 0, 0, 0 },
/* U+59ac */ { 0, 0, 0, 0, 0 },
/* U+59ad */ { 0, 0, 0, 0, 0 },
/* U+59ae */ { 0, 0, 0, 0, 0 },
/* U+59af */ { 0, 0, 0, 0, 0 },
/* U+59b0 */ { 0, 0, 0, 0, 0 },
/* U+59b1 */ { 0, 0, 0, 0, 0 },
/* U+59b2 */ { 0, 0, 0, 0, 0 },
/* U+59b3 */ { 0, 0, 0, 0, 0 },
/* U+59b4 */ { 0, 0, 0, 0, 0 },
/* U+59b5 */ { 0, 0, 0, 0, 0 },
/* U+59b6 */ { 0, 0, 0, 0, 0 },
/* U+59b7 */ { 0, 0, 0, 0, 0 },
/* U+59b8 */ { 0, 0, 0, 0, 0 },
/* U+59b9 */ { 0, 0, 0, 0, 0 },
/* U+59ba */ { 0, 0, 0, 0, 0 },
/* U+59bb */ { 0, 0, 0, 0, 0 },
/* U+59bc */ { 0, 0, 0, 0, 0 },
/* U+59bd */ { 0, 0, 0, 0, 0 },
/* U+59be */ { 0, 0, 0, 0, 0 },
/* U+59bf */ { 0, 0, 0, 0, 0 },
/* U+59c0 */ { 0, 0, 0, 0, 0 },
/* U+59c1 */ { 0, 0, 0, 0, 0 },
/* U+59c2 */ { 0, 0, 0, 0, 0 },
/* U+59c3 */ { 0, 0, 0, 0, 0 },
/* U+59c4 */ { 0, 0, 0, 0, 0 },
/* U+59c5 */ { 0, 0, 0, 0, 0 },
/* U+59c6 */ { 0, 0, 0, 0, 0 },
/* U+59c7 */ { 0, 0, 0, 0, 0 },
/* U+59c8 */ { 0, 0, 0, 0, 0 },
/* U+59c9 */ { 0, 0, 0, 0, 0 },
/* U+59ca */ { 0, 0, 0, 0, 0 },
/* U+59cb */ { 0, 0, 0, 0, 0 },
/* U+59cc */ { 0, 0, 0, 0, 0 },
/* U+59cd */ { 0, 0, 0, 0, 0 },
/* U+59ce */ { 0, 0, 0, 0, 0 },
/* U+59cf */ { 0, 0, 0, 0, 0 },
/* U+59d0 */ { 0, 0, 0, 0, 0 },
/* U+59d1 */ { 0, 0, 0, 0, 0 },
/* U+59d2 */ { 0, 0, 0, 0, 0 },
/* U+59d3 */ { 0, 0, 0, 0, 0 },
/* U+59d4 */ { 0, 0, 0, 0, 0 },
/* U+59d5 */ { 0, 0, 0, 0, 0 },
/* U+59d6 */ { 0, 0, 0, 0, 0 },
/* U+59d7 */ { 0, 0, 0, 0, 0 },
/* U+59d8 */ { 0, 0, 0, 0, 0 },
/* U+59d9 */ { 0, 0, 0, 0, 0 },
/* U+59da */ { 0, 0, 0, 0, 0 },
/* U+59db */ { 0, 0, 0, 0, 0 },
/* U+59dc */ { 0, 0, 0, 0, 0 },
/* U+59dd */ { 0, 0, 0, 0, 0 },
/* U+59de */ { 0, 0, 0, 0, 0 },
/* U+59df */ { 0, 0, 0, 0, 0 },
/* U+59e0 */ { 0, 0, 0, 0, 0 },
/* U+59e1 */ { 0, 0, 0, 0, 0 },
/* U+59e2 */ { 0, 0, 0, 0, 0 },
/* U+59e3 */ { 0, 0, 0, 0, 0 },
/* U+59e4 */ { 0, 0, 0, 0, 0 },
/* U+59e5 */ { 0, 0, 0, 0, 0 },
/* U+59e6 */ { 0, 0, 0, 0, 0 },
/* U+59e7 */ { 0, 0, 0, 0, 0 },
/* U+59e8 */ { 0, 0, 0, 0, 0 },
/* U+59e9 */ { 0, 0, 0, 0, 0 },
/* U+59ea */ { 0, 0, 0, 0, 0 },
/* U+59eb */ { 0, 0, 0, 0, 0 },
/* U+59ec */ { 0, 0, 0, 0, 0 },
/* U+59ed */ { 0, 0, 0, 0, 0 },
/* U+59ee */ { 0, 0, 0, 0, 0 },
/* U+59ef */ { 0, 0, 0, 0, 0 },
/* U+59f0 */ { 0, 0, 0, 0, 0 },
/* U+59f1 */ { 0, 0, 0, 0, 0 },
/* U+59f2 */ { 0, 0, 0, 0, 0 },
/* U+59f3 */ { 0, 0, 0, 0, 0 },
/* U+59f4 */ { 0, 0, 0, 0, 0 },
/* U+59f5 */ { 0, 0, 0, 0, 0 },
/* U+59f6 */ { 0, 0, 0, 0, 0 },
/* U+59f7 */ { 0, 0, 0, 0, 0 },
/* U+59f8 */ { 0, 0, 0, 0, 0 },
/* U+59f9 */ { 0, 0, 0, 0, 0 },
/* U+59fa */ { 0, 0, 0, 0, 0 },
/* U+59fb */ { 0, 0, 0, 0, 0 },
/* U+59fc */ { 0, 0, 0, 0, 0 },
/* U+59fd */ { 0, 0, 0, 0, 0 },
/* U+59fe */ { 0, 0, 0, 0, 0 },
/* U+59ff */ { 0, 0, 0, 0, 0 },
/* U+5a00 */ { 0, 0, 0, 0, 0 },
/* U+5a01 */ { 0, 0, 0, 0, 0 },
/* U+5a02 */ { 0, 0, 0, 0, 0 },
/* U+5a03 */ { 0, 0, 0, 0, 0 },
/* U+5a04 */ { 0, 0, 0, 0, 0 },
/* U+5a05 */ { 0, 0, 0, 0, 0 },
/* U+5a06 */ { 0, 0, 0, 0, 0 },
/* U+5a07 */ { 0, 0, 0, 0, 0 },
/* U+5a08 */ { 0, 0, 0, 0, 0 },
/* U+5a09 */ { 0, 0, 0, 0, 0 },
/* U+5a0a */ { 0, 0, 0, 0, 0 },
/* U+5a0b */ { 0, 0, 0, 0, 0 },
/* U+5a0c */ { 0, 0, 0, 0, 0 },
/* U+5a0d */ { 0, 0, 0, 0, 0 },
/* U+5a0e */ { 0, 0, 0, 0, 0 },
/* U+5a0f */ { 0, 0, 0, 0, 0 },
/* U+5a10 */ { 0, 0, 0, 0, 0 },
/* U+5a11 */ { 0, 0, 0, 0, 0 },
/* U+5a12 */ { 0, 0, 0, 0, 0 },
/* U+5a13 */ { 0, 0, 0, 0, 0 },
/* U+5a14 */ { 0, 0, 0, 0, 0 },
/* U+5a15 */ { 0, 0, 0, 0, 0 },
/* U+5a16 */ { 0, 0, 0, 0, 0 },
/* U+5a17 */ { 0, 0, 0, 0, 0 },
/* U+5a18 */ { 0, 0, 0, 0, 0 },
/* U+5a19 */ { 0, 0, 0, 0, 0 },
/* U+5a1a */ { 0, 0, 0, 0, 0 },
/* U+5a1b */ { 0, 0, 0, 0, 0 },
/* U+5a1c */ { 0, 0, 0, 0, 0 },
/* U+5a1d */ { 0, 0, 0, 0, 0 },
/* U+5a1e */ { 0, 0, 0, 0, 0 },
/* U+5a1f */ { 0, 0, 0, 0, 0 },
/* U+5a20 */ { 0, 0, 0, 0, 0 },
/* U+5a21 */ { 0, 0, 0, 0, 0 },
/* U+5a22 */ { 0, 0, 0, 0, 0 },
/* U+5a23 */ { 0, 0, 0, 0, 0 },
/* U+5a24 */ { 0, 0, 0, 0, 0 },
/* U+5a25 */ { 0, 0, 0, 0, 0 },
/* U+5a26 */ { 0, 0, 0, 0, 0 },
/* U+5a27 */ { 0, 0, 0, 0, 0 },
/* U+5a28 */ { 0, 0, 0, 0, 0 },
/* U+5a29 */ { 0, 0, 0, 0, 0 },
/* U+5a2a */ { 0, 0, 0, 0, 0 },
/* U+5a2b */ { 0, 0, 0, 0, 0 },
/* U+5a2c */ { 0, 0, 0, 0, 0 },
/* U+5a2d */ { 0, 0, 0, 0, 0 },
/* U+5a2e */ { 0, 0, 0, 0, 0 },
/* U+5a2f */ { 0, 0, 0, 0, 0 },
/* U+5a30 */ { 0, 0, 0, 0, 0 },
/* U+5a31 */ { 0, 0, 0, 0, 0 },
/* U+5a32 */ { 0, 0, 0, 0, 0 },
/* U+5a33 */ { 0, 0, 0, 0, 0 },
/* U+5a34 */ { 0, 0, 0, 0, 0 },
/* U+5a35 */ { 0, 0, 0, 0, 0 },
/* U+5a36 */ { 0, 0, 0, 0, 0 },
/* U+5a37 */ { 0, 0, 0, 0, 0 },
/* U+5a38 */ { 0, 0, 0, 0, 0 },
/* U+5a39 */ { 0, 0, 0, 0, 0 },
/* U+5a3a */ { 0, 0, 0, 0, 0 },
/* U+5a3b */ { 0, 0, 0, 0, 0 },
/* U+5a3c */ { 0, 0, 0, 0, 0 },
/* U+5a3d */ { 0, 0, 0, 0, 0 },
/* U+5a3e */ { 0, 0, 0, 0, 0 },
/* U+5a3f */ { 0, 0, 0, 0, 0 },
/* U+5a40 */ { 0, 0, 0, 0, 0 },
/* U+5a41 */ { 0, 0, 0, 0, 0 },
/* U+5a42 */ { 0, 0, 0, 0, 0 },
/* U+5a43 */ { 0, 0, 0, 0, 0 },
/* U+5a44 */ { 0, 0, 0, 0, 0 },
/* U+5a45 */ { 0, 0, 0, 0, 0 },
/* U+5a46 */ { 0, 0, 0, 0, 0 },
/* U+5a47 */ { 0, 0, 0, 0, 0 },
/* U+5a48 */ { 0, 0, 0, 0, 0 },
/* U+5a49 */ { 0, 0, 0, 0, 0 },
/* U+5a4a */ { 0, 0, 0, 0, 0 },
/* U+5a4b */ { 0, 0, 0, 0, 0 },
/* U+5a4c */ { 0, 0, 0, 0, 0 },
/* U+5a4d */ { 0, 0, 0, 0, 0 },
/* U+5a4e */ { 0, 0, 0, 0, 0 },
/* U+5a4f */ { 0, 0, 0, 0, 0 },
/* U+5a50 */ { 0, 0, 0, 0, 0 },
/* U+5a51 */ { 0, 0, 0, 0, 0 },
/* U+5a52 */ { 0, 0, 0, 0, 0 },
/* U+5a53 */ { 0, 0, 0, 0, 0 },
/* U+5a54 */ { 0, 0, 0, 0, 0 },
/* U+5a55 */ { 0, 0, 0, 0, 0 },
/* U+5a56 */ { 0, 0, 0, 0, 0 },
/* U+5a57 */ { 0, 0, 0, 0, 0 },
/* U+5a58 */ { 0, 0, 0, 0, 0 },
/* U+5a59 */ { 0, 0, 0, 0, 0 },
/* U+5a5a */ { 0, 0, 0, 0, 0 },
/* U+5a5b */ { 0, 0, 0, 0, 0 },
/* U+5a5c */ { 0, 0, 0, 0, 0 },
/* U+5a5d */ { 0, 0, 0, 0, 0 },
/* U+5a5e */ { 0, 0, 0, 0, 0 },
/* U+5a5f */ { 0, 0, 0, 0, 0 },
/* U+5a60 */ { 0, 0, 0, 0, 0 },
/* U+5a61 */ { 0, 0, 0, 0, 0 },
/* U+5a62 */ { 0, 0, 0, 0, 0 },
/* U+5a63 */ { 0, 0, 0, 0, 0 },
/* U+5a64 */ { 0, 0, 0, 0, 0 },
/* U+5a65 */ { 0, 0, 0, 0, 0 },
/* U+5a66 */ { 0, 0, 0, 0, 0 },
/* U+5a67 */ { 0, 0, 0, 0, 0 },
/* U+5a68 */ { 0, 0, 0, 0, 0 },
/* U+5a69 */ { 0, 0, 0, 0, 0 },
/* U+5a6a */ { 0, 0, 0, 0, 0 },
/* U+5a6b */ { 0, 0, 0, 0, 0 },
/* U+5a6c */ { 0, 0, 0, 0, 0 },
/* U+5a6d */ { 0, 0, 0, 0, 0 },
/* U+5a6e */ { 0, 0, 0, 0, 0 },
/* U+5a6f */ { 0, 0, 0, 0, 0 },
/* U+5a70 */ { 0, 0, 0, 0, 0 },
/* U+5a71 */ { 0, 0, 0, 0, 0 },
/* U+5a72 */ { 0, 0, 0, 0, 0 },
/* U+5a73 */ { 0, 0, 0, 0, 0 },
/* U+5a74 */ { 0, 0, 0, 0, 0 },
/* U+5a75 */ { 0, 0, 0, 0, 0 },
/* U+5a76 */ { 0, 0, 0, 0, 0 },
/* U+5a77 */ { 0, 0, 0, 0, 0 },
/* U+5a78 */ { 0, 0, 0, 0, 0 },
/* U+5a79 */ { 0, 0, 0, 0, 0 },
/* U+5a7a */ { 0, 0, 0, 0, 0 },
/* U+5a7b */ { 0, 0, 0, 0, 0 },
/* U+5a7c */ { 0, 0, 0, 0, 0 },
/* U+5a7d */ { 0, 0, 0, 0, 0 },
/* U+5a7e */ { 0, 0, 0, 0, 0 },
/* U+5a7f */ { 0, 0, 0, 0, 0 },
/* U+5a80 */ { 0, 0, 0, 0, 0 },
/* U+5a81 */ { 0, 0, 0, 0, 0 },
/* U+5a82 */ { 0, 0, 0, 0, 0 },
/* U+5a83 */ { 0, 0, 0, 0, 0 },
/* U+5a84 */ { 0, 0, 0, 0, 0 },
/* U+5a85 */ { 0, 0, 0, 0, 0 },
/* U+5a86 */ { 0, 0, 0, 0, 0 },
/* U+5a87 */ { 0, 0, 0, 0, 0 },
/* U+5a88 */ { 0, 0, 0, 0, 0 },
/* U+5a89 */ { 0, 0, 0, 0, 0 },
/* U+5a8a */ { 0, 0, 0, 0, 0 },
/* U+5a8b */ { 0, 0, 0, 0, 0 },
/* U+5a8c */ { 0, 0, 0, 0, 0 },
/* U+5a8d */ { 0, 0, 0, 0, 0 },
/* U+5a8e */ { 0, 0, 0, 0, 0 },
/* U+5a8f */ { 0, 0, 0, 0, 0 },
/* U+5a90 */ { 0, 0, 0, 0, 0 },
/* U+5a91 */ { 0, 0, 0, 0, 0 },
/* U+5a92 */ { 0, 0, 0, 0, 0 },
/* U+5a93 */ { 0, 0, 0, 0, 0 },
/* U+5a94 */ { 0, 0, 0, 0, 0 },
/* U+5a95 */ { 0, 0, 0, 0, 0 },
/* U+5a96 */ { 0, 0, 0, 0, 0 },
/* U+5a97 */ { 0, 0, 0, 0, 0 },
/* U+5a98 */ { 0, 0, 0, 0, 0 },
/* U+5a99 */ { 0, 0, 0, 0, 0 },
/* U+5a9a */ { 0, 0, 0, 0, 0 },
/* U+5a9b */ { 0, 0, 0, 0, 0 },
/* U+5a9c */ { 0, 0, 0, 0, 0 },
/* U+5a9d */ { 0, 0, 0, 0, 0 },
/* U+5a9e */ { 0, 0, 0, 0, 0 },
/* U+5a9f */ { 0, 0, 0, 0, 0 },
/* U+5aa0 */ { 0, 0, 0, 0, 0 },
/* U+5aa1 */ { 0, 0, 0, 0, 0 },
/* U+5aa2 */ { 0, 0, 0, 0, 0 },
/* U+5aa3 */ { 0, 0, 0, 0, 0 },
/* U+5aa4 */ { 0, 0, 0, 0, 0 },
/* U+5aa5 */ { 0, 0, 0, 0, 0 },
/* U+5aa6 */ { 0, 0, 0, 0, 0 },
/* U+5aa7 */ { 0, 0, 0, 0, 0 },
/* U+5aa8 */ { 0, 0, 0, 0, 0 },
/* U+5aa9 */ { 0, 0, 0, 0, 0 },
/* U+5aaa */ { 0, 0, 0, 0, 0 },
/* U+5aab */ { 0, 0, 0, 0, 0 },
/* U+5aac */ { 0, 0, 0, 0, 0 },
/* U+5aad */ { 0, 0, 0, 0, 0 },
/* U+5aae */ { 0, 0, 0, 0, 0 },
/* U+5aaf */ { 0, 0, 0, 0, 0 },
/* U+5ab0 */ { 0, 0, 0, 0, 0 },
/* U+5ab1 */ { 0, 0, 0, 0, 0 },
/* U+5ab2 */ { 0, 0, 0, 0, 0 },
/* U+5ab3 */ { 0, 0, 0, 0, 0 },
/* U+5ab4 */ { 0, 0, 0, 0, 0 },
/* U+5ab5 */ { 0, 0, 0, 0, 0 },
/* U+5ab6 */ { 0, 0, 0, 0, 0 },
/* U+5ab7 */ { 0, 0, 0, 0, 0 },
/* U+5ab8 */ { 0, 0, 0, 0, 0 },
/* U+5ab9 */ { 0, 0, 0, 0, 0 },
/* U+5aba */ { 0, 0, 0, 0, 0 },
/* U+5abb */ { 0, 0, 0, 0, 0 },
/* U+5abc */ { 0, 0, 0, 0, 0 },
/* U+5abd */ { 0, 0, 0, 0, 0 },
/* U+5abe */ { 0, 0, 0, 0, 0 },
/* U+5abf */ { 0, 0, 0, 0, 0 },
/* U+5ac0 */ { 0, 0, 0, 0, 0 },
/* U+5ac1 */ { 0, 0, 0, 0, 0 },
/* U+5ac2 */ { 0, 0, 0, 0, 0 },
/* U+5ac3 */ { 0, 0, 0, 0, 0 },
/* U+5ac4 */ { 0, 0, 0, 0, 0 },
/* U+5ac5 */ { 0, 0, 0, 0, 0 },
/* U+5ac6 */ { 0, 0, 0, 0, 0 },
/* U+5ac7 */ { 0, 0, 0, 0, 0 },
/* U+5ac8 */ { 0, 0, 0, 0, 0 },
/* U+5ac9 */ { 0, 0, 0, 0, 0 },
/* U+5aca */ { 0, 0, 0, 0, 0 },
/* U+5acb */ { 0, 0, 0, 0, 0 },
/* U+5acc */ { 0, 0, 0, 0, 0 },
/* U+5acd */ { 0, 0, 0, 0, 0 },
/* U+5ace */ { 0, 0, 0, 0, 0 },
/* U+5acf */ { 0, 0, 0, 0, 0 },
/* U+5ad0 */ { 0, 0, 0, 0, 0 },
/* U+5ad1 */ { 0, 0, 0, 0, 0 },
/* U+5ad2 */ { 0, 0, 0, 0, 0 },
/* U+5ad3 */ { 0, 0, 0, 0, 0 },
/* U+5ad4 */ { 0, 0, 0, 0, 0 },
/* U+5ad5 */ { 0, 0, 0, 0, 0 },
/* U+5ad6 */ { 0, 0, 0, 0, 0 },
/* U+5ad7 */ { 0, 0, 0, 0, 0 },
/* U+5ad8 */ { 0, 0, 0, 0, 0 },
/* U+5ad9 */ { 0, 0, 0, 0, 0 },
/* U+5ada */ { 0, 0, 0, 0, 0 },
/* U+5adb */ { 0, 0, 0, 0, 0 },
/* U+5adc */ { 0, 0, 0, 0, 0 },
/* U+5add */ { 0, 0, 0, 0, 0 },
/* U+5ade */ { 0, 0, 0, 0, 0 },
/* U+5adf */ { 0, 0, 0, 0, 0 },
/* U+5ae0 */ { 0, 0, 0, 0, 0 },
/* U+5ae1 */ { 0, 0, 0, 0, 0 },
/* U+5ae2 */ { 0, 0, 0, 0, 0 },
/* U+5ae3 */ { 0, 0, 0, 0, 0 },
/* U+5ae4 */ { 0, 0, 0, 0, 0 },
/* U+5ae5 */ { 0, 0, 0, 0, 0 },
/* U+5ae6 */ { 0, 0, 0, 0, 0 },
/* U+5ae7 */ { 0, 0, 0, 0, 0 },
/* U+5ae8 */ { 0, 0, 0, 0, 0 },
/* U+5ae9 */ { 0, 0, 0, 0, 0 },
/* U+5aea */ { 0, 0, 0, 0, 0 },
/* U+5aeb */ { 0, 0, 0, 0, 0 },
/* U+5aec */ { 0, 0, 0, 0, 0 },
/* U+5aed */ { 0, 0, 0, 0, 0 },
/* U+5aee */ { 0, 0, 0, 0, 0 },
/* U+5aef */ { 0, 0, 0, 0, 0 },
/* U+5af0 */ { 0, 0, 0, 0, 0 },
/* U+5af1 */ { 0, 0, 0, 0, 0 },
/* U+5af2 */ { 0, 0, 0, 0, 0 },
/* U+5af3 */ { 0, 0, 0, 0, 0 },
/* U+5af4 */ { 0, 0, 0, 0, 0 },
/* U+5af5 */ { 0, 0, 0, 0, 0 },
/* U+5af6 */ { 0, 0, 0, 0, 0 },
/* U+5af7 */ { 0, 0, 0, 0, 0 },
/* U+5af8 */ { 0, 0, 0, 0, 0 },
/* U+5af9 */ { 0, 0, 0, 0, 0 },
/* U+5afa */ { 0, 0, 0, 0, 0 },
/* U+5afb */ { 0, 0, 0, 0, 0 },
/* U+5afc */ { 0, 0, 0, 0, 0 },
/* U+5afd */ { 0, 0, 0, 0, 0 },
/* U+5afe */ { 0, 0, 0, 0, 0 },
/* U+5aff */ { 0, 0, 0, 0, 0 },
/* U+5b00 */ { 0, 0, 0, 0, 0 },
/* U+5b01 */ { 0, 0, 0, 0, 0 },
/* U+5b02 */ { 0, 0, 0, 0, 0 },
/* U+5b03 */ { 0, 0, 0, 0, 0 },
/* U+5b04 */ { 0, 0, 0, 0, 0 },
/* U+5b05 */ { 0, 0, 0, 0, 0 },
/* U+5b06 */ { 0, 0, 0, 0, 0 },
/* U+5b07 */ { 0, 0, 0, 0, 0 },
/* U+5b08 */ { 0, 0, 0, 0, 0 },
/* U+5b09 */ { 0, 0, 0, 0, 0 },
/* U+5b0a */ { 0, 0, 0, 0, 0 },
/* U+5b0b */ { 0, 0, 0, 0, 0 },
/* U+5b0c */ { 0, 0, 0, 0, 0 },
/* U+5b0d */ { 0, 0, 0, 0, 0 },
/* U+5b0e */ { 0, 0, 0, 0, 0 },
/* U+5b0f */ { 0, 0, 0, 0, 0 },
/* U+5b10 */ { 0, 0, 0, 0, 0 },
/* U+5b11 */ { 0, 0, 0, 0, 0 },
/* U+5b12 */ { 0, 0, 0, 0, 0 },
/* U+5b13 */ { 0, 0, 0, 0, 0 },
/* U+5b14 */ { 0, 0, 0, 0, 0 },
/* U+5b15 */ { 0, 0, 0, 0, 0 },
/* U+5b16 */ { 0, 0, 0, 0, 0 },
/* U+5b17 */ { 0, 0, 0, 0, 0 },
/* U+5b18 */ { 0, 0, 0, 0, 0 },
/* U+5b19 */ { 0, 0, 0, 0, 0 },
/* U+5b1a */ { 0, 0, 0, 0, 0 },
/* U+5b1b */ { 0, 0, 0, 0, 0 },
/* U+5b1c */ { 0, 0, 0, 0, 0 },
/* U+5b1d */ { 0, 0, 0, 0, 0 },
/* U+5b1e */ { 0, 0, 0, 0, 0 },
/* U+5b1f */ { 0, 0, 0, 0, 0 },
/* U+5b20 */ { 0, 0, 0, 0, 0 },
/* U+5b21 */ { 0, 0, 0, 0, 0 },
/* U+5b22 */ { 0, 0, 0, 0, 0 },
/* U+5b23 */ { 0, 0, 0, 0, 0 },
/* U+5b24 */ { 0, 0, 0, 0, 0 },
/* U+5b25 */ { 0, 0, 0, 0, 0 },
/* U+5b26 */ { 0, 0, 0, 0, 0 },
/* U+5b27 */ { 0, 0, 0, 0, 0 },
/* U+5b28 */ { 0, 0, 0, 0, 0 },
/* U+5b29 */ { 0, 0, 0, 0, 0 },
/* U+5b2a */ { 0, 0, 0, 0, 0 },
/* U+5b2b */ { 0, 0, 0, 0, 0 },
/* U+5b2c */ { 0, 0, 0, 0, 0 },
/* U+5b2d */ { 0, 0, 0, 0, 0 },
/* U+5b2e */ { 0, 0, 0, 0, 0 },
/* U+5b2f */ { 0, 0, 0, 0, 0 },
/* U+5b30 */ { 0, 0, 0, 0, 0 },
/* U+5b31 */ { 0, 0, 0, 0, 0 },
/* U+5b32 */ { 0, 0, 0, 0, 0 },
/* U+5b33 */ { 0, 0, 0, 0, 0 },
/* U+5b34 */ { 0, 0, 0, 0, 0 },
/* U+5b35 */ { 0, 0, 0, 0, 0 },
/* U+5b36 */ { 0, 0, 0, 0, 0 },
/* U+5b37 */ { 0, 0, 0, 0, 0 },
/* U+5b38 */ { 0, 0, 0, 0, 0 },
/* U+5b39 */ { 0, 0, 0, 0, 0 },
/* U+5b3a */ { 0, 0, 0, 0, 0 },
/* U+5b3b */ { 0, 0, 0, 0, 0 },
/* U+5b3c */ { 0, 0, 0, 0, 0 },
/* U+5b3d */ { 0, 0, 0, 0, 0 },
/* U+5b3e */ { 0, 0, 0, 0, 0 },
/* U+5b3f */ { 0, 0, 0, 0, 0 },
/* U+5b40 */ { 0, 0, 0, 0, 0 },
/* U+5b41 */ { 0, 0, 0, 0, 0 },
/* U+5b42 */ { 0, 0, 0, 0, 0 },
/* U+5b43 */ { 0, 0, 0, 0, 0 },
/* U+5b44 */ { 0, 0, 0, 0, 0 },
/* U+5b45 */ { 0, 0, 0, 0, 0 },
/* U+5b46 */ { 0, 0, 0, 0, 0 },
/* U+5b47 */ { 0, 0, 0, 0, 0 },
/* U+5b48 */ { 0, 0, 0, 0, 0 },
/* U+5b49 */ { 0, 0, 0, 0, 0 },
/* U+5b4a */ { 0, 0, 0, 0, 0 },
/* U+5b4b */ { 0, 0, 0, 0, 0 },
/* U+5b4c */ { 0, 0, 0, 0, 0 },
/* U+5b4d */ { 0, 0, 0, 0, 0 },
/* U+5b4e */ { 0, 0, 0, 0, 0 },
/* U+5b4f */ { 0, 0, 0, 0, 0 },
/* U+5b50 */ { 0, 0, 0, 0, 0 },
/* U+5b51 */ { 0, 0, 0, 0, 0 },
/* U+5b52 */ { 0, 0, 0, 0, 0 },
/* U+5b53 */ { 0, 0, 0, 0, 0 },
/* U+5b54 */ { 0, 0, 0, 0, 0 },
/* U+5b55 */ { 0, 0, 0, 0, 0 },
/* U+5b56 */ { 0, 0, 0, 0, 0 },
/* U+5b57 */ { 0, 0, 0, 0, 0 },
/* U+5b58 */ { 0, 0, 0, 0, 0 },
/* U+5b59 */ { 0, 0, 0, 0, 0 },
/* U+5b5a */ { 0, 0, 0, 0, 0 },
/* U+5b5b */ { 0, 0, 0, 0, 0 },
/* U+5b5c */ { 0, 0, 0, 0, 0 },
/* U+5b5d */ { 0, 0, 0, 0, 0 },
/* U+5b5e */ { 0, 0, 0, 0, 0 },
/* U+5b5f */ { 0, 0, 0, 0, 0 },
/* U+5b60 */ { 0, 0, 0, 0, 0 },
/* U+5b61 */ { 0, 0, 0, 0, 0 },
/* U+5b62 */ { 0, 0, 0, 0, 0 },
/* U+5b63 */ { 0, 0, 0, 0, 0 },
/* U+5b64 */ { 0, 0, 0, 0, 0 },
/* U+5b65 */ { 0, 0, 0, 0, 0 },
/* U+5b66 */ { 0, 0, 0, 0, 0 },
/* U+5b67 */ { 0, 0, 0, 0, 0 },
/* U+5b68 */ { 0, 0, 0, 0, 0 },
/* U+5b69 */ { 0, 0, 0, 0, 0 },
/* U+5b6a */ { 0, 0, 0, 0, 0 },
/* U+5b6b */ { 0, 0, 0, 0, 0 },
/* U+5b6c */ { 0, 0, 0, 0, 0 },
/* U+5b6d */ { 0, 0, 0, 0, 0 },
/* U+5b6e */ { 0, 0, 0, 0, 0 },
/* U+5b6f */ { 0, 0, 0, 0, 0 },
/* U+5b70 */ { 0, 0, 0, 0, 0 },
/* U+5b71 */ { 0, 0, 0, 0, 0 },
/* U+5b72 */ { 0, 0, 0, 0, 0 },
/* U+5b73 */ { 0, 0, 0, 0, 0 },
/* U+5b74 */ { 0, 0, 0, 0, 0 },
/* U+5b75 */ { 0, 0, 0, 0, 0 },
/* U+5b76 */ { 0, 0, 0, 0, 0 },
/* U+5b77 */ { 0, 0, 0, 0, 0 },
/* U+5b78 */ { 0, 0, 0, 0, 0 },
/* U+5b79 */ { 0, 0, 0, 0, 0 },
/* U+5b7a */ { 0, 0, 0, 0, 0 },
/* U+5b7b */ { 0, 0, 0, 0, 0 },
/* U+5b7c */ { 0, 0, 0, 0, 0 },
/* U+5b7d */ { 0, 0, 0, 0, 0 },
/* U+5b7e */ { 0, 0, 0, 0, 0 },
/* U+5b7f */ { 0, 0, 0, 0, 0 },
/* U+5b80 */ { 0, 0, 0, 0, 0 },
/* U+5b81 */ { 0, 0, 0, 0, 0 },
/* U+5b82 */ { 0, 0, 0, 0, 0 },
/* U+5b83 */ { 0, 0, 0, 0, 0 },
/* U+5b84 */ { 0, 0, 0, 0, 0 },
/* U+5b85 */ { 0, 0, 0, 0, 0 },
/* U+5b86 */ { 0, 0, 0, 0, 0 },
/* U+5b87 */ { 0, 0, 0, 0, 0 },
/* U+5b88 */ { 0, 0, 0, 0, 0 },
/* U+5b89 */ { 0, 0, 0, 0, 0 },
/* U+5b8a */ { 0, 0, 0, 0, 0 },
/* U+5b8b */ { 0, 0, 0, 0, 0 },
/* U+5b8c */ { 0, 0, 0, 0, 0 },
/* U+5b8d */ { 0, 0, 0, 0, 0 },
/* U+5b8e */ { 0, 0, 0, 0, 0 },
/* U+5b8f */ { 0, 0, 0, 0, 0 },
/* U+5b90 */ { 0, 0, 0, 0, 0 },
/* U+5b91 */ { 0, 0, 0, 0, 0 },
/* U+5b92 */ { 0, 0, 0, 0, 0 },
/* U+5b93 */ { 0, 0, 0, 0, 0 },
/* U+5b94 */ { 0, 0, 0, 0, 0 },
/* U+5b95 */ { 0, 0, 0, 0, 0 },
/* U+5b96 */ { 0, 0, 0, 0, 0 },
/* U+5b97 */ { 0, 0, 0, 0, 0 },
/* U+5b98 */ { 0, 0, 0, 0, 0 },
/* U+5b99 */ { 0, 0, 0, 0, 0 },
/* U+5b9a */ { 0, 0, 0, 0, 0 },
/* U+5b9b */ { 0, 0, 0, 0, 0 },
/* U+5b9c */ { 0, 0, 0, 0, 0 },
/* U+5b9d */ { 0, 0, 0, 0, 0 },
/* U+5b9e */ { 0, 0, 0, 0, 0 },
/* U+5b9f */ { 0, 0, 0, 0, 0 },
/* U+5ba0 */ { 0, 0, 0, 0, 0 },
/* U+5ba1 */ { 0, 0, 0, 0, 0 },
/* U+5ba2 */ { 0, 0, 0, 0, 0 },
/* U+5ba3 */ { 0, 0, 0, 0, 0 },
/* U+5ba4 */ { 0, 0, 0, 0, 0 },
/* U+5ba5 */ { 0, 0, 0, 0, 0 },
/* U+5ba6 */ { 0, 0, 0, 0, 0 },
/* U+5ba7 */ { 0, 0, 0, 0, 0 },
/* U+5ba8 */ { 0, 0, 0, 0, 0 },
/* U+5ba9 */ { 0, 0, 0, 0, 0 },
/* U+5baa */ { 0, 0, 0, 0, 0 },
/* U+5bab */ { 0, 0, 0, 0, 0 },
/* U+5bac */ { 0, 0, 0, 0, 0 },
/* U+5bad */ { 0, 0, 0, 0, 0 },
/* U+5bae */ { 0, 0, 0, 0, 0 },
/* U+5baf */ { 0, 0, 0, 0, 0 },
/* U+5bb0 */ { 0, 0, 0, 0, 0 },
/* U+5bb1 */ { 0, 0, 0, 0, 0 },
/* U+5bb2 */ { 0, 0, 0, 0, 0 },
/* U+5bb3 */ { 0, 0, 0, 0, 0 },
/* U+5bb4 */ { 0, 0, 0, 0, 0 },
/* U+5bb5 */ { 0, 0, 0, 0, 0 },
/* U+5bb6 */ { 0, 0, 0, 0, 0 },
/* U+5bb7 */ { 0, 0, 0, 0, 0 },
/* U+5bb8 */ { 0, 0, 0, 0, 0 },
/* U+5bb9 */ { 0, 0, 0, 0, 0 },
/* U+5bba */ { 0, 0, 0, 0, 0 },
/* U+5bbb */ { 0, 0, 0, 0, 0 },
/* U+5bbc */ { 0, 0, 0, 0, 0 },
/* U+5bbd */ { 0, 0, 0, 0, 0 },
/* U+5bbe */ { 0, 0, 0, 0, 0 },
/* U+5bbf */ { 0, 0, 0, 0, 0 },
/* U+5bc0 */ { 0, 0, 0, 0, 0 },
/* U+5bc1 */ { 0, 0, 0, 0, 0 },
/* U+5bc2 */ { 0, 0, 0, 0, 0 },
/* U+5bc3 */ { 0, 0, 0, 0, 0 },
/* U+5bc4 */ { 0, 0, 0, 0, 0 },
/* U+5bc5 */ { 0, 0, 0, 0, 0 },
/* U+5bc6 */ { 0, 0, 0, 0, 0 },
/* U+5bc7 */ { 0, 0, 0, 0, 0 },
/* U+5bc8 */ { 0, 0, 0, 0, 0 },
/* U+5bc9 */ { 0, 0, 0, 0, 0 },
/* U+5bca */ { 0, 0, 0, 0, 0 },
/* U+5bcb */ { 0, 0, 0, 0, 0 },
/* U+5bcc */ { 0, 0, 0, 0, 0 },
/* U+5bcd */ { 0, 0, 0, 0, 0 },
/* U+5bce */ { 0, 0, 0, 0, 0 },
/* U+5bcf */ { 0, 0, 0, 0, 0 },
/* U+5bd0 */ { 0, 0, 0, 0, 0 },
/* U+5bd1 */ { 0, 0, 0, 0, 0 },
/* U+5bd2 */ { 0, 0, 0, 0, 0 },
/* U+5bd3 */ { 0, 0, 0, 0, 0 },
/* U+5bd4 */ { 0, 0, 0, 0, 0 },
/* U+5bd5 */ { 0, 0, 0, 0, 0 },
/* U+5bd6 */ { 0, 0, 0, 0, 0 },
/* U+5bd7 */ { 0, 0, 0, 0, 0 },
/* U+5bd8 */ { 0, 0, 0, 0, 0 },
/* U+5bd9 */ { 0, 0, 0, 0, 0 },
/* U+5bda */ { 0, 0, 0, 0, 0 },
/* U+5bdb */ { 0, 0, 0, 0, 0 },
/* U+5bdc */ { 0, 0, 0, 0, 0 },
/* U+5bdd */ { 0, 0, 0, 0, 0 },
/* U+5bde */ { 0, 0, 0, 0, 0 },
/* U+5bdf */ { 0, 0, 0, 0, 0 },
/* U+5be0 */ { 0, 0, 0, 0, 0 },
/* U+5be1 */ { 0, 0, 0, 0, 0 },
/* U+5be2 */ { 0, 0, 0, 0, 0 },
/* U+5be3 */ { 0, 0, 0, 0, 0 },
/* U+5be4 */ { 0, 0, 0, 0, 0 },
/* U+5be5 */ { 0, 0, 0, 0, 0 },
/* U+5be6 */ { 0, 0, 0, 0, 0 },
/* U+5be7 */ { 0, 0, 0, 0, 0 },
/* U+5be8 */ { 0, 0, 0, 0, 0 },
/* U+5be9 */ { 0, 0, 0, 0, 0 },
/* U+5bea */ { 0, 0, 0, 0, 0 },
/* U+5beb */ { 0, 0, 0, 0, 0 },
/* U+5bec */ { 0, 0, 0, 0, 0 },
/* U+5bed */ { 0, 0, 0, 0, 0 },
/* U+5bee */ { 0, 0, 0, 0, 0 },
/* U+5bef */ { 0, 0, 0, 0, 0 },
/* U+5bf0 */ { 0, 0, 0, 0, 0 },
/* U+5bf1 */ { 0, 0, 0, 0, 0 },
/* U+5bf2 */ { 0, 0, 0, 0, 0 },
/* U+5bf3 */ { 0, 0, 0, 0, 0 },
/* U+5bf4 */ { 0, 0, 0, 0, 0 },
/* U+5bf5 */ { 0, 0, 0, 0, 0 },
/* U+5bf6 */ { 0, 0, 0, 0, 0 },
/* U+5bf7 */ { 0, 0, 0, 0, 0 },
/* U+5bf8 */ { 0, 0, 0, 0, 0 },
/* U+5bf9 */ { 0, 0, 0, 0, 0 },
/* U+5bfa */ { 0, 0, 0, 0, 0 },
/* U+5bfb */ { 0, 0, 0, 0, 0 },
/* U+5bfc */ { 0, 0, 0, 0, 0 },
/* U+5bfd */ { 0, 0, 0, 0, 0 },
/* U+5bfe */ { 0, 0, 0, 0, 0 },
/* U+5bff */ { 0, 0, 0, 0, 0 },
/* U+5c00 */ { 0, 0, 0, 0, 0 },
/* U+5c01 */ { 0, 0, 0, 0, 0 },
/* U+5c02 */ { 0, 0, 0, 0, 0 },
/* U+5c03 */ { 0, 0, 0, 0, 0 },
/* U+5c04 */ { 0, 0, 0, 0, 0 },
/* U+5c05 */ { 0, 0, 0, 0, 0 },
/* U+5c06 */ { 0, 0, 0, 0, 0 },
/* U+5c07 */ { 0, 0, 0, 0, 0 },
/* U+5c08 */ { 0, 0, 0, 0, 0 },
/* U+5c09 */ { 0, 0, 0, 0, 0 },
/* U+5c0a */ { 0, 0, 0, 0, 0 },
/* U+5c0b */ { 0, 0, 0, 0, 0 },
/* U+5c0c */ { 0, 0, 0, 0, 0 },
/* U+5c0d */ { 0, 0, 0, 0, 0 },
/* U+5c0e */ { 0, 0, 0, 0, 0 },
/* U+5c0f */ { 0, 0, 0, 0, 0 },
/* U+5c10 */ { 0, 0, 0, 0, 0 },
/* U+5c11 */ { 0, 0, 0, 0, 0 },
/* U+5c12 */ { 0, 0, 0, 0, 0 },
/* U+5c13 */ { 0, 0, 0, 0, 0 },
/* U+5c14 */ { 0, 0, 0, 0, 0 },
/* U+5c15 */ { 0, 0, 0, 0, 0 },
/* U+5c16 */ { 0, 0, 0, 0, 0 },
/* U+5c17 */ { 0, 0, 0, 0, 0 },
/* U+5c18 */ { 0, 0, 0, 0, 0 },
/* U+5c19 */ { 0, 0, 0, 0, 0 },
/* U+5c1a */ { 0, 0, 0, 0, 0 },
/* U+5c1b */ { 0, 0, 0, 0, 0 },
/* U+5c1c */ { 0, 0, 0, 0, 0 },
/* U+5c1d */ { 0, 0, 0, 0, 0 },
/* U+5c1e */ { 0, 0, 0, 0, 0 },
/* U+5c1f */ { 0, 0, 0, 0, 0 },
/* U+5c20 */ { 0, 0, 0, 0, 0 },
/* U+5c21 */ { 0, 0, 0, 0, 0 },
/* U+5c22 */ { 0, 0, 0, 0, 0 },
/* U+5c23 */ { 0, 0, 0, 0, 0 },
/* U+5c24 */ { 0, 0, 0, 0, 0 },
/* U+5c25 */ { 0, 0, 0, 0, 0 },
/* U+5c26 */ { 0, 0, 0, 0, 0 },
/* U+5c27 */ { 0, 0, 0, 0, 0 },
/* U+5c28 */ { 0, 0, 0, 0, 0 },
/* U+5c29 */ { 0, 0, 0, 0, 0 },
/* U+5c2a */ { 0, 0, 0, 0, 0 },
/* U+5c2b */ { 0, 0, 0, 0, 0 },
/* U+5c2c */ { 0, 0, 0, 0, 0 },
/* U+5c2d */ { 0, 0, 0, 0, 0 },
/* U+5c2e */ { 0, 0, 0, 0, 0 },
/* U+5c2f */ { 0, 0, 0, 0, 0 },
/* U+5c30 */ { 0, 0, 0, 0, 0 },
/* U+5c31 */ { 0, 0, 0, 0, 0 },
/* U+5c32 */ { 0, 0, 0, 0, 0 },
/* U+5c33 */ { 0, 0, 0, 0, 0 },
/* U+5c34 */ { 0, 0, 0, 0, 0 },
/* U+5c35 */ { 0, 0, 0, 0, 0 },
/* U+5c36 */ { 0, 0, 0, 0, 0 },
/* U+5c37 */ { 0, 0, 0, 0, 0 },
/* U+5c38 */ { 0, 0, 0, 0, 0 },
/* U+5c39 */ { 0, 0, 0, 0, 0 },
/* U+5c3a */ { 0, 0, 0, 0, 0 },
/* U+5c3b */ { 0, 0, 0, 0, 0 },
/* U+5c3c */ { 0, 0, 0, 0, 0 },
/* U+5c3d */ { 0, 0, 0, 0, 0 },
/* U+5c3e */ { 0, 0, 0, 0, 0 },
/* U+5c3f */ { 0, 0, 0, 0, 0 },
/* U+5c40 */ { 0, 0, 0, 0, 0 },
/* U+5c41 */ { 0, 0, 0, 0, 0 },
/* U+5c42 */ { 0, 0, 0, 0, 0 },
/* U+5c43 */ { 0, 0, 0, 0, 0 },
/* U+5c44 */ { 0, 0, 0, 0, 0 },
/* U+5c45 */ { 0, 0, 0, 0, 0 },
/* U+5c46 */ { 0, 0, 0, 0, 0 },
/* U+5c47 */ { 0, 0, 0, 0, 0 },
/* U+5c48 */ { 0, 0, 0, 0, 0 },
/* U+5c49 */ { 0, 0, 0, 0, 0 },
/* U+5c4a */ { 0, 0, 0, 0, 0 },
/* U+5c4b */ { 0, 0, 0, 0, 0 },
/* U+5c4c */ { 0, 0, 0, 0, 0 },
/* U+5c4d */ { 0, 0, 0, 0, 0 },
/* U+5c4e */ { 0, 0, 0, 0, 0 },
/* U+5c4f */ { 0, 0, 0, 0, 0 },
/* U+5c50 */ { 0, 0, 0, 0, 0 },
/* U+5c51 */ { 0, 0, 0, 0, 0 },
/* U+5c52 */ { 0, 0, 0, 0, 0 },
/* U+5c53 */ { 0, 0, 0, 0, 0 },
/* U+5c54 */ { 0, 0, 0, 0, 0 },
/* U+5c55 */ { 0, 0, 0, 0, 0 },
/* U+5c56 */ { 0, 0, 0, 0, 0 },
/* U+5c57 */ { 0, 0, 0, 0, 0 },
/* U+5c58 */ { 0, 0, 0, 0, 0 },
/* U+5c59 */ { 0, 0, 0, 0, 0 },
/* U+5c5a */ { 0, 0, 0, 0, 0 },
/* U+5c5b */ { 0, 0, 0, 0, 0 },
/* U+5c5c */ { 0, 0, 0, 0, 0 },
/* U+5c5d */ { 0, 0, 0, 0, 0 },
/* U+5c5e */ { 0, 0, 0, 0, 0 },
/* U+5c5f */ { 0, 0, 0, 0, 0 },
/* U+5c60 */ { 0, 0, 0, 0, 0 },
/* U+5c61 */ { 0, 0, 0, 0, 0 },
/* U+5c62 */ { 0, 0, 0, 0, 0 },
/* U+5c63 */ { 0, 0, 0, 0, 0 },
/* U+5c64 */ { 0, 0, 0, 0, 0 },
/* U+5c65 */ { 0, 0, 0, 0, 0 },
/* U+5c66 */ { 0, 0, 0, 0, 0 },
/* U+5c67 */ { 0, 0, 0, 0, 0 },
/* U+5c68 */ { 0, 0, 0, 0, 0 },
/* U+5c69 */ { 0, 0, 0, 0, 0 },
/* U+5c6a */ { 0, 0, 0, 0, 0 },
/* U+5c6b */ { 0, 0, 0, 0, 0 },
/* U+5c6c */ { 0, 0, 0, 0, 0 },
/* U+5c6d */ { 0, 0, 0, 0, 0 },
/* U+5c6e */ { 0, 0, 0, 0, 0 },
/* U+5c6f */ { 0, 0, 0, 0, 0 },
/* U+5c70 */ { 0, 0, 0, 0, 0 },
/* U+5c71 */ { 0, 0, 0, 0, 0 },
/* U+5c72 */ { 0, 0, 0, 0, 0 },
/* U+5c73 */ { 0, 0, 0, 0, 0 },
/* U+5c74 */ { 0, 0, 0, 0, 0 },
/* U+5c75 */ { 0, 0, 0, 0, 0 },
/* U+5c76 */ { 0, 0, 0, 0, 0 },
/* U+5c77 */ { 0, 0, 0, 0, 0 },
/* U+5c78 */ { 0, 0, 0, 0, 0 },
/* U+5c79 */ { 0, 0, 0, 0, 0 },
/* U+5c7a */ { 0, 0, 0, 0, 0 },
/* U+5c7b */ { 0, 0, 0, 0, 0 },
/* U+5c7c */ { 0, 0, 0, 0, 0 },
/* U+5c7d */ { 0, 0, 0, 0, 0 },
/* U+5c7e */ { 0, 0, 0, 0, 0 },
/* U+5c7f */ { 0, 0, 0, 0, 0 },
/* U+5c80 */ { 0, 0, 0, 0, 0 },
/* U+5c81 */ { 0, 0, 0, 0, 0 },
/* U+5c82 */ { 0, 0, 0, 0, 0 },
/* U+5c83 */ { 0, 0, 0, 0, 0 },
/* U+5c84 */ { 0, 0, 0, 0, 0 },
/* U+5c85 */ { 0, 0, 0, 0, 0 },
/* U+5c86 */ { 0, 0, 0, 0, 0 },
/* U+5c87 */ { 0, 0, 0, 0, 0 },
/* U+5c88 */ { 0, 0, 0, 0, 0 },
/* U+5c89 */ { 0, 0, 0, 0, 0 },
/* U+5c8a */ { 0, 0, 0, 0, 0 },
/* U+5c8b */ { 0, 0, 0, 0, 0 },
/* U+5c8c */ { 0, 0, 0, 0, 0 },
/* U+5c8d */ { 0, 0, 0, 0, 0 },
/* U+5c8e */ { 0, 0, 0, 0, 0 },
/* U+5c8f */ { 0, 0, 0, 0, 0 },
/* U+5c90 */ { 0, 0, 0, 0, 0 },
/* U+5c91 */ { 0, 0, 0, 0, 0 },
/* U+5c92 */ { 0, 0, 0, 0, 0 },
/* U+5c93 */ { 0, 0, 0, 0, 0 },
/* U+5c94 */ { 0, 0, 0, 0, 0 },
/* U+5c95 */ { 0, 0, 0, 0, 0 },
/* U+5c96 */ { 0, 0, 0, 0, 0 },
/* U+5c97 */ { 0, 0, 0, 0, 0 },
/* U+5c98 */ { 0, 0, 0, 0, 0 },
/* U+5c99 */ { 0, 0, 0, 0, 0 },
/* U+5c9a */ { 0, 0, 0, 0, 0 },
/* U+5c9b */ { 0, 0, 0, 0, 0 },
/* U+5c9c */ { 0, 0, 0, 0, 0 },
/* U+5c9d */ { 0, 0, 0, 0, 0 },
/* U+5c9e */ { 0, 0, 0, 0, 0 },
/* U+5c9f */ { 0, 0, 0, 0, 0 },
/* U+5ca0 */ { 0, 0, 0, 0, 0 },
/* U+5ca1 */ { 0, 0, 0, 0, 0 },
/* U+5ca2 */ { 0, 0, 0, 0, 0 },
/* U+5ca3 */ { 0, 0, 0, 0, 0 },
/* U+5ca4 */ { 0, 0, 0, 0, 0 },
/* U+5ca5 */ { 0, 0, 0, 0, 0 },
/* U+5ca6 */ { 0, 0, 0, 0, 0 },
/* U+5ca7 */ { 0, 0, 0, 0, 0 },
/* U+5ca8 */ { 0, 0, 0, 0, 0 },
/* U+5ca9 */ { 0, 0, 0, 0, 0 },
/* U+5caa */ { 0, 0, 0, 0, 0 },
/* U+5cab */ { 0, 0, 0, 0, 0 },
/* U+5cac */ { 0, 0, 0, 0, 0 },
/* U+5cad */ { 0, 0, 0, 0, 0 },
/* U+5cae */ { 0, 0, 0, 0, 0 },
/* U+5caf */ { 0, 0, 0, 0, 0 },
/* U+5cb0 */ { 0, 0, 0, 0, 0 },
/* U+5cb1 */ { 0, 0, 0, 0, 0 },
/* U+5cb2 */ { 0, 0, 0, 0, 0 },
/* U+5cb3 */ { 0, 0, 0, 0, 0 },
/* U+5cb4 */ { 0, 0, 0, 0, 0 },
/* U+5cb5 */ { 0, 0, 0, 0, 0 },
/* U+5cb6 */ { 0, 0, 0, 0, 0 },
/* U+5cb7 */ { 0, 0, 0, 0, 0 },
/* U+5cb8 */ { 0, 0, 0, 0, 0 },
/* U+5cb9 */ { 0, 0, 0, 0, 0 },
/* U+5cba */ { 0, 0, 0, 0, 0 },
/* U+5cbb */ { 0, 0, 0, 0, 0 },
/* U+5cbc */ { 0, 0, 0, 0, 0 },
/* U+5cbd */ { 0, 0, 0, 0, 0 },
/* U+5cbe */ { 0, 0, 0, 0, 0 },
/* U+5cbf */ { 0, 0, 0, 0, 0 },
/* U+5cc0 */ { 0, 0, 0, 0, 0 },
/* U+5cc1 */ { 0, 0, 0, 0, 0 },
/* U+5cc2 */ { 0, 0, 0, 0, 0 },
/* U+5cc3 */ { 0, 0, 0, 0, 0 },
/* U+5cc4 */ { 0, 0, 0, 0, 0 },
/* U+5cc5 */ { 0, 0, 0, 0, 0 },
/* U+5cc6 */ { 0, 0, 0, 0, 0 },
/* U+5cc7 */ { 0, 0, 0, 0, 0 },
/* U+5cc8 */ { 0, 0, 0, 0, 0 },
/* U+5cc9 */ { 0, 0, 0, 0, 0 },
/* U+5cca */ { 0, 0, 0, 0, 0 },
/* U+5ccb */ { 0, 0, 0, 0, 0 },
/* U+5ccc */ { 0, 0, 0, 0, 0 },
/* U+5ccd */ { 0, 0, 0, 0, 0 },
/* U+5cce */ { 0, 0, 0, 0, 0 },
/* U+5ccf */ { 0, 0, 0, 0, 0 },
/* U+5cd0 */ { 0, 0, 0, 0, 0 },
/* U+5cd1 */ { 0, 0, 0, 0, 0 },
/* U+5cd2 */ { 0, 0, 0, 0, 0 },
/* U+5cd3 */ { 0, 0, 0, 0, 0 },
/* U+5cd4 */ { 0, 0, 0, 0, 0 },
/* U+5cd5 */ { 0, 0, 0, 0, 0 },
/* U+5cd6 */ { 0, 0, 0, 0, 0 },
/* U+5cd7 */ { 0, 0, 0, 0, 0 },
/* U+5cd8 */ { 0, 0, 0, 0, 0 },
/* U+5cd9 */ { 0, 0, 0, 0, 0 },
/* U+5cda */ { 0, 0, 0, 0, 0 },
/* U+5cdb */ { 0, 0, 0, 0, 0 },
/* U+5cdc */ { 0, 0, 0, 0, 0 },
/* U+5cdd */ { 0, 0, 0, 0, 0 },
/* U+5cde */ { 0, 0, 0, 0, 0 },
/* U+5cdf */ { 0, 0, 0, 0, 0 },
/* U+5ce0 */ { 0, 0, 0, 0, 0 },
/* U+5ce1 */ { 0, 0, 0, 0, 0 },
/* U+5ce2 */ { 0, 0, 0, 0, 0 },
/* U+5ce3 */ { 0, 0, 0, 0, 0 },
/* U+5ce4 */ { 0, 0, 0, 0, 0 },
/* U+5ce5 */ { 0, 0, 0, 0, 0 },
/* U+5ce6 */ { 0, 0, 0, 0, 0 },
/* U+5ce7 */ { 0, 0, 0, 0, 0 },
/* U+5ce8 */ { 0, 0, 0, 0, 0 },
/* U+5ce9 */ { 0, 0, 0, 0, 0 },
/* U+5cea */ { 0, 0, 0, 0, 0 },
/* U+5ceb */ { 0, 0, 0, 0, 0 },
/* U+5cec */ { 0, 0, 0, 0, 0 },
/* U+5ced */ { 0, 0, 0, 0, 0 },
/* U+5cee */ { 0, 0, 0, 0, 0 },
/* U+5cef */ { 0, 0, 0, 0, 0 },
/* U+5cf0 */ { 0, 0, 0, 0, 0 },
/* U+5cf1 */ { 0, 0, 0, 0, 0 },
/* U+5cf2 */ { 0, 0, 0, 0, 0 },
/* U+5cf3 */ { 0, 0, 0, 0, 0 },
/* U+5cf4 */ { 0, 0, 0, 0, 0 },
/* U+5cf5 */ { 0, 0, 0, 0, 0 },
/* U+5cf6 */ { 0, 0, 0, 0, 0 },
/* U+5cf7 */ { 0, 0, 0, 0, 0 },
/* U+5cf8 */ { 0, 0, 0, 0, 0 },
/* U+5cf9 */ { 0, 0, 0, 0, 0 },
/* U+5cfa */ { 0, 0, 0, 0, 0 },
/* U+5cfb */ { 0, 0, 0, 0, 0 },
/* U+5cfc */ { 0, 0, 0, 0, 0 },
/* U+5cfd */ { 0, 0, 0, 0, 0 },
/* U+5cfe */ { 0, 0, 0, 0, 0 },
/* U+5cff */ { 0, 0, 0, 0, 0 },
/* U+5d00 */ { 0, 0, 0, 0, 0 },
/* U+5d01 */ { 0, 0, 0, 0, 0 },
/* U+5d02 */ { 0, 0, 0, 0, 0 },
/* U+5d03 */ { 0, 0, 0, 0, 0 },
/* U+5d04 */ { 0, 0, 0, 0, 0 },
/* U+5d05 */ { 0, 0, 0, 0, 0 },
/* U+5d06 */ { 0, 0, 0, 0, 0 },
/* U+5d07 */ { 0, 0, 0, 0, 0 },
/* U+5d08 */ { 0, 0, 0, 0, 0 },
/* U+5d09 */ { 0, 0, 0, 0, 0 },
/* U+5d0a */ { 0, 0, 0, 0, 0 },
/* U+5d0b */ { 0, 0, 0, 0, 0 },
/* U+5d0c */ { 0, 0, 0, 0, 0 },
/* U+5d0d */ { 0, 0, 0, 0, 0 },
/* U+5d0e */ { 0, 0, 0, 0, 0 },
/* U+5d0f */ { 0, 0, 0, 0, 0 },
/* U+5d10 */ { 0, 0, 0, 0, 0 },
/* U+5d11 */ { 0, 0, 0, 0, 0 },
/* U+5d12 */ { 0, 0, 0, 0, 0 },
/* U+5d13 */ { 0, 0, 0, 0, 0 },
/* U+5d14 */ { 0, 0, 0, 0, 0 },
/* U+5d15 */ { 0, 0, 0, 0, 0 },
/* U+5d16 */ { 0, 0, 0, 0, 0 },
/* U+5d17 */ { 0, 0, 0, 0, 0 },
/* U+5d18 */ { 0, 0, 0, 0, 0 },
/* U+5d19 */ { 0, 0, 0, 0, 0 },
/* U+5d1a */ { 0, 0, 0, 0, 0 },
/* U+5d1b */ { 0, 0, 0, 0, 0 },
/* U+5d1c */ { 0, 0, 0, 0, 0 },
/* U+5d1d */ { 0, 0, 0, 0, 0 },
/* U+5d1e */ { 0, 0, 0, 0, 0 },
/* U+5d1f */ { 0, 0, 0, 0, 0 },
/* U+5d20 */ { 0, 0, 0, 0, 0 },
/* U+5d21 */ { 0, 0, 0, 0, 0 },
/* U+5d22 */ { 0, 0, 0, 0, 0 },
/* U+5d23 */ { 0, 0, 0, 0, 0 },
/* U+5d24 */ { 0, 0, 0, 0, 0 },
/* U+5d25 */ { 0, 0, 0, 0, 0 },
/* U+5d26 */ { 0, 0, 0, 0, 0 },
/* U+5d27 */ { 0, 0, 0, 0, 0 },
/* U+5d28 */ { 0, 0, 0, 0, 0 },
/* U+5d29 */ { 0, 0, 0, 0, 0 },
/* U+5d2a */ { 0, 0, 0, 0, 0 },
/* U+5d2b */ { 0, 0, 0, 0, 0 },
/* U+5d2c */ { 0, 0, 0, 0, 0 },
/* U+5d2d */ { 0, 0, 0, 0, 0 },
/* U+5d2e */ { 0, 0, 0, 0, 0 },
/* U+5d2f */ { 0, 0, 0, 0, 0 },
/* U+5d30 */ { 0, 0, 0, 0, 0 },
/* U+5d31 */ { 0, 0, 0, 0, 0 },
/* U+5d32 */ { 0, 0, 0, 0, 0 },
/* U+5d33 */ { 0, 0, 0, 0, 0 },
/* U+5d34 */ { 0, 0, 0, 0, 0 },
/* U+5d35 */ { 0, 0, 0, 0, 0 },
/* U+5d36 */ { 0, 0, 0, 0, 0 },
/* U+5d37 */ { 0, 0, 0, 0, 0 },
/* U+5d38 */ { 0, 0, 0, 0, 0 },
/* U+5d39 */ { 0, 0, 0, 0, 0 },
/* U+5d3a */ { 0, 0, 0, 0, 0 },
/* U+5d3b */ { 0, 0, 0, 0, 0 },
/* U+5d3c */ { 0, 0, 0, 0, 0 },
/* U+5d3d */ { 0, 0, 0, 0, 0 },
/* U+5d3e */ { 0, 0, 0, 0, 0 },
/* U+5d3f */ { 0, 0, 0, 0, 0 },
/* U+5d40 */ { 0, 0, 0, 0, 0 },
/* U+5d41 */ { 0, 0, 0, 0, 0 },
/* U+5d42 */ { 0, 0, 0, 0, 0 },
/* U+5d43 */ { 0, 0, 0, 0, 0 },
/* U+5d44 */ { 0, 0, 0, 0, 0 },
/* U+5d45 */ { 0, 0, 0, 0, 0 },
/* U+5d46 */ { 0, 0, 0, 0, 0 },
/* U+5d47 */ { 0, 0, 0, 0, 0 },
/* U+5d48 */ { 0, 0, 0, 0, 0 },
/* U+5d49 */ { 0, 0, 0, 0, 0 },
/* U+5d4a */ { 0, 0, 0, 0, 0 },
/* U+5d4b */ { 0, 0, 0, 0, 0 },
/* U+5d4c */ { 0, 0, 0, 0, 0 },
/* U+5d4d */ { 0, 0, 0, 0, 0 },
/* U+5d4e */ { 0, 0, 0, 0, 0 },
/* U+5d4f */ { 0, 0, 0, 0, 0 },
/* U+5d50 */ { 0, 0, 0, 0, 0 },
/* U+5d51 */ { 0, 0, 0, 0, 0 },
/* U+5d52 */ { 0, 0, 0, 0, 0 },
/* U+5d53 */ { 0, 0, 0, 0, 0 },
/* U+5d54 */ { 0, 0, 0, 0, 0 },
/* U+5d55 */ { 0, 0, 0, 0, 0 },
/* U+5d56 */ { 0, 0, 0, 0, 0 },
/* U+5d57 */ { 0, 0, 0, 0, 0 },
/* U+5d58 */ { 0, 0, 0, 0, 0 },
/* U+5d59 */ { 0, 0, 0, 0, 0 },
/* U+5d5a */ { 0, 0, 0, 0, 0 },
/* U+5d5b */ { 0, 0, 0, 0, 0 },
/* U+5d5c */ { 0, 0, 0, 0, 0 },
/* U+5d5d */ { 0, 0, 0, 0, 0 },
/* U+5d5e */ { 0, 0, 0, 0, 0 },
/* U+5d5f */ { 0, 0, 0, 0, 0 },
/* U+5d60 */ { 0, 0, 0, 0, 0 },
/* U+5d61 */ { 0, 0, 0, 0, 0 },
/* U+5d62 */ { 0, 0, 0, 0, 0 },
/* U+5d63 */ { 0, 0, 0, 0, 0 },
/* U+5d64 */ { 0, 0, 0, 0, 0 },
/* U+5d65 */ { 0, 0, 0, 0, 0 },
/* U+5d66 */ { 0, 0, 0, 0, 0 },
/* U+5d67 */ { 0, 0, 0, 0, 0 },
/* U+5d68 */ { 0, 0, 0, 0, 0 },
/* U+5d69 */ { 0, 0, 0, 0, 0 },
/* U+5d6a */ { 0, 0, 0, 0, 0 },
/* U+5d6b */ { 0, 0, 0, 0, 0 },
/* U+5d6c */ { 0, 0, 0, 0, 0 },
/* U+5d6d */ { 0, 0, 0, 0, 0 },
/* U+5d6e */ { 0, 0, 0, 0, 0 },
/* U+5d6f */ { 0, 0, 0, 0, 0 },
/* U+5d70 */ { 0, 0, 0, 0, 0 },
/* U+5d71 */ { 0, 0, 0, 0, 0 },
/* U+5d72 */ { 0, 0, 0, 0, 0 },
/* U+5d73 */ { 0, 0, 0, 0, 0 },
/* U+5d74 */ { 0, 0, 0, 0, 0 },
/* U+5d75 */ { 0, 0, 0, 0, 0 },
/* U+5d76 */ { 0, 0, 0, 0, 0 },
/* U+5d77 */ { 0, 0, 0, 0, 0 },
/* U+5d78 */ { 0, 0, 0, 0, 0 },
/* U+5d79 */ { 0, 0, 0, 0, 0 },
/* U+5d7a */ { 0, 0, 0, 0, 0 },
/* U+5d7b */ { 0, 0, 0, 0, 0 },
/* U+5d7c */ { 0, 0, 0, 0, 0 },
/* U+5d7d */ { 0, 0, 0, 0, 0 },
/* U+5d7e */ { 0, 0, 0, 0, 0 },
/* U+5d7f */ { 0, 0, 0, 0, 0 },
/* U+5d80 */ { 0, 0, 0, 0, 0 },
/* U+5d81 */ { 0, 0, 0, 0, 0 },
/* U+5d82 */ { 0, 0, 0, 0, 0 },
/* U+5d83 */ { 0, 0, 0, 0, 0 },
/* U+5d84 */ { 0, 0, 0, 0, 0 },
/* U+5d85 */ { 0, 0, 0, 0, 0 },
/* U+5d86 */ { 0, 0, 0, 0, 0 },
/* U+5d87 */ { 0, 0, 0, 0, 0 },
/* U+5d88 */ { 0, 0, 0, 0, 0 },
/* U+5d89 */ { 0, 0, 0, 0, 0 },
/* U+5d8a */ { 0, 0, 0, 0, 0 },
/* U+5d8b */ { 0, 0, 0, 0, 0 },
/* U+5d8c */ { 0, 0, 0, 0, 0 },
/* U+5d8d */ { 0, 0, 0, 0, 0 },
/* U+5d8e */ { 0, 0, 0, 0, 0 },
/* U+5d8f */ { 0, 0, 0, 0, 0 },
/* U+5d90 */ { 0, 0, 0, 0, 0 },
/* U+5d91 */ { 0, 0, 0, 0, 0 },
/* U+5d92 */ { 0, 0, 0, 0, 0 },
/* U+5d93 */ { 0, 0, 0, 0, 0 },
/* U+5d94 */ { 0, 0, 0, 0, 0 },
/* U+5d95 */ { 0, 0, 0, 0, 0 },
/* U+5d96 */ { 0, 0, 0, 0, 0 },
/* U+5d97 */ { 0, 0, 0, 0, 0 },
/* U+5d98 */ { 0, 0, 0, 0, 0 },
/* U+5d99 */ { 0, 0, 0, 0, 0 },
/* U+5d9a */ { 0, 0, 0, 0, 0 },
/* U+5d9b */ { 0, 0, 0, 0, 0 },
/* U+5d9c */ { 0, 0, 0, 0, 0 },
/* U+5d9d */ { 0, 0, 0, 0, 0 },
/* U+5d9e */ { 0, 0, 0, 0, 0 },
/* U+5d9f */ { 0, 0, 0, 0, 0 },
/* U+5da0 */ { 0, 0, 0, 0, 0 },
/* U+5da1 */ { 0, 0, 0, 0, 0 },
/* U+5da2 */ { 0, 0, 0, 0, 0 },
/* U+5da3 */ { 0, 0, 0, 0, 0 },
/* U+5da4 */ { 0, 0, 0, 0, 0 },
/* U+5da5 */ { 0, 0, 0, 0, 0 },
/* U+5da6 */ { 0, 0, 0, 0, 0 },
/* U+5da7 */ { 0, 0, 0, 0, 0 },
/* U+5da8 */ { 0, 0, 0, 0, 0 },
/* U+5da9 */ { 0, 0, 0, 0, 0 },
/* U+5daa */ { 0, 0, 0, 0, 0 },
/* U+5dab */ { 0, 0, 0, 0, 0 },
/* U+5dac */ { 0, 0, 0, 0, 0 },
/* U+5dad */ { 0, 0, 0, 0, 0 },
/* U+5dae */ { 0, 0, 0, 0, 0 },
/* U+5daf */ { 0, 0, 0, 0, 0 },
/* U+5db0 */ { 0, 0, 0, 0, 0 },
/* U+5db1 */ { 0, 0, 0, 0, 0 },
/* U+5db2 */ { 0, 0, 0, 0, 0 },
/* U+5db3 */ { 0, 0, 0, 0, 0 },
/* U+5db4 */ { 0, 0, 0, 0, 0 },
/* U+5db5 */ { 0, 0, 0, 0, 0 },
/* U+5db6 */ { 0, 0, 0, 0, 0 },
/* U+5db7 */ { 0, 0, 0, 0, 0 },
/* U+5db8 */ { 0, 0, 0, 0, 0 },
/* U+5db9 */ { 0, 0, 0, 0, 0 },
/* U+5dba */ { 0, 0, 0, 0, 0 },
/* U+5dbb */ { 0, 0, 0, 0, 0 },
/* U+5dbc */ { 0, 0, 0, 0, 0 },
/* U+5dbd */ { 0, 0, 0, 0, 0 },
/* U+5dbe */ { 0, 0, 0, 0, 0 },
/* U+5dbf */ { 0, 0, 0, 0, 0 },
/* U+5dc0 */ { 0, 0, 0, 0, 0 },
/* U+5dc1 */ { 0, 0, 0, 0, 0 },
/* U+5dc2 */ { 0, 0, 0, 0, 0 },
/* U+5dc3 */ { 0, 0, 0, 0, 0 },
/* U+5dc4 */ { 0, 0, 0, 0, 0 },
/* U+5dc5 */ { 0, 0, 0, 0, 0 },
/* U+5dc6 */ { 0, 0, 0, 0, 0 },
/* U+5dc7 */ { 0, 0, 0, 0, 0 },
/* U+5dc8 */ { 0, 0, 0, 0, 0 },
/* U+5dc9 */ { 0, 0, 0, 0, 0 },
/* U+5dca */ { 0, 0, 0, 0, 0 },
/* U+5dcb */ { 0, 0, 0, 0, 0 },
/* U+5dcc */ { 0, 0, 0, 0, 0 },
/* U+5dcd */ { 0, 0, 0, 0, 0 },
/* U+5dce */ { 0, 0, 0, 0, 0 },
/* U+5dcf */ { 0, 0, 0, 0, 0 },
/* U+5dd0 */ { 0, 0, 0, 0, 0 },
/* U+5dd1 */ { 0, 0, 0, 0, 0 },
/* U+5dd2 */ { 0, 0, 0, 0, 0 },
/* U+5dd3 */ { 0, 0, 0, 0, 0 },
/* U+5dd4 */ { 0, 0, 0, 0, 0 },
/* U+5dd5 */ { 0, 0, 0, 0, 0 },
/* U+5dd6 */ { 0, 0, 0, 0, 0 },
/* U+5dd7 */ { 0, 0, 0, 0, 0 },
/* U+5dd8 */ { 0, 0, 0, 0, 0 },
/* U+5dd9 */ { 0, 0, 0, 0, 0 },
/* U+5dda */ { 0, 0, 0, 0, 0 },
/* U+5ddb */ { 0, 0, 0, 0, 0 },
/* U+5ddc */ { 0, 0, 0, 0, 0 },
/* U+5ddd */ { 0, 0, 0, 0, 0 },
/* U+5dde */ { 0, 0, 0, 0, 0 },
/* U+5ddf */ { 0, 0, 0, 0, 0 },
/* U+5de0 */ { 0, 0, 0, 0, 0 },
/* U+5de1 */ { 0, 0, 0, 0, 0 },
/* U+5de2 */ { 0, 0, 0, 0, 0 },
/* U+5de3 */ { 0, 0, 0, 0, 0 },
/* U+5de4 */ { 0, 0, 0, 0, 0 },
/* U+5de5 */ { 0, 0, 0, 0, 0 },
/* U+5de6 */ { 0, 0, 0, 0, 0 },
/* U+5de7 */ { 0, 0, 0, 0, 0 },
/* U+5de8 */ { 0, 0, 0, 0, 0 },
/* U+5de9 */ { 0, 0, 0, 0, 0 },
/* U+5dea */ { 0, 0, 0, 0, 0 },
/* U+5deb */ { 0, 0, 0, 0, 0 },
/* U+5dec */ { 0, 0, 0, 0, 0 },
/* U+5ded */ { 0, 0, 0, 0, 0 },
/* U+5dee */ { 0, 0, 0, 0, 0 },
/* U+5def */ { 0, 0, 0, 0, 0 },
/* U+5df0 */ { 0, 0, 0, 0, 0 },
/* U+5df1 */ { 0, 0, 0, 0, 0 },
/* U+5df2 */ { 0, 0, 0, 0, 0 },
/* U+5df3 */ { 0, 0, 0, 0, 0 },
/* U+5df4 */ { 0, 0, 0, 0, 0 },
/* U+5df5 */ { 0, 0, 0, 0, 0 },
/* U+5df6 */ { 0, 0, 0, 0, 0 },
/* U+5df7 */ { 0, 0, 0, 0, 0 },
/* U+5df8 */ { 0, 0, 0, 0, 0 },
/* U+5df9 */ { 0, 0, 0, 0, 0 },
/* U+5dfa */ { 0, 0, 0, 0, 0 },
/* U+5dfb */ { 0, 0, 0, 0, 0 },
/* U+5dfc */ { 0, 0, 0, 0, 0 },
/* U+5dfd */ { 0, 0, 0, 0, 0 },
/* U+5dfe */ { 0, 0, 0, 0, 0 },
/* U+5dff */ { 0, 0, 0, 0, 0 },
/* U+5e00 */ { 0, 0, 0, 0, 0 },
/* U+5e01 */ { 0, 0, 0, 0, 0 },
/* U+5e02 */ { 0, 0, 0, 0, 0 },
/* U+5e03 */ { 0, 0, 0, 0, 0 },
/* U+5e04 */ { 0, 0, 0, 0, 0 },
/* U+5e05 */ { 0, 0, 0, 0, 0 },
/* U+5e06 */ { 0, 0, 0, 0, 0 },
/* U+5e07 */ { 0, 0, 0, 0, 0 },
/* U+5e08 */ { 0, 0, 0, 0, 0 },
/* U+5e09 */ { 0, 0, 0, 0, 0 },
/* U+5e0a */ { 0, 0, 0, 0, 0 },
/* U+5e0b */ { 0, 0, 0, 0, 0 },
/* U+5e0c */ { 0, 0, 0, 0, 0 },
/* U+5e0d */ { 0, 0, 0, 0, 0 },
/* U+5e0e */ { 0, 0, 0, 0, 0 },
/* U+5e0f */ { 0, 0, 0, 0, 0 },
/* U+5e10 */ { 0, 0, 0, 0, 0 },
/* U+5e11 */ { 0, 0, 0, 0, 0 },
/* U+5e12 */ { 0, 0, 0, 0, 0 },
/* U+5e13 */ { 0, 0, 0, 0, 0 },
/* U+5e14 */ { 0, 0, 0, 0, 0 },
/* U+5e15 */ { 0, 0, 0, 0, 0 },
/* U+5e16 */ { 0, 0, 0, 0, 0 },
/* U+5e17 */ { 0, 0, 0, 0, 0 },
/* U+5e18 */ { 0, 0, 0, 0, 0 },
/* U+5e19 */ { 0, 0, 0, 0, 0 },
/* U+5e1a */ { 0, 0, 0, 0, 0 },
/* U+5e1b */ { 0, 0, 0, 0, 0 },
/* U+5e1c */ { 0, 0, 0, 0, 0 },
/* U+5e1d */ { 0, 0, 0, 0, 0 },
/* U+5e1e */ { 0, 0, 0, 0, 0 },
/* U+5e1f */ { 0, 0, 0, 0, 0 },
/* U+5e20 */ { 0, 0, 0, 0, 0 },
/* U+5e21 */ { 0, 0, 0, 0, 0 },
/* U+5e22 */ { 0, 0, 0, 0, 0 },
/* U+5e23 */ { 0, 0, 0, 0, 0 },
/* U+5e24 */ { 0, 0, 0, 0, 0 },
/* U+5e25 */ { 0, 0, 0, 0, 0 },
/* U+5e26 */ { 0, 0, 0, 0, 0 },
/* U+5e27 */ { 0, 0, 0, 0, 0 },
/* U+5e28 */ { 0, 0, 0, 0, 0 },
/* U+5e29 */ { 0, 0, 0, 0, 0 },
/* U+5e2a */ { 0, 0, 0, 0, 0 },
/* U+5e2b */ { 0, 0, 0, 0, 0 },
/* U+5e2c */ { 0, 0, 0, 0, 0 },
/* U+5e2d */ { 0, 0, 0, 0, 0 },
/* U+5e2e */ { 0, 0, 0, 0, 0 },
/* U+5e2f */ { 0, 0, 0, 0, 0 },
/* U+5e30 */ { 0, 0, 0, 0, 0 },
/* U+5e31 */ { 0, 0, 0, 0, 0 },
/* U+5e32 */ { 0, 0, 0, 0, 0 },
/* U+5e33 */ { 0, 0, 0, 0, 0 },
/* U+5e34 */ { 0, 0, 0, 0, 0 },
/* U+5e35 */ { 0, 0, 0, 0, 0 },
/* U+5e36 */ { 0, 0, 0, 0, 0 },
/* U+5e37 */ { 0, 0, 0, 0, 0 },
/* U+5e38 */ { 0, 0, 0, 0, 0 },
/* U+5e39 */ { 0, 0, 0, 0, 0 },
/* U+5e3a */ { 0, 0, 0, 0, 0 },
/* U+5e3b */ { 0, 0, 0, 0, 0 },
/* U+5e3c */ { 0, 0, 0, 0, 0 },
/* U+5e3d */ { 0, 0, 0, 0, 0 },
/* U+5e3e */ { 0, 0, 0, 0, 0 },
/* U+5e3f */ { 0, 0, 0, 0, 0 },
/* U+5e40 */ { 0, 0, 0, 0, 0 },
/* U+5e41 */ { 0, 0, 0, 0, 0 },
/* U+5e42 */ { 0, 0, 0, 0, 0 },
/* U+5e43 */ { 0, 0, 0, 0, 0 },
/* U+5e44 */ { 0, 0, 0, 0, 0 },
/* U+5e45 */ { 0, 0, 0, 0, 0 },
/* U+5e46 */ { 0, 0, 0, 0, 0 },
/* U+5e47 */ { 0, 0, 0, 0, 0 },
/* U+5e48 */ { 0, 0, 0, 0, 0 },
/* U+5e49 */ { 0, 0, 0, 0, 0 },
/* U+5e4a */ { 0, 0, 0, 0, 0 },
/* U+5e4b */ { 0, 0, 0, 0, 0 },
/* U+5e4c */ { 0, 0, 0, 0, 0 },
/* U+5e4d */ { 0, 0, 0, 0, 0 },
/* U+5e4e */ { 0, 0, 0, 0, 0 },
/* U+5e4f */ { 0, 0, 0, 0, 0 },
/* U+5e50 */ { 0, 0, 0, 0, 0 },
/* U+5e51 */ { 0, 0, 0, 0, 0 },
/* U+5e52 */ { 0, 0, 0, 0, 0 },
/* U+5e53 */ { 0, 0, 0, 0, 0 },
/* U+5e54 */ { 0, 0, 0, 0, 0 },
/* U+5e55 */ { 0, 0, 0, 0, 0 },
/* U+5e56 */ { 0, 0, 0, 0, 0 },
/* U+5e57 */ { 0, 0, 0, 0, 0 },
/* U+5e58 */ { 0, 0, 0, 0, 0 },
/* U+5e59 */ { 0, 0, 0, 0, 0 },
/* U+5e5a */ { 0, 0, 0, 0, 0 },
/* U+5e5b */ { 0, 0, 0, 0, 0 },
/* U+5e5c */ { 0, 0, 0, 0, 0 },
/* U+5e5d */ { 0, 0, 0, 0, 0 },
/* U+5e5e */ { 0, 0, 0, 0, 0 },
/* U+5e5f */ { 0, 0, 0, 0, 0 },
/* U+5e60 */ { 0, 0, 0, 0, 0 },
/* U+5e61 */ { 0, 0, 0, 0, 0 },
/* U+5e62 */ { 0, 0, 0, 0, 0 },
/* U+5e63 */ { 0, 0, 0, 0, 0 },
/* U+5e64 */ { 0, 0, 0, 0, 0 },
/* U+5e65 */ { 0, 0, 0, 0, 0 },
/* U+5e66 */ { 0, 0, 0, 0, 0 },
/* U+5e67 */ { 0, 0, 0, 0, 0 },
/* U+5e68 */ { 0, 0, 0, 0, 0 },
/* U+5e69 */ { 0, 0, 0, 0, 0 },
/* U+5e6a */ { 0, 0, 0, 0, 0 },
/* U+5e6b */ { 0, 0, 0, 0, 0 },
/* U+5e6c */ { 0, 0, 0, 0, 0 },
/* U+5e6d */ { 0, 0, 0, 0, 0 },
/* U+5e6e */ { 0, 0, 0, 0, 0 },
/* U+5e6f */ { 0, 0, 0, 0, 0 },
/* U+5e70 */ { 0, 0, 0, 0, 0 },
/* U+5e71 */ { 0, 0, 0, 0, 0 },
/* U+5e72 */ { 0, 0, 0, 0, 0 },
/* U+5e73 */ { 0, 0, 0, 0, 0 },
/* U+5e74 */ { 0, 0, 0, 0, 0 },
/* U+5e75 */ { 0, 0, 0, 0, 0 },
/* U+5e76 */ { 0, 0, 0, 0, 0 },
/* U+5e77 */ { 0, 0, 0, 0, 0 },
/* U+5e78 */ { 0, 0, 0, 0, 0 },
/* U+5e79 */ { 0, 0, 0, 0, 0 },
/* U+5e7a */ { 0, 0, 0, 0, 0 },
/* U+5e7b */ { 0, 0, 0, 0, 0 },
/* U+5e7c */ { 0, 0, 0, 0, 0 },
/* U+5e7d */ { 0, 0, 0, 0, 0 },
/* U+5e7e */ { 0, 0, 0, 0, 0 },
/* U+5e7f */ { 0, 0, 0, 0, 0 },
/* U+5e80 */ { 0, 0, 0, 0, 0 },
/* U+5e81 */ { 0, 0, 0, 0, 0 },
/* U+5e82 */ { 0, 0, 0, 0, 0 },
/* U+5e83 */ { 0, 0, 0, 0, 0 },
/* U+5e84 */ { 0, 0, 0, 0, 0 },
/* U+5e85 */ { 0, 0, 0, 0, 0 },
/* U+5e86 */ { 0, 0, 0, 0, 0 },
/* U+5e87 */ { 0, 0, 0, 0, 0 },
/* U+5e88 */ { 0, 0, 0, 0, 0 },
/* U+5e89 */ { 0, 0, 0, 0, 0 },
/* U+5e8a */ { 0, 0, 0, 0, 0 },
/* U+5e8b */ { 0, 0, 0, 0, 0 },
/* U+5e8c */ { 0, 0, 0, 0, 0 },
/* U+5e8d */ { 0, 0, 0, 0, 0 },
/* U+5e8e */ { 0, 0, 0, 0, 0 },
/* U+5e8f */ { 0, 0, 0, 0, 0 },
/* U+5e90 */ { 0, 0, 0, 0, 0 },
/* U+5e91 */ { 0, 0, 0, 0, 0 },
/* U+5e92 */ { 0, 0, 0, 0, 0 },
/* U+5e93 */ { 0, 0, 0, 0, 0 },
/* U+5e94 */ { 0, 0, 0, 0, 0 },
/* U+5e95 */ { 0, 0, 0, 0, 0 },
/* U+5e96 */ { 0, 0, 0, 0, 0 },
/* U+5e97 */ { 0, 0, 0, 0, 0 },
/* U+5e98 */ { 0, 0, 0, 0, 0 },
/* U+5e99 */ { 0, 0, 0, 0, 0 },
/* U+5e9a */ { 0, 0, 0, 0, 0 },
/* U+5e9b */ { 0, 0, 0, 0, 0 },
/* U+5e9c */ { 0, 0, 0, 0, 0 },
/* U+5e9d */ { 0, 0, 0, 0, 0 },
/* U+5e9e */ { 0, 0, 0, 0, 0 },
/* U+5e9f */ { 0, 0, 0, 0, 0 },
/* U+5ea0 */ { 0, 0, 0, 0, 0 },
/* U+5ea1 */ { 0, 0, 0, 0, 0 },
/* U+5ea2 */ { 0, 0, 0, 0, 0 },
/* U+5ea3 */ { 0, 0, 0, 0, 0 },
/* U+5ea4 */ { 0, 0, 0, 0, 0 },
/* U+5ea5 */ { 0, 0, 0, 0, 0 },
/* U+5ea6 */ { 0, 0, 0, 0, 0 },
/* U+5ea7 */ { 0, 0, 0, 0, 0 },
/* U+5ea8 */ { 0, 0, 0, 0, 0 },
/* U+5ea9 */ { 0, 0, 0, 0, 0 },
/* U+5eaa */ { 0, 0, 0, 0, 0 },
/* U+5eab */ { 0, 0, 0, 0, 0 },
/* U+5eac */ { 0, 0, 0, 0, 0 },
/* U+5ead */ { 0, 0, 0, 0, 0 },
/* U+5eae */ { 0, 0, 0, 0, 0 },
/* U+5eaf */ { 0, 0, 0, 0, 0 },
/* U+5eb0 */ { 0, 0, 0, 0, 0 },
/* U+5eb1 */ { 0, 0, 0, 0, 0 },
/* U+5eb2 */ { 0, 0, 0, 0, 0 },
/* U+5eb3 */ { 0, 0, 0, 0, 0 },
/* U+5eb4 */ { 0, 0, 0, 0, 0 },
/* U+5eb5 */ { 0, 0, 0, 0, 0 },
/* U+5eb6 */ { 0, 0, 0, 0, 0 },
/* U+5eb7 */ { 0, 0, 0, 0, 0 },
/* U+5eb8 */ { 0, 0, 0, 0, 0 },
/* U+5eb9 */ { 0, 0, 0, 0, 0 },
/* U+5eba */ { 0, 0, 0, 0, 0 },
/* U+5ebb */ { 0, 0, 0, 0, 0 },
/* U+5ebc */ { 0, 0, 0, 0, 0 },
/* U+5ebd */ { 0, 0, 0, 0, 0 },
/* U+5ebe */ { 0, 0, 0, 0, 0 },
/* U+5ebf */ { 0, 0, 0, 0, 0 },
/* U+5ec0 */ { 0, 0, 0, 0, 0 },
/* U+5ec1 */ { 0, 0, 0, 0, 0 },
/* U+5ec2 */ { 0, 0, 0, 0, 0 },
/* U+5ec3 */ { 0, 0, 0, 0, 0 },
/* U+5ec4 */ { 0, 0, 0, 0, 0 },
/* U+5ec5 */ { 0, 0, 0, 0, 0 },
/* U+5ec6 */ { 0, 0, 0, 0, 0 },
/* U+5ec7 */ { 0, 0, 0, 0, 0 },
/* U+5ec8 */ { 0, 0, 0, 0, 0 },
/* U+5ec9 */ { 0, 0, 0, 0, 0 },
/* U+5eca */ { 0, 0, 0, 0, 0 },
/* U+5ecb */ { 0, 0, 0, 0, 0 },
/* U+5ecc */ { 0, 0, 0, 0, 0 },
/* U+5ecd */ { 0, 0, 0, 0, 0 },
/* U+5ece */ { 0, 0, 0, 0, 0 },
/* U+5ecf */ { 0, 0, 0, 0, 0 },
/* U+5ed0 */ { 0, 0, 0, 0, 0 },
/* U+5ed1 */ { 0, 0, 0, 0, 0 },
/* U+5ed2 */ { 0, 0, 0, 0, 0 },
/* U+5ed3 */ { 0, 0, 0, 0, 0 },
/* U+5ed4 */ { 0, 0, 0, 0, 0 },
/* U+5ed5 */ { 0, 0, 0, 0, 0 },
/* U+5ed6 */ { 0, 0, 0, 0, 0 },
/* U+5ed7 */ { 0, 0, 0, 0, 0 },
/* U+5ed8 */ { 0, 0, 0, 0, 0 },
/* U+5ed9 */ { 0, 0, 0, 0, 0 },
/* U+5eda */ { 0, 0, 0, 0, 0 },
/* U+5edb */ { 0, 0, 0, 0, 0 },
/* U+5edc */ { 0, 0, 0, 0, 0 },
/* U+5edd */ { 0, 0, 0, 0, 0 },
/* U+5ede */ { 0, 0, 0, 0, 0 },
/* U+5edf */ { 0, 0, 0, 0, 0 },
/* U+5ee0 */ { 0, 0, 0, 0, 0 },
/* U+5ee1 */ { 0, 0, 0, 0, 0 },
/* U+5ee2 */ { 0, 0, 0, 0, 0 },
/* U+5ee3 */ { 0, 0, 0, 0, 0 },
/* U+5ee4 */ { 0, 0, 0, 0, 0 },
/* U+5ee5 */ { 0, 0, 0, 0, 0 },
/* U+5ee6 */ { 0, 0, 0, 0, 0 },
/* U+5ee7 */ { 0, 0, 0, 0, 0 },
/* U+5ee8 */ { 0, 0, 0, 0, 0 },
/* U+5ee9 */ { 0, 0, 0, 0, 0 },
/* U+5eea */ { 0, 0, 0, 0, 0 },
/* U+5eeb */ { 0, 0, 0, 0, 0 },
/* U+5eec */ { 0, 0, 0, 0, 0 },
/* U+5eed */ { 0, 0, 0, 0, 0 },
/* U+5eee */ { 0, 0, 0, 0, 0 },
/* U+5eef */ { 0, 0, 0, 0, 0 },
/* U+5ef0 */ { 0, 0, 0, 0, 0 },
/* U+5ef1 */ { 0, 0, 0, 0, 0 },
/* U+5ef2 */ { 0, 0, 0, 0, 0 },
/* U+5ef3 */ { 0, 0, 0, 0, 0 },
/* U+5ef4 */ { 0, 0, 0, 0, 0 },
/* U+5ef5 */ { 0, 0, 0, 0, 0 },
/* U+5ef6 */ { 0, 0, 0, 0, 0 },
/* U+5ef7 */ { 0, 0, 0, 0, 0 },
/* U+5ef8 */ { 0, 0, 0, 0, 0 },
/* U+5ef9 */ { 0, 0, 0, 0, 0 },
/* U+5efa */ { 0, 0, 0, 0, 0 },
/* U+5efb */ { 0, 0, 0, 0, 0 },
/* U+5efc */ { 0, 0, 0, 0, 0 },
/* U+5efd */ { 0, 0, 0, 0, 0 },
/* U+5efe */ { 0, 0, 0, 0, 0 },
/* U+5eff */ { 0, 0, 0, 0, 0 },
/* U+5f00 */ { 0, 0, 0, 0, 0 },
/* U+5f01 */ { 0, 0, 0, 0, 0 },
/* U+5f02 */ { 0, 0, 0, 0, 0 },
/* U+5f03 */ { 0, 0, 0, 0, 0 },
/* U+5f04 */ { 0, 0, 0, 0, 0 },
/* U+5f05 */ { 0, 0, 0, 0, 0 },
/* U+5f06 */ { 0, 0, 0, 0, 0 },
/* U+5f07 */ { 0, 0, 0, 0, 0 },
/* U+5f08 */ { 0, 0, 0, 0, 0 },
/* U+5f09 */ { 0, 0, 0, 0, 0 },
/* U+5f0a */ { 0, 0, 0, 0, 0 },
/* U+5f0b */ { 0, 0, 0, 0, 0 },
/* U+5f0c */ { 0, 0, 0, 0, 0 },
/* U+5f0d */ { 0, 0, 0, 0, 0 },
/* U+5f0e */ { 0, 0, 0, 0, 0 },
/* U+5f0f */ { 0, 0, 0, 0, 0 },
/* U+5f10 */ { 0, 0, 0, 0, 0 },
/* U+5f11 */ { 0, 0, 0, 0, 0 },
/* U+5f12 */ { 0, 0, 0, 0, 0 },
/* U+5f13 */ { 0, 0, 0, 0, 0 },
/* U+5f14 */ { 0, 0, 0, 0, 0 },
/* U+5f15 */ { 0, 0, 0, 0, 0 },
/* U+5f16 */ { 0, 0, 0, 0, 0 },
/* U+5f17 */ { 0, 0, 0, 0, 0 },
/* U+5f18 */ { 0, 0, 0, 0, 0 },
/* U+5f19 */ { 0, 0, 0, 0, 0 },
/* U+5f1a */ { 0, 0, 0, 0, 0 },
/* U+5f1b */ { 0, 0, 0, 0, 0 },
/* U+5f1c */ { 0, 0, 0, 0, 0 },
/* U+5f1d */ { 0, 0, 0, 0, 0 },
/* U+5f1e */ { 0, 0, 0, 0, 0 },
/* U+5f1f */ { 0, 0, 0, 0, 0 },
/* U+5f20 */ { 0, 0, 0, 0, 0 },
/* U+5f21 */ { 0, 0, 0, 0, 0 },
/* U+5f22 */ { 0, 0, 0, 0, 0 },
/* U+5f23 */ { 0, 0, 0, 0, 0 },
/* U+5f24 */ { 0, 0, 0, 0, 0 },
/* U+5f25 */ { 0, 0, 0, 0, 0 },
/* U+5f26 */ { 0, 0, 0, 0, 0 },
/* U+5f27 */ { 0, 0, 0, 0, 0 },
/* U+5f28 */ { 0, 0, 0, 0, 0 },
/* U+5f29 */ { 0, 0, 0, 0, 0 },
/* U+5f2a */ { 0, 0, 0, 0, 0 },
/* U+5f2b */ { 0, 0, 0, 0, 0 },
/* U+5f2c */ { 0, 0, 0, 0, 0 },
/* U+5f2d */ { 0, 0, 0, 0, 0 },
/* U+5f2e */ { 0, 0, 0, 0, 0 },
/* U+5f2f */ { 0, 0, 0, 0, 0 },
/* U+5f30 */ { 0, 0, 0, 0, 0 },
/* U+5f31 */ { 0, 0, 0, 0, 0 },
/* U+5f32 */ { 0, 0, 0, 0, 0 },
/* U+5f33 */ { 0, 0, 0, 0, 0 },
/* U+5f34 */ { 0, 0, 0, 0, 0 },
/* U+5f35 */ { 0, 0, 0, 0, 0 },
/* U+5f36 */ { 0, 0, 0, 0, 0 },
/* U+5f37 */ { 0, 0, 0, 0, 0 },
/* U+5f38 */ { 0, 0, 0, 0, 0 },
/* U+5f39 */ { 0, 0, 0, 0, 0 },
/* U+5f3a */ { 0, 0, 0, 0, 0 },
/* U+5f3b */ { 0, 0, 0, 0, 0 },
/* U+5f3c */ { 0, 0, 0, 0, 0 },
/* U+5f3d */ { 0, 0, 0, 0, 0 },
/* U+5f3e */ { 0, 0, 0, 0, 0 },
/* U+5f3f */ { 0, 0, 0, 0, 0 },
/* U+5f40 */ { 0, 0, 0, 0, 0 },
/* U+5f41 */ { 0, 0, 0, 0, 0 },
/* U+5f42 */ { 0, 0, 0, 0, 0 },
/* U+5f43 */ { 0, 0, 0, 0, 0 },
/* U+5f44 */ { 0, 0, 0, 0, 0 },
/* U+5f45 */ { 0, 0, 0, 0, 0 },
/* U+5f46 */ { 0, 0, 0, 0, 0 },
/* U+5f47 */ { 0, 0, 0, 0, 0 },
/* U+5f48 */ { 0, 0, 0, 0, 0 },
/* U+5f49 */ { 0, 0, 0, 0, 0 },
/* U+5f4a */ { 0, 0, 0, 0, 0 },
/* U+5f4b */ { 0, 0, 0, 0, 0 },
/* U+5f4c */ { 0, 0, 0, 0, 0 },
/* U+5f4d */ { 0, 0, 0, 0, 0 },
/* U+5f4e */ { 0, 0, 0, 0, 0 },
/* U+5f4f */ { 0, 0, 0, 0, 0 },
/* U+5f50 */ { 0, 0, 0, 0, 0 },
/* U+5f51 */ { 0, 0, 0, 0, 0 },
/* U+5f52 */ { 0, 0, 0, 0, 0 },
/* U+5f53 */ { 0, 0, 0, 0, 0 },
/* U+5f54 */ { 0, 0, 0, 0, 0 },
/* U+5f55 */ { 0, 0, 0, 0, 0 },
/* U+5f56 */ { 0, 0, 0, 0, 0 },
/* U+5f57 */ { 0, 0, 0, 0, 0 },
/* U+5f58 */ { 0, 0, 0, 0, 0 },
/* U+5f59 */ { 0, 0, 0, 0, 0 },
/* U+5f5a */ { 0, 0, 0, 0, 0 },
/* U+5f5b */ { 0, 0, 0, 0, 0 },
/* U+5f5c */ { 0, 0, 0, 0, 0 },
/* U+5f5d */ { 0, 0, 0, 0, 0 },
/* U+5f5e */ { 0, 0, 0, 0, 0 },
/* U+5f5f */ { 0, 0, 0, 0, 0 },
/* U+5f60 */ { 0, 0, 0, 0, 0 },
/* U+5f61 */ { 0, 0, 0, 0, 0 },
/* U+5f62 */ { 0, 0, 0, 0, 0 },
/* U+5f63 */ { 0, 0, 0, 0, 0 },
/* U+5f64 */ { 0, 0, 0, 0, 0 },
/* U+5f65 */ { 0, 0, 0, 0, 0 },
/* U+5f66 */ { 0, 0, 0, 0, 0 },
/* U+5f67 */ { 0, 0, 0, 0, 0 },
/* U+5f68 */ { 0, 0, 0, 0, 0 },
/* U+5f69 */ { 0, 0, 0, 0, 0 },
/* U+5f6a */ { 0, 0, 0, 0, 0 },
/* U+5f6b */ { 0, 0, 0, 0, 0 },
/* U+5f6c */ { 0, 0, 0, 0, 0 },
/* U+5f6d */ { 0, 0, 0, 0, 0 },
/* U+5f6e */ { 0, 0, 0, 0, 0 },
/* U+5f6f */ { 0, 0, 0, 0, 0 },
/* U+5f70 */ { 0, 0, 0, 0, 0 },
/* U+5f71 */ { 0, 0, 0, 0, 0 },
/* U+5f72 */ { 0, 0, 0, 0, 0 },
/* U+5f73 */ { 0, 0, 0, 0, 0 },
/* U+5f74 */ { 0, 0, 0, 0, 0 },
/* U+5f75 */ { 0, 0, 0, 0, 0 },
/* U+5f76 */ { 0, 0, 0, 0, 0 },
/* U+5f77 */ { 0, 0, 0, 0, 0 },
/* U+5f78 */ { 0, 0, 0, 0, 0 },
/* U+5f79 */ { 0, 0, 0, 0, 0 },
/* U+5f7a */ { 0, 0, 0, 0, 0 },
/* U+5f7b */ { 0, 0, 0, 0, 0 },
/* U+5f7c */ { 0, 0, 0, 0, 0 },
/* U+5f7d */ { 0, 0, 0, 0, 0 },
/* U+5f7e */ { 0, 0, 0, 0, 0 },
/* U+5f7f */ { 0, 0, 0, 0, 0 },
/* U+5f80 */ { 0, 0, 0, 0, 0 },
/* U+5f81 */ { 0, 0, 0, 0, 0 },
/* U+5f82 */ { 0, 0, 0, 0, 0 },
/* U+5f83 */ { 0, 0, 0, 0, 0 },
/* U+5f84 */ { 0, 0, 0, 0, 0 },
/* U+5f85 */ { 0, 0, 0, 0, 0 },
/* U+5f86 */ { 0, 0, 0, 0, 0 },
/* U+5f87 */ { 0, 0, 0, 0, 0 },
/* U+5f88 */ { 0, 0, 0, 0, 0 },
/* U+5f89 */ { 0, 0, 0, 0, 0 },
/* U+5f8a */ { 0, 0, 0, 0, 0 },
/* U+5f8b */ { 0, 0, 0, 0, 0 },
/* U+5f8c */ { 0, 0, 0, 0, 0 },
/* U+5f8d */ { 0, 0, 0, 0, 0 },
/* U+5f8e */ { 0, 0, 0, 0, 0 },
/* U+5f8f */ { 0, 0, 0, 0, 0 },
/* U+5f90 */ { 0, 0, 0, 0, 0 },
/* U+5f91 */ { 0, 0, 0, 0, 0 },
/* U+5f92 */ { 0, 0, 0, 0, 0 },
/* U+5f93 */ { 0, 0, 0, 0, 0 },
/* U+5f94 */ { 0, 0, 0, 0, 0 },
/* U+5f95 */ { 0, 0, 0, 0, 0 },
/* U+5f96 */ { 0, 0, 0, 0, 0 },
/* U+5f97 */ { 0, 0, 0, 0, 0 },
/* U+5f98 */ { 0, 0, 0, 0, 0 },
/* U+5f99 */ { 0, 0, 0, 0, 0 },
/* U+5f9a */ { 0, 0, 0, 0, 0 },
/* U+5f9b */ { 0, 0, 0, 0, 0 },
/* U+5f9c */ { 0, 0, 0, 0, 0 },
/* U+5f9d */ { 0, 0, 0, 0, 0 },
/* U+5f9e */ { 0, 0, 0, 0, 0 },
/* U+5f9f */ { 0, 0, 0, 0, 0 },
/* U+5fa0 */ { 0, 0, 0, 0, 0 },
/* U+5fa1 */ { 0, 0, 0, 0, 0 },
/* U+5fa2 */ { 0, 0, 0, 0, 0 },
/* U+5fa3 */ { 0, 0, 0, 0, 0 },
/* U+5fa4 */ { 0, 0, 0, 0, 0 },
/* U+5fa5 */ { 0, 0, 0, 0, 0 },
/* U+5fa6 */ { 0, 0, 0, 0, 0 },
/* U+5fa7 */ { 0, 0, 0, 0, 0 },
/* U+5fa8 */ { 0, 0, 0, 0, 0 },
/* U+5fa9 */ { 0, 0, 0, 0, 0 },
/* U+5faa */ { 0, 0, 0, 0, 0 },
/* U+5fab */ { 0, 0, 0, 0, 0 },
/* U+5fac */ { 0, 0, 0, 0, 0 },
/* U+5fad */ { 0, 0, 0, 0, 0 },
/* U+5fae */ { 0, 0, 0, 0, 0 },
/* U+5faf */ { 0, 0, 0, 0, 0 },
/* U+5fb0 */ { 0, 0, 0, 0, 0 },
/* U+5fb1 */ { 0, 0, 0, 0, 0 },
/* U+5fb2 */ { 0, 0, 0, 0, 0 },
/* U+5fb3 */ { 0, 0, 0, 0, 0 },
/* U+5fb4 */ { 0, 0, 0, 0, 0 },
/* U+5fb5 */ { 0, 0, 0, 0, 0 },
/* U+5fb6 */ { 0, 0, 0, 0, 0 },
/* U+5fb7 */ { 0, 0, 0, 0, 0 },
/* U+5fb8 */ { 0, 0, 0, 0, 0 },
/* U+5fb9 */ { 0, 0, 0, 0, 0 },
/* U+5fba */ { 0, 0, 0, 0, 0 },
/* U+5fbb */ { 0, 0, 0, 0, 0 },
/* U+5fbc */ { 0, 0, 0, 0, 0 },
/* U+5fbd */ { 0, 0, 0, 0, 0 },
/* U+5fbe */ { 0, 0, 0, 0, 0 },
/* U+5fbf */ { 0, 0, 0, 0, 0 },
/* U+5fc0 */ { 0, 0, 0, 0, 0 },
/* U+5fc1 */ { 0, 0, 0, 0, 0 },
/* U+5fc2 */ { 0, 0, 0, 0, 0 },
/* U+5fc3 */ { 0, 0, 0, 0, 0 },
/* U+5fc4 */ { 0, 0, 0, 0, 0 },
/* U+5fc5 */ { 0, 0, 0, 0, 0 },
/* U+5fc6 */ { 0, 0, 0, 0, 0 },
/* U+5fc7 */ { 0, 0, 0, 0, 0 },
/* U+5fc8 */ { 0, 0, 0, 0, 0 },
/* U+5fc9 */ { 0, 0, 0, 0, 0 },
/* U+5fca */ { 0, 0, 0, 0, 0 },
/* U+5fcb */ { 0, 0, 0, 0, 0 },
/* U+5fcc */ { 0, 0, 0, 0, 0 },
/* U+5fcd */ { 0, 0, 0, 0, 0 },
/* U+5fce */ { 0, 0, 0, 0, 0 },
/* U+5fcf */ { 0, 0, 0, 0, 0 },
/* U+5fd0 */ { 0, 0, 0, 0, 0 },
/* U+5fd1 */ { 0, 0, 0, 0, 0 },
/* U+5fd2 */ { 0, 0, 0, 0, 0 },
/* U+5fd3 */ { 0, 0, 0, 0, 0 },
/* U+5fd4 */ { 0, 0, 0, 0, 0 },
/* U+5fd5 */ { 0, 0, 0, 0, 0 },
/* U+5fd6 */ { 0, 0, 0, 0, 0 },
/* U+5fd7 */ { 0, 0, 0, 0, 0 },
/* U+5fd8 */ { 0, 0, 0, 0, 0 },
/* U+5fd9 */ { 0, 0, 0, 0, 0 },
/* U+5fda */ { 0, 0, 0, 0, 0 },
/* U+5fdb */ { 0, 0, 0, 0, 0 },
/* U+5fdc */ { 0, 0, 0, 0, 0 },
/* U+5fdd */ { 0, 0, 0, 0, 0 },
/* U+5fde */ { 0, 0, 0, 0, 0 },
/* U+5fdf */ { 0, 0, 0, 0, 0 },
/* U+5fe0 */ { 0, 0, 0, 0, 0 },
/* U+5fe1 */ { 0, 0, 0, 0, 0 },
/* U+5fe2 */ { 0, 0, 0, 0, 0 },
/* U+5fe3 */ { 0, 0, 0, 0, 0 },
/* U+5fe4 */ { 0, 0, 0, 0, 0 },
/* U+5fe5 */ { 0, 0, 0, 0, 0 },
/* U+5fe6 */ { 0, 0, 0, 0, 0 },
/* U+5fe7 */ { 0, 0, 0, 0, 0 },
/* U+5fe8 */ { 0, 0, 0, 0, 0 },
/* U+5fe9 */ { 0, 0, 0, 0, 0 },
/* U+5fea */ { 0, 0, 0, 0, 0 },
/* U+5feb */ { 0, 0, 0, 0, 0 },
/* U+5fec */ { 0, 0, 0, 0, 0 },
/* U+5fed */ { 0, 0, 0, 0, 0 },
/* U+5fee */ { 0, 0, 0, 0, 0 },
/* U+5fef */ { 0, 0, 0, 0, 0 },
/* U+5ff0 */ { 0, 0, 0, 0, 0 },
/* U+5ff1 */ { 0, 0, 0, 0, 0 },
/* U+5ff2 */ { 0, 0, 0, 0, 0 },
/* U+5ff3 */ { 0, 0, 0, 0, 0 },
/* U+5ff4 */ { 0, 0, 0, 0, 0 },
/* U+5ff5 */ { 0, 0, 0, 0, 0 },
/* U+5ff6 */ { 0, 0, 0, 0, 0 },
/* U+5ff7 */ { 0, 0, 0, 0, 0 },
/* U+5ff8 */ { 0, 0, 0, 0, 0 },
/* U+5ff9 */ { 0, 0, 0, 0, 0 },
/* U+5ffa */ { 0, 0, 0, 0, 0 },
/* U+5ffb */ { 0, 0, 0, 0, 0 },
/* U+5ffc */ { 0, 0, 0, 0, 0 },
/* U+5ffd */ { 0, 0, 0, 0, 0 },
/* U+5ffe */ { 0, 0, 0, 0, 0 },
/* U+5fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_6[4096] = {
    
/* U+6000 */ { 0, 0, 0, 0, 0 },
/* U+6001 */ { 0, 0, 0, 0, 0 },
/* U+6002 */ { 0, 0, 0, 0, 0 },
/* U+6003 */ { 0, 0, 0, 0, 0 },
/* U+6004 */ { 0, 0, 0, 0, 0 },
/* U+6005 */ { 0, 0, 0, 0, 0 },
/* U+6006 */ { 0, 0, 0, 0, 0 },
/* U+6007 */ { 0, 0, 0, 0, 0 },
/* U+6008 */ { 0, 0, 0, 0, 0 },
/* U+6009 */ { 0, 0, 0, 0, 0 },
/* U+600a */ { 0, 0, 0, 0, 0 },
/* U+600b */ { 0, 0, 0, 0, 0 },
/* U+600c */ { 0, 0, 0, 0, 0 },
/* U+600d */ { 0, 0, 0, 0, 0 },
/* U+600e */ { 0, 0, 0, 0, 0 },
/* U+600f */ { 0, 0, 0, 0, 0 },
/* U+6010 */ { 0, 0, 0, 0, 0 },
/* U+6011 */ { 0, 0, 0, 0, 0 },
/* U+6012 */ { 0, 0, 0, 0, 0 },
/* U+6013 */ { 0, 0, 0, 0, 0 },
/* U+6014 */ { 0, 0, 0, 0, 0 },
/* U+6015 */ { 0, 0, 0, 0, 0 },
/* U+6016 */ { 0, 0, 0, 0, 0 },
/* U+6017 */ { 0, 0, 0, 0, 0 },
/* U+6018 */ { 0, 0, 0, 0, 0 },
/* U+6019 */ { 0, 0, 0, 0, 0 },
/* U+601a */ { 0, 0, 0, 0, 0 },
/* U+601b */ { 0, 0, 0, 0, 0 },
/* U+601c */ { 0, 0, 0, 0, 0 },
/* U+601d */ { 0, 0, 0, 0, 0 },
/* U+601e */ { 0, 0, 0, 0, 0 },
/* U+601f */ { 0, 0, 0, 0, 0 },
/* U+6020 */ { 0, 0, 0, 0, 0 },
/* U+6021 */ { 0, 0, 0, 0, 0 },
/* U+6022 */ { 0, 0, 0, 0, 0 },
/* U+6023 */ { 0, 0, 0, 0, 0 },
/* U+6024 */ { 0, 0, 0, 0, 0 },
/* U+6025 */ { 0, 0, 0, 0, 0 },
/* U+6026 */ { 0, 0, 0, 0, 0 },
/* U+6027 */ { 0, 0, 0, 0, 0 },
/* U+6028 */ { 0, 0, 0, 0, 0 },
/* U+6029 */ { 0, 0, 0, 0, 0 },
/* U+602a */ { 0, 0, 0, 0, 0 },
/* U+602b */ { 0, 0, 0, 0, 0 },
/* U+602c */ { 0, 0, 0, 0, 0 },
/* U+602d */ { 0, 0, 0, 0, 0 },
/* U+602e */ { 0, 0, 0, 0, 0 },
/* U+602f */ { 0, 0, 0, 0, 0 },
/* U+6030 */ { 0, 0, 0, 0, 0 },
/* U+6031 */ { 0, 0, 0, 0, 0 },
/* U+6032 */ { 0, 0, 0, 0, 0 },
/* U+6033 */ { 0, 0, 0, 0, 0 },
/* U+6034 */ { 0, 0, 0, 0, 0 },
/* U+6035 */ { 0, 0, 0, 0, 0 },
/* U+6036 */ { 0, 0, 0, 0, 0 },
/* U+6037 */ { 0, 0, 0, 0, 0 },
/* U+6038 */ { 0, 0, 0, 0, 0 },
/* U+6039 */ { 0, 0, 0, 0, 0 },
/* U+603a */ { 0, 0, 0, 0, 0 },
/* U+603b */ { 0, 0, 0, 0, 0 },
/* U+603c */ { 0, 0, 0, 0, 0 },
/* U+603d */ { 0, 0, 0, 0, 0 },
/* U+603e */ { 0, 0, 0, 0, 0 },
/* U+603f */ { 0, 0, 0, 0, 0 },
/* U+6040 */ { 0, 0, 0, 0, 0 },
/* U+6041 */ { 0, 0, 0, 0, 0 },
/* U+6042 */ { 0, 0, 0, 0, 0 },
/* U+6043 */ { 0, 0, 0, 0, 0 },
/* U+6044 */ { 0, 0, 0, 0, 0 },
/* U+6045 */ { 0, 0, 0, 0, 0 },
/* U+6046 */ { 0, 0, 0, 0, 0 },
/* U+6047 */ { 0, 0, 0, 0, 0 },
/* U+6048 */ { 0, 0, 0, 0, 0 },
/* U+6049 */ { 0, 0, 0, 0, 0 },
/* U+604a */ { 0, 0, 0, 0, 0 },
/* U+604b */ { 0, 0, 0, 0, 0 },
/* U+604c */ { 0, 0, 0, 0, 0 },
/* U+604d */ { 0, 0, 0, 0, 0 },
/* U+604e */ { 0, 0, 0, 0, 0 },
/* U+604f */ { 0, 0, 0, 0, 0 },
/* U+6050 */ { 0, 0, 0, 0, 0 },
/* U+6051 */ { 0, 0, 0, 0, 0 },
/* U+6052 */ { 0, 0, 0, 0, 0 },
/* U+6053 */ { 0, 0, 0, 0, 0 },
/* U+6054 */ { 0, 0, 0, 0, 0 },
/* U+6055 */ { 0, 0, 0, 0, 0 },
/* U+6056 */ { 0, 0, 0, 0, 0 },
/* U+6057 */ { 0, 0, 0, 0, 0 },
/* U+6058 */ { 0, 0, 0, 0, 0 },
/* U+6059 */ { 0, 0, 0, 0, 0 },
/* U+605a */ { 0, 0, 0, 0, 0 },
/* U+605b */ { 0, 0, 0, 0, 0 },
/* U+605c */ { 0, 0, 0, 0, 0 },
/* U+605d */ { 0, 0, 0, 0, 0 },
/* U+605e */ { 0, 0, 0, 0, 0 },
/* U+605f */ { 0, 0, 0, 0, 0 },
/* U+6060 */ { 0, 0, 0, 0, 0 },
/* U+6061 */ { 0, 0, 0, 0, 0 },
/* U+6062 */ { 0, 0, 0, 0, 0 },
/* U+6063 */ { 0, 0, 0, 0, 0 },
/* U+6064 */ { 0, 0, 0, 0, 0 },
/* U+6065 */ { 0, 0, 0, 0, 0 },
/* U+6066 */ { 0, 0, 0, 0, 0 },
/* U+6067 */ { 0, 0, 0, 0, 0 },
/* U+6068 */ { 0, 0, 0, 0, 0 },
/* U+6069 */ { 0, 0, 0, 0, 0 },
/* U+606a */ { 0, 0, 0, 0, 0 },
/* U+606b */ { 0, 0, 0, 0, 0 },
/* U+606c */ { 0, 0, 0, 0, 0 },
/* U+606d */ { 0, 0, 0, 0, 0 },
/* U+606e */ { 0, 0, 0, 0, 0 },
/* U+606f */ { 0, 0, 0, 0, 0 },
/* U+6070 */ { 0, 0, 0, 0, 0 },
/* U+6071 */ { 0, 0, 0, 0, 0 },
/* U+6072 */ { 0, 0, 0, 0, 0 },
/* U+6073 */ { 0, 0, 0, 0, 0 },
/* U+6074 */ { 0, 0, 0, 0, 0 },
/* U+6075 */ { 0, 0, 0, 0, 0 },
/* U+6076 */ { 0, 0, 0, 0, 0 },
/* U+6077 */ { 0, 0, 0, 0, 0 },
/* U+6078 */ { 0, 0, 0, 0, 0 },
/* U+6079 */ { 0, 0, 0, 0, 0 },
/* U+607a */ { 0, 0, 0, 0, 0 },
/* U+607b */ { 0, 0, 0, 0, 0 },
/* U+607c */ { 0, 0, 0, 0, 0 },
/* U+607d */ { 0, 0, 0, 0, 0 },
/* U+607e */ { 0, 0, 0, 0, 0 },
/* U+607f */ { 0, 0, 0, 0, 0 },
/* U+6080 */ { 0, 0, 0, 0, 0 },
/* U+6081 */ { 0, 0, 0, 0, 0 },
/* U+6082 */ { 0, 0, 0, 0, 0 },
/* U+6083 */ { 0, 0, 0, 0, 0 },
/* U+6084 */ { 0, 0, 0, 0, 0 },
/* U+6085 */ { 0, 0, 0, 0, 0 },
/* U+6086 */ { 0, 0, 0, 0, 0 },
/* U+6087 */ { 0, 0, 0, 0, 0 },
/* U+6088 */ { 0, 0, 0, 0, 0 },
/* U+6089 */ { 0, 0, 0, 0, 0 },
/* U+608a */ { 0, 0, 0, 0, 0 },
/* U+608b */ { 0, 0, 0, 0, 0 },
/* U+608c */ { 0, 0, 0, 0, 0 },
/* U+608d */ { 0, 0, 0, 0, 0 },
/* U+608e */ { 0, 0, 0, 0, 0 },
/* U+608f */ { 0, 0, 0, 0, 0 },
/* U+6090 */ { 0, 0, 0, 0, 0 },
/* U+6091 */ { 0, 0, 0, 0, 0 },
/* U+6092 */ { 0, 0, 0, 0, 0 },
/* U+6093 */ { 0, 0, 0, 0, 0 },
/* U+6094 */ { 0, 0, 0, 0, 0 },
/* U+6095 */ { 0, 0, 0, 0, 0 },
/* U+6096 */ { 0, 0, 0, 0, 0 },
/* U+6097 */ { 0, 0, 0, 0, 0 },
/* U+6098 */ { 0, 0, 0, 0, 0 },
/* U+6099 */ { 0, 0, 0, 0, 0 },
/* U+609a */ { 0, 0, 0, 0, 0 },
/* U+609b */ { 0, 0, 0, 0, 0 },
/* U+609c */ { 0, 0, 0, 0, 0 },
/* U+609d */ { 0, 0, 0, 0, 0 },
/* U+609e */ { 0, 0, 0, 0, 0 },
/* U+609f */ { 0, 0, 0, 0, 0 },
/* U+60a0 */ { 0, 0, 0, 0, 0 },
/* U+60a1 */ { 0, 0, 0, 0, 0 },
/* U+60a2 */ { 0, 0, 0, 0, 0 },
/* U+60a3 */ { 0, 0, 0, 0, 0 },
/* U+60a4 */ { 0, 0, 0, 0, 0 },
/* U+60a5 */ { 0, 0, 0, 0, 0 },
/* U+60a6 */ { 0, 0, 0, 0, 0 },
/* U+60a7 */ { 0, 0, 0, 0, 0 },
/* U+60a8 */ { 0, 0, 0, 0, 0 },
/* U+60a9 */ { 0, 0, 0, 0, 0 },
/* U+60aa */ { 0, 0, 0, 0, 0 },
/* U+60ab */ { 0, 0, 0, 0, 0 },
/* U+60ac */ { 0, 0, 0, 0, 0 },
/* U+60ad */ { 0, 0, 0, 0, 0 },
/* U+60ae */ { 0, 0, 0, 0, 0 },
/* U+60af */ { 0, 0, 0, 0, 0 },
/* U+60b0 */ { 0, 0, 0, 0, 0 },
/* U+60b1 */ { 0, 0, 0, 0, 0 },
/* U+60b2 */ { 0, 0, 0, 0, 0 },
/* U+60b3 */ { 0, 0, 0, 0, 0 },
/* U+60b4 */ { 0, 0, 0, 0, 0 },
/* U+60b5 */ { 0, 0, 0, 0, 0 },
/* U+60b6 */ { 0, 0, 0, 0, 0 },
/* U+60b7 */ { 0, 0, 0, 0, 0 },
/* U+60b8 */ { 0, 0, 0, 0, 0 },
/* U+60b9 */ { 0, 0, 0, 0, 0 },
/* U+60ba */ { 0, 0, 0, 0, 0 },
/* U+60bb */ { 0, 0, 0, 0, 0 },
/* U+60bc */ { 0, 0, 0, 0, 0 },
/* U+60bd */ { 0, 0, 0, 0, 0 },
/* U+60be */ { 0, 0, 0, 0, 0 },
/* U+60bf */ { 0, 0, 0, 0, 0 },
/* U+60c0 */ { 0, 0, 0, 0, 0 },
/* U+60c1 */ { 0, 0, 0, 0, 0 },
/* U+60c2 */ { 0, 0, 0, 0, 0 },
/* U+60c3 */ { 0, 0, 0, 0, 0 },
/* U+60c4 */ { 0, 0, 0, 0, 0 },
/* U+60c5 */ { 0, 0, 0, 0, 0 },
/* U+60c6 */ { 0, 0, 0, 0, 0 },
/* U+60c7 */ { 0, 0, 0, 0, 0 },
/* U+60c8 */ { 0, 0, 0, 0, 0 },
/* U+60c9 */ { 0, 0, 0, 0, 0 },
/* U+60ca */ { 0, 0, 0, 0, 0 },
/* U+60cb */ { 0, 0, 0, 0, 0 },
/* U+60cc */ { 0, 0, 0, 0, 0 },
/* U+60cd */ { 0, 0, 0, 0, 0 },
/* U+60ce */ { 0, 0, 0, 0, 0 },
/* U+60cf */ { 0, 0, 0, 0, 0 },
/* U+60d0 */ { 0, 0, 0, 0, 0 },
/* U+60d1 */ { 0, 0, 0, 0, 0 },
/* U+60d2 */ { 0, 0, 0, 0, 0 },
/* U+60d3 */ { 0, 0, 0, 0, 0 },
/* U+60d4 */ { 0, 0, 0, 0, 0 },
/* U+60d5 */ { 0, 0, 0, 0, 0 },
/* U+60d6 */ { 0, 0, 0, 0, 0 },
/* U+60d7 */ { 0, 0, 0, 0, 0 },
/* U+60d8 */ { 0, 0, 0, 0, 0 },
/* U+60d9 */ { 0, 0, 0, 0, 0 },
/* U+60da */ { 0, 0, 0, 0, 0 },
/* U+60db */ { 0, 0, 0, 0, 0 },
/* U+60dc */ { 0, 0, 0, 0, 0 },
/* U+60dd */ { 0, 0, 0, 0, 0 },
/* U+60de */ { 0, 0, 0, 0, 0 },
/* U+60df */ { 0, 0, 0, 0, 0 },
/* U+60e0 */ { 0, 0, 0, 0, 0 },
/* U+60e1 */ { 0, 0, 0, 0, 0 },
/* U+60e2 */ { 0, 0, 0, 0, 0 },
/* U+60e3 */ { 0, 0, 0, 0, 0 },
/* U+60e4 */ { 0, 0, 0, 0, 0 },
/* U+60e5 */ { 0, 0, 0, 0, 0 },
/* U+60e6 */ { 0, 0, 0, 0, 0 },
/* U+60e7 */ { 0, 0, 0, 0, 0 },
/* U+60e8 */ { 0, 0, 0, 0, 0 },
/* U+60e9 */ { 0, 0, 0, 0, 0 },
/* U+60ea */ { 0, 0, 0, 0, 0 },
/* U+60eb */ { 0, 0, 0, 0, 0 },
/* U+60ec */ { 0, 0, 0, 0, 0 },
/* U+60ed */ { 0, 0, 0, 0, 0 },
/* U+60ee */ { 0, 0, 0, 0, 0 },
/* U+60ef */ { 0, 0, 0, 0, 0 },
/* U+60f0 */ { 0, 0, 0, 0, 0 },
/* U+60f1 */ { 0, 0, 0, 0, 0 },
/* U+60f2 */ { 0, 0, 0, 0, 0 },
/* U+60f3 */ { 0, 0, 0, 0, 0 },
/* U+60f4 */ { 0, 0, 0, 0, 0 },
/* U+60f5 */ { 0, 0, 0, 0, 0 },
/* U+60f6 */ { 0, 0, 0, 0, 0 },
/* U+60f7 */ { 0, 0, 0, 0, 0 },
/* U+60f8 */ { 0, 0, 0, 0, 0 },
/* U+60f9 */ { 0, 0, 0, 0, 0 },
/* U+60fa */ { 0, 0, 0, 0, 0 },
/* U+60fb */ { 0, 0, 0, 0, 0 },
/* U+60fc */ { 0, 0, 0, 0, 0 },
/* U+60fd */ { 0, 0, 0, 0, 0 },
/* U+60fe */ { 0, 0, 0, 0, 0 },
/* U+60ff */ { 0, 0, 0, 0, 0 },
/* U+6100 */ { 0, 0, 0, 0, 0 },
/* U+6101 */ { 0, 0, 0, 0, 0 },
/* U+6102 */ { 0, 0, 0, 0, 0 },
/* U+6103 */ { 0, 0, 0, 0, 0 },
/* U+6104 */ { 0, 0, 0, 0, 0 },
/* U+6105 */ { 0, 0, 0, 0, 0 },
/* U+6106 */ { 0, 0, 0, 0, 0 },
/* U+6107 */ { 0, 0, 0, 0, 0 },
/* U+6108 */ { 0, 0, 0, 0, 0 },
/* U+6109 */ { 0, 0, 0, 0, 0 },
/* U+610a */ { 0, 0, 0, 0, 0 },
/* U+610b */ { 0, 0, 0, 0, 0 },
/* U+610c */ { 0, 0, 0, 0, 0 },
/* U+610d */ { 0, 0, 0, 0, 0 },
/* U+610e */ { 0, 0, 0, 0, 0 },
/* U+610f */ { 0, 0, 0, 0, 0 },
/* U+6110 */ { 0, 0, 0, 0, 0 },
/* U+6111 */ { 0, 0, 0, 0, 0 },
/* U+6112 */ { 0, 0, 0, 0, 0 },
/* U+6113 */ { 0, 0, 0, 0, 0 },
/* U+6114 */ { 0, 0, 0, 0, 0 },
/* U+6115 */ { 0, 0, 0, 0, 0 },
/* U+6116 */ { 0, 0, 0, 0, 0 },
/* U+6117 */ { 0, 0, 0, 0, 0 },
/* U+6118 */ { 0, 0, 0, 0, 0 },
/* U+6119 */ { 0, 0, 0, 0, 0 },
/* U+611a */ { 0, 0, 0, 0, 0 },
/* U+611b */ { 0, 0, 0, 0, 0 },
/* U+611c */ { 0, 0, 0, 0, 0 },
/* U+611d */ { 0, 0, 0, 0, 0 },
/* U+611e */ { 0, 0, 0, 0, 0 },
/* U+611f */ { 0, 0, 0, 0, 0 },
/* U+6120 */ { 0, 0, 0, 0, 0 },
/* U+6121 */ { 0, 0, 0, 0, 0 },
/* U+6122 */ { 0, 0, 0, 0, 0 },
/* U+6123 */ { 0, 0, 0, 0, 0 },
/* U+6124 */ { 0, 0, 0, 0, 0 },
/* U+6125 */ { 0, 0, 0, 0, 0 },
/* U+6126 */ { 0, 0, 0, 0, 0 },
/* U+6127 */ { 0, 0, 0, 0, 0 },
/* U+6128 */ { 0, 0, 0, 0, 0 },
/* U+6129 */ { 0, 0, 0, 0, 0 },
/* U+612a */ { 0, 0, 0, 0, 0 },
/* U+612b */ { 0, 0, 0, 0, 0 },
/* U+612c */ { 0, 0, 0, 0, 0 },
/* U+612d */ { 0, 0, 0, 0, 0 },
/* U+612e */ { 0, 0, 0, 0, 0 },
/* U+612f */ { 0, 0, 0, 0, 0 },
/* U+6130 */ { 0, 0, 0, 0, 0 },
/* U+6131 */ { 0, 0, 0, 0, 0 },
/* U+6132 */ { 0, 0, 0, 0, 0 },
/* U+6133 */ { 0, 0, 0, 0, 0 },
/* U+6134 */ { 0, 0, 0, 0, 0 },
/* U+6135 */ { 0, 0, 0, 0, 0 },
/* U+6136 */ { 0, 0, 0, 0, 0 },
/* U+6137 */ { 0, 0, 0, 0, 0 },
/* U+6138 */ { 0, 0, 0, 0, 0 },
/* U+6139 */ { 0, 0, 0, 0, 0 },
/* U+613a */ { 0, 0, 0, 0, 0 },
/* U+613b */ { 0, 0, 0, 0, 0 },
/* U+613c */ { 0, 0, 0, 0, 0 },
/* U+613d */ { 0, 0, 0, 0, 0 },
/* U+613e */ { 0, 0, 0, 0, 0 },
/* U+613f */ { 0, 0, 0, 0, 0 },
/* U+6140 */ { 0, 0, 0, 0, 0 },
/* U+6141 */ { 0, 0, 0, 0, 0 },
/* U+6142 */ { 0, 0, 0, 0, 0 },
/* U+6143 */ { 0, 0, 0, 0, 0 },
/* U+6144 */ { 0, 0, 0, 0, 0 },
/* U+6145 */ { 0, 0, 0, 0, 0 },
/* U+6146 */ { 0, 0, 0, 0, 0 },
/* U+6147 */ { 0, 0, 0, 0, 0 },
/* U+6148 */ { 0, 0, 0, 0, 0 },
/* U+6149 */ { 0, 0, 0, 0, 0 },
/* U+614a */ { 0, 0, 0, 0, 0 },
/* U+614b */ { 0, 0, 0, 0, 0 },
/* U+614c */ { 0, 0, 0, 0, 0 },
/* U+614d */ { 0, 0, 0, 0, 0 },
/* U+614e */ { 0, 0, 0, 0, 0 },
/* U+614f */ { 0, 0, 0, 0, 0 },
/* U+6150 */ { 0, 0, 0, 0, 0 },
/* U+6151 */ { 0, 0, 0, 0, 0 },
/* U+6152 */ { 0, 0, 0, 0, 0 },
/* U+6153 */ { 0, 0, 0, 0, 0 },
/* U+6154 */ { 0, 0, 0, 0, 0 },
/* U+6155 */ { 0, 0, 0, 0, 0 },
/* U+6156 */ { 0, 0, 0, 0, 0 },
/* U+6157 */ { 0, 0, 0, 0, 0 },
/* U+6158 */ { 0, 0, 0, 0, 0 },
/* U+6159 */ { 0, 0, 0, 0, 0 },
/* U+615a */ { 0, 0, 0, 0, 0 },
/* U+615b */ { 0, 0, 0, 0, 0 },
/* U+615c */ { 0, 0, 0, 0, 0 },
/* U+615d */ { 0, 0, 0, 0, 0 },
/* U+615e */ { 0, 0, 0, 0, 0 },
/* U+615f */ { 0, 0, 0, 0, 0 },
/* U+6160 */ { 0, 0, 0, 0, 0 },
/* U+6161 */ { 0, 0, 0, 0, 0 },
/* U+6162 */ { 0, 0, 0, 0, 0 },
/* U+6163 */ { 0, 0, 0, 0, 0 },
/* U+6164 */ { 0, 0, 0, 0, 0 },
/* U+6165 */ { 0, 0, 0, 0, 0 },
/* U+6166 */ { 0, 0, 0, 0, 0 },
/* U+6167 */ { 0, 0, 0, 0, 0 },
/* U+6168 */ { 0, 0, 0, 0, 0 },
/* U+6169 */ { 0, 0, 0, 0, 0 },
/* U+616a */ { 0, 0, 0, 0, 0 },
/* U+616b */ { 0, 0, 0, 0, 0 },
/* U+616c */ { 0, 0, 0, 0, 0 },
/* U+616d */ { 0, 0, 0, 0, 0 },
/* U+616e */ { 0, 0, 0, 0, 0 },
/* U+616f */ { 0, 0, 0, 0, 0 },
/* U+6170 */ { 0, 0, 0, 0, 0 },
/* U+6171 */ { 0, 0, 0, 0, 0 },
/* U+6172 */ { 0, 0, 0, 0, 0 },
/* U+6173 */ { 0, 0, 0, 0, 0 },
/* U+6174 */ { 0, 0, 0, 0, 0 },
/* U+6175 */ { 0, 0, 0, 0, 0 },
/* U+6176 */ { 0, 0, 0, 0, 0 },
/* U+6177 */ { 0, 0, 0, 0, 0 },
/* U+6178 */ { 0, 0, 0, 0, 0 },
/* U+6179 */ { 0, 0, 0, 0, 0 },
/* U+617a */ { 0, 0, 0, 0, 0 },
/* U+617b */ { 0, 0, 0, 0, 0 },
/* U+617c */ { 0, 0, 0, 0, 0 },
/* U+617d */ { 0, 0, 0, 0, 0 },
/* U+617e */ { 0, 0, 0, 0, 0 },
/* U+617f */ { 0, 0, 0, 0, 0 },
/* U+6180 */ { 0, 0, 0, 0, 0 },
/* U+6181 */ { 0, 0, 0, 0, 0 },
/* U+6182 */ { 0, 0, 0, 0, 0 },
/* U+6183 */ { 0, 0, 0, 0, 0 },
/* U+6184 */ { 0, 0, 0, 0, 0 },
/* U+6185 */ { 0, 0, 0, 0, 0 },
/* U+6186 */ { 0, 0, 0, 0, 0 },
/* U+6187 */ { 0, 0, 0, 0, 0 },
/* U+6188 */ { 0, 0, 0, 0, 0 },
/* U+6189 */ { 0, 0, 0, 0, 0 },
/* U+618a */ { 0, 0, 0, 0, 0 },
/* U+618b */ { 0, 0, 0, 0, 0 },
/* U+618c */ { 0, 0, 0, 0, 0 },
/* U+618d */ { 0, 0, 0, 0, 0 },
/* U+618e */ { 0, 0, 0, 0, 0 },
/* U+618f */ { 0, 0, 0, 0, 0 },
/* U+6190 */ { 0, 0, 0, 0, 0 },
/* U+6191 */ { 0, 0, 0, 0, 0 },
/* U+6192 */ { 0, 0, 0, 0, 0 },
/* U+6193 */ { 0, 0, 0, 0, 0 },
/* U+6194 */ { 0, 0, 0, 0, 0 },
/* U+6195 */ { 0, 0, 0, 0, 0 },
/* U+6196 */ { 0, 0, 0, 0, 0 },
/* U+6197 */ { 0, 0, 0, 0, 0 },
/* U+6198 */ { 0, 0, 0, 0, 0 },
/* U+6199 */ { 0, 0, 0, 0, 0 },
/* U+619a */ { 0, 0, 0, 0, 0 },
/* U+619b */ { 0, 0, 0, 0, 0 },
/* U+619c */ { 0, 0, 0, 0, 0 },
/* U+619d */ { 0, 0, 0, 0, 0 },
/* U+619e */ { 0, 0, 0, 0, 0 },
/* U+619f */ { 0, 0, 0, 0, 0 },
/* U+61a0 */ { 0, 0, 0, 0, 0 },
/* U+61a1 */ { 0, 0, 0, 0, 0 },
/* U+61a2 */ { 0, 0, 0, 0, 0 },
/* U+61a3 */ { 0, 0, 0, 0, 0 },
/* U+61a4 */ { 0, 0, 0, 0, 0 },
/* U+61a5 */ { 0, 0, 0, 0, 0 },
/* U+61a6 */ { 0, 0, 0, 0, 0 },
/* U+61a7 */ { 0, 0, 0, 0, 0 },
/* U+61a8 */ { 0, 0, 0, 0, 0 },
/* U+61a9 */ { 0, 0, 0, 0, 0 },
/* U+61aa */ { 0, 0, 0, 0, 0 },
/* U+61ab */ { 0, 0, 0, 0, 0 },
/* U+61ac */ { 0, 0, 0, 0, 0 },
/* U+61ad */ { 0, 0, 0, 0, 0 },
/* U+61ae */ { 0, 0, 0, 0, 0 },
/* U+61af */ { 0, 0, 0, 0, 0 },
/* U+61b0 */ { 0, 0, 0, 0, 0 },
/* U+61b1 */ { 0, 0, 0, 0, 0 },
/* U+61b2 */ { 0, 0, 0, 0, 0 },
/* U+61b3 */ { 0, 0, 0, 0, 0 },
/* U+61b4 */ { 0, 0, 0, 0, 0 },
/* U+61b5 */ { 0, 0, 0, 0, 0 },
/* U+61b6 */ { 0, 0, 0, 0, 0 },
/* U+61b7 */ { 0, 0, 0, 0, 0 },
/* U+61b8 */ { 0, 0, 0, 0, 0 },
/* U+61b9 */ { 0, 0, 0, 0, 0 },
/* U+61ba */ { 0, 0, 0, 0, 0 },
/* U+61bb */ { 0, 0, 0, 0, 0 },
/* U+61bc */ { 0, 0, 0, 0, 0 },
/* U+61bd */ { 0, 0, 0, 0, 0 },
/* U+61be */ { 0, 0, 0, 0, 0 },
/* U+61bf */ { 0, 0, 0, 0, 0 },
/* U+61c0 */ { 0, 0, 0, 0, 0 },
/* U+61c1 */ { 0, 0, 0, 0, 0 },
/* U+61c2 */ { 0, 0, 0, 0, 0 },
/* U+61c3 */ { 0, 0, 0, 0, 0 },
/* U+61c4 */ { 0, 0, 0, 0, 0 },
/* U+61c5 */ { 0, 0, 0, 0, 0 },
/* U+61c6 */ { 0, 0, 0, 0, 0 },
/* U+61c7 */ { 0, 0, 0, 0, 0 },
/* U+61c8 */ { 0, 0, 0, 0, 0 },
/* U+61c9 */ { 0, 0, 0, 0, 0 },
/* U+61ca */ { 0, 0, 0, 0, 0 },
/* U+61cb */ { 0, 0, 0, 0, 0 },
/* U+61cc */ { 0, 0, 0, 0, 0 },
/* U+61cd */ { 0, 0, 0, 0, 0 },
/* U+61ce */ { 0, 0, 0, 0, 0 },
/* U+61cf */ { 0, 0, 0, 0, 0 },
/* U+61d0 */ { 0, 0, 0, 0, 0 },
/* U+61d1 */ { 0, 0, 0, 0, 0 },
/* U+61d2 */ { 0, 0, 0, 0, 0 },
/* U+61d3 */ { 0, 0, 0, 0, 0 },
/* U+61d4 */ { 0, 0, 0, 0, 0 },
/* U+61d5 */ { 0, 0, 0, 0, 0 },
/* U+61d6 */ { 0, 0, 0, 0, 0 },
/* U+61d7 */ { 0, 0, 0, 0, 0 },
/* U+61d8 */ { 0, 0, 0, 0, 0 },
/* U+61d9 */ { 0, 0, 0, 0, 0 },
/* U+61da */ { 0, 0, 0, 0, 0 },
/* U+61db */ { 0, 0, 0, 0, 0 },
/* U+61dc */ { 0, 0, 0, 0, 0 },
/* U+61dd */ { 0, 0, 0, 0, 0 },
/* U+61de */ { 0, 0, 0, 0, 0 },
/* U+61df */ { 0, 0, 0, 0, 0 },
/* U+61e0 */ { 0, 0, 0, 0, 0 },
/* U+61e1 */ { 0, 0, 0, 0, 0 },
/* U+61e2 */ { 0, 0, 0, 0, 0 },
/* U+61e3 */ { 0, 0, 0, 0, 0 },
/* U+61e4 */ { 0, 0, 0, 0, 0 },
/* U+61e5 */ { 0, 0, 0, 0, 0 },
/* U+61e6 */ { 0, 0, 0, 0, 0 },
/* U+61e7 */ { 0, 0, 0, 0, 0 },
/* U+61e8 */ { 0, 0, 0, 0, 0 },
/* U+61e9 */ { 0, 0, 0, 0, 0 },
/* U+61ea */ { 0, 0, 0, 0, 0 },
/* U+61eb */ { 0, 0, 0, 0, 0 },
/* U+61ec */ { 0, 0, 0, 0, 0 },
/* U+61ed */ { 0, 0, 0, 0, 0 },
/* U+61ee */ { 0, 0, 0, 0, 0 },
/* U+61ef */ { 0, 0, 0, 0, 0 },
/* U+61f0 */ { 0, 0, 0, 0, 0 },
/* U+61f1 */ { 0, 0, 0, 0, 0 },
/* U+61f2 */ { 0, 0, 0, 0, 0 },
/* U+61f3 */ { 0, 0, 0, 0, 0 },
/* U+61f4 */ { 0, 0, 0, 0, 0 },
/* U+61f5 */ { 0, 0, 0, 0, 0 },
/* U+61f6 */ { 0, 0, 0, 0, 0 },
/* U+61f7 */ { 0, 0, 0, 0, 0 },
/* U+61f8 */ { 0, 0, 0, 0, 0 },
/* U+61f9 */ { 0, 0, 0, 0, 0 },
/* U+61fa */ { 0, 0, 0, 0, 0 },
/* U+61fb */ { 0, 0, 0, 0, 0 },
/* U+61fc */ { 0, 0, 0, 0, 0 },
/* U+61fd */ { 0, 0, 0, 0, 0 },
/* U+61fe */ { 0, 0, 0, 0, 0 },
/* U+61ff */ { 0, 0, 0, 0, 0 },
/* U+6200 */ { 0, 0, 0, 0, 0 },
/* U+6201 */ { 0, 0, 0, 0, 0 },
/* U+6202 */ { 0, 0, 0, 0, 0 },
/* U+6203 */ { 0, 0, 0, 0, 0 },
/* U+6204 */ { 0, 0, 0, 0, 0 },
/* U+6205 */ { 0, 0, 0, 0, 0 },
/* U+6206 */ { 0, 0, 0, 0, 0 },
/* U+6207 */ { 0, 0, 0, 0, 0 },
/* U+6208 */ { 0, 0, 0, 0, 0 },
/* U+6209 */ { 0, 0, 0, 0, 0 },
/* U+620a */ { 0, 0, 0, 0, 0 },
/* U+620b */ { 0, 0, 0, 0, 0 },
/* U+620c */ { 0, 0, 0, 0, 0 },
/* U+620d */ { 0, 0, 0, 0, 0 },
/* U+620e */ { 0, 0, 0, 0, 0 },
/* U+620f */ { 0, 0, 0, 0, 0 },
/* U+6210 */ { 0, 0, 0, 0, 0 },
/* U+6211 */ { 0, 0, 0, 0, 0 },
/* U+6212 */ { 0, 0, 0, 0, 0 },
/* U+6213 */ { 0, 0, 0, 0, 0 },
/* U+6214 */ { 0, 0, 0, 0, 0 },
/* U+6215 */ { 0, 0, 0, 0, 0 },
/* U+6216 */ { 0, 0, 0, 0, 0 },
/* U+6217 */ { 0, 0, 0, 0, 0 },
/* U+6218 */ { 0, 0, 0, 0, 0 },
/* U+6219 */ { 0, 0, 0, 0, 0 },
/* U+621a */ { 0, 0, 0, 0, 0 },
/* U+621b */ { 0, 0, 0, 0, 0 },
/* U+621c */ { 0, 0, 0, 0, 0 },
/* U+621d */ { 0, 0, 0, 0, 0 },
/* U+621e */ { 0, 0, 0, 0, 0 },
/* U+621f */ { 0, 0, 0, 0, 0 },
/* U+6220 */ { 0, 0, 0, 0, 0 },
/* U+6221 */ { 0, 0, 0, 0, 0 },
/* U+6222 */ { 0, 0, 0, 0, 0 },
/* U+6223 */ { 0, 0, 0, 0, 0 },
/* U+6224 */ { 0, 0, 0, 0, 0 },
/* U+6225 */ { 0, 0, 0, 0, 0 },
/* U+6226 */ { 0, 0, 0, 0, 0 },
/* U+6227 */ { 0, 0, 0, 0, 0 },
/* U+6228 */ { 0, 0, 0, 0, 0 },
/* U+6229 */ { 0, 0, 0, 0, 0 },
/* U+622a */ { 0, 0, 0, 0, 0 },
/* U+622b */ { 0, 0, 0, 0, 0 },
/* U+622c */ { 0, 0, 0, 0, 0 },
/* U+622d */ { 0, 0, 0, 0, 0 },
/* U+622e */ { 0, 0, 0, 0, 0 },
/* U+622f */ { 0, 0, 0, 0, 0 },
/* U+6230 */ { 0, 0, 0, 0, 0 },
/* U+6231 */ { 0, 0, 0, 0, 0 },
/* U+6232 */ { 0, 0, 0, 0, 0 },
/* U+6233 */ { 0, 0, 0, 0, 0 },
/* U+6234 */ { 0, 0, 0, 0, 0 },
/* U+6235 */ { 0, 0, 0, 0, 0 },
/* U+6236 */ { 0, 0, 0, 0, 0 },
/* U+6237 */ { 0, 0, 0, 0, 0 },
/* U+6238 */ { 0, 0, 0, 0, 0 },
/* U+6239 */ { 0, 0, 0, 0, 0 },
/* U+623a */ { 0, 0, 0, 0, 0 },
/* U+623b */ { 0, 0, 0, 0, 0 },
/* U+623c */ { 0, 0, 0, 0, 0 },
/* U+623d */ { 0, 0, 0, 0, 0 },
/* U+623e */ { 0, 0, 0, 0, 0 },
/* U+623f */ { 0, 0, 0, 0, 0 },
/* U+6240 */ { 0, 0, 0, 0, 0 },
/* U+6241 */ { 0, 0, 0, 0, 0 },
/* U+6242 */ { 0, 0, 0, 0, 0 },
/* U+6243 */ { 0, 0, 0, 0, 0 },
/* U+6244 */ { 0, 0, 0, 0, 0 },
/* U+6245 */ { 0, 0, 0, 0, 0 },
/* U+6246 */ { 0, 0, 0, 0, 0 },
/* U+6247 */ { 0, 0, 0, 0, 0 },
/* U+6248 */ { 0, 0, 0, 0, 0 },
/* U+6249 */ { 0, 0, 0, 0, 0 },
/* U+624a */ { 0, 0, 0, 0, 0 },
/* U+624b */ { 0, 0, 0, 0, 0 },
/* U+624c */ { 0, 0, 0, 0, 0 },
/* U+624d */ { 0, 0, 0, 0, 0 },
/* U+624e */ { 0, 0, 0, 0, 0 },
/* U+624f */ { 0, 0, 0, 0, 0 },
/* U+6250 */ { 0, 0, 0, 0, 0 },
/* U+6251 */ { 0, 0, 0, 0, 0 },
/* U+6252 */ { 0, 0, 0, 0, 0 },
/* U+6253 */ { 0, 0, 0, 0, 0 },
/* U+6254 */ { 0, 0, 0, 0, 0 },
/* U+6255 */ { 0, 0, 0, 0, 0 },
/* U+6256 */ { 0, 0, 0, 0, 0 },
/* U+6257 */ { 0, 0, 0, 0, 0 },
/* U+6258 */ { 0, 0, 0, 0, 0 },
/* U+6259 */ { 0, 0, 0, 0, 0 },
/* U+625a */ { 0, 0, 0, 0, 0 },
/* U+625b */ { 0, 0, 0, 0, 0 },
/* U+625c */ { 0, 0, 0, 0, 0 },
/* U+625d */ { 0, 0, 0, 0, 0 },
/* U+625e */ { 0, 0, 0, 0, 0 },
/* U+625f */ { 0, 0, 0, 0, 0 },
/* U+6260 */ { 0, 0, 0, 0, 0 },
/* U+6261 */ { 0, 0, 0, 0, 0 },
/* U+6262 */ { 0, 0, 0, 0, 0 },
/* U+6263 */ { 0, 0, 0, 0, 0 },
/* U+6264 */ { 0, 0, 0, 0, 0 },
/* U+6265 */ { 0, 0, 0, 0, 0 },
/* U+6266 */ { 0, 0, 0, 0, 0 },
/* U+6267 */ { 0, 0, 0, 0, 0 },
/* U+6268 */ { 0, 0, 0, 0, 0 },
/* U+6269 */ { 0, 0, 0, 0, 0 },
/* U+626a */ { 0, 0, 0, 0, 0 },
/* U+626b */ { 0, 0, 0, 0, 0 },
/* U+626c */ { 0, 0, 0, 0, 0 },
/* U+626d */ { 0, 0, 0, 0, 0 },
/* U+626e */ { 0, 0, 0, 0, 0 },
/* U+626f */ { 0, 0, 0, 0, 0 },
/* U+6270 */ { 0, 0, 0, 0, 0 },
/* U+6271 */ { 0, 0, 0, 0, 0 },
/* U+6272 */ { 0, 0, 0, 0, 0 },
/* U+6273 */ { 0, 0, 0, 0, 0 },
/* U+6274 */ { 0, 0, 0, 0, 0 },
/* U+6275 */ { 0, 0, 0, 0, 0 },
/* U+6276 */ { 0, 0, 0, 0, 0 },
/* U+6277 */ { 0, 0, 0, 0, 0 },
/* U+6278 */ { 0, 0, 0, 0, 0 },
/* U+6279 */ { 0, 0, 0, 0, 0 },
/* U+627a */ { 0, 0, 0, 0, 0 },
/* U+627b */ { 0, 0, 0, 0, 0 },
/* U+627c */ { 0, 0, 0, 0, 0 },
/* U+627d */ { 0, 0, 0, 0, 0 },
/* U+627e */ { 0, 0, 0, 0, 0 },
/* U+627f */ { 0, 0, 0, 0, 0 },
/* U+6280 */ { 0, 0, 0, 0, 0 },
/* U+6281 */ { 0, 0, 0, 0, 0 },
/* U+6282 */ { 0, 0, 0, 0, 0 },
/* U+6283 */ { 0, 0, 0, 0, 0 },
/* U+6284 */ { 0, 0, 0, 0, 0 },
/* U+6285 */ { 0, 0, 0, 0, 0 },
/* U+6286 */ { 0, 0, 0, 0, 0 },
/* U+6287 */ { 0, 0, 0, 0, 0 },
/* U+6288 */ { 0, 0, 0, 0, 0 },
/* U+6289 */ { 0, 0, 0, 0, 0 },
/* U+628a */ { 0, 0, 0, 0, 0 },
/* U+628b */ { 0, 0, 0, 0, 0 },
/* U+628c */ { 0, 0, 0, 0, 0 },
/* U+628d */ { 0, 0, 0, 0, 0 },
/* U+628e */ { 0, 0, 0, 0, 0 },
/* U+628f */ { 0, 0, 0, 0, 0 },
/* U+6290 */ { 0, 0, 0, 0, 0 },
/* U+6291 */ { 0, 0, 0, 0, 0 },
/* U+6292 */ { 0, 0, 0, 0, 0 },
/* U+6293 */ { 0, 0, 0, 0, 0 },
/* U+6294 */ { 0, 0, 0, 0, 0 },
/* U+6295 */ { 0, 0, 0, 0, 0 },
/* U+6296 */ { 0, 0, 0, 0, 0 },
/* U+6297 */ { 0, 0, 0, 0, 0 },
/* U+6298 */ { 0, 0, 0, 0, 0 },
/* U+6299 */ { 0, 0, 0, 0, 0 },
/* U+629a */ { 0, 0, 0, 0, 0 },
/* U+629b */ { 0, 0, 0, 0, 0 },
/* U+629c */ { 0, 0, 0, 0, 0 },
/* U+629d */ { 0, 0, 0, 0, 0 },
/* U+629e */ { 0, 0, 0, 0, 0 },
/* U+629f */ { 0, 0, 0, 0, 0 },
/* U+62a0 */ { 0, 0, 0, 0, 0 },
/* U+62a1 */ { 0, 0, 0, 0, 0 },
/* U+62a2 */ { 0, 0, 0, 0, 0 },
/* U+62a3 */ { 0, 0, 0, 0, 0 },
/* U+62a4 */ { 0, 0, 0, 0, 0 },
/* U+62a5 */ { 0, 0, 0, 0, 0 },
/* U+62a6 */ { 0, 0, 0, 0, 0 },
/* U+62a7 */ { 0, 0, 0, 0, 0 },
/* U+62a8 */ { 0, 0, 0, 0, 0 },
/* U+62a9 */ { 0, 0, 0, 0, 0 },
/* U+62aa */ { 0, 0, 0, 0, 0 },
/* U+62ab */ { 0, 0, 0, 0, 0 },
/* U+62ac */ { 0, 0, 0, 0, 0 },
/* U+62ad */ { 0, 0, 0, 0, 0 },
/* U+62ae */ { 0, 0, 0, 0, 0 },
/* U+62af */ { 0, 0, 0, 0, 0 },
/* U+62b0 */ { 0, 0, 0, 0, 0 },
/* U+62b1 */ { 0, 0, 0, 0, 0 },
/* U+62b2 */ { 0, 0, 0, 0, 0 },
/* U+62b3 */ { 0, 0, 0, 0, 0 },
/* U+62b4 */ { 0, 0, 0, 0, 0 },
/* U+62b5 */ { 0, 0, 0, 0, 0 },
/* U+62b6 */ { 0, 0, 0, 0, 0 },
/* U+62b7 */ { 0, 0, 0, 0, 0 },
/* U+62b8 */ { 0, 0, 0, 0, 0 },
/* U+62b9 */ { 0, 0, 0, 0, 0 },
/* U+62ba */ { 0, 0, 0, 0, 0 },
/* U+62bb */ { 0, 0, 0, 0, 0 },
/* U+62bc */ { 0, 0, 0, 0, 0 },
/* U+62bd */ { 0, 0, 0, 0, 0 },
/* U+62be */ { 0, 0, 0, 0, 0 },
/* U+62bf */ { 0, 0, 0, 0, 0 },
/* U+62c0 */ { 0, 0, 0, 0, 0 },
/* U+62c1 */ { 0, 0, 0, 0, 0 },
/* U+62c2 */ { 0, 0, 0, 0, 0 },
/* U+62c3 */ { 0, 0, 0, 0, 0 },
/* U+62c4 */ { 0, 0, 0, 0, 0 },
/* U+62c5 */ { 0, 0, 0, 0, 0 },
/* U+62c6 */ { 0, 0, 0, 0, 0 },
/* U+62c7 */ { 0, 0, 0, 0, 0 },
/* U+62c8 */ { 0, 0, 0, 0, 0 },
/* U+62c9 */ { 0, 0, 0, 0, 0 },
/* U+62ca */ { 0, 0, 0, 0, 0 },
/* U+62cb */ { 0, 0, 0, 0, 0 },
/* U+62cc */ { 0, 0, 0, 0, 0 },
/* U+62cd */ { 0, 0, 0, 0, 0 },
/* U+62ce */ { 0, 0, 0, 0, 0 },
/* U+62cf */ { 0, 0, 0, 0, 0 },
/* U+62d0 */ { 0, 0, 0, 0, 0 },
/* U+62d1 */ { 0, 0, 0, 0, 0 },
/* U+62d2 */ { 0, 0, 0, 0, 0 },
/* U+62d3 */ { 0, 0, 0, 0, 0 },
/* U+62d4 */ { 0, 0, 0, 0, 0 },
/* U+62d5 */ { 0, 0, 0, 0, 0 },
/* U+62d6 */ { 0, 0, 0, 0, 0 },
/* U+62d7 */ { 0, 0, 0, 0, 0 },
/* U+62d8 */ { 0, 0, 0, 0, 0 },
/* U+62d9 */ { 0, 0, 0, 0, 0 },
/* U+62da */ { 0, 0, 0, 0, 0 },
/* U+62db */ { 0, 0, 0, 0, 0 },
/* U+62dc */ { 0, 0, 0, 0, 0 },
/* U+62dd */ { 0, 0, 0, 0, 0 },
/* U+62de */ { 0, 0, 0, 0, 0 },
/* U+62df */ { 0, 0, 0, 0, 0 },
/* U+62e0 */ { 0, 0, 0, 0, 0 },
/* U+62e1 */ { 0, 0, 0, 0, 0 },
/* U+62e2 */ { 0, 0, 0, 0, 0 },
/* U+62e3 */ { 0, 0, 0, 0, 0 },
/* U+62e4 */ { 0, 0, 0, 0, 0 },
/* U+62e5 */ { 0, 0, 0, 0, 0 },
/* U+62e6 */ { 0, 0, 0, 0, 0 },
/* U+62e7 */ { 0, 0, 0, 0, 0 },
/* U+62e8 */ { 0, 0, 0, 0, 0 },
/* U+62e9 */ { 0, 0, 0, 0, 0 },
/* U+62ea */ { 0, 0, 0, 0, 0 },
/* U+62eb */ { 0, 0, 0, 0, 0 },
/* U+62ec */ { 0, 0, 0, 0, 0 },
/* U+62ed */ { 0, 0, 0, 0, 0 },
/* U+62ee */ { 0, 0, 0, 0, 0 },
/* U+62ef */ { 0, 0, 0, 0, 0 },
/* U+62f0 */ { 0, 0, 0, 0, 0 },
/* U+62f1 */ { 0, 0, 0, 0, 0 },
/* U+62f2 */ { 0, 0, 0, 0, 0 },
/* U+62f3 */ { 0, 0, 0, 0, 0 },
/* U+62f4 */ { 0, 0, 0, 0, 0 },
/* U+62f5 */ { 0, 0, 0, 0, 0 },
/* U+62f6 */ { 0, 0, 0, 0, 0 },
/* U+62f7 */ { 0, 0, 0, 0, 0 },
/* U+62f8 */ { 0, 0, 0, 0, 0 },
/* U+62f9 */ { 0, 0, 0, 0, 0 },
/* U+62fa */ { 0, 0, 0, 0, 0 },
/* U+62fb */ { 0, 0, 0, 0, 0 },
/* U+62fc */ { 0, 0, 0, 0, 0 },
/* U+62fd */ { 0, 0, 0, 0, 0 },
/* U+62fe */ { 0, 0, 0, 0, 0 },
/* U+62ff */ { 0, 0, 0, 0, 0 },
/* U+6300 */ { 0, 0, 0, 0, 0 },
/* U+6301 */ { 0, 0, 0, 0, 0 },
/* U+6302 */ { 0, 0, 0, 0, 0 },
/* U+6303 */ { 0, 0, 0, 0, 0 },
/* U+6304 */ { 0, 0, 0, 0, 0 },
/* U+6305 */ { 0, 0, 0, 0, 0 },
/* U+6306 */ { 0, 0, 0, 0, 0 },
/* U+6307 */ { 0, 0, 0, 0, 0 },
/* U+6308 */ { 0, 0, 0, 0, 0 },
/* U+6309 */ { 0, 0, 0, 0, 0 },
/* U+630a */ { 0, 0, 0, 0, 0 },
/* U+630b */ { 0, 0, 0, 0, 0 },
/* U+630c */ { 0, 0, 0, 0, 0 },
/* U+630d */ { 0, 0, 0, 0, 0 },
/* U+630e */ { 0, 0, 0, 0, 0 },
/* U+630f */ { 0, 0, 0, 0, 0 },
/* U+6310 */ { 0, 0, 0, 0, 0 },
/* U+6311 */ { 0, 0, 0, 0, 0 },
/* U+6312 */ { 0, 0, 0, 0, 0 },
/* U+6313 */ { 0, 0, 0, 0, 0 },
/* U+6314 */ { 0, 0, 0, 0, 0 },
/* U+6315 */ { 0, 0, 0, 0, 0 },
/* U+6316 */ { 0, 0, 0, 0, 0 },
/* U+6317 */ { 0, 0, 0, 0, 0 },
/* U+6318 */ { 0, 0, 0, 0, 0 },
/* U+6319 */ { 0, 0, 0, 0, 0 },
/* U+631a */ { 0, 0, 0, 0, 0 },
/* U+631b */ { 0, 0, 0, 0, 0 },
/* U+631c */ { 0, 0, 0, 0, 0 },
/* U+631d */ { 0, 0, 0, 0, 0 },
/* U+631e */ { 0, 0, 0, 0, 0 },
/* U+631f */ { 0, 0, 0, 0, 0 },
/* U+6320 */ { 0, 0, 0, 0, 0 },
/* U+6321 */ { 0, 0, 0, 0, 0 },
/* U+6322 */ { 0, 0, 0, 0, 0 },
/* U+6323 */ { 0, 0, 0, 0, 0 },
/* U+6324 */ { 0, 0, 0, 0, 0 },
/* U+6325 */ { 0, 0, 0, 0, 0 },
/* U+6326 */ { 0, 0, 0, 0, 0 },
/* U+6327 */ { 0, 0, 0, 0, 0 },
/* U+6328 */ { 0, 0, 0, 0, 0 },
/* U+6329 */ { 0, 0, 0, 0, 0 },
/* U+632a */ { 0, 0, 0, 0, 0 },
/* U+632b */ { 0, 0, 0, 0, 0 },
/* U+632c */ { 0, 0, 0, 0, 0 },
/* U+632d */ { 0, 0, 0, 0, 0 },
/* U+632e */ { 0, 0, 0, 0, 0 },
/* U+632f */ { 0, 0, 0, 0, 0 },
/* U+6330 */ { 0, 0, 0, 0, 0 },
/* U+6331 */ { 0, 0, 0, 0, 0 },
/* U+6332 */ { 0, 0, 0, 0, 0 },
/* U+6333 */ { 0, 0, 0, 0, 0 },
/* U+6334 */ { 0, 0, 0, 0, 0 },
/* U+6335 */ { 0, 0, 0, 0, 0 },
/* U+6336 */ { 0, 0, 0, 0, 0 },
/* U+6337 */ { 0, 0, 0, 0, 0 },
/* U+6338 */ { 0, 0, 0, 0, 0 },
/* U+6339 */ { 0, 0, 0, 0, 0 },
/* U+633a */ { 0, 0, 0, 0, 0 },
/* U+633b */ { 0, 0, 0, 0, 0 },
/* U+633c */ { 0, 0, 0, 0, 0 },
/* U+633d */ { 0, 0, 0, 0, 0 },
/* U+633e */ { 0, 0, 0, 0, 0 },
/* U+633f */ { 0, 0, 0, 0, 0 },
/* U+6340 */ { 0, 0, 0, 0, 0 },
/* U+6341 */ { 0, 0, 0, 0, 0 },
/* U+6342 */ { 0, 0, 0, 0, 0 },
/* U+6343 */ { 0, 0, 0, 0, 0 },
/* U+6344 */ { 0, 0, 0, 0, 0 },
/* U+6345 */ { 0, 0, 0, 0, 0 },
/* U+6346 */ { 0, 0, 0, 0, 0 },
/* U+6347 */ { 0, 0, 0, 0, 0 },
/* U+6348 */ { 0, 0, 0, 0, 0 },
/* U+6349 */ { 0, 0, 0, 0, 0 },
/* U+634a */ { 0, 0, 0, 0, 0 },
/* U+634b */ { 0, 0, 0, 0, 0 },
/* U+634c */ { 0, 0, 0, 0, 0 },
/* U+634d */ { 0, 0, 0, 0, 0 },
/* U+634e */ { 0, 0, 0, 0, 0 },
/* U+634f */ { 0, 0, 0, 0, 0 },
/* U+6350 */ { 0, 0, 0, 0, 0 },
/* U+6351 */ { 0, 0, 0, 0, 0 },
/* U+6352 */ { 0, 0, 0, 0, 0 },
/* U+6353 */ { 0, 0, 0, 0, 0 },
/* U+6354 */ { 0, 0, 0, 0, 0 },
/* U+6355 */ { 0, 0, 0, 0, 0 },
/* U+6356 */ { 0, 0, 0, 0, 0 },
/* U+6357 */ { 0, 0, 0, 0, 0 },
/* U+6358 */ { 0, 0, 0, 0, 0 },
/* U+6359 */ { 0, 0, 0, 0, 0 },
/* U+635a */ { 0, 0, 0, 0, 0 },
/* U+635b */ { 0, 0, 0, 0, 0 },
/* U+635c */ { 0, 0, 0, 0, 0 },
/* U+635d */ { 0, 0, 0, 0, 0 },
/* U+635e */ { 0, 0, 0, 0, 0 },
/* U+635f */ { 0, 0, 0, 0, 0 },
/* U+6360 */ { 0, 0, 0, 0, 0 },
/* U+6361 */ { 0, 0, 0, 0, 0 },
/* U+6362 */ { 0, 0, 0, 0, 0 },
/* U+6363 */ { 0, 0, 0, 0, 0 },
/* U+6364 */ { 0, 0, 0, 0, 0 },
/* U+6365 */ { 0, 0, 0, 0, 0 },
/* U+6366 */ { 0, 0, 0, 0, 0 },
/* U+6367 */ { 0, 0, 0, 0, 0 },
/* U+6368 */ { 0, 0, 0, 0, 0 },
/* U+6369 */ { 0, 0, 0, 0, 0 },
/* U+636a */ { 0, 0, 0, 0, 0 },
/* U+636b */ { 0, 0, 0, 0, 0 },
/* U+636c */ { 0, 0, 0, 0, 0 },
/* U+636d */ { 0, 0, 0, 0, 0 },
/* U+636e */ { 0, 0, 0, 0, 0 },
/* U+636f */ { 0, 0, 0, 0, 0 },
/* U+6370 */ { 0, 0, 0, 0, 0 },
/* U+6371 */ { 0, 0, 0, 0, 0 },
/* U+6372 */ { 0, 0, 0, 0, 0 },
/* U+6373 */ { 0, 0, 0, 0, 0 },
/* U+6374 */ { 0, 0, 0, 0, 0 },
/* U+6375 */ { 0, 0, 0, 0, 0 },
/* U+6376 */ { 0, 0, 0, 0, 0 },
/* U+6377 */ { 0, 0, 0, 0, 0 },
/* U+6378 */ { 0, 0, 0, 0, 0 },
/* U+6379 */ { 0, 0, 0, 0, 0 },
/* U+637a */ { 0, 0, 0, 0, 0 },
/* U+637b */ { 0, 0, 0, 0, 0 },
/* U+637c */ { 0, 0, 0, 0, 0 },
/* U+637d */ { 0, 0, 0, 0, 0 },
/* U+637e */ { 0, 0, 0, 0, 0 },
/* U+637f */ { 0, 0, 0, 0, 0 },
/* U+6380 */ { 0, 0, 0, 0, 0 },
/* U+6381 */ { 0, 0, 0, 0, 0 },
/* U+6382 */ { 0, 0, 0, 0, 0 },
/* U+6383 */ { 0, 0, 0, 0, 0 },
/* U+6384 */ { 0, 0, 0, 0, 0 },
/* U+6385 */ { 0, 0, 0, 0, 0 },
/* U+6386 */ { 0, 0, 0, 0, 0 },
/* U+6387 */ { 0, 0, 0, 0, 0 },
/* U+6388 */ { 0, 0, 0, 0, 0 },
/* U+6389 */ { 0, 0, 0, 0, 0 },
/* U+638a */ { 0, 0, 0, 0, 0 },
/* U+638b */ { 0, 0, 0, 0, 0 },
/* U+638c */ { 0, 0, 0, 0, 0 },
/* U+638d */ { 0, 0, 0, 0, 0 },
/* U+638e */ { 0, 0, 0, 0, 0 },
/* U+638f */ { 0, 0, 0, 0, 0 },
/* U+6390 */ { 0, 0, 0, 0, 0 },
/* U+6391 */ { 0, 0, 0, 0, 0 },
/* U+6392 */ { 0, 0, 0, 0, 0 },
/* U+6393 */ { 0, 0, 0, 0, 0 },
/* U+6394 */ { 0, 0, 0, 0, 0 },
/* U+6395 */ { 0, 0, 0, 0, 0 },
/* U+6396 */ { 0, 0, 0, 0, 0 },
/* U+6397 */ { 0, 0, 0, 0, 0 },
/* U+6398 */ { 0, 0, 0, 0, 0 },
/* U+6399 */ { 0, 0, 0, 0, 0 },
/* U+639a */ { 0, 0, 0, 0, 0 },
/* U+639b */ { 0, 0, 0, 0, 0 },
/* U+639c */ { 0, 0, 0, 0, 0 },
/* U+639d */ { 0, 0, 0, 0, 0 },
/* U+639e */ { 0, 0, 0, 0, 0 },
/* U+639f */ { 0, 0, 0, 0, 0 },
/* U+63a0 */ { 0, 0, 0, 0, 0 },
/* U+63a1 */ { 0, 0, 0, 0, 0 },
/* U+63a2 */ { 0, 0, 0, 0, 0 },
/* U+63a3 */ { 0, 0, 0, 0, 0 },
/* U+63a4 */ { 0, 0, 0, 0, 0 },
/* U+63a5 */ { 0, 0, 0, 0, 0 },
/* U+63a6 */ { 0, 0, 0, 0, 0 },
/* U+63a7 */ { 0, 0, 0, 0, 0 },
/* U+63a8 */ { 0, 0, 0, 0, 0 },
/* U+63a9 */ { 0, 0, 0, 0, 0 },
/* U+63aa */ { 0, 0, 0, 0, 0 },
/* U+63ab */ { 0, 0, 0, 0, 0 },
/* U+63ac */ { 0, 0, 0, 0, 0 },
/* U+63ad */ { 0, 0, 0, 0, 0 },
/* U+63ae */ { 0, 0, 0, 0, 0 },
/* U+63af */ { 0, 0, 0, 0, 0 },
/* U+63b0 */ { 0, 0, 0, 0, 0 },
/* U+63b1 */ { 0, 0, 0, 0, 0 },
/* U+63b2 */ { 0, 0, 0, 0, 0 },
/* U+63b3 */ { 0, 0, 0, 0, 0 },
/* U+63b4 */ { 0, 0, 0, 0, 0 },
/* U+63b5 */ { 0, 0, 0, 0, 0 },
/* U+63b6 */ { 0, 0, 0, 0, 0 },
/* U+63b7 */ { 0, 0, 0, 0, 0 },
/* U+63b8 */ { 0, 0, 0, 0, 0 },
/* U+63b9 */ { 0, 0, 0, 0, 0 },
/* U+63ba */ { 0, 0, 0, 0, 0 },
/* U+63bb */ { 0, 0, 0, 0, 0 },
/* U+63bc */ { 0, 0, 0, 0, 0 },
/* U+63bd */ { 0, 0, 0, 0, 0 },
/* U+63be */ { 0, 0, 0, 0, 0 },
/* U+63bf */ { 0, 0, 0, 0, 0 },
/* U+63c0 */ { 0, 0, 0, 0, 0 },
/* U+63c1 */ { 0, 0, 0, 0, 0 },
/* U+63c2 */ { 0, 0, 0, 0, 0 },
/* U+63c3 */ { 0, 0, 0, 0, 0 },
/* U+63c4 */ { 0, 0, 0, 0, 0 },
/* U+63c5 */ { 0, 0, 0, 0, 0 },
/* U+63c6 */ { 0, 0, 0, 0, 0 },
/* U+63c7 */ { 0, 0, 0, 0, 0 },
/* U+63c8 */ { 0, 0, 0, 0, 0 },
/* U+63c9 */ { 0, 0, 0, 0, 0 },
/* U+63ca */ { 0, 0, 0, 0, 0 },
/* U+63cb */ { 0, 0, 0, 0, 0 },
/* U+63cc */ { 0, 0, 0, 0, 0 },
/* U+63cd */ { 0, 0, 0, 0, 0 },
/* U+63ce */ { 0, 0, 0, 0, 0 },
/* U+63cf */ { 0, 0, 0, 0, 0 },
/* U+63d0 */ { 0, 0, 0, 0, 0 },
/* U+63d1 */ { 0, 0, 0, 0, 0 },
/* U+63d2 */ { 0, 0, 0, 0, 0 },
/* U+63d3 */ { 0, 0, 0, 0, 0 },
/* U+63d4 */ { 0, 0, 0, 0, 0 },
/* U+63d5 */ { 0, 0, 0, 0, 0 },
/* U+63d6 */ { 0, 0, 0, 0, 0 },
/* U+63d7 */ { 0, 0, 0, 0, 0 },
/* U+63d8 */ { 0, 0, 0, 0, 0 },
/* U+63d9 */ { 0, 0, 0, 0, 0 },
/* U+63da */ { 0, 0, 0, 0, 0 },
/* U+63db */ { 0, 0, 0, 0, 0 },
/* U+63dc */ { 0, 0, 0, 0, 0 },
/* U+63dd */ { 0, 0, 0, 0, 0 },
/* U+63de */ { 0, 0, 0, 0, 0 },
/* U+63df */ { 0, 0, 0, 0, 0 },
/* U+63e0 */ { 0, 0, 0, 0, 0 },
/* U+63e1 */ { 0, 0, 0, 0, 0 },
/* U+63e2 */ { 0, 0, 0, 0, 0 },
/* U+63e3 */ { 0, 0, 0, 0, 0 },
/* U+63e4 */ { 0, 0, 0, 0, 0 },
/* U+63e5 */ { 0, 0, 0, 0, 0 },
/* U+63e6 */ { 0, 0, 0, 0, 0 },
/* U+63e7 */ { 0, 0, 0, 0, 0 },
/* U+63e8 */ { 0, 0, 0, 0, 0 },
/* U+63e9 */ { 0, 0, 0, 0, 0 },
/* U+63ea */ { 0, 0, 0, 0, 0 },
/* U+63eb */ { 0, 0, 0, 0, 0 },
/* U+63ec */ { 0, 0, 0, 0, 0 },
/* U+63ed */ { 0, 0, 0, 0, 0 },
/* U+63ee */ { 0, 0, 0, 0, 0 },
/* U+63ef */ { 0, 0, 0, 0, 0 },
/* U+63f0 */ { 0, 0, 0, 0, 0 },
/* U+63f1 */ { 0, 0, 0, 0, 0 },
/* U+63f2 */ { 0, 0, 0, 0, 0 },
/* U+63f3 */ { 0, 0, 0, 0, 0 },
/* U+63f4 */ { 0, 0, 0, 0, 0 },
/* U+63f5 */ { 0, 0, 0, 0, 0 },
/* U+63f6 */ { 0, 0, 0, 0, 0 },
/* U+63f7 */ { 0, 0, 0, 0, 0 },
/* U+63f8 */ { 0, 0, 0, 0, 0 },
/* U+63f9 */ { 0, 0, 0, 0, 0 },
/* U+63fa */ { 0, 0, 0, 0, 0 },
/* U+63fb */ { 0, 0, 0, 0, 0 },
/* U+63fc */ { 0, 0, 0, 0, 0 },
/* U+63fd */ { 0, 0, 0, 0, 0 },
/* U+63fe */ { 0, 0, 0, 0, 0 },
/* U+63ff */ { 0, 0, 0, 0, 0 },
/* U+6400 */ { 0, 0, 0, 0, 0 },
/* U+6401 */ { 0, 0, 0, 0, 0 },
/* U+6402 */ { 0, 0, 0, 0, 0 },
/* U+6403 */ { 0, 0, 0, 0, 0 },
/* U+6404 */ { 0, 0, 0, 0, 0 },
/* U+6405 */ { 0, 0, 0, 0, 0 },
/* U+6406 */ { 0, 0, 0, 0, 0 },
/* U+6407 */ { 0, 0, 0, 0, 0 },
/* U+6408 */ { 0, 0, 0, 0, 0 },
/* U+6409 */ { 0, 0, 0, 0, 0 },
/* U+640a */ { 0, 0, 0, 0, 0 },
/* U+640b */ { 0, 0, 0, 0, 0 },
/* U+640c */ { 0, 0, 0, 0, 0 },
/* U+640d */ { 0, 0, 0, 0, 0 },
/* U+640e */ { 0, 0, 0, 0, 0 },
/* U+640f */ { 0, 0, 0, 0, 0 },
/* U+6410 */ { 0, 0, 0, 0, 0 },
/* U+6411 */ { 0, 0, 0, 0, 0 },
/* U+6412 */ { 0, 0, 0, 0, 0 },
/* U+6413 */ { 0, 0, 0, 0, 0 },
/* U+6414 */ { 0, 0, 0, 0, 0 },
/* U+6415 */ { 0, 0, 0, 0, 0 },
/* U+6416 */ { 0, 0, 0, 0, 0 },
/* U+6417 */ { 0, 0, 0, 0, 0 },
/* U+6418 */ { 0, 0, 0, 0, 0 },
/* U+6419 */ { 0, 0, 0, 0, 0 },
/* U+641a */ { 0, 0, 0, 0, 0 },
/* U+641b */ { 0, 0, 0, 0, 0 },
/* U+641c */ { 0, 0, 0, 0, 0 },
/* U+641d */ { 0, 0, 0, 0, 0 },
/* U+641e */ { 0, 0, 0, 0, 0 },
/* U+641f */ { 0, 0, 0, 0, 0 },
/* U+6420 */ { 0, 0, 0, 0, 0 },
/* U+6421 */ { 0, 0, 0, 0, 0 },
/* U+6422 */ { 0, 0, 0, 0, 0 },
/* U+6423 */ { 0, 0, 0, 0, 0 },
/* U+6424 */ { 0, 0, 0, 0, 0 },
/* U+6425 */ { 0, 0, 0, 0, 0 },
/* U+6426 */ { 0, 0, 0, 0, 0 },
/* U+6427 */ { 0, 0, 0, 0, 0 },
/* U+6428 */ { 0, 0, 0, 0, 0 },
/* U+6429 */ { 0, 0, 0, 0, 0 },
/* U+642a */ { 0, 0, 0, 0, 0 },
/* U+642b */ { 0, 0, 0, 0, 0 },
/* U+642c */ { 0, 0, 0, 0, 0 },
/* U+642d */ { 0, 0, 0, 0, 0 },
/* U+642e */ { 0, 0, 0, 0, 0 },
/* U+642f */ { 0, 0, 0, 0, 0 },
/* U+6430 */ { 0, 0, 0, 0, 0 },
/* U+6431 */ { 0, 0, 0, 0, 0 },
/* U+6432 */ { 0, 0, 0, 0, 0 },
/* U+6433 */ { 0, 0, 0, 0, 0 },
/* U+6434 */ { 0, 0, 0, 0, 0 },
/* U+6435 */ { 0, 0, 0, 0, 0 },
/* U+6436 */ { 0, 0, 0, 0, 0 },
/* U+6437 */ { 0, 0, 0, 0, 0 },
/* U+6438 */ { 0, 0, 0, 0, 0 },
/* U+6439 */ { 0, 0, 0, 0, 0 },
/* U+643a */ { 0, 0, 0, 0, 0 },
/* U+643b */ { 0, 0, 0, 0, 0 },
/* U+643c */ { 0, 0, 0, 0, 0 },
/* U+643d */ { 0, 0, 0, 0, 0 },
/* U+643e */ { 0, 0, 0, 0, 0 },
/* U+643f */ { 0, 0, 0, 0, 0 },
/* U+6440 */ { 0, 0, 0, 0, 0 },
/* U+6441 */ { 0, 0, 0, 0, 0 },
/* U+6442 */ { 0, 0, 0, 0, 0 },
/* U+6443 */ { 0, 0, 0, 0, 0 },
/* U+6444 */ { 0, 0, 0, 0, 0 },
/* U+6445 */ { 0, 0, 0, 0, 0 },
/* U+6446 */ { 0, 0, 0, 0, 0 },
/* U+6447 */ { 0, 0, 0, 0, 0 },
/* U+6448 */ { 0, 0, 0, 0, 0 },
/* U+6449 */ { 0, 0, 0, 0, 0 },
/* U+644a */ { 0, 0, 0, 0, 0 },
/* U+644b */ { 0, 0, 0, 0, 0 },
/* U+644c */ { 0, 0, 0, 0, 0 },
/* U+644d */ { 0, 0, 0, 0, 0 },
/* U+644e */ { 0, 0, 0, 0, 0 },
/* U+644f */ { 0, 0, 0, 0, 0 },
/* U+6450 */ { 0, 0, 0, 0, 0 },
/* U+6451 */ { 0, 0, 0, 0, 0 },
/* U+6452 */ { 0, 0, 0, 0, 0 },
/* U+6453 */ { 0, 0, 0, 0, 0 },
/* U+6454 */ { 0, 0, 0, 0, 0 },
/* U+6455 */ { 0, 0, 0, 0, 0 },
/* U+6456 */ { 0, 0, 0, 0, 0 },
/* U+6457 */ { 0, 0, 0, 0, 0 },
/* U+6458 */ { 0, 0, 0, 0, 0 },
/* U+6459 */ { 0, 0, 0, 0, 0 },
/* U+645a */ { 0, 0, 0, 0, 0 },
/* U+645b */ { 0, 0, 0, 0, 0 },
/* U+645c */ { 0, 0, 0, 0, 0 },
/* U+645d */ { 0, 0, 0, 0, 0 },
/* U+645e */ { 0, 0, 0, 0, 0 },
/* U+645f */ { 0, 0, 0, 0, 0 },
/* U+6460 */ { 0, 0, 0, 0, 0 },
/* U+6461 */ { 0, 0, 0, 0, 0 },
/* U+6462 */ { 0, 0, 0, 0, 0 },
/* U+6463 */ { 0, 0, 0, 0, 0 },
/* U+6464 */ { 0, 0, 0, 0, 0 },
/* U+6465 */ { 0, 0, 0, 0, 0 },
/* U+6466 */ { 0, 0, 0, 0, 0 },
/* U+6467 */ { 0, 0, 0, 0, 0 },
/* U+6468 */ { 0, 0, 0, 0, 0 },
/* U+6469 */ { 0, 0, 0, 0, 0 },
/* U+646a */ { 0, 0, 0, 0, 0 },
/* U+646b */ { 0, 0, 0, 0, 0 },
/* U+646c */ { 0, 0, 0, 0, 0 },
/* U+646d */ { 0, 0, 0, 0, 0 },
/* U+646e */ { 0, 0, 0, 0, 0 },
/* U+646f */ { 0, 0, 0, 0, 0 },
/* U+6470 */ { 0, 0, 0, 0, 0 },
/* U+6471 */ { 0, 0, 0, 0, 0 },
/* U+6472 */ { 0, 0, 0, 0, 0 },
/* U+6473 */ { 0, 0, 0, 0, 0 },
/* U+6474 */ { 0, 0, 0, 0, 0 },
/* U+6475 */ { 0, 0, 0, 0, 0 },
/* U+6476 */ { 0, 0, 0, 0, 0 },
/* U+6477 */ { 0, 0, 0, 0, 0 },
/* U+6478 */ { 0, 0, 0, 0, 0 },
/* U+6479 */ { 0, 0, 0, 0, 0 },
/* U+647a */ { 0, 0, 0, 0, 0 },
/* U+647b */ { 0, 0, 0, 0, 0 },
/* U+647c */ { 0, 0, 0, 0, 0 },
/* U+647d */ { 0, 0, 0, 0, 0 },
/* U+647e */ { 0, 0, 0, 0, 0 },
/* U+647f */ { 0, 0, 0, 0, 0 },
/* U+6480 */ { 0, 0, 0, 0, 0 },
/* U+6481 */ { 0, 0, 0, 0, 0 },
/* U+6482 */ { 0, 0, 0, 0, 0 },
/* U+6483 */ { 0, 0, 0, 0, 0 },
/* U+6484 */ { 0, 0, 0, 0, 0 },
/* U+6485 */ { 0, 0, 0, 0, 0 },
/* U+6486 */ { 0, 0, 0, 0, 0 },
/* U+6487 */ { 0, 0, 0, 0, 0 },
/* U+6488 */ { 0, 0, 0, 0, 0 },
/* U+6489 */ { 0, 0, 0, 0, 0 },
/* U+648a */ { 0, 0, 0, 0, 0 },
/* U+648b */ { 0, 0, 0, 0, 0 },
/* U+648c */ { 0, 0, 0, 0, 0 },
/* U+648d */ { 0, 0, 0, 0, 0 },
/* U+648e */ { 0, 0, 0, 0, 0 },
/* U+648f */ { 0, 0, 0, 0, 0 },
/* U+6490 */ { 0, 0, 0, 0, 0 },
/* U+6491 */ { 0, 0, 0, 0, 0 },
/* U+6492 */ { 0, 0, 0, 0, 0 },
/* U+6493 */ { 0, 0, 0, 0, 0 },
/* U+6494 */ { 0, 0, 0, 0, 0 },
/* U+6495 */ { 0, 0, 0, 0, 0 },
/* U+6496 */ { 0, 0, 0, 0, 0 },
/* U+6497 */ { 0, 0, 0, 0, 0 },
/* U+6498 */ { 0, 0, 0, 0, 0 },
/* U+6499 */ { 0, 0, 0, 0, 0 },
/* U+649a */ { 0, 0, 0, 0, 0 },
/* U+649b */ { 0, 0, 0, 0, 0 },
/* U+649c */ { 0, 0, 0, 0, 0 },
/* U+649d */ { 0, 0, 0, 0, 0 },
/* U+649e */ { 0, 0, 0, 0, 0 },
/* U+649f */ { 0, 0, 0, 0, 0 },
/* U+64a0 */ { 0, 0, 0, 0, 0 },
/* U+64a1 */ { 0, 0, 0, 0, 0 },
/* U+64a2 */ { 0, 0, 0, 0, 0 },
/* U+64a3 */ { 0, 0, 0, 0, 0 },
/* U+64a4 */ { 0, 0, 0, 0, 0 },
/* U+64a5 */ { 0, 0, 0, 0, 0 },
/* U+64a6 */ { 0, 0, 0, 0, 0 },
/* U+64a7 */ { 0, 0, 0, 0, 0 },
/* U+64a8 */ { 0, 0, 0, 0, 0 },
/* U+64a9 */ { 0, 0, 0, 0, 0 },
/* U+64aa */ { 0, 0, 0, 0, 0 },
/* U+64ab */ { 0, 0, 0, 0, 0 },
/* U+64ac */ { 0, 0, 0, 0, 0 },
/* U+64ad */ { 0, 0, 0, 0, 0 },
/* U+64ae */ { 0, 0, 0, 0, 0 },
/* U+64af */ { 0, 0, 0, 0, 0 },
/* U+64b0 */ { 0, 0, 0, 0, 0 },
/* U+64b1 */ { 0, 0, 0, 0, 0 },
/* U+64b2 */ { 0, 0, 0, 0, 0 },
/* U+64b3 */ { 0, 0, 0, 0, 0 },
/* U+64b4 */ { 0, 0, 0, 0, 0 },
/* U+64b5 */ { 0, 0, 0, 0, 0 },
/* U+64b6 */ { 0, 0, 0, 0, 0 },
/* U+64b7 */ { 0, 0, 0, 0, 0 },
/* U+64b8 */ { 0, 0, 0, 0, 0 },
/* U+64b9 */ { 0, 0, 0, 0, 0 },
/* U+64ba */ { 0, 0, 0, 0, 0 },
/* U+64bb */ { 0, 0, 0, 0, 0 },
/* U+64bc */ { 0, 0, 0, 0, 0 },
/* U+64bd */ { 0, 0, 0, 0, 0 },
/* U+64be */ { 0, 0, 0, 0, 0 },
/* U+64bf */ { 0, 0, 0, 0, 0 },
/* U+64c0 */ { 0, 0, 0, 0, 0 },
/* U+64c1 */ { 0, 0, 0, 0, 0 },
/* U+64c2 */ { 0, 0, 0, 0, 0 },
/* U+64c3 */ { 0, 0, 0, 0, 0 },
/* U+64c4 */ { 0, 0, 0, 0, 0 },
/* U+64c5 */ { 0, 0, 0, 0, 0 },
/* U+64c6 */ { 0, 0, 0, 0, 0 },
/* U+64c7 */ { 0, 0, 0, 0, 0 },
/* U+64c8 */ { 0, 0, 0, 0, 0 },
/* U+64c9 */ { 0, 0, 0, 0, 0 },
/* U+64ca */ { 0, 0, 0, 0, 0 },
/* U+64cb */ { 0, 0, 0, 0, 0 },
/* U+64cc */ { 0, 0, 0, 0, 0 },
/* U+64cd */ { 0, 0, 0, 0, 0 },
/* U+64ce */ { 0, 0, 0, 0, 0 },
/* U+64cf */ { 0, 0, 0, 0, 0 },
/* U+64d0 */ { 0, 0, 0, 0, 0 },
/* U+64d1 */ { 0, 0, 0, 0, 0 },
/* U+64d2 */ { 0, 0, 0, 0, 0 },
/* U+64d3 */ { 0, 0, 0, 0, 0 },
/* U+64d4 */ { 0, 0, 0, 0, 0 },
/* U+64d5 */ { 0, 0, 0, 0, 0 },
/* U+64d6 */ { 0, 0, 0, 0, 0 },
/* U+64d7 */ { 0, 0, 0, 0, 0 },
/* U+64d8 */ { 0, 0, 0, 0, 0 },
/* U+64d9 */ { 0, 0, 0, 0, 0 },
/* U+64da */ { 0, 0, 0, 0, 0 },
/* U+64db */ { 0, 0, 0, 0, 0 },
/* U+64dc */ { 0, 0, 0, 0, 0 },
/* U+64dd */ { 0, 0, 0, 0, 0 },
/* U+64de */ { 0, 0, 0, 0, 0 },
/* U+64df */ { 0, 0, 0, 0, 0 },
/* U+64e0 */ { 0, 0, 0, 0, 0 },
/* U+64e1 */ { 0, 0, 0, 0, 0 },
/* U+64e2 */ { 0, 0, 0, 0, 0 },
/* U+64e3 */ { 0, 0, 0, 0, 0 },
/* U+64e4 */ { 0, 0, 0, 0, 0 },
/* U+64e5 */ { 0, 0, 0, 0, 0 },
/* U+64e6 */ { 0, 0, 0, 0, 0 },
/* U+64e7 */ { 0, 0, 0, 0, 0 },
/* U+64e8 */ { 0, 0, 0, 0, 0 },
/* U+64e9 */ { 0, 0, 0, 0, 0 },
/* U+64ea */ { 0, 0, 0, 0, 0 },
/* U+64eb */ { 0, 0, 0, 0, 0 },
/* U+64ec */ { 0, 0, 0, 0, 0 },
/* U+64ed */ { 0, 0, 0, 0, 0 },
/* U+64ee */ { 0, 0, 0, 0, 0 },
/* U+64ef */ { 0, 0, 0, 0, 0 },
/* U+64f0 */ { 0, 0, 0, 0, 0 },
/* U+64f1 */ { 0, 0, 0, 0, 0 },
/* U+64f2 */ { 0, 0, 0, 0, 0 },
/* U+64f3 */ { 0, 0, 0, 0, 0 },
/* U+64f4 */ { 0, 0, 0, 0, 0 },
/* U+64f5 */ { 0, 0, 0, 0, 0 },
/* U+64f6 */ { 0, 0, 0, 0, 0 },
/* U+64f7 */ { 0, 0, 0, 0, 0 },
/* U+64f8 */ { 0, 0, 0, 0, 0 },
/* U+64f9 */ { 0, 0, 0, 0, 0 },
/* U+64fa */ { 0, 0, 0, 0, 0 },
/* U+64fb */ { 0, 0, 0, 0, 0 },
/* U+64fc */ { 0, 0, 0, 0, 0 },
/* U+64fd */ { 0, 0, 0, 0, 0 },
/* U+64fe */ { 0, 0, 0, 0, 0 },
/* U+64ff */ { 0, 0, 0, 0, 0 },
/* U+6500 */ { 0, 0, 0, 0, 0 },
/* U+6501 */ { 0, 0, 0, 0, 0 },
/* U+6502 */ { 0, 0, 0, 0, 0 },
/* U+6503 */ { 0, 0, 0, 0, 0 },
/* U+6504 */ { 0, 0, 0, 0, 0 },
/* U+6505 */ { 0, 0, 0, 0, 0 },
/* U+6506 */ { 0, 0, 0, 0, 0 },
/* U+6507 */ { 0, 0, 0, 0, 0 },
/* U+6508 */ { 0, 0, 0, 0, 0 },
/* U+6509 */ { 0, 0, 0, 0, 0 },
/* U+650a */ { 0, 0, 0, 0, 0 },
/* U+650b */ { 0, 0, 0, 0, 0 },
/* U+650c */ { 0, 0, 0, 0, 0 },
/* U+650d */ { 0, 0, 0, 0, 0 },
/* U+650e */ { 0, 0, 0, 0, 0 },
/* U+650f */ { 0, 0, 0, 0, 0 },
/* U+6510 */ { 0, 0, 0, 0, 0 },
/* U+6511 */ { 0, 0, 0, 0, 0 },
/* U+6512 */ { 0, 0, 0, 0, 0 },
/* U+6513 */ { 0, 0, 0, 0, 0 },
/* U+6514 */ { 0, 0, 0, 0, 0 },
/* U+6515 */ { 0, 0, 0, 0, 0 },
/* U+6516 */ { 0, 0, 0, 0, 0 },
/* U+6517 */ { 0, 0, 0, 0, 0 },
/* U+6518 */ { 0, 0, 0, 0, 0 },
/* U+6519 */ { 0, 0, 0, 0, 0 },
/* U+651a */ { 0, 0, 0, 0, 0 },
/* U+651b */ { 0, 0, 0, 0, 0 },
/* U+651c */ { 0, 0, 0, 0, 0 },
/* U+651d */ { 0, 0, 0, 0, 0 },
/* U+651e */ { 0, 0, 0, 0, 0 },
/* U+651f */ { 0, 0, 0, 0, 0 },
/* U+6520 */ { 0, 0, 0, 0, 0 },
/* U+6521 */ { 0, 0, 0, 0, 0 },
/* U+6522 */ { 0, 0, 0, 0, 0 },
/* U+6523 */ { 0, 0, 0, 0, 0 },
/* U+6524 */ { 0, 0, 0, 0, 0 },
/* U+6525 */ { 0, 0, 0, 0, 0 },
/* U+6526 */ { 0, 0, 0, 0, 0 },
/* U+6527 */ { 0, 0, 0, 0, 0 },
/* U+6528 */ { 0, 0, 0, 0, 0 },
/* U+6529 */ { 0, 0, 0, 0, 0 },
/* U+652a */ { 0, 0, 0, 0, 0 },
/* U+652b */ { 0, 0, 0, 0, 0 },
/* U+652c */ { 0, 0, 0, 0, 0 },
/* U+652d */ { 0, 0, 0, 0, 0 },
/* U+652e */ { 0, 0, 0, 0, 0 },
/* U+652f */ { 0, 0, 0, 0, 0 },
/* U+6530 */ { 0, 0, 0, 0, 0 },
/* U+6531 */ { 0, 0, 0, 0, 0 },
/* U+6532 */ { 0, 0, 0, 0, 0 },
/* U+6533 */ { 0, 0, 0, 0, 0 },
/* U+6534 */ { 0, 0, 0, 0, 0 },
/* U+6535 */ { 0, 0, 0, 0, 0 },
/* U+6536 */ { 0, 0, 0, 0, 0 },
/* U+6537 */ { 0, 0, 0, 0, 0 },
/* U+6538 */ { 0, 0, 0, 0, 0 },
/* U+6539 */ { 0, 0, 0, 0, 0 },
/* U+653a */ { 0, 0, 0, 0, 0 },
/* U+653b */ { 0, 0, 0, 0, 0 },
/* U+653c */ { 0, 0, 0, 0, 0 },
/* U+653d */ { 0, 0, 0, 0, 0 },
/* U+653e */ { 0, 0, 0, 0, 0 },
/* U+653f */ { 0, 0, 0, 0, 0 },
/* U+6540 */ { 0, 0, 0, 0, 0 },
/* U+6541 */ { 0, 0, 0, 0, 0 },
/* U+6542 */ { 0, 0, 0, 0, 0 },
/* U+6543 */ { 0, 0, 0, 0, 0 },
/* U+6544 */ { 0, 0, 0, 0, 0 },
/* U+6545 */ { 0, 0, 0, 0, 0 },
/* U+6546 */ { 0, 0, 0, 0, 0 },
/* U+6547 */ { 0, 0, 0, 0, 0 },
/* U+6548 */ { 0, 0, 0, 0, 0 },
/* U+6549 */ { 0, 0, 0, 0, 0 },
/* U+654a */ { 0, 0, 0, 0, 0 },
/* U+654b */ { 0, 0, 0, 0, 0 },
/* U+654c */ { 0, 0, 0, 0, 0 },
/* U+654d */ { 0, 0, 0, 0, 0 },
/* U+654e */ { 0, 0, 0, 0, 0 },
/* U+654f */ { 0, 0, 0, 0, 0 },
/* U+6550 */ { 0, 0, 0, 0, 0 },
/* U+6551 */ { 0, 0, 0, 0, 0 },
/* U+6552 */ { 0, 0, 0, 0, 0 },
/* U+6553 */ { 0, 0, 0, 0, 0 },
/* U+6554 */ { 0, 0, 0, 0, 0 },
/* U+6555 */ { 0, 0, 0, 0, 0 },
/* U+6556 */ { 0, 0, 0, 0, 0 },
/* U+6557 */ { 0, 0, 0, 0, 0 },
/* U+6558 */ { 0, 0, 0, 0, 0 },
/* U+6559 */ { 0, 0, 0, 0, 0 },
/* U+655a */ { 0, 0, 0, 0, 0 },
/* U+655b */ { 0, 0, 0, 0, 0 },
/* U+655c */ { 0, 0, 0, 0, 0 },
/* U+655d */ { 0, 0, 0, 0, 0 },
/* U+655e */ { 0, 0, 0, 0, 0 },
/* U+655f */ { 0, 0, 0, 0, 0 },
/* U+6560 */ { 0, 0, 0, 0, 0 },
/* U+6561 */ { 0, 0, 0, 0, 0 },
/* U+6562 */ { 0, 0, 0, 0, 0 },
/* U+6563 */ { 0, 0, 0, 0, 0 },
/* U+6564 */ { 0, 0, 0, 0, 0 },
/* U+6565 */ { 0, 0, 0, 0, 0 },
/* U+6566 */ { 0, 0, 0, 0, 0 },
/* U+6567 */ { 0, 0, 0, 0, 0 },
/* U+6568 */ { 0, 0, 0, 0, 0 },
/* U+6569 */ { 0, 0, 0, 0, 0 },
/* U+656a */ { 0, 0, 0, 0, 0 },
/* U+656b */ { 0, 0, 0, 0, 0 },
/* U+656c */ { 0, 0, 0, 0, 0 },
/* U+656d */ { 0, 0, 0, 0, 0 },
/* U+656e */ { 0, 0, 0, 0, 0 },
/* U+656f */ { 0, 0, 0, 0, 0 },
/* U+6570 */ { 0, 0, 0, 0, 0 },
/* U+6571 */ { 0, 0, 0, 0, 0 },
/* U+6572 */ { 0, 0, 0, 0, 0 },
/* U+6573 */ { 0, 0, 0, 0, 0 },
/* U+6574 */ { 0, 0, 0, 0, 0 },
/* U+6575 */ { 0, 0, 0, 0, 0 },
/* U+6576 */ { 0, 0, 0, 0, 0 },
/* U+6577 */ { 0, 0, 0, 0, 0 },
/* U+6578 */ { 0, 0, 0, 0, 0 },
/* U+6579 */ { 0, 0, 0, 0, 0 },
/* U+657a */ { 0, 0, 0, 0, 0 },
/* U+657b */ { 0, 0, 0, 0, 0 },
/* U+657c */ { 0, 0, 0, 0, 0 },
/* U+657d */ { 0, 0, 0, 0, 0 },
/* U+657e */ { 0, 0, 0, 0, 0 },
/* U+657f */ { 0, 0, 0, 0, 0 },
/* U+6580 */ { 0, 0, 0, 0, 0 },
/* U+6581 */ { 0, 0, 0, 0, 0 },
/* U+6582 */ { 0, 0, 0, 0, 0 },
/* U+6583 */ { 0, 0, 0, 0, 0 },
/* U+6584 */ { 0, 0, 0, 0, 0 },
/* U+6585 */ { 0, 0, 0, 0, 0 },
/* U+6586 */ { 0, 0, 0, 0, 0 },
/* U+6587 */ { 0, 0, 0, 0, 0 },
/* U+6588 */ { 0, 0, 0, 0, 0 },
/* U+6589 */ { 0, 0, 0, 0, 0 },
/* U+658a */ { 0, 0, 0, 0, 0 },
/* U+658b */ { 0, 0, 0, 0, 0 },
/* U+658c */ { 0, 0, 0, 0, 0 },
/* U+658d */ { 0, 0, 0, 0, 0 },
/* U+658e */ { 0, 0, 0, 0, 0 },
/* U+658f */ { 0, 0, 0, 0, 0 },
/* U+6590 */ { 0, 0, 0, 0, 0 },
/* U+6591 */ { 0, 0, 0, 0, 0 },
/* U+6592 */ { 0, 0, 0, 0, 0 },
/* U+6593 */ { 0, 0, 0, 0, 0 },
/* U+6594 */ { 0, 0, 0, 0, 0 },
/* U+6595 */ { 0, 0, 0, 0, 0 },
/* U+6596 */ { 0, 0, 0, 0, 0 },
/* U+6597 */ { 0, 0, 0, 0, 0 },
/* U+6598 */ { 0, 0, 0, 0, 0 },
/* U+6599 */ { 0, 0, 0, 0, 0 },
/* U+659a */ { 0, 0, 0, 0, 0 },
/* U+659b */ { 0, 0, 0, 0, 0 },
/* U+659c */ { 0, 0, 0, 0, 0 },
/* U+659d */ { 0, 0, 0, 0, 0 },
/* U+659e */ { 0, 0, 0, 0, 0 },
/* U+659f */ { 0, 0, 0, 0, 0 },
/* U+65a0 */ { 0, 0, 0, 0, 0 },
/* U+65a1 */ { 0, 0, 0, 0, 0 },
/* U+65a2 */ { 0, 0, 0, 0, 0 },
/* U+65a3 */ { 0, 0, 0, 0, 0 },
/* U+65a4 */ { 0, 0, 0, 0, 0 },
/* U+65a5 */ { 0, 0, 0, 0, 0 },
/* U+65a6 */ { 0, 0, 0, 0, 0 },
/* U+65a7 */ { 0, 0, 0, 0, 0 },
/* U+65a8 */ { 0, 0, 0, 0, 0 },
/* U+65a9 */ { 0, 0, 0, 0, 0 },
/* U+65aa */ { 0, 0, 0, 0, 0 },
/* U+65ab */ { 0, 0, 0, 0, 0 },
/* U+65ac */ { 0, 0, 0, 0, 0 },
/* U+65ad */ { 0, 0, 0, 0, 0 },
/* U+65ae */ { 0, 0, 0, 0, 0 },
/* U+65af */ { 0, 0, 0, 0, 0 },
/* U+65b0 */ { 0, 0, 0, 0, 0 },
/* U+65b1 */ { 0, 0, 0, 0, 0 },
/* U+65b2 */ { 0, 0, 0, 0, 0 },
/* U+65b3 */ { 0, 0, 0, 0, 0 },
/* U+65b4 */ { 0, 0, 0, 0, 0 },
/* U+65b5 */ { 0, 0, 0, 0, 0 },
/* U+65b6 */ { 0, 0, 0, 0, 0 },
/* U+65b7 */ { 0, 0, 0, 0, 0 },
/* U+65b8 */ { 0, 0, 0, 0, 0 },
/* U+65b9 */ { 0, 0, 0, 0, 0 },
/* U+65ba */ { 0, 0, 0, 0, 0 },
/* U+65bb */ { 0, 0, 0, 0, 0 },
/* U+65bc */ { 0, 0, 0, 0, 0 },
/* U+65bd */ { 0, 0, 0, 0, 0 },
/* U+65be */ { 0, 0, 0, 0, 0 },
/* U+65bf */ { 0, 0, 0, 0, 0 },
/* U+65c0 */ { 0, 0, 0, 0, 0 },
/* U+65c1 */ { 0, 0, 0, 0, 0 },
/* U+65c2 */ { 0, 0, 0, 0, 0 },
/* U+65c3 */ { 0, 0, 0, 0, 0 },
/* U+65c4 */ { 0, 0, 0, 0, 0 },
/* U+65c5 */ { 0, 0, 0, 0, 0 },
/* U+65c6 */ { 0, 0, 0, 0, 0 },
/* U+65c7 */ { 0, 0, 0, 0, 0 },
/* U+65c8 */ { 0, 0, 0, 0, 0 },
/* U+65c9 */ { 0, 0, 0, 0, 0 },
/* U+65ca */ { 0, 0, 0, 0, 0 },
/* U+65cb */ { 0, 0, 0, 0, 0 },
/* U+65cc */ { 0, 0, 0, 0, 0 },
/* U+65cd */ { 0, 0, 0, 0, 0 },
/* U+65ce */ { 0, 0, 0, 0, 0 },
/* U+65cf */ { 0, 0, 0, 0, 0 },
/* U+65d0 */ { 0, 0, 0, 0, 0 },
/* U+65d1 */ { 0, 0, 0, 0, 0 },
/* U+65d2 */ { 0, 0, 0, 0, 0 },
/* U+65d3 */ { 0, 0, 0, 0, 0 },
/* U+65d4 */ { 0, 0, 0, 0, 0 },
/* U+65d5 */ { 0, 0, 0, 0, 0 },
/* U+65d6 */ { 0, 0, 0, 0, 0 },
/* U+65d7 */ { 0, 0, 0, 0, 0 },
/* U+65d8 */ { 0, 0, 0, 0, 0 },
/* U+65d9 */ { 0, 0, 0, 0, 0 },
/* U+65da */ { 0, 0, 0, 0, 0 },
/* U+65db */ { 0, 0, 0, 0, 0 },
/* U+65dc */ { 0, 0, 0, 0, 0 },
/* U+65dd */ { 0, 0, 0, 0, 0 },
/* U+65de */ { 0, 0, 0, 0, 0 },
/* U+65df */ { 0, 0, 0, 0, 0 },
/* U+65e0 */ { 0, 0, 0, 0, 0 },
/* U+65e1 */ { 0, 0, 0, 0, 0 },
/* U+65e2 */ { 0, 0, 0, 0, 0 },
/* U+65e3 */ { 0, 0, 0, 0, 0 },
/* U+65e4 */ { 0, 0, 0, 0, 0 },
/* U+65e5 */ { 0, 0, 0, 0, 0 },
/* U+65e6 */ { 0, 0, 0, 0, 0 },
/* U+65e7 */ { 0, 0, 0, 0, 0 },
/* U+65e8 */ { 0, 0, 0, 0, 0 },
/* U+65e9 */ { 0, 0, 0, 0, 0 },
/* U+65ea */ { 0, 0, 0, 0, 0 },
/* U+65eb */ { 0, 0, 0, 0, 0 },
/* U+65ec */ { 0, 0, 0, 0, 0 },
/* U+65ed */ { 0, 0, 0, 0, 0 },
/* U+65ee */ { 0, 0, 0, 0, 0 },
/* U+65ef */ { 0, 0, 0, 0, 0 },
/* U+65f0 */ { 0, 0, 0, 0, 0 },
/* U+65f1 */ { 0, 0, 0, 0, 0 },
/* U+65f2 */ { 0, 0, 0, 0, 0 },
/* U+65f3 */ { 0, 0, 0, 0, 0 },
/* U+65f4 */ { 0, 0, 0, 0, 0 },
/* U+65f5 */ { 0, 0, 0, 0, 0 },
/* U+65f6 */ { 0, 0, 0, 0, 0 },
/* U+65f7 */ { 0, 0, 0, 0, 0 },
/* U+65f8 */ { 0, 0, 0, 0, 0 },
/* U+65f9 */ { 0, 0, 0, 0, 0 },
/* U+65fa */ { 0, 0, 0, 0, 0 },
/* U+65fb */ { 0, 0, 0, 0, 0 },
/* U+65fc */ { 0, 0, 0, 0, 0 },
/* U+65fd */ { 0, 0, 0, 0, 0 },
/* U+65fe */ { 0, 0, 0, 0, 0 },
/* U+65ff */ { 0, 0, 0, 0, 0 },
/* U+6600 */ { 0, 0, 0, 0, 0 },
/* U+6601 */ { 0, 0, 0, 0, 0 },
/* U+6602 */ { 0, 0, 0, 0, 0 },
/* U+6603 */ { 0, 0, 0, 0, 0 },
/* U+6604 */ { 0, 0, 0, 0, 0 },
/* U+6605 */ { 0, 0, 0, 0, 0 },
/* U+6606 */ { 0, 0, 0, 0, 0 },
/* U+6607 */ { 0, 0, 0, 0, 0 },
/* U+6608 */ { 0, 0, 0, 0, 0 },
/* U+6609 */ { 0, 0, 0, 0, 0 },
/* U+660a */ { 0, 0, 0, 0, 0 },
/* U+660b */ { 0, 0, 0, 0, 0 },
/* U+660c */ { 0, 0, 0, 0, 0 },
/* U+660d */ { 0, 0, 0, 0, 0 },
/* U+660e */ { 0, 0, 0, 0, 0 },
/* U+660f */ { 0, 0, 0, 0, 0 },
/* U+6610 */ { 0, 0, 0, 0, 0 },
/* U+6611 */ { 0, 0, 0, 0, 0 },
/* U+6612 */ { 0, 0, 0, 0, 0 },
/* U+6613 */ { 0, 0, 0, 0, 0 },
/* U+6614 */ { 0, 0, 0, 0, 0 },
/* U+6615 */ { 0, 0, 0, 0, 0 },
/* U+6616 */ { 0, 0, 0, 0, 0 },
/* U+6617 */ { 0, 0, 0, 0, 0 },
/* U+6618 */ { 0, 0, 0, 0, 0 },
/* U+6619 */ { 0, 0, 0, 0, 0 },
/* U+661a */ { 0, 0, 0, 0, 0 },
/* U+661b */ { 0, 0, 0, 0, 0 },
/* U+661c */ { 0, 0, 0, 0, 0 },
/* U+661d */ { 0, 0, 0, 0, 0 },
/* U+661e */ { 0, 0, 0, 0, 0 },
/* U+661f */ { 0, 0, 0, 0, 0 },
/* U+6620 */ { 0, 0, 0, 0, 0 },
/* U+6621 */ { 0, 0, 0, 0, 0 },
/* U+6622 */ { 0, 0, 0, 0, 0 },
/* U+6623 */ { 0, 0, 0, 0, 0 },
/* U+6624 */ { 0, 0, 0, 0, 0 },
/* U+6625 */ { 0, 0, 0, 0, 0 },
/* U+6626 */ { 0, 0, 0, 0, 0 },
/* U+6627 */ { 0, 0, 0, 0, 0 },
/* U+6628 */ { 0, 0, 0, 0, 0 },
/* U+6629 */ { 0, 0, 0, 0, 0 },
/* U+662a */ { 0, 0, 0, 0, 0 },
/* U+662b */ { 0, 0, 0, 0, 0 },
/* U+662c */ { 0, 0, 0, 0, 0 },
/* U+662d */ { 0, 0, 0, 0, 0 },
/* U+662e */ { 0, 0, 0, 0, 0 },
/* U+662f */ { 0, 0, 0, 0, 0 },
/* U+6630 */ { 0, 0, 0, 0, 0 },
/* U+6631 */ { 0, 0, 0, 0, 0 },
/* U+6632 */ { 0, 0, 0, 0, 0 },
/* U+6633 */ { 0, 0, 0, 0, 0 },
/* U+6634 */ { 0, 0, 0, 0, 0 },
/* U+6635 */ { 0, 0, 0, 0, 0 },
/* U+6636 */ { 0, 0, 0, 0, 0 },
/* U+6637 */ { 0, 0, 0, 0, 0 },
/* U+6638 */ { 0, 0, 0, 0, 0 },
/* U+6639 */ { 0, 0, 0, 0, 0 },
/* U+663a */ { 0, 0, 0, 0, 0 },
/* U+663b */ { 0, 0, 0, 0, 0 },
/* U+663c */ { 0, 0, 0, 0, 0 },
/* U+663d */ { 0, 0, 0, 0, 0 },
/* U+663e */ { 0, 0, 0, 0, 0 },
/* U+663f */ { 0, 0, 0, 0, 0 },
/* U+6640 */ { 0, 0, 0, 0, 0 },
/* U+6641 */ { 0, 0, 0, 0, 0 },
/* U+6642 */ { 0, 0, 0, 0, 0 },
/* U+6643 */ { 0, 0, 0, 0, 0 },
/* U+6644 */ { 0, 0, 0, 0, 0 },
/* U+6645 */ { 0, 0, 0, 0, 0 },
/* U+6646 */ { 0, 0, 0, 0, 0 },
/* U+6647 */ { 0, 0, 0, 0, 0 },
/* U+6648 */ { 0, 0, 0, 0, 0 },
/* U+6649 */ { 0, 0, 0, 0, 0 },
/* U+664a */ { 0, 0, 0, 0, 0 },
/* U+664b */ { 0, 0, 0, 0, 0 },
/* U+664c */ { 0, 0, 0, 0, 0 },
/* U+664d */ { 0, 0, 0, 0, 0 },
/* U+664e */ { 0, 0, 0, 0, 0 },
/* U+664f */ { 0, 0, 0, 0, 0 },
/* U+6650 */ { 0, 0, 0, 0, 0 },
/* U+6651 */ { 0, 0, 0, 0, 0 },
/* U+6652 */ { 0, 0, 0, 0, 0 },
/* U+6653 */ { 0, 0, 0, 0, 0 },
/* U+6654 */ { 0, 0, 0, 0, 0 },
/* U+6655 */ { 0, 0, 0, 0, 0 },
/* U+6656 */ { 0, 0, 0, 0, 0 },
/* U+6657 */ { 0, 0, 0, 0, 0 },
/* U+6658 */ { 0, 0, 0, 0, 0 },
/* U+6659 */ { 0, 0, 0, 0, 0 },
/* U+665a */ { 0, 0, 0, 0, 0 },
/* U+665b */ { 0, 0, 0, 0, 0 },
/* U+665c */ { 0, 0, 0, 0, 0 },
/* U+665d */ { 0, 0, 0, 0, 0 },
/* U+665e */ { 0, 0, 0, 0, 0 },
/* U+665f */ { 0, 0, 0, 0, 0 },
/* U+6660 */ { 0, 0, 0, 0, 0 },
/* U+6661 */ { 0, 0, 0, 0, 0 },
/* U+6662 */ { 0, 0, 0, 0, 0 },
/* U+6663 */ { 0, 0, 0, 0, 0 },
/* U+6664 */ { 0, 0, 0, 0, 0 },
/* U+6665 */ { 0, 0, 0, 0, 0 },
/* U+6666 */ { 0, 0, 0, 0, 0 },
/* U+6667 */ { 0, 0, 0, 0, 0 },
/* U+6668 */ { 0, 0, 0, 0, 0 },
/* U+6669 */ { 0, 0, 0, 0, 0 },
/* U+666a */ { 0, 0, 0, 0, 0 },
/* U+666b */ { 0, 0, 0, 0, 0 },
/* U+666c */ { 0, 0, 0, 0, 0 },
/* U+666d */ { 0, 0, 0, 0, 0 },
/* U+666e */ { 0, 0, 0, 0, 0 },
/* U+666f */ { 0, 0, 0, 0, 0 },
/* U+6670 */ { 0, 0, 0, 0, 0 },
/* U+6671 */ { 0, 0, 0, 0, 0 },
/* U+6672 */ { 0, 0, 0, 0, 0 },
/* U+6673 */ { 0, 0, 0, 0, 0 },
/* U+6674 */ { 0, 0, 0, 0, 0 },
/* U+6675 */ { 0, 0, 0, 0, 0 },
/* U+6676 */ { 0, 0, 0, 0, 0 },
/* U+6677 */ { 0, 0, 0, 0, 0 },
/* U+6678 */ { 0, 0, 0, 0, 0 },
/* U+6679 */ { 0, 0, 0, 0, 0 },
/* U+667a */ { 0, 0, 0, 0, 0 },
/* U+667b */ { 0, 0, 0, 0, 0 },
/* U+667c */ { 0, 0, 0, 0, 0 },
/* U+667d */ { 0, 0, 0, 0, 0 },
/* U+667e */ { 0, 0, 0, 0, 0 },
/* U+667f */ { 0, 0, 0, 0, 0 },
/* U+6680 */ { 0, 0, 0, 0, 0 },
/* U+6681 */ { 0, 0, 0, 0, 0 },
/* U+6682 */ { 0, 0, 0, 0, 0 },
/* U+6683 */ { 0, 0, 0, 0, 0 },
/* U+6684 */ { 0, 0, 0, 0, 0 },
/* U+6685 */ { 0, 0, 0, 0, 0 },
/* U+6686 */ { 0, 0, 0, 0, 0 },
/* U+6687 */ { 0, 0, 0, 0, 0 },
/* U+6688 */ { 0, 0, 0, 0, 0 },
/* U+6689 */ { 0, 0, 0, 0, 0 },
/* U+668a */ { 0, 0, 0, 0, 0 },
/* U+668b */ { 0, 0, 0, 0, 0 },
/* U+668c */ { 0, 0, 0, 0, 0 },
/* U+668d */ { 0, 0, 0, 0, 0 },
/* U+668e */ { 0, 0, 0, 0, 0 },
/* U+668f */ { 0, 0, 0, 0, 0 },
/* U+6690 */ { 0, 0, 0, 0, 0 },
/* U+6691 */ { 0, 0, 0, 0, 0 },
/* U+6692 */ { 0, 0, 0, 0, 0 },
/* U+6693 */ { 0, 0, 0, 0, 0 },
/* U+6694 */ { 0, 0, 0, 0, 0 },
/* U+6695 */ { 0, 0, 0, 0, 0 },
/* U+6696 */ { 0, 0, 0, 0, 0 },
/* U+6697 */ { 0, 0, 0, 0, 0 },
/* U+6698 */ { 0, 0, 0, 0, 0 },
/* U+6699 */ { 0, 0, 0, 0, 0 },
/* U+669a */ { 0, 0, 0, 0, 0 },
/* U+669b */ { 0, 0, 0, 0, 0 },
/* U+669c */ { 0, 0, 0, 0, 0 },
/* U+669d */ { 0, 0, 0, 0, 0 },
/* U+669e */ { 0, 0, 0, 0, 0 },
/* U+669f */ { 0, 0, 0, 0, 0 },
/* U+66a0 */ { 0, 0, 0, 0, 0 },
/* U+66a1 */ { 0, 0, 0, 0, 0 },
/* U+66a2 */ { 0, 0, 0, 0, 0 },
/* U+66a3 */ { 0, 0, 0, 0, 0 },
/* U+66a4 */ { 0, 0, 0, 0, 0 },
/* U+66a5 */ { 0, 0, 0, 0, 0 },
/* U+66a6 */ { 0, 0, 0, 0, 0 },
/* U+66a7 */ { 0, 0, 0, 0, 0 },
/* U+66a8 */ { 0, 0, 0, 0, 0 },
/* U+66a9 */ { 0, 0, 0, 0, 0 },
/* U+66aa */ { 0, 0, 0, 0, 0 },
/* U+66ab */ { 0, 0, 0, 0, 0 },
/* U+66ac */ { 0, 0, 0, 0, 0 },
/* U+66ad */ { 0, 0, 0, 0, 0 },
/* U+66ae */ { 0, 0, 0, 0, 0 },
/* U+66af */ { 0, 0, 0, 0, 0 },
/* U+66b0 */ { 0, 0, 0, 0, 0 },
/* U+66b1 */ { 0, 0, 0, 0, 0 },
/* U+66b2 */ { 0, 0, 0, 0, 0 },
/* U+66b3 */ { 0, 0, 0, 0, 0 },
/* U+66b4 */ { 0, 0, 0, 0, 0 },
/* U+66b5 */ { 0, 0, 0, 0, 0 },
/* U+66b6 */ { 0, 0, 0, 0, 0 },
/* U+66b7 */ { 0, 0, 0, 0, 0 },
/* U+66b8 */ { 0, 0, 0, 0, 0 },
/* U+66b9 */ { 0, 0, 0, 0, 0 },
/* U+66ba */ { 0, 0, 0, 0, 0 },
/* U+66bb */ { 0, 0, 0, 0, 0 },
/* U+66bc */ { 0, 0, 0, 0, 0 },
/* U+66bd */ { 0, 0, 0, 0, 0 },
/* U+66be */ { 0, 0, 0, 0, 0 },
/* U+66bf */ { 0, 0, 0, 0, 0 },
/* U+66c0 */ { 0, 0, 0, 0, 0 },
/* U+66c1 */ { 0, 0, 0, 0, 0 },
/* U+66c2 */ { 0, 0, 0, 0, 0 },
/* U+66c3 */ { 0, 0, 0, 0, 0 },
/* U+66c4 */ { 0, 0, 0, 0, 0 },
/* U+66c5 */ { 0, 0, 0, 0, 0 },
/* U+66c6 */ { 0, 0, 0, 0, 0 },
/* U+66c7 */ { 0, 0, 0, 0, 0 },
/* U+66c8 */ { 0, 0, 0, 0, 0 },
/* U+66c9 */ { 0, 0, 0, 0, 0 },
/* U+66ca */ { 0, 0, 0, 0, 0 },
/* U+66cb */ { 0, 0, 0, 0, 0 },
/* U+66cc */ { 0, 0, 0, 0, 0 },
/* U+66cd */ { 0, 0, 0, 0, 0 },
/* U+66ce */ { 0, 0, 0, 0, 0 },
/* U+66cf */ { 0, 0, 0, 0, 0 },
/* U+66d0 */ { 0, 0, 0, 0, 0 },
/* U+66d1 */ { 0, 0, 0, 0, 0 },
/* U+66d2 */ { 0, 0, 0, 0, 0 },
/* U+66d3 */ { 0, 0, 0, 0, 0 },
/* U+66d4 */ { 0, 0, 0, 0, 0 },
/* U+66d5 */ { 0, 0, 0, 0, 0 },
/* U+66d6 */ { 0, 0, 0, 0, 0 },
/* U+66d7 */ { 0, 0, 0, 0, 0 },
/* U+66d8 */ { 0, 0, 0, 0, 0 },
/* U+66d9 */ { 0, 0, 0, 0, 0 },
/* U+66da */ { 0, 0, 0, 0, 0 },
/* U+66db */ { 0, 0, 0, 0, 0 },
/* U+66dc */ { 0, 0, 0, 0, 0 },
/* U+66dd */ { 0, 0, 0, 0, 0 },
/* U+66de */ { 0, 0, 0, 0, 0 },
/* U+66df */ { 0, 0, 0, 0, 0 },
/* U+66e0 */ { 0, 0, 0, 0, 0 },
/* U+66e1 */ { 0, 0, 0, 0, 0 },
/* U+66e2 */ { 0, 0, 0, 0, 0 },
/* U+66e3 */ { 0, 0, 0, 0, 0 },
/* U+66e4 */ { 0, 0, 0, 0, 0 },
/* U+66e5 */ { 0, 0, 0, 0, 0 },
/* U+66e6 */ { 0, 0, 0, 0, 0 },
/* U+66e7 */ { 0, 0, 0, 0, 0 },
/* U+66e8 */ { 0, 0, 0, 0, 0 },
/* U+66e9 */ { 0, 0, 0, 0, 0 },
/* U+66ea */ { 0, 0, 0, 0, 0 },
/* U+66eb */ { 0, 0, 0, 0, 0 },
/* U+66ec */ { 0, 0, 0, 0, 0 },
/* U+66ed */ { 0, 0, 0, 0, 0 },
/* U+66ee */ { 0, 0, 0, 0, 0 },
/* U+66ef */ { 0, 0, 0, 0, 0 },
/* U+66f0 */ { 0, 0, 0, 0, 0 },
/* U+66f1 */ { 0, 0, 0, 0, 0 },
/* U+66f2 */ { 0, 0, 0, 0, 0 },
/* U+66f3 */ { 0, 0, 0, 0, 0 },
/* U+66f4 */ { 0, 0, 0, 0, 0 },
/* U+66f5 */ { 0, 0, 0, 0, 0 },
/* U+66f6 */ { 0, 0, 0, 0, 0 },
/* U+66f7 */ { 0, 0, 0, 0, 0 },
/* U+66f8 */ { 0, 0, 0, 0, 0 },
/* U+66f9 */ { 0, 0, 0, 0, 0 },
/* U+66fa */ { 0, 0, 0, 0, 0 },
/* U+66fb */ { 0, 0, 0, 0, 0 },
/* U+66fc */ { 0, 0, 0, 0, 0 },
/* U+66fd */ { 0, 0, 0, 0, 0 },
/* U+66fe */ { 0, 0, 0, 0, 0 },
/* U+66ff */ { 0, 0, 0, 0, 0 },
/* U+6700 */ { 0, 0, 0, 0, 0 },
/* U+6701 */ { 0, 0, 0, 0, 0 },
/* U+6702 */ { 0, 0, 0, 0, 0 },
/* U+6703 */ { 0, 0, 0, 0, 0 },
/* U+6704 */ { 0, 0, 0, 0, 0 },
/* U+6705 */ { 0, 0, 0, 0, 0 },
/* U+6706 */ { 0, 0, 0, 0, 0 },
/* U+6707 */ { 0, 0, 0, 0, 0 },
/* U+6708 */ { 0, 0, 0, 0, 0 },
/* U+6709 */ { 0, 0, 0, 0, 0 },
/* U+670a */ { 0, 0, 0, 0, 0 },
/* U+670b */ { 0, 0, 0, 0, 0 },
/* U+670c */ { 0, 0, 0, 0, 0 },
/* U+670d */ { 0, 0, 0, 0, 0 },
/* U+670e */ { 0, 0, 0, 0, 0 },
/* U+670f */ { 0, 0, 0, 0, 0 },
/* U+6710 */ { 0, 0, 0, 0, 0 },
/* U+6711 */ { 0, 0, 0, 0, 0 },
/* U+6712 */ { 0, 0, 0, 0, 0 },
/* U+6713 */ { 0, 0, 0, 0, 0 },
/* U+6714 */ { 0, 0, 0, 0, 0 },
/* U+6715 */ { 0, 0, 0, 0, 0 },
/* U+6716 */ { 0, 0, 0, 0, 0 },
/* U+6717 */ { 0, 0, 0, 0, 0 },
/* U+6718 */ { 0, 0, 0, 0, 0 },
/* U+6719 */ { 0, 0, 0, 0, 0 },
/* U+671a */ { 0, 0, 0, 0, 0 },
/* U+671b */ { 0, 0, 0, 0, 0 },
/* U+671c */ { 0, 0, 0, 0, 0 },
/* U+671d */ { 0, 0, 0, 0, 0 },
/* U+671e */ { 0, 0, 0, 0, 0 },
/* U+671f */ { 0, 0, 0, 0, 0 },
/* U+6720 */ { 0, 0, 0, 0, 0 },
/* U+6721 */ { 0, 0, 0, 0, 0 },
/* U+6722 */ { 0, 0, 0, 0, 0 },
/* U+6723 */ { 0, 0, 0, 0, 0 },
/* U+6724 */ { 0, 0, 0, 0, 0 },
/* U+6725 */ { 0, 0, 0, 0, 0 },
/* U+6726 */ { 0, 0, 0, 0, 0 },
/* U+6727 */ { 0, 0, 0, 0, 0 },
/* U+6728 */ { 0, 0, 0, 0, 0 },
/* U+6729 */ { 0, 0, 0, 0, 0 },
/* U+672a */ { 0, 0, 0, 0, 0 },
/* U+672b */ { 0, 0, 0, 0, 0 },
/* U+672c */ { 0, 0, 0, 0, 0 },
/* U+672d */ { 0, 0, 0, 0, 0 },
/* U+672e */ { 0, 0, 0, 0, 0 },
/* U+672f */ { 0, 0, 0, 0, 0 },
/* U+6730 */ { 0, 0, 0, 0, 0 },
/* U+6731 */ { 0, 0, 0, 0, 0 },
/* U+6732 */ { 0, 0, 0, 0, 0 },
/* U+6733 */ { 0, 0, 0, 0, 0 },
/* U+6734 */ { 0, 0, 0, 0, 0 },
/* U+6735 */ { 0, 0, 0, 0, 0 },
/* U+6736 */ { 0, 0, 0, 0, 0 },
/* U+6737 */ { 0, 0, 0, 0, 0 },
/* U+6738 */ { 0, 0, 0, 0, 0 },
/* U+6739 */ { 0, 0, 0, 0, 0 },
/* U+673a */ { 0, 0, 0, 0, 0 },
/* U+673b */ { 0, 0, 0, 0, 0 },
/* U+673c */ { 0, 0, 0, 0, 0 },
/* U+673d */ { 0, 0, 0, 0, 0 },
/* U+673e */ { 0, 0, 0, 0, 0 },
/* U+673f */ { 0, 0, 0, 0, 0 },
/* U+6740 */ { 0, 0, 0, 0, 0 },
/* U+6741 */ { 0, 0, 0, 0, 0 },
/* U+6742 */ { 0, 0, 0, 0, 0 },
/* U+6743 */ { 0, 0, 0, 0, 0 },
/* U+6744 */ { 0, 0, 0, 0, 0 },
/* U+6745 */ { 0, 0, 0, 0, 0 },
/* U+6746 */ { 0, 0, 0, 0, 0 },
/* U+6747 */ { 0, 0, 0, 0, 0 },
/* U+6748 */ { 0, 0, 0, 0, 0 },
/* U+6749 */ { 0, 0, 0, 0, 0 },
/* U+674a */ { 0, 0, 0, 0, 0 },
/* U+674b */ { 0, 0, 0, 0, 0 },
/* U+674c */ { 0, 0, 0, 0, 0 },
/* U+674d */ { 0, 0, 0, 0, 0 },
/* U+674e */ { 0, 0, 0, 0, 0 },
/* U+674f */ { 0, 0, 0, 0, 0 },
/* U+6750 */ { 0, 0, 0, 0, 0 },
/* U+6751 */ { 0, 0, 0, 0, 0 },
/* U+6752 */ { 0, 0, 0, 0, 0 },
/* U+6753 */ { 0, 0, 0, 0, 0 },
/* U+6754 */ { 0, 0, 0, 0, 0 },
/* U+6755 */ { 0, 0, 0, 0, 0 },
/* U+6756 */ { 0, 0, 0, 0, 0 },
/* U+6757 */ { 0, 0, 0, 0, 0 },
/* U+6758 */ { 0, 0, 0, 0, 0 },
/* U+6759 */ { 0, 0, 0, 0, 0 },
/* U+675a */ { 0, 0, 0, 0, 0 },
/* U+675b */ { 0, 0, 0, 0, 0 },
/* U+675c */ { 0, 0, 0, 0, 0 },
/* U+675d */ { 0, 0, 0, 0, 0 },
/* U+675e */ { 0, 0, 0, 0, 0 },
/* U+675f */ { 0, 0, 0, 0, 0 },
/* U+6760 */ { 0, 0, 0, 0, 0 },
/* U+6761 */ { 0, 0, 0, 0, 0 },
/* U+6762 */ { 0, 0, 0, 0, 0 },
/* U+6763 */ { 0, 0, 0, 0, 0 },
/* U+6764 */ { 0, 0, 0, 0, 0 },
/* U+6765 */ { 0, 0, 0, 0, 0 },
/* U+6766 */ { 0, 0, 0, 0, 0 },
/* U+6767 */ { 0, 0, 0, 0, 0 },
/* U+6768 */ { 0, 0, 0, 0, 0 },
/* U+6769 */ { 0, 0, 0, 0, 0 },
/* U+676a */ { 0, 0, 0, 0, 0 },
/* U+676b */ { 0, 0, 0, 0, 0 },
/* U+676c */ { 0, 0, 0, 0, 0 },
/* U+676d */ { 0, 0, 0, 0, 0 },
/* U+676e */ { 0, 0, 0, 0, 0 },
/* U+676f */ { 0, 0, 0, 0, 0 },
/* U+6770 */ { 0, 0, 0, 0, 0 },
/* U+6771 */ { 0, 0, 0, 0, 0 },
/* U+6772 */ { 0, 0, 0, 0, 0 },
/* U+6773 */ { 0, 0, 0, 0, 0 },
/* U+6774 */ { 0, 0, 0, 0, 0 },
/* U+6775 */ { 0, 0, 0, 0, 0 },
/* U+6776 */ { 0, 0, 0, 0, 0 },
/* U+6777 */ { 0, 0, 0, 0, 0 },
/* U+6778 */ { 0, 0, 0, 0, 0 },
/* U+6779 */ { 0, 0, 0, 0, 0 },
/* U+677a */ { 0, 0, 0, 0, 0 },
/* U+677b */ { 0, 0, 0, 0, 0 },
/* U+677c */ { 0, 0, 0, 0, 0 },
/* U+677d */ { 0, 0, 0, 0, 0 },
/* U+677e */ { 0, 0, 0, 0, 0 },
/* U+677f */ { 0, 0, 0, 0, 0 },
/* U+6780 */ { 0, 0, 0, 0, 0 },
/* U+6781 */ { 0, 0, 0, 0, 0 },
/* U+6782 */ { 0, 0, 0, 0, 0 },
/* U+6783 */ { 0, 0, 0, 0, 0 },
/* U+6784 */ { 0, 0, 0, 0, 0 },
/* U+6785 */ { 0, 0, 0, 0, 0 },
/* U+6786 */ { 0, 0, 0, 0, 0 },
/* U+6787 */ { 0, 0, 0, 0, 0 },
/* U+6788 */ { 0, 0, 0, 0, 0 },
/* U+6789 */ { 0, 0, 0, 0, 0 },
/* U+678a */ { 0, 0, 0, 0, 0 },
/* U+678b */ { 0, 0, 0, 0, 0 },
/* U+678c */ { 0, 0, 0, 0, 0 },
/* U+678d */ { 0, 0, 0, 0, 0 },
/* U+678e */ { 0, 0, 0, 0, 0 },
/* U+678f */ { 0, 0, 0, 0, 0 },
/* U+6790 */ { 0, 0, 0, 0, 0 },
/* U+6791 */ { 0, 0, 0, 0, 0 },
/* U+6792 */ { 0, 0, 0, 0, 0 },
/* U+6793 */ { 0, 0, 0, 0, 0 },
/* U+6794 */ { 0, 0, 0, 0, 0 },
/* U+6795 */ { 0, 0, 0, 0, 0 },
/* U+6796 */ { 0, 0, 0, 0, 0 },
/* U+6797 */ { 0, 0, 0, 0, 0 },
/* U+6798 */ { 0, 0, 0, 0, 0 },
/* U+6799 */ { 0, 0, 0, 0, 0 },
/* U+679a */ { 0, 0, 0, 0, 0 },
/* U+679b */ { 0, 0, 0, 0, 0 },
/* U+679c */ { 0, 0, 0, 0, 0 },
/* U+679d */ { 0, 0, 0, 0, 0 },
/* U+679e */ { 0, 0, 0, 0, 0 },
/* U+679f */ { 0, 0, 0, 0, 0 },
/* U+67a0 */ { 0, 0, 0, 0, 0 },
/* U+67a1 */ { 0, 0, 0, 0, 0 },
/* U+67a2 */ { 0, 0, 0, 0, 0 },
/* U+67a3 */ { 0, 0, 0, 0, 0 },
/* U+67a4 */ { 0, 0, 0, 0, 0 },
/* U+67a5 */ { 0, 0, 0, 0, 0 },
/* U+67a6 */ { 0, 0, 0, 0, 0 },
/* U+67a7 */ { 0, 0, 0, 0, 0 },
/* U+67a8 */ { 0, 0, 0, 0, 0 },
/* U+67a9 */ { 0, 0, 0, 0, 0 },
/* U+67aa */ { 0, 0, 0, 0, 0 },
/* U+67ab */ { 0, 0, 0, 0, 0 },
/* U+67ac */ { 0, 0, 0, 0, 0 },
/* U+67ad */ { 0, 0, 0, 0, 0 },
/* U+67ae */ { 0, 0, 0, 0, 0 },
/* U+67af */ { 0, 0, 0, 0, 0 },
/* U+67b0 */ { 0, 0, 0, 0, 0 },
/* U+67b1 */ { 0, 0, 0, 0, 0 },
/* U+67b2 */ { 0, 0, 0, 0, 0 },
/* U+67b3 */ { 0, 0, 0, 0, 0 },
/* U+67b4 */ { 0, 0, 0, 0, 0 },
/* U+67b5 */ { 0, 0, 0, 0, 0 },
/* U+67b6 */ { 0, 0, 0, 0, 0 },
/* U+67b7 */ { 0, 0, 0, 0, 0 },
/* U+67b8 */ { 0, 0, 0, 0, 0 },
/* U+67b9 */ { 0, 0, 0, 0, 0 },
/* U+67ba */ { 0, 0, 0, 0, 0 },
/* U+67bb */ { 0, 0, 0, 0, 0 },
/* U+67bc */ { 0, 0, 0, 0, 0 },
/* U+67bd */ { 0, 0, 0, 0, 0 },
/* U+67be */ { 0, 0, 0, 0, 0 },
/* U+67bf */ { 0, 0, 0, 0, 0 },
/* U+67c0 */ { 0, 0, 0, 0, 0 },
/* U+67c1 */ { 0, 0, 0, 0, 0 },
/* U+67c2 */ { 0, 0, 0, 0, 0 },
/* U+67c3 */ { 0, 0, 0, 0, 0 },
/* U+67c4 */ { 0, 0, 0, 0, 0 },
/* U+67c5 */ { 0, 0, 0, 0, 0 },
/* U+67c6 */ { 0, 0, 0, 0, 0 },
/* U+67c7 */ { 0, 0, 0, 0, 0 },
/* U+67c8 */ { 0, 0, 0, 0, 0 },
/* U+67c9 */ { 0, 0, 0, 0, 0 },
/* U+67ca */ { 0, 0, 0, 0, 0 },
/* U+67cb */ { 0, 0, 0, 0, 0 },
/* U+67cc */ { 0, 0, 0, 0, 0 },
/* U+67cd */ { 0, 0, 0, 0, 0 },
/* U+67ce */ { 0, 0, 0, 0, 0 },
/* U+67cf */ { 0, 0, 0, 0, 0 },
/* U+67d0 */ { 0, 0, 0, 0, 0 },
/* U+67d1 */ { 0, 0, 0, 0, 0 },
/* U+67d2 */ { 0, 0, 0, 0, 0 },
/* U+67d3 */ { 0, 0, 0, 0, 0 },
/* U+67d4 */ { 0, 0, 0, 0, 0 },
/* U+67d5 */ { 0, 0, 0, 0, 0 },
/* U+67d6 */ { 0, 0, 0, 0, 0 },
/* U+67d7 */ { 0, 0, 0, 0, 0 },
/* U+67d8 */ { 0, 0, 0, 0, 0 },
/* U+67d9 */ { 0, 0, 0, 0, 0 },
/* U+67da */ { 0, 0, 0, 0, 0 },
/* U+67db */ { 0, 0, 0, 0, 0 },
/* U+67dc */ { 0, 0, 0, 0, 0 },
/* U+67dd */ { 0, 0, 0, 0, 0 },
/* U+67de */ { 0, 0, 0, 0, 0 },
/* U+67df */ { 0, 0, 0, 0, 0 },
/* U+67e0 */ { 0, 0, 0, 0, 0 },
/* U+67e1 */ { 0, 0, 0, 0, 0 },
/* U+67e2 */ { 0, 0, 0, 0, 0 },
/* U+67e3 */ { 0, 0, 0, 0, 0 },
/* U+67e4 */ { 0, 0, 0, 0, 0 },
/* U+67e5 */ { 0, 0, 0, 0, 0 },
/* U+67e6 */ { 0, 0, 0, 0, 0 },
/* U+67e7 */ { 0, 0, 0, 0, 0 },
/* U+67e8 */ { 0, 0, 0, 0, 0 },
/* U+67e9 */ { 0, 0, 0, 0, 0 },
/* U+67ea */ { 0, 0, 0, 0, 0 },
/* U+67eb */ { 0, 0, 0, 0, 0 },
/* U+67ec */ { 0, 0, 0, 0, 0 },
/* U+67ed */ { 0, 0, 0, 0, 0 },
/* U+67ee */ { 0, 0, 0, 0, 0 },
/* U+67ef */ { 0, 0, 0, 0, 0 },
/* U+67f0 */ { 0, 0, 0, 0, 0 },
/* U+67f1 */ { 0, 0, 0, 0, 0 },
/* U+67f2 */ { 0, 0, 0, 0, 0 },
/* U+67f3 */ { 0, 0, 0, 0, 0 },
/* U+67f4 */ { 0, 0, 0, 0, 0 },
/* U+67f5 */ { 0, 0, 0, 0, 0 },
/* U+67f6 */ { 0, 0, 0, 0, 0 },
/* U+67f7 */ { 0, 0, 0, 0, 0 },
/* U+67f8 */ { 0, 0, 0, 0, 0 },
/* U+67f9 */ { 0, 0, 0, 0, 0 },
/* U+67fa */ { 0, 0, 0, 0, 0 },
/* U+67fb */ { 0, 0, 0, 0, 0 },
/* U+67fc */ { 0, 0, 0, 0, 0 },
/* U+67fd */ { 0, 0, 0, 0, 0 },
/* U+67fe */ { 0, 0, 0, 0, 0 },
/* U+67ff */ { 0, 0, 0, 0, 0 },
/* U+6800 */ { 0, 0, 0, 0, 0 },
/* U+6801 */ { 0, 0, 0, 0, 0 },
/* U+6802 */ { 0, 0, 0, 0, 0 },
/* U+6803 */ { 0, 0, 0, 0, 0 },
/* U+6804 */ { 0, 0, 0, 0, 0 },
/* U+6805 */ { 0, 0, 0, 0, 0 },
/* U+6806 */ { 0, 0, 0, 0, 0 },
/* U+6807 */ { 0, 0, 0, 0, 0 },
/* U+6808 */ { 0, 0, 0, 0, 0 },
/* U+6809 */ { 0, 0, 0, 0, 0 },
/* U+680a */ { 0, 0, 0, 0, 0 },
/* U+680b */ { 0, 0, 0, 0, 0 },
/* U+680c */ { 0, 0, 0, 0, 0 },
/* U+680d */ { 0, 0, 0, 0, 0 },
/* U+680e */ { 0, 0, 0, 0, 0 },
/* U+680f */ { 0, 0, 0, 0, 0 },
/* U+6810 */ { 0, 0, 0, 0, 0 },
/* U+6811 */ { 0, 0, 0, 0, 0 },
/* U+6812 */ { 0, 0, 0, 0, 0 },
/* U+6813 */ { 0, 0, 0, 0, 0 },
/* U+6814 */ { 0, 0, 0, 0, 0 },
/* U+6815 */ { 0, 0, 0, 0, 0 },
/* U+6816 */ { 0, 0, 0, 0, 0 },
/* U+6817 */ { 0, 0, 0, 0, 0 },
/* U+6818 */ { 0, 0, 0, 0, 0 },
/* U+6819 */ { 0, 0, 0, 0, 0 },
/* U+681a */ { 0, 0, 0, 0, 0 },
/* U+681b */ { 0, 0, 0, 0, 0 },
/* U+681c */ { 0, 0, 0, 0, 0 },
/* U+681d */ { 0, 0, 0, 0, 0 },
/* U+681e */ { 0, 0, 0, 0, 0 },
/* U+681f */ { 0, 0, 0, 0, 0 },
/* U+6820 */ { 0, 0, 0, 0, 0 },
/* U+6821 */ { 0, 0, 0, 0, 0 },
/* U+6822 */ { 0, 0, 0, 0, 0 },
/* U+6823 */ { 0, 0, 0, 0, 0 },
/* U+6824 */ { 0, 0, 0, 0, 0 },
/* U+6825 */ { 0, 0, 0, 0, 0 },
/* U+6826 */ { 0, 0, 0, 0, 0 },
/* U+6827 */ { 0, 0, 0, 0, 0 },
/* U+6828 */ { 0, 0, 0, 0, 0 },
/* U+6829 */ { 0, 0, 0, 0, 0 },
/* U+682a */ { 0, 0, 0, 0, 0 },
/* U+682b */ { 0, 0, 0, 0, 0 },
/* U+682c */ { 0, 0, 0, 0, 0 },
/* U+682d */ { 0, 0, 0, 0, 0 },
/* U+682e */ { 0, 0, 0, 0, 0 },
/* U+682f */ { 0, 0, 0, 0, 0 },
/* U+6830 */ { 0, 0, 0, 0, 0 },
/* U+6831 */ { 0, 0, 0, 0, 0 },
/* U+6832 */ { 0, 0, 0, 0, 0 },
/* U+6833 */ { 0, 0, 0, 0, 0 },
/* U+6834 */ { 0, 0, 0, 0, 0 },
/* U+6835 */ { 0, 0, 0, 0, 0 },
/* U+6836 */ { 0, 0, 0, 0, 0 },
/* U+6837 */ { 0, 0, 0, 0, 0 },
/* U+6838 */ { 0, 0, 0, 0, 0 },
/* U+6839 */ { 0, 0, 0, 0, 0 },
/* U+683a */ { 0, 0, 0, 0, 0 },
/* U+683b */ { 0, 0, 0, 0, 0 },
/* U+683c */ { 0, 0, 0, 0, 0 },
/* U+683d */ { 0, 0, 0, 0, 0 },
/* U+683e */ { 0, 0, 0, 0, 0 },
/* U+683f */ { 0, 0, 0, 0, 0 },
/* U+6840 */ { 0, 0, 0, 0, 0 },
/* U+6841 */ { 0, 0, 0, 0, 0 },
/* U+6842 */ { 0, 0, 0, 0, 0 },
/* U+6843 */ { 0, 0, 0, 0, 0 },
/* U+6844 */ { 0, 0, 0, 0, 0 },
/* U+6845 */ { 0, 0, 0, 0, 0 },
/* U+6846 */ { 0, 0, 0, 0, 0 },
/* U+6847 */ { 0, 0, 0, 0, 0 },
/* U+6848 */ { 0, 0, 0, 0, 0 },
/* U+6849 */ { 0, 0, 0, 0, 0 },
/* U+684a */ { 0, 0, 0, 0, 0 },
/* U+684b */ { 0, 0, 0, 0, 0 },
/* U+684c */ { 0, 0, 0, 0, 0 },
/* U+684d */ { 0, 0, 0, 0, 0 },
/* U+684e */ { 0, 0, 0, 0, 0 },
/* U+684f */ { 0, 0, 0, 0, 0 },
/* U+6850 */ { 0, 0, 0, 0, 0 },
/* U+6851 */ { 0, 0, 0, 0, 0 },
/* U+6852 */ { 0, 0, 0, 0, 0 },
/* U+6853 */ { 0, 0, 0, 0, 0 },
/* U+6854 */ { 0, 0, 0, 0, 0 },
/* U+6855 */ { 0, 0, 0, 0, 0 },
/* U+6856 */ { 0, 0, 0, 0, 0 },
/* U+6857 */ { 0, 0, 0, 0, 0 },
/* U+6858 */ { 0, 0, 0, 0, 0 },
/* U+6859 */ { 0, 0, 0, 0, 0 },
/* U+685a */ { 0, 0, 0, 0, 0 },
/* U+685b */ { 0, 0, 0, 0, 0 },
/* U+685c */ { 0, 0, 0, 0, 0 },
/* U+685d */ { 0, 0, 0, 0, 0 },
/* U+685e */ { 0, 0, 0, 0, 0 },
/* U+685f */ { 0, 0, 0, 0, 0 },
/* U+6860 */ { 0, 0, 0, 0, 0 },
/* U+6861 */ { 0, 0, 0, 0, 0 },
/* U+6862 */ { 0, 0, 0, 0, 0 },
/* U+6863 */ { 0, 0, 0, 0, 0 },
/* U+6864 */ { 0, 0, 0, 0, 0 },
/* U+6865 */ { 0, 0, 0, 0, 0 },
/* U+6866 */ { 0, 0, 0, 0, 0 },
/* U+6867 */ { 0, 0, 0, 0, 0 },
/* U+6868 */ { 0, 0, 0, 0, 0 },
/* U+6869 */ { 0, 0, 0, 0, 0 },
/* U+686a */ { 0, 0, 0, 0, 0 },
/* U+686b */ { 0, 0, 0, 0, 0 },
/* U+686c */ { 0, 0, 0, 0, 0 },
/* U+686d */ { 0, 0, 0, 0, 0 },
/* U+686e */ { 0, 0, 0, 0, 0 },
/* U+686f */ { 0, 0, 0, 0, 0 },
/* U+6870 */ { 0, 0, 0, 0, 0 },
/* U+6871 */ { 0, 0, 0, 0, 0 },
/* U+6872 */ { 0, 0, 0, 0, 0 },
/* U+6873 */ { 0, 0, 0, 0, 0 },
/* U+6874 */ { 0, 0, 0, 0, 0 },
/* U+6875 */ { 0, 0, 0, 0, 0 },
/* U+6876 */ { 0, 0, 0, 0, 0 },
/* U+6877 */ { 0, 0, 0, 0, 0 },
/* U+6878 */ { 0, 0, 0, 0, 0 },
/* U+6879 */ { 0, 0, 0, 0, 0 },
/* U+687a */ { 0, 0, 0, 0, 0 },
/* U+687b */ { 0, 0, 0, 0, 0 },
/* U+687c */ { 0, 0, 0, 0, 0 },
/* U+687d */ { 0, 0, 0, 0, 0 },
/* U+687e */ { 0, 0, 0, 0, 0 },
/* U+687f */ { 0, 0, 0, 0, 0 },
/* U+6880 */ { 0, 0, 0, 0, 0 },
/* U+6881 */ { 0, 0, 0, 0, 0 },
/* U+6882 */ { 0, 0, 0, 0, 0 },
/* U+6883 */ { 0, 0, 0, 0, 0 },
/* U+6884 */ { 0, 0, 0, 0, 0 },
/* U+6885 */ { 0, 0, 0, 0, 0 },
/* U+6886 */ { 0, 0, 0, 0, 0 },
/* U+6887 */ { 0, 0, 0, 0, 0 },
/* U+6888 */ { 0, 0, 0, 0, 0 },
/* U+6889 */ { 0, 0, 0, 0, 0 },
/* U+688a */ { 0, 0, 0, 0, 0 },
/* U+688b */ { 0, 0, 0, 0, 0 },
/* U+688c */ { 0, 0, 0, 0, 0 },
/* U+688d */ { 0, 0, 0, 0, 0 },
/* U+688e */ { 0, 0, 0, 0, 0 },
/* U+688f */ { 0, 0, 0, 0, 0 },
/* U+6890 */ { 0, 0, 0, 0, 0 },
/* U+6891 */ { 0, 0, 0, 0, 0 },
/* U+6892 */ { 0, 0, 0, 0, 0 },
/* U+6893 */ { 0, 0, 0, 0, 0 },
/* U+6894 */ { 0, 0, 0, 0, 0 },
/* U+6895 */ { 0, 0, 0, 0, 0 },
/* U+6896 */ { 0, 0, 0, 0, 0 },
/* U+6897 */ { 0, 0, 0, 0, 0 },
/* U+6898 */ { 0, 0, 0, 0, 0 },
/* U+6899 */ { 0, 0, 0, 0, 0 },
/* U+689a */ { 0, 0, 0, 0, 0 },
/* U+689b */ { 0, 0, 0, 0, 0 },
/* U+689c */ { 0, 0, 0, 0, 0 },
/* U+689d */ { 0, 0, 0, 0, 0 },
/* U+689e */ { 0, 0, 0, 0, 0 },
/* U+689f */ { 0, 0, 0, 0, 0 },
/* U+68a0 */ { 0, 0, 0, 0, 0 },
/* U+68a1 */ { 0, 0, 0, 0, 0 },
/* U+68a2 */ { 0, 0, 0, 0, 0 },
/* U+68a3 */ { 0, 0, 0, 0, 0 },
/* U+68a4 */ { 0, 0, 0, 0, 0 },
/* U+68a5 */ { 0, 0, 0, 0, 0 },
/* U+68a6 */ { 0, 0, 0, 0, 0 },
/* U+68a7 */ { 0, 0, 0, 0, 0 },
/* U+68a8 */ { 0, 0, 0, 0, 0 },
/* U+68a9 */ { 0, 0, 0, 0, 0 },
/* U+68aa */ { 0, 0, 0, 0, 0 },
/* U+68ab */ { 0, 0, 0, 0, 0 },
/* U+68ac */ { 0, 0, 0, 0, 0 },
/* U+68ad */ { 0, 0, 0, 0, 0 },
/* U+68ae */ { 0, 0, 0, 0, 0 },
/* U+68af */ { 0, 0, 0, 0, 0 },
/* U+68b0 */ { 0, 0, 0, 0, 0 },
/* U+68b1 */ { 0, 0, 0, 0, 0 },
/* U+68b2 */ { 0, 0, 0, 0, 0 },
/* U+68b3 */ { 0, 0, 0, 0, 0 },
/* U+68b4 */ { 0, 0, 0, 0, 0 },
/* U+68b5 */ { 0, 0, 0, 0, 0 },
/* U+68b6 */ { 0, 0, 0, 0, 0 },
/* U+68b7 */ { 0, 0, 0, 0, 0 },
/* U+68b8 */ { 0, 0, 0, 0, 0 },
/* U+68b9 */ { 0, 0, 0, 0, 0 },
/* U+68ba */ { 0, 0, 0, 0, 0 },
/* U+68bb */ { 0, 0, 0, 0, 0 },
/* U+68bc */ { 0, 0, 0, 0, 0 },
/* U+68bd */ { 0, 0, 0, 0, 0 },
/* U+68be */ { 0, 0, 0, 0, 0 },
/* U+68bf */ { 0, 0, 0, 0, 0 },
/* U+68c0 */ { 0, 0, 0, 0, 0 },
/* U+68c1 */ { 0, 0, 0, 0, 0 },
/* U+68c2 */ { 0, 0, 0, 0, 0 },
/* U+68c3 */ { 0, 0, 0, 0, 0 },
/* U+68c4 */ { 0, 0, 0, 0, 0 },
/* U+68c5 */ { 0, 0, 0, 0, 0 },
/* U+68c6 */ { 0, 0, 0, 0, 0 },
/* U+68c7 */ { 0, 0, 0, 0, 0 },
/* U+68c8 */ { 0, 0, 0, 0, 0 },
/* U+68c9 */ { 0, 0, 0, 0, 0 },
/* U+68ca */ { 0, 0, 0, 0, 0 },
/* U+68cb */ { 0, 0, 0, 0, 0 },
/* U+68cc */ { 0, 0, 0, 0, 0 },
/* U+68cd */ { 0, 0, 0, 0, 0 },
/* U+68ce */ { 0, 0, 0, 0, 0 },
/* U+68cf */ { 0, 0, 0, 0, 0 },
/* U+68d0 */ { 0, 0, 0, 0, 0 },
/* U+68d1 */ { 0, 0, 0, 0, 0 },
/* U+68d2 */ { 0, 0, 0, 0, 0 },
/* U+68d3 */ { 0, 0, 0, 0, 0 },
/* U+68d4 */ { 0, 0, 0, 0, 0 },
/* U+68d5 */ { 0, 0, 0, 0, 0 },
/* U+68d6 */ { 0, 0, 0, 0, 0 },
/* U+68d7 */ { 0, 0, 0, 0, 0 },
/* U+68d8 */ { 0, 0, 0, 0, 0 },
/* U+68d9 */ { 0, 0, 0, 0, 0 },
/* U+68da */ { 0, 0, 0, 0, 0 },
/* U+68db */ { 0, 0, 0, 0, 0 },
/* U+68dc */ { 0, 0, 0, 0, 0 },
/* U+68dd */ { 0, 0, 0, 0, 0 },
/* U+68de */ { 0, 0, 0, 0, 0 },
/* U+68df */ { 0, 0, 0, 0, 0 },
/* U+68e0 */ { 0, 0, 0, 0, 0 },
/* U+68e1 */ { 0, 0, 0, 0, 0 },
/* U+68e2 */ { 0, 0, 0, 0, 0 },
/* U+68e3 */ { 0, 0, 0, 0, 0 },
/* U+68e4 */ { 0, 0, 0, 0, 0 },
/* U+68e5 */ { 0, 0, 0, 0, 0 },
/* U+68e6 */ { 0, 0, 0, 0, 0 },
/* U+68e7 */ { 0, 0, 0, 0, 0 },
/* U+68e8 */ { 0, 0, 0, 0, 0 },
/* U+68e9 */ { 0, 0, 0, 0, 0 },
/* U+68ea */ { 0, 0, 0, 0, 0 },
/* U+68eb */ { 0, 0, 0, 0, 0 },
/* U+68ec */ { 0, 0, 0, 0, 0 },
/* U+68ed */ { 0, 0, 0, 0, 0 },
/* U+68ee */ { 0, 0, 0, 0, 0 },
/* U+68ef */ { 0, 0, 0, 0, 0 },
/* U+68f0 */ { 0, 0, 0, 0, 0 },
/* U+68f1 */ { 0, 0, 0, 0, 0 },
/* U+68f2 */ { 0, 0, 0, 0, 0 },
/* U+68f3 */ { 0, 0, 0, 0, 0 },
/* U+68f4 */ { 0, 0, 0, 0, 0 },
/* U+68f5 */ { 0, 0, 0, 0, 0 },
/* U+68f6 */ { 0, 0, 0, 0, 0 },
/* U+68f7 */ { 0, 0, 0, 0, 0 },
/* U+68f8 */ { 0, 0, 0, 0, 0 },
/* U+68f9 */ { 0, 0, 0, 0, 0 },
/* U+68fa */ { 0, 0, 0, 0, 0 },
/* U+68fb */ { 0, 0, 0, 0, 0 },
/* U+68fc */ { 0, 0, 0, 0, 0 },
/* U+68fd */ { 0, 0, 0, 0, 0 },
/* U+68fe */ { 0, 0, 0, 0, 0 },
/* U+68ff */ { 0, 0, 0, 0, 0 },
/* U+6900 */ { 0, 0, 0, 0, 0 },
/* U+6901 */ { 0, 0, 0, 0, 0 },
/* U+6902 */ { 0, 0, 0, 0, 0 },
/* U+6903 */ { 0, 0, 0, 0, 0 },
/* U+6904 */ { 0, 0, 0, 0, 0 },
/* U+6905 */ { 0, 0, 0, 0, 0 },
/* U+6906 */ { 0, 0, 0, 0, 0 },
/* U+6907 */ { 0, 0, 0, 0, 0 },
/* U+6908 */ { 0, 0, 0, 0, 0 },
/* U+6909 */ { 0, 0, 0, 0, 0 },
/* U+690a */ { 0, 0, 0, 0, 0 },
/* U+690b */ { 0, 0, 0, 0, 0 },
/* U+690c */ { 0, 0, 0, 0, 0 },
/* U+690d */ { 0, 0, 0, 0, 0 },
/* U+690e */ { 0, 0, 0, 0, 0 },
/* U+690f */ { 0, 0, 0, 0, 0 },
/* U+6910 */ { 0, 0, 0, 0, 0 },
/* U+6911 */ { 0, 0, 0, 0, 0 },
/* U+6912 */ { 0, 0, 0, 0, 0 },
/* U+6913 */ { 0, 0, 0, 0, 0 },
/* U+6914 */ { 0, 0, 0, 0, 0 },
/* U+6915 */ { 0, 0, 0, 0, 0 },
/* U+6916 */ { 0, 0, 0, 0, 0 },
/* U+6917 */ { 0, 0, 0, 0, 0 },
/* U+6918 */ { 0, 0, 0, 0, 0 },
/* U+6919 */ { 0, 0, 0, 0, 0 },
/* U+691a */ { 0, 0, 0, 0, 0 },
/* U+691b */ { 0, 0, 0, 0, 0 },
/* U+691c */ { 0, 0, 0, 0, 0 },
/* U+691d */ { 0, 0, 0, 0, 0 },
/* U+691e */ { 0, 0, 0, 0, 0 },
/* U+691f */ { 0, 0, 0, 0, 0 },
/* U+6920 */ { 0, 0, 0, 0, 0 },
/* U+6921 */ { 0, 0, 0, 0, 0 },
/* U+6922 */ { 0, 0, 0, 0, 0 },
/* U+6923 */ { 0, 0, 0, 0, 0 },
/* U+6924 */ { 0, 0, 0, 0, 0 },
/* U+6925 */ { 0, 0, 0, 0, 0 },
/* U+6926 */ { 0, 0, 0, 0, 0 },
/* U+6927 */ { 0, 0, 0, 0, 0 },
/* U+6928 */ { 0, 0, 0, 0, 0 },
/* U+6929 */ { 0, 0, 0, 0, 0 },
/* U+692a */ { 0, 0, 0, 0, 0 },
/* U+692b */ { 0, 0, 0, 0, 0 },
/* U+692c */ { 0, 0, 0, 0, 0 },
/* U+692d */ { 0, 0, 0, 0, 0 },
/* U+692e */ { 0, 0, 0, 0, 0 },
/* U+692f */ { 0, 0, 0, 0, 0 },
/* U+6930 */ { 0, 0, 0, 0, 0 },
/* U+6931 */ { 0, 0, 0, 0, 0 },
/* U+6932 */ { 0, 0, 0, 0, 0 },
/* U+6933 */ { 0, 0, 0, 0, 0 },
/* U+6934 */ { 0, 0, 0, 0, 0 },
/* U+6935 */ { 0, 0, 0, 0, 0 },
/* U+6936 */ { 0, 0, 0, 0, 0 },
/* U+6937 */ { 0, 0, 0, 0, 0 },
/* U+6938 */ { 0, 0, 0, 0, 0 },
/* U+6939 */ { 0, 0, 0, 0, 0 },
/* U+693a */ { 0, 0, 0, 0, 0 },
/* U+693b */ { 0, 0, 0, 0, 0 },
/* U+693c */ { 0, 0, 0, 0, 0 },
/* U+693d */ { 0, 0, 0, 0, 0 },
/* U+693e */ { 0, 0, 0, 0, 0 },
/* U+693f */ { 0, 0, 0, 0, 0 },
/* U+6940 */ { 0, 0, 0, 0, 0 },
/* U+6941 */ { 0, 0, 0, 0, 0 },
/* U+6942 */ { 0, 0, 0, 0, 0 },
/* U+6943 */ { 0, 0, 0, 0, 0 },
/* U+6944 */ { 0, 0, 0, 0, 0 },
/* U+6945 */ { 0, 0, 0, 0, 0 },
/* U+6946 */ { 0, 0, 0, 0, 0 },
/* U+6947 */ { 0, 0, 0, 0, 0 },
/* U+6948 */ { 0, 0, 0, 0, 0 },
/* U+6949 */ { 0, 0, 0, 0, 0 },
/* U+694a */ { 0, 0, 0, 0, 0 },
/* U+694b */ { 0, 0, 0, 0, 0 },
/* U+694c */ { 0, 0, 0, 0, 0 },
/* U+694d */ { 0, 0, 0, 0, 0 },
/* U+694e */ { 0, 0, 0, 0, 0 },
/* U+694f */ { 0, 0, 0, 0, 0 },
/* U+6950 */ { 0, 0, 0, 0, 0 },
/* U+6951 */ { 0, 0, 0, 0, 0 },
/* U+6952 */ { 0, 0, 0, 0, 0 },
/* U+6953 */ { 0, 0, 0, 0, 0 },
/* U+6954 */ { 0, 0, 0, 0, 0 },
/* U+6955 */ { 0, 0, 0, 0, 0 },
/* U+6956 */ { 0, 0, 0, 0, 0 },
/* U+6957 */ { 0, 0, 0, 0, 0 },
/* U+6958 */ { 0, 0, 0, 0, 0 },
/* U+6959 */ { 0, 0, 0, 0, 0 },
/* U+695a */ { 0, 0, 0, 0, 0 },
/* U+695b */ { 0, 0, 0, 0, 0 },
/* U+695c */ { 0, 0, 0, 0, 0 },
/* U+695d */ { 0, 0, 0, 0, 0 },
/* U+695e */ { 0, 0, 0, 0, 0 },
/* U+695f */ { 0, 0, 0, 0, 0 },
/* U+6960 */ { 0, 0, 0, 0, 0 },
/* U+6961 */ { 0, 0, 0, 0, 0 },
/* U+6962 */ { 0, 0, 0, 0, 0 },
/* U+6963 */ { 0, 0, 0, 0, 0 },
/* U+6964 */ { 0, 0, 0, 0, 0 },
/* U+6965 */ { 0, 0, 0, 0, 0 },
/* U+6966 */ { 0, 0, 0, 0, 0 },
/* U+6967 */ { 0, 0, 0, 0, 0 },
/* U+6968 */ { 0, 0, 0, 0, 0 },
/* U+6969 */ { 0, 0, 0, 0, 0 },
/* U+696a */ { 0, 0, 0, 0, 0 },
/* U+696b */ { 0, 0, 0, 0, 0 },
/* U+696c */ { 0, 0, 0, 0, 0 },
/* U+696d */ { 0, 0, 0, 0, 0 },
/* U+696e */ { 0, 0, 0, 0, 0 },
/* U+696f */ { 0, 0, 0, 0, 0 },
/* U+6970 */ { 0, 0, 0, 0, 0 },
/* U+6971 */ { 0, 0, 0, 0, 0 },
/* U+6972 */ { 0, 0, 0, 0, 0 },
/* U+6973 */ { 0, 0, 0, 0, 0 },
/* U+6974 */ { 0, 0, 0, 0, 0 },
/* U+6975 */ { 0, 0, 0, 0, 0 },
/* U+6976 */ { 0, 0, 0, 0, 0 },
/* U+6977 */ { 0, 0, 0, 0, 0 },
/* U+6978 */ { 0, 0, 0, 0, 0 },
/* U+6979 */ { 0, 0, 0, 0, 0 },
/* U+697a */ { 0, 0, 0, 0, 0 },
/* U+697b */ { 0, 0, 0, 0, 0 },
/* U+697c */ { 0, 0, 0, 0, 0 },
/* U+697d */ { 0, 0, 0, 0, 0 },
/* U+697e */ { 0, 0, 0, 0, 0 },
/* U+697f */ { 0, 0, 0, 0, 0 },
/* U+6980 */ { 0, 0, 0, 0, 0 },
/* U+6981 */ { 0, 0, 0, 0, 0 },
/* U+6982 */ { 0, 0, 0, 0, 0 },
/* U+6983 */ { 0, 0, 0, 0, 0 },
/* U+6984 */ { 0, 0, 0, 0, 0 },
/* U+6985 */ { 0, 0, 0, 0, 0 },
/* U+6986 */ { 0, 0, 0, 0, 0 },
/* U+6987 */ { 0, 0, 0, 0, 0 },
/* U+6988 */ { 0, 0, 0, 0, 0 },
/* U+6989 */ { 0, 0, 0, 0, 0 },
/* U+698a */ { 0, 0, 0, 0, 0 },
/* U+698b */ { 0, 0, 0, 0, 0 },
/* U+698c */ { 0, 0, 0, 0, 0 },
/* U+698d */ { 0, 0, 0, 0, 0 },
/* U+698e */ { 0, 0, 0, 0, 0 },
/* U+698f */ { 0, 0, 0, 0, 0 },
/* U+6990 */ { 0, 0, 0, 0, 0 },
/* U+6991 */ { 0, 0, 0, 0, 0 },
/* U+6992 */ { 0, 0, 0, 0, 0 },
/* U+6993 */ { 0, 0, 0, 0, 0 },
/* U+6994 */ { 0, 0, 0, 0, 0 },
/* U+6995 */ { 0, 0, 0, 0, 0 },
/* U+6996 */ { 0, 0, 0, 0, 0 },
/* U+6997 */ { 0, 0, 0, 0, 0 },
/* U+6998 */ { 0, 0, 0, 0, 0 },
/* U+6999 */ { 0, 0, 0, 0, 0 },
/* U+699a */ { 0, 0, 0, 0, 0 },
/* U+699b */ { 0, 0, 0, 0, 0 },
/* U+699c */ { 0, 0, 0, 0, 0 },
/* U+699d */ { 0, 0, 0, 0, 0 },
/* U+699e */ { 0, 0, 0, 0, 0 },
/* U+699f */ { 0, 0, 0, 0, 0 },
/* U+69a0 */ { 0, 0, 0, 0, 0 },
/* U+69a1 */ { 0, 0, 0, 0, 0 },
/* U+69a2 */ { 0, 0, 0, 0, 0 },
/* U+69a3 */ { 0, 0, 0, 0, 0 },
/* U+69a4 */ { 0, 0, 0, 0, 0 },
/* U+69a5 */ { 0, 0, 0, 0, 0 },
/* U+69a6 */ { 0, 0, 0, 0, 0 },
/* U+69a7 */ { 0, 0, 0, 0, 0 },
/* U+69a8 */ { 0, 0, 0, 0, 0 },
/* U+69a9 */ { 0, 0, 0, 0, 0 },
/* U+69aa */ { 0, 0, 0, 0, 0 },
/* U+69ab */ { 0, 0, 0, 0, 0 },
/* U+69ac */ { 0, 0, 0, 0, 0 },
/* U+69ad */ { 0, 0, 0, 0, 0 },
/* U+69ae */ { 0, 0, 0, 0, 0 },
/* U+69af */ { 0, 0, 0, 0, 0 },
/* U+69b0 */ { 0, 0, 0, 0, 0 },
/* U+69b1 */ { 0, 0, 0, 0, 0 },
/* U+69b2 */ { 0, 0, 0, 0, 0 },
/* U+69b3 */ { 0, 0, 0, 0, 0 },
/* U+69b4 */ { 0, 0, 0, 0, 0 },
/* U+69b5 */ { 0, 0, 0, 0, 0 },
/* U+69b6 */ { 0, 0, 0, 0, 0 },
/* U+69b7 */ { 0, 0, 0, 0, 0 },
/* U+69b8 */ { 0, 0, 0, 0, 0 },
/* U+69b9 */ { 0, 0, 0, 0, 0 },
/* U+69ba */ { 0, 0, 0, 0, 0 },
/* U+69bb */ { 0, 0, 0, 0, 0 },
/* U+69bc */ { 0, 0, 0, 0, 0 },
/* U+69bd */ { 0, 0, 0, 0, 0 },
/* U+69be */ { 0, 0, 0, 0, 0 },
/* U+69bf */ { 0, 0, 0, 0, 0 },
/* U+69c0 */ { 0, 0, 0, 0, 0 },
/* U+69c1 */ { 0, 0, 0, 0, 0 },
/* U+69c2 */ { 0, 0, 0, 0, 0 },
/* U+69c3 */ { 0, 0, 0, 0, 0 },
/* U+69c4 */ { 0, 0, 0, 0, 0 },
/* U+69c5 */ { 0, 0, 0, 0, 0 },
/* U+69c6 */ { 0, 0, 0, 0, 0 },
/* U+69c7 */ { 0, 0, 0, 0, 0 },
/* U+69c8 */ { 0, 0, 0, 0, 0 },
/* U+69c9 */ { 0, 0, 0, 0, 0 },
/* U+69ca */ { 0, 0, 0, 0, 0 },
/* U+69cb */ { 0, 0, 0, 0, 0 },
/* U+69cc */ { 0, 0, 0, 0, 0 },
/* U+69cd */ { 0, 0, 0, 0, 0 },
/* U+69ce */ { 0, 0, 0, 0, 0 },
/* U+69cf */ { 0, 0, 0, 0, 0 },
/* U+69d0 */ { 0, 0, 0, 0, 0 },
/* U+69d1 */ { 0, 0, 0, 0, 0 },
/* U+69d2 */ { 0, 0, 0, 0, 0 },
/* U+69d3 */ { 0, 0, 0, 0, 0 },
/* U+69d4 */ { 0, 0, 0, 0, 0 },
/* U+69d5 */ { 0, 0, 0, 0, 0 },
/* U+69d6 */ { 0, 0, 0, 0, 0 },
/* U+69d7 */ { 0, 0, 0, 0, 0 },
/* U+69d8 */ { 0, 0, 0, 0, 0 },
/* U+69d9 */ { 0, 0, 0, 0, 0 },
/* U+69da */ { 0, 0, 0, 0, 0 },
/* U+69db */ { 0, 0, 0, 0, 0 },
/* U+69dc */ { 0, 0, 0, 0, 0 },
/* U+69dd */ { 0, 0, 0, 0, 0 },
/* U+69de */ { 0, 0, 0, 0, 0 },
/* U+69df */ { 0, 0, 0, 0, 0 },
/* U+69e0 */ { 0, 0, 0, 0, 0 },
/* U+69e1 */ { 0, 0, 0, 0, 0 },
/* U+69e2 */ { 0, 0, 0, 0, 0 },
/* U+69e3 */ { 0, 0, 0, 0, 0 },
/* U+69e4 */ { 0, 0, 0, 0, 0 },
/* U+69e5 */ { 0, 0, 0, 0, 0 },
/* U+69e6 */ { 0, 0, 0, 0, 0 },
/* U+69e7 */ { 0, 0, 0, 0, 0 },
/* U+69e8 */ { 0, 0, 0, 0, 0 },
/* U+69e9 */ { 0, 0, 0, 0, 0 },
/* U+69ea */ { 0, 0, 0, 0, 0 },
/* U+69eb */ { 0, 0, 0, 0, 0 },
/* U+69ec */ { 0, 0, 0, 0, 0 },
/* U+69ed */ { 0, 0, 0, 0, 0 },
/* U+69ee */ { 0, 0, 0, 0, 0 },
/* U+69ef */ { 0, 0, 0, 0, 0 },
/* U+69f0 */ { 0, 0, 0, 0, 0 },
/* U+69f1 */ { 0, 0, 0, 0, 0 },
/* U+69f2 */ { 0, 0, 0, 0, 0 },
/* U+69f3 */ { 0, 0, 0, 0, 0 },
/* U+69f4 */ { 0, 0, 0, 0, 0 },
/* U+69f5 */ { 0, 0, 0, 0, 0 },
/* U+69f6 */ { 0, 0, 0, 0, 0 },
/* U+69f7 */ { 0, 0, 0, 0, 0 },
/* U+69f8 */ { 0, 0, 0, 0, 0 },
/* U+69f9 */ { 0, 0, 0, 0, 0 },
/* U+69fa */ { 0, 0, 0, 0, 0 },
/* U+69fb */ { 0, 0, 0, 0, 0 },
/* U+69fc */ { 0, 0, 0, 0, 0 },
/* U+69fd */ { 0, 0, 0, 0, 0 },
/* U+69fe */ { 0, 0, 0, 0, 0 },
/* U+69ff */ { 0, 0, 0, 0, 0 },
/* U+6a00 */ { 0, 0, 0, 0, 0 },
/* U+6a01 */ { 0, 0, 0, 0, 0 },
/* U+6a02 */ { 0, 0, 0, 0, 0 },
/* U+6a03 */ { 0, 0, 0, 0, 0 },
/* U+6a04 */ { 0, 0, 0, 0, 0 },
/* U+6a05 */ { 0, 0, 0, 0, 0 },
/* U+6a06 */ { 0, 0, 0, 0, 0 },
/* U+6a07 */ { 0, 0, 0, 0, 0 },
/* U+6a08 */ { 0, 0, 0, 0, 0 },
/* U+6a09 */ { 0, 0, 0, 0, 0 },
/* U+6a0a */ { 0, 0, 0, 0, 0 },
/* U+6a0b */ { 0, 0, 0, 0, 0 },
/* U+6a0c */ { 0, 0, 0, 0, 0 },
/* U+6a0d */ { 0, 0, 0, 0, 0 },
/* U+6a0e */ { 0, 0, 0, 0, 0 },
/* U+6a0f */ { 0, 0, 0, 0, 0 },
/* U+6a10 */ { 0, 0, 0, 0, 0 },
/* U+6a11 */ { 0, 0, 0, 0, 0 },
/* U+6a12 */ { 0, 0, 0, 0, 0 },
/* U+6a13 */ { 0, 0, 0, 0, 0 },
/* U+6a14 */ { 0, 0, 0, 0, 0 },
/* U+6a15 */ { 0, 0, 0, 0, 0 },
/* U+6a16 */ { 0, 0, 0, 0, 0 },
/* U+6a17 */ { 0, 0, 0, 0, 0 },
/* U+6a18 */ { 0, 0, 0, 0, 0 },
/* U+6a19 */ { 0, 0, 0, 0, 0 },
/* U+6a1a */ { 0, 0, 0, 0, 0 },
/* U+6a1b */ { 0, 0, 0, 0, 0 },
/* U+6a1c */ { 0, 0, 0, 0, 0 },
/* U+6a1d */ { 0, 0, 0, 0, 0 },
/* U+6a1e */ { 0, 0, 0, 0, 0 },
/* U+6a1f */ { 0, 0, 0, 0, 0 },
/* U+6a20 */ { 0, 0, 0, 0, 0 },
/* U+6a21 */ { 0, 0, 0, 0, 0 },
/* U+6a22 */ { 0, 0, 0, 0, 0 },
/* U+6a23 */ { 0, 0, 0, 0, 0 },
/* U+6a24 */ { 0, 0, 0, 0, 0 },
/* U+6a25 */ { 0, 0, 0, 0, 0 },
/* U+6a26 */ { 0, 0, 0, 0, 0 },
/* U+6a27 */ { 0, 0, 0, 0, 0 },
/* U+6a28 */ { 0, 0, 0, 0, 0 },
/* U+6a29 */ { 0, 0, 0, 0, 0 },
/* U+6a2a */ { 0, 0, 0, 0, 0 },
/* U+6a2b */ { 0, 0, 0, 0, 0 },
/* U+6a2c */ { 0, 0, 0, 0, 0 },
/* U+6a2d */ { 0, 0, 0, 0, 0 },
/* U+6a2e */ { 0, 0, 0, 0, 0 },
/* U+6a2f */ { 0, 0, 0, 0, 0 },
/* U+6a30 */ { 0, 0, 0, 0, 0 },
/* U+6a31 */ { 0, 0, 0, 0, 0 },
/* U+6a32 */ { 0, 0, 0, 0, 0 },
/* U+6a33 */ { 0, 0, 0, 0, 0 },
/* U+6a34 */ { 0, 0, 0, 0, 0 },
/* U+6a35 */ { 0, 0, 0, 0, 0 },
/* U+6a36 */ { 0, 0, 0, 0, 0 },
/* U+6a37 */ { 0, 0, 0, 0, 0 },
/* U+6a38 */ { 0, 0, 0, 0, 0 },
/* U+6a39 */ { 0, 0, 0, 0, 0 },
/* U+6a3a */ { 0, 0, 0, 0, 0 },
/* U+6a3b */ { 0, 0, 0, 0, 0 },
/* U+6a3c */ { 0, 0, 0, 0, 0 },
/* U+6a3d */ { 0, 0, 0, 0, 0 },
/* U+6a3e */ { 0, 0, 0, 0, 0 },
/* U+6a3f */ { 0, 0, 0, 0, 0 },
/* U+6a40 */ { 0, 0, 0, 0, 0 },
/* U+6a41 */ { 0, 0, 0, 0, 0 },
/* U+6a42 */ { 0, 0, 0, 0, 0 },
/* U+6a43 */ { 0, 0, 0, 0, 0 },
/* U+6a44 */ { 0, 0, 0, 0, 0 },
/* U+6a45 */ { 0, 0, 0, 0, 0 },
/* U+6a46 */ { 0, 0, 0, 0, 0 },
/* U+6a47 */ { 0, 0, 0, 0, 0 },
/* U+6a48 */ { 0, 0, 0, 0, 0 },
/* U+6a49 */ { 0, 0, 0, 0, 0 },
/* U+6a4a */ { 0, 0, 0, 0, 0 },
/* U+6a4b */ { 0, 0, 0, 0, 0 },
/* U+6a4c */ { 0, 0, 0, 0, 0 },
/* U+6a4d */ { 0, 0, 0, 0, 0 },
/* U+6a4e */ { 0, 0, 0, 0, 0 },
/* U+6a4f */ { 0, 0, 0, 0, 0 },
/* U+6a50 */ { 0, 0, 0, 0, 0 },
/* U+6a51 */ { 0, 0, 0, 0, 0 },
/* U+6a52 */ { 0, 0, 0, 0, 0 },
/* U+6a53 */ { 0, 0, 0, 0, 0 },
/* U+6a54 */ { 0, 0, 0, 0, 0 },
/* U+6a55 */ { 0, 0, 0, 0, 0 },
/* U+6a56 */ { 0, 0, 0, 0, 0 },
/* U+6a57 */ { 0, 0, 0, 0, 0 },
/* U+6a58 */ { 0, 0, 0, 0, 0 },
/* U+6a59 */ { 0, 0, 0, 0, 0 },
/* U+6a5a */ { 0, 0, 0, 0, 0 },
/* U+6a5b */ { 0, 0, 0, 0, 0 },
/* U+6a5c */ { 0, 0, 0, 0, 0 },
/* U+6a5d */ { 0, 0, 0, 0, 0 },
/* U+6a5e */ { 0, 0, 0, 0, 0 },
/* U+6a5f */ { 0, 0, 0, 0, 0 },
/* U+6a60 */ { 0, 0, 0, 0, 0 },
/* U+6a61 */ { 0, 0, 0, 0, 0 },
/* U+6a62 */ { 0, 0, 0, 0, 0 },
/* U+6a63 */ { 0, 0, 0, 0, 0 },
/* U+6a64 */ { 0, 0, 0, 0, 0 },
/* U+6a65 */ { 0, 0, 0, 0, 0 },
/* U+6a66 */ { 0, 0, 0, 0, 0 },
/* U+6a67 */ { 0, 0, 0, 0, 0 },
/* U+6a68 */ { 0, 0, 0, 0, 0 },
/* U+6a69 */ { 0, 0, 0, 0, 0 },
/* U+6a6a */ { 0, 0, 0, 0, 0 },
/* U+6a6b */ { 0, 0, 0, 0, 0 },
/* U+6a6c */ { 0, 0, 0, 0, 0 },
/* U+6a6d */ { 0, 0, 0, 0, 0 },
/* U+6a6e */ { 0, 0, 0, 0, 0 },
/* U+6a6f */ { 0, 0, 0, 0, 0 },
/* U+6a70 */ { 0, 0, 0, 0, 0 },
/* U+6a71 */ { 0, 0, 0, 0, 0 },
/* U+6a72 */ { 0, 0, 0, 0, 0 },
/* U+6a73 */ { 0, 0, 0, 0, 0 },
/* U+6a74 */ { 0, 0, 0, 0, 0 },
/* U+6a75 */ { 0, 0, 0, 0, 0 },
/* U+6a76 */ { 0, 0, 0, 0, 0 },
/* U+6a77 */ { 0, 0, 0, 0, 0 },
/* U+6a78 */ { 0, 0, 0, 0, 0 },
/* U+6a79 */ { 0, 0, 0, 0, 0 },
/* U+6a7a */ { 0, 0, 0, 0, 0 },
/* U+6a7b */ { 0, 0, 0, 0, 0 },
/* U+6a7c */ { 0, 0, 0, 0, 0 },
/* U+6a7d */ { 0, 0, 0, 0, 0 },
/* U+6a7e */ { 0, 0, 0, 0, 0 },
/* U+6a7f */ { 0, 0, 0, 0, 0 },
/* U+6a80 */ { 0, 0, 0, 0, 0 },
/* U+6a81 */ { 0, 0, 0, 0, 0 },
/* U+6a82 */ { 0, 0, 0, 0, 0 },
/* U+6a83 */ { 0, 0, 0, 0, 0 },
/* U+6a84 */ { 0, 0, 0, 0, 0 },
/* U+6a85 */ { 0, 0, 0, 0, 0 },
/* U+6a86 */ { 0, 0, 0, 0, 0 },
/* U+6a87 */ { 0, 0, 0, 0, 0 },
/* U+6a88 */ { 0, 0, 0, 0, 0 },
/* U+6a89 */ { 0, 0, 0, 0, 0 },
/* U+6a8a */ { 0, 0, 0, 0, 0 },
/* U+6a8b */ { 0, 0, 0, 0, 0 },
/* U+6a8c */ { 0, 0, 0, 0, 0 },
/* U+6a8d */ { 0, 0, 0, 0, 0 },
/* U+6a8e */ { 0, 0, 0, 0, 0 },
/* U+6a8f */ { 0, 0, 0, 0, 0 },
/* U+6a90 */ { 0, 0, 0, 0, 0 },
/* U+6a91 */ { 0, 0, 0, 0, 0 },
/* U+6a92 */ { 0, 0, 0, 0, 0 },
/* U+6a93 */ { 0, 0, 0, 0, 0 },
/* U+6a94 */ { 0, 0, 0, 0, 0 },
/* U+6a95 */ { 0, 0, 0, 0, 0 },
/* U+6a96 */ { 0, 0, 0, 0, 0 },
/* U+6a97 */ { 0, 0, 0, 0, 0 },
/* U+6a98 */ { 0, 0, 0, 0, 0 },
/* U+6a99 */ { 0, 0, 0, 0, 0 },
/* U+6a9a */ { 0, 0, 0, 0, 0 },
/* U+6a9b */ { 0, 0, 0, 0, 0 },
/* U+6a9c */ { 0, 0, 0, 0, 0 },
/* U+6a9d */ { 0, 0, 0, 0, 0 },
/* U+6a9e */ { 0, 0, 0, 0, 0 },
/* U+6a9f */ { 0, 0, 0, 0, 0 },
/* U+6aa0 */ { 0, 0, 0, 0, 0 },
/* U+6aa1 */ { 0, 0, 0, 0, 0 },
/* U+6aa2 */ { 0, 0, 0, 0, 0 },
/* U+6aa3 */ { 0, 0, 0, 0, 0 },
/* U+6aa4 */ { 0, 0, 0, 0, 0 },
/* U+6aa5 */ { 0, 0, 0, 0, 0 },
/* U+6aa6 */ { 0, 0, 0, 0, 0 },
/* U+6aa7 */ { 0, 0, 0, 0, 0 },
/* U+6aa8 */ { 0, 0, 0, 0, 0 },
/* U+6aa9 */ { 0, 0, 0, 0, 0 },
/* U+6aaa */ { 0, 0, 0, 0, 0 },
/* U+6aab */ { 0, 0, 0, 0, 0 },
/* U+6aac */ { 0, 0, 0, 0, 0 },
/* U+6aad */ { 0, 0, 0, 0, 0 },
/* U+6aae */ { 0, 0, 0, 0, 0 },
/* U+6aaf */ { 0, 0, 0, 0, 0 },
/* U+6ab0 */ { 0, 0, 0, 0, 0 },
/* U+6ab1 */ { 0, 0, 0, 0, 0 },
/* U+6ab2 */ { 0, 0, 0, 0, 0 },
/* U+6ab3 */ { 0, 0, 0, 0, 0 },
/* U+6ab4 */ { 0, 0, 0, 0, 0 },
/* U+6ab5 */ { 0, 0, 0, 0, 0 },
/* U+6ab6 */ { 0, 0, 0, 0, 0 },
/* U+6ab7 */ { 0, 0, 0, 0, 0 },
/* U+6ab8 */ { 0, 0, 0, 0, 0 },
/* U+6ab9 */ { 0, 0, 0, 0, 0 },
/* U+6aba */ { 0, 0, 0, 0, 0 },
/* U+6abb */ { 0, 0, 0, 0, 0 },
/* U+6abc */ { 0, 0, 0, 0, 0 },
/* U+6abd */ { 0, 0, 0, 0, 0 },
/* U+6abe */ { 0, 0, 0, 0, 0 },
/* U+6abf */ { 0, 0, 0, 0, 0 },
/* U+6ac0 */ { 0, 0, 0, 0, 0 },
/* U+6ac1 */ { 0, 0, 0, 0, 0 },
/* U+6ac2 */ { 0, 0, 0, 0, 0 },
/* U+6ac3 */ { 0, 0, 0, 0, 0 },
/* U+6ac4 */ { 0, 0, 0, 0, 0 },
/* U+6ac5 */ { 0, 0, 0, 0, 0 },
/* U+6ac6 */ { 0, 0, 0, 0, 0 },
/* U+6ac7 */ { 0, 0, 0, 0, 0 },
/* U+6ac8 */ { 0, 0, 0, 0, 0 },
/* U+6ac9 */ { 0, 0, 0, 0, 0 },
/* U+6aca */ { 0, 0, 0, 0, 0 },
/* U+6acb */ { 0, 0, 0, 0, 0 },
/* U+6acc */ { 0, 0, 0, 0, 0 },
/* U+6acd */ { 0, 0, 0, 0, 0 },
/* U+6ace */ { 0, 0, 0, 0, 0 },
/* U+6acf */ { 0, 0, 0, 0, 0 },
/* U+6ad0 */ { 0, 0, 0, 0, 0 },
/* U+6ad1 */ { 0, 0, 0, 0, 0 },
/* U+6ad2 */ { 0, 0, 0, 0, 0 },
/* U+6ad3 */ { 0, 0, 0, 0, 0 },
/* U+6ad4 */ { 0, 0, 0, 0, 0 },
/* U+6ad5 */ { 0, 0, 0, 0, 0 },
/* U+6ad6 */ { 0, 0, 0, 0, 0 },
/* U+6ad7 */ { 0, 0, 0, 0, 0 },
/* U+6ad8 */ { 0, 0, 0, 0, 0 },
/* U+6ad9 */ { 0, 0, 0, 0, 0 },
/* U+6ada */ { 0, 0, 0, 0, 0 },
/* U+6adb */ { 0, 0, 0, 0, 0 },
/* U+6adc */ { 0, 0, 0, 0, 0 },
/* U+6add */ { 0, 0, 0, 0, 0 },
/* U+6ade */ { 0, 0, 0, 0, 0 },
/* U+6adf */ { 0, 0, 0, 0, 0 },
/* U+6ae0 */ { 0, 0, 0, 0, 0 },
/* U+6ae1 */ { 0, 0, 0, 0, 0 },
/* U+6ae2 */ { 0, 0, 0, 0, 0 },
/* U+6ae3 */ { 0, 0, 0, 0, 0 },
/* U+6ae4 */ { 0, 0, 0, 0, 0 },
/* U+6ae5 */ { 0, 0, 0, 0, 0 },
/* U+6ae6 */ { 0, 0, 0, 0, 0 },
/* U+6ae7 */ { 0, 0, 0, 0, 0 },
/* U+6ae8 */ { 0, 0, 0, 0, 0 },
/* U+6ae9 */ { 0, 0, 0, 0, 0 },
/* U+6aea */ { 0, 0, 0, 0, 0 },
/* U+6aeb */ { 0, 0, 0, 0, 0 },
/* U+6aec */ { 0, 0, 0, 0, 0 },
/* U+6aed */ { 0, 0, 0, 0, 0 },
/* U+6aee */ { 0, 0, 0, 0, 0 },
/* U+6aef */ { 0, 0, 0, 0, 0 },
/* U+6af0 */ { 0, 0, 0, 0, 0 },
/* U+6af1 */ { 0, 0, 0, 0, 0 },
/* U+6af2 */ { 0, 0, 0, 0, 0 },
/* U+6af3 */ { 0, 0, 0, 0, 0 },
/* U+6af4 */ { 0, 0, 0, 0, 0 },
/* U+6af5 */ { 0, 0, 0, 0, 0 },
/* U+6af6 */ { 0, 0, 0, 0, 0 },
/* U+6af7 */ { 0, 0, 0, 0, 0 },
/* U+6af8 */ { 0, 0, 0, 0, 0 },
/* U+6af9 */ { 0, 0, 0, 0, 0 },
/* U+6afa */ { 0, 0, 0, 0, 0 },
/* U+6afb */ { 0, 0, 0, 0, 0 },
/* U+6afc */ { 0, 0, 0, 0, 0 },
/* U+6afd */ { 0, 0, 0, 0, 0 },
/* U+6afe */ { 0, 0, 0, 0, 0 },
/* U+6aff */ { 0, 0, 0, 0, 0 },
/* U+6b00 */ { 0, 0, 0, 0, 0 },
/* U+6b01 */ { 0, 0, 0, 0, 0 },
/* U+6b02 */ { 0, 0, 0, 0, 0 },
/* U+6b03 */ { 0, 0, 0, 0, 0 },
/* U+6b04 */ { 0, 0, 0, 0, 0 },
/* U+6b05 */ { 0, 0, 0, 0, 0 },
/* U+6b06 */ { 0, 0, 0, 0, 0 },
/* U+6b07 */ { 0, 0, 0, 0, 0 },
/* U+6b08 */ { 0, 0, 0, 0, 0 },
/* U+6b09 */ { 0, 0, 0, 0, 0 },
/* U+6b0a */ { 0, 0, 0, 0, 0 },
/* U+6b0b */ { 0, 0, 0, 0, 0 },
/* U+6b0c */ { 0, 0, 0, 0, 0 },
/* U+6b0d */ { 0, 0, 0, 0, 0 },
/* U+6b0e */ { 0, 0, 0, 0, 0 },
/* U+6b0f */ { 0, 0, 0, 0, 0 },
/* U+6b10 */ { 0, 0, 0, 0, 0 },
/* U+6b11 */ { 0, 0, 0, 0, 0 },
/* U+6b12 */ { 0, 0, 0, 0, 0 },
/* U+6b13 */ { 0, 0, 0, 0, 0 },
/* U+6b14 */ { 0, 0, 0, 0, 0 },
/* U+6b15 */ { 0, 0, 0, 0, 0 },
/* U+6b16 */ { 0, 0, 0, 0, 0 },
/* U+6b17 */ { 0, 0, 0, 0, 0 },
/* U+6b18 */ { 0, 0, 0, 0, 0 },
/* U+6b19 */ { 0, 0, 0, 0, 0 },
/* U+6b1a */ { 0, 0, 0, 0, 0 },
/* U+6b1b */ { 0, 0, 0, 0, 0 },
/* U+6b1c */ { 0, 0, 0, 0, 0 },
/* U+6b1d */ { 0, 0, 0, 0, 0 },
/* U+6b1e */ { 0, 0, 0, 0, 0 },
/* U+6b1f */ { 0, 0, 0, 0, 0 },
/* U+6b20 */ { 0, 0, 0, 0, 0 },
/* U+6b21 */ { 0, 0, 0, 0, 0 },
/* U+6b22 */ { 0, 0, 0, 0, 0 },
/* U+6b23 */ { 0, 0, 0, 0, 0 },
/* U+6b24 */ { 0, 0, 0, 0, 0 },
/* U+6b25 */ { 0, 0, 0, 0, 0 },
/* U+6b26 */ { 0, 0, 0, 0, 0 },
/* U+6b27 */ { 0, 0, 0, 0, 0 },
/* U+6b28 */ { 0, 0, 0, 0, 0 },
/* U+6b29 */ { 0, 0, 0, 0, 0 },
/* U+6b2a */ { 0, 0, 0, 0, 0 },
/* U+6b2b */ { 0, 0, 0, 0, 0 },
/* U+6b2c */ { 0, 0, 0, 0, 0 },
/* U+6b2d */ { 0, 0, 0, 0, 0 },
/* U+6b2e */ { 0, 0, 0, 0, 0 },
/* U+6b2f */ { 0, 0, 0, 0, 0 },
/* U+6b30 */ { 0, 0, 0, 0, 0 },
/* U+6b31 */ { 0, 0, 0, 0, 0 },
/* U+6b32 */ { 0, 0, 0, 0, 0 },
/* U+6b33 */ { 0, 0, 0, 0, 0 },
/* U+6b34 */ { 0, 0, 0, 0, 0 },
/* U+6b35 */ { 0, 0, 0, 0, 0 },
/* U+6b36 */ { 0, 0, 0, 0, 0 },
/* U+6b37 */ { 0, 0, 0, 0, 0 },
/* U+6b38 */ { 0, 0, 0, 0, 0 },
/* U+6b39 */ { 0, 0, 0, 0, 0 },
/* U+6b3a */ { 0, 0, 0, 0, 0 },
/* U+6b3b */ { 0, 0, 0, 0, 0 },
/* U+6b3c */ { 0, 0, 0, 0, 0 },
/* U+6b3d */ { 0, 0, 0, 0, 0 },
/* U+6b3e */ { 0, 0, 0, 0, 0 },
/* U+6b3f */ { 0, 0, 0, 0, 0 },
/* U+6b40 */ { 0, 0, 0, 0, 0 },
/* U+6b41 */ { 0, 0, 0, 0, 0 },
/* U+6b42 */ { 0, 0, 0, 0, 0 },
/* U+6b43 */ { 0, 0, 0, 0, 0 },
/* U+6b44 */ { 0, 0, 0, 0, 0 },
/* U+6b45 */ { 0, 0, 0, 0, 0 },
/* U+6b46 */ { 0, 0, 0, 0, 0 },
/* U+6b47 */ { 0, 0, 0, 0, 0 },
/* U+6b48 */ { 0, 0, 0, 0, 0 },
/* U+6b49 */ { 0, 0, 0, 0, 0 },
/* U+6b4a */ { 0, 0, 0, 0, 0 },
/* U+6b4b */ { 0, 0, 0, 0, 0 },
/* U+6b4c */ { 0, 0, 0, 0, 0 },
/* U+6b4d */ { 0, 0, 0, 0, 0 },
/* U+6b4e */ { 0, 0, 0, 0, 0 },
/* U+6b4f */ { 0, 0, 0, 0, 0 },
/* U+6b50 */ { 0, 0, 0, 0, 0 },
/* U+6b51 */ { 0, 0, 0, 0, 0 },
/* U+6b52 */ { 0, 0, 0, 0, 0 },
/* U+6b53 */ { 0, 0, 0, 0, 0 },
/* U+6b54 */ { 0, 0, 0, 0, 0 },
/* U+6b55 */ { 0, 0, 0, 0, 0 },
/* U+6b56 */ { 0, 0, 0, 0, 0 },
/* U+6b57 */ { 0, 0, 0, 0, 0 },
/* U+6b58 */ { 0, 0, 0, 0, 0 },
/* U+6b59 */ { 0, 0, 0, 0, 0 },
/* U+6b5a */ { 0, 0, 0, 0, 0 },
/* U+6b5b */ { 0, 0, 0, 0, 0 },
/* U+6b5c */ { 0, 0, 0, 0, 0 },
/* U+6b5d */ { 0, 0, 0, 0, 0 },
/* U+6b5e */ { 0, 0, 0, 0, 0 },
/* U+6b5f */ { 0, 0, 0, 0, 0 },
/* U+6b60 */ { 0, 0, 0, 0, 0 },
/* U+6b61 */ { 0, 0, 0, 0, 0 },
/* U+6b62 */ { 0, 0, 0, 0, 0 },
/* U+6b63 */ { 0, 0, 0, 0, 0 },
/* U+6b64 */ { 0, 0, 0, 0, 0 },
/* U+6b65 */ { 0, 0, 0, 0, 0 },
/* U+6b66 */ { 0, 0, 0, 0, 0 },
/* U+6b67 */ { 0, 0, 0, 0, 0 },
/* U+6b68 */ { 0, 0, 0, 0, 0 },
/* U+6b69 */ { 0, 0, 0, 0, 0 },
/* U+6b6a */ { 0, 0, 0, 0, 0 },
/* U+6b6b */ { 0, 0, 0, 0, 0 },
/* U+6b6c */ { 0, 0, 0, 0, 0 },
/* U+6b6d */ { 0, 0, 0, 0, 0 },
/* U+6b6e */ { 0, 0, 0, 0, 0 },
/* U+6b6f */ { 0, 0, 0, 0, 0 },
/* U+6b70 */ { 0, 0, 0, 0, 0 },
/* U+6b71 */ { 0, 0, 0, 0, 0 },
/* U+6b72 */ { 0, 0, 0, 0, 0 },
/* U+6b73 */ { 0, 0, 0, 0, 0 },
/* U+6b74 */ { 0, 0, 0, 0, 0 },
/* U+6b75 */ { 0, 0, 0, 0, 0 },
/* U+6b76 */ { 0, 0, 0, 0, 0 },
/* U+6b77 */ { 0, 0, 0, 0, 0 },
/* U+6b78 */ { 0, 0, 0, 0, 0 },
/* U+6b79 */ { 0, 0, 0, 0, 0 },
/* U+6b7a */ { 0, 0, 0, 0, 0 },
/* U+6b7b */ { 0, 0, 0, 0, 0 },
/* U+6b7c */ { 0, 0, 0, 0, 0 },
/* U+6b7d */ { 0, 0, 0, 0, 0 },
/* U+6b7e */ { 0, 0, 0, 0, 0 },
/* U+6b7f */ { 0, 0, 0, 0, 0 },
/* U+6b80 */ { 0, 0, 0, 0, 0 },
/* U+6b81 */ { 0, 0, 0, 0, 0 },
/* U+6b82 */ { 0, 0, 0, 0, 0 },
/* U+6b83 */ { 0, 0, 0, 0, 0 },
/* U+6b84 */ { 0, 0, 0, 0, 0 },
/* U+6b85 */ { 0, 0, 0, 0, 0 },
/* U+6b86 */ { 0, 0, 0, 0, 0 },
/* U+6b87 */ { 0, 0, 0, 0, 0 },
/* U+6b88 */ { 0, 0, 0, 0, 0 },
/* U+6b89 */ { 0, 0, 0, 0, 0 },
/* U+6b8a */ { 0, 0, 0, 0, 0 },
/* U+6b8b */ { 0, 0, 0, 0, 0 },
/* U+6b8c */ { 0, 0, 0, 0, 0 },
/* U+6b8d */ { 0, 0, 0, 0, 0 },
/* U+6b8e */ { 0, 0, 0, 0, 0 },
/* U+6b8f */ { 0, 0, 0, 0, 0 },
/* U+6b90 */ { 0, 0, 0, 0, 0 },
/* U+6b91 */ { 0, 0, 0, 0, 0 },
/* U+6b92 */ { 0, 0, 0, 0, 0 },
/* U+6b93 */ { 0, 0, 0, 0, 0 },
/* U+6b94 */ { 0, 0, 0, 0, 0 },
/* U+6b95 */ { 0, 0, 0, 0, 0 },
/* U+6b96 */ { 0, 0, 0, 0, 0 },
/* U+6b97 */ { 0, 0, 0, 0, 0 },
/* U+6b98 */ { 0, 0, 0, 0, 0 },
/* U+6b99 */ { 0, 0, 0, 0, 0 },
/* U+6b9a */ { 0, 0, 0, 0, 0 },
/* U+6b9b */ { 0, 0, 0, 0, 0 },
/* U+6b9c */ { 0, 0, 0, 0, 0 },
/* U+6b9d */ { 0, 0, 0, 0, 0 },
/* U+6b9e */ { 0, 0, 0, 0, 0 },
/* U+6b9f */ { 0, 0, 0, 0, 0 },
/* U+6ba0 */ { 0, 0, 0, 0, 0 },
/* U+6ba1 */ { 0, 0, 0, 0, 0 },
/* U+6ba2 */ { 0, 0, 0, 0, 0 },
/* U+6ba3 */ { 0, 0, 0, 0, 0 },
/* U+6ba4 */ { 0, 0, 0, 0, 0 },
/* U+6ba5 */ { 0, 0, 0, 0, 0 },
/* U+6ba6 */ { 0, 0, 0, 0, 0 },
/* U+6ba7 */ { 0, 0, 0, 0, 0 },
/* U+6ba8 */ { 0, 0, 0, 0, 0 },
/* U+6ba9 */ { 0, 0, 0, 0, 0 },
/* U+6baa */ { 0, 0, 0, 0, 0 },
/* U+6bab */ { 0, 0, 0, 0, 0 },
/* U+6bac */ { 0, 0, 0, 0, 0 },
/* U+6bad */ { 0, 0, 0, 0, 0 },
/* U+6bae */ { 0, 0, 0, 0, 0 },
/* U+6baf */ { 0, 0, 0, 0, 0 },
/* U+6bb0 */ { 0, 0, 0, 0, 0 },
/* U+6bb1 */ { 0, 0, 0, 0, 0 },
/* U+6bb2 */ { 0, 0, 0, 0, 0 },
/* U+6bb3 */ { 0, 0, 0, 0, 0 },
/* U+6bb4 */ { 0, 0, 0, 0, 0 },
/* U+6bb5 */ { 0, 0, 0, 0, 0 },
/* U+6bb6 */ { 0, 0, 0, 0, 0 },
/* U+6bb7 */ { 0, 0, 0, 0, 0 },
/* U+6bb8 */ { 0, 0, 0, 0, 0 },
/* U+6bb9 */ { 0, 0, 0, 0, 0 },
/* U+6bba */ { 0, 0, 0, 0, 0 },
/* U+6bbb */ { 0, 0, 0, 0, 0 },
/* U+6bbc */ { 0, 0, 0, 0, 0 },
/* U+6bbd */ { 0, 0, 0, 0, 0 },
/* U+6bbe */ { 0, 0, 0, 0, 0 },
/* U+6bbf */ { 0, 0, 0, 0, 0 },
/* U+6bc0 */ { 0, 0, 0, 0, 0 },
/* U+6bc1 */ { 0, 0, 0, 0, 0 },
/* U+6bc2 */ { 0, 0, 0, 0, 0 },
/* U+6bc3 */ { 0, 0, 0, 0, 0 },
/* U+6bc4 */ { 0, 0, 0, 0, 0 },
/* U+6bc5 */ { 0, 0, 0, 0, 0 },
/* U+6bc6 */ { 0, 0, 0, 0, 0 },
/* U+6bc7 */ { 0, 0, 0, 0, 0 },
/* U+6bc8 */ { 0, 0, 0, 0, 0 },
/* U+6bc9 */ { 0, 0, 0, 0, 0 },
/* U+6bca */ { 0, 0, 0, 0, 0 },
/* U+6bcb */ { 0, 0, 0, 0, 0 },
/* U+6bcc */ { 0, 0, 0, 0, 0 },
/* U+6bcd */ { 0, 0, 0, 0, 0 },
/* U+6bce */ { 0, 0, 0, 0, 0 },
/* U+6bcf */ { 0, 0, 0, 0, 0 },
/* U+6bd0 */ { 0, 0, 0, 0, 0 },
/* U+6bd1 */ { 0, 0, 0, 0, 0 },
/* U+6bd2 */ { 0, 0, 0, 0, 0 },
/* U+6bd3 */ { 0, 0, 0, 0, 0 },
/* U+6bd4 */ { 0, 0, 0, 0, 0 },
/* U+6bd5 */ { 0, 0, 0, 0, 0 },
/* U+6bd6 */ { 0, 0, 0, 0, 0 },
/* U+6bd7 */ { 0, 0, 0, 0, 0 },
/* U+6bd8 */ { 0, 0, 0, 0, 0 },
/* U+6bd9 */ { 0, 0, 0, 0, 0 },
/* U+6bda */ { 0, 0, 0, 0, 0 },
/* U+6bdb */ { 0, 0, 0, 0, 0 },
/* U+6bdc */ { 0, 0, 0, 0, 0 },
/* U+6bdd */ { 0, 0, 0, 0, 0 },
/* U+6bde */ { 0, 0, 0, 0, 0 },
/* U+6bdf */ { 0, 0, 0, 0, 0 },
/* U+6be0 */ { 0, 0, 0, 0, 0 },
/* U+6be1 */ { 0, 0, 0, 0, 0 },
/* U+6be2 */ { 0, 0, 0, 0, 0 },
/* U+6be3 */ { 0, 0, 0, 0, 0 },
/* U+6be4 */ { 0, 0, 0, 0, 0 },
/* U+6be5 */ { 0, 0, 0, 0, 0 },
/* U+6be6 */ { 0, 0, 0, 0, 0 },
/* U+6be7 */ { 0, 0, 0, 0, 0 },
/* U+6be8 */ { 0, 0, 0, 0, 0 },
/* U+6be9 */ { 0, 0, 0, 0, 0 },
/* U+6bea */ { 0, 0, 0, 0, 0 },
/* U+6beb */ { 0, 0, 0, 0, 0 },
/* U+6bec */ { 0, 0, 0, 0, 0 },
/* U+6bed */ { 0, 0, 0, 0, 0 },
/* U+6bee */ { 0, 0, 0, 0, 0 },
/* U+6bef */ { 0, 0, 0, 0, 0 },
/* U+6bf0 */ { 0, 0, 0, 0, 0 },
/* U+6bf1 */ { 0, 0, 0, 0, 0 },
/* U+6bf2 */ { 0, 0, 0, 0, 0 },
/* U+6bf3 */ { 0, 0, 0, 0, 0 },
/* U+6bf4 */ { 0, 0, 0, 0, 0 },
/* U+6bf5 */ { 0, 0, 0, 0, 0 },
/* U+6bf6 */ { 0, 0, 0, 0, 0 },
/* U+6bf7 */ { 0, 0, 0, 0, 0 },
/* U+6bf8 */ { 0, 0, 0, 0, 0 },
/* U+6bf9 */ { 0, 0, 0, 0, 0 },
/* U+6bfa */ { 0, 0, 0, 0, 0 },
/* U+6bfb */ { 0, 0, 0, 0, 0 },
/* U+6bfc */ { 0, 0, 0, 0, 0 },
/* U+6bfd */ { 0, 0, 0, 0, 0 },
/* U+6bfe */ { 0, 0, 0, 0, 0 },
/* U+6bff */ { 0, 0, 0, 0, 0 },
/* U+6c00 */ { 0, 0, 0, 0, 0 },
/* U+6c01 */ { 0, 0, 0, 0, 0 },
/* U+6c02 */ { 0, 0, 0, 0, 0 },
/* U+6c03 */ { 0, 0, 0, 0, 0 },
/* U+6c04 */ { 0, 0, 0, 0, 0 },
/* U+6c05 */ { 0, 0, 0, 0, 0 },
/* U+6c06 */ { 0, 0, 0, 0, 0 },
/* U+6c07 */ { 0, 0, 0, 0, 0 },
/* U+6c08 */ { 0, 0, 0, 0, 0 },
/* U+6c09 */ { 0, 0, 0, 0, 0 },
/* U+6c0a */ { 0, 0, 0, 0, 0 },
/* U+6c0b */ { 0, 0, 0, 0, 0 },
/* U+6c0c */ { 0, 0, 0, 0, 0 },
/* U+6c0d */ { 0, 0, 0, 0, 0 },
/* U+6c0e */ { 0, 0, 0, 0, 0 },
/* U+6c0f */ { 0, 0, 0, 0, 0 },
/* U+6c10 */ { 0, 0, 0, 0, 0 },
/* U+6c11 */ { 0, 0, 0, 0, 0 },
/* U+6c12 */ { 0, 0, 0, 0, 0 },
/* U+6c13 */ { 0, 0, 0, 0, 0 },
/* U+6c14 */ { 0, 0, 0, 0, 0 },
/* U+6c15 */ { 0, 0, 0, 0, 0 },
/* U+6c16 */ { 0, 0, 0, 0, 0 },
/* U+6c17 */ { 0, 0, 0, 0, 0 },
/* U+6c18 */ { 0, 0, 0, 0, 0 },
/* U+6c19 */ { 0, 0, 0, 0, 0 },
/* U+6c1a */ { 0, 0, 0, 0, 0 },
/* U+6c1b */ { 0, 0, 0, 0, 0 },
/* U+6c1c */ { 0, 0, 0, 0, 0 },
/* U+6c1d */ { 0, 0, 0, 0, 0 },
/* U+6c1e */ { 0, 0, 0, 0, 0 },
/* U+6c1f */ { 0, 0, 0, 0, 0 },
/* U+6c20 */ { 0, 0, 0, 0, 0 },
/* U+6c21 */ { 0, 0, 0, 0, 0 },
/* U+6c22 */ { 0, 0, 0, 0, 0 },
/* U+6c23 */ { 0, 0, 0, 0, 0 },
/* U+6c24 */ { 0, 0, 0, 0, 0 },
/* U+6c25 */ { 0, 0, 0, 0, 0 },
/* U+6c26 */ { 0, 0, 0, 0, 0 },
/* U+6c27 */ { 0, 0, 0, 0, 0 },
/* U+6c28 */ { 0, 0, 0, 0, 0 },
/* U+6c29 */ { 0, 0, 0, 0, 0 },
/* U+6c2a */ { 0, 0, 0, 0, 0 },
/* U+6c2b */ { 0, 0, 0, 0, 0 },
/* U+6c2c */ { 0, 0, 0, 0, 0 },
/* U+6c2d */ { 0, 0, 0, 0, 0 },
/* U+6c2e */ { 0, 0, 0, 0, 0 },
/* U+6c2f */ { 0, 0, 0, 0, 0 },
/* U+6c30 */ { 0, 0, 0, 0, 0 },
/* U+6c31 */ { 0, 0, 0, 0, 0 },
/* U+6c32 */ { 0, 0, 0, 0, 0 },
/* U+6c33 */ { 0, 0, 0, 0, 0 },
/* U+6c34 */ { 0, 0, 0, 0, 0 },
/* U+6c35 */ { 0, 0, 0, 0, 0 },
/* U+6c36 */ { 0, 0, 0, 0, 0 },
/* U+6c37 */ { 0, 0, 0, 0, 0 },
/* U+6c38 */ { 0, 0, 0, 0, 0 },
/* U+6c39 */ { 0, 0, 0, 0, 0 },
/* U+6c3a */ { 0, 0, 0, 0, 0 },
/* U+6c3b */ { 0, 0, 0, 0, 0 },
/* U+6c3c */ { 0, 0, 0, 0, 0 },
/* U+6c3d */ { 0, 0, 0, 0, 0 },
/* U+6c3e */ { 0, 0, 0, 0, 0 },
/* U+6c3f */ { 0, 0, 0, 0, 0 },
/* U+6c40 */ { 0, 0, 0, 0, 0 },
/* U+6c41 */ { 0, 0, 0, 0, 0 },
/* U+6c42 */ { 0, 0, 0, 0, 0 },
/* U+6c43 */ { 0, 0, 0, 0, 0 },
/* U+6c44 */ { 0, 0, 0, 0, 0 },
/* U+6c45 */ { 0, 0, 0, 0, 0 },
/* U+6c46 */ { 0, 0, 0, 0, 0 },
/* U+6c47 */ { 0, 0, 0, 0, 0 },
/* U+6c48 */ { 0, 0, 0, 0, 0 },
/* U+6c49 */ { 0, 0, 0, 0, 0 },
/* U+6c4a */ { 0, 0, 0, 0, 0 },
/* U+6c4b */ { 0, 0, 0, 0, 0 },
/* U+6c4c */ { 0, 0, 0, 0, 0 },
/* U+6c4d */ { 0, 0, 0, 0, 0 },
/* U+6c4e */ { 0, 0, 0, 0, 0 },
/* U+6c4f */ { 0, 0, 0, 0, 0 },
/* U+6c50 */ { 0, 0, 0, 0, 0 },
/* U+6c51 */ { 0, 0, 0, 0, 0 },
/* U+6c52 */ { 0, 0, 0, 0, 0 },
/* U+6c53 */ { 0, 0, 0, 0, 0 },
/* U+6c54 */ { 0, 0, 0, 0, 0 },
/* U+6c55 */ { 0, 0, 0, 0, 0 },
/* U+6c56 */ { 0, 0, 0, 0, 0 },
/* U+6c57 */ { 0, 0, 0, 0, 0 },
/* U+6c58 */ { 0, 0, 0, 0, 0 },
/* U+6c59 */ { 0, 0, 0, 0, 0 },
/* U+6c5a */ { 0, 0, 0, 0, 0 },
/* U+6c5b */ { 0, 0, 0, 0, 0 },
/* U+6c5c */ { 0, 0, 0, 0, 0 },
/* U+6c5d */ { 0, 0, 0, 0, 0 },
/* U+6c5e */ { 0, 0, 0, 0, 0 },
/* U+6c5f */ { 0, 0, 0, 0, 0 },
/* U+6c60 */ { 0, 0, 0, 0, 0 },
/* U+6c61 */ { 0, 0, 0, 0, 0 },
/* U+6c62 */ { 0, 0, 0, 0, 0 },
/* U+6c63 */ { 0, 0, 0, 0, 0 },
/* U+6c64 */ { 0, 0, 0, 0, 0 },
/* U+6c65 */ { 0, 0, 0, 0, 0 },
/* U+6c66 */ { 0, 0, 0, 0, 0 },
/* U+6c67 */ { 0, 0, 0, 0, 0 },
/* U+6c68 */ { 0, 0, 0, 0, 0 },
/* U+6c69 */ { 0, 0, 0, 0, 0 },
/* U+6c6a */ { 0, 0, 0, 0, 0 },
/* U+6c6b */ { 0, 0, 0, 0, 0 },
/* U+6c6c */ { 0, 0, 0, 0, 0 },
/* U+6c6d */ { 0, 0, 0, 0, 0 },
/* U+6c6e */ { 0, 0, 0, 0, 0 },
/* U+6c6f */ { 0, 0, 0, 0, 0 },
/* U+6c70 */ { 0, 0, 0, 0, 0 },
/* U+6c71 */ { 0, 0, 0, 0, 0 },
/* U+6c72 */ { 0, 0, 0, 0, 0 },
/* U+6c73 */ { 0, 0, 0, 0, 0 },
/* U+6c74 */ { 0, 0, 0, 0, 0 },
/* U+6c75 */ { 0, 0, 0, 0, 0 },
/* U+6c76 */ { 0, 0, 0, 0, 0 },
/* U+6c77 */ { 0, 0, 0, 0, 0 },
/* U+6c78 */ { 0, 0, 0, 0, 0 },
/* U+6c79 */ { 0, 0, 0, 0, 0 },
/* U+6c7a */ { 0, 0, 0, 0, 0 },
/* U+6c7b */ { 0, 0, 0, 0, 0 },
/* U+6c7c */ { 0, 0, 0, 0, 0 },
/* U+6c7d */ { 0, 0, 0, 0, 0 },
/* U+6c7e */ { 0, 0, 0, 0, 0 },
/* U+6c7f */ { 0, 0, 0, 0, 0 },
/* U+6c80 */ { 0, 0, 0, 0, 0 },
/* U+6c81 */ { 0, 0, 0, 0, 0 },
/* U+6c82 */ { 0, 0, 0, 0, 0 },
/* U+6c83 */ { 0, 0, 0, 0, 0 },
/* U+6c84 */ { 0, 0, 0, 0, 0 },
/* U+6c85 */ { 0, 0, 0, 0, 0 },
/* U+6c86 */ { 0, 0, 0, 0, 0 },
/* U+6c87 */ { 0, 0, 0, 0, 0 },
/* U+6c88 */ { 0, 0, 0, 0, 0 },
/* U+6c89 */ { 0, 0, 0, 0, 0 },
/* U+6c8a */ { 0, 0, 0, 0, 0 },
/* U+6c8b */ { 0, 0, 0, 0, 0 },
/* U+6c8c */ { 0, 0, 0, 0, 0 },
/* U+6c8d */ { 0, 0, 0, 0, 0 },
/* U+6c8e */ { 0, 0, 0, 0, 0 },
/* U+6c8f */ { 0, 0, 0, 0, 0 },
/* U+6c90 */ { 0, 0, 0, 0, 0 },
/* U+6c91 */ { 0, 0, 0, 0, 0 },
/* U+6c92 */ { 0, 0, 0, 0, 0 },
/* U+6c93 */ { 0, 0, 0, 0, 0 },
/* U+6c94 */ { 0, 0, 0, 0, 0 },
/* U+6c95 */ { 0, 0, 0, 0, 0 },
/* U+6c96 */ { 0, 0, 0, 0, 0 },
/* U+6c97 */ { 0, 0, 0, 0, 0 },
/* U+6c98 */ { 0, 0, 0, 0, 0 },
/* U+6c99 */ { 0, 0, 0, 0, 0 },
/* U+6c9a */ { 0, 0, 0, 0, 0 },
/* U+6c9b */ { 0, 0, 0, 0, 0 },
/* U+6c9c */ { 0, 0, 0, 0, 0 },
/* U+6c9d */ { 0, 0, 0, 0, 0 },
/* U+6c9e */ { 0, 0, 0, 0, 0 },
/* U+6c9f */ { 0, 0, 0, 0, 0 },
/* U+6ca0 */ { 0, 0, 0, 0, 0 },
/* U+6ca1 */ { 0, 0, 0, 0, 0 },
/* U+6ca2 */ { 0, 0, 0, 0, 0 },
/* U+6ca3 */ { 0, 0, 0, 0, 0 },
/* U+6ca4 */ { 0, 0, 0, 0, 0 },
/* U+6ca5 */ { 0, 0, 0, 0, 0 },
/* U+6ca6 */ { 0, 0, 0, 0, 0 },
/* U+6ca7 */ { 0, 0, 0, 0, 0 },
/* U+6ca8 */ { 0, 0, 0, 0, 0 },
/* U+6ca9 */ { 0, 0, 0, 0, 0 },
/* U+6caa */ { 0, 0, 0, 0, 0 },
/* U+6cab */ { 0, 0, 0, 0, 0 },
/* U+6cac */ { 0, 0, 0, 0, 0 },
/* U+6cad */ { 0, 0, 0, 0, 0 },
/* U+6cae */ { 0, 0, 0, 0, 0 },
/* U+6caf */ { 0, 0, 0, 0, 0 },
/* U+6cb0 */ { 0, 0, 0, 0, 0 },
/* U+6cb1 */ { 0, 0, 0, 0, 0 },
/* U+6cb2 */ { 0, 0, 0, 0, 0 },
/* U+6cb3 */ { 0, 0, 0, 0, 0 },
/* U+6cb4 */ { 0, 0, 0, 0, 0 },
/* U+6cb5 */ { 0, 0, 0, 0, 0 },
/* U+6cb6 */ { 0, 0, 0, 0, 0 },
/* U+6cb7 */ { 0, 0, 0, 0, 0 },
/* U+6cb8 */ { 0, 0, 0, 0, 0 },
/* U+6cb9 */ { 0, 0, 0, 0, 0 },
/* U+6cba */ { 0, 0, 0, 0, 0 },
/* U+6cbb */ { 0, 0, 0, 0, 0 },
/* U+6cbc */ { 0, 0, 0, 0, 0 },
/* U+6cbd */ { 0, 0, 0, 0, 0 },
/* U+6cbe */ { 0, 0, 0, 0, 0 },
/* U+6cbf */ { 0, 0, 0, 0, 0 },
/* U+6cc0 */ { 0, 0, 0, 0, 0 },
/* U+6cc1 */ { 0, 0, 0, 0, 0 },
/* U+6cc2 */ { 0, 0, 0, 0, 0 },
/* U+6cc3 */ { 0, 0, 0, 0, 0 },
/* U+6cc4 */ { 0, 0, 0, 0, 0 },
/* U+6cc5 */ { 0, 0, 0, 0, 0 },
/* U+6cc6 */ { 0, 0, 0, 0, 0 },
/* U+6cc7 */ { 0, 0, 0, 0, 0 },
/* U+6cc8 */ { 0, 0, 0, 0, 0 },
/* U+6cc9 */ { 0, 0, 0, 0, 0 },
/* U+6cca */ { 0, 0, 0, 0, 0 },
/* U+6ccb */ { 0, 0, 0, 0, 0 },
/* U+6ccc */ { 0, 0, 0, 0, 0 },
/* U+6ccd */ { 0, 0, 0, 0, 0 },
/* U+6cce */ { 0, 0, 0, 0, 0 },
/* U+6ccf */ { 0, 0, 0, 0, 0 },
/* U+6cd0 */ { 0, 0, 0, 0, 0 },
/* U+6cd1 */ { 0, 0, 0, 0, 0 },
/* U+6cd2 */ { 0, 0, 0, 0, 0 },
/* U+6cd3 */ { 0, 0, 0, 0, 0 },
/* U+6cd4 */ { 0, 0, 0, 0, 0 },
/* U+6cd5 */ { 0, 0, 0, 0, 0 },
/* U+6cd6 */ { 0, 0, 0, 0, 0 },
/* U+6cd7 */ { 0, 0, 0, 0, 0 },
/* U+6cd8 */ { 0, 0, 0, 0, 0 },
/* U+6cd9 */ { 0, 0, 0, 0, 0 },
/* U+6cda */ { 0, 0, 0, 0, 0 },
/* U+6cdb */ { 0, 0, 0, 0, 0 },
/* U+6cdc */ { 0, 0, 0, 0, 0 },
/* U+6cdd */ { 0, 0, 0, 0, 0 },
/* U+6cde */ { 0, 0, 0, 0, 0 },
/* U+6cdf */ { 0, 0, 0, 0, 0 },
/* U+6ce0 */ { 0, 0, 0, 0, 0 },
/* U+6ce1 */ { 0, 0, 0, 0, 0 },
/* U+6ce2 */ { 0, 0, 0, 0, 0 },
/* U+6ce3 */ { 0, 0, 0, 0, 0 },
/* U+6ce4 */ { 0, 0, 0, 0, 0 },
/* U+6ce5 */ { 0, 0, 0, 0, 0 },
/* U+6ce6 */ { 0, 0, 0, 0, 0 },
/* U+6ce7 */ { 0, 0, 0, 0, 0 },
/* U+6ce8 */ { 0, 0, 0, 0, 0 },
/* U+6ce9 */ { 0, 0, 0, 0, 0 },
/* U+6cea */ { 0, 0, 0, 0, 0 },
/* U+6ceb */ { 0, 0, 0, 0, 0 },
/* U+6cec */ { 0, 0, 0, 0, 0 },
/* U+6ced */ { 0, 0, 0, 0, 0 },
/* U+6cee */ { 0, 0, 0, 0, 0 },
/* U+6cef */ { 0, 0, 0, 0, 0 },
/* U+6cf0 */ { 0, 0, 0, 0, 0 },
/* U+6cf1 */ { 0, 0, 0, 0, 0 },
/* U+6cf2 */ { 0, 0, 0, 0, 0 },
/* U+6cf3 */ { 0, 0, 0, 0, 0 },
/* U+6cf4 */ { 0, 0, 0, 0, 0 },
/* U+6cf5 */ { 0, 0, 0, 0, 0 },
/* U+6cf6 */ { 0, 0, 0, 0, 0 },
/* U+6cf7 */ { 0, 0, 0, 0, 0 },
/* U+6cf8 */ { 0, 0, 0, 0, 0 },
/* U+6cf9 */ { 0, 0, 0, 0, 0 },
/* U+6cfa */ { 0, 0, 0, 0, 0 },
/* U+6cfb */ { 0, 0, 0, 0, 0 },
/* U+6cfc */ { 0, 0, 0, 0, 0 },
/* U+6cfd */ { 0, 0, 0, 0, 0 },
/* U+6cfe */ { 0, 0, 0, 0, 0 },
/* U+6cff */ { 0, 0, 0, 0, 0 },
/* U+6d00 */ { 0, 0, 0, 0, 0 },
/* U+6d01 */ { 0, 0, 0, 0, 0 },
/* U+6d02 */ { 0, 0, 0, 0, 0 },
/* U+6d03 */ { 0, 0, 0, 0, 0 },
/* U+6d04 */ { 0, 0, 0, 0, 0 },
/* U+6d05 */ { 0, 0, 0, 0, 0 },
/* U+6d06 */ { 0, 0, 0, 0, 0 },
/* U+6d07 */ { 0, 0, 0, 0, 0 },
/* U+6d08 */ { 0, 0, 0, 0, 0 },
/* U+6d09 */ { 0, 0, 0, 0, 0 },
/* U+6d0a */ { 0, 0, 0, 0, 0 },
/* U+6d0b */ { 0, 0, 0, 0, 0 },
/* U+6d0c */ { 0, 0, 0, 0, 0 },
/* U+6d0d */ { 0, 0, 0, 0, 0 },
/* U+6d0e */ { 0, 0, 0, 0, 0 },
/* U+6d0f */ { 0, 0, 0, 0, 0 },
/* U+6d10 */ { 0, 0, 0, 0, 0 },
/* U+6d11 */ { 0, 0, 0, 0, 0 },
/* U+6d12 */ { 0, 0, 0, 0, 0 },
/* U+6d13 */ { 0, 0, 0, 0, 0 },
/* U+6d14 */ { 0, 0, 0, 0, 0 },
/* U+6d15 */ { 0, 0, 0, 0, 0 },
/* U+6d16 */ { 0, 0, 0, 0, 0 },
/* U+6d17 */ { 0, 0, 0, 0, 0 },
/* U+6d18 */ { 0, 0, 0, 0, 0 },
/* U+6d19 */ { 0, 0, 0, 0, 0 },
/* U+6d1a */ { 0, 0, 0, 0, 0 },
/* U+6d1b */ { 0, 0, 0, 0, 0 },
/* U+6d1c */ { 0, 0, 0, 0, 0 },
/* U+6d1d */ { 0, 0, 0, 0, 0 },
/* U+6d1e */ { 0, 0, 0, 0, 0 },
/* U+6d1f */ { 0, 0, 0, 0, 0 },
/* U+6d20 */ { 0, 0, 0, 0, 0 },
/* U+6d21 */ { 0, 0, 0, 0, 0 },
/* U+6d22 */ { 0, 0, 0, 0, 0 },
/* U+6d23 */ { 0, 0, 0, 0, 0 },
/* U+6d24 */ { 0, 0, 0, 0, 0 },
/* U+6d25 */ { 0, 0, 0, 0, 0 },
/* U+6d26 */ { 0, 0, 0, 0, 0 },
/* U+6d27 */ { 0, 0, 0, 0, 0 },
/* U+6d28 */ { 0, 0, 0, 0, 0 },
/* U+6d29 */ { 0, 0, 0, 0, 0 },
/* U+6d2a */ { 0, 0, 0, 0, 0 },
/* U+6d2b */ { 0, 0, 0, 0, 0 },
/* U+6d2c */ { 0, 0, 0, 0, 0 },
/* U+6d2d */ { 0, 0, 0, 0, 0 },
/* U+6d2e */ { 0, 0, 0, 0, 0 },
/* U+6d2f */ { 0, 0, 0, 0, 0 },
/* U+6d30 */ { 0, 0, 0, 0, 0 },
/* U+6d31 */ { 0, 0, 0, 0, 0 },
/* U+6d32 */ { 0, 0, 0, 0, 0 },
/* U+6d33 */ { 0, 0, 0, 0, 0 },
/* U+6d34 */ { 0, 0, 0, 0, 0 },
/* U+6d35 */ { 0, 0, 0, 0, 0 },
/* U+6d36 */ { 0, 0, 0, 0, 0 },
/* U+6d37 */ { 0, 0, 0, 0, 0 },
/* U+6d38 */ { 0, 0, 0, 0, 0 },
/* U+6d39 */ { 0, 0, 0, 0, 0 },
/* U+6d3a */ { 0, 0, 0, 0, 0 },
/* U+6d3b */ { 0, 0, 0, 0, 0 },
/* U+6d3c */ { 0, 0, 0, 0, 0 },
/* U+6d3d */ { 0, 0, 0, 0, 0 },
/* U+6d3e */ { 0, 0, 0, 0, 0 },
/* U+6d3f */ { 0, 0, 0, 0, 0 },
/* U+6d40 */ { 0, 0, 0, 0, 0 },
/* U+6d41 */ { 0, 0, 0, 0, 0 },
/* U+6d42 */ { 0, 0, 0, 0, 0 },
/* U+6d43 */ { 0, 0, 0, 0, 0 },
/* U+6d44 */ { 0, 0, 0, 0, 0 },
/* U+6d45 */ { 0, 0, 0, 0, 0 },
/* U+6d46 */ { 0, 0, 0, 0, 0 },
/* U+6d47 */ { 0, 0, 0, 0, 0 },
/* U+6d48 */ { 0, 0, 0, 0, 0 },
/* U+6d49 */ { 0, 0, 0, 0, 0 },
/* U+6d4a */ { 0, 0, 0, 0, 0 },
/* U+6d4b */ { 0, 0, 0, 0, 0 },
/* U+6d4c */ { 0, 0, 0, 0, 0 },
/* U+6d4d */ { 0, 0, 0, 0, 0 },
/* U+6d4e */ { 0, 0, 0, 0, 0 },
/* U+6d4f */ { 0, 0, 0, 0, 0 },
/* U+6d50 */ { 0, 0, 0, 0, 0 },
/* U+6d51 */ { 0, 0, 0, 0, 0 },
/* U+6d52 */ { 0, 0, 0, 0, 0 },
/* U+6d53 */ { 0, 0, 0, 0, 0 },
/* U+6d54 */ { 0, 0, 0, 0, 0 },
/* U+6d55 */ { 0, 0, 0, 0, 0 },
/* U+6d56 */ { 0, 0, 0, 0, 0 },
/* U+6d57 */ { 0, 0, 0, 0, 0 },
/* U+6d58 */ { 0, 0, 0, 0, 0 },
/* U+6d59 */ { 0, 0, 0, 0, 0 },
/* U+6d5a */ { 0, 0, 0, 0, 0 },
/* U+6d5b */ { 0, 0, 0, 0, 0 },
/* U+6d5c */ { 0, 0, 0, 0, 0 },
/* U+6d5d */ { 0, 0, 0, 0, 0 },
/* U+6d5e */ { 0, 0, 0, 0, 0 },
/* U+6d5f */ { 0, 0, 0, 0, 0 },
/* U+6d60 */ { 0, 0, 0, 0, 0 },
/* U+6d61 */ { 0, 0, 0, 0, 0 },
/* U+6d62 */ { 0, 0, 0, 0, 0 },
/* U+6d63 */ { 0, 0, 0, 0, 0 },
/* U+6d64 */ { 0, 0, 0, 0, 0 },
/* U+6d65 */ { 0, 0, 0, 0, 0 },
/* U+6d66 */ { 0, 0, 0, 0, 0 },
/* U+6d67 */ { 0, 0, 0, 0, 0 },
/* U+6d68 */ { 0, 0, 0, 0, 0 },
/* U+6d69 */ { 0, 0, 0, 0, 0 },
/* U+6d6a */ { 0, 0, 0, 0, 0 },
/* U+6d6b */ { 0, 0, 0, 0, 0 },
/* U+6d6c */ { 0, 0, 0, 0, 0 },
/* U+6d6d */ { 0, 0, 0, 0, 0 },
/* U+6d6e */ { 0, 0, 0, 0, 0 },
/* U+6d6f */ { 0, 0, 0, 0, 0 },
/* U+6d70 */ { 0, 0, 0, 0, 0 },
/* U+6d71 */ { 0, 0, 0, 0, 0 },
/* U+6d72 */ { 0, 0, 0, 0, 0 },
/* U+6d73 */ { 0, 0, 0, 0, 0 },
/* U+6d74 */ { 0, 0, 0, 0, 0 },
/* U+6d75 */ { 0, 0, 0, 0, 0 },
/* U+6d76 */ { 0, 0, 0, 0, 0 },
/* U+6d77 */ { 0, 0, 0, 0, 0 },
/* U+6d78 */ { 0, 0, 0, 0, 0 },
/* U+6d79 */ { 0, 0, 0, 0, 0 },
/* U+6d7a */ { 0, 0, 0, 0, 0 },
/* U+6d7b */ { 0, 0, 0, 0, 0 },
/* U+6d7c */ { 0, 0, 0, 0, 0 },
/* U+6d7d */ { 0, 0, 0, 0, 0 },
/* U+6d7e */ { 0, 0, 0, 0, 0 },
/* U+6d7f */ { 0, 0, 0, 0, 0 },
/* U+6d80 */ { 0, 0, 0, 0, 0 },
/* U+6d81 */ { 0, 0, 0, 0, 0 },
/* U+6d82 */ { 0, 0, 0, 0, 0 },
/* U+6d83 */ { 0, 0, 0, 0, 0 },
/* U+6d84 */ { 0, 0, 0, 0, 0 },
/* U+6d85 */ { 0, 0, 0, 0, 0 },
/* U+6d86 */ { 0, 0, 0, 0, 0 },
/* U+6d87 */ { 0, 0, 0, 0, 0 },
/* U+6d88 */ { 0, 0, 0, 0, 0 },
/* U+6d89 */ { 0, 0, 0, 0, 0 },
/* U+6d8a */ { 0, 0, 0, 0, 0 },
/* U+6d8b */ { 0, 0, 0, 0, 0 },
/* U+6d8c */ { 0, 0, 0, 0, 0 },
/* U+6d8d */ { 0, 0, 0, 0, 0 },
/* U+6d8e */ { 0, 0, 0, 0, 0 },
/* U+6d8f */ { 0, 0, 0, 0, 0 },
/* U+6d90 */ { 0, 0, 0, 0, 0 },
/* U+6d91 */ { 0, 0, 0, 0, 0 },
/* U+6d92 */ { 0, 0, 0, 0, 0 },
/* U+6d93 */ { 0, 0, 0, 0, 0 },
/* U+6d94 */ { 0, 0, 0, 0, 0 },
/* U+6d95 */ { 0, 0, 0, 0, 0 },
/* U+6d96 */ { 0, 0, 0, 0, 0 },
/* U+6d97 */ { 0, 0, 0, 0, 0 },
/* U+6d98 */ { 0, 0, 0, 0, 0 },
/* U+6d99 */ { 0, 0, 0, 0, 0 },
/* U+6d9a */ { 0, 0, 0, 0, 0 },
/* U+6d9b */ { 0, 0, 0, 0, 0 },
/* U+6d9c */ { 0, 0, 0, 0, 0 },
/* U+6d9d */ { 0, 0, 0, 0, 0 },
/* U+6d9e */ { 0, 0, 0, 0, 0 },
/* U+6d9f */ { 0, 0, 0, 0, 0 },
/* U+6da0 */ { 0, 0, 0, 0, 0 },
/* U+6da1 */ { 0, 0, 0, 0, 0 },
/* U+6da2 */ { 0, 0, 0, 0, 0 },
/* U+6da3 */ { 0, 0, 0, 0, 0 },
/* U+6da4 */ { 0, 0, 0, 0, 0 },
/* U+6da5 */ { 0, 0, 0, 0, 0 },
/* U+6da6 */ { 0, 0, 0, 0, 0 },
/* U+6da7 */ { 0, 0, 0, 0, 0 },
/* U+6da8 */ { 0, 0, 0, 0, 0 },
/* U+6da9 */ { 0, 0, 0, 0, 0 },
/* U+6daa */ { 0, 0, 0, 0, 0 },
/* U+6dab */ { 0, 0, 0, 0, 0 },
/* U+6dac */ { 0, 0, 0, 0, 0 },
/* U+6dad */ { 0, 0, 0, 0, 0 },
/* U+6dae */ { 0, 0, 0, 0, 0 },
/* U+6daf */ { 0, 0, 0, 0, 0 },
/* U+6db0 */ { 0, 0, 0, 0, 0 },
/* U+6db1 */ { 0, 0, 0, 0, 0 },
/* U+6db2 */ { 0, 0, 0, 0, 0 },
/* U+6db3 */ { 0, 0, 0, 0, 0 },
/* U+6db4 */ { 0, 0, 0, 0, 0 },
/* U+6db5 */ { 0, 0, 0, 0, 0 },
/* U+6db6 */ { 0, 0, 0, 0, 0 },
/* U+6db7 */ { 0, 0, 0, 0, 0 },
/* U+6db8 */ { 0, 0, 0, 0, 0 },
/* U+6db9 */ { 0, 0, 0, 0, 0 },
/* U+6dba */ { 0, 0, 0, 0, 0 },
/* U+6dbb */ { 0, 0, 0, 0, 0 },
/* U+6dbc */ { 0, 0, 0, 0, 0 },
/* U+6dbd */ { 0, 0, 0, 0, 0 },
/* U+6dbe */ { 0, 0, 0, 0, 0 },
/* U+6dbf */ { 0, 0, 0, 0, 0 },
/* U+6dc0 */ { 0, 0, 0, 0, 0 },
/* U+6dc1 */ { 0, 0, 0, 0, 0 },
/* U+6dc2 */ { 0, 0, 0, 0, 0 },
/* U+6dc3 */ { 0, 0, 0, 0, 0 },
/* U+6dc4 */ { 0, 0, 0, 0, 0 },
/* U+6dc5 */ { 0, 0, 0, 0, 0 },
/* U+6dc6 */ { 0, 0, 0, 0, 0 },
/* U+6dc7 */ { 0, 0, 0, 0, 0 },
/* U+6dc8 */ { 0, 0, 0, 0, 0 },
/* U+6dc9 */ { 0, 0, 0, 0, 0 },
/* U+6dca */ { 0, 0, 0, 0, 0 },
/* U+6dcb */ { 0, 0, 0, 0, 0 },
/* U+6dcc */ { 0, 0, 0, 0, 0 },
/* U+6dcd */ { 0, 0, 0, 0, 0 },
/* U+6dce */ { 0, 0, 0, 0, 0 },
/* U+6dcf */ { 0, 0, 0, 0, 0 },
/* U+6dd0 */ { 0, 0, 0, 0, 0 },
/* U+6dd1 */ { 0, 0, 0, 0, 0 },
/* U+6dd2 */ { 0, 0, 0, 0, 0 },
/* U+6dd3 */ { 0, 0, 0, 0, 0 },
/* U+6dd4 */ { 0, 0, 0, 0, 0 },
/* U+6dd5 */ { 0, 0, 0, 0, 0 },
/* U+6dd6 */ { 0, 0, 0, 0, 0 },
/* U+6dd7 */ { 0, 0, 0, 0, 0 },
/* U+6dd8 */ { 0, 0, 0, 0, 0 },
/* U+6dd9 */ { 0, 0, 0, 0, 0 },
/* U+6dda */ { 0, 0, 0, 0, 0 },
/* U+6ddb */ { 0, 0, 0, 0, 0 },
/* U+6ddc */ { 0, 0, 0, 0, 0 },
/* U+6ddd */ { 0, 0, 0, 0, 0 },
/* U+6dde */ { 0, 0, 0, 0, 0 },
/* U+6ddf */ { 0, 0, 0, 0, 0 },
/* U+6de0 */ { 0, 0, 0, 0, 0 },
/* U+6de1 */ { 0, 0, 0, 0, 0 },
/* U+6de2 */ { 0, 0, 0, 0, 0 },
/* U+6de3 */ { 0, 0, 0, 0, 0 },
/* U+6de4 */ { 0, 0, 0, 0, 0 },
/* U+6de5 */ { 0, 0, 0, 0, 0 },
/* U+6de6 */ { 0, 0, 0, 0, 0 },
/* U+6de7 */ { 0, 0, 0, 0, 0 },
/* U+6de8 */ { 0, 0, 0, 0, 0 },
/* U+6de9 */ { 0, 0, 0, 0, 0 },
/* U+6dea */ { 0, 0, 0, 0, 0 },
/* U+6deb */ { 0, 0, 0, 0, 0 },
/* U+6dec */ { 0, 0, 0, 0, 0 },
/* U+6ded */ { 0, 0, 0, 0, 0 },
/* U+6dee */ { 0, 0, 0, 0, 0 },
/* U+6def */ { 0, 0, 0, 0, 0 },
/* U+6df0 */ { 0, 0, 0, 0, 0 },
/* U+6df1 */ { 0, 0, 0, 0, 0 },
/* U+6df2 */ { 0, 0, 0, 0, 0 },
/* U+6df3 */ { 0, 0, 0, 0, 0 },
/* U+6df4 */ { 0, 0, 0, 0, 0 },
/* U+6df5 */ { 0, 0, 0, 0, 0 },
/* U+6df6 */ { 0, 0, 0, 0, 0 },
/* U+6df7 */ { 0, 0, 0, 0, 0 },
/* U+6df8 */ { 0, 0, 0, 0, 0 },
/* U+6df9 */ { 0, 0, 0, 0, 0 },
/* U+6dfa */ { 0, 0, 0, 0, 0 },
/* U+6dfb */ { 0, 0, 0, 0, 0 },
/* U+6dfc */ { 0, 0, 0, 0, 0 },
/* U+6dfd */ { 0, 0, 0, 0, 0 },
/* U+6dfe */ { 0, 0, 0, 0, 0 },
/* U+6dff */ { 0, 0, 0, 0, 0 },
/* U+6e00 */ { 0, 0, 0, 0, 0 },
/* U+6e01 */ { 0, 0, 0, 0, 0 },
/* U+6e02 */ { 0, 0, 0, 0, 0 },
/* U+6e03 */ { 0, 0, 0, 0, 0 },
/* U+6e04 */ { 0, 0, 0, 0, 0 },
/* U+6e05 */ { 0, 0, 0, 0, 0 },
/* U+6e06 */ { 0, 0, 0, 0, 0 },
/* U+6e07 */ { 0, 0, 0, 0, 0 },
/* U+6e08 */ { 0, 0, 0, 0, 0 },
/* U+6e09 */ { 0, 0, 0, 0, 0 },
/* U+6e0a */ { 0, 0, 0, 0, 0 },
/* U+6e0b */ { 0, 0, 0, 0, 0 },
/* U+6e0c */ { 0, 0, 0, 0, 0 },
/* U+6e0d */ { 0, 0, 0, 0, 0 },
/* U+6e0e */ { 0, 0, 0, 0, 0 },
/* U+6e0f */ { 0, 0, 0, 0, 0 },
/* U+6e10 */ { 0, 0, 0, 0, 0 },
/* U+6e11 */ { 0, 0, 0, 0, 0 },
/* U+6e12 */ { 0, 0, 0, 0, 0 },
/* U+6e13 */ { 0, 0, 0, 0, 0 },
/* U+6e14 */ { 0, 0, 0, 0, 0 },
/* U+6e15 */ { 0, 0, 0, 0, 0 },
/* U+6e16 */ { 0, 0, 0, 0, 0 },
/* U+6e17 */ { 0, 0, 0, 0, 0 },
/* U+6e18 */ { 0, 0, 0, 0, 0 },
/* U+6e19 */ { 0, 0, 0, 0, 0 },
/* U+6e1a */ { 0, 0, 0, 0, 0 },
/* U+6e1b */ { 0, 0, 0, 0, 0 },
/* U+6e1c */ { 0, 0, 0, 0, 0 },
/* U+6e1d */ { 0, 0, 0, 0, 0 },
/* U+6e1e */ { 0, 0, 0, 0, 0 },
/* U+6e1f */ { 0, 0, 0, 0, 0 },
/* U+6e20 */ { 0, 0, 0, 0, 0 },
/* U+6e21 */ { 0, 0, 0, 0, 0 },
/* U+6e22 */ { 0, 0, 0, 0, 0 },
/* U+6e23 */ { 0, 0, 0, 0, 0 },
/* U+6e24 */ { 0, 0, 0, 0, 0 },
/* U+6e25 */ { 0, 0, 0, 0, 0 },
/* U+6e26 */ { 0, 0, 0, 0, 0 },
/* U+6e27 */ { 0, 0, 0, 0, 0 },
/* U+6e28 */ { 0, 0, 0, 0, 0 },
/* U+6e29 */ { 0, 0, 0, 0, 0 },
/* U+6e2a */ { 0, 0, 0, 0, 0 },
/* U+6e2b */ { 0, 0, 0, 0, 0 },
/* U+6e2c */ { 0, 0, 0, 0, 0 },
/* U+6e2d */ { 0, 0, 0, 0, 0 },
/* U+6e2e */ { 0, 0, 0, 0, 0 },
/* U+6e2f */ { 0, 0, 0, 0, 0 },
/* U+6e30 */ { 0, 0, 0, 0, 0 },
/* U+6e31 */ { 0, 0, 0, 0, 0 },
/* U+6e32 */ { 0, 0, 0, 0, 0 },
/* U+6e33 */ { 0, 0, 0, 0, 0 },
/* U+6e34 */ { 0, 0, 0, 0, 0 },
/* U+6e35 */ { 0, 0, 0, 0, 0 },
/* U+6e36 */ { 0, 0, 0, 0, 0 },
/* U+6e37 */ { 0, 0, 0, 0, 0 },
/* U+6e38 */ { 0, 0, 0, 0, 0 },
/* U+6e39 */ { 0, 0, 0, 0, 0 },
/* U+6e3a */ { 0, 0, 0, 0, 0 },
/* U+6e3b */ { 0, 0, 0, 0, 0 },
/* U+6e3c */ { 0, 0, 0, 0, 0 },
/* U+6e3d */ { 0, 0, 0, 0, 0 },
/* U+6e3e */ { 0, 0, 0, 0, 0 },
/* U+6e3f */ { 0, 0, 0, 0, 0 },
/* U+6e40 */ { 0, 0, 0, 0, 0 },
/* U+6e41 */ { 0, 0, 0, 0, 0 },
/* U+6e42 */ { 0, 0, 0, 0, 0 },
/* U+6e43 */ { 0, 0, 0, 0, 0 },
/* U+6e44 */ { 0, 0, 0, 0, 0 },
/* U+6e45 */ { 0, 0, 0, 0, 0 },
/* U+6e46 */ { 0, 0, 0, 0, 0 },
/* U+6e47 */ { 0, 0, 0, 0, 0 },
/* U+6e48 */ { 0, 0, 0, 0, 0 },
/* U+6e49 */ { 0, 0, 0, 0, 0 },
/* U+6e4a */ { 0, 0, 0, 0, 0 },
/* U+6e4b */ { 0, 0, 0, 0, 0 },
/* U+6e4c */ { 0, 0, 0, 0, 0 },
/* U+6e4d */ { 0, 0, 0, 0, 0 },
/* U+6e4e */ { 0, 0, 0, 0, 0 },
/* U+6e4f */ { 0, 0, 0, 0, 0 },
/* U+6e50 */ { 0, 0, 0, 0, 0 },
/* U+6e51 */ { 0, 0, 0, 0, 0 },
/* U+6e52 */ { 0, 0, 0, 0, 0 },
/* U+6e53 */ { 0, 0, 0, 0, 0 },
/* U+6e54 */ { 0, 0, 0, 0, 0 },
/* U+6e55 */ { 0, 0, 0, 0, 0 },
/* U+6e56 */ { 0, 0, 0, 0, 0 },
/* U+6e57 */ { 0, 0, 0, 0, 0 },
/* U+6e58 */ { 0, 0, 0, 0, 0 },
/* U+6e59 */ { 0, 0, 0, 0, 0 },
/* U+6e5a */ { 0, 0, 0, 0, 0 },
/* U+6e5b */ { 0, 0, 0, 0, 0 },
/* U+6e5c */ { 0, 0, 0, 0, 0 },
/* U+6e5d */ { 0, 0, 0, 0, 0 },
/* U+6e5e */ { 0, 0, 0, 0, 0 },
/* U+6e5f */ { 0, 0, 0, 0, 0 },
/* U+6e60 */ { 0, 0, 0, 0, 0 },
/* U+6e61 */ { 0, 0, 0, 0, 0 },
/* U+6e62 */ { 0, 0, 0, 0, 0 },
/* U+6e63 */ { 0, 0, 0, 0, 0 },
/* U+6e64 */ { 0, 0, 0, 0, 0 },
/* U+6e65 */ { 0, 0, 0, 0, 0 },
/* U+6e66 */ { 0, 0, 0, 0, 0 },
/* U+6e67 */ { 0, 0, 0, 0, 0 },
/* U+6e68 */ { 0, 0, 0, 0, 0 },
/* U+6e69 */ { 0, 0, 0, 0, 0 },
/* U+6e6a */ { 0, 0, 0, 0, 0 },
/* U+6e6b */ { 0, 0, 0, 0, 0 },
/* U+6e6c */ { 0, 0, 0, 0, 0 },
/* U+6e6d */ { 0, 0, 0, 0, 0 },
/* U+6e6e */ { 0, 0, 0, 0, 0 },
/* U+6e6f */ { 0, 0, 0, 0, 0 },
/* U+6e70 */ { 0, 0, 0, 0, 0 },
/* U+6e71 */ { 0, 0, 0, 0, 0 },
/* U+6e72 */ { 0, 0, 0, 0, 0 },
/* U+6e73 */ { 0, 0, 0, 0, 0 },
/* U+6e74 */ { 0, 0, 0, 0, 0 },
/* U+6e75 */ { 0, 0, 0, 0, 0 },
/* U+6e76 */ { 0, 0, 0, 0, 0 },
/* U+6e77 */ { 0, 0, 0, 0, 0 },
/* U+6e78 */ { 0, 0, 0, 0, 0 },
/* U+6e79 */ { 0, 0, 0, 0, 0 },
/* U+6e7a */ { 0, 0, 0, 0, 0 },
/* U+6e7b */ { 0, 0, 0, 0, 0 },
/* U+6e7c */ { 0, 0, 0, 0, 0 },
/* U+6e7d */ { 0, 0, 0, 0, 0 },
/* U+6e7e */ { 0, 0, 0, 0, 0 },
/* U+6e7f */ { 0, 0, 0, 0, 0 },
/* U+6e80 */ { 0, 0, 0, 0, 0 },
/* U+6e81 */ { 0, 0, 0, 0, 0 },
/* U+6e82 */ { 0, 0, 0, 0, 0 },
/* U+6e83 */ { 0, 0, 0, 0, 0 },
/* U+6e84 */ { 0, 0, 0, 0, 0 },
/* U+6e85 */ { 0, 0, 0, 0, 0 },
/* U+6e86 */ { 0, 0, 0, 0, 0 },
/* U+6e87 */ { 0, 0, 0, 0, 0 },
/* U+6e88 */ { 0, 0, 0, 0, 0 },
/* U+6e89 */ { 0, 0, 0, 0, 0 },
/* U+6e8a */ { 0, 0, 0, 0, 0 },
/* U+6e8b */ { 0, 0, 0, 0, 0 },
/* U+6e8c */ { 0, 0, 0, 0, 0 },
/* U+6e8d */ { 0, 0, 0, 0, 0 },
/* U+6e8e */ { 0, 0, 0, 0, 0 },
/* U+6e8f */ { 0, 0, 0, 0, 0 },
/* U+6e90 */ { 0, 0, 0, 0, 0 },
/* U+6e91 */ { 0, 0, 0, 0, 0 },
/* U+6e92 */ { 0, 0, 0, 0, 0 },
/* U+6e93 */ { 0, 0, 0, 0, 0 },
/* U+6e94 */ { 0, 0, 0, 0, 0 },
/* U+6e95 */ { 0, 0, 0, 0, 0 },
/* U+6e96 */ { 0, 0, 0, 0, 0 },
/* U+6e97 */ { 0, 0, 0, 0, 0 },
/* U+6e98 */ { 0, 0, 0, 0, 0 },
/* U+6e99 */ { 0, 0, 0, 0, 0 },
/* U+6e9a */ { 0, 0, 0, 0, 0 },
/* U+6e9b */ { 0, 0, 0, 0, 0 },
/* U+6e9c */ { 0, 0, 0, 0, 0 },
/* U+6e9d */ { 0, 0, 0, 0, 0 },
/* U+6e9e */ { 0, 0, 0, 0, 0 },
/* U+6e9f */ { 0, 0, 0, 0, 0 },
/* U+6ea0 */ { 0, 0, 0, 0, 0 },
/* U+6ea1 */ { 0, 0, 0, 0, 0 },
/* U+6ea2 */ { 0, 0, 0, 0, 0 },
/* U+6ea3 */ { 0, 0, 0, 0, 0 },
/* U+6ea4 */ { 0, 0, 0, 0, 0 },
/* U+6ea5 */ { 0, 0, 0, 0, 0 },
/* U+6ea6 */ { 0, 0, 0, 0, 0 },
/* U+6ea7 */ { 0, 0, 0, 0, 0 },
/* U+6ea8 */ { 0, 0, 0, 0, 0 },
/* U+6ea9 */ { 0, 0, 0, 0, 0 },
/* U+6eaa */ { 0, 0, 0, 0, 0 },
/* U+6eab */ { 0, 0, 0, 0, 0 },
/* U+6eac */ { 0, 0, 0, 0, 0 },
/* U+6ead */ { 0, 0, 0, 0, 0 },
/* U+6eae */ { 0, 0, 0, 0, 0 },
/* U+6eaf */ { 0, 0, 0, 0, 0 },
/* U+6eb0 */ { 0, 0, 0, 0, 0 },
/* U+6eb1 */ { 0, 0, 0, 0, 0 },
/* U+6eb2 */ { 0, 0, 0, 0, 0 },
/* U+6eb3 */ { 0, 0, 0, 0, 0 },
/* U+6eb4 */ { 0, 0, 0, 0, 0 },
/* U+6eb5 */ { 0, 0, 0, 0, 0 },
/* U+6eb6 */ { 0, 0, 0, 0, 0 },
/* U+6eb7 */ { 0, 0, 0, 0, 0 },
/* U+6eb8 */ { 0, 0, 0, 0, 0 },
/* U+6eb9 */ { 0, 0, 0, 0, 0 },
/* U+6eba */ { 0, 0, 0, 0, 0 },
/* U+6ebb */ { 0, 0, 0, 0, 0 },
/* U+6ebc */ { 0, 0, 0, 0, 0 },
/* U+6ebd */ { 0, 0, 0, 0, 0 },
/* U+6ebe */ { 0, 0, 0, 0, 0 },
/* U+6ebf */ { 0, 0, 0, 0, 0 },
/* U+6ec0 */ { 0, 0, 0, 0, 0 },
/* U+6ec1 */ { 0, 0, 0, 0, 0 },
/* U+6ec2 */ { 0, 0, 0, 0, 0 },
/* U+6ec3 */ { 0, 0, 0, 0, 0 },
/* U+6ec4 */ { 0, 0, 0, 0, 0 },
/* U+6ec5 */ { 0, 0, 0, 0, 0 },
/* U+6ec6 */ { 0, 0, 0, 0, 0 },
/* U+6ec7 */ { 0, 0, 0, 0, 0 },
/* U+6ec8 */ { 0, 0, 0, 0, 0 },
/* U+6ec9 */ { 0, 0, 0, 0, 0 },
/* U+6eca */ { 0, 0, 0, 0, 0 },
/* U+6ecb */ { 0, 0, 0, 0, 0 },
/* U+6ecc */ { 0, 0, 0, 0, 0 },
/* U+6ecd */ { 0, 0, 0, 0, 0 },
/* U+6ece */ { 0, 0, 0, 0, 0 },
/* U+6ecf */ { 0, 0, 0, 0, 0 },
/* U+6ed0 */ { 0, 0, 0, 0, 0 },
/* U+6ed1 */ { 0, 0, 0, 0, 0 },
/* U+6ed2 */ { 0, 0, 0, 0, 0 },
/* U+6ed3 */ { 0, 0, 0, 0, 0 },
/* U+6ed4 */ { 0, 0, 0, 0, 0 },
/* U+6ed5 */ { 0, 0, 0, 0, 0 },
/* U+6ed6 */ { 0, 0, 0, 0, 0 },
/* U+6ed7 */ { 0, 0, 0, 0, 0 },
/* U+6ed8 */ { 0, 0, 0, 0, 0 },
/* U+6ed9 */ { 0, 0, 0, 0, 0 },
/* U+6eda */ { 0, 0, 0, 0, 0 },
/* U+6edb */ { 0, 0, 0, 0, 0 },
/* U+6edc */ { 0, 0, 0, 0, 0 },
/* U+6edd */ { 0, 0, 0, 0, 0 },
/* U+6ede */ { 0, 0, 0, 0, 0 },
/* U+6edf */ { 0, 0, 0, 0, 0 },
/* U+6ee0 */ { 0, 0, 0, 0, 0 },
/* U+6ee1 */ { 0, 0, 0, 0, 0 },
/* U+6ee2 */ { 0, 0, 0, 0, 0 },
/* U+6ee3 */ { 0, 0, 0, 0, 0 },
/* U+6ee4 */ { 0, 0, 0, 0, 0 },
/* U+6ee5 */ { 0, 0, 0, 0, 0 },
/* U+6ee6 */ { 0, 0, 0, 0, 0 },
/* U+6ee7 */ { 0, 0, 0, 0, 0 },
/* U+6ee8 */ { 0, 0, 0, 0, 0 },
/* U+6ee9 */ { 0, 0, 0, 0, 0 },
/* U+6eea */ { 0, 0, 0, 0, 0 },
/* U+6eeb */ { 0, 0, 0, 0, 0 },
/* U+6eec */ { 0, 0, 0, 0, 0 },
/* U+6eed */ { 0, 0, 0, 0, 0 },
/* U+6eee */ { 0, 0, 0, 0, 0 },
/* U+6eef */ { 0, 0, 0, 0, 0 },
/* U+6ef0 */ { 0, 0, 0, 0, 0 },
/* U+6ef1 */ { 0, 0, 0, 0, 0 },
/* U+6ef2 */ { 0, 0, 0, 0, 0 },
/* U+6ef3 */ { 0, 0, 0, 0, 0 },
/* U+6ef4 */ { 0, 0, 0, 0, 0 },
/* U+6ef5 */ { 0, 0, 0, 0, 0 },
/* U+6ef6 */ { 0, 0, 0, 0, 0 },
/* U+6ef7 */ { 0, 0, 0, 0, 0 },
/* U+6ef8 */ { 0, 0, 0, 0, 0 },
/* U+6ef9 */ { 0, 0, 0, 0, 0 },
/* U+6efa */ { 0, 0, 0, 0, 0 },
/* U+6efb */ { 0, 0, 0, 0, 0 },
/* U+6efc */ { 0, 0, 0, 0, 0 },
/* U+6efd */ { 0, 0, 0, 0, 0 },
/* U+6efe */ { 0, 0, 0, 0, 0 },
/* U+6eff */ { 0, 0, 0, 0, 0 },
/* U+6f00 */ { 0, 0, 0, 0, 0 },
/* U+6f01 */ { 0, 0, 0, 0, 0 },
/* U+6f02 */ { 0, 0, 0, 0, 0 },
/* U+6f03 */ { 0, 0, 0, 0, 0 },
/* U+6f04 */ { 0, 0, 0, 0, 0 },
/* U+6f05 */ { 0, 0, 0, 0, 0 },
/* U+6f06 */ { 0, 0, 0, 0, 0 },
/* U+6f07 */ { 0, 0, 0, 0, 0 },
/* U+6f08 */ { 0, 0, 0, 0, 0 },
/* U+6f09 */ { 0, 0, 0, 0, 0 },
/* U+6f0a */ { 0, 0, 0, 0, 0 },
/* U+6f0b */ { 0, 0, 0, 0, 0 },
/* U+6f0c */ { 0, 0, 0, 0, 0 },
/* U+6f0d */ { 0, 0, 0, 0, 0 },
/* U+6f0e */ { 0, 0, 0, 0, 0 },
/* U+6f0f */ { 0, 0, 0, 0, 0 },
/* U+6f10 */ { 0, 0, 0, 0, 0 },
/* U+6f11 */ { 0, 0, 0, 0, 0 },
/* U+6f12 */ { 0, 0, 0, 0, 0 },
/* U+6f13 */ { 0, 0, 0, 0, 0 },
/* U+6f14 */ { 0, 0, 0, 0, 0 },
/* U+6f15 */ { 0, 0, 0, 0, 0 },
/* U+6f16 */ { 0, 0, 0, 0, 0 },
/* U+6f17 */ { 0, 0, 0, 0, 0 },
/* U+6f18 */ { 0, 0, 0, 0, 0 },
/* U+6f19 */ { 0, 0, 0, 0, 0 },
/* U+6f1a */ { 0, 0, 0, 0, 0 },
/* U+6f1b */ { 0, 0, 0, 0, 0 },
/* U+6f1c */ { 0, 0, 0, 0, 0 },
/* U+6f1d */ { 0, 0, 0, 0, 0 },
/* U+6f1e */ { 0, 0, 0, 0, 0 },
/* U+6f1f */ { 0, 0, 0, 0, 0 },
/* U+6f20 */ { 0, 0, 0, 0, 0 },
/* U+6f21 */ { 0, 0, 0, 0, 0 },
/* U+6f22 */ { 0, 0, 0, 0, 0 },
/* U+6f23 */ { 0, 0, 0, 0, 0 },
/* U+6f24 */ { 0, 0, 0, 0, 0 },
/* U+6f25 */ { 0, 0, 0, 0, 0 },
/* U+6f26 */ { 0, 0, 0, 0, 0 },
/* U+6f27 */ { 0, 0, 0, 0, 0 },
/* U+6f28 */ { 0, 0, 0, 0, 0 },
/* U+6f29 */ { 0, 0, 0, 0, 0 },
/* U+6f2a */ { 0, 0, 0, 0, 0 },
/* U+6f2b */ { 0, 0, 0, 0, 0 },
/* U+6f2c */ { 0, 0, 0, 0, 0 },
/* U+6f2d */ { 0, 0, 0, 0, 0 },
/* U+6f2e */ { 0, 0, 0, 0, 0 },
/* U+6f2f */ { 0, 0, 0, 0, 0 },
/* U+6f30 */ { 0, 0, 0, 0, 0 },
/* U+6f31 */ { 0, 0, 0, 0, 0 },
/* U+6f32 */ { 0, 0, 0, 0, 0 },
/* U+6f33 */ { 0, 0, 0, 0, 0 },
/* U+6f34 */ { 0, 0, 0, 0, 0 },
/* U+6f35 */ { 0, 0, 0, 0, 0 },
/* U+6f36 */ { 0, 0, 0, 0, 0 },
/* U+6f37 */ { 0, 0, 0, 0, 0 },
/* U+6f38 */ { 0, 0, 0, 0, 0 },
/* U+6f39 */ { 0, 0, 0, 0, 0 },
/* U+6f3a */ { 0, 0, 0, 0, 0 },
/* U+6f3b */ { 0, 0, 0, 0, 0 },
/* U+6f3c */ { 0, 0, 0, 0, 0 },
/* U+6f3d */ { 0, 0, 0, 0, 0 },
/* U+6f3e */ { 0, 0, 0, 0, 0 },
/* U+6f3f */ { 0, 0, 0, 0, 0 },
/* U+6f40 */ { 0, 0, 0, 0, 0 },
/* U+6f41 */ { 0, 0, 0, 0, 0 },
/* U+6f42 */ { 0, 0, 0, 0, 0 },
/* U+6f43 */ { 0, 0, 0, 0, 0 },
/* U+6f44 */ { 0, 0, 0, 0, 0 },
/* U+6f45 */ { 0, 0, 0, 0, 0 },
/* U+6f46 */ { 0, 0, 0, 0, 0 },
/* U+6f47 */ { 0, 0, 0, 0, 0 },
/* U+6f48 */ { 0, 0, 0, 0, 0 },
/* U+6f49 */ { 0, 0, 0, 0, 0 },
/* U+6f4a */ { 0, 0, 0, 0, 0 },
/* U+6f4b */ { 0, 0, 0, 0, 0 },
/* U+6f4c */ { 0, 0, 0, 0, 0 },
/* U+6f4d */ { 0, 0, 0, 0, 0 },
/* U+6f4e */ { 0, 0, 0, 0, 0 },
/* U+6f4f */ { 0, 0, 0, 0, 0 },
/* U+6f50 */ { 0, 0, 0, 0, 0 },
/* U+6f51 */ { 0, 0, 0, 0, 0 },
/* U+6f52 */ { 0, 0, 0, 0, 0 },
/* U+6f53 */ { 0, 0, 0, 0, 0 },
/* U+6f54 */ { 0, 0, 0, 0, 0 },
/* U+6f55 */ { 0, 0, 0, 0, 0 },
/* U+6f56 */ { 0, 0, 0, 0, 0 },
/* U+6f57 */ { 0, 0, 0, 0, 0 },
/* U+6f58 */ { 0, 0, 0, 0, 0 },
/* U+6f59 */ { 0, 0, 0, 0, 0 },
/* U+6f5a */ { 0, 0, 0, 0, 0 },
/* U+6f5b */ { 0, 0, 0, 0, 0 },
/* U+6f5c */ { 0, 0, 0, 0, 0 },
/* U+6f5d */ { 0, 0, 0, 0, 0 },
/* U+6f5e */ { 0, 0, 0, 0, 0 },
/* U+6f5f */ { 0, 0, 0, 0, 0 },
/* U+6f60 */ { 0, 0, 0, 0, 0 },
/* U+6f61 */ { 0, 0, 0, 0, 0 },
/* U+6f62 */ { 0, 0, 0, 0, 0 },
/* U+6f63 */ { 0, 0, 0, 0, 0 },
/* U+6f64 */ { 0, 0, 0, 0, 0 },
/* U+6f65 */ { 0, 0, 0, 0, 0 },
/* U+6f66 */ { 0, 0, 0, 0, 0 },
/* U+6f67 */ { 0, 0, 0, 0, 0 },
/* U+6f68 */ { 0, 0, 0, 0, 0 },
/* U+6f69 */ { 0, 0, 0, 0, 0 },
/* U+6f6a */ { 0, 0, 0, 0, 0 },
/* U+6f6b */ { 0, 0, 0, 0, 0 },
/* U+6f6c */ { 0, 0, 0, 0, 0 },
/* U+6f6d */ { 0, 0, 0, 0, 0 },
/* U+6f6e */ { 0, 0, 0, 0, 0 },
/* U+6f6f */ { 0, 0, 0, 0, 0 },
/* U+6f70 */ { 0, 0, 0, 0, 0 },
/* U+6f71 */ { 0, 0, 0, 0, 0 },
/* U+6f72 */ { 0, 0, 0, 0, 0 },
/* U+6f73 */ { 0, 0, 0, 0, 0 },
/* U+6f74 */ { 0, 0, 0, 0, 0 },
/* U+6f75 */ { 0, 0, 0, 0, 0 },
/* U+6f76 */ { 0, 0, 0, 0, 0 },
/* U+6f77 */ { 0, 0, 0, 0, 0 },
/* U+6f78 */ { 0, 0, 0, 0, 0 },
/* U+6f79 */ { 0, 0, 0, 0, 0 },
/* U+6f7a */ { 0, 0, 0, 0, 0 },
/* U+6f7b */ { 0, 0, 0, 0, 0 },
/* U+6f7c */ { 0, 0, 0, 0, 0 },
/* U+6f7d */ { 0, 0, 0, 0, 0 },
/* U+6f7e */ { 0, 0, 0, 0, 0 },
/* U+6f7f */ { 0, 0, 0, 0, 0 },
/* U+6f80 */ { 0, 0, 0, 0, 0 },
/* U+6f81 */ { 0, 0, 0, 0, 0 },
/* U+6f82 */ { 0, 0, 0, 0, 0 },
/* U+6f83 */ { 0, 0, 0, 0, 0 },
/* U+6f84 */ { 0, 0, 0, 0, 0 },
/* U+6f85 */ { 0, 0, 0, 0, 0 },
/* U+6f86 */ { 0, 0, 0, 0, 0 },
/* U+6f87 */ { 0, 0, 0, 0, 0 },
/* U+6f88 */ { 0, 0, 0, 0, 0 },
/* U+6f89 */ { 0, 0, 0, 0, 0 },
/* U+6f8a */ { 0, 0, 0, 0, 0 },
/* U+6f8b */ { 0, 0, 0, 0, 0 },
/* U+6f8c */ { 0, 0, 0, 0, 0 },
/* U+6f8d */ { 0, 0, 0, 0, 0 },
/* U+6f8e */ { 0, 0, 0, 0, 0 },
/* U+6f8f */ { 0, 0, 0, 0, 0 },
/* U+6f90 */ { 0, 0, 0, 0, 0 },
/* U+6f91 */ { 0, 0, 0, 0, 0 },
/* U+6f92 */ { 0, 0, 0, 0, 0 },
/* U+6f93 */ { 0, 0, 0, 0, 0 },
/* U+6f94 */ { 0, 0, 0, 0, 0 },
/* U+6f95 */ { 0, 0, 0, 0, 0 },
/* U+6f96 */ { 0, 0, 0, 0, 0 },
/* U+6f97 */ { 0, 0, 0, 0, 0 },
/* U+6f98 */ { 0, 0, 0, 0, 0 },
/* U+6f99 */ { 0, 0, 0, 0, 0 },
/* U+6f9a */ { 0, 0, 0, 0, 0 },
/* U+6f9b */ { 0, 0, 0, 0, 0 },
/* U+6f9c */ { 0, 0, 0, 0, 0 },
/* U+6f9d */ { 0, 0, 0, 0, 0 },
/* U+6f9e */ { 0, 0, 0, 0, 0 },
/* U+6f9f */ { 0, 0, 0, 0, 0 },
/* U+6fa0 */ { 0, 0, 0, 0, 0 },
/* U+6fa1 */ { 0, 0, 0, 0, 0 },
/* U+6fa2 */ { 0, 0, 0, 0, 0 },
/* U+6fa3 */ { 0, 0, 0, 0, 0 },
/* U+6fa4 */ { 0, 0, 0, 0, 0 },
/* U+6fa5 */ { 0, 0, 0, 0, 0 },
/* U+6fa6 */ { 0, 0, 0, 0, 0 },
/* U+6fa7 */ { 0, 0, 0, 0, 0 },
/* U+6fa8 */ { 0, 0, 0, 0, 0 },
/* U+6fa9 */ { 0, 0, 0, 0, 0 },
/* U+6faa */ { 0, 0, 0, 0, 0 },
/* U+6fab */ { 0, 0, 0, 0, 0 },
/* U+6fac */ { 0, 0, 0, 0, 0 },
/* U+6fad */ { 0, 0, 0, 0, 0 },
/* U+6fae */ { 0, 0, 0, 0, 0 },
/* U+6faf */ { 0, 0, 0, 0, 0 },
/* U+6fb0 */ { 0, 0, 0, 0, 0 },
/* U+6fb1 */ { 0, 0, 0, 0, 0 },
/* U+6fb2 */ { 0, 0, 0, 0, 0 },
/* U+6fb3 */ { 0, 0, 0, 0, 0 },
/* U+6fb4 */ { 0, 0, 0, 0, 0 },
/* U+6fb5 */ { 0, 0, 0, 0, 0 },
/* U+6fb6 */ { 0, 0, 0, 0, 0 },
/* U+6fb7 */ { 0, 0, 0, 0, 0 },
/* U+6fb8 */ { 0, 0, 0, 0, 0 },
/* U+6fb9 */ { 0, 0, 0, 0, 0 },
/* U+6fba */ { 0, 0, 0, 0, 0 },
/* U+6fbb */ { 0, 0, 0, 0, 0 },
/* U+6fbc */ { 0, 0, 0, 0, 0 },
/* U+6fbd */ { 0, 0, 0, 0, 0 },
/* U+6fbe */ { 0, 0, 0, 0, 0 },
/* U+6fbf */ { 0, 0, 0, 0, 0 },
/* U+6fc0 */ { 0, 0, 0, 0, 0 },
/* U+6fc1 */ { 0, 0, 0, 0, 0 },
/* U+6fc2 */ { 0, 0, 0, 0, 0 },
/* U+6fc3 */ { 0, 0, 0, 0, 0 },
/* U+6fc4 */ { 0, 0, 0, 0, 0 },
/* U+6fc5 */ { 0, 0, 0, 0, 0 },
/* U+6fc6 */ { 0, 0, 0, 0, 0 },
/* U+6fc7 */ { 0, 0, 0, 0, 0 },
/* U+6fc8 */ { 0, 0, 0, 0, 0 },
/* U+6fc9 */ { 0, 0, 0, 0, 0 },
/* U+6fca */ { 0, 0, 0, 0, 0 },
/* U+6fcb */ { 0, 0, 0, 0, 0 },
/* U+6fcc */ { 0, 0, 0, 0, 0 },
/* U+6fcd */ { 0, 0, 0, 0, 0 },
/* U+6fce */ { 0, 0, 0, 0, 0 },
/* U+6fcf */ { 0, 0, 0, 0, 0 },
/* U+6fd0 */ { 0, 0, 0, 0, 0 },
/* U+6fd1 */ { 0, 0, 0, 0, 0 },
/* U+6fd2 */ { 0, 0, 0, 0, 0 },
/* U+6fd3 */ { 0, 0, 0, 0, 0 },
/* U+6fd4 */ { 0, 0, 0, 0, 0 },
/* U+6fd5 */ { 0, 0, 0, 0, 0 },
/* U+6fd6 */ { 0, 0, 0, 0, 0 },
/* U+6fd7 */ { 0, 0, 0, 0, 0 },
/* U+6fd8 */ { 0, 0, 0, 0, 0 },
/* U+6fd9 */ { 0, 0, 0, 0, 0 },
/* U+6fda */ { 0, 0, 0, 0, 0 },
/* U+6fdb */ { 0, 0, 0, 0, 0 },
/* U+6fdc */ { 0, 0, 0, 0, 0 },
/* U+6fdd */ { 0, 0, 0, 0, 0 },
/* U+6fde */ { 0, 0, 0, 0, 0 },
/* U+6fdf */ { 0, 0, 0, 0, 0 },
/* U+6fe0 */ { 0, 0, 0, 0, 0 },
/* U+6fe1 */ { 0, 0, 0, 0, 0 },
/* U+6fe2 */ { 0, 0, 0, 0, 0 },
/* U+6fe3 */ { 0, 0, 0, 0, 0 },
/* U+6fe4 */ { 0, 0, 0, 0, 0 },
/* U+6fe5 */ { 0, 0, 0, 0, 0 },
/* U+6fe6 */ { 0, 0, 0, 0, 0 },
/* U+6fe7 */ { 0, 0, 0, 0, 0 },
/* U+6fe8 */ { 0, 0, 0, 0, 0 },
/* U+6fe9 */ { 0, 0, 0, 0, 0 },
/* U+6fea */ { 0, 0, 0, 0, 0 },
/* U+6feb */ { 0, 0, 0, 0, 0 },
/* U+6fec */ { 0, 0, 0, 0, 0 },
/* U+6fed */ { 0, 0, 0, 0, 0 },
/* U+6fee */ { 0, 0, 0, 0, 0 },
/* U+6fef */ { 0, 0, 0, 0, 0 },
/* U+6ff0 */ { 0, 0, 0, 0, 0 },
/* U+6ff1 */ { 0, 0, 0, 0, 0 },
/* U+6ff2 */ { 0, 0, 0, 0, 0 },
/* U+6ff3 */ { 0, 0, 0, 0, 0 },
/* U+6ff4 */ { 0, 0, 0, 0, 0 },
/* U+6ff5 */ { 0, 0, 0, 0, 0 },
/* U+6ff6 */ { 0, 0, 0, 0, 0 },
/* U+6ff7 */ { 0, 0, 0, 0, 0 },
/* U+6ff8 */ { 0, 0, 0, 0, 0 },
/* U+6ff9 */ { 0, 0, 0, 0, 0 },
/* U+6ffa */ { 0, 0, 0, 0, 0 },
/* U+6ffb */ { 0, 0, 0, 0, 0 },
/* U+6ffc */ { 0, 0, 0, 0, 0 },
/* U+6ffd */ { 0, 0, 0, 0, 0 },
/* U+6ffe */ { 0, 0, 0, 0, 0 },
/* U+6fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_7[4096] = {
    
/* U+7000 */ { 0, 0, 0, 0, 0 },
/* U+7001 */ { 0, 0, 0, 0, 0 },
/* U+7002 */ { 0, 0, 0, 0, 0 },
/* U+7003 */ { 0, 0, 0, 0, 0 },
/* U+7004 */ { 0, 0, 0, 0, 0 },
/* U+7005 */ { 0, 0, 0, 0, 0 },
/* U+7006 */ { 0, 0, 0, 0, 0 },
/* U+7007 */ { 0, 0, 0, 0, 0 },
/* U+7008 */ { 0, 0, 0, 0, 0 },
/* U+7009 */ { 0, 0, 0, 0, 0 },
/* U+700a */ { 0, 0, 0, 0, 0 },
/* U+700b */ { 0, 0, 0, 0, 0 },
/* U+700c */ { 0, 0, 0, 0, 0 },
/* U+700d */ { 0, 0, 0, 0, 0 },
/* U+700e */ { 0, 0, 0, 0, 0 },
/* U+700f */ { 0, 0, 0, 0, 0 },
/* U+7010 */ { 0, 0, 0, 0, 0 },
/* U+7011 */ { 0, 0, 0, 0, 0 },
/* U+7012 */ { 0, 0, 0, 0, 0 },
/* U+7013 */ { 0, 0, 0, 0, 0 },
/* U+7014 */ { 0, 0, 0, 0, 0 },
/* U+7015 */ { 0, 0, 0, 0, 0 },
/* U+7016 */ { 0, 0, 0, 0, 0 },
/* U+7017 */ { 0, 0, 0, 0, 0 },
/* U+7018 */ { 0, 0, 0, 0, 0 },
/* U+7019 */ { 0, 0, 0, 0, 0 },
/* U+701a */ { 0, 0, 0, 0, 0 },
/* U+701b */ { 0, 0, 0, 0, 0 },
/* U+701c */ { 0, 0, 0, 0, 0 },
/* U+701d */ { 0, 0, 0, 0, 0 },
/* U+701e */ { 0, 0, 0, 0, 0 },
/* U+701f */ { 0, 0, 0, 0, 0 },
/* U+7020 */ { 0, 0, 0, 0, 0 },
/* U+7021 */ { 0, 0, 0, 0, 0 },
/* U+7022 */ { 0, 0, 0, 0, 0 },
/* U+7023 */ { 0, 0, 0, 0, 0 },
/* U+7024 */ { 0, 0, 0, 0, 0 },
/* U+7025 */ { 0, 0, 0, 0, 0 },
/* U+7026 */ { 0, 0, 0, 0, 0 },
/* U+7027 */ { 0, 0, 0, 0, 0 },
/* U+7028 */ { 0, 0, 0, 0, 0 },
/* U+7029 */ { 0, 0, 0, 0, 0 },
/* U+702a */ { 0, 0, 0, 0, 0 },
/* U+702b */ { 0, 0, 0, 0, 0 },
/* U+702c */ { 0, 0, 0, 0, 0 },
/* U+702d */ { 0, 0, 0, 0, 0 },
/* U+702e */ { 0, 0, 0, 0, 0 },
/* U+702f */ { 0, 0, 0, 0, 0 },
/* U+7030 */ { 0, 0, 0, 0, 0 },
/* U+7031 */ { 0, 0, 0, 0, 0 },
/* U+7032 */ { 0, 0, 0, 0, 0 },
/* U+7033 */ { 0, 0, 0, 0, 0 },
/* U+7034 */ { 0, 0, 0, 0, 0 },
/* U+7035 */ { 0, 0, 0, 0, 0 },
/* U+7036 */ { 0, 0, 0, 0, 0 },
/* U+7037 */ { 0, 0, 0, 0, 0 },
/* U+7038 */ { 0, 0, 0, 0, 0 },
/* U+7039 */ { 0, 0, 0, 0, 0 },
/* U+703a */ { 0, 0, 0, 0, 0 },
/* U+703b */ { 0, 0, 0, 0, 0 },
/* U+703c */ { 0, 0, 0, 0, 0 },
/* U+703d */ { 0, 0, 0, 0, 0 },
/* U+703e */ { 0, 0, 0, 0, 0 },
/* U+703f */ { 0, 0, 0, 0, 0 },
/* U+7040 */ { 0, 0, 0, 0, 0 },
/* U+7041 */ { 0, 0, 0, 0, 0 },
/* U+7042 */ { 0, 0, 0, 0, 0 },
/* U+7043 */ { 0, 0, 0, 0, 0 },
/* U+7044 */ { 0, 0, 0, 0, 0 },
/* U+7045 */ { 0, 0, 0, 0, 0 },
/* U+7046 */ { 0, 0, 0, 0, 0 },
/* U+7047 */ { 0, 0, 0, 0, 0 },
/* U+7048 */ { 0, 0, 0, 0, 0 },
/* U+7049 */ { 0, 0, 0, 0, 0 },
/* U+704a */ { 0, 0, 0, 0, 0 },
/* U+704b */ { 0, 0, 0, 0, 0 },
/* U+704c */ { 0, 0, 0, 0, 0 },
/* U+704d */ { 0, 0, 0, 0, 0 },
/* U+704e */ { 0, 0, 0, 0, 0 },
/* U+704f */ { 0, 0, 0, 0, 0 },
/* U+7050 */ { 0, 0, 0, 0, 0 },
/* U+7051 */ { 0, 0, 0, 0, 0 },
/* U+7052 */ { 0, 0, 0, 0, 0 },
/* U+7053 */ { 0, 0, 0, 0, 0 },
/* U+7054 */ { 0, 0, 0, 0, 0 },
/* U+7055 */ { 0, 0, 0, 0, 0 },
/* U+7056 */ { 0, 0, 0, 0, 0 },
/* U+7057 */ { 0, 0, 0, 0, 0 },
/* U+7058 */ { 0, 0, 0, 0, 0 },
/* U+7059 */ { 0, 0, 0, 0, 0 },
/* U+705a */ { 0, 0, 0, 0, 0 },
/* U+705b */ { 0, 0, 0, 0, 0 },
/* U+705c */ { 0, 0, 0, 0, 0 },
/* U+705d */ { 0, 0, 0, 0, 0 },
/* U+705e */ { 0, 0, 0, 0, 0 },
/* U+705f */ { 0, 0, 0, 0, 0 },
/* U+7060 */ { 0, 0, 0, 0, 0 },
/* U+7061 */ { 0, 0, 0, 0, 0 },
/* U+7062 */ { 0, 0, 0, 0, 0 },
/* U+7063 */ { 0, 0, 0, 0, 0 },
/* U+7064 */ { 0, 0, 0, 0, 0 },
/* U+7065 */ { 0, 0, 0, 0, 0 },
/* U+7066 */ { 0, 0, 0, 0, 0 },
/* U+7067 */ { 0, 0, 0, 0, 0 },
/* U+7068 */ { 0, 0, 0, 0, 0 },
/* U+7069 */ { 0, 0, 0, 0, 0 },
/* U+706a */ { 0, 0, 0, 0, 0 },
/* U+706b */ { 0, 0, 0, 0, 0 },
/* U+706c */ { 0, 0, 0, 0, 0 },
/* U+706d */ { 0, 0, 0, 0, 0 },
/* U+706e */ { 0, 0, 0, 0, 0 },
/* U+706f */ { 0, 0, 0, 0, 0 },
/* U+7070 */ { 0, 0, 0, 0, 0 },
/* U+7071 */ { 0, 0, 0, 0, 0 },
/* U+7072 */ { 0, 0, 0, 0, 0 },
/* U+7073 */ { 0, 0, 0, 0, 0 },
/* U+7074 */ { 0, 0, 0, 0, 0 },
/* U+7075 */ { 0, 0, 0, 0, 0 },
/* U+7076 */ { 0, 0, 0, 0, 0 },
/* U+7077 */ { 0, 0, 0, 0, 0 },
/* U+7078 */ { 0, 0, 0, 0, 0 },
/* U+7079 */ { 0, 0, 0, 0, 0 },
/* U+707a */ { 0, 0, 0, 0, 0 },
/* U+707b */ { 0, 0, 0, 0, 0 },
/* U+707c */ { 0, 0, 0, 0, 0 },
/* U+707d */ { 0, 0, 0, 0, 0 },
/* U+707e */ { 0, 0, 0, 0, 0 },
/* U+707f */ { 0, 0, 0, 0, 0 },
/* U+7080 */ { 0, 0, 0, 0, 0 },
/* U+7081 */ { 0, 0, 0, 0, 0 },
/* U+7082 */ { 0, 0, 0, 0, 0 },
/* U+7083 */ { 0, 0, 0, 0, 0 },
/* U+7084 */ { 0, 0, 0, 0, 0 },
/* U+7085 */ { 0, 0, 0, 0, 0 },
/* U+7086 */ { 0, 0, 0, 0, 0 },
/* U+7087 */ { 0, 0, 0, 0, 0 },
/* U+7088 */ { 0, 0, 0, 0, 0 },
/* U+7089 */ { 0, 0, 0, 0, 0 },
/* U+708a */ { 0, 0, 0, 0, 0 },
/* U+708b */ { 0, 0, 0, 0, 0 },
/* U+708c */ { 0, 0, 0, 0, 0 },
/* U+708d */ { 0, 0, 0, 0, 0 },
/* U+708e */ { 0, 0, 0, 0, 0 },
/* U+708f */ { 0, 0, 0, 0, 0 },
/* U+7090 */ { 0, 0, 0, 0, 0 },
/* U+7091 */ { 0, 0, 0, 0, 0 },
/* U+7092 */ { 0, 0, 0, 0, 0 },
/* U+7093 */ { 0, 0, 0, 0, 0 },
/* U+7094 */ { 0, 0, 0, 0, 0 },
/* U+7095 */ { 0, 0, 0, 0, 0 },
/* U+7096 */ { 0, 0, 0, 0, 0 },
/* U+7097 */ { 0, 0, 0, 0, 0 },
/* U+7098 */ { 0, 0, 0, 0, 0 },
/* U+7099 */ { 0, 0, 0, 0, 0 },
/* U+709a */ { 0, 0, 0, 0, 0 },
/* U+709b */ { 0, 0, 0, 0, 0 },
/* U+709c */ { 0, 0, 0, 0, 0 },
/* U+709d */ { 0, 0, 0, 0, 0 },
/* U+709e */ { 0, 0, 0, 0, 0 },
/* U+709f */ { 0, 0, 0, 0, 0 },
/* U+70a0 */ { 0, 0, 0, 0, 0 },
/* U+70a1 */ { 0, 0, 0, 0, 0 },
/* U+70a2 */ { 0, 0, 0, 0, 0 },
/* U+70a3 */ { 0, 0, 0, 0, 0 },
/* U+70a4 */ { 0, 0, 0, 0, 0 },
/* U+70a5 */ { 0, 0, 0, 0, 0 },
/* U+70a6 */ { 0, 0, 0, 0, 0 },
/* U+70a7 */ { 0, 0, 0, 0, 0 },
/* U+70a8 */ { 0, 0, 0, 0, 0 },
/* U+70a9 */ { 0, 0, 0, 0, 0 },
/* U+70aa */ { 0, 0, 0, 0, 0 },
/* U+70ab */ { 0, 0, 0, 0, 0 },
/* U+70ac */ { 0, 0, 0, 0, 0 },
/* U+70ad */ { 0, 0, 0, 0, 0 },
/* U+70ae */ { 0, 0, 0, 0, 0 },
/* U+70af */ { 0, 0, 0, 0, 0 },
/* U+70b0 */ { 0, 0, 0, 0, 0 },
/* U+70b1 */ { 0, 0, 0, 0, 0 },
/* U+70b2 */ { 0, 0, 0, 0, 0 },
/* U+70b3 */ { 0, 0, 0, 0, 0 },
/* U+70b4 */ { 0, 0, 0, 0, 0 },
/* U+70b5 */ { 0, 0, 0, 0, 0 },
/* U+70b6 */ { 0, 0, 0, 0, 0 },
/* U+70b7 */ { 0, 0, 0, 0, 0 },
/* U+70b8 */ { 0, 0, 0, 0, 0 },
/* U+70b9 */ { 0, 0, 0, 0, 0 },
/* U+70ba */ { 0, 0, 0, 0, 0 },
/* U+70bb */ { 0, 0, 0, 0, 0 },
/* U+70bc */ { 0, 0, 0, 0, 0 },
/* U+70bd */ { 0, 0, 0, 0, 0 },
/* U+70be */ { 0, 0, 0, 0, 0 },
/* U+70bf */ { 0, 0, 0, 0, 0 },
/* U+70c0 */ { 0, 0, 0, 0, 0 },
/* U+70c1 */ { 0, 0, 0, 0, 0 },
/* U+70c2 */ { 0, 0, 0, 0, 0 },
/* U+70c3 */ { 0, 0, 0, 0, 0 },
/* U+70c4 */ { 0, 0, 0, 0, 0 },
/* U+70c5 */ { 0, 0, 0, 0, 0 },
/* U+70c6 */ { 0, 0, 0, 0, 0 },
/* U+70c7 */ { 0, 0, 0, 0, 0 },
/* U+70c8 */ { 0, 0, 0, 0, 0 },
/* U+70c9 */ { 0, 0, 0, 0, 0 },
/* U+70ca */ { 0, 0, 0, 0, 0 },
/* U+70cb */ { 0, 0, 0, 0, 0 },
/* U+70cc */ { 0, 0, 0, 0, 0 },
/* U+70cd */ { 0, 0, 0, 0, 0 },
/* U+70ce */ { 0, 0, 0, 0, 0 },
/* U+70cf */ { 0, 0, 0, 0, 0 },
/* U+70d0 */ { 0, 0, 0, 0, 0 },
/* U+70d1 */ { 0, 0, 0, 0, 0 },
/* U+70d2 */ { 0, 0, 0, 0, 0 },
/* U+70d3 */ { 0, 0, 0, 0, 0 },
/* U+70d4 */ { 0, 0, 0, 0, 0 },
/* U+70d5 */ { 0, 0, 0, 0, 0 },
/* U+70d6 */ { 0, 0, 0, 0, 0 },
/* U+70d7 */ { 0, 0, 0, 0, 0 },
/* U+70d8 */ { 0, 0, 0, 0, 0 },
/* U+70d9 */ { 0, 0, 0, 0, 0 },
/* U+70da */ { 0, 0, 0, 0, 0 },
/* U+70db */ { 0, 0, 0, 0, 0 },
/* U+70dc */ { 0, 0, 0, 0, 0 },
/* U+70dd */ { 0, 0, 0, 0, 0 },
/* U+70de */ { 0, 0, 0, 0, 0 },
/* U+70df */ { 0, 0, 0, 0, 0 },
/* U+70e0 */ { 0, 0, 0, 0, 0 },
/* U+70e1 */ { 0, 0, 0, 0, 0 },
/* U+70e2 */ { 0, 0, 0, 0, 0 },
/* U+70e3 */ { 0, 0, 0, 0, 0 },
/* U+70e4 */ { 0, 0, 0, 0, 0 },
/* U+70e5 */ { 0, 0, 0, 0, 0 },
/* U+70e6 */ { 0, 0, 0, 0, 0 },
/* U+70e7 */ { 0, 0, 0, 0, 0 },
/* U+70e8 */ { 0, 0, 0, 0, 0 },
/* U+70e9 */ { 0, 0, 0, 0, 0 },
/* U+70ea */ { 0, 0, 0, 0, 0 },
/* U+70eb */ { 0, 0, 0, 0, 0 },
/* U+70ec */ { 0, 0, 0, 0, 0 },
/* U+70ed */ { 0, 0, 0, 0, 0 },
/* U+70ee */ { 0, 0, 0, 0, 0 },
/* U+70ef */ { 0, 0, 0, 0, 0 },
/* U+70f0 */ { 0, 0, 0, 0, 0 },
/* U+70f1 */ { 0, 0, 0, 0, 0 },
/* U+70f2 */ { 0, 0, 0, 0, 0 },
/* U+70f3 */ { 0, 0, 0, 0, 0 },
/* U+70f4 */ { 0, 0, 0, 0, 0 },
/* U+70f5 */ { 0, 0, 0, 0, 0 },
/* U+70f6 */ { 0, 0, 0, 0, 0 },
/* U+70f7 */ { 0, 0, 0, 0, 0 },
/* U+70f8 */ { 0, 0, 0, 0, 0 },
/* U+70f9 */ { 0, 0, 0, 0, 0 },
/* U+70fa */ { 0, 0, 0, 0, 0 },
/* U+70fb */ { 0, 0, 0, 0, 0 },
/* U+70fc */ { 0, 0, 0, 0, 0 },
/* U+70fd */ { 0, 0, 0, 0, 0 },
/* U+70fe */ { 0, 0, 0, 0, 0 },
/* U+70ff */ { 0, 0, 0, 0, 0 },
/* U+7100 */ { 0, 0, 0, 0, 0 },
/* U+7101 */ { 0, 0, 0, 0, 0 },
/* U+7102 */ { 0, 0, 0, 0, 0 },
/* U+7103 */ { 0, 0, 0, 0, 0 },
/* U+7104 */ { 0, 0, 0, 0, 0 },
/* U+7105 */ { 0, 0, 0, 0, 0 },
/* U+7106 */ { 0, 0, 0, 0, 0 },
/* U+7107 */ { 0, 0, 0, 0, 0 },
/* U+7108 */ { 0, 0, 0, 0, 0 },
/* U+7109 */ { 0, 0, 0, 0, 0 },
/* U+710a */ { 0, 0, 0, 0, 0 },
/* U+710b */ { 0, 0, 0, 0, 0 },
/* U+710c */ { 0, 0, 0, 0, 0 },
/* U+710d */ { 0, 0, 0, 0, 0 },
/* U+710e */ { 0, 0, 0, 0, 0 },
/* U+710f */ { 0, 0, 0, 0, 0 },
/* U+7110 */ { 0, 0, 0, 0, 0 },
/* U+7111 */ { 0, 0, 0, 0, 0 },
/* U+7112 */ { 0, 0, 0, 0, 0 },
/* U+7113 */ { 0, 0, 0, 0, 0 },
/* U+7114 */ { 0, 0, 0, 0, 0 },
/* U+7115 */ { 0, 0, 0, 0, 0 },
/* U+7116 */ { 0, 0, 0, 0, 0 },
/* U+7117 */ { 0, 0, 0, 0, 0 },
/* U+7118 */ { 0, 0, 0, 0, 0 },
/* U+7119 */ { 0, 0, 0, 0, 0 },
/* U+711a */ { 0, 0, 0, 0, 0 },
/* U+711b */ { 0, 0, 0, 0, 0 },
/* U+711c */ { 0, 0, 0, 0, 0 },
/* U+711d */ { 0, 0, 0, 0, 0 },
/* U+711e */ { 0, 0, 0, 0, 0 },
/* U+711f */ { 0, 0, 0, 0, 0 },
/* U+7120 */ { 0, 0, 0, 0, 0 },
/* U+7121 */ { 0, 0, 0, 0, 0 },
/* U+7122 */ { 0, 0, 0, 0, 0 },
/* U+7123 */ { 0, 0, 0, 0, 0 },
/* U+7124 */ { 0, 0, 0, 0, 0 },
/* U+7125 */ { 0, 0, 0, 0, 0 },
/* U+7126 */ { 0, 0, 0, 0, 0 },
/* U+7127 */ { 0, 0, 0, 0, 0 },
/* U+7128 */ { 0, 0, 0, 0, 0 },
/* U+7129 */ { 0, 0, 0, 0, 0 },
/* U+712a */ { 0, 0, 0, 0, 0 },
/* U+712b */ { 0, 0, 0, 0, 0 },
/* U+712c */ { 0, 0, 0, 0, 0 },
/* U+712d */ { 0, 0, 0, 0, 0 },
/* U+712e */ { 0, 0, 0, 0, 0 },
/* U+712f */ { 0, 0, 0, 0, 0 },
/* U+7130 */ { 0, 0, 0, 0, 0 },
/* U+7131 */ { 0, 0, 0, 0, 0 },
/* U+7132 */ { 0, 0, 0, 0, 0 },
/* U+7133 */ { 0, 0, 0, 0, 0 },
/* U+7134 */ { 0, 0, 0, 0, 0 },
/* U+7135 */ { 0, 0, 0, 0, 0 },
/* U+7136 */ { 0, 0, 0, 0, 0 },
/* U+7137 */ { 0, 0, 0, 0, 0 },
/* U+7138 */ { 0, 0, 0, 0, 0 },
/* U+7139 */ { 0, 0, 0, 0, 0 },
/* U+713a */ { 0, 0, 0, 0, 0 },
/* U+713b */ { 0, 0, 0, 0, 0 },
/* U+713c */ { 0, 0, 0, 0, 0 },
/* U+713d */ { 0, 0, 0, 0, 0 },
/* U+713e */ { 0, 0, 0, 0, 0 },
/* U+713f */ { 0, 0, 0, 0, 0 },
/* U+7140 */ { 0, 0, 0, 0, 0 },
/* U+7141 */ { 0, 0, 0, 0, 0 },
/* U+7142 */ { 0, 0, 0, 0, 0 },
/* U+7143 */ { 0, 0, 0, 0, 0 },
/* U+7144 */ { 0, 0, 0, 0, 0 },
/* U+7145 */ { 0, 0, 0, 0, 0 },
/* U+7146 */ { 0, 0, 0, 0, 0 },
/* U+7147 */ { 0, 0, 0, 0, 0 },
/* U+7148 */ { 0, 0, 0, 0, 0 },
/* U+7149 */ { 0, 0, 0, 0, 0 },
/* U+714a */ { 0, 0, 0, 0, 0 },
/* U+714b */ { 0, 0, 0, 0, 0 },
/* U+714c */ { 0, 0, 0, 0, 0 },
/* U+714d */ { 0, 0, 0, 0, 0 },
/* U+714e */ { 0, 0, 0, 0, 0 },
/* U+714f */ { 0, 0, 0, 0, 0 },
/* U+7150 */ { 0, 0, 0, 0, 0 },
/* U+7151 */ { 0, 0, 0, 0, 0 },
/* U+7152 */ { 0, 0, 0, 0, 0 },
/* U+7153 */ { 0, 0, 0, 0, 0 },
/* U+7154 */ { 0, 0, 0, 0, 0 },
/* U+7155 */ { 0, 0, 0, 0, 0 },
/* U+7156 */ { 0, 0, 0, 0, 0 },
/* U+7157 */ { 0, 0, 0, 0, 0 },
/* U+7158 */ { 0, 0, 0, 0, 0 },
/* U+7159 */ { 0, 0, 0, 0, 0 },
/* U+715a */ { 0, 0, 0, 0, 0 },
/* U+715b */ { 0, 0, 0, 0, 0 },
/* U+715c */ { 0, 0, 0, 0, 0 },
/* U+715d */ { 0, 0, 0, 0, 0 },
/* U+715e */ { 0, 0, 0, 0, 0 },
/* U+715f */ { 0, 0, 0, 0, 0 },
/* U+7160 */ { 0, 0, 0, 0, 0 },
/* U+7161 */ { 0, 0, 0, 0, 0 },
/* U+7162 */ { 0, 0, 0, 0, 0 },
/* U+7163 */ { 0, 0, 0, 0, 0 },
/* U+7164 */ { 0, 0, 0, 0, 0 },
/* U+7165 */ { 0, 0, 0, 0, 0 },
/* U+7166 */ { 0, 0, 0, 0, 0 },
/* U+7167 */ { 0, 0, 0, 0, 0 },
/* U+7168 */ { 0, 0, 0, 0, 0 },
/* U+7169 */ { 0, 0, 0, 0, 0 },
/* U+716a */ { 0, 0, 0, 0, 0 },
/* U+716b */ { 0, 0, 0, 0, 0 },
/* U+716c */ { 0, 0, 0, 0, 0 },
/* U+716d */ { 0, 0, 0, 0, 0 },
/* U+716e */ { 0, 0, 0, 0, 0 },
/* U+716f */ { 0, 0, 0, 0, 0 },
/* U+7170 */ { 0, 0, 0, 0, 0 },
/* U+7171 */ { 0, 0, 0, 0, 0 },
/* U+7172 */ { 0, 0, 0, 0, 0 },
/* U+7173 */ { 0, 0, 0, 0, 0 },
/* U+7174 */ { 0, 0, 0, 0, 0 },
/* U+7175 */ { 0, 0, 0, 0, 0 },
/* U+7176 */ { 0, 0, 0, 0, 0 },
/* U+7177 */ { 0, 0, 0, 0, 0 },
/* U+7178 */ { 0, 0, 0, 0, 0 },
/* U+7179 */ { 0, 0, 0, 0, 0 },
/* U+717a */ { 0, 0, 0, 0, 0 },
/* U+717b */ { 0, 0, 0, 0, 0 },
/* U+717c */ { 0, 0, 0, 0, 0 },
/* U+717d */ { 0, 0, 0, 0, 0 },
/* U+717e */ { 0, 0, 0, 0, 0 },
/* U+717f */ { 0, 0, 0, 0, 0 },
/* U+7180 */ { 0, 0, 0, 0, 0 },
/* U+7181 */ { 0, 0, 0, 0, 0 },
/* U+7182 */ { 0, 0, 0, 0, 0 },
/* U+7183 */ { 0, 0, 0, 0, 0 },
/* U+7184 */ { 0, 0, 0, 0, 0 },
/* U+7185 */ { 0, 0, 0, 0, 0 },
/* U+7186 */ { 0, 0, 0, 0, 0 },
/* U+7187 */ { 0, 0, 0, 0, 0 },
/* U+7188 */ { 0, 0, 0, 0, 0 },
/* U+7189 */ { 0, 0, 0, 0, 0 },
/* U+718a */ { 0, 0, 0, 0, 0 },
/* U+718b */ { 0, 0, 0, 0, 0 },
/* U+718c */ { 0, 0, 0, 0, 0 },
/* U+718d */ { 0, 0, 0, 0, 0 },
/* U+718e */ { 0, 0, 0, 0, 0 },
/* U+718f */ { 0, 0, 0, 0, 0 },
/* U+7190 */ { 0, 0, 0, 0, 0 },
/* U+7191 */ { 0, 0, 0, 0, 0 },
/* U+7192 */ { 0, 0, 0, 0, 0 },
/* U+7193 */ { 0, 0, 0, 0, 0 },
/* U+7194 */ { 0, 0, 0, 0, 0 },
/* U+7195 */ { 0, 0, 0, 0, 0 },
/* U+7196 */ { 0, 0, 0, 0, 0 },
/* U+7197 */ { 0, 0, 0, 0, 0 },
/* U+7198 */ { 0, 0, 0, 0, 0 },
/* U+7199 */ { 0, 0, 0, 0, 0 },
/* U+719a */ { 0, 0, 0, 0, 0 },
/* U+719b */ { 0, 0, 0, 0, 0 },
/* U+719c */ { 0, 0, 0, 0, 0 },
/* U+719d */ { 0, 0, 0, 0, 0 },
/* U+719e */ { 0, 0, 0, 0, 0 },
/* U+719f */ { 0, 0, 0, 0, 0 },
/* U+71a0 */ { 0, 0, 0, 0, 0 },
/* U+71a1 */ { 0, 0, 0, 0, 0 },
/* U+71a2 */ { 0, 0, 0, 0, 0 },
/* U+71a3 */ { 0, 0, 0, 0, 0 },
/* U+71a4 */ { 0, 0, 0, 0, 0 },
/* U+71a5 */ { 0, 0, 0, 0, 0 },
/* U+71a6 */ { 0, 0, 0, 0, 0 },
/* U+71a7 */ { 0, 0, 0, 0, 0 },
/* U+71a8 */ { 0, 0, 0, 0, 0 },
/* U+71a9 */ { 0, 0, 0, 0, 0 },
/* U+71aa */ { 0, 0, 0, 0, 0 },
/* U+71ab */ { 0, 0, 0, 0, 0 },
/* U+71ac */ { 0, 0, 0, 0, 0 },
/* U+71ad */ { 0, 0, 0, 0, 0 },
/* U+71ae */ { 0, 0, 0, 0, 0 },
/* U+71af */ { 0, 0, 0, 0, 0 },
/* U+71b0 */ { 0, 0, 0, 0, 0 },
/* U+71b1 */ { 0, 0, 0, 0, 0 },
/* U+71b2 */ { 0, 0, 0, 0, 0 },
/* U+71b3 */ { 0, 0, 0, 0, 0 },
/* U+71b4 */ { 0, 0, 0, 0, 0 },
/* U+71b5 */ { 0, 0, 0, 0, 0 },
/* U+71b6 */ { 0, 0, 0, 0, 0 },
/* U+71b7 */ { 0, 0, 0, 0, 0 },
/* U+71b8 */ { 0, 0, 0, 0, 0 },
/* U+71b9 */ { 0, 0, 0, 0, 0 },
/* U+71ba */ { 0, 0, 0, 0, 0 },
/* U+71bb */ { 0, 0, 0, 0, 0 },
/* U+71bc */ { 0, 0, 0, 0, 0 },
/* U+71bd */ { 0, 0, 0, 0, 0 },
/* U+71be */ { 0, 0, 0, 0, 0 },
/* U+71bf */ { 0, 0, 0, 0, 0 },
/* U+71c0 */ { 0, 0, 0, 0, 0 },
/* U+71c1 */ { 0, 0, 0, 0, 0 },
/* U+71c2 */ { 0, 0, 0, 0, 0 },
/* U+71c3 */ { 0, 0, 0, 0, 0 },
/* U+71c4 */ { 0, 0, 0, 0, 0 },
/* U+71c5 */ { 0, 0, 0, 0, 0 },
/* U+71c6 */ { 0, 0, 0, 0, 0 },
/* U+71c7 */ { 0, 0, 0, 0, 0 },
/* U+71c8 */ { 0, 0, 0, 0, 0 },
/* U+71c9 */ { 0, 0, 0, 0, 0 },
/* U+71ca */ { 0, 0, 0, 0, 0 },
/* U+71cb */ { 0, 0, 0, 0, 0 },
/* U+71cc */ { 0, 0, 0, 0, 0 },
/* U+71cd */ { 0, 0, 0, 0, 0 },
/* U+71ce */ { 0, 0, 0, 0, 0 },
/* U+71cf */ { 0, 0, 0, 0, 0 },
/* U+71d0 */ { 0, 0, 0, 0, 0 },
/* U+71d1 */ { 0, 0, 0, 0, 0 },
/* U+71d2 */ { 0, 0, 0, 0, 0 },
/* U+71d3 */ { 0, 0, 0, 0, 0 },
/* U+71d4 */ { 0, 0, 0, 0, 0 },
/* U+71d5 */ { 0, 0, 0, 0, 0 },
/* U+71d6 */ { 0, 0, 0, 0, 0 },
/* U+71d7 */ { 0, 0, 0, 0, 0 },
/* U+71d8 */ { 0, 0, 0, 0, 0 },
/* U+71d9 */ { 0, 0, 0, 0, 0 },
/* U+71da */ { 0, 0, 0, 0, 0 },
/* U+71db */ { 0, 0, 0, 0, 0 },
/* U+71dc */ { 0, 0, 0, 0, 0 },
/* U+71dd */ { 0, 0, 0, 0, 0 },
/* U+71de */ { 0, 0, 0, 0, 0 },
/* U+71df */ { 0, 0, 0, 0, 0 },
/* U+71e0 */ { 0, 0, 0, 0, 0 },
/* U+71e1 */ { 0, 0, 0, 0, 0 },
/* U+71e2 */ { 0, 0, 0, 0, 0 },
/* U+71e3 */ { 0, 0, 0, 0, 0 },
/* U+71e4 */ { 0, 0, 0, 0, 0 },
/* U+71e5 */ { 0, 0, 0, 0, 0 },
/* U+71e6 */ { 0, 0, 0, 0, 0 },
/* U+71e7 */ { 0, 0, 0, 0, 0 },
/* U+71e8 */ { 0, 0, 0, 0, 0 },
/* U+71e9 */ { 0, 0, 0, 0, 0 },
/* U+71ea */ { 0, 0, 0, 0, 0 },
/* U+71eb */ { 0, 0, 0, 0, 0 },
/* U+71ec */ { 0, 0, 0, 0, 0 },
/* U+71ed */ { 0, 0, 0, 0, 0 },
/* U+71ee */ { 0, 0, 0, 0, 0 },
/* U+71ef */ { 0, 0, 0, 0, 0 },
/* U+71f0 */ { 0, 0, 0, 0, 0 },
/* U+71f1 */ { 0, 0, 0, 0, 0 },
/* U+71f2 */ { 0, 0, 0, 0, 0 },
/* U+71f3 */ { 0, 0, 0, 0, 0 },
/* U+71f4 */ { 0, 0, 0, 0, 0 },
/* U+71f5 */ { 0, 0, 0, 0, 0 },
/* U+71f6 */ { 0, 0, 0, 0, 0 },
/* U+71f7 */ { 0, 0, 0, 0, 0 },
/* U+71f8 */ { 0, 0, 0, 0, 0 },
/* U+71f9 */ { 0, 0, 0, 0, 0 },
/* U+71fa */ { 0, 0, 0, 0, 0 },
/* U+71fb */ { 0, 0, 0, 0, 0 },
/* U+71fc */ { 0, 0, 0, 0, 0 },
/* U+71fd */ { 0, 0, 0, 0, 0 },
/* U+71fe */ { 0, 0, 0, 0, 0 },
/* U+71ff */ { 0, 0, 0, 0, 0 },
/* U+7200 */ { 0, 0, 0, 0, 0 },
/* U+7201 */ { 0, 0, 0, 0, 0 },
/* U+7202 */ { 0, 0, 0, 0, 0 },
/* U+7203 */ { 0, 0, 0, 0, 0 },
/* U+7204 */ { 0, 0, 0, 0, 0 },
/* U+7205 */ { 0, 0, 0, 0, 0 },
/* U+7206 */ { 0, 0, 0, 0, 0 },
/* U+7207 */ { 0, 0, 0, 0, 0 },
/* U+7208 */ { 0, 0, 0, 0, 0 },
/* U+7209 */ { 0, 0, 0, 0, 0 },
/* U+720a */ { 0, 0, 0, 0, 0 },
/* U+720b */ { 0, 0, 0, 0, 0 },
/* U+720c */ { 0, 0, 0, 0, 0 },
/* U+720d */ { 0, 0, 0, 0, 0 },
/* U+720e */ { 0, 0, 0, 0, 0 },
/* U+720f */ { 0, 0, 0, 0, 0 },
/* U+7210 */ { 0, 0, 0, 0, 0 },
/* U+7211 */ { 0, 0, 0, 0, 0 },
/* U+7212 */ { 0, 0, 0, 0, 0 },
/* U+7213 */ { 0, 0, 0, 0, 0 },
/* U+7214 */ { 0, 0, 0, 0, 0 },
/* U+7215 */ { 0, 0, 0, 0, 0 },
/* U+7216 */ { 0, 0, 0, 0, 0 },
/* U+7217 */ { 0, 0, 0, 0, 0 },
/* U+7218 */ { 0, 0, 0, 0, 0 },
/* U+7219 */ { 0, 0, 0, 0, 0 },
/* U+721a */ { 0, 0, 0, 0, 0 },
/* U+721b */ { 0, 0, 0, 0, 0 },
/* U+721c */ { 0, 0, 0, 0, 0 },
/* U+721d */ { 0, 0, 0, 0, 0 },
/* U+721e */ { 0, 0, 0, 0, 0 },
/* U+721f */ { 0, 0, 0, 0, 0 },
/* U+7220 */ { 0, 0, 0, 0, 0 },
/* U+7221 */ { 0, 0, 0, 0, 0 },
/* U+7222 */ { 0, 0, 0, 0, 0 },
/* U+7223 */ { 0, 0, 0, 0, 0 },
/* U+7224 */ { 0, 0, 0, 0, 0 },
/* U+7225 */ { 0, 0, 0, 0, 0 },
/* U+7226 */ { 0, 0, 0, 0, 0 },
/* U+7227 */ { 0, 0, 0, 0, 0 },
/* U+7228 */ { 0, 0, 0, 0, 0 },
/* U+7229 */ { 0, 0, 0, 0, 0 },
/* U+722a */ { 0, 0, 0, 0, 0 },
/* U+722b */ { 0, 0, 0, 0, 0 },
/* U+722c */ { 0, 0, 0, 0, 0 },
/* U+722d */ { 0, 0, 0, 0, 0 },
/* U+722e */ { 0, 0, 0, 0, 0 },
/* U+722f */ { 0, 0, 0, 0, 0 },
/* U+7230 */ { 0, 0, 0, 0, 0 },
/* U+7231 */ { 0, 0, 0, 0, 0 },
/* U+7232 */ { 0, 0, 0, 0, 0 },
/* U+7233 */ { 0, 0, 0, 0, 0 },
/* U+7234 */ { 0, 0, 0, 0, 0 },
/* U+7235 */ { 0, 0, 0, 0, 0 },
/* U+7236 */ { 0, 0, 0, 0, 0 },
/* U+7237 */ { 0, 0, 0, 0, 0 },
/* U+7238 */ { 0, 0, 0, 0, 0 },
/* U+7239 */ { 0, 0, 0, 0, 0 },
/* U+723a */ { 0, 0, 0, 0, 0 },
/* U+723b */ { 0, 0, 0, 0, 0 },
/* U+723c */ { 0, 0, 0, 0, 0 },
/* U+723d */ { 0, 0, 0, 0, 0 },
/* U+723e */ { 0, 0, 0, 0, 0 },
/* U+723f */ { 0, 0, 0, 0, 0 },
/* U+7240 */ { 0, 0, 0, 0, 0 },
/* U+7241 */ { 0, 0, 0, 0, 0 },
/* U+7242 */ { 0, 0, 0, 0, 0 },
/* U+7243 */ { 0, 0, 0, 0, 0 },
/* U+7244 */ { 0, 0, 0, 0, 0 },
/* U+7245 */ { 0, 0, 0, 0, 0 },
/* U+7246 */ { 0, 0, 0, 0, 0 },
/* U+7247 */ { 0, 0, 0, 0, 0 },
/* U+7248 */ { 0, 0, 0, 0, 0 },
/* U+7249 */ { 0, 0, 0, 0, 0 },
/* U+724a */ { 0, 0, 0, 0, 0 },
/* U+724b */ { 0, 0, 0, 0, 0 },
/* U+724c */ { 0, 0, 0, 0, 0 },
/* U+724d */ { 0, 0, 0, 0, 0 },
/* U+724e */ { 0, 0, 0, 0, 0 },
/* U+724f */ { 0, 0, 0, 0, 0 },
/* U+7250 */ { 0, 0, 0, 0, 0 },
/* U+7251 */ { 0, 0, 0, 0, 0 },
/* U+7252 */ { 0, 0, 0, 0, 0 },
/* U+7253 */ { 0, 0, 0, 0, 0 },
/* U+7254 */ { 0, 0, 0, 0, 0 },
/* U+7255 */ { 0, 0, 0, 0, 0 },
/* U+7256 */ { 0, 0, 0, 0, 0 },
/* U+7257 */ { 0, 0, 0, 0, 0 },
/* U+7258 */ { 0, 0, 0, 0, 0 },
/* U+7259 */ { 0, 0, 0, 0, 0 },
/* U+725a */ { 0, 0, 0, 0, 0 },
/* U+725b */ { 0, 0, 0, 0, 0 },
/* U+725c */ { 0, 0, 0, 0, 0 },
/* U+725d */ { 0, 0, 0, 0, 0 },
/* U+725e */ { 0, 0, 0, 0, 0 },
/* U+725f */ { 0, 0, 0, 0, 0 },
/* U+7260 */ { 0, 0, 0, 0, 0 },
/* U+7261 */ { 0, 0, 0, 0, 0 },
/* U+7262 */ { 0, 0, 0, 0, 0 },
/* U+7263 */ { 0, 0, 0, 0, 0 },
/* U+7264 */ { 0, 0, 0, 0, 0 },
/* U+7265 */ { 0, 0, 0, 0, 0 },
/* U+7266 */ { 0, 0, 0, 0, 0 },
/* U+7267 */ { 0, 0, 0, 0, 0 },
/* U+7268 */ { 0, 0, 0, 0, 0 },
/* U+7269 */ { 0, 0, 0, 0, 0 },
/* U+726a */ { 0, 0, 0, 0, 0 },
/* U+726b */ { 0, 0, 0, 0, 0 },
/* U+726c */ { 0, 0, 0, 0, 0 },
/* U+726d */ { 0, 0, 0, 0, 0 },
/* U+726e */ { 0, 0, 0, 0, 0 },
/* U+726f */ { 0, 0, 0, 0, 0 },
/* U+7270 */ { 0, 0, 0, 0, 0 },
/* U+7271 */ { 0, 0, 0, 0, 0 },
/* U+7272 */ { 0, 0, 0, 0, 0 },
/* U+7273 */ { 0, 0, 0, 0, 0 },
/* U+7274 */ { 0, 0, 0, 0, 0 },
/* U+7275 */ { 0, 0, 0, 0, 0 },
/* U+7276 */ { 0, 0, 0, 0, 0 },
/* U+7277 */ { 0, 0, 0, 0, 0 },
/* U+7278 */ { 0, 0, 0, 0, 0 },
/* U+7279 */ { 0, 0, 0, 0, 0 },
/* U+727a */ { 0, 0, 0, 0, 0 },
/* U+727b */ { 0, 0, 0, 0, 0 },
/* U+727c */ { 0, 0, 0, 0, 0 },
/* U+727d */ { 0, 0, 0, 0, 0 },
/* U+727e */ { 0, 0, 0, 0, 0 },
/* U+727f */ { 0, 0, 0, 0, 0 },
/* U+7280 */ { 0, 0, 0, 0, 0 },
/* U+7281 */ { 0, 0, 0, 0, 0 },
/* U+7282 */ { 0, 0, 0, 0, 0 },
/* U+7283 */ { 0, 0, 0, 0, 0 },
/* U+7284 */ { 0, 0, 0, 0, 0 },
/* U+7285 */ { 0, 0, 0, 0, 0 },
/* U+7286 */ { 0, 0, 0, 0, 0 },
/* U+7287 */ { 0, 0, 0, 0, 0 },
/* U+7288 */ { 0, 0, 0, 0, 0 },
/* U+7289 */ { 0, 0, 0, 0, 0 },
/* U+728a */ { 0, 0, 0, 0, 0 },
/* U+728b */ { 0, 0, 0, 0, 0 },
/* U+728c */ { 0, 0, 0, 0, 0 },
/* U+728d */ { 0, 0, 0, 0, 0 },
/* U+728e */ { 0, 0, 0, 0, 0 },
/* U+728f */ { 0, 0, 0, 0, 0 },
/* U+7290 */ { 0, 0, 0, 0, 0 },
/* U+7291 */ { 0, 0, 0, 0, 0 },
/* U+7292 */ { 0, 0, 0, 0, 0 },
/* U+7293 */ { 0, 0, 0, 0, 0 },
/* U+7294 */ { 0, 0, 0, 0, 0 },
/* U+7295 */ { 0, 0, 0, 0, 0 },
/* U+7296 */ { 0, 0, 0, 0, 0 },
/* U+7297 */ { 0, 0, 0, 0, 0 },
/* U+7298 */ { 0, 0, 0, 0, 0 },
/* U+7299 */ { 0, 0, 0, 0, 0 },
/* U+729a */ { 0, 0, 0, 0, 0 },
/* U+729b */ { 0, 0, 0, 0, 0 },
/* U+729c */ { 0, 0, 0, 0, 0 },
/* U+729d */ { 0, 0, 0, 0, 0 },
/* U+729e */ { 0, 0, 0, 0, 0 },
/* U+729f */ { 0, 0, 0, 0, 0 },
/* U+72a0 */ { 0, 0, 0, 0, 0 },
/* U+72a1 */ { 0, 0, 0, 0, 0 },
/* U+72a2 */ { 0, 0, 0, 0, 0 },
/* U+72a3 */ { 0, 0, 0, 0, 0 },
/* U+72a4 */ { 0, 0, 0, 0, 0 },
/* U+72a5 */ { 0, 0, 0, 0, 0 },
/* U+72a6 */ { 0, 0, 0, 0, 0 },
/* U+72a7 */ { 0, 0, 0, 0, 0 },
/* U+72a8 */ { 0, 0, 0, 0, 0 },
/* U+72a9 */ { 0, 0, 0, 0, 0 },
/* U+72aa */ { 0, 0, 0, 0, 0 },
/* U+72ab */ { 0, 0, 0, 0, 0 },
/* U+72ac */ { 0, 0, 0, 0, 0 },
/* U+72ad */ { 0, 0, 0, 0, 0 },
/* U+72ae */ { 0, 0, 0, 0, 0 },
/* U+72af */ { 0, 0, 0, 0, 0 },
/* U+72b0 */ { 0, 0, 0, 0, 0 },
/* U+72b1 */ { 0, 0, 0, 0, 0 },
/* U+72b2 */ { 0, 0, 0, 0, 0 },
/* U+72b3 */ { 0, 0, 0, 0, 0 },
/* U+72b4 */ { 0, 0, 0, 0, 0 },
/* U+72b5 */ { 0, 0, 0, 0, 0 },
/* U+72b6 */ { 0, 0, 0, 0, 0 },
/* U+72b7 */ { 0, 0, 0, 0, 0 },
/* U+72b8 */ { 0, 0, 0, 0, 0 },
/* U+72b9 */ { 0, 0, 0, 0, 0 },
/* U+72ba */ { 0, 0, 0, 0, 0 },
/* U+72bb */ { 0, 0, 0, 0, 0 },
/* U+72bc */ { 0, 0, 0, 0, 0 },
/* U+72bd */ { 0, 0, 0, 0, 0 },
/* U+72be */ { 0, 0, 0, 0, 0 },
/* U+72bf */ { 0, 0, 0, 0, 0 },
/* U+72c0 */ { 0, 0, 0, 0, 0 },
/* U+72c1 */ { 0, 0, 0, 0, 0 },
/* U+72c2 */ { 0, 0, 0, 0, 0 },
/* U+72c3 */ { 0, 0, 0, 0, 0 },
/* U+72c4 */ { 0, 0, 0, 0, 0 },
/* U+72c5 */ { 0, 0, 0, 0, 0 },
/* U+72c6 */ { 0, 0, 0, 0, 0 },
/* U+72c7 */ { 0, 0, 0, 0, 0 },
/* U+72c8 */ { 0, 0, 0, 0, 0 },
/* U+72c9 */ { 0, 0, 0, 0, 0 },
/* U+72ca */ { 0, 0, 0, 0, 0 },
/* U+72cb */ { 0, 0, 0, 0, 0 },
/* U+72cc */ { 0, 0, 0, 0, 0 },
/* U+72cd */ { 0, 0, 0, 0, 0 },
/* U+72ce */ { 0, 0, 0, 0, 0 },
/* U+72cf */ { 0, 0, 0, 0, 0 },
/* U+72d0 */ { 0, 0, 0, 0, 0 },
/* U+72d1 */ { 0, 0, 0, 0, 0 },
/* U+72d2 */ { 0, 0, 0, 0, 0 },
/* U+72d3 */ { 0, 0, 0, 0, 0 },
/* U+72d4 */ { 0, 0, 0, 0, 0 },
/* U+72d5 */ { 0, 0, 0, 0, 0 },
/* U+72d6 */ { 0, 0, 0, 0, 0 },
/* U+72d7 */ { 0, 0, 0, 0, 0 },
/* U+72d8 */ { 0, 0, 0, 0, 0 },
/* U+72d9 */ { 0, 0, 0, 0, 0 },
/* U+72da */ { 0, 0, 0, 0, 0 },
/* U+72db */ { 0, 0, 0, 0, 0 },
/* U+72dc */ { 0, 0, 0, 0, 0 },
/* U+72dd */ { 0, 0, 0, 0, 0 },
/* U+72de */ { 0, 0, 0, 0, 0 },
/* U+72df */ { 0, 0, 0, 0, 0 },
/* U+72e0 */ { 0, 0, 0, 0, 0 },
/* U+72e1 */ { 0, 0, 0, 0, 0 },
/* U+72e2 */ { 0, 0, 0, 0, 0 },
/* U+72e3 */ { 0, 0, 0, 0, 0 },
/* U+72e4 */ { 0, 0, 0, 0, 0 },
/* U+72e5 */ { 0, 0, 0, 0, 0 },
/* U+72e6 */ { 0, 0, 0, 0, 0 },
/* U+72e7 */ { 0, 0, 0, 0, 0 },
/* U+72e8 */ { 0, 0, 0, 0, 0 },
/* U+72e9 */ { 0, 0, 0, 0, 0 },
/* U+72ea */ { 0, 0, 0, 0, 0 },
/* U+72eb */ { 0, 0, 0, 0, 0 },
/* U+72ec */ { 0, 0, 0, 0, 0 },
/* U+72ed */ { 0, 0, 0, 0, 0 },
/* U+72ee */ { 0, 0, 0, 0, 0 },
/* U+72ef */ { 0, 0, 0, 0, 0 },
/* U+72f0 */ { 0, 0, 0, 0, 0 },
/* U+72f1 */ { 0, 0, 0, 0, 0 },
/* U+72f2 */ { 0, 0, 0, 0, 0 },
/* U+72f3 */ { 0, 0, 0, 0, 0 },
/* U+72f4 */ { 0, 0, 0, 0, 0 },
/* U+72f5 */ { 0, 0, 0, 0, 0 },
/* U+72f6 */ { 0, 0, 0, 0, 0 },
/* U+72f7 */ { 0, 0, 0, 0, 0 },
/* U+72f8 */ { 0, 0, 0, 0, 0 },
/* U+72f9 */ { 0, 0, 0, 0, 0 },
/* U+72fa */ { 0, 0, 0, 0, 0 },
/* U+72fb */ { 0, 0, 0, 0, 0 },
/* U+72fc */ { 0, 0, 0, 0, 0 },
/* U+72fd */ { 0, 0, 0, 0, 0 },
/* U+72fe */ { 0, 0, 0, 0, 0 },
/* U+72ff */ { 0, 0, 0, 0, 0 },
/* U+7300 */ { 0, 0, 0, 0, 0 },
/* U+7301 */ { 0, 0, 0, 0, 0 },
/* U+7302 */ { 0, 0, 0, 0, 0 },
/* U+7303 */ { 0, 0, 0, 0, 0 },
/* U+7304 */ { 0, 0, 0, 0, 0 },
/* U+7305 */ { 0, 0, 0, 0, 0 },
/* U+7306 */ { 0, 0, 0, 0, 0 },
/* U+7307 */ { 0, 0, 0, 0, 0 },
/* U+7308 */ { 0, 0, 0, 0, 0 },
/* U+7309 */ { 0, 0, 0, 0, 0 },
/* U+730a */ { 0, 0, 0, 0, 0 },
/* U+730b */ { 0, 0, 0, 0, 0 },
/* U+730c */ { 0, 0, 0, 0, 0 },
/* U+730d */ { 0, 0, 0, 0, 0 },
/* U+730e */ { 0, 0, 0, 0, 0 },
/* U+730f */ { 0, 0, 0, 0, 0 },
/* U+7310 */ { 0, 0, 0, 0, 0 },
/* U+7311 */ { 0, 0, 0, 0, 0 },
/* U+7312 */ { 0, 0, 0, 0, 0 },
/* U+7313 */ { 0, 0, 0, 0, 0 },
/* U+7314 */ { 0, 0, 0, 0, 0 },
/* U+7315 */ { 0, 0, 0, 0, 0 },
/* U+7316 */ { 0, 0, 0, 0, 0 },
/* U+7317 */ { 0, 0, 0, 0, 0 },
/* U+7318 */ { 0, 0, 0, 0, 0 },
/* U+7319 */ { 0, 0, 0, 0, 0 },
/* U+731a */ { 0, 0, 0, 0, 0 },
/* U+731b */ { 0, 0, 0, 0, 0 },
/* U+731c */ { 0, 0, 0, 0, 0 },
/* U+731d */ { 0, 0, 0, 0, 0 },
/* U+731e */ { 0, 0, 0, 0, 0 },
/* U+731f */ { 0, 0, 0, 0, 0 },
/* U+7320 */ { 0, 0, 0, 0, 0 },
/* U+7321 */ { 0, 0, 0, 0, 0 },
/* U+7322 */ { 0, 0, 0, 0, 0 },
/* U+7323 */ { 0, 0, 0, 0, 0 },
/* U+7324 */ { 0, 0, 0, 0, 0 },
/* U+7325 */ { 0, 0, 0, 0, 0 },
/* U+7326 */ { 0, 0, 0, 0, 0 },
/* U+7327 */ { 0, 0, 0, 0, 0 },
/* U+7328 */ { 0, 0, 0, 0, 0 },
/* U+7329 */ { 0, 0, 0, 0, 0 },
/* U+732a */ { 0, 0, 0, 0, 0 },
/* U+732b */ { 0, 0, 0, 0, 0 },
/* U+732c */ { 0, 0, 0, 0, 0 },
/* U+732d */ { 0, 0, 0, 0, 0 },
/* U+732e */ { 0, 0, 0, 0, 0 },
/* U+732f */ { 0, 0, 0, 0, 0 },
/* U+7330 */ { 0, 0, 0, 0, 0 },
/* U+7331 */ { 0, 0, 0, 0, 0 },
/* U+7332 */ { 0, 0, 0, 0, 0 },
/* U+7333 */ { 0, 0, 0, 0, 0 },
/* U+7334 */ { 0, 0, 0, 0, 0 },
/* U+7335 */ { 0, 0, 0, 0, 0 },
/* U+7336 */ { 0, 0, 0, 0, 0 },
/* U+7337 */ { 0, 0, 0, 0, 0 },
/* U+7338 */ { 0, 0, 0, 0, 0 },
/* U+7339 */ { 0, 0, 0, 0, 0 },
/* U+733a */ { 0, 0, 0, 0, 0 },
/* U+733b */ { 0, 0, 0, 0, 0 },
/* U+733c */ { 0, 0, 0, 0, 0 },
/* U+733d */ { 0, 0, 0, 0, 0 },
/* U+733e */ { 0, 0, 0, 0, 0 },
/* U+733f */ { 0, 0, 0, 0, 0 },
/* U+7340 */ { 0, 0, 0, 0, 0 },
/* U+7341 */ { 0, 0, 0, 0, 0 },
/* U+7342 */ { 0, 0, 0, 0, 0 },
/* U+7343 */ { 0, 0, 0, 0, 0 },
/* U+7344 */ { 0, 0, 0, 0, 0 },
/* U+7345 */ { 0, 0, 0, 0, 0 },
/* U+7346 */ { 0, 0, 0, 0, 0 },
/* U+7347 */ { 0, 0, 0, 0, 0 },
/* U+7348 */ { 0, 0, 0, 0, 0 },
/* U+7349 */ { 0, 0, 0, 0, 0 },
/* U+734a */ { 0, 0, 0, 0, 0 },
/* U+734b */ { 0, 0, 0, 0, 0 },
/* U+734c */ { 0, 0, 0, 0, 0 },
/* U+734d */ { 0, 0, 0, 0, 0 },
/* U+734e */ { 0, 0, 0, 0, 0 },
/* U+734f */ { 0, 0, 0, 0, 0 },
/* U+7350 */ { 0, 0, 0, 0, 0 },
/* U+7351 */ { 0, 0, 0, 0, 0 },
/* U+7352 */ { 0, 0, 0, 0, 0 },
/* U+7353 */ { 0, 0, 0, 0, 0 },
/* U+7354 */ { 0, 0, 0, 0, 0 },
/* U+7355 */ { 0, 0, 0, 0, 0 },
/* U+7356 */ { 0, 0, 0, 0, 0 },
/* U+7357 */ { 0, 0, 0, 0, 0 },
/* U+7358 */ { 0, 0, 0, 0, 0 },
/* U+7359 */ { 0, 0, 0, 0, 0 },
/* U+735a */ { 0, 0, 0, 0, 0 },
/* U+735b */ { 0, 0, 0, 0, 0 },
/* U+735c */ { 0, 0, 0, 0, 0 },
/* U+735d */ { 0, 0, 0, 0, 0 },
/* U+735e */ { 0, 0, 0, 0, 0 },
/* U+735f */ { 0, 0, 0, 0, 0 },
/* U+7360 */ { 0, 0, 0, 0, 0 },
/* U+7361 */ { 0, 0, 0, 0, 0 },
/* U+7362 */ { 0, 0, 0, 0, 0 },
/* U+7363 */ { 0, 0, 0, 0, 0 },
/* U+7364 */ { 0, 0, 0, 0, 0 },
/* U+7365 */ { 0, 0, 0, 0, 0 },
/* U+7366 */ { 0, 0, 0, 0, 0 },
/* U+7367 */ { 0, 0, 0, 0, 0 },
/* U+7368 */ { 0, 0, 0, 0, 0 },
/* U+7369 */ { 0, 0, 0, 0, 0 },
/* U+736a */ { 0, 0, 0, 0, 0 },
/* U+736b */ { 0, 0, 0, 0, 0 },
/* U+736c */ { 0, 0, 0, 0, 0 },
/* U+736d */ { 0, 0, 0, 0, 0 },
/* U+736e */ { 0, 0, 0, 0, 0 },
/* U+736f */ { 0, 0, 0, 0, 0 },
/* U+7370 */ { 0, 0, 0, 0, 0 },
/* U+7371 */ { 0, 0, 0, 0, 0 },
/* U+7372 */ { 0, 0, 0, 0, 0 },
/* U+7373 */ { 0, 0, 0, 0, 0 },
/* U+7374 */ { 0, 0, 0, 0, 0 },
/* U+7375 */ { 0, 0, 0, 0, 0 },
/* U+7376 */ { 0, 0, 0, 0, 0 },
/* U+7377 */ { 0, 0, 0, 0, 0 },
/* U+7378 */ { 0, 0, 0, 0, 0 },
/* U+7379 */ { 0, 0, 0, 0, 0 },
/* U+737a */ { 0, 0, 0, 0, 0 },
/* U+737b */ { 0, 0, 0, 0, 0 },
/* U+737c */ { 0, 0, 0, 0, 0 },
/* U+737d */ { 0, 0, 0, 0, 0 },
/* U+737e */ { 0, 0, 0, 0, 0 },
/* U+737f */ { 0, 0, 0, 0, 0 },
/* U+7380 */ { 0, 0, 0, 0, 0 },
/* U+7381 */ { 0, 0, 0, 0, 0 },
/* U+7382 */ { 0, 0, 0, 0, 0 },
/* U+7383 */ { 0, 0, 0, 0, 0 },
/* U+7384 */ { 0, 0, 0, 0, 0 },
/* U+7385 */ { 0, 0, 0, 0, 0 },
/* U+7386 */ { 0, 0, 0, 0, 0 },
/* U+7387 */ { 0, 0, 0, 0, 0 },
/* U+7388 */ { 0, 0, 0, 0, 0 },
/* U+7389 */ { 0, 0, 0, 0, 0 },
/* U+738a */ { 0, 0, 0, 0, 0 },
/* U+738b */ { 0, 0, 0, 0, 0 },
/* U+738c */ { 0, 0, 0, 0, 0 },
/* U+738d */ { 0, 0, 0, 0, 0 },
/* U+738e */ { 0, 0, 0, 0, 0 },
/* U+738f */ { 0, 0, 0, 0, 0 },
/* U+7390 */ { 0, 0, 0, 0, 0 },
/* U+7391 */ { 0, 0, 0, 0, 0 },
/* U+7392 */ { 0, 0, 0, 0, 0 },
/* U+7393 */ { 0, 0, 0, 0, 0 },
/* U+7394 */ { 0, 0, 0, 0, 0 },
/* U+7395 */ { 0, 0, 0, 0, 0 },
/* U+7396 */ { 0, 0, 0, 0, 0 },
/* U+7397 */ { 0, 0, 0, 0, 0 },
/* U+7398 */ { 0, 0, 0, 0, 0 },
/* U+7399 */ { 0, 0, 0, 0, 0 },
/* U+739a */ { 0, 0, 0, 0, 0 },
/* U+739b */ { 0, 0, 0, 0, 0 },
/* U+739c */ { 0, 0, 0, 0, 0 },
/* U+739d */ { 0, 0, 0, 0, 0 },
/* U+739e */ { 0, 0, 0, 0, 0 },
/* U+739f */ { 0, 0, 0, 0, 0 },
/* U+73a0 */ { 0, 0, 0, 0, 0 },
/* U+73a1 */ { 0, 0, 0, 0, 0 },
/* U+73a2 */ { 0, 0, 0, 0, 0 },
/* U+73a3 */ { 0, 0, 0, 0, 0 },
/* U+73a4 */ { 0, 0, 0, 0, 0 },
/* U+73a5 */ { 0, 0, 0, 0, 0 },
/* U+73a6 */ { 0, 0, 0, 0, 0 },
/* U+73a7 */ { 0, 0, 0, 0, 0 },
/* U+73a8 */ { 0, 0, 0, 0, 0 },
/* U+73a9 */ { 0, 0, 0, 0, 0 },
/* U+73aa */ { 0, 0, 0, 0, 0 },
/* U+73ab */ { 0, 0, 0, 0, 0 },
/* U+73ac */ { 0, 0, 0, 0, 0 },
/* U+73ad */ { 0, 0, 0, 0, 0 },
/* U+73ae */ { 0, 0, 0, 0, 0 },
/* U+73af */ { 0, 0, 0, 0, 0 },
/* U+73b0 */ { 0, 0, 0, 0, 0 },
/* U+73b1 */ { 0, 0, 0, 0, 0 },
/* U+73b2 */ { 0, 0, 0, 0, 0 },
/* U+73b3 */ { 0, 0, 0, 0, 0 },
/* U+73b4 */ { 0, 0, 0, 0, 0 },
/* U+73b5 */ { 0, 0, 0, 0, 0 },
/* U+73b6 */ { 0, 0, 0, 0, 0 },
/* U+73b7 */ { 0, 0, 0, 0, 0 },
/* U+73b8 */ { 0, 0, 0, 0, 0 },
/* U+73b9 */ { 0, 0, 0, 0, 0 },
/* U+73ba */ { 0, 0, 0, 0, 0 },
/* U+73bb */ { 0, 0, 0, 0, 0 },
/* U+73bc */ { 0, 0, 0, 0, 0 },
/* U+73bd */ { 0, 0, 0, 0, 0 },
/* U+73be */ { 0, 0, 0, 0, 0 },
/* U+73bf */ { 0, 0, 0, 0, 0 },
/* U+73c0 */ { 0, 0, 0, 0, 0 },
/* U+73c1 */ { 0, 0, 0, 0, 0 },
/* U+73c2 */ { 0, 0, 0, 0, 0 },
/* U+73c3 */ { 0, 0, 0, 0, 0 },
/* U+73c4 */ { 0, 0, 0, 0, 0 },
/* U+73c5 */ { 0, 0, 0, 0, 0 },
/* U+73c6 */ { 0, 0, 0, 0, 0 },
/* U+73c7 */ { 0, 0, 0, 0, 0 },
/* U+73c8 */ { 0, 0, 0, 0, 0 },
/* U+73c9 */ { 0, 0, 0, 0, 0 },
/* U+73ca */ { 0, 0, 0, 0, 0 },
/* U+73cb */ { 0, 0, 0, 0, 0 },
/* U+73cc */ { 0, 0, 0, 0, 0 },
/* U+73cd */ { 0, 0, 0, 0, 0 },
/* U+73ce */ { 0, 0, 0, 0, 0 },
/* U+73cf */ { 0, 0, 0, 0, 0 },
/* U+73d0 */ { 0, 0, 0, 0, 0 },
/* U+73d1 */ { 0, 0, 0, 0, 0 },
/* U+73d2 */ { 0, 0, 0, 0, 0 },
/* U+73d3 */ { 0, 0, 0, 0, 0 },
/* U+73d4 */ { 0, 0, 0, 0, 0 },
/* U+73d5 */ { 0, 0, 0, 0, 0 },
/* U+73d6 */ { 0, 0, 0, 0, 0 },
/* U+73d7 */ { 0, 0, 0, 0, 0 },
/* U+73d8 */ { 0, 0, 0, 0, 0 },
/* U+73d9 */ { 0, 0, 0, 0, 0 },
/* U+73da */ { 0, 0, 0, 0, 0 },
/* U+73db */ { 0, 0, 0, 0, 0 },
/* U+73dc */ { 0, 0, 0, 0, 0 },
/* U+73dd */ { 0, 0, 0, 0, 0 },
/* U+73de */ { 0, 0, 0, 0, 0 },
/* U+73df */ { 0, 0, 0, 0, 0 },
/* U+73e0 */ { 0, 0, 0, 0, 0 },
/* U+73e1 */ { 0, 0, 0, 0, 0 },
/* U+73e2 */ { 0, 0, 0, 0, 0 },
/* U+73e3 */ { 0, 0, 0, 0, 0 },
/* U+73e4 */ { 0, 0, 0, 0, 0 },
/* U+73e5 */ { 0, 0, 0, 0, 0 },
/* U+73e6 */ { 0, 0, 0, 0, 0 },
/* U+73e7 */ { 0, 0, 0, 0, 0 },
/* U+73e8 */ { 0, 0, 0, 0, 0 },
/* U+73e9 */ { 0, 0, 0, 0, 0 },
/* U+73ea */ { 0, 0, 0, 0, 0 },
/* U+73eb */ { 0, 0, 0, 0, 0 },
/* U+73ec */ { 0, 0, 0, 0, 0 },
/* U+73ed */ { 0, 0, 0, 0, 0 },
/* U+73ee */ { 0, 0, 0, 0, 0 },
/* U+73ef */ { 0, 0, 0, 0, 0 },
/* U+73f0 */ { 0, 0, 0, 0, 0 },
/* U+73f1 */ { 0, 0, 0, 0, 0 },
/* U+73f2 */ { 0, 0, 0, 0, 0 },
/* U+73f3 */ { 0, 0, 0, 0, 0 },
/* U+73f4 */ { 0, 0, 0, 0, 0 },
/* U+73f5 */ { 0, 0, 0, 0, 0 },
/* U+73f6 */ { 0, 0, 0, 0, 0 },
/* U+73f7 */ { 0, 0, 0, 0, 0 },
/* U+73f8 */ { 0, 0, 0, 0, 0 },
/* U+73f9 */ { 0, 0, 0, 0, 0 },
/* U+73fa */ { 0, 0, 0, 0, 0 },
/* U+73fb */ { 0, 0, 0, 0, 0 },
/* U+73fc */ { 0, 0, 0, 0, 0 },
/* U+73fd */ { 0, 0, 0, 0, 0 },
/* U+73fe */ { 0, 0, 0, 0, 0 },
/* U+73ff */ { 0, 0, 0, 0, 0 },
/* U+7400 */ { 0, 0, 0, 0, 0 },
/* U+7401 */ { 0, 0, 0, 0, 0 },
/* U+7402 */ { 0, 0, 0, 0, 0 },
/* U+7403 */ { 0, 0, 0, 0, 0 },
/* U+7404 */ { 0, 0, 0, 0, 0 },
/* U+7405 */ { 0, 0, 0, 0, 0 },
/* U+7406 */ { 0, 0, 0, 0, 0 },
/* U+7407 */ { 0, 0, 0, 0, 0 },
/* U+7408 */ { 0, 0, 0, 0, 0 },
/* U+7409 */ { 0, 0, 0, 0, 0 },
/* U+740a */ { 0, 0, 0, 0, 0 },
/* U+740b */ { 0, 0, 0, 0, 0 },
/* U+740c */ { 0, 0, 0, 0, 0 },
/* U+740d */ { 0, 0, 0, 0, 0 },
/* U+740e */ { 0, 0, 0, 0, 0 },
/* U+740f */ { 0, 0, 0, 0, 0 },
/* U+7410 */ { 0, 0, 0, 0, 0 },
/* U+7411 */ { 0, 0, 0, 0, 0 },
/* U+7412 */ { 0, 0, 0, 0, 0 },
/* U+7413 */ { 0, 0, 0, 0, 0 },
/* U+7414 */ { 0, 0, 0, 0, 0 },
/* U+7415 */ { 0, 0, 0, 0, 0 },
/* U+7416 */ { 0, 0, 0, 0, 0 },
/* U+7417 */ { 0, 0, 0, 0, 0 },
/* U+7418 */ { 0, 0, 0, 0, 0 },
/* U+7419 */ { 0, 0, 0, 0, 0 },
/* U+741a */ { 0, 0, 0, 0, 0 },
/* U+741b */ { 0, 0, 0, 0, 0 },
/* U+741c */ { 0, 0, 0, 0, 0 },
/* U+741d */ { 0, 0, 0, 0, 0 },
/* U+741e */ { 0, 0, 0, 0, 0 },
/* U+741f */ { 0, 0, 0, 0, 0 },
/* U+7420 */ { 0, 0, 0, 0, 0 },
/* U+7421 */ { 0, 0, 0, 0, 0 },
/* U+7422 */ { 0, 0, 0, 0, 0 },
/* U+7423 */ { 0, 0, 0, 0, 0 },
/* U+7424 */ { 0, 0, 0, 0, 0 },
/* U+7425 */ { 0, 0, 0, 0, 0 },
/* U+7426 */ { 0, 0, 0, 0, 0 },
/* U+7427 */ { 0, 0, 0, 0, 0 },
/* U+7428 */ { 0, 0, 0, 0, 0 },
/* U+7429 */ { 0, 0, 0, 0, 0 },
/* U+742a */ { 0, 0, 0, 0, 0 },
/* U+742b */ { 0, 0, 0, 0, 0 },
/* U+742c */ { 0, 0, 0, 0, 0 },
/* U+742d */ { 0, 0, 0, 0, 0 },
/* U+742e */ { 0, 0, 0, 0, 0 },
/* U+742f */ { 0, 0, 0, 0, 0 },
/* U+7430 */ { 0, 0, 0, 0, 0 },
/* U+7431 */ { 0, 0, 0, 0, 0 },
/* U+7432 */ { 0, 0, 0, 0, 0 },
/* U+7433 */ { 0, 0, 0, 0, 0 },
/* U+7434 */ { 0, 0, 0, 0, 0 },
/* U+7435 */ { 0, 0, 0, 0, 0 },
/* U+7436 */ { 0, 0, 0, 0, 0 },
/* U+7437 */ { 0, 0, 0, 0, 0 },
/* U+7438 */ { 0, 0, 0, 0, 0 },
/* U+7439 */ { 0, 0, 0, 0, 0 },
/* U+743a */ { 0, 0, 0, 0, 0 },
/* U+743b */ { 0, 0, 0, 0, 0 },
/* U+743c */ { 0, 0, 0, 0, 0 },
/* U+743d */ { 0, 0, 0, 0, 0 },
/* U+743e */ { 0, 0, 0, 0, 0 },
/* U+743f */ { 0, 0, 0, 0, 0 },
/* U+7440 */ { 0, 0, 0, 0, 0 },
/* U+7441 */ { 0, 0, 0, 0, 0 },
/* U+7442 */ { 0, 0, 0, 0, 0 },
/* U+7443 */ { 0, 0, 0, 0, 0 },
/* U+7444 */ { 0, 0, 0, 0, 0 },
/* U+7445 */ { 0, 0, 0, 0, 0 },
/* U+7446 */ { 0, 0, 0, 0, 0 },
/* U+7447 */ { 0, 0, 0, 0, 0 },
/* U+7448 */ { 0, 0, 0, 0, 0 },
/* U+7449 */ { 0, 0, 0, 0, 0 },
/* U+744a */ { 0, 0, 0, 0, 0 },
/* U+744b */ { 0, 0, 0, 0, 0 },
/* U+744c */ { 0, 0, 0, 0, 0 },
/* U+744d */ { 0, 0, 0, 0, 0 },
/* U+744e */ { 0, 0, 0, 0, 0 },
/* U+744f */ { 0, 0, 0, 0, 0 },
/* U+7450 */ { 0, 0, 0, 0, 0 },
/* U+7451 */ { 0, 0, 0, 0, 0 },
/* U+7452 */ { 0, 0, 0, 0, 0 },
/* U+7453 */ { 0, 0, 0, 0, 0 },
/* U+7454 */ { 0, 0, 0, 0, 0 },
/* U+7455 */ { 0, 0, 0, 0, 0 },
/* U+7456 */ { 0, 0, 0, 0, 0 },
/* U+7457 */ { 0, 0, 0, 0, 0 },
/* U+7458 */ { 0, 0, 0, 0, 0 },
/* U+7459 */ { 0, 0, 0, 0, 0 },
/* U+745a */ { 0, 0, 0, 0, 0 },
/* U+745b */ { 0, 0, 0, 0, 0 },
/* U+745c */ { 0, 0, 0, 0, 0 },
/* U+745d */ { 0, 0, 0, 0, 0 },
/* U+745e */ { 0, 0, 0, 0, 0 },
/* U+745f */ { 0, 0, 0, 0, 0 },
/* U+7460 */ { 0, 0, 0, 0, 0 },
/* U+7461 */ { 0, 0, 0, 0, 0 },
/* U+7462 */ { 0, 0, 0, 0, 0 },
/* U+7463 */ { 0, 0, 0, 0, 0 },
/* U+7464 */ { 0, 0, 0, 0, 0 },
/* U+7465 */ { 0, 0, 0, 0, 0 },
/* U+7466 */ { 0, 0, 0, 0, 0 },
/* U+7467 */ { 0, 0, 0, 0, 0 },
/* U+7468 */ { 0, 0, 0, 0, 0 },
/* U+7469 */ { 0, 0, 0, 0, 0 },
/* U+746a */ { 0, 0, 0, 0, 0 },
/* U+746b */ { 0, 0, 0, 0, 0 },
/* U+746c */ { 0, 0, 0, 0, 0 },
/* U+746d */ { 0, 0, 0, 0, 0 },
/* U+746e */ { 0, 0, 0, 0, 0 },
/* U+746f */ { 0, 0, 0, 0, 0 },
/* U+7470 */ { 0, 0, 0, 0, 0 },
/* U+7471 */ { 0, 0, 0, 0, 0 },
/* U+7472 */ { 0, 0, 0, 0, 0 },
/* U+7473 */ { 0, 0, 0, 0, 0 },
/* U+7474 */ { 0, 0, 0, 0, 0 },
/* U+7475 */ { 0, 0, 0, 0, 0 },
/* U+7476 */ { 0, 0, 0, 0, 0 },
/* U+7477 */ { 0, 0, 0, 0, 0 },
/* U+7478 */ { 0, 0, 0, 0, 0 },
/* U+7479 */ { 0, 0, 0, 0, 0 },
/* U+747a */ { 0, 0, 0, 0, 0 },
/* U+747b */ { 0, 0, 0, 0, 0 },
/* U+747c */ { 0, 0, 0, 0, 0 },
/* U+747d */ { 0, 0, 0, 0, 0 },
/* U+747e */ { 0, 0, 0, 0, 0 },
/* U+747f */ { 0, 0, 0, 0, 0 },
/* U+7480 */ { 0, 0, 0, 0, 0 },
/* U+7481 */ { 0, 0, 0, 0, 0 },
/* U+7482 */ { 0, 0, 0, 0, 0 },
/* U+7483 */ { 0, 0, 0, 0, 0 },
/* U+7484 */ { 0, 0, 0, 0, 0 },
/* U+7485 */ { 0, 0, 0, 0, 0 },
/* U+7486 */ { 0, 0, 0, 0, 0 },
/* U+7487 */ { 0, 0, 0, 0, 0 },
/* U+7488 */ { 0, 0, 0, 0, 0 },
/* U+7489 */ { 0, 0, 0, 0, 0 },
/* U+748a */ { 0, 0, 0, 0, 0 },
/* U+748b */ { 0, 0, 0, 0, 0 },
/* U+748c */ { 0, 0, 0, 0, 0 },
/* U+748d */ { 0, 0, 0, 0, 0 },
/* U+748e */ { 0, 0, 0, 0, 0 },
/* U+748f */ { 0, 0, 0, 0, 0 },
/* U+7490 */ { 0, 0, 0, 0, 0 },
/* U+7491 */ { 0, 0, 0, 0, 0 },
/* U+7492 */ { 0, 0, 0, 0, 0 },
/* U+7493 */ { 0, 0, 0, 0, 0 },
/* U+7494 */ { 0, 0, 0, 0, 0 },
/* U+7495 */ { 0, 0, 0, 0, 0 },
/* U+7496 */ { 0, 0, 0, 0, 0 },
/* U+7497 */ { 0, 0, 0, 0, 0 },
/* U+7498 */ { 0, 0, 0, 0, 0 },
/* U+7499 */ { 0, 0, 0, 0, 0 },
/* U+749a */ { 0, 0, 0, 0, 0 },
/* U+749b */ { 0, 0, 0, 0, 0 },
/* U+749c */ { 0, 0, 0, 0, 0 },
/* U+749d */ { 0, 0, 0, 0, 0 },
/* U+749e */ { 0, 0, 0, 0, 0 },
/* U+749f */ { 0, 0, 0, 0, 0 },
/* U+74a0 */ { 0, 0, 0, 0, 0 },
/* U+74a1 */ { 0, 0, 0, 0, 0 },
/* U+74a2 */ { 0, 0, 0, 0, 0 },
/* U+74a3 */ { 0, 0, 0, 0, 0 },
/* U+74a4 */ { 0, 0, 0, 0, 0 },
/* U+74a5 */ { 0, 0, 0, 0, 0 },
/* U+74a6 */ { 0, 0, 0, 0, 0 },
/* U+74a7 */ { 0, 0, 0, 0, 0 },
/* U+74a8 */ { 0, 0, 0, 0, 0 },
/* U+74a9 */ { 0, 0, 0, 0, 0 },
/* U+74aa */ { 0, 0, 0, 0, 0 },
/* U+74ab */ { 0, 0, 0, 0, 0 },
/* U+74ac */ { 0, 0, 0, 0, 0 },
/* U+74ad */ { 0, 0, 0, 0, 0 },
/* U+74ae */ { 0, 0, 0, 0, 0 },
/* U+74af */ { 0, 0, 0, 0, 0 },
/* U+74b0 */ { 0, 0, 0, 0, 0 },
/* U+74b1 */ { 0, 0, 0, 0, 0 },
/* U+74b2 */ { 0, 0, 0, 0, 0 },
/* U+74b3 */ { 0, 0, 0, 0, 0 },
/* U+74b4 */ { 0, 0, 0, 0, 0 },
/* U+74b5 */ { 0, 0, 0, 0, 0 },
/* U+74b6 */ { 0, 0, 0, 0, 0 },
/* U+74b7 */ { 0, 0, 0, 0, 0 },
/* U+74b8 */ { 0, 0, 0, 0, 0 },
/* U+74b9 */ { 0, 0, 0, 0, 0 },
/* U+74ba */ { 0, 0, 0, 0, 0 },
/* U+74bb */ { 0, 0, 0, 0, 0 },
/* U+74bc */ { 0, 0, 0, 0, 0 },
/* U+74bd */ { 0, 0, 0, 0, 0 },
/* U+74be */ { 0, 0, 0, 0, 0 },
/* U+74bf */ { 0, 0, 0, 0, 0 },
/* U+74c0 */ { 0, 0, 0, 0, 0 },
/* U+74c1 */ { 0, 0, 0, 0, 0 },
/* U+74c2 */ { 0, 0, 0, 0, 0 },
/* U+74c3 */ { 0, 0, 0, 0, 0 },
/* U+74c4 */ { 0, 0, 0, 0, 0 },
/* U+74c5 */ { 0, 0, 0, 0, 0 },
/* U+74c6 */ { 0, 0, 0, 0, 0 },
/* U+74c7 */ { 0, 0, 0, 0, 0 },
/* U+74c8 */ { 0, 0, 0, 0, 0 },
/* U+74c9 */ { 0, 0, 0, 0, 0 },
/* U+74ca */ { 0, 0, 0, 0, 0 },
/* U+74cb */ { 0, 0, 0, 0, 0 },
/* U+74cc */ { 0, 0, 0, 0, 0 },
/* U+74cd */ { 0, 0, 0, 0, 0 },
/* U+74ce */ { 0, 0, 0, 0, 0 },
/* U+74cf */ { 0, 0, 0, 0, 0 },
/* U+74d0 */ { 0, 0, 0, 0, 0 },
/* U+74d1 */ { 0, 0, 0, 0, 0 },
/* U+74d2 */ { 0, 0, 0, 0, 0 },
/* U+74d3 */ { 0, 0, 0, 0, 0 },
/* U+74d4 */ { 0, 0, 0, 0, 0 },
/* U+74d5 */ { 0, 0, 0, 0, 0 },
/* U+74d6 */ { 0, 0, 0, 0, 0 },
/* U+74d7 */ { 0, 0, 0, 0, 0 },
/* U+74d8 */ { 0, 0, 0, 0, 0 },
/* U+74d9 */ { 0, 0, 0, 0, 0 },
/* U+74da */ { 0, 0, 0, 0, 0 },
/* U+74db */ { 0, 0, 0, 0, 0 },
/* U+74dc */ { 0, 0, 0, 0, 0 },
/* U+74dd */ { 0, 0, 0, 0, 0 },
/* U+74de */ { 0, 0, 0, 0, 0 },
/* U+74df */ { 0, 0, 0, 0, 0 },
/* U+74e0 */ { 0, 0, 0, 0, 0 },
/* U+74e1 */ { 0, 0, 0, 0, 0 },
/* U+74e2 */ { 0, 0, 0, 0, 0 },
/* U+74e3 */ { 0, 0, 0, 0, 0 },
/* U+74e4 */ { 0, 0, 0, 0, 0 },
/* U+74e5 */ { 0, 0, 0, 0, 0 },
/* U+74e6 */ { 0, 0, 0, 0, 0 },
/* U+74e7 */ { 0, 0, 0, 0, 0 },
/* U+74e8 */ { 0, 0, 0, 0, 0 },
/* U+74e9 */ { 0, 0, 0, 0, 0 },
/* U+74ea */ { 0, 0, 0, 0, 0 },
/* U+74eb */ { 0, 0, 0, 0, 0 },
/* U+74ec */ { 0, 0, 0, 0, 0 },
/* U+74ed */ { 0, 0, 0, 0, 0 },
/* U+74ee */ { 0, 0, 0, 0, 0 },
/* U+74ef */ { 0, 0, 0, 0, 0 },
/* U+74f0 */ { 0, 0, 0, 0, 0 },
/* U+74f1 */ { 0, 0, 0, 0, 0 },
/* U+74f2 */ { 0, 0, 0, 0, 0 },
/* U+74f3 */ { 0, 0, 0, 0, 0 },
/* U+74f4 */ { 0, 0, 0, 0, 0 },
/* U+74f5 */ { 0, 0, 0, 0, 0 },
/* U+74f6 */ { 0, 0, 0, 0, 0 },
/* U+74f7 */ { 0, 0, 0, 0, 0 },
/* U+74f8 */ { 0, 0, 0, 0, 0 },
/* U+74f9 */ { 0, 0, 0, 0, 0 },
/* U+74fa */ { 0, 0, 0, 0, 0 },
/* U+74fb */ { 0, 0, 0, 0, 0 },
/* U+74fc */ { 0, 0, 0, 0, 0 },
/* U+74fd */ { 0, 0, 0, 0, 0 },
/* U+74fe */ { 0, 0, 0, 0, 0 },
/* U+74ff */ { 0, 0, 0, 0, 0 },
/* U+7500 */ { 0, 0, 0, 0, 0 },
/* U+7501 */ { 0, 0, 0, 0, 0 },
/* U+7502 */ { 0, 0, 0, 0, 0 },
/* U+7503 */ { 0, 0, 0, 0, 0 },
/* U+7504 */ { 0, 0, 0, 0, 0 },
/* U+7505 */ { 0, 0, 0, 0, 0 },
/* U+7506 */ { 0, 0, 0, 0, 0 },
/* U+7507 */ { 0, 0, 0, 0, 0 },
/* U+7508 */ { 0, 0, 0, 0, 0 },
/* U+7509 */ { 0, 0, 0, 0, 0 },
/* U+750a */ { 0, 0, 0, 0, 0 },
/* U+750b */ { 0, 0, 0, 0, 0 },
/* U+750c */ { 0, 0, 0, 0, 0 },
/* U+750d */ { 0, 0, 0, 0, 0 },
/* U+750e */ { 0, 0, 0, 0, 0 },
/* U+750f */ { 0, 0, 0, 0, 0 },
/* U+7510 */ { 0, 0, 0, 0, 0 },
/* U+7511 */ { 0, 0, 0, 0, 0 },
/* U+7512 */ { 0, 0, 0, 0, 0 },
/* U+7513 */ { 0, 0, 0, 0, 0 },
/* U+7514 */ { 0, 0, 0, 0, 0 },
/* U+7515 */ { 0, 0, 0, 0, 0 },
/* U+7516 */ { 0, 0, 0, 0, 0 },
/* U+7517 */ { 0, 0, 0, 0, 0 },
/* U+7518 */ { 0, 0, 0, 0, 0 },
/* U+7519 */ { 0, 0, 0, 0, 0 },
/* U+751a */ { 0, 0, 0, 0, 0 },
/* U+751b */ { 0, 0, 0, 0, 0 },
/* U+751c */ { 0, 0, 0, 0, 0 },
/* U+751d */ { 0, 0, 0, 0, 0 },
/* U+751e */ { 0, 0, 0, 0, 0 },
/* U+751f */ { 0, 0, 0, 0, 0 },
/* U+7520 */ { 0, 0, 0, 0, 0 },
/* U+7521 */ { 0, 0, 0, 0, 0 },
/* U+7522 */ { 0, 0, 0, 0, 0 },
/* U+7523 */ { 0, 0, 0, 0, 0 },
/* U+7524 */ { 0, 0, 0, 0, 0 },
/* U+7525 */ { 0, 0, 0, 0, 0 },
/* U+7526 */ { 0, 0, 0, 0, 0 },
/* U+7527 */ { 0, 0, 0, 0, 0 },
/* U+7528 */ { 0, 0, 0, 0, 0 },
/* U+7529 */ { 0, 0, 0, 0, 0 },
/* U+752a */ { 0, 0, 0, 0, 0 },
/* U+752b */ { 0, 0, 0, 0, 0 },
/* U+752c */ { 0, 0, 0, 0, 0 },
/* U+752d */ { 0, 0, 0, 0, 0 },
/* U+752e */ { 0, 0, 0, 0, 0 },
/* U+752f */ { 0, 0, 0, 0, 0 },
/* U+7530 */ { 0, 0, 0, 0, 0 },
/* U+7531 */ { 0, 0, 0, 0, 0 },
/* U+7532 */ { 0, 0, 0, 0, 0 },
/* U+7533 */ { 0, 0, 0, 0, 0 },
/* U+7534 */ { 0, 0, 0, 0, 0 },
/* U+7535 */ { 0, 0, 0, 0, 0 },
/* U+7536 */ { 0, 0, 0, 0, 0 },
/* U+7537 */ { 0, 0, 0, 0, 0 },
/* U+7538 */ { 0, 0, 0, 0, 0 },
/* U+7539 */ { 0, 0, 0, 0, 0 },
/* U+753a */ { 0, 0, 0, 0, 0 },
/* U+753b */ { 0, 0, 0, 0, 0 },
/* U+753c */ { 0, 0, 0, 0, 0 },
/* U+753d */ { 0, 0, 0, 0, 0 },
/* U+753e */ { 0, 0, 0, 0, 0 },
/* U+753f */ { 0, 0, 0, 0, 0 },
/* U+7540 */ { 0, 0, 0, 0, 0 },
/* U+7541 */ { 0, 0, 0, 0, 0 },
/* U+7542 */ { 0, 0, 0, 0, 0 },
/* U+7543 */ { 0, 0, 0, 0, 0 },
/* U+7544 */ { 0, 0, 0, 0, 0 },
/* U+7545 */ { 0, 0, 0, 0, 0 },
/* U+7546 */ { 0, 0, 0, 0, 0 },
/* U+7547 */ { 0, 0, 0, 0, 0 },
/* U+7548 */ { 0, 0, 0, 0, 0 },
/* U+7549 */ { 0, 0, 0, 0, 0 },
/* U+754a */ { 0, 0, 0, 0, 0 },
/* U+754b */ { 0, 0, 0, 0, 0 },
/* U+754c */ { 0, 0, 0, 0, 0 },
/* U+754d */ { 0, 0, 0, 0, 0 },
/* U+754e */ { 0, 0, 0, 0, 0 },
/* U+754f */ { 0, 0, 0, 0, 0 },
/* U+7550 */ { 0, 0, 0, 0, 0 },
/* U+7551 */ { 0, 0, 0, 0, 0 },
/* U+7552 */ { 0, 0, 0, 0, 0 },
/* U+7553 */ { 0, 0, 0, 0, 0 },
/* U+7554 */ { 0, 0, 0, 0, 0 },
/* U+7555 */ { 0, 0, 0, 0, 0 },
/* U+7556 */ { 0, 0, 0, 0, 0 },
/* U+7557 */ { 0, 0, 0, 0, 0 },
/* U+7558 */ { 0, 0, 0, 0, 0 },
/* U+7559 */ { 0, 0, 0, 0, 0 },
/* U+755a */ { 0, 0, 0, 0, 0 },
/* U+755b */ { 0, 0, 0, 0, 0 },
/* U+755c */ { 0, 0, 0, 0, 0 },
/* U+755d */ { 0, 0, 0, 0, 0 },
/* U+755e */ { 0, 0, 0, 0, 0 },
/* U+755f */ { 0, 0, 0, 0, 0 },
/* U+7560 */ { 0, 0, 0, 0, 0 },
/* U+7561 */ { 0, 0, 0, 0, 0 },
/* U+7562 */ { 0, 0, 0, 0, 0 },
/* U+7563 */ { 0, 0, 0, 0, 0 },
/* U+7564 */ { 0, 0, 0, 0, 0 },
/* U+7565 */ { 0, 0, 0, 0, 0 },
/* U+7566 */ { 0, 0, 0, 0, 0 },
/* U+7567 */ { 0, 0, 0, 0, 0 },
/* U+7568 */ { 0, 0, 0, 0, 0 },
/* U+7569 */ { 0, 0, 0, 0, 0 },
/* U+756a */ { 0, 0, 0, 0, 0 },
/* U+756b */ { 0, 0, 0, 0, 0 },
/* U+756c */ { 0, 0, 0, 0, 0 },
/* U+756d */ { 0, 0, 0, 0, 0 },
/* U+756e */ { 0, 0, 0, 0, 0 },
/* U+756f */ { 0, 0, 0, 0, 0 },
/* U+7570 */ { 0, 0, 0, 0, 0 },
/* U+7571 */ { 0, 0, 0, 0, 0 },
/* U+7572 */ { 0, 0, 0, 0, 0 },
/* U+7573 */ { 0, 0, 0, 0, 0 },
/* U+7574 */ { 0, 0, 0, 0, 0 },
/* U+7575 */ { 0, 0, 0, 0, 0 },
/* U+7576 */ { 0, 0, 0, 0, 0 },
/* U+7577 */ { 0, 0, 0, 0, 0 },
/* U+7578 */ { 0, 0, 0, 0, 0 },
/* U+7579 */ { 0, 0, 0, 0, 0 },
/* U+757a */ { 0, 0, 0, 0, 0 },
/* U+757b */ { 0, 0, 0, 0, 0 },
/* U+757c */ { 0, 0, 0, 0, 0 },
/* U+757d */ { 0, 0, 0, 0, 0 },
/* U+757e */ { 0, 0, 0, 0, 0 },
/* U+757f */ { 0, 0, 0, 0, 0 },
/* U+7580 */ { 0, 0, 0, 0, 0 },
/* U+7581 */ { 0, 0, 0, 0, 0 },
/* U+7582 */ { 0, 0, 0, 0, 0 },
/* U+7583 */ { 0, 0, 0, 0, 0 },
/* U+7584 */ { 0, 0, 0, 0, 0 },
/* U+7585 */ { 0, 0, 0, 0, 0 },
/* U+7586 */ { 0, 0, 0, 0, 0 },
/* U+7587 */ { 0, 0, 0, 0, 0 },
/* U+7588 */ { 0, 0, 0, 0, 0 },
/* U+7589 */ { 0, 0, 0, 0, 0 },
/* U+758a */ { 0, 0, 0, 0, 0 },
/* U+758b */ { 0, 0, 0, 0, 0 },
/* U+758c */ { 0, 0, 0, 0, 0 },
/* U+758d */ { 0, 0, 0, 0, 0 },
/* U+758e */ { 0, 0, 0, 0, 0 },
/* U+758f */ { 0, 0, 0, 0, 0 },
/* U+7590 */ { 0, 0, 0, 0, 0 },
/* U+7591 */ { 0, 0, 0, 0, 0 },
/* U+7592 */ { 0, 0, 0, 0, 0 },
/* U+7593 */ { 0, 0, 0, 0, 0 },
/* U+7594 */ { 0, 0, 0, 0, 0 },
/* U+7595 */ { 0, 0, 0, 0, 0 },
/* U+7596 */ { 0, 0, 0, 0, 0 },
/* U+7597 */ { 0, 0, 0, 0, 0 },
/* U+7598 */ { 0, 0, 0, 0, 0 },
/* U+7599 */ { 0, 0, 0, 0, 0 },
/* U+759a */ { 0, 0, 0, 0, 0 },
/* U+759b */ { 0, 0, 0, 0, 0 },
/* U+759c */ { 0, 0, 0, 0, 0 },
/* U+759d */ { 0, 0, 0, 0, 0 },
/* U+759e */ { 0, 0, 0, 0, 0 },
/* U+759f */ { 0, 0, 0, 0, 0 },
/* U+75a0 */ { 0, 0, 0, 0, 0 },
/* U+75a1 */ { 0, 0, 0, 0, 0 },
/* U+75a2 */ { 0, 0, 0, 0, 0 },
/* U+75a3 */ { 0, 0, 0, 0, 0 },
/* U+75a4 */ { 0, 0, 0, 0, 0 },
/* U+75a5 */ { 0, 0, 0, 0, 0 },
/* U+75a6 */ { 0, 0, 0, 0, 0 },
/* U+75a7 */ { 0, 0, 0, 0, 0 },
/* U+75a8 */ { 0, 0, 0, 0, 0 },
/* U+75a9 */ { 0, 0, 0, 0, 0 },
/* U+75aa */ { 0, 0, 0, 0, 0 },
/* U+75ab */ { 0, 0, 0, 0, 0 },
/* U+75ac */ { 0, 0, 0, 0, 0 },
/* U+75ad */ { 0, 0, 0, 0, 0 },
/* U+75ae */ { 0, 0, 0, 0, 0 },
/* U+75af */ { 0, 0, 0, 0, 0 },
/* U+75b0 */ { 0, 0, 0, 0, 0 },
/* U+75b1 */ { 0, 0, 0, 0, 0 },
/* U+75b2 */ { 0, 0, 0, 0, 0 },
/* U+75b3 */ { 0, 0, 0, 0, 0 },
/* U+75b4 */ { 0, 0, 0, 0, 0 },
/* U+75b5 */ { 0, 0, 0, 0, 0 },
/* U+75b6 */ { 0, 0, 0, 0, 0 },
/* U+75b7 */ { 0, 0, 0, 0, 0 },
/* U+75b8 */ { 0, 0, 0, 0, 0 },
/* U+75b9 */ { 0, 0, 0, 0, 0 },
/* U+75ba */ { 0, 0, 0, 0, 0 },
/* U+75bb */ { 0, 0, 0, 0, 0 },
/* U+75bc */ { 0, 0, 0, 0, 0 },
/* U+75bd */ { 0, 0, 0, 0, 0 },
/* U+75be */ { 0, 0, 0, 0, 0 },
/* U+75bf */ { 0, 0, 0, 0, 0 },
/* U+75c0 */ { 0, 0, 0, 0, 0 },
/* U+75c1 */ { 0, 0, 0, 0, 0 },
/* U+75c2 */ { 0, 0, 0, 0, 0 },
/* U+75c3 */ { 0, 0, 0, 0, 0 },
/* U+75c4 */ { 0, 0, 0, 0, 0 },
/* U+75c5 */ { 0, 0, 0, 0, 0 },
/* U+75c6 */ { 0, 0, 0, 0, 0 },
/* U+75c7 */ { 0, 0, 0, 0, 0 },
/* U+75c8 */ { 0, 0, 0, 0, 0 },
/* U+75c9 */ { 0, 0, 0, 0, 0 },
/* U+75ca */ { 0, 0, 0, 0, 0 },
/* U+75cb */ { 0, 0, 0, 0, 0 },
/* U+75cc */ { 0, 0, 0, 0, 0 },
/* U+75cd */ { 0, 0, 0, 0, 0 },
/* U+75ce */ { 0, 0, 0, 0, 0 },
/* U+75cf */ { 0, 0, 0, 0, 0 },
/* U+75d0 */ { 0, 0, 0, 0, 0 },
/* U+75d1 */ { 0, 0, 0, 0, 0 },
/* U+75d2 */ { 0, 0, 0, 0, 0 },
/* U+75d3 */ { 0, 0, 0, 0, 0 },
/* U+75d4 */ { 0, 0, 0, 0, 0 },
/* U+75d5 */ { 0, 0, 0, 0, 0 },
/* U+75d6 */ { 0, 0, 0, 0, 0 },
/* U+75d7 */ { 0, 0, 0, 0, 0 },
/* U+75d8 */ { 0, 0, 0, 0, 0 },
/* U+75d9 */ { 0, 0, 0, 0, 0 },
/* U+75da */ { 0, 0, 0, 0, 0 },
/* U+75db */ { 0, 0, 0, 0, 0 },
/* U+75dc */ { 0, 0, 0, 0, 0 },
/* U+75dd */ { 0, 0, 0, 0, 0 },
/* U+75de */ { 0, 0, 0, 0, 0 },
/* U+75df */ { 0, 0, 0, 0, 0 },
/* U+75e0 */ { 0, 0, 0, 0, 0 },
/* U+75e1 */ { 0, 0, 0, 0, 0 },
/* U+75e2 */ { 0, 0, 0, 0, 0 },
/* U+75e3 */ { 0, 0, 0, 0, 0 },
/* U+75e4 */ { 0, 0, 0, 0, 0 },
/* U+75e5 */ { 0, 0, 0, 0, 0 },
/* U+75e6 */ { 0, 0, 0, 0, 0 },
/* U+75e7 */ { 0, 0, 0, 0, 0 },
/* U+75e8 */ { 0, 0, 0, 0, 0 },
/* U+75e9 */ { 0, 0, 0, 0, 0 },
/* U+75ea */ { 0, 0, 0, 0, 0 },
/* U+75eb */ { 0, 0, 0, 0, 0 },
/* U+75ec */ { 0, 0, 0, 0, 0 },
/* U+75ed */ { 0, 0, 0, 0, 0 },
/* U+75ee */ { 0, 0, 0, 0, 0 },
/* U+75ef */ { 0, 0, 0, 0, 0 },
/* U+75f0 */ { 0, 0, 0, 0, 0 },
/* U+75f1 */ { 0, 0, 0, 0, 0 },
/* U+75f2 */ { 0, 0, 0, 0, 0 },
/* U+75f3 */ { 0, 0, 0, 0, 0 },
/* U+75f4 */ { 0, 0, 0, 0, 0 },
/* U+75f5 */ { 0, 0, 0, 0, 0 },
/* U+75f6 */ { 0, 0, 0, 0, 0 },
/* U+75f7 */ { 0, 0, 0, 0, 0 },
/* U+75f8 */ { 0, 0, 0, 0, 0 },
/* U+75f9 */ { 0, 0, 0, 0, 0 },
/* U+75fa */ { 0, 0, 0, 0, 0 },
/* U+75fb */ { 0, 0, 0, 0, 0 },
/* U+75fc */ { 0, 0, 0, 0, 0 },
/* U+75fd */ { 0, 0, 0, 0, 0 },
/* U+75fe */ { 0, 0, 0, 0, 0 },
/* U+75ff */ { 0, 0, 0, 0, 0 },
/* U+7600 */ { 0, 0, 0, 0, 0 },
/* U+7601 */ { 0, 0, 0, 0, 0 },
/* U+7602 */ { 0, 0, 0, 0, 0 },
/* U+7603 */ { 0, 0, 0, 0, 0 },
/* U+7604 */ { 0, 0, 0, 0, 0 },
/* U+7605 */ { 0, 0, 0, 0, 0 },
/* U+7606 */ { 0, 0, 0, 0, 0 },
/* U+7607 */ { 0, 0, 0, 0, 0 },
/* U+7608 */ { 0, 0, 0, 0, 0 },
/* U+7609 */ { 0, 0, 0, 0, 0 },
/* U+760a */ { 0, 0, 0, 0, 0 },
/* U+760b */ { 0, 0, 0, 0, 0 },
/* U+760c */ { 0, 0, 0, 0, 0 },
/* U+760d */ { 0, 0, 0, 0, 0 },
/* U+760e */ { 0, 0, 0, 0, 0 },
/* U+760f */ { 0, 0, 0, 0, 0 },
/* U+7610 */ { 0, 0, 0, 0, 0 },
/* U+7611 */ { 0, 0, 0, 0, 0 },
/* U+7612 */ { 0, 0, 0, 0, 0 },
/* U+7613 */ { 0, 0, 0, 0, 0 },
/* U+7614 */ { 0, 0, 0, 0, 0 },
/* U+7615 */ { 0, 0, 0, 0, 0 },
/* U+7616 */ { 0, 0, 0, 0, 0 },
/* U+7617 */ { 0, 0, 0, 0, 0 },
/* U+7618 */ { 0, 0, 0, 0, 0 },
/* U+7619 */ { 0, 0, 0, 0, 0 },
/* U+761a */ { 0, 0, 0, 0, 0 },
/* U+761b */ { 0, 0, 0, 0, 0 },
/* U+761c */ { 0, 0, 0, 0, 0 },
/* U+761d */ { 0, 0, 0, 0, 0 },
/* U+761e */ { 0, 0, 0, 0, 0 },
/* U+761f */ { 0, 0, 0, 0, 0 },
/* U+7620 */ { 0, 0, 0, 0, 0 },
/* U+7621 */ { 0, 0, 0, 0, 0 },
/* U+7622 */ { 0, 0, 0, 0, 0 },
/* U+7623 */ { 0, 0, 0, 0, 0 },
/* U+7624 */ { 0, 0, 0, 0, 0 },
/* U+7625 */ { 0, 0, 0, 0, 0 },
/* U+7626 */ { 0, 0, 0, 0, 0 },
/* U+7627 */ { 0, 0, 0, 0, 0 },
/* U+7628 */ { 0, 0, 0, 0, 0 },
/* U+7629 */ { 0, 0, 0, 0, 0 },
/* U+762a */ { 0, 0, 0, 0, 0 },
/* U+762b */ { 0, 0, 0, 0, 0 },
/* U+762c */ { 0, 0, 0, 0, 0 },
/* U+762d */ { 0, 0, 0, 0, 0 },
/* U+762e */ { 0, 0, 0, 0, 0 },
/* U+762f */ { 0, 0, 0, 0, 0 },
/* U+7630 */ { 0, 0, 0, 0, 0 },
/* U+7631 */ { 0, 0, 0, 0, 0 },
/* U+7632 */ { 0, 0, 0, 0, 0 },
/* U+7633 */ { 0, 0, 0, 0, 0 },
/* U+7634 */ { 0, 0, 0, 0, 0 },
/* U+7635 */ { 0, 0, 0, 0, 0 },
/* U+7636 */ { 0, 0, 0, 0, 0 },
/* U+7637 */ { 0, 0, 0, 0, 0 },
/* U+7638 */ { 0, 0, 0, 0, 0 },
/* U+7639 */ { 0, 0, 0, 0, 0 },
/* U+763a */ { 0, 0, 0, 0, 0 },
/* U+763b */ { 0, 0, 0, 0, 0 },
/* U+763c */ { 0, 0, 0, 0, 0 },
/* U+763d */ { 0, 0, 0, 0, 0 },
/* U+763e */ { 0, 0, 0, 0, 0 },
/* U+763f */ { 0, 0, 0, 0, 0 },
/* U+7640 */ { 0, 0, 0, 0, 0 },
/* U+7641 */ { 0, 0, 0, 0, 0 },
/* U+7642 */ { 0, 0, 0, 0, 0 },
/* U+7643 */ { 0, 0, 0, 0, 0 },
/* U+7644 */ { 0, 0, 0, 0, 0 },
/* U+7645 */ { 0, 0, 0, 0, 0 },
/* U+7646 */ { 0, 0, 0, 0, 0 },
/* U+7647 */ { 0, 0, 0, 0, 0 },
/* U+7648 */ { 0, 0, 0, 0, 0 },
/* U+7649 */ { 0, 0, 0, 0, 0 },
/* U+764a */ { 0, 0, 0, 0, 0 },
/* U+764b */ { 0, 0, 0, 0, 0 },
/* U+764c */ { 0, 0, 0, 0, 0 },
/* U+764d */ { 0, 0, 0, 0, 0 },
/* U+764e */ { 0, 0, 0, 0, 0 },
/* U+764f */ { 0, 0, 0, 0, 0 },
/* U+7650 */ { 0, 0, 0, 0, 0 },
/* U+7651 */ { 0, 0, 0, 0, 0 },
/* U+7652 */ { 0, 0, 0, 0, 0 },
/* U+7653 */ { 0, 0, 0, 0, 0 },
/* U+7654 */ { 0, 0, 0, 0, 0 },
/* U+7655 */ { 0, 0, 0, 0, 0 },
/* U+7656 */ { 0, 0, 0, 0, 0 },
/* U+7657 */ { 0, 0, 0, 0, 0 },
/* U+7658 */ { 0, 0, 0, 0, 0 },
/* U+7659 */ { 0, 0, 0, 0, 0 },
/* U+765a */ { 0, 0, 0, 0, 0 },
/* U+765b */ { 0, 0, 0, 0, 0 },
/* U+765c */ { 0, 0, 0, 0, 0 },
/* U+765d */ { 0, 0, 0, 0, 0 },
/* U+765e */ { 0, 0, 0, 0, 0 },
/* U+765f */ { 0, 0, 0, 0, 0 },
/* U+7660 */ { 0, 0, 0, 0, 0 },
/* U+7661 */ { 0, 0, 0, 0, 0 },
/* U+7662 */ { 0, 0, 0, 0, 0 },
/* U+7663 */ { 0, 0, 0, 0, 0 },
/* U+7664 */ { 0, 0, 0, 0, 0 },
/* U+7665 */ { 0, 0, 0, 0, 0 },
/* U+7666 */ { 0, 0, 0, 0, 0 },
/* U+7667 */ { 0, 0, 0, 0, 0 },
/* U+7668 */ { 0, 0, 0, 0, 0 },
/* U+7669 */ { 0, 0, 0, 0, 0 },
/* U+766a */ { 0, 0, 0, 0, 0 },
/* U+766b */ { 0, 0, 0, 0, 0 },
/* U+766c */ { 0, 0, 0, 0, 0 },
/* U+766d */ { 0, 0, 0, 0, 0 },
/* U+766e */ { 0, 0, 0, 0, 0 },
/* U+766f */ { 0, 0, 0, 0, 0 },
/* U+7670 */ { 0, 0, 0, 0, 0 },
/* U+7671 */ { 0, 0, 0, 0, 0 },
/* U+7672 */ { 0, 0, 0, 0, 0 },
/* U+7673 */ { 0, 0, 0, 0, 0 },
/* U+7674 */ { 0, 0, 0, 0, 0 },
/* U+7675 */ { 0, 0, 0, 0, 0 },
/* U+7676 */ { 0, 0, 0, 0, 0 },
/* U+7677 */ { 0, 0, 0, 0, 0 },
/* U+7678 */ { 0, 0, 0, 0, 0 },
/* U+7679 */ { 0, 0, 0, 0, 0 },
/* U+767a */ { 0, 0, 0, 0, 0 },
/* U+767b */ { 0, 0, 0, 0, 0 },
/* U+767c */ { 0, 0, 0, 0, 0 },
/* U+767d */ { 0, 0, 0, 0, 0 },
/* U+767e */ { 0, 0, 0, 0, 0 },
/* U+767f */ { 0, 0, 0, 0, 0 },
/* U+7680 */ { 0, 0, 0, 0, 0 },
/* U+7681 */ { 0, 0, 0, 0, 0 },
/* U+7682 */ { 0, 0, 0, 0, 0 },
/* U+7683 */ { 0, 0, 0, 0, 0 },
/* U+7684 */ { 0, 0, 0, 0, 0 },
/* U+7685 */ { 0, 0, 0, 0, 0 },
/* U+7686 */ { 0, 0, 0, 0, 0 },
/* U+7687 */ { 0, 0, 0, 0, 0 },
/* U+7688 */ { 0, 0, 0, 0, 0 },
/* U+7689 */ { 0, 0, 0, 0, 0 },
/* U+768a */ { 0, 0, 0, 0, 0 },
/* U+768b */ { 0, 0, 0, 0, 0 },
/* U+768c */ { 0, 0, 0, 0, 0 },
/* U+768d */ { 0, 0, 0, 0, 0 },
/* U+768e */ { 0, 0, 0, 0, 0 },
/* U+768f */ { 0, 0, 0, 0, 0 },
/* U+7690 */ { 0, 0, 0, 0, 0 },
/* U+7691 */ { 0, 0, 0, 0, 0 },
/* U+7692 */ { 0, 0, 0, 0, 0 },
/* U+7693 */ { 0, 0, 0, 0, 0 },
/* U+7694 */ { 0, 0, 0, 0, 0 },
/* U+7695 */ { 0, 0, 0, 0, 0 },
/* U+7696 */ { 0, 0, 0, 0, 0 },
/* U+7697 */ { 0, 0, 0, 0, 0 },
/* U+7698 */ { 0, 0, 0, 0, 0 },
/* U+7699 */ { 0, 0, 0, 0, 0 },
/* U+769a */ { 0, 0, 0, 0, 0 },
/* U+769b */ { 0, 0, 0, 0, 0 },
/* U+769c */ { 0, 0, 0, 0, 0 },
/* U+769d */ { 0, 0, 0, 0, 0 },
/* U+769e */ { 0, 0, 0, 0, 0 },
/* U+769f */ { 0, 0, 0, 0, 0 },
/* U+76a0 */ { 0, 0, 0, 0, 0 },
/* U+76a1 */ { 0, 0, 0, 0, 0 },
/* U+76a2 */ { 0, 0, 0, 0, 0 },
/* U+76a3 */ { 0, 0, 0, 0, 0 },
/* U+76a4 */ { 0, 0, 0, 0, 0 },
/* U+76a5 */ { 0, 0, 0, 0, 0 },
/* U+76a6 */ { 0, 0, 0, 0, 0 },
/* U+76a7 */ { 0, 0, 0, 0, 0 },
/* U+76a8 */ { 0, 0, 0, 0, 0 },
/* U+76a9 */ { 0, 0, 0, 0, 0 },
/* U+76aa */ { 0, 0, 0, 0, 0 },
/* U+76ab */ { 0, 0, 0, 0, 0 },
/* U+76ac */ { 0, 0, 0, 0, 0 },
/* U+76ad */ { 0, 0, 0, 0, 0 },
/* U+76ae */ { 0, 0, 0, 0, 0 },
/* U+76af */ { 0, 0, 0, 0, 0 },
/* U+76b0 */ { 0, 0, 0, 0, 0 },
/* U+76b1 */ { 0, 0, 0, 0, 0 },
/* U+76b2 */ { 0, 0, 0, 0, 0 },
/* U+76b3 */ { 0, 0, 0, 0, 0 },
/* U+76b4 */ { 0, 0, 0, 0, 0 },
/* U+76b5 */ { 0, 0, 0, 0, 0 },
/* U+76b6 */ { 0, 0, 0, 0, 0 },
/* U+76b7 */ { 0, 0, 0, 0, 0 },
/* U+76b8 */ { 0, 0, 0, 0, 0 },
/* U+76b9 */ { 0, 0, 0, 0, 0 },
/* U+76ba */ { 0, 0, 0, 0, 0 },
/* U+76bb */ { 0, 0, 0, 0, 0 },
/* U+76bc */ { 0, 0, 0, 0, 0 },
/* U+76bd */ { 0, 0, 0, 0, 0 },
/* U+76be */ { 0, 0, 0, 0, 0 },
/* U+76bf */ { 0, 0, 0, 0, 0 },
/* U+76c0 */ { 0, 0, 0, 0, 0 },
/* U+76c1 */ { 0, 0, 0, 0, 0 },
/* U+76c2 */ { 0, 0, 0, 0, 0 },
/* U+76c3 */ { 0, 0, 0, 0, 0 },
/* U+76c4 */ { 0, 0, 0, 0, 0 },
/* U+76c5 */ { 0, 0, 0, 0, 0 },
/* U+76c6 */ { 0, 0, 0, 0, 0 },
/* U+76c7 */ { 0, 0, 0, 0, 0 },
/* U+76c8 */ { 0, 0, 0, 0, 0 },
/* U+76c9 */ { 0, 0, 0, 0, 0 },
/* U+76ca */ { 0, 0, 0, 0, 0 },
/* U+76cb */ { 0, 0, 0, 0, 0 },
/* U+76cc */ { 0, 0, 0, 0, 0 },
/* U+76cd */ { 0, 0, 0, 0, 0 },
/* U+76ce */ { 0, 0, 0, 0, 0 },
/* U+76cf */ { 0, 0, 0, 0, 0 },
/* U+76d0 */ { 0, 0, 0, 0, 0 },
/* U+76d1 */ { 0, 0, 0, 0, 0 },
/* U+76d2 */ { 0, 0, 0, 0, 0 },
/* U+76d3 */ { 0, 0, 0, 0, 0 },
/* U+76d4 */ { 0, 0, 0, 0, 0 },
/* U+76d5 */ { 0, 0, 0, 0, 0 },
/* U+76d6 */ { 0, 0, 0, 0, 0 },
/* U+76d7 */ { 0, 0, 0, 0, 0 },
/* U+76d8 */ { 0, 0, 0, 0, 0 },
/* U+76d9 */ { 0, 0, 0, 0, 0 },
/* U+76da */ { 0, 0, 0, 0, 0 },
/* U+76db */ { 0, 0, 0, 0, 0 },
/* U+76dc */ { 0, 0, 0, 0, 0 },
/* U+76dd */ { 0, 0, 0, 0, 0 },
/* U+76de */ { 0, 0, 0, 0, 0 },
/* U+76df */ { 0, 0, 0, 0, 0 },
/* U+76e0 */ { 0, 0, 0, 0, 0 },
/* U+76e1 */ { 0, 0, 0, 0, 0 },
/* U+76e2 */ { 0, 0, 0, 0, 0 },
/* U+76e3 */ { 0, 0, 0, 0, 0 },
/* U+76e4 */ { 0, 0, 0, 0, 0 },
/* U+76e5 */ { 0, 0, 0, 0, 0 },
/* U+76e6 */ { 0, 0, 0, 0, 0 },
/* U+76e7 */ { 0, 0, 0, 0, 0 },
/* U+76e8 */ { 0, 0, 0, 0, 0 },
/* U+76e9 */ { 0, 0, 0, 0, 0 },
/* U+76ea */ { 0, 0, 0, 0, 0 },
/* U+76eb */ { 0, 0, 0, 0, 0 },
/* U+76ec */ { 0, 0, 0, 0, 0 },
/* U+76ed */ { 0, 0, 0, 0, 0 },
/* U+76ee */ { 0, 0, 0, 0, 0 },
/* U+76ef */ { 0, 0, 0, 0, 0 },
/* U+76f0 */ { 0, 0, 0, 0, 0 },
/* U+76f1 */ { 0, 0, 0, 0, 0 },
/* U+76f2 */ { 0, 0, 0, 0, 0 },
/* U+76f3 */ { 0, 0, 0, 0, 0 },
/* U+76f4 */ { 0, 0, 0, 0, 0 },
/* U+76f5 */ { 0, 0, 0, 0, 0 },
/* U+76f6 */ { 0, 0, 0, 0, 0 },
/* U+76f7 */ { 0, 0, 0, 0, 0 },
/* U+76f8 */ { 0, 0, 0, 0, 0 },
/* U+76f9 */ { 0, 0, 0, 0, 0 },
/* U+76fa */ { 0, 0, 0, 0, 0 },
/* U+76fb */ { 0, 0, 0, 0, 0 },
/* U+76fc */ { 0, 0, 0, 0, 0 },
/* U+76fd */ { 0, 0, 0, 0, 0 },
/* U+76fe */ { 0, 0, 0, 0, 0 },
/* U+76ff */ { 0, 0, 0, 0, 0 },
/* U+7700 */ { 0, 0, 0, 0, 0 },
/* U+7701 */ { 0, 0, 0, 0, 0 },
/* U+7702 */ { 0, 0, 0, 0, 0 },
/* U+7703 */ { 0, 0, 0, 0, 0 },
/* U+7704 */ { 0, 0, 0, 0, 0 },
/* U+7705 */ { 0, 0, 0, 0, 0 },
/* U+7706 */ { 0, 0, 0, 0, 0 },
/* U+7707 */ { 0, 0, 0, 0, 0 },
/* U+7708 */ { 0, 0, 0, 0, 0 },
/* U+7709 */ { 0, 0, 0, 0, 0 },
/* U+770a */ { 0, 0, 0, 0, 0 },
/* U+770b */ { 0, 0, 0, 0, 0 },
/* U+770c */ { 0, 0, 0, 0, 0 },
/* U+770d */ { 0, 0, 0, 0, 0 },
/* U+770e */ { 0, 0, 0, 0, 0 },
/* U+770f */ { 0, 0, 0, 0, 0 },
/* U+7710 */ { 0, 0, 0, 0, 0 },
/* U+7711 */ { 0, 0, 0, 0, 0 },
/* U+7712 */ { 0, 0, 0, 0, 0 },
/* U+7713 */ { 0, 0, 0, 0, 0 },
/* U+7714 */ { 0, 0, 0, 0, 0 },
/* U+7715 */ { 0, 0, 0, 0, 0 },
/* U+7716 */ { 0, 0, 0, 0, 0 },
/* U+7717 */ { 0, 0, 0, 0, 0 },
/* U+7718 */ { 0, 0, 0, 0, 0 },
/* U+7719 */ { 0, 0, 0, 0, 0 },
/* U+771a */ { 0, 0, 0, 0, 0 },
/* U+771b */ { 0, 0, 0, 0, 0 },
/* U+771c */ { 0, 0, 0, 0, 0 },
/* U+771d */ { 0, 0, 0, 0, 0 },
/* U+771e */ { 0, 0, 0, 0, 0 },
/* U+771f */ { 0, 0, 0, 0, 0 },
/* U+7720 */ { 0, 0, 0, 0, 0 },
/* U+7721 */ { 0, 0, 0, 0, 0 },
/* U+7722 */ { 0, 0, 0, 0, 0 },
/* U+7723 */ { 0, 0, 0, 0, 0 },
/* U+7724 */ { 0, 0, 0, 0, 0 },
/* U+7725 */ { 0, 0, 0, 0, 0 },
/* U+7726 */ { 0, 0, 0, 0, 0 },
/* U+7727 */ { 0, 0, 0, 0, 0 },
/* U+7728 */ { 0, 0, 0, 0, 0 },
/* U+7729 */ { 0, 0, 0, 0, 0 },
/* U+772a */ { 0, 0, 0, 0, 0 },
/* U+772b */ { 0, 0, 0, 0, 0 },
/* U+772c */ { 0, 0, 0, 0, 0 },
/* U+772d */ { 0, 0, 0, 0, 0 },
/* U+772e */ { 0, 0, 0, 0, 0 },
/* U+772f */ { 0, 0, 0, 0, 0 },
/* U+7730 */ { 0, 0, 0, 0, 0 },
/* U+7731 */ { 0, 0, 0, 0, 0 },
/* U+7732 */ { 0, 0, 0, 0, 0 },
/* U+7733 */ { 0, 0, 0, 0, 0 },
/* U+7734 */ { 0, 0, 0, 0, 0 },
/* U+7735 */ { 0, 0, 0, 0, 0 },
/* U+7736 */ { 0, 0, 0, 0, 0 },
/* U+7737 */ { 0, 0, 0, 0, 0 },
/* U+7738 */ { 0, 0, 0, 0, 0 },
/* U+7739 */ { 0, 0, 0, 0, 0 },
/* U+773a */ { 0, 0, 0, 0, 0 },
/* U+773b */ { 0, 0, 0, 0, 0 },
/* U+773c */ { 0, 0, 0, 0, 0 },
/* U+773d */ { 0, 0, 0, 0, 0 },
/* U+773e */ { 0, 0, 0, 0, 0 },
/* U+773f */ { 0, 0, 0, 0, 0 },
/* U+7740 */ { 0, 0, 0, 0, 0 },
/* U+7741 */ { 0, 0, 0, 0, 0 },
/* U+7742 */ { 0, 0, 0, 0, 0 },
/* U+7743 */ { 0, 0, 0, 0, 0 },
/* U+7744 */ { 0, 0, 0, 0, 0 },
/* U+7745 */ { 0, 0, 0, 0, 0 },
/* U+7746 */ { 0, 0, 0, 0, 0 },
/* U+7747 */ { 0, 0, 0, 0, 0 },
/* U+7748 */ { 0, 0, 0, 0, 0 },
/* U+7749 */ { 0, 0, 0, 0, 0 },
/* U+774a */ { 0, 0, 0, 0, 0 },
/* U+774b */ { 0, 0, 0, 0, 0 },
/* U+774c */ { 0, 0, 0, 0, 0 },
/* U+774d */ { 0, 0, 0, 0, 0 },
/* U+774e */ { 0, 0, 0, 0, 0 },
/* U+774f */ { 0, 0, 0, 0, 0 },
/* U+7750 */ { 0, 0, 0, 0, 0 },
/* U+7751 */ { 0, 0, 0, 0, 0 },
/* U+7752 */ { 0, 0, 0, 0, 0 },
/* U+7753 */ { 0, 0, 0, 0, 0 },
/* U+7754 */ { 0, 0, 0, 0, 0 },
/* U+7755 */ { 0, 0, 0, 0, 0 },
/* U+7756 */ { 0, 0, 0, 0, 0 },
/* U+7757 */ { 0, 0, 0, 0, 0 },
/* U+7758 */ { 0, 0, 0, 0, 0 },
/* U+7759 */ { 0, 0, 0, 0, 0 },
/* U+775a */ { 0, 0, 0, 0, 0 },
/* U+775b */ { 0, 0, 0, 0, 0 },
/* U+775c */ { 0, 0, 0, 0, 0 },
/* U+775d */ { 0, 0, 0, 0, 0 },
/* U+775e */ { 0, 0, 0, 0, 0 },
/* U+775f */ { 0, 0, 0, 0, 0 },
/* U+7760 */ { 0, 0, 0, 0, 0 },
/* U+7761 */ { 0, 0, 0, 0, 0 },
/* U+7762 */ { 0, 0, 0, 0, 0 },
/* U+7763 */ { 0, 0, 0, 0, 0 },
/* U+7764 */ { 0, 0, 0, 0, 0 },
/* U+7765 */ { 0, 0, 0, 0, 0 },
/* U+7766 */ { 0, 0, 0, 0, 0 },
/* U+7767 */ { 0, 0, 0, 0, 0 },
/* U+7768 */ { 0, 0, 0, 0, 0 },
/* U+7769 */ { 0, 0, 0, 0, 0 },
/* U+776a */ { 0, 0, 0, 0, 0 },
/* U+776b */ { 0, 0, 0, 0, 0 },
/* U+776c */ { 0, 0, 0, 0, 0 },
/* U+776d */ { 0, 0, 0, 0, 0 },
/* U+776e */ { 0, 0, 0, 0, 0 },
/* U+776f */ { 0, 0, 0, 0, 0 },
/* U+7770 */ { 0, 0, 0, 0, 0 },
/* U+7771 */ { 0, 0, 0, 0, 0 },
/* U+7772 */ { 0, 0, 0, 0, 0 },
/* U+7773 */ { 0, 0, 0, 0, 0 },
/* U+7774 */ { 0, 0, 0, 0, 0 },
/* U+7775 */ { 0, 0, 0, 0, 0 },
/* U+7776 */ { 0, 0, 0, 0, 0 },
/* U+7777 */ { 0, 0, 0, 0, 0 },
/* U+7778 */ { 0, 0, 0, 0, 0 },
/* U+7779 */ { 0, 0, 0, 0, 0 },
/* U+777a */ { 0, 0, 0, 0, 0 },
/* U+777b */ { 0, 0, 0, 0, 0 },
/* U+777c */ { 0, 0, 0, 0, 0 },
/* U+777d */ { 0, 0, 0, 0, 0 },
/* U+777e */ { 0, 0, 0, 0, 0 },
/* U+777f */ { 0, 0, 0, 0, 0 },
/* U+7780 */ { 0, 0, 0, 0, 0 },
/* U+7781 */ { 0, 0, 0, 0, 0 },
/* U+7782 */ { 0, 0, 0, 0, 0 },
/* U+7783 */ { 0, 0, 0, 0, 0 },
/* U+7784 */ { 0, 0, 0, 0, 0 },
/* U+7785 */ { 0, 0, 0, 0, 0 },
/* U+7786 */ { 0, 0, 0, 0, 0 },
/* U+7787 */ { 0, 0, 0, 0, 0 },
/* U+7788 */ { 0, 0, 0, 0, 0 },
/* U+7789 */ { 0, 0, 0, 0, 0 },
/* U+778a */ { 0, 0, 0, 0, 0 },
/* U+778b */ { 0, 0, 0, 0, 0 },
/* U+778c */ { 0, 0, 0, 0, 0 },
/* U+778d */ { 0, 0, 0, 0, 0 },
/* U+778e */ { 0, 0, 0, 0, 0 },
/* U+778f */ { 0, 0, 0, 0, 0 },
/* U+7790 */ { 0, 0, 0, 0, 0 },
/* U+7791 */ { 0, 0, 0, 0, 0 },
/* U+7792 */ { 0, 0, 0, 0, 0 },
/* U+7793 */ { 0, 0, 0, 0, 0 },
/* U+7794 */ { 0, 0, 0, 0, 0 },
/* U+7795 */ { 0, 0, 0, 0, 0 },
/* U+7796 */ { 0, 0, 0, 0, 0 },
/* U+7797 */ { 0, 0, 0, 0, 0 },
/* U+7798 */ { 0, 0, 0, 0, 0 },
/* U+7799 */ { 0, 0, 0, 0, 0 },
/* U+779a */ { 0, 0, 0, 0, 0 },
/* U+779b */ { 0, 0, 0, 0, 0 },
/* U+779c */ { 0, 0, 0, 0, 0 },
/* U+779d */ { 0, 0, 0, 0, 0 },
/* U+779e */ { 0, 0, 0, 0, 0 },
/* U+779f */ { 0, 0, 0, 0, 0 },
/* U+77a0 */ { 0, 0, 0, 0, 0 },
/* U+77a1 */ { 0, 0, 0, 0, 0 },
/* U+77a2 */ { 0, 0, 0, 0, 0 },
/* U+77a3 */ { 0, 0, 0, 0, 0 },
/* U+77a4 */ { 0, 0, 0, 0, 0 },
/* U+77a5 */ { 0, 0, 0, 0, 0 },
/* U+77a6 */ { 0, 0, 0, 0, 0 },
/* U+77a7 */ { 0, 0, 0, 0, 0 },
/* U+77a8 */ { 0, 0, 0, 0, 0 },
/* U+77a9 */ { 0, 0, 0, 0, 0 },
/* U+77aa */ { 0, 0, 0, 0, 0 },
/* U+77ab */ { 0, 0, 0, 0, 0 },
/* U+77ac */ { 0, 0, 0, 0, 0 },
/* U+77ad */ { 0, 0, 0, 0, 0 },
/* U+77ae */ { 0, 0, 0, 0, 0 },
/* U+77af */ { 0, 0, 0, 0, 0 },
/* U+77b0 */ { 0, 0, 0, 0, 0 },
/* U+77b1 */ { 0, 0, 0, 0, 0 },
/* U+77b2 */ { 0, 0, 0, 0, 0 },
/* U+77b3 */ { 0, 0, 0, 0, 0 },
/* U+77b4 */ { 0, 0, 0, 0, 0 },
/* U+77b5 */ { 0, 0, 0, 0, 0 },
/* U+77b6 */ { 0, 0, 0, 0, 0 },
/* U+77b7 */ { 0, 0, 0, 0, 0 },
/* U+77b8 */ { 0, 0, 0, 0, 0 },
/* U+77b9 */ { 0, 0, 0, 0, 0 },
/* U+77ba */ { 0, 0, 0, 0, 0 },
/* U+77bb */ { 0, 0, 0, 0, 0 },
/* U+77bc */ { 0, 0, 0, 0, 0 },
/* U+77bd */ { 0, 0, 0, 0, 0 },
/* U+77be */ { 0, 0, 0, 0, 0 },
/* U+77bf */ { 0, 0, 0, 0, 0 },
/* U+77c0 */ { 0, 0, 0, 0, 0 },
/* U+77c1 */ { 0, 0, 0, 0, 0 },
/* U+77c2 */ { 0, 0, 0, 0, 0 },
/* U+77c3 */ { 0, 0, 0, 0, 0 },
/* U+77c4 */ { 0, 0, 0, 0, 0 },
/* U+77c5 */ { 0, 0, 0, 0, 0 },
/* U+77c6 */ { 0, 0, 0, 0, 0 },
/* U+77c7 */ { 0, 0, 0, 0, 0 },
/* U+77c8 */ { 0, 0, 0, 0, 0 },
/* U+77c9 */ { 0, 0, 0, 0, 0 },
/* U+77ca */ { 0, 0, 0, 0, 0 },
/* U+77cb */ { 0, 0, 0, 0, 0 },
/* U+77cc */ { 0, 0, 0, 0, 0 },
/* U+77cd */ { 0, 0, 0, 0, 0 },
/* U+77ce */ { 0, 0, 0, 0, 0 },
/* U+77cf */ { 0, 0, 0, 0, 0 },
/* U+77d0 */ { 0, 0, 0, 0, 0 },
/* U+77d1 */ { 0, 0, 0, 0, 0 },
/* U+77d2 */ { 0, 0, 0, 0, 0 },
/* U+77d3 */ { 0, 0, 0, 0, 0 },
/* U+77d4 */ { 0, 0, 0, 0, 0 },
/* U+77d5 */ { 0, 0, 0, 0, 0 },
/* U+77d6 */ { 0, 0, 0, 0, 0 },
/* U+77d7 */ { 0, 0, 0, 0, 0 },
/* U+77d8 */ { 0, 0, 0, 0, 0 },
/* U+77d9 */ { 0, 0, 0, 0, 0 },
/* U+77da */ { 0, 0, 0, 0, 0 },
/* U+77db */ { 0, 0, 0, 0, 0 },
/* U+77dc */ { 0, 0, 0, 0, 0 },
/* U+77dd */ { 0, 0, 0, 0, 0 },
/* U+77de */ { 0, 0, 0, 0, 0 },
/* U+77df */ { 0, 0, 0, 0, 0 },
/* U+77e0 */ { 0, 0, 0, 0, 0 },
/* U+77e1 */ { 0, 0, 0, 0, 0 },
/* U+77e2 */ { 0, 0, 0, 0, 0 },
/* U+77e3 */ { 0, 0, 0, 0, 0 },
/* U+77e4 */ { 0, 0, 0, 0, 0 },
/* U+77e5 */ { 0, 0, 0, 0, 0 },
/* U+77e6 */ { 0, 0, 0, 0, 0 },
/* U+77e7 */ { 0, 0, 0, 0, 0 },
/* U+77e8 */ { 0, 0, 0, 0, 0 },
/* U+77e9 */ { 0, 0, 0, 0, 0 },
/* U+77ea */ { 0, 0, 0, 0, 0 },
/* U+77eb */ { 0, 0, 0, 0, 0 },
/* U+77ec */ { 0, 0, 0, 0, 0 },
/* U+77ed */ { 0, 0, 0, 0, 0 },
/* U+77ee */ { 0, 0, 0, 0, 0 },
/* U+77ef */ { 0, 0, 0, 0, 0 },
/* U+77f0 */ { 0, 0, 0, 0, 0 },
/* U+77f1 */ { 0, 0, 0, 0, 0 },
/* U+77f2 */ { 0, 0, 0, 0, 0 },
/* U+77f3 */ { 0, 0, 0, 0, 0 },
/* U+77f4 */ { 0, 0, 0, 0, 0 },
/* U+77f5 */ { 0, 0, 0, 0, 0 },
/* U+77f6 */ { 0, 0, 0, 0, 0 },
/* U+77f7 */ { 0, 0, 0, 0, 0 },
/* U+77f8 */ { 0, 0, 0, 0, 0 },
/* U+77f9 */ { 0, 0, 0, 0, 0 },
/* U+77fa */ { 0, 0, 0, 0, 0 },
/* U+77fb */ { 0, 0, 0, 0, 0 },
/* U+77fc */ { 0, 0, 0, 0, 0 },
/* U+77fd */ { 0, 0, 0, 0, 0 },
/* U+77fe */ { 0, 0, 0, 0, 0 },
/* U+77ff */ { 0, 0, 0, 0, 0 },
/* U+7800 */ { 0, 0, 0, 0, 0 },
/* U+7801 */ { 0, 0, 0, 0, 0 },
/* U+7802 */ { 0, 0, 0, 0, 0 },
/* U+7803 */ { 0, 0, 0, 0, 0 },
/* U+7804 */ { 0, 0, 0, 0, 0 },
/* U+7805 */ { 0, 0, 0, 0, 0 },
/* U+7806 */ { 0, 0, 0, 0, 0 },
/* U+7807 */ { 0, 0, 0, 0, 0 },
/* U+7808 */ { 0, 0, 0, 0, 0 },
/* U+7809 */ { 0, 0, 0, 0, 0 },
/* U+780a */ { 0, 0, 0, 0, 0 },
/* U+780b */ { 0, 0, 0, 0, 0 },
/* U+780c */ { 0, 0, 0, 0, 0 },
/* U+780d */ { 0, 0, 0, 0, 0 },
/* U+780e */ { 0, 0, 0, 0, 0 },
/* U+780f */ { 0, 0, 0, 0, 0 },
/* U+7810 */ { 0, 0, 0, 0, 0 },
/* U+7811 */ { 0, 0, 0, 0, 0 },
/* U+7812 */ { 0, 0, 0, 0, 0 },
/* U+7813 */ { 0, 0, 0, 0, 0 },
/* U+7814 */ { 0, 0, 0, 0, 0 },
/* U+7815 */ { 0, 0, 0, 0, 0 },
/* U+7816 */ { 0, 0, 0, 0, 0 },
/* U+7817 */ { 0, 0, 0, 0, 0 },
/* U+7818 */ { 0, 0, 0, 0, 0 },
/* U+7819 */ { 0, 0, 0, 0, 0 },
/* U+781a */ { 0, 0, 0, 0, 0 },
/* U+781b */ { 0, 0, 0, 0, 0 },
/* U+781c */ { 0, 0, 0, 0, 0 },
/* U+781d */ { 0, 0, 0, 0, 0 },
/* U+781e */ { 0, 0, 0, 0, 0 },
/* U+781f */ { 0, 0, 0, 0, 0 },
/* U+7820 */ { 0, 0, 0, 0, 0 },
/* U+7821 */ { 0, 0, 0, 0, 0 },
/* U+7822 */ { 0, 0, 0, 0, 0 },
/* U+7823 */ { 0, 0, 0, 0, 0 },
/* U+7824 */ { 0, 0, 0, 0, 0 },
/* U+7825 */ { 0, 0, 0, 0, 0 },
/* U+7826 */ { 0, 0, 0, 0, 0 },
/* U+7827 */ { 0, 0, 0, 0, 0 },
/* U+7828 */ { 0, 0, 0, 0, 0 },
/* U+7829 */ { 0, 0, 0, 0, 0 },
/* U+782a */ { 0, 0, 0, 0, 0 },
/* U+782b */ { 0, 0, 0, 0, 0 },
/* U+782c */ { 0, 0, 0, 0, 0 },
/* U+782d */ { 0, 0, 0, 0, 0 },
/* U+782e */ { 0, 0, 0, 0, 0 },
/* U+782f */ { 0, 0, 0, 0, 0 },
/* U+7830 */ { 0, 0, 0, 0, 0 },
/* U+7831 */ { 0, 0, 0, 0, 0 },
/* U+7832 */ { 0, 0, 0, 0, 0 },
/* U+7833 */ { 0, 0, 0, 0, 0 },
/* U+7834 */ { 0, 0, 0, 0, 0 },
/* U+7835 */ { 0, 0, 0, 0, 0 },
/* U+7836 */ { 0, 0, 0, 0, 0 },
/* U+7837 */ { 0, 0, 0, 0, 0 },
/* U+7838 */ { 0, 0, 0, 0, 0 },
/* U+7839 */ { 0, 0, 0, 0, 0 },
/* U+783a */ { 0, 0, 0, 0, 0 },
/* U+783b */ { 0, 0, 0, 0, 0 },
/* U+783c */ { 0, 0, 0, 0, 0 },
/* U+783d */ { 0, 0, 0, 0, 0 },
/* U+783e */ { 0, 0, 0, 0, 0 },
/* U+783f */ { 0, 0, 0, 0, 0 },
/* U+7840 */ { 0, 0, 0, 0, 0 },
/* U+7841 */ { 0, 0, 0, 0, 0 },
/* U+7842 */ { 0, 0, 0, 0, 0 },
/* U+7843 */ { 0, 0, 0, 0, 0 },
/* U+7844 */ { 0, 0, 0, 0, 0 },
/* U+7845 */ { 0, 0, 0, 0, 0 },
/* U+7846 */ { 0, 0, 0, 0, 0 },
/* U+7847 */ { 0, 0, 0, 0, 0 },
/* U+7848 */ { 0, 0, 0, 0, 0 },
/* U+7849 */ { 0, 0, 0, 0, 0 },
/* U+784a */ { 0, 0, 0, 0, 0 },
/* U+784b */ { 0, 0, 0, 0, 0 },
/* U+784c */ { 0, 0, 0, 0, 0 },
/* U+784d */ { 0, 0, 0, 0, 0 },
/* U+784e */ { 0, 0, 0, 0, 0 },
/* U+784f */ { 0, 0, 0, 0, 0 },
/* U+7850 */ { 0, 0, 0, 0, 0 },
/* U+7851 */ { 0, 0, 0, 0, 0 },
/* U+7852 */ { 0, 0, 0, 0, 0 },
/* U+7853 */ { 0, 0, 0, 0, 0 },
/* U+7854 */ { 0, 0, 0, 0, 0 },
/* U+7855 */ { 0, 0, 0, 0, 0 },
/* U+7856 */ { 0, 0, 0, 0, 0 },
/* U+7857 */ { 0, 0, 0, 0, 0 },
/* U+7858 */ { 0, 0, 0, 0, 0 },
/* U+7859 */ { 0, 0, 0, 0, 0 },
/* U+785a */ { 0, 0, 0, 0, 0 },
/* U+785b */ { 0, 0, 0, 0, 0 },
/* U+785c */ { 0, 0, 0, 0, 0 },
/* U+785d */ { 0, 0, 0, 0, 0 },
/* U+785e */ { 0, 0, 0, 0, 0 },
/* U+785f */ { 0, 0, 0, 0, 0 },
/* U+7860 */ { 0, 0, 0, 0, 0 },
/* U+7861 */ { 0, 0, 0, 0, 0 },
/* U+7862 */ { 0, 0, 0, 0, 0 },
/* U+7863 */ { 0, 0, 0, 0, 0 },
/* U+7864 */ { 0, 0, 0, 0, 0 },
/* U+7865 */ { 0, 0, 0, 0, 0 },
/* U+7866 */ { 0, 0, 0, 0, 0 },
/* U+7867 */ { 0, 0, 0, 0, 0 },
/* U+7868 */ { 0, 0, 0, 0, 0 },
/* U+7869 */ { 0, 0, 0, 0, 0 },
/* U+786a */ { 0, 0, 0, 0, 0 },
/* U+786b */ { 0, 0, 0, 0, 0 },
/* U+786c */ { 0, 0, 0, 0, 0 },
/* U+786d */ { 0, 0, 0, 0, 0 },
/* U+786e */ { 0, 0, 0, 0, 0 },
/* U+786f */ { 0, 0, 0, 0, 0 },
/* U+7870 */ { 0, 0, 0, 0, 0 },
/* U+7871 */ { 0, 0, 0, 0, 0 },
/* U+7872 */ { 0, 0, 0, 0, 0 },
/* U+7873 */ { 0, 0, 0, 0, 0 },
/* U+7874 */ { 0, 0, 0, 0, 0 },
/* U+7875 */ { 0, 0, 0, 0, 0 },
/* U+7876 */ { 0, 0, 0, 0, 0 },
/* U+7877 */ { 0, 0, 0, 0, 0 },
/* U+7878 */ { 0, 0, 0, 0, 0 },
/* U+7879 */ { 0, 0, 0, 0, 0 },
/* U+787a */ { 0, 0, 0, 0, 0 },
/* U+787b */ { 0, 0, 0, 0, 0 },
/* U+787c */ { 0, 0, 0, 0, 0 },
/* U+787d */ { 0, 0, 0, 0, 0 },
/* U+787e */ { 0, 0, 0, 0, 0 },
/* U+787f */ { 0, 0, 0, 0, 0 },
/* U+7880 */ { 0, 0, 0, 0, 0 },
/* U+7881 */ { 0, 0, 0, 0, 0 },
/* U+7882 */ { 0, 0, 0, 0, 0 },
/* U+7883 */ { 0, 0, 0, 0, 0 },
/* U+7884 */ { 0, 0, 0, 0, 0 },
/* U+7885 */ { 0, 0, 0, 0, 0 },
/* U+7886 */ { 0, 0, 0, 0, 0 },
/* U+7887 */ { 0, 0, 0, 0, 0 },
/* U+7888 */ { 0, 0, 0, 0, 0 },
/* U+7889 */ { 0, 0, 0, 0, 0 },
/* U+788a */ { 0, 0, 0, 0, 0 },
/* U+788b */ { 0, 0, 0, 0, 0 },
/* U+788c */ { 0, 0, 0, 0, 0 },
/* U+788d */ { 0, 0, 0, 0, 0 },
/* U+788e */ { 0, 0, 0, 0, 0 },
/* U+788f */ { 0, 0, 0, 0, 0 },
/* U+7890 */ { 0, 0, 0, 0, 0 },
/* U+7891 */ { 0, 0, 0, 0, 0 },
/* U+7892 */ { 0, 0, 0, 0, 0 },
/* U+7893 */ { 0, 0, 0, 0, 0 },
/* U+7894 */ { 0, 0, 0, 0, 0 },
/* U+7895 */ { 0, 0, 0, 0, 0 },
/* U+7896 */ { 0, 0, 0, 0, 0 },
/* U+7897 */ { 0, 0, 0, 0, 0 },
/* U+7898 */ { 0, 0, 0, 0, 0 },
/* U+7899 */ { 0, 0, 0, 0, 0 },
/* U+789a */ { 0, 0, 0, 0, 0 },
/* U+789b */ { 0, 0, 0, 0, 0 },
/* U+789c */ { 0, 0, 0, 0, 0 },
/* U+789d */ { 0, 0, 0, 0, 0 },
/* U+789e */ { 0, 0, 0, 0, 0 },
/* U+789f */ { 0, 0, 0, 0, 0 },
/* U+78a0 */ { 0, 0, 0, 0, 0 },
/* U+78a1 */ { 0, 0, 0, 0, 0 },
/* U+78a2 */ { 0, 0, 0, 0, 0 },
/* U+78a3 */ { 0, 0, 0, 0, 0 },
/* U+78a4 */ { 0, 0, 0, 0, 0 },
/* U+78a5 */ { 0, 0, 0, 0, 0 },
/* U+78a6 */ { 0, 0, 0, 0, 0 },
/* U+78a7 */ { 0, 0, 0, 0, 0 },
/* U+78a8 */ { 0, 0, 0, 0, 0 },
/* U+78a9 */ { 0, 0, 0, 0, 0 },
/* U+78aa */ { 0, 0, 0, 0, 0 },
/* U+78ab */ { 0, 0, 0, 0, 0 },
/* U+78ac */ { 0, 0, 0, 0, 0 },
/* U+78ad */ { 0, 0, 0, 0, 0 },
/* U+78ae */ { 0, 0, 0, 0, 0 },
/* U+78af */ { 0, 0, 0, 0, 0 },
/* U+78b0 */ { 0, 0, 0, 0, 0 },
/* U+78b1 */ { 0, 0, 0, 0, 0 },
/* U+78b2 */ { 0, 0, 0, 0, 0 },
/* U+78b3 */ { 0, 0, 0, 0, 0 },
/* U+78b4 */ { 0, 0, 0, 0, 0 },
/* U+78b5 */ { 0, 0, 0, 0, 0 },
/* U+78b6 */ { 0, 0, 0, 0, 0 },
/* U+78b7 */ { 0, 0, 0, 0, 0 },
/* U+78b8 */ { 0, 0, 0, 0, 0 },
/* U+78b9 */ { 0, 0, 0, 0, 0 },
/* U+78ba */ { 0, 0, 0, 0, 0 },
/* U+78bb */ { 0, 0, 0, 0, 0 },
/* U+78bc */ { 0, 0, 0, 0, 0 },
/* U+78bd */ { 0, 0, 0, 0, 0 },
/* U+78be */ { 0, 0, 0, 0, 0 },
/* U+78bf */ { 0, 0, 0, 0, 0 },
/* U+78c0 */ { 0, 0, 0, 0, 0 },
/* U+78c1 */ { 0, 0, 0, 0, 0 },
/* U+78c2 */ { 0, 0, 0, 0, 0 },
/* U+78c3 */ { 0, 0, 0, 0, 0 },
/* U+78c4 */ { 0, 0, 0, 0, 0 },
/* U+78c5 */ { 0, 0, 0, 0, 0 },
/* U+78c6 */ { 0, 0, 0, 0, 0 },
/* U+78c7 */ { 0, 0, 0, 0, 0 },
/* U+78c8 */ { 0, 0, 0, 0, 0 },
/* U+78c9 */ { 0, 0, 0, 0, 0 },
/* U+78ca */ { 0, 0, 0, 0, 0 },
/* U+78cb */ { 0, 0, 0, 0, 0 },
/* U+78cc */ { 0, 0, 0, 0, 0 },
/* U+78cd */ { 0, 0, 0, 0, 0 },
/* U+78ce */ { 0, 0, 0, 0, 0 },
/* U+78cf */ { 0, 0, 0, 0, 0 },
/* U+78d0 */ { 0, 0, 0, 0, 0 },
/* U+78d1 */ { 0, 0, 0, 0, 0 },
/* U+78d2 */ { 0, 0, 0, 0, 0 },
/* U+78d3 */ { 0, 0, 0, 0, 0 },
/* U+78d4 */ { 0, 0, 0, 0, 0 },
/* U+78d5 */ { 0, 0, 0, 0, 0 },
/* U+78d6 */ { 0, 0, 0, 0, 0 },
/* U+78d7 */ { 0, 0, 0, 0, 0 },
/* U+78d8 */ { 0, 0, 0, 0, 0 },
/* U+78d9 */ { 0, 0, 0, 0, 0 },
/* U+78da */ { 0, 0, 0, 0, 0 },
/* U+78db */ { 0, 0, 0, 0, 0 },
/* U+78dc */ { 0, 0, 0, 0, 0 },
/* U+78dd */ { 0, 0, 0, 0, 0 },
/* U+78de */ { 0, 0, 0, 0, 0 },
/* U+78df */ { 0, 0, 0, 0, 0 },
/* U+78e0 */ { 0, 0, 0, 0, 0 },
/* U+78e1 */ { 0, 0, 0, 0, 0 },
/* U+78e2 */ { 0, 0, 0, 0, 0 },
/* U+78e3 */ { 0, 0, 0, 0, 0 },
/* U+78e4 */ { 0, 0, 0, 0, 0 },
/* U+78e5 */ { 0, 0, 0, 0, 0 },
/* U+78e6 */ { 0, 0, 0, 0, 0 },
/* U+78e7 */ { 0, 0, 0, 0, 0 },
/* U+78e8 */ { 0, 0, 0, 0, 0 },
/* U+78e9 */ { 0, 0, 0, 0, 0 },
/* U+78ea */ { 0, 0, 0, 0, 0 },
/* U+78eb */ { 0, 0, 0, 0, 0 },
/* U+78ec */ { 0, 0, 0, 0, 0 },
/* U+78ed */ { 0, 0, 0, 0, 0 },
/* U+78ee */ { 0, 0, 0, 0, 0 },
/* U+78ef */ { 0, 0, 0, 0, 0 },
/* U+78f0 */ { 0, 0, 0, 0, 0 },
/* U+78f1 */ { 0, 0, 0, 0, 0 },
/* U+78f2 */ { 0, 0, 0, 0, 0 },
/* U+78f3 */ { 0, 0, 0, 0, 0 },
/* U+78f4 */ { 0, 0, 0, 0, 0 },
/* U+78f5 */ { 0, 0, 0, 0, 0 },
/* U+78f6 */ { 0, 0, 0, 0, 0 },
/* U+78f7 */ { 0, 0, 0, 0, 0 },
/* U+78f8 */ { 0, 0, 0, 0, 0 },
/* U+78f9 */ { 0, 0, 0, 0, 0 },
/* U+78fa */ { 0, 0, 0, 0, 0 },
/* U+78fb */ { 0, 0, 0, 0, 0 },
/* U+78fc */ { 0, 0, 0, 0, 0 },
/* U+78fd */ { 0, 0, 0, 0, 0 },
/* U+78fe */ { 0, 0, 0, 0, 0 },
/* U+78ff */ { 0, 0, 0, 0, 0 },
/* U+7900 */ { 0, 0, 0, 0, 0 },
/* U+7901 */ { 0, 0, 0, 0, 0 },
/* U+7902 */ { 0, 0, 0, 0, 0 },
/* U+7903 */ { 0, 0, 0, 0, 0 },
/* U+7904 */ { 0, 0, 0, 0, 0 },
/* U+7905 */ { 0, 0, 0, 0, 0 },
/* U+7906 */ { 0, 0, 0, 0, 0 },
/* U+7907 */ { 0, 0, 0, 0, 0 },
/* U+7908 */ { 0, 0, 0, 0, 0 },
/* U+7909 */ { 0, 0, 0, 0, 0 },
/* U+790a */ { 0, 0, 0, 0, 0 },
/* U+790b */ { 0, 0, 0, 0, 0 },
/* U+790c */ { 0, 0, 0, 0, 0 },
/* U+790d */ { 0, 0, 0, 0, 0 },
/* U+790e */ { 0, 0, 0, 0, 0 },
/* U+790f */ { 0, 0, 0, 0, 0 },
/* U+7910 */ { 0, 0, 0, 0, 0 },
/* U+7911 */ { 0, 0, 0, 0, 0 },
/* U+7912 */ { 0, 0, 0, 0, 0 },
/* U+7913 */ { 0, 0, 0, 0, 0 },
/* U+7914 */ { 0, 0, 0, 0, 0 },
/* U+7915 */ { 0, 0, 0, 0, 0 },
/* U+7916 */ { 0, 0, 0, 0, 0 },
/* U+7917 */ { 0, 0, 0, 0, 0 },
/* U+7918 */ { 0, 0, 0, 0, 0 },
/* U+7919 */ { 0, 0, 0, 0, 0 },
/* U+791a */ { 0, 0, 0, 0, 0 },
/* U+791b */ { 0, 0, 0, 0, 0 },
/* U+791c */ { 0, 0, 0, 0, 0 },
/* U+791d */ { 0, 0, 0, 0, 0 },
/* U+791e */ { 0, 0, 0, 0, 0 },
/* U+791f */ { 0, 0, 0, 0, 0 },
/* U+7920 */ { 0, 0, 0, 0, 0 },
/* U+7921 */ { 0, 0, 0, 0, 0 },
/* U+7922 */ { 0, 0, 0, 0, 0 },
/* U+7923 */ { 0, 0, 0, 0, 0 },
/* U+7924 */ { 0, 0, 0, 0, 0 },
/* U+7925 */ { 0, 0, 0, 0, 0 },
/* U+7926 */ { 0, 0, 0, 0, 0 },
/* U+7927 */ { 0, 0, 0, 0, 0 },
/* U+7928 */ { 0, 0, 0, 0, 0 },
/* U+7929 */ { 0, 0, 0, 0, 0 },
/* U+792a */ { 0, 0, 0, 0, 0 },
/* U+792b */ { 0, 0, 0, 0, 0 },
/* U+792c */ { 0, 0, 0, 0, 0 },
/* U+792d */ { 0, 0, 0, 0, 0 },
/* U+792e */ { 0, 0, 0, 0, 0 },
/* U+792f */ { 0, 0, 0, 0, 0 },
/* U+7930 */ { 0, 0, 0, 0, 0 },
/* U+7931 */ { 0, 0, 0, 0, 0 },
/* U+7932 */ { 0, 0, 0, 0, 0 },
/* U+7933 */ { 0, 0, 0, 0, 0 },
/* U+7934 */ { 0, 0, 0, 0, 0 },
/* U+7935 */ { 0, 0, 0, 0, 0 },
/* U+7936 */ { 0, 0, 0, 0, 0 },
/* U+7937 */ { 0, 0, 0, 0, 0 },
/* U+7938 */ { 0, 0, 0, 0, 0 },
/* U+7939 */ { 0, 0, 0, 0, 0 },
/* U+793a */ { 0, 0, 0, 0, 0 },
/* U+793b */ { 0, 0, 0, 0, 0 },
/* U+793c */ { 0, 0, 0, 0, 0 },
/* U+793d */ { 0, 0, 0, 0, 0 },
/* U+793e */ { 0, 0, 0, 0, 0 },
/* U+793f */ { 0, 0, 0, 0, 0 },
/* U+7940 */ { 0, 0, 0, 0, 0 },
/* U+7941 */ { 0, 0, 0, 0, 0 },
/* U+7942 */ { 0, 0, 0, 0, 0 },
/* U+7943 */ { 0, 0, 0, 0, 0 },
/* U+7944 */ { 0, 0, 0, 0, 0 },
/* U+7945 */ { 0, 0, 0, 0, 0 },
/* U+7946 */ { 0, 0, 0, 0, 0 },
/* U+7947 */ { 0, 0, 0, 0, 0 },
/* U+7948 */ { 0, 0, 0, 0, 0 },
/* U+7949 */ { 0, 0, 0, 0, 0 },
/* U+794a */ { 0, 0, 0, 0, 0 },
/* U+794b */ { 0, 0, 0, 0, 0 },
/* U+794c */ { 0, 0, 0, 0, 0 },
/* U+794d */ { 0, 0, 0, 0, 0 },
/* U+794e */ { 0, 0, 0, 0, 0 },
/* U+794f */ { 0, 0, 0, 0, 0 },
/* U+7950 */ { 0, 0, 0, 0, 0 },
/* U+7951 */ { 0, 0, 0, 0, 0 },
/* U+7952 */ { 0, 0, 0, 0, 0 },
/* U+7953 */ { 0, 0, 0, 0, 0 },
/* U+7954 */ { 0, 0, 0, 0, 0 },
/* U+7955 */ { 0, 0, 0, 0, 0 },
/* U+7956 */ { 0, 0, 0, 0, 0 },
/* U+7957 */ { 0, 0, 0, 0, 0 },
/* U+7958 */ { 0, 0, 0, 0, 0 },
/* U+7959 */ { 0, 0, 0, 0, 0 },
/* U+795a */ { 0, 0, 0, 0, 0 },
/* U+795b */ { 0, 0, 0, 0, 0 },
/* U+795c */ { 0, 0, 0, 0, 0 },
/* U+795d */ { 0, 0, 0, 0, 0 },
/* U+795e */ { 0, 0, 0, 0, 0 },
/* U+795f */ { 0, 0, 0, 0, 0 },
/* U+7960 */ { 0, 0, 0, 0, 0 },
/* U+7961 */ { 0, 0, 0, 0, 0 },
/* U+7962 */ { 0, 0, 0, 0, 0 },
/* U+7963 */ { 0, 0, 0, 0, 0 },
/* U+7964 */ { 0, 0, 0, 0, 0 },
/* U+7965 */ { 0, 0, 0, 0, 0 },
/* U+7966 */ { 0, 0, 0, 0, 0 },
/* U+7967 */ { 0, 0, 0, 0, 0 },
/* U+7968 */ { 0, 0, 0, 0, 0 },
/* U+7969 */ { 0, 0, 0, 0, 0 },
/* U+796a */ { 0, 0, 0, 0, 0 },
/* U+796b */ { 0, 0, 0, 0, 0 },
/* U+796c */ { 0, 0, 0, 0, 0 },
/* U+796d */ { 0, 0, 0, 0, 0 },
/* U+796e */ { 0, 0, 0, 0, 0 },
/* U+796f */ { 0, 0, 0, 0, 0 },
/* U+7970 */ { 0, 0, 0, 0, 0 },
/* U+7971 */ { 0, 0, 0, 0, 0 },
/* U+7972 */ { 0, 0, 0, 0, 0 },
/* U+7973 */ { 0, 0, 0, 0, 0 },
/* U+7974 */ { 0, 0, 0, 0, 0 },
/* U+7975 */ { 0, 0, 0, 0, 0 },
/* U+7976 */ { 0, 0, 0, 0, 0 },
/* U+7977 */ { 0, 0, 0, 0, 0 },
/* U+7978 */ { 0, 0, 0, 0, 0 },
/* U+7979 */ { 0, 0, 0, 0, 0 },
/* U+797a */ { 0, 0, 0, 0, 0 },
/* U+797b */ { 0, 0, 0, 0, 0 },
/* U+797c */ { 0, 0, 0, 0, 0 },
/* U+797d */ { 0, 0, 0, 0, 0 },
/* U+797e */ { 0, 0, 0, 0, 0 },
/* U+797f */ { 0, 0, 0, 0, 0 },
/* U+7980 */ { 0, 0, 0, 0, 0 },
/* U+7981 */ { 0, 0, 0, 0, 0 },
/* U+7982 */ { 0, 0, 0, 0, 0 },
/* U+7983 */ { 0, 0, 0, 0, 0 },
/* U+7984 */ { 0, 0, 0, 0, 0 },
/* U+7985 */ { 0, 0, 0, 0, 0 },
/* U+7986 */ { 0, 0, 0, 0, 0 },
/* U+7987 */ { 0, 0, 0, 0, 0 },
/* U+7988 */ { 0, 0, 0, 0, 0 },
/* U+7989 */ { 0, 0, 0, 0, 0 },
/* U+798a */ { 0, 0, 0, 0, 0 },
/* U+798b */ { 0, 0, 0, 0, 0 },
/* U+798c */ { 0, 0, 0, 0, 0 },
/* U+798d */ { 0, 0, 0, 0, 0 },
/* U+798e */ { 0, 0, 0, 0, 0 },
/* U+798f */ { 0, 0, 0, 0, 0 },
/* U+7990 */ { 0, 0, 0, 0, 0 },
/* U+7991 */ { 0, 0, 0, 0, 0 },
/* U+7992 */ { 0, 0, 0, 0, 0 },
/* U+7993 */ { 0, 0, 0, 0, 0 },
/* U+7994 */ { 0, 0, 0, 0, 0 },
/* U+7995 */ { 0, 0, 0, 0, 0 },
/* U+7996 */ { 0, 0, 0, 0, 0 },
/* U+7997 */ { 0, 0, 0, 0, 0 },
/* U+7998 */ { 0, 0, 0, 0, 0 },
/* U+7999 */ { 0, 0, 0, 0, 0 },
/* U+799a */ { 0, 0, 0, 0, 0 },
/* U+799b */ { 0, 0, 0, 0, 0 },
/* U+799c */ { 0, 0, 0, 0, 0 },
/* U+799d */ { 0, 0, 0, 0, 0 },
/* U+799e */ { 0, 0, 0, 0, 0 },
/* U+799f */ { 0, 0, 0, 0, 0 },
/* U+79a0 */ { 0, 0, 0, 0, 0 },
/* U+79a1 */ { 0, 0, 0, 0, 0 },
/* U+79a2 */ { 0, 0, 0, 0, 0 },
/* U+79a3 */ { 0, 0, 0, 0, 0 },
/* U+79a4 */ { 0, 0, 0, 0, 0 },
/* U+79a5 */ { 0, 0, 0, 0, 0 },
/* U+79a6 */ { 0, 0, 0, 0, 0 },
/* U+79a7 */ { 0, 0, 0, 0, 0 },
/* U+79a8 */ { 0, 0, 0, 0, 0 },
/* U+79a9 */ { 0, 0, 0, 0, 0 },
/* U+79aa */ { 0, 0, 0, 0, 0 },
/* U+79ab */ { 0, 0, 0, 0, 0 },
/* U+79ac */ { 0, 0, 0, 0, 0 },
/* U+79ad */ { 0, 0, 0, 0, 0 },
/* U+79ae */ { 0, 0, 0, 0, 0 },
/* U+79af */ { 0, 0, 0, 0, 0 },
/* U+79b0 */ { 0, 0, 0, 0, 0 },
/* U+79b1 */ { 0, 0, 0, 0, 0 },
/* U+79b2 */ { 0, 0, 0, 0, 0 },
/* U+79b3 */ { 0, 0, 0, 0, 0 },
/* U+79b4 */ { 0, 0, 0, 0, 0 },
/* U+79b5 */ { 0, 0, 0, 0, 0 },
/* U+79b6 */ { 0, 0, 0, 0, 0 },
/* U+79b7 */ { 0, 0, 0, 0, 0 },
/* U+79b8 */ { 0, 0, 0, 0, 0 },
/* U+79b9 */ { 0, 0, 0, 0, 0 },
/* U+79ba */ { 0, 0, 0, 0, 0 },
/* U+79bb */ { 0, 0, 0, 0, 0 },
/* U+79bc */ { 0, 0, 0, 0, 0 },
/* U+79bd */ { 0, 0, 0, 0, 0 },
/* U+79be */ { 0, 0, 0, 0, 0 },
/* U+79bf */ { 0, 0, 0, 0, 0 },
/* U+79c0 */ { 0, 0, 0, 0, 0 },
/* U+79c1 */ { 0, 0, 0, 0, 0 },
/* U+79c2 */ { 0, 0, 0, 0, 0 },
/* U+79c3 */ { 0, 0, 0, 0, 0 },
/* U+79c4 */ { 0, 0, 0, 0, 0 },
/* U+79c5 */ { 0, 0, 0, 0, 0 },
/* U+79c6 */ { 0, 0, 0, 0, 0 },
/* U+79c7 */ { 0, 0, 0, 0, 0 },
/* U+79c8 */ { 0, 0, 0, 0, 0 },
/* U+79c9 */ { 0, 0, 0, 0, 0 },
/* U+79ca */ { 0, 0, 0, 0, 0 },
/* U+79cb */ { 0, 0, 0, 0, 0 },
/* U+79cc */ { 0, 0, 0, 0, 0 },
/* U+79cd */ { 0, 0, 0, 0, 0 },
/* U+79ce */ { 0, 0, 0, 0, 0 },
/* U+79cf */ { 0, 0, 0, 0, 0 },
/* U+79d0 */ { 0, 0, 0, 0, 0 },
/* U+79d1 */ { 0, 0, 0, 0, 0 },
/* U+79d2 */ { 0, 0, 0, 0, 0 },
/* U+79d3 */ { 0, 0, 0, 0, 0 },
/* U+79d4 */ { 0, 0, 0, 0, 0 },
/* U+79d5 */ { 0, 0, 0, 0, 0 },
/* U+79d6 */ { 0, 0, 0, 0, 0 },
/* U+79d7 */ { 0, 0, 0, 0, 0 },
/* U+79d8 */ { 0, 0, 0, 0, 0 },
/* U+79d9 */ { 0, 0, 0, 0, 0 },
/* U+79da */ { 0, 0, 0, 0, 0 },
/* U+79db */ { 0, 0, 0, 0, 0 },
/* U+79dc */ { 0, 0, 0, 0, 0 },
/* U+79dd */ { 0, 0, 0, 0, 0 },
/* U+79de */ { 0, 0, 0, 0, 0 },
/* U+79df */ { 0, 0, 0, 0, 0 },
/* U+79e0 */ { 0, 0, 0, 0, 0 },
/* U+79e1 */ { 0, 0, 0, 0, 0 },
/* U+79e2 */ { 0, 0, 0, 0, 0 },
/* U+79e3 */ { 0, 0, 0, 0, 0 },
/* U+79e4 */ { 0, 0, 0, 0, 0 },
/* U+79e5 */ { 0, 0, 0, 0, 0 },
/* U+79e6 */ { 0, 0, 0, 0, 0 },
/* U+79e7 */ { 0, 0, 0, 0, 0 },
/* U+79e8 */ { 0, 0, 0, 0, 0 },
/* U+79e9 */ { 0, 0, 0, 0, 0 },
/* U+79ea */ { 0, 0, 0, 0, 0 },
/* U+79eb */ { 0, 0, 0, 0, 0 },
/* U+79ec */ { 0, 0, 0, 0, 0 },
/* U+79ed */ { 0, 0, 0, 0, 0 },
/* U+79ee */ { 0, 0, 0, 0, 0 },
/* U+79ef */ { 0, 0, 0, 0, 0 },
/* U+79f0 */ { 0, 0, 0, 0, 0 },
/* U+79f1 */ { 0, 0, 0, 0, 0 },
/* U+79f2 */ { 0, 0, 0, 0, 0 },
/* U+79f3 */ { 0, 0, 0, 0, 0 },
/* U+79f4 */ { 0, 0, 0, 0, 0 },
/* U+79f5 */ { 0, 0, 0, 0, 0 },
/* U+79f6 */ { 0, 0, 0, 0, 0 },
/* U+79f7 */ { 0, 0, 0, 0, 0 },
/* U+79f8 */ { 0, 0, 0, 0, 0 },
/* U+79f9 */ { 0, 0, 0, 0, 0 },
/* U+79fa */ { 0, 0, 0, 0, 0 },
/* U+79fb */ { 0, 0, 0, 0, 0 },
/* U+79fc */ { 0, 0, 0, 0, 0 },
/* U+79fd */ { 0, 0, 0, 0, 0 },
/* U+79fe */ { 0, 0, 0, 0, 0 },
/* U+79ff */ { 0, 0, 0, 0, 0 },
/* U+7a00 */ { 0, 0, 0, 0, 0 },
/* U+7a01 */ { 0, 0, 0, 0, 0 },
/* U+7a02 */ { 0, 0, 0, 0, 0 },
/* U+7a03 */ { 0, 0, 0, 0, 0 },
/* U+7a04 */ { 0, 0, 0, 0, 0 },
/* U+7a05 */ { 0, 0, 0, 0, 0 },
/* U+7a06 */ { 0, 0, 0, 0, 0 },
/* U+7a07 */ { 0, 0, 0, 0, 0 },
/* U+7a08 */ { 0, 0, 0, 0, 0 },
/* U+7a09 */ { 0, 0, 0, 0, 0 },
/* U+7a0a */ { 0, 0, 0, 0, 0 },
/* U+7a0b */ { 0, 0, 0, 0, 0 },
/* U+7a0c */ { 0, 0, 0, 0, 0 },
/* U+7a0d */ { 0, 0, 0, 0, 0 },
/* U+7a0e */ { 0, 0, 0, 0, 0 },
/* U+7a0f */ { 0, 0, 0, 0, 0 },
/* U+7a10 */ { 0, 0, 0, 0, 0 },
/* U+7a11 */ { 0, 0, 0, 0, 0 },
/* U+7a12 */ { 0, 0, 0, 0, 0 },
/* U+7a13 */ { 0, 0, 0, 0, 0 },
/* U+7a14 */ { 0, 0, 0, 0, 0 },
/* U+7a15 */ { 0, 0, 0, 0, 0 },
/* U+7a16 */ { 0, 0, 0, 0, 0 },
/* U+7a17 */ { 0, 0, 0, 0, 0 },
/* U+7a18 */ { 0, 0, 0, 0, 0 },
/* U+7a19 */ { 0, 0, 0, 0, 0 },
/* U+7a1a */ { 0, 0, 0, 0, 0 },
/* U+7a1b */ { 0, 0, 0, 0, 0 },
/* U+7a1c */ { 0, 0, 0, 0, 0 },
/* U+7a1d */ { 0, 0, 0, 0, 0 },
/* U+7a1e */ { 0, 0, 0, 0, 0 },
/* U+7a1f */ { 0, 0, 0, 0, 0 },
/* U+7a20 */ { 0, 0, 0, 0, 0 },
/* U+7a21 */ { 0, 0, 0, 0, 0 },
/* U+7a22 */ { 0, 0, 0, 0, 0 },
/* U+7a23 */ { 0, 0, 0, 0, 0 },
/* U+7a24 */ { 0, 0, 0, 0, 0 },
/* U+7a25 */ { 0, 0, 0, 0, 0 },
/* U+7a26 */ { 0, 0, 0, 0, 0 },
/* U+7a27 */ { 0, 0, 0, 0, 0 },
/* U+7a28 */ { 0, 0, 0, 0, 0 },
/* U+7a29 */ { 0, 0, 0, 0, 0 },
/* U+7a2a */ { 0, 0, 0, 0, 0 },
/* U+7a2b */ { 0, 0, 0, 0, 0 },
/* U+7a2c */ { 0, 0, 0, 0, 0 },
/* U+7a2d */ { 0, 0, 0, 0, 0 },
/* U+7a2e */ { 0, 0, 0, 0, 0 },
/* U+7a2f */ { 0, 0, 0, 0, 0 },
/* U+7a30 */ { 0, 0, 0, 0, 0 },
/* U+7a31 */ { 0, 0, 0, 0, 0 },
/* U+7a32 */ { 0, 0, 0, 0, 0 },
/* U+7a33 */ { 0, 0, 0, 0, 0 },
/* U+7a34 */ { 0, 0, 0, 0, 0 },
/* U+7a35 */ { 0, 0, 0, 0, 0 },
/* U+7a36 */ { 0, 0, 0, 0, 0 },
/* U+7a37 */ { 0, 0, 0, 0, 0 },
/* U+7a38 */ { 0, 0, 0, 0, 0 },
/* U+7a39 */ { 0, 0, 0, 0, 0 },
/* U+7a3a */ { 0, 0, 0, 0, 0 },
/* U+7a3b */ { 0, 0, 0, 0, 0 },
/* U+7a3c */ { 0, 0, 0, 0, 0 },
/* U+7a3d */ { 0, 0, 0, 0, 0 },
/* U+7a3e */ { 0, 0, 0, 0, 0 },
/* U+7a3f */ { 0, 0, 0, 0, 0 },
/* U+7a40 */ { 0, 0, 0, 0, 0 },
/* U+7a41 */ { 0, 0, 0, 0, 0 },
/* U+7a42 */ { 0, 0, 0, 0, 0 },
/* U+7a43 */ { 0, 0, 0, 0, 0 },
/* U+7a44 */ { 0, 0, 0, 0, 0 },
/* U+7a45 */ { 0, 0, 0, 0, 0 },
/* U+7a46 */ { 0, 0, 0, 0, 0 },
/* U+7a47 */ { 0, 0, 0, 0, 0 },
/* U+7a48 */ { 0, 0, 0, 0, 0 },
/* U+7a49 */ { 0, 0, 0, 0, 0 },
/* U+7a4a */ { 0, 0, 0, 0, 0 },
/* U+7a4b */ { 0, 0, 0, 0, 0 },
/* U+7a4c */ { 0, 0, 0, 0, 0 },
/* U+7a4d */ { 0, 0, 0, 0, 0 },
/* U+7a4e */ { 0, 0, 0, 0, 0 },
/* U+7a4f */ { 0, 0, 0, 0, 0 },
/* U+7a50 */ { 0, 0, 0, 0, 0 },
/* U+7a51 */ { 0, 0, 0, 0, 0 },
/* U+7a52 */ { 0, 0, 0, 0, 0 },
/* U+7a53 */ { 0, 0, 0, 0, 0 },
/* U+7a54 */ { 0, 0, 0, 0, 0 },
/* U+7a55 */ { 0, 0, 0, 0, 0 },
/* U+7a56 */ { 0, 0, 0, 0, 0 },
/* U+7a57 */ { 0, 0, 0, 0, 0 },
/* U+7a58 */ { 0, 0, 0, 0, 0 },
/* U+7a59 */ { 0, 0, 0, 0, 0 },
/* U+7a5a */ { 0, 0, 0, 0, 0 },
/* U+7a5b */ { 0, 0, 0, 0, 0 },
/* U+7a5c */ { 0, 0, 0, 0, 0 },
/* U+7a5d */ { 0, 0, 0, 0, 0 },
/* U+7a5e */ { 0, 0, 0, 0, 0 },
/* U+7a5f */ { 0, 0, 0, 0, 0 },
/* U+7a60 */ { 0, 0, 0, 0, 0 },
/* U+7a61 */ { 0, 0, 0, 0, 0 },
/* U+7a62 */ { 0, 0, 0, 0, 0 },
/* U+7a63 */ { 0, 0, 0, 0, 0 },
/* U+7a64 */ { 0, 0, 0, 0, 0 },
/* U+7a65 */ { 0, 0, 0, 0, 0 },
/* U+7a66 */ { 0, 0, 0, 0, 0 },
/* U+7a67 */ { 0, 0, 0, 0, 0 },
/* U+7a68 */ { 0, 0, 0, 0, 0 },
/* U+7a69 */ { 0, 0, 0, 0, 0 },
/* U+7a6a */ { 0, 0, 0, 0, 0 },
/* U+7a6b */ { 0, 0, 0, 0, 0 },
/* U+7a6c */ { 0, 0, 0, 0, 0 },
/* U+7a6d */ { 0, 0, 0, 0, 0 },
/* U+7a6e */ { 0, 0, 0, 0, 0 },
/* U+7a6f */ { 0, 0, 0, 0, 0 },
/* U+7a70 */ { 0, 0, 0, 0, 0 },
/* U+7a71 */ { 0, 0, 0, 0, 0 },
/* U+7a72 */ { 0, 0, 0, 0, 0 },
/* U+7a73 */ { 0, 0, 0, 0, 0 },
/* U+7a74 */ { 0, 0, 0, 0, 0 },
/* U+7a75 */ { 0, 0, 0, 0, 0 },
/* U+7a76 */ { 0, 0, 0, 0, 0 },
/* U+7a77 */ { 0, 0, 0, 0, 0 },
/* U+7a78 */ { 0, 0, 0, 0, 0 },
/* U+7a79 */ { 0, 0, 0, 0, 0 },
/* U+7a7a */ { 0, 0, 0, 0, 0 },
/* U+7a7b */ { 0, 0, 0, 0, 0 },
/* U+7a7c */ { 0, 0, 0, 0, 0 },
/* U+7a7d */ { 0, 0, 0, 0, 0 },
/* U+7a7e */ { 0, 0, 0, 0, 0 },
/* U+7a7f */ { 0, 0, 0, 0, 0 },
/* U+7a80 */ { 0, 0, 0, 0, 0 },
/* U+7a81 */ { 0, 0, 0, 0, 0 },
/* U+7a82 */ { 0, 0, 0, 0, 0 },
/* U+7a83 */ { 0, 0, 0, 0, 0 },
/* U+7a84 */ { 0, 0, 0, 0, 0 },
/* U+7a85 */ { 0, 0, 0, 0, 0 },
/* U+7a86 */ { 0, 0, 0, 0, 0 },
/* U+7a87 */ { 0, 0, 0, 0, 0 },
/* U+7a88 */ { 0, 0, 0, 0, 0 },
/* U+7a89 */ { 0, 0, 0, 0, 0 },
/* U+7a8a */ { 0, 0, 0, 0, 0 },
/* U+7a8b */ { 0, 0, 0, 0, 0 },
/* U+7a8c */ { 0, 0, 0, 0, 0 },
/* U+7a8d */ { 0, 0, 0, 0, 0 },
/* U+7a8e */ { 0, 0, 0, 0, 0 },
/* U+7a8f */ { 0, 0, 0, 0, 0 },
/* U+7a90 */ { 0, 0, 0, 0, 0 },
/* U+7a91 */ { 0, 0, 0, 0, 0 },
/* U+7a92 */ { 0, 0, 0, 0, 0 },
/* U+7a93 */ { 0, 0, 0, 0, 0 },
/* U+7a94 */ { 0, 0, 0, 0, 0 },
/* U+7a95 */ { 0, 0, 0, 0, 0 },
/* U+7a96 */ { 0, 0, 0, 0, 0 },
/* U+7a97 */ { 0, 0, 0, 0, 0 },
/* U+7a98 */ { 0, 0, 0, 0, 0 },
/* U+7a99 */ { 0, 0, 0, 0, 0 },
/* U+7a9a */ { 0, 0, 0, 0, 0 },
/* U+7a9b */ { 0, 0, 0, 0, 0 },
/* U+7a9c */ { 0, 0, 0, 0, 0 },
/* U+7a9d */ { 0, 0, 0, 0, 0 },
/* U+7a9e */ { 0, 0, 0, 0, 0 },
/* U+7a9f */ { 0, 0, 0, 0, 0 },
/* U+7aa0 */ { 0, 0, 0, 0, 0 },
/* U+7aa1 */ { 0, 0, 0, 0, 0 },
/* U+7aa2 */ { 0, 0, 0, 0, 0 },
/* U+7aa3 */ { 0, 0, 0, 0, 0 },
/* U+7aa4 */ { 0, 0, 0, 0, 0 },
/* U+7aa5 */ { 0, 0, 0, 0, 0 },
/* U+7aa6 */ { 0, 0, 0, 0, 0 },
/* U+7aa7 */ { 0, 0, 0, 0, 0 },
/* U+7aa8 */ { 0, 0, 0, 0, 0 },
/* U+7aa9 */ { 0, 0, 0, 0, 0 },
/* U+7aaa */ { 0, 0, 0, 0, 0 },
/* U+7aab */ { 0, 0, 0, 0, 0 },
/* U+7aac */ { 0, 0, 0, 0, 0 },
/* U+7aad */ { 0, 0, 0, 0, 0 },
/* U+7aae */ { 0, 0, 0, 0, 0 },
/* U+7aaf */ { 0, 0, 0, 0, 0 },
/* U+7ab0 */ { 0, 0, 0, 0, 0 },
/* U+7ab1 */ { 0, 0, 0, 0, 0 },
/* U+7ab2 */ { 0, 0, 0, 0, 0 },
/* U+7ab3 */ { 0, 0, 0, 0, 0 },
/* U+7ab4 */ { 0, 0, 0, 0, 0 },
/* U+7ab5 */ { 0, 0, 0, 0, 0 },
/* U+7ab6 */ { 0, 0, 0, 0, 0 },
/* U+7ab7 */ { 0, 0, 0, 0, 0 },
/* U+7ab8 */ { 0, 0, 0, 0, 0 },
/* U+7ab9 */ { 0, 0, 0, 0, 0 },
/* U+7aba */ { 0, 0, 0, 0, 0 },
/* U+7abb */ { 0, 0, 0, 0, 0 },
/* U+7abc */ { 0, 0, 0, 0, 0 },
/* U+7abd */ { 0, 0, 0, 0, 0 },
/* U+7abe */ { 0, 0, 0, 0, 0 },
/* U+7abf */ { 0, 0, 0, 0, 0 },
/* U+7ac0 */ { 0, 0, 0, 0, 0 },
/* U+7ac1 */ { 0, 0, 0, 0, 0 },
/* U+7ac2 */ { 0, 0, 0, 0, 0 },
/* U+7ac3 */ { 0, 0, 0, 0, 0 },
/* U+7ac4 */ { 0, 0, 0, 0, 0 },
/* U+7ac5 */ { 0, 0, 0, 0, 0 },
/* U+7ac6 */ { 0, 0, 0, 0, 0 },
/* U+7ac7 */ { 0, 0, 0, 0, 0 },
/* U+7ac8 */ { 0, 0, 0, 0, 0 },
/* U+7ac9 */ { 0, 0, 0, 0, 0 },
/* U+7aca */ { 0, 0, 0, 0, 0 },
/* U+7acb */ { 0, 0, 0, 0, 0 },
/* U+7acc */ { 0, 0, 0, 0, 0 },
/* U+7acd */ { 0, 0, 0, 0, 0 },
/* U+7ace */ { 0, 0, 0, 0, 0 },
/* U+7acf */ { 0, 0, 0, 0, 0 },
/* U+7ad0 */ { 0, 0, 0, 0, 0 },
/* U+7ad1 */ { 0, 0, 0, 0, 0 },
/* U+7ad2 */ { 0, 0, 0, 0, 0 },
/* U+7ad3 */ { 0, 0, 0, 0, 0 },
/* U+7ad4 */ { 0, 0, 0, 0, 0 },
/* U+7ad5 */ { 0, 0, 0, 0, 0 },
/* U+7ad6 */ { 0, 0, 0, 0, 0 },
/* U+7ad7 */ { 0, 0, 0, 0, 0 },
/* U+7ad8 */ { 0, 0, 0, 0, 0 },
/* U+7ad9 */ { 0, 0, 0, 0, 0 },
/* U+7ada */ { 0, 0, 0, 0, 0 },
/* U+7adb */ { 0, 0, 0, 0, 0 },
/* U+7adc */ { 0, 0, 0, 0, 0 },
/* U+7add */ { 0, 0, 0, 0, 0 },
/* U+7ade */ { 0, 0, 0, 0, 0 },
/* U+7adf */ { 0, 0, 0, 0, 0 },
/* U+7ae0 */ { 0, 0, 0, 0, 0 },
/* U+7ae1 */ { 0, 0, 0, 0, 0 },
/* U+7ae2 */ { 0, 0, 0, 0, 0 },
/* U+7ae3 */ { 0, 0, 0, 0, 0 },
/* U+7ae4 */ { 0, 0, 0, 0, 0 },
/* U+7ae5 */ { 0, 0, 0, 0, 0 },
/* U+7ae6 */ { 0, 0, 0, 0, 0 },
/* U+7ae7 */ { 0, 0, 0, 0, 0 },
/* U+7ae8 */ { 0, 0, 0, 0, 0 },
/* U+7ae9 */ { 0, 0, 0, 0, 0 },
/* U+7aea */ { 0, 0, 0, 0, 0 },
/* U+7aeb */ { 0, 0, 0, 0, 0 },
/* U+7aec */ { 0, 0, 0, 0, 0 },
/* U+7aed */ { 0, 0, 0, 0, 0 },
/* U+7aee */ { 0, 0, 0, 0, 0 },
/* U+7aef */ { 0, 0, 0, 0, 0 },
/* U+7af0 */ { 0, 0, 0, 0, 0 },
/* U+7af1 */ { 0, 0, 0, 0, 0 },
/* U+7af2 */ { 0, 0, 0, 0, 0 },
/* U+7af3 */ { 0, 0, 0, 0, 0 },
/* U+7af4 */ { 0, 0, 0, 0, 0 },
/* U+7af5 */ { 0, 0, 0, 0, 0 },
/* U+7af6 */ { 0, 0, 0, 0, 0 },
/* U+7af7 */ { 0, 0, 0, 0, 0 },
/* U+7af8 */ { 0, 0, 0, 0, 0 },
/* U+7af9 */ { 0, 0, 0, 0, 0 },
/* U+7afa */ { 0, 0, 0, 0, 0 },
/* U+7afb */ { 0, 0, 0, 0, 0 },
/* U+7afc */ { 0, 0, 0, 0, 0 },
/* U+7afd */ { 0, 0, 0, 0, 0 },
/* U+7afe */ { 0, 0, 0, 0, 0 },
/* U+7aff */ { 0, 0, 0, 0, 0 },
/* U+7b00 */ { 0, 0, 0, 0, 0 },
/* U+7b01 */ { 0, 0, 0, 0, 0 },
/* U+7b02 */ { 0, 0, 0, 0, 0 },
/* U+7b03 */ { 0, 0, 0, 0, 0 },
/* U+7b04 */ { 0, 0, 0, 0, 0 },
/* U+7b05 */ { 0, 0, 0, 0, 0 },
/* U+7b06 */ { 0, 0, 0, 0, 0 },
/* U+7b07 */ { 0, 0, 0, 0, 0 },
/* U+7b08 */ { 0, 0, 0, 0, 0 },
/* U+7b09 */ { 0, 0, 0, 0, 0 },
/* U+7b0a */ { 0, 0, 0, 0, 0 },
/* U+7b0b */ { 0, 0, 0, 0, 0 },
/* U+7b0c */ { 0, 0, 0, 0, 0 },
/* U+7b0d */ { 0, 0, 0, 0, 0 },
/* U+7b0e */ { 0, 0, 0, 0, 0 },
/* U+7b0f */ { 0, 0, 0, 0, 0 },
/* U+7b10 */ { 0, 0, 0, 0, 0 },
/* U+7b11 */ { 0, 0, 0, 0, 0 },
/* U+7b12 */ { 0, 0, 0, 0, 0 },
/* U+7b13 */ { 0, 0, 0, 0, 0 },
/* U+7b14 */ { 0, 0, 0, 0, 0 },
/* U+7b15 */ { 0, 0, 0, 0, 0 },
/* U+7b16 */ { 0, 0, 0, 0, 0 },
/* U+7b17 */ { 0, 0, 0, 0, 0 },
/* U+7b18 */ { 0, 0, 0, 0, 0 },
/* U+7b19 */ { 0, 0, 0, 0, 0 },
/* U+7b1a */ { 0, 0, 0, 0, 0 },
/* U+7b1b */ { 0, 0, 0, 0, 0 },
/* U+7b1c */ { 0, 0, 0, 0, 0 },
/* U+7b1d */ { 0, 0, 0, 0, 0 },
/* U+7b1e */ { 0, 0, 0, 0, 0 },
/* U+7b1f */ { 0, 0, 0, 0, 0 },
/* U+7b20 */ { 0, 0, 0, 0, 0 },
/* U+7b21 */ { 0, 0, 0, 0, 0 },
/* U+7b22 */ { 0, 0, 0, 0, 0 },
/* U+7b23 */ { 0, 0, 0, 0, 0 },
/* U+7b24 */ { 0, 0, 0, 0, 0 },
/* U+7b25 */ { 0, 0, 0, 0, 0 },
/* U+7b26 */ { 0, 0, 0, 0, 0 },
/* U+7b27 */ { 0, 0, 0, 0, 0 },
/* U+7b28 */ { 0, 0, 0, 0, 0 },
/* U+7b29 */ { 0, 0, 0, 0, 0 },
/* U+7b2a */ { 0, 0, 0, 0, 0 },
/* U+7b2b */ { 0, 0, 0, 0, 0 },
/* U+7b2c */ { 0, 0, 0, 0, 0 },
/* U+7b2d */ { 0, 0, 0, 0, 0 },
/* U+7b2e */ { 0, 0, 0, 0, 0 },
/* U+7b2f */ { 0, 0, 0, 0, 0 },
/* U+7b30 */ { 0, 0, 0, 0, 0 },
/* U+7b31 */ { 0, 0, 0, 0, 0 },
/* U+7b32 */ { 0, 0, 0, 0, 0 },
/* U+7b33 */ { 0, 0, 0, 0, 0 },
/* U+7b34 */ { 0, 0, 0, 0, 0 },
/* U+7b35 */ { 0, 0, 0, 0, 0 },
/* U+7b36 */ { 0, 0, 0, 0, 0 },
/* U+7b37 */ { 0, 0, 0, 0, 0 },
/* U+7b38 */ { 0, 0, 0, 0, 0 },
/* U+7b39 */ { 0, 0, 0, 0, 0 },
/* U+7b3a */ { 0, 0, 0, 0, 0 },
/* U+7b3b */ { 0, 0, 0, 0, 0 },
/* U+7b3c */ { 0, 0, 0, 0, 0 },
/* U+7b3d */ { 0, 0, 0, 0, 0 },
/* U+7b3e */ { 0, 0, 0, 0, 0 },
/* U+7b3f */ { 0, 0, 0, 0, 0 },
/* U+7b40 */ { 0, 0, 0, 0, 0 },
/* U+7b41 */ { 0, 0, 0, 0, 0 },
/* U+7b42 */ { 0, 0, 0, 0, 0 },
/* U+7b43 */ { 0, 0, 0, 0, 0 },
/* U+7b44 */ { 0, 0, 0, 0, 0 },
/* U+7b45 */ { 0, 0, 0, 0, 0 },
/* U+7b46 */ { 0, 0, 0, 0, 0 },
/* U+7b47 */ { 0, 0, 0, 0, 0 },
/* U+7b48 */ { 0, 0, 0, 0, 0 },
/* U+7b49 */ { 0, 0, 0, 0, 0 },
/* U+7b4a */ { 0, 0, 0, 0, 0 },
/* U+7b4b */ { 0, 0, 0, 0, 0 },
/* U+7b4c */ { 0, 0, 0, 0, 0 },
/* U+7b4d */ { 0, 0, 0, 0, 0 },
/* U+7b4e */ { 0, 0, 0, 0, 0 },
/* U+7b4f */ { 0, 0, 0, 0, 0 },
/* U+7b50 */ { 0, 0, 0, 0, 0 },
/* U+7b51 */ { 0, 0, 0, 0, 0 },
/* U+7b52 */ { 0, 0, 0, 0, 0 },
/* U+7b53 */ { 0, 0, 0, 0, 0 },
/* U+7b54 */ { 0, 0, 0, 0, 0 },
/* U+7b55 */ { 0, 0, 0, 0, 0 },
/* U+7b56 */ { 0, 0, 0, 0, 0 },
/* U+7b57 */ { 0, 0, 0, 0, 0 },
/* U+7b58 */ { 0, 0, 0, 0, 0 },
/* U+7b59 */ { 0, 0, 0, 0, 0 },
/* U+7b5a */ { 0, 0, 0, 0, 0 },
/* U+7b5b */ { 0, 0, 0, 0, 0 },
/* U+7b5c */ { 0, 0, 0, 0, 0 },
/* U+7b5d */ { 0, 0, 0, 0, 0 },
/* U+7b5e */ { 0, 0, 0, 0, 0 },
/* U+7b5f */ { 0, 0, 0, 0, 0 },
/* U+7b60 */ { 0, 0, 0, 0, 0 },
/* U+7b61 */ { 0, 0, 0, 0, 0 },
/* U+7b62 */ { 0, 0, 0, 0, 0 },
/* U+7b63 */ { 0, 0, 0, 0, 0 },
/* U+7b64 */ { 0, 0, 0, 0, 0 },
/* U+7b65 */ { 0, 0, 0, 0, 0 },
/* U+7b66 */ { 0, 0, 0, 0, 0 },
/* U+7b67 */ { 0, 0, 0, 0, 0 },
/* U+7b68 */ { 0, 0, 0, 0, 0 },
/* U+7b69 */ { 0, 0, 0, 0, 0 },
/* U+7b6a */ { 0, 0, 0, 0, 0 },
/* U+7b6b */ { 0, 0, 0, 0, 0 },
/* U+7b6c */ { 0, 0, 0, 0, 0 },
/* U+7b6d */ { 0, 0, 0, 0, 0 },
/* U+7b6e */ { 0, 0, 0, 0, 0 },
/* U+7b6f */ { 0, 0, 0, 0, 0 },
/* U+7b70 */ { 0, 0, 0, 0, 0 },
/* U+7b71 */ { 0, 0, 0, 0, 0 },
/* U+7b72 */ { 0, 0, 0, 0, 0 },
/* U+7b73 */ { 0, 0, 0, 0, 0 },
/* U+7b74 */ { 0, 0, 0, 0, 0 },
/* U+7b75 */ { 0, 0, 0, 0, 0 },
/* U+7b76 */ { 0, 0, 0, 0, 0 },
/* U+7b77 */ { 0, 0, 0, 0, 0 },
/* U+7b78 */ { 0, 0, 0, 0, 0 },
/* U+7b79 */ { 0, 0, 0, 0, 0 },
/* U+7b7a */ { 0, 0, 0, 0, 0 },
/* U+7b7b */ { 0, 0, 0, 0, 0 },
/* U+7b7c */ { 0, 0, 0, 0, 0 },
/* U+7b7d */ { 0, 0, 0, 0, 0 },
/* U+7b7e */ { 0, 0, 0, 0, 0 },
/* U+7b7f */ { 0, 0, 0, 0, 0 },
/* U+7b80 */ { 0, 0, 0, 0, 0 },
/* U+7b81 */ { 0, 0, 0, 0, 0 },
/* U+7b82 */ { 0, 0, 0, 0, 0 },
/* U+7b83 */ { 0, 0, 0, 0, 0 },
/* U+7b84 */ { 0, 0, 0, 0, 0 },
/* U+7b85 */ { 0, 0, 0, 0, 0 },
/* U+7b86 */ { 0, 0, 0, 0, 0 },
/* U+7b87 */ { 0, 0, 0, 0, 0 },
/* U+7b88 */ { 0, 0, 0, 0, 0 },
/* U+7b89 */ { 0, 0, 0, 0, 0 },
/* U+7b8a */ { 0, 0, 0, 0, 0 },
/* U+7b8b */ { 0, 0, 0, 0, 0 },
/* U+7b8c */ { 0, 0, 0, 0, 0 },
/* U+7b8d */ { 0, 0, 0, 0, 0 },
/* U+7b8e */ { 0, 0, 0, 0, 0 },
/* U+7b8f */ { 0, 0, 0, 0, 0 },
/* U+7b90 */ { 0, 0, 0, 0, 0 },
/* U+7b91 */ { 0, 0, 0, 0, 0 },
/* U+7b92 */ { 0, 0, 0, 0, 0 },
/* U+7b93 */ { 0, 0, 0, 0, 0 },
/* U+7b94 */ { 0, 0, 0, 0, 0 },
/* U+7b95 */ { 0, 0, 0, 0, 0 },
/* U+7b96 */ { 0, 0, 0, 0, 0 },
/* U+7b97 */ { 0, 0, 0, 0, 0 },
/* U+7b98 */ { 0, 0, 0, 0, 0 },
/* U+7b99 */ { 0, 0, 0, 0, 0 },
/* U+7b9a */ { 0, 0, 0, 0, 0 },
/* U+7b9b */ { 0, 0, 0, 0, 0 },
/* U+7b9c */ { 0, 0, 0, 0, 0 },
/* U+7b9d */ { 0, 0, 0, 0, 0 },
/* U+7b9e */ { 0, 0, 0, 0, 0 },
/* U+7b9f */ { 0, 0, 0, 0, 0 },
/* U+7ba0 */ { 0, 0, 0, 0, 0 },
/* U+7ba1 */ { 0, 0, 0, 0, 0 },
/* U+7ba2 */ { 0, 0, 0, 0, 0 },
/* U+7ba3 */ { 0, 0, 0, 0, 0 },
/* U+7ba4 */ { 0, 0, 0, 0, 0 },
/* U+7ba5 */ { 0, 0, 0, 0, 0 },
/* U+7ba6 */ { 0, 0, 0, 0, 0 },
/* U+7ba7 */ { 0, 0, 0, 0, 0 },
/* U+7ba8 */ { 0, 0, 0, 0, 0 },
/* U+7ba9 */ { 0, 0, 0, 0, 0 },
/* U+7baa */ { 0, 0, 0, 0, 0 },
/* U+7bab */ { 0, 0, 0, 0, 0 },
/* U+7bac */ { 0, 0, 0, 0, 0 },
/* U+7bad */ { 0, 0, 0, 0, 0 },
/* U+7bae */ { 0, 0, 0, 0, 0 },
/* U+7baf */ { 0, 0, 0, 0, 0 },
/* U+7bb0 */ { 0, 0, 0, 0, 0 },
/* U+7bb1 */ { 0, 0, 0, 0, 0 },
/* U+7bb2 */ { 0, 0, 0, 0, 0 },
/* U+7bb3 */ { 0, 0, 0, 0, 0 },
/* U+7bb4 */ { 0, 0, 0, 0, 0 },
/* U+7bb5 */ { 0, 0, 0, 0, 0 },
/* U+7bb6 */ { 0, 0, 0, 0, 0 },
/* U+7bb7 */ { 0, 0, 0, 0, 0 },
/* U+7bb8 */ { 0, 0, 0, 0, 0 },
/* U+7bb9 */ { 0, 0, 0, 0, 0 },
/* U+7bba */ { 0, 0, 0, 0, 0 },
/* U+7bbb */ { 0, 0, 0, 0, 0 },
/* U+7bbc */ { 0, 0, 0, 0, 0 },
/* U+7bbd */ { 0, 0, 0, 0, 0 },
/* U+7bbe */ { 0, 0, 0, 0, 0 },
/* U+7bbf */ { 0, 0, 0, 0, 0 },
/* U+7bc0 */ { 0, 0, 0, 0, 0 },
/* U+7bc1 */ { 0, 0, 0, 0, 0 },
/* U+7bc2 */ { 0, 0, 0, 0, 0 },
/* U+7bc3 */ { 0, 0, 0, 0, 0 },
/* U+7bc4 */ { 0, 0, 0, 0, 0 },
/* U+7bc5 */ { 0, 0, 0, 0, 0 },
/* U+7bc6 */ { 0, 0, 0, 0, 0 },
/* U+7bc7 */ { 0, 0, 0, 0, 0 },
/* U+7bc8 */ { 0, 0, 0, 0, 0 },
/* U+7bc9 */ { 0, 0, 0, 0, 0 },
/* U+7bca */ { 0, 0, 0, 0, 0 },
/* U+7bcb */ { 0, 0, 0, 0, 0 },
/* U+7bcc */ { 0, 0, 0, 0, 0 },
/* U+7bcd */ { 0, 0, 0, 0, 0 },
/* U+7bce */ { 0, 0, 0, 0, 0 },
/* U+7bcf */ { 0, 0, 0, 0, 0 },
/* U+7bd0 */ { 0, 0, 0, 0, 0 },
/* U+7bd1 */ { 0, 0, 0, 0, 0 },
/* U+7bd2 */ { 0, 0, 0, 0, 0 },
/* U+7bd3 */ { 0, 0, 0, 0, 0 },
/* U+7bd4 */ { 0, 0, 0, 0, 0 },
/* U+7bd5 */ { 0, 0, 0, 0, 0 },
/* U+7bd6 */ { 0, 0, 0, 0, 0 },
/* U+7bd7 */ { 0, 0, 0, 0, 0 },
/* U+7bd8 */ { 0, 0, 0, 0, 0 },
/* U+7bd9 */ { 0, 0, 0, 0, 0 },
/* U+7bda */ { 0, 0, 0, 0, 0 },
/* U+7bdb */ { 0, 0, 0, 0, 0 },
/* U+7bdc */ { 0, 0, 0, 0, 0 },
/* U+7bdd */ { 0, 0, 0, 0, 0 },
/* U+7bde */ { 0, 0, 0, 0, 0 },
/* U+7bdf */ { 0, 0, 0, 0, 0 },
/* U+7be0 */ { 0, 0, 0, 0, 0 },
/* U+7be1 */ { 0, 0, 0, 0, 0 },
/* U+7be2 */ { 0, 0, 0, 0, 0 },
/* U+7be3 */ { 0, 0, 0, 0, 0 },
/* U+7be4 */ { 0, 0, 0, 0, 0 },
/* U+7be5 */ { 0, 0, 0, 0, 0 },
/* U+7be6 */ { 0, 0, 0, 0, 0 },
/* U+7be7 */ { 0, 0, 0, 0, 0 },
/* U+7be8 */ { 0, 0, 0, 0, 0 },
/* U+7be9 */ { 0, 0, 0, 0, 0 },
/* U+7bea */ { 0, 0, 0, 0, 0 },
/* U+7beb */ { 0, 0, 0, 0, 0 },
/* U+7bec */ { 0, 0, 0, 0, 0 },
/* U+7bed */ { 0, 0, 0, 0, 0 },
/* U+7bee */ { 0, 0, 0, 0, 0 },
/* U+7bef */ { 0, 0, 0, 0, 0 },
/* U+7bf0 */ { 0, 0, 0, 0, 0 },
/* U+7bf1 */ { 0, 0, 0, 0, 0 },
/* U+7bf2 */ { 0, 0, 0, 0, 0 },
/* U+7bf3 */ { 0, 0, 0, 0, 0 },
/* U+7bf4 */ { 0, 0, 0, 0, 0 },
/* U+7bf5 */ { 0, 0, 0, 0, 0 },
/* U+7bf6 */ { 0, 0, 0, 0, 0 },
/* U+7bf7 */ { 0, 0, 0, 0, 0 },
/* U+7bf8 */ { 0, 0, 0, 0, 0 },
/* U+7bf9 */ { 0, 0, 0, 0, 0 },
/* U+7bfa */ { 0, 0, 0, 0, 0 },
/* U+7bfb */ { 0, 0, 0, 0, 0 },
/* U+7bfc */ { 0, 0, 0, 0, 0 },
/* U+7bfd */ { 0, 0, 0, 0, 0 },
/* U+7bfe */ { 0, 0, 0, 0, 0 },
/* U+7bff */ { 0, 0, 0, 0, 0 },
/* U+7c00 */ { 0, 0, 0, 0, 0 },
/* U+7c01 */ { 0, 0, 0, 0, 0 },
/* U+7c02 */ { 0, 0, 0, 0, 0 },
/* U+7c03 */ { 0, 0, 0, 0, 0 },
/* U+7c04 */ { 0, 0, 0, 0, 0 },
/* U+7c05 */ { 0, 0, 0, 0, 0 },
/* U+7c06 */ { 0, 0, 0, 0, 0 },
/* U+7c07 */ { 0, 0, 0, 0, 0 },
/* U+7c08 */ { 0, 0, 0, 0, 0 },
/* U+7c09 */ { 0, 0, 0, 0, 0 },
/* U+7c0a */ { 0, 0, 0, 0, 0 },
/* U+7c0b */ { 0, 0, 0, 0, 0 },
/* U+7c0c */ { 0, 0, 0, 0, 0 },
/* U+7c0d */ { 0, 0, 0, 0, 0 },
/* U+7c0e */ { 0, 0, 0, 0, 0 },
/* U+7c0f */ { 0, 0, 0, 0, 0 },
/* U+7c10 */ { 0, 0, 0, 0, 0 },
/* U+7c11 */ { 0, 0, 0, 0, 0 },
/* U+7c12 */ { 0, 0, 0, 0, 0 },
/* U+7c13 */ { 0, 0, 0, 0, 0 },
/* U+7c14 */ { 0, 0, 0, 0, 0 },
/* U+7c15 */ { 0, 0, 0, 0, 0 },
/* U+7c16 */ { 0, 0, 0, 0, 0 },
/* U+7c17 */ { 0, 0, 0, 0, 0 },
/* U+7c18 */ { 0, 0, 0, 0, 0 },
/* U+7c19 */ { 0, 0, 0, 0, 0 },
/* U+7c1a */ { 0, 0, 0, 0, 0 },
/* U+7c1b */ { 0, 0, 0, 0, 0 },
/* U+7c1c */ { 0, 0, 0, 0, 0 },
/* U+7c1d */ { 0, 0, 0, 0, 0 },
/* U+7c1e */ { 0, 0, 0, 0, 0 },
/* U+7c1f */ { 0, 0, 0, 0, 0 },
/* U+7c20 */ { 0, 0, 0, 0, 0 },
/* U+7c21 */ { 0, 0, 0, 0, 0 },
/* U+7c22 */ { 0, 0, 0, 0, 0 },
/* U+7c23 */ { 0, 0, 0, 0, 0 },
/* U+7c24 */ { 0, 0, 0, 0, 0 },
/* U+7c25 */ { 0, 0, 0, 0, 0 },
/* U+7c26 */ { 0, 0, 0, 0, 0 },
/* U+7c27 */ { 0, 0, 0, 0, 0 },
/* U+7c28 */ { 0, 0, 0, 0, 0 },
/* U+7c29 */ { 0, 0, 0, 0, 0 },
/* U+7c2a */ { 0, 0, 0, 0, 0 },
/* U+7c2b */ { 0, 0, 0, 0, 0 },
/* U+7c2c */ { 0, 0, 0, 0, 0 },
/* U+7c2d */ { 0, 0, 0, 0, 0 },
/* U+7c2e */ { 0, 0, 0, 0, 0 },
/* U+7c2f */ { 0, 0, 0, 0, 0 },
/* U+7c30 */ { 0, 0, 0, 0, 0 },
/* U+7c31 */ { 0, 0, 0, 0, 0 },
/* U+7c32 */ { 0, 0, 0, 0, 0 },
/* U+7c33 */ { 0, 0, 0, 0, 0 },
/* U+7c34 */ { 0, 0, 0, 0, 0 },
/* U+7c35 */ { 0, 0, 0, 0, 0 },
/* U+7c36 */ { 0, 0, 0, 0, 0 },
/* U+7c37 */ { 0, 0, 0, 0, 0 },
/* U+7c38 */ { 0, 0, 0, 0, 0 },
/* U+7c39 */ { 0, 0, 0, 0, 0 },
/* U+7c3a */ { 0, 0, 0, 0, 0 },
/* U+7c3b */ { 0, 0, 0, 0, 0 },
/* U+7c3c */ { 0, 0, 0, 0, 0 },
/* U+7c3d */ { 0, 0, 0, 0, 0 },
/* U+7c3e */ { 0, 0, 0, 0, 0 },
/* U+7c3f */ { 0, 0, 0, 0, 0 },
/* U+7c40 */ { 0, 0, 0, 0, 0 },
/* U+7c41 */ { 0, 0, 0, 0, 0 },
/* U+7c42 */ { 0, 0, 0, 0, 0 },
/* U+7c43 */ { 0, 0, 0, 0, 0 },
/* U+7c44 */ { 0, 0, 0, 0, 0 },
/* U+7c45 */ { 0, 0, 0, 0, 0 },
/* U+7c46 */ { 0, 0, 0, 0, 0 },
/* U+7c47 */ { 0, 0, 0, 0, 0 },
/* U+7c48 */ { 0, 0, 0, 0, 0 },
/* U+7c49 */ { 0, 0, 0, 0, 0 },
/* U+7c4a */ { 0, 0, 0, 0, 0 },
/* U+7c4b */ { 0, 0, 0, 0, 0 },
/* U+7c4c */ { 0, 0, 0, 0, 0 },
/* U+7c4d */ { 0, 0, 0, 0, 0 },
/* U+7c4e */ { 0, 0, 0, 0, 0 },
/* U+7c4f */ { 0, 0, 0, 0, 0 },
/* U+7c50 */ { 0, 0, 0, 0, 0 },
/* U+7c51 */ { 0, 0, 0, 0, 0 },
/* U+7c52 */ { 0, 0, 0, 0, 0 },
/* U+7c53 */ { 0, 0, 0, 0, 0 },
/* U+7c54 */ { 0, 0, 0, 0, 0 },
/* U+7c55 */ { 0, 0, 0, 0, 0 },
/* U+7c56 */ { 0, 0, 0, 0, 0 },
/* U+7c57 */ { 0, 0, 0, 0, 0 },
/* U+7c58 */ { 0, 0, 0, 0, 0 },
/* U+7c59 */ { 0, 0, 0, 0, 0 },
/* U+7c5a */ { 0, 0, 0, 0, 0 },
/* U+7c5b */ { 0, 0, 0, 0, 0 },
/* U+7c5c */ { 0, 0, 0, 0, 0 },
/* U+7c5d */ { 0, 0, 0, 0, 0 },
/* U+7c5e */ { 0, 0, 0, 0, 0 },
/* U+7c5f */ { 0, 0, 0, 0, 0 },
/* U+7c60 */ { 0, 0, 0, 0, 0 },
/* U+7c61 */ { 0, 0, 0, 0, 0 },
/* U+7c62 */ { 0, 0, 0, 0, 0 },
/* U+7c63 */ { 0, 0, 0, 0, 0 },
/* U+7c64 */ { 0, 0, 0, 0, 0 },
/* U+7c65 */ { 0, 0, 0, 0, 0 },
/* U+7c66 */ { 0, 0, 0, 0, 0 },
/* U+7c67 */ { 0, 0, 0, 0, 0 },
/* U+7c68 */ { 0, 0, 0, 0, 0 },
/* U+7c69 */ { 0, 0, 0, 0, 0 },
/* U+7c6a */ { 0, 0, 0, 0, 0 },
/* U+7c6b */ { 0, 0, 0, 0, 0 },
/* U+7c6c */ { 0, 0, 0, 0, 0 },
/* U+7c6d */ { 0, 0, 0, 0, 0 },
/* U+7c6e */ { 0, 0, 0, 0, 0 },
/* U+7c6f */ { 0, 0, 0, 0, 0 },
/* U+7c70 */ { 0, 0, 0, 0, 0 },
/* U+7c71 */ { 0, 0, 0, 0, 0 },
/* U+7c72 */ { 0, 0, 0, 0, 0 },
/* U+7c73 */ { 0, 0, 0, 0, 0 },
/* U+7c74 */ { 0, 0, 0, 0, 0 },
/* U+7c75 */ { 0, 0, 0, 0, 0 },
/* U+7c76 */ { 0, 0, 0, 0, 0 },
/* U+7c77 */ { 0, 0, 0, 0, 0 },
/* U+7c78 */ { 0, 0, 0, 0, 0 },
/* U+7c79 */ { 0, 0, 0, 0, 0 },
/* U+7c7a */ { 0, 0, 0, 0, 0 },
/* U+7c7b */ { 0, 0, 0, 0, 0 },
/* U+7c7c */ { 0, 0, 0, 0, 0 },
/* U+7c7d */ { 0, 0, 0, 0, 0 },
/* U+7c7e */ { 0, 0, 0, 0, 0 },
/* U+7c7f */ { 0, 0, 0, 0, 0 },
/* U+7c80 */ { 0, 0, 0, 0, 0 },
/* U+7c81 */ { 0, 0, 0, 0, 0 },
/* U+7c82 */ { 0, 0, 0, 0, 0 },
/* U+7c83 */ { 0, 0, 0, 0, 0 },
/* U+7c84 */ { 0, 0, 0, 0, 0 },
/* U+7c85 */ { 0, 0, 0, 0, 0 },
/* U+7c86 */ { 0, 0, 0, 0, 0 },
/* U+7c87 */ { 0, 0, 0, 0, 0 },
/* U+7c88 */ { 0, 0, 0, 0, 0 },
/* U+7c89 */ { 0, 0, 0, 0, 0 },
/* U+7c8a */ { 0, 0, 0, 0, 0 },
/* U+7c8b */ { 0, 0, 0, 0, 0 },
/* U+7c8c */ { 0, 0, 0, 0, 0 },
/* U+7c8d */ { 0, 0, 0, 0, 0 },
/* U+7c8e */ { 0, 0, 0, 0, 0 },
/* U+7c8f */ { 0, 0, 0, 0, 0 },
/* U+7c90 */ { 0, 0, 0, 0, 0 },
/* U+7c91 */ { 0, 0, 0, 0, 0 },
/* U+7c92 */ { 0, 0, 0, 0, 0 },
/* U+7c93 */ { 0, 0, 0, 0, 0 },
/* U+7c94 */ { 0, 0, 0, 0, 0 },
/* U+7c95 */ { 0, 0, 0, 0, 0 },
/* U+7c96 */ { 0, 0, 0, 0, 0 },
/* U+7c97 */ { 0, 0, 0, 0, 0 },
/* U+7c98 */ { 0, 0, 0, 0, 0 },
/* U+7c99 */ { 0, 0, 0, 0, 0 },
/* U+7c9a */ { 0, 0, 0, 0, 0 },
/* U+7c9b */ { 0, 0, 0, 0, 0 },
/* U+7c9c */ { 0, 0, 0, 0, 0 },
/* U+7c9d */ { 0, 0, 0, 0, 0 },
/* U+7c9e */ { 0, 0, 0, 0, 0 },
/* U+7c9f */ { 0, 0, 0, 0, 0 },
/* U+7ca0 */ { 0, 0, 0, 0, 0 },
/* U+7ca1 */ { 0, 0, 0, 0, 0 },
/* U+7ca2 */ { 0, 0, 0, 0, 0 },
/* U+7ca3 */ { 0, 0, 0, 0, 0 },
/* U+7ca4 */ { 0, 0, 0, 0, 0 },
/* U+7ca5 */ { 0, 0, 0, 0, 0 },
/* U+7ca6 */ { 0, 0, 0, 0, 0 },
/* U+7ca7 */ { 0, 0, 0, 0, 0 },
/* U+7ca8 */ { 0, 0, 0, 0, 0 },
/* U+7ca9 */ { 0, 0, 0, 0, 0 },
/* U+7caa */ { 0, 0, 0, 0, 0 },
/* U+7cab */ { 0, 0, 0, 0, 0 },
/* U+7cac */ { 0, 0, 0, 0, 0 },
/* U+7cad */ { 0, 0, 0, 0, 0 },
/* U+7cae */ { 0, 0, 0, 0, 0 },
/* U+7caf */ { 0, 0, 0, 0, 0 },
/* U+7cb0 */ { 0, 0, 0, 0, 0 },
/* U+7cb1 */ { 0, 0, 0, 0, 0 },
/* U+7cb2 */ { 0, 0, 0, 0, 0 },
/* U+7cb3 */ { 0, 0, 0, 0, 0 },
/* U+7cb4 */ { 0, 0, 0, 0, 0 },
/* U+7cb5 */ { 0, 0, 0, 0, 0 },
/* U+7cb6 */ { 0, 0, 0, 0, 0 },
/* U+7cb7 */ { 0, 0, 0, 0, 0 },
/* U+7cb8 */ { 0, 0, 0, 0, 0 },
/* U+7cb9 */ { 0, 0, 0, 0, 0 },
/* U+7cba */ { 0, 0, 0, 0, 0 },
/* U+7cbb */ { 0, 0, 0, 0, 0 },
/* U+7cbc */ { 0, 0, 0, 0, 0 },
/* U+7cbd */ { 0, 0, 0, 0, 0 },
/* U+7cbe */ { 0, 0, 0, 0, 0 },
/* U+7cbf */ { 0, 0, 0, 0, 0 },
/* U+7cc0 */ { 0, 0, 0, 0, 0 },
/* U+7cc1 */ { 0, 0, 0, 0, 0 },
/* U+7cc2 */ { 0, 0, 0, 0, 0 },
/* U+7cc3 */ { 0, 0, 0, 0, 0 },
/* U+7cc4 */ { 0, 0, 0, 0, 0 },
/* U+7cc5 */ { 0, 0, 0, 0, 0 },
/* U+7cc6 */ { 0, 0, 0, 0, 0 },
/* U+7cc7 */ { 0, 0, 0, 0, 0 },
/* U+7cc8 */ { 0, 0, 0, 0, 0 },
/* U+7cc9 */ { 0, 0, 0, 0, 0 },
/* U+7cca */ { 0, 0, 0, 0, 0 },
/* U+7ccb */ { 0, 0, 0, 0, 0 },
/* U+7ccc */ { 0, 0, 0, 0, 0 },
/* U+7ccd */ { 0, 0, 0, 0, 0 },
/* U+7cce */ { 0, 0, 0, 0, 0 },
/* U+7ccf */ { 0, 0, 0, 0, 0 },
/* U+7cd0 */ { 0, 0, 0, 0, 0 },
/* U+7cd1 */ { 0, 0, 0, 0, 0 },
/* U+7cd2 */ { 0, 0, 0, 0, 0 },
/* U+7cd3 */ { 0, 0, 0, 0, 0 },
/* U+7cd4 */ { 0, 0, 0, 0, 0 },
/* U+7cd5 */ { 0, 0, 0, 0, 0 },
/* U+7cd6 */ { 0, 0, 0, 0, 0 },
/* U+7cd7 */ { 0, 0, 0, 0, 0 },
/* U+7cd8 */ { 0, 0, 0, 0, 0 },
/* U+7cd9 */ { 0, 0, 0, 0, 0 },
/* U+7cda */ { 0, 0, 0, 0, 0 },
/* U+7cdb */ { 0, 0, 0, 0, 0 },
/* U+7cdc */ { 0, 0, 0, 0, 0 },
/* U+7cdd */ { 0, 0, 0, 0, 0 },
/* U+7cde */ { 0, 0, 0, 0, 0 },
/* U+7cdf */ { 0, 0, 0, 0, 0 },
/* U+7ce0 */ { 0, 0, 0, 0, 0 },
/* U+7ce1 */ { 0, 0, 0, 0, 0 },
/* U+7ce2 */ { 0, 0, 0, 0, 0 },
/* U+7ce3 */ { 0, 0, 0, 0, 0 },
/* U+7ce4 */ { 0, 0, 0, 0, 0 },
/* U+7ce5 */ { 0, 0, 0, 0, 0 },
/* U+7ce6 */ { 0, 0, 0, 0, 0 },
/* U+7ce7 */ { 0, 0, 0, 0, 0 },
/* U+7ce8 */ { 0, 0, 0, 0, 0 },
/* U+7ce9 */ { 0, 0, 0, 0, 0 },
/* U+7cea */ { 0, 0, 0, 0, 0 },
/* U+7ceb */ { 0, 0, 0, 0, 0 },
/* U+7cec */ { 0, 0, 0, 0, 0 },
/* U+7ced */ { 0, 0, 0, 0, 0 },
/* U+7cee */ { 0, 0, 0, 0, 0 },
/* U+7cef */ { 0, 0, 0, 0, 0 },
/* U+7cf0 */ { 0, 0, 0, 0, 0 },
/* U+7cf1 */ { 0, 0, 0, 0, 0 },
/* U+7cf2 */ { 0, 0, 0, 0, 0 },
/* U+7cf3 */ { 0, 0, 0, 0, 0 },
/* U+7cf4 */ { 0, 0, 0, 0, 0 },
/* U+7cf5 */ { 0, 0, 0, 0, 0 },
/* U+7cf6 */ { 0, 0, 0, 0, 0 },
/* U+7cf7 */ { 0, 0, 0, 0, 0 },
/* U+7cf8 */ { 0, 0, 0, 0, 0 },
/* U+7cf9 */ { 0, 0, 0, 0, 0 },
/* U+7cfa */ { 0, 0, 0, 0, 0 },
/* U+7cfb */ { 0, 0, 0, 0, 0 },
/* U+7cfc */ { 0, 0, 0, 0, 0 },
/* U+7cfd */ { 0, 0, 0, 0, 0 },
/* U+7cfe */ { 0, 0, 0, 0, 0 },
/* U+7cff */ { 0, 0, 0, 0, 0 },
/* U+7d00 */ { 0, 0, 0, 0, 0 },
/* U+7d01 */ { 0, 0, 0, 0, 0 },
/* U+7d02 */ { 0, 0, 0, 0, 0 },
/* U+7d03 */ { 0, 0, 0, 0, 0 },
/* U+7d04 */ { 0, 0, 0, 0, 0 },
/* U+7d05 */ { 0, 0, 0, 0, 0 },
/* U+7d06 */ { 0, 0, 0, 0, 0 },
/* U+7d07 */ { 0, 0, 0, 0, 0 },
/* U+7d08 */ { 0, 0, 0, 0, 0 },
/* U+7d09 */ { 0, 0, 0, 0, 0 },
/* U+7d0a */ { 0, 0, 0, 0, 0 },
/* U+7d0b */ { 0, 0, 0, 0, 0 },
/* U+7d0c */ { 0, 0, 0, 0, 0 },
/* U+7d0d */ { 0, 0, 0, 0, 0 },
/* U+7d0e */ { 0, 0, 0, 0, 0 },
/* U+7d0f */ { 0, 0, 0, 0, 0 },
/* U+7d10 */ { 0, 0, 0, 0, 0 },
/* U+7d11 */ { 0, 0, 0, 0, 0 },
/* U+7d12 */ { 0, 0, 0, 0, 0 },
/* U+7d13 */ { 0, 0, 0, 0, 0 },
/* U+7d14 */ { 0, 0, 0, 0, 0 },
/* U+7d15 */ { 0, 0, 0, 0, 0 },
/* U+7d16 */ { 0, 0, 0, 0, 0 },
/* U+7d17 */ { 0, 0, 0, 0, 0 },
/* U+7d18 */ { 0, 0, 0, 0, 0 },
/* U+7d19 */ { 0, 0, 0, 0, 0 },
/* U+7d1a */ { 0, 0, 0, 0, 0 },
/* U+7d1b */ { 0, 0, 0, 0, 0 },
/* U+7d1c */ { 0, 0, 0, 0, 0 },
/* U+7d1d */ { 0, 0, 0, 0, 0 },
/* U+7d1e */ { 0, 0, 0, 0, 0 },
/* U+7d1f */ { 0, 0, 0, 0, 0 },
/* U+7d20 */ { 0, 0, 0, 0, 0 },
/* U+7d21 */ { 0, 0, 0, 0, 0 },
/* U+7d22 */ { 0, 0, 0, 0, 0 },
/* U+7d23 */ { 0, 0, 0, 0, 0 },
/* U+7d24 */ { 0, 0, 0, 0, 0 },
/* U+7d25 */ { 0, 0, 0, 0, 0 },
/* U+7d26 */ { 0, 0, 0, 0, 0 },
/* U+7d27 */ { 0, 0, 0, 0, 0 },
/* U+7d28 */ { 0, 0, 0, 0, 0 },
/* U+7d29 */ { 0, 0, 0, 0, 0 },
/* U+7d2a */ { 0, 0, 0, 0, 0 },
/* U+7d2b */ { 0, 0, 0, 0, 0 },
/* U+7d2c */ { 0, 0, 0, 0, 0 },
/* U+7d2d */ { 0, 0, 0, 0, 0 },
/* U+7d2e */ { 0, 0, 0, 0, 0 },
/* U+7d2f */ { 0, 0, 0, 0, 0 },
/* U+7d30 */ { 0, 0, 0, 0, 0 },
/* U+7d31 */ { 0, 0, 0, 0, 0 },
/* U+7d32 */ { 0, 0, 0, 0, 0 },
/* U+7d33 */ { 0, 0, 0, 0, 0 },
/* U+7d34 */ { 0, 0, 0, 0, 0 },
/* U+7d35 */ { 0, 0, 0, 0, 0 },
/* U+7d36 */ { 0, 0, 0, 0, 0 },
/* U+7d37 */ { 0, 0, 0, 0, 0 },
/* U+7d38 */ { 0, 0, 0, 0, 0 },
/* U+7d39 */ { 0, 0, 0, 0, 0 },
/* U+7d3a */ { 0, 0, 0, 0, 0 },
/* U+7d3b */ { 0, 0, 0, 0, 0 },
/* U+7d3c */ { 0, 0, 0, 0, 0 },
/* U+7d3d */ { 0, 0, 0, 0, 0 },
/* U+7d3e */ { 0, 0, 0, 0, 0 },
/* U+7d3f */ { 0, 0, 0, 0, 0 },
/* U+7d40 */ { 0, 0, 0, 0, 0 },
/* U+7d41 */ { 0, 0, 0, 0, 0 },
/* U+7d42 */ { 0, 0, 0, 0, 0 },
/* U+7d43 */ { 0, 0, 0, 0, 0 },
/* U+7d44 */ { 0, 0, 0, 0, 0 },
/* U+7d45 */ { 0, 0, 0, 0, 0 },
/* U+7d46 */ { 0, 0, 0, 0, 0 },
/* U+7d47 */ { 0, 0, 0, 0, 0 },
/* U+7d48 */ { 0, 0, 0, 0, 0 },
/* U+7d49 */ { 0, 0, 0, 0, 0 },
/* U+7d4a */ { 0, 0, 0, 0, 0 },
/* U+7d4b */ { 0, 0, 0, 0, 0 },
/* U+7d4c */ { 0, 0, 0, 0, 0 },
/* U+7d4d */ { 0, 0, 0, 0, 0 },
/* U+7d4e */ { 0, 0, 0, 0, 0 },
/* U+7d4f */ { 0, 0, 0, 0, 0 },
/* U+7d50 */ { 0, 0, 0, 0, 0 },
/* U+7d51 */ { 0, 0, 0, 0, 0 },
/* U+7d52 */ { 0, 0, 0, 0, 0 },
/* U+7d53 */ { 0, 0, 0, 0, 0 },
/* U+7d54 */ { 0, 0, 0, 0, 0 },
/* U+7d55 */ { 0, 0, 0, 0, 0 },
/* U+7d56 */ { 0, 0, 0, 0, 0 },
/* U+7d57 */ { 0, 0, 0, 0, 0 },
/* U+7d58 */ { 0, 0, 0, 0, 0 },
/* U+7d59 */ { 0, 0, 0, 0, 0 },
/* U+7d5a */ { 0, 0, 0, 0, 0 },
/* U+7d5b */ { 0, 0, 0, 0, 0 },
/* U+7d5c */ { 0, 0, 0, 0, 0 },
/* U+7d5d */ { 0, 0, 0, 0, 0 },
/* U+7d5e */ { 0, 0, 0, 0, 0 },
/* U+7d5f */ { 0, 0, 0, 0, 0 },
/* U+7d60 */ { 0, 0, 0, 0, 0 },
/* U+7d61 */ { 0, 0, 0, 0, 0 },
/* U+7d62 */ { 0, 0, 0, 0, 0 },
/* U+7d63 */ { 0, 0, 0, 0, 0 },
/* U+7d64 */ { 0, 0, 0, 0, 0 },
/* U+7d65 */ { 0, 0, 0, 0, 0 },
/* U+7d66 */ { 0, 0, 0, 0, 0 },
/* U+7d67 */ { 0, 0, 0, 0, 0 },
/* U+7d68 */ { 0, 0, 0, 0, 0 },
/* U+7d69 */ { 0, 0, 0, 0, 0 },
/* U+7d6a */ { 0, 0, 0, 0, 0 },
/* U+7d6b */ { 0, 0, 0, 0, 0 },
/* U+7d6c */ { 0, 0, 0, 0, 0 },
/* U+7d6d */ { 0, 0, 0, 0, 0 },
/* U+7d6e */ { 0, 0, 0, 0, 0 },
/* U+7d6f */ { 0, 0, 0, 0, 0 },
/* U+7d70 */ { 0, 0, 0, 0, 0 },
/* U+7d71 */ { 0, 0, 0, 0, 0 },
/* U+7d72 */ { 0, 0, 0, 0, 0 },
/* U+7d73 */ { 0, 0, 0, 0, 0 },
/* U+7d74 */ { 0, 0, 0, 0, 0 },
/* U+7d75 */ { 0, 0, 0, 0, 0 },
/* U+7d76 */ { 0, 0, 0, 0, 0 },
/* U+7d77 */ { 0, 0, 0, 0, 0 },
/* U+7d78 */ { 0, 0, 0, 0, 0 },
/* U+7d79 */ { 0, 0, 0, 0, 0 },
/* U+7d7a */ { 0, 0, 0, 0, 0 },
/* U+7d7b */ { 0, 0, 0, 0, 0 },
/* U+7d7c */ { 0, 0, 0, 0, 0 },
/* U+7d7d */ { 0, 0, 0, 0, 0 },
/* U+7d7e */ { 0, 0, 0, 0, 0 },
/* U+7d7f */ { 0, 0, 0, 0, 0 },
/* U+7d80 */ { 0, 0, 0, 0, 0 },
/* U+7d81 */ { 0, 0, 0, 0, 0 },
/* U+7d82 */ { 0, 0, 0, 0, 0 },
/* U+7d83 */ { 0, 0, 0, 0, 0 },
/* U+7d84 */ { 0, 0, 0, 0, 0 },
/* U+7d85 */ { 0, 0, 0, 0, 0 },
/* U+7d86 */ { 0, 0, 0, 0, 0 },
/* U+7d87 */ { 0, 0, 0, 0, 0 },
/* U+7d88 */ { 0, 0, 0, 0, 0 },
/* U+7d89 */ { 0, 0, 0, 0, 0 },
/* U+7d8a */ { 0, 0, 0, 0, 0 },
/* U+7d8b */ { 0, 0, 0, 0, 0 },
/* U+7d8c */ { 0, 0, 0, 0, 0 },
/* U+7d8d */ { 0, 0, 0, 0, 0 },
/* U+7d8e */ { 0, 0, 0, 0, 0 },
/* U+7d8f */ { 0, 0, 0, 0, 0 },
/* U+7d90 */ { 0, 0, 0, 0, 0 },
/* U+7d91 */ { 0, 0, 0, 0, 0 },
/* U+7d92 */ { 0, 0, 0, 0, 0 },
/* U+7d93 */ { 0, 0, 0, 0, 0 },
/* U+7d94 */ { 0, 0, 0, 0, 0 },
/* U+7d95 */ { 0, 0, 0, 0, 0 },
/* U+7d96 */ { 0, 0, 0, 0, 0 },
/* U+7d97 */ { 0, 0, 0, 0, 0 },
/* U+7d98 */ { 0, 0, 0, 0, 0 },
/* U+7d99 */ { 0, 0, 0, 0, 0 },
/* U+7d9a */ { 0, 0, 0, 0, 0 },
/* U+7d9b */ { 0, 0, 0, 0, 0 },
/* U+7d9c */ { 0, 0, 0, 0, 0 },
/* U+7d9d */ { 0, 0, 0, 0, 0 },
/* U+7d9e */ { 0, 0, 0, 0, 0 },
/* U+7d9f */ { 0, 0, 0, 0, 0 },
/* U+7da0 */ { 0, 0, 0, 0, 0 },
/* U+7da1 */ { 0, 0, 0, 0, 0 },
/* U+7da2 */ { 0, 0, 0, 0, 0 },
/* U+7da3 */ { 0, 0, 0, 0, 0 },
/* U+7da4 */ { 0, 0, 0, 0, 0 },
/* U+7da5 */ { 0, 0, 0, 0, 0 },
/* U+7da6 */ { 0, 0, 0, 0, 0 },
/* U+7da7 */ { 0, 0, 0, 0, 0 },
/* U+7da8 */ { 0, 0, 0, 0, 0 },
/* U+7da9 */ { 0, 0, 0, 0, 0 },
/* U+7daa */ { 0, 0, 0, 0, 0 },
/* U+7dab */ { 0, 0, 0, 0, 0 },
/* U+7dac */ { 0, 0, 0, 0, 0 },
/* U+7dad */ { 0, 0, 0, 0, 0 },
/* U+7dae */ { 0, 0, 0, 0, 0 },
/* U+7daf */ { 0, 0, 0, 0, 0 },
/* U+7db0 */ { 0, 0, 0, 0, 0 },
/* U+7db1 */ { 0, 0, 0, 0, 0 },
/* U+7db2 */ { 0, 0, 0, 0, 0 },
/* U+7db3 */ { 0, 0, 0, 0, 0 },
/* U+7db4 */ { 0, 0, 0, 0, 0 },
/* U+7db5 */ { 0, 0, 0, 0, 0 },
/* U+7db6 */ { 0, 0, 0, 0, 0 },
/* U+7db7 */ { 0, 0, 0, 0, 0 },
/* U+7db8 */ { 0, 0, 0, 0, 0 },
/* U+7db9 */ { 0, 0, 0, 0, 0 },
/* U+7dba */ { 0, 0, 0, 0, 0 },
/* U+7dbb */ { 0, 0, 0, 0, 0 },
/* U+7dbc */ { 0, 0, 0, 0, 0 },
/* U+7dbd */ { 0, 0, 0, 0, 0 },
/* U+7dbe */ { 0, 0, 0, 0, 0 },
/* U+7dbf */ { 0, 0, 0, 0, 0 },
/* U+7dc0 */ { 0, 0, 0, 0, 0 },
/* U+7dc1 */ { 0, 0, 0, 0, 0 },
/* U+7dc2 */ { 0, 0, 0, 0, 0 },
/* U+7dc3 */ { 0, 0, 0, 0, 0 },
/* U+7dc4 */ { 0, 0, 0, 0, 0 },
/* U+7dc5 */ { 0, 0, 0, 0, 0 },
/* U+7dc6 */ { 0, 0, 0, 0, 0 },
/* U+7dc7 */ { 0, 0, 0, 0, 0 },
/* U+7dc8 */ { 0, 0, 0, 0, 0 },
/* U+7dc9 */ { 0, 0, 0, 0, 0 },
/* U+7dca */ { 0, 0, 0, 0, 0 },
/* U+7dcb */ { 0, 0, 0, 0, 0 },
/* U+7dcc */ { 0, 0, 0, 0, 0 },
/* U+7dcd */ { 0, 0, 0, 0, 0 },
/* U+7dce */ { 0, 0, 0, 0, 0 },
/* U+7dcf */ { 0, 0, 0, 0, 0 },
/* U+7dd0 */ { 0, 0, 0, 0, 0 },
/* U+7dd1 */ { 0, 0, 0, 0, 0 },
/* U+7dd2 */ { 0, 0, 0, 0, 0 },
/* U+7dd3 */ { 0, 0, 0, 0, 0 },
/* U+7dd4 */ { 0, 0, 0, 0, 0 },
/* U+7dd5 */ { 0, 0, 0, 0, 0 },
/* U+7dd6 */ { 0, 0, 0, 0, 0 },
/* U+7dd7 */ { 0, 0, 0, 0, 0 },
/* U+7dd8 */ { 0, 0, 0, 0, 0 },
/* U+7dd9 */ { 0, 0, 0, 0, 0 },
/* U+7dda */ { 0, 0, 0, 0, 0 },
/* U+7ddb */ { 0, 0, 0, 0, 0 },
/* U+7ddc */ { 0, 0, 0, 0, 0 },
/* U+7ddd */ { 0, 0, 0, 0, 0 },
/* U+7dde */ { 0, 0, 0, 0, 0 },
/* U+7ddf */ { 0, 0, 0, 0, 0 },
/* U+7de0 */ { 0, 0, 0, 0, 0 },
/* U+7de1 */ { 0, 0, 0, 0, 0 },
/* U+7de2 */ { 0, 0, 0, 0, 0 },
/* U+7de3 */ { 0, 0, 0, 0, 0 },
/* U+7de4 */ { 0, 0, 0, 0, 0 },
/* U+7de5 */ { 0, 0, 0, 0, 0 },
/* U+7de6 */ { 0, 0, 0, 0, 0 },
/* U+7de7 */ { 0, 0, 0, 0, 0 },
/* U+7de8 */ { 0, 0, 0, 0, 0 },
/* U+7de9 */ { 0, 0, 0, 0, 0 },
/* U+7dea */ { 0, 0, 0, 0, 0 },
/* U+7deb */ { 0, 0, 0, 0, 0 },
/* U+7dec */ { 0, 0, 0, 0, 0 },
/* U+7ded */ { 0, 0, 0, 0, 0 },
/* U+7dee */ { 0, 0, 0, 0, 0 },
/* U+7def */ { 0, 0, 0, 0, 0 },
/* U+7df0 */ { 0, 0, 0, 0, 0 },
/* U+7df1 */ { 0, 0, 0, 0, 0 },
/* U+7df2 */ { 0, 0, 0, 0, 0 },
/* U+7df3 */ { 0, 0, 0, 0, 0 },
/* U+7df4 */ { 0, 0, 0, 0, 0 },
/* U+7df5 */ { 0, 0, 0, 0, 0 },
/* U+7df6 */ { 0, 0, 0, 0, 0 },
/* U+7df7 */ { 0, 0, 0, 0, 0 },
/* U+7df8 */ { 0, 0, 0, 0, 0 },
/* U+7df9 */ { 0, 0, 0, 0, 0 },
/* U+7dfa */ { 0, 0, 0, 0, 0 },
/* U+7dfb */ { 0, 0, 0, 0, 0 },
/* U+7dfc */ { 0, 0, 0, 0, 0 },
/* U+7dfd */ { 0, 0, 0, 0, 0 },
/* U+7dfe */ { 0, 0, 0, 0, 0 },
/* U+7dff */ { 0, 0, 0, 0, 0 },
/* U+7e00 */ { 0, 0, 0, 0, 0 },
/* U+7e01 */ { 0, 0, 0, 0, 0 },
/* U+7e02 */ { 0, 0, 0, 0, 0 },
/* U+7e03 */ { 0, 0, 0, 0, 0 },
/* U+7e04 */ { 0, 0, 0, 0, 0 },
/* U+7e05 */ { 0, 0, 0, 0, 0 },
/* U+7e06 */ { 0, 0, 0, 0, 0 },
/* U+7e07 */ { 0, 0, 0, 0, 0 },
/* U+7e08 */ { 0, 0, 0, 0, 0 },
/* U+7e09 */ { 0, 0, 0, 0, 0 },
/* U+7e0a */ { 0, 0, 0, 0, 0 },
/* U+7e0b */ { 0, 0, 0, 0, 0 },
/* U+7e0c */ { 0, 0, 0, 0, 0 },
/* U+7e0d */ { 0, 0, 0, 0, 0 },
/* U+7e0e */ { 0, 0, 0, 0, 0 },
/* U+7e0f */ { 0, 0, 0, 0, 0 },
/* U+7e10 */ { 0, 0, 0, 0, 0 },
/* U+7e11 */ { 0, 0, 0, 0, 0 },
/* U+7e12 */ { 0, 0, 0, 0, 0 },
/* U+7e13 */ { 0, 0, 0, 0, 0 },
/* U+7e14 */ { 0, 0, 0, 0, 0 },
/* U+7e15 */ { 0, 0, 0, 0, 0 },
/* U+7e16 */ { 0, 0, 0, 0, 0 },
/* U+7e17 */ { 0, 0, 0, 0, 0 },
/* U+7e18 */ { 0, 0, 0, 0, 0 },
/* U+7e19 */ { 0, 0, 0, 0, 0 },
/* U+7e1a */ { 0, 0, 0, 0, 0 },
/* U+7e1b */ { 0, 0, 0, 0, 0 },
/* U+7e1c */ { 0, 0, 0, 0, 0 },
/* U+7e1d */ { 0, 0, 0, 0, 0 },
/* U+7e1e */ { 0, 0, 0, 0, 0 },
/* U+7e1f */ { 0, 0, 0, 0, 0 },
/* U+7e20 */ { 0, 0, 0, 0, 0 },
/* U+7e21 */ { 0, 0, 0, 0, 0 },
/* U+7e22 */ { 0, 0, 0, 0, 0 },
/* U+7e23 */ { 0, 0, 0, 0, 0 },
/* U+7e24 */ { 0, 0, 0, 0, 0 },
/* U+7e25 */ { 0, 0, 0, 0, 0 },
/* U+7e26 */ { 0, 0, 0, 0, 0 },
/* U+7e27 */ { 0, 0, 0, 0, 0 },
/* U+7e28 */ { 0, 0, 0, 0, 0 },
/* U+7e29 */ { 0, 0, 0, 0, 0 },
/* U+7e2a */ { 0, 0, 0, 0, 0 },
/* U+7e2b */ { 0, 0, 0, 0, 0 },
/* U+7e2c */ { 0, 0, 0, 0, 0 },
/* U+7e2d */ { 0, 0, 0, 0, 0 },
/* U+7e2e */ { 0, 0, 0, 0, 0 },
/* U+7e2f */ { 0, 0, 0, 0, 0 },
/* U+7e30 */ { 0, 0, 0, 0, 0 },
/* U+7e31 */ { 0, 0, 0, 0, 0 },
/* U+7e32 */ { 0, 0, 0, 0, 0 },
/* U+7e33 */ { 0, 0, 0, 0, 0 },
/* U+7e34 */ { 0, 0, 0, 0, 0 },
/* U+7e35 */ { 0, 0, 0, 0, 0 },
/* U+7e36 */ { 0, 0, 0, 0, 0 },
/* U+7e37 */ { 0, 0, 0, 0, 0 },
/* U+7e38 */ { 0, 0, 0, 0, 0 },
/* U+7e39 */ { 0, 0, 0, 0, 0 },
/* U+7e3a */ { 0, 0, 0, 0, 0 },
/* U+7e3b */ { 0, 0, 0, 0, 0 },
/* U+7e3c */ { 0, 0, 0, 0, 0 },
/* U+7e3d */ { 0, 0, 0, 0, 0 },
/* U+7e3e */ { 0, 0, 0, 0, 0 },
/* U+7e3f */ { 0, 0, 0, 0, 0 },
/* U+7e40 */ { 0, 0, 0, 0, 0 },
/* U+7e41 */ { 0, 0, 0, 0, 0 },
/* U+7e42 */ { 0, 0, 0, 0, 0 },
/* U+7e43 */ { 0, 0, 0, 0, 0 },
/* U+7e44 */ { 0, 0, 0, 0, 0 },
/* U+7e45 */ { 0, 0, 0, 0, 0 },
/* U+7e46 */ { 0, 0, 0, 0, 0 },
/* U+7e47 */ { 0, 0, 0, 0, 0 },
/* U+7e48 */ { 0, 0, 0, 0, 0 },
/* U+7e49 */ { 0, 0, 0, 0, 0 },
/* U+7e4a */ { 0, 0, 0, 0, 0 },
/* U+7e4b */ { 0, 0, 0, 0, 0 },
/* U+7e4c */ { 0, 0, 0, 0, 0 },
/* U+7e4d */ { 0, 0, 0, 0, 0 },
/* U+7e4e */ { 0, 0, 0, 0, 0 },
/* U+7e4f */ { 0, 0, 0, 0, 0 },
/* U+7e50 */ { 0, 0, 0, 0, 0 },
/* U+7e51 */ { 0, 0, 0, 0, 0 },
/* U+7e52 */ { 0, 0, 0, 0, 0 },
/* U+7e53 */ { 0, 0, 0, 0, 0 },
/* U+7e54 */ { 0, 0, 0, 0, 0 },
/* U+7e55 */ { 0, 0, 0, 0, 0 },
/* U+7e56 */ { 0, 0, 0, 0, 0 },
/* U+7e57 */ { 0, 0, 0, 0, 0 },
/* U+7e58 */ { 0, 0, 0, 0, 0 },
/* U+7e59 */ { 0, 0, 0, 0, 0 },
/* U+7e5a */ { 0, 0, 0, 0, 0 },
/* U+7e5b */ { 0, 0, 0, 0, 0 },
/* U+7e5c */ { 0, 0, 0, 0, 0 },
/* U+7e5d */ { 0, 0, 0, 0, 0 },
/* U+7e5e */ { 0, 0, 0, 0, 0 },
/* U+7e5f */ { 0, 0, 0, 0, 0 },
/* U+7e60 */ { 0, 0, 0, 0, 0 },
/* U+7e61 */ { 0, 0, 0, 0, 0 },
/* U+7e62 */ { 0, 0, 0, 0, 0 },
/* U+7e63 */ { 0, 0, 0, 0, 0 },
/* U+7e64 */ { 0, 0, 0, 0, 0 },
/* U+7e65 */ { 0, 0, 0, 0, 0 },
/* U+7e66 */ { 0, 0, 0, 0, 0 },
/* U+7e67 */ { 0, 0, 0, 0, 0 },
/* U+7e68 */ { 0, 0, 0, 0, 0 },
/* U+7e69 */ { 0, 0, 0, 0, 0 },
/* U+7e6a */ { 0, 0, 0, 0, 0 },
/* U+7e6b */ { 0, 0, 0, 0, 0 },
/* U+7e6c */ { 0, 0, 0, 0, 0 },
/* U+7e6d */ { 0, 0, 0, 0, 0 },
/* U+7e6e */ { 0, 0, 0, 0, 0 },
/* U+7e6f */ { 0, 0, 0, 0, 0 },
/* U+7e70 */ { 0, 0, 0, 0, 0 },
/* U+7e71 */ { 0, 0, 0, 0, 0 },
/* U+7e72 */ { 0, 0, 0, 0, 0 },
/* U+7e73 */ { 0, 0, 0, 0, 0 },
/* U+7e74 */ { 0, 0, 0, 0, 0 },
/* U+7e75 */ { 0, 0, 0, 0, 0 },
/* U+7e76 */ { 0, 0, 0, 0, 0 },
/* U+7e77 */ { 0, 0, 0, 0, 0 },
/* U+7e78 */ { 0, 0, 0, 0, 0 },
/* U+7e79 */ { 0, 0, 0, 0, 0 },
/* U+7e7a */ { 0, 0, 0, 0, 0 },
/* U+7e7b */ { 0, 0, 0, 0, 0 },
/* U+7e7c */ { 0, 0, 0, 0, 0 },
/* U+7e7d */ { 0, 0, 0, 0, 0 },
/* U+7e7e */ { 0, 0, 0, 0, 0 },
/* U+7e7f */ { 0, 0, 0, 0, 0 },
/* U+7e80 */ { 0, 0, 0, 0, 0 },
/* U+7e81 */ { 0, 0, 0, 0, 0 },
/* U+7e82 */ { 0, 0, 0, 0, 0 },
/* U+7e83 */ { 0, 0, 0, 0, 0 },
/* U+7e84 */ { 0, 0, 0, 0, 0 },
/* U+7e85 */ { 0, 0, 0, 0, 0 },
/* U+7e86 */ { 0, 0, 0, 0, 0 },
/* U+7e87 */ { 0, 0, 0, 0, 0 },
/* U+7e88 */ { 0, 0, 0, 0, 0 },
/* U+7e89 */ { 0, 0, 0, 0, 0 },
/* U+7e8a */ { 0, 0, 0, 0, 0 },
/* U+7e8b */ { 0, 0, 0, 0, 0 },
/* U+7e8c */ { 0, 0, 0, 0, 0 },
/* U+7e8d */ { 0, 0, 0, 0, 0 },
/* U+7e8e */ { 0, 0, 0, 0, 0 },
/* U+7e8f */ { 0, 0, 0, 0, 0 },
/* U+7e90 */ { 0, 0, 0, 0, 0 },
/* U+7e91 */ { 0, 0, 0, 0, 0 },
/* U+7e92 */ { 0, 0, 0, 0, 0 },
/* U+7e93 */ { 0, 0, 0, 0, 0 },
/* U+7e94 */ { 0, 0, 0, 0, 0 },
/* U+7e95 */ { 0, 0, 0, 0, 0 },
/* U+7e96 */ { 0, 0, 0, 0, 0 },
/* U+7e97 */ { 0, 0, 0, 0, 0 },
/* U+7e98 */ { 0, 0, 0, 0, 0 },
/* U+7e99 */ { 0, 0, 0, 0, 0 },
/* U+7e9a */ { 0, 0, 0, 0, 0 },
/* U+7e9b */ { 0, 0, 0, 0, 0 },
/* U+7e9c */ { 0, 0, 0, 0, 0 },
/* U+7e9d */ { 0, 0, 0, 0, 0 },
/* U+7e9e */ { 0, 0, 0, 0, 0 },
/* U+7e9f */ { 0, 0, 0, 0, 0 },
/* U+7ea0 */ { 0, 0, 0, 0, 0 },
/* U+7ea1 */ { 0, 0, 0, 0, 0 },
/* U+7ea2 */ { 0, 0, 0, 0, 0 },
/* U+7ea3 */ { 0, 0, 0, 0, 0 },
/* U+7ea4 */ { 0, 0, 0, 0, 0 },
/* U+7ea5 */ { 0, 0, 0, 0, 0 },
/* U+7ea6 */ { 0, 0, 0, 0, 0 },
/* U+7ea7 */ { 0, 0, 0, 0, 0 },
/* U+7ea8 */ { 0, 0, 0, 0, 0 },
/* U+7ea9 */ { 0, 0, 0, 0, 0 },
/* U+7eaa */ { 0, 0, 0, 0, 0 },
/* U+7eab */ { 0, 0, 0, 0, 0 },
/* U+7eac */ { 0, 0, 0, 0, 0 },
/* U+7ead */ { 0, 0, 0, 0, 0 },
/* U+7eae */ { 0, 0, 0, 0, 0 },
/* U+7eaf */ { 0, 0, 0, 0, 0 },
/* U+7eb0 */ { 0, 0, 0, 0, 0 },
/* U+7eb1 */ { 0, 0, 0, 0, 0 },
/* U+7eb2 */ { 0, 0, 0, 0, 0 },
/* U+7eb3 */ { 0, 0, 0, 0, 0 },
/* U+7eb4 */ { 0, 0, 0, 0, 0 },
/* U+7eb5 */ { 0, 0, 0, 0, 0 },
/* U+7eb6 */ { 0, 0, 0, 0, 0 },
/* U+7eb7 */ { 0, 0, 0, 0, 0 },
/* U+7eb8 */ { 0, 0, 0, 0, 0 },
/* U+7eb9 */ { 0, 0, 0, 0, 0 },
/* U+7eba */ { 0, 0, 0, 0, 0 },
/* U+7ebb */ { 0, 0, 0, 0, 0 },
/* U+7ebc */ { 0, 0, 0, 0, 0 },
/* U+7ebd */ { 0, 0, 0, 0, 0 },
/* U+7ebe */ { 0, 0, 0, 0, 0 },
/* U+7ebf */ { 0, 0, 0, 0, 0 },
/* U+7ec0 */ { 0, 0, 0, 0, 0 },
/* U+7ec1 */ { 0, 0, 0, 0, 0 },
/* U+7ec2 */ { 0, 0, 0, 0, 0 },
/* U+7ec3 */ { 0, 0, 0, 0, 0 },
/* U+7ec4 */ { 0, 0, 0, 0, 0 },
/* U+7ec5 */ { 0, 0, 0, 0, 0 },
/* U+7ec6 */ { 0, 0, 0, 0, 0 },
/* U+7ec7 */ { 0, 0, 0, 0, 0 },
/* U+7ec8 */ { 0, 0, 0, 0, 0 },
/* U+7ec9 */ { 0, 0, 0, 0, 0 },
/* U+7eca */ { 0, 0, 0, 0, 0 },
/* U+7ecb */ { 0, 0, 0, 0, 0 },
/* U+7ecc */ { 0, 0, 0, 0, 0 },
/* U+7ecd */ { 0, 0, 0, 0, 0 },
/* U+7ece */ { 0, 0, 0, 0, 0 },
/* U+7ecf */ { 0, 0, 0, 0, 0 },
/* U+7ed0 */ { 0, 0, 0, 0, 0 },
/* U+7ed1 */ { 0, 0, 0, 0, 0 },
/* U+7ed2 */ { 0, 0, 0, 0, 0 },
/* U+7ed3 */ { 0, 0, 0, 0, 0 },
/* U+7ed4 */ { 0, 0, 0, 0, 0 },
/* U+7ed5 */ { 0, 0, 0, 0, 0 },
/* U+7ed6 */ { 0, 0, 0, 0, 0 },
/* U+7ed7 */ { 0, 0, 0, 0, 0 },
/* U+7ed8 */ { 0, 0, 0, 0, 0 },
/* U+7ed9 */ { 0, 0, 0, 0, 0 },
/* U+7eda */ { 0, 0, 0, 0, 0 },
/* U+7edb */ { 0, 0, 0, 0, 0 },
/* U+7edc */ { 0, 0, 0, 0, 0 },
/* U+7edd */ { 0, 0, 0, 0, 0 },
/* U+7ede */ { 0, 0, 0, 0, 0 },
/* U+7edf */ { 0, 0, 0, 0, 0 },
/* U+7ee0 */ { 0, 0, 0, 0, 0 },
/* U+7ee1 */ { 0, 0, 0, 0, 0 },
/* U+7ee2 */ { 0, 0, 0, 0, 0 },
/* U+7ee3 */ { 0, 0, 0, 0, 0 },
/* U+7ee4 */ { 0, 0, 0, 0, 0 },
/* U+7ee5 */ { 0, 0, 0, 0, 0 },
/* U+7ee6 */ { 0, 0, 0, 0, 0 },
/* U+7ee7 */ { 0, 0, 0, 0, 0 },
/* U+7ee8 */ { 0, 0, 0, 0, 0 },
/* U+7ee9 */ { 0, 0, 0, 0, 0 },
/* U+7eea */ { 0, 0, 0, 0, 0 },
/* U+7eeb */ { 0, 0, 0, 0, 0 },
/* U+7eec */ { 0, 0, 0, 0, 0 },
/* U+7eed */ { 0, 0, 0, 0, 0 },
/* U+7eee */ { 0, 0, 0, 0, 0 },
/* U+7eef */ { 0, 0, 0, 0, 0 },
/* U+7ef0 */ { 0, 0, 0, 0, 0 },
/* U+7ef1 */ { 0, 0, 0, 0, 0 },
/* U+7ef2 */ { 0, 0, 0, 0, 0 },
/* U+7ef3 */ { 0, 0, 0, 0, 0 },
/* U+7ef4 */ { 0, 0, 0, 0, 0 },
/* U+7ef5 */ { 0, 0, 0, 0, 0 },
/* U+7ef6 */ { 0, 0, 0, 0, 0 },
/* U+7ef7 */ { 0, 0, 0, 0, 0 },
/* U+7ef8 */ { 0, 0, 0, 0, 0 },
/* U+7ef9 */ { 0, 0, 0, 0, 0 },
/* U+7efa */ { 0, 0, 0, 0, 0 },
/* U+7efb */ { 0, 0, 0, 0, 0 },
/* U+7efc */ { 0, 0, 0, 0, 0 },
/* U+7efd */ { 0, 0, 0, 0, 0 },
/* U+7efe */ { 0, 0, 0, 0, 0 },
/* U+7eff */ { 0, 0, 0, 0, 0 },
/* U+7f00 */ { 0, 0, 0, 0, 0 },
/* U+7f01 */ { 0, 0, 0, 0, 0 },
/* U+7f02 */ { 0, 0, 0, 0, 0 },
/* U+7f03 */ { 0, 0, 0, 0, 0 },
/* U+7f04 */ { 0, 0, 0, 0, 0 },
/* U+7f05 */ { 0, 0, 0, 0, 0 },
/* U+7f06 */ { 0, 0, 0, 0, 0 },
/* U+7f07 */ { 0, 0, 0, 0, 0 },
/* U+7f08 */ { 0, 0, 0, 0, 0 },
/* U+7f09 */ { 0, 0, 0, 0, 0 },
/* U+7f0a */ { 0, 0, 0, 0, 0 },
/* U+7f0b */ { 0, 0, 0, 0, 0 },
/* U+7f0c */ { 0, 0, 0, 0, 0 },
/* U+7f0d */ { 0, 0, 0, 0, 0 },
/* U+7f0e */ { 0, 0, 0, 0, 0 },
/* U+7f0f */ { 0, 0, 0, 0, 0 },
/* U+7f10 */ { 0, 0, 0, 0, 0 },
/* U+7f11 */ { 0, 0, 0, 0, 0 },
/* U+7f12 */ { 0, 0, 0, 0, 0 },
/* U+7f13 */ { 0, 0, 0, 0, 0 },
/* U+7f14 */ { 0, 0, 0, 0, 0 },
/* U+7f15 */ { 0, 0, 0, 0, 0 },
/* U+7f16 */ { 0, 0, 0, 0, 0 },
/* U+7f17 */ { 0, 0, 0, 0, 0 },
/* U+7f18 */ { 0, 0, 0, 0, 0 },
/* U+7f19 */ { 0, 0, 0, 0, 0 },
/* U+7f1a */ { 0, 0, 0, 0, 0 },
/* U+7f1b */ { 0, 0, 0, 0, 0 },
/* U+7f1c */ { 0, 0, 0, 0, 0 },
/* U+7f1d */ { 0, 0, 0, 0, 0 },
/* U+7f1e */ { 0, 0, 0, 0, 0 },
/* U+7f1f */ { 0, 0, 0, 0, 0 },
/* U+7f20 */ { 0, 0, 0, 0, 0 },
/* U+7f21 */ { 0, 0, 0, 0, 0 },
/* U+7f22 */ { 0, 0, 0, 0, 0 },
/* U+7f23 */ { 0, 0, 0, 0, 0 },
/* U+7f24 */ { 0, 0, 0, 0, 0 },
/* U+7f25 */ { 0, 0, 0, 0, 0 },
/* U+7f26 */ { 0, 0, 0, 0, 0 },
/* U+7f27 */ { 0, 0, 0, 0, 0 },
/* U+7f28 */ { 0, 0, 0, 0, 0 },
/* U+7f29 */ { 0, 0, 0, 0, 0 },
/* U+7f2a */ { 0, 0, 0, 0, 0 },
/* U+7f2b */ { 0, 0, 0, 0, 0 },
/* U+7f2c */ { 0, 0, 0, 0, 0 },
/* U+7f2d */ { 0, 0, 0, 0, 0 },
/* U+7f2e */ { 0, 0, 0, 0, 0 },
/* U+7f2f */ { 0, 0, 0, 0, 0 },
/* U+7f30 */ { 0, 0, 0, 0, 0 },
/* U+7f31 */ { 0, 0, 0, 0, 0 },
/* U+7f32 */ { 0, 0, 0, 0, 0 },
/* U+7f33 */ { 0, 0, 0, 0, 0 },
/* U+7f34 */ { 0, 0, 0, 0, 0 },
/* U+7f35 */ { 0, 0, 0, 0, 0 },
/* U+7f36 */ { 0, 0, 0, 0, 0 },
/* U+7f37 */ { 0, 0, 0, 0, 0 },
/* U+7f38 */ { 0, 0, 0, 0, 0 },
/* U+7f39 */ { 0, 0, 0, 0, 0 },
/* U+7f3a */ { 0, 0, 0, 0, 0 },
/* U+7f3b */ { 0, 0, 0, 0, 0 },
/* U+7f3c */ { 0, 0, 0, 0, 0 },
/* U+7f3d */ { 0, 0, 0, 0, 0 },
/* U+7f3e */ { 0, 0, 0, 0, 0 },
/* U+7f3f */ { 0, 0, 0, 0, 0 },
/* U+7f40 */ { 0, 0, 0, 0, 0 },
/* U+7f41 */ { 0, 0, 0, 0, 0 },
/* U+7f42 */ { 0, 0, 0, 0, 0 },
/* U+7f43 */ { 0, 0, 0, 0, 0 },
/* U+7f44 */ { 0, 0, 0, 0, 0 },
/* U+7f45 */ { 0, 0, 0, 0, 0 },
/* U+7f46 */ { 0, 0, 0, 0, 0 },
/* U+7f47 */ { 0, 0, 0, 0, 0 },
/* U+7f48 */ { 0, 0, 0, 0, 0 },
/* U+7f49 */ { 0, 0, 0, 0, 0 },
/* U+7f4a */ { 0, 0, 0, 0, 0 },
/* U+7f4b */ { 0, 0, 0, 0, 0 },
/* U+7f4c */ { 0, 0, 0, 0, 0 },
/* U+7f4d */ { 0, 0, 0, 0, 0 },
/* U+7f4e */ { 0, 0, 0, 0, 0 },
/* U+7f4f */ { 0, 0, 0, 0, 0 },
/* U+7f50 */ { 0, 0, 0, 0, 0 },
/* U+7f51 */ { 0, 0, 0, 0, 0 },
/* U+7f52 */ { 0, 0, 0, 0, 0 },
/* U+7f53 */ { 0, 0, 0, 0, 0 },
/* U+7f54 */ { 0, 0, 0, 0, 0 },
/* U+7f55 */ { 0, 0, 0, 0, 0 },
/* U+7f56 */ { 0, 0, 0, 0, 0 },
/* U+7f57 */ { 0, 0, 0, 0, 0 },
/* U+7f58 */ { 0, 0, 0, 0, 0 },
/* U+7f59 */ { 0, 0, 0, 0, 0 },
/* U+7f5a */ { 0, 0, 0, 0, 0 },
/* U+7f5b */ { 0, 0, 0, 0, 0 },
/* U+7f5c */ { 0, 0, 0, 0, 0 },
/* U+7f5d */ { 0, 0, 0, 0, 0 },
/* U+7f5e */ { 0, 0, 0, 0, 0 },
/* U+7f5f */ { 0, 0, 0, 0, 0 },
/* U+7f60 */ { 0, 0, 0, 0, 0 },
/* U+7f61 */ { 0, 0, 0, 0, 0 },
/* U+7f62 */ { 0, 0, 0, 0, 0 },
/* U+7f63 */ { 0, 0, 0, 0, 0 },
/* U+7f64 */ { 0, 0, 0, 0, 0 },
/* U+7f65 */ { 0, 0, 0, 0, 0 },
/* U+7f66 */ { 0, 0, 0, 0, 0 },
/* U+7f67 */ { 0, 0, 0, 0, 0 },
/* U+7f68 */ { 0, 0, 0, 0, 0 },
/* U+7f69 */ { 0, 0, 0, 0, 0 },
/* U+7f6a */ { 0, 0, 0, 0, 0 },
/* U+7f6b */ { 0, 0, 0, 0, 0 },
/* U+7f6c */ { 0, 0, 0, 0, 0 },
/* U+7f6d */ { 0, 0, 0, 0, 0 },
/* U+7f6e */ { 0, 0, 0, 0, 0 },
/* U+7f6f */ { 0, 0, 0, 0, 0 },
/* U+7f70 */ { 0, 0, 0, 0, 0 },
/* U+7f71 */ { 0, 0, 0, 0, 0 },
/* U+7f72 */ { 0, 0, 0, 0, 0 },
/* U+7f73 */ { 0, 0, 0, 0, 0 },
/* U+7f74 */ { 0, 0, 0, 0, 0 },
/* U+7f75 */ { 0, 0, 0, 0, 0 },
/* U+7f76 */ { 0, 0, 0, 0, 0 },
/* U+7f77 */ { 0, 0, 0, 0, 0 },
/* U+7f78 */ { 0, 0, 0, 0, 0 },
/* U+7f79 */ { 0, 0, 0, 0, 0 },
/* U+7f7a */ { 0, 0, 0, 0, 0 },
/* U+7f7b */ { 0, 0, 0, 0, 0 },
/* U+7f7c */ { 0, 0, 0, 0, 0 },
/* U+7f7d */ { 0, 0, 0, 0, 0 },
/* U+7f7e */ { 0, 0, 0, 0, 0 },
/* U+7f7f */ { 0, 0, 0, 0, 0 },
/* U+7f80 */ { 0, 0, 0, 0, 0 },
/* U+7f81 */ { 0, 0, 0, 0, 0 },
/* U+7f82 */ { 0, 0, 0, 0, 0 },
/* U+7f83 */ { 0, 0, 0, 0, 0 },
/* U+7f84 */ { 0, 0, 0, 0, 0 },
/* U+7f85 */ { 0, 0, 0, 0, 0 },
/* U+7f86 */ { 0, 0, 0, 0, 0 },
/* U+7f87 */ { 0, 0, 0, 0, 0 },
/* U+7f88 */ { 0, 0, 0, 0, 0 },
/* U+7f89 */ { 0, 0, 0, 0, 0 },
/* U+7f8a */ { 0, 0, 0, 0, 0 },
/* U+7f8b */ { 0, 0, 0, 0, 0 },
/* U+7f8c */ { 0, 0, 0, 0, 0 },
/* U+7f8d */ { 0, 0, 0, 0, 0 },
/* U+7f8e */ { 0, 0, 0, 0, 0 },
/* U+7f8f */ { 0, 0, 0, 0, 0 },
/* U+7f90 */ { 0, 0, 0, 0, 0 },
/* U+7f91 */ { 0, 0, 0, 0, 0 },
/* U+7f92 */ { 0, 0, 0, 0, 0 },
/* U+7f93 */ { 0, 0, 0, 0, 0 },
/* U+7f94 */ { 0, 0, 0, 0, 0 },
/* U+7f95 */ { 0, 0, 0, 0, 0 },
/* U+7f96 */ { 0, 0, 0, 0, 0 },
/* U+7f97 */ { 0, 0, 0, 0, 0 },
/* U+7f98 */ { 0, 0, 0, 0, 0 },
/* U+7f99 */ { 0, 0, 0, 0, 0 },
/* U+7f9a */ { 0, 0, 0, 0, 0 },
/* U+7f9b */ { 0, 0, 0, 0, 0 },
/* U+7f9c */ { 0, 0, 0, 0, 0 },
/* U+7f9d */ { 0, 0, 0, 0, 0 },
/* U+7f9e */ { 0, 0, 0, 0, 0 },
/* U+7f9f */ { 0, 0, 0, 0, 0 },
/* U+7fa0 */ { 0, 0, 0, 0, 0 },
/* U+7fa1 */ { 0, 0, 0, 0, 0 },
/* U+7fa2 */ { 0, 0, 0, 0, 0 },
/* U+7fa3 */ { 0, 0, 0, 0, 0 },
/* U+7fa4 */ { 0, 0, 0, 0, 0 },
/* U+7fa5 */ { 0, 0, 0, 0, 0 },
/* U+7fa6 */ { 0, 0, 0, 0, 0 },
/* U+7fa7 */ { 0, 0, 0, 0, 0 },
/* U+7fa8 */ { 0, 0, 0, 0, 0 },
/* U+7fa9 */ { 0, 0, 0, 0, 0 },
/* U+7faa */ { 0, 0, 0, 0, 0 },
/* U+7fab */ { 0, 0, 0, 0, 0 },
/* U+7fac */ { 0, 0, 0, 0, 0 },
/* U+7fad */ { 0, 0, 0, 0, 0 },
/* U+7fae */ { 0, 0, 0, 0, 0 },
/* U+7faf */ { 0, 0, 0, 0, 0 },
/* U+7fb0 */ { 0, 0, 0, 0, 0 },
/* U+7fb1 */ { 0, 0, 0, 0, 0 },
/* U+7fb2 */ { 0, 0, 0, 0, 0 },
/* U+7fb3 */ { 0, 0, 0, 0, 0 },
/* U+7fb4 */ { 0, 0, 0, 0, 0 },
/* U+7fb5 */ { 0, 0, 0, 0, 0 },
/* U+7fb6 */ { 0, 0, 0, 0, 0 },
/* U+7fb7 */ { 0, 0, 0, 0, 0 },
/* U+7fb8 */ { 0, 0, 0, 0, 0 },
/* U+7fb9 */ { 0, 0, 0, 0, 0 },
/* U+7fba */ { 0, 0, 0, 0, 0 },
/* U+7fbb */ { 0, 0, 0, 0, 0 },
/* U+7fbc */ { 0, 0, 0, 0, 0 },
/* U+7fbd */ { 0, 0, 0, 0, 0 },
/* U+7fbe */ { 0, 0, 0, 0, 0 },
/* U+7fbf */ { 0, 0, 0, 0, 0 },
/* U+7fc0 */ { 0, 0, 0, 0, 0 },
/* U+7fc1 */ { 0, 0, 0, 0, 0 },
/* U+7fc2 */ { 0, 0, 0, 0, 0 },
/* U+7fc3 */ { 0, 0, 0, 0, 0 },
/* U+7fc4 */ { 0, 0, 0, 0, 0 },
/* U+7fc5 */ { 0, 0, 0, 0, 0 },
/* U+7fc6 */ { 0, 0, 0, 0, 0 },
/* U+7fc7 */ { 0, 0, 0, 0, 0 },
/* U+7fc8 */ { 0, 0, 0, 0, 0 },
/* U+7fc9 */ { 0, 0, 0, 0, 0 },
/* U+7fca */ { 0, 0, 0, 0, 0 },
/* U+7fcb */ { 0, 0, 0, 0, 0 },
/* U+7fcc */ { 0, 0, 0, 0, 0 },
/* U+7fcd */ { 0, 0, 0, 0, 0 },
/* U+7fce */ { 0, 0, 0, 0, 0 },
/* U+7fcf */ { 0, 0, 0, 0, 0 },
/* U+7fd0 */ { 0, 0, 0, 0, 0 },
/* U+7fd1 */ { 0, 0, 0, 0, 0 },
/* U+7fd2 */ { 0, 0, 0, 0, 0 },
/* U+7fd3 */ { 0, 0, 0, 0, 0 },
/* U+7fd4 */ { 0, 0, 0, 0, 0 },
/* U+7fd5 */ { 0, 0, 0, 0, 0 },
/* U+7fd6 */ { 0, 0, 0, 0, 0 },
/* U+7fd7 */ { 0, 0, 0, 0, 0 },
/* U+7fd8 */ { 0, 0, 0, 0, 0 },
/* U+7fd9 */ { 0, 0, 0, 0, 0 },
/* U+7fda */ { 0, 0, 0, 0, 0 },
/* U+7fdb */ { 0, 0, 0, 0, 0 },
/* U+7fdc */ { 0, 0, 0, 0, 0 },
/* U+7fdd */ { 0, 0, 0, 0, 0 },
/* U+7fde */ { 0, 0, 0, 0, 0 },
/* U+7fdf */ { 0, 0, 0, 0, 0 },
/* U+7fe0 */ { 0, 0, 0, 0, 0 },
/* U+7fe1 */ { 0, 0, 0, 0, 0 },
/* U+7fe2 */ { 0, 0, 0, 0, 0 },
/* U+7fe3 */ { 0, 0, 0, 0, 0 },
/* U+7fe4 */ { 0, 0, 0, 0, 0 },
/* U+7fe5 */ { 0, 0, 0, 0, 0 },
/* U+7fe6 */ { 0, 0, 0, 0, 0 },
/* U+7fe7 */ { 0, 0, 0, 0, 0 },
/* U+7fe8 */ { 0, 0, 0, 0, 0 },
/* U+7fe9 */ { 0, 0, 0, 0, 0 },
/* U+7fea */ { 0, 0, 0, 0, 0 },
/* U+7feb */ { 0, 0, 0, 0, 0 },
/* U+7fec */ { 0, 0, 0, 0, 0 },
/* U+7fed */ { 0, 0, 0, 0, 0 },
/* U+7fee */ { 0, 0, 0, 0, 0 },
/* U+7fef */ { 0, 0, 0, 0, 0 },
/* U+7ff0 */ { 0, 0, 0, 0, 0 },
/* U+7ff1 */ { 0, 0, 0, 0, 0 },
/* U+7ff2 */ { 0, 0, 0, 0, 0 },
/* U+7ff3 */ { 0, 0, 0, 0, 0 },
/* U+7ff4 */ { 0, 0, 0, 0, 0 },
/* U+7ff5 */ { 0, 0, 0, 0, 0 },
/* U+7ff6 */ { 0, 0, 0, 0, 0 },
/* U+7ff7 */ { 0, 0, 0, 0, 0 },
/* U+7ff8 */ { 0, 0, 0, 0, 0 },
/* U+7ff9 */ { 0, 0, 0, 0, 0 },
/* U+7ffa */ { 0, 0, 0, 0, 0 },
/* U+7ffb */ { 0, 0, 0, 0, 0 },
/* U+7ffc */ { 0, 0, 0, 0, 0 },
/* U+7ffd */ { 0, 0, 0, 0, 0 },
/* U+7ffe */ { 0, 0, 0, 0, 0 },
/* U+7fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_8[4096] = {
    
/* U+8000 */ { 0, 0, 0, 0, 0 },
/* U+8001 */ { 0, 0, 0, 0, 0 },
/* U+8002 */ { 0, 0, 0, 0, 0 },
/* U+8003 */ { 0, 0, 0, 0, 0 },
/* U+8004 */ { 0, 0, 0, 0, 0 },
/* U+8005 */ { 0, 0, 0, 0, 0 },
/* U+8006 */ { 0, 0, 0, 0, 0 },
/* U+8007 */ { 0, 0, 0, 0, 0 },
/* U+8008 */ { 0, 0, 0, 0, 0 },
/* U+8009 */ { 0, 0, 0, 0, 0 },
/* U+800a */ { 0, 0, 0, 0, 0 },
/* U+800b */ { 0, 0, 0, 0, 0 },
/* U+800c */ { 0, 0, 0, 0, 0 },
/* U+800d */ { 0, 0, 0, 0, 0 },
/* U+800e */ { 0, 0, 0, 0, 0 },
/* U+800f */ { 0, 0, 0, 0, 0 },
/* U+8010 */ { 0, 0, 0, 0, 0 },
/* U+8011 */ { 0, 0, 0, 0, 0 },
/* U+8012 */ { 0, 0, 0, 0, 0 },
/* U+8013 */ { 0, 0, 0, 0, 0 },
/* U+8014 */ { 0, 0, 0, 0, 0 },
/* U+8015 */ { 0, 0, 0, 0, 0 },
/* U+8016 */ { 0, 0, 0, 0, 0 },
/* U+8017 */ { 0, 0, 0, 0, 0 },
/* U+8018 */ { 0, 0, 0, 0, 0 },
/* U+8019 */ { 0, 0, 0, 0, 0 },
/* U+801a */ { 0, 0, 0, 0, 0 },
/* U+801b */ { 0, 0, 0, 0, 0 },
/* U+801c */ { 0, 0, 0, 0, 0 },
/* U+801d */ { 0, 0, 0, 0, 0 },
/* U+801e */ { 0, 0, 0, 0, 0 },
/* U+801f */ { 0, 0, 0, 0, 0 },
/* U+8020 */ { 0, 0, 0, 0, 0 },
/* U+8021 */ { 0, 0, 0, 0, 0 },
/* U+8022 */ { 0, 0, 0, 0, 0 },
/* U+8023 */ { 0, 0, 0, 0, 0 },
/* U+8024 */ { 0, 0, 0, 0, 0 },
/* U+8025 */ { 0, 0, 0, 0, 0 },
/* U+8026 */ { 0, 0, 0, 0, 0 },
/* U+8027 */ { 0, 0, 0, 0, 0 },
/* U+8028 */ { 0, 0, 0, 0, 0 },
/* U+8029 */ { 0, 0, 0, 0, 0 },
/* U+802a */ { 0, 0, 0, 0, 0 },
/* U+802b */ { 0, 0, 0, 0, 0 },
/* U+802c */ { 0, 0, 0, 0, 0 },
/* U+802d */ { 0, 0, 0, 0, 0 },
/* U+802e */ { 0, 0, 0, 0, 0 },
/* U+802f */ { 0, 0, 0, 0, 0 },
/* U+8030 */ { 0, 0, 0, 0, 0 },
/* U+8031 */ { 0, 0, 0, 0, 0 },
/* U+8032 */ { 0, 0, 0, 0, 0 },
/* U+8033 */ { 0, 0, 0, 0, 0 },
/* U+8034 */ { 0, 0, 0, 0, 0 },
/* U+8035 */ { 0, 0, 0, 0, 0 },
/* U+8036 */ { 0, 0, 0, 0, 0 },
/* U+8037 */ { 0, 0, 0, 0, 0 },
/* U+8038 */ { 0, 0, 0, 0, 0 },
/* U+8039 */ { 0, 0, 0, 0, 0 },
/* U+803a */ { 0, 0, 0, 0, 0 },
/* U+803b */ { 0, 0, 0, 0, 0 },
/* U+803c */ { 0, 0, 0, 0, 0 },
/* U+803d */ { 0, 0, 0, 0, 0 },
/* U+803e */ { 0, 0, 0, 0, 0 },
/* U+803f */ { 0, 0, 0, 0, 0 },
/* U+8040 */ { 0, 0, 0, 0, 0 },
/* U+8041 */ { 0, 0, 0, 0, 0 },
/* U+8042 */ { 0, 0, 0, 0, 0 },
/* U+8043 */ { 0, 0, 0, 0, 0 },
/* U+8044 */ { 0, 0, 0, 0, 0 },
/* U+8045 */ { 0, 0, 0, 0, 0 },
/* U+8046 */ { 0, 0, 0, 0, 0 },
/* U+8047 */ { 0, 0, 0, 0, 0 },
/* U+8048 */ { 0, 0, 0, 0, 0 },
/* U+8049 */ { 0, 0, 0, 0, 0 },
/* U+804a */ { 0, 0, 0, 0, 0 },
/* U+804b */ { 0, 0, 0, 0, 0 },
/* U+804c */ { 0, 0, 0, 0, 0 },
/* U+804d */ { 0, 0, 0, 0, 0 },
/* U+804e */ { 0, 0, 0, 0, 0 },
/* U+804f */ { 0, 0, 0, 0, 0 },
/* U+8050 */ { 0, 0, 0, 0, 0 },
/* U+8051 */ { 0, 0, 0, 0, 0 },
/* U+8052 */ { 0, 0, 0, 0, 0 },
/* U+8053 */ { 0, 0, 0, 0, 0 },
/* U+8054 */ { 0, 0, 0, 0, 0 },
/* U+8055 */ { 0, 0, 0, 0, 0 },
/* U+8056 */ { 0, 0, 0, 0, 0 },
/* U+8057 */ { 0, 0, 0, 0, 0 },
/* U+8058 */ { 0, 0, 0, 0, 0 },
/* U+8059 */ { 0, 0, 0, 0, 0 },
/* U+805a */ { 0, 0, 0, 0, 0 },
/* U+805b */ { 0, 0, 0, 0, 0 },
/* U+805c */ { 0, 0, 0, 0, 0 },
/* U+805d */ { 0, 0, 0, 0, 0 },
/* U+805e */ { 0, 0, 0, 0, 0 },
/* U+805f */ { 0, 0, 0, 0, 0 },
/* U+8060 */ { 0, 0, 0, 0, 0 },
/* U+8061 */ { 0, 0, 0, 0, 0 },
/* U+8062 */ { 0, 0, 0, 0, 0 },
/* U+8063 */ { 0, 0, 0, 0, 0 },
/* U+8064 */ { 0, 0, 0, 0, 0 },
/* U+8065 */ { 0, 0, 0, 0, 0 },
/* U+8066 */ { 0, 0, 0, 0, 0 },
/* U+8067 */ { 0, 0, 0, 0, 0 },
/* U+8068 */ { 0, 0, 0, 0, 0 },
/* U+8069 */ { 0, 0, 0, 0, 0 },
/* U+806a */ { 0, 0, 0, 0, 0 },
/* U+806b */ { 0, 0, 0, 0, 0 },
/* U+806c */ { 0, 0, 0, 0, 0 },
/* U+806d */ { 0, 0, 0, 0, 0 },
/* U+806e */ { 0, 0, 0, 0, 0 },
/* U+806f */ { 0, 0, 0, 0, 0 },
/* U+8070 */ { 0, 0, 0, 0, 0 },
/* U+8071 */ { 0, 0, 0, 0, 0 },
/* U+8072 */ { 0, 0, 0, 0, 0 },
/* U+8073 */ { 0, 0, 0, 0, 0 },
/* U+8074 */ { 0, 0, 0, 0, 0 },
/* U+8075 */ { 0, 0, 0, 0, 0 },
/* U+8076 */ { 0, 0, 0, 0, 0 },
/* U+8077 */ { 0, 0, 0, 0, 0 },
/* U+8078 */ { 0, 0, 0, 0, 0 },
/* U+8079 */ { 0, 0, 0, 0, 0 },
/* U+807a */ { 0, 0, 0, 0, 0 },
/* U+807b */ { 0, 0, 0, 0, 0 },
/* U+807c */ { 0, 0, 0, 0, 0 },
/* U+807d */ { 0, 0, 0, 0, 0 },
/* U+807e */ { 0, 0, 0, 0, 0 },
/* U+807f */ { 0, 0, 0, 0, 0 },
/* U+8080 */ { 0, 0, 0, 0, 0 },
/* U+8081 */ { 0, 0, 0, 0, 0 },
/* U+8082 */ { 0, 0, 0, 0, 0 },
/* U+8083 */ { 0, 0, 0, 0, 0 },
/* U+8084 */ { 0, 0, 0, 0, 0 },
/* U+8085 */ { 0, 0, 0, 0, 0 },
/* U+8086 */ { 0, 0, 0, 0, 0 },
/* U+8087 */ { 0, 0, 0, 0, 0 },
/* U+8088 */ { 0, 0, 0, 0, 0 },
/* U+8089 */ { 0, 0, 0, 0, 0 },
/* U+808a */ { 0, 0, 0, 0, 0 },
/* U+808b */ { 0, 0, 0, 0, 0 },
/* U+808c */ { 0, 0, 0, 0, 0 },
/* U+808d */ { 0, 0, 0, 0, 0 },
/* U+808e */ { 0, 0, 0, 0, 0 },
/* U+808f */ { 0, 0, 0, 0, 0 },
/* U+8090 */ { 0, 0, 0, 0, 0 },
/* U+8091 */ { 0, 0, 0, 0, 0 },
/* U+8092 */ { 0, 0, 0, 0, 0 },
/* U+8093 */ { 0, 0, 0, 0, 0 },
/* U+8094 */ { 0, 0, 0, 0, 0 },
/* U+8095 */ { 0, 0, 0, 0, 0 },
/* U+8096 */ { 0, 0, 0, 0, 0 },
/* U+8097 */ { 0, 0, 0, 0, 0 },
/* U+8098 */ { 0, 0, 0, 0, 0 },
/* U+8099 */ { 0, 0, 0, 0, 0 },
/* U+809a */ { 0, 0, 0, 0, 0 },
/* U+809b */ { 0, 0, 0, 0, 0 },
/* U+809c */ { 0, 0, 0, 0, 0 },
/* U+809d */ { 0, 0, 0, 0, 0 },
/* U+809e */ { 0, 0, 0, 0, 0 },
/* U+809f */ { 0, 0, 0, 0, 0 },
/* U+80a0 */ { 0, 0, 0, 0, 0 },
/* U+80a1 */ { 0, 0, 0, 0, 0 },
/* U+80a2 */ { 0, 0, 0, 0, 0 },
/* U+80a3 */ { 0, 0, 0, 0, 0 },
/* U+80a4 */ { 0, 0, 0, 0, 0 },
/* U+80a5 */ { 0, 0, 0, 0, 0 },
/* U+80a6 */ { 0, 0, 0, 0, 0 },
/* U+80a7 */ { 0, 0, 0, 0, 0 },
/* U+80a8 */ { 0, 0, 0, 0, 0 },
/* U+80a9 */ { 0, 0, 0, 0, 0 },
/* U+80aa */ { 0, 0, 0, 0, 0 },
/* U+80ab */ { 0, 0, 0, 0, 0 },
/* U+80ac */ { 0, 0, 0, 0, 0 },
/* U+80ad */ { 0, 0, 0, 0, 0 },
/* U+80ae */ { 0, 0, 0, 0, 0 },
/* U+80af */ { 0, 0, 0, 0, 0 },
/* U+80b0 */ { 0, 0, 0, 0, 0 },
/* U+80b1 */ { 0, 0, 0, 0, 0 },
/* U+80b2 */ { 0, 0, 0, 0, 0 },
/* U+80b3 */ { 0, 0, 0, 0, 0 },
/* U+80b4 */ { 0, 0, 0, 0, 0 },
/* U+80b5 */ { 0, 0, 0, 0, 0 },
/* U+80b6 */ { 0, 0, 0, 0, 0 },
/* U+80b7 */ { 0, 0, 0, 0, 0 },
/* U+80b8 */ { 0, 0, 0, 0, 0 },
/* U+80b9 */ { 0, 0, 0, 0, 0 },
/* U+80ba */ { 0, 0, 0, 0, 0 },
/* U+80bb */ { 0, 0, 0, 0, 0 },
/* U+80bc */ { 0, 0, 0, 0, 0 },
/* U+80bd */ { 0, 0, 0, 0, 0 },
/* U+80be */ { 0, 0, 0, 0, 0 },
/* U+80bf */ { 0, 0, 0, 0, 0 },
/* U+80c0 */ { 0, 0, 0, 0, 0 },
/* U+80c1 */ { 0, 0, 0, 0, 0 },
/* U+80c2 */ { 0, 0, 0, 0, 0 },
/* U+80c3 */ { 0, 0, 0, 0, 0 },
/* U+80c4 */ { 0, 0, 0, 0, 0 },
/* U+80c5 */ { 0, 0, 0, 0, 0 },
/* U+80c6 */ { 0, 0, 0, 0, 0 },
/* U+80c7 */ { 0, 0, 0, 0, 0 },
/* U+80c8 */ { 0, 0, 0, 0, 0 },
/* U+80c9 */ { 0, 0, 0, 0, 0 },
/* U+80ca */ { 0, 0, 0, 0, 0 },
/* U+80cb */ { 0, 0, 0, 0, 0 },
/* U+80cc */ { 0, 0, 0, 0, 0 },
/* U+80cd */ { 0, 0, 0, 0, 0 },
/* U+80ce */ { 0, 0, 0, 0, 0 },
/* U+80cf */ { 0, 0, 0, 0, 0 },
/* U+80d0 */ { 0, 0, 0, 0, 0 },
/* U+80d1 */ { 0, 0, 0, 0, 0 },
/* U+80d2 */ { 0, 0, 0, 0, 0 },
/* U+80d3 */ { 0, 0, 0, 0, 0 },
/* U+80d4 */ { 0, 0, 0, 0, 0 },
/* U+80d5 */ { 0, 0, 0, 0, 0 },
/* U+80d6 */ { 0, 0, 0, 0, 0 },
/* U+80d7 */ { 0, 0, 0, 0, 0 },
/* U+80d8 */ { 0, 0, 0, 0, 0 },
/* U+80d9 */ { 0, 0, 0, 0, 0 },
/* U+80da */ { 0, 0, 0, 0, 0 },
/* U+80db */ { 0, 0, 0, 0, 0 },
/* U+80dc */ { 0, 0, 0, 0, 0 },
/* U+80dd */ { 0, 0, 0, 0, 0 },
/* U+80de */ { 0, 0, 0, 0, 0 },
/* U+80df */ { 0, 0, 0, 0, 0 },
/* U+80e0 */ { 0, 0, 0, 0, 0 },
/* U+80e1 */ { 0, 0, 0, 0, 0 },
/* U+80e2 */ { 0, 0, 0, 0, 0 },
/* U+80e3 */ { 0, 0, 0, 0, 0 },
/* U+80e4 */ { 0, 0, 0, 0, 0 },
/* U+80e5 */ { 0, 0, 0, 0, 0 },
/* U+80e6 */ { 0, 0, 0, 0, 0 },
/* U+80e7 */ { 0, 0, 0, 0, 0 },
/* U+80e8 */ { 0, 0, 0, 0, 0 },
/* U+80e9 */ { 0, 0, 0, 0, 0 },
/* U+80ea */ { 0, 0, 0, 0, 0 },
/* U+80eb */ { 0, 0, 0, 0, 0 },
/* U+80ec */ { 0, 0, 0, 0, 0 },
/* U+80ed */ { 0, 0, 0, 0, 0 },
/* U+80ee */ { 0, 0, 0, 0, 0 },
/* U+80ef */ { 0, 0, 0, 0, 0 },
/* U+80f0 */ { 0, 0, 0, 0, 0 },
/* U+80f1 */ { 0, 0, 0, 0, 0 },
/* U+80f2 */ { 0, 0, 0, 0, 0 },
/* U+80f3 */ { 0, 0, 0, 0, 0 },
/* U+80f4 */ { 0, 0, 0, 0, 0 },
/* U+80f5 */ { 0, 0, 0, 0, 0 },
/* U+80f6 */ { 0, 0, 0, 0, 0 },
/* U+80f7 */ { 0, 0, 0, 0, 0 },
/* U+80f8 */ { 0, 0, 0, 0, 0 },
/* U+80f9 */ { 0, 0, 0, 0, 0 },
/* U+80fa */ { 0, 0, 0, 0, 0 },
/* U+80fb */ { 0, 0, 0, 0, 0 },
/* U+80fc */ { 0, 0, 0, 0, 0 },
/* U+80fd */ { 0, 0, 0, 0, 0 },
/* U+80fe */ { 0, 0, 0, 0, 0 },
/* U+80ff */ { 0, 0, 0, 0, 0 },
/* U+8100 */ { 0, 0, 0, 0, 0 },
/* U+8101 */ { 0, 0, 0, 0, 0 },
/* U+8102 */ { 0, 0, 0, 0, 0 },
/* U+8103 */ { 0, 0, 0, 0, 0 },
/* U+8104 */ { 0, 0, 0, 0, 0 },
/* U+8105 */ { 0, 0, 0, 0, 0 },
/* U+8106 */ { 0, 0, 0, 0, 0 },
/* U+8107 */ { 0, 0, 0, 0, 0 },
/* U+8108 */ { 0, 0, 0, 0, 0 },
/* U+8109 */ { 0, 0, 0, 0, 0 },
/* U+810a */ { 0, 0, 0, 0, 0 },
/* U+810b */ { 0, 0, 0, 0, 0 },
/* U+810c */ { 0, 0, 0, 0, 0 },
/* U+810d */ { 0, 0, 0, 0, 0 },
/* U+810e */ { 0, 0, 0, 0, 0 },
/* U+810f */ { 0, 0, 0, 0, 0 },
/* U+8110 */ { 0, 0, 0, 0, 0 },
/* U+8111 */ { 0, 0, 0, 0, 0 },
/* U+8112 */ { 0, 0, 0, 0, 0 },
/* U+8113 */ { 0, 0, 0, 0, 0 },
/* U+8114 */ { 0, 0, 0, 0, 0 },
/* U+8115 */ { 0, 0, 0, 0, 0 },
/* U+8116 */ { 0, 0, 0, 0, 0 },
/* U+8117 */ { 0, 0, 0, 0, 0 },
/* U+8118 */ { 0, 0, 0, 0, 0 },
/* U+8119 */ { 0, 0, 0, 0, 0 },
/* U+811a */ { 0, 0, 0, 0, 0 },
/* U+811b */ { 0, 0, 0, 0, 0 },
/* U+811c */ { 0, 0, 0, 0, 0 },
/* U+811d */ { 0, 0, 0, 0, 0 },
/* U+811e */ { 0, 0, 0, 0, 0 },
/* U+811f */ { 0, 0, 0, 0, 0 },
/* U+8120 */ { 0, 0, 0, 0, 0 },
/* U+8121 */ { 0, 0, 0, 0, 0 },
/* U+8122 */ { 0, 0, 0, 0, 0 },
/* U+8123 */ { 0, 0, 0, 0, 0 },
/* U+8124 */ { 0, 0, 0, 0, 0 },
/* U+8125 */ { 0, 0, 0, 0, 0 },
/* U+8126 */ { 0, 0, 0, 0, 0 },
/* U+8127 */ { 0, 0, 0, 0, 0 },
/* U+8128 */ { 0, 0, 0, 0, 0 },
/* U+8129 */ { 0, 0, 0, 0, 0 },
/* U+812a */ { 0, 0, 0, 0, 0 },
/* U+812b */ { 0, 0, 0, 0, 0 },
/* U+812c */ { 0, 0, 0, 0, 0 },
/* U+812d */ { 0, 0, 0, 0, 0 },
/* U+812e */ { 0, 0, 0, 0, 0 },
/* U+812f */ { 0, 0, 0, 0, 0 },
/* U+8130 */ { 0, 0, 0, 0, 0 },
/* U+8131 */ { 0, 0, 0, 0, 0 },
/* U+8132 */ { 0, 0, 0, 0, 0 },
/* U+8133 */ { 0, 0, 0, 0, 0 },
/* U+8134 */ { 0, 0, 0, 0, 0 },
/* U+8135 */ { 0, 0, 0, 0, 0 },
/* U+8136 */ { 0, 0, 0, 0, 0 },
/* U+8137 */ { 0, 0, 0, 0, 0 },
/* U+8138 */ { 0, 0, 0, 0, 0 },
/* U+8139 */ { 0, 0, 0, 0, 0 },
/* U+813a */ { 0, 0, 0, 0, 0 },
/* U+813b */ { 0, 0, 0, 0, 0 },
/* U+813c */ { 0, 0, 0, 0, 0 },
/* U+813d */ { 0, 0, 0, 0, 0 },
/* U+813e */ { 0, 0, 0, 0, 0 },
/* U+813f */ { 0, 0, 0, 0, 0 },
/* U+8140 */ { 0, 0, 0, 0, 0 },
/* U+8141 */ { 0, 0, 0, 0, 0 },
/* U+8142 */ { 0, 0, 0, 0, 0 },
/* U+8143 */ { 0, 0, 0, 0, 0 },
/* U+8144 */ { 0, 0, 0, 0, 0 },
/* U+8145 */ { 0, 0, 0, 0, 0 },
/* U+8146 */ { 0, 0, 0, 0, 0 },
/* U+8147 */ { 0, 0, 0, 0, 0 },
/* U+8148 */ { 0, 0, 0, 0, 0 },
/* U+8149 */ { 0, 0, 0, 0, 0 },
/* U+814a */ { 0, 0, 0, 0, 0 },
/* U+814b */ { 0, 0, 0, 0, 0 },
/* U+814c */ { 0, 0, 0, 0, 0 },
/* U+814d */ { 0, 0, 0, 0, 0 },
/* U+814e */ { 0, 0, 0, 0, 0 },
/* U+814f */ { 0, 0, 0, 0, 0 },
/* U+8150 */ { 0, 0, 0, 0, 0 },
/* U+8151 */ { 0, 0, 0, 0, 0 },
/* U+8152 */ { 0, 0, 0, 0, 0 },
/* U+8153 */ { 0, 0, 0, 0, 0 },
/* U+8154 */ { 0, 0, 0, 0, 0 },
/* U+8155 */ { 0, 0, 0, 0, 0 },
/* U+8156 */ { 0, 0, 0, 0, 0 },
/* U+8157 */ { 0, 0, 0, 0, 0 },
/* U+8158 */ { 0, 0, 0, 0, 0 },
/* U+8159 */ { 0, 0, 0, 0, 0 },
/* U+815a */ { 0, 0, 0, 0, 0 },
/* U+815b */ { 0, 0, 0, 0, 0 },
/* U+815c */ { 0, 0, 0, 0, 0 },
/* U+815d */ { 0, 0, 0, 0, 0 },
/* U+815e */ { 0, 0, 0, 0, 0 },
/* U+815f */ { 0, 0, 0, 0, 0 },
/* U+8160 */ { 0, 0, 0, 0, 0 },
/* U+8161 */ { 0, 0, 0, 0, 0 },
/* U+8162 */ { 0, 0, 0, 0, 0 },
/* U+8163 */ { 0, 0, 0, 0, 0 },
/* U+8164 */ { 0, 0, 0, 0, 0 },
/* U+8165 */ { 0, 0, 0, 0, 0 },
/* U+8166 */ { 0, 0, 0, 0, 0 },
/* U+8167 */ { 0, 0, 0, 0, 0 },
/* U+8168 */ { 0, 0, 0, 0, 0 },
/* U+8169 */ { 0, 0, 0, 0, 0 },
/* U+816a */ { 0, 0, 0, 0, 0 },
/* U+816b */ { 0, 0, 0, 0, 0 },
/* U+816c */ { 0, 0, 0, 0, 0 },
/* U+816d */ { 0, 0, 0, 0, 0 },
/* U+816e */ { 0, 0, 0, 0, 0 },
/* U+816f */ { 0, 0, 0, 0, 0 },
/* U+8170 */ { 0, 0, 0, 0, 0 },
/* U+8171 */ { 0, 0, 0, 0, 0 },
/* U+8172 */ { 0, 0, 0, 0, 0 },
/* U+8173 */ { 0, 0, 0, 0, 0 },
/* U+8174 */ { 0, 0, 0, 0, 0 },
/* U+8175 */ { 0, 0, 0, 0, 0 },
/* U+8176 */ { 0, 0, 0, 0, 0 },
/* U+8177 */ { 0, 0, 0, 0, 0 },
/* U+8178 */ { 0, 0, 0, 0, 0 },
/* U+8179 */ { 0, 0, 0, 0, 0 },
/* U+817a */ { 0, 0, 0, 0, 0 },
/* U+817b */ { 0, 0, 0, 0, 0 },
/* U+817c */ { 0, 0, 0, 0, 0 },
/* U+817d */ { 0, 0, 0, 0, 0 },
/* U+817e */ { 0, 0, 0, 0, 0 },
/* U+817f */ { 0, 0, 0, 0, 0 },
/* U+8180 */ { 0, 0, 0, 0, 0 },
/* U+8181 */ { 0, 0, 0, 0, 0 },
/* U+8182 */ { 0, 0, 0, 0, 0 },
/* U+8183 */ { 0, 0, 0, 0, 0 },
/* U+8184 */ { 0, 0, 0, 0, 0 },
/* U+8185 */ { 0, 0, 0, 0, 0 },
/* U+8186 */ { 0, 0, 0, 0, 0 },
/* U+8187 */ { 0, 0, 0, 0, 0 },
/* U+8188 */ { 0, 0, 0, 0, 0 },
/* U+8189 */ { 0, 0, 0, 0, 0 },
/* U+818a */ { 0, 0, 0, 0, 0 },
/* U+818b */ { 0, 0, 0, 0, 0 },
/* U+818c */ { 0, 0, 0, 0, 0 },
/* U+818d */ { 0, 0, 0, 0, 0 },
/* U+818e */ { 0, 0, 0, 0, 0 },
/* U+818f */ { 0, 0, 0, 0, 0 },
/* U+8190 */ { 0, 0, 0, 0, 0 },
/* U+8191 */ { 0, 0, 0, 0, 0 },
/* U+8192 */ { 0, 0, 0, 0, 0 },
/* U+8193 */ { 0, 0, 0, 0, 0 },
/* U+8194 */ { 0, 0, 0, 0, 0 },
/* U+8195 */ { 0, 0, 0, 0, 0 },
/* U+8196 */ { 0, 0, 0, 0, 0 },
/* U+8197 */ { 0, 0, 0, 0, 0 },
/* U+8198 */ { 0, 0, 0, 0, 0 },
/* U+8199 */ { 0, 0, 0, 0, 0 },
/* U+819a */ { 0, 0, 0, 0, 0 },
/* U+819b */ { 0, 0, 0, 0, 0 },
/* U+819c */ { 0, 0, 0, 0, 0 },
/* U+819d */ { 0, 0, 0, 0, 0 },
/* U+819e */ { 0, 0, 0, 0, 0 },
/* U+819f */ { 0, 0, 0, 0, 0 },
/* U+81a0 */ { 0, 0, 0, 0, 0 },
/* U+81a1 */ { 0, 0, 0, 0, 0 },
/* U+81a2 */ { 0, 0, 0, 0, 0 },
/* U+81a3 */ { 0, 0, 0, 0, 0 },
/* U+81a4 */ { 0, 0, 0, 0, 0 },
/* U+81a5 */ { 0, 0, 0, 0, 0 },
/* U+81a6 */ { 0, 0, 0, 0, 0 },
/* U+81a7 */ { 0, 0, 0, 0, 0 },
/* U+81a8 */ { 0, 0, 0, 0, 0 },
/* U+81a9 */ { 0, 0, 0, 0, 0 },
/* U+81aa */ { 0, 0, 0, 0, 0 },
/* U+81ab */ { 0, 0, 0, 0, 0 },
/* U+81ac */ { 0, 0, 0, 0, 0 },
/* U+81ad */ { 0, 0, 0, 0, 0 },
/* U+81ae */ { 0, 0, 0, 0, 0 },
/* U+81af */ { 0, 0, 0, 0, 0 },
/* U+81b0 */ { 0, 0, 0, 0, 0 },
/* U+81b1 */ { 0, 0, 0, 0, 0 },
/* U+81b2 */ { 0, 0, 0, 0, 0 },
/* U+81b3 */ { 0, 0, 0, 0, 0 },
/* U+81b4 */ { 0, 0, 0, 0, 0 },
/* U+81b5 */ { 0, 0, 0, 0, 0 },
/* U+81b6 */ { 0, 0, 0, 0, 0 },
/* U+81b7 */ { 0, 0, 0, 0, 0 },
/* U+81b8 */ { 0, 0, 0, 0, 0 },
/* U+81b9 */ { 0, 0, 0, 0, 0 },
/* U+81ba */ { 0, 0, 0, 0, 0 },
/* U+81bb */ { 0, 0, 0, 0, 0 },
/* U+81bc */ { 0, 0, 0, 0, 0 },
/* U+81bd */ { 0, 0, 0, 0, 0 },
/* U+81be */ { 0, 0, 0, 0, 0 },
/* U+81bf */ { 0, 0, 0, 0, 0 },
/* U+81c0 */ { 0, 0, 0, 0, 0 },
/* U+81c1 */ { 0, 0, 0, 0, 0 },
/* U+81c2 */ { 0, 0, 0, 0, 0 },
/* U+81c3 */ { 0, 0, 0, 0, 0 },
/* U+81c4 */ { 0, 0, 0, 0, 0 },
/* U+81c5 */ { 0, 0, 0, 0, 0 },
/* U+81c6 */ { 0, 0, 0, 0, 0 },
/* U+81c7 */ { 0, 0, 0, 0, 0 },
/* U+81c8 */ { 0, 0, 0, 0, 0 },
/* U+81c9 */ { 0, 0, 0, 0, 0 },
/* U+81ca */ { 0, 0, 0, 0, 0 },
/* U+81cb */ { 0, 0, 0, 0, 0 },
/* U+81cc */ { 0, 0, 0, 0, 0 },
/* U+81cd */ { 0, 0, 0, 0, 0 },
/* U+81ce */ { 0, 0, 0, 0, 0 },
/* U+81cf */ { 0, 0, 0, 0, 0 },
/* U+81d0 */ { 0, 0, 0, 0, 0 },
/* U+81d1 */ { 0, 0, 0, 0, 0 },
/* U+81d2 */ { 0, 0, 0, 0, 0 },
/* U+81d3 */ { 0, 0, 0, 0, 0 },
/* U+81d4 */ { 0, 0, 0, 0, 0 },
/* U+81d5 */ { 0, 0, 0, 0, 0 },
/* U+81d6 */ { 0, 0, 0, 0, 0 },
/* U+81d7 */ { 0, 0, 0, 0, 0 },
/* U+81d8 */ { 0, 0, 0, 0, 0 },
/* U+81d9 */ { 0, 0, 0, 0, 0 },
/* U+81da */ { 0, 0, 0, 0, 0 },
/* U+81db */ { 0, 0, 0, 0, 0 },
/* U+81dc */ { 0, 0, 0, 0, 0 },
/* U+81dd */ { 0, 0, 0, 0, 0 },
/* U+81de */ { 0, 0, 0, 0, 0 },
/* U+81df */ { 0, 0, 0, 0, 0 },
/* U+81e0 */ { 0, 0, 0, 0, 0 },
/* U+81e1 */ { 0, 0, 0, 0, 0 },
/* U+81e2 */ { 0, 0, 0, 0, 0 },
/* U+81e3 */ { 0, 0, 0, 0, 0 },
/* U+81e4 */ { 0, 0, 0, 0, 0 },
/* U+81e5 */ { 0, 0, 0, 0, 0 },
/* U+81e6 */ { 0, 0, 0, 0, 0 },
/* U+81e7 */ { 0, 0, 0, 0, 0 },
/* U+81e8 */ { 0, 0, 0, 0, 0 },
/* U+81e9 */ { 0, 0, 0, 0, 0 },
/* U+81ea */ { 0, 0, 0, 0, 0 },
/* U+81eb */ { 0, 0, 0, 0, 0 },
/* U+81ec */ { 0, 0, 0, 0, 0 },
/* U+81ed */ { 0, 0, 0, 0, 0 },
/* U+81ee */ { 0, 0, 0, 0, 0 },
/* U+81ef */ { 0, 0, 0, 0, 0 },
/* U+81f0 */ { 0, 0, 0, 0, 0 },
/* U+81f1 */ { 0, 0, 0, 0, 0 },
/* U+81f2 */ { 0, 0, 0, 0, 0 },
/* U+81f3 */ { 0, 0, 0, 0, 0 },
/* U+81f4 */ { 0, 0, 0, 0, 0 },
/* U+81f5 */ { 0, 0, 0, 0, 0 },
/* U+81f6 */ { 0, 0, 0, 0, 0 },
/* U+81f7 */ { 0, 0, 0, 0, 0 },
/* U+81f8 */ { 0, 0, 0, 0, 0 },
/* U+81f9 */ { 0, 0, 0, 0, 0 },
/* U+81fa */ { 0, 0, 0, 0, 0 },
/* U+81fb */ { 0, 0, 0, 0, 0 },
/* U+81fc */ { 0, 0, 0, 0, 0 },
/* U+81fd */ { 0, 0, 0, 0, 0 },
/* U+81fe */ { 0, 0, 0, 0, 0 },
/* U+81ff */ { 0, 0, 0, 0, 0 },
/* U+8200 */ { 0, 0, 0, 0, 0 },
/* U+8201 */ { 0, 0, 0, 0, 0 },
/* U+8202 */ { 0, 0, 0, 0, 0 },
/* U+8203 */ { 0, 0, 0, 0, 0 },
/* U+8204 */ { 0, 0, 0, 0, 0 },
/* U+8205 */ { 0, 0, 0, 0, 0 },
/* U+8206 */ { 0, 0, 0, 0, 0 },
/* U+8207 */ { 0, 0, 0, 0, 0 },
/* U+8208 */ { 0, 0, 0, 0, 0 },
/* U+8209 */ { 0, 0, 0, 0, 0 },
/* U+820a */ { 0, 0, 0, 0, 0 },
/* U+820b */ { 0, 0, 0, 0, 0 },
/* U+820c */ { 0, 0, 0, 0, 0 },
/* U+820d */ { 0, 0, 0, 0, 0 },
/* U+820e */ { 0, 0, 0, 0, 0 },
/* U+820f */ { 0, 0, 0, 0, 0 },
/* U+8210 */ { 0, 0, 0, 0, 0 },
/* U+8211 */ { 0, 0, 0, 0, 0 },
/* U+8212 */ { 0, 0, 0, 0, 0 },
/* U+8213 */ { 0, 0, 0, 0, 0 },
/* U+8214 */ { 0, 0, 0, 0, 0 },
/* U+8215 */ { 0, 0, 0, 0, 0 },
/* U+8216 */ { 0, 0, 0, 0, 0 },
/* U+8217 */ { 0, 0, 0, 0, 0 },
/* U+8218 */ { 0, 0, 0, 0, 0 },
/* U+8219 */ { 0, 0, 0, 0, 0 },
/* U+821a */ { 0, 0, 0, 0, 0 },
/* U+821b */ { 0, 0, 0, 0, 0 },
/* U+821c */ { 0, 0, 0, 0, 0 },
/* U+821d */ { 0, 0, 0, 0, 0 },
/* U+821e */ { 0, 0, 0, 0, 0 },
/* U+821f */ { 0, 0, 0, 0, 0 },
/* U+8220 */ { 0, 0, 0, 0, 0 },
/* U+8221 */ { 0, 0, 0, 0, 0 },
/* U+8222 */ { 0, 0, 0, 0, 0 },
/* U+8223 */ { 0, 0, 0, 0, 0 },
/* U+8224 */ { 0, 0, 0, 0, 0 },
/* U+8225 */ { 0, 0, 0, 0, 0 },
/* U+8226 */ { 0, 0, 0, 0, 0 },
/* U+8227 */ { 0, 0, 0, 0, 0 },
/* U+8228 */ { 0, 0, 0, 0, 0 },
/* U+8229 */ { 0, 0, 0, 0, 0 },
/* U+822a */ { 0, 0, 0, 0, 0 },
/* U+822b */ { 0, 0, 0, 0, 0 },
/* U+822c */ { 0, 0, 0, 0, 0 },
/* U+822d */ { 0, 0, 0, 0, 0 },
/* U+822e */ { 0, 0, 0, 0, 0 },
/* U+822f */ { 0, 0, 0, 0, 0 },
/* U+8230 */ { 0, 0, 0, 0, 0 },
/* U+8231 */ { 0, 0, 0, 0, 0 },
/* U+8232 */ { 0, 0, 0, 0, 0 },
/* U+8233 */ { 0, 0, 0, 0, 0 },
/* U+8234 */ { 0, 0, 0, 0, 0 },
/* U+8235 */ { 0, 0, 0, 0, 0 },
/* U+8236 */ { 0, 0, 0, 0, 0 },
/* U+8237 */ { 0, 0, 0, 0, 0 },
/* U+8238 */ { 0, 0, 0, 0, 0 },
/* U+8239 */ { 0, 0, 0, 0, 0 },
/* U+823a */ { 0, 0, 0, 0, 0 },
/* U+823b */ { 0, 0, 0, 0, 0 },
/* U+823c */ { 0, 0, 0, 0, 0 },
/* U+823d */ { 0, 0, 0, 0, 0 },
/* U+823e */ { 0, 0, 0, 0, 0 },
/* U+823f */ { 0, 0, 0, 0, 0 },
/* U+8240 */ { 0, 0, 0, 0, 0 },
/* U+8241 */ { 0, 0, 0, 0, 0 },
/* U+8242 */ { 0, 0, 0, 0, 0 },
/* U+8243 */ { 0, 0, 0, 0, 0 },
/* U+8244 */ { 0, 0, 0, 0, 0 },
/* U+8245 */ { 0, 0, 0, 0, 0 },
/* U+8246 */ { 0, 0, 0, 0, 0 },
/* U+8247 */ { 0, 0, 0, 0, 0 },
/* U+8248 */ { 0, 0, 0, 0, 0 },
/* U+8249 */ { 0, 0, 0, 0, 0 },
/* U+824a */ { 0, 0, 0, 0, 0 },
/* U+824b */ { 0, 0, 0, 0, 0 },
/* U+824c */ { 0, 0, 0, 0, 0 },
/* U+824d */ { 0, 0, 0, 0, 0 },
/* U+824e */ { 0, 0, 0, 0, 0 },
/* U+824f */ { 0, 0, 0, 0, 0 },
/* U+8250 */ { 0, 0, 0, 0, 0 },
/* U+8251 */ { 0, 0, 0, 0, 0 },
/* U+8252 */ { 0, 0, 0, 0, 0 },
/* U+8253 */ { 0, 0, 0, 0, 0 },
/* U+8254 */ { 0, 0, 0, 0, 0 },
/* U+8255 */ { 0, 0, 0, 0, 0 },
/* U+8256 */ { 0, 0, 0, 0, 0 },
/* U+8257 */ { 0, 0, 0, 0, 0 },
/* U+8258 */ { 0, 0, 0, 0, 0 },
/* U+8259 */ { 0, 0, 0, 0, 0 },
/* U+825a */ { 0, 0, 0, 0, 0 },
/* U+825b */ { 0, 0, 0, 0, 0 },
/* U+825c */ { 0, 0, 0, 0, 0 },
/* U+825d */ { 0, 0, 0, 0, 0 },
/* U+825e */ { 0, 0, 0, 0, 0 },
/* U+825f */ { 0, 0, 0, 0, 0 },
/* U+8260 */ { 0, 0, 0, 0, 0 },
/* U+8261 */ { 0, 0, 0, 0, 0 },
/* U+8262 */ { 0, 0, 0, 0, 0 },
/* U+8263 */ { 0, 0, 0, 0, 0 },
/* U+8264 */ { 0, 0, 0, 0, 0 },
/* U+8265 */ { 0, 0, 0, 0, 0 },
/* U+8266 */ { 0, 0, 0, 0, 0 },
/* U+8267 */ { 0, 0, 0, 0, 0 },
/* U+8268 */ { 0, 0, 0, 0, 0 },
/* U+8269 */ { 0, 0, 0, 0, 0 },
/* U+826a */ { 0, 0, 0, 0, 0 },
/* U+826b */ { 0, 0, 0, 0, 0 },
/* U+826c */ { 0, 0, 0, 0, 0 },
/* U+826d */ { 0, 0, 0, 0, 0 },
/* U+826e */ { 0, 0, 0, 0, 0 },
/* U+826f */ { 0, 0, 0, 0, 0 },
/* U+8270 */ { 0, 0, 0, 0, 0 },
/* U+8271 */ { 0, 0, 0, 0, 0 },
/* U+8272 */ { 0, 0, 0, 0, 0 },
/* U+8273 */ { 0, 0, 0, 0, 0 },
/* U+8274 */ { 0, 0, 0, 0, 0 },
/* U+8275 */ { 0, 0, 0, 0, 0 },
/* U+8276 */ { 0, 0, 0, 0, 0 },
/* U+8277 */ { 0, 0, 0, 0, 0 },
/* U+8278 */ { 0, 0, 0, 0, 0 },
/* U+8279 */ { 0, 0, 0, 0, 0 },
/* U+827a */ { 0, 0, 0, 0, 0 },
/* U+827b */ { 0, 0, 0, 0, 0 },
/* U+827c */ { 0, 0, 0, 0, 0 },
/* U+827d */ { 0, 0, 0, 0, 0 },
/* U+827e */ { 0, 0, 0, 0, 0 },
/* U+827f */ { 0, 0, 0, 0, 0 },
/* U+8280 */ { 0, 0, 0, 0, 0 },
/* U+8281 */ { 0, 0, 0, 0, 0 },
/* U+8282 */ { 0, 0, 0, 0, 0 },
/* U+8283 */ { 0, 0, 0, 0, 0 },
/* U+8284 */ { 0, 0, 0, 0, 0 },
/* U+8285 */ { 0, 0, 0, 0, 0 },
/* U+8286 */ { 0, 0, 0, 0, 0 },
/* U+8287 */ { 0, 0, 0, 0, 0 },
/* U+8288 */ { 0, 0, 0, 0, 0 },
/* U+8289 */ { 0, 0, 0, 0, 0 },
/* U+828a */ { 0, 0, 0, 0, 0 },
/* U+828b */ { 0, 0, 0, 0, 0 },
/* U+828c */ { 0, 0, 0, 0, 0 },
/* U+828d */ { 0, 0, 0, 0, 0 },
/* U+828e */ { 0, 0, 0, 0, 0 },
/* U+828f */ { 0, 0, 0, 0, 0 },
/* U+8290 */ { 0, 0, 0, 0, 0 },
/* U+8291 */ { 0, 0, 0, 0, 0 },
/* U+8292 */ { 0, 0, 0, 0, 0 },
/* U+8293 */ { 0, 0, 0, 0, 0 },
/* U+8294 */ { 0, 0, 0, 0, 0 },
/* U+8295 */ { 0, 0, 0, 0, 0 },
/* U+8296 */ { 0, 0, 0, 0, 0 },
/* U+8297 */ { 0, 0, 0, 0, 0 },
/* U+8298 */ { 0, 0, 0, 0, 0 },
/* U+8299 */ { 0, 0, 0, 0, 0 },
/* U+829a */ { 0, 0, 0, 0, 0 },
/* U+829b */ { 0, 0, 0, 0, 0 },
/* U+829c */ { 0, 0, 0, 0, 0 },
/* U+829d */ { 0, 0, 0, 0, 0 },
/* U+829e */ { 0, 0, 0, 0, 0 },
/* U+829f */ { 0, 0, 0, 0, 0 },
/* U+82a0 */ { 0, 0, 0, 0, 0 },
/* U+82a1 */ { 0, 0, 0, 0, 0 },
/* U+82a2 */ { 0, 0, 0, 0, 0 },
/* U+82a3 */ { 0, 0, 0, 0, 0 },
/* U+82a4 */ { 0, 0, 0, 0, 0 },
/* U+82a5 */ { 0, 0, 0, 0, 0 },
/* U+82a6 */ { 0, 0, 0, 0, 0 },
/* U+82a7 */ { 0, 0, 0, 0, 0 },
/* U+82a8 */ { 0, 0, 0, 0, 0 },
/* U+82a9 */ { 0, 0, 0, 0, 0 },
/* U+82aa */ { 0, 0, 0, 0, 0 },
/* U+82ab */ { 0, 0, 0, 0, 0 },
/* U+82ac */ { 0, 0, 0, 0, 0 },
/* U+82ad */ { 0, 0, 0, 0, 0 },
/* U+82ae */ { 0, 0, 0, 0, 0 },
/* U+82af */ { 0, 0, 0, 0, 0 },
/* U+82b0 */ { 0, 0, 0, 0, 0 },
/* U+82b1 */ { 0, 0, 0, 0, 0 },
/* U+82b2 */ { 0, 0, 0, 0, 0 },
/* U+82b3 */ { 0, 0, 0, 0, 0 },
/* U+82b4 */ { 0, 0, 0, 0, 0 },
/* U+82b5 */ { 0, 0, 0, 0, 0 },
/* U+82b6 */ { 0, 0, 0, 0, 0 },
/* U+82b7 */ { 0, 0, 0, 0, 0 },
/* U+82b8 */ { 0, 0, 0, 0, 0 },
/* U+82b9 */ { 0, 0, 0, 0, 0 },
/* U+82ba */ { 0, 0, 0, 0, 0 },
/* U+82bb */ { 0, 0, 0, 0, 0 },
/* U+82bc */ { 0, 0, 0, 0, 0 },
/* U+82bd */ { 0, 0, 0, 0, 0 },
/* U+82be */ { 0, 0, 0, 0, 0 },
/* U+82bf */ { 0, 0, 0, 0, 0 },
/* U+82c0 */ { 0, 0, 0, 0, 0 },
/* U+82c1 */ { 0, 0, 0, 0, 0 },
/* U+82c2 */ { 0, 0, 0, 0, 0 },
/* U+82c3 */ { 0, 0, 0, 0, 0 },
/* U+82c4 */ { 0, 0, 0, 0, 0 },
/* U+82c5 */ { 0, 0, 0, 0, 0 },
/* U+82c6 */ { 0, 0, 0, 0, 0 },
/* U+82c7 */ { 0, 0, 0, 0, 0 },
/* U+82c8 */ { 0, 0, 0, 0, 0 },
/* U+82c9 */ { 0, 0, 0, 0, 0 },
/* U+82ca */ { 0, 0, 0, 0, 0 },
/* U+82cb */ { 0, 0, 0, 0, 0 },
/* U+82cc */ { 0, 0, 0, 0, 0 },
/* U+82cd */ { 0, 0, 0, 0, 0 },
/* U+82ce */ { 0, 0, 0, 0, 0 },
/* U+82cf */ { 0, 0, 0, 0, 0 },
/* U+82d0 */ { 0, 0, 0, 0, 0 },
/* U+82d1 */ { 0, 0, 0, 0, 0 },
/* U+82d2 */ { 0, 0, 0, 0, 0 },
/* U+82d3 */ { 0, 0, 0, 0, 0 },
/* U+82d4 */ { 0, 0, 0, 0, 0 },
/* U+82d5 */ { 0, 0, 0, 0, 0 },
/* U+82d6 */ { 0, 0, 0, 0, 0 },
/* U+82d7 */ { 0, 0, 0, 0, 0 },
/* U+82d8 */ { 0, 0, 0, 0, 0 },
/* U+82d9 */ { 0, 0, 0, 0, 0 },
/* U+82da */ { 0, 0, 0, 0, 0 },
/* U+82db */ { 0, 0, 0, 0, 0 },
/* U+82dc */ { 0, 0, 0, 0, 0 },
/* U+82dd */ { 0, 0, 0, 0, 0 },
/* U+82de */ { 0, 0, 0, 0, 0 },
/* U+82df */ { 0, 0, 0, 0, 0 },
/* U+82e0 */ { 0, 0, 0, 0, 0 },
/* U+82e1 */ { 0, 0, 0, 0, 0 },
/* U+82e2 */ { 0, 0, 0, 0, 0 },
/* U+82e3 */ { 0, 0, 0, 0, 0 },
/* U+82e4 */ { 0, 0, 0, 0, 0 },
/* U+82e5 */ { 0, 0, 0, 0, 0 },
/* U+82e6 */ { 0, 0, 0, 0, 0 },
/* U+82e7 */ { 0, 0, 0, 0, 0 },
/* U+82e8 */ { 0, 0, 0, 0, 0 },
/* U+82e9 */ { 0, 0, 0, 0, 0 },
/* U+82ea */ { 0, 0, 0, 0, 0 },
/* U+82eb */ { 0, 0, 0, 0, 0 },
/* U+82ec */ { 0, 0, 0, 0, 0 },
/* U+82ed */ { 0, 0, 0, 0, 0 },
/* U+82ee */ { 0, 0, 0, 0, 0 },
/* U+82ef */ { 0, 0, 0, 0, 0 },
/* U+82f0 */ { 0, 0, 0, 0, 0 },
/* U+82f1 */ { 0, 0, 0, 0, 0 },
/* U+82f2 */ { 0, 0, 0, 0, 0 },
/* U+82f3 */ { 0, 0, 0, 0, 0 },
/* U+82f4 */ { 0, 0, 0, 0, 0 },
/* U+82f5 */ { 0, 0, 0, 0, 0 },
/* U+82f6 */ { 0, 0, 0, 0, 0 },
/* U+82f7 */ { 0, 0, 0, 0, 0 },
/* U+82f8 */ { 0, 0, 0, 0, 0 },
/* U+82f9 */ { 0, 0, 0, 0, 0 },
/* U+82fa */ { 0, 0, 0, 0, 0 },
/* U+82fb */ { 0, 0, 0, 0, 0 },
/* U+82fc */ { 0, 0, 0, 0, 0 },
/* U+82fd */ { 0, 0, 0, 0, 0 },
/* U+82fe */ { 0, 0, 0, 0, 0 },
/* U+82ff */ { 0, 0, 0, 0, 0 },
/* U+8300 */ { 0, 0, 0, 0, 0 },
/* U+8301 */ { 0, 0, 0, 0, 0 },
/* U+8302 */ { 0, 0, 0, 0, 0 },
/* U+8303 */ { 0, 0, 0, 0, 0 },
/* U+8304 */ { 0, 0, 0, 0, 0 },
/* U+8305 */ { 0, 0, 0, 0, 0 },
/* U+8306 */ { 0, 0, 0, 0, 0 },
/* U+8307 */ { 0, 0, 0, 0, 0 },
/* U+8308 */ { 0, 0, 0, 0, 0 },
/* U+8309 */ { 0, 0, 0, 0, 0 },
/* U+830a */ { 0, 0, 0, 0, 0 },
/* U+830b */ { 0, 0, 0, 0, 0 },
/* U+830c */ { 0, 0, 0, 0, 0 },
/* U+830d */ { 0, 0, 0, 0, 0 },
/* U+830e */ { 0, 0, 0, 0, 0 },
/* U+830f */ { 0, 0, 0, 0, 0 },
/* U+8310 */ { 0, 0, 0, 0, 0 },
/* U+8311 */ { 0, 0, 0, 0, 0 },
/* U+8312 */ { 0, 0, 0, 0, 0 },
/* U+8313 */ { 0, 0, 0, 0, 0 },
/* U+8314 */ { 0, 0, 0, 0, 0 },
/* U+8315 */ { 0, 0, 0, 0, 0 },
/* U+8316 */ { 0, 0, 0, 0, 0 },
/* U+8317 */ { 0, 0, 0, 0, 0 },
/* U+8318 */ { 0, 0, 0, 0, 0 },
/* U+8319 */ { 0, 0, 0, 0, 0 },
/* U+831a */ { 0, 0, 0, 0, 0 },
/* U+831b */ { 0, 0, 0, 0, 0 },
/* U+831c */ { 0, 0, 0, 0, 0 },
/* U+831d */ { 0, 0, 0, 0, 0 },
/* U+831e */ { 0, 0, 0, 0, 0 },
/* U+831f */ { 0, 0, 0, 0, 0 },
/* U+8320 */ { 0, 0, 0, 0, 0 },
/* U+8321 */ { 0, 0, 0, 0, 0 },
/* U+8322 */ { 0, 0, 0, 0, 0 },
/* U+8323 */ { 0, 0, 0, 0, 0 },
/* U+8324 */ { 0, 0, 0, 0, 0 },
/* U+8325 */ { 0, 0, 0, 0, 0 },
/* U+8326 */ { 0, 0, 0, 0, 0 },
/* U+8327 */ { 0, 0, 0, 0, 0 },
/* U+8328 */ { 0, 0, 0, 0, 0 },
/* U+8329 */ { 0, 0, 0, 0, 0 },
/* U+832a */ { 0, 0, 0, 0, 0 },
/* U+832b */ { 0, 0, 0, 0, 0 },
/* U+832c */ { 0, 0, 0, 0, 0 },
/* U+832d */ { 0, 0, 0, 0, 0 },
/* U+832e */ { 0, 0, 0, 0, 0 },
/* U+832f */ { 0, 0, 0, 0, 0 },
/* U+8330 */ { 0, 0, 0, 0, 0 },
/* U+8331 */ { 0, 0, 0, 0, 0 },
/* U+8332 */ { 0, 0, 0, 0, 0 },
/* U+8333 */ { 0, 0, 0, 0, 0 },
/* U+8334 */ { 0, 0, 0, 0, 0 },
/* U+8335 */ { 0, 0, 0, 0, 0 },
/* U+8336 */ { 0, 0, 0, 0, 0 },
/* U+8337 */ { 0, 0, 0, 0, 0 },
/* U+8338 */ { 0, 0, 0, 0, 0 },
/* U+8339 */ { 0, 0, 0, 0, 0 },
/* U+833a */ { 0, 0, 0, 0, 0 },
/* U+833b */ { 0, 0, 0, 0, 0 },
/* U+833c */ { 0, 0, 0, 0, 0 },
/* U+833d */ { 0, 0, 0, 0, 0 },
/* U+833e */ { 0, 0, 0, 0, 0 },
/* U+833f */ { 0, 0, 0, 0, 0 },
/* U+8340 */ { 0, 0, 0, 0, 0 },
/* U+8341 */ { 0, 0, 0, 0, 0 },
/* U+8342 */ { 0, 0, 0, 0, 0 },
/* U+8343 */ { 0, 0, 0, 0, 0 },
/* U+8344 */ { 0, 0, 0, 0, 0 },
/* U+8345 */ { 0, 0, 0, 0, 0 },
/* U+8346 */ { 0, 0, 0, 0, 0 },
/* U+8347 */ { 0, 0, 0, 0, 0 },
/* U+8348 */ { 0, 0, 0, 0, 0 },
/* U+8349 */ { 0, 0, 0, 0, 0 },
/* U+834a */ { 0, 0, 0, 0, 0 },
/* U+834b */ { 0, 0, 0, 0, 0 },
/* U+834c */ { 0, 0, 0, 0, 0 },
/* U+834d */ { 0, 0, 0, 0, 0 },
/* U+834e */ { 0, 0, 0, 0, 0 },
/* U+834f */ { 0, 0, 0, 0, 0 },
/* U+8350 */ { 0, 0, 0, 0, 0 },
/* U+8351 */ { 0, 0, 0, 0, 0 },
/* U+8352 */ { 0, 0, 0, 0, 0 },
/* U+8353 */ { 0, 0, 0, 0, 0 },
/* U+8354 */ { 0, 0, 0, 0, 0 },
/* U+8355 */ { 0, 0, 0, 0, 0 },
/* U+8356 */ { 0, 0, 0, 0, 0 },
/* U+8357 */ { 0, 0, 0, 0, 0 },
/* U+8358 */ { 0, 0, 0, 0, 0 },
/* U+8359 */ { 0, 0, 0, 0, 0 },
/* U+835a */ { 0, 0, 0, 0, 0 },
/* U+835b */ { 0, 0, 0, 0, 0 },
/* U+835c */ { 0, 0, 0, 0, 0 },
/* U+835d */ { 0, 0, 0, 0, 0 },
/* U+835e */ { 0, 0, 0, 0, 0 },
/* U+835f */ { 0, 0, 0, 0, 0 },
/* U+8360 */ { 0, 0, 0, 0, 0 },
/* U+8361 */ { 0, 0, 0, 0, 0 },
/* U+8362 */ { 0, 0, 0, 0, 0 },
/* U+8363 */ { 0, 0, 0, 0, 0 },
/* U+8364 */ { 0, 0, 0, 0, 0 },
/* U+8365 */ { 0, 0, 0, 0, 0 },
/* U+8366 */ { 0, 0, 0, 0, 0 },
/* U+8367 */ { 0, 0, 0, 0, 0 },
/* U+8368 */ { 0, 0, 0, 0, 0 },
/* U+8369 */ { 0, 0, 0, 0, 0 },
/* U+836a */ { 0, 0, 0, 0, 0 },
/* U+836b */ { 0, 0, 0, 0, 0 },
/* U+836c */ { 0, 0, 0, 0, 0 },
/* U+836d */ { 0, 0, 0, 0, 0 },
/* U+836e */ { 0, 0, 0, 0, 0 },
/* U+836f */ { 0, 0, 0, 0, 0 },
/* U+8370 */ { 0, 0, 0, 0, 0 },
/* U+8371 */ { 0, 0, 0, 0, 0 },
/* U+8372 */ { 0, 0, 0, 0, 0 },
/* U+8373 */ { 0, 0, 0, 0, 0 },
/* U+8374 */ { 0, 0, 0, 0, 0 },
/* U+8375 */ { 0, 0, 0, 0, 0 },
/* U+8376 */ { 0, 0, 0, 0, 0 },
/* U+8377 */ { 0, 0, 0, 0, 0 },
/* U+8378 */ { 0, 0, 0, 0, 0 },
/* U+8379 */ { 0, 0, 0, 0, 0 },
/* U+837a */ { 0, 0, 0, 0, 0 },
/* U+837b */ { 0, 0, 0, 0, 0 },
/* U+837c */ { 0, 0, 0, 0, 0 },
/* U+837d */ { 0, 0, 0, 0, 0 },
/* U+837e */ { 0, 0, 0, 0, 0 },
/* U+837f */ { 0, 0, 0, 0, 0 },
/* U+8380 */ { 0, 0, 0, 0, 0 },
/* U+8381 */ { 0, 0, 0, 0, 0 },
/* U+8382 */ { 0, 0, 0, 0, 0 },
/* U+8383 */ { 0, 0, 0, 0, 0 },
/* U+8384 */ { 0, 0, 0, 0, 0 },
/* U+8385 */ { 0, 0, 0, 0, 0 },
/* U+8386 */ { 0, 0, 0, 0, 0 },
/* U+8387 */ { 0, 0, 0, 0, 0 },
/* U+8388 */ { 0, 0, 0, 0, 0 },
/* U+8389 */ { 0, 0, 0, 0, 0 },
/* U+838a */ { 0, 0, 0, 0, 0 },
/* U+838b */ { 0, 0, 0, 0, 0 },
/* U+838c */ { 0, 0, 0, 0, 0 },
/* U+838d */ { 0, 0, 0, 0, 0 },
/* U+838e */ { 0, 0, 0, 0, 0 },
/* U+838f */ { 0, 0, 0, 0, 0 },
/* U+8390 */ { 0, 0, 0, 0, 0 },
/* U+8391 */ { 0, 0, 0, 0, 0 },
/* U+8392 */ { 0, 0, 0, 0, 0 },
/* U+8393 */ { 0, 0, 0, 0, 0 },
/* U+8394 */ { 0, 0, 0, 0, 0 },
/* U+8395 */ { 0, 0, 0, 0, 0 },
/* U+8396 */ { 0, 0, 0, 0, 0 },
/* U+8397 */ { 0, 0, 0, 0, 0 },
/* U+8398 */ { 0, 0, 0, 0, 0 },
/* U+8399 */ { 0, 0, 0, 0, 0 },
/* U+839a */ { 0, 0, 0, 0, 0 },
/* U+839b */ { 0, 0, 0, 0, 0 },
/* U+839c */ { 0, 0, 0, 0, 0 },
/* U+839d */ { 0, 0, 0, 0, 0 },
/* U+839e */ { 0, 0, 0, 0, 0 },
/* U+839f */ { 0, 0, 0, 0, 0 },
/* U+83a0 */ { 0, 0, 0, 0, 0 },
/* U+83a1 */ { 0, 0, 0, 0, 0 },
/* U+83a2 */ { 0, 0, 0, 0, 0 },
/* U+83a3 */ { 0, 0, 0, 0, 0 },
/* U+83a4 */ { 0, 0, 0, 0, 0 },
/* U+83a5 */ { 0, 0, 0, 0, 0 },
/* U+83a6 */ { 0, 0, 0, 0, 0 },
/* U+83a7 */ { 0, 0, 0, 0, 0 },
/* U+83a8 */ { 0, 0, 0, 0, 0 },
/* U+83a9 */ { 0, 0, 0, 0, 0 },
/* U+83aa */ { 0, 0, 0, 0, 0 },
/* U+83ab */ { 0, 0, 0, 0, 0 },
/* U+83ac */ { 0, 0, 0, 0, 0 },
/* U+83ad */ { 0, 0, 0, 0, 0 },
/* U+83ae */ { 0, 0, 0, 0, 0 },
/* U+83af */ { 0, 0, 0, 0, 0 },
/* U+83b0 */ { 0, 0, 0, 0, 0 },
/* U+83b1 */ { 0, 0, 0, 0, 0 },
/* U+83b2 */ { 0, 0, 0, 0, 0 },
/* U+83b3 */ { 0, 0, 0, 0, 0 },
/* U+83b4 */ { 0, 0, 0, 0, 0 },
/* U+83b5 */ { 0, 0, 0, 0, 0 },
/* U+83b6 */ { 0, 0, 0, 0, 0 },
/* U+83b7 */ { 0, 0, 0, 0, 0 },
/* U+83b8 */ { 0, 0, 0, 0, 0 },
/* U+83b9 */ { 0, 0, 0, 0, 0 },
/* U+83ba */ { 0, 0, 0, 0, 0 },
/* U+83bb */ { 0, 0, 0, 0, 0 },
/* U+83bc */ { 0, 0, 0, 0, 0 },
/* U+83bd */ { 0, 0, 0, 0, 0 },
/* U+83be */ { 0, 0, 0, 0, 0 },
/* U+83bf */ { 0, 0, 0, 0, 0 },
/* U+83c0 */ { 0, 0, 0, 0, 0 },
/* U+83c1 */ { 0, 0, 0, 0, 0 },
/* U+83c2 */ { 0, 0, 0, 0, 0 },
/* U+83c3 */ { 0, 0, 0, 0, 0 },
/* U+83c4 */ { 0, 0, 0, 0, 0 },
/* U+83c5 */ { 0, 0, 0, 0, 0 },
/* U+83c6 */ { 0, 0, 0, 0, 0 },
/* U+83c7 */ { 0, 0, 0, 0, 0 },
/* U+83c8 */ { 0, 0, 0, 0, 0 },
/* U+83c9 */ { 0, 0, 0, 0, 0 },
/* U+83ca */ { 0, 0, 0, 0, 0 },
/* U+83cb */ { 0, 0, 0, 0, 0 },
/* U+83cc */ { 0, 0, 0, 0, 0 },
/* U+83cd */ { 0, 0, 0, 0, 0 },
/* U+83ce */ { 0, 0, 0, 0, 0 },
/* U+83cf */ { 0, 0, 0, 0, 0 },
/* U+83d0 */ { 0, 0, 0, 0, 0 },
/* U+83d1 */ { 0, 0, 0, 0, 0 },
/* U+83d2 */ { 0, 0, 0, 0, 0 },
/* U+83d3 */ { 0, 0, 0, 0, 0 },
/* U+83d4 */ { 0, 0, 0, 0, 0 },
/* U+83d5 */ { 0, 0, 0, 0, 0 },
/* U+83d6 */ { 0, 0, 0, 0, 0 },
/* U+83d7 */ { 0, 0, 0, 0, 0 },
/* U+83d8 */ { 0, 0, 0, 0, 0 },
/* U+83d9 */ { 0, 0, 0, 0, 0 },
/* U+83da */ { 0, 0, 0, 0, 0 },
/* U+83db */ { 0, 0, 0, 0, 0 },
/* U+83dc */ { 0, 0, 0, 0, 0 },
/* U+83dd */ { 0, 0, 0, 0, 0 },
/* U+83de */ { 0, 0, 0, 0, 0 },
/* U+83df */ { 0, 0, 0, 0, 0 },
/* U+83e0 */ { 0, 0, 0, 0, 0 },
/* U+83e1 */ { 0, 0, 0, 0, 0 },
/* U+83e2 */ { 0, 0, 0, 0, 0 },
/* U+83e3 */ { 0, 0, 0, 0, 0 },
/* U+83e4 */ { 0, 0, 0, 0, 0 },
/* U+83e5 */ { 0, 0, 0, 0, 0 },
/* U+83e6 */ { 0, 0, 0, 0, 0 },
/* U+83e7 */ { 0, 0, 0, 0, 0 },
/* U+83e8 */ { 0, 0, 0, 0, 0 },
/* U+83e9 */ { 0, 0, 0, 0, 0 },
/* U+83ea */ { 0, 0, 0, 0, 0 },
/* U+83eb */ { 0, 0, 0, 0, 0 },
/* U+83ec */ { 0, 0, 0, 0, 0 },
/* U+83ed */ { 0, 0, 0, 0, 0 },
/* U+83ee */ { 0, 0, 0, 0, 0 },
/* U+83ef */ { 0, 0, 0, 0, 0 },
/* U+83f0 */ { 0, 0, 0, 0, 0 },
/* U+83f1 */ { 0, 0, 0, 0, 0 },
/* U+83f2 */ { 0, 0, 0, 0, 0 },
/* U+83f3 */ { 0, 0, 0, 0, 0 },
/* U+83f4 */ { 0, 0, 0, 0, 0 },
/* U+83f5 */ { 0, 0, 0, 0, 0 },
/* U+83f6 */ { 0, 0, 0, 0, 0 },
/* U+83f7 */ { 0, 0, 0, 0, 0 },
/* U+83f8 */ { 0, 0, 0, 0, 0 },
/* U+83f9 */ { 0, 0, 0, 0, 0 },
/* U+83fa */ { 0, 0, 0, 0, 0 },
/* U+83fb */ { 0, 0, 0, 0, 0 },
/* U+83fc */ { 0, 0, 0, 0, 0 },
/* U+83fd */ { 0, 0, 0, 0, 0 },
/* U+83fe */ { 0, 0, 0, 0, 0 },
/* U+83ff */ { 0, 0, 0, 0, 0 },
/* U+8400 */ { 0, 0, 0, 0, 0 },
/* U+8401 */ { 0, 0, 0, 0, 0 },
/* U+8402 */ { 0, 0, 0, 0, 0 },
/* U+8403 */ { 0, 0, 0, 0, 0 },
/* U+8404 */ { 0, 0, 0, 0, 0 },
/* U+8405 */ { 0, 0, 0, 0, 0 },
/* U+8406 */ { 0, 0, 0, 0, 0 },
/* U+8407 */ { 0, 0, 0, 0, 0 },
/* U+8408 */ { 0, 0, 0, 0, 0 },
/* U+8409 */ { 0, 0, 0, 0, 0 },
/* U+840a */ { 0, 0, 0, 0, 0 },
/* U+840b */ { 0, 0, 0, 0, 0 },
/* U+840c */ { 0, 0, 0, 0, 0 },
/* U+840d */ { 0, 0, 0, 0, 0 },
/* U+840e */ { 0, 0, 0, 0, 0 },
/* U+840f */ { 0, 0, 0, 0, 0 },
/* U+8410 */ { 0, 0, 0, 0, 0 },
/* U+8411 */ { 0, 0, 0, 0, 0 },
/* U+8412 */ { 0, 0, 0, 0, 0 },
/* U+8413 */ { 0, 0, 0, 0, 0 },
/* U+8414 */ { 0, 0, 0, 0, 0 },
/* U+8415 */ { 0, 0, 0, 0, 0 },
/* U+8416 */ { 0, 0, 0, 0, 0 },
/* U+8417 */ { 0, 0, 0, 0, 0 },
/* U+8418 */ { 0, 0, 0, 0, 0 },
/* U+8419 */ { 0, 0, 0, 0, 0 },
/* U+841a */ { 0, 0, 0, 0, 0 },
/* U+841b */ { 0, 0, 0, 0, 0 },
/* U+841c */ { 0, 0, 0, 0, 0 },
/* U+841d */ { 0, 0, 0, 0, 0 },
/* U+841e */ { 0, 0, 0, 0, 0 },
/* U+841f */ { 0, 0, 0, 0, 0 },
/* U+8420 */ { 0, 0, 0, 0, 0 },
/* U+8421 */ { 0, 0, 0, 0, 0 },
/* U+8422 */ { 0, 0, 0, 0, 0 },
/* U+8423 */ { 0, 0, 0, 0, 0 },
/* U+8424 */ { 0, 0, 0, 0, 0 },
/* U+8425 */ { 0, 0, 0, 0, 0 },
/* U+8426 */ { 0, 0, 0, 0, 0 },
/* U+8427 */ { 0, 0, 0, 0, 0 },
/* U+8428 */ { 0, 0, 0, 0, 0 },
/* U+8429 */ { 0, 0, 0, 0, 0 },
/* U+842a */ { 0, 0, 0, 0, 0 },
/* U+842b */ { 0, 0, 0, 0, 0 },
/* U+842c */ { 0, 0, 0, 0, 0 },
/* U+842d */ { 0, 0, 0, 0, 0 },
/* U+842e */ { 0, 0, 0, 0, 0 },
/* U+842f */ { 0, 0, 0, 0, 0 },
/* U+8430 */ { 0, 0, 0, 0, 0 },
/* U+8431 */ { 0, 0, 0, 0, 0 },
/* U+8432 */ { 0, 0, 0, 0, 0 },
/* U+8433 */ { 0, 0, 0, 0, 0 },
/* U+8434 */ { 0, 0, 0, 0, 0 },
/* U+8435 */ { 0, 0, 0, 0, 0 },
/* U+8436 */ { 0, 0, 0, 0, 0 },
/* U+8437 */ { 0, 0, 0, 0, 0 },
/* U+8438 */ { 0, 0, 0, 0, 0 },
/* U+8439 */ { 0, 0, 0, 0, 0 },
/* U+843a */ { 0, 0, 0, 0, 0 },
/* U+843b */ { 0, 0, 0, 0, 0 },
/* U+843c */ { 0, 0, 0, 0, 0 },
/* U+843d */ { 0, 0, 0, 0, 0 },
/* U+843e */ { 0, 0, 0, 0, 0 },
/* U+843f */ { 0, 0, 0, 0, 0 },
/* U+8440 */ { 0, 0, 0, 0, 0 },
/* U+8441 */ { 0, 0, 0, 0, 0 },
/* U+8442 */ { 0, 0, 0, 0, 0 },
/* U+8443 */ { 0, 0, 0, 0, 0 },
/* U+8444 */ { 0, 0, 0, 0, 0 },
/* U+8445 */ { 0, 0, 0, 0, 0 },
/* U+8446 */ { 0, 0, 0, 0, 0 },
/* U+8447 */ { 0, 0, 0, 0, 0 },
/* U+8448 */ { 0, 0, 0, 0, 0 },
/* U+8449 */ { 0, 0, 0, 0, 0 },
/* U+844a */ { 0, 0, 0, 0, 0 },
/* U+844b */ { 0, 0, 0, 0, 0 },
/* U+844c */ { 0, 0, 0, 0, 0 },
/* U+844d */ { 0, 0, 0, 0, 0 },
/* U+844e */ { 0, 0, 0, 0, 0 },
/* U+844f */ { 0, 0, 0, 0, 0 },
/* U+8450 */ { 0, 0, 0, 0, 0 },
/* U+8451 */ { 0, 0, 0, 0, 0 },
/* U+8452 */ { 0, 0, 0, 0, 0 },
/* U+8453 */ { 0, 0, 0, 0, 0 },
/* U+8454 */ { 0, 0, 0, 0, 0 },
/* U+8455 */ { 0, 0, 0, 0, 0 },
/* U+8456 */ { 0, 0, 0, 0, 0 },
/* U+8457 */ { 0, 0, 0, 0, 0 },
/* U+8458 */ { 0, 0, 0, 0, 0 },
/* U+8459 */ { 0, 0, 0, 0, 0 },
/* U+845a */ { 0, 0, 0, 0, 0 },
/* U+845b */ { 0, 0, 0, 0, 0 },
/* U+845c */ { 0, 0, 0, 0, 0 },
/* U+845d */ { 0, 0, 0, 0, 0 },
/* U+845e */ { 0, 0, 0, 0, 0 },
/* U+845f */ { 0, 0, 0, 0, 0 },
/* U+8460 */ { 0, 0, 0, 0, 0 },
/* U+8461 */ { 0, 0, 0, 0, 0 },
/* U+8462 */ { 0, 0, 0, 0, 0 },
/* U+8463 */ { 0, 0, 0, 0, 0 },
/* U+8464 */ { 0, 0, 0, 0, 0 },
/* U+8465 */ { 0, 0, 0, 0, 0 },
/* U+8466 */ { 0, 0, 0, 0, 0 },
/* U+8467 */ { 0, 0, 0, 0, 0 },
/* U+8468 */ { 0, 0, 0, 0, 0 },
/* U+8469 */ { 0, 0, 0, 0, 0 },
/* U+846a */ { 0, 0, 0, 0, 0 },
/* U+846b */ { 0, 0, 0, 0, 0 },
/* U+846c */ { 0, 0, 0, 0, 0 },
/* U+846d */ { 0, 0, 0, 0, 0 },
/* U+846e */ { 0, 0, 0, 0, 0 },
/* U+846f */ { 0, 0, 0, 0, 0 },
/* U+8470 */ { 0, 0, 0, 0, 0 },
/* U+8471 */ { 0, 0, 0, 0, 0 },
/* U+8472 */ { 0, 0, 0, 0, 0 },
/* U+8473 */ { 0, 0, 0, 0, 0 },
/* U+8474 */ { 0, 0, 0, 0, 0 },
/* U+8475 */ { 0, 0, 0, 0, 0 },
/* U+8476 */ { 0, 0, 0, 0, 0 },
/* U+8477 */ { 0, 0, 0, 0, 0 },
/* U+8478 */ { 0, 0, 0, 0, 0 },
/* U+8479 */ { 0, 0, 0, 0, 0 },
/* U+847a */ { 0, 0, 0, 0, 0 },
/* U+847b */ { 0, 0, 0, 0, 0 },
/* U+847c */ { 0, 0, 0, 0, 0 },
/* U+847d */ { 0, 0, 0, 0, 0 },
/* U+847e */ { 0, 0, 0, 0, 0 },
/* U+847f */ { 0, 0, 0, 0, 0 },
/* U+8480 */ { 0, 0, 0, 0, 0 },
/* U+8481 */ { 0, 0, 0, 0, 0 },
/* U+8482 */ { 0, 0, 0, 0, 0 },
/* U+8483 */ { 0, 0, 0, 0, 0 },
/* U+8484 */ { 0, 0, 0, 0, 0 },
/* U+8485 */ { 0, 0, 0, 0, 0 },
/* U+8486 */ { 0, 0, 0, 0, 0 },
/* U+8487 */ { 0, 0, 0, 0, 0 },
/* U+8488 */ { 0, 0, 0, 0, 0 },
/* U+8489 */ { 0, 0, 0, 0, 0 },
/* U+848a */ { 0, 0, 0, 0, 0 },
/* U+848b */ { 0, 0, 0, 0, 0 },
/* U+848c */ { 0, 0, 0, 0, 0 },
/* U+848d */ { 0, 0, 0, 0, 0 },
/* U+848e */ { 0, 0, 0, 0, 0 },
/* U+848f */ { 0, 0, 0, 0, 0 },
/* U+8490 */ { 0, 0, 0, 0, 0 },
/* U+8491 */ { 0, 0, 0, 0, 0 },
/* U+8492 */ { 0, 0, 0, 0, 0 },
/* U+8493 */ { 0, 0, 0, 0, 0 },
/* U+8494 */ { 0, 0, 0, 0, 0 },
/* U+8495 */ { 0, 0, 0, 0, 0 },
/* U+8496 */ { 0, 0, 0, 0, 0 },
/* U+8497 */ { 0, 0, 0, 0, 0 },
/* U+8498 */ { 0, 0, 0, 0, 0 },
/* U+8499 */ { 0, 0, 0, 0, 0 },
/* U+849a */ { 0, 0, 0, 0, 0 },
/* U+849b */ { 0, 0, 0, 0, 0 },
/* U+849c */ { 0, 0, 0, 0, 0 },
/* U+849d */ { 0, 0, 0, 0, 0 },
/* U+849e */ { 0, 0, 0, 0, 0 },
/* U+849f */ { 0, 0, 0, 0, 0 },
/* U+84a0 */ { 0, 0, 0, 0, 0 },
/* U+84a1 */ { 0, 0, 0, 0, 0 },
/* U+84a2 */ { 0, 0, 0, 0, 0 },
/* U+84a3 */ { 0, 0, 0, 0, 0 },
/* U+84a4 */ { 0, 0, 0, 0, 0 },
/* U+84a5 */ { 0, 0, 0, 0, 0 },
/* U+84a6 */ { 0, 0, 0, 0, 0 },
/* U+84a7 */ { 0, 0, 0, 0, 0 },
/* U+84a8 */ { 0, 0, 0, 0, 0 },
/* U+84a9 */ { 0, 0, 0, 0, 0 },
/* U+84aa */ { 0, 0, 0, 0, 0 },
/* U+84ab */ { 0, 0, 0, 0, 0 },
/* U+84ac */ { 0, 0, 0, 0, 0 },
/* U+84ad */ { 0, 0, 0, 0, 0 },
/* U+84ae */ { 0, 0, 0, 0, 0 },
/* U+84af */ { 0, 0, 0, 0, 0 },
/* U+84b0 */ { 0, 0, 0, 0, 0 },
/* U+84b1 */ { 0, 0, 0, 0, 0 },
/* U+84b2 */ { 0, 0, 0, 0, 0 },
/* U+84b3 */ { 0, 0, 0, 0, 0 },
/* U+84b4 */ { 0, 0, 0, 0, 0 },
/* U+84b5 */ { 0, 0, 0, 0, 0 },
/* U+84b6 */ { 0, 0, 0, 0, 0 },
/* U+84b7 */ { 0, 0, 0, 0, 0 },
/* U+84b8 */ { 0, 0, 0, 0, 0 },
/* U+84b9 */ { 0, 0, 0, 0, 0 },
/* U+84ba */ { 0, 0, 0, 0, 0 },
/* U+84bb */ { 0, 0, 0, 0, 0 },
/* U+84bc */ { 0, 0, 0, 0, 0 },
/* U+84bd */ { 0, 0, 0, 0, 0 },
/* U+84be */ { 0, 0, 0, 0, 0 },
/* U+84bf */ { 0, 0, 0, 0, 0 },
/* U+84c0 */ { 0, 0, 0, 0, 0 },
/* U+84c1 */ { 0, 0, 0, 0, 0 },
/* U+84c2 */ { 0, 0, 0, 0, 0 },
/* U+84c3 */ { 0, 0, 0, 0, 0 },
/* U+84c4 */ { 0, 0, 0, 0, 0 },
/* U+84c5 */ { 0, 0, 0, 0, 0 },
/* U+84c6 */ { 0, 0, 0, 0, 0 },
/* U+84c7 */ { 0, 0, 0, 0, 0 },
/* U+84c8 */ { 0, 0, 0, 0, 0 },
/* U+84c9 */ { 0, 0, 0, 0, 0 },
/* U+84ca */ { 0, 0, 0, 0, 0 },
/* U+84cb */ { 0, 0, 0, 0, 0 },
/* U+84cc */ { 0, 0, 0, 0, 0 },
/* U+84cd */ { 0, 0, 0, 0, 0 },
/* U+84ce */ { 0, 0, 0, 0, 0 },
/* U+84cf */ { 0, 0, 0, 0, 0 },
/* U+84d0 */ { 0, 0, 0, 0, 0 },
/* U+84d1 */ { 0, 0, 0, 0, 0 },
/* U+84d2 */ { 0, 0, 0, 0, 0 },
/* U+84d3 */ { 0, 0, 0, 0, 0 },
/* U+84d4 */ { 0, 0, 0, 0, 0 },
/* U+84d5 */ { 0, 0, 0, 0, 0 },
/* U+84d6 */ { 0, 0, 0, 0, 0 },
/* U+84d7 */ { 0, 0, 0, 0, 0 },
/* U+84d8 */ { 0, 0, 0, 0, 0 },
/* U+84d9 */ { 0, 0, 0, 0, 0 },
/* U+84da */ { 0, 0, 0, 0, 0 },
/* U+84db */ { 0, 0, 0, 0, 0 },
/* U+84dc */ { 0, 0, 0, 0, 0 },
/* U+84dd */ { 0, 0, 0, 0, 0 },
/* U+84de */ { 0, 0, 0, 0, 0 },
/* U+84df */ { 0, 0, 0, 0, 0 },
/* U+84e0 */ { 0, 0, 0, 0, 0 },
/* U+84e1 */ { 0, 0, 0, 0, 0 },
/* U+84e2 */ { 0, 0, 0, 0, 0 },
/* U+84e3 */ { 0, 0, 0, 0, 0 },
/* U+84e4 */ { 0, 0, 0, 0, 0 },
/* U+84e5 */ { 0, 0, 0, 0, 0 },
/* U+84e6 */ { 0, 0, 0, 0, 0 },
/* U+84e7 */ { 0, 0, 0, 0, 0 },
/* U+84e8 */ { 0, 0, 0, 0, 0 },
/* U+84e9 */ { 0, 0, 0, 0, 0 },
/* U+84ea */ { 0, 0, 0, 0, 0 },
/* U+84eb */ { 0, 0, 0, 0, 0 },
/* U+84ec */ { 0, 0, 0, 0, 0 },
/* U+84ed */ { 0, 0, 0, 0, 0 },
/* U+84ee */ { 0, 0, 0, 0, 0 },
/* U+84ef */ { 0, 0, 0, 0, 0 },
/* U+84f0 */ { 0, 0, 0, 0, 0 },
/* U+84f1 */ { 0, 0, 0, 0, 0 },
/* U+84f2 */ { 0, 0, 0, 0, 0 },
/* U+84f3 */ { 0, 0, 0, 0, 0 },
/* U+84f4 */ { 0, 0, 0, 0, 0 },
/* U+84f5 */ { 0, 0, 0, 0, 0 },
/* U+84f6 */ { 0, 0, 0, 0, 0 },
/* U+84f7 */ { 0, 0, 0, 0, 0 },
/* U+84f8 */ { 0, 0, 0, 0, 0 },
/* U+84f9 */ { 0, 0, 0, 0, 0 },
/* U+84fa */ { 0, 0, 0, 0, 0 },
/* U+84fb */ { 0, 0, 0, 0, 0 },
/* U+84fc */ { 0, 0, 0, 0, 0 },
/* U+84fd */ { 0, 0, 0, 0, 0 },
/* U+84fe */ { 0, 0, 0, 0, 0 },
/* U+84ff */ { 0, 0, 0, 0, 0 },
/* U+8500 */ { 0, 0, 0, 0, 0 },
/* U+8501 */ { 0, 0, 0, 0, 0 },
/* U+8502 */ { 0, 0, 0, 0, 0 },
/* U+8503 */ { 0, 0, 0, 0, 0 },
/* U+8504 */ { 0, 0, 0, 0, 0 },
/* U+8505 */ { 0, 0, 0, 0, 0 },
/* U+8506 */ { 0, 0, 0, 0, 0 },
/* U+8507 */ { 0, 0, 0, 0, 0 },
/* U+8508 */ { 0, 0, 0, 0, 0 },
/* U+8509 */ { 0, 0, 0, 0, 0 },
/* U+850a */ { 0, 0, 0, 0, 0 },
/* U+850b */ { 0, 0, 0, 0, 0 },
/* U+850c */ { 0, 0, 0, 0, 0 },
/* U+850d */ { 0, 0, 0, 0, 0 },
/* U+850e */ { 0, 0, 0, 0, 0 },
/* U+850f */ { 0, 0, 0, 0, 0 },
/* U+8510 */ { 0, 0, 0, 0, 0 },
/* U+8511 */ { 0, 0, 0, 0, 0 },
/* U+8512 */ { 0, 0, 0, 0, 0 },
/* U+8513 */ { 0, 0, 0, 0, 0 },
/* U+8514 */ { 0, 0, 0, 0, 0 },
/* U+8515 */ { 0, 0, 0, 0, 0 },
/* U+8516 */ { 0, 0, 0, 0, 0 },
/* U+8517 */ { 0, 0, 0, 0, 0 },
/* U+8518 */ { 0, 0, 0, 0, 0 },
/* U+8519 */ { 0, 0, 0, 0, 0 },
/* U+851a */ { 0, 0, 0, 0, 0 },
/* U+851b */ { 0, 0, 0, 0, 0 },
/* U+851c */ { 0, 0, 0, 0, 0 },
/* U+851d */ { 0, 0, 0, 0, 0 },
/* U+851e */ { 0, 0, 0, 0, 0 },
/* U+851f */ { 0, 0, 0, 0, 0 },
/* U+8520 */ { 0, 0, 0, 0, 0 },
/* U+8521 */ { 0, 0, 0, 0, 0 },
/* U+8522 */ { 0, 0, 0, 0, 0 },
/* U+8523 */ { 0, 0, 0, 0, 0 },
/* U+8524 */ { 0, 0, 0, 0, 0 },
/* U+8525 */ { 0, 0, 0, 0, 0 },
/* U+8526 */ { 0, 0, 0, 0, 0 },
/* U+8527 */ { 0, 0, 0, 0, 0 },
/* U+8528 */ { 0, 0, 0, 0, 0 },
/* U+8529 */ { 0, 0, 0, 0, 0 },
/* U+852a */ { 0, 0, 0, 0, 0 },
/* U+852b */ { 0, 0, 0, 0, 0 },
/* U+852c */ { 0, 0, 0, 0, 0 },
/* U+852d */ { 0, 0, 0, 0, 0 },
/* U+852e */ { 0, 0, 0, 0, 0 },
/* U+852f */ { 0, 0, 0, 0, 0 },
/* U+8530 */ { 0, 0, 0, 0, 0 },
/* U+8531 */ { 0, 0, 0, 0, 0 },
/* U+8532 */ { 0, 0, 0, 0, 0 },
/* U+8533 */ { 0, 0, 0, 0, 0 },
/* U+8534 */ { 0, 0, 0, 0, 0 },
/* U+8535 */ { 0, 0, 0, 0, 0 },
/* U+8536 */ { 0, 0, 0, 0, 0 },
/* U+8537 */ { 0, 0, 0, 0, 0 },
/* U+8538 */ { 0, 0, 0, 0, 0 },
/* U+8539 */ { 0, 0, 0, 0, 0 },
/* U+853a */ { 0, 0, 0, 0, 0 },
/* U+853b */ { 0, 0, 0, 0, 0 },
/* U+853c */ { 0, 0, 0, 0, 0 },
/* U+853d */ { 0, 0, 0, 0, 0 },
/* U+853e */ { 0, 0, 0, 0, 0 },
/* U+853f */ { 0, 0, 0, 0, 0 },
/* U+8540 */ { 0, 0, 0, 0, 0 },
/* U+8541 */ { 0, 0, 0, 0, 0 },
/* U+8542 */ { 0, 0, 0, 0, 0 },
/* U+8543 */ { 0, 0, 0, 0, 0 },
/* U+8544 */ { 0, 0, 0, 0, 0 },
/* U+8545 */ { 0, 0, 0, 0, 0 },
/* U+8546 */ { 0, 0, 0, 0, 0 },
/* U+8547 */ { 0, 0, 0, 0, 0 },
/* U+8548 */ { 0, 0, 0, 0, 0 },
/* U+8549 */ { 0, 0, 0, 0, 0 },
/* U+854a */ { 0, 0, 0, 0, 0 },
/* U+854b */ { 0, 0, 0, 0, 0 },
/* U+854c */ { 0, 0, 0, 0, 0 },
/* U+854d */ { 0, 0, 0, 0, 0 },
/* U+854e */ { 0, 0, 0, 0, 0 },
/* U+854f */ { 0, 0, 0, 0, 0 },
/* U+8550 */ { 0, 0, 0, 0, 0 },
/* U+8551 */ { 0, 0, 0, 0, 0 },
/* U+8552 */ { 0, 0, 0, 0, 0 },
/* U+8553 */ { 0, 0, 0, 0, 0 },
/* U+8554 */ { 0, 0, 0, 0, 0 },
/* U+8555 */ { 0, 0, 0, 0, 0 },
/* U+8556 */ { 0, 0, 0, 0, 0 },
/* U+8557 */ { 0, 0, 0, 0, 0 },
/* U+8558 */ { 0, 0, 0, 0, 0 },
/* U+8559 */ { 0, 0, 0, 0, 0 },
/* U+855a */ { 0, 0, 0, 0, 0 },
/* U+855b */ { 0, 0, 0, 0, 0 },
/* U+855c */ { 0, 0, 0, 0, 0 },
/* U+855d */ { 0, 0, 0, 0, 0 },
/* U+855e */ { 0, 0, 0, 0, 0 },
/* U+855f */ { 0, 0, 0, 0, 0 },
/* U+8560 */ { 0, 0, 0, 0, 0 },
/* U+8561 */ { 0, 0, 0, 0, 0 },
/* U+8562 */ { 0, 0, 0, 0, 0 },
/* U+8563 */ { 0, 0, 0, 0, 0 },
/* U+8564 */ { 0, 0, 0, 0, 0 },
/* U+8565 */ { 0, 0, 0, 0, 0 },
/* U+8566 */ { 0, 0, 0, 0, 0 },
/* U+8567 */ { 0, 0, 0, 0, 0 },
/* U+8568 */ { 0, 0, 0, 0, 0 },
/* U+8569 */ { 0, 0, 0, 0, 0 },
/* U+856a */ { 0, 0, 0, 0, 0 },
/* U+856b */ { 0, 0, 0, 0, 0 },
/* U+856c */ { 0, 0, 0, 0, 0 },
/* U+856d */ { 0, 0, 0, 0, 0 },
/* U+856e */ { 0, 0, 0, 0, 0 },
/* U+856f */ { 0, 0, 0, 0, 0 },
/* U+8570 */ { 0, 0, 0, 0, 0 },
/* U+8571 */ { 0, 0, 0, 0, 0 },
/* U+8572 */ { 0, 0, 0, 0, 0 },
/* U+8573 */ { 0, 0, 0, 0, 0 },
/* U+8574 */ { 0, 0, 0, 0, 0 },
/* U+8575 */ { 0, 0, 0, 0, 0 },
/* U+8576 */ { 0, 0, 0, 0, 0 },
/* U+8577 */ { 0, 0, 0, 0, 0 },
/* U+8578 */ { 0, 0, 0, 0, 0 },
/* U+8579 */ { 0, 0, 0, 0, 0 },
/* U+857a */ { 0, 0, 0, 0, 0 },
/* U+857b */ { 0, 0, 0, 0, 0 },
/* U+857c */ { 0, 0, 0, 0, 0 },
/* U+857d */ { 0, 0, 0, 0, 0 },
/* U+857e */ { 0, 0, 0, 0, 0 },
/* U+857f */ { 0, 0, 0, 0, 0 },
/* U+8580 */ { 0, 0, 0, 0, 0 },
/* U+8581 */ { 0, 0, 0, 0, 0 },
/* U+8582 */ { 0, 0, 0, 0, 0 },
/* U+8583 */ { 0, 0, 0, 0, 0 },
/* U+8584 */ { 0, 0, 0, 0, 0 },
/* U+8585 */ { 0, 0, 0, 0, 0 },
/* U+8586 */ { 0, 0, 0, 0, 0 },
/* U+8587 */ { 0, 0, 0, 0, 0 },
/* U+8588 */ { 0, 0, 0, 0, 0 },
/* U+8589 */ { 0, 0, 0, 0, 0 },
/* U+858a */ { 0, 0, 0, 0, 0 },
/* U+858b */ { 0, 0, 0, 0, 0 },
/* U+858c */ { 0, 0, 0, 0, 0 },
/* U+858d */ { 0, 0, 0, 0, 0 },
/* U+858e */ { 0, 0, 0, 0, 0 },
/* U+858f */ { 0, 0, 0, 0, 0 },
/* U+8590 */ { 0, 0, 0, 0, 0 },
/* U+8591 */ { 0, 0, 0, 0, 0 },
/* U+8592 */ { 0, 0, 0, 0, 0 },
/* U+8593 */ { 0, 0, 0, 0, 0 },
/* U+8594 */ { 0, 0, 0, 0, 0 },
/* U+8595 */ { 0, 0, 0, 0, 0 },
/* U+8596 */ { 0, 0, 0, 0, 0 },
/* U+8597 */ { 0, 0, 0, 0, 0 },
/* U+8598 */ { 0, 0, 0, 0, 0 },
/* U+8599 */ { 0, 0, 0, 0, 0 },
/* U+859a */ { 0, 0, 0, 0, 0 },
/* U+859b */ { 0, 0, 0, 0, 0 },
/* U+859c */ { 0, 0, 0, 0, 0 },
/* U+859d */ { 0, 0, 0, 0, 0 },
/* U+859e */ { 0, 0, 0, 0, 0 },
/* U+859f */ { 0, 0, 0, 0, 0 },
/* U+85a0 */ { 0, 0, 0, 0, 0 },
/* U+85a1 */ { 0, 0, 0, 0, 0 },
/* U+85a2 */ { 0, 0, 0, 0, 0 },
/* U+85a3 */ { 0, 0, 0, 0, 0 },
/* U+85a4 */ { 0, 0, 0, 0, 0 },
/* U+85a5 */ { 0, 0, 0, 0, 0 },
/* U+85a6 */ { 0, 0, 0, 0, 0 },
/* U+85a7 */ { 0, 0, 0, 0, 0 },
/* U+85a8 */ { 0, 0, 0, 0, 0 },
/* U+85a9 */ { 0, 0, 0, 0, 0 },
/* U+85aa */ { 0, 0, 0, 0, 0 },
/* U+85ab */ { 0, 0, 0, 0, 0 },
/* U+85ac */ { 0, 0, 0, 0, 0 },
/* U+85ad */ { 0, 0, 0, 0, 0 },
/* U+85ae */ { 0, 0, 0, 0, 0 },
/* U+85af */ { 0, 0, 0, 0, 0 },
/* U+85b0 */ { 0, 0, 0, 0, 0 },
/* U+85b1 */ { 0, 0, 0, 0, 0 },
/* U+85b2 */ { 0, 0, 0, 0, 0 },
/* U+85b3 */ { 0, 0, 0, 0, 0 },
/* U+85b4 */ { 0, 0, 0, 0, 0 },
/* U+85b5 */ { 0, 0, 0, 0, 0 },
/* U+85b6 */ { 0, 0, 0, 0, 0 },
/* U+85b7 */ { 0, 0, 0, 0, 0 },
/* U+85b8 */ { 0, 0, 0, 0, 0 },
/* U+85b9 */ { 0, 0, 0, 0, 0 },
/* U+85ba */ { 0, 0, 0, 0, 0 },
/* U+85bb */ { 0, 0, 0, 0, 0 },
/* U+85bc */ { 0, 0, 0, 0, 0 },
/* U+85bd */ { 0, 0, 0, 0, 0 },
/* U+85be */ { 0, 0, 0, 0, 0 },
/* U+85bf */ { 0, 0, 0, 0, 0 },
/* U+85c0 */ { 0, 0, 0, 0, 0 },
/* U+85c1 */ { 0, 0, 0, 0, 0 },
/* U+85c2 */ { 0, 0, 0, 0, 0 },
/* U+85c3 */ { 0, 0, 0, 0, 0 },
/* U+85c4 */ { 0, 0, 0, 0, 0 },
/* U+85c5 */ { 0, 0, 0, 0, 0 },
/* U+85c6 */ { 0, 0, 0, 0, 0 },
/* U+85c7 */ { 0, 0, 0, 0, 0 },
/* U+85c8 */ { 0, 0, 0, 0, 0 },
/* U+85c9 */ { 0, 0, 0, 0, 0 },
/* U+85ca */ { 0, 0, 0, 0, 0 },
/* U+85cb */ { 0, 0, 0, 0, 0 },
/* U+85cc */ { 0, 0, 0, 0, 0 },
/* U+85cd */ { 0, 0, 0, 0, 0 },
/* U+85ce */ { 0, 0, 0, 0, 0 },
/* U+85cf */ { 0, 0, 0, 0, 0 },
/* U+85d0 */ { 0, 0, 0, 0, 0 },
/* U+85d1 */ { 0, 0, 0, 0, 0 },
/* U+85d2 */ { 0, 0, 0, 0, 0 },
/* U+85d3 */ { 0, 0, 0, 0, 0 },
/* U+85d4 */ { 0, 0, 0, 0, 0 },
/* U+85d5 */ { 0, 0, 0, 0, 0 },
/* U+85d6 */ { 0, 0, 0, 0, 0 },
/* U+85d7 */ { 0, 0, 0, 0, 0 },
/* U+85d8 */ { 0, 0, 0, 0, 0 },
/* U+85d9 */ { 0, 0, 0, 0, 0 },
/* U+85da */ { 0, 0, 0, 0, 0 },
/* U+85db */ { 0, 0, 0, 0, 0 },
/* U+85dc */ { 0, 0, 0, 0, 0 },
/* U+85dd */ { 0, 0, 0, 0, 0 },
/* U+85de */ { 0, 0, 0, 0, 0 },
/* U+85df */ { 0, 0, 0, 0, 0 },
/* U+85e0 */ { 0, 0, 0, 0, 0 },
/* U+85e1 */ { 0, 0, 0, 0, 0 },
/* U+85e2 */ { 0, 0, 0, 0, 0 },
/* U+85e3 */ { 0, 0, 0, 0, 0 },
/* U+85e4 */ { 0, 0, 0, 0, 0 },
/* U+85e5 */ { 0, 0, 0, 0, 0 },
/* U+85e6 */ { 0, 0, 0, 0, 0 },
/* U+85e7 */ { 0, 0, 0, 0, 0 },
/* U+85e8 */ { 0, 0, 0, 0, 0 },
/* U+85e9 */ { 0, 0, 0, 0, 0 },
/* U+85ea */ { 0, 0, 0, 0, 0 },
/* U+85eb */ { 0, 0, 0, 0, 0 },
/* U+85ec */ { 0, 0, 0, 0, 0 },
/* U+85ed */ { 0, 0, 0, 0, 0 },
/* U+85ee */ { 0, 0, 0, 0, 0 },
/* U+85ef */ { 0, 0, 0, 0, 0 },
/* U+85f0 */ { 0, 0, 0, 0, 0 },
/* U+85f1 */ { 0, 0, 0, 0, 0 },
/* U+85f2 */ { 0, 0, 0, 0, 0 },
/* U+85f3 */ { 0, 0, 0, 0, 0 },
/* U+85f4 */ { 0, 0, 0, 0, 0 },
/* U+85f5 */ { 0, 0, 0, 0, 0 },
/* U+85f6 */ { 0, 0, 0, 0, 0 },
/* U+85f7 */ { 0, 0, 0, 0, 0 },
/* U+85f8 */ { 0, 0, 0, 0, 0 },
/* U+85f9 */ { 0, 0, 0, 0, 0 },
/* U+85fa */ { 0, 0, 0, 0, 0 },
/* U+85fb */ { 0, 0, 0, 0, 0 },
/* U+85fc */ { 0, 0, 0, 0, 0 },
/* U+85fd */ { 0, 0, 0, 0, 0 },
/* U+85fe */ { 0, 0, 0, 0, 0 },
/* U+85ff */ { 0, 0, 0, 0, 0 },
/* U+8600 */ { 0, 0, 0, 0, 0 },
/* U+8601 */ { 0, 0, 0, 0, 0 },
/* U+8602 */ { 0, 0, 0, 0, 0 },
/* U+8603 */ { 0, 0, 0, 0, 0 },
/* U+8604 */ { 0, 0, 0, 0, 0 },
/* U+8605 */ { 0, 0, 0, 0, 0 },
/* U+8606 */ { 0, 0, 0, 0, 0 },
/* U+8607 */ { 0, 0, 0, 0, 0 },
/* U+8608 */ { 0, 0, 0, 0, 0 },
/* U+8609 */ { 0, 0, 0, 0, 0 },
/* U+860a */ { 0, 0, 0, 0, 0 },
/* U+860b */ { 0, 0, 0, 0, 0 },
/* U+860c */ { 0, 0, 0, 0, 0 },
/* U+860d */ { 0, 0, 0, 0, 0 },
/* U+860e */ { 0, 0, 0, 0, 0 },
/* U+860f */ { 0, 0, 0, 0, 0 },
/* U+8610 */ { 0, 0, 0, 0, 0 },
/* U+8611 */ { 0, 0, 0, 0, 0 },
/* U+8612 */ { 0, 0, 0, 0, 0 },
/* U+8613 */ { 0, 0, 0, 0, 0 },
/* U+8614 */ { 0, 0, 0, 0, 0 },
/* U+8615 */ { 0, 0, 0, 0, 0 },
/* U+8616 */ { 0, 0, 0, 0, 0 },
/* U+8617 */ { 0, 0, 0, 0, 0 },
/* U+8618 */ { 0, 0, 0, 0, 0 },
/* U+8619 */ { 0, 0, 0, 0, 0 },
/* U+861a */ { 0, 0, 0, 0, 0 },
/* U+861b */ { 0, 0, 0, 0, 0 },
/* U+861c */ { 0, 0, 0, 0, 0 },
/* U+861d */ { 0, 0, 0, 0, 0 },
/* U+861e */ { 0, 0, 0, 0, 0 },
/* U+861f */ { 0, 0, 0, 0, 0 },
/* U+8620 */ { 0, 0, 0, 0, 0 },
/* U+8621 */ { 0, 0, 0, 0, 0 },
/* U+8622 */ { 0, 0, 0, 0, 0 },
/* U+8623 */ { 0, 0, 0, 0, 0 },
/* U+8624 */ { 0, 0, 0, 0, 0 },
/* U+8625 */ { 0, 0, 0, 0, 0 },
/* U+8626 */ { 0, 0, 0, 0, 0 },
/* U+8627 */ { 0, 0, 0, 0, 0 },
/* U+8628 */ { 0, 0, 0, 0, 0 },
/* U+8629 */ { 0, 0, 0, 0, 0 },
/* U+862a */ { 0, 0, 0, 0, 0 },
/* U+862b */ { 0, 0, 0, 0, 0 },
/* U+862c */ { 0, 0, 0, 0, 0 },
/* U+862d */ { 0, 0, 0, 0, 0 },
/* U+862e */ { 0, 0, 0, 0, 0 },
/* U+862f */ { 0, 0, 0, 0, 0 },
/* U+8630 */ { 0, 0, 0, 0, 0 },
/* U+8631 */ { 0, 0, 0, 0, 0 },
/* U+8632 */ { 0, 0, 0, 0, 0 },
/* U+8633 */ { 0, 0, 0, 0, 0 },
/* U+8634 */ { 0, 0, 0, 0, 0 },
/* U+8635 */ { 0, 0, 0, 0, 0 },
/* U+8636 */ { 0, 0, 0, 0, 0 },
/* U+8637 */ { 0, 0, 0, 0, 0 },
/* U+8638 */ { 0, 0, 0, 0, 0 },
/* U+8639 */ { 0, 0, 0, 0, 0 },
/* U+863a */ { 0, 0, 0, 0, 0 },
/* U+863b */ { 0, 0, 0, 0, 0 },
/* U+863c */ { 0, 0, 0, 0, 0 },
/* U+863d */ { 0, 0, 0, 0, 0 },
/* U+863e */ { 0, 0, 0, 0, 0 },
/* U+863f */ { 0, 0, 0, 0, 0 },
/* U+8640 */ { 0, 0, 0, 0, 0 },
/* U+8641 */ { 0, 0, 0, 0, 0 },
/* U+8642 */ { 0, 0, 0, 0, 0 },
/* U+8643 */ { 0, 0, 0, 0, 0 },
/* U+8644 */ { 0, 0, 0, 0, 0 },
/* U+8645 */ { 0, 0, 0, 0, 0 },
/* U+8646 */ { 0, 0, 0, 0, 0 },
/* U+8647 */ { 0, 0, 0, 0, 0 },
/* U+8648 */ { 0, 0, 0, 0, 0 },
/* U+8649 */ { 0, 0, 0, 0, 0 },
/* U+864a */ { 0, 0, 0, 0, 0 },
/* U+864b */ { 0, 0, 0, 0, 0 },
/* U+864c */ { 0, 0, 0, 0, 0 },
/* U+864d */ { 0, 0, 0, 0, 0 },
/* U+864e */ { 0, 0, 0, 0, 0 },
/* U+864f */ { 0, 0, 0, 0, 0 },
/* U+8650 */ { 0, 0, 0, 0, 0 },
/* U+8651 */ { 0, 0, 0, 0, 0 },
/* U+8652 */ { 0, 0, 0, 0, 0 },
/* U+8653 */ { 0, 0, 0, 0, 0 },
/* U+8654 */ { 0, 0, 0, 0, 0 },
/* U+8655 */ { 0, 0, 0, 0, 0 },
/* U+8656 */ { 0, 0, 0, 0, 0 },
/* U+8657 */ { 0, 0, 0, 0, 0 },
/* U+8658 */ { 0, 0, 0, 0, 0 },
/* U+8659 */ { 0, 0, 0, 0, 0 },
/* U+865a */ { 0, 0, 0, 0, 0 },
/* U+865b */ { 0, 0, 0, 0, 0 },
/* U+865c */ { 0, 0, 0, 0, 0 },
/* U+865d */ { 0, 0, 0, 0, 0 },
/* U+865e */ { 0, 0, 0, 0, 0 },
/* U+865f */ { 0, 0, 0, 0, 0 },
/* U+8660 */ { 0, 0, 0, 0, 0 },
/* U+8661 */ { 0, 0, 0, 0, 0 },
/* U+8662 */ { 0, 0, 0, 0, 0 },
/* U+8663 */ { 0, 0, 0, 0, 0 },
/* U+8664 */ { 0, 0, 0, 0, 0 },
/* U+8665 */ { 0, 0, 0, 0, 0 },
/* U+8666 */ { 0, 0, 0, 0, 0 },
/* U+8667 */ { 0, 0, 0, 0, 0 },
/* U+8668 */ { 0, 0, 0, 0, 0 },
/* U+8669 */ { 0, 0, 0, 0, 0 },
/* U+866a */ { 0, 0, 0, 0, 0 },
/* U+866b */ { 0, 0, 0, 0, 0 },
/* U+866c */ { 0, 0, 0, 0, 0 },
/* U+866d */ { 0, 0, 0, 0, 0 },
/* U+866e */ { 0, 0, 0, 0, 0 },
/* U+866f */ { 0, 0, 0, 0, 0 },
/* U+8670 */ { 0, 0, 0, 0, 0 },
/* U+8671 */ { 0, 0, 0, 0, 0 },
/* U+8672 */ { 0, 0, 0, 0, 0 },
/* U+8673 */ { 0, 0, 0, 0, 0 },
/* U+8674 */ { 0, 0, 0, 0, 0 },
/* U+8675 */ { 0, 0, 0, 0, 0 },
/* U+8676 */ { 0, 0, 0, 0, 0 },
/* U+8677 */ { 0, 0, 0, 0, 0 },
/* U+8678 */ { 0, 0, 0, 0, 0 },
/* U+8679 */ { 0, 0, 0, 0, 0 },
/* U+867a */ { 0, 0, 0, 0, 0 },
/* U+867b */ { 0, 0, 0, 0, 0 },
/* U+867c */ { 0, 0, 0, 0, 0 },
/* U+867d */ { 0, 0, 0, 0, 0 },
/* U+867e */ { 0, 0, 0, 0, 0 },
/* U+867f */ { 0, 0, 0, 0, 0 },
/* U+8680 */ { 0, 0, 0, 0, 0 },
/* U+8681 */ { 0, 0, 0, 0, 0 },
/* U+8682 */ { 0, 0, 0, 0, 0 },
/* U+8683 */ { 0, 0, 0, 0, 0 },
/* U+8684 */ { 0, 0, 0, 0, 0 },
/* U+8685 */ { 0, 0, 0, 0, 0 },
/* U+8686 */ { 0, 0, 0, 0, 0 },
/* U+8687 */ { 0, 0, 0, 0, 0 },
/* U+8688 */ { 0, 0, 0, 0, 0 },
/* U+8689 */ { 0, 0, 0, 0, 0 },
/* U+868a */ { 0, 0, 0, 0, 0 },
/* U+868b */ { 0, 0, 0, 0, 0 },
/* U+868c */ { 0, 0, 0, 0, 0 },
/* U+868d */ { 0, 0, 0, 0, 0 },
/* U+868e */ { 0, 0, 0, 0, 0 },
/* U+868f */ { 0, 0, 0, 0, 0 },
/* U+8690 */ { 0, 0, 0, 0, 0 },
/* U+8691 */ { 0, 0, 0, 0, 0 },
/* U+8692 */ { 0, 0, 0, 0, 0 },
/* U+8693 */ { 0, 0, 0, 0, 0 },
/* U+8694 */ { 0, 0, 0, 0, 0 },
/* U+8695 */ { 0, 0, 0, 0, 0 },
/* U+8696 */ { 0, 0, 0, 0, 0 },
/* U+8697 */ { 0, 0, 0, 0, 0 },
/* U+8698 */ { 0, 0, 0, 0, 0 },
/* U+8699 */ { 0, 0, 0, 0, 0 },
/* U+869a */ { 0, 0, 0, 0, 0 },
/* U+869b */ { 0, 0, 0, 0, 0 },
/* U+869c */ { 0, 0, 0, 0, 0 },
/* U+869d */ { 0, 0, 0, 0, 0 },
/* U+869e */ { 0, 0, 0, 0, 0 },
/* U+869f */ { 0, 0, 0, 0, 0 },
/* U+86a0 */ { 0, 0, 0, 0, 0 },
/* U+86a1 */ { 0, 0, 0, 0, 0 },
/* U+86a2 */ { 0, 0, 0, 0, 0 },
/* U+86a3 */ { 0, 0, 0, 0, 0 },
/* U+86a4 */ { 0, 0, 0, 0, 0 },
/* U+86a5 */ { 0, 0, 0, 0, 0 },
/* U+86a6 */ { 0, 0, 0, 0, 0 },
/* U+86a7 */ { 0, 0, 0, 0, 0 },
/* U+86a8 */ { 0, 0, 0, 0, 0 },
/* U+86a9 */ { 0, 0, 0, 0, 0 },
/* U+86aa */ { 0, 0, 0, 0, 0 },
/* U+86ab */ { 0, 0, 0, 0, 0 },
/* U+86ac */ { 0, 0, 0, 0, 0 },
/* U+86ad */ { 0, 0, 0, 0, 0 },
/* U+86ae */ { 0, 0, 0, 0, 0 },
/* U+86af */ { 0, 0, 0, 0, 0 },
/* U+86b0 */ { 0, 0, 0, 0, 0 },
/* U+86b1 */ { 0, 0, 0, 0, 0 },
/* U+86b2 */ { 0, 0, 0, 0, 0 },
/* U+86b3 */ { 0, 0, 0, 0, 0 },
/* U+86b4 */ { 0, 0, 0, 0, 0 },
/* U+86b5 */ { 0, 0, 0, 0, 0 },
/* U+86b6 */ { 0, 0, 0, 0, 0 },
/* U+86b7 */ { 0, 0, 0, 0, 0 },
/* U+86b8 */ { 0, 0, 0, 0, 0 },
/* U+86b9 */ { 0, 0, 0, 0, 0 },
/* U+86ba */ { 0, 0, 0, 0, 0 },
/* U+86bb */ { 0, 0, 0, 0, 0 },
/* U+86bc */ { 0, 0, 0, 0, 0 },
/* U+86bd */ { 0, 0, 0, 0, 0 },
/* U+86be */ { 0, 0, 0, 0, 0 },
/* U+86bf */ { 0, 0, 0, 0, 0 },
/* U+86c0 */ { 0, 0, 0, 0, 0 },
/* U+86c1 */ { 0, 0, 0, 0, 0 },
/* U+86c2 */ { 0, 0, 0, 0, 0 },
/* U+86c3 */ { 0, 0, 0, 0, 0 },
/* U+86c4 */ { 0, 0, 0, 0, 0 },
/* U+86c5 */ { 0, 0, 0, 0, 0 },
/* U+86c6 */ { 0, 0, 0, 0, 0 },
/* U+86c7 */ { 0, 0, 0, 0, 0 },
/* U+86c8 */ { 0, 0, 0, 0, 0 },
/* U+86c9 */ { 0, 0, 0, 0, 0 },
/* U+86ca */ { 0, 0, 0, 0, 0 },
/* U+86cb */ { 0, 0, 0, 0, 0 },
/* U+86cc */ { 0, 0, 0, 0, 0 },
/* U+86cd */ { 0, 0, 0, 0, 0 },
/* U+86ce */ { 0, 0, 0, 0, 0 },
/* U+86cf */ { 0, 0, 0, 0, 0 },
/* U+86d0 */ { 0, 0, 0, 0, 0 },
/* U+86d1 */ { 0, 0, 0, 0, 0 },
/* U+86d2 */ { 0, 0, 0, 0, 0 },
/* U+86d3 */ { 0, 0, 0, 0, 0 },
/* U+86d4 */ { 0, 0, 0, 0, 0 },
/* U+86d5 */ { 0, 0, 0, 0, 0 },
/* U+86d6 */ { 0, 0, 0, 0, 0 },
/* U+86d7 */ { 0, 0, 0, 0, 0 },
/* U+86d8 */ { 0, 0, 0, 0, 0 },
/* U+86d9 */ { 0, 0, 0, 0, 0 },
/* U+86da */ { 0, 0, 0, 0, 0 },
/* U+86db */ { 0, 0, 0, 0, 0 },
/* U+86dc */ { 0, 0, 0, 0, 0 },
/* U+86dd */ { 0, 0, 0, 0, 0 },
/* U+86de */ { 0, 0, 0, 0, 0 },
/* U+86df */ { 0, 0, 0, 0, 0 },
/* U+86e0 */ { 0, 0, 0, 0, 0 },
/* U+86e1 */ { 0, 0, 0, 0, 0 },
/* U+86e2 */ { 0, 0, 0, 0, 0 },
/* U+86e3 */ { 0, 0, 0, 0, 0 },
/* U+86e4 */ { 0, 0, 0, 0, 0 },
/* U+86e5 */ { 0, 0, 0, 0, 0 },
/* U+86e6 */ { 0, 0, 0, 0, 0 },
/* U+86e7 */ { 0, 0, 0, 0, 0 },
/* U+86e8 */ { 0, 0, 0, 0, 0 },
/* U+86e9 */ { 0, 0, 0, 0, 0 },
/* U+86ea */ { 0, 0, 0, 0, 0 },
/* U+86eb */ { 0, 0, 0, 0, 0 },
/* U+86ec */ { 0, 0, 0, 0, 0 },
/* U+86ed */ { 0, 0, 0, 0, 0 },
/* U+86ee */ { 0, 0, 0, 0, 0 },
/* U+86ef */ { 0, 0, 0, 0, 0 },
/* U+86f0 */ { 0, 0, 0, 0, 0 },
/* U+86f1 */ { 0, 0, 0, 0, 0 },
/* U+86f2 */ { 0, 0, 0, 0, 0 },
/* U+86f3 */ { 0, 0, 0, 0, 0 },
/* U+86f4 */ { 0, 0, 0, 0, 0 },
/* U+86f5 */ { 0, 0, 0, 0, 0 },
/* U+86f6 */ { 0, 0, 0, 0, 0 },
/* U+86f7 */ { 0, 0, 0, 0, 0 },
/* U+86f8 */ { 0, 0, 0, 0, 0 },
/* U+86f9 */ { 0, 0, 0, 0, 0 },
/* U+86fa */ { 0, 0, 0, 0, 0 },
/* U+86fb */ { 0, 0, 0, 0, 0 },
/* U+86fc */ { 0, 0, 0, 0, 0 },
/* U+86fd */ { 0, 0, 0, 0, 0 },
/* U+86fe */ { 0, 0, 0, 0, 0 },
/* U+86ff */ { 0, 0, 0, 0, 0 },
/* U+8700 */ { 0, 0, 0, 0, 0 },
/* U+8701 */ { 0, 0, 0, 0, 0 },
/* U+8702 */ { 0, 0, 0, 0, 0 },
/* U+8703 */ { 0, 0, 0, 0, 0 },
/* U+8704 */ { 0, 0, 0, 0, 0 },
/* U+8705 */ { 0, 0, 0, 0, 0 },
/* U+8706 */ { 0, 0, 0, 0, 0 },
/* U+8707 */ { 0, 0, 0, 0, 0 },
/* U+8708 */ { 0, 0, 0, 0, 0 },
/* U+8709 */ { 0, 0, 0, 0, 0 },
/* U+870a */ { 0, 0, 0, 0, 0 },
/* U+870b */ { 0, 0, 0, 0, 0 },
/* U+870c */ { 0, 0, 0, 0, 0 },
/* U+870d */ { 0, 0, 0, 0, 0 },
/* U+870e */ { 0, 0, 0, 0, 0 },
/* U+870f */ { 0, 0, 0, 0, 0 },
/* U+8710 */ { 0, 0, 0, 0, 0 },
/* U+8711 */ { 0, 0, 0, 0, 0 },
/* U+8712 */ { 0, 0, 0, 0, 0 },
/* U+8713 */ { 0, 0, 0, 0, 0 },
/* U+8714 */ { 0, 0, 0, 0, 0 },
/* U+8715 */ { 0, 0, 0, 0, 0 },
/* U+8716 */ { 0, 0, 0, 0, 0 },
/* U+8717 */ { 0, 0, 0, 0, 0 },
/* U+8718 */ { 0, 0, 0, 0, 0 },
/* U+8719 */ { 0, 0, 0, 0, 0 },
/* U+871a */ { 0, 0, 0, 0, 0 },
/* U+871b */ { 0, 0, 0, 0, 0 },
/* U+871c */ { 0, 0, 0, 0, 0 },
/* U+871d */ { 0, 0, 0, 0, 0 },
/* U+871e */ { 0, 0, 0, 0, 0 },
/* U+871f */ { 0, 0, 0, 0, 0 },
/* U+8720 */ { 0, 0, 0, 0, 0 },
/* U+8721 */ { 0, 0, 0, 0, 0 },
/* U+8722 */ { 0, 0, 0, 0, 0 },
/* U+8723 */ { 0, 0, 0, 0, 0 },
/* U+8724 */ { 0, 0, 0, 0, 0 },
/* U+8725 */ { 0, 0, 0, 0, 0 },
/* U+8726 */ { 0, 0, 0, 0, 0 },
/* U+8727 */ { 0, 0, 0, 0, 0 },
/* U+8728 */ { 0, 0, 0, 0, 0 },
/* U+8729 */ { 0, 0, 0, 0, 0 },
/* U+872a */ { 0, 0, 0, 0, 0 },
/* U+872b */ { 0, 0, 0, 0, 0 },
/* U+872c */ { 0, 0, 0, 0, 0 },
/* U+872d */ { 0, 0, 0, 0, 0 },
/* U+872e */ { 0, 0, 0, 0, 0 },
/* U+872f */ { 0, 0, 0, 0, 0 },
/* U+8730 */ { 0, 0, 0, 0, 0 },
/* U+8731 */ { 0, 0, 0, 0, 0 },
/* U+8732 */ { 0, 0, 0, 0, 0 },
/* U+8733 */ { 0, 0, 0, 0, 0 },
/* U+8734 */ { 0, 0, 0, 0, 0 },
/* U+8735 */ { 0, 0, 0, 0, 0 },
/* U+8736 */ { 0, 0, 0, 0, 0 },
/* U+8737 */ { 0, 0, 0, 0, 0 },
/* U+8738 */ { 0, 0, 0, 0, 0 },
/* U+8739 */ { 0, 0, 0, 0, 0 },
/* U+873a */ { 0, 0, 0, 0, 0 },
/* U+873b */ { 0, 0, 0, 0, 0 },
/* U+873c */ { 0, 0, 0, 0, 0 },
/* U+873d */ { 0, 0, 0, 0, 0 },
/* U+873e */ { 0, 0, 0, 0, 0 },
/* U+873f */ { 0, 0, 0, 0, 0 },
/* U+8740 */ { 0, 0, 0, 0, 0 },
/* U+8741 */ { 0, 0, 0, 0, 0 },
/* U+8742 */ { 0, 0, 0, 0, 0 },
/* U+8743 */ { 0, 0, 0, 0, 0 },
/* U+8744 */ { 0, 0, 0, 0, 0 },
/* U+8745 */ { 0, 0, 0, 0, 0 },
/* U+8746 */ { 0, 0, 0, 0, 0 },
/* U+8747 */ { 0, 0, 0, 0, 0 },
/* U+8748 */ { 0, 0, 0, 0, 0 },
/* U+8749 */ { 0, 0, 0, 0, 0 },
/* U+874a */ { 0, 0, 0, 0, 0 },
/* U+874b */ { 0, 0, 0, 0, 0 },
/* U+874c */ { 0, 0, 0, 0, 0 },
/* U+874d */ { 0, 0, 0, 0, 0 },
/* U+874e */ { 0, 0, 0, 0, 0 },
/* U+874f */ { 0, 0, 0, 0, 0 },
/* U+8750 */ { 0, 0, 0, 0, 0 },
/* U+8751 */ { 0, 0, 0, 0, 0 },
/* U+8752 */ { 0, 0, 0, 0, 0 },
/* U+8753 */ { 0, 0, 0, 0, 0 },
/* U+8754 */ { 0, 0, 0, 0, 0 },
/* U+8755 */ { 0, 0, 0, 0, 0 },
/* U+8756 */ { 0, 0, 0, 0, 0 },
/* U+8757 */ { 0, 0, 0, 0, 0 },
/* U+8758 */ { 0, 0, 0, 0, 0 },
/* U+8759 */ { 0, 0, 0, 0, 0 },
/* U+875a */ { 0, 0, 0, 0, 0 },
/* U+875b */ { 0, 0, 0, 0, 0 },
/* U+875c */ { 0, 0, 0, 0, 0 },
/* U+875d */ { 0, 0, 0, 0, 0 },
/* U+875e */ { 0, 0, 0, 0, 0 },
/* U+875f */ { 0, 0, 0, 0, 0 },
/* U+8760 */ { 0, 0, 0, 0, 0 },
/* U+8761 */ { 0, 0, 0, 0, 0 },
/* U+8762 */ { 0, 0, 0, 0, 0 },
/* U+8763 */ { 0, 0, 0, 0, 0 },
/* U+8764 */ { 0, 0, 0, 0, 0 },
/* U+8765 */ { 0, 0, 0, 0, 0 },
/* U+8766 */ { 0, 0, 0, 0, 0 },
/* U+8767 */ { 0, 0, 0, 0, 0 },
/* U+8768 */ { 0, 0, 0, 0, 0 },
/* U+8769 */ { 0, 0, 0, 0, 0 },
/* U+876a */ { 0, 0, 0, 0, 0 },
/* U+876b */ { 0, 0, 0, 0, 0 },
/* U+876c */ { 0, 0, 0, 0, 0 },
/* U+876d */ { 0, 0, 0, 0, 0 },
/* U+876e */ { 0, 0, 0, 0, 0 },
/* U+876f */ { 0, 0, 0, 0, 0 },
/* U+8770 */ { 0, 0, 0, 0, 0 },
/* U+8771 */ { 0, 0, 0, 0, 0 },
/* U+8772 */ { 0, 0, 0, 0, 0 },
/* U+8773 */ { 0, 0, 0, 0, 0 },
/* U+8774 */ { 0, 0, 0, 0, 0 },
/* U+8775 */ { 0, 0, 0, 0, 0 },
/* U+8776 */ { 0, 0, 0, 0, 0 },
/* U+8777 */ { 0, 0, 0, 0, 0 },
/* U+8778 */ { 0, 0, 0, 0, 0 },
/* U+8779 */ { 0, 0, 0, 0, 0 },
/* U+877a */ { 0, 0, 0, 0, 0 },
/* U+877b */ { 0, 0, 0, 0, 0 },
/* U+877c */ { 0, 0, 0, 0, 0 },
/* U+877d */ { 0, 0, 0, 0, 0 },
/* U+877e */ { 0, 0, 0, 0, 0 },
/* U+877f */ { 0, 0, 0, 0, 0 },
/* U+8780 */ { 0, 0, 0, 0, 0 },
/* U+8781 */ { 0, 0, 0, 0, 0 },
/* U+8782 */ { 0, 0, 0, 0, 0 },
/* U+8783 */ { 0, 0, 0, 0, 0 },
/* U+8784 */ { 0, 0, 0, 0, 0 },
/* U+8785 */ { 0, 0, 0, 0, 0 },
/* U+8786 */ { 0, 0, 0, 0, 0 },
/* U+8787 */ { 0, 0, 0, 0, 0 },
/* U+8788 */ { 0, 0, 0, 0, 0 },
/* U+8789 */ { 0, 0, 0, 0, 0 },
/* U+878a */ { 0, 0, 0, 0, 0 },
/* U+878b */ { 0, 0, 0, 0, 0 },
/* U+878c */ { 0, 0, 0, 0, 0 },
/* U+878d */ { 0, 0, 0, 0, 0 },
/* U+878e */ { 0, 0, 0, 0, 0 },
/* U+878f */ { 0, 0, 0, 0, 0 },
/* U+8790 */ { 0, 0, 0, 0, 0 },
/* U+8791 */ { 0, 0, 0, 0, 0 },
/* U+8792 */ { 0, 0, 0, 0, 0 },
/* U+8793 */ { 0, 0, 0, 0, 0 },
/* U+8794 */ { 0, 0, 0, 0, 0 },
/* U+8795 */ { 0, 0, 0, 0, 0 },
/* U+8796 */ { 0, 0, 0, 0, 0 },
/* U+8797 */ { 0, 0, 0, 0, 0 },
/* U+8798 */ { 0, 0, 0, 0, 0 },
/* U+8799 */ { 0, 0, 0, 0, 0 },
/* U+879a */ { 0, 0, 0, 0, 0 },
/* U+879b */ { 0, 0, 0, 0, 0 },
/* U+879c */ { 0, 0, 0, 0, 0 },
/* U+879d */ { 0, 0, 0, 0, 0 },
/* U+879e */ { 0, 0, 0, 0, 0 },
/* U+879f */ { 0, 0, 0, 0, 0 },
/* U+87a0 */ { 0, 0, 0, 0, 0 },
/* U+87a1 */ { 0, 0, 0, 0, 0 },
/* U+87a2 */ { 0, 0, 0, 0, 0 },
/* U+87a3 */ { 0, 0, 0, 0, 0 },
/* U+87a4 */ { 0, 0, 0, 0, 0 },
/* U+87a5 */ { 0, 0, 0, 0, 0 },
/* U+87a6 */ { 0, 0, 0, 0, 0 },
/* U+87a7 */ { 0, 0, 0, 0, 0 },
/* U+87a8 */ { 0, 0, 0, 0, 0 },
/* U+87a9 */ { 0, 0, 0, 0, 0 },
/* U+87aa */ { 0, 0, 0, 0, 0 },
/* U+87ab */ { 0, 0, 0, 0, 0 },
/* U+87ac */ { 0, 0, 0, 0, 0 },
/* U+87ad */ { 0, 0, 0, 0, 0 },
/* U+87ae */ { 0, 0, 0, 0, 0 },
/* U+87af */ { 0, 0, 0, 0, 0 },
/* U+87b0 */ { 0, 0, 0, 0, 0 },
/* U+87b1 */ { 0, 0, 0, 0, 0 },
/* U+87b2 */ { 0, 0, 0, 0, 0 },
/* U+87b3 */ { 0, 0, 0, 0, 0 },
/* U+87b4 */ { 0, 0, 0, 0, 0 },
/* U+87b5 */ { 0, 0, 0, 0, 0 },
/* U+87b6 */ { 0, 0, 0, 0, 0 },
/* U+87b7 */ { 0, 0, 0, 0, 0 },
/* U+87b8 */ { 0, 0, 0, 0, 0 },
/* U+87b9 */ { 0, 0, 0, 0, 0 },
/* U+87ba */ { 0, 0, 0, 0, 0 },
/* U+87bb */ { 0, 0, 0, 0, 0 },
/* U+87bc */ { 0, 0, 0, 0, 0 },
/* U+87bd */ { 0, 0, 0, 0, 0 },
/* U+87be */ { 0, 0, 0, 0, 0 },
/* U+87bf */ { 0, 0, 0, 0, 0 },
/* U+87c0 */ { 0, 0, 0, 0, 0 },
/* U+87c1 */ { 0, 0, 0, 0, 0 },
/* U+87c2 */ { 0, 0, 0, 0, 0 },
/* U+87c3 */ { 0, 0, 0, 0, 0 },
/* U+87c4 */ { 0, 0, 0, 0, 0 },
/* U+87c5 */ { 0, 0, 0, 0, 0 },
/* U+87c6 */ { 0, 0, 0, 0, 0 },
/* U+87c7 */ { 0, 0, 0, 0, 0 },
/* U+87c8 */ { 0, 0, 0, 0, 0 },
/* U+87c9 */ { 0, 0, 0, 0, 0 },
/* U+87ca */ { 0, 0, 0, 0, 0 },
/* U+87cb */ { 0, 0, 0, 0, 0 },
/* U+87cc */ { 0, 0, 0, 0, 0 },
/* U+87cd */ { 0, 0, 0, 0, 0 },
/* U+87ce */ { 0, 0, 0, 0, 0 },
/* U+87cf */ { 0, 0, 0, 0, 0 },
/* U+87d0 */ { 0, 0, 0, 0, 0 },
/* U+87d1 */ { 0, 0, 0, 0, 0 },
/* U+87d2 */ { 0, 0, 0, 0, 0 },
/* U+87d3 */ { 0, 0, 0, 0, 0 },
/* U+87d4 */ { 0, 0, 0, 0, 0 },
/* U+87d5 */ { 0, 0, 0, 0, 0 },
/* U+87d6 */ { 0, 0, 0, 0, 0 },
/* U+87d7 */ { 0, 0, 0, 0, 0 },
/* U+87d8 */ { 0, 0, 0, 0, 0 },
/* U+87d9 */ { 0, 0, 0, 0, 0 },
/* U+87da */ { 0, 0, 0, 0, 0 },
/* U+87db */ { 0, 0, 0, 0, 0 },
/* U+87dc */ { 0, 0, 0, 0, 0 },
/* U+87dd */ { 0, 0, 0, 0, 0 },
/* U+87de */ { 0, 0, 0, 0, 0 },
/* U+87df */ { 0, 0, 0, 0, 0 },
/* U+87e0 */ { 0, 0, 0, 0, 0 },
/* U+87e1 */ { 0, 0, 0, 0, 0 },
/* U+87e2 */ { 0, 0, 0, 0, 0 },
/* U+87e3 */ { 0, 0, 0, 0, 0 },
/* U+87e4 */ { 0, 0, 0, 0, 0 },
/* U+87e5 */ { 0, 0, 0, 0, 0 },
/* U+87e6 */ { 0, 0, 0, 0, 0 },
/* U+87e7 */ { 0, 0, 0, 0, 0 },
/* U+87e8 */ { 0, 0, 0, 0, 0 },
/* U+87e9 */ { 0, 0, 0, 0, 0 },
/* U+87ea */ { 0, 0, 0, 0, 0 },
/* U+87eb */ { 0, 0, 0, 0, 0 },
/* U+87ec */ { 0, 0, 0, 0, 0 },
/* U+87ed */ { 0, 0, 0, 0, 0 },
/* U+87ee */ { 0, 0, 0, 0, 0 },
/* U+87ef */ { 0, 0, 0, 0, 0 },
/* U+87f0 */ { 0, 0, 0, 0, 0 },
/* U+87f1 */ { 0, 0, 0, 0, 0 },
/* U+87f2 */ { 0, 0, 0, 0, 0 },
/* U+87f3 */ { 0, 0, 0, 0, 0 },
/* U+87f4 */ { 0, 0, 0, 0, 0 },
/* U+87f5 */ { 0, 0, 0, 0, 0 },
/* U+87f6 */ { 0, 0, 0, 0, 0 },
/* U+87f7 */ { 0, 0, 0, 0, 0 },
/* U+87f8 */ { 0, 0, 0, 0, 0 },
/* U+87f9 */ { 0, 0, 0, 0, 0 },
/* U+87fa */ { 0, 0, 0, 0, 0 },
/* U+87fb */ { 0, 0, 0, 0, 0 },
/* U+87fc */ { 0, 0, 0, 0, 0 },
/* U+87fd */ { 0, 0, 0, 0, 0 },
/* U+87fe */ { 0, 0, 0, 0, 0 },
/* U+87ff */ { 0, 0, 0, 0, 0 },
/* U+8800 */ { 0, 0, 0, 0, 0 },
/* U+8801 */ { 0, 0, 0, 0, 0 },
/* U+8802 */ { 0, 0, 0, 0, 0 },
/* U+8803 */ { 0, 0, 0, 0, 0 },
/* U+8804 */ { 0, 0, 0, 0, 0 },
/* U+8805 */ { 0, 0, 0, 0, 0 },
/* U+8806 */ { 0, 0, 0, 0, 0 },
/* U+8807 */ { 0, 0, 0, 0, 0 },
/* U+8808 */ { 0, 0, 0, 0, 0 },
/* U+8809 */ { 0, 0, 0, 0, 0 },
/* U+880a */ { 0, 0, 0, 0, 0 },
/* U+880b */ { 0, 0, 0, 0, 0 },
/* U+880c */ { 0, 0, 0, 0, 0 },
/* U+880d */ { 0, 0, 0, 0, 0 },
/* U+880e */ { 0, 0, 0, 0, 0 },
/* U+880f */ { 0, 0, 0, 0, 0 },
/* U+8810 */ { 0, 0, 0, 0, 0 },
/* U+8811 */ { 0, 0, 0, 0, 0 },
/* U+8812 */ { 0, 0, 0, 0, 0 },
/* U+8813 */ { 0, 0, 0, 0, 0 },
/* U+8814 */ { 0, 0, 0, 0, 0 },
/* U+8815 */ { 0, 0, 0, 0, 0 },
/* U+8816 */ { 0, 0, 0, 0, 0 },
/* U+8817 */ { 0, 0, 0, 0, 0 },
/* U+8818 */ { 0, 0, 0, 0, 0 },
/* U+8819 */ { 0, 0, 0, 0, 0 },
/* U+881a */ { 0, 0, 0, 0, 0 },
/* U+881b */ { 0, 0, 0, 0, 0 },
/* U+881c */ { 0, 0, 0, 0, 0 },
/* U+881d */ { 0, 0, 0, 0, 0 },
/* U+881e */ { 0, 0, 0, 0, 0 },
/* U+881f */ { 0, 0, 0, 0, 0 },
/* U+8820 */ { 0, 0, 0, 0, 0 },
/* U+8821 */ { 0, 0, 0, 0, 0 },
/* U+8822 */ { 0, 0, 0, 0, 0 },
/* U+8823 */ { 0, 0, 0, 0, 0 },
/* U+8824 */ { 0, 0, 0, 0, 0 },
/* U+8825 */ { 0, 0, 0, 0, 0 },
/* U+8826 */ { 0, 0, 0, 0, 0 },
/* U+8827 */ { 0, 0, 0, 0, 0 },
/* U+8828 */ { 0, 0, 0, 0, 0 },
/* U+8829 */ { 0, 0, 0, 0, 0 },
/* U+882a */ { 0, 0, 0, 0, 0 },
/* U+882b */ { 0, 0, 0, 0, 0 },
/* U+882c */ { 0, 0, 0, 0, 0 },
/* U+882d */ { 0, 0, 0, 0, 0 },
/* U+882e */ { 0, 0, 0, 0, 0 },
/* U+882f */ { 0, 0, 0, 0, 0 },
/* U+8830 */ { 0, 0, 0, 0, 0 },
/* U+8831 */ { 0, 0, 0, 0, 0 },
/* U+8832 */ { 0, 0, 0, 0, 0 },
/* U+8833 */ { 0, 0, 0, 0, 0 },
/* U+8834 */ { 0, 0, 0, 0, 0 },
/* U+8835 */ { 0, 0, 0, 0, 0 },
/* U+8836 */ { 0, 0, 0, 0, 0 },
/* U+8837 */ { 0, 0, 0, 0, 0 },
/* U+8838 */ { 0, 0, 0, 0, 0 },
/* U+8839 */ { 0, 0, 0, 0, 0 },
/* U+883a */ { 0, 0, 0, 0, 0 },
/* U+883b */ { 0, 0, 0, 0, 0 },
/* U+883c */ { 0, 0, 0, 0, 0 },
/* U+883d */ { 0, 0, 0, 0, 0 },
/* U+883e */ { 0, 0, 0, 0, 0 },
/* U+883f */ { 0, 0, 0, 0, 0 },
/* U+8840 */ { 0, 0, 0, 0, 0 },
/* U+8841 */ { 0, 0, 0, 0, 0 },
/* U+8842 */ { 0, 0, 0, 0, 0 },
/* U+8843 */ { 0, 0, 0, 0, 0 },
/* U+8844 */ { 0, 0, 0, 0, 0 },
/* U+8845 */ { 0, 0, 0, 0, 0 },
/* U+8846 */ { 0, 0, 0, 0, 0 },
/* U+8847 */ { 0, 0, 0, 0, 0 },
/* U+8848 */ { 0, 0, 0, 0, 0 },
/* U+8849 */ { 0, 0, 0, 0, 0 },
/* U+884a */ { 0, 0, 0, 0, 0 },
/* U+884b */ { 0, 0, 0, 0, 0 },
/* U+884c */ { 0, 0, 0, 0, 0 },
/* U+884d */ { 0, 0, 0, 0, 0 },
/* U+884e */ { 0, 0, 0, 0, 0 },
/* U+884f */ { 0, 0, 0, 0, 0 },
/* U+8850 */ { 0, 0, 0, 0, 0 },
/* U+8851 */ { 0, 0, 0, 0, 0 },
/* U+8852 */ { 0, 0, 0, 0, 0 },
/* U+8853 */ { 0, 0, 0, 0, 0 },
/* U+8854 */ { 0, 0, 0, 0, 0 },
/* U+8855 */ { 0, 0, 0, 0, 0 },
/* U+8856 */ { 0, 0, 0, 0, 0 },
/* U+8857 */ { 0, 0, 0, 0, 0 },
/* U+8858 */ { 0, 0, 0, 0, 0 },
/* U+8859 */ { 0, 0, 0, 0, 0 },
/* U+885a */ { 0, 0, 0, 0, 0 },
/* U+885b */ { 0, 0, 0, 0, 0 },
/* U+885c */ { 0, 0, 0, 0, 0 },
/* U+885d */ { 0, 0, 0, 0, 0 },
/* U+885e */ { 0, 0, 0, 0, 0 },
/* U+885f */ { 0, 0, 0, 0, 0 },
/* U+8860 */ { 0, 0, 0, 0, 0 },
/* U+8861 */ { 0, 0, 0, 0, 0 },
/* U+8862 */ { 0, 0, 0, 0, 0 },
/* U+8863 */ { 0, 0, 0, 0, 0 },
/* U+8864 */ { 0, 0, 0, 0, 0 },
/* U+8865 */ { 0, 0, 0, 0, 0 },
/* U+8866 */ { 0, 0, 0, 0, 0 },
/* U+8867 */ { 0, 0, 0, 0, 0 },
/* U+8868 */ { 0, 0, 0, 0, 0 },
/* U+8869 */ { 0, 0, 0, 0, 0 },
/* U+886a */ { 0, 0, 0, 0, 0 },
/* U+886b */ { 0, 0, 0, 0, 0 },
/* U+886c */ { 0, 0, 0, 0, 0 },
/* U+886d */ { 0, 0, 0, 0, 0 },
/* U+886e */ { 0, 0, 0, 0, 0 },
/* U+886f */ { 0, 0, 0, 0, 0 },
/* U+8870 */ { 0, 0, 0, 0, 0 },
/* U+8871 */ { 0, 0, 0, 0, 0 },
/* U+8872 */ { 0, 0, 0, 0, 0 },
/* U+8873 */ { 0, 0, 0, 0, 0 },
/* U+8874 */ { 0, 0, 0, 0, 0 },
/* U+8875 */ { 0, 0, 0, 0, 0 },
/* U+8876 */ { 0, 0, 0, 0, 0 },
/* U+8877 */ { 0, 0, 0, 0, 0 },
/* U+8878 */ { 0, 0, 0, 0, 0 },
/* U+8879 */ { 0, 0, 0, 0, 0 },
/* U+887a */ { 0, 0, 0, 0, 0 },
/* U+887b */ { 0, 0, 0, 0, 0 },
/* U+887c */ { 0, 0, 0, 0, 0 },
/* U+887d */ { 0, 0, 0, 0, 0 },
/* U+887e */ { 0, 0, 0, 0, 0 },
/* U+887f */ { 0, 0, 0, 0, 0 },
/* U+8880 */ { 0, 0, 0, 0, 0 },
/* U+8881 */ { 0, 0, 0, 0, 0 },
/* U+8882 */ { 0, 0, 0, 0, 0 },
/* U+8883 */ { 0, 0, 0, 0, 0 },
/* U+8884 */ { 0, 0, 0, 0, 0 },
/* U+8885 */ { 0, 0, 0, 0, 0 },
/* U+8886 */ { 0, 0, 0, 0, 0 },
/* U+8887 */ { 0, 0, 0, 0, 0 },
/* U+8888 */ { 0, 0, 0, 0, 0 },
/* U+8889 */ { 0, 0, 0, 0, 0 },
/* U+888a */ { 0, 0, 0, 0, 0 },
/* U+888b */ { 0, 0, 0, 0, 0 },
/* U+888c */ { 0, 0, 0, 0, 0 },
/* U+888d */ { 0, 0, 0, 0, 0 },
/* U+888e */ { 0, 0, 0, 0, 0 },
/* U+888f */ { 0, 0, 0, 0, 0 },
/* U+8890 */ { 0, 0, 0, 0, 0 },
/* U+8891 */ { 0, 0, 0, 0, 0 },
/* U+8892 */ { 0, 0, 0, 0, 0 },
/* U+8893 */ { 0, 0, 0, 0, 0 },
/* U+8894 */ { 0, 0, 0, 0, 0 },
/* U+8895 */ { 0, 0, 0, 0, 0 },
/* U+8896 */ { 0, 0, 0, 0, 0 },
/* U+8897 */ { 0, 0, 0, 0, 0 },
/* U+8898 */ { 0, 0, 0, 0, 0 },
/* U+8899 */ { 0, 0, 0, 0, 0 },
/* U+889a */ { 0, 0, 0, 0, 0 },
/* U+889b */ { 0, 0, 0, 0, 0 },
/* U+889c */ { 0, 0, 0, 0, 0 },
/* U+889d */ { 0, 0, 0, 0, 0 },
/* U+889e */ { 0, 0, 0, 0, 0 },
/* U+889f */ { 0, 0, 0, 0, 0 },
/* U+88a0 */ { 0, 0, 0, 0, 0 },
/* U+88a1 */ { 0, 0, 0, 0, 0 },
/* U+88a2 */ { 0, 0, 0, 0, 0 },
/* U+88a3 */ { 0, 0, 0, 0, 0 },
/* U+88a4 */ { 0, 0, 0, 0, 0 },
/* U+88a5 */ { 0, 0, 0, 0, 0 },
/* U+88a6 */ { 0, 0, 0, 0, 0 },
/* U+88a7 */ { 0, 0, 0, 0, 0 },
/* U+88a8 */ { 0, 0, 0, 0, 0 },
/* U+88a9 */ { 0, 0, 0, 0, 0 },
/* U+88aa */ { 0, 0, 0, 0, 0 },
/* U+88ab */ { 0, 0, 0, 0, 0 },
/* U+88ac */ { 0, 0, 0, 0, 0 },
/* U+88ad */ { 0, 0, 0, 0, 0 },
/* U+88ae */ { 0, 0, 0, 0, 0 },
/* U+88af */ { 0, 0, 0, 0, 0 },
/* U+88b0 */ { 0, 0, 0, 0, 0 },
/* U+88b1 */ { 0, 0, 0, 0, 0 },
/* U+88b2 */ { 0, 0, 0, 0, 0 },
/* U+88b3 */ { 0, 0, 0, 0, 0 },
/* U+88b4 */ { 0, 0, 0, 0, 0 },
/* U+88b5 */ { 0, 0, 0, 0, 0 },
/* U+88b6 */ { 0, 0, 0, 0, 0 },
/* U+88b7 */ { 0, 0, 0, 0, 0 },
/* U+88b8 */ { 0, 0, 0, 0, 0 },
/* U+88b9 */ { 0, 0, 0, 0, 0 },
/* U+88ba */ { 0, 0, 0, 0, 0 },
/* U+88bb */ { 0, 0, 0, 0, 0 },
/* U+88bc */ { 0, 0, 0, 0, 0 },
/* U+88bd */ { 0, 0, 0, 0, 0 },
/* U+88be */ { 0, 0, 0, 0, 0 },
/* U+88bf */ { 0, 0, 0, 0, 0 },
/* U+88c0 */ { 0, 0, 0, 0, 0 },
/* U+88c1 */ { 0, 0, 0, 0, 0 },
/* U+88c2 */ { 0, 0, 0, 0, 0 },
/* U+88c3 */ { 0, 0, 0, 0, 0 },
/* U+88c4 */ { 0, 0, 0, 0, 0 },
/* U+88c5 */ { 0, 0, 0, 0, 0 },
/* U+88c6 */ { 0, 0, 0, 0, 0 },
/* U+88c7 */ { 0, 0, 0, 0, 0 },
/* U+88c8 */ { 0, 0, 0, 0, 0 },
/* U+88c9 */ { 0, 0, 0, 0, 0 },
/* U+88ca */ { 0, 0, 0, 0, 0 },
/* U+88cb */ { 0, 0, 0, 0, 0 },
/* U+88cc */ { 0, 0, 0, 0, 0 },
/* U+88cd */ { 0, 0, 0, 0, 0 },
/* U+88ce */ { 0, 0, 0, 0, 0 },
/* U+88cf */ { 0, 0, 0, 0, 0 },
/* U+88d0 */ { 0, 0, 0, 0, 0 },
/* U+88d1 */ { 0, 0, 0, 0, 0 },
/* U+88d2 */ { 0, 0, 0, 0, 0 },
/* U+88d3 */ { 0, 0, 0, 0, 0 },
/* U+88d4 */ { 0, 0, 0, 0, 0 },
/* U+88d5 */ { 0, 0, 0, 0, 0 },
/* U+88d6 */ { 0, 0, 0, 0, 0 },
/* U+88d7 */ { 0, 0, 0, 0, 0 },
/* U+88d8 */ { 0, 0, 0, 0, 0 },
/* U+88d9 */ { 0, 0, 0, 0, 0 },
/* U+88da */ { 0, 0, 0, 0, 0 },
/* U+88db */ { 0, 0, 0, 0, 0 },
/* U+88dc */ { 0, 0, 0, 0, 0 },
/* U+88dd */ { 0, 0, 0, 0, 0 },
/* U+88de */ { 0, 0, 0, 0, 0 },
/* U+88df */ { 0, 0, 0, 0, 0 },
/* U+88e0 */ { 0, 0, 0, 0, 0 },
/* U+88e1 */ { 0, 0, 0, 0, 0 },
/* U+88e2 */ { 0, 0, 0, 0, 0 },
/* U+88e3 */ { 0, 0, 0, 0, 0 },
/* U+88e4 */ { 0, 0, 0, 0, 0 },
/* U+88e5 */ { 0, 0, 0, 0, 0 },
/* U+88e6 */ { 0, 0, 0, 0, 0 },
/* U+88e7 */ { 0, 0, 0, 0, 0 },
/* U+88e8 */ { 0, 0, 0, 0, 0 },
/* U+88e9 */ { 0, 0, 0, 0, 0 },
/* U+88ea */ { 0, 0, 0, 0, 0 },
/* U+88eb */ { 0, 0, 0, 0, 0 },
/* U+88ec */ { 0, 0, 0, 0, 0 },
/* U+88ed */ { 0, 0, 0, 0, 0 },
/* U+88ee */ { 0, 0, 0, 0, 0 },
/* U+88ef */ { 0, 0, 0, 0, 0 },
/* U+88f0 */ { 0, 0, 0, 0, 0 },
/* U+88f1 */ { 0, 0, 0, 0, 0 },
/* U+88f2 */ { 0, 0, 0, 0, 0 },
/* U+88f3 */ { 0, 0, 0, 0, 0 },
/* U+88f4 */ { 0, 0, 0, 0, 0 },
/* U+88f5 */ { 0, 0, 0, 0, 0 },
/* U+88f6 */ { 0, 0, 0, 0, 0 },
/* U+88f7 */ { 0, 0, 0, 0, 0 },
/* U+88f8 */ { 0, 0, 0, 0, 0 },
/* U+88f9 */ { 0, 0, 0, 0, 0 },
/* U+88fa */ { 0, 0, 0, 0, 0 },
/* U+88fb */ { 0, 0, 0, 0, 0 },
/* U+88fc */ { 0, 0, 0, 0, 0 },
/* U+88fd */ { 0, 0, 0, 0, 0 },
/* U+88fe */ { 0, 0, 0, 0, 0 },
/* U+88ff */ { 0, 0, 0, 0, 0 },
/* U+8900 */ { 0, 0, 0, 0, 0 },
/* U+8901 */ { 0, 0, 0, 0, 0 },
/* U+8902 */ { 0, 0, 0, 0, 0 },
/* U+8903 */ { 0, 0, 0, 0, 0 },
/* U+8904 */ { 0, 0, 0, 0, 0 },
/* U+8905 */ { 0, 0, 0, 0, 0 },
/* U+8906 */ { 0, 0, 0, 0, 0 },
/* U+8907 */ { 0, 0, 0, 0, 0 },
/* U+8908 */ { 0, 0, 0, 0, 0 },
/* U+8909 */ { 0, 0, 0, 0, 0 },
/* U+890a */ { 0, 0, 0, 0, 0 },
/* U+890b */ { 0, 0, 0, 0, 0 },
/* U+890c */ { 0, 0, 0, 0, 0 },
/* U+890d */ { 0, 0, 0, 0, 0 },
/* U+890e */ { 0, 0, 0, 0, 0 },
/* U+890f */ { 0, 0, 0, 0, 0 },
/* U+8910 */ { 0, 0, 0, 0, 0 },
/* U+8911 */ { 0, 0, 0, 0, 0 },
/* U+8912 */ { 0, 0, 0, 0, 0 },
/* U+8913 */ { 0, 0, 0, 0, 0 },
/* U+8914 */ { 0, 0, 0, 0, 0 },
/* U+8915 */ { 0, 0, 0, 0, 0 },
/* U+8916 */ { 0, 0, 0, 0, 0 },
/* U+8917 */ { 0, 0, 0, 0, 0 },
/* U+8918 */ { 0, 0, 0, 0, 0 },
/* U+8919 */ { 0, 0, 0, 0, 0 },
/* U+891a */ { 0, 0, 0, 0, 0 },
/* U+891b */ { 0, 0, 0, 0, 0 },
/* U+891c */ { 0, 0, 0, 0, 0 },
/* U+891d */ { 0, 0, 0, 0, 0 },
/* U+891e */ { 0, 0, 0, 0, 0 },
/* U+891f */ { 0, 0, 0, 0, 0 },
/* U+8920 */ { 0, 0, 0, 0, 0 },
/* U+8921 */ { 0, 0, 0, 0, 0 },
/* U+8922 */ { 0, 0, 0, 0, 0 },
/* U+8923 */ { 0, 0, 0, 0, 0 },
/* U+8924 */ { 0, 0, 0, 0, 0 },
/* U+8925 */ { 0, 0, 0, 0, 0 },
/* U+8926 */ { 0, 0, 0, 0, 0 },
/* U+8927 */ { 0, 0, 0, 0, 0 },
/* U+8928 */ { 0, 0, 0, 0, 0 },
/* U+8929 */ { 0, 0, 0, 0, 0 },
/* U+892a */ { 0, 0, 0, 0, 0 },
/* U+892b */ { 0, 0, 0, 0, 0 },
/* U+892c */ { 0, 0, 0, 0, 0 },
/* U+892d */ { 0, 0, 0, 0, 0 },
/* U+892e */ { 0, 0, 0, 0, 0 },
/* U+892f */ { 0, 0, 0, 0, 0 },
/* U+8930 */ { 0, 0, 0, 0, 0 },
/* U+8931 */ { 0, 0, 0, 0, 0 },
/* U+8932 */ { 0, 0, 0, 0, 0 },
/* U+8933 */ { 0, 0, 0, 0, 0 },
/* U+8934 */ { 0, 0, 0, 0, 0 },
/* U+8935 */ { 0, 0, 0, 0, 0 },
/* U+8936 */ { 0, 0, 0, 0, 0 },
/* U+8937 */ { 0, 0, 0, 0, 0 },
/* U+8938 */ { 0, 0, 0, 0, 0 },
/* U+8939 */ { 0, 0, 0, 0, 0 },
/* U+893a */ { 0, 0, 0, 0, 0 },
/* U+893b */ { 0, 0, 0, 0, 0 },
/* U+893c */ { 0, 0, 0, 0, 0 },
/* U+893d */ { 0, 0, 0, 0, 0 },
/* U+893e */ { 0, 0, 0, 0, 0 },
/* U+893f */ { 0, 0, 0, 0, 0 },
/* U+8940 */ { 0, 0, 0, 0, 0 },
/* U+8941 */ { 0, 0, 0, 0, 0 },
/* U+8942 */ { 0, 0, 0, 0, 0 },
/* U+8943 */ { 0, 0, 0, 0, 0 },
/* U+8944 */ { 0, 0, 0, 0, 0 },
/* U+8945 */ { 0, 0, 0, 0, 0 },
/* U+8946 */ { 0, 0, 0, 0, 0 },
/* U+8947 */ { 0, 0, 0, 0, 0 },
/* U+8948 */ { 0, 0, 0, 0, 0 },
/* U+8949 */ { 0, 0, 0, 0, 0 },
/* U+894a */ { 0, 0, 0, 0, 0 },
/* U+894b */ { 0, 0, 0, 0, 0 },
/* U+894c */ { 0, 0, 0, 0, 0 },
/* U+894d */ { 0, 0, 0, 0, 0 },
/* U+894e */ { 0, 0, 0, 0, 0 },
/* U+894f */ { 0, 0, 0, 0, 0 },
/* U+8950 */ { 0, 0, 0, 0, 0 },
/* U+8951 */ { 0, 0, 0, 0, 0 },
/* U+8952 */ { 0, 0, 0, 0, 0 },
/* U+8953 */ { 0, 0, 0, 0, 0 },
/* U+8954 */ { 0, 0, 0, 0, 0 },
/* U+8955 */ { 0, 0, 0, 0, 0 },
/* U+8956 */ { 0, 0, 0, 0, 0 },
/* U+8957 */ { 0, 0, 0, 0, 0 },
/* U+8958 */ { 0, 0, 0, 0, 0 },
/* U+8959 */ { 0, 0, 0, 0, 0 },
/* U+895a */ { 0, 0, 0, 0, 0 },
/* U+895b */ { 0, 0, 0, 0, 0 },
/* U+895c */ { 0, 0, 0, 0, 0 },
/* U+895d */ { 0, 0, 0, 0, 0 },
/* U+895e */ { 0, 0, 0, 0, 0 },
/* U+895f */ { 0, 0, 0, 0, 0 },
/* U+8960 */ { 0, 0, 0, 0, 0 },
/* U+8961 */ { 0, 0, 0, 0, 0 },
/* U+8962 */ { 0, 0, 0, 0, 0 },
/* U+8963 */ { 0, 0, 0, 0, 0 },
/* U+8964 */ { 0, 0, 0, 0, 0 },
/* U+8965 */ { 0, 0, 0, 0, 0 },
/* U+8966 */ { 0, 0, 0, 0, 0 },
/* U+8967 */ { 0, 0, 0, 0, 0 },
/* U+8968 */ { 0, 0, 0, 0, 0 },
/* U+8969 */ { 0, 0, 0, 0, 0 },
/* U+896a */ { 0, 0, 0, 0, 0 },
/* U+896b */ { 0, 0, 0, 0, 0 },
/* U+896c */ { 0, 0, 0, 0, 0 },
/* U+896d */ { 0, 0, 0, 0, 0 },
/* U+896e */ { 0, 0, 0, 0, 0 },
/* U+896f */ { 0, 0, 0, 0, 0 },
/* U+8970 */ { 0, 0, 0, 0, 0 },
/* U+8971 */ { 0, 0, 0, 0, 0 },
/* U+8972 */ { 0, 0, 0, 0, 0 },
/* U+8973 */ { 0, 0, 0, 0, 0 },
/* U+8974 */ { 0, 0, 0, 0, 0 },
/* U+8975 */ { 0, 0, 0, 0, 0 },
/* U+8976 */ { 0, 0, 0, 0, 0 },
/* U+8977 */ { 0, 0, 0, 0, 0 },
/* U+8978 */ { 0, 0, 0, 0, 0 },
/* U+8979 */ { 0, 0, 0, 0, 0 },
/* U+897a */ { 0, 0, 0, 0, 0 },
/* U+897b */ { 0, 0, 0, 0, 0 },
/* U+897c */ { 0, 0, 0, 0, 0 },
/* U+897d */ { 0, 0, 0, 0, 0 },
/* U+897e */ { 0, 0, 0, 0, 0 },
/* U+897f */ { 0, 0, 0, 0, 0 },
/* U+8980 */ { 0, 0, 0, 0, 0 },
/* U+8981 */ { 0, 0, 0, 0, 0 },
/* U+8982 */ { 0, 0, 0, 0, 0 },
/* U+8983 */ { 0, 0, 0, 0, 0 },
/* U+8984 */ { 0, 0, 0, 0, 0 },
/* U+8985 */ { 0, 0, 0, 0, 0 },
/* U+8986 */ { 0, 0, 0, 0, 0 },
/* U+8987 */ { 0, 0, 0, 0, 0 },
/* U+8988 */ { 0, 0, 0, 0, 0 },
/* U+8989 */ { 0, 0, 0, 0, 0 },
/* U+898a */ { 0, 0, 0, 0, 0 },
/* U+898b */ { 0, 0, 0, 0, 0 },
/* U+898c */ { 0, 0, 0, 0, 0 },
/* U+898d */ { 0, 0, 0, 0, 0 },
/* U+898e */ { 0, 0, 0, 0, 0 },
/* U+898f */ { 0, 0, 0, 0, 0 },
/* U+8990 */ { 0, 0, 0, 0, 0 },
/* U+8991 */ { 0, 0, 0, 0, 0 },
/* U+8992 */ { 0, 0, 0, 0, 0 },
/* U+8993 */ { 0, 0, 0, 0, 0 },
/* U+8994 */ { 0, 0, 0, 0, 0 },
/* U+8995 */ { 0, 0, 0, 0, 0 },
/* U+8996 */ { 0, 0, 0, 0, 0 },
/* U+8997 */ { 0, 0, 0, 0, 0 },
/* U+8998 */ { 0, 0, 0, 0, 0 },
/* U+8999 */ { 0, 0, 0, 0, 0 },
/* U+899a */ { 0, 0, 0, 0, 0 },
/* U+899b */ { 0, 0, 0, 0, 0 },
/* U+899c */ { 0, 0, 0, 0, 0 },
/* U+899d */ { 0, 0, 0, 0, 0 },
/* U+899e */ { 0, 0, 0, 0, 0 },
/* U+899f */ { 0, 0, 0, 0, 0 },
/* U+89a0 */ { 0, 0, 0, 0, 0 },
/* U+89a1 */ { 0, 0, 0, 0, 0 },
/* U+89a2 */ { 0, 0, 0, 0, 0 },
/* U+89a3 */ { 0, 0, 0, 0, 0 },
/* U+89a4 */ { 0, 0, 0, 0, 0 },
/* U+89a5 */ { 0, 0, 0, 0, 0 },
/* U+89a6 */ { 0, 0, 0, 0, 0 },
/* U+89a7 */ { 0, 0, 0, 0, 0 },
/* U+89a8 */ { 0, 0, 0, 0, 0 },
/* U+89a9 */ { 0, 0, 0, 0, 0 },
/* U+89aa */ { 0, 0, 0, 0, 0 },
/* U+89ab */ { 0, 0, 0, 0, 0 },
/* U+89ac */ { 0, 0, 0, 0, 0 },
/* U+89ad */ { 0, 0, 0, 0, 0 },
/* U+89ae */ { 0, 0, 0, 0, 0 },
/* U+89af */ { 0, 0, 0, 0, 0 },
/* U+89b0 */ { 0, 0, 0, 0, 0 },
/* U+89b1 */ { 0, 0, 0, 0, 0 },
/* U+89b2 */ { 0, 0, 0, 0, 0 },
/* U+89b3 */ { 0, 0, 0, 0, 0 },
/* U+89b4 */ { 0, 0, 0, 0, 0 },
/* U+89b5 */ { 0, 0, 0, 0, 0 },
/* U+89b6 */ { 0, 0, 0, 0, 0 },
/* U+89b7 */ { 0, 0, 0, 0, 0 },
/* U+89b8 */ { 0, 0, 0, 0, 0 },
/* U+89b9 */ { 0, 0, 0, 0, 0 },
/* U+89ba */ { 0, 0, 0, 0, 0 },
/* U+89bb */ { 0, 0, 0, 0, 0 },
/* U+89bc */ { 0, 0, 0, 0, 0 },
/* U+89bd */ { 0, 0, 0, 0, 0 },
/* U+89be */ { 0, 0, 0, 0, 0 },
/* U+89bf */ { 0, 0, 0, 0, 0 },
/* U+89c0 */ { 0, 0, 0, 0, 0 },
/* U+89c1 */ { 0, 0, 0, 0, 0 },
/* U+89c2 */ { 0, 0, 0, 0, 0 },
/* U+89c3 */ { 0, 0, 0, 0, 0 },
/* U+89c4 */ { 0, 0, 0, 0, 0 },
/* U+89c5 */ { 0, 0, 0, 0, 0 },
/* U+89c6 */ { 0, 0, 0, 0, 0 },
/* U+89c7 */ { 0, 0, 0, 0, 0 },
/* U+89c8 */ { 0, 0, 0, 0, 0 },
/* U+89c9 */ { 0, 0, 0, 0, 0 },
/* U+89ca */ { 0, 0, 0, 0, 0 },
/* U+89cb */ { 0, 0, 0, 0, 0 },
/* U+89cc */ { 0, 0, 0, 0, 0 },
/* U+89cd */ { 0, 0, 0, 0, 0 },
/* U+89ce */ { 0, 0, 0, 0, 0 },
/* U+89cf */ { 0, 0, 0, 0, 0 },
/* U+89d0 */ { 0, 0, 0, 0, 0 },
/* U+89d1 */ { 0, 0, 0, 0, 0 },
/* U+89d2 */ { 0, 0, 0, 0, 0 },
/* U+89d3 */ { 0, 0, 0, 0, 0 },
/* U+89d4 */ { 0, 0, 0, 0, 0 },
/* U+89d5 */ { 0, 0, 0, 0, 0 },
/* U+89d6 */ { 0, 0, 0, 0, 0 },
/* U+89d7 */ { 0, 0, 0, 0, 0 },
/* U+89d8 */ { 0, 0, 0, 0, 0 },
/* U+89d9 */ { 0, 0, 0, 0, 0 },
/* U+89da */ { 0, 0, 0, 0, 0 },
/* U+89db */ { 0, 0, 0, 0, 0 },
/* U+89dc */ { 0, 0, 0, 0, 0 },
/* U+89dd */ { 0, 0, 0, 0, 0 },
/* U+89de */ { 0, 0, 0, 0, 0 },
/* U+89df */ { 0, 0, 0, 0, 0 },
/* U+89e0 */ { 0, 0, 0, 0, 0 },
/* U+89e1 */ { 0, 0, 0, 0, 0 },
/* U+89e2 */ { 0, 0, 0, 0, 0 },
/* U+89e3 */ { 0, 0, 0, 0, 0 },
/* U+89e4 */ { 0, 0, 0, 0, 0 },
/* U+89e5 */ { 0, 0, 0, 0, 0 },
/* U+89e6 */ { 0, 0, 0, 0, 0 },
/* U+89e7 */ { 0, 0, 0, 0, 0 },
/* U+89e8 */ { 0, 0, 0, 0, 0 },
/* U+89e9 */ { 0, 0, 0, 0, 0 },
/* U+89ea */ { 0, 0, 0, 0, 0 },
/* U+89eb */ { 0, 0, 0, 0, 0 },
/* U+89ec */ { 0, 0, 0, 0, 0 },
/* U+89ed */ { 0, 0, 0, 0, 0 },
/* U+89ee */ { 0, 0, 0, 0, 0 },
/* U+89ef */ { 0, 0, 0, 0, 0 },
/* U+89f0 */ { 0, 0, 0, 0, 0 },
/* U+89f1 */ { 0, 0, 0, 0, 0 },
/* U+89f2 */ { 0, 0, 0, 0, 0 },
/* U+89f3 */ { 0, 0, 0, 0, 0 },
/* U+89f4 */ { 0, 0, 0, 0, 0 },
/* U+89f5 */ { 0, 0, 0, 0, 0 },
/* U+89f6 */ { 0, 0, 0, 0, 0 },
/* U+89f7 */ { 0, 0, 0, 0, 0 },
/* U+89f8 */ { 0, 0, 0, 0, 0 },
/* U+89f9 */ { 0, 0, 0, 0, 0 },
/* U+89fa */ { 0, 0, 0, 0, 0 },
/* U+89fb */ { 0, 0, 0, 0, 0 },
/* U+89fc */ { 0, 0, 0, 0, 0 },
/* U+89fd */ { 0, 0, 0, 0, 0 },
/* U+89fe */ { 0, 0, 0, 0, 0 },
/* U+89ff */ { 0, 0, 0, 0, 0 },
/* U+8a00 */ { 0, 0, 0, 0, 0 },
/* U+8a01 */ { 0, 0, 0, 0, 0 },
/* U+8a02 */ { 0, 0, 0, 0, 0 },
/* U+8a03 */ { 0, 0, 0, 0, 0 },
/* U+8a04 */ { 0, 0, 0, 0, 0 },
/* U+8a05 */ { 0, 0, 0, 0, 0 },
/* U+8a06 */ { 0, 0, 0, 0, 0 },
/* U+8a07 */ { 0, 0, 0, 0, 0 },
/* U+8a08 */ { 0, 0, 0, 0, 0 },
/* U+8a09 */ { 0, 0, 0, 0, 0 },
/* U+8a0a */ { 0, 0, 0, 0, 0 },
/* U+8a0b */ { 0, 0, 0, 0, 0 },
/* U+8a0c */ { 0, 0, 0, 0, 0 },
/* U+8a0d */ { 0, 0, 0, 0, 0 },
/* U+8a0e */ { 0, 0, 0, 0, 0 },
/* U+8a0f */ { 0, 0, 0, 0, 0 },
/* U+8a10 */ { 0, 0, 0, 0, 0 },
/* U+8a11 */ { 0, 0, 0, 0, 0 },
/* U+8a12 */ { 0, 0, 0, 0, 0 },
/* U+8a13 */ { 0, 0, 0, 0, 0 },
/* U+8a14 */ { 0, 0, 0, 0, 0 },
/* U+8a15 */ { 0, 0, 0, 0, 0 },
/* U+8a16 */ { 0, 0, 0, 0, 0 },
/* U+8a17 */ { 0, 0, 0, 0, 0 },
/* U+8a18 */ { 0, 0, 0, 0, 0 },
/* U+8a19 */ { 0, 0, 0, 0, 0 },
/* U+8a1a */ { 0, 0, 0, 0, 0 },
/* U+8a1b */ { 0, 0, 0, 0, 0 },
/* U+8a1c */ { 0, 0, 0, 0, 0 },
/* U+8a1d */ { 0, 0, 0, 0, 0 },
/* U+8a1e */ { 0, 0, 0, 0, 0 },
/* U+8a1f */ { 0, 0, 0, 0, 0 },
/* U+8a20 */ { 0, 0, 0, 0, 0 },
/* U+8a21 */ { 0, 0, 0, 0, 0 },
/* U+8a22 */ { 0, 0, 0, 0, 0 },
/* U+8a23 */ { 0, 0, 0, 0, 0 },
/* U+8a24 */ { 0, 0, 0, 0, 0 },
/* U+8a25 */ { 0, 0, 0, 0, 0 },
/* U+8a26 */ { 0, 0, 0, 0, 0 },
/* U+8a27 */ { 0, 0, 0, 0, 0 },
/* U+8a28 */ { 0, 0, 0, 0, 0 },
/* U+8a29 */ { 0, 0, 0, 0, 0 },
/* U+8a2a */ { 0, 0, 0, 0, 0 },
/* U+8a2b */ { 0, 0, 0, 0, 0 },
/* U+8a2c */ { 0, 0, 0, 0, 0 },
/* U+8a2d */ { 0, 0, 0, 0, 0 },
/* U+8a2e */ { 0, 0, 0, 0, 0 },
/* U+8a2f */ { 0, 0, 0, 0, 0 },
/* U+8a30 */ { 0, 0, 0, 0, 0 },
/* U+8a31 */ { 0, 0, 0, 0, 0 },
/* U+8a32 */ { 0, 0, 0, 0, 0 },
/* U+8a33 */ { 0, 0, 0, 0, 0 },
/* U+8a34 */ { 0, 0, 0, 0, 0 },
/* U+8a35 */ { 0, 0, 0, 0, 0 },
/* U+8a36 */ { 0, 0, 0, 0, 0 },
/* U+8a37 */ { 0, 0, 0, 0, 0 },
/* U+8a38 */ { 0, 0, 0, 0, 0 },
/* U+8a39 */ { 0, 0, 0, 0, 0 },
/* U+8a3a */ { 0, 0, 0, 0, 0 },
/* U+8a3b */ { 0, 0, 0, 0, 0 },
/* U+8a3c */ { 0, 0, 0, 0, 0 },
/* U+8a3d */ { 0, 0, 0, 0, 0 },
/* U+8a3e */ { 0, 0, 0, 0, 0 },
/* U+8a3f */ { 0, 0, 0, 0, 0 },
/* U+8a40 */ { 0, 0, 0, 0, 0 },
/* U+8a41 */ { 0, 0, 0, 0, 0 },
/* U+8a42 */ { 0, 0, 0, 0, 0 },
/* U+8a43 */ { 0, 0, 0, 0, 0 },
/* U+8a44 */ { 0, 0, 0, 0, 0 },
/* U+8a45 */ { 0, 0, 0, 0, 0 },
/* U+8a46 */ { 0, 0, 0, 0, 0 },
/* U+8a47 */ { 0, 0, 0, 0, 0 },
/* U+8a48 */ { 0, 0, 0, 0, 0 },
/* U+8a49 */ { 0, 0, 0, 0, 0 },
/* U+8a4a */ { 0, 0, 0, 0, 0 },
/* U+8a4b */ { 0, 0, 0, 0, 0 },
/* U+8a4c */ { 0, 0, 0, 0, 0 },
/* U+8a4d */ { 0, 0, 0, 0, 0 },
/* U+8a4e */ { 0, 0, 0, 0, 0 },
/* U+8a4f */ { 0, 0, 0, 0, 0 },
/* U+8a50 */ { 0, 0, 0, 0, 0 },
/* U+8a51 */ { 0, 0, 0, 0, 0 },
/* U+8a52 */ { 0, 0, 0, 0, 0 },
/* U+8a53 */ { 0, 0, 0, 0, 0 },
/* U+8a54 */ { 0, 0, 0, 0, 0 },
/* U+8a55 */ { 0, 0, 0, 0, 0 },
/* U+8a56 */ { 0, 0, 0, 0, 0 },
/* U+8a57 */ { 0, 0, 0, 0, 0 },
/* U+8a58 */ { 0, 0, 0, 0, 0 },
/* U+8a59 */ { 0, 0, 0, 0, 0 },
/* U+8a5a */ { 0, 0, 0, 0, 0 },
/* U+8a5b */ { 0, 0, 0, 0, 0 },
/* U+8a5c */ { 0, 0, 0, 0, 0 },
/* U+8a5d */ { 0, 0, 0, 0, 0 },
/* U+8a5e */ { 0, 0, 0, 0, 0 },
/* U+8a5f */ { 0, 0, 0, 0, 0 },
/* U+8a60 */ { 0, 0, 0, 0, 0 },
/* U+8a61 */ { 0, 0, 0, 0, 0 },
/* U+8a62 */ { 0, 0, 0, 0, 0 },
/* U+8a63 */ { 0, 0, 0, 0, 0 },
/* U+8a64 */ { 0, 0, 0, 0, 0 },
/* U+8a65 */ { 0, 0, 0, 0, 0 },
/* U+8a66 */ { 0, 0, 0, 0, 0 },
/* U+8a67 */ { 0, 0, 0, 0, 0 },
/* U+8a68 */ { 0, 0, 0, 0, 0 },
/* U+8a69 */ { 0, 0, 0, 0, 0 },
/* U+8a6a */ { 0, 0, 0, 0, 0 },
/* U+8a6b */ { 0, 0, 0, 0, 0 },
/* U+8a6c */ { 0, 0, 0, 0, 0 },
/* U+8a6d */ { 0, 0, 0, 0, 0 },
/* U+8a6e */ { 0, 0, 0, 0, 0 },
/* U+8a6f */ { 0, 0, 0, 0, 0 },
/* U+8a70 */ { 0, 0, 0, 0, 0 },
/* U+8a71 */ { 0, 0, 0, 0, 0 },
/* U+8a72 */ { 0, 0, 0, 0, 0 },
/* U+8a73 */ { 0, 0, 0, 0, 0 },
/* U+8a74 */ { 0, 0, 0, 0, 0 },
/* U+8a75 */ { 0, 0, 0, 0, 0 },
/* U+8a76 */ { 0, 0, 0, 0, 0 },
/* U+8a77 */ { 0, 0, 0, 0, 0 },
/* U+8a78 */ { 0, 0, 0, 0, 0 },
/* U+8a79 */ { 0, 0, 0, 0, 0 },
/* U+8a7a */ { 0, 0, 0, 0, 0 },
/* U+8a7b */ { 0, 0, 0, 0, 0 },
/* U+8a7c */ { 0, 0, 0, 0, 0 },
/* U+8a7d */ { 0, 0, 0, 0, 0 },
/* U+8a7e */ { 0, 0, 0, 0, 0 },
/* U+8a7f */ { 0, 0, 0, 0, 0 },
/* U+8a80 */ { 0, 0, 0, 0, 0 },
/* U+8a81 */ { 0, 0, 0, 0, 0 },
/* U+8a82 */ { 0, 0, 0, 0, 0 },
/* U+8a83 */ { 0, 0, 0, 0, 0 },
/* U+8a84 */ { 0, 0, 0, 0, 0 },
/* U+8a85 */ { 0, 0, 0, 0, 0 },
/* U+8a86 */ { 0, 0, 0, 0, 0 },
/* U+8a87 */ { 0, 0, 0, 0, 0 },
/* U+8a88 */ { 0, 0, 0, 0, 0 },
/* U+8a89 */ { 0, 0, 0, 0, 0 },
/* U+8a8a */ { 0, 0, 0, 0, 0 },
/* U+8a8b */ { 0, 0, 0, 0, 0 },
/* U+8a8c */ { 0, 0, 0, 0, 0 },
/* U+8a8d */ { 0, 0, 0, 0, 0 },
/* U+8a8e */ { 0, 0, 0, 0, 0 },
/* U+8a8f */ { 0, 0, 0, 0, 0 },
/* U+8a90 */ { 0, 0, 0, 0, 0 },
/* U+8a91 */ { 0, 0, 0, 0, 0 },
/* U+8a92 */ { 0, 0, 0, 0, 0 },
/* U+8a93 */ { 0, 0, 0, 0, 0 },
/* U+8a94 */ { 0, 0, 0, 0, 0 },
/* U+8a95 */ { 0, 0, 0, 0, 0 },
/* U+8a96 */ { 0, 0, 0, 0, 0 },
/* U+8a97 */ { 0, 0, 0, 0, 0 },
/* U+8a98 */ { 0, 0, 0, 0, 0 },
/* U+8a99 */ { 0, 0, 0, 0, 0 },
/* U+8a9a */ { 0, 0, 0, 0, 0 },
/* U+8a9b */ { 0, 0, 0, 0, 0 },
/* U+8a9c */ { 0, 0, 0, 0, 0 },
/* U+8a9d */ { 0, 0, 0, 0, 0 },
/* U+8a9e */ { 0, 0, 0, 0, 0 },
/* U+8a9f */ { 0, 0, 0, 0, 0 },
/* U+8aa0 */ { 0, 0, 0, 0, 0 },
/* U+8aa1 */ { 0, 0, 0, 0, 0 },
/* U+8aa2 */ { 0, 0, 0, 0, 0 },
/* U+8aa3 */ { 0, 0, 0, 0, 0 },
/* U+8aa4 */ { 0, 0, 0, 0, 0 },
/* U+8aa5 */ { 0, 0, 0, 0, 0 },
/* U+8aa6 */ { 0, 0, 0, 0, 0 },
/* U+8aa7 */ { 0, 0, 0, 0, 0 },
/* U+8aa8 */ { 0, 0, 0, 0, 0 },
/* U+8aa9 */ { 0, 0, 0, 0, 0 },
/* U+8aaa */ { 0, 0, 0, 0, 0 },
/* U+8aab */ { 0, 0, 0, 0, 0 },
/* U+8aac */ { 0, 0, 0, 0, 0 },
/* U+8aad */ { 0, 0, 0, 0, 0 },
/* U+8aae */ { 0, 0, 0, 0, 0 },
/* U+8aaf */ { 0, 0, 0, 0, 0 },
/* U+8ab0 */ { 0, 0, 0, 0, 0 },
/* U+8ab1 */ { 0, 0, 0, 0, 0 },
/* U+8ab2 */ { 0, 0, 0, 0, 0 },
/* U+8ab3 */ { 0, 0, 0, 0, 0 },
/* U+8ab4 */ { 0, 0, 0, 0, 0 },
/* U+8ab5 */ { 0, 0, 0, 0, 0 },
/* U+8ab6 */ { 0, 0, 0, 0, 0 },
/* U+8ab7 */ { 0, 0, 0, 0, 0 },
/* U+8ab8 */ { 0, 0, 0, 0, 0 },
/* U+8ab9 */ { 0, 0, 0, 0, 0 },
/* U+8aba */ { 0, 0, 0, 0, 0 },
/* U+8abb */ { 0, 0, 0, 0, 0 },
/* U+8abc */ { 0, 0, 0, 0, 0 },
/* U+8abd */ { 0, 0, 0, 0, 0 },
/* U+8abe */ { 0, 0, 0, 0, 0 },
/* U+8abf */ { 0, 0, 0, 0, 0 },
/* U+8ac0 */ { 0, 0, 0, 0, 0 },
/* U+8ac1 */ { 0, 0, 0, 0, 0 },
/* U+8ac2 */ { 0, 0, 0, 0, 0 },
/* U+8ac3 */ { 0, 0, 0, 0, 0 },
/* U+8ac4 */ { 0, 0, 0, 0, 0 },
/* U+8ac5 */ { 0, 0, 0, 0, 0 },
/* U+8ac6 */ { 0, 0, 0, 0, 0 },
/* U+8ac7 */ { 0, 0, 0, 0, 0 },
/* U+8ac8 */ { 0, 0, 0, 0, 0 },
/* U+8ac9 */ { 0, 0, 0, 0, 0 },
/* U+8aca */ { 0, 0, 0, 0, 0 },
/* U+8acb */ { 0, 0, 0, 0, 0 },
/* U+8acc */ { 0, 0, 0, 0, 0 },
/* U+8acd */ { 0, 0, 0, 0, 0 },
/* U+8ace */ { 0, 0, 0, 0, 0 },
/* U+8acf */ { 0, 0, 0, 0, 0 },
/* U+8ad0 */ { 0, 0, 0, 0, 0 },
/* U+8ad1 */ { 0, 0, 0, 0, 0 },
/* U+8ad2 */ { 0, 0, 0, 0, 0 },
/* U+8ad3 */ { 0, 0, 0, 0, 0 },
/* U+8ad4 */ { 0, 0, 0, 0, 0 },
/* U+8ad5 */ { 0, 0, 0, 0, 0 },
/* U+8ad6 */ { 0, 0, 0, 0, 0 },
/* U+8ad7 */ { 0, 0, 0, 0, 0 },
/* U+8ad8 */ { 0, 0, 0, 0, 0 },
/* U+8ad9 */ { 0, 0, 0, 0, 0 },
/* U+8ada */ { 0, 0, 0, 0, 0 },
/* U+8adb */ { 0, 0, 0, 0, 0 },
/* U+8adc */ { 0, 0, 0, 0, 0 },
/* U+8add */ { 0, 0, 0, 0, 0 },
/* U+8ade */ { 0, 0, 0, 0, 0 },
/* U+8adf */ { 0, 0, 0, 0, 0 },
/* U+8ae0 */ { 0, 0, 0, 0, 0 },
/* U+8ae1 */ { 0, 0, 0, 0, 0 },
/* U+8ae2 */ { 0, 0, 0, 0, 0 },
/* U+8ae3 */ { 0, 0, 0, 0, 0 },
/* U+8ae4 */ { 0, 0, 0, 0, 0 },
/* U+8ae5 */ { 0, 0, 0, 0, 0 },
/* U+8ae6 */ { 0, 0, 0, 0, 0 },
/* U+8ae7 */ { 0, 0, 0, 0, 0 },
/* U+8ae8 */ { 0, 0, 0, 0, 0 },
/* U+8ae9 */ { 0, 0, 0, 0, 0 },
/* U+8aea */ { 0, 0, 0, 0, 0 },
/* U+8aeb */ { 0, 0, 0, 0, 0 },
/* U+8aec */ { 0, 0, 0, 0, 0 },
/* U+8aed */ { 0, 0, 0, 0, 0 },
/* U+8aee */ { 0, 0, 0, 0, 0 },
/* U+8aef */ { 0, 0, 0, 0, 0 },
/* U+8af0 */ { 0, 0, 0, 0, 0 },
/* U+8af1 */ { 0, 0, 0, 0, 0 },
/* U+8af2 */ { 0, 0, 0, 0, 0 },
/* U+8af3 */ { 0, 0, 0, 0, 0 },
/* U+8af4 */ { 0, 0, 0, 0, 0 },
/* U+8af5 */ { 0, 0, 0, 0, 0 },
/* U+8af6 */ { 0, 0, 0, 0, 0 },
/* U+8af7 */ { 0, 0, 0, 0, 0 },
/* U+8af8 */ { 0, 0, 0, 0, 0 },
/* U+8af9 */ { 0, 0, 0, 0, 0 },
/* U+8afa */ { 0, 0, 0, 0, 0 },
/* U+8afb */ { 0, 0, 0, 0, 0 },
/* U+8afc */ { 0, 0, 0, 0, 0 },
/* U+8afd */ { 0, 0, 0, 0, 0 },
/* U+8afe */ { 0, 0, 0, 0, 0 },
/* U+8aff */ { 0, 0, 0, 0, 0 },
/* U+8b00 */ { 0, 0, 0, 0, 0 },
/* U+8b01 */ { 0, 0, 0, 0, 0 },
/* U+8b02 */ { 0, 0, 0, 0, 0 },
/* U+8b03 */ { 0, 0, 0, 0, 0 },
/* U+8b04 */ { 0, 0, 0, 0, 0 },
/* U+8b05 */ { 0, 0, 0, 0, 0 },
/* U+8b06 */ { 0, 0, 0, 0, 0 },
/* U+8b07 */ { 0, 0, 0, 0, 0 },
/* U+8b08 */ { 0, 0, 0, 0, 0 },
/* U+8b09 */ { 0, 0, 0, 0, 0 },
/* U+8b0a */ { 0, 0, 0, 0, 0 },
/* U+8b0b */ { 0, 0, 0, 0, 0 },
/* U+8b0c */ { 0, 0, 0, 0, 0 },
/* U+8b0d */ { 0, 0, 0, 0, 0 },
/* U+8b0e */ { 0, 0, 0, 0, 0 },
/* U+8b0f */ { 0, 0, 0, 0, 0 },
/* U+8b10 */ { 0, 0, 0, 0, 0 },
/* U+8b11 */ { 0, 0, 0, 0, 0 },
/* U+8b12 */ { 0, 0, 0, 0, 0 },
/* U+8b13 */ { 0, 0, 0, 0, 0 },
/* U+8b14 */ { 0, 0, 0, 0, 0 },
/* U+8b15 */ { 0, 0, 0, 0, 0 },
/* U+8b16 */ { 0, 0, 0, 0, 0 },
/* U+8b17 */ { 0, 0, 0, 0, 0 },
/* U+8b18 */ { 0, 0, 0, 0, 0 },
/* U+8b19 */ { 0, 0, 0, 0, 0 },
/* U+8b1a */ { 0, 0, 0, 0, 0 },
/* U+8b1b */ { 0, 0, 0, 0, 0 },
/* U+8b1c */ { 0, 0, 0, 0, 0 },
/* U+8b1d */ { 0, 0, 0, 0, 0 },
/* U+8b1e */ { 0, 0, 0, 0, 0 },
/* U+8b1f */ { 0, 0, 0, 0, 0 },
/* U+8b20 */ { 0, 0, 0, 0, 0 },
/* U+8b21 */ { 0, 0, 0, 0, 0 },
/* U+8b22 */ { 0, 0, 0, 0, 0 },
/* U+8b23 */ { 0, 0, 0, 0, 0 },
/* U+8b24 */ { 0, 0, 0, 0, 0 },
/* U+8b25 */ { 0, 0, 0, 0, 0 },
/* U+8b26 */ { 0, 0, 0, 0, 0 },
/* U+8b27 */ { 0, 0, 0, 0, 0 },
/* U+8b28 */ { 0, 0, 0, 0, 0 },
/* U+8b29 */ { 0, 0, 0, 0, 0 },
/* U+8b2a */ { 0, 0, 0, 0, 0 },
/* U+8b2b */ { 0, 0, 0, 0, 0 },
/* U+8b2c */ { 0, 0, 0, 0, 0 },
/* U+8b2d */ { 0, 0, 0, 0, 0 },
/* U+8b2e */ { 0, 0, 0, 0, 0 },
/* U+8b2f */ { 0, 0, 0, 0, 0 },
/* U+8b30 */ { 0, 0, 0, 0, 0 },
/* U+8b31 */ { 0, 0, 0, 0, 0 },
/* U+8b32 */ { 0, 0, 0, 0, 0 },
/* U+8b33 */ { 0, 0, 0, 0, 0 },
/* U+8b34 */ { 0, 0, 0, 0, 0 },
/* U+8b35 */ { 0, 0, 0, 0, 0 },
/* U+8b36 */ { 0, 0, 0, 0, 0 },
/* U+8b37 */ { 0, 0, 0, 0, 0 },
/* U+8b38 */ { 0, 0, 0, 0, 0 },
/* U+8b39 */ { 0, 0, 0, 0, 0 },
/* U+8b3a */ { 0, 0, 0, 0, 0 },
/* U+8b3b */ { 0, 0, 0, 0, 0 },
/* U+8b3c */ { 0, 0, 0, 0, 0 },
/* U+8b3d */ { 0, 0, 0, 0, 0 },
/* U+8b3e */ { 0, 0, 0, 0, 0 },
/* U+8b3f */ { 0, 0, 0, 0, 0 },
/* U+8b40 */ { 0, 0, 0, 0, 0 },
/* U+8b41 */ { 0, 0, 0, 0, 0 },
/* U+8b42 */ { 0, 0, 0, 0, 0 },
/* U+8b43 */ { 0, 0, 0, 0, 0 },
/* U+8b44 */ { 0, 0, 0, 0, 0 },
/* U+8b45 */ { 0, 0, 0, 0, 0 },
/* U+8b46 */ { 0, 0, 0, 0, 0 },
/* U+8b47 */ { 0, 0, 0, 0, 0 },
/* U+8b48 */ { 0, 0, 0, 0, 0 },
/* U+8b49 */ { 0, 0, 0, 0, 0 },
/* U+8b4a */ { 0, 0, 0, 0, 0 },
/* U+8b4b */ { 0, 0, 0, 0, 0 },
/* U+8b4c */ { 0, 0, 0, 0, 0 },
/* U+8b4d */ { 0, 0, 0, 0, 0 },
/* U+8b4e */ { 0, 0, 0, 0, 0 },
/* U+8b4f */ { 0, 0, 0, 0, 0 },
/* U+8b50 */ { 0, 0, 0, 0, 0 },
/* U+8b51 */ { 0, 0, 0, 0, 0 },
/* U+8b52 */ { 0, 0, 0, 0, 0 },
/* U+8b53 */ { 0, 0, 0, 0, 0 },
/* U+8b54 */ { 0, 0, 0, 0, 0 },
/* U+8b55 */ { 0, 0, 0, 0, 0 },
/* U+8b56 */ { 0, 0, 0, 0, 0 },
/* U+8b57 */ { 0, 0, 0, 0, 0 },
/* U+8b58 */ { 0, 0, 0, 0, 0 },
/* U+8b59 */ { 0, 0, 0, 0, 0 },
/* U+8b5a */ { 0, 0, 0, 0, 0 },
/* U+8b5b */ { 0, 0, 0, 0, 0 },
/* U+8b5c */ { 0, 0, 0, 0, 0 },
/* U+8b5d */ { 0, 0, 0, 0, 0 },
/* U+8b5e */ { 0, 0, 0, 0, 0 },
/* U+8b5f */ { 0, 0, 0, 0, 0 },
/* U+8b60 */ { 0, 0, 0, 0, 0 },
/* U+8b61 */ { 0, 0, 0, 0, 0 },
/* U+8b62 */ { 0, 0, 0, 0, 0 },
/* U+8b63 */ { 0, 0, 0, 0, 0 },
/* U+8b64 */ { 0, 0, 0, 0, 0 },
/* U+8b65 */ { 0, 0, 0, 0, 0 },
/* U+8b66 */ { 0, 0, 0, 0, 0 },
/* U+8b67 */ { 0, 0, 0, 0, 0 },
/* U+8b68 */ { 0, 0, 0, 0, 0 },
/* U+8b69 */ { 0, 0, 0, 0, 0 },
/* U+8b6a */ { 0, 0, 0, 0, 0 },
/* U+8b6b */ { 0, 0, 0, 0, 0 },
/* U+8b6c */ { 0, 0, 0, 0, 0 },
/* U+8b6d */ { 0, 0, 0, 0, 0 },
/* U+8b6e */ { 0, 0, 0, 0, 0 },
/* U+8b6f */ { 0, 0, 0, 0, 0 },
/* U+8b70 */ { 0, 0, 0, 0, 0 },
/* U+8b71 */ { 0, 0, 0, 0, 0 },
/* U+8b72 */ { 0, 0, 0, 0, 0 },
/* U+8b73 */ { 0, 0, 0, 0, 0 },
/* U+8b74 */ { 0, 0, 0, 0, 0 },
/* U+8b75 */ { 0, 0, 0, 0, 0 },
/* U+8b76 */ { 0, 0, 0, 0, 0 },
/* U+8b77 */ { 0, 0, 0, 0, 0 },
/* U+8b78 */ { 0, 0, 0, 0, 0 },
/* U+8b79 */ { 0, 0, 0, 0, 0 },
/* U+8b7a */ { 0, 0, 0, 0, 0 },
/* U+8b7b */ { 0, 0, 0, 0, 0 },
/* U+8b7c */ { 0, 0, 0, 0, 0 },
/* U+8b7d */ { 0, 0, 0, 0, 0 },
/* U+8b7e */ { 0, 0, 0, 0, 0 },
/* U+8b7f */ { 0, 0, 0, 0, 0 },
/* U+8b80 */ { 0, 0, 0, 0, 0 },
/* U+8b81 */ { 0, 0, 0, 0, 0 },
/* U+8b82 */ { 0, 0, 0, 0, 0 },
/* U+8b83 */ { 0, 0, 0, 0, 0 },
/* U+8b84 */ { 0, 0, 0, 0, 0 },
/* U+8b85 */ { 0, 0, 0, 0, 0 },
/* U+8b86 */ { 0, 0, 0, 0, 0 },
/* U+8b87 */ { 0, 0, 0, 0, 0 },
/* U+8b88 */ { 0, 0, 0, 0, 0 },
/* U+8b89 */ { 0, 0, 0, 0, 0 },
/* U+8b8a */ { 0, 0, 0, 0, 0 },
/* U+8b8b */ { 0, 0, 0, 0, 0 },
/* U+8b8c */ { 0, 0, 0, 0, 0 },
/* U+8b8d */ { 0, 0, 0, 0, 0 },
/* U+8b8e */ { 0, 0, 0, 0, 0 },
/* U+8b8f */ { 0, 0, 0, 0, 0 },
/* U+8b90 */ { 0, 0, 0, 0, 0 },
/* U+8b91 */ { 0, 0, 0, 0, 0 },
/* U+8b92 */ { 0, 0, 0, 0, 0 },
/* U+8b93 */ { 0, 0, 0, 0, 0 },
/* U+8b94 */ { 0, 0, 0, 0, 0 },
/* U+8b95 */ { 0, 0, 0, 0, 0 },
/* U+8b96 */ { 0, 0, 0, 0, 0 },
/* U+8b97 */ { 0, 0, 0, 0, 0 },
/* U+8b98 */ { 0, 0, 0, 0, 0 },
/* U+8b99 */ { 0, 0, 0, 0, 0 },
/* U+8b9a */ { 0, 0, 0, 0, 0 },
/* U+8b9b */ { 0, 0, 0, 0, 0 },
/* U+8b9c */ { 0, 0, 0, 0, 0 },
/* U+8b9d */ { 0, 0, 0, 0, 0 },
/* U+8b9e */ { 0, 0, 0, 0, 0 },
/* U+8b9f */ { 0, 0, 0, 0, 0 },
/* U+8ba0 */ { 0, 0, 0, 0, 0 },
/* U+8ba1 */ { 0, 0, 0, 0, 0 },
/* U+8ba2 */ { 0, 0, 0, 0, 0 },
/* U+8ba3 */ { 0, 0, 0, 0, 0 },
/* U+8ba4 */ { 0, 0, 0, 0, 0 },
/* U+8ba5 */ { 0, 0, 0, 0, 0 },
/* U+8ba6 */ { 0, 0, 0, 0, 0 },
/* U+8ba7 */ { 0, 0, 0, 0, 0 },
/* U+8ba8 */ { 0, 0, 0, 0, 0 },
/* U+8ba9 */ { 0, 0, 0, 0, 0 },
/* U+8baa */ { 0, 0, 0, 0, 0 },
/* U+8bab */ { 0, 0, 0, 0, 0 },
/* U+8bac */ { 0, 0, 0, 0, 0 },
/* U+8bad */ { 0, 0, 0, 0, 0 },
/* U+8bae */ { 0, 0, 0, 0, 0 },
/* U+8baf */ { 0, 0, 0, 0, 0 },
/* U+8bb0 */ { 0, 0, 0, 0, 0 },
/* U+8bb1 */ { 0, 0, 0, 0, 0 },
/* U+8bb2 */ { 0, 0, 0, 0, 0 },
/* U+8bb3 */ { 0, 0, 0, 0, 0 },
/* U+8bb4 */ { 0, 0, 0, 0, 0 },
/* U+8bb5 */ { 0, 0, 0, 0, 0 },
/* U+8bb6 */ { 0, 0, 0, 0, 0 },
/* U+8bb7 */ { 0, 0, 0, 0, 0 },
/* U+8bb8 */ { 0, 0, 0, 0, 0 },
/* U+8bb9 */ { 0, 0, 0, 0, 0 },
/* U+8bba */ { 0, 0, 0, 0, 0 },
/* U+8bbb */ { 0, 0, 0, 0, 0 },
/* U+8bbc */ { 0, 0, 0, 0, 0 },
/* U+8bbd */ { 0, 0, 0, 0, 0 },
/* U+8bbe */ { 0, 0, 0, 0, 0 },
/* U+8bbf */ { 0, 0, 0, 0, 0 },
/* U+8bc0 */ { 0, 0, 0, 0, 0 },
/* U+8bc1 */ { 0, 0, 0, 0, 0 },
/* U+8bc2 */ { 0, 0, 0, 0, 0 },
/* U+8bc3 */ { 0, 0, 0, 0, 0 },
/* U+8bc4 */ { 0, 0, 0, 0, 0 },
/* U+8bc5 */ { 0, 0, 0, 0, 0 },
/* U+8bc6 */ { 0, 0, 0, 0, 0 },
/* U+8bc7 */ { 0, 0, 0, 0, 0 },
/* U+8bc8 */ { 0, 0, 0, 0, 0 },
/* U+8bc9 */ { 0, 0, 0, 0, 0 },
/* U+8bca */ { 0, 0, 0, 0, 0 },
/* U+8bcb */ { 0, 0, 0, 0, 0 },
/* U+8bcc */ { 0, 0, 0, 0, 0 },
/* U+8bcd */ { 0, 0, 0, 0, 0 },
/* U+8bce */ { 0, 0, 0, 0, 0 },
/* U+8bcf */ { 0, 0, 0, 0, 0 },
/* U+8bd0 */ { 0, 0, 0, 0, 0 },
/* U+8bd1 */ { 0, 0, 0, 0, 0 },
/* U+8bd2 */ { 0, 0, 0, 0, 0 },
/* U+8bd3 */ { 0, 0, 0, 0, 0 },
/* U+8bd4 */ { 0, 0, 0, 0, 0 },
/* U+8bd5 */ { 0, 0, 0, 0, 0 },
/* U+8bd6 */ { 0, 0, 0, 0, 0 },
/* U+8bd7 */ { 0, 0, 0, 0, 0 },
/* U+8bd8 */ { 0, 0, 0, 0, 0 },
/* U+8bd9 */ { 0, 0, 0, 0, 0 },
/* U+8bda */ { 0, 0, 0, 0, 0 },
/* U+8bdb */ { 0, 0, 0, 0, 0 },
/* U+8bdc */ { 0, 0, 0, 0, 0 },
/* U+8bdd */ { 0, 0, 0, 0, 0 },
/* U+8bde */ { 0, 0, 0, 0, 0 },
/* U+8bdf */ { 0, 0, 0, 0, 0 },
/* U+8be0 */ { 0, 0, 0, 0, 0 },
/* U+8be1 */ { 0, 0, 0, 0, 0 },
/* U+8be2 */ { 0, 0, 0, 0, 0 },
/* U+8be3 */ { 0, 0, 0, 0, 0 },
/* U+8be4 */ { 0, 0, 0, 0, 0 },
/* U+8be5 */ { 0, 0, 0, 0, 0 },
/* U+8be6 */ { 0, 0, 0, 0, 0 },
/* U+8be7 */ { 0, 0, 0, 0, 0 },
/* U+8be8 */ { 0, 0, 0, 0, 0 },
/* U+8be9 */ { 0, 0, 0, 0, 0 },
/* U+8bea */ { 0, 0, 0, 0, 0 },
/* U+8beb */ { 0, 0, 0, 0, 0 },
/* U+8bec */ { 0, 0, 0, 0, 0 },
/* U+8bed */ { 0, 0, 0, 0, 0 },
/* U+8bee */ { 0, 0, 0, 0, 0 },
/* U+8bef */ { 0, 0, 0, 0, 0 },
/* U+8bf0 */ { 0, 0, 0, 0, 0 },
/* U+8bf1 */ { 0, 0, 0, 0, 0 },
/* U+8bf2 */ { 0, 0, 0, 0, 0 },
/* U+8bf3 */ { 0, 0, 0, 0, 0 },
/* U+8bf4 */ { 0, 0, 0, 0, 0 },
/* U+8bf5 */ { 0, 0, 0, 0, 0 },
/* U+8bf6 */ { 0, 0, 0, 0, 0 },
/* U+8bf7 */ { 0, 0, 0, 0, 0 },
/* U+8bf8 */ { 0, 0, 0, 0, 0 },
/* U+8bf9 */ { 0, 0, 0, 0, 0 },
/* U+8bfa */ { 0, 0, 0, 0, 0 },
/* U+8bfb */ { 0, 0, 0, 0, 0 },
/* U+8bfc */ { 0, 0, 0, 0, 0 },
/* U+8bfd */ { 0, 0, 0, 0, 0 },
/* U+8bfe */ { 0, 0, 0, 0, 0 },
/* U+8bff */ { 0, 0, 0, 0, 0 },
/* U+8c00 */ { 0, 0, 0, 0, 0 },
/* U+8c01 */ { 0, 0, 0, 0, 0 },
/* U+8c02 */ { 0, 0, 0, 0, 0 },
/* U+8c03 */ { 0, 0, 0, 0, 0 },
/* U+8c04 */ { 0, 0, 0, 0, 0 },
/* U+8c05 */ { 0, 0, 0, 0, 0 },
/* U+8c06 */ { 0, 0, 0, 0, 0 },
/* U+8c07 */ { 0, 0, 0, 0, 0 },
/* U+8c08 */ { 0, 0, 0, 0, 0 },
/* U+8c09 */ { 0, 0, 0, 0, 0 },
/* U+8c0a */ { 0, 0, 0, 0, 0 },
/* U+8c0b */ { 0, 0, 0, 0, 0 },
/* U+8c0c */ { 0, 0, 0, 0, 0 },
/* U+8c0d */ { 0, 0, 0, 0, 0 },
/* U+8c0e */ { 0, 0, 0, 0, 0 },
/* U+8c0f */ { 0, 0, 0, 0, 0 },
/* U+8c10 */ { 0, 0, 0, 0, 0 },
/* U+8c11 */ { 0, 0, 0, 0, 0 },
/* U+8c12 */ { 0, 0, 0, 0, 0 },
/* U+8c13 */ { 0, 0, 0, 0, 0 },
/* U+8c14 */ { 0, 0, 0, 0, 0 },
/* U+8c15 */ { 0, 0, 0, 0, 0 },
/* U+8c16 */ { 0, 0, 0, 0, 0 },
/* U+8c17 */ { 0, 0, 0, 0, 0 },
/* U+8c18 */ { 0, 0, 0, 0, 0 },
/* U+8c19 */ { 0, 0, 0, 0, 0 },
/* U+8c1a */ { 0, 0, 0, 0, 0 },
/* U+8c1b */ { 0, 0, 0, 0, 0 },
/* U+8c1c */ { 0, 0, 0, 0, 0 },
/* U+8c1d */ { 0, 0, 0, 0, 0 },
/* U+8c1e */ { 0, 0, 0, 0, 0 },
/* U+8c1f */ { 0, 0, 0, 0, 0 },
/* U+8c20 */ { 0, 0, 0, 0, 0 },
/* U+8c21 */ { 0, 0, 0, 0, 0 },
/* U+8c22 */ { 0, 0, 0, 0, 0 },
/* U+8c23 */ { 0, 0, 0, 0, 0 },
/* U+8c24 */ { 0, 0, 0, 0, 0 },
/* U+8c25 */ { 0, 0, 0, 0, 0 },
/* U+8c26 */ { 0, 0, 0, 0, 0 },
/* U+8c27 */ { 0, 0, 0, 0, 0 },
/* U+8c28 */ { 0, 0, 0, 0, 0 },
/* U+8c29 */ { 0, 0, 0, 0, 0 },
/* U+8c2a */ { 0, 0, 0, 0, 0 },
/* U+8c2b */ { 0, 0, 0, 0, 0 },
/* U+8c2c */ { 0, 0, 0, 0, 0 },
/* U+8c2d */ { 0, 0, 0, 0, 0 },
/* U+8c2e */ { 0, 0, 0, 0, 0 },
/* U+8c2f */ { 0, 0, 0, 0, 0 },
/* U+8c30 */ { 0, 0, 0, 0, 0 },
/* U+8c31 */ { 0, 0, 0, 0, 0 },
/* U+8c32 */ { 0, 0, 0, 0, 0 },
/* U+8c33 */ { 0, 0, 0, 0, 0 },
/* U+8c34 */ { 0, 0, 0, 0, 0 },
/* U+8c35 */ { 0, 0, 0, 0, 0 },
/* U+8c36 */ { 0, 0, 0, 0, 0 },
/* U+8c37 */ { 0, 0, 0, 0, 0 },
/* U+8c38 */ { 0, 0, 0, 0, 0 },
/* U+8c39 */ { 0, 0, 0, 0, 0 },
/* U+8c3a */ { 0, 0, 0, 0, 0 },
/* U+8c3b */ { 0, 0, 0, 0, 0 },
/* U+8c3c */ { 0, 0, 0, 0, 0 },
/* U+8c3d */ { 0, 0, 0, 0, 0 },
/* U+8c3e */ { 0, 0, 0, 0, 0 },
/* U+8c3f */ { 0, 0, 0, 0, 0 },
/* U+8c40 */ { 0, 0, 0, 0, 0 },
/* U+8c41 */ { 0, 0, 0, 0, 0 },
/* U+8c42 */ { 0, 0, 0, 0, 0 },
/* U+8c43 */ { 0, 0, 0, 0, 0 },
/* U+8c44 */ { 0, 0, 0, 0, 0 },
/* U+8c45 */ { 0, 0, 0, 0, 0 },
/* U+8c46 */ { 0, 0, 0, 0, 0 },
/* U+8c47 */ { 0, 0, 0, 0, 0 },
/* U+8c48 */ { 0, 0, 0, 0, 0 },
/* U+8c49 */ { 0, 0, 0, 0, 0 },
/* U+8c4a */ { 0, 0, 0, 0, 0 },
/* U+8c4b */ { 0, 0, 0, 0, 0 },
/* U+8c4c */ { 0, 0, 0, 0, 0 },
/* U+8c4d */ { 0, 0, 0, 0, 0 },
/* U+8c4e */ { 0, 0, 0, 0, 0 },
/* U+8c4f */ { 0, 0, 0, 0, 0 },
/* U+8c50 */ { 0, 0, 0, 0, 0 },
/* U+8c51 */ { 0, 0, 0, 0, 0 },
/* U+8c52 */ { 0, 0, 0, 0, 0 },
/* U+8c53 */ { 0, 0, 0, 0, 0 },
/* U+8c54 */ { 0, 0, 0, 0, 0 },
/* U+8c55 */ { 0, 0, 0, 0, 0 },
/* U+8c56 */ { 0, 0, 0, 0, 0 },
/* U+8c57 */ { 0, 0, 0, 0, 0 },
/* U+8c58 */ { 0, 0, 0, 0, 0 },
/* U+8c59 */ { 0, 0, 0, 0, 0 },
/* U+8c5a */ { 0, 0, 0, 0, 0 },
/* U+8c5b */ { 0, 0, 0, 0, 0 },
/* U+8c5c */ { 0, 0, 0, 0, 0 },
/* U+8c5d */ { 0, 0, 0, 0, 0 },
/* U+8c5e */ { 0, 0, 0, 0, 0 },
/* U+8c5f */ { 0, 0, 0, 0, 0 },
/* U+8c60 */ { 0, 0, 0, 0, 0 },
/* U+8c61 */ { 0, 0, 0, 0, 0 },
/* U+8c62 */ { 0, 0, 0, 0, 0 },
/* U+8c63 */ { 0, 0, 0, 0, 0 },
/* U+8c64 */ { 0, 0, 0, 0, 0 },
/* U+8c65 */ { 0, 0, 0, 0, 0 },
/* U+8c66 */ { 0, 0, 0, 0, 0 },
/* U+8c67 */ { 0, 0, 0, 0, 0 },
/* U+8c68 */ { 0, 0, 0, 0, 0 },
/* U+8c69 */ { 0, 0, 0, 0, 0 },
/* U+8c6a */ { 0, 0, 0, 0, 0 },
/* U+8c6b */ { 0, 0, 0, 0, 0 },
/* U+8c6c */ { 0, 0, 0, 0, 0 },
/* U+8c6d */ { 0, 0, 0, 0, 0 },
/* U+8c6e */ { 0, 0, 0, 0, 0 },
/* U+8c6f */ { 0, 0, 0, 0, 0 },
/* U+8c70 */ { 0, 0, 0, 0, 0 },
/* U+8c71 */ { 0, 0, 0, 0, 0 },
/* U+8c72 */ { 0, 0, 0, 0, 0 },
/* U+8c73 */ { 0, 0, 0, 0, 0 },
/* U+8c74 */ { 0, 0, 0, 0, 0 },
/* U+8c75 */ { 0, 0, 0, 0, 0 },
/* U+8c76 */ { 0, 0, 0, 0, 0 },
/* U+8c77 */ { 0, 0, 0, 0, 0 },
/* U+8c78 */ { 0, 0, 0, 0, 0 },
/* U+8c79 */ { 0, 0, 0, 0, 0 },
/* U+8c7a */ { 0, 0, 0, 0, 0 },
/* U+8c7b */ { 0, 0, 0, 0, 0 },
/* U+8c7c */ { 0, 0, 0, 0, 0 },
/* U+8c7d */ { 0, 0, 0, 0, 0 },
/* U+8c7e */ { 0, 0, 0, 0, 0 },
/* U+8c7f */ { 0, 0, 0, 0, 0 },
/* U+8c80 */ { 0, 0, 0, 0, 0 },
/* U+8c81 */ { 0, 0, 0, 0, 0 },
/* U+8c82 */ { 0, 0, 0, 0, 0 },
/* U+8c83 */ { 0, 0, 0, 0, 0 },
/* U+8c84 */ { 0, 0, 0, 0, 0 },
/* U+8c85 */ { 0, 0, 0, 0, 0 },
/* U+8c86 */ { 0, 0, 0, 0, 0 },
/* U+8c87 */ { 0, 0, 0, 0, 0 },
/* U+8c88 */ { 0, 0, 0, 0, 0 },
/* U+8c89 */ { 0, 0, 0, 0, 0 },
/* U+8c8a */ { 0, 0, 0, 0, 0 },
/* U+8c8b */ { 0, 0, 0, 0, 0 },
/* U+8c8c */ { 0, 0, 0, 0, 0 },
/* U+8c8d */ { 0, 0, 0, 0, 0 },
/* U+8c8e */ { 0, 0, 0, 0, 0 },
/* U+8c8f */ { 0, 0, 0, 0, 0 },
/* U+8c90 */ { 0, 0, 0, 0, 0 },
/* U+8c91 */ { 0, 0, 0, 0, 0 },
/* U+8c92 */ { 0, 0, 0, 0, 0 },
/* U+8c93 */ { 0, 0, 0, 0, 0 },
/* U+8c94 */ { 0, 0, 0, 0, 0 },
/* U+8c95 */ { 0, 0, 0, 0, 0 },
/* U+8c96 */ { 0, 0, 0, 0, 0 },
/* U+8c97 */ { 0, 0, 0, 0, 0 },
/* U+8c98 */ { 0, 0, 0, 0, 0 },
/* U+8c99 */ { 0, 0, 0, 0, 0 },
/* U+8c9a */ { 0, 0, 0, 0, 0 },
/* U+8c9b */ { 0, 0, 0, 0, 0 },
/* U+8c9c */ { 0, 0, 0, 0, 0 },
/* U+8c9d */ { 0, 0, 0, 0, 0 },
/* U+8c9e */ { 0, 0, 0, 0, 0 },
/* U+8c9f */ { 0, 0, 0, 0, 0 },
/* U+8ca0 */ { 0, 0, 0, 0, 0 },
/* U+8ca1 */ { 0, 0, 0, 0, 0 },
/* U+8ca2 */ { 0, 0, 0, 0, 0 },
/* U+8ca3 */ { 0, 0, 0, 0, 0 },
/* U+8ca4 */ { 0, 0, 0, 0, 0 },
/* U+8ca5 */ { 0, 0, 0, 0, 0 },
/* U+8ca6 */ { 0, 0, 0, 0, 0 },
/* U+8ca7 */ { 0, 0, 0, 0, 0 },
/* U+8ca8 */ { 0, 0, 0, 0, 0 },
/* U+8ca9 */ { 0, 0, 0, 0, 0 },
/* U+8caa */ { 0, 0, 0, 0, 0 },
/* U+8cab */ { 0, 0, 0, 0, 0 },
/* U+8cac */ { 0, 0, 0, 0, 0 },
/* U+8cad */ { 0, 0, 0, 0, 0 },
/* U+8cae */ { 0, 0, 0, 0, 0 },
/* U+8caf */ { 0, 0, 0, 0, 0 },
/* U+8cb0 */ { 0, 0, 0, 0, 0 },
/* U+8cb1 */ { 0, 0, 0, 0, 0 },
/* U+8cb2 */ { 0, 0, 0, 0, 0 },
/* U+8cb3 */ { 0, 0, 0, 0, 0 },
/* U+8cb4 */ { 0, 0, 0, 0, 0 },
/* U+8cb5 */ { 0, 0, 0, 0, 0 },
/* U+8cb6 */ { 0, 0, 0, 0, 0 },
/* U+8cb7 */ { 0, 0, 0, 0, 0 },
/* U+8cb8 */ { 0, 0, 0, 0, 0 },
/* U+8cb9 */ { 0, 0, 0, 0, 0 },
/* U+8cba */ { 0, 0, 0, 0, 0 },
/* U+8cbb */ { 0, 0, 0, 0, 0 },
/* U+8cbc */ { 0, 0, 0, 0, 0 },
/* U+8cbd */ { 0, 0, 0, 0, 0 },
/* U+8cbe */ { 0, 0, 0, 0, 0 },
/* U+8cbf */ { 0, 0, 0, 0, 0 },
/* U+8cc0 */ { 0, 0, 0, 0, 0 },
/* U+8cc1 */ { 0, 0, 0, 0, 0 },
/* U+8cc2 */ { 0, 0, 0, 0, 0 },
/* U+8cc3 */ { 0, 0, 0, 0, 0 },
/* U+8cc4 */ { 0, 0, 0, 0, 0 },
/* U+8cc5 */ { 0, 0, 0, 0, 0 },
/* U+8cc6 */ { 0, 0, 0, 0, 0 },
/* U+8cc7 */ { 0, 0, 0, 0, 0 },
/* U+8cc8 */ { 0, 0, 0, 0, 0 },
/* U+8cc9 */ { 0, 0, 0, 0, 0 },
/* U+8cca */ { 0, 0, 0, 0, 0 },
/* U+8ccb */ { 0, 0, 0, 0, 0 },
/* U+8ccc */ { 0, 0, 0, 0, 0 },
/* U+8ccd */ { 0, 0, 0, 0, 0 },
/* U+8cce */ { 0, 0, 0, 0, 0 },
/* U+8ccf */ { 0, 0, 0, 0, 0 },
/* U+8cd0 */ { 0, 0, 0, 0, 0 },
/* U+8cd1 */ { 0, 0, 0, 0, 0 },
/* U+8cd2 */ { 0, 0, 0, 0, 0 },
/* U+8cd3 */ { 0, 0, 0, 0, 0 },
/* U+8cd4 */ { 0, 0, 0, 0, 0 },
/* U+8cd5 */ { 0, 0, 0, 0, 0 },
/* U+8cd6 */ { 0, 0, 0, 0, 0 },
/* U+8cd7 */ { 0, 0, 0, 0, 0 },
/* U+8cd8 */ { 0, 0, 0, 0, 0 },
/* U+8cd9 */ { 0, 0, 0, 0, 0 },
/* U+8cda */ { 0, 0, 0, 0, 0 },
/* U+8cdb */ { 0, 0, 0, 0, 0 },
/* U+8cdc */ { 0, 0, 0, 0, 0 },
/* U+8cdd */ { 0, 0, 0, 0, 0 },
/* U+8cde */ { 0, 0, 0, 0, 0 },
/* U+8cdf */ { 0, 0, 0, 0, 0 },
/* U+8ce0 */ { 0, 0, 0, 0, 0 },
/* U+8ce1 */ { 0, 0, 0, 0, 0 },
/* U+8ce2 */ { 0, 0, 0, 0, 0 },
/* U+8ce3 */ { 0, 0, 0, 0, 0 },
/* U+8ce4 */ { 0, 0, 0, 0, 0 },
/* U+8ce5 */ { 0, 0, 0, 0, 0 },
/* U+8ce6 */ { 0, 0, 0, 0, 0 },
/* U+8ce7 */ { 0, 0, 0, 0, 0 },
/* U+8ce8 */ { 0, 0, 0, 0, 0 },
/* U+8ce9 */ { 0, 0, 0, 0, 0 },
/* U+8cea */ { 0, 0, 0, 0, 0 },
/* U+8ceb */ { 0, 0, 0, 0, 0 },
/* U+8cec */ { 0, 0, 0, 0, 0 },
/* U+8ced */ { 0, 0, 0, 0, 0 },
/* U+8cee */ { 0, 0, 0, 0, 0 },
/* U+8cef */ { 0, 0, 0, 0, 0 },
/* U+8cf0 */ { 0, 0, 0, 0, 0 },
/* U+8cf1 */ { 0, 0, 0, 0, 0 },
/* U+8cf2 */ { 0, 0, 0, 0, 0 },
/* U+8cf3 */ { 0, 0, 0, 0, 0 },
/* U+8cf4 */ { 0, 0, 0, 0, 0 },
/* U+8cf5 */ { 0, 0, 0, 0, 0 },
/* U+8cf6 */ { 0, 0, 0, 0, 0 },
/* U+8cf7 */ { 0, 0, 0, 0, 0 },
/* U+8cf8 */ { 0, 0, 0, 0, 0 },
/* U+8cf9 */ { 0, 0, 0, 0, 0 },
/* U+8cfa */ { 0, 0, 0, 0, 0 },
/* U+8cfb */ { 0, 0, 0, 0, 0 },
/* U+8cfc */ { 0, 0, 0, 0, 0 },
/* U+8cfd */ { 0, 0, 0, 0, 0 },
/* U+8cfe */ { 0, 0, 0, 0, 0 },
/* U+8cff */ { 0, 0, 0, 0, 0 },
/* U+8d00 */ { 0, 0, 0, 0, 0 },
/* U+8d01 */ { 0, 0, 0, 0, 0 },
/* U+8d02 */ { 0, 0, 0, 0, 0 },
/* U+8d03 */ { 0, 0, 0, 0, 0 },
/* U+8d04 */ { 0, 0, 0, 0, 0 },
/* U+8d05 */ { 0, 0, 0, 0, 0 },
/* U+8d06 */ { 0, 0, 0, 0, 0 },
/* U+8d07 */ { 0, 0, 0, 0, 0 },
/* U+8d08 */ { 0, 0, 0, 0, 0 },
/* U+8d09 */ { 0, 0, 0, 0, 0 },
/* U+8d0a */ { 0, 0, 0, 0, 0 },
/* U+8d0b */ { 0, 0, 0, 0, 0 },
/* U+8d0c */ { 0, 0, 0, 0, 0 },
/* U+8d0d */ { 0, 0, 0, 0, 0 },
/* U+8d0e */ { 0, 0, 0, 0, 0 },
/* U+8d0f */ { 0, 0, 0, 0, 0 },
/* U+8d10 */ { 0, 0, 0, 0, 0 },
/* U+8d11 */ { 0, 0, 0, 0, 0 },
/* U+8d12 */ { 0, 0, 0, 0, 0 },
/* U+8d13 */ { 0, 0, 0, 0, 0 },
/* U+8d14 */ { 0, 0, 0, 0, 0 },
/* U+8d15 */ { 0, 0, 0, 0, 0 },
/* U+8d16 */ { 0, 0, 0, 0, 0 },
/* U+8d17 */ { 0, 0, 0, 0, 0 },
/* U+8d18 */ { 0, 0, 0, 0, 0 },
/* U+8d19 */ { 0, 0, 0, 0, 0 },
/* U+8d1a */ { 0, 0, 0, 0, 0 },
/* U+8d1b */ { 0, 0, 0, 0, 0 },
/* U+8d1c */ { 0, 0, 0, 0, 0 },
/* U+8d1d */ { 0, 0, 0, 0, 0 },
/* U+8d1e */ { 0, 0, 0, 0, 0 },
/* U+8d1f */ { 0, 0, 0, 0, 0 },
/* U+8d20 */ { 0, 0, 0, 0, 0 },
/* U+8d21 */ { 0, 0, 0, 0, 0 },
/* U+8d22 */ { 0, 0, 0, 0, 0 },
/* U+8d23 */ { 0, 0, 0, 0, 0 },
/* U+8d24 */ { 0, 0, 0, 0, 0 },
/* U+8d25 */ { 0, 0, 0, 0, 0 },
/* U+8d26 */ { 0, 0, 0, 0, 0 },
/* U+8d27 */ { 0, 0, 0, 0, 0 },
/* U+8d28 */ { 0, 0, 0, 0, 0 },
/* U+8d29 */ { 0, 0, 0, 0, 0 },
/* U+8d2a */ { 0, 0, 0, 0, 0 },
/* U+8d2b */ { 0, 0, 0, 0, 0 },
/* U+8d2c */ { 0, 0, 0, 0, 0 },
/* U+8d2d */ { 0, 0, 0, 0, 0 },
/* U+8d2e */ { 0, 0, 0, 0, 0 },
/* U+8d2f */ { 0, 0, 0, 0, 0 },
/* U+8d30 */ { 0, 0, 0, 0, 0 },
/* U+8d31 */ { 0, 0, 0, 0, 0 },
/* U+8d32 */ { 0, 0, 0, 0, 0 },
/* U+8d33 */ { 0, 0, 0, 0, 0 },
/* U+8d34 */ { 0, 0, 0, 0, 0 },
/* U+8d35 */ { 0, 0, 0, 0, 0 },
/* U+8d36 */ { 0, 0, 0, 0, 0 },
/* U+8d37 */ { 0, 0, 0, 0, 0 },
/* U+8d38 */ { 0, 0, 0, 0, 0 },
/* U+8d39 */ { 0, 0, 0, 0, 0 },
/* U+8d3a */ { 0, 0, 0, 0, 0 },
/* U+8d3b */ { 0, 0, 0, 0, 0 },
/* U+8d3c */ { 0, 0, 0, 0, 0 },
/* U+8d3d */ { 0, 0, 0, 0, 0 },
/* U+8d3e */ { 0, 0, 0, 0, 0 },
/* U+8d3f */ { 0, 0, 0, 0, 0 },
/* U+8d40 */ { 0, 0, 0, 0, 0 },
/* U+8d41 */ { 0, 0, 0, 0, 0 },
/* U+8d42 */ { 0, 0, 0, 0, 0 },
/* U+8d43 */ { 0, 0, 0, 0, 0 },
/* U+8d44 */ { 0, 0, 0, 0, 0 },
/* U+8d45 */ { 0, 0, 0, 0, 0 },
/* U+8d46 */ { 0, 0, 0, 0, 0 },
/* U+8d47 */ { 0, 0, 0, 0, 0 },
/* U+8d48 */ { 0, 0, 0, 0, 0 },
/* U+8d49 */ { 0, 0, 0, 0, 0 },
/* U+8d4a */ { 0, 0, 0, 0, 0 },
/* U+8d4b */ { 0, 0, 0, 0, 0 },
/* U+8d4c */ { 0, 0, 0, 0, 0 },
/* U+8d4d */ { 0, 0, 0, 0, 0 },
/* U+8d4e */ { 0, 0, 0, 0, 0 },
/* U+8d4f */ { 0, 0, 0, 0, 0 },
/* U+8d50 */ { 0, 0, 0, 0, 0 },
/* U+8d51 */ { 0, 0, 0, 0, 0 },
/* U+8d52 */ { 0, 0, 0, 0, 0 },
/* U+8d53 */ { 0, 0, 0, 0, 0 },
/* U+8d54 */ { 0, 0, 0, 0, 0 },
/* U+8d55 */ { 0, 0, 0, 0, 0 },
/* U+8d56 */ { 0, 0, 0, 0, 0 },
/* U+8d57 */ { 0, 0, 0, 0, 0 },
/* U+8d58 */ { 0, 0, 0, 0, 0 },
/* U+8d59 */ { 0, 0, 0, 0, 0 },
/* U+8d5a */ { 0, 0, 0, 0, 0 },
/* U+8d5b */ { 0, 0, 0, 0, 0 },
/* U+8d5c */ { 0, 0, 0, 0, 0 },
/* U+8d5d */ { 0, 0, 0, 0, 0 },
/* U+8d5e */ { 0, 0, 0, 0, 0 },
/* U+8d5f */ { 0, 0, 0, 0, 0 },
/* U+8d60 */ { 0, 0, 0, 0, 0 },
/* U+8d61 */ { 0, 0, 0, 0, 0 },
/* U+8d62 */ { 0, 0, 0, 0, 0 },
/* U+8d63 */ { 0, 0, 0, 0, 0 },
/* U+8d64 */ { 0, 0, 0, 0, 0 },
/* U+8d65 */ { 0, 0, 0, 0, 0 },
/* U+8d66 */ { 0, 0, 0, 0, 0 },
/* U+8d67 */ { 0, 0, 0, 0, 0 },
/* U+8d68 */ { 0, 0, 0, 0, 0 },
/* U+8d69 */ { 0, 0, 0, 0, 0 },
/* U+8d6a */ { 0, 0, 0, 0, 0 },
/* U+8d6b */ { 0, 0, 0, 0, 0 },
/* U+8d6c */ { 0, 0, 0, 0, 0 },
/* U+8d6d */ { 0, 0, 0, 0, 0 },
/* U+8d6e */ { 0, 0, 0, 0, 0 },
/* U+8d6f */ { 0, 0, 0, 0, 0 },
/* U+8d70 */ { 0, 0, 0, 0, 0 },
/* U+8d71 */ { 0, 0, 0, 0, 0 },
/* U+8d72 */ { 0, 0, 0, 0, 0 },
/* U+8d73 */ { 0, 0, 0, 0, 0 },
/* U+8d74 */ { 0, 0, 0, 0, 0 },
/* U+8d75 */ { 0, 0, 0, 0, 0 },
/* U+8d76 */ { 0, 0, 0, 0, 0 },
/* U+8d77 */ { 0, 0, 0, 0, 0 },
/* U+8d78 */ { 0, 0, 0, 0, 0 },
/* U+8d79 */ { 0, 0, 0, 0, 0 },
/* U+8d7a */ { 0, 0, 0, 0, 0 },
/* U+8d7b */ { 0, 0, 0, 0, 0 },
/* U+8d7c */ { 0, 0, 0, 0, 0 },
/* U+8d7d */ { 0, 0, 0, 0, 0 },
/* U+8d7e */ { 0, 0, 0, 0, 0 },
/* U+8d7f */ { 0, 0, 0, 0, 0 },
/* U+8d80 */ { 0, 0, 0, 0, 0 },
/* U+8d81 */ { 0, 0, 0, 0, 0 },
/* U+8d82 */ { 0, 0, 0, 0, 0 },
/* U+8d83 */ { 0, 0, 0, 0, 0 },
/* U+8d84 */ { 0, 0, 0, 0, 0 },
/* U+8d85 */ { 0, 0, 0, 0, 0 },
/* U+8d86 */ { 0, 0, 0, 0, 0 },
/* U+8d87 */ { 0, 0, 0, 0, 0 },
/* U+8d88 */ { 0, 0, 0, 0, 0 },
/* U+8d89 */ { 0, 0, 0, 0, 0 },
/* U+8d8a */ { 0, 0, 0, 0, 0 },
/* U+8d8b */ { 0, 0, 0, 0, 0 },
/* U+8d8c */ { 0, 0, 0, 0, 0 },
/* U+8d8d */ { 0, 0, 0, 0, 0 },
/* U+8d8e */ { 0, 0, 0, 0, 0 },
/* U+8d8f */ { 0, 0, 0, 0, 0 },
/* U+8d90 */ { 0, 0, 0, 0, 0 },
/* U+8d91 */ { 0, 0, 0, 0, 0 },
/* U+8d92 */ { 0, 0, 0, 0, 0 },
/* U+8d93 */ { 0, 0, 0, 0, 0 },
/* U+8d94 */ { 0, 0, 0, 0, 0 },
/* U+8d95 */ { 0, 0, 0, 0, 0 },
/* U+8d96 */ { 0, 0, 0, 0, 0 },
/* U+8d97 */ { 0, 0, 0, 0, 0 },
/* U+8d98 */ { 0, 0, 0, 0, 0 },
/* U+8d99 */ { 0, 0, 0, 0, 0 },
/* U+8d9a */ { 0, 0, 0, 0, 0 },
/* U+8d9b */ { 0, 0, 0, 0, 0 },
/* U+8d9c */ { 0, 0, 0, 0, 0 },
/* U+8d9d */ { 0, 0, 0, 0, 0 },
/* U+8d9e */ { 0, 0, 0, 0, 0 },
/* U+8d9f */ { 0, 0, 0, 0, 0 },
/* U+8da0 */ { 0, 0, 0, 0, 0 },
/* U+8da1 */ { 0, 0, 0, 0, 0 },
/* U+8da2 */ { 0, 0, 0, 0, 0 },
/* U+8da3 */ { 0, 0, 0, 0, 0 },
/* U+8da4 */ { 0, 0, 0, 0, 0 },
/* U+8da5 */ { 0, 0, 0, 0, 0 },
/* U+8da6 */ { 0, 0, 0, 0, 0 },
/* U+8da7 */ { 0, 0, 0, 0, 0 },
/* U+8da8 */ { 0, 0, 0, 0, 0 },
/* U+8da9 */ { 0, 0, 0, 0, 0 },
/* U+8daa */ { 0, 0, 0, 0, 0 },
/* U+8dab */ { 0, 0, 0, 0, 0 },
/* U+8dac */ { 0, 0, 0, 0, 0 },
/* U+8dad */ { 0, 0, 0, 0, 0 },
/* U+8dae */ { 0, 0, 0, 0, 0 },
/* U+8daf */ { 0, 0, 0, 0, 0 },
/* U+8db0 */ { 0, 0, 0, 0, 0 },
/* U+8db1 */ { 0, 0, 0, 0, 0 },
/* U+8db2 */ { 0, 0, 0, 0, 0 },
/* U+8db3 */ { 0, 0, 0, 0, 0 },
/* U+8db4 */ { 0, 0, 0, 0, 0 },
/* U+8db5 */ { 0, 0, 0, 0, 0 },
/* U+8db6 */ { 0, 0, 0, 0, 0 },
/* U+8db7 */ { 0, 0, 0, 0, 0 },
/* U+8db8 */ { 0, 0, 0, 0, 0 },
/* U+8db9 */ { 0, 0, 0, 0, 0 },
/* U+8dba */ { 0, 0, 0, 0, 0 },
/* U+8dbb */ { 0, 0, 0, 0, 0 },
/* U+8dbc */ { 0, 0, 0, 0, 0 },
/* U+8dbd */ { 0, 0, 0, 0, 0 },
/* U+8dbe */ { 0, 0, 0, 0, 0 },
/* U+8dbf */ { 0, 0, 0, 0, 0 },
/* U+8dc0 */ { 0, 0, 0, 0, 0 },
/* U+8dc1 */ { 0, 0, 0, 0, 0 },
/* U+8dc2 */ { 0, 0, 0, 0, 0 },
/* U+8dc3 */ { 0, 0, 0, 0, 0 },
/* U+8dc4 */ { 0, 0, 0, 0, 0 },
/* U+8dc5 */ { 0, 0, 0, 0, 0 },
/* U+8dc6 */ { 0, 0, 0, 0, 0 },
/* U+8dc7 */ { 0, 0, 0, 0, 0 },
/* U+8dc8 */ { 0, 0, 0, 0, 0 },
/* U+8dc9 */ { 0, 0, 0, 0, 0 },
/* U+8dca */ { 0, 0, 0, 0, 0 },
/* U+8dcb */ { 0, 0, 0, 0, 0 },
/* U+8dcc */ { 0, 0, 0, 0, 0 },
/* U+8dcd */ { 0, 0, 0, 0, 0 },
/* U+8dce */ { 0, 0, 0, 0, 0 },
/* U+8dcf */ { 0, 0, 0, 0, 0 },
/* U+8dd0 */ { 0, 0, 0, 0, 0 },
/* U+8dd1 */ { 0, 0, 0, 0, 0 },
/* U+8dd2 */ { 0, 0, 0, 0, 0 },
/* U+8dd3 */ { 0, 0, 0, 0, 0 },
/* U+8dd4 */ { 0, 0, 0, 0, 0 },
/* U+8dd5 */ { 0, 0, 0, 0, 0 },
/* U+8dd6 */ { 0, 0, 0, 0, 0 },
/* U+8dd7 */ { 0, 0, 0, 0, 0 },
/* U+8dd8 */ { 0, 0, 0, 0, 0 },
/* U+8dd9 */ { 0, 0, 0, 0, 0 },
/* U+8dda */ { 0, 0, 0, 0, 0 },
/* U+8ddb */ { 0, 0, 0, 0, 0 },
/* U+8ddc */ { 0, 0, 0, 0, 0 },
/* U+8ddd */ { 0, 0, 0, 0, 0 },
/* U+8dde */ { 0, 0, 0, 0, 0 },
/* U+8ddf */ { 0, 0, 0, 0, 0 },
/* U+8de0 */ { 0, 0, 0, 0, 0 },
/* U+8de1 */ { 0, 0, 0, 0, 0 },
/* U+8de2 */ { 0, 0, 0, 0, 0 },
/* U+8de3 */ { 0, 0, 0, 0, 0 },
/* U+8de4 */ { 0, 0, 0, 0, 0 },
/* U+8de5 */ { 0, 0, 0, 0, 0 },
/* U+8de6 */ { 0, 0, 0, 0, 0 },
/* U+8de7 */ { 0, 0, 0, 0, 0 },
/* U+8de8 */ { 0, 0, 0, 0, 0 },
/* U+8de9 */ { 0, 0, 0, 0, 0 },
/* U+8dea */ { 0, 0, 0, 0, 0 },
/* U+8deb */ { 0, 0, 0, 0, 0 },
/* U+8dec */ { 0, 0, 0, 0, 0 },
/* U+8ded */ { 0, 0, 0, 0, 0 },
/* U+8dee */ { 0, 0, 0, 0, 0 },
/* U+8def */ { 0, 0, 0, 0, 0 },
/* U+8df0 */ { 0, 0, 0, 0, 0 },
/* U+8df1 */ { 0, 0, 0, 0, 0 },
/* U+8df2 */ { 0, 0, 0, 0, 0 },
/* U+8df3 */ { 0, 0, 0, 0, 0 },
/* U+8df4 */ { 0, 0, 0, 0, 0 },
/* U+8df5 */ { 0, 0, 0, 0, 0 },
/* U+8df6 */ { 0, 0, 0, 0, 0 },
/* U+8df7 */ { 0, 0, 0, 0, 0 },
/* U+8df8 */ { 0, 0, 0, 0, 0 },
/* U+8df9 */ { 0, 0, 0, 0, 0 },
/* U+8dfa */ { 0, 0, 0, 0, 0 },
/* U+8dfb */ { 0, 0, 0, 0, 0 },
/* U+8dfc */ { 0, 0, 0, 0, 0 },
/* U+8dfd */ { 0, 0, 0, 0, 0 },
/* U+8dfe */ { 0, 0, 0, 0, 0 },
/* U+8dff */ { 0, 0, 0, 0, 0 },
/* U+8e00 */ { 0, 0, 0, 0, 0 },
/* U+8e01 */ { 0, 0, 0, 0, 0 },
/* U+8e02 */ { 0, 0, 0, 0, 0 },
/* U+8e03 */ { 0, 0, 0, 0, 0 },
/* U+8e04 */ { 0, 0, 0, 0, 0 },
/* U+8e05 */ { 0, 0, 0, 0, 0 },
/* U+8e06 */ { 0, 0, 0, 0, 0 },
/* U+8e07 */ { 0, 0, 0, 0, 0 },
/* U+8e08 */ { 0, 0, 0, 0, 0 },
/* U+8e09 */ { 0, 0, 0, 0, 0 },
/* U+8e0a */ { 0, 0, 0, 0, 0 },
/* U+8e0b */ { 0, 0, 0, 0, 0 },
/* U+8e0c */ { 0, 0, 0, 0, 0 },
/* U+8e0d */ { 0, 0, 0, 0, 0 },
/* U+8e0e */ { 0, 0, 0, 0, 0 },
/* U+8e0f */ { 0, 0, 0, 0, 0 },
/* U+8e10 */ { 0, 0, 0, 0, 0 },
/* U+8e11 */ { 0, 0, 0, 0, 0 },
/* U+8e12 */ { 0, 0, 0, 0, 0 },
/* U+8e13 */ { 0, 0, 0, 0, 0 },
/* U+8e14 */ { 0, 0, 0, 0, 0 },
/* U+8e15 */ { 0, 0, 0, 0, 0 },
/* U+8e16 */ { 0, 0, 0, 0, 0 },
/* U+8e17 */ { 0, 0, 0, 0, 0 },
/* U+8e18 */ { 0, 0, 0, 0, 0 },
/* U+8e19 */ { 0, 0, 0, 0, 0 },
/* U+8e1a */ { 0, 0, 0, 0, 0 },
/* U+8e1b */ { 0, 0, 0, 0, 0 },
/* U+8e1c */ { 0, 0, 0, 0, 0 },
/* U+8e1d */ { 0, 0, 0, 0, 0 },
/* U+8e1e */ { 0, 0, 0, 0, 0 },
/* U+8e1f */ { 0, 0, 0, 0, 0 },
/* U+8e20 */ { 0, 0, 0, 0, 0 },
/* U+8e21 */ { 0, 0, 0, 0, 0 },
/* U+8e22 */ { 0, 0, 0, 0, 0 },
/* U+8e23 */ { 0, 0, 0, 0, 0 },
/* U+8e24 */ { 0, 0, 0, 0, 0 },
/* U+8e25 */ { 0, 0, 0, 0, 0 },
/* U+8e26 */ { 0, 0, 0, 0, 0 },
/* U+8e27 */ { 0, 0, 0, 0, 0 },
/* U+8e28 */ { 0, 0, 0, 0, 0 },
/* U+8e29 */ { 0, 0, 0, 0, 0 },
/* U+8e2a */ { 0, 0, 0, 0, 0 },
/* U+8e2b */ { 0, 0, 0, 0, 0 },
/* U+8e2c */ { 0, 0, 0, 0, 0 },
/* U+8e2d */ { 0, 0, 0, 0, 0 },
/* U+8e2e */ { 0, 0, 0, 0, 0 },
/* U+8e2f */ { 0, 0, 0, 0, 0 },
/* U+8e30 */ { 0, 0, 0, 0, 0 },
/* U+8e31 */ { 0, 0, 0, 0, 0 },
/* U+8e32 */ { 0, 0, 0, 0, 0 },
/* U+8e33 */ { 0, 0, 0, 0, 0 },
/* U+8e34 */ { 0, 0, 0, 0, 0 },
/* U+8e35 */ { 0, 0, 0, 0, 0 },
/* U+8e36 */ { 0, 0, 0, 0, 0 },
/* U+8e37 */ { 0, 0, 0, 0, 0 },
/* U+8e38 */ { 0, 0, 0, 0, 0 },
/* U+8e39 */ { 0, 0, 0, 0, 0 },
/* U+8e3a */ { 0, 0, 0, 0, 0 },
/* U+8e3b */ { 0, 0, 0, 0, 0 },
/* U+8e3c */ { 0, 0, 0, 0, 0 },
/* U+8e3d */ { 0, 0, 0, 0, 0 },
/* U+8e3e */ { 0, 0, 0, 0, 0 },
/* U+8e3f */ { 0, 0, 0, 0, 0 },
/* U+8e40 */ { 0, 0, 0, 0, 0 },
/* U+8e41 */ { 0, 0, 0, 0, 0 },
/* U+8e42 */ { 0, 0, 0, 0, 0 },
/* U+8e43 */ { 0, 0, 0, 0, 0 },
/* U+8e44 */ { 0, 0, 0, 0, 0 },
/* U+8e45 */ { 0, 0, 0, 0, 0 },
/* U+8e46 */ { 0, 0, 0, 0, 0 },
/* U+8e47 */ { 0, 0, 0, 0, 0 },
/* U+8e48 */ { 0, 0, 0, 0, 0 },
/* U+8e49 */ { 0, 0, 0, 0, 0 },
/* U+8e4a */ { 0, 0, 0, 0, 0 },
/* U+8e4b */ { 0, 0, 0, 0, 0 },
/* U+8e4c */ { 0, 0, 0, 0, 0 },
/* U+8e4d */ { 0, 0, 0, 0, 0 },
/* U+8e4e */ { 0, 0, 0, 0, 0 },
/* U+8e4f */ { 0, 0, 0, 0, 0 },
/* U+8e50 */ { 0, 0, 0, 0, 0 },
/* U+8e51 */ { 0, 0, 0, 0, 0 },
/* U+8e52 */ { 0, 0, 0, 0, 0 },
/* U+8e53 */ { 0, 0, 0, 0, 0 },
/* U+8e54 */ { 0, 0, 0, 0, 0 },
/* U+8e55 */ { 0, 0, 0, 0, 0 },
/* U+8e56 */ { 0, 0, 0, 0, 0 },
/* U+8e57 */ { 0, 0, 0, 0, 0 },
/* U+8e58 */ { 0, 0, 0, 0, 0 },
/* U+8e59 */ { 0, 0, 0, 0, 0 },
/* U+8e5a */ { 0, 0, 0, 0, 0 },
/* U+8e5b */ { 0, 0, 0, 0, 0 },
/* U+8e5c */ { 0, 0, 0, 0, 0 },
/* U+8e5d */ { 0, 0, 0, 0, 0 },
/* U+8e5e */ { 0, 0, 0, 0, 0 },
/* U+8e5f */ { 0, 0, 0, 0, 0 },
/* U+8e60 */ { 0, 0, 0, 0, 0 },
/* U+8e61 */ { 0, 0, 0, 0, 0 },
/* U+8e62 */ { 0, 0, 0, 0, 0 },
/* U+8e63 */ { 0, 0, 0, 0, 0 },
/* U+8e64 */ { 0, 0, 0, 0, 0 },
/* U+8e65 */ { 0, 0, 0, 0, 0 },
/* U+8e66 */ { 0, 0, 0, 0, 0 },
/* U+8e67 */ { 0, 0, 0, 0, 0 },
/* U+8e68 */ { 0, 0, 0, 0, 0 },
/* U+8e69 */ { 0, 0, 0, 0, 0 },
/* U+8e6a */ { 0, 0, 0, 0, 0 },
/* U+8e6b */ { 0, 0, 0, 0, 0 },
/* U+8e6c */ { 0, 0, 0, 0, 0 },
/* U+8e6d */ { 0, 0, 0, 0, 0 },
/* U+8e6e */ { 0, 0, 0, 0, 0 },
/* U+8e6f */ { 0, 0, 0, 0, 0 },
/* U+8e70 */ { 0, 0, 0, 0, 0 },
/* U+8e71 */ { 0, 0, 0, 0, 0 },
/* U+8e72 */ { 0, 0, 0, 0, 0 },
/* U+8e73 */ { 0, 0, 0, 0, 0 },
/* U+8e74 */ { 0, 0, 0, 0, 0 },
/* U+8e75 */ { 0, 0, 0, 0, 0 },
/* U+8e76 */ { 0, 0, 0, 0, 0 },
/* U+8e77 */ { 0, 0, 0, 0, 0 },
/* U+8e78 */ { 0, 0, 0, 0, 0 },
/* U+8e79 */ { 0, 0, 0, 0, 0 },
/* U+8e7a */ { 0, 0, 0, 0, 0 },
/* U+8e7b */ { 0, 0, 0, 0, 0 },
/* U+8e7c */ { 0, 0, 0, 0, 0 },
/* U+8e7d */ { 0, 0, 0, 0, 0 },
/* U+8e7e */ { 0, 0, 0, 0, 0 },
/* U+8e7f */ { 0, 0, 0, 0, 0 },
/* U+8e80 */ { 0, 0, 0, 0, 0 },
/* U+8e81 */ { 0, 0, 0, 0, 0 },
/* U+8e82 */ { 0, 0, 0, 0, 0 },
/* U+8e83 */ { 0, 0, 0, 0, 0 },
/* U+8e84 */ { 0, 0, 0, 0, 0 },
/* U+8e85 */ { 0, 0, 0, 0, 0 },
/* U+8e86 */ { 0, 0, 0, 0, 0 },
/* U+8e87 */ { 0, 0, 0, 0, 0 },
/* U+8e88 */ { 0, 0, 0, 0, 0 },
/* U+8e89 */ { 0, 0, 0, 0, 0 },
/* U+8e8a */ { 0, 0, 0, 0, 0 },
/* U+8e8b */ { 0, 0, 0, 0, 0 },
/* U+8e8c */ { 0, 0, 0, 0, 0 },
/* U+8e8d */ { 0, 0, 0, 0, 0 },
/* U+8e8e */ { 0, 0, 0, 0, 0 },
/* U+8e8f */ { 0, 0, 0, 0, 0 },
/* U+8e90 */ { 0, 0, 0, 0, 0 },
/* U+8e91 */ { 0, 0, 0, 0, 0 },
/* U+8e92 */ { 0, 0, 0, 0, 0 },
/* U+8e93 */ { 0, 0, 0, 0, 0 },
/* U+8e94 */ { 0, 0, 0, 0, 0 },
/* U+8e95 */ { 0, 0, 0, 0, 0 },
/* U+8e96 */ { 0, 0, 0, 0, 0 },
/* U+8e97 */ { 0, 0, 0, 0, 0 },
/* U+8e98 */ { 0, 0, 0, 0, 0 },
/* U+8e99 */ { 0, 0, 0, 0, 0 },
/* U+8e9a */ { 0, 0, 0, 0, 0 },
/* U+8e9b */ { 0, 0, 0, 0, 0 },
/* U+8e9c */ { 0, 0, 0, 0, 0 },
/* U+8e9d */ { 0, 0, 0, 0, 0 },
/* U+8e9e */ { 0, 0, 0, 0, 0 },
/* U+8e9f */ { 0, 0, 0, 0, 0 },
/* U+8ea0 */ { 0, 0, 0, 0, 0 },
/* U+8ea1 */ { 0, 0, 0, 0, 0 },
/* U+8ea2 */ { 0, 0, 0, 0, 0 },
/* U+8ea3 */ { 0, 0, 0, 0, 0 },
/* U+8ea4 */ { 0, 0, 0, 0, 0 },
/* U+8ea5 */ { 0, 0, 0, 0, 0 },
/* U+8ea6 */ { 0, 0, 0, 0, 0 },
/* U+8ea7 */ { 0, 0, 0, 0, 0 },
/* U+8ea8 */ { 0, 0, 0, 0, 0 },
/* U+8ea9 */ { 0, 0, 0, 0, 0 },
/* U+8eaa */ { 0, 0, 0, 0, 0 },
/* U+8eab */ { 0, 0, 0, 0, 0 },
/* U+8eac */ { 0, 0, 0, 0, 0 },
/* U+8ead */ { 0, 0, 0, 0, 0 },
/* U+8eae */ { 0, 0, 0, 0, 0 },
/* U+8eaf */ { 0, 0, 0, 0, 0 },
/* U+8eb0 */ { 0, 0, 0, 0, 0 },
/* U+8eb1 */ { 0, 0, 0, 0, 0 },
/* U+8eb2 */ { 0, 0, 0, 0, 0 },
/* U+8eb3 */ { 0, 0, 0, 0, 0 },
/* U+8eb4 */ { 0, 0, 0, 0, 0 },
/* U+8eb5 */ { 0, 0, 0, 0, 0 },
/* U+8eb6 */ { 0, 0, 0, 0, 0 },
/* U+8eb7 */ { 0, 0, 0, 0, 0 },
/* U+8eb8 */ { 0, 0, 0, 0, 0 },
/* U+8eb9 */ { 0, 0, 0, 0, 0 },
/* U+8eba */ { 0, 0, 0, 0, 0 },
/* U+8ebb */ { 0, 0, 0, 0, 0 },
/* U+8ebc */ { 0, 0, 0, 0, 0 },
/* U+8ebd */ { 0, 0, 0, 0, 0 },
/* U+8ebe */ { 0, 0, 0, 0, 0 },
/* U+8ebf */ { 0, 0, 0, 0, 0 },
/* U+8ec0 */ { 0, 0, 0, 0, 0 },
/* U+8ec1 */ { 0, 0, 0, 0, 0 },
/* U+8ec2 */ { 0, 0, 0, 0, 0 },
/* U+8ec3 */ { 0, 0, 0, 0, 0 },
/* U+8ec4 */ { 0, 0, 0, 0, 0 },
/* U+8ec5 */ { 0, 0, 0, 0, 0 },
/* U+8ec6 */ { 0, 0, 0, 0, 0 },
/* U+8ec7 */ { 0, 0, 0, 0, 0 },
/* U+8ec8 */ { 0, 0, 0, 0, 0 },
/* U+8ec9 */ { 0, 0, 0, 0, 0 },
/* U+8eca */ { 0, 0, 0, 0, 0 },
/* U+8ecb */ { 0, 0, 0, 0, 0 },
/* U+8ecc */ { 0, 0, 0, 0, 0 },
/* U+8ecd */ { 0, 0, 0, 0, 0 },
/* U+8ece */ { 0, 0, 0, 0, 0 },
/* U+8ecf */ { 0, 0, 0, 0, 0 },
/* U+8ed0 */ { 0, 0, 0, 0, 0 },
/* U+8ed1 */ { 0, 0, 0, 0, 0 },
/* U+8ed2 */ { 0, 0, 0, 0, 0 },
/* U+8ed3 */ { 0, 0, 0, 0, 0 },
/* U+8ed4 */ { 0, 0, 0, 0, 0 },
/* U+8ed5 */ { 0, 0, 0, 0, 0 },
/* U+8ed6 */ { 0, 0, 0, 0, 0 },
/* U+8ed7 */ { 0, 0, 0, 0, 0 },
/* U+8ed8 */ { 0, 0, 0, 0, 0 },
/* U+8ed9 */ { 0, 0, 0, 0, 0 },
/* U+8eda */ { 0, 0, 0, 0, 0 },
/* U+8edb */ { 0, 0, 0, 0, 0 },
/* U+8edc */ { 0, 0, 0, 0, 0 },
/* U+8edd */ { 0, 0, 0, 0, 0 },
/* U+8ede */ { 0, 0, 0, 0, 0 },
/* U+8edf */ { 0, 0, 0, 0, 0 },
/* U+8ee0 */ { 0, 0, 0, 0, 0 },
/* U+8ee1 */ { 0, 0, 0, 0, 0 },
/* U+8ee2 */ { 0, 0, 0, 0, 0 },
/* U+8ee3 */ { 0, 0, 0, 0, 0 },
/* U+8ee4 */ { 0, 0, 0, 0, 0 },
/* U+8ee5 */ { 0, 0, 0, 0, 0 },
/* U+8ee6 */ { 0, 0, 0, 0, 0 },
/* U+8ee7 */ { 0, 0, 0, 0, 0 },
/* U+8ee8 */ { 0, 0, 0, 0, 0 },
/* U+8ee9 */ { 0, 0, 0, 0, 0 },
/* U+8eea */ { 0, 0, 0, 0, 0 },
/* U+8eeb */ { 0, 0, 0, 0, 0 },
/* U+8eec */ { 0, 0, 0, 0, 0 },
/* U+8eed */ { 0, 0, 0, 0, 0 },
/* U+8eee */ { 0, 0, 0, 0, 0 },
/* U+8eef */ { 0, 0, 0, 0, 0 },
/* U+8ef0 */ { 0, 0, 0, 0, 0 },
/* U+8ef1 */ { 0, 0, 0, 0, 0 },
/* U+8ef2 */ { 0, 0, 0, 0, 0 },
/* U+8ef3 */ { 0, 0, 0, 0, 0 },
/* U+8ef4 */ { 0, 0, 0, 0, 0 },
/* U+8ef5 */ { 0, 0, 0, 0, 0 },
/* U+8ef6 */ { 0, 0, 0, 0, 0 },
/* U+8ef7 */ { 0, 0, 0, 0, 0 },
/* U+8ef8 */ { 0, 0, 0, 0, 0 },
/* U+8ef9 */ { 0, 0, 0, 0, 0 },
/* U+8efa */ { 0, 0, 0, 0, 0 },
/* U+8efb */ { 0, 0, 0, 0, 0 },
/* U+8efc */ { 0, 0, 0, 0, 0 },
/* U+8efd */ { 0, 0, 0, 0, 0 },
/* U+8efe */ { 0, 0, 0, 0, 0 },
/* U+8eff */ { 0, 0, 0, 0, 0 },
/* U+8f00 */ { 0, 0, 0, 0, 0 },
/* U+8f01 */ { 0, 0, 0, 0, 0 },
/* U+8f02 */ { 0, 0, 0, 0, 0 },
/* U+8f03 */ { 0, 0, 0, 0, 0 },
/* U+8f04 */ { 0, 0, 0, 0, 0 },
/* U+8f05 */ { 0, 0, 0, 0, 0 },
/* U+8f06 */ { 0, 0, 0, 0, 0 },
/* U+8f07 */ { 0, 0, 0, 0, 0 },
/* U+8f08 */ { 0, 0, 0, 0, 0 },
/* U+8f09 */ { 0, 0, 0, 0, 0 },
/* U+8f0a */ { 0, 0, 0, 0, 0 },
/* U+8f0b */ { 0, 0, 0, 0, 0 },
/* U+8f0c */ { 0, 0, 0, 0, 0 },
/* U+8f0d */ { 0, 0, 0, 0, 0 },
/* U+8f0e */ { 0, 0, 0, 0, 0 },
/* U+8f0f */ { 0, 0, 0, 0, 0 },
/* U+8f10 */ { 0, 0, 0, 0, 0 },
/* U+8f11 */ { 0, 0, 0, 0, 0 },
/* U+8f12 */ { 0, 0, 0, 0, 0 },
/* U+8f13 */ { 0, 0, 0, 0, 0 },
/* U+8f14 */ { 0, 0, 0, 0, 0 },
/* U+8f15 */ { 0, 0, 0, 0, 0 },
/* U+8f16 */ { 0, 0, 0, 0, 0 },
/* U+8f17 */ { 0, 0, 0, 0, 0 },
/* U+8f18 */ { 0, 0, 0, 0, 0 },
/* U+8f19 */ { 0, 0, 0, 0, 0 },
/* U+8f1a */ { 0, 0, 0, 0, 0 },
/* U+8f1b */ { 0, 0, 0, 0, 0 },
/* U+8f1c */ { 0, 0, 0, 0, 0 },
/* U+8f1d */ { 0, 0, 0, 0, 0 },
/* U+8f1e */ { 0, 0, 0, 0, 0 },
/* U+8f1f */ { 0, 0, 0, 0, 0 },
/* U+8f20 */ { 0, 0, 0, 0, 0 },
/* U+8f21 */ { 0, 0, 0, 0, 0 },
/* U+8f22 */ { 0, 0, 0, 0, 0 },
/* U+8f23 */ { 0, 0, 0, 0, 0 },
/* U+8f24 */ { 0, 0, 0, 0, 0 },
/* U+8f25 */ { 0, 0, 0, 0, 0 },
/* U+8f26 */ { 0, 0, 0, 0, 0 },
/* U+8f27 */ { 0, 0, 0, 0, 0 },
/* U+8f28 */ { 0, 0, 0, 0, 0 },
/* U+8f29 */ { 0, 0, 0, 0, 0 },
/* U+8f2a */ { 0, 0, 0, 0, 0 },
/* U+8f2b */ { 0, 0, 0, 0, 0 },
/* U+8f2c */ { 0, 0, 0, 0, 0 },
/* U+8f2d */ { 0, 0, 0, 0, 0 },
/* U+8f2e */ { 0, 0, 0, 0, 0 },
/* U+8f2f */ { 0, 0, 0, 0, 0 },
/* U+8f30 */ { 0, 0, 0, 0, 0 },
/* U+8f31 */ { 0, 0, 0, 0, 0 },
/* U+8f32 */ { 0, 0, 0, 0, 0 },
/* U+8f33 */ { 0, 0, 0, 0, 0 },
/* U+8f34 */ { 0, 0, 0, 0, 0 },
/* U+8f35 */ { 0, 0, 0, 0, 0 },
/* U+8f36 */ { 0, 0, 0, 0, 0 },
/* U+8f37 */ { 0, 0, 0, 0, 0 },
/* U+8f38 */ { 0, 0, 0, 0, 0 },
/* U+8f39 */ { 0, 0, 0, 0, 0 },
/* U+8f3a */ { 0, 0, 0, 0, 0 },
/* U+8f3b */ { 0, 0, 0, 0, 0 },
/* U+8f3c */ { 0, 0, 0, 0, 0 },
/* U+8f3d */ { 0, 0, 0, 0, 0 },
/* U+8f3e */ { 0, 0, 0, 0, 0 },
/* U+8f3f */ { 0, 0, 0, 0, 0 },
/* U+8f40 */ { 0, 0, 0, 0, 0 },
/* U+8f41 */ { 0, 0, 0, 0, 0 },
/* U+8f42 */ { 0, 0, 0, 0, 0 },
/* U+8f43 */ { 0, 0, 0, 0, 0 },
/* U+8f44 */ { 0, 0, 0, 0, 0 },
/* U+8f45 */ { 0, 0, 0, 0, 0 },
/* U+8f46 */ { 0, 0, 0, 0, 0 },
/* U+8f47 */ { 0, 0, 0, 0, 0 },
/* U+8f48 */ { 0, 0, 0, 0, 0 },
/* U+8f49 */ { 0, 0, 0, 0, 0 },
/* U+8f4a */ { 0, 0, 0, 0, 0 },
/* U+8f4b */ { 0, 0, 0, 0, 0 },
/* U+8f4c */ { 0, 0, 0, 0, 0 },
/* U+8f4d */ { 0, 0, 0, 0, 0 },
/* U+8f4e */ { 0, 0, 0, 0, 0 },
/* U+8f4f */ { 0, 0, 0, 0, 0 },
/* U+8f50 */ { 0, 0, 0, 0, 0 },
/* U+8f51 */ { 0, 0, 0, 0, 0 },
/* U+8f52 */ { 0, 0, 0, 0, 0 },
/* U+8f53 */ { 0, 0, 0, 0, 0 },
/* U+8f54 */ { 0, 0, 0, 0, 0 },
/* U+8f55 */ { 0, 0, 0, 0, 0 },
/* U+8f56 */ { 0, 0, 0, 0, 0 },
/* U+8f57 */ { 0, 0, 0, 0, 0 },
/* U+8f58 */ { 0, 0, 0, 0, 0 },
/* U+8f59 */ { 0, 0, 0, 0, 0 },
/* U+8f5a */ { 0, 0, 0, 0, 0 },
/* U+8f5b */ { 0, 0, 0, 0, 0 },
/* U+8f5c */ { 0, 0, 0, 0, 0 },
/* U+8f5d */ { 0, 0, 0, 0, 0 },
/* U+8f5e */ { 0, 0, 0, 0, 0 },
/* U+8f5f */ { 0, 0, 0, 0, 0 },
/* U+8f60 */ { 0, 0, 0, 0, 0 },
/* U+8f61 */ { 0, 0, 0, 0, 0 },
/* U+8f62 */ { 0, 0, 0, 0, 0 },
/* U+8f63 */ { 0, 0, 0, 0, 0 },
/* U+8f64 */ { 0, 0, 0, 0, 0 },
/* U+8f65 */ { 0, 0, 0, 0, 0 },
/* U+8f66 */ { 0, 0, 0, 0, 0 },
/* U+8f67 */ { 0, 0, 0, 0, 0 },
/* U+8f68 */ { 0, 0, 0, 0, 0 },
/* U+8f69 */ { 0, 0, 0, 0, 0 },
/* U+8f6a */ { 0, 0, 0, 0, 0 },
/* U+8f6b */ { 0, 0, 0, 0, 0 },
/* U+8f6c */ { 0, 0, 0, 0, 0 },
/* U+8f6d */ { 0, 0, 0, 0, 0 },
/* U+8f6e */ { 0, 0, 0, 0, 0 },
/* U+8f6f */ { 0, 0, 0, 0, 0 },
/* U+8f70 */ { 0, 0, 0, 0, 0 },
/* U+8f71 */ { 0, 0, 0, 0, 0 },
/* U+8f72 */ { 0, 0, 0, 0, 0 },
/* U+8f73 */ { 0, 0, 0, 0, 0 },
/* U+8f74 */ { 0, 0, 0, 0, 0 },
/* U+8f75 */ { 0, 0, 0, 0, 0 },
/* U+8f76 */ { 0, 0, 0, 0, 0 },
/* U+8f77 */ { 0, 0, 0, 0, 0 },
/* U+8f78 */ { 0, 0, 0, 0, 0 },
/* U+8f79 */ { 0, 0, 0, 0, 0 },
/* U+8f7a */ { 0, 0, 0, 0, 0 },
/* U+8f7b */ { 0, 0, 0, 0, 0 },
/* U+8f7c */ { 0, 0, 0, 0, 0 },
/* U+8f7d */ { 0, 0, 0, 0, 0 },
/* U+8f7e */ { 0, 0, 0, 0, 0 },
/* U+8f7f */ { 0, 0, 0, 0, 0 },
/* U+8f80 */ { 0, 0, 0, 0, 0 },
/* U+8f81 */ { 0, 0, 0, 0, 0 },
/* U+8f82 */ { 0, 0, 0, 0, 0 },
/* U+8f83 */ { 0, 0, 0, 0, 0 },
/* U+8f84 */ { 0, 0, 0, 0, 0 },
/* U+8f85 */ { 0, 0, 0, 0, 0 },
/* U+8f86 */ { 0, 0, 0, 0, 0 },
/* U+8f87 */ { 0, 0, 0, 0, 0 },
/* U+8f88 */ { 0, 0, 0, 0, 0 },
/* U+8f89 */ { 0, 0, 0, 0, 0 },
/* U+8f8a */ { 0, 0, 0, 0, 0 },
/* U+8f8b */ { 0, 0, 0, 0, 0 },
/* U+8f8c */ { 0, 0, 0, 0, 0 },
/* U+8f8d */ { 0, 0, 0, 0, 0 },
/* U+8f8e */ { 0, 0, 0, 0, 0 },
/* U+8f8f */ { 0, 0, 0, 0, 0 },
/* U+8f90 */ { 0, 0, 0, 0, 0 },
/* U+8f91 */ { 0, 0, 0, 0, 0 },
/* U+8f92 */ { 0, 0, 0, 0, 0 },
/* U+8f93 */ { 0, 0, 0, 0, 0 },
/* U+8f94 */ { 0, 0, 0, 0, 0 },
/* U+8f95 */ { 0, 0, 0, 0, 0 },
/* U+8f96 */ { 0, 0, 0, 0, 0 },
/* U+8f97 */ { 0, 0, 0, 0, 0 },
/* U+8f98 */ { 0, 0, 0, 0, 0 },
/* U+8f99 */ { 0, 0, 0, 0, 0 },
/* U+8f9a */ { 0, 0, 0, 0, 0 },
/* U+8f9b */ { 0, 0, 0, 0, 0 },
/* U+8f9c */ { 0, 0, 0, 0, 0 },
/* U+8f9d */ { 0, 0, 0, 0, 0 },
/* U+8f9e */ { 0, 0, 0, 0, 0 },
/* U+8f9f */ { 0, 0, 0, 0, 0 },
/* U+8fa0 */ { 0, 0, 0, 0, 0 },
/* U+8fa1 */ { 0, 0, 0, 0, 0 },
/* U+8fa2 */ { 0, 0, 0, 0, 0 },
/* U+8fa3 */ { 0, 0, 0, 0, 0 },
/* U+8fa4 */ { 0, 0, 0, 0, 0 },
/* U+8fa5 */ { 0, 0, 0, 0, 0 },
/* U+8fa6 */ { 0, 0, 0, 0, 0 },
/* U+8fa7 */ { 0, 0, 0, 0, 0 },
/* U+8fa8 */ { 0, 0, 0, 0, 0 },
/* U+8fa9 */ { 0, 0, 0, 0, 0 },
/* U+8faa */ { 0, 0, 0, 0, 0 },
/* U+8fab */ { 0, 0, 0, 0, 0 },
/* U+8fac */ { 0, 0, 0, 0, 0 },
/* U+8fad */ { 0, 0, 0, 0, 0 },
/* U+8fae */ { 0, 0, 0, 0, 0 },
/* U+8faf */ { 0, 0, 0, 0, 0 },
/* U+8fb0 */ { 0, 0, 0, 0, 0 },
/* U+8fb1 */ { 0, 0, 0, 0, 0 },
/* U+8fb2 */ { 0, 0, 0, 0, 0 },
/* U+8fb3 */ { 0, 0, 0, 0, 0 },
/* U+8fb4 */ { 0, 0, 0, 0, 0 },
/* U+8fb5 */ { 0, 0, 0, 0, 0 },
/* U+8fb6 */ { 0, 0, 0, 0, 0 },
/* U+8fb7 */ { 0, 0, 0, 0, 0 },
/* U+8fb8 */ { 0, 0, 0, 0, 0 },
/* U+8fb9 */ { 0, 0, 0, 0, 0 },
/* U+8fba */ { 0, 0, 0, 0, 0 },
/* U+8fbb */ { 0, 0, 0, 0, 0 },
/* U+8fbc */ { 0, 0, 0, 0, 0 },
/* U+8fbd */ { 0, 0, 0, 0, 0 },
/* U+8fbe */ { 0, 0, 0, 0, 0 },
/* U+8fbf */ { 0, 0, 0, 0, 0 },
/* U+8fc0 */ { 0, 0, 0, 0, 0 },
/* U+8fc1 */ { 0, 0, 0, 0, 0 },
/* U+8fc2 */ { 0, 0, 0, 0, 0 },
/* U+8fc3 */ { 0, 0, 0, 0, 0 },
/* U+8fc4 */ { 0, 0, 0, 0, 0 },
/* U+8fc5 */ { 0, 0, 0, 0, 0 },
/* U+8fc6 */ { 0, 0, 0, 0, 0 },
/* U+8fc7 */ { 0, 0, 0, 0, 0 },
/* U+8fc8 */ { 0, 0, 0, 0, 0 },
/* U+8fc9 */ { 0, 0, 0, 0, 0 },
/* U+8fca */ { 0, 0, 0, 0, 0 },
/* U+8fcb */ { 0, 0, 0, 0, 0 },
/* U+8fcc */ { 0, 0, 0, 0, 0 },
/* U+8fcd */ { 0, 0, 0, 0, 0 },
/* U+8fce */ { 0, 0, 0, 0, 0 },
/* U+8fcf */ { 0, 0, 0, 0, 0 },
/* U+8fd0 */ { 0, 0, 0, 0, 0 },
/* U+8fd1 */ { 0, 0, 0, 0, 0 },
/* U+8fd2 */ { 0, 0, 0, 0, 0 },
/* U+8fd3 */ { 0, 0, 0, 0, 0 },
/* U+8fd4 */ { 0, 0, 0, 0, 0 },
/* U+8fd5 */ { 0, 0, 0, 0, 0 },
/* U+8fd6 */ { 0, 0, 0, 0, 0 },
/* U+8fd7 */ { 0, 0, 0, 0, 0 },
/* U+8fd8 */ { 0, 0, 0, 0, 0 },
/* U+8fd9 */ { 0, 0, 0, 0, 0 },
/* U+8fda */ { 0, 0, 0, 0, 0 },
/* U+8fdb */ { 0, 0, 0, 0, 0 },
/* U+8fdc */ { 0, 0, 0, 0, 0 },
/* U+8fdd */ { 0, 0, 0, 0, 0 },
/* U+8fde */ { 0, 0, 0, 0, 0 },
/* U+8fdf */ { 0, 0, 0, 0, 0 },
/* U+8fe0 */ { 0, 0, 0, 0, 0 },
/* U+8fe1 */ { 0, 0, 0, 0, 0 },
/* U+8fe2 */ { 0, 0, 0, 0, 0 },
/* U+8fe3 */ { 0, 0, 0, 0, 0 },
/* U+8fe4 */ { 0, 0, 0, 0, 0 },
/* U+8fe5 */ { 0, 0, 0, 0, 0 },
/* U+8fe6 */ { 0, 0, 0, 0, 0 },
/* U+8fe7 */ { 0, 0, 0, 0, 0 },
/* U+8fe8 */ { 0, 0, 0, 0, 0 },
/* U+8fe9 */ { 0, 0, 0, 0, 0 },
/* U+8fea */ { 0, 0, 0, 0, 0 },
/* U+8feb */ { 0, 0, 0, 0, 0 },
/* U+8fec */ { 0, 0, 0, 0, 0 },
/* U+8fed */ { 0, 0, 0, 0, 0 },
/* U+8fee */ { 0, 0, 0, 0, 0 },
/* U+8fef */ { 0, 0, 0, 0, 0 },
/* U+8ff0 */ { 0, 0, 0, 0, 0 },
/* U+8ff1 */ { 0, 0, 0, 0, 0 },
/* U+8ff2 */ { 0, 0, 0, 0, 0 },
/* U+8ff3 */ { 0, 0, 0, 0, 0 },
/* U+8ff4 */ { 0, 0, 0, 0, 0 },
/* U+8ff5 */ { 0, 0, 0, 0, 0 },
/* U+8ff6 */ { 0, 0, 0, 0, 0 },
/* U+8ff7 */ { 0, 0, 0, 0, 0 },
/* U+8ff8 */ { 0, 0, 0, 0, 0 },
/* U+8ff9 */ { 0, 0, 0, 0, 0 },
/* U+8ffa */ { 0, 0, 0, 0, 0 },
/* U+8ffb */ { 0, 0, 0, 0, 0 },
/* U+8ffc */ { 0, 0, 0, 0, 0 },
/* U+8ffd */ { 0, 0, 0, 0, 0 },
/* U+8ffe */ { 0, 0, 0, 0, 0 },
/* U+8fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_9[4096] = {
    
/* U+9000 */ { 0, 0, 0, 0, 0 },
/* U+9001 */ { 0, 0, 0, 0, 0 },
/* U+9002 */ { 0, 0, 0, 0, 0 },
/* U+9003 */ { 0, 0, 0, 0, 0 },
/* U+9004 */ { 0, 0, 0, 0, 0 },
/* U+9005 */ { 0, 0, 0, 0, 0 },
/* U+9006 */ { 0, 0, 0, 0, 0 },
/* U+9007 */ { 0, 0, 0, 0, 0 },
/* U+9008 */ { 0, 0, 0, 0, 0 },
/* U+9009 */ { 0, 0, 0, 0, 0 },
/* U+900a */ { 0, 0, 0, 0, 0 },
/* U+900b */ { 0, 0, 0, 0, 0 },
/* U+900c */ { 0, 0, 0, 0, 0 },
/* U+900d */ { 0, 0, 0, 0, 0 },
/* U+900e */ { 0, 0, 0, 0, 0 },
/* U+900f */ { 0, 0, 0, 0, 0 },
/* U+9010 */ { 0, 0, 0, 0, 0 },
/* U+9011 */ { 0, 0, 0, 0, 0 },
/* U+9012 */ { 0, 0, 0, 0, 0 },
/* U+9013 */ { 0, 0, 0, 0, 0 },
/* U+9014 */ { 0, 0, 0, 0, 0 },
/* U+9015 */ { 0, 0, 0, 0, 0 },
/* U+9016 */ { 0, 0, 0, 0, 0 },
/* U+9017 */ { 0, 0, 0, 0, 0 },
/* U+9018 */ { 0, 0, 0, 0, 0 },
/* U+9019 */ { 0, 0, 0, 0, 0 },
/* U+901a */ { 0, 0, 0, 0, 0 },
/* U+901b */ { 0, 0, 0, 0, 0 },
/* U+901c */ { 0, 0, 0, 0, 0 },
/* U+901d */ { 0, 0, 0, 0, 0 },
/* U+901e */ { 0, 0, 0, 0, 0 },
/* U+901f */ { 0, 0, 0, 0, 0 },
/* U+9020 */ { 0, 0, 0, 0, 0 },
/* U+9021 */ { 0, 0, 0, 0, 0 },
/* U+9022 */ { 0, 0, 0, 0, 0 },
/* U+9023 */ { 0, 0, 0, 0, 0 },
/* U+9024 */ { 0, 0, 0, 0, 0 },
/* U+9025 */ { 0, 0, 0, 0, 0 },
/* U+9026 */ { 0, 0, 0, 0, 0 },
/* U+9027 */ { 0, 0, 0, 0, 0 },
/* U+9028 */ { 0, 0, 0, 0, 0 },
/* U+9029 */ { 0, 0, 0, 0, 0 },
/* U+902a */ { 0, 0, 0, 0, 0 },
/* U+902b */ { 0, 0, 0, 0, 0 },
/* U+902c */ { 0, 0, 0, 0, 0 },
/* U+902d */ { 0, 0, 0, 0, 0 },
/* U+902e */ { 0, 0, 0, 0, 0 },
/* U+902f */ { 0, 0, 0, 0, 0 },
/* U+9030 */ { 0, 0, 0, 0, 0 },
/* U+9031 */ { 0, 0, 0, 0, 0 },
/* U+9032 */ { 0, 0, 0, 0, 0 },
/* U+9033 */ { 0, 0, 0, 0, 0 },
/* U+9034 */ { 0, 0, 0, 0, 0 },
/* U+9035 */ { 0, 0, 0, 0, 0 },
/* U+9036 */ { 0, 0, 0, 0, 0 },
/* U+9037 */ { 0, 0, 0, 0, 0 },
/* U+9038 */ { 0, 0, 0, 0, 0 },
/* U+9039 */ { 0, 0, 0, 0, 0 },
/* U+903a */ { 0, 0, 0, 0, 0 },
/* U+903b */ { 0, 0, 0, 0, 0 },
/* U+903c */ { 0, 0, 0, 0, 0 },
/* U+903d */ { 0, 0, 0, 0, 0 },
/* U+903e */ { 0, 0, 0, 0, 0 },
/* U+903f */ { 0, 0, 0, 0, 0 },
/* U+9040 */ { 0, 0, 0, 0, 0 },
/* U+9041 */ { 0, 0, 0, 0, 0 },
/* U+9042 */ { 0, 0, 0, 0, 0 },
/* U+9043 */ { 0, 0, 0, 0, 0 },
/* U+9044 */ { 0, 0, 0, 0, 0 },
/* U+9045 */ { 0, 0, 0, 0, 0 },
/* U+9046 */ { 0, 0, 0, 0, 0 },
/* U+9047 */ { 0, 0, 0, 0, 0 },
/* U+9048 */ { 0, 0, 0, 0, 0 },
/* U+9049 */ { 0, 0, 0, 0, 0 },
/* U+904a */ { 0, 0, 0, 0, 0 },
/* U+904b */ { 0, 0, 0, 0, 0 },
/* U+904c */ { 0, 0, 0, 0, 0 },
/* U+904d */ { 0, 0, 0, 0, 0 },
/* U+904e */ { 0, 0, 0, 0, 0 },
/* U+904f */ { 0, 0, 0, 0, 0 },
/* U+9050 */ { 0, 0, 0, 0, 0 },
/* U+9051 */ { 0, 0, 0, 0, 0 },
/* U+9052 */ { 0, 0, 0, 0, 0 },
/* U+9053 */ { 0, 0, 0, 0, 0 },
/* U+9054 */ { 0, 0, 0, 0, 0 },
/* U+9055 */ { 0, 0, 0, 0, 0 },
/* U+9056 */ { 0, 0, 0, 0, 0 },
/* U+9057 */ { 0, 0, 0, 0, 0 },
/* U+9058 */ { 0, 0, 0, 0, 0 },
/* U+9059 */ { 0, 0, 0, 0, 0 },
/* U+905a */ { 0, 0, 0, 0, 0 },
/* U+905b */ { 0, 0, 0, 0, 0 },
/* U+905c */ { 0, 0, 0, 0, 0 },
/* U+905d */ { 0, 0, 0, 0, 0 },
/* U+905e */ { 0, 0, 0, 0, 0 },
/* U+905f */ { 0, 0, 0, 0, 0 },
/* U+9060 */ { 0, 0, 0, 0, 0 },
/* U+9061 */ { 0, 0, 0, 0, 0 },
/* U+9062 */ { 0, 0, 0, 0, 0 },
/* U+9063 */ { 0, 0, 0, 0, 0 },
/* U+9064 */ { 0, 0, 0, 0, 0 },
/* U+9065 */ { 0, 0, 0, 0, 0 },
/* U+9066 */ { 0, 0, 0, 0, 0 },
/* U+9067 */ { 0, 0, 0, 0, 0 },
/* U+9068 */ { 0, 0, 0, 0, 0 },
/* U+9069 */ { 0, 0, 0, 0, 0 },
/* U+906a */ { 0, 0, 0, 0, 0 },
/* U+906b */ { 0, 0, 0, 0, 0 },
/* U+906c */ { 0, 0, 0, 0, 0 },
/* U+906d */ { 0, 0, 0, 0, 0 },
/* U+906e */ { 0, 0, 0, 0, 0 },
/* U+906f */ { 0, 0, 0, 0, 0 },
/* U+9070 */ { 0, 0, 0, 0, 0 },
/* U+9071 */ { 0, 0, 0, 0, 0 },
/* U+9072 */ { 0, 0, 0, 0, 0 },
/* U+9073 */ { 0, 0, 0, 0, 0 },
/* U+9074 */ { 0, 0, 0, 0, 0 },
/* U+9075 */ { 0, 0, 0, 0, 0 },
/* U+9076 */ { 0, 0, 0, 0, 0 },
/* U+9077 */ { 0, 0, 0, 0, 0 },
/* U+9078 */ { 0, 0, 0, 0, 0 },
/* U+9079 */ { 0, 0, 0, 0, 0 },
/* U+907a */ { 0, 0, 0, 0, 0 },
/* U+907b */ { 0, 0, 0, 0, 0 },
/* U+907c */ { 0, 0, 0, 0, 0 },
/* U+907d */ { 0, 0, 0, 0, 0 },
/* U+907e */ { 0, 0, 0, 0, 0 },
/* U+907f */ { 0, 0, 0, 0, 0 },
/* U+9080 */ { 0, 0, 0, 0, 0 },
/* U+9081 */ { 0, 0, 0, 0, 0 },
/* U+9082 */ { 0, 0, 0, 0, 0 },
/* U+9083 */ { 0, 0, 0, 0, 0 },
/* U+9084 */ { 0, 0, 0, 0, 0 },
/* U+9085 */ { 0, 0, 0, 0, 0 },
/* U+9086 */ { 0, 0, 0, 0, 0 },
/* U+9087 */ { 0, 0, 0, 0, 0 },
/* U+9088 */ { 0, 0, 0, 0, 0 },
/* U+9089 */ { 0, 0, 0, 0, 0 },
/* U+908a */ { 0, 0, 0, 0, 0 },
/* U+908b */ { 0, 0, 0, 0, 0 },
/* U+908c */ { 0, 0, 0, 0, 0 },
/* U+908d */ { 0, 0, 0, 0, 0 },
/* U+908e */ { 0, 0, 0, 0, 0 },
/* U+908f */ { 0, 0, 0, 0, 0 },
/* U+9090 */ { 0, 0, 0, 0, 0 },
/* U+9091 */ { 0, 0, 0, 0, 0 },
/* U+9092 */ { 0, 0, 0, 0, 0 },
/* U+9093 */ { 0, 0, 0, 0, 0 },
/* U+9094 */ { 0, 0, 0, 0, 0 },
/* U+9095 */ { 0, 0, 0, 0, 0 },
/* U+9096 */ { 0, 0, 0, 0, 0 },
/* U+9097 */ { 0, 0, 0, 0, 0 },
/* U+9098 */ { 0, 0, 0, 0, 0 },
/* U+9099 */ { 0, 0, 0, 0, 0 },
/* U+909a */ { 0, 0, 0, 0, 0 },
/* U+909b */ { 0, 0, 0, 0, 0 },
/* U+909c */ { 0, 0, 0, 0, 0 },
/* U+909d */ { 0, 0, 0, 0, 0 },
/* U+909e */ { 0, 0, 0, 0, 0 },
/* U+909f */ { 0, 0, 0, 0, 0 },
/* U+90a0 */ { 0, 0, 0, 0, 0 },
/* U+90a1 */ { 0, 0, 0, 0, 0 },
/* U+90a2 */ { 0, 0, 0, 0, 0 },
/* U+90a3 */ { 0, 0, 0, 0, 0 },
/* U+90a4 */ { 0, 0, 0, 0, 0 },
/* U+90a5 */ { 0, 0, 0, 0, 0 },
/* U+90a6 */ { 0, 0, 0, 0, 0 },
/* U+90a7 */ { 0, 0, 0, 0, 0 },
/* U+90a8 */ { 0, 0, 0, 0, 0 },
/* U+90a9 */ { 0, 0, 0, 0, 0 },
/* U+90aa */ { 0, 0, 0, 0, 0 },
/* U+90ab */ { 0, 0, 0, 0, 0 },
/* U+90ac */ { 0, 0, 0, 0, 0 },
/* U+90ad */ { 0, 0, 0, 0, 0 },
/* U+90ae */ { 0, 0, 0, 0, 0 },
/* U+90af */ { 0, 0, 0, 0, 0 },
/* U+90b0 */ { 0, 0, 0, 0, 0 },
/* U+90b1 */ { 0, 0, 0, 0, 0 },
/* U+90b2 */ { 0, 0, 0, 0, 0 },
/* U+90b3 */ { 0, 0, 0, 0, 0 },
/* U+90b4 */ { 0, 0, 0, 0, 0 },
/* U+90b5 */ { 0, 0, 0, 0, 0 },
/* U+90b6 */ { 0, 0, 0, 0, 0 },
/* U+90b7 */ { 0, 0, 0, 0, 0 },
/* U+90b8 */ { 0, 0, 0, 0, 0 },
/* U+90b9 */ { 0, 0, 0, 0, 0 },
/* U+90ba */ { 0, 0, 0, 0, 0 },
/* U+90bb */ { 0, 0, 0, 0, 0 },
/* U+90bc */ { 0, 0, 0, 0, 0 },
/* U+90bd */ { 0, 0, 0, 0, 0 },
/* U+90be */ { 0, 0, 0, 0, 0 },
/* U+90bf */ { 0, 0, 0, 0, 0 },
/* U+90c0 */ { 0, 0, 0, 0, 0 },
/* U+90c1 */ { 0, 0, 0, 0, 0 },
/* U+90c2 */ { 0, 0, 0, 0, 0 },
/* U+90c3 */ { 0, 0, 0, 0, 0 },
/* U+90c4 */ { 0, 0, 0, 0, 0 },
/* U+90c5 */ { 0, 0, 0, 0, 0 },
/* U+90c6 */ { 0, 0, 0, 0, 0 },
/* U+90c7 */ { 0, 0, 0, 0, 0 },
/* U+90c8 */ { 0, 0, 0, 0, 0 },
/* U+90c9 */ { 0, 0, 0, 0, 0 },
/* U+90ca */ { 0, 0, 0, 0, 0 },
/* U+90cb */ { 0, 0, 0, 0, 0 },
/* U+90cc */ { 0, 0, 0, 0, 0 },
/* U+90cd */ { 0, 0, 0, 0, 0 },
/* U+90ce */ { 0, 0, 0, 0, 0 },
/* U+90cf */ { 0, 0, 0, 0, 0 },
/* U+90d0 */ { 0, 0, 0, 0, 0 },
/* U+90d1 */ { 0, 0, 0, 0, 0 },
/* U+90d2 */ { 0, 0, 0, 0, 0 },
/* U+90d3 */ { 0, 0, 0, 0, 0 },
/* U+90d4 */ { 0, 0, 0, 0, 0 },
/* U+90d5 */ { 0, 0, 0, 0, 0 },
/* U+90d6 */ { 0, 0, 0, 0, 0 },
/* U+90d7 */ { 0, 0, 0, 0, 0 },
/* U+90d8 */ { 0, 0, 0, 0, 0 },
/* U+90d9 */ { 0, 0, 0, 0, 0 },
/* U+90da */ { 0, 0, 0, 0, 0 },
/* U+90db */ { 0, 0, 0, 0, 0 },
/* U+90dc */ { 0, 0, 0, 0, 0 },
/* U+90dd */ { 0, 0, 0, 0, 0 },
/* U+90de */ { 0, 0, 0, 0, 0 },
/* U+90df */ { 0, 0, 0, 0, 0 },
/* U+90e0 */ { 0, 0, 0, 0, 0 },
/* U+90e1 */ { 0, 0, 0, 0, 0 },
/* U+90e2 */ { 0, 0, 0, 0, 0 },
/* U+90e3 */ { 0, 0, 0, 0, 0 },
/* U+90e4 */ { 0, 0, 0, 0, 0 },
/* U+90e5 */ { 0, 0, 0, 0, 0 },
/* U+90e6 */ { 0, 0, 0, 0, 0 },
/* U+90e7 */ { 0, 0, 0, 0, 0 },
/* U+90e8 */ { 0, 0, 0, 0, 0 },
/* U+90e9 */ { 0, 0, 0, 0, 0 },
/* U+90ea */ { 0, 0, 0, 0, 0 },
/* U+90eb */ { 0, 0, 0, 0, 0 },
/* U+90ec */ { 0, 0, 0, 0, 0 },
/* U+90ed */ { 0, 0, 0, 0, 0 },
/* U+90ee */ { 0, 0, 0, 0, 0 },
/* U+90ef */ { 0, 0, 0, 0, 0 },
/* U+90f0 */ { 0, 0, 0, 0, 0 },
/* U+90f1 */ { 0, 0, 0, 0, 0 },
/* U+90f2 */ { 0, 0, 0, 0, 0 },
/* U+90f3 */ { 0, 0, 0, 0, 0 },
/* U+90f4 */ { 0, 0, 0, 0, 0 },
/* U+90f5 */ { 0, 0, 0, 0, 0 },
/* U+90f6 */ { 0, 0, 0, 0, 0 },
/* U+90f7 */ { 0, 0, 0, 0, 0 },
/* U+90f8 */ { 0, 0, 0, 0, 0 },
/* U+90f9 */ { 0, 0, 0, 0, 0 },
/* U+90fa */ { 0, 0, 0, 0, 0 },
/* U+90fb */ { 0, 0, 0, 0, 0 },
/* U+90fc */ { 0, 0, 0, 0, 0 },
/* U+90fd */ { 0, 0, 0, 0, 0 },
/* U+90fe */ { 0, 0, 0, 0, 0 },
/* U+90ff */ { 0, 0, 0, 0, 0 },
/* U+9100 */ { 0, 0, 0, 0, 0 },
/* U+9101 */ { 0, 0, 0, 0, 0 },
/* U+9102 */ { 0, 0, 0, 0, 0 },
/* U+9103 */ { 0, 0, 0, 0, 0 },
/* U+9104 */ { 0, 0, 0, 0, 0 },
/* U+9105 */ { 0, 0, 0, 0, 0 },
/* U+9106 */ { 0, 0, 0, 0, 0 },
/* U+9107 */ { 0, 0, 0, 0, 0 },
/* U+9108 */ { 0, 0, 0, 0, 0 },
/* U+9109 */ { 0, 0, 0, 0, 0 },
/* U+910a */ { 0, 0, 0, 0, 0 },
/* U+910b */ { 0, 0, 0, 0, 0 },
/* U+910c */ { 0, 0, 0, 0, 0 },
/* U+910d */ { 0, 0, 0, 0, 0 },
/* U+910e */ { 0, 0, 0, 0, 0 },
/* U+910f */ { 0, 0, 0, 0, 0 },
/* U+9110 */ { 0, 0, 0, 0, 0 },
/* U+9111 */ { 0, 0, 0, 0, 0 },
/* U+9112 */ { 0, 0, 0, 0, 0 },
/* U+9113 */ { 0, 0, 0, 0, 0 },
/* U+9114 */ { 0, 0, 0, 0, 0 },
/* U+9115 */ { 0, 0, 0, 0, 0 },
/* U+9116 */ { 0, 0, 0, 0, 0 },
/* U+9117 */ { 0, 0, 0, 0, 0 },
/* U+9118 */ { 0, 0, 0, 0, 0 },
/* U+9119 */ { 0, 0, 0, 0, 0 },
/* U+911a */ { 0, 0, 0, 0, 0 },
/* U+911b */ { 0, 0, 0, 0, 0 },
/* U+911c */ { 0, 0, 0, 0, 0 },
/* U+911d */ { 0, 0, 0, 0, 0 },
/* U+911e */ { 0, 0, 0, 0, 0 },
/* U+911f */ { 0, 0, 0, 0, 0 },
/* U+9120 */ { 0, 0, 0, 0, 0 },
/* U+9121 */ { 0, 0, 0, 0, 0 },
/* U+9122 */ { 0, 0, 0, 0, 0 },
/* U+9123 */ { 0, 0, 0, 0, 0 },
/* U+9124 */ { 0, 0, 0, 0, 0 },
/* U+9125 */ { 0, 0, 0, 0, 0 },
/* U+9126 */ { 0, 0, 0, 0, 0 },
/* U+9127 */ { 0, 0, 0, 0, 0 },
/* U+9128 */ { 0, 0, 0, 0, 0 },
/* U+9129 */ { 0, 0, 0, 0, 0 },
/* U+912a */ { 0, 0, 0, 0, 0 },
/* U+912b */ { 0, 0, 0, 0, 0 },
/* U+912c */ { 0, 0, 0, 0, 0 },
/* U+912d */ { 0, 0, 0, 0, 0 },
/* U+912e */ { 0, 0, 0, 0, 0 },
/* U+912f */ { 0, 0, 0, 0, 0 },
/* U+9130 */ { 0, 0, 0, 0, 0 },
/* U+9131 */ { 0, 0, 0, 0, 0 },
/* U+9132 */ { 0, 0, 0, 0, 0 },
/* U+9133 */ { 0, 0, 0, 0, 0 },
/* U+9134 */ { 0, 0, 0, 0, 0 },
/* U+9135 */ { 0, 0, 0, 0, 0 },
/* U+9136 */ { 0, 0, 0, 0, 0 },
/* U+9137 */ { 0, 0, 0, 0, 0 },
/* U+9138 */ { 0, 0, 0, 0, 0 },
/* U+9139 */ { 0, 0, 0, 0, 0 },
/* U+913a */ { 0, 0, 0, 0, 0 },
/* U+913b */ { 0, 0, 0, 0, 0 },
/* U+913c */ { 0, 0, 0, 0, 0 },
/* U+913d */ { 0, 0, 0, 0, 0 },
/* U+913e */ { 0, 0, 0, 0, 0 },
/* U+913f */ { 0, 0, 0, 0, 0 },
/* U+9140 */ { 0, 0, 0, 0, 0 },
/* U+9141 */ { 0, 0, 0, 0, 0 },
/* U+9142 */ { 0, 0, 0, 0, 0 },
/* U+9143 */ { 0, 0, 0, 0, 0 },
/* U+9144 */ { 0, 0, 0, 0, 0 },
/* U+9145 */ { 0, 0, 0, 0, 0 },
/* U+9146 */ { 0, 0, 0, 0, 0 },
/* U+9147 */ { 0, 0, 0, 0, 0 },
/* U+9148 */ { 0, 0, 0, 0, 0 },
/* U+9149 */ { 0, 0, 0, 0, 0 },
/* U+914a */ { 0, 0, 0, 0, 0 },
/* U+914b */ { 0, 0, 0, 0, 0 },
/* U+914c */ { 0, 0, 0, 0, 0 },
/* U+914d */ { 0, 0, 0, 0, 0 },
/* U+914e */ { 0, 0, 0, 0, 0 },
/* U+914f */ { 0, 0, 0, 0, 0 },
/* U+9150 */ { 0, 0, 0, 0, 0 },
/* U+9151 */ { 0, 0, 0, 0, 0 },
/* U+9152 */ { 0, 0, 0, 0, 0 },
/* U+9153 */ { 0, 0, 0, 0, 0 },
/* U+9154 */ { 0, 0, 0, 0, 0 },
/* U+9155 */ { 0, 0, 0, 0, 0 },
/* U+9156 */ { 0, 0, 0, 0, 0 },
/* U+9157 */ { 0, 0, 0, 0, 0 },
/* U+9158 */ { 0, 0, 0, 0, 0 },
/* U+9159 */ { 0, 0, 0, 0, 0 },
/* U+915a */ { 0, 0, 0, 0, 0 },
/* U+915b */ { 0, 0, 0, 0, 0 },
/* U+915c */ { 0, 0, 0, 0, 0 },
/* U+915d */ { 0, 0, 0, 0, 0 },
/* U+915e */ { 0, 0, 0, 0, 0 },
/* U+915f */ { 0, 0, 0, 0, 0 },
/* U+9160 */ { 0, 0, 0, 0, 0 },
/* U+9161 */ { 0, 0, 0, 0, 0 },
/* U+9162 */ { 0, 0, 0, 0, 0 },
/* U+9163 */ { 0, 0, 0, 0, 0 },
/* U+9164 */ { 0, 0, 0, 0, 0 },
/* U+9165 */ { 0, 0, 0, 0, 0 },
/* U+9166 */ { 0, 0, 0, 0, 0 },
/* U+9167 */ { 0, 0, 0, 0, 0 },
/* U+9168 */ { 0, 0, 0, 0, 0 },
/* U+9169 */ { 0, 0, 0, 0, 0 },
/* U+916a */ { 0, 0, 0, 0, 0 },
/* U+916b */ { 0, 0, 0, 0, 0 },
/* U+916c */ { 0, 0, 0, 0, 0 },
/* U+916d */ { 0, 0, 0, 0, 0 },
/* U+916e */ { 0, 0, 0, 0, 0 },
/* U+916f */ { 0, 0, 0, 0, 0 },
/* U+9170 */ { 0, 0, 0, 0, 0 },
/* U+9171 */ { 0, 0, 0, 0, 0 },
/* U+9172 */ { 0, 0, 0, 0, 0 },
/* U+9173 */ { 0, 0, 0, 0, 0 },
/* U+9174 */ { 0, 0, 0, 0, 0 },
/* U+9175 */ { 0, 0, 0, 0, 0 },
/* U+9176 */ { 0, 0, 0, 0, 0 },
/* U+9177 */ { 0, 0, 0, 0, 0 },
/* U+9178 */ { 0, 0, 0, 0, 0 },
/* U+9179 */ { 0, 0, 0, 0, 0 },
/* U+917a */ { 0, 0, 0, 0, 0 },
/* U+917b */ { 0, 0, 0, 0, 0 },
/* U+917c */ { 0, 0, 0, 0, 0 },
/* U+917d */ { 0, 0, 0, 0, 0 },
/* U+917e */ { 0, 0, 0, 0, 0 },
/* U+917f */ { 0, 0, 0, 0, 0 },
/* U+9180 */ { 0, 0, 0, 0, 0 },
/* U+9181 */ { 0, 0, 0, 0, 0 },
/* U+9182 */ { 0, 0, 0, 0, 0 },
/* U+9183 */ { 0, 0, 0, 0, 0 },
/* U+9184 */ { 0, 0, 0, 0, 0 },
/* U+9185 */ { 0, 0, 0, 0, 0 },
/* U+9186 */ { 0, 0, 0, 0, 0 },
/* U+9187 */ { 0, 0, 0, 0, 0 },
/* U+9188 */ { 0, 0, 0, 0, 0 },
/* U+9189 */ { 0, 0, 0, 0, 0 },
/* U+918a */ { 0, 0, 0, 0, 0 },
/* U+918b */ { 0, 0, 0, 0, 0 },
/* U+918c */ { 0, 0, 0, 0, 0 },
/* U+918d */ { 0, 0, 0, 0, 0 },
/* U+918e */ { 0, 0, 0, 0, 0 },
/* U+918f */ { 0, 0, 0, 0, 0 },
/* U+9190 */ { 0, 0, 0, 0, 0 },
/* U+9191 */ { 0, 0, 0, 0, 0 },
/* U+9192 */ { 0, 0, 0, 0, 0 },
/* U+9193 */ { 0, 0, 0, 0, 0 },
/* U+9194 */ { 0, 0, 0, 0, 0 },
/* U+9195 */ { 0, 0, 0, 0, 0 },
/* U+9196 */ { 0, 0, 0, 0, 0 },
/* U+9197 */ { 0, 0, 0, 0, 0 },
/* U+9198 */ { 0, 0, 0, 0, 0 },
/* U+9199 */ { 0, 0, 0, 0, 0 },
/* U+919a */ { 0, 0, 0, 0, 0 },
/* U+919b */ { 0, 0, 0, 0, 0 },
/* U+919c */ { 0, 0, 0, 0, 0 },
/* U+919d */ { 0, 0, 0, 0, 0 },
/* U+919e */ { 0, 0, 0, 0, 0 },
/* U+919f */ { 0, 0, 0, 0, 0 },
/* U+91a0 */ { 0, 0, 0, 0, 0 },
/* U+91a1 */ { 0, 0, 0, 0, 0 },
/* U+91a2 */ { 0, 0, 0, 0, 0 },
/* U+91a3 */ { 0, 0, 0, 0, 0 },
/* U+91a4 */ { 0, 0, 0, 0, 0 },
/* U+91a5 */ { 0, 0, 0, 0, 0 },
/* U+91a6 */ { 0, 0, 0, 0, 0 },
/* U+91a7 */ { 0, 0, 0, 0, 0 },
/* U+91a8 */ { 0, 0, 0, 0, 0 },
/* U+91a9 */ { 0, 0, 0, 0, 0 },
/* U+91aa */ { 0, 0, 0, 0, 0 },
/* U+91ab */ { 0, 0, 0, 0, 0 },
/* U+91ac */ { 0, 0, 0, 0, 0 },
/* U+91ad */ { 0, 0, 0, 0, 0 },
/* U+91ae */ { 0, 0, 0, 0, 0 },
/* U+91af */ { 0, 0, 0, 0, 0 },
/* U+91b0 */ { 0, 0, 0, 0, 0 },
/* U+91b1 */ { 0, 0, 0, 0, 0 },
/* U+91b2 */ { 0, 0, 0, 0, 0 },
/* U+91b3 */ { 0, 0, 0, 0, 0 },
/* U+91b4 */ { 0, 0, 0, 0, 0 },
/* U+91b5 */ { 0, 0, 0, 0, 0 },
/* U+91b6 */ { 0, 0, 0, 0, 0 },
/* U+91b7 */ { 0, 0, 0, 0, 0 },
/* U+91b8 */ { 0, 0, 0, 0, 0 },
/* U+91b9 */ { 0, 0, 0, 0, 0 },
/* U+91ba */ { 0, 0, 0, 0, 0 },
/* U+91bb */ { 0, 0, 0, 0, 0 },
/* U+91bc */ { 0, 0, 0, 0, 0 },
/* U+91bd */ { 0, 0, 0, 0, 0 },
/* U+91be */ { 0, 0, 0, 0, 0 },
/* U+91bf */ { 0, 0, 0, 0, 0 },
/* U+91c0 */ { 0, 0, 0, 0, 0 },
/* U+91c1 */ { 0, 0, 0, 0, 0 },
/* U+91c2 */ { 0, 0, 0, 0, 0 },
/* U+91c3 */ { 0, 0, 0, 0, 0 },
/* U+91c4 */ { 0, 0, 0, 0, 0 },
/* U+91c5 */ { 0, 0, 0, 0, 0 },
/* U+91c6 */ { 0, 0, 0, 0, 0 },
/* U+91c7 */ { 0, 0, 0, 0, 0 },
/* U+91c8 */ { 0, 0, 0, 0, 0 },
/* U+91c9 */ { 0, 0, 0, 0, 0 },
/* U+91ca */ { 0, 0, 0, 0, 0 },
/* U+91cb */ { 0, 0, 0, 0, 0 },
/* U+91cc */ { 0, 0, 0, 0, 0 },
/* U+91cd */ { 0, 0, 0, 0, 0 },
/* U+91ce */ { 0, 0, 0, 0, 0 },
/* U+91cf */ { 0, 0, 0, 0, 0 },
/* U+91d0 */ { 0, 0, 0, 0, 0 },
/* U+91d1 */ { 0, 0, 0, 0, 0 },
/* U+91d2 */ { 0, 0, 0, 0, 0 },
/* U+91d3 */ { 0, 0, 0, 0, 0 },
/* U+91d4 */ { 0, 0, 0, 0, 0 },
/* U+91d5 */ { 0, 0, 0, 0, 0 },
/* U+91d6 */ { 0, 0, 0, 0, 0 },
/* U+91d7 */ { 0, 0, 0, 0, 0 },
/* U+91d8 */ { 0, 0, 0, 0, 0 },
/* U+91d9 */ { 0, 0, 0, 0, 0 },
/* U+91da */ { 0, 0, 0, 0, 0 },
/* U+91db */ { 0, 0, 0, 0, 0 },
/* U+91dc */ { 0, 0, 0, 0, 0 },
/* U+91dd */ { 0, 0, 0, 0, 0 },
/* U+91de */ { 0, 0, 0, 0, 0 },
/* U+91df */ { 0, 0, 0, 0, 0 },
/* U+91e0 */ { 0, 0, 0, 0, 0 },
/* U+91e1 */ { 0, 0, 0, 0, 0 },
/* U+91e2 */ { 0, 0, 0, 0, 0 },
/* U+91e3 */ { 0, 0, 0, 0, 0 },
/* U+91e4 */ { 0, 0, 0, 0, 0 },
/* U+91e5 */ { 0, 0, 0, 0, 0 },
/* U+91e6 */ { 0, 0, 0, 0, 0 },
/* U+91e7 */ { 0, 0, 0, 0, 0 },
/* U+91e8 */ { 0, 0, 0, 0, 0 },
/* U+91e9 */ { 0, 0, 0, 0, 0 },
/* U+91ea */ { 0, 0, 0, 0, 0 },
/* U+91eb */ { 0, 0, 0, 0, 0 },
/* U+91ec */ { 0, 0, 0, 0, 0 },
/* U+91ed */ { 0, 0, 0, 0, 0 },
/* U+91ee */ { 0, 0, 0, 0, 0 },
/* U+91ef */ { 0, 0, 0, 0, 0 },
/* U+91f0 */ { 0, 0, 0, 0, 0 },
/* U+91f1 */ { 0, 0, 0, 0, 0 },
/* U+91f2 */ { 0, 0, 0, 0, 0 },
/* U+91f3 */ { 0, 0, 0, 0, 0 },
/* U+91f4 */ { 0, 0, 0, 0, 0 },
/* U+91f5 */ { 0, 0, 0, 0, 0 },
/* U+91f6 */ { 0, 0, 0, 0, 0 },
/* U+91f7 */ { 0, 0, 0, 0, 0 },
/* U+91f8 */ { 0, 0, 0, 0, 0 },
/* U+91f9 */ { 0, 0, 0, 0, 0 },
/* U+91fa */ { 0, 0, 0, 0, 0 },
/* U+91fb */ { 0, 0, 0, 0, 0 },
/* U+91fc */ { 0, 0, 0, 0, 0 },
/* U+91fd */ { 0, 0, 0, 0, 0 },
/* U+91fe */ { 0, 0, 0, 0, 0 },
/* U+91ff */ { 0, 0, 0, 0, 0 },
/* U+9200 */ { 0, 0, 0, 0, 0 },
/* U+9201 */ { 0, 0, 0, 0, 0 },
/* U+9202 */ { 0, 0, 0, 0, 0 },
/* U+9203 */ { 0, 0, 0, 0, 0 },
/* U+9204 */ { 0, 0, 0, 0, 0 },
/* U+9205 */ { 0, 0, 0, 0, 0 },
/* U+9206 */ { 0, 0, 0, 0, 0 },
/* U+9207 */ { 0, 0, 0, 0, 0 },
/* U+9208 */ { 0, 0, 0, 0, 0 },
/* U+9209 */ { 0, 0, 0, 0, 0 },
/* U+920a */ { 0, 0, 0, 0, 0 },
/* U+920b */ { 0, 0, 0, 0, 0 },
/* U+920c */ { 0, 0, 0, 0, 0 },
/* U+920d */ { 0, 0, 0, 0, 0 },
/* U+920e */ { 0, 0, 0, 0, 0 },
/* U+920f */ { 0, 0, 0, 0, 0 },
/* U+9210 */ { 0, 0, 0, 0, 0 },
/* U+9211 */ { 0, 0, 0, 0, 0 },
/* U+9212 */ { 0, 0, 0, 0, 0 },
/* U+9213 */ { 0, 0, 0, 0, 0 },
/* U+9214 */ { 0, 0, 0, 0, 0 },
/* U+9215 */ { 0, 0, 0, 0, 0 },
/* U+9216 */ { 0, 0, 0, 0, 0 },
/* U+9217 */ { 0, 0, 0, 0, 0 },
/* U+9218 */ { 0, 0, 0, 0, 0 },
/* U+9219 */ { 0, 0, 0, 0, 0 },
/* U+921a */ { 0, 0, 0, 0, 0 },
/* U+921b */ { 0, 0, 0, 0, 0 },
/* U+921c */ { 0, 0, 0, 0, 0 },
/* U+921d */ { 0, 0, 0, 0, 0 },
/* U+921e */ { 0, 0, 0, 0, 0 },
/* U+921f */ { 0, 0, 0, 0, 0 },
/* U+9220 */ { 0, 0, 0, 0, 0 },
/* U+9221 */ { 0, 0, 0, 0, 0 },
/* U+9222 */ { 0, 0, 0, 0, 0 },
/* U+9223 */ { 0, 0, 0, 0, 0 },
/* U+9224 */ { 0, 0, 0, 0, 0 },
/* U+9225 */ { 0, 0, 0, 0, 0 },
/* U+9226 */ { 0, 0, 0, 0, 0 },
/* U+9227 */ { 0, 0, 0, 0, 0 },
/* U+9228 */ { 0, 0, 0, 0, 0 },
/* U+9229 */ { 0, 0, 0, 0, 0 },
/* U+922a */ { 0, 0, 0, 0, 0 },
/* U+922b */ { 0, 0, 0, 0, 0 },
/* U+922c */ { 0, 0, 0, 0, 0 },
/* U+922d */ { 0, 0, 0, 0, 0 },
/* U+922e */ { 0, 0, 0, 0, 0 },
/* U+922f */ { 0, 0, 0, 0, 0 },
/* U+9230 */ { 0, 0, 0, 0, 0 },
/* U+9231 */ { 0, 0, 0, 0, 0 },
/* U+9232 */ { 0, 0, 0, 0, 0 },
/* U+9233 */ { 0, 0, 0, 0, 0 },
/* U+9234 */ { 0, 0, 0, 0, 0 },
/* U+9235 */ { 0, 0, 0, 0, 0 },
/* U+9236 */ { 0, 0, 0, 0, 0 },
/* U+9237 */ { 0, 0, 0, 0, 0 },
/* U+9238 */ { 0, 0, 0, 0, 0 },
/* U+9239 */ { 0, 0, 0, 0, 0 },
/* U+923a */ { 0, 0, 0, 0, 0 },
/* U+923b */ { 0, 0, 0, 0, 0 },
/* U+923c */ { 0, 0, 0, 0, 0 },
/* U+923d */ { 0, 0, 0, 0, 0 },
/* U+923e */ { 0, 0, 0, 0, 0 },
/* U+923f */ { 0, 0, 0, 0, 0 },
/* U+9240 */ { 0, 0, 0, 0, 0 },
/* U+9241 */ { 0, 0, 0, 0, 0 },
/* U+9242 */ { 0, 0, 0, 0, 0 },
/* U+9243 */ { 0, 0, 0, 0, 0 },
/* U+9244 */ { 0, 0, 0, 0, 0 },
/* U+9245 */ { 0, 0, 0, 0, 0 },
/* U+9246 */ { 0, 0, 0, 0, 0 },
/* U+9247 */ { 0, 0, 0, 0, 0 },
/* U+9248 */ { 0, 0, 0, 0, 0 },
/* U+9249 */ { 0, 0, 0, 0, 0 },
/* U+924a */ { 0, 0, 0, 0, 0 },
/* U+924b */ { 0, 0, 0, 0, 0 },
/* U+924c */ { 0, 0, 0, 0, 0 },
/* U+924d */ { 0, 0, 0, 0, 0 },
/* U+924e */ { 0, 0, 0, 0, 0 },
/* U+924f */ { 0, 0, 0, 0, 0 },
/* U+9250 */ { 0, 0, 0, 0, 0 },
/* U+9251 */ { 0, 0, 0, 0, 0 },
/* U+9252 */ { 0, 0, 0, 0, 0 },
/* U+9253 */ { 0, 0, 0, 0, 0 },
/* U+9254 */ { 0, 0, 0, 0, 0 },
/* U+9255 */ { 0, 0, 0, 0, 0 },
/* U+9256 */ { 0, 0, 0, 0, 0 },
/* U+9257 */ { 0, 0, 0, 0, 0 },
/* U+9258 */ { 0, 0, 0, 0, 0 },
/* U+9259 */ { 0, 0, 0, 0, 0 },
/* U+925a */ { 0, 0, 0, 0, 0 },
/* U+925b */ { 0, 0, 0, 0, 0 },
/* U+925c */ { 0, 0, 0, 0, 0 },
/* U+925d */ { 0, 0, 0, 0, 0 },
/* U+925e */ { 0, 0, 0, 0, 0 },
/* U+925f */ { 0, 0, 0, 0, 0 },
/* U+9260 */ { 0, 0, 0, 0, 0 },
/* U+9261 */ { 0, 0, 0, 0, 0 },
/* U+9262 */ { 0, 0, 0, 0, 0 },
/* U+9263 */ { 0, 0, 0, 0, 0 },
/* U+9264 */ { 0, 0, 0, 0, 0 },
/* U+9265 */ { 0, 0, 0, 0, 0 },
/* U+9266 */ { 0, 0, 0, 0, 0 },
/* U+9267 */ { 0, 0, 0, 0, 0 },
/* U+9268 */ { 0, 0, 0, 0, 0 },
/* U+9269 */ { 0, 0, 0, 0, 0 },
/* U+926a */ { 0, 0, 0, 0, 0 },
/* U+926b */ { 0, 0, 0, 0, 0 },
/* U+926c */ { 0, 0, 0, 0, 0 },
/* U+926d */ { 0, 0, 0, 0, 0 },
/* U+926e */ { 0, 0, 0, 0, 0 },
/* U+926f */ { 0, 0, 0, 0, 0 },
/* U+9270 */ { 0, 0, 0, 0, 0 },
/* U+9271 */ { 0, 0, 0, 0, 0 },
/* U+9272 */ { 0, 0, 0, 0, 0 },
/* U+9273 */ { 0, 0, 0, 0, 0 },
/* U+9274 */ { 0, 0, 0, 0, 0 },
/* U+9275 */ { 0, 0, 0, 0, 0 },
/* U+9276 */ { 0, 0, 0, 0, 0 },
/* U+9277 */ { 0, 0, 0, 0, 0 },
/* U+9278 */ { 0, 0, 0, 0, 0 },
/* U+9279 */ { 0, 0, 0, 0, 0 },
/* U+927a */ { 0, 0, 0, 0, 0 },
/* U+927b */ { 0, 0, 0, 0, 0 },
/* U+927c */ { 0, 0, 0, 0, 0 },
/* U+927d */ { 0, 0, 0, 0, 0 },
/* U+927e */ { 0, 0, 0, 0, 0 },
/* U+927f */ { 0, 0, 0, 0, 0 },
/* U+9280 */ { 0, 0, 0, 0, 0 },
/* U+9281 */ { 0, 0, 0, 0, 0 },
/* U+9282 */ { 0, 0, 0, 0, 0 },
/* U+9283 */ { 0, 0, 0, 0, 0 },
/* U+9284 */ { 0, 0, 0, 0, 0 },
/* U+9285 */ { 0, 0, 0, 0, 0 },
/* U+9286 */ { 0, 0, 0, 0, 0 },
/* U+9287 */ { 0, 0, 0, 0, 0 },
/* U+9288 */ { 0, 0, 0, 0, 0 },
/* U+9289 */ { 0, 0, 0, 0, 0 },
/* U+928a */ { 0, 0, 0, 0, 0 },
/* U+928b */ { 0, 0, 0, 0, 0 },
/* U+928c */ { 0, 0, 0, 0, 0 },
/* U+928d */ { 0, 0, 0, 0, 0 },
/* U+928e */ { 0, 0, 0, 0, 0 },
/* U+928f */ { 0, 0, 0, 0, 0 },
/* U+9290 */ { 0, 0, 0, 0, 0 },
/* U+9291 */ { 0, 0, 0, 0, 0 },
/* U+9292 */ { 0, 0, 0, 0, 0 },
/* U+9293 */ { 0, 0, 0, 0, 0 },
/* U+9294 */ { 0, 0, 0, 0, 0 },
/* U+9295 */ { 0, 0, 0, 0, 0 },
/* U+9296 */ { 0, 0, 0, 0, 0 },
/* U+9297 */ { 0, 0, 0, 0, 0 },
/* U+9298 */ { 0, 0, 0, 0, 0 },
/* U+9299 */ { 0, 0, 0, 0, 0 },
/* U+929a */ { 0, 0, 0, 0, 0 },
/* U+929b */ { 0, 0, 0, 0, 0 },
/* U+929c */ { 0, 0, 0, 0, 0 },
/* U+929d */ { 0, 0, 0, 0, 0 },
/* U+929e */ { 0, 0, 0, 0, 0 },
/* U+929f */ { 0, 0, 0, 0, 0 },
/* U+92a0 */ { 0, 0, 0, 0, 0 },
/* U+92a1 */ { 0, 0, 0, 0, 0 },
/* U+92a2 */ { 0, 0, 0, 0, 0 },
/* U+92a3 */ { 0, 0, 0, 0, 0 },
/* U+92a4 */ { 0, 0, 0, 0, 0 },
/* U+92a5 */ { 0, 0, 0, 0, 0 },
/* U+92a6 */ { 0, 0, 0, 0, 0 },
/* U+92a7 */ { 0, 0, 0, 0, 0 },
/* U+92a8 */ { 0, 0, 0, 0, 0 },
/* U+92a9 */ { 0, 0, 0, 0, 0 },
/* U+92aa */ { 0, 0, 0, 0, 0 },
/* U+92ab */ { 0, 0, 0, 0, 0 },
/* U+92ac */ { 0, 0, 0, 0, 0 },
/* U+92ad */ { 0, 0, 0, 0, 0 },
/* U+92ae */ { 0, 0, 0, 0, 0 },
/* U+92af */ { 0, 0, 0, 0, 0 },
/* U+92b0 */ { 0, 0, 0, 0, 0 },
/* U+92b1 */ { 0, 0, 0, 0, 0 },
/* U+92b2 */ { 0, 0, 0, 0, 0 },
/* U+92b3 */ { 0, 0, 0, 0, 0 },
/* U+92b4 */ { 0, 0, 0, 0, 0 },
/* U+92b5 */ { 0, 0, 0, 0, 0 },
/* U+92b6 */ { 0, 0, 0, 0, 0 },
/* U+92b7 */ { 0, 0, 0, 0, 0 },
/* U+92b8 */ { 0, 0, 0, 0, 0 },
/* U+92b9 */ { 0, 0, 0, 0, 0 },
/* U+92ba */ { 0, 0, 0, 0, 0 },
/* U+92bb */ { 0, 0, 0, 0, 0 },
/* U+92bc */ { 0, 0, 0, 0, 0 },
/* U+92bd */ { 0, 0, 0, 0, 0 },
/* U+92be */ { 0, 0, 0, 0, 0 },
/* U+92bf */ { 0, 0, 0, 0, 0 },
/* U+92c0 */ { 0, 0, 0, 0, 0 },
/* U+92c1 */ { 0, 0, 0, 0, 0 },
/* U+92c2 */ { 0, 0, 0, 0, 0 },
/* U+92c3 */ { 0, 0, 0, 0, 0 },
/* U+92c4 */ { 0, 0, 0, 0, 0 },
/* U+92c5 */ { 0, 0, 0, 0, 0 },
/* U+92c6 */ { 0, 0, 0, 0, 0 },
/* U+92c7 */ { 0, 0, 0, 0, 0 },
/* U+92c8 */ { 0, 0, 0, 0, 0 },
/* U+92c9 */ { 0, 0, 0, 0, 0 },
/* U+92ca */ { 0, 0, 0, 0, 0 },
/* U+92cb */ { 0, 0, 0, 0, 0 },
/* U+92cc */ { 0, 0, 0, 0, 0 },
/* U+92cd */ { 0, 0, 0, 0, 0 },
/* U+92ce */ { 0, 0, 0, 0, 0 },
/* U+92cf */ { 0, 0, 0, 0, 0 },
/* U+92d0 */ { 0, 0, 0, 0, 0 },
/* U+92d1 */ { 0, 0, 0, 0, 0 },
/* U+92d2 */ { 0, 0, 0, 0, 0 },
/* U+92d3 */ { 0, 0, 0, 0, 0 },
/* U+92d4 */ { 0, 0, 0, 0, 0 },
/* U+92d5 */ { 0, 0, 0, 0, 0 },
/* U+92d6 */ { 0, 0, 0, 0, 0 },
/* U+92d7 */ { 0, 0, 0, 0, 0 },
/* U+92d8 */ { 0, 0, 0, 0, 0 },
/* U+92d9 */ { 0, 0, 0, 0, 0 },
/* U+92da */ { 0, 0, 0, 0, 0 },
/* U+92db */ { 0, 0, 0, 0, 0 },
/* U+92dc */ { 0, 0, 0, 0, 0 },
/* U+92dd */ { 0, 0, 0, 0, 0 },
/* U+92de */ { 0, 0, 0, 0, 0 },
/* U+92df */ { 0, 0, 0, 0, 0 },
/* U+92e0 */ { 0, 0, 0, 0, 0 },
/* U+92e1 */ { 0, 0, 0, 0, 0 },
/* U+92e2 */ { 0, 0, 0, 0, 0 },
/* U+92e3 */ { 0, 0, 0, 0, 0 },
/* U+92e4 */ { 0, 0, 0, 0, 0 },
/* U+92e5 */ { 0, 0, 0, 0, 0 },
/* U+92e6 */ { 0, 0, 0, 0, 0 },
/* U+92e7 */ { 0, 0, 0, 0, 0 },
/* U+92e8 */ { 0, 0, 0, 0, 0 },
/* U+92e9 */ { 0, 0, 0, 0, 0 },
/* U+92ea */ { 0, 0, 0, 0, 0 },
/* U+92eb */ { 0, 0, 0, 0, 0 },
/* U+92ec */ { 0, 0, 0, 0, 0 },
/* U+92ed */ { 0, 0, 0, 0, 0 },
/* U+92ee */ { 0, 0, 0, 0, 0 },
/* U+92ef */ { 0, 0, 0, 0, 0 },
/* U+92f0 */ { 0, 0, 0, 0, 0 },
/* U+92f1 */ { 0, 0, 0, 0, 0 },
/* U+92f2 */ { 0, 0, 0, 0, 0 },
/* U+92f3 */ { 0, 0, 0, 0, 0 },
/* U+92f4 */ { 0, 0, 0, 0, 0 },
/* U+92f5 */ { 0, 0, 0, 0, 0 },
/* U+92f6 */ { 0, 0, 0, 0, 0 },
/* U+92f7 */ { 0, 0, 0, 0, 0 },
/* U+92f8 */ { 0, 0, 0, 0, 0 },
/* U+92f9 */ { 0, 0, 0, 0, 0 },
/* U+92fa */ { 0, 0, 0, 0, 0 },
/* U+92fb */ { 0, 0, 0, 0, 0 },
/* U+92fc */ { 0, 0, 0, 0, 0 },
/* U+92fd */ { 0, 0, 0, 0, 0 },
/* U+92fe */ { 0, 0, 0, 0, 0 },
/* U+92ff */ { 0, 0, 0, 0, 0 },
/* U+9300 */ { 0, 0, 0, 0, 0 },
/* U+9301 */ { 0, 0, 0, 0, 0 },
/* U+9302 */ { 0, 0, 0, 0, 0 },
/* U+9303 */ { 0, 0, 0, 0, 0 },
/* U+9304 */ { 0, 0, 0, 0, 0 },
/* U+9305 */ { 0, 0, 0, 0, 0 },
/* U+9306 */ { 0, 0, 0, 0, 0 },
/* U+9307 */ { 0, 0, 0, 0, 0 },
/* U+9308 */ { 0, 0, 0, 0, 0 },
/* U+9309 */ { 0, 0, 0, 0, 0 },
/* U+930a */ { 0, 0, 0, 0, 0 },
/* U+930b */ { 0, 0, 0, 0, 0 },
/* U+930c */ { 0, 0, 0, 0, 0 },
/* U+930d */ { 0, 0, 0, 0, 0 },
/* U+930e */ { 0, 0, 0, 0, 0 },
/* U+930f */ { 0, 0, 0, 0, 0 },
/* U+9310 */ { 0, 0, 0, 0, 0 },
/* U+9311 */ { 0, 0, 0, 0, 0 },
/* U+9312 */ { 0, 0, 0, 0, 0 },
/* U+9313 */ { 0, 0, 0, 0, 0 },
/* U+9314 */ { 0, 0, 0, 0, 0 },
/* U+9315 */ { 0, 0, 0, 0, 0 },
/* U+9316 */ { 0, 0, 0, 0, 0 },
/* U+9317 */ { 0, 0, 0, 0, 0 },
/* U+9318 */ { 0, 0, 0, 0, 0 },
/* U+9319 */ { 0, 0, 0, 0, 0 },
/* U+931a */ { 0, 0, 0, 0, 0 },
/* U+931b */ { 0, 0, 0, 0, 0 },
/* U+931c */ { 0, 0, 0, 0, 0 },
/* U+931d */ { 0, 0, 0, 0, 0 },
/* U+931e */ { 0, 0, 0, 0, 0 },
/* U+931f */ { 0, 0, 0, 0, 0 },
/* U+9320 */ { 0, 0, 0, 0, 0 },
/* U+9321 */ { 0, 0, 0, 0, 0 },
/* U+9322 */ { 0, 0, 0, 0, 0 },
/* U+9323 */ { 0, 0, 0, 0, 0 },
/* U+9324 */ { 0, 0, 0, 0, 0 },
/* U+9325 */ { 0, 0, 0, 0, 0 },
/* U+9326 */ { 0, 0, 0, 0, 0 },
/* U+9327 */ { 0, 0, 0, 0, 0 },
/* U+9328 */ { 0, 0, 0, 0, 0 },
/* U+9329 */ { 0, 0, 0, 0, 0 },
/* U+932a */ { 0, 0, 0, 0, 0 },
/* U+932b */ { 0, 0, 0, 0, 0 },
/* U+932c */ { 0, 0, 0, 0, 0 },
/* U+932d */ { 0, 0, 0, 0, 0 },
/* U+932e */ { 0, 0, 0, 0, 0 },
/* U+932f */ { 0, 0, 0, 0, 0 },
/* U+9330 */ { 0, 0, 0, 0, 0 },
/* U+9331 */ { 0, 0, 0, 0, 0 },
/* U+9332 */ { 0, 0, 0, 0, 0 },
/* U+9333 */ { 0, 0, 0, 0, 0 },
/* U+9334 */ { 0, 0, 0, 0, 0 },
/* U+9335 */ { 0, 0, 0, 0, 0 },
/* U+9336 */ { 0, 0, 0, 0, 0 },
/* U+9337 */ { 0, 0, 0, 0, 0 },
/* U+9338 */ { 0, 0, 0, 0, 0 },
/* U+9339 */ { 0, 0, 0, 0, 0 },
/* U+933a */ { 0, 0, 0, 0, 0 },
/* U+933b */ { 0, 0, 0, 0, 0 },
/* U+933c */ { 0, 0, 0, 0, 0 },
/* U+933d */ { 0, 0, 0, 0, 0 },
/* U+933e */ { 0, 0, 0, 0, 0 },
/* U+933f */ { 0, 0, 0, 0, 0 },
/* U+9340 */ { 0, 0, 0, 0, 0 },
/* U+9341 */ { 0, 0, 0, 0, 0 },
/* U+9342 */ { 0, 0, 0, 0, 0 },
/* U+9343 */ { 0, 0, 0, 0, 0 },
/* U+9344 */ { 0, 0, 0, 0, 0 },
/* U+9345 */ { 0, 0, 0, 0, 0 },
/* U+9346 */ { 0, 0, 0, 0, 0 },
/* U+9347 */ { 0, 0, 0, 0, 0 },
/* U+9348 */ { 0, 0, 0, 0, 0 },
/* U+9349 */ { 0, 0, 0, 0, 0 },
/* U+934a */ { 0, 0, 0, 0, 0 },
/* U+934b */ { 0, 0, 0, 0, 0 },
/* U+934c */ { 0, 0, 0, 0, 0 },
/* U+934d */ { 0, 0, 0, 0, 0 },
/* U+934e */ { 0, 0, 0, 0, 0 },
/* U+934f */ { 0, 0, 0, 0, 0 },
/* U+9350 */ { 0, 0, 0, 0, 0 },
/* U+9351 */ { 0, 0, 0, 0, 0 },
/* U+9352 */ { 0, 0, 0, 0, 0 },
/* U+9353 */ { 0, 0, 0, 0, 0 },
/* U+9354 */ { 0, 0, 0, 0, 0 },
/* U+9355 */ { 0, 0, 0, 0, 0 },
/* U+9356 */ { 0, 0, 0, 0, 0 },
/* U+9357 */ { 0, 0, 0, 0, 0 },
/* U+9358 */ { 0, 0, 0, 0, 0 },
/* U+9359 */ { 0, 0, 0, 0, 0 },
/* U+935a */ { 0, 0, 0, 0, 0 },
/* U+935b */ { 0, 0, 0, 0, 0 },
/* U+935c */ { 0, 0, 0, 0, 0 },
/* U+935d */ { 0, 0, 0, 0, 0 },
/* U+935e */ { 0, 0, 0, 0, 0 },
/* U+935f */ { 0, 0, 0, 0, 0 },
/* U+9360 */ { 0, 0, 0, 0, 0 },
/* U+9361 */ { 0, 0, 0, 0, 0 },
/* U+9362 */ { 0, 0, 0, 0, 0 },
/* U+9363 */ { 0, 0, 0, 0, 0 },
/* U+9364 */ { 0, 0, 0, 0, 0 },
/* U+9365 */ { 0, 0, 0, 0, 0 },
/* U+9366 */ { 0, 0, 0, 0, 0 },
/* U+9367 */ { 0, 0, 0, 0, 0 },
/* U+9368 */ { 0, 0, 0, 0, 0 },
/* U+9369 */ { 0, 0, 0, 0, 0 },
/* U+936a */ { 0, 0, 0, 0, 0 },
/* U+936b */ { 0, 0, 0, 0, 0 },
/* U+936c */ { 0, 0, 0, 0, 0 },
/* U+936d */ { 0, 0, 0, 0, 0 },
/* U+936e */ { 0, 0, 0, 0, 0 },
/* U+936f */ { 0, 0, 0, 0, 0 },
/* U+9370 */ { 0, 0, 0, 0, 0 },
/* U+9371 */ { 0, 0, 0, 0, 0 },
/* U+9372 */ { 0, 0, 0, 0, 0 },
/* U+9373 */ { 0, 0, 0, 0, 0 },
/* U+9374 */ { 0, 0, 0, 0, 0 },
/* U+9375 */ { 0, 0, 0, 0, 0 },
/* U+9376 */ { 0, 0, 0, 0, 0 },
/* U+9377 */ { 0, 0, 0, 0, 0 },
/* U+9378 */ { 0, 0, 0, 0, 0 },
/* U+9379 */ { 0, 0, 0, 0, 0 },
/* U+937a */ { 0, 0, 0, 0, 0 },
/* U+937b */ { 0, 0, 0, 0, 0 },
/* U+937c */ { 0, 0, 0, 0, 0 },
/* U+937d */ { 0, 0, 0, 0, 0 },
/* U+937e */ { 0, 0, 0, 0, 0 },
/* U+937f */ { 0, 0, 0, 0, 0 },
/* U+9380 */ { 0, 0, 0, 0, 0 },
/* U+9381 */ { 0, 0, 0, 0, 0 },
/* U+9382 */ { 0, 0, 0, 0, 0 },
/* U+9383 */ { 0, 0, 0, 0, 0 },
/* U+9384 */ { 0, 0, 0, 0, 0 },
/* U+9385 */ { 0, 0, 0, 0, 0 },
/* U+9386 */ { 0, 0, 0, 0, 0 },
/* U+9387 */ { 0, 0, 0, 0, 0 },
/* U+9388 */ { 0, 0, 0, 0, 0 },
/* U+9389 */ { 0, 0, 0, 0, 0 },
/* U+938a */ { 0, 0, 0, 0, 0 },
/* U+938b */ { 0, 0, 0, 0, 0 },
/* U+938c */ { 0, 0, 0, 0, 0 },
/* U+938d */ { 0, 0, 0, 0, 0 },
/* U+938e */ { 0, 0, 0, 0, 0 },
/* U+938f */ { 0, 0, 0, 0, 0 },
/* U+9390 */ { 0, 0, 0, 0, 0 },
/* U+9391 */ { 0, 0, 0, 0, 0 },
/* U+9392 */ { 0, 0, 0, 0, 0 },
/* U+9393 */ { 0, 0, 0, 0, 0 },
/* U+9394 */ { 0, 0, 0, 0, 0 },
/* U+9395 */ { 0, 0, 0, 0, 0 },
/* U+9396 */ { 0, 0, 0, 0, 0 },
/* U+9397 */ { 0, 0, 0, 0, 0 },
/* U+9398 */ { 0, 0, 0, 0, 0 },
/* U+9399 */ { 0, 0, 0, 0, 0 },
/* U+939a */ { 0, 0, 0, 0, 0 },
/* U+939b */ { 0, 0, 0, 0, 0 },
/* U+939c */ { 0, 0, 0, 0, 0 },
/* U+939d */ { 0, 0, 0, 0, 0 },
/* U+939e */ { 0, 0, 0, 0, 0 },
/* U+939f */ { 0, 0, 0, 0, 0 },
/* U+93a0 */ { 0, 0, 0, 0, 0 },
/* U+93a1 */ { 0, 0, 0, 0, 0 },
/* U+93a2 */ { 0, 0, 0, 0, 0 },
/* U+93a3 */ { 0, 0, 0, 0, 0 },
/* U+93a4 */ { 0, 0, 0, 0, 0 },
/* U+93a5 */ { 0, 0, 0, 0, 0 },
/* U+93a6 */ { 0, 0, 0, 0, 0 },
/* U+93a7 */ { 0, 0, 0, 0, 0 },
/* U+93a8 */ { 0, 0, 0, 0, 0 },
/* U+93a9 */ { 0, 0, 0, 0, 0 },
/* U+93aa */ { 0, 0, 0, 0, 0 },
/* U+93ab */ { 0, 0, 0, 0, 0 },
/* U+93ac */ { 0, 0, 0, 0, 0 },
/* U+93ad */ { 0, 0, 0, 0, 0 },
/* U+93ae */ { 0, 0, 0, 0, 0 },
/* U+93af */ { 0, 0, 0, 0, 0 },
/* U+93b0 */ { 0, 0, 0, 0, 0 },
/* U+93b1 */ { 0, 0, 0, 0, 0 },
/* U+93b2 */ { 0, 0, 0, 0, 0 },
/* U+93b3 */ { 0, 0, 0, 0, 0 },
/* U+93b4 */ { 0, 0, 0, 0, 0 },
/* U+93b5 */ { 0, 0, 0, 0, 0 },
/* U+93b6 */ { 0, 0, 0, 0, 0 },
/* U+93b7 */ { 0, 0, 0, 0, 0 },
/* U+93b8 */ { 0, 0, 0, 0, 0 },
/* U+93b9 */ { 0, 0, 0, 0, 0 },
/* U+93ba */ { 0, 0, 0, 0, 0 },
/* U+93bb */ { 0, 0, 0, 0, 0 },
/* U+93bc */ { 0, 0, 0, 0, 0 },
/* U+93bd */ { 0, 0, 0, 0, 0 },
/* U+93be */ { 0, 0, 0, 0, 0 },
/* U+93bf */ { 0, 0, 0, 0, 0 },
/* U+93c0 */ { 0, 0, 0, 0, 0 },
/* U+93c1 */ { 0, 0, 0, 0, 0 },
/* U+93c2 */ { 0, 0, 0, 0, 0 },
/* U+93c3 */ { 0, 0, 0, 0, 0 },
/* U+93c4 */ { 0, 0, 0, 0, 0 },
/* U+93c5 */ { 0, 0, 0, 0, 0 },
/* U+93c6 */ { 0, 0, 0, 0, 0 },
/* U+93c7 */ { 0, 0, 0, 0, 0 },
/* U+93c8 */ { 0, 0, 0, 0, 0 },
/* U+93c9 */ { 0, 0, 0, 0, 0 },
/* U+93ca */ { 0, 0, 0, 0, 0 },
/* U+93cb */ { 0, 0, 0, 0, 0 },
/* U+93cc */ { 0, 0, 0, 0, 0 },
/* U+93cd */ { 0, 0, 0, 0, 0 },
/* U+93ce */ { 0, 0, 0, 0, 0 },
/* U+93cf */ { 0, 0, 0, 0, 0 },
/* U+93d0 */ { 0, 0, 0, 0, 0 },
/* U+93d1 */ { 0, 0, 0, 0, 0 },
/* U+93d2 */ { 0, 0, 0, 0, 0 },
/* U+93d3 */ { 0, 0, 0, 0, 0 },
/* U+93d4 */ { 0, 0, 0, 0, 0 },
/* U+93d5 */ { 0, 0, 0, 0, 0 },
/* U+93d6 */ { 0, 0, 0, 0, 0 },
/* U+93d7 */ { 0, 0, 0, 0, 0 },
/* U+93d8 */ { 0, 0, 0, 0, 0 },
/* U+93d9 */ { 0, 0, 0, 0, 0 },
/* U+93da */ { 0, 0, 0, 0, 0 },
/* U+93db */ { 0, 0, 0, 0, 0 },
/* U+93dc */ { 0, 0, 0, 0, 0 },
/* U+93dd */ { 0, 0, 0, 0, 0 },
/* U+93de */ { 0, 0, 0, 0, 0 },
/* U+93df */ { 0, 0, 0, 0, 0 },
/* U+93e0 */ { 0, 0, 0, 0, 0 },
/* U+93e1 */ { 0, 0, 0, 0, 0 },
/* U+93e2 */ { 0, 0, 0, 0, 0 },
/* U+93e3 */ { 0, 0, 0, 0, 0 },
/* U+93e4 */ { 0, 0, 0, 0, 0 },
/* U+93e5 */ { 0, 0, 0, 0, 0 },
/* U+93e6 */ { 0, 0, 0, 0, 0 },
/* U+93e7 */ { 0, 0, 0, 0, 0 },
/* U+93e8 */ { 0, 0, 0, 0, 0 },
/* U+93e9 */ { 0, 0, 0, 0, 0 },
/* U+93ea */ { 0, 0, 0, 0, 0 },
/* U+93eb */ { 0, 0, 0, 0, 0 },
/* U+93ec */ { 0, 0, 0, 0, 0 },
/* U+93ed */ { 0, 0, 0, 0, 0 },
/* U+93ee */ { 0, 0, 0, 0, 0 },
/* U+93ef */ { 0, 0, 0, 0, 0 },
/* U+93f0 */ { 0, 0, 0, 0, 0 },
/* U+93f1 */ { 0, 0, 0, 0, 0 },
/* U+93f2 */ { 0, 0, 0, 0, 0 },
/* U+93f3 */ { 0, 0, 0, 0, 0 },
/* U+93f4 */ { 0, 0, 0, 0, 0 },
/* U+93f5 */ { 0, 0, 0, 0, 0 },
/* U+93f6 */ { 0, 0, 0, 0, 0 },
/* U+93f7 */ { 0, 0, 0, 0, 0 },
/* U+93f8 */ { 0, 0, 0, 0, 0 },
/* U+93f9 */ { 0, 0, 0, 0, 0 },
/* U+93fa */ { 0, 0, 0, 0, 0 },
/* U+93fb */ { 0, 0, 0, 0, 0 },
/* U+93fc */ { 0, 0, 0, 0, 0 },
/* U+93fd */ { 0, 0, 0, 0, 0 },
/* U+93fe */ { 0, 0, 0, 0, 0 },
/* U+93ff */ { 0, 0, 0, 0, 0 },
/* U+9400 */ { 0, 0, 0, 0, 0 },
/* U+9401 */ { 0, 0, 0, 0, 0 },
/* U+9402 */ { 0, 0, 0, 0, 0 },
/* U+9403 */ { 0, 0, 0, 0, 0 },
/* U+9404 */ { 0, 0, 0, 0, 0 },
/* U+9405 */ { 0, 0, 0, 0, 0 },
/* U+9406 */ { 0, 0, 0, 0, 0 },
/* U+9407 */ { 0, 0, 0, 0, 0 },
/* U+9408 */ { 0, 0, 0, 0, 0 },
/* U+9409 */ { 0, 0, 0, 0, 0 },
/* U+940a */ { 0, 0, 0, 0, 0 },
/* U+940b */ { 0, 0, 0, 0, 0 },
/* U+940c */ { 0, 0, 0, 0, 0 },
/* U+940d */ { 0, 0, 0, 0, 0 },
/* U+940e */ { 0, 0, 0, 0, 0 },
/* U+940f */ { 0, 0, 0, 0, 0 },
/* U+9410 */ { 0, 0, 0, 0, 0 },
/* U+9411 */ { 0, 0, 0, 0, 0 },
/* U+9412 */ { 0, 0, 0, 0, 0 },
/* U+9413 */ { 0, 0, 0, 0, 0 },
/* U+9414 */ { 0, 0, 0, 0, 0 },
/* U+9415 */ { 0, 0, 0, 0, 0 },
/* U+9416 */ { 0, 0, 0, 0, 0 },
/* U+9417 */ { 0, 0, 0, 0, 0 },
/* U+9418 */ { 0, 0, 0, 0, 0 },
/* U+9419 */ { 0, 0, 0, 0, 0 },
/* U+941a */ { 0, 0, 0, 0, 0 },
/* U+941b */ { 0, 0, 0, 0, 0 },
/* U+941c */ { 0, 0, 0, 0, 0 },
/* U+941d */ { 0, 0, 0, 0, 0 },
/* U+941e */ { 0, 0, 0, 0, 0 },
/* U+941f */ { 0, 0, 0, 0, 0 },
/* U+9420 */ { 0, 0, 0, 0, 0 },
/* U+9421 */ { 0, 0, 0, 0, 0 },
/* U+9422 */ { 0, 0, 0, 0, 0 },
/* U+9423 */ { 0, 0, 0, 0, 0 },
/* U+9424 */ { 0, 0, 0, 0, 0 },
/* U+9425 */ { 0, 0, 0, 0, 0 },
/* U+9426 */ { 0, 0, 0, 0, 0 },
/* U+9427 */ { 0, 0, 0, 0, 0 },
/* U+9428 */ { 0, 0, 0, 0, 0 },
/* U+9429 */ { 0, 0, 0, 0, 0 },
/* U+942a */ { 0, 0, 0, 0, 0 },
/* U+942b */ { 0, 0, 0, 0, 0 },
/* U+942c */ { 0, 0, 0, 0, 0 },
/* U+942d */ { 0, 0, 0, 0, 0 },
/* U+942e */ { 0, 0, 0, 0, 0 },
/* U+942f */ { 0, 0, 0, 0, 0 },
/* U+9430 */ { 0, 0, 0, 0, 0 },
/* U+9431 */ { 0, 0, 0, 0, 0 },
/* U+9432 */ { 0, 0, 0, 0, 0 },
/* U+9433 */ { 0, 0, 0, 0, 0 },
/* U+9434 */ { 0, 0, 0, 0, 0 },
/* U+9435 */ { 0, 0, 0, 0, 0 },
/* U+9436 */ { 0, 0, 0, 0, 0 },
/* U+9437 */ { 0, 0, 0, 0, 0 },
/* U+9438 */ { 0, 0, 0, 0, 0 },
/* U+9439 */ { 0, 0, 0, 0, 0 },
/* U+943a */ { 0, 0, 0, 0, 0 },
/* U+943b */ { 0, 0, 0, 0, 0 },
/* U+943c */ { 0, 0, 0, 0, 0 },
/* U+943d */ { 0, 0, 0, 0, 0 },
/* U+943e */ { 0, 0, 0, 0, 0 },
/* U+943f */ { 0, 0, 0, 0, 0 },
/* U+9440 */ { 0, 0, 0, 0, 0 },
/* U+9441 */ { 0, 0, 0, 0, 0 },
/* U+9442 */ { 0, 0, 0, 0, 0 },
/* U+9443 */ { 0, 0, 0, 0, 0 },
/* U+9444 */ { 0, 0, 0, 0, 0 },
/* U+9445 */ { 0, 0, 0, 0, 0 },
/* U+9446 */ { 0, 0, 0, 0, 0 },
/* U+9447 */ { 0, 0, 0, 0, 0 },
/* U+9448 */ { 0, 0, 0, 0, 0 },
/* U+9449 */ { 0, 0, 0, 0, 0 },
/* U+944a */ { 0, 0, 0, 0, 0 },
/* U+944b */ { 0, 0, 0, 0, 0 },
/* U+944c */ { 0, 0, 0, 0, 0 },
/* U+944d */ { 0, 0, 0, 0, 0 },
/* U+944e */ { 0, 0, 0, 0, 0 },
/* U+944f */ { 0, 0, 0, 0, 0 },
/* U+9450 */ { 0, 0, 0, 0, 0 },
/* U+9451 */ { 0, 0, 0, 0, 0 },
/* U+9452 */ { 0, 0, 0, 0, 0 },
/* U+9453 */ { 0, 0, 0, 0, 0 },
/* U+9454 */ { 0, 0, 0, 0, 0 },
/* U+9455 */ { 0, 0, 0, 0, 0 },
/* U+9456 */ { 0, 0, 0, 0, 0 },
/* U+9457 */ { 0, 0, 0, 0, 0 },
/* U+9458 */ { 0, 0, 0, 0, 0 },
/* U+9459 */ { 0, 0, 0, 0, 0 },
/* U+945a */ { 0, 0, 0, 0, 0 },
/* U+945b */ { 0, 0, 0, 0, 0 },
/* U+945c */ { 0, 0, 0, 0, 0 },
/* U+945d */ { 0, 0, 0, 0, 0 },
/* U+945e */ { 0, 0, 0, 0, 0 },
/* U+945f */ { 0, 0, 0, 0, 0 },
/* U+9460 */ { 0, 0, 0, 0, 0 },
/* U+9461 */ { 0, 0, 0, 0, 0 },
/* U+9462 */ { 0, 0, 0, 0, 0 },
/* U+9463 */ { 0, 0, 0, 0, 0 },
/* U+9464 */ { 0, 0, 0, 0, 0 },
/* U+9465 */ { 0, 0, 0, 0, 0 },
/* U+9466 */ { 0, 0, 0, 0, 0 },
/* U+9467 */ { 0, 0, 0, 0, 0 },
/* U+9468 */ { 0, 0, 0, 0, 0 },
/* U+9469 */ { 0, 0, 0, 0, 0 },
/* U+946a */ { 0, 0, 0, 0, 0 },
/* U+946b */ { 0, 0, 0, 0, 0 },
/* U+946c */ { 0, 0, 0, 0, 0 },
/* U+946d */ { 0, 0, 0, 0, 0 },
/* U+946e */ { 0, 0, 0, 0, 0 },
/* U+946f */ { 0, 0, 0, 0, 0 },
/* U+9470 */ { 0, 0, 0, 0, 0 },
/* U+9471 */ { 0, 0, 0, 0, 0 },
/* U+9472 */ { 0, 0, 0, 0, 0 },
/* U+9473 */ { 0, 0, 0, 0, 0 },
/* U+9474 */ { 0, 0, 0, 0, 0 },
/* U+9475 */ { 0, 0, 0, 0, 0 },
/* U+9476 */ { 0, 0, 0, 0, 0 },
/* U+9477 */ { 0, 0, 0, 0, 0 },
/* U+9478 */ { 0, 0, 0, 0, 0 },
/* U+9479 */ { 0, 0, 0, 0, 0 },
/* U+947a */ { 0, 0, 0, 0, 0 },
/* U+947b */ { 0, 0, 0, 0, 0 },
/* U+947c */ { 0, 0, 0, 0, 0 },
/* U+947d */ { 0, 0, 0, 0, 0 },
/* U+947e */ { 0, 0, 0, 0, 0 },
/* U+947f */ { 0, 0, 0, 0, 0 },
/* U+9480 */ { 0, 0, 0, 0, 0 },
/* U+9481 */ { 0, 0, 0, 0, 0 },
/* U+9482 */ { 0, 0, 0, 0, 0 },
/* U+9483 */ { 0, 0, 0, 0, 0 },
/* U+9484 */ { 0, 0, 0, 0, 0 },
/* U+9485 */ { 0, 0, 0, 0, 0 },
/* U+9486 */ { 0, 0, 0, 0, 0 },
/* U+9487 */ { 0, 0, 0, 0, 0 },
/* U+9488 */ { 0, 0, 0, 0, 0 },
/* U+9489 */ { 0, 0, 0, 0, 0 },
/* U+948a */ { 0, 0, 0, 0, 0 },
/* U+948b */ { 0, 0, 0, 0, 0 },
/* U+948c */ { 0, 0, 0, 0, 0 },
/* U+948d */ { 0, 0, 0, 0, 0 },
/* U+948e */ { 0, 0, 0, 0, 0 },
/* U+948f */ { 0, 0, 0, 0, 0 },
/* U+9490 */ { 0, 0, 0, 0, 0 },
/* U+9491 */ { 0, 0, 0, 0, 0 },
/* U+9492 */ { 0, 0, 0, 0, 0 },
/* U+9493 */ { 0, 0, 0, 0, 0 },
/* U+9494 */ { 0, 0, 0, 0, 0 },
/* U+9495 */ { 0, 0, 0, 0, 0 },
/* U+9496 */ { 0, 0, 0, 0, 0 },
/* U+9497 */ { 0, 0, 0, 0, 0 },
/* U+9498 */ { 0, 0, 0, 0, 0 },
/* U+9499 */ { 0, 0, 0, 0, 0 },
/* U+949a */ { 0, 0, 0, 0, 0 },
/* U+949b */ { 0, 0, 0, 0, 0 },
/* U+949c */ { 0, 0, 0, 0, 0 },
/* U+949d */ { 0, 0, 0, 0, 0 },
/* U+949e */ { 0, 0, 0, 0, 0 },
/* U+949f */ { 0, 0, 0, 0, 0 },
/* U+94a0 */ { 0, 0, 0, 0, 0 },
/* U+94a1 */ { 0, 0, 0, 0, 0 },
/* U+94a2 */ { 0, 0, 0, 0, 0 },
/* U+94a3 */ { 0, 0, 0, 0, 0 },
/* U+94a4 */ { 0, 0, 0, 0, 0 },
/* U+94a5 */ { 0, 0, 0, 0, 0 },
/* U+94a6 */ { 0, 0, 0, 0, 0 },
/* U+94a7 */ { 0, 0, 0, 0, 0 },
/* U+94a8 */ { 0, 0, 0, 0, 0 },
/* U+94a9 */ { 0, 0, 0, 0, 0 },
/* U+94aa */ { 0, 0, 0, 0, 0 },
/* U+94ab */ { 0, 0, 0, 0, 0 },
/* U+94ac */ { 0, 0, 0, 0, 0 },
/* U+94ad */ { 0, 0, 0, 0, 0 },
/* U+94ae */ { 0, 0, 0, 0, 0 },
/* U+94af */ { 0, 0, 0, 0, 0 },
/* U+94b0 */ { 0, 0, 0, 0, 0 },
/* U+94b1 */ { 0, 0, 0, 0, 0 },
/* U+94b2 */ { 0, 0, 0, 0, 0 },
/* U+94b3 */ { 0, 0, 0, 0, 0 },
/* U+94b4 */ { 0, 0, 0, 0, 0 },
/* U+94b5 */ { 0, 0, 0, 0, 0 },
/* U+94b6 */ { 0, 0, 0, 0, 0 },
/* U+94b7 */ { 0, 0, 0, 0, 0 },
/* U+94b8 */ { 0, 0, 0, 0, 0 },
/* U+94b9 */ { 0, 0, 0, 0, 0 },
/* U+94ba */ { 0, 0, 0, 0, 0 },
/* U+94bb */ { 0, 0, 0, 0, 0 },
/* U+94bc */ { 0, 0, 0, 0, 0 },
/* U+94bd */ { 0, 0, 0, 0, 0 },
/* U+94be */ { 0, 0, 0, 0, 0 },
/* U+94bf */ { 0, 0, 0, 0, 0 },
/* U+94c0 */ { 0, 0, 0, 0, 0 },
/* U+94c1 */ { 0, 0, 0, 0, 0 },
/* U+94c2 */ { 0, 0, 0, 0, 0 },
/* U+94c3 */ { 0, 0, 0, 0, 0 },
/* U+94c4 */ { 0, 0, 0, 0, 0 },
/* U+94c5 */ { 0, 0, 0, 0, 0 },
/* U+94c6 */ { 0, 0, 0, 0, 0 },
/* U+94c7 */ { 0, 0, 0, 0, 0 },
/* U+94c8 */ { 0, 0, 0, 0, 0 },
/* U+94c9 */ { 0, 0, 0, 0, 0 },
/* U+94ca */ { 0, 0, 0, 0, 0 },
/* U+94cb */ { 0, 0, 0, 0, 0 },
/* U+94cc */ { 0, 0, 0, 0, 0 },
/* U+94cd */ { 0, 0, 0, 0, 0 },
/* U+94ce */ { 0, 0, 0, 0, 0 },
/* U+94cf */ { 0, 0, 0, 0, 0 },
/* U+94d0 */ { 0, 0, 0, 0, 0 },
/* U+94d1 */ { 0, 0, 0, 0, 0 },
/* U+94d2 */ { 0, 0, 0, 0, 0 },
/* U+94d3 */ { 0, 0, 0, 0, 0 },
/* U+94d4 */ { 0, 0, 0, 0, 0 },
/* U+94d5 */ { 0, 0, 0, 0, 0 },
/* U+94d6 */ { 0, 0, 0, 0, 0 },
/* U+94d7 */ { 0, 0, 0, 0, 0 },
/* U+94d8 */ { 0, 0, 0, 0, 0 },
/* U+94d9 */ { 0, 0, 0, 0, 0 },
/* U+94da */ { 0, 0, 0, 0, 0 },
/* U+94db */ { 0, 0, 0, 0, 0 },
/* U+94dc */ { 0, 0, 0, 0, 0 },
/* U+94dd */ { 0, 0, 0, 0, 0 },
/* U+94de */ { 0, 0, 0, 0, 0 },
/* U+94df */ { 0, 0, 0, 0, 0 },
/* U+94e0 */ { 0, 0, 0, 0, 0 },
/* U+94e1 */ { 0, 0, 0, 0, 0 },
/* U+94e2 */ { 0, 0, 0, 0, 0 },
/* U+94e3 */ { 0, 0, 0, 0, 0 },
/* U+94e4 */ { 0, 0, 0, 0, 0 },
/* U+94e5 */ { 0, 0, 0, 0, 0 },
/* U+94e6 */ { 0, 0, 0, 0, 0 },
/* U+94e7 */ { 0, 0, 0, 0, 0 },
/* U+94e8 */ { 0, 0, 0, 0, 0 },
/* U+94e9 */ { 0, 0, 0, 0, 0 },
/* U+94ea */ { 0, 0, 0, 0, 0 },
/* U+94eb */ { 0, 0, 0, 0, 0 },
/* U+94ec */ { 0, 0, 0, 0, 0 },
/* U+94ed */ { 0, 0, 0, 0, 0 },
/* U+94ee */ { 0, 0, 0, 0, 0 },
/* U+94ef */ { 0, 0, 0, 0, 0 },
/* U+94f0 */ { 0, 0, 0, 0, 0 },
/* U+94f1 */ { 0, 0, 0, 0, 0 },
/* U+94f2 */ { 0, 0, 0, 0, 0 },
/* U+94f3 */ { 0, 0, 0, 0, 0 },
/* U+94f4 */ { 0, 0, 0, 0, 0 },
/* U+94f5 */ { 0, 0, 0, 0, 0 },
/* U+94f6 */ { 0, 0, 0, 0, 0 },
/* U+94f7 */ { 0, 0, 0, 0, 0 },
/* U+94f8 */ { 0, 0, 0, 0, 0 },
/* U+94f9 */ { 0, 0, 0, 0, 0 },
/* U+94fa */ { 0, 0, 0, 0, 0 },
/* U+94fb */ { 0, 0, 0, 0, 0 },
/* U+94fc */ { 0, 0, 0, 0, 0 },
/* U+94fd */ { 0, 0, 0, 0, 0 },
/* U+94fe */ { 0, 0, 0, 0, 0 },
/* U+94ff */ { 0, 0, 0, 0, 0 },
/* U+9500 */ { 0, 0, 0, 0, 0 },
/* U+9501 */ { 0, 0, 0, 0, 0 },
/* U+9502 */ { 0, 0, 0, 0, 0 },
/* U+9503 */ { 0, 0, 0, 0, 0 },
/* U+9504 */ { 0, 0, 0, 0, 0 },
/* U+9505 */ { 0, 0, 0, 0, 0 },
/* U+9506 */ { 0, 0, 0, 0, 0 },
/* U+9507 */ { 0, 0, 0, 0, 0 },
/* U+9508 */ { 0, 0, 0, 0, 0 },
/* U+9509 */ { 0, 0, 0, 0, 0 },
/* U+950a */ { 0, 0, 0, 0, 0 },
/* U+950b */ { 0, 0, 0, 0, 0 },
/* U+950c */ { 0, 0, 0, 0, 0 },
/* U+950d */ { 0, 0, 0, 0, 0 },
/* U+950e */ { 0, 0, 0, 0, 0 },
/* U+950f */ { 0, 0, 0, 0, 0 },
/* U+9510 */ { 0, 0, 0, 0, 0 },
/* U+9511 */ { 0, 0, 0, 0, 0 },
/* U+9512 */ { 0, 0, 0, 0, 0 },
/* U+9513 */ { 0, 0, 0, 0, 0 },
/* U+9514 */ { 0, 0, 0, 0, 0 },
/* U+9515 */ { 0, 0, 0, 0, 0 },
/* U+9516 */ { 0, 0, 0, 0, 0 },
/* U+9517 */ { 0, 0, 0, 0, 0 },
/* U+9518 */ { 0, 0, 0, 0, 0 },
/* U+9519 */ { 0, 0, 0, 0, 0 },
/* U+951a */ { 0, 0, 0, 0, 0 },
/* U+951b */ { 0, 0, 0, 0, 0 },
/* U+951c */ { 0, 0, 0, 0, 0 },
/* U+951d */ { 0, 0, 0, 0, 0 },
/* U+951e */ { 0, 0, 0, 0, 0 },
/* U+951f */ { 0, 0, 0, 0, 0 },
/* U+9520 */ { 0, 0, 0, 0, 0 },
/* U+9521 */ { 0, 0, 0, 0, 0 },
/* U+9522 */ { 0, 0, 0, 0, 0 },
/* U+9523 */ { 0, 0, 0, 0, 0 },
/* U+9524 */ { 0, 0, 0, 0, 0 },
/* U+9525 */ { 0, 0, 0, 0, 0 },
/* U+9526 */ { 0, 0, 0, 0, 0 },
/* U+9527 */ { 0, 0, 0, 0, 0 },
/* U+9528 */ { 0, 0, 0, 0, 0 },
/* U+9529 */ { 0, 0, 0, 0, 0 },
/* U+952a */ { 0, 0, 0, 0, 0 },
/* U+952b */ { 0, 0, 0, 0, 0 },
/* U+952c */ { 0, 0, 0, 0, 0 },
/* U+952d */ { 0, 0, 0, 0, 0 },
/* U+952e */ { 0, 0, 0, 0, 0 },
/* U+952f */ { 0, 0, 0, 0, 0 },
/* U+9530 */ { 0, 0, 0, 0, 0 },
/* U+9531 */ { 0, 0, 0, 0, 0 },
/* U+9532 */ { 0, 0, 0, 0, 0 },
/* U+9533 */ { 0, 0, 0, 0, 0 },
/* U+9534 */ { 0, 0, 0, 0, 0 },
/* U+9535 */ { 0, 0, 0, 0, 0 },
/* U+9536 */ { 0, 0, 0, 0, 0 },
/* U+9537 */ { 0, 0, 0, 0, 0 },
/* U+9538 */ { 0, 0, 0, 0, 0 },
/* U+9539 */ { 0, 0, 0, 0, 0 },
/* U+953a */ { 0, 0, 0, 0, 0 },
/* U+953b */ { 0, 0, 0, 0, 0 },
/* U+953c */ { 0, 0, 0, 0, 0 },
/* U+953d */ { 0, 0, 0, 0, 0 },
/* U+953e */ { 0, 0, 0, 0, 0 },
/* U+953f */ { 0, 0, 0, 0, 0 },
/* U+9540 */ { 0, 0, 0, 0, 0 },
/* U+9541 */ { 0, 0, 0, 0, 0 },
/* U+9542 */ { 0, 0, 0, 0, 0 },
/* U+9543 */ { 0, 0, 0, 0, 0 },
/* U+9544 */ { 0, 0, 0, 0, 0 },
/* U+9545 */ { 0, 0, 0, 0, 0 },
/* U+9546 */ { 0, 0, 0, 0, 0 },
/* U+9547 */ { 0, 0, 0, 0, 0 },
/* U+9548 */ { 0, 0, 0, 0, 0 },
/* U+9549 */ { 0, 0, 0, 0, 0 },
/* U+954a */ { 0, 0, 0, 0, 0 },
/* U+954b */ { 0, 0, 0, 0, 0 },
/* U+954c */ { 0, 0, 0, 0, 0 },
/* U+954d */ { 0, 0, 0, 0, 0 },
/* U+954e */ { 0, 0, 0, 0, 0 },
/* U+954f */ { 0, 0, 0, 0, 0 },
/* U+9550 */ { 0, 0, 0, 0, 0 },
/* U+9551 */ { 0, 0, 0, 0, 0 },
/* U+9552 */ { 0, 0, 0, 0, 0 },
/* U+9553 */ { 0, 0, 0, 0, 0 },
/* U+9554 */ { 0, 0, 0, 0, 0 },
/* U+9555 */ { 0, 0, 0, 0, 0 },
/* U+9556 */ { 0, 0, 0, 0, 0 },
/* U+9557 */ { 0, 0, 0, 0, 0 },
/* U+9558 */ { 0, 0, 0, 0, 0 },
/* U+9559 */ { 0, 0, 0, 0, 0 },
/* U+955a */ { 0, 0, 0, 0, 0 },
/* U+955b */ { 0, 0, 0, 0, 0 },
/* U+955c */ { 0, 0, 0, 0, 0 },
/* U+955d */ { 0, 0, 0, 0, 0 },
/* U+955e */ { 0, 0, 0, 0, 0 },
/* U+955f */ { 0, 0, 0, 0, 0 },
/* U+9560 */ { 0, 0, 0, 0, 0 },
/* U+9561 */ { 0, 0, 0, 0, 0 },
/* U+9562 */ { 0, 0, 0, 0, 0 },
/* U+9563 */ { 0, 0, 0, 0, 0 },
/* U+9564 */ { 0, 0, 0, 0, 0 },
/* U+9565 */ { 0, 0, 0, 0, 0 },
/* U+9566 */ { 0, 0, 0, 0, 0 },
/* U+9567 */ { 0, 0, 0, 0, 0 },
/* U+9568 */ { 0, 0, 0, 0, 0 },
/* U+9569 */ { 0, 0, 0, 0, 0 },
/* U+956a */ { 0, 0, 0, 0, 0 },
/* U+956b */ { 0, 0, 0, 0, 0 },
/* U+956c */ { 0, 0, 0, 0, 0 },
/* U+956d */ { 0, 0, 0, 0, 0 },
/* U+956e */ { 0, 0, 0, 0, 0 },
/* U+956f */ { 0, 0, 0, 0, 0 },
/* U+9570 */ { 0, 0, 0, 0, 0 },
/* U+9571 */ { 0, 0, 0, 0, 0 },
/* U+9572 */ { 0, 0, 0, 0, 0 },
/* U+9573 */ { 0, 0, 0, 0, 0 },
/* U+9574 */ { 0, 0, 0, 0, 0 },
/* U+9575 */ { 0, 0, 0, 0, 0 },
/* U+9576 */ { 0, 0, 0, 0, 0 },
/* U+9577 */ { 0, 0, 0, 0, 0 },
/* U+9578 */ { 0, 0, 0, 0, 0 },
/* U+9579 */ { 0, 0, 0, 0, 0 },
/* U+957a */ { 0, 0, 0, 0, 0 },
/* U+957b */ { 0, 0, 0, 0, 0 },
/* U+957c */ { 0, 0, 0, 0, 0 },
/* U+957d */ { 0, 0, 0, 0, 0 },
/* U+957e */ { 0, 0, 0, 0, 0 },
/* U+957f */ { 0, 0, 0, 0, 0 },
/* U+9580 */ { 0, 0, 0, 0, 0 },
/* U+9581 */ { 0, 0, 0, 0, 0 },
/* U+9582 */ { 0, 0, 0, 0, 0 },
/* U+9583 */ { 0, 0, 0, 0, 0 },
/* U+9584 */ { 0, 0, 0, 0, 0 },
/* U+9585 */ { 0, 0, 0, 0, 0 },
/* U+9586 */ { 0, 0, 0, 0, 0 },
/* U+9587 */ { 0, 0, 0, 0, 0 },
/* U+9588 */ { 0, 0, 0, 0, 0 },
/* U+9589 */ { 0, 0, 0, 0, 0 },
/* U+958a */ { 0, 0, 0, 0, 0 },
/* U+958b */ { 0, 0, 0, 0, 0 },
/* U+958c */ { 0, 0, 0, 0, 0 },
/* U+958d */ { 0, 0, 0, 0, 0 },
/* U+958e */ { 0, 0, 0, 0, 0 },
/* U+958f */ { 0, 0, 0, 0, 0 },
/* U+9590 */ { 0, 0, 0, 0, 0 },
/* U+9591 */ { 0, 0, 0, 0, 0 },
/* U+9592 */ { 0, 0, 0, 0, 0 },
/* U+9593 */ { 0, 0, 0, 0, 0 },
/* U+9594 */ { 0, 0, 0, 0, 0 },
/* U+9595 */ { 0, 0, 0, 0, 0 },
/* U+9596 */ { 0, 0, 0, 0, 0 },
/* U+9597 */ { 0, 0, 0, 0, 0 },
/* U+9598 */ { 0, 0, 0, 0, 0 },
/* U+9599 */ { 0, 0, 0, 0, 0 },
/* U+959a */ { 0, 0, 0, 0, 0 },
/* U+959b */ { 0, 0, 0, 0, 0 },
/* U+959c */ { 0, 0, 0, 0, 0 },
/* U+959d */ { 0, 0, 0, 0, 0 },
/* U+959e */ { 0, 0, 0, 0, 0 },
/* U+959f */ { 0, 0, 0, 0, 0 },
/* U+95a0 */ { 0, 0, 0, 0, 0 },
/* U+95a1 */ { 0, 0, 0, 0, 0 },
/* U+95a2 */ { 0, 0, 0, 0, 0 },
/* U+95a3 */ { 0, 0, 0, 0, 0 },
/* U+95a4 */ { 0, 0, 0, 0, 0 },
/* U+95a5 */ { 0, 0, 0, 0, 0 },
/* U+95a6 */ { 0, 0, 0, 0, 0 },
/* U+95a7 */ { 0, 0, 0, 0, 0 },
/* U+95a8 */ { 0, 0, 0, 0, 0 },
/* U+95a9 */ { 0, 0, 0, 0, 0 },
/* U+95aa */ { 0, 0, 0, 0, 0 },
/* U+95ab */ { 0, 0, 0, 0, 0 },
/* U+95ac */ { 0, 0, 0, 0, 0 },
/* U+95ad */ { 0, 0, 0, 0, 0 },
/* U+95ae */ { 0, 0, 0, 0, 0 },
/* U+95af */ { 0, 0, 0, 0, 0 },
/* U+95b0 */ { 0, 0, 0, 0, 0 },
/* U+95b1 */ { 0, 0, 0, 0, 0 },
/* U+95b2 */ { 0, 0, 0, 0, 0 },
/* U+95b3 */ { 0, 0, 0, 0, 0 },
/* U+95b4 */ { 0, 0, 0, 0, 0 },
/* U+95b5 */ { 0, 0, 0, 0, 0 },
/* U+95b6 */ { 0, 0, 0, 0, 0 },
/* U+95b7 */ { 0, 0, 0, 0, 0 },
/* U+95b8 */ { 0, 0, 0, 0, 0 },
/* U+95b9 */ { 0, 0, 0, 0, 0 },
/* U+95ba */ { 0, 0, 0, 0, 0 },
/* U+95bb */ { 0, 0, 0, 0, 0 },
/* U+95bc */ { 0, 0, 0, 0, 0 },
/* U+95bd */ { 0, 0, 0, 0, 0 },
/* U+95be */ { 0, 0, 0, 0, 0 },
/* U+95bf */ { 0, 0, 0, 0, 0 },
/* U+95c0 */ { 0, 0, 0, 0, 0 },
/* U+95c1 */ { 0, 0, 0, 0, 0 },
/* U+95c2 */ { 0, 0, 0, 0, 0 },
/* U+95c3 */ { 0, 0, 0, 0, 0 },
/* U+95c4 */ { 0, 0, 0, 0, 0 },
/* U+95c5 */ { 0, 0, 0, 0, 0 },
/* U+95c6 */ { 0, 0, 0, 0, 0 },
/* U+95c7 */ { 0, 0, 0, 0, 0 },
/* U+95c8 */ { 0, 0, 0, 0, 0 },
/* U+95c9 */ { 0, 0, 0, 0, 0 },
/* U+95ca */ { 0, 0, 0, 0, 0 },
/* U+95cb */ { 0, 0, 0, 0, 0 },
/* U+95cc */ { 0, 0, 0, 0, 0 },
/* U+95cd */ { 0, 0, 0, 0, 0 },
/* U+95ce */ { 0, 0, 0, 0, 0 },
/* U+95cf */ { 0, 0, 0, 0, 0 },
/* U+95d0 */ { 0, 0, 0, 0, 0 },
/* U+95d1 */ { 0, 0, 0, 0, 0 },
/* U+95d2 */ { 0, 0, 0, 0, 0 },
/* U+95d3 */ { 0, 0, 0, 0, 0 },
/* U+95d4 */ { 0, 0, 0, 0, 0 },
/* U+95d5 */ { 0, 0, 0, 0, 0 },
/* U+95d6 */ { 0, 0, 0, 0, 0 },
/* U+95d7 */ { 0, 0, 0, 0, 0 },
/* U+95d8 */ { 0, 0, 0, 0, 0 },
/* U+95d9 */ { 0, 0, 0, 0, 0 },
/* U+95da */ { 0, 0, 0, 0, 0 },
/* U+95db */ { 0, 0, 0, 0, 0 },
/* U+95dc */ { 0, 0, 0, 0, 0 },
/* U+95dd */ { 0, 0, 0, 0, 0 },
/* U+95de */ { 0, 0, 0, 0, 0 },
/* U+95df */ { 0, 0, 0, 0, 0 },
/* U+95e0 */ { 0, 0, 0, 0, 0 },
/* U+95e1 */ { 0, 0, 0, 0, 0 },
/* U+95e2 */ { 0, 0, 0, 0, 0 },
/* U+95e3 */ { 0, 0, 0, 0, 0 },
/* U+95e4 */ { 0, 0, 0, 0, 0 },
/* U+95e5 */ { 0, 0, 0, 0, 0 },
/* U+95e6 */ { 0, 0, 0, 0, 0 },
/* U+95e7 */ { 0, 0, 0, 0, 0 },
/* U+95e8 */ { 0, 0, 0, 0, 0 },
/* U+95e9 */ { 0, 0, 0, 0, 0 },
/* U+95ea */ { 0, 0, 0, 0, 0 },
/* U+95eb */ { 0, 0, 0, 0, 0 },
/* U+95ec */ { 0, 0, 0, 0, 0 },
/* U+95ed */ { 0, 0, 0, 0, 0 },
/* U+95ee */ { 0, 0, 0, 0, 0 },
/* U+95ef */ { 0, 0, 0, 0, 0 },
/* U+95f0 */ { 0, 0, 0, 0, 0 },
/* U+95f1 */ { 0, 0, 0, 0, 0 },
/* U+95f2 */ { 0, 0, 0, 0, 0 },
/* U+95f3 */ { 0, 0, 0, 0, 0 },
/* U+95f4 */ { 0, 0, 0, 0, 0 },
/* U+95f5 */ { 0, 0, 0, 0, 0 },
/* U+95f6 */ { 0, 0, 0, 0, 0 },
/* U+95f7 */ { 0, 0, 0, 0, 0 },
/* U+95f8 */ { 0, 0, 0, 0, 0 },
/* U+95f9 */ { 0, 0, 0, 0, 0 },
/* U+95fa */ { 0, 0, 0, 0, 0 },
/* U+95fb */ { 0, 0, 0, 0, 0 },
/* U+95fc */ { 0, 0, 0, 0, 0 },
/* U+95fd */ { 0, 0, 0, 0, 0 },
/* U+95fe */ { 0, 0, 0, 0, 0 },
/* U+95ff */ { 0, 0, 0, 0, 0 },
/* U+9600 */ { 0, 0, 0, 0, 0 },
/* U+9601 */ { 0, 0, 0, 0, 0 },
/* U+9602 */ { 0, 0, 0, 0, 0 },
/* U+9603 */ { 0, 0, 0, 0, 0 },
/* U+9604 */ { 0, 0, 0, 0, 0 },
/* U+9605 */ { 0, 0, 0, 0, 0 },
/* U+9606 */ { 0, 0, 0, 0, 0 },
/* U+9607 */ { 0, 0, 0, 0, 0 },
/* U+9608 */ { 0, 0, 0, 0, 0 },
/* U+9609 */ { 0, 0, 0, 0, 0 },
/* U+960a */ { 0, 0, 0, 0, 0 },
/* U+960b */ { 0, 0, 0, 0, 0 },
/* U+960c */ { 0, 0, 0, 0, 0 },
/* U+960d */ { 0, 0, 0, 0, 0 },
/* U+960e */ { 0, 0, 0, 0, 0 },
/* U+960f */ { 0, 0, 0, 0, 0 },
/* U+9610 */ { 0, 0, 0, 0, 0 },
/* U+9611 */ { 0, 0, 0, 0, 0 },
/* U+9612 */ { 0, 0, 0, 0, 0 },
/* U+9613 */ { 0, 0, 0, 0, 0 },
/* U+9614 */ { 0, 0, 0, 0, 0 },
/* U+9615 */ { 0, 0, 0, 0, 0 },
/* U+9616 */ { 0, 0, 0, 0, 0 },
/* U+9617 */ { 0, 0, 0, 0, 0 },
/* U+9618 */ { 0, 0, 0, 0, 0 },
/* U+9619 */ { 0, 0, 0, 0, 0 },
/* U+961a */ { 0, 0, 0, 0, 0 },
/* U+961b */ { 0, 0, 0, 0, 0 },
/* U+961c */ { 0, 0, 0, 0, 0 },
/* U+961d */ { 0, 0, 0, 0, 0 },
/* U+961e */ { 0, 0, 0, 0, 0 },
/* U+961f */ { 0, 0, 0, 0, 0 },
/* U+9620 */ { 0, 0, 0, 0, 0 },
/* U+9621 */ { 0, 0, 0, 0, 0 },
/* U+9622 */ { 0, 0, 0, 0, 0 },
/* U+9623 */ { 0, 0, 0, 0, 0 },
/* U+9624 */ { 0, 0, 0, 0, 0 },
/* U+9625 */ { 0, 0, 0, 0, 0 },
/* U+9626 */ { 0, 0, 0, 0, 0 },
/* U+9627 */ { 0, 0, 0, 0, 0 },
/* U+9628 */ { 0, 0, 0, 0, 0 },
/* U+9629 */ { 0, 0, 0, 0, 0 },
/* U+962a */ { 0, 0, 0, 0, 0 },
/* U+962b */ { 0, 0, 0, 0, 0 },
/* U+962c */ { 0, 0, 0, 0, 0 },
/* U+962d */ { 0, 0, 0, 0, 0 },
/* U+962e */ { 0, 0, 0, 0, 0 },
/* U+962f */ { 0, 0, 0, 0, 0 },
/* U+9630 */ { 0, 0, 0, 0, 0 },
/* U+9631 */ { 0, 0, 0, 0, 0 },
/* U+9632 */ { 0, 0, 0, 0, 0 },
/* U+9633 */ { 0, 0, 0, 0, 0 },
/* U+9634 */ { 0, 0, 0, 0, 0 },
/* U+9635 */ { 0, 0, 0, 0, 0 },
/* U+9636 */ { 0, 0, 0, 0, 0 },
/* U+9637 */ { 0, 0, 0, 0, 0 },
/* U+9638 */ { 0, 0, 0, 0, 0 },
/* U+9639 */ { 0, 0, 0, 0, 0 },
/* U+963a */ { 0, 0, 0, 0, 0 },
/* U+963b */ { 0, 0, 0, 0, 0 },
/* U+963c */ { 0, 0, 0, 0, 0 },
/* U+963d */ { 0, 0, 0, 0, 0 },
/* U+963e */ { 0, 0, 0, 0, 0 },
/* U+963f */ { 0, 0, 0, 0, 0 },
/* U+9640 */ { 0, 0, 0, 0, 0 },
/* U+9641 */ { 0, 0, 0, 0, 0 },
/* U+9642 */ { 0, 0, 0, 0, 0 },
/* U+9643 */ { 0, 0, 0, 0, 0 },
/* U+9644 */ { 0, 0, 0, 0, 0 },
/* U+9645 */ { 0, 0, 0, 0, 0 },
/* U+9646 */ { 0, 0, 0, 0, 0 },
/* U+9647 */ { 0, 0, 0, 0, 0 },
/* U+9648 */ { 0, 0, 0, 0, 0 },
/* U+9649 */ { 0, 0, 0, 0, 0 },
/* U+964a */ { 0, 0, 0, 0, 0 },
/* U+964b */ { 0, 0, 0, 0, 0 },
/* U+964c */ { 0, 0, 0, 0, 0 },
/* U+964d */ { 0, 0, 0, 0, 0 },
/* U+964e */ { 0, 0, 0, 0, 0 },
/* U+964f */ { 0, 0, 0, 0, 0 },
/* U+9650 */ { 0, 0, 0, 0, 0 },
/* U+9651 */ { 0, 0, 0, 0, 0 },
/* U+9652 */ { 0, 0, 0, 0, 0 },
/* U+9653 */ { 0, 0, 0, 0, 0 },
/* U+9654 */ { 0, 0, 0, 0, 0 },
/* U+9655 */ { 0, 0, 0, 0, 0 },
/* U+9656 */ { 0, 0, 0, 0, 0 },
/* U+9657 */ { 0, 0, 0, 0, 0 },
/* U+9658 */ { 0, 0, 0, 0, 0 },
/* U+9659 */ { 0, 0, 0, 0, 0 },
/* U+965a */ { 0, 0, 0, 0, 0 },
/* U+965b */ { 0, 0, 0, 0, 0 },
/* U+965c */ { 0, 0, 0, 0, 0 },
/* U+965d */ { 0, 0, 0, 0, 0 },
/* U+965e */ { 0, 0, 0, 0, 0 },
/* U+965f */ { 0, 0, 0, 0, 0 },
/* U+9660 */ { 0, 0, 0, 0, 0 },
/* U+9661 */ { 0, 0, 0, 0, 0 },
/* U+9662 */ { 0, 0, 0, 0, 0 },
/* U+9663 */ { 0, 0, 0, 0, 0 },
/* U+9664 */ { 0, 0, 0, 0, 0 },
/* U+9665 */ { 0, 0, 0, 0, 0 },
/* U+9666 */ { 0, 0, 0, 0, 0 },
/* U+9667 */ { 0, 0, 0, 0, 0 },
/* U+9668 */ { 0, 0, 0, 0, 0 },
/* U+9669 */ { 0, 0, 0, 0, 0 },
/* U+966a */ { 0, 0, 0, 0, 0 },
/* U+966b */ { 0, 0, 0, 0, 0 },
/* U+966c */ { 0, 0, 0, 0, 0 },
/* U+966d */ { 0, 0, 0, 0, 0 },
/* U+966e */ { 0, 0, 0, 0, 0 },
/* U+966f */ { 0, 0, 0, 0, 0 },
/* U+9670 */ { 0, 0, 0, 0, 0 },
/* U+9671 */ { 0, 0, 0, 0, 0 },
/* U+9672 */ { 0, 0, 0, 0, 0 },
/* U+9673 */ { 0, 0, 0, 0, 0 },
/* U+9674 */ { 0, 0, 0, 0, 0 },
/* U+9675 */ { 0, 0, 0, 0, 0 },
/* U+9676 */ { 0, 0, 0, 0, 0 },
/* U+9677 */ { 0, 0, 0, 0, 0 },
/* U+9678 */ { 0, 0, 0, 0, 0 },
/* U+9679 */ { 0, 0, 0, 0, 0 },
/* U+967a */ { 0, 0, 0, 0, 0 },
/* U+967b */ { 0, 0, 0, 0, 0 },
/* U+967c */ { 0, 0, 0, 0, 0 },
/* U+967d */ { 0, 0, 0, 0, 0 },
/* U+967e */ { 0, 0, 0, 0, 0 },
/* U+967f */ { 0, 0, 0, 0, 0 },
/* U+9680 */ { 0, 0, 0, 0, 0 },
/* U+9681 */ { 0, 0, 0, 0, 0 },
/* U+9682 */ { 0, 0, 0, 0, 0 },
/* U+9683 */ { 0, 0, 0, 0, 0 },
/* U+9684 */ { 0, 0, 0, 0, 0 },
/* U+9685 */ { 0, 0, 0, 0, 0 },
/* U+9686 */ { 0, 0, 0, 0, 0 },
/* U+9687 */ { 0, 0, 0, 0, 0 },
/* U+9688 */ { 0, 0, 0, 0, 0 },
/* U+9689 */ { 0, 0, 0, 0, 0 },
/* U+968a */ { 0, 0, 0, 0, 0 },
/* U+968b */ { 0, 0, 0, 0, 0 },
/* U+968c */ { 0, 0, 0, 0, 0 },
/* U+968d */ { 0, 0, 0, 0, 0 },
/* U+968e */ { 0, 0, 0, 0, 0 },
/* U+968f */ { 0, 0, 0, 0, 0 },
/* U+9690 */ { 0, 0, 0, 0, 0 },
/* U+9691 */ { 0, 0, 0, 0, 0 },
/* U+9692 */ { 0, 0, 0, 0, 0 },
/* U+9693 */ { 0, 0, 0, 0, 0 },
/* U+9694 */ { 0, 0, 0, 0, 0 },
/* U+9695 */ { 0, 0, 0, 0, 0 },
/* U+9696 */ { 0, 0, 0, 0, 0 },
/* U+9697 */ { 0, 0, 0, 0, 0 },
/* U+9698 */ { 0, 0, 0, 0, 0 },
/* U+9699 */ { 0, 0, 0, 0, 0 },
/* U+969a */ { 0, 0, 0, 0, 0 },
/* U+969b */ { 0, 0, 0, 0, 0 },
/* U+969c */ { 0, 0, 0, 0, 0 },
/* U+969d */ { 0, 0, 0, 0, 0 },
/* U+969e */ { 0, 0, 0, 0, 0 },
/* U+969f */ { 0, 0, 0, 0, 0 },
/* U+96a0 */ { 0, 0, 0, 0, 0 },
/* U+96a1 */ { 0, 0, 0, 0, 0 },
/* U+96a2 */ { 0, 0, 0, 0, 0 },
/* U+96a3 */ { 0, 0, 0, 0, 0 },
/* U+96a4 */ { 0, 0, 0, 0, 0 },
/* U+96a5 */ { 0, 0, 0, 0, 0 },
/* U+96a6 */ { 0, 0, 0, 0, 0 },
/* U+96a7 */ { 0, 0, 0, 0, 0 },
/* U+96a8 */ { 0, 0, 0, 0, 0 },
/* U+96a9 */ { 0, 0, 0, 0, 0 },
/* U+96aa */ { 0, 0, 0, 0, 0 },
/* U+96ab */ { 0, 0, 0, 0, 0 },
/* U+96ac */ { 0, 0, 0, 0, 0 },
/* U+96ad */ { 0, 0, 0, 0, 0 },
/* U+96ae */ { 0, 0, 0, 0, 0 },
/* U+96af */ { 0, 0, 0, 0, 0 },
/* U+96b0 */ { 0, 0, 0, 0, 0 },
/* U+96b1 */ { 0, 0, 0, 0, 0 },
/* U+96b2 */ { 0, 0, 0, 0, 0 },
/* U+96b3 */ { 0, 0, 0, 0, 0 },
/* U+96b4 */ { 0, 0, 0, 0, 0 },
/* U+96b5 */ { 0, 0, 0, 0, 0 },
/* U+96b6 */ { 0, 0, 0, 0, 0 },
/* U+96b7 */ { 0, 0, 0, 0, 0 },
/* U+96b8 */ { 0, 0, 0, 0, 0 },
/* U+96b9 */ { 0, 0, 0, 0, 0 },
/* U+96ba */ { 0, 0, 0, 0, 0 },
/* U+96bb */ { 0, 0, 0, 0, 0 },
/* U+96bc */ { 0, 0, 0, 0, 0 },
/* U+96bd */ { 0, 0, 0, 0, 0 },
/* U+96be */ { 0, 0, 0, 0, 0 },
/* U+96bf */ { 0, 0, 0, 0, 0 },
/* U+96c0 */ { 0, 0, 0, 0, 0 },
/* U+96c1 */ { 0, 0, 0, 0, 0 },
/* U+96c2 */ { 0, 0, 0, 0, 0 },
/* U+96c3 */ { 0, 0, 0, 0, 0 },
/* U+96c4 */ { 0, 0, 0, 0, 0 },
/* U+96c5 */ { 0, 0, 0, 0, 0 },
/* U+96c6 */ { 0, 0, 0, 0, 0 },
/* U+96c7 */ { 0, 0, 0, 0, 0 },
/* U+96c8 */ { 0, 0, 0, 0, 0 },
/* U+96c9 */ { 0, 0, 0, 0, 0 },
/* U+96ca */ { 0, 0, 0, 0, 0 },
/* U+96cb */ { 0, 0, 0, 0, 0 },
/* U+96cc */ { 0, 0, 0, 0, 0 },
/* U+96cd */ { 0, 0, 0, 0, 0 },
/* U+96ce */ { 0, 0, 0, 0, 0 },
/* U+96cf */ { 0, 0, 0, 0, 0 },
/* U+96d0 */ { 0, 0, 0, 0, 0 },
/* U+96d1 */ { 0, 0, 0, 0, 0 },
/* U+96d2 */ { 0, 0, 0, 0, 0 },
/* U+96d3 */ { 0, 0, 0, 0, 0 },
/* U+96d4 */ { 0, 0, 0, 0, 0 },
/* U+96d5 */ { 0, 0, 0, 0, 0 },
/* U+96d6 */ { 0, 0, 0, 0, 0 },
/* U+96d7 */ { 0, 0, 0, 0, 0 },
/* U+96d8 */ { 0, 0, 0, 0, 0 },
/* U+96d9 */ { 0, 0, 0, 0, 0 },
/* U+96da */ { 0, 0, 0, 0, 0 },
/* U+96db */ { 0, 0, 0, 0, 0 },
/* U+96dc */ { 0, 0, 0, 0, 0 },
/* U+96dd */ { 0, 0, 0, 0, 0 },
/* U+96de */ { 0, 0, 0, 0, 0 },
/* U+96df */ { 0, 0, 0, 0, 0 },
/* U+96e0 */ { 0, 0, 0, 0, 0 },
/* U+96e1 */ { 0, 0, 0, 0, 0 },
/* U+96e2 */ { 0, 0, 0, 0, 0 },
/* U+96e3 */ { 0, 0, 0, 0, 0 },
/* U+96e4 */ { 0, 0, 0, 0, 0 },
/* U+96e5 */ { 0, 0, 0, 0, 0 },
/* U+96e6 */ { 0, 0, 0, 0, 0 },
/* U+96e7 */ { 0, 0, 0, 0, 0 },
/* U+96e8 */ { 0, 0, 0, 0, 0 },
/* U+96e9 */ { 0, 0, 0, 0, 0 },
/* U+96ea */ { 0, 0, 0, 0, 0 },
/* U+96eb */ { 0, 0, 0, 0, 0 },
/* U+96ec */ { 0, 0, 0, 0, 0 },
/* U+96ed */ { 0, 0, 0, 0, 0 },
/* U+96ee */ { 0, 0, 0, 0, 0 },
/* U+96ef */ { 0, 0, 0, 0, 0 },
/* U+96f0 */ { 0, 0, 0, 0, 0 },
/* U+96f1 */ { 0, 0, 0, 0, 0 },
/* U+96f2 */ { 0, 0, 0, 0, 0 },
/* U+96f3 */ { 0, 0, 0, 0, 0 },
/* U+96f4 */ { 0, 0, 0, 0, 0 },
/* U+96f5 */ { 0, 0, 0, 0, 0 },
/* U+96f6 */ { 0, 0, 0, 0, 0 },
/* U+96f7 */ { 0, 0, 0, 0, 0 },
/* U+96f8 */ { 0, 0, 0, 0, 0 },
/* U+96f9 */ { 0, 0, 0, 0, 0 },
/* U+96fa */ { 0, 0, 0, 0, 0 },
/* U+96fb */ { 0, 0, 0, 0, 0 },
/* U+96fc */ { 0, 0, 0, 0, 0 },
/* U+96fd */ { 0, 0, 0, 0, 0 },
/* U+96fe */ { 0, 0, 0, 0, 0 },
/* U+96ff */ { 0, 0, 0, 0, 0 },
/* U+9700 */ { 0, 0, 0, 0, 0 },
/* U+9701 */ { 0, 0, 0, 0, 0 },
/* U+9702 */ { 0, 0, 0, 0, 0 },
/* U+9703 */ { 0, 0, 0, 0, 0 },
/* U+9704 */ { 0, 0, 0, 0, 0 },
/* U+9705 */ { 0, 0, 0, 0, 0 },
/* U+9706 */ { 0, 0, 0, 0, 0 },
/* U+9707 */ { 0, 0, 0, 0, 0 },
/* U+9708 */ { 0, 0, 0, 0, 0 },
/* U+9709 */ { 0, 0, 0, 0, 0 },
/* U+970a */ { 0, 0, 0, 0, 0 },
/* U+970b */ { 0, 0, 0, 0, 0 },
/* U+970c */ { 0, 0, 0, 0, 0 },
/* U+970d */ { 0, 0, 0, 0, 0 },
/* U+970e */ { 0, 0, 0, 0, 0 },
/* U+970f */ { 0, 0, 0, 0, 0 },
/* U+9710 */ { 0, 0, 0, 0, 0 },
/* U+9711 */ { 0, 0, 0, 0, 0 },
/* U+9712 */ { 0, 0, 0, 0, 0 },
/* U+9713 */ { 0, 0, 0, 0, 0 },
/* U+9714 */ { 0, 0, 0, 0, 0 },
/* U+9715 */ { 0, 0, 0, 0, 0 },
/* U+9716 */ { 0, 0, 0, 0, 0 },
/* U+9717 */ { 0, 0, 0, 0, 0 },
/* U+9718 */ { 0, 0, 0, 0, 0 },
/* U+9719 */ { 0, 0, 0, 0, 0 },
/* U+971a */ { 0, 0, 0, 0, 0 },
/* U+971b */ { 0, 0, 0, 0, 0 },
/* U+971c */ { 0, 0, 0, 0, 0 },
/* U+971d */ { 0, 0, 0, 0, 0 },
/* U+971e */ { 0, 0, 0, 0, 0 },
/* U+971f */ { 0, 0, 0, 0, 0 },
/* U+9720 */ { 0, 0, 0, 0, 0 },
/* U+9721 */ { 0, 0, 0, 0, 0 },
/* U+9722 */ { 0, 0, 0, 0, 0 },
/* U+9723 */ { 0, 0, 0, 0, 0 },
/* U+9724 */ { 0, 0, 0, 0, 0 },
/* U+9725 */ { 0, 0, 0, 0, 0 },
/* U+9726 */ { 0, 0, 0, 0, 0 },
/* U+9727 */ { 0, 0, 0, 0, 0 },
/* U+9728 */ { 0, 0, 0, 0, 0 },
/* U+9729 */ { 0, 0, 0, 0, 0 },
/* U+972a */ { 0, 0, 0, 0, 0 },
/* U+972b */ { 0, 0, 0, 0, 0 },
/* U+972c */ { 0, 0, 0, 0, 0 },
/* U+972d */ { 0, 0, 0, 0, 0 },
/* U+972e */ { 0, 0, 0, 0, 0 },
/* U+972f */ { 0, 0, 0, 0, 0 },
/* U+9730 */ { 0, 0, 0, 0, 0 },
/* U+9731 */ { 0, 0, 0, 0, 0 },
/* U+9732 */ { 0, 0, 0, 0, 0 },
/* U+9733 */ { 0, 0, 0, 0, 0 },
/* U+9734 */ { 0, 0, 0, 0, 0 },
/* U+9735 */ { 0, 0, 0, 0, 0 },
/* U+9736 */ { 0, 0, 0, 0, 0 },
/* U+9737 */ { 0, 0, 0, 0, 0 },
/* U+9738 */ { 0, 0, 0, 0, 0 },
/* U+9739 */ { 0, 0, 0, 0, 0 },
/* U+973a */ { 0, 0, 0, 0, 0 },
/* U+973b */ { 0, 0, 0, 0, 0 },
/* U+973c */ { 0, 0, 0, 0, 0 },
/* U+973d */ { 0, 0, 0, 0, 0 },
/* U+973e */ { 0, 0, 0, 0, 0 },
/* U+973f */ { 0, 0, 0, 0, 0 },
/* U+9740 */ { 0, 0, 0, 0, 0 },
/* U+9741 */ { 0, 0, 0, 0, 0 },
/* U+9742 */ { 0, 0, 0, 0, 0 },
/* U+9743 */ { 0, 0, 0, 0, 0 },
/* U+9744 */ { 0, 0, 0, 0, 0 },
/* U+9745 */ { 0, 0, 0, 0, 0 },
/* U+9746 */ { 0, 0, 0, 0, 0 },
/* U+9747 */ { 0, 0, 0, 0, 0 },
/* U+9748 */ { 0, 0, 0, 0, 0 },
/* U+9749 */ { 0, 0, 0, 0, 0 },
/* U+974a */ { 0, 0, 0, 0, 0 },
/* U+974b */ { 0, 0, 0, 0, 0 },
/* U+974c */ { 0, 0, 0, 0, 0 },
/* U+974d */ { 0, 0, 0, 0, 0 },
/* U+974e */ { 0, 0, 0, 0, 0 },
/* U+974f */ { 0, 0, 0, 0, 0 },
/* U+9750 */ { 0, 0, 0, 0, 0 },
/* U+9751 */ { 0, 0, 0, 0, 0 },
/* U+9752 */ { 0, 0, 0, 0, 0 },
/* U+9753 */ { 0, 0, 0, 0, 0 },
/* U+9754 */ { 0, 0, 0, 0, 0 },
/* U+9755 */ { 0, 0, 0, 0, 0 },
/* U+9756 */ { 0, 0, 0, 0, 0 },
/* U+9757 */ { 0, 0, 0, 0, 0 },
/* U+9758 */ { 0, 0, 0, 0, 0 },
/* U+9759 */ { 0, 0, 0, 0, 0 },
/* U+975a */ { 0, 0, 0, 0, 0 },
/* U+975b */ { 0, 0, 0, 0, 0 },
/* U+975c */ { 0, 0, 0, 0, 0 },
/* U+975d */ { 0, 0, 0, 0, 0 },
/* U+975e */ { 0, 0, 0, 0, 0 },
/* U+975f */ { 0, 0, 0, 0, 0 },
/* U+9760 */ { 0, 0, 0, 0, 0 },
/* U+9761 */ { 0, 0, 0, 0, 0 },
/* U+9762 */ { 0, 0, 0, 0, 0 },
/* U+9763 */ { 0, 0, 0, 0, 0 },
/* U+9764 */ { 0, 0, 0, 0, 0 },
/* U+9765 */ { 0, 0, 0, 0, 0 },
/* U+9766 */ { 0, 0, 0, 0, 0 },
/* U+9767 */ { 0, 0, 0, 0, 0 },
/* U+9768 */ { 0, 0, 0, 0, 0 },
/* U+9769 */ { 0, 0, 0, 0, 0 },
/* U+976a */ { 0, 0, 0, 0, 0 },
/* U+976b */ { 0, 0, 0, 0, 0 },
/* U+976c */ { 0, 0, 0, 0, 0 },
/* U+976d */ { 0, 0, 0, 0, 0 },
/* U+976e */ { 0, 0, 0, 0, 0 },
/* U+976f */ { 0, 0, 0, 0, 0 },
/* U+9770 */ { 0, 0, 0, 0, 0 },
/* U+9771 */ { 0, 0, 0, 0, 0 },
/* U+9772 */ { 0, 0, 0, 0, 0 },
/* U+9773 */ { 0, 0, 0, 0, 0 },
/* U+9774 */ { 0, 0, 0, 0, 0 },
/* U+9775 */ { 0, 0, 0, 0, 0 },
/* U+9776 */ { 0, 0, 0, 0, 0 },
/* U+9777 */ { 0, 0, 0, 0, 0 },
/* U+9778 */ { 0, 0, 0, 0, 0 },
/* U+9779 */ { 0, 0, 0, 0, 0 },
/* U+977a */ { 0, 0, 0, 0, 0 },
/* U+977b */ { 0, 0, 0, 0, 0 },
/* U+977c */ { 0, 0, 0, 0, 0 },
/* U+977d */ { 0, 0, 0, 0, 0 },
/* U+977e */ { 0, 0, 0, 0, 0 },
/* U+977f */ { 0, 0, 0, 0, 0 },
/* U+9780 */ { 0, 0, 0, 0, 0 },
/* U+9781 */ { 0, 0, 0, 0, 0 },
/* U+9782 */ { 0, 0, 0, 0, 0 },
/* U+9783 */ { 0, 0, 0, 0, 0 },
/* U+9784 */ { 0, 0, 0, 0, 0 },
/* U+9785 */ { 0, 0, 0, 0, 0 },
/* U+9786 */ { 0, 0, 0, 0, 0 },
/* U+9787 */ { 0, 0, 0, 0, 0 },
/* U+9788 */ { 0, 0, 0, 0, 0 },
/* U+9789 */ { 0, 0, 0, 0, 0 },
/* U+978a */ { 0, 0, 0, 0, 0 },
/* U+978b */ { 0, 0, 0, 0, 0 },
/* U+978c */ { 0, 0, 0, 0, 0 },
/* U+978d */ { 0, 0, 0, 0, 0 },
/* U+978e */ { 0, 0, 0, 0, 0 },
/* U+978f */ { 0, 0, 0, 0, 0 },
/* U+9790 */ { 0, 0, 0, 0, 0 },
/* U+9791 */ { 0, 0, 0, 0, 0 },
/* U+9792 */ { 0, 0, 0, 0, 0 },
/* U+9793 */ { 0, 0, 0, 0, 0 },
/* U+9794 */ { 0, 0, 0, 0, 0 },
/* U+9795 */ { 0, 0, 0, 0, 0 },
/* U+9796 */ { 0, 0, 0, 0, 0 },
/* U+9797 */ { 0, 0, 0, 0, 0 },
/* U+9798 */ { 0, 0, 0, 0, 0 },
/* U+9799 */ { 0, 0, 0, 0, 0 },
/* U+979a */ { 0, 0, 0, 0, 0 },
/* U+979b */ { 0, 0, 0, 0, 0 },
/* U+979c */ { 0, 0, 0, 0, 0 },
/* U+979d */ { 0, 0, 0, 0, 0 },
/* U+979e */ { 0, 0, 0, 0, 0 },
/* U+979f */ { 0, 0, 0, 0, 0 },
/* U+97a0 */ { 0, 0, 0, 0, 0 },
/* U+97a1 */ { 0, 0, 0, 0, 0 },
/* U+97a2 */ { 0, 0, 0, 0, 0 },
/* U+97a3 */ { 0, 0, 0, 0, 0 },
/* U+97a4 */ { 0, 0, 0, 0, 0 },
/* U+97a5 */ { 0, 0, 0, 0, 0 },
/* U+97a6 */ { 0, 0, 0, 0, 0 },
/* U+97a7 */ { 0, 0, 0, 0, 0 },
/* U+97a8 */ { 0, 0, 0, 0, 0 },
/* U+97a9 */ { 0, 0, 0, 0, 0 },
/* U+97aa */ { 0, 0, 0, 0, 0 },
/* U+97ab */ { 0, 0, 0, 0, 0 },
/* U+97ac */ { 0, 0, 0, 0, 0 },
/* U+97ad */ { 0, 0, 0, 0, 0 },
/* U+97ae */ { 0, 0, 0, 0, 0 },
/* U+97af */ { 0, 0, 0, 0, 0 },
/* U+97b0 */ { 0, 0, 0, 0, 0 },
/* U+97b1 */ { 0, 0, 0, 0, 0 },
/* U+97b2 */ { 0, 0, 0, 0, 0 },
/* U+97b3 */ { 0, 0, 0, 0, 0 },
/* U+97b4 */ { 0, 0, 0, 0, 0 },
/* U+97b5 */ { 0, 0, 0, 0, 0 },
/* U+97b6 */ { 0, 0, 0, 0, 0 },
/* U+97b7 */ { 0, 0, 0, 0, 0 },
/* U+97b8 */ { 0, 0, 0, 0, 0 },
/* U+97b9 */ { 0, 0, 0, 0, 0 },
/* U+97ba */ { 0, 0, 0, 0, 0 },
/* U+97bb */ { 0, 0, 0, 0, 0 },
/* U+97bc */ { 0, 0, 0, 0, 0 },
/* U+97bd */ { 0, 0, 0, 0, 0 },
/* U+97be */ { 0, 0, 0, 0, 0 },
/* U+97bf */ { 0, 0, 0, 0, 0 },
/* U+97c0 */ { 0, 0, 0, 0, 0 },
/* U+97c1 */ { 0, 0, 0, 0, 0 },
/* U+97c2 */ { 0, 0, 0, 0, 0 },
/* U+97c3 */ { 0, 0, 0, 0, 0 },
/* U+97c4 */ { 0, 0, 0, 0, 0 },
/* U+97c5 */ { 0, 0, 0, 0, 0 },
/* U+97c6 */ { 0, 0, 0, 0, 0 },
/* U+97c7 */ { 0, 0, 0, 0, 0 },
/* U+97c8 */ { 0, 0, 0, 0, 0 },
/* U+97c9 */ { 0, 0, 0, 0, 0 },
/* U+97ca */ { 0, 0, 0, 0, 0 },
/* U+97cb */ { 0, 0, 0, 0, 0 },
/* U+97cc */ { 0, 0, 0, 0, 0 },
/* U+97cd */ { 0, 0, 0, 0, 0 },
/* U+97ce */ { 0, 0, 0, 0, 0 },
/* U+97cf */ { 0, 0, 0, 0, 0 },
/* U+97d0 */ { 0, 0, 0, 0, 0 },
/* U+97d1 */ { 0, 0, 0, 0, 0 },
/* U+97d2 */ { 0, 0, 0, 0, 0 },
/* U+97d3 */ { 0, 0, 0, 0, 0 },
/* U+97d4 */ { 0, 0, 0, 0, 0 },
/* U+97d5 */ { 0, 0, 0, 0, 0 },
/* U+97d6 */ { 0, 0, 0, 0, 0 },
/* U+97d7 */ { 0, 0, 0, 0, 0 },
/* U+97d8 */ { 0, 0, 0, 0, 0 },
/* U+97d9 */ { 0, 0, 0, 0, 0 },
/* U+97da */ { 0, 0, 0, 0, 0 },
/* U+97db */ { 0, 0, 0, 0, 0 },
/* U+97dc */ { 0, 0, 0, 0, 0 },
/* U+97dd */ { 0, 0, 0, 0, 0 },
/* U+97de */ { 0, 0, 0, 0, 0 },
/* U+97df */ { 0, 0, 0, 0, 0 },
/* U+97e0 */ { 0, 0, 0, 0, 0 },
/* U+97e1 */ { 0, 0, 0, 0, 0 },
/* U+97e2 */ { 0, 0, 0, 0, 0 },
/* U+97e3 */ { 0, 0, 0, 0, 0 },
/* U+97e4 */ { 0, 0, 0, 0, 0 },
/* U+97e5 */ { 0, 0, 0, 0, 0 },
/* U+97e6 */ { 0, 0, 0, 0, 0 },
/* U+97e7 */ { 0, 0, 0, 0, 0 },
/* U+97e8 */ { 0, 0, 0, 0, 0 },
/* U+97e9 */ { 0, 0, 0, 0, 0 },
/* U+97ea */ { 0, 0, 0, 0, 0 },
/* U+97eb */ { 0, 0, 0, 0, 0 },
/* U+97ec */ { 0, 0, 0, 0, 0 },
/* U+97ed */ { 0, 0, 0, 0, 0 },
/* U+97ee */ { 0, 0, 0, 0, 0 },
/* U+97ef */ { 0, 0, 0, 0, 0 },
/* U+97f0 */ { 0, 0, 0, 0, 0 },
/* U+97f1 */ { 0, 0, 0, 0, 0 },
/* U+97f2 */ { 0, 0, 0, 0, 0 },
/* U+97f3 */ { 0, 0, 0, 0, 0 },
/* U+97f4 */ { 0, 0, 0, 0, 0 },
/* U+97f5 */ { 0, 0, 0, 0, 0 },
/* U+97f6 */ { 0, 0, 0, 0, 0 },
/* U+97f7 */ { 0, 0, 0, 0, 0 },
/* U+97f8 */ { 0, 0, 0, 0, 0 },
/* U+97f9 */ { 0, 0, 0, 0, 0 },
/* U+97fa */ { 0, 0, 0, 0, 0 },
/* U+97fb */ { 0, 0, 0, 0, 0 },
/* U+97fc */ { 0, 0, 0, 0, 0 },
/* U+97fd */ { 0, 0, 0, 0, 0 },
/* U+97fe */ { 0, 0, 0, 0, 0 },
/* U+97ff */ { 0, 0, 0, 0, 0 },
/* U+9800 */ { 0, 0, 0, 0, 0 },
/* U+9801 */ { 0, 0, 0, 0, 0 },
/* U+9802 */ { 0, 0, 0, 0, 0 },
/* U+9803 */ { 0, 0, 0, 0, 0 },
/* U+9804 */ { 0, 0, 0, 0, 0 },
/* U+9805 */ { 0, 0, 0, 0, 0 },
/* U+9806 */ { 0, 0, 0, 0, 0 },
/* U+9807 */ { 0, 0, 0, 0, 0 },
/* U+9808 */ { 0, 0, 0, 0, 0 },
/* U+9809 */ { 0, 0, 0, 0, 0 },
/* U+980a */ { 0, 0, 0, 0, 0 },
/* U+980b */ { 0, 0, 0, 0, 0 },
/* U+980c */ { 0, 0, 0, 0, 0 },
/* U+980d */ { 0, 0, 0, 0, 0 },
/* U+980e */ { 0, 0, 0, 0, 0 },
/* U+980f */ { 0, 0, 0, 0, 0 },
/* U+9810 */ { 0, 0, 0, 0, 0 },
/* U+9811 */ { 0, 0, 0, 0, 0 },
/* U+9812 */ { 0, 0, 0, 0, 0 },
/* U+9813 */ { 0, 0, 0, 0, 0 },
/* U+9814 */ { 0, 0, 0, 0, 0 },
/* U+9815 */ { 0, 0, 0, 0, 0 },
/* U+9816 */ { 0, 0, 0, 0, 0 },
/* U+9817 */ { 0, 0, 0, 0, 0 },
/* U+9818 */ { 0, 0, 0, 0, 0 },
/* U+9819 */ { 0, 0, 0, 0, 0 },
/* U+981a */ { 0, 0, 0, 0, 0 },
/* U+981b */ { 0, 0, 0, 0, 0 },
/* U+981c */ { 0, 0, 0, 0, 0 },
/* U+981d */ { 0, 0, 0, 0, 0 },
/* U+981e */ { 0, 0, 0, 0, 0 },
/* U+981f */ { 0, 0, 0, 0, 0 },
/* U+9820 */ { 0, 0, 0, 0, 0 },
/* U+9821 */ { 0, 0, 0, 0, 0 },
/* U+9822 */ { 0, 0, 0, 0, 0 },
/* U+9823 */ { 0, 0, 0, 0, 0 },
/* U+9824 */ { 0, 0, 0, 0, 0 },
/* U+9825 */ { 0, 0, 0, 0, 0 },
/* U+9826 */ { 0, 0, 0, 0, 0 },
/* U+9827 */ { 0, 0, 0, 0, 0 },
/* U+9828 */ { 0, 0, 0, 0, 0 },
/* U+9829 */ { 0, 0, 0, 0, 0 },
/* U+982a */ { 0, 0, 0, 0, 0 },
/* U+982b */ { 0, 0, 0, 0, 0 },
/* U+982c */ { 0, 0, 0, 0, 0 },
/* U+982d */ { 0, 0, 0, 0, 0 },
/* U+982e */ { 0, 0, 0, 0, 0 },
/* U+982f */ { 0, 0, 0, 0, 0 },
/* U+9830 */ { 0, 0, 0, 0, 0 },
/* U+9831 */ { 0, 0, 0, 0, 0 },
/* U+9832 */ { 0, 0, 0, 0, 0 },
/* U+9833 */ { 0, 0, 0, 0, 0 },
/* U+9834 */ { 0, 0, 0, 0, 0 },
/* U+9835 */ { 0, 0, 0, 0, 0 },
/* U+9836 */ { 0, 0, 0, 0, 0 },
/* U+9837 */ { 0, 0, 0, 0, 0 },
/* U+9838 */ { 0, 0, 0, 0, 0 },
/* U+9839 */ { 0, 0, 0, 0, 0 },
/* U+983a */ { 0, 0, 0, 0, 0 },
/* U+983b */ { 0, 0, 0, 0, 0 },
/* U+983c */ { 0, 0, 0, 0, 0 },
/* U+983d */ { 0, 0, 0, 0, 0 },
/* U+983e */ { 0, 0, 0, 0, 0 },
/* U+983f */ { 0, 0, 0, 0, 0 },
/* U+9840 */ { 0, 0, 0, 0, 0 },
/* U+9841 */ { 0, 0, 0, 0, 0 },
/* U+9842 */ { 0, 0, 0, 0, 0 },
/* U+9843 */ { 0, 0, 0, 0, 0 },
/* U+9844 */ { 0, 0, 0, 0, 0 },
/* U+9845 */ { 0, 0, 0, 0, 0 },
/* U+9846 */ { 0, 0, 0, 0, 0 },
/* U+9847 */ { 0, 0, 0, 0, 0 },
/* U+9848 */ { 0, 0, 0, 0, 0 },
/* U+9849 */ { 0, 0, 0, 0, 0 },
/* U+984a */ { 0, 0, 0, 0, 0 },
/* U+984b */ { 0, 0, 0, 0, 0 },
/* U+984c */ { 0, 0, 0, 0, 0 },
/* U+984d */ { 0, 0, 0, 0, 0 },
/* U+984e */ { 0, 0, 0, 0, 0 },
/* U+984f */ { 0, 0, 0, 0, 0 },
/* U+9850 */ { 0, 0, 0, 0, 0 },
/* U+9851 */ { 0, 0, 0, 0, 0 },
/* U+9852 */ { 0, 0, 0, 0, 0 },
/* U+9853 */ { 0, 0, 0, 0, 0 },
/* U+9854 */ { 0, 0, 0, 0, 0 },
/* U+9855 */ { 0, 0, 0, 0, 0 },
/* U+9856 */ { 0, 0, 0, 0, 0 },
/* U+9857 */ { 0, 0, 0, 0, 0 },
/* U+9858 */ { 0, 0, 0, 0, 0 },
/* U+9859 */ { 0, 0, 0, 0, 0 },
/* U+985a */ { 0, 0, 0, 0, 0 },
/* U+985b */ { 0, 0, 0, 0, 0 },
/* U+985c */ { 0, 0, 0, 0, 0 },
/* U+985d */ { 0, 0, 0, 0, 0 },
/* U+985e */ { 0, 0, 0, 0, 0 },
/* U+985f */ { 0, 0, 0, 0, 0 },
/* U+9860 */ { 0, 0, 0, 0, 0 },
/* U+9861 */ { 0, 0, 0, 0, 0 },
/* U+9862 */ { 0, 0, 0, 0, 0 },
/* U+9863 */ { 0, 0, 0, 0, 0 },
/* U+9864 */ { 0, 0, 0, 0, 0 },
/* U+9865 */ { 0, 0, 0, 0, 0 },
/* U+9866 */ { 0, 0, 0, 0, 0 },
/* U+9867 */ { 0, 0, 0, 0, 0 },
/* U+9868 */ { 0, 0, 0, 0, 0 },
/* U+9869 */ { 0, 0, 0, 0, 0 },
/* U+986a */ { 0, 0, 0, 0, 0 },
/* U+986b */ { 0, 0, 0, 0, 0 },
/* U+986c */ { 0, 0, 0, 0, 0 },
/* U+986d */ { 0, 0, 0, 0, 0 },
/* U+986e */ { 0, 0, 0, 0, 0 },
/* U+986f */ { 0, 0, 0, 0, 0 },
/* U+9870 */ { 0, 0, 0, 0, 0 },
/* U+9871 */ { 0, 0, 0, 0, 0 },
/* U+9872 */ { 0, 0, 0, 0, 0 },
/* U+9873 */ { 0, 0, 0, 0, 0 },
/* U+9874 */ { 0, 0, 0, 0, 0 },
/* U+9875 */ { 0, 0, 0, 0, 0 },
/* U+9876 */ { 0, 0, 0, 0, 0 },
/* U+9877 */ { 0, 0, 0, 0, 0 },
/* U+9878 */ { 0, 0, 0, 0, 0 },
/* U+9879 */ { 0, 0, 0, 0, 0 },
/* U+987a */ { 0, 0, 0, 0, 0 },
/* U+987b */ { 0, 0, 0, 0, 0 },
/* U+987c */ { 0, 0, 0, 0, 0 },
/* U+987d */ { 0, 0, 0, 0, 0 },
/* U+987e */ { 0, 0, 0, 0, 0 },
/* U+987f */ { 0, 0, 0, 0, 0 },
/* U+9880 */ { 0, 0, 0, 0, 0 },
/* U+9881 */ { 0, 0, 0, 0, 0 },
/* U+9882 */ { 0, 0, 0, 0, 0 },
/* U+9883 */ { 0, 0, 0, 0, 0 },
/* U+9884 */ { 0, 0, 0, 0, 0 },
/* U+9885 */ { 0, 0, 0, 0, 0 },
/* U+9886 */ { 0, 0, 0, 0, 0 },
/* U+9887 */ { 0, 0, 0, 0, 0 },
/* U+9888 */ { 0, 0, 0, 0, 0 },
/* U+9889 */ { 0, 0, 0, 0, 0 },
/* U+988a */ { 0, 0, 0, 0, 0 },
/* U+988b */ { 0, 0, 0, 0, 0 },
/* U+988c */ { 0, 0, 0, 0, 0 },
/* U+988d */ { 0, 0, 0, 0, 0 },
/* U+988e */ { 0, 0, 0, 0, 0 },
/* U+988f */ { 0, 0, 0, 0, 0 },
/* U+9890 */ { 0, 0, 0, 0, 0 },
/* U+9891 */ { 0, 0, 0, 0, 0 },
/* U+9892 */ { 0, 0, 0, 0, 0 },
/* U+9893 */ { 0, 0, 0, 0, 0 },
/* U+9894 */ { 0, 0, 0, 0, 0 },
/* U+9895 */ { 0, 0, 0, 0, 0 },
/* U+9896 */ { 0, 0, 0, 0, 0 },
/* U+9897 */ { 0, 0, 0, 0, 0 },
/* U+9898 */ { 0, 0, 0, 0, 0 },
/* U+9899 */ { 0, 0, 0, 0, 0 },
/* U+989a */ { 0, 0, 0, 0, 0 },
/* U+989b */ { 0, 0, 0, 0, 0 },
/* U+989c */ { 0, 0, 0, 0, 0 },
/* U+989d */ { 0, 0, 0, 0, 0 },
/* U+989e */ { 0, 0, 0, 0, 0 },
/* U+989f */ { 0, 0, 0, 0, 0 },
/* U+98a0 */ { 0, 0, 0, 0, 0 },
/* U+98a1 */ { 0, 0, 0, 0, 0 },
/* U+98a2 */ { 0, 0, 0, 0, 0 },
/* U+98a3 */ { 0, 0, 0, 0, 0 },
/* U+98a4 */ { 0, 0, 0, 0, 0 },
/* U+98a5 */ { 0, 0, 0, 0, 0 },
/* U+98a6 */ { 0, 0, 0, 0, 0 },
/* U+98a7 */ { 0, 0, 0, 0, 0 },
/* U+98a8 */ { 0, 0, 0, 0, 0 },
/* U+98a9 */ { 0, 0, 0, 0, 0 },
/* U+98aa */ { 0, 0, 0, 0, 0 },
/* U+98ab */ { 0, 0, 0, 0, 0 },
/* U+98ac */ { 0, 0, 0, 0, 0 },
/* U+98ad */ { 0, 0, 0, 0, 0 },
/* U+98ae */ { 0, 0, 0, 0, 0 },
/* U+98af */ { 0, 0, 0, 0, 0 },
/* U+98b0 */ { 0, 0, 0, 0, 0 },
/* U+98b1 */ { 0, 0, 0, 0, 0 },
/* U+98b2 */ { 0, 0, 0, 0, 0 },
/* U+98b3 */ { 0, 0, 0, 0, 0 },
/* U+98b4 */ { 0, 0, 0, 0, 0 },
/* U+98b5 */ { 0, 0, 0, 0, 0 },
/* U+98b6 */ { 0, 0, 0, 0, 0 },
/* U+98b7 */ { 0, 0, 0, 0, 0 },
/* U+98b8 */ { 0, 0, 0, 0, 0 },
/* U+98b9 */ { 0, 0, 0, 0, 0 },
/* U+98ba */ { 0, 0, 0, 0, 0 },
/* U+98bb */ { 0, 0, 0, 0, 0 },
/* U+98bc */ { 0, 0, 0, 0, 0 },
/* U+98bd */ { 0, 0, 0, 0, 0 },
/* U+98be */ { 0, 0, 0, 0, 0 },
/* U+98bf */ { 0, 0, 0, 0, 0 },
/* U+98c0 */ { 0, 0, 0, 0, 0 },
/* U+98c1 */ { 0, 0, 0, 0, 0 },
/* U+98c2 */ { 0, 0, 0, 0, 0 },
/* U+98c3 */ { 0, 0, 0, 0, 0 },
/* U+98c4 */ { 0, 0, 0, 0, 0 },
/* U+98c5 */ { 0, 0, 0, 0, 0 },
/* U+98c6 */ { 0, 0, 0, 0, 0 },
/* U+98c7 */ { 0, 0, 0, 0, 0 },
/* U+98c8 */ { 0, 0, 0, 0, 0 },
/* U+98c9 */ { 0, 0, 0, 0, 0 },
/* U+98ca */ { 0, 0, 0, 0, 0 },
/* U+98cb */ { 0, 0, 0, 0, 0 },
/* U+98cc */ { 0, 0, 0, 0, 0 },
/* U+98cd */ { 0, 0, 0, 0, 0 },
/* U+98ce */ { 0, 0, 0, 0, 0 },
/* U+98cf */ { 0, 0, 0, 0, 0 },
/* U+98d0 */ { 0, 0, 0, 0, 0 },
/* U+98d1 */ { 0, 0, 0, 0, 0 },
/* U+98d2 */ { 0, 0, 0, 0, 0 },
/* U+98d3 */ { 0, 0, 0, 0, 0 },
/* U+98d4 */ { 0, 0, 0, 0, 0 },
/* U+98d5 */ { 0, 0, 0, 0, 0 },
/* U+98d6 */ { 0, 0, 0, 0, 0 },
/* U+98d7 */ { 0, 0, 0, 0, 0 },
/* U+98d8 */ { 0, 0, 0, 0, 0 },
/* U+98d9 */ { 0, 0, 0, 0, 0 },
/* U+98da */ { 0, 0, 0, 0, 0 },
/* U+98db */ { 0, 0, 0, 0, 0 },
/* U+98dc */ { 0, 0, 0, 0, 0 },
/* U+98dd */ { 0, 0, 0, 0, 0 },
/* U+98de */ { 0, 0, 0, 0, 0 },
/* U+98df */ { 0, 0, 0, 0, 0 },
/* U+98e0 */ { 0, 0, 0, 0, 0 },
/* U+98e1 */ { 0, 0, 0, 0, 0 },
/* U+98e2 */ { 0, 0, 0, 0, 0 },
/* U+98e3 */ { 0, 0, 0, 0, 0 },
/* U+98e4 */ { 0, 0, 0, 0, 0 },
/* U+98e5 */ { 0, 0, 0, 0, 0 },
/* U+98e6 */ { 0, 0, 0, 0, 0 },
/* U+98e7 */ { 0, 0, 0, 0, 0 },
/* U+98e8 */ { 0, 0, 0, 0, 0 },
/* U+98e9 */ { 0, 0, 0, 0, 0 },
/* U+98ea */ { 0, 0, 0, 0, 0 },
/* U+98eb */ { 0, 0, 0, 0, 0 },
/* U+98ec */ { 0, 0, 0, 0, 0 },
/* U+98ed */ { 0, 0, 0, 0, 0 },
/* U+98ee */ { 0, 0, 0, 0, 0 },
/* U+98ef */ { 0, 0, 0, 0, 0 },
/* U+98f0 */ { 0, 0, 0, 0, 0 },
/* U+98f1 */ { 0, 0, 0, 0, 0 },
/* U+98f2 */ { 0, 0, 0, 0, 0 },
/* U+98f3 */ { 0, 0, 0, 0, 0 },
/* U+98f4 */ { 0, 0, 0, 0, 0 },
/* U+98f5 */ { 0, 0, 0, 0, 0 },
/* U+98f6 */ { 0, 0, 0, 0, 0 },
/* U+98f7 */ { 0, 0, 0, 0, 0 },
/* U+98f8 */ { 0, 0, 0, 0, 0 },
/* U+98f9 */ { 0, 0, 0, 0, 0 },
/* U+98fa */ { 0, 0, 0, 0, 0 },
/* U+98fb */ { 0, 0, 0, 0, 0 },
/* U+98fc */ { 0, 0, 0, 0, 0 },
/* U+98fd */ { 0, 0, 0, 0, 0 },
/* U+98fe */ { 0, 0, 0, 0, 0 },
/* U+98ff */ { 0, 0, 0, 0, 0 },
/* U+9900 */ { 0, 0, 0, 0, 0 },
/* U+9901 */ { 0, 0, 0, 0, 0 },
/* U+9902 */ { 0, 0, 0, 0, 0 },
/* U+9903 */ { 0, 0, 0, 0, 0 },
/* U+9904 */ { 0, 0, 0, 0, 0 },
/* U+9905 */ { 0, 0, 0, 0, 0 },
/* U+9906 */ { 0, 0, 0, 0, 0 },
/* U+9907 */ { 0, 0, 0, 0, 0 },
/* U+9908 */ { 0, 0, 0, 0, 0 },
/* U+9909 */ { 0, 0, 0, 0, 0 },
/* U+990a */ { 0, 0, 0, 0, 0 },
/* U+990b */ { 0, 0, 0, 0, 0 },
/* U+990c */ { 0, 0, 0, 0, 0 },
/* U+990d */ { 0, 0, 0, 0, 0 },
/* U+990e */ { 0, 0, 0, 0, 0 },
/* U+990f */ { 0, 0, 0, 0, 0 },
/* U+9910 */ { 0, 0, 0, 0, 0 },
/* U+9911 */ { 0, 0, 0, 0, 0 },
/* U+9912 */ { 0, 0, 0, 0, 0 },
/* U+9913 */ { 0, 0, 0, 0, 0 },
/* U+9914 */ { 0, 0, 0, 0, 0 },
/* U+9915 */ { 0, 0, 0, 0, 0 },
/* U+9916 */ { 0, 0, 0, 0, 0 },
/* U+9917 */ { 0, 0, 0, 0, 0 },
/* U+9918 */ { 0, 0, 0, 0, 0 },
/* U+9919 */ { 0, 0, 0, 0, 0 },
/* U+991a */ { 0, 0, 0, 0, 0 },
/* U+991b */ { 0, 0, 0, 0, 0 },
/* U+991c */ { 0, 0, 0, 0, 0 },
/* U+991d */ { 0, 0, 0, 0, 0 },
/* U+991e */ { 0, 0, 0, 0, 0 },
/* U+991f */ { 0, 0, 0, 0, 0 },
/* U+9920 */ { 0, 0, 0, 0, 0 },
/* U+9921 */ { 0, 0, 0, 0, 0 },
/* U+9922 */ { 0, 0, 0, 0, 0 },
/* U+9923 */ { 0, 0, 0, 0, 0 },
/* U+9924 */ { 0, 0, 0, 0, 0 },
/* U+9925 */ { 0, 0, 0, 0, 0 },
/* U+9926 */ { 0, 0, 0, 0, 0 },
/* U+9927 */ { 0, 0, 0, 0, 0 },
/* U+9928 */ { 0, 0, 0, 0, 0 },
/* U+9929 */ { 0, 0, 0, 0, 0 },
/* U+992a */ { 0, 0, 0, 0, 0 },
/* U+992b */ { 0, 0, 0, 0, 0 },
/* U+992c */ { 0, 0, 0, 0, 0 },
/* U+992d */ { 0, 0, 0, 0, 0 },
/* U+992e */ { 0, 0, 0, 0, 0 },
/* U+992f */ { 0, 0, 0, 0, 0 },
/* U+9930 */ { 0, 0, 0, 0, 0 },
/* U+9931 */ { 0, 0, 0, 0, 0 },
/* U+9932 */ { 0, 0, 0, 0, 0 },
/* U+9933 */ { 0, 0, 0, 0, 0 },
/* U+9934 */ { 0, 0, 0, 0, 0 },
/* U+9935 */ { 0, 0, 0, 0, 0 },
/* U+9936 */ { 0, 0, 0, 0, 0 },
/* U+9937 */ { 0, 0, 0, 0, 0 },
/* U+9938 */ { 0, 0, 0, 0, 0 },
/* U+9939 */ { 0, 0, 0, 0, 0 },
/* U+993a */ { 0, 0, 0, 0, 0 },
/* U+993b */ { 0, 0, 0, 0, 0 },
/* U+993c */ { 0, 0, 0, 0, 0 },
/* U+993d */ { 0, 0, 0, 0, 0 },
/* U+993e */ { 0, 0, 0, 0, 0 },
/* U+993f */ { 0, 0, 0, 0, 0 },
/* U+9940 */ { 0, 0, 0, 0, 0 },
/* U+9941 */ { 0, 0, 0, 0, 0 },
/* U+9942 */ { 0, 0, 0, 0, 0 },
/* U+9943 */ { 0, 0, 0, 0, 0 },
/* U+9944 */ { 0, 0, 0, 0, 0 },
/* U+9945 */ { 0, 0, 0, 0, 0 },
/* U+9946 */ { 0, 0, 0, 0, 0 },
/* U+9947 */ { 0, 0, 0, 0, 0 },
/* U+9948 */ { 0, 0, 0, 0, 0 },
/* U+9949 */ { 0, 0, 0, 0, 0 },
/* U+994a */ { 0, 0, 0, 0, 0 },
/* U+994b */ { 0, 0, 0, 0, 0 },
/* U+994c */ { 0, 0, 0, 0, 0 },
/* U+994d */ { 0, 0, 0, 0, 0 },
/* U+994e */ { 0, 0, 0, 0, 0 },
/* U+994f */ { 0, 0, 0, 0, 0 },
/* U+9950 */ { 0, 0, 0, 0, 0 },
/* U+9951 */ { 0, 0, 0, 0, 0 },
/* U+9952 */ { 0, 0, 0, 0, 0 },
/* U+9953 */ { 0, 0, 0, 0, 0 },
/* U+9954 */ { 0, 0, 0, 0, 0 },
/* U+9955 */ { 0, 0, 0, 0, 0 },
/* U+9956 */ { 0, 0, 0, 0, 0 },
/* U+9957 */ { 0, 0, 0, 0, 0 },
/* U+9958 */ { 0, 0, 0, 0, 0 },
/* U+9959 */ { 0, 0, 0, 0, 0 },
/* U+995a */ { 0, 0, 0, 0, 0 },
/* U+995b */ { 0, 0, 0, 0, 0 },
/* U+995c */ { 0, 0, 0, 0, 0 },
/* U+995d */ { 0, 0, 0, 0, 0 },
/* U+995e */ { 0, 0, 0, 0, 0 },
/* U+995f */ { 0, 0, 0, 0, 0 },
/* U+9960 */ { 0, 0, 0, 0, 0 },
/* U+9961 */ { 0, 0, 0, 0, 0 },
/* U+9962 */ { 0, 0, 0, 0, 0 },
/* U+9963 */ { 0, 0, 0, 0, 0 },
/* U+9964 */ { 0, 0, 0, 0, 0 },
/* U+9965 */ { 0, 0, 0, 0, 0 },
/* U+9966 */ { 0, 0, 0, 0, 0 },
/* U+9967 */ { 0, 0, 0, 0, 0 },
/* U+9968 */ { 0, 0, 0, 0, 0 },
/* U+9969 */ { 0, 0, 0, 0, 0 },
/* U+996a */ { 0, 0, 0, 0, 0 },
/* U+996b */ { 0, 0, 0, 0, 0 },
/* U+996c */ { 0, 0, 0, 0, 0 },
/* U+996d */ { 0, 0, 0, 0, 0 },
/* U+996e */ { 0, 0, 0, 0, 0 },
/* U+996f */ { 0, 0, 0, 0, 0 },
/* U+9970 */ { 0, 0, 0, 0, 0 },
/* U+9971 */ { 0, 0, 0, 0, 0 },
/* U+9972 */ { 0, 0, 0, 0, 0 },
/* U+9973 */ { 0, 0, 0, 0, 0 },
/* U+9974 */ { 0, 0, 0, 0, 0 },
/* U+9975 */ { 0, 0, 0, 0, 0 },
/* U+9976 */ { 0, 0, 0, 0, 0 },
/* U+9977 */ { 0, 0, 0, 0, 0 },
/* U+9978 */ { 0, 0, 0, 0, 0 },
/* U+9979 */ { 0, 0, 0, 0, 0 },
/* U+997a */ { 0, 0, 0, 0, 0 },
/* U+997b */ { 0, 0, 0, 0, 0 },
/* U+997c */ { 0, 0, 0, 0, 0 },
/* U+997d */ { 0, 0, 0, 0, 0 },
/* U+997e */ { 0, 0, 0, 0, 0 },
/* U+997f */ { 0, 0, 0, 0, 0 },
/* U+9980 */ { 0, 0, 0, 0, 0 },
/* U+9981 */ { 0, 0, 0, 0, 0 },
/* U+9982 */ { 0, 0, 0, 0, 0 },
/* U+9983 */ { 0, 0, 0, 0, 0 },
/* U+9984 */ { 0, 0, 0, 0, 0 },
/* U+9985 */ { 0, 0, 0, 0, 0 },
/* U+9986 */ { 0, 0, 0, 0, 0 },
/* U+9987 */ { 0, 0, 0, 0, 0 },
/* U+9988 */ { 0, 0, 0, 0, 0 },
/* U+9989 */ { 0, 0, 0, 0, 0 },
/* U+998a */ { 0, 0, 0, 0, 0 },
/* U+998b */ { 0, 0, 0, 0, 0 },
/* U+998c */ { 0, 0, 0, 0, 0 },
/* U+998d */ { 0, 0, 0, 0, 0 },
/* U+998e */ { 0, 0, 0, 0, 0 },
/* U+998f */ { 0, 0, 0, 0, 0 },
/* U+9990 */ { 0, 0, 0, 0, 0 },
/* U+9991 */ { 0, 0, 0, 0, 0 },
/* U+9992 */ { 0, 0, 0, 0, 0 },
/* U+9993 */ { 0, 0, 0, 0, 0 },
/* U+9994 */ { 0, 0, 0, 0, 0 },
/* U+9995 */ { 0, 0, 0, 0, 0 },
/* U+9996 */ { 0, 0, 0, 0, 0 },
/* U+9997 */ { 0, 0, 0, 0, 0 },
/* U+9998 */ { 0, 0, 0, 0, 0 },
/* U+9999 */ { 0, 0, 0, 0, 0 },
/* U+999a */ { 0, 0, 0, 0, 0 },
/* U+999b */ { 0, 0, 0, 0, 0 },
/* U+999c */ { 0, 0, 0, 0, 0 },
/* U+999d */ { 0, 0, 0, 0, 0 },
/* U+999e */ { 0, 0, 0, 0, 0 },
/* U+999f */ { 0, 0, 0, 0, 0 },
/* U+99a0 */ { 0, 0, 0, 0, 0 },
/* U+99a1 */ { 0, 0, 0, 0, 0 },
/* U+99a2 */ { 0, 0, 0, 0, 0 },
/* U+99a3 */ { 0, 0, 0, 0, 0 },
/* U+99a4 */ { 0, 0, 0, 0, 0 },
/* U+99a5 */ { 0, 0, 0, 0, 0 },
/* U+99a6 */ { 0, 0, 0, 0, 0 },
/* U+99a7 */ { 0, 0, 0, 0, 0 },
/* U+99a8 */ { 0, 0, 0, 0, 0 },
/* U+99a9 */ { 0, 0, 0, 0, 0 },
/* U+99aa */ { 0, 0, 0, 0, 0 },
/* U+99ab */ { 0, 0, 0, 0, 0 },
/* U+99ac */ { 0, 0, 0, 0, 0 },
/* U+99ad */ { 0, 0, 0, 0, 0 },
/* U+99ae */ { 0, 0, 0, 0, 0 },
/* U+99af */ { 0, 0, 0, 0, 0 },
/* U+99b0 */ { 0, 0, 0, 0, 0 },
/* U+99b1 */ { 0, 0, 0, 0, 0 },
/* U+99b2 */ { 0, 0, 0, 0, 0 },
/* U+99b3 */ { 0, 0, 0, 0, 0 },
/* U+99b4 */ { 0, 0, 0, 0, 0 },
/* U+99b5 */ { 0, 0, 0, 0, 0 },
/* U+99b6 */ { 0, 0, 0, 0, 0 },
/* U+99b7 */ { 0, 0, 0, 0, 0 },
/* U+99b8 */ { 0, 0, 0, 0, 0 },
/* U+99b9 */ { 0, 0, 0, 0, 0 },
/* U+99ba */ { 0, 0, 0, 0, 0 },
/* U+99bb */ { 0, 0, 0, 0, 0 },
/* U+99bc */ { 0, 0, 0, 0, 0 },
/* U+99bd */ { 0, 0, 0, 0, 0 },
/* U+99be */ { 0, 0, 0, 0, 0 },
/* U+99bf */ { 0, 0, 0, 0, 0 },
/* U+99c0 */ { 0, 0, 0, 0, 0 },
/* U+99c1 */ { 0, 0, 0, 0, 0 },
/* U+99c2 */ { 0, 0, 0, 0, 0 },
/* U+99c3 */ { 0, 0, 0, 0, 0 },
/* U+99c4 */ { 0, 0, 0, 0, 0 },
/* U+99c5 */ { 0, 0, 0, 0, 0 },
/* U+99c6 */ { 0, 0, 0, 0, 0 },
/* U+99c7 */ { 0, 0, 0, 0, 0 },
/* U+99c8 */ { 0, 0, 0, 0, 0 },
/* U+99c9 */ { 0, 0, 0, 0, 0 },
/* U+99ca */ { 0, 0, 0, 0, 0 },
/* U+99cb */ { 0, 0, 0, 0, 0 },
/* U+99cc */ { 0, 0, 0, 0, 0 },
/* U+99cd */ { 0, 0, 0, 0, 0 },
/* U+99ce */ { 0, 0, 0, 0, 0 },
/* U+99cf */ { 0, 0, 0, 0, 0 },
/* U+99d0 */ { 0, 0, 0, 0, 0 },
/* U+99d1 */ { 0, 0, 0, 0, 0 },
/* U+99d2 */ { 0, 0, 0, 0, 0 },
/* U+99d3 */ { 0, 0, 0, 0, 0 },
/* U+99d4 */ { 0, 0, 0, 0, 0 },
/* U+99d5 */ { 0, 0, 0, 0, 0 },
/* U+99d6 */ { 0, 0, 0, 0, 0 },
/* U+99d7 */ { 0, 0, 0, 0, 0 },
/* U+99d8 */ { 0, 0, 0, 0, 0 },
/* U+99d9 */ { 0, 0, 0, 0, 0 },
/* U+99da */ { 0, 0, 0, 0, 0 },
/* U+99db */ { 0, 0, 0, 0, 0 },
/* U+99dc */ { 0, 0, 0, 0, 0 },
/* U+99dd */ { 0, 0, 0, 0, 0 },
/* U+99de */ { 0, 0, 0, 0, 0 },
/* U+99df */ { 0, 0, 0, 0, 0 },
/* U+99e0 */ { 0, 0, 0, 0, 0 },
/* U+99e1 */ { 0, 0, 0, 0, 0 },
/* U+99e2 */ { 0, 0, 0, 0, 0 },
/* U+99e3 */ { 0, 0, 0, 0, 0 },
/* U+99e4 */ { 0, 0, 0, 0, 0 },
/* U+99e5 */ { 0, 0, 0, 0, 0 },
/* U+99e6 */ { 0, 0, 0, 0, 0 },
/* U+99e7 */ { 0, 0, 0, 0, 0 },
/* U+99e8 */ { 0, 0, 0, 0, 0 },
/* U+99e9 */ { 0, 0, 0, 0, 0 },
/* U+99ea */ { 0, 0, 0, 0, 0 },
/* U+99eb */ { 0, 0, 0, 0, 0 },
/* U+99ec */ { 0, 0, 0, 0, 0 },
/* U+99ed */ { 0, 0, 0, 0, 0 },
/* U+99ee */ { 0, 0, 0, 0, 0 },
/* U+99ef */ { 0, 0, 0, 0, 0 },
/* U+99f0 */ { 0, 0, 0, 0, 0 },
/* U+99f1 */ { 0, 0, 0, 0, 0 },
/* U+99f2 */ { 0, 0, 0, 0, 0 },
/* U+99f3 */ { 0, 0, 0, 0, 0 },
/* U+99f4 */ { 0, 0, 0, 0, 0 },
/* U+99f5 */ { 0, 0, 0, 0, 0 },
/* U+99f6 */ { 0, 0, 0, 0, 0 },
/* U+99f7 */ { 0, 0, 0, 0, 0 },
/* U+99f8 */ { 0, 0, 0, 0, 0 },
/* U+99f9 */ { 0, 0, 0, 0, 0 },
/* U+99fa */ { 0, 0, 0, 0, 0 },
/* U+99fb */ { 0, 0, 0, 0, 0 },
/* U+99fc */ { 0, 0, 0, 0, 0 },
/* U+99fd */ { 0, 0, 0, 0, 0 },
/* U+99fe */ { 0, 0, 0, 0, 0 },
/* U+99ff */ { 0, 0, 0, 0, 0 },
/* U+9a00 */ { 0, 0, 0, 0, 0 },
/* U+9a01 */ { 0, 0, 0, 0, 0 },
/* U+9a02 */ { 0, 0, 0, 0, 0 },
/* U+9a03 */ { 0, 0, 0, 0, 0 },
/* U+9a04 */ { 0, 0, 0, 0, 0 },
/* U+9a05 */ { 0, 0, 0, 0, 0 },
/* U+9a06 */ { 0, 0, 0, 0, 0 },
/* U+9a07 */ { 0, 0, 0, 0, 0 },
/* U+9a08 */ { 0, 0, 0, 0, 0 },
/* U+9a09 */ { 0, 0, 0, 0, 0 },
/* U+9a0a */ { 0, 0, 0, 0, 0 },
/* U+9a0b */ { 0, 0, 0, 0, 0 },
/* U+9a0c */ { 0, 0, 0, 0, 0 },
/* U+9a0d */ { 0, 0, 0, 0, 0 },
/* U+9a0e */ { 0, 0, 0, 0, 0 },
/* U+9a0f */ { 0, 0, 0, 0, 0 },
/* U+9a10 */ { 0, 0, 0, 0, 0 },
/* U+9a11 */ { 0, 0, 0, 0, 0 },
/* U+9a12 */ { 0, 0, 0, 0, 0 },
/* U+9a13 */ { 0, 0, 0, 0, 0 },
/* U+9a14 */ { 0, 0, 0, 0, 0 },
/* U+9a15 */ { 0, 0, 0, 0, 0 },
/* U+9a16 */ { 0, 0, 0, 0, 0 },
/* U+9a17 */ { 0, 0, 0, 0, 0 },
/* U+9a18 */ { 0, 0, 0, 0, 0 },
/* U+9a19 */ { 0, 0, 0, 0, 0 },
/* U+9a1a */ { 0, 0, 0, 0, 0 },
/* U+9a1b */ { 0, 0, 0, 0, 0 },
/* U+9a1c */ { 0, 0, 0, 0, 0 },
/* U+9a1d */ { 0, 0, 0, 0, 0 },
/* U+9a1e */ { 0, 0, 0, 0, 0 },
/* U+9a1f */ { 0, 0, 0, 0, 0 },
/* U+9a20 */ { 0, 0, 0, 0, 0 },
/* U+9a21 */ { 0, 0, 0, 0, 0 },
/* U+9a22 */ { 0, 0, 0, 0, 0 },
/* U+9a23 */ { 0, 0, 0, 0, 0 },
/* U+9a24 */ { 0, 0, 0, 0, 0 },
/* U+9a25 */ { 0, 0, 0, 0, 0 },
/* U+9a26 */ { 0, 0, 0, 0, 0 },
/* U+9a27 */ { 0, 0, 0, 0, 0 },
/* U+9a28 */ { 0, 0, 0, 0, 0 },
/* U+9a29 */ { 0, 0, 0, 0, 0 },
/* U+9a2a */ { 0, 0, 0, 0, 0 },
/* U+9a2b */ { 0, 0, 0, 0, 0 },
/* U+9a2c */ { 0, 0, 0, 0, 0 },
/* U+9a2d */ { 0, 0, 0, 0, 0 },
/* U+9a2e */ { 0, 0, 0, 0, 0 },
/* U+9a2f */ { 0, 0, 0, 0, 0 },
/* U+9a30 */ { 0, 0, 0, 0, 0 },
/* U+9a31 */ { 0, 0, 0, 0, 0 },
/* U+9a32 */ { 0, 0, 0, 0, 0 },
/* U+9a33 */ { 0, 0, 0, 0, 0 },
/* U+9a34 */ { 0, 0, 0, 0, 0 },
/* U+9a35 */ { 0, 0, 0, 0, 0 },
/* U+9a36 */ { 0, 0, 0, 0, 0 },
/* U+9a37 */ { 0, 0, 0, 0, 0 },
/* U+9a38 */ { 0, 0, 0, 0, 0 },
/* U+9a39 */ { 0, 0, 0, 0, 0 },
/* U+9a3a */ { 0, 0, 0, 0, 0 },
/* U+9a3b */ { 0, 0, 0, 0, 0 },
/* U+9a3c */ { 0, 0, 0, 0, 0 },
/* U+9a3d */ { 0, 0, 0, 0, 0 },
/* U+9a3e */ { 0, 0, 0, 0, 0 },
/* U+9a3f */ { 0, 0, 0, 0, 0 },
/* U+9a40 */ { 0, 0, 0, 0, 0 },
/* U+9a41 */ { 0, 0, 0, 0, 0 },
/* U+9a42 */ { 0, 0, 0, 0, 0 },
/* U+9a43 */ { 0, 0, 0, 0, 0 },
/* U+9a44 */ { 0, 0, 0, 0, 0 },
/* U+9a45 */ { 0, 0, 0, 0, 0 },
/* U+9a46 */ { 0, 0, 0, 0, 0 },
/* U+9a47 */ { 0, 0, 0, 0, 0 },
/* U+9a48 */ { 0, 0, 0, 0, 0 },
/* U+9a49 */ { 0, 0, 0, 0, 0 },
/* U+9a4a */ { 0, 0, 0, 0, 0 },
/* U+9a4b */ { 0, 0, 0, 0, 0 },
/* U+9a4c */ { 0, 0, 0, 0, 0 },
/* U+9a4d */ { 0, 0, 0, 0, 0 },
/* U+9a4e */ { 0, 0, 0, 0, 0 },
/* U+9a4f */ { 0, 0, 0, 0, 0 },
/* U+9a50 */ { 0, 0, 0, 0, 0 },
/* U+9a51 */ { 0, 0, 0, 0, 0 },
/* U+9a52 */ { 0, 0, 0, 0, 0 },
/* U+9a53 */ { 0, 0, 0, 0, 0 },
/* U+9a54 */ { 0, 0, 0, 0, 0 },
/* U+9a55 */ { 0, 0, 0, 0, 0 },
/* U+9a56 */ { 0, 0, 0, 0, 0 },
/* U+9a57 */ { 0, 0, 0, 0, 0 },
/* U+9a58 */ { 0, 0, 0, 0, 0 },
/* U+9a59 */ { 0, 0, 0, 0, 0 },
/* U+9a5a */ { 0, 0, 0, 0, 0 },
/* U+9a5b */ { 0, 0, 0, 0, 0 },
/* U+9a5c */ { 0, 0, 0, 0, 0 },
/* U+9a5d */ { 0, 0, 0, 0, 0 },
/* U+9a5e */ { 0, 0, 0, 0, 0 },
/* U+9a5f */ { 0, 0, 0, 0, 0 },
/* U+9a60 */ { 0, 0, 0, 0, 0 },
/* U+9a61 */ { 0, 0, 0, 0, 0 },
/* U+9a62 */ { 0, 0, 0, 0, 0 },
/* U+9a63 */ { 0, 0, 0, 0, 0 },
/* U+9a64 */ { 0, 0, 0, 0, 0 },
/* U+9a65 */ { 0, 0, 0, 0, 0 },
/* U+9a66 */ { 0, 0, 0, 0, 0 },
/* U+9a67 */ { 0, 0, 0, 0, 0 },
/* U+9a68 */ { 0, 0, 0, 0, 0 },
/* U+9a69 */ { 0, 0, 0, 0, 0 },
/* U+9a6a */ { 0, 0, 0, 0, 0 },
/* U+9a6b */ { 0, 0, 0, 0, 0 },
/* U+9a6c */ { 0, 0, 0, 0, 0 },
/* U+9a6d */ { 0, 0, 0, 0, 0 },
/* U+9a6e */ { 0, 0, 0, 0, 0 },
/* U+9a6f */ { 0, 0, 0, 0, 0 },
/* U+9a70 */ { 0, 0, 0, 0, 0 },
/* U+9a71 */ { 0, 0, 0, 0, 0 },
/* U+9a72 */ { 0, 0, 0, 0, 0 },
/* U+9a73 */ { 0, 0, 0, 0, 0 },
/* U+9a74 */ { 0, 0, 0, 0, 0 },
/* U+9a75 */ { 0, 0, 0, 0, 0 },
/* U+9a76 */ { 0, 0, 0, 0, 0 },
/* U+9a77 */ { 0, 0, 0, 0, 0 },
/* U+9a78 */ { 0, 0, 0, 0, 0 },
/* U+9a79 */ { 0, 0, 0, 0, 0 },
/* U+9a7a */ { 0, 0, 0, 0, 0 },
/* U+9a7b */ { 0, 0, 0, 0, 0 },
/* U+9a7c */ { 0, 0, 0, 0, 0 },
/* U+9a7d */ { 0, 0, 0, 0, 0 },
/* U+9a7e */ { 0, 0, 0, 0, 0 },
/* U+9a7f */ { 0, 0, 0, 0, 0 },
/* U+9a80 */ { 0, 0, 0, 0, 0 },
/* U+9a81 */ { 0, 0, 0, 0, 0 },
/* U+9a82 */ { 0, 0, 0, 0, 0 },
/* U+9a83 */ { 0, 0, 0, 0, 0 },
/* U+9a84 */ { 0, 0, 0, 0, 0 },
/* U+9a85 */ { 0, 0, 0, 0, 0 },
/* U+9a86 */ { 0, 0, 0, 0, 0 },
/* U+9a87 */ { 0, 0, 0, 0, 0 },
/* U+9a88 */ { 0, 0, 0, 0, 0 },
/* U+9a89 */ { 0, 0, 0, 0, 0 },
/* U+9a8a */ { 0, 0, 0, 0, 0 },
/* U+9a8b */ { 0, 0, 0, 0, 0 },
/* U+9a8c */ { 0, 0, 0, 0, 0 },
/* U+9a8d */ { 0, 0, 0, 0, 0 },
/* U+9a8e */ { 0, 0, 0, 0, 0 },
/* U+9a8f */ { 0, 0, 0, 0, 0 },
/* U+9a90 */ { 0, 0, 0, 0, 0 },
/* U+9a91 */ { 0, 0, 0, 0, 0 },
/* U+9a92 */ { 0, 0, 0, 0, 0 },
/* U+9a93 */ { 0, 0, 0, 0, 0 },
/* U+9a94 */ { 0, 0, 0, 0, 0 },
/* U+9a95 */ { 0, 0, 0, 0, 0 },
/* U+9a96 */ { 0, 0, 0, 0, 0 },
/* U+9a97 */ { 0, 0, 0, 0, 0 },
/* U+9a98 */ { 0, 0, 0, 0, 0 },
/* U+9a99 */ { 0, 0, 0, 0, 0 },
/* U+9a9a */ { 0, 0, 0, 0, 0 },
/* U+9a9b */ { 0, 0, 0, 0, 0 },
/* U+9a9c */ { 0, 0, 0, 0, 0 },
/* U+9a9d */ { 0, 0, 0, 0, 0 },
/* U+9a9e */ { 0, 0, 0, 0, 0 },
/* U+9a9f */ { 0, 0, 0, 0, 0 },
/* U+9aa0 */ { 0, 0, 0, 0, 0 },
/* U+9aa1 */ { 0, 0, 0, 0, 0 },
/* U+9aa2 */ { 0, 0, 0, 0, 0 },
/* U+9aa3 */ { 0, 0, 0, 0, 0 },
/* U+9aa4 */ { 0, 0, 0, 0, 0 },
/* U+9aa5 */ { 0, 0, 0, 0, 0 },
/* U+9aa6 */ { 0, 0, 0, 0, 0 },
/* U+9aa7 */ { 0, 0, 0, 0, 0 },
/* U+9aa8 */ { 0, 0, 0, 0, 0 },
/* U+9aa9 */ { 0, 0, 0, 0, 0 },
/* U+9aaa */ { 0, 0, 0, 0, 0 },
/* U+9aab */ { 0, 0, 0, 0, 0 },
/* U+9aac */ { 0, 0, 0, 0, 0 },
/* U+9aad */ { 0, 0, 0, 0, 0 },
/* U+9aae */ { 0, 0, 0, 0, 0 },
/* U+9aaf */ { 0, 0, 0, 0, 0 },
/* U+9ab0 */ { 0, 0, 0, 0, 0 },
/* U+9ab1 */ { 0, 0, 0, 0, 0 },
/* U+9ab2 */ { 0, 0, 0, 0, 0 },
/* U+9ab3 */ { 0, 0, 0, 0, 0 },
/* U+9ab4 */ { 0, 0, 0, 0, 0 },
/* U+9ab5 */ { 0, 0, 0, 0, 0 },
/* U+9ab6 */ { 0, 0, 0, 0, 0 },
/* U+9ab7 */ { 0, 0, 0, 0, 0 },
/* U+9ab8 */ { 0, 0, 0, 0, 0 },
/* U+9ab9 */ { 0, 0, 0, 0, 0 },
/* U+9aba */ { 0, 0, 0, 0, 0 },
/* U+9abb */ { 0, 0, 0, 0, 0 },
/* U+9abc */ { 0, 0, 0, 0, 0 },
/* U+9abd */ { 0, 0, 0, 0, 0 },
/* U+9abe */ { 0, 0, 0, 0, 0 },
/* U+9abf */ { 0, 0, 0, 0, 0 },
/* U+9ac0 */ { 0, 0, 0, 0, 0 },
/* U+9ac1 */ { 0, 0, 0, 0, 0 },
/* U+9ac2 */ { 0, 0, 0, 0, 0 },
/* U+9ac3 */ { 0, 0, 0, 0, 0 },
/* U+9ac4 */ { 0, 0, 0, 0, 0 },
/* U+9ac5 */ { 0, 0, 0, 0, 0 },
/* U+9ac6 */ { 0, 0, 0, 0, 0 },
/* U+9ac7 */ { 0, 0, 0, 0, 0 },
/* U+9ac8 */ { 0, 0, 0, 0, 0 },
/* U+9ac9 */ { 0, 0, 0, 0, 0 },
/* U+9aca */ { 0, 0, 0, 0, 0 },
/* U+9acb */ { 0, 0, 0, 0, 0 },
/* U+9acc */ { 0, 0, 0, 0, 0 },
/* U+9acd */ { 0, 0, 0, 0, 0 },
/* U+9ace */ { 0, 0, 0, 0, 0 },
/* U+9acf */ { 0, 0, 0, 0, 0 },
/* U+9ad0 */ { 0, 0, 0, 0, 0 },
/* U+9ad1 */ { 0, 0, 0, 0, 0 },
/* U+9ad2 */ { 0, 0, 0, 0, 0 },
/* U+9ad3 */ { 0, 0, 0, 0, 0 },
/* U+9ad4 */ { 0, 0, 0, 0, 0 },
/* U+9ad5 */ { 0, 0, 0, 0, 0 },
/* U+9ad6 */ { 0, 0, 0, 0, 0 },
/* U+9ad7 */ { 0, 0, 0, 0, 0 },
/* U+9ad8 */ { 0, 0, 0, 0, 0 },
/* U+9ad9 */ { 0, 0, 0, 0, 0 },
/* U+9ada */ { 0, 0, 0, 0, 0 },
/* U+9adb */ { 0, 0, 0, 0, 0 },
/* U+9adc */ { 0, 0, 0, 0, 0 },
/* U+9add */ { 0, 0, 0, 0, 0 },
/* U+9ade */ { 0, 0, 0, 0, 0 },
/* U+9adf */ { 0, 0, 0, 0, 0 },
/* U+9ae0 */ { 0, 0, 0, 0, 0 },
/* U+9ae1 */ { 0, 0, 0, 0, 0 },
/* U+9ae2 */ { 0, 0, 0, 0, 0 },
/* U+9ae3 */ { 0, 0, 0, 0, 0 },
/* U+9ae4 */ { 0, 0, 0, 0, 0 },
/* U+9ae5 */ { 0, 0, 0, 0, 0 },
/* U+9ae6 */ { 0, 0, 0, 0, 0 },
/* U+9ae7 */ { 0, 0, 0, 0, 0 },
/* U+9ae8 */ { 0, 0, 0, 0, 0 },
/* U+9ae9 */ { 0, 0, 0, 0, 0 },
/* U+9aea */ { 0, 0, 0, 0, 0 },
/* U+9aeb */ { 0, 0, 0, 0, 0 },
/* U+9aec */ { 0, 0, 0, 0, 0 },
/* U+9aed */ { 0, 0, 0, 0, 0 },
/* U+9aee */ { 0, 0, 0, 0, 0 },
/* U+9aef */ { 0, 0, 0, 0, 0 },
/* U+9af0 */ { 0, 0, 0, 0, 0 },
/* U+9af1 */ { 0, 0, 0, 0, 0 },
/* U+9af2 */ { 0, 0, 0, 0, 0 },
/* U+9af3 */ { 0, 0, 0, 0, 0 },
/* U+9af4 */ { 0, 0, 0, 0, 0 },
/* U+9af5 */ { 0, 0, 0, 0, 0 },
/* U+9af6 */ { 0, 0, 0, 0, 0 },
/* U+9af7 */ { 0, 0, 0, 0, 0 },
/* U+9af8 */ { 0, 0, 0, 0, 0 },
/* U+9af9 */ { 0, 0, 0, 0, 0 },
/* U+9afa */ { 0, 0, 0, 0, 0 },
/* U+9afb */ { 0, 0, 0, 0, 0 },
/* U+9afc */ { 0, 0, 0, 0, 0 },
/* U+9afd */ { 0, 0, 0, 0, 0 },
/* U+9afe */ { 0, 0, 0, 0, 0 },
/* U+9aff */ { 0, 0, 0, 0, 0 },
/* U+9b00 */ { 0, 0, 0, 0, 0 },
/* U+9b01 */ { 0, 0, 0, 0, 0 },
/* U+9b02 */ { 0, 0, 0, 0, 0 },
/* U+9b03 */ { 0, 0, 0, 0, 0 },
/* U+9b04 */ { 0, 0, 0, 0, 0 },
/* U+9b05 */ { 0, 0, 0, 0, 0 },
/* U+9b06 */ { 0, 0, 0, 0, 0 },
/* U+9b07 */ { 0, 0, 0, 0, 0 },
/* U+9b08 */ { 0, 0, 0, 0, 0 },
/* U+9b09 */ { 0, 0, 0, 0, 0 },
/* U+9b0a */ { 0, 0, 0, 0, 0 },
/* U+9b0b */ { 0, 0, 0, 0, 0 },
/* U+9b0c */ { 0, 0, 0, 0, 0 },
/* U+9b0d */ { 0, 0, 0, 0, 0 },
/* U+9b0e */ { 0, 0, 0, 0, 0 },
/* U+9b0f */ { 0, 0, 0, 0, 0 },
/* U+9b10 */ { 0, 0, 0, 0, 0 },
/* U+9b11 */ { 0, 0, 0, 0, 0 },
/* U+9b12 */ { 0, 0, 0, 0, 0 },
/* U+9b13 */ { 0, 0, 0, 0, 0 },
/* U+9b14 */ { 0, 0, 0, 0, 0 },
/* U+9b15 */ { 0, 0, 0, 0, 0 },
/* U+9b16 */ { 0, 0, 0, 0, 0 },
/* U+9b17 */ { 0, 0, 0, 0, 0 },
/* U+9b18 */ { 0, 0, 0, 0, 0 },
/* U+9b19 */ { 0, 0, 0, 0, 0 },
/* U+9b1a */ { 0, 0, 0, 0, 0 },
/* U+9b1b */ { 0, 0, 0, 0, 0 },
/* U+9b1c */ { 0, 0, 0, 0, 0 },
/* U+9b1d */ { 0, 0, 0, 0, 0 },
/* U+9b1e */ { 0, 0, 0, 0, 0 },
/* U+9b1f */ { 0, 0, 0, 0, 0 },
/* U+9b20 */ { 0, 0, 0, 0, 0 },
/* U+9b21 */ { 0, 0, 0, 0, 0 },
/* U+9b22 */ { 0, 0, 0, 0, 0 },
/* U+9b23 */ { 0, 0, 0, 0, 0 },
/* U+9b24 */ { 0, 0, 0, 0, 0 },
/* U+9b25 */ { 0, 0, 0, 0, 0 },
/* U+9b26 */ { 0, 0, 0, 0, 0 },
/* U+9b27 */ { 0, 0, 0, 0, 0 },
/* U+9b28 */ { 0, 0, 0, 0, 0 },
/* U+9b29 */ { 0, 0, 0, 0, 0 },
/* U+9b2a */ { 0, 0, 0, 0, 0 },
/* U+9b2b */ { 0, 0, 0, 0, 0 },
/* U+9b2c */ { 0, 0, 0, 0, 0 },
/* U+9b2d */ { 0, 0, 0, 0, 0 },
/* U+9b2e */ { 0, 0, 0, 0, 0 },
/* U+9b2f */ { 0, 0, 0, 0, 0 },
/* U+9b30 */ { 0, 0, 0, 0, 0 },
/* U+9b31 */ { 0, 0, 0, 0, 0 },
/* U+9b32 */ { 0, 0, 0, 0, 0 },
/* U+9b33 */ { 0, 0, 0, 0, 0 },
/* U+9b34 */ { 0, 0, 0, 0, 0 },
/* U+9b35 */ { 0, 0, 0, 0, 0 },
/* U+9b36 */ { 0, 0, 0, 0, 0 },
/* U+9b37 */ { 0, 0, 0, 0, 0 },
/* U+9b38 */ { 0, 0, 0, 0, 0 },
/* U+9b39 */ { 0, 0, 0, 0, 0 },
/* U+9b3a */ { 0, 0, 0, 0, 0 },
/* U+9b3b */ { 0, 0, 0, 0, 0 },
/* U+9b3c */ { 0, 0, 0, 0, 0 },
/* U+9b3d */ { 0, 0, 0, 0, 0 },
/* U+9b3e */ { 0, 0, 0, 0, 0 },
/* U+9b3f */ { 0, 0, 0, 0, 0 },
/* U+9b40 */ { 0, 0, 0, 0, 0 },
/* U+9b41 */ { 0, 0, 0, 0, 0 },
/* U+9b42 */ { 0, 0, 0, 0, 0 },
/* U+9b43 */ { 0, 0, 0, 0, 0 },
/* U+9b44 */ { 0, 0, 0, 0, 0 },
/* U+9b45 */ { 0, 0, 0, 0, 0 },
/* U+9b46 */ { 0, 0, 0, 0, 0 },
/* U+9b47 */ { 0, 0, 0, 0, 0 },
/* U+9b48 */ { 0, 0, 0, 0, 0 },
/* U+9b49 */ { 0, 0, 0, 0, 0 },
/* U+9b4a */ { 0, 0, 0, 0, 0 },
/* U+9b4b */ { 0, 0, 0, 0, 0 },
/* U+9b4c */ { 0, 0, 0, 0, 0 },
/* U+9b4d */ { 0, 0, 0, 0, 0 },
/* U+9b4e */ { 0, 0, 0, 0, 0 },
/* U+9b4f */ { 0, 0, 0, 0, 0 },
/* U+9b50 */ { 0, 0, 0, 0, 0 },
/* U+9b51 */ { 0, 0, 0, 0, 0 },
/* U+9b52 */ { 0, 0, 0, 0, 0 },
/* U+9b53 */ { 0, 0, 0, 0, 0 },
/* U+9b54 */ { 0, 0, 0, 0, 0 },
/* U+9b55 */ { 0, 0, 0, 0, 0 },
/* U+9b56 */ { 0, 0, 0, 0, 0 },
/* U+9b57 */ { 0, 0, 0, 0, 0 },
/* U+9b58 */ { 0, 0, 0, 0, 0 },
/* U+9b59 */ { 0, 0, 0, 0, 0 },
/* U+9b5a */ { 0, 0, 0, 0, 0 },
/* U+9b5b */ { 0, 0, 0, 0, 0 },
/* U+9b5c */ { 0, 0, 0, 0, 0 },
/* U+9b5d */ { 0, 0, 0, 0, 0 },
/* U+9b5e */ { 0, 0, 0, 0, 0 },
/* U+9b5f */ { 0, 0, 0, 0, 0 },
/* U+9b60 */ { 0, 0, 0, 0, 0 },
/* U+9b61 */ { 0, 0, 0, 0, 0 },
/* U+9b62 */ { 0, 0, 0, 0, 0 },
/* U+9b63 */ { 0, 0, 0, 0, 0 },
/* U+9b64 */ { 0, 0, 0, 0, 0 },
/* U+9b65 */ { 0, 0, 0, 0, 0 },
/* U+9b66 */ { 0, 0, 0, 0, 0 },
/* U+9b67 */ { 0, 0, 0, 0, 0 },
/* U+9b68 */ { 0, 0, 0, 0, 0 },
/* U+9b69 */ { 0, 0, 0, 0, 0 },
/* U+9b6a */ { 0, 0, 0, 0, 0 },
/* U+9b6b */ { 0, 0, 0, 0, 0 },
/* U+9b6c */ { 0, 0, 0, 0, 0 },
/* U+9b6d */ { 0, 0, 0, 0, 0 },
/* U+9b6e */ { 0, 0, 0, 0, 0 },
/* U+9b6f */ { 0, 0, 0, 0, 0 },
/* U+9b70 */ { 0, 0, 0, 0, 0 },
/* U+9b71 */ { 0, 0, 0, 0, 0 },
/* U+9b72 */ { 0, 0, 0, 0, 0 },
/* U+9b73 */ { 0, 0, 0, 0, 0 },
/* U+9b74 */ { 0, 0, 0, 0, 0 },
/* U+9b75 */ { 0, 0, 0, 0, 0 },
/* U+9b76 */ { 0, 0, 0, 0, 0 },
/* U+9b77 */ { 0, 0, 0, 0, 0 },
/* U+9b78 */ { 0, 0, 0, 0, 0 },
/* U+9b79 */ { 0, 0, 0, 0, 0 },
/* U+9b7a */ { 0, 0, 0, 0, 0 },
/* U+9b7b */ { 0, 0, 0, 0, 0 },
/* U+9b7c */ { 0, 0, 0, 0, 0 },
/* U+9b7d */ { 0, 0, 0, 0, 0 },
/* U+9b7e */ { 0, 0, 0, 0, 0 },
/* U+9b7f */ { 0, 0, 0, 0, 0 },
/* U+9b80 */ { 0, 0, 0, 0, 0 },
/* U+9b81 */ { 0, 0, 0, 0, 0 },
/* U+9b82 */ { 0, 0, 0, 0, 0 },
/* U+9b83 */ { 0, 0, 0, 0, 0 },
/* U+9b84 */ { 0, 0, 0, 0, 0 },
/* U+9b85 */ { 0, 0, 0, 0, 0 },
/* U+9b86 */ { 0, 0, 0, 0, 0 },
/* U+9b87 */ { 0, 0, 0, 0, 0 },
/* U+9b88 */ { 0, 0, 0, 0, 0 },
/* U+9b89 */ { 0, 0, 0, 0, 0 },
/* U+9b8a */ { 0, 0, 0, 0, 0 },
/* U+9b8b */ { 0, 0, 0, 0, 0 },
/* U+9b8c */ { 0, 0, 0, 0, 0 },
/* U+9b8d */ { 0, 0, 0, 0, 0 },
/* U+9b8e */ { 0, 0, 0, 0, 0 },
/* U+9b8f */ { 0, 0, 0, 0, 0 },
/* U+9b90 */ { 0, 0, 0, 0, 0 },
/* U+9b91 */ { 0, 0, 0, 0, 0 },
/* U+9b92 */ { 0, 0, 0, 0, 0 },
/* U+9b93 */ { 0, 0, 0, 0, 0 },
/* U+9b94 */ { 0, 0, 0, 0, 0 },
/* U+9b95 */ { 0, 0, 0, 0, 0 },
/* U+9b96 */ { 0, 0, 0, 0, 0 },
/* U+9b97 */ { 0, 0, 0, 0, 0 },
/* U+9b98 */ { 0, 0, 0, 0, 0 },
/* U+9b99 */ { 0, 0, 0, 0, 0 },
/* U+9b9a */ { 0, 0, 0, 0, 0 },
/* U+9b9b */ { 0, 0, 0, 0, 0 },
/* U+9b9c */ { 0, 0, 0, 0, 0 },
/* U+9b9d */ { 0, 0, 0, 0, 0 },
/* U+9b9e */ { 0, 0, 0, 0, 0 },
/* U+9b9f */ { 0, 0, 0, 0, 0 },
/* U+9ba0 */ { 0, 0, 0, 0, 0 },
/* U+9ba1 */ { 0, 0, 0, 0, 0 },
/* U+9ba2 */ { 0, 0, 0, 0, 0 },
/* U+9ba3 */ { 0, 0, 0, 0, 0 },
/* U+9ba4 */ { 0, 0, 0, 0, 0 },
/* U+9ba5 */ { 0, 0, 0, 0, 0 },
/* U+9ba6 */ { 0, 0, 0, 0, 0 },
/* U+9ba7 */ { 0, 0, 0, 0, 0 },
/* U+9ba8 */ { 0, 0, 0, 0, 0 },
/* U+9ba9 */ { 0, 0, 0, 0, 0 },
/* U+9baa */ { 0, 0, 0, 0, 0 },
/* U+9bab */ { 0, 0, 0, 0, 0 },
/* U+9bac */ { 0, 0, 0, 0, 0 },
/* U+9bad */ { 0, 0, 0, 0, 0 },
/* U+9bae */ { 0, 0, 0, 0, 0 },
/* U+9baf */ { 0, 0, 0, 0, 0 },
/* U+9bb0 */ { 0, 0, 0, 0, 0 },
/* U+9bb1 */ { 0, 0, 0, 0, 0 },
/* U+9bb2 */ { 0, 0, 0, 0, 0 },
/* U+9bb3 */ { 0, 0, 0, 0, 0 },
/* U+9bb4 */ { 0, 0, 0, 0, 0 },
/* U+9bb5 */ { 0, 0, 0, 0, 0 },
/* U+9bb6 */ { 0, 0, 0, 0, 0 },
/* U+9bb7 */ { 0, 0, 0, 0, 0 },
/* U+9bb8 */ { 0, 0, 0, 0, 0 },
/* U+9bb9 */ { 0, 0, 0, 0, 0 },
/* U+9bba */ { 0, 0, 0, 0, 0 },
/* U+9bbb */ { 0, 0, 0, 0, 0 },
/* U+9bbc */ { 0, 0, 0, 0, 0 },
/* U+9bbd */ { 0, 0, 0, 0, 0 },
/* U+9bbe */ { 0, 0, 0, 0, 0 },
/* U+9bbf */ { 0, 0, 0, 0, 0 },
/* U+9bc0 */ { 0, 0, 0, 0, 0 },
/* U+9bc1 */ { 0, 0, 0, 0, 0 },
/* U+9bc2 */ { 0, 0, 0, 0, 0 },
/* U+9bc3 */ { 0, 0, 0, 0, 0 },
/* U+9bc4 */ { 0, 0, 0, 0, 0 },
/* U+9bc5 */ { 0, 0, 0, 0, 0 },
/* U+9bc6 */ { 0, 0, 0, 0, 0 },
/* U+9bc7 */ { 0, 0, 0, 0, 0 },
/* U+9bc8 */ { 0, 0, 0, 0, 0 },
/* U+9bc9 */ { 0, 0, 0, 0, 0 },
/* U+9bca */ { 0, 0, 0, 0, 0 },
/* U+9bcb */ { 0, 0, 0, 0, 0 },
/* U+9bcc */ { 0, 0, 0, 0, 0 },
/* U+9bcd */ { 0, 0, 0, 0, 0 },
/* U+9bce */ { 0, 0, 0, 0, 0 },
/* U+9bcf */ { 0, 0, 0, 0, 0 },
/* U+9bd0 */ { 0, 0, 0, 0, 0 },
/* U+9bd1 */ { 0, 0, 0, 0, 0 },
/* U+9bd2 */ { 0, 0, 0, 0, 0 },
/* U+9bd3 */ { 0, 0, 0, 0, 0 },
/* U+9bd4 */ { 0, 0, 0, 0, 0 },
/* U+9bd5 */ { 0, 0, 0, 0, 0 },
/* U+9bd6 */ { 0, 0, 0, 0, 0 },
/* U+9bd7 */ { 0, 0, 0, 0, 0 },
/* U+9bd8 */ { 0, 0, 0, 0, 0 },
/* U+9bd9 */ { 0, 0, 0, 0, 0 },
/* U+9bda */ { 0, 0, 0, 0, 0 },
/* U+9bdb */ { 0, 0, 0, 0, 0 },
/* U+9bdc */ { 0, 0, 0, 0, 0 },
/* U+9bdd */ { 0, 0, 0, 0, 0 },
/* U+9bde */ { 0, 0, 0, 0, 0 },
/* U+9bdf */ { 0, 0, 0, 0, 0 },
/* U+9be0 */ { 0, 0, 0, 0, 0 },
/* U+9be1 */ { 0, 0, 0, 0, 0 },
/* U+9be2 */ { 0, 0, 0, 0, 0 },
/* U+9be3 */ { 0, 0, 0, 0, 0 },
/* U+9be4 */ { 0, 0, 0, 0, 0 },
/* U+9be5 */ { 0, 0, 0, 0, 0 },
/* U+9be6 */ { 0, 0, 0, 0, 0 },
/* U+9be7 */ { 0, 0, 0, 0, 0 },
/* U+9be8 */ { 0, 0, 0, 0, 0 },
/* U+9be9 */ { 0, 0, 0, 0, 0 },
/* U+9bea */ { 0, 0, 0, 0, 0 },
/* U+9beb */ { 0, 0, 0, 0, 0 },
/* U+9bec */ { 0, 0, 0, 0, 0 },
/* U+9bed */ { 0, 0, 0, 0, 0 },
/* U+9bee */ { 0, 0, 0, 0, 0 },
/* U+9bef */ { 0, 0, 0, 0, 0 },
/* U+9bf0 */ { 0, 0, 0, 0, 0 },
/* U+9bf1 */ { 0, 0, 0, 0, 0 },
/* U+9bf2 */ { 0, 0, 0, 0, 0 },
/* U+9bf3 */ { 0, 0, 0, 0, 0 },
/* U+9bf4 */ { 0, 0, 0, 0, 0 },
/* U+9bf5 */ { 0, 0, 0, 0, 0 },
/* U+9bf6 */ { 0, 0, 0, 0, 0 },
/* U+9bf7 */ { 0, 0, 0, 0, 0 },
/* U+9bf8 */ { 0, 0, 0, 0, 0 },
/* U+9bf9 */ { 0, 0, 0, 0, 0 },
/* U+9bfa */ { 0, 0, 0, 0, 0 },
/* U+9bfb */ { 0, 0, 0, 0, 0 },
/* U+9bfc */ { 0, 0, 0, 0, 0 },
/* U+9bfd */ { 0, 0, 0, 0, 0 },
/* U+9bfe */ { 0, 0, 0, 0, 0 },
/* U+9bff */ { 0, 0, 0, 0, 0 },
/* U+9c00 */ { 0, 0, 0, 0, 0 },
/* U+9c01 */ { 0, 0, 0, 0, 0 },
/* U+9c02 */ { 0, 0, 0, 0, 0 },
/* U+9c03 */ { 0, 0, 0, 0, 0 },
/* U+9c04 */ { 0, 0, 0, 0, 0 },
/* U+9c05 */ { 0, 0, 0, 0, 0 },
/* U+9c06 */ { 0, 0, 0, 0, 0 },
/* U+9c07 */ { 0, 0, 0, 0, 0 },
/* U+9c08 */ { 0, 0, 0, 0, 0 },
/* U+9c09 */ { 0, 0, 0, 0, 0 },
/* U+9c0a */ { 0, 0, 0, 0, 0 },
/* U+9c0b */ { 0, 0, 0, 0, 0 },
/* U+9c0c */ { 0, 0, 0, 0, 0 },
/* U+9c0d */ { 0, 0, 0, 0, 0 },
/* U+9c0e */ { 0, 0, 0, 0, 0 },
/* U+9c0f */ { 0, 0, 0, 0, 0 },
/* U+9c10 */ { 0, 0, 0, 0, 0 },
/* U+9c11 */ { 0, 0, 0, 0, 0 },
/* U+9c12 */ { 0, 0, 0, 0, 0 },
/* U+9c13 */ { 0, 0, 0, 0, 0 },
/* U+9c14 */ { 0, 0, 0, 0, 0 },
/* U+9c15 */ { 0, 0, 0, 0, 0 },
/* U+9c16 */ { 0, 0, 0, 0, 0 },
/* U+9c17 */ { 0, 0, 0, 0, 0 },
/* U+9c18 */ { 0, 0, 0, 0, 0 },
/* U+9c19 */ { 0, 0, 0, 0, 0 },
/* U+9c1a */ { 0, 0, 0, 0, 0 },
/* U+9c1b */ { 0, 0, 0, 0, 0 },
/* U+9c1c */ { 0, 0, 0, 0, 0 },
/* U+9c1d */ { 0, 0, 0, 0, 0 },
/* U+9c1e */ { 0, 0, 0, 0, 0 },
/* U+9c1f */ { 0, 0, 0, 0, 0 },
/* U+9c20 */ { 0, 0, 0, 0, 0 },
/* U+9c21 */ { 0, 0, 0, 0, 0 },
/* U+9c22 */ { 0, 0, 0, 0, 0 },
/* U+9c23 */ { 0, 0, 0, 0, 0 },
/* U+9c24 */ { 0, 0, 0, 0, 0 },
/* U+9c25 */ { 0, 0, 0, 0, 0 },
/* U+9c26 */ { 0, 0, 0, 0, 0 },
/* U+9c27 */ { 0, 0, 0, 0, 0 },
/* U+9c28 */ { 0, 0, 0, 0, 0 },
/* U+9c29 */ { 0, 0, 0, 0, 0 },
/* U+9c2a */ { 0, 0, 0, 0, 0 },
/* U+9c2b */ { 0, 0, 0, 0, 0 },
/* U+9c2c */ { 0, 0, 0, 0, 0 },
/* U+9c2d */ { 0, 0, 0, 0, 0 },
/* U+9c2e */ { 0, 0, 0, 0, 0 },
/* U+9c2f */ { 0, 0, 0, 0, 0 },
/* U+9c30 */ { 0, 0, 0, 0, 0 },
/* U+9c31 */ { 0, 0, 0, 0, 0 },
/* U+9c32 */ { 0, 0, 0, 0, 0 },
/* U+9c33 */ { 0, 0, 0, 0, 0 },
/* U+9c34 */ { 0, 0, 0, 0, 0 },
/* U+9c35 */ { 0, 0, 0, 0, 0 },
/* U+9c36 */ { 0, 0, 0, 0, 0 },
/* U+9c37 */ { 0, 0, 0, 0, 0 },
/* U+9c38 */ { 0, 0, 0, 0, 0 },
/* U+9c39 */ { 0, 0, 0, 0, 0 },
/* U+9c3a */ { 0, 0, 0, 0, 0 },
/* U+9c3b */ { 0, 0, 0, 0, 0 },
/* U+9c3c */ { 0, 0, 0, 0, 0 },
/* U+9c3d */ { 0, 0, 0, 0, 0 },
/* U+9c3e */ { 0, 0, 0, 0, 0 },
/* U+9c3f */ { 0, 0, 0, 0, 0 },
/* U+9c40 */ { 0, 0, 0, 0, 0 },
/* U+9c41 */ { 0, 0, 0, 0, 0 },
/* U+9c42 */ { 0, 0, 0, 0, 0 },
/* U+9c43 */ { 0, 0, 0, 0, 0 },
/* U+9c44 */ { 0, 0, 0, 0, 0 },
/* U+9c45 */ { 0, 0, 0, 0, 0 },
/* U+9c46 */ { 0, 0, 0, 0, 0 },
/* U+9c47 */ { 0, 0, 0, 0, 0 },
/* U+9c48 */ { 0, 0, 0, 0, 0 },
/* U+9c49 */ { 0, 0, 0, 0, 0 },
/* U+9c4a */ { 0, 0, 0, 0, 0 },
/* U+9c4b */ { 0, 0, 0, 0, 0 },
/* U+9c4c */ { 0, 0, 0, 0, 0 },
/* U+9c4d */ { 0, 0, 0, 0, 0 },
/* U+9c4e */ { 0, 0, 0, 0, 0 },
/* U+9c4f */ { 0, 0, 0, 0, 0 },
/* U+9c50 */ { 0, 0, 0, 0, 0 },
/* U+9c51 */ { 0, 0, 0, 0, 0 },
/* U+9c52 */ { 0, 0, 0, 0, 0 },
/* U+9c53 */ { 0, 0, 0, 0, 0 },
/* U+9c54 */ { 0, 0, 0, 0, 0 },
/* U+9c55 */ { 0, 0, 0, 0, 0 },
/* U+9c56 */ { 0, 0, 0, 0, 0 },
/* U+9c57 */ { 0, 0, 0, 0, 0 },
/* U+9c58 */ { 0, 0, 0, 0, 0 },
/* U+9c59 */ { 0, 0, 0, 0, 0 },
/* U+9c5a */ { 0, 0, 0, 0, 0 },
/* U+9c5b */ { 0, 0, 0, 0, 0 },
/* U+9c5c */ { 0, 0, 0, 0, 0 },
/* U+9c5d */ { 0, 0, 0, 0, 0 },
/* U+9c5e */ { 0, 0, 0, 0, 0 },
/* U+9c5f */ { 0, 0, 0, 0, 0 },
/* U+9c60 */ { 0, 0, 0, 0, 0 },
/* U+9c61 */ { 0, 0, 0, 0, 0 },
/* U+9c62 */ { 0, 0, 0, 0, 0 },
/* U+9c63 */ { 0, 0, 0, 0, 0 },
/* U+9c64 */ { 0, 0, 0, 0, 0 },
/* U+9c65 */ { 0, 0, 0, 0, 0 },
/* U+9c66 */ { 0, 0, 0, 0, 0 },
/* U+9c67 */ { 0, 0, 0, 0, 0 },
/* U+9c68 */ { 0, 0, 0, 0, 0 },
/* U+9c69 */ { 0, 0, 0, 0, 0 },
/* U+9c6a */ { 0, 0, 0, 0, 0 },
/* U+9c6b */ { 0, 0, 0, 0, 0 },
/* U+9c6c */ { 0, 0, 0, 0, 0 },
/* U+9c6d */ { 0, 0, 0, 0, 0 },
/* U+9c6e */ { 0, 0, 0, 0, 0 },
/* U+9c6f */ { 0, 0, 0, 0, 0 },
/* U+9c70 */ { 0, 0, 0, 0, 0 },
/* U+9c71 */ { 0, 0, 0, 0, 0 },
/* U+9c72 */ { 0, 0, 0, 0, 0 },
/* U+9c73 */ { 0, 0, 0, 0, 0 },
/* U+9c74 */ { 0, 0, 0, 0, 0 },
/* U+9c75 */ { 0, 0, 0, 0, 0 },
/* U+9c76 */ { 0, 0, 0, 0, 0 },
/* U+9c77 */ { 0, 0, 0, 0, 0 },
/* U+9c78 */ { 0, 0, 0, 0, 0 },
/* U+9c79 */ { 0, 0, 0, 0, 0 },
/* U+9c7a */ { 0, 0, 0, 0, 0 },
/* U+9c7b */ { 0, 0, 0, 0, 0 },
/* U+9c7c */ { 0, 0, 0, 0, 0 },
/* U+9c7d */ { 0, 0, 0, 0, 0 },
/* U+9c7e */ { 0, 0, 0, 0, 0 },
/* U+9c7f */ { 0, 0, 0, 0, 0 },
/* U+9c80 */ { 0, 0, 0, 0, 0 },
/* U+9c81 */ { 0, 0, 0, 0, 0 },
/* U+9c82 */ { 0, 0, 0, 0, 0 },
/* U+9c83 */ { 0, 0, 0, 0, 0 },
/* U+9c84 */ { 0, 0, 0, 0, 0 },
/* U+9c85 */ { 0, 0, 0, 0, 0 },
/* U+9c86 */ { 0, 0, 0, 0, 0 },
/* U+9c87 */ { 0, 0, 0, 0, 0 },
/* U+9c88 */ { 0, 0, 0, 0, 0 },
/* U+9c89 */ { 0, 0, 0, 0, 0 },
/* U+9c8a */ { 0, 0, 0, 0, 0 },
/* U+9c8b */ { 0, 0, 0, 0, 0 },
/* U+9c8c */ { 0, 0, 0, 0, 0 },
/* U+9c8d */ { 0, 0, 0, 0, 0 },
/* U+9c8e */ { 0, 0, 0, 0, 0 },
/* U+9c8f */ { 0, 0, 0, 0, 0 },
/* U+9c90 */ { 0, 0, 0, 0, 0 },
/* U+9c91 */ { 0, 0, 0, 0, 0 },
/* U+9c92 */ { 0, 0, 0, 0, 0 },
/* U+9c93 */ { 0, 0, 0, 0, 0 },
/* U+9c94 */ { 0, 0, 0, 0, 0 },
/* U+9c95 */ { 0, 0, 0, 0, 0 },
/* U+9c96 */ { 0, 0, 0, 0, 0 },
/* U+9c97 */ { 0, 0, 0, 0, 0 },
/* U+9c98 */ { 0, 0, 0, 0, 0 },
/* U+9c99 */ { 0, 0, 0, 0, 0 },
/* U+9c9a */ { 0, 0, 0, 0, 0 },
/* U+9c9b */ { 0, 0, 0, 0, 0 },
/* U+9c9c */ { 0, 0, 0, 0, 0 },
/* U+9c9d */ { 0, 0, 0, 0, 0 },
/* U+9c9e */ { 0, 0, 0, 0, 0 },
/* U+9c9f */ { 0, 0, 0, 0, 0 },
/* U+9ca0 */ { 0, 0, 0, 0, 0 },
/* U+9ca1 */ { 0, 0, 0, 0, 0 },
/* U+9ca2 */ { 0, 0, 0, 0, 0 },
/* U+9ca3 */ { 0, 0, 0, 0, 0 },
/* U+9ca4 */ { 0, 0, 0, 0, 0 },
/* U+9ca5 */ { 0, 0, 0, 0, 0 },
/* U+9ca6 */ { 0, 0, 0, 0, 0 },
/* U+9ca7 */ { 0, 0, 0, 0, 0 },
/* U+9ca8 */ { 0, 0, 0, 0, 0 },
/* U+9ca9 */ { 0, 0, 0, 0, 0 },
/* U+9caa */ { 0, 0, 0, 0, 0 },
/* U+9cab */ { 0, 0, 0, 0, 0 },
/* U+9cac */ { 0, 0, 0, 0, 0 },
/* U+9cad */ { 0, 0, 0, 0, 0 },
/* U+9cae */ { 0, 0, 0, 0, 0 },
/* U+9caf */ { 0, 0, 0, 0, 0 },
/* U+9cb0 */ { 0, 0, 0, 0, 0 },
/* U+9cb1 */ { 0, 0, 0, 0, 0 },
/* U+9cb2 */ { 0, 0, 0, 0, 0 },
/* U+9cb3 */ { 0, 0, 0, 0, 0 },
/* U+9cb4 */ { 0, 0, 0, 0, 0 },
/* U+9cb5 */ { 0, 0, 0, 0, 0 },
/* U+9cb6 */ { 0, 0, 0, 0, 0 },
/* U+9cb7 */ { 0, 0, 0, 0, 0 },
/* U+9cb8 */ { 0, 0, 0, 0, 0 },
/* U+9cb9 */ { 0, 0, 0, 0, 0 },
/* U+9cba */ { 0, 0, 0, 0, 0 },
/* U+9cbb */ { 0, 0, 0, 0, 0 },
/* U+9cbc */ { 0, 0, 0, 0, 0 },
/* U+9cbd */ { 0, 0, 0, 0, 0 },
/* U+9cbe */ { 0, 0, 0, 0, 0 },
/* U+9cbf */ { 0, 0, 0, 0, 0 },
/* U+9cc0 */ { 0, 0, 0, 0, 0 },
/* U+9cc1 */ { 0, 0, 0, 0, 0 },
/* U+9cc2 */ { 0, 0, 0, 0, 0 },
/* U+9cc3 */ { 0, 0, 0, 0, 0 },
/* U+9cc4 */ { 0, 0, 0, 0, 0 },
/* U+9cc5 */ { 0, 0, 0, 0, 0 },
/* U+9cc6 */ { 0, 0, 0, 0, 0 },
/* U+9cc7 */ { 0, 0, 0, 0, 0 },
/* U+9cc8 */ { 0, 0, 0, 0, 0 },
/* U+9cc9 */ { 0, 0, 0, 0, 0 },
/* U+9cca */ { 0, 0, 0, 0, 0 },
/* U+9ccb */ { 0, 0, 0, 0, 0 },
/* U+9ccc */ { 0, 0, 0, 0, 0 },
/* U+9ccd */ { 0, 0, 0, 0, 0 },
/* U+9cce */ { 0, 0, 0, 0, 0 },
/* U+9ccf */ { 0, 0, 0, 0, 0 },
/* U+9cd0 */ { 0, 0, 0, 0, 0 },
/* U+9cd1 */ { 0, 0, 0, 0, 0 },
/* U+9cd2 */ { 0, 0, 0, 0, 0 },
/* U+9cd3 */ { 0, 0, 0, 0, 0 },
/* U+9cd4 */ { 0, 0, 0, 0, 0 },
/* U+9cd5 */ { 0, 0, 0, 0, 0 },
/* U+9cd6 */ { 0, 0, 0, 0, 0 },
/* U+9cd7 */ { 0, 0, 0, 0, 0 },
/* U+9cd8 */ { 0, 0, 0, 0, 0 },
/* U+9cd9 */ { 0, 0, 0, 0, 0 },
/* U+9cda */ { 0, 0, 0, 0, 0 },
/* U+9cdb */ { 0, 0, 0, 0, 0 },
/* U+9cdc */ { 0, 0, 0, 0, 0 },
/* U+9cdd */ { 0, 0, 0, 0, 0 },
/* U+9cde */ { 0, 0, 0, 0, 0 },
/* U+9cdf */ { 0, 0, 0, 0, 0 },
/* U+9ce0 */ { 0, 0, 0, 0, 0 },
/* U+9ce1 */ { 0, 0, 0, 0, 0 },
/* U+9ce2 */ { 0, 0, 0, 0, 0 },
/* U+9ce3 */ { 0, 0, 0, 0, 0 },
/* U+9ce4 */ { 0, 0, 0, 0, 0 },
/* U+9ce5 */ { 0, 0, 0, 0, 0 },
/* U+9ce6 */ { 0, 0, 0, 0, 0 },
/* U+9ce7 */ { 0, 0, 0, 0, 0 },
/* U+9ce8 */ { 0, 0, 0, 0, 0 },
/* U+9ce9 */ { 0, 0, 0, 0, 0 },
/* U+9cea */ { 0, 0, 0, 0, 0 },
/* U+9ceb */ { 0, 0, 0, 0, 0 },
/* U+9cec */ { 0, 0, 0, 0, 0 },
/* U+9ced */ { 0, 0, 0, 0, 0 },
/* U+9cee */ { 0, 0, 0, 0, 0 },
/* U+9cef */ { 0, 0, 0, 0, 0 },
/* U+9cf0 */ { 0, 0, 0, 0, 0 },
/* U+9cf1 */ { 0, 0, 0, 0, 0 },
/* U+9cf2 */ { 0, 0, 0, 0, 0 },
/* U+9cf3 */ { 0, 0, 0, 0, 0 },
/* U+9cf4 */ { 0, 0, 0, 0, 0 },
/* U+9cf5 */ { 0, 0, 0, 0, 0 },
/* U+9cf6 */ { 0, 0, 0, 0, 0 },
/* U+9cf7 */ { 0, 0, 0, 0, 0 },
/* U+9cf8 */ { 0, 0, 0, 0, 0 },
/* U+9cf9 */ { 0, 0, 0, 0, 0 },
/* U+9cfa */ { 0, 0, 0, 0, 0 },
/* U+9cfb */ { 0, 0, 0, 0, 0 },
/* U+9cfc */ { 0, 0, 0, 0, 0 },
/* U+9cfd */ { 0, 0, 0, 0, 0 },
/* U+9cfe */ { 0, 0, 0, 0, 0 },
/* U+9cff */ { 0, 0, 0, 0, 0 },
/* U+9d00 */ { 0, 0, 0, 0, 0 },
/* U+9d01 */ { 0, 0, 0, 0, 0 },
/* U+9d02 */ { 0, 0, 0, 0, 0 },
/* U+9d03 */ { 0, 0, 0, 0, 0 },
/* U+9d04 */ { 0, 0, 0, 0, 0 },
/* U+9d05 */ { 0, 0, 0, 0, 0 },
/* U+9d06 */ { 0, 0, 0, 0, 0 },
/* U+9d07 */ { 0, 0, 0, 0, 0 },
/* U+9d08 */ { 0, 0, 0, 0, 0 },
/* U+9d09 */ { 0, 0, 0, 0, 0 },
/* U+9d0a */ { 0, 0, 0, 0, 0 },
/* U+9d0b */ { 0, 0, 0, 0, 0 },
/* U+9d0c */ { 0, 0, 0, 0, 0 },
/* U+9d0d */ { 0, 0, 0, 0, 0 },
/* U+9d0e */ { 0, 0, 0, 0, 0 },
/* U+9d0f */ { 0, 0, 0, 0, 0 },
/* U+9d10 */ { 0, 0, 0, 0, 0 },
/* U+9d11 */ { 0, 0, 0, 0, 0 },
/* U+9d12 */ { 0, 0, 0, 0, 0 },
/* U+9d13 */ { 0, 0, 0, 0, 0 },
/* U+9d14 */ { 0, 0, 0, 0, 0 },
/* U+9d15 */ { 0, 0, 0, 0, 0 },
/* U+9d16 */ { 0, 0, 0, 0, 0 },
/* U+9d17 */ { 0, 0, 0, 0, 0 },
/* U+9d18 */ { 0, 0, 0, 0, 0 },
/* U+9d19 */ { 0, 0, 0, 0, 0 },
/* U+9d1a */ { 0, 0, 0, 0, 0 },
/* U+9d1b */ { 0, 0, 0, 0, 0 },
/* U+9d1c */ { 0, 0, 0, 0, 0 },
/* U+9d1d */ { 0, 0, 0, 0, 0 },
/* U+9d1e */ { 0, 0, 0, 0, 0 },
/* U+9d1f */ { 0, 0, 0, 0, 0 },
/* U+9d20 */ { 0, 0, 0, 0, 0 },
/* U+9d21 */ { 0, 0, 0, 0, 0 },
/* U+9d22 */ { 0, 0, 0, 0, 0 },
/* U+9d23 */ { 0, 0, 0, 0, 0 },
/* U+9d24 */ { 0, 0, 0, 0, 0 },
/* U+9d25 */ { 0, 0, 0, 0, 0 },
/* U+9d26 */ { 0, 0, 0, 0, 0 },
/* U+9d27 */ { 0, 0, 0, 0, 0 },
/* U+9d28 */ { 0, 0, 0, 0, 0 },
/* U+9d29 */ { 0, 0, 0, 0, 0 },
/* U+9d2a */ { 0, 0, 0, 0, 0 },
/* U+9d2b */ { 0, 0, 0, 0, 0 },
/* U+9d2c */ { 0, 0, 0, 0, 0 },
/* U+9d2d */ { 0, 0, 0, 0, 0 },
/* U+9d2e */ { 0, 0, 0, 0, 0 },
/* U+9d2f */ { 0, 0, 0, 0, 0 },
/* U+9d30 */ { 0, 0, 0, 0, 0 },
/* U+9d31 */ { 0, 0, 0, 0, 0 },
/* U+9d32 */ { 0, 0, 0, 0, 0 },
/* U+9d33 */ { 0, 0, 0, 0, 0 },
/* U+9d34 */ { 0, 0, 0, 0, 0 },
/* U+9d35 */ { 0, 0, 0, 0, 0 },
/* U+9d36 */ { 0, 0, 0, 0, 0 },
/* U+9d37 */ { 0, 0, 0, 0, 0 },
/* U+9d38 */ { 0, 0, 0, 0, 0 },
/* U+9d39 */ { 0, 0, 0, 0, 0 },
/* U+9d3a */ { 0, 0, 0, 0, 0 },
/* U+9d3b */ { 0, 0, 0, 0, 0 },
/* U+9d3c */ { 0, 0, 0, 0, 0 },
/* U+9d3d */ { 0, 0, 0, 0, 0 },
/* U+9d3e */ { 0, 0, 0, 0, 0 },
/* U+9d3f */ { 0, 0, 0, 0, 0 },
/* U+9d40 */ { 0, 0, 0, 0, 0 },
/* U+9d41 */ { 0, 0, 0, 0, 0 },
/* U+9d42 */ { 0, 0, 0, 0, 0 },
/* U+9d43 */ { 0, 0, 0, 0, 0 },
/* U+9d44 */ { 0, 0, 0, 0, 0 },
/* U+9d45 */ { 0, 0, 0, 0, 0 },
/* U+9d46 */ { 0, 0, 0, 0, 0 },
/* U+9d47 */ { 0, 0, 0, 0, 0 },
/* U+9d48 */ { 0, 0, 0, 0, 0 },
/* U+9d49 */ { 0, 0, 0, 0, 0 },
/* U+9d4a */ { 0, 0, 0, 0, 0 },
/* U+9d4b */ { 0, 0, 0, 0, 0 },
/* U+9d4c */ { 0, 0, 0, 0, 0 },
/* U+9d4d */ { 0, 0, 0, 0, 0 },
/* U+9d4e */ { 0, 0, 0, 0, 0 },
/* U+9d4f */ { 0, 0, 0, 0, 0 },
/* U+9d50 */ { 0, 0, 0, 0, 0 },
/* U+9d51 */ { 0, 0, 0, 0, 0 },
/* U+9d52 */ { 0, 0, 0, 0, 0 },
/* U+9d53 */ { 0, 0, 0, 0, 0 },
/* U+9d54 */ { 0, 0, 0, 0, 0 },
/* U+9d55 */ { 0, 0, 0, 0, 0 },
/* U+9d56 */ { 0, 0, 0, 0, 0 },
/* U+9d57 */ { 0, 0, 0, 0, 0 },
/* U+9d58 */ { 0, 0, 0, 0, 0 },
/* U+9d59 */ { 0, 0, 0, 0, 0 },
/* U+9d5a */ { 0, 0, 0, 0, 0 },
/* U+9d5b */ { 0, 0, 0, 0, 0 },
/* U+9d5c */ { 0, 0, 0, 0, 0 },
/* U+9d5d */ { 0, 0, 0, 0, 0 },
/* U+9d5e */ { 0, 0, 0, 0, 0 },
/* U+9d5f */ { 0, 0, 0, 0, 0 },
/* U+9d60 */ { 0, 0, 0, 0, 0 },
/* U+9d61 */ { 0, 0, 0, 0, 0 },
/* U+9d62 */ { 0, 0, 0, 0, 0 },
/* U+9d63 */ { 0, 0, 0, 0, 0 },
/* U+9d64 */ { 0, 0, 0, 0, 0 },
/* U+9d65 */ { 0, 0, 0, 0, 0 },
/* U+9d66 */ { 0, 0, 0, 0, 0 },
/* U+9d67 */ { 0, 0, 0, 0, 0 },
/* U+9d68 */ { 0, 0, 0, 0, 0 },
/* U+9d69 */ { 0, 0, 0, 0, 0 },
/* U+9d6a */ { 0, 0, 0, 0, 0 },
/* U+9d6b */ { 0, 0, 0, 0, 0 },
/* U+9d6c */ { 0, 0, 0, 0, 0 },
/* U+9d6d */ { 0, 0, 0, 0, 0 },
/* U+9d6e */ { 0, 0, 0, 0, 0 },
/* U+9d6f */ { 0, 0, 0, 0, 0 },
/* U+9d70 */ { 0, 0, 0, 0, 0 },
/* U+9d71 */ { 0, 0, 0, 0, 0 },
/* U+9d72 */ { 0, 0, 0, 0, 0 },
/* U+9d73 */ { 0, 0, 0, 0, 0 },
/* U+9d74 */ { 0, 0, 0, 0, 0 },
/* U+9d75 */ { 0, 0, 0, 0, 0 },
/* U+9d76 */ { 0, 0, 0, 0, 0 },
/* U+9d77 */ { 0, 0, 0, 0, 0 },
/* U+9d78 */ { 0, 0, 0, 0, 0 },
/* U+9d79 */ { 0, 0, 0, 0, 0 },
/* U+9d7a */ { 0, 0, 0, 0, 0 },
/* U+9d7b */ { 0, 0, 0, 0, 0 },
/* U+9d7c */ { 0, 0, 0, 0, 0 },
/* U+9d7d */ { 0, 0, 0, 0, 0 },
/* U+9d7e */ { 0, 0, 0, 0, 0 },
/* U+9d7f */ { 0, 0, 0, 0, 0 },
/* U+9d80 */ { 0, 0, 0, 0, 0 },
/* U+9d81 */ { 0, 0, 0, 0, 0 },
/* U+9d82 */ { 0, 0, 0, 0, 0 },
/* U+9d83 */ { 0, 0, 0, 0, 0 },
/* U+9d84 */ { 0, 0, 0, 0, 0 },
/* U+9d85 */ { 0, 0, 0, 0, 0 },
/* U+9d86 */ { 0, 0, 0, 0, 0 },
/* U+9d87 */ { 0, 0, 0, 0, 0 },
/* U+9d88 */ { 0, 0, 0, 0, 0 },
/* U+9d89 */ { 0, 0, 0, 0, 0 },
/* U+9d8a */ { 0, 0, 0, 0, 0 },
/* U+9d8b */ { 0, 0, 0, 0, 0 },
/* U+9d8c */ { 0, 0, 0, 0, 0 },
/* U+9d8d */ { 0, 0, 0, 0, 0 },
/* U+9d8e */ { 0, 0, 0, 0, 0 },
/* U+9d8f */ { 0, 0, 0, 0, 0 },
/* U+9d90 */ { 0, 0, 0, 0, 0 },
/* U+9d91 */ { 0, 0, 0, 0, 0 },
/* U+9d92 */ { 0, 0, 0, 0, 0 },
/* U+9d93 */ { 0, 0, 0, 0, 0 },
/* U+9d94 */ { 0, 0, 0, 0, 0 },
/* U+9d95 */ { 0, 0, 0, 0, 0 },
/* U+9d96 */ { 0, 0, 0, 0, 0 },
/* U+9d97 */ { 0, 0, 0, 0, 0 },
/* U+9d98 */ { 0, 0, 0, 0, 0 },
/* U+9d99 */ { 0, 0, 0, 0, 0 },
/* U+9d9a */ { 0, 0, 0, 0, 0 },
/* U+9d9b */ { 0, 0, 0, 0, 0 },
/* U+9d9c */ { 0, 0, 0, 0, 0 },
/* U+9d9d */ { 0, 0, 0, 0, 0 },
/* U+9d9e */ { 0, 0, 0, 0, 0 },
/* U+9d9f */ { 0, 0, 0, 0, 0 },
/* U+9da0 */ { 0, 0, 0, 0, 0 },
/* U+9da1 */ { 0, 0, 0, 0, 0 },
/* U+9da2 */ { 0, 0, 0, 0, 0 },
/* U+9da3 */ { 0, 0, 0, 0, 0 },
/* U+9da4 */ { 0, 0, 0, 0, 0 },
/* U+9da5 */ { 0, 0, 0, 0, 0 },
/* U+9da6 */ { 0, 0, 0, 0, 0 },
/* U+9da7 */ { 0, 0, 0, 0, 0 },
/* U+9da8 */ { 0, 0, 0, 0, 0 },
/* U+9da9 */ { 0, 0, 0, 0, 0 },
/* U+9daa */ { 0, 0, 0, 0, 0 },
/* U+9dab */ { 0, 0, 0, 0, 0 },
/* U+9dac */ { 0, 0, 0, 0, 0 },
/* U+9dad */ { 0, 0, 0, 0, 0 },
/* U+9dae */ { 0, 0, 0, 0, 0 },
/* U+9daf */ { 0, 0, 0, 0, 0 },
/* U+9db0 */ { 0, 0, 0, 0, 0 },
/* U+9db1 */ { 0, 0, 0, 0, 0 },
/* U+9db2 */ { 0, 0, 0, 0, 0 },
/* U+9db3 */ { 0, 0, 0, 0, 0 },
/* U+9db4 */ { 0, 0, 0, 0, 0 },
/* U+9db5 */ { 0, 0, 0, 0, 0 },
/* U+9db6 */ { 0, 0, 0, 0, 0 },
/* U+9db7 */ { 0, 0, 0, 0, 0 },
/* U+9db8 */ { 0, 0, 0, 0, 0 },
/* U+9db9 */ { 0, 0, 0, 0, 0 },
/* U+9dba */ { 0, 0, 0, 0, 0 },
/* U+9dbb */ { 0, 0, 0, 0, 0 },
/* U+9dbc */ { 0, 0, 0, 0, 0 },
/* U+9dbd */ { 0, 0, 0, 0, 0 },
/* U+9dbe */ { 0, 0, 0, 0, 0 },
/* U+9dbf */ { 0, 0, 0, 0, 0 },
/* U+9dc0 */ { 0, 0, 0, 0, 0 },
/* U+9dc1 */ { 0, 0, 0, 0, 0 },
/* U+9dc2 */ { 0, 0, 0, 0, 0 },
/* U+9dc3 */ { 0, 0, 0, 0, 0 },
/* U+9dc4 */ { 0, 0, 0, 0, 0 },
/* U+9dc5 */ { 0, 0, 0, 0, 0 },
/* U+9dc6 */ { 0, 0, 0, 0, 0 },
/* U+9dc7 */ { 0, 0, 0, 0, 0 },
/* U+9dc8 */ { 0, 0, 0, 0, 0 },
/* U+9dc9 */ { 0, 0, 0, 0, 0 },
/* U+9dca */ { 0, 0, 0, 0, 0 },
/* U+9dcb */ { 0, 0, 0, 0, 0 },
/* U+9dcc */ { 0, 0, 0, 0, 0 },
/* U+9dcd */ { 0, 0, 0, 0, 0 },
/* U+9dce */ { 0, 0, 0, 0, 0 },
/* U+9dcf */ { 0, 0, 0, 0, 0 },
/* U+9dd0 */ { 0, 0, 0, 0, 0 },
/* U+9dd1 */ { 0, 0, 0, 0, 0 },
/* U+9dd2 */ { 0, 0, 0, 0, 0 },
/* U+9dd3 */ { 0, 0, 0, 0, 0 },
/* U+9dd4 */ { 0, 0, 0, 0, 0 },
/* U+9dd5 */ { 0, 0, 0, 0, 0 },
/* U+9dd6 */ { 0, 0, 0, 0, 0 },
/* U+9dd7 */ { 0, 0, 0, 0, 0 },
/* U+9dd8 */ { 0, 0, 0, 0, 0 },
/* U+9dd9 */ { 0, 0, 0, 0, 0 },
/* U+9dda */ { 0, 0, 0, 0, 0 },
/* U+9ddb */ { 0, 0, 0, 0, 0 },
/* U+9ddc */ { 0, 0, 0, 0, 0 },
/* U+9ddd */ { 0, 0, 0, 0, 0 },
/* U+9dde */ { 0, 0, 0, 0, 0 },
/* U+9ddf */ { 0, 0, 0, 0, 0 },
/* U+9de0 */ { 0, 0, 0, 0, 0 },
/* U+9de1 */ { 0, 0, 0, 0, 0 },
/* U+9de2 */ { 0, 0, 0, 0, 0 },
/* U+9de3 */ { 0, 0, 0, 0, 0 },
/* U+9de4 */ { 0, 0, 0, 0, 0 },
/* U+9de5 */ { 0, 0, 0, 0, 0 },
/* U+9de6 */ { 0, 0, 0, 0, 0 },
/* U+9de7 */ { 0, 0, 0, 0, 0 },
/* U+9de8 */ { 0, 0, 0, 0, 0 },
/* U+9de9 */ { 0, 0, 0, 0, 0 },
/* U+9dea */ { 0, 0, 0, 0, 0 },
/* U+9deb */ { 0, 0, 0, 0, 0 },
/* U+9dec */ { 0, 0, 0, 0, 0 },
/* U+9ded */ { 0, 0, 0, 0, 0 },
/* U+9dee */ { 0, 0, 0, 0, 0 },
/* U+9def */ { 0, 0, 0, 0, 0 },
/* U+9df0 */ { 0, 0, 0, 0, 0 },
/* U+9df1 */ { 0, 0, 0, 0, 0 },
/* U+9df2 */ { 0, 0, 0, 0, 0 },
/* U+9df3 */ { 0, 0, 0, 0, 0 },
/* U+9df4 */ { 0, 0, 0, 0, 0 },
/* U+9df5 */ { 0, 0, 0, 0, 0 },
/* U+9df6 */ { 0, 0, 0, 0, 0 },
/* U+9df7 */ { 0, 0, 0, 0, 0 },
/* U+9df8 */ { 0, 0, 0, 0, 0 },
/* U+9df9 */ { 0, 0, 0, 0, 0 },
/* U+9dfa */ { 0, 0, 0, 0, 0 },
/* U+9dfb */ { 0, 0, 0, 0, 0 },
/* U+9dfc */ { 0, 0, 0, 0, 0 },
/* U+9dfd */ { 0, 0, 0, 0, 0 },
/* U+9dfe */ { 0, 0, 0, 0, 0 },
/* U+9dff */ { 0, 0, 0, 0, 0 },
/* U+9e00 */ { 0, 0, 0, 0, 0 },
/* U+9e01 */ { 0, 0, 0, 0, 0 },
/* U+9e02 */ { 0, 0, 0, 0, 0 },
/* U+9e03 */ { 0, 0, 0, 0, 0 },
/* U+9e04 */ { 0, 0, 0, 0, 0 },
/* U+9e05 */ { 0, 0, 0, 0, 0 },
/* U+9e06 */ { 0, 0, 0, 0, 0 },
/* U+9e07 */ { 0, 0, 0, 0, 0 },
/* U+9e08 */ { 0, 0, 0, 0, 0 },
/* U+9e09 */ { 0, 0, 0, 0, 0 },
/* U+9e0a */ { 0, 0, 0, 0, 0 },
/* U+9e0b */ { 0, 0, 0, 0, 0 },
/* U+9e0c */ { 0, 0, 0, 0, 0 },
/* U+9e0d */ { 0, 0, 0, 0, 0 },
/* U+9e0e */ { 0, 0, 0, 0, 0 },
/* U+9e0f */ { 0, 0, 0, 0, 0 },
/* U+9e10 */ { 0, 0, 0, 0, 0 },
/* U+9e11 */ { 0, 0, 0, 0, 0 },
/* U+9e12 */ { 0, 0, 0, 0, 0 },
/* U+9e13 */ { 0, 0, 0, 0, 0 },
/* U+9e14 */ { 0, 0, 0, 0, 0 },
/* U+9e15 */ { 0, 0, 0, 0, 0 },
/* U+9e16 */ { 0, 0, 0, 0, 0 },
/* U+9e17 */ { 0, 0, 0, 0, 0 },
/* U+9e18 */ { 0, 0, 0, 0, 0 },
/* U+9e19 */ { 0, 0, 0, 0, 0 },
/* U+9e1a */ { 0, 0, 0, 0, 0 },
/* U+9e1b */ { 0, 0, 0, 0, 0 },
/* U+9e1c */ { 0, 0, 0, 0, 0 },
/* U+9e1d */ { 0, 0, 0, 0, 0 },
/* U+9e1e */ { 0, 0, 0, 0, 0 },
/* U+9e1f */ { 0, 0, 0, 0, 0 },
/* U+9e20 */ { 0, 0, 0, 0, 0 },
/* U+9e21 */ { 0, 0, 0, 0, 0 },
/* U+9e22 */ { 0, 0, 0, 0, 0 },
/* U+9e23 */ { 0, 0, 0, 0, 0 },
/* U+9e24 */ { 0, 0, 0, 0, 0 },
/* U+9e25 */ { 0, 0, 0, 0, 0 },
/* U+9e26 */ { 0, 0, 0, 0, 0 },
/* U+9e27 */ { 0, 0, 0, 0, 0 },
/* U+9e28 */ { 0, 0, 0, 0, 0 },
/* U+9e29 */ { 0, 0, 0, 0, 0 },
/* U+9e2a */ { 0, 0, 0, 0, 0 },
/* U+9e2b */ { 0, 0, 0, 0, 0 },
/* U+9e2c */ { 0, 0, 0, 0, 0 },
/* U+9e2d */ { 0, 0, 0, 0, 0 },
/* U+9e2e */ { 0, 0, 0, 0, 0 },
/* U+9e2f */ { 0, 0, 0, 0, 0 },
/* U+9e30 */ { 0, 0, 0, 0, 0 },
/* U+9e31 */ { 0, 0, 0, 0, 0 },
/* U+9e32 */ { 0, 0, 0, 0, 0 },
/* U+9e33 */ { 0, 0, 0, 0, 0 },
/* U+9e34 */ { 0, 0, 0, 0, 0 },
/* U+9e35 */ { 0, 0, 0, 0, 0 },
/* U+9e36 */ { 0, 0, 0, 0, 0 },
/* U+9e37 */ { 0, 0, 0, 0, 0 },
/* U+9e38 */ { 0, 0, 0, 0, 0 },
/* U+9e39 */ { 0, 0, 0, 0, 0 },
/* U+9e3a */ { 0, 0, 0, 0, 0 },
/* U+9e3b */ { 0, 0, 0, 0, 0 },
/* U+9e3c */ { 0, 0, 0, 0, 0 },
/* U+9e3d */ { 0, 0, 0, 0, 0 },
/* U+9e3e */ { 0, 0, 0, 0, 0 },
/* U+9e3f */ { 0, 0, 0, 0, 0 },
/* U+9e40 */ { 0, 0, 0, 0, 0 },
/* U+9e41 */ { 0, 0, 0, 0, 0 },
/* U+9e42 */ { 0, 0, 0, 0, 0 },
/* U+9e43 */ { 0, 0, 0, 0, 0 },
/* U+9e44 */ { 0, 0, 0, 0, 0 },
/* U+9e45 */ { 0, 0, 0, 0, 0 },
/* U+9e46 */ { 0, 0, 0, 0, 0 },
/* U+9e47 */ { 0, 0, 0, 0, 0 },
/* U+9e48 */ { 0, 0, 0, 0, 0 },
/* U+9e49 */ { 0, 0, 0, 0, 0 },
/* U+9e4a */ { 0, 0, 0, 0, 0 },
/* U+9e4b */ { 0, 0, 0, 0, 0 },
/* U+9e4c */ { 0, 0, 0, 0, 0 },
/* U+9e4d */ { 0, 0, 0, 0, 0 },
/* U+9e4e */ { 0, 0, 0, 0, 0 },
/* U+9e4f */ { 0, 0, 0, 0, 0 },
/* U+9e50 */ { 0, 0, 0, 0, 0 },
/* U+9e51 */ { 0, 0, 0, 0, 0 },
/* U+9e52 */ { 0, 0, 0, 0, 0 },
/* U+9e53 */ { 0, 0, 0, 0, 0 },
/* U+9e54 */ { 0, 0, 0, 0, 0 },
/* U+9e55 */ { 0, 0, 0, 0, 0 },
/* U+9e56 */ { 0, 0, 0, 0, 0 },
/* U+9e57 */ { 0, 0, 0, 0, 0 },
/* U+9e58 */ { 0, 0, 0, 0, 0 },
/* U+9e59 */ { 0, 0, 0, 0, 0 },
/* U+9e5a */ { 0, 0, 0, 0, 0 },
/* U+9e5b */ { 0, 0, 0, 0, 0 },
/* U+9e5c */ { 0, 0, 0, 0, 0 },
/* U+9e5d */ { 0, 0, 0, 0, 0 },
/* U+9e5e */ { 0, 0, 0, 0, 0 },
/* U+9e5f */ { 0, 0, 0, 0, 0 },
/* U+9e60 */ { 0, 0, 0, 0, 0 },
/* U+9e61 */ { 0, 0, 0, 0, 0 },
/* U+9e62 */ { 0, 0, 0, 0, 0 },
/* U+9e63 */ { 0, 0, 0, 0, 0 },
/* U+9e64 */ { 0, 0, 0, 0, 0 },
/* U+9e65 */ { 0, 0, 0, 0, 0 },
/* U+9e66 */ { 0, 0, 0, 0, 0 },
/* U+9e67 */ { 0, 0, 0, 0, 0 },
/* U+9e68 */ { 0, 0, 0, 0, 0 },
/* U+9e69 */ { 0, 0, 0, 0, 0 },
/* U+9e6a */ { 0, 0, 0, 0, 0 },
/* U+9e6b */ { 0, 0, 0, 0, 0 },
/* U+9e6c */ { 0, 0, 0, 0, 0 },
/* U+9e6d */ { 0, 0, 0, 0, 0 },
/* U+9e6e */ { 0, 0, 0, 0, 0 },
/* U+9e6f */ { 0, 0, 0, 0, 0 },
/* U+9e70 */ { 0, 0, 0, 0, 0 },
/* U+9e71 */ { 0, 0, 0, 0, 0 },
/* U+9e72 */ { 0, 0, 0, 0, 0 },
/* U+9e73 */ { 0, 0, 0, 0, 0 },
/* U+9e74 */ { 0, 0, 0, 0, 0 },
/* U+9e75 */ { 0, 0, 0, 0, 0 },
/* U+9e76 */ { 0, 0, 0, 0, 0 },
/* U+9e77 */ { 0, 0, 0, 0, 0 },
/* U+9e78 */ { 0, 0, 0, 0, 0 },
/* U+9e79 */ { 0, 0, 0, 0, 0 },
/* U+9e7a */ { 0, 0, 0, 0, 0 },
/* U+9e7b */ { 0, 0, 0, 0, 0 },
/* U+9e7c */ { 0, 0, 0, 0, 0 },
/* U+9e7d */ { 0, 0, 0, 0, 0 },
/* U+9e7e */ { 0, 0, 0, 0, 0 },
/* U+9e7f */ { 0, 0, 0, 0, 0 },
/* U+9e80 */ { 0, 0, 0, 0, 0 },
/* U+9e81 */ { 0, 0, 0, 0, 0 },
/* U+9e82 */ { 0, 0, 0, 0, 0 },
/* U+9e83 */ { 0, 0, 0, 0, 0 },
/* U+9e84 */ { 0, 0, 0, 0, 0 },
/* U+9e85 */ { 0, 0, 0, 0, 0 },
/* U+9e86 */ { 0, 0, 0, 0, 0 },
/* U+9e87 */ { 0, 0, 0, 0, 0 },
/* U+9e88 */ { 0, 0, 0, 0, 0 },
/* U+9e89 */ { 0, 0, 0, 0, 0 },
/* U+9e8a */ { 0, 0, 0, 0, 0 },
/* U+9e8b */ { 0, 0, 0, 0, 0 },
/* U+9e8c */ { 0, 0, 0, 0, 0 },
/* U+9e8d */ { 0, 0, 0, 0, 0 },
/* U+9e8e */ { 0, 0, 0, 0, 0 },
/* U+9e8f */ { 0, 0, 0, 0, 0 },
/* U+9e90 */ { 0, 0, 0, 0, 0 },
/* U+9e91 */ { 0, 0, 0, 0, 0 },
/* U+9e92 */ { 0, 0, 0, 0, 0 },
/* U+9e93 */ { 0, 0, 0, 0, 0 },
/* U+9e94 */ { 0, 0, 0, 0, 0 },
/* U+9e95 */ { 0, 0, 0, 0, 0 },
/* U+9e96 */ { 0, 0, 0, 0, 0 },
/* U+9e97 */ { 0, 0, 0, 0, 0 },
/* U+9e98 */ { 0, 0, 0, 0, 0 },
/* U+9e99 */ { 0, 0, 0, 0, 0 },
/* U+9e9a */ { 0, 0, 0, 0, 0 },
/* U+9e9b */ { 0, 0, 0, 0, 0 },
/* U+9e9c */ { 0, 0, 0, 0, 0 },
/* U+9e9d */ { 0, 0, 0, 0, 0 },
/* U+9e9e */ { 0, 0, 0, 0, 0 },
/* U+9e9f */ { 0, 0, 0, 0, 0 },
/* U+9ea0 */ { 0, 0, 0, 0, 0 },
/* U+9ea1 */ { 0, 0, 0, 0, 0 },
/* U+9ea2 */ { 0, 0, 0, 0, 0 },
/* U+9ea3 */ { 0, 0, 0, 0, 0 },
/* U+9ea4 */ { 0, 0, 0, 0, 0 },
/* U+9ea5 */ { 0, 0, 0, 0, 0 },
/* U+9ea6 */ { 0, 0, 0, 0, 0 },
/* U+9ea7 */ { 0, 0, 0, 0, 0 },
/* U+9ea8 */ { 0, 0, 0, 0, 0 },
/* U+9ea9 */ { 0, 0, 0, 0, 0 },
/* U+9eaa */ { 0, 0, 0, 0, 0 },
/* U+9eab */ { 0, 0, 0, 0, 0 },
/* U+9eac */ { 0, 0, 0, 0, 0 },
/* U+9ead */ { 0, 0, 0, 0, 0 },
/* U+9eae */ { 0, 0, 0, 0, 0 },
/* U+9eaf */ { 0, 0, 0, 0, 0 },
/* U+9eb0 */ { 0, 0, 0, 0, 0 },
/* U+9eb1 */ { 0, 0, 0, 0, 0 },
/* U+9eb2 */ { 0, 0, 0, 0, 0 },
/* U+9eb3 */ { 0, 0, 0, 0, 0 },
/* U+9eb4 */ { 0, 0, 0, 0, 0 },
/* U+9eb5 */ { 0, 0, 0, 0, 0 },
/* U+9eb6 */ { 0, 0, 0, 0, 0 },
/* U+9eb7 */ { 0, 0, 0, 0, 0 },
/* U+9eb8 */ { 0, 0, 0, 0, 0 },
/* U+9eb9 */ { 0, 0, 0, 0, 0 },
/* U+9eba */ { 0, 0, 0, 0, 0 },
/* U+9ebb */ { 0, 0, 0, 0, 0 },
/* U+9ebc */ { 0, 0, 0, 0, 0 },
/* U+9ebd */ { 0, 0, 0, 0, 0 },
/* U+9ebe */ { 0, 0, 0, 0, 0 },
/* U+9ebf */ { 0, 0, 0, 0, 0 },
/* U+9ec0 */ { 0, 0, 0, 0, 0 },
/* U+9ec1 */ { 0, 0, 0, 0, 0 },
/* U+9ec2 */ { 0, 0, 0, 0, 0 },
/* U+9ec3 */ { 0, 0, 0, 0, 0 },
/* U+9ec4 */ { 0, 0, 0, 0, 0 },
/* U+9ec5 */ { 0, 0, 0, 0, 0 },
/* U+9ec6 */ { 0, 0, 0, 0, 0 },
/* U+9ec7 */ { 0, 0, 0, 0, 0 },
/* U+9ec8 */ { 0, 0, 0, 0, 0 },
/* U+9ec9 */ { 0, 0, 0, 0, 0 },
/* U+9eca */ { 0, 0, 0, 0, 0 },
/* U+9ecb */ { 0, 0, 0, 0, 0 },
/* U+9ecc */ { 0, 0, 0, 0, 0 },
/* U+9ecd */ { 0, 0, 0, 0, 0 },
/* U+9ece */ { 0, 0, 0, 0, 0 },
/* U+9ecf */ { 0, 0, 0, 0, 0 },
/* U+9ed0 */ { 0, 0, 0, 0, 0 },
/* U+9ed1 */ { 0, 0, 0, 0, 0 },
/* U+9ed2 */ { 0, 0, 0, 0, 0 },
/* U+9ed3 */ { 0, 0, 0, 0, 0 },
/* U+9ed4 */ { 0, 0, 0, 0, 0 },
/* U+9ed5 */ { 0, 0, 0, 0, 0 },
/* U+9ed6 */ { 0, 0, 0, 0, 0 },
/* U+9ed7 */ { 0, 0, 0, 0, 0 },
/* U+9ed8 */ { 0, 0, 0, 0, 0 },
/* U+9ed9 */ { 0, 0, 0, 0, 0 },
/* U+9eda */ { 0, 0, 0, 0, 0 },
/* U+9edb */ { 0, 0, 0, 0, 0 },
/* U+9edc */ { 0, 0, 0, 0, 0 },
/* U+9edd */ { 0, 0, 0, 0, 0 },
/* U+9ede */ { 0, 0, 0, 0, 0 },
/* U+9edf */ { 0, 0, 0, 0, 0 },
/* U+9ee0 */ { 0, 0, 0, 0, 0 },
/* U+9ee1 */ { 0, 0, 0, 0, 0 },
/* U+9ee2 */ { 0, 0, 0, 0, 0 },
/* U+9ee3 */ { 0, 0, 0, 0, 0 },
/* U+9ee4 */ { 0, 0, 0, 0, 0 },
/* U+9ee5 */ { 0, 0, 0, 0, 0 },
/* U+9ee6 */ { 0, 0, 0, 0, 0 },
/* U+9ee7 */ { 0, 0, 0, 0, 0 },
/* U+9ee8 */ { 0, 0, 0, 0, 0 },
/* U+9ee9 */ { 0, 0, 0, 0, 0 },
/* U+9eea */ { 0, 0, 0, 0, 0 },
/* U+9eeb */ { 0, 0, 0, 0, 0 },
/* U+9eec */ { 0, 0, 0, 0, 0 },
/* U+9eed */ { 0, 0, 0, 0, 0 },
/* U+9eee */ { 0, 0, 0, 0, 0 },
/* U+9eef */ { 0, 0, 0, 0, 0 },
/* U+9ef0 */ { 0, 0, 0, 0, 0 },
/* U+9ef1 */ { 0, 0, 0, 0, 0 },
/* U+9ef2 */ { 0, 0, 0, 0, 0 },
/* U+9ef3 */ { 0, 0, 0, 0, 0 },
/* U+9ef4 */ { 0, 0, 0, 0, 0 },
/* U+9ef5 */ { 0, 0, 0, 0, 0 },
/* U+9ef6 */ { 0, 0, 0, 0, 0 },
/* U+9ef7 */ { 0, 0, 0, 0, 0 },
/* U+9ef8 */ { 0, 0, 0, 0, 0 },
/* U+9ef9 */ { 0, 0, 0, 0, 0 },
/* U+9efa */ { 0, 0, 0, 0, 0 },
/* U+9efb */ { 0, 0, 0, 0, 0 },
/* U+9efc */ { 0, 0, 0, 0, 0 },
/* U+9efd */ { 0, 0, 0, 0, 0 },
/* U+9efe */ { 0, 0, 0, 0, 0 },
/* U+9eff */ { 0, 0, 0, 0, 0 },
/* U+9f00 */ { 0, 0, 0, 0, 0 },
/* U+9f01 */ { 0, 0, 0, 0, 0 },
/* U+9f02 */ { 0, 0, 0, 0, 0 },
/* U+9f03 */ { 0, 0, 0, 0, 0 },
/* U+9f04 */ { 0, 0, 0, 0, 0 },
/* U+9f05 */ { 0, 0, 0, 0, 0 },
/* U+9f06 */ { 0, 0, 0, 0, 0 },
/* U+9f07 */ { 0, 0, 0, 0, 0 },
/* U+9f08 */ { 0, 0, 0, 0, 0 },
/* U+9f09 */ { 0, 0, 0, 0, 0 },
/* U+9f0a */ { 0, 0, 0, 0, 0 },
/* U+9f0b */ { 0, 0, 0, 0, 0 },
/* U+9f0c */ { 0, 0, 0, 0, 0 },
/* U+9f0d */ { 0, 0, 0, 0, 0 },
/* U+9f0e */ { 0, 0, 0, 0, 0 },
/* U+9f0f */ { 0, 0, 0, 0, 0 },
/* U+9f10 */ { 0, 0, 0, 0, 0 },
/* U+9f11 */ { 0, 0, 0, 0, 0 },
/* U+9f12 */ { 0, 0, 0, 0, 0 },
/* U+9f13 */ { 0, 0, 0, 0, 0 },
/* U+9f14 */ { 0, 0, 0, 0, 0 },
/* U+9f15 */ { 0, 0, 0, 0, 0 },
/* U+9f16 */ { 0, 0, 0, 0, 0 },
/* U+9f17 */ { 0, 0, 0, 0, 0 },
/* U+9f18 */ { 0, 0, 0, 0, 0 },
/* U+9f19 */ { 0, 0, 0, 0, 0 },
/* U+9f1a */ { 0, 0, 0, 0, 0 },
/* U+9f1b */ { 0, 0, 0, 0, 0 },
/* U+9f1c */ { 0, 0, 0, 0, 0 },
/* U+9f1d */ { 0, 0, 0, 0, 0 },
/* U+9f1e */ { 0, 0, 0, 0, 0 },
/* U+9f1f */ { 0, 0, 0, 0, 0 },
/* U+9f20 */ { 0, 0, 0, 0, 0 },
/* U+9f21 */ { 0, 0, 0, 0, 0 },
/* U+9f22 */ { 0, 0, 0, 0, 0 },
/* U+9f23 */ { 0, 0, 0, 0, 0 },
/* U+9f24 */ { 0, 0, 0, 0, 0 },
/* U+9f25 */ { 0, 0, 0, 0, 0 },
/* U+9f26 */ { 0, 0, 0, 0, 0 },
/* U+9f27 */ { 0, 0, 0, 0, 0 },
/* U+9f28 */ { 0, 0, 0, 0, 0 },
/* U+9f29 */ { 0, 0, 0, 0, 0 },
/* U+9f2a */ { 0, 0, 0, 0, 0 },
/* U+9f2b */ { 0, 0, 0, 0, 0 },
/* U+9f2c */ { 0, 0, 0, 0, 0 },
/* U+9f2d */ { 0, 0, 0, 0, 0 },
/* U+9f2e */ { 0, 0, 0, 0, 0 },
/* U+9f2f */ { 0, 0, 0, 0, 0 },
/* U+9f30 */ { 0, 0, 0, 0, 0 },
/* U+9f31 */ { 0, 0, 0, 0, 0 },
/* U+9f32 */ { 0, 0, 0, 0, 0 },
/* U+9f33 */ { 0, 0, 0, 0, 0 },
/* U+9f34 */ { 0, 0, 0, 0, 0 },
/* U+9f35 */ { 0, 0, 0, 0, 0 },
/* U+9f36 */ { 0, 0, 0, 0, 0 },
/* U+9f37 */ { 0, 0, 0, 0, 0 },
/* U+9f38 */ { 0, 0, 0, 0, 0 },
/* U+9f39 */ { 0, 0, 0, 0, 0 },
/* U+9f3a */ { 0, 0, 0, 0, 0 },
/* U+9f3b */ { 0, 0, 0, 0, 0 },
/* U+9f3c */ { 0, 0, 0, 0, 0 },
/* U+9f3d */ { 0, 0, 0, 0, 0 },
/* U+9f3e */ { 0, 0, 0, 0, 0 },
/* U+9f3f */ { 0, 0, 0, 0, 0 },
/* U+9f40 */ { 0, 0, 0, 0, 0 },
/* U+9f41 */ { 0, 0, 0, 0, 0 },
/* U+9f42 */ { 0, 0, 0, 0, 0 },
/* U+9f43 */ { 0, 0, 0, 0, 0 },
/* U+9f44 */ { 0, 0, 0, 0, 0 },
/* U+9f45 */ { 0, 0, 0, 0, 0 },
/* U+9f46 */ { 0, 0, 0, 0, 0 },
/* U+9f47 */ { 0, 0, 0, 0, 0 },
/* U+9f48 */ { 0, 0, 0, 0, 0 },
/* U+9f49 */ { 0, 0, 0, 0, 0 },
/* U+9f4a */ { 0, 0, 0, 0, 0 },
/* U+9f4b */ { 0, 0, 0, 0, 0 },
/* U+9f4c */ { 0, 0, 0, 0, 0 },
/* U+9f4d */ { 0, 0, 0, 0, 0 },
/* U+9f4e */ { 0, 0, 0, 0, 0 },
/* U+9f4f */ { 0, 0, 0, 0, 0 },
/* U+9f50 */ { 0, 0, 0, 0, 0 },
/* U+9f51 */ { 0, 0, 0, 0, 0 },
/* U+9f52 */ { 0, 0, 0, 0, 0 },
/* U+9f53 */ { 0, 0, 0, 0, 0 },
/* U+9f54 */ { 0, 0, 0, 0, 0 },
/* U+9f55 */ { 0, 0, 0, 0, 0 },
/* U+9f56 */ { 0, 0, 0, 0, 0 },
/* U+9f57 */ { 0, 0, 0, 0, 0 },
/* U+9f58 */ { 0, 0, 0, 0, 0 },
/* U+9f59 */ { 0, 0, 0, 0, 0 },
/* U+9f5a */ { 0, 0, 0, 0, 0 },
/* U+9f5b */ { 0, 0, 0, 0, 0 },
/* U+9f5c */ { 0, 0, 0, 0, 0 },
/* U+9f5d */ { 0, 0, 0, 0, 0 },
/* U+9f5e */ { 0, 0, 0, 0, 0 },
/* U+9f5f */ { 0, 0, 0, 0, 0 },
/* U+9f60 */ { 0, 0, 0, 0, 0 },
/* U+9f61 */ { 0, 0, 0, 0, 0 },
/* U+9f62 */ { 0, 0, 0, 0, 0 },
/* U+9f63 */ { 0, 0, 0, 0, 0 },
/* U+9f64 */ { 0, 0, 0, 0, 0 },
/* U+9f65 */ { 0, 0, 0, 0, 0 },
/* U+9f66 */ { 0, 0, 0, 0, 0 },
/* U+9f67 */ { 0, 0, 0, 0, 0 },
/* U+9f68 */ { 0, 0, 0, 0, 0 },
/* U+9f69 */ { 0, 0, 0, 0, 0 },
/* U+9f6a */ { 0, 0, 0, 0, 0 },
/* U+9f6b */ { 0, 0, 0, 0, 0 },
/* U+9f6c */ { 0, 0, 0, 0, 0 },
/* U+9f6d */ { 0, 0, 0, 0, 0 },
/* U+9f6e */ { 0, 0, 0, 0, 0 },
/* U+9f6f */ { 0, 0, 0, 0, 0 },
/* U+9f70 */ { 0, 0, 0, 0, 0 },
/* U+9f71 */ { 0, 0, 0, 0, 0 },
/* U+9f72 */ { 0, 0, 0, 0, 0 },
/* U+9f73 */ { 0, 0, 0, 0, 0 },
/* U+9f74 */ { 0, 0, 0, 0, 0 },
/* U+9f75 */ { 0, 0, 0, 0, 0 },
/* U+9f76 */ { 0, 0, 0, 0, 0 },
/* U+9f77 */ { 0, 0, 0, 0, 0 },
/* U+9f78 */ { 0, 0, 0, 0, 0 },
/* U+9f79 */ { 0, 0, 0, 0, 0 },
/* U+9f7a */ { 0, 0, 0, 0, 0 },
/* U+9f7b */ { 0, 0, 0, 0, 0 },
/* U+9f7c */ { 0, 0, 0, 0, 0 },
/* U+9f7d */ { 0, 0, 0, 0, 0 },
/* U+9f7e */ { 0, 0, 0, 0, 0 },
/* U+9f7f */ { 0, 0, 0, 0, 0 },
/* U+9f80 */ { 0, 0, 0, 0, 0 },
/* U+9f81 */ { 0, 0, 0, 0, 0 },
/* U+9f82 */ { 0, 0, 0, 0, 0 },
/* U+9f83 */ { 0, 0, 0, 0, 0 },
/* U+9f84 */ { 0, 0, 0, 0, 0 },
/* U+9f85 */ { 0, 0, 0, 0, 0 },
/* U+9f86 */ { 0, 0, 0, 0, 0 },
/* U+9f87 */ { 0, 0, 0, 0, 0 },
/* U+9f88 */ { 0, 0, 0, 0, 0 },
/* U+9f89 */ { 0, 0, 0, 0, 0 },
/* U+9f8a */ { 0, 0, 0, 0, 0 },
/* U+9f8b */ { 0, 0, 0, 0, 0 },
/* U+9f8c */ { 0, 0, 0, 0, 0 },
/* U+9f8d */ { 0, 0, 0, 0, 0 },
/* U+9f8e */ { 0, 0, 0, 0, 0 },
/* U+9f8f */ { 0, 0, 0, 0, 0 },
/* U+9f90 */ { 0, 0, 0, 0, 0 },
/* U+9f91 */ { 0, 0, 0, 0, 0 },
/* U+9f92 */ { 0, 0, 0, 0, 0 },
/* U+9f93 */ { 0, 0, 0, 0, 0 },
/* U+9f94 */ { 0, 0, 0, 0, 0 },
/* U+9f95 */ { 0, 0, 0, 0, 0 },
/* U+9f96 */ { 0, 0, 0, 0, 0 },
/* U+9f97 */ { 0, 0, 0, 0, 0 },
/* U+9f98 */ { 0, 0, 0, 0, 0 },
/* U+9f99 */ { 0, 0, 0, 0, 0 },
/* U+9f9a */ { 0, 0, 0, 0, 0 },
/* U+9f9b */ { 0, 0, 0, 0, 0 },
/* U+9f9c */ { 0, 0, 0, 0, 0 },
/* U+9f9d */ { 0, 0, 0, 0, 0 },
/* U+9f9e */ { 0, 0, 0, 0, 0 },
/* U+9f9f */ { 0, 0, 0, 0, 0 },
/* U+9fa0 */ { 0, 0, 0, 0, 0 },
/* U+9fa1 */ { 0, 0, 0, 0, 0 },
/* U+9fa2 */ { 0, 0, 0, 0, 0 },
/* U+9fa3 */ { 0, 0, 0, 0, 0 },
/* U+9fa4 */ { 0, 0, 0, 0, 0 },
/* U+9fa5 */ { 19, 0, 1, 0, 0 },
/* U+9fa6 */ { 0, 0, 0, 0, 0 },
/* U+9fa7 */ { 0, 0, 0, 0, 0 },
/* U+9fa8 */ { 0, 0, 0, 0, 0 },
/* U+9fa9 */ { 0, 0, 0, 0, 0 },
/* U+9faa */ { 0, 0, 0, 0, 0 },
/* U+9fab */ { 0, 0, 0, 0, 0 },
/* U+9fac */ { 0, 0, 0, 0, 0 },
/* U+9fad */ { 0, 0, 0, 0, 0 },
/* U+9fae */ { 0, 0, 0, 0, 0 },
/* U+9faf */ { 0, 0, 0, 0, 0 },
/* U+9fb0 */ { 0, 0, 0, 0, 0 },
/* U+9fb1 */ { 0, 0, 0, 0, 0 },
/* U+9fb2 */ { 0, 0, 0, 0, 0 },
/* U+9fb3 */ { 0, 0, 0, 0, 0 },
/* U+9fb4 */ { 0, 0, 0, 0, 0 },
/* U+9fb5 */ { 0, 0, 0, 0, 0 },
/* U+9fb6 */ { 0, 0, 0, 0, 0 },
/* U+9fb7 */ { 0, 0, 0, 0, 0 },
/* U+9fb8 */ { 0, 0, 0, 0, 0 },
/* U+9fb9 */ { 0, 0, 0, 0, 0 },
/* U+9fba */ { 0, 0, 0, 0, 0 },
/* U+9fbb */ { 0, 0, 0, 0, 0 },
/* U+9fbc */ { 0, 0, 0, 0, 0 },
/* U+9fbd */ { 0, 0, 0, 0, 0 },
/* U+9fbe */ { 0, 0, 0, 0, 0 },
/* U+9fbf */ { 0, 0, 0, 0, 0 },
/* U+9fc0 */ { 0, 0, 0, 0, 0 },
/* U+9fc1 */ { 0, 0, 0, 0, 0 },
/* U+9fc2 */ { 0, 0, 0, 0, 0 },
/* U+9fc3 */ { 0, 0, 0, 0, 0 },
/* U+9fc4 */ { 0, 0, 0, 0, 0 },
/* U+9fc5 */ { 0, 0, 0, 0, 0 },
/* U+9fc6 */ { 0, 0, 0, 0, 0 },
/* U+9fc7 */ { 0, 0, 0, 0, 0 },
/* U+9fc8 */ { 0, 0, 0, 0, 0 },
/* U+9fc9 */ { 0, 0, 0, 0, 0 },
/* U+9fca */ { 0, 0, 0, 0, 0 },
/* U+9fcb */ { 0, 0, 0, 0, 0 },
/* U+9fcc */ { 0, 0, 0, 0, 0 },
/* U+9fcd */ { 0, 0, 0, 0, 0 },
/* U+9fce */ { 0, 0, 0, 0, 0 },
/* U+9fcf */ { 0, 0, 0, 0, 0 },
/* U+9fd0 */ { 0, 0, 0, 0, 0 },
/* U+9fd1 */ { 0, 0, 0, 0, 0 },
/* U+9fd2 */ { 0, 0, 0, 0, 0 },
/* U+9fd3 */ { 0, 0, 0, 0, 0 },
/* U+9fd4 */ { 0, 0, 0, 0, 0 },
/* U+9fd5 */ { 0, 0, 0, 0, 0 },
/* U+9fd6 */ { 0, 0, 0, 0, 0 },
/* U+9fd7 */ { 0, 0, 0, 0, 0 },
/* U+9fd8 */ { 0, 0, 0, 0, 0 },
/* U+9fd9 */ { 0, 0, 0, 0, 0 },
/* U+9fda */ { 0, 0, 0, 0, 0 },
/* U+9fdb */ { 0, 0, 0, 0, 0 },
/* U+9fdc */ { 0, 0, 0, 0, 0 },
/* U+9fdd */ { 0, 0, 0, 0, 0 },
/* U+9fde */ { 0, 0, 0, 0, 0 },
/* U+9fdf */ { 0, 0, 0, 0, 0 },
/* U+9fe0 */ { 0, 0, 0, 0, 0 },
/* U+9fe1 */ { 0, 0, 0, 0, 0 },
/* U+9fe2 */ { 0, 0, 0, 0, 0 },
/* U+9fe3 */ { 0, 0, 0, 0, 0 },
/* U+9fe4 */ { 0, 0, 0, 0, 0 },
/* U+9fe5 */ { 0, 0, 0, 0, 0 },
/* U+9fe6 */ { 0, 0, 0, 0, 0 },
/* U+9fe7 */ { 0, 0, 0, 0, 0 },
/* U+9fe8 */ { 0, 0, 0, 0, 0 },
/* U+9fe9 */ { 0, 0, 0, 0, 0 },
/* U+9fea */ { 0, 0, 0, 0, 0 },
/* U+9feb */ { 0, 0, 0, 0, 0 },
/* U+9fec */ { 0, 0, 0, 0, 0 },
/* U+9fed */ { 0, 0, 0, 0, 0 },
/* U+9fee */ { 0, 0, 0, 0, 0 },
/* U+9fef */ { 0, 0, 0, 0, 0 },
/* U+9ff0 */ { 0, 0, 0, 0, 0 },
/* U+9ff1 */ { 0, 0, 0, 0, 0 },
/* U+9ff2 */ { 0, 0, 0, 0, 0 },
/* U+9ff3 */ { 0, 0, 0, 0, 0 },
/* U+9ff4 */ { 0, 0, 0, 0, 0 },
/* U+9ff5 */ { 0, 0, 0, 0, 0 },
/* U+9ff6 */ { 0, 0, 0, 0, 0 },
/* U+9ff7 */ { 0, 0, 0, 0, 0 },
/* U+9ff8 */ { 0, 0, 0, 0, 0 },
/* U+9ff9 */ { 0, 0, 0, 0, 0 },
/* U+9ffa */ { 0, 0, 0, 0, 0 },
/* U+9ffb */ { 0, 0, 0, 0, 0 },
/* U+9ffc */ { 0, 0, 0, 0, 0 },
/* U+9ffd */ { 0, 0, 0, 0, 0 },
/* U+9ffe */ { 0, 0, 0, 0, 0 },
/* U+9fff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_10[4096] = {
    
/* U+a000 */ { 19, 0, 1, 0, 0 },
/* U+a001 */ { 19, 0, 1, 0, 0 },
/* U+a002 */ { 19, 0, 1, 0, 0 },
/* U+a003 */ { 19, 0, 1, 0, 0 },
/* U+a004 */ { 19, 0, 1, 0, 0 },
/* U+a005 */ { 19, 0, 1, 0, 0 },
/* U+a006 */ { 19, 0, 1, 0, 0 },
/* U+a007 */ { 19, 0, 1, 0, 0 },
/* U+a008 */ { 19, 0, 1, 0, 0 },
/* U+a009 */ { 19, 0, 1, 0, 0 },
/* U+a00a */ { 19, 0, 1, 0, 0 },
/* U+a00b */ { 19, 0, 1, 0, 0 },
/* U+a00c */ { 19, 0, 1, 0, 0 },
/* U+a00d */ { 19, 0, 1, 0, 0 },
/* U+a00e */ { 19, 0, 1, 0, 0 },
/* U+a00f */ { 19, 0, 1, 0, 0 },
/* U+a010 */ { 19, 0, 1, 0, 0 },
/* U+a011 */ { 19, 0, 1, 0, 0 },
/* U+a012 */ { 19, 0, 1, 0, 0 },
/* U+a013 */ { 19, 0, 1, 0, 0 },
/* U+a014 */ { 19, 0, 1, 0, 0 },
/* U+a015 */ { 19, 0, 1, 0, 0 },
/* U+a016 */ { 19, 0, 1, 0, 0 },
/* U+a017 */ { 19, 0, 1, 0, 0 },
/* U+a018 */ { 19, 0, 1, 0, 0 },
/* U+a019 */ { 19, 0, 1, 0, 0 },
/* U+a01a */ { 19, 0, 1, 0, 0 },
/* U+a01b */ { 19, 0, 1, 0, 0 },
/* U+a01c */ { 19, 0, 1, 0, 0 },
/* U+a01d */ { 19, 0, 1, 0, 0 },
/* U+a01e */ { 19, 0, 1, 0, 0 },
/* U+a01f */ { 19, 0, 1, 0, 0 },
/* U+a020 */ { 19, 0, 1, 0, 0 },
/* U+a021 */ { 19, 0, 1, 0, 0 },
/* U+a022 */ { 19, 0, 1, 0, 0 },
/* U+a023 */ { 19, 0, 1, 0, 0 },
/* U+a024 */ { 19, 0, 1, 0, 0 },
/* U+a025 */ { 19, 0, 1, 0, 0 },
/* U+a026 */ { 19, 0, 1, 0, 0 },
/* U+a027 */ { 19, 0, 1, 0, 0 },
/* U+a028 */ { 19, 0, 1, 0, 0 },
/* U+a029 */ { 19, 0, 1, 0, 0 },
/* U+a02a */ { 19, 0, 1, 0, 0 },
/* U+a02b */ { 19, 0, 1, 0, 0 },
/* U+a02c */ { 19, 0, 1, 0, 0 },
/* U+a02d */ { 19, 0, 1, 0, 0 },
/* U+a02e */ { 19, 0, 1, 0, 0 },
/* U+a02f */ { 19, 0, 1, 0, 0 },
/* U+a030 */ { 19, 0, 1, 0, 0 },
/* U+a031 */ { 19, 0, 1, 0, 0 },
/* U+a032 */ { 19, 0, 1, 0, 0 },
/* U+a033 */ { 19, 0, 1, 0, 0 },
/* U+a034 */ { 19, 0, 1, 0, 0 },
/* U+a035 */ { 19, 0, 1, 0, 0 },
/* U+a036 */ { 19, 0, 1, 0, 0 },
/* U+a037 */ { 19, 0, 1, 0, 0 },
/* U+a038 */ { 19, 0, 1, 0, 0 },
/* U+a039 */ { 19, 0, 1, 0, 0 },
/* U+a03a */ { 19, 0, 1, 0, 0 },
/* U+a03b */ { 19, 0, 1, 0, 0 },
/* U+a03c */ { 19, 0, 1, 0, 0 },
/* U+a03d */ { 19, 0, 1, 0, 0 },
/* U+a03e */ { 19, 0, 1, 0, 0 },
/* U+a03f */ { 19, 0, 1, 0, 0 },
/* U+a040 */ { 19, 0, 1, 0, 0 },
/* U+a041 */ { 19, 0, 1, 0, 0 },
/* U+a042 */ { 19, 0, 1, 0, 0 },
/* U+a043 */ { 19, 0, 1, 0, 0 },
/* U+a044 */ { 19, 0, 1, 0, 0 },
/* U+a045 */ { 19, 0, 1, 0, 0 },
/* U+a046 */ { 19, 0, 1, 0, 0 },
/* U+a047 */ { 19, 0, 1, 0, 0 },
/* U+a048 */ { 19, 0, 1, 0, 0 },
/* U+a049 */ { 19, 0, 1, 0, 0 },
/* U+a04a */ { 19, 0, 1, 0, 0 },
/* U+a04b */ { 19, 0, 1, 0, 0 },
/* U+a04c */ { 19, 0, 1, 0, 0 },
/* U+a04d */ { 19, 0, 1, 0, 0 },
/* U+a04e */ { 19, 0, 1, 0, 0 },
/* U+a04f */ { 19, 0, 1, 0, 0 },
/* U+a050 */ { 19, 0, 1, 0, 0 },
/* U+a051 */ { 19, 0, 1, 0, 0 },
/* U+a052 */ { 19, 0, 1, 0, 0 },
/* U+a053 */ { 19, 0, 1, 0, 0 },
/* U+a054 */ { 19, 0, 1, 0, 0 },
/* U+a055 */ { 19, 0, 1, 0, 0 },
/* U+a056 */ { 19, 0, 1, 0, 0 },
/* U+a057 */ { 19, 0, 1, 0, 0 },
/* U+a058 */ { 19, 0, 1, 0, 0 },
/* U+a059 */ { 19, 0, 1, 0, 0 },
/* U+a05a */ { 19, 0, 1, 0, 0 },
/* U+a05b */ { 19, 0, 1, 0, 0 },
/* U+a05c */ { 19, 0, 1, 0, 0 },
/* U+a05d */ { 19, 0, 1, 0, 0 },
/* U+a05e */ { 19, 0, 1, 0, 0 },
/* U+a05f */ { 19, 0, 1, 0, 0 },
/* U+a060 */ { 19, 0, 1, 0, 0 },
/* U+a061 */ { 19, 0, 1, 0, 0 },
/* U+a062 */ { 19, 0, 1, 0, 0 },
/* U+a063 */ { 19, 0, 1, 0, 0 },
/* U+a064 */ { 19, 0, 1, 0, 0 },
/* U+a065 */ { 19, 0, 1, 0, 0 },
/* U+a066 */ { 19, 0, 1, 0, 0 },
/* U+a067 */ { 19, 0, 1, 0, 0 },
/* U+a068 */ { 19, 0, 1, 0, 0 },
/* U+a069 */ { 19, 0, 1, 0, 0 },
/* U+a06a */ { 19, 0, 1, 0, 0 },
/* U+a06b */ { 19, 0, 1, 0, 0 },
/* U+a06c */ { 19, 0, 1, 0, 0 },
/* U+a06d */ { 19, 0, 1, 0, 0 },
/* U+a06e */ { 19, 0, 1, 0, 0 },
/* U+a06f */ { 19, 0, 1, 0, 0 },
/* U+a070 */ { 19, 0, 1, 0, 0 },
/* U+a071 */ { 19, 0, 1, 0, 0 },
/* U+a072 */ { 19, 0, 1, 0, 0 },
/* U+a073 */ { 19, 0, 1, 0, 0 },
/* U+a074 */ { 19, 0, 1, 0, 0 },
/* U+a075 */ { 19, 0, 1, 0, 0 },
/* U+a076 */ { 19, 0, 1, 0, 0 },
/* U+a077 */ { 19, 0, 1, 0, 0 },
/* U+a078 */ { 19, 0, 1, 0, 0 },
/* U+a079 */ { 19, 0, 1, 0, 0 },
/* U+a07a */ { 19, 0, 1, 0, 0 },
/* U+a07b */ { 19, 0, 1, 0, 0 },
/* U+a07c */ { 19, 0, 1, 0, 0 },
/* U+a07d */ { 19, 0, 1, 0, 0 },
/* U+a07e */ { 19, 0, 1, 0, 0 },
/* U+a07f */ { 19, 0, 1, 0, 0 },
/* U+a080 */ { 19, 0, 1, 0, 0 },
/* U+a081 */ { 19, 0, 1, 0, 0 },
/* U+a082 */ { 19, 0, 1, 0, 0 },
/* U+a083 */ { 19, 0, 1, 0, 0 },
/* U+a084 */ { 19, 0, 1, 0, 0 },
/* U+a085 */ { 19, 0, 1, 0, 0 },
/* U+a086 */ { 19, 0, 1, 0, 0 },
/* U+a087 */ { 19, 0, 1, 0, 0 },
/* U+a088 */ { 19, 0, 1, 0, 0 },
/* U+a089 */ { 19, 0, 1, 0, 0 },
/* U+a08a */ { 19, 0, 1, 0, 0 },
/* U+a08b */ { 19, 0, 1, 0, 0 },
/* U+a08c */ { 19, 0, 1, 0, 0 },
/* U+a08d */ { 19, 0, 1, 0, 0 },
/* U+a08e */ { 19, 0, 1, 0, 0 },
/* U+a08f */ { 19, 0, 1, 0, 0 },
/* U+a090 */ { 19, 0, 1, 0, 0 },
/* U+a091 */ { 19, 0, 1, 0, 0 },
/* U+a092 */ { 19, 0, 1, 0, 0 },
/* U+a093 */ { 19, 0, 1, 0, 0 },
/* U+a094 */ { 19, 0, 1, 0, 0 },
/* U+a095 */ { 19, 0, 1, 0, 0 },
/* U+a096 */ { 19, 0, 1, 0, 0 },
/* U+a097 */ { 19, 0, 1, 0, 0 },
/* U+a098 */ { 19, 0, 1, 0, 0 },
/* U+a099 */ { 19, 0, 1, 0, 0 },
/* U+a09a */ { 19, 0, 1, 0, 0 },
/* U+a09b */ { 19, 0, 1, 0, 0 },
/* U+a09c */ { 19, 0, 1, 0, 0 },
/* U+a09d */ { 19, 0, 1, 0, 0 },
/* U+a09e */ { 19, 0, 1, 0, 0 },
/* U+a09f */ { 19, 0, 1, 0, 0 },
/* U+a0a0 */ { 19, 0, 1, 0, 0 },
/* U+a0a1 */ { 19, 0, 1, 0, 0 },
/* U+a0a2 */ { 19, 0, 1, 0, 0 },
/* U+a0a3 */ { 19, 0, 1, 0, 0 },
/* U+a0a4 */ { 19, 0, 1, 0, 0 },
/* U+a0a5 */ { 19, 0, 1, 0, 0 },
/* U+a0a6 */ { 19, 0, 1, 0, 0 },
/* U+a0a7 */ { 19, 0, 1, 0, 0 },
/* U+a0a8 */ { 19, 0, 1, 0, 0 },
/* U+a0a9 */ { 19, 0, 1, 0, 0 },
/* U+a0aa */ { 19, 0, 1, 0, 0 },
/* U+a0ab */ { 19, 0, 1, 0, 0 },
/* U+a0ac */ { 19, 0, 1, 0, 0 },
/* U+a0ad */ { 19, 0, 1, 0, 0 },
/* U+a0ae */ { 19, 0, 1, 0, 0 },
/* U+a0af */ { 19, 0, 1, 0, 0 },
/* U+a0b0 */ { 19, 0, 1, 0, 0 },
/* U+a0b1 */ { 19, 0, 1, 0, 0 },
/* U+a0b2 */ { 19, 0, 1, 0, 0 },
/* U+a0b3 */ { 19, 0, 1, 0, 0 },
/* U+a0b4 */ { 19, 0, 1, 0, 0 },
/* U+a0b5 */ { 19, 0, 1, 0, 0 },
/* U+a0b6 */ { 19, 0, 1, 0, 0 },
/* U+a0b7 */ { 19, 0, 1, 0, 0 },
/* U+a0b8 */ { 19, 0, 1, 0, 0 },
/* U+a0b9 */ { 19, 0, 1, 0, 0 },
/* U+a0ba */ { 19, 0, 1, 0, 0 },
/* U+a0bb */ { 19, 0, 1, 0, 0 },
/* U+a0bc */ { 19, 0, 1, 0, 0 },
/* U+a0bd */ { 19, 0, 1, 0, 0 },
/* U+a0be */ { 19, 0, 1, 0, 0 },
/* U+a0bf */ { 19, 0, 1, 0, 0 },
/* U+a0c0 */ { 19, 0, 1, 0, 0 },
/* U+a0c1 */ { 19, 0, 1, 0, 0 },
/* U+a0c2 */ { 19, 0, 1, 0, 0 },
/* U+a0c3 */ { 19, 0, 1, 0, 0 },
/* U+a0c4 */ { 19, 0, 1, 0, 0 },
/* U+a0c5 */ { 19, 0, 1, 0, 0 },
/* U+a0c6 */ { 19, 0, 1, 0, 0 },
/* U+a0c7 */ { 19, 0, 1, 0, 0 },
/* U+a0c8 */ { 19, 0, 1, 0, 0 },
/* U+a0c9 */ { 19, 0, 1, 0, 0 },
/* U+a0ca */ { 19, 0, 1, 0, 0 },
/* U+a0cb */ { 19, 0, 1, 0, 0 },
/* U+a0cc */ { 19, 0, 1, 0, 0 },
/* U+a0cd */ { 19, 0, 1, 0, 0 },
/* U+a0ce */ { 19, 0, 1, 0, 0 },
/* U+a0cf */ { 19, 0, 1, 0, 0 },
/* U+a0d0 */ { 19, 0, 1, 0, 0 },
/* U+a0d1 */ { 19, 0, 1, 0, 0 },
/* U+a0d2 */ { 19, 0, 1, 0, 0 },
/* U+a0d3 */ { 19, 0, 1, 0, 0 },
/* U+a0d4 */ { 19, 0, 1, 0, 0 },
/* U+a0d5 */ { 19, 0, 1, 0, 0 },
/* U+a0d6 */ { 19, 0, 1, 0, 0 },
/* U+a0d7 */ { 19, 0, 1, 0, 0 },
/* U+a0d8 */ { 19, 0, 1, 0, 0 },
/* U+a0d9 */ { 19, 0, 1, 0, 0 },
/* U+a0da */ { 19, 0, 1, 0, 0 },
/* U+a0db */ { 19, 0, 1, 0, 0 },
/* U+a0dc */ { 19, 0, 1, 0, 0 },
/* U+a0dd */ { 19, 0, 1, 0, 0 },
/* U+a0de */ { 19, 0, 1, 0, 0 },
/* U+a0df */ { 19, 0, 1, 0, 0 },
/* U+a0e0 */ { 19, 0, 1, 0, 0 },
/* U+a0e1 */ { 19, 0, 1, 0, 0 },
/* U+a0e2 */ { 19, 0, 1, 0, 0 },
/* U+a0e3 */ { 19, 0, 1, 0, 0 },
/* U+a0e4 */ { 19, 0, 1, 0, 0 },
/* U+a0e5 */ { 19, 0, 1, 0, 0 },
/* U+a0e6 */ { 19, 0, 1, 0, 0 },
/* U+a0e7 */ { 19, 0, 1, 0, 0 },
/* U+a0e8 */ { 19, 0, 1, 0, 0 },
/* U+a0e9 */ { 19, 0, 1, 0, 0 },
/* U+a0ea */ { 19, 0, 1, 0, 0 },
/* U+a0eb */ { 19, 0, 1, 0, 0 },
/* U+a0ec */ { 19, 0, 1, 0, 0 },
/* U+a0ed */ { 19, 0, 1, 0, 0 },
/* U+a0ee */ { 19, 0, 1, 0, 0 },
/* U+a0ef */ { 19, 0, 1, 0, 0 },
/* U+a0f0 */ { 19, 0, 1, 0, 0 },
/* U+a0f1 */ { 19, 0, 1, 0, 0 },
/* U+a0f2 */ { 19, 0, 1, 0, 0 },
/* U+a0f3 */ { 19, 0, 1, 0, 0 },
/* U+a0f4 */ { 19, 0, 1, 0, 0 },
/* U+a0f5 */ { 19, 0, 1, 0, 0 },
/* U+a0f6 */ { 19, 0, 1, 0, 0 },
/* U+a0f7 */ { 19, 0, 1, 0, 0 },
/* U+a0f8 */ { 19, 0, 1, 0, 0 },
/* U+a0f9 */ { 19, 0, 1, 0, 0 },
/* U+a0fa */ { 19, 0, 1, 0, 0 },
/* U+a0fb */ { 19, 0, 1, 0, 0 },
/* U+a0fc */ { 19, 0, 1, 0, 0 },
/* U+a0fd */ { 19, 0, 1, 0, 0 },
/* U+a0fe */ { 19, 0, 1, 0, 0 },
/* U+a0ff */ { 19, 0, 1, 0, 0 },
/* U+a100 */ { 19, 0, 1, 0, 0 },
/* U+a101 */ { 19, 0, 1, 0, 0 },
/* U+a102 */ { 19, 0, 1, 0, 0 },
/* U+a103 */ { 19, 0, 1, 0, 0 },
/* U+a104 */ { 19, 0, 1, 0, 0 },
/* U+a105 */ { 19, 0, 1, 0, 0 },
/* U+a106 */ { 19, 0, 1, 0, 0 },
/* U+a107 */ { 19, 0, 1, 0, 0 },
/* U+a108 */ { 19, 0, 1, 0, 0 },
/* U+a109 */ { 19, 0, 1, 0, 0 },
/* U+a10a */ { 19, 0, 1, 0, 0 },
/* U+a10b */ { 19, 0, 1, 0, 0 },
/* U+a10c */ { 19, 0, 1, 0, 0 },
/* U+a10d */ { 19, 0, 1, 0, 0 },
/* U+a10e */ { 19, 0, 1, 0, 0 },
/* U+a10f */ { 19, 0, 1, 0, 0 },
/* U+a110 */ { 19, 0, 1, 0, 0 },
/* U+a111 */ { 19, 0, 1, 0, 0 },
/* U+a112 */ { 19, 0, 1, 0, 0 },
/* U+a113 */ { 19, 0, 1, 0, 0 },
/* U+a114 */ { 19, 0, 1, 0, 0 },
/* U+a115 */ { 19, 0, 1, 0, 0 },
/* U+a116 */ { 19, 0, 1, 0, 0 },
/* U+a117 */ { 19, 0, 1, 0, 0 },
/* U+a118 */ { 19, 0, 1, 0, 0 },
/* U+a119 */ { 19, 0, 1, 0, 0 },
/* U+a11a */ { 19, 0, 1, 0, 0 },
/* U+a11b */ { 19, 0, 1, 0, 0 },
/* U+a11c */ { 19, 0, 1, 0, 0 },
/* U+a11d */ { 19, 0, 1, 0, 0 },
/* U+a11e */ { 19, 0, 1, 0, 0 },
/* U+a11f */ { 19, 0, 1, 0, 0 },
/* U+a120 */ { 19, 0, 1, 0, 0 },
/* U+a121 */ { 19, 0, 1, 0, 0 },
/* U+a122 */ { 19, 0, 1, 0, 0 },
/* U+a123 */ { 19, 0, 1, 0, 0 },
/* U+a124 */ { 19, 0, 1, 0, 0 },
/* U+a125 */ { 19, 0, 1, 0, 0 },
/* U+a126 */ { 19, 0, 1, 0, 0 },
/* U+a127 */ { 19, 0, 1, 0, 0 },
/* U+a128 */ { 19, 0, 1, 0, 0 },
/* U+a129 */ { 19, 0, 1, 0, 0 },
/* U+a12a */ { 19, 0, 1, 0, 0 },
/* U+a12b */ { 19, 0, 1, 0, 0 },
/* U+a12c */ { 19, 0, 1, 0, 0 },
/* U+a12d */ { 19, 0, 1, 0, 0 },
/* U+a12e */ { 19, 0, 1, 0, 0 },
/* U+a12f */ { 19, 0, 1, 0, 0 },
/* U+a130 */ { 19, 0, 1, 0, 0 },
/* U+a131 */ { 19, 0, 1, 0, 0 },
/* U+a132 */ { 19, 0, 1, 0, 0 },
/* U+a133 */ { 19, 0, 1, 0, 0 },
/* U+a134 */ { 19, 0, 1, 0, 0 },
/* U+a135 */ { 19, 0, 1, 0, 0 },
/* U+a136 */ { 19, 0, 1, 0, 0 },
/* U+a137 */ { 19, 0, 1, 0, 0 },
/* U+a138 */ { 19, 0, 1, 0, 0 },
/* U+a139 */ { 19, 0, 1, 0, 0 },
/* U+a13a */ { 19, 0, 1, 0, 0 },
/* U+a13b */ { 19, 0, 1, 0, 0 },
/* U+a13c */ { 19, 0, 1, 0, 0 },
/* U+a13d */ { 19, 0, 1, 0, 0 },
/* U+a13e */ { 19, 0, 1, 0, 0 },
/* U+a13f */ { 19, 0, 1, 0, 0 },
/* U+a140 */ { 19, 0, 1, 0, 0 },
/* U+a141 */ { 19, 0, 1, 0, 0 },
/* U+a142 */ { 19, 0, 1, 0, 0 },
/* U+a143 */ { 19, 0, 1, 0, 0 },
/* U+a144 */ { 19, 0, 1, 0, 0 },
/* U+a145 */ { 19, 0, 1, 0, 0 },
/* U+a146 */ { 19, 0, 1, 0, 0 },
/* U+a147 */ { 19, 0, 1, 0, 0 },
/* U+a148 */ { 19, 0, 1, 0, 0 },
/* U+a149 */ { 19, 0, 1, 0, 0 },
/* U+a14a */ { 19, 0, 1, 0, 0 },
/* U+a14b */ { 19, 0, 1, 0, 0 },
/* U+a14c */ { 19, 0, 1, 0, 0 },
/* U+a14d */ { 19, 0, 1, 0, 0 },
/* U+a14e */ { 19, 0, 1, 0, 0 },
/* U+a14f */ { 19, 0, 1, 0, 0 },
/* U+a150 */ { 19, 0, 1, 0, 0 },
/* U+a151 */ { 19, 0, 1, 0, 0 },
/* U+a152 */ { 19, 0, 1, 0, 0 },
/* U+a153 */ { 19, 0, 1, 0, 0 },
/* U+a154 */ { 19, 0, 1, 0, 0 },
/* U+a155 */ { 19, 0, 1, 0, 0 },
/* U+a156 */ { 19, 0, 1, 0, 0 },
/* U+a157 */ { 19, 0, 1, 0, 0 },
/* U+a158 */ { 19, 0, 1, 0, 0 },
/* U+a159 */ { 19, 0, 1, 0, 0 },
/* U+a15a */ { 19, 0, 1, 0, 0 },
/* U+a15b */ { 19, 0, 1, 0, 0 },
/* U+a15c */ { 19, 0, 1, 0, 0 },
/* U+a15d */ { 19, 0, 1, 0, 0 },
/* U+a15e */ { 19, 0, 1, 0, 0 },
/* U+a15f */ { 19, 0, 1, 0, 0 },
/* U+a160 */ { 19, 0, 1, 0, 0 },
/* U+a161 */ { 19, 0, 1, 0, 0 },
/* U+a162 */ { 19, 0, 1, 0, 0 },
/* U+a163 */ { 19, 0, 1, 0, 0 },
/* U+a164 */ { 19, 0, 1, 0, 0 },
/* U+a165 */ { 19, 0, 1, 0, 0 },
/* U+a166 */ { 19, 0, 1, 0, 0 },
/* U+a167 */ { 19, 0, 1, 0, 0 },
/* U+a168 */ { 19, 0, 1, 0, 0 },
/* U+a169 */ { 19, 0, 1, 0, 0 },
/* U+a16a */ { 19, 0, 1, 0, 0 },
/* U+a16b */ { 19, 0, 1, 0, 0 },
/* U+a16c */ { 19, 0, 1, 0, 0 },
/* U+a16d */ { 19, 0, 1, 0, 0 },
/* U+a16e */ { 19, 0, 1, 0, 0 },
/* U+a16f */ { 19, 0, 1, 0, 0 },
/* U+a170 */ { 19, 0, 1, 0, 0 },
/* U+a171 */ { 19, 0, 1, 0, 0 },
/* U+a172 */ { 19, 0, 1, 0, 0 },
/* U+a173 */ { 19, 0, 1, 0, 0 },
/* U+a174 */ { 19, 0, 1, 0, 0 },
/* U+a175 */ { 19, 0, 1, 0, 0 },
/* U+a176 */ { 19, 0, 1, 0, 0 },
/* U+a177 */ { 19, 0, 1, 0, 0 },
/* U+a178 */ { 19, 0, 1, 0, 0 },
/* U+a179 */ { 19, 0, 1, 0, 0 },
/* U+a17a */ { 19, 0, 1, 0, 0 },
/* U+a17b */ { 19, 0, 1, 0, 0 },
/* U+a17c */ { 19, 0, 1, 0, 0 },
/* U+a17d */ { 19, 0, 1, 0, 0 },
/* U+a17e */ { 19, 0, 1, 0, 0 },
/* U+a17f */ { 19, 0, 1, 0, 0 },
/* U+a180 */ { 19, 0, 1, 0, 0 },
/* U+a181 */ { 19, 0, 1, 0, 0 },
/* U+a182 */ { 19, 0, 1, 0, 0 },
/* U+a183 */ { 19, 0, 1, 0, 0 },
/* U+a184 */ { 19, 0, 1, 0, 0 },
/* U+a185 */ { 19, 0, 1, 0, 0 },
/* U+a186 */ { 19, 0, 1, 0, 0 },
/* U+a187 */ { 19, 0, 1, 0, 0 },
/* U+a188 */ { 19, 0, 1, 0, 0 },
/* U+a189 */ { 19, 0, 1, 0, 0 },
/* U+a18a */ { 19, 0, 1, 0, 0 },
/* U+a18b */ { 19, 0, 1, 0, 0 },
/* U+a18c */ { 19, 0, 1, 0, 0 },
/* U+a18d */ { 19, 0, 1, 0, 0 },
/* U+a18e */ { 19, 0, 1, 0, 0 },
/* U+a18f */ { 19, 0, 1, 0, 0 },
/* U+a190 */ { 19, 0, 1, 0, 0 },
/* U+a191 */ { 19, 0, 1, 0, 0 },
/* U+a192 */ { 19, 0, 1, 0, 0 },
/* U+a193 */ { 19, 0, 1, 0, 0 },
/* U+a194 */ { 19, 0, 1, 0, 0 },
/* U+a195 */ { 19, 0, 1, 0, 0 },
/* U+a196 */ { 19, 0, 1, 0, 0 },
/* U+a197 */ { 19, 0, 1, 0, 0 },
/* U+a198 */ { 19, 0, 1, 0, 0 },
/* U+a199 */ { 19, 0, 1, 0, 0 },
/* U+a19a */ { 19, 0, 1, 0, 0 },
/* U+a19b */ { 19, 0, 1, 0, 0 },
/* U+a19c */ { 19, 0, 1, 0, 0 },
/* U+a19d */ { 19, 0, 1, 0, 0 },
/* U+a19e */ { 19, 0, 1, 0, 0 },
/* U+a19f */ { 19, 0, 1, 0, 0 },
/* U+a1a0 */ { 19, 0, 1, 0, 0 },
/* U+a1a1 */ { 19, 0, 1, 0, 0 },
/* U+a1a2 */ { 19, 0, 1, 0, 0 },
/* U+a1a3 */ { 19, 0, 1, 0, 0 },
/* U+a1a4 */ { 19, 0, 1, 0, 0 },
/* U+a1a5 */ { 19, 0, 1, 0, 0 },
/* U+a1a6 */ { 19, 0, 1, 0, 0 },
/* U+a1a7 */ { 19, 0, 1, 0, 0 },
/* U+a1a8 */ { 19, 0, 1, 0, 0 },
/* U+a1a9 */ { 19, 0, 1, 0, 0 },
/* U+a1aa */ { 19, 0, 1, 0, 0 },
/* U+a1ab */ { 19, 0, 1, 0, 0 },
/* U+a1ac */ { 19, 0, 1, 0, 0 },
/* U+a1ad */ { 19, 0, 1, 0, 0 },
/* U+a1ae */ { 19, 0, 1, 0, 0 },
/* U+a1af */ { 19, 0, 1, 0, 0 },
/* U+a1b0 */ { 19, 0, 1, 0, 0 },
/* U+a1b1 */ { 19, 0, 1, 0, 0 },
/* U+a1b2 */ { 19, 0, 1, 0, 0 },
/* U+a1b3 */ { 19, 0, 1, 0, 0 },
/* U+a1b4 */ { 19, 0, 1, 0, 0 },
/* U+a1b5 */ { 19, 0, 1, 0, 0 },
/* U+a1b6 */ { 19, 0, 1, 0, 0 },
/* U+a1b7 */ { 19, 0, 1, 0, 0 },
/* U+a1b8 */ { 19, 0, 1, 0, 0 },
/* U+a1b9 */ { 19, 0, 1, 0, 0 },
/* U+a1ba */ { 19, 0, 1, 0, 0 },
/* U+a1bb */ { 19, 0, 1, 0, 0 },
/* U+a1bc */ { 19, 0, 1, 0, 0 },
/* U+a1bd */ { 19, 0, 1, 0, 0 },
/* U+a1be */ { 19, 0, 1, 0, 0 },
/* U+a1bf */ { 19, 0, 1, 0, 0 },
/* U+a1c0 */ { 19, 0, 1, 0, 0 },
/* U+a1c1 */ { 19, 0, 1, 0, 0 },
/* U+a1c2 */ { 19, 0, 1, 0, 0 },
/* U+a1c3 */ { 19, 0, 1, 0, 0 },
/* U+a1c4 */ { 19, 0, 1, 0, 0 },
/* U+a1c5 */ { 19, 0, 1, 0, 0 },
/* U+a1c6 */ { 19, 0, 1, 0, 0 },
/* U+a1c7 */ { 19, 0, 1, 0, 0 },
/* U+a1c8 */ { 19, 0, 1, 0, 0 },
/* U+a1c9 */ { 19, 0, 1, 0, 0 },
/* U+a1ca */ { 19, 0, 1, 0, 0 },
/* U+a1cb */ { 19, 0, 1, 0, 0 },
/* U+a1cc */ { 19, 0, 1, 0, 0 },
/* U+a1cd */ { 19, 0, 1, 0, 0 },
/* U+a1ce */ { 19, 0, 1, 0, 0 },
/* U+a1cf */ { 19, 0, 1, 0, 0 },
/* U+a1d0 */ { 19, 0, 1, 0, 0 },
/* U+a1d1 */ { 19, 0, 1, 0, 0 },
/* U+a1d2 */ { 19, 0, 1, 0, 0 },
/* U+a1d3 */ { 19, 0, 1, 0, 0 },
/* U+a1d4 */ { 19, 0, 1, 0, 0 },
/* U+a1d5 */ { 19, 0, 1, 0, 0 },
/* U+a1d6 */ { 19, 0, 1, 0, 0 },
/* U+a1d7 */ { 19, 0, 1, 0, 0 },
/* U+a1d8 */ { 19, 0, 1, 0, 0 },
/* U+a1d9 */ { 19, 0, 1, 0, 0 },
/* U+a1da */ { 19, 0, 1, 0, 0 },
/* U+a1db */ { 19, 0, 1, 0, 0 },
/* U+a1dc */ { 19, 0, 1, 0, 0 },
/* U+a1dd */ { 19, 0, 1, 0, 0 },
/* U+a1de */ { 19, 0, 1, 0, 0 },
/* U+a1df */ { 19, 0, 1, 0, 0 },
/* U+a1e0 */ { 19, 0, 1, 0, 0 },
/* U+a1e1 */ { 19, 0, 1, 0, 0 },
/* U+a1e2 */ { 19, 0, 1, 0, 0 },
/* U+a1e3 */ { 19, 0, 1, 0, 0 },
/* U+a1e4 */ { 19, 0, 1, 0, 0 },
/* U+a1e5 */ { 19, 0, 1, 0, 0 },
/* U+a1e6 */ { 19, 0, 1, 0, 0 },
/* U+a1e7 */ { 19, 0, 1, 0, 0 },
/* U+a1e8 */ { 19, 0, 1, 0, 0 },
/* U+a1e9 */ { 19, 0, 1, 0, 0 },
/* U+a1ea */ { 19, 0, 1, 0, 0 },
/* U+a1eb */ { 19, 0, 1, 0, 0 },
/* U+a1ec */ { 19, 0, 1, 0, 0 },
/* U+a1ed */ { 19, 0, 1, 0, 0 },
/* U+a1ee */ { 19, 0, 1, 0, 0 },
/* U+a1ef */ { 19, 0, 1, 0, 0 },
/* U+a1f0 */ { 19, 0, 1, 0, 0 },
/* U+a1f1 */ { 19, 0, 1, 0, 0 },
/* U+a1f2 */ { 19, 0, 1, 0, 0 },
/* U+a1f3 */ { 19, 0, 1, 0, 0 },
/* U+a1f4 */ { 19, 0, 1, 0, 0 },
/* U+a1f5 */ { 19, 0, 1, 0, 0 },
/* U+a1f6 */ { 19, 0, 1, 0, 0 },
/* U+a1f7 */ { 19, 0, 1, 0, 0 },
/* U+a1f8 */ { 19, 0, 1, 0, 0 },
/* U+a1f9 */ { 19, 0, 1, 0, 0 },
/* U+a1fa */ { 19, 0, 1, 0, 0 },
/* U+a1fb */ { 19, 0, 1, 0, 0 },
/* U+a1fc */ { 19, 0, 1, 0, 0 },
/* U+a1fd */ { 19, 0, 1, 0, 0 },
/* U+a1fe */ { 19, 0, 1, 0, 0 },
/* U+a1ff */ { 19, 0, 1, 0, 0 },
/* U+a200 */ { 19, 0, 1, 0, 0 },
/* U+a201 */ { 19, 0, 1, 0, 0 },
/* U+a202 */ { 19, 0, 1, 0, 0 },
/* U+a203 */ { 19, 0, 1, 0, 0 },
/* U+a204 */ { 19, 0, 1, 0, 0 },
/* U+a205 */ { 19, 0, 1, 0, 0 },
/* U+a206 */ { 19, 0, 1, 0, 0 },
/* U+a207 */ { 19, 0, 1, 0, 0 },
/* U+a208 */ { 19, 0, 1, 0, 0 },
/* U+a209 */ { 19, 0, 1, 0, 0 },
/* U+a20a */ { 19, 0, 1, 0, 0 },
/* U+a20b */ { 19, 0, 1, 0, 0 },
/* U+a20c */ { 19, 0, 1, 0, 0 },
/* U+a20d */ { 19, 0, 1, 0, 0 },
/* U+a20e */ { 19, 0, 1, 0, 0 },
/* U+a20f */ { 19, 0, 1, 0, 0 },
/* U+a210 */ { 19, 0, 1, 0, 0 },
/* U+a211 */ { 19, 0, 1, 0, 0 },
/* U+a212 */ { 19, 0, 1, 0, 0 },
/* U+a213 */ { 19, 0, 1, 0, 0 },
/* U+a214 */ { 19, 0, 1, 0, 0 },
/* U+a215 */ { 19, 0, 1, 0, 0 },
/* U+a216 */ { 19, 0, 1, 0, 0 },
/* U+a217 */ { 19, 0, 1, 0, 0 },
/* U+a218 */ { 19, 0, 1, 0, 0 },
/* U+a219 */ { 19, 0, 1, 0, 0 },
/* U+a21a */ { 19, 0, 1, 0, 0 },
/* U+a21b */ { 19, 0, 1, 0, 0 },
/* U+a21c */ { 19, 0, 1, 0, 0 },
/* U+a21d */ { 19, 0, 1, 0, 0 },
/* U+a21e */ { 19, 0, 1, 0, 0 },
/* U+a21f */ { 19, 0, 1, 0, 0 },
/* U+a220 */ { 19, 0, 1, 0, 0 },
/* U+a221 */ { 19, 0, 1, 0, 0 },
/* U+a222 */ { 19, 0, 1, 0, 0 },
/* U+a223 */ { 19, 0, 1, 0, 0 },
/* U+a224 */ { 19, 0, 1, 0, 0 },
/* U+a225 */ { 19, 0, 1, 0, 0 },
/* U+a226 */ { 19, 0, 1, 0, 0 },
/* U+a227 */ { 19, 0, 1, 0, 0 },
/* U+a228 */ { 19, 0, 1, 0, 0 },
/* U+a229 */ { 19, 0, 1, 0, 0 },
/* U+a22a */ { 19, 0, 1, 0, 0 },
/* U+a22b */ { 19, 0, 1, 0, 0 },
/* U+a22c */ { 19, 0, 1, 0, 0 },
/* U+a22d */ { 19, 0, 1, 0, 0 },
/* U+a22e */ { 19, 0, 1, 0, 0 },
/* U+a22f */ { 19, 0, 1, 0, 0 },
/* U+a230 */ { 19, 0, 1, 0, 0 },
/* U+a231 */ { 19, 0, 1, 0, 0 },
/* U+a232 */ { 19, 0, 1, 0, 0 },
/* U+a233 */ { 19, 0, 1, 0, 0 },
/* U+a234 */ { 19, 0, 1, 0, 0 },
/* U+a235 */ { 19, 0, 1, 0, 0 },
/* U+a236 */ { 19, 0, 1, 0, 0 },
/* U+a237 */ { 19, 0, 1, 0, 0 },
/* U+a238 */ { 19, 0, 1, 0, 0 },
/* U+a239 */ { 19, 0, 1, 0, 0 },
/* U+a23a */ { 19, 0, 1, 0, 0 },
/* U+a23b */ { 19, 0, 1, 0, 0 },
/* U+a23c */ { 19, 0, 1, 0, 0 },
/* U+a23d */ { 19, 0, 1, 0, 0 },
/* U+a23e */ { 19, 0, 1, 0, 0 },
/* U+a23f */ { 19, 0, 1, 0, 0 },
/* U+a240 */ { 19, 0, 1, 0, 0 },
/* U+a241 */ { 19, 0, 1, 0, 0 },
/* U+a242 */ { 19, 0, 1, 0, 0 },
/* U+a243 */ { 19, 0, 1, 0, 0 },
/* U+a244 */ { 19, 0, 1, 0, 0 },
/* U+a245 */ { 19, 0, 1, 0, 0 },
/* U+a246 */ { 19, 0, 1, 0, 0 },
/* U+a247 */ { 19, 0, 1, 0, 0 },
/* U+a248 */ { 19, 0, 1, 0, 0 },
/* U+a249 */ { 19, 0, 1, 0, 0 },
/* U+a24a */ { 19, 0, 1, 0, 0 },
/* U+a24b */ { 19, 0, 1, 0, 0 },
/* U+a24c */ { 19, 0, 1, 0, 0 },
/* U+a24d */ { 19, 0, 1, 0, 0 },
/* U+a24e */ { 19, 0, 1, 0, 0 },
/* U+a24f */ { 19, 0, 1, 0, 0 },
/* U+a250 */ { 19, 0, 1, 0, 0 },
/* U+a251 */ { 19, 0, 1, 0, 0 },
/* U+a252 */ { 19, 0, 1, 0, 0 },
/* U+a253 */ { 19, 0, 1, 0, 0 },
/* U+a254 */ { 19, 0, 1, 0, 0 },
/* U+a255 */ { 19, 0, 1, 0, 0 },
/* U+a256 */ { 19, 0, 1, 0, 0 },
/* U+a257 */ { 19, 0, 1, 0, 0 },
/* U+a258 */ { 19, 0, 1, 0, 0 },
/* U+a259 */ { 19, 0, 1, 0, 0 },
/* U+a25a */ { 19, 0, 1, 0, 0 },
/* U+a25b */ { 19, 0, 1, 0, 0 },
/* U+a25c */ { 19, 0, 1, 0, 0 },
/* U+a25d */ { 19, 0, 1, 0, 0 },
/* U+a25e */ { 19, 0, 1, 0, 0 },
/* U+a25f */ { 19, 0, 1, 0, 0 },
/* U+a260 */ { 19, 0, 1, 0, 0 },
/* U+a261 */ { 19, 0, 1, 0, 0 },
/* U+a262 */ { 19, 0, 1, 0, 0 },
/* U+a263 */ { 19, 0, 1, 0, 0 },
/* U+a264 */ { 19, 0, 1, 0, 0 },
/* U+a265 */ { 19, 0, 1, 0, 0 },
/* U+a266 */ { 19, 0, 1, 0, 0 },
/* U+a267 */ { 19, 0, 1, 0, 0 },
/* U+a268 */ { 19, 0, 1, 0, 0 },
/* U+a269 */ { 19, 0, 1, 0, 0 },
/* U+a26a */ { 19, 0, 1, 0, 0 },
/* U+a26b */ { 19, 0, 1, 0, 0 },
/* U+a26c */ { 19, 0, 1, 0, 0 },
/* U+a26d */ { 19, 0, 1, 0, 0 },
/* U+a26e */ { 19, 0, 1, 0, 0 },
/* U+a26f */ { 19, 0, 1, 0, 0 },
/* U+a270 */ { 19, 0, 1, 0, 0 },
/* U+a271 */ { 19, 0, 1, 0, 0 },
/* U+a272 */ { 19, 0, 1, 0, 0 },
/* U+a273 */ { 19, 0, 1, 0, 0 },
/* U+a274 */ { 19, 0, 1, 0, 0 },
/* U+a275 */ { 19, 0, 1, 0, 0 },
/* U+a276 */ { 19, 0, 1, 0, 0 },
/* U+a277 */ { 19, 0, 1, 0, 0 },
/* U+a278 */ { 19, 0, 1, 0, 0 },
/* U+a279 */ { 19, 0, 1, 0, 0 },
/* U+a27a */ { 19, 0, 1, 0, 0 },
/* U+a27b */ { 19, 0, 1, 0, 0 },
/* U+a27c */ { 19, 0, 1, 0, 0 },
/* U+a27d */ { 19, 0, 1, 0, 0 },
/* U+a27e */ { 19, 0, 1, 0, 0 },
/* U+a27f */ { 19, 0, 1, 0, 0 },
/* U+a280 */ { 19, 0, 1, 0, 0 },
/* U+a281 */ { 19, 0, 1, 0, 0 },
/* U+a282 */ { 19, 0, 1, 0, 0 },
/* U+a283 */ { 19, 0, 1, 0, 0 },
/* U+a284 */ { 19, 0, 1, 0, 0 },
/* U+a285 */ { 19, 0, 1, 0, 0 },
/* U+a286 */ { 19, 0, 1, 0, 0 },
/* U+a287 */ { 19, 0, 1, 0, 0 },
/* U+a288 */ { 19, 0, 1, 0, 0 },
/* U+a289 */ { 19, 0, 1, 0, 0 },
/* U+a28a */ { 19, 0, 1, 0, 0 },
/* U+a28b */ { 19, 0, 1, 0, 0 },
/* U+a28c */ { 19, 0, 1, 0, 0 },
/* U+a28d */ { 19, 0, 1, 0, 0 },
/* U+a28e */ { 19, 0, 1, 0, 0 },
/* U+a28f */ { 19, 0, 1, 0, 0 },
/* U+a290 */ { 19, 0, 1, 0, 0 },
/* U+a291 */ { 19, 0, 1, 0, 0 },
/* U+a292 */ { 19, 0, 1, 0, 0 },
/* U+a293 */ { 19, 0, 1, 0, 0 },
/* U+a294 */ { 19, 0, 1, 0, 0 },
/* U+a295 */ { 19, 0, 1, 0, 0 },
/* U+a296 */ { 19, 0, 1, 0, 0 },
/* U+a297 */ { 19, 0, 1, 0, 0 },
/* U+a298 */ { 19, 0, 1, 0, 0 },
/* U+a299 */ { 19, 0, 1, 0, 0 },
/* U+a29a */ { 19, 0, 1, 0, 0 },
/* U+a29b */ { 19, 0, 1, 0, 0 },
/* U+a29c */ { 19, 0, 1, 0, 0 },
/* U+a29d */ { 19, 0, 1, 0, 0 },
/* U+a29e */ { 19, 0, 1, 0, 0 },
/* U+a29f */ { 19, 0, 1, 0, 0 },
/* U+a2a0 */ { 19, 0, 1, 0, 0 },
/* U+a2a1 */ { 19, 0, 1, 0, 0 },
/* U+a2a2 */ { 19, 0, 1, 0, 0 },
/* U+a2a3 */ { 19, 0, 1, 0, 0 },
/* U+a2a4 */ { 19, 0, 1, 0, 0 },
/* U+a2a5 */ { 19, 0, 1, 0, 0 },
/* U+a2a6 */ { 19, 0, 1, 0, 0 },
/* U+a2a7 */ { 19, 0, 1, 0, 0 },
/* U+a2a8 */ { 19, 0, 1, 0, 0 },
/* U+a2a9 */ { 19, 0, 1, 0, 0 },
/* U+a2aa */ { 19, 0, 1, 0, 0 },
/* U+a2ab */ { 19, 0, 1, 0, 0 },
/* U+a2ac */ { 19, 0, 1, 0, 0 },
/* U+a2ad */ { 19, 0, 1, 0, 0 },
/* U+a2ae */ { 19, 0, 1, 0, 0 },
/* U+a2af */ { 19, 0, 1, 0, 0 },
/* U+a2b0 */ { 19, 0, 1, 0, 0 },
/* U+a2b1 */ { 19, 0, 1, 0, 0 },
/* U+a2b2 */ { 19, 0, 1, 0, 0 },
/* U+a2b3 */ { 19, 0, 1, 0, 0 },
/* U+a2b4 */ { 19, 0, 1, 0, 0 },
/* U+a2b5 */ { 19, 0, 1, 0, 0 },
/* U+a2b6 */ { 19, 0, 1, 0, 0 },
/* U+a2b7 */ { 19, 0, 1, 0, 0 },
/* U+a2b8 */ { 19, 0, 1, 0, 0 },
/* U+a2b9 */ { 19, 0, 1, 0, 0 },
/* U+a2ba */ { 19, 0, 1, 0, 0 },
/* U+a2bb */ { 19, 0, 1, 0, 0 },
/* U+a2bc */ { 19, 0, 1, 0, 0 },
/* U+a2bd */ { 19, 0, 1, 0, 0 },
/* U+a2be */ { 19, 0, 1, 0, 0 },
/* U+a2bf */ { 19, 0, 1, 0, 0 },
/* U+a2c0 */ { 19, 0, 1, 0, 0 },
/* U+a2c1 */ { 19, 0, 1, 0, 0 },
/* U+a2c2 */ { 19, 0, 1, 0, 0 },
/* U+a2c3 */ { 19, 0, 1, 0, 0 },
/* U+a2c4 */ { 19, 0, 1, 0, 0 },
/* U+a2c5 */ { 19, 0, 1, 0, 0 },
/* U+a2c6 */ { 19, 0, 1, 0, 0 },
/* U+a2c7 */ { 19, 0, 1, 0, 0 },
/* U+a2c8 */ { 19, 0, 1, 0, 0 },
/* U+a2c9 */ { 19, 0, 1, 0, 0 },
/* U+a2ca */ { 19, 0, 1, 0, 0 },
/* U+a2cb */ { 19, 0, 1, 0, 0 },
/* U+a2cc */ { 19, 0, 1, 0, 0 },
/* U+a2cd */ { 19, 0, 1, 0, 0 },
/* U+a2ce */ { 19, 0, 1, 0, 0 },
/* U+a2cf */ { 19, 0, 1, 0, 0 },
/* U+a2d0 */ { 19, 0, 1, 0, 0 },
/* U+a2d1 */ { 19, 0, 1, 0, 0 },
/* U+a2d2 */ { 19, 0, 1, 0, 0 },
/* U+a2d3 */ { 19, 0, 1, 0, 0 },
/* U+a2d4 */ { 19, 0, 1, 0, 0 },
/* U+a2d5 */ { 19, 0, 1, 0, 0 },
/* U+a2d6 */ { 19, 0, 1, 0, 0 },
/* U+a2d7 */ { 19, 0, 1, 0, 0 },
/* U+a2d8 */ { 19, 0, 1, 0, 0 },
/* U+a2d9 */ { 19, 0, 1, 0, 0 },
/* U+a2da */ { 19, 0, 1, 0, 0 },
/* U+a2db */ { 19, 0, 1, 0, 0 },
/* U+a2dc */ { 19, 0, 1, 0, 0 },
/* U+a2dd */ { 19, 0, 1, 0, 0 },
/* U+a2de */ { 19, 0, 1, 0, 0 },
/* U+a2df */ { 19, 0, 1, 0, 0 },
/* U+a2e0 */ { 19, 0, 1, 0, 0 },
/* U+a2e1 */ { 19, 0, 1, 0, 0 },
/* U+a2e2 */ { 19, 0, 1, 0, 0 },
/* U+a2e3 */ { 19, 0, 1, 0, 0 },
/* U+a2e4 */ { 19, 0, 1, 0, 0 },
/* U+a2e5 */ { 19, 0, 1, 0, 0 },
/* U+a2e6 */ { 19, 0, 1, 0, 0 },
/* U+a2e7 */ { 19, 0, 1, 0, 0 },
/* U+a2e8 */ { 19, 0, 1, 0, 0 },
/* U+a2e9 */ { 19, 0, 1, 0, 0 },
/* U+a2ea */ { 19, 0, 1, 0, 0 },
/* U+a2eb */ { 19, 0, 1, 0, 0 },
/* U+a2ec */ { 19, 0, 1, 0, 0 },
/* U+a2ed */ { 19, 0, 1, 0, 0 },
/* U+a2ee */ { 19, 0, 1, 0, 0 },
/* U+a2ef */ { 19, 0, 1, 0, 0 },
/* U+a2f0 */ { 19, 0, 1, 0, 0 },
/* U+a2f1 */ { 19, 0, 1, 0, 0 },
/* U+a2f2 */ { 19, 0, 1, 0, 0 },
/* U+a2f3 */ { 19, 0, 1, 0, 0 },
/* U+a2f4 */ { 19, 0, 1, 0, 0 },
/* U+a2f5 */ { 19, 0, 1, 0, 0 },
/* U+a2f6 */ { 19, 0, 1, 0, 0 },
/* U+a2f7 */ { 19, 0, 1, 0, 0 },
/* U+a2f8 */ { 19, 0, 1, 0, 0 },
/* U+a2f9 */ { 19, 0, 1, 0, 0 },
/* U+a2fa */ { 19, 0, 1, 0, 0 },
/* U+a2fb */ { 19, 0, 1, 0, 0 },
/* U+a2fc */ { 19, 0, 1, 0, 0 },
/* U+a2fd */ { 19, 0, 1, 0, 0 },
/* U+a2fe */ { 19, 0, 1, 0, 0 },
/* U+a2ff */ { 19, 0, 1, 0, 0 },
/* U+a300 */ { 19, 0, 1, 0, 0 },
/* U+a301 */ { 19, 0, 1, 0, 0 },
/* U+a302 */ { 19, 0, 1, 0, 0 },
/* U+a303 */ { 19, 0, 1, 0, 0 },
/* U+a304 */ { 19, 0, 1, 0, 0 },
/* U+a305 */ { 19, 0, 1, 0, 0 },
/* U+a306 */ { 19, 0, 1, 0, 0 },
/* U+a307 */ { 19, 0, 1, 0, 0 },
/* U+a308 */ { 19, 0, 1, 0, 0 },
/* U+a309 */ { 19, 0, 1, 0, 0 },
/* U+a30a */ { 19, 0, 1, 0, 0 },
/* U+a30b */ { 19, 0, 1, 0, 0 },
/* U+a30c */ { 19, 0, 1, 0, 0 },
/* U+a30d */ { 19, 0, 1, 0, 0 },
/* U+a30e */ { 19, 0, 1, 0, 0 },
/* U+a30f */ { 19, 0, 1, 0, 0 },
/* U+a310 */ { 19, 0, 1, 0, 0 },
/* U+a311 */ { 19, 0, 1, 0, 0 },
/* U+a312 */ { 19, 0, 1, 0, 0 },
/* U+a313 */ { 19, 0, 1, 0, 0 },
/* U+a314 */ { 19, 0, 1, 0, 0 },
/* U+a315 */ { 19, 0, 1, 0, 0 },
/* U+a316 */ { 19, 0, 1, 0, 0 },
/* U+a317 */ { 19, 0, 1, 0, 0 },
/* U+a318 */ { 19, 0, 1, 0, 0 },
/* U+a319 */ { 19, 0, 1, 0, 0 },
/* U+a31a */ { 19, 0, 1, 0, 0 },
/* U+a31b */ { 19, 0, 1, 0, 0 },
/* U+a31c */ { 19, 0, 1, 0, 0 },
/* U+a31d */ { 19, 0, 1, 0, 0 },
/* U+a31e */ { 19, 0, 1, 0, 0 },
/* U+a31f */ { 19, 0, 1, 0, 0 },
/* U+a320 */ { 19, 0, 1, 0, 0 },
/* U+a321 */ { 19, 0, 1, 0, 0 },
/* U+a322 */ { 19, 0, 1, 0, 0 },
/* U+a323 */ { 19, 0, 1, 0, 0 },
/* U+a324 */ { 19, 0, 1, 0, 0 },
/* U+a325 */ { 19, 0, 1, 0, 0 },
/* U+a326 */ { 19, 0, 1, 0, 0 },
/* U+a327 */ { 19, 0, 1, 0, 0 },
/* U+a328 */ { 19, 0, 1, 0, 0 },
/* U+a329 */ { 19, 0, 1, 0, 0 },
/* U+a32a */ { 19, 0, 1, 0, 0 },
/* U+a32b */ { 19, 0, 1, 0, 0 },
/* U+a32c */ { 19, 0, 1, 0, 0 },
/* U+a32d */ { 19, 0, 1, 0, 0 },
/* U+a32e */ { 19, 0, 1, 0, 0 },
/* U+a32f */ { 19, 0, 1, 0, 0 },
/* U+a330 */ { 19, 0, 1, 0, 0 },
/* U+a331 */ { 19, 0, 1, 0, 0 },
/* U+a332 */ { 19, 0, 1, 0, 0 },
/* U+a333 */ { 19, 0, 1, 0, 0 },
/* U+a334 */ { 19, 0, 1, 0, 0 },
/* U+a335 */ { 19, 0, 1, 0, 0 },
/* U+a336 */ { 19, 0, 1, 0, 0 },
/* U+a337 */ { 19, 0, 1, 0, 0 },
/* U+a338 */ { 19, 0, 1, 0, 0 },
/* U+a339 */ { 19, 0, 1, 0, 0 },
/* U+a33a */ { 19, 0, 1, 0, 0 },
/* U+a33b */ { 19, 0, 1, 0, 0 },
/* U+a33c */ { 19, 0, 1, 0, 0 },
/* U+a33d */ { 19, 0, 1, 0, 0 },
/* U+a33e */ { 19, 0, 1, 0, 0 },
/* U+a33f */ { 19, 0, 1, 0, 0 },
/* U+a340 */ { 19, 0, 1, 0, 0 },
/* U+a341 */ { 19, 0, 1, 0, 0 },
/* U+a342 */ { 19, 0, 1, 0, 0 },
/* U+a343 */ { 19, 0, 1, 0, 0 },
/* U+a344 */ { 19, 0, 1, 0, 0 },
/* U+a345 */ { 19, 0, 1, 0, 0 },
/* U+a346 */ { 19, 0, 1, 0, 0 },
/* U+a347 */ { 19, 0, 1, 0, 0 },
/* U+a348 */ { 19, 0, 1, 0, 0 },
/* U+a349 */ { 19, 0, 1, 0, 0 },
/* U+a34a */ { 19, 0, 1, 0, 0 },
/* U+a34b */ { 19, 0, 1, 0, 0 },
/* U+a34c */ { 19, 0, 1, 0, 0 },
/* U+a34d */ { 19, 0, 1, 0, 0 },
/* U+a34e */ { 19, 0, 1, 0, 0 },
/* U+a34f */ { 19, 0, 1, 0, 0 },
/* U+a350 */ { 19, 0, 1, 0, 0 },
/* U+a351 */ { 19, 0, 1, 0, 0 },
/* U+a352 */ { 19, 0, 1, 0, 0 },
/* U+a353 */ { 19, 0, 1, 0, 0 },
/* U+a354 */ { 19, 0, 1, 0, 0 },
/* U+a355 */ { 19, 0, 1, 0, 0 },
/* U+a356 */ { 19, 0, 1, 0, 0 },
/* U+a357 */ { 19, 0, 1, 0, 0 },
/* U+a358 */ { 19, 0, 1, 0, 0 },
/* U+a359 */ { 19, 0, 1, 0, 0 },
/* U+a35a */ { 19, 0, 1, 0, 0 },
/* U+a35b */ { 19, 0, 1, 0, 0 },
/* U+a35c */ { 19, 0, 1, 0, 0 },
/* U+a35d */ { 19, 0, 1, 0, 0 },
/* U+a35e */ { 19, 0, 1, 0, 0 },
/* U+a35f */ { 19, 0, 1, 0, 0 },
/* U+a360 */ { 19, 0, 1, 0, 0 },
/* U+a361 */ { 19, 0, 1, 0, 0 },
/* U+a362 */ { 19, 0, 1, 0, 0 },
/* U+a363 */ { 19, 0, 1, 0, 0 },
/* U+a364 */ { 19, 0, 1, 0, 0 },
/* U+a365 */ { 19, 0, 1, 0, 0 },
/* U+a366 */ { 19, 0, 1, 0, 0 },
/* U+a367 */ { 19, 0, 1, 0, 0 },
/* U+a368 */ { 19, 0, 1, 0, 0 },
/* U+a369 */ { 19, 0, 1, 0, 0 },
/* U+a36a */ { 19, 0, 1, 0, 0 },
/* U+a36b */ { 19, 0, 1, 0, 0 },
/* U+a36c */ { 19, 0, 1, 0, 0 },
/* U+a36d */ { 19, 0, 1, 0, 0 },
/* U+a36e */ { 19, 0, 1, 0, 0 },
/* U+a36f */ { 19, 0, 1, 0, 0 },
/* U+a370 */ { 19, 0, 1, 0, 0 },
/* U+a371 */ { 19, 0, 1, 0, 0 },
/* U+a372 */ { 19, 0, 1, 0, 0 },
/* U+a373 */ { 19, 0, 1, 0, 0 },
/* U+a374 */ { 19, 0, 1, 0, 0 },
/* U+a375 */ { 19, 0, 1, 0, 0 },
/* U+a376 */ { 19, 0, 1, 0, 0 },
/* U+a377 */ { 19, 0, 1, 0, 0 },
/* U+a378 */ { 19, 0, 1, 0, 0 },
/* U+a379 */ { 19, 0, 1, 0, 0 },
/* U+a37a */ { 19, 0, 1, 0, 0 },
/* U+a37b */ { 19, 0, 1, 0, 0 },
/* U+a37c */ { 19, 0, 1, 0, 0 },
/* U+a37d */ { 19, 0, 1, 0, 0 },
/* U+a37e */ { 19, 0, 1, 0, 0 },
/* U+a37f */ { 19, 0, 1, 0, 0 },
/* U+a380 */ { 19, 0, 1, 0, 0 },
/* U+a381 */ { 19, 0, 1, 0, 0 },
/* U+a382 */ { 19, 0, 1, 0, 0 },
/* U+a383 */ { 19, 0, 1, 0, 0 },
/* U+a384 */ { 19, 0, 1, 0, 0 },
/* U+a385 */ { 19, 0, 1, 0, 0 },
/* U+a386 */ { 19, 0, 1, 0, 0 },
/* U+a387 */ { 19, 0, 1, 0, 0 },
/* U+a388 */ { 19, 0, 1, 0, 0 },
/* U+a389 */ { 19, 0, 1, 0, 0 },
/* U+a38a */ { 19, 0, 1, 0, 0 },
/* U+a38b */ { 19, 0, 1, 0, 0 },
/* U+a38c */ { 19, 0, 1, 0, 0 },
/* U+a38d */ { 19, 0, 1, 0, 0 },
/* U+a38e */ { 19, 0, 1, 0, 0 },
/* U+a38f */ { 19, 0, 1, 0, 0 },
/* U+a390 */ { 19, 0, 1, 0, 0 },
/* U+a391 */ { 19, 0, 1, 0, 0 },
/* U+a392 */ { 19, 0, 1, 0, 0 },
/* U+a393 */ { 19, 0, 1, 0, 0 },
/* U+a394 */ { 19, 0, 1, 0, 0 },
/* U+a395 */ { 19, 0, 1, 0, 0 },
/* U+a396 */ { 19, 0, 1, 0, 0 },
/* U+a397 */ { 19, 0, 1, 0, 0 },
/* U+a398 */ { 19, 0, 1, 0, 0 },
/* U+a399 */ { 19, 0, 1, 0, 0 },
/* U+a39a */ { 19, 0, 1, 0, 0 },
/* U+a39b */ { 19, 0, 1, 0, 0 },
/* U+a39c */ { 19, 0, 1, 0, 0 },
/* U+a39d */ { 19, 0, 1, 0, 0 },
/* U+a39e */ { 19, 0, 1, 0, 0 },
/* U+a39f */ { 19, 0, 1, 0, 0 },
/* U+a3a0 */ { 19, 0, 1, 0, 0 },
/* U+a3a1 */ { 19, 0, 1, 0, 0 },
/* U+a3a2 */ { 19, 0, 1, 0, 0 },
/* U+a3a3 */ { 19, 0, 1, 0, 0 },
/* U+a3a4 */ { 19, 0, 1, 0, 0 },
/* U+a3a5 */ { 19, 0, 1, 0, 0 },
/* U+a3a6 */ { 19, 0, 1, 0, 0 },
/* U+a3a7 */ { 19, 0, 1, 0, 0 },
/* U+a3a8 */ { 19, 0, 1, 0, 0 },
/* U+a3a9 */ { 19, 0, 1, 0, 0 },
/* U+a3aa */ { 19, 0, 1, 0, 0 },
/* U+a3ab */ { 19, 0, 1, 0, 0 },
/* U+a3ac */ { 19, 0, 1, 0, 0 },
/* U+a3ad */ { 19, 0, 1, 0, 0 },
/* U+a3ae */ { 19, 0, 1, 0, 0 },
/* U+a3af */ { 19, 0, 1, 0, 0 },
/* U+a3b0 */ { 19, 0, 1, 0, 0 },
/* U+a3b1 */ { 19, 0, 1, 0, 0 },
/* U+a3b2 */ { 19, 0, 1, 0, 0 },
/* U+a3b3 */ { 19, 0, 1, 0, 0 },
/* U+a3b4 */ { 19, 0, 1, 0, 0 },
/* U+a3b5 */ { 19, 0, 1, 0, 0 },
/* U+a3b6 */ { 19, 0, 1, 0, 0 },
/* U+a3b7 */ { 19, 0, 1, 0, 0 },
/* U+a3b8 */ { 19, 0, 1, 0, 0 },
/* U+a3b9 */ { 19, 0, 1, 0, 0 },
/* U+a3ba */ { 19, 0, 1, 0, 0 },
/* U+a3bb */ { 19, 0, 1, 0, 0 },
/* U+a3bc */ { 19, 0, 1, 0, 0 },
/* U+a3bd */ { 19, 0, 1, 0, 0 },
/* U+a3be */ { 19, 0, 1, 0, 0 },
/* U+a3bf */ { 19, 0, 1, 0, 0 },
/* U+a3c0 */ { 19, 0, 1, 0, 0 },
/* U+a3c1 */ { 19, 0, 1, 0, 0 },
/* U+a3c2 */ { 19, 0, 1, 0, 0 },
/* U+a3c3 */ { 19, 0, 1, 0, 0 },
/* U+a3c4 */ { 19, 0, 1, 0, 0 },
/* U+a3c5 */ { 19, 0, 1, 0, 0 },
/* U+a3c6 */ { 19, 0, 1, 0, 0 },
/* U+a3c7 */ { 19, 0, 1, 0, 0 },
/* U+a3c8 */ { 19, 0, 1, 0, 0 },
/* U+a3c9 */ { 19, 0, 1, 0, 0 },
/* U+a3ca */ { 19, 0, 1, 0, 0 },
/* U+a3cb */ { 19, 0, 1, 0, 0 },
/* U+a3cc */ { 19, 0, 1, 0, 0 },
/* U+a3cd */ { 19, 0, 1, 0, 0 },
/* U+a3ce */ { 19, 0, 1, 0, 0 },
/* U+a3cf */ { 19, 0, 1, 0, 0 },
/* U+a3d0 */ { 19, 0, 1, 0, 0 },
/* U+a3d1 */ { 19, 0, 1, 0, 0 },
/* U+a3d2 */ { 19, 0, 1, 0, 0 },
/* U+a3d3 */ { 19, 0, 1, 0, 0 },
/* U+a3d4 */ { 19, 0, 1, 0, 0 },
/* U+a3d5 */ { 19, 0, 1, 0, 0 },
/* U+a3d6 */ { 19, 0, 1, 0, 0 },
/* U+a3d7 */ { 19, 0, 1, 0, 0 },
/* U+a3d8 */ { 19, 0, 1, 0, 0 },
/* U+a3d9 */ { 19, 0, 1, 0, 0 },
/* U+a3da */ { 19, 0, 1, 0, 0 },
/* U+a3db */ { 19, 0, 1, 0, 0 },
/* U+a3dc */ { 19, 0, 1, 0, 0 },
/* U+a3dd */ { 19, 0, 1, 0, 0 },
/* U+a3de */ { 19, 0, 1, 0, 0 },
/* U+a3df */ { 19, 0, 1, 0, 0 },
/* U+a3e0 */ { 19, 0, 1, 0, 0 },
/* U+a3e1 */ { 19, 0, 1, 0, 0 },
/* U+a3e2 */ { 19, 0, 1, 0, 0 },
/* U+a3e3 */ { 19, 0, 1, 0, 0 },
/* U+a3e4 */ { 19, 0, 1, 0, 0 },
/* U+a3e5 */ { 19, 0, 1, 0, 0 },
/* U+a3e6 */ { 19, 0, 1, 0, 0 },
/* U+a3e7 */ { 19, 0, 1, 0, 0 },
/* U+a3e8 */ { 19, 0, 1, 0, 0 },
/* U+a3e9 */ { 19, 0, 1, 0, 0 },
/* U+a3ea */ { 19, 0, 1, 0, 0 },
/* U+a3eb */ { 19, 0, 1, 0, 0 },
/* U+a3ec */ { 19, 0, 1, 0, 0 },
/* U+a3ed */ { 19, 0, 1, 0, 0 },
/* U+a3ee */ { 19, 0, 1, 0, 0 },
/* U+a3ef */ { 19, 0, 1, 0, 0 },
/* U+a3f0 */ { 19, 0, 1, 0, 0 },
/* U+a3f1 */ { 19, 0, 1, 0, 0 },
/* U+a3f2 */ { 19, 0, 1, 0, 0 },
/* U+a3f3 */ { 19, 0, 1, 0, 0 },
/* U+a3f4 */ { 19, 0, 1, 0, 0 },
/* U+a3f5 */ { 19, 0, 1, 0, 0 },
/* U+a3f6 */ { 19, 0, 1, 0, 0 },
/* U+a3f7 */ { 19, 0, 1, 0, 0 },
/* U+a3f8 */ { 19, 0, 1, 0, 0 },
/* U+a3f9 */ { 19, 0, 1, 0, 0 },
/* U+a3fa */ { 19, 0, 1, 0, 0 },
/* U+a3fb */ { 19, 0, 1, 0, 0 },
/* U+a3fc */ { 19, 0, 1, 0, 0 },
/* U+a3fd */ { 19, 0, 1, 0, 0 },
/* U+a3fe */ { 19, 0, 1, 0, 0 },
/* U+a3ff */ { 19, 0, 1, 0, 0 },
/* U+a400 */ { 19, 0, 1, 0, 0 },
/* U+a401 */ { 19, 0, 1, 0, 0 },
/* U+a402 */ { 19, 0, 1, 0, 0 },
/* U+a403 */ { 19, 0, 1, 0, 0 },
/* U+a404 */ { 19, 0, 1, 0, 0 },
/* U+a405 */ { 19, 0, 1, 0, 0 },
/* U+a406 */ { 19, 0, 1, 0, 0 },
/* U+a407 */ { 19, 0, 1, 0, 0 },
/* U+a408 */ { 19, 0, 1, 0, 0 },
/* U+a409 */ { 19, 0, 1, 0, 0 },
/* U+a40a */ { 19, 0, 1, 0, 0 },
/* U+a40b */ { 19, 0, 1, 0, 0 },
/* U+a40c */ { 19, 0, 1, 0, 0 },
/* U+a40d */ { 19, 0, 1, 0, 0 },
/* U+a40e */ { 19, 0, 1, 0, 0 },
/* U+a40f */ { 19, 0, 1, 0, 0 },
/* U+a410 */ { 19, 0, 1, 0, 0 },
/* U+a411 */ { 19, 0, 1, 0, 0 },
/* U+a412 */ { 19, 0, 1, 0, 0 },
/* U+a413 */ { 19, 0, 1, 0, 0 },
/* U+a414 */ { 19, 0, 1, 0, 0 },
/* U+a415 */ { 19, 0, 1, 0, 0 },
/* U+a416 */ { 19, 0, 1, 0, 0 },
/* U+a417 */ { 19, 0, 1, 0, 0 },
/* U+a418 */ { 19, 0, 1, 0, 0 },
/* U+a419 */ { 19, 0, 1, 0, 0 },
/* U+a41a */ { 19, 0, 1, 0, 0 },
/* U+a41b */ { 19, 0, 1, 0, 0 },
/* U+a41c */ { 19, 0, 1, 0, 0 },
/* U+a41d */ { 19, 0, 1, 0, 0 },
/* U+a41e */ { 19, 0, 1, 0, 0 },
/* U+a41f */ { 19, 0, 1, 0, 0 },
/* U+a420 */ { 19, 0, 1, 0, 0 },
/* U+a421 */ { 19, 0, 1, 0, 0 },
/* U+a422 */ { 19, 0, 1, 0, 0 },
/* U+a423 */ { 19, 0, 1, 0, 0 },
/* U+a424 */ { 19, 0, 1, 0, 0 },
/* U+a425 */ { 19, 0, 1, 0, 0 },
/* U+a426 */ { 19, 0, 1, 0, 0 },
/* U+a427 */ { 19, 0, 1, 0, 0 },
/* U+a428 */ { 19, 0, 1, 0, 0 },
/* U+a429 */ { 19, 0, 1, 0, 0 },
/* U+a42a */ { 19, 0, 1, 0, 0 },
/* U+a42b */ { 19, 0, 1, 0, 0 },
/* U+a42c */ { 19, 0, 1, 0, 0 },
/* U+a42d */ { 19, 0, 1, 0, 0 },
/* U+a42e */ { 19, 0, 1, 0, 0 },
/* U+a42f */ { 19, 0, 1, 0, 0 },
/* U+a430 */ { 19, 0, 1, 0, 0 },
/* U+a431 */ { 19, 0, 1, 0, 0 },
/* U+a432 */ { 19, 0, 1, 0, 0 },
/* U+a433 */ { 19, 0, 1, 0, 0 },
/* U+a434 */ { 19, 0, 1, 0, 0 },
/* U+a435 */ { 19, 0, 1, 0, 0 },
/* U+a436 */ { 19, 0, 1, 0, 0 },
/* U+a437 */ { 19, 0, 1, 0, 0 },
/* U+a438 */ { 19, 0, 1, 0, 0 },
/* U+a439 */ { 19, 0, 1, 0, 0 },
/* U+a43a */ { 19, 0, 1, 0, 0 },
/* U+a43b */ { 19, 0, 1, 0, 0 },
/* U+a43c */ { 19, 0, 1, 0, 0 },
/* U+a43d */ { 19, 0, 1, 0, 0 },
/* U+a43e */ { 19, 0, 1, 0, 0 },
/* U+a43f */ { 19, 0, 1, 0, 0 },
/* U+a440 */ { 19, 0, 1, 0, 0 },
/* U+a441 */ { 19, 0, 1, 0, 0 },
/* U+a442 */ { 19, 0, 1, 0, 0 },
/* U+a443 */ { 19, 0, 1, 0, 0 },
/* U+a444 */ { 19, 0, 1, 0, 0 },
/* U+a445 */ { 19, 0, 1, 0, 0 },
/* U+a446 */ { 19, 0, 1, 0, 0 },
/* U+a447 */ { 19, 0, 1, 0, 0 },
/* U+a448 */ { 19, 0, 1, 0, 0 },
/* U+a449 */ { 19, 0, 1, 0, 0 },
/* U+a44a */ { 19, 0, 1, 0, 0 },
/* U+a44b */ { 19, 0, 1, 0, 0 },
/* U+a44c */ { 19, 0, 1, 0, 0 },
/* U+a44d */ { 19, 0, 1, 0, 0 },
/* U+a44e */ { 19, 0, 1, 0, 0 },
/* U+a44f */ { 19, 0, 1, 0, 0 },
/* U+a450 */ { 19, 0, 1, 0, 0 },
/* U+a451 */ { 19, 0, 1, 0, 0 },
/* U+a452 */ { 19, 0, 1, 0, 0 },
/* U+a453 */ { 19, 0, 1, 0, 0 },
/* U+a454 */ { 19, 0, 1, 0, 0 },
/* U+a455 */ { 19, 0, 1, 0, 0 },
/* U+a456 */ { 19, 0, 1, 0, 0 },
/* U+a457 */ { 19, 0, 1, 0, 0 },
/* U+a458 */ { 19, 0, 1, 0, 0 },
/* U+a459 */ { 19, 0, 1, 0, 0 },
/* U+a45a */ { 19, 0, 1, 0, 0 },
/* U+a45b */ { 19, 0, 1, 0, 0 },
/* U+a45c */ { 19, 0, 1, 0, 0 },
/* U+a45d */ { 19, 0, 1, 0, 0 },
/* U+a45e */ { 19, 0, 1, 0, 0 },
/* U+a45f */ { 19, 0, 1, 0, 0 },
/* U+a460 */ { 19, 0, 1, 0, 0 },
/* U+a461 */ { 19, 0, 1, 0, 0 },
/* U+a462 */ { 19, 0, 1, 0, 0 },
/* U+a463 */ { 19, 0, 1, 0, 0 },
/* U+a464 */ { 19, 0, 1, 0, 0 },
/* U+a465 */ { 19, 0, 1, 0, 0 },
/* U+a466 */ { 19, 0, 1, 0, 0 },
/* U+a467 */ { 19, 0, 1, 0, 0 },
/* U+a468 */ { 19, 0, 1, 0, 0 },
/* U+a469 */ { 19, 0, 1, 0, 0 },
/* U+a46a */ { 19, 0, 1, 0, 0 },
/* U+a46b */ { 19, 0, 1, 0, 0 },
/* U+a46c */ { 19, 0, 1, 0, 0 },
/* U+a46d */ { 19, 0, 1, 0, 0 },
/* U+a46e */ { 19, 0, 1, 0, 0 },
/* U+a46f */ { 19, 0, 1, 0, 0 },
/* U+a470 */ { 19, 0, 1, 0, 0 },
/* U+a471 */ { 19, 0, 1, 0, 0 },
/* U+a472 */ { 19, 0, 1, 0, 0 },
/* U+a473 */ { 19, 0, 1, 0, 0 },
/* U+a474 */ { 19, 0, 1, 0, 0 },
/* U+a475 */ { 19, 0, 1, 0, 0 },
/* U+a476 */ { 19, 0, 1, 0, 0 },
/* U+a477 */ { 19, 0, 1, 0, 0 },
/* U+a478 */ { 19, 0, 1, 0, 0 },
/* U+a479 */ { 19, 0, 1, 0, 0 },
/* U+a47a */ { 19, 0, 1, 0, 0 },
/* U+a47b */ { 19, 0, 1, 0, 0 },
/* U+a47c */ { 19, 0, 1, 0, 0 },
/* U+a47d */ { 19, 0, 1, 0, 0 },
/* U+a47e */ { 19, 0, 1, 0, 0 },
/* U+a47f */ { 19, 0, 1, 0, 0 },
/* U+a480 */ { 19, 0, 1, 0, 0 },
/* U+a481 */ { 19, 0, 1, 0, 0 },
/* U+a482 */ { 19, 0, 1, 0, 0 },
/* U+a483 */ { 19, 0, 1, 0, 0 },
/* U+a484 */ { 19, 0, 1, 0, 0 },
/* U+a485 */ { 19, 0, 1, 0, 0 },
/* U+a486 */ { 19, 0, 1, 0, 0 },
/* U+a487 */ { 19, 0, 1, 0, 0 },
/* U+a488 */ { 19, 0, 1, 0, 0 },
/* U+a489 */ { 19, 0, 1, 0, 0 },
/* U+a48a */ { 19, 0, 1, 0, 0 },
/* U+a48b */ { 19, 0, 1, 0, 0 },
/* U+a48c */ { 19, 0, 1, 0, 0 },
/* U+a48d */ { 0, 0, 0, 0, 0 },
/* U+a48e */ { 0, 0, 0, 0, 0 },
/* U+a48f */ { 0, 0, 0, 0, 0 },
/* U+a490 */ { 30, 0, 19, 0, 0 },
/* U+a491 */ { 30, 0, 19, 0, 0 },
/* U+a492 */ { 30, 0, 19, 0, 0 },
/* U+a493 */ { 30, 0, 19, 0, 0 },
/* U+a494 */ { 30, 0, 19, 0, 0 },
/* U+a495 */ { 30, 0, 19, 0, 0 },
/* U+a496 */ { 30, 0, 19, 0, 0 },
/* U+a497 */ { 30, 0, 19, 0, 0 },
/* U+a498 */ { 30, 0, 19, 0, 0 },
/* U+a499 */ { 30, 0, 19, 0, 0 },
/* U+a49a */ { 30, 0, 19, 0, 0 },
/* U+a49b */ { 30, 0, 19, 0, 0 },
/* U+a49c */ { 30, 0, 19, 0, 0 },
/* U+a49d */ { 30, 0, 19, 0, 0 },
/* U+a49e */ { 30, 0, 19, 0, 0 },
/* U+a49f */ { 30, 0, 19, 0, 0 },
/* U+a4a0 */ { 30, 0, 19, 0, 0 },
/* U+a4a1 */ { 30, 0, 19, 0, 0 },
/* U+a4a2 */ { 0, 0, 0, 0, 0 },
/* U+a4a3 */ { 0, 0, 0, 0, 0 },
/* U+a4a4 */ { 30, 0, 19, 0, 0 },
/* U+a4a5 */ { 30, 0, 19, 0, 0 },
/* U+a4a6 */ { 30, 0, 19, 0, 0 },
/* U+a4a7 */ { 30, 0, 19, 0, 0 },
/* U+a4a8 */ { 30, 0, 19, 0, 0 },
/* U+a4a9 */ { 30, 0, 19, 0, 0 },
/* U+a4aa */ { 30, 0, 19, 0, 0 },
/* U+a4ab */ { 30, 0, 19, 0, 0 },
/* U+a4ac */ { 30, 0, 19, 0, 0 },
/* U+a4ad */ { 30, 0, 19, 0, 0 },
/* U+a4ae */ { 30, 0, 19, 0, 0 },
/* U+a4af */ { 30, 0, 19, 0, 0 },
/* U+a4b0 */ { 30, 0, 19, 0, 0 },
/* U+a4b1 */ { 30, 0, 19, 0, 0 },
/* U+a4b2 */ { 30, 0, 19, 0, 0 },
/* U+a4b3 */ { 30, 0, 19, 0, 0 },
/* U+a4b4 */ { 0, 0, 0, 0, 0 },
/* U+a4b5 */ { 30, 0, 19, 0, 0 },
/* U+a4b6 */ { 30, 0, 19, 0, 0 },
/* U+a4b7 */ { 30, 0, 19, 0, 0 },
/* U+a4b8 */ { 30, 0, 19, 0, 0 },
/* U+a4b9 */ { 30, 0, 19, 0, 0 },
/* U+a4ba */ { 30, 0, 19, 0, 0 },
/* U+a4bb */ { 30, 0, 19, 0, 0 },
/* U+a4bc */ { 30, 0, 19, 0, 0 },
/* U+a4bd */ { 30, 0, 19, 0, 0 },
/* U+a4be */ { 30, 0, 19, 0, 0 },
/* U+a4bf */ { 30, 0, 19, 0, 0 },
/* U+a4c0 */ { 30, 0, 19, 0, 0 },
/* U+a4c1 */ { 0, 0, 0, 0, 0 },
/* U+a4c2 */ { 30, 0, 19, 0, 0 },
/* U+a4c3 */ { 30, 0, 19, 0, 0 },
/* U+a4c4 */ { 30, 0, 19, 0, 0 },
/* U+a4c5 */ { 0, 0, 0, 0, 0 },
/* U+a4c6 */ { 30, 0, 19, 0, 0 },
/* U+a4c7 */ { 0, 0, 0, 0, 0 },
/* U+a4c8 */ { 0, 0, 0, 0, 0 },
/* U+a4c9 */ { 0, 0, 0, 0, 0 },
/* U+a4ca */ { 0, 0, 0, 0, 0 },
/* U+a4cb */ { 0, 0, 0, 0, 0 },
/* U+a4cc */ { 0, 0, 0, 0, 0 },
/* U+a4cd */ { 0, 0, 0, 0, 0 },
/* U+a4ce */ { 0, 0, 0, 0, 0 },
/* U+a4cf */ { 0, 0, 0, 0, 0 },
/* U+a4d0 */ { 0, 0, 0, 0, 0 },
/* U+a4d1 */ { 0, 0, 0, 0, 0 },
/* U+a4d2 */ { 0, 0, 0, 0, 0 },
/* U+a4d3 */ { 0, 0, 0, 0, 0 },
/* U+a4d4 */ { 0, 0, 0, 0, 0 },
/* U+a4d5 */ { 0, 0, 0, 0, 0 },
/* U+a4d6 */ { 0, 0, 0, 0, 0 },
/* U+a4d7 */ { 0, 0, 0, 0, 0 },
/* U+a4d8 */ { 0, 0, 0, 0, 0 },
/* U+a4d9 */ { 0, 0, 0, 0, 0 },
/* U+a4da */ { 0, 0, 0, 0, 0 },
/* U+a4db */ { 0, 0, 0, 0, 0 },
/* U+a4dc */ { 0, 0, 0, 0, 0 },
/* U+a4dd */ { 0, 0, 0, 0, 0 },
/* U+a4de */ { 0, 0, 0, 0, 0 },
/* U+a4df */ { 0, 0, 0, 0, 0 },
/* U+a4e0 */ { 0, 0, 0, 0, 0 },
/* U+a4e1 */ { 0, 0, 0, 0, 0 },
/* U+a4e2 */ { 0, 0, 0, 0, 0 },
/* U+a4e3 */ { 0, 0, 0, 0, 0 },
/* U+a4e4 */ { 0, 0, 0, 0, 0 },
/* U+a4e5 */ { 0, 0, 0, 0, 0 },
/* U+a4e6 */ { 0, 0, 0, 0, 0 },
/* U+a4e7 */ { 0, 0, 0, 0, 0 },
/* U+a4e8 */ { 0, 0, 0, 0, 0 },
/* U+a4e9 */ { 0, 0, 0, 0, 0 },
/* U+a4ea */ { 0, 0, 0, 0, 0 },
/* U+a4eb */ { 0, 0, 0, 0, 0 },
/* U+a4ec */ { 0, 0, 0, 0, 0 },
/* U+a4ed */ { 0, 0, 0, 0, 0 },
/* U+a4ee */ { 0, 0, 0, 0, 0 },
/* U+a4ef */ { 0, 0, 0, 0, 0 },
/* U+a4f0 */ { 0, 0, 0, 0, 0 },
/* U+a4f1 */ { 0, 0, 0, 0, 0 },
/* U+a4f2 */ { 0, 0, 0, 0, 0 },
/* U+a4f3 */ { 0, 0, 0, 0, 0 },
/* U+a4f4 */ { 0, 0, 0, 0, 0 },
/* U+a4f5 */ { 0, 0, 0, 0, 0 },
/* U+a4f6 */ { 0, 0, 0, 0, 0 },
/* U+a4f7 */ { 0, 0, 0, 0, 0 },
/* U+a4f8 */ { 0, 0, 0, 0, 0 },
/* U+a4f9 */ { 0, 0, 0, 0, 0 },
/* U+a4fa */ { 0, 0, 0, 0, 0 },
/* U+a4fb */ { 0, 0, 0, 0, 0 },
/* U+a4fc */ { 0, 0, 0, 0, 0 },
/* U+a4fd */ { 0, 0, 0, 0, 0 },
/* U+a4fe */ { 0, 0, 0, 0, 0 },
/* U+a4ff */ { 0, 0, 0, 0, 0 },
/* U+a500 */ { 0, 0, 0, 0, 0 },
/* U+a501 */ { 0, 0, 0, 0, 0 },
/* U+a502 */ { 0, 0, 0, 0, 0 },
/* U+a503 */ { 0, 0, 0, 0, 0 },
/* U+a504 */ { 0, 0, 0, 0, 0 },
/* U+a505 */ { 0, 0, 0, 0, 0 },
/* U+a506 */ { 0, 0, 0, 0, 0 },
/* U+a507 */ { 0, 0, 0, 0, 0 },
/* U+a508 */ { 0, 0, 0, 0, 0 },
/* U+a509 */ { 0, 0, 0, 0, 0 },
/* U+a50a */ { 0, 0, 0, 0, 0 },
/* U+a50b */ { 0, 0, 0, 0, 0 },
/* U+a50c */ { 0, 0, 0, 0, 0 },
/* U+a50d */ { 0, 0, 0, 0, 0 },
/* U+a50e */ { 0, 0, 0, 0, 0 },
/* U+a50f */ { 0, 0, 0, 0, 0 },
/* U+a510 */ { 0, 0, 0, 0, 0 },
/* U+a511 */ { 0, 0, 0, 0, 0 },
/* U+a512 */ { 0, 0, 0, 0, 0 },
/* U+a513 */ { 0, 0, 0, 0, 0 },
/* U+a514 */ { 0, 0, 0, 0, 0 },
/* U+a515 */ { 0, 0, 0, 0, 0 },
/* U+a516 */ { 0, 0, 0, 0, 0 },
/* U+a517 */ { 0, 0, 0, 0, 0 },
/* U+a518 */ { 0, 0, 0, 0, 0 },
/* U+a519 */ { 0, 0, 0, 0, 0 },
/* U+a51a */ { 0, 0, 0, 0, 0 },
/* U+a51b */ { 0, 0, 0, 0, 0 },
/* U+a51c */ { 0, 0, 0, 0, 0 },
/* U+a51d */ { 0, 0, 0, 0, 0 },
/* U+a51e */ { 0, 0, 0, 0, 0 },
/* U+a51f */ { 0, 0, 0, 0, 0 },
/* U+a520 */ { 0, 0, 0, 0, 0 },
/* U+a521 */ { 0, 0, 0, 0, 0 },
/* U+a522 */ { 0, 0, 0, 0, 0 },
/* U+a523 */ { 0, 0, 0, 0, 0 },
/* U+a524 */ { 0, 0, 0, 0, 0 },
/* U+a525 */ { 0, 0, 0, 0, 0 },
/* U+a526 */ { 0, 0, 0, 0, 0 },
/* U+a527 */ { 0, 0, 0, 0, 0 },
/* U+a528 */ { 0, 0, 0, 0, 0 },
/* U+a529 */ { 0, 0, 0, 0, 0 },
/* U+a52a */ { 0, 0, 0, 0, 0 },
/* U+a52b */ { 0, 0, 0, 0, 0 },
/* U+a52c */ { 0, 0, 0, 0, 0 },
/* U+a52d */ { 0, 0, 0, 0, 0 },
/* U+a52e */ { 0, 0, 0, 0, 0 },
/* U+a52f */ { 0, 0, 0, 0, 0 },
/* U+a530 */ { 0, 0, 0, 0, 0 },
/* U+a531 */ { 0, 0, 0, 0, 0 },
/* U+a532 */ { 0, 0, 0, 0, 0 },
/* U+a533 */ { 0, 0, 0, 0, 0 },
/* U+a534 */ { 0, 0, 0, 0, 0 },
/* U+a535 */ { 0, 0, 0, 0, 0 },
/* U+a536 */ { 0, 0, 0, 0, 0 },
/* U+a537 */ { 0, 0, 0, 0, 0 },
/* U+a538 */ { 0, 0, 0, 0, 0 },
/* U+a539 */ { 0, 0, 0, 0, 0 },
/* U+a53a */ { 0, 0, 0, 0, 0 },
/* U+a53b */ { 0, 0, 0, 0, 0 },
/* U+a53c */ { 0, 0, 0, 0, 0 },
/* U+a53d */ { 0, 0, 0, 0, 0 },
/* U+a53e */ { 0, 0, 0, 0, 0 },
/* U+a53f */ { 0, 0, 0, 0, 0 },
/* U+a540 */ { 0, 0, 0, 0, 0 },
/* U+a541 */ { 0, 0, 0, 0, 0 },
/* U+a542 */ { 0, 0, 0, 0, 0 },
/* U+a543 */ { 0, 0, 0, 0, 0 },
/* U+a544 */ { 0, 0, 0, 0, 0 },
/* U+a545 */ { 0, 0, 0, 0, 0 },
/* U+a546 */ { 0, 0, 0, 0, 0 },
/* U+a547 */ { 0, 0, 0, 0, 0 },
/* U+a548 */ { 0, 0, 0, 0, 0 },
/* U+a549 */ { 0, 0, 0, 0, 0 },
/* U+a54a */ { 0, 0, 0, 0, 0 },
/* U+a54b */ { 0, 0, 0, 0, 0 },
/* U+a54c */ { 0, 0, 0, 0, 0 },
/* U+a54d */ { 0, 0, 0, 0, 0 },
/* U+a54e */ { 0, 0, 0, 0, 0 },
/* U+a54f */ { 0, 0, 0, 0, 0 },
/* U+a550 */ { 0, 0, 0, 0, 0 },
/* U+a551 */ { 0, 0, 0, 0, 0 },
/* U+a552 */ { 0, 0, 0, 0, 0 },
/* U+a553 */ { 0, 0, 0, 0, 0 },
/* U+a554 */ { 0, 0, 0, 0, 0 },
/* U+a555 */ { 0, 0, 0, 0, 0 },
/* U+a556 */ { 0, 0, 0, 0, 0 },
/* U+a557 */ { 0, 0, 0, 0, 0 },
/* U+a558 */ { 0, 0, 0, 0, 0 },
/* U+a559 */ { 0, 0, 0, 0, 0 },
/* U+a55a */ { 0, 0, 0, 0, 0 },
/* U+a55b */ { 0, 0, 0, 0, 0 },
/* U+a55c */ { 0, 0, 0, 0, 0 },
/* U+a55d */ { 0, 0, 0, 0, 0 },
/* U+a55e */ { 0, 0, 0, 0, 0 },
/* U+a55f */ { 0, 0, 0, 0, 0 },
/* U+a560 */ { 0, 0, 0, 0, 0 },
/* U+a561 */ { 0, 0, 0, 0, 0 },
/* U+a562 */ { 0, 0, 0, 0, 0 },
/* U+a563 */ { 0, 0, 0, 0, 0 },
/* U+a564 */ { 0, 0, 0, 0, 0 },
/* U+a565 */ { 0, 0, 0, 0, 0 },
/* U+a566 */ { 0, 0, 0, 0, 0 },
/* U+a567 */ { 0, 0, 0, 0, 0 },
/* U+a568 */ { 0, 0, 0, 0, 0 },
/* U+a569 */ { 0, 0, 0, 0, 0 },
/* U+a56a */ { 0, 0, 0, 0, 0 },
/* U+a56b */ { 0, 0, 0, 0, 0 },
/* U+a56c */ { 0, 0, 0, 0, 0 },
/* U+a56d */ { 0, 0, 0, 0, 0 },
/* U+a56e */ { 0, 0, 0, 0, 0 },
/* U+a56f */ { 0, 0, 0, 0, 0 },
/* U+a570 */ { 0, 0, 0, 0, 0 },
/* U+a571 */ { 0, 0, 0, 0, 0 },
/* U+a572 */ { 0, 0, 0, 0, 0 },
/* U+a573 */ { 0, 0, 0, 0, 0 },
/* U+a574 */ { 0, 0, 0, 0, 0 },
/* U+a575 */ { 0, 0, 0, 0, 0 },
/* U+a576 */ { 0, 0, 0, 0, 0 },
/* U+a577 */ { 0, 0, 0, 0, 0 },
/* U+a578 */ { 0, 0, 0, 0, 0 },
/* U+a579 */ { 0, 0, 0, 0, 0 },
/* U+a57a */ { 0, 0, 0, 0, 0 },
/* U+a57b */ { 0, 0, 0, 0, 0 },
/* U+a57c */ { 0, 0, 0, 0, 0 },
/* U+a57d */ { 0, 0, 0, 0, 0 },
/* U+a57e */ { 0, 0, 0, 0, 0 },
/* U+a57f */ { 0, 0, 0, 0, 0 },
/* U+a580 */ { 0, 0, 0, 0, 0 },
/* U+a581 */ { 0, 0, 0, 0, 0 },
/* U+a582 */ { 0, 0, 0, 0, 0 },
/* U+a583 */ { 0, 0, 0, 0, 0 },
/* U+a584 */ { 0, 0, 0, 0, 0 },
/* U+a585 */ { 0, 0, 0, 0, 0 },
/* U+a586 */ { 0, 0, 0, 0, 0 },
/* U+a587 */ { 0, 0, 0, 0, 0 },
/* U+a588 */ { 0, 0, 0, 0, 0 },
/* U+a589 */ { 0, 0, 0, 0, 0 },
/* U+a58a */ { 0, 0, 0, 0, 0 },
/* U+a58b */ { 0, 0, 0, 0, 0 },
/* U+a58c */ { 0, 0, 0, 0, 0 },
/* U+a58d */ { 0, 0, 0, 0, 0 },
/* U+a58e */ { 0, 0, 0, 0, 0 },
/* U+a58f */ { 0, 0, 0, 0, 0 },
/* U+a590 */ { 0, 0, 0, 0, 0 },
/* U+a591 */ { 0, 0, 0, 0, 0 },
/* U+a592 */ { 0, 0, 0, 0, 0 },
/* U+a593 */ { 0, 0, 0, 0, 0 },
/* U+a594 */ { 0, 0, 0, 0, 0 },
/* U+a595 */ { 0, 0, 0, 0, 0 },
/* U+a596 */ { 0, 0, 0, 0, 0 },
/* U+a597 */ { 0, 0, 0, 0, 0 },
/* U+a598 */ { 0, 0, 0, 0, 0 },
/* U+a599 */ { 0, 0, 0, 0, 0 },
/* U+a59a */ { 0, 0, 0, 0, 0 },
/* U+a59b */ { 0, 0, 0, 0, 0 },
/* U+a59c */ { 0, 0, 0, 0, 0 },
/* U+a59d */ { 0, 0, 0, 0, 0 },
/* U+a59e */ { 0, 0, 0, 0, 0 },
/* U+a59f */ { 0, 0, 0, 0, 0 },
/* U+a5a0 */ { 0, 0, 0, 0, 0 },
/* U+a5a1 */ { 0, 0, 0, 0, 0 },
/* U+a5a2 */ { 0, 0, 0, 0, 0 },
/* U+a5a3 */ { 0, 0, 0, 0, 0 },
/* U+a5a4 */ { 0, 0, 0, 0, 0 },
/* U+a5a5 */ { 0, 0, 0, 0, 0 },
/* U+a5a6 */ { 0, 0, 0, 0, 0 },
/* U+a5a7 */ { 0, 0, 0, 0, 0 },
/* U+a5a8 */ { 0, 0, 0, 0, 0 },
/* U+a5a9 */ { 0, 0, 0, 0, 0 },
/* U+a5aa */ { 0, 0, 0, 0, 0 },
/* U+a5ab */ { 0, 0, 0, 0, 0 },
/* U+a5ac */ { 0, 0, 0, 0, 0 },
/* U+a5ad */ { 0, 0, 0, 0, 0 },
/* U+a5ae */ { 0, 0, 0, 0, 0 },
/* U+a5af */ { 0, 0, 0, 0, 0 },
/* U+a5b0 */ { 0, 0, 0, 0, 0 },
/* U+a5b1 */ { 0, 0, 0, 0, 0 },
/* U+a5b2 */ { 0, 0, 0, 0, 0 },
/* U+a5b3 */ { 0, 0, 0, 0, 0 },
/* U+a5b4 */ { 0, 0, 0, 0, 0 },
/* U+a5b5 */ { 0, 0, 0, 0, 0 },
/* U+a5b6 */ { 0, 0, 0, 0, 0 },
/* U+a5b7 */ { 0, 0, 0, 0, 0 },
/* U+a5b8 */ { 0, 0, 0, 0, 0 },
/* U+a5b9 */ { 0, 0, 0, 0, 0 },
/* U+a5ba */ { 0, 0, 0, 0, 0 },
/* U+a5bb */ { 0, 0, 0, 0, 0 },
/* U+a5bc */ { 0, 0, 0, 0, 0 },
/* U+a5bd */ { 0, 0, 0, 0, 0 },
/* U+a5be */ { 0, 0, 0, 0, 0 },
/* U+a5bf */ { 0, 0, 0, 0, 0 },
/* U+a5c0 */ { 0, 0, 0, 0, 0 },
/* U+a5c1 */ { 0, 0, 0, 0, 0 },
/* U+a5c2 */ { 0, 0, 0, 0, 0 },
/* U+a5c3 */ { 0, 0, 0, 0, 0 },
/* U+a5c4 */ { 0, 0, 0, 0, 0 },
/* U+a5c5 */ { 0, 0, 0, 0, 0 },
/* U+a5c6 */ { 0, 0, 0, 0, 0 },
/* U+a5c7 */ { 0, 0, 0, 0, 0 },
/* U+a5c8 */ { 0, 0, 0, 0, 0 },
/* U+a5c9 */ { 0, 0, 0, 0, 0 },
/* U+a5ca */ { 0, 0, 0, 0, 0 },
/* U+a5cb */ { 0, 0, 0, 0, 0 },
/* U+a5cc */ { 0, 0, 0, 0, 0 },
/* U+a5cd */ { 0, 0, 0, 0, 0 },
/* U+a5ce */ { 0, 0, 0, 0, 0 },
/* U+a5cf */ { 0, 0, 0, 0, 0 },
/* U+a5d0 */ { 0, 0, 0, 0, 0 },
/* U+a5d1 */ { 0, 0, 0, 0, 0 },
/* U+a5d2 */ { 0, 0, 0, 0, 0 },
/* U+a5d3 */ { 0, 0, 0, 0, 0 },
/* U+a5d4 */ { 0, 0, 0, 0, 0 },
/* U+a5d5 */ { 0, 0, 0, 0, 0 },
/* U+a5d6 */ { 0, 0, 0, 0, 0 },
/* U+a5d7 */ { 0, 0, 0, 0, 0 },
/* U+a5d8 */ { 0, 0, 0, 0, 0 },
/* U+a5d9 */ { 0, 0, 0, 0, 0 },
/* U+a5da */ { 0, 0, 0, 0, 0 },
/* U+a5db */ { 0, 0, 0, 0, 0 },
/* U+a5dc */ { 0, 0, 0, 0, 0 },
/* U+a5dd */ { 0, 0, 0, 0, 0 },
/* U+a5de */ { 0, 0, 0, 0, 0 },
/* U+a5df */ { 0, 0, 0, 0, 0 },
/* U+a5e0 */ { 0, 0, 0, 0, 0 },
/* U+a5e1 */ { 0, 0, 0, 0, 0 },
/* U+a5e2 */ { 0, 0, 0, 0, 0 },
/* U+a5e3 */ { 0, 0, 0, 0, 0 },
/* U+a5e4 */ { 0, 0, 0, 0, 0 },
/* U+a5e5 */ { 0, 0, 0, 0, 0 },
/* U+a5e6 */ { 0, 0, 0, 0, 0 },
/* U+a5e7 */ { 0, 0, 0, 0, 0 },
/* U+a5e8 */ { 0, 0, 0, 0, 0 },
/* U+a5e9 */ { 0, 0, 0, 0, 0 },
/* U+a5ea */ { 0, 0, 0, 0, 0 },
/* U+a5eb */ { 0, 0, 0, 0, 0 },
/* U+a5ec */ { 0, 0, 0, 0, 0 },
/* U+a5ed */ { 0, 0, 0, 0, 0 },
/* U+a5ee */ { 0, 0, 0, 0, 0 },
/* U+a5ef */ { 0, 0, 0, 0, 0 },
/* U+a5f0 */ { 0, 0, 0, 0, 0 },
/* U+a5f1 */ { 0, 0, 0, 0, 0 },
/* U+a5f2 */ { 0, 0, 0, 0, 0 },
/* U+a5f3 */ { 0, 0, 0, 0, 0 },
/* U+a5f4 */ { 0, 0, 0, 0, 0 },
/* U+a5f5 */ { 0, 0, 0, 0, 0 },
/* U+a5f6 */ { 0, 0, 0, 0, 0 },
/* U+a5f7 */ { 0, 0, 0, 0, 0 },
/* U+a5f8 */ { 0, 0, 0, 0, 0 },
/* U+a5f9 */ { 0, 0, 0, 0, 0 },
/* U+a5fa */ { 0, 0, 0, 0, 0 },
/* U+a5fb */ { 0, 0, 0, 0, 0 },
/* U+a5fc */ { 0, 0, 0, 0, 0 },
/* U+a5fd */ { 0, 0, 0, 0, 0 },
/* U+a5fe */ { 0, 0, 0, 0, 0 },
/* U+a5ff */ { 0, 0, 0, 0, 0 },
/* U+a600 */ { 0, 0, 0, 0, 0 },
/* U+a601 */ { 0, 0, 0, 0, 0 },
/* U+a602 */ { 0, 0, 0, 0, 0 },
/* U+a603 */ { 0, 0, 0, 0, 0 },
/* U+a604 */ { 0, 0, 0, 0, 0 },
/* U+a605 */ { 0, 0, 0, 0, 0 },
/* U+a606 */ { 0, 0, 0, 0, 0 },
/* U+a607 */ { 0, 0, 0, 0, 0 },
/* U+a608 */ { 0, 0, 0, 0, 0 },
/* U+a609 */ { 0, 0, 0, 0, 0 },
/* U+a60a */ { 0, 0, 0, 0, 0 },
/* U+a60b */ { 0, 0, 0, 0, 0 },
/* U+a60c */ { 0, 0, 0, 0, 0 },
/* U+a60d */ { 0, 0, 0, 0, 0 },
/* U+a60e */ { 0, 0, 0, 0, 0 },
/* U+a60f */ { 0, 0, 0, 0, 0 },
/* U+a610 */ { 0, 0, 0, 0, 0 },
/* U+a611 */ { 0, 0, 0, 0, 0 },
/* U+a612 */ { 0, 0, 0, 0, 0 },
/* U+a613 */ { 0, 0, 0, 0, 0 },
/* U+a614 */ { 0, 0, 0, 0, 0 },
/* U+a615 */ { 0, 0, 0, 0, 0 },
/* U+a616 */ { 0, 0, 0, 0, 0 },
/* U+a617 */ { 0, 0, 0, 0, 0 },
/* U+a618 */ { 0, 0, 0, 0, 0 },
/* U+a619 */ { 0, 0, 0, 0, 0 },
/* U+a61a */ { 0, 0, 0, 0, 0 },
/* U+a61b */ { 0, 0, 0, 0, 0 },
/* U+a61c */ { 0, 0, 0, 0, 0 },
/* U+a61d */ { 0, 0, 0, 0, 0 },
/* U+a61e */ { 0, 0, 0, 0, 0 },
/* U+a61f */ { 0, 0, 0, 0, 0 },
/* U+a620 */ { 0, 0, 0, 0, 0 },
/* U+a621 */ { 0, 0, 0, 0, 0 },
/* U+a622 */ { 0, 0, 0, 0, 0 },
/* U+a623 */ { 0, 0, 0, 0, 0 },
/* U+a624 */ { 0, 0, 0, 0, 0 },
/* U+a625 */ { 0, 0, 0, 0, 0 },
/* U+a626 */ { 0, 0, 0, 0, 0 },
/* U+a627 */ { 0, 0, 0, 0, 0 },
/* U+a628 */ { 0, 0, 0, 0, 0 },
/* U+a629 */ { 0, 0, 0, 0, 0 },
/* U+a62a */ { 0, 0, 0, 0, 0 },
/* U+a62b */ { 0, 0, 0, 0, 0 },
/* U+a62c */ { 0, 0, 0, 0, 0 },
/* U+a62d */ { 0, 0, 0, 0, 0 },
/* U+a62e */ { 0, 0, 0, 0, 0 },
/* U+a62f */ { 0, 0, 0, 0, 0 },
/* U+a630 */ { 0, 0, 0, 0, 0 },
/* U+a631 */ { 0, 0, 0, 0, 0 },
/* U+a632 */ { 0, 0, 0, 0, 0 },
/* U+a633 */ { 0, 0, 0, 0, 0 },
/* U+a634 */ { 0, 0, 0, 0, 0 },
/* U+a635 */ { 0, 0, 0, 0, 0 },
/* U+a636 */ { 0, 0, 0, 0, 0 },
/* U+a637 */ { 0, 0, 0, 0, 0 },
/* U+a638 */ { 0, 0, 0, 0, 0 },
/* U+a639 */ { 0, 0, 0, 0, 0 },
/* U+a63a */ { 0, 0, 0, 0, 0 },
/* U+a63b */ { 0, 0, 0, 0, 0 },
/* U+a63c */ { 0, 0, 0, 0, 0 },
/* U+a63d */ { 0, 0, 0, 0, 0 },
/* U+a63e */ { 0, 0, 0, 0, 0 },
/* U+a63f */ { 0, 0, 0, 0, 0 },
/* U+a640 */ { 0, 0, 0, 0, 0 },
/* U+a641 */ { 0, 0, 0, 0, 0 },
/* U+a642 */ { 0, 0, 0, 0, 0 },
/* U+a643 */ { 0, 0, 0, 0, 0 },
/* U+a644 */ { 0, 0, 0, 0, 0 },
/* U+a645 */ { 0, 0, 0, 0, 0 },
/* U+a646 */ { 0, 0, 0, 0, 0 },
/* U+a647 */ { 0, 0, 0, 0, 0 },
/* U+a648 */ { 0, 0, 0, 0, 0 },
/* U+a649 */ { 0, 0, 0, 0, 0 },
/* U+a64a */ { 0, 0, 0, 0, 0 },
/* U+a64b */ { 0, 0, 0, 0, 0 },
/* U+a64c */ { 0, 0, 0, 0, 0 },
/* U+a64d */ { 0, 0, 0, 0, 0 },
/* U+a64e */ { 0, 0, 0, 0, 0 },
/* U+a64f */ { 0, 0, 0, 0, 0 },
/* U+a650 */ { 0, 0, 0, 0, 0 },
/* U+a651 */ { 0, 0, 0, 0, 0 },
/* U+a652 */ { 0, 0, 0, 0, 0 },
/* U+a653 */ { 0, 0, 0, 0, 0 },
/* U+a654 */ { 0, 0, 0, 0, 0 },
/* U+a655 */ { 0, 0, 0, 0, 0 },
/* U+a656 */ { 0, 0, 0, 0, 0 },
/* U+a657 */ { 0, 0, 0, 0, 0 },
/* U+a658 */ { 0, 0, 0, 0, 0 },
/* U+a659 */ { 0, 0, 0, 0, 0 },
/* U+a65a */ { 0, 0, 0, 0, 0 },
/* U+a65b */ { 0, 0, 0, 0, 0 },
/* U+a65c */ { 0, 0, 0, 0, 0 },
/* U+a65d */ { 0, 0, 0, 0, 0 },
/* U+a65e */ { 0, 0, 0, 0, 0 },
/* U+a65f */ { 0, 0, 0, 0, 0 },
/* U+a660 */ { 0, 0, 0, 0, 0 },
/* U+a661 */ { 0, 0, 0, 0, 0 },
/* U+a662 */ { 0, 0, 0, 0, 0 },
/* U+a663 */ { 0, 0, 0, 0, 0 },
/* U+a664 */ { 0, 0, 0, 0, 0 },
/* U+a665 */ { 0, 0, 0, 0, 0 },
/* U+a666 */ { 0, 0, 0, 0, 0 },
/* U+a667 */ { 0, 0, 0, 0, 0 },
/* U+a668 */ { 0, 0, 0, 0, 0 },
/* U+a669 */ { 0, 0, 0, 0, 0 },
/* U+a66a */ { 0, 0, 0, 0, 0 },
/* U+a66b */ { 0, 0, 0, 0, 0 },
/* U+a66c */ { 0, 0, 0, 0, 0 },
/* U+a66d */ { 0, 0, 0, 0, 0 },
/* U+a66e */ { 0, 0, 0, 0, 0 },
/* U+a66f */ { 0, 0, 0, 0, 0 },
/* U+a670 */ { 0, 0, 0, 0, 0 },
/* U+a671 */ { 0, 0, 0, 0, 0 },
/* U+a672 */ { 0, 0, 0, 0, 0 },
/* U+a673 */ { 0, 0, 0, 0, 0 },
/* U+a674 */ { 0, 0, 0, 0, 0 },
/* U+a675 */ { 0, 0, 0, 0, 0 },
/* U+a676 */ { 0, 0, 0, 0, 0 },
/* U+a677 */ { 0, 0, 0, 0, 0 },
/* U+a678 */ { 0, 0, 0, 0, 0 },
/* U+a679 */ { 0, 0, 0, 0, 0 },
/* U+a67a */ { 0, 0, 0, 0, 0 },
/* U+a67b */ { 0, 0, 0, 0, 0 },
/* U+a67c */ { 0, 0, 0, 0, 0 },
/* U+a67d */ { 0, 0, 0, 0, 0 },
/* U+a67e */ { 0, 0, 0, 0, 0 },
/* U+a67f */ { 0, 0, 0, 0, 0 },
/* U+a680 */ { 0, 0, 0, 0, 0 },
/* U+a681 */ { 0, 0, 0, 0, 0 },
/* U+a682 */ { 0, 0, 0, 0, 0 },
/* U+a683 */ { 0, 0, 0, 0, 0 },
/* U+a684 */ { 0, 0, 0, 0, 0 },
/* U+a685 */ { 0, 0, 0, 0, 0 },
/* U+a686 */ { 0, 0, 0, 0, 0 },
/* U+a687 */ { 0, 0, 0, 0, 0 },
/* U+a688 */ { 0, 0, 0, 0, 0 },
/* U+a689 */ { 0, 0, 0, 0, 0 },
/* U+a68a */ { 0, 0, 0, 0, 0 },
/* U+a68b */ { 0, 0, 0, 0, 0 },
/* U+a68c */ { 0, 0, 0, 0, 0 },
/* U+a68d */ { 0, 0, 0, 0, 0 },
/* U+a68e */ { 0, 0, 0, 0, 0 },
/* U+a68f */ { 0, 0, 0, 0, 0 },
/* U+a690 */ { 0, 0, 0, 0, 0 },
/* U+a691 */ { 0, 0, 0, 0, 0 },
/* U+a692 */ { 0, 0, 0, 0, 0 },
/* U+a693 */ { 0, 0, 0, 0, 0 },
/* U+a694 */ { 0, 0, 0, 0, 0 },
/* U+a695 */ { 0, 0, 0, 0, 0 },
/* U+a696 */ { 0, 0, 0, 0, 0 },
/* U+a697 */ { 0, 0, 0, 0, 0 },
/* U+a698 */ { 0, 0, 0, 0, 0 },
/* U+a699 */ { 0, 0, 0, 0, 0 },
/* U+a69a */ { 0, 0, 0, 0, 0 },
/* U+a69b */ { 0, 0, 0, 0, 0 },
/* U+a69c */ { 0, 0, 0, 0, 0 },
/* U+a69d */ { 0, 0, 0, 0, 0 },
/* U+a69e */ { 0, 0, 0, 0, 0 },
/* U+a69f */ { 0, 0, 0, 0, 0 },
/* U+a6a0 */ { 0, 0, 0, 0, 0 },
/* U+a6a1 */ { 0, 0, 0, 0, 0 },
/* U+a6a2 */ { 0, 0, 0, 0, 0 },
/* U+a6a3 */ { 0, 0, 0, 0, 0 },
/* U+a6a4 */ { 0, 0, 0, 0, 0 },
/* U+a6a5 */ { 0, 0, 0, 0, 0 },
/* U+a6a6 */ { 0, 0, 0, 0, 0 },
/* U+a6a7 */ { 0, 0, 0, 0, 0 },
/* U+a6a8 */ { 0, 0, 0, 0, 0 },
/* U+a6a9 */ { 0, 0, 0, 0, 0 },
/* U+a6aa */ { 0, 0, 0, 0, 0 },
/* U+a6ab */ { 0, 0, 0, 0, 0 },
/* U+a6ac */ { 0, 0, 0, 0, 0 },
/* U+a6ad */ { 0, 0, 0, 0, 0 },
/* U+a6ae */ { 0, 0, 0, 0, 0 },
/* U+a6af */ { 0, 0, 0, 0, 0 },
/* U+a6b0 */ { 0, 0, 0, 0, 0 },
/* U+a6b1 */ { 0, 0, 0, 0, 0 },
/* U+a6b2 */ { 0, 0, 0, 0, 0 },
/* U+a6b3 */ { 0, 0, 0, 0, 0 },
/* U+a6b4 */ { 0, 0, 0, 0, 0 },
/* U+a6b5 */ { 0, 0, 0, 0, 0 },
/* U+a6b6 */ { 0, 0, 0, 0, 0 },
/* U+a6b7 */ { 0, 0, 0, 0, 0 },
/* U+a6b8 */ { 0, 0, 0, 0, 0 },
/* U+a6b9 */ { 0, 0, 0, 0, 0 },
/* U+a6ba */ { 0, 0, 0, 0, 0 },
/* U+a6bb */ { 0, 0, 0, 0, 0 },
/* U+a6bc */ { 0, 0, 0, 0, 0 },
/* U+a6bd */ { 0, 0, 0, 0, 0 },
/* U+a6be */ { 0, 0, 0, 0, 0 },
/* U+a6bf */ { 0, 0, 0, 0, 0 },
/* U+a6c0 */ { 0, 0, 0, 0, 0 },
/* U+a6c1 */ { 0, 0, 0, 0, 0 },
/* U+a6c2 */ { 0, 0, 0, 0, 0 },
/* U+a6c3 */ { 0, 0, 0, 0, 0 },
/* U+a6c4 */ { 0, 0, 0, 0, 0 },
/* U+a6c5 */ { 0, 0, 0, 0, 0 },
/* U+a6c6 */ { 0, 0, 0, 0, 0 },
/* U+a6c7 */ { 0, 0, 0, 0, 0 },
/* U+a6c8 */ { 0, 0, 0, 0, 0 },
/* U+a6c9 */ { 0, 0, 0, 0, 0 },
/* U+a6ca */ { 0, 0, 0, 0, 0 },
/* U+a6cb */ { 0, 0, 0, 0, 0 },
/* U+a6cc */ { 0, 0, 0, 0, 0 },
/* U+a6cd */ { 0, 0, 0, 0, 0 },
/* U+a6ce */ { 0, 0, 0, 0, 0 },
/* U+a6cf */ { 0, 0, 0, 0, 0 },
/* U+a6d0 */ { 0, 0, 0, 0, 0 },
/* U+a6d1 */ { 0, 0, 0, 0, 0 },
/* U+a6d2 */ { 0, 0, 0, 0, 0 },
/* U+a6d3 */ { 0, 0, 0, 0, 0 },
/* U+a6d4 */ { 0, 0, 0, 0, 0 },
/* U+a6d5 */ { 0, 0, 0, 0, 0 },
/* U+a6d6 */ { 0, 0, 0, 0, 0 },
/* U+a6d7 */ { 0, 0, 0, 0, 0 },
/* U+a6d8 */ { 0, 0, 0, 0, 0 },
/* U+a6d9 */ { 0, 0, 0, 0, 0 },
/* U+a6da */ { 0, 0, 0, 0, 0 },
/* U+a6db */ { 0, 0, 0, 0, 0 },
/* U+a6dc */ { 0, 0, 0, 0, 0 },
/* U+a6dd */ { 0, 0, 0, 0, 0 },
/* U+a6de */ { 0, 0, 0, 0, 0 },
/* U+a6df */ { 0, 0, 0, 0, 0 },
/* U+a6e0 */ { 0, 0, 0, 0, 0 },
/* U+a6e1 */ { 0, 0, 0, 0, 0 },
/* U+a6e2 */ { 0, 0, 0, 0, 0 },
/* U+a6e3 */ { 0, 0, 0, 0, 0 },
/* U+a6e4 */ { 0, 0, 0, 0, 0 },
/* U+a6e5 */ { 0, 0, 0, 0, 0 },
/* U+a6e6 */ { 0, 0, 0, 0, 0 },
/* U+a6e7 */ { 0, 0, 0, 0, 0 },
/* U+a6e8 */ { 0, 0, 0, 0, 0 },
/* U+a6e9 */ { 0, 0, 0, 0, 0 },
/* U+a6ea */ { 0, 0, 0, 0, 0 },
/* U+a6eb */ { 0, 0, 0, 0, 0 },
/* U+a6ec */ { 0, 0, 0, 0, 0 },
/* U+a6ed */ { 0, 0, 0, 0, 0 },
/* U+a6ee */ { 0, 0, 0, 0, 0 },
/* U+a6ef */ { 0, 0, 0, 0, 0 },
/* U+a6f0 */ { 0, 0, 0, 0, 0 },
/* U+a6f1 */ { 0, 0, 0, 0, 0 },
/* U+a6f2 */ { 0, 0, 0, 0, 0 },
/* U+a6f3 */ { 0, 0, 0, 0, 0 },
/* U+a6f4 */ { 0, 0, 0, 0, 0 },
/* U+a6f5 */ { 0, 0, 0, 0, 0 },
/* U+a6f6 */ { 0, 0, 0, 0, 0 },
/* U+a6f7 */ { 0, 0, 0, 0, 0 },
/* U+a6f8 */ { 0, 0, 0, 0, 0 },
/* U+a6f9 */ { 0, 0, 0, 0, 0 },
/* U+a6fa */ { 0, 0, 0, 0, 0 },
/* U+a6fb */ { 0, 0, 0, 0, 0 },
/* U+a6fc */ { 0, 0, 0, 0, 0 },
/* U+a6fd */ { 0, 0, 0, 0, 0 },
/* U+a6fe */ { 0, 0, 0, 0, 0 },
/* U+a6ff */ { 0, 0, 0, 0, 0 },
/* U+a700 */ { 0, 0, 0, 0, 0 },
/* U+a701 */ { 0, 0, 0, 0, 0 },
/* U+a702 */ { 0, 0, 0, 0, 0 },
/* U+a703 */ { 0, 0, 0, 0, 0 },
/* U+a704 */ { 0, 0, 0, 0, 0 },
/* U+a705 */ { 0, 0, 0, 0, 0 },
/* U+a706 */ { 0, 0, 0, 0, 0 },
/* U+a707 */ { 0, 0, 0, 0, 0 },
/* U+a708 */ { 0, 0, 0, 0, 0 },
/* U+a709 */ { 0, 0, 0, 0, 0 },
/* U+a70a */ { 0, 0, 0, 0, 0 },
/* U+a70b */ { 0, 0, 0, 0, 0 },
/* U+a70c */ { 0, 0, 0, 0, 0 },
/* U+a70d */ { 0, 0, 0, 0, 0 },
/* U+a70e */ { 0, 0, 0, 0, 0 },
/* U+a70f */ { 0, 0, 0, 0, 0 },
/* U+a710 */ { 0, 0, 0, 0, 0 },
/* U+a711 */ { 0, 0, 0, 0, 0 },
/* U+a712 */ { 0, 0, 0, 0, 0 },
/* U+a713 */ { 0, 0, 0, 0, 0 },
/* U+a714 */ { 0, 0, 0, 0, 0 },
/* U+a715 */ { 0, 0, 0, 0, 0 },
/* U+a716 */ { 0, 0, 0, 0, 0 },
/* U+a717 */ { 0, 0, 0, 0, 0 },
/* U+a718 */ { 0, 0, 0, 0, 0 },
/* U+a719 */ { 0, 0, 0, 0, 0 },
/* U+a71a */ { 0, 0, 0, 0, 0 },
/* U+a71b */ { 0, 0, 0, 0, 0 },
/* U+a71c */ { 0, 0, 0, 0, 0 },
/* U+a71d */ { 0, 0, 0, 0, 0 },
/* U+a71e */ { 0, 0, 0, 0, 0 },
/* U+a71f */ { 0, 0, 0, 0, 0 },
/* U+a720 */ { 0, 0, 0, 0, 0 },
/* U+a721 */ { 0, 0, 0, 0, 0 },
/* U+a722 */ { 0, 0, 0, 0, 0 },
/* U+a723 */ { 0, 0, 0, 0, 0 },
/* U+a724 */ { 0, 0, 0, 0, 0 },
/* U+a725 */ { 0, 0, 0, 0, 0 },
/* U+a726 */ { 0, 0, 0, 0, 0 },
/* U+a727 */ { 0, 0, 0, 0, 0 },
/* U+a728 */ { 0, 0, 0, 0, 0 },
/* U+a729 */ { 0, 0, 0, 0, 0 },
/* U+a72a */ { 0, 0, 0, 0, 0 },
/* U+a72b */ { 0, 0, 0, 0, 0 },
/* U+a72c */ { 0, 0, 0, 0, 0 },
/* U+a72d */ { 0, 0, 0, 0, 0 },
/* U+a72e */ { 0, 0, 0, 0, 0 },
/* U+a72f */ { 0, 0, 0, 0, 0 },
/* U+a730 */ { 0, 0, 0, 0, 0 },
/* U+a731 */ { 0, 0, 0, 0, 0 },
/* U+a732 */ { 0, 0, 0, 0, 0 },
/* U+a733 */ { 0, 0, 0, 0, 0 },
/* U+a734 */ { 0, 0, 0, 0, 0 },
/* U+a735 */ { 0, 0, 0, 0, 0 },
/* U+a736 */ { 0, 0, 0, 0, 0 },
/* U+a737 */ { 0, 0, 0, 0, 0 },
/* U+a738 */ { 0, 0, 0, 0, 0 },
/* U+a739 */ { 0, 0, 0, 0, 0 },
/* U+a73a */ { 0, 0, 0, 0, 0 },
/* U+a73b */ { 0, 0, 0, 0, 0 },
/* U+a73c */ { 0, 0, 0, 0, 0 },
/* U+a73d */ { 0, 0, 0, 0, 0 },
/* U+a73e */ { 0, 0, 0, 0, 0 },
/* U+a73f */ { 0, 0, 0, 0, 0 },
/* U+a740 */ { 0, 0, 0, 0, 0 },
/* U+a741 */ { 0, 0, 0, 0, 0 },
/* U+a742 */ { 0, 0, 0, 0, 0 },
/* U+a743 */ { 0, 0, 0, 0, 0 },
/* U+a744 */ { 0, 0, 0, 0, 0 },
/* U+a745 */ { 0, 0, 0, 0, 0 },
/* U+a746 */ { 0, 0, 0, 0, 0 },
/* U+a747 */ { 0, 0, 0, 0, 0 },
/* U+a748 */ { 0, 0, 0, 0, 0 },
/* U+a749 */ { 0, 0, 0, 0, 0 },
/* U+a74a */ { 0, 0, 0, 0, 0 },
/* U+a74b */ { 0, 0, 0, 0, 0 },
/* U+a74c */ { 0, 0, 0, 0, 0 },
/* U+a74d */ { 0, 0, 0, 0, 0 },
/* U+a74e */ { 0, 0, 0, 0, 0 },
/* U+a74f */ { 0, 0, 0, 0, 0 },
/* U+a750 */ { 0, 0, 0, 0, 0 },
/* U+a751 */ { 0, 0, 0, 0, 0 },
/* U+a752 */ { 0, 0, 0, 0, 0 },
/* U+a753 */ { 0, 0, 0, 0, 0 },
/* U+a754 */ { 0, 0, 0, 0, 0 },
/* U+a755 */ { 0, 0, 0, 0, 0 },
/* U+a756 */ { 0, 0, 0, 0, 0 },
/* U+a757 */ { 0, 0, 0, 0, 0 },
/* U+a758 */ { 0, 0, 0, 0, 0 },
/* U+a759 */ { 0, 0, 0, 0, 0 },
/* U+a75a */ { 0, 0, 0, 0, 0 },
/* U+a75b */ { 0, 0, 0, 0, 0 },
/* U+a75c */ { 0, 0, 0, 0, 0 },
/* U+a75d */ { 0, 0, 0, 0, 0 },
/* U+a75e */ { 0, 0, 0, 0, 0 },
/* U+a75f */ { 0, 0, 0, 0, 0 },
/* U+a760 */ { 0, 0, 0, 0, 0 },
/* U+a761 */ { 0, 0, 0, 0, 0 },
/* U+a762 */ { 0, 0, 0, 0, 0 },
/* U+a763 */ { 0, 0, 0, 0, 0 },
/* U+a764 */ { 0, 0, 0, 0, 0 },
/* U+a765 */ { 0, 0, 0, 0, 0 },
/* U+a766 */ { 0, 0, 0, 0, 0 },
/* U+a767 */ { 0, 0, 0, 0, 0 },
/* U+a768 */ { 0, 0, 0, 0, 0 },
/* U+a769 */ { 0, 0, 0, 0, 0 },
/* U+a76a */ { 0, 0, 0, 0, 0 },
/* U+a76b */ { 0, 0, 0, 0, 0 },
/* U+a76c */ { 0, 0, 0, 0, 0 },
/* U+a76d */ { 0, 0, 0, 0, 0 },
/* U+a76e */ { 0, 0, 0, 0, 0 },
/* U+a76f */ { 0, 0, 0, 0, 0 },
/* U+a770 */ { 0, 0, 0, 0, 0 },
/* U+a771 */ { 0, 0, 0, 0, 0 },
/* U+a772 */ { 0, 0, 0, 0, 0 },
/* U+a773 */ { 0, 0, 0, 0, 0 },
/* U+a774 */ { 0, 0, 0, 0, 0 },
/* U+a775 */ { 0, 0, 0, 0, 0 },
/* U+a776 */ { 0, 0, 0, 0, 0 },
/* U+a777 */ { 0, 0, 0, 0, 0 },
/* U+a778 */ { 0, 0, 0, 0, 0 },
/* U+a779 */ { 0, 0, 0, 0, 0 },
/* U+a77a */ { 0, 0, 0, 0, 0 },
/* U+a77b */ { 0, 0, 0, 0, 0 },
/* U+a77c */ { 0, 0, 0, 0, 0 },
/* U+a77d */ { 0, 0, 0, 0, 0 },
/* U+a77e */ { 0, 0, 0, 0, 0 },
/* U+a77f */ { 0, 0, 0, 0, 0 },
/* U+a780 */ { 0, 0, 0, 0, 0 },
/* U+a781 */ { 0, 0, 0, 0, 0 },
/* U+a782 */ { 0, 0, 0, 0, 0 },
/* U+a783 */ { 0, 0, 0, 0, 0 },
/* U+a784 */ { 0, 0, 0, 0, 0 },
/* U+a785 */ { 0, 0, 0, 0, 0 },
/* U+a786 */ { 0, 0, 0, 0, 0 },
/* U+a787 */ { 0, 0, 0, 0, 0 },
/* U+a788 */ { 0, 0, 0, 0, 0 },
/* U+a789 */ { 0, 0, 0, 0, 0 },
/* U+a78a */ { 0, 0, 0, 0, 0 },
/* U+a78b */ { 0, 0, 0, 0, 0 },
/* U+a78c */ { 0, 0, 0, 0, 0 },
/* U+a78d */ { 0, 0, 0, 0, 0 },
/* U+a78e */ { 0, 0, 0, 0, 0 },
/* U+a78f */ { 0, 0, 0, 0, 0 },
/* U+a790 */ { 0, 0, 0, 0, 0 },
/* U+a791 */ { 0, 0, 0, 0, 0 },
/* U+a792 */ { 0, 0, 0, 0, 0 },
/* U+a793 */ { 0, 0, 0, 0, 0 },
/* U+a794 */ { 0, 0, 0, 0, 0 },
/* U+a795 */ { 0, 0, 0, 0, 0 },
/* U+a796 */ { 0, 0, 0, 0, 0 },
/* U+a797 */ { 0, 0, 0, 0, 0 },
/* U+a798 */ { 0, 0, 0, 0, 0 },
/* U+a799 */ { 0, 0, 0, 0, 0 },
/* U+a79a */ { 0, 0, 0, 0, 0 },
/* U+a79b */ { 0, 0, 0, 0, 0 },
/* U+a79c */ { 0, 0, 0, 0, 0 },
/* U+a79d */ { 0, 0, 0, 0, 0 },
/* U+a79e */ { 0, 0, 0, 0, 0 },
/* U+a79f */ { 0, 0, 0, 0, 0 },
/* U+a7a0 */ { 0, 0, 0, 0, 0 },
/* U+a7a1 */ { 0, 0, 0, 0, 0 },
/* U+a7a2 */ { 0, 0, 0, 0, 0 },
/* U+a7a3 */ { 0, 0, 0, 0, 0 },
/* U+a7a4 */ { 0, 0, 0, 0, 0 },
/* U+a7a5 */ { 0, 0, 0, 0, 0 },
/* U+a7a6 */ { 0, 0, 0, 0, 0 },
/* U+a7a7 */ { 0, 0, 0, 0, 0 },
/* U+a7a8 */ { 0, 0, 0, 0, 0 },
/* U+a7a9 */ { 0, 0, 0, 0, 0 },
/* U+a7aa */ { 0, 0, 0, 0, 0 },
/* U+a7ab */ { 0, 0, 0, 0, 0 },
/* U+a7ac */ { 0, 0, 0, 0, 0 },
/* U+a7ad */ { 0, 0, 0, 0, 0 },
/* U+a7ae */ { 0, 0, 0, 0, 0 },
/* U+a7af */ { 0, 0, 0, 0, 0 },
/* U+a7b0 */ { 0, 0, 0, 0, 0 },
/* U+a7b1 */ { 0, 0, 0, 0, 0 },
/* U+a7b2 */ { 0, 0, 0, 0, 0 },
/* U+a7b3 */ { 0, 0, 0, 0, 0 },
/* U+a7b4 */ { 0, 0, 0, 0, 0 },
/* U+a7b5 */ { 0, 0, 0, 0, 0 },
/* U+a7b6 */ { 0, 0, 0, 0, 0 },
/* U+a7b7 */ { 0, 0, 0, 0, 0 },
/* U+a7b8 */ { 0, 0, 0, 0, 0 },
/* U+a7b9 */ { 0, 0, 0, 0, 0 },
/* U+a7ba */ { 0, 0, 0, 0, 0 },
/* U+a7bb */ { 0, 0, 0, 0, 0 },
/* U+a7bc */ { 0, 0, 0, 0, 0 },
/* U+a7bd */ { 0, 0, 0, 0, 0 },
/* U+a7be */ { 0, 0, 0, 0, 0 },
/* U+a7bf */ { 0, 0, 0, 0, 0 },
/* U+a7c0 */ { 0, 0, 0, 0, 0 },
/* U+a7c1 */ { 0, 0, 0, 0, 0 },
/* U+a7c2 */ { 0, 0, 0, 0, 0 },
/* U+a7c3 */ { 0, 0, 0, 0, 0 },
/* U+a7c4 */ { 0, 0, 0, 0, 0 },
/* U+a7c5 */ { 0, 0, 0, 0, 0 },
/* U+a7c6 */ { 0, 0, 0, 0, 0 },
/* U+a7c7 */ { 0, 0, 0, 0, 0 },
/* U+a7c8 */ { 0, 0, 0, 0, 0 },
/* U+a7c9 */ { 0, 0, 0, 0, 0 },
/* U+a7ca */ { 0, 0, 0, 0, 0 },
/* U+a7cb */ { 0, 0, 0, 0, 0 },
/* U+a7cc */ { 0, 0, 0, 0, 0 },
/* U+a7cd */ { 0, 0, 0, 0, 0 },
/* U+a7ce */ { 0, 0, 0, 0, 0 },
/* U+a7cf */ { 0, 0, 0, 0, 0 },
/* U+a7d0 */ { 0, 0, 0, 0, 0 },
/* U+a7d1 */ { 0, 0, 0, 0, 0 },
/* U+a7d2 */ { 0, 0, 0, 0, 0 },
/* U+a7d3 */ { 0, 0, 0, 0, 0 },
/* U+a7d4 */ { 0, 0, 0, 0, 0 },
/* U+a7d5 */ { 0, 0, 0, 0, 0 },
/* U+a7d6 */ { 0, 0, 0, 0, 0 },
/* U+a7d7 */ { 0, 0, 0, 0, 0 },
/* U+a7d8 */ { 0, 0, 0, 0, 0 },
/* U+a7d9 */ { 0, 0, 0, 0, 0 },
/* U+a7da */ { 0, 0, 0, 0, 0 },
/* U+a7db */ { 0, 0, 0, 0, 0 },
/* U+a7dc */ { 0, 0, 0, 0, 0 },
/* U+a7dd */ { 0, 0, 0, 0, 0 },
/* U+a7de */ { 0, 0, 0, 0, 0 },
/* U+a7df */ { 0, 0, 0, 0, 0 },
/* U+a7e0 */ { 0, 0, 0, 0, 0 },
/* U+a7e1 */ { 0, 0, 0, 0, 0 },
/* U+a7e2 */ { 0, 0, 0, 0, 0 },
/* U+a7e3 */ { 0, 0, 0, 0, 0 },
/* U+a7e4 */ { 0, 0, 0, 0, 0 },
/* U+a7e5 */ { 0, 0, 0, 0, 0 },
/* U+a7e6 */ { 0, 0, 0, 0, 0 },
/* U+a7e7 */ { 0, 0, 0, 0, 0 },
/* U+a7e8 */ { 0, 0, 0, 0, 0 },
/* U+a7e9 */ { 0, 0, 0, 0, 0 },
/* U+a7ea */ { 0, 0, 0, 0, 0 },
/* U+a7eb */ { 0, 0, 0, 0, 0 },
/* U+a7ec */ { 0, 0, 0, 0, 0 },
/* U+a7ed */ { 0, 0, 0, 0, 0 },
/* U+a7ee */ { 0, 0, 0, 0, 0 },
/* U+a7ef */ { 0, 0, 0, 0, 0 },
/* U+a7f0 */ { 0, 0, 0, 0, 0 },
/* U+a7f1 */ { 0, 0, 0, 0, 0 },
/* U+a7f2 */ { 0, 0, 0, 0, 0 },
/* U+a7f3 */ { 0, 0, 0, 0, 0 },
/* U+a7f4 */ { 0, 0, 0, 0, 0 },
/* U+a7f5 */ { 0, 0, 0, 0, 0 },
/* U+a7f6 */ { 0, 0, 0, 0, 0 },
/* U+a7f7 */ { 0, 0, 0, 0, 0 },
/* U+a7f8 */ { 0, 0, 0, 0, 0 },
/* U+a7f9 */ { 0, 0, 0, 0, 0 },
/* U+a7fa */ { 0, 0, 0, 0, 0 },
/* U+a7fb */ { 0, 0, 0, 0, 0 },
/* U+a7fc */ { 0, 0, 0, 0, 0 },
/* U+a7fd */ { 0, 0, 0, 0, 0 },
/* U+a7fe */ { 0, 0, 0, 0, 0 },
/* U+a7ff */ { 0, 0, 0, 0, 0 },
/* U+a800 */ { 0, 0, 0, 0, 0 },
/* U+a801 */ { 0, 0, 0, 0, 0 },
/* U+a802 */ { 0, 0, 0, 0, 0 },
/* U+a803 */ { 0, 0, 0, 0, 0 },
/* U+a804 */ { 0, 0, 0, 0, 0 },
/* U+a805 */ { 0, 0, 0, 0, 0 },
/* U+a806 */ { 0, 0, 0, 0, 0 },
/* U+a807 */ { 0, 0, 0, 0, 0 },
/* U+a808 */ { 0, 0, 0, 0, 0 },
/* U+a809 */ { 0, 0, 0, 0, 0 },
/* U+a80a */ { 0, 0, 0, 0, 0 },
/* U+a80b */ { 0, 0, 0, 0, 0 },
/* U+a80c */ { 0, 0, 0, 0, 0 },
/* U+a80d */ { 0, 0, 0, 0, 0 },
/* U+a80e */ { 0, 0, 0, 0, 0 },
/* U+a80f */ { 0, 0, 0, 0, 0 },
/* U+a810 */ { 0, 0, 0, 0, 0 },
/* U+a811 */ { 0, 0, 0, 0, 0 },
/* U+a812 */ { 0, 0, 0, 0, 0 },
/* U+a813 */ { 0, 0, 0, 0, 0 },
/* U+a814 */ { 0, 0, 0, 0, 0 },
/* U+a815 */ { 0, 0, 0, 0, 0 },
/* U+a816 */ { 0, 0, 0, 0, 0 },
/* U+a817 */ { 0, 0, 0, 0, 0 },
/* U+a818 */ { 0, 0, 0, 0, 0 },
/* U+a819 */ { 0, 0, 0, 0, 0 },
/* U+a81a */ { 0, 0, 0, 0, 0 },
/* U+a81b */ { 0, 0, 0, 0, 0 },
/* U+a81c */ { 0, 0, 0, 0, 0 },
/* U+a81d */ { 0, 0, 0, 0, 0 },
/* U+a81e */ { 0, 0, 0, 0, 0 },
/* U+a81f */ { 0, 0, 0, 0, 0 },
/* U+a820 */ { 0, 0, 0, 0, 0 },
/* U+a821 */ { 0, 0, 0, 0, 0 },
/* U+a822 */ { 0, 0, 0, 0, 0 },
/* U+a823 */ { 0, 0, 0, 0, 0 },
/* U+a824 */ { 0, 0, 0, 0, 0 },
/* U+a825 */ { 0, 0, 0, 0, 0 },
/* U+a826 */ { 0, 0, 0, 0, 0 },
/* U+a827 */ { 0, 0, 0, 0, 0 },
/* U+a828 */ { 0, 0, 0, 0, 0 },
/* U+a829 */ { 0, 0, 0, 0, 0 },
/* U+a82a */ { 0, 0, 0, 0, 0 },
/* U+a82b */ { 0, 0, 0, 0, 0 },
/* U+a82c */ { 0, 0, 0, 0, 0 },
/* U+a82d */ { 0, 0, 0, 0, 0 },
/* U+a82e */ { 0, 0, 0, 0, 0 },
/* U+a82f */ { 0, 0, 0, 0, 0 },
/* U+a830 */ { 0, 0, 0, 0, 0 },
/* U+a831 */ { 0, 0, 0, 0, 0 },
/* U+a832 */ { 0, 0, 0, 0, 0 },
/* U+a833 */ { 0, 0, 0, 0, 0 },
/* U+a834 */ { 0, 0, 0, 0, 0 },
/* U+a835 */ { 0, 0, 0, 0, 0 },
/* U+a836 */ { 0, 0, 0, 0, 0 },
/* U+a837 */ { 0, 0, 0, 0, 0 },
/* U+a838 */ { 0, 0, 0, 0, 0 },
/* U+a839 */ { 0, 0, 0, 0, 0 },
/* U+a83a */ { 0, 0, 0, 0, 0 },
/* U+a83b */ { 0, 0, 0, 0, 0 },
/* U+a83c */ { 0, 0, 0, 0, 0 },
/* U+a83d */ { 0, 0, 0, 0, 0 },
/* U+a83e */ { 0, 0, 0, 0, 0 },
/* U+a83f */ { 0, 0, 0, 0, 0 },
/* U+a840 */ { 0, 0, 0, 0, 0 },
/* U+a841 */ { 0, 0, 0, 0, 0 },
/* U+a842 */ { 0, 0, 0, 0, 0 },
/* U+a843 */ { 0, 0, 0, 0, 0 },
/* U+a844 */ { 0, 0, 0, 0, 0 },
/* U+a845 */ { 0, 0, 0, 0, 0 },
/* U+a846 */ { 0, 0, 0, 0, 0 },
/* U+a847 */ { 0, 0, 0, 0, 0 },
/* U+a848 */ { 0, 0, 0, 0, 0 },
/* U+a849 */ { 0, 0, 0, 0, 0 },
/* U+a84a */ { 0, 0, 0, 0, 0 },
/* U+a84b */ { 0, 0, 0, 0, 0 },
/* U+a84c */ { 0, 0, 0, 0, 0 },
/* U+a84d */ { 0, 0, 0, 0, 0 },
/* U+a84e */ { 0, 0, 0, 0, 0 },
/* U+a84f */ { 0, 0, 0, 0, 0 },
/* U+a850 */ { 0, 0, 0, 0, 0 },
/* U+a851 */ { 0, 0, 0, 0, 0 },
/* U+a852 */ { 0, 0, 0, 0, 0 },
/* U+a853 */ { 0, 0, 0, 0, 0 },
/* U+a854 */ { 0, 0, 0, 0, 0 },
/* U+a855 */ { 0, 0, 0, 0, 0 },
/* U+a856 */ { 0, 0, 0, 0, 0 },
/* U+a857 */ { 0, 0, 0, 0, 0 },
/* U+a858 */ { 0, 0, 0, 0, 0 },
/* U+a859 */ { 0, 0, 0, 0, 0 },
/* U+a85a */ { 0, 0, 0, 0, 0 },
/* U+a85b */ { 0, 0, 0, 0, 0 },
/* U+a85c */ { 0, 0, 0, 0, 0 },
/* U+a85d */ { 0, 0, 0, 0, 0 },
/* U+a85e */ { 0, 0, 0, 0, 0 },
/* U+a85f */ { 0, 0, 0, 0, 0 },
/* U+a860 */ { 0, 0, 0, 0, 0 },
/* U+a861 */ { 0, 0, 0, 0, 0 },
/* U+a862 */ { 0, 0, 0, 0, 0 },
/* U+a863 */ { 0, 0, 0, 0, 0 },
/* U+a864 */ { 0, 0, 0, 0, 0 },
/* U+a865 */ { 0, 0, 0, 0, 0 },
/* U+a866 */ { 0, 0, 0, 0, 0 },
/* U+a867 */ { 0, 0, 0, 0, 0 },
/* U+a868 */ { 0, 0, 0, 0, 0 },
/* U+a869 */ { 0, 0, 0, 0, 0 },
/* U+a86a */ { 0, 0, 0, 0, 0 },
/* U+a86b */ { 0, 0, 0, 0, 0 },
/* U+a86c */ { 0, 0, 0, 0, 0 },
/* U+a86d */ { 0, 0, 0, 0, 0 },
/* U+a86e */ { 0, 0, 0, 0, 0 },
/* U+a86f */ { 0, 0, 0, 0, 0 },
/* U+a870 */ { 0, 0, 0, 0, 0 },
/* U+a871 */ { 0, 0, 0, 0, 0 },
/* U+a872 */ { 0, 0, 0, 0, 0 },
/* U+a873 */ { 0, 0, 0, 0, 0 },
/* U+a874 */ { 0, 0, 0, 0, 0 },
/* U+a875 */ { 0, 0, 0, 0, 0 },
/* U+a876 */ { 0, 0, 0, 0, 0 },
/* U+a877 */ { 0, 0, 0, 0, 0 },
/* U+a878 */ { 0, 0, 0, 0, 0 },
/* U+a879 */ { 0, 0, 0, 0, 0 },
/* U+a87a */ { 0, 0, 0, 0, 0 },
/* U+a87b */ { 0, 0, 0, 0, 0 },
/* U+a87c */ { 0, 0, 0, 0, 0 },
/* U+a87d */ { 0, 0, 0, 0, 0 },
/* U+a87e */ { 0, 0, 0, 0, 0 },
/* U+a87f */ { 0, 0, 0, 0, 0 },
/* U+a880 */ { 0, 0, 0, 0, 0 },
/* U+a881 */ { 0, 0, 0, 0, 0 },
/* U+a882 */ { 0, 0, 0, 0, 0 },
/* U+a883 */ { 0, 0, 0, 0, 0 },
/* U+a884 */ { 0, 0, 0, 0, 0 },
/* U+a885 */ { 0, 0, 0, 0, 0 },
/* U+a886 */ { 0, 0, 0, 0, 0 },
/* U+a887 */ { 0, 0, 0, 0, 0 },
/* U+a888 */ { 0, 0, 0, 0, 0 },
/* U+a889 */ { 0, 0, 0, 0, 0 },
/* U+a88a */ { 0, 0, 0, 0, 0 },
/* U+a88b */ { 0, 0, 0, 0, 0 },
/* U+a88c */ { 0, 0, 0, 0, 0 },
/* U+a88d */ { 0, 0, 0, 0, 0 },
/* U+a88e */ { 0, 0, 0, 0, 0 },
/* U+a88f */ { 0, 0, 0, 0, 0 },
/* U+a890 */ { 0, 0, 0, 0, 0 },
/* U+a891 */ { 0, 0, 0, 0, 0 },
/* U+a892 */ { 0, 0, 0, 0, 0 },
/* U+a893 */ { 0, 0, 0, 0, 0 },
/* U+a894 */ { 0, 0, 0, 0, 0 },
/* U+a895 */ { 0, 0, 0, 0, 0 },
/* U+a896 */ { 0, 0, 0, 0, 0 },
/* U+a897 */ { 0, 0, 0, 0, 0 },
/* U+a898 */ { 0, 0, 0, 0, 0 },
/* U+a899 */ { 0, 0, 0, 0, 0 },
/* U+a89a */ { 0, 0, 0, 0, 0 },
/* U+a89b */ { 0, 0, 0, 0, 0 },
/* U+a89c */ { 0, 0, 0, 0, 0 },
/* U+a89d */ { 0, 0, 0, 0, 0 },
/* U+a89e */ { 0, 0, 0, 0, 0 },
/* U+a89f */ { 0, 0, 0, 0, 0 },
/* U+a8a0 */ { 0, 0, 0, 0, 0 },
/* U+a8a1 */ { 0, 0, 0, 0, 0 },
/* U+a8a2 */ { 0, 0, 0, 0, 0 },
/* U+a8a3 */ { 0, 0, 0, 0, 0 },
/* U+a8a4 */ { 0, 0, 0, 0, 0 },
/* U+a8a5 */ { 0, 0, 0, 0, 0 },
/* U+a8a6 */ { 0, 0, 0, 0, 0 },
/* U+a8a7 */ { 0, 0, 0, 0, 0 },
/* U+a8a8 */ { 0, 0, 0, 0, 0 },
/* U+a8a9 */ { 0, 0, 0, 0, 0 },
/* U+a8aa */ { 0, 0, 0, 0, 0 },
/* U+a8ab */ { 0, 0, 0, 0, 0 },
/* U+a8ac */ { 0, 0, 0, 0, 0 },
/* U+a8ad */ { 0, 0, 0, 0, 0 },
/* U+a8ae */ { 0, 0, 0, 0, 0 },
/* U+a8af */ { 0, 0, 0, 0, 0 },
/* U+a8b0 */ { 0, 0, 0, 0, 0 },
/* U+a8b1 */ { 0, 0, 0, 0, 0 },
/* U+a8b2 */ { 0, 0, 0, 0, 0 },
/* U+a8b3 */ { 0, 0, 0, 0, 0 },
/* U+a8b4 */ { 0, 0, 0, 0, 0 },
/* U+a8b5 */ { 0, 0, 0, 0, 0 },
/* U+a8b6 */ { 0, 0, 0, 0, 0 },
/* U+a8b7 */ { 0, 0, 0, 0, 0 },
/* U+a8b8 */ { 0, 0, 0, 0, 0 },
/* U+a8b9 */ { 0, 0, 0, 0, 0 },
/* U+a8ba */ { 0, 0, 0, 0, 0 },
/* U+a8bb */ { 0, 0, 0, 0, 0 },
/* U+a8bc */ { 0, 0, 0, 0, 0 },
/* U+a8bd */ { 0, 0, 0, 0, 0 },
/* U+a8be */ { 0, 0, 0, 0, 0 },
/* U+a8bf */ { 0, 0, 0, 0, 0 },
/* U+a8c0 */ { 0, 0, 0, 0, 0 },
/* U+a8c1 */ { 0, 0, 0, 0, 0 },
/* U+a8c2 */ { 0, 0, 0, 0, 0 },
/* U+a8c3 */ { 0, 0, 0, 0, 0 },
/* U+a8c4 */ { 0, 0, 0, 0, 0 },
/* U+a8c5 */ { 0, 0, 0, 0, 0 },
/* U+a8c6 */ { 0, 0, 0, 0, 0 },
/* U+a8c7 */ { 0, 0, 0, 0, 0 },
/* U+a8c8 */ { 0, 0, 0, 0, 0 },
/* U+a8c9 */ { 0, 0, 0, 0, 0 },
/* U+a8ca */ { 0, 0, 0, 0, 0 },
/* U+a8cb */ { 0, 0, 0, 0, 0 },
/* U+a8cc */ { 0, 0, 0, 0, 0 },
/* U+a8cd */ { 0, 0, 0, 0, 0 },
/* U+a8ce */ { 0, 0, 0, 0, 0 },
/* U+a8cf */ { 0, 0, 0, 0, 0 },
/* U+a8d0 */ { 0, 0, 0, 0, 0 },
/* U+a8d1 */ { 0, 0, 0, 0, 0 },
/* U+a8d2 */ { 0, 0, 0, 0, 0 },
/* U+a8d3 */ { 0, 0, 0, 0, 0 },
/* U+a8d4 */ { 0, 0, 0, 0, 0 },
/* U+a8d5 */ { 0, 0, 0, 0, 0 },
/* U+a8d6 */ { 0, 0, 0, 0, 0 },
/* U+a8d7 */ { 0, 0, 0, 0, 0 },
/* U+a8d8 */ { 0, 0, 0, 0, 0 },
/* U+a8d9 */ { 0, 0, 0, 0, 0 },
/* U+a8da */ { 0, 0, 0, 0, 0 },
/* U+a8db */ { 0, 0, 0, 0, 0 },
/* U+a8dc */ { 0, 0, 0, 0, 0 },
/* U+a8dd */ { 0, 0, 0, 0, 0 },
/* U+a8de */ { 0, 0, 0, 0, 0 },
/* U+a8df */ { 0, 0, 0, 0, 0 },
/* U+a8e0 */ { 0, 0, 0, 0, 0 },
/* U+a8e1 */ { 0, 0, 0, 0, 0 },
/* U+a8e2 */ { 0, 0, 0, 0, 0 },
/* U+a8e3 */ { 0, 0, 0, 0, 0 },
/* U+a8e4 */ { 0, 0, 0, 0, 0 },
/* U+a8e5 */ { 0, 0, 0, 0, 0 },
/* U+a8e6 */ { 0, 0, 0, 0, 0 },
/* U+a8e7 */ { 0, 0, 0, 0, 0 },
/* U+a8e8 */ { 0, 0, 0, 0, 0 },
/* U+a8e9 */ { 0, 0, 0, 0, 0 },
/* U+a8ea */ { 0, 0, 0, 0, 0 },
/* U+a8eb */ { 0, 0, 0, 0, 0 },
/* U+a8ec */ { 0, 0, 0, 0, 0 },
/* U+a8ed */ { 0, 0, 0, 0, 0 },
/* U+a8ee */ { 0, 0, 0, 0, 0 },
/* U+a8ef */ { 0, 0, 0, 0, 0 },
/* U+a8f0 */ { 0, 0, 0, 0, 0 },
/* U+a8f1 */ { 0, 0, 0, 0, 0 },
/* U+a8f2 */ { 0, 0, 0, 0, 0 },
/* U+a8f3 */ { 0, 0, 0, 0, 0 },
/* U+a8f4 */ { 0, 0, 0, 0, 0 },
/* U+a8f5 */ { 0, 0, 0, 0, 0 },
/* U+a8f6 */ { 0, 0, 0, 0, 0 },
/* U+a8f7 */ { 0, 0, 0, 0, 0 },
/* U+a8f8 */ { 0, 0, 0, 0, 0 },
/* U+a8f9 */ { 0, 0, 0, 0, 0 },
/* U+a8fa */ { 0, 0, 0, 0, 0 },
/* U+a8fb */ { 0, 0, 0, 0, 0 },
/* U+a8fc */ { 0, 0, 0, 0, 0 },
/* U+a8fd */ { 0, 0, 0, 0, 0 },
/* U+a8fe */ { 0, 0, 0, 0, 0 },
/* U+a8ff */ { 0, 0, 0, 0, 0 },
/* U+a900 */ { 0, 0, 0, 0, 0 },
/* U+a901 */ { 0, 0, 0, 0, 0 },
/* U+a902 */ { 0, 0, 0, 0, 0 },
/* U+a903 */ { 0, 0, 0, 0, 0 },
/* U+a904 */ { 0, 0, 0, 0, 0 },
/* U+a905 */ { 0, 0, 0, 0, 0 },
/* U+a906 */ { 0, 0, 0, 0, 0 },
/* U+a907 */ { 0, 0, 0, 0, 0 },
/* U+a908 */ { 0, 0, 0, 0, 0 },
/* U+a909 */ { 0, 0, 0, 0, 0 },
/* U+a90a */ { 0, 0, 0, 0, 0 },
/* U+a90b */ { 0, 0, 0, 0, 0 },
/* U+a90c */ { 0, 0, 0, 0, 0 },
/* U+a90d */ { 0, 0, 0, 0, 0 },
/* U+a90e */ { 0, 0, 0, 0, 0 },
/* U+a90f */ { 0, 0, 0, 0, 0 },
/* U+a910 */ { 0, 0, 0, 0, 0 },
/* U+a911 */ { 0, 0, 0, 0, 0 },
/* U+a912 */ { 0, 0, 0, 0, 0 },
/* U+a913 */ { 0, 0, 0, 0, 0 },
/* U+a914 */ { 0, 0, 0, 0, 0 },
/* U+a915 */ { 0, 0, 0, 0, 0 },
/* U+a916 */ { 0, 0, 0, 0, 0 },
/* U+a917 */ { 0, 0, 0, 0, 0 },
/* U+a918 */ { 0, 0, 0, 0, 0 },
/* U+a919 */ { 0, 0, 0, 0, 0 },
/* U+a91a */ { 0, 0, 0, 0, 0 },
/* U+a91b */ { 0, 0, 0, 0, 0 },
/* U+a91c */ { 0, 0, 0, 0, 0 },
/* U+a91d */ { 0, 0, 0, 0, 0 },
/* U+a91e */ { 0, 0, 0, 0, 0 },
/* U+a91f */ { 0, 0, 0, 0, 0 },
/* U+a920 */ { 0, 0, 0, 0, 0 },
/* U+a921 */ { 0, 0, 0, 0, 0 },
/* U+a922 */ { 0, 0, 0, 0, 0 },
/* U+a923 */ { 0, 0, 0, 0, 0 },
/* U+a924 */ { 0, 0, 0, 0, 0 },
/* U+a925 */ { 0, 0, 0, 0, 0 },
/* U+a926 */ { 0, 0, 0, 0, 0 },
/* U+a927 */ { 0, 0, 0, 0, 0 },
/* U+a928 */ { 0, 0, 0, 0, 0 },
/* U+a929 */ { 0, 0, 0, 0, 0 },
/* U+a92a */ { 0, 0, 0, 0, 0 },
/* U+a92b */ { 0, 0, 0, 0, 0 },
/* U+a92c */ { 0, 0, 0, 0, 0 },
/* U+a92d */ { 0, 0, 0, 0, 0 },
/* U+a92e */ { 0, 0, 0, 0, 0 },
/* U+a92f */ { 0, 0, 0, 0, 0 },
/* U+a930 */ { 0, 0, 0, 0, 0 },
/* U+a931 */ { 0, 0, 0, 0, 0 },
/* U+a932 */ { 0, 0, 0, 0, 0 },
/* U+a933 */ { 0, 0, 0, 0, 0 },
/* U+a934 */ { 0, 0, 0, 0, 0 },
/* U+a935 */ { 0, 0, 0, 0, 0 },
/* U+a936 */ { 0, 0, 0, 0, 0 },
/* U+a937 */ { 0, 0, 0, 0, 0 },
/* U+a938 */ { 0, 0, 0, 0, 0 },
/* U+a939 */ { 0, 0, 0, 0, 0 },
/* U+a93a */ { 0, 0, 0, 0, 0 },
/* U+a93b */ { 0, 0, 0, 0, 0 },
/* U+a93c */ { 0, 0, 0, 0, 0 },
/* U+a93d */ { 0, 0, 0, 0, 0 },
/* U+a93e */ { 0, 0, 0, 0, 0 },
/* U+a93f */ { 0, 0, 0, 0, 0 },
/* U+a940 */ { 0, 0, 0, 0, 0 },
/* U+a941 */ { 0, 0, 0, 0, 0 },
/* U+a942 */ { 0, 0, 0, 0, 0 },
/* U+a943 */ { 0, 0, 0, 0, 0 },
/* U+a944 */ { 0, 0, 0, 0, 0 },
/* U+a945 */ { 0, 0, 0, 0, 0 },
/* U+a946 */ { 0, 0, 0, 0, 0 },
/* U+a947 */ { 0, 0, 0, 0, 0 },
/* U+a948 */ { 0, 0, 0, 0, 0 },
/* U+a949 */ { 0, 0, 0, 0, 0 },
/* U+a94a */ { 0, 0, 0, 0, 0 },
/* U+a94b */ { 0, 0, 0, 0, 0 },
/* U+a94c */ { 0, 0, 0, 0, 0 },
/* U+a94d */ { 0, 0, 0, 0, 0 },
/* U+a94e */ { 0, 0, 0, 0, 0 },
/* U+a94f */ { 0, 0, 0, 0, 0 },
/* U+a950 */ { 0, 0, 0, 0, 0 },
/* U+a951 */ { 0, 0, 0, 0, 0 },
/* U+a952 */ { 0, 0, 0, 0, 0 },
/* U+a953 */ { 0, 0, 0, 0, 0 },
/* U+a954 */ { 0, 0, 0, 0, 0 },
/* U+a955 */ { 0, 0, 0, 0, 0 },
/* U+a956 */ { 0, 0, 0, 0, 0 },
/* U+a957 */ { 0, 0, 0, 0, 0 },
/* U+a958 */ { 0, 0, 0, 0, 0 },
/* U+a959 */ { 0, 0, 0, 0, 0 },
/* U+a95a */ { 0, 0, 0, 0, 0 },
/* U+a95b */ { 0, 0, 0, 0, 0 },
/* U+a95c */ { 0, 0, 0, 0, 0 },
/* U+a95d */ { 0, 0, 0, 0, 0 },
/* U+a95e */ { 0, 0, 0, 0, 0 },
/* U+a95f */ { 0, 0, 0, 0, 0 },
/* U+a960 */ { 0, 0, 0, 0, 0 },
/* U+a961 */ { 0, 0, 0, 0, 0 },
/* U+a962 */ { 0, 0, 0, 0, 0 },
/* U+a963 */ { 0, 0, 0, 0, 0 },
/* U+a964 */ { 0, 0, 0, 0, 0 },
/* U+a965 */ { 0, 0, 0, 0, 0 },
/* U+a966 */ { 0, 0, 0, 0, 0 },
/* U+a967 */ { 0, 0, 0, 0, 0 },
/* U+a968 */ { 0, 0, 0, 0, 0 },
/* U+a969 */ { 0, 0, 0, 0, 0 },
/* U+a96a */ { 0, 0, 0, 0, 0 },
/* U+a96b */ { 0, 0, 0, 0, 0 },
/* U+a96c */ { 0, 0, 0, 0, 0 },
/* U+a96d */ { 0, 0, 0, 0, 0 },
/* U+a96e */ { 0, 0, 0, 0, 0 },
/* U+a96f */ { 0, 0, 0, 0, 0 },
/* U+a970 */ { 0, 0, 0, 0, 0 },
/* U+a971 */ { 0, 0, 0, 0, 0 },
/* U+a972 */ { 0, 0, 0, 0, 0 },
/* U+a973 */ { 0, 0, 0, 0, 0 },
/* U+a974 */ { 0, 0, 0, 0, 0 },
/* U+a975 */ { 0, 0, 0, 0, 0 },
/* U+a976 */ { 0, 0, 0, 0, 0 },
/* U+a977 */ { 0, 0, 0, 0, 0 },
/* U+a978 */ { 0, 0, 0, 0, 0 },
/* U+a979 */ { 0, 0, 0, 0, 0 },
/* U+a97a */ { 0, 0, 0, 0, 0 },
/* U+a97b */ { 0, 0, 0, 0, 0 },
/* U+a97c */ { 0, 0, 0, 0, 0 },
/* U+a97d */ { 0, 0, 0, 0, 0 },
/* U+a97e */ { 0, 0, 0, 0, 0 },
/* U+a97f */ { 0, 0, 0, 0, 0 },
/* U+a980 */ { 0, 0, 0, 0, 0 },
/* U+a981 */ { 0, 0, 0, 0, 0 },
/* U+a982 */ { 0, 0, 0, 0, 0 },
/* U+a983 */ { 0, 0, 0, 0, 0 },
/* U+a984 */ { 0, 0, 0, 0, 0 },
/* U+a985 */ { 0, 0, 0, 0, 0 },
/* U+a986 */ { 0, 0, 0, 0, 0 },
/* U+a987 */ { 0, 0, 0, 0, 0 },
/* U+a988 */ { 0, 0, 0, 0, 0 },
/* U+a989 */ { 0, 0, 0, 0, 0 },
/* U+a98a */ { 0, 0, 0, 0, 0 },
/* U+a98b */ { 0, 0, 0, 0, 0 },
/* U+a98c */ { 0, 0, 0, 0, 0 },
/* U+a98d */ { 0, 0, 0, 0, 0 },
/* U+a98e */ { 0, 0, 0, 0, 0 },
/* U+a98f */ { 0, 0, 0, 0, 0 },
/* U+a990 */ { 0, 0, 0, 0, 0 },
/* U+a991 */ { 0, 0, 0, 0, 0 },
/* U+a992 */ { 0, 0, 0, 0, 0 },
/* U+a993 */ { 0, 0, 0, 0, 0 },
/* U+a994 */ { 0, 0, 0, 0, 0 },
/* U+a995 */ { 0, 0, 0, 0, 0 },
/* U+a996 */ { 0, 0, 0, 0, 0 },
/* U+a997 */ { 0, 0, 0, 0, 0 },
/* U+a998 */ { 0, 0, 0, 0, 0 },
/* U+a999 */ { 0, 0, 0, 0, 0 },
/* U+a99a */ { 0, 0, 0, 0, 0 },
/* U+a99b */ { 0, 0, 0, 0, 0 },
/* U+a99c */ { 0, 0, 0, 0, 0 },
/* U+a99d */ { 0, 0, 0, 0, 0 },
/* U+a99e */ { 0, 0, 0, 0, 0 },
/* U+a99f */ { 0, 0, 0, 0, 0 },
/* U+a9a0 */ { 0, 0, 0, 0, 0 },
/* U+a9a1 */ { 0, 0, 0, 0, 0 },
/* U+a9a2 */ { 0, 0, 0, 0, 0 },
/* U+a9a3 */ { 0, 0, 0, 0, 0 },
/* U+a9a4 */ { 0, 0, 0, 0, 0 },
/* U+a9a5 */ { 0, 0, 0, 0, 0 },
/* U+a9a6 */ { 0, 0, 0, 0, 0 },
/* U+a9a7 */ { 0, 0, 0, 0, 0 },
/* U+a9a8 */ { 0, 0, 0, 0, 0 },
/* U+a9a9 */ { 0, 0, 0, 0, 0 },
/* U+a9aa */ { 0, 0, 0, 0, 0 },
/* U+a9ab */ { 0, 0, 0, 0, 0 },
/* U+a9ac */ { 0, 0, 0, 0, 0 },
/* U+a9ad */ { 0, 0, 0, 0, 0 },
/* U+a9ae */ { 0, 0, 0, 0, 0 },
/* U+a9af */ { 0, 0, 0, 0, 0 },
/* U+a9b0 */ { 0, 0, 0, 0, 0 },
/* U+a9b1 */ { 0, 0, 0, 0, 0 },
/* U+a9b2 */ { 0, 0, 0, 0, 0 },
/* U+a9b3 */ { 0, 0, 0, 0, 0 },
/* U+a9b4 */ { 0, 0, 0, 0, 0 },
/* U+a9b5 */ { 0, 0, 0, 0, 0 },
/* U+a9b6 */ { 0, 0, 0, 0, 0 },
/* U+a9b7 */ { 0, 0, 0, 0, 0 },
/* U+a9b8 */ { 0, 0, 0, 0, 0 },
/* U+a9b9 */ { 0, 0, 0, 0, 0 },
/* U+a9ba */ { 0, 0, 0, 0, 0 },
/* U+a9bb */ { 0, 0, 0, 0, 0 },
/* U+a9bc */ { 0, 0, 0, 0, 0 },
/* U+a9bd */ { 0, 0, 0, 0, 0 },
/* U+a9be */ { 0, 0, 0, 0, 0 },
/* U+a9bf */ { 0, 0, 0, 0, 0 },
/* U+a9c0 */ { 0, 0, 0, 0, 0 },
/* U+a9c1 */ { 0, 0, 0, 0, 0 },
/* U+a9c2 */ { 0, 0, 0, 0, 0 },
/* U+a9c3 */ { 0, 0, 0, 0, 0 },
/* U+a9c4 */ { 0, 0, 0, 0, 0 },
/* U+a9c5 */ { 0, 0, 0, 0, 0 },
/* U+a9c6 */ { 0, 0, 0, 0, 0 },
/* U+a9c7 */ { 0, 0, 0, 0, 0 },
/* U+a9c8 */ { 0, 0, 0, 0, 0 },
/* U+a9c9 */ { 0, 0, 0, 0, 0 },
/* U+a9ca */ { 0, 0, 0, 0, 0 },
/* U+a9cb */ { 0, 0, 0, 0, 0 },
/* U+a9cc */ { 0, 0, 0, 0, 0 },
/* U+a9cd */ { 0, 0, 0, 0, 0 },
/* U+a9ce */ { 0, 0, 0, 0, 0 },
/* U+a9cf */ { 0, 0, 0, 0, 0 },
/* U+a9d0 */ { 0, 0, 0, 0, 0 },
/* U+a9d1 */ { 0, 0, 0, 0, 0 },
/* U+a9d2 */ { 0, 0, 0, 0, 0 },
/* U+a9d3 */ { 0, 0, 0, 0, 0 },
/* U+a9d4 */ { 0, 0, 0, 0, 0 },
/* U+a9d5 */ { 0, 0, 0, 0, 0 },
/* U+a9d6 */ { 0, 0, 0, 0, 0 },
/* U+a9d7 */ { 0, 0, 0, 0, 0 },
/* U+a9d8 */ { 0, 0, 0, 0, 0 },
/* U+a9d9 */ { 0, 0, 0, 0, 0 },
/* U+a9da */ { 0, 0, 0, 0, 0 },
/* U+a9db */ { 0, 0, 0, 0, 0 },
/* U+a9dc */ { 0, 0, 0, 0, 0 },
/* U+a9dd */ { 0, 0, 0, 0, 0 },
/* U+a9de */ { 0, 0, 0, 0, 0 },
/* U+a9df */ { 0, 0, 0, 0, 0 },
/* U+a9e0 */ { 0, 0, 0, 0, 0 },
/* U+a9e1 */ { 0, 0, 0, 0, 0 },
/* U+a9e2 */ { 0, 0, 0, 0, 0 },
/* U+a9e3 */ { 0, 0, 0, 0, 0 },
/* U+a9e4 */ { 0, 0, 0, 0, 0 },
/* U+a9e5 */ { 0, 0, 0, 0, 0 },
/* U+a9e6 */ { 0, 0, 0, 0, 0 },
/* U+a9e7 */ { 0, 0, 0, 0, 0 },
/* U+a9e8 */ { 0, 0, 0, 0, 0 },
/* U+a9e9 */ { 0, 0, 0, 0, 0 },
/* U+a9ea */ { 0, 0, 0, 0, 0 },
/* U+a9eb */ { 0, 0, 0, 0, 0 },
/* U+a9ec */ { 0, 0, 0, 0, 0 },
/* U+a9ed */ { 0, 0, 0, 0, 0 },
/* U+a9ee */ { 0, 0, 0, 0, 0 },
/* U+a9ef */ { 0, 0, 0, 0, 0 },
/* U+a9f0 */ { 0, 0, 0, 0, 0 },
/* U+a9f1 */ { 0, 0, 0, 0, 0 },
/* U+a9f2 */ { 0, 0, 0, 0, 0 },
/* U+a9f3 */ { 0, 0, 0, 0, 0 },
/* U+a9f4 */ { 0, 0, 0, 0, 0 },
/* U+a9f5 */ { 0, 0, 0, 0, 0 },
/* U+a9f6 */ { 0, 0, 0, 0, 0 },
/* U+a9f7 */ { 0, 0, 0, 0, 0 },
/* U+a9f8 */ { 0, 0, 0, 0, 0 },
/* U+a9f9 */ { 0, 0, 0, 0, 0 },
/* U+a9fa */ { 0, 0, 0, 0, 0 },
/* U+a9fb */ { 0, 0, 0, 0, 0 },
/* U+a9fc */ { 0, 0, 0, 0, 0 },
/* U+a9fd */ { 0, 0, 0, 0, 0 },
/* U+a9fe */ { 0, 0, 0, 0, 0 },
/* U+a9ff */ { 0, 0, 0, 0, 0 },
/* U+aa00 */ { 0, 0, 0, 0, 0 },
/* U+aa01 */ { 0, 0, 0, 0, 0 },
/* U+aa02 */ { 0, 0, 0, 0, 0 },
/* U+aa03 */ { 0, 0, 0, 0, 0 },
/* U+aa04 */ { 0, 0, 0, 0, 0 },
/* U+aa05 */ { 0, 0, 0, 0, 0 },
/* U+aa06 */ { 0, 0, 0, 0, 0 },
/* U+aa07 */ { 0, 0, 0, 0, 0 },
/* U+aa08 */ { 0, 0, 0, 0, 0 },
/* U+aa09 */ { 0, 0, 0, 0, 0 },
/* U+aa0a */ { 0, 0, 0, 0, 0 },
/* U+aa0b */ { 0, 0, 0, 0, 0 },
/* U+aa0c */ { 0, 0, 0, 0, 0 },
/* U+aa0d */ { 0, 0, 0, 0, 0 },
/* U+aa0e */ { 0, 0, 0, 0, 0 },
/* U+aa0f */ { 0, 0, 0, 0, 0 },
/* U+aa10 */ { 0, 0, 0, 0, 0 },
/* U+aa11 */ { 0, 0, 0, 0, 0 },
/* U+aa12 */ { 0, 0, 0, 0, 0 },
/* U+aa13 */ { 0, 0, 0, 0, 0 },
/* U+aa14 */ { 0, 0, 0, 0, 0 },
/* U+aa15 */ { 0, 0, 0, 0, 0 },
/* U+aa16 */ { 0, 0, 0, 0, 0 },
/* U+aa17 */ { 0, 0, 0, 0, 0 },
/* U+aa18 */ { 0, 0, 0, 0, 0 },
/* U+aa19 */ { 0, 0, 0, 0, 0 },
/* U+aa1a */ { 0, 0, 0, 0, 0 },
/* U+aa1b */ { 0, 0, 0, 0, 0 },
/* U+aa1c */ { 0, 0, 0, 0, 0 },
/* U+aa1d */ { 0, 0, 0, 0, 0 },
/* U+aa1e */ { 0, 0, 0, 0, 0 },
/* U+aa1f */ { 0, 0, 0, 0, 0 },
/* U+aa20 */ { 0, 0, 0, 0, 0 },
/* U+aa21 */ { 0, 0, 0, 0, 0 },
/* U+aa22 */ { 0, 0, 0, 0, 0 },
/* U+aa23 */ { 0, 0, 0, 0, 0 },
/* U+aa24 */ { 0, 0, 0, 0, 0 },
/* U+aa25 */ { 0, 0, 0, 0, 0 },
/* U+aa26 */ { 0, 0, 0, 0, 0 },
/* U+aa27 */ { 0, 0, 0, 0, 0 },
/* U+aa28 */ { 0, 0, 0, 0, 0 },
/* U+aa29 */ { 0, 0, 0, 0, 0 },
/* U+aa2a */ { 0, 0, 0, 0, 0 },
/* U+aa2b */ { 0, 0, 0, 0, 0 },
/* U+aa2c */ { 0, 0, 0, 0, 0 },
/* U+aa2d */ { 0, 0, 0, 0, 0 },
/* U+aa2e */ { 0, 0, 0, 0, 0 },
/* U+aa2f */ { 0, 0, 0, 0, 0 },
/* U+aa30 */ { 0, 0, 0, 0, 0 },
/* U+aa31 */ { 0, 0, 0, 0, 0 },
/* U+aa32 */ { 0, 0, 0, 0, 0 },
/* U+aa33 */ { 0, 0, 0, 0, 0 },
/* U+aa34 */ { 0, 0, 0, 0, 0 },
/* U+aa35 */ { 0, 0, 0, 0, 0 },
/* U+aa36 */ { 0, 0, 0, 0, 0 },
/* U+aa37 */ { 0, 0, 0, 0, 0 },
/* U+aa38 */ { 0, 0, 0, 0, 0 },
/* U+aa39 */ { 0, 0, 0, 0, 0 },
/* U+aa3a */ { 0, 0, 0, 0, 0 },
/* U+aa3b */ { 0, 0, 0, 0, 0 },
/* U+aa3c */ { 0, 0, 0, 0, 0 },
/* U+aa3d */ { 0, 0, 0, 0, 0 },
/* U+aa3e */ { 0, 0, 0, 0, 0 },
/* U+aa3f */ { 0, 0, 0, 0, 0 },
/* U+aa40 */ { 0, 0, 0, 0, 0 },
/* U+aa41 */ { 0, 0, 0, 0, 0 },
/* U+aa42 */ { 0, 0, 0, 0, 0 },
/* U+aa43 */ { 0, 0, 0, 0, 0 },
/* U+aa44 */ { 0, 0, 0, 0, 0 },
/* U+aa45 */ { 0, 0, 0, 0, 0 },
/* U+aa46 */ { 0, 0, 0, 0, 0 },
/* U+aa47 */ { 0, 0, 0, 0, 0 },
/* U+aa48 */ { 0, 0, 0, 0, 0 },
/* U+aa49 */ { 0, 0, 0, 0, 0 },
/* U+aa4a */ { 0, 0, 0, 0, 0 },
/* U+aa4b */ { 0, 0, 0, 0, 0 },
/* U+aa4c */ { 0, 0, 0, 0, 0 },
/* U+aa4d */ { 0, 0, 0, 0, 0 },
/* U+aa4e */ { 0, 0, 0, 0, 0 },
/* U+aa4f */ { 0, 0, 0, 0, 0 },
/* U+aa50 */ { 0, 0, 0, 0, 0 },
/* U+aa51 */ { 0, 0, 0, 0, 0 },
/* U+aa52 */ { 0, 0, 0, 0, 0 },
/* U+aa53 */ { 0, 0, 0, 0, 0 },
/* U+aa54 */ { 0, 0, 0, 0, 0 },
/* U+aa55 */ { 0, 0, 0, 0, 0 },
/* U+aa56 */ { 0, 0, 0, 0, 0 },
/* U+aa57 */ { 0, 0, 0, 0, 0 },
/* U+aa58 */ { 0, 0, 0, 0, 0 },
/* U+aa59 */ { 0, 0, 0, 0, 0 },
/* U+aa5a */ { 0, 0, 0, 0, 0 },
/* U+aa5b */ { 0, 0, 0, 0, 0 },
/* U+aa5c */ { 0, 0, 0, 0, 0 },
/* U+aa5d */ { 0, 0, 0, 0, 0 },
/* U+aa5e */ { 0, 0, 0, 0, 0 },
/* U+aa5f */ { 0, 0, 0, 0, 0 },
/* U+aa60 */ { 0, 0, 0, 0, 0 },
/* U+aa61 */ { 0, 0, 0, 0, 0 },
/* U+aa62 */ { 0, 0, 0, 0, 0 },
/* U+aa63 */ { 0, 0, 0, 0, 0 },
/* U+aa64 */ { 0, 0, 0, 0, 0 },
/* U+aa65 */ { 0, 0, 0, 0, 0 },
/* U+aa66 */ { 0, 0, 0, 0, 0 },
/* U+aa67 */ { 0, 0, 0, 0, 0 },
/* U+aa68 */ { 0, 0, 0, 0, 0 },
/* U+aa69 */ { 0, 0, 0, 0, 0 },
/* U+aa6a */ { 0, 0, 0, 0, 0 },
/* U+aa6b */ { 0, 0, 0, 0, 0 },
/* U+aa6c */ { 0, 0, 0, 0, 0 },
/* U+aa6d */ { 0, 0, 0, 0, 0 },
/* U+aa6e */ { 0, 0, 0, 0, 0 },
/* U+aa6f */ { 0, 0, 0, 0, 0 },
/* U+aa70 */ { 0, 0, 0, 0, 0 },
/* U+aa71 */ { 0, 0, 0, 0, 0 },
/* U+aa72 */ { 0, 0, 0, 0, 0 },
/* U+aa73 */ { 0, 0, 0, 0, 0 },
/* U+aa74 */ { 0, 0, 0, 0, 0 },
/* U+aa75 */ { 0, 0, 0, 0, 0 },
/* U+aa76 */ { 0, 0, 0, 0, 0 },
/* U+aa77 */ { 0, 0, 0, 0, 0 },
/* U+aa78 */ { 0, 0, 0, 0, 0 },
/* U+aa79 */ { 0, 0, 0, 0, 0 },
/* U+aa7a */ { 0, 0, 0, 0, 0 },
/* U+aa7b */ { 0, 0, 0, 0, 0 },
/* U+aa7c */ { 0, 0, 0, 0, 0 },
/* U+aa7d */ { 0, 0, 0, 0, 0 },
/* U+aa7e */ { 0, 0, 0, 0, 0 },
/* U+aa7f */ { 0, 0, 0, 0, 0 },
/* U+aa80 */ { 0, 0, 0, 0, 0 },
/* U+aa81 */ { 0, 0, 0, 0, 0 },
/* U+aa82 */ { 0, 0, 0, 0, 0 },
/* U+aa83 */ { 0, 0, 0, 0, 0 },
/* U+aa84 */ { 0, 0, 0, 0, 0 },
/* U+aa85 */ { 0, 0, 0, 0, 0 },
/* U+aa86 */ { 0, 0, 0, 0, 0 },
/* U+aa87 */ { 0, 0, 0, 0, 0 },
/* U+aa88 */ { 0, 0, 0, 0, 0 },
/* U+aa89 */ { 0, 0, 0, 0, 0 },
/* U+aa8a */ { 0, 0, 0, 0, 0 },
/* U+aa8b */ { 0, 0, 0, 0, 0 },
/* U+aa8c */ { 0, 0, 0, 0, 0 },
/* U+aa8d */ { 0, 0, 0, 0, 0 },
/* U+aa8e */ { 0, 0, 0, 0, 0 },
/* U+aa8f */ { 0, 0, 0, 0, 0 },
/* U+aa90 */ { 0, 0, 0, 0, 0 },
/* U+aa91 */ { 0, 0, 0, 0, 0 },
/* U+aa92 */ { 0, 0, 0, 0, 0 },
/* U+aa93 */ { 0, 0, 0, 0, 0 },
/* U+aa94 */ { 0, 0, 0, 0, 0 },
/* U+aa95 */ { 0, 0, 0, 0, 0 },
/* U+aa96 */ { 0, 0, 0, 0, 0 },
/* U+aa97 */ { 0, 0, 0, 0, 0 },
/* U+aa98 */ { 0, 0, 0, 0, 0 },
/* U+aa99 */ { 0, 0, 0, 0, 0 },
/* U+aa9a */ { 0, 0, 0, 0, 0 },
/* U+aa9b */ { 0, 0, 0, 0, 0 },
/* U+aa9c */ { 0, 0, 0, 0, 0 },
/* U+aa9d */ { 0, 0, 0, 0, 0 },
/* U+aa9e */ { 0, 0, 0, 0, 0 },
/* U+aa9f */ { 0, 0, 0, 0, 0 },
/* U+aaa0 */ { 0, 0, 0, 0, 0 },
/* U+aaa1 */ { 0, 0, 0, 0, 0 },
/* U+aaa2 */ { 0, 0, 0, 0, 0 },
/* U+aaa3 */ { 0, 0, 0, 0, 0 },
/* U+aaa4 */ { 0, 0, 0, 0, 0 },
/* U+aaa5 */ { 0, 0, 0, 0, 0 },
/* U+aaa6 */ { 0, 0, 0, 0, 0 },
/* U+aaa7 */ { 0, 0, 0, 0, 0 },
/* U+aaa8 */ { 0, 0, 0, 0, 0 },
/* U+aaa9 */ { 0, 0, 0, 0, 0 },
/* U+aaaa */ { 0, 0, 0, 0, 0 },
/* U+aaab */ { 0, 0, 0, 0, 0 },
/* U+aaac */ { 0, 0, 0, 0, 0 },
/* U+aaad */ { 0, 0, 0, 0, 0 },
/* U+aaae */ { 0, 0, 0, 0, 0 },
/* U+aaaf */ { 0, 0, 0, 0, 0 },
/* U+aab0 */ { 0, 0, 0, 0, 0 },
/* U+aab1 */ { 0, 0, 0, 0, 0 },
/* U+aab2 */ { 0, 0, 0, 0, 0 },
/* U+aab3 */ { 0, 0, 0, 0, 0 },
/* U+aab4 */ { 0, 0, 0, 0, 0 },
/* U+aab5 */ { 0, 0, 0, 0, 0 },
/* U+aab6 */ { 0, 0, 0, 0, 0 },
/* U+aab7 */ { 0, 0, 0, 0, 0 },
/* U+aab8 */ { 0, 0, 0, 0, 0 },
/* U+aab9 */ { 0, 0, 0, 0, 0 },
/* U+aaba */ { 0, 0, 0, 0, 0 },
/* U+aabb */ { 0, 0, 0, 0, 0 },
/* U+aabc */ { 0, 0, 0, 0, 0 },
/* U+aabd */ { 0, 0, 0, 0, 0 },
/* U+aabe */ { 0, 0, 0, 0, 0 },
/* U+aabf */ { 0, 0, 0, 0, 0 },
/* U+aac0 */ { 0, 0, 0, 0, 0 },
/* U+aac1 */ { 0, 0, 0, 0, 0 },
/* U+aac2 */ { 0, 0, 0, 0, 0 },
/* U+aac3 */ { 0, 0, 0, 0, 0 },
/* U+aac4 */ { 0, 0, 0, 0, 0 },
/* U+aac5 */ { 0, 0, 0, 0, 0 },
/* U+aac6 */ { 0, 0, 0, 0, 0 },
/* U+aac7 */ { 0, 0, 0, 0, 0 },
/* U+aac8 */ { 0, 0, 0, 0, 0 },
/* U+aac9 */ { 0, 0, 0, 0, 0 },
/* U+aaca */ { 0, 0, 0, 0, 0 },
/* U+aacb */ { 0, 0, 0, 0, 0 },
/* U+aacc */ { 0, 0, 0, 0, 0 },
/* U+aacd */ { 0, 0, 0, 0, 0 },
/* U+aace */ { 0, 0, 0, 0, 0 },
/* U+aacf */ { 0, 0, 0, 0, 0 },
/* U+aad0 */ { 0, 0, 0, 0, 0 },
/* U+aad1 */ { 0, 0, 0, 0, 0 },
/* U+aad2 */ { 0, 0, 0, 0, 0 },
/* U+aad3 */ { 0, 0, 0, 0, 0 },
/* U+aad4 */ { 0, 0, 0, 0, 0 },
/* U+aad5 */ { 0, 0, 0, 0, 0 },
/* U+aad6 */ { 0, 0, 0, 0, 0 },
/* U+aad7 */ { 0, 0, 0, 0, 0 },
/* U+aad8 */ { 0, 0, 0, 0, 0 },
/* U+aad9 */ { 0, 0, 0, 0, 0 },
/* U+aada */ { 0, 0, 0, 0, 0 },
/* U+aadb */ { 0, 0, 0, 0, 0 },
/* U+aadc */ { 0, 0, 0, 0, 0 },
/* U+aadd */ { 0, 0, 0, 0, 0 },
/* U+aade */ { 0, 0, 0, 0, 0 },
/* U+aadf */ { 0, 0, 0, 0, 0 },
/* U+aae0 */ { 0, 0, 0, 0, 0 },
/* U+aae1 */ { 0, 0, 0, 0, 0 },
/* U+aae2 */ { 0, 0, 0, 0, 0 },
/* U+aae3 */ { 0, 0, 0, 0, 0 },
/* U+aae4 */ { 0, 0, 0, 0, 0 },
/* U+aae5 */ { 0, 0, 0, 0, 0 },
/* U+aae6 */ { 0, 0, 0, 0, 0 },
/* U+aae7 */ { 0, 0, 0, 0, 0 },
/* U+aae8 */ { 0, 0, 0, 0, 0 },
/* U+aae9 */ { 0, 0, 0, 0, 0 },
/* U+aaea */ { 0, 0, 0, 0, 0 },
/* U+aaeb */ { 0, 0, 0, 0, 0 },
/* U+aaec */ { 0, 0, 0, 0, 0 },
/* U+aaed */ { 0, 0, 0, 0, 0 },
/* U+aaee */ { 0, 0, 0, 0, 0 },
/* U+aaef */ { 0, 0, 0, 0, 0 },
/* U+aaf0 */ { 0, 0, 0, 0, 0 },
/* U+aaf1 */ { 0, 0, 0, 0, 0 },
/* U+aaf2 */ { 0, 0, 0, 0, 0 },
/* U+aaf3 */ { 0, 0, 0, 0, 0 },
/* U+aaf4 */ { 0, 0, 0, 0, 0 },
/* U+aaf5 */ { 0, 0, 0, 0, 0 },
/* U+aaf6 */ { 0, 0, 0, 0, 0 },
/* U+aaf7 */ { 0, 0, 0, 0, 0 },
/* U+aaf8 */ { 0, 0, 0, 0, 0 },
/* U+aaf9 */ { 0, 0, 0, 0, 0 },
/* U+aafa */ { 0, 0, 0, 0, 0 },
/* U+aafb */ { 0, 0, 0, 0, 0 },
/* U+aafc */ { 0, 0, 0, 0, 0 },
/* U+aafd */ { 0, 0, 0, 0, 0 },
/* U+aafe */ { 0, 0, 0, 0, 0 },
/* U+aaff */ { 0, 0, 0, 0, 0 },
/* U+ab00 */ { 0, 0, 0, 0, 0 },
/* U+ab01 */ { 0, 0, 0, 0, 0 },
/* U+ab02 */ { 0, 0, 0, 0, 0 },
/* U+ab03 */ { 0, 0, 0, 0, 0 },
/* U+ab04 */ { 0, 0, 0, 0, 0 },
/* U+ab05 */ { 0, 0, 0, 0, 0 },
/* U+ab06 */ { 0, 0, 0, 0, 0 },
/* U+ab07 */ { 0, 0, 0, 0, 0 },
/* U+ab08 */ { 0, 0, 0, 0, 0 },
/* U+ab09 */ { 0, 0, 0, 0, 0 },
/* U+ab0a */ { 0, 0, 0, 0, 0 },
/* U+ab0b */ { 0, 0, 0, 0, 0 },
/* U+ab0c */ { 0, 0, 0, 0, 0 },
/* U+ab0d */ { 0, 0, 0, 0, 0 },
/* U+ab0e */ { 0, 0, 0, 0, 0 },
/* U+ab0f */ { 0, 0, 0, 0, 0 },
/* U+ab10 */ { 0, 0, 0, 0, 0 },
/* U+ab11 */ { 0, 0, 0, 0, 0 },
/* U+ab12 */ { 0, 0, 0, 0, 0 },
/* U+ab13 */ { 0, 0, 0, 0, 0 },
/* U+ab14 */ { 0, 0, 0, 0, 0 },
/* U+ab15 */ { 0, 0, 0, 0, 0 },
/* U+ab16 */ { 0, 0, 0, 0, 0 },
/* U+ab17 */ { 0, 0, 0, 0, 0 },
/* U+ab18 */ { 0, 0, 0, 0, 0 },
/* U+ab19 */ { 0, 0, 0, 0, 0 },
/* U+ab1a */ { 0, 0, 0, 0, 0 },
/* U+ab1b */ { 0, 0, 0, 0, 0 },
/* U+ab1c */ { 0, 0, 0, 0, 0 },
/* U+ab1d */ { 0, 0, 0, 0, 0 },
/* U+ab1e */ { 0, 0, 0, 0, 0 },
/* U+ab1f */ { 0, 0, 0, 0, 0 },
/* U+ab20 */ { 0, 0, 0, 0, 0 },
/* U+ab21 */ { 0, 0, 0, 0, 0 },
/* U+ab22 */ { 0, 0, 0, 0, 0 },
/* U+ab23 */ { 0, 0, 0, 0, 0 },
/* U+ab24 */ { 0, 0, 0, 0, 0 },
/* U+ab25 */ { 0, 0, 0, 0, 0 },
/* U+ab26 */ { 0, 0, 0, 0, 0 },
/* U+ab27 */ { 0, 0, 0, 0, 0 },
/* U+ab28 */ { 0, 0, 0, 0, 0 },
/* U+ab29 */ { 0, 0, 0, 0, 0 },
/* U+ab2a */ { 0, 0, 0, 0, 0 },
/* U+ab2b */ { 0, 0, 0, 0, 0 },
/* U+ab2c */ { 0, 0, 0, 0, 0 },
/* U+ab2d */ { 0, 0, 0, 0, 0 },
/* U+ab2e */ { 0, 0, 0, 0, 0 },
/* U+ab2f */ { 0, 0, 0, 0, 0 },
/* U+ab30 */ { 0, 0, 0, 0, 0 },
/* U+ab31 */ { 0, 0, 0, 0, 0 },
/* U+ab32 */ { 0, 0, 0, 0, 0 },
/* U+ab33 */ { 0, 0, 0, 0, 0 },
/* U+ab34 */ { 0, 0, 0, 0, 0 },
/* U+ab35 */ { 0, 0, 0, 0, 0 },
/* U+ab36 */ { 0, 0, 0, 0, 0 },
/* U+ab37 */ { 0, 0, 0, 0, 0 },
/* U+ab38 */ { 0, 0, 0, 0, 0 },
/* U+ab39 */ { 0, 0, 0, 0, 0 },
/* U+ab3a */ { 0, 0, 0, 0, 0 },
/* U+ab3b */ { 0, 0, 0, 0, 0 },
/* U+ab3c */ { 0, 0, 0, 0, 0 },
/* U+ab3d */ { 0, 0, 0, 0, 0 },
/* U+ab3e */ { 0, 0, 0, 0, 0 },
/* U+ab3f */ { 0, 0, 0, 0, 0 },
/* U+ab40 */ { 0, 0, 0, 0, 0 },
/* U+ab41 */ { 0, 0, 0, 0, 0 },
/* U+ab42 */ { 0, 0, 0, 0, 0 },
/* U+ab43 */ { 0, 0, 0, 0, 0 },
/* U+ab44 */ { 0, 0, 0, 0, 0 },
/* U+ab45 */ { 0, 0, 0, 0, 0 },
/* U+ab46 */ { 0, 0, 0, 0, 0 },
/* U+ab47 */ { 0, 0, 0, 0, 0 },
/* U+ab48 */ { 0, 0, 0, 0, 0 },
/* U+ab49 */ { 0, 0, 0, 0, 0 },
/* U+ab4a */ { 0, 0, 0, 0, 0 },
/* U+ab4b */ { 0, 0, 0, 0, 0 },
/* U+ab4c */ { 0, 0, 0, 0, 0 },
/* U+ab4d */ { 0, 0, 0, 0, 0 },
/* U+ab4e */ { 0, 0, 0, 0, 0 },
/* U+ab4f */ { 0, 0, 0, 0, 0 },
/* U+ab50 */ { 0, 0, 0, 0, 0 },
/* U+ab51 */ { 0, 0, 0, 0, 0 },
/* U+ab52 */ { 0, 0, 0, 0, 0 },
/* U+ab53 */ { 0, 0, 0, 0, 0 },
/* U+ab54 */ { 0, 0, 0, 0, 0 },
/* U+ab55 */ { 0, 0, 0, 0, 0 },
/* U+ab56 */ { 0, 0, 0, 0, 0 },
/* U+ab57 */ { 0, 0, 0, 0, 0 },
/* U+ab58 */ { 0, 0, 0, 0, 0 },
/* U+ab59 */ { 0, 0, 0, 0, 0 },
/* U+ab5a */ { 0, 0, 0, 0, 0 },
/* U+ab5b */ { 0, 0, 0, 0, 0 },
/* U+ab5c */ { 0, 0, 0, 0, 0 },
/* U+ab5d */ { 0, 0, 0, 0, 0 },
/* U+ab5e */ { 0, 0, 0, 0, 0 },
/* U+ab5f */ { 0, 0, 0, 0, 0 },
/* U+ab60 */ { 0, 0, 0, 0, 0 },
/* U+ab61 */ { 0, 0, 0, 0, 0 },
/* U+ab62 */ { 0, 0, 0, 0, 0 },
/* U+ab63 */ { 0, 0, 0, 0, 0 },
/* U+ab64 */ { 0, 0, 0, 0, 0 },
/* U+ab65 */ { 0, 0, 0, 0, 0 },
/* U+ab66 */ { 0, 0, 0, 0, 0 },
/* U+ab67 */ { 0, 0, 0, 0, 0 },
/* U+ab68 */ { 0, 0, 0, 0, 0 },
/* U+ab69 */ { 0, 0, 0, 0, 0 },
/* U+ab6a */ { 0, 0, 0, 0, 0 },
/* U+ab6b */ { 0, 0, 0, 0, 0 },
/* U+ab6c */ { 0, 0, 0, 0, 0 },
/* U+ab6d */ { 0, 0, 0, 0, 0 },
/* U+ab6e */ { 0, 0, 0, 0, 0 },
/* U+ab6f */ { 0, 0, 0, 0, 0 },
/* U+ab70 */ { 0, 0, 0, 0, 0 },
/* U+ab71 */ { 0, 0, 0, 0, 0 },
/* U+ab72 */ { 0, 0, 0, 0, 0 },
/* U+ab73 */ { 0, 0, 0, 0, 0 },
/* U+ab74 */ { 0, 0, 0, 0, 0 },
/* U+ab75 */ { 0, 0, 0, 0, 0 },
/* U+ab76 */ { 0, 0, 0, 0, 0 },
/* U+ab77 */ { 0, 0, 0, 0, 0 },
/* U+ab78 */ { 0, 0, 0, 0, 0 },
/* U+ab79 */ { 0, 0, 0, 0, 0 },
/* U+ab7a */ { 0, 0, 0, 0, 0 },
/* U+ab7b */ { 0, 0, 0, 0, 0 },
/* U+ab7c */ { 0, 0, 0, 0, 0 },
/* U+ab7d */ { 0, 0, 0, 0, 0 },
/* U+ab7e */ { 0, 0, 0, 0, 0 },
/* U+ab7f */ { 0, 0, 0, 0, 0 },
/* U+ab80 */ { 0, 0, 0, 0, 0 },
/* U+ab81 */ { 0, 0, 0, 0, 0 },
/* U+ab82 */ { 0, 0, 0, 0, 0 },
/* U+ab83 */ { 0, 0, 0, 0, 0 },
/* U+ab84 */ { 0, 0, 0, 0, 0 },
/* U+ab85 */ { 0, 0, 0, 0, 0 },
/* U+ab86 */ { 0, 0, 0, 0, 0 },
/* U+ab87 */ { 0, 0, 0, 0, 0 },
/* U+ab88 */ { 0, 0, 0, 0, 0 },
/* U+ab89 */ { 0, 0, 0, 0, 0 },
/* U+ab8a */ { 0, 0, 0, 0, 0 },
/* U+ab8b */ { 0, 0, 0, 0, 0 },
/* U+ab8c */ { 0, 0, 0, 0, 0 },
/* U+ab8d */ { 0, 0, 0, 0, 0 },
/* U+ab8e */ { 0, 0, 0, 0, 0 },
/* U+ab8f */ { 0, 0, 0, 0, 0 },
/* U+ab90 */ { 0, 0, 0, 0, 0 },
/* U+ab91 */ { 0, 0, 0, 0, 0 },
/* U+ab92 */ { 0, 0, 0, 0, 0 },
/* U+ab93 */ { 0, 0, 0, 0, 0 },
/* U+ab94 */ { 0, 0, 0, 0, 0 },
/* U+ab95 */ { 0, 0, 0, 0, 0 },
/* U+ab96 */ { 0, 0, 0, 0, 0 },
/* U+ab97 */ { 0, 0, 0, 0, 0 },
/* U+ab98 */ { 0, 0, 0, 0, 0 },
/* U+ab99 */ { 0, 0, 0, 0, 0 },
/* U+ab9a */ { 0, 0, 0, 0, 0 },
/* U+ab9b */ { 0, 0, 0, 0, 0 },
/* U+ab9c */ { 0, 0, 0, 0, 0 },
/* U+ab9d */ { 0, 0, 0, 0, 0 },
/* U+ab9e */ { 0, 0, 0, 0, 0 },
/* U+ab9f */ { 0, 0, 0, 0, 0 },
/* U+aba0 */ { 0, 0, 0, 0, 0 },
/* U+aba1 */ { 0, 0, 0, 0, 0 },
/* U+aba2 */ { 0, 0, 0, 0, 0 },
/* U+aba3 */ { 0, 0, 0, 0, 0 },
/* U+aba4 */ { 0, 0, 0, 0, 0 },
/* U+aba5 */ { 0, 0, 0, 0, 0 },
/* U+aba6 */ { 0, 0, 0, 0, 0 },
/* U+aba7 */ { 0, 0, 0, 0, 0 },
/* U+aba8 */ { 0, 0, 0, 0, 0 },
/* U+aba9 */ { 0, 0, 0, 0, 0 },
/* U+abaa */ { 0, 0, 0, 0, 0 },
/* U+abab */ { 0, 0, 0, 0, 0 },
/* U+abac */ { 0, 0, 0, 0, 0 },
/* U+abad */ { 0, 0, 0, 0, 0 },
/* U+abae */ { 0, 0, 0, 0, 0 },
/* U+abaf */ { 0, 0, 0, 0, 0 },
/* U+abb0 */ { 0, 0, 0, 0, 0 },
/* U+abb1 */ { 0, 0, 0, 0, 0 },
/* U+abb2 */ { 0, 0, 0, 0, 0 },
/* U+abb3 */ { 0, 0, 0, 0, 0 },
/* U+abb4 */ { 0, 0, 0, 0, 0 },
/* U+abb5 */ { 0, 0, 0, 0, 0 },
/* U+abb6 */ { 0, 0, 0, 0, 0 },
/* U+abb7 */ { 0, 0, 0, 0, 0 },
/* U+abb8 */ { 0, 0, 0, 0, 0 },
/* U+abb9 */ { 0, 0, 0, 0, 0 },
/* U+abba */ { 0, 0, 0, 0, 0 },
/* U+abbb */ { 0, 0, 0, 0, 0 },
/* U+abbc */ { 0, 0, 0, 0, 0 },
/* U+abbd */ { 0, 0, 0, 0, 0 },
/* U+abbe */ { 0, 0, 0, 0, 0 },
/* U+abbf */ { 0, 0, 0, 0, 0 },
/* U+abc0 */ { 0, 0, 0, 0, 0 },
/* U+abc1 */ { 0, 0, 0, 0, 0 },
/* U+abc2 */ { 0, 0, 0, 0, 0 },
/* U+abc3 */ { 0, 0, 0, 0, 0 },
/* U+abc4 */ { 0, 0, 0, 0, 0 },
/* U+abc5 */ { 0, 0, 0, 0, 0 },
/* U+abc6 */ { 0, 0, 0, 0, 0 },
/* U+abc7 */ { 0, 0, 0, 0, 0 },
/* U+abc8 */ { 0, 0, 0, 0, 0 },
/* U+abc9 */ { 0, 0, 0, 0, 0 },
/* U+abca */ { 0, 0, 0, 0, 0 },
/* U+abcb */ { 0, 0, 0, 0, 0 },
/* U+abcc */ { 0, 0, 0, 0, 0 },
/* U+abcd */ { 0, 0, 0, 0, 0 },
/* U+abce */ { 0, 0, 0, 0, 0 },
/* U+abcf */ { 0, 0, 0, 0, 0 },
/* U+abd0 */ { 0, 0, 0, 0, 0 },
/* U+abd1 */ { 0, 0, 0, 0, 0 },
/* U+abd2 */ { 0, 0, 0, 0, 0 },
/* U+abd3 */ { 0, 0, 0, 0, 0 },
/* U+abd4 */ { 0, 0, 0, 0, 0 },
/* U+abd5 */ { 0, 0, 0, 0, 0 },
/* U+abd6 */ { 0, 0, 0, 0, 0 },
/* U+abd7 */ { 0, 0, 0, 0, 0 },
/* U+abd8 */ { 0, 0, 0, 0, 0 },
/* U+abd9 */ { 0, 0, 0, 0, 0 },
/* U+abda */ { 0, 0, 0, 0, 0 },
/* U+abdb */ { 0, 0, 0, 0, 0 },
/* U+abdc */ { 0, 0, 0, 0, 0 },
/* U+abdd */ { 0, 0, 0, 0, 0 },
/* U+abde */ { 0, 0, 0, 0, 0 },
/* U+abdf */ { 0, 0, 0, 0, 0 },
/* U+abe0 */ { 0, 0, 0, 0, 0 },
/* U+abe1 */ { 0, 0, 0, 0, 0 },
/* U+abe2 */ { 0, 0, 0, 0, 0 },
/* U+abe3 */ { 0, 0, 0, 0, 0 },
/* U+abe4 */ { 0, 0, 0, 0, 0 },
/* U+abe5 */ { 0, 0, 0, 0, 0 },
/* U+abe6 */ { 0, 0, 0, 0, 0 },
/* U+abe7 */ { 0, 0, 0, 0, 0 },
/* U+abe8 */ { 0, 0, 0, 0, 0 },
/* U+abe9 */ { 0, 0, 0, 0, 0 },
/* U+abea */ { 0, 0, 0, 0, 0 },
/* U+abeb */ { 0, 0, 0, 0, 0 },
/* U+abec */ { 0, 0, 0, 0, 0 },
/* U+abed */ { 0, 0, 0, 0, 0 },
/* U+abee */ { 0, 0, 0, 0, 0 },
/* U+abef */ { 0, 0, 0, 0, 0 },
/* U+abf0 */ { 0, 0, 0, 0, 0 },
/* U+abf1 */ { 0, 0, 0, 0, 0 },
/* U+abf2 */ { 0, 0, 0, 0, 0 },
/* U+abf3 */ { 0, 0, 0, 0, 0 },
/* U+abf4 */ { 0, 0, 0, 0, 0 },
/* U+abf5 */ { 0, 0, 0, 0, 0 },
/* U+abf6 */ { 0, 0, 0, 0, 0 },
/* U+abf7 */ { 0, 0, 0, 0, 0 },
/* U+abf8 */ { 0, 0, 0, 0, 0 },
/* U+abf9 */ { 0, 0, 0, 0, 0 },
/* U+abfa */ { 0, 0, 0, 0, 0 },
/* U+abfb */ { 0, 0, 0, 0, 0 },
/* U+abfc */ { 0, 0, 0, 0, 0 },
/* U+abfd */ { 0, 0, 0, 0, 0 },
/* U+abfe */ { 0, 0, 0, 0, 0 },
/* U+abff */ { 0, 0, 0, 0, 0 },
/* U+ac00 */ { 19, 0, 1, 0, 0 },
/* U+ac01 */ { 0, 0, 0, 0, 0 },
/* U+ac02 */ { 0, 0, 0, 0, 0 },
/* U+ac03 */ { 0, 0, 0, 0, 0 },
/* U+ac04 */ { 0, 0, 0, 0, 0 },
/* U+ac05 */ { 0, 0, 0, 0, 0 },
/* U+ac06 */ { 0, 0, 0, 0, 0 },
/* U+ac07 */ { 0, 0, 0, 0, 0 },
/* U+ac08 */ { 0, 0, 0, 0, 0 },
/* U+ac09 */ { 0, 0, 0, 0, 0 },
/* U+ac0a */ { 0, 0, 0, 0, 0 },
/* U+ac0b */ { 0, 0, 0, 0, 0 },
/* U+ac0c */ { 0, 0, 0, 0, 0 },
/* U+ac0d */ { 0, 0, 0, 0, 0 },
/* U+ac0e */ { 0, 0, 0, 0, 0 },
/* U+ac0f */ { 0, 0, 0, 0, 0 },
/* U+ac10 */ { 0, 0, 0, 0, 0 },
/* U+ac11 */ { 0, 0, 0, 0, 0 },
/* U+ac12 */ { 0, 0, 0, 0, 0 },
/* U+ac13 */ { 0, 0, 0, 0, 0 },
/* U+ac14 */ { 0, 0, 0, 0, 0 },
/* U+ac15 */ { 0, 0, 0, 0, 0 },
/* U+ac16 */ { 0, 0, 0, 0, 0 },
/* U+ac17 */ { 0, 0, 0, 0, 0 },
/* U+ac18 */ { 0, 0, 0, 0, 0 },
/* U+ac19 */ { 0, 0, 0, 0, 0 },
/* U+ac1a */ { 0, 0, 0, 0, 0 },
/* U+ac1b */ { 0, 0, 0, 0, 0 },
/* U+ac1c */ { 0, 0, 0, 0, 0 },
/* U+ac1d */ { 0, 0, 0, 0, 0 },
/* U+ac1e */ { 0, 0, 0, 0, 0 },
/* U+ac1f */ { 0, 0, 0, 0, 0 },
/* U+ac20 */ { 0, 0, 0, 0, 0 },
/* U+ac21 */ { 0, 0, 0, 0, 0 },
/* U+ac22 */ { 0, 0, 0, 0, 0 },
/* U+ac23 */ { 0, 0, 0, 0, 0 },
/* U+ac24 */ { 0, 0, 0, 0, 0 },
/* U+ac25 */ { 0, 0, 0, 0, 0 },
/* U+ac26 */ { 0, 0, 0, 0, 0 },
/* U+ac27 */ { 0, 0, 0, 0, 0 },
/* U+ac28 */ { 0, 0, 0, 0, 0 },
/* U+ac29 */ { 0, 0, 0, 0, 0 },
/* U+ac2a */ { 0, 0, 0, 0, 0 },
/* U+ac2b */ { 0, 0, 0, 0, 0 },
/* U+ac2c */ { 0, 0, 0, 0, 0 },
/* U+ac2d */ { 0, 0, 0, 0, 0 },
/* U+ac2e */ { 0, 0, 0, 0, 0 },
/* U+ac2f */ { 0, 0, 0, 0, 0 },
/* U+ac30 */ { 0, 0, 0, 0, 0 },
/* U+ac31 */ { 0, 0, 0, 0, 0 },
/* U+ac32 */ { 0, 0, 0, 0, 0 },
/* U+ac33 */ { 0, 0, 0, 0, 0 },
/* U+ac34 */ { 0, 0, 0, 0, 0 },
/* U+ac35 */ { 0, 0, 0, 0, 0 },
/* U+ac36 */ { 0, 0, 0, 0, 0 },
/* U+ac37 */ { 0, 0, 0, 0, 0 },
/* U+ac38 */ { 0, 0, 0, 0, 0 },
/* U+ac39 */ { 0, 0, 0, 0, 0 },
/* U+ac3a */ { 0, 0, 0, 0, 0 },
/* U+ac3b */ { 0, 0, 0, 0, 0 },
/* U+ac3c */ { 0, 0, 0, 0, 0 },
/* U+ac3d */ { 0, 0, 0, 0, 0 },
/* U+ac3e */ { 0, 0, 0, 0, 0 },
/* U+ac3f */ { 0, 0, 0, 0, 0 },
/* U+ac40 */ { 0, 0, 0, 0, 0 },
/* U+ac41 */ { 0, 0, 0, 0, 0 },
/* U+ac42 */ { 0, 0, 0, 0, 0 },
/* U+ac43 */ { 0, 0, 0, 0, 0 },
/* U+ac44 */ { 0, 0, 0, 0, 0 },
/* U+ac45 */ { 0, 0, 0, 0, 0 },
/* U+ac46 */ { 0, 0, 0, 0, 0 },
/* U+ac47 */ { 0, 0, 0, 0, 0 },
/* U+ac48 */ { 0, 0, 0, 0, 0 },
/* U+ac49 */ { 0, 0, 0, 0, 0 },
/* U+ac4a */ { 0, 0, 0, 0, 0 },
/* U+ac4b */ { 0, 0, 0, 0, 0 },
/* U+ac4c */ { 0, 0, 0, 0, 0 },
/* U+ac4d */ { 0, 0, 0, 0, 0 },
/* U+ac4e */ { 0, 0, 0, 0, 0 },
/* U+ac4f */ { 0, 0, 0, 0, 0 },
/* U+ac50 */ { 0, 0, 0, 0, 0 },
/* U+ac51 */ { 0, 0, 0, 0, 0 },
/* U+ac52 */ { 0, 0, 0, 0, 0 },
/* U+ac53 */ { 0, 0, 0, 0, 0 },
/* U+ac54 */ { 0, 0, 0, 0, 0 },
/* U+ac55 */ { 0, 0, 0, 0, 0 },
/* U+ac56 */ { 0, 0, 0, 0, 0 },
/* U+ac57 */ { 0, 0, 0, 0, 0 },
/* U+ac58 */ { 0, 0, 0, 0, 0 },
/* U+ac59 */ { 0, 0, 0, 0, 0 },
/* U+ac5a */ { 0, 0, 0, 0, 0 },
/* U+ac5b */ { 0, 0, 0, 0, 0 },
/* U+ac5c */ { 0, 0, 0, 0, 0 },
/* U+ac5d */ { 0, 0, 0, 0, 0 },
/* U+ac5e */ { 0, 0, 0, 0, 0 },
/* U+ac5f */ { 0, 0, 0, 0, 0 },
/* U+ac60 */ { 0, 0, 0, 0, 0 },
/* U+ac61 */ { 0, 0, 0, 0, 0 },
/* U+ac62 */ { 0, 0, 0, 0, 0 },
/* U+ac63 */ { 0, 0, 0, 0, 0 },
/* U+ac64 */ { 0, 0, 0, 0, 0 },
/* U+ac65 */ { 0, 0, 0, 0, 0 },
/* U+ac66 */ { 0, 0, 0, 0, 0 },
/* U+ac67 */ { 0, 0, 0, 0, 0 },
/* U+ac68 */ { 0, 0, 0, 0, 0 },
/* U+ac69 */ { 0, 0, 0, 0, 0 },
/* U+ac6a */ { 0, 0, 0, 0, 0 },
/* U+ac6b */ { 0, 0, 0, 0, 0 },
/* U+ac6c */ { 0, 0, 0, 0, 0 },
/* U+ac6d */ { 0, 0, 0, 0, 0 },
/* U+ac6e */ { 0, 0, 0, 0, 0 },
/* U+ac6f */ { 0, 0, 0, 0, 0 },
/* U+ac70 */ { 0, 0, 0, 0, 0 },
/* U+ac71 */ { 0, 0, 0, 0, 0 },
/* U+ac72 */ { 0, 0, 0, 0, 0 },
/* U+ac73 */ { 0, 0, 0, 0, 0 },
/* U+ac74 */ { 0, 0, 0, 0, 0 },
/* U+ac75 */ { 0, 0, 0, 0, 0 },
/* U+ac76 */ { 0, 0, 0, 0, 0 },
/* U+ac77 */ { 0, 0, 0, 0, 0 },
/* U+ac78 */ { 0, 0, 0, 0, 0 },
/* U+ac79 */ { 0, 0, 0, 0, 0 },
/* U+ac7a */ { 0, 0, 0, 0, 0 },
/* U+ac7b */ { 0, 0, 0, 0, 0 },
/* U+ac7c */ { 0, 0, 0, 0, 0 },
/* U+ac7d */ { 0, 0, 0, 0, 0 },
/* U+ac7e */ { 0, 0, 0, 0, 0 },
/* U+ac7f */ { 0, 0, 0, 0, 0 },
/* U+ac80 */ { 0, 0, 0, 0, 0 },
/* U+ac81 */ { 0, 0, 0, 0, 0 },
/* U+ac82 */ { 0, 0, 0, 0, 0 },
/* U+ac83 */ { 0, 0, 0, 0, 0 },
/* U+ac84 */ { 0, 0, 0, 0, 0 },
/* U+ac85 */ { 0, 0, 0, 0, 0 },
/* U+ac86 */ { 0, 0, 0, 0, 0 },
/* U+ac87 */ { 0, 0, 0, 0, 0 },
/* U+ac88 */ { 0, 0, 0, 0, 0 },
/* U+ac89 */ { 0, 0, 0, 0, 0 },
/* U+ac8a */ { 0, 0, 0, 0, 0 },
/* U+ac8b */ { 0, 0, 0, 0, 0 },
/* U+ac8c */ { 0, 0, 0, 0, 0 },
/* U+ac8d */ { 0, 0, 0, 0, 0 },
/* U+ac8e */ { 0, 0, 0, 0, 0 },
/* U+ac8f */ { 0, 0, 0, 0, 0 },
/* U+ac90 */ { 0, 0, 0, 0, 0 },
/* U+ac91 */ { 0, 0, 0, 0, 0 },
/* U+ac92 */ { 0, 0, 0, 0, 0 },
/* U+ac93 */ { 0, 0, 0, 0, 0 },
/* U+ac94 */ { 0, 0, 0, 0, 0 },
/* U+ac95 */ { 0, 0, 0, 0, 0 },
/* U+ac96 */ { 0, 0, 0, 0, 0 },
/* U+ac97 */ { 0, 0, 0, 0, 0 },
/* U+ac98 */ { 0, 0, 0, 0, 0 },
/* U+ac99 */ { 0, 0, 0, 0, 0 },
/* U+ac9a */ { 0, 0, 0, 0, 0 },
/* U+ac9b */ { 0, 0, 0, 0, 0 },
/* U+ac9c */ { 0, 0, 0, 0, 0 },
/* U+ac9d */ { 0, 0, 0, 0, 0 },
/* U+ac9e */ { 0, 0, 0, 0, 0 },
/* U+ac9f */ { 0, 0, 0, 0, 0 },
/* U+aca0 */ { 0, 0, 0, 0, 0 },
/* U+aca1 */ { 0, 0, 0, 0, 0 },
/* U+aca2 */ { 0, 0, 0, 0, 0 },
/* U+aca3 */ { 0, 0, 0, 0, 0 },
/* U+aca4 */ { 0, 0, 0, 0, 0 },
/* U+aca5 */ { 0, 0, 0, 0, 0 },
/* U+aca6 */ { 0, 0, 0, 0, 0 },
/* U+aca7 */ { 0, 0, 0, 0, 0 },
/* U+aca8 */ { 0, 0, 0, 0, 0 },
/* U+aca9 */ { 0, 0, 0, 0, 0 },
/* U+acaa */ { 0, 0, 0, 0, 0 },
/* U+acab */ { 0, 0, 0, 0, 0 },
/* U+acac */ { 0, 0, 0, 0, 0 },
/* U+acad */ { 0, 0, 0, 0, 0 },
/* U+acae */ { 0, 0, 0, 0, 0 },
/* U+acaf */ { 0, 0, 0, 0, 0 },
/* U+acb0 */ { 0, 0, 0, 0, 0 },
/* U+acb1 */ { 0, 0, 0, 0, 0 },
/* U+acb2 */ { 0, 0, 0, 0, 0 },
/* U+acb3 */ { 0, 0, 0, 0, 0 },
/* U+acb4 */ { 0, 0, 0, 0, 0 },
/* U+acb5 */ { 0, 0, 0, 0, 0 },
/* U+acb6 */ { 0, 0, 0, 0, 0 },
/* U+acb7 */ { 0, 0, 0, 0, 0 },
/* U+acb8 */ { 0, 0, 0, 0, 0 },
/* U+acb9 */ { 0, 0, 0, 0, 0 },
/* U+acba */ { 0, 0, 0, 0, 0 },
/* U+acbb */ { 0, 0, 0, 0, 0 },
/* U+acbc */ { 0, 0, 0, 0, 0 },
/* U+acbd */ { 0, 0, 0, 0, 0 },
/* U+acbe */ { 0, 0, 0, 0, 0 },
/* U+acbf */ { 0, 0, 0, 0, 0 },
/* U+acc0 */ { 0, 0, 0, 0, 0 },
/* U+acc1 */ { 0, 0, 0, 0, 0 },
/* U+acc2 */ { 0, 0, 0, 0, 0 },
/* U+acc3 */ { 0, 0, 0, 0, 0 },
/* U+acc4 */ { 0, 0, 0, 0, 0 },
/* U+acc5 */ { 0, 0, 0, 0, 0 },
/* U+acc6 */ { 0, 0, 0, 0, 0 },
/* U+acc7 */ { 0, 0, 0, 0, 0 },
/* U+acc8 */ { 0, 0, 0, 0, 0 },
/* U+acc9 */ { 0, 0, 0, 0, 0 },
/* U+acca */ { 0, 0, 0, 0, 0 },
/* U+accb */ { 0, 0, 0, 0, 0 },
/* U+accc */ { 0, 0, 0, 0, 0 },
/* U+accd */ { 0, 0, 0, 0, 0 },
/* U+acce */ { 0, 0, 0, 0, 0 },
/* U+accf */ { 0, 0, 0, 0, 0 },
/* U+acd0 */ { 0, 0, 0, 0, 0 },
/* U+acd1 */ { 0, 0, 0, 0, 0 },
/* U+acd2 */ { 0, 0, 0, 0, 0 },
/* U+acd3 */ { 0, 0, 0, 0, 0 },
/* U+acd4 */ { 0, 0, 0, 0, 0 },
/* U+acd5 */ { 0, 0, 0, 0, 0 },
/* U+acd6 */ { 0, 0, 0, 0, 0 },
/* U+acd7 */ { 0, 0, 0, 0, 0 },
/* U+acd8 */ { 0, 0, 0, 0, 0 },
/* U+acd9 */ { 0, 0, 0, 0, 0 },
/* U+acda */ { 0, 0, 0, 0, 0 },
/* U+acdb */ { 0, 0, 0, 0, 0 },
/* U+acdc */ { 0, 0, 0, 0, 0 },
/* U+acdd */ { 0, 0, 0, 0, 0 },
/* U+acde */ { 0, 0, 0, 0, 0 },
/* U+acdf */ { 0, 0, 0, 0, 0 },
/* U+ace0 */ { 0, 0, 0, 0, 0 },
/* U+ace1 */ { 0, 0, 0, 0, 0 },
/* U+ace2 */ { 0, 0, 0, 0, 0 },
/* U+ace3 */ { 0, 0, 0, 0, 0 },
/* U+ace4 */ { 0, 0, 0, 0, 0 },
/* U+ace5 */ { 0, 0, 0, 0, 0 },
/* U+ace6 */ { 0, 0, 0, 0, 0 },
/* U+ace7 */ { 0, 0, 0, 0, 0 },
/* U+ace8 */ { 0, 0, 0, 0, 0 },
/* U+ace9 */ { 0, 0, 0, 0, 0 },
/* U+acea */ { 0, 0, 0, 0, 0 },
/* U+aceb */ { 0, 0, 0, 0, 0 },
/* U+acec */ { 0, 0, 0, 0, 0 },
/* U+aced */ { 0, 0, 0, 0, 0 },
/* U+acee */ { 0, 0, 0, 0, 0 },
/* U+acef */ { 0, 0, 0, 0, 0 },
/* U+acf0 */ { 0, 0, 0, 0, 0 },
/* U+acf1 */ { 0, 0, 0, 0, 0 },
/* U+acf2 */ { 0, 0, 0, 0, 0 },
/* U+acf3 */ { 0, 0, 0, 0, 0 },
/* U+acf4 */ { 0, 0, 0, 0, 0 },
/* U+acf5 */ { 0, 0, 0, 0, 0 },
/* U+acf6 */ { 0, 0, 0, 0, 0 },
/* U+acf7 */ { 0, 0, 0, 0, 0 },
/* U+acf8 */ { 0, 0, 0, 0, 0 },
/* U+acf9 */ { 0, 0, 0, 0, 0 },
/* U+acfa */ { 0, 0, 0, 0, 0 },
/* U+acfb */ { 0, 0, 0, 0, 0 },
/* U+acfc */ { 0, 0, 0, 0, 0 },
/* U+acfd */ { 0, 0, 0, 0, 0 },
/* U+acfe */ { 0, 0, 0, 0, 0 },
/* U+acff */ { 0, 0, 0, 0, 0 },
/* U+ad00 */ { 0, 0, 0, 0, 0 },
/* U+ad01 */ { 0, 0, 0, 0, 0 },
/* U+ad02 */ { 0, 0, 0, 0, 0 },
/* U+ad03 */ { 0, 0, 0, 0, 0 },
/* U+ad04 */ { 0, 0, 0, 0, 0 },
/* U+ad05 */ { 0, 0, 0, 0, 0 },
/* U+ad06 */ { 0, 0, 0, 0, 0 },
/* U+ad07 */ { 0, 0, 0, 0, 0 },
/* U+ad08 */ { 0, 0, 0, 0, 0 },
/* U+ad09 */ { 0, 0, 0, 0, 0 },
/* U+ad0a */ { 0, 0, 0, 0, 0 },
/* U+ad0b */ { 0, 0, 0, 0, 0 },
/* U+ad0c */ { 0, 0, 0, 0, 0 },
/* U+ad0d */ { 0, 0, 0, 0, 0 },
/* U+ad0e */ { 0, 0, 0, 0, 0 },
/* U+ad0f */ { 0, 0, 0, 0, 0 },
/* U+ad10 */ { 0, 0, 0, 0, 0 },
/* U+ad11 */ { 0, 0, 0, 0, 0 },
/* U+ad12 */ { 0, 0, 0, 0, 0 },
/* U+ad13 */ { 0, 0, 0, 0, 0 },
/* U+ad14 */ { 0, 0, 0, 0, 0 },
/* U+ad15 */ { 0, 0, 0, 0, 0 },
/* U+ad16 */ { 0, 0, 0, 0, 0 },
/* U+ad17 */ { 0, 0, 0, 0, 0 },
/* U+ad18 */ { 0, 0, 0, 0, 0 },
/* U+ad19 */ { 0, 0, 0, 0, 0 },
/* U+ad1a */ { 0, 0, 0, 0, 0 },
/* U+ad1b */ { 0, 0, 0, 0, 0 },
/* U+ad1c */ { 0, 0, 0, 0, 0 },
/* U+ad1d */ { 0, 0, 0, 0, 0 },
/* U+ad1e */ { 0, 0, 0, 0, 0 },
/* U+ad1f */ { 0, 0, 0, 0, 0 },
/* U+ad20 */ { 0, 0, 0, 0, 0 },
/* U+ad21 */ { 0, 0, 0, 0, 0 },
/* U+ad22 */ { 0, 0, 0, 0, 0 },
/* U+ad23 */ { 0, 0, 0, 0, 0 },
/* U+ad24 */ { 0, 0, 0, 0, 0 },
/* U+ad25 */ { 0, 0, 0, 0, 0 },
/* U+ad26 */ { 0, 0, 0, 0, 0 },
/* U+ad27 */ { 0, 0, 0, 0, 0 },
/* U+ad28 */ { 0, 0, 0, 0, 0 },
/* U+ad29 */ { 0, 0, 0, 0, 0 },
/* U+ad2a */ { 0, 0, 0, 0, 0 },
/* U+ad2b */ { 0, 0, 0, 0, 0 },
/* U+ad2c */ { 0, 0, 0, 0, 0 },
/* U+ad2d */ { 0, 0, 0, 0, 0 },
/* U+ad2e */ { 0, 0, 0, 0, 0 },
/* U+ad2f */ { 0, 0, 0, 0, 0 },
/* U+ad30 */ { 0, 0, 0, 0, 0 },
/* U+ad31 */ { 0, 0, 0, 0, 0 },
/* U+ad32 */ { 0, 0, 0, 0, 0 },
/* U+ad33 */ { 0, 0, 0, 0, 0 },
/* U+ad34 */ { 0, 0, 0, 0, 0 },
/* U+ad35 */ { 0, 0, 0, 0, 0 },
/* U+ad36 */ { 0, 0, 0, 0, 0 },
/* U+ad37 */ { 0, 0, 0, 0, 0 },
/* U+ad38 */ { 0, 0, 0, 0, 0 },
/* U+ad39 */ { 0, 0, 0, 0, 0 },
/* U+ad3a */ { 0, 0, 0, 0, 0 },
/* U+ad3b */ { 0, 0, 0, 0, 0 },
/* U+ad3c */ { 0, 0, 0, 0, 0 },
/* U+ad3d */ { 0, 0, 0, 0, 0 },
/* U+ad3e */ { 0, 0, 0, 0, 0 },
/* U+ad3f */ { 0, 0, 0, 0, 0 },
/* U+ad40 */ { 0, 0, 0, 0, 0 },
/* U+ad41 */ { 0, 0, 0, 0, 0 },
/* U+ad42 */ { 0, 0, 0, 0, 0 },
/* U+ad43 */ { 0, 0, 0, 0, 0 },
/* U+ad44 */ { 0, 0, 0, 0, 0 },
/* U+ad45 */ { 0, 0, 0, 0, 0 },
/* U+ad46 */ { 0, 0, 0, 0, 0 },
/* U+ad47 */ { 0, 0, 0, 0, 0 },
/* U+ad48 */ { 0, 0, 0, 0, 0 },
/* U+ad49 */ { 0, 0, 0, 0, 0 },
/* U+ad4a */ { 0, 0, 0, 0, 0 },
/* U+ad4b */ { 0, 0, 0, 0, 0 },
/* U+ad4c */ { 0, 0, 0, 0, 0 },
/* U+ad4d */ { 0, 0, 0, 0, 0 },
/* U+ad4e */ { 0, 0, 0, 0, 0 },
/* U+ad4f */ { 0, 0, 0, 0, 0 },
/* U+ad50 */ { 0, 0, 0, 0, 0 },
/* U+ad51 */ { 0, 0, 0, 0, 0 },
/* U+ad52 */ { 0, 0, 0, 0, 0 },
/* U+ad53 */ { 0, 0, 0, 0, 0 },
/* U+ad54 */ { 0, 0, 0, 0, 0 },
/* U+ad55 */ { 0, 0, 0, 0, 0 },
/* U+ad56 */ { 0, 0, 0, 0, 0 },
/* U+ad57 */ { 0, 0, 0, 0, 0 },
/* U+ad58 */ { 0, 0, 0, 0, 0 },
/* U+ad59 */ { 0, 0, 0, 0, 0 },
/* U+ad5a */ { 0, 0, 0, 0, 0 },
/* U+ad5b */ { 0, 0, 0, 0, 0 },
/* U+ad5c */ { 0, 0, 0, 0, 0 },
/* U+ad5d */ { 0, 0, 0, 0, 0 },
/* U+ad5e */ { 0, 0, 0, 0, 0 },
/* U+ad5f */ { 0, 0, 0, 0, 0 },
/* U+ad60 */ { 0, 0, 0, 0, 0 },
/* U+ad61 */ { 0, 0, 0, 0, 0 },
/* U+ad62 */ { 0, 0, 0, 0, 0 },
/* U+ad63 */ { 0, 0, 0, 0, 0 },
/* U+ad64 */ { 0, 0, 0, 0, 0 },
/* U+ad65 */ { 0, 0, 0, 0, 0 },
/* U+ad66 */ { 0, 0, 0, 0, 0 },
/* U+ad67 */ { 0, 0, 0, 0, 0 },
/* U+ad68 */ { 0, 0, 0, 0, 0 },
/* U+ad69 */ { 0, 0, 0, 0, 0 },
/* U+ad6a */ { 0, 0, 0, 0, 0 },
/* U+ad6b */ { 0, 0, 0, 0, 0 },
/* U+ad6c */ { 0, 0, 0, 0, 0 },
/* U+ad6d */ { 0, 0, 0, 0, 0 },
/* U+ad6e */ { 0, 0, 0, 0, 0 },
/* U+ad6f */ { 0, 0, 0, 0, 0 },
/* U+ad70 */ { 0, 0, 0, 0, 0 },
/* U+ad71 */ { 0, 0, 0, 0, 0 },
/* U+ad72 */ { 0, 0, 0, 0, 0 },
/* U+ad73 */ { 0, 0, 0, 0, 0 },
/* U+ad74 */ { 0, 0, 0, 0, 0 },
/* U+ad75 */ { 0, 0, 0, 0, 0 },
/* U+ad76 */ { 0, 0, 0, 0, 0 },
/* U+ad77 */ { 0, 0, 0, 0, 0 },
/* U+ad78 */ { 0, 0, 0, 0, 0 },
/* U+ad79 */ { 0, 0, 0, 0, 0 },
/* U+ad7a */ { 0, 0, 0, 0, 0 },
/* U+ad7b */ { 0, 0, 0, 0, 0 },
/* U+ad7c */ { 0, 0, 0, 0, 0 },
/* U+ad7d */ { 0, 0, 0, 0, 0 },
/* U+ad7e */ { 0, 0, 0, 0, 0 },
/* U+ad7f */ { 0, 0, 0, 0, 0 },
/* U+ad80 */ { 0, 0, 0, 0, 0 },
/* U+ad81 */ { 0, 0, 0, 0, 0 },
/* U+ad82 */ { 0, 0, 0, 0, 0 },
/* U+ad83 */ { 0, 0, 0, 0, 0 },
/* U+ad84 */ { 0, 0, 0, 0, 0 },
/* U+ad85 */ { 0, 0, 0, 0, 0 },
/* U+ad86 */ { 0, 0, 0, 0, 0 },
/* U+ad87 */ { 0, 0, 0, 0, 0 },
/* U+ad88 */ { 0, 0, 0, 0, 0 },
/* U+ad89 */ { 0, 0, 0, 0, 0 },
/* U+ad8a */ { 0, 0, 0, 0, 0 },
/* U+ad8b */ { 0, 0, 0, 0, 0 },
/* U+ad8c */ { 0, 0, 0, 0, 0 },
/* U+ad8d */ { 0, 0, 0, 0, 0 },
/* U+ad8e */ { 0, 0, 0, 0, 0 },
/* U+ad8f */ { 0, 0, 0, 0, 0 },
/* U+ad90 */ { 0, 0, 0, 0, 0 },
/* U+ad91 */ { 0, 0, 0, 0, 0 },
/* U+ad92 */ { 0, 0, 0, 0, 0 },
/* U+ad93 */ { 0, 0, 0, 0, 0 },
/* U+ad94 */ { 0, 0, 0, 0, 0 },
/* U+ad95 */ { 0, 0, 0, 0, 0 },
/* U+ad96 */ { 0, 0, 0, 0, 0 },
/* U+ad97 */ { 0, 0, 0, 0, 0 },
/* U+ad98 */ { 0, 0, 0, 0, 0 },
/* U+ad99 */ { 0, 0, 0, 0, 0 },
/* U+ad9a */ { 0, 0, 0, 0, 0 },
/* U+ad9b */ { 0, 0, 0, 0, 0 },
/* U+ad9c */ { 0, 0, 0, 0, 0 },
/* U+ad9d */ { 0, 0, 0, 0, 0 },
/* U+ad9e */ { 0, 0, 0, 0, 0 },
/* U+ad9f */ { 0, 0, 0, 0, 0 },
/* U+ada0 */ { 0, 0, 0, 0, 0 },
/* U+ada1 */ { 0, 0, 0, 0, 0 },
/* U+ada2 */ { 0, 0, 0, 0, 0 },
/* U+ada3 */ { 0, 0, 0, 0, 0 },
/* U+ada4 */ { 0, 0, 0, 0, 0 },
/* U+ada5 */ { 0, 0, 0, 0, 0 },
/* U+ada6 */ { 0, 0, 0, 0, 0 },
/* U+ada7 */ { 0, 0, 0, 0, 0 },
/* U+ada8 */ { 0, 0, 0, 0, 0 },
/* U+ada9 */ { 0, 0, 0, 0, 0 },
/* U+adaa */ { 0, 0, 0, 0, 0 },
/* U+adab */ { 0, 0, 0, 0, 0 },
/* U+adac */ { 0, 0, 0, 0, 0 },
/* U+adad */ { 0, 0, 0, 0, 0 },
/* U+adae */ { 0, 0, 0, 0, 0 },
/* U+adaf */ { 0, 0, 0, 0, 0 },
/* U+adb0 */ { 0, 0, 0, 0, 0 },
/* U+adb1 */ { 0, 0, 0, 0, 0 },
/* U+adb2 */ { 0, 0, 0, 0, 0 },
/* U+adb3 */ { 0, 0, 0, 0, 0 },
/* U+adb4 */ { 0, 0, 0, 0, 0 },
/* U+adb5 */ { 0, 0, 0, 0, 0 },
/* U+adb6 */ { 0, 0, 0, 0, 0 },
/* U+adb7 */ { 0, 0, 0, 0, 0 },
/* U+adb8 */ { 0, 0, 0, 0, 0 },
/* U+adb9 */ { 0, 0, 0, 0, 0 },
/* U+adba */ { 0, 0, 0, 0, 0 },
/* U+adbb */ { 0, 0, 0, 0, 0 },
/* U+adbc */ { 0, 0, 0, 0, 0 },
/* U+adbd */ { 0, 0, 0, 0, 0 },
/* U+adbe */ { 0, 0, 0, 0, 0 },
/* U+adbf */ { 0, 0, 0, 0, 0 },
/* U+adc0 */ { 0, 0, 0, 0, 0 },
/* U+adc1 */ { 0, 0, 0, 0, 0 },
/* U+adc2 */ { 0, 0, 0, 0, 0 },
/* U+adc3 */ { 0, 0, 0, 0, 0 },
/* U+adc4 */ { 0, 0, 0, 0, 0 },
/* U+adc5 */ { 0, 0, 0, 0, 0 },
/* U+adc6 */ { 0, 0, 0, 0, 0 },
/* U+adc7 */ { 0, 0, 0, 0, 0 },
/* U+adc8 */ { 0, 0, 0, 0, 0 },
/* U+adc9 */ { 0, 0, 0, 0, 0 },
/* U+adca */ { 0, 0, 0, 0, 0 },
/* U+adcb */ { 0, 0, 0, 0, 0 },
/* U+adcc */ { 0, 0, 0, 0, 0 },
/* U+adcd */ { 0, 0, 0, 0, 0 },
/* U+adce */ { 0, 0, 0, 0, 0 },
/* U+adcf */ { 0, 0, 0, 0, 0 },
/* U+add0 */ { 0, 0, 0, 0, 0 },
/* U+add1 */ { 0, 0, 0, 0, 0 },
/* U+add2 */ { 0, 0, 0, 0, 0 },
/* U+add3 */ { 0, 0, 0, 0, 0 },
/* U+add4 */ { 0, 0, 0, 0, 0 },
/* U+add5 */ { 0, 0, 0, 0, 0 },
/* U+add6 */ { 0, 0, 0, 0, 0 },
/* U+add7 */ { 0, 0, 0, 0, 0 },
/* U+add8 */ { 0, 0, 0, 0, 0 },
/* U+add9 */ { 0, 0, 0, 0, 0 },
/* U+adda */ { 0, 0, 0, 0, 0 },
/* U+addb */ { 0, 0, 0, 0, 0 },
/* U+addc */ { 0, 0, 0, 0, 0 },
/* U+addd */ { 0, 0, 0, 0, 0 },
/* U+adde */ { 0, 0, 0, 0, 0 },
/* U+addf */ { 0, 0, 0, 0, 0 },
/* U+ade0 */ { 0, 0, 0, 0, 0 },
/* U+ade1 */ { 0, 0, 0, 0, 0 },
/* U+ade2 */ { 0, 0, 0, 0, 0 },
/* U+ade3 */ { 0, 0, 0, 0, 0 },
/* U+ade4 */ { 0, 0, 0, 0, 0 },
/* U+ade5 */ { 0, 0, 0, 0, 0 },
/* U+ade6 */ { 0, 0, 0, 0, 0 },
/* U+ade7 */ { 0, 0, 0, 0, 0 },
/* U+ade8 */ { 0, 0, 0, 0, 0 },
/* U+ade9 */ { 0, 0, 0, 0, 0 },
/* U+adea */ { 0, 0, 0, 0, 0 },
/* U+adeb */ { 0, 0, 0, 0, 0 },
/* U+adec */ { 0, 0, 0, 0, 0 },
/* U+aded */ { 0, 0, 0, 0, 0 },
/* U+adee */ { 0, 0, 0, 0, 0 },
/* U+adef */ { 0, 0, 0, 0, 0 },
/* U+adf0 */ { 0, 0, 0, 0, 0 },
/* U+adf1 */ { 0, 0, 0, 0, 0 },
/* U+adf2 */ { 0, 0, 0, 0, 0 },
/* U+adf3 */ { 0, 0, 0, 0, 0 },
/* U+adf4 */ { 0, 0, 0, 0, 0 },
/* U+adf5 */ { 0, 0, 0, 0, 0 },
/* U+adf6 */ { 0, 0, 0, 0, 0 },
/* U+adf7 */ { 0, 0, 0, 0, 0 },
/* U+adf8 */ { 0, 0, 0, 0, 0 },
/* U+adf9 */ { 0, 0, 0, 0, 0 },
/* U+adfa */ { 0, 0, 0, 0, 0 },
/* U+adfb */ { 0, 0, 0, 0, 0 },
/* U+adfc */ { 0, 0, 0, 0, 0 },
/* U+adfd */ { 0, 0, 0, 0, 0 },
/* U+adfe */ { 0, 0, 0, 0, 0 },
/* U+adff */ { 0, 0, 0, 0, 0 },
/* U+ae00 */ { 0, 0, 0, 0, 0 },
/* U+ae01 */ { 0, 0, 0, 0, 0 },
/* U+ae02 */ { 0, 0, 0, 0, 0 },
/* U+ae03 */ { 0, 0, 0, 0, 0 },
/* U+ae04 */ { 0, 0, 0, 0, 0 },
/* U+ae05 */ { 0, 0, 0, 0, 0 },
/* U+ae06 */ { 0, 0, 0, 0, 0 },
/* U+ae07 */ { 0, 0, 0, 0, 0 },
/* U+ae08 */ { 0, 0, 0, 0, 0 },
/* U+ae09 */ { 0, 0, 0, 0, 0 },
/* U+ae0a */ { 0, 0, 0, 0, 0 },
/* U+ae0b */ { 0, 0, 0, 0, 0 },
/* U+ae0c */ { 0, 0, 0, 0, 0 },
/* U+ae0d */ { 0, 0, 0, 0, 0 },
/* U+ae0e */ { 0, 0, 0, 0, 0 },
/* U+ae0f */ { 0, 0, 0, 0, 0 },
/* U+ae10 */ { 0, 0, 0, 0, 0 },
/* U+ae11 */ { 0, 0, 0, 0, 0 },
/* U+ae12 */ { 0, 0, 0, 0, 0 },
/* U+ae13 */ { 0, 0, 0, 0, 0 },
/* U+ae14 */ { 0, 0, 0, 0, 0 },
/* U+ae15 */ { 0, 0, 0, 0, 0 },
/* U+ae16 */ { 0, 0, 0, 0, 0 },
/* U+ae17 */ { 0, 0, 0, 0, 0 },
/* U+ae18 */ { 0, 0, 0, 0, 0 },
/* U+ae19 */ { 0, 0, 0, 0, 0 },
/* U+ae1a */ { 0, 0, 0, 0, 0 },
/* U+ae1b */ { 0, 0, 0, 0, 0 },
/* U+ae1c */ { 0, 0, 0, 0, 0 },
/* U+ae1d */ { 0, 0, 0, 0, 0 },
/* U+ae1e */ { 0, 0, 0, 0, 0 },
/* U+ae1f */ { 0, 0, 0, 0, 0 },
/* U+ae20 */ { 0, 0, 0, 0, 0 },
/* U+ae21 */ { 0, 0, 0, 0, 0 },
/* U+ae22 */ { 0, 0, 0, 0, 0 },
/* U+ae23 */ { 0, 0, 0, 0, 0 },
/* U+ae24 */ { 0, 0, 0, 0, 0 },
/* U+ae25 */ { 0, 0, 0, 0, 0 },
/* U+ae26 */ { 0, 0, 0, 0, 0 },
/* U+ae27 */ { 0, 0, 0, 0, 0 },
/* U+ae28 */ { 0, 0, 0, 0, 0 },
/* U+ae29 */ { 0, 0, 0, 0, 0 },
/* U+ae2a */ { 0, 0, 0, 0, 0 },
/* U+ae2b */ { 0, 0, 0, 0, 0 },
/* U+ae2c */ { 0, 0, 0, 0, 0 },
/* U+ae2d */ { 0, 0, 0, 0, 0 },
/* U+ae2e */ { 0, 0, 0, 0, 0 },
/* U+ae2f */ { 0, 0, 0, 0, 0 },
/* U+ae30 */ { 0, 0, 0, 0, 0 },
/* U+ae31 */ { 0, 0, 0, 0, 0 },
/* U+ae32 */ { 0, 0, 0, 0, 0 },
/* U+ae33 */ { 0, 0, 0, 0, 0 },
/* U+ae34 */ { 0, 0, 0, 0, 0 },
/* U+ae35 */ { 0, 0, 0, 0, 0 },
/* U+ae36 */ { 0, 0, 0, 0, 0 },
/* U+ae37 */ { 0, 0, 0, 0, 0 },
/* U+ae38 */ { 0, 0, 0, 0, 0 },
/* U+ae39 */ { 0, 0, 0, 0, 0 },
/* U+ae3a */ { 0, 0, 0, 0, 0 },
/* U+ae3b */ { 0, 0, 0, 0, 0 },
/* U+ae3c */ { 0, 0, 0, 0, 0 },
/* U+ae3d */ { 0, 0, 0, 0, 0 },
/* U+ae3e */ { 0, 0, 0, 0, 0 },
/* U+ae3f */ { 0, 0, 0, 0, 0 },
/* U+ae40 */ { 0, 0, 0, 0, 0 },
/* U+ae41 */ { 0, 0, 0, 0, 0 },
/* U+ae42 */ { 0, 0, 0, 0, 0 },
/* U+ae43 */ { 0, 0, 0, 0, 0 },
/* U+ae44 */ { 0, 0, 0, 0, 0 },
/* U+ae45 */ { 0, 0, 0, 0, 0 },
/* U+ae46 */ { 0, 0, 0, 0, 0 },
/* U+ae47 */ { 0, 0, 0, 0, 0 },
/* U+ae48 */ { 0, 0, 0, 0, 0 },
/* U+ae49 */ { 0, 0, 0, 0, 0 },
/* U+ae4a */ { 0, 0, 0, 0, 0 },
/* U+ae4b */ { 0, 0, 0, 0, 0 },
/* U+ae4c */ { 0, 0, 0, 0, 0 },
/* U+ae4d */ { 0, 0, 0, 0, 0 },
/* U+ae4e */ { 0, 0, 0, 0, 0 },
/* U+ae4f */ { 0, 0, 0, 0, 0 },
/* U+ae50 */ { 0, 0, 0, 0, 0 },
/* U+ae51 */ { 0, 0, 0, 0, 0 },
/* U+ae52 */ { 0, 0, 0, 0, 0 },
/* U+ae53 */ { 0, 0, 0, 0, 0 },
/* U+ae54 */ { 0, 0, 0, 0, 0 },
/* U+ae55 */ { 0, 0, 0, 0, 0 },
/* U+ae56 */ { 0, 0, 0, 0, 0 },
/* U+ae57 */ { 0, 0, 0, 0, 0 },
/* U+ae58 */ { 0, 0, 0, 0, 0 },
/* U+ae59 */ { 0, 0, 0, 0, 0 },
/* U+ae5a */ { 0, 0, 0, 0, 0 },
/* U+ae5b */ { 0, 0, 0, 0, 0 },
/* U+ae5c */ { 0, 0, 0, 0, 0 },
/* U+ae5d */ { 0, 0, 0, 0, 0 },
/* U+ae5e */ { 0, 0, 0, 0, 0 },
/* U+ae5f */ { 0, 0, 0, 0, 0 },
/* U+ae60 */ { 0, 0, 0, 0, 0 },
/* U+ae61 */ { 0, 0, 0, 0, 0 },
/* U+ae62 */ { 0, 0, 0, 0, 0 },
/* U+ae63 */ { 0, 0, 0, 0, 0 },
/* U+ae64 */ { 0, 0, 0, 0, 0 },
/* U+ae65 */ { 0, 0, 0, 0, 0 },
/* U+ae66 */ { 0, 0, 0, 0, 0 },
/* U+ae67 */ { 0, 0, 0, 0, 0 },
/* U+ae68 */ { 0, 0, 0, 0, 0 },
/* U+ae69 */ { 0, 0, 0, 0, 0 },
/* U+ae6a */ { 0, 0, 0, 0, 0 },
/* U+ae6b */ { 0, 0, 0, 0, 0 },
/* U+ae6c */ { 0, 0, 0, 0, 0 },
/* U+ae6d */ { 0, 0, 0, 0, 0 },
/* U+ae6e */ { 0, 0, 0, 0, 0 },
/* U+ae6f */ { 0, 0, 0, 0, 0 },
/* U+ae70 */ { 0, 0, 0, 0, 0 },
/* U+ae71 */ { 0, 0, 0, 0, 0 },
/* U+ae72 */ { 0, 0, 0, 0, 0 },
/* U+ae73 */ { 0, 0, 0, 0, 0 },
/* U+ae74 */ { 0, 0, 0, 0, 0 },
/* U+ae75 */ { 0, 0, 0, 0, 0 },
/* U+ae76 */ { 0, 0, 0, 0, 0 },
/* U+ae77 */ { 0, 0, 0, 0, 0 },
/* U+ae78 */ { 0, 0, 0, 0, 0 },
/* U+ae79 */ { 0, 0, 0, 0, 0 },
/* U+ae7a */ { 0, 0, 0, 0, 0 },
/* U+ae7b */ { 0, 0, 0, 0, 0 },
/* U+ae7c */ { 0, 0, 0, 0, 0 },
/* U+ae7d */ { 0, 0, 0, 0, 0 },
/* U+ae7e */ { 0, 0, 0, 0, 0 },
/* U+ae7f */ { 0, 0, 0, 0, 0 },
/* U+ae80 */ { 0, 0, 0, 0, 0 },
/* U+ae81 */ { 0, 0, 0, 0, 0 },
/* U+ae82 */ { 0, 0, 0, 0, 0 },
/* U+ae83 */ { 0, 0, 0, 0, 0 },
/* U+ae84 */ { 0, 0, 0, 0, 0 },
/* U+ae85 */ { 0, 0, 0, 0, 0 },
/* U+ae86 */ { 0, 0, 0, 0, 0 },
/* U+ae87 */ { 0, 0, 0, 0, 0 },
/* U+ae88 */ { 0, 0, 0, 0, 0 },
/* U+ae89 */ { 0, 0, 0, 0, 0 },
/* U+ae8a */ { 0, 0, 0, 0, 0 },
/* U+ae8b */ { 0, 0, 0, 0, 0 },
/* U+ae8c */ { 0, 0, 0, 0, 0 },
/* U+ae8d */ { 0, 0, 0, 0, 0 },
/* U+ae8e */ { 0, 0, 0, 0, 0 },
/* U+ae8f */ { 0, 0, 0, 0, 0 },
/* U+ae90 */ { 0, 0, 0, 0, 0 },
/* U+ae91 */ { 0, 0, 0, 0, 0 },
/* U+ae92 */ { 0, 0, 0, 0, 0 },
/* U+ae93 */ { 0, 0, 0, 0, 0 },
/* U+ae94 */ { 0, 0, 0, 0, 0 },
/* U+ae95 */ { 0, 0, 0, 0, 0 },
/* U+ae96 */ { 0, 0, 0, 0, 0 },
/* U+ae97 */ { 0, 0, 0, 0, 0 },
/* U+ae98 */ { 0, 0, 0, 0, 0 },
/* U+ae99 */ { 0, 0, 0, 0, 0 },
/* U+ae9a */ { 0, 0, 0, 0, 0 },
/* U+ae9b */ { 0, 0, 0, 0, 0 },
/* U+ae9c */ { 0, 0, 0, 0, 0 },
/* U+ae9d */ { 0, 0, 0, 0, 0 },
/* U+ae9e */ { 0, 0, 0, 0, 0 },
/* U+ae9f */ { 0, 0, 0, 0, 0 },
/* U+aea0 */ { 0, 0, 0, 0, 0 },
/* U+aea1 */ { 0, 0, 0, 0, 0 },
/* U+aea2 */ { 0, 0, 0, 0, 0 },
/* U+aea3 */ { 0, 0, 0, 0, 0 },
/* U+aea4 */ { 0, 0, 0, 0, 0 },
/* U+aea5 */ { 0, 0, 0, 0, 0 },
/* U+aea6 */ { 0, 0, 0, 0, 0 },
/* U+aea7 */ { 0, 0, 0, 0, 0 },
/* U+aea8 */ { 0, 0, 0, 0, 0 },
/* U+aea9 */ { 0, 0, 0, 0, 0 },
/* U+aeaa */ { 0, 0, 0, 0, 0 },
/* U+aeab */ { 0, 0, 0, 0, 0 },
/* U+aeac */ { 0, 0, 0, 0, 0 },
/* U+aead */ { 0, 0, 0, 0, 0 },
/* U+aeae */ { 0, 0, 0, 0, 0 },
/* U+aeaf */ { 0, 0, 0, 0, 0 },
/* U+aeb0 */ { 0, 0, 0, 0, 0 },
/* U+aeb1 */ { 0, 0, 0, 0, 0 },
/* U+aeb2 */ { 0, 0, 0, 0, 0 },
/* U+aeb3 */ { 0, 0, 0, 0, 0 },
/* U+aeb4 */ { 0, 0, 0, 0, 0 },
/* U+aeb5 */ { 0, 0, 0, 0, 0 },
/* U+aeb6 */ { 0, 0, 0, 0, 0 },
/* U+aeb7 */ { 0, 0, 0, 0, 0 },
/* U+aeb8 */ { 0, 0, 0, 0, 0 },
/* U+aeb9 */ { 0, 0, 0, 0, 0 },
/* U+aeba */ { 0, 0, 0, 0, 0 },
/* U+aebb */ { 0, 0, 0, 0, 0 },
/* U+aebc */ { 0, 0, 0, 0, 0 },
/* U+aebd */ { 0, 0, 0, 0, 0 },
/* U+aebe */ { 0, 0, 0, 0, 0 },
/* U+aebf */ { 0, 0, 0, 0, 0 },
/* U+aec0 */ { 0, 0, 0, 0, 0 },
/* U+aec1 */ { 0, 0, 0, 0, 0 },
/* U+aec2 */ { 0, 0, 0, 0, 0 },
/* U+aec3 */ { 0, 0, 0, 0, 0 },
/* U+aec4 */ { 0, 0, 0, 0, 0 },
/* U+aec5 */ { 0, 0, 0, 0, 0 },
/* U+aec6 */ { 0, 0, 0, 0, 0 },
/* U+aec7 */ { 0, 0, 0, 0, 0 },
/* U+aec8 */ { 0, 0, 0, 0, 0 },
/* U+aec9 */ { 0, 0, 0, 0, 0 },
/* U+aeca */ { 0, 0, 0, 0, 0 },
/* U+aecb */ { 0, 0, 0, 0, 0 },
/* U+aecc */ { 0, 0, 0, 0, 0 },
/* U+aecd */ { 0, 0, 0, 0, 0 },
/* U+aece */ { 0, 0, 0, 0, 0 },
/* U+aecf */ { 0, 0, 0, 0, 0 },
/* U+aed0 */ { 0, 0, 0, 0, 0 },
/* U+aed1 */ { 0, 0, 0, 0, 0 },
/* U+aed2 */ { 0, 0, 0, 0, 0 },
/* U+aed3 */ { 0, 0, 0, 0, 0 },
/* U+aed4 */ { 0, 0, 0, 0, 0 },
/* U+aed5 */ { 0, 0, 0, 0, 0 },
/* U+aed6 */ { 0, 0, 0, 0, 0 },
/* U+aed7 */ { 0, 0, 0, 0, 0 },
/* U+aed8 */ { 0, 0, 0, 0, 0 },
/* U+aed9 */ { 0, 0, 0, 0, 0 },
/* U+aeda */ { 0, 0, 0, 0, 0 },
/* U+aedb */ { 0, 0, 0, 0, 0 },
/* U+aedc */ { 0, 0, 0, 0, 0 },
/* U+aedd */ { 0, 0, 0, 0, 0 },
/* U+aede */ { 0, 0, 0, 0, 0 },
/* U+aedf */ { 0, 0, 0, 0, 0 },
/* U+aee0 */ { 0, 0, 0, 0, 0 },
/* U+aee1 */ { 0, 0, 0, 0, 0 },
/* U+aee2 */ { 0, 0, 0, 0, 0 },
/* U+aee3 */ { 0, 0, 0, 0, 0 },
/* U+aee4 */ { 0, 0, 0, 0, 0 },
/* U+aee5 */ { 0, 0, 0, 0, 0 },
/* U+aee6 */ { 0, 0, 0, 0, 0 },
/* U+aee7 */ { 0, 0, 0, 0, 0 },
/* U+aee8 */ { 0, 0, 0, 0, 0 },
/* U+aee9 */ { 0, 0, 0, 0, 0 },
/* U+aeea */ { 0, 0, 0, 0, 0 },
/* U+aeeb */ { 0, 0, 0, 0, 0 },
/* U+aeec */ { 0, 0, 0, 0, 0 },
/* U+aeed */ { 0, 0, 0, 0, 0 },
/* U+aeee */ { 0, 0, 0, 0, 0 },
/* U+aeef */ { 0, 0, 0, 0, 0 },
/* U+aef0 */ { 0, 0, 0, 0, 0 },
/* U+aef1 */ { 0, 0, 0, 0, 0 },
/* U+aef2 */ { 0, 0, 0, 0, 0 },
/* U+aef3 */ { 0, 0, 0, 0, 0 },
/* U+aef4 */ { 0, 0, 0, 0, 0 },
/* U+aef5 */ { 0, 0, 0, 0, 0 },
/* U+aef6 */ { 0, 0, 0, 0, 0 },
/* U+aef7 */ { 0, 0, 0, 0, 0 },
/* U+aef8 */ { 0, 0, 0, 0, 0 },
/* U+aef9 */ { 0, 0, 0, 0, 0 },
/* U+aefa */ { 0, 0, 0, 0, 0 },
/* U+aefb */ { 0, 0, 0, 0, 0 },
/* U+aefc */ { 0, 0, 0, 0, 0 },
/* U+aefd */ { 0, 0, 0, 0, 0 },
/* U+aefe */ { 0, 0, 0, 0, 0 },
/* U+aeff */ { 0, 0, 0, 0, 0 },
/* U+af00 */ { 0, 0, 0, 0, 0 },
/* U+af01 */ { 0, 0, 0, 0, 0 },
/* U+af02 */ { 0, 0, 0, 0, 0 },
/* U+af03 */ { 0, 0, 0, 0, 0 },
/* U+af04 */ { 0, 0, 0, 0, 0 },
/* U+af05 */ { 0, 0, 0, 0, 0 },
/* U+af06 */ { 0, 0, 0, 0, 0 },
/* U+af07 */ { 0, 0, 0, 0, 0 },
/* U+af08 */ { 0, 0, 0, 0, 0 },
/* U+af09 */ { 0, 0, 0, 0, 0 },
/* U+af0a */ { 0, 0, 0, 0, 0 },
/* U+af0b */ { 0, 0, 0, 0, 0 },
/* U+af0c */ { 0, 0, 0, 0, 0 },
/* U+af0d */ { 0, 0, 0, 0, 0 },
/* U+af0e */ { 0, 0, 0, 0, 0 },
/* U+af0f */ { 0, 0, 0, 0, 0 },
/* U+af10 */ { 0, 0, 0, 0, 0 },
/* U+af11 */ { 0, 0, 0, 0, 0 },
/* U+af12 */ { 0, 0, 0, 0, 0 },
/* U+af13 */ { 0, 0, 0, 0, 0 },
/* U+af14 */ { 0, 0, 0, 0, 0 },
/* U+af15 */ { 0, 0, 0, 0, 0 },
/* U+af16 */ { 0, 0, 0, 0, 0 },
/* U+af17 */ { 0, 0, 0, 0, 0 },
/* U+af18 */ { 0, 0, 0, 0, 0 },
/* U+af19 */ { 0, 0, 0, 0, 0 },
/* U+af1a */ { 0, 0, 0, 0, 0 },
/* U+af1b */ { 0, 0, 0, 0, 0 },
/* U+af1c */ { 0, 0, 0, 0, 0 },
/* U+af1d */ { 0, 0, 0, 0, 0 },
/* U+af1e */ { 0, 0, 0, 0, 0 },
/* U+af1f */ { 0, 0, 0, 0, 0 },
/* U+af20 */ { 0, 0, 0, 0, 0 },
/* U+af21 */ { 0, 0, 0, 0, 0 },
/* U+af22 */ { 0, 0, 0, 0, 0 },
/* U+af23 */ { 0, 0, 0, 0, 0 },
/* U+af24 */ { 0, 0, 0, 0, 0 },
/* U+af25 */ { 0, 0, 0, 0, 0 },
/* U+af26 */ { 0, 0, 0, 0, 0 },
/* U+af27 */ { 0, 0, 0, 0, 0 },
/* U+af28 */ { 0, 0, 0, 0, 0 },
/* U+af29 */ { 0, 0, 0, 0, 0 },
/* U+af2a */ { 0, 0, 0, 0, 0 },
/* U+af2b */ { 0, 0, 0, 0, 0 },
/* U+af2c */ { 0, 0, 0, 0, 0 },
/* U+af2d */ { 0, 0, 0, 0, 0 },
/* U+af2e */ { 0, 0, 0, 0, 0 },
/* U+af2f */ { 0, 0, 0, 0, 0 },
/* U+af30 */ { 0, 0, 0, 0, 0 },
/* U+af31 */ { 0, 0, 0, 0, 0 },
/* U+af32 */ { 0, 0, 0, 0, 0 },
/* U+af33 */ { 0, 0, 0, 0, 0 },
/* U+af34 */ { 0, 0, 0, 0, 0 },
/* U+af35 */ { 0, 0, 0, 0, 0 },
/* U+af36 */ { 0, 0, 0, 0, 0 },
/* U+af37 */ { 0, 0, 0, 0, 0 },
/* U+af38 */ { 0, 0, 0, 0, 0 },
/* U+af39 */ { 0, 0, 0, 0, 0 },
/* U+af3a */ { 0, 0, 0, 0, 0 },
/* U+af3b */ { 0, 0, 0, 0, 0 },
/* U+af3c */ { 0, 0, 0, 0, 0 },
/* U+af3d */ { 0, 0, 0, 0, 0 },
/* U+af3e */ { 0, 0, 0, 0, 0 },
/* U+af3f */ { 0, 0, 0, 0, 0 },
/* U+af40 */ { 0, 0, 0, 0, 0 },
/* U+af41 */ { 0, 0, 0, 0, 0 },
/* U+af42 */ { 0, 0, 0, 0, 0 },
/* U+af43 */ { 0, 0, 0, 0, 0 },
/* U+af44 */ { 0, 0, 0, 0, 0 },
/* U+af45 */ { 0, 0, 0, 0, 0 },
/* U+af46 */ { 0, 0, 0, 0, 0 },
/* U+af47 */ { 0, 0, 0, 0, 0 },
/* U+af48 */ { 0, 0, 0, 0, 0 },
/* U+af49 */ { 0, 0, 0, 0, 0 },
/* U+af4a */ { 0, 0, 0, 0, 0 },
/* U+af4b */ { 0, 0, 0, 0, 0 },
/* U+af4c */ { 0, 0, 0, 0, 0 },
/* U+af4d */ { 0, 0, 0, 0, 0 },
/* U+af4e */ { 0, 0, 0, 0, 0 },
/* U+af4f */ { 0, 0, 0, 0, 0 },
/* U+af50 */ { 0, 0, 0, 0, 0 },
/* U+af51 */ { 0, 0, 0, 0, 0 },
/* U+af52 */ { 0, 0, 0, 0, 0 },
/* U+af53 */ { 0, 0, 0, 0, 0 },
/* U+af54 */ { 0, 0, 0, 0, 0 },
/* U+af55 */ { 0, 0, 0, 0, 0 },
/* U+af56 */ { 0, 0, 0, 0, 0 },
/* U+af57 */ { 0, 0, 0, 0, 0 },
/* U+af58 */ { 0, 0, 0, 0, 0 },
/* U+af59 */ { 0, 0, 0, 0, 0 },
/* U+af5a */ { 0, 0, 0, 0, 0 },
/* U+af5b */ { 0, 0, 0, 0, 0 },
/* U+af5c */ { 0, 0, 0, 0, 0 },
/* U+af5d */ { 0, 0, 0, 0, 0 },
/* U+af5e */ { 0, 0, 0, 0, 0 },
/* U+af5f */ { 0, 0, 0, 0, 0 },
/* U+af60 */ { 0, 0, 0, 0, 0 },
/* U+af61 */ { 0, 0, 0, 0, 0 },
/* U+af62 */ { 0, 0, 0, 0, 0 },
/* U+af63 */ { 0, 0, 0, 0, 0 },
/* U+af64 */ { 0, 0, 0, 0, 0 },
/* U+af65 */ { 0, 0, 0, 0, 0 },
/* U+af66 */ { 0, 0, 0, 0, 0 },
/* U+af67 */ { 0, 0, 0, 0, 0 },
/* U+af68 */ { 0, 0, 0, 0, 0 },
/* U+af69 */ { 0, 0, 0, 0, 0 },
/* U+af6a */ { 0, 0, 0, 0, 0 },
/* U+af6b */ { 0, 0, 0, 0, 0 },
/* U+af6c */ { 0, 0, 0, 0, 0 },
/* U+af6d */ { 0, 0, 0, 0, 0 },
/* U+af6e */ { 0, 0, 0, 0, 0 },
/* U+af6f */ { 0, 0, 0, 0, 0 },
/* U+af70 */ { 0, 0, 0, 0, 0 },
/* U+af71 */ { 0, 0, 0, 0, 0 },
/* U+af72 */ { 0, 0, 0, 0, 0 },
/* U+af73 */ { 0, 0, 0, 0, 0 },
/* U+af74 */ { 0, 0, 0, 0, 0 },
/* U+af75 */ { 0, 0, 0, 0, 0 },
/* U+af76 */ { 0, 0, 0, 0, 0 },
/* U+af77 */ { 0, 0, 0, 0, 0 },
/* U+af78 */ { 0, 0, 0, 0, 0 },
/* U+af79 */ { 0, 0, 0, 0, 0 },
/* U+af7a */ { 0, 0, 0, 0, 0 },
/* U+af7b */ { 0, 0, 0, 0, 0 },
/* U+af7c */ { 0, 0, 0, 0, 0 },
/* U+af7d */ { 0, 0, 0, 0, 0 },
/* U+af7e */ { 0, 0, 0, 0, 0 },
/* U+af7f */ { 0, 0, 0, 0, 0 },
/* U+af80 */ { 0, 0, 0, 0, 0 },
/* U+af81 */ { 0, 0, 0, 0, 0 },
/* U+af82 */ { 0, 0, 0, 0, 0 },
/* U+af83 */ { 0, 0, 0, 0, 0 },
/* U+af84 */ { 0, 0, 0, 0, 0 },
/* U+af85 */ { 0, 0, 0, 0, 0 },
/* U+af86 */ { 0, 0, 0, 0, 0 },
/* U+af87 */ { 0, 0, 0, 0, 0 },
/* U+af88 */ { 0, 0, 0, 0, 0 },
/* U+af89 */ { 0, 0, 0, 0, 0 },
/* U+af8a */ { 0, 0, 0, 0, 0 },
/* U+af8b */ { 0, 0, 0, 0, 0 },
/* U+af8c */ { 0, 0, 0, 0, 0 },
/* U+af8d */ { 0, 0, 0, 0, 0 },
/* U+af8e */ { 0, 0, 0, 0, 0 },
/* U+af8f */ { 0, 0, 0, 0, 0 },
/* U+af90 */ { 0, 0, 0, 0, 0 },
/* U+af91 */ { 0, 0, 0, 0, 0 },
/* U+af92 */ { 0, 0, 0, 0, 0 },
/* U+af93 */ { 0, 0, 0, 0, 0 },
/* U+af94 */ { 0, 0, 0, 0, 0 },
/* U+af95 */ { 0, 0, 0, 0, 0 },
/* U+af96 */ { 0, 0, 0, 0, 0 },
/* U+af97 */ { 0, 0, 0, 0, 0 },
/* U+af98 */ { 0, 0, 0, 0, 0 },
/* U+af99 */ { 0, 0, 0, 0, 0 },
/* U+af9a */ { 0, 0, 0, 0, 0 },
/* U+af9b */ { 0, 0, 0, 0, 0 },
/* U+af9c */ { 0, 0, 0, 0, 0 },
/* U+af9d */ { 0, 0, 0, 0, 0 },
/* U+af9e */ { 0, 0, 0, 0, 0 },
/* U+af9f */ { 0, 0, 0, 0, 0 },
/* U+afa0 */ { 0, 0, 0, 0, 0 },
/* U+afa1 */ { 0, 0, 0, 0, 0 },
/* U+afa2 */ { 0, 0, 0, 0, 0 },
/* U+afa3 */ { 0, 0, 0, 0, 0 },
/* U+afa4 */ { 0, 0, 0, 0, 0 },
/* U+afa5 */ { 0, 0, 0, 0, 0 },
/* U+afa6 */ { 0, 0, 0, 0, 0 },
/* U+afa7 */ { 0, 0, 0, 0, 0 },
/* U+afa8 */ { 0, 0, 0, 0, 0 },
/* U+afa9 */ { 0, 0, 0, 0, 0 },
/* U+afaa */ { 0, 0, 0, 0, 0 },
/* U+afab */ { 0, 0, 0, 0, 0 },
/* U+afac */ { 0, 0, 0, 0, 0 },
/* U+afad */ { 0, 0, 0, 0, 0 },
/* U+afae */ { 0, 0, 0, 0, 0 },
/* U+afaf */ { 0, 0, 0, 0, 0 },
/* U+afb0 */ { 0, 0, 0, 0, 0 },
/* U+afb1 */ { 0, 0, 0, 0, 0 },
/* U+afb2 */ { 0, 0, 0, 0, 0 },
/* U+afb3 */ { 0, 0, 0, 0, 0 },
/* U+afb4 */ { 0, 0, 0, 0, 0 },
/* U+afb5 */ { 0, 0, 0, 0, 0 },
/* U+afb6 */ { 0, 0, 0, 0, 0 },
/* U+afb7 */ { 0, 0, 0, 0, 0 },
/* U+afb8 */ { 0, 0, 0, 0, 0 },
/* U+afb9 */ { 0, 0, 0, 0, 0 },
/* U+afba */ { 0, 0, 0, 0, 0 },
/* U+afbb */ { 0, 0, 0, 0, 0 },
/* U+afbc */ { 0, 0, 0, 0, 0 },
/* U+afbd */ { 0, 0, 0, 0, 0 },
/* U+afbe */ { 0, 0, 0, 0, 0 },
/* U+afbf */ { 0, 0, 0, 0, 0 },
/* U+afc0 */ { 0, 0, 0, 0, 0 },
/* U+afc1 */ { 0, 0, 0, 0, 0 },
/* U+afc2 */ { 0, 0, 0, 0, 0 },
/* U+afc3 */ { 0, 0, 0, 0, 0 },
/* U+afc4 */ { 0, 0, 0, 0, 0 },
/* U+afc5 */ { 0, 0, 0, 0, 0 },
/* U+afc6 */ { 0, 0, 0, 0, 0 },
/* U+afc7 */ { 0, 0, 0, 0, 0 },
/* U+afc8 */ { 0, 0, 0, 0, 0 },
/* U+afc9 */ { 0, 0, 0, 0, 0 },
/* U+afca */ { 0, 0, 0, 0, 0 },
/* U+afcb */ { 0, 0, 0, 0, 0 },
/* U+afcc */ { 0, 0, 0, 0, 0 },
/* U+afcd */ { 0, 0, 0, 0, 0 },
/* U+afce */ { 0, 0, 0, 0, 0 },
/* U+afcf */ { 0, 0, 0, 0, 0 },
/* U+afd0 */ { 0, 0, 0, 0, 0 },
/* U+afd1 */ { 0, 0, 0, 0, 0 },
/* U+afd2 */ { 0, 0, 0, 0, 0 },
/* U+afd3 */ { 0, 0, 0, 0, 0 },
/* U+afd4 */ { 0, 0, 0, 0, 0 },
/* U+afd5 */ { 0, 0, 0, 0, 0 },
/* U+afd6 */ { 0, 0, 0, 0, 0 },
/* U+afd7 */ { 0, 0, 0, 0, 0 },
/* U+afd8 */ { 0, 0, 0, 0, 0 },
/* U+afd9 */ { 0, 0, 0, 0, 0 },
/* U+afda */ { 0, 0, 0, 0, 0 },
/* U+afdb */ { 0, 0, 0, 0, 0 },
/* U+afdc */ { 0, 0, 0, 0, 0 },
/* U+afdd */ { 0, 0, 0, 0, 0 },
/* U+afde */ { 0, 0, 0, 0, 0 },
/* U+afdf */ { 0, 0, 0, 0, 0 },
/* U+afe0 */ { 0, 0, 0, 0, 0 },
/* U+afe1 */ { 0, 0, 0, 0, 0 },
/* U+afe2 */ { 0, 0, 0, 0, 0 },
/* U+afe3 */ { 0, 0, 0, 0, 0 },
/* U+afe4 */ { 0, 0, 0, 0, 0 },
/* U+afe5 */ { 0, 0, 0, 0, 0 },
/* U+afe6 */ { 0, 0, 0, 0, 0 },
/* U+afe7 */ { 0, 0, 0, 0, 0 },
/* U+afe8 */ { 0, 0, 0, 0, 0 },
/* U+afe9 */ { 0, 0, 0, 0, 0 },
/* U+afea */ { 0, 0, 0, 0, 0 },
/* U+afeb */ { 0, 0, 0, 0, 0 },
/* U+afec */ { 0, 0, 0, 0, 0 },
/* U+afed */ { 0, 0, 0, 0, 0 },
/* U+afee */ { 0, 0, 0, 0, 0 },
/* U+afef */ { 0, 0, 0, 0, 0 },
/* U+aff0 */ { 0, 0, 0, 0, 0 },
/* U+aff1 */ { 0, 0, 0, 0, 0 },
/* U+aff2 */ { 0, 0, 0, 0, 0 },
/* U+aff3 */ { 0, 0, 0, 0, 0 },
/* U+aff4 */ { 0, 0, 0, 0, 0 },
/* U+aff5 */ { 0, 0, 0, 0, 0 },
/* U+aff6 */ { 0, 0, 0, 0, 0 },
/* U+aff7 */ { 0, 0, 0, 0, 0 },
/* U+aff8 */ { 0, 0, 0, 0, 0 },
/* U+aff9 */ { 0, 0, 0, 0, 0 },
/* U+affa */ { 0, 0, 0, 0, 0 },
/* U+affb */ { 0, 0, 0, 0, 0 },
/* U+affc */ { 0, 0, 0, 0, 0 },
/* U+affd */ { 0, 0, 0, 0, 0 },
/* U+affe */ { 0, 0, 0, 0, 0 },
/* U+afff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_11[4096] = {
    
/* U+b000 */ { 0, 0, 0, 0, 0 },
/* U+b001 */ { 0, 0, 0, 0, 0 },
/* U+b002 */ { 0, 0, 0, 0, 0 },
/* U+b003 */ { 0, 0, 0, 0, 0 },
/* U+b004 */ { 0, 0, 0, 0, 0 },
/* U+b005 */ { 0, 0, 0, 0, 0 },
/* U+b006 */ { 0, 0, 0, 0, 0 },
/* U+b007 */ { 0, 0, 0, 0, 0 },
/* U+b008 */ { 0, 0, 0, 0, 0 },
/* U+b009 */ { 0, 0, 0, 0, 0 },
/* U+b00a */ { 0, 0, 0, 0, 0 },
/* U+b00b */ { 0, 0, 0, 0, 0 },
/* U+b00c */ { 0, 0, 0, 0, 0 },
/* U+b00d */ { 0, 0, 0, 0, 0 },
/* U+b00e */ { 0, 0, 0, 0, 0 },
/* U+b00f */ { 0, 0, 0, 0, 0 },
/* U+b010 */ { 0, 0, 0, 0, 0 },
/* U+b011 */ { 0, 0, 0, 0, 0 },
/* U+b012 */ { 0, 0, 0, 0, 0 },
/* U+b013 */ { 0, 0, 0, 0, 0 },
/* U+b014 */ { 0, 0, 0, 0, 0 },
/* U+b015 */ { 0, 0, 0, 0, 0 },
/* U+b016 */ { 0, 0, 0, 0, 0 },
/* U+b017 */ { 0, 0, 0, 0, 0 },
/* U+b018 */ { 0, 0, 0, 0, 0 },
/* U+b019 */ { 0, 0, 0, 0, 0 },
/* U+b01a */ { 0, 0, 0, 0, 0 },
/* U+b01b */ { 0, 0, 0, 0, 0 },
/* U+b01c */ { 0, 0, 0, 0, 0 },
/* U+b01d */ { 0, 0, 0, 0, 0 },
/* U+b01e */ { 0, 0, 0, 0, 0 },
/* U+b01f */ { 0, 0, 0, 0, 0 },
/* U+b020 */ { 0, 0, 0, 0, 0 },
/* U+b021 */ { 0, 0, 0, 0, 0 },
/* U+b022 */ { 0, 0, 0, 0, 0 },
/* U+b023 */ { 0, 0, 0, 0, 0 },
/* U+b024 */ { 0, 0, 0, 0, 0 },
/* U+b025 */ { 0, 0, 0, 0, 0 },
/* U+b026 */ { 0, 0, 0, 0, 0 },
/* U+b027 */ { 0, 0, 0, 0, 0 },
/* U+b028 */ { 0, 0, 0, 0, 0 },
/* U+b029 */ { 0, 0, 0, 0, 0 },
/* U+b02a */ { 0, 0, 0, 0, 0 },
/* U+b02b */ { 0, 0, 0, 0, 0 },
/* U+b02c */ { 0, 0, 0, 0, 0 },
/* U+b02d */ { 0, 0, 0, 0, 0 },
/* U+b02e */ { 0, 0, 0, 0, 0 },
/* U+b02f */ { 0, 0, 0, 0, 0 },
/* U+b030 */ { 0, 0, 0, 0, 0 },
/* U+b031 */ { 0, 0, 0, 0, 0 },
/* U+b032 */ { 0, 0, 0, 0, 0 },
/* U+b033 */ { 0, 0, 0, 0, 0 },
/* U+b034 */ { 0, 0, 0, 0, 0 },
/* U+b035 */ { 0, 0, 0, 0, 0 },
/* U+b036 */ { 0, 0, 0, 0, 0 },
/* U+b037 */ { 0, 0, 0, 0, 0 },
/* U+b038 */ { 0, 0, 0, 0, 0 },
/* U+b039 */ { 0, 0, 0, 0, 0 },
/* U+b03a */ { 0, 0, 0, 0, 0 },
/* U+b03b */ { 0, 0, 0, 0, 0 },
/* U+b03c */ { 0, 0, 0, 0, 0 },
/* U+b03d */ { 0, 0, 0, 0, 0 },
/* U+b03e */ { 0, 0, 0, 0, 0 },
/* U+b03f */ { 0, 0, 0, 0, 0 },
/* U+b040 */ { 0, 0, 0, 0, 0 },
/* U+b041 */ { 0, 0, 0, 0, 0 },
/* U+b042 */ { 0, 0, 0, 0, 0 },
/* U+b043 */ { 0, 0, 0, 0, 0 },
/* U+b044 */ { 0, 0, 0, 0, 0 },
/* U+b045 */ { 0, 0, 0, 0, 0 },
/* U+b046 */ { 0, 0, 0, 0, 0 },
/* U+b047 */ { 0, 0, 0, 0, 0 },
/* U+b048 */ { 0, 0, 0, 0, 0 },
/* U+b049 */ { 0, 0, 0, 0, 0 },
/* U+b04a */ { 0, 0, 0, 0, 0 },
/* U+b04b */ { 0, 0, 0, 0, 0 },
/* U+b04c */ { 0, 0, 0, 0, 0 },
/* U+b04d */ { 0, 0, 0, 0, 0 },
/* U+b04e */ { 0, 0, 0, 0, 0 },
/* U+b04f */ { 0, 0, 0, 0, 0 },
/* U+b050 */ { 0, 0, 0, 0, 0 },
/* U+b051 */ { 0, 0, 0, 0, 0 },
/* U+b052 */ { 0, 0, 0, 0, 0 },
/* U+b053 */ { 0, 0, 0, 0, 0 },
/* U+b054 */ { 0, 0, 0, 0, 0 },
/* U+b055 */ { 0, 0, 0, 0, 0 },
/* U+b056 */ { 0, 0, 0, 0, 0 },
/* U+b057 */ { 0, 0, 0, 0, 0 },
/* U+b058 */ { 0, 0, 0, 0, 0 },
/* U+b059 */ { 0, 0, 0, 0, 0 },
/* U+b05a */ { 0, 0, 0, 0, 0 },
/* U+b05b */ { 0, 0, 0, 0, 0 },
/* U+b05c */ { 0, 0, 0, 0, 0 },
/* U+b05d */ { 0, 0, 0, 0, 0 },
/* U+b05e */ { 0, 0, 0, 0, 0 },
/* U+b05f */ { 0, 0, 0, 0, 0 },
/* U+b060 */ { 0, 0, 0, 0, 0 },
/* U+b061 */ { 0, 0, 0, 0, 0 },
/* U+b062 */ { 0, 0, 0, 0, 0 },
/* U+b063 */ { 0, 0, 0, 0, 0 },
/* U+b064 */ { 0, 0, 0, 0, 0 },
/* U+b065 */ { 0, 0, 0, 0, 0 },
/* U+b066 */ { 0, 0, 0, 0, 0 },
/* U+b067 */ { 0, 0, 0, 0, 0 },
/* U+b068 */ { 0, 0, 0, 0, 0 },
/* U+b069 */ { 0, 0, 0, 0, 0 },
/* U+b06a */ { 0, 0, 0, 0, 0 },
/* U+b06b */ { 0, 0, 0, 0, 0 },
/* U+b06c */ { 0, 0, 0, 0, 0 },
/* U+b06d */ { 0, 0, 0, 0, 0 },
/* U+b06e */ { 0, 0, 0, 0, 0 },
/* U+b06f */ { 0, 0, 0, 0, 0 },
/* U+b070 */ { 0, 0, 0, 0, 0 },
/* U+b071 */ { 0, 0, 0, 0, 0 },
/* U+b072 */ { 0, 0, 0, 0, 0 },
/* U+b073 */ { 0, 0, 0, 0, 0 },
/* U+b074 */ { 0, 0, 0, 0, 0 },
/* U+b075 */ { 0, 0, 0, 0, 0 },
/* U+b076 */ { 0, 0, 0, 0, 0 },
/* U+b077 */ { 0, 0, 0, 0, 0 },
/* U+b078 */ { 0, 0, 0, 0, 0 },
/* U+b079 */ { 0, 0, 0, 0, 0 },
/* U+b07a */ { 0, 0, 0, 0, 0 },
/* U+b07b */ { 0, 0, 0, 0, 0 },
/* U+b07c */ { 0, 0, 0, 0, 0 },
/* U+b07d */ { 0, 0, 0, 0, 0 },
/* U+b07e */ { 0, 0, 0, 0, 0 },
/* U+b07f */ { 0, 0, 0, 0, 0 },
/* U+b080 */ { 0, 0, 0, 0, 0 },
/* U+b081 */ { 0, 0, 0, 0, 0 },
/* U+b082 */ { 0, 0, 0, 0, 0 },
/* U+b083 */ { 0, 0, 0, 0, 0 },
/* U+b084 */ { 0, 0, 0, 0, 0 },
/* U+b085 */ { 0, 0, 0, 0, 0 },
/* U+b086 */ { 0, 0, 0, 0, 0 },
/* U+b087 */ { 0, 0, 0, 0, 0 },
/* U+b088 */ { 0, 0, 0, 0, 0 },
/* U+b089 */ { 0, 0, 0, 0, 0 },
/* U+b08a */ { 0, 0, 0, 0, 0 },
/* U+b08b */ { 0, 0, 0, 0, 0 },
/* U+b08c */ { 0, 0, 0, 0, 0 },
/* U+b08d */ { 0, 0, 0, 0, 0 },
/* U+b08e */ { 0, 0, 0, 0, 0 },
/* U+b08f */ { 0, 0, 0, 0, 0 },
/* U+b090 */ { 0, 0, 0, 0, 0 },
/* U+b091 */ { 0, 0, 0, 0, 0 },
/* U+b092 */ { 0, 0, 0, 0, 0 },
/* U+b093 */ { 0, 0, 0, 0, 0 },
/* U+b094 */ { 0, 0, 0, 0, 0 },
/* U+b095 */ { 0, 0, 0, 0, 0 },
/* U+b096 */ { 0, 0, 0, 0, 0 },
/* U+b097 */ { 0, 0, 0, 0, 0 },
/* U+b098 */ { 0, 0, 0, 0, 0 },
/* U+b099 */ { 0, 0, 0, 0, 0 },
/* U+b09a */ { 0, 0, 0, 0, 0 },
/* U+b09b */ { 0, 0, 0, 0, 0 },
/* U+b09c */ { 0, 0, 0, 0, 0 },
/* U+b09d */ { 0, 0, 0, 0, 0 },
/* U+b09e */ { 0, 0, 0, 0, 0 },
/* U+b09f */ { 0, 0, 0, 0, 0 },
/* U+b0a0 */ { 0, 0, 0, 0, 0 },
/* U+b0a1 */ { 0, 0, 0, 0, 0 },
/* U+b0a2 */ { 0, 0, 0, 0, 0 },
/* U+b0a3 */ { 0, 0, 0, 0, 0 },
/* U+b0a4 */ { 0, 0, 0, 0, 0 },
/* U+b0a5 */ { 0, 0, 0, 0, 0 },
/* U+b0a6 */ { 0, 0, 0, 0, 0 },
/* U+b0a7 */ { 0, 0, 0, 0, 0 },
/* U+b0a8 */ { 0, 0, 0, 0, 0 },
/* U+b0a9 */ { 0, 0, 0, 0, 0 },
/* U+b0aa */ { 0, 0, 0, 0, 0 },
/* U+b0ab */ { 0, 0, 0, 0, 0 },
/* U+b0ac */ { 0, 0, 0, 0, 0 },
/* U+b0ad */ { 0, 0, 0, 0, 0 },
/* U+b0ae */ { 0, 0, 0, 0, 0 },
/* U+b0af */ { 0, 0, 0, 0, 0 },
/* U+b0b0 */ { 0, 0, 0, 0, 0 },
/* U+b0b1 */ { 0, 0, 0, 0, 0 },
/* U+b0b2 */ { 0, 0, 0, 0, 0 },
/* U+b0b3 */ { 0, 0, 0, 0, 0 },
/* U+b0b4 */ { 0, 0, 0, 0, 0 },
/* U+b0b5 */ { 0, 0, 0, 0, 0 },
/* U+b0b6 */ { 0, 0, 0, 0, 0 },
/* U+b0b7 */ { 0, 0, 0, 0, 0 },
/* U+b0b8 */ { 0, 0, 0, 0, 0 },
/* U+b0b9 */ { 0, 0, 0, 0, 0 },
/* U+b0ba */ { 0, 0, 0, 0, 0 },
/* U+b0bb */ { 0, 0, 0, 0, 0 },
/* U+b0bc */ { 0, 0, 0, 0, 0 },
/* U+b0bd */ { 0, 0, 0, 0, 0 },
/* U+b0be */ { 0, 0, 0, 0, 0 },
/* U+b0bf */ { 0, 0, 0, 0, 0 },
/* U+b0c0 */ { 0, 0, 0, 0, 0 },
/* U+b0c1 */ { 0, 0, 0, 0, 0 },
/* U+b0c2 */ { 0, 0, 0, 0, 0 },
/* U+b0c3 */ { 0, 0, 0, 0, 0 },
/* U+b0c4 */ { 0, 0, 0, 0, 0 },
/* U+b0c5 */ { 0, 0, 0, 0, 0 },
/* U+b0c6 */ { 0, 0, 0, 0, 0 },
/* U+b0c7 */ { 0, 0, 0, 0, 0 },
/* U+b0c8 */ { 0, 0, 0, 0, 0 },
/* U+b0c9 */ { 0, 0, 0, 0, 0 },
/* U+b0ca */ { 0, 0, 0, 0, 0 },
/* U+b0cb */ { 0, 0, 0, 0, 0 },
/* U+b0cc */ { 0, 0, 0, 0, 0 },
/* U+b0cd */ { 0, 0, 0, 0, 0 },
/* U+b0ce */ { 0, 0, 0, 0, 0 },
/* U+b0cf */ { 0, 0, 0, 0, 0 },
/* U+b0d0 */ { 0, 0, 0, 0, 0 },
/* U+b0d1 */ { 0, 0, 0, 0, 0 },
/* U+b0d2 */ { 0, 0, 0, 0, 0 },
/* U+b0d3 */ { 0, 0, 0, 0, 0 },
/* U+b0d4 */ { 0, 0, 0, 0, 0 },
/* U+b0d5 */ { 0, 0, 0, 0, 0 },
/* U+b0d6 */ { 0, 0, 0, 0, 0 },
/* U+b0d7 */ { 0, 0, 0, 0, 0 },
/* U+b0d8 */ { 0, 0, 0, 0, 0 },
/* U+b0d9 */ { 0, 0, 0, 0, 0 },
/* U+b0da */ { 0, 0, 0, 0, 0 },
/* U+b0db */ { 0, 0, 0, 0, 0 },
/* U+b0dc */ { 0, 0, 0, 0, 0 },
/* U+b0dd */ { 0, 0, 0, 0, 0 },
/* U+b0de */ { 0, 0, 0, 0, 0 },
/* U+b0df */ { 0, 0, 0, 0, 0 },
/* U+b0e0 */ { 0, 0, 0, 0, 0 },
/* U+b0e1 */ { 0, 0, 0, 0, 0 },
/* U+b0e2 */ { 0, 0, 0, 0, 0 },
/* U+b0e3 */ { 0, 0, 0, 0, 0 },
/* U+b0e4 */ { 0, 0, 0, 0, 0 },
/* U+b0e5 */ { 0, 0, 0, 0, 0 },
/* U+b0e6 */ { 0, 0, 0, 0, 0 },
/* U+b0e7 */ { 0, 0, 0, 0, 0 },
/* U+b0e8 */ { 0, 0, 0, 0, 0 },
/* U+b0e9 */ { 0, 0, 0, 0, 0 },
/* U+b0ea */ { 0, 0, 0, 0, 0 },
/* U+b0eb */ { 0, 0, 0, 0, 0 },
/* U+b0ec */ { 0, 0, 0, 0, 0 },
/* U+b0ed */ { 0, 0, 0, 0, 0 },
/* U+b0ee */ { 0, 0, 0, 0, 0 },
/* U+b0ef */ { 0, 0, 0, 0, 0 },
/* U+b0f0 */ { 0, 0, 0, 0, 0 },
/* U+b0f1 */ { 0, 0, 0, 0, 0 },
/* U+b0f2 */ { 0, 0, 0, 0, 0 },
/* U+b0f3 */ { 0, 0, 0, 0, 0 },
/* U+b0f4 */ { 0, 0, 0, 0, 0 },
/* U+b0f5 */ { 0, 0, 0, 0, 0 },
/* U+b0f6 */ { 0, 0, 0, 0, 0 },
/* U+b0f7 */ { 0, 0, 0, 0, 0 },
/* U+b0f8 */ { 0, 0, 0, 0, 0 },
/* U+b0f9 */ { 0, 0, 0, 0, 0 },
/* U+b0fa */ { 0, 0, 0, 0, 0 },
/* U+b0fb */ { 0, 0, 0, 0, 0 },
/* U+b0fc */ { 0, 0, 0, 0, 0 },
/* U+b0fd */ { 0, 0, 0, 0, 0 },
/* U+b0fe */ { 0, 0, 0, 0, 0 },
/* U+b0ff */ { 0, 0, 0, 0, 0 },
/* U+b100 */ { 0, 0, 0, 0, 0 },
/* U+b101 */ { 0, 0, 0, 0, 0 },
/* U+b102 */ { 0, 0, 0, 0, 0 },
/* U+b103 */ { 0, 0, 0, 0, 0 },
/* U+b104 */ { 0, 0, 0, 0, 0 },
/* U+b105 */ { 0, 0, 0, 0, 0 },
/* U+b106 */ { 0, 0, 0, 0, 0 },
/* U+b107 */ { 0, 0, 0, 0, 0 },
/* U+b108 */ { 0, 0, 0, 0, 0 },
/* U+b109 */ { 0, 0, 0, 0, 0 },
/* U+b10a */ { 0, 0, 0, 0, 0 },
/* U+b10b */ { 0, 0, 0, 0, 0 },
/* U+b10c */ { 0, 0, 0, 0, 0 },
/* U+b10d */ { 0, 0, 0, 0, 0 },
/* U+b10e */ { 0, 0, 0, 0, 0 },
/* U+b10f */ { 0, 0, 0, 0, 0 },
/* U+b110 */ { 0, 0, 0, 0, 0 },
/* U+b111 */ { 0, 0, 0, 0, 0 },
/* U+b112 */ { 0, 0, 0, 0, 0 },
/* U+b113 */ { 0, 0, 0, 0, 0 },
/* U+b114 */ { 0, 0, 0, 0, 0 },
/* U+b115 */ { 0, 0, 0, 0, 0 },
/* U+b116 */ { 0, 0, 0, 0, 0 },
/* U+b117 */ { 0, 0, 0, 0, 0 },
/* U+b118 */ { 0, 0, 0, 0, 0 },
/* U+b119 */ { 0, 0, 0, 0, 0 },
/* U+b11a */ { 0, 0, 0, 0, 0 },
/* U+b11b */ { 0, 0, 0, 0, 0 },
/* U+b11c */ { 0, 0, 0, 0, 0 },
/* U+b11d */ { 0, 0, 0, 0, 0 },
/* U+b11e */ { 0, 0, 0, 0, 0 },
/* U+b11f */ { 0, 0, 0, 0, 0 },
/* U+b120 */ { 0, 0, 0, 0, 0 },
/* U+b121 */ { 0, 0, 0, 0, 0 },
/* U+b122 */ { 0, 0, 0, 0, 0 },
/* U+b123 */ { 0, 0, 0, 0, 0 },
/* U+b124 */ { 0, 0, 0, 0, 0 },
/* U+b125 */ { 0, 0, 0, 0, 0 },
/* U+b126 */ { 0, 0, 0, 0, 0 },
/* U+b127 */ { 0, 0, 0, 0, 0 },
/* U+b128 */ { 0, 0, 0, 0, 0 },
/* U+b129 */ { 0, 0, 0, 0, 0 },
/* U+b12a */ { 0, 0, 0, 0, 0 },
/* U+b12b */ { 0, 0, 0, 0, 0 },
/* U+b12c */ { 0, 0, 0, 0, 0 },
/* U+b12d */ { 0, 0, 0, 0, 0 },
/* U+b12e */ { 0, 0, 0, 0, 0 },
/* U+b12f */ { 0, 0, 0, 0, 0 },
/* U+b130 */ { 0, 0, 0, 0, 0 },
/* U+b131 */ { 0, 0, 0, 0, 0 },
/* U+b132 */ { 0, 0, 0, 0, 0 },
/* U+b133 */ { 0, 0, 0, 0, 0 },
/* U+b134 */ { 0, 0, 0, 0, 0 },
/* U+b135 */ { 0, 0, 0, 0, 0 },
/* U+b136 */ { 0, 0, 0, 0, 0 },
/* U+b137 */ { 0, 0, 0, 0, 0 },
/* U+b138 */ { 0, 0, 0, 0, 0 },
/* U+b139 */ { 0, 0, 0, 0, 0 },
/* U+b13a */ { 0, 0, 0, 0, 0 },
/* U+b13b */ { 0, 0, 0, 0, 0 },
/* U+b13c */ { 0, 0, 0, 0, 0 },
/* U+b13d */ { 0, 0, 0, 0, 0 },
/* U+b13e */ { 0, 0, 0, 0, 0 },
/* U+b13f */ { 0, 0, 0, 0, 0 },
/* U+b140 */ { 0, 0, 0, 0, 0 },
/* U+b141 */ { 0, 0, 0, 0, 0 },
/* U+b142 */ { 0, 0, 0, 0, 0 },
/* U+b143 */ { 0, 0, 0, 0, 0 },
/* U+b144 */ { 0, 0, 0, 0, 0 },
/* U+b145 */ { 0, 0, 0, 0, 0 },
/* U+b146 */ { 0, 0, 0, 0, 0 },
/* U+b147 */ { 0, 0, 0, 0, 0 },
/* U+b148 */ { 0, 0, 0, 0, 0 },
/* U+b149 */ { 0, 0, 0, 0, 0 },
/* U+b14a */ { 0, 0, 0, 0, 0 },
/* U+b14b */ { 0, 0, 0, 0, 0 },
/* U+b14c */ { 0, 0, 0, 0, 0 },
/* U+b14d */ { 0, 0, 0, 0, 0 },
/* U+b14e */ { 0, 0, 0, 0, 0 },
/* U+b14f */ { 0, 0, 0, 0, 0 },
/* U+b150 */ { 0, 0, 0, 0, 0 },
/* U+b151 */ { 0, 0, 0, 0, 0 },
/* U+b152 */ { 0, 0, 0, 0, 0 },
/* U+b153 */ { 0, 0, 0, 0, 0 },
/* U+b154 */ { 0, 0, 0, 0, 0 },
/* U+b155 */ { 0, 0, 0, 0, 0 },
/* U+b156 */ { 0, 0, 0, 0, 0 },
/* U+b157 */ { 0, 0, 0, 0, 0 },
/* U+b158 */ { 0, 0, 0, 0, 0 },
/* U+b159 */ { 0, 0, 0, 0, 0 },
/* U+b15a */ { 0, 0, 0, 0, 0 },
/* U+b15b */ { 0, 0, 0, 0, 0 },
/* U+b15c */ { 0, 0, 0, 0, 0 },
/* U+b15d */ { 0, 0, 0, 0, 0 },
/* U+b15e */ { 0, 0, 0, 0, 0 },
/* U+b15f */ { 0, 0, 0, 0, 0 },
/* U+b160 */ { 0, 0, 0, 0, 0 },
/* U+b161 */ { 0, 0, 0, 0, 0 },
/* U+b162 */ { 0, 0, 0, 0, 0 },
/* U+b163 */ { 0, 0, 0, 0, 0 },
/* U+b164 */ { 0, 0, 0, 0, 0 },
/* U+b165 */ { 0, 0, 0, 0, 0 },
/* U+b166 */ { 0, 0, 0, 0, 0 },
/* U+b167 */ { 0, 0, 0, 0, 0 },
/* U+b168 */ { 0, 0, 0, 0, 0 },
/* U+b169 */ { 0, 0, 0, 0, 0 },
/* U+b16a */ { 0, 0, 0, 0, 0 },
/* U+b16b */ { 0, 0, 0, 0, 0 },
/* U+b16c */ { 0, 0, 0, 0, 0 },
/* U+b16d */ { 0, 0, 0, 0, 0 },
/* U+b16e */ { 0, 0, 0, 0, 0 },
/* U+b16f */ { 0, 0, 0, 0, 0 },
/* U+b170 */ { 0, 0, 0, 0, 0 },
/* U+b171 */ { 0, 0, 0, 0, 0 },
/* U+b172 */ { 0, 0, 0, 0, 0 },
/* U+b173 */ { 0, 0, 0, 0, 0 },
/* U+b174 */ { 0, 0, 0, 0, 0 },
/* U+b175 */ { 0, 0, 0, 0, 0 },
/* U+b176 */ { 0, 0, 0, 0, 0 },
/* U+b177 */ { 0, 0, 0, 0, 0 },
/* U+b178 */ { 0, 0, 0, 0, 0 },
/* U+b179 */ { 0, 0, 0, 0, 0 },
/* U+b17a */ { 0, 0, 0, 0, 0 },
/* U+b17b */ { 0, 0, 0, 0, 0 },
/* U+b17c */ { 0, 0, 0, 0, 0 },
/* U+b17d */ { 0, 0, 0, 0, 0 },
/* U+b17e */ { 0, 0, 0, 0, 0 },
/* U+b17f */ { 0, 0, 0, 0, 0 },
/* U+b180 */ { 0, 0, 0, 0, 0 },
/* U+b181 */ { 0, 0, 0, 0, 0 },
/* U+b182 */ { 0, 0, 0, 0, 0 },
/* U+b183 */ { 0, 0, 0, 0, 0 },
/* U+b184 */ { 0, 0, 0, 0, 0 },
/* U+b185 */ { 0, 0, 0, 0, 0 },
/* U+b186 */ { 0, 0, 0, 0, 0 },
/* U+b187 */ { 0, 0, 0, 0, 0 },
/* U+b188 */ { 0, 0, 0, 0, 0 },
/* U+b189 */ { 0, 0, 0, 0, 0 },
/* U+b18a */ { 0, 0, 0, 0, 0 },
/* U+b18b */ { 0, 0, 0, 0, 0 },
/* U+b18c */ { 0, 0, 0, 0, 0 },
/* U+b18d */ { 0, 0, 0, 0, 0 },
/* U+b18e */ { 0, 0, 0, 0, 0 },
/* U+b18f */ { 0, 0, 0, 0, 0 },
/* U+b190 */ { 0, 0, 0, 0, 0 },
/* U+b191 */ { 0, 0, 0, 0, 0 },
/* U+b192 */ { 0, 0, 0, 0, 0 },
/* U+b193 */ { 0, 0, 0, 0, 0 },
/* U+b194 */ { 0, 0, 0, 0, 0 },
/* U+b195 */ { 0, 0, 0, 0, 0 },
/* U+b196 */ { 0, 0, 0, 0, 0 },
/* U+b197 */ { 0, 0, 0, 0, 0 },
/* U+b198 */ { 0, 0, 0, 0, 0 },
/* U+b199 */ { 0, 0, 0, 0, 0 },
/* U+b19a */ { 0, 0, 0, 0, 0 },
/* U+b19b */ { 0, 0, 0, 0, 0 },
/* U+b19c */ { 0, 0, 0, 0, 0 },
/* U+b19d */ { 0, 0, 0, 0, 0 },
/* U+b19e */ { 0, 0, 0, 0, 0 },
/* U+b19f */ { 0, 0, 0, 0, 0 },
/* U+b1a0 */ { 0, 0, 0, 0, 0 },
/* U+b1a1 */ { 0, 0, 0, 0, 0 },
/* U+b1a2 */ { 0, 0, 0, 0, 0 },
/* U+b1a3 */ { 0, 0, 0, 0, 0 },
/* U+b1a4 */ { 0, 0, 0, 0, 0 },
/* U+b1a5 */ { 0, 0, 0, 0, 0 },
/* U+b1a6 */ { 0, 0, 0, 0, 0 },
/* U+b1a7 */ { 0, 0, 0, 0, 0 },
/* U+b1a8 */ { 0, 0, 0, 0, 0 },
/* U+b1a9 */ { 0, 0, 0, 0, 0 },
/* U+b1aa */ { 0, 0, 0, 0, 0 },
/* U+b1ab */ { 0, 0, 0, 0, 0 },
/* U+b1ac */ { 0, 0, 0, 0, 0 },
/* U+b1ad */ { 0, 0, 0, 0, 0 },
/* U+b1ae */ { 0, 0, 0, 0, 0 },
/* U+b1af */ { 0, 0, 0, 0, 0 },
/* U+b1b0 */ { 0, 0, 0, 0, 0 },
/* U+b1b1 */ { 0, 0, 0, 0, 0 },
/* U+b1b2 */ { 0, 0, 0, 0, 0 },
/* U+b1b3 */ { 0, 0, 0, 0, 0 },
/* U+b1b4 */ { 0, 0, 0, 0, 0 },
/* U+b1b5 */ { 0, 0, 0, 0, 0 },
/* U+b1b6 */ { 0, 0, 0, 0, 0 },
/* U+b1b7 */ { 0, 0, 0, 0, 0 },
/* U+b1b8 */ { 0, 0, 0, 0, 0 },
/* U+b1b9 */ { 0, 0, 0, 0, 0 },
/* U+b1ba */ { 0, 0, 0, 0, 0 },
/* U+b1bb */ { 0, 0, 0, 0, 0 },
/* U+b1bc */ { 0, 0, 0, 0, 0 },
/* U+b1bd */ { 0, 0, 0, 0, 0 },
/* U+b1be */ { 0, 0, 0, 0, 0 },
/* U+b1bf */ { 0, 0, 0, 0, 0 },
/* U+b1c0 */ { 0, 0, 0, 0, 0 },
/* U+b1c1 */ { 0, 0, 0, 0, 0 },
/* U+b1c2 */ { 0, 0, 0, 0, 0 },
/* U+b1c3 */ { 0, 0, 0, 0, 0 },
/* U+b1c4 */ { 0, 0, 0, 0, 0 },
/* U+b1c5 */ { 0, 0, 0, 0, 0 },
/* U+b1c6 */ { 0, 0, 0, 0, 0 },
/* U+b1c7 */ { 0, 0, 0, 0, 0 },
/* U+b1c8 */ { 0, 0, 0, 0, 0 },
/* U+b1c9 */ { 0, 0, 0, 0, 0 },
/* U+b1ca */ { 0, 0, 0, 0, 0 },
/* U+b1cb */ { 0, 0, 0, 0, 0 },
/* U+b1cc */ { 0, 0, 0, 0, 0 },
/* U+b1cd */ { 0, 0, 0, 0, 0 },
/* U+b1ce */ { 0, 0, 0, 0, 0 },
/* U+b1cf */ { 0, 0, 0, 0, 0 },
/* U+b1d0 */ { 0, 0, 0, 0, 0 },
/* U+b1d1 */ { 0, 0, 0, 0, 0 },
/* U+b1d2 */ { 0, 0, 0, 0, 0 },
/* U+b1d3 */ { 0, 0, 0, 0, 0 },
/* U+b1d4 */ { 0, 0, 0, 0, 0 },
/* U+b1d5 */ { 0, 0, 0, 0, 0 },
/* U+b1d6 */ { 0, 0, 0, 0, 0 },
/* U+b1d7 */ { 0, 0, 0, 0, 0 },
/* U+b1d8 */ { 0, 0, 0, 0, 0 },
/* U+b1d9 */ { 0, 0, 0, 0, 0 },
/* U+b1da */ { 0, 0, 0, 0, 0 },
/* U+b1db */ { 0, 0, 0, 0, 0 },
/* U+b1dc */ { 0, 0, 0, 0, 0 },
/* U+b1dd */ { 0, 0, 0, 0, 0 },
/* U+b1de */ { 0, 0, 0, 0, 0 },
/* U+b1df */ { 0, 0, 0, 0, 0 },
/* U+b1e0 */ { 0, 0, 0, 0, 0 },
/* U+b1e1 */ { 0, 0, 0, 0, 0 },
/* U+b1e2 */ { 0, 0, 0, 0, 0 },
/* U+b1e3 */ { 0, 0, 0, 0, 0 },
/* U+b1e4 */ { 0, 0, 0, 0, 0 },
/* U+b1e5 */ { 0, 0, 0, 0, 0 },
/* U+b1e6 */ { 0, 0, 0, 0, 0 },
/* U+b1e7 */ { 0, 0, 0, 0, 0 },
/* U+b1e8 */ { 0, 0, 0, 0, 0 },
/* U+b1e9 */ { 0, 0, 0, 0, 0 },
/* U+b1ea */ { 0, 0, 0, 0, 0 },
/* U+b1eb */ { 0, 0, 0, 0, 0 },
/* U+b1ec */ { 0, 0, 0, 0, 0 },
/* U+b1ed */ { 0, 0, 0, 0, 0 },
/* U+b1ee */ { 0, 0, 0, 0, 0 },
/* U+b1ef */ { 0, 0, 0, 0, 0 },
/* U+b1f0 */ { 0, 0, 0, 0, 0 },
/* U+b1f1 */ { 0, 0, 0, 0, 0 },
/* U+b1f2 */ { 0, 0, 0, 0, 0 },
/* U+b1f3 */ { 0, 0, 0, 0, 0 },
/* U+b1f4 */ { 0, 0, 0, 0, 0 },
/* U+b1f5 */ { 0, 0, 0, 0, 0 },
/* U+b1f6 */ { 0, 0, 0, 0, 0 },
/* U+b1f7 */ { 0, 0, 0, 0, 0 },
/* U+b1f8 */ { 0, 0, 0, 0, 0 },
/* U+b1f9 */ { 0, 0, 0, 0, 0 },
/* U+b1fa */ { 0, 0, 0, 0, 0 },
/* U+b1fb */ { 0, 0, 0, 0, 0 },
/* U+b1fc */ { 0, 0, 0, 0, 0 },
/* U+b1fd */ { 0, 0, 0, 0, 0 },
/* U+b1fe */ { 0, 0, 0, 0, 0 },
/* U+b1ff */ { 0, 0, 0, 0, 0 },
/* U+b200 */ { 0, 0, 0, 0, 0 },
/* U+b201 */ { 0, 0, 0, 0, 0 },
/* U+b202 */ { 0, 0, 0, 0, 0 },
/* U+b203 */ { 0, 0, 0, 0, 0 },
/* U+b204 */ { 0, 0, 0, 0, 0 },
/* U+b205 */ { 0, 0, 0, 0, 0 },
/* U+b206 */ { 0, 0, 0, 0, 0 },
/* U+b207 */ { 0, 0, 0, 0, 0 },
/* U+b208 */ { 0, 0, 0, 0, 0 },
/* U+b209 */ { 0, 0, 0, 0, 0 },
/* U+b20a */ { 0, 0, 0, 0, 0 },
/* U+b20b */ { 0, 0, 0, 0, 0 },
/* U+b20c */ { 0, 0, 0, 0, 0 },
/* U+b20d */ { 0, 0, 0, 0, 0 },
/* U+b20e */ { 0, 0, 0, 0, 0 },
/* U+b20f */ { 0, 0, 0, 0, 0 },
/* U+b210 */ { 0, 0, 0, 0, 0 },
/* U+b211 */ { 0, 0, 0, 0, 0 },
/* U+b212 */ { 0, 0, 0, 0, 0 },
/* U+b213 */ { 0, 0, 0, 0, 0 },
/* U+b214 */ { 0, 0, 0, 0, 0 },
/* U+b215 */ { 0, 0, 0, 0, 0 },
/* U+b216 */ { 0, 0, 0, 0, 0 },
/* U+b217 */ { 0, 0, 0, 0, 0 },
/* U+b218 */ { 0, 0, 0, 0, 0 },
/* U+b219 */ { 0, 0, 0, 0, 0 },
/* U+b21a */ { 0, 0, 0, 0, 0 },
/* U+b21b */ { 0, 0, 0, 0, 0 },
/* U+b21c */ { 0, 0, 0, 0, 0 },
/* U+b21d */ { 0, 0, 0, 0, 0 },
/* U+b21e */ { 0, 0, 0, 0, 0 },
/* U+b21f */ { 0, 0, 0, 0, 0 },
/* U+b220 */ { 0, 0, 0, 0, 0 },
/* U+b221 */ { 0, 0, 0, 0, 0 },
/* U+b222 */ { 0, 0, 0, 0, 0 },
/* U+b223 */ { 0, 0, 0, 0, 0 },
/* U+b224 */ { 0, 0, 0, 0, 0 },
/* U+b225 */ { 0, 0, 0, 0, 0 },
/* U+b226 */ { 0, 0, 0, 0, 0 },
/* U+b227 */ { 0, 0, 0, 0, 0 },
/* U+b228 */ { 0, 0, 0, 0, 0 },
/* U+b229 */ { 0, 0, 0, 0, 0 },
/* U+b22a */ { 0, 0, 0, 0, 0 },
/* U+b22b */ { 0, 0, 0, 0, 0 },
/* U+b22c */ { 0, 0, 0, 0, 0 },
/* U+b22d */ { 0, 0, 0, 0, 0 },
/* U+b22e */ { 0, 0, 0, 0, 0 },
/* U+b22f */ { 0, 0, 0, 0, 0 },
/* U+b230 */ { 0, 0, 0, 0, 0 },
/* U+b231 */ { 0, 0, 0, 0, 0 },
/* U+b232 */ { 0, 0, 0, 0, 0 },
/* U+b233 */ { 0, 0, 0, 0, 0 },
/* U+b234 */ { 0, 0, 0, 0, 0 },
/* U+b235 */ { 0, 0, 0, 0, 0 },
/* U+b236 */ { 0, 0, 0, 0, 0 },
/* U+b237 */ { 0, 0, 0, 0, 0 },
/* U+b238 */ { 0, 0, 0, 0, 0 },
/* U+b239 */ { 0, 0, 0, 0, 0 },
/* U+b23a */ { 0, 0, 0, 0, 0 },
/* U+b23b */ { 0, 0, 0, 0, 0 },
/* U+b23c */ { 0, 0, 0, 0, 0 },
/* U+b23d */ { 0, 0, 0, 0, 0 },
/* U+b23e */ { 0, 0, 0, 0, 0 },
/* U+b23f */ { 0, 0, 0, 0, 0 },
/* U+b240 */ { 0, 0, 0, 0, 0 },
/* U+b241 */ { 0, 0, 0, 0, 0 },
/* U+b242 */ { 0, 0, 0, 0, 0 },
/* U+b243 */ { 0, 0, 0, 0, 0 },
/* U+b244 */ { 0, 0, 0, 0, 0 },
/* U+b245 */ { 0, 0, 0, 0, 0 },
/* U+b246 */ { 0, 0, 0, 0, 0 },
/* U+b247 */ { 0, 0, 0, 0, 0 },
/* U+b248 */ { 0, 0, 0, 0, 0 },
/* U+b249 */ { 0, 0, 0, 0, 0 },
/* U+b24a */ { 0, 0, 0, 0, 0 },
/* U+b24b */ { 0, 0, 0, 0, 0 },
/* U+b24c */ { 0, 0, 0, 0, 0 },
/* U+b24d */ { 0, 0, 0, 0, 0 },
/* U+b24e */ { 0, 0, 0, 0, 0 },
/* U+b24f */ { 0, 0, 0, 0, 0 },
/* U+b250 */ { 0, 0, 0, 0, 0 },
/* U+b251 */ { 0, 0, 0, 0, 0 },
/* U+b252 */ { 0, 0, 0, 0, 0 },
/* U+b253 */ { 0, 0, 0, 0, 0 },
/* U+b254 */ { 0, 0, 0, 0, 0 },
/* U+b255 */ { 0, 0, 0, 0, 0 },
/* U+b256 */ { 0, 0, 0, 0, 0 },
/* U+b257 */ { 0, 0, 0, 0, 0 },
/* U+b258 */ { 0, 0, 0, 0, 0 },
/* U+b259 */ { 0, 0, 0, 0, 0 },
/* U+b25a */ { 0, 0, 0, 0, 0 },
/* U+b25b */ { 0, 0, 0, 0, 0 },
/* U+b25c */ { 0, 0, 0, 0, 0 },
/* U+b25d */ { 0, 0, 0, 0, 0 },
/* U+b25e */ { 0, 0, 0, 0, 0 },
/* U+b25f */ { 0, 0, 0, 0, 0 },
/* U+b260 */ { 0, 0, 0, 0, 0 },
/* U+b261 */ { 0, 0, 0, 0, 0 },
/* U+b262 */ { 0, 0, 0, 0, 0 },
/* U+b263 */ { 0, 0, 0, 0, 0 },
/* U+b264 */ { 0, 0, 0, 0, 0 },
/* U+b265 */ { 0, 0, 0, 0, 0 },
/* U+b266 */ { 0, 0, 0, 0, 0 },
/* U+b267 */ { 0, 0, 0, 0, 0 },
/* U+b268 */ { 0, 0, 0, 0, 0 },
/* U+b269 */ { 0, 0, 0, 0, 0 },
/* U+b26a */ { 0, 0, 0, 0, 0 },
/* U+b26b */ { 0, 0, 0, 0, 0 },
/* U+b26c */ { 0, 0, 0, 0, 0 },
/* U+b26d */ { 0, 0, 0, 0, 0 },
/* U+b26e */ { 0, 0, 0, 0, 0 },
/* U+b26f */ { 0, 0, 0, 0, 0 },
/* U+b270 */ { 0, 0, 0, 0, 0 },
/* U+b271 */ { 0, 0, 0, 0, 0 },
/* U+b272 */ { 0, 0, 0, 0, 0 },
/* U+b273 */ { 0, 0, 0, 0, 0 },
/* U+b274 */ { 0, 0, 0, 0, 0 },
/* U+b275 */ { 0, 0, 0, 0, 0 },
/* U+b276 */ { 0, 0, 0, 0, 0 },
/* U+b277 */ { 0, 0, 0, 0, 0 },
/* U+b278 */ { 0, 0, 0, 0, 0 },
/* U+b279 */ { 0, 0, 0, 0, 0 },
/* U+b27a */ { 0, 0, 0, 0, 0 },
/* U+b27b */ { 0, 0, 0, 0, 0 },
/* U+b27c */ { 0, 0, 0, 0, 0 },
/* U+b27d */ { 0, 0, 0, 0, 0 },
/* U+b27e */ { 0, 0, 0, 0, 0 },
/* U+b27f */ { 0, 0, 0, 0, 0 },
/* U+b280 */ { 0, 0, 0, 0, 0 },
/* U+b281 */ { 0, 0, 0, 0, 0 },
/* U+b282 */ { 0, 0, 0, 0, 0 },
/* U+b283 */ { 0, 0, 0, 0, 0 },
/* U+b284 */ { 0, 0, 0, 0, 0 },
/* U+b285 */ { 0, 0, 0, 0, 0 },
/* U+b286 */ { 0, 0, 0, 0, 0 },
/* U+b287 */ { 0, 0, 0, 0, 0 },
/* U+b288 */ { 0, 0, 0, 0, 0 },
/* U+b289 */ { 0, 0, 0, 0, 0 },
/* U+b28a */ { 0, 0, 0, 0, 0 },
/* U+b28b */ { 0, 0, 0, 0, 0 },
/* U+b28c */ { 0, 0, 0, 0, 0 },
/* U+b28d */ { 0, 0, 0, 0, 0 },
/* U+b28e */ { 0, 0, 0, 0, 0 },
/* U+b28f */ { 0, 0, 0, 0, 0 },
/* U+b290 */ { 0, 0, 0, 0, 0 },
/* U+b291 */ { 0, 0, 0, 0, 0 },
/* U+b292 */ { 0, 0, 0, 0, 0 },
/* U+b293 */ { 0, 0, 0, 0, 0 },
/* U+b294 */ { 0, 0, 0, 0, 0 },
/* U+b295 */ { 0, 0, 0, 0, 0 },
/* U+b296 */ { 0, 0, 0, 0, 0 },
/* U+b297 */ { 0, 0, 0, 0, 0 },
/* U+b298 */ { 0, 0, 0, 0, 0 },
/* U+b299 */ { 0, 0, 0, 0, 0 },
/* U+b29a */ { 0, 0, 0, 0, 0 },
/* U+b29b */ { 0, 0, 0, 0, 0 },
/* U+b29c */ { 0, 0, 0, 0, 0 },
/* U+b29d */ { 0, 0, 0, 0, 0 },
/* U+b29e */ { 0, 0, 0, 0, 0 },
/* U+b29f */ { 0, 0, 0, 0, 0 },
/* U+b2a0 */ { 0, 0, 0, 0, 0 },
/* U+b2a1 */ { 0, 0, 0, 0, 0 },
/* U+b2a2 */ { 0, 0, 0, 0, 0 },
/* U+b2a3 */ { 0, 0, 0, 0, 0 },
/* U+b2a4 */ { 0, 0, 0, 0, 0 },
/* U+b2a5 */ { 0, 0, 0, 0, 0 },
/* U+b2a6 */ { 0, 0, 0, 0, 0 },
/* U+b2a7 */ { 0, 0, 0, 0, 0 },
/* U+b2a8 */ { 0, 0, 0, 0, 0 },
/* U+b2a9 */ { 0, 0, 0, 0, 0 },
/* U+b2aa */ { 0, 0, 0, 0, 0 },
/* U+b2ab */ { 0, 0, 0, 0, 0 },
/* U+b2ac */ { 0, 0, 0, 0, 0 },
/* U+b2ad */ { 0, 0, 0, 0, 0 },
/* U+b2ae */ { 0, 0, 0, 0, 0 },
/* U+b2af */ { 0, 0, 0, 0, 0 },
/* U+b2b0 */ { 0, 0, 0, 0, 0 },
/* U+b2b1 */ { 0, 0, 0, 0, 0 },
/* U+b2b2 */ { 0, 0, 0, 0, 0 },
/* U+b2b3 */ { 0, 0, 0, 0, 0 },
/* U+b2b4 */ { 0, 0, 0, 0, 0 },
/* U+b2b5 */ { 0, 0, 0, 0, 0 },
/* U+b2b6 */ { 0, 0, 0, 0, 0 },
/* U+b2b7 */ { 0, 0, 0, 0, 0 },
/* U+b2b8 */ { 0, 0, 0, 0, 0 },
/* U+b2b9 */ { 0, 0, 0, 0, 0 },
/* U+b2ba */ { 0, 0, 0, 0, 0 },
/* U+b2bb */ { 0, 0, 0, 0, 0 },
/* U+b2bc */ { 0, 0, 0, 0, 0 },
/* U+b2bd */ { 0, 0, 0, 0, 0 },
/* U+b2be */ { 0, 0, 0, 0, 0 },
/* U+b2bf */ { 0, 0, 0, 0, 0 },
/* U+b2c0 */ { 0, 0, 0, 0, 0 },
/* U+b2c1 */ { 0, 0, 0, 0, 0 },
/* U+b2c2 */ { 0, 0, 0, 0, 0 },
/* U+b2c3 */ { 0, 0, 0, 0, 0 },
/* U+b2c4 */ { 0, 0, 0, 0, 0 },
/* U+b2c5 */ { 0, 0, 0, 0, 0 },
/* U+b2c6 */ { 0, 0, 0, 0, 0 },
/* U+b2c7 */ { 0, 0, 0, 0, 0 },
/* U+b2c8 */ { 0, 0, 0, 0, 0 },
/* U+b2c9 */ { 0, 0, 0, 0, 0 },
/* U+b2ca */ { 0, 0, 0, 0, 0 },
/* U+b2cb */ { 0, 0, 0, 0, 0 },
/* U+b2cc */ { 0, 0, 0, 0, 0 },
/* U+b2cd */ { 0, 0, 0, 0, 0 },
/* U+b2ce */ { 0, 0, 0, 0, 0 },
/* U+b2cf */ { 0, 0, 0, 0, 0 },
/* U+b2d0 */ { 0, 0, 0, 0, 0 },
/* U+b2d1 */ { 0, 0, 0, 0, 0 },
/* U+b2d2 */ { 0, 0, 0, 0, 0 },
/* U+b2d3 */ { 0, 0, 0, 0, 0 },
/* U+b2d4 */ { 0, 0, 0, 0, 0 },
/* U+b2d5 */ { 0, 0, 0, 0, 0 },
/* U+b2d6 */ { 0, 0, 0, 0, 0 },
/* U+b2d7 */ { 0, 0, 0, 0, 0 },
/* U+b2d8 */ { 0, 0, 0, 0, 0 },
/* U+b2d9 */ { 0, 0, 0, 0, 0 },
/* U+b2da */ { 0, 0, 0, 0, 0 },
/* U+b2db */ { 0, 0, 0, 0, 0 },
/* U+b2dc */ { 0, 0, 0, 0, 0 },
/* U+b2dd */ { 0, 0, 0, 0, 0 },
/* U+b2de */ { 0, 0, 0, 0, 0 },
/* U+b2df */ { 0, 0, 0, 0, 0 },
/* U+b2e0 */ { 0, 0, 0, 0, 0 },
/* U+b2e1 */ { 0, 0, 0, 0, 0 },
/* U+b2e2 */ { 0, 0, 0, 0, 0 },
/* U+b2e3 */ { 0, 0, 0, 0, 0 },
/* U+b2e4 */ { 0, 0, 0, 0, 0 },
/* U+b2e5 */ { 0, 0, 0, 0, 0 },
/* U+b2e6 */ { 0, 0, 0, 0, 0 },
/* U+b2e7 */ { 0, 0, 0, 0, 0 },
/* U+b2e8 */ { 0, 0, 0, 0, 0 },
/* U+b2e9 */ { 0, 0, 0, 0, 0 },
/* U+b2ea */ { 0, 0, 0, 0, 0 },
/* U+b2eb */ { 0, 0, 0, 0, 0 },
/* U+b2ec */ { 0, 0, 0, 0, 0 },
/* U+b2ed */ { 0, 0, 0, 0, 0 },
/* U+b2ee */ { 0, 0, 0, 0, 0 },
/* U+b2ef */ { 0, 0, 0, 0, 0 },
/* U+b2f0 */ { 0, 0, 0, 0, 0 },
/* U+b2f1 */ { 0, 0, 0, 0, 0 },
/* U+b2f2 */ { 0, 0, 0, 0, 0 },
/* U+b2f3 */ { 0, 0, 0, 0, 0 },
/* U+b2f4 */ { 0, 0, 0, 0, 0 },
/* U+b2f5 */ { 0, 0, 0, 0, 0 },
/* U+b2f6 */ { 0, 0, 0, 0, 0 },
/* U+b2f7 */ { 0, 0, 0, 0, 0 },
/* U+b2f8 */ { 0, 0, 0, 0, 0 },
/* U+b2f9 */ { 0, 0, 0, 0, 0 },
/* U+b2fa */ { 0, 0, 0, 0, 0 },
/* U+b2fb */ { 0, 0, 0, 0, 0 },
/* U+b2fc */ { 0, 0, 0, 0, 0 },
/* U+b2fd */ { 0, 0, 0, 0, 0 },
/* U+b2fe */ { 0, 0, 0, 0, 0 },
/* U+b2ff */ { 0, 0, 0, 0, 0 },
/* U+b300 */ { 0, 0, 0, 0, 0 },
/* U+b301 */ { 0, 0, 0, 0, 0 },
/* U+b302 */ { 0, 0, 0, 0, 0 },
/* U+b303 */ { 0, 0, 0, 0, 0 },
/* U+b304 */ { 0, 0, 0, 0, 0 },
/* U+b305 */ { 0, 0, 0, 0, 0 },
/* U+b306 */ { 0, 0, 0, 0, 0 },
/* U+b307 */ { 0, 0, 0, 0, 0 },
/* U+b308 */ { 0, 0, 0, 0, 0 },
/* U+b309 */ { 0, 0, 0, 0, 0 },
/* U+b30a */ { 0, 0, 0, 0, 0 },
/* U+b30b */ { 0, 0, 0, 0, 0 },
/* U+b30c */ { 0, 0, 0, 0, 0 },
/* U+b30d */ { 0, 0, 0, 0, 0 },
/* U+b30e */ { 0, 0, 0, 0, 0 },
/* U+b30f */ { 0, 0, 0, 0, 0 },
/* U+b310 */ { 0, 0, 0, 0, 0 },
/* U+b311 */ { 0, 0, 0, 0, 0 },
/* U+b312 */ { 0, 0, 0, 0, 0 },
/* U+b313 */ { 0, 0, 0, 0, 0 },
/* U+b314 */ { 0, 0, 0, 0, 0 },
/* U+b315 */ { 0, 0, 0, 0, 0 },
/* U+b316 */ { 0, 0, 0, 0, 0 },
/* U+b317 */ { 0, 0, 0, 0, 0 },
/* U+b318 */ { 0, 0, 0, 0, 0 },
/* U+b319 */ { 0, 0, 0, 0, 0 },
/* U+b31a */ { 0, 0, 0, 0, 0 },
/* U+b31b */ { 0, 0, 0, 0, 0 },
/* U+b31c */ { 0, 0, 0, 0, 0 },
/* U+b31d */ { 0, 0, 0, 0, 0 },
/* U+b31e */ { 0, 0, 0, 0, 0 },
/* U+b31f */ { 0, 0, 0, 0, 0 },
/* U+b320 */ { 0, 0, 0, 0, 0 },
/* U+b321 */ { 0, 0, 0, 0, 0 },
/* U+b322 */ { 0, 0, 0, 0, 0 },
/* U+b323 */ { 0, 0, 0, 0, 0 },
/* U+b324 */ { 0, 0, 0, 0, 0 },
/* U+b325 */ { 0, 0, 0, 0, 0 },
/* U+b326 */ { 0, 0, 0, 0, 0 },
/* U+b327 */ { 0, 0, 0, 0, 0 },
/* U+b328 */ { 0, 0, 0, 0, 0 },
/* U+b329 */ { 0, 0, 0, 0, 0 },
/* U+b32a */ { 0, 0, 0, 0, 0 },
/* U+b32b */ { 0, 0, 0, 0, 0 },
/* U+b32c */ { 0, 0, 0, 0, 0 },
/* U+b32d */ { 0, 0, 0, 0, 0 },
/* U+b32e */ { 0, 0, 0, 0, 0 },
/* U+b32f */ { 0, 0, 0, 0, 0 },
/* U+b330 */ { 0, 0, 0, 0, 0 },
/* U+b331 */ { 0, 0, 0, 0, 0 },
/* U+b332 */ { 0, 0, 0, 0, 0 },
/* U+b333 */ { 0, 0, 0, 0, 0 },
/* U+b334 */ { 0, 0, 0, 0, 0 },
/* U+b335 */ { 0, 0, 0, 0, 0 },
/* U+b336 */ { 0, 0, 0, 0, 0 },
/* U+b337 */ { 0, 0, 0, 0, 0 },
/* U+b338 */ { 0, 0, 0, 0, 0 },
/* U+b339 */ { 0, 0, 0, 0, 0 },
/* U+b33a */ { 0, 0, 0, 0, 0 },
/* U+b33b */ { 0, 0, 0, 0, 0 },
/* U+b33c */ { 0, 0, 0, 0, 0 },
/* U+b33d */ { 0, 0, 0, 0, 0 },
/* U+b33e */ { 0, 0, 0, 0, 0 },
/* U+b33f */ { 0, 0, 0, 0, 0 },
/* U+b340 */ { 0, 0, 0, 0, 0 },
/* U+b341 */ { 0, 0, 0, 0, 0 },
/* U+b342 */ { 0, 0, 0, 0, 0 },
/* U+b343 */ { 0, 0, 0, 0, 0 },
/* U+b344 */ { 0, 0, 0, 0, 0 },
/* U+b345 */ { 0, 0, 0, 0, 0 },
/* U+b346 */ { 0, 0, 0, 0, 0 },
/* U+b347 */ { 0, 0, 0, 0, 0 },
/* U+b348 */ { 0, 0, 0, 0, 0 },
/* U+b349 */ { 0, 0, 0, 0, 0 },
/* U+b34a */ { 0, 0, 0, 0, 0 },
/* U+b34b */ { 0, 0, 0, 0, 0 },
/* U+b34c */ { 0, 0, 0, 0, 0 },
/* U+b34d */ { 0, 0, 0, 0, 0 },
/* U+b34e */ { 0, 0, 0, 0, 0 },
/* U+b34f */ { 0, 0, 0, 0, 0 },
/* U+b350 */ { 0, 0, 0, 0, 0 },
/* U+b351 */ { 0, 0, 0, 0, 0 },
/* U+b352 */ { 0, 0, 0, 0, 0 },
/* U+b353 */ { 0, 0, 0, 0, 0 },
/* U+b354 */ { 0, 0, 0, 0, 0 },
/* U+b355 */ { 0, 0, 0, 0, 0 },
/* U+b356 */ { 0, 0, 0, 0, 0 },
/* U+b357 */ { 0, 0, 0, 0, 0 },
/* U+b358 */ { 0, 0, 0, 0, 0 },
/* U+b359 */ { 0, 0, 0, 0, 0 },
/* U+b35a */ { 0, 0, 0, 0, 0 },
/* U+b35b */ { 0, 0, 0, 0, 0 },
/* U+b35c */ { 0, 0, 0, 0, 0 },
/* U+b35d */ { 0, 0, 0, 0, 0 },
/* U+b35e */ { 0, 0, 0, 0, 0 },
/* U+b35f */ { 0, 0, 0, 0, 0 },
/* U+b360 */ { 0, 0, 0, 0, 0 },
/* U+b361 */ { 0, 0, 0, 0, 0 },
/* U+b362 */ { 0, 0, 0, 0, 0 },
/* U+b363 */ { 0, 0, 0, 0, 0 },
/* U+b364 */ { 0, 0, 0, 0, 0 },
/* U+b365 */ { 0, 0, 0, 0, 0 },
/* U+b366 */ { 0, 0, 0, 0, 0 },
/* U+b367 */ { 0, 0, 0, 0, 0 },
/* U+b368 */ { 0, 0, 0, 0, 0 },
/* U+b369 */ { 0, 0, 0, 0, 0 },
/* U+b36a */ { 0, 0, 0, 0, 0 },
/* U+b36b */ { 0, 0, 0, 0, 0 },
/* U+b36c */ { 0, 0, 0, 0, 0 },
/* U+b36d */ { 0, 0, 0, 0, 0 },
/* U+b36e */ { 0, 0, 0, 0, 0 },
/* U+b36f */ { 0, 0, 0, 0, 0 },
/* U+b370 */ { 0, 0, 0, 0, 0 },
/* U+b371 */ { 0, 0, 0, 0, 0 },
/* U+b372 */ { 0, 0, 0, 0, 0 },
/* U+b373 */ { 0, 0, 0, 0, 0 },
/* U+b374 */ { 0, 0, 0, 0, 0 },
/* U+b375 */ { 0, 0, 0, 0, 0 },
/* U+b376 */ { 0, 0, 0, 0, 0 },
/* U+b377 */ { 0, 0, 0, 0, 0 },
/* U+b378 */ { 0, 0, 0, 0, 0 },
/* U+b379 */ { 0, 0, 0, 0, 0 },
/* U+b37a */ { 0, 0, 0, 0, 0 },
/* U+b37b */ { 0, 0, 0, 0, 0 },
/* U+b37c */ { 0, 0, 0, 0, 0 },
/* U+b37d */ { 0, 0, 0, 0, 0 },
/* U+b37e */ { 0, 0, 0, 0, 0 },
/* U+b37f */ { 0, 0, 0, 0, 0 },
/* U+b380 */ { 0, 0, 0, 0, 0 },
/* U+b381 */ { 0, 0, 0, 0, 0 },
/* U+b382 */ { 0, 0, 0, 0, 0 },
/* U+b383 */ { 0, 0, 0, 0, 0 },
/* U+b384 */ { 0, 0, 0, 0, 0 },
/* U+b385 */ { 0, 0, 0, 0, 0 },
/* U+b386 */ { 0, 0, 0, 0, 0 },
/* U+b387 */ { 0, 0, 0, 0, 0 },
/* U+b388 */ { 0, 0, 0, 0, 0 },
/* U+b389 */ { 0, 0, 0, 0, 0 },
/* U+b38a */ { 0, 0, 0, 0, 0 },
/* U+b38b */ { 0, 0, 0, 0, 0 },
/* U+b38c */ { 0, 0, 0, 0, 0 },
/* U+b38d */ { 0, 0, 0, 0, 0 },
/* U+b38e */ { 0, 0, 0, 0, 0 },
/* U+b38f */ { 0, 0, 0, 0, 0 },
/* U+b390 */ { 0, 0, 0, 0, 0 },
/* U+b391 */ { 0, 0, 0, 0, 0 },
/* U+b392 */ { 0, 0, 0, 0, 0 },
/* U+b393 */ { 0, 0, 0, 0, 0 },
/* U+b394 */ { 0, 0, 0, 0, 0 },
/* U+b395 */ { 0, 0, 0, 0, 0 },
/* U+b396 */ { 0, 0, 0, 0, 0 },
/* U+b397 */ { 0, 0, 0, 0, 0 },
/* U+b398 */ { 0, 0, 0, 0, 0 },
/* U+b399 */ { 0, 0, 0, 0, 0 },
/* U+b39a */ { 0, 0, 0, 0, 0 },
/* U+b39b */ { 0, 0, 0, 0, 0 },
/* U+b39c */ { 0, 0, 0, 0, 0 },
/* U+b39d */ { 0, 0, 0, 0, 0 },
/* U+b39e */ { 0, 0, 0, 0, 0 },
/* U+b39f */ { 0, 0, 0, 0, 0 },
/* U+b3a0 */ { 0, 0, 0, 0, 0 },
/* U+b3a1 */ { 0, 0, 0, 0, 0 },
/* U+b3a2 */ { 0, 0, 0, 0, 0 },
/* U+b3a3 */ { 0, 0, 0, 0, 0 },
/* U+b3a4 */ { 0, 0, 0, 0, 0 },
/* U+b3a5 */ { 0, 0, 0, 0, 0 },
/* U+b3a6 */ { 0, 0, 0, 0, 0 },
/* U+b3a7 */ { 0, 0, 0, 0, 0 },
/* U+b3a8 */ { 0, 0, 0, 0, 0 },
/* U+b3a9 */ { 0, 0, 0, 0, 0 },
/* U+b3aa */ { 0, 0, 0, 0, 0 },
/* U+b3ab */ { 0, 0, 0, 0, 0 },
/* U+b3ac */ { 0, 0, 0, 0, 0 },
/* U+b3ad */ { 0, 0, 0, 0, 0 },
/* U+b3ae */ { 0, 0, 0, 0, 0 },
/* U+b3af */ { 0, 0, 0, 0, 0 },
/* U+b3b0 */ { 0, 0, 0, 0, 0 },
/* U+b3b1 */ { 0, 0, 0, 0, 0 },
/* U+b3b2 */ { 0, 0, 0, 0, 0 },
/* U+b3b3 */ { 0, 0, 0, 0, 0 },
/* U+b3b4 */ { 0, 0, 0, 0, 0 },
/* U+b3b5 */ { 0, 0, 0, 0, 0 },
/* U+b3b6 */ { 0, 0, 0, 0, 0 },
/* U+b3b7 */ { 0, 0, 0, 0, 0 },
/* U+b3b8 */ { 0, 0, 0, 0, 0 },
/* U+b3b9 */ { 0, 0, 0, 0, 0 },
/* U+b3ba */ { 0, 0, 0, 0, 0 },
/* U+b3bb */ { 0, 0, 0, 0, 0 },
/* U+b3bc */ { 0, 0, 0, 0, 0 },
/* U+b3bd */ { 0, 0, 0, 0, 0 },
/* U+b3be */ { 0, 0, 0, 0, 0 },
/* U+b3bf */ { 0, 0, 0, 0, 0 },
/* U+b3c0 */ { 0, 0, 0, 0, 0 },
/* U+b3c1 */ { 0, 0, 0, 0, 0 },
/* U+b3c2 */ { 0, 0, 0, 0, 0 },
/* U+b3c3 */ { 0, 0, 0, 0, 0 },
/* U+b3c4 */ { 0, 0, 0, 0, 0 },
/* U+b3c5 */ { 0, 0, 0, 0, 0 },
/* U+b3c6 */ { 0, 0, 0, 0, 0 },
/* U+b3c7 */ { 0, 0, 0, 0, 0 },
/* U+b3c8 */ { 0, 0, 0, 0, 0 },
/* U+b3c9 */ { 0, 0, 0, 0, 0 },
/* U+b3ca */ { 0, 0, 0, 0, 0 },
/* U+b3cb */ { 0, 0, 0, 0, 0 },
/* U+b3cc */ { 0, 0, 0, 0, 0 },
/* U+b3cd */ { 0, 0, 0, 0, 0 },
/* U+b3ce */ { 0, 0, 0, 0, 0 },
/* U+b3cf */ { 0, 0, 0, 0, 0 },
/* U+b3d0 */ { 0, 0, 0, 0, 0 },
/* U+b3d1 */ { 0, 0, 0, 0, 0 },
/* U+b3d2 */ { 0, 0, 0, 0, 0 },
/* U+b3d3 */ { 0, 0, 0, 0, 0 },
/* U+b3d4 */ { 0, 0, 0, 0, 0 },
/* U+b3d5 */ { 0, 0, 0, 0, 0 },
/* U+b3d6 */ { 0, 0, 0, 0, 0 },
/* U+b3d7 */ { 0, 0, 0, 0, 0 },
/* U+b3d8 */ { 0, 0, 0, 0, 0 },
/* U+b3d9 */ { 0, 0, 0, 0, 0 },
/* U+b3da */ { 0, 0, 0, 0, 0 },
/* U+b3db */ { 0, 0, 0, 0, 0 },
/* U+b3dc */ { 0, 0, 0, 0, 0 },
/* U+b3dd */ { 0, 0, 0, 0, 0 },
/* U+b3de */ { 0, 0, 0, 0, 0 },
/* U+b3df */ { 0, 0, 0, 0, 0 },
/* U+b3e0 */ { 0, 0, 0, 0, 0 },
/* U+b3e1 */ { 0, 0, 0, 0, 0 },
/* U+b3e2 */ { 0, 0, 0, 0, 0 },
/* U+b3e3 */ { 0, 0, 0, 0, 0 },
/* U+b3e4 */ { 0, 0, 0, 0, 0 },
/* U+b3e5 */ { 0, 0, 0, 0, 0 },
/* U+b3e6 */ { 0, 0, 0, 0, 0 },
/* U+b3e7 */ { 0, 0, 0, 0, 0 },
/* U+b3e8 */ { 0, 0, 0, 0, 0 },
/* U+b3e9 */ { 0, 0, 0, 0, 0 },
/* U+b3ea */ { 0, 0, 0, 0, 0 },
/* U+b3eb */ { 0, 0, 0, 0, 0 },
/* U+b3ec */ { 0, 0, 0, 0, 0 },
/* U+b3ed */ { 0, 0, 0, 0, 0 },
/* U+b3ee */ { 0, 0, 0, 0, 0 },
/* U+b3ef */ { 0, 0, 0, 0, 0 },
/* U+b3f0 */ { 0, 0, 0, 0, 0 },
/* U+b3f1 */ { 0, 0, 0, 0, 0 },
/* U+b3f2 */ { 0, 0, 0, 0, 0 },
/* U+b3f3 */ { 0, 0, 0, 0, 0 },
/* U+b3f4 */ { 0, 0, 0, 0, 0 },
/* U+b3f5 */ { 0, 0, 0, 0, 0 },
/* U+b3f6 */ { 0, 0, 0, 0, 0 },
/* U+b3f7 */ { 0, 0, 0, 0, 0 },
/* U+b3f8 */ { 0, 0, 0, 0, 0 },
/* U+b3f9 */ { 0, 0, 0, 0, 0 },
/* U+b3fa */ { 0, 0, 0, 0, 0 },
/* U+b3fb */ { 0, 0, 0, 0, 0 },
/* U+b3fc */ { 0, 0, 0, 0, 0 },
/* U+b3fd */ { 0, 0, 0, 0, 0 },
/* U+b3fe */ { 0, 0, 0, 0, 0 },
/* U+b3ff */ { 0, 0, 0, 0, 0 },
/* U+b400 */ { 0, 0, 0, 0, 0 },
/* U+b401 */ { 0, 0, 0, 0, 0 },
/* U+b402 */ { 0, 0, 0, 0, 0 },
/* U+b403 */ { 0, 0, 0, 0, 0 },
/* U+b404 */ { 0, 0, 0, 0, 0 },
/* U+b405 */ { 0, 0, 0, 0, 0 },
/* U+b406 */ { 0, 0, 0, 0, 0 },
/* U+b407 */ { 0, 0, 0, 0, 0 },
/* U+b408 */ { 0, 0, 0, 0, 0 },
/* U+b409 */ { 0, 0, 0, 0, 0 },
/* U+b40a */ { 0, 0, 0, 0, 0 },
/* U+b40b */ { 0, 0, 0, 0, 0 },
/* U+b40c */ { 0, 0, 0, 0, 0 },
/* U+b40d */ { 0, 0, 0, 0, 0 },
/* U+b40e */ { 0, 0, 0, 0, 0 },
/* U+b40f */ { 0, 0, 0, 0, 0 },
/* U+b410 */ { 0, 0, 0, 0, 0 },
/* U+b411 */ { 0, 0, 0, 0, 0 },
/* U+b412 */ { 0, 0, 0, 0, 0 },
/* U+b413 */ { 0, 0, 0, 0, 0 },
/* U+b414 */ { 0, 0, 0, 0, 0 },
/* U+b415 */ { 0, 0, 0, 0, 0 },
/* U+b416 */ { 0, 0, 0, 0, 0 },
/* U+b417 */ { 0, 0, 0, 0, 0 },
/* U+b418 */ { 0, 0, 0, 0, 0 },
/* U+b419 */ { 0, 0, 0, 0, 0 },
/* U+b41a */ { 0, 0, 0, 0, 0 },
/* U+b41b */ { 0, 0, 0, 0, 0 },
/* U+b41c */ { 0, 0, 0, 0, 0 },
/* U+b41d */ { 0, 0, 0, 0, 0 },
/* U+b41e */ { 0, 0, 0, 0, 0 },
/* U+b41f */ { 0, 0, 0, 0, 0 },
/* U+b420 */ { 0, 0, 0, 0, 0 },
/* U+b421 */ { 0, 0, 0, 0, 0 },
/* U+b422 */ { 0, 0, 0, 0, 0 },
/* U+b423 */ { 0, 0, 0, 0, 0 },
/* U+b424 */ { 0, 0, 0, 0, 0 },
/* U+b425 */ { 0, 0, 0, 0, 0 },
/* U+b426 */ { 0, 0, 0, 0, 0 },
/* U+b427 */ { 0, 0, 0, 0, 0 },
/* U+b428 */ { 0, 0, 0, 0, 0 },
/* U+b429 */ { 0, 0, 0, 0, 0 },
/* U+b42a */ { 0, 0, 0, 0, 0 },
/* U+b42b */ { 0, 0, 0, 0, 0 },
/* U+b42c */ { 0, 0, 0, 0, 0 },
/* U+b42d */ { 0, 0, 0, 0, 0 },
/* U+b42e */ { 0, 0, 0, 0, 0 },
/* U+b42f */ { 0, 0, 0, 0, 0 },
/* U+b430 */ { 0, 0, 0, 0, 0 },
/* U+b431 */ { 0, 0, 0, 0, 0 },
/* U+b432 */ { 0, 0, 0, 0, 0 },
/* U+b433 */ { 0, 0, 0, 0, 0 },
/* U+b434 */ { 0, 0, 0, 0, 0 },
/* U+b435 */ { 0, 0, 0, 0, 0 },
/* U+b436 */ { 0, 0, 0, 0, 0 },
/* U+b437 */ { 0, 0, 0, 0, 0 },
/* U+b438 */ { 0, 0, 0, 0, 0 },
/* U+b439 */ { 0, 0, 0, 0, 0 },
/* U+b43a */ { 0, 0, 0, 0, 0 },
/* U+b43b */ { 0, 0, 0, 0, 0 },
/* U+b43c */ { 0, 0, 0, 0, 0 },
/* U+b43d */ { 0, 0, 0, 0, 0 },
/* U+b43e */ { 0, 0, 0, 0, 0 },
/* U+b43f */ { 0, 0, 0, 0, 0 },
/* U+b440 */ { 0, 0, 0, 0, 0 },
/* U+b441 */ { 0, 0, 0, 0, 0 },
/* U+b442 */ { 0, 0, 0, 0, 0 },
/* U+b443 */ { 0, 0, 0, 0, 0 },
/* U+b444 */ { 0, 0, 0, 0, 0 },
/* U+b445 */ { 0, 0, 0, 0, 0 },
/* U+b446 */ { 0, 0, 0, 0, 0 },
/* U+b447 */ { 0, 0, 0, 0, 0 },
/* U+b448 */ { 0, 0, 0, 0, 0 },
/* U+b449 */ { 0, 0, 0, 0, 0 },
/* U+b44a */ { 0, 0, 0, 0, 0 },
/* U+b44b */ { 0, 0, 0, 0, 0 },
/* U+b44c */ { 0, 0, 0, 0, 0 },
/* U+b44d */ { 0, 0, 0, 0, 0 },
/* U+b44e */ { 0, 0, 0, 0, 0 },
/* U+b44f */ { 0, 0, 0, 0, 0 },
/* U+b450 */ { 0, 0, 0, 0, 0 },
/* U+b451 */ { 0, 0, 0, 0, 0 },
/* U+b452 */ { 0, 0, 0, 0, 0 },
/* U+b453 */ { 0, 0, 0, 0, 0 },
/* U+b454 */ { 0, 0, 0, 0, 0 },
/* U+b455 */ { 0, 0, 0, 0, 0 },
/* U+b456 */ { 0, 0, 0, 0, 0 },
/* U+b457 */ { 0, 0, 0, 0, 0 },
/* U+b458 */ { 0, 0, 0, 0, 0 },
/* U+b459 */ { 0, 0, 0, 0, 0 },
/* U+b45a */ { 0, 0, 0, 0, 0 },
/* U+b45b */ { 0, 0, 0, 0, 0 },
/* U+b45c */ { 0, 0, 0, 0, 0 },
/* U+b45d */ { 0, 0, 0, 0, 0 },
/* U+b45e */ { 0, 0, 0, 0, 0 },
/* U+b45f */ { 0, 0, 0, 0, 0 },
/* U+b460 */ { 0, 0, 0, 0, 0 },
/* U+b461 */ { 0, 0, 0, 0, 0 },
/* U+b462 */ { 0, 0, 0, 0, 0 },
/* U+b463 */ { 0, 0, 0, 0, 0 },
/* U+b464 */ { 0, 0, 0, 0, 0 },
/* U+b465 */ { 0, 0, 0, 0, 0 },
/* U+b466 */ { 0, 0, 0, 0, 0 },
/* U+b467 */ { 0, 0, 0, 0, 0 },
/* U+b468 */ { 0, 0, 0, 0, 0 },
/* U+b469 */ { 0, 0, 0, 0, 0 },
/* U+b46a */ { 0, 0, 0, 0, 0 },
/* U+b46b */ { 0, 0, 0, 0, 0 },
/* U+b46c */ { 0, 0, 0, 0, 0 },
/* U+b46d */ { 0, 0, 0, 0, 0 },
/* U+b46e */ { 0, 0, 0, 0, 0 },
/* U+b46f */ { 0, 0, 0, 0, 0 },
/* U+b470 */ { 0, 0, 0, 0, 0 },
/* U+b471 */ { 0, 0, 0, 0, 0 },
/* U+b472 */ { 0, 0, 0, 0, 0 },
/* U+b473 */ { 0, 0, 0, 0, 0 },
/* U+b474 */ { 0, 0, 0, 0, 0 },
/* U+b475 */ { 0, 0, 0, 0, 0 },
/* U+b476 */ { 0, 0, 0, 0, 0 },
/* U+b477 */ { 0, 0, 0, 0, 0 },
/* U+b478 */ { 0, 0, 0, 0, 0 },
/* U+b479 */ { 0, 0, 0, 0, 0 },
/* U+b47a */ { 0, 0, 0, 0, 0 },
/* U+b47b */ { 0, 0, 0, 0, 0 },
/* U+b47c */ { 0, 0, 0, 0, 0 },
/* U+b47d */ { 0, 0, 0, 0, 0 },
/* U+b47e */ { 0, 0, 0, 0, 0 },
/* U+b47f */ { 0, 0, 0, 0, 0 },
/* U+b480 */ { 0, 0, 0, 0, 0 },
/* U+b481 */ { 0, 0, 0, 0, 0 },
/* U+b482 */ { 0, 0, 0, 0, 0 },
/* U+b483 */ { 0, 0, 0, 0, 0 },
/* U+b484 */ { 0, 0, 0, 0, 0 },
/* U+b485 */ { 0, 0, 0, 0, 0 },
/* U+b486 */ { 0, 0, 0, 0, 0 },
/* U+b487 */ { 0, 0, 0, 0, 0 },
/* U+b488 */ { 0, 0, 0, 0, 0 },
/* U+b489 */ { 0, 0, 0, 0, 0 },
/* U+b48a */ { 0, 0, 0, 0, 0 },
/* U+b48b */ { 0, 0, 0, 0, 0 },
/* U+b48c */ { 0, 0, 0, 0, 0 },
/* U+b48d */ { 0, 0, 0, 0, 0 },
/* U+b48e */ { 0, 0, 0, 0, 0 },
/* U+b48f */ { 0, 0, 0, 0, 0 },
/* U+b490 */ { 0, 0, 0, 0, 0 },
/* U+b491 */ { 0, 0, 0, 0, 0 },
/* U+b492 */ { 0, 0, 0, 0, 0 },
/* U+b493 */ { 0, 0, 0, 0, 0 },
/* U+b494 */ { 0, 0, 0, 0, 0 },
/* U+b495 */ { 0, 0, 0, 0, 0 },
/* U+b496 */ { 0, 0, 0, 0, 0 },
/* U+b497 */ { 0, 0, 0, 0, 0 },
/* U+b498 */ { 0, 0, 0, 0, 0 },
/* U+b499 */ { 0, 0, 0, 0, 0 },
/* U+b49a */ { 0, 0, 0, 0, 0 },
/* U+b49b */ { 0, 0, 0, 0, 0 },
/* U+b49c */ { 0, 0, 0, 0, 0 },
/* U+b49d */ { 0, 0, 0, 0, 0 },
/* U+b49e */ { 0, 0, 0, 0, 0 },
/* U+b49f */ { 0, 0, 0, 0, 0 },
/* U+b4a0 */ { 0, 0, 0, 0, 0 },
/* U+b4a1 */ { 0, 0, 0, 0, 0 },
/* U+b4a2 */ { 0, 0, 0, 0, 0 },
/* U+b4a3 */ { 0, 0, 0, 0, 0 },
/* U+b4a4 */ { 0, 0, 0, 0, 0 },
/* U+b4a5 */ { 0, 0, 0, 0, 0 },
/* U+b4a6 */ { 0, 0, 0, 0, 0 },
/* U+b4a7 */ { 0, 0, 0, 0, 0 },
/* U+b4a8 */ { 0, 0, 0, 0, 0 },
/* U+b4a9 */ { 0, 0, 0, 0, 0 },
/* U+b4aa */ { 0, 0, 0, 0, 0 },
/* U+b4ab */ { 0, 0, 0, 0, 0 },
/* U+b4ac */ { 0, 0, 0, 0, 0 },
/* U+b4ad */ { 0, 0, 0, 0, 0 },
/* U+b4ae */ { 0, 0, 0, 0, 0 },
/* U+b4af */ { 0, 0, 0, 0, 0 },
/* U+b4b0 */ { 0, 0, 0, 0, 0 },
/* U+b4b1 */ { 0, 0, 0, 0, 0 },
/* U+b4b2 */ { 0, 0, 0, 0, 0 },
/* U+b4b3 */ { 0, 0, 0, 0, 0 },
/* U+b4b4 */ { 0, 0, 0, 0, 0 },
/* U+b4b5 */ { 0, 0, 0, 0, 0 },
/* U+b4b6 */ { 0, 0, 0, 0, 0 },
/* U+b4b7 */ { 0, 0, 0, 0, 0 },
/* U+b4b8 */ { 0, 0, 0, 0, 0 },
/* U+b4b9 */ { 0, 0, 0, 0, 0 },
/* U+b4ba */ { 0, 0, 0, 0, 0 },
/* U+b4bb */ { 0, 0, 0, 0, 0 },
/* U+b4bc */ { 0, 0, 0, 0, 0 },
/* U+b4bd */ { 0, 0, 0, 0, 0 },
/* U+b4be */ { 0, 0, 0, 0, 0 },
/* U+b4bf */ { 0, 0, 0, 0, 0 },
/* U+b4c0 */ { 0, 0, 0, 0, 0 },
/* U+b4c1 */ { 0, 0, 0, 0, 0 },
/* U+b4c2 */ { 0, 0, 0, 0, 0 },
/* U+b4c3 */ { 0, 0, 0, 0, 0 },
/* U+b4c4 */ { 0, 0, 0, 0, 0 },
/* U+b4c5 */ { 0, 0, 0, 0, 0 },
/* U+b4c6 */ { 0, 0, 0, 0, 0 },
/* U+b4c7 */ { 0, 0, 0, 0, 0 },
/* U+b4c8 */ { 0, 0, 0, 0, 0 },
/* U+b4c9 */ { 0, 0, 0, 0, 0 },
/* U+b4ca */ { 0, 0, 0, 0, 0 },
/* U+b4cb */ { 0, 0, 0, 0, 0 },
/* U+b4cc */ { 0, 0, 0, 0, 0 },
/* U+b4cd */ { 0, 0, 0, 0, 0 },
/* U+b4ce */ { 0, 0, 0, 0, 0 },
/* U+b4cf */ { 0, 0, 0, 0, 0 },
/* U+b4d0 */ { 0, 0, 0, 0, 0 },
/* U+b4d1 */ { 0, 0, 0, 0, 0 },
/* U+b4d2 */ { 0, 0, 0, 0, 0 },
/* U+b4d3 */ { 0, 0, 0, 0, 0 },
/* U+b4d4 */ { 0, 0, 0, 0, 0 },
/* U+b4d5 */ { 0, 0, 0, 0, 0 },
/* U+b4d6 */ { 0, 0, 0, 0, 0 },
/* U+b4d7 */ { 0, 0, 0, 0, 0 },
/* U+b4d8 */ { 0, 0, 0, 0, 0 },
/* U+b4d9 */ { 0, 0, 0, 0, 0 },
/* U+b4da */ { 0, 0, 0, 0, 0 },
/* U+b4db */ { 0, 0, 0, 0, 0 },
/* U+b4dc */ { 0, 0, 0, 0, 0 },
/* U+b4dd */ { 0, 0, 0, 0, 0 },
/* U+b4de */ { 0, 0, 0, 0, 0 },
/* U+b4df */ { 0, 0, 0, 0, 0 },
/* U+b4e0 */ { 0, 0, 0, 0, 0 },
/* U+b4e1 */ { 0, 0, 0, 0, 0 },
/* U+b4e2 */ { 0, 0, 0, 0, 0 },
/* U+b4e3 */ { 0, 0, 0, 0, 0 },
/* U+b4e4 */ { 0, 0, 0, 0, 0 },
/* U+b4e5 */ { 0, 0, 0, 0, 0 },
/* U+b4e6 */ { 0, 0, 0, 0, 0 },
/* U+b4e7 */ { 0, 0, 0, 0, 0 },
/* U+b4e8 */ { 0, 0, 0, 0, 0 },
/* U+b4e9 */ { 0, 0, 0, 0, 0 },
/* U+b4ea */ { 0, 0, 0, 0, 0 },
/* U+b4eb */ { 0, 0, 0, 0, 0 },
/* U+b4ec */ { 0, 0, 0, 0, 0 },
/* U+b4ed */ { 0, 0, 0, 0, 0 },
/* U+b4ee */ { 0, 0, 0, 0, 0 },
/* U+b4ef */ { 0, 0, 0, 0, 0 },
/* U+b4f0 */ { 0, 0, 0, 0, 0 },
/* U+b4f1 */ { 0, 0, 0, 0, 0 },
/* U+b4f2 */ { 0, 0, 0, 0, 0 },
/* U+b4f3 */ { 0, 0, 0, 0, 0 },
/* U+b4f4 */ { 0, 0, 0, 0, 0 },
/* U+b4f5 */ { 0, 0, 0, 0, 0 },
/* U+b4f6 */ { 0, 0, 0, 0, 0 },
/* U+b4f7 */ { 0, 0, 0, 0, 0 },
/* U+b4f8 */ { 0, 0, 0, 0, 0 },
/* U+b4f9 */ { 0, 0, 0, 0, 0 },
/* U+b4fa */ { 0, 0, 0, 0, 0 },
/* U+b4fb */ { 0, 0, 0, 0, 0 },
/* U+b4fc */ { 0, 0, 0, 0, 0 },
/* U+b4fd */ { 0, 0, 0, 0, 0 },
/* U+b4fe */ { 0, 0, 0, 0, 0 },
/* U+b4ff */ { 0, 0, 0, 0, 0 },
/* U+b500 */ { 0, 0, 0, 0, 0 },
/* U+b501 */ { 0, 0, 0, 0, 0 },
/* U+b502 */ { 0, 0, 0, 0, 0 },
/* U+b503 */ { 0, 0, 0, 0, 0 },
/* U+b504 */ { 0, 0, 0, 0, 0 },
/* U+b505 */ { 0, 0, 0, 0, 0 },
/* U+b506 */ { 0, 0, 0, 0, 0 },
/* U+b507 */ { 0, 0, 0, 0, 0 },
/* U+b508 */ { 0, 0, 0, 0, 0 },
/* U+b509 */ { 0, 0, 0, 0, 0 },
/* U+b50a */ { 0, 0, 0, 0, 0 },
/* U+b50b */ { 0, 0, 0, 0, 0 },
/* U+b50c */ { 0, 0, 0, 0, 0 },
/* U+b50d */ { 0, 0, 0, 0, 0 },
/* U+b50e */ { 0, 0, 0, 0, 0 },
/* U+b50f */ { 0, 0, 0, 0, 0 },
/* U+b510 */ { 0, 0, 0, 0, 0 },
/* U+b511 */ { 0, 0, 0, 0, 0 },
/* U+b512 */ { 0, 0, 0, 0, 0 },
/* U+b513 */ { 0, 0, 0, 0, 0 },
/* U+b514 */ { 0, 0, 0, 0, 0 },
/* U+b515 */ { 0, 0, 0, 0, 0 },
/* U+b516 */ { 0, 0, 0, 0, 0 },
/* U+b517 */ { 0, 0, 0, 0, 0 },
/* U+b518 */ { 0, 0, 0, 0, 0 },
/* U+b519 */ { 0, 0, 0, 0, 0 },
/* U+b51a */ { 0, 0, 0, 0, 0 },
/* U+b51b */ { 0, 0, 0, 0, 0 },
/* U+b51c */ { 0, 0, 0, 0, 0 },
/* U+b51d */ { 0, 0, 0, 0, 0 },
/* U+b51e */ { 0, 0, 0, 0, 0 },
/* U+b51f */ { 0, 0, 0, 0, 0 },
/* U+b520 */ { 0, 0, 0, 0, 0 },
/* U+b521 */ { 0, 0, 0, 0, 0 },
/* U+b522 */ { 0, 0, 0, 0, 0 },
/* U+b523 */ { 0, 0, 0, 0, 0 },
/* U+b524 */ { 0, 0, 0, 0, 0 },
/* U+b525 */ { 0, 0, 0, 0, 0 },
/* U+b526 */ { 0, 0, 0, 0, 0 },
/* U+b527 */ { 0, 0, 0, 0, 0 },
/* U+b528 */ { 0, 0, 0, 0, 0 },
/* U+b529 */ { 0, 0, 0, 0, 0 },
/* U+b52a */ { 0, 0, 0, 0, 0 },
/* U+b52b */ { 0, 0, 0, 0, 0 },
/* U+b52c */ { 0, 0, 0, 0, 0 },
/* U+b52d */ { 0, 0, 0, 0, 0 },
/* U+b52e */ { 0, 0, 0, 0, 0 },
/* U+b52f */ { 0, 0, 0, 0, 0 },
/* U+b530 */ { 0, 0, 0, 0, 0 },
/* U+b531 */ { 0, 0, 0, 0, 0 },
/* U+b532 */ { 0, 0, 0, 0, 0 },
/* U+b533 */ { 0, 0, 0, 0, 0 },
/* U+b534 */ { 0, 0, 0, 0, 0 },
/* U+b535 */ { 0, 0, 0, 0, 0 },
/* U+b536 */ { 0, 0, 0, 0, 0 },
/* U+b537 */ { 0, 0, 0, 0, 0 },
/* U+b538 */ { 0, 0, 0, 0, 0 },
/* U+b539 */ { 0, 0, 0, 0, 0 },
/* U+b53a */ { 0, 0, 0, 0, 0 },
/* U+b53b */ { 0, 0, 0, 0, 0 },
/* U+b53c */ { 0, 0, 0, 0, 0 },
/* U+b53d */ { 0, 0, 0, 0, 0 },
/* U+b53e */ { 0, 0, 0, 0, 0 },
/* U+b53f */ { 0, 0, 0, 0, 0 },
/* U+b540 */ { 0, 0, 0, 0, 0 },
/* U+b541 */ { 0, 0, 0, 0, 0 },
/* U+b542 */ { 0, 0, 0, 0, 0 },
/* U+b543 */ { 0, 0, 0, 0, 0 },
/* U+b544 */ { 0, 0, 0, 0, 0 },
/* U+b545 */ { 0, 0, 0, 0, 0 },
/* U+b546 */ { 0, 0, 0, 0, 0 },
/* U+b547 */ { 0, 0, 0, 0, 0 },
/* U+b548 */ { 0, 0, 0, 0, 0 },
/* U+b549 */ { 0, 0, 0, 0, 0 },
/* U+b54a */ { 0, 0, 0, 0, 0 },
/* U+b54b */ { 0, 0, 0, 0, 0 },
/* U+b54c */ { 0, 0, 0, 0, 0 },
/* U+b54d */ { 0, 0, 0, 0, 0 },
/* U+b54e */ { 0, 0, 0, 0, 0 },
/* U+b54f */ { 0, 0, 0, 0, 0 },
/* U+b550 */ { 0, 0, 0, 0, 0 },
/* U+b551 */ { 0, 0, 0, 0, 0 },
/* U+b552 */ { 0, 0, 0, 0, 0 },
/* U+b553 */ { 0, 0, 0, 0, 0 },
/* U+b554 */ { 0, 0, 0, 0, 0 },
/* U+b555 */ { 0, 0, 0, 0, 0 },
/* U+b556 */ { 0, 0, 0, 0, 0 },
/* U+b557 */ { 0, 0, 0, 0, 0 },
/* U+b558 */ { 0, 0, 0, 0, 0 },
/* U+b559 */ { 0, 0, 0, 0, 0 },
/* U+b55a */ { 0, 0, 0, 0, 0 },
/* U+b55b */ { 0, 0, 0, 0, 0 },
/* U+b55c */ { 0, 0, 0, 0, 0 },
/* U+b55d */ { 0, 0, 0, 0, 0 },
/* U+b55e */ { 0, 0, 0, 0, 0 },
/* U+b55f */ { 0, 0, 0, 0, 0 },
/* U+b560 */ { 0, 0, 0, 0, 0 },
/* U+b561 */ { 0, 0, 0, 0, 0 },
/* U+b562 */ { 0, 0, 0, 0, 0 },
/* U+b563 */ { 0, 0, 0, 0, 0 },
/* U+b564 */ { 0, 0, 0, 0, 0 },
/* U+b565 */ { 0, 0, 0, 0, 0 },
/* U+b566 */ { 0, 0, 0, 0, 0 },
/* U+b567 */ { 0, 0, 0, 0, 0 },
/* U+b568 */ { 0, 0, 0, 0, 0 },
/* U+b569 */ { 0, 0, 0, 0, 0 },
/* U+b56a */ { 0, 0, 0, 0, 0 },
/* U+b56b */ { 0, 0, 0, 0, 0 },
/* U+b56c */ { 0, 0, 0, 0, 0 },
/* U+b56d */ { 0, 0, 0, 0, 0 },
/* U+b56e */ { 0, 0, 0, 0, 0 },
/* U+b56f */ { 0, 0, 0, 0, 0 },
/* U+b570 */ { 0, 0, 0, 0, 0 },
/* U+b571 */ { 0, 0, 0, 0, 0 },
/* U+b572 */ { 0, 0, 0, 0, 0 },
/* U+b573 */ { 0, 0, 0, 0, 0 },
/* U+b574 */ { 0, 0, 0, 0, 0 },
/* U+b575 */ { 0, 0, 0, 0, 0 },
/* U+b576 */ { 0, 0, 0, 0, 0 },
/* U+b577 */ { 0, 0, 0, 0, 0 },
/* U+b578 */ { 0, 0, 0, 0, 0 },
/* U+b579 */ { 0, 0, 0, 0, 0 },
/* U+b57a */ { 0, 0, 0, 0, 0 },
/* U+b57b */ { 0, 0, 0, 0, 0 },
/* U+b57c */ { 0, 0, 0, 0, 0 },
/* U+b57d */ { 0, 0, 0, 0, 0 },
/* U+b57e */ { 0, 0, 0, 0, 0 },
/* U+b57f */ { 0, 0, 0, 0, 0 },
/* U+b580 */ { 0, 0, 0, 0, 0 },
/* U+b581 */ { 0, 0, 0, 0, 0 },
/* U+b582 */ { 0, 0, 0, 0, 0 },
/* U+b583 */ { 0, 0, 0, 0, 0 },
/* U+b584 */ { 0, 0, 0, 0, 0 },
/* U+b585 */ { 0, 0, 0, 0, 0 },
/* U+b586 */ { 0, 0, 0, 0, 0 },
/* U+b587 */ { 0, 0, 0, 0, 0 },
/* U+b588 */ { 0, 0, 0, 0, 0 },
/* U+b589 */ { 0, 0, 0, 0, 0 },
/* U+b58a */ { 0, 0, 0, 0, 0 },
/* U+b58b */ { 0, 0, 0, 0, 0 },
/* U+b58c */ { 0, 0, 0, 0, 0 },
/* U+b58d */ { 0, 0, 0, 0, 0 },
/* U+b58e */ { 0, 0, 0, 0, 0 },
/* U+b58f */ { 0, 0, 0, 0, 0 },
/* U+b590 */ { 0, 0, 0, 0, 0 },
/* U+b591 */ { 0, 0, 0, 0, 0 },
/* U+b592 */ { 0, 0, 0, 0, 0 },
/* U+b593 */ { 0, 0, 0, 0, 0 },
/* U+b594 */ { 0, 0, 0, 0, 0 },
/* U+b595 */ { 0, 0, 0, 0, 0 },
/* U+b596 */ { 0, 0, 0, 0, 0 },
/* U+b597 */ { 0, 0, 0, 0, 0 },
/* U+b598 */ { 0, 0, 0, 0, 0 },
/* U+b599 */ { 0, 0, 0, 0, 0 },
/* U+b59a */ { 0, 0, 0, 0, 0 },
/* U+b59b */ { 0, 0, 0, 0, 0 },
/* U+b59c */ { 0, 0, 0, 0, 0 },
/* U+b59d */ { 0, 0, 0, 0, 0 },
/* U+b59e */ { 0, 0, 0, 0, 0 },
/* U+b59f */ { 0, 0, 0, 0, 0 },
/* U+b5a0 */ { 0, 0, 0, 0, 0 },
/* U+b5a1 */ { 0, 0, 0, 0, 0 },
/* U+b5a2 */ { 0, 0, 0, 0, 0 },
/* U+b5a3 */ { 0, 0, 0, 0, 0 },
/* U+b5a4 */ { 0, 0, 0, 0, 0 },
/* U+b5a5 */ { 0, 0, 0, 0, 0 },
/* U+b5a6 */ { 0, 0, 0, 0, 0 },
/* U+b5a7 */ { 0, 0, 0, 0, 0 },
/* U+b5a8 */ { 0, 0, 0, 0, 0 },
/* U+b5a9 */ { 0, 0, 0, 0, 0 },
/* U+b5aa */ { 0, 0, 0, 0, 0 },
/* U+b5ab */ { 0, 0, 0, 0, 0 },
/* U+b5ac */ { 0, 0, 0, 0, 0 },
/* U+b5ad */ { 0, 0, 0, 0, 0 },
/* U+b5ae */ { 0, 0, 0, 0, 0 },
/* U+b5af */ { 0, 0, 0, 0, 0 },
/* U+b5b0 */ { 0, 0, 0, 0, 0 },
/* U+b5b1 */ { 0, 0, 0, 0, 0 },
/* U+b5b2 */ { 0, 0, 0, 0, 0 },
/* U+b5b3 */ { 0, 0, 0, 0, 0 },
/* U+b5b4 */ { 0, 0, 0, 0, 0 },
/* U+b5b5 */ { 0, 0, 0, 0, 0 },
/* U+b5b6 */ { 0, 0, 0, 0, 0 },
/* U+b5b7 */ { 0, 0, 0, 0, 0 },
/* U+b5b8 */ { 0, 0, 0, 0, 0 },
/* U+b5b9 */ { 0, 0, 0, 0, 0 },
/* U+b5ba */ { 0, 0, 0, 0, 0 },
/* U+b5bb */ { 0, 0, 0, 0, 0 },
/* U+b5bc */ { 0, 0, 0, 0, 0 },
/* U+b5bd */ { 0, 0, 0, 0, 0 },
/* U+b5be */ { 0, 0, 0, 0, 0 },
/* U+b5bf */ { 0, 0, 0, 0, 0 },
/* U+b5c0 */ { 0, 0, 0, 0, 0 },
/* U+b5c1 */ { 0, 0, 0, 0, 0 },
/* U+b5c2 */ { 0, 0, 0, 0, 0 },
/* U+b5c3 */ { 0, 0, 0, 0, 0 },
/* U+b5c4 */ { 0, 0, 0, 0, 0 },
/* U+b5c5 */ { 0, 0, 0, 0, 0 },
/* U+b5c6 */ { 0, 0, 0, 0, 0 },
/* U+b5c7 */ { 0, 0, 0, 0, 0 },
/* U+b5c8 */ { 0, 0, 0, 0, 0 },
/* U+b5c9 */ { 0, 0, 0, 0, 0 },
/* U+b5ca */ { 0, 0, 0, 0, 0 },
/* U+b5cb */ { 0, 0, 0, 0, 0 },
/* U+b5cc */ { 0, 0, 0, 0, 0 },
/* U+b5cd */ { 0, 0, 0, 0, 0 },
/* U+b5ce */ { 0, 0, 0, 0, 0 },
/* U+b5cf */ { 0, 0, 0, 0, 0 },
/* U+b5d0 */ { 0, 0, 0, 0, 0 },
/* U+b5d1 */ { 0, 0, 0, 0, 0 },
/* U+b5d2 */ { 0, 0, 0, 0, 0 },
/* U+b5d3 */ { 0, 0, 0, 0, 0 },
/* U+b5d4 */ { 0, 0, 0, 0, 0 },
/* U+b5d5 */ { 0, 0, 0, 0, 0 },
/* U+b5d6 */ { 0, 0, 0, 0, 0 },
/* U+b5d7 */ { 0, 0, 0, 0, 0 },
/* U+b5d8 */ { 0, 0, 0, 0, 0 },
/* U+b5d9 */ { 0, 0, 0, 0, 0 },
/* U+b5da */ { 0, 0, 0, 0, 0 },
/* U+b5db */ { 0, 0, 0, 0, 0 },
/* U+b5dc */ { 0, 0, 0, 0, 0 },
/* U+b5dd */ { 0, 0, 0, 0, 0 },
/* U+b5de */ { 0, 0, 0, 0, 0 },
/* U+b5df */ { 0, 0, 0, 0, 0 },
/* U+b5e0 */ { 0, 0, 0, 0, 0 },
/* U+b5e1 */ { 0, 0, 0, 0, 0 },
/* U+b5e2 */ { 0, 0, 0, 0, 0 },
/* U+b5e3 */ { 0, 0, 0, 0, 0 },
/* U+b5e4 */ { 0, 0, 0, 0, 0 },
/* U+b5e5 */ { 0, 0, 0, 0, 0 },
/* U+b5e6 */ { 0, 0, 0, 0, 0 },
/* U+b5e7 */ { 0, 0, 0, 0, 0 },
/* U+b5e8 */ { 0, 0, 0, 0, 0 },
/* U+b5e9 */ { 0, 0, 0, 0, 0 },
/* U+b5ea */ { 0, 0, 0, 0, 0 },
/* U+b5eb */ { 0, 0, 0, 0, 0 },
/* U+b5ec */ { 0, 0, 0, 0, 0 },
/* U+b5ed */ { 0, 0, 0, 0, 0 },
/* U+b5ee */ { 0, 0, 0, 0, 0 },
/* U+b5ef */ { 0, 0, 0, 0, 0 },
/* U+b5f0 */ { 0, 0, 0, 0, 0 },
/* U+b5f1 */ { 0, 0, 0, 0, 0 },
/* U+b5f2 */ { 0, 0, 0, 0, 0 },
/* U+b5f3 */ { 0, 0, 0, 0, 0 },
/* U+b5f4 */ { 0, 0, 0, 0, 0 },
/* U+b5f5 */ { 0, 0, 0, 0, 0 },
/* U+b5f6 */ { 0, 0, 0, 0, 0 },
/* U+b5f7 */ { 0, 0, 0, 0, 0 },
/* U+b5f8 */ { 0, 0, 0, 0, 0 },
/* U+b5f9 */ { 0, 0, 0, 0, 0 },
/* U+b5fa */ { 0, 0, 0, 0, 0 },
/* U+b5fb */ { 0, 0, 0, 0, 0 },
/* U+b5fc */ { 0, 0, 0, 0, 0 },
/* U+b5fd */ { 0, 0, 0, 0, 0 },
/* U+b5fe */ { 0, 0, 0, 0, 0 },
/* U+b5ff */ { 0, 0, 0, 0, 0 },
/* U+b600 */ { 0, 0, 0, 0, 0 },
/* U+b601 */ { 0, 0, 0, 0, 0 },
/* U+b602 */ { 0, 0, 0, 0, 0 },
/* U+b603 */ { 0, 0, 0, 0, 0 },
/* U+b604 */ { 0, 0, 0, 0, 0 },
/* U+b605 */ { 0, 0, 0, 0, 0 },
/* U+b606 */ { 0, 0, 0, 0, 0 },
/* U+b607 */ { 0, 0, 0, 0, 0 },
/* U+b608 */ { 0, 0, 0, 0, 0 },
/* U+b609 */ { 0, 0, 0, 0, 0 },
/* U+b60a */ { 0, 0, 0, 0, 0 },
/* U+b60b */ { 0, 0, 0, 0, 0 },
/* U+b60c */ { 0, 0, 0, 0, 0 },
/* U+b60d */ { 0, 0, 0, 0, 0 },
/* U+b60e */ { 0, 0, 0, 0, 0 },
/* U+b60f */ { 0, 0, 0, 0, 0 },
/* U+b610 */ { 0, 0, 0, 0, 0 },
/* U+b611 */ { 0, 0, 0, 0, 0 },
/* U+b612 */ { 0, 0, 0, 0, 0 },
/* U+b613 */ { 0, 0, 0, 0, 0 },
/* U+b614 */ { 0, 0, 0, 0, 0 },
/* U+b615 */ { 0, 0, 0, 0, 0 },
/* U+b616 */ { 0, 0, 0, 0, 0 },
/* U+b617 */ { 0, 0, 0, 0, 0 },
/* U+b618 */ { 0, 0, 0, 0, 0 },
/* U+b619 */ { 0, 0, 0, 0, 0 },
/* U+b61a */ { 0, 0, 0, 0, 0 },
/* U+b61b */ { 0, 0, 0, 0, 0 },
/* U+b61c */ { 0, 0, 0, 0, 0 },
/* U+b61d */ { 0, 0, 0, 0, 0 },
/* U+b61e */ { 0, 0, 0, 0, 0 },
/* U+b61f */ { 0, 0, 0, 0, 0 },
/* U+b620 */ { 0, 0, 0, 0, 0 },
/* U+b621 */ { 0, 0, 0, 0, 0 },
/* U+b622 */ { 0, 0, 0, 0, 0 },
/* U+b623 */ { 0, 0, 0, 0, 0 },
/* U+b624 */ { 0, 0, 0, 0, 0 },
/* U+b625 */ { 0, 0, 0, 0, 0 },
/* U+b626 */ { 0, 0, 0, 0, 0 },
/* U+b627 */ { 0, 0, 0, 0, 0 },
/* U+b628 */ { 0, 0, 0, 0, 0 },
/* U+b629 */ { 0, 0, 0, 0, 0 },
/* U+b62a */ { 0, 0, 0, 0, 0 },
/* U+b62b */ { 0, 0, 0, 0, 0 },
/* U+b62c */ { 0, 0, 0, 0, 0 },
/* U+b62d */ { 0, 0, 0, 0, 0 },
/* U+b62e */ { 0, 0, 0, 0, 0 },
/* U+b62f */ { 0, 0, 0, 0, 0 },
/* U+b630 */ { 0, 0, 0, 0, 0 },
/* U+b631 */ { 0, 0, 0, 0, 0 },
/* U+b632 */ { 0, 0, 0, 0, 0 },
/* U+b633 */ { 0, 0, 0, 0, 0 },
/* U+b634 */ { 0, 0, 0, 0, 0 },
/* U+b635 */ { 0, 0, 0, 0, 0 },
/* U+b636 */ { 0, 0, 0, 0, 0 },
/* U+b637 */ { 0, 0, 0, 0, 0 },
/* U+b638 */ { 0, 0, 0, 0, 0 },
/* U+b639 */ { 0, 0, 0, 0, 0 },
/* U+b63a */ { 0, 0, 0, 0, 0 },
/* U+b63b */ { 0, 0, 0, 0, 0 },
/* U+b63c */ { 0, 0, 0, 0, 0 },
/* U+b63d */ { 0, 0, 0, 0, 0 },
/* U+b63e */ { 0, 0, 0, 0, 0 },
/* U+b63f */ { 0, 0, 0, 0, 0 },
/* U+b640 */ { 0, 0, 0, 0, 0 },
/* U+b641 */ { 0, 0, 0, 0, 0 },
/* U+b642 */ { 0, 0, 0, 0, 0 },
/* U+b643 */ { 0, 0, 0, 0, 0 },
/* U+b644 */ { 0, 0, 0, 0, 0 },
/* U+b645 */ { 0, 0, 0, 0, 0 },
/* U+b646 */ { 0, 0, 0, 0, 0 },
/* U+b647 */ { 0, 0, 0, 0, 0 },
/* U+b648 */ { 0, 0, 0, 0, 0 },
/* U+b649 */ { 0, 0, 0, 0, 0 },
/* U+b64a */ { 0, 0, 0, 0, 0 },
/* U+b64b */ { 0, 0, 0, 0, 0 },
/* U+b64c */ { 0, 0, 0, 0, 0 },
/* U+b64d */ { 0, 0, 0, 0, 0 },
/* U+b64e */ { 0, 0, 0, 0, 0 },
/* U+b64f */ { 0, 0, 0, 0, 0 },
/* U+b650 */ { 0, 0, 0, 0, 0 },
/* U+b651 */ { 0, 0, 0, 0, 0 },
/* U+b652 */ { 0, 0, 0, 0, 0 },
/* U+b653 */ { 0, 0, 0, 0, 0 },
/* U+b654 */ { 0, 0, 0, 0, 0 },
/* U+b655 */ { 0, 0, 0, 0, 0 },
/* U+b656 */ { 0, 0, 0, 0, 0 },
/* U+b657 */ { 0, 0, 0, 0, 0 },
/* U+b658 */ { 0, 0, 0, 0, 0 },
/* U+b659 */ { 0, 0, 0, 0, 0 },
/* U+b65a */ { 0, 0, 0, 0, 0 },
/* U+b65b */ { 0, 0, 0, 0, 0 },
/* U+b65c */ { 0, 0, 0, 0, 0 },
/* U+b65d */ { 0, 0, 0, 0, 0 },
/* U+b65e */ { 0, 0, 0, 0, 0 },
/* U+b65f */ { 0, 0, 0, 0, 0 },
/* U+b660 */ { 0, 0, 0, 0, 0 },
/* U+b661 */ { 0, 0, 0, 0, 0 },
/* U+b662 */ { 0, 0, 0, 0, 0 },
/* U+b663 */ { 0, 0, 0, 0, 0 },
/* U+b664 */ { 0, 0, 0, 0, 0 },
/* U+b665 */ { 0, 0, 0, 0, 0 },
/* U+b666 */ { 0, 0, 0, 0, 0 },
/* U+b667 */ { 0, 0, 0, 0, 0 },
/* U+b668 */ { 0, 0, 0, 0, 0 },
/* U+b669 */ { 0, 0, 0, 0, 0 },
/* U+b66a */ { 0, 0, 0, 0, 0 },
/* U+b66b */ { 0, 0, 0, 0, 0 },
/* U+b66c */ { 0, 0, 0, 0, 0 },
/* U+b66d */ { 0, 0, 0, 0, 0 },
/* U+b66e */ { 0, 0, 0, 0, 0 },
/* U+b66f */ { 0, 0, 0, 0, 0 },
/* U+b670 */ { 0, 0, 0, 0, 0 },
/* U+b671 */ { 0, 0, 0, 0, 0 },
/* U+b672 */ { 0, 0, 0, 0, 0 },
/* U+b673 */ { 0, 0, 0, 0, 0 },
/* U+b674 */ { 0, 0, 0, 0, 0 },
/* U+b675 */ { 0, 0, 0, 0, 0 },
/* U+b676 */ { 0, 0, 0, 0, 0 },
/* U+b677 */ { 0, 0, 0, 0, 0 },
/* U+b678 */ { 0, 0, 0, 0, 0 },
/* U+b679 */ { 0, 0, 0, 0, 0 },
/* U+b67a */ { 0, 0, 0, 0, 0 },
/* U+b67b */ { 0, 0, 0, 0, 0 },
/* U+b67c */ { 0, 0, 0, 0, 0 },
/* U+b67d */ { 0, 0, 0, 0, 0 },
/* U+b67e */ { 0, 0, 0, 0, 0 },
/* U+b67f */ { 0, 0, 0, 0, 0 },
/* U+b680 */ { 0, 0, 0, 0, 0 },
/* U+b681 */ { 0, 0, 0, 0, 0 },
/* U+b682 */ { 0, 0, 0, 0, 0 },
/* U+b683 */ { 0, 0, 0, 0, 0 },
/* U+b684 */ { 0, 0, 0, 0, 0 },
/* U+b685 */ { 0, 0, 0, 0, 0 },
/* U+b686 */ { 0, 0, 0, 0, 0 },
/* U+b687 */ { 0, 0, 0, 0, 0 },
/* U+b688 */ { 0, 0, 0, 0, 0 },
/* U+b689 */ { 0, 0, 0, 0, 0 },
/* U+b68a */ { 0, 0, 0, 0, 0 },
/* U+b68b */ { 0, 0, 0, 0, 0 },
/* U+b68c */ { 0, 0, 0, 0, 0 },
/* U+b68d */ { 0, 0, 0, 0, 0 },
/* U+b68e */ { 0, 0, 0, 0, 0 },
/* U+b68f */ { 0, 0, 0, 0, 0 },
/* U+b690 */ { 0, 0, 0, 0, 0 },
/* U+b691 */ { 0, 0, 0, 0, 0 },
/* U+b692 */ { 0, 0, 0, 0, 0 },
/* U+b693 */ { 0, 0, 0, 0, 0 },
/* U+b694 */ { 0, 0, 0, 0, 0 },
/* U+b695 */ { 0, 0, 0, 0, 0 },
/* U+b696 */ { 0, 0, 0, 0, 0 },
/* U+b697 */ { 0, 0, 0, 0, 0 },
/* U+b698 */ { 0, 0, 0, 0, 0 },
/* U+b699 */ { 0, 0, 0, 0, 0 },
/* U+b69a */ { 0, 0, 0, 0, 0 },
/* U+b69b */ { 0, 0, 0, 0, 0 },
/* U+b69c */ { 0, 0, 0, 0, 0 },
/* U+b69d */ { 0, 0, 0, 0, 0 },
/* U+b69e */ { 0, 0, 0, 0, 0 },
/* U+b69f */ { 0, 0, 0, 0, 0 },
/* U+b6a0 */ { 0, 0, 0, 0, 0 },
/* U+b6a1 */ { 0, 0, 0, 0, 0 },
/* U+b6a2 */ { 0, 0, 0, 0, 0 },
/* U+b6a3 */ { 0, 0, 0, 0, 0 },
/* U+b6a4 */ { 0, 0, 0, 0, 0 },
/* U+b6a5 */ { 0, 0, 0, 0, 0 },
/* U+b6a6 */ { 0, 0, 0, 0, 0 },
/* U+b6a7 */ { 0, 0, 0, 0, 0 },
/* U+b6a8 */ { 0, 0, 0, 0, 0 },
/* U+b6a9 */ { 0, 0, 0, 0, 0 },
/* U+b6aa */ { 0, 0, 0, 0, 0 },
/* U+b6ab */ { 0, 0, 0, 0, 0 },
/* U+b6ac */ { 0, 0, 0, 0, 0 },
/* U+b6ad */ { 0, 0, 0, 0, 0 },
/* U+b6ae */ { 0, 0, 0, 0, 0 },
/* U+b6af */ { 0, 0, 0, 0, 0 },
/* U+b6b0 */ { 0, 0, 0, 0, 0 },
/* U+b6b1 */ { 0, 0, 0, 0, 0 },
/* U+b6b2 */ { 0, 0, 0, 0, 0 },
/* U+b6b3 */ { 0, 0, 0, 0, 0 },
/* U+b6b4 */ { 0, 0, 0, 0, 0 },
/* U+b6b5 */ { 0, 0, 0, 0, 0 },
/* U+b6b6 */ { 0, 0, 0, 0, 0 },
/* U+b6b7 */ { 0, 0, 0, 0, 0 },
/* U+b6b8 */ { 0, 0, 0, 0, 0 },
/* U+b6b9 */ { 0, 0, 0, 0, 0 },
/* U+b6ba */ { 0, 0, 0, 0, 0 },
/* U+b6bb */ { 0, 0, 0, 0, 0 },
/* U+b6bc */ { 0, 0, 0, 0, 0 },
/* U+b6bd */ { 0, 0, 0, 0, 0 },
/* U+b6be */ { 0, 0, 0, 0, 0 },
/* U+b6bf */ { 0, 0, 0, 0, 0 },
/* U+b6c0 */ { 0, 0, 0, 0, 0 },
/* U+b6c1 */ { 0, 0, 0, 0, 0 },
/* U+b6c2 */ { 0, 0, 0, 0, 0 },
/* U+b6c3 */ { 0, 0, 0, 0, 0 },
/* U+b6c4 */ { 0, 0, 0, 0, 0 },
/* U+b6c5 */ { 0, 0, 0, 0, 0 },
/* U+b6c6 */ { 0, 0, 0, 0, 0 },
/* U+b6c7 */ { 0, 0, 0, 0, 0 },
/* U+b6c8 */ { 0, 0, 0, 0, 0 },
/* U+b6c9 */ { 0, 0, 0, 0, 0 },
/* U+b6ca */ { 0, 0, 0, 0, 0 },
/* U+b6cb */ { 0, 0, 0, 0, 0 },
/* U+b6cc */ { 0, 0, 0, 0, 0 },
/* U+b6cd */ { 0, 0, 0, 0, 0 },
/* U+b6ce */ { 0, 0, 0, 0, 0 },
/* U+b6cf */ { 0, 0, 0, 0, 0 },
/* U+b6d0 */ { 0, 0, 0, 0, 0 },
/* U+b6d1 */ { 0, 0, 0, 0, 0 },
/* U+b6d2 */ { 0, 0, 0, 0, 0 },
/* U+b6d3 */ { 0, 0, 0, 0, 0 },
/* U+b6d4 */ { 0, 0, 0, 0, 0 },
/* U+b6d5 */ { 0, 0, 0, 0, 0 },
/* U+b6d6 */ { 0, 0, 0, 0, 0 },
/* U+b6d7 */ { 0, 0, 0, 0, 0 },
/* U+b6d8 */ { 0, 0, 0, 0, 0 },
/* U+b6d9 */ { 0, 0, 0, 0, 0 },
/* U+b6da */ { 0, 0, 0, 0, 0 },
/* U+b6db */ { 0, 0, 0, 0, 0 },
/* U+b6dc */ { 0, 0, 0, 0, 0 },
/* U+b6dd */ { 0, 0, 0, 0, 0 },
/* U+b6de */ { 0, 0, 0, 0, 0 },
/* U+b6df */ { 0, 0, 0, 0, 0 },
/* U+b6e0 */ { 0, 0, 0, 0, 0 },
/* U+b6e1 */ { 0, 0, 0, 0, 0 },
/* U+b6e2 */ { 0, 0, 0, 0, 0 },
/* U+b6e3 */ { 0, 0, 0, 0, 0 },
/* U+b6e4 */ { 0, 0, 0, 0, 0 },
/* U+b6e5 */ { 0, 0, 0, 0, 0 },
/* U+b6e6 */ { 0, 0, 0, 0, 0 },
/* U+b6e7 */ { 0, 0, 0, 0, 0 },
/* U+b6e8 */ { 0, 0, 0, 0, 0 },
/* U+b6e9 */ { 0, 0, 0, 0, 0 },
/* U+b6ea */ { 0, 0, 0, 0, 0 },
/* U+b6eb */ { 0, 0, 0, 0, 0 },
/* U+b6ec */ { 0, 0, 0, 0, 0 },
/* U+b6ed */ { 0, 0, 0, 0, 0 },
/* U+b6ee */ { 0, 0, 0, 0, 0 },
/* U+b6ef */ { 0, 0, 0, 0, 0 },
/* U+b6f0 */ { 0, 0, 0, 0, 0 },
/* U+b6f1 */ { 0, 0, 0, 0, 0 },
/* U+b6f2 */ { 0, 0, 0, 0, 0 },
/* U+b6f3 */ { 0, 0, 0, 0, 0 },
/* U+b6f4 */ { 0, 0, 0, 0, 0 },
/* U+b6f5 */ { 0, 0, 0, 0, 0 },
/* U+b6f6 */ { 0, 0, 0, 0, 0 },
/* U+b6f7 */ { 0, 0, 0, 0, 0 },
/* U+b6f8 */ { 0, 0, 0, 0, 0 },
/* U+b6f9 */ { 0, 0, 0, 0, 0 },
/* U+b6fa */ { 0, 0, 0, 0, 0 },
/* U+b6fb */ { 0, 0, 0, 0, 0 },
/* U+b6fc */ { 0, 0, 0, 0, 0 },
/* U+b6fd */ { 0, 0, 0, 0, 0 },
/* U+b6fe */ { 0, 0, 0, 0, 0 },
/* U+b6ff */ { 0, 0, 0, 0, 0 },
/* U+b700 */ { 0, 0, 0, 0, 0 },
/* U+b701 */ { 0, 0, 0, 0, 0 },
/* U+b702 */ { 0, 0, 0, 0, 0 },
/* U+b703 */ { 0, 0, 0, 0, 0 },
/* U+b704 */ { 0, 0, 0, 0, 0 },
/* U+b705 */ { 0, 0, 0, 0, 0 },
/* U+b706 */ { 0, 0, 0, 0, 0 },
/* U+b707 */ { 0, 0, 0, 0, 0 },
/* U+b708 */ { 0, 0, 0, 0, 0 },
/* U+b709 */ { 0, 0, 0, 0, 0 },
/* U+b70a */ { 0, 0, 0, 0, 0 },
/* U+b70b */ { 0, 0, 0, 0, 0 },
/* U+b70c */ { 0, 0, 0, 0, 0 },
/* U+b70d */ { 0, 0, 0, 0, 0 },
/* U+b70e */ { 0, 0, 0, 0, 0 },
/* U+b70f */ { 0, 0, 0, 0, 0 },
/* U+b710 */ { 0, 0, 0, 0, 0 },
/* U+b711 */ { 0, 0, 0, 0, 0 },
/* U+b712 */ { 0, 0, 0, 0, 0 },
/* U+b713 */ { 0, 0, 0, 0, 0 },
/* U+b714 */ { 0, 0, 0, 0, 0 },
/* U+b715 */ { 0, 0, 0, 0, 0 },
/* U+b716 */ { 0, 0, 0, 0, 0 },
/* U+b717 */ { 0, 0, 0, 0, 0 },
/* U+b718 */ { 0, 0, 0, 0, 0 },
/* U+b719 */ { 0, 0, 0, 0, 0 },
/* U+b71a */ { 0, 0, 0, 0, 0 },
/* U+b71b */ { 0, 0, 0, 0, 0 },
/* U+b71c */ { 0, 0, 0, 0, 0 },
/* U+b71d */ { 0, 0, 0, 0, 0 },
/* U+b71e */ { 0, 0, 0, 0, 0 },
/* U+b71f */ { 0, 0, 0, 0, 0 },
/* U+b720 */ { 0, 0, 0, 0, 0 },
/* U+b721 */ { 0, 0, 0, 0, 0 },
/* U+b722 */ { 0, 0, 0, 0, 0 },
/* U+b723 */ { 0, 0, 0, 0, 0 },
/* U+b724 */ { 0, 0, 0, 0, 0 },
/* U+b725 */ { 0, 0, 0, 0, 0 },
/* U+b726 */ { 0, 0, 0, 0, 0 },
/* U+b727 */ { 0, 0, 0, 0, 0 },
/* U+b728 */ { 0, 0, 0, 0, 0 },
/* U+b729 */ { 0, 0, 0, 0, 0 },
/* U+b72a */ { 0, 0, 0, 0, 0 },
/* U+b72b */ { 0, 0, 0, 0, 0 },
/* U+b72c */ { 0, 0, 0, 0, 0 },
/* U+b72d */ { 0, 0, 0, 0, 0 },
/* U+b72e */ { 0, 0, 0, 0, 0 },
/* U+b72f */ { 0, 0, 0, 0, 0 },
/* U+b730 */ { 0, 0, 0, 0, 0 },
/* U+b731 */ { 0, 0, 0, 0, 0 },
/* U+b732 */ { 0, 0, 0, 0, 0 },
/* U+b733 */ { 0, 0, 0, 0, 0 },
/* U+b734 */ { 0, 0, 0, 0, 0 },
/* U+b735 */ { 0, 0, 0, 0, 0 },
/* U+b736 */ { 0, 0, 0, 0, 0 },
/* U+b737 */ { 0, 0, 0, 0, 0 },
/* U+b738 */ { 0, 0, 0, 0, 0 },
/* U+b739 */ { 0, 0, 0, 0, 0 },
/* U+b73a */ { 0, 0, 0, 0, 0 },
/* U+b73b */ { 0, 0, 0, 0, 0 },
/* U+b73c */ { 0, 0, 0, 0, 0 },
/* U+b73d */ { 0, 0, 0, 0, 0 },
/* U+b73e */ { 0, 0, 0, 0, 0 },
/* U+b73f */ { 0, 0, 0, 0, 0 },
/* U+b740 */ { 0, 0, 0, 0, 0 },
/* U+b741 */ { 0, 0, 0, 0, 0 },
/* U+b742 */ { 0, 0, 0, 0, 0 },
/* U+b743 */ { 0, 0, 0, 0, 0 },
/* U+b744 */ { 0, 0, 0, 0, 0 },
/* U+b745 */ { 0, 0, 0, 0, 0 },
/* U+b746 */ { 0, 0, 0, 0, 0 },
/* U+b747 */ { 0, 0, 0, 0, 0 },
/* U+b748 */ { 0, 0, 0, 0, 0 },
/* U+b749 */ { 0, 0, 0, 0, 0 },
/* U+b74a */ { 0, 0, 0, 0, 0 },
/* U+b74b */ { 0, 0, 0, 0, 0 },
/* U+b74c */ { 0, 0, 0, 0, 0 },
/* U+b74d */ { 0, 0, 0, 0, 0 },
/* U+b74e */ { 0, 0, 0, 0, 0 },
/* U+b74f */ { 0, 0, 0, 0, 0 },
/* U+b750 */ { 0, 0, 0, 0, 0 },
/* U+b751 */ { 0, 0, 0, 0, 0 },
/* U+b752 */ { 0, 0, 0, 0, 0 },
/* U+b753 */ { 0, 0, 0, 0, 0 },
/* U+b754 */ { 0, 0, 0, 0, 0 },
/* U+b755 */ { 0, 0, 0, 0, 0 },
/* U+b756 */ { 0, 0, 0, 0, 0 },
/* U+b757 */ { 0, 0, 0, 0, 0 },
/* U+b758 */ { 0, 0, 0, 0, 0 },
/* U+b759 */ { 0, 0, 0, 0, 0 },
/* U+b75a */ { 0, 0, 0, 0, 0 },
/* U+b75b */ { 0, 0, 0, 0, 0 },
/* U+b75c */ { 0, 0, 0, 0, 0 },
/* U+b75d */ { 0, 0, 0, 0, 0 },
/* U+b75e */ { 0, 0, 0, 0, 0 },
/* U+b75f */ { 0, 0, 0, 0, 0 },
/* U+b760 */ { 0, 0, 0, 0, 0 },
/* U+b761 */ { 0, 0, 0, 0, 0 },
/* U+b762 */ { 0, 0, 0, 0, 0 },
/* U+b763 */ { 0, 0, 0, 0, 0 },
/* U+b764 */ { 0, 0, 0, 0, 0 },
/* U+b765 */ { 0, 0, 0, 0, 0 },
/* U+b766 */ { 0, 0, 0, 0, 0 },
/* U+b767 */ { 0, 0, 0, 0, 0 },
/* U+b768 */ { 0, 0, 0, 0, 0 },
/* U+b769 */ { 0, 0, 0, 0, 0 },
/* U+b76a */ { 0, 0, 0, 0, 0 },
/* U+b76b */ { 0, 0, 0, 0, 0 },
/* U+b76c */ { 0, 0, 0, 0, 0 },
/* U+b76d */ { 0, 0, 0, 0, 0 },
/* U+b76e */ { 0, 0, 0, 0, 0 },
/* U+b76f */ { 0, 0, 0, 0, 0 },
/* U+b770 */ { 0, 0, 0, 0, 0 },
/* U+b771 */ { 0, 0, 0, 0, 0 },
/* U+b772 */ { 0, 0, 0, 0, 0 },
/* U+b773 */ { 0, 0, 0, 0, 0 },
/* U+b774 */ { 0, 0, 0, 0, 0 },
/* U+b775 */ { 0, 0, 0, 0, 0 },
/* U+b776 */ { 0, 0, 0, 0, 0 },
/* U+b777 */ { 0, 0, 0, 0, 0 },
/* U+b778 */ { 0, 0, 0, 0, 0 },
/* U+b779 */ { 0, 0, 0, 0, 0 },
/* U+b77a */ { 0, 0, 0, 0, 0 },
/* U+b77b */ { 0, 0, 0, 0, 0 },
/* U+b77c */ { 0, 0, 0, 0, 0 },
/* U+b77d */ { 0, 0, 0, 0, 0 },
/* U+b77e */ { 0, 0, 0, 0, 0 },
/* U+b77f */ { 0, 0, 0, 0, 0 },
/* U+b780 */ { 0, 0, 0, 0, 0 },
/* U+b781 */ { 0, 0, 0, 0, 0 },
/* U+b782 */ { 0, 0, 0, 0, 0 },
/* U+b783 */ { 0, 0, 0, 0, 0 },
/* U+b784 */ { 0, 0, 0, 0, 0 },
/* U+b785 */ { 0, 0, 0, 0, 0 },
/* U+b786 */ { 0, 0, 0, 0, 0 },
/* U+b787 */ { 0, 0, 0, 0, 0 },
/* U+b788 */ { 0, 0, 0, 0, 0 },
/* U+b789 */ { 0, 0, 0, 0, 0 },
/* U+b78a */ { 0, 0, 0, 0, 0 },
/* U+b78b */ { 0, 0, 0, 0, 0 },
/* U+b78c */ { 0, 0, 0, 0, 0 },
/* U+b78d */ { 0, 0, 0, 0, 0 },
/* U+b78e */ { 0, 0, 0, 0, 0 },
/* U+b78f */ { 0, 0, 0, 0, 0 },
/* U+b790 */ { 0, 0, 0, 0, 0 },
/* U+b791 */ { 0, 0, 0, 0, 0 },
/* U+b792 */ { 0, 0, 0, 0, 0 },
/* U+b793 */ { 0, 0, 0, 0, 0 },
/* U+b794 */ { 0, 0, 0, 0, 0 },
/* U+b795 */ { 0, 0, 0, 0, 0 },
/* U+b796 */ { 0, 0, 0, 0, 0 },
/* U+b797 */ { 0, 0, 0, 0, 0 },
/* U+b798 */ { 0, 0, 0, 0, 0 },
/* U+b799 */ { 0, 0, 0, 0, 0 },
/* U+b79a */ { 0, 0, 0, 0, 0 },
/* U+b79b */ { 0, 0, 0, 0, 0 },
/* U+b79c */ { 0, 0, 0, 0, 0 },
/* U+b79d */ { 0, 0, 0, 0, 0 },
/* U+b79e */ { 0, 0, 0, 0, 0 },
/* U+b79f */ { 0, 0, 0, 0, 0 },
/* U+b7a0 */ { 0, 0, 0, 0, 0 },
/* U+b7a1 */ { 0, 0, 0, 0, 0 },
/* U+b7a2 */ { 0, 0, 0, 0, 0 },
/* U+b7a3 */ { 0, 0, 0, 0, 0 },
/* U+b7a4 */ { 0, 0, 0, 0, 0 },
/* U+b7a5 */ { 0, 0, 0, 0, 0 },
/* U+b7a6 */ { 0, 0, 0, 0, 0 },
/* U+b7a7 */ { 0, 0, 0, 0, 0 },
/* U+b7a8 */ { 0, 0, 0, 0, 0 },
/* U+b7a9 */ { 0, 0, 0, 0, 0 },
/* U+b7aa */ { 0, 0, 0, 0, 0 },
/* U+b7ab */ { 0, 0, 0, 0, 0 },
/* U+b7ac */ { 0, 0, 0, 0, 0 },
/* U+b7ad */ { 0, 0, 0, 0, 0 },
/* U+b7ae */ { 0, 0, 0, 0, 0 },
/* U+b7af */ { 0, 0, 0, 0, 0 },
/* U+b7b0 */ { 0, 0, 0, 0, 0 },
/* U+b7b1 */ { 0, 0, 0, 0, 0 },
/* U+b7b2 */ { 0, 0, 0, 0, 0 },
/* U+b7b3 */ { 0, 0, 0, 0, 0 },
/* U+b7b4 */ { 0, 0, 0, 0, 0 },
/* U+b7b5 */ { 0, 0, 0, 0, 0 },
/* U+b7b6 */ { 0, 0, 0, 0, 0 },
/* U+b7b7 */ { 0, 0, 0, 0, 0 },
/* U+b7b8 */ { 0, 0, 0, 0, 0 },
/* U+b7b9 */ { 0, 0, 0, 0, 0 },
/* U+b7ba */ { 0, 0, 0, 0, 0 },
/* U+b7bb */ { 0, 0, 0, 0, 0 },
/* U+b7bc */ { 0, 0, 0, 0, 0 },
/* U+b7bd */ { 0, 0, 0, 0, 0 },
/* U+b7be */ { 0, 0, 0, 0, 0 },
/* U+b7bf */ { 0, 0, 0, 0, 0 },
/* U+b7c0 */ { 0, 0, 0, 0, 0 },
/* U+b7c1 */ { 0, 0, 0, 0, 0 },
/* U+b7c2 */ { 0, 0, 0, 0, 0 },
/* U+b7c3 */ { 0, 0, 0, 0, 0 },
/* U+b7c4 */ { 0, 0, 0, 0, 0 },
/* U+b7c5 */ { 0, 0, 0, 0, 0 },
/* U+b7c6 */ { 0, 0, 0, 0, 0 },
/* U+b7c7 */ { 0, 0, 0, 0, 0 },
/* U+b7c8 */ { 0, 0, 0, 0, 0 },
/* U+b7c9 */ { 0, 0, 0, 0, 0 },
/* U+b7ca */ { 0, 0, 0, 0, 0 },
/* U+b7cb */ { 0, 0, 0, 0, 0 },
/* U+b7cc */ { 0, 0, 0, 0, 0 },
/* U+b7cd */ { 0, 0, 0, 0, 0 },
/* U+b7ce */ { 0, 0, 0, 0, 0 },
/* U+b7cf */ { 0, 0, 0, 0, 0 },
/* U+b7d0 */ { 0, 0, 0, 0, 0 },
/* U+b7d1 */ { 0, 0, 0, 0, 0 },
/* U+b7d2 */ { 0, 0, 0, 0, 0 },
/* U+b7d3 */ { 0, 0, 0, 0, 0 },
/* U+b7d4 */ { 0, 0, 0, 0, 0 },
/* U+b7d5 */ { 0, 0, 0, 0, 0 },
/* U+b7d6 */ { 0, 0, 0, 0, 0 },
/* U+b7d7 */ { 0, 0, 0, 0, 0 },
/* U+b7d8 */ { 0, 0, 0, 0, 0 },
/* U+b7d9 */ { 0, 0, 0, 0, 0 },
/* U+b7da */ { 0, 0, 0, 0, 0 },
/* U+b7db */ { 0, 0, 0, 0, 0 },
/* U+b7dc */ { 0, 0, 0, 0, 0 },
/* U+b7dd */ { 0, 0, 0, 0, 0 },
/* U+b7de */ { 0, 0, 0, 0, 0 },
/* U+b7df */ { 0, 0, 0, 0, 0 },
/* U+b7e0 */ { 0, 0, 0, 0, 0 },
/* U+b7e1 */ { 0, 0, 0, 0, 0 },
/* U+b7e2 */ { 0, 0, 0, 0, 0 },
/* U+b7e3 */ { 0, 0, 0, 0, 0 },
/* U+b7e4 */ { 0, 0, 0, 0, 0 },
/* U+b7e5 */ { 0, 0, 0, 0, 0 },
/* U+b7e6 */ { 0, 0, 0, 0, 0 },
/* U+b7e7 */ { 0, 0, 0, 0, 0 },
/* U+b7e8 */ { 0, 0, 0, 0, 0 },
/* U+b7e9 */ { 0, 0, 0, 0, 0 },
/* U+b7ea */ { 0, 0, 0, 0, 0 },
/* U+b7eb */ { 0, 0, 0, 0, 0 },
/* U+b7ec */ { 0, 0, 0, 0, 0 },
/* U+b7ed */ { 0, 0, 0, 0, 0 },
/* U+b7ee */ { 0, 0, 0, 0, 0 },
/* U+b7ef */ { 0, 0, 0, 0, 0 },
/* U+b7f0 */ { 0, 0, 0, 0, 0 },
/* U+b7f1 */ { 0, 0, 0, 0, 0 },
/* U+b7f2 */ { 0, 0, 0, 0, 0 },
/* U+b7f3 */ { 0, 0, 0, 0, 0 },
/* U+b7f4 */ { 0, 0, 0, 0, 0 },
/* U+b7f5 */ { 0, 0, 0, 0, 0 },
/* U+b7f6 */ { 0, 0, 0, 0, 0 },
/* U+b7f7 */ { 0, 0, 0, 0, 0 },
/* U+b7f8 */ { 0, 0, 0, 0, 0 },
/* U+b7f9 */ { 0, 0, 0, 0, 0 },
/* U+b7fa */ { 0, 0, 0, 0, 0 },
/* U+b7fb */ { 0, 0, 0, 0, 0 },
/* U+b7fc */ { 0, 0, 0, 0, 0 },
/* U+b7fd */ { 0, 0, 0, 0, 0 },
/* U+b7fe */ { 0, 0, 0, 0, 0 },
/* U+b7ff */ { 0, 0, 0, 0, 0 },
/* U+b800 */ { 0, 0, 0, 0, 0 },
/* U+b801 */ { 0, 0, 0, 0, 0 },
/* U+b802 */ { 0, 0, 0, 0, 0 },
/* U+b803 */ { 0, 0, 0, 0, 0 },
/* U+b804 */ { 0, 0, 0, 0, 0 },
/* U+b805 */ { 0, 0, 0, 0, 0 },
/* U+b806 */ { 0, 0, 0, 0, 0 },
/* U+b807 */ { 0, 0, 0, 0, 0 },
/* U+b808 */ { 0, 0, 0, 0, 0 },
/* U+b809 */ { 0, 0, 0, 0, 0 },
/* U+b80a */ { 0, 0, 0, 0, 0 },
/* U+b80b */ { 0, 0, 0, 0, 0 },
/* U+b80c */ { 0, 0, 0, 0, 0 },
/* U+b80d */ { 0, 0, 0, 0, 0 },
/* U+b80e */ { 0, 0, 0, 0, 0 },
/* U+b80f */ { 0, 0, 0, 0, 0 },
/* U+b810 */ { 0, 0, 0, 0, 0 },
/* U+b811 */ { 0, 0, 0, 0, 0 },
/* U+b812 */ { 0, 0, 0, 0, 0 },
/* U+b813 */ { 0, 0, 0, 0, 0 },
/* U+b814 */ { 0, 0, 0, 0, 0 },
/* U+b815 */ { 0, 0, 0, 0, 0 },
/* U+b816 */ { 0, 0, 0, 0, 0 },
/* U+b817 */ { 0, 0, 0, 0, 0 },
/* U+b818 */ { 0, 0, 0, 0, 0 },
/* U+b819 */ { 0, 0, 0, 0, 0 },
/* U+b81a */ { 0, 0, 0, 0, 0 },
/* U+b81b */ { 0, 0, 0, 0, 0 },
/* U+b81c */ { 0, 0, 0, 0, 0 },
/* U+b81d */ { 0, 0, 0, 0, 0 },
/* U+b81e */ { 0, 0, 0, 0, 0 },
/* U+b81f */ { 0, 0, 0, 0, 0 },
/* U+b820 */ { 0, 0, 0, 0, 0 },
/* U+b821 */ { 0, 0, 0, 0, 0 },
/* U+b822 */ { 0, 0, 0, 0, 0 },
/* U+b823 */ { 0, 0, 0, 0, 0 },
/* U+b824 */ { 0, 0, 0, 0, 0 },
/* U+b825 */ { 0, 0, 0, 0, 0 },
/* U+b826 */ { 0, 0, 0, 0, 0 },
/* U+b827 */ { 0, 0, 0, 0, 0 },
/* U+b828 */ { 0, 0, 0, 0, 0 },
/* U+b829 */ { 0, 0, 0, 0, 0 },
/* U+b82a */ { 0, 0, 0, 0, 0 },
/* U+b82b */ { 0, 0, 0, 0, 0 },
/* U+b82c */ { 0, 0, 0, 0, 0 },
/* U+b82d */ { 0, 0, 0, 0, 0 },
/* U+b82e */ { 0, 0, 0, 0, 0 },
/* U+b82f */ { 0, 0, 0, 0, 0 },
/* U+b830 */ { 0, 0, 0, 0, 0 },
/* U+b831 */ { 0, 0, 0, 0, 0 },
/* U+b832 */ { 0, 0, 0, 0, 0 },
/* U+b833 */ { 0, 0, 0, 0, 0 },
/* U+b834 */ { 0, 0, 0, 0, 0 },
/* U+b835 */ { 0, 0, 0, 0, 0 },
/* U+b836 */ { 0, 0, 0, 0, 0 },
/* U+b837 */ { 0, 0, 0, 0, 0 },
/* U+b838 */ { 0, 0, 0, 0, 0 },
/* U+b839 */ { 0, 0, 0, 0, 0 },
/* U+b83a */ { 0, 0, 0, 0, 0 },
/* U+b83b */ { 0, 0, 0, 0, 0 },
/* U+b83c */ { 0, 0, 0, 0, 0 },
/* U+b83d */ { 0, 0, 0, 0, 0 },
/* U+b83e */ { 0, 0, 0, 0, 0 },
/* U+b83f */ { 0, 0, 0, 0, 0 },
/* U+b840 */ { 0, 0, 0, 0, 0 },
/* U+b841 */ { 0, 0, 0, 0, 0 },
/* U+b842 */ { 0, 0, 0, 0, 0 },
/* U+b843 */ { 0, 0, 0, 0, 0 },
/* U+b844 */ { 0, 0, 0, 0, 0 },
/* U+b845 */ { 0, 0, 0, 0, 0 },
/* U+b846 */ { 0, 0, 0, 0, 0 },
/* U+b847 */ { 0, 0, 0, 0, 0 },
/* U+b848 */ { 0, 0, 0, 0, 0 },
/* U+b849 */ { 0, 0, 0, 0, 0 },
/* U+b84a */ { 0, 0, 0, 0, 0 },
/* U+b84b */ { 0, 0, 0, 0, 0 },
/* U+b84c */ { 0, 0, 0, 0, 0 },
/* U+b84d */ { 0, 0, 0, 0, 0 },
/* U+b84e */ { 0, 0, 0, 0, 0 },
/* U+b84f */ { 0, 0, 0, 0, 0 },
/* U+b850 */ { 0, 0, 0, 0, 0 },
/* U+b851 */ { 0, 0, 0, 0, 0 },
/* U+b852 */ { 0, 0, 0, 0, 0 },
/* U+b853 */ { 0, 0, 0, 0, 0 },
/* U+b854 */ { 0, 0, 0, 0, 0 },
/* U+b855 */ { 0, 0, 0, 0, 0 },
/* U+b856 */ { 0, 0, 0, 0, 0 },
/* U+b857 */ { 0, 0, 0, 0, 0 },
/* U+b858 */ { 0, 0, 0, 0, 0 },
/* U+b859 */ { 0, 0, 0, 0, 0 },
/* U+b85a */ { 0, 0, 0, 0, 0 },
/* U+b85b */ { 0, 0, 0, 0, 0 },
/* U+b85c */ { 0, 0, 0, 0, 0 },
/* U+b85d */ { 0, 0, 0, 0, 0 },
/* U+b85e */ { 0, 0, 0, 0, 0 },
/* U+b85f */ { 0, 0, 0, 0, 0 },
/* U+b860 */ { 0, 0, 0, 0, 0 },
/* U+b861 */ { 0, 0, 0, 0, 0 },
/* U+b862 */ { 0, 0, 0, 0, 0 },
/* U+b863 */ { 0, 0, 0, 0, 0 },
/* U+b864 */ { 0, 0, 0, 0, 0 },
/* U+b865 */ { 0, 0, 0, 0, 0 },
/* U+b866 */ { 0, 0, 0, 0, 0 },
/* U+b867 */ { 0, 0, 0, 0, 0 },
/* U+b868 */ { 0, 0, 0, 0, 0 },
/* U+b869 */ { 0, 0, 0, 0, 0 },
/* U+b86a */ { 0, 0, 0, 0, 0 },
/* U+b86b */ { 0, 0, 0, 0, 0 },
/* U+b86c */ { 0, 0, 0, 0, 0 },
/* U+b86d */ { 0, 0, 0, 0, 0 },
/* U+b86e */ { 0, 0, 0, 0, 0 },
/* U+b86f */ { 0, 0, 0, 0, 0 },
/* U+b870 */ { 0, 0, 0, 0, 0 },
/* U+b871 */ { 0, 0, 0, 0, 0 },
/* U+b872 */ { 0, 0, 0, 0, 0 },
/* U+b873 */ { 0, 0, 0, 0, 0 },
/* U+b874 */ { 0, 0, 0, 0, 0 },
/* U+b875 */ { 0, 0, 0, 0, 0 },
/* U+b876 */ { 0, 0, 0, 0, 0 },
/* U+b877 */ { 0, 0, 0, 0, 0 },
/* U+b878 */ { 0, 0, 0, 0, 0 },
/* U+b879 */ { 0, 0, 0, 0, 0 },
/* U+b87a */ { 0, 0, 0, 0, 0 },
/* U+b87b */ { 0, 0, 0, 0, 0 },
/* U+b87c */ { 0, 0, 0, 0, 0 },
/* U+b87d */ { 0, 0, 0, 0, 0 },
/* U+b87e */ { 0, 0, 0, 0, 0 },
/* U+b87f */ { 0, 0, 0, 0, 0 },
/* U+b880 */ { 0, 0, 0, 0, 0 },
/* U+b881 */ { 0, 0, 0, 0, 0 },
/* U+b882 */ { 0, 0, 0, 0, 0 },
/* U+b883 */ { 0, 0, 0, 0, 0 },
/* U+b884 */ { 0, 0, 0, 0, 0 },
/* U+b885 */ { 0, 0, 0, 0, 0 },
/* U+b886 */ { 0, 0, 0, 0, 0 },
/* U+b887 */ { 0, 0, 0, 0, 0 },
/* U+b888 */ { 0, 0, 0, 0, 0 },
/* U+b889 */ { 0, 0, 0, 0, 0 },
/* U+b88a */ { 0, 0, 0, 0, 0 },
/* U+b88b */ { 0, 0, 0, 0, 0 },
/* U+b88c */ { 0, 0, 0, 0, 0 },
/* U+b88d */ { 0, 0, 0, 0, 0 },
/* U+b88e */ { 0, 0, 0, 0, 0 },
/* U+b88f */ { 0, 0, 0, 0, 0 },
/* U+b890 */ { 0, 0, 0, 0, 0 },
/* U+b891 */ { 0, 0, 0, 0, 0 },
/* U+b892 */ { 0, 0, 0, 0, 0 },
/* U+b893 */ { 0, 0, 0, 0, 0 },
/* U+b894 */ { 0, 0, 0, 0, 0 },
/* U+b895 */ { 0, 0, 0, 0, 0 },
/* U+b896 */ { 0, 0, 0, 0, 0 },
/* U+b897 */ { 0, 0, 0, 0, 0 },
/* U+b898 */ { 0, 0, 0, 0, 0 },
/* U+b899 */ { 0, 0, 0, 0, 0 },
/* U+b89a */ { 0, 0, 0, 0, 0 },
/* U+b89b */ { 0, 0, 0, 0, 0 },
/* U+b89c */ { 0, 0, 0, 0, 0 },
/* U+b89d */ { 0, 0, 0, 0, 0 },
/* U+b89e */ { 0, 0, 0, 0, 0 },
/* U+b89f */ { 0, 0, 0, 0, 0 },
/* U+b8a0 */ { 0, 0, 0, 0, 0 },
/* U+b8a1 */ { 0, 0, 0, 0, 0 },
/* U+b8a2 */ { 0, 0, 0, 0, 0 },
/* U+b8a3 */ { 0, 0, 0, 0, 0 },
/* U+b8a4 */ { 0, 0, 0, 0, 0 },
/* U+b8a5 */ { 0, 0, 0, 0, 0 },
/* U+b8a6 */ { 0, 0, 0, 0, 0 },
/* U+b8a7 */ { 0, 0, 0, 0, 0 },
/* U+b8a8 */ { 0, 0, 0, 0, 0 },
/* U+b8a9 */ { 0, 0, 0, 0, 0 },
/* U+b8aa */ { 0, 0, 0, 0, 0 },
/* U+b8ab */ { 0, 0, 0, 0, 0 },
/* U+b8ac */ { 0, 0, 0, 0, 0 },
/* U+b8ad */ { 0, 0, 0, 0, 0 },
/* U+b8ae */ { 0, 0, 0, 0, 0 },
/* U+b8af */ { 0, 0, 0, 0, 0 },
/* U+b8b0 */ { 0, 0, 0, 0, 0 },
/* U+b8b1 */ { 0, 0, 0, 0, 0 },
/* U+b8b2 */ { 0, 0, 0, 0, 0 },
/* U+b8b3 */ { 0, 0, 0, 0, 0 },
/* U+b8b4 */ { 0, 0, 0, 0, 0 },
/* U+b8b5 */ { 0, 0, 0, 0, 0 },
/* U+b8b6 */ { 0, 0, 0, 0, 0 },
/* U+b8b7 */ { 0, 0, 0, 0, 0 },
/* U+b8b8 */ { 0, 0, 0, 0, 0 },
/* U+b8b9 */ { 0, 0, 0, 0, 0 },
/* U+b8ba */ { 0, 0, 0, 0, 0 },
/* U+b8bb */ { 0, 0, 0, 0, 0 },
/* U+b8bc */ { 0, 0, 0, 0, 0 },
/* U+b8bd */ { 0, 0, 0, 0, 0 },
/* U+b8be */ { 0, 0, 0, 0, 0 },
/* U+b8bf */ { 0, 0, 0, 0, 0 },
/* U+b8c0 */ { 0, 0, 0, 0, 0 },
/* U+b8c1 */ { 0, 0, 0, 0, 0 },
/* U+b8c2 */ { 0, 0, 0, 0, 0 },
/* U+b8c3 */ { 0, 0, 0, 0, 0 },
/* U+b8c4 */ { 0, 0, 0, 0, 0 },
/* U+b8c5 */ { 0, 0, 0, 0, 0 },
/* U+b8c6 */ { 0, 0, 0, 0, 0 },
/* U+b8c7 */ { 0, 0, 0, 0, 0 },
/* U+b8c8 */ { 0, 0, 0, 0, 0 },
/* U+b8c9 */ { 0, 0, 0, 0, 0 },
/* U+b8ca */ { 0, 0, 0, 0, 0 },
/* U+b8cb */ { 0, 0, 0, 0, 0 },
/* U+b8cc */ { 0, 0, 0, 0, 0 },
/* U+b8cd */ { 0, 0, 0, 0, 0 },
/* U+b8ce */ { 0, 0, 0, 0, 0 },
/* U+b8cf */ { 0, 0, 0, 0, 0 },
/* U+b8d0 */ { 0, 0, 0, 0, 0 },
/* U+b8d1 */ { 0, 0, 0, 0, 0 },
/* U+b8d2 */ { 0, 0, 0, 0, 0 },
/* U+b8d3 */ { 0, 0, 0, 0, 0 },
/* U+b8d4 */ { 0, 0, 0, 0, 0 },
/* U+b8d5 */ { 0, 0, 0, 0, 0 },
/* U+b8d6 */ { 0, 0, 0, 0, 0 },
/* U+b8d7 */ { 0, 0, 0, 0, 0 },
/* U+b8d8 */ { 0, 0, 0, 0, 0 },
/* U+b8d9 */ { 0, 0, 0, 0, 0 },
/* U+b8da */ { 0, 0, 0, 0, 0 },
/* U+b8db */ { 0, 0, 0, 0, 0 },
/* U+b8dc */ { 0, 0, 0, 0, 0 },
/* U+b8dd */ { 0, 0, 0, 0, 0 },
/* U+b8de */ { 0, 0, 0, 0, 0 },
/* U+b8df */ { 0, 0, 0, 0, 0 },
/* U+b8e0 */ { 0, 0, 0, 0, 0 },
/* U+b8e1 */ { 0, 0, 0, 0, 0 },
/* U+b8e2 */ { 0, 0, 0, 0, 0 },
/* U+b8e3 */ { 0, 0, 0, 0, 0 },
/* U+b8e4 */ { 0, 0, 0, 0, 0 },
/* U+b8e5 */ { 0, 0, 0, 0, 0 },
/* U+b8e6 */ { 0, 0, 0, 0, 0 },
/* U+b8e7 */ { 0, 0, 0, 0, 0 },
/* U+b8e8 */ { 0, 0, 0, 0, 0 },
/* U+b8e9 */ { 0, 0, 0, 0, 0 },
/* U+b8ea */ { 0, 0, 0, 0, 0 },
/* U+b8eb */ { 0, 0, 0, 0, 0 },
/* U+b8ec */ { 0, 0, 0, 0, 0 },
/* U+b8ed */ { 0, 0, 0, 0, 0 },
/* U+b8ee */ { 0, 0, 0, 0, 0 },
/* U+b8ef */ { 0, 0, 0, 0, 0 },
/* U+b8f0 */ { 0, 0, 0, 0, 0 },
/* U+b8f1 */ { 0, 0, 0, 0, 0 },
/* U+b8f2 */ { 0, 0, 0, 0, 0 },
/* U+b8f3 */ { 0, 0, 0, 0, 0 },
/* U+b8f4 */ { 0, 0, 0, 0, 0 },
/* U+b8f5 */ { 0, 0, 0, 0, 0 },
/* U+b8f6 */ { 0, 0, 0, 0, 0 },
/* U+b8f7 */ { 0, 0, 0, 0, 0 },
/* U+b8f8 */ { 0, 0, 0, 0, 0 },
/* U+b8f9 */ { 0, 0, 0, 0, 0 },
/* U+b8fa */ { 0, 0, 0, 0, 0 },
/* U+b8fb */ { 0, 0, 0, 0, 0 },
/* U+b8fc */ { 0, 0, 0, 0, 0 },
/* U+b8fd */ { 0, 0, 0, 0, 0 },
/* U+b8fe */ { 0, 0, 0, 0, 0 },
/* U+b8ff */ { 0, 0, 0, 0, 0 },
/* U+b900 */ { 0, 0, 0, 0, 0 },
/* U+b901 */ { 0, 0, 0, 0, 0 },
/* U+b902 */ { 0, 0, 0, 0, 0 },
/* U+b903 */ { 0, 0, 0, 0, 0 },
/* U+b904 */ { 0, 0, 0, 0, 0 },
/* U+b905 */ { 0, 0, 0, 0, 0 },
/* U+b906 */ { 0, 0, 0, 0, 0 },
/* U+b907 */ { 0, 0, 0, 0, 0 },
/* U+b908 */ { 0, 0, 0, 0, 0 },
/* U+b909 */ { 0, 0, 0, 0, 0 },
/* U+b90a */ { 0, 0, 0, 0, 0 },
/* U+b90b */ { 0, 0, 0, 0, 0 },
/* U+b90c */ { 0, 0, 0, 0, 0 },
/* U+b90d */ { 0, 0, 0, 0, 0 },
/* U+b90e */ { 0, 0, 0, 0, 0 },
/* U+b90f */ { 0, 0, 0, 0, 0 },
/* U+b910 */ { 0, 0, 0, 0, 0 },
/* U+b911 */ { 0, 0, 0, 0, 0 },
/* U+b912 */ { 0, 0, 0, 0, 0 },
/* U+b913 */ { 0, 0, 0, 0, 0 },
/* U+b914 */ { 0, 0, 0, 0, 0 },
/* U+b915 */ { 0, 0, 0, 0, 0 },
/* U+b916 */ { 0, 0, 0, 0, 0 },
/* U+b917 */ { 0, 0, 0, 0, 0 },
/* U+b918 */ { 0, 0, 0, 0, 0 },
/* U+b919 */ { 0, 0, 0, 0, 0 },
/* U+b91a */ { 0, 0, 0, 0, 0 },
/* U+b91b */ { 0, 0, 0, 0, 0 },
/* U+b91c */ { 0, 0, 0, 0, 0 },
/* U+b91d */ { 0, 0, 0, 0, 0 },
/* U+b91e */ { 0, 0, 0, 0, 0 },
/* U+b91f */ { 0, 0, 0, 0, 0 },
/* U+b920 */ { 0, 0, 0, 0, 0 },
/* U+b921 */ { 0, 0, 0, 0, 0 },
/* U+b922 */ { 0, 0, 0, 0, 0 },
/* U+b923 */ { 0, 0, 0, 0, 0 },
/* U+b924 */ { 0, 0, 0, 0, 0 },
/* U+b925 */ { 0, 0, 0, 0, 0 },
/* U+b926 */ { 0, 0, 0, 0, 0 },
/* U+b927 */ { 0, 0, 0, 0, 0 },
/* U+b928 */ { 0, 0, 0, 0, 0 },
/* U+b929 */ { 0, 0, 0, 0, 0 },
/* U+b92a */ { 0, 0, 0, 0, 0 },
/* U+b92b */ { 0, 0, 0, 0, 0 },
/* U+b92c */ { 0, 0, 0, 0, 0 },
/* U+b92d */ { 0, 0, 0, 0, 0 },
/* U+b92e */ { 0, 0, 0, 0, 0 },
/* U+b92f */ { 0, 0, 0, 0, 0 },
/* U+b930 */ { 0, 0, 0, 0, 0 },
/* U+b931 */ { 0, 0, 0, 0, 0 },
/* U+b932 */ { 0, 0, 0, 0, 0 },
/* U+b933 */ { 0, 0, 0, 0, 0 },
/* U+b934 */ { 0, 0, 0, 0, 0 },
/* U+b935 */ { 0, 0, 0, 0, 0 },
/* U+b936 */ { 0, 0, 0, 0, 0 },
/* U+b937 */ { 0, 0, 0, 0, 0 },
/* U+b938 */ { 0, 0, 0, 0, 0 },
/* U+b939 */ { 0, 0, 0, 0, 0 },
/* U+b93a */ { 0, 0, 0, 0, 0 },
/* U+b93b */ { 0, 0, 0, 0, 0 },
/* U+b93c */ { 0, 0, 0, 0, 0 },
/* U+b93d */ { 0, 0, 0, 0, 0 },
/* U+b93e */ { 0, 0, 0, 0, 0 },
/* U+b93f */ { 0, 0, 0, 0, 0 },
/* U+b940 */ { 0, 0, 0, 0, 0 },
/* U+b941 */ { 0, 0, 0, 0, 0 },
/* U+b942 */ { 0, 0, 0, 0, 0 },
/* U+b943 */ { 0, 0, 0, 0, 0 },
/* U+b944 */ { 0, 0, 0, 0, 0 },
/* U+b945 */ { 0, 0, 0, 0, 0 },
/* U+b946 */ { 0, 0, 0, 0, 0 },
/* U+b947 */ { 0, 0, 0, 0, 0 },
/* U+b948 */ { 0, 0, 0, 0, 0 },
/* U+b949 */ { 0, 0, 0, 0, 0 },
/* U+b94a */ { 0, 0, 0, 0, 0 },
/* U+b94b */ { 0, 0, 0, 0, 0 },
/* U+b94c */ { 0, 0, 0, 0, 0 },
/* U+b94d */ { 0, 0, 0, 0, 0 },
/* U+b94e */ { 0, 0, 0, 0, 0 },
/* U+b94f */ { 0, 0, 0, 0, 0 },
/* U+b950 */ { 0, 0, 0, 0, 0 },
/* U+b951 */ { 0, 0, 0, 0, 0 },
/* U+b952 */ { 0, 0, 0, 0, 0 },
/* U+b953 */ { 0, 0, 0, 0, 0 },
/* U+b954 */ { 0, 0, 0, 0, 0 },
/* U+b955 */ { 0, 0, 0, 0, 0 },
/* U+b956 */ { 0, 0, 0, 0, 0 },
/* U+b957 */ { 0, 0, 0, 0, 0 },
/* U+b958 */ { 0, 0, 0, 0, 0 },
/* U+b959 */ { 0, 0, 0, 0, 0 },
/* U+b95a */ { 0, 0, 0, 0, 0 },
/* U+b95b */ { 0, 0, 0, 0, 0 },
/* U+b95c */ { 0, 0, 0, 0, 0 },
/* U+b95d */ { 0, 0, 0, 0, 0 },
/* U+b95e */ { 0, 0, 0, 0, 0 },
/* U+b95f */ { 0, 0, 0, 0, 0 },
/* U+b960 */ { 0, 0, 0, 0, 0 },
/* U+b961 */ { 0, 0, 0, 0, 0 },
/* U+b962 */ { 0, 0, 0, 0, 0 },
/* U+b963 */ { 0, 0, 0, 0, 0 },
/* U+b964 */ { 0, 0, 0, 0, 0 },
/* U+b965 */ { 0, 0, 0, 0, 0 },
/* U+b966 */ { 0, 0, 0, 0, 0 },
/* U+b967 */ { 0, 0, 0, 0, 0 },
/* U+b968 */ { 0, 0, 0, 0, 0 },
/* U+b969 */ { 0, 0, 0, 0, 0 },
/* U+b96a */ { 0, 0, 0, 0, 0 },
/* U+b96b */ { 0, 0, 0, 0, 0 },
/* U+b96c */ { 0, 0, 0, 0, 0 },
/* U+b96d */ { 0, 0, 0, 0, 0 },
/* U+b96e */ { 0, 0, 0, 0, 0 },
/* U+b96f */ { 0, 0, 0, 0, 0 },
/* U+b970 */ { 0, 0, 0, 0, 0 },
/* U+b971 */ { 0, 0, 0, 0, 0 },
/* U+b972 */ { 0, 0, 0, 0, 0 },
/* U+b973 */ { 0, 0, 0, 0, 0 },
/* U+b974 */ { 0, 0, 0, 0, 0 },
/* U+b975 */ { 0, 0, 0, 0, 0 },
/* U+b976 */ { 0, 0, 0, 0, 0 },
/* U+b977 */ { 0, 0, 0, 0, 0 },
/* U+b978 */ { 0, 0, 0, 0, 0 },
/* U+b979 */ { 0, 0, 0, 0, 0 },
/* U+b97a */ { 0, 0, 0, 0, 0 },
/* U+b97b */ { 0, 0, 0, 0, 0 },
/* U+b97c */ { 0, 0, 0, 0, 0 },
/* U+b97d */ { 0, 0, 0, 0, 0 },
/* U+b97e */ { 0, 0, 0, 0, 0 },
/* U+b97f */ { 0, 0, 0, 0, 0 },
/* U+b980 */ { 0, 0, 0, 0, 0 },
/* U+b981 */ { 0, 0, 0, 0, 0 },
/* U+b982 */ { 0, 0, 0, 0, 0 },
/* U+b983 */ { 0, 0, 0, 0, 0 },
/* U+b984 */ { 0, 0, 0, 0, 0 },
/* U+b985 */ { 0, 0, 0, 0, 0 },
/* U+b986 */ { 0, 0, 0, 0, 0 },
/* U+b987 */ { 0, 0, 0, 0, 0 },
/* U+b988 */ { 0, 0, 0, 0, 0 },
/* U+b989 */ { 0, 0, 0, 0, 0 },
/* U+b98a */ { 0, 0, 0, 0, 0 },
/* U+b98b */ { 0, 0, 0, 0, 0 },
/* U+b98c */ { 0, 0, 0, 0, 0 },
/* U+b98d */ { 0, 0, 0, 0, 0 },
/* U+b98e */ { 0, 0, 0, 0, 0 },
/* U+b98f */ { 0, 0, 0, 0, 0 },
/* U+b990 */ { 0, 0, 0, 0, 0 },
/* U+b991 */ { 0, 0, 0, 0, 0 },
/* U+b992 */ { 0, 0, 0, 0, 0 },
/* U+b993 */ { 0, 0, 0, 0, 0 },
/* U+b994 */ { 0, 0, 0, 0, 0 },
/* U+b995 */ { 0, 0, 0, 0, 0 },
/* U+b996 */ { 0, 0, 0, 0, 0 },
/* U+b997 */ { 0, 0, 0, 0, 0 },
/* U+b998 */ { 0, 0, 0, 0, 0 },
/* U+b999 */ { 0, 0, 0, 0, 0 },
/* U+b99a */ { 0, 0, 0, 0, 0 },
/* U+b99b */ { 0, 0, 0, 0, 0 },
/* U+b99c */ { 0, 0, 0, 0, 0 },
/* U+b99d */ { 0, 0, 0, 0, 0 },
/* U+b99e */ { 0, 0, 0, 0, 0 },
/* U+b99f */ { 0, 0, 0, 0, 0 },
/* U+b9a0 */ { 0, 0, 0, 0, 0 },
/* U+b9a1 */ { 0, 0, 0, 0, 0 },
/* U+b9a2 */ { 0, 0, 0, 0, 0 },
/* U+b9a3 */ { 0, 0, 0, 0, 0 },
/* U+b9a4 */ { 0, 0, 0, 0, 0 },
/* U+b9a5 */ { 0, 0, 0, 0, 0 },
/* U+b9a6 */ { 0, 0, 0, 0, 0 },
/* U+b9a7 */ { 0, 0, 0, 0, 0 },
/* U+b9a8 */ { 0, 0, 0, 0, 0 },
/* U+b9a9 */ { 0, 0, 0, 0, 0 },
/* U+b9aa */ { 0, 0, 0, 0, 0 },
/* U+b9ab */ { 0, 0, 0, 0, 0 },
/* U+b9ac */ { 0, 0, 0, 0, 0 },
/* U+b9ad */ { 0, 0, 0, 0, 0 },
/* U+b9ae */ { 0, 0, 0, 0, 0 },
/* U+b9af */ { 0, 0, 0, 0, 0 },
/* U+b9b0 */ { 0, 0, 0, 0, 0 },
/* U+b9b1 */ { 0, 0, 0, 0, 0 },
/* U+b9b2 */ { 0, 0, 0, 0, 0 },
/* U+b9b3 */ { 0, 0, 0, 0, 0 },
/* U+b9b4 */ { 0, 0, 0, 0, 0 },
/* U+b9b5 */ { 0, 0, 0, 0, 0 },
/* U+b9b6 */ { 0, 0, 0, 0, 0 },
/* U+b9b7 */ { 0, 0, 0, 0, 0 },
/* U+b9b8 */ { 0, 0, 0, 0, 0 },
/* U+b9b9 */ { 0, 0, 0, 0, 0 },
/* U+b9ba */ { 0, 0, 0, 0, 0 },
/* U+b9bb */ { 0, 0, 0, 0, 0 },
/* U+b9bc */ { 0, 0, 0, 0, 0 },
/* U+b9bd */ { 0, 0, 0, 0, 0 },
/* U+b9be */ { 0, 0, 0, 0, 0 },
/* U+b9bf */ { 0, 0, 0, 0, 0 },
/* U+b9c0 */ { 0, 0, 0, 0, 0 },
/* U+b9c1 */ { 0, 0, 0, 0, 0 },
/* U+b9c2 */ { 0, 0, 0, 0, 0 },
/* U+b9c3 */ { 0, 0, 0, 0, 0 },
/* U+b9c4 */ { 0, 0, 0, 0, 0 },
/* U+b9c5 */ { 0, 0, 0, 0, 0 },
/* U+b9c6 */ { 0, 0, 0, 0, 0 },
/* U+b9c7 */ { 0, 0, 0, 0, 0 },
/* U+b9c8 */ { 0, 0, 0, 0, 0 },
/* U+b9c9 */ { 0, 0, 0, 0, 0 },
/* U+b9ca */ { 0, 0, 0, 0, 0 },
/* U+b9cb */ { 0, 0, 0, 0, 0 },
/* U+b9cc */ { 0, 0, 0, 0, 0 },
/* U+b9cd */ { 0, 0, 0, 0, 0 },
/* U+b9ce */ { 0, 0, 0, 0, 0 },
/* U+b9cf */ { 0, 0, 0, 0, 0 },
/* U+b9d0 */ { 0, 0, 0, 0, 0 },
/* U+b9d1 */ { 0, 0, 0, 0, 0 },
/* U+b9d2 */ { 0, 0, 0, 0, 0 },
/* U+b9d3 */ { 0, 0, 0, 0, 0 },
/* U+b9d4 */ { 0, 0, 0, 0, 0 },
/* U+b9d5 */ { 0, 0, 0, 0, 0 },
/* U+b9d6 */ { 0, 0, 0, 0, 0 },
/* U+b9d7 */ { 0, 0, 0, 0, 0 },
/* U+b9d8 */ { 0, 0, 0, 0, 0 },
/* U+b9d9 */ { 0, 0, 0, 0, 0 },
/* U+b9da */ { 0, 0, 0, 0, 0 },
/* U+b9db */ { 0, 0, 0, 0, 0 },
/* U+b9dc */ { 0, 0, 0, 0, 0 },
/* U+b9dd */ { 0, 0, 0, 0, 0 },
/* U+b9de */ { 0, 0, 0, 0, 0 },
/* U+b9df */ { 0, 0, 0, 0, 0 },
/* U+b9e0 */ { 0, 0, 0, 0, 0 },
/* U+b9e1 */ { 0, 0, 0, 0, 0 },
/* U+b9e2 */ { 0, 0, 0, 0, 0 },
/* U+b9e3 */ { 0, 0, 0, 0, 0 },
/* U+b9e4 */ { 0, 0, 0, 0, 0 },
/* U+b9e5 */ { 0, 0, 0, 0, 0 },
/* U+b9e6 */ { 0, 0, 0, 0, 0 },
/* U+b9e7 */ { 0, 0, 0, 0, 0 },
/* U+b9e8 */ { 0, 0, 0, 0, 0 },
/* U+b9e9 */ { 0, 0, 0, 0, 0 },
/* U+b9ea */ { 0, 0, 0, 0, 0 },
/* U+b9eb */ { 0, 0, 0, 0, 0 },
/* U+b9ec */ { 0, 0, 0, 0, 0 },
/* U+b9ed */ { 0, 0, 0, 0, 0 },
/* U+b9ee */ { 0, 0, 0, 0, 0 },
/* U+b9ef */ { 0, 0, 0, 0, 0 },
/* U+b9f0 */ { 0, 0, 0, 0, 0 },
/* U+b9f1 */ { 0, 0, 0, 0, 0 },
/* U+b9f2 */ { 0, 0, 0, 0, 0 },
/* U+b9f3 */ { 0, 0, 0, 0, 0 },
/* U+b9f4 */ { 0, 0, 0, 0, 0 },
/* U+b9f5 */ { 0, 0, 0, 0, 0 },
/* U+b9f6 */ { 0, 0, 0, 0, 0 },
/* U+b9f7 */ { 0, 0, 0, 0, 0 },
/* U+b9f8 */ { 0, 0, 0, 0, 0 },
/* U+b9f9 */ { 0, 0, 0, 0, 0 },
/* U+b9fa */ { 0, 0, 0, 0, 0 },
/* U+b9fb */ { 0, 0, 0, 0, 0 },
/* U+b9fc */ { 0, 0, 0, 0, 0 },
/* U+b9fd */ { 0, 0, 0, 0, 0 },
/* U+b9fe */ { 0, 0, 0, 0, 0 },
/* U+b9ff */ { 0, 0, 0, 0, 0 },
/* U+ba00 */ { 0, 0, 0, 0, 0 },
/* U+ba01 */ { 0, 0, 0, 0, 0 },
/* U+ba02 */ { 0, 0, 0, 0, 0 },
/* U+ba03 */ { 0, 0, 0, 0, 0 },
/* U+ba04 */ { 0, 0, 0, 0, 0 },
/* U+ba05 */ { 0, 0, 0, 0, 0 },
/* U+ba06 */ { 0, 0, 0, 0, 0 },
/* U+ba07 */ { 0, 0, 0, 0, 0 },
/* U+ba08 */ { 0, 0, 0, 0, 0 },
/* U+ba09 */ { 0, 0, 0, 0, 0 },
/* U+ba0a */ { 0, 0, 0, 0, 0 },
/* U+ba0b */ { 0, 0, 0, 0, 0 },
/* U+ba0c */ { 0, 0, 0, 0, 0 },
/* U+ba0d */ { 0, 0, 0, 0, 0 },
/* U+ba0e */ { 0, 0, 0, 0, 0 },
/* U+ba0f */ { 0, 0, 0, 0, 0 },
/* U+ba10 */ { 0, 0, 0, 0, 0 },
/* U+ba11 */ { 0, 0, 0, 0, 0 },
/* U+ba12 */ { 0, 0, 0, 0, 0 },
/* U+ba13 */ { 0, 0, 0, 0, 0 },
/* U+ba14 */ { 0, 0, 0, 0, 0 },
/* U+ba15 */ { 0, 0, 0, 0, 0 },
/* U+ba16 */ { 0, 0, 0, 0, 0 },
/* U+ba17 */ { 0, 0, 0, 0, 0 },
/* U+ba18 */ { 0, 0, 0, 0, 0 },
/* U+ba19 */ { 0, 0, 0, 0, 0 },
/* U+ba1a */ { 0, 0, 0, 0, 0 },
/* U+ba1b */ { 0, 0, 0, 0, 0 },
/* U+ba1c */ { 0, 0, 0, 0, 0 },
/* U+ba1d */ { 0, 0, 0, 0, 0 },
/* U+ba1e */ { 0, 0, 0, 0, 0 },
/* U+ba1f */ { 0, 0, 0, 0, 0 },
/* U+ba20 */ { 0, 0, 0, 0, 0 },
/* U+ba21 */ { 0, 0, 0, 0, 0 },
/* U+ba22 */ { 0, 0, 0, 0, 0 },
/* U+ba23 */ { 0, 0, 0, 0, 0 },
/* U+ba24 */ { 0, 0, 0, 0, 0 },
/* U+ba25 */ { 0, 0, 0, 0, 0 },
/* U+ba26 */ { 0, 0, 0, 0, 0 },
/* U+ba27 */ { 0, 0, 0, 0, 0 },
/* U+ba28 */ { 0, 0, 0, 0, 0 },
/* U+ba29 */ { 0, 0, 0, 0, 0 },
/* U+ba2a */ { 0, 0, 0, 0, 0 },
/* U+ba2b */ { 0, 0, 0, 0, 0 },
/* U+ba2c */ { 0, 0, 0, 0, 0 },
/* U+ba2d */ { 0, 0, 0, 0, 0 },
/* U+ba2e */ { 0, 0, 0, 0, 0 },
/* U+ba2f */ { 0, 0, 0, 0, 0 },
/* U+ba30 */ { 0, 0, 0, 0, 0 },
/* U+ba31 */ { 0, 0, 0, 0, 0 },
/* U+ba32 */ { 0, 0, 0, 0, 0 },
/* U+ba33 */ { 0, 0, 0, 0, 0 },
/* U+ba34 */ { 0, 0, 0, 0, 0 },
/* U+ba35 */ { 0, 0, 0, 0, 0 },
/* U+ba36 */ { 0, 0, 0, 0, 0 },
/* U+ba37 */ { 0, 0, 0, 0, 0 },
/* U+ba38 */ { 0, 0, 0, 0, 0 },
/* U+ba39 */ { 0, 0, 0, 0, 0 },
/* U+ba3a */ { 0, 0, 0, 0, 0 },
/* U+ba3b */ { 0, 0, 0, 0, 0 },
/* U+ba3c */ { 0, 0, 0, 0, 0 },
/* U+ba3d */ { 0, 0, 0, 0, 0 },
/* U+ba3e */ { 0, 0, 0, 0, 0 },
/* U+ba3f */ { 0, 0, 0, 0, 0 },
/* U+ba40 */ { 0, 0, 0, 0, 0 },
/* U+ba41 */ { 0, 0, 0, 0, 0 },
/* U+ba42 */ { 0, 0, 0, 0, 0 },
/* U+ba43 */ { 0, 0, 0, 0, 0 },
/* U+ba44 */ { 0, 0, 0, 0, 0 },
/* U+ba45 */ { 0, 0, 0, 0, 0 },
/* U+ba46 */ { 0, 0, 0, 0, 0 },
/* U+ba47 */ { 0, 0, 0, 0, 0 },
/* U+ba48 */ { 0, 0, 0, 0, 0 },
/* U+ba49 */ { 0, 0, 0, 0, 0 },
/* U+ba4a */ { 0, 0, 0, 0, 0 },
/* U+ba4b */ { 0, 0, 0, 0, 0 },
/* U+ba4c */ { 0, 0, 0, 0, 0 },
/* U+ba4d */ { 0, 0, 0, 0, 0 },
/* U+ba4e */ { 0, 0, 0, 0, 0 },
/* U+ba4f */ { 0, 0, 0, 0, 0 },
/* U+ba50 */ { 0, 0, 0, 0, 0 },
/* U+ba51 */ { 0, 0, 0, 0, 0 },
/* U+ba52 */ { 0, 0, 0, 0, 0 },
/* U+ba53 */ { 0, 0, 0, 0, 0 },
/* U+ba54 */ { 0, 0, 0, 0, 0 },
/* U+ba55 */ { 0, 0, 0, 0, 0 },
/* U+ba56 */ { 0, 0, 0, 0, 0 },
/* U+ba57 */ { 0, 0, 0, 0, 0 },
/* U+ba58 */ { 0, 0, 0, 0, 0 },
/* U+ba59 */ { 0, 0, 0, 0, 0 },
/* U+ba5a */ { 0, 0, 0, 0, 0 },
/* U+ba5b */ { 0, 0, 0, 0, 0 },
/* U+ba5c */ { 0, 0, 0, 0, 0 },
/* U+ba5d */ { 0, 0, 0, 0, 0 },
/* U+ba5e */ { 0, 0, 0, 0, 0 },
/* U+ba5f */ { 0, 0, 0, 0, 0 },
/* U+ba60 */ { 0, 0, 0, 0, 0 },
/* U+ba61 */ { 0, 0, 0, 0, 0 },
/* U+ba62 */ { 0, 0, 0, 0, 0 },
/* U+ba63 */ { 0, 0, 0, 0, 0 },
/* U+ba64 */ { 0, 0, 0, 0, 0 },
/* U+ba65 */ { 0, 0, 0, 0, 0 },
/* U+ba66 */ { 0, 0, 0, 0, 0 },
/* U+ba67 */ { 0, 0, 0, 0, 0 },
/* U+ba68 */ { 0, 0, 0, 0, 0 },
/* U+ba69 */ { 0, 0, 0, 0, 0 },
/* U+ba6a */ { 0, 0, 0, 0, 0 },
/* U+ba6b */ { 0, 0, 0, 0, 0 },
/* U+ba6c */ { 0, 0, 0, 0, 0 },
/* U+ba6d */ { 0, 0, 0, 0, 0 },
/* U+ba6e */ { 0, 0, 0, 0, 0 },
/* U+ba6f */ { 0, 0, 0, 0, 0 },
/* U+ba70 */ { 0, 0, 0, 0, 0 },
/* U+ba71 */ { 0, 0, 0, 0, 0 },
/* U+ba72 */ { 0, 0, 0, 0, 0 },
/* U+ba73 */ { 0, 0, 0, 0, 0 },
/* U+ba74 */ { 0, 0, 0, 0, 0 },
/* U+ba75 */ { 0, 0, 0, 0, 0 },
/* U+ba76 */ { 0, 0, 0, 0, 0 },
/* U+ba77 */ { 0, 0, 0, 0, 0 },
/* U+ba78 */ { 0, 0, 0, 0, 0 },
/* U+ba79 */ { 0, 0, 0, 0, 0 },
/* U+ba7a */ { 0, 0, 0, 0, 0 },
/* U+ba7b */ { 0, 0, 0, 0, 0 },
/* U+ba7c */ { 0, 0, 0, 0, 0 },
/* U+ba7d */ { 0, 0, 0, 0, 0 },
/* U+ba7e */ { 0, 0, 0, 0, 0 },
/* U+ba7f */ { 0, 0, 0, 0, 0 },
/* U+ba80 */ { 0, 0, 0, 0, 0 },
/* U+ba81 */ { 0, 0, 0, 0, 0 },
/* U+ba82 */ { 0, 0, 0, 0, 0 },
/* U+ba83 */ { 0, 0, 0, 0, 0 },
/* U+ba84 */ { 0, 0, 0, 0, 0 },
/* U+ba85 */ { 0, 0, 0, 0, 0 },
/* U+ba86 */ { 0, 0, 0, 0, 0 },
/* U+ba87 */ { 0, 0, 0, 0, 0 },
/* U+ba88 */ { 0, 0, 0, 0, 0 },
/* U+ba89 */ { 0, 0, 0, 0, 0 },
/* U+ba8a */ { 0, 0, 0, 0, 0 },
/* U+ba8b */ { 0, 0, 0, 0, 0 },
/* U+ba8c */ { 0, 0, 0, 0, 0 },
/* U+ba8d */ { 0, 0, 0, 0, 0 },
/* U+ba8e */ { 0, 0, 0, 0, 0 },
/* U+ba8f */ { 0, 0, 0, 0, 0 },
/* U+ba90 */ { 0, 0, 0, 0, 0 },
/* U+ba91 */ { 0, 0, 0, 0, 0 },
/* U+ba92 */ { 0, 0, 0, 0, 0 },
/* U+ba93 */ { 0, 0, 0, 0, 0 },
/* U+ba94 */ { 0, 0, 0, 0, 0 },
/* U+ba95 */ { 0, 0, 0, 0, 0 },
/* U+ba96 */ { 0, 0, 0, 0, 0 },
/* U+ba97 */ { 0, 0, 0, 0, 0 },
/* U+ba98 */ { 0, 0, 0, 0, 0 },
/* U+ba99 */ { 0, 0, 0, 0, 0 },
/* U+ba9a */ { 0, 0, 0, 0, 0 },
/* U+ba9b */ { 0, 0, 0, 0, 0 },
/* U+ba9c */ { 0, 0, 0, 0, 0 },
/* U+ba9d */ { 0, 0, 0, 0, 0 },
/* U+ba9e */ { 0, 0, 0, 0, 0 },
/* U+ba9f */ { 0, 0, 0, 0, 0 },
/* U+baa0 */ { 0, 0, 0, 0, 0 },
/* U+baa1 */ { 0, 0, 0, 0, 0 },
/* U+baa2 */ { 0, 0, 0, 0, 0 },
/* U+baa3 */ { 0, 0, 0, 0, 0 },
/* U+baa4 */ { 0, 0, 0, 0, 0 },
/* U+baa5 */ { 0, 0, 0, 0, 0 },
/* U+baa6 */ { 0, 0, 0, 0, 0 },
/* U+baa7 */ { 0, 0, 0, 0, 0 },
/* U+baa8 */ { 0, 0, 0, 0, 0 },
/* U+baa9 */ { 0, 0, 0, 0, 0 },
/* U+baaa */ { 0, 0, 0, 0, 0 },
/* U+baab */ { 0, 0, 0, 0, 0 },
/* U+baac */ { 0, 0, 0, 0, 0 },
/* U+baad */ { 0, 0, 0, 0, 0 },
/* U+baae */ { 0, 0, 0, 0, 0 },
/* U+baaf */ { 0, 0, 0, 0, 0 },
/* U+bab0 */ { 0, 0, 0, 0, 0 },
/* U+bab1 */ { 0, 0, 0, 0, 0 },
/* U+bab2 */ { 0, 0, 0, 0, 0 },
/* U+bab3 */ { 0, 0, 0, 0, 0 },
/* U+bab4 */ { 0, 0, 0, 0, 0 },
/* U+bab5 */ { 0, 0, 0, 0, 0 },
/* U+bab6 */ { 0, 0, 0, 0, 0 },
/* U+bab7 */ { 0, 0, 0, 0, 0 },
/* U+bab8 */ { 0, 0, 0, 0, 0 },
/* U+bab9 */ { 0, 0, 0, 0, 0 },
/* U+baba */ { 0, 0, 0, 0, 0 },
/* U+babb */ { 0, 0, 0, 0, 0 },
/* U+babc */ { 0, 0, 0, 0, 0 },
/* U+babd */ { 0, 0, 0, 0, 0 },
/* U+babe */ { 0, 0, 0, 0, 0 },
/* U+babf */ { 0, 0, 0, 0, 0 },
/* U+bac0 */ { 0, 0, 0, 0, 0 },
/* U+bac1 */ { 0, 0, 0, 0, 0 },
/* U+bac2 */ { 0, 0, 0, 0, 0 },
/* U+bac3 */ { 0, 0, 0, 0, 0 },
/* U+bac4 */ { 0, 0, 0, 0, 0 },
/* U+bac5 */ { 0, 0, 0, 0, 0 },
/* U+bac6 */ { 0, 0, 0, 0, 0 },
/* U+bac7 */ { 0, 0, 0, 0, 0 },
/* U+bac8 */ { 0, 0, 0, 0, 0 },
/* U+bac9 */ { 0, 0, 0, 0, 0 },
/* U+baca */ { 0, 0, 0, 0, 0 },
/* U+bacb */ { 0, 0, 0, 0, 0 },
/* U+bacc */ { 0, 0, 0, 0, 0 },
/* U+bacd */ { 0, 0, 0, 0, 0 },
/* U+bace */ { 0, 0, 0, 0, 0 },
/* U+bacf */ { 0, 0, 0, 0, 0 },
/* U+bad0 */ { 0, 0, 0, 0, 0 },
/* U+bad1 */ { 0, 0, 0, 0, 0 },
/* U+bad2 */ { 0, 0, 0, 0, 0 },
/* U+bad3 */ { 0, 0, 0, 0, 0 },
/* U+bad4 */ { 0, 0, 0, 0, 0 },
/* U+bad5 */ { 0, 0, 0, 0, 0 },
/* U+bad6 */ { 0, 0, 0, 0, 0 },
/* U+bad7 */ { 0, 0, 0, 0, 0 },
/* U+bad8 */ { 0, 0, 0, 0, 0 },
/* U+bad9 */ { 0, 0, 0, 0, 0 },
/* U+bada */ { 0, 0, 0, 0, 0 },
/* U+badb */ { 0, 0, 0, 0, 0 },
/* U+badc */ { 0, 0, 0, 0, 0 },
/* U+badd */ { 0, 0, 0, 0, 0 },
/* U+bade */ { 0, 0, 0, 0, 0 },
/* U+badf */ { 0, 0, 0, 0, 0 },
/* U+bae0 */ { 0, 0, 0, 0, 0 },
/* U+bae1 */ { 0, 0, 0, 0, 0 },
/* U+bae2 */ { 0, 0, 0, 0, 0 },
/* U+bae3 */ { 0, 0, 0, 0, 0 },
/* U+bae4 */ { 0, 0, 0, 0, 0 },
/* U+bae5 */ { 0, 0, 0, 0, 0 },
/* U+bae6 */ { 0, 0, 0, 0, 0 },
/* U+bae7 */ { 0, 0, 0, 0, 0 },
/* U+bae8 */ { 0, 0, 0, 0, 0 },
/* U+bae9 */ { 0, 0, 0, 0, 0 },
/* U+baea */ { 0, 0, 0, 0, 0 },
/* U+baeb */ { 0, 0, 0, 0, 0 },
/* U+baec */ { 0, 0, 0, 0, 0 },
/* U+baed */ { 0, 0, 0, 0, 0 },
/* U+baee */ { 0, 0, 0, 0, 0 },
/* U+baef */ { 0, 0, 0, 0, 0 },
/* U+baf0 */ { 0, 0, 0, 0, 0 },
/* U+baf1 */ { 0, 0, 0, 0, 0 },
/* U+baf2 */ { 0, 0, 0, 0, 0 },
/* U+baf3 */ { 0, 0, 0, 0, 0 },
/* U+baf4 */ { 0, 0, 0, 0, 0 },
/* U+baf5 */ { 0, 0, 0, 0, 0 },
/* U+baf6 */ { 0, 0, 0, 0, 0 },
/* U+baf7 */ { 0, 0, 0, 0, 0 },
/* U+baf8 */ { 0, 0, 0, 0, 0 },
/* U+baf9 */ { 0, 0, 0, 0, 0 },
/* U+bafa */ { 0, 0, 0, 0, 0 },
/* U+bafb */ { 0, 0, 0, 0, 0 },
/* U+bafc */ { 0, 0, 0, 0, 0 },
/* U+bafd */ { 0, 0, 0, 0, 0 },
/* U+bafe */ { 0, 0, 0, 0, 0 },
/* U+baff */ { 0, 0, 0, 0, 0 },
/* U+bb00 */ { 0, 0, 0, 0, 0 },
/* U+bb01 */ { 0, 0, 0, 0, 0 },
/* U+bb02 */ { 0, 0, 0, 0, 0 },
/* U+bb03 */ { 0, 0, 0, 0, 0 },
/* U+bb04 */ { 0, 0, 0, 0, 0 },
/* U+bb05 */ { 0, 0, 0, 0, 0 },
/* U+bb06 */ { 0, 0, 0, 0, 0 },
/* U+bb07 */ { 0, 0, 0, 0, 0 },
/* U+bb08 */ { 0, 0, 0, 0, 0 },
/* U+bb09 */ { 0, 0, 0, 0, 0 },
/* U+bb0a */ { 0, 0, 0, 0, 0 },
/* U+bb0b */ { 0, 0, 0, 0, 0 },
/* U+bb0c */ { 0, 0, 0, 0, 0 },
/* U+bb0d */ { 0, 0, 0, 0, 0 },
/* U+bb0e */ { 0, 0, 0, 0, 0 },
/* U+bb0f */ { 0, 0, 0, 0, 0 },
/* U+bb10 */ { 0, 0, 0, 0, 0 },
/* U+bb11 */ { 0, 0, 0, 0, 0 },
/* U+bb12 */ { 0, 0, 0, 0, 0 },
/* U+bb13 */ { 0, 0, 0, 0, 0 },
/* U+bb14 */ { 0, 0, 0, 0, 0 },
/* U+bb15 */ { 0, 0, 0, 0, 0 },
/* U+bb16 */ { 0, 0, 0, 0, 0 },
/* U+bb17 */ { 0, 0, 0, 0, 0 },
/* U+bb18 */ { 0, 0, 0, 0, 0 },
/* U+bb19 */ { 0, 0, 0, 0, 0 },
/* U+bb1a */ { 0, 0, 0, 0, 0 },
/* U+bb1b */ { 0, 0, 0, 0, 0 },
/* U+bb1c */ { 0, 0, 0, 0, 0 },
/* U+bb1d */ { 0, 0, 0, 0, 0 },
/* U+bb1e */ { 0, 0, 0, 0, 0 },
/* U+bb1f */ { 0, 0, 0, 0, 0 },
/* U+bb20 */ { 0, 0, 0, 0, 0 },
/* U+bb21 */ { 0, 0, 0, 0, 0 },
/* U+bb22 */ { 0, 0, 0, 0, 0 },
/* U+bb23 */ { 0, 0, 0, 0, 0 },
/* U+bb24 */ { 0, 0, 0, 0, 0 },
/* U+bb25 */ { 0, 0, 0, 0, 0 },
/* U+bb26 */ { 0, 0, 0, 0, 0 },
/* U+bb27 */ { 0, 0, 0, 0, 0 },
/* U+bb28 */ { 0, 0, 0, 0, 0 },
/* U+bb29 */ { 0, 0, 0, 0, 0 },
/* U+bb2a */ { 0, 0, 0, 0, 0 },
/* U+bb2b */ { 0, 0, 0, 0, 0 },
/* U+bb2c */ { 0, 0, 0, 0, 0 },
/* U+bb2d */ { 0, 0, 0, 0, 0 },
/* U+bb2e */ { 0, 0, 0, 0, 0 },
/* U+bb2f */ { 0, 0, 0, 0, 0 },
/* U+bb30 */ { 0, 0, 0, 0, 0 },
/* U+bb31 */ { 0, 0, 0, 0, 0 },
/* U+bb32 */ { 0, 0, 0, 0, 0 },
/* U+bb33 */ { 0, 0, 0, 0, 0 },
/* U+bb34 */ { 0, 0, 0, 0, 0 },
/* U+bb35 */ { 0, 0, 0, 0, 0 },
/* U+bb36 */ { 0, 0, 0, 0, 0 },
/* U+bb37 */ { 0, 0, 0, 0, 0 },
/* U+bb38 */ { 0, 0, 0, 0, 0 },
/* U+bb39 */ { 0, 0, 0, 0, 0 },
/* U+bb3a */ { 0, 0, 0, 0, 0 },
/* U+bb3b */ { 0, 0, 0, 0, 0 },
/* U+bb3c */ { 0, 0, 0, 0, 0 },
/* U+bb3d */ { 0, 0, 0, 0, 0 },
/* U+bb3e */ { 0, 0, 0, 0, 0 },
/* U+bb3f */ { 0, 0, 0, 0, 0 },
/* U+bb40 */ { 0, 0, 0, 0, 0 },
/* U+bb41 */ { 0, 0, 0, 0, 0 },
/* U+bb42 */ { 0, 0, 0, 0, 0 },
/* U+bb43 */ { 0, 0, 0, 0, 0 },
/* U+bb44 */ { 0, 0, 0, 0, 0 },
/* U+bb45 */ { 0, 0, 0, 0, 0 },
/* U+bb46 */ { 0, 0, 0, 0, 0 },
/* U+bb47 */ { 0, 0, 0, 0, 0 },
/* U+bb48 */ { 0, 0, 0, 0, 0 },
/* U+bb49 */ { 0, 0, 0, 0, 0 },
/* U+bb4a */ { 0, 0, 0, 0, 0 },
/* U+bb4b */ { 0, 0, 0, 0, 0 },
/* U+bb4c */ { 0, 0, 0, 0, 0 },
/* U+bb4d */ { 0, 0, 0, 0, 0 },
/* U+bb4e */ { 0, 0, 0, 0, 0 },
/* U+bb4f */ { 0, 0, 0, 0, 0 },
/* U+bb50 */ { 0, 0, 0, 0, 0 },
/* U+bb51 */ { 0, 0, 0, 0, 0 },
/* U+bb52 */ { 0, 0, 0, 0, 0 },
/* U+bb53 */ { 0, 0, 0, 0, 0 },
/* U+bb54 */ { 0, 0, 0, 0, 0 },
/* U+bb55 */ { 0, 0, 0, 0, 0 },
/* U+bb56 */ { 0, 0, 0, 0, 0 },
/* U+bb57 */ { 0, 0, 0, 0, 0 },
/* U+bb58 */ { 0, 0, 0, 0, 0 },
/* U+bb59 */ { 0, 0, 0, 0, 0 },
/* U+bb5a */ { 0, 0, 0, 0, 0 },
/* U+bb5b */ { 0, 0, 0, 0, 0 },
/* U+bb5c */ { 0, 0, 0, 0, 0 },
/* U+bb5d */ { 0, 0, 0, 0, 0 },
/* U+bb5e */ { 0, 0, 0, 0, 0 },
/* U+bb5f */ { 0, 0, 0, 0, 0 },
/* U+bb60 */ { 0, 0, 0, 0, 0 },
/* U+bb61 */ { 0, 0, 0, 0, 0 },
/* U+bb62 */ { 0, 0, 0, 0, 0 },
/* U+bb63 */ { 0, 0, 0, 0, 0 },
/* U+bb64 */ { 0, 0, 0, 0, 0 },
/* U+bb65 */ { 0, 0, 0, 0, 0 },
/* U+bb66 */ { 0, 0, 0, 0, 0 },
/* U+bb67 */ { 0, 0, 0, 0, 0 },
/* U+bb68 */ { 0, 0, 0, 0, 0 },
/* U+bb69 */ { 0, 0, 0, 0, 0 },
/* U+bb6a */ { 0, 0, 0, 0, 0 },
/* U+bb6b */ { 0, 0, 0, 0, 0 },
/* U+bb6c */ { 0, 0, 0, 0, 0 },
/* U+bb6d */ { 0, 0, 0, 0, 0 },
/* U+bb6e */ { 0, 0, 0, 0, 0 },
/* U+bb6f */ { 0, 0, 0, 0, 0 },
/* U+bb70 */ { 0, 0, 0, 0, 0 },
/* U+bb71 */ { 0, 0, 0, 0, 0 },
/* U+bb72 */ { 0, 0, 0, 0, 0 },
/* U+bb73 */ { 0, 0, 0, 0, 0 },
/* U+bb74 */ { 0, 0, 0, 0, 0 },
/* U+bb75 */ { 0, 0, 0, 0, 0 },
/* U+bb76 */ { 0, 0, 0, 0, 0 },
/* U+bb77 */ { 0, 0, 0, 0, 0 },
/* U+bb78 */ { 0, 0, 0, 0, 0 },
/* U+bb79 */ { 0, 0, 0, 0, 0 },
/* U+bb7a */ { 0, 0, 0, 0, 0 },
/* U+bb7b */ { 0, 0, 0, 0, 0 },
/* U+bb7c */ { 0, 0, 0, 0, 0 },
/* U+bb7d */ { 0, 0, 0, 0, 0 },
/* U+bb7e */ { 0, 0, 0, 0, 0 },
/* U+bb7f */ { 0, 0, 0, 0, 0 },
/* U+bb80 */ { 0, 0, 0, 0, 0 },
/* U+bb81 */ { 0, 0, 0, 0, 0 },
/* U+bb82 */ { 0, 0, 0, 0, 0 },
/* U+bb83 */ { 0, 0, 0, 0, 0 },
/* U+bb84 */ { 0, 0, 0, 0, 0 },
/* U+bb85 */ { 0, 0, 0, 0, 0 },
/* U+bb86 */ { 0, 0, 0, 0, 0 },
/* U+bb87 */ { 0, 0, 0, 0, 0 },
/* U+bb88 */ { 0, 0, 0, 0, 0 },
/* U+bb89 */ { 0, 0, 0, 0, 0 },
/* U+bb8a */ { 0, 0, 0, 0, 0 },
/* U+bb8b */ { 0, 0, 0, 0, 0 },
/* U+bb8c */ { 0, 0, 0, 0, 0 },
/* U+bb8d */ { 0, 0, 0, 0, 0 },
/* U+bb8e */ { 0, 0, 0, 0, 0 },
/* U+bb8f */ { 0, 0, 0, 0, 0 },
/* U+bb90 */ { 0, 0, 0, 0, 0 },
/* U+bb91 */ { 0, 0, 0, 0, 0 },
/* U+bb92 */ { 0, 0, 0, 0, 0 },
/* U+bb93 */ { 0, 0, 0, 0, 0 },
/* U+bb94 */ { 0, 0, 0, 0, 0 },
/* U+bb95 */ { 0, 0, 0, 0, 0 },
/* U+bb96 */ { 0, 0, 0, 0, 0 },
/* U+bb97 */ { 0, 0, 0, 0, 0 },
/* U+bb98 */ { 0, 0, 0, 0, 0 },
/* U+bb99 */ { 0, 0, 0, 0, 0 },
/* U+bb9a */ { 0, 0, 0, 0, 0 },
/* U+bb9b */ { 0, 0, 0, 0, 0 },
/* U+bb9c */ { 0, 0, 0, 0, 0 },
/* U+bb9d */ { 0, 0, 0, 0, 0 },
/* U+bb9e */ { 0, 0, 0, 0, 0 },
/* U+bb9f */ { 0, 0, 0, 0, 0 },
/* U+bba0 */ { 0, 0, 0, 0, 0 },
/* U+bba1 */ { 0, 0, 0, 0, 0 },
/* U+bba2 */ { 0, 0, 0, 0, 0 },
/* U+bba3 */ { 0, 0, 0, 0, 0 },
/* U+bba4 */ { 0, 0, 0, 0, 0 },
/* U+bba5 */ { 0, 0, 0, 0, 0 },
/* U+bba6 */ { 0, 0, 0, 0, 0 },
/* U+bba7 */ { 0, 0, 0, 0, 0 },
/* U+bba8 */ { 0, 0, 0, 0, 0 },
/* U+bba9 */ { 0, 0, 0, 0, 0 },
/* U+bbaa */ { 0, 0, 0, 0, 0 },
/* U+bbab */ { 0, 0, 0, 0, 0 },
/* U+bbac */ { 0, 0, 0, 0, 0 },
/* U+bbad */ { 0, 0, 0, 0, 0 },
/* U+bbae */ { 0, 0, 0, 0, 0 },
/* U+bbaf */ { 0, 0, 0, 0, 0 },
/* U+bbb0 */ { 0, 0, 0, 0, 0 },
/* U+bbb1 */ { 0, 0, 0, 0, 0 },
/* U+bbb2 */ { 0, 0, 0, 0, 0 },
/* U+bbb3 */ { 0, 0, 0, 0, 0 },
/* U+bbb4 */ { 0, 0, 0, 0, 0 },
/* U+bbb5 */ { 0, 0, 0, 0, 0 },
/* U+bbb6 */ { 0, 0, 0, 0, 0 },
/* U+bbb7 */ { 0, 0, 0, 0, 0 },
/* U+bbb8 */ { 0, 0, 0, 0, 0 },
/* U+bbb9 */ { 0, 0, 0, 0, 0 },
/* U+bbba */ { 0, 0, 0, 0, 0 },
/* U+bbbb */ { 0, 0, 0, 0, 0 },
/* U+bbbc */ { 0, 0, 0, 0, 0 },
/* U+bbbd */ { 0, 0, 0, 0, 0 },
/* U+bbbe */ { 0, 0, 0, 0, 0 },
/* U+bbbf */ { 0, 0, 0, 0, 0 },
/* U+bbc0 */ { 0, 0, 0, 0, 0 },
/* U+bbc1 */ { 0, 0, 0, 0, 0 },
/* U+bbc2 */ { 0, 0, 0, 0, 0 },
/* U+bbc3 */ { 0, 0, 0, 0, 0 },
/* U+bbc4 */ { 0, 0, 0, 0, 0 },
/* U+bbc5 */ { 0, 0, 0, 0, 0 },
/* U+bbc6 */ { 0, 0, 0, 0, 0 },
/* U+bbc7 */ { 0, 0, 0, 0, 0 },
/* U+bbc8 */ { 0, 0, 0, 0, 0 },
/* U+bbc9 */ { 0, 0, 0, 0, 0 },
/* U+bbca */ { 0, 0, 0, 0, 0 },
/* U+bbcb */ { 0, 0, 0, 0, 0 },
/* U+bbcc */ { 0, 0, 0, 0, 0 },
/* U+bbcd */ { 0, 0, 0, 0, 0 },
/* U+bbce */ { 0, 0, 0, 0, 0 },
/* U+bbcf */ { 0, 0, 0, 0, 0 },
/* U+bbd0 */ { 0, 0, 0, 0, 0 },
/* U+bbd1 */ { 0, 0, 0, 0, 0 },
/* U+bbd2 */ { 0, 0, 0, 0, 0 },
/* U+bbd3 */ { 0, 0, 0, 0, 0 },
/* U+bbd4 */ { 0, 0, 0, 0, 0 },
/* U+bbd5 */ { 0, 0, 0, 0, 0 },
/* U+bbd6 */ { 0, 0, 0, 0, 0 },
/* U+bbd7 */ { 0, 0, 0, 0, 0 },
/* U+bbd8 */ { 0, 0, 0, 0, 0 },
/* U+bbd9 */ { 0, 0, 0, 0, 0 },
/* U+bbda */ { 0, 0, 0, 0, 0 },
/* U+bbdb */ { 0, 0, 0, 0, 0 },
/* U+bbdc */ { 0, 0, 0, 0, 0 },
/* U+bbdd */ { 0, 0, 0, 0, 0 },
/* U+bbde */ { 0, 0, 0, 0, 0 },
/* U+bbdf */ { 0, 0, 0, 0, 0 },
/* U+bbe0 */ { 0, 0, 0, 0, 0 },
/* U+bbe1 */ { 0, 0, 0, 0, 0 },
/* U+bbe2 */ { 0, 0, 0, 0, 0 },
/* U+bbe3 */ { 0, 0, 0, 0, 0 },
/* U+bbe4 */ { 0, 0, 0, 0, 0 },
/* U+bbe5 */ { 0, 0, 0, 0, 0 },
/* U+bbe6 */ { 0, 0, 0, 0, 0 },
/* U+bbe7 */ { 0, 0, 0, 0, 0 },
/* U+bbe8 */ { 0, 0, 0, 0, 0 },
/* U+bbe9 */ { 0, 0, 0, 0, 0 },
/* U+bbea */ { 0, 0, 0, 0, 0 },
/* U+bbeb */ { 0, 0, 0, 0, 0 },
/* U+bbec */ { 0, 0, 0, 0, 0 },
/* U+bbed */ { 0, 0, 0, 0, 0 },
/* U+bbee */ { 0, 0, 0, 0, 0 },
/* U+bbef */ { 0, 0, 0, 0, 0 },
/* U+bbf0 */ { 0, 0, 0, 0, 0 },
/* U+bbf1 */ { 0, 0, 0, 0, 0 },
/* U+bbf2 */ { 0, 0, 0, 0, 0 },
/* U+bbf3 */ { 0, 0, 0, 0, 0 },
/* U+bbf4 */ { 0, 0, 0, 0, 0 },
/* U+bbf5 */ { 0, 0, 0, 0, 0 },
/* U+bbf6 */ { 0, 0, 0, 0, 0 },
/* U+bbf7 */ { 0, 0, 0, 0, 0 },
/* U+bbf8 */ { 0, 0, 0, 0, 0 },
/* U+bbf9 */ { 0, 0, 0, 0, 0 },
/* U+bbfa */ { 0, 0, 0, 0, 0 },
/* U+bbfb */ { 0, 0, 0, 0, 0 },
/* U+bbfc */ { 0, 0, 0, 0, 0 },
/* U+bbfd */ { 0, 0, 0, 0, 0 },
/* U+bbfe */ { 0, 0, 0, 0, 0 },
/* U+bbff */ { 0, 0, 0, 0, 0 },
/* U+bc00 */ { 0, 0, 0, 0, 0 },
/* U+bc01 */ { 0, 0, 0, 0, 0 },
/* U+bc02 */ { 0, 0, 0, 0, 0 },
/* U+bc03 */ { 0, 0, 0, 0, 0 },
/* U+bc04 */ { 0, 0, 0, 0, 0 },
/* U+bc05 */ { 0, 0, 0, 0, 0 },
/* U+bc06 */ { 0, 0, 0, 0, 0 },
/* U+bc07 */ { 0, 0, 0, 0, 0 },
/* U+bc08 */ { 0, 0, 0, 0, 0 },
/* U+bc09 */ { 0, 0, 0, 0, 0 },
/* U+bc0a */ { 0, 0, 0, 0, 0 },
/* U+bc0b */ { 0, 0, 0, 0, 0 },
/* U+bc0c */ { 0, 0, 0, 0, 0 },
/* U+bc0d */ { 0, 0, 0, 0, 0 },
/* U+bc0e */ { 0, 0, 0, 0, 0 },
/* U+bc0f */ { 0, 0, 0, 0, 0 },
/* U+bc10 */ { 0, 0, 0, 0, 0 },
/* U+bc11 */ { 0, 0, 0, 0, 0 },
/* U+bc12 */ { 0, 0, 0, 0, 0 },
/* U+bc13 */ { 0, 0, 0, 0, 0 },
/* U+bc14 */ { 0, 0, 0, 0, 0 },
/* U+bc15 */ { 0, 0, 0, 0, 0 },
/* U+bc16 */ { 0, 0, 0, 0, 0 },
/* U+bc17 */ { 0, 0, 0, 0, 0 },
/* U+bc18 */ { 0, 0, 0, 0, 0 },
/* U+bc19 */ { 0, 0, 0, 0, 0 },
/* U+bc1a */ { 0, 0, 0, 0, 0 },
/* U+bc1b */ { 0, 0, 0, 0, 0 },
/* U+bc1c */ { 0, 0, 0, 0, 0 },
/* U+bc1d */ { 0, 0, 0, 0, 0 },
/* U+bc1e */ { 0, 0, 0, 0, 0 },
/* U+bc1f */ { 0, 0, 0, 0, 0 },
/* U+bc20 */ { 0, 0, 0, 0, 0 },
/* U+bc21 */ { 0, 0, 0, 0, 0 },
/* U+bc22 */ { 0, 0, 0, 0, 0 },
/* U+bc23 */ { 0, 0, 0, 0, 0 },
/* U+bc24 */ { 0, 0, 0, 0, 0 },
/* U+bc25 */ { 0, 0, 0, 0, 0 },
/* U+bc26 */ { 0, 0, 0, 0, 0 },
/* U+bc27 */ { 0, 0, 0, 0, 0 },
/* U+bc28 */ { 0, 0, 0, 0, 0 },
/* U+bc29 */ { 0, 0, 0, 0, 0 },
/* U+bc2a */ { 0, 0, 0, 0, 0 },
/* U+bc2b */ { 0, 0, 0, 0, 0 },
/* U+bc2c */ { 0, 0, 0, 0, 0 },
/* U+bc2d */ { 0, 0, 0, 0, 0 },
/* U+bc2e */ { 0, 0, 0, 0, 0 },
/* U+bc2f */ { 0, 0, 0, 0, 0 },
/* U+bc30 */ { 0, 0, 0, 0, 0 },
/* U+bc31 */ { 0, 0, 0, 0, 0 },
/* U+bc32 */ { 0, 0, 0, 0, 0 },
/* U+bc33 */ { 0, 0, 0, 0, 0 },
/* U+bc34 */ { 0, 0, 0, 0, 0 },
/* U+bc35 */ { 0, 0, 0, 0, 0 },
/* U+bc36 */ { 0, 0, 0, 0, 0 },
/* U+bc37 */ { 0, 0, 0, 0, 0 },
/* U+bc38 */ { 0, 0, 0, 0, 0 },
/* U+bc39 */ { 0, 0, 0, 0, 0 },
/* U+bc3a */ { 0, 0, 0, 0, 0 },
/* U+bc3b */ { 0, 0, 0, 0, 0 },
/* U+bc3c */ { 0, 0, 0, 0, 0 },
/* U+bc3d */ { 0, 0, 0, 0, 0 },
/* U+bc3e */ { 0, 0, 0, 0, 0 },
/* U+bc3f */ { 0, 0, 0, 0, 0 },
/* U+bc40 */ { 0, 0, 0, 0, 0 },
/* U+bc41 */ { 0, 0, 0, 0, 0 },
/* U+bc42 */ { 0, 0, 0, 0, 0 },
/* U+bc43 */ { 0, 0, 0, 0, 0 },
/* U+bc44 */ { 0, 0, 0, 0, 0 },
/* U+bc45 */ { 0, 0, 0, 0, 0 },
/* U+bc46 */ { 0, 0, 0, 0, 0 },
/* U+bc47 */ { 0, 0, 0, 0, 0 },
/* U+bc48 */ { 0, 0, 0, 0, 0 },
/* U+bc49 */ { 0, 0, 0, 0, 0 },
/* U+bc4a */ { 0, 0, 0, 0, 0 },
/* U+bc4b */ { 0, 0, 0, 0, 0 },
/* U+bc4c */ { 0, 0, 0, 0, 0 },
/* U+bc4d */ { 0, 0, 0, 0, 0 },
/* U+bc4e */ { 0, 0, 0, 0, 0 },
/* U+bc4f */ { 0, 0, 0, 0, 0 },
/* U+bc50 */ { 0, 0, 0, 0, 0 },
/* U+bc51 */ { 0, 0, 0, 0, 0 },
/* U+bc52 */ { 0, 0, 0, 0, 0 },
/* U+bc53 */ { 0, 0, 0, 0, 0 },
/* U+bc54 */ { 0, 0, 0, 0, 0 },
/* U+bc55 */ { 0, 0, 0, 0, 0 },
/* U+bc56 */ { 0, 0, 0, 0, 0 },
/* U+bc57 */ { 0, 0, 0, 0, 0 },
/* U+bc58 */ { 0, 0, 0, 0, 0 },
/* U+bc59 */ { 0, 0, 0, 0, 0 },
/* U+bc5a */ { 0, 0, 0, 0, 0 },
/* U+bc5b */ { 0, 0, 0, 0, 0 },
/* U+bc5c */ { 0, 0, 0, 0, 0 },
/* U+bc5d */ { 0, 0, 0, 0, 0 },
/* U+bc5e */ { 0, 0, 0, 0, 0 },
/* U+bc5f */ { 0, 0, 0, 0, 0 },
/* U+bc60 */ { 0, 0, 0, 0, 0 },
/* U+bc61 */ { 0, 0, 0, 0, 0 },
/* U+bc62 */ { 0, 0, 0, 0, 0 },
/* U+bc63 */ { 0, 0, 0, 0, 0 },
/* U+bc64 */ { 0, 0, 0, 0, 0 },
/* U+bc65 */ { 0, 0, 0, 0, 0 },
/* U+bc66 */ { 0, 0, 0, 0, 0 },
/* U+bc67 */ { 0, 0, 0, 0, 0 },
/* U+bc68 */ { 0, 0, 0, 0, 0 },
/* U+bc69 */ { 0, 0, 0, 0, 0 },
/* U+bc6a */ { 0, 0, 0, 0, 0 },
/* U+bc6b */ { 0, 0, 0, 0, 0 },
/* U+bc6c */ { 0, 0, 0, 0, 0 },
/* U+bc6d */ { 0, 0, 0, 0, 0 },
/* U+bc6e */ { 0, 0, 0, 0, 0 },
/* U+bc6f */ { 0, 0, 0, 0, 0 },
/* U+bc70 */ { 0, 0, 0, 0, 0 },
/* U+bc71 */ { 0, 0, 0, 0, 0 },
/* U+bc72 */ { 0, 0, 0, 0, 0 },
/* U+bc73 */ { 0, 0, 0, 0, 0 },
/* U+bc74 */ { 0, 0, 0, 0, 0 },
/* U+bc75 */ { 0, 0, 0, 0, 0 },
/* U+bc76 */ { 0, 0, 0, 0, 0 },
/* U+bc77 */ { 0, 0, 0, 0, 0 },
/* U+bc78 */ { 0, 0, 0, 0, 0 },
/* U+bc79 */ { 0, 0, 0, 0, 0 },
/* U+bc7a */ { 0, 0, 0, 0, 0 },
/* U+bc7b */ { 0, 0, 0, 0, 0 },
/* U+bc7c */ { 0, 0, 0, 0, 0 },
/* U+bc7d */ { 0, 0, 0, 0, 0 },
/* U+bc7e */ { 0, 0, 0, 0, 0 },
/* U+bc7f */ { 0, 0, 0, 0, 0 },
/* U+bc80 */ { 0, 0, 0, 0, 0 },
/* U+bc81 */ { 0, 0, 0, 0, 0 },
/* U+bc82 */ { 0, 0, 0, 0, 0 },
/* U+bc83 */ { 0, 0, 0, 0, 0 },
/* U+bc84 */ { 0, 0, 0, 0, 0 },
/* U+bc85 */ { 0, 0, 0, 0, 0 },
/* U+bc86 */ { 0, 0, 0, 0, 0 },
/* U+bc87 */ { 0, 0, 0, 0, 0 },
/* U+bc88 */ { 0, 0, 0, 0, 0 },
/* U+bc89 */ { 0, 0, 0, 0, 0 },
/* U+bc8a */ { 0, 0, 0, 0, 0 },
/* U+bc8b */ { 0, 0, 0, 0, 0 },
/* U+bc8c */ { 0, 0, 0, 0, 0 },
/* U+bc8d */ { 0, 0, 0, 0, 0 },
/* U+bc8e */ { 0, 0, 0, 0, 0 },
/* U+bc8f */ { 0, 0, 0, 0, 0 },
/* U+bc90 */ { 0, 0, 0, 0, 0 },
/* U+bc91 */ { 0, 0, 0, 0, 0 },
/* U+bc92 */ { 0, 0, 0, 0, 0 },
/* U+bc93 */ { 0, 0, 0, 0, 0 },
/* U+bc94 */ { 0, 0, 0, 0, 0 },
/* U+bc95 */ { 0, 0, 0, 0, 0 },
/* U+bc96 */ { 0, 0, 0, 0, 0 },
/* U+bc97 */ { 0, 0, 0, 0, 0 },
/* U+bc98 */ { 0, 0, 0, 0, 0 },
/* U+bc99 */ { 0, 0, 0, 0, 0 },
/* U+bc9a */ { 0, 0, 0, 0, 0 },
/* U+bc9b */ { 0, 0, 0, 0, 0 },
/* U+bc9c */ { 0, 0, 0, 0, 0 },
/* U+bc9d */ { 0, 0, 0, 0, 0 },
/* U+bc9e */ { 0, 0, 0, 0, 0 },
/* U+bc9f */ { 0, 0, 0, 0, 0 },
/* U+bca0 */ { 0, 0, 0, 0, 0 },
/* U+bca1 */ { 0, 0, 0, 0, 0 },
/* U+bca2 */ { 0, 0, 0, 0, 0 },
/* U+bca3 */ { 0, 0, 0, 0, 0 },
/* U+bca4 */ { 0, 0, 0, 0, 0 },
/* U+bca5 */ { 0, 0, 0, 0, 0 },
/* U+bca6 */ { 0, 0, 0, 0, 0 },
/* U+bca7 */ { 0, 0, 0, 0, 0 },
/* U+bca8 */ { 0, 0, 0, 0, 0 },
/* U+bca9 */ { 0, 0, 0, 0, 0 },
/* U+bcaa */ { 0, 0, 0, 0, 0 },
/* U+bcab */ { 0, 0, 0, 0, 0 },
/* U+bcac */ { 0, 0, 0, 0, 0 },
/* U+bcad */ { 0, 0, 0, 0, 0 },
/* U+bcae */ { 0, 0, 0, 0, 0 },
/* U+bcaf */ { 0, 0, 0, 0, 0 },
/* U+bcb0 */ { 0, 0, 0, 0, 0 },
/* U+bcb1 */ { 0, 0, 0, 0, 0 },
/* U+bcb2 */ { 0, 0, 0, 0, 0 },
/* U+bcb3 */ { 0, 0, 0, 0, 0 },
/* U+bcb4 */ { 0, 0, 0, 0, 0 },
/* U+bcb5 */ { 0, 0, 0, 0, 0 },
/* U+bcb6 */ { 0, 0, 0, 0, 0 },
/* U+bcb7 */ { 0, 0, 0, 0, 0 },
/* U+bcb8 */ { 0, 0, 0, 0, 0 },
/* U+bcb9 */ { 0, 0, 0, 0, 0 },
/* U+bcba */ { 0, 0, 0, 0, 0 },
/* U+bcbb */ { 0, 0, 0, 0, 0 },
/* U+bcbc */ { 0, 0, 0, 0, 0 },
/* U+bcbd */ { 0, 0, 0, 0, 0 },
/* U+bcbe */ { 0, 0, 0, 0, 0 },
/* U+bcbf */ { 0, 0, 0, 0, 0 },
/* U+bcc0 */ { 0, 0, 0, 0, 0 },
/* U+bcc1 */ { 0, 0, 0, 0, 0 },
/* U+bcc2 */ { 0, 0, 0, 0, 0 },
/* U+bcc3 */ { 0, 0, 0, 0, 0 },
/* U+bcc4 */ { 0, 0, 0, 0, 0 },
/* U+bcc5 */ { 0, 0, 0, 0, 0 },
/* U+bcc6 */ { 0, 0, 0, 0, 0 },
/* U+bcc7 */ { 0, 0, 0, 0, 0 },
/* U+bcc8 */ { 0, 0, 0, 0, 0 },
/* U+bcc9 */ { 0, 0, 0, 0, 0 },
/* U+bcca */ { 0, 0, 0, 0, 0 },
/* U+bccb */ { 0, 0, 0, 0, 0 },
/* U+bccc */ { 0, 0, 0, 0, 0 },
/* U+bccd */ { 0, 0, 0, 0, 0 },
/* U+bcce */ { 0, 0, 0, 0, 0 },
/* U+bccf */ { 0, 0, 0, 0, 0 },
/* U+bcd0 */ { 0, 0, 0, 0, 0 },
/* U+bcd1 */ { 0, 0, 0, 0, 0 },
/* U+bcd2 */ { 0, 0, 0, 0, 0 },
/* U+bcd3 */ { 0, 0, 0, 0, 0 },
/* U+bcd4 */ { 0, 0, 0, 0, 0 },
/* U+bcd5 */ { 0, 0, 0, 0, 0 },
/* U+bcd6 */ { 0, 0, 0, 0, 0 },
/* U+bcd7 */ { 0, 0, 0, 0, 0 },
/* U+bcd8 */ { 0, 0, 0, 0, 0 },
/* U+bcd9 */ { 0, 0, 0, 0, 0 },
/* U+bcda */ { 0, 0, 0, 0, 0 },
/* U+bcdb */ { 0, 0, 0, 0, 0 },
/* U+bcdc */ { 0, 0, 0, 0, 0 },
/* U+bcdd */ { 0, 0, 0, 0, 0 },
/* U+bcde */ { 0, 0, 0, 0, 0 },
/* U+bcdf */ { 0, 0, 0, 0, 0 },
/* U+bce0 */ { 0, 0, 0, 0, 0 },
/* U+bce1 */ { 0, 0, 0, 0, 0 },
/* U+bce2 */ { 0, 0, 0, 0, 0 },
/* U+bce3 */ { 0, 0, 0, 0, 0 },
/* U+bce4 */ { 0, 0, 0, 0, 0 },
/* U+bce5 */ { 0, 0, 0, 0, 0 },
/* U+bce6 */ { 0, 0, 0, 0, 0 },
/* U+bce7 */ { 0, 0, 0, 0, 0 },
/* U+bce8 */ { 0, 0, 0, 0, 0 },
/* U+bce9 */ { 0, 0, 0, 0, 0 },
/* U+bcea */ { 0, 0, 0, 0, 0 },
/* U+bceb */ { 0, 0, 0, 0, 0 },
/* U+bcec */ { 0, 0, 0, 0, 0 },
/* U+bced */ { 0, 0, 0, 0, 0 },
/* U+bcee */ { 0, 0, 0, 0, 0 },
/* U+bcef */ { 0, 0, 0, 0, 0 },
/* U+bcf0 */ { 0, 0, 0, 0, 0 },
/* U+bcf1 */ { 0, 0, 0, 0, 0 },
/* U+bcf2 */ { 0, 0, 0, 0, 0 },
/* U+bcf3 */ { 0, 0, 0, 0, 0 },
/* U+bcf4 */ { 0, 0, 0, 0, 0 },
/* U+bcf5 */ { 0, 0, 0, 0, 0 },
/* U+bcf6 */ { 0, 0, 0, 0, 0 },
/* U+bcf7 */ { 0, 0, 0, 0, 0 },
/* U+bcf8 */ { 0, 0, 0, 0, 0 },
/* U+bcf9 */ { 0, 0, 0, 0, 0 },
/* U+bcfa */ { 0, 0, 0, 0, 0 },
/* U+bcfb */ { 0, 0, 0, 0, 0 },
/* U+bcfc */ { 0, 0, 0, 0, 0 },
/* U+bcfd */ { 0, 0, 0, 0, 0 },
/* U+bcfe */ { 0, 0, 0, 0, 0 },
/* U+bcff */ { 0, 0, 0, 0, 0 },
/* U+bd00 */ { 0, 0, 0, 0, 0 },
/* U+bd01 */ { 0, 0, 0, 0, 0 },
/* U+bd02 */ { 0, 0, 0, 0, 0 },
/* U+bd03 */ { 0, 0, 0, 0, 0 },
/* U+bd04 */ { 0, 0, 0, 0, 0 },
/* U+bd05 */ { 0, 0, 0, 0, 0 },
/* U+bd06 */ { 0, 0, 0, 0, 0 },
/* U+bd07 */ { 0, 0, 0, 0, 0 },
/* U+bd08 */ { 0, 0, 0, 0, 0 },
/* U+bd09 */ { 0, 0, 0, 0, 0 },
/* U+bd0a */ { 0, 0, 0, 0, 0 },
/* U+bd0b */ { 0, 0, 0, 0, 0 },
/* U+bd0c */ { 0, 0, 0, 0, 0 },
/* U+bd0d */ { 0, 0, 0, 0, 0 },
/* U+bd0e */ { 0, 0, 0, 0, 0 },
/* U+bd0f */ { 0, 0, 0, 0, 0 },
/* U+bd10 */ { 0, 0, 0, 0, 0 },
/* U+bd11 */ { 0, 0, 0, 0, 0 },
/* U+bd12 */ { 0, 0, 0, 0, 0 },
/* U+bd13 */ { 0, 0, 0, 0, 0 },
/* U+bd14 */ { 0, 0, 0, 0, 0 },
/* U+bd15 */ { 0, 0, 0, 0, 0 },
/* U+bd16 */ { 0, 0, 0, 0, 0 },
/* U+bd17 */ { 0, 0, 0, 0, 0 },
/* U+bd18 */ { 0, 0, 0, 0, 0 },
/* U+bd19 */ { 0, 0, 0, 0, 0 },
/* U+bd1a */ { 0, 0, 0, 0, 0 },
/* U+bd1b */ { 0, 0, 0, 0, 0 },
/* U+bd1c */ { 0, 0, 0, 0, 0 },
/* U+bd1d */ { 0, 0, 0, 0, 0 },
/* U+bd1e */ { 0, 0, 0, 0, 0 },
/* U+bd1f */ { 0, 0, 0, 0, 0 },
/* U+bd20 */ { 0, 0, 0, 0, 0 },
/* U+bd21 */ { 0, 0, 0, 0, 0 },
/* U+bd22 */ { 0, 0, 0, 0, 0 },
/* U+bd23 */ { 0, 0, 0, 0, 0 },
/* U+bd24 */ { 0, 0, 0, 0, 0 },
/* U+bd25 */ { 0, 0, 0, 0, 0 },
/* U+bd26 */ { 0, 0, 0, 0, 0 },
/* U+bd27 */ { 0, 0, 0, 0, 0 },
/* U+bd28 */ { 0, 0, 0, 0, 0 },
/* U+bd29 */ { 0, 0, 0, 0, 0 },
/* U+bd2a */ { 0, 0, 0, 0, 0 },
/* U+bd2b */ { 0, 0, 0, 0, 0 },
/* U+bd2c */ { 0, 0, 0, 0, 0 },
/* U+bd2d */ { 0, 0, 0, 0, 0 },
/* U+bd2e */ { 0, 0, 0, 0, 0 },
/* U+bd2f */ { 0, 0, 0, 0, 0 },
/* U+bd30 */ { 0, 0, 0, 0, 0 },
/* U+bd31 */ { 0, 0, 0, 0, 0 },
/* U+bd32 */ { 0, 0, 0, 0, 0 },
/* U+bd33 */ { 0, 0, 0, 0, 0 },
/* U+bd34 */ { 0, 0, 0, 0, 0 },
/* U+bd35 */ { 0, 0, 0, 0, 0 },
/* U+bd36 */ { 0, 0, 0, 0, 0 },
/* U+bd37 */ { 0, 0, 0, 0, 0 },
/* U+bd38 */ { 0, 0, 0, 0, 0 },
/* U+bd39 */ { 0, 0, 0, 0, 0 },
/* U+bd3a */ { 0, 0, 0, 0, 0 },
/* U+bd3b */ { 0, 0, 0, 0, 0 },
/* U+bd3c */ { 0, 0, 0, 0, 0 },
/* U+bd3d */ { 0, 0, 0, 0, 0 },
/* U+bd3e */ { 0, 0, 0, 0, 0 },
/* U+bd3f */ { 0, 0, 0, 0, 0 },
/* U+bd40 */ { 0, 0, 0, 0, 0 },
/* U+bd41 */ { 0, 0, 0, 0, 0 },
/* U+bd42 */ { 0, 0, 0, 0, 0 },
/* U+bd43 */ { 0, 0, 0, 0, 0 },
/* U+bd44 */ { 0, 0, 0, 0, 0 },
/* U+bd45 */ { 0, 0, 0, 0, 0 },
/* U+bd46 */ { 0, 0, 0, 0, 0 },
/* U+bd47 */ { 0, 0, 0, 0, 0 },
/* U+bd48 */ { 0, 0, 0, 0, 0 },
/* U+bd49 */ { 0, 0, 0, 0, 0 },
/* U+bd4a */ { 0, 0, 0, 0, 0 },
/* U+bd4b */ { 0, 0, 0, 0, 0 },
/* U+bd4c */ { 0, 0, 0, 0, 0 },
/* U+bd4d */ { 0, 0, 0, 0, 0 },
/* U+bd4e */ { 0, 0, 0, 0, 0 },
/* U+bd4f */ { 0, 0, 0, 0, 0 },
/* U+bd50 */ { 0, 0, 0, 0, 0 },
/* U+bd51 */ { 0, 0, 0, 0, 0 },
/* U+bd52 */ { 0, 0, 0, 0, 0 },
/* U+bd53 */ { 0, 0, 0, 0, 0 },
/* U+bd54 */ { 0, 0, 0, 0, 0 },
/* U+bd55 */ { 0, 0, 0, 0, 0 },
/* U+bd56 */ { 0, 0, 0, 0, 0 },
/* U+bd57 */ { 0, 0, 0, 0, 0 },
/* U+bd58 */ { 0, 0, 0, 0, 0 },
/* U+bd59 */ { 0, 0, 0, 0, 0 },
/* U+bd5a */ { 0, 0, 0, 0, 0 },
/* U+bd5b */ { 0, 0, 0, 0, 0 },
/* U+bd5c */ { 0, 0, 0, 0, 0 },
/* U+bd5d */ { 0, 0, 0, 0, 0 },
/* U+bd5e */ { 0, 0, 0, 0, 0 },
/* U+bd5f */ { 0, 0, 0, 0, 0 },
/* U+bd60 */ { 0, 0, 0, 0, 0 },
/* U+bd61 */ { 0, 0, 0, 0, 0 },
/* U+bd62 */ { 0, 0, 0, 0, 0 },
/* U+bd63 */ { 0, 0, 0, 0, 0 },
/* U+bd64 */ { 0, 0, 0, 0, 0 },
/* U+bd65 */ { 0, 0, 0, 0, 0 },
/* U+bd66 */ { 0, 0, 0, 0, 0 },
/* U+bd67 */ { 0, 0, 0, 0, 0 },
/* U+bd68 */ { 0, 0, 0, 0, 0 },
/* U+bd69 */ { 0, 0, 0, 0, 0 },
/* U+bd6a */ { 0, 0, 0, 0, 0 },
/* U+bd6b */ { 0, 0, 0, 0, 0 },
/* U+bd6c */ { 0, 0, 0, 0, 0 },
/* U+bd6d */ { 0, 0, 0, 0, 0 },
/* U+bd6e */ { 0, 0, 0, 0, 0 },
/* U+bd6f */ { 0, 0, 0, 0, 0 },
/* U+bd70 */ { 0, 0, 0, 0, 0 },
/* U+bd71 */ { 0, 0, 0, 0, 0 },
/* U+bd72 */ { 0, 0, 0, 0, 0 },
/* U+bd73 */ { 0, 0, 0, 0, 0 },
/* U+bd74 */ { 0, 0, 0, 0, 0 },
/* U+bd75 */ { 0, 0, 0, 0, 0 },
/* U+bd76 */ { 0, 0, 0, 0, 0 },
/* U+bd77 */ { 0, 0, 0, 0, 0 },
/* U+bd78 */ { 0, 0, 0, 0, 0 },
/* U+bd79 */ { 0, 0, 0, 0, 0 },
/* U+bd7a */ { 0, 0, 0, 0, 0 },
/* U+bd7b */ { 0, 0, 0, 0, 0 },
/* U+bd7c */ { 0, 0, 0, 0, 0 },
/* U+bd7d */ { 0, 0, 0, 0, 0 },
/* U+bd7e */ { 0, 0, 0, 0, 0 },
/* U+bd7f */ { 0, 0, 0, 0, 0 },
/* U+bd80 */ { 0, 0, 0, 0, 0 },
/* U+bd81 */ { 0, 0, 0, 0, 0 },
/* U+bd82 */ { 0, 0, 0, 0, 0 },
/* U+bd83 */ { 0, 0, 0, 0, 0 },
/* U+bd84 */ { 0, 0, 0, 0, 0 },
/* U+bd85 */ { 0, 0, 0, 0, 0 },
/* U+bd86 */ { 0, 0, 0, 0, 0 },
/* U+bd87 */ { 0, 0, 0, 0, 0 },
/* U+bd88 */ { 0, 0, 0, 0, 0 },
/* U+bd89 */ { 0, 0, 0, 0, 0 },
/* U+bd8a */ { 0, 0, 0, 0, 0 },
/* U+bd8b */ { 0, 0, 0, 0, 0 },
/* U+bd8c */ { 0, 0, 0, 0, 0 },
/* U+bd8d */ { 0, 0, 0, 0, 0 },
/* U+bd8e */ { 0, 0, 0, 0, 0 },
/* U+bd8f */ { 0, 0, 0, 0, 0 },
/* U+bd90 */ { 0, 0, 0, 0, 0 },
/* U+bd91 */ { 0, 0, 0, 0, 0 },
/* U+bd92 */ { 0, 0, 0, 0, 0 },
/* U+bd93 */ { 0, 0, 0, 0, 0 },
/* U+bd94 */ { 0, 0, 0, 0, 0 },
/* U+bd95 */ { 0, 0, 0, 0, 0 },
/* U+bd96 */ { 0, 0, 0, 0, 0 },
/* U+bd97 */ { 0, 0, 0, 0, 0 },
/* U+bd98 */ { 0, 0, 0, 0, 0 },
/* U+bd99 */ { 0, 0, 0, 0, 0 },
/* U+bd9a */ { 0, 0, 0, 0, 0 },
/* U+bd9b */ { 0, 0, 0, 0, 0 },
/* U+bd9c */ { 0, 0, 0, 0, 0 },
/* U+bd9d */ { 0, 0, 0, 0, 0 },
/* U+bd9e */ { 0, 0, 0, 0, 0 },
/* U+bd9f */ { 0, 0, 0, 0, 0 },
/* U+bda0 */ { 0, 0, 0, 0, 0 },
/* U+bda1 */ { 0, 0, 0, 0, 0 },
/* U+bda2 */ { 0, 0, 0, 0, 0 },
/* U+bda3 */ { 0, 0, 0, 0, 0 },
/* U+bda4 */ { 0, 0, 0, 0, 0 },
/* U+bda5 */ { 0, 0, 0, 0, 0 },
/* U+bda6 */ { 0, 0, 0, 0, 0 },
/* U+bda7 */ { 0, 0, 0, 0, 0 },
/* U+bda8 */ { 0, 0, 0, 0, 0 },
/* U+bda9 */ { 0, 0, 0, 0, 0 },
/* U+bdaa */ { 0, 0, 0, 0, 0 },
/* U+bdab */ { 0, 0, 0, 0, 0 },
/* U+bdac */ { 0, 0, 0, 0, 0 },
/* U+bdad */ { 0, 0, 0, 0, 0 },
/* U+bdae */ { 0, 0, 0, 0, 0 },
/* U+bdaf */ { 0, 0, 0, 0, 0 },
/* U+bdb0 */ { 0, 0, 0, 0, 0 },
/* U+bdb1 */ { 0, 0, 0, 0, 0 },
/* U+bdb2 */ { 0, 0, 0, 0, 0 },
/* U+bdb3 */ { 0, 0, 0, 0, 0 },
/* U+bdb4 */ { 0, 0, 0, 0, 0 },
/* U+bdb5 */ { 0, 0, 0, 0, 0 },
/* U+bdb6 */ { 0, 0, 0, 0, 0 },
/* U+bdb7 */ { 0, 0, 0, 0, 0 },
/* U+bdb8 */ { 0, 0, 0, 0, 0 },
/* U+bdb9 */ { 0, 0, 0, 0, 0 },
/* U+bdba */ { 0, 0, 0, 0, 0 },
/* U+bdbb */ { 0, 0, 0, 0, 0 },
/* U+bdbc */ { 0, 0, 0, 0, 0 },
/* U+bdbd */ { 0, 0, 0, 0, 0 },
/* U+bdbe */ { 0, 0, 0, 0, 0 },
/* U+bdbf */ { 0, 0, 0, 0, 0 },
/* U+bdc0 */ { 0, 0, 0, 0, 0 },
/* U+bdc1 */ { 0, 0, 0, 0, 0 },
/* U+bdc2 */ { 0, 0, 0, 0, 0 },
/* U+bdc3 */ { 0, 0, 0, 0, 0 },
/* U+bdc4 */ { 0, 0, 0, 0, 0 },
/* U+bdc5 */ { 0, 0, 0, 0, 0 },
/* U+bdc6 */ { 0, 0, 0, 0, 0 },
/* U+bdc7 */ { 0, 0, 0, 0, 0 },
/* U+bdc8 */ { 0, 0, 0, 0, 0 },
/* U+bdc9 */ { 0, 0, 0, 0, 0 },
/* U+bdca */ { 0, 0, 0, 0, 0 },
/* U+bdcb */ { 0, 0, 0, 0, 0 },
/* U+bdcc */ { 0, 0, 0, 0, 0 },
/* U+bdcd */ { 0, 0, 0, 0, 0 },
/* U+bdce */ { 0, 0, 0, 0, 0 },
/* U+bdcf */ { 0, 0, 0, 0, 0 },
/* U+bdd0 */ { 0, 0, 0, 0, 0 },
/* U+bdd1 */ { 0, 0, 0, 0, 0 },
/* U+bdd2 */ { 0, 0, 0, 0, 0 },
/* U+bdd3 */ { 0, 0, 0, 0, 0 },
/* U+bdd4 */ { 0, 0, 0, 0, 0 },
/* U+bdd5 */ { 0, 0, 0, 0, 0 },
/* U+bdd6 */ { 0, 0, 0, 0, 0 },
/* U+bdd7 */ { 0, 0, 0, 0, 0 },
/* U+bdd8 */ { 0, 0, 0, 0, 0 },
/* U+bdd9 */ { 0, 0, 0, 0, 0 },
/* U+bdda */ { 0, 0, 0, 0, 0 },
/* U+bddb */ { 0, 0, 0, 0, 0 },
/* U+bddc */ { 0, 0, 0, 0, 0 },
/* U+bddd */ { 0, 0, 0, 0, 0 },
/* U+bdde */ { 0, 0, 0, 0, 0 },
/* U+bddf */ { 0, 0, 0, 0, 0 },
/* U+bde0 */ { 0, 0, 0, 0, 0 },
/* U+bde1 */ { 0, 0, 0, 0, 0 },
/* U+bde2 */ { 0, 0, 0, 0, 0 },
/* U+bde3 */ { 0, 0, 0, 0, 0 },
/* U+bde4 */ { 0, 0, 0, 0, 0 },
/* U+bde5 */ { 0, 0, 0, 0, 0 },
/* U+bde6 */ { 0, 0, 0, 0, 0 },
/* U+bde7 */ { 0, 0, 0, 0, 0 },
/* U+bde8 */ { 0, 0, 0, 0, 0 },
/* U+bde9 */ { 0, 0, 0, 0, 0 },
/* U+bdea */ { 0, 0, 0, 0, 0 },
/* U+bdeb */ { 0, 0, 0, 0, 0 },
/* U+bdec */ { 0, 0, 0, 0, 0 },
/* U+bded */ { 0, 0, 0, 0, 0 },
/* U+bdee */ { 0, 0, 0, 0, 0 },
/* U+bdef */ { 0, 0, 0, 0, 0 },
/* U+bdf0 */ { 0, 0, 0, 0, 0 },
/* U+bdf1 */ { 0, 0, 0, 0, 0 },
/* U+bdf2 */ { 0, 0, 0, 0, 0 },
/* U+bdf3 */ { 0, 0, 0, 0, 0 },
/* U+bdf4 */ { 0, 0, 0, 0, 0 },
/* U+bdf5 */ { 0, 0, 0, 0, 0 },
/* U+bdf6 */ { 0, 0, 0, 0, 0 },
/* U+bdf7 */ { 0, 0, 0, 0, 0 },
/* U+bdf8 */ { 0, 0, 0, 0, 0 },
/* U+bdf9 */ { 0, 0, 0, 0, 0 },
/* U+bdfa */ { 0, 0, 0, 0, 0 },
/* U+bdfb */ { 0, 0, 0, 0, 0 },
/* U+bdfc */ { 0, 0, 0, 0, 0 },
/* U+bdfd */ { 0, 0, 0, 0, 0 },
/* U+bdfe */ { 0, 0, 0, 0, 0 },
/* U+bdff */ { 0, 0, 0, 0, 0 },
/* U+be00 */ { 0, 0, 0, 0, 0 },
/* U+be01 */ { 0, 0, 0, 0, 0 },
/* U+be02 */ { 0, 0, 0, 0, 0 },
/* U+be03 */ { 0, 0, 0, 0, 0 },
/* U+be04 */ { 0, 0, 0, 0, 0 },
/* U+be05 */ { 0, 0, 0, 0, 0 },
/* U+be06 */ { 0, 0, 0, 0, 0 },
/* U+be07 */ { 0, 0, 0, 0, 0 },
/* U+be08 */ { 0, 0, 0, 0, 0 },
/* U+be09 */ { 0, 0, 0, 0, 0 },
/* U+be0a */ { 0, 0, 0, 0, 0 },
/* U+be0b */ { 0, 0, 0, 0, 0 },
/* U+be0c */ { 0, 0, 0, 0, 0 },
/* U+be0d */ { 0, 0, 0, 0, 0 },
/* U+be0e */ { 0, 0, 0, 0, 0 },
/* U+be0f */ { 0, 0, 0, 0, 0 },
/* U+be10 */ { 0, 0, 0, 0, 0 },
/* U+be11 */ { 0, 0, 0, 0, 0 },
/* U+be12 */ { 0, 0, 0, 0, 0 },
/* U+be13 */ { 0, 0, 0, 0, 0 },
/* U+be14 */ { 0, 0, 0, 0, 0 },
/* U+be15 */ { 0, 0, 0, 0, 0 },
/* U+be16 */ { 0, 0, 0, 0, 0 },
/* U+be17 */ { 0, 0, 0, 0, 0 },
/* U+be18 */ { 0, 0, 0, 0, 0 },
/* U+be19 */ { 0, 0, 0, 0, 0 },
/* U+be1a */ { 0, 0, 0, 0, 0 },
/* U+be1b */ { 0, 0, 0, 0, 0 },
/* U+be1c */ { 0, 0, 0, 0, 0 },
/* U+be1d */ { 0, 0, 0, 0, 0 },
/* U+be1e */ { 0, 0, 0, 0, 0 },
/* U+be1f */ { 0, 0, 0, 0, 0 },
/* U+be20 */ { 0, 0, 0, 0, 0 },
/* U+be21 */ { 0, 0, 0, 0, 0 },
/* U+be22 */ { 0, 0, 0, 0, 0 },
/* U+be23 */ { 0, 0, 0, 0, 0 },
/* U+be24 */ { 0, 0, 0, 0, 0 },
/* U+be25 */ { 0, 0, 0, 0, 0 },
/* U+be26 */ { 0, 0, 0, 0, 0 },
/* U+be27 */ { 0, 0, 0, 0, 0 },
/* U+be28 */ { 0, 0, 0, 0, 0 },
/* U+be29 */ { 0, 0, 0, 0, 0 },
/* U+be2a */ { 0, 0, 0, 0, 0 },
/* U+be2b */ { 0, 0, 0, 0, 0 },
/* U+be2c */ { 0, 0, 0, 0, 0 },
/* U+be2d */ { 0, 0, 0, 0, 0 },
/* U+be2e */ { 0, 0, 0, 0, 0 },
/* U+be2f */ { 0, 0, 0, 0, 0 },
/* U+be30 */ { 0, 0, 0, 0, 0 },
/* U+be31 */ { 0, 0, 0, 0, 0 },
/* U+be32 */ { 0, 0, 0, 0, 0 },
/* U+be33 */ { 0, 0, 0, 0, 0 },
/* U+be34 */ { 0, 0, 0, 0, 0 },
/* U+be35 */ { 0, 0, 0, 0, 0 },
/* U+be36 */ { 0, 0, 0, 0, 0 },
/* U+be37 */ { 0, 0, 0, 0, 0 },
/* U+be38 */ { 0, 0, 0, 0, 0 },
/* U+be39 */ { 0, 0, 0, 0, 0 },
/* U+be3a */ { 0, 0, 0, 0, 0 },
/* U+be3b */ { 0, 0, 0, 0, 0 },
/* U+be3c */ { 0, 0, 0, 0, 0 },
/* U+be3d */ { 0, 0, 0, 0, 0 },
/* U+be3e */ { 0, 0, 0, 0, 0 },
/* U+be3f */ { 0, 0, 0, 0, 0 },
/* U+be40 */ { 0, 0, 0, 0, 0 },
/* U+be41 */ { 0, 0, 0, 0, 0 },
/* U+be42 */ { 0, 0, 0, 0, 0 },
/* U+be43 */ { 0, 0, 0, 0, 0 },
/* U+be44 */ { 0, 0, 0, 0, 0 },
/* U+be45 */ { 0, 0, 0, 0, 0 },
/* U+be46 */ { 0, 0, 0, 0, 0 },
/* U+be47 */ { 0, 0, 0, 0, 0 },
/* U+be48 */ { 0, 0, 0, 0, 0 },
/* U+be49 */ { 0, 0, 0, 0, 0 },
/* U+be4a */ { 0, 0, 0, 0, 0 },
/* U+be4b */ { 0, 0, 0, 0, 0 },
/* U+be4c */ { 0, 0, 0, 0, 0 },
/* U+be4d */ { 0, 0, 0, 0, 0 },
/* U+be4e */ { 0, 0, 0, 0, 0 },
/* U+be4f */ { 0, 0, 0, 0, 0 },
/* U+be50 */ { 0, 0, 0, 0, 0 },
/* U+be51 */ { 0, 0, 0, 0, 0 },
/* U+be52 */ { 0, 0, 0, 0, 0 },
/* U+be53 */ { 0, 0, 0, 0, 0 },
/* U+be54 */ { 0, 0, 0, 0, 0 },
/* U+be55 */ { 0, 0, 0, 0, 0 },
/* U+be56 */ { 0, 0, 0, 0, 0 },
/* U+be57 */ { 0, 0, 0, 0, 0 },
/* U+be58 */ { 0, 0, 0, 0, 0 },
/* U+be59 */ { 0, 0, 0, 0, 0 },
/* U+be5a */ { 0, 0, 0, 0, 0 },
/* U+be5b */ { 0, 0, 0, 0, 0 },
/* U+be5c */ { 0, 0, 0, 0, 0 },
/* U+be5d */ { 0, 0, 0, 0, 0 },
/* U+be5e */ { 0, 0, 0, 0, 0 },
/* U+be5f */ { 0, 0, 0, 0, 0 },
/* U+be60 */ { 0, 0, 0, 0, 0 },
/* U+be61 */ { 0, 0, 0, 0, 0 },
/* U+be62 */ { 0, 0, 0, 0, 0 },
/* U+be63 */ { 0, 0, 0, 0, 0 },
/* U+be64 */ { 0, 0, 0, 0, 0 },
/* U+be65 */ { 0, 0, 0, 0, 0 },
/* U+be66 */ { 0, 0, 0, 0, 0 },
/* U+be67 */ { 0, 0, 0, 0, 0 },
/* U+be68 */ { 0, 0, 0, 0, 0 },
/* U+be69 */ { 0, 0, 0, 0, 0 },
/* U+be6a */ { 0, 0, 0, 0, 0 },
/* U+be6b */ { 0, 0, 0, 0, 0 },
/* U+be6c */ { 0, 0, 0, 0, 0 },
/* U+be6d */ { 0, 0, 0, 0, 0 },
/* U+be6e */ { 0, 0, 0, 0, 0 },
/* U+be6f */ { 0, 0, 0, 0, 0 },
/* U+be70 */ { 0, 0, 0, 0, 0 },
/* U+be71 */ { 0, 0, 0, 0, 0 },
/* U+be72 */ { 0, 0, 0, 0, 0 },
/* U+be73 */ { 0, 0, 0, 0, 0 },
/* U+be74 */ { 0, 0, 0, 0, 0 },
/* U+be75 */ { 0, 0, 0, 0, 0 },
/* U+be76 */ { 0, 0, 0, 0, 0 },
/* U+be77 */ { 0, 0, 0, 0, 0 },
/* U+be78 */ { 0, 0, 0, 0, 0 },
/* U+be79 */ { 0, 0, 0, 0, 0 },
/* U+be7a */ { 0, 0, 0, 0, 0 },
/* U+be7b */ { 0, 0, 0, 0, 0 },
/* U+be7c */ { 0, 0, 0, 0, 0 },
/* U+be7d */ { 0, 0, 0, 0, 0 },
/* U+be7e */ { 0, 0, 0, 0, 0 },
/* U+be7f */ { 0, 0, 0, 0, 0 },
/* U+be80 */ { 0, 0, 0, 0, 0 },
/* U+be81 */ { 0, 0, 0, 0, 0 },
/* U+be82 */ { 0, 0, 0, 0, 0 },
/* U+be83 */ { 0, 0, 0, 0, 0 },
/* U+be84 */ { 0, 0, 0, 0, 0 },
/* U+be85 */ { 0, 0, 0, 0, 0 },
/* U+be86 */ { 0, 0, 0, 0, 0 },
/* U+be87 */ { 0, 0, 0, 0, 0 },
/* U+be88 */ { 0, 0, 0, 0, 0 },
/* U+be89 */ { 0, 0, 0, 0, 0 },
/* U+be8a */ { 0, 0, 0, 0, 0 },
/* U+be8b */ { 0, 0, 0, 0, 0 },
/* U+be8c */ { 0, 0, 0, 0, 0 },
/* U+be8d */ { 0, 0, 0, 0, 0 },
/* U+be8e */ { 0, 0, 0, 0, 0 },
/* U+be8f */ { 0, 0, 0, 0, 0 },
/* U+be90 */ { 0, 0, 0, 0, 0 },
/* U+be91 */ { 0, 0, 0, 0, 0 },
/* U+be92 */ { 0, 0, 0, 0, 0 },
/* U+be93 */ { 0, 0, 0, 0, 0 },
/* U+be94 */ { 0, 0, 0, 0, 0 },
/* U+be95 */ { 0, 0, 0, 0, 0 },
/* U+be96 */ { 0, 0, 0, 0, 0 },
/* U+be97 */ { 0, 0, 0, 0, 0 },
/* U+be98 */ { 0, 0, 0, 0, 0 },
/* U+be99 */ { 0, 0, 0, 0, 0 },
/* U+be9a */ { 0, 0, 0, 0, 0 },
/* U+be9b */ { 0, 0, 0, 0, 0 },
/* U+be9c */ { 0, 0, 0, 0, 0 },
/* U+be9d */ { 0, 0, 0, 0, 0 },
/* U+be9e */ { 0, 0, 0, 0, 0 },
/* U+be9f */ { 0, 0, 0, 0, 0 },
/* U+bea0 */ { 0, 0, 0, 0, 0 },
/* U+bea1 */ { 0, 0, 0, 0, 0 },
/* U+bea2 */ { 0, 0, 0, 0, 0 },
/* U+bea3 */ { 0, 0, 0, 0, 0 },
/* U+bea4 */ { 0, 0, 0, 0, 0 },
/* U+bea5 */ { 0, 0, 0, 0, 0 },
/* U+bea6 */ { 0, 0, 0, 0, 0 },
/* U+bea7 */ { 0, 0, 0, 0, 0 },
/* U+bea8 */ { 0, 0, 0, 0, 0 },
/* U+bea9 */ { 0, 0, 0, 0, 0 },
/* U+beaa */ { 0, 0, 0, 0, 0 },
/* U+beab */ { 0, 0, 0, 0, 0 },
/* U+beac */ { 0, 0, 0, 0, 0 },
/* U+bead */ { 0, 0, 0, 0, 0 },
/* U+beae */ { 0, 0, 0, 0, 0 },
/* U+beaf */ { 0, 0, 0, 0, 0 },
/* U+beb0 */ { 0, 0, 0, 0, 0 },
/* U+beb1 */ { 0, 0, 0, 0, 0 },
/* U+beb2 */ { 0, 0, 0, 0, 0 },
/* U+beb3 */ { 0, 0, 0, 0, 0 },
/* U+beb4 */ { 0, 0, 0, 0, 0 },
/* U+beb5 */ { 0, 0, 0, 0, 0 },
/* U+beb6 */ { 0, 0, 0, 0, 0 },
/* U+beb7 */ { 0, 0, 0, 0, 0 },
/* U+beb8 */ { 0, 0, 0, 0, 0 },
/* U+beb9 */ { 0, 0, 0, 0, 0 },
/* U+beba */ { 0, 0, 0, 0, 0 },
/* U+bebb */ { 0, 0, 0, 0, 0 },
/* U+bebc */ { 0, 0, 0, 0, 0 },
/* U+bebd */ { 0, 0, 0, 0, 0 },
/* U+bebe */ { 0, 0, 0, 0, 0 },
/* U+bebf */ { 0, 0, 0, 0, 0 },
/* U+bec0 */ { 0, 0, 0, 0, 0 },
/* U+bec1 */ { 0, 0, 0, 0, 0 },
/* U+bec2 */ { 0, 0, 0, 0, 0 },
/* U+bec3 */ { 0, 0, 0, 0, 0 },
/* U+bec4 */ { 0, 0, 0, 0, 0 },
/* U+bec5 */ { 0, 0, 0, 0, 0 },
/* U+bec6 */ { 0, 0, 0, 0, 0 },
/* U+bec7 */ { 0, 0, 0, 0, 0 },
/* U+bec8 */ { 0, 0, 0, 0, 0 },
/* U+bec9 */ { 0, 0, 0, 0, 0 },
/* U+beca */ { 0, 0, 0, 0, 0 },
/* U+becb */ { 0, 0, 0, 0, 0 },
/* U+becc */ { 0, 0, 0, 0, 0 },
/* U+becd */ { 0, 0, 0, 0, 0 },
/* U+bece */ { 0, 0, 0, 0, 0 },
/* U+becf */ { 0, 0, 0, 0, 0 },
/* U+bed0 */ { 0, 0, 0, 0, 0 },
/* U+bed1 */ { 0, 0, 0, 0, 0 },
/* U+bed2 */ { 0, 0, 0, 0, 0 },
/* U+bed3 */ { 0, 0, 0, 0, 0 },
/* U+bed4 */ { 0, 0, 0, 0, 0 },
/* U+bed5 */ { 0, 0, 0, 0, 0 },
/* U+bed6 */ { 0, 0, 0, 0, 0 },
/* U+bed7 */ { 0, 0, 0, 0, 0 },
/* U+bed8 */ { 0, 0, 0, 0, 0 },
/* U+bed9 */ { 0, 0, 0, 0, 0 },
/* U+beda */ { 0, 0, 0, 0, 0 },
/* U+bedb */ { 0, 0, 0, 0, 0 },
/* U+bedc */ { 0, 0, 0, 0, 0 },
/* U+bedd */ { 0, 0, 0, 0, 0 },
/* U+bede */ { 0, 0, 0, 0, 0 },
/* U+bedf */ { 0, 0, 0, 0, 0 },
/* U+bee0 */ { 0, 0, 0, 0, 0 },
/* U+bee1 */ { 0, 0, 0, 0, 0 },
/* U+bee2 */ { 0, 0, 0, 0, 0 },
/* U+bee3 */ { 0, 0, 0, 0, 0 },
/* U+bee4 */ { 0, 0, 0, 0, 0 },
/* U+bee5 */ { 0, 0, 0, 0, 0 },
/* U+bee6 */ { 0, 0, 0, 0, 0 },
/* U+bee7 */ { 0, 0, 0, 0, 0 },
/* U+bee8 */ { 0, 0, 0, 0, 0 },
/* U+bee9 */ { 0, 0, 0, 0, 0 },
/* U+beea */ { 0, 0, 0, 0, 0 },
/* U+beeb */ { 0, 0, 0, 0, 0 },
/* U+beec */ { 0, 0, 0, 0, 0 },
/* U+beed */ { 0, 0, 0, 0, 0 },
/* U+beee */ { 0, 0, 0, 0, 0 },
/* U+beef */ { 0, 0, 0, 0, 0 },
/* U+bef0 */ { 0, 0, 0, 0, 0 },
/* U+bef1 */ { 0, 0, 0, 0, 0 },
/* U+bef2 */ { 0, 0, 0, 0, 0 },
/* U+bef3 */ { 0, 0, 0, 0, 0 },
/* U+bef4 */ { 0, 0, 0, 0, 0 },
/* U+bef5 */ { 0, 0, 0, 0, 0 },
/* U+bef6 */ { 0, 0, 0, 0, 0 },
/* U+bef7 */ { 0, 0, 0, 0, 0 },
/* U+bef8 */ { 0, 0, 0, 0, 0 },
/* U+bef9 */ { 0, 0, 0, 0, 0 },
/* U+befa */ { 0, 0, 0, 0, 0 },
/* U+befb */ { 0, 0, 0, 0, 0 },
/* U+befc */ { 0, 0, 0, 0, 0 },
/* U+befd */ { 0, 0, 0, 0, 0 },
/* U+befe */ { 0, 0, 0, 0, 0 },
/* U+beff */ { 0, 0, 0, 0, 0 },
/* U+bf00 */ { 0, 0, 0, 0, 0 },
/* U+bf01 */ { 0, 0, 0, 0, 0 },
/* U+bf02 */ { 0, 0, 0, 0, 0 },
/* U+bf03 */ { 0, 0, 0, 0, 0 },
/* U+bf04 */ { 0, 0, 0, 0, 0 },
/* U+bf05 */ { 0, 0, 0, 0, 0 },
/* U+bf06 */ { 0, 0, 0, 0, 0 },
/* U+bf07 */ { 0, 0, 0, 0, 0 },
/* U+bf08 */ { 0, 0, 0, 0, 0 },
/* U+bf09 */ { 0, 0, 0, 0, 0 },
/* U+bf0a */ { 0, 0, 0, 0, 0 },
/* U+bf0b */ { 0, 0, 0, 0, 0 },
/* U+bf0c */ { 0, 0, 0, 0, 0 },
/* U+bf0d */ { 0, 0, 0, 0, 0 },
/* U+bf0e */ { 0, 0, 0, 0, 0 },
/* U+bf0f */ { 0, 0, 0, 0, 0 },
/* U+bf10 */ { 0, 0, 0, 0, 0 },
/* U+bf11 */ { 0, 0, 0, 0, 0 },
/* U+bf12 */ { 0, 0, 0, 0, 0 },
/* U+bf13 */ { 0, 0, 0, 0, 0 },
/* U+bf14 */ { 0, 0, 0, 0, 0 },
/* U+bf15 */ { 0, 0, 0, 0, 0 },
/* U+bf16 */ { 0, 0, 0, 0, 0 },
/* U+bf17 */ { 0, 0, 0, 0, 0 },
/* U+bf18 */ { 0, 0, 0, 0, 0 },
/* U+bf19 */ { 0, 0, 0, 0, 0 },
/* U+bf1a */ { 0, 0, 0, 0, 0 },
/* U+bf1b */ { 0, 0, 0, 0, 0 },
/* U+bf1c */ { 0, 0, 0, 0, 0 },
/* U+bf1d */ { 0, 0, 0, 0, 0 },
/* U+bf1e */ { 0, 0, 0, 0, 0 },
/* U+bf1f */ { 0, 0, 0, 0, 0 },
/* U+bf20 */ { 0, 0, 0, 0, 0 },
/* U+bf21 */ { 0, 0, 0, 0, 0 },
/* U+bf22 */ { 0, 0, 0, 0, 0 },
/* U+bf23 */ { 0, 0, 0, 0, 0 },
/* U+bf24 */ { 0, 0, 0, 0, 0 },
/* U+bf25 */ { 0, 0, 0, 0, 0 },
/* U+bf26 */ { 0, 0, 0, 0, 0 },
/* U+bf27 */ { 0, 0, 0, 0, 0 },
/* U+bf28 */ { 0, 0, 0, 0, 0 },
/* U+bf29 */ { 0, 0, 0, 0, 0 },
/* U+bf2a */ { 0, 0, 0, 0, 0 },
/* U+bf2b */ { 0, 0, 0, 0, 0 },
/* U+bf2c */ { 0, 0, 0, 0, 0 },
/* U+bf2d */ { 0, 0, 0, 0, 0 },
/* U+bf2e */ { 0, 0, 0, 0, 0 },
/* U+bf2f */ { 0, 0, 0, 0, 0 },
/* U+bf30 */ { 0, 0, 0, 0, 0 },
/* U+bf31 */ { 0, 0, 0, 0, 0 },
/* U+bf32 */ { 0, 0, 0, 0, 0 },
/* U+bf33 */ { 0, 0, 0, 0, 0 },
/* U+bf34 */ { 0, 0, 0, 0, 0 },
/* U+bf35 */ { 0, 0, 0, 0, 0 },
/* U+bf36 */ { 0, 0, 0, 0, 0 },
/* U+bf37 */ { 0, 0, 0, 0, 0 },
/* U+bf38 */ { 0, 0, 0, 0, 0 },
/* U+bf39 */ { 0, 0, 0, 0, 0 },
/* U+bf3a */ { 0, 0, 0, 0, 0 },
/* U+bf3b */ { 0, 0, 0, 0, 0 },
/* U+bf3c */ { 0, 0, 0, 0, 0 },
/* U+bf3d */ { 0, 0, 0, 0, 0 },
/* U+bf3e */ { 0, 0, 0, 0, 0 },
/* U+bf3f */ { 0, 0, 0, 0, 0 },
/* U+bf40 */ { 0, 0, 0, 0, 0 },
/* U+bf41 */ { 0, 0, 0, 0, 0 },
/* U+bf42 */ { 0, 0, 0, 0, 0 },
/* U+bf43 */ { 0, 0, 0, 0, 0 },
/* U+bf44 */ { 0, 0, 0, 0, 0 },
/* U+bf45 */ { 0, 0, 0, 0, 0 },
/* U+bf46 */ { 0, 0, 0, 0, 0 },
/* U+bf47 */ { 0, 0, 0, 0, 0 },
/* U+bf48 */ { 0, 0, 0, 0, 0 },
/* U+bf49 */ { 0, 0, 0, 0, 0 },
/* U+bf4a */ { 0, 0, 0, 0, 0 },
/* U+bf4b */ { 0, 0, 0, 0, 0 },
/* U+bf4c */ { 0, 0, 0, 0, 0 },
/* U+bf4d */ { 0, 0, 0, 0, 0 },
/* U+bf4e */ { 0, 0, 0, 0, 0 },
/* U+bf4f */ { 0, 0, 0, 0, 0 },
/* U+bf50 */ { 0, 0, 0, 0, 0 },
/* U+bf51 */ { 0, 0, 0, 0, 0 },
/* U+bf52 */ { 0, 0, 0, 0, 0 },
/* U+bf53 */ { 0, 0, 0, 0, 0 },
/* U+bf54 */ { 0, 0, 0, 0, 0 },
/* U+bf55 */ { 0, 0, 0, 0, 0 },
/* U+bf56 */ { 0, 0, 0, 0, 0 },
/* U+bf57 */ { 0, 0, 0, 0, 0 },
/* U+bf58 */ { 0, 0, 0, 0, 0 },
/* U+bf59 */ { 0, 0, 0, 0, 0 },
/* U+bf5a */ { 0, 0, 0, 0, 0 },
/* U+bf5b */ { 0, 0, 0, 0, 0 },
/* U+bf5c */ { 0, 0, 0, 0, 0 },
/* U+bf5d */ { 0, 0, 0, 0, 0 },
/* U+bf5e */ { 0, 0, 0, 0, 0 },
/* U+bf5f */ { 0, 0, 0, 0, 0 },
/* U+bf60 */ { 0, 0, 0, 0, 0 },
/* U+bf61 */ { 0, 0, 0, 0, 0 },
/* U+bf62 */ { 0, 0, 0, 0, 0 },
/* U+bf63 */ { 0, 0, 0, 0, 0 },
/* U+bf64 */ { 0, 0, 0, 0, 0 },
/* U+bf65 */ { 0, 0, 0, 0, 0 },
/* U+bf66 */ { 0, 0, 0, 0, 0 },
/* U+bf67 */ { 0, 0, 0, 0, 0 },
/* U+bf68 */ { 0, 0, 0, 0, 0 },
/* U+bf69 */ { 0, 0, 0, 0, 0 },
/* U+bf6a */ { 0, 0, 0, 0, 0 },
/* U+bf6b */ { 0, 0, 0, 0, 0 },
/* U+bf6c */ { 0, 0, 0, 0, 0 },
/* U+bf6d */ { 0, 0, 0, 0, 0 },
/* U+bf6e */ { 0, 0, 0, 0, 0 },
/* U+bf6f */ { 0, 0, 0, 0, 0 },
/* U+bf70 */ { 0, 0, 0, 0, 0 },
/* U+bf71 */ { 0, 0, 0, 0, 0 },
/* U+bf72 */ { 0, 0, 0, 0, 0 },
/* U+bf73 */ { 0, 0, 0, 0, 0 },
/* U+bf74 */ { 0, 0, 0, 0, 0 },
/* U+bf75 */ { 0, 0, 0, 0, 0 },
/* U+bf76 */ { 0, 0, 0, 0, 0 },
/* U+bf77 */ { 0, 0, 0, 0, 0 },
/* U+bf78 */ { 0, 0, 0, 0, 0 },
/* U+bf79 */ { 0, 0, 0, 0, 0 },
/* U+bf7a */ { 0, 0, 0, 0, 0 },
/* U+bf7b */ { 0, 0, 0, 0, 0 },
/* U+bf7c */ { 0, 0, 0, 0, 0 },
/* U+bf7d */ { 0, 0, 0, 0, 0 },
/* U+bf7e */ { 0, 0, 0, 0, 0 },
/* U+bf7f */ { 0, 0, 0, 0, 0 },
/* U+bf80 */ { 0, 0, 0, 0, 0 },
/* U+bf81 */ { 0, 0, 0, 0, 0 },
/* U+bf82 */ { 0, 0, 0, 0, 0 },
/* U+bf83 */ { 0, 0, 0, 0, 0 },
/* U+bf84 */ { 0, 0, 0, 0, 0 },
/* U+bf85 */ { 0, 0, 0, 0, 0 },
/* U+bf86 */ { 0, 0, 0, 0, 0 },
/* U+bf87 */ { 0, 0, 0, 0, 0 },
/* U+bf88 */ { 0, 0, 0, 0, 0 },
/* U+bf89 */ { 0, 0, 0, 0, 0 },
/* U+bf8a */ { 0, 0, 0, 0, 0 },
/* U+bf8b */ { 0, 0, 0, 0, 0 },
/* U+bf8c */ { 0, 0, 0, 0, 0 },
/* U+bf8d */ { 0, 0, 0, 0, 0 },
/* U+bf8e */ { 0, 0, 0, 0, 0 },
/* U+bf8f */ { 0, 0, 0, 0, 0 },
/* U+bf90 */ { 0, 0, 0, 0, 0 },
/* U+bf91 */ { 0, 0, 0, 0, 0 },
/* U+bf92 */ { 0, 0, 0, 0, 0 },
/* U+bf93 */ { 0, 0, 0, 0, 0 },
/* U+bf94 */ { 0, 0, 0, 0, 0 },
/* U+bf95 */ { 0, 0, 0, 0, 0 },
/* U+bf96 */ { 0, 0, 0, 0, 0 },
/* U+bf97 */ { 0, 0, 0, 0, 0 },
/* U+bf98 */ { 0, 0, 0, 0, 0 },
/* U+bf99 */ { 0, 0, 0, 0, 0 },
/* U+bf9a */ { 0, 0, 0, 0, 0 },
/* U+bf9b */ { 0, 0, 0, 0, 0 },
/* U+bf9c */ { 0, 0, 0, 0, 0 },
/* U+bf9d */ { 0, 0, 0, 0, 0 },
/* U+bf9e */ { 0, 0, 0, 0, 0 },
/* U+bf9f */ { 0, 0, 0, 0, 0 },
/* U+bfa0 */ { 0, 0, 0, 0, 0 },
/* U+bfa1 */ { 0, 0, 0, 0, 0 },
/* U+bfa2 */ { 0, 0, 0, 0, 0 },
/* U+bfa3 */ { 0, 0, 0, 0, 0 },
/* U+bfa4 */ { 0, 0, 0, 0, 0 },
/* U+bfa5 */ { 0, 0, 0, 0, 0 },
/* U+bfa6 */ { 0, 0, 0, 0, 0 },
/* U+bfa7 */ { 0, 0, 0, 0, 0 },
/* U+bfa8 */ { 0, 0, 0, 0, 0 },
/* U+bfa9 */ { 0, 0, 0, 0, 0 },
/* U+bfaa */ { 0, 0, 0, 0, 0 },
/* U+bfab */ { 0, 0, 0, 0, 0 },
/* U+bfac */ { 0, 0, 0, 0, 0 },
/* U+bfad */ { 0, 0, 0, 0, 0 },
/* U+bfae */ { 0, 0, 0, 0, 0 },
/* U+bfaf */ { 0, 0, 0, 0, 0 },
/* U+bfb0 */ { 0, 0, 0, 0, 0 },
/* U+bfb1 */ { 0, 0, 0, 0, 0 },
/* U+bfb2 */ { 0, 0, 0, 0, 0 },
/* U+bfb3 */ { 0, 0, 0, 0, 0 },
/* U+bfb4 */ { 0, 0, 0, 0, 0 },
/* U+bfb5 */ { 0, 0, 0, 0, 0 },
/* U+bfb6 */ { 0, 0, 0, 0, 0 },
/* U+bfb7 */ { 0, 0, 0, 0, 0 },
/* U+bfb8 */ { 0, 0, 0, 0, 0 },
/* U+bfb9 */ { 0, 0, 0, 0, 0 },
/* U+bfba */ { 0, 0, 0, 0, 0 },
/* U+bfbb */ { 0, 0, 0, 0, 0 },
/* U+bfbc */ { 0, 0, 0, 0, 0 },
/* U+bfbd */ { 0, 0, 0, 0, 0 },
/* U+bfbe */ { 0, 0, 0, 0, 0 },
/* U+bfbf */ { 0, 0, 0, 0, 0 },
/* U+bfc0 */ { 0, 0, 0, 0, 0 },
/* U+bfc1 */ { 0, 0, 0, 0, 0 },
/* U+bfc2 */ { 0, 0, 0, 0, 0 },
/* U+bfc3 */ { 0, 0, 0, 0, 0 },
/* U+bfc4 */ { 0, 0, 0, 0, 0 },
/* U+bfc5 */ { 0, 0, 0, 0, 0 },
/* U+bfc6 */ { 0, 0, 0, 0, 0 },
/* U+bfc7 */ { 0, 0, 0, 0, 0 },
/* U+bfc8 */ { 0, 0, 0, 0, 0 },
/* U+bfc9 */ { 0, 0, 0, 0, 0 },
/* U+bfca */ { 0, 0, 0, 0, 0 },
/* U+bfcb */ { 0, 0, 0, 0, 0 },
/* U+bfcc */ { 0, 0, 0, 0, 0 },
/* U+bfcd */ { 0, 0, 0, 0, 0 },
/* U+bfce */ { 0, 0, 0, 0, 0 },
/* U+bfcf */ { 0, 0, 0, 0, 0 },
/* U+bfd0 */ { 0, 0, 0, 0, 0 },
/* U+bfd1 */ { 0, 0, 0, 0, 0 },
/* U+bfd2 */ { 0, 0, 0, 0, 0 },
/* U+bfd3 */ { 0, 0, 0, 0, 0 },
/* U+bfd4 */ { 0, 0, 0, 0, 0 },
/* U+bfd5 */ { 0, 0, 0, 0, 0 },
/* U+bfd6 */ { 0, 0, 0, 0, 0 },
/* U+bfd7 */ { 0, 0, 0, 0, 0 },
/* U+bfd8 */ { 0, 0, 0, 0, 0 },
/* U+bfd9 */ { 0, 0, 0, 0, 0 },
/* U+bfda */ { 0, 0, 0, 0, 0 },
/* U+bfdb */ { 0, 0, 0, 0, 0 },
/* U+bfdc */ { 0, 0, 0, 0, 0 },
/* U+bfdd */ { 0, 0, 0, 0, 0 },
/* U+bfde */ { 0, 0, 0, 0, 0 },
/* U+bfdf */ { 0, 0, 0, 0, 0 },
/* U+bfe0 */ { 0, 0, 0, 0, 0 },
/* U+bfe1 */ { 0, 0, 0, 0, 0 },
/* U+bfe2 */ { 0, 0, 0, 0, 0 },
/* U+bfe3 */ { 0, 0, 0, 0, 0 },
/* U+bfe4 */ { 0, 0, 0, 0, 0 },
/* U+bfe5 */ { 0, 0, 0, 0, 0 },
/* U+bfe6 */ { 0, 0, 0, 0, 0 },
/* U+bfe7 */ { 0, 0, 0, 0, 0 },
/* U+bfe8 */ { 0, 0, 0, 0, 0 },
/* U+bfe9 */ { 0, 0, 0, 0, 0 },
/* U+bfea */ { 0, 0, 0, 0, 0 },
/* U+bfeb */ { 0, 0, 0, 0, 0 },
/* U+bfec */ { 0, 0, 0, 0, 0 },
/* U+bfed */ { 0, 0, 0, 0, 0 },
/* U+bfee */ { 0, 0, 0, 0, 0 },
/* U+bfef */ { 0, 0, 0, 0, 0 },
/* U+bff0 */ { 0, 0, 0, 0, 0 },
/* U+bff1 */ { 0, 0, 0, 0, 0 },
/* U+bff2 */ { 0, 0, 0, 0, 0 },
/* U+bff3 */ { 0, 0, 0, 0, 0 },
/* U+bff4 */ { 0, 0, 0, 0, 0 },
/* U+bff5 */ { 0, 0, 0, 0, 0 },
/* U+bff6 */ { 0, 0, 0, 0, 0 },
/* U+bff7 */ { 0, 0, 0, 0, 0 },
/* U+bff8 */ { 0, 0, 0, 0, 0 },
/* U+bff9 */ { 0, 0, 0, 0, 0 },
/* U+bffa */ { 0, 0, 0, 0, 0 },
/* U+bffb */ { 0, 0, 0, 0, 0 },
/* U+bffc */ { 0, 0, 0, 0, 0 },
/* U+bffd */ { 0, 0, 0, 0, 0 },
/* U+bffe */ { 0, 0, 0, 0, 0 },
/* U+bfff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_12[4096] = {
    
/* U+c000 */ { 0, 0, 0, 0, 0 },
/* U+c001 */ { 0, 0, 0, 0, 0 },
/* U+c002 */ { 0, 0, 0, 0, 0 },
/* U+c003 */ { 0, 0, 0, 0, 0 },
/* U+c004 */ { 0, 0, 0, 0, 0 },
/* U+c005 */ { 0, 0, 0, 0, 0 },
/* U+c006 */ { 0, 0, 0, 0, 0 },
/* U+c007 */ { 0, 0, 0, 0, 0 },
/* U+c008 */ { 0, 0, 0, 0, 0 },
/* U+c009 */ { 0, 0, 0, 0, 0 },
/* U+c00a */ { 0, 0, 0, 0, 0 },
/* U+c00b */ { 0, 0, 0, 0, 0 },
/* U+c00c */ { 0, 0, 0, 0, 0 },
/* U+c00d */ { 0, 0, 0, 0, 0 },
/* U+c00e */ { 0, 0, 0, 0, 0 },
/* U+c00f */ { 0, 0, 0, 0, 0 },
/* U+c010 */ { 0, 0, 0, 0, 0 },
/* U+c011 */ { 0, 0, 0, 0, 0 },
/* U+c012 */ { 0, 0, 0, 0, 0 },
/* U+c013 */ { 0, 0, 0, 0, 0 },
/* U+c014 */ { 0, 0, 0, 0, 0 },
/* U+c015 */ { 0, 0, 0, 0, 0 },
/* U+c016 */ { 0, 0, 0, 0, 0 },
/* U+c017 */ { 0, 0, 0, 0, 0 },
/* U+c018 */ { 0, 0, 0, 0, 0 },
/* U+c019 */ { 0, 0, 0, 0, 0 },
/* U+c01a */ { 0, 0, 0, 0, 0 },
/* U+c01b */ { 0, 0, 0, 0, 0 },
/* U+c01c */ { 0, 0, 0, 0, 0 },
/* U+c01d */ { 0, 0, 0, 0, 0 },
/* U+c01e */ { 0, 0, 0, 0, 0 },
/* U+c01f */ { 0, 0, 0, 0, 0 },
/* U+c020 */ { 0, 0, 0, 0, 0 },
/* U+c021 */ { 0, 0, 0, 0, 0 },
/* U+c022 */ { 0, 0, 0, 0, 0 },
/* U+c023 */ { 0, 0, 0, 0, 0 },
/* U+c024 */ { 0, 0, 0, 0, 0 },
/* U+c025 */ { 0, 0, 0, 0, 0 },
/* U+c026 */ { 0, 0, 0, 0, 0 },
/* U+c027 */ { 0, 0, 0, 0, 0 },
/* U+c028 */ { 0, 0, 0, 0, 0 },
/* U+c029 */ { 0, 0, 0, 0, 0 },
/* U+c02a */ { 0, 0, 0, 0, 0 },
/* U+c02b */ { 0, 0, 0, 0, 0 },
/* U+c02c */ { 0, 0, 0, 0, 0 },
/* U+c02d */ { 0, 0, 0, 0, 0 },
/* U+c02e */ { 0, 0, 0, 0, 0 },
/* U+c02f */ { 0, 0, 0, 0, 0 },
/* U+c030 */ { 0, 0, 0, 0, 0 },
/* U+c031 */ { 0, 0, 0, 0, 0 },
/* U+c032 */ { 0, 0, 0, 0, 0 },
/* U+c033 */ { 0, 0, 0, 0, 0 },
/* U+c034 */ { 0, 0, 0, 0, 0 },
/* U+c035 */ { 0, 0, 0, 0, 0 },
/* U+c036 */ { 0, 0, 0, 0, 0 },
/* U+c037 */ { 0, 0, 0, 0, 0 },
/* U+c038 */ { 0, 0, 0, 0, 0 },
/* U+c039 */ { 0, 0, 0, 0, 0 },
/* U+c03a */ { 0, 0, 0, 0, 0 },
/* U+c03b */ { 0, 0, 0, 0, 0 },
/* U+c03c */ { 0, 0, 0, 0, 0 },
/* U+c03d */ { 0, 0, 0, 0, 0 },
/* U+c03e */ { 0, 0, 0, 0, 0 },
/* U+c03f */ { 0, 0, 0, 0, 0 },
/* U+c040 */ { 0, 0, 0, 0, 0 },
/* U+c041 */ { 0, 0, 0, 0, 0 },
/* U+c042 */ { 0, 0, 0, 0, 0 },
/* U+c043 */ { 0, 0, 0, 0, 0 },
/* U+c044 */ { 0, 0, 0, 0, 0 },
/* U+c045 */ { 0, 0, 0, 0, 0 },
/* U+c046 */ { 0, 0, 0, 0, 0 },
/* U+c047 */ { 0, 0, 0, 0, 0 },
/* U+c048 */ { 0, 0, 0, 0, 0 },
/* U+c049 */ { 0, 0, 0, 0, 0 },
/* U+c04a */ { 0, 0, 0, 0, 0 },
/* U+c04b */ { 0, 0, 0, 0, 0 },
/* U+c04c */ { 0, 0, 0, 0, 0 },
/* U+c04d */ { 0, 0, 0, 0, 0 },
/* U+c04e */ { 0, 0, 0, 0, 0 },
/* U+c04f */ { 0, 0, 0, 0, 0 },
/* U+c050 */ { 0, 0, 0, 0, 0 },
/* U+c051 */ { 0, 0, 0, 0, 0 },
/* U+c052 */ { 0, 0, 0, 0, 0 },
/* U+c053 */ { 0, 0, 0, 0, 0 },
/* U+c054 */ { 0, 0, 0, 0, 0 },
/* U+c055 */ { 0, 0, 0, 0, 0 },
/* U+c056 */ { 0, 0, 0, 0, 0 },
/* U+c057 */ { 0, 0, 0, 0, 0 },
/* U+c058 */ { 0, 0, 0, 0, 0 },
/* U+c059 */ { 0, 0, 0, 0, 0 },
/* U+c05a */ { 0, 0, 0, 0, 0 },
/* U+c05b */ { 0, 0, 0, 0, 0 },
/* U+c05c */ { 0, 0, 0, 0, 0 },
/* U+c05d */ { 0, 0, 0, 0, 0 },
/* U+c05e */ { 0, 0, 0, 0, 0 },
/* U+c05f */ { 0, 0, 0, 0, 0 },
/* U+c060 */ { 0, 0, 0, 0, 0 },
/* U+c061 */ { 0, 0, 0, 0, 0 },
/* U+c062 */ { 0, 0, 0, 0, 0 },
/* U+c063 */ { 0, 0, 0, 0, 0 },
/* U+c064 */ { 0, 0, 0, 0, 0 },
/* U+c065 */ { 0, 0, 0, 0, 0 },
/* U+c066 */ { 0, 0, 0, 0, 0 },
/* U+c067 */ { 0, 0, 0, 0, 0 },
/* U+c068 */ { 0, 0, 0, 0, 0 },
/* U+c069 */ { 0, 0, 0, 0, 0 },
/* U+c06a */ { 0, 0, 0, 0, 0 },
/* U+c06b */ { 0, 0, 0, 0, 0 },
/* U+c06c */ { 0, 0, 0, 0, 0 },
/* U+c06d */ { 0, 0, 0, 0, 0 },
/* U+c06e */ { 0, 0, 0, 0, 0 },
/* U+c06f */ { 0, 0, 0, 0, 0 },
/* U+c070 */ { 0, 0, 0, 0, 0 },
/* U+c071 */ { 0, 0, 0, 0, 0 },
/* U+c072 */ { 0, 0, 0, 0, 0 },
/* U+c073 */ { 0, 0, 0, 0, 0 },
/* U+c074 */ { 0, 0, 0, 0, 0 },
/* U+c075 */ { 0, 0, 0, 0, 0 },
/* U+c076 */ { 0, 0, 0, 0, 0 },
/* U+c077 */ { 0, 0, 0, 0, 0 },
/* U+c078 */ { 0, 0, 0, 0, 0 },
/* U+c079 */ { 0, 0, 0, 0, 0 },
/* U+c07a */ { 0, 0, 0, 0, 0 },
/* U+c07b */ { 0, 0, 0, 0, 0 },
/* U+c07c */ { 0, 0, 0, 0, 0 },
/* U+c07d */ { 0, 0, 0, 0, 0 },
/* U+c07e */ { 0, 0, 0, 0, 0 },
/* U+c07f */ { 0, 0, 0, 0, 0 },
/* U+c080 */ { 0, 0, 0, 0, 0 },
/* U+c081 */ { 0, 0, 0, 0, 0 },
/* U+c082 */ { 0, 0, 0, 0, 0 },
/* U+c083 */ { 0, 0, 0, 0, 0 },
/* U+c084 */ { 0, 0, 0, 0, 0 },
/* U+c085 */ { 0, 0, 0, 0, 0 },
/* U+c086 */ { 0, 0, 0, 0, 0 },
/* U+c087 */ { 0, 0, 0, 0, 0 },
/* U+c088 */ { 0, 0, 0, 0, 0 },
/* U+c089 */ { 0, 0, 0, 0, 0 },
/* U+c08a */ { 0, 0, 0, 0, 0 },
/* U+c08b */ { 0, 0, 0, 0, 0 },
/* U+c08c */ { 0, 0, 0, 0, 0 },
/* U+c08d */ { 0, 0, 0, 0, 0 },
/* U+c08e */ { 0, 0, 0, 0, 0 },
/* U+c08f */ { 0, 0, 0, 0, 0 },
/* U+c090 */ { 0, 0, 0, 0, 0 },
/* U+c091 */ { 0, 0, 0, 0, 0 },
/* U+c092 */ { 0, 0, 0, 0, 0 },
/* U+c093 */ { 0, 0, 0, 0, 0 },
/* U+c094 */ { 0, 0, 0, 0, 0 },
/* U+c095 */ { 0, 0, 0, 0, 0 },
/* U+c096 */ { 0, 0, 0, 0, 0 },
/* U+c097 */ { 0, 0, 0, 0, 0 },
/* U+c098 */ { 0, 0, 0, 0, 0 },
/* U+c099 */ { 0, 0, 0, 0, 0 },
/* U+c09a */ { 0, 0, 0, 0, 0 },
/* U+c09b */ { 0, 0, 0, 0, 0 },
/* U+c09c */ { 0, 0, 0, 0, 0 },
/* U+c09d */ { 0, 0, 0, 0, 0 },
/* U+c09e */ { 0, 0, 0, 0, 0 },
/* U+c09f */ { 0, 0, 0, 0, 0 },
/* U+c0a0 */ { 0, 0, 0, 0, 0 },
/* U+c0a1 */ { 0, 0, 0, 0, 0 },
/* U+c0a2 */ { 0, 0, 0, 0, 0 },
/* U+c0a3 */ { 0, 0, 0, 0, 0 },
/* U+c0a4 */ { 0, 0, 0, 0, 0 },
/* U+c0a5 */ { 0, 0, 0, 0, 0 },
/* U+c0a6 */ { 0, 0, 0, 0, 0 },
/* U+c0a7 */ { 0, 0, 0, 0, 0 },
/* U+c0a8 */ { 0, 0, 0, 0, 0 },
/* U+c0a9 */ { 0, 0, 0, 0, 0 },
/* U+c0aa */ { 0, 0, 0, 0, 0 },
/* U+c0ab */ { 0, 0, 0, 0, 0 },
/* U+c0ac */ { 0, 0, 0, 0, 0 },
/* U+c0ad */ { 0, 0, 0, 0, 0 },
/* U+c0ae */ { 0, 0, 0, 0, 0 },
/* U+c0af */ { 0, 0, 0, 0, 0 },
/* U+c0b0 */ { 0, 0, 0, 0, 0 },
/* U+c0b1 */ { 0, 0, 0, 0, 0 },
/* U+c0b2 */ { 0, 0, 0, 0, 0 },
/* U+c0b3 */ { 0, 0, 0, 0, 0 },
/* U+c0b4 */ { 0, 0, 0, 0, 0 },
/* U+c0b5 */ { 0, 0, 0, 0, 0 },
/* U+c0b6 */ { 0, 0, 0, 0, 0 },
/* U+c0b7 */ { 0, 0, 0, 0, 0 },
/* U+c0b8 */ { 0, 0, 0, 0, 0 },
/* U+c0b9 */ { 0, 0, 0, 0, 0 },
/* U+c0ba */ { 0, 0, 0, 0, 0 },
/* U+c0bb */ { 0, 0, 0, 0, 0 },
/* U+c0bc */ { 0, 0, 0, 0, 0 },
/* U+c0bd */ { 0, 0, 0, 0, 0 },
/* U+c0be */ { 0, 0, 0, 0, 0 },
/* U+c0bf */ { 0, 0, 0, 0, 0 },
/* U+c0c0 */ { 0, 0, 0, 0, 0 },
/* U+c0c1 */ { 0, 0, 0, 0, 0 },
/* U+c0c2 */ { 0, 0, 0, 0, 0 },
/* U+c0c3 */ { 0, 0, 0, 0, 0 },
/* U+c0c4 */ { 0, 0, 0, 0, 0 },
/* U+c0c5 */ { 0, 0, 0, 0, 0 },
/* U+c0c6 */ { 0, 0, 0, 0, 0 },
/* U+c0c7 */ { 0, 0, 0, 0, 0 },
/* U+c0c8 */ { 0, 0, 0, 0, 0 },
/* U+c0c9 */ { 0, 0, 0, 0, 0 },
/* U+c0ca */ { 0, 0, 0, 0, 0 },
/* U+c0cb */ { 0, 0, 0, 0, 0 },
/* U+c0cc */ { 0, 0, 0, 0, 0 },
/* U+c0cd */ { 0, 0, 0, 0, 0 },
/* U+c0ce */ { 0, 0, 0, 0, 0 },
/* U+c0cf */ { 0, 0, 0, 0, 0 },
/* U+c0d0 */ { 0, 0, 0, 0, 0 },
/* U+c0d1 */ { 0, 0, 0, 0, 0 },
/* U+c0d2 */ { 0, 0, 0, 0, 0 },
/* U+c0d3 */ { 0, 0, 0, 0, 0 },
/* U+c0d4 */ { 0, 0, 0, 0, 0 },
/* U+c0d5 */ { 0, 0, 0, 0, 0 },
/* U+c0d6 */ { 0, 0, 0, 0, 0 },
/* U+c0d7 */ { 0, 0, 0, 0, 0 },
/* U+c0d8 */ { 0, 0, 0, 0, 0 },
/* U+c0d9 */ { 0, 0, 0, 0, 0 },
/* U+c0da */ { 0, 0, 0, 0, 0 },
/* U+c0db */ { 0, 0, 0, 0, 0 },
/* U+c0dc */ { 0, 0, 0, 0, 0 },
/* U+c0dd */ { 0, 0, 0, 0, 0 },
/* U+c0de */ { 0, 0, 0, 0, 0 },
/* U+c0df */ { 0, 0, 0, 0, 0 },
/* U+c0e0 */ { 0, 0, 0, 0, 0 },
/* U+c0e1 */ { 0, 0, 0, 0, 0 },
/* U+c0e2 */ { 0, 0, 0, 0, 0 },
/* U+c0e3 */ { 0, 0, 0, 0, 0 },
/* U+c0e4 */ { 0, 0, 0, 0, 0 },
/* U+c0e5 */ { 0, 0, 0, 0, 0 },
/* U+c0e6 */ { 0, 0, 0, 0, 0 },
/* U+c0e7 */ { 0, 0, 0, 0, 0 },
/* U+c0e8 */ { 0, 0, 0, 0, 0 },
/* U+c0e9 */ { 0, 0, 0, 0, 0 },
/* U+c0ea */ { 0, 0, 0, 0, 0 },
/* U+c0eb */ { 0, 0, 0, 0, 0 },
/* U+c0ec */ { 0, 0, 0, 0, 0 },
/* U+c0ed */ { 0, 0, 0, 0, 0 },
/* U+c0ee */ { 0, 0, 0, 0, 0 },
/* U+c0ef */ { 0, 0, 0, 0, 0 },
/* U+c0f0 */ { 0, 0, 0, 0, 0 },
/* U+c0f1 */ { 0, 0, 0, 0, 0 },
/* U+c0f2 */ { 0, 0, 0, 0, 0 },
/* U+c0f3 */ { 0, 0, 0, 0, 0 },
/* U+c0f4 */ { 0, 0, 0, 0, 0 },
/* U+c0f5 */ { 0, 0, 0, 0, 0 },
/* U+c0f6 */ { 0, 0, 0, 0, 0 },
/* U+c0f7 */ { 0, 0, 0, 0, 0 },
/* U+c0f8 */ { 0, 0, 0, 0, 0 },
/* U+c0f9 */ { 0, 0, 0, 0, 0 },
/* U+c0fa */ { 0, 0, 0, 0, 0 },
/* U+c0fb */ { 0, 0, 0, 0, 0 },
/* U+c0fc */ { 0, 0, 0, 0, 0 },
/* U+c0fd */ { 0, 0, 0, 0, 0 },
/* U+c0fe */ { 0, 0, 0, 0, 0 },
/* U+c0ff */ { 0, 0, 0, 0, 0 },
/* U+c100 */ { 0, 0, 0, 0, 0 },
/* U+c101 */ { 0, 0, 0, 0, 0 },
/* U+c102 */ { 0, 0, 0, 0, 0 },
/* U+c103 */ { 0, 0, 0, 0, 0 },
/* U+c104 */ { 0, 0, 0, 0, 0 },
/* U+c105 */ { 0, 0, 0, 0, 0 },
/* U+c106 */ { 0, 0, 0, 0, 0 },
/* U+c107 */ { 0, 0, 0, 0, 0 },
/* U+c108 */ { 0, 0, 0, 0, 0 },
/* U+c109 */ { 0, 0, 0, 0, 0 },
/* U+c10a */ { 0, 0, 0, 0, 0 },
/* U+c10b */ { 0, 0, 0, 0, 0 },
/* U+c10c */ { 0, 0, 0, 0, 0 },
/* U+c10d */ { 0, 0, 0, 0, 0 },
/* U+c10e */ { 0, 0, 0, 0, 0 },
/* U+c10f */ { 0, 0, 0, 0, 0 },
/* U+c110 */ { 0, 0, 0, 0, 0 },
/* U+c111 */ { 0, 0, 0, 0, 0 },
/* U+c112 */ { 0, 0, 0, 0, 0 },
/* U+c113 */ { 0, 0, 0, 0, 0 },
/* U+c114 */ { 0, 0, 0, 0, 0 },
/* U+c115 */ { 0, 0, 0, 0, 0 },
/* U+c116 */ { 0, 0, 0, 0, 0 },
/* U+c117 */ { 0, 0, 0, 0, 0 },
/* U+c118 */ { 0, 0, 0, 0, 0 },
/* U+c119 */ { 0, 0, 0, 0, 0 },
/* U+c11a */ { 0, 0, 0, 0, 0 },
/* U+c11b */ { 0, 0, 0, 0, 0 },
/* U+c11c */ { 0, 0, 0, 0, 0 },
/* U+c11d */ { 0, 0, 0, 0, 0 },
/* U+c11e */ { 0, 0, 0, 0, 0 },
/* U+c11f */ { 0, 0, 0, 0, 0 },
/* U+c120 */ { 0, 0, 0, 0, 0 },
/* U+c121 */ { 0, 0, 0, 0, 0 },
/* U+c122 */ { 0, 0, 0, 0, 0 },
/* U+c123 */ { 0, 0, 0, 0, 0 },
/* U+c124 */ { 0, 0, 0, 0, 0 },
/* U+c125 */ { 0, 0, 0, 0, 0 },
/* U+c126 */ { 0, 0, 0, 0, 0 },
/* U+c127 */ { 0, 0, 0, 0, 0 },
/* U+c128 */ { 0, 0, 0, 0, 0 },
/* U+c129 */ { 0, 0, 0, 0, 0 },
/* U+c12a */ { 0, 0, 0, 0, 0 },
/* U+c12b */ { 0, 0, 0, 0, 0 },
/* U+c12c */ { 0, 0, 0, 0, 0 },
/* U+c12d */ { 0, 0, 0, 0, 0 },
/* U+c12e */ { 0, 0, 0, 0, 0 },
/* U+c12f */ { 0, 0, 0, 0, 0 },
/* U+c130 */ { 0, 0, 0, 0, 0 },
/* U+c131 */ { 0, 0, 0, 0, 0 },
/* U+c132 */ { 0, 0, 0, 0, 0 },
/* U+c133 */ { 0, 0, 0, 0, 0 },
/* U+c134 */ { 0, 0, 0, 0, 0 },
/* U+c135 */ { 0, 0, 0, 0, 0 },
/* U+c136 */ { 0, 0, 0, 0, 0 },
/* U+c137 */ { 0, 0, 0, 0, 0 },
/* U+c138 */ { 0, 0, 0, 0, 0 },
/* U+c139 */ { 0, 0, 0, 0, 0 },
/* U+c13a */ { 0, 0, 0, 0, 0 },
/* U+c13b */ { 0, 0, 0, 0, 0 },
/* U+c13c */ { 0, 0, 0, 0, 0 },
/* U+c13d */ { 0, 0, 0, 0, 0 },
/* U+c13e */ { 0, 0, 0, 0, 0 },
/* U+c13f */ { 0, 0, 0, 0, 0 },
/* U+c140 */ { 0, 0, 0, 0, 0 },
/* U+c141 */ { 0, 0, 0, 0, 0 },
/* U+c142 */ { 0, 0, 0, 0, 0 },
/* U+c143 */ { 0, 0, 0, 0, 0 },
/* U+c144 */ { 0, 0, 0, 0, 0 },
/* U+c145 */ { 0, 0, 0, 0, 0 },
/* U+c146 */ { 0, 0, 0, 0, 0 },
/* U+c147 */ { 0, 0, 0, 0, 0 },
/* U+c148 */ { 0, 0, 0, 0, 0 },
/* U+c149 */ { 0, 0, 0, 0, 0 },
/* U+c14a */ { 0, 0, 0, 0, 0 },
/* U+c14b */ { 0, 0, 0, 0, 0 },
/* U+c14c */ { 0, 0, 0, 0, 0 },
/* U+c14d */ { 0, 0, 0, 0, 0 },
/* U+c14e */ { 0, 0, 0, 0, 0 },
/* U+c14f */ { 0, 0, 0, 0, 0 },
/* U+c150 */ { 0, 0, 0, 0, 0 },
/* U+c151 */ { 0, 0, 0, 0, 0 },
/* U+c152 */ { 0, 0, 0, 0, 0 },
/* U+c153 */ { 0, 0, 0, 0, 0 },
/* U+c154 */ { 0, 0, 0, 0, 0 },
/* U+c155 */ { 0, 0, 0, 0, 0 },
/* U+c156 */ { 0, 0, 0, 0, 0 },
/* U+c157 */ { 0, 0, 0, 0, 0 },
/* U+c158 */ { 0, 0, 0, 0, 0 },
/* U+c159 */ { 0, 0, 0, 0, 0 },
/* U+c15a */ { 0, 0, 0, 0, 0 },
/* U+c15b */ { 0, 0, 0, 0, 0 },
/* U+c15c */ { 0, 0, 0, 0, 0 },
/* U+c15d */ { 0, 0, 0, 0, 0 },
/* U+c15e */ { 0, 0, 0, 0, 0 },
/* U+c15f */ { 0, 0, 0, 0, 0 },
/* U+c160 */ { 0, 0, 0, 0, 0 },
/* U+c161 */ { 0, 0, 0, 0, 0 },
/* U+c162 */ { 0, 0, 0, 0, 0 },
/* U+c163 */ { 0, 0, 0, 0, 0 },
/* U+c164 */ { 0, 0, 0, 0, 0 },
/* U+c165 */ { 0, 0, 0, 0, 0 },
/* U+c166 */ { 0, 0, 0, 0, 0 },
/* U+c167 */ { 0, 0, 0, 0, 0 },
/* U+c168 */ { 0, 0, 0, 0, 0 },
/* U+c169 */ { 0, 0, 0, 0, 0 },
/* U+c16a */ { 0, 0, 0, 0, 0 },
/* U+c16b */ { 0, 0, 0, 0, 0 },
/* U+c16c */ { 0, 0, 0, 0, 0 },
/* U+c16d */ { 0, 0, 0, 0, 0 },
/* U+c16e */ { 0, 0, 0, 0, 0 },
/* U+c16f */ { 0, 0, 0, 0, 0 },
/* U+c170 */ { 0, 0, 0, 0, 0 },
/* U+c171 */ { 0, 0, 0, 0, 0 },
/* U+c172 */ { 0, 0, 0, 0, 0 },
/* U+c173 */ { 0, 0, 0, 0, 0 },
/* U+c174 */ { 0, 0, 0, 0, 0 },
/* U+c175 */ { 0, 0, 0, 0, 0 },
/* U+c176 */ { 0, 0, 0, 0, 0 },
/* U+c177 */ { 0, 0, 0, 0, 0 },
/* U+c178 */ { 0, 0, 0, 0, 0 },
/* U+c179 */ { 0, 0, 0, 0, 0 },
/* U+c17a */ { 0, 0, 0, 0, 0 },
/* U+c17b */ { 0, 0, 0, 0, 0 },
/* U+c17c */ { 0, 0, 0, 0, 0 },
/* U+c17d */ { 0, 0, 0, 0, 0 },
/* U+c17e */ { 0, 0, 0, 0, 0 },
/* U+c17f */ { 0, 0, 0, 0, 0 },
/* U+c180 */ { 0, 0, 0, 0, 0 },
/* U+c181 */ { 0, 0, 0, 0, 0 },
/* U+c182 */ { 0, 0, 0, 0, 0 },
/* U+c183 */ { 0, 0, 0, 0, 0 },
/* U+c184 */ { 0, 0, 0, 0, 0 },
/* U+c185 */ { 0, 0, 0, 0, 0 },
/* U+c186 */ { 0, 0, 0, 0, 0 },
/* U+c187 */ { 0, 0, 0, 0, 0 },
/* U+c188 */ { 0, 0, 0, 0, 0 },
/* U+c189 */ { 0, 0, 0, 0, 0 },
/* U+c18a */ { 0, 0, 0, 0, 0 },
/* U+c18b */ { 0, 0, 0, 0, 0 },
/* U+c18c */ { 0, 0, 0, 0, 0 },
/* U+c18d */ { 0, 0, 0, 0, 0 },
/* U+c18e */ { 0, 0, 0, 0, 0 },
/* U+c18f */ { 0, 0, 0, 0, 0 },
/* U+c190 */ { 0, 0, 0, 0, 0 },
/* U+c191 */ { 0, 0, 0, 0, 0 },
/* U+c192 */ { 0, 0, 0, 0, 0 },
/* U+c193 */ { 0, 0, 0, 0, 0 },
/* U+c194 */ { 0, 0, 0, 0, 0 },
/* U+c195 */ { 0, 0, 0, 0, 0 },
/* U+c196 */ { 0, 0, 0, 0, 0 },
/* U+c197 */ { 0, 0, 0, 0, 0 },
/* U+c198 */ { 0, 0, 0, 0, 0 },
/* U+c199 */ { 0, 0, 0, 0, 0 },
/* U+c19a */ { 0, 0, 0, 0, 0 },
/* U+c19b */ { 0, 0, 0, 0, 0 },
/* U+c19c */ { 0, 0, 0, 0, 0 },
/* U+c19d */ { 0, 0, 0, 0, 0 },
/* U+c19e */ { 0, 0, 0, 0, 0 },
/* U+c19f */ { 0, 0, 0, 0, 0 },
/* U+c1a0 */ { 0, 0, 0, 0, 0 },
/* U+c1a1 */ { 0, 0, 0, 0, 0 },
/* U+c1a2 */ { 0, 0, 0, 0, 0 },
/* U+c1a3 */ { 0, 0, 0, 0, 0 },
/* U+c1a4 */ { 0, 0, 0, 0, 0 },
/* U+c1a5 */ { 0, 0, 0, 0, 0 },
/* U+c1a6 */ { 0, 0, 0, 0, 0 },
/* U+c1a7 */ { 0, 0, 0, 0, 0 },
/* U+c1a8 */ { 0, 0, 0, 0, 0 },
/* U+c1a9 */ { 0, 0, 0, 0, 0 },
/* U+c1aa */ { 0, 0, 0, 0, 0 },
/* U+c1ab */ { 0, 0, 0, 0, 0 },
/* U+c1ac */ { 0, 0, 0, 0, 0 },
/* U+c1ad */ { 0, 0, 0, 0, 0 },
/* U+c1ae */ { 0, 0, 0, 0, 0 },
/* U+c1af */ { 0, 0, 0, 0, 0 },
/* U+c1b0 */ { 0, 0, 0, 0, 0 },
/* U+c1b1 */ { 0, 0, 0, 0, 0 },
/* U+c1b2 */ { 0, 0, 0, 0, 0 },
/* U+c1b3 */ { 0, 0, 0, 0, 0 },
/* U+c1b4 */ { 0, 0, 0, 0, 0 },
/* U+c1b5 */ { 0, 0, 0, 0, 0 },
/* U+c1b6 */ { 0, 0, 0, 0, 0 },
/* U+c1b7 */ { 0, 0, 0, 0, 0 },
/* U+c1b8 */ { 0, 0, 0, 0, 0 },
/* U+c1b9 */ { 0, 0, 0, 0, 0 },
/* U+c1ba */ { 0, 0, 0, 0, 0 },
/* U+c1bb */ { 0, 0, 0, 0, 0 },
/* U+c1bc */ { 0, 0, 0, 0, 0 },
/* U+c1bd */ { 0, 0, 0, 0, 0 },
/* U+c1be */ { 0, 0, 0, 0, 0 },
/* U+c1bf */ { 0, 0, 0, 0, 0 },
/* U+c1c0 */ { 0, 0, 0, 0, 0 },
/* U+c1c1 */ { 0, 0, 0, 0, 0 },
/* U+c1c2 */ { 0, 0, 0, 0, 0 },
/* U+c1c3 */ { 0, 0, 0, 0, 0 },
/* U+c1c4 */ { 0, 0, 0, 0, 0 },
/* U+c1c5 */ { 0, 0, 0, 0, 0 },
/* U+c1c6 */ { 0, 0, 0, 0, 0 },
/* U+c1c7 */ { 0, 0, 0, 0, 0 },
/* U+c1c8 */ { 0, 0, 0, 0, 0 },
/* U+c1c9 */ { 0, 0, 0, 0, 0 },
/* U+c1ca */ { 0, 0, 0, 0, 0 },
/* U+c1cb */ { 0, 0, 0, 0, 0 },
/* U+c1cc */ { 0, 0, 0, 0, 0 },
/* U+c1cd */ { 0, 0, 0, 0, 0 },
/* U+c1ce */ { 0, 0, 0, 0, 0 },
/* U+c1cf */ { 0, 0, 0, 0, 0 },
/* U+c1d0 */ { 0, 0, 0, 0, 0 },
/* U+c1d1 */ { 0, 0, 0, 0, 0 },
/* U+c1d2 */ { 0, 0, 0, 0, 0 },
/* U+c1d3 */ { 0, 0, 0, 0, 0 },
/* U+c1d4 */ { 0, 0, 0, 0, 0 },
/* U+c1d5 */ { 0, 0, 0, 0, 0 },
/* U+c1d6 */ { 0, 0, 0, 0, 0 },
/* U+c1d7 */ { 0, 0, 0, 0, 0 },
/* U+c1d8 */ { 0, 0, 0, 0, 0 },
/* U+c1d9 */ { 0, 0, 0, 0, 0 },
/* U+c1da */ { 0, 0, 0, 0, 0 },
/* U+c1db */ { 0, 0, 0, 0, 0 },
/* U+c1dc */ { 0, 0, 0, 0, 0 },
/* U+c1dd */ { 0, 0, 0, 0, 0 },
/* U+c1de */ { 0, 0, 0, 0, 0 },
/* U+c1df */ { 0, 0, 0, 0, 0 },
/* U+c1e0 */ { 0, 0, 0, 0, 0 },
/* U+c1e1 */ { 0, 0, 0, 0, 0 },
/* U+c1e2 */ { 0, 0, 0, 0, 0 },
/* U+c1e3 */ { 0, 0, 0, 0, 0 },
/* U+c1e4 */ { 0, 0, 0, 0, 0 },
/* U+c1e5 */ { 0, 0, 0, 0, 0 },
/* U+c1e6 */ { 0, 0, 0, 0, 0 },
/* U+c1e7 */ { 0, 0, 0, 0, 0 },
/* U+c1e8 */ { 0, 0, 0, 0, 0 },
/* U+c1e9 */ { 0, 0, 0, 0, 0 },
/* U+c1ea */ { 0, 0, 0, 0, 0 },
/* U+c1eb */ { 0, 0, 0, 0, 0 },
/* U+c1ec */ { 0, 0, 0, 0, 0 },
/* U+c1ed */ { 0, 0, 0, 0, 0 },
/* U+c1ee */ { 0, 0, 0, 0, 0 },
/* U+c1ef */ { 0, 0, 0, 0, 0 },
/* U+c1f0 */ { 0, 0, 0, 0, 0 },
/* U+c1f1 */ { 0, 0, 0, 0, 0 },
/* U+c1f2 */ { 0, 0, 0, 0, 0 },
/* U+c1f3 */ { 0, 0, 0, 0, 0 },
/* U+c1f4 */ { 0, 0, 0, 0, 0 },
/* U+c1f5 */ { 0, 0, 0, 0, 0 },
/* U+c1f6 */ { 0, 0, 0, 0, 0 },
/* U+c1f7 */ { 0, 0, 0, 0, 0 },
/* U+c1f8 */ { 0, 0, 0, 0, 0 },
/* U+c1f9 */ { 0, 0, 0, 0, 0 },
/* U+c1fa */ { 0, 0, 0, 0, 0 },
/* U+c1fb */ { 0, 0, 0, 0, 0 },
/* U+c1fc */ { 0, 0, 0, 0, 0 },
/* U+c1fd */ { 0, 0, 0, 0, 0 },
/* U+c1fe */ { 0, 0, 0, 0, 0 },
/* U+c1ff */ { 0, 0, 0, 0, 0 },
/* U+c200 */ { 0, 0, 0, 0, 0 },
/* U+c201 */ { 0, 0, 0, 0, 0 },
/* U+c202 */ { 0, 0, 0, 0, 0 },
/* U+c203 */ { 0, 0, 0, 0, 0 },
/* U+c204 */ { 0, 0, 0, 0, 0 },
/* U+c205 */ { 0, 0, 0, 0, 0 },
/* U+c206 */ { 0, 0, 0, 0, 0 },
/* U+c207 */ { 0, 0, 0, 0, 0 },
/* U+c208 */ { 0, 0, 0, 0, 0 },
/* U+c209 */ { 0, 0, 0, 0, 0 },
/* U+c20a */ { 0, 0, 0, 0, 0 },
/* U+c20b */ { 0, 0, 0, 0, 0 },
/* U+c20c */ { 0, 0, 0, 0, 0 },
/* U+c20d */ { 0, 0, 0, 0, 0 },
/* U+c20e */ { 0, 0, 0, 0, 0 },
/* U+c20f */ { 0, 0, 0, 0, 0 },
/* U+c210 */ { 0, 0, 0, 0, 0 },
/* U+c211 */ { 0, 0, 0, 0, 0 },
/* U+c212 */ { 0, 0, 0, 0, 0 },
/* U+c213 */ { 0, 0, 0, 0, 0 },
/* U+c214 */ { 0, 0, 0, 0, 0 },
/* U+c215 */ { 0, 0, 0, 0, 0 },
/* U+c216 */ { 0, 0, 0, 0, 0 },
/* U+c217 */ { 0, 0, 0, 0, 0 },
/* U+c218 */ { 0, 0, 0, 0, 0 },
/* U+c219 */ { 0, 0, 0, 0, 0 },
/* U+c21a */ { 0, 0, 0, 0, 0 },
/* U+c21b */ { 0, 0, 0, 0, 0 },
/* U+c21c */ { 0, 0, 0, 0, 0 },
/* U+c21d */ { 0, 0, 0, 0, 0 },
/* U+c21e */ { 0, 0, 0, 0, 0 },
/* U+c21f */ { 0, 0, 0, 0, 0 },
/* U+c220 */ { 0, 0, 0, 0, 0 },
/* U+c221 */ { 0, 0, 0, 0, 0 },
/* U+c222 */ { 0, 0, 0, 0, 0 },
/* U+c223 */ { 0, 0, 0, 0, 0 },
/* U+c224 */ { 0, 0, 0, 0, 0 },
/* U+c225 */ { 0, 0, 0, 0, 0 },
/* U+c226 */ { 0, 0, 0, 0, 0 },
/* U+c227 */ { 0, 0, 0, 0, 0 },
/* U+c228 */ { 0, 0, 0, 0, 0 },
/* U+c229 */ { 0, 0, 0, 0, 0 },
/* U+c22a */ { 0, 0, 0, 0, 0 },
/* U+c22b */ { 0, 0, 0, 0, 0 },
/* U+c22c */ { 0, 0, 0, 0, 0 },
/* U+c22d */ { 0, 0, 0, 0, 0 },
/* U+c22e */ { 0, 0, 0, 0, 0 },
/* U+c22f */ { 0, 0, 0, 0, 0 },
/* U+c230 */ { 0, 0, 0, 0, 0 },
/* U+c231 */ { 0, 0, 0, 0, 0 },
/* U+c232 */ { 0, 0, 0, 0, 0 },
/* U+c233 */ { 0, 0, 0, 0, 0 },
/* U+c234 */ { 0, 0, 0, 0, 0 },
/* U+c235 */ { 0, 0, 0, 0, 0 },
/* U+c236 */ { 0, 0, 0, 0, 0 },
/* U+c237 */ { 0, 0, 0, 0, 0 },
/* U+c238 */ { 0, 0, 0, 0, 0 },
/* U+c239 */ { 0, 0, 0, 0, 0 },
/* U+c23a */ { 0, 0, 0, 0, 0 },
/* U+c23b */ { 0, 0, 0, 0, 0 },
/* U+c23c */ { 0, 0, 0, 0, 0 },
/* U+c23d */ { 0, 0, 0, 0, 0 },
/* U+c23e */ { 0, 0, 0, 0, 0 },
/* U+c23f */ { 0, 0, 0, 0, 0 },
/* U+c240 */ { 0, 0, 0, 0, 0 },
/* U+c241 */ { 0, 0, 0, 0, 0 },
/* U+c242 */ { 0, 0, 0, 0, 0 },
/* U+c243 */ { 0, 0, 0, 0, 0 },
/* U+c244 */ { 0, 0, 0, 0, 0 },
/* U+c245 */ { 0, 0, 0, 0, 0 },
/* U+c246 */ { 0, 0, 0, 0, 0 },
/* U+c247 */ { 0, 0, 0, 0, 0 },
/* U+c248 */ { 0, 0, 0, 0, 0 },
/* U+c249 */ { 0, 0, 0, 0, 0 },
/* U+c24a */ { 0, 0, 0, 0, 0 },
/* U+c24b */ { 0, 0, 0, 0, 0 },
/* U+c24c */ { 0, 0, 0, 0, 0 },
/* U+c24d */ { 0, 0, 0, 0, 0 },
/* U+c24e */ { 0, 0, 0, 0, 0 },
/* U+c24f */ { 0, 0, 0, 0, 0 },
/* U+c250 */ { 0, 0, 0, 0, 0 },
/* U+c251 */ { 0, 0, 0, 0, 0 },
/* U+c252 */ { 0, 0, 0, 0, 0 },
/* U+c253 */ { 0, 0, 0, 0, 0 },
/* U+c254 */ { 0, 0, 0, 0, 0 },
/* U+c255 */ { 0, 0, 0, 0, 0 },
/* U+c256 */ { 0, 0, 0, 0, 0 },
/* U+c257 */ { 0, 0, 0, 0, 0 },
/* U+c258 */ { 0, 0, 0, 0, 0 },
/* U+c259 */ { 0, 0, 0, 0, 0 },
/* U+c25a */ { 0, 0, 0, 0, 0 },
/* U+c25b */ { 0, 0, 0, 0, 0 },
/* U+c25c */ { 0, 0, 0, 0, 0 },
/* U+c25d */ { 0, 0, 0, 0, 0 },
/* U+c25e */ { 0, 0, 0, 0, 0 },
/* U+c25f */ { 0, 0, 0, 0, 0 },
/* U+c260 */ { 0, 0, 0, 0, 0 },
/* U+c261 */ { 0, 0, 0, 0, 0 },
/* U+c262 */ { 0, 0, 0, 0, 0 },
/* U+c263 */ { 0, 0, 0, 0, 0 },
/* U+c264 */ { 0, 0, 0, 0, 0 },
/* U+c265 */ { 0, 0, 0, 0, 0 },
/* U+c266 */ { 0, 0, 0, 0, 0 },
/* U+c267 */ { 0, 0, 0, 0, 0 },
/* U+c268 */ { 0, 0, 0, 0, 0 },
/* U+c269 */ { 0, 0, 0, 0, 0 },
/* U+c26a */ { 0, 0, 0, 0, 0 },
/* U+c26b */ { 0, 0, 0, 0, 0 },
/* U+c26c */ { 0, 0, 0, 0, 0 },
/* U+c26d */ { 0, 0, 0, 0, 0 },
/* U+c26e */ { 0, 0, 0, 0, 0 },
/* U+c26f */ { 0, 0, 0, 0, 0 },
/* U+c270 */ { 0, 0, 0, 0, 0 },
/* U+c271 */ { 0, 0, 0, 0, 0 },
/* U+c272 */ { 0, 0, 0, 0, 0 },
/* U+c273 */ { 0, 0, 0, 0, 0 },
/* U+c274 */ { 0, 0, 0, 0, 0 },
/* U+c275 */ { 0, 0, 0, 0, 0 },
/* U+c276 */ { 0, 0, 0, 0, 0 },
/* U+c277 */ { 0, 0, 0, 0, 0 },
/* U+c278 */ { 0, 0, 0, 0, 0 },
/* U+c279 */ { 0, 0, 0, 0, 0 },
/* U+c27a */ { 0, 0, 0, 0, 0 },
/* U+c27b */ { 0, 0, 0, 0, 0 },
/* U+c27c */ { 0, 0, 0, 0, 0 },
/* U+c27d */ { 0, 0, 0, 0, 0 },
/* U+c27e */ { 0, 0, 0, 0, 0 },
/* U+c27f */ { 0, 0, 0, 0, 0 },
/* U+c280 */ { 0, 0, 0, 0, 0 },
/* U+c281 */ { 0, 0, 0, 0, 0 },
/* U+c282 */ { 0, 0, 0, 0, 0 },
/* U+c283 */ { 0, 0, 0, 0, 0 },
/* U+c284 */ { 0, 0, 0, 0, 0 },
/* U+c285 */ { 0, 0, 0, 0, 0 },
/* U+c286 */ { 0, 0, 0, 0, 0 },
/* U+c287 */ { 0, 0, 0, 0, 0 },
/* U+c288 */ { 0, 0, 0, 0, 0 },
/* U+c289 */ { 0, 0, 0, 0, 0 },
/* U+c28a */ { 0, 0, 0, 0, 0 },
/* U+c28b */ { 0, 0, 0, 0, 0 },
/* U+c28c */ { 0, 0, 0, 0, 0 },
/* U+c28d */ { 0, 0, 0, 0, 0 },
/* U+c28e */ { 0, 0, 0, 0, 0 },
/* U+c28f */ { 0, 0, 0, 0, 0 },
/* U+c290 */ { 0, 0, 0, 0, 0 },
/* U+c291 */ { 0, 0, 0, 0, 0 },
/* U+c292 */ { 0, 0, 0, 0, 0 },
/* U+c293 */ { 0, 0, 0, 0, 0 },
/* U+c294 */ { 0, 0, 0, 0, 0 },
/* U+c295 */ { 0, 0, 0, 0, 0 },
/* U+c296 */ { 0, 0, 0, 0, 0 },
/* U+c297 */ { 0, 0, 0, 0, 0 },
/* U+c298 */ { 0, 0, 0, 0, 0 },
/* U+c299 */ { 0, 0, 0, 0, 0 },
/* U+c29a */ { 0, 0, 0, 0, 0 },
/* U+c29b */ { 0, 0, 0, 0, 0 },
/* U+c29c */ { 0, 0, 0, 0, 0 },
/* U+c29d */ { 0, 0, 0, 0, 0 },
/* U+c29e */ { 0, 0, 0, 0, 0 },
/* U+c29f */ { 0, 0, 0, 0, 0 },
/* U+c2a0 */ { 0, 0, 0, 0, 0 },
/* U+c2a1 */ { 0, 0, 0, 0, 0 },
/* U+c2a2 */ { 0, 0, 0, 0, 0 },
/* U+c2a3 */ { 0, 0, 0, 0, 0 },
/* U+c2a4 */ { 0, 0, 0, 0, 0 },
/* U+c2a5 */ { 0, 0, 0, 0, 0 },
/* U+c2a6 */ { 0, 0, 0, 0, 0 },
/* U+c2a7 */ { 0, 0, 0, 0, 0 },
/* U+c2a8 */ { 0, 0, 0, 0, 0 },
/* U+c2a9 */ { 0, 0, 0, 0, 0 },
/* U+c2aa */ { 0, 0, 0, 0, 0 },
/* U+c2ab */ { 0, 0, 0, 0, 0 },
/* U+c2ac */ { 0, 0, 0, 0, 0 },
/* U+c2ad */ { 0, 0, 0, 0, 0 },
/* U+c2ae */ { 0, 0, 0, 0, 0 },
/* U+c2af */ { 0, 0, 0, 0, 0 },
/* U+c2b0 */ { 0, 0, 0, 0, 0 },
/* U+c2b1 */ { 0, 0, 0, 0, 0 },
/* U+c2b2 */ { 0, 0, 0, 0, 0 },
/* U+c2b3 */ { 0, 0, 0, 0, 0 },
/* U+c2b4 */ { 0, 0, 0, 0, 0 },
/* U+c2b5 */ { 0, 0, 0, 0, 0 },
/* U+c2b6 */ { 0, 0, 0, 0, 0 },
/* U+c2b7 */ { 0, 0, 0, 0, 0 },
/* U+c2b8 */ { 0, 0, 0, 0, 0 },
/* U+c2b9 */ { 0, 0, 0, 0, 0 },
/* U+c2ba */ { 0, 0, 0, 0, 0 },
/* U+c2bb */ { 0, 0, 0, 0, 0 },
/* U+c2bc */ { 0, 0, 0, 0, 0 },
/* U+c2bd */ { 0, 0, 0, 0, 0 },
/* U+c2be */ { 0, 0, 0, 0, 0 },
/* U+c2bf */ { 0, 0, 0, 0, 0 },
/* U+c2c0 */ { 0, 0, 0, 0, 0 },
/* U+c2c1 */ { 0, 0, 0, 0, 0 },
/* U+c2c2 */ { 0, 0, 0, 0, 0 },
/* U+c2c3 */ { 0, 0, 0, 0, 0 },
/* U+c2c4 */ { 0, 0, 0, 0, 0 },
/* U+c2c5 */ { 0, 0, 0, 0, 0 },
/* U+c2c6 */ { 0, 0, 0, 0, 0 },
/* U+c2c7 */ { 0, 0, 0, 0, 0 },
/* U+c2c8 */ { 0, 0, 0, 0, 0 },
/* U+c2c9 */ { 0, 0, 0, 0, 0 },
/* U+c2ca */ { 0, 0, 0, 0, 0 },
/* U+c2cb */ { 0, 0, 0, 0, 0 },
/* U+c2cc */ { 0, 0, 0, 0, 0 },
/* U+c2cd */ { 0, 0, 0, 0, 0 },
/* U+c2ce */ { 0, 0, 0, 0, 0 },
/* U+c2cf */ { 0, 0, 0, 0, 0 },
/* U+c2d0 */ { 0, 0, 0, 0, 0 },
/* U+c2d1 */ { 0, 0, 0, 0, 0 },
/* U+c2d2 */ { 0, 0, 0, 0, 0 },
/* U+c2d3 */ { 0, 0, 0, 0, 0 },
/* U+c2d4 */ { 0, 0, 0, 0, 0 },
/* U+c2d5 */ { 0, 0, 0, 0, 0 },
/* U+c2d6 */ { 0, 0, 0, 0, 0 },
/* U+c2d7 */ { 0, 0, 0, 0, 0 },
/* U+c2d8 */ { 0, 0, 0, 0, 0 },
/* U+c2d9 */ { 0, 0, 0, 0, 0 },
/* U+c2da */ { 0, 0, 0, 0, 0 },
/* U+c2db */ { 0, 0, 0, 0, 0 },
/* U+c2dc */ { 0, 0, 0, 0, 0 },
/* U+c2dd */ { 0, 0, 0, 0, 0 },
/* U+c2de */ { 0, 0, 0, 0, 0 },
/* U+c2df */ { 0, 0, 0, 0, 0 },
/* U+c2e0 */ { 0, 0, 0, 0, 0 },
/* U+c2e1 */ { 0, 0, 0, 0, 0 },
/* U+c2e2 */ { 0, 0, 0, 0, 0 },
/* U+c2e3 */ { 0, 0, 0, 0, 0 },
/* U+c2e4 */ { 0, 0, 0, 0, 0 },
/* U+c2e5 */ { 0, 0, 0, 0, 0 },
/* U+c2e6 */ { 0, 0, 0, 0, 0 },
/* U+c2e7 */ { 0, 0, 0, 0, 0 },
/* U+c2e8 */ { 0, 0, 0, 0, 0 },
/* U+c2e9 */ { 0, 0, 0, 0, 0 },
/* U+c2ea */ { 0, 0, 0, 0, 0 },
/* U+c2eb */ { 0, 0, 0, 0, 0 },
/* U+c2ec */ { 0, 0, 0, 0, 0 },
/* U+c2ed */ { 0, 0, 0, 0, 0 },
/* U+c2ee */ { 0, 0, 0, 0, 0 },
/* U+c2ef */ { 0, 0, 0, 0, 0 },
/* U+c2f0 */ { 0, 0, 0, 0, 0 },
/* U+c2f1 */ { 0, 0, 0, 0, 0 },
/* U+c2f2 */ { 0, 0, 0, 0, 0 },
/* U+c2f3 */ { 0, 0, 0, 0, 0 },
/* U+c2f4 */ { 0, 0, 0, 0, 0 },
/* U+c2f5 */ { 0, 0, 0, 0, 0 },
/* U+c2f6 */ { 0, 0, 0, 0, 0 },
/* U+c2f7 */ { 0, 0, 0, 0, 0 },
/* U+c2f8 */ { 0, 0, 0, 0, 0 },
/* U+c2f9 */ { 0, 0, 0, 0, 0 },
/* U+c2fa */ { 0, 0, 0, 0, 0 },
/* U+c2fb */ { 0, 0, 0, 0, 0 },
/* U+c2fc */ { 0, 0, 0, 0, 0 },
/* U+c2fd */ { 0, 0, 0, 0, 0 },
/* U+c2fe */ { 0, 0, 0, 0, 0 },
/* U+c2ff */ { 0, 0, 0, 0, 0 },
/* U+c300 */ { 0, 0, 0, 0, 0 },
/* U+c301 */ { 0, 0, 0, 0, 0 },
/* U+c302 */ { 0, 0, 0, 0, 0 },
/* U+c303 */ { 0, 0, 0, 0, 0 },
/* U+c304 */ { 0, 0, 0, 0, 0 },
/* U+c305 */ { 0, 0, 0, 0, 0 },
/* U+c306 */ { 0, 0, 0, 0, 0 },
/* U+c307 */ { 0, 0, 0, 0, 0 },
/* U+c308 */ { 0, 0, 0, 0, 0 },
/* U+c309 */ { 0, 0, 0, 0, 0 },
/* U+c30a */ { 0, 0, 0, 0, 0 },
/* U+c30b */ { 0, 0, 0, 0, 0 },
/* U+c30c */ { 0, 0, 0, 0, 0 },
/* U+c30d */ { 0, 0, 0, 0, 0 },
/* U+c30e */ { 0, 0, 0, 0, 0 },
/* U+c30f */ { 0, 0, 0, 0, 0 },
/* U+c310 */ { 0, 0, 0, 0, 0 },
/* U+c311 */ { 0, 0, 0, 0, 0 },
/* U+c312 */ { 0, 0, 0, 0, 0 },
/* U+c313 */ { 0, 0, 0, 0, 0 },
/* U+c314 */ { 0, 0, 0, 0, 0 },
/* U+c315 */ { 0, 0, 0, 0, 0 },
/* U+c316 */ { 0, 0, 0, 0, 0 },
/* U+c317 */ { 0, 0, 0, 0, 0 },
/* U+c318 */ { 0, 0, 0, 0, 0 },
/* U+c319 */ { 0, 0, 0, 0, 0 },
/* U+c31a */ { 0, 0, 0, 0, 0 },
/* U+c31b */ { 0, 0, 0, 0, 0 },
/* U+c31c */ { 0, 0, 0, 0, 0 },
/* U+c31d */ { 0, 0, 0, 0, 0 },
/* U+c31e */ { 0, 0, 0, 0, 0 },
/* U+c31f */ { 0, 0, 0, 0, 0 },
/* U+c320 */ { 0, 0, 0, 0, 0 },
/* U+c321 */ { 0, 0, 0, 0, 0 },
/* U+c322 */ { 0, 0, 0, 0, 0 },
/* U+c323 */ { 0, 0, 0, 0, 0 },
/* U+c324 */ { 0, 0, 0, 0, 0 },
/* U+c325 */ { 0, 0, 0, 0, 0 },
/* U+c326 */ { 0, 0, 0, 0, 0 },
/* U+c327 */ { 0, 0, 0, 0, 0 },
/* U+c328 */ { 0, 0, 0, 0, 0 },
/* U+c329 */ { 0, 0, 0, 0, 0 },
/* U+c32a */ { 0, 0, 0, 0, 0 },
/* U+c32b */ { 0, 0, 0, 0, 0 },
/* U+c32c */ { 0, 0, 0, 0, 0 },
/* U+c32d */ { 0, 0, 0, 0, 0 },
/* U+c32e */ { 0, 0, 0, 0, 0 },
/* U+c32f */ { 0, 0, 0, 0, 0 },
/* U+c330 */ { 0, 0, 0, 0, 0 },
/* U+c331 */ { 0, 0, 0, 0, 0 },
/* U+c332 */ { 0, 0, 0, 0, 0 },
/* U+c333 */ { 0, 0, 0, 0, 0 },
/* U+c334 */ { 0, 0, 0, 0, 0 },
/* U+c335 */ { 0, 0, 0, 0, 0 },
/* U+c336 */ { 0, 0, 0, 0, 0 },
/* U+c337 */ { 0, 0, 0, 0, 0 },
/* U+c338 */ { 0, 0, 0, 0, 0 },
/* U+c339 */ { 0, 0, 0, 0, 0 },
/* U+c33a */ { 0, 0, 0, 0, 0 },
/* U+c33b */ { 0, 0, 0, 0, 0 },
/* U+c33c */ { 0, 0, 0, 0, 0 },
/* U+c33d */ { 0, 0, 0, 0, 0 },
/* U+c33e */ { 0, 0, 0, 0, 0 },
/* U+c33f */ { 0, 0, 0, 0, 0 },
/* U+c340 */ { 0, 0, 0, 0, 0 },
/* U+c341 */ { 0, 0, 0, 0, 0 },
/* U+c342 */ { 0, 0, 0, 0, 0 },
/* U+c343 */ { 0, 0, 0, 0, 0 },
/* U+c344 */ { 0, 0, 0, 0, 0 },
/* U+c345 */ { 0, 0, 0, 0, 0 },
/* U+c346 */ { 0, 0, 0, 0, 0 },
/* U+c347 */ { 0, 0, 0, 0, 0 },
/* U+c348 */ { 0, 0, 0, 0, 0 },
/* U+c349 */ { 0, 0, 0, 0, 0 },
/* U+c34a */ { 0, 0, 0, 0, 0 },
/* U+c34b */ { 0, 0, 0, 0, 0 },
/* U+c34c */ { 0, 0, 0, 0, 0 },
/* U+c34d */ { 0, 0, 0, 0, 0 },
/* U+c34e */ { 0, 0, 0, 0, 0 },
/* U+c34f */ { 0, 0, 0, 0, 0 },
/* U+c350 */ { 0, 0, 0, 0, 0 },
/* U+c351 */ { 0, 0, 0, 0, 0 },
/* U+c352 */ { 0, 0, 0, 0, 0 },
/* U+c353 */ { 0, 0, 0, 0, 0 },
/* U+c354 */ { 0, 0, 0, 0, 0 },
/* U+c355 */ { 0, 0, 0, 0, 0 },
/* U+c356 */ { 0, 0, 0, 0, 0 },
/* U+c357 */ { 0, 0, 0, 0, 0 },
/* U+c358 */ { 0, 0, 0, 0, 0 },
/* U+c359 */ { 0, 0, 0, 0, 0 },
/* U+c35a */ { 0, 0, 0, 0, 0 },
/* U+c35b */ { 0, 0, 0, 0, 0 },
/* U+c35c */ { 0, 0, 0, 0, 0 },
/* U+c35d */ { 0, 0, 0, 0, 0 },
/* U+c35e */ { 0, 0, 0, 0, 0 },
/* U+c35f */ { 0, 0, 0, 0, 0 },
/* U+c360 */ { 0, 0, 0, 0, 0 },
/* U+c361 */ { 0, 0, 0, 0, 0 },
/* U+c362 */ { 0, 0, 0, 0, 0 },
/* U+c363 */ { 0, 0, 0, 0, 0 },
/* U+c364 */ { 0, 0, 0, 0, 0 },
/* U+c365 */ { 0, 0, 0, 0, 0 },
/* U+c366 */ { 0, 0, 0, 0, 0 },
/* U+c367 */ { 0, 0, 0, 0, 0 },
/* U+c368 */ { 0, 0, 0, 0, 0 },
/* U+c369 */ { 0, 0, 0, 0, 0 },
/* U+c36a */ { 0, 0, 0, 0, 0 },
/* U+c36b */ { 0, 0, 0, 0, 0 },
/* U+c36c */ { 0, 0, 0, 0, 0 },
/* U+c36d */ { 0, 0, 0, 0, 0 },
/* U+c36e */ { 0, 0, 0, 0, 0 },
/* U+c36f */ { 0, 0, 0, 0, 0 },
/* U+c370 */ { 0, 0, 0, 0, 0 },
/* U+c371 */ { 0, 0, 0, 0, 0 },
/* U+c372 */ { 0, 0, 0, 0, 0 },
/* U+c373 */ { 0, 0, 0, 0, 0 },
/* U+c374 */ { 0, 0, 0, 0, 0 },
/* U+c375 */ { 0, 0, 0, 0, 0 },
/* U+c376 */ { 0, 0, 0, 0, 0 },
/* U+c377 */ { 0, 0, 0, 0, 0 },
/* U+c378 */ { 0, 0, 0, 0, 0 },
/* U+c379 */ { 0, 0, 0, 0, 0 },
/* U+c37a */ { 0, 0, 0, 0, 0 },
/* U+c37b */ { 0, 0, 0, 0, 0 },
/* U+c37c */ { 0, 0, 0, 0, 0 },
/* U+c37d */ { 0, 0, 0, 0, 0 },
/* U+c37e */ { 0, 0, 0, 0, 0 },
/* U+c37f */ { 0, 0, 0, 0, 0 },
/* U+c380 */ { 0, 0, 0, 0, 0 },
/* U+c381 */ { 0, 0, 0, 0, 0 },
/* U+c382 */ { 0, 0, 0, 0, 0 },
/* U+c383 */ { 0, 0, 0, 0, 0 },
/* U+c384 */ { 0, 0, 0, 0, 0 },
/* U+c385 */ { 0, 0, 0, 0, 0 },
/* U+c386 */ { 0, 0, 0, 0, 0 },
/* U+c387 */ { 0, 0, 0, 0, 0 },
/* U+c388 */ { 0, 0, 0, 0, 0 },
/* U+c389 */ { 0, 0, 0, 0, 0 },
/* U+c38a */ { 0, 0, 0, 0, 0 },
/* U+c38b */ { 0, 0, 0, 0, 0 },
/* U+c38c */ { 0, 0, 0, 0, 0 },
/* U+c38d */ { 0, 0, 0, 0, 0 },
/* U+c38e */ { 0, 0, 0, 0, 0 },
/* U+c38f */ { 0, 0, 0, 0, 0 },
/* U+c390 */ { 0, 0, 0, 0, 0 },
/* U+c391 */ { 0, 0, 0, 0, 0 },
/* U+c392 */ { 0, 0, 0, 0, 0 },
/* U+c393 */ { 0, 0, 0, 0, 0 },
/* U+c394 */ { 0, 0, 0, 0, 0 },
/* U+c395 */ { 0, 0, 0, 0, 0 },
/* U+c396 */ { 0, 0, 0, 0, 0 },
/* U+c397 */ { 0, 0, 0, 0, 0 },
/* U+c398 */ { 0, 0, 0, 0, 0 },
/* U+c399 */ { 0, 0, 0, 0, 0 },
/* U+c39a */ { 0, 0, 0, 0, 0 },
/* U+c39b */ { 0, 0, 0, 0, 0 },
/* U+c39c */ { 0, 0, 0, 0, 0 },
/* U+c39d */ { 0, 0, 0, 0, 0 },
/* U+c39e */ { 0, 0, 0, 0, 0 },
/* U+c39f */ { 0, 0, 0, 0, 0 },
/* U+c3a0 */ { 0, 0, 0, 0, 0 },
/* U+c3a1 */ { 0, 0, 0, 0, 0 },
/* U+c3a2 */ { 0, 0, 0, 0, 0 },
/* U+c3a3 */ { 0, 0, 0, 0, 0 },
/* U+c3a4 */ { 0, 0, 0, 0, 0 },
/* U+c3a5 */ { 0, 0, 0, 0, 0 },
/* U+c3a6 */ { 0, 0, 0, 0, 0 },
/* U+c3a7 */ { 0, 0, 0, 0, 0 },
/* U+c3a8 */ { 0, 0, 0, 0, 0 },
/* U+c3a9 */ { 0, 0, 0, 0, 0 },
/* U+c3aa */ { 0, 0, 0, 0, 0 },
/* U+c3ab */ { 0, 0, 0, 0, 0 },
/* U+c3ac */ { 0, 0, 0, 0, 0 },
/* U+c3ad */ { 0, 0, 0, 0, 0 },
/* U+c3ae */ { 0, 0, 0, 0, 0 },
/* U+c3af */ { 0, 0, 0, 0, 0 },
/* U+c3b0 */ { 0, 0, 0, 0, 0 },
/* U+c3b1 */ { 0, 0, 0, 0, 0 },
/* U+c3b2 */ { 0, 0, 0, 0, 0 },
/* U+c3b3 */ { 0, 0, 0, 0, 0 },
/* U+c3b4 */ { 0, 0, 0, 0, 0 },
/* U+c3b5 */ { 0, 0, 0, 0, 0 },
/* U+c3b6 */ { 0, 0, 0, 0, 0 },
/* U+c3b7 */ { 0, 0, 0, 0, 0 },
/* U+c3b8 */ { 0, 0, 0, 0, 0 },
/* U+c3b9 */ { 0, 0, 0, 0, 0 },
/* U+c3ba */ { 0, 0, 0, 0, 0 },
/* U+c3bb */ { 0, 0, 0, 0, 0 },
/* U+c3bc */ { 0, 0, 0, 0, 0 },
/* U+c3bd */ { 0, 0, 0, 0, 0 },
/* U+c3be */ { 0, 0, 0, 0, 0 },
/* U+c3bf */ { 0, 0, 0, 0, 0 },
/* U+c3c0 */ { 0, 0, 0, 0, 0 },
/* U+c3c1 */ { 0, 0, 0, 0, 0 },
/* U+c3c2 */ { 0, 0, 0, 0, 0 },
/* U+c3c3 */ { 0, 0, 0, 0, 0 },
/* U+c3c4 */ { 0, 0, 0, 0, 0 },
/* U+c3c5 */ { 0, 0, 0, 0, 0 },
/* U+c3c6 */ { 0, 0, 0, 0, 0 },
/* U+c3c7 */ { 0, 0, 0, 0, 0 },
/* U+c3c8 */ { 0, 0, 0, 0, 0 },
/* U+c3c9 */ { 0, 0, 0, 0, 0 },
/* U+c3ca */ { 0, 0, 0, 0, 0 },
/* U+c3cb */ { 0, 0, 0, 0, 0 },
/* U+c3cc */ { 0, 0, 0, 0, 0 },
/* U+c3cd */ { 0, 0, 0, 0, 0 },
/* U+c3ce */ { 0, 0, 0, 0, 0 },
/* U+c3cf */ { 0, 0, 0, 0, 0 },
/* U+c3d0 */ { 0, 0, 0, 0, 0 },
/* U+c3d1 */ { 0, 0, 0, 0, 0 },
/* U+c3d2 */ { 0, 0, 0, 0, 0 },
/* U+c3d3 */ { 0, 0, 0, 0, 0 },
/* U+c3d4 */ { 0, 0, 0, 0, 0 },
/* U+c3d5 */ { 0, 0, 0, 0, 0 },
/* U+c3d6 */ { 0, 0, 0, 0, 0 },
/* U+c3d7 */ { 0, 0, 0, 0, 0 },
/* U+c3d8 */ { 0, 0, 0, 0, 0 },
/* U+c3d9 */ { 0, 0, 0, 0, 0 },
/* U+c3da */ { 0, 0, 0, 0, 0 },
/* U+c3db */ { 0, 0, 0, 0, 0 },
/* U+c3dc */ { 0, 0, 0, 0, 0 },
/* U+c3dd */ { 0, 0, 0, 0, 0 },
/* U+c3de */ { 0, 0, 0, 0, 0 },
/* U+c3df */ { 0, 0, 0, 0, 0 },
/* U+c3e0 */ { 0, 0, 0, 0, 0 },
/* U+c3e1 */ { 0, 0, 0, 0, 0 },
/* U+c3e2 */ { 0, 0, 0, 0, 0 },
/* U+c3e3 */ { 0, 0, 0, 0, 0 },
/* U+c3e4 */ { 0, 0, 0, 0, 0 },
/* U+c3e5 */ { 0, 0, 0, 0, 0 },
/* U+c3e6 */ { 0, 0, 0, 0, 0 },
/* U+c3e7 */ { 0, 0, 0, 0, 0 },
/* U+c3e8 */ { 0, 0, 0, 0, 0 },
/* U+c3e9 */ { 0, 0, 0, 0, 0 },
/* U+c3ea */ { 0, 0, 0, 0, 0 },
/* U+c3eb */ { 0, 0, 0, 0, 0 },
/* U+c3ec */ { 0, 0, 0, 0, 0 },
/* U+c3ed */ { 0, 0, 0, 0, 0 },
/* U+c3ee */ { 0, 0, 0, 0, 0 },
/* U+c3ef */ { 0, 0, 0, 0, 0 },
/* U+c3f0 */ { 0, 0, 0, 0, 0 },
/* U+c3f1 */ { 0, 0, 0, 0, 0 },
/* U+c3f2 */ { 0, 0, 0, 0, 0 },
/* U+c3f3 */ { 0, 0, 0, 0, 0 },
/* U+c3f4 */ { 0, 0, 0, 0, 0 },
/* U+c3f5 */ { 0, 0, 0, 0, 0 },
/* U+c3f6 */ { 0, 0, 0, 0, 0 },
/* U+c3f7 */ { 0, 0, 0, 0, 0 },
/* U+c3f8 */ { 0, 0, 0, 0, 0 },
/* U+c3f9 */ { 0, 0, 0, 0, 0 },
/* U+c3fa */ { 0, 0, 0, 0, 0 },
/* U+c3fb */ { 0, 0, 0, 0, 0 },
/* U+c3fc */ { 0, 0, 0, 0, 0 },
/* U+c3fd */ { 0, 0, 0, 0, 0 },
/* U+c3fe */ { 0, 0, 0, 0, 0 },
/* U+c3ff */ { 0, 0, 0, 0, 0 },
/* U+c400 */ { 0, 0, 0, 0, 0 },
/* U+c401 */ { 0, 0, 0, 0, 0 },
/* U+c402 */ { 0, 0, 0, 0, 0 },
/* U+c403 */ { 0, 0, 0, 0, 0 },
/* U+c404 */ { 0, 0, 0, 0, 0 },
/* U+c405 */ { 0, 0, 0, 0, 0 },
/* U+c406 */ { 0, 0, 0, 0, 0 },
/* U+c407 */ { 0, 0, 0, 0, 0 },
/* U+c408 */ { 0, 0, 0, 0, 0 },
/* U+c409 */ { 0, 0, 0, 0, 0 },
/* U+c40a */ { 0, 0, 0, 0, 0 },
/* U+c40b */ { 0, 0, 0, 0, 0 },
/* U+c40c */ { 0, 0, 0, 0, 0 },
/* U+c40d */ { 0, 0, 0, 0, 0 },
/* U+c40e */ { 0, 0, 0, 0, 0 },
/* U+c40f */ { 0, 0, 0, 0, 0 },
/* U+c410 */ { 0, 0, 0, 0, 0 },
/* U+c411 */ { 0, 0, 0, 0, 0 },
/* U+c412 */ { 0, 0, 0, 0, 0 },
/* U+c413 */ { 0, 0, 0, 0, 0 },
/* U+c414 */ { 0, 0, 0, 0, 0 },
/* U+c415 */ { 0, 0, 0, 0, 0 },
/* U+c416 */ { 0, 0, 0, 0, 0 },
/* U+c417 */ { 0, 0, 0, 0, 0 },
/* U+c418 */ { 0, 0, 0, 0, 0 },
/* U+c419 */ { 0, 0, 0, 0, 0 },
/* U+c41a */ { 0, 0, 0, 0, 0 },
/* U+c41b */ { 0, 0, 0, 0, 0 },
/* U+c41c */ { 0, 0, 0, 0, 0 },
/* U+c41d */ { 0, 0, 0, 0, 0 },
/* U+c41e */ { 0, 0, 0, 0, 0 },
/* U+c41f */ { 0, 0, 0, 0, 0 },
/* U+c420 */ { 0, 0, 0, 0, 0 },
/* U+c421 */ { 0, 0, 0, 0, 0 },
/* U+c422 */ { 0, 0, 0, 0, 0 },
/* U+c423 */ { 0, 0, 0, 0, 0 },
/* U+c424 */ { 0, 0, 0, 0, 0 },
/* U+c425 */ { 0, 0, 0, 0, 0 },
/* U+c426 */ { 0, 0, 0, 0, 0 },
/* U+c427 */ { 0, 0, 0, 0, 0 },
/* U+c428 */ { 0, 0, 0, 0, 0 },
/* U+c429 */ { 0, 0, 0, 0, 0 },
/* U+c42a */ { 0, 0, 0, 0, 0 },
/* U+c42b */ { 0, 0, 0, 0, 0 },
/* U+c42c */ { 0, 0, 0, 0, 0 },
/* U+c42d */ { 0, 0, 0, 0, 0 },
/* U+c42e */ { 0, 0, 0, 0, 0 },
/* U+c42f */ { 0, 0, 0, 0, 0 },
/* U+c430 */ { 0, 0, 0, 0, 0 },
/* U+c431 */ { 0, 0, 0, 0, 0 },
/* U+c432 */ { 0, 0, 0, 0, 0 },
/* U+c433 */ { 0, 0, 0, 0, 0 },
/* U+c434 */ { 0, 0, 0, 0, 0 },
/* U+c435 */ { 0, 0, 0, 0, 0 },
/* U+c436 */ { 0, 0, 0, 0, 0 },
/* U+c437 */ { 0, 0, 0, 0, 0 },
/* U+c438 */ { 0, 0, 0, 0, 0 },
/* U+c439 */ { 0, 0, 0, 0, 0 },
/* U+c43a */ { 0, 0, 0, 0, 0 },
/* U+c43b */ { 0, 0, 0, 0, 0 },
/* U+c43c */ { 0, 0, 0, 0, 0 },
/* U+c43d */ { 0, 0, 0, 0, 0 },
/* U+c43e */ { 0, 0, 0, 0, 0 },
/* U+c43f */ { 0, 0, 0, 0, 0 },
/* U+c440 */ { 0, 0, 0, 0, 0 },
/* U+c441 */ { 0, 0, 0, 0, 0 },
/* U+c442 */ { 0, 0, 0, 0, 0 },
/* U+c443 */ { 0, 0, 0, 0, 0 },
/* U+c444 */ { 0, 0, 0, 0, 0 },
/* U+c445 */ { 0, 0, 0, 0, 0 },
/* U+c446 */ { 0, 0, 0, 0, 0 },
/* U+c447 */ { 0, 0, 0, 0, 0 },
/* U+c448 */ { 0, 0, 0, 0, 0 },
/* U+c449 */ { 0, 0, 0, 0, 0 },
/* U+c44a */ { 0, 0, 0, 0, 0 },
/* U+c44b */ { 0, 0, 0, 0, 0 },
/* U+c44c */ { 0, 0, 0, 0, 0 },
/* U+c44d */ { 0, 0, 0, 0, 0 },
/* U+c44e */ { 0, 0, 0, 0, 0 },
/* U+c44f */ { 0, 0, 0, 0, 0 },
/* U+c450 */ { 0, 0, 0, 0, 0 },
/* U+c451 */ { 0, 0, 0, 0, 0 },
/* U+c452 */ { 0, 0, 0, 0, 0 },
/* U+c453 */ { 0, 0, 0, 0, 0 },
/* U+c454 */ { 0, 0, 0, 0, 0 },
/* U+c455 */ { 0, 0, 0, 0, 0 },
/* U+c456 */ { 0, 0, 0, 0, 0 },
/* U+c457 */ { 0, 0, 0, 0, 0 },
/* U+c458 */ { 0, 0, 0, 0, 0 },
/* U+c459 */ { 0, 0, 0, 0, 0 },
/* U+c45a */ { 0, 0, 0, 0, 0 },
/* U+c45b */ { 0, 0, 0, 0, 0 },
/* U+c45c */ { 0, 0, 0, 0, 0 },
/* U+c45d */ { 0, 0, 0, 0, 0 },
/* U+c45e */ { 0, 0, 0, 0, 0 },
/* U+c45f */ { 0, 0, 0, 0, 0 },
/* U+c460 */ { 0, 0, 0, 0, 0 },
/* U+c461 */ { 0, 0, 0, 0, 0 },
/* U+c462 */ { 0, 0, 0, 0, 0 },
/* U+c463 */ { 0, 0, 0, 0, 0 },
/* U+c464 */ { 0, 0, 0, 0, 0 },
/* U+c465 */ { 0, 0, 0, 0, 0 },
/* U+c466 */ { 0, 0, 0, 0, 0 },
/* U+c467 */ { 0, 0, 0, 0, 0 },
/* U+c468 */ { 0, 0, 0, 0, 0 },
/* U+c469 */ { 0, 0, 0, 0, 0 },
/* U+c46a */ { 0, 0, 0, 0, 0 },
/* U+c46b */ { 0, 0, 0, 0, 0 },
/* U+c46c */ { 0, 0, 0, 0, 0 },
/* U+c46d */ { 0, 0, 0, 0, 0 },
/* U+c46e */ { 0, 0, 0, 0, 0 },
/* U+c46f */ { 0, 0, 0, 0, 0 },
/* U+c470 */ { 0, 0, 0, 0, 0 },
/* U+c471 */ { 0, 0, 0, 0, 0 },
/* U+c472 */ { 0, 0, 0, 0, 0 },
/* U+c473 */ { 0, 0, 0, 0, 0 },
/* U+c474 */ { 0, 0, 0, 0, 0 },
/* U+c475 */ { 0, 0, 0, 0, 0 },
/* U+c476 */ { 0, 0, 0, 0, 0 },
/* U+c477 */ { 0, 0, 0, 0, 0 },
/* U+c478 */ { 0, 0, 0, 0, 0 },
/* U+c479 */ { 0, 0, 0, 0, 0 },
/* U+c47a */ { 0, 0, 0, 0, 0 },
/* U+c47b */ { 0, 0, 0, 0, 0 },
/* U+c47c */ { 0, 0, 0, 0, 0 },
/* U+c47d */ { 0, 0, 0, 0, 0 },
/* U+c47e */ { 0, 0, 0, 0, 0 },
/* U+c47f */ { 0, 0, 0, 0, 0 },
/* U+c480 */ { 0, 0, 0, 0, 0 },
/* U+c481 */ { 0, 0, 0, 0, 0 },
/* U+c482 */ { 0, 0, 0, 0, 0 },
/* U+c483 */ { 0, 0, 0, 0, 0 },
/* U+c484 */ { 0, 0, 0, 0, 0 },
/* U+c485 */ { 0, 0, 0, 0, 0 },
/* U+c486 */ { 0, 0, 0, 0, 0 },
/* U+c487 */ { 0, 0, 0, 0, 0 },
/* U+c488 */ { 0, 0, 0, 0, 0 },
/* U+c489 */ { 0, 0, 0, 0, 0 },
/* U+c48a */ { 0, 0, 0, 0, 0 },
/* U+c48b */ { 0, 0, 0, 0, 0 },
/* U+c48c */ { 0, 0, 0, 0, 0 },
/* U+c48d */ { 0, 0, 0, 0, 0 },
/* U+c48e */ { 0, 0, 0, 0, 0 },
/* U+c48f */ { 0, 0, 0, 0, 0 },
/* U+c490 */ { 0, 0, 0, 0, 0 },
/* U+c491 */ { 0, 0, 0, 0, 0 },
/* U+c492 */ { 0, 0, 0, 0, 0 },
/* U+c493 */ { 0, 0, 0, 0, 0 },
/* U+c494 */ { 0, 0, 0, 0, 0 },
/* U+c495 */ { 0, 0, 0, 0, 0 },
/* U+c496 */ { 0, 0, 0, 0, 0 },
/* U+c497 */ { 0, 0, 0, 0, 0 },
/* U+c498 */ { 0, 0, 0, 0, 0 },
/* U+c499 */ { 0, 0, 0, 0, 0 },
/* U+c49a */ { 0, 0, 0, 0, 0 },
/* U+c49b */ { 0, 0, 0, 0, 0 },
/* U+c49c */ { 0, 0, 0, 0, 0 },
/* U+c49d */ { 0, 0, 0, 0, 0 },
/* U+c49e */ { 0, 0, 0, 0, 0 },
/* U+c49f */ { 0, 0, 0, 0, 0 },
/* U+c4a0 */ { 0, 0, 0, 0, 0 },
/* U+c4a1 */ { 0, 0, 0, 0, 0 },
/* U+c4a2 */ { 0, 0, 0, 0, 0 },
/* U+c4a3 */ { 0, 0, 0, 0, 0 },
/* U+c4a4 */ { 0, 0, 0, 0, 0 },
/* U+c4a5 */ { 0, 0, 0, 0, 0 },
/* U+c4a6 */ { 0, 0, 0, 0, 0 },
/* U+c4a7 */ { 0, 0, 0, 0, 0 },
/* U+c4a8 */ { 0, 0, 0, 0, 0 },
/* U+c4a9 */ { 0, 0, 0, 0, 0 },
/* U+c4aa */ { 0, 0, 0, 0, 0 },
/* U+c4ab */ { 0, 0, 0, 0, 0 },
/* U+c4ac */ { 0, 0, 0, 0, 0 },
/* U+c4ad */ { 0, 0, 0, 0, 0 },
/* U+c4ae */ { 0, 0, 0, 0, 0 },
/* U+c4af */ { 0, 0, 0, 0, 0 },
/* U+c4b0 */ { 0, 0, 0, 0, 0 },
/* U+c4b1 */ { 0, 0, 0, 0, 0 },
/* U+c4b2 */ { 0, 0, 0, 0, 0 },
/* U+c4b3 */ { 0, 0, 0, 0, 0 },
/* U+c4b4 */ { 0, 0, 0, 0, 0 },
/* U+c4b5 */ { 0, 0, 0, 0, 0 },
/* U+c4b6 */ { 0, 0, 0, 0, 0 },
/* U+c4b7 */ { 0, 0, 0, 0, 0 },
/* U+c4b8 */ { 0, 0, 0, 0, 0 },
/* U+c4b9 */ { 0, 0, 0, 0, 0 },
/* U+c4ba */ { 0, 0, 0, 0, 0 },
/* U+c4bb */ { 0, 0, 0, 0, 0 },
/* U+c4bc */ { 0, 0, 0, 0, 0 },
/* U+c4bd */ { 0, 0, 0, 0, 0 },
/* U+c4be */ { 0, 0, 0, 0, 0 },
/* U+c4bf */ { 0, 0, 0, 0, 0 },
/* U+c4c0 */ { 0, 0, 0, 0, 0 },
/* U+c4c1 */ { 0, 0, 0, 0, 0 },
/* U+c4c2 */ { 0, 0, 0, 0, 0 },
/* U+c4c3 */ { 0, 0, 0, 0, 0 },
/* U+c4c4 */ { 0, 0, 0, 0, 0 },
/* U+c4c5 */ { 0, 0, 0, 0, 0 },
/* U+c4c6 */ { 0, 0, 0, 0, 0 },
/* U+c4c7 */ { 0, 0, 0, 0, 0 },
/* U+c4c8 */ { 0, 0, 0, 0, 0 },
/* U+c4c9 */ { 0, 0, 0, 0, 0 },
/* U+c4ca */ { 0, 0, 0, 0, 0 },
/* U+c4cb */ { 0, 0, 0, 0, 0 },
/* U+c4cc */ { 0, 0, 0, 0, 0 },
/* U+c4cd */ { 0, 0, 0, 0, 0 },
/* U+c4ce */ { 0, 0, 0, 0, 0 },
/* U+c4cf */ { 0, 0, 0, 0, 0 },
/* U+c4d0 */ { 0, 0, 0, 0, 0 },
/* U+c4d1 */ { 0, 0, 0, 0, 0 },
/* U+c4d2 */ { 0, 0, 0, 0, 0 },
/* U+c4d3 */ { 0, 0, 0, 0, 0 },
/* U+c4d4 */ { 0, 0, 0, 0, 0 },
/* U+c4d5 */ { 0, 0, 0, 0, 0 },
/* U+c4d6 */ { 0, 0, 0, 0, 0 },
/* U+c4d7 */ { 0, 0, 0, 0, 0 },
/* U+c4d8 */ { 0, 0, 0, 0, 0 },
/* U+c4d9 */ { 0, 0, 0, 0, 0 },
/* U+c4da */ { 0, 0, 0, 0, 0 },
/* U+c4db */ { 0, 0, 0, 0, 0 },
/* U+c4dc */ { 0, 0, 0, 0, 0 },
/* U+c4dd */ { 0, 0, 0, 0, 0 },
/* U+c4de */ { 0, 0, 0, 0, 0 },
/* U+c4df */ { 0, 0, 0, 0, 0 },
/* U+c4e0 */ { 0, 0, 0, 0, 0 },
/* U+c4e1 */ { 0, 0, 0, 0, 0 },
/* U+c4e2 */ { 0, 0, 0, 0, 0 },
/* U+c4e3 */ { 0, 0, 0, 0, 0 },
/* U+c4e4 */ { 0, 0, 0, 0, 0 },
/* U+c4e5 */ { 0, 0, 0, 0, 0 },
/* U+c4e6 */ { 0, 0, 0, 0, 0 },
/* U+c4e7 */ { 0, 0, 0, 0, 0 },
/* U+c4e8 */ { 0, 0, 0, 0, 0 },
/* U+c4e9 */ { 0, 0, 0, 0, 0 },
/* U+c4ea */ { 0, 0, 0, 0, 0 },
/* U+c4eb */ { 0, 0, 0, 0, 0 },
/* U+c4ec */ { 0, 0, 0, 0, 0 },
/* U+c4ed */ { 0, 0, 0, 0, 0 },
/* U+c4ee */ { 0, 0, 0, 0, 0 },
/* U+c4ef */ { 0, 0, 0, 0, 0 },
/* U+c4f0 */ { 0, 0, 0, 0, 0 },
/* U+c4f1 */ { 0, 0, 0, 0, 0 },
/* U+c4f2 */ { 0, 0, 0, 0, 0 },
/* U+c4f3 */ { 0, 0, 0, 0, 0 },
/* U+c4f4 */ { 0, 0, 0, 0, 0 },
/* U+c4f5 */ { 0, 0, 0, 0, 0 },
/* U+c4f6 */ { 0, 0, 0, 0, 0 },
/* U+c4f7 */ { 0, 0, 0, 0, 0 },
/* U+c4f8 */ { 0, 0, 0, 0, 0 },
/* U+c4f9 */ { 0, 0, 0, 0, 0 },
/* U+c4fa */ { 0, 0, 0, 0, 0 },
/* U+c4fb */ { 0, 0, 0, 0, 0 },
/* U+c4fc */ { 0, 0, 0, 0, 0 },
/* U+c4fd */ { 0, 0, 0, 0, 0 },
/* U+c4fe */ { 0, 0, 0, 0, 0 },
/* U+c4ff */ { 0, 0, 0, 0, 0 },
/* U+c500 */ { 0, 0, 0, 0, 0 },
/* U+c501 */ { 0, 0, 0, 0, 0 },
/* U+c502 */ { 0, 0, 0, 0, 0 },
/* U+c503 */ { 0, 0, 0, 0, 0 },
/* U+c504 */ { 0, 0, 0, 0, 0 },
/* U+c505 */ { 0, 0, 0, 0, 0 },
/* U+c506 */ { 0, 0, 0, 0, 0 },
/* U+c507 */ { 0, 0, 0, 0, 0 },
/* U+c508 */ { 0, 0, 0, 0, 0 },
/* U+c509 */ { 0, 0, 0, 0, 0 },
/* U+c50a */ { 0, 0, 0, 0, 0 },
/* U+c50b */ { 0, 0, 0, 0, 0 },
/* U+c50c */ { 0, 0, 0, 0, 0 },
/* U+c50d */ { 0, 0, 0, 0, 0 },
/* U+c50e */ { 0, 0, 0, 0, 0 },
/* U+c50f */ { 0, 0, 0, 0, 0 },
/* U+c510 */ { 0, 0, 0, 0, 0 },
/* U+c511 */ { 0, 0, 0, 0, 0 },
/* U+c512 */ { 0, 0, 0, 0, 0 },
/* U+c513 */ { 0, 0, 0, 0, 0 },
/* U+c514 */ { 0, 0, 0, 0, 0 },
/* U+c515 */ { 0, 0, 0, 0, 0 },
/* U+c516 */ { 0, 0, 0, 0, 0 },
/* U+c517 */ { 0, 0, 0, 0, 0 },
/* U+c518 */ { 0, 0, 0, 0, 0 },
/* U+c519 */ { 0, 0, 0, 0, 0 },
/* U+c51a */ { 0, 0, 0, 0, 0 },
/* U+c51b */ { 0, 0, 0, 0, 0 },
/* U+c51c */ { 0, 0, 0, 0, 0 },
/* U+c51d */ { 0, 0, 0, 0, 0 },
/* U+c51e */ { 0, 0, 0, 0, 0 },
/* U+c51f */ { 0, 0, 0, 0, 0 },
/* U+c520 */ { 0, 0, 0, 0, 0 },
/* U+c521 */ { 0, 0, 0, 0, 0 },
/* U+c522 */ { 0, 0, 0, 0, 0 },
/* U+c523 */ { 0, 0, 0, 0, 0 },
/* U+c524 */ { 0, 0, 0, 0, 0 },
/* U+c525 */ { 0, 0, 0, 0, 0 },
/* U+c526 */ { 0, 0, 0, 0, 0 },
/* U+c527 */ { 0, 0, 0, 0, 0 },
/* U+c528 */ { 0, 0, 0, 0, 0 },
/* U+c529 */ { 0, 0, 0, 0, 0 },
/* U+c52a */ { 0, 0, 0, 0, 0 },
/* U+c52b */ { 0, 0, 0, 0, 0 },
/* U+c52c */ { 0, 0, 0, 0, 0 },
/* U+c52d */ { 0, 0, 0, 0, 0 },
/* U+c52e */ { 0, 0, 0, 0, 0 },
/* U+c52f */ { 0, 0, 0, 0, 0 },
/* U+c530 */ { 0, 0, 0, 0, 0 },
/* U+c531 */ { 0, 0, 0, 0, 0 },
/* U+c532 */ { 0, 0, 0, 0, 0 },
/* U+c533 */ { 0, 0, 0, 0, 0 },
/* U+c534 */ { 0, 0, 0, 0, 0 },
/* U+c535 */ { 0, 0, 0, 0, 0 },
/* U+c536 */ { 0, 0, 0, 0, 0 },
/* U+c537 */ { 0, 0, 0, 0, 0 },
/* U+c538 */ { 0, 0, 0, 0, 0 },
/* U+c539 */ { 0, 0, 0, 0, 0 },
/* U+c53a */ { 0, 0, 0, 0, 0 },
/* U+c53b */ { 0, 0, 0, 0, 0 },
/* U+c53c */ { 0, 0, 0, 0, 0 },
/* U+c53d */ { 0, 0, 0, 0, 0 },
/* U+c53e */ { 0, 0, 0, 0, 0 },
/* U+c53f */ { 0, 0, 0, 0, 0 },
/* U+c540 */ { 0, 0, 0, 0, 0 },
/* U+c541 */ { 0, 0, 0, 0, 0 },
/* U+c542 */ { 0, 0, 0, 0, 0 },
/* U+c543 */ { 0, 0, 0, 0, 0 },
/* U+c544 */ { 0, 0, 0, 0, 0 },
/* U+c545 */ { 0, 0, 0, 0, 0 },
/* U+c546 */ { 0, 0, 0, 0, 0 },
/* U+c547 */ { 0, 0, 0, 0, 0 },
/* U+c548 */ { 0, 0, 0, 0, 0 },
/* U+c549 */ { 0, 0, 0, 0, 0 },
/* U+c54a */ { 0, 0, 0, 0, 0 },
/* U+c54b */ { 0, 0, 0, 0, 0 },
/* U+c54c */ { 0, 0, 0, 0, 0 },
/* U+c54d */ { 0, 0, 0, 0, 0 },
/* U+c54e */ { 0, 0, 0, 0, 0 },
/* U+c54f */ { 0, 0, 0, 0, 0 },
/* U+c550 */ { 0, 0, 0, 0, 0 },
/* U+c551 */ { 0, 0, 0, 0, 0 },
/* U+c552 */ { 0, 0, 0, 0, 0 },
/* U+c553 */ { 0, 0, 0, 0, 0 },
/* U+c554 */ { 0, 0, 0, 0, 0 },
/* U+c555 */ { 0, 0, 0, 0, 0 },
/* U+c556 */ { 0, 0, 0, 0, 0 },
/* U+c557 */ { 0, 0, 0, 0, 0 },
/* U+c558 */ { 0, 0, 0, 0, 0 },
/* U+c559 */ { 0, 0, 0, 0, 0 },
/* U+c55a */ { 0, 0, 0, 0, 0 },
/* U+c55b */ { 0, 0, 0, 0, 0 },
/* U+c55c */ { 0, 0, 0, 0, 0 },
/* U+c55d */ { 0, 0, 0, 0, 0 },
/* U+c55e */ { 0, 0, 0, 0, 0 },
/* U+c55f */ { 0, 0, 0, 0, 0 },
/* U+c560 */ { 0, 0, 0, 0, 0 },
/* U+c561 */ { 0, 0, 0, 0, 0 },
/* U+c562 */ { 0, 0, 0, 0, 0 },
/* U+c563 */ { 0, 0, 0, 0, 0 },
/* U+c564 */ { 0, 0, 0, 0, 0 },
/* U+c565 */ { 0, 0, 0, 0, 0 },
/* U+c566 */ { 0, 0, 0, 0, 0 },
/* U+c567 */ { 0, 0, 0, 0, 0 },
/* U+c568 */ { 0, 0, 0, 0, 0 },
/* U+c569 */ { 0, 0, 0, 0, 0 },
/* U+c56a */ { 0, 0, 0, 0, 0 },
/* U+c56b */ { 0, 0, 0, 0, 0 },
/* U+c56c */ { 0, 0, 0, 0, 0 },
/* U+c56d */ { 0, 0, 0, 0, 0 },
/* U+c56e */ { 0, 0, 0, 0, 0 },
/* U+c56f */ { 0, 0, 0, 0, 0 },
/* U+c570 */ { 0, 0, 0, 0, 0 },
/* U+c571 */ { 0, 0, 0, 0, 0 },
/* U+c572 */ { 0, 0, 0, 0, 0 },
/* U+c573 */ { 0, 0, 0, 0, 0 },
/* U+c574 */ { 0, 0, 0, 0, 0 },
/* U+c575 */ { 0, 0, 0, 0, 0 },
/* U+c576 */ { 0, 0, 0, 0, 0 },
/* U+c577 */ { 0, 0, 0, 0, 0 },
/* U+c578 */ { 0, 0, 0, 0, 0 },
/* U+c579 */ { 0, 0, 0, 0, 0 },
/* U+c57a */ { 0, 0, 0, 0, 0 },
/* U+c57b */ { 0, 0, 0, 0, 0 },
/* U+c57c */ { 0, 0, 0, 0, 0 },
/* U+c57d */ { 0, 0, 0, 0, 0 },
/* U+c57e */ { 0, 0, 0, 0, 0 },
/* U+c57f */ { 0, 0, 0, 0, 0 },
/* U+c580 */ { 0, 0, 0, 0, 0 },
/* U+c581 */ { 0, 0, 0, 0, 0 },
/* U+c582 */ { 0, 0, 0, 0, 0 },
/* U+c583 */ { 0, 0, 0, 0, 0 },
/* U+c584 */ { 0, 0, 0, 0, 0 },
/* U+c585 */ { 0, 0, 0, 0, 0 },
/* U+c586 */ { 0, 0, 0, 0, 0 },
/* U+c587 */ { 0, 0, 0, 0, 0 },
/* U+c588 */ { 0, 0, 0, 0, 0 },
/* U+c589 */ { 0, 0, 0, 0, 0 },
/* U+c58a */ { 0, 0, 0, 0, 0 },
/* U+c58b */ { 0, 0, 0, 0, 0 },
/* U+c58c */ { 0, 0, 0, 0, 0 },
/* U+c58d */ { 0, 0, 0, 0, 0 },
/* U+c58e */ { 0, 0, 0, 0, 0 },
/* U+c58f */ { 0, 0, 0, 0, 0 },
/* U+c590 */ { 0, 0, 0, 0, 0 },
/* U+c591 */ { 0, 0, 0, 0, 0 },
/* U+c592 */ { 0, 0, 0, 0, 0 },
/* U+c593 */ { 0, 0, 0, 0, 0 },
/* U+c594 */ { 0, 0, 0, 0, 0 },
/* U+c595 */ { 0, 0, 0, 0, 0 },
/* U+c596 */ { 0, 0, 0, 0, 0 },
/* U+c597 */ { 0, 0, 0, 0, 0 },
/* U+c598 */ { 0, 0, 0, 0, 0 },
/* U+c599 */ { 0, 0, 0, 0, 0 },
/* U+c59a */ { 0, 0, 0, 0, 0 },
/* U+c59b */ { 0, 0, 0, 0, 0 },
/* U+c59c */ { 0, 0, 0, 0, 0 },
/* U+c59d */ { 0, 0, 0, 0, 0 },
/* U+c59e */ { 0, 0, 0, 0, 0 },
/* U+c59f */ { 0, 0, 0, 0, 0 },
/* U+c5a0 */ { 0, 0, 0, 0, 0 },
/* U+c5a1 */ { 0, 0, 0, 0, 0 },
/* U+c5a2 */ { 0, 0, 0, 0, 0 },
/* U+c5a3 */ { 0, 0, 0, 0, 0 },
/* U+c5a4 */ { 0, 0, 0, 0, 0 },
/* U+c5a5 */ { 0, 0, 0, 0, 0 },
/* U+c5a6 */ { 0, 0, 0, 0, 0 },
/* U+c5a7 */ { 0, 0, 0, 0, 0 },
/* U+c5a8 */ { 0, 0, 0, 0, 0 },
/* U+c5a9 */ { 0, 0, 0, 0, 0 },
/* U+c5aa */ { 0, 0, 0, 0, 0 },
/* U+c5ab */ { 0, 0, 0, 0, 0 },
/* U+c5ac */ { 0, 0, 0, 0, 0 },
/* U+c5ad */ { 0, 0, 0, 0, 0 },
/* U+c5ae */ { 0, 0, 0, 0, 0 },
/* U+c5af */ { 0, 0, 0, 0, 0 },
/* U+c5b0 */ { 0, 0, 0, 0, 0 },
/* U+c5b1 */ { 0, 0, 0, 0, 0 },
/* U+c5b2 */ { 0, 0, 0, 0, 0 },
/* U+c5b3 */ { 0, 0, 0, 0, 0 },
/* U+c5b4 */ { 0, 0, 0, 0, 0 },
/* U+c5b5 */ { 0, 0, 0, 0, 0 },
/* U+c5b6 */ { 0, 0, 0, 0, 0 },
/* U+c5b7 */ { 0, 0, 0, 0, 0 },
/* U+c5b8 */ { 0, 0, 0, 0, 0 },
/* U+c5b9 */ { 0, 0, 0, 0, 0 },
/* U+c5ba */ { 0, 0, 0, 0, 0 },
/* U+c5bb */ { 0, 0, 0, 0, 0 },
/* U+c5bc */ { 0, 0, 0, 0, 0 },
/* U+c5bd */ { 0, 0, 0, 0, 0 },
/* U+c5be */ { 0, 0, 0, 0, 0 },
/* U+c5bf */ { 0, 0, 0, 0, 0 },
/* U+c5c0 */ { 0, 0, 0, 0, 0 },
/* U+c5c1 */ { 0, 0, 0, 0, 0 },
/* U+c5c2 */ { 0, 0, 0, 0, 0 },
/* U+c5c3 */ { 0, 0, 0, 0, 0 },
/* U+c5c4 */ { 0, 0, 0, 0, 0 },
/* U+c5c5 */ { 0, 0, 0, 0, 0 },
/* U+c5c6 */ { 0, 0, 0, 0, 0 },
/* U+c5c7 */ { 0, 0, 0, 0, 0 },
/* U+c5c8 */ { 0, 0, 0, 0, 0 },
/* U+c5c9 */ { 0, 0, 0, 0, 0 },
/* U+c5ca */ { 0, 0, 0, 0, 0 },
/* U+c5cb */ { 0, 0, 0, 0, 0 },
/* U+c5cc */ { 0, 0, 0, 0, 0 },
/* U+c5cd */ { 0, 0, 0, 0, 0 },
/* U+c5ce */ { 0, 0, 0, 0, 0 },
/* U+c5cf */ { 0, 0, 0, 0, 0 },
/* U+c5d0 */ { 0, 0, 0, 0, 0 },
/* U+c5d1 */ { 0, 0, 0, 0, 0 },
/* U+c5d2 */ { 0, 0, 0, 0, 0 },
/* U+c5d3 */ { 0, 0, 0, 0, 0 },
/* U+c5d4 */ { 0, 0, 0, 0, 0 },
/* U+c5d5 */ { 0, 0, 0, 0, 0 },
/* U+c5d6 */ { 0, 0, 0, 0, 0 },
/* U+c5d7 */ { 0, 0, 0, 0, 0 },
/* U+c5d8 */ { 0, 0, 0, 0, 0 },
/* U+c5d9 */ { 0, 0, 0, 0, 0 },
/* U+c5da */ { 0, 0, 0, 0, 0 },
/* U+c5db */ { 0, 0, 0, 0, 0 },
/* U+c5dc */ { 0, 0, 0, 0, 0 },
/* U+c5dd */ { 0, 0, 0, 0, 0 },
/* U+c5de */ { 0, 0, 0, 0, 0 },
/* U+c5df */ { 0, 0, 0, 0, 0 },
/* U+c5e0 */ { 0, 0, 0, 0, 0 },
/* U+c5e1 */ { 0, 0, 0, 0, 0 },
/* U+c5e2 */ { 0, 0, 0, 0, 0 },
/* U+c5e3 */ { 0, 0, 0, 0, 0 },
/* U+c5e4 */ { 0, 0, 0, 0, 0 },
/* U+c5e5 */ { 0, 0, 0, 0, 0 },
/* U+c5e6 */ { 0, 0, 0, 0, 0 },
/* U+c5e7 */ { 0, 0, 0, 0, 0 },
/* U+c5e8 */ { 0, 0, 0, 0, 0 },
/* U+c5e9 */ { 0, 0, 0, 0, 0 },
/* U+c5ea */ { 0, 0, 0, 0, 0 },
/* U+c5eb */ { 0, 0, 0, 0, 0 },
/* U+c5ec */ { 0, 0, 0, 0, 0 },
/* U+c5ed */ { 0, 0, 0, 0, 0 },
/* U+c5ee */ { 0, 0, 0, 0, 0 },
/* U+c5ef */ { 0, 0, 0, 0, 0 },
/* U+c5f0 */ { 0, 0, 0, 0, 0 },
/* U+c5f1 */ { 0, 0, 0, 0, 0 },
/* U+c5f2 */ { 0, 0, 0, 0, 0 },
/* U+c5f3 */ { 0, 0, 0, 0, 0 },
/* U+c5f4 */ { 0, 0, 0, 0, 0 },
/* U+c5f5 */ { 0, 0, 0, 0, 0 },
/* U+c5f6 */ { 0, 0, 0, 0, 0 },
/* U+c5f7 */ { 0, 0, 0, 0, 0 },
/* U+c5f8 */ { 0, 0, 0, 0, 0 },
/* U+c5f9 */ { 0, 0, 0, 0, 0 },
/* U+c5fa */ { 0, 0, 0, 0, 0 },
/* U+c5fb */ { 0, 0, 0, 0, 0 },
/* U+c5fc */ { 0, 0, 0, 0, 0 },
/* U+c5fd */ { 0, 0, 0, 0, 0 },
/* U+c5fe */ { 0, 0, 0, 0, 0 },
/* U+c5ff */ { 0, 0, 0, 0, 0 },
/* U+c600 */ { 0, 0, 0, 0, 0 },
/* U+c601 */ { 0, 0, 0, 0, 0 },
/* U+c602 */ { 0, 0, 0, 0, 0 },
/* U+c603 */ { 0, 0, 0, 0, 0 },
/* U+c604 */ { 0, 0, 0, 0, 0 },
/* U+c605 */ { 0, 0, 0, 0, 0 },
/* U+c606 */ { 0, 0, 0, 0, 0 },
/* U+c607 */ { 0, 0, 0, 0, 0 },
/* U+c608 */ { 0, 0, 0, 0, 0 },
/* U+c609 */ { 0, 0, 0, 0, 0 },
/* U+c60a */ { 0, 0, 0, 0, 0 },
/* U+c60b */ { 0, 0, 0, 0, 0 },
/* U+c60c */ { 0, 0, 0, 0, 0 },
/* U+c60d */ { 0, 0, 0, 0, 0 },
/* U+c60e */ { 0, 0, 0, 0, 0 },
/* U+c60f */ { 0, 0, 0, 0, 0 },
/* U+c610 */ { 0, 0, 0, 0, 0 },
/* U+c611 */ { 0, 0, 0, 0, 0 },
/* U+c612 */ { 0, 0, 0, 0, 0 },
/* U+c613 */ { 0, 0, 0, 0, 0 },
/* U+c614 */ { 0, 0, 0, 0, 0 },
/* U+c615 */ { 0, 0, 0, 0, 0 },
/* U+c616 */ { 0, 0, 0, 0, 0 },
/* U+c617 */ { 0, 0, 0, 0, 0 },
/* U+c618 */ { 0, 0, 0, 0, 0 },
/* U+c619 */ { 0, 0, 0, 0, 0 },
/* U+c61a */ { 0, 0, 0, 0, 0 },
/* U+c61b */ { 0, 0, 0, 0, 0 },
/* U+c61c */ { 0, 0, 0, 0, 0 },
/* U+c61d */ { 0, 0, 0, 0, 0 },
/* U+c61e */ { 0, 0, 0, 0, 0 },
/* U+c61f */ { 0, 0, 0, 0, 0 },
/* U+c620 */ { 0, 0, 0, 0, 0 },
/* U+c621 */ { 0, 0, 0, 0, 0 },
/* U+c622 */ { 0, 0, 0, 0, 0 },
/* U+c623 */ { 0, 0, 0, 0, 0 },
/* U+c624 */ { 0, 0, 0, 0, 0 },
/* U+c625 */ { 0, 0, 0, 0, 0 },
/* U+c626 */ { 0, 0, 0, 0, 0 },
/* U+c627 */ { 0, 0, 0, 0, 0 },
/* U+c628 */ { 0, 0, 0, 0, 0 },
/* U+c629 */ { 0, 0, 0, 0, 0 },
/* U+c62a */ { 0, 0, 0, 0, 0 },
/* U+c62b */ { 0, 0, 0, 0, 0 },
/* U+c62c */ { 0, 0, 0, 0, 0 },
/* U+c62d */ { 0, 0, 0, 0, 0 },
/* U+c62e */ { 0, 0, 0, 0, 0 },
/* U+c62f */ { 0, 0, 0, 0, 0 },
/* U+c630 */ { 0, 0, 0, 0, 0 },
/* U+c631 */ { 0, 0, 0, 0, 0 },
/* U+c632 */ { 0, 0, 0, 0, 0 },
/* U+c633 */ { 0, 0, 0, 0, 0 },
/* U+c634 */ { 0, 0, 0, 0, 0 },
/* U+c635 */ { 0, 0, 0, 0, 0 },
/* U+c636 */ { 0, 0, 0, 0, 0 },
/* U+c637 */ { 0, 0, 0, 0, 0 },
/* U+c638 */ { 0, 0, 0, 0, 0 },
/* U+c639 */ { 0, 0, 0, 0, 0 },
/* U+c63a */ { 0, 0, 0, 0, 0 },
/* U+c63b */ { 0, 0, 0, 0, 0 },
/* U+c63c */ { 0, 0, 0, 0, 0 },
/* U+c63d */ { 0, 0, 0, 0, 0 },
/* U+c63e */ { 0, 0, 0, 0, 0 },
/* U+c63f */ { 0, 0, 0, 0, 0 },
/* U+c640 */ { 0, 0, 0, 0, 0 },
/* U+c641 */ { 0, 0, 0, 0, 0 },
/* U+c642 */ { 0, 0, 0, 0, 0 },
/* U+c643 */ { 0, 0, 0, 0, 0 },
/* U+c644 */ { 0, 0, 0, 0, 0 },
/* U+c645 */ { 0, 0, 0, 0, 0 },
/* U+c646 */ { 0, 0, 0, 0, 0 },
/* U+c647 */ { 0, 0, 0, 0, 0 },
/* U+c648 */ { 0, 0, 0, 0, 0 },
/* U+c649 */ { 0, 0, 0, 0, 0 },
/* U+c64a */ { 0, 0, 0, 0, 0 },
/* U+c64b */ { 0, 0, 0, 0, 0 },
/* U+c64c */ { 0, 0, 0, 0, 0 },
/* U+c64d */ { 0, 0, 0, 0, 0 },
/* U+c64e */ { 0, 0, 0, 0, 0 },
/* U+c64f */ { 0, 0, 0, 0, 0 },
/* U+c650 */ { 0, 0, 0, 0, 0 },
/* U+c651 */ { 0, 0, 0, 0, 0 },
/* U+c652 */ { 0, 0, 0, 0, 0 },
/* U+c653 */ { 0, 0, 0, 0, 0 },
/* U+c654 */ { 0, 0, 0, 0, 0 },
/* U+c655 */ { 0, 0, 0, 0, 0 },
/* U+c656 */ { 0, 0, 0, 0, 0 },
/* U+c657 */ { 0, 0, 0, 0, 0 },
/* U+c658 */ { 0, 0, 0, 0, 0 },
/* U+c659 */ { 0, 0, 0, 0, 0 },
/* U+c65a */ { 0, 0, 0, 0, 0 },
/* U+c65b */ { 0, 0, 0, 0, 0 },
/* U+c65c */ { 0, 0, 0, 0, 0 },
/* U+c65d */ { 0, 0, 0, 0, 0 },
/* U+c65e */ { 0, 0, 0, 0, 0 },
/* U+c65f */ { 0, 0, 0, 0, 0 },
/* U+c660 */ { 0, 0, 0, 0, 0 },
/* U+c661 */ { 0, 0, 0, 0, 0 },
/* U+c662 */ { 0, 0, 0, 0, 0 },
/* U+c663 */ { 0, 0, 0, 0, 0 },
/* U+c664 */ { 0, 0, 0, 0, 0 },
/* U+c665 */ { 0, 0, 0, 0, 0 },
/* U+c666 */ { 0, 0, 0, 0, 0 },
/* U+c667 */ { 0, 0, 0, 0, 0 },
/* U+c668 */ { 0, 0, 0, 0, 0 },
/* U+c669 */ { 0, 0, 0, 0, 0 },
/* U+c66a */ { 0, 0, 0, 0, 0 },
/* U+c66b */ { 0, 0, 0, 0, 0 },
/* U+c66c */ { 0, 0, 0, 0, 0 },
/* U+c66d */ { 0, 0, 0, 0, 0 },
/* U+c66e */ { 0, 0, 0, 0, 0 },
/* U+c66f */ { 0, 0, 0, 0, 0 },
/* U+c670 */ { 0, 0, 0, 0, 0 },
/* U+c671 */ { 0, 0, 0, 0, 0 },
/* U+c672 */ { 0, 0, 0, 0, 0 },
/* U+c673 */ { 0, 0, 0, 0, 0 },
/* U+c674 */ { 0, 0, 0, 0, 0 },
/* U+c675 */ { 0, 0, 0, 0, 0 },
/* U+c676 */ { 0, 0, 0, 0, 0 },
/* U+c677 */ { 0, 0, 0, 0, 0 },
/* U+c678 */ { 0, 0, 0, 0, 0 },
/* U+c679 */ { 0, 0, 0, 0, 0 },
/* U+c67a */ { 0, 0, 0, 0, 0 },
/* U+c67b */ { 0, 0, 0, 0, 0 },
/* U+c67c */ { 0, 0, 0, 0, 0 },
/* U+c67d */ { 0, 0, 0, 0, 0 },
/* U+c67e */ { 0, 0, 0, 0, 0 },
/* U+c67f */ { 0, 0, 0, 0, 0 },
/* U+c680 */ { 0, 0, 0, 0, 0 },
/* U+c681 */ { 0, 0, 0, 0, 0 },
/* U+c682 */ { 0, 0, 0, 0, 0 },
/* U+c683 */ { 0, 0, 0, 0, 0 },
/* U+c684 */ { 0, 0, 0, 0, 0 },
/* U+c685 */ { 0, 0, 0, 0, 0 },
/* U+c686 */ { 0, 0, 0, 0, 0 },
/* U+c687 */ { 0, 0, 0, 0, 0 },
/* U+c688 */ { 0, 0, 0, 0, 0 },
/* U+c689 */ { 0, 0, 0, 0, 0 },
/* U+c68a */ { 0, 0, 0, 0, 0 },
/* U+c68b */ { 0, 0, 0, 0, 0 },
/* U+c68c */ { 0, 0, 0, 0, 0 },
/* U+c68d */ { 0, 0, 0, 0, 0 },
/* U+c68e */ { 0, 0, 0, 0, 0 },
/* U+c68f */ { 0, 0, 0, 0, 0 },
/* U+c690 */ { 0, 0, 0, 0, 0 },
/* U+c691 */ { 0, 0, 0, 0, 0 },
/* U+c692 */ { 0, 0, 0, 0, 0 },
/* U+c693 */ { 0, 0, 0, 0, 0 },
/* U+c694 */ { 0, 0, 0, 0, 0 },
/* U+c695 */ { 0, 0, 0, 0, 0 },
/* U+c696 */ { 0, 0, 0, 0, 0 },
/* U+c697 */ { 0, 0, 0, 0, 0 },
/* U+c698 */ { 0, 0, 0, 0, 0 },
/* U+c699 */ { 0, 0, 0, 0, 0 },
/* U+c69a */ { 0, 0, 0, 0, 0 },
/* U+c69b */ { 0, 0, 0, 0, 0 },
/* U+c69c */ { 0, 0, 0, 0, 0 },
/* U+c69d */ { 0, 0, 0, 0, 0 },
/* U+c69e */ { 0, 0, 0, 0, 0 },
/* U+c69f */ { 0, 0, 0, 0, 0 },
/* U+c6a0 */ { 0, 0, 0, 0, 0 },
/* U+c6a1 */ { 0, 0, 0, 0, 0 },
/* U+c6a2 */ { 0, 0, 0, 0, 0 },
/* U+c6a3 */ { 0, 0, 0, 0, 0 },
/* U+c6a4 */ { 0, 0, 0, 0, 0 },
/* U+c6a5 */ { 0, 0, 0, 0, 0 },
/* U+c6a6 */ { 0, 0, 0, 0, 0 },
/* U+c6a7 */ { 0, 0, 0, 0, 0 },
/* U+c6a8 */ { 0, 0, 0, 0, 0 },
/* U+c6a9 */ { 0, 0, 0, 0, 0 },
/* U+c6aa */ { 0, 0, 0, 0, 0 },
/* U+c6ab */ { 0, 0, 0, 0, 0 },
/* U+c6ac */ { 0, 0, 0, 0, 0 },
/* U+c6ad */ { 0, 0, 0, 0, 0 },
/* U+c6ae */ { 0, 0, 0, 0, 0 },
/* U+c6af */ { 0, 0, 0, 0, 0 },
/* U+c6b0 */ { 0, 0, 0, 0, 0 },
/* U+c6b1 */ { 0, 0, 0, 0, 0 },
/* U+c6b2 */ { 0, 0, 0, 0, 0 },
/* U+c6b3 */ { 0, 0, 0, 0, 0 },
/* U+c6b4 */ { 0, 0, 0, 0, 0 },
/* U+c6b5 */ { 0, 0, 0, 0, 0 },
/* U+c6b6 */ { 0, 0, 0, 0, 0 },
/* U+c6b7 */ { 0, 0, 0, 0, 0 },
/* U+c6b8 */ { 0, 0, 0, 0, 0 },
/* U+c6b9 */ { 0, 0, 0, 0, 0 },
/* U+c6ba */ { 0, 0, 0, 0, 0 },
/* U+c6bb */ { 0, 0, 0, 0, 0 },
/* U+c6bc */ { 0, 0, 0, 0, 0 },
/* U+c6bd */ { 0, 0, 0, 0, 0 },
/* U+c6be */ { 0, 0, 0, 0, 0 },
/* U+c6bf */ { 0, 0, 0, 0, 0 },
/* U+c6c0 */ { 0, 0, 0, 0, 0 },
/* U+c6c1 */ { 0, 0, 0, 0, 0 },
/* U+c6c2 */ { 0, 0, 0, 0, 0 },
/* U+c6c3 */ { 0, 0, 0, 0, 0 },
/* U+c6c4 */ { 0, 0, 0, 0, 0 },
/* U+c6c5 */ { 0, 0, 0, 0, 0 },
/* U+c6c6 */ { 0, 0, 0, 0, 0 },
/* U+c6c7 */ { 0, 0, 0, 0, 0 },
/* U+c6c8 */ { 0, 0, 0, 0, 0 },
/* U+c6c9 */ { 0, 0, 0, 0, 0 },
/* U+c6ca */ { 0, 0, 0, 0, 0 },
/* U+c6cb */ { 0, 0, 0, 0, 0 },
/* U+c6cc */ { 0, 0, 0, 0, 0 },
/* U+c6cd */ { 0, 0, 0, 0, 0 },
/* U+c6ce */ { 0, 0, 0, 0, 0 },
/* U+c6cf */ { 0, 0, 0, 0, 0 },
/* U+c6d0 */ { 0, 0, 0, 0, 0 },
/* U+c6d1 */ { 0, 0, 0, 0, 0 },
/* U+c6d2 */ { 0, 0, 0, 0, 0 },
/* U+c6d3 */ { 0, 0, 0, 0, 0 },
/* U+c6d4 */ { 0, 0, 0, 0, 0 },
/* U+c6d5 */ { 0, 0, 0, 0, 0 },
/* U+c6d6 */ { 0, 0, 0, 0, 0 },
/* U+c6d7 */ { 0, 0, 0, 0, 0 },
/* U+c6d8 */ { 0, 0, 0, 0, 0 },
/* U+c6d9 */ { 0, 0, 0, 0, 0 },
/* U+c6da */ { 0, 0, 0, 0, 0 },
/* U+c6db */ { 0, 0, 0, 0, 0 },
/* U+c6dc */ { 0, 0, 0, 0, 0 },
/* U+c6dd */ { 0, 0, 0, 0, 0 },
/* U+c6de */ { 0, 0, 0, 0, 0 },
/* U+c6df */ { 0, 0, 0, 0, 0 },
/* U+c6e0 */ { 0, 0, 0, 0, 0 },
/* U+c6e1 */ { 0, 0, 0, 0, 0 },
/* U+c6e2 */ { 0, 0, 0, 0, 0 },
/* U+c6e3 */ { 0, 0, 0, 0, 0 },
/* U+c6e4 */ { 0, 0, 0, 0, 0 },
/* U+c6e5 */ { 0, 0, 0, 0, 0 },
/* U+c6e6 */ { 0, 0, 0, 0, 0 },
/* U+c6e7 */ { 0, 0, 0, 0, 0 },
/* U+c6e8 */ { 0, 0, 0, 0, 0 },
/* U+c6e9 */ { 0, 0, 0, 0, 0 },
/* U+c6ea */ { 0, 0, 0, 0, 0 },
/* U+c6eb */ { 0, 0, 0, 0, 0 },
/* U+c6ec */ { 0, 0, 0, 0, 0 },
/* U+c6ed */ { 0, 0, 0, 0, 0 },
/* U+c6ee */ { 0, 0, 0, 0, 0 },
/* U+c6ef */ { 0, 0, 0, 0, 0 },
/* U+c6f0 */ { 0, 0, 0, 0, 0 },
/* U+c6f1 */ { 0, 0, 0, 0, 0 },
/* U+c6f2 */ { 0, 0, 0, 0, 0 },
/* U+c6f3 */ { 0, 0, 0, 0, 0 },
/* U+c6f4 */ { 0, 0, 0, 0, 0 },
/* U+c6f5 */ { 0, 0, 0, 0, 0 },
/* U+c6f6 */ { 0, 0, 0, 0, 0 },
/* U+c6f7 */ { 0, 0, 0, 0, 0 },
/* U+c6f8 */ { 0, 0, 0, 0, 0 },
/* U+c6f9 */ { 0, 0, 0, 0, 0 },
/* U+c6fa */ { 0, 0, 0, 0, 0 },
/* U+c6fb */ { 0, 0, 0, 0, 0 },
/* U+c6fc */ { 0, 0, 0, 0, 0 },
/* U+c6fd */ { 0, 0, 0, 0, 0 },
/* U+c6fe */ { 0, 0, 0, 0, 0 },
/* U+c6ff */ { 0, 0, 0, 0, 0 },
/* U+c700 */ { 0, 0, 0, 0, 0 },
/* U+c701 */ { 0, 0, 0, 0, 0 },
/* U+c702 */ { 0, 0, 0, 0, 0 },
/* U+c703 */ { 0, 0, 0, 0, 0 },
/* U+c704 */ { 0, 0, 0, 0, 0 },
/* U+c705 */ { 0, 0, 0, 0, 0 },
/* U+c706 */ { 0, 0, 0, 0, 0 },
/* U+c707 */ { 0, 0, 0, 0, 0 },
/* U+c708 */ { 0, 0, 0, 0, 0 },
/* U+c709 */ { 0, 0, 0, 0, 0 },
/* U+c70a */ { 0, 0, 0, 0, 0 },
/* U+c70b */ { 0, 0, 0, 0, 0 },
/* U+c70c */ { 0, 0, 0, 0, 0 },
/* U+c70d */ { 0, 0, 0, 0, 0 },
/* U+c70e */ { 0, 0, 0, 0, 0 },
/* U+c70f */ { 0, 0, 0, 0, 0 },
/* U+c710 */ { 0, 0, 0, 0, 0 },
/* U+c711 */ { 0, 0, 0, 0, 0 },
/* U+c712 */ { 0, 0, 0, 0, 0 },
/* U+c713 */ { 0, 0, 0, 0, 0 },
/* U+c714 */ { 0, 0, 0, 0, 0 },
/* U+c715 */ { 0, 0, 0, 0, 0 },
/* U+c716 */ { 0, 0, 0, 0, 0 },
/* U+c717 */ { 0, 0, 0, 0, 0 },
/* U+c718 */ { 0, 0, 0, 0, 0 },
/* U+c719 */ { 0, 0, 0, 0, 0 },
/* U+c71a */ { 0, 0, 0, 0, 0 },
/* U+c71b */ { 0, 0, 0, 0, 0 },
/* U+c71c */ { 0, 0, 0, 0, 0 },
/* U+c71d */ { 0, 0, 0, 0, 0 },
/* U+c71e */ { 0, 0, 0, 0, 0 },
/* U+c71f */ { 0, 0, 0, 0, 0 },
/* U+c720 */ { 0, 0, 0, 0, 0 },
/* U+c721 */ { 0, 0, 0, 0, 0 },
/* U+c722 */ { 0, 0, 0, 0, 0 },
/* U+c723 */ { 0, 0, 0, 0, 0 },
/* U+c724 */ { 0, 0, 0, 0, 0 },
/* U+c725 */ { 0, 0, 0, 0, 0 },
/* U+c726 */ { 0, 0, 0, 0, 0 },
/* U+c727 */ { 0, 0, 0, 0, 0 },
/* U+c728 */ { 0, 0, 0, 0, 0 },
/* U+c729 */ { 0, 0, 0, 0, 0 },
/* U+c72a */ { 0, 0, 0, 0, 0 },
/* U+c72b */ { 0, 0, 0, 0, 0 },
/* U+c72c */ { 0, 0, 0, 0, 0 },
/* U+c72d */ { 0, 0, 0, 0, 0 },
/* U+c72e */ { 0, 0, 0, 0, 0 },
/* U+c72f */ { 0, 0, 0, 0, 0 },
/* U+c730 */ { 0, 0, 0, 0, 0 },
/* U+c731 */ { 0, 0, 0, 0, 0 },
/* U+c732 */ { 0, 0, 0, 0, 0 },
/* U+c733 */ { 0, 0, 0, 0, 0 },
/* U+c734 */ { 0, 0, 0, 0, 0 },
/* U+c735 */ { 0, 0, 0, 0, 0 },
/* U+c736 */ { 0, 0, 0, 0, 0 },
/* U+c737 */ { 0, 0, 0, 0, 0 },
/* U+c738 */ { 0, 0, 0, 0, 0 },
/* U+c739 */ { 0, 0, 0, 0, 0 },
/* U+c73a */ { 0, 0, 0, 0, 0 },
/* U+c73b */ { 0, 0, 0, 0, 0 },
/* U+c73c */ { 0, 0, 0, 0, 0 },
/* U+c73d */ { 0, 0, 0, 0, 0 },
/* U+c73e */ { 0, 0, 0, 0, 0 },
/* U+c73f */ { 0, 0, 0, 0, 0 },
/* U+c740 */ { 0, 0, 0, 0, 0 },
/* U+c741 */ { 0, 0, 0, 0, 0 },
/* U+c742 */ { 0, 0, 0, 0, 0 },
/* U+c743 */ { 0, 0, 0, 0, 0 },
/* U+c744 */ { 0, 0, 0, 0, 0 },
/* U+c745 */ { 0, 0, 0, 0, 0 },
/* U+c746 */ { 0, 0, 0, 0, 0 },
/* U+c747 */ { 0, 0, 0, 0, 0 },
/* U+c748 */ { 0, 0, 0, 0, 0 },
/* U+c749 */ { 0, 0, 0, 0, 0 },
/* U+c74a */ { 0, 0, 0, 0, 0 },
/* U+c74b */ { 0, 0, 0, 0, 0 },
/* U+c74c */ { 0, 0, 0, 0, 0 },
/* U+c74d */ { 0, 0, 0, 0, 0 },
/* U+c74e */ { 0, 0, 0, 0, 0 },
/* U+c74f */ { 0, 0, 0, 0, 0 },
/* U+c750 */ { 0, 0, 0, 0, 0 },
/* U+c751 */ { 0, 0, 0, 0, 0 },
/* U+c752 */ { 0, 0, 0, 0, 0 },
/* U+c753 */ { 0, 0, 0, 0, 0 },
/* U+c754 */ { 0, 0, 0, 0, 0 },
/* U+c755 */ { 0, 0, 0, 0, 0 },
/* U+c756 */ { 0, 0, 0, 0, 0 },
/* U+c757 */ { 0, 0, 0, 0, 0 },
/* U+c758 */ { 0, 0, 0, 0, 0 },
/* U+c759 */ { 0, 0, 0, 0, 0 },
/* U+c75a */ { 0, 0, 0, 0, 0 },
/* U+c75b */ { 0, 0, 0, 0, 0 },
/* U+c75c */ { 0, 0, 0, 0, 0 },
/* U+c75d */ { 0, 0, 0, 0, 0 },
/* U+c75e */ { 0, 0, 0, 0, 0 },
/* U+c75f */ { 0, 0, 0, 0, 0 },
/* U+c760 */ { 0, 0, 0, 0, 0 },
/* U+c761 */ { 0, 0, 0, 0, 0 },
/* U+c762 */ { 0, 0, 0, 0, 0 },
/* U+c763 */ { 0, 0, 0, 0, 0 },
/* U+c764 */ { 0, 0, 0, 0, 0 },
/* U+c765 */ { 0, 0, 0, 0, 0 },
/* U+c766 */ { 0, 0, 0, 0, 0 },
/* U+c767 */ { 0, 0, 0, 0, 0 },
/* U+c768 */ { 0, 0, 0, 0, 0 },
/* U+c769 */ { 0, 0, 0, 0, 0 },
/* U+c76a */ { 0, 0, 0, 0, 0 },
/* U+c76b */ { 0, 0, 0, 0, 0 },
/* U+c76c */ { 0, 0, 0, 0, 0 },
/* U+c76d */ { 0, 0, 0, 0, 0 },
/* U+c76e */ { 0, 0, 0, 0, 0 },
/* U+c76f */ { 0, 0, 0, 0, 0 },
/* U+c770 */ { 0, 0, 0, 0, 0 },
/* U+c771 */ { 0, 0, 0, 0, 0 },
/* U+c772 */ { 0, 0, 0, 0, 0 },
/* U+c773 */ { 0, 0, 0, 0, 0 },
/* U+c774 */ { 0, 0, 0, 0, 0 },
/* U+c775 */ { 0, 0, 0, 0, 0 },
/* U+c776 */ { 0, 0, 0, 0, 0 },
/* U+c777 */ { 0, 0, 0, 0, 0 },
/* U+c778 */ { 0, 0, 0, 0, 0 },
/* U+c779 */ { 0, 0, 0, 0, 0 },
/* U+c77a */ { 0, 0, 0, 0, 0 },
/* U+c77b */ { 0, 0, 0, 0, 0 },
/* U+c77c */ { 0, 0, 0, 0, 0 },
/* U+c77d */ { 0, 0, 0, 0, 0 },
/* U+c77e */ { 0, 0, 0, 0, 0 },
/* U+c77f */ { 0, 0, 0, 0, 0 },
/* U+c780 */ { 0, 0, 0, 0, 0 },
/* U+c781 */ { 0, 0, 0, 0, 0 },
/* U+c782 */ { 0, 0, 0, 0, 0 },
/* U+c783 */ { 0, 0, 0, 0, 0 },
/* U+c784 */ { 0, 0, 0, 0, 0 },
/* U+c785 */ { 0, 0, 0, 0, 0 },
/* U+c786 */ { 0, 0, 0, 0, 0 },
/* U+c787 */ { 0, 0, 0, 0, 0 },
/* U+c788 */ { 0, 0, 0, 0, 0 },
/* U+c789 */ { 0, 0, 0, 0, 0 },
/* U+c78a */ { 0, 0, 0, 0, 0 },
/* U+c78b */ { 0, 0, 0, 0, 0 },
/* U+c78c */ { 0, 0, 0, 0, 0 },
/* U+c78d */ { 0, 0, 0, 0, 0 },
/* U+c78e */ { 0, 0, 0, 0, 0 },
/* U+c78f */ { 0, 0, 0, 0, 0 },
/* U+c790 */ { 0, 0, 0, 0, 0 },
/* U+c791 */ { 0, 0, 0, 0, 0 },
/* U+c792 */ { 0, 0, 0, 0, 0 },
/* U+c793 */ { 0, 0, 0, 0, 0 },
/* U+c794 */ { 0, 0, 0, 0, 0 },
/* U+c795 */ { 0, 0, 0, 0, 0 },
/* U+c796 */ { 0, 0, 0, 0, 0 },
/* U+c797 */ { 0, 0, 0, 0, 0 },
/* U+c798 */ { 0, 0, 0, 0, 0 },
/* U+c799 */ { 0, 0, 0, 0, 0 },
/* U+c79a */ { 0, 0, 0, 0, 0 },
/* U+c79b */ { 0, 0, 0, 0, 0 },
/* U+c79c */ { 0, 0, 0, 0, 0 },
/* U+c79d */ { 0, 0, 0, 0, 0 },
/* U+c79e */ { 0, 0, 0, 0, 0 },
/* U+c79f */ { 0, 0, 0, 0, 0 },
/* U+c7a0 */ { 0, 0, 0, 0, 0 },
/* U+c7a1 */ { 0, 0, 0, 0, 0 },
/* U+c7a2 */ { 0, 0, 0, 0, 0 },
/* U+c7a3 */ { 0, 0, 0, 0, 0 },
/* U+c7a4 */ { 0, 0, 0, 0, 0 },
/* U+c7a5 */ { 0, 0, 0, 0, 0 },
/* U+c7a6 */ { 0, 0, 0, 0, 0 },
/* U+c7a7 */ { 0, 0, 0, 0, 0 },
/* U+c7a8 */ { 0, 0, 0, 0, 0 },
/* U+c7a9 */ { 0, 0, 0, 0, 0 },
/* U+c7aa */ { 0, 0, 0, 0, 0 },
/* U+c7ab */ { 0, 0, 0, 0, 0 },
/* U+c7ac */ { 0, 0, 0, 0, 0 },
/* U+c7ad */ { 0, 0, 0, 0, 0 },
/* U+c7ae */ { 0, 0, 0, 0, 0 },
/* U+c7af */ { 0, 0, 0, 0, 0 },
/* U+c7b0 */ { 0, 0, 0, 0, 0 },
/* U+c7b1 */ { 0, 0, 0, 0, 0 },
/* U+c7b2 */ { 0, 0, 0, 0, 0 },
/* U+c7b3 */ { 0, 0, 0, 0, 0 },
/* U+c7b4 */ { 0, 0, 0, 0, 0 },
/* U+c7b5 */ { 0, 0, 0, 0, 0 },
/* U+c7b6 */ { 0, 0, 0, 0, 0 },
/* U+c7b7 */ { 0, 0, 0, 0, 0 },
/* U+c7b8 */ { 0, 0, 0, 0, 0 },
/* U+c7b9 */ { 0, 0, 0, 0, 0 },
/* U+c7ba */ { 0, 0, 0, 0, 0 },
/* U+c7bb */ { 0, 0, 0, 0, 0 },
/* U+c7bc */ { 0, 0, 0, 0, 0 },
/* U+c7bd */ { 0, 0, 0, 0, 0 },
/* U+c7be */ { 0, 0, 0, 0, 0 },
/* U+c7bf */ { 0, 0, 0, 0, 0 },
/* U+c7c0 */ { 0, 0, 0, 0, 0 },
/* U+c7c1 */ { 0, 0, 0, 0, 0 },
/* U+c7c2 */ { 0, 0, 0, 0, 0 },
/* U+c7c3 */ { 0, 0, 0, 0, 0 },
/* U+c7c4 */ { 0, 0, 0, 0, 0 },
/* U+c7c5 */ { 0, 0, 0, 0, 0 },
/* U+c7c6 */ { 0, 0, 0, 0, 0 },
/* U+c7c7 */ { 0, 0, 0, 0, 0 },
/* U+c7c8 */ { 0, 0, 0, 0, 0 },
/* U+c7c9 */ { 0, 0, 0, 0, 0 },
/* U+c7ca */ { 0, 0, 0, 0, 0 },
/* U+c7cb */ { 0, 0, 0, 0, 0 },
/* U+c7cc */ { 0, 0, 0, 0, 0 },
/* U+c7cd */ { 0, 0, 0, 0, 0 },
/* U+c7ce */ { 0, 0, 0, 0, 0 },
/* U+c7cf */ { 0, 0, 0, 0, 0 },
/* U+c7d0 */ { 0, 0, 0, 0, 0 },
/* U+c7d1 */ { 0, 0, 0, 0, 0 },
/* U+c7d2 */ { 0, 0, 0, 0, 0 },
/* U+c7d3 */ { 0, 0, 0, 0, 0 },
/* U+c7d4 */ { 0, 0, 0, 0, 0 },
/* U+c7d5 */ { 0, 0, 0, 0, 0 },
/* U+c7d6 */ { 0, 0, 0, 0, 0 },
/* U+c7d7 */ { 0, 0, 0, 0, 0 },
/* U+c7d8 */ { 0, 0, 0, 0, 0 },
/* U+c7d9 */ { 0, 0, 0, 0, 0 },
/* U+c7da */ { 0, 0, 0, 0, 0 },
/* U+c7db */ { 0, 0, 0, 0, 0 },
/* U+c7dc */ { 0, 0, 0, 0, 0 },
/* U+c7dd */ { 0, 0, 0, 0, 0 },
/* U+c7de */ { 0, 0, 0, 0, 0 },
/* U+c7df */ { 0, 0, 0, 0, 0 },
/* U+c7e0 */ { 0, 0, 0, 0, 0 },
/* U+c7e1 */ { 0, 0, 0, 0, 0 },
/* U+c7e2 */ { 0, 0, 0, 0, 0 },
/* U+c7e3 */ { 0, 0, 0, 0, 0 },
/* U+c7e4 */ { 0, 0, 0, 0, 0 },
/* U+c7e5 */ { 0, 0, 0, 0, 0 },
/* U+c7e6 */ { 0, 0, 0, 0, 0 },
/* U+c7e7 */ { 0, 0, 0, 0, 0 },
/* U+c7e8 */ { 0, 0, 0, 0, 0 },
/* U+c7e9 */ { 0, 0, 0, 0, 0 },
/* U+c7ea */ { 0, 0, 0, 0, 0 },
/* U+c7eb */ { 0, 0, 0, 0, 0 },
/* U+c7ec */ { 0, 0, 0, 0, 0 },
/* U+c7ed */ { 0, 0, 0, 0, 0 },
/* U+c7ee */ { 0, 0, 0, 0, 0 },
/* U+c7ef */ { 0, 0, 0, 0, 0 },
/* U+c7f0 */ { 0, 0, 0, 0, 0 },
/* U+c7f1 */ { 0, 0, 0, 0, 0 },
/* U+c7f2 */ { 0, 0, 0, 0, 0 },
/* U+c7f3 */ { 0, 0, 0, 0, 0 },
/* U+c7f4 */ { 0, 0, 0, 0, 0 },
/* U+c7f5 */ { 0, 0, 0, 0, 0 },
/* U+c7f6 */ { 0, 0, 0, 0, 0 },
/* U+c7f7 */ { 0, 0, 0, 0, 0 },
/* U+c7f8 */ { 0, 0, 0, 0, 0 },
/* U+c7f9 */ { 0, 0, 0, 0, 0 },
/* U+c7fa */ { 0, 0, 0, 0, 0 },
/* U+c7fb */ { 0, 0, 0, 0, 0 },
/* U+c7fc */ { 0, 0, 0, 0, 0 },
/* U+c7fd */ { 0, 0, 0, 0, 0 },
/* U+c7fe */ { 0, 0, 0, 0, 0 },
/* U+c7ff */ { 0, 0, 0, 0, 0 },
/* U+c800 */ { 0, 0, 0, 0, 0 },
/* U+c801 */ { 0, 0, 0, 0, 0 },
/* U+c802 */ { 0, 0, 0, 0, 0 },
/* U+c803 */ { 0, 0, 0, 0, 0 },
/* U+c804 */ { 0, 0, 0, 0, 0 },
/* U+c805 */ { 0, 0, 0, 0, 0 },
/* U+c806 */ { 0, 0, 0, 0, 0 },
/* U+c807 */ { 0, 0, 0, 0, 0 },
/* U+c808 */ { 0, 0, 0, 0, 0 },
/* U+c809 */ { 0, 0, 0, 0, 0 },
/* U+c80a */ { 0, 0, 0, 0, 0 },
/* U+c80b */ { 0, 0, 0, 0, 0 },
/* U+c80c */ { 0, 0, 0, 0, 0 },
/* U+c80d */ { 0, 0, 0, 0, 0 },
/* U+c80e */ { 0, 0, 0, 0, 0 },
/* U+c80f */ { 0, 0, 0, 0, 0 },
/* U+c810 */ { 0, 0, 0, 0, 0 },
/* U+c811 */ { 0, 0, 0, 0, 0 },
/* U+c812 */ { 0, 0, 0, 0, 0 },
/* U+c813 */ { 0, 0, 0, 0, 0 },
/* U+c814 */ { 0, 0, 0, 0, 0 },
/* U+c815 */ { 0, 0, 0, 0, 0 },
/* U+c816 */ { 0, 0, 0, 0, 0 },
/* U+c817 */ { 0, 0, 0, 0, 0 },
/* U+c818 */ { 0, 0, 0, 0, 0 },
/* U+c819 */ { 0, 0, 0, 0, 0 },
/* U+c81a */ { 0, 0, 0, 0, 0 },
/* U+c81b */ { 0, 0, 0, 0, 0 },
/* U+c81c */ { 0, 0, 0, 0, 0 },
/* U+c81d */ { 0, 0, 0, 0, 0 },
/* U+c81e */ { 0, 0, 0, 0, 0 },
/* U+c81f */ { 0, 0, 0, 0, 0 },
/* U+c820 */ { 0, 0, 0, 0, 0 },
/* U+c821 */ { 0, 0, 0, 0, 0 },
/* U+c822 */ { 0, 0, 0, 0, 0 },
/* U+c823 */ { 0, 0, 0, 0, 0 },
/* U+c824 */ { 0, 0, 0, 0, 0 },
/* U+c825 */ { 0, 0, 0, 0, 0 },
/* U+c826 */ { 0, 0, 0, 0, 0 },
/* U+c827 */ { 0, 0, 0, 0, 0 },
/* U+c828 */ { 0, 0, 0, 0, 0 },
/* U+c829 */ { 0, 0, 0, 0, 0 },
/* U+c82a */ { 0, 0, 0, 0, 0 },
/* U+c82b */ { 0, 0, 0, 0, 0 },
/* U+c82c */ { 0, 0, 0, 0, 0 },
/* U+c82d */ { 0, 0, 0, 0, 0 },
/* U+c82e */ { 0, 0, 0, 0, 0 },
/* U+c82f */ { 0, 0, 0, 0, 0 },
/* U+c830 */ { 0, 0, 0, 0, 0 },
/* U+c831 */ { 0, 0, 0, 0, 0 },
/* U+c832 */ { 0, 0, 0, 0, 0 },
/* U+c833 */ { 0, 0, 0, 0, 0 },
/* U+c834 */ { 0, 0, 0, 0, 0 },
/* U+c835 */ { 0, 0, 0, 0, 0 },
/* U+c836 */ { 0, 0, 0, 0, 0 },
/* U+c837 */ { 0, 0, 0, 0, 0 },
/* U+c838 */ { 0, 0, 0, 0, 0 },
/* U+c839 */ { 0, 0, 0, 0, 0 },
/* U+c83a */ { 0, 0, 0, 0, 0 },
/* U+c83b */ { 0, 0, 0, 0, 0 },
/* U+c83c */ { 0, 0, 0, 0, 0 },
/* U+c83d */ { 0, 0, 0, 0, 0 },
/* U+c83e */ { 0, 0, 0, 0, 0 },
/* U+c83f */ { 0, 0, 0, 0, 0 },
/* U+c840 */ { 0, 0, 0, 0, 0 },
/* U+c841 */ { 0, 0, 0, 0, 0 },
/* U+c842 */ { 0, 0, 0, 0, 0 },
/* U+c843 */ { 0, 0, 0, 0, 0 },
/* U+c844 */ { 0, 0, 0, 0, 0 },
/* U+c845 */ { 0, 0, 0, 0, 0 },
/* U+c846 */ { 0, 0, 0, 0, 0 },
/* U+c847 */ { 0, 0, 0, 0, 0 },
/* U+c848 */ { 0, 0, 0, 0, 0 },
/* U+c849 */ { 0, 0, 0, 0, 0 },
/* U+c84a */ { 0, 0, 0, 0, 0 },
/* U+c84b */ { 0, 0, 0, 0, 0 },
/* U+c84c */ { 0, 0, 0, 0, 0 },
/* U+c84d */ { 0, 0, 0, 0, 0 },
/* U+c84e */ { 0, 0, 0, 0, 0 },
/* U+c84f */ { 0, 0, 0, 0, 0 },
/* U+c850 */ { 0, 0, 0, 0, 0 },
/* U+c851 */ { 0, 0, 0, 0, 0 },
/* U+c852 */ { 0, 0, 0, 0, 0 },
/* U+c853 */ { 0, 0, 0, 0, 0 },
/* U+c854 */ { 0, 0, 0, 0, 0 },
/* U+c855 */ { 0, 0, 0, 0, 0 },
/* U+c856 */ { 0, 0, 0, 0, 0 },
/* U+c857 */ { 0, 0, 0, 0, 0 },
/* U+c858 */ { 0, 0, 0, 0, 0 },
/* U+c859 */ { 0, 0, 0, 0, 0 },
/* U+c85a */ { 0, 0, 0, 0, 0 },
/* U+c85b */ { 0, 0, 0, 0, 0 },
/* U+c85c */ { 0, 0, 0, 0, 0 },
/* U+c85d */ { 0, 0, 0, 0, 0 },
/* U+c85e */ { 0, 0, 0, 0, 0 },
/* U+c85f */ { 0, 0, 0, 0, 0 },
/* U+c860 */ { 0, 0, 0, 0, 0 },
/* U+c861 */ { 0, 0, 0, 0, 0 },
/* U+c862 */ { 0, 0, 0, 0, 0 },
/* U+c863 */ { 0, 0, 0, 0, 0 },
/* U+c864 */ { 0, 0, 0, 0, 0 },
/* U+c865 */ { 0, 0, 0, 0, 0 },
/* U+c866 */ { 0, 0, 0, 0, 0 },
/* U+c867 */ { 0, 0, 0, 0, 0 },
/* U+c868 */ { 0, 0, 0, 0, 0 },
/* U+c869 */ { 0, 0, 0, 0, 0 },
/* U+c86a */ { 0, 0, 0, 0, 0 },
/* U+c86b */ { 0, 0, 0, 0, 0 },
/* U+c86c */ { 0, 0, 0, 0, 0 },
/* U+c86d */ { 0, 0, 0, 0, 0 },
/* U+c86e */ { 0, 0, 0, 0, 0 },
/* U+c86f */ { 0, 0, 0, 0, 0 },
/* U+c870 */ { 0, 0, 0, 0, 0 },
/* U+c871 */ { 0, 0, 0, 0, 0 },
/* U+c872 */ { 0, 0, 0, 0, 0 },
/* U+c873 */ { 0, 0, 0, 0, 0 },
/* U+c874 */ { 0, 0, 0, 0, 0 },
/* U+c875 */ { 0, 0, 0, 0, 0 },
/* U+c876 */ { 0, 0, 0, 0, 0 },
/* U+c877 */ { 0, 0, 0, 0, 0 },
/* U+c878 */ { 0, 0, 0, 0, 0 },
/* U+c879 */ { 0, 0, 0, 0, 0 },
/* U+c87a */ { 0, 0, 0, 0, 0 },
/* U+c87b */ { 0, 0, 0, 0, 0 },
/* U+c87c */ { 0, 0, 0, 0, 0 },
/* U+c87d */ { 0, 0, 0, 0, 0 },
/* U+c87e */ { 0, 0, 0, 0, 0 },
/* U+c87f */ { 0, 0, 0, 0, 0 },
/* U+c880 */ { 0, 0, 0, 0, 0 },
/* U+c881 */ { 0, 0, 0, 0, 0 },
/* U+c882 */ { 0, 0, 0, 0, 0 },
/* U+c883 */ { 0, 0, 0, 0, 0 },
/* U+c884 */ { 0, 0, 0, 0, 0 },
/* U+c885 */ { 0, 0, 0, 0, 0 },
/* U+c886 */ { 0, 0, 0, 0, 0 },
/* U+c887 */ { 0, 0, 0, 0, 0 },
/* U+c888 */ { 0, 0, 0, 0, 0 },
/* U+c889 */ { 0, 0, 0, 0, 0 },
/* U+c88a */ { 0, 0, 0, 0, 0 },
/* U+c88b */ { 0, 0, 0, 0, 0 },
/* U+c88c */ { 0, 0, 0, 0, 0 },
/* U+c88d */ { 0, 0, 0, 0, 0 },
/* U+c88e */ { 0, 0, 0, 0, 0 },
/* U+c88f */ { 0, 0, 0, 0, 0 },
/* U+c890 */ { 0, 0, 0, 0, 0 },
/* U+c891 */ { 0, 0, 0, 0, 0 },
/* U+c892 */ { 0, 0, 0, 0, 0 },
/* U+c893 */ { 0, 0, 0, 0, 0 },
/* U+c894 */ { 0, 0, 0, 0, 0 },
/* U+c895 */ { 0, 0, 0, 0, 0 },
/* U+c896 */ { 0, 0, 0, 0, 0 },
/* U+c897 */ { 0, 0, 0, 0, 0 },
/* U+c898 */ { 0, 0, 0, 0, 0 },
/* U+c899 */ { 0, 0, 0, 0, 0 },
/* U+c89a */ { 0, 0, 0, 0, 0 },
/* U+c89b */ { 0, 0, 0, 0, 0 },
/* U+c89c */ { 0, 0, 0, 0, 0 },
/* U+c89d */ { 0, 0, 0, 0, 0 },
/* U+c89e */ { 0, 0, 0, 0, 0 },
/* U+c89f */ { 0, 0, 0, 0, 0 },
/* U+c8a0 */ { 0, 0, 0, 0, 0 },
/* U+c8a1 */ { 0, 0, 0, 0, 0 },
/* U+c8a2 */ { 0, 0, 0, 0, 0 },
/* U+c8a3 */ { 0, 0, 0, 0, 0 },
/* U+c8a4 */ { 0, 0, 0, 0, 0 },
/* U+c8a5 */ { 0, 0, 0, 0, 0 },
/* U+c8a6 */ { 0, 0, 0, 0, 0 },
/* U+c8a7 */ { 0, 0, 0, 0, 0 },
/* U+c8a8 */ { 0, 0, 0, 0, 0 },
/* U+c8a9 */ { 0, 0, 0, 0, 0 },
/* U+c8aa */ { 0, 0, 0, 0, 0 },
/* U+c8ab */ { 0, 0, 0, 0, 0 },
/* U+c8ac */ { 0, 0, 0, 0, 0 },
/* U+c8ad */ { 0, 0, 0, 0, 0 },
/* U+c8ae */ { 0, 0, 0, 0, 0 },
/* U+c8af */ { 0, 0, 0, 0, 0 },
/* U+c8b0 */ { 0, 0, 0, 0, 0 },
/* U+c8b1 */ { 0, 0, 0, 0, 0 },
/* U+c8b2 */ { 0, 0, 0, 0, 0 },
/* U+c8b3 */ { 0, 0, 0, 0, 0 },
/* U+c8b4 */ { 0, 0, 0, 0, 0 },
/* U+c8b5 */ { 0, 0, 0, 0, 0 },
/* U+c8b6 */ { 0, 0, 0, 0, 0 },
/* U+c8b7 */ { 0, 0, 0, 0, 0 },
/* U+c8b8 */ { 0, 0, 0, 0, 0 },
/* U+c8b9 */ { 0, 0, 0, 0, 0 },
/* U+c8ba */ { 0, 0, 0, 0, 0 },
/* U+c8bb */ { 0, 0, 0, 0, 0 },
/* U+c8bc */ { 0, 0, 0, 0, 0 },
/* U+c8bd */ { 0, 0, 0, 0, 0 },
/* U+c8be */ { 0, 0, 0, 0, 0 },
/* U+c8bf */ { 0, 0, 0, 0, 0 },
/* U+c8c0 */ { 0, 0, 0, 0, 0 },
/* U+c8c1 */ { 0, 0, 0, 0, 0 },
/* U+c8c2 */ { 0, 0, 0, 0, 0 },
/* U+c8c3 */ { 0, 0, 0, 0, 0 },
/* U+c8c4 */ { 0, 0, 0, 0, 0 },
/* U+c8c5 */ { 0, 0, 0, 0, 0 },
/* U+c8c6 */ { 0, 0, 0, 0, 0 },
/* U+c8c7 */ { 0, 0, 0, 0, 0 },
/* U+c8c8 */ { 0, 0, 0, 0, 0 },
/* U+c8c9 */ { 0, 0, 0, 0, 0 },
/* U+c8ca */ { 0, 0, 0, 0, 0 },
/* U+c8cb */ { 0, 0, 0, 0, 0 },
/* U+c8cc */ { 0, 0, 0, 0, 0 },
/* U+c8cd */ { 0, 0, 0, 0, 0 },
/* U+c8ce */ { 0, 0, 0, 0, 0 },
/* U+c8cf */ { 0, 0, 0, 0, 0 },
/* U+c8d0 */ { 0, 0, 0, 0, 0 },
/* U+c8d1 */ { 0, 0, 0, 0, 0 },
/* U+c8d2 */ { 0, 0, 0, 0, 0 },
/* U+c8d3 */ { 0, 0, 0, 0, 0 },
/* U+c8d4 */ { 0, 0, 0, 0, 0 },
/* U+c8d5 */ { 0, 0, 0, 0, 0 },
/* U+c8d6 */ { 0, 0, 0, 0, 0 },
/* U+c8d7 */ { 0, 0, 0, 0, 0 },
/* U+c8d8 */ { 0, 0, 0, 0, 0 },
/* U+c8d9 */ { 0, 0, 0, 0, 0 },
/* U+c8da */ { 0, 0, 0, 0, 0 },
/* U+c8db */ { 0, 0, 0, 0, 0 },
/* U+c8dc */ { 0, 0, 0, 0, 0 },
/* U+c8dd */ { 0, 0, 0, 0, 0 },
/* U+c8de */ { 0, 0, 0, 0, 0 },
/* U+c8df */ { 0, 0, 0, 0, 0 },
/* U+c8e0 */ { 0, 0, 0, 0, 0 },
/* U+c8e1 */ { 0, 0, 0, 0, 0 },
/* U+c8e2 */ { 0, 0, 0, 0, 0 },
/* U+c8e3 */ { 0, 0, 0, 0, 0 },
/* U+c8e4 */ { 0, 0, 0, 0, 0 },
/* U+c8e5 */ { 0, 0, 0, 0, 0 },
/* U+c8e6 */ { 0, 0, 0, 0, 0 },
/* U+c8e7 */ { 0, 0, 0, 0, 0 },
/* U+c8e8 */ { 0, 0, 0, 0, 0 },
/* U+c8e9 */ { 0, 0, 0, 0, 0 },
/* U+c8ea */ { 0, 0, 0, 0, 0 },
/* U+c8eb */ { 0, 0, 0, 0, 0 },
/* U+c8ec */ { 0, 0, 0, 0, 0 },
/* U+c8ed */ { 0, 0, 0, 0, 0 },
/* U+c8ee */ { 0, 0, 0, 0, 0 },
/* U+c8ef */ { 0, 0, 0, 0, 0 },
/* U+c8f0 */ { 0, 0, 0, 0, 0 },
/* U+c8f1 */ { 0, 0, 0, 0, 0 },
/* U+c8f2 */ { 0, 0, 0, 0, 0 },
/* U+c8f3 */ { 0, 0, 0, 0, 0 },
/* U+c8f4 */ { 0, 0, 0, 0, 0 },
/* U+c8f5 */ { 0, 0, 0, 0, 0 },
/* U+c8f6 */ { 0, 0, 0, 0, 0 },
/* U+c8f7 */ { 0, 0, 0, 0, 0 },
/* U+c8f8 */ { 0, 0, 0, 0, 0 },
/* U+c8f9 */ { 0, 0, 0, 0, 0 },
/* U+c8fa */ { 0, 0, 0, 0, 0 },
/* U+c8fb */ { 0, 0, 0, 0, 0 },
/* U+c8fc */ { 0, 0, 0, 0, 0 },
/* U+c8fd */ { 0, 0, 0, 0, 0 },
/* U+c8fe */ { 0, 0, 0, 0, 0 },
/* U+c8ff */ { 0, 0, 0, 0, 0 },
/* U+c900 */ { 0, 0, 0, 0, 0 },
/* U+c901 */ { 0, 0, 0, 0, 0 },
/* U+c902 */ { 0, 0, 0, 0, 0 },
/* U+c903 */ { 0, 0, 0, 0, 0 },
/* U+c904 */ { 0, 0, 0, 0, 0 },
/* U+c905 */ { 0, 0, 0, 0, 0 },
/* U+c906 */ { 0, 0, 0, 0, 0 },
/* U+c907 */ { 0, 0, 0, 0, 0 },
/* U+c908 */ { 0, 0, 0, 0, 0 },
/* U+c909 */ { 0, 0, 0, 0, 0 },
/* U+c90a */ { 0, 0, 0, 0, 0 },
/* U+c90b */ { 0, 0, 0, 0, 0 },
/* U+c90c */ { 0, 0, 0, 0, 0 },
/* U+c90d */ { 0, 0, 0, 0, 0 },
/* U+c90e */ { 0, 0, 0, 0, 0 },
/* U+c90f */ { 0, 0, 0, 0, 0 },
/* U+c910 */ { 0, 0, 0, 0, 0 },
/* U+c911 */ { 0, 0, 0, 0, 0 },
/* U+c912 */ { 0, 0, 0, 0, 0 },
/* U+c913 */ { 0, 0, 0, 0, 0 },
/* U+c914 */ { 0, 0, 0, 0, 0 },
/* U+c915 */ { 0, 0, 0, 0, 0 },
/* U+c916 */ { 0, 0, 0, 0, 0 },
/* U+c917 */ { 0, 0, 0, 0, 0 },
/* U+c918 */ { 0, 0, 0, 0, 0 },
/* U+c919 */ { 0, 0, 0, 0, 0 },
/* U+c91a */ { 0, 0, 0, 0, 0 },
/* U+c91b */ { 0, 0, 0, 0, 0 },
/* U+c91c */ { 0, 0, 0, 0, 0 },
/* U+c91d */ { 0, 0, 0, 0, 0 },
/* U+c91e */ { 0, 0, 0, 0, 0 },
/* U+c91f */ { 0, 0, 0, 0, 0 },
/* U+c920 */ { 0, 0, 0, 0, 0 },
/* U+c921 */ { 0, 0, 0, 0, 0 },
/* U+c922 */ { 0, 0, 0, 0, 0 },
/* U+c923 */ { 0, 0, 0, 0, 0 },
/* U+c924 */ { 0, 0, 0, 0, 0 },
/* U+c925 */ { 0, 0, 0, 0, 0 },
/* U+c926 */ { 0, 0, 0, 0, 0 },
/* U+c927 */ { 0, 0, 0, 0, 0 },
/* U+c928 */ { 0, 0, 0, 0, 0 },
/* U+c929 */ { 0, 0, 0, 0, 0 },
/* U+c92a */ { 0, 0, 0, 0, 0 },
/* U+c92b */ { 0, 0, 0, 0, 0 },
/* U+c92c */ { 0, 0, 0, 0, 0 },
/* U+c92d */ { 0, 0, 0, 0, 0 },
/* U+c92e */ { 0, 0, 0, 0, 0 },
/* U+c92f */ { 0, 0, 0, 0, 0 },
/* U+c930 */ { 0, 0, 0, 0, 0 },
/* U+c931 */ { 0, 0, 0, 0, 0 },
/* U+c932 */ { 0, 0, 0, 0, 0 },
/* U+c933 */ { 0, 0, 0, 0, 0 },
/* U+c934 */ { 0, 0, 0, 0, 0 },
/* U+c935 */ { 0, 0, 0, 0, 0 },
/* U+c936 */ { 0, 0, 0, 0, 0 },
/* U+c937 */ { 0, 0, 0, 0, 0 },
/* U+c938 */ { 0, 0, 0, 0, 0 },
/* U+c939 */ { 0, 0, 0, 0, 0 },
/* U+c93a */ { 0, 0, 0, 0, 0 },
/* U+c93b */ { 0, 0, 0, 0, 0 },
/* U+c93c */ { 0, 0, 0, 0, 0 },
/* U+c93d */ { 0, 0, 0, 0, 0 },
/* U+c93e */ { 0, 0, 0, 0, 0 },
/* U+c93f */ { 0, 0, 0, 0, 0 },
/* U+c940 */ { 0, 0, 0, 0, 0 },
/* U+c941 */ { 0, 0, 0, 0, 0 },
/* U+c942 */ { 0, 0, 0, 0, 0 },
/* U+c943 */ { 0, 0, 0, 0, 0 },
/* U+c944 */ { 0, 0, 0, 0, 0 },
/* U+c945 */ { 0, 0, 0, 0, 0 },
/* U+c946 */ { 0, 0, 0, 0, 0 },
/* U+c947 */ { 0, 0, 0, 0, 0 },
/* U+c948 */ { 0, 0, 0, 0, 0 },
/* U+c949 */ { 0, 0, 0, 0, 0 },
/* U+c94a */ { 0, 0, 0, 0, 0 },
/* U+c94b */ { 0, 0, 0, 0, 0 },
/* U+c94c */ { 0, 0, 0, 0, 0 },
/* U+c94d */ { 0, 0, 0, 0, 0 },
/* U+c94e */ { 0, 0, 0, 0, 0 },
/* U+c94f */ { 0, 0, 0, 0, 0 },
/* U+c950 */ { 0, 0, 0, 0, 0 },
/* U+c951 */ { 0, 0, 0, 0, 0 },
/* U+c952 */ { 0, 0, 0, 0, 0 },
/* U+c953 */ { 0, 0, 0, 0, 0 },
/* U+c954 */ { 0, 0, 0, 0, 0 },
/* U+c955 */ { 0, 0, 0, 0, 0 },
/* U+c956 */ { 0, 0, 0, 0, 0 },
/* U+c957 */ { 0, 0, 0, 0, 0 },
/* U+c958 */ { 0, 0, 0, 0, 0 },
/* U+c959 */ { 0, 0, 0, 0, 0 },
/* U+c95a */ { 0, 0, 0, 0, 0 },
/* U+c95b */ { 0, 0, 0, 0, 0 },
/* U+c95c */ { 0, 0, 0, 0, 0 },
/* U+c95d */ { 0, 0, 0, 0, 0 },
/* U+c95e */ { 0, 0, 0, 0, 0 },
/* U+c95f */ { 0, 0, 0, 0, 0 },
/* U+c960 */ { 0, 0, 0, 0, 0 },
/* U+c961 */ { 0, 0, 0, 0, 0 },
/* U+c962 */ { 0, 0, 0, 0, 0 },
/* U+c963 */ { 0, 0, 0, 0, 0 },
/* U+c964 */ { 0, 0, 0, 0, 0 },
/* U+c965 */ { 0, 0, 0, 0, 0 },
/* U+c966 */ { 0, 0, 0, 0, 0 },
/* U+c967 */ { 0, 0, 0, 0, 0 },
/* U+c968 */ { 0, 0, 0, 0, 0 },
/* U+c969 */ { 0, 0, 0, 0, 0 },
/* U+c96a */ { 0, 0, 0, 0, 0 },
/* U+c96b */ { 0, 0, 0, 0, 0 },
/* U+c96c */ { 0, 0, 0, 0, 0 },
/* U+c96d */ { 0, 0, 0, 0, 0 },
/* U+c96e */ { 0, 0, 0, 0, 0 },
/* U+c96f */ { 0, 0, 0, 0, 0 },
/* U+c970 */ { 0, 0, 0, 0, 0 },
/* U+c971 */ { 0, 0, 0, 0, 0 },
/* U+c972 */ { 0, 0, 0, 0, 0 },
/* U+c973 */ { 0, 0, 0, 0, 0 },
/* U+c974 */ { 0, 0, 0, 0, 0 },
/* U+c975 */ { 0, 0, 0, 0, 0 },
/* U+c976 */ { 0, 0, 0, 0, 0 },
/* U+c977 */ { 0, 0, 0, 0, 0 },
/* U+c978 */ { 0, 0, 0, 0, 0 },
/* U+c979 */ { 0, 0, 0, 0, 0 },
/* U+c97a */ { 0, 0, 0, 0, 0 },
/* U+c97b */ { 0, 0, 0, 0, 0 },
/* U+c97c */ { 0, 0, 0, 0, 0 },
/* U+c97d */ { 0, 0, 0, 0, 0 },
/* U+c97e */ { 0, 0, 0, 0, 0 },
/* U+c97f */ { 0, 0, 0, 0, 0 },
/* U+c980 */ { 0, 0, 0, 0, 0 },
/* U+c981 */ { 0, 0, 0, 0, 0 },
/* U+c982 */ { 0, 0, 0, 0, 0 },
/* U+c983 */ { 0, 0, 0, 0, 0 },
/* U+c984 */ { 0, 0, 0, 0, 0 },
/* U+c985 */ { 0, 0, 0, 0, 0 },
/* U+c986 */ { 0, 0, 0, 0, 0 },
/* U+c987 */ { 0, 0, 0, 0, 0 },
/* U+c988 */ { 0, 0, 0, 0, 0 },
/* U+c989 */ { 0, 0, 0, 0, 0 },
/* U+c98a */ { 0, 0, 0, 0, 0 },
/* U+c98b */ { 0, 0, 0, 0, 0 },
/* U+c98c */ { 0, 0, 0, 0, 0 },
/* U+c98d */ { 0, 0, 0, 0, 0 },
/* U+c98e */ { 0, 0, 0, 0, 0 },
/* U+c98f */ { 0, 0, 0, 0, 0 },
/* U+c990 */ { 0, 0, 0, 0, 0 },
/* U+c991 */ { 0, 0, 0, 0, 0 },
/* U+c992 */ { 0, 0, 0, 0, 0 },
/* U+c993 */ { 0, 0, 0, 0, 0 },
/* U+c994 */ { 0, 0, 0, 0, 0 },
/* U+c995 */ { 0, 0, 0, 0, 0 },
/* U+c996 */ { 0, 0, 0, 0, 0 },
/* U+c997 */ { 0, 0, 0, 0, 0 },
/* U+c998 */ { 0, 0, 0, 0, 0 },
/* U+c999 */ { 0, 0, 0, 0, 0 },
/* U+c99a */ { 0, 0, 0, 0, 0 },
/* U+c99b */ { 0, 0, 0, 0, 0 },
/* U+c99c */ { 0, 0, 0, 0, 0 },
/* U+c99d */ { 0, 0, 0, 0, 0 },
/* U+c99e */ { 0, 0, 0, 0, 0 },
/* U+c99f */ { 0, 0, 0, 0, 0 },
/* U+c9a0 */ { 0, 0, 0, 0, 0 },
/* U+c9a1 */ { 0, 0, 0, 0, 0 },
/* U+c9a2 */ { 0, 0, 0, 0, 0 },
/* U+c9a3 */ { 0, 0, 0, 0, 0 },
/* U+c9a4 */ { 0, 0, 0, 0, 0 },
/* U+c9a5 */ { 0, 0, 0, 0, 0 },
/* U+c9a6 */ { 0, 0, 0, 0, 0 },
/* U+c9a7 */ { 0, 0, 0, 0, 0 },
/* U+c9a8 */ { 0, 0, 0, 0, 0 },
/* U+c9a9 */ { 0, 0, 0, 0, 0 },
/* U+c9aa */ { 0, 0, 0, 0, 0 },
/* U+c9ab */ { 0, 0, 0, 0, 0 },
/* U+c9ac */ { 0, 0, 0, 0, 0 },
/* U+c9ad */ { 0, 0, 0, 0, 0 },
/* U+c9ae */ { 0, 0, 0, 0, 0 },
/* U+c9af */ { 0, 0, 0, 0, 0 },
/* U+c9b0 */ { 0, 0, 0, 0, 0 },
/* U+c9b1 */ { 0, 0, 0, 0, 0 },
/* U+c9b2 */ { 0, 0, 0, 0, 0 },
/* U+c9b3 */ { 0, 0, 0, 0, 0 },
/* U+c9b4 */ { 0, 0, 0, 0, 0 },
/* U+c9b5 */ { 0, 0, 0, 0, 0 },
/* U+c9b6 */ { 0, 0, 0, 0, 0 },
/* U+c9b7 */ { 0, 0, 0, 0, 0 },
/* U+c9b8 */ { 0, 0, 0, 0, 0 },
/* U+c9b9 */ { 0, 0, 0, 0, 0 },
/* U+c9ba */ { 0, 0, 0, 0, 0 },
/* U+c9bb */ { 0, 0, 0, 0, 0 },
/* U+c9bc */ { 0, 0, 0, 0, 0 },
/* U+c9bd */ { 0, 0, 0, 0, 0 },
/* U+c9be */ { 0, 0, 0, 0, 0 },
/* U+c9bf */ { 0, 0, 0, 0, 0 },
/* U+c9c0 */ { 0, 0, 0, 0, 0 },
/* U+c9c1 */ { 0, 0, 0, 0, 0 },
/* U+c9c2 */ { 0, 0, 0, 0, 0 },
/* U+c9c3 */ { 0, 0, 0, 0, 0 },
/* U+c9c4 */ { 0, 0, 0, 0, 0 },
/* U+c9c5 */ { 0, 0, 0, 0, 0 },
/* U+c9c6 */ { 0, 0, 0, 0, 0 },
/* U+c9c7 */ { 0, 0, 0, 0, 0 },
/* U+c9c8 */ { 0, 0, 0, 0, 0 },
/* U+c9c9 */ { 0, 0, 0, 0, 0 },
/* U+c9ca */ { 0, 0, 0, 0, 0 },
/* U+c9cb */ { 0, 0, 0, 0, 0 },
/* U+c9cc */ { 0, 0, 0, 0, 0 },
/* U+c9cd */ { 0, 0, 0, 0, 0 },
/* U+c9ce */ { 0, 0, 0, 0, 0 },
/* U+c9cf */ { 0, 0, 0, 0, 0 },
/* U+c9d0 */ { 0, 0, 0, 0, 0 },
/* U+c9d1 */ { 0, 0, 0, 0, 0 },
/* U+c9d2 */ { 0, 0, 0, 0, 0 },
/* U+c9d3 */ { 0, 0, 0, 0, 0 },
/* U+c9d4 */ { 0, 0, 0, 0, 0 },
/* U+c9d5 */ { 0, 0, 0, 0, 0 },
/* U+c9d6 */ { 0, 0, 0, 0, 0 },
/* U+c9d7 */ { 0, 0, 0, 0, 0 },
/* U+c9d8 */ { 0, 0, 0, 0, 0 },
/* U+c9d9 */ { 0, 0, 0, 0, 0 },
/* U+c9da */ { 0, 0, 0, 0, 0 },
/* U+c9db */ { 0, 0, 0, 0, 0 },
/* U+c9dc */ { 0, 0, 0, 0, 0 },
/* U+c9dd */ { 0, 0, 0, 0, 0 },
/* U+c9de */ { 0, 0, 0, 0, 0 },
/* U+c9df */ { 0, 0, 0, 0, 0 },
/* U+c9e0 */ { 0, 0, 0, 0, 0 },
/* U+c9e1 */ { 0, 0, 0, 0, 0 },
/* U+c9e2 */ { 0, 0, 0, 0, 0 },
/* U+c9e3 */ { 0, 0, 0, 0, 0 },
/* U+c9e4 */ { 0, 0, 0, 0, 0 },
/* U+c9e5 */ { 0, 0, 0, 0, 0 },
/* U+c9e6 */ { 0, 0, 0, 0, 0 },
/* U+c9e7 */ { 0, 0, 0, 0, 0 },
/* U+c9e8 */ { 0, 0, 0, 0, 0 },
/* U+c9e9 */ { 0, 0, 0, 0, 0 },
/* U+c9ea */ { 0, 0, 0, 0, 0 },
/* U+c9eb */ { 0, 0, 0, 0, 0 },
/* U+c9ec */ { 0, 0, 0, 0, 0 },
/* U+c9ed */ { 0, 0, 0, 0, 0 },
/* U+c9ee */ { 0, 0, 0, 0, 0 },
/* U+c9ef */ { 0, 0, 0, 0, 0 },
/* U+c9f0 */ { 0, 0, 0, 0, 0 },
/* U+c9f1 */ { 0, 0, 0, 0, 0 },
/* U+c9f2 */ { 0, 0, 0, 0, 0 },
/* U+c9f3 */ { 0, 0, 0, 0, 0 },
/* U+c9f4 */ { 0, 0, 0, 0, 0 },
/* U+c9f5 */ { 0, 0, 0, 0, 0 },
/* U+c9f6 */ { 0, 0, 0, 0, 0 },
/* U+c9f7 */ { 0, 0, 0, 0, 0 },
/* U+c9f8 */ { 0, 0, 0, 0, 0 },
/* U+c9f9 */ { 0, 0, 0, 0, 0 },
/* U+c9fa */ { 0, 0, 0, 0, 0 },
/* U+c9fb */ { 0, 0, 0, 0, 0 },
/* U+c9fc */ { 0, 0, 0, 0, 0 },
/* U+c9fd */ { 0, 0, 0, 0, 0 },
/* U+c9fe */ { 0, 0, 0, 0, 0 },
/* U+c9ff */ { 0, 0, 0, 0, 0 },
/* U+ca00 */ { 0, 0, 0, 0, 0 },
/* U+ca01 */ { 0, 0, 0, 0, 0 },
/* U+ca02 */ { 0, 0, 0, 0, 0 },
/* U+ca03 */ { 0, 0, 0, 0, 0 },
/* U+ca04 */ { 0, 0, 0, 0, 0 },
/* U+ca05 */ { 0, 0, 0, 0, 0 },
/* U+ca06 */ { 0, 0, 0, 0, 0 },
/* U+ca07 */ { 0, 0, 0, 0, 0 },
/* U+ca08 */ { 0, 0, 0, 0, 0 },
/* U+ca09 */ { 0, 0, 0, 0, 0 },
/* U+ca0a */ { 0, 0, 0, 0, 0 },
/* U+ca0b */ { 0, 0, 0, 0, 0 },
/* U+ca0c */ { 0, 0, 0, 0, 0 },
/* U+ca0d */ { 0, 0, 0, 0, 0 },
/* U+ca0e */ { 0, 0, 0, 0, 0 },
/* U+ca0f */ { 0, 0, 0, 0, 0 },
/* U+ca10 */ { 0, 0, 0, 0, 0 },
/* U+ca11 */ { 0, 0, 0, 0, 0 },
/* U+ca12 */ { 0, 0, 0, 0, 0 },
/* U+ca13 */ { 0, 0, 0, 0, 0 },
/* U+ca14 */ { 0, 0, 0, 0, 0 },
/* U+ca15 */ { 0, 0, 0, 0, 0 },
/* U+ca16 */ { 0, 0, 0, 0, 0 },
/* U+ca17 */ { 0, 0, 0, 0, 0 },
/* U+ca18 */ { 0, 0, 0, 0, 0 },
/* U+ca19 */ { 0, 0, 0, 0, 0 },
/* U+ca1a */ { 0, 0, 0, 0, 0 },
/* U+ca1b */ { 0, 0, 0, 0, 0 },
/* U+ca1c */ { 0, 0, 0, 0, 0 },
/* U+ca1d */ { 0, 0, 0, 0, 0 },
/* U+ca1e */ { 0, 0, 0, 0, 0 },
/* U+ca1f */ { 0, 0, 0, 0, 0 },
/* U+ca20 */ { 0, 0, 0, 0, 0 },
/* U+ca21 */ { 0, 0, 0, 0, 0 },
/* U+ca22 */ { 0, 0, 0, 0, 0 },
/* U+ca23 */ { 0, 0, 0, 0, 0 },
/* U+ca24 */ { 0, 0, 0, 0, 0 },
/* U+ca25 */ { 0, 0, 0, 0, 0 },
/* U+ca26 */ { 0, 0, 0, 0, 0 },
/* U+ca27 */ { 0, 0, 0, 0, 0 },
/* U+ca28 */ { 0, 0, 0, 0, 0 },
/* U+ca29 */ { 0, 0, 0, 0, 0 },
/* U+ca2a */ { 0, 0, 0, 0, 0 },
/* U+ca2b */ { 0, 0, 0, 0, 0 },
/* U+ca2c */ { 0, 0, 0, 0, 0 },
/* U+ca2d */ { 0, 0, 0, 0, 0 },
/* U+ca2e */ { 0, 0, 0, 0, 0 },
/* U+ca2f */ { 0, 0, 0, 0, 0 },
/* U+ca30 */ { 0, 0, 0, 0, 0 },
/* U+ca31 */ { 0, 0, 0, 0, 0 },
/* U+ca32 */ { 0, 0, 0, 0, 0 },
/* U+ca33 */ { 0, 0, 0, 0, 0 },
/* U+ca34 */ { 0, 0, 0, 0, 0 },
/* U+ca35 */ { 0, 0, 0, 0, 0 },
/* U+ca36 */ { 0, 0, 0, 0, 0 },
/* U+ca37 */ { 0, 0, 0, 0, 0 },
/* U+ca38 */ { 0, 0, 0, 0, 0 },
/* U+ca39 */ { 0, 0, 0, 0, 0 },
/* U+ca3a */ { 0, 0, 0, 0, 0 },
/* U+ca3b */ { 0, 0, 0, 0, 0 },
/* U+ca3c */ { 0, 0, 0, 0, 0 },
/* U+ca3d */ { 0, 0, 0, 0, 0 },
/* U+ca3e */ { 0, 0, 0, 0, 0 },
/* U+ca3f */ { 0, 0, 0, 0, 0 },
/* U+ca40 */ { 0, 0, 0, 0, 0 },
/* U+ca41 */ { 0, 0, 0, 0, 0 },
/* U+ca42 */ { 0, 0, 0, 0, 0 },
/* U+ca43 */ { 0, 0, 0, 0, 0 },
/* U+ca44 */ { 0, 0, 0, 0, 0 },
/* U+ca45 */ { 0, 0, 0, 0, 0 },
/* U+ca46 */ { 0, 0, 0, 0, 0 },
/* U+ca47 */ { 0, 0, 0, 0, 0 },
/* U+ca48 */ { 0, 0, 0, 0, 0 },
/* U+ca49 */ { 0, 0, 0, 0, 0 },
/* U+ca4a */ { 0, 0, 0, 0, 0 },
/* U+ca4b */ { 0, 0, 0, 0, 0 },
/* U+ca4c */ { 0, 0, 0, 0, 0 },
/* U+ca4d */ { 0, 0, 0, 0, 0 },
/* U+ca4e */ { 0, 0, 0, 0, 0 },
/* U+ca4f */ { 0, 0, 0, 0, 0 },
/* U+ca50 */ { 0, 0, 0, 0, 0 },
/* U+ca51 */ { 0, 0, 0, 0, 0 },
/* U+ca52 */ { 0, 0, 0, 0, 0 },
/* U+ca53 */ { 0, 0, 0, 0, 0 },
/* U+ca54 */ { 0, 0, 0, 0, 0 },
/* U+ca55 */ { 0, 0, 0, 0, 0 },
/* U+ca56 */ { 0, 0, 0, 0, 0 },
/* U+ca57 */ { 0, 0, 0, 0, 0 },
/* U+ca58 */ { 0, 0, 0, 0, 0 },
/* U+ca59 */ { 0, 0, 0, 0, 0 },
/* U+ca5a */ { 0, 0, 0, 0, 0 },
/* U+ca5b */ { 0, 0, 0, 0, 0 },
/* U+ca5c */ { 0, 0, 0, 0, 0 },
/* U+ca5d */ { 0, 0, 0, 0, 0 },
/* U+ca5e */ { 0, 0, 0, 0, 0 },
/* U+ca5f */ { 0, 0, 0, 0, 0 },
/* U+ca60 */ { 0, 0, 0, 0, 0 },
/* U+ca61 */ { 0, 0, 0, 0, 0 },
/* U+ca62 */ { 0, 0, 0, 0, 0 },
/* U+ca63 */ { 0, 0, 0, 0, 0 },
/* U+ca64 */ { 0, 0, 0, 0, 0 },
/* U+ca65 */ { 0, 0, 0, 0, 0 },
/* U+ca66 */ { 0, 0, 0, 0, 0 },
/* U+ca67 */ { 0, 0, 0, 0, 0 },
/* U+ca68 */ { 0, 0, 0, 0, 0 },
/* U+ca69 */ { 0, 0, 0, 0, 0 },
/* U+ca6a */ { 0, 0, 0, 0, 0 },
/* U+ca6b */ { 0, 0, 0, 0, 0 },
/* U+ca6c */ { 0, 0, 0, 0, 0 },
/* U+ca6d */ { 0, 0, 0, 0, 0 },
/* U+ca6e */ { 0, 0, 0, 0, 0 },
/* U+ca6f */ { 0, 0, 0, 0, 0 },
/* U+ca70 */ { 0, 0, 0, 0, 0 },
/* U+ca71 */ { 0, 0, 0, 0, 0 },
/* U+ca72 */ { 0, 0, 0, 0, 0 },
/* U+ca73 */ { 0, 0, 0, 0, 0 },
/* U+ca74 */ { 0, 0, 0, 0, 0 },
/* U+ca75 */ { 0, 0, 0, 0, 0 },
/* U+ca76 */ { 0, 0, 0, 0, 0 },
/* U+ca77 */ { 0, 0, 0, 0, 0 },
/* U+ca78 */ { 0, 0, 0, 0, 0 },
/* U+ca79 */ { 0, 0, 0, 0, 0 },
/* U+ca7a */ { 0, 0, 0, 0, 0 },
/* U+ca7b */ { 0, 0, 0, 0, 0 },
/* U+ca7c */ { 0, 0, 0, 0, 0 },
/* U+ca7d */ { 0, 0, 0, 0, 0 },
/* U+ca7e */ { 0, 0, 0, 0, 0 },
/* U+ca7f */ { 0, 0, 0, 0, 0 },
/* U+ca80 */ { 0, 0, 0, 0, 0 },
/* U+ca81 */ { 0, 0, 0, 0, 0 },
/* U+ca82 */ { 0, 0, 0, 0, 0 },
/* U+ca83 */ { 0, 0, 0, 0, 0 },
/* U+ca84 */ { 0, 0, 0, 0, 0 },
/* U+ca85 */ { 0, 0, 0, 0, 0 },
/* U+ca86 */ { 0, 0, 0, 0, 0 },
/* U+ca87 */ { 0, 0, 0, 0, 0 },
/* U+ca88 */ { 0, 0, 0, 0, 0 },
/* U+ca89 */ { 0, 0, 0, 0, 0 },
/* U+ca8a */ { 0, 0, 0, 0, 0 },
/* U+ca8b */ { 0, 0, 0, 0, 0 },
/* U+ca8c */ { 0, 0, 0, 0, 0 },
/* U+ca8d */ { 0, 0, 0, 0, 0 },
/* U+ca8e */ { 0, 0, 0, 0, 0 },
/* U+ca8f */ { 0, 0, 0, 0, 0 },
/* U+ca90 */ { 0, 0, 0, 0, 0 },
/* U+ca91 */ { 0, 0, 0, 0, 0 },
/* U+ca92 */ { 0, 0, 0, 0, 0 },
/* U+ca93 */ { 0, 0, 0, 0, 0 },
/* U+ca94 */ { 0, 0, 0, 0, 0 },
/* U+ca95 */ { 0, 0, 0, 0, 0 },
/* U+ca96 */ { 0, 0, 0, 0, 0 },
/* U+ca97 */ { 0, 0, 0, 0, 0 },
/* U+ca98 */ { 0, 0, 0, 0, 0 },
/* U+ca99 */ { 0, 0, 0, 0, 0 },
/* U+ca9a */ { 0, 0, 0, 0, 0 },
/* U+ca9b */ { 0, 0, 0, 0, 0 },
/* U+ca9c */ { 0, 0, 0, 0, 0 },
/* U+ca9d */ { 0, 0, 0, 0, 0 },
/* U+ca9e */ { 0, 0, 0, 0, 0 },
/* U+ca9f */ { 0, 0, 0, 0, 0 },
/* U+caa0 */ { 0, 0, 0, 0, 0 },
/* U+caa1 */ { 0, 0, 0, 0, 0 },
/* U+caa2 */ { 0, 0, 0, 0, 0 },
/* U+caa3 */ { 0, 0, 0, 0, 0 },
/* U+caa4 */ { 0, 0, 0, 0, 0 },
/* U+caa5 */ { 0, 0, 0, 0, 0 },
/* U+caa6 */ { 0, 0, 0, 0, 0 },
/* U+caa7 */ { 0, 0, 0, 0, 0 },
/* U+caa8 */ { 0, 0, 0, 0, 0 },
/* U+caa9 */ { 0, 0, 0, 0, 0 },
/* U+caaa */ { 0, 0, 0, 0, 0 },
/* U+caab */ { 0, 0, 0, 0, 0 },
/* U+caac */ { 0, 0, 0, 0, 0 },
/* U+caad */ { 0, 0, 0, 0, 0 },
/* U+caae */ { 0, 0, 0, 0, 0 },
/* U+caaf */ { 0, 0, 0, 0, 0 },
/* U+cab0 */ { 0, 0, 0, 0, 0 },
/* U+cab1 */ { 0, 0, 0, 0, 0 },
/* U+cab2 */ { 0, 0, 0, 0, 0 },
/* U+cab3 */ { 0, 0, 0, 0, 0 },
/* U+cab4 */ { 0, 0, 0, 0, 0 },
/* U+cab5 */ { 0, 0, 0, 0, 0 },
/* U+cab6 */ { 0, 0, 0, 0, 0 },
/* U+cab7 */ { 0, 0, 0, 0, 0 },
/* U+cab8 */ { 0, 0, 0, 0, 0 },
/* U+cab9 */ { 0, 0, 0, 0, 0 },
/* U+caba */ { 0, 0, 0, 0, 0 },
/* U+cabb */ { 0, 0, 0, 0, 0 },
/* U+cabc */ { 0, 0, 0, 0, 0 },
/* U+cabd */ { 0, 0, 0, 0, 0 },
/* U+cabe */ { 0, 0, 0, 0, 0 },
/* U+cabf */ { 0, 0, 0, 0, 0 },
/* U+cac0 */ { 0, 0, 0, 0, 0 },
/* U+cac1 */ { 0, 0, 0, 0, 0 },
/* U+cac2 */ { 0, 0, 0, 0, 0 },
/* U+cac3 */ { 0, 0, 0, 0, 0 },
/* U+cac4 */ { 0, 0, 0, 0, 0 },
/* U+cac5 */ { 0, 0, 0, 0, 0 },
/* U+cac6 */ { 0, 0, 0, 0, 0 },
/* U+cac7 */ { 0, 0, 0, 0, 0 },
/* U+cac8 */ { 0, 0, 0, 0, 0 },
/* U+cac9 */ { 0, 0, 0, 0, 0 },
/* U+caca */ { 0, 0, 0, 0, 0 },
/* U+cacb */ { 0, 0, 0, 0, 0 },
/* U+cacc */ { 0, 0, 0, 0, 0 },
/* U+cacd */ { 0, 0, 0, 0, 0 },
/* U+cace */ { 0, 0, 0, 0, 0 },
/* U+cacf */ { 0, 0, 0, 0, 0 },
/* U+cad0 */ { 0, 0, 0, 0, 0 },
/* U+cad1 */ { 0, 0, 0, 0, 0 },
/* U+cad2 */ { 0, 0, 0, 0, 0 },
/* U+cad3 */ { 0, 0, 0, 0, 0 },
/* U+cad4 */ { 0, 0, 0, 0, 0 },
/* U+cad5 */ { 0, 0, 0, 0, 0 },
/* U+cad6 */ { 0, 0, 0, 0, 0 },
/* U+cad7 */ { 0, 0, 0, 0, 0 },
/* U+cad8 */ { 0, 0, 0, 0, 0 },
/* U+cad9 */ { 0, 0, 0, 0, 0 },
/* U+cada */ { 0, 0, 0, 0, 0 },
/* U+cadb */ { 0, 0, 0, 0, 0 },
/* U+cadc */ { 0, 0, 0, 0, 0 },
/* U+cadd */ { 0, 0, 0, 0, 0 },
/* U+cade */ { 0, 0, 0, 0, 0 },
/* U+cadf */ { 0, 0, 0, 0, 0 },
/* U+cae0 */ { 0, 0, 0, 0, 0 },
/* U+cae1 */ { 0, 0, 0, 0, 0 },
/* U+cae2 */ { 0, 0, 0, 0, 0 },
/* U+cae3 */ { 0, 0, 0, 0, 0 },
/* U+cae4 */ { 0, 0, 0, 0, 0 },
/* U+cae5 */ { 0, 0, 0, 0, 0 },
/* U+cae6 */ { 0, 0, 0, 0, 0 },
/* U+cae7 */ { 0, 0, 0, 0, 0 },
/* U+cae8 */ { 0, 0, 0, 0, 0 },
/* U+cae9 */ { 0, 0, 0, 0, 0 },
/* U+caea */ { 0, 0, 0, 0, 0 },
/* U+caeb */ { 0, 0, 0, 0, 0 },
/* U+caec */ { 0, 0, 0, 0, 0 },
/* U+caed */ { 0, 0, 0, 0, 0 },
/* U+caee */ { 0, 0, 0, 0, 0 },
/* U+caef */ { 0, 0, 0, 0, 0 },
/* U+caf0 */ { 0, 0, 0, 0, 0 },
/* U+caf1 */ { 0, 0, 0, 0, 0 },
/* U+caf2 */ { 0, 0, 0, 0, 0 },
/* U+caf3 */ { 0, 0, 0, 0, 0 },
/* U+caf4 */ { 0, 0, 0, 0, 0 },
/* U+caf5 */ { 0, 0, 0, 0, 0 },
/* U+caf6 */ { 0, 0, 0, 0, 0 },
/* U+caf7 */ { 0, 0, 0, 0, 0 },
/* U+caf8 */ { 0, 0, 0, 0, 0 },
/* U+caf9 */ { 0, 0, 0, 0, 0 },
/* U+cafa */ { 0, 0, 0, 0, 0 },
/* U+cafb */ { 0, 0, 0, 0, 0 },
/* U+cafc */ { 0, 0, 0, 0, 0 },
/* U+cafd */ { 0, 0, 0, 0, 0 },
/* U+cafe */ { 0, 0, 0, 0, 0 },
/* U+caff */ { 0, 0, 0, 0, 0 },
/* U+cb00 */ { 0, 0, 0, 0, 0 },
/* U+cb01 */ { 0, 0, 0, 0, 0 },
/* U+cb02 */ { 0, 0, 0, 0, 0 },
/* U+cb03 */ { 0, 0, 0, 0, 0 },
/* U+cb04 */ { 0, 0, 0, 0, 0 },
/* U+cb05 */ { 0, 0, 0, 0, 0 },
/* U+cb06 */ { 0, 0, 0, 0, 0 },
/* U+cb07 */ { 0, 0, 0, 0, 0 },
/* U+cb08 */ { 0, 0, 0, 0, 0 },
/* U+cb09 */ { 0, 0, 0, 0, 0 },
/* U+cb0a */ { 0, 0, 0, 0, 0 },
/* U+cb0b */ { 0, 0, 0, 0, 0 },
/* U+cb0c */ { 0, 0, 0, 0, 0 },
/* U+cb0d */ { 0, 0, 0, 0, 0 },
/* U+cb0e */ { 0, 0, 0, 0, 0 },
/* U+cb0f */ { 0, 0, 0, 0, 0 },
/* U+cb10 */ { 0, 0, 0, 0, 0 },
/* U+cb11 */ { 0, 0, 0, 0, 0 },
/* U+cb12 */ { 0, 0, 0, 0, 0 },
/* U+cb13 */ { 0, 0, 0, 0, 0 },
/* U+cb14 */ { 0, 0, 0, 0, 0 },
/* U+cb15 */ { 0, 0, 0, 0, 0 },
/* U+cb16 */ { 0, 0, 0, 0, 0 },
/* U+cb17 */ { 0, 0, 0, 0, 0 },
/* U+cb18 */ { 0, 0, 0, 0, 0 },
/* U+cb19 */ { 0, 0, 0, 0, 0 },
/* U+cb1a */ { 0, 0, 0, 0, 0 },
/* U+cb1b */ { 0, 0, 0, 0, 0 },
/* U+cb1c */ { 0, 0, 0, 0, 0 },
/* U+cb1d */ { 0, 0, 0, 0, 0 },
/* U+cb1e */ { 0, 0, 0, 0, 0 },
/* U+cb1f */ { 0, 0, 0, 0, 0 },
/* U+cb20 */ { 0, 0, 0, 0, 0 },
/* U+cb21 */ { 0, 0, 0, 0, 0 },
/* U+cb22 */ { 0, 0, 0, 0, 0 },
/* U+cb23 */ { 0, 0, 0, 0, 0 },
/* U+cb24 */ { 0, 0, 0, 0, 0 },
/* U+cb25 */ { 0, 0, 0, 0, 0 },
/* U+cb26 */ { 0, 0, 0, 0, 0 },
/* U+cb27 */ { 0, 0, 0, 0, 0 },
/* U+cb28 */ { 0, 0, 0, 0, 0 },
/* U+cb29 */ { 0, 0, 0, 0, 0 },
/* U+cb2a */ { 0, 0, 0, 0, 0 },
/* U+cb2b */ { 0, 0, 0, 0, 0 },
/* U+cb2c */ { 0, 0, 0, 0, 0 },
/* U+cb2d */ { 0, 0, 0, 0, 0 },
/* U+cb2e */ { 0, 0, 0, 0, 0 },
/* U+cb2f */ { 0, 0, 0, 0, 0 },
/* U+cb30 */ { 0, 0, 0, 0, 0 },
/* U+cb31 */ { 0, 0, 0, 0, 0 },
/* U+cb32 */ { 0, 0, 0, 0, 0 },
/* U+cb33 */ { 0, 0, 0, 0, 0 },
/* U+cb34 */ { 0, 0, 0, 0, 0 },
/* U+cb35 */ { 0, 0, 0, 0, 0 },
/* U+cb36 */ { 0, 0, 0, 0, 0 },
/* U+cb37 */ { 0, 0, 0, 0, 0 },
/* U+cb38 */ { 0, 0, 0, 0, 0 },
/* U+cb39 */ { 0, 0, 0, 0, 0 },
/* U+cb3a */ { 0, 0, 0, 0, 0 },
/* U+cb3b */ { 0, 0, 0, 0, 0 },
/* U+cb3c */ { 0, 0, 0, 0, 0 },
/* U+cb3d */ { 0, 0, 0, 0, 0 },
/* U+cb3e */ { 0, 0, 0, 0, 0 },
/* U+cb3f */ { 0, 0, 0, 0, 0 },
/* U+cb40 */ { 0, 0, 0, 0, 0 },
/* U+cb41 */ { 0, 0, 0, 0, 0 },
/* U+cb42 */ { 0, 0, 0, 0, 0 },
/* U+cb43 */ { 0, 0, 0, 0, 0 },
/* U+cb44 */ { 0, 0, 0, 0, 0 },
/* U+cb45 */ { 0, 0, 0, 0, 0 },
/* U+cb46 */ { 0, 0, 0, 0, 0 },
/* U+cb47 */ { 0, 0, 0, 0, 0 },
/* U+cb48 */ { 0, 0, 0, 0, 0 },
/* U+cb49 */ { 0, 0, 0, 0, 0 },
/* U+cb4a */ { 0, 0, 0, 0, 0 },
/* U+cb4b */ { 0, 0, 0, 0, 0 },
/* U+cb4c */ { 0, 0, 0, 0, 0 },
/* U+cb4d */ { 0, 0, 0, 0, 0 },
/* U+cb4e */ { 0, 0, 0, 0, 0 },
/* U+cb4f */ { 0, 0, 0, 0, 0 },
/* U+cb50 */ { 0, 0, 0, 0, 0 },
/* U+cb51 */ { 0, 0, 0, 0, 0 },
/* U+cb52 */ { 0, 0, 0, 0, 0 },
/* U+cb53 */ { 0, 0, 0, 0, 0 },
/* U+cb54 */ { 0, 0, 0, 0, 0 },
/* U+cb55 */ { 0, 0, 0, 0, 0 },
/* U+cb56 */ { 0, 0, 0, 0, 0 },
/* U+cb57 */ { 0, 0, 0, 0, 0 },
/* U+cb58 */ { 0, 0, 0, 0, 0 },
/* U+cb59 */ { 0, 0, 0, 0, 0 },
/* U+cb5a */ { 0, 0, 0, 0, 0 },
/* U+cb5b */ { 0, 0, 0, 0, 0 },
/* U+cb5c */ { 0, 0, 0, 0, 0 },
/* U+cb5d */ { 0, 0, 0, 0, 0 },
/* U+cb5e */ { 0, 0, 0, 0, 0 },
/* U+cb5f */ { 0, 0, 0, 0, 0 },
/* U+cb60 */ { 0, 0, 0, 0, 0 },
/* U+cb61 */ { 0, 0, 0, 0, 0 },
/* U+cb62 */ { 0, 0, 0, 0, 0 },
/* U+cb63 */ { 0, 0, 0, 0, 0 },
/* U+cb64 */ { 0, 0, 0, 0, 0 },
/* U+cb65 */ { 0, 0, 0, 0, 0 },
/* U+cb66 */ { 0, 0, 0, 0, 0 },
/* U+cb67 */ { 0, 0, 0, 0, 0 },
/* U+cb68 */ { 0, 0, 0, 0, 0 },
/* U+cb69 */ { 0, 0, 0, 0, 0 },
/* U+cb6a */ { 0, 0, 0, 0, 0 },
/* U+cb6b */ { 0, 0, 0, 0, 0 },
/* U+cb6c */ { 0, 0, 0, 0, 0 },
/* U+cb6d */ { 0, 0, 0, 0, 0 },
/* U+cb6e */ { 0, 0, 0, 0, 0 },
/* U+cb6f */ { 0, 0, 0, 0, 0 },
/* U+cb70 */ { 0, 0, 0, 0, 0 },
/* U+cb71 */ { 0, 0, 0, 0, 0 },
/* U+cb72 */ { 0, 0, 0, 0, 0 },
/* U+cb73 */ { 0, 0, 0, 0, 0 },
/* U+cb74 */ { 0, 0, 0, 0, 0 },
/* U+cb75 */ { 0, 0, 0, 0, 0 },
/* U+cb76 */ { 0, 0, 0, 0, 0 },
/* U+cb77 */ { 0, 0, 0, 0, 0 },
/* U+cb78 */ { 0, 0, 0, 0, 0 },
/* U+cb79 */ { 0, 0, 0, 0, 0 },
/* U+cb7a */ { 0, 0, 0, 0, 0 },
/* U+cb7b */ { 0, 0, 0, 0, 0 },
/* U+cb7c */ { 0, 0, 0, 0, 0 },
/* U+cb7d */ { 0, 0, 0, 0, 0 },
/* U+cb7e */ { 0, 0, 0, 0, 0 },
/* U+cb7f */ { 0, 0, 0, 0, 0 },
/* U+cb80 */ { 0, 0, 0, 0, 0 },
/* U+cb81 */ { 0, 0, 0, 0, 0 },
/* U+cb82 */ { 0, 0, 0, 0, 0 },
/* U+cb83 */ { 0, 0, 0, 0, 0 },
/* U+cb84 */ { 0, 0, 0, 0, 0 },
/* U+cb85 */ { 0, 0, 0, 0, 0 },
/* U+cb86 */ { 0, 0, 0, 0, 0 },
/* U+cb87 */ { 0, 0, 0, 0, 0 },
/* U+cb88 */ { 0, 0, 0, 0, 0 },
/* U+cb89 */ { 0, 0, 0, 0, 0 },
/* U+cb8a */ { 0, 0, 0, 0, 0 },
/* U+cb8b */ { 0, 0, 0, 0, 0 },
/* U+cb8c */ { 0, 0, 0, 0, 0 },
/* U+cb8d */ { 0, 0, 0, 0, 0 },
/* U+cb8e */ { 0, 0, 0, 0, 0 },
/* U+cb8f */ { 0, 0, 0, 0, 0 },
/* U+cb90 */ { 0, 0, 0, 0, 0 },
/* U+cb91 */ { 0, 0, 0, 0, 0 },
/* U+cb92 */ { 0, 0, 0, 0, 0 },
/* U+cb93 */ { 0, 0, 0, 0, 0 },
/* U+cb94 */ { 0, 0, 0, 0, 0 },
/* U+cb95 */ { 0, 0, 0, 0, 0 },
/* U+cb96 */ { 0, 0, 0, 0, 0 },
/* U+cb97 */ { 0, 0, 0, 0, 0 },
/* U+cb98 */ { 0, 0, 0, 0, 0 },
/* U+cb99 */ { 0, 0, 0, 0, 0 },
/* U+cb9a */ { 0, 0, 0, 0, 0 },
/* U+cb9b */ { 0, 0, 0, 0, 0 },
/* U+cb9c */ { 0, 0, 0, 0, 0 },
/* U+cb9d */ { 0, 0, 0, 0, 0 },
/* U+cb9e */ { 0, 0, 0, 0, 0 },
/* U+cb9f */ { 0, 0, 0, 0, 0 },
/* U+cba0 */ { 0, 0, 0, 0, 0 },
/* U+cba1 */ { 0, 0, 0, 0, 0 },
/* U+cba2 */ { 0, 0, 0, 0, 0 },
/* U+cba3 */ { 0, 0, 0, 0, 0 },
/* U+cba4 */ { 0, 0, 0, 0, 0 },
/* U+cba5 */ { 0, 0, 0, 0, 0 },
/* U+cba6 */ { 0, 0, 0, 0, 0 },
/* U+cba7 */ { 0, 0, 0, 0, 0 },
/* U+cba8 */ { 0, 0, 0, 0, 0 },
/* U+cba9 */ { 0, 0, 0, 0, 0 },
/* U+cbaa */ { 0, 0, 0, 0, 0 },
/* U+cbab */ { 0, 0, 0, 0, 0 },
/* U+cbac */ { 0, 0, 0, 0, 0 },
/* U+cbad */ { 0, 0, 0, 0, 0 },
/* U+cbae */ { 0, 0, 0, 0, 0 },
/* U+cbaf */ { 0, 0, 0, 0, 0 },
/* U+cbb0 */ { 0, 0, 0, 0, 0 },
/* U+cbb1 */ { 0, 0, 0, 0, 0 },
/* U+cbb2 */ { 0, 0, 0, 0, 0 },
/* U+cbb3 */ { 0, 0, 0, 0, 0 },
/* U+cbb4 */ { 0, 0, 0, 0, 0 },
/* U+cbb5 */ { 0, 0, 0, 0, 0 },
/* U+cbb6 */ { 0, 0, 0, 0, 0 },
/* U+cbb7 */ { 0, 0, 0, 0, 0 },
/* U+cbb8 */ { 0, 0, 0, 0, 0 },
/* U+cbb9 */ { 0, 0, 0, 0, 0 },
/* U+cbba */ { 0, 0, 0, 0, 0 },
/* U+cbbb */ { 0, 0, 0, 0, 0 },
/* U+cbbc */ { 0, 0, 0, 0, 0 },
/* U+cbbd */ { 0, 0, 0, 0, 0 },
/* U+cbbe */ { 0, 0, 0, 0, 0 },
/* U+cbbf */ { 0, 0, 0, 0, 0 },
/* U+cbc0 */ { 0, 0, 0, 0, 0 },
/* U+cbc1 */ { 0, 0, 0, 0, 0 },
/* U+cbc2 */ { 0, 0, 0, 0, 0 },
/* U+cbc3 */ { 0, 0, 0, 0, 0 },
/* U+cbc4 */ { 0, 0, 0, 0, 0 },
/* U+cbc5 */ { 0, 0, 0, 0, 0 },
/* U+cbc6 */ { 0, 0, 0, 0, 0 },
/* U+cbc7 */ { 0, 0, 0, 0, 0 },
/* U+cbc8 */ { 0, 0, 0, 0, 0 },
/* U+cbc9 */ { 0, 0, 0, 0, 0 },
/* U+cbca */ { 0, 0, 0, 0, 0 },
/* U+cbcb */ { 0, 0, 0, 0, 0 },
/* U+cbcc */ { 0, 0, 0, 0, 0 },
/* U+cbcd */ { 0, 0, 0, 0, 0 },
/* U+cbce */ { 0, 0, 0, 0, 0 },
/* U+cbcf */ { 0, 0, 0, 0, 0 },
/* U+cbd0 */ { 0, 0, 0, 0, 0 },
/* U+cbd1 */ { 0, 0, 0, 0, 0 },
/* U+cbd2 */ { 0, 0, 0, 0, 0 },
/* U+cbd3 */ { 0, 0, 0, 0, 0 },
/* U+cbd4 */ { 0, 0, 0, 0, 0 },
/* U+cbd5 */ { 0, 0, 0, 0, 0 },
/* U+cbd6 */ { 0, 0, 0, 0, 0 },
/* U+cbd7 */ { 0, 0, 0, 0, 0 },
/* U+cbd8 */ { 0, 0, 0, 0, 0 },
/* U+cbd9 */ { 0, 0, 0, 0, 0 },
/* U+cbda */ { 0, 0, 0, 0, 0 },
/* U+cbdb */ { 0, 0, 0, 0, 0 },
/* U+cbdc */ { 0, 0, 0, 0, 0 },
/* U+cbdd */ { 0, 0, 0, 0, 0 },
/* U+cbde */ { 0, 0, 0, 0, 0 },
/* U+cbdf */ { 0, 0, 0, 0, 0 },
/* U+cbe0 */ { 0, 0, 0, 0, 0 },
/* U+cbe1 */ { 0, 0, 0, 0, 0 },
/* U+cbe2 */ { 0, 0, 0, 0, 0 },
/* U+cbe3 */ { 0, 0, 0, 0, 0 },
/* U+cbe4 */ { 0, 0, 0, 0, 0 },
/* U+cbe5 */ { 0, 0, 0, 0, 0 },
/* U+cbe6 */ { 0, 0, 0, 0, 0 },
/* U+cbe7 */ { 0, 0, 0, 0, 0 },
/* U+cbe8 */ { 0, 0, 0, 0, 0 },
/* U+cbe9 */ { 0, 0, 0, 0, 0 },
/* U+cbea */ { 0, 0, 0, 0, 0 },
/* U+cbeb */ { 0, 0, 0, 0, 0 },
/* U+cbec */ { 0, 0, 0, 0, 0 },
/* U+cbed */ { 0, 0, 0, 0, 0 },
/* U+cbee */ { 0, 0, 0, 0, 0 },
/* U+cbef */ { 0, 0, 0, 0, 0 },
/* U+cbf0 */ { 0, 0, 0, 0, 0 },
/* U+cbf1 */ { 0, 0, 0, 0, 0 },
/* U+cbf2 */ { 0, 0, 0, 0, 0 },
/* U+cbf3 */ { 0, 0, 0, 0, 0 },
/* U+cbf4 */ { 0, 0, 0, 0, 0 },
/* U+cbf5 */ { 0, 0, 0, 0, 0 },
/* U+cbf6 */ { 0, 0, 0, 0, 0 },
/* U+cbf7 */ { 0, 0, 0, 0, 0 },
/* U+cbf8 */ { 0, 0, 0, 0, 0 },
/* U+cbf9 */ { 0, 0, 0, 0, 0 },
/* U+cbfa */ { 0, 0, 0, 0, 0 },
/* U+cbfb */ { 0, 0, 0, 0, 0 },
/* U+cbfc */ { 0, 0, 0, 0, 0 },
/* U+cbfd */ { 0, 0, 0, 0, 0 },
/* U+cbfe */ { 0, 0, 0, 0, 0 },
/* U+cbff */ { 0, 0, 0, 0, 0 },
/* U+cc00 */ { 0, 0, 0, 0, 0 },
/* U+cc01 */ { 0, 0, 0, 0, 0 },
/* U+cc02 */ { 0, 0, 0, 0, 0 },
/* U+cc03 */ { 0, 0, 0, 0, 0 },
/* U+cc04 */ { 0, 0, 0, 0, 0 },
/* U+cc05 */ { 0, 0, 0, 0, 0 },
/* U+cc06 */ { 0, 0, 0, 0, 0 },
/* U+cc07 */ { 0, 0, 0, 0, 0 },
/* U+cc08 */ { 0, 0, 0, 0, 0 },
/* U+cc09 */ { 0, 0, 0, 0, 0 },
/* U+cc0a */ { 0, 0, 0, 0, 0 },
/* U+cc0b */ { 0, 0, 0, 0, 0 },
/* U+cc0c */ { 0, 0, 0, 0, 0 },
/* U+cc0d */ { 0, 0, 0, 0, 0 },
/* U+cc0e */ { 0, 0, 0, 0, 0 },
/* U+cc0f */ { 0, 0, 0, 0, 0 },
/* U+cc10 */ { 0, 0, 0, 0, 0 },
/* U+cc11 */ { 0, 0, 0, 0, 0 },
/* U+cc12 */ { 0, 0, 0, 0, 0 },
/* U+cc13 */ { 0, 0, 0, 0, 0 },
/* U+cc14 */ { 0, 0, 0, 0, 0 },
/* U+cc15 */ { 0, 0, 0, 0, 0 },
/* U+cc16 */ { 0, 0, 0, 0, 0 },
/* U+cc17 */ { 0, 0, 0, 0, 0 },
/* U+cc18 */ { 0, 0, 0, 0, 0 },
/* U+cc19 */ { 0, 0, 0, 0, 0 },
/* U+cc1a */ { 0, 0, 0, 0, 0 },
/* U+cc1b */ { 0, 0, 0, 0, 0 },
/* U+cc1c */ { 0, 0, 0, 0, 0 },
/* U+cc1d */ { 0, 0, 0, 0, 0 },
/* U+cc1e */ { 0, 0, 0, 0, 0 },
/* U+cc1f */ { 0, 0, 0, 0, 0 },
/* U+cc20 */ { 0, 0, 0, 0, 0 },
/* U+cc21 */ { 0, 0, 0, 0, 0 },
/* U+cc22 */ { 0, 0, 0, 0, 0 },
/* U+cc23 */ { 0, 0, 0, 0, 0 },
/* U+cc24 */ { 0, 0, 0, 0, 0 },
/* U+cc25 */ { 0, 0, 0, 0, 0 },
/* U+cc26 */ { 0, 0, 0, 0, 0 },
/* U+cc27 */ { 0, 0, 0, 0, 0 },
/* U+cc28 */ { 0, 0, 0, 0, 0 },
/* U+cc29 */ { 0, 0, 0, 0, 0 },
/* U+cc2a */ { 0, 0, 0, 0, 0 },
/* U+cc2b */ { 0, 0, 0, 0, 0 },
/* U+cc2c */ { 0, 0, 0, 0, 0 },
/* U+cc2d */ { 0, 0, 0, 0, 0 },
/* U+cc2e */ { 0, 0, 0, 0, 0 },
/* U+cc2f */ { 0, 0, 0, 0, 0 },
/* U+cc30 */ { 0, 0, 0, 0, 0 },
/* U+cc31 */ { 0, 0, 0, 0, 0 },
/* U+cc32 */ { 0, 0, 0, 0, 0 },
/* U+cc33 */ { 0, 0, 0, 0, 0 },
/* U+cc34 */ { 0, 0, 0, 0, 0 },
/* U+cc35 */ { 0, 0, 0, 0, 0 },
/* U+cc36 */ { 0, 0, 0, 0, 0 },
/* U+cc37 */ { 0, 0, 0, 0, 0 },
/* U+cc38 */ { 0, 0, 0, 0, 0 },
/* U+cc39 */ { 0, 0, 0, 0, 0 },
/* U+cc3a */ { 0, 0, 0, 0, 0 },
/* U+cc3b */ { 0, 0, 0, 0, 0 },
/* U+cc3c */ { 0, 0, 0, 0, 0 },
/* U+cc3d */ { 0, 0, 0, 0, 0 },
/* U+cc3e */ { 0, 0, 0, 0, 0 },
/* U+cc3f */ { 0, 0, 0, 0, 0 },
/* U+cc40 */ { 0, 0, 0, 0, 0 },
/* U+cc41 */ { 0, 0, 0, 0, 0 },
/* U+cc42 */ { 0, 0, 0, 0, 0 },
/* U+cc43 */ { 0, 0, 0, 0, 0 },
/* U+cc44 */ { 0, 0, 0, 0, 0 },
/* U+cc45 */ { 0, 0, 0, 0, 0 },
/* U+cc46 */ { 0, 0, 0, 0, 0 },
/* U+cc47 */ { 0, 0, 0, 0, 0 },
/* U+cc48 */ { 0, 0, 0, 0, 0 },
/* U+cc49 */ { 0, 0, 0, 0, 0 },
/* U+cc4a */ { 0, 0, 0, 0, 0 },
/* U+cc4b */ { 0, 0, 0, 0, 0 },
/* U+cc4c */ { 0, 0, 0, 0, 0 },
/* U+cc4d */ { 0, 0, 0, 0, 0 },
/* U+cc4e */ { 0, 0, 0, 0, 0 },
/* U+cc4f */ { 0, 0, 0, 0, 0 },
/* U+cc50 */ { 0, 0, 0, 0, 0 },
/* U+cc51 */ { 0, 0, 0, 0, 0 },
/* U+cc52 */ { 0, 0, 0, 0, 0 },
/* U+cc53 */ { 0, 0, 0, 0, 0 },
/* U+cc54 */ { 0, 0, 0, 0, 0 },
/* U+cc55 */ { 0, 0, 0, 0, 0 },
/* U+cc56 */ { 0, 0, 0, 0, 0 },
/* U+cc57 */ { 0, 0, 0, 0, 0 },
/* U+cc58 */ { 0, 0, 0, 0, 0 },
/* U+cc59 */ { 0, 0, 0, 0, 0 },
/* U+cc5a */ { 0, 0, 0, 0, 0 },
/* U+cc5b */ { 0, 0, 0, 0, 0 },
/* U+cc5c */ { 0, 0, 0, 0, 0 },
/* U+cc5d */ { 0, 0, 0, 0, 0 },
/* U+cc5e */ { 0, 0, 0, 0, 0 },
/* U+cc5f */ { 0, 0, 0, 0, 0 },
/* U+cc60 */ { 0, 0, 0, 0, 0 },
/* U+cc61 */ { 0, 0, 0, 0, 0 },
/* U+cc62 */ { 0, 0, 0, 0, 0 },
/* U+cc63 */ { 0, 0, 0, 0, 0 },
/* U+cc64 */ { 0, 0, 0, 0, 0 },
/* U+cc65 */ { 0, 0, 0, 0, 0 },
/* U+cc66 */ { 0, 0, 0, 0, 0 },
/* U+cc67 */ { 0, 0, 0, 0, 0 },
/* U+cc68 */ { 0, 0, 0, 0, 0 },
/* U+cc69 */ { 0, 0, 0, 0, 0 },
/* U+cc6a */ { 0, 0, 0, 0, 0 },
/* U+cc6b */ { 0, 0, 0, 0, 0 },
/* U+cc6c */ { 0, 0, 0, 0, 0 },
/* U+cc6d */ { 0, 0, 0, 0, 0 },
/* U+cc6e */ { 0, 0, 0, 0, 0 },
/* U+cc6f */ { 0, 0, 0, 0, 0 },
/* U+cc70 */ { 0, 0, 0, 0, 0 },
/* U+cc71 */ { 0, 0, 0, 0, 0 },
/* U+cc72 */ { 0, 0, 0, 0, 0 },
/* U+cc73 */ { 0, 0, 0, 0, 0 },
/* U+cc74 */ { 0, 0, 0, 0, 0 },
/* U+cc75 */ { 0, 0, 0, 0, 0 },
/* U+cc76 */ { 0, 0, 0, 0, 0 },
/* U+cc77 */ { 0, 0, 0, 0, 0 },
/* U+cc78 */ { 0, 0, 0, 0, 0 },
/* U+cc79 */ { 0, 0, 0, 0, 0 },
/* U+cc7a */ { 0, 0, 0, 0, 0 },
/* U+cc7b */ { 0, 0, 0, 0, 0 },
/* U+cc7c */ { 0, 0, 0, 0, 0 },
/* U+cc7d */ { 0, 0, 0, 0, 0 },
/* U+cc7e */ { 0, 0, 0, 0, 0 },
/* U+cc7f */ { 0, 0, 0, 0, 0 },
/* U+cc80 */ { 0, 0, 0, 0, 0 },
/* U+cc81 */ { 0, 0, 0, 0, 0 },
/* U+cc82 */ { 0, 0, 0, 0, 0 },
/* U+cc83 */ { 0, 0, 0, 0, 0 },
/* U+cc84 */ { 0, 0, 0, 0, 0 },
/* U+cc85 */ { 0, 0, 0, 0, 0 },
/* U+cc86 */ { 0, 0, 0, 0, 0 },
/* U+cc87 */ { 0, 0, 0, 0, 0 },
/* U+cc88 */ { 0, 0, 0, 0, 0 },
/* U+cc89 */ { 0, 0, 0, 0, 0 },
/* U+cc8a */ { 0, 0, 0, 0, 0 },
/* U+cc8b */ { 0, 0, 0, 0, 0 },
/* U+cc8c */ { 0, 0, 0, 0, 0 },
/* U+cc8d */ { 0, 0, 0, 0, 0 },
/* U+cc8e */ { 0, 0, 0, 0, 0 },
/* U+cc8f */ { 0, 0, 0, 0, 0 },
/* U+cc90 */ { 0, 0, 0, 0, 0 },
/* U+cc91 */ { 0, 0, 0, 0, 0 },
/* U+cc92 */ { 0, 0, 0, 0, 0 },
/* U+cc93 */ { 0, 0, 0, 0, 0 },
/* U+cc94 */ { 0, 0, 0, 0, 0 },
/* U+cc95 */ { 0, 0, 0, 0, 0 },
/* U+cc96 */ { 0, 0, 0, 0, 0 },
/* U+cc97 */ { 0, 0, 0, 0, 0 },
/* U+cc98 */ { 0, 0, 0, 0, 0 },
/* U+cc99 */ { 0, 0, 0, 0, 0 },
/* U+cc9a */ { 0, 0, 0, 0, 0 },
/* U+cc9b */ { 0, 0, 0, 0, 0 },
/* U+cc9c */ { 0, 0, 0, 0, 0 },
/* U+cc9d */ { 0, 0, 0, 0, 0 },
/* U+cc9e */ { 0, 0, 0, 0, 0 },
/* U+cc9f */ { 0, 0, 0, 0, 0 },
/* U+cca0 */ { 0, 0, 0, 0, 0 },
/* U+cca1 */ { 0, 0, 0, 0, 0 },
/* U+cca2 */ { 0, 0, 0, 0, 0 },
/* U+cca3 */ { 0, 0, 0, 0, 0 },
/* U+cca4 */ { 0, 0, 0, 0, 0 },
/* U+cca5 */ { 0, 0, 0, 0, 0 },
/* U+cca6 */ { 0, 0, 0, 0, 0 },
/* U+cca7 */ { 0, 0, 0, 0, 0 },
/* U+cca8 */ { 0, 0, 0, 0, 0 },
/* U+cca9 */ { 0, 0, 0, 0, 0 },
/* U+ccaa */ { 0, 0, 0, 0, 0 },
/* U+ccab */ { 0, 0, 0, 0, 0 },
/* U+ccac */ { 0, 0, 0, 0, 0 },
/* U+ccad */ { 0, 0, 0, 0, 0 },
/* U+ccae */ { 0, 0, 0, 0, 0 },
/* U+ccaf */ { 0, 0, 0, 0, 0 },
/* U+ccb0 */ { 0, 0, 0, 0, 0 },
/* U+ccb1 */ { 0, 0, 0, 0, 0 },
/* U+ccb2 */ { 0, 0, 0, 0, 0 },
/* U+ccb3 */ { 0, 0, 0, 0, 0 },
/* U+ccb4 */ { 0, 0, 0, 0, 0 },
/* U+ccb5 */ { 0, 0, 0, 0, 0 },
/* U+ccb6 */ { 0, 0, 0, 0, 0 },
/* U+ccb7 */ { 0, 0, 0, 0, 0 },
/* U+ccb8 */ { 0, 0, 0, 0, 0 },
/* U+ccb9 */ { 0, 0, 0, 0, 0 },
/* U+ccba */ { 0, 0, 0, 0, 0 },
/* U+ccbb */ { 0, 0, 0, 0, 0 },
/* U+ccbc */ { 0, 0, 0, 0, 0 },
/* U+ccbd */ { 0, 0, 0, 0, 0 },
/* U+ccbe */ { 0, 0, 0, 0, 0 },
/* U+ccbf */ { 0, 0, 0, 0, 0 },
/* U+ccc0 */ { 0, 0, 0, 0, 0 },
/* U+ccc1 */ { 0, 0, 0, 0, 0 },
/* U+ccc2 */ { 0, 0, 0, 0, 0 },
/* U+ccc3 */ { 0, 0, 0, 0, 0 },
/* U+ccc4 */ { 0, 0, 0, 0, 0 },
/* U+ccc5 */ { 0, 0, 0, 0, 0 },
/* U+ccc6 */ { 0, 0, 0, 0, 0 },
/* U+ccc7 */ { 0, 0, 0, 0, 0 },
/* U+ccc8 */ { 0, 0, 0, 0, 0 },
/* U+ccc9 */ { 0, 0, 0, 0, 0 },
/* U+ccca */ { 0, 0, 0, 0, 0 },
/* U+cccb */ { 0, 0, 0, 0, 0 },
/* U+cccc */ { 0, 0, 0, 0, 0 },
/* U+cccd */ { 0, 0, 0, 0, 0 },
/* U+ccce */ { 0, 0, 0, 0, 0 },
/* U+cccf */ { 0, 0, 0, 0, 0 },
/* U+ccd0 */ { 0, 0, 0, 0, 0 },
/* U+ccd1 */ { 0, 0, 0, 0, 0 },
/* U+ccd2 */ { 0, 0, 0, 0, 0 },
/* U+ccd3 */ { 0, 0, 0, 0, 0 },
/* U+ccd4 */ { 0, 0, 0, 0, 0 },
/* U+ccd5 */ { 0, 0, 0, 0, 0 },
/* U+ccd6 */ { 0, 0, 0, 0, 0 },
/* U+ccd7 */ { 0, 0, 0, 0, 0 },
/* U+ccd8 */ { 0, 0, 0, 0, 0 },
/* U+ccd9 */ { 0, 0, 0, 0, 0 },
/* U+ccda */ { 0, 0, 0, 0, 0 },
/* U+ccdb */ { 0, 0, 0, 0, 0 },
/* U+ccdc */ { 0, 0, 0, 0, 0 },
/* U+ccdd */ { 0, 0, 0, 0, 0 },
/* U+ccde */ { 0, 0, 0, 0, 0 },
/* U+ccdf */ { 0, 0, 0, 0, 0 },
/* U+cce0 */ { 0, 0, 0, 0, 0 },
/* U+cce1 */ { 0, 0, 0, 0, 0 },
/* U+cce2 */ { 0, 0, 0, 0, 0 },
/* U+cce3 */ { 0, 0, 0, 0, 0 },
/* U+cce4 */ { 0, 0, 0, 0, 0 },
/* U+cce5 */ { 0, 0, 0, 0, 0 },
/* U+cce6 */ { 0, 0, 0, 0, 0 },
/* U+cce7 */ { 0, 0, 0, 0, 0 },
/* U+cce8 */ { 0, 0, 0, 0, 0 },
/* U+cce9 */ { 0, 0, 0, 0, 0 },
/* U+ccea */ { 0, 0, 0, 0, 0 },
/* U+cceb */ { 0, 0, 0, 0, 0 },
/* U+ccec */ { 0, 0, 0, 0, 0 },
/* U+cced */ { 0, 0, 0, 0, 0 },
/* U+ccee */ { 0, 0, 0, 0, 0 },
/* U+ccef */ { 0, 0, 0, 0, 0 },
/* U+ccf0 */ { 0, 0, 0, 0, 0 },
/* U+ccf1 */ { 0, 0, 0, 0, 0 },
/* U+ccf2 */ { 0, 0, 0, 0, 0 },
/* U+ccf3 */ { 0, 0, 0, 0, 0 },
/* U+ccf4 */ { 0, 0, 0, 0, 0 },
/* U+ccf5 */ { 0, 0, 0, 0, 0 },
/* U+ccf6 */ { 0, 0, 0, 0, 0 },
/* U+ccf7 */ { 0, 0, 0, 0, 0 },
/* U+ccf8 */ { 0, 0, 0, 0, 0 },
/* U+ccf9 */ { 0, 0, 0, 0, 0 },
/* U+ccfa */ { 0, 0, 0, 0, 0 },
/* U+ccfb */ { 0, 0, 0, 0, 0 },
/* U+ccfc */ { 0, 0, 0, 0, 0 },
/* U+ccfd */ { 0, 0, 0, 0, 0 },
/* U+ccfe */ { 0, 0, 0, 0, 0 },
/* U+ccff */ { 0, 0, 0, 0, 0 },
/* U+cd00 */ { 0, 0, 0, 0, 0 },
/* U+cd01 */ { 0, 0, 0, 0, 0 },
/* U+cd02 */ { 0, 0, 0, 0, 0 },
/* U+cd03 */ { 0, 0, 0, 0, 0 },
/* U+cd04 */ { 0, 0, 0, 0, 0 },
/* U+cd05 */ { 0, 0, 0, 0, 0 },
/* U+cd06 */ { 0, 0, 0, 0, 0 },
/* U+cd07 */ { 0, 0, 0, 0, 0 },
/* U+cd08 */ { 0, 0, 0, 0, 0 },
/* U+cd09 */ { 0, 0, 0, 0, 0 },
/* U+cd0a */ { 0, 0, 0, 0, 0 },
/* U+cd0b */ { 0, 0, 0, 0, 0 },
/* U+cd0c */ { 0, 0, 0, 0, 0 },
/* U+cd0d */ { 0, 0, 0, 0, 0 },
/* U+cd0e */ { 0, 0, 0, 0, 0 },
/* U+cd0f */ { 0, 0, 0, 0, 0 },
/* U+cd10 */ { 0, 0, 0, 0, 0 },
/* U+cd11 */ { 0, 0, 0, 0, 0 },
/* U+cd12 */ { 0, 0, 0, 0, 0 },
/* U+cd13 */ { 0, 0, 0, 0, 0 },
/* U+cd14 */ { 0, 0, 0, 0, 0 },
/* U+cd15 */ { 0, 0, 0, 0, 0 },
/* U+cd16 */ { 0, 0, 0, 0, 0 },
/* U+cd17 */ { 0, 0, 0, 0, 0 },
/* U+cd18 */ { 0, 0, 0, 0, 0 },
/* U+cd19 */ { 0, 0, 0, 0, 0 },
/* U+cd1a */ { 0, 0, 0, 0, 0 },
/* U+cd1b */ { 0, 0, 0, 0, 0 },
/* U+cd1c */ { 0, 0, 0, 0, 0 },
/* U+cd1d */ { 0, 0, 0, 0, 0 },
/* U+cd1e */ { 0, 0, 0, 0, 0 },
/* U+cd1f */ { 0, 0, 0, 0, 0 },
/* U+cd20 */ { 0, 0, 0, 0, 0 },
/* U+cd21 */ { 0, 0, 0, 0, 0 },
/* U+cd22 */ { 0, 0, 0, 0, 0 },
/* U+cd23 */ { 0, 0, 0, 0, 0 },
/* U+cd24 */ { 0, 0, 0, 0, 0 },
/* U+cd25 */ { 0, 0, 0, 0, 0 },
/* U+cd26 */ { 0, 0, 0, 0, 0 },
/* U+cd27 */ { 0, 0, 0, 0, 0 },
/* U+cd28 */ { 0, 0, 0, 0, 0 },
/* U+cd29 */ { 0, 0, 0, 0, 0 },
/* U+cd2a */ { 0, 0, 0, 0, 0 },
/* U+cd2b */ { 0, 0, 0, 0, 0 },
/* U+cd2c */ { 0, 0, 0, 0, 0 },
/* U+cd2d */ { 0, 0, 0, 0, 0 },
/* U+cd2e */ { 0, 0, 0, 0, 0 },
/* U+cd2f */ { 0, 0, 0, 0, 0 },
/* U+cd30 */ { 0, 0, 0, 0, 0 },
/* U+cd31 */ { 0, 0, 0, 0, 0 },
/* U+cd32 */ { 0, 0, 0, 0, 0 },
/* U+cd33 */ { 0, 0, 0, 0, 0 },
/* U+cd34 */ { 0, 0, 0, 0, 0 },
/* U+cd35 */ { 0, 0, 0, 0, 0 },
/* U+cd36 */ { 0, 0, 0, 0, 0 },
/* U+cd37 */ { 0, 0, 0, 0, 0 },
/* U+cd38 */ { 0, 0, 0, 0, 0 },
/* U+cd39 */ { 0, 0, 0, 0, 0 },
/* U+cd3a */ { 0, 0, 0, 0, 0 },
/* U+cd3b */ { 0, 0, 0, 0, 0 },
/* U+cd3c */ { 0, 0, 0, 0, 0 },
/* U+cd3d */ { 0, 0, 0, 0, 0 },
/* U+cd3e */ { 0, 0, 0, 0, 0 },
/* U+cd3f */ { 0, 0, 0, 0, 0 },
/* U+cd40 */ { 0, 0, 0, 0, 0 },
/* U+cd41 */ { 0, 0, 0, 0, 0 },
/* U+cd42 */ { 0, 0, 0, 0, 0 },
/* U+cd43 */ { 0, 0, 0, 0, 0 },
/* U+cd44 */ { 0, 0, 0, 0, 0 },
/* U+cd45 */ { 0, 0, 0, 0, 0 },
/* U+cd46 */ { 0, 0, 0, 0, 0 },
/* U+cd47 */ { 0, 0, 0, 0, 0 },
/* U+cd48 */ { 0, 0, 0, 0, 0 },
/* U+cd49 */ { 0, 0, 0, 0, 0 },
/* U+cd4a */ { 0, 0, 0, 0, 0 },
/* U+cd4b */ { 0, 0, 0, 0, 0 },
/* U+cd4c */ { 0, 0, 0, 0, 0 },
/* U+cd4d */ { 0, 0, 0, 0, 0 },
/* U+cd4e */ { 0, 0, 0, 0, 0 },
/* U+cd4f */ { 0, 0, 0, 0, 0 },
/* U+cd50 */ { 0, 0, 0, 0, 0 },
/* U+cd51 */ { 0, 0, 0, 0, 0 },
/* U+cd52 */ { 0, 0, 0, 0, 0 },
/* U+cd53 */ { 0, 0, 0, 0, 0 },
/* U+cd54 */ { 0, 0, 0, 0, 0 },
/* U+cd55 */ { 0, 0, 0, 0, 0 },
/* U+cd56 */ { 0, 0, 0, 0, 0 },
/* U+cd57 */ { 0, 0, 0, 0, 0 },
/* U+cd58 */ { 0, 0, 0, 0, 0 },
/* U+cd59 */ { 0, 0, 0, 0, 0 },
/* U+cd5a */ { 0, 0, 0, 0, 0 },
/* U+cd5b */ { 0, 0, 0, 0, 0 },
/* U+cd5c */ { 0, 0, 0, 0, 0 },
/* U+cd5d */ { 0, 0, 0, 0, 0 },
/* U+cd5e */ { 0, 0, 0, 0, 0 },
/* U+cd5f */ { 0, 0, 0, 0, 0 },
/* U+cd60 */ { 0, 0, 0, 0, 0 },
/* U+cd61 */ { 0, 0, 0, 0, 0 },
/* U+cd62 */ { 0, 0, 0, 0, 0 },
/* U+cd63 */ { 0, 0, 0, 0, 0 },
/* U+cd64 */ { 0, 0, 0, 0, 0 },
/* U+cd65 */ { 0, 0, 0, 0, 0 },
/* U+cd66 */ { 0, 0, 0, 0, 0 },
/* U+cd67 */ { 0, 0, 0, 0, 0 },
/* U+cd68 */ { 0, 0, 0, 0, 0 },
/* U+cd69 */ { 0, 0, 0, 0, 0 },
/* U+cd6a */ { 0, 0, 0, 0, 0 },
/* U+cd6b */ { 0, 0, 0, 0, 0 },
/* U+cd6c */ { 0, 0, 0, 0, 0 },
/* U+cd6d */ { 0, 0, 0, 0, 0 },
/* U+cd6e */ { 0, 0, 0, 0, 0 },
/* U+cd6f */ { 0, 0, 0, 0, 0 },
/* U+cd70 */ { 0, 0, 0, 0, 0 },
/* U+cd71 */ { 0, 0, 0, 0, 0 },
/* U+cd72 */ { 0, 0, 0, 0, 0 },
/* U+cd73 */ { 0, 0, 0, 0, 0 },
/* U+cd74 */ { 0, 0, 0, 0, 0 },
/* U+cd75 */ { 0, 0, 0, 0, 0 },
/* U+cd76 */ { 0, 0, 0, 0, 0 },
/* U+cd77 */ { 0, 0, 0, 0, 0 },
/* U+cd78 */ { 0, 0, 0, 0, 0 },
/* U+cd79 */ { 0, 0, 0, 0, 0 },
/* U+cd7a */ { 0, 0, 0, 0, 0 },
/* U+cd7b */ { 0, 0, 0, 0, 0 },
/* U+cd7c */ { 0, 0, 0, 0, 0 },
/* U+cd7d */ { 0, 0, 0, 0, 0 },
/* U+cd7e */ { 0, 0, 0, 0, 0 },
/* U+cd7f */ { 0, 0, 0, 0, 0 },
/* U+cd80 */ { 0, 0, 0, 0, 0 },
/* U+cd81 */ { 0, 0, 0, 0, 0 },
/* U+cd82 */ { 0, 0, 0, 0, 0 },
/* U+cd83 */ { 0, 0, 0, 0, 0 },
/* U+cd84 */ { 0, 0, 0, 0, 0 },
/* U+cd85 */ { 0, 0, 0, 0, 0 },
/* U+cd86 */ { 0, 0, 0, 0, 0 },
/* U+cd87 */ { 0, 0, 0, 0, 0 },
/* U+cd88 */ { 0, 0, 0, 0, 0 },
/* U+cd89 */ { 0, 0, 0, 0, 0 },
/* U+cd8a */ { 0, 0, 0, 0, 0 },
/* U+cd8b */ { 0, 0, 0, 0, 0 },
/* U+cd8c */ { 0, 0, 0, 0, 0 },
/* U+cd8d */ { 0, 0, 0, 0, 0 },
/* U+cd8e */ { 0, 0, 0, 0, 0 },
/* U+cd8f */ { 0, 0, 0, 0, 0 },
/* U+cd90 */ { 0, 0, 0, 0, 0 },
/* U+cd91 */ { 0, 0, 0, 0, 0 },
/* U+cd92 */ { 0, 0, 0, 0, 0 },
/* U+cd93 */ { 0, 0, 0, 0, 0 },
/* U+cd94 */ { 0, 0, 0, 0, 0 },
/* U+cd95 */ { 0, 0, 0, 0, 0 },
/* U+cd96 */ { 0, 0, 0, 0, 0 },
/* U+cd97 */ { 0, 0, 0, 0, 0 },
/* U+cd98 */ { 0, 0, 0, 0, 0 },
/* U+cd99 */ { 0, 0, 0, 0, 0 },
/* U+cd9a */ { 0, 0, 0, 0, 0 },
/* U+cd9b */ { 0, 0, 0, 0, 0 },
/* U+cd9c */ { 0, 0, 0, 0, 0 },
/* U+cd9d */ { 0, 0, 0, 0, 0 },
/* U+cd9e */ { 0, 0, 0, 0, 0 },
/* U+cd9f */ { 0, 0, 0, 0, 0 },
/* U+cda0 */ { 0, 0, 0, 0, 0 },
/* U+cda1 */ { 0, 0, 0, 0, 0 },
/* U+cda2 */ { 0, 0, 0, 0, 0 },
/* U+cda3 */ { 0, 0, 0, 0, 0 },
/* U+cda4 */ { 0, 0, 0, 0, 0 },
/* U+cda5 */ { 0, 0, 0, 0, 0 },
/* U+cda6 */ { 0, 0, 0, 0, 0 },
/* U+cda7 */ { 0, 0, 0, 0, 0 },
/* U+cda8 */ { 0, 0, 0, 0, 0 },
/* U+cda9 */ { 0, 0, 0, 0, 0 },
/* U+cdaa */ { 0, 0, 0, 0, 0 },
/* U+cdab */ { 0, 0, 0, 0, 0 },
/* U+cdac */ { 0, 0, 0, 0, 0 },
/* U+cdad */ { 0, 0, 0, 0, 0 },
/* U+cdae */ { 0, 0, 0, 0, 0 },
/* U+cdaf */ { 0, 0, 0, 0, 0 },
/* U+cdb0 */ { 0, 0, 0, 0, 0 },
/* U+cdb1 */ { 0, 0, 0, 0, 0 },
/* U+cdb2 */ { 0, 0, 0, 0, 0 },
/* U+cdb3 */ { 0, 0, 0, 0, 0 },
/* U+cdb4 */ { 0, 0, 0, 0, 0 },
/* U+cdb5 */ { 0, 0, 0, 0, 0 },
/* U+cdb6 */ { 0, 0, 0, 0, 0 },
/* U+cdb7 */ { 0, 0, 0, 0, 0 },
/* U+cdb8 */ { 0, 0, 0, 0, 0 },
/* U+cdb9 */ { 0, 0, 0, 0, 0 },
/* U+cdba */ { 0, 0, 0, 0, 0 },
/* U+cdbb */ { 0, 0, 0, 0, 0 },
/* U+cdbc */ { 0, 0, 0, 0, 0 },
/* U+cdbd */ { 0, 0, 0, 0, 0 },
/* U+cdbe */ { 0, 0, 0, 0, 0 },
/* U+cdbf */ { 0, 0, 0, 0, 0 },
/* U+cdc0 */ { 0, 0, 0, 0, 0 },
/* U+cdc1 */ { 0, 0, 0, 0, 0 },
/* U+cdc2 */ { 0, 0, 0, 0, 0 },
/* U+cdc3 */ { 0, 0, 0, 0, 0 },
/* U+cdc4 */ { 0, 0, 0, 0, 0 },
/* U+cdc5 */ { 0, 0, 0, 0, 0 },
/* U+cdc6 */ { 0, 0, 0, 0, 0 },
/* U+cdc7 */ { 0, 0, 0, 0, 0 },
/* U+cdc8 */ { 0, 0, 0, 0, 0 },
/* U+cdc9 */ { 0, 0, 0, 0, 0 },
/* U+cdca */ { 0, 0, 0, 0, 0 },
/* U+cdcb */ { 0, 0, 0, 0, 0 },
/* U+cdcc */ { 0, 0, 0, 0, 0 },
/* U+cdcd */ { 0, 0, 0, 0, 0 },
/* U+cdce */ { 0, 0, 0, 0, 0 },
/* U+cdcf */ { 0, 0, 0, 0, 0 },
/* U+cdd0 */ { 0, 0, 0, 0, 0 },
/* U+cdd1 */ { 0, 0, 0, 0, 0 },
/* U+cdd2 */ { 0, 0, 0, 0, 0 },
/* U+cdd3 */ { 0, 0, 0, 0, 0 },
/* U+cdd4 */ { 0, 0, 0, 0, 0 },
/* U+cdd5 */ { 0, 0, 0, 0, 0 },
/* U+cdd6 */ { 0, 0, 0, 0, 0 },
/* U+cdd7 */ { 0, 0, 0, 0, 0 },
/* U+cdd8 */ { 0, 0, 0, 0, 0 },
/* U+cdd9 */ { 0, 0, 0, 0, 0 },
/* U+cdda */ { 0, 0, 0, 0, 0 },
/* U+cddb */ { 0, 0, 0, 0, 0 },
/* U+cddc */ { 0, 0, 0, 0, 0 },
/* U+cddd */ { 0, 0, 0, 0, 0 },
/* U+cdde */ { 0, 0, 0, 0, 0 },
/* U+cddf */ { 0, 0, 0, 0, 0 },
/* U+cde0 */ { 0, 0, 0, 0, 0 },
/* U+cde1 */ { 0, 0, 0, 0, 0 },
/* U+cde2 */ { 0, 0, 0, 0, 0 },
/* U+cde3 */ { 0, 0, 0, 0, 0 },
/* U+cde4 */ { 0, 0, 0, 0, 0 },
/* U+cde5 */ { 0, 0, 0, 0, 0 },
/* U+cde6 */ { 0, 0, 0, 0, 0 },
/* U+cde7 */ { 0, 0, 0, 0, 0 },
/* U+cde8 */ { 0, 0, 0, 0, 0 },
/* U+cde9 */ { 0, 0, 0, 0, 0 },
/* U+cdea */ { 0, 0, 0, 0, 0 },
/* U+cdeb */ { 0, 0, 0, 0, 0 },
/* U+cdec */ { 0, 0, 0, 0, 0 },
/* U+cded */ { 0, 0, 0, 0, 0 },
/* U+cdee */ { 0, 0, 0, 0, 0 },
/* U+cdef */ { 0, 0, 0, 0, 0 },
/* U+cdf0 */ { 0, 0, 0, 0, 0 },
/* U+cdf1 */ { 0, 0, 0, 0, 0 },
/* U+cdf2 */ { 0, 0, 0, 0, 0 },
/* U+cdf3 */ { 0, 0, 0, 0, 0 },
/* U+cdf4 */ { 0, 0, 0, 0, 0 },
/* U+cdf5 */ { 0, 0, 0, 0, 0 },
/* U+cdf6 */ { 0, 0, 0, 0, 0 },
/* U+cdf7 */ { 0, 0, 0, 0, 0 },
/* U+cdf8 */ { 0, 0, 0, 0, 0 },
/* U+cdf9 */ { 0, 0, 0, 0, 0 },
/* U+cdfa */ { 0, 0, 0, 0, 0 },
/* U+cdfb */ { 0, 0, 0, 0, 0 },
/* U+cdfc */ { 0, 0, 0, 0, 0 },
/* U+cdfd */ { 0, 0, 0, 0, 0 },
/* U+cdfe */ { 0, 0, 0, 0, 0 },
/* U+cdff */ { 0, 0, 0, 0, 0 },
/* U+ce00 */ { 0, 0, 0, 0, 0 },
/* U+ce01 */ { 0, 0, 0, 0, 0 },
/* U+ce02 */ { 0, 0, 0, 0, 0 },
/* U+ce03 */ { 0, 0, 0, 0, 0 },
/* U+ce04 */ { 0, 0, 0, 0, 0 },
/* U+ce05 */ { 0, 0, 0, 0, 0 },
/* U+ce06 */ { 0, 0, 0, 0, 0 },
/* U+ce07 */ { 0, 0, 0, 0, 0 },
/* U+ce08 */ { 0, 0, 0, 0, 0 },
/* U+ce09 */ { 0, 0, 0, 0, 0 },
/* U+ce0a */ { 0, 0, 0, 0, 0 },
/* U+ce0b */ { 0, 0, 0, 0, 0 },
/* U+ce0c */ { 0, 0, 0, 0, 0 },
/* U+ce0d */ { 0, 0, 0, 0, 0 },
/* U+ce0e */ { 0, 0, 0, 0, 0 },
/* U+ce0f */ { 0, 0, 0, 0, 0 },
/* U+ce10 */ { 0, 0, 0, 0, 0 },
/* U+ce11 */ { 0, 0, 0, 0, 0 },
/* U+ce12 */ { 0, 0, 0, 0, 0 },
/* U+ce13 */ { 0, 0, 0, 0, 0 },
/* U+ce14 */ { 0, 0, 0, 0, 0 },
/* U+ce15 */ { 0, 0, 0, 0, 0 },
/* U+ce16 */ { 0, 0, 0, 0, 0 },
/* U+ce17 */ { 0, 0, 0, 0, 0 },
/* U+ce18 */ { 0, 0, 0, 0, 0 },
/* U+ce19 */ { 0, 0, 0, 0, 0 },
/* U+ce1a */ { 0, 0, 0, 0, 0 },
/* U+ce1b */ { 0, 0, 0, 0, 0 },
/* U+ce1c */ { 0, 0, 0, 0, 0 },
/* U+ce1d */ { 0, 0, 0, 0, 0 },
/* U+ce1e */ { 0, 0, 0, 0, 0 },
/* U+ce1f */ { 0, 0, 0, 0, 0 },
/* U+ce20 */ { 0, 0, 0, 0, 0 },
/* U+ce21 */ { 0, 0, 0, 0, 0 },
/* U+ce22 */ { 0, 0, 0, 0, 0 },
/* U+ce23 */ { 0, 0, 0, 0, 0 },
/* U+ce24 */ { 0, 0, 0, 0, 0 },
/* U+ce25 */ { 0, 0, 0, 0, 0 },
/* U+ce26 */ { 0, 0, 0, 0, 0 },
/* U+ce27 */ { 0, 0, 0, 0, 0 },
/* U+ce28 */ { 0, 0, 0, 0, 0 },
/* U+ce29 */ { 0, 0, 0, 0, 0 },
/* U+ce2a */ { 0, 0, 0, 0, 0 },
/* U+ce2b */ { 0, 0, 0, 0, 0 },
/* U+ce2c */ { 0, 0, 0, 0, 0 },
/* U+ce2d */ { 0, 0, 0, 0, 0 },
/* U+ce2e */ { 0, 0, 0, 0, 0 },
/* U+ce2f */ { 0, 0, 0, 0, 0 },
/* U+ce30 */ { 0, 0, 0, 0, 0 },
/* U+ce31 */ { 0, 0, 0, 0, 0 },
/* U+ce32 */ { 0, 0, 0, 0, 0 },
/* U+ce33 */ { 0, 0, 0, 0, 0 },
/* U+ce34 */ { 0, 0, 0, 0, 0 },
/* U+ce35 */ { 0, 0, 0, 0, 0 },
/* U+ce36 */ { 0, 0, 0, 0, 0 },
/* U+ce37 */ { 0, 0, 0, 0, 0 },
/* U+ce38 */ { 0, 0, 0, 0, 0 },
/* U+ce39 */ { 0, 0, 0, 0, 0 },
/* U+ce3a */ { 0, 0, 0, 0, 0 },
/* U+ce3b */ { 0, 0, 0, 0, 0 },
/* U+ce3c */ { 0, 0, 0, 0, 0 },
/* U+ce3d */ { 0, 0, 0, 0, 0 },
/* U+ce3e */ { 0, 0, 0, 0, 0 },
/* U+ce3f */ { 0, 0, 0, 0, 0 },
/* U+ce40 */ { 0, 0, 0, 0, 0 },
/* U+ce41 */ { 0, 0, 0, 0, 0 },
/* U+ce42 */ { 0, 0, 0, 0, 0 },
/* U+ce43 */ { 0, 0, 0, 0, 0 },
/* U+ce44 */ { 0, 0, 0, 0, 0 },
/* U+ce45 */ { 0, 0, 0, 0, 0 },
/* U+ce46 */ { 0, 0, 0, 0, 0 },
/* U+ce47 */ { 0, 0, 0, 0, 0 },
/* U+ce48 */ { 0, 0, 0, 0, 0 },
/* U+ce49 */ { 0, 0, 0, 0, 0 },
/* U+ce4a */ { 0, 0, 0, 0, 0 },
/* U+ce4b */ { 0, 0, 0, 0, 0 },
/* U+ce4c */ { 0, 0, 0, 0, 0 },
/* U+ce4d */ { 0, 0, 0, 0, 0 },
/* U+ce4e */ { 0, 0, 0, 0, 0 },
/* U+ce4f */ { 0, 0, 0, 0, 0 },
/* U+ce50 */ { 0, 0, 0, 0, 0 },
/* U+ce51 */ { 0, 0, 0, 0, 0 },
/* U+ce52 */ { 0, 0, 0, 0, 0 },
/* U+ce53 */ { 0, 0, 0, 0, 0 },
/* U+ce54 */ { 0, 0, 0, 0, 0 },
/* U+ce55 */ { 0, 0, 0, 0, 0 },
/* U+ce56 */ { 0, 0, 0, 0, 0 },
/* U+ce57 */ { 0, 0, 0, 0, 0 },
/* U+ce58 */ { 0, 0, 0, 0, 0 },
/* U+ce59 */ { 0, 0, 0, 0, 0 },
/* U+ce5a */ { 0, 0, 0, 0, 0 },
/* U+ce5b */ { 0, 0, 0, 0, 0 },
/* U+ce5c */ { 0, 0, 0, 0, 0 },
/* U+ce5d */ { 0, 0, 0, 0, 0 },
/* U+ce5e */ { 0, 0, 0, 0, 0 },
/* U+ce5f */ { 0, 0, 0, 0, 0 },
/* U+ce60 */ { 0, 0, 0, 0, 0 },
/* U+ce61 */ { 0, 0, 0, 0, 0 },
/* U+ce62 */ { 0, 0, 0, 0, 0 },
/* U+ce63 */ { 0, 0, 0, 0, 0 },
/* U+ce64 */ { 0, 0, 0, 0, 0 },
/* U+ce65 */ { 0, 0, 0, 0, 0 },
/* U+ce66 */ { 0, 0, 0, 0, 0 },
/* U+ce67 */ { 0, 0, 0, 0, 0 },
/* U+ce68 */ { 0, 0, 0, 0, 0 },
/* U+ce69 */ { 0, 0, 0, 0, 0 },
/* U+ce6a */ { 0, 0, 0, 0, 0 },
/* U+ce6b */ { 0, 0, 0, 0, 0 },
/* U+ce6c */ { 0, 0, 0, 0, 0 },
/* U+ce6d */ { 0, 0, 0, 0, 0 },
/* U+ce6e */ { 0, 0, 0, 0, 0 },
/* U+ce6f */ { 0, 0, 0, 0, 0 },
/* U+ce70 */ { 0, 0, 0, 0, 0 },
/* U+ce71 */ { 0, 0, 0, 0, 0 },
/* U+ce72 */ { 0, 0, 0, 0, 0 },
/* U+ce73 */ { 0, 0, 0, 0, 0 },
/* U+ce74 */ { 0, 0, 0, 0, 0 },
/* U+ce75 */ { 0, 0, 0, 0, 0 },
/* U+ce76 */ { 0, 0, 0, 0, 0 },
/* U+ce77 */ { 0, 0, 0, 0, 0 },
/* U+ce78 */ { 0, 0, 0, 0, 0 },
/* U+ce79 */ { 0, 0, 0, 0, 0 },
/* U+ce7a */ { 0, 0, 0, 0, 0 },
/* U+ce7b */ { 0, 0, 0, 0, 0 },
/* U+ce7c */ { 0, 0, 0, 0, 0 },
/* U+ce7d */ { 0, 0, 0, 0, 0 },
/* U+ce7e */ { 0, 0, 0, 0, 0 },
/* U+ce7f */ { 0, 0, 0, 0, 0 },
/* U+ce80 */ { 0, 0, 0, 0, 0 },
/* U+ce81 */ { 0, 0, 0, 0, 0 },
/* U+ce82 */ { 0, 0, 0, 0, 0 },
/* U+ce83 */ { 0, 0, 0, 0, 0 },
/* U+ce84 */ { 0, 0, 0, 0, 0 },
/* U+ce85 */ { 0, 0, 0, 0, 0 },
/* U+ce86 */ { 0, 0, 0, 0, 0 },
/* U+ce87 */ { 0, 0, 0, 0, 0 },
/* U+ce88 */ { 0, 0, 0, 0, 0 },
/* U+ce89 */ { 0, 0, 0, 0, 0 },
/* U+ce8a */ { 0, 0, 0, 0, 0 },
/* U+ce8b */ { 0, 0, 0, 0, 0 },
/* U+ce8c */ { 0, 0, 0, 0, 0 },
/* U+ce8d */ { 0, 0, 0, 0, 0 },
/* U+ce8e */ { 0, 0, 0, 0, 0 },
/* U+ce8f */ { 0, 0, 0, 0, 0 },
/* U+ce90 */ { 0, 0, 0, 0, 0 },
/* U+ce91 */ { 0, 0, 0, 0, 0 },
/* U+ce92 */ { 0, 0, 0, 0, 0 },
/* U+ce93 */ { 0, 0, 0, 0, 0 },
/* U+ce94 */ { 0, 0, 0, 0, 0 },
/* U+ce95 */ { 0, 0, 0, 0, 0 },
/* U+ce96 */ { 0, 0, 0, 0, 0 },
/* U+ce97 */ { 0, 0, 0, 0, 0 },
/* U+ce98 */ { 0, 0, 0, 0, 0 },
/* U+ce99 */ { 0, 0, 0, 0, 0 },
/* U+ce9a */ { 0, 0, 0, 0, 0 },
/* U+ce9b */ { 0, 0, 0, 0, 0 },
/* U+ce9c */ { 0, 0, 0, 0, 0 },
/* U+ce9d */ { 0, 0, 0, 0, 0 },
/* U+ce9e */ { 0, 0, 0, 0, 0 },
/* U+ce9f */ { 0, 0, 0, 0, 0 },
/* U+cea0 */ { 0, 0, 0, 0, 0 },
/* U+cea1 */ { 0, 0, 0, 0, 0 },
/* U+cea2 */ { 0, 0, 0, 0, 0 },
/* U+cea3 */ { 0, 0, 0, 0, 0 },
/* U+cea4 */ { 0, 0, 0, 0, 0 },
/* U+cea5 */ { 0, 0, 0, 0, 0 },
/* U+cea6 */ { 0, 0, 0, 0, 0 },
/* U+cea7 */ { 0, 0, 0, 0, 0 },
/* U+cea8 */ { 0, 0, 0, 0, 0 },
/* U+cea9 */ { 0, 0, 0, 0, 0 },
/* U+ceaa */ { 0, 0, 0, 0, 0 },
/* U+ceab */ { 0, 0, 0, 0, 0 },
/* U+ceac */ { 0, 0, 0, 0, 0 },
/* U+cead */ { 0, 0, 0, 0, 0 },
/* U+ceae */ { 0, 0, 0, 0, 0 },
/* U+ceaf */ { 0, 0, 0, 0, 0 },
/* U+ceb0 */ { 0, 0, 0, 0, 0 },
/* U+ceb1 */ { 0, 0, 0, 0, 0 },
/* U+ceb2 */ { 0, 0, 0, 0, 0 },
/* U+ceb3 */ { 0, 0, 0, 0, 0 },
/* U+ceb4 */ { 0, 0, 0, 0, 0 },
/* U+ceb5 */ { 0, 0, 0, 0, 0 },
/* U+ceb6 */ { 0, 0, 0, 0, 0 },
/* U+ceb7 */ { 0, 0, 0, 0, 0 },
/* U+ceb8 */ { 0, 0, 0, 0, 0 },
/* U+ceb9 */ { 0, 0, 0, 0, 0 },
/* U+ceba */ { 0, 0, 0, 0, 0 },
/* U+cebb */ { 0, 0, 0, 0, 0 },
/* U+cebc */ { 0, 0, 0, 0, 0 },
/* U+cebd */ { 0, 0, 0, 0, 0 },
/* U+cebe */ { 0, 0, 0, 0, 0 },
/* U+cebf */ { 0, 0, 0, 0, 0 },
/* U+cec0 */ { 0, 0, 0, 0, 0 },
/* U+cec1 */ { 0, 0, 0, 0, 0 },
/* U+cec2 */ { 0, 0, 0, 0, 0 },
/* U+cec3 */ { 0, 0, 0, 0, 0 },
/* U+cec4 */ { 0, 0, 0, 0, 0 },
/* U+cec5 */ { 0, 0, 0, 0, 0 },
/* U+cec6 */ { 0, 0, 0, 0, 0 },
/* U+cec7 */ { 0, 0, 0, 0, 0 },
/* U+cec8 */ { 0, 0, 0, 0, 0 },
/* U+cec9 */ { 0, 0, 0, 0, 0 },
/* U+ceca */ { 0, 0, 0, 0, 0 },
/* U+cecb */ { 0, 0, 0, 0, 0 },
/* U+cecc */ { 0, 0, 0, 0, 0 },
/* U+cecd */ { 0, 0, 0, 0, 0 },
/* U+cece */ { 0, 0, 0, 0, 0 },
/* U+cecf */ { 0, 0, 0, 0, 0 },
/* U+ced0 */ { 0, 0, 0, 0, 0 },
/* U+ced1 */ { 0, 0, 0, 0, 0 },
/* U+ced2 */ { 0, 0, 0, 0, 0 },
/* U+ced3 */ { 0, 0, 0, 0, 0 },
/* U+ced4 */ { 0, 0, 0, 0, 0 },
/* U+ced5 */ { 0, 0, 0, 0, 0 },
/* U+ced6 */ { 0, 0, 0, 0, 0 },
/* U+ced7 */ { 0, 0, 0, 0, 0 },
/* U+ced8 */ { 0, 0, 0, 0, 0 },
/* U+ced9 */ { 0, 0, 0, 0, 0 },
/* U+ceda */ { 0, 0, 0, 0, 0 },
/* U+cedb */ { 0, 0, 0, 0, 0 },
/* U+cedc */ { 0, 0, 0, 0, 0 },
/* U+cedd */ { 0, 0, 0, 0, 0 },
/* U+cede */ { 0, 0, 0, 0, 0 },
/* U+cedf */ { 0, 0, 0, 0, 0 },
/* U+cee0 */ { 0, 0, 0, 0, 0 },
/* U+cee1 */ { 0, 0, 0, 0, 0 },
/* U+cee2 */ { 0, 0, 0, 0, 0 },
/* U+cee3 */ { 0, 0, 0, 0, 0 },
/* U+cee4 */ { 0, 0, 0, 0, 0 },
/* U+cee5 */ { 0, 0, 0, 0, 0 },
/* U+cee6 */ { 0, 0, 0, 0, 0 },
/* U+cee7 */ { 0, 0, 0, 0, 0 },
/* U+cee8 */ { 0, 0, 0, 0, 0 },
/* U+cee9 */ { 0, 0, 0, 0, 0 },
/* U+ceea */ { 0, 0, 0, 0, 0 },
/* U+ceeb */ { 0, 0, 0, 0, 0 },
/* U+ceec */ { 0, 0, 0, 0, 0 },
/* U+ceed */ { 0, 0, 0, 0, 0 },
/* U+ceee */ { 0, 0, 0, 0, 0 },
/* U+ceef */ { 0, 0, 0, 0, 0 },
/* U+cef0 */ { 0, 0, 0, 0, 0 },
/* U+cef1 */ { 0, 0, 0, 0, 0 },
/* U+cef2 */ { 0, 0, 0, 0, 0 },
/* U+cef3 */ { 0, 0, 0, 0, 0 },
/* U+cef4 */ { 0, 0, 0, 0, 0 },
/* U+cef5 */ { 0, 0, 0, 0, 0 },
/* U+cef6 */ { 0, 0, 0, 0, 0 },
/* U+cef7 */ { 0, 0, 0, 0, 0 },
/* U+cef8 */ { 0, 0, 0, 0, 0 },
/* U+cef9 */ { 0, 0, 0, 0, 0 },
/* U+cefa */ { 0, 0, 0, 0, 0 },
/* U+cefb */ { 0, 0, 0, 0, 0 },
/* U+cefc */ { 0, 0, 0, 0, 0 },
/* U+cefd */ { 0, 0, 0, 0, 0 },
/* U+cefe */ { 0, 0, 0, 0, 0 },
/* U+ceff */ { 0, 0, 0, 0, 0 },
/* U+cf00 */ { 0, 0, 0, 0, 0 },
/* U+cf01 */ { 0, 0, 0, 0, 0 },
/* U+cf02 */ { 0, 0, 0, 0, 0 },
/* U+cf03 */ { 0, 0, 0, 0, 0 },
/* U+cf04 */ { 0, 0, 0, 0, 0 },
/* U+cf05 */ { 0, 0, 0, 0, 0 },
/* U+cf06 */ { 0, 0, 0, 0, 0 },
/* U+cf07 */ { 0, 0, 0, 0, 0 },
/* U+cf08 */ { 0, 0, 0, 0, 0 },
/* U+cf09 */ { 0, 0, 0, 0, 0 },
/* U+cf0a */ { 0, 0, 0, 0, 0 },
/* U+cf0b */ { 0, 0, 0, 0, 0 },
/* U+cf0c */ { 0, 0, 0, 0, 0 },
/* U+cf0d */ { 0, 0, 0, 0, 0 },
/* U+cf0e */ { 0, 0, 0, 0, 0 },
/* U+cf0f */ { 0, 0, 0, 0, 0 },
/* U+cf10 */ { 0, 0, 0, 0, 0 },
/* U+cf11 */ { 0, 0, 0, 0, 0 },
/* U+cf12 */ { 0, 0, 0, 0, 0 },
/* U+cf13 */ { 0, 0, 0, 0, 0 },
/* U+cf14 */ { 0, 0, 0, 0, 0 },
/* U+cf15 */ { 0, 0, 0, 0, 0 },
/* U+cf16 */ { 0, 0, 0, 0, 0 },
/* U+cf17 */ { 0, 0, 0, 0, 0 },
/* U+cf18 */ { 0, 0, 0, 0, 0 },
/* U+cf19 */ { 0, 0, 0, 0, 0 },
/* U+cf1a */ { 0, 0, 0, 0, 0 },
/* U+cf1b */ { 0, 0, 0, 0, 0 },
/* U+cf1c */ { 0, 0, 0, 0, 0 },
/* U+cf1d */ { 0, 0, 0, 0, 0 },
/* U+cf1e */ { 0, 0, 0, 0, 0 },
/* U+cf1f */ { 0, 0, 0, 0, 0 },
/* U+cf20 */ { 0, 0, 0, 0, 0 },
/* U+cf21 */ { 0, 0, 0, 0, 0 },
/* U+cf22 */ { 0, 0, 0, 0, 0 },
/* U+cf23 */ { 0, 0, 0, 0, 0 },
/* U+cf24 */ { 0, 0, 0, 0, 0 },
/* U+cf25 */ { 0, 0, 0, 0, 0 },
/* U+cf26 */ { 0, 0, 0, 0, 0 },
/* U+cf27 */ { 0, 0, 0, 0, 0 },
/* U+cf28 */ { 0, 0, 0, 0, 0 },
/* U+cf29 */ { 0, 0, 0, 0, 0 },
/* U+cf2a */ { 0, 0, 0, 0, 0 },
/* U+cf2b */ { 0, 0, 0, 0, 0 },
/* U+cf2c */ { 0, 0, 0, 0, 0 },
/* U+cf2d */ { 0, 0, 0, 0, 0 },
/* U+cf2e */ { 0, 0, 0, 0, 0 },
/* U+cf2f */ { 0, 0, 0, 0, 0 },
/* U+cf30 */ { 0, 0, 0, 0, 0 },
/* U+cf31 */ { 0, 0, 0, 0, 0 },
/* U+cf32 */ { 0, 0, 0, 0, 0 },
/* U+cf33 */ { 0, 0, 0, 0, 0 },
/* U+cf34 */ { 0, 0, 0, 0, 0 },
/* U+cf35 */ { 0, 0, 0, 0, 0 },
/* U+cf36 */ { 0, 0, 0, 0, 0 },
/* U+cf37 */ { 0, 0, 0, 0, 0 },
/* U+cf38 */ { 0, 0, 0, 0, 0 },
/* U+cf39 */ { 0, 0, 0, 0, 0 },
/* U+cf3a */ { 0, 0, 0, 0, 0 },
/* U+cf3b */ { 0, 0, 0, 0, 0 },
/* U+cf3c */ { 0, 0, 0, 0, 0 },
/* U+cf3d */ { 0, 0, 0, 0, 0 },
/* U+cf3e */ { 0, 0, 0, 0, 0 },
/* U+cf3f */ { 0, 0, 0, 0, 0 },
/* U+cf40 */ { 0, 0, 0, 0, 0 },
/* U+cf41 */ { 0, 0, 0, 0, 0 },
/* U+cf42 */ { 0, 0, 0, 0, 0 },
/* U+cf43 */ { 0, 0, 0, 0, 0 },
/* U+cf44 */ { 0, 0, 0, 0, 0 },
/* U+cf45 */ { 0, 0, 0, 0, 0 },
/* U+cf46 */ { 0, 0, 0, 0, 0 },
/* U+cf47 */ { 0, 0, 0, 0, 0 },
/* U+cf48 */ { 0, 0, 0, 0, 0 },
/* U+cf49 */ { 0, 0, 0, 0, 0 },
/* U+cf4a */ { 0, 0, 0, 0, 0 },
/* U+cf4b */ { 0, 0, 0, 0, 0 },
/* U+cf4c */ { 0, 0, 0, 0, 0 },
/* U+cf4d */ { 0, 0, 0, 0, 0 },
/* U+cf4e */ { 0, 0, 0, 0, 0 },
/* U+cf4f */ { 0, 0, 0, 0, 0 },
/* U+cf50 */ { 0, 0, 0, 0, 0 },
/* U+cf51 */ { 0, 0, 0, 0, 0 },
/* U+cf52 */ { 0, 0, 0, 0, 0 },
/* U+cf53 */ { 0, 0, 0, 0, 0 },
/* U+cf54 */ { 0, 0, 0, 0, 0 },
/* U+cf55 */ { 0, 0, 0, 0, 0 },
/* U+cf56 */ { 0, 0, 0, 0, 0 },
/* U+cf57 */ { 0, 0, 0, 0, 0 },
/* U+cf58 */ { 0, 0, 0, 0, 0 },
/* U+cf59 */ { 0, 0, 0, 0, 0 },
/* U+cf5a */ { 0, 0, 0, 0, 0 },
/* U+cf5b */ { 0, 0, 0, 0, 0 },
/* U+cf5c */ { 0, 0, 0, 0, 0 },
/* U+cf5d */ { 0, 0, 0, 0, 0 },
/* U+cf5e */ { 0, 0, 0, 0, 0 },
/* U+cf5f */ { 0, 0, 0, 0, 0 },
/* U+cf60 */ { 0, 0, 0, 0, 0 },
/* U+cf61 */ { 0, 0, 0, 0, 0 },
/* U+cf62 */ { 0, 0, 0, 0, 0 },
/* U+cf63 */ { 0, 0, 0, 0, 0 },
/* U+cf64 */ { 0, 0, 0, 0, 0 },
/* U+cf65 */ { 0, 0, 0, 0, 0 },
/* U+cf66 */ { 0, 0, 0, 0, 0 },
/* U+cf67 */ { 0, 0, 0, 0, 0 },
/* U+cf68 */ { 0, 0, 0, 0, 0 },
/* U+cf69 */ { 0, 0, 0, 0, 0 },
/* U+cf6a */ { 0, 0, 0, 0, 0 },
/* U+cf6b */ { 0, 0, 0, 0, 0 },
/* U+cf6c */ { 0, 0, 0, 0, 0 },
/* U+cf6d */ { 0, 0, 0, 0, 0 },
/* U+cf6e */ { 0, 0, 0, 0, 0 },
/* U+cf6f */ { 0, 0, 0, 0, 0 },
/* U+cf70 */ { 0, 0, 0, 0, 0 },
/* U+cf71 */ { 0, 0, 0, 0, 0 },
/* U+cf72 */ { 0, 0, 0, 0, 0 },
/* U+cf73 */ { 0, 0, 0, 0, 0 },
/* U+cf74 */ { 0, 0, 0, 0, 0 },
/* U+cf75 */ { 0, 0, 0, 0, 0 },
/* U+cf76 */ { 0, 0, 0, 0, 0 },
/* U+cf77 */ { 0, 0, 0, 0, 0 },
/* U+cf78 */ { 0, 0, 0, 0, 0 },
/* U+cf79 */ { 0, 0, 0, 0, 0 },
/* U+cf7a */ { 0, 0, 0, 0, 0 },
/* U+cf7b */ { 0, 0, 0, 0, 0 },
/* U+cf7c */ { 0, 0, 0, 0, 0 },
/* U+cf7d */ { 0, 0, 0, 0, 0 },
/* U+cf7e */ { 0, 0, 0, 0, 0 },
/* U+cf7f */ { 0, 0, 0, 0, 0 },
/* U+cf80 */ { 0, 0, 0, 0, 0 },
/* U+cf81 */ { 0, 0, 0, 0, 0 },
/* U+cf82 */ { 0, 0, 0, 0, 0 },
/* U+cf83 */ { 0, 0, 0, 0, 0 },
/* U+cf84 */ { 0, 0, 0, 0, 0 },
/* U+cf85 */ { 0, 0, 0, 0, 0 },
/* U+cf86 */ { 0, 0, 0, 0, 0 },
/* U+cf87 */ { 0, 0, 0, 0, 0 },
/* U+cf88 */ { 0, 0, 0, 0, 0 },
/* U+cf89 */ { 0, 0, 0, 0, 0 },
/* U+cf8a */ { 0, 0, 0, 0, 0 },
/* U+cf8b */ { 0, 0, 0, 0, 0 },
/* U+cf8c */ { 0, 0, 0, 0, 0 },
/* U+cf8d */ { 0, 0, 0, 0, 0 },
/* U+cf8e */ { 0, 0, 0, 0, 0 },
/* U+cf8f */ { 0, 0, 0, 0, 0 },
/* U+cf90 */ { 0, 0, 0, 0, 0 },
/* U+cf91 */ { 0, 0, 0, 0, 0 },
/* U+cf92 */ { 0, 0, 0, 0, 0 },
/* U+cf93 */ { 0, 0, 0, 0, 0 },
/* U+cf94 */ { 0, 0, 0, 0, 0 },
/* U+cf95 */ { 0, 0, 0, 0, 0 },
/* U+cf96 */ { 0, 0, 0, 0, 0 },
/* U+cf97 */ { 0, 0, 0, 0, 0 },
/* U+cf98 */ { 0, 0, 0, 0, 0 },
/* U+cf99 */ { 0, 0, 0, 0, 0 },
/* U+cf9a */ { 0, 0, 0, 0, 0 },
/* U+cf9b */ { 0, 0, 0, 0, 0 },
/* U+cf9c */ { 0, 0, 0, 0, 0 },
/* U+cf9d */ { 0, 0, 0, 0, 0 },
/* U+cf9e */ { 0, 0, 0, 0, 0 },
/* U+cf9f */ { 0, 0, 0, 0, 0 },
/* U+cfa0 */ { 0, 0, 0, 0, 0 },
/* U+cfa1 */ { 0, 0, 0, 0, 0 },
/* U+cfa2 */ { 0, 0, 0, 0, 0 },
/* U+cfa3 */ { 0, 0, 0, 0, 0 },
/* U+cfa4 */ { 0, 0, 0, 0, 0 },
/* U+cfa5 */ { 0, 0, 0, 0, 0 },
/* U+cfa6 */ { 0, 0, 0, 0, 0 },
/* U+cfa7 */ { 0, 0, 0, 0, 0 },
/* U+cfa8 */ { 0, 0, 0, 0, 0 },
/* U+cfa9 */ { 0, 0, 0, 0, 0 },
/* U+cfaa */ { 0, 0, 0, 0, 0 },
/* U+cfab */ { 0, 0, 0, 0, 0 },
/* U+cfac */ { 0, 0, 0, 0, 0 },
/* U+cfad */ { 0, 0, 0, 0, 0 },
/* U+cfae */ { 0, 0, 0, 0, 0 },
/* U+cfaf */ { 0, 0, 0, 0, 0 },
/* U+cfb0 */ { 0, 0, 0, 0, 0 },
/* U+cfb1 */ { 0, 0, 0, 0, 0 },
/* U+cfb2 */ { 0, 0, 0, 0, 0 },
/* U+cfb3 */ { 0, 0, 0, 0, 0 },
/* U+cfb4 */ { 0, 0, 0, 0, 0 },
/* U+cfb5 */ { 0, 0, 0, 0, 0 },
/* U+cfb6 */ { 0, 0, 0, 0, 0 },
/* U+cfb7 */ { 0, 0, 0, 0, 0 },
/* U+cfb8 */ { 0, 0, 0, 0, 0 },
/* U+cfb9 */ { 0, 0, 0, 0, 0 },
/* U+cfba */ { 0, 0, 0, 0, 0 },
/* U+cfbb */ { 0, 0, 0, 0, 0 },
/* U+cfbc */ { 0, 0, 0, 0, 0 },
/* U+cfbd */ { 0, 0, 0, 0, 0 },
/* U+cfbe */ { 0, 0, 0, 0, 0 },
/* U+cfbf */ { 0, 0, 0, 0, 0 },
/* U+cfc0 */ { 0, 0, 0, 0, 0 },
/* U+cfc1 */ { 0, 0, 0, 0, 0 },
/* U+cfc2 */ { 0, 0, 0, 0, 0 },
/* U+cfc3 */ { 0, 0, 0, 0, 0 },
/* U+cfc4 */ { 0, 0, 0, 0, 0 },
/* U+cfc5 */ { 0, 0, 0, 0, 0 },
/* U+cfc6 */ { 0, 0, 0, 0, 0 },
/* U+cfc7 */ { 0, 0, 0, 0, 0 },
/* U+cfc8 */ { 0, 0, 0, 0, 0 },
/* U+cfc9 */ { 0, 0, 0, 0, 0 },
/* U+cfca */ { 0, 0, 0, 0, 0 },
/* U+cfcb */ { 0, 0, 0, 0, 0 },
/* U+cfcc */ { 0, 0, 0, 0, 0 },
/* U+cfcd */ { 0, 0, 0, 0, 0 },
/* U+cfce */ { 0, 0, 0, 0, 0 },
/* U+cfcf */ { 0, 0, 0, 0, 0 },
/* U+cfd0 */ { 0, 0, 0, 0, 0 },
/* U+cfd1 */ { 0, 0, 0, 0, 0 },
/* U+cfd2 */ { 0, 0, 0, 0, 0 },
/* U+cfd3 */ { 0, 0, 0, 0, 0 },
/* U+cfd4 */ { 0, 0, 0, 0, 0 },
/* U+cfd5 */ { 0, 0, 0, 0, 0 },
/* U+cfd6 */ { 0, 0, 0, 0, 0 },
/* U+cfd7 */ { 0, 0, 0, 0, 0 },
/* U+cfd8 */ { 0, 0, 0, 0, 0 },
/* U+cfd9 */ { 0, 0, 0, 0, 0 },
/* U+cfda */ { 0, 0, 0, 0, 0 },
/* U+cfdb */ { 0, 0, 0, 0, 0 },
/* U+cfdc */ { 0, 0, 0, 0, 0 },
/* U+cfdd */ { 0, 0, 0, 0, 0 },
/* U+cfde */ { 0, 0, 0, 0, 0 },
/* U+cfdf */ { 0, 0, 0, 0, 0 },
/* U+cfe0 */ { 0, 0, 0, 0, 0 },
/* U+cfe1 */ { 0, 0, 0, 0, 0 },
/* U+cfe2 */ { 0, 0, 0, 0, 0 },
/* U+cfe3 */ { 0, 0, 0, 0, 0 },
/* U+cfe4 */ { 0, 0, 0, 0, 0 },
/* U+cfe5 */ { 0, 0, 0, 0, 0 },
/* U+cfe6 */ { 0, 0, 0, 0, 0 },
/* U+cfe7 */ { 0, 0, 0, 0, 0 },
/* U+cfe8 */ { 0, 0, 0, 0, 0 },
/* U+cfe9 */ { 0, 0, 0, 0, 0 },
/* U+cfea */ { 0, 0, 0, 0, 0 },
/* U+cfeb */ { 0, 0, 0, 0, 0 },
/* U+cfec */ { 0, 0, 0, 0, 0 },
/* U+cfed */ { 0, 0, 0, 0, 0 },
/* U+cfee */ { 0, 0, 0, 0, 0 },
/* U+cfef */ { 0, 0, 0, 0, 0 },
/* U+cff0 */ { 0, 0, 0, 0, 0 },
/* U+cff1 */ { 0, 0, 0, 0, 0 },
/* U+cff2 */ { 0, 0, 0, 0, 0 },
/* U+cff3 */ { 0, 0, 0, 0, 0 },
/* U+cff4 */ { 0, 0, 0, 0, 0 },
/* U+cff5 */ { 0, 0, 0, 0, 0 },
/* U+cff6 */ { 0, 0, 0, 0, 0 },
/* U+cff7 */ { 0, 0, 0, 0, 0 },
/* U+cff8 */ { 0, 0, 0, 0, 0 },
/* U+cff9 */ { 0, 0, 0, 0, 0 },
/* U+cffa */ { 0, 0, 0, 0, 0 },
/* U+cffb */ { 0, 0, 0, 0, 0 },
/* U+cffc */ { 0, 0, 0, 0, 0 },
/* U+cffd */ { 0, 0, 0, 0, 0 },
/* U+cffe */ { 0, 0, 0, 0, 0 },
/* U+cfff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_13[4096] = {
    
/* U+d000 */ { 0, 0, 0, 0, 0 },
/* U+d001 */ { 0, 0, 0, 0, 0 },
/* U+d002 */ { 0, 0, 0, 0, 0 },
/* U+d003 */ { 0, 0, 0, 0, 0 },
/* U+d004 */ { 0, 0, 0, 0, 0 },
/* U+d005 */ { 0, 0, 0, 0, 0 },
/* U+d006 */ { 0, 0, 0, 0, 0 },
/* U+d007 */ { 0, 0, 0, 0, 0 },
/* U+d008 */ { 0, 0, 0, 0, 0 },
/* U+d009 */ { 0, 0, 0, 0, 0 },
/* U+d00a */ { 0, 0, 0, 0, 0 },
/* U+d00b */ { 0, 0, 0, 0, 0 },
/* U+d00c */ { 0, 0, 0, 0, 0 },
/* U+d00d */ { 0, 0, 0, 0, 0 },
/* U+d00e */ { 0, 0, 0, 0, 0 },
/* U+d00f */ { 0, 0, 0, 0, 0 },
/* U+d010 */ { 0, 0, 0, 0, 0 },
/* U+d011 */ { 0, 0, 0, 0, 0 },
/* U+d012 */ { 0, 0, 0, 0, 0 },
/* U+d013 */ { 0, 0, 0, 0, 0 },
/* U+d014 */ { 0, 0, 0, 0, 0 },
/* U+d015 */ { 0, 0, 0, 0, 0 },
/* U+d016 */ { 0, 0, 0, 0, 0 },
/* U+d017 */ { 0, 0, 0, 0, 0 },
/* U+d018 */ { 0, 0, 0, 0, 0 },
/* U+d019 */ { 0, 0, 0, 0, 0 },
/* U+d01a */ { 0, 0, 0, 0, 0 },
/* U+d01b */ { 0, 0, 0, 0, 0 },
/* U+d01c */ { 0, 0, 0, 0, 0 },
/* U+d01d */ { 0, 0, 0, 0, 0 },
/* U+d01e */ { 0, 0, 0, 0, 0 },
/* U+d01f */ { 0, 0, 0, 0, 0 },
/* U+d020 */ { 0, 0, 0, 0, 0 },
/* U+d021 */ { 0, 0, 0, 0, 0 },
/* U+d022 */ { 0, 0, 0, 0, 0 },
/* U+d023 */ { 0, 0, 0, 0, 0 },
/* U+d024 */ { 0, 0, 0, 0, 0 },
/* U+d025 */ { 0, 0, 0, 0, 0 },
/* U+d026 */ { 0, 0, 0, 0, 0 },
/* U+d027 */ { 0, 0, 0, 0, 0 },
/* U+d028 */ { 0, 0, 0, 0, 0 },
/* U+d029 */ { 0, 0, 0, 0, 0 },
/* U+d02a */ { 0, 0, 0, 0, 0 },
/* U+d02b */ { 0, 0, 0, 0, 0 },
/* U+d02c */ { 0, 0, 0, 0, 0 },
/* U+d02d */ { 0, 0, 0, 0, 0 },
/* U+d02e */ { 0, 0, 0, 0, 0 },
/* U+d02f */ { 0, 0, 0, 0, 0 },
/* U+d030 */ { 0, 0, 0, 0, 0 },
/* U+d031 */ { 0, 0, 0, 0, 0 },
/* U+d032 */ { 0, 0, 0, 0, 0 },
/* U+d033 */ { 0, 0, 0, 0, 0 },
/* U+d034 */ { 0, 0, 0, 0, 0 },
/* U+d035 */ { 0, 0, 0, 0, 0 },
/* U+d036 */ { 0, 0, 0, 0, 0 },
/* U+d037 */ { 0, 0, 0, 0, 0 },
/* U+d038 */ { 0, 0, 0, 0, 0 },
/* U+d039 */ { 0, 0, 0, 0, 0 },
/* U+d03a */ { 0, 0, 0, 0, 0 },
/* U+d03b */ { 0, 0, 0, 0, 0 },
/* U+d03c */ { 0, 0, 0, 0, 0 },
/* U+d03d */ { 0, 0, 0, 0, 0 },
/* U+d03e */ { 0, 0, 0, 0, 0 },
/* U+d03f */ { 0, 0, 0, 0, 0 },
/* U+d040 */ { 0, 0, 0, 0, 0 },
/* U+d041 */ { 0, 0, 0, 0, 0 },
/* U+d042 */ { 0, 0, 0, 0, 0 },
/* U+d043 */ { 0, 0, 0, 0, 0 },
/* U+d044 */ { 0, 0, 0, 0, 0 },
/* U+d045 */ { 0, 0, 0, 0, 0 },
/* U+d046 */ { 0, 0, 0, 0, 0 },
/* U+d047 */ { 0, 0, 0, 0, 0 },
/* U+d048 */ { 0, 0, 0, 0, 0 },
/* U+d049 */ { 0, 0, 0, 0, 0 },
/* U+d04a */ { 0, 0, 0, 0, 0 },
/* U+d04b */ { 0, 0, 0, 0, 0 },
/* U+d04c */ { 0, 0, 0, 0, 0 },
/* U+d04d */ { 0, 0, 0, 0, 0 },
/* U+d04e */ { 0, 0, 0, 0, 0 },
/* U+d04f */ { 0, 0, 0, 0, 0 },
/* U+d050 */ { 0, 0, 0, 0, 0 },
/* U+d051 */ { 0, 0, 0, 0, 0 },
/* U+d052 */ { 0, 0, 0, 0, 0 },
/* U+d053 */ { 0, 0, 0, 0, 0 },
/* U+d054 */ { 0, 0, 0, 0, 0 },
/* U+d055 */ { 0, 0, 0, 0, 0 },
/* U+d056 */ { 0, 0, 0, 0, 0 },
/* U+d057 */ { 0, 0, 0, 0, 0 },
/* U+d058 */ { 0, 0, 0, 0, 0 },
/* U+d059 */ { 0, 0, 0, 0, 0 },
/* U+d05a */ { 0, 0, 0, 0, 0 },
/* U+d05b */ { 0, 0, 0, 0, 0 },
/* U+d05c */ { 0, 0, 0, 0, 0 },
/* U+d05d */ { 0, 0, 0, 0, 0 },
/* U+d05e */ { 0, 0, 0, 0, 0 },
/* U+d05f */ { 0, 0, 0, 0, 0 },
/* U+d060 */ { 0, 0, 0, 0, 0 },
/* U+d061 */ { 0, 0, 0, 0, 0 },
/* U+d062 */ { 0, 0, 0, 0, 0 },
/* U+d063 */ { 0, 0, 0, 0, 0 },
/* U+d064 */ { 0, 0, 0, 0, 0 },
/* U+d065 */ { 0, 0, 0, 0, 0 },
/* U+d066 */ { 0, 0, 0, 0, 0 },
/* U+d067 */ { 0, 0, 0, 0, 0 },
/* U+d068 */ { 0, 0, 0, 0, 0 },
/* U+d069 */ { 0, 0, 0, 0, 0 },
/* U+d06a */ { 0, 0, 0, 0, 0 },
/* U+d06b */ { 0, 0, 0, 0, 0 },
/* U+d06c */ { 0, 0, 0, 0, 0 },
/* U+d06d */ { 0, 0, 0, 0, 0 },
/* U+d06e */ { 0, 0, 0, 0, 0 },
/* U+d06f */ { 0, 0, 0, 0, 0 },
/* U+d070 */ { 0, 0, 0, 0, 0 },
/* U+d071 */ { 0, 0, 0, 0, 0 },
/* U+d072 */ { 0, 0, 0, 0, 0 },
/* U+d073 */ { 0, 0, 0, 0, 0 },
/* U+d074 */ { 0, 0, 0, 0, 0 },
/* U+d075 */ { 0, 0, 0, 0, 0 },
/* U+d076 */ { 0, 0, 0, 0, 0 },
/* U+d077 */ { 0, 0, 0, 0, 0 },
/* U+d078 */ { 0, 0, 0, 0, 0 },
/* U+d079 */ { 0, 0, 0, 0, 0 },
/* U+d07a */ { 0, 0, 0, 0, 0 },
/* U+d07b */ { 0, 0, 0, 0, 0 },
/* U+d07c */ { 0, 0, 0, 0, 0 },
/* U+d07d */ { 0, 0, 0, 0, 0 },
/* U+d07e */ { 0, 0, 0, 0, 0 },
/* U+d07f */ { 0, 0, 0, 0, 0 },
/* U+d080 */ { 0, 0, 0, 0, 0 },
/* U+d081 */ { 0, 0, 0, 0, 0 },
/* U+d082 */ { 0, 0, 0, 0, 0 },
/* U+d083 */ { 0, 0, 0, 0, 0 },
/* U+d084 */ { 0, 0, 0, 0, 0 },
/* U+d085 */ { 0, 0, 0, 0, 0 },
/* U+d086 */ { 0, 0, 0, 0, 0 },
/* U+d087 */ { 0, 0, 0, 0, 0 },
/* U+d088 */ { 0, 0, 0, 0, 0 },
/* U+d089 */ { 0, 0, 0, 0, 0 },
/* U+d08a */ { 0, 0, 0, 0, 0 },
/* U+d08b */ { 0, 0, 0, 0, 0 },
/* U+d08c */ { 0, 0, 0, 0, 0 },
/* U+d08d */ { 0, 0, 0, 0, 0 },
/* U+d08e */ { 0, 0, 0, 0, 0 },
/* U+d08f */ { 0, 0, 0, 0, 0 },
/* U+d090 */ { 0, 0, 0, 0, 0 },
/* U+d091 */ { 0, 0, 0, 0, 0 },
/* U+d092 */ { 0, 0, 0, 0, 0 },
/* U+d093 */ { 0, 0, 0, 0, 0 },
/* U+d094 */ { 0, 0, 0, 0, 0 },
/* U+d095 */ { 0, 0, 0, 0, 0 },
/* U+d096 */ { 0, 0, 0, 0, 0 },
/* U+d097 */ { 0, 0, 0, 0, 0 },
/* U+d098 */ { 0, 0, 0, 0, 0 },
/* U+d099 */ { 0, 0, 0, 0, 0 },
/* U+d09a */ { 0, 0, 0, 0, 0 },
/* U+d09b */ { 0, 0, 0, 0, 0 },
/* U+d09c */ { 0, 0, 0, 0, 0 },
/* U+d09d */ { 0, 0, 0, 0, 0 },
/* U+d09e */ { 0, 0, 0, 0, 0 },
/* U+d09f */ { 0, 0, 0, 0, 0 },
/* U+d0a0 */ { 0, 0, 0, 0, 0 },
/* U+d0a1 */ { 0, 0, 0, 0, 0 },
/* U+d0a2 */ { 0, 0, 0, 0, 0 },
/* U+d0a3 */ { 0, 0, 0, 0, 0 },
/* U+d0a4 */ { 0, 0, 0, 0, 0 },
/* U+d0a5 */ { 0, 0, 0, 0, 0 },
/* U+d0a6 */ { 0, 0, 0, 0, 0 },
/* U+d0a7 */ { 0, 0, 0, 0, 0 },
/* U+d0a8 */ { 0, 0, 0, 0, 0 },
/* U+d0a9 */ { 0, 0, 0, 0, 0 },
/* U+d0aa */ { 0, 0, 0, 0, 0 },
/* U+d0ab */ { 0, 0, 0, 0, 0 },
/* U+d0ac */ { 0, 0, 0, 0, 0 },
/* U+d0ad */ { 0, 0, 0, 0, 0 },
/* U+d0ae */ { 0, 0, 0, 0, 0 },
/* U+d0af */ { 0, 0, 0, 0, 0 },
/* U+d0b0 */ { 0, 0, 0, 0, 0 },
/* U+d0b1 */ { 0, 0, 0, 0, 0 },
/* U+d0b2 */ { 0, 0, 0, 0, 0 },
/* U+d0b3 */ { 0, 0, 0, 0, 0 },
/* U+d0b4 */ { 0, 0, 0, 0, 0 },
/* U+d0b5 */ { 0, 0, 0, 0, 0 },
/* U+d0b6 */ { 0, 0, 0, 0, 0 },
/* U+d0b7 */ { 0, 0, 0, 0, 0 },
/* U+d0b8 */ { 0, 0, 0, 0, 0 },
/* U+d0b9 */ { 0, 0, 0, 0, 0 },
/* U+d0ba */ { 0, 0, 0, 0, 0 },
/* U+d0bb */ { 0, 0, 0, 0, 0 },
/* U+d0bc */ { 0, 0, 0, 0, 0 },
/* U+d0bd */ { 0, 0, 0, 0, 0 },
/* U+d0be */ { 0, 0, 0, 0, 0 },
/* U+d0bf */ { 0, 0, 0, 0, 0 },
/* U+d0c0 */ { 0, 0, 0, 0, 0 },
/* U+d0c1 */ { 0, 0, 0, 0, 0 },
/* U+d0c2 */ { 0, 0, 0, 0, 0 },
/* U+d0c3 */ { 0, 0, 0, 0, 0 },
/* U+d0c4 */ { 0, 0, 0, 0, 0 },
/* U+d0c5 */ { 0, 0, 0, 0, 0 },
/* U+d0c6 */ { 0, 0, 0, 0, 0 },
/* U+d0c7 */ { 0, 0, 0, 0, 0 },
/* U+d0c8 */ { 0, 0, 0, 0, 0 },
/* U+d0c9 */ { 0, 0, 0, 0, 0 },
/* U+d0ca */ { 0, 0, 0, 0, 0 },
/* U+d0cb */ { 0, 0, 0, 0, 0 },
/* U+d0cc */ { 0, 0, 0, 0, 0 },
/* U+d0cd */ { 0, 0, 0, 0, 0 },
/* U+d0ce */ { 0, 0, 0, 0, 0 },
/* U+d0cf */ { 0, 0, 0, 0, 0 },
/* U+d0d0 */ { 0, 0, 0, 0, 0 },
/* U+d0d1 */ { 0, 0, 0, 0, 0 },
/* U+d0d2 */ { 0, 0, 0, 0, 0 },
/* U+d0d3 */ { 0, 0, 0, 0, 0 },
/* U+d0d4 */ { 0, 0, 0, 0, 0 },
/* U+d0d5 */ { 0, 0, 0, 0, 0 },
/* U+d0d6 */ { 0, 0, 0, 0, 0 },
/* U+d0d7 */ { 0, 0, 0, 0, 0 },
/* U+d0d8 */ { 0, 0, 0, 0, 0 },
/* U+d0d9 */ { 0, 0, 0, 0, 0 },
/* U+d0da */ { 0, 0, 0, 0, 0 },
/* U+d0db */ { 0, 0, 0, 0, 0 },
/* U+d0dc */ { 0, 0, 0, 0, 0 },
/* U+d0dd */ { 0, 0, 0, 0, 0 },
/* U+d0de */ { 0, 0, 0, 0, 0 },
/* U+d0df */ { 0, 0, 0, 0, 0 },
/* U+d0e0 */ { 0, 0, 0, 0, 0 },
/* U+d0e1 */ { 0, 0, 0, 0, 0 },
/* U+d0e2 */ { 0, 0, 0, 0, 0 },
/* U+d0e3 */ { 0, 0, 0, 0, 0 },
/* U+d0e4 */ { 0, 0, 0, 0, 0 },
/* U+d0e5 */ { 0, 0, 0, 0, 0 },
/* U+d0e6 */ { 0, 0, 0, 0, 0 },
/* U+d0e7 */ { 0, 0, 0, 0, 0 },
/* U+d0e8 */ { 0, 0, 0, 0, 0 },
/* U+d0e9 */ { 0, 0, 0, 0, 0 },
/* U+d0ea */ { 0, 0, 0, 0, 0 },
/* U+d0eb */ { 0, 0, 0, 0, 0 },
/* U+d0ec */ { 0, 0, 0, 0, 0 },
/* U+d0ed */ { 0, 0, 0, 0, 0 },
/* U+d0ee */ { 0, 0, 0, 0, 0 },
/* U+d0ef */ { 0, 0, 0, 0, 0 },
/* U+d0f0 */ { 0, 0, 0, 0, 0 },
/* U+d0f1 */ { 0, 0, 0, 0, 0 },
/* U+d0f2 */ { 0, 0, 0, 0, 0 },
/* U+d0f3 */ { 0, 0, 0, 0, 0 },
/* U+d0f4 */ { 0, 0, 0, 0, 0 },
/* U+d0f5 */ { 0, 0, 0, 0, 0 },
/* U+d0f6 */ { 0, 0, 0, 0, 0 },
/* U+d0f7 */ { 0, 0, 0, 0, 0 },
/* U+d0f8 */ { 0, 0, 0, 0, 0 },
/* U+d0f9 */ { 0, 0, 0, 0, 0 },
/* U+d0fa */ { 0, 0, 0, 0, 0 },
/* U+d0fb */ { 0, 0, 0, 0, 0 },
/* U+d0fc */ { 0, 0, 0, 0, 0 },
/* U+d0fd */ { 0, 0, 0, 0, 0 },
/* U+d0fe */ { 0, 0, 0, 0, 0 },
/* U+d0ff */ { 0, 0, 0, 0, 0 },
/* U+d100 */ { 0, 0, 0, 0, 0 },
/* U+d101 */ { 0, 0, 0, 0, 0 },
/* U+d102 */ { 0, 0, 0, 0, 0 },
/* U+d103 */ { 0, 0, 0, 0, 0 },
/* U+d104 */ { 0, 0, 0, 0, 0 },
/* U+d105 */ { 0, 0, 0, 0, 0 },
/* U+d106 */ { 0, 0, 0, 0, 0 },
/* U+d107 */ { 0, 0, 0, 0, 0 },
/* U+d108 */ { 0, 0, 0, 0, 0 },
/* U+d109 */ { 0, 0, 0, 0, 0 },
/* U+d10a */ { 0, 0, 0, 0, 0 },
/* U+d10b */ { 0, 0, 0, 0, 0 },
/* U+d10c */ { 0, 0, 0, 0, 0 },
/* U+d10d */ { 0, 0, 0, 0, 0 },
/* U+d10e */ { 0, 0, 0, 0, 0 },
/* U+d10f */ { 0, 0, 0, 0, 0 },
/* U+d110 */ { 0, 0, 0, 0, 0 },
/* U+d111 */ { 0, 0, 0, 0, 0 },
/* U+d112 */ { 0, 0, 0, 0, 0 },
/* U+d113 */ { 0, 0, 0, 0, 0 },
/* U+d114 */ { 0, 0, 0, 0, 0 },
/* U+d115 */ { 0, 0, 0, 0, 0 },
/* U+d116 */ { 0, 0, 0, 0, 0 },
/* U+d117 */ { 0, 0, 0, 0, 0 },
/* U+d118 */ { 0, 0, 0, 0, 0 },
/* U+d119 */ { 0, 0, 0, 0, 0 },
/* U+d11a */ { 0, 0, 0, 0, 0 },
/* U+d11b */ { 0, 0, 0, 0, 0 },
/* U+d11c */ { 0, 0, 0, 0, 0 },
/* U+d11d */ { 0, 0, 0, 0, 0 },
/* U+d11e */ { 0, 0, 0, 0, 0 },
/* U+d11f */ { 0, 0, 0, 0, 0 },
/* U+d120 */ { 0, 0, 0, 0, 0 },
/* U+d121 */ { 0, 0, 0, 0, 0 },
/* U+d122 */ { 0, 0, 0, 0, 0 },
/* U+d123 */ { 0, 0, 0, 0, 0 },
/* U+d124 */ { 0, 0, 0, 0, 0 },
/* U+d125 */ { 0, 0, 0, 0, 0 },
/* U+d126 */ { 0, 0, 0, 0, 0 },
/* U+d127 */ { 0, 0, 0, 0, 0 },
/* U+d128 */ { 0, 0, 0, 0, 0 },
/* U+d129 */ { 0, 0, 0, 0, 0 },
/* U+d12a */ { 0, 0, 0, 0, 0 },
/* U+d12b */ { 0, 0, 0, 0, 0 },
/* U+d12c */ { 0, 0, 0, 0, 0 },
/* U+d12d */ { 0, 0, 0, 0, 0 },
/* U+d12e */ { 0, 0, 0, 0, 0 },
/* U+d12f */ { 0, 0, 0, 0, 0 },
/* U+d130 */ { 0, 0, 0, 0, 0 },
/* U+d131 */ { 0, 0, 0, 0, 0 },
/* U+d132 */ { 0, 0, 0, 0, 0 },
/* U+d133 */ { 0, 0, 0, 0, 0 },
/* U+d134 */ { 0, 0, 0, 0, 0 },
/* U+d135 */ { 0, 0, 0, 0, 0 },
/* U+d136 */ { 0, 0, 0, 0, 0 },
/* U+d137 */ { 0, 0, 0, 0, 0 },
/* U+d138 */ { 0, 0, 0, 0, 0 },
/* U+d139 */ { 0, 0, 0, 0, 0 },
/* U+d13a */ { 0, 0, 0, 0, 0 },
/* U+d13b */ { 0, 0, 0, 0, 0 },
/* U+d13c */ { 0, 0, 0, 0, 0 },
/* U+d13d */ { 0, 0, 0, 0, 0 },
/* U+d13e */ { 0, 0, 0, 0, 0 },
/* U+d13f */ { 0, 0, 0, 0, 0 },
/* U+d140 */ { 0, 0, 0, 0, 0 },
/* U+d141 */ { 0, 0, 0, 0, 0 },
/* U+d142 */ { 0, 0, 0, 0, 0 },
/* U+d143 */ { 0, 0, 0, 0, 0 },
/* U+d144 */ { 0, 0, 0, 0, 0 },
/* U+d145 */ { 0, 0, 0, 0, 0 },
/* U+d146 */ { 0, 0, 0, 0, 0 },
/* U+d147 */ { 0, 0, 0, 0, 0 },
/* U+d148 */ { 0, 0, 0, 0, 0 },
/* U+d149 */ { 0, 0, 0, 0, 0 },
/* U+d14a */ { 0, 0, 0, 0, 0 },
/* U+d14b */ { 0, 0, 0, 0, 0 },
/* U+d14c */ { 0, 0, 0, 0, 0 },
/* U+d14d */ { 0, 0, 0, 0, 0 },
/* U+d14e */ { 0, 0, 0, 0, 0 },
/* U+d14f */ { 0, 0, 0, 0, 0 },
/* U+d150 */ { 0, 0, 0, 0, 0 },
/* U+d151 */ { 0, 0, 0, 0, 0 },
/* U+d152 */ { 0, 0, 0, 0, 0 },
/* U+d153 */ { 0, 0, 0, 0, 0 },
/* U+d154 */ { 0, 0, 0, 0, 0 },
/* U+d155 */ { 0, 0, 0, 0, 0 },
/* U+d156 */ { 0, 0, 0, 0, 0 },
/* U+d157 */ { 0, 0, 0, 0, 0 },
/* U+d158 */ { 0, 0, 0, 0, 0 },
/* U+d159 */ { 0, 0, 0, 0, 0 },
/* U+d15a */ { 0, 0, 0, 0, 0 },
/* U+d15b */ { 0, 0, 0, 0, 0 },
/* U+d15c */ { 0, 0, 0, 0, 0 },
/* U+d15d */ { 0, 0, 0, 0, 0 },
/* U+d15e */ { 0, 0, 0, 0, 0 },
/* U+d15f */ { 0, 0, 0, 0, 0 },
/* U+d160 */ { 0, 0, 0, 0, 0 },
/* U+d161 */ { 0, 0, 0, 0, 0 },
/* U+d162 */ { 0, 0, 0, 0, 0 },
/* U+d163 */ { 0, 0, 0, 0, 0 },
/* U+d164 */ { 0, 0, 0, 0, 0 },
/* U+d165 */ { 0, 0, 0, 0, 0 },
/* U+d166 */ { 0, 0, 0, 0, 0 },
/* U+d167 */ { 0, 0, 0, 0, 0 },
/* U+d168 */ { 0, 0, 0, 0, 0 },
/* U+d169 */ { 0, 0, 0, 0, 0 },
/* U+d16a */ { 0, 0, 0, 0, 0 },
/* U+d16b */ { 0, 0, 0, 0, 0 },
/* U+d16c */ { 0, 0, 0, 0, 0 },
/* U+d16d */ { 0, 0, 0, 0, 0 },
/* U+d16e */ { 0, 0, 0, 0, 0 },
/* U+d16f */ { 0, 0, 0, 0, 0 },
/* U+d170 */ { 0, 0, 0, 0, 0 },
/* U+d171 */ { 0, 0, 0, 0, 0 },
/* U+d172 */ { 0, 0, 0, 0, 0 },
/* U+d173 */ { 0, 0, 0, 0, 0 },
/* U+d174 */ { 0, 0, 0, 0, 0 },
/* U+d175 */ { 0, 0, 0, 0, 0 },
/* U+d176 */ { 0, 0, 0, 0, 0 },
/* U+d177 */ { 0, 0, 0, 0, 0 },
/* U+d178 */ { 0, 0, 0, 0, 0 },
/* U+d179 */ { 0, 0, 0, 0, 0 },
/* U+d17a */ { 0, 0, 0, 0, 0 },
/* U+d17b */ { 0, 0, 0, 0, 0 },
/* U+d17c */ { 0, 0, 0, 0, 0 },
/* U+d17d */ { 0, 0, 0, 0, 0 },
/* U+d17e */ { 0, 0, 0, 0, 0 },
/* U+d17f */ { 0, 0, 0, 0, 0 },
/* U+d180 */ { 0, 0, 0, 0, 0 },
/* U+d181 */ { 0, 0, 0, 0, 0 },
/* U+d182 */ { 0, 0, 0, 0, 0 },
/* U+d183 */ { 0, 0, 0, 0, 0 },
/* U+d184 */ { 0, 0, 0, 0, 0 },
/* U+d185 */ { 0, 0, 0, 0, 0 },
/* U+d186 */ { 0, 0, 0, 0, 0 },
/* U+d187 */ { 0, 0, 0, 0, 0 },
/* U+d188 */ { 0, 0, 0, 0, 0 },
/* U+d189 */ { 0, 0, 0, 0, 0 },
/* U+d18a */ { 0, 0, 0, 0, 0 },
/* U+d18b */ { 0, 0, 0, 0, 0 },
/* U+d18c */ { 0, 0, 0, 0, 0 },
/* U+d18d */ { 0, 0, 0, 0, 0 },
/* U+d18e */ { 0, 0, 0, 0, 0 },
/* U+d18f */ { 0, 0, 0, 0, 0 },
/* U+d190 */ { 0, 0, 0, 0, 0 },
/* U+d191 */ { 0, 0, 0, 0, 0 },
/* U+d192 */ { 0, 0, 0, 0, 0 },
/* U+d193 */ { 0, 0, 0, 0, 0 },
/* U+d194 */ { 0, 0, 0, 0, 0 },
/* U+d195 */ { 0, 0, 0, 0, 0 },
/* U+d196 */ { 0, 0, 0, 0, 0 },
/* U+d197 */ { 0, 0, 0, 0, 0 },
/* U+d198 */ { 0, 0, 0, 0, 0 },
/* U+d199 */ { 0, 0, 0, 0, 0 },
/* U+d19a */ { 0, 0, 0, 0, 0 },
/* U+d19b */ { 0, 0, 0, 0, 0 },
/* U+d19c */ { 0, 0, 0, 0, 0 },
/* U+d19d */ { 0, 0, 0, 0, 0 },
/* U+d19e */ { 0, 0, 0, 0, 0 },
/* U+d19f */ { 0, 0, 0, 0, 0 },
/* U+d1a0 */ { 0, 0, 0, 0, 0 },
/* U+d1a1 */ { 0, 0, 0, 0, 0 },
/* U+d1a2 */ { 0, 0, 0, 0, 0 },
/* U+d1a3 */ { 0, 0, 0, 0, 0 },
/* U+d1a4 */ { 0, 0, 0, 0, 0 },
/* U+d1a5 */ { 0, 0, 0, 0, 0 },
/* U+d1a6 */ { 0, 0, 0, 0, 0 },
/* U+d1a7 */ { 0, 0, 0, 0, 0 },
/* U+d1a8 */ { 0, 0, 0, 0, 0 },
/* U+d1a9 */ { 0, 0, 0, 0, 0 },
/* U+d1aa */ { 0, 0, 0, 0, 0 },
/* U+d1ab */ { 0, 0, 0, 0, 0 },
/* U+d1ac */ { 0, 0, 0, 0, 0 },
/* U+d1ad */ { 0, 0, 0, 0, 0 },
/* U+d1ae */ { 0, 0, 0, 0, 0 },
/* U+d1af */ { 0, 0, 0, 0, 0 },
/* U+d1b0 */ { 0, 0, 0, 0, 0 },
/* U+d1b1 */ { 0, 0, 0, 0, 0 },
/* U+d1b2 */ { 0, 0, 0, 0, 0 },
/* U+d1b3 */ { 0, 0, 0, 0, 0 },
/* U+d1b4 */ { 0, 0, 0, 0, 0 },
/* U+d1b5 */ { 0, 0, 0, 0, 0 },
/* U+d1b6 */ { 0, 0, 0, 0, 0 },
/* U+d1b7 */ { 0, 0, 0, 0, 0 },
/* U+d1b8 */ { 0, 0, 0, 0, 0 },
/* U+d1b9 */ { 0, 0, 0, 0, 0 },
/* U+d1ba */ { 0, 0, 0, 0, 0 },
/* U+d1bb */ { 0, 0, 0, 0, 0 },
/* U+d1bc */ { 0, 0, 0, 0, 0 },
/* U+d1bd */ { 0, 0, 0, 0, 0 },
/* U+d1be */ { 0, 0, 0, 0, 0 },
/* U+d1bf */ { 0, 0, 0, 0, 0 },
/* U+d1c0 */ { 0, 0, 0, 0, 0 },
/* U+d1c1 */ { 0, 0, 0, 0, 0 },
/* U+d1c2 */ { 0, 0, 0, 0, 0 },
/* U+d1c3 */ { 0, 0, 0, 0, 0 },
/* U+d1c4 */ { 0, 0, 0, 0, 0 },
/* U+d1c5 */ { 0, 0, 0, 0, 0 },
/* U+d1c6 */ { 0, 0, 0, 0, 0 },
/* U+d1c7 */ { 0, 0, 0, 0, 0 },
/* U+d1c8 */ { 0, 0, 0, 0, 0 },
/* U+d1c9 */ { 0, 0, 0, 0, 0 },
/* U+d1ca */ { 0, 0, 0, 0, 0 },
/* U+d1cb */ { 0, 0, 0, 0, 0 },
/* U+d1cc */ { 0, 0, 0, 0, 0 },
/* U+d1cd */ { 0, 0, 0, 0, 0 },
/* U+d1ce */ { 0, 0, 0, 0, 0 },
/* U+d1cf */ { 0, 0, 0, 0, 0 },
/* U+d1d0 */ { 0, 0, 0, 0, 0 },
/* U+d1d1 */ { 0, 0, 0, 0, 0 },
/* U+d1d2 */ { 0, 0, 0, 0, 0 },
/* U+d1d3 */ { 0, 0, 0, 0, 0 },
/* U+d1d4 */ { 0, 0, 0, 0, 0 },
/* U+d1d5 */ { 0, 0, 0, 0, 0 },
/* U+d1d6 */ { 0, 0, 0, 0, 0 },
/* U+d1d7 */ { 0, 0, 0, 0, 0 },
/* U+d1d8 */ { 0, 0, 0, 0, 0 },
/* U+d1d9 */ { 0, 0, 0, 0, 0 },
/* U+d1da */ { 0, 0, 0, 0, 0 },
/* U+d1db */ { 0, 0, 0, 0, 0 },
/* U+d1dc */ { 0, 0, 0, 0, 0 },
/* U+d1dd */ { 0, 0, 0, 0, 0 },
/* U+d1de */ { 0, 0, 0, 0, 0 },
/* U+d1df */ { 0, 0, 0, 0, 0 },
/* U+d1e0 */ { 0, 0, 0, 0, 0 },
/* U+d1e1 */ { 0, 0, 0, 0, 0 },
/* U+d1e2 */ { 0, 0, 0, 0, 0 },
/* U+d1e3 */ { 0, 0, 0, 0, 0 },
/* U+d1e4 */ { 0, 0, 0, 0, 0 },
/* U+d1e5 */ { 0, 0, 0, 0, 0 },
/* U+d1e6 */ { 0, 0, 0, 0, 0 },
/* U+d1e7 */ { 0, 0, 0, 0, 0 },
/* U+d1e8 */ { 0, 0, 0, 0, 0 },
/* U+d1e9 */ { 0, 0, 0, 0, 0 },
/* U+d1ea */ { 0, 0, 0, 0, 0 },
/* U+d1eb */ { 0, 0, 0, 0, 0 },
/* U+d1ec */ { 0, 0, 0, 0, 0 },
/* U+d1ed */ { 0, 0, 0, 0, 0 },
/* U+d1ee */ { 0, 0, 0, 0, 0 },
/* U+d1ef */ { 0, 0, 0, 0, 0 },
/* U+d1f0 */ { 0, 0, 0, 0, 0 },
/* U+d1f1 */ { 0, 0, 0, 0, 0 },
/* U+d1f2 */ { 0, 0, 0, 0, 0 },
/* U+d1f3 */ { 0, 0, 0, 0, 0 },
/* U+d1f4 */ { 0, 0, 0, 0, 0 },
/* U+d1f5 */ { 0, 0, 0, 0, 0 },
/* U+d1f6 */ { 0, 0, 0, 0, 0 },
/* U+d1f7 */ { 0, 0, 0, 0, 0 },
/* U+d1f8 */ { 0, 0, 0, 0, 0 },
/* U+d1f9 */ { 0, 0, 0, 0, 0 },
/* U+d1fa */ { 0, 0, 0, 0, 0 },
/* U+d1fb */ { 0, 0, 0, 0, 0 },
/* U+d1fc */ { 0, 0, 0, 0, 0 },
/* U+d1fd */ { 0, 0, 0, 0, 0 },
/* U+d1fe */ { 0, 0, 0, 0, 0 },
/* U+d1ff */ { 0, 0, 0, 0, 0 },
/* U+d200 */ { 0, 0, 0, 0, 0 },
/* U+d201 */ { 0, 0, 0, 0, 0 },
/* U+d202 */ { 0, 0, 0, 0, 0 },
/* U+d203 */ { 0, 0, 0, 0, 0 },
/* U+d204 */ { 0, 0, 0, 0, 0 },
/* U+d205 */ { 0, 0, 0, 0, 0 },
/* U+d206 */ { 0, 0, 0, 0, 0 },
/* U+d207 */ { 0, 0, 0, 0, 0 },
/* U+d208 */ { 0, 0, 0, 0, 0 },
/* U+d209 */ { 0, 0, 0, 0, 0 },
/* U+d20a */ { 0, 0, 0, 0, 0 },
/* U+d20b */ { 0, 0, 0, 0, 0 },
/* U+d20c */ { 0, 0, 0, 0, 0 },
/* U+d20d */ { 0, 0, 0, 0, 0 },
/* U+d20e */ { 0, 0, 0, 0, 0 },
/* U+d20f */ { 0, 0, 0, 0, 0 },
/* U+d210 */ { 0, 0, 0, 0, 0 },
/* U+d211 */ { 0, 0, 0, 0, 0 },
/* U+d212 */ { 0, 0, 0, 0, 0 },
/* U+d213 */ { 0, 0, 0, 0, 0 },
/* U+d214 */ { 0, 0, 0, 0, 0 },
/* U+d215 */ { 0, 0, 0, 0, 0 },
/* U+d216 */ { 0, 0, 0, 0, 0 },
/* U+d217 */ { 0, 0, 0, 0, 0 },
/* U+d218 */ { 0, 0, 0, 0, 0 },
/* U+d219 */ { 0, 0, 0, 0, 0 },
/* U+d21a */ { 0, 0, 0, 0, 0 },
/* U+d21b */ { 0, 0, 0, 0, 0 },
/* U+d21c */ { 0, 0, 0, 0, 0 },
/* U+d21d */ { 0, 0, 0, 0, 0 },
/* U+d21e */ { 0, 0, 0, 0, 0 },
/* U+d21f */ { 0, 0, 0, 0, 0 },
/* U+d220 */ { 0, 0, 0, 0, 0 },
/* U+d221 */ { 0, 0, 0, 0, 0 },
/* U+d222 */ { 0, 0, 0, 0, 0 },
/* U+d223 */ { 0, 0, 0, 0, 0 },
/* U+d224 */ { 0, 0, 0, 0, 0 },
/* U+d225 */ { 0, 0, 0, 0, 0 },
/* U+d226 */ { 0, 0, 0, 0, 0 },
/* U+d227 */ { 0, 0, 0, 0, 0 },
/* U+d228 */ { 0, 0, 0, 0, 0 },
/* U+d229 */ { 0, 0, 0, 0, 0 },
/* U+d22a */ { 0, 0, 0, 0, 0 },
/* U+d22b */ { 0, 0, 0, 0, 0 },
/* U+d22c */ { 0, 0, 0, 0, 0 },
/* U+d22d */ { 0, 0, 0, 0, 0 },
/* U+d22e */ { 0, 0, 0, 0, 0 },
/* U+d22f */ { 0, 0, 0, 0, 0 },
/* U+d230 */ { 0, 0, 0, 0, 0 },
/* U+d231 */ { 0, 0, 0, 0, 0 },
/* U+d232 */ { 0, 0, 0, 0, 0 },
/* U+d233 */ { 0, 0, 0, 0, 0 },
/* U+d234 */ { 0, 0, 0, 0, 0 },
/* U+d235 */ { 0, 0, 0, 0, 0 },
/* U+d236 */ { 0, 0, 0, 0, 0 },
/* U+d237 */ { 0, 0, 0, 0, 0 },
/* U+d238 */ { 0, 0, 0, 0, 0 },
/* U+d239 */ { 0, 0, 0, 0, 0 },
/* U+d23a */ { 0, 0, 0, 0, 0 },
/* U+d23b */ { 0, 0, 0, 0, 0 },
/* U+d23c */ { 0, 0, 0, 0, 0 },
/* U+d23d */ { 0, 0, 0, 0, 0 },
/* U+d23e */ { 0, 0, 0, 0, 0 },
/* U+d23f */ { 0, 0, 0, 0, 0 },
/* U+d240 */ { 0, 0, 0, 0, 0 },
/* U+d241 */ { 0, 0, 0, 0, 0 },
/* U+d242 */ { 0, 0, 0, 0, 0 },
/* U+d243 */ { 0, 0, 0, 0, 0 },
/* U+d244 */ { 0, 0, 0, 0, 0 },
/* U+d245 */ { 0, 0, 0, 0, 0 },
/* U+d246 */ { 0, 0, 0, 0, 0 },
/* U+d247 */ { 0, 0, 0, 0, 0 },
/* U+d248 */ { 0, 0, 0, 0, 0 },
/* U+d249 */ { 0, 0, 0, 0, 0 },
/* U+d24a */ { 0, 0, 0, 0, 0 },
/* U+d24b */ { 0, 0, 0, 0, 0 },
/* U+d24c */ { 0, 0, 0, 0, 0 },
/* U+d24d */ { 0, 0, 0, 0, 0 },
/* U+d24e */ { 0, 0, 0, 0, 0 },
/* U+d24f */ { 0, 0, 0, 0, 0 },
/* U+d250 */ { 0, 0, 0, 0, 0 },
/* U+d251 */ { 0, 0, 0, 0, 0 },
/* U+d252 */ { 0, 0, 0, 0, 0 },
/* U+d253 */ { 0, 0, 0, 0, 0 },
/* U+d254 */ { 0, 0, 0, 0, 0 },
/* U+d255 */ { 0, 0, 0, 0, 0 },
/* U+d256 */ { 0, 0, 0, 0, 0 },
/* U+d257 */ { 0, 0, 0, 0, 0 },
/* U+d258 */ { 0, 0, 0, 0, 0 },
/* U+d259 */ { 0, 0, 0, 0, 0 },
/* U+d25a */ { 0, 0, 0, 0, 0 },
/* U+d25b */ { 0, 0, 0, 0, 0 },
/* U+d25c */ { 0, 0, 0, 0, 0 },
/* U+d25d */ { 0, 0, 0, 0, 0 },
/* U+d25e */ { 0, 0, 0, 0, 0 },
/* U+d25f */ { 0, 0, 0, 0, 0 },
/* U+d260 */ { 0, 0, 0, 0, 0 },
/* U+d261 */ { 0, 0, 0, 0, 0 },
/* U+d262 */ { 0, 0, 0, 0, 0 },
/* U+d263 */ { 0, 0, 0, 0, 0 },
/* U+d264 */ { 0, 0, 0, 0, 0 },
/* U+d265 */ { 0, 0, 0, 0, 0 },
/* U+d266 */ { 0, 0, 0, 0, 0 },
/* U+d267 */ { 0, 0, 0, 0, 0 },
/* U+d268 */ { 0, 0, 0, 0, 0 },
/* U+d269 */ { 0, 0, 0, 0, 0 },
/* U+d26a */ { 0, 0, 0, 0, 0 },
/* U+d26b */ { 0, 0, 0, 0, 0 },
/* U+d26c */ { 0, 0, 0, 0, 0 },
/* U+d26d */ { 0, 0, 0, 0, 0 },
/* U+d26e */ { 0, 0, 0, 0, 0 },
/* U+d26f */ { 0, 0, 0, 0, 0 },
/* U+d270 */ { 0, 0, 0, 0, 0 },
/* U+d271 */ { 0, 0, 0, 0, 0 },
/* U+d272 */ { 0, 0, 0, 0, 0 },
/* U+d273 */ { 0, 0, 0, 0, 0 },
/* U+d274 */ { 0, 0, 0, 0, 0 },
/* U+d275 */ { 0, 0, 0, 0, 0 },
/* U+d276 */ { 0, 0, 0, 0, 0 },
/* U+d277 */ { 0, 0, 0, 0, 0 },
/* U+d278 */ { 0, 0, 0, 0, 0 },
/* U+d279 */ { 0, 0, 0, 0, 0 },
/* U+d27a */ { 0, 0, 0, 0, 0 },
/* U+d27b */ { 0, 0, 0, 0, 0 },
/* U+d27c */ { 0, 0, 0, 0, 0 },
/* U+d27d */ { 0, 0, 0, 0, 0 },
/* U+d27e */ { 0, 0, 0, 0, 0 },
/* U+d27f */ { 0, 0, 0, 0, 0 },
/* U+d280 */ { 0, 0, 0, 0, 0 },
/* U+d281 */ { 0, 0, 0, 0, 0 },
/* U+d282 */ { 0, 0, 0, 0, 0 },
/* U+d283 */ { 0, 0, 0, 0, 0 },
/* U+d284 */ { 0, 0, 0, 0, 0 },
/* U+d285 */ { 0, 0, 0, 0, 0 },
/* U+d286 */ { 0, 0, 0, 0, 0 },
/* U+d287 */ { 0, 0, 0, 0, 0 },
/* U+d288 */ { 0, 0, 0, 0, 0 },
/* U+d289 */ { 0, 0, 0, 0, 0 },
/* U+d28a */ { 0, 0, 0, 0, 0 },
/* U+d28b */ { 0, 0, 0, 0, 0 },
/* U+d28c */ { 0, 0, 0, 0, 0 },
/* U+d28d */ { 0, 0, 0, 0, 0 },
/* U+d28e */ { 0, 0, 0, 0, 0 },
/* U+d28f */ { 0, 0, 0, 0, 0 },
/* U+d290 */ { 0, 0, 0, 0, 0 },
/* U+d291 */ { 0, 0, 0, 0, 0 },
/* U+d292 */ { 0, 0, 0, 0, 0 },
/* U+d293 */ { 0, 0, 0, 0, 0 },
/* U+d294 */ { 0, 0, 0, 0, 0 },
/* U+d295 */ { 0, 0, 0, 0, 0 },
/* U+d296 */ { 0, 0, 0, 0, 0 },
/* U+d297 */ { 0, 0, 0, 0, 0 },
/* U+d298 */ { 0, 0, 0, 0, 0 },
/* U+d299 */ { 0, 0, 0, 0, 0 },
/* U+d29a */ { 0, 0, 0, 0, 0 },
/* U+d29b */ { 0, 0, 0, 0, 0 },
/* U+d29c */ { 0, 0, 0, 0, 0 },
/* U+d29d */ { 0, 0, 0, 0, 0 },
/* U+d29e */ { 0, 0, 0, 0, 0 },
/* U+d29f */ { 0, 0, 0, 0, 0 },
/* U+d2a0 */ { 0, 0, 0, 0, 0 },
/* U+d2a1 */ { 0, 0, 0, 0, 0 },
/* U+d2a2 */ { 0, 0, 0, 0, 0 },
/* U+d2a3 */ { 0, 0, 0, 0, 0 },
/* U+d2a4 */ { 0, 0, 0, 0, 0 },
/* U+d2a5 */ { 0, 0, 0, 0, 0 },
/* U+d2a6 */ { 0, 0, 0, 0, 0 },
/* U+d2a7 */ { 0, 0, 0, 0, 0 },
/* U+d2a8 */ { 0, 0, 0, 0, 0 },
/* U+d2a9 */ { 0, 0, 0, 0, 0 },
/* U+d2aa */ { 0, 0, 0, 0, 0 },
/* U+d2ab */ { 0, 0, 0, 0, 0 },
/* U+d2ac */ { 0, 0, 0, 0, 0 },
/* U+d2ad */ { 0, 0, 0, 0, 0 },
/* U+d2ae */ { 0, 0, 0, 0, 0 },
/* U+d2af */ { 0, 0, 0, 0, 0 },
/* U+d2b0 */ { 0, 0, 0, 0, 0 },
/* U+d2b1 */ { 0, 0, 0, 0, 0 },
/* U+d2b2 */ { 0, 0, 0, 0, 0 },
/* U+d2b3 */ { 0, 0, 0, 0, 0 },
/* U+d2b4 */ { 0, 0, 0, 0, 0 },
/* U+d2b5 */ { 0, 0, 0, 0, 0 },
/* U+d2b6 */ { 0, 0, 0, 0, 0 },
/* U+d2b7 */ { 0, 0, 0, 0, 0 },
/* U+d2b8 */ { 0, 0, 0, 0, 0 },
/* U+d2b9 */ { 0, 0, 0, 0, 0 },
/* U+d2ba */ { 0, 0, 0, 0, 0 },
/* U+d2bb */ { 0, 0, 0, 0, 0 },
/* U+d2bc */ { 0, 0, 0, 0, 0 },
/* U+d2bd */ { 0, 0, 0, 0, 0 },
/* U+d2be */ { 0, 0, 0, 0, 0 },
/* U+d2bf */ { 0, 0, 0, 0, 0 },
/* U+d2c0 */ { 0, 0, 0, 0, 0 },
/* U+d2c1 */ { 0, 0, 0, 0, 0 },
/* U+d2c2 */ { 0, 0, 0, 0, 0 },
/* U+d2c3 */ { 0, 0, 0, 0, 0 },
/* U+d2c4 */ { 0, 0, 0, 0, 0 },
/* U+d2c5 */ { 0, 0, 0, 0, 0 },
/* U+d2c6 */ { 0, 0, 0, 0, 0 },
/* U+d2c7 */ { 0, 0, 0, 0, 0 },
/* U+d2c8 */ { 0, 0, 0, 0, 0 },
/* U+d2c9 */ { 0, 0, 0, 0, 0 },
/* U+d2ca */ { 0, 0, 0, 0, 0 },
/* U+d2cb */ { 0, 0, 0, 0, 0 },
/* U+d2cc */ { 0, 0, 0, 0, 0 },
/* U+d2cd */ { 0, 0, 0, 0, 0 },
/* U+d2ce */ { 0, 0, 0, 0, 0 },
/* U+d2cf */ { 0, 0, 0, 0, 0 },
/* U+d2d0 */ { 0, 0, 0, 0, 0 },
/* U+d2d1 */ { 0, 0, 0, 0, 0 },
/* U+d2d2 */ { 0, 0, 0, 0, 0 },
/* U+d2d3 */ { 0, 0, 0, 0, 0 },
/* U+d2d4 */ { 0, 0, 0, 0, 0 },
/* U+d2d5 */ { 0, 0, 0, 0, 0 },
/* U+d2d6 */ { 0, 0, 0, 0, 0 },
/* U+d2d7 */ { 0, 0, 0, 0, 0 },
/* U+d2d8 */ { 0, 0, 0, 0, 0 },
/* U+d2d9 */ { 0, 0, 0, 0, 0 },
/* U+d2da */ { 0, 0, 0, 0, 0 },
/* U+d2db */ { 0, 0, 0, 0, 0 },
/* U+d2dc */ { 0, 0, 0, 0, 0 },
/* U+d2dd */ { 0, 0, 0, 0, 0 },
/* U+d2de */ { 0, 0, 0, 0, 0 },
/* U+d2df */ { 0, 0, 0, 0, 0 },
/* U+d2e0 */ { 0, 0, 0, 0, 0 },
/* U+d2e1 */ { 0, 0, 0, 0, 0 },
/* U+d2e2 */ { 0, 0, 0, 0, 0 },
/* U+d2e3 */ { 0, 0, 0, 0, 0 },
/* U+d2e4 */ { 0, 0, 0, 0, 0 },
/* U+d2e5 */ { 0, 0, 0, 0, 0 },
/* U+d2e6 */ { 0, 0, 0, 0, 0 },
/* U+d2e7 */ { 0, 0, 0, 0, 0 },
/* U+d2e8 */ { 0, 0, 0, 0, 0 },
/* U+d2e9 */ { 0, 0, 0, 0, 0 },
/* U+d2ea */ { 0, 0, 0, 0, 0 },
/* U+d2eb */ { 0, 0, 0, 0, 0 },
/* U+d2ec */ { 0, 0, 0, 0, 0 },
/* U+d2ed */ { 0, 0, 0, 0, 0 },
/* U+d2ee */ { 0, 0, 0, 0, 0 },
/* U+d2ef */ { 0, 0, 0, 0, 0 },
/* U+d2f0 */ { 0, 0, 0, 0, 0 },
/* U+d2f1 */ { 0, 0, 0, 0, 0 },
/* U+d2f2 */ { 0, 0, 0, 0, 0 },
/* U+d2f3 */ { 0, 0, 0, 0, 0 },
/* U+d2f4 */ { 0, 0, 0, 0, 0 },
/* U+d2f5 */ { 0, 0, 0, 0, 0 },
/* U+d2f6 */ { 0, 0, 0, 0, 0 },
/* U+d2f7 */ { 0, 0, 0, 0, 0 },
/* U+d2f8 */ { 0, 0, 0, 0, 0 },
/* U+d2f9 */ { 0, 0, 0, 0, 0 },
/* U+d2fa */ { 0, 0, 0, 0, 0 },
/* U+d2fb */ { 0, 0, 0, 0, 0 },
/* U+d2fc */ { 0, 0, 0, 0, 0 },
/* U+d2fd */ { 0, 0, 0, 0, 0 },
/* U+d2fe */ { 0, 0, 0, 0, 0 },
/* U+d2ff */ { 0, 0, 0, 0, 0 },
/* U+d300 */ { 0, 0, 0, 0, 0 },
/* U+d301 */ { 0, 0, 0, 0, 0 },
/* U+d302 */ { 0, 0, 0, 0, 0 },
/* U+d303 */ { 0, 0, 0, 0, 0 },
/* U+d304 */ { 0, 0, 0, 0, 0 },
/* U+d305 */ { 0, 0, 0, 0, 0 },
/* U+d306 */ { 0, 0, 0, 0, 0 },
/* U+d307 */ { 0, 0, 0, 0, 0 },
/* U+d308 */ { 0, 0, 0, 0, 0 },
/* U+d309 */ { 0, 0, 0, 0, 0 },
/* U+d30a */ { 0, 0, 0, 0, 0 },
/* U+d30b */ { 0, 0, 0, 0, 0 },
/* U+d30c */ { 0, 0, 0, 0, 0 },
/* U+d30d */ { 0, 0, 0, 0, 0 },
/* U+d30e */ { 0, 0, 0, 0, 0 },
/* U+d30f */ { 0, 0, 0, 0, 0 },
/* U+d310 */ { 0, 0, 0, 0, 0 },
/* U+d311 */ { 0, 0, 0, 0, 0 },
/* U+d312 */ { 0, 0, 0, 0, 0 },
/* U+d313 */ { 0, 0, 0, 0, 0 },
/* U+d314 */ { 0, 0, 0, 0, 0 },
/* U+d315 */ { 0, 0, 0, 0, 0 },
/* U+d316 */ { 0, 0, 0, 0, 0 },
/* U+d317 */ { 0, 0, 0, 0, 0 },
/* U+d318 */ { 0, 0, 0, 0, 0 },
/* U+d319 */ { 0, 0, 0, 0, 0 },
/* U+d31a */ { 0, 0, 0, 0, 0 },
/* U+d31b */ { 0, 0, 0, 0, 0 },
/* U+d31c */ { 0, 0, 0, 0, 0 },
/* U+d31d */ { 0, 0, 0, 0, 0 },
/* U+d31e */ { 0, 0, 0, 0, 0 },
/* U+d31f */ { 0, 0, 0, 0, 0 },
/* U+d320 */ { 0, 0, 0, 0, 0 },
/* U+d321 */ { 0, 0, 0, 0, 0 },
/* U+d322 */ { 0, 0, 0, 0, 0 },
/* U+d323 */ { 0, 0, 0, 0, 0 },
/* U+d324 */ { 0, 0, 0, 0, 0 },
/* U+d325 */ { 0, 0, 0, 0, 0 },
/* U+d326 */ { 0, 0, 0, 0, 0 },
/* U+d327 */ { 0, 0, 0, 0, 0 },
/* U+d328 */ { 0, 0, 0, 0, 0 },
/* U+d329 */ { 0, 0, 0, 0, 0 },
/* U+d32a */ { 0, 0, 0, 0, 0 },
/* U+d32b */ { 0, 0, 0, 0, 0 },
/* U+d32c */ { 0, 0, 0, 0, 0 },
/* U+d32d */ { 0, 0, 0, 0, 0 },
/* U+d32e */ { 0, 0, 0, 0, 0 },
/* U+d32f */ { 0, 0, 0, 0, 0 },
/* U+d330 */ { 0, 0, 0, 0, 0 },
/* U+d331 */ { 0, 0, 0, 0, 0 },
/* U+d332 */ { 0, 0, 0, 0, 0 },
/* U+d333 */ { 0, 0, 0, 0, 0 },
/* U+d334 */ { 0, 0, 0, 0, 0 },
/* U+d335 */ { 0, 0, 0, 0, 0 },
/* U+d336 */ { 0, 0, 0, 0, 0 },
/* U+d337 */ { 0, 0, 0, 0, 0 },
/* U+d338 */ { 0, 0, 0, 0, 0 },
/* U+d339 */ { 0, 0, 0, 0, 0 },
/* U+d33a */ { 0, 0, 0, 0, 0 },
/* U+d33b */ { 0, 0, 0, 0, 0 },
/* U+d33c */ { 0, 0, 0, 0, 0 },
/* U+d33d */ { 0, 0, 0, 0, 0 },
/* U+d33e */ { 0, 0, 0, 0, 0 },
/* U+d33f */ { 0, 0, 0, 0, 0 },
/* U+d340 */ { 0, 0, 0, 0, 0 },
/* U+d341 */ { 0, 0, 0, 0, 0 },
/* U+d342 */ { 0, 0, 0, 0, 0 },
/* U+d343 */ { 0, 0, 0, 0, 0 },
/* U+d344 */ { 0, 0, 0, 0, 0 },
/* U+d345 */ { 0, 0, 0, 0, 0 },
/* U+d346 */ { 0, 0, 0, 0, 0 },
/* U+d347 */ { 0, 0, 0, 0, 0 },
/* U+d348 */ { 0, 0, 0, 0, 0 },
/* U+d349 */ { 0, 0, 0, 0, 0 },
/* U+d34a */ { 0, 0, 0, 0, 0 },
/* U+d34b */ { 0, 0, 0, 0, 0 },
/* U+d34c */ { 0, 0, 0, 0, 0 },
/* U+d34d */ { 0, 0, 0, 0, 0 },
/* U+d34e */ { 0, 0, 0, 0, 0 },
/* U+d34f */ { 0, 0, 0, 0, 0 },
/* U+d350 */ { 0, 0, 0, 0, 0 },
/* U+d351 */ { 0, 0, 0, 0, 0 },
/* U+d352 */ { 0, 0, 0, 0, 0 },
/* U+d353 */ { 0, 0, 0, 0, 0 },
/* U+d354 */ { 0, 0, 0, 0, 0 },
/* U+d355 */ { 0, 0, 0, 0, 0 },
/* U+d356 */ { 0, 0, 0, 0, 0 },
/* U+d357 */ { 0, 0, 0, 0, 0 },
/* U+d358 */ { 0, 0, 0, 0, 0 },
/* U+d359 */ { 0, 0, 0, 0, 0 },
/* U+d35a */ { 0, 0, 0, 0, 0 },
/* U+d35b */ { 0, 0, 0, 0, 0 },
/* U+d35c */ { 0, 0, 0, 0, 0 },
/* U+d35d */ { 0, 0, 0, 0, 0 },
/* U+d35e */ { 0, 0, 0, 0, 0 },
/* U+d35f */ { 0, 0, 0, 0, 0 },
/* U+d360 */ { 0, 0, 0, 0, 0 },
/* U+d361 */ { 0, 0, 0, 0, 0 },
/* U+d362 */ { 0, 0, 0, 0, 0 },
/* U+d363 */ { 0, 0, 0, 0, 0 },
/* U+d364 */ { 0, 0, 0, 0, 0 },
/* U+d365 */ { 0, 0, 0, 0, 0 },
/* U+d366 */ { 0, 0, 0, 0, 0 },
/* U+d367 */ { 0, 0, 0, 0, 0 },
/* U+d368 */ { 0, 0, 0, 0, 0 },
/* U+d369 */ { 0, 0, 0, 0, 0 },
/* U+d36a */ { 0, 0, 0, 0, 0 },
/* U+d36b */ { 0, 0, 0, 0, 0 },
/* U+d36c */ { 0, 0, 0, 0, 0 },
/* U+d36d */ { 0, 0, 0, 0, 0 },
/* U+d36e */ { 0, 0, 0, 0, 0 },
/* U+d36f */ { 0, 0, 0, 0, 0 },
/* U+d370 */ { 0, 0, 0, 0, 0 },
/* U+d371 */ { 0, 0, 0, 0, 0 },
/* U+d372 */ { 0, 0, 0, 0, 0 },
/* U+d373 */ { 0, 0, 0, 0, 0 },
/* U+d374 */ { 0, 0, 0, 0, 0 },
/* U+d375 */ { 0, 0, 0, 0, 0 },
/* U+d376 */ { 0, 0, 0, 0, 0 },
/* U+d377 */ { 0, 0, 0, 0, 0 },
/* U+d378 */ { 0, 0, 0, 0, 0 },
/* U+d379 */ { 0, 0, 0, 0, 0 },
/* U+d37a */ { 0, 0, 0, 0, 0 },
/* U+d37b */ { 0, 0, 0, 0, 0 },
/* U+d37c */ { 0, 0, 0, 0, 0 },
/* U+d37d */ { 0, 0, 0, 0, 0 },
/* U+d37e */ { 0, 0, 0, 0, 0 },
/* U+d37f */ { 0, 0, 0, 0, 0 },
/* U+d380 */ { 0, 0, 0, 0, 0 },
/* U+d381 */ { 0, 0, 0, 0, 0 },
/* U+d382 */ { 0, 0, 0, 0, 0 },
/* U+d383 */ { 0, 0, 0, 0, 0 },
/* U+d384 */ { 0, 0, 0, 0, 0 },
/* U+d385 */ { 0, 0, 0, 0, 0 },
/* U+d386 */ { 0, 0, 0, 0, 0 },
/* U+d387 */ { 0, 0, 0, 0, 0 },
/* U+d388 */ { 0, 0, 0, 0, 0 },
/* U+d389 */ { 0, 0, 0, 0, 0 },
/* U+d38a */ { 0, 0, 0, 0, 0 },
/* U+d38b */ { 0, 0, 0, 0, 0 },
/* U+d38c */ { 0, 0, 0, 0, 0 },
/* U+d38d */ { 0, 0, 0, 0, 0 },
/* U+d38e */ { 0, 0, 0, 0, 0 },
/* U+d38f */ { 0, 0, 0, 0, 0 },
/* U+d390 */ { 0, 0, 0, 0, 0 },
/* U+d391 */ { 0, 0, 0, 0, 0 },
/* U+d392 */ { 0, 0, 0, 0, 0 },
/* U+d393 */ { 0, 0, 0, 0, 0 },
/* U+d394 */ { 0, 0, 0, 0, 0 },
/* U+d395 */ { 0, 0, 0, 0, 0 },
/* U+d396 */ { 0, 0, 0, 0, 0 },
/* U+d397 */ { 0, 0, 0, 0, 0 },
/* U+d398 */ { 0, 0, 0, 0, 0 },
/* U+d399 */ { 0, 0, 0, 0, 0 },
/* U+d39a */ { 0, 0, 0, 0, 0 },
/* U+d39b */ { 0, 0, 0, 0, 0 },
/* U+d39c */ { 0, 0, 0, 0, 0 },
/* U+d39d */ { 0, 0, 0, 0, 0 },
/* U+d39e */ { 0, 0, 0, 0, 0 },
/* U+d39f */ { 0, 0, 0, 0, 0 },
/* U+d3a0 */ { 0, 0, 0, 0, 0 },
/* U+d3a1 */ { 0, 0, 0, 0, 0 },
/* U+d3a2 */ { 0, 0, 0, 0, 0 },
/* U+d3a3 */ { 0, 0, 0, 0, 0 },
/* U+d3a4 */ { 0, 0, 0, 0, 0 },
/* U+d3a5 */ { 0, 0, 0, 0, 0 },
/* U+d3a6 */ { 0, 0, 0, 0, 0 },
/* U+d3a7 */ { 0, 0, 0, 0, 0 },
/* U+d3a8 */ { 0, 0, 0, 0, 0 },
/* U+d3a9 */ { 0, 0, 0, 0, 0 },
/* U+d3aa */ { 0, 0, 0, 0, 0 },
/* U+d3ab */ { 0, 0, 0, 0, 0 },
/* U+d3ac */ { 0, 0, 0, 0, 0 },
/* U+d3ad */ { 0, 0, 0, 0, 0 },
/* U+d3ae */ { 0, 0, 0, 0, 0 },
/* U+d3af */ { 0, 0, 0, 0, 0 },
/* U+d3b0 */ { 0, 0, 0, 0, 0 },
/* U+d3b1 */ { 0, 0, 0, 0, 0 },
/* U+d3b2 */ { 0, 0, 0, 0, 0 },
/* U+d3b3 */ { 0, 0, 0, 0, 0 },
/* U+d3b4 */ { 0, 0, 0, 0, 0 },
/* U+d3b5 */ { 0, 0, 0, 0, 0 },
/* U+d3b6 */ { 0, 0, 0, 0, 0 },
/* U+d3b7 */ { 0, 0, 0, 0, 0 },
/* U+d3b8 */ { 0, 0, 0, 0, 0 },
/* U+d3b9 */ { 0, 0, 0, 0, 0 },
/* U+d3ba */ { 0, 0, 0, 0, 0 },
/* U+d3bb */ { 0, 0, 0, 0, 0 },
/* U+d3bc */ { 0, 0, 0, 0, 0 },
/* U+d3bd */ { 0, 0, 0, 0, 0 },
/* U+d3be */ { 0, 0, 0, 0, 0 },
/* U+d3bf */ { 0, 0, 0, 0, 0 },
/* U+d3c0 */ { 0, 0, 0, 0, 0 },
/* U+d3c1 */ { 0, 0, 0, 0, 0 },
/* U+d3c2 */ { 0, 0, 0, 0, 0 },
/* U+d3c3 */ { 0, 0, 0, 0, 0 },
/* U+d3c4 */ { 0, 0, 0, 0, 0 },
/* U+d3c5 */ { 0, 0, 0, 0, 0 },
/* U+d3c6 */ { 0, 0, 0, 0, 0 },
/* U+d3c7 */ { 0, 0, 0, 0, 0 },
/* U+d3c8 */ { 0, 0, 0, 0, 0 },
/* U+d3c9 */ { 0, 0, 0, 0, 0 },
/* U+d3ca */ { 0, 0, 0, 0, 0 },
/* U+d3cb */ { 0, 0, 0, 0, 0 },
/* U+d3cc */ { 0, 0, 0, 0, 0 },
/* U+d3cd */ { 0, 0, 0, 0, 0 },
/* U+d3ce */ { 0, 0, 0, 0, 0 },
/* U+d3cf */ { 0, 0, 0, 0, 0 },
/* U+d3d0 */ { 0, 0, 0, 0, 0 },
/* U+d3d1 */ { 0, 0, 0, 0, 0 },
/* U+d3d2 */ { 0, 0, 0, 0, 0 },
/* U+d3d3 */ { 0, 0, 0, 0, 0 },
/* U+d3d4 */ { 0, 0, 0, 0, 0 },
/* U+d3d5 */ { 0, 0, 0, 0, 0 },
/* U+d3d6 */ { 0, 0, 0, 0, 0 },
/* U+d3d7 */ { 0, 0, 0, 0, 0 },
/* U+d3d8 */ { 0, 0, 0, 0, 0 },
/* U+d3d9 */ { 0, 0, 0, 0, 0 },
/* U+d3da */ { 0, 0, 0, 0, 0 },
/* U+d3db */ { 0, 0, 0, 0, 0 },
/* U+d3dc */ { 0, 0, 0, 0, 0 },
/* U+d3dd */ { 0, 0, 0, 0, 0 },
/* U+d3de */ { 0, 0, 0, 0, 0 },
/* U+d3df */ { 0, 0, 0, 0, 0 },
/* U+d3e0 */ { 0, 0, 0, 0, 0 },
/* U+d3e1 */ { 0, 0, 0, 0, 0 },
/* U+d3e2 */ { 0, 0, 0, 0, 0 },
/* U+d3e3 */ { 0, 0, 0, 0, 0 },
/* U+d3e4 */ { 0, 0, 0, 0, 0 },
/* U+d3e5 */ { 0, 0, 0, 0, 0 },
/* U+d3e6 */ { 0, 0, 0, 0, 0 },
/* U+d3e7 */ { 0, 0, 0, 0, 0 },
/* U+d3e8 */ { 0, 0, 0, 0, 0 },
/* U+d3e9 */ { 0, 0, 0, 0, 0 },
/* U+d3ea */ { 0, 0, 0, 0, 0 },
/* U+d3eb */ { 0, 0, 0, 0, 0 },
/* U+d3ec */ { 0, 0, 0, 0, 0 },
/* U+d3ed */ { 0, 0, 0, 0, 0 },
/* U+d3ee */ { 0, 0, 0, 0, 0 },
/* U+d3ef */ { 0, 0, 0, 0, 0 },
/* U+d3f0 */ { 0, 0, 0, 0, 0 },
/* U+d3f1 */ { 0, 0, 0, 0, 0 },
/* U+d3f2 */ { 0, 0, 0, 0, 0 },
/* U+d3f3 */ { 0, 0, 0, 0, 0 },
/* U+d3f4 */ { 0, 0, 0, 0, 0 },
/* U+d3f5 */ { 0, 0, 0, 0, 0 },
/* U+d3f6 */ { 0, 0, 0, 0, 0 },
/* U+d3f7 */ { 0, 0, 0, 0, 0 },
/* U+d3f8 */ { 0, 0, 0, 0, 0 },
/* U+d3f9 */ { 0, 0, 0, 0, 0 },
/* U+d3fa */ { 0, 0, 0, 0, 0 },
/* U+d3fb */ { 0, 0, 0, 0, 0 },
/* U+d3fc */ { 0, 0, 0, 0, 0 },
/* U+d3fd */ { 0, 0, 0, 0, 0 },
/* U+d3fe */ { 0, 0, 0, 0, 0 },
/* U+d3ff */ { 0, 0, 0, 0, 0 },
/* U+d400 */ { 0, 0, 0, 0, 0 },
/* U+d401 */ { 0, 0, 0, 0, 0 },
/* U+d402 */ { 0, 0, 0, 0, 0 },
/* U+d403 */ { 0, 0, 0, 0, 0 },
/* U+d404 */ { 0, 0, 0, 0, 0 },
/* U+d405 */ { 0, 0, 0, 0, 0 },
/* U+d406 */ { 0, 0, 0, 0, 0 },
/* U+d407 */ { 0, 0, 0, 0, 0 },
/* U+d408 */ { 0, 0, 0, 0, 0 },
/* U+d409 */ { 0, 0, 0, 0, 0 },
/* U+d40a */ { 0, 0, 0, 0, 0 },
/* U+d40b */ { 0, 0, 0, 0, 0 },
/* U+d40c */ { 0, 0, 0, 0, 0 },
/* U+d40d */ { 0, 0, 0, 0, 0 },
/* U+d40e */ { 0, 0, 0, 0, 0 },
/* U+d40f */ { 0, 0, 0, 0, 0 },
/* U+d410 */ { 0, 0, 0, 0, 0 },
/* U+d411 */ { 0, 0, 0, 0, 0 },
/* U+d412 */ { 0, 0, 0, 0, 0 },
/* U+d413 */ { 0, 0, 0, 0, 0 },
/* U+d414 */ { 0, 0, 0, 0, 0 },
/* U+d415 */ { 0, 0, 0, 0, 0 },
/* U+d416 */ { 0, 0, 0, 0, 0 },
/* U+d417 */ { 0, 0, 0, 0, 0 },
/* U+d418 */ { 0, 0, 0, 0, 0 },
/* U+d419 */ { 0, 0, 0, 0, 0 },
/* U+d41a */ { 0, 0, 0, 0, 0 },
/* U+d41b */ { 0, 0, 0, 0, 0 },
/* U+d41c */ { 0, 0, 0, 0, 0 },
/* U+d41d */ { 0, 0, 0, 0, 0 },
/* U+d41e */ { 0, 0, 0, 0, 0 },
/* U+d41f */ { 0, 0, 0, 0, 0 },
/* U+d420 */ { 0, 0, 0, 0, 0 },
/* U+d421 */ { 0, 0, 0, 0, 0 },
/* U+d422 */ { 0, 0, 0, 0, 0 },
/* U+d423 */ { 0, 0, 0, 0, 0 },
/* U+d424 */ { 0, 0, 0, 0, 0 },
/* U+d425 */ { 0, 0, 0, 0, 0 },
/* U+d426 */ { 0, 0, 0, 0, 0 },
/* U+d427 */ { 0, 0, 0, 0, 0 },
/* U+d428 */ { 0, 0, 0, 0, 0 },
/* U+d429 */ { 0, 0, 0, 0, 0 },
/* U+d42a */ { 0, 0, 0, 0, 0 },
/* U+d42b */ { 0, 0, 0, 0, 0 },
/* U+d42c */ { 0, 0, 0, 0, 0 },
/* U+d42d */ { 0, 0, 0, 0, 0 },
/* U+d42e */ { 0, 0, 0, 0, 0 },
/* U+d42f */ { 0, 0, 0, 0, 0 },
/* U+d430 */ { 0, 0, 0, 0, 0 },
/* U+d431 */ { 0, 0, 0, 0, 0 },
/* U+d432 */ { 0, 0, 0, 0, 0 },
/* U+d433 */ { 0, 0, 0, 0, 0 },
/* U+d434 */ { 0, 0, 0, 0, 0 },
/* U+d435 */ { 0, 0, 0, 0, 0 },
/* U+d436 */ { 0, 0, 0, 0, 0 },
/* U+d437 */ { 0, 0, 0, 0, 0 },
/* U+d438 */ { 0, 0, 0, 0, 0 },
/* U+d439 */ { 0, 0, 0, 0, 0 },
/* U+d43a */ { 0, 0, 0, 0, 0 },
/* U+d43b */ { 0, 0, 0, 0, 0 },
/* U+d43c */ { 0, 0, 0, 0, 0 },
/* U+d43d */ { 0, 0, 0, 0, 0 },
/* U+d43e */ { 0, 0, 0, 0, 0 },
/* U+d43f */ { 0, 0, 0, 0, 0 },
/* U+d440 */ { 0, 0, 0, 0, 0 },
/* U+d441 */ { 0, 0, 0, 0, 0 },
/* U+d442 */ { 0, 0, 0, 0, 0 },
/* U+d443 */ { 0, 0, 0, 0, 0 },
/* U+d444 */ { 0, 0, 0, 0, 0 },
/* U+d445 */ { 0, 0, 0, 0, 0 },
/* U+d446 */ { 0, 0, 0, 0, 0 },
/* U+d447 */ { 0, 0, 0, 0, 0 },
/* U+d448 */ { 0, 0, 0, 0, 0 },
/* U+d449 */ { 0, 0, 0, 0, 0 },
/* U+d44a */ { 0, 0, 0, 0, 0 },
/* U+d44b */ { 0, 0, 0, 0, 0 },
/* U+d44c */ { 0, 0, 0, 0, 0 },
/* U+d44d */ { 0, 0, 0, 0, 0 },
/* U+d44e */ { 0, 0, 0, 0, 0 },
/* U+d44f */ { 0, 0, 0, 0, 0 },
/* U+d450 */ { 0, 0, 0, 0, 0 },
/* U+d451 */ { 0, 0, 0, 0, 0 },
/* U+d452 */ { 0, 0, 0, 0, 0 },
/* U+d453 */ { 0, 0, 0, 0, 0 },
/* U+d454 */ { 0, 0, 0, 0, 0 },
/* U+d455 */ { 0, 0, 0, 0, 0 },
/* U+d456 */ { 0, 0, 0, 0, 0 },
/* U+d457 */ { 0, 0, 0, 0, 0 },
/* U+d458 */ { 0, 0, 0, 0, 0 },
/* U+d459 */ { 0, 0, 0, 0, 0 },
/* U+d45a */ { 0, 0, 0, 0, 0 },
/* U+d45b */ { 0, 0, 0, 0, 0 },
/* U+d45c */ { 0, 0, 0, 0, 0 },
/* U+d45d */ { 0, 0, 0, 0, 0 },
/* U+d45e */ { 0, 0, 0, 0, 0 },
/* U+d45f */ { 0, 0, 0, 0, 0 },
/* U+d460 */ { 0, 0, 0, 0, 0 },
/* U+d461 */ { 0, 0, 0, 0, 0 },
/* U+d462 */ { 0, 0, 0, 0, 0 },
/* U+d463 */ { 0, 0, 0, 0, 0 },
/* U+d464 */ { 0, 0, 0, 0, 0 },
/* U+d465 */ { 0, 0, 0, 0, 0 },
/* U+d466 */ { 0, 0, 0, 0, 0 },
/* U+d467 */ { 0, 0, 0, 0, 0 },
/* U+d468 */ { 0, 0, 0, 0, 0 },
/* U+d469 */ { 0, 0, 0, 0, 0 },
/* U+d46a */ { 0, 0, 0, 0, 0 },
/* U+d46b */ { 0, 0, 0, 0, 0 },
/* U+d46c */ { 0, 0, 0, 0, 0 },
/* U+d46d */ { 0, 0, 0, 0, 0 },
/* U+d46e */ { 0, 0, 0, 0, 0 },
/* U+d46f */ { 0, 0, 0, 0, 0 },
/* U+d470 */ { 0, 0, 0, 0, 0 },
/* U+d471 */ { 0, 0, 0, 0, 0 },
/* U+d472 */ { 0, 0, 0, 0, 0 },
/* U+d473 */ { 0, 0, 0, 0, 0 },
/* U+d474 */ { 0, 0, 0, 0, 0 },
/* U+d475 */ { 0, 0, 0, 0, 0 },
/* U+d476 */ { 0, 0, 0, 0, 0 },
/* U+d477 */ { 0, 0, 0, 0, 0 },
/* U+d478 */ { 0, 0, 0, 0, 0 },
/* U+d479 */ { 0, 0, 0, 0, 0 },
/* U+d47a */ { 0, 0, 0, 0, 0 },
/* U+d47b */ { 0, 0, 0, 0, 0 },
/* U+d47c */ { 0, 0, 0, 0, 0 },
/* U+d47d */ { 0, 0, 0, 0, 0 },
/* U+d47e */ { 0, 0, 0, 0, 0 },
/* U+d47f */ { 0, 0, 0, 0, 0 },
/* U+d480 */ { 0, 0, 0, 0, 0 },
/* U+d481 */ { 0, 0, 0, 0, 0 },
/* U+d482 */ { 0, 0, 0, 0, 0 },
/* U+d483 */ { 0, 0, 0, 0, 0 },
/* U+d484 */ { 0, 0, 0, 0, 0 },
/* U+d485 */ { 0, 0, 0, 0, 0 },
/* U+d486 */ { 0, 0, 0, 0, 0 },
/* U+d487 */ { 0, 0, 0, 0, 0 },
/* U+d488 */ { 0, 0, 0, 0, 0 },
/* U+d489 */ { 0, 0, 0, 0, 0 },
/* U+d48a */ { 0, 0, 0, 0, 0 },
/* U+d48b */ { 0, 0, 0, 0, 0 },
/* U+d48c */ { 0, 0, 0, 0, 0 },
/* U+d48d */ { 0, 0, 0, 0, 0 },
/* U+d48e */ { 0, 0, 0, 0, 0 },
/* U+d48f */ { 0, 0, 0, 0, 0 },
/* U+d490 */ { 0, 0, 0, 0, 0 },
/* U+d491 */ { 0, 0, 0, 0, 0 },
/* U+d492 */ { 0, 0, 0, 0, 0 },
/* U+d493 */ { 0, 0, 0, 0, 0 },
/* U+d494 */ { 0, 0, 0, 0, 0 },
/* U+d495 */ { 0, 0, 0, 0, 0 },
/* U+d496 */ { 0, 0, 0, 0, 0 },
/* U+d497 */ { 0, 0, 0, 0, 0 },
/* U+d498 */ { 0, 0, 0, 0, 0 },
/* U+d499 */ { 0, 0, 0, 0, 0 },
/* U+d49a */ { 0, 0, 0, 0, 0 },
/* U+d49b */ { 0, 0, 0, 0, 0 },
/* U+d49c */ { 0, 0, 0, 0, 0 },
/* U+d49d */ { 0, 0, 0, 0, 0 },
/* U+d49e */ { 0, 0, 0, 0, 0 },
/* U+d49f */ { 0, 0, 0, 0, 0 },
/* U+d4a0 */ { 0, 0, 0, 0, 0 },
/* U+d4a1 */ { 0, 0, 0, 0, 0 },
/* U+d4a2 */ { 0, 0, 0, 0, 0 },
/* U+d4a3 */ { 0, 0, 0, 0, 0 },
/* U+d4a4 */ { 0, 0, 0, 0, 0 },
/* U+d4a5 */ { 0, 0, 0, 0, 0 },
/* U+d4a6 */ { 0, 0, 0, 0, 0 },
/* U+d4a7 */ { 0, 0, 0, 0, 0 },
/* U+d4a8 */ { 0, 0, 0, 0, 0 },
/* U+d4a9 */ { 0, 0, 0, 0, 0 },
/* U+d4aa */ { 0, 0, 0, 0, 0 },
/* U+d4ab */ { 0, 0, 0, 0, 0 },
/* U+d4ac */ { 0, 0, 0, 0, 0 },
/* U+d4ad */ { 0, 0, 0, 0, 0 },
/* U+d4ae */ { 0, 0, 0, 0, 0 },
/* U+d4af */ { 0, 0, 0, 0, 0 },
/* U+d4b0 */ { 0, 0, 0, 0, 0 },
/* U+d4b1 */ { 0, 0, 0, 0, 0 },
/* U+d4b2 */ { 0, 0, 0, 0, 0 },
/* U+d4b3 */ { 0, 0, 0, 0, 0 },
/* U+d4b4 */ { 0, 0, 0, 0, 0 },
/* U+d4b5 */ { 0, 0, 0, 0, 0 },
/* U+d4b6 */ { 0, 0, 0, 0, 0 },
/* U+d4b7 */ { 0, 0, 0, 0, 0 },
/* U+d4b8 */ { 0, 0, 0, 0, 0 },
/* U+d4b9 */ { 0, 0, 0, 0, 0 },
/* U+d4ba */ { 0, 0, 0, 0, 0 },
/* U+d4bb */ { 0, 0, 0, 0, 0 },
/* U+d4bc */ { 0, 0, 0, 0, 0 },
/* U+d4bd */ { 0, 0, 0, 0, 0 },
/* U+d4be */ { 0, 0, 0, 0, 0 },
/* U+d4bf */ { 0, 0, 0, 0, 0 },
/* U+d4c0 */ { 0, 0, 0, 0, 0 },
/* U+d4c1 */ { 0, 0, 0, 0, 0 },
/* U+d4c2 */ { 0, 0, 0, 0, 0 },
/* U+d4c3 */ { 0, 0, 0, 0, 0 },
/* U+d4c4 */ { 0, 0, 0, 0, 0 },
/* U+d4c5 */ { 0, 0, 0, 0, 0 },
/* U+d4c6 */ { 0, 0, 0, 0, 0 },
/* U+d4c7 */ { 0, 0, 0, 0, 0 },
/* U+d4c8 */ { 0, 0, 0, 0, 0 },
/* U+d4c9 */ { 0, 0, 0, 0, 0 },
/* U+d4ca */ { 0, 0, 0, 0, 0 },
/* U+d4cb */ { 0, 0, 0, 0, 0 },
/* U+d4cc */ { 0, 0, 0, 0, 0 },
/* U+d4cd */ { 0, 0, 0, 0, 0 },
/* U+d4ce */ { 0, 0, 0, 0, 0 },
/* U+d4cf */ { 0, 0, 0, 0, 0 },
/* U+d4d0 */ { 0, 0, 0, 0, 0 },
/* U+d4d1 */ { 0, 0, 0, 0, 0 },
/* U+d4d2 */ { 0, 0, 0, 0, 0 },
/* U+d4d3 */ { 0, 0, 0, 0, 0 },
/* U+d4d4 */ { 0, 0, 0, 0, 0 },
/* U+d4d5 */ { 0, 0, 0, 0, 0 },
/* U+d4d6 */ { 0, 0, 0, 0, 0 },
/* U+d4d7 */ { 0, 0, 0, 0, 0 },
/* U+d4d8 */ { 0, 0, 0, 0, 0 },
/* U+d4d9 */ { 0, 0, 0, 0, 0 },
/* U+d4da */ { 0, 0, 0, 0, 0 },
/* U+d4db */ { 0, 0, 0, 0, 0 },
/* U+d4dc */ { 0, 0, 0, 0, 0 },
/* U+d4dd */ { 0, 0, 0, 0, 0 },
/* U+d4de */ { 0, 0, 0, 0, 0 },
/* U+d4df */ { 0, 0, 0, 0, 0 },
/* U+d4e0 */ { 0, 0, 0, 0, 0 },
/* U+d4e1 */ { 0, 0, 0, 0, 0 },
/* U+d4e2 */ { 0, 0, 0, 0, 0 },
/* U+d4e3 */ { 0, 0, 0, 0, 0 },
/* U+d4e4 */ { 0, 0, 0, 0, 0 },
/* U+d4e5 */ { 0, 0, 0, 0, 0 },
/* U+d4e6 */ { 0, 0, 0, 0, 0 },
/* U+d4e7 */ { 0, 0, 0, 0, 0 },
/* U+d4e8 */ { 0, 0, 0, 0, 0 },
/* U+d4e9 */ { 0, 0, 0, 0, 0 },
/* U+d4ea */ { 0, 0, 0, 0, 0 },
/* U+d4eb */ { 0, 0, 0, 0, 0 },
/* U+d4ec */ { 0, 0, 0, 0, 0 },
/* U+d4ed */ { 0, 0, 0, 0, 0 },
/* U+d4ee */ { 0, 0, 0, 0, 0 },
/* U+d4ef */ { 0, 0, 0, 0, 0 },
/* U+d4f0 */ { 0, 0, 0, 0, 0 },
/* U+d4f1 */ { 0, 0, 0, 0, 0 },
/* U+d4f2 */ { 0, 0, 0, 0, 0 },
/* U+d4f3 */ { 0, 0, 0, 0, 0 },
/* U+d4f4 */ { 0, 0, 0, 0, 0 },
/* U+d4f5 */ { 0, 0, 0, 0, 0 },
/* U+d4f6 */ { 0, 0, 0, 0, 0 },
/* U+d4f7 */ { 0, 0, 0, 0, 0 },
/* U+d4f8 */ { 0, 0, 0, 0, 0 },
/* U+d4f9 */ { 0, 0, 0, 0, 0 },
/* U+d4fa */ { 0, 0, 0, 0, 0 },
/* U+d4fb */ { 0, 0, 0, 0, 0 },
/* U+d4fc */ { 0, 0, 0, 0, 0 },
/* U+d4fd */ { 0, 0, 0, 0, 0 },
/* U+d4fe */ { 0, 0, 0, 0, 0 },
/* U+d4ff */ { 0, 0, 0, 0, 0 },
/* U+d500 */ { 0, 0, 0, 0, 0 },
/* U+d501 */ { 0, 0, 0, 0, 0 },
/* U+d502 */ { 0, 0, 0, 0, 0 },
/* U+d503 */ { 0, 0, 0, 0, 0 },
/* U+d504 */ { 0, 0, 0, 0, 0 },
/* U+d505 */ { 0, 0, 0, 0, 0 },
/* U+d506 */ { 0, 0, 0, 0, 0 },
/* U+d507 */ { 0, 0, 0, 0, 0 },
/* U+d508 */ { 0, 0, 0, 0, 0 },
/* U+d509 */ { 0, 0, 0, 0, 0 },
/* U+d50a */ { 0, 0, 0, 0, 0 },
/* U+d50b */ { 0, 0, 0, 0, 0 },
/* U+d50c */ { 0, 0, 0, 0, 0 },
/* U+d50d */ { 0, 0, 0, 0, 0 },
/* U+d50e */ { 0, 0, 0, 0, 0 },
/* U+d50f */ { 0, 0, 0, 0, 0 },
/* U+d510 */ { 0, 0, 0, 0, 0 },
/* U+d511 */ { 0, 0, 0, 0, 0 },
/* U+d512 */ { 0, 0, 0, 0, 0 },
/* U+d513 */ { 0, 0, 0, 0, 0 },
/* U+d514 */ { 0, 0, 0, 0, 0 },
/* U+d515 */ { 0, 0, 0, 0, 0 },
/* U+d516 */ { 0, 0, 0, 0, 0 },
/* U+d517 */ { 0, 0, 0, 0, 0 },
/* U+d518 */ { 0, 0, 0, 0, 0 },
/* U+d519 */ { 0, 0, 0, 0, 0 },
/* U+d51a */ { 0, 0, 0, 0, 0 },
/* U+d51b */ { 0, 0, 0, 0, 0 },
/* U+d51c */ { 0, 0, 0, 0, 0 },
/* U+d51d */ { 0, 0, 0, 0, 0 },
/* U+d51e */ { 0, 0, 0, 0, 0 },
/* U+d51f */ { 0, 0, 0, 0, 0 },
/* U+d520 */ { 0, 0, 0, 0, 0 },
/* U+d521 */ { 0, 0, 0, 0, 0 },
/* U+d522 */ { 0, 0, 0, 0, 0 },
/* U+d523 */ { 0, 0, 0, 0, 0 },
/* U+d524 */ { 0, 0, 0, 0, 0 },
/* U+d525 */ { 0, 0, 0, 0, 0 },
/* U+d526 */ { 0, 0, 0, 0, 0 },
/* U+d527 */ { 0, 0, 0, 0, 0 },
/* U+d528 */ { 0, 0, 0, 0, 0 },
/* U+d529 */ { 0, 0, 0, 0, 0 },
/* U+d52a */ { 0, 0, 0, 0, 0 },
/* U+d52b */ { 0, 0, 0, 0, 0 },
/* U+d52c */ { 0, 0, 0, 0, 0 },
/* U+d52d */ { 0, 0, 0, 0, 0 },
/* U+d52e */ { 0, 0, 0, 0, 0 },
/* U+d52f */ { 0, 0, 0, 0, 0 },
/* U+d530 */ { 0, 0, 0, 0, 0 },
/* U+d531 */ { 0, 0, 0, 0, 0 },
/* U+d532 */ { 0, 0, 0, 0, 0 },
/* U+d533 */ { 0, 0, 0, 0, 0 },
/* U+d534 */ { 0, 0, 0, 0, 0 },
/* U+d535 */ { 0, 0, 0, 0, 0 },
/* U+d536 */ { 0, 0, 0, 0, 0 },
/* U+d537 */ { 0, 0, 0, 0, 0 },
/* U+d538 */ { 0, 0, 0, 0, 0 },
/* U+d539 */ { 0, 0, 0, 0, 0 },
/* U+d53a */ { 0, 0, 0, 0, 0 },
/* U+d53b */ { 0, 0, 0, 0, 0 },
/* U+d53c */ { 0, 0, 0, 0, 0 },
/* U+d53d */ { 0, 0, 0, 0, 0 },
/* U+d53e */ { 0, 0, 0, 0, 0 },
/* U+d53f */ { 0, 0, 0, 0, 0 },
/* U+d540 */ { 0, 0, 0, 0, 0 },
/* U+d541 */ { 0, 0, 0, 0, 0 },
/* U+d542 */ { 0, 0, 0, 0, 0 },
/* U+d543 */ { 0, 0, 0, 0, 0 },
/* U+d544 */ { 0, 0, 0, 0, 0 },
/* U+d545 */ { 0, 0, 0, 0, 0 },
/* U+d546 */ { 0, 0, 0, 0, 0 },
/* U+d547 */ { 0, 0, 0, 0, 0 },
/* U+d548 */ { 0, 0, 0, 0, 0 },
/* U+d549 */ { 0, 0, 0, 0, 0 },
/* U+d54a */ { 0, 0, 0, 0, 0 },
/* U+d54b */ { 0, 0, 0, 0, 0 },
/* U+d54c */ { 0, 0, 0, 0, 0 },
/* U+d54d */ { 0, 0, 0, 0, 0 },
/* U+d54e */ { 0, 0, 0, 0, 0 },
/* U+d54f */ { 0, 0, 0, 0, 0 },
/* U+d550 */ { 0, 0, 0, 0, 0 },
/* U+d551 */ { 0, 0, 0, 0, 0 },
/* U+d552 */ { 0, 0, 0, 0, 0 },
/* U+d553 */ { 0, 0, 0, 0, 0 },
/* U+d554 */ { 0, 0, 0, 0, 0 },
/* U+d555 */ { 0, 0, 0, 0, 0 },
/* U+d556 */ { 0, 0, 0, 0, 0 },
/* U+d557 */ { 0, 0, 0, 0, 0 },
/* U+d558 */ { 0, 0, 0, 0, 0 },
/* U+d559 */ { 0, 0, 0, 0, 0 },
/* U+d55a */ { 0, 0, 0, 0, 0 },
/* U+d55b */ { 0, 0, 0, 0, 0 },
/* U+d55c */ { 0, 0, 0, 0, 0 },
/* U+d55d */ { 0, 0, 0, 0, 0 },
/* U+d55e */ { 0, 0, 0, 0, 0 },
/* U+d55f */ { 0, 0, 0, 0, 0 },
/* U+d560 */ { 0, 0, 0, 0, 0 },
/* U+d561 */ { 0, 0, 0, 0, 0 },
/* U+d562 */ { 0, 0, 0, 0, 0 },
/* U+d563 */ { 0, 0, 0, 0, 0 },
/* U+d564 */ { 0, 0, 0, 0, 0 },
/* U+d565 */ { 0, 0, 0, 0, 0 },
/* U+d566 */ { 0, 0, 0, 0, 0 },
/* U+d567 */ { 0, 0, 0, 0, 0 },
/* U+d568 */ { 0, 0, 0, 0, 0 },
/* U+d569 */ { 0, 0, 0, 0, 0 },
/* U+d56a */ { 0, 0, 0, 0, 0 },
/* U+d56b */ { 0, 0, 0, 0, 0 },
/* U+d56c */ { 0, 0, 0, 0, 0 },
/* U+d56d */ { 0, 0, 0, 0, 0 },
/* U+d56e */ { 0, 0, 0, 0, 0 },
/* U+d56f */ { 0, 0, 0, 0, 0 },
/* U+d570 */ { 0, 0, 0, 0, 0 },
/* U+d571 */ { 0, 0, 0, 0, 0 },
/* U+d572 */ { 0, 0, 0, 0, 0 },
/* U+d573 */ { 0, 0, 0, 0, 0 },
/* U+d574 */ { 0, 0, 0, 0, 0 },
/* U+d575 */ { 0, 0, 0, 0, 0 },
/* U+d576 */ { 0, 0, 0, 0, 0 },
/* U+d577 */ { 0, 0, 0, 0, 0 },
/* U+d578 */ { 0, 0, 0, 0, 0 },
/* U+d579 */ { 0, 0, 0, 0, 0 },
/* U+d57a */ { 0, 0, 0, 0, 0 },
/* U+d57b */ { 0, 0, 0, 0, 0 },
/* U+d57c */ { 0, 0, 0, 0, 0 },
/* U+d57d */ { 0, 0, 0, 0, 0 },
/* U+d57e */ { 0, 0, 0, 0, 0 },
/* U+d57f */ { 0, 0, 0, 0, 0 },
/* U+d580 */ { 0, 0, 0, 0, 0 },
/* U+d581 */ { 0, 0, 0, 0, 0 },
/* U+d582 */ { 0, 0, 0, 0, 0 },
/* U+d583 */ { 0, 0, 0, 0, 0 },
/* U+d584 */ { 0, 0, 0, 0, 0 },
/* U+d585 */ { 0, 0, 0, 0, 0 },
/* U+d586 */ { 0, 0, 0, 0, 0 },
/* U+d587 */ { 0, 0, 0, 0, 0 },
/* U+d588 */ { 0, 0, 0, 0, 0 },
/* U+d589 */ { 0, 0, 0, 0, 0 },
/* U+d58a */ { 0, 0, 0, 0, 0 },
/* U+d58b */ { 0, 0, 0, 0, 0 },
/* U+d58c */ { 0, 0, 0, 0, 0 },
/* U+d58d */ { 0, 0, 0, 0, 0 },
/* U+d58e */ { 0, 0, 0, 0, 0 },
/* U+d58f */ { 0, 0, 0, 0, 0 },
/* U+d590 */ { 0, 0, 0, 0, 0 },
/* U+d591 */ { 0, 0, 0, 0, 0 },
/* U+d592 */ { 0, 0, 0, 0, 0 },
/* U+d593 */ { 0, 0, 0, 0, 0 },
/* U+d594 */ { 0, 0, 0, 0, 0 },
/* U+d595 */ { 0, 0, 0, 0, 0 },
/* U+d596 */ { 0, 0, 0, 0, 0 },
/* U+d597 */ { 0, 0, 0, 0, 0 },
/* U+d598 */ { 0, 0, 0, 0, 0 },
/* U+d599 */ { 0, 0, 0, 0, 0 },
/* U+d59a */ { 0, 0, 0, 0, 0 },
/* U+d59b */ { 0, 0, 0, 0, 0 },
/* U+d59c */ { 0, 0, 0, 0, 0 },
/* U+d59d */ { 0, 0, 0, 0, 0 },
/* U+d59e */ { 0, 0, 0, 0, 0 },
/* U+d59f */ { 0, 0, 0, 0, 0 },
/* U+d5a0 */ { 0, 0, 0, 0, 0 },
/* U+d5a1 */ { 0, 0, 0, 0, 0 },
/* U+d5a2 */ { 0, 0, 0, 0, 0 },
/* U+d5a3 */ { 0, 0, 0, 0, 0 },
/* U+d5a4 */ { 0, 0, 0, 0, 0 },
/* U+d5a5 */ { 0, 0, 0, 0, 0 },
/* U+d5a6 */ { 0, 0, 0, 0, 0 },
/* U+d5a7 */ { 0, 0, 0, 0, 0 },
/* U+d5a8 */ { 0, 0, 0, 0, 0 },
/* U+d5a9 */ { 0, 0, 0, 0, 0 },
/* U+d5aa */ { 0, 0, 0, 0, 0 },
/* U+d5ab */ { 0, 0, 0, 0, 0 },
/* U+d5ac */ { 0, 0, 0, 0, 0 },
/* U+d5ad */ { 0, 0, 0, 0, 0 },
/* U+d5ae */ { 0, 0, 0, 0, 0 },
/* U+d5af */ { 0, 0, 0, 0, 0 },
/* U+d5b0 */ { 0, 0, 0, 0, 0 },
/* U+d5b1 */ { 0, 0, 0, 0, 0 },
/* U+d5b2 */ { 0, 0, 0, 0, 0 },
/* U+d5b3 */ { 0, 0, 0, 0, 0 },
/* U+d5b4 */ { 0, 0, 0, 0, 0 },
/* U+d5b5 */ { 0, 0, 0, 0, 0 },
/* U+d5b6 */ { 0, 0, 0, 0, 0 },
/* U+d5b7 */ { 0, 0, 0, 0, 0 },
/* U+d5b8 */ { 0, 0, 0, 0, 0 },
/* U+d5b9 */ { 0, 0, 0, 0, 0 },
/* U+d5ba */ { 0, 0, 0, 0, 0 },
/* U+d5bb */ { 0, 0, 0, 0, 0 },
/* U+d5bc */ { 0, 0, 0, 0, 0 },
/* U+d5bd */ { 0, 0, 0, 0, 0 },
/* U+d5be */ { 0, 0, 0, 0, 0 },
/* U+d5bf */ { 0, 0, 0, 0, 0 },
/* U+d5c0 */ { 0, 0, 0, 0, 0 },
/* U+d5c1 */ { 0, 0, 0, 0, 0 },
/* U+d5c2 */ { 0, 0, 0, 0, 0 },
/* U+d5c3 */ { 0, 0, 0, 0, 0 },
/* U+d5c4 */ { 0, 0, 0, 0, 0 },
/* U+d5c5 */ { 0, 0, 0, 0, 0 },
/* U+d5c6 */ { 0, 0, 0, 0, 0 },
/* U+d5c7 */ { 0, 0, 0, 0, 0 },
/* U+d5c8 */ { 0, 0, 0, 0, 0 },
/* U+d5c9 */ { 0, 0, 0, 0, 0 },
/* U+d5ca */ { 0, 0, 0, 0, 0 },
/* U+d5cb */ { 0, 0, 0, 0, 0 },
/* U+d5cc */ { 0, 0, 0, 0, 0 },
/* U+d5cd */ { 0, 0, 0, 0, 0 },
/* U+d5ce */ { 0, 0, 0, 0, 0 },
/* U+d5cf */ { 0, 0, 0, 0, 0 },
/* U+d5d0 */ { 0, 0, 0, 0, 0 },
/* U+d5d1 */ { 0, 0, 0, 0, 0 },
/* U+d5d2 */ { 0, 0, 0, 0, 0 },
/* U+d5d3 */ { 0, 0, 0, 0, 0 },
/* U+d5d4 */ { 0, 0, 0, 0, 0 },
/* U+d5d5 */ { 0, 0, 0, 0, 0 },
/* U+d5d6 */ { 0, 0, 0, 0, 0 },
/* U+d5d7 */ { 0, 0, 0, 0, 0 },
/* U+d5d8 */ { 0, 0, 0, 0, 0 },
/* U+d5d9 */ { 0, 0, 0, 0, 0 },
/* U+d5da */ { 0, 0, 0, 0, 0 },
/* U+d5db */ { 0, 0, 0, 0, 0 },
/* U+d5dc */ { 0, 0, 0, 0, 0 },
/* U+d5dd */ { 0, 0, 0, 0, 0 },
/* U+d5de */ { 0, 0, 0, 0, 0 },
/* U+d5df */ { 0, 0, 0, 0, 0 },
/* U+d5e0 */ { 0, 0, 0, 0, 0 },
/* U+d5e1 */ { 0, 0, 0, 0, 0 },
/* U+d5e2 */ { 0, 0, 0, 0, 0 },
/* U+d5e3 */ { 0, 0, 0, 0, 0 },
/* U+d5e4 */ { 0, 0, 0, 0, 0 },
/* U+d5e5 */ { 0, 0, 0, 0, 0 },
/* U+d5e6 */ { 0, 0, 0, 0, 0 },
/* U+d5e7 */ { 0, 0, 0, 0, 0 },
/* U+d5e8 */ { 0, 0, 0, 0, 0 },
/* U+d5e9 */ { 0, 0, 0, 0, 0 },
/* U+d5ea */ { 0, 0, 0, 0, 0 },
/* U+d5eb */ { 0, 0, 0, 0, 0 },
/* U+d5ec */ { 0, 0, 0, 0, 0 },
/* U+d5ed */ { 0, 0, 0, 0, 0 },
/* U+d5ee */ { 0, 0, 0, 0, 0 },
/* U+d5ef */ { 0, 0, 0, 0, 0 },
/* U+d5f0 */ { 0, 0, 0, 0, 0 },
/* U+d5f1 */ { 0, 0, 0, 0, 0 },
/* U+d5f2 */ { 0, 0, 0, 0, 0 },
/* U+d5f3 */ { 0, 0, 0, 0, 0 },
/* U+d5f4 */ { 0, 0, 0, 0, 0 },
/* U+d5f5 */ { 0, 0, 0, 0, 0 },
/* U+d5f6 */ { 0, 0, 0, 0, 0 },
/* U+d5f7 */ { 0, 0, 0, 0, 0 },
/* U+d5f8 */ { 0, 0, 0, 0, 0 },
/* U+d5f9 */ { 0, 0, 0, 0, 0 },
/* U+d5fa */ { 0, 0, 0, 0, 0 },
/* U+d5fb */ { 0, 0, 0, 0, 0 },
/* U+d5fc */ { 0, 0, 0, 0, 0 },
/* U+d5fd */ { 0, 0, 0, 0, 0 },
/* U+d5fe */ { 0, 0, 0, 0, 0 },
/* U+d5ff */ { 0, 0, 0, 0, 0 },
/* U+d600 */ { 0, 0, 0, 0, 0 },
/* U+d601 */ { 0, 0, 0, 0, 0 },
/* U+d602 */ { 0, 0, 0, 0, 0 },
/* U+d603 */ { 0, 0, 0, 0, 0 },
/* U+d604 */ { 0, 0, 0, 0, 0 },
/* U+d605 */ { 0, 0, 0, 0, 0 },
/* U+d606 */ { 0, 0, 0, 0, 0 },
/* U+d607 */ { 0, 0, 0, 0, 0 },
/* U+d608 */ { 0, 0, 0, 0, 0 },
/* U+d609 */ { 0, 0, 0, 0, 0 },
/* U+d60a */ { 0, 0, 0, 0, 0 },
/* U+d60b */ { 0, 0, 0, 0, 0 },
/* U+d60c */ { 0, 0, 0, 0, 0 },
/* U+d60d */ { 0, 0, 0, 0, 0 },
/* U+d60e */ { 0, 0, 0, 0, 0 },
/* U+d60f */ { 0, 0, 0, 0, 0 },
/* U+d610 */ { 0, 0, 0, 0, 0 },
/* U+d611 */ { 0, 0, 0, 0, 0 },
/* U+d612 */ { 0, 0, 0, 0, 0 },
/* U+d613 */ { 0, 0, 0, 0, 0 },
/* U+d614 */ { 0, 0, 0, 0, 0 },
/* U+d615 */ { 0, 0, 0, 0, 0 },
/* U+d616 */ { 0, 0, 0, 0, 0 },
/* U+d617 */ { 0, 0, 0, 0, 0 },
/* U+d618 */ { 0, 0, 0, 0, 0 },
/* U+d619 */ { 0, 0, 0, 0, 0 },
/* U+d61a */ { 0, 0, 0, 0, 0 },
/* U+d61b */ { 0, 0, 0, 0, 0 },
/* U+d61c */ { 0, 0, 0, 0, 0 },
/* U+d61d */ { 0, 0, 0, 0, 0 },
/* U+d61e */ { 0, 0, 0, 0, 0 },
/* U+d61f */ { 0, 0, 0, 0, 0 },
/* U+d620 */ { 0, 0, 0, 0, 0 },
/* U+d621 */ { 0, 0, 0, 0, 0 },
/* U+d622 */ { 0, 0, 0, 0, 0 },
/* U+d623 */ { 0, 0, 0, 0, 0 },
/* U+d624 */ { 0, 0, 0, 0, 0 },
/* U+d625 */ { 0, 0, 0, 0, 0 },
/* U+d626 */ { 0, 0, 0, 0, 0 },
/* U+d627 */ { 0, 0, 0, 0, 0 },
/* U+d628 */ { 0, 0, 0, 0, 0 },
/* U+d629 */ { 0, 0, 0, 0, 0 },
/* U+d62a */ { 0, 0, 0, 0, 0 },
/* U+d62b */ { 0, 0, 0, 0, 0 },
/* U+d62c */ { 0, 0, 0, 0, 0 },
/* U+d62d */ { 0, 0, 0, 0, 0 },
/* U+d62e */ { 0, 0, 0, 0, 0 },
/* U+d62f */ { 0, 0, 0, 0, 0 },
/* U+d630 */ { 0, 0, 0, 0, 0 },
/* U+d631 */ { 0, 0, 0, 0, 0 },
/* U+d632 */ { 0, 0, 0, 0, 0 },
/* U+d633 */ { 0, 0, 0, 0, 0 },
/* U+d634 */ { 0, 0, 0, 0, 0 },
/* U+d635 */ { 0, 0, 0, 0, 0 },
/* U+d636 */ { 0, 0, 0, 0, 0 },
/* U+d637 */ { 0, 0, 0, 0, 0 },
/* U+d638 */ { 0, 0, 0, 0, 0 },
/* U+d639 */ { 0, 0, 0, 0, 0 },
/* U+d63a */ { 0, 0, 0, 0, 0 },
/* U+d63b */ { 0, 0, 0, 0, 0 },
/* U+d63c */ { 0, 0, 0, 0, 0 },
/* U+d63d */ { 0, 0, 0, 0, 0 },
/* U+d63e */ { 0, 0, 0, 0, 0 },
/* U+d63f */ { 0, 0, 0, 0, 0 },
/* U+d640 */ { 0, 0, 0, 0, 0 },
/* U+d641 */ { 0, 0, 0, 0, 0 },
/* U+d642 */ { 0, 0, 0, 0, 0 },
/* U+d643 */ { 0, 0, 0, 0, 0 },
/* U+d644 */ { 0, 0, 0, 0, 0 },
/* U+d645 */ { 0, 0, 0, 0, 0 },
/* U+d646 */ { 0, 0, 0, 0, 0 },
/* U+d647 */ { 0, 0, 0, 0, 0 },
/* U+d648 */ { 0, 0, 0, 0, 0 },
/* U+d649 */ { 0, 0, 0, 0, 0 },
/* U+d64a */ { 0, 0, 0, 0, 0 },
/* U+d64b */ { 0, 0, 0, 0, 0 },
/* U+d64c */ { 0, 0, 0, 0, 0 },
/* U+d64d */ { 0, 0, 0, 0, 0 },
/* U+d64e */ { 0, 0, 0, 0, 0 },
/* U+d64f */ { 0, 0, 0, 0, 0 },
/* U+d650 */ { 0, 0, 0, 0, 0 },
/* U+d651 */ { 0, 0, 0, 0, 0 },
/* U+d652 */ { 0, 0, 0, 0, 0 },
/* U+d653 */ { 0, 0, 0, 0, 0 },
/* U+d654 */ { 0, 0, 0, 0, 0 },
/* U+d655 */ { 0, 0, 0, 0, 0 },
/* U+d656 */ { 0, 0, 0, 0, 0 },
/* U+d657 */ { 0, 0, 0, 0, 0 },
/* U+d658 */ { 0, 0, 0, 0, 0 },
/* U+d659 */ { 0, 0, 0, 0, 0 },
/* U+d65a */ { 0, 0, 0, 0, 0 },
/* U+d65b */ { 0, 0, 0, 0, 0 },
/* U+d65c */ { 0, 0, 0, 0, 0 },
/* U+d65d */ { 0, 0, 0, 0, 0 },
/* U+d65e */ { 0, 0, 0, 0, 0 },
/* U+d65f */ { 0, 0, 0, 0, 0 },
/* U+d660 */ { 0, 0, 0, 0, 0 },
/* U+d661 */ { 0, 0, 0, 0, 0 },
/* U+d662 */ { 0, 0, 0, 0, 0 },
/* U+d663 */ { 0, 0, 0, 0, 0 },
/* U+d664 */ { 0, 0, 0, 0, 0 },
/* U+d665 */ { 0, 0, 0, 0, 0 },
/* U+d666 */ { 0, 0, 0, 0, 0 },
/* U+d667 */ { 0, 0, 0, 0, 0 },
/* U+d668 */ { 0, 0, 0, 0, 0 },
/* U+d669 */ { 0, 0, 0, 0, 0 },
/* U+d66a */ { 0, 0, 0, 0, 0 },
/* U+d66b */ { 0, 0, 0, 0, 0 },
/* U+d66c */ { 0, 0, 0, 0, 0 },
/* U+d66d */ { 0, 0, 0, 0, 0 },
/* U+d66e */ { 0, 0, 0, 0, 0 },
/* U+d66f */ { 0, 0, 0, 0, 0 },
/* U+d670 */ { 0, 0, 0, 0, 0 },
/* U+d671 */ { 0, 0, 0, 0, 0 },
/* U+d672 */ { 0, 0, 0, 0, 0 },
/* U+d673 */ { 0, 0, 0, 0, 0 },
/* U+d674 */ { 0, 0, 0, 0, 0 },
/* U+d675 */ { 0, 0, 0, 0, 0 },
/* U+d676 */ { 0, 0, 0, 0, 0 },
/* U+d677 */ { 0, 0, 0, 0, 0 },
/* U+d678 */ { 0, 0, 0, 0, 0 },
/* U+d679 */ { 0, 0, 0, 0, 0 },
/* U+d67a */ { 0, 0, 0, 0, 0 },
/* U+d67b */ { 0, 0, 0, 0, 0 },
/* U+d67c */ { 0, 0, 0, 0, 0 },
/* U+d67d */ { 0, 0, 0, 0, 0 },
/* U+d67e */ { 0, 0, 0, 0, 0 },
/* U+d67f */ { 0, 0, 0, 0, 0 },
/* U+d680 */ { 0, 0, 0, 0, 0 },
/* U+d681 */ { 0, 0, 0, 0, 0 },
/* U+d682 */ { 0, 0, 0, 0, 0 },
/* U+d683 */ { 0, 0, 0, 0, 0 },
/* U+d684 */ { 0, 0, 0, 0, 0 },
/* U+d685 */ { 0, 0, 0, 0, 0 },
/* U+d686 */ { 0, 0, 0, 0, 0 },
/* U+d687 */ { 0, 0, 0, 0, 0 },
/* U+d688 */ { 0, 0, 0, 0, 0 },
/* U+d689 */ { 0, 0, 0, 0, 0 },
/* U+d68a */ { 0, 0, 0, 0, 0 },
/* U+d68b */ { 0, 0, 0, 0, 0 },
/* U+d68c */ { 0, 0, 0, 0, 0 },
/* U+d68d */ { 0, 0, 0, 0, 0 },
/* U+d68e */ { 0, 0, 0, 0, 0 },
/* U+d68f */ { 0, 0, 0, 0, 0 },
/* U+d690 */ { 0, 0, 0, 0, 0 },
/* U+d691 */ { 0, 0, 0, 0, 0 },
/* U+d692 */ { 0, 0, 0, 0, 0 },
/* U+d693 */ { 0, 0, 0, 0, 0 },
/* U+d694 */ { 0, 0, 0, 0, 0 },
/* U+d695 */ { 0, 0, 0, 0, 0 },
/* U+d696 */ { 0, 0, 0, 0, 0 },
/* U+d697 */ { 0, 0, 0, 0, 0 },
/* U+d698 */ { 0, 0, 0, 0, 0 },
/* U+d699 */ { 0, 0, 0, 0, 0 },
/* U+d69a */ { 0, 0, 0, 0, 0 },
/* U+d69b */ { 0, 0, 0, 0, 0 },
/* U+d69c */ { 0, 0, 0, 0, 0 },
/* U+d69d */ { 0, 0, 0, 0, 0 },
/* U+d69e */ { 0, 0, 0, 0, 0 },
/* U+d69f */ { 0, 0, 0, 0, 0 },
/* U+d6a0 */ { 0, 0, 0, 0, 0 },
/* U+d6a1 */ { 0, 0, 0, 0, 0 },
/* U+d6a2 */ { 0, 0, 0, 0, 0 },
/* U+d6a3 */ { 0, 0, 0, 0, 0 },
/* U+d6a4 */ { 0, 0, 0, 0, 0 },
/* U+d6a5 */ { 0, 0, 0, 0, 0 },
/* U+d6a6 */ { 0, 0, 0, 0, 0 },
/* U+d6a7 */ { 0, 0, 0, 0, 0 },
/* U+d6a8 */ { 0, 0, 0, 0, 0 },
/* U+d6a9 */ { 0, 0, 0, 0, 0 },
/* U+d6aa */ { 0, 0, 0, 0, 0 },
/* U+d6ab */ { 0, 0, 0, 0, 0 },
/* U+d6ac */ { 0, 0, 0, 0, 0 },
/* U+d6ad */ { 0, 0, 0, 0, 0 },
/* U+d6ae */ { 0, 0, 0, 0, 0 },
/* U+d6af */ { 0, 0, 0, 0, 0 },
/* U+d6b0 */ { 0, 0, 0, 0, 0 },
/* U+d6b1 */ { 0, 0, 0, 0, 0 },
/* U+d6b2 */ { 0, 0, 0, 0, 0 },
/* U+d6b3 */ { 0, 0, 0, 0, 0 },
/* U+d6b4 */ { 0, 0, 0, 0, 0 },
/* U+d6b5 */ { 0, 0, 0, 0, 0 },
/* U+d6b6 */ { 0, 0, 0, 0, 0 },
/* U+d6b7 */ { 0, 0, 0, 0, 0 },
/* U+d6b8 */ { 0, 0, 0, 0, 0 },
/* U+d6b9 */ { 0, 0, 0, 0, 0 },
/* U+d6ba */ { 0, 0, 0, 0, 0 },
/* U+d6bb */ { 0, 0, 0, 0, 0 },
/* U+d6bc */ { 0, 0, 0, 0, 0 },
/* U+d6bd */ { 0, 0, 0, 0, 0 },
/* U+d6be */ { 0, 0, 0, 0, 0 },
/* U+d6bf */ { 0, 0, 0, 0, 0 },
/* U+d6c0 */ { 0, 0, 0, 0, 0 },
/* U+d6c1 */ { 0, 0, 0, 0, 0 },
/* U+d6c2 */ { 0, 0, 0, 0, 0 },
/* U+d6c3 */ { 0, 0, 0, 0, 0 },
/* U+d6c4 */ { 0, 0, 0, 0, 0 },
/* U+d6c5 */ { 0, 0, 0, 0, 0 },
/* U+d6c6 */ { 0, 0, 0, 0, 0 },
/* U+d6c7 */ { 0, 0, 0, 0, 0 },
/* U+d6c8 */ { 0, 0, 0, 0, 0 },
/* U+d6c9 */ { 0, 0, 0, 0, 0 },
/* U+d6ca */ { 0, 0, 0, 0, 0 },
/* U+d6cb */ { 0, 0, 0, 0, 0 },
/* U+d6cc */ { 0, 0, 0, 0, 0 },
/* U+d6cd */ { 0, 0, 0, 0, 0 },
/* U+d6ce */ { 0, 0, 0, 0, 0 },
/* U+d6cf */ { 0, 0, 0, 0, 0 },
/* U+d6d0 */ { 0, 0, 0, 0, 0 },
/* U+d6d1 */ { 0, 0, 0, 0, 0 },
/* U+d6d2 */ { 0, 0, 0, 0, 0 },
/* U+d6d3 */ { 0, 0, 0, 0, 0 },
/* U+d6d4 */ { 0, 0, 0, 0, 0 },
/* U+d6d5 */ { 0, 0, 0, 0, 0 },
/* U+d6d6 */ { 0, 0, 0, 0, 0 },
/* U+d6d7 */ { 0, 0, 0, 0, 0 },
/* U+d6d8 */ { 0, 0, 0, 0, 0 },
/* U+d6d9 */ { 0, 0, 0, 0, 0 },
/* U+d6da */ { 0, 0, 0, 0, 0 },
/* U+d6db */ { 0, 0, 0, 0, 0 },
/* U+d6dc */ { 0, 0, 0, 0, 0 },
/* U+d6dd */ { 0, 0, 0, 0, 0 },
/* U+d6de */ { 0, 0, 0, 0, 0 },
/* U+d6df */ { 0, 0, 0, 0, 0 },
/* U+d6e0 */ { 0, 0, 0, 0, 0 },
/* U+d6e1 */ { 0, 0, 0, 0, 0 },
/* U+d6e2 */ { 0, 0, 0, 0, 0 },
/* U+d6e3 */ { 0, 0, 0, 0, 0 },
/* U+d6e4 */ { 0, 0, 0, 0, 0 },
/* U+d6e5 */ { 0, 0, 0, 0, 0 },
/* U+d6e6 */ { 0, 0, 0, 0, 0 },
/* U+d6e7 */ { 0, 0, 0, 0, 0 },
/* U+d6e8 */ { 0, 0, 0, 0, 0 },
/* U+d6e9 */ { 0, 0, 0, 0, 0 },
/* U+d6ea */ { 0, 0, 0, 0, 0 },
/* U+d6eb */ { 0, 0, 0, 0, 0 },
/* U+d6ec */ { 0, 0, 0, 0, 0 },
/* U+d6ed */ { 0, 0, 0, 0, 0 },
/* U+d6ee */ { 0, 0, 0, 0, 0 },
/* U+d6ef */ { 0, 0, 0, 0, 0 },
/* U+d6f0 */ { 0, 0, 0, 0, 0 },
/* U+d6f1 */ { 0, 0, 0, 0, 0 },
/* U+d6f2 */ { 0, 0, 0, 0, 0 },
/* U+d6f3 */ { 0, 0, 0, 0, 0 },
/* U+d6f4 */ { 0, 0, 0, 0, 0 },
/* U+d6f5 */ { 0, 0, 0, 0, 0 },
/* U+d6f6 */ { 0, 0, 0, 0, 0 },
/* U+d6f7 */ { 0, 0, 0, 0, 0 },
/* U+d6f8 */ { 0, 0, 0, 0, 0 },
/* U+d6f9 */ { 0, 0, 0, 0, 0 },
/* U+d6fa */ { 0, 0, 0, 0, 0 },
/* U+d6fb */ { 0, 0, 0, 0, 0 },
/* U+d6fc */ { 0, 0, 0, 0, 0 },
/* U+d6fd */ { 0, 0, 0, 0, 0 },
/* U+d6fe */ { 0, 0, 0, 0, 0 },
/* U+d6ff */ { 0, 0, 0, 0, 0 },
/* U+d700 */ { 0, 0, 0, 0, 0 },
/* U+d701 */ { 0, 0, 0, 0, 0 },
/* U+d702 */ { 0, 0, 0, 0, 0 },
/* U+d703 */ { 0, 0, 0, 0, 0 },
/* U+d704 */ { 0, 0, 0, 0, 0 },
/* U+d705 */ { 0, 0, 0, 0, 0 },
/* U+d706 */ { 0, 0, 0, 0, 0 },
/* U+d707 */ { 0, 0, 0, 0, 0 },
/* U+d708 */ { 0, 0, 0, 0, 0 },
/* U+d709 */ { 0, 0, 0, 0, 0 },
/* U+d70a */ { 0, 0, 0, 0, 0 },
/* U+d70b */ { 0, 0, 0, 0, 0 },
/* U+d70c */ { 0, 0, 0, 0, 0 },
/* U+d70d */ { 0, 0, 0, 0, 0 },
/* U+d70e */ { 0, 0, 0, 0, 0 },
/* U+d70f */ { 0, 0, 0, 0, 0 },
/* U+d710 */ { 0, 0, 0, 0, 0 },
/* U+d711 */ { 0, 0, 0, 0, 0 },
/* U+d712 */ { 0, 0, 0, 0, 0 },
/* U+d713 */ { 0, 0, 0, 0, 0 },
/* U+d714 */ { 0, 0, 0, 0, 0 },
/* U+d715 */ { 0, 0, 0, 0, 0 },
/* U+d716 */ { 0, 0, 0, 0, 0 },
/* U+d717 */ { 0, 0, 0, 0, 0 },
/* U+d718 */ { 0, 0, 0, 0, 0 },
/* U+d719 */ { 0, 0, 0, 0, 0 },
/* U+d71a */ { 0, 0, 0, 0, 0 },
/* U+d71b */ { 0, 0, 0, 0, 0 },
/* U+d71c */ { 0, 0, 0, 0, 0 },
/* U+d71d */ { 0, 0, 0, 0, 0 },
/* U+d71e */ { 0, 0, 0, 0, 0 },
/* U+d71f */ { 0, 0, 0, 0, 0 },
/* U+d720 */ { 0, 0, 0, 0, 0 },
/* U+d721 */ { 0, 0, 0, 0, 0 },
/* U+d722 */ { 0, 0, 0, 0, 0 },
/* U+d723 */ { 0, 0, 0, 0, 0 },
/* U+d724 */ { 0, 0, 0, 0, 0 },
/* U+d725 */ { 0, 0, 0, 0, 0 },
/* U+d726 */ { 0, 0, 0, 0, 0 },
/* U+d727 */ { 0, 0, 0, 0, 0 },
/* U+d728 */ { 0, 0, 0, 0, 0 },
/* U+d729 */ { 0, 0, 0, 0, 0 },
/* U+d72a */ { 0, 0, 0, 0, 0 },
/* U+d72b */ { 0, 0, 0, 0, 0 },
/* U+d72c */ { 0, 0, 0, 0, 0 },
/* U+d72d */ { 0, 0, 0, 0, 0 },
/* U+d72e */ { 0, 0, 0, 0, 0 },
/* U+d72f */ { 0, 0, 0, 0, 0 },
/* U+d730 */ { 0, 0, 0, 0, 0 },
/* U+d731 */ { 0, 0, 0, 0, 0 },
/* U+d732 */ { 0, 0, 0, 0, 0 },
/* U+d733 */ { 0, 0, 0, 0, 0 },
/* U+d734 */ { 0, 0, 0, 0, 0 },
/* U+d735 */ { 0, 0, 0, 0, 0 },
/* U+d736 */ { 0, 0, 0, 0, 0 },
/* U+d737 */ { 0, 0, 0, 0, 0 },
/* U+d738 */ { 0, 0, 0, 0, 0 },
/* U+d739 */ { 0, 0, 0, 0, 0 },
/* U+d73a */ { 0, 0, 0, 0, 0 },
/* U+d73b */ { 0, 0, 0, 0, 0 },
/* U+d73c */ { 0, 0, 0, 0, 0 },
/* U+d73d */ { 0, 0, 0, 0, 0 },
/* U+d73e */ { 0, 0, 0, 0, 0 },
/* U+d73f */ { 0, 0, 0, 0, 0 },
/* U+d740 */ { 0, 0, 0, 0, 0 },
/* U+d741 */ { 0, 0, 0, 0, 0 },
/* U+d742 */ { 0, 0, 0, 0, 0 },
/* U+d743 */ { 0, 0, 0, 0, 0 },
/* U+d744 */ { 0, 0, 0, 0, 0 },
/* U+d745 */ { 0, 0, 0, 0, 0 },
/* U+d746 */ { 0, 0, 0, 0, 0 },
/* U+d747 */ { 0, 0, 0, 0, 0 },
/* U+d748 */ { 0, 0, 0, 0, 0 },
/* U+d749 */ { 0, 0, 0, 0, 0 },
/* U+d74a */ { 0, 0, 0, 0, 0 },
/* U+d74b */ { 0, 0, 0, 0, 0 },
/* U+d74c */ { 0, 0, 0, 0, 0 },
/* U+d74d */ { 0, 0, 0, 0, 0 },
/* U+d74e */ { 0, 0, 0, 0, 0 },
/* U+d74f */ { 0, 0, 0, 0, 0 },
/* U+d750 */ { 0, 0, 0, 0, 0 },
/* U+d751 */ { 0, 0, 0, 0, 0 },
/* U+d752 */ { 0, 0, 0, 0, 0 },
/* U+d753 */ { 0, 0, 0, 0, 0 },
/* U+d754 */ { 0, 0, 0, 0, 0 },
/* U+d755 */ { 0, 0, 0, 0, 0 },
/* U+d756 */ { 0, 0, 0, 0, 0 },
/* U+d757 */ { 0, 0, 0, 0, 0 },
/* U+d758 */ { 0, 0, 0, 0, 0 },
/* U+d759 */ { 0, 0, 0, 0, 0 },
/* U+d75a */ { 0, 0, 0, 0, 0 },
/* U+d75b */ { 0, 0, 0, 0, 0 },
/* U+d75c */ { 0, 0, 0, 0, 0 },
/* U+d75d */ { 0, 0, 0, 0, 0 },
/* U+d75e */ { 0, 0, 0, 0, 0 },
/* U+d75f */ { 0, 0, 0, 0, 0 },
/* U+d760 */ { 0, 0, 0, 0, 0 },
/* U+d761 */ { 0, 0, 0, 0, 0 },
/* U+d762 */ { 0, 0, 0, 0, 0 },
/* U+d763 */ { 0, 0, 0, 0, 0 },
/* U+d764 */ { 0, 0, 0, 0, 0 },
/* U+d765 */ { 0, 0, 0, 0, 0 },
/* U+d766 */ { 0, 0, 0, 0, 0 },
/* U+d767 */ { 0, 0, 0, 0, 0 },
/* U+d768 */ { 0, 0, 0, 0, 0 },
/* U+d769 */ { 0, 0, 0, 0, 0 },
/* U+d76a */ { 0, 0, 0, 0, 0 },
/* U+d76b */ { 0, 0, 0, 0, 0 },
/* U+d76c */ { 0, 0, 0, 0, 0 },
/* U+d76d */ { 0, 0, 0, 0, 0 },
/* U+d76e */ { 0, 0, 0, 0, 0 },
/* U+d76f */ { 0, 0, 0, 0, 0 },
/* U+d770 */ { 0, 0, 0, 0, 0 },
/* U+d771 */ { 0, 0, 0, 0, 0 },
/* U+d772 */ { 0, 0, 0, 0, 0 },
/* U+d773 */ { 0, 0, 0, 0, 0 },
/* U+d774 */ { 0, 0, 0, 0, 0 },
/* U+d775 */ { 0, 0, 0, 0, 0 },
/* U+d776 */ { 0, 0, 0, 0, 0 },
/* U+d777 */ { 0, 0, 0, 0, 0 },
/* U+d778 */ { 0, 0, 0, 0, 0 },
/* U+d779 */ { 0, 0, 0, 0, 0 },
/* U+d77a */ { 0, 0, 0, 0, 0 },
/* U+d77b */ { 0, 0, 0, 0, 0 },
/* U+d77c */ { 0, 0, 0, 0, 0 },
/* U+d77d */ { 0, 0, 0, 0, 0 },
/* U+d77e */ { 0, 0, 0, 0, 0 },
/* U+d77f */ { 0, 0, 0, 0, 0 },
/* U+d780 */ { 0, 0, 0, 0, 0 },
/* U+d781 */ { 0, 0, 0, 0, 0 },
/* U+d782 */ { 0, 0, 0, 0, 0 },
/* U+d783 */ { 0, 0, 0, 0, 0 },
/* U+d784 */ { 0, 0, 0, 0, 0 },
/* U+d785 */ { 0, 0, 0, 0, 0 },
/* U+d786 */ { 0, 0, 0, 0, 0 },
/* U+d787 */ { 0, 0, 0, 0, 0 },
/* U+d788 */ { 0, 0, 0, 0, 0 },
/* U+d789 */ { 0, 0, 0, 0, 0 },
/* U+d78a */ { 0, 0, 0, 0, 0 },
/* U+d78b */ { 0, 0, 0, 0, 0 },
/* U+d78c */ { 0, 0, 0, 0, 0 },
/* U+d78d */ { 0, 0, 0, 0, 0 },
/* U+d78e */ { 0, 0, 0, 0, 0 },
/* U+d78f */ { 0, 0, 0, 0, 0 },
/* U+d790 */ { 0, 0, 0, 0, 0 },
/* U+d791 */ { 0, 0, 0, 0, 0 },
/* U+d792 */ { 0, 0, 0, 0, 0 },
/* U+d793 */ { 0, 0, 0, 0, 0 },
/* U+d794 */ { 0, 0, 0, 0, 0 },
/* U+d795 */ { 0, 0, 0, 0, 0 },
/* U+d796 */ { 0, 0, 0, 0, 0 },
/* U+d797 */ { 0, 0, 0, 0, 0 },
/* U+d798 */ { 0, 0, 0, 0, 0 },
/* U+d799 */ { 0, 0, 0, 0, 0 },
/* U+d79a */ { 0, 0, 0, 0, 0 },
/* U+d79b */ { 0, 0, 0, 0, 0 },
/* U+d79c */ { 0, 0, 0, 0, 0 },
/* U+d79d */ { 0, 0, 0, 0, 0 },
/* U+d79e */ { 0, 0, 0, 0, 0 },
/* U+d79f */ { 0, 0, 0, 0, 0 },
/* U+d7a0 */ { 0, 0, 0, 0, 0 },
/* U+d7a1 */ { 0, 0, 0, 0, 0 },
/* U+d7a2 */ { 0, 0, 0, 0, 0 },
/* U+d7a3 */ { 19, 0, 1, 0, 0 },
/* U+d7a4 */ { 0, 0, 0, 0, 0 },
/* U+d7a5 */ { 0, 0, 0, 0, 0 },
/* U+d7a6 */ { 0, 0, 0, 0, 0 },
/* U+d7a7 */ { 0, 0, 0, 0, 0 },
/* U+d7a8 */ { 0, 0, 0, 0, 0 },
/* U+d7a9 */ { 0, 0, 0, 0, 0 },
/* U+d7aa */ { 0, 0, 0, 0, 0 },
/* U+d7ab */ { 0, 0, 0, 0, 0 },
/* U+d7ac */ { 0, 0, 0, 0, 0 },
/* U+d7ad */ { 0, 0, 0, 0, 0 },
/* U+d7ae */ { 0, 0, 0, 0, 0 },
/* U+d7af */ { 0, 0, 0, 0, 0 },
/* U+d7b0 */ { 0, 0, 0, 0, 0 },
/* U+d7b1 */ { 0, 0, 0, 0, 0 },
/* U+d7b2 */ { 0, 0, 0, 0, 0 },
/* U+d7b3 */ { 0, 0, 0, 0, 0 },
/* U+d7b4 */ { 0, 0, 0, 0, 0 },
/* U+d7b5 */ { 0, 0, 0, 0, 0 },
/* U+d7b6 */ { 0, 0, 0, 0, 0 },
/* U+d7b7 */ { 0, 0, 0, 0, 0 },
/* U+d7b8 */ { 0, 0, 0, 0, 0 },
/* U+d7b9 */ { 0, 0, 0, 0, 0 },
/* U+d7ba */ { 0, 0, 0, 0, 0 },
/* U+d7bb */ { 0, 0, 0, 0, 0 },
/* U+d7bc */ { 0, 0, 0, 0, 0 },
/* U+d7bd */ { 0, 0, 0, 0, 0 },
/* U+d7be */ { 0, 0, 0, 0, 0 },
/* U+d7bf */ { 0, 0, 0, 0, 0 },
/* U+d7c0 */ { 0, 0, 0, 0, 0 },
/* U+d7c1 */ { 0, 0, 0, 0, 0 },
/* U+d7c2 */ { 0, 0, 0, 0, 0 },
/* U+d7c3 */ { 0, 0, 0, 0, 0 },
/* U+d7c4 */ { 0, 0, 0, 0, 0 },
/* U+d7c5 */ { 0, 0, 0, 0, 0 },
/* U+d7c6 */ { 0, 0, 0, 0, 0 },
/* U+d7c7 */ { 0, 0, 0, 0, 0 },
/* U+d7c8 */ { 0, 0, 0, 0, 0 },
/* U+d7c9 */ { 0, 0, 0, 0, 0 },
/* U+d7ca */ { 0, 0, 0, 0, 0 },
/* U+d7cb */ { 0, 0, 0, 0, 0 },
/* U+d7cc */ { 0, 0, 0, 0, 0 },
/* U+d7cd */ { 0, 0, 0, 0, 0 },
/* U+d7ce */ { 0, 0, 0, 0, 0 },
/* U+d7cf */ { 0, 0, 0, 0, 0 },
/* U+d7d0 */ { 0, 0, 0, 0, 0 },
/* U+d7d1 */ { 0, 0, 0, 0, 0 },
/* U+d7d2 */ { 0, 0, 0, 0, 0 },
/* U+d7d3 */ { 0, 0, 0, 0, 0 },
/* U+d7d4 */ { 0, 0, 0, 0, 0 },
/* U+d7d5 */ { 0, 0, 0, 0, 0 },
/* U+d7d6 */ { 0, 0, 0, 0, 0 },
/* U+d7d7 */ { 0, 0, 0, 0, 0 },
/* U+d7d8 */ { 0, 0, 0, 0, 0 },
/* U+d7d9 */ { 0, 0, 0, 0, 0 },
/* U+d7da */ { 0, 0, 0, 0, 0 },
/* U+d7db */ { 0, 0, 0, 0, 0 },
/* U+d7dc */ { 0, 0, 0, 0, 0 },
/* U+d7dd */ { 0, 0, 0, 0, 0 },
/* U+d7de */ { 0, 0, 0, 0, 0 },
/* U+d7df */ { 0, 0, 0, 0, 0 },
/* U+d7e0 */ { 0, 0, 0, 0, 0 },
/* U+d7e1 */ { 0, 0, 0, 0, 0 },
/* U+d7e2 */ { 0, 0, 0, 0, 0 },
/* U+d7e3 */ { 0, 0, 0, 0, 0 },
/* U+d7e4 */ { 0, 0, 0, 0, 0 },
/* U+d7e5 */ { 0, 0, 0, 0, 0 },
/* U+d7e6 */ { 0, 0, 0, 0, 0 },
/* U+d7e7 */ { 0, 0, 0, 0, 0 },
/* U+d7e8 */ { 0, 0, 0, 0, 0 },
/* U+d7e9 */ { 0, 0, 0, 0, 0 },
/* U+d7ea */ { 0, 0, 0, 0, 0 },
/* U+d7eb */ { 0, 0, 0, 0, 0 },
/* U+d7ec */ { 0, 0, 0, 0, 0 },
/* U+d7ed */ { 0, 0, 0, 0, 0 },
/* U+d7ee */ { 0, 0, 0, 0, 0 },
/* U+d7ef */ { 0, 0, 0, 0, 0 },
/* U+d7f0 */ { 0, 0, 0, 0, 0 },
/* U+d7f1 */ { 0, 0, 0, 0, 0 },
/* U+d7f2 */ { 0, 0, 0, 0, 0 },
/* U+d7f3 */ { 0, 0, 0, 0, 0 },
/* U+d7f4 */ { 0, 0, 0, 0, 0 },
/* U+d7f5 */ { 0, 0, 0, 0, 0 },
/* U+d7f6 */ { 0, 0, 0, 0, 0 },
/* U+d7f7 */ { 0, 0, 0, 0, 0 },
/* U+d7f8 */ { 0, 0, 0, 0, 0 },
/* U+d7f9 */ { 0, 0, 0, 0, 0 },
/* U+d7fa */ { 0, 0, 0, 0, 0 },
/* U+d7fb */ { 0, 0, 0, 0, 0 },
/* U+d7fc */ { 0, 0, 0, 0, 0 },
/* U+d7fd */ { 0, 0, 0, 0, 0 },
/* U+d7fe */ { 0, 0, 0, 0, 0 },
/* U+d7ff */ { 0, 0, 0, 0, 0 },
/* U+d800 */ { 15, 0, 1, 0, 0 },
/* U+d801 */ { 0, 0, 0, 0, 0 },
/* U+d802 */ { 0, 0, 0, 0, 0 },
/* U+d803 */ { 0, 0, 0, 0, 0 },
/* U+d804 */ { 0, 0, 0, 0, 0 },
/* U+d805 */ { 0, 0, 0, 0, 0 },
/* U+d806 */ { 0, 0, 0, 0, 0 },
/* U+d807 */ { 0, 0, 0, 0, 0 },
/* U+d808 */ { 0, 0, 0, 0, 0 },
/* U+d809 */ { 0, 0, 0, 0, 0 },
/* U+d80a */ { 0, 0, 0, 0, 0 },
/* U+d80b */ { 0, 0, 0, 0, 0 },
/* U+d80c */ { 0, 0, 0, 0, 0 },
/* U+d80d */ { 0, 0, 0, 0, 0 },
/* U+d80e */ { 0, 0, 0, 0, 0 },
/* U+d80f */ { 0, 0, 0, 0, 0 },
/* U+d810 */ { 0, 0, 0, 0, 0 },
/* U+d811 */ { 0, 0, 0, 0, 0 },
/* U+d812 */ { 0, 0, 0, 0, 0 },
/* U+d813 */ { 0, 0, 0, 0, 0 },
/* U+d814 */ { 0, 0, 0, 0, 0 },
/* U+d815 */ { 0, 0, 0, 0, 0 },
/* U+d816 */ { 0, 0, 0, 0, 0 },
/* U+d817 */ { 0, 0, 0, 0, 0 },
/* U+d818 */ { 0, 0, 0, 0, 0 },
/* U+d819 */ { 0, 0, 0, 0, 0 },
/* U+d81a */ { 0, 0, 0, 0, 0 },
/* U+d81b */ { 0, 0, 0, 0, 0 },
/* U+d81c */ { 0, 0, 0, 0, 0 },
/* U+d81d */ { 0, 0, 0, 0, 0 },
/* U+d81e */ { 0, 0, 0, 0, 0 },
/* U+d81f */ { 0, 0, 0, 0, 0 },
/* U+d820 */ { 0, 0, 0, 0, 0 },
/* U+d821 */ { 0, 0, 0, 0, 0 },
/* U+d822 */ { 0, 0, 0, 0, 0 },
/* U+d823 */ { 0, 0, 0, 0, 0 },
/* U+d824 */ { 0, 0, 0, 0, 0 },
/* U+d825 */ { 0, 0, 0, 0, 0 },
/* U+d826 */ { 0, 0, 0, 0, 0 },
/* U+d827 */ { 0, 0, 0, 0, 0 },
/* U+d828 */ { 0, 0, 0, 0, 0 },
/* U+d829 */ { 0, 0, 0, 0, 0 },
/* U+d82a */ { 0, 0, 0, 0, 0 },
/* U+d82b */ { 0, 0, 0, 0, 0 },
/* U+d82c */ { 0, 0, 0, 0, 0 },
/* U+d82d */ { 0, 0, 0, 0, 0 },
/* U+d82e */ { 0, 0, 0, 0, 0 },
/* U+d82f */ { 0, 0, 0, 0, 0 },
/* U+d830 */ { 0, 0, 0, 0, 0 },
/* U+d831 */ { 0, 0, 0, 0, 0 },
/* U+d832 */ { 0, 0, 0, 0, 0 },
/* U+d833 */ { 0, 0, 0, 0, 0 },
/* U+d834 */ { 0, 0, 0, 0, 0 },
/* U+d835 */ { 0, 0, 0, 0, 0 },
/* U+d836 */ { 0, 0, 0, 0, 0 },
/* U+d837 */ { 0, 0, 0, 0, 0 },
/* U+d838 */ { 0, 0, 0, 0, 0 },
/* U+d839 */ { 0, 0, 0, 0, 0 },
/* U+d83a */ { 0, 0, 0, 0, 0 },
/* U+d83b */ { 0, 0, 0, 0, 0 },
/* U+d83c */ { 0, 0, 0, 0, 0 },
/* U+d83d */ { 0, 0, 0, 0, 0 },
/* U+d83e */ { 0, 0, 0, 0, 0 },
/* U+d83f */ { 0, 0, 0, 0, 0 },
/* U+d840 */ { 0, 0, 0, 0, 0 },
/* U+d841 */ { 0, 0, 0, 0, 0 },
/* U+d842 */ { 0, 0, 0, 0, 0 },
/* U+d843 */ { 0, 0, 0, 0, 0 },
/* U+d844 */ { 0, 0, 0, 0, 0 },
/* U+d845 */ { 0, 0, 0, 0, 0 },
/* U+d846 */ { 0, 0, 0, 0, 0 },
/* U+d847 */ { 0, 0, 0, 0, 0 },
/* U+d848 */ { 0, 0, 0, 0, 0 },
/* U+d849 */ { 0, 0, 0, 0, 0 },
/* U+d84a */ { 0, 0, 0, 0, 0 },
/* U+d84b */ { 0, 0, 0, 0, 0 },
/* U+d84c */ { 0, 0, 0, 0, 0 },
/* U+d84d */ { 0, 0, 0, 0, 0 },
/* U+d84e */ { 0, 0, 0, 0, 0 },
/* U+d84f */ { 0, 0, 0, 0, 0 },
/* U+d850 */ { 0, 0, 0, 0, 0 },
/* U+d851 */ { 0, 0, 0, 0, 0 },
/* U+d852 */ { 0, 0, 0, 0, 0 },
/* U+d853 */ { 0, 0, 0, 0, 0 },
/* U+d854 */ { 0, 0, 0, 0, 0 },
/* U+d855 */ { 0, 0, 0, 0, 0 },
/* U+d856 */ { 0, 0, 0, 0, 0 },
/* U+d857 */ { 0, 0, 0, 0, 0 },
/* U+d858 */ { 0, 0, 0, 0, 0 },
/* U+d859 */ { 0, 0, 0, 0, 0 },
/* U+d85a */ { 0, 0, 0, 0, 0 },
/* U+d85b */ { 0, 0, 0, 0, 0 },
/* U+d85c */ { 0, 0, 0, 0, 0 },
/* U+d85d */ { 0, 0, 0, 0, 0 },
/* U+d85e */ { 0, 0, 0, 0, 0 },
/* U+d85f */ { 0, 0, 0, 0, 0 },
/* U+d860 */ { 0, 0, 0, 0, 0 },
/* U+d861 */ { 0, 0, 0, 0, 0 },
/* U+d862 */ { 0, 0, 0, 0, 0 },
/* U+d863 */ { 0, 0, 0, 0, 0 },
/* U+d864 */ { 0, 0, 0, 0, 0 },
/* U+d865 */ { 0, 0, 0, 0, 0 },
/* U+d866 */ { 0, 0, 0, 0, 0 },
/* U+d867 */ { 0, 0, 0, 0, 0 },
/* U+d868 */ { 0, 0, 0, 0, 0 },
/* U+d869 */ { 0, 0, 0, 0, 0 },
/* U+d86a */ { 0, 0, 0, 0, 0 },
/* U+d86b */ { 0, 0, 0, 0, 0 },
/* U+d86c */ { 0, 0, 0, 0, 0 },
/* U+d86d */ { 0, 0, 0, 0, 0 },
/* U+d86e */ { 0, 0, 0, 0, 0 },
/* U+d86f */ { 0, 0, 0, 0, 0 },
/* U+d870 */ { 0, 0, 0, 0, 0 },
/* U+d871 */ { 0, 0, 0, 0, 0 },
/* U+d872 */ { 0, 0, 0, 0, 0 },
/* U+d873 */ { 0, 0, 0, 0, 0 },
/* U+d874 */ { 0, 0, 0, 0, 0 },
/* U+d875 */ { 0, 0, 0, 0, 0 },
/* U+d876 */ { 0, 0, 0, 0, 0 },
/* U+d877 */ { 0, 0, 0, 0, 0 },
/* U+d878 */ { 0, 0, 0, 0, 0 },
/* U+d879 */ { 0, 0, 0, 0, 0 },
/* U+d87a */ { 0, 0, 0, 0, 0 },
/* U+d87b */ { 0, 0, 0, 0, 0 },
/* U+d87c */ { 0, 0, 0, 0, 0 },
/* U+d87d */ { 0, 0, 0, 0, 0 },
/* U+d87e */ { 0, 0, 0, 0, 0 },
/* U+d87f */ { 0, 0, 0, 0, 0 },
/* U+d880 */ { 0, 0, 0, 0, 0 },
/* U+d881 */ { 0, 0, 0, 0, 0 },
/* U+d882 */ { 0, 0, 0, 0, 0 },
/* U+d883 */ { 0, 0, 0, 0, 0 },
/* U+d884 */ { 0, 0, 0, 0, 0 },
/* U+d885 */ { 0, 0, 0, 0, 0 },
/* U+d886 */ { 0, 0, 0, 0, 0 },
/* U+d887 */ { 0, 0, 0, 0, 0 },
/* U+d888 */ { 0, 0, 0, 0, 0 },
/* U+d889 */ { 0, 0, 0, 0, 0 },
/* U+d88a */ { 0, 0, 0, 0, 0 },
/* U+d88b */ { 0, 0, 0, 0, 0 },
/* U+d88c */ { 0, 0, 0, 0, 0 },
/* U+d88d */ { 0, 0, 0, 0, 0 },
/* U+d88e */ { 0, 0, 0, 0, 0 },
/* U+d88f */ { 0, 0, 0, 0, 0 },
/* U+d890 */ { 0, 0, 0, 0, 0 },
/* U+d891 */ { 0, 0, 0, 0, 0 },
/* U+d892 */ { 0, 0, 0, 0, 0 },
/* U+d893 */ { 0, 0, 0, 0, 0 },
/* U+d894 */ { 0, 0, 0, 0, 0 },
/* U+d895 */ { 0, 0, 0, 0, 0 },
/* U+d896 */ { 0, 0, 0, 0, 0 },
/* U+d897 */ { 0, 0, 0, 0, 0 },
/* U+d898 */ { 0, 0, 0, 0, 0 },
/* U+d899 */ { 0, 0, 0, 0, 0 },
/* U+d89a */ { 0, 0, 0, 0, 0 },
/* U+d89b */ { 0, 0, 0, 0, 0 },
/* U+d89c */ { 0, 0, 0, 0, 0 },
/* U+d89d */ { 0, 0, 0, 0, 0 },
/* U+d89e */ { 0, 0, 0, 0, 0 },
/* U+d89f */ { 0, 0, 0, 0, 0 },
/* U+d8a0 */ { 0, 0, 0, 0, 0 },
/* U+d8a1 */ { 0, 0, 0, 0, 0 },
/* U+d8a2 */ { 0, 0, 0, 0, 0 },
/* U+d8a3 */ { 0, 0, 0, 0, 0 },
/* U+d8a4 */ { 0, 0, 0, 0, 0 },
/* U+d8a5 */ { 0, 0, 0, 0, 0 },
/* U+d8a6 */ { 0, 0, 0, 0, 0 },
/* U+d8a7 */ { 0, 0, 0, 0, 0 },
/* U+d8a8 */ { 0, 0, 0, 0, 0 },
/* U+d8a9 */ { 0, 0, 0, 0, 0 },
/* U+d8aa */ { 0, 0, 0, 0, 0 },
/* U+d8ab */ { 0, 0, 0, 0, 0 },
/* U+d8ac */ { 0, 0, 0, 0, 0 },
/* U+d8ad */ { 0, 0, 0, 0, 0 },
/* U+d8ae */ { 0, 0, 0, 0, 0 },
/* U+d8af */ { 0, 0, 0, 0, 0 },
/* U+d8b0 */ { 0, 0, 0, 0, 0 },
/* U+d8b1 */ { 0, 0, 0, 0, 0 },
/* U+d8b2 */ { 0, 0, 0, 0, 0 },
/* U+d8b3 */ { 0, 0, 0, 0, 0 },
/* U+d8b4 */ { 0, 0, 0, 0, 0 },
/* U+d8b5 */ { 0, 0, 0, 0, 0 },
/* U+d8b6 */ { 0, 0, 0, 0, 0 },
/* U+d8b7 */ { 0, 0, 0, 0, 0 },
/* U+d8b8 */ { 0, 0, 0, 0, 0 },
/* U+d8b9 */ { 0, 0, 0, 0, 0 },
/* U+d8ba */ { 0, 0, 0, 0, 0 },
/* U+d8bb */ { 0, 0, 0, 0, 0 },
/* U+d8bc */ { 0, 0, 0, 0, 0 },
/* U+d8bd */ { 0, 0, 0, 0, 0 },
/* U+d8be */ { 0, 0, 0, 0, 0 },
/* U+d8bf */ { 0, 0, 0, 0, 0 },
/* U+d8c0 */ { 0, 0, 0, 0, 0 },
/* U+d8c1 */ { 0, 0, 0, 0, 0 },
/* U+d8c2 */ { 0, 0, 0, 0, 0 },
/* U+d8c3 */ { 0, 0, 0, 0, 0 },
/* U+d8c4 */ { 0, 0, 0, 0, 0 },
/* U+d8c5 */ { 0, 0, 0, 0, 0 },
/* U+d8c6 */ { 0, 0, 0, 0, 0 },
/* U+d8c7 */ { 0, 0, 0, 0, 0 },
/* U+d8c8 */ { 0, 0, 0, 0, 0 },
/* U+d8c9 */ { 0, 0, 0, 0, 0 },
/* U+d8ca */ { 0, 0, 0, 0, 0 },
/* U+d8cb */ { 0, 0, 0, 0, 0 },
/* U+d8cc */ { 0, 0, 0, 0, 0 },
/* U+d8cd */ { 0, 0, 0, 0, 0 },
/* U+d8ce */ { 0, 0, 0, 0, 0 },
/* U+d8cf */ { 0, 0, 0, 0, 0 },
/* U+d8d0 */ { 0, 0, 0, 0, 0 },
/* U+d8d1 */ { 0, 0, 0, 0, 0 },
/* U+d8d2 */ { 0, 0, 0, 0, 0 },
/* U+d8d3 */ { 0, 0, 0, 0, 0 },
/* U+d8d4 */ { 0, 0, 0, 0, 0 },
/* U+d8d5 */ { 0, 0, 0, 0, 0 },
/* U+d8d6 */ { 0, 0, 0, 0, 0 },
/* U+d8d7 */ { 0, 0, 0, 0, 0 },
/* U+d8d8 */ { 0, 0, 0, 0, 0 },
/* U+d8d9 */ { 0, 0, 0, 0, 0 },
/* U+d8da */ { 0, 0, 0, 0, 0 },
/* U+d8db */ { 0, 0, 0, 0, 0 },
/* U+d8dc */ { 0, 0, 0, 0, 0 },
/* U+d8dd */ { 0, 0, 0, 0, 0 },
/* U+d8de */ { 0, 0, 0, 0, 0 },
/* U+d8df */ { 0, 0, 0, 0, 0 },
/* U+d8e0 */ { 0, 0, 0, 0, 0 },
/* U+d8e1 */ { 0, 0, 0, 0, 0 },
/* U+d8e2 */ { 0, 0, 0, 0, 0 },
/* U+d8e3 */ { 0, 0, 0, 0, 0 },
/* U+d8e4 */ { 0, 0, 0, 0, 0 },
/* U+d8e5 */ { 0, 0, 0, 0, 0 },
/* U+d8e6 */ { 0, 0, 0, 0, 0 },
/* U+d8e7 */ { 0, 0, 0, 0, 0 },
/* U+d8e8 */ { 0, 0, 0, 0, 0 },
/* U+d8e9 */ { 0, 0, 0, 0, 0 },
/* U+d8ea */ { 0, 0, 0, 0, 0 },
/* U+d8eb */ { 0, 0, 0, 0, 0 },
/* U+d8ec */ { 0, 0, 0, 0, 0 },
/* U+d8ed */ { 0, 0, 0, 0, 0 },
/* U+d8ee */ { 0, 0, 0, 0, 0 },
/* U+d8ef */ { 0, 0, 0, 0, 0 },
/* U+d8f0 */ { 0, 0, 0, 0, 0 },
/* U+d8f1 */ { 0, 0, 0, 0, 0 },
/* U+d8f2 */ { 0, 0, 0, 0, 0 },
/* U+d8f3 */ { 0, 0, 0, 0, 0 },
/* U+d8f4 */ { 0, 0, 0, 0, 0 },
/* U+d8f5 */ { 0, 0, 0, 0, 0 },
/* U+d8f6 */ { 0, 0, 0, 0, 0 },
/* U+d8f7 */ { 0, 0, 0, 0, 0 },
/* U+d8f8 */ { 0, 0, 0, 0, 0 },
/* U+d8f9 */ { 0, 0, 0, 0, 0 },
/* U+d8fa */ { 0, 0, 0, 0, 0 },
/* U+d8fb */ { 0, 0, 0, 0, 0 },
/* U+d8fc */ { 0, 0, 0, 0, 0 },
/* U+d8fd */ { 0, 0, 0, 0, 0 },
/* U+d8fe */ { 0, 0, 0, 0, 0 },
/* U+d8ff */ { 0, 0, 0, 0, 0 },
/* U+d900 */ { 0, 0, 0, 0, 0 },
/* U+d901 */ { 0, 0, 0, 0, 0 },
/* U+d902 */ { 0, 0, 0, 0, 0 },
/* U+d903 */ { 0, 0, 0, 0, 0 },
/* U+d904 */ { 0, 0, 0, 0, 0 },
/* U+d905 */ { 0, 0, 0, 0, 0 },
/* U+d906 */ { 0, 0, 0, 0, 0 },
/* U+d907 */ { 0, 0, 0, 0, 0 },
/* U+d908 */ { 0, 0, 0, 0, 0 },
/* U+d909 */ { 0, 0, 0, 0, 0 },
/* U+d90a */ { 0, 0, 0, 0, 0 },
/* U+d90b */ { 0, 0, 0, 0, 0 },
/* U+d90c */ { 0, 0, 0, 0, 0 },
/* U+d90d */ { 0, 0, 0, 0, 0 },
/* U+d90e */ { 0, 0, 0, 0, 0 },
/* U+d90f */ { 0, 0, 0, 0, 0 },
/* U+d910 */ { 0, 0, 0, 0, 0 },
/* U+d911 */ { 0, 0, 0, 0, 0 },
/* U+d912 */ { 0, 0, 0, 0, 0 },
/* U+d913 */ { 0, 0, 0, 0, 0 },
/* U+d914 */ { 0, 0, 0, 0, 0 },
/* U+d915 */ { 0, 0, 0, 0, 0 },
/* U+d916 */ { 0, 0, 0, 0, 0 },
/* U+d917 */ { 0, 0, 0, 0, 0 },
/* U+d918 */ { 0, 0, 0, 0, 0 },
/* U+d919 */ { 0, 0, 0, 0, 0 },
/* U+d91a */ { 0, 0, 0, 0, 0 },
/* U+d91b */ { 0, 0, 0, 0, 0 },
/* U+d91c */ { 0, 0, 0, 0, 0 },
/* U+d91d */ { 0, 0, 0, 0, 0 },
/* U+d91e */ { 0, 0, 0, 0, 0 },
/* U+d91f */ { 0, 0, 0, 0, 0 },
/* U+d920 */ { 0, 0, 0, 0, 0 },
/* U+d921 */ { 0, 0, 0, 0, 0 },
/* U+d922 */ { 0, 0, 0, 0, 0 },
/* U+d923 */ { 0, 0, 0, 0, 0 },
/* U+d924 */ { 0, 0, 0, 0, 0 },
/* U+d925 */ { 0, 0, 0, 0, 0 },
/* U+d926 */ { 0, 0, 0, 0, 0 },
/* U+d927 */ { 0, 0, 0, 0, 0 },
/* U+d928 */ { 0, 0, 0, 0, 0 },
/* U+d929 */ { 0, 0, 0, 0, 0 },
/* U+d92a */ { 0, 0, 0, 0, 0 },
/* U+d92b */ { 0, 0, 0, 0, 0 },
/* U+d92c */ { 0, 0, 0, 0, 0 },
/* U+d92d */ { 0, 0, 0, 0, 0 },
/* U+d92e */ { 0, 0, 0, 0, 0 },
/* U+d92f */ { 0, 0, 0, 0, 0 },
/* U+d930 */ { 0, 0, 0, 0, 0 },
/* U+d931 */ { 0, 0, 0, 0, 0 },
/* U+d932 */ { 0, 0, 0, 0, 0 },
/* U+d933 */ { 0, 0, 0, 0, 0 },
/* U+d934 */ { 0, 0, 0, 0, 0 },
/* U+d935 */ { 0, 0, 0, 0, 0 },
/* U+d936 */ { 0, 0, 0, 0, 0 },
/* U+d937 */ { 0, 0, 0, 0, 0 },
/* U+d938 */ { 0, 0, 0, 0, 0 },
/* U+d939 */ { 0, 0, 0, 0, 0 },
/* U+d93a */ { 0, 0, 0, 0, 0 },
/* U+d93b */ { 0, 0, 0, 0, 0 },
/* U+d93c */ { 0, 0, 0, 0, 0 },
/* U+d93d */ { 0, 0, 0, 0, 0 },
/* U+d93e */ { 0, 0, 0, 0, 0 },
/* U+d93f */ { 0, 0, 0, 0, 0 },
/* U+d940 */ { 0, 0, 0, 0, 0 },
/* U+d941 */ { 0, 0, 0, 0, 0 },
/* U+d942 */ { 0, 0, 0, 0, 0 },
/* U+d943 */ { 0, 0, 0, 0, 0 },
/* U+d944 */ { 0, 0, 0, 0, 0 },
/* U+d945 */ { 0, 0, 0, 0, 0 },
/* U+d946 */ { 0, 0, 0, 0, 0 },
/* U+d947 */ { 0, 0, 0, 0, 0 },
/* U+d948 */ { 0, 0, 0, 0, 0 },
/* U+d949 */ { 0, 0, 0, 0, 0 },
/* U+d94a */ { 0, 0, 0, 0, 0 },
/* U+d94b */ { 0, 0, 0, 0, 0 },
/* U+d94c */ { 0, 0, 0, 0, 0 },
/* U+d94d */ { 0, 0, 0, 0, 0 },
/* U+d94e */ { 0, 0, 0, 0, 0 },
/* U+d94f */ { 0, 0, 0, 0, 0 },
/* U+d950 */ { 0, 0, 0, 0, 0 },
/* U+d951 */ { 0, 0, 0, 0, 0 },
/* U+d952 */ { 0, 0, 0, 0, 0 },
/* U+d953 */ { 0, 0, 0, 0, 0 },
/* U+d954 */ { 0, 0, 0, 0, 0 },
/* U+d955 */ { 0, 0, 0, 0, 0 },
/* U+d956 */ { 0, 0, 0, 0, 0 },
/* U+d957 */ { 0, 0, 0, 0, 0 },
/* U+d958 */ { 0, 0, 0, 0, 0 },
/* U+d959 */ { 0, 0, 0, 0, 0 },
/* U+d95a */ { 0, 0, 0, 0, 0 },
/* U+d95b */ { 0, 0, 0, 0, 0 },
/* U+d95c */ { 0, 0, 0, 0, 0 },
/* U+d95d */ { 0, 0, 0, 0, 0 },
/* U+d95e */ { 0, 0, 0, 0, 0 },
/* U+d95f */ { 0, 0, 0, 0, 0 },
/* U+d960 */ { 0, 0, 0, 0, 0 },
/* U+d961 */ { 0, 0, 0, 0, 0 },
/* U+d962 */ { 0, 0, 0, 0, 0 },
/* U+d963 */ { 0, 0, 0, 0, 0 },
/* U+d964 */ { 0, 0, 0, 0, 0 },
/* U+d965 */ { 0, 0, 0, 0, 0 },
/* U+d966 */ { 0, 0, 0, 0, 0 },
/* U+d967 */ { 0, 0, 0, 0, 0 },
/* U+d968 */ { 0, 0, 0, 0, 0 },
/* U+d969 */ { 0, 0, 0, 0, 0 },
/* U+d96a */ { 0, 0, 0, 0, 0 },
/* U+d96b */ { 0, 0, 0, 0, 0 },
/* U+d96c */ { 0, 0, 0, 0, 0 },
/* U+d96d */ { 0, 0, 0, 0, 0 },
/* U+d96e */ { 0, 0, 0, 0, 0 },
/* U+d96f */ { 0, 0, 0, 0, 0 },
/* U+d970 */ { 0, 0, 0, 0, 0 },
/* U+d971 */ { 0, 0, 0, 0, 0 },
/* U+d972 */ { 0, 0, 0, 0, 0 },
/* U+d973 */ { 0, 0, 0, 0, 0 },
/* U+d974 */ { 0, 0, 0, 0, 0 },
/* U+d975 */ { 0, 0, 0, 0, 0 },
/* U+d976 */ { 0, 0, 0, 0, 0 },
/* U+d977 */ { 0, 0, 0, 0, 0 },
/* U+d978 */ { 0, 0, 0, 0, 0 },
/* U+d979 */ { 0, 0, 0, 0, 0 },
/* U+d97a */ { 0, 0, 0, 0, 0 },
/* U+d97b */ { 0, 0, 0, 0, 0 },
/* U+d97c */ { 0, 0, 0, 0, 0 },
/* U+d97d */ { 0, 0, 0, 0, 0 },
/* U+d97e */ { 0, 0, 0, 0, 0 },
/* U+d97f */ { 0, 0, 0, 0, 0 },
/* U+d980 */ { 0, 0, 0, 0, 0 },
/* U+d981 */ { 0, 0, 0, 0, 0 },
/* U+d982 */ { 0, 0, 0, 0, 0 },
/* U+d983 */ { 0, 0, 0, 0, 0 },
/* U+d984 */ { 0, 0, 0, 0, 0 },
/* U+d985 */ { 0, 0, 0, 0, 0 },
/* U+d986 */ { 0, 0, 0, 0, 0 },
/* U+d987 */ { 0, 0, 0, 0, 0 },
/* U+d988 */ { 0, 0, 0, 0, 0 },
/* U+d989 */ { 0, 0, 0, 0, 0 },
/* U+d98a */ { 0, 0, 0, 0, 0 },
/* U+d98b */ { 0, 0, 0, 0, 0 },
/* U+d98c */ { 0, 0, 0, 0, 0 },
/* U+d98d */ { 0, 0, 0, 0, 0 },
/* U+d98e */ { 0, 0, 0, 0, 0 },
/* U+d98f */ { 0, 0, 0, 0, 0 },
/* U+d990 */ { 0, 0, 0, 0, 0 },
/* U+d991 */ { 0, 0, 0, 0, 0 },
/* U+d992 */ { 0, 0, 0, 0, 0 },
/* U+d993 */ { 0, 0, 0, 0, 0 },
/* U+d994 */ { 0, 0, 0, 0, 0 },
/* U+d995 */ { 0, 0, 0, 0, 0 },
/* U+d996 */ { 0, 0, 0, 0, 0 },
/* U+d997 */ { 0, 0, 0, 0, 0 },
/* U+d998 */ { 0, 0, 0, 0, 0 },
/* U+d999 */ { 0, 0, 0, 0, 0 },
/* U+d99a */ { 0, 0, 0, 0, 0 },
/* U+d99b */ { 0, 0, 0, 0, 0 },
/* U+d99c */ { 0, 0, 0, 0, 0 },
/* U+d99d */ { 0, 0, 0, 0, 0 },
/* U+d99e */ { 0, 0, 0, 0, 0 },
/* U+d99f */ { 0, 0, 0, 0, 0 },
/* U+d9a0 */ { 0, 0, 0, 0, 0 },
/* U+d9a1 */ { 0, 0, 0, 0, 0 },
/* U+d9a2 */ { 0, 0, 0, 0, 0 },
/* U+d9a3 */ { 0, 0, 0, 0, 0 },
/* U+d9a4 */ { 0, 0, 0, 0, 0 },
/* U+d9a5 */ { 0, 0, 0, 0, 0 },
/* U+d9a6 */ { 0, 0, 0, 0, 0 },
/* U+d9a7 */ { 0, 0, 0, 0, 0 },
/* U+d9a8 */ { 0, 0, 0, 0, 0 },
/* U+d9a9 */ { 0, 0, 0, 0, 0 },
/* U+d9aa */ { 0, 0, 0, 0, 0 },
/* U+d9ab */ { 0, 0, 0, 0, 0 },
/* U+d9ac */ { 0, 0, 0, 0, 0 },
/* U+d9ad */ { 0, 0, 0, 0, 0 },
/* U+d9ae */ { 0, 0, 0, 0, 0 },
/* U+d9af */ { 0, 0, 0, 0, 0 },
/* U+d9b0 */ { 0, 0, 0, 0, 0 },
/* U+d9b1 */ { 0, 0, 0, 0, 0 },
/* U+d9b2 */ { 0, 0, 0, 0, 0 },
/* U+d9b3 */ { 0, 0, 0, 0, 0 },
/* U+d9b4 */ { 0, 0, 0, 0, 0 },
/* U+d9b5 */ { 0, 0, 0, 0, 0 },
/* U+d9b6 */ { 0, 0, 0, 0, 0 },
/* U+d9b7 */ { 0, 0, 0, 0, 0 },
/* U+d9b8 */ { 0, 0, 0, 0, 0 },
/* U+d9b9 */ { 0, 0, 0, 0, 0 },
/* U+d9ba */ { 0, 0, 0, 0, 0 },
/* U+d9bb */ { 0, 0, 0, 0, 0 },
/* U+d9bc */ { 0, 0, 0, 0, 0 },
/* U+d9bd */ { 0, 0, 0, 0, 0 },
/* U+d9be */ { 0, 0, 0, 0, 0 },
/* U+d9bf */ { 0, 0, 0, 0, 0 },
/* U+d9c0 */ { 0, 0, 0, 0, 0 },
/* U+d9c1 */ { 0, 0, 0, 0, 0 },
/* U+d9c2 */ { 0, 0, 0, 0, 0 },
/* U+d9c3 */ { 0, 0, 0, 0, 0 },
/* U+d9c4 */ { 0, 0, 0, 0, 0 },
/* U+d9c5 */ { 0, 0, 0, 0, 0 },
/* U+d9c6 */ { 0, 0, 0, 0, 0 },
/* U+d9c7 */ { 0, 0, 0, 0, 0 },
/* U+d9c8 */ { 0, 0, 0, 0, 0 },
/* U+d9c9 */ { 0, 0, 0, 0, 0 },
/* U+d9ca */ { 0, 0, 0, 0, 0 },
/* U+d9cb */ { 0, 0, 0, 0, 0 },
/* U+d9cc */ { 0, 0, 0, 0, 0 },
/* U+d9cd */ { 0, 0, 0, 0, 0 },
/* U+d9ce */ { 0, 0, 0, 0, 0 },
/* U+d9cf */ { 0, 0, 0, 0, 0 },
/* U+d9d0 */ { 0, 0, 0, 0, 0 },
/* U+d9d1 */ { 0, 0, 0, 0, 0 },
/* U+d9d2 */ { 0, 0, 0, 0, 0 },
/* U+d9d3 */ { 0, 0, 0, 0, 0 },
/* U+d9d4 */ { 0, 0, 0, 0, 0 },
/* U+d9d5 */ { 0, 0, 0, 0, 0 },
/* U+d9d6 */ { 0, 0, 0, 0, 0 },
/* U+d9d7 */ { 0, 0, 0, 0, 0 },
/* U+d9d8 */ { 0, 0, 0, 0, 0 },
/* U+d9d9 */ { 0, 0, 0, 0, 0 },
/* U+d9da */ { 0, 0, 0, 0, 0 },
/* U+d9db */ { 0, 0, 0, 0, 0 },
/* U+d9dc */ { 0, 0, 0, 0, 0 },
/* U+d9dd */ { 0, 0, 0, 0, 0 },
/* U+d9de */ { 0, 0, 0, 0, 0 },
/* U+d9df */ { 0, 0, 0, 0, 0 },
/* U+d9e0 */ { 0, 0, 0, 0, 0 },
/* U+d9e1 */ { 0, 0, 0, 0, 0 },
/* U+d9e2 */ { 0, 0, 0, 0, 0 },
/* U+d9e3 */ { 0, 0, 0, 0, 0 },
/* U+d9e4 */ { 0, 0, 0, 0, 0 },
/* U+d9e5 */ { 0, 0, 0, 0, 0 },
/* U+d9e6 */ { 0, 0, 0, 0, 0 },
/* U+d9e7 */ { 0, 0, 0, 0, 0 },
/* U+d9e8 */ { 0, 0, 0, 0, 0 },
/* U+d9e9 */ { 0, 0, 0, 0, 0 },
/* U+d9ea */ { 0, 0, 0, 0, 0 },
/* U+d9eb */ { 0, 0, 0, 0, 0 },
/* U+d9ec */ { 0, 0, 0, 0, 0 },
/* U+d9ed */ { 0, 0, 0, 0, 0 },
/* U+d9ee */ { 0, 0, 0, 0, 0 },
/* U+d9ef */ { 0, 0, 0, 0, 0 },
/* U+d9f0 */ { 0, 0, 0, 0, 0 },
/* U+d9f1 */ { 0, 0, 0, 0, 0 },
/* U+d9f2 */ { 0, 0, 0, 0, 0 },
/* U+d9f3 */ { 0, 0, 0, 0, 0 },
/* U+d9f4 */ { 0, 0, 0, 0, 0 },
/* U+d9f5 */ { 0, 0, 0, 0, 0 },
/* U+d9f6 */ { 0, 0, 0, 0, 0 },
/* U+d9f7 */ { 0, 0, 0, 0, 0 },
/* U+d9f8 */ { 0, 0, 0, 0, 0 },
/* U+d9f9 */ { 0, 0, 0, 0, 0 },
/* U+d9fa */ { 0, 0, 0, 0, 0 },
/* U+d9fb */ { 0, 0, 0, 0, 0 },
/* U+d9fc */ { 0, 0, 0, 0, 0 },
/* U+d9fd */ { 0, 0, 0, 0, 0 },
/* U+d9fe */ { 0, 0, 0, 0, 0 },
/* U+d9ff */ { 0, 0, 0, 0, 0 },
/* U+da00 */ { 0, 0, 0, 0, 0 },
/* U+da01 */ { 0, 0, 0, 0, 0 },
/* U+da02 */ { 0, 0, 0, 0, 0 },
/* U+da03 */ { 0, 0, 0, 0, 0 },
/* U+da04 */ { 0, 0, 0, 0, 0 },
/* U+da05 */ { 0, 0, 0, 0, 0 },
/* U+da06 */ { 0, 0, 0, 0, 0 },
/* U+da07 */ { 0, 0, 0, 0, 0 },
/* U+da08 */ { 0, 0, 0, 0, 0 },
/* U+da09 */ { 0, 0, 0, 0, 0 },
/* U+da0a */ { 0, 0, 0, 0, 0 },
/* U+da0b */ { 0, 0, 0, 0, 0 },
/* U+da0c */ { 0, 0, 0, 0, 0 },
/* U+da0d */ { 0, 0, 0, 0, 0 },
/* U+da0e */ { 0, 0, 0, 0, 0 },
/* U+da0f */ { 0, 0, 0, 0, 0 },
/* U+da10 */ { 0, 0, 0, 0, 0 },
/* U+da11 */ { 0, 0, 0, 0, 0 },
/* U+da12 */ { 0, 0, 0, 0, 0 },
/* U+da13 */ { 0, 0, 0, 0, 0 },
/* U+da14 */ { 0, 0, 0, 0, 0 },
/* U+da15 */ { 0, 0, 0, 0, 0 },
/* U+da16 */ { 0, 0, 0, 0, 0 },
/* U+da17 */ { 0, 0, 0, 0, 0 },
/* U+da18 */ { 0, 0, 0, 0, 0 },
/* U+da19 */ { 0, 0, 0, 0, 0 },
/* U+da1a */ { 0, 0, 0, 0, 0 },
/* U+da1b */ { 0, 0, 0, 0, 0 },
/* U+da1c */ { 0, 0, 0, 0, 0 },
/* U+da1d */ { 0, 0, 0, 0, 0 },
/* U+da1e */ { 0, 0, 0, 0, 0 },
/* U+da1f */ { 0, 0, 0, 0, 0 },
/* U+da20 */ { 0, 0, 0, 0, 0 },
/* U+da21 */ { 0, 0, 0, 0, 0 },
/* U+da22 */ { 0, 0, 0, 0, 0 },
/* U+da23 */ { 0, 0, 0, 0, 0 },
/* U+da24 */ { 0, 0, 0, 0, 0 },
/* U+da25 */ { 0, 0, 0, 0, 0 },
/* U+da26 */ { 0, 0, 0, 0, 0 },
/* U+da27 */ { 0, 0, 0, 0, 0 },
/* U+da28 */ { 0, 0, 0, 0, 0 },
/* U+da29 */ { 0, 0, 0, 0, 0 },
/* U+da2a */ { 0, 0, 0, 0, 0 },
/* U+da2b */ { 0, 0, 0, 0, 0 },
/* U+da2c */ { 0, 0, 0, 0, 0 },
/* U+da2d */ { 0, 0, 0, 0, 0 },
/* U+da2e */ { 0, 0, 0, 0, 0 },
/* U+da2f */ { 0, 0, 0, 0, 0 },
/* U+da30 */ { 0, 0, 0, 0, 0 },
/* U+da31 */ { 0, 0, 0, 0, 0 },
/* U+da32 */ { 0, 0, 0, 0, 0 },
/* U+da33 */ { 0, 0, 0, 0, 0 },
/* U+da34 */ { 0, 0, 0, 0, 0 },
/* U+da35 */ { 0, 0, 0, 0, 0 },
/* U+da36 */ { 0, 0, 0, 0, 0 },
/* U+da37 */ { 0, 0, 0, 0, 0 },
/* U+da38 */ { 0, 0, 0, 0, 0 },
/* U+da39 */ { 0, 0, 0, 0, 0 },
/* U+da3a */ { 0, 0, 0, 0, 0 },
/* U+da3b */ { 0, 0, 0, 0, 0 },
/* U+da3c */ { 0, 0, 0, 0, 0 },
/* U+da3d */ { 0, 0, 0, 0, 0 },
/* U+da3e */ { 0, 0, 0, 0, 0 },
/* U+da3f */ { 0, 0, 0, 0, 0 },
/* U+da40 */ { 0, 0, 0, 0, 0 },
/* U+da41 */ { 0, 0, 0, 0, 0 },
/* U+da42 */ { 0, 0, 0, 0, 0 },
/* U+da43 */ { 0, 0, 0, 0, 0 },
/* U+da44 */ { 0, 0, 0, 0, 0 },
/* U+da45 */ { 0, 0, 0, 0, 0 },
/* U+da46 */ { 0, 0, 0, 0, 0 },
/* U+da47 */ { 0, 0, 0, 0, 0 },
/* U+da48 */ { 0, 0, 0, 0, 0 },
/* U+da49 */ { 0, 0, 0, 0, 0 },
/* U+da4a */ { 0, 0, 0, 0, 0 },
/* U+da4b */ { 0, 0, 0, 0, 0 },
/* U+da4c */ { 0, 0, 0, 0, 0 },
/* U+da4d */ { 0, 0, 0, 0, 0 },
/* U+da4e */ { 0, 0, 0, 0, 0 },
/* U+da4f */ { 0, 0, 0, 0, 0 },
/* U+da50 */ { 0, 0, 0, 0, 0 },
/* U+da51 */ { 0, 0, 0, 0, 0 },
/* U+da52 */ { 0, 0, 0, 0, 0 },
/* U+da53 */ { 0, 0, 0, 0, 0 },
/* U+da54 */ { 0, 0, 0, 0, 0 },
/* U+da55 */ { 0, 0, 0, 0, 0 },
/* U+da56 */ { 0, 0, 0, 0, 0 },
/* U+da57 */ { 0, 0, 0, 0, 0 },
/* U+da58 */ { 0, 0, 0, 0, 0 },
/* U+da59 */ { 0, 0, 0, 0, 0 },
/* U+da5a */ { 0, 0, 0, 0, 0 },
/* U+da5b */ { 0, 0, 0, 0, 0 },
/* U+da5c */ { 0, 0, 0, 0, 0 },
/* U+da5d */ { 0, 0, 0, 0, 0 },
/* U+da5e */ { 0, 0, 0, 0, 0 },
/* U+da5f */ { 0, 0, 0, 0, 0 },
/* U+da60 */ { 0, 0, 0, 0, 0 },
/* U+da61 */ { 0, 0, 0, 0, 0 },
/* U+da62 */ { 0, 0, 0, 0, 0 },
/* U+da63 */ { 0, 0, 0, 0, 0 },
/* U+da64 */ { 0, 0, 0, 0, 0 },
/* U+da65 */ { 0, 0, 0, 0, 0 },
/* U+da66 */ { 0, 0, 0, 0, 0 },
/* U+da67 */ { 0, 0, 0, 0, 0 },
/* U+da68 */ { 0, 0, 0, 0, 0 },
/* U+da69 */ { 0, 0, 0, 0, 0 },
/* U+da6a */ { 0, 0, 0, 0, 0 },
/* U+da6b */ { 0, 0, 0, 0, 0 },
/* U+da6c */ { 0, 0, 0, 0, 0 },
/* U+da6d */ { 0, 0, 0, 0, 0 },
/* U+da6e */ { 0, 0, 0, 0, 0 },
/* U+da6f */ { 0, 0, 0, 0, 0 },
/* U+da70 */ { 0, 0, 0, 0, 0 },
/* U+da71 */ { 0, 0, 0, 0, 0 },
/* U+da72 */ { 0, 0, 0, 0, 0 },
/* U+da73 */ { 0, 0, 0, 0, 0 },
/* U+da74 */ { 0, 0, 0, 0, 0 },
/* U+da75 */ { 0, 0, 0, 0, 0 },
/* U+da76 */ { 0, 0, 0, 0, 0 },
/* U+da77 */ { 0, 0, 0, 0, 0 },
/* U+da78 */ { 0, 0, 0, 0, 0 },
/* U+da79 */ { 0, 0, 0, 0, 0 },
/* U+da7a */ { 0, 0, 0, 0, 0 },
/* U+da7b */ { 0, 0, 0, 0, 0 },
/* U+da7c */ { 0, 0, 0, 0, 0 },
/* U+da7d */ { 0, 0, 0, 0, 0 },
/* U+da7e */ { 0, 0, 0, 0, 0 },
/* U+da7f */ { 0, 0, 0, 0, 0 },
/* U+da80 */ { 0, 0, 0, 0, 0 },
/* U+da81 */ { 0, 0, 0, 0, 0 },
/* U+da82 */ { 0, 0, 0, 0, 0 },
/* U+da83 */ { 0, 0, 0, 0, 0 },
/* U+da84 */ { 0, 0, 0, 0, 0 },
/* U+da85 */ { 0, 0, 0, 0, 0 },
/* U+da86 */ { 0, 0, 0, 0, 0 },
/* U+da87 */ { 0, 0, 0, 0, 0 },
/* U+da88 */ { 0, 0, 0, 0, 0 },
/* U+da89 */ { 0, 0, 0, 0, 0 },
/* U+da8a */ { 0, 0, 0, 0, 0 },
/* U+da8b */ { 0, 0, 0, 0, 0 },
/* U+da8c */ { 0, 0, 0, 0, 0 },
/* U+da8d */ { 0, 0, 0, 0, 0 },
/* U+da8e */ { 0, 0, 0, 0, 0 },
/* U+da8f */ { 0, 0, 0, 0, 0 },
/* U+da90 */ { 0, 0, 0, 0, 0 },
/* U+da91 */ { 0, 0, 0, 0, 0 },
/* U+da92 */ { 0, 0, 0, 0, 0 },
/* U+da93 */ { 0, 0, 0, 0, 0 },
/* U+da94 */ { 0, 0, 0, 0, 0 },
/* U+da95 */ { 0, 0, 0, 0, 0 },
/* U+da96 */ { 0, 0, 0, 0, 0 },
/* U+da97 */ { 0, 0, 0, 0, 0 },
/* U+da98 */ { 0, 0, 0, 0, 0 },
/* U+da99 */ { 0, 0, 0, 0, 0 },
/* U+da9a */ { 0, 0, 0, 0, 0 },
/* U+da9b */ { 0, 0, 0, 0, 0 },
/* U+da9c */ { 0, 0, 0, 0, 0 },
/* U+da9d */ { 0, 0, 0, 0, 0 },
/* U+da9e */ { 0, 0, 0, 0, 0 },
/* U+da9f */ { 0, 0, 0, 0, 0 },
/* U+daa0 */ { 0, 0, 0, 0, 0 },
/* U+daa1 */ { 0, 0, 0, 0, 0 },
/* U+daa2 */ { 0, 0, 0, 0, 0 },
/* U+daa3 */ { 0, 0, 0, 0, 0 },
/* U+daa4 */ { 0, 0, 0, 0, 0 },
/* U+daa5 */ { 0, 0, 0, 0, 0 },
/* U+daa6 */ { 0, 0, 0, 0, 0 },
/* U+daa7 */ { 0, 0, 0, 0, 0 },
/* U+daa8 */ { 0, 0, 0, 0, 0 },
/* U+daa9 */ { 0, 0, 0, 0, 0 },
/* U+daaa */ { 0, 0, 0, 0, 0 },
/* U+daab */ { 0, 0, 0, 0, 0 },
/* U+daac */ { 0, 0, 0, 0, 0 },
/* U+daad */ { 0, 0, 0, 0, 0 },
/* U+daae */ { 0, 0, 0, 0, 0 },
/* U+daaf */ { 0, 0, 0, 0, 0 },
/* U+dab0 */ { 0, 0, 0, 0, 0 },
/* U+dab1 */ { 0, 0, 0, 0, 0 },
/* U+dab2 */ { 0, 0, 0, 0, 0 },
/* U+dab3 */ { 0, 0, 0, 0, 0 },
/* U+dab4 */ { 0, 0, 0, 0, 0 },
/* U+dab5 */ { 0, 0, 0, 0, 0 },
/* U+dab6 */ { 0, 0, 0, 0, 0 },
/* U+dab7 */ { 0, 0, 0, 0, 0 },
/* U+dab8 */ { 0, 0, 0, 0, 0 },
/* U+dab9 */ { 0, 0, 0, 0, 0 },
/* U+daba */ { 0, 0, 0, 0, 0 },
/* U+dabb */ { 0, 0, 0, 0, 0 },
/* U+dabc */ { 0, 0, 0, 0, 0 },
/* U+dabd */ { 0, 0, 0, 0, 0 },
/* U+dabe */ { 0, 0, 0, 0, 0 },
/* U+dabf */ { 0, 0, 0, 0, 0 },
/* U+dac0 */ { 0, 0, 0, 0, 0 },
/* U+dac1 */ { 0, 0, 0, 0, 0 },
/* U+dac2 */ { 0, 0, 0, 0, 0 },
/* U+dac3 */ { 0, 0, 0, 0, 0 },
/* U+dac4 */ { 0, 0, 0, 0, 0 },
/* U+dac5 */ { 0, 0, 0, 0, 0 },
/* U+dac6 */ { 0, 0, 0, 0, 0 },
/* U+dac7 */ { 0, 0, 0, 0, 0 },
/* U+dac8 */ { 0, 0, 0, 0, 0 },
/* U+dac9 */ { 0, 0, 0, 0, 0 },
/* U+daca */ { 0, 0, 0, 0, 0 },
/* U+dacb */ { 0, 0, 0, 0, 0 },
/* U+dacc */ { 0, 0, 0, 0, 0 },
/* U+dacd */ { 0, 0, 0, 0, 0 },
/* U+dace */ { 0, 0, 0, 0, 0 },
/* U+dacf */ { 0, 0, 0, 0, 0 },
/* U+dad0 */ { 0, 0, 0, 0, 0 },
/* U+dad1 */ { 0, 0, 0, 0, 0 },
/* U+dad2 */ { 0, 0, 0, 0, 0 },
/* U+dad3 */ { 0, 0, 0, 0, 0 },
/* U+dad4 */ { 0, 0, 0, 0, 0 },
/* U+dad5 */ { 0, 0, 0, 0, 0 },
/* U+dad6 */ { 0, 0, 0, 0, 0 },
/* U+dad7 */ { 0, 0, 0, 0, 0 },
/* U+dad8 */ { 0, 0, 0, 0, 0 },
/* U+dad9 */ { 0, 0, 0, 0, 0 },
/* U+dada */ { 0, 0, 0, 0, 0 },
/* U+dadb */ { 0, 0, 0, 0, 0 },
/* U+dadc */ { 0, 0, 0, 0, 0 },
/* U+dadd */ { 0, 0, 0, 0, 0 },
/* U+dade */ { 0, 0, 0, 0, 0 },
/* U+dadf */ { 0, 0, 0, 0, 0 },
/* U+dae0 */ { 0, 0, 0, 0, 0 },
/* U+dae1 */ { 0, 0, 0, 0, 0 },
/* U+dae2 */ { 0, 0, 0, 0, 0 },
/* U+dae3 */ { 0, 0, 0, 0, 0 },
/* U+dae4 */ { 0, 0, 0, 0, 0 },
/* U+dae5 */ { 0, 0, 0, 0, 0 },
/* U+dae6 */ { 0, 0, 0, 0, 0 },
/* U+dae7 */ { 0, 0, 0, 0, 0 },
/* U+dae8 */ { 0, 0, 0, 0, 0 },
/* U+dae9 */ { 0, 0, 0, 0, 0 },
/* U+daea */ { 0, 0, 0, 0, 0 },
/* U+daeb */ { 0, 0, 0, 0, 0 },
/* U+daec */ { 0, 0, 0, 0, 0 },
/* U+daed */ { 0, 0, 0, 0, 0 },
/* U+daee */ { 0, 0, 0, 0, 0 },
/* U+daef */ { 0, 0, 0, 0, 0 },
/* U+daf0 */ { 0, 0, 0, 0, 0 },
/* U+daf1 */ { 0, 0, 0, 0, 0 },
/* U+daf2 */ { 0, 0, 0, 0, 0 },
/* U+daf3 */ { 0, 0, 0, 0, 0 },
/* U+daf4 */ { 0, 0, 0, 0, 0 },
/* U+daf5 */ { 0, 0, 0, 0, 0 },
/* U+daf6 */ { 0, 0, 0, 0, 0 },
/* U+daf7 */ { 0, 0, 0, 0, 0 },
/* U+daf8 */ { 0, 0, 0, 0, 0 },
/* U+daf9 */ { 0, 0, 0, 0, 0 },
/* U+dafa */ { 0, 0, 0, 0, 0 },
/* U+dafb */ { 0, 0, 0, 0, 0 },
/* U+dafc */ { 0, 0, 0, 0, 0 },
/* U+dafd */ { 0, 0, 0, 0, 0 },
/* U+dafe */ { 0, 0, 0, 0, 0 },
/* U+daff */ { 0, 0, 0, 0, 0 },
/* U+db00 */ { 0, 0, 0, 0, 0 },
/* U+db01 */ { 0, 0, 0, 0, 0 },
/* U+db02 */ { 0, 0, 0, 0, 0 },
/* U+db03 */ { 0, 0, 0, 0, 0 },
/* U+db04 */ { 0, 0, 0, 0, 0 },
/* U+db05 */ { 0, 0, 0, 0, 0 },
/* U+db06 */ { 0, 0, 0, 0, 0 },
/* U+db07 */ { 0, 0, 0, 0, 0 },
/* U+db08 */ { 0, 0, 0, 0, 0 },
/* U+db09 */ { 0, 0, 0, 0, 0 },
/* U+db0a */ { 0, 0, 0, 0, 0 },
/* U+db0b */ { 0, 0, 0, 0, 0 },
/* U+db0c */ { 0, 0, 0, 0, 0 },
/* U+db0d */ { 0, 0, 0, 0, 0 },
/* U+db0e */ { 0, 0, 0, 0, 0 },
/* U+db0f */ { 0, 0, 0, 0, 0 },
/* U+db10 */ { 0, 0, 0, 0, 0 },
/* U+db11 */ { 0, 0, 0, 0, 0 },
/* U+db12 */ { 0, 0, 0, 0, 0 },
/* U+db13 */ { 0, 0, 0, 0, 0 },
/* U+db14 */ { 0, 0, 0, 0, 0 },
/* U+db15 */ { 0, 0, 0, 0, 0 },
/* U+db16 */ { 0, 0, 0, 0, 0 },
/* U+db17 */ { 0, 0, 0, 0, 0 },
/* U+db18 */ { 0, 0, 0, 0, 0 },
/* U+db19 */ { 0, 0, 0, 0, 0 },
/* U+db1a */ { 0, 0, 0, 0, 0 },
/* U+db1b */ { 0, 0, 0, 0, 0 },
/* U+db1c */ { 0, 0, 0, 0, 0 },
/* U+db1d */ { 0, 0, 0, 0, 0 },
/* U+db1e */ { 0, 0, 0, 0, 0 },
/* U+db1f */ { 0, 0, 0, 0, 0 },
/* U+db20 */ { 0, 0, 0, 0, 0 },
/* U+db21 */ { 0, 0, 0, 0, 0 },
/* U+db22 */ { 0, 0, 0, 0, 0 },
/* U+db23 */ { 0, 0, 0, 0, 0 },
/* U+db24 */ { 0, 0, 0, 0, 0 },
/* U+db25 */ { 0, 0, 0, 0, 0 },
/* U+db26 */ { 0, 0, 0, 0, 0 },
/* U+db27 */ { 0, 0, 0, 0, 0 },
/* U+db28 */ { 0, 0, 0, 0, 0 },
/* U+db29 */ { 0, 0, 0, 0, 0 },
/* U+db2a */ { 0, 0, 0, 0, 0 },
/* U+db2b */ { 0, 0, 0, 0, 0 },
/* U+db2c */ { 0, 0, 0, 0, 0 },
/* U+db2d */ { 0, 0, 0, 0, 0 },
/* U+db2e */ { 0, 0, 0, 0, 0 },
/* U+db2f */ { 0, 0, 0, 0, 0 },
/* U+db30 */ { 0, 0, 0, 0, 0 },
/* U+db31 */ { 0, 0, 0, 0, 0 },
/* U+db32 */ { 0, 0, 0, 0, 0 },
/* U+db33 */ { 0, 0, 0, 0, 0 },
/* U+db34 */ { 0, 0, 0, 0, 0 },
/* U+db35 */ { 0, 0, 0, 0, 0 },
/* U+db36 */ { 0, 0, 0, 0, 0 },
/* U+db37 */ { 0, 0, 0, 0, 0 },
/* U+db38 */ { 0, 0, 0, 0, 0 },
/* U+db39 */ { 0, 0, 0, 0, 0 },
/* U+db3a */ { 0, 0, 0, 0, 0 },
/* U+db3b */ { 0, 0, 0, 0, 0 },
/* U+db3c */ { 0, 0, 0, 0, 0 },
/* U+db3d */ { 0, 0, 0, 0, 0 },
/* U+db3e */ { 0, 0, 0, 0, 0 },
/* U+db3f */ { 0, 0, 0, 0, 0 },
/* U+db40 */ { 0, 0, 0, 0, 0 },
/* U+db41 */ { 0, 0, 0, 0, 0 },
/* U+db42 */ { 0, 0, 0, 0, 0 },
/* U+db43 */ { 0, 0, 0, 0, 0 },
/* U+db44 */ { 0, 0, 0, 0, 0 },
/* U+db45 */ { 0, 0, 0, 0, 0 },
/* U+db46 */ { 0, 0, 0, 0, 0 },
/* U+db47 */ { 0, 0, 0, 0, 0 },
/* U+db48 */ { 0, 0, 0, 0, 0 },
/* U+db49 */ { 0, 0, 0, 0, 0 },
/* U+db4a */ { 0, 0, 0, 0, 0 },
/* U+db4b */ { 0, 0, 0, 0, 0 },
/* U+db4c */ { 0, 0, 0, 0, 0 },
/* U+db4d */ { 0, 0, 0, 0, 0 },
/* U+db4e */ { 0, 0, 0, 0, 0 },
/* U+db4f */ { 0, 0, 0, 0, 0 },
/* U+db50 */ { 0, 0, 0, 0, 0 },
/* U+db51 */ { 0, 0, 0, 0, 0 },
/* U+db52 */ { 0, 0, 0, 0, 0 },
/* U+db53 */ { 0, 0, 0, 0, 0 },
/* U+db54 */ { 0, 0, 0, 0, 0 },
/* U+db55 */ { 0, 0, 0, 0, 0 },
/* U+db56 */ { 0, 0, 0, 0, 0 },
/* U+db57 */ { 0, 0, 0, 0, 0 },
/* U+db58 */ { 0, 0, 0, 0, 0 },
/* U+db59 */ { 0, 0, 0, 0, 0 },
/* U+db5a */ { 0, 0, 0, 0, 0 },
/* U+db5b */ { 0, 0, 0, 0, 0 },
/* U+db5c */ { 0, 0, 0, 0, 0 },
/* U+db5d */ { 0, 0, 0, 0, 0 },
/* U+db5e */ { 0, 0, 0, 0, 0 },
/* U+db5f */ { 0, 0, 0, 0, 0 },
/* U+db60 */ { 0, 0, 0, 0, 0 },
/* U+db61 */ { 0, 0, 0, 0, 0 },
/* U+db62 */ { 0, 0, 0, 0, 0 },
/* U+db63 */ { 0, 0, 0, 0, 0 },
/* U+db64 */ { 0, 0, 0, 0, 0 },
/* U+db65 */ { 0, 0, 0, 0, 0 },
/* U+db66 */ { 0, 0, 0, 0, 0 },
/* U+db67 */ { 0, 0, 0, 0, 0 },
/* U+db68 */ { 0, 0, 0, 0, 0 },
/* U+db69 */ { 0, 0, 0, 0, 0 },
/* U+db6a */ { 0, 0, 0, 0, 0 },
/* U+db6b */ { 0, 0, 0, 0, 0 },
/* U+db6c */ { 0, 0, 0, 0, 0 },
/* U+db6d */ { 0, 0, 0, 0, 0 },
/* U+db6e */ { 0, 0, 0, 0, 0 },
/* U+db6f */ { 0, 0, 0, 0, 0 },
/* U+db70 */ { 0, 0, 0, 0, 0 },
/* U+db71 */ { 0, 0, 0, 0, 0 },
/* U+db72 */ { 0, 0, 0, 0, 0 },
/* U+db73 */ { 0, 0, 0, 0, 0 },
/* U+db74 */ { 0, 0, 0, 0, 0 },
/* U+db75 */ { 0, 0, 0, 0, 0 },
/* U+db76 */ { 0, 0, 0, 0, 0 },
/* U+db77 */ { 0, 0, 0, 0, 0 },
/* U+db78 */ { 0, 0, 0, 0, 0 },
/* U+db79 */ { 0, 0, 0, 0, 0 },
/* U+db7a */ { 0, 0, 0, 0, 0 },
/* U+db7b */ { 0, 0, 0, 0, 0 },
/* U+db7c */ { 0, 0, 0, 0, 0 },
/* U+db7d */ { 0, 0, 0, 0, 0 },
/* U+db7e */ { 0, 0, 0, 0, 0 },
/* U+db7f */ { 15, 0, 1, 0, 0 },
/* U+db80 */ { 15, 0, 1, 0, 0 },
/* U+db81 */ { 0, 0, 0, 0, 0 },
/* U+db82 */ { 0, 0, 0, 0, 0 },
/* U+db83 */ { 0, 0, 0, 0, 0 },
/* U+db84 */ { 0, 0, 0, 0, 0 },
/* U+db85 */ { 0, 0, 0, 0, 0 },
/* U+db86 */ { 0, 0, 0, 0, 0 },
/* U+db87 */ { 0, 0, 0, 0, 0 },
/* U+db88 */ { 0, 0, 0, 0, 0 },
/* U+db89 */ { 0, 0, 0, 0, 0 },
/* U+db8a */ { 0, 0, 0, 0, 0 },
/* U+db8b */ { 0, 0, 0, 0, 0 },
/* U+db8c */ { 0, 0, 0, 0, 0 },
/* U+db8d */ { 0, 0, 0, 0, 0 },
/* U+db8e */ { 0, 0, 0, 0, 0 },
/* U+db8f */ { 0, 0, 0, 0, 0 },
/* U+db90 */ { 0, 0, 0, 0, 0 },
/* U+db91 */ { 0, 0, 0, 0, 0 },
/* U+db92 */ { 0, 0, 0, 0, 0 },
/* U+db93 */ { 0, 0, 0, 0, 0 },
/* U+db94 */ { 0, 0, 0, 0, 0 },
/* U+db95 */ { 0, 0, 0, 0, 0 },
/* U+db96 */ { 0, 0, 0, 0, 0 },
/* U+db97 */ { 0, 0, 0, 0, 0 },
/* U+db98 */ { 0, 0, 0, 0, 0 },
/* U+db99 */ { 0, 0, 0, 0, 0 },
/* U+db9a */ { 0, 0, 0, 0, 0 },
/* U+db9b */ { 0, 0, 0, 0, 0 },
/* U+db9c */ { 0, 0, 0, 0, 0 },
/* U+db9d */ { 0, 0, 0, 0, 0 },
/* U+db9e */ { 0, 0, 0, 0, 0 },
/* U+db9f */ { 0, 0, 0, 0, 0 },
/* U+dba0 */ { 0, 0, 0, 0, 0 },
/* U+dba1 */ { 0, 0, 0, 0, 0 },
/* U+dba2 */ { 0, 0, 0, 0, 0 },
/* U+dba3 */ { 0, 0, 0, 0, 0 },
/* U+dba4 */ { 0, 0, 0, 0, 0 },
/* U+dba5 */ { 0, 0, 0, 0, 0 },
/* U+dba6 */ { 0, 0, 0, 0, 0 },
/* U+dba7 */ { 0, 0, 0, 0, 0 },
/* U+dba8 */ { 0, 0, 0, 0, 0 },
/* U+dba9 */ { 0, 0, 0, 0, 0 },
/* U+dbaa */ { 0, 0, 0, 0, 0 },
/* U+dbab */ { 0, 0, 0, 0, 0 },
/* U+dbac */ { 0, 0, 0, 0, 0 },
/* U+dbad */ { 0, 0, 0, 0, 0 },
/* U+dbae */ { 0, 0, 0, 0, 0 },
/* U+dbaf */ { 0, 0, 0, 0, 0 },
/* U+dbb0 */ { 0, 0, 0, 0, 0 },
/* U+dbb1 */ { 0, 0, 0, 0, 0 },
/* U+dbb2 */ { 0, 0, 0, 0, 0 },
/* U+dbb3 */ { 0, 0, 0, 0, 0 },
/* U+dbb4 */ { 0, 0, 0, 0, 0 },
/* U+dbb5 */ { 0, 0, 0, 0, 0 },
/* U+dbb6 */ { 0, 0, 0, 0, 0 },
/* U+dbb7 */ { 0, 0, 0, 0, 0 },
/* U+dbb8 */ { 0, 0, 0, 0, 0 },
/* U+dbb9 */ { 0, 0, 0, 0, 0 },
/* U+dbba */ { 0, 0, 0, 0, 0 },
/* U+dbbb */ { 0, 0, 0, 0, 0 },
/* U+dbbc */ { 0, 0, 0, 0, 0 },
/* U+dbbd */ { 0, 0, 0, 0, 0 },
/* U+dbbe */ { 0, 0, 0, 0, 0 },
/* U+dbbf */ { 0, 0, 0, 0, 0 },
/* U+dbc0 */ { 0, 0, 0, 0, 0 },
/* U+dbc1 */ { 0, 0, 0, 0, 0 },
/* U+dbc2 */ { 0, 0, 0, 0, 0 },
/* U+dbc3 */ { 0, 0, 0, 0, 0 },
/* U+dbc4 */ { 0, 0, 0, 0, 0 },
/* U+dbc5 */ { 0, 0, 0, 0, 0 },
/* U+dbc6 */ { 0, 0, 0, 0, 0 },
/* U+dbc7 */ { 0, 0, 0, 0, 0 },
/* U+dbc8 */ { 0, 0, 0, 0, 0 },
/* U+dbc9 */ { 0, 0, 0, 0, 0 },
/* U+dbca */ { 0, 0, 0, 0, 0 },
/* U+dbcb */ { 0, 0, 0, 0, 0 },
/* U+dbcc */ { 0, 0, 0, 0, 0 },
/* U+dbcd */ { 0, 0, 0, 0, 0 },
/* U+dbce */ { 0, 0, 0, 0, 0 },
/* U+dbcf */ { 0, 0, 0, 0, 0 },
/* U+dbd0 */ { 0, 0, 0, 0, 0 },
/* U+dbd1 */ { 0, 0, 0, 0, 0 },
/* U+dbd2 */ { 0, 0, 0, 0, 0 },
/* U+dbd3 */ { 0, 0, 0, 0, 0 },
/* U+dbd4 */ { 0, 0, 0, 0, 0 },
/* U+dbd5 */ { 0, 0, 0, 0, 0 },
/* U+dbd6 */ { 0, 0, 0, 0, 0 },
/* U+dbd7 */ { 0, 0, 0, 0, 0 },
/* U+dbd8 */ { 0, 0, 0, 0, 0 },
/* U+dbd9 */ { 0, 0, 0, 0, 0 },
/* U+dbda */ { 0, 0, 0, 0, 0 },
/* U+dbdb */ { 0, 0, 0, 0, 0 },
/* U+dbdc */ { 0, 0, 0, 0, 0 },
/* U+dbdd */ { 0, 0, 0, 0, 0 },
/* U+dbde */ { 0, 0, 0, 0, 0 },
/* U+dbdf */ { 0, 0, 0, 0, 0 },
/* U+dbe0 */ { 0, 0, 0, 0, 0 },
/* U+dbe1 */ { 0, 0, 0, 0, 0 },
/* U+dbe2 */ { 0, 0, 0, 0, 0 },
/* U+dbe3 */ { 0, 0, 0, 0, 0 },
/* U+dbe4 */ { 0, 0, 0, 0, 0 },
/* U+dbe5 */ { 0, 0, 0, 0, 0 },
/* U+dbe6 */ { 0, 0, 0, 0, 0 },
/* U+dbe7 */ { 0, 0, 0, 0, 0 },
/* U+dbe8 */ { 0, 0, 0, 0, 0 },
/* U+dbe9 */ { 0, 0, 0, 0, 0 },
/* U+dbea */ { 0, 0, 0, 0, 0 },
/* U+dbeb */ { 0, 0, 0, 0, 0 },
/* U+dbec */ { 0, 0, 0, 0, 0 },
/* U+dbed */ { 0, 0, 0, 0, 0 },
/* U+dbee */ { 0, 0, 0, 0, 0 },
/* U+dbef */ { 0, 0, 0, 0, 0 },
/* U+dbf0 */ { 0, 0, 0, 0, 0 },
/* U+dbf1 */ { 0, 0, 0, 0, 0 },
/* U+dbf2 */ { 0, 0, 0, 0, 0 },
/* U+dbf3 */ { 0, 0, 0, 0, 0 },
/* U+dbf4 */ { 0, 0, 0, 0, 0 },
/* U+dbf5 */ { 0, 0, 0, 0, 0 },
/* U+dbf6 */ { 0, 0, 0, 0, 0 },
/* U+dbf7 */ { 0, 0, 0, 0, 0 },
/* U+dbf8 */ { 0, 0, 0, 0, 0 },
/* U+dbf9 */ { 0, 0, 0, 0, 0 },
/* U+dbfa */ { 0, 0, 0, 0, 0 },
/* U+dbfb */ { 0, 0, 0, 0, 0 },
/* U+dbfc */ { 0, 0, 0, 0, 0 },
/* U+dbfd */ { 0, 0, 0, 0, 0 },
/* U+dbfe */ { 0, 0, 0, 0, 0 },
/* U+dbff */ { 15, 0, 1, 0, 0 },
/* U+dc00 */ { 15, 0, 1, 0, 0 },
/* U+dc01 */ { 0, 0, 0, 0, 0 },
/* U+dc02 */ { 0, 0, 0, 0, 0 },
/* U+dc03 */ { 0, 0, 0, 0, 0 },
/* U+dc04 */ { 0, 0, 0, 0, 0 },
/* U+dc05 */ { 0, 0, 0, 0, 0 },
/* U+dc06 */ { 0, 0, 0, 0, 0 },
/* U+dc07 */ { 0, 0, 0, 0, 0 },
/* U+dc08 */ { 0, 0, 0, 0, 0 },
/* U+dc09 */ { 0, 0, 0, 0, 0 },
/* U+dc0a */ { 0, 0, 0, 0, 0 },
/* U+dc0b */ { 0, 0, 0, 0, 0 },
/* U+dc0c */ { 0, 0, 0, 0, 0 },
/* U+dc0d */ { 0, 0, 0, 0, 0 },
/* U+dc0e */ { 0, 0, 0, 0, 0 },
/* U+dc0f */ { 0, 0, 0, 0, 0 },
/* U+dc10 */ { 0, 0, 0, 0, 0 },
/* U+dc11 */ { 0, 0, 0, 0, 0 },
/* U+dc12 */ { 0, 0, 0, 0, 0 },
/* U+dc13 */ { 0, 0, 0, 0, 0 },
/* U+dc14 */ { 0, 0, 0, 0, 0 },
/* U+dc15 */ { 0, 0, 0, 0, 0 },
/* U+dc16 */ { 0, 0, 0, 0, 0 },
/* U+dc17 */ { 0, 0, 0, 0, 0 },
/* U+dc18 */ { 0, 0, 0, 0, 0 },
/* U+dc19 */ { 0, 0, 0, 0, 0 },
/* U+dc1a */ { 0, 0, 0, 0, 0 },
/* U+dc1b */ { 0, 0, 0, 0, 0 },
/* U+dc1c */ { 0, 0, 0, 0, 0 },
/* U+dc1d */ { 0, 0, 0, 0, 0 },
/* U+dc1e */ { 0, 0, 0, 0, 0 },
/* U+dc1f */ { 0, 0, 0, 0, 0 },
/* U+dc20 */ { 0, 0, 0, 0, 0 },
/* U+dc21 */ { 0, 0, 0, 0, 0 },
/* U+dc22 */ { 0, 0, 0, 0, 0 },
/* U+dc23 */ { 0, 0, 0, 0, 0 },
/* U+dc24 */ { 0, 0, 0, 0, 0 },
/* U+dc25 */ { 0, 0, 0, 0, 0 },
/* U+dc26 */ { 0, 0, 0, 0, 0 },
/* U+dc27 */ { 0, 0, 0, 0, 0 },
/* U+dc28 */ { 0, 0, 0, 0, 0 },
/* U+dc29 */ { 0, 0, 0, 0, 0 },
/* U+dc2a */ { 0, 0, 0, 0, 0 },
/* U+dc2b */ { 0, 0, 0, 0, 0 },
/* U+dc2c */ { 0, 0, 0, 0, 0 },
/* U+dc2d */ { 0, 0, 0, 0, 0 },
/* U+dc2e */ { 0, 0, 0, 0, 0 },
/* U+dc2f */ { 0, 0, 0, 0, 0 },
/* U+dc30 */ { 0, 0, 0, 0, 0 },
/* U+dc31 */ { 0, 0, 0, 0, 0 },
/* U+dc32 */ { 0, 0, 0, 0, 0 },
/* U+dc33 */ { 0, 0, 0, 0, 0 },
/* U+dc34 */ { 0, 0, 0, 0, 0 },
/* U+dc35 */ { 0, 0, 0, 0, 0 },
/* U+dc36 */ { 0, 0, 0, 0, 0 },
/* U+dc37 */ { 0, 0, 0, 0, 0 },
/* U+dc38 */ { 0, 0, 0, 0, 0 },
/* U+dc39 */ { 0, 0, 0, 0, 0 },
/* U+dc3a */ { 0, 0, 0, 0, 0 },
/* U+dc3b */ { 0, 0, 0, 0, 0 },
/* U+dc3c */ { 0, 0, 0, 0, 0 },
/* U+dc3d */ { 0, 0, 0, 0, 0 },
/* U+dc3e */ { 0, 0, 0, 0, 0 },
/* U+dc3f */ { 0, 0, 0, 0, 0 },
/* U+dc40 */ { 0, 0, 0, 0, 0 },
/* U+dc41 */ { 0, 0, 0, 0, 0 },
/* U+dc42 */ { 0, 0, 0, 0, 0 },
/* U+dc43 */ { 0, 0, 0, 0, 0 },
/* U+dc44 */ { 0, 0, 0, 0, 0 },
/* U+dc45 */ { 0, 0, 0, 0, 0 },
/* U+dc46 */ { 0, 0, 0, 0, 0 },
/* U+dc47 */ { 0, 0, 0, 0, 0 },
/* U+dc48 */ { 0, 0, 0, 0, 0 },
/* U+dc49 */ { 0, 0, 0, 0, 0 },
/* U+dc4a */ { 0, 0, 0, 0, 0 },
/* U+dc4b */ { 0, 0, 0, 0, 0 },
/* U+dc4c */ { 0, 0, 0, 0, 0 },
/* U+dc4d */ { 0, 0, 0, 0, 0 },
/* U+dc4e */ { 0, 0, 0, 0, 0 },
/* U+dc4f */ { 0, 0, 0, 0, 0 },
/* U+dc50 */ { 0, 0, 0, 0, 0 },
/* U+dc51 */ { 0, 0, 0, 0, 0 },
/* U+dc52 */ { 0, 0, 0, 0, 0 },
/* U+dc53 */ { 0, 0, 0, 0, 0 },
/* U+dc54 */ { 0, 0, 0, 0, 0 },
/* U+dc55 */ { 0, 0, 0, 0, 0 },
/* U+dc56 */ { 0, 0, 0, 0, 0 },
/* U+dc57 */ { 0, 0, 0, 0, 0 },
/* U+dc58 */ { 0, 0, 0, 0, 0 },
/* U+dc59 */ { 0, 0, 0, 0, 0 },
/* U+dc5a */ { 0, 0, 0, 0, 0 },
/* U+dc5b */ { 0, 0, 0, 0, 0 },
/* U+dc5c */ { 0, 0, 0, 0, 0 },
/* U+dc5d */ { 0, 0, 0, 0, 0 },
/* U+dc5e */ { 0, 0, 0, 0, 0 },
/* U+dc5f */ { 0, 0, 0, 0, 0 },
/* U+dc60 */ { 0, 0, 0, 0, 0 },
/* U+dc61 */ { 0, 0, 0, 0, 0 },
/* U+dc62 */ { 0, 0, 0, 0, 0 },
/* U+dc63 */ { 0, 0, 0, 0, 0 },
/* U+dc64 */ { 0, 0, 0, 0, 0 },
/* U+dc65 */ { 0, 0, 0, 0, 0 },
/* U+dc66 */ { 0, 0, 0, 0, 0 },
/* U+dc67 */ { 0, 0, 0, 0, 0 },
/* U+dc68 */ { 0, 0, 0, 0, 0 },
/* U+dc69 */ { 0, 0, 0, 0, 0 },
/* U+dc6a */ { 0, 0, 0, 0, 0 },
/* U+dc6b */ { 0, 0, 0, 0, 0 },
/* U+dc6c */ { 0, 0, 0, 0, 0 },
/* U+dc6d */ { 0, 0, 0, 0, 0 },
/* U+dc6e */ { 0, 0, 0, 0, 0 },
/* U+dc6f */ { 0, 0, 0, 0, 0 },
/* U+dc70 */ { 0, 0, 0, 0, 0 },
/* U+dc71 */ { 0, 0, 0, 0, 0 },
/* U+dc72 */ { 0, 0, 0, 0, 0 },
/* U+dc73 */ { 0, 0, 0, 0, 0 },
/* U+dc74 */ { 0, 0, 0, 0, 0 },
/* U+dc75 */ { 0, 0, 0, 0, 0 },
/* U+dc76 */ { 0, 0, 0, 0, 0 },
/* U+dc77 */ { 0, 0, 0, 0, 0 },
/* U+dc78 */ { 0, 0, 0, 0, 0 },
/* U+dc79 */ { 0, 0, 0, 0, 0 },
/* U+dc7a */ { 0, 0, 0, 0, 0 },
/* U+dc7b */ { 0, 0, 0, 0, 0 },
/* U+dc7c */ { 0, 0, 0, 0, 0 },
/* U+dc7d */ { 0, 0, 0, 0, 0 },
/* U+dc7e */ { 0, 0, 0, 0, 0 },
/* U+dc7f */ { 0, 0, 0, 0, 0 },
/* U+dc80 */ { 0, 0, 0, 0, 0 },
/* U+dc81 */ { 0, 0, 0, 0, 0 },
/* U+dc82 */ { 0, 0, 0, 0, 0 },
/* U+dc83 */ { 0, 0, 0, 0, 0 },
/* U+dc84 */ { 0, 0, 0, 0, 0 },
/* U+dc85 */ { 0, 0, 0, 0, 0 },
/* U+dc86 */ { 0, 0, 0, 0, 0 },
/* U+dc87 */ { 0, 0, 0, 0, 0 },
/* U+dc88 */ { 0, 0, 0, 0, 0 },
/* U+dc89 */ { 0, 0, 0, 0, 0 },
/* U+dc8a */ { 0, 0, 0, 0, 0 },
/* U+dc8b */ { 0, 0, 0, 0, 0 },
/* U+dc8c */ { 0, 0, 0, 0, 0 },
/* U+dc8d */ { 0, 0, 0, 0, 0 },
/* U+dc8e */ { 0, 0, 0, 0, 0 },
/* U+dc8f */ { 0, 0, 0, 0, 0 },
/* U+dc90 */ { 0, 0, 0, 0, 0 },
/* U+dc91 */ { 0, 0, 0, 0, 0 },
/* U+dc92 */ { 0, 0, 0, 0, 0 },
/* U+dc93 */ { 0, 0, 0, 0, 0 },
/* U+dc94 */ { 0, 0, 0, 0, 0 },
/* U+dc95 */ { 0, 0, 0, 0, 0 },
/* U+dc96 */ { 0, 0, 0, 0, 0 },
/* U+dc97 */ { 0, 0, 0, 0, 0 },
/* U+dc98 */ { 0, 0, 0, 0, 0 },
/* U+dc99 */ { 0, 0, 0, 0, 0 },
/* U+dc9a */ { 0, 0, 0, 0, 0 },
/* U+dc9b */ { 0, 0, 0, 0, 0 },
/* U+dc9c */ { 0, 0, 0, 0, 0 },
/* U+dc9d */ { 0, 0, 0, 0, 0 },
/* U+dc9e */ { 0, 0, 0, 0, 0 },
/* U+dc9f */ { 0, 0, 0, 0, 0 },
/* U+dca0 */ { 0, 0, 0, 0, 0 },
/* U+dca1 */ { 0, 0, 0, 0, 0 },
/* U+dca2 */ { 0, 0, 0, 0, 0 },
/* U+dca3 */ { 0, 0, 0, 0, 0 },
/* U+dca4 */ { 0, 0, 0, 0, 0 },
/* U+dca5 */ { 0, 0, 0, 0, 0 },
/* U+dca6 */ { 0, 0, 0, 0, 0 },
/* U+dca7 */ { 0, 0, 0, 0, 0 },
/* U+dca8 */ { 0, 0, 0, 0, 0 },
/* U+dca9 */ { 0, 0, 0, 0, 0 },
/* U+dcaa */ { 0, 0, 0, 0, 0 },
/* U+dcab */ { 0, 0, 0, 0, 0 },
/* U+dcac */ { 0, 0, 0, 0, 0 },
/* U+dcad */ { 0, 0, 0, 0, 0 },
/* U+dcae */ { 0, 0, 0, 0, 0 },
/* U+dcaf */ { 0, 0, 0, 0, 0 },
/* U+dcb0 */ { 0, 0, 0, 0, 0 },
/* U+dcb1 */ { 0, 0, 0, 0, 0 },
/* U+dcb2 */ { 0, 0, 0, 0, 0 },
/* U+dcb3 */ { 0, 0, 0, 0, 0 },
/* U+dcb4 */ { 0, 0, 0, 0, 0 },
/* U+dcb5 */ { 0, 0, 0, 0, 0 },
/* U+dcb6 */ { 0, 0, 0, 0, 0 },
/* U+dcb7 */ { 0, 0, 0, 0, 0 },
/* U+dcb8 */ { 0, 0, 0, 0, 0 },
/* U+dcb9 */ { 0, 0, 0, 0, 0 },
/* U+dcba */ { 0, 0, 0, 0, 0 },
/* U+dcbb */ { 0, 0, 0, 0, 0 },
/* U+dcbc */ { 0, 0, 0, 0, 0 },
/* U+dcbd */ { 0, 0, 0, 0, 0 },
/* U+dcbe */ { 0, 0, 0, 0, 0 },
/* U+dcbf */ { 0, 0, 0, 0, 0 },
/* U+dcc0 */ { 0, 0, 0, 0, 0 },
/* U+dcc1 */ { 0, 0, 0, 0, 0 },
/* U+dcc2 */ { 0, 0, 0, 0, 0 },
/* U+dcc3 */ { 0, 0, 0, 0, 0 },
/* U+dcc4 */ { 0, 0, 0, 0, 0 },
/* U+dcc5 */ { 0, 0, 0, 0, 0 },
/* U+dcc6 */ { 0, 0, 0, 0, 0 },
/* U+dcc7 */ { 0, 0, 0, 0, 0 },
/* U+dcc8 */ { 0, 0, 0, 0, 0 },
/* U+dcc9 */ { 0, 0, 0, 0, 0 },
/* U+dcca */ { 0, 0, 0, 0, 0 },
/* U+dccb */ { 0, 0, 0, 0, 0 },
/* U+dccc */ { 0, 0, 0, 0, 0 },
/* U+dccd */ { 0, 0, 0, 0, 0 },
/* U+dcce */ { 0, 0, 0, 0, 0 },
/* U+dccf */ { 0, 0, 0, 0, 0 },
/* U+dcd0 */ { 0, 0, 0, 0, 0 },
/* U+dcd1 */ { 0, 0, 0, 0, 0 },
/* U+dcd2 */ { 0, 0, 0, 0, 0 },
/* U+dcd3 */ { 0, 0, 0, 0, 0 },
/* U+dcd4 */ { 0, 0, 0, 0, 0 },
/* U+dcd5 */ { 0, 0, 0, 0, 0 },
/* U+dcd6 */ { 0, 0, 0, 0, 0 },
/* U+dcd7 */ { 0, 0, 0, 0, 0 },
/* U+dcd8 */ { 0, 0, 0, 0, 0 },
/* U+dcd9 */ { 0, 0, 0, 0, 0 },
/* U+dcda */ { 0, 0, 0, 0, 0 },
/* U+dcdb */ { 0, 0, 0, 0, 0 },
/* U+dcdc */ { 0, 0, 0, 0, 0 },
/* U+dcdd */ { 0, 0, 0, 0, 0 },
/* U+dcde */ { 0, 0, 0, 0, 0 },
/* U+dcdf */ { 0, 0, 0, 0, 0 },
/* U+dce0 */ { 0, 0, 0, 0, 0 },
/* U+dce1 */ { 0, 0, 0, 0, 0 },
/* U+dce2 */ { 0, 0, 0, 0, 0 },
/* U+dce3 */ { 0, 0, 0, 0, 0 },
/* U+dce4 */ { 0, 0, 0, 0, 0 },
/* U+dce5 */ { 0, 0, 0, 0, 0 },
/* U+dce6 */ { 0, 0, 0, 0, 0 },
/* U+dce7 */ { 0, 0, 0, 0, 0 },
/* U+dce8 */ { 0, 0, 0, 0, 0 },
/* U+dce9 */ { 0, 0, 0, 0, 0 },
/* U+dcea */ { 0, 0, 0, 0, 0 },
/* U+dceb */ { 0, 0, 0, 0, 0 },
/* U+dcec */ { 0, 0, 0, 0, 0 },
/* U+dced */ { 0, 0, 0, 0, 0 },
/* U+dcee */ { 0, 0, 0, 0, 0 },
/* U+dcef */ { 0, 0, 0, 0, 0 },
/* U+dcf0 */ { 0, 0, 0, 0, 0 },
/* U+dcf1 */ { 0, 0, 0, 0, 0 },
/* U+dcf2 */ { 0, 0, 0, 0, 0 },
/* U+dcf3 */ { 0, 0, 0, 0, 0 },
/* U+dcf4 */ { 0, 0, 0, 0, 0 },
/* U+dcf5 */ { 0, 0, 0, 0, 0 },
/* U+dcf6 */ { 0, 0, 0, 0, 0 },
/* U+dcf7 */ { 0, 0, 0, 0, 0 },
/* U+dcf8 */ { 0, 0, 0, 0, 0 },
/* U+dcf9 */ { 0, 0, 0, 0, 0 },
/* U+dcfa */ { 0, 0, 0, 0, 0 },
/* U+dcfb */ { 0, 0, 0, 0, 0 },
/* U+dcfc */ { 0, 0, 0, 0, 0 },
/* U+dcfd */ { 0, 0, 0, 0, 0 },
/* U+dcfe */ { 0, 0, 0, 0, 0 },
/* U+dcff */ { 0, 0, 0, 0, 0 },
/* U+dd00 */ { 0, 0, 0, 0, 0 },
/* U+dd01 */ { 0, 0, 0, 0, 0 },
/* U+dd02 */ { 0, 0, 0, 0, 0 },
/* U+dd03 */ { 0, 0, 0, 0, 0 },
/* U+dd04 */ { 0, 0, 0, 0, 0 },
/* U+dd05 */ { 0, 0, 0, 0, 0 },
/* U+dd06 */ { 0, 0, 0, 0, 0 },
/* U+dd07 */ { 0, 0, 0, 0, 0 },
/* U+dd08 */ { 0, 0, 0, 0, 0 },
/* U+dd09 */ { 0, 0, 0, 0, 0 },
/* U+dd0a */ { 0, 0, 0, 0, 0 },
/* U+dd0b */ { 0, 0, 0, 0, 0 },
/* U+dd0c */ { 0, 0, 0, 0, 0 },
/* U+dd0d */ { 0, 0, 0, 0, 0 },
/* U+dd0e */ { 0, 0, 0, 0, 0 },
/* U+dd0f */ { 0, 0, 0, 0, 0 },
/* U+dd10 */ { 0, 0, 0, 0, 0 },
/* U+dd11 */ { 0, 0, 0, 0, 0 },
/* U+dd12 */ { 0, 0, 0, 0, 0 },
/* U+dd13 */ { 0, 0, 0, 0, 0 },
/* U+dd14 */ { 0, 0, 0, 0, 0 },
/* U+dd15 */ { 0, 0, 0, 0, 0 },
/* U+dd16 */ { 0, 0, 0, 0, 0 },
/* U+dd17 */ { 0, 0, 0, 0, 0 },
/* U+dd18 */ { 0, 0, 0, 0, 0 },
/* U+dd19 */ { 0, 0, 0, 0, 0 },
/* U+dd1a */ { 0, 0, 0, 0, 0 },
/* U+dd1b */ { 0, 0, 0, 0, 0 },
/* U+dd1c */ { 0, 0, 0, 0, 0 },
/* U+dd1d */ { 0, 0, 0, 0, 0 },
/* U+dd1e */ { 0, 0, 0, 0, 0 },
/* U+dd1f */ { 0, 0, 0, 0, 0 },
/* U+dd20 */ { 0, 0, 0, 0, 0 },
/* U+dd21 */ { 0, 0, 0, 0, 0 },
/* U+dd22 */ { 0, 0, 0, 0, 0 },
/* U+dd23 */ { 0, 0, 0, 0, 0 },
/* U+dd24 */ { 0, 0, 0, 0, 0 },
/* U+dd25 */ { 0, 0, 0, 0, 0 },
/* U+dd26 */ { 0, 0, 0, 0, 0 },
/* U+dd27 */ { 0, 0, 0, 0, 0 },
/* U+dd28 */ { 0, 0, 0, 0, 0 },
/* U+dd29 */ { 0, 0, 0, 0, 0 },
/* U+dd2a */ { 0, 0, 0, 0, 0 },
/* U+dd2b */ { 0, 0, 0, 0, 0 },
/* U+dd2c */ { 0, 0, 0, 0, 0 },
/* U+dd2d */ { 0, 0, 0, 0, 0 },
/* U+dd2e */ { 0, 0, 0, 0, 0 },
/* U+dd2f */ { 0, 0, 0, 0, 0 },
/* U+dd30 */ { 0, 0, 0, 0, 0 },
/* U+dd31 */ { 0, 0, 0, 0, 0 },
/* U+dd32 */ { 0, 0, 0, 0, 0 },
/* U+dd33 */ { 0, 0, 0, 0, 0 },
/* U+dd34 */ { 0, 0, 0, 0, 0 },
/* U+dd35 */ { 0, 0, 0, 0, 0 },
/* U+dd36 */ { 0, 0, 0, 0, 0 },
/* U+dd37 */ { 0, 0, 0, 0, 0 },
/* U+dd38 */ { 0, 0, 0, 0, 0 },
/* U+dd39 */ { 0, 0, 0, 0, 0 },
/* U+dd3a */ { 0, 0, 0, 0, 0 },
/* U+dd3b */ { 0, 0, 0, 0, 0 },
/* U+dd3c */ { 0, 0, 0, 0, 0 },
/* U+dd3d */ { 0, 0, 0, 0, 0 },
/* U+dd3e */ { 0, 0, 0, 0, 0 },
/* U+dd3f */ { 0, 0, 0, 0, 0 },
/* U+dd40 */ { 0, 0, 0, 0, 0 },
/* U+dd41 */ { 0, 0, 0, 0, 0 },
/* U+dd42 */ { 0, 0, 0, 0, 0 },
/* U+dd43 */ { 0, 0, 0, 0, 0 },
/* U+dd44 */ { 0, 0, 0, 0, 0 },
/* U+dd45 */ { 0, 0, 0, 0, 0 },
/* U+dd46 */ { 0, 0, 0, 0, 0 },
/* U+dd47 */ { 0, 0, 0, 0, 0 },
/* U+dd48 */ { 0, 0, 0, 0, 0 },
/* U+dd49 */ { 0, 0, 0, 0, 0 },
/* U+dd4a */ { 0, 0, 0, 0, 0 },
/* U+dd4b */ { 0, 0, 0, 0, 0 },
/* U+dd4c */ { 0, 0, 0, 0, 0 },
/* U+dd4d */ { 0, 0, 0, 0, 0 },
/* U+dd4e */ { 0, 0, 0, 0, 0 },
/* U+dd4f */ { 0, 0, 0, 0, 0 },
/* U+dd50 */ { 0, 0, 0, 0, 0 },
/* U+dd51 */ { 0, 0, 0, 0, 0 },
/* U+dd52 */ { 0, 0, 0, 0, 0 },
/* U+dd53 */ { 0, 0, 0, 0, 0 },
/* U+dd54 */ { 0, 0, 0, 0, 0 },
/* U+dd55 */ { 0, 0, 0, 0, 0 },
/* U+dd56 */ { 0, 0, 0, 0, 0 },
/* U+dd57 */ { 0, 0, 0, 0, 0 },
/* U+dd58 */ { 0, 0, 0, 0, 0 },
/* U+dd59 */ { 0, 0, 0, 0, 0 },
/* U+dd5a */ { 0, 0, 0, 0, 0 },
/* U+dd5b */ { 0, 0, 0, 0, 0 },
/* U+dd5c */ { 0, 0, 0, 0, 0 },
/* U+dd5d */ { 0, 0, 0, 0, 0 },
/* U+dd5e */ { 0, 0, 0, 0, 0 },
/* U+dd5f */ { 0, 0, 0, 0, 0 },
/* U+dd60 */ { 0, 0, 0, 0, 0 },
/* U+dd61 */ { 0, 0, 0, 0, 0 },
/* U+dd62 */ { 0, 0, 0, 0, 0 },
/* U+dd63 */ { 0, 0, 0, 0, 0 },
/* U+dd64 */ { 0, 0, 0, 0, 0 },
/* U+dd65 */ { 0, 0, 0, 0, 0 },
/* U+dd66 */ { 0, 0, 0, 0, 0 },
/* U+dd67 */ { 0, 0, 0, 0, 0 },
/* U+dd68 */ { 0, 0, 0, 0, 0 },
/* U+dd69 */ { 0, 0, 0, 0, 0 },
/* U+dd6a */ { 0, 0, 0, 0, 0 },
/* U+dd6b */ { 0, 0, 0, 0, 0 },
/* U+dd6c */ { 0, 0, 0, 0, 0 },
/* U+dd6d */ { 0, 0, 0, 0, 0 },
/* U+dd6e */ { 0, 0, 0, 0, 0 },
/* U+dd6f */ { 0, 0, 0, 0, 0 },
/* U+dd70 */ { 0, 0, 0, 0, 0 },
/* U+dd71 */ { 0, 0, 0, 0, 0 },
/* U+dd72 */ { 0, 0, 0, 0, 0 },
/* U+dd73 */ { 0, 0, 0, 0, 0 },
/* U+dd74 */ { 0, 0, 0, 0, 0 },
/* U+dd75 */ { 0, 0, 0, 0, 0 },
/* U+dd76 */ { 0, 0, 0, 0, 0 },
/* U+dd77 */ { 0, 0, 0, 0, 0 },
/* U+dd78 */ { 0, 0, 0, 0, 0 },
/* U+dd79 */ { 0, 0, 0, 0, 0 },
/* U+dd7a */ { 0, 0, 0, 0, 0 },
/* U+dd7b */ { 0, 0, 0, 0, 0 },
/* U+dd7c */ { 0, 0, 0, 0, 0 },
/* U+dd7d */ { 0, 0, 0, 0, 0 },
/* U+dd7e */ { 0, 0, 0, 0, 0 },
/* U+dd7f */ { 0, 0, 0, 0, 0 },
/* U+dd80 */ { 0, 0, 0, 0, 0 },
/* U+dd81 */ { 0, 0, 0, 0, 0 },
/* U+dd82 */ { 0, 0, 0, 0, 0 },
/* U+dd83 */ { 0, 0, 0, 0, 0 },
/* U+dd84 */ { 0, 0, 0, 0, 0 },
/* U+dd85 */ { 0, 0, 0, 0, 0 },
/* U+dd86 */ { 0, 0, 0, 0, 0 },
/* U+dd87 */ { 0, 0, 0, 0, 0 },
/* U+dd88 */ { 0, 0, 0, 0, 0 },
/* U+dd89 */ { 0, 0, 0, 0, 0 },
/* U+dd8a */ { 0, 0, 0, 0, 0 },
/* U+dd8b */ { 0, 0, 0, 0, 0 },
/* U+dd8c */ { 0, 0, 0, 0, 0 },
/* U+dd8d */ { 0, 0, 0, 0, 0 },
/* U+dd8e */ { 0, 0, 0, 0, 0 },
/* U+dd8f */ { 0, 0, 0, 0, 0 },
/* U+dd90 */ { 0, 0, 0, 0, 0 },
/* U+dd91 */ { 0, 0, 0, 0, 0 },
/* U+dd92 */ { 0, 0, 0, 0, 0 },
/* U+dd93 */ { 0, 0, 0, 0, 0 },
/* U+dd94 */ { 0, 0, 0, 0, 0 },
/* U+dd95 */ { 0, 0, 0, 0, 0 },
/* U+dd96 */ { 0, 0, 0, 0, 0 },
/* U+dd97 */ { 0, 0, 0, 0, 0 },
/* U+dd98 */ { 0, 0, 0, 0, 0 },
/* U+dd99 */ { 0, 0, 0, 0, 0 },
/* U+dd9a */ { 0, 0, 0, 0, 0 },
/* U+dd9b */ { 0, 0, 0, 0, 0 },
/* U+dd9c */ { 0, 0, 0, 0, 0 },
/* U+dd9d */ { 0, 0, 0, 0, 0 },
/* U+dd9e */ { 0, 0, 0, 0, 0 },
/* U+dd9f */ { 0, 0, 0, 0, 0 },
/* U+dda0 */ { 0, 0, 0, 0, 0 },
/* U+dda1 */ { 0, 0, 0, 0, 0 },
/* U+dda2 */ { 0, 0, 0, 0, 0 },
/* U+dda3 */ { 0, 0, 0, 0, 0 },
/* U+dda4 */ { 0, 0, 0, 0, 0 },
/* U+dda5 */ { 0, 0, 0, 0, 0 },
/* U+dda6 */ { 0, 0, 0, 0, 0 },
/* U+dda7 */ { 0, 0, 0, 0, 0 },
/* U+dda8 */ { 0, 0, 0, 0, 0 },
/* U+dda9 */ { 0, 0, 0, 0, 0 },
/* U+ddaa */ { 0, 0, 0, 0, 0 },
/* U+ddab */ { 0, 0, 0, 0, 0 },
/* U+ddac */ { 0, 0, 0, 0, 0 },
/* U+ddad */ { 0, 0, 0, 0, 0 },
/* U+ddae */ { 0, 0, 0, 0, 0 },
/* U+ddaf */ { 0, 0, 0, 0, 0 },
/* U+ddb0 */ { 0, 0, 0, 0, 0 },
/* U+ddb1 */ { 0, 0, 0, 0, 0 },
/* U+ddb2 */ { 0, 0, 0, 0, 0 },
/* U+ddb3 */ { 0, 0, 0, 0, 0 },
/* U+ddb4 */ { 0, 0, 0, 0, 0 },
/* U+ddb5 */ { 0, 0, 0, 0, 0 },
/* U+ddb6 */ { 0, 0, 0, 0, 0 },
/* U+ddb7 */ { 0, 0, 0, 0, 0 },
/* U+ddb8 */ { 0, 0, 0, 0, 0 },
/* U+ddb9 */ { 0, 0, 0, 0, 0 },
/* U+ddba */ { 0, 0, 0, 0, 0 },
/* U+ddbb */ { 0, 0, 0, 0, 0 },
/* U+ddbc */ { 0, 0, 0, 0, 0 },
/* U+ddbd */ { 0, 0, 0, 0, 0 },
/* U+ddbe */ { 0, 0, 0, 0, 0 },
/* U+ddbf */ { 0, 0, 0, 0, 0 },
/* U+ddc0 */ { 0, 0, 0, 0, 0 },
/* U+ddc1 */ { 0, 0, 0, 0, 0 },
/* U+ddc2 */ { 0, 0, 0, 0, 0 },
/* U+ddc3 */ { 0, 0, 0, 0, 0 },
/* U+ddc4 */ { 0, 0, 0, 0, 0 },
/* U+ddc5 */ { 0, 0, 0, 0, 0 },
/* U+ddc6 */ { 0, 0, 0, 0, 0 },
/* U+ddc7 */ { 0, 0, 0, 0, 0 },
/* U+ddc8 */ { 0, 0, 0, 0, 0 },
/* U+ddc9 */ { 0, 0, 0, 0, 0 },
/* U+ddca */ { 0, 0, 0, 0, 0 },
/* U+ddcb */ { 0, 0, 0, 0, 0 },
/* U+ddcc */ { 0, 0, 0, 0, 0 },
/* U+ddcd */ { 0, 0, 0, 0, 0 },
/* U+ddce */ { 0, 0, 0, 0, 0 },
/* U+ddcf */ { 0, 0, 0, 0, 0 },
/* U+ddd0 */ { 0, 0, 0, 0, 0 },
/* U+ddd1 */ { 0, 0, 0, 0, 0 },
/* U+ddd2 */ { 0, 0, 0, 0, 0 },
/* U+ddd3 */ { 0, 0, 0, 0, 0 },
/* U+ddd4 */ { 0, 0, 0, 0, 0 },
/* U+ddd5 */ { 0, 0, 0, 0, 0 },
/* U+ddd6 */ { 0, 0, 0, 0, 0 },
/* U+ddd7 */ { 0, 0, 0, 0, 0 },
/* U+ddd8 */ { 0, 0, 0, 0, 0 },
/* U+ddd9 */ { 0, 0, 0, 0, 0 },
/* U+ddda */ { 0, 0, 0, 0, 0 },
/* U+dddb */ { 0, 0, 0, 0, 0 },
/* U+dddc */ { 0, 0, 0, 0, 0 },
/* U+dddd */ { 0, 0, 0, 0, 0 },
/* U+ddde */ { 0, 0, 0, 0, 0 },
/* U+dddf */ { 0, 0, 0, 0, 0 },
/* U+dde0 */ { 0, 0, 0, 0, 0 },
/* U+dde1 */ { 0, 0, 0, 0, 0 },
/* U+dde2 */ { 0, 0, 0, 0, 0 },
/* U+dde3 */ { 0, 0, 0, 0, 0 },
/* U+dde4 */ { 0, 0, 0, 0, 0 },
/* U+dde5 */ { 0, 0, 0, 0, 0 },
/* U+dde6 */ { 0, 0, 0, 0, 0 },
/* U+dde7 */ { 0, 0, 0, 0, 0 },
/* U+dde8 */ { 0, 0, 0, 0, 0 },
/* U+dde9 */ { 0, 0, 0, 0, 0 },
/* U+ddea */ { 0, 0, 0, 0, 0 },
/* U+ddeb */ { 0, 0, 0, 0, 0 },
/* U+ddec */ { 0, 0, 0, 0, 0 },
/* U+dded */ { 0, 0, 0, 0, 0 },
/* U+ddee */ { 0, 0, 0, 0, 0 },
/* U+ddef */ { 0, 0, 0, 0, 0 },
/* U+ddf0 */ { 0, 0, 0, 0, 0 },
/* U+ddf1 */ { 0, 0, 0, 0, 0 },
/* U+ddf2 */ { 0, 0, 0, 0, 0 },
/* U+ddf3 */ { 0, 0, 0, 0, 0 },
/* U+ddf4 */ { 0, 0, 0, 0, 0 },
/* U+ddf5 */ { 0, 0, 0, 0, 0 },
/* U+ddf6 */ { 0, 0, 0, 0, 0 },
/* U+ddf7 */ { 0, 0, 0, 0, 0 },
/* U+ddf8 */ { 0, 0, 0, 0, 0 },
/* U+ddf9 */ { 0, 0, 0, 0, 0 },
/* U+ddfa */ { 0, 0, 0, 0, 0 },
/* U+ddfb */ { 0, 0, 0, 0, 0 },
/* U+ddfc */ { 0, 0, 0, 0, 0 },
/* U+ddfd */ { 0, 0, 0, 0, 0 },
/* U+ddfe */ { 0, 0, 0, 0, 0 },
/* U+ddff */ { 0, 0, 0, 0, 0 },
/* U+de00 */ { 0, 0, 0, 0, 0 },
/* U+de01 */ { 0, 0, 0, 0, 0 },
/* U+de02 */ { 0, 0, 0, 0, 0 },
/* U+de03 */ { 0, 0, 0, 0, 0 },
/* U+de04 */ { 0, 0, 0, 0, 0 },
/* U+de05 */ { 0, 0, 0, 0, 0 },
/* U+de06 */ { 0, 0, 0, 0, 0 },
/* U+de07 */ { 0, 0, 0, 0, 0 },
/* U+de08 */ { 0, 0, 0, 0, 0 },
/* U+de09 */ { 0, 0, 0, 0, 0 },
/* U+de0a */ { 0, 0, 0, 0, 0 },
/* U+de0b */ { 0, 0, 0, 0, 0 },
/* U+de0c */ { 0, 0, 0, 0, 0 },
/* U+de0d */ { 0, 0, 0, 0, 0 },
/* U+de0e */ { 0, 0, 0, 0, 0 },
/* U+de0f */ { 0, 0, 0, 0, 0 },
/* U+de10 */ { 0, 0, 0, 0, 0 },
/* U+de11 */ { 0, 0, 0, 0, 0 },
/* U+de12 */ { 0, 0, 0, 0, 0 },
/* U+de13 */ { 0, 0, 0, 0, 0 },
/* U+de14 */ { 0, 0, 0, 0, 0 },
/* U+de15 */ { 0, 0, 0, 0, 0 },
/* U+de16 */ { 0, 0, 0, 0, 0 },
/* U+de17 */ { 0, 0, 0, 0, 0 },
/* U+de18 */ { 0, 0, 0, 0, 0 },
/* U+de19 */ { 0, 0, 0, 0, 0 },
/* U+de1a */ { 0, 0, 0, 0, 0 },
/* U+de1b */ { 0, 0, 0, 0, 0 },
/* U+de1c */ { 0, 0, 0, 0, 0 },
/* U+de1d */ { 0, 0, 0, 0, 0 },
/* U+de1e */ { 0, 0, 0, 0, 0 },
/* U+de1f */ { 0, 0, 0, 0, 0 },
/* U+de20 */ { 0, 0, 0, 0, 0 },
/* U+de21 */ { 0, 0, 0, 0, 0 },
/* U+de22 */ { 0, 0, 0, 0, 0 },
/* U+de23 */ { 0, 0, 0, 0, 0 },
/* U+de24 */ { 0, 0, 0, 0, 0 },
/* U+de25 */ { 0, 0, 0, 0, 0 },
/* U+de26 */ { 0, 0, 0, 0, 0 },
/* U+de27 */ { 0, 0, 0, 0, 0 },
/* U+de28 */ { 0, 0, 0, 0, 0 },
/* U+de29 */ { 0, 0, 0, 0, 0 },
/* U+de2a */ { 0, 0, 0, 0, 0 },
/* U+de2b */ { 0, 0, 0, 0, 0 },
/* U+de2c */ { 0, 0, 0, 0, 0 },
/* U+de2d */ { 0, 0, 0, 0, 0 },
/* U+de2e */ { 0, 0, 0, 0, 0 },
/* U+de2f */ { 0, 0, 0, 0, 0 },
/* U+de30 */ { 0, 0, 0, 0, 0 },
/* U+de31 */ { 0, 0, 0, 0, 0 },
/* U+de32 */ { 0, 0, 0, 0, 0 },
/* U+de33 */ { 0, 0, 0, 0, 0 },
/* U+de34 */ { 0, 0, 0, 0, 0 },
/* U+de35 */ { 0, 0, 0, 0, 0 },
/* U+de36 */ { 0, 0, 0, 0, 0 },
/* U+de37 */ { 0, 0, 0, 0, 0 },
/* U+de38 */ { 0, 0, 0, 0, 0 },
/* U+de39 */ { 0, 0, 0, 0, 0 },
/* U+de3a */ { 0, 0, 0, 0, 0 },
/* U+de3b */ { 0, 0, 0, 0, 0 },
/* U+de3c */ { 0, 0, 0, 0, 0 },
/* U+de3d */ { 0, 0, 0, 0, 0 },
/* U+de3e */ { 0, 0, 0, 0, 0 },
/* U+de3f */ { 0, 0, 0, 0, 0 },
/* U+de40 */ { 0, 0, 0, 0, 0 },
/* U+de41 */ { 0, 0, 0, 0, 0 },
/* U+de42 */ { 0, 0, 0, 0, 0 },
/* U+de43 */ { 0, 0, 0, 0, 0 },
/* U+de44 */ { 0, 0, 0, 0, 0 },
/* U+de45 */ { 0, 0, 0, 0, 0 },
/* U+de46 */ { 0, 0, 0, 0, 0 },
/* U+de47 */ { 0, 0, 0, 0, 0 },
/* U+de48 */ { 0, 0, 0, 0, 0 },
/* U+de49 */ { 0, 0, 0, 0, 0 },
/* U+de4a */ { 0, 0, 0, 0, 0 },
/* U+de4b */ { 0, 0, 0, 0, 0 },
/* U+de4c */ { 0, 0, 0, 0, 0 },
/* U+de4d */ { 0, 0, 0, 0, 0 },
/* U+de4e */ { 0, 0, 0, 0, 0 },
/* U+de4f */ { 0, 0, 0, 0, 0 },
/* U+de50 */ { 0, 0, 0, 0, 0 },
/* U+de51 */ { 0, 0, 0, 0, 0 },
/* U+de52 */ { 0, 0, 0, 0, 0 },
/* U+de53 */ { 0, 0, 0, 0, 0 },
/* U+de54 */ { 0, 0, 0, 0, 0 },
/* U+de55 */ { 0, 0, 0, 0, 0 },
/* U+de56 */ { 0, 0, 0, 0, 0 },
/* U+de57 */ { 0, 0, 0, 0, 0 },
/* U+de58 */ { 0, 0, 0, 0, 0 },
/* U+de59 */ { 0, 0, 0, 0, 0 },
/* U+de5a */ { 0, 0, 0, 0, 0 },
/* U+de5b */ { 0, 0, 0, 0, 0 },
/* U+de5c */ { 0, 0, 0, 0, 0 },
/* U+de5d */ { 0, 0, 0, 0, 0 },
/* U+de5e */ { 0, 0, 0, 0, 0 },
/* U+de5f */ { 0, 0, 0, 0, 0 },
/* U+de60 */ { 0, 0, 0, 0, 0 },
/* U+de61 */ { 0, 0, 0, 0, 0 },
/* U+de62 */ { 0, 0, 0, 0, 0 },
/* U+de63 */ { 0, 0, 0, 0, 0 },
/* U+de64 */ { 0, 0, 0, 0, 0 },
/* U+de65 */ { 0, 0, 0, 0, 0 },
/* U+de66 */ { 0, 0, 0, 0, 0 },
/* U+de67 */ { 0, 0, 0, 0, 0 },
/* U+de68 */ { 0, 0, 0, 0, 0 },
/* U+de69 */ { 0, 0, 0, 0, 0 },
/* U+de6a */ { 0, 0, 0, 0, 0 },
/* U+de6b */ { 0, 0, 0, 0, 0 },
/* U+de6c */ { 0, 0, 0, 0, 0 },
/* U+de6d */ { 0, 0, 0, 0, 0 },
/* U+de6e */ { 0, 0, 0, 0, 0 },
/* U+de6f */ { 0, 0, 0, 0, 0 },
/* U+de70 */ { 0, 0, 0, 0, 0 },
/* U+de71 */ { 0, 0, 0, 0, 0 },
/* U+de72 */ { 0, 0, 0, 0, 0 },
/* U+de73 */ { 0, 0, 0, 0, 0 },
/* U+de74 */ { 0, 0, 0, 0, 0 },
/* U+de75 */ { 0, 0, 0, 0, 0 },
/* U+de76 */ { 0, 0, 0, 0, 0 },
/* U+de77 */ { 0, 0, 0, 0, 0 },
/* U+de78 */ { 0, 0, 0, 0, 0 },
/* U+de79 */ { 0, 0, 0, 0, 0 },
/* U+de7a */ { 0, 0, 0, 0, 0 },
/* U+de7b */ { 0, 0, 0, 0, 0 },
/* U+de7c */ { 0, 0, 0, 0, 0 },
/* U+de7d */ { 0, 0, 0, 0, 0 },
/* U+de7e */ { 0, 0, 0, 0, 0 },
/* U+de7f */ { 0, 0, 0, 0, 0 },
/* U+de80 */ { 0, 0, 0, 0, 0 },
/* U+de81 */ { 0, 0, 0, 0, 0 },
/* U+de82 */ { 0, 0, 0, 0, 0 },
/* U+de83 */ { 0, 0, 0, 0, 0 },
/* U+de84 */ { 0, 0, 0, 0, 0 },
/* U+de85 */ { 0, 0, 0, 0, 0 },
/* U+de86 */ { 0, 0, 0, 0, 0 },
/* U+de87 */ { 0, 0, 0, 0, 0 },
/* U+de88 */ { 0, 0, 0, 0, 0 },
/* U+de89 */ { 0, 0, 0, 0, 0 },
/* U+de8a */ { 0, 0, 0, 0, 0 },
/* U+de8b */ { 0, 0, 0, 0, 0 },
/* U+de8c */ { 0, 0, 0, 0, 0 },
/* U+de8d */ { 0, 0, 0, 0, 0 },
/* U+de8e */ { 0, 0, 0, 0, 0 },
/* U+de8f */ { 0, 0, 0, 0, 0 },
/* U+de90 */ { 0, 0, 0, 0, 0 },
/* U+de91 */ { 0, 0, 0, 0, 0 },
/* U+de92 */ { 0, 0, 0, 0, 0 },
/* U+de93 */ { 0, 0, 0, 0, 0 },
/* U+de94 */ { 0, 0, 0, 0, 0 },
/* U+de95 */ { 0, 0, 0, 0, 0 },
/* U+de96 */ { 0, 0, 0, 0, 0 },
/* U+de97 */ { 0, 0, 0, 0, 0 },
/* U+de98 */ { 0, 0, 0, 0, 0 },
/* U+de99 */ { 0, 0, 0, 0, 0 },
/* U+de9a */ { 0, 0, 0, 0, 0 },
/* U+de9b */ { 0, 0, 0, 0, 0 },
/* U+de9c */ { 0, 0, 0, 0, 0 },
/* U+de9d */ { 0, 0, 0, 0, 0 },
/* U+de9e */ { 0, 0, 0, 0, 0 },
/* U+de9f */ { 0, 0, 0, 0, 0 },
/* U+dea0 */ { 0, 0, 0, 0, 0 },
/* U+dea1 */ { 0, 0, 0, 0, 0 },
/* U+dea2 */ { 0, 0, 0, 0, 0 },
/* U+dea3 */ { 0, 0, 0, 0, 0 },
/* U+dea4 */ { 0, 0, 0, 0, 0 },
/* U+dea5 */ { 0, 0, 0, 0, 0 },
/* U+dea6 */ { 0, 0, 0, 0, 0 },
/* U+dea7 */ { 0, 0, 0, 0, 0 },
/* U+dea8 */ { 0, 0, 0, 0, 0 },
/* U+dea9 */ { 0, 0, 0, 0, 0 },
/* U+deaa */ { 0, 0, 0, 0, 0 },
/* U+deab */ { 0, 0, 0, 0, 0 },
/* U+deac */ { 0, 0, 0, 0, 0 },
/* U+dead */ { 0, 0, 0, 0, 0 },
/* U+deae */ { 0, 0, 0, 0, 0 },
/* U+deaf */ { 0, 0, 0, 0, 0 },
/* U+deb0 */ { 0, 0, 0, 0, 0 },
/* U+deb1 */ { 0, 0, 0, 0, 0 },
/* U+deb2 */ { 0, 0, 0, 0, 0 },
/* U+deb3 */ { 0, 0, 0, 0, 0 },
/* U+deb4 */ { 0, 0, 0, 0, 0 },
/* U+deb5 */ { 0, 0, 0, 0, 0 },
/* U+deb6 */ { 0, 0, 0, 0, 0 },
/* U+deb7 */ { 0, 0, 0, 0, 0 },
/* U+deb8 */ { 0, 0, 0, 0, 0 },
/* U+deb9 */ { 0, 0, 0, 0, 0 },
/* U+deba */ { 0, 0, 0, 0, 0 },
/* U+debb */ { 0, 0, 0, 0, 0 },
/* U+debc */ { 0, 0, 0, 0, 0 },
/* U+debd */ { 0, 0, 0, 0, 0 },
/* U+debe */ { 0, 0, 0, 0, 0 },
/* U+debf */ { 0, 0, 0, 0, 0 },
/* U+dec0 */ { 0, 0, 0, 0, 0 },
/* U+dec1 */ { 0, 0, 0, 0, 0 },
/* U+dec2 */ { 0, 0, 0, 0, 0 },
/* U+dec3 */ { 0, 0, 0, 0, 0 },
/* U+dec4 */ { 0, 0, 0, 0, 0 },
/* U+dec5 */ { 0, 0, 0, 0, 0 },
/* U+dec6 */ { 0, 0, 0, 0, 0 },
/* U+dec7 */ { 0, 0, 0, 0, 0 },
/* U+dec8 */ { 0, 0, 0, 0, 0 },
/* U+dec9 */ { 0, 0, 0, 0, 0 },
/* U+deca */ { 0, 0, 0, 0, 0 },
/* U+decb */ { 0, 0, 0, 0, 0 },
/* U+decc */ { 0, 0, 0, 0, 0 },
/* U+decd */ { 0, 0, 0, 0, 0 },
/* U+dece */ { 0, 0, 0, 0, 0 },
/* U+decf */ { 0, 0, 0, 0, 0 },
/* U+ded0 */ { 0, 0, 0, 0, 0 },
/* U+ded1 */ { 0, 0, 0, 0, 0 },
/* U+ded2 */ { 0, 0, 0, 0, 0 },
/* U+ded3 */ { 0, 0, 0, 0, 0 },
/* U+ded4 */ { 0, 0, 0, 0, 0 },
/* U+ded5 */ { 0, 0, 0, 0, 0 },
/* U+ded6 */ { 0, 0, 0, 0, 0 },
/* U+ded7 */ { 0, 0, 0, 0, 0 },
/* U+ded8 */ { 0, 0, 0, 0, 0 },
/* U+ded9 */ { 0, 0, 0, 0, 0 },
/* U+deda */ { 0, 0, 0, 0, 0 },
/* U+dedb */ { 0, 0, 0, 0, 0 },
/* U+dedc */ { 0, 0, 0, 0, 0 },
/* U+dedd */ { 0, 0, 0, 0, 0 },
/* U+dede */ { 0, 0, 0, 0, 0 },
/* U+dedf */ { 0, 0, 0, 0, 0 },
/* U+dee0 */ { 0, 0, 0, 0, 0 },
/* U+dee1 */ { 0, 0, 0, 0, 0 },
/* U+dee2 */ { 0, 0, 0, 0, 0 },
/* U+dee3 */ { 0, 0, 0, 0, 0 },
/* U+dee4 */ { 0, 0, 0, 0, 0 },
/* U+dee5 */ { 0, 0, 0, 0, 0 },
/* U+dee6 */ { 0, 0, 0, 0, 0 },
/* U+dee7 */ { 0, 0, 0, 0, 0 },
/* U+dee8 */ { 0, 0, 0, 0, 0 },
/* U+dee9 */ { 0, 0, 0, 0, 0 },
/* U+deea */ { 0, 0, 0, 0, 0 },
/* U+deeb */ { 0, 0, 0, 0, 0 },
/* U+deec */ { 0, 0, 0, 0, 0 },
/* U+deed */ { 0, 0, 0, 0, 0 },
/* U+deee */ { 0, 0, 0, 0, 0 },
/* U+deef */ { 0, 0, 0, 0, 0 },
/* U+def0 */ { 0, 0, 0, 0, 0 },
/* U+def1 */ { 0, 0, 0, 0, 0 },
/* U+def2 */ { 0, 0, 0, 0, 0 },
/* U+def3 */ { 0, 0, 0, 0, 0 },
/* U+def4 */ { 0, 0, 0, 0, 0 },
/* U+def5 */ { 0, 0, 0, 0, 0 },
/* U+def6 */ { 0, 0, 0, 0, 0 },
/* U+def7 */ { 0, 0, 0, 0, 0 },
/* U+def8 */ { 0, 0, 0, 0, 0 },
/* U+def9 */ { 0, 0, 0, 0, 0 },
/* U+defa */ { 0, 0, 0, 0, 0 },
/* U+defb */ { 0, 0, 0, 0, 0 },
/* U+defc */ { 0, 0, 0, 0, 0 },
/* U+defd */ { 0, 0, 0, 0, 0 },
/* U+defe */ { 0, 0, 0, 0, 0 },
/* U+deff */ { 0, 0, 0, 0, 0 },
/* U+df00 */ { 0, 0, 0, 0, 0 },
/* U+df01 */ { 0, 0, 0, 0, 0 },
/* U+df02 */ { 0, 0, 0, 0, 0 },
/* U+df03 */ { 0, 0, 0, 0, 0 },
/* U+df04 */ { 0, 0, 0, 0, 0 },
/* U+df05 */ { 0, 0, 0, 0, 0 },
/* U+df06 */ { 0, 0, 0, 0, 0 },
/* U+df07 */ { 0, 0, 0, 0, 0 },
/* U+df08 */ { 0, 0, 0, 0, 0 },
/* U+df09 */ { 0, 0, 0, 0, 0 },
/* U+df0a */ { 0, 0, 0, 0, 0 },
/* U+df0b */ { 0, 0, 0, 0, 0 },
/* U+df0c */ { 0, 0, 0, 0, 0 },
/* U+df0d */ { 0, 0, 0, 0, 0 },
/* U+df0e */ { 0, 0, 0, 0, 0 },
/* U+df0f */ { 0, 0, 0, 0, 0 },
/* U+df10 */ { 0, 0, 0, 0, 0 },
/* U+df11 */ { 0, 0, 0, 0, 0 },
/* U+df12 */ { 0, 0, 0, 0, 0 },
/* U+df13 */ { 0, 0, 0, 0, 0 },
/* U+df14 */ { 0, 0, 0, 0, 0 },
/* U+df15 */ { 0, 0, 0, 0, 0 },
/* U+df16 */ { 0, 0, 0, 0, 0 },
/* U+df17 */ { 0, 0, 0, 0, 0 },
/* U+df18 */ { 0, 0, 0, 0, 0 },
/* U+df19 */ { 0, 0, 0, 0, 0 },
/* U+df1a */ { 0, 0, 0, 0, 0 },
/* U+df1b */ { 0, 0, 0, 0, 0 },
/* U+df1c */ { 0, 0, 0, 0, 0 },
/* U+df1d */ { 0, 0, 0, 0, 0 },
/* U+df1e */ { 0, 0, 0, 0, 0 },
/* U+df1f */ { 0, 0, 0, 0, 0 },
/* U+df20 */ { 0, 0, 0, 0, 0 },
/* U+df21 */ { 0, 0, 0, 0, 0 },
/* U+df22 */ { 0, 0, 0, 0, 0 },
/* U+df23 */ { 0, 0, 0, 0, 0 },
/* U+df24 */ { 0, 0, 0, 0, 0 },
/* U+df25 */ { 0, 0, 0, 0, 0 },
/* U+df26 */ { 0, 0, 0, 0, 0 },
/* U+df27 */ { 0, 0, 0, 0, 0 },
/* U+df28 */ { 0, 0, 0, 0, 0 },
/* U+df29 */ { 0, 0, 0, 0, 0 },
/* U+df2a */ { 0, 0, 0, 0, 0 },
/* U+df2b */ { 0, 0, 0, 0, 0 },
/* U+df2c */ { 0, 0, 0, 0, 0 },
/* U+df2d */ { 0, 0, 0, 0, 0 },
/* U+df2e */ { 0, 0, 0, 0, 0 },
/* U+df2f */ { 0, 0, 0, 0, 0 },
/* U+df30 */ { 0, 0, 0, 0, 0 },
/* U+df31 */ { 0, 0, 0, 0, 0 },
/* U+df32 */ { 0, 0, 0, 0, 0 },
/* U+df33 */ { 0, 0, 0, 0, 0 },
/* U+df34 */ { 0, 0, 0, 0, 0 },
/* U+df35 */ { 0, 0, 0, 0, 0 },
/* U+df36 */ { 0, 0, 0, 0, 0 },
/* U+df37 */ { 0, 0, 0, 0, 0 },
/* U+df38 */ { 0, 0, 0, 0, 0 },
/* U+df39 */ { 0, 0, 0, 0, 0 },
/* U+df3a */ { 0, 0, 0, 0, 0 },
/* U+df3b */ { 0, 0, 0, 0, 0 },
/* U+df3c */ { 0, 0, 0, 0, 0 },
/* U+df3d */ { 0, 0, 0, 0, 0 },
/* U+df3e */ { 0, 0, 0, 0, 0 },
/* U+df3f */ { 0, 0, 0, 0, 0 },
/* U+df40 */ { 0, 0, 0, 0, 0 },
/* U+df41 */ { 0, 0, 0, 0, 0 },
/* U+df42 */ { 0, 0, 0, 0, 0 },
/* U+df43 */ { 0, 0, 0, 0, 0 },
/* U+df44 */ { 0, 0, 0, 0, 0 },
/* U+df45 */ { 0, 0, 0, 0, 0 },
/* U+df46 */ { 0, 0, 0, 0, 0 },
/* U+df47 */ { 0, 0, 0, 0, 0 },
/* U+df48 */ { 0, 0, 0, 0, 0 },
/* U+df49 */ { 0, 0, 0, 0, 0 },
/* U+df4a */ { 0, 0, 0, 0, 0 },
/* U+df4b */ { 0, 0, 0, 0, 0 },
/* U+df4c */ { 0, 0, 0, 0, 0 },
/* U+df4d */ { 0, 0, 0, 0, 0 },
/* U+df4e */ { 0, 0, 0, 0, 0 },
/* U+df4f */ { 0, 0, 0, 0, 0 },
/* U+df50 */ { 0, 0, 0, 0, 0 },
/* U+df51 */ { 0, 0, 0, 0, 0 },
/* U+df52 */ { 0, 0, 0, 0, 0 },
/* U+df53 */ { 0, 0, 0, 0, 0 },
/* U+df54 */ { 0, 0, 0, 0, 0 },
/* U+df55 */ { 0, 0, 0, 0, 0 },
/* U+df56 */ { 0, 0, 0, 0, 0 },
/* U+df57 */ { 0, 0, 0, 0, 0 },
/* U+df58 */ { 0, 0, 0, 0, 0 },
/* U+df59 */ { 0, 0, 0, 0, 0 },
/* U+df5a */ { 0, 0, 0, 0, 0 },
/* U+df5b */ { 0, 0, 0, 0, 0 },
/* U+df5c */ { 0, 0, 0, 0, 0 },
/* U+df5d */ { 0, 0, 0, 0, 0 },
/* U+df5e */ { 0, 0, 0, 0, 0 },
/* U+df5f */ { 0, 0, 0, 0, 0 },
/* U+df60 */ { 0, 0, 0, 0, 0 },
/* U+df61 */ { 0, 0, 0, 0, 0 },
/* U+df62 */ { 0, 0, 0, 0, 0 },
/* U+df63 */ { 0, 0, 0, 0, 0 },
/* U+df64 */ { 0, 0, 0, 0, 0 },
/* U+df65 */ { 0, 0, 0, 0, 0 },
/* U+df66 */ { 0, 0, 0, 0, 0 },
/* U+df67 */ { 0, 0, 0, 0, 0 },
/* U+df68 */ { 0, 0, 0, 0, 0 },
/* U+df69 */ { 0, 0, 0, 0, 0 },
/* U+df6a */ { 0, 0, 0, 0, 0 },
/* U+df6b */ { 0, 0, 0, 0, 0 },
/* U+df6c */ { 0, 0, 0, 0, 0 },
/* U+df6d */ { 0, 0, 0, 0, 0 },
/* U+df6e */ { 0, 0, 0, 0, 0 },
/* U+df6f */ { 0, 0, 0, 0, 0 },
/* U+df70 */ { 0, 0, 0, 0, 0 },
/* U+df71 */ { 0, 0, 0, 0, 0 },
/* U+df72 */ { 0, 0, 0, 0, 0 },
/* U+df73 */ { 0, 0, 0, 0, 0 },
/* U+df74 */ { 0, 0, 0, 0, 0 },
/* U+df75 */ { 0, 0, 0, 0, 0 },
/* U+df76 */ { 0, 0, 0, 0, 0 },
/* U+df77 */ { 0, 0, 0, 0, 0 },
/* U+df78 */ { 0, 0, 0, 0, 0 },
/* U+df79 */ { 0, 0, 0, 0, 0 },
/* U+df7a */ { 0, 0, 0, 0, 0 },
/* U+df7b */ { 0, 0, 0, 0, 0 },
/* U+df7c */ { 0, 0, 0, 0, 0 },
/* U+df7d */ { 0, 0, 0, 0, 0 },
/* U+df7e */ { 0, 0, 0, 0, 0 },
/* U+df7f */ { 0, 0, 0, 0, 0 },
/* U+df80 */ { 0, 0, 0, 0, 0 },
/* U+df81 */ { 0, 0, 0, 0, 0 },
/* U+df82 */ { 0, 0, 0, 0, 0 },
/* U+df83 */ { 0, 0, 0, 0, 0 },
/* U+df84 */ { 0, 0, 0, 0, 0 },
/* U+df85 */ { 0, 0, 0, 0, 0 },
/* U+df86 */ { 0, 0, 0, 0, 0 },
/* U+df87 */ { 0, 0, 0, 0, 0 },
/* U+df88 */ { 0, 0, 0, 0, 0 },
/* U+df89 */ { 0, 0, 0, 0, 0 },
/* U+df8a */ { 0, 0, 0, 0, 0 },
/* U+df8b */ { 0, 0, 0, 0, 0 },
/* U+df8c */ { 0, 0, 0, 0, 0 },
/* U+df8d */ { 0, 0, 0, 0, 0 },
/* U+df8e */ { 0, 0, 0, 0, 0 },
/* U+df8f */ { 0, 0, 0, 0, 0 },
/* U+df90 */ { 0, 0, 0, 0, 0 },
/* U+df91 */ { 0, 0, 0, 0, 0 },
/* U+df92 */ { 0, 0, 0, 0, 0 },
/* U+df93 */ { 0, 0, 0, 0, 0 },
/* U+df94 */ { 0, 0, 0, 0, 0 },
/* U+df95 */ { 0, 0, 0, 0, 0 },
/* U+df96 */ { 0, 0, 0, 0, 0 },
/* U+df97 */ { 0, 0, 0, 0, 0 },
/* U+df98 */ { 0, 0, 0, 0, 0 },
/* U+df99 */ { 0, 0, 0, 0, 0 },
/* U+df9a */ { 0, 0, 0, 0, 0 },
/* U+df9b */ { 0, 0, 0, 0, 0 },
/* U+df9c */ { 0, 0, 0, 0, 0 },
/* U+df9d */ { 0, 0, 0, 0, 0 },
/* U+df9e */ { 0, 0, 0, 0, 0 },
/* U+df9f */ { 0, 0, 0, 0, 0 },
/* U+dfa0 */ { 0, 0, 0, 0, 0 },
/* U+dfa1 */ { 0, 0, 0, 0, 0 },
/* U+dfa2 */ { 0, 0, 0, 0, 0 },
/* U+dfa3 */ { 0, 0, 0, 0, 0 },
/* U+dfa4 */ { 0, 0, 0, 0, 0 },
/* U+dfa5 */ { 0, 0, 0, 0, 0 },
/* U+dfa6 */ { 0, 0, 0, 0, 0 },
/* U+dfa7 */ { 0, 0, 0, 0, 0 },
/* U+dfa8 */ { 0, 0, 0, 0, 0 },
/* U+dfa9 */ { 0, 0, 0, 0, 0 },
/* U+dfaa */ { 0, 0, 0, 0, 0 },
/* U+dfab */ { 0, 0, 0, 0, 0 },
/* U+dfac */ { 0, 0, 0, 0, 0 },
/* U+dfad */ { 0, 0, 0, 0, 0 },
/* U+dfae */ { 0, 0, 0, 0, 0 },
/* U+dfaf */ { 0, 0, 0, 0, 0 },
/* U+dfb0 */ { 0, 0, 0, 0, 0 },
/* U+dfb1 */ { 0, 0, 0, 0, 0 },
/* U+dfb2 */ { 0, 0, 0, 0, 0 },
/* U+dfb3 */ { 0, 0, 0, 0, 0 },
/* U+dfb4 */ { 0, 0, 0, 0, 0 },
/* U+dfb5 */ { 0, 0, 0, 0, 0 },
/* U+dfb6 */ { 0, 0, 0, 0, 0 },
/* U+dfb7 */ { 0, 0, 0, 0, 0 },
/* U+dfb8 */ { 0, 0, 0, 0, 0 },
/* U+dfb9 */ { 0, 0, 0, 0, 0 },
/* U+dfba */ { 0, 0, 0, 0, 0 },
/* U+dfbb */ { 0, 0, 0, 0, 0 },
/* U+dfbc */ { 0, 0, 0, 0, 0 },
/* U+dfbd */ { 0, 0, 0, 0, 0 },
/* U+dfbe */ { 0, 0, 0, 0, 0 },
/* U+dfbf */ { 0, 0, 0, 0, 0 },
/* U+dfc0 */ { 0, 0, 0, 0, 0 },
/* U+dfc1 */ { 0, 0, 0, 0, 0 },
/* U+dfc2 */ { 0, 0, 0, 0, 0 },
/* U+dfc3 */ { 0, 0, 0, 0, 0 },
/* U+dfc4 */ { 0, 0, 0, 0, 0 },
/* U+dfc5 */ { 0, 0, 0, 0, 0 },
/* U+dfc6 */ { 0, 0, 0, 0, 0 },
/* U+dfc7 */ { 0, 0, 0, 0, 0 },
/* U+dfc8 */ { 0, 0, 0, 0, 0 },
/* U+dfc9 */ { 0, 0, 0, 0, 0 },
/* U+dfca */ { 0, 0, 0, 0, 0 },
/* U+dfcb */ { 0, 0, 0, 0, 0 },
/* U+dfcc */ { 0, 0, 0, 0, 0 },
/* U+dfcd */ { 0, 0, 0, 0, 0 },
/* U+dfce */ { 0, 0, 0, 0, 0 },
/* U+dfcf */ { 0, 0, 0, 0, 0 },
/* U+dfd0 */ { 0, 0, 0, 0, 0 },
/* U+dfd1 */ { 0, 0, 0, 0, 0 },
/* U+dfd2 */ { 0, 0, 0, 0, 0 },
/* U+dfd3 */ { 0, 0, 0, 0, 0 },
/* U+dfd4 */ { 0, 0, 0, 0, 0 },
/* U+dfd5 */ { 0, 0, 0, 0, 0 },
/* U+dfd6 */ { 0, 0, 0, 0, 0 },
/* U+dfd7 */ { 0, 0, 0, 0, 0 },
/* U+dfd8 */ { 0, 0, 0, 0, 0 },
/* U+dfd9 */ { 0, 0, 0, 0, 0 },
/* U+dfda */ { 0, 0, 0, 0, 0 },
/* U+dfdb */ { 0, 0, 0, 0, 0 },
/* U+dfdc */ { 0, 0, 0, 0, 0 },
/* U+dfdd */ { 0, 0, 0, 0, 0 },
/* U+dfde */ { 0, 0, 0, 0, 0 },
/* U+dfdf */ { 0, 0, 0, 0, 0 },
/* U+dfe0 */ { 0, 0, 0, 0, 0 },
/* U+dfe1 */ { 0, 0, 0, 0, 0 },
/* U+dfe2 */ { 0, 0, 0, 0, 0 },
/* U+dfe3 */ { 0, 0, 0, 0, 0 },
/* U+dfe4 */ { 0, 0, 0, 0, 0 },
/* U+dfe5 */ { 0, 0, 0, 0, 0 },
/* U+dfe6 */ { 0, 0, 0, 0, 0 },
/* U+dfe7 */ { 0, 0, 0, 0, 0 },
/* U+dfe8 */ { 0, 0, 0, 0, 0 },
/* U+dfe9 */ { 0, 0, 0, 0, 0 },
/* U+dfea */ { 0, 0, 0, 0, 0 },
/* U+dfeb */ { 0, 0, 0, 0, 0 },
/* U+dfec */ { 0, 0, 0, 0, 0 },
/* U+dfed */ { 0, 0, 0, 0, 0 },
/* U+dfee */ { 0, 0, 0, 0, 0 },
/* U+dfef */ { 0, 0, 0, 0, 0 },
/* U+dff0 */ { 0, 0, 0, 0, 0 },
/* U+dff1 */ { 0, 0, 0, 0, 0 },
/* U+dff2 */ { 0, 0, 0, 0, 0 },
/* U+dff3 */ { 0, 0, 0, 0, 0 },
/* U+dff4 */ { 0, 0, 0, 0, 0 },
/* U+dff5 */ { 0, 0, 0, 0, 0 },
/* U+dff6 */ { 0, 0, 0, 0, 0 },
/* U+dff7 */ { 0, 0, 0, 0, 0 },
/* U+dff8 */ { 0, 0, 0, 0, 0 },
/* U+dff9 */ { 0, 0, 0, 0, 0 },
/* U+dffa */ { 0, 0, 0, 0, 0 },
/* U+dffb */ { 0, 0, 0, 0, 0 },
/* U+dffc */ { 0, 0, 0, 0, 0 },
/* U+dffd */ { 0, 0, 0, 0, 0 },
/* U+dffe */ { 0, 0, 0, 0, 0 },
/* U+dfff */ { 15, 0, 1, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_14[4096] = {
    
/* U+e000 */ { 16, 0, 1, 0, 0 },
/* U+e001 */ { 0, 0, 0, 0, 0 },
/* U+e002 */ { 0, 0, 0, 0, 0 },
/* U+e003 */ { 0, 0, 0, 0, 0 },
/* U+e004 */ { 0, 0, 0, 0, 0 },
/* U+e005 */ { 0, 0, 0, 0, 0 },
/* U+e006 */ { 0, 0, 0, 0, 0 },
/* U+e007 */ { 0, 0, 0, 0, 0 },
/* U+e008 */ { 0, 0, 0, 0, 0 },
/* U+e009 */ { 0, 0, 0, 0, 0 },
/* U+e00a */ { 0, 0, 0, 0, 0 },
/* U+e00b */ { 0, 0, 0, 0, 0 },
/* U+e00c */ { 0, 0, 0, 0, 0 },
/* U+e00d */ { 0, 0, 0, 0, 0 },
/* U+e00e */ { 0, 0, 0, 0, 0 },
/* U+e00f */ { 0, 0, 0, 0, 0 },
/* U+e010 */ { 0, 0, 0, 0, 0 },
/* U+e011 */ { 0, 0, 0, 0, 0 },
/* U+e012 */ { 0, 0, 0, 0, 0 },
/* U+e013 */ { 0, 0, 0, 0, 0 },
/* U+e014 */ { 0, 0, 0, 0, 0 },
/* U+e015 */ { 0, 0, 0, 0, 0 },
/* U+e016 */ { 0, 0, 0, 0, 0 },
/* U+e017 */ { 0, 0, 0, 0, 0 },
/* U+e018 */ { 0, 0, 0, 0, 0 },
/* U+e019 */ { 0, 0, 0, 0, 0 },
/* U+e01a */ { 0, 0, 0, 0, 0 },
/* U+e01b */ { 0, 0, 0, 0, 0 },
/* U+e01c */ { 0, 0, 0, 0, 0 },
/* U+e01d */ { 0, 0, 0, 0, 0 },
/* U+e01e */ { 0, 0, 0, 0, 0 },
/* U+e01f */ { 0, 0, 0, 0, 0 },
/* U+e020 */ { 0, 0, 0, 0, 0 },
/* U+e021 */ { 0, 0, 0, 0, 0 },
/* U+e022 */ { 0, 0, 0, 0, 0 },
/* U+e023 */ { 0, 0, 0, 0, 0 },
/* U+e024 */ { 0, 0, 0, 0, 0 },
/* U+e025 */ { 0, 0, 0, 0, 0 },
/* U+e026 */ { 0, 0, 0, 0, 0 },
/* U+e027 */ { 0, 0, 0, 0, 0 },
/* U+e028 */ { 0, 0, 0, 0, 0 },
/* U+e029 */ { 0, 0, 0, 0, 0 },
/* U+e02a */ { 0, 0, 0, 0, 0 },
/* U+e02b */ { 0, 0, 0, 0, 0 },
/* U+e02c */ { 0, 0, 0, 0, 0 },
/* U+e02d */ { 0, 0, 0, 0, 0 },
/* U+e02e */ { 0, 0, 0, 0, 0 },
/* U+e02f */ { 0, 0, 0, 0, 0 },
/* U+e030 */ { 0, 0, 0, 0, 0 },
/* U+e031 */ { 0, 0, 0, 0, 0 },
/* U+e032 */ { 0, 0, 0, 0, 0 },
/* U+e033 */ { 0, 0, 0, 0, 0 },
/* U+e034 */ { 0, 0, 0, 0, 0 },
/* U+e035 */ { 0, 0, 0, 0, 0 },
/* U+e036 */ { 0, 0, 0, 0, 0 },
/* U+e037 */ { 0, 0, 0, 0, 0 },
/* U+e038 */ { 0, 0, 0, 0, 0 },
/* U+e039 */ { 0, 0, 0, 0, 0 },
/* U+e03a */ { 0, 0, 0, 0, 0 },
/* U+e03b */ { 0, 0, 0, 0, 0 },
/* U+e03c */ { 0, 0, 0, 0, 0 },
/* U+e03d */ { 0, 0, 0, 0, 0 },
/* U+e03e */ { 0, 0, 0, 0, 0 },
/* U+e03f */ { 0, 0, 0, 0, 0 },
/* U+e040 */ { 0, 0, 0, 0, 0 },
/* U+e041 */ { 0, 0, 0, 0, 0 },
/* U+e042 */ { 0, 0, 0, 0, 0 },
/* U+e043 */ { 0, 0, 0, 0, 0 },
/* U+e044 */ { 0, 0, 0, 0, 0 },
/* U+e045 */ { 0, 0, 0, 0, 0 },
/* U+e046 */ { 0, 0, 0, 0, 0 },
/* U+e047 */ { 0, 0, 0, 0, 0 },
/* U+e048 */ { 0, 0, 0, 0, 0 },
/* U+e049 */ { 0, 0, 0, 0, 0 },
/* U+e04a */ { 0, 0, 0, 0, 0 },
/* U+e04b */ { 0, 0, 0, 0, 0 },
/* U+e04c */ { 0, 0, 0, 0, 0 },
/* U+e04d */ { 0, 0, 0, 0, 0 },
/* U+e04e */ { 0, 0, 0, 0, 0 },
/* U+e04f */ { 0, 0, 0, 0, 0 },
/* U+e050 */ { 0, 0, 0, 0, 0 },
/* U+e051 */ { 0, 0, 0, 0, 0 },
/* U+e052 */ { 0, 0, 0, 0, 0 },
/* U+e053 */ { 0, 0, 0, 0, 0 },
/* U+e054 */ { 0, 0, 0, 0, 0 },
/* U+e055 */ { 0, 0, 0, 0, 0 },
/* U+e056 */ { 0, 0, 0, 0, 0 },
/* U+e057 */ { 0, 0, 0, 0, 0 },
/* U+e058 */ { 0, 0, 0, 0, 0 },
/* U+e059 */ { 0, 0, 0, 0, 0 },
/* U+e05a */ { 0, 0, 0, 0, 0 },
/* U+e05b */ { 0, 0, 0, 0, 0 },
/* U+e05c */ { 0, 0, 0, 0, 0 },
/* U+e05d */ { 0, 0, 0, 0, 0 },
/* U+e05e */ { 0, 0, 0, 0, 0 },
/* U+e05f */ { 0, 0, 0, 0, 0 },
/* U+e060 */ { 0, 0, 0, 0, 0 },
/* U+e061 */ { 0, 0, 0, 0, 0 },
/* U+e062 */ { 0, 0, 0, 0, 0 },
/* U+e063 */ { 0, 0, 0, 0, 0 },
/* U+e064 */ { 0, 0, 0, 0, 0 },
/* U+e065 */ { 0, 0, 0, 0, 0 },
/* U+e066 */ { 0, 0, 0, 0, 0 },
/* U+e067 */ { 0, 0, 0, 0, 0 },
/* U+e068 */ { 0, 0, 0, 0, 0 },
/* U+e069 */ { 0, 0, 0, 0, 0 },
/* U+e06a */ { 0, 0, 0, 0, 0 },
/* U+e06b */ { 0, 0, 0, 0, 0 },
/* U+e06c */ { 0, 0, 0, 0, 0 },
/* U+e06d */ { 0, 0, 0, 0, 0 },
/* U+e06e */ { 0, 0, 0, 0, 0 },
/* U+e06f */ { 0, 0, 0, 0, 0 },
/* U+e070 */ { 0, 0, 0, 0, 0 },
/* U+e071 */ { 0, 0, 0, 0, 0 },
/* U+e072 */ { 0, 0, 0, 0, 0 },
/* U+e073 */ { 0, 0, 0, 0, 0 },
/* U+e074 */ { 0, 0, 0, 0, 0 },
/* U+e075 */ { 0, 0, 0, 0, 0 },
/* U+e076 */ { 0, 0, 0, 0, 0 },
/* U+e077 */ { 0, 0, 0, 0, 0 },
/* U+e078 */ { 0, 0, 0, 0, 0 },
/* U+e079 */ { 0, 0, 0, 0, 0 },
/* U+e07a */ { 0, 0, 0, 0, 0 },
/* U+e07b */ { 0, 0, 0, 0, 0 },
/* U+e07c */ { 0, 0, 0, 0, 0 },
/* U+e07d */ { 0, 0, 0, 0, 0 },
/* U+e07e */ { 0, 0, 0, 0, 0 },
/* U+e07f */ { 0, 0, 0, 0, 0 },
/* U+e080 */ { 0, 0, 0, 0, 0 },
/* U+e081 */ { 0, 0, 0, 0, 0 },
/* U+e082 */ { 0, 0, 0, 0, 0 },
/* U+e083 */ { 0, 0, 0, 0, 0 },
/* U+e084 */ { 0, 0, 0, 0, 0 },
/* U+e085 */ { 0, 0, 0, 0, 0 },
/* U+e086 */ { 0, 0, 0, 0, 0 },
/* U+e087 */ { 0, 0, 0, 0, 0 },
/* U+e088 */ { 0, 0, 0, 0, 0 },
/* U+e089 */ { 0, 0, 0, 0, 0 },
/* U+e08a */ { 0, 0, 0, 0, 0 },
/* U+e08b */ { 0, 0, 0, 0, 0 },
/* U+e08c */ { 0, 0, 0, 0, 0 },
/* U+e08d */ { 0, 0, 0, 0, 0 },
/* U+e08e */ { 0, 0, 0, 0, 0 },
/* U+e08f */ { 0, 0, 0, 0, 0 },
/* U+e090 */ { 0, 0, 0, 0, 0 },
/* U+e091 */ { 0, 0, 0, 0, 0 },
/* U+e092 */ { 0, 0, 0, 0, 0 },
/* U+e093 */ { 0, 0, 0, 0, 0 },
/* U+e094 */ { 0, 0, 0, 0, 0 },
/* U+e095 */ { 0, 0, 0, 0, 0 },
/* U+e096 */ { 0, 0, 0, 0, 0 },
/* U+e097 */ { 0, 0, 0, 0, 0 },
/* U+e098 */ { 0, 0, 0, 0, 0 },
/* U+e099 */ { 0, 0, 0, 0, 0 },
/* U+e09a */ { 0, 0, 0, 0, 0 },
/* U+e09b */ { 0, 0, 0, 0, 0 },
/* U+e09c */ { 0, 0, 0, 0, 0 },
/* U+e09d */ { 0, 0, 0, 0, 0 },
/* U+e09e */ { 0, 0, 0, 0, 0 },
/* U+e09f */ { 0, 0, 0, 0, 0 },
/* U+e0a0 */ { 0, 0, 0, 0, 0 },
/* U+e0a1 */ { 0, 0, 0, 0, 0 },
/* U+e0a2 */ { 0, 0, 0, 0, 0 },
/* U+e0a3 */ { 0, 0, 0, 0, 0 },
/* U+e0a4 */ { 0, 0, 0, 0, 0 },
/* U+e0a5 */ { 0, 0, 0, 0, 0 },
/* U+e0a6 */ { 0, 0, 0, 0, 0 },
/* U+e0a7 */ { 0, 0, 0, 0, 0 },
/* U+e0a8 */ { 0, 0, 0, 0, 0 },
/* U+e0a9 */ { 0, 0, 0, 0, 0 },
/* U+e0aa */ { 0, 0, 0, 0, 0 },
/* U+e0ab */ { 0, 0, 0, 0, 0 },
/* U+e0ac */ { 0, 0, 0, 0, 0 },
/* U+e0ad */ { 0, 0, 0, 0, 0 },
/* U+e0ae */ { 0, 0, 0, 0, 0 },
/* U+e0af */ { 0, 0, 0, 0, 0 },
/* U+e0b0 */ { 0, 0, 0, 0, 0 },
/* U+e0b1 */ { 0, 0, 0, 0, 0 },
/* U+e0b2 */ { 0, 0, 0, 0, 0 },
/* U+e0b3 */ { 0, 0, 0, 0, 0 },
/* U+e0b4 */ { 0, 0, 0, 0, 0 },
/* U+e0b5 */ { 0, 0, 0, 0, 0 },
/* U+e0b6 */ { 0, 0, 0, 0, 0 },
/* U+e0b7 */ { 0, 0, 0, 0, 0 },
/* U+e0b8 */ { 0, 0, 0, 0, 0 },
/* U+e0b9 */ { 0, 0, 0, 0, 0 },
/* U+e0ba */ { 0, 0, 0, 0, 0 },
/* U+e0bb */ { 0, 0, 0, 0, 0 },
/* U+e0bc */ { 0, 0, 0, 0, 0 },
/* U+e0bd */ { 0, 0, 0, 0, 0 },
/* U+e0be */ { 0, 0, 0, 0, 0 },
/* U+e0bf */ { 0, 0, 0, 0, 0 },
/* U+e0c0 */ { 0, 0, 0, 0, 0 },
/* U+e0c1 */ { 0, 0, 0, 0, 0 },
/* U+e0c2 */ { 0, 0, 0, 0, 0 },
/* U+e0c3 */ { 0, 0, 0, 0, 0 },
/* U+e0c4 */ { 0, 0, 0, 0, 0 },
/* U+e0c5 */ { 0, 0, 0, 0, 0 },
/* U+e0c6 */ { 0, 0, 0, 0, 0 },
/* U+e0c7 */ { 0, 0, 0, 0, 0 },
/* U+e0c8 */ { 0, 0, 0, 0, 0 },
/* U+e0c9 */ { 0, 0, 0, 0, 0 },
/* U+e0ca */ { 0, 0, 0, 0, 0 },
/* U+e0cb */ { 0, 0, 0, 0, 0 },
/* U+e0cc */ { 0, 0, 0, 0, 0 },
/* U+e0cd */ { 0, 0, 0, 0, 0 },
/* U+e0ce */ { 0, 0, 0, 0, 0 },
/* U+e0cf */ { 0, 0, 0, 0, 0 },
/* U+e0d0 */ { 0, 0, 0, 0, 0 },
/* U+e0d1 */ { 0, 0, 0, 0, 0 },
/* U+e0d2 */ { 0, 0, 0, 0, 0 },
/* U+e0d3 */ { 0, 0, 0, 0, 0 },
/* U+e0d4 */ { 0, 0, 0, 0, 0 },
/* U+e0d5 */ { 0, 0, 0, 0, 0 },
/* U+e0d6 */ { 0, 0, 0, 0, 0 },
/* U+e0d7 */ { 0, 0, 0, 0, 0 },
/* U+e0d8 */ { 0, 0, 0, 0, 0 },
/* U+e0d9 */ { 0, 0, 0, 0, 0 },
/* U+e0da */ { 0, 0, 0, 0, 0 },
/* U+e0db */ { 0, 0, 0, 0, 0 },
/* U+e0dc */ { 0, 0, 0, 0, 0 },
/* U+e0dd */ { 0, 0, 0, 0, 0 },
/* U+e0de */ { 0, 0, 0, 0, 0 },
/* U+e0df */ { 0, 0, 0, 0, 0 },
/* U+e0e0 */ { 0, 0, 0, 0, 0 },
/* U+e0e1 */ { 0, 0, 0, 0, 0 },
/* U+e0e2 */ { 0, 0, 0, 0, 0 },
/* U+e0e3 */ { 0, 0, 0, 0, 0 },
/* U+e0e4 */ { 0, 0, 0, 0, 0 },
/* U+e0e5 */ { 0, 0, 0, 0, 0 },
/* U+e0e6 */ { 0, 0, 0, 0, 0 },
/* U+e0e7 */ { 0, 0, 0, 0, 0 },
/* U+e0e8 */ { 0, 0, 0, 0, 0 },
/* U+e0e9 */ { 0, 0, 0, 0, 0 },
/* U+e0ea */ { 0, 0, 0, 0, 0 },
/* U+e0eb */ { 0, 0, 0, 0, 0 },
/* U+e0ec */ { 0, 0, 0, 0, 0 },
/* U+e0ed */ { 0, 0, 0, 0, 0 },
/* U+e0ee */ { 0, 0, 0, 0, 0 },
/* U+e0ef */ { 0, 0, 0, 0, 0 },
/* U+e0f0 */ { 0, 0, 0, 0, 0 },
/* U+e0f1 */ { 0, 0, 0, 0, 0 },
/* U+e0f2 */ { 0, 0, 0, 0, 0 },
/* U+e0f3 */ { 0, 0, 0, 0, 0 },
/* U+e0f4 */ { 0, 0, 0, 0, 0 },
/* U+e0f5 */ { 0, 0, 0, 0, 0 },
/* U+e0f6 */ { 0, 0, 0, 0, 0 },
/* U+e0f7 */ { 0, 0, 0, 0, 0 },
/* U+e0f8 */ { 0, 0, 0, 0, 0 },
/* U+e0f9 */ { 0, 0, 0, 0, 0 },
/* U+e0fa */ { 0, 0, 0, 0, 0 },
/* U+e0fb */ { 0, 0, 0, 0, 0 },
/* U+e0fc */ { 0, 0, 0, 0, 0 },
/* U+e0fd */ { 0, 0, 0, 0, 0 },
/* U+e0fe */ { 0, 0, 0, 0, 0 },
/* U+e0ff */ { 0, 0, 0, 0, 0 },
/* U+e100 */ { 0, 0, 0, 0, 0 },
/* U+e101 */ { 0, 0, 0, 0, 0 },
/* U+e102 */ { 0, 0, 0, 0, 0 },
/* U+e103 */ { 0, 0, 0, 0, 0 },
/* U+e104 */ { 0, 0, 0, 0, 0 },
/* U+e105 */ { 0, 0, 0, 0, 0 },
/* U+e106 */ { 0, 0, 0, 0, 0 },
/* U+e107 */ { 0, 0, 0, 0, 0 },
/* U+e108 */ { 0, 0, 0, 0, 0 },
/* U+e109 */ { 0, 0, 0, 0, 0 },
/* U+e10a */ { 0, 0, 0, 0, 0 },
/* U+e10b */ { 0, 0, 0, 0, 0 },
/* U+e10c */ { 0, 0, 0, 0, 0 },
/* U+e10d */ { 0, 0, 0, 0, 0 },
/* U+e10e */ { 0, 0, 0, 0, 0 },
/* U+e10f */ { 0, 0, 0, 0, 0 },
/* U+e110 */ { 0, 0, 0, 0, 0 },
/* U+e111 */ { 0, 0, 0, 0, 0 },
/* U+e112 */ { 0, 0, 0, 0, 0 },
/* U+e113 */ { 0, 0, 0, 0, 0 },
/* U+e114 */ { 0, 0, 0, 0, 0 },
/* U+e115 */ { 0, 0, 0, 0, 0 },
/* U+e116 */ { 0, 0, 0, 0, 0 },
/* U+e117 */ { 0, 0, 0, 0, 0 },
/* U+e118 */ { 0, 0, 0, 0, 0 },
/* U+e119 */ { 0, 0, 0, 0, 0 },
/* U+e11a */ { 0, 0, 0, 0, 0 },
/* U+e11b */ { 0, 0, 0, 0, 0 },
/* U+e11c */ { 0, 0, 0, 0, 0 },
/* U+e11d */ { 0, 0, 0, 0, 0 },
/* U+e11e */ { 0, 0, 0, 0, 0 },
/* U+e11f */ { 0, 0, 0, 0, 0 },
/* U+e120 */ { 0, 0, 0, 0, 0 },
/* U+e121 */ { 0, 0, 0, 0, 0 },
/* U+e122 */ { 0, 0, 0, 0, 0 },
/* U+e123 */ { 0, 0, 0, 0, 0 },
/* U+e124 */ { 0, 0, 0, 0, 0 },
/* U+e125 */ { 0, 0, 0, 0, 0 },
/* U+e126 */ { 0, 0, 0, 0, 0 },
/* U+e127 */ { 0, 0, 0, 0, 0 },
/* U+e128 */ { 0, 0, 0, 0, 0 },
/* U+e129 */ { 0, 0, 0, 0, 0 },
/* U+e12a */ { 0, 0, 0, 0, 0 },
/* U+e12b */ { 0, 0, 0, 0, 0 },
/* U+e12c */ { 0, 0, 0, 0, 0 },
/* U+e12d */ { 0, 0, 0, 0, 0 },
/* U+e12e */ { 0, 0, 0, 0, 0 },
/* U+e12f */ { 0, 0, 0, 0, 0 },
/* U+e130 */ { 0, 0, 0, 0, 0 },
/* U+e131 */ { 0, 0, 0, 0, 0 },
/* U+e132 */ { 0, 0, 0, 0, 0 },
/* U+e133 */ { 0, 0, 0, 0, 0 },
/* U+e134 */ { 0, 0, 0, 0, 0 },
/* U+e135 */ { 0, 0, 0, 0, 0 },
/* U+e136 */ { 0, 0, 0, 0, 0 },
/* U+e137 */ { 0, 0, 0, 0, 0 },
/* U+e138 */ { 0, 0, 0, 0, 0 },
/* U+e139 */ { 0, 0, 0, 0, 0 },
/* U+e13a */ { 0, 0, 0, 0, 0 },
/* U+e13b */ { 0, 0, 0, 0, 0 },
/* U+e13c */ { 0, 0, 0, 0, 0 },
/* U+e13d */ { 0, 0, 0, 0, 0 },
/* U+e13e */ { 0, 0, 0, 0, 0 },
/* U+e13f */ { 0, 0, 0, 0, 0 },
/* U+e140 */ { 0, 0, 0, 0, 0 },
/* U+e141 */ { 0, 0, 0, 0, 0 },
/* U+e142 */ { 0, 0, 0, 0, 0 },
/* U+e143 */ { 0, 0, 0, 0, 0 },
/* U+e144 */ { 0, 0, 0, 0, 0 },
/* U+e145 */ { 0, 0, 0, 0, 0 },
/* U+e146 */ { 0, 0, 0, 0, 0 },
/* U+e147 */ { 0, 0, 0, 0, 0 },
/* U+e148 */ { 0, 0, 0, 0, 0 },
/* U+e149 */ { 0, 0, 0, 0, 0 },
/* U+e14a */ { 0, 0, 0, 0, 0 },
/* U+e14b */ { 0, 0, 0, 0, 0 },
/* U+e14c */ { 0, 0, 0, 0, 0 },
/* U+e14d */ { 0, 0, 0, 0, 0 },
/* U+e14e */ { 0, 0, 0, 0, 0 },
/* U+e14f */ { 0, 0, 0, 0, 0 },
/* U+e150 */ { 0, 0, 0, 0, 0 },
/* U+e151 */ { 0, 0, 0, 0, 0 },
/* U+e152 */ { 0, 0, 0, 0, 0 },
/* U+e153 */ { 0, 0, 0, 0, 0 },
/* U+e154 */ { 0, 0, 0, 0, 0 },
/* U+e155 */ { 0, 0, 0, 0, 0 },
/* U+e156 */ { 0, 0, 0, 0, 0 },
/* U+e157 */ { 0, 0, 0, 0, 0 },
/* U+e158 */ { 0, 0, 0, 0, 0 },
/* U+e159 */ { 0, 0, 0, 0, 0 },
/* U+e15a */ { 0, 0, 0, 0, 0 },
/* U+e15b */ { 0, 0, 0, 0, 0 },
/* U+e15c */ { 0, 0, 0, 0, 0 },
/* U+e15d */ { 0, 0, 0, 0, 0 },
/* U+e15e */ { 0, 0, 0, 0, 0 },
/* U+e15f */ { 0, 0, 0, 0, 0 },
/* U+e160 */ { 0, 0, 0, 0, 0 },
/* U+e161 */ { 0, 0, 0, 0, 0 },
/* U+e162 */ { 0, 0, 0, 0, 0 },
/* U+e163 */ { 0, 0, 0, 0, 0 },
/* U+e164 */ { 0, 0, 0, 0, 0 },
/* U+e165 */ { 0, 0, 0, 0, 0 },
/* U+e166 */ { 0, 0, 0, 0, 0 },
/* U+e167 */ { 0, 0, 0, 0, 0 },
/* U+e168 */ { 0, 0, 0, 0, 0 },
/* U+e169 */ { 0, 0, 0, 0, 0 },
/* U+e16a */ { 0, 0, 0, 0, 0 },
/* U+e16b */ { 0, 0, 0, 0, 0 },
/* U+e16c */ { 0, 0, 0, 0, 0 },
/* U+e16d */ { 0, 0, 0, 0, 0 },
/* U+e16e */ { 0, 0, 0, 0, 0 },
/* U+e16f */ { 0, 0, 0, 0, 0 },
/* U+e170 */ { 0, 0, 0, 0, 0 },
/* U+e171 */ { 0, 0, 0, 0, 0 },
/* U+e172 */ { 0, 0, 0, 0, 0 },
/* U+e173 */ { 0, 0, 0, 0, 0 },
/* U+e174 */ { 0, 0, 0, 0, 0 },
/* U+e175 */ { 0, 0, 0, 0, 0 },
/* U+e176 */ { 0, 0, 0, 0, 0 },
/* U+e177 */ { 0, 0, 0, 0, 0 },
/* U+e178 */ { 0, 0, 0, 0, 0 },
/* U+e179 */ { 0, 0, 0, 0, 0 },
/* U+e17a */ { 0, 0, 0, 0, 0 },
/* U+e17b */ { 0, 0, 0, 0, 0 },
/* U+e17c */ { 0, 0, 0, 0, 0 },
/* U+e17d */ { 0, 0, 0, 0, 0 },
/* U+e17e */ { 0, 0, 0, 0, 0 },
/* U+e17f */ { 0, 0, 0, 0, 0 },
/* U+e180 */ { 0, 0, 0, 0, 0 },
/* U+e181 */ { 0, 0, 0, 0, 0 },
/* U+e182 */ { 0, 0, 0, 0, 0 },
/* U+e183 */ { 0, 0, 0, 0, 0 },
/* U+e184 */ { 0, 0, 0, 0, 0 },
/* U+e185 */ { 0, 0, 0, 0, 0 },
/* U+e186 */ { 0, 0, 0, 0, 0 },
/* U+e187 */ { 0, 0, 0, 0, 0 },
/* U+e188 */ { 0, 0, 0, 0, 0 },
/* U+e189 */ { 0, 0, 0, 0, 0 },
/* U+e18a */ { 0, 0, 0, 0, 0 },
/* U+e18b */ { 0, 0, 0, 0, 0 },
/* U+e18c */ { 0, 0, 0, 0, 0 },
/* U+e18d */ { 0, 0, 0, 0, 0 },
/* U+e18e */ { 0, 0, 0, 0, 0 },
/* U+e18f */ { 0, 0, 0, 0, 0 },
/* U+e190 */ { 0, 0, 0, 0, 0 },
/* U+e191 */ { 0, 0, 0, 0, 0 },
/* U+e192 */ { 0, 0, 0, 0, 0 },
/* U+e193 */ { 0, 0, 0, 0, 0 },
/* U+e194 */ { 0, 0, 0, 0, 0 },
/* U+e195 */ { 0, 0, 0, 0, 0 },
/* U+e196 */ { 0, 0, 0, 0, 0 },
/* U+e197 */ { 0, 0, 0, 0, 0 },
/* U+e198 */ { 0, 0, 0, 0, 0 },
/* U+e199 */ { 0, 0, 0, 0, 0 },
/* U+e19a */ { 0, 0, 0, 0, 0 },
/* U+e19b */ { 0, 0, 0, 0, 0 },
/* U+e19c */ { 0, 0, 0, 0, 0 },
/* U+e19d */ { 0, 0, 0, 0, 0 },
/* U+e19e */ { 0, 0, 0, 0, 0 },
/* U+e19f */ { 0, 0, 0, 0, 0 },
/* U+e1a0 */ { 0, 0, 0, 0, 0 },
/* U+e1a1 */ { 0, 0, 0, 0, 0 },
/* U+e1a2 */ { 0, 0, 0, 0, 0 },
/* U+e1a3 */ { 0, 0, 0, 0, 0 },
/* U+e1a4 */ { 0, 0, 0, 0, 0 },
/* U+e1a5 */ { 0, 0, 0, 0, 0 },
/* U+e1a6 */ { 0, 0, 0, 0, 0 },
/* U+e1a7 */ { 0, 0, 0, 0, 0 },
/* U+e1a8 */ { 0, 0, 0, 0, 0 },
/* U+e1a9 */ { 0, 0, 0, 0, 0 },
/* U+e1aa */ { 0, 0, 0, 0, 0 },
/* U+e1ab */ { 0, 0, 0, 0, 0 },
/* U+e1ac */ { 0, 0, 0, 0, 0 },
/* U+e1ad */ { 0, 0, 0, 0, 0 },
/* U+e1ae */ { 0, 0, 0, 0, 0 },
/* U+e1af */ { 0, 0, 0, 0, 0 },
/* U+e1b0 */ { 0, 0, 0, 0, 0 },
/* U+e1b1 */ { 0, 0, 0, 0, 0 },
/* U+e1b2 */ { 0, 0, 0, 0, 0 },
/* U+e1b3 */ { 0, 0, 0, 0, 0 },
/* U+e1b4 */ { 0, 0, 0, 0, 0 },
/* U+e1b5 */ { 0, 0, 0, 0, 0 },
/* U+e1b6 */ { 0, 0, 0, 0, 0 },
/* U+e1b7 */ { 0, 0, 0, 0, 0 },
/* U+e1b8 */ { 0, 0, 0, 0, 0 },
/* U+e1b9 */ { 0, 0, 0, 0, 0 },
/* U+e1ba */ { 0, 0, 0, 0, 0 },
/* U+e1bb */ { 0, 0, 0, 0, 0 },
/* U+e1bc */ { 0, 0, 0, 0, 0 },
/* U+e1bd */ { 0, 0, 0, 0, 0 },
/* U+e1be */ { 0, 0, 0, 0, 0 },
/* U+e1bf */ { 0, 0, 0, 0, 0 },
/* U+e1c0 */ { 0, 0, 0, 0, 0 },
/* U+e1c1 */ { 0, 0, 0, 0, 0 },
/* U+e1c2 */ { 0, 0, 0, 0, 0 },
/* U+e1c3 */ { 0, 0, 0, 0, 0 },
/* U+e1c4 */ { 0, 0, 0, 0, 0 },
/* U+e1c5 */ { 0, 0, 0, 0, 0 },
/* U+e1c6 */ { 0, 0, 0, 0, 0 },
/* U+e1c7 */ { 0, 0, 0, 0, 0 },
/* U+e1c8 */ { 0, 0, 0, 0, 0 },
/* U+e1c9 */ { 0, 0, 0, 0, 0 },
/* U+e1ca */ { 0, 0, 0, 0, 0 },
/* U+e1cb */ { 0, 0, 0, 0, 0 },
/* U+e1cc */ { 0, 0, 0, 0, 0 },
/* U+e1cd */ { 0, 0, 0, 0, 0 },
/* U+e1ce */ { 0, 0, 0, 0, 0 },
/* U+e1cf */ { 0, 0, 0, 0, 0 },
/* U+e1d0 */ { 0, 0, 0, 0, 0 },
/* U+e1d1 */ { 0, 0, 0, 0, 0 },
/* U+e1d2 */ { 0, 0, 0, 0, 0 },
/* U+e1d3 */ { 0, 0, 0, 0, 0 },
/* U+e1d4 */ { 0, 0, 0, 0, 0 },
/* U+e1d5 */ { 0, 0, 0, 0, 0 },
/* U+e1d6 */ { 0, 0, 0, 0, 0 },
/* U+e1d7 */ { 0, 0, 0, 0, 0 },
/* U+e1d8 */ { 0, 0, 0, 0, 0 },
/* U+e1d9 */ { 0, 0, 0, 0, 0 },
/* U+e1da */ { 0, 0, 0, 0, 0 },
/* U+e1db */ { 0, 0, 0, 0, 0 },
/* U+e1dc */ { 0, 0, 0, 0, 0 },
/* U+e1dd */ { 0, 0, 0, 0, 0 },
/* U+e1de */ { 0, 0, 0, 0, 0 },
/* U+e1df */ { 0, 0, 0, 0, 0 },
/* U+e1e0 */ { 0, 0, 0, 0, 0 },
/* U+e1e1 */ { 0, 0, 0, 0, 0 },
/* U+e1e2 */ { 0, 0, 0, 0, 0 },
/* U+e1e3 */ { 0, 0, 0, 0, 0 },
/* U+e1e4 */ { 0, 0, 0, 0, 0 },
/* U+e1e5 */ { 0, 0, 0, 0, 0 },
/* U+e1e6 */ { 0, 0, 0, 0, 0 },
/* U+e1e7 */ { 0, 0, 0, 0, 0 },
/* U+e1e8 */ { 0, 0, 0, 0, 0 },
/* U+e1e9 */ { 0, 0, 0, 0, 0 },
/* U+e1ea */ { 0, 0, 0, 0, 0 },
/* U+e1eb */ { 0, 0, 0, 0, 0 },
/* U+e1ec */ { 0, 0, 0, 0, 0 },
/* U+e1ed */ { 0, 0, 0, 0, 0 },
/* U+e1ee */ { 0, 0, 0, 0, 0 },
/* U+e1ef */ { 0, 0, 0, 0, 0 },
/* U+e1f0 */ { 0, 0, 0, 0, 0 },
/* U+e1f1 */ { 0, 0, 0, 0, 0 },
/* U+e1f2 */ { 0, 0, 0, 0, 0 },
/* U+e1f3 */ { 0, 0, 0, 0, 0 },
/* U+e1f4 */ { 0, 0, 0, 0, 0 },
/* U+e1f5 */ { 0, 0, 0, 0, 0 },
/* U+e1f6 */ { 0, 0, 0, 0, 0 },
/* U+e1f7 */ { 0, 0, 0, 0, 0 },
/* U+e1f8 */ { 0, 0, 0, 0, 0 },
/* U+e1f9 */ { 0, 0, 0, 0, 0 },
/* U+e1fa */ { 0, 0, 0, 0, 0 },
/* U+e1fb */ { 0, 0, 0, 0, 0 },
/* U+e1fc */ { 0, 0, 0, 0, 0 },
/* U+e1fd */ { 0, 0, 0, 0, 0 },
/* U+e1fe */ { 0, 0, 0, 0, 0 },
/* U+e1ff */ { 0, 0, 0, 0, 0 },
/* U+e200 */ { 0, 0, 0, 0, 0 },
/* U+e201 */ { 0, 0, 0, 0, 0 },
/* U+e202 */ { 0, 0, 0, 0, 0 },
/* U+e203 */ { 0, 0, 0, 0, 0 },
/* U+e204 */ { 0, 0, 0, 0, 0 },
/* U+e205 */ { 0, 0, 0, 0, 0 },
/* U+e206 */ { 0, 0, 0, 0, 0 },
/* U+e207 */ { 0, 0, 0, 0, 0 },
/* U+e208 */ { 0, 0, 0, 0, 0 },
/* U+e209 */ { 0, 0, 0, 0, 0 },
/* U+e20a */ { 0, 0, 0, 0, 0 },
/* U+e20b */ { 0, 0, 0, 0, 0 },
/* U+e20c */ { 0, 0, 0, 0, 0 },
/* U+e20d */ { 0, 0, 0, 0, 0 },
/* U+e20e */ { 0, 0, 0, 0, 0 },
/* U+e20f */ { 0, 0, 0, 0, 0 },
/* U+e210 */ { 0, 0, 0, 0, 0 },
/* U+e211 */ { 0, 0, 0, 0, 0 },
/* U+e212 */ { 0, 0, 0, 0, 0 },
/* U+e213 */ { 0, 0, 0, 0, 0 },
/* U+e214 */ { 0, 0, 0, 0, 0 },
/* U+e215 */ { 0, 0, 0, 0, 0 },
/* U+e216 */ { 0, 0, 0, 0, 0 },
/* U+e217 */ { 0, 0, 0, 0, 0 },
/* U+e218 */ { 0, 0, 0, 0, 0 },
/* U+e219 */ { 0, 0, 0, 0, 0 },
/* U+e21a */ { 0, 0, 0, 0, 0 },
/* U+e21b */ { 0, 0, 0, 0, 0 },
/* U+e21c */ { 0, 0, 0, 0, 0 },
/* U+e21d */ { 0, 0, 0, 0, 0 },
/* U+e21e */ { 0, 0, 0, 0, 0 },
/* U+e21f */ { 0, 0, 0, 0, 0 },
/* U+e220 */ { 0, 0, 0, 0, 0 },
/* U+e221 */ { 0, 0, 0, 0, 0 },
/* U+e222 */ { 0, 0, 0, 0, 0 },
/* U+e223 */ { 0, 0, 0, 0, 0 },
/* U+e224 */ { 0, 0, 0, 0, 0 },
/* U+e225 */ { 0, 0, 0, 0, 0 },
/* U+e226 */ { 0, 0, 0, 0, 0 },
/* U+e227 */ { 0, 0, 0, 0, 0 },
/* U+e228 */ { 0, 0, 0, 0, 0 },
/* U+e229 */ { 0, 0, 0, 0, 0 },
/* U+e22a */ { 0, 0, 0, 0, 0 },
/* U+e22b */ { 0, 0, 0, 0, 0 },
/* U+e22c */ { 0, 0, 0, 0, 0 },
/* U+e22d */ { 0, 0, 0, 0, 0 },
/* U+e22e */ { 0, 0, 0, 0, 0 },
/* U+e22f */ { 0, 0, 0, 0, 0 },
/* U+e230 */ { 0, 0, 0, 0, 0 },
/* U+e231 */ { 0, 0, 0, 0, 0 },
/* U+e232 */ { 0, 0, 0, 0, 0 },
/* U+e233 */ { 0, 0, 0, 0, 0 },
/* U+e234 */ { 0, 0, 0, 0, 0 },
/* U+e235 */ { 0, 0, 0, 0, 0 },
/* U+e236 */ { 0, 0, 0, 0, 0 },
/* U+e237 */ { 0, 0, 0, 0, 0 },
/* U+e238 */ { 0, 0, 0, 0, 0 },
/* U+e239 */ { 0, 0, 0, 0, 0 },
/* U+e23a */ { 0, 0, 0, 0, 0 },
/* U+e23b */ { 0, 0, 0, 0, 0 },
/* U+e23c */ { 0, 0, 0, 0, 0 },
/* U+e23d */ { 0, 0, 0, 0, 0 },
/* U+e23e */ { 0, 0, 0, 0, 0 },
/* U+e23f */ { 0, 0, 0, 0, 0 },
/* U+e240 */ { 0, 0, 0, 0, 0 },
/* U+e241 */ { 0, 0, 0, 0, 0 },
/* U+e242 */ { 0, 0, 0, 0, 0 },
/* U+e243 */ { 0, 0, 0, 0, 0 },
/* U+e244 */ { 0, 0, 0, 0, 0 },
/* U+e245 */ { 0, 0, 0, 0, 0 },
/* U+e246 */ { 0, 0, 0, 0, 0 },
/* U+e247 */ { 0, 0, 0, 0, 0 },
/* U+e248 */ { 0, 0, 0, 0, 0 },
/* U+e249 */ { 0, 0, 0, 0, 0 },
/* U+e24a */ { 0, 0, 0, 0, 0 },
/* U+e24b */ { 0, 0, 0, 0, 0 },
/* U+e24c */ { 0, 0, 0, 0, 0 },
/* U+e24d */ { 0, 0, 0, 0, 0 },
/* U+e24e */ { 0, 0, 0, 0, 0 },
/* U+e24f */ { 0, 0, 0, 0, 0 },
/* U+e250 */ { 0, 0, 0, 0, 0 },
/* U+e251 */ { 0, 0, 0, 0, 0 },
/* U+e252 */ { 0, 0, 0, 0, 0 },
/* U+e253 */ { 0, 0, 0, 0, 0 },
/* U+e254 */ { 0, 0, 0, 0, 0 },
/* U+e255 */ { 0, 0, 0, 0, 0 },
/* U+e256 */ { 0, 0, 0, 0, 0 },
/* U+e257 */ { 0, 0, 0, 0, 0 },
/* U+e258 */ { 0, 0, 0, 0, 0 },
/* U+e259 */ { 0, 0, 0, 0, 0 },
/* U+e25a */ { 0, 0, 0, 0, 0 },
/* U+e25b */ { 0, 0, 0, 0, 0 },
/* U+e25c */ { 0, 0, 0, 0, 0 },
/* U+e25d */ { 0, 0, 0, 0, 0 },
/* U+e25e */ { 0, 0, 0, 0, 0 },
/* U+e25f */ { 0, 0, 0, 0, 0 },
/* U+e260 */ { 0, 0, 0, 0, 0 },
/* U+e261 */ { 0, 0, 0, 0, 0 },
/* U+e262 */ { 0, 0, 0, 0, 0 },
/* U+e263 */ { 0, 0, 0, 0, 0 },
/* U+e264 */ { 0, 0, 0, 0, 0 },
/* U+e265 */ { 0, 0, 0, 0, 0 },
/* U+e266 */ { 0, 0, 0, 0, 0 },
/* U+e267 */ { 0, 0, 0, 0, 0 },
/* U+e268 */ { 0, 0, 0, 0, 0 },
/* U+e269 */ { 0, 0, 0, 0, 0 },
/* U+e26a */ { 0, 0, 0, 0, 0 },
/* U+e26b */ { 0, 0, 0, 0, 0 },
/* U+e26c */ { 0, 0, 0, 0, 0 },
/* U+e26d */ { 0, 0, 0, 0, 0 },
/* U+e26e */ { 0, 0, 0, 0, 0 },
/* U+e26f */ { 0, 0, 0, 0, 0 },
/* U+e270 */ { 0, 0, 0, 0, 0 },
/* U+e271 */ { 0, 0, 0, 0, 0 },
/* U+e272 */ { 0, 0, 0, 0, 0 },
/* U+e273 */ { 0, 0, 0, 0, 0 },
/* U+e274 */ { 0, 0, 0, 0, 0 },
/* U+e275 */ { 0, 0, 0, 0, 0 },
/* U+e276 */ { 0, 0, 0, 0, 0 },
/* U+e277 */ { 0, 0, 0, 0, 0 },
/* U+e278 */ { 0, 0, 0, 0, 0 },
/* U+e279 */ { 0, 0, 0, 0, 0 },
/* U+e27a */ { 0, 0, 0, 0, 0 },
/* U+e27b */ { 0, 0, 0, 0, 0 },
/* U+e27c */ { 0, 0, 0, 0, 0 },
/* U+e27d */ { 0, 0, 0, 0, 0 },
/* U+e27e */ { 0, 0, 0, 0, 0 },
/* U+e27f */ { 0, 0, 0, 0, 0 },
/* U+e280 */ { 0, 0, 0, 0, 0 },
/* U+e281 */ { 0, 0, 0, 0, 0 },
/* U+e282 */ { 0, 0, 0, 0, 0 },
/* U+e283 */ { 0, 0, 0, 0, 0 },
/* U+e284 */ { 0, 0, 0, 0, 0 },
/* U+e285 */ { 0, 0, 0, 0, 0 },
/* U+e286 */ { 0, 0, 0, 0, 0 },
/* U+e287 */ { 0, 0, 0, 0, 0 },
/* U+e288 */ { 0, 0, 0, 0, 0 },
/* U+e289 */ { 0, 0, 0, 0, 0 },
/* U+e28a */ { 0, 0, 0, 0, 0 },
/* U+e28b */ { 0, 0, 0, 0, 0 },
/* U+e28c */ { 0, 0, 0, 0, 0 },
/* U+e28d */ { 0, 0, 0, 0, 0 },
/* U+e28e */ { 0, 0, 0, 0, 0 },
/* U+e28f */ { 0, 0, 0, 0, 0 },
/* U+e290 */ { 0, 0, 0, 0, 0 },
/* U+e291 */ { 0, 0, 0, 0, 0 },
/* U+e292 */ { 0, 0, 0, 0, 0 },
/* U+e293 */ { 0, 0, 0, 0, 0 },
/* U+e294 */ { 0, 0, 0, 0, 0 },
/* U+e295 */ { 0, 0, 0, 0, 0 },
/* U+e296 */ { 0, 0, 0, 0, 0 },
/* U+e297 */ { 0, 0, 0, 0, 0 },
/* U+e298 */ { 0, 0, 0, 0, 0 },
/* U+e299 */ { 0, 0, 0, 0, 0 },
/* U+e29a */ { 0, 0, 0, 0, 0 },
/* U+e29b */ { 0, 0, 0, 0, 0 },
/* U+e29c */ { 0, 0, 0, 0, 0 },
/* U+e29d */ { 0, 0, 0, 0, 0 },
/* U+e29e */ { 0, 0, 0, 0, 0 },
/* U+e29f */ { 0, 0, 0, 0, 0 },
/* U+e2a0 */ { 0, 0, 0, 0, 0 },
/* U+e2a1 */ { 0, 0, 0, 0, 0 },
/* U+e2a2 */ { 0, 0, 0, 0, 0 },
/* U+e2a3 */ { 0, 0, 0, 0, 0 },
/* U+e2a4 */ { 0, 0, 0, 0, 0 },
/* U+e2a5 */ { 0, 0, 0, 0, 0 },
/* U+e2a6 */ { 0, 0, 0, 0, 0 },
/* U+e2a7 */ { 0, 0, 0, 0, 0 },
/* U+e2a8 */ { 0, 0, 0, 0, 0 },
/* U+e2a9 */ { 0, 0, 0, 0, 0 },
/* U+e2aa */ { 0, 0, 0, 0, 0 },
/* U+e2ab */ { 0, 0, 0, 0, 0 },
/* U+e2ac */ { 0, 0, 0, 0, 0 },
/* U+e2ad */ { 0, 0, 0, 0, 0 },
/* U+e2ae */ { 0, 0, 0, 0, 0 },
/* U+e2af */ { 0, 0, 0, 0, 0 },
/* U+e2b0 */ { 0, 0, 0, 0, 0 },
/* U+e2b1 */ { 0, 0, 0, 0, 0 },
/* U+e2b2 */ { 0, 0, 0, 0, 0 },
/* U+e2b3 */ { 0, 0, 0, 0, 0 },
/* U+e2b4 */ { 0, 0, 0, 0, 0 },
/* U+e2b5 */ { 0, 0, 0, 0, 0 },
/* U+e2b6 */ { 0, 0, 0, 0, 0 },
/* U+e2b7 */ { 0, 0, 0, 0, 0 },
/* U+e2b8 */ { 0, 0, 0, 0, 0 },
/* U+e2b9 */ { 0, 0, 0, 0, 0 },
/* U+e2ba */ { 0, 0, 0, 0, 0 },
/* U+e2bb */ { 0, 0, 0, 0, 0 },
/* U+e2bc */ { 0, 0, 0, 0, 0 },
/* U+e2bd */ { 0, 0, 0, 0, 0 },
/* U+e2be */ { 0, 0, 0, 0, 0 },
/* U+e2bf */ { 0, 0, 0, 0, 0 },
/* U+e2c0 */ { 0, 0, 0, 0, 0 },
/* U+e2c1 */ { 0, 0, 0, 0, 0 },
/* U+e2c2 */ { 0, 0, 0, 0, 0 },
/* U+e2c3 */ { 0, 0, 0, 0, 0 },
/* U+e2c4 */ { 0, 0, 0, 0, 0 },
/* U+e2c5 */ { 0, 0, 0, 0, 0 },
/* U+e2c6 */ { 0, 0, 0, 0, 0 },
/* U+e2c7 */ { 0, 0, 0, 0, 0 },
/* U+e2c8 */ { 0, 0, 0, 0, 0 },
/* U+e2c9 */ { 0, 0, 0, 0, 0 },
/* U+e2ca */ { 0, 0, 0, 0, 0 },
/* U+e2cb */ { 0, 0, 0, 0, 0 },
/* U+e2cc */ { 0, 0, 0, 0, 0 },
/* U+e2cd */ { 0, 0, 0, 0, 0 },
/* U+e2ce */ { 0, 0, 0, 0, 0 },
/* U+e2cf */ { 0, 0, 0, 0, 0 },
/* U+e2d0 */ { 0, 0, 0, 0, 0 },
/* U+e2d1 */ { 0, 0, 0, 0, 0 },
/* U+e2d2 */ { 0, 0, 0, 0, 0 },
/* U+e2d3 */ { 0, 0, 0, 0, 0 },
/* U+e2d4 */ { 0, 0, 0, 0, 0 },
/* U+e2d5 */ { 0, 0, 0, 0, 0 },
/* U+e2d6 */ { 0, 0, 0, 0, 0 },
/* U+e2d7 */ { 0, 0, 0, 0, 0 },
/* U+e2d8 */ { 0, 0, 0, 0, 0 },
/* U+e2d9 */ { 0, 0, 0, 0, 0 },
/* U+e2da */ { 0, 0, 0, 0, 0 },
/* U+e2db */ { 0, 0, 0, 0, 0 },
/* U+e2dc */ { 0, 0, 0, 0, 0 },
/* U+e2dd */ { 0, 0, 0, 0, 0 },
/* U+e2de */ { 0, 0, 0, 0, 0 },
/* U+e2df */ { 0, 0, 0, 0, 0 },
/* U+e2e0 */ { 0, 0, 0, 0, 0 },
/* U+e2e1 */ { 0, 0, 0, 0, 0 },
/* U+e2e2 */ { 0, 0, 0, 0, 0 },
/* U+e2e3 */ { 0, 0, 0, 0, 0 },
/* U+e2e4 */ { 0, 0, 0, 0, 0 },
/* U+e2e5 */ { 0, 0, 0, 0, 0 },
/* U+e2e6 */ { 0, 0, 0, 0, 0 },
/* U+e2e7 */ { 0, 0, 0, 0, 0 },
/* U+e2e8 */ { 0, 0, 0, 0, 0 },
/* U+e2e9 */ { 0, 0, 0, 0, 0 },
/* U+e2ea */ { 0, 0, 0, 0, 0 },
/* U+e2eb */ { 0, 0, 0, 0, 0 },
/* U+e2ec */ { 0, 0, 0, 0, 0 },
/* U+e2ed */ { 0, 0, 0, 0, 0 },
/* U+e2ee */ { 0, 0, 0, 0, 0 },
/* U+e2ef */ { 0, 0, 0, 0, 0 },
/* U+e2f0 */ { 0, 0, 0, 0, 0 },
/* U+e2f1 */ { 0, 0, 0, 0, 0 },
/* U+e2f2 */ { 0, 0, 0, 0, 0 },
/* U+e2f3 */ { 0, 0, 0, 0, 0 },
/* U+e2f4 */ { 0, 0, 0, 0, 0 },
/* U+e2f5 */ { 0, 0, 0, 0, 0 },
/* U+e2f6 */ { 0, 0, 0, 0, 0 },
/* U+e2f7 */ { 0, 0, 0, 0, 0 },
/* U+e2f8 */ { 0, 0, 0, 0, 0 },
/* U+e2f9 */ { 0, 0, 0, 0, 0 },
/* U+e2fa */ { 0, 0, 0, 0, 0 },
/* U+e2fb */ { 0, 0, 0, 0, 0 },
/* U+e2fc */ { 0, 0, 0, 0, 0 },
/* U+e2fd */ { 0, 0, 0, 0, 0 },
/* U+e2fe */ { 0, 0, 0, 0, 0 },
/* U+e2ff */ { 0, 0, 0, 0, 0 },
/* U+e300 */ { 0, 0, 0, 0, 0 },
/* U+e301 */ { 0, 0, 0, 0, 0 },
/* U+e302 */ { 0, 0, 0, 0, 0 },
/* U+e303 */ { 0, 0, 0, 0, 0 },
/* U+e304 */ { 0, 0, 0, 0, 0 },
/* U+e305 */ { 0, 0, 0, 0, 0 },
/* U+e306 */ { 0, 0, 0, 0, 0 },
/* U+e307 */ { 0, 0, 0, 0, 0 },
/* U+e308 */ { 0, 0, 0, 0, 0 },
/* U+e309 */ { 0, 0, 0, 0, 0 },
/* U+e30a */ { 0, 0, 0, 0, 0 },
/* U+e30b */ { 0, 0, 0, 0, 0 },
/* U+e30c */ { 0, 0, 0, 0, 0 },
/* U+e30d */ { 0, 0, 0, 0, 0 },
/* U+e30e */ { 0, 0, 0, 0, 0 },
/* U+e30f */ { 0, 0, 0, 0, 0 },
/* U+e310 */ { 0, 0, 0, 0, 0 },
/* U+e311 */ { 0, 0, 0, 0, 0 },
/* U+e312 */ { 0, 0, 0, 0, 0 },
/* U+e313 */ { 0, 0, 0, 0, 0 },
/* U+e314 */ { 0, 0, 0, 0, 0 },
/* U+e315 */ { 0, 0, 0, 0, 0 },
/* U+e316 */ { 0, 0, 0, 0, 0 },
/* U+e317 */ { 0, 0, 0, 0, 0 },
/* U+e318 */ { 0, 0, 0, 0, 0 },
/* U+e319 */ { 0, 0, 0, 0, 0 },
/* U+e31a */ { 0, 0, 0, 0, 0 },
/* U+e31b */ { 0, 0, 0, 0, 0 },
/* U+e31c */ { 0, 0, 0, 0, 0 },
/* U+e31d */ { 0, 0, 0, 0, 0 },
/* U+e31e */ { 0, 0, 0, 0, 0 },
/* U+e31f */ { 0, 0, 0, 0, 0 },
/* U+e320 */ { 0, 0, 0, 0, 0 },
/* U+e321 */ { 0, 0, 0, 0, 0 },
/* U+e322 */ { 0, 0, 0, 0, 0 },
/* U+e323 */ { 0, 0, 0, 0, 0 },
/* U+e324 */ { 0, 0, 0, 0, 0 },
/* U+e325 */ { 0, 0, 0, 0, 0 },
/* U+e326 */ { 0, 0, 0, 0, 0 },
/* U+e327 */ { 0, 0, 0, 0, 0 },
/* U+e328 */ { 0, 0, 0, 0, 0 },
/* U+e329 */ { 0, 0, 0, 0, 0 },
/* U+e32a */ { 0, 0, 0, 0, 0 },
/* U+e32b */ { 0, 0, 0, 0, 0 },
/* U+e32c */ { 0, 0, 0, 0, 0 },
/* U+e32d */ { 0, 0, 0, 0, 0 },
/* U+e32e */ { 0, 0, 0, 0, 0 },
/* U+e32f */ { 0, 0, 0, 0, 0 },
/* U+e330 */ { 0, 0, 0, 0, 0 },
/* U+e331 */ { 0, 0, 0, 0, 0 },
/* U+e332 */ { 0, 0, 0, 0, 0 },
/* U+e333 */ { 0, 0, 0, 0, 0 },
/* U+e334 */ { 0, 0, 0, 0, 0 },
/* U+e335 */ { 0, 0, 0, 0, 0 },
/* U+e336 */ { 0, 0, 0, 0, 0 },
/* U+e337 */ { 0, 0, 0, 0, 0 },
/* U+e338 */ { 0, 0, 0, 0, 0 },
/* U+e339 */ { 0, 0, 0, 0, 0 },
/* U+e33a */ { 0, 0, 0, 0, 0 },
/* U+e33b */ { 0, 0, 0, 0, 0 },
/* U+e33c */ { 0, 0, 0, 0, 0 },
/* U+e33d */ { 0, 0, 0, 0, 0 },
/* U+e33e */ { 0, 0, 0, 0, 0 },
/* U+e33f */ { 0, 0, 0, 0, 0 },
/* U+e340 */ { 0, 0, 0, 0, 0 },
/* U+e341 */ { 0, 0, 0, 0, 0 },
/* U+e342 */ { 0, 0, 0, 0, 0 },
/* U+e343 */ { 0, 0, 0, 0, 0 },
/* U+e344 */ { 0, 0, 0, 0, 0 },
/* U+e345 */ { 0, 0, 0, 0, 0 },
/* U+e346 */ { 0, 0, 0, 0, 0 },
/* U+e347 */ { 0, 0, 0, 0, 0 },
/* U+e348 */ { 0, 0, 0, 0, 0 },
/* U+e349 */ { 0, 0, 0, 0, 0 },
/* U+e34a */ { 0, 0, 0, 0, 0 },
/* U+e34b */ { 0, 0, 0, 0, 0 },
/* U+e34c */ { 0, 0, 0, 0, 0 },
/* U+e34d */ { 0, 0, 0, 0, 0 },
/* U+e34e */ { 0, 0, 0, 0, 0 },
/* U+e34f */ { 0, 0, 0, 0, 0 },
/* U+e350 */ { 0, 0, 0, 0, 0 },
/* U+e351 */ { 0, 0, 0, 0, 0 },
/* U+e352 */ { 0, 0, 0, 0, 0 },
/* U+e353 */ { 0, 0, 0, 0, 0 },
/* U+e354 */ { 0, 0, 0, 0, 0 },
/* U+e355 */ { 0, 0, 0, 0, 0 },
/* U+e356 */ { 0, 0, 0, 0, 0 },
/* U+e357 */ { 0, 0, 0, 0, 0 },
/* U+e358 */ { 0, 0, 0, 0, 0 },
/* U+e359 */ { 0, 0, 0, 0, 0 },
/* U+e35a */ { 0, 0, 0, 0, 0 },
/* U+e35b */ { 0, 0, 0, 0, 0 },
/* U+e35c */ { 0, 0, 0, 0, 0 },
/* U+e35d */ { 0, 0, 0, 0, 0 },
/* U+e35e */ { 0, 0, 0, 0, 0 },
/* U+e35f */ { 0, 0, 0, 0, 0 },
/* U+e360 */ { 0, 0, 0, 0, 0 },
/* U+e361 */ { 0, 0, 0, 0, 0 },
/* U+e362 */ { 0, 0, 0, 0, 0 },
/* U+e363 */ { 0, 0, 0, 0, 0 },
/* U+e364 */ { 0, 0, 0, 0, 0 },
/* U+e365 */ { 0, 0, 0, 0, 0 },
/* U+e366 */ { 0, 0, 0, 0, 0 },
/* U+e367 */ { 0, 0, 0, 0, 0 },
/* U+e368 */ { 0, 0, 0, 0, 0 },
/* U+e369 */ { 0, 0, 0, 0, 0 },
/* U+e36a */ { 0, 0, 0, 0, 0 },
/* U+e36b */ { 0, 0, 0, 0, 0 },
/* U+e36c */ { 0, 0, 0, 0, 0 },
/* U+e36d */ { 0, 0, 0, 0, 0 },
/* U+e36e */ { 0, 0, 0, 0, 0 },
/* U+e36f */ { 0, 0, 0, 0, 0 },
/* U+e370 */ { 0, 0, 0, 0, 0 },
/* U+e371 */ { 0, 0, 0, 0, 0 },
/* U+e372 */ { 0, 0, 0, 0, 0 },
/* U+e373 */ { 0, 0, 0, 0, 0 },
/* U+e374 */ { 0, 0, 0, 0, 0 },
/* U+e375 */ { 0, 0, 0, 0, 0 },
/* U+e376 */ { 0, 0, 0, 0, 0 },
/* U+e377 */ { 0, 0, 0, 0, 0 },
/* U+e378 */ { 0, 0, 0, 0, 0 },
/* U+e379 */ { 0, 0, 0, 0, 0 },
/* U+e37a */ { 0, 0, 0, 0, 0 },
/* U+e37b */ { 0, 0, 0, 0, 0 },
/* U+e37c */ { 0, 0, 0, 0, 0 },
/* U+e37d */ { 0, 0, 0, 0, 0 },
/* U+e37e */ { 0, 0, 0, 0, 0 },
/* U+e37f */ { 0, 0, 0, 0, 0 },
/* U+e380 */ { 0, 0, 0, 0, 0 },
/* U+e381 */ { 0, 0, 0, 0, 0 },
/* U+e382 */ { 0, 0, 0, 0, 0 },
/* U+e383 */ { 0, 0, 0, 0, 0 },
/* U+e384 */ { 0, 0, 0, 0, 0 },
/* U+e385 */ { 0, 0, 0, 0, 0 },
/* U+e386 */ { 0, 0, 0, 0, 0 },
/* U+e387 */ { 0, 0, 0, 0, 0 },
/* U+e388 */ { 0, 0, 0, 0, 0 },
/* U+e389 */ { 0, 0, 0, 0, 0 },
/* U+e38a */ { 0, 0, 0, 0, 0 },
/* U+e38b */ { 0, 0, 0, 0, 0 },
/* U+e38c */ { 0, 0, 0, 0, 0 },
/* U+e38d */ { 0, 0, 0, 0, 0 },
/* U+e38e */ { 0, 0, 0, 0, 0 },
/* U+e38f */ { 0, 0, 0, 0, 0 },
/* U+e390 */ { 0, 0, 0, 0, 0 },
/* U+e391 */ { 0, 0, 0, 0, 0 },
/* U+e392 */ { 0, 0, 0, 0, 0 },
/* U+e393 */ { 0, 0, 0, 0, 0 },
/* U+e394 */ { 0, 0, 0, 0, 0 },
/* U+e395 */ { 0, 0, 0, 0, 0 },
/* U+e396 */ { 0, 0, 0, 0, 0 },
/* U+e397 */ { 0, 0, 0, 0, 0 },
/* U+e398 */ { 0, 0, 0, 0, 0 },
/* U+e399 */ { 0, 0, 0, 0, 0 },
/* U+e39a */ { 0, 0, 0, 0, 0 },
/* U+e39b */ { 0, 0, 0, 0, 0 },
/* U+e39c */ { 0, 0, 0, 0, 0 },
/* U+e39d */ { 0, 0, 0, 0, 0 },
/* U+e39e */ { 0, 0, 0, 0, 0 },
/* U+e39f */ { 0, 0, 0, 0, 0 },
/* U+e3a0 */ { 0, 0, 0, 0, 0 },
/* U+e3a1 */ { 0, 0, 0, 0, 0 },
/* U+e3a2 */ { 0, 0, 0, 0, 0 },
/* U+e3a3 */ { 0, 0, 0, 0, 0 },
/* U+e3a4 */ { 0, 0, 0, 0, 0 },
/* U+e3a5 */ { 0, 0, 0, 0, 0 },
/* U+e3a6 */ { 0, 0, 0, 0, 0 },
/* U+e3a7 */ { 0, 0, 0, 0, 0 },
/* U+e3a8 */ { 0, 0, 0, 0, 0 },
/* U+e3a9 */ { 0, 0, 0, 0, 0 },
/* U+e3aa */ { 0, 0, 0, 0, 0 },
/* U+e3ab */ { 0, 0, 0, 0, 0 },
/* U+e3ac */ { 0, 0, 0, 0, 0 },
/* U+e3ad */ { 0, 0, 0, 0, 0 },
/* U+e3ae */ { 0, 0, 0, 0, 0 },
/* U+e3af */ { 0, 0, 0, 0, 0 },
/* U+e3b0 */ { 0, 0, 0, 0, 0 },
/* U+e3b1 */ { 0, 0, 0, 0, 0 },
/* U+e3b2 */ { 0, 0, 0, 0, 0 },
/* U+e3b3 */ { 0, 0, 0, 0, 0 },
/* U+e3b4 */ { 0, 0, 0, 0, 0 },
/* U+e3b5 */ { 0, 0, 0, 0, 0 },
/* U+e3b6 */ { 0, 0, 0, 0, 0 },
/* U+e3b7 */ { 0, 0, 0, 0, 0 },
/* U+e3b8 */ { 0, 0, 0, 0, 0 },
/* U+e3b9 */ { 0, 0, 0, 0, 0 },
/* U+e3ba */ { 0, 0, 0, 0, 0 },
/* U+e3bb */ { 0, 0, 0, 0, 0 },
/* U+e3bc */ { 0, 0, 0, 0, 0 },
/* U+e3bd */ { 0, 0, 0, 0, 0 },
/* U+e3be */ { 0, 0, 0, 0, 0 },
/* U+e3bf */ { 0, 0, 0, 0, 0 },
/* U+e3c0 */ { 0, 0, 0, 0, 0 },
/* U+e3c1 */ { 0, 0, 0, 0, 0 },
/* U+e3c2 */ { 0, 0, 0, 0, 0 },
/* U+e3c3 */ { 0, 0, 0, 0, 0 },
/* U+e3c4 */ { 0, 0, 0, 0, 0 },
/* U+e3c5 */ { 0, 0, 0, 0, 0 },
/* U+e3c6 */ { 0, 0, 0, 0, 0 },
/* U+e3c7 */ { 0, 0, 0, 0, 0 },
/* U+e3c8 */ { 0, 0, 0, 0, 0 },
/* U+e3c9 */ { 0, 0, 0, 0, 0 },
/* U+e3ca */ { 0, 0, 0, 0, 0 },
/* U+e3cb */ { 0, 0, 0, 0, 0 },
/* U+e3cc */ { 0, 0, 0, 0, 0 },
/* U+e3cd */ { 0, 0, 0, 0, 0 },
/* U+e3ce */ { 0, 0, 0, 0, 0 },
/* U+e3cf */ { 0, 0, 0, 0, 0 },
/* U+e3d0 */ { 0, 0, 0, 0, 0 },
/* U+e3d1 */ { 0, 0, 0, 0, 0 },
/* U+e3d2 */ { 0, 0, 0, 0, 0 },
/* U+e3d3 */ { 0, 0, 0, 0, 0 },
/* U+e3d4 */ { 0, 0, 0, 0, 0 },
/* U+e3d5 */ { 0, 0, 0, 0, 0 },
/* U+e3d6 */ { 0, 0, 0, 0, 0 },
/* U+e3d7 */ { 0, 0, 0, 0, 0 },
/* U+e3d8 */ { 0, 0, 0, 0, 0 },
/* U+e3d9 */ { 0, 0, 0, 0, 0 },
/* U+e3da */ { 0, 0, 0, 0, 0 },
/* U+e3db */ { 0, 0, 0, 0, 0 },
/* U+e3dc */ { 0, 0, 0, 0, 0 },
/* U+e3dd */ { 0, 0, 0, 0, 0 },
/* U+e3de */ { 0, 0, 0, 0, 0 },
/* U+e3df */ { 0, 0, 0, 0, 0 },
/* U+e3e0 */ { 0, 0, 0, 0, 0 },
/* U+e3e1 */ { 0, 0, 0, 0, 0 },
/* U+e3e2 */ { 0, 0, 0, 0, 0 },
/* U+e3e3 */ { 0, 0, 0, 0, 0 },
/* U+e3e4 */ { 0, 0, 0, 0, 0 },
/* U+e3e5 */ { 0, 0, 0, 0, 0 },
/* U+e3e6 */ { 0, 0, 0, 0, 0 },
/* U+e3e7 */ { 0, 0, 0, 0, 0 },
/* U+e3e8 */ { 0, 0, 0, 0, 0 },
/* U+e3e9 */ { 0, 0, 0, 0, 0 },
/* U+e3ea */ { 0, 0, 0, 0, 0 },
/* U+e3eb */ { 0, 0, 0, 0, 0 },
/* U+e3ec */ { 0, 0, 0, 0, 0 },
/* U+e3ed */ { 0, 0, 0, 0, 0 },
/* U+e3ee */ { 0, 0, 0, 0, 0 },
/* U+e3ef */ { 0, 0, 0, 0, 0 },
/* U+e3f0 */ { 0, 0, 0, 0, 0 },
/* U+e3f1 */ { 0, 0, 0, 0, 0 },
/* U+e3f2 */ { 0, 0, 0, 0, 0 },
/* U+e3f3 */ { 0, 0, 0, 0, 0 },
/* U+e3f4 */ { 0, 0, 0, 0, 0 },
/* U+e3f5 */ { 0, 0, 0, 0, 0 },
/* U+e3f6 */ { 0, 0, 0, 0, 0 },
/* U+e3f7 */ { 0, 0, 0, 0, 0 },
/* U+e3f8 */ { 0, 0, 0, 0, 0 },
/* U+e3f9 */ { 0, 0, 0, 0, 0 },
/* U+e3fa */ { 0, 0, 0, 0, 0 },
/* U+e3fb */ { 0, 0, 0, 0, 0 },
/* U+e3fc */ { 0, 0, 0, 0, 0 },
/* U+e3fd */ { 0, 0, 0, 0, 0 },
/* U+e3fe */ { 0, 0, 0, 0, 0 },
/* U+e3ff */ { 0, 0, 0, 0, 0 },
/* U+e400 */ { 0, 0, 0, 0, 0 },
/* U+e401 */ { 0, 0, 0, 0, 0 },
/* U+e402 */ { 0, 0, 0, 0, 0 },
/* U+e403 */ { 0, 0, 0, 0, 0 },
/* U+e404 */ { 0, 0, 0, 0, 0 },
/* U+e405 */ { 0, 0, 0, 0, 0 },
/* U+e406 */ { 0, 0, 0, 0, 0 },
/* U+e407 */ { 0, 0, 0, 0, 0 },
/* U+e408 */ { 0, 0, 0, 0, 0 },
/* U+e409 */ { 0, 0, 0, 0, 0 },
/* U+e40a */ { 0, 0, 0, 0, 0 },
/* U+e40b */ { 0, 0, 0, 0, 0 },
/* U+e40c */ { 0, 0, 0, 0, 0 },
/* U+e40d */ { 0, 0, 0, 0, 0 },
/* U+e40e */ { 0, 0, 0, 0, 0 },
/* U+e40f */ { 0, 0, 0, 0, 0 },
/* U+e410 */ { 0, 0, 0, 0, 0 },
/* U+e411 */ { 0, 0, 0, 0, 0 },
/* U+e412 */ { 0, 0, 0, 0, 0 },
/* U+e413 */ { 0, 0, 0, 0, 0 },
/* U+e414 */ { 0, 0, 0, 0, 0 },
/* U+e415 */ { 0, 0, 0, 0, 0 },
/* U+e416 */ { 0, 0, 0, 0, 0 },
/* U+e417 */ { 0, 0, 0, 0, 0 },
/* U+e418 */ { 0, 0, 0, 0, 0 },
/* U+e419 */ { 0, 0, 0, 0, 0 },
/* U+e41a */ { 0, 0, 0, 0, 0 },
/* U+e41b */ { 0, 0, 0, 0, 0 },
/* U+e41c */ { 0, 0, 0, 0, 0 },
/* U+e41d */ { 0, 0, 0, 0, 0 },
/* U+e41e */ { 0, 0, 0, 0, 0 },
/* U+e41f */ { 0, 0, 0, 0, 0 },
/* U+e420 */ { 0, 0, 0, 0, 0 },
/* U+e421 */ { 0, 0, 0, 0, 0 },
/* U+e422 */ { 0, 0, 0, 0, 0 },
/* U+e423 */ { 0, 0, 0, 0, 0 },
/* U+e424 */ { 0, 0, 0, 0, 0 },
/* U+e425 */ { 0, 0, 0, 0, 0 },
/* U+e426 */ { 0, 0, 0, 0, 0 },
/* U+e427 */ { 0, 0, 0, 0, 0 },
/* U+e428 */ { 0, 0, 0, 0, 0 },
/* U+e429 */ { 0, 0, 0, 0, 0 },
/* U+e42a */ { 0, 0, 0, 0, 0 },
/* U+e42b */ { 0, 0, 0, 0, 0 },
/* U+e42c */ { 0, 0, 0, 0, 0 },
/* U+e42d */ { 0, 0, 0, 0, 0 },
/* U+e42e */ { 0, 0, 0, 0, 0 },
/* U+e42f */ { 0, 0, 0, 0, 0 },
/* U+e430 */ { 0, 0, 0, 0, 0 },
/* U+e431 */ { 0, 0, 0, 0, 0 },
/* U+e432 */ { 0, 0, 0, 0, 0 },
/* U+e433 */ { 0, 0, 0, 0, 0 },
/* U+e434 */ { 0, 0, 0, 0, 0 },
/* U+e435 */ { 0, 0, 0, 0, 0 },
/* U+e436 */ { 0, 0, 0, 0, 0 },
/* U+e437 */ { 0, 0, 0, 0, 0 },
/* U+e438 */ { 0, 0, 0, 0, 0 },
/* U+e439 */ { 0, 0, 0, 0, 0 },
/* U+e43a */ { 0, 0, 0, 0, 0 },
/* U+e43b */ { 0, 0, 0, 0, 0 },
/* U+e43c */ { 0, 0, 0, 0, 0 },
/* U+e43d */ { 0, 0, 0, 0, 0 },
/* U+e43e */ { 0, 0, 0, 0, 0 },
/* U+e43f */ { 0, 0, 0, 0, 0 },
/* U+e440 */ { 0, 0, 0, 0, 0 },
/* U+e441 */ { 0, 0, 0, 0, 0 },
/* U+e442 */ { 0, 0, 0, 0, 0 },
/* U+e443 */ { 0, 0, 0, 0, 0 },
/* U+e444 */ { 0, 0, 0, 0, 0 },
/* U+e445 */ { 0, 0, 0, 0, 0 },
/* U+e446 */ { 0, 0, 0, 0, 0 },
/* U+e447 */ { 0, 0, 0, 0, 0 },
/* U+e448 */ { 0, 0, 0, 0, 0 },
/* U+e449 */ { 0, 0, 0, 0, 0 },
/* U+e44a */ { 0, 0, 0, 0, 0 },
/* U+e44b */ { 0, 0, 0, 0, 0 },
/* U+e44c */ { 0, 0, 0, 0, 0 },
/* U+e44d */ { 0, 0, 0, 0, 0 },
/* U+e44e */ { 0, 0, 0, 0, 0 },
/* U+e44f */ { 0, 0, 0, 0, 0 },
/* U+e450 */ { 0, 0, 0, 0, 0 },
/* U+e451 */ { 0, 0, 0, 0, 0 },
/* U+e452 */ { 0, 0, 0, 0, 0 },
/* U+e453 */ { 0, 0, 0, 0, 0 },
/* U+e454 */ { 0, 0, 0, 0, 0 },
/* U+e455 */ { 0, 0, 0, 0, 0 },
/* U+e456 */ { 0, 0, 0, 0, 0 },
/* U+e457 */ { 0, 0, 0, 0, 0 },
/* U+e458 */ { 0, 0, 0, 0, 0 },
/* U+e459 */ { 0, 0, 0, 0, 0 },
/* U+e45a */ { 0, 0, 0, 0, 0 },
/* U+e45b */ { 0, 0, 0, 0, 0 },
/* U+e45c */ { 0, 0, 0, 0, 0 },
/* U+e45d */ { 0, 0, 0, 0, 0 },
/* U+e45e */ { 0, 0, 0, 0, 0 },
/* U+e45f */ { 0, 0, 0, 0, 0 },
/* U+e460 */ { 0, 0, 0, 0, 0 },
/* U+e461 */ { 0, 0, 0, 0, 0 },
/* U+e462 */ { 0, 0, 0, 0, 0 },
/* U+e463 */ { 0, 0, 0, 0, 0 },
/* U+e464 */ { 0, 0, 0, 0, 0 },
/* U+e465 */ { 0, 0, 0, 0, 0 },
/* U+e466 */ { 0, 0, 0, 0, 0 },
/* U+e467 */ { 0, 0, 0, 0, 0 },
/* U+e468 */ { 0, 0, 0, 0, 0 },
/* U+e469 */ { 0, 0, 0, 0, 0 },
/* U+e46a */ { 0, 0, 0, 0, 0 },
/* U+e46b */ { 0, 0, 0, 0, 0 },
/* U+e46c */ { 0, 0, 0, 0, 0 },
/* U+e46d */ { 0, 0, 0, 0, 0 },
/* U+e46e */ { 0, 0, 0, 0, 0 },
/* U+e46f */ { 0, 0, 0, 0, 0 },
/* U+e470 */ { 0, 0, 0, 0, 0 },
/* U+e471 */ { 0, 0, 0, 0, 0 },
/* U+e472 */ { 0, 0, 0, 0, 0 },
/* U+e473 */ { 0, 0, 0, 0, 0 },
/* U+e474 */ { 0, 0, 0, 0, 0 },
/* U+e475 */ { 0, 0, 0, 0, 0 },
/* U+e476 */ { 0, 0, 0, 0, 0 },
/* U+e477 */ { 0, 0, 0, 0, 0 },
/* U+e478 */ { 0, 0, 0, 0, 0 },
/* U+e479 */ { 0, 0, 0, 0, 0 },
/* U+e47a */ { 0, 0, 0, 0, 0 },
/* U+e47b */ { 0, 0, 0, 0, 0 },
/* U+e47c */ { 0, 0, 0, 0, 0 },
/* U+e47d */ { 0, 0, 0, 0, 0 },
/* U+e47e */ { 0, 0, 0, 0, 0 },
/* U+e47f */ { 0, 0, 0, 0, 0 },
/* U+e480 */ { 0, 0, 0, 0, 0 },
/* U+e481 */ { 0, 0, 0, 0, 0 },
/* U+e482 */ { 0, 0, 0, 0, 0 },
/* U+e483 */ { 0, 0, 0, 0, 0 },
/* U+e484 */ { 0, 0, 0, 0, 0 },
/* U+e485 */ { 0, 0, 0, 0, 0 },
/* U+e486 */ { 0, 0, 0, 0, 0 },
/* U+e487 */ { 0, 0, 0, 0, 0 },
/* U+e488 */ { 0, 0, 0, 0, 0 },
/* U+e489 */ { 0, 0, 0, 0, 0 },
/* U+e48a */ { 0, 0, 0, 0, 0 },
/* U+e48b */ { 0, 0, 0, 0, 0 },
/* U+e48c */ { 0, 0, 0, 0, 0 },
/* U+e48d */ { 0, 0, 0, 0, 0 },
/* U+e48e */ { 0, 0, 0, 0, 0 },
/* U+e48f */ { 0, 0, 0, 0, 0 },
/* U+e490 */ { 0, 0, 0, 0, 0 },
/* U+e491 */ { 0, 0, 0, 0, 0 },
/* U+e492 */ { 0, 0, 0, 0, 0 },
/* U+e493 */ { 0, 0, 0, 0, 0 },
/* U+e494 */ { 0, 0, 0, 0, 0 },
/* U+e495 */ { 0, 0, 0, 0, 0 },
/* U+e496 */ { 0, 0, 0, 0, 0 },
/* U+e497 */ { 0, 0, 0, 0, 0 },
/* U+e498 */ { 0, 0, 0, 0, 0 },
/* U+e499 */ { 0, 0, 0, 0, 0 },
/* U+e49a */ { 0, 0, 0, 0, 0 },
/* U+e49b */ { 0, 0, 0, 0, 0 },
/* U+e49c */ { 0, 0, 0, 0, 0 },
/* U+e49d */ { 0, 0, 0, 0, 0 },
/* U+e49e */ { 0, 0, 0, 0, 0 },
/* U+e49f */ { 0, 0, 0, 0, 0 },
/* U+e4a0 */ { 0, 0, 0, 0, 0 },
/* U+e4a1 */ { 0, 0, 0, 0, 0 },
/* U+e4a2 */ { 0, 0, 0, 0, 0 },
/* U+e4a3 */ { 0, 0, 0, 0, 0 },
/* U+e4a4 */ { 0, 0, 0, 0, 0 },
/* U+e4a5 */ { 0, 0, 0, 0, 0 },
/* U+e4a6 */ { 0, 0, 0, 0, 0 },
/* U+e4a7 */ { 0, 0, 0, 0, 0 },
/* U+e4a8 */ { 0, 0, 0, 0, 0 },
/* U+e4a9 */ { 0, 0, 0, 0, 0 },
/* U+e4aa */ { 0, 0, 0, 0, 0 },
/* U+e4ab */ { 0, 0, 0, 0, 0 },
/* U+e4ac */ { 0, 0, 0, 0, 0 },
/* U+e4ad */ { 0, 0, 0, 0, 0 },
/* U+e4ae */ { 0, 0, 0, 0, 0 },
/* U+e4af */ { 0, 0, 0, 0, 0 },
/* U+e4b0 */ { 0, 0, 0, 0, 0 },
/* U+e4b1 */ { 0, 0, 0, 0, 0 },
/* U+e4b2 */ { 0, 0, 0, 0, 0 },
/* U+e4b3 */ { 0, 0, 0, 0, 0 },
/* U+e4b4 */ { 0, 0, 0, 0, 0 },
/* U+e4b5 */ { 0, 0, 0, 0, 0 },
/* U+e4b6 */ { 0, 0, 0, 0, 0 },
/* U+e4b7 */ { 0, 0, 0, 0, 0 },
/* U+e4b8 */ { 0, 0, 0, 0, 0 },
/* U+e4b9 */ { 0, 0, 0, 0, 0 },
/* U+e4ba */ { 0, 0, 0, 0, 0 },
/* U+e4bb */ { 0, 0, 0, 0, 0 },
/* U+e4bc */ { 0, 0, 0, 0, 0 },
/* U+e4bd */ { 0, 0, 0, 0, 0 },
/* U+e4be */ { 0, 0, 0, 0, 0 },
/* U+e4bf */ { 0, 0, 0, 0, 0 },
/* U+e4c0 */ { 0, 0, 0, 0, 0 },
/* U+e4c1 */ { 0, 0, 0, 0, 0 },
/* U+e4c2 */ { 0, 0, 0, 0, 0 },
/* U+e4c3 */ { 0, 0, 0, 0, 0 },
/* U+e4c4 */ { 0, 0, 0, 0, 0 },
/* U+e4c5 */ { 0, 0, 0, 0, 0 },
/* U+e4c6 */ { 0, 0, 0, 0, 0 },
/* U+e4c7 */ { 0, 0, 0, 0, 0 },
/* U+e4c8 */ { 0, 0, 0, 0, 0 },
/* U+e4c9 */ { 0, 0, 0, 0, 0 },
/* U+e4ca */ { 0, 0, 0, 0, 0 },
/* U+e4cb */ { 0, 0, 0, 0, 0 },
/* U+e4cc */ { 0, 0, 0, 0, 0 },
/* U+e4cd */ { 0, 0, 0, 0, 0 },
/* U+e4ce */ { 0, 0, 0, 0, 0 },
/* U+e4cf */ { 0, 0, 0, 0, 0 },
/* U+e4d0 */ { 0, 0, 0, 0, 0 },
/* U+e4d1 */ { 0, 0, 0, 0, 0 },
/* U+e4d2 */ { 0, 0, 0, 0, 0 },
/* U+e4d3 */ { 0, 0, 0, 0, 0 },
/* U+e4d4 */ { 0, 0, 0, 0, 0 },
/* U+e4d5 */ { 0, 0, 0, 0, 0 },
/* U+e4d6 */ { 0, 0, 0, 0, 0 },
/* U+e4d7 */ { 0, 0, 0, 0, 0 },
/* U+e4d8 */ { 0, 0, 0, 0, 0 },
/* U+e4d9 */ { 0, 0, 0, 0, 0 },
/* U+e4da */ { 0, 0, 0, 0, 0 },
/* U+e4db */ { 0, 0, 0, 0, 0 },
/* U+e4dc */ { 0, 0, 0, 0, 0 },
/* U+e4dd */ { 0, 0, 0, 0, 0 },
/* U+e4de */ { 0, 0, 0, 0, 0 },
/* U+e4df */ { 0, 0, 0, 0, 0 },
/* U+e4e0 */ { 0, 0, 0, 0, 0 },
/* U+e4e1 */ { 0, 0, 0, 0, 0 },
/* U+e4e2 */ { 0, 0, 0, 0, 0 },
/* U+e4e3 */ { 0, 0, 0, 0, 0 },
/* U+e4e4 */ { 0, 0, 0, 0, 0 },
/* U+e4e5 */ { 0, 0, 0, 0, 0 },
/* U+e4e6 */ { 0, 0, 0, 0, 0 },
/* U+e4e7 */ { 0, 0, 0, 0, 0 },
/* U+e4e8 */ { 0, 0, 0, 0, 0 },
/* U+e4e9 */ { 0, 0, 0, 0, 0 },
/* U+e4ea */ { 0, 0, 0, 0, 0 },
/* U+e4eb */ { 0, 0, 0, 0, 0 },
/* U+e4ec */ { 0, 0, 0, 0, 0 },
/* U+e4ed */ { 0, 0, 0, 0, 0 },
/* U+e4ee */ { 0, 0, 0, 0, 0 },
/* U+e4ef */ { 0, 0, 0, 0, 0 },
/* U+e4f0 */ { 0, 0, 0, 0, 0 },
/* U+e4f1 */ { 0, 0, 0, 0, 0 },
/* U+e4f2 */ { 0, 0, 0, 0, 0 },
/* U+e4f3 */ { 0, 0, 0, 0, 0 },
/* U+e4f4 */ { 0, 0, 0, 0, 0 },
/* U+e4f5 */ { 0, 0, 0, 0, 0 },
/* U+e4f6 */ { 0, 0, 0, 0, 0 },
/* U+e4f7 */ { 0, 0, 0, 0, 0 },
/* U+e4f8 */ { 0, 0, 0, 0, 0 },
/* U+e4f9 */ { 0, 0, 0, 0, 0 },
/* U+e4fa */ { 0, 0, 0, 0, 0 },
/* U+e4fb */ { 0, 0, 0, 0, 0 },
/* U+e4fc */ { 0, 0, 0, 0, 0 },
/* U+e4fd */ { 0, 0, 0, 0, 0 },
/* U+e4fe */ { 0, 0, 0, 0, 0 },
/* U+e4ff */ { 0, 0, 0, 0, 0 },
/* U+e500 */ { 0, 0, 0, 0, 0 },
/* U+e501 */ { 0, 0, 0, 0, 0 },
/* U+e502 */ { 0, 0, 0, 0, 0 },
/* U+e503 */ { 0, 0, 0, 0, 0 },
/* U+e504 */ { 0, 0, 0, 0, 0 },
/* U+e505 */ { 0, 0, 0, 0, 0 },
/* U+e506 */ { 0, 0, 0, 0, 0 },
/* U+e507 */ { 0, 0, 0, 0, 0 },
/* U+e508 */ { 0, 0, 0, 0, 0 },
/* U+e509 */ { 0, 0, 0, 0, 0 },
/* U+e50a */ { 0, 0, 0, 0, 0 },
/* U+e50b */ { 0, 0, 0, 0, 0 },
/* U+e50c */ { 0, 0, 0, 0, 0 },
/* U+e50d */ { 0, 0, 0, 0, 0 },
/* U+e50e */ { 0, 0, 0, 0, 0 },
/* U+e50f */ { 0, 0, 0, 0, 0 },
/* U+e510 */ { 0, 0, 0, 0, 0 },
/* U+e511 */ { 0, 0, 0, 0, 0 },
/* U+e512 */ { 0, 0, 0, 0, 0 },
/* U+e513 */ { 0, 0, 0, 0, 0 },
/* U+e514 */ { 0, 0, 0, 0, 0 },
/* U+e515 */ { 0, 0, 0, 0, 0 },
/* U+e516 */ { 0, 0, 0, 0, 0 },
/* U+e517 */ { 0, 0, 0, 0, 0 },
/* U+e518 */ { 0, 0, 0, 0, 0 },
/* U+e519 */ { 0, 0, 0, 0, 0 },
/* U+e51a */ { 0, 0, 0, 0, 0 },
/* U+e51b */ { 0, 0, 0, 0, 0 },
/* U+e51c */ { 0, 0, 0, 0, 0 },
/* U+e51d */ { 0, 0, 0, 0, 0 },
/* U+e51e */ { 0, 0, 0, 0, 0 },
/* U+e51f */ { 0, 0, 0, 0, 0 },
/* U+e520 */ { 0, 0, 0, 0, 0 },
/* U+e521 */ { 0, 0, 0, 0, 0 },
/* U+e522 */ { 0, 0, 0, 0, 0 },
/* U+e523 */ { 0, 0, 0, 0, 0 },
/* U+e524 */ { 0, 0, 0, 0, 0 },
/* U+e525 */ { 0, 0, 0, 0, 0 },
/* U+e526 */ { 0, 0, 0, 0, 0 },
/* U+e527 */ { 0, 0, 0, 0, 0 },
/* U+e528 */ { 0, 0, 0, 0, 0 },
/* U+e529 */ { 0, 0, 0, 0, 0 },
/* U+e52a */ { 0, 0, 0, 0, 0 },
/* U+e52b */ { 0, 0, 0, 0, 0 },
/* U+e52c */ { 0, 0, 0, 0, 0 },
/* U+e52d */ { 0, 0, 0, 0, 0 },
/* U+e52e */ { 0, 0, 0, 0, 0 },
/* U+e52f */ { 0, 0, 0, 0, 0 },
/* U+e530 */ { 0, 0, 0, 0, 0 },
/* U+e531 */ { 0, 0, 0, 0, 0 },
/* U+e532 */ { 0, 0, 0, 0, 0 },
/* U+e533 */ { 0, 0, 0, 0, 0 },
/* U+e534 */ { 0, 0, 0, 0, 0 },
/* U+e535 */ { 0, 0, 0, 0, 0 },
/* U+e536 */ { 0, 0, 0, 0, 0 },
/* U+e537 */ { 0, 0, 0, 0, 0 },
/* U+e538 */ { 0, 0, 0, 0, 0 },
/* U+e539 */ { 0, 0, 0, 0, 0 },
/* U+e53a */ { 0, 0, 0, 0, 0 },
/* U+e53b */ { 0, 0, 0, 0, 0 },
/* U+e53c */ { 0, 0, 0, 0, 0 },
/* U+e53d */ { 0, 0, 0, 0, 0 },
/* U+e53e */ { 0, 0, 0, 0, 0 },
/* U+e53f */ { 0, 0, 0, 0, 0 },
/* U+e540 */ { 0, 0, 0, 0, 0 },
/* U+e541 */ { 0, 0, 0, 0, 0 },
/* U+e542 */ { 0, 0, 0, 0, 0 },
/* U+e543 */ { 0, 0, 0, 0, 0 },
/* U+e544 */ { 0, 0, 0, 0, 0 },
/* U+e545 */ { 0, 0, 0, 0, 0 },
/* U+e546 */ { 0, 0, 0, 0, 0 },
/* U+e547 */ { 0, 0, 0, 0, 0 },
/* U+e548 */ { 0, 0, 0, 0, 0 },
/* U+e549 */ { 0, 0, 0, 0, 0 },
/* U+e54a */ { 0, 0, 0, 0, 0 },
/* U+e54b */ { 0, 0, 0, 0, 0 },
/* U+e54c */ { 0, 0, 0, 0, 0 },
/* U+e54d */ { 0, 0, 0, 0, 0 },
/* U+e54e */ { 0, 0, 0, 0, 0 },
/* U+e54f */ { 0, 0, 0, 0, 0 },
/* U+e550 */ { 0, 0, 0, 0, 0 },
/* U+e551 */ { 0, 0, 0, 0, 0 },
/* U+e552 */ { 0, 0, 0, 0, 0 },
/* U+e553 */ { 0, 0, 0, 0, 0 },
/* U+e554 */ { 0, 0, 0, 0, 0 },
/* U+e555 */ { 0, 0, 0, 0, 0 },
/* U+e556 */ { 0, 0, 0, 0, 0 },
/* U+e557 */ { 0, 0, 0, 0, 0 },
/* U+e558 */ { 0, 0, 0, 0, 0 },
/* U+e559 */ { 0, 0, 0, 0, 0 },
/* U+e55a */ { 0, 0, 0, 0, 0 },
/* U+e55b */ { 0, 0, 0, 0, 0 },
/* U+e55c */ { 0, 0, 0, 0, 0 },
/* U+e55d */ { 0, 0, 0, 0, 0 },
/* U+e55e */ { 0, 0, 0, 0, 0 },
/* U+e55f */ { 0, 0, 0, 0, 0 },
/* U+e560 */ { 0, 0, 0, 0, 0 },
/* U+e561 */ { 0, 0, 0, 0, 0 },
/* U+e562 */ { 0, 0, 0, 0, 0 },
/* U+e563 */ { 0, 0, 0, 0, 0 },
/* U+e564 */ { 0, 0, 0, 0, 0 },
/* U+e565 */ { 0, 0, 0, 0, 0 },
/* U+e566 */ { 0, 0, 0, 0, 0 },
/* U+e567 */ { 0, 0, 0, 0, 0 },
/* U+e568 */ { 0, 0, 0, 0, 0 },
/* U+e569 */ { 0, 0, 0, 0, 0 },
/* U+e56a */ { 0, 0, 0, 0, 0 },
/* U+e56b */ { 0, 0, 0, 0, 0 },
/* U+e56c */ { 0, 0, 0, 0, 0 },
/* U+e56d */ { 0, 0, 0, 0, 0 },
/* U+e56e */ { 0, 0, 0, 0, 0 },
/* U+e56f */ { 0, 0, 0, 0, 0 },
/* U+e570 */ { 0, 0, 0, 0, 0 },
/* U+e571 */ { 0, 0, 0, 0, 0 },
/* U+e572 */ { 0, 0, 0, 0, 0 },
/* U+e573 */ { 0, 0, 0, 0, 0 },
/* U+e574 */ { 0, 0, 0, 0, 0 },
/* U+e575 */ { 0, 0, 0, 0, 0 },
/* U+e576 */ { 0, 0, 0, 0, 0 },
/* U+e577 */ { 0, 0, 0, 0, 0 },
/* U+e578 */ { 0, 0, 0, 0, 0 },
/* U+e579 */ { 0, 0, 0, 0, 0 },
/* U+e57a */ { 0, 0, 0, 0, 0 },
/* U+e57b */ { 0, 0, 0, 0, 0 },
/* U+e57c */ { 0, 0, 0, 0, 0 },
/* U+e57d */ { 0, 0, 0, 0, 0 },
/* U+e57e */ { 0, 0, 0, 0, 0 },
/* U+e57f */ { 0, 0, 0, 0, 0 },
/* U+e580 */ { 0, 0, 0, 0, 0 },
/* U+e581 */ { 0, 0, 0, 0, 0 },
/* U+e582 */ { 0, 0, 0, 0, 0 },
/* U+e583 */ { 0, 0, 0, 0, 0 },
/* U+e584 */ { 0, 0, 0, 0, 0 },
/* U+e585 */ { 0, 0, 0, 0, 0 },
/* U+e586 */ { 0, 0, 0, 0, 0 },
/* U+e587 */ { 0, 0, 0, 0, 0 },
/* U+e588 */ { 0, 0, 0, 0, 0 },
/* U+e589 */ { 0, 0, 0, 0, 0 },
/* U+e58a */ { 0, 0, 0, 0, 0 },
/* U+e58b */ { 0, 0, 0, 0, 0 },
/* U+e58c */ { 0, 0, 0, 0, 0 },
/* U+e58d */ { 0, 0, 0, 0, 0 },
/* U+e58e */ { 0, 0, 0, 0, 0 },
/* U+e58f */ { 0, 0, 0, 0, 0 },
/* U+e590 */ { 0, 0, 0, 0, 0 },
/* U+e591 */ { 0, 0, 0, 0, 0 },
/* U+e592 */ { 0, 0, 0, 0, 0 },
/* U+e593 */ { 0, 0, 0, 0, 0 },
/* U+e594 */ { 0, 0, 0, 0, 0 },
/* U+e595 */ { 0, 0, 0, 0, 0 },
/* U+e596 */ { 0, 0, 0, 0, 0 },
/* U+e597 */ { 0, 0, 0, 0, 0 },
/* U+e598 */ { 0, 0, 0, 0, 0 },
/* U+e599 */ { 0, 0, 0, 0, 0 },
/* U+e59a */ { 0, 0, 0, 0, 0 },
/* U+e59b */ { 0, 0, 0, 0, 0 },
/* U+e59c */ { 0, 0, 0, 0, 0 },
/* U+e59d */ { 0, 0, 0, 0, 0 },
/* U+e59e */ { 0, 0, 0, 0, 0 },
/* U+e59f */ { 0, 0, 0, 0, 0 },
/* U+e5a0 */ { 0, 0, 0, 0, 0 },
/* U+e5a1 */ { 0, 0, 0, 0, 0 },
/* U+e5a2 */ { 0, 0, 0, 0, 0 },
/* U+e5a3 */ { 0, 0, 0, 0, 0 },
/* U+e5a4 */ { 0, 0, 0, 0, 0 },
/* U+e5a5 */ { 0, 0, 0, 0, 0 },
/* U+e5a6 */ { 0, 0, 0, 0, 0 },
/* U+e5a7 */ { 0, 0, 0, 0, 0 },
/* U+e5a8 */ { 0, 0, 0, 0, 0 },
/* U+e5a9 */ { 0, 0, 0, 0, 0 },
/* U+e5aa */ { 0, 0, 0, 0, 0 },
/* U+e5ab */ { 0, 0, 0, 0, 0 },
/* U+e5ac */ { 0, 0, 0, 0, 0 },
/* U+e5ad */ { 0, 0, 0, 0, 0 },
/* U+e5ae */ { 0, 0, 0, 0, 0 },
/* U+e5af */ { 0, 0, 0, 0, 0 },
/* U+e5b0 */ { 0, 0, 0, 0, 0 },
/* U+e5b1 */ { 0, 0, 0, 0, 0 },
/* U+e5b2 */ { 0, 0, 0, 0, 0 },
/* U+e5b3 */ { 0, 0, 0, 0, 0 },
/* U+e5b4 */ { 0, 0, 0, 0, 0 },
/* U+e5b5 */ { 0, 0, 0, 0, 0 },
/* U+e5b6 */ { 0, 0, 0, 0, 0 },
/* U+e5b7 */ { 0, 0, 0, 0, 0 },
/* U+e5b8 */ { 0, 0, 0, 0, 0 },
/* U+e5b9 */ { 0, 0, 0, 0, 0 },
/* U+e5ba */ { 0, 0, 0, 0, 0 },
/* U+e5bb */ { 0, 0, 0, 0, 0 },
/* U+e5bc */ { 0, 0, 0, 0, 0 },
/* U+e5bd */ { 0, 0, 0, 0, 0 },
/* U+e5be */ { 0, 0, 0, 0, 0 },
/* U+e5bf */ { 0, 0, 0, 0, 0 },
/* U+e5c0 */ { 0, 0, 0, 0, 0 },
/* U+e5c1 */ { 0, 0, 0, 0, 0 },
/* U+e5c2 */ { 0, 0, 0, 0, 0 },
/* U+e5c3 */ { 0, 0, 0, 0, 0 },
/* U+e5c4 */ { 0, 0, 0, 0, 0 },
/* U+e5c5 */ { 0, 0, 0, 0, 0 },
/* U+e5c6 */ { 0, 0, 0, 0, 0 },
/* U+e5c7 */ { 0, 0, 0, 0, 0 },
/* U+e5c8 */ { 0, 0, 0, 0, 0 },
/* U+e5c9 */ { 0, 0, 0, 0, 0 },
/* U+e5ca */ { 0, 0, 0, 0, 0 },
/* U+e5cb */ { 0, 0, 0, 0, 0 },
/* U+e5cc */ { 0, 0, 0, 0, 0 },
/* U+e5cd */ { 0, 0, 0, 0, 0 },
/* U+e5ce */ { 0, 0, 0, 0, 0 },
/* U+e5cf */ { 0, 0, 0, 0, 0 },
/* U+e5d0 */ { 0, 0, 0, 0, 0 },
/* U+e5d1 */ { 0, 0, 0, 0, 0 },
/* U+e5d2 */ { 0, 0, 0, 0, 0 },
/* U+e5d3 */ { 0, 0, 0, 0, 0 },
/* U+e5d4 */ { 0, 0, 0, 0, 0 },
/* U+e5d5 */ { 0, 0, 0, 0, 0 },
/* U+e5d6 */ { 0, 0, 0, 0, 0 },
/* U+e5d7 */ { 0, 0, 0, 0, 0 },
/* U+e5d8 */ { 0, 0, 0, 0, 0 },
/* U+e5d9 */ { 0, 0, 0, 0, 0 },
/* U+e5da */ { 0, 0, 0, 0, 0 },
/* U+e5db */ { 0, 0, 0, 0, 0 },
/* U+e5dc */ { 0, 0, 0, 0, 0 },
/* U+e5dd */ { 0, 0, 0, 0, 0 },
/* U+e5de */ { 0, 0, 0, 0, 0 },
/* U+e5df */ { 0, 0, 0, 0, 0 },
/* U+e5e0 */ { 0, 0, 0, 0, 0 },
/* U+e5e1 */ { 0, 0, 0, 0, 0 },
/* U+e5e2 */ { 0, 0, 0, 0, 0 },
/* U+e5e3 */ { 0, 0, 0, 0, 0 },
/* U+e5e4 */ { 0, 0, 0, 0, 0 },
/* U+e5e5 */ { 0, 0, 0, 0, 0 },
/* U+e5e6 */ { 0, 0, 0, 0, 0 },
/* U+e5e7 */ { 0, 0, 0, 0, 0 },
/* U+e5e8 */ { 0, 0, 0, 0, 0 },
/* U+e5e9 */ { 0, 0, 0, 0, 0 },
/* U+e5ea */ { 0, 0, 0, 0, 0 },
/* U+e5eb */ { 0, 0, 0, 0, 0 },
/* U+e5ec */ { 0, 0, 0, 0, 0 },
/* U+e5ed */ { 0, 0, 0, 0, 0 },
/* U+e5ee */ { 0, 0, 0, 0, 0 },
/* U+e5ef */ { 0, 0, 0, 0, 0 },
/* U+e5f0 */ { 0, 0, 0, 0, 0 },
/* U+e5f1 */ { 0, 0, 0, 0, 0 },
/* U+e5f2 */ { 0, 0, 0, 0, 0 },
/* U+e5f3 */ { 0, 0, 0, 0, 0 },
/* U+e5f4 */ { 0, 0, 0, 0, 0 },
/* U+e5f5 */ { 0, 0, 0, 0, 0 },
/* U+e5f6 */ { 0, 0, 0, 0, 0 },
/* U+e5f7 */ { 0, 0, 0, 0, 0 },
/* U+e5f8 */ { 0, 0, 0, 0, 0 },
/* U+e5f9 */ { 0, 0, 0, 0, 0 },
/* U+e5fa */ { 0, 0, 0, 0, 0 },
/* U+e5fb */ { 0, 0, 0, 0, 0 },
/* U+e5fc */ { 0, 0, 0, 0, 0 },
/* U+e5fd */ { 0, 0, 0, 0, 0 },
/* U+e5fe */ { 0, 0, 0, 0, 0 },
/* U+e5ff */ { 0, 0, 0, 0, 0 },
/* U+e600 */ { 0, 0, 0, 0, 0 },
/* U+e601 */ { 0, 0, 0, 0, 0 },
/* U+e602 */ { 0, 0, 0, 0, 0 },
/* U+e603 */ { 0, 0, 0, 0, 0 },
/* U+e604 */ { 0, 0, 0, 0, 0 },
/* U+e605 */ { 0, 0, 0, 0, 0 },
/* U+e606 */ { 0, 0, 0, 0, 0 },
/* U+e607 */ { 0, 0, 0, 0, 0 },
/* U+e608 */ { 0, 0, 0, 0, 0 },
/* U+e609 */ { 0, 0, 0, 0, 0 },
/* U+e60a */ { 0, 0, 0, 0, 0 },
/* U+e60b */ { 0, 0, 0, 0, 0 },
/* U+e60c */ { 0, 0, 0, 0, 0 },
/* U+e60d */ { 0, 0, 0, 0, 0 },
/* U+e60e */ { 0, 0, 0, 0, 0 },
/* U+e60f */ { 0, 0, 0, 0, 0 },
/* U+e610 */ { 0, 0, 0, 0, 0 },
/* U+e611 */ { 0, 0, 0, 0, 0 },
/* U+e612 */ { 0, 0, 0, 0, 0 },
/* U+e613 */ { 0, 0, 0, 0, 0 },
/* U+e614 */ { 0, 0, 0, 0, 0 },
/* U+e615 */ { 0, 0, 0, 0, 0 },
/* U+e616 */ { 0, 0, 0, 0, 0 },
/* U+e617 */ { 0, 0, 0, 0, 0 },
/* U+e618 */ { 0, 0, 0, 0, 0 },
/* U+e619 */ { 0, 0, 0, 0, 0 },
/* U+e61a */ { 0, 0, 0, 0, 0 },
/* U+e61b */ { 0, 0, 0, 0, 0 },
/* U+e61c */ { 0, 0, 0, 0, 0 },
/* U+e61d */ { 0, 0, 0, 0, 0 },
/* U+e61e */ { 0, 0, 0, 0, 0 },
/* U+e61f */ { 0, 0, 0, 0, 0 },
/* U+e620 */ { 0, 0, 0, 0, 0 },
/* U+e621 */ { 0, 0, 0, 0, 0 },
/* U+e622 */ { 0, 0, 0, 0, 0 },
/* U+e623 */ { 0, 0, 0, 0, 0 },
/* U+e624 */ { 0, 0, 0, 0, 0 },
/* U+e625 */ { 0, 0, 0, 0, 0 },
/* U+e626 */ { 0, 0, 0, 0, 0 },
/* U+e627 */ { 0, 0, 0, 0, 0 },
/* U+e628 */ { 0, 0, 0, 0, 0 },
/* U+e629 */ { 0, 0, 0, 0, 0 },
/* U+e62a */ { 0, 0, 0, 0, 0 },
/* U+e62b */ { 0, 0, 0, 0, 0 },
/* U+e62c */ { 0, 0, 0, 0, 0 },
/* U+e62d */ { 0, 0, 0, 0, 0 },
/* U+e62e */ { 0, 0, 0, 0, 0 },
/* U+e62f */ { 0, 0, 0, 0, 0 },
/* U+e630 */ { 0, 0, 0, 0, 0 },
/* U+e631 */ { 0, 0, 0, 0, 0 },
/* U+e632 */ { 0, 0, 0, 0, 0 },
/* U+e633 */ { 0, 0, 0, 0, 0 },
/* U+e634 */ { 0, 0, 0, 0, 0 },
/* U+e635 */ { 0, 0, 0, 0, 0 },
/* U+e636 */ { 0, 0, 0, 0, 0 },
/* U+e637 */ { 0, 0, 0, 0, 0 },
/* U+e638 */ { 0, 0, 0, 0, 0 },
/* U+e639 */ { 0, 0, 0, 0, 0 },
/* U+e63a */ { 0, 0, 0, 0, 0 },
/* U+e63b */ { 0, 0, 0, 0, 0 },
/* U+e63c */ { 0, 0, 0, 0, 0 },
/* U+e63d */ { 0, 0, 0, 0, 0 },
/* U+e63e */ { 0, 0, 0, 0, 0 },
/* U+e63f */ { 0, 0, 0, 0, 0 },
/* U+e640 */ { 0, 0, 0, 0, 0 },
/* U+e641 */ { 0, 0, 0, 0, 0 },
/* U+e642 */ { 0, 0, 0, 0, 0 },
/* U+e643 */ { 0, 0, 0, 0, 0 },
/* U+e644 */ { 0, 0, 0, 0, 0 },
/* U+e645 */ { 0, 0, 0, 0, 0 },
/* U+e646 */ { 0, 0, 0, 0, 0 },
/* U+e647 */ { 0, 0, 0, 0, 0 },
/* U+e648 */ { 0, 0, 0, 0, 0 },
/* U+e649 */ { 0, 0, 0, 0, 0 },
/* U+e64a */ { 0, 0, 0, 0, 0 },
/* U+e64b */ { 0, 0, 0, 0, 0 },
/* U+e64c */ { 0, 0, 0, 0, 0 },
/* U+e64d */ { 0, 0, 0, 0, 0 },
/* U+e64e */ { 0, 0, 0, 0, 0 },
/* U+e64f */ { 0, 0, 0, 0, 0 },
/* U+e650 */ { 0, 0, 0, 0, 0 },
/* U+e651 */ { 0, 0, 0, 0, 0 },
/* U+e652 */ { 0, 0, 0, 0, 0 },
/* U+e653 */ { 0, 0, 0, 0, 0 },
/* U+e654 */ { 0, 0, 0, 0, 0 },
/* U+e655 */ { 0, 0, 0, 0, 0 },
/* U+e656 */ { 0, 0, 0, 0, 0 },
/* U+e657 */ { 0, 0, 0, 0, 0 },
/* U+e658 */ { 0, 0, 0, 0, 0 },
/* U+e659 */ { 0, 0, 0, 0, 0 },
/* U+e65a */ { 0, 0, 0, 0, 0 },
/* U+e65b */ { 0, 0, 0, 0, 0 },
/* U+e65c */ { 0, 0, 0, 0, 0 },
/* U+e65d */ { 0, 0, 0, 0, 0 },
/* U+e65e */ { 0, 0, 0, 0, 0 },
/* U+e65f */ { 0, 0, 0, 0, 0 },
/* U+e660 */ { 0, 0, 0, 0, 0 },
/* U+e661 */ { 0, 0, 0, 0, 0 },
/* U+e662 */ { 0, 0, 0, 0, 0 },
/* U+e663 */ { 0, 0, 0, 0, 0 },
/* U+e664 */ { 0, 0, 0, 0, 0 },
/* U+e665 */ { 0, 0, 0, 0, 0 },
/* U+e666 */ { 0, 0, 0, 0, 0 },
/* U+e667 */ { 0, 0, 0, 0, 0 },
/* U+e668 */ { 0, 0, 0, 0, 0 },
/* U+e669 */ { 0, 0, 0, 0, 0 },
/* U+e66a */ { 0, 0, 0, 0, 0 },
/* U+e66b */ { 0, 0, 0, 0, 0 },
/* U+e66c */ { 0, 0, 0, 0, 0 },
/* U+e66d */ { 0, 0, 0, 0, 0 },
/* U+e66e */ { 0, 0, 0, 0, 0 },
/* U+e66f */ { 0, 0, 0, 0, 0 },
/* U+e670 */ { 0, 0, 0, 0, 0 },
/* U+e671 */ { 0, 0, 0, 0, 0 },
/* U+e672 */ { 0, 0, 0, 0, 0 },
/* U+e673 */ { 0, 0, 0, 0, 0 },
/* U+e674 */ { 0, 0, 0, 0, 0 },
/* U+e675 */ { 0, 0, 0, 0, 0 },
/* U+e676 */ { 0, 0, 0, 0, 0 },
/* U+e677 */ { 0, 0, 0, 0, 0 },
/* U+e678 */ { 0, 0, 0, 0, 0 },
/* U+e679 */ { 0, 0, 0, 0, 0 },
/* U+e67a */ { 0, 0, 0, 0, 0 },
/* U+e67b */ { 0, 0, 0, 0, 0 },
/* U+e67c */ { 0, 0, 0, 0, 0 },
/* U+e67d */ { 0, 0, 0, 0, 0 },
/* U+e67e */ { 0, 0, 0, 0, 0 },
/* U+e67f */ { 0, 0, 0, 0, 0 },
/* U+e680 */ { 0, 0, 0, 0, 0 },
/* U+e681 */ { 0, 0, 0, 0, 0 },
/* U+e682 */ { 0, 0, 0, 0, 0 },
/* U+e683 */ { 0, 0, 0, 0, 0 },
/* U+e684 */ { 0, 0, 0, 0, 0 },
/* U+e685 */ { 0, 0, 0, 0, 0 },
/* U+e686 */ { 0, 0, 0, 0, 0 },
/* U+e687 */ { 0, 0, 0, 0, 0 },
/* U+e688 */ { 0, 0, 0, 0, 0 },
/* U+e689 */ { 0, 0, 0, 0, 0 },
/* U+e68a */ { 0, 0, 0, 0, 0 },
/* U+e68b */ { 0, 0, 0, 0, 0 },
/* U+e68c */ { 0, 0, 0, 0, 0 },
/* U+e68d */ { 0, 0, 0, 0, 0 },
/* U+e68e */ { 0, 0, 0, 0, 0 },
/* U+e68f */ { 0, 0, 0, 0, 0 },
/* U+e690 */ { 0, 0, 0, 0, 0 },
/* U+e691 */ { 0, 0, 0, 0, 0 },
/* U+e692 */ { 0, 0, 0, 0, 0 },
/* U+e693 */ { 0, 0, 0, 0, 0 },
/* U+e694 */ { 0, 0, 0, 0, 0 },
/* U+e695 */ { 0, 0, 0, 0, 0 },
/* U+e696 */ { 0, 0, 0, 0, 0 },
/* U+e697 */ { 0, 0, 0, 0, 0 },
/* U+e698 */ { 0, 0, 0, 0, 0 },
/* U+e699 */ { 0, 0, 0, 0, 0 },
/* U+e69a */ { 0, 0, 0, 0, 0 },
/* U+e69b */ { 0, 0, 0, 0, 0 },
/* U+e69c */ { 0, 0, 0, 0, 0 },
/* U+e69d */ { 0, 0, 0, 0, 0 },
/* U+e69e */ { 0, 0, 0, 0, 0 },
/* U+e69f */ { 0, 0, 0, 0, 0 },
/* U+e6a0 */ { 0, 0, 0, 0, 0 },
/* U+e6a1 */ { 0, 0, 0, 0, 0 },
/* U+e6a2 */ { 0, 0, 0, 0, 0 },
/* U+e6a3 */ { 0, 0, 0, 0, 0 },
/* U+e6a4 */ { 0, 0, 0, 0, 0 },
/* U+e6a5 */ { 0, 0, 0, 0, 0 },
/* U+e6a6 */ { 0, 0, 0, 0, 0 },
/* U+e6a7 */ { 0, 0, 0, 0, 0 },
/* U+e6a8 */ { 0, 0, 0, 0, 0 },
/* U+e6a9 */ { 0, 0, 0, 0, 0 },
/* U+e6aa */ { 0, 0, 0, 0, 0 },
/* U+e6ab */ { 0, 0, 0, 0, 0 },
/* U+e6ac */ { 0, 0, 0, 0, 0 },
/* U+e6ad */ { 0, 0, 0, 0, 0 },
/* U+e6ae */ { 0, 0, 0, 0, 0 },
/* U+e6af */ { 0, 0, 0, 0, 0 },
/* U+e6b0 */ { 0, 0, 0, 0, 0 },
/* U+e6b1 */ { 0, 0, 0, 0, 0 },
/* U+e6b2 */ { 0, 0, 0, 0, 0 },
/* U+e6b3 */ { 0, 0, 0, 0, 0 },
/* U+e6b4 */ { 0, 0, 0, 0, 0 },
/* U+e6b5 */ { 0, 0, 0, 0, 0 },
/* U+e6b6 */ { 0, 0, 0, 0, 0 },
/* U+e6b7 */ { 0, 0, 0, 0, 0 },
/* U+e6b8 */ { 0, 0, 0, 0, 0 },
/* U+e6b9 */ { 0, 0, 0, 0, 0 },
/* U+e6ba */ { 0, 0, 0, 0, 0 },
/* U+e6bb */ { 0, 0, 0, 0, 0 },
/* U+e6bc */ { 0, 0, 0, 0, 0 },
/* U+e6bd */ { 0, 0, 0, 0, 0 },
/* U+e6be */ { 0, 0, 0, 0, 0 },
/* U+e6bf */ { 0, 0, 0, 0, 0 },
/* U+e6c0 */ { 0, 0, 0, 0, 0 },
/* U+e6c1 */ { 0, 0, 0, 0, 0 },
/* U+e6c2 */ { 0, 0, 0, 0, 0 },
/* U+e6c3 */ { 0, 0, 0, 0, 0 },
/* U+e6c4 */ { 0, 0, 0, 0, 0 },
/* U+e6c5 */ { 0, 0, 0, 0, 0 },
/* U+e6c6 */ { 0, 0, 0, 0, 0 },
/* U+e6c7 */ { 0, 0, 0, 0, 0 },
/* U+e6c8 */ { 0, 0, 0, 0, 0 },
/* U+e6c9 */ { 0, 0, 0, 0, 0 },
/* U+e6ca */ { 0, 0, 0, 0, 0 },
/* U+e6cb */ { 0, 0, 0, 0, 0 },
/* U+e6cc */ { 0, 0, 0, 0, 0 },
/* U+e6cd */ { 0, 0, 0, 0, 0 },
/* U+e6ce */ { 0, 0, 0, 0, 0 },
/* U+e6cf */ { 0, 0, 0, 0, 0 },
/* U+e6d0 */ { 0, 0, 0, 0, 0 },
/* U+e6d1 */ { 0, 0, 0, 0, 0 },
/* U+e6d2 */ { 0, 0, 0, 0, 0 },
/* U+e6d3 */ { 0, 0, 0, 0, 0 },
/* U+e6d4 */ { 0, 0, 0, 0, 0 },
/* U+e6d5 */ { 0, 0, 0, 0, 0 },
/* U+e6d6 */ { 0, 0, 0, 0, 0 },
/* U+e6d7 */ { 0, 0, 0, 0, 0 },
/* U+e6d8 */ { 0, 0, 0, 0, 0 },
/* U+e6d9 */ { 0, 0, 0, 0, 0 },
/* U+e6da */ { 0, 0, 0, 0, 0 },
/* U+e6db */ { 0, 0, 0, 0, 0 },
/* U+e6dc */ { 0, 0, 0, 0, 0 },
/* U+e6dd */ { 0, 0, 0, 0, 0 },
/* U+e6de */ { 0, 0, 0, 0, 0 },
/* U+e6df */ { 0, 0, 0, 0, 0 },
/* U+e6e0 */ { 0, 0, 0, 0, 0 },
/* U+e6e1 */ { 0, 0, 0, 0, 0 },
/* U+e6e2 */ { 0, 0, 0, 0, 0 },
/* U+e6e3 */ { 0, 0, 0, 0, 0 },
/* U+e6e4 */ { 0, 0, 0, 0, 0 },
/* U+e6e5 */ { 0, 0, 0, 0, 0 },
/* U+e6e6 */ { 0, 0, 0, 0, 0 },
/* U+e6e7 */ { 0, 0, 0, 0, 0 },
/* U+e6e8 */ { 0, 0, 0, 0, 0 },
/* U+e6e9 */ { 0, 0, 0, 0, 0 },
/* U+e6ea */ { 0, 0, 0, 0, 0 },
/* U+e6eb */ { 0, 0, 0, 0, 0 },
/* U+e6ec */ { 0, 0, 0, 0, 0 },
/* U+e6ed */ { 0, 0, 0, 0, 0 },
/* U+e6ee */ { 0, 0, 0, 0, 0 },
/* U+e6ef */ { 0, 0, 0, 0, 0 },
/* U+e6f0 */ { 0, 0, 0, 0, 0 },
/* U+e6f1 */ { 0, 0, 0, 0, 0 },
/* U+e6f2 */ { 0, 0, 0, 0, 0 },
/* U+e6f3 */ { 0, 0, 0, 0, 0 },
/* U+e6f4 */ { 0, 0, 0, 0, 0 },
/* U+e6f5 */ { 0, 0, 0, 0, 0 },
/* U+e6f6 */ { 0, 0, 0, 0, 0 },
/* U+e6f7 */ { 0, 0, 0, 0, 0 },
/* U+e6f8 */ { 0, 0, 0, 0, 0 },
/* U+e6f9 */ { 0, 0, 0, 0, 0 },
/* U+e6fa */ { 0, 0, 0, 0, 0 },
/* U+e6fb */ { 0, 0, 0, 0, 0 },
/* U+e6fc */ { 0, 0, 0, 0, 0 },
/* U+e6fd */ { 0, 0, 0, 0, 0 },
/* U+e6fe */ { 0, 0, 0, 0, 0 },
/* U+e6ff */ { 0, 0, 0, 0, 0 },
/* U+e700 */ { 0, 0, 0, 0, 0 },
/* U+e701 */ { 0, 0, 0, 0, 0 },
/* U+e702 */ { 0, 0, 0, 0, 0 },
/* U+e703 */ { 0, 0, 0, 0, 0 },
/* U+e704 */ { 0, 0, 0, 0, 0 },
/* U+e705 */ { 0, 0, 0, 0, 0 },
/* U+e706 */ { 0, 0, 0, 0, 0 },
/* U+e707 */ { 0, 0, 0, 0, 0 },
/* U+e708 */ { 0, 0, 0, 0, 0 },
/* U+e709 */ { 0, 0, 0, 0, 0 },
/* U+e70a */ { 0, 0, 0, 0, 0 },
/* U+e70b */ { 0, 0, 0, 0, 0 },
/* U+e70c */ { 0, 0, 0, 0, 0 },
/* U+e70d */ { 0, 0, 0, 0, 0 },
/* U+e70e */ { 0, 0, 0, 0, 0 },
/* U+e70f */ { 0, 0, 0, 0, 0 },
/* U+e710 */ { 0, 0, 0, 0, 0 },
/* U+e711 */ { 0, 0, 0, 0, 0 },
/* U+e712 */ { 0, 0, 0, 0, 0 },
/* U+e713 */ { 0, 0, 0, 0, 0 },
/* U+e714 */ { 0, 0, 0, 0, 0 },
/* U+e715 */ { 0, 0, 0, 0, 0 },
/* U+e716 */ { 0, 0, 0, 0, 0 },
/* U+e717 */ { 0, 0, 0, 0, 0 },
/* U+e718 */ { 0, 0, 0, 0, 0 },
/* U+e719 */ { 0, 0, 0, 0, 0 },
/* U+e71a */ { 0, 0, 0, 0, 0 },
/* U+e71b */ { 0, 0, 0, 0, 0 },
/* U+e71c */ { 0, 0, 0, 0, 0 },
/* U+e71d */ { 0, 0, 0, 0, 0 },
/* U+e71e */ { 0, 0, 0, 0, 0 },
/* U+e71f */ { 0, 0, 0, 0, 0 },
/* U+e720 */ { 0, 0, 0, 0, 0 },
/* U+e721 */ { 0, 0, 0, 0, 0 },
/* U+e722 */ { 0, 0, 0, 0, 0 },
/* U+e723 */ { 0, 0, 0, 0, 0 },
/* U+e724 */ { 0, 0, 0, 0, 0 },
/* U+e725 */ { 0, 0, 0, 0, 0 },
/* U+e726 */ { 0, 0, 0, 0, 0 },
/* U+e727 */ { 0, 0, 0, 0, 0 },
/* U+e728 */ { 0, 0, 0, 0, 0 },
/* U+e729 */ { 0, 0, 0, 0, 0 },
/* U+e72a */ { 0, 0, 0, 0, 0 },
/* U+e72b */ { 0, 0, 0, 0, 0 },
/* U+e72c */ { 0, 0, 0, 0, 0 },
/* U+e72d */ { 0, 0, 0, 0, 0 },
/* U+e72e */ { 0, 0, 0, 0, 0 },
/* U+e72f */ { 0, 0, 0, 0, 0 },
/* U+e730 */ { 0, 0, 0, 0, 0 },
/* U+e731 */ { 0, 0, 0, 0, 0 },
/* U+e732 */ { 0, 0, 0, 0, 0 },
/* U+e733 */ { 0, 0, 0, 0, 0 },
/* U+e734 */ { 0, 0, 0, 0, 0 },
/* U+e735 */ { 0, 0, 0, 0, 0 },
/* U+e736 */ { 0, 0, 0, 0, 0 },
/* U+e737 */ { 0, 0, 0, 0, 0 },
/* U+e738 */ { 0, 0, 0, 0, 0 },
/* U+e739 */ { 0, 0, 0, 0, 0 },
/* U+e73a */ { 0, 0, 0, 0, 0 },
/* U+e73b */ { 0, 0, 0, 0, 0 },
/* U+e73c */ { 0, 0, 0, 0, 0 },
/* U+e73d */ { 0, 0, 0, 0, 0 },
/* U+e73e */ { 0, 0, 0, 0, 0 },
/* U+e73f */ { 0, 0, 0, 0, 0 },
/* U+e740 */ { 0, 0, 0, 0, 0 },
/* U+e741 */ { 0, 0, 0, 0, 0 },
/* U+e742 */ { 0, 0, 0, 0, 0 },
/* U+e743 */ { 0, 0, 0, 0, 0 },
/* U+e744 */ { 0, 0, 0, 0, 0 },
/* U+e745 */ { 0, 0, 0, 0, 0 },
/* U+e746 */ { 0, 0, 0, 0, 0 },
/* U+e747 */ { 0, 0, 0, 0, 0 },
/* U+e748 */ { 0, 0, 0, 0, 0 },
/* U+e749 */ { 0, 0, 0, 0, 0 },
/* U+e74a */ { 0, 0, 0, 0, 0 },
/* U+e74b */ { 0, 0, 0, 0, 0 },
/* U+e74c */ { 0, 0, 0, 0, 0 },
/* U+e74d */ { 0, 0, 0, 0, 0 },
/* U+e74e */ { 0, 0, 0, 0, 0 },
/* U+e74f */ { 0, 0, 0, 0, 0 },
/* U+e750 */ { 0, 0, 0, 0, 0 },
/* U+e751 */ { 0, 0, 0, 0, 0 },
/* U+e752 */ { 0, 0, 0, 0, 0 },
/* U+e753 */ { 0, 0, 0, 0, 0 },
/* U+e754 */ { 0, 0, 0, 0, 0 },
/* U+e755 */ { 0, 0, 0, 0, 0 },
/* U+e756 */ { 0, 0, 0, 0, 0 },
/* U+e757 */ { 0, 0, 0, 0, 0 },
/* U+e758 */ { 0, 0, 0, 0, 0 },
/* U+e759 */ { 0, 0, 0, 0, 0 },
/* U+e75a */ { 0, 0, 0, 0, 0 },
/* U+e75b */ { 0, 0, 0, 0, 0 },
/* U+e75c */ { 0, 0, 0, 0, 0 },
/* U+e75d */ { 0, 0, 0, 0, 0 },
/* U+e75e */ { 0, 0, 0, 0, 0 },
/* U+e75f */ { 0, 0, 0, 0, 0 },
/* U+e760 */ { 0, 0, 0, 0, 0 },
/* U+e761 */ { 0, 0, 0, 0, 0 },
/* U+e762 */ { 0, 0, 0, 0, 0 },
/* U+e763 */ { 0, 0, 0, 0, 0 },
/* U+e764 */ { 0, 0, 0, 0, 0 },
/* U+e765 */ { 0, 0, 0, 0, 0 },
/* U+e766 */ { 0, 0, 0, 0, 0 },
/* U+e767 */ { 0, 0, 0, 0, 0 },
/* U+e768 */ { 0, 0, 0, 0, 0 },
/* U+e769 */ { 0, 0, 0, 0, 0 },
/* U+e76a */ { 0, 0, 0, 0, 0 },
/* U+e76b */ { 0, 0, 0, 0, 0 },
/* U+e76c */ { 0, 0, 0, 0, 0 },
/* U+e76d */ { 0, 0, 0, 0, 0 },
/* U+e76e */ { 0, 0, 0, 0, 0 },
/* U+e76f */ { 0, 0, 0, 0, 0 },
/* U+e770 */ { 0, 0, 0, 0, 0 },
/* U+e771 */ { 0, 0, 0, 0, 0 },
/* U+e772 */ { 0, 0, 0, 0, 0 },
/* U+e773 */ { 0, 0, 0, 0, 0 },
/* U+e774 */ { 0, 0, 0, 0, 0 },
/* U+e775 */ { 0, 0, 0, 0, 0 },
/* U+e776 */ { 0, 0, 0, 0, 0 },
/* U+e777 */ { 0, 0, 0, 0, 0 },
/* U+e778 */ { 0, 0, 0, 0, 0 },
/* U+e779 */ { 0, 0, 0, 0, 0 },
/* U+e77a */ { 0, 0, 0, 0, 0 },
/* U+e77b */ { 0, 0, 0, 0, 0 },
/* U+e77c */ { 0, 0, 0, 0, 0 },
/* U+e77d */ { 0, 0, 0, 0, 0 },
/* U+e77e */ { 0, 0, 0, 0, 0 },
/* U+e77f */ { 0, 0, 0, 0, 0 },
/* U+e780 */ { 0, 0, 0, 0, 0 },
/* U+e781 */ { 0, 0, 0, 0, 0 },
/* U+e782 */ { 0, 0, 0, 0, 0 },
/* U+e783 */ { 0, 0, 0, 0, 0 },
/* U+e784 */ { 0, 0, 0, 0, 0 },
/* U+e785 */ { 0, 0, 0, 0, 0 },
/* U+e786 */ { 0, 0, 0, 0, 0 },
/* U+e787 */ { 0, 0, 0, 0, 0 },
/* U+e788 */ { 0, 0, 0, 0, 0 },
/* U+e789 */ { 0, 0, 0, 0, 0 },
/* U+e78a */ { 0, 0, 0, 0, 0 },
/* U+e78b */ { 0, 0, 0, 0, 0 },
/* U+e78c */ { 0, 0, 0, 0, 0 },
/* U+e78d */ { 0, 0, 0, 0, 0 },
/* U+e78e */ { 0, 0, 0, 0, 0 },
/* U+e78f */ { 0, 0, 0, 0, 0 },
/* U+e790 */ { 0, 0, 0, 0, 0 },
/* U+e791 */ { 0, 0, 0, 0, 0 },
/* U+e792 */ { 0, 0, 0, 0, 0 },
/* U+e793 */ { 0, 0, 0, 0, 0 },
/* U+e794 */ { 0, 0, 0, 0, 0 },
/* U+e795 */ { 0, 0, 0, 0, 0 },
/* U+e796 */ { 0, 0, 0, 0, 0 },
/* U+e797 */ { 0, 0, 0, 0, 0 },
/* U+e798 */ { 0, 0, 0, 0, 0 },
/* U+e799 */ { 0, 0, 0, 0, 0 },
/* U+e79a */ { 0, 0, 0, 0, 0 },
/* U+e79b */ { 0, 0, 0, 0, 0 },
/* U+e79c */ { 0, 0, 0, 0, 0 },
/* U+e79d */ { 0, 0, 0, 0, 0 },
/* U+e79e */ { 0, 0, 0, 0, 0 },
/* U+e79f */ { 0, 0, 0, 0, 0 },
/* U+e7a0 */ { 0, 0, 0, 0, 0 },
/* U+e7a1 */ { 0, 0, 0, 0, 0 },
/* U+e7a2 */ { 0, 0, 0, 0, 0 },
/* U+e7a3 */ { 0, 0, 0, 0, 0 },
/* U+e7a4 */ { 0, 0, 0, 0, 0 },
/* U+e7a5 */ { 0, 0, 0, 0, 0 },
/* U+e7a6 */ { 0, 0, 0, 0, 0 },
/* U+e7a7 */ { 0, 0, 0, 0, 0 },
/* U+e7a8 */ { 0, 0, 0, 0, 0 },
/* U+e7a9 */ { 0, 0, 0, 0, 0 },
/* U+e7aa */ { 0, 0, 0, 0, 0 },
/* U+e7ab */ { 0, 0, 0, 0, 0 },
/* U+e7ac */ { 0, 0, 0, 0, 0 },
/* U+e7ad */ { 0, 0, 0, 0, 0 },
/* U+e7ae */ { 0, 0, 0, 0, 0 },
/* U+e7af */ { 0, 0, 0, 0, 0 },
/* U+e7b0 */ { 0, 0, 0, 0, 0 },
/* U+e7b1 */ { 0, 0, 0, 0, 0 },
/* U+e7b2 */ { 0, 0, 0, 0, 0 },
/* U+e7b3 */ { 0, 0, 0, 0, 0 },
/* U+e7b4 */ { 0, 0, 0, 0, 0 },
/* U+e7b5 */ { 0, 0, 0, 0, 0 },
/* U+e7b6 */ { 0, 0, 0, 0, 0 },
/* U+e7b7 */ { 0, 0, 0, 0, 0 },
/* U+e7b8 */ { 0, 0, 0, 0, 0 },
/* U+e7b9 */ { 0, 0, 0, 0, 0 },
/* U+e7ba */ { 0, 0, 0, 0, 0 },
/* U+e7bb */ { 0, 0, 0, 0, 0 },
/* U+e7bc */ { 0, 0, 0, 0, 0 },
/* U+e7bd */ { 0, 0, 0, 0, 0 },
/* U+e7be */ { 0, 0, 0, 0, 0 },
/* U+e7bf */ { 0, 0, 0, 0, 0 },
/* U+e7c0 */ { 0, 0, 0, 0, 0 },
/* U+e7c1 */ { 0, 0, 0, 0, 0 },
/* U+e7c2 */ { 0, 0, 0, 0, 0 },
/* U+e7c3 */ { 0, 0, 0, 0, 0 },
/* U+e7c4 */ { 0, 0, 0, 0, 0 },
/* U+e7c5 */ { 0, 0, 0, 0, 0 },
/* U+e7c6 */ { 0, 0, 0, 0, 0 },
/* U+e7c7 */ { 0, 0, 0, 0, 0 },
/* U+e7c8 */ { 0, 0, 0, 0, 0 },
/* U+e7c9 */ { 0, 0, 0, 0, 0 },
/* U+e7ca */ { 0, 0, 0, 0, 0 },
/* U+e7cb */ { 0, 0, 0, 0, 0 },
/* U+e7cc */ { 0, 0, 0, 0, 0 },
/* U+e7cd */ { 0, 0, 0, 0, 0 },
/* U+e7ce */ { 0, 0, 0, 0, 0 },
/* U+e7cf */ { 0, 0, 0, 0, 0 },
/* U+e7d0 */ { 0, 0, 0, 0, 0 },
/* U+e7d1 */ { 0, 0, 0, 0, 0 },
/* U+e7d2 */ { 0, 0, 0, 0, 0 },
/* U+e7d3 */ { 0, 0, 0, 0, 0 },
/* U+e7d4 */ { 0, 0, 0, 0, 0 },
/* U+e7d5 */ { 0, 0, 0, 0, 0 },
/* U+e7d6 */ { 0, 0, 0, 0, 0 },
/* U+e7d7 */ { 0, 0, 0, 0, 0 },
/* U+e7d8 */ { 0, 0, 0, 0, 0 },
/* U+e7d9 */ { 0, 0, 0, 0, 0 },
/* U+e7da */ { 0, 0, 0, 0, 0 },
/* U+e7db */ { 0, 0, 0, 0, 0 },
/* U+e7dc */ { 0, 0, 0, 0, 0 },
/* U+e7dd */ { 0, 0, 0, 0, 0 },
/* U+e7de */ { 0, 0, 0, 0, 0 },
/* U+e7df */ { 0, 0, 0, 0, 0 },
/* U+e7e0 */ { 0, 0, 0, 0, 0 },
/* U+e7e1 */ { 0, 0, 0, 0, 0 },
/* U+e7e2 */ { 0, 0, 0, 0, 0 },
/* U+e7e3 */ { 0, 0, 0, 0, 0 },
/* U+e7e4 */ { 0, 0, 0, 0, 0 },
/* U+e7e5 */ { 0, 0, 0, 0, 0 },
/* U+e7e6 */ { 0, 0, 0, 0, 0 },
/* U+e7e7 */ { 0, 0, 0, 0, 0 },
/* U+e7e8 */ { 0, 0, 0, 0, 0 },
/* U+e7e9 */ { 0, 0, 0, 0, 0 },
/* U+e7ea */ { 0, 0, 0, 0, 0 },
/* U+e7eb */ { 0, 0, 0, 0, 0 },
/* U+e7ec */ { 0, 0, 0, 0, 0 },
/* U+e7ed */ { 0, 0, 0, 0, 0 },
/* U+e7ee */ { 0, 0, 0, 0, 0 },
/* U+e7ef */ { 0, 0, 0, 0, 0 },
/* U+e7f0 */ { 0, 0, 0, 0, 0 },
/* U+e7f1 */ { 0, 0, 0, 0, 0 },
/* U+e7f2 */ { 0, 0, 0, 0, 0 },
/* U+e7f3 */ { 0, 0, 0, 0, 0 },
/* U+e7f4 */ { 0, 0, 0, 0, 0 },
/* U+e7f5 */ { 0, 0, 0, 0, 0 },
/* U+e7f6 */ { 0, 0, 0, 0, 0 },
/* U+e7f7 */ { 0, 0, 0, 0, 0 },
/* U+e7f8 */ { 0, 0, 0, 0, 0 },
/* U+e7f9 */ { 0, 0, 0, 0, 0 },
/* U+e7fa */ { 0, 0, 0, 0, 0 },
/* U+e7fb */ { 0, 0, 0, 0, 0 },
/* U+e7fc */ { 0, 0, 0, 0, 0 },
/* U+e7fd */ { 0, 0, 0, 0, 0 },
/* U+e7fe */ { 0, 0, 0, 0, 0 },
/* U+e7ff */ { 0, 0, 0, 0, 0 },
/* U+e800 */ { 0, 0, 0, 0, 0 },
/* U+e801 */ { 0, 0, 0, 0, 0 },
/* U+e802 */ { 0, 0, 0, 0, 0 },
/* U+e803 */ { 0, 0, 0, 0, 0 },
/* U+e804 */ { 0, 0, 0, 0, 0 },
/* U+e805 */ { 0, 0, 0, 0, 0 },
/* U+e806 */ { 0, 0, 0, 0, 0 },
/* U+e807 */ { 0, 0, 0, 0, 0 },
/* U+e808 */ { 0, 0, 0, 0, 0 },
/* U+e809 */ { 0, 0, 0, 0, 0 },
/* U+e80a */ { 0, 0, 0, 0, 0 },
/* U+e80b */ { 0, 0, 0, 0, 0 },
/* U+e80c */ { 0, 0, 0, 0, 0 },
/* U+e80d */ { 0, 0, 0, 0, 0 },
/* U+e80e */ { 0, 0, 0, 0, 0 },
/* U+e80f */ { 0, 0, 0, 0, 0 },
/* U+e810 */ { 0, 0, 0, 0, 0 },
/* U+e811 */ { 0, 0, 0, 0, 0 },
/* U+e812 */ { 0, 0, 0, 0, 0 },
/* U+e813 */ { 0, 0, 0, 0, 0 },
/* U+e814 */ { 0, 0, 0, 0, 0 },
/* U+e815 */ { 0, 0, 0, 0, 0 },
/* U+e816 */ { 0, 0, 0, 0, 0 },
/* U+e817 */ { 0, 0, 0, 0, 0 },
/* U+e818 */ { 0, 0, 0, 0, 0 },
/* U+e819 */ { 0, 0, 0, 0, 0 },
/* U+e81a */ { 0, 0, 0, 0, 0 },
/* U+e81b */ { 0, 0, 0, 0, 0 },
/* U+e81c */ { 0, 0, 0, 0, 0 },
/* U+e81d */ { 0, 0, 0, 0, 0 },
/* U+e81e */ { 0, 0, 0, 0, 0 },
/* U+e81f */ { 0, 0, 0, 0, 0 },
/* U+e820 */ { 0, 0, 0, 0, 0 },
/* U+e821 */ { 0, 0, 0, 0, 0 },
/* U+e822 */ { 0, 0, 0, 0, 0 },
/* U+e823 */ { 0, 0, 0, 0, 0 },
/* U+e824 */ { 0, 0, 0, 0, 0 },
/* U+e825 */ { 0, 0, 0, 0, 0 },
/* U+e826 */ { 0, 0, 0, 0, 0 },
/* U+e827 */ { 0, 0, 0, 0, 0 },
/* U+e828 */ { 0, 0, 0, 0, 0 },
/* U+e829 */ { 0, 0, 0, 0, 0 },
/* U+e82a */ { 0, 0, 0, 0, 0 },
/* U+e82b */ { 0, 0, 0, 0, 0 },
/* U+e82c */ { 0, 0, 0, 0, 0 },
/* U+e82d */ { 0, 0, 0, 0, 0 },
/* U+e82e */ { 0, 0, 0, 0, 0 },
/* U+e82f */ { 0, 0, 0, 0, 0 },
/* U+e830 */ { 0, 0, 0, 0, 0 },
/* U+e831 */ { 0, 0, 0, 0, 0 },
/* U+e832 */ { 0, 0, 0, 0, 0 },
/* U+e833 */ { 0, 0, 0, 0, 0 },
/* U+e834 */ { 0, 0, 0, 0, 0 },
/* U+e835 */ { 0, 0, 0, 0, 0 },
/* U+e836 */ { 0, 0, 0, 0, 0 },
/* U+e837 */ { 0, 0, 0, 0, 0 },
/* U+e838 */ { 0, 0, 0, 0, 0 },
/* U+e839 */ { 0, 0, 0, 0, 0 },
/* U+e83a */ { 0, 0, 0, 0, 0 },
/* U+e83b */ { 0, 0, 0, 0, 0 },
/* U+e83c */ { 0, 0, 0, 0, 0 },
/* U+e83d */ { 0, 0, 0, 0, 0 },
/* U+e83e */ { 0, 0, 0, 0, 0 },
/* U+e83f */ { 0, 0, 0, 0, 0 },
/* U+e840 */ { 0, 0, 0, 0, 0 },
/* U+e841 */ { 0, 0, 0, 0, 0 },
/* U+e842 */ { 0, 0, 0, 0, 0 },
/* U+e843 */ { 0, 0, 0, 0, 0 },
/* U+e844 */ { 0, 0, 0, 0, 0 },
/* U+e845 */ { 0, 0, 0, 0, 0 },
/* U+e846 */ { 0, 0, 0, 0, 0 },
/* U+e847 */ { 0, 0, 0, 0, 0 },
/* U+e848 */ { 0, 0, 0, 0, 0 },
/* U+e849 */ { 0, 0, 0, 0, 0 },
/* U+e84a */ { 0, 0, 0, 0, 0 },
/* U+e84b */ { 0, 0, 0, 0, 0 },
/* U+e84c */ { 0, 0, 0, 0, 0 },
/* U+e84d */ { 0, 0, 0, 0, 0 },
/* U+e84e */ { 0, 0, 0, 0, 0 },
/* U+e84f */ { 0, 0, 0, 0, 0 },
/* U+e850 */ { 0, 0, 0, 0, 0 },
/* U+e851 */ { 0, 0, 0, 0, 0 },
/* U+e852 */ { 0, 0, 0, 0, 0 },
/* U+e853 */ { 0, 0, 0, 0, 0 },
/* U+e854 */ { 0, 0, 0, 0, 0 },
/* U+e855 */ { 0, 0, 0, 0, 0 },
/* U+e856 */ { 0, 0, 0, 0, 0 },
/* U+e857 */ { 0, 0, 0, 0, 0 },
/* U+e858 */ { 0, 0, 0, 0, 0 },
/* U+e859 */ { 0, 0, 0, 0, 0 },
/* U+e85a */ { 0, 0, 0, 0, 0 },
/* U+e85b */ { 0, 0, 0, 0, 0 },
/* U+e85c */ { 0, 0, 0, 0, 0 },
/* U+e85d */ { 0, 0, 0, 0, 0 },
/* U+e85e */ { 0, 0, 0, 0, 0 },
/* U+e85f */ { 0, 0, 0, 0, 0 },
/* U+e860 */ { 0, 0, 0, 0, 0 },
/* U+e861 */ { 0, 0, 0, 0, 0 },
/* U+e862 */ { 0, 0, 0, 0, 0 },
/* U+e863 */ { 0, 0, 0, 0, 0 },
/* U+e864 */ { 0, 0, 0, 0, 0 },
/* U+e865 */ { 0, 0, 0, 0, 0 },
/* U+e866 */ { 0, 0, 0, 0, 0 },
/* U+e867 */ { 0, 0, 0, 0, 0 },
/* U+e868 */ { 0, 0, 0, 0, 0 },
/* U+e869 */ { 0, 0, 0, 0, 0 },
/* U+e86a */ { 0, 0, 0, 0, 0 },
/* U+e86b */ { 0, 0, 0, 0, 0 },
/* U+e86c */ { 0, 0, 0, 0, 0 },
/* U+e86d */ { 0, 0, 0, 0, 0 },
/* U+e86e */ { 0, 0, 0, 0, 0 },
/* U+e86f */ { 0, 0, 0, 0, 0 },
/* U+e870 */ { 0, 0, 0, 0, 0 },
/* U+e871 */ { 0, 0, 0, 0, 0 },
/* U+e872 */ { 0, 0, 0, 0, 0 },
/* U+e873 */ { 0, 0, 0, 0, 0 },
/* U+e874 */ { 0, 0, 0, 0, 0 },
/* U+e875 */ { 0, 0, 0, 0, 0 },
/* U+e876 */ { 0, 0, 0, 0, 0 },
/* U+e877 */ { 0, 0, 0, 0, 0 },
/* U+e878 */ { 0, 0, 0, 0, 0 },
/* U+e879 */ { 0, 0, 0, 0, 0 },
/* U+e87a */ { 0, 0, 0, 0, 0 },
/* U+e87b */ { 0, 0, 0, 0, 0 },
/* U+e87c */ { 0, 0, 0, 0, 0 },
/* U+e87d */ { 0, 0, 0, 0, 0 },
/* U+e87e */ { 0, 0, 0, 0, 0 },
/* U+e87f */ { 0, 0, 0, 0, 0 },
/* U+e880 */ { 0, 0, 0, 0, 0 },
/* U+e881 */ { 0, 0, 0, 0, 0 },
/* U+e882 */ { 0, 0, 0, 0, 0 },
/* U+e883 */ { 0, 0, 0, 0, 0 },
/* U+e884 */ { 0, 0, 0, 0, 0 },
/* U+e885 */ { 0, 0, 0, 0, 0 },
/* U+e886 */ { 0, 0, 0, 0, 0 },
/* U+e887 */ { 0, 0, 0, 0, 0 },
/* U+e888 */ { 0, 0, 0, 0, 0 },
/* U+e889 */ { 0, 0, 0, 0, 0 },
/* U+e88a */ { 0, 0, 0, 0, 0 },
/* U+e88b */ { 0, 0, 0, 0, 0 },
/* U+e88c */ { 0, 0, 0, 0, 0 },
/* U+e88d */ { 0, 0, 0, 0, 0 },
/* U+e88e */ { 0, 0, 0, 0, 0 },
/* U+e88f */ { 0, 0, 0, 0, 0 },
/* U+e890 */ { 0, 0, 0, 0, 0 },
/* U+e891 */ { 0, 0, 0, 0, 0 },
/* U+e892 */ { 0, 0, 0, 0, 0 },
/* U+e893 */ { 0, 0, 0, 0, 0 },
/* U+e894 */ { 0, 0, 0, 0, 0 },
/* U+e895 */ { 0, 0, 0, 0, 0 },
/* U+e896 */ { 0, 0, 0, 0, 0 },
/* U+e897 */ { 0, 0, 0, 0, 0 },
/* U+e898 */ { 0, 0, 0, 0, 0 },
/* U+e899 */ { 0, 0, 0, 0, 0 },
/* U+e89a */ { 0, 0, 0, 0, 0 },
/* U+e89b */ { 0, 0, 0, 0, 0 },
/* U+e89c */ { 0, 0, 0, 0, 0 },
/* U+e89d */ { 0, 0, 0, 0, 0 },
/* U+e89e */ { 0, 0, 0, 0, 0 },
/* U+e89f */ { 0, 0, 0, 0, 0 },
/* U+e8a0 */ { 0, 0, 0, 0, 0 },
/* U+e8a1 */ { 0, 0, 0, 0, 0 },
/* U+e8a2 */ { 0, 0, 0, 0, 0 },
/* U+e8a3 */ { 0, 0, 0, 0, 0 },
/* U+e8a4 */ { 0, 0, 0, 0, 0 },
/* U+e8a5 */ { 0, 0, 0, 0, 0 },
/* U+e8a6 */ { 0, 0, 0, 0, 0 },
/* U+e8a7 */ { 0, 0, 0, 0, 0 },
/* U+e8a8 */ { 0, 0, 0, 0, 0 },
/* U+e8a9 */ { 0, 0, 0, 0, 0 },
/* U+e8aa */ { 0, 0, 0, 0, 0 },
/* U+e8ab */ { 0, 0, 0, 0, 0 },
/* U+e8ac */ { 0, 0, 0, 0, 0 },
/* U+e8ad */ { 0, 0, 0, 0, 0 },
/* U+e8ae */ { 0, 0, 0, 0, 0 },
/* U+e8af */ { 0, 0, 0, 0, 0 },
/* U+e8b0 */ { 0, 0, 0, 0, 0 },
/* U+e8b1 */ { 0, 0, 0, 0, 0 },
/* U+e8b2 */ { 0, 0, 0, 0, 0 },
/* U+e8b3 */ { 0, 0, 0, 0, 0 },
/* U+e8b4 */ { 0, 0, 0, 0, 0 },
/* U+e8b5 */ { 0, 0, 0, 0, 0 },
/* U+e8b6 */ { 0, 0, 0, 0, 0 },
/* U+e8b7 */ { 0, 0, 0, 0, 0 },
/* U+e8b8 */ { 0, 0, 0, 0, 0 },
/* U+e8b9 */ { 0, 0, 0, 0, 0 },
/* U+e8ba */ { 0, 0, 0, 0, 0 },
/* U+e8bb */ { 0, 0, 0, 0, 0 },
/* U+e8bc */ { 0, 0, 0, 0, 0 },
/* U+e8bd */ { 0, 0, 0, 0, 0 },
/* U+e8be */ { 0, 0, 0, 0, 0 },
/* U+e8bf */ { 0, 0, 0, 0, 0 },
/* U+e8c0 */ { 0, 0, 0, 0, 0 },
/* U+e8c1 */ { 0, 0, 0, 0, 0 },
/* U+e8c2 */ { 0, 0, 0, 0, 0 },
/* U+e8c3 */ { 0, 0, 0, 0, 0 },
/* U+e8c4 */ { 0, 0, 0, 0, 0 },
/* U+e8c5 */ { 0, 0, 0, 0, 0 },
/* U+e8c6 */ { 0, 0, 0, 0, 0 },
/* U+e8c7 */ { 0, 0, 0, 0, 0 },
/* U+e8c8 */ { 0, 0, 0, 0, 0 },
/* U+e8c9 */ { 0, 0, 0, 0, 0 },
/* U+e8ca */ { 0, 0, 0, 0, 0 },
/* U+e8cb */ { 0, 0, 0, 0, 0 },
/* U+e8cc */ { 0, 0, 0, 0, 0 },
/* U+e8cd */ { 0, 0, 0, 0, 0 },
/* U+e8ce */ { 0, 0, 0, 0, 0 },
/* U+e8cf */ { 0, 0, 0, 0, 0 },
/* U+e8d0 */ { 0, 0, 0, 0, 0 },
/* U+e8d1 */ { 0, 0, 0, 0, 0 },
/* U+e8d2 */ { 0, 0, 0, 0, 0 },
/* U+e8d3 */ { 0, 0, 0, 0, 0 },
/* U+e8d4 */ { 0, 0, 0, 0, 0 },
/* U+e8d5 */ { 0, 0, 0, 0, 0 },
/* U+e8d6 */ { 0, 0, 0, 0, 0 },
/* U+e8d7 */ { 0, 0, 0, 0, 0 },
/* U+e8d8 */ { 0, 0, 0, 0, 0 },
/* U+e8d9 */ { 0, 0, 0, 0, 0 },
/* U+e8da */ { 0, 0, 0, 0, 0 },
/* U+e8db */ { 0, 0, 0, 0, 0 },
/* U+e8dc */ { 0, 0, 0, 0, 0 },
/* U+e8dd */ { 0, 0, 0, 0, 0 },
/* U+e8de */ { 0, 0, 0, 0, 0 },
/* U+e8df */ { 0, 0, 0, 0, 0 },
/* U+e8e0 */ { 0, 0, 0, 0, 0 },
/* U+e8e1 */ { 0, 0, 0, 0, 0 },
/* U+e8e2 */ { 0, 0, 0, 0, 0 },
/* U+e8e3 */ { 0, 0, 0, 0, 0 },
/* U+e8e4 */ { 0, 0, 0, 0, 0 },
/* U+e8e5 */ { 0, 0, 0, 0, 0 },
/* U+e8e6 */ { 0, 0, 0, 0, 0 },
/* U+e8e7 */ { 0, 0, 0, 0, 0 },
/* U+e8e8 */ { 0, 0, 0, 0, 0 },
/* U+e8e9 */ { 0, 0, 0, 0, 0 },
/* U+e8ea */ { 0, 0, 0, 0, 0 },
/* U+e8eb */ { 0, 0, 0, 0, 0 },
/* U+e8ec */ { 0, 0, 0, 0, 0 },
/* U+e8ed */ { 0, 0, 0, 0, 0 },
/* U+e8ee */ { 0, 0, 0, 0, 0 },
/* U+e8ef */ { 0, 0, 0, 0, 0 },
/* U+e8f0 */ { 0, 0, 0, 0, 0 },
/* U+e8f1 */ { 0, 0, 0, 0, 0 },
/* U+e8f2 */ { 0, 0, 0, 0, 0 },
/* U+e8f3 */ { 0, 0, 0, 0, 0 },
/* U+e8f4 */ { 0, 0, 0, 0, 0 },
/* U+e8f5 */ { 0, 0, 0, 0, 0 },
/* U+e8f6 */ { 0, 0, 0, 0, 0 },
/* U+e8f7 */ { 0, 0, 0, 0, 0 },
/* U+e8f8 */ { 0, 0, 0, 0, 0 },
/* U+e8f9 */ { 0, 0, 0, 0, 0 },
/* U+e8fa */ { 0, 0, 0, 0, 0 },
/* U+e8fb */ { 0, 0, 0, 0, 0 },
/* U+e8fc */ { 0, 0, 0, 0, 0 },
/* U+e8fd */ { 0, 0, 0, 0, 0 },
/* U+e8fe */ { 0, 0, 0, 0, 0 },
/* U+e8ff */ { 0, 0, 0, 0, 0 },
/* U+e900 */ { 0, 0, 0, 0, 0 },
/* U+e901 */ { 0, 0, 0, 0, 0 },
/* U+e902 */ { 0, 0, 0, 0, 0 },
/* U+e903 */ { 0, 0, 0, 0, 0 },
/* U+e904 */ { 0, 0, 0, 0, 0 },
/* U+e905 */ { 0, 0, 0, 0, 0 },
/* U+e906 */ { 0, 0, 0, 0, 0 },
/* U+e907 */ { 0, 0, 0, 0, 0 },
/* U+e908 */ { 0, 0, 0, 0, 0 },
/* U+e909 */ { 0, 0, 0, 0, 0 },
/* U+e90a */ { 0, 0, 0, 0, 0 },
/* U+e90b */ { 0, 0, 0, 0, 0 },
/* U+e90c */ { 0, 0, 0, 0, 0 },
/* U+e90d */ { 0, 0, 0, 0, 0 },
/* U+e90e */ { 0, 0, 0, 0, 0 },
/* U+e90f */ { 0, 0, 0, 0, 0 },
/* U+e910 */ { 0, 0, 0, 0, 0 },
/* U+e911 */ { 0, 0, 0, 0, 0 },
/* U+e912 */ { 0, 0, 0, 0, 0 },
/* U+e913 */ { 0, 0, 0, 0, 0 },
/* U+e914 */ { 0, 0, 0, 0, 0 },
/* U+e915 */ { 0, 0, 0, 0, 0 },
/* U+e916 */ { 0, 0, 0, 0, 0 },
/* U+e917 */ { 0, 0, 0, 0, 0 },
/* U+e918 */ { 0, 0, 0, 0, 0 },
/* U+e919 */ { 0, 0, 0, 0, 0 },
/* U+e91a */ { 0, 0, 0, 0, 0 },
/* U+e91b */ { 0, 0, 0, 0, 0 },
/* U+e91c */ { 0, 0, 0, 0, 0 },
/* U+e91d */ { 0, 0, 0, 0, 0 },
/* U+e91e */ { 0, 0, 0, 0, 0 },
/* U+e91f */ { 0, 0, 0, 0, 0 },
/* U+e920 */ { 0, 0, 0, 0, 0 },
/* U+e921 */ { 0, 0, 0, 0, 0 },
/* U+e922 */ { 0, 0, 0, 0, 0 },
/* U+e923 */ { 0, 0, 0, 0, 0 },
/* U+e924 */ { 0, 0, 0, 0, 0 },
/* U+e925 */ { 0, 0, 0, 0, 0 },
/* U+e926 */ { 0, 0, 0, 0, 0 },
/* U+e927 */ { 0, 0, 0, 0, 0 },
/* U+e928 */ { 0, 0, 0, 0, 0 },
/* U+e929 */ { 0, 0, 0, 0, 0 },
/* U+e92a */ { 0, 0, 0, 0, 0 },
/* U+e92b */ { 0, 0, 0, 0, 0 },
/* U+e92c */ { 0, 0, 0, 0, 0 },
/* U+e92d */ { 0, 0, 0, 0, 0 },
/* U+e92e */ { 0, 0, 0, 0, 0 },
/* U+e92f */ { 0, 0, 0, 0, 0 },
/* U+e930 */ { 0, 0, 0, 0, 0 },
/* U+e931 */ { 0, 0, 0, 0, 0 },
/* U+e932 */ { 0, 0, 0, 0, 0 },
/* U+e933 */ { 0, 0, 0, 0, 0 },
/* U+e934 */ { 0, 0, 0, 0, 0 },
/* U+e935 */ { 0, 0, 0, 0, 0 },
/* U+e936 */ { 0, 0, 0, 0, 0 },
/* U+e937 */ { 0, 0, 0, 0, 0 },
/* U+e938 */ { 0, 0, 0, 0, 0 },
/* U+e939 */ { 0, 0, 0, 0, 0 },
/* U+e93a */ { 0, 0, 0, 0, 0 },
/* U+e93b */ { 0, 0, 0, 0, 0 },
/* U+e93c */ { 0, 0, 0, 0, 0 },
/* U+e93d */ { 0, 0, 0, 0, 0 },
/* U+e93e */ { 0, 0, 0, 0, 0 },
/* U+e93f */ { 0, 0, 0, 0, 0 },
/* U+e940 */ { 0, 0, 0, 0, 0 },
/* U+e941 */ { 0, 0, 0, 0, 0 },
/* U+e942 */ { 0, 0, 0, 0, 0 },
/* U+e943 */ { 0, 0, 0, 0, 0 },
/* U+e944 */ { 0, 0, 0, 0, 0 },
/* U+e945 */ { 0, 0, 0, 0, 0 },
/* U+e946 */ { 0, 0, 0, 0, 0 },
/* U+e947 */ { 0, 0, 0, 0, 0 },
/* U+e948 */ { 0, 0, 0, 0, 0 },
/* U+e949 */ { 0, 0, 0, 0, 0 },
/* U+e94a */ { 0, 0, 0, 0, 0 },
/* U+e94b */ { 0, 0, 0, 0, 0 },
/* U+e94c */ { 0, 0, 0, 0, 0 },
/* U+e94d */ { 0, 0, 0, 0, 0 },
/* U+e94e */ { 0, 0, 0, 0, 0 },
/* U+e94f */ { 0, 0, 0, 0, 0 },
/* U+e950 */ { 0, 0, 0, 0, 0 },
/* U+e951 */ { 0, 0, 0, 0, 0 },
/* U+e952 */ { 0, 0, 0, 0, 0 },
/* U+e953 */ { 0, 0, 0, 0, 0 },
/* U+e954 */ { 0, 0, 0, 0, 0 },
/* U+e955 */ { 0, 0, 0, 0, 0 },
/* U+e956 */ { 0, 0, 0, 0, 0 },
/* U+e957 */ { 0, 0, 0, 0, 0 },
/* U+e958 */ { 0, 0, 0, 0, 0 },
/* U+e959 */ { 0, 0, 0, 0, 0 },
/* U+e95a */ { 0, 0, 0, 0, 0 },
/* U+e95b */ { 0, 0, 0, 0, 0 },
/* U+e95c */ { 0, 0, 0, 0, 0 },
/* U+e95d */ { 0, 0, 0, 0, 0 },
/* U+e95e */ { 0, 0, 0, 0, 0 },
/* U+e95f */ { 0, 0, 0, 0, 0 },
/* U+e960 */ { 0, 0, 0, 0, 0 },
/* U+e961 */ { 0, 0, 0, 0, 0 },
/* U+e962 */ { 0, 0, 0, 0, 0 },
/* U+e963 */ { 0, 0, 0, 0, 0 },
/* U+e964 */ { 0, 0, 0, 0, 0 },
/* U+e965 */ { 0, 0, 0, 0, 0 },
/* U+e966 */ { 0, 0, 0, 0, 0 },
/* U+e967 */ { 0, 0, 0, 0, 0 },
/* U+e968 */ { 0, 0, 0, 0, 0 },
/* U+e969 */ { 0, 0, 0, 0, 0 },
/* U+e96a */ { 0, 0, 0, 0, 0 },
/* U+e96b */ { 0, 0, 0, 0, 0 },
/* U+e96c */ { 0, 0, 0, 0, 0 },
/* U+e96d */ { 0, 0, 0, 0, 0 },
/* U+e96e */ { 0, 0, 0, 0, 0 },
/* U+e96f */ { 0, 0, 0, 0, 0 },
/* U+e970 */ { 0, 0, 0, 0, 0 },
/* U+e971 */ { 0, 0, 0, 0, 0 },
/* U+e972 */ { 0, 0, 0, 0, 0 },
/* U+e973 */ { 0, 0, 0, 0, 0 },
/* U+e974 */ { 0, 0, 0, 0, 0 },
/* U+e975 */ { 0, 0, 0, 0, 0 },
/* U+e976 */ { 0, 0, 0, 0, 0 },
/* U+e977 */ { 0, 0, 0, 0, 0 },
/* U+e978 */ { 0, 0, 0, 0, 0 },
/* U+e979 */ { 0, 0, 0, 0, 0 },
/* U+e97a */ { 0, 0, 0, 0, 0 },
/* U+e97b */ { 0, 0, 0, 0, 0 },
/* U+e97c */ { 0, 0, 0, 0, 0 },
/* U+e97d */ { 0, 0, 0, 0, 0 },
/* U+e97e */ { 0, 0, 0, 0, 0 },
/* U+e97f */ { 0, 0, 0, 0, 0 },
/* U+e980 */ { 0, 0, 0, 0, 0 },
/* U+e981 */ { 0, 0, 0, 0, 0 },
/* U+e982 */ { 0, 0, 0, 0, 0 },
/* U+e983 */ { 0, 0, 0, 0, 0 },
/* U+e984 */ { 0, 0, 0, 0, 0 },
/* U+e985 */ { 0, 0, 0, 0, 0 },
/* U+e986 */ { 0, 0, 0, 0, 0 },
/* U+e987 */ { 0, 0, 0, 0, 0 },
/* U+e988 */ { 0, 0, 0, 0, 0 },
/* U+e989 */ { 0, 0, 0, 0, 0 },
/* U+e98a */ { 0, 0, 0, 0, 0 },
/* U+e98b */ { 0, 0, 0, 0, 0 },
/* U+e98c */ { 0, 0, 0, 0, 0 },
/* U+e98d */ { 0, 0, 0, 0, 0 },
/* U+e98e */ { 0, 0, 0, 0, 0 },
/* U+e98f */ { 0, 0, 0, 0, 0 },
/* U+e990 */ { 0, 0, 0, 0, 0 },
/* U+e991 */ { 0, 0, 0, 0, 0 },
/* U+e992 */ { 0, 0, 0, 0, 0 },
/* U+e993 */ { 0, 0, 0, 0, 0 },
/* U+e994 */ { 0, 0, 0, 0, 0 },
/* U+e995 */ { 0, 0, 0, 0, 0 },
/* U+e996 */ { 0, 0, 0, 0, 0 },
/* U+e997 */ { 0, 0, 0, 0, 0 },
/* U+e998 */ { 0, 0, 0, 0, 0 },
/* U+e999 */ { 0, 0, 0, 0, 0 },
/* U+e99a */ { 0, 0, 0, 0, 0 },
/* U+e99b */ { 0, 0, 0, 0, 0 },
/* U+e99c */ { 0, 0, 0, 0, 0 },
/* U+e99d */ { 0, 0, 0, 0, 0 },
/* U+e99e */ { 0, 0, 0, 0, 0 },
/* U+e99f */ { 0, 0, 0, 0, 0 },
/* U+e9a0 */ { 0, 0, 0, 0, 0 },
/* U+e9a1 */ { 0, 0, 0, 0, 0 },
/* U+e9a2 */ { 0, 0, 0, 0, 0 },
/* U+e9a3 */ { 0, 0, 0, 0, 0 },
/* U+e9a4 */ { 0, 0, 0, 0, 0 },
/* U+e9a5 */ { 0, 0, 0, 0, 0 },
/* U+e9a6 */ { 0, 0, 0, 0, 0 },
/* U+e9a7 */ { 0, 0, 0, 0, 0 },
/* U+e9a8 */ { 0, 0, 0, 0, 0 },
/* U+e9a9 */ { 0, 0, 0, 0, 0 },
/* U+e9aa */ { 0, 0, 0, 0, 0 },
/* U+e9ab */ { 0, 0, 0, 0, 0 },
/* U+e9ac */ { 0, 0, 0, 0, 0 },
/* U+e9ad */ { 0, 0, 0, 0, 0 },
/* U+e9ae */ { 0, 0, 0, 0, 0 },
/* U+e9af */ { 0, 0, 0, 0, 0 },
/* U+e9b0 */ { 0, 0, 0, 0, 0 },
/* U+e9b1 */ { 0, 0, 0, 0, 0 },
/* U+e9b2 */ { 0, 0, 0, 0, 0 },
/* U+e9b3 */ { 0, 0, 0, 0, 0 },
/* U+e9b4 */ { 0, 0, 0, 0, 0 },
/* U+e9b5 */ { 0, 0, 0, 0, 0 },
/* U+e9b6 */ { 0, 0, 0, 0, 0 },
/* U+e9b7 */ { 0, 0, 0, 0, 0 },
/* U+e9b8 */ { 0, 0, 0, 0, 0 },
/* U+e9b9 */ { 0, 0, 0, 0, 0 },
/* U+e9ba */ { 0, 0, 0, 0, 0 },
/* U+e9bb */ { 0, 0, 0, 0, 0 },
/* U+e9bc */ { 0, 0, 0, 0, 0 },
/* U+e9bd */ { 0, 0, 0, 0, 0 },
/* U+e9be */ { 0, 0, 0, 0, 0 },
/* U+e9bf */ { 0, 0, 0, 0, 0 },
/* U+e9c0 */ { 0, 0, 0, 0, 0 },
/* U+e9c1 */ { 0, 0, 0, 0, 0 },
/* U+e9c2 */ { 0, 0, 0, 0, 0 },
/* U+e9c3 */ { 0, 0, 0, 0, 0 },
/* U+e9c4 */ { 0, 0, 0, 0, 0 },
/* U+e9c5 */ { 0, 0, 0, 0, 0 },
/* U+e9c6 */ { 0, 0, 0, 0, 0 },
/* U+e9c7 */ { 0, 0, 0, 0, 0 },
/* U+e9c8 */ { 0, 0, 0, 0, 0 },
/* U+e9c9 */ { 0, 0, 0, 0, 0 },
/* U+e9ca */ { 0, 0, 0, 0, 0 },
/* U+e9cb */ { 0, 0, 0, 0, 0 },
/* U+e9cc */ { 0, 0, 0, 0, 0 },
/* U+e9cd */ { 0, 0, 0, 0, 0 },
/* U+e9ce */ { 0, 0, 0, 0, 0 },
/* U+e9cf */ { 0, 0, 0, 0, 0 },
/* U+e9d0 */ { 0, 0, 0, 0, 0 },
/* U+e9d1 */ { 0, 0, 0, 0, 0 },
/* U+e9d2 */ { 0, 0, 0, 0, 0 },
/* U+e9d3 */ { 0, 0, 0, 0, 0 },
/* U+e9d4 */ { 0, 0, 0, 0, 0 },
/* U+e9d5 */ { 0, 0, 0, 0, 0 },
/* U+e9d6 */ { 0, 0, 0, 0, 0 },
/* U+e9d7 */ { 0, 0, 0, 0, 0 },
/* U+e9d8 */ { 0, 0, 0, 0, 0 },
/* U+e9d9 */ { 0, 0, 0, 0, 0 },
/* U+e9da */ { 0, 0, 0, 0, 0 },
/* U+e9db */ { 0, 0, 0, 0, 0 },
/* U+e9dc */ { 0, 0, 0, 0, 0 },
/* U+e9dd */ { 0, 0, 0, 0, 0 },
/* U+e9de */ { 0, 0, 0, 0, 0 },
/* U+e9df */ { 0, 0, 0, 0, 0 },
/* U+e9e0 */ { 0, 0, 0, 0, 0 },
/* U+e9e1 */ { 0, 0, 0, 0, 0 },
/* U+e9e2 */ { 0, 0, 0, 0, 0 },
/* U+e9e3 */ { 0, 0, 0, 0, 0 },
/* U+e9e4 */ { 0, 0, 0, 0, 0 },
/* U+e9e5 */ { 0, 0, 0, 0, 0 },
/* U+e9e6 */ { 0, 0, 0, 0, 0 },
/* U+e9e7 */ { 0, 0, 0, 0, 0 },
/* U+e9e8 */ { 0, 0, 0, 0, 0 },
/* U+e9e9 */ { 0, 0, 0, 0, 0 },
/* U+e9ea */ { 0, 0, 0, 0, 0 },
/* U+e9eb */ { 0, 0, 0, 0, 0 },
/* U+e9ec */ { 0, 0, 0, 0, 0 },
/* U+e9ed */ { 0, 0, 0, 0, 0 },
/* U+e9ee */ { 0, 0, 0, 0, 0 },
/* U+e9ef */ { 0, 0, 0, 0, 0 },
/* U+e9f0 */ { 0, 0, 0, 0, 0 },
/* U+e9f1 */ { 0, 0, 0, 0, 0 },
/* U+e9f2 */ { 0, 0, 0, 0, 0 },
/* U+e9f3 */ { 0, 0, 0, 0, 0 },
/* U+e9f4 */ { 0, 0, 0, 0, 0 },
/* U+e9f5 */ { 0, 0, 0, 0, 0 },
/* U+e9f6 */ { 0, 0, 0, 0, 0 },
/* U+e9f7 */ { 0, 0, 0, 0, 0 },
/* U+e9f8 */ { 0, 0, 0, 0, 0 },
/* U+e9f9 */ { 0, 0, 0, 0, 0 },
/* U+e9fa */ { 0, 0, 0, 0, 0 },
/* U+e9fb */ { 0, 0, 0, 0, 0 },
/* U+e9fc */ { 0, 0, 0, 0, 0 },
/* U+e9fd */ { 0, 0, 0, 0, 0 },
/* U+e9fe */ { 0, 0, 0, 0, 0 },
/* U+e9ff */ { 0, 0, 0, 0, 0 },
/* U+ea00 */ { 0, 0, 0, 0, 0 },
/* U+ea01 */ { 0, 0, 0, 0, 0 },
/* U+ea02 */ { 0, 0, 0, 0, 0 },
/* U+ea03 */ { 0, 0, 0, 0, 0 },
/* U+ea04 */ { 0, 0, 0, 0, 0 },
/* U+ea05 */ { 0, 0, 0, 0, 0 },
/* U+ea06 */ { 0, 0, 0, 0, 0 },
/* U+ea07 */ { 0, 0, 0, 0, 0 },
/* U+ea08 */ { 0, 0, 0, 0, 0 },
/* U+ea09 */ { 0, 0, 0, 0, 0 },
/* U+ea0a */ { 0, 0, 0, 0, 0 },
/* U+ea0b */ { 0, 0, 0, 0, 0 },
/* U+ea0c */ { 0, 0, 0, 0, 0 },
/* U+ea0d */ { 0, 0, 0, 0, 0 },
/* U+ea0e */ { 0, 0, 0, 0, 0 },
/* U+ea0f */ { 0, 0, 0, 0, 0 },
/* U+ea10 */ { 0, 0, 0, 0, 0 },
/* U+ea11 */ { 0, 0, 0, 0, 0 },
/* U+ea12 */ { 0, 0, 0, 0, 0 },
/* U+ea13 */ { 0, 0, 0, 0, 0 },
/* U+ea14 */ { 0, 0, 0, 0, 0 },
/* U+ea15 */ { 0, 0, 0, 0, 0 },
/* U+ea16 */ { 0, 0, 0, 0, 0 },
/* U+ea17 */ { 0, 0, 0, 0, 0 },
/* U+ea18 */ { 0, 0, 0, 0, 0 },
/* U+ea19 */ { 0, 0, 0, 0, 0 },
/* U+ea1a */ { 0, 0, 0, 0, 0 },
/* U+ea1b */ { 0, 0, 0, 0, 0 },
/* U+ea1c */ { 0, 0, 0, 0, 0 },
/* U+ea1d */ { 0, 0, 0, 0, 0 },
/* U+ea1e */ { 0, 0, 0, 0, 0 },
/* U+ea1f */ { 0, 0, 0, 0, 0 },
/* U+ea20 */ { 0, 0, 0, 0, 0 },
/* U+ea21 */ { 0, 0, 0, 0, 0 },
/* U+ea22 */ { 0, 0, 0, 0, 0 },
/* U+ea23 */ { 0, 0, 0, 0, 0 },
/* U+ea24 */ { 0, 0, 0, 0, 0 },
/* U+ea25 */ { 0, 0, 0, 0, 0 },
/* U+ea26 */ { 0, 0, 0, 0, 0 },
/* U+ea27 */ { 0, 0, 0, 0, 0 },
/* U+ea28 */ { 0, 0, 0, 0, 0 },
/* U+ea29 */ { 0, 0, 0, 0, 0 },
/* U+ea2a */ { 0, 0, 0, 0, 0 },
/* U+ea2b */ { 0, 0, 0, 0, 0 },
/* U+ea2c */ { 0, 0, 0, 0, 0 },
/* U+ea2d */ { 0, 0, 0, 0, 0 },
/* U+ea2e */ { 0, 0, 0, 0, 0 },
/* U+ea2f */ { 0, 0, 0, 0, 0 },
/* U+ea30 */ { 0, 0, 0, 0, 0 },
/* U+ea31 */ { 0, 0, 0, 0, 0 },
/* U+ea32 */ { 0, 0, 0, 0, 0 },
/* U+ea33 */ { 0, 0, 0, 0, 0 },
/* U+ea34 */ { 0, 0, 0, 0, 0 },
/* U+ea35 */ { 0, 0, 0, 0, 0 },
/* U+ea36 */ { 0, 0, 0, 0, 0 },
/* U+ea37 */ { 0, 0, 0, 0, 0 },
/* U+ea38 */ { 0, 0, 0, 0, 0 },
/* U+ea39 */ { 0, 0, 0, 0, 0 },
/* U+ea3a */ { 0, 0, 0, 0, 0 },
/* U+ea3b */ { 0, 0, 0, 0, 0 },
/* U+ea3c */ { 0, 0, 0, 0, 0 },
/* U+ea3d */ { 0, 0, 0, 0, 0 },
/* U+ea3e */ { 0, 0, 0, 0, 0 },
/* U+ea3f */ { 0, 0, 0, 0, 0 },
/* U+ea40 */ { 0, 0, 0, 0, 0 },
/* U+ea41 */ { 0, 0, 0, 0, 0 },
/* U+ea42 */ { 0, 0, 0, 0, 0 },
/* U+ea43 */ { 0, 0, 0, 0, 0 },
/* U+ea44 */ { 0, 0, 0, 0, 0 },
/* U+ea45 */ { 0, 0, 0, 0, 0 },
/* U+ea46 */ { 0, 0, 0, 0, 0 },
/* U+ea47 */ { 0, 0, 0, 0, 0 },
/* U+ea48 */ { 0, 0, 0, 0, 0 },
/* U+ea49 */ { 0, 0, 0, 0, 0 },
/* U+ea4a */ { 0, 0, 0, 0, 0 },
/* U+ea4b */ { 0, 0, 0, 0, 0 },
/* U+ea4c */ { 0, 0, 0, 0, 0 },
/* U+ea4d */ { 0, 0, 0, 0, 0 },
/* U+ea4e */ { 0, 0, 0, 0, 0 },
/* U+ea4f */ { 0, 0, 0, 0, 0 },
/* U+ea50 */ { 0, 0, 0, 0, 0 },
/* U+ea51 */ { 0, 0, 0, 0, 0 },
/* U+ea52 */ { 0, 0, 0, 0, 0 },
/* U+ea53 */ { 0, 0, 0, 0, 0 },
/* U+ea54 */ { 0, 0, 0, 0, 0 },
/* U+ea55 */ { 0, 0, 0, 0, 0 },
/* U+ea56 */ { 0, 0, 0, 0, 0 },
/* U+ea57 */ { 0, 0, 0, 0, 0 },
/* U+ea58 */ { 0, 0, 0, 0, 0 },
/* U+ea59 */ { 0, 0, 0, 0, 0 },
/* U+ea5a */ { 0, 0, 0, 0, 0 },
/* U+ea5b */ { 0, 0, 0, 0, 0 },
/* U+ea5c */ { 0, 0, 0, 0, 0 },
/* U+ea5d */ { 0, 0, 0, 0, 0 },
/* U+ea5e */ { 0, 0, 0, 0, 0 },
/* U+ea5f */ { 0, 0, 0, 0, 0 },
/* U+ea60 */ { 0, 0, 0, 0, 0 },
/* U+ea61 */ { 0, 0, 0, 0, 0 },
/* U+ea62 */ { 0, 0, 0, 0, 0 },
/* U+ea63 */ { 0, 0, 0, 0, 0 },
/* U+ea64 */ { 0, 0, 0, 0, 0 },
/* U+ea65 */ { 0, 0, 0, 0, 0 },
/* U+ea66 */ { 0, 0, 0, 0, 0 },
/* U+ea67 */ { 0, 0, 0, 0, 0 },
/* U+ea68 */ { 0, 0, 0, 0, 0 },
/* U+ea69 */ { 0, 0, 0, 0, 0 },
/* U+ea6a */ { 0, 0, 0, 0, 0 },
/* U+ea6b */ { 0, 0, 0, 0, 0 },
/* U+ea6c */ { 0, 0, 0, 0, 0 },
/* U+ea6d */ { 0, 0, 0, 0, 0 },
/* U+ea6e */ { 0, 0, 0, 0, 0 },
/* U+ea6f */ { 0, 0, 0, 0, 0 },
/* U+ea70 */ { 0, 0, 0, 0, 0 },
/* U+ea71 */ { 0, 0, 0, 0, 0 },
/* U+ea72 */ { 0, 0, 0, 0, 0 },
/* U+ea73 */ { 0, 0, 0, 0, 0 },
/* U+ea74 */ { 0, 0, 0, 0, 0 },
/* U+ea75 */ { 0, 0, 0, 0, 0 },
/* U+ea76 */ { 0, 0, 0, 0, 0 },
/* U+ea77 */ { 0, 0, 0, 0, 0 },
/* U+ea78 */ { 0, 0, 0, 0, 0 },
/* U+ea79 */ { 0, 0, 0, 0, 0 },
/* U+ea7a */ { 0, 0, 0, 0, 0 },
/* U+ea7b */ { 0, 0, 0, 0, 0 },
/* U+ea7c */ { 0, 0, 0, 0, 0 },
/* U+ea7d */ { 0, 0, 0, 0, 0 },
/* U+ea7e */ { 0, 0, 0, 0, 0 },
/* U+ea7f */ { 0, 0, 0, 0, 0 },
/* U+ea80 */ { 0, 0, 0, 0, 0 },
/* U+ea81 */ { 0, 0, 0, 0, 0 },
/* U+ea82 */ { 0, 0, 0, 0, 0 },
/* U+ea83 */ { 0, 0, 0, 0, 0 },
/* U+ea84 */ { 0, 0, 0, 0, 0 },
/* U+ea85 */ { 0, 0, 0, 0, 0 },
/* U+ea86 */ { 0, 0, 0, 0, 0 },
/* U+ea87 */ { 0, 0, 0, 0, 0 },
/* U+ea88 */ { 0, 0, 0, 0, 0 },
/* U+ea89 */ { 0, 0, 0, 0, 0 },
/* U+ea8a */ { 0, 0, 0, 0, 0 },
/* U+ea8b */ { 0, 0, 0, 0, 0 },
/* U+ea8c */ { 0, 0, 0, 0, 0 },
/* U+ea8d */ { 0, 0, 0, 0, 0 },
/* U+ea8e */ { 0, 0, 0, 0, 0 },
/* U+ea8f */ { 0, 0, 0, 0, 0 },
/* U+ea90 */ { 0, 0, 0, 0, 0 },
/* U+ea91 */ { 0, 0, 0, 0, 0 },
/* U+ea92 */ { 0, 0, 0, 0, 0 },
/* U+ea93 */ { 0, 0, 0, 0, 0 },
/* U+ea94 */ { 0, 0, 0, 0, 0 },
/* U+ea95 */ { 0, 0, 0, 0, 0 },
/* U+ea96 */ { 0, 0, 0, 0, 0 },
/* U+ea97 */ { 0, 0, 0, 0, 0 },
/* U+ea98 */ { 0, 0, 0, 0, 0 },
/* U+ea99 */ { 0, 0, 0, 0, 0 },
/* U+ea9a */ { 0, 0, 0, 0, 0 },
/* U+ea9b */ { 0, 0, 0, 0, 0 },
/* U+ea9c */ { 0, 0, 0, 0, 0 },
/* U+ea9d */ { 0, 0, 0, 0, 0 },
/* U+ea9e */ { 0, 0, 0, 0, 0 },
/* U+ea9f */ { 0, 0, 0, 0, 0 },
/* U+eaa0 */ { 0, 0, 0, 0, 0 },
/* U+eaa1 */ { 0, 0, 0, 0, 0 },
/* U+eaa2 */ { 0, 0, 0, 0, 0 },
/* U+eaa3 */ { 0, 0, 0, 0, 0 },
/* U+eaa4 */ { 0, 0, 0, 0, 0 },
/* U+eaa5 */ { 0, 0, 0, 0, 0 },
/* U+eaa6 */ { 0, 0, 0, 0, 0 },
/* U+eaa7 */ { 0, 0, 0, 0, 0 },
/* U+eaa8 */ { 0, 0, 0, 0, 0 },
/* U+eaa9 */ { 0, 0, 0, 0, 0 },
/* U+eaaa */ { 0, 0, 0, 0, 0 },
/* U+eaab */ { 0, 0, 0, 0, 0 },
/* U+eaac */ { 0, 0, 0, 0, 0 },
/* U+eaad */ { 0, 0, 0, 0, 0 },
/* U+eaae */ { 0, 0, 0, 0, 0 },
/* U+eaaf */ { 0, 0, 0, 0, 0 },
/* U+eab0 */ { 0, 0, 0, 0, 0 },
/* U+eab1 */ { 0, 0, 0, 0, 0 },
/* U+eab2 */ { 0, 0, 0, 0, 0 },
/* U+eab3 */ { 0, 0, 0, 0, 0 },
/* U+eab4 */ { 0, 0, 0, 0, 0 },
/* U+eab5 */ { 0, 0, 0, 0, 0 },
/* U+eab6 */ { 0, 0, 0, 0, 0 },
/* U+eab7 */ { 0, 0, 0, 0, 0 },
/* U+eab8 */ { 0, 0, 0, 0, 0 },
/* U+eab9 */ { 0, 0, 0, 0, 0 },
/* U+eaba */ { 0, 0, 0, 0, 0 },
/* U+eabb */ { 0, 0, 0, 0, 0 },
/* U+eabc */ { 0, 0, 0, 0, 0 },
/* U+eabd */ { 0, 0, 0, 0, 0 },
/* U+eabe */ { 0, 0, 0, 0, 0 },
/* U+eabf */ { 0, 0, 0, 0, 0 },
/* U+eac0 */ { 0, 0, 0, 0, 0 },
/* U+eac1 */ { 0, 0, 0, 0, 0 },
/* U+eac2 */ { 0, 0, 0, 0, 0 },
/* U+eac3 */ { 0, 0, 0, 0, 0 },
/* U+eac4 */ { 0, 0, 0, 0, 0 },
/* U+eac5 */ { 0, 0, 0, 0, 0 },
/* U+eac6 */ { 0, 0, 0, 0, 0 },
/* U+eac7 */ { 0, 0, 0, 0, 0 },
/* U+eac8 */ { 0, 0, 0, 0, 0 },
/* U+eac9 */ { 0, 0, 0, 0, 0 },
/* U+eaca */ { 0, 0, 0, 0, 0 },
/* U+eacb */ { 0, 0, 0, 0, 0 },
/* U+eacc */ { 0, 0, 0, 0, 0 },
/* U+eacd */ { 0, 0, 0, 0, 0 },
/* U+eace */ { 0, 0, 0, 0, 0 },
/* U+eacf */ { 0, 0, 0, 0, 0 },
/* U+ead0 */ { 0, 0, 0, 0, 0 },
/* U+ead1 */ { 0, 0, 0, 0, 0 },
/* U+ead2 */ { 0, 0, 0, 0, 0 },
/* U+ead3 */ { 0, 0, 0, 0, 0 },
/* U+ead4 */ { 0, 0, 0, 0, 0 },
/* U+ead5 */ { 0, 0, 0, 0, 0 },
/* U+ead6 */ { 0, 0, 0, 0, 0 },
/* U+ead7 */ { 0, 0, 0, 0, 0 },
/* U+ead8 */ { 0, 0, 0, 0, 0 },
/* U+ead9 */ { 0, 0, 0, 0, 0 },
/* U+eada */ { 0, 0, 0, 0, 0 },
/* U+eadb */ { 0, 0, 0, 0, 0 },
/* U+eadc */ { 0, 0, 0, 0, 0 },
/* U+eadd */ { 0, 0, 0, 0, 0 },
/* U+eade */ { 0, 0, 0, 0, 0 },
/* U+eadf */ { 0, 0, 0, 0, 0 },
/* U+eae0 */ { 0, 0, 0, 0, 0 },
/* U+eae1 */ { 0, 0, 0, 0, 0 },
/* U+eae2 */ { 0, 0, 0, 0, 0 },
/* U+eae3 */ { 0, 0, 0, 0, 0 },
/* U+eae4 */ { 0, 0, 0, 0, 0 },
/* U+eae5 */ { 0, 0, 0, 0, 0 },
/* U+eae6 */ { 0, 0, 0, 0, 0 },
/* U+eae7 */ { 0, 0, 0, 0, 0 },
/* U+eae8 */ { 0, 0, 0, 0, 0 },
/* U+eae9 */ { 0, 0, 0, 0, 0 },
/* U+eaea */ { 0, 0, 0, 0, 0 },
/* U+eaeb */ { 0, 0, 0, 0, 0 },
/* U+eaec */ { 0, 0, 0, 0, 0 },
/* U+eaed */ { 0, 0, 0, 0, 0 },
/* U+eaee */ { 0, 0, 0, 0, 0 },
/* U+eaef */ { 0, 0, 0, 0, 0 },
/* U+eaf0 */ { 0, 0, 0, 0, 0 },
/* U+eaf1 */ { 0, 0, 0, 0, 0 },
/* U+eaf2 */ { 0, 0, 0, 0, 0 },
/* U+eaf3 */ { 0, 0, 0, 0, 0 },
/* U+eaf4 */ { 0, 0, 0, 0, 0 },
/* U+eaf5 */ { 0, 0, 0, 0, 0 },
/* U+eaf6 */ { 0, 0, 0, 0, 0 },
/* U+eaf7 */ { 0, 0, 0, 0, 0 },
/* U+eaf8 */ { 0, 0, 0, 0, 0 },
/* U+eaf9 */ { 0, 0, 0, 0, 0 },
/* U+eafa */ { 0, 0, 0, 0, 0 },
/* U+eafb */ { 0, 0, 0, 0, 0 },
/* U+eafc */ { 0, 0, 0, 0, 0 },
/* U+eafd */ { 0, 0, 0, 0, 0 },
/* U+eafe */ { 0, 0, 0, 0, 0 },
/* U+eaff */ { 0, 0, 0, 0, 0 },
/* U+eb00 */ { 0, 0, 0, 0, 0 },
/* U+eb01 */ { 0, 0, 0, 0, 0 },
/* U+eb02 */ { 0, 0, 0, 0, 0 },
/* U+eb03 */ { 0, 0, 0, 0, 0 },
/* U+eb04 */ { 0, 0, 0, 0, 0 },
/* U+eb05 */ { 0, 0, 0, 0, 0 },
/* U+eb06 */ { 0, 0, 0, 0, 0 },
/* U+eb07 */ { 0, 0, 0, 0, 0 },
/* U+eb08 */ { 0, 0, 0, 0, 0 },
/* U+eb09 */ { 0, 0, 0, 0, 0 },
/* U+eb0a */ { 0, 0, 0, 0, 0 },
/* U+eb0b */ { 0, 0, 0, 0, 0 },
/* U+eb0c */ { 0, 0, 0, 0, 0 },
/* U+eb0d */ { 0, 0, 0, 0, 0 },
/* U+eb0e */ { 0, 0, 0, 0, 0 },
/* U+eb0f */ { 0, 0, 0, 0, 0 },
/* U+eb10 */ { 0, 0, 0, 0, 0 },
/* U+eb11 */ { 0, 0, 0, 0, 0 },
/* U+eb12 */ { 0, 0, 0, 0, 0 },
/* U+eb13 */ { 0, 0, 0, 0, 0 },
/* U+eb14 */ { 0, 0, 0, 0, 0 },
/* U+eb15 */ { 0, 0, 0, 0, 0 },
/* U+eb16 */ { 0, 0, 0, 0, 0 },
/* U+eb17 */ { 0, 0, 0, 0, 0 },
/* U+eb18 */ { 0, 0, 0, 0, 0 },
/* U+eb19 */ { 0, 0, 0, 0, 0 },
/* U+eb1a */ { 0, 0, 0, 0, 0 },
/* U+eb1b */ { 0, 0, 0, 0, 0 },
/* U+eb1c */ { 0, 0, 0, 0, 0 },
/* U+eb1d */ { 0, 0, 0, 0, 0 },
/* U+eb1e */ { 0, 0, 0, 0, 0 },
/* U+eb1f */ { 0, 0, 0, 0, 0 },
/* U+eb20 */ { 0, 0, 0, 0, 0 },
/* U+eb21 */ { 0, 0, 0, 0, 0 },
/* U+eb22 */ { 0, 0, 0, 0, 0 },
/* U+eb23 */ { 0, 0, 0, 0, 0 },
/* U+eb24 */ { 0, 0, 0, 0, 0 },
/* U+eb25 */ { 0, 0, 0, 0, 0 },
/* U+eb26 */ { 0, 0, 0, 0, 0 },
/* U+eb27 */ { 0, 0, 0, 0, 0 },
/* U+eb28 */ { 0, 0, 0, 0, 0 },
/* U+eb29 */ { 0, 0, 0, 0, 0 },
/* U+eb2a */ { 0, 0, 0, 0, 0 },
/* U+eb2b */ { 0, 0, 0, 0, 0 },
/* U+eb2c */ { 0, 0, 0, 0, 0 },
/* U+eb2d */ { 0, 0, 0, 0, 0 },
/* U+eb2e */ { 0, 0, 0, 0, 0 },
/* U+eb2f */ { 0, 0, 0, 0, 0 },
/* U+eb30 */ { 0, 0, 0, 0, 0 },
/* U+eb31 */ { 0, 0, 0, 0, 0 },
/* U+eb32 */ { 0, 0, 0, 0, 0 },
/* U+eb33 */ { 0, 0, 0, 0, 0 },
/* U+eb34 */ { 0, 0, 0, 0, 0 },
/* U+eb35 */ { 0, 0, 0, 0, 0 },
/* U+eb36 */ { 0, 0, 0, 0, 0 },
/* U+eb37 */ { 0, 0, 0, 0, 0 },
/* U+eb38 */ { 0, 0, 0, 0, 0 },
/* U+eb39 */ { 0, 0, 0, 0, 0 },
/* U+eb3a */ { 0, 0, 0, 0, 0 },
/* U+eb3b */ { 0, 0, 0, 0, 0 },
/* U+eb3c */ { 0, 0, 0, 0, 0 },
/* U+eb3d */ { 0, 0, 0, 0, 0 },
/* U+eb3e */ { 0, 0, 0, 0, 0 },
/* U+eb3f */ { 0, 0, 0, 0, 0 },
/* U+eb40 */ { 0, 0, 0, 0, 0 },
/* U+eb41 */ { 0, 0, 0, 0, 0 },
/* U+eb42 */ { 0, 0, 0, 0, 0 },
/* U+eb43 */ { 0, 0, 0, 0, 0 },
/* U+eb44 */ { 0, 0, 0, 0, 0 },
/* U+eb45 */ { 0, 0, 0, 0, 0 },
/* U+eb46 */ { 0, 0, 0, 0, 0 },
/* U+eb47 */ { 0, 0, 0, 0, 0 },
/* U+eb48 */ { 0, 0, 0, 0, 0 },
/* U+eb49 */ { 0, 0, 0, 0, 0 },
/* U+eb4a */ { 0, 0, 0, 0, 0 },
/* U+eb4b */ { 0, 0, 0, 0, 0 },
/* U+eb4c */ { 0, 0, 0, 0, 0 },
/* U+eb4d */ { 0, 0, 0, 0, 0 },
/* U+eb4e */ { 0, 0, 0, 0, 0 },
/* U+eb4f */ { 0, 0, 0, 0, 0 },
/* U+eb50 */ { 0, 0, 0, 0, 0 },
/* U+eb51 */ { 0, 0, 0, 0, 0 },
/* U+eb52 */ { 0, 0, 0, 0, 0 },
/* U+eb53 */ { 0, 0, 0, 0, 0 },
/* U+eb54 */ { 0, 0, 0, 0, 0 },
/* U+eb55 */ { 0, 0, 0, 0, 0 },
/* U+eb56 */ { 0, 0, 0, 0, 0 },
/* U+eb57 */ { 0, 0, 0, 0, 0 },
/* U+eb58 */ { 0, 0, 0, 0, 0 },
/* U+eb59 */ { 0, 0, 0, 0, 0 },
/* U+eb5a */ { 0, 0, 0, 0, 0 },
/* U+eb5b */ { 0, 0, 0, 0, 0 },
/* U+eb5c */ { 0, 0, 0, 0, 0 },
/* U+eb5d */ { 0, 0, 0, 0, 0 },
/* U+eb5e */ { 0, 0, 0, 0, 0 },
/* U+eb5f */ { 0, 0, 0, 0, 0 },
/* U+eb60 */ { 0, 0, 0, 0, 0 },
/* U+eb61 */ { 0, 0, 0, 0, 0 },
/* U+eb62 */ { 0, 0, 0, 0, 0 },
/* U+eb63 */ { 0, 0, 0, 0, 0 },
/* U+eb64 */ { 0, 0, 0, 0, 0 },
/* U+eb65 */ { 0, 0, 0, 0, 0 },
/* U+eb66 */ { 0, 0, 0, 0, 0 },
/* U+eb67 */ { 0, 0, 0, 0, 0 },
/* U+eb68 */ { 0, 0, 0, 0, 0 },
/* U+eb69 */ { 0, 0, 0, 0, 0 },
/* U+eb6a */ { 0, 0, 0, 0, 0 },
/* U+eb6b */ { 0, 0, 0, 0, 0 },
/* U+eb6c */ { 0, 0, 0, 0, 0 },
/* U+eb6d */ { 0, 0, 0, 0, 0 },
/* U+eb6e */ { 0, 0, 0, 0, 0 },
/* U+eb6f */ { 0, 0, 0, 0, 0 },
/* U+eb70 */ { 0, 0, 0, 0, 0 },
/* U+eb71 */ { 0, 0, 0, 0, 0 },
/* U+eb72 */ { 0, 0, 0, 0, 0 },
/* U+eb73 */ { 0, 0, 0, 0, 0 },
/* U+eb74 */ { 0, 0, 0, 0, 0 },
/* U+eb75 */ { 0, 0, 0, 0, 0 },
/* U+eb76 */ { 0, 0, 0, 0, 0 },
/* U+eb77 */ { 0, 0, 0, 0, 0 },
/* U+eb78 */ { 0, 0, 0, 0, 0 },
/* U+eb79 */ { 0, 0, 0, 0, 0 },
/* U+eb7a */ { 0, 0, 0, 0, 0 },
/* U+eb7b */ { 0, 0, 0, 0, 0 },
/* U+eb7c */ { 0, 0, 0, 0, 0 },
/* U+eb7d */ { 0, 0, 0, 0, 0 },
/* U+eb7e */ { 0, 0, 0, 0, 0 },
/* U+eb7f */ { 0, 0, 0, 0, 0 },
/* U+eb80 */ { 0, 0, 0, 0, 0 },
/* U+eb81 */ { 0, 0, 0, 0, 0 },
/* U+eb82 */ { 0, 0, 0, 0, 0 },
/* U+eb83 */ { 0, 0, 0, 0, 0 },
/* U+eb84 */ { 0, 0, 0, 0, 0 },
/* U+eb85 */ { 0, 0, 0, 0, 0 },
/* U+eb86 */ { 0, 0, 0, 0, 0 },
/* U+eb87 */ { 0, 0, 0, 0, 0 },
/* U+eb88 */ { 0, 0, 0, 0, 0 },
/* U+eb89 */ { 0, 0, 0, 0, 0 },
/* U+eb8a */ { 0, 0, 0, 0, 0 },
/* U+eb8b */ { 0, 0, 0, 0, 0 },
/* U+eb8c */ { 0, 0, 0, 0, 0 },
/* U+eb8d */ { 0, 0, 0, 0, 0 },
/* U+eb8e */ { 0, 0, 0, 0, 0 },
/* U+eb8f */ { 0, 0, 0, 0, 0 },
/* U+eb90 */ { 0, 0, 0, 0, 0 },
/* U+eb91 */ { 0, 0, 0, 0, 0 },
/* U+eb92 */ { 0, 0, 0, 0, 0 },
/* U+eb93 */ { 0, 0, 0, 0, 0 },
/* U+eb94 */ { 0, 0, 0, 0, 0 },
/* U+eb95 */ { 0, 0, 0, 0, 0 },
/* U+eb96 */ { 0, 0, 0, 0, 0 },
/* U+eb97 */ { 0, 0, 0, 0, 0 },
/* U+eb98 */ { 0, 0, 0, 0, 0 },
/* U+eb99 */ { 0, 0, 0, 0, 0 },
/* U+eb9a */ { 0, 0, 0, 0, 0 },
/* U+eb9b */ { 0, 0, 0, 0, 0 },
/* U+eb9c */ { 0, 0, 0, 0, 0 },
/* U+eb9d */ { 0, 0, 0, 0, 0 },
/* U+eb9e */ { 0, 0, 0, 0, 0 },
/* U+eb9f */ { 0, 0, 0, 0, 0 },
/* U+eba0 */ { 0, 0, 0, 0, 0 },
/* U+eba1 */ { 0, 0, 0, 0, 0 },
/* U+eba2 */ { 0, 0, 0, 0, 0 },
/* U+eba3 */ { 0, 0, 0, 0, 0 },
/* U+eba4 */ { 0, 0, 0, 0, 0 },
/* U+eba5 */ { 0, 0, 0, 0, 0 },
/* U+eba6 */ { 0, 0, 0, 0, 0 },
/* U+eba7 */ { 0, 0, 0, 0, 0 },
/* U+eba8 */ { 0, 0, 0, 0, 0 },
/* U+eba9 */ { 0, 0, 0, 0, 0 },
/* U+ebaa */ { 0, 0, 0, 0, 0 },
/* U+ebab */ { 0, 0, 0, 0, 0 },
/* U+ebac */ { 0, 0, 0, 0, 0 },
/* U+ebad */ { 0, 0, 0, 0, 0 },
/* U+ebae */ { 0, 0, 0, 0, 0 },
/* U+ebaf */ { 0, 0, 0, 0, 0 },
/* U+ebb0 */ { 0, 0, 0, 0, 0 },
/* U+ebb1 */ { 0, 0, 0, 0, 0 },
/* U+ebb2 */ { 0, 0, 0, 0, 0 },
/* U+ebb3 */ { 0, 0, 0, 0, 0 },
/* U+ebb4 */ { 0, 0, 0, 0, 0 },
/* U+ebb5 */ { 0, 0, 0, 0, 0 },
/* U+ebb6 */ { 0, 0, 0, 0, 0 },
/* U+ebb7 */ { 0, 0, 0, 0, 0 },
/* U+ebb8 */ { 0, 0, 0, 0, 0 },
/* U+ebb9 */ { 0, 0, 0, 0, 0 },
/* U+ebba */ { 0, 0, 0, 0, 0 },
/* U+ebbb */ { 0, 0, 0, 0, 0 },
/* U+ebbc */ { 0, 0, 0, 0, 0 },
/* U+ebbd */ { 0, 0, 0, 0, 0 },
/* U+ebbe */ { 0, 0, 0, 0, 0 },
/* U+ebbf */ { 0, 0, 0, 0, 0 },
/* U+ebc0 */ { 0, 0, 0, 0, 0 },
/* U+ebc1 */ { 0, 0, 0, 0, 0 },
/* U+ebc2 */ { 0, 0, 0, 0, 0 },
/* U+ebc3 */ { 0, 0, 0, 0, 0 },
/* U+ebc4 */ { 0, 0, 0, 0, 0 },
/* U+ebc5 */ { 0, 0, 0, 0, 0 },
/* U+ebc6 */ { 0, 0, 0, 0, 0 },
/* U+ebc7 */ { 0, 0, 0, 0, 0 },
/* U+ebc8 */ { 0, 0, 0, 0, 0 },
/* U+ebc9 */ { 0, 0, 0, 0, 0 },
/* U+ebca */ { 0, 0, 0, 0, 0 },
/* U+ebcb */ { 0, 0, 0, 0, 0 },
/* U+ebcc */ { 0, 0, 0, 0, 0 },
/* U+ebcd */ { 0, 0, 0, 0, 0 },
/* U+ebce */ { 0, 0, 0, 0, 0 },
/* U+ebcf */ { 0, 0, 0, 0, 0 },
/* U+ebd0 */ { 0, 0, 0, 0, 0 },
/* U+ebd1 */ { 0, 0, 0, 0, 0 },
/* U+ebd2 */ { 0, 0, 0, 0, 0 },
/* U+ebd3 */ { 0, 0, 0, 0, 0 },
/* U+ebd4 */ { 0, 0, 0, 0, 0 },
/* U+ebd5 */ { 0, 0, 0, 0, 0 },
/* U+ebd6 */ { 0, 0, 0, 0, 0 },
/* U+ebd7 */ { 0, 0, 0, 0, 0 },
/* U+ebd8 */ { 0, 0, 0, 0, 0 },
/* U+ebd9 */ { 0, 0, 0, 0, 0 },
/* U+ebda */ { 0, 0, 0, 0, 0 },
/* U+ebdb */ { 0, 0, 0, 0, 0 },
/* U+ebdc */ { 0, 0, 0, 0, 0 },
/* U+ebdd */ { 0, 0, 0, 0, 0 },
/* U+ebde */ { 0, 0, 0, 0, 0 },
/* U+ebdf */ { 0, 0, 0, 0, 0 },
/* U+ebe0 */ { 0, 0, 0, 0, 0 },
/* U+ebe1 */ { 0, 0, 0, 0, 0 },
/* U+ebe2 */ { 0, 0, 0, 0, 0 },
/* U+ebe3 */ { 0, 0, 0, 0, 0 },
/* U+ebe4 */ { 0, 0, 0, 0, 0 },
/* U+ebe5 */ { 0, 0, 0, 0, 0 },
/* U+ebe6 */ { 0, 0, 0, 0, 0 },
/* U+ebe7 */ { 0, 0, 0, 0, 0 },
/* U+ebe8 */ { 0, 0, 0, 0, 0 },
/* U+ebe9 */ { 0, 0, 0, 0, 0 },
/* U+ebea */ { 0, 0, 0, 0, 0 },
/* U+ebeb */ { 0, 0, 0, 0, 0 },
/* U+ebec */ { 0, 0, 0, 0, 0 },
/* U+ebed */ { 0, 0, 0, 0, 0 },
/* U+ebee */ { 0, 0, 0, 0, 0 },
/* U+ebef */ { 0, 0, 0, 0, 0 },
/* U+ebf0 */ { 0, 0, 0, 0, 0 },
/* U+ebf1 */ { 0, 0, 0, 0, 0 },
/* U+ebf2 */ { 0, 0, 0, 0, 0 },
/* U+ebf3 */ { 0, 0, 0, 0, 0 },
/* U+ebf4 */ { 0, 0, 0, 0, 0 },
/* U+ebf5 */ { 0, 0, 0, 0, 0 },
/* U+ebf6 */ { 0, 0, 0, 0, 0 },
/* U+ebf7 */ { 0, 0, 0, 0, 0 },
/* U+ebf8 */ { 0, 0, 0, 0, 0 },
/* U+ebf9 */ { 0, 0, 0, 0, 0 },
/* U+ebfa */ { 0, 0, 0, 0, 0 },
/* U+ebfb */ { 0, 0, 0, 0, 0 },
/* U+ebfc */ { 0, 0, 0, 0, 0 },
/* U+ebfd */ { 0, 0, 0, 0, 0 },
/* U+ebfe */ { 0, 0, 0, 0, 0 },
/* U+ebff */ { 0, 0, 0, 0, 0 },
/* U+ec00 */ { 0, 0, 0, 0, 0 },
/* U+ec01 */ { 0, 0, 0, 0, 0 },
/* U+ec02 */ { 0, 0, 0, 0, 0 },
/* U+ec03 */ { 0, 0, 0, 0, 0 },
/* U+ec04 */ { 0, 0, 0, 0, 0 },
/* U+ec05 */ { 0, 0, 0, 0, 0 },
/* U+ec06 */ { 0, 0, 0, 0, 0 },
/* U+ec07 */ { 0, 0, 0, 0, 0 },
/* U+ec08 */ { 0, 0, 0, 0, 0 },
/* U+ec09 */ { 0, 0, 0, 0, 0 },
/* U+ec0a */ { 0, 0, 0, 0, 0 },
/* U+ec0b */ { 0, 0, 0, 0, 0 },
/* U+ec0c */ { 0, 0, 0, 0, 0 },
/* U+ec0d */ { 0, 0, 0, 0, 0 },
/* U+ec0e */ { 0, 0, 0, 0, 0 },
/* U+ec0f */ { 0, 0, 0, 0, 0 },
/* U+ec10 */ { 0, 0, 0, 0, 0 },
/* U+ec11 */ { 0, 0, 0, 0, 0 },
/* U+ec12 */ { 0, 0, 0, 0, 0 },
/* U+ec13 */ { 0, 0, 0, 0, 0 },
/* U+ec14 */ { 0, 0, 0, 0, 0 },
/* U+ec15 */ { 0, 0, 0, 0, 0 },
/* U+ec16 */ { 0, 0, 0, 0, 0 },
/* U+ec17 */ { 0, 0, 0, 0, 0 },
/* U+ec18 */ { 0, 0, 0, 0, 0 },
/* U+ec19 */ { 0, 0, 0, 0, 0 },
/* U+ec1a */ { 0, 0, 0, 0, 0 },
/* U+ec1b */ { 0, 0, 0, 0, 0 },
/* U+ec1c */ { 0, 0, 0, 0, 0 },
/* U+ec1d */ { 0, 0, 0, 0, 0 },
/* U+ec1e */ { 0, 0, 0, 0, 0 },
/* U+ec1f */ { 0, 0, 0, 0, 0 },
/* U+ec20 */ { 0, 0, 0, 0, 0 },
/* U+ec21 */ { 0, 0, 0, 0, 0 },
/* U+ec22 */ { 0, 0, 0, 0, 0 },
/* U+ec23 */ { 0, 0, 0, 0, 0 },
/* U+ec24 */ { 0, 0, 0, 0, 0 },
/* U+ec25 */ { 0, 0, 0, 0, 0 },
/* U+ec26 */ { 0, 0, 0, 0, 0 },
/* U+ec27 */ { 0, 0, 0, 0, 0 },
/* U+ec28 */ { 0, 0, 0, 0, 0 },
/* U+ec29 */ { 0, 0, 0, 0, 0 },
/* U+ec2a */ { 0, 0, 0, 0, 0 },
/* U+ec2b */ { 0, 0, 0, 0, 0 },
/* U+ec2c */ { 0, 0, 0, 0, 0 },
/* U+ec2d */ { 0, 0, 0, 0, 0 },
/* U+ec2e */ { 0, 0, 0, 0, 0 },
/* U+ec2f */ { 0, 0, 0, 0, 0 },
/* U+ec30 */ { 0, 0, 0, 0, 0 },
/* U+ec31 */ { 0, 0, 0, 0, 0 },
/* U+ec32 */ { 0, 0, 0, 0, 0 },
/* U+ec33 */ { 0, 0, 0, 0, 0 },
/* U+ec34 */ { 0, 0, 0, 0, 0 },
/* U+ec35 */ { 0, 0, 0, 0, 0 },
/* U+ec36 */ { 0, 0, 0, 0, 0 },
/* U+ec37 */ { 0, 0, 0, 0, 0 },
/* U+ec38 */ { 0, 0, 0, 0, 0 },
/* U+ec39 */ { 0, 0, 0, 0, 0 },
/* U+ec3a */ { 0, 0, 0, 0, 0 },
/* U+ec3b */ { 0, 0, 0, 0, 0 },
/* U+ec3c */ { 0, 0, 0, 0, 0 },
/* U+ec3d */ { 0, 0, 0, 0, 0 },
/* U+ec3e */ { 0, 0, 0, 0, 0 },
/* U+ec3f */ { 0, 0, 0, 0, 0 },
/* U+ec40 */ { 0, 0, 0, 0, 0 },
/* U+ec41 */ { 0, 0, 0, 0, 0 },
/* U+ec42 */ { 0, 0, 0, 0, 0 },
/* U+ec43 */ { 0, 0, 0, 0, 0 },
/* U+ec44 */ { 0, 0, 0, 0, 0 },
/* U+ec45 */ { 0, 0, 0, 0, 0 },
/* U+ec46 */ { 0, 0, 0, 0, 0 },
/* U+ec47 */ { 0, 0, 0, 0, 0 },
/* U+ec48 */ { 0, 0, 0, 0, 0 },
/* U+ec49 */ { 0, 0, 0, 0, 0 },
/* U+ec4a */ { 0, 0, 0, 0, 0 },
/* U+ec4b */ { 0, 0, 0, 0, 0 },
/* U+ec4c */ { 0, 0, 0, 0, 0 },
/* U+ec4d */ { 0, 0, 0, 0, 0 },
/* U+ec4e */ { 0, 0, 0, 0, 0 },
/* U+ec4f */ { 0, 0, 0, 0, 0 },
/* U+ec50 */ { 0, 0, 0, 0, 0 },
/* U+ec51 */ { 0, 0, 0, 0, 0 },
/* U+ec52 */ { 0, 0, 0, 0, 0 },
/* U+ec53 */ { 0, 0, 0, 0, 0 },
/* U+ec54 */ { 0, 0, 0, 0, 0 },
/* U+ec55 */ { 0, 0, 0, 0, 0 },
/* U+ec56 */ { 0, 0, 0, 0, 0 },
/* U+ec57 */ { 0, 0, 0, 0, 0 },
/* U+ec58 */ { 0, 0, 0, 0, 0 },
/* U+ec59 */ { 0, 0, 0, 0, 0 },
/* U+ec5a */ { 0, 0, 0, 0, 0 },
/* U+ec5b */ { 0, 0, 0, 0, 0 },
/* U+ec5c */ { 0, 0, 0, 0, 0 },
/* U+ec5d */ { 0, 0, 0, 0, 0 },
/* U+ec5e */ { 0, 0, 0, 0, 0 },
/* U+ec5f */ { 0, 0, 0, 0, 0 },
/* U+ec60 */ { 0, 0, 0, 0, 0 },
/* U+ec61 */ { 0, 0, 0, 0, 0 },
/* U+ec62 */ { 0, 0, 0, 0, 0 },
/* U+ec63 */ { 0, 0, 0, 0, 0 },
/* U+ec64 */ { 0, 0, 0, 0, 0 },
/* U+ec65 */ { 0, 0, 0, 0, 0 },
/* U+ec66 */ { 0, 0, 0, 0, 0 },
/* U+ec67 */ { 0, 0, 0, 0, 0 },
/* U+ec68 */ { 0, 0, 0, 0, 0 },
/* U+ec69 */ { 0, 0, 0, 0, 0 },
/* U+ec6a */ { 0, 0, 0, 0, 0 },
/* U+ec6b */ { 0, 0, 0, 0, 0 },
/* U+ec6c */ { 0, 0, 0, 0, 0 },
/* U+ec6d */ { 0, 0, 0, 0, 0 },
/* U+ec6e */ { 0, 0, 0, 0, 0 },
/* U+ec6f */ { 0, 0, 0, 0, 0 },
/* U+ec70 */ { 0, 0, 0, 0, 0 },
/* U+ec71 */ { 0, 0, 0, 0, 0 },
/* U+ec72 */ { 0, 0, 0, 0, 0 },
/* U+ec73 */ { 0, 0, 0, 0, 0 },
/* U+ec74 */ { 0, 0, 0, 0, 0 },
/* U+ec75 */ { 0, 0, 0, 0, 0 },
/* U+ec76 */ { 0, 0, 0, 0, 0 },
/* U+ec77 */ { 0, 0, 0, 0, 0 },
/* U+ec78 */ { 0, 0, 0, 0, 0 },
/* U+ec79 */ { 0, 0, 0, 0, 0 },
/* U+ec7a */ { 0, 0, 0, 0, 0 },
/* U+ec7b */ { 0, 0, 0, 0, 0 },
/* U+ec7c */ { 0, 0, 0, 0, 0 },
/* U+ec7d */ { 0, 0, 0, 0, 0 },
/* U+ec7e */ { 0, 0, 0, 0, 0 },
/* U+ec7f */ { 0, 0, 0, 0, 0 },
/* U+ec80 */ { 0, 0, 0, 0, 0 },
/* U+ec81 */ { 0, 0, 0, 0, 0 },
/* U+ec82 */ { 0, 0, 0, 0, 0 },
/* U+ec83 */ { 0, 0, 0, 0, 0 },
/* U+ec84 */ { 0, 0, 0, 0, 0 },
/* U+ec85 */ { 0, 0, 0, 0, 0 },
/* U+ec86 */ { 0, 0, 0, 0, 0 },
/* U+ec87 */ { 0, 0, 0, 0, 0 },
/* U+ec88 */ { 0, 0, 0, 0, 0 },
/* U+ec89 */ { 0, 0, 0, 0, 0 },
/* U+ec8a */ { 0, 0, 0, 0, 0 },
/* U+ec8b */ { 0, 0, 0, 0, 0 },
/* U+ec8c */ { 0, 0, 0, 0, 0 },
/* U+ec8d */ { 0, 0, 0, 0, 0 },
/* U+ec8e */ { 0, 0, 0, 0, 0 },
/* U+ec8f */ { 0, 0, 0, 0, 0 },
/* U+ec90 */ { 0, 0, 0, 0, 0 },
/* U+ec91 */ { 0, 0, 0, 0, 0 },
/* U+ec92 */ { 0, 0, 0, 0, 0 },
/* U+ec93 */ { 0, 0, 0, 0, 0 },
/* U+ec94 */ { 0, 0, 0, 0, 0 },
/* U+ec95 */ { 0, 0, 0, 0, 0 },
/* U+ec96 */ { 0, 0, 0, 0, 0 },
/* U+ec97 */ { 0, 0, 0, 0, 0 },
/* U+ec98 */ { 0, 0, 0, 0, 0 },
/* U+ec99 */ { 0, 0, 0, 0, 0 },
/* U+ec9a */ { 0, 0, 0, 0, 0 },
/* U+ec9b */ { 0, 0, 0, 0, 0 },
/* U+ec9c */ { 0, 0, 0, 0, 0 },
/* U+ec9d */ { 0, 0, 0, 0, 0 },
/* U+ec9e */ { 0, 0, 0, 0, 0 },
/* U+ec9f */ { 0, 0, 0, 0, 0 },
/* U+eca0 */ { 0, 0, 0, 0, 0 },
/* U+eca1 */ { 0, 0, 0, 0, 0 },
/* U+eca2 */ { 0, 0, 0, 0, 0 },
/* U+eca3 */ { 0, 0, 0, 0, 0 },
/* U+eca4 */ { 0, 0, 0, 0, 0 },
/* U+eca5 */ { 0, 0, 0, 0, 0 },
/* U+eca6 */ { 0, 0, 0, 0, 0 },
/* U+eca7 */ { 0, 0, 0, 0, 0 },
/* U+eca8 */ { 0, 0, 0, 0, 0 },
/* U+eca9 */ { 0, 0, 0, 0, 0 },
/* U+ecaa */ { 0, 0, 0, 0, 0 },
/* U+ecab */ { 0, 0, 0, 0, 0 },
/* U+ecac */ { 0, 0, 0, 0, 0 },
/* U+ecad */ { 0, 0, 0, 0, 0 },
/* U+ecae */ { 0, 0, 0, 0, 0 },
/* U+ecaf */ { 0, 0, 0, 0, 0 },
/* U+ecb0 */ { 0, 0, 0, 0, 0 },
/* U+ecb1 */ { 0, 0, 0, 0, 0 },
/* U+ecb2 */ { 0, 0, 0, 0, 0 },
/* U+ecb3 */ { 0, 0, 0, 0, 0 },
/* U+ecb4 */ { 0, 0, 0, 0, 0 },
/* U+ecb5 */ { 0, 0, 0, 0, 0 },
/* U+ecb6 */ { 0, 0, 0, 0, 0 },
/* U+ecb7 */ { 0, 0, 0, 0, 0 },
/* U+ecb8 */ { 0, 0, 0, 0, 0 },
/* U+ecb9 */ { 0, 0, 0, 0, 0 },
/* U+ecba */ { 0, 0, 0, 0, 0 },
/* U+ecbb */ { 0, 0, 0, 0, 0 },
/* U+ecbc */ { 0, 0, 0, 0, 0 },
/* U+ecbd */ { 0, 0, 0, 0, 0 },
/* U+ecbe */ { 0, 0, 0, 0, 0 },
/* U+ecbf */ { 0, 0, 0, 0, 0 },
/* U+ecc0 */ { 0, 0, 0, 0, 0 },
/* U+ecc1 */ { 0, 0, 0, 0, 0 },
/* U+ecc2 */ { 0, 0, 0, 0, 0 },
/* U+ecc3 */ { 0, 0, 0, 0, 0 },
/* U+ecc4 */ { 0, 0, 0, 0, 0 },
/* U+ecc5 */ { 0, 0, 0, 0, 0 },
/* U+ecc6 */ { 0, 0, 0, 0, 0 },
/* U+ecc7 */ { 0, 0, 0, 0, 0 },
/* U+ecc8 */ { 0, 0, 0, 0, 0 },
/* U+ecc9 */ { 0, 0, 0, 0, 0 },
/* U+ecca */ { 0, 0, 0, 0, 0 },
/* U+eccb */ { 0, 0, 0, 0, 0 },
/* U+eccc */ { 0, 0, 0, 0, 0 },
/* U+eccd */ { 0, 0, 0, 0, 0 },
/* U+ecce */ { 0, 0, 0, 0, 0 },
/* U+eccf */ { 0, 0, 0, 0, 0 },
/* U+ecd0 */ { 0, 0, 0, 0, 0 },
/* U+ecd1 */ { 0, 0, 0, 0, 0 },
/* U+ecd2 */ { 0, 0, 0, 0, 0 },
/* U+ecd3 */ { 0, 0, 0, 0, 0 },
/* U+ecd4 */ { 0, 0, 0, 0, 0 },
/* U+ecd5 */ { 0, 0, 0, 0, 0 },
/* U+ecd6 */ { 0, 0, 0, 0, 0 },
/* U+ecd7 */ { 0, 0, 0, 0, 0 },
/* U+ecd8 */ { 0, 0, 0, 0, 0 },
/* U+ecd9 */ { 0, 0, 0, 0, 0 },
/* U+ecda */ { 0, 0, 0, 0, 0 },
/* U+ecdb */ { 0, 0, 0, 0, 0 },
/* U+ecdc */ { 0, 0, 0, 0, 0 },
/* U+ecdd */ { 0, 0, 0, 0, 0 },
/* U+ecde */ { 0, 0, 0, 0, 0 },
/* U+ecdf */ { 0, 0, 0, 0, 0 },
/* U+ece0 */ { 0, 0, 0, 0, 0 },
/* U+ece1 */ { 0, 0, 0, 0, 0 },
/* U+ece2 */ { 0, 0, 0, 0, 0 },
/* U+ece3 */ { 0, 0, 0, 0, 0 },
/* U+ece4 */ { 0, 0, 0, 0, 0 },
/* U+ece5 */ { 0, 0, 0, 0, 0 },
/* U+ece6 */ { 0, 0, 0, 0, 0 },
/* U+ece7 */ { 0, 0, 0, 0, 0 },
/* U+ece8 */ { 0, 0, 0, 0, 0 },
/* U+ece9 */ { 0, 0, 0, 0, 0 },
/* U+ecea */ { 0, 0, 0, 0, 0 },
/* U+eceb */ { 0, 0, 0, 0, 0 },
/* U+ecec */ { 0, 0, 0, 0, 0 },
/* U+eced */ { 0, 0, 0, 0, 0 },
/* U+ecee */ { 0, 0, 0, 0, 0 },
/* U+ecef */ { 0, 0, 0, 0, 0 },
/* U+ecf0 */ { 0, 0, 0, 0, 0 },
/* U+ecf1 */ { 0, 0, 0, 0, 0 },
/* U+ecf2 */ { 0, 0, 0, 0, 0 },
/* U+ecf3 */ { 0, 0, 0, 0, 0 },
/* U+ecf4 */ { 0, 0, 0, 0, 0 },
/* U+ecf5 */ { 0, 0, 0, 0, 0 },
/* U+ecf6 */ { 0, 0, 0, 0, 0 },
/* U+ecf7 */ { 0, 0, 0, 0, 0 },
/* U+ecf8 */ { 0, 0, 0, 0, 0 },
/* U+ecf9 */ { 0, 0, 0, 0, 0 },
/* U+ecfa */ { 0, 0, 0, 0, 0 },
/* U+ecfb */ { 0, 0, 0, 0, 0 },
/* U+ecfc */ { 0, 0, 0, 0, 0 },
/* U+ecfd */ { 0, 0, 0, 0, 0 },
/* U+ecfe */ { 0, 0, 0, 0, 0 },
/* U+ecff */ { 0, 0, 0, 0, 0 },
/* U+ed00 */ { 0, 0, 0, 0, 0 },
/* U+ed01 */ { 0, 0, 0, 0, 0 },
/* U+ed02 */ { 0, 0, 0, 0, 0 },
/* U+ed03 */ { 0, 0, 0, 0, 0 },
/* U+ed04 */ { 0, 0, 0, 0, 0 },
/* U+ed05 */ { 0, 0, 0, 0, 0 },
/* U+ed06 */ { 0, 0, 0, 0, 0 },
/* U+ed07 */ { 0, 0, 0, 0, 0 },
/* U+ed08 */ { 0, 0, 0, 0, 0 },
/* U+ed09 */ { 0, 0, 0, 0, 0 },
/* U+ed0a */ { 0, 0, 0, 0, 0 },
/* U+ed0b */ { 0, 0, 0, 0, 0 },
/* U+ed0c */ { 0, 0, 0, 0, 0 },
/* U+ed0d */ { 0, 0, 0, 0, 0 },
/* U+ed0e */ { 0, 0, 0, 0, 0 },
/* U+ed0f */ { 0, 0, 0, 0, 0 },
/* U+ed10 */ { 0, 0, 0, 0, 0 },
/* U+ed11 */ { 0, 0, 0, 0, 0 },
/* U+ed12 */ { 0, 0, 0, 0, 0 },
/* U+ed13 */ { 0, 0, 0, 0, 0 },
/* U+ed14 */ { 0, 0, 0, 0, 0 },
/* U+ed15 */ { 0, 0, 0, 0, 0 },
/* U+ed16 */ { 0, 0, 0, 0, 0 },
/* U+ed17 */ { 0, 0, 0, 0, 0 },
/* U+ed18 */ { 0, 0, 0, 0, 0 },
/* U+ed19 */ { 0, 0, 0, 0, 0 },
/* U+ed1a */ { 0, 0, 0, 0, 0 },
/* U+ed1b */ { 0, 0, 0, 0, 0 },
/* U+ed1c */ { 0, 0, 0, 0, 0 },
/* U+ed1d */ { 0, 0, 0, 0, 0 },
/* U+ed1e */ { 0, 0, 0, 0, 0 },
/* U+ed1f */ { 0, 0, 0, 0, 0 },
/* U+ed20 */ { 0, 0, 0, 0, 0 },
/* U+ed21 */ { 0, 0, 0, 0, 0 },
/* U+ed22 */ { 0, 0, 0, 0, 0 },
/* U+ed23 */ { 0, 0, 0, 0, 0 },
/* U+ed24 */ { 0, 0, 0, 0, 0 },
/* U+ed25 */ { 0, 0, 0, 0, 0 },
/* U+ed26 */ { 0, 0, 0, 0, 0 },
/* U+ed27 */ { 0, 0, 0, 0, 0 },
/* U+ed28 */ { 0, 0, 0, 0, 0 },
/* U+ed29 */ { 0, 0, 0, 0, 0 },
/* U+ed2a */ { 0, 0, 0, 0, 0 },
/* U+ed2b */ { 0, 0, 0, 0, 0 },
/* U+ed2c */ { 0, 0, 0, 0, 0 },
/* U+ed2d */ { 0, 0, 0, 0, 0 },
/* U+ed2e */ { 0, 0, 0, 0, 0 },
/* U+ed2f */ { 0, 0, 0, 0, 0 },
/* U+ed30 */ { 0, 0, 0, 0, 0 },
/* U+ed31 */ { 0, 0, 0, 0, 0 },
/* U+ed32 */ { 0, 0, 0, 0, 0 },
/* U+ed33 */ { 0, 0, 0, 0, 0 },
/* U+ed34 */ { 0, 0, 0, 0, 0 },
/* U+ed35 */ { 0, 0, 0, 0, 0 },
/* U+ed36 */ { 0, 0, 0, 0, 0 },
/* U+ed37 */ { 0, 0, 0, 0, 0 },
/* U+ed38 */ { 0, 0, 0, 0, 0 },
/* U+ed39 */ { 0, 0, 0, 0, 0 },
/* U+ed3a */ { 0, 0, 0, 0, 0 },
/* U+ed3b */ { 0, 0, 0, 0, 0 },
/* U+ed3c */ { 0, 0, 0, 0, 0 },
/* U+ed3d */ { 0, 0, 0, 0, 0 },
/* U+ed3e */ { 0, 0, 0, 0, 0 },
/* U+ed3f */ { 0, 0, 0, 0, 0 },
/* U+ed40 */ { 0, 0, 0, 0, 0 },
/* U+ed41 */ { 0, 0, 0, 0, 0 },
/* U+ed42 */ { 0, 0, 0, 0, 0 },
/* U+ed43 */ { 0, 0, 0, 0, 0 },
/* U+ed44 */ { 0, 0, 0, 0, 0 },
/* U+ed45 */ { 0, 0, 0, 0, 0 },
/* U+ed46 */ { 0, 0, 0, 0, 0 },
/* U+ed47 */ { 0, 0, 0, 0, 0 },
/* U+ed48 */ { 0, 0, 0, 0, 0 },
/* U+ed49 */ { 0, 0, 0, 0, 0 },
/* U+ed4a */ { 0, 0, 0, 0, 0 },
/* U+ed4b */ { 0, 0, 0, 0, 0 },
/* U+ed4c */ { 0, 0, 0, 0, 0 },
/* U+ed4d */ { 0, 0, 0, 0, 0 },
/* U+ed4e */ { 0, 0, 0, 0, 0 },
/* U+ed4f */ { 0, 0, 0, 0, 0 },
/* U+ed50 */ { 0, 0, 0, 0, 0 },
/* U+ed51 */ { 0, 0, 0, 0, 0 },
/* U+ed52 */ { 0, 0, 0, 0, 0 },
/* U+ed53 */ { 0, 0, 0, 0, 0 },
/* U+ed54 */ { 0, 0, 0, 0, 0 },
/* U+ed55 */ { 0, 0, 0, 0, 0 },
/* U+ed56 */ { 0, 0, 0, 0, 0 },
/* U+ed57 */ { 0, 0, 0, 0, 0 },
/* U+ed58 */ { 0, 0, 0, 0, 0 },
/* U+ed59 */ { 0, 0, 0, 0, 0 },
/* U+ed5a */ { 0, 0, 0, 0, 0 },
/* U+ed5b */ { 0, 0, 0, 0, 0 },
/* U+ed5c */ { 0, 0, 0, 0, 0 },
/* U+ed5d */ { 0, 0, 0, 0, 0 },
/* U+ed5e */ { 0, 0, 0, 0, 0 },
/* U+ed5f */ { 0, 0, 0, 0, 0 },
/* U+ed60 */ { 0, 0, 0, 0, 0 },
/* U+ed61 */ { 0, 0, 0, 0, 0 },
/* U+ed62 */ { 0, 0, 0, 0, 0 },
/* U+ed63 */ { 0, 0, 0, 0, 0 },
/* U+ed64 */ { 0, 0, 0, 0, 0 },
/* U+ed65 */ { 0, 0, 0, 0, 0 },
/* U+ed66 */ { 0, 0, 0, 0, 0 },
/* U+ed67 */ { 0, 0, 0, 0, 0 },
/* U+ed68 */ { 0, 0, 0, 0, 0 },
/* U+ed69 */ { 0, 0, 0, 0, 0 },
/* U+ed6a */ { 0, 0, 0, 0, 0 },
/* U+ed6b */ { 0, 0, 0, 0, 0 },
/* U+ed6c */ { 0, 0, 0, 0, 0 },
/* U+ed6d */ { 0, 0, 0, 0, 0 },
/* U+ed6e */ { 0, 0, 0, 0, 0 },
/* U+ed6f */ { 0, 0, 0, 0, 0 },
/* U+ed70 */ { 0, 0, 0, 0, 0 },
/* U+ed71 */ { 0, 0, 0, 0, 0 },
/* U+ed72 */ { 0, 0, 0, 0, 0 },
/* U+ed73 */ { 0, 0, 0, 0, 0 },
/* U+ed74 */ { 0, 0, 0, 0, 0 },
/* U+ed75 */ { 0, 0, 0, 0, 0 },
/* U+ed76 */ { 0, 0, 0, 0, 0 },
/* U+ed77 */ { 0, 0, 0, 0, 0 },
/* U+ed78 */ { 0, 0, 0, 0, 0 },
/* U+ed79 */ { 0, 0, 0, 0, 0 },
/* U+ed7a */ { 0, 0, 0, 0, 0 },
/* U+ed7b */ { 0, 0, 0, 0, 0 },
/* U+ed7c */ { 0, 0, 0, 0, 0 },
/* U+ed7d */ { 0, 0, 0, 0, 0 },
/* U+ed7e */ { 0, 0, 0, 0, 0 },
/* U+ed7f */ { 0, 0, 0, 0, 0 },
/* U+ed80 */ { 0, 0, 0, 0, 0 },
/* U+ed81 */ { 0, 0, 0, 0, 0 },
/* U+ed82 */ { 0, 0, 0, 0, 0 },
/* U+ed83 */ { 0, 0, 0, 0, 0 },
/* U+ed84 */ { 0, 0, 0, 0, 0 },
/* U+ed85 */ { 0, 0, 0, 0, 0 },
/* U+ed86 */ { 0, 0, 0, 0, 0 },
/* U+ed87 */ { 0, 0, 0, 0, 0 },
/* U+ed88 */ { 0, 0, 0, 0, 0 },
/* U+ed89 */ { 0, 0, 0, 0, 0 },
/* U+ed8a */ { 0, 0, 0, 0, 0 },
/* U+ed8b */ { 0, 0, 0, 0, 0 },
/* U+ed8c */ { 0, 0, 0, 0, 0 },
/* U+ed8d */ { 0, 0, 0, 0, 0 },
/* U+ed8e */ { 0, 0, 0, 0, 0 },
/* U+ed8f */ { 0, 0, 0, 0, 0 },
/* U+ed90 */ { 0, 0, 0, 0, 0 },
/* U+ed91 */ { 0, 0, 0, 0, 0 },
/* U+ed92 */ { 0, 0, 0, 0, 0 },
/* U+ed93 */ { 0, 0, 0, 0, 0 },
/* U+ed94 */ { 0, 0, 0, 0, 0 },
/* U+ed95 */ { 0, 0, 0, 0, 0 },
/* U+ed96 */ { 0, 0, 0, 0, 0 },
/* U+ed97 */ { 0, 0, 0, 0, 0 },
/* U+ed98 */ { 0, 0, 0, 0, 0 },
/* U+ed99 */ { 0, 0, 0, 0, 0 },
/* U+ed9a */ { 0, 0, 0, 0, 0 },
/* U+ed9b */ { 0, 0, 0, 0, 0 },
/* U+ed9c */ { 0, 0, 0, 0, 0 },
/* U+ed9d */ { 0, 0, 0, 0, 0 },
/* U+ed9e */ { 0, 0, 0, 0, 0 },
/* U+ed9f */ { 0, 0, 0, 0, 0 },
/* U+eda0 */ { 0, 0, 0, 0, 0 },
/* U+eda1 */ { 0, 0, 0, 0, 0 },
/* U+eda2 */ { 0, 0, 0, 0, 0 },
/* U+eda3 */ { 0, 0, 0, 0, 0 },
/* U+eda4 */ { 0, 0, 0, 0, 0 },
/* U+eda5 */ { 0, 0, 0, 0, 0 },
/* U+eda6 */ { 0, 0, 0, 0, 0 },
/* U+eda7 */ { 0, 0, 0, 0, 0 },
/* U+eda8 */ { 0, 0, 0, 0, 0 },
/* U+eda9 */ { 0, 0, 0, 0, 0 },
/* U+edaa */ { 0, 0, 0, 0, 0 },
/* U+edab */ { 0, 0, 0, 0, 0 },
/* U+edac */ { 0, 0, 0, 0, 0 },
/* U+edad */ { 0, 0, 0, 0, 0 },
/* U+edae */ { 0, 0, 0, 0, 0 },
/* U+edaf */ { 0, 0, 0, 0, 0 },
/* U+edb0 */ { 0, 0, 0, 0, 0 },
/* U+edb1 */ { 0, 0, 0, 0, 0 },
/* U+edb2 */ { 0, 0, 0, 0, 0 },
/* U+edb3 */ { 0, 0, 0, 0, 0 },
/* U+edb4 */ { 0, 0, 0, 0, 0 },
/* U+edb5 */ { 0, 0, 0, 0, 0 },
/* U+edb6 */ { 0, 0, 0, 0, 0 },
/* U+edb7 */ { 0, 0, 0, 0, 0 },
/* U+edb8 */ { 0, 0, 0, 0, 0 },
/* U+edb9 */ { 0, 0, 0, 0, 0 },
/* U+edba */ { 0, 0, 0, 0, 0 },
/* U+edbb */ { 0, 0, 0, 0, 0 },
/* U+edbc */ { 0, 0, 0, 0, 0 },
/* U+edbd */ { 0, 0, 0, 0, 0 },
/* U+edbe */ { 0, 0, 0, 0, 0 },
/* U+edbf */ { 0, 0, 0, 0, 0 },
/* U+edc0 */ { 0, 0, 0, 0, 0 },
/* U+edc1 */ { 0, 0, 0, 0, 0 },
/* U+edc2 */ { 0, 0, 0, 0, 0 },
/* U+edc3 */ { 0, 0, 0, 0, 0 },
/* U+edc4 */ { 0, 0, 0, 0, 0 },
/* U+edc5 */ { 0, 0, 0, 0, 0 },
/* U+edc6 */ { 0, 0, 0, 0, 0 },
/* U+edc7 */ { 0, 0, 0, 0, 0 },
/* U+edc8 */ { 0, 0, 0, 0, 0 },
/* U+edc9 */ { 0, 0, 0, 0, 0 },
/* U+edca */ { 0, 0, 0, 0, 0 },
/* U+edcb */ { 0, 0, 0, 0, 0 },
/* U+edcc */ { 0, 0, 0, 0, 0 },
/* U+edcd */ { 0, 0, 0, 0, 0 },
/* U+edce */ { 0, 0, 0, 0, 0 },
/* U+edcf */ { 0, 0, 0, 0, 0 },
/* U+edd0 */ { 0, 0, 0, 0, 0 },
/* U+edd1 */ { 0, 0, 0, 0, 0 },
/* U+edd2 */ { 0, 0, 0, 0, 0 },
/* U+edd3 */ { 0, 0, 0, 0, 0 },
/* U+edd4 */ { 0, 0, 0, 0, 0 },
/* U+edd5 */ { 0, 0, 0, 0, 0 },
/* U+edd6 */ { 0, 0, 0, 0, 0 },
/* U+edd7 */ { 0, 0, 0, 0, 0 },
/* U+edd8 */ { 0, 0, 0, 0, 0 },
/* U+edd9 */ { 0, 0, 0, 0, 0 },
/* U+edda */ { 0, 0, 0, 0, 0 },
/* U+eddb */ { 0, 0, 0, 0, 0 },
/* U+eddc */ { 0, 0, 0, 0, 0 },
/* U+eddd */ { 0, 0, 0, 0, 0 },
/* U+edde */ { 0, 0, 0, 0, 0 },
/* U+eddf */ { 0, 0, 0, 0, 0 },
/* U+ede0 */ { 0, 0, 0, 0, 0 },
/* U+ede1 */ { 0, 0, 0, 0, 0 },
/* U+ede2 */ { 0, 0, 0, 0, 0 },
/* U+ede3 */ { 0, 0, 0, 0, 0 },
/* U+ede4 */ { 0, 0, 0, 0, 0 },
/* U+ede5 */ { 0, 0, 0, 0, 0 },
/* U+ede6 */ { 0, 0, 0, 0, 0 },
/* U+ede7 */ { 0, 0, 0, 0, 0 },
/* U+ede8 */ { 0, 0, 0, 0, 0 },
/* U+ede9 */ { 0, 0, 0, 0, 0 },
/* U+edea */ { 0, 0, 0, 0, 0 },
/* U+edeb */ { 0, 0, 0, 0, 0 },
/* U+edec */ { 0, 0, 0, 0, 0 },
/* U+eded */ { 0, 0, 0, 0, 0 },
/* U+edee */ { 0, 0, 0, 0, 0 },
/* U+edef */ { 0, 0, 0, 0, 0 },
/* U+edf0 */ { 0, 0, 0, 0, 0 },
/* U+edf1 */ { 0, 0, 0, 0, 0 },
/* U+edf2 */ { 0, 0, 0, 0, 0 },
/* U+edf3 */ { 0, 0, 0, 0, 0 },
/* U+edf4 */ { 0, 0, 0, 0, 0 },
/* U+edf5 */ { 0, 0, 0, 0, 0 },
/* U+edf6 */ { 0, 0, 0, 0, 0 },
/* U+edf7 */ { 0, 0, 0, 0, 0 },
/* U+edf8 */ { 0, 0, 0, 0, 0 },
/* U+edf9 */ { 0, 0, 0, 0, 0 },
/* U+edfa */ { 0, 0, 0, 0, 0 },
/* U+edfb */ { 0, 0, 0, 0, 0 },
/* U+edfc */ { 0, 0, 0, 0, 0 },
/* U+edfd */ { 0, 0, 0, 0, 0 },
/* U+edfe */ { 0, 0, 0, 0, 0 },
/* U+edff */ { 0, 0, 0, 0, 0 },
/* U+ee00 */ { 0, 0, 0, 0, 0 },
/* U+ee01 */ { 0, 0, 0, 0, 0 },
/* U+ee02 */ { 0, 0, 0, 0, 0 },
/* U+ee03 */ { 0, 0, 0, 0, 0 },
/* U+ee04 */ { 0, 0, 0, 0, 0 },
/* U+ee05 */ { 0, 0, 0, 0, 0 },
/* U+ee06 */ { 0, 0, 0, 0, 0 },
/* U+ee07 */ { 0, 0, 0, 0, 0 },
/* U+ee08 */ { 0, 0, 0, 0, 0 },
/* U+ee09 */ { 0, 0, 0, 0, 0 },
/* U+ee0a */ { 0, 0, 0, 0, 0 },
/* U+ee0b */ { 0, 0, 0, 0, 0 },
/* U+ee0c */ { 0, 0, 0, 0, 0 },
/* U+ee0d */ { 0, 0, 0, 0, 0 },
/* U+ee0e */ { 0, 0, 0, 0, 0 },
/* U+ee0f */ { 0, 0, 0, 0, 0 },
/* U+ee10 */ { 0, 0, 0, 0, 0 },
/* U+ee11 */ { 0, 0, 0, 0, 0 },
/* U+ee12 */ { 0, 0, 0, 0, 0 },
/* U+ee13 */ { 0, 0, 0, 0, 0 },
/* U+ee14 */ { 0, 0, 0, 0, 0 },
/* U+ee15 */ { 0, 0, 0, 0, 0 },
/* U+ee16 */ { 0, 0, 0, 0, 0 },
/* U+ee17 */ { 0, 0, 0, 0, 0 },
/* U+ee18 */ { 0, 0, 0, 0, 0 },
/* U+ee19 */ { 0, 0, 0, 0, 0 },
/* U+ee1a */ { 0, 0, 0, 0, 0 },
/* U+ee1b */ { 0, 0, 0, 0, 0 },
/* U+ee1c */ { 0, 0, 0, 0, 0 },
/* U+ee1d */ { 0, 0, 0, 0, 0 },
/* U+ee1e */ { 0, 0, 0, 0, 0 },
/* U+ee1f */ { 0, 0, 0, 0, 0 },
/* U+ee20 */ { 0, 0, 0, 0, 0 },
/* U+ee21 */ { 0, 0, 0, 0, 0 },
/* U+ee22 */ { 0, 0, 0, 0, 0 },
/* U+ee23 */ { 0, 0, 0, 0, 0 },
/* U+ee24 */ { 0, 0, 0, 0, 0 },
/* U+ee25 */ { 0, 0, 0, 0, 0 },
/* U+ee26 */ { 0, 0, 0, 0, 0 },
/* U+ee27 */ { 0, 0, 0, 0, 0 },
/* U+ee28 */ { 0, 0, 0, 0, 0 },
/* U+ee29 */ { 0, 0, 0, 0, 0 },
/* U+ee2a */ { 0, 0, 0, 0, 0 },
/* U+ee2b */ { 0, 0, 0, 0, 0 },
/* U+ee2c */ { 0, 0, 0, 0, 0 },
/* U+ee2d */ { 0, 0, 0, 0, 0 },
/* U+ee2e */ { 0, 0, 0, 0, 0 },
/* U+ee2f */ { 0, 0, 0, 0, 0 },
/* U+ee30 */ { 0, 0, 0, 0, 0 },
/* U+ee31 */ { 0, 0, 0, 0, 0 },
/* U+ee32 */ { 0, 0, 0, 0, 0 },
/* U+ee33 */ { 0, 0, 0, 0, 0 },
/* U+ee34 */ { 0, 0, 0, 0, 0 },
/* U+ee35 */ { 0, 0, 0, 0, 0 },
/* U+ee36 */ { 0, 0, 0, 0, 0 },
/* U+ee37 */ { 0, 0, 0, 0, 0 },
/* U+ee38 */ { 0, 0, 0, 0, 0 },
/* U+ee39 */ { 0, 0, 0, 0, 0 },
/* U+ee3a */ { 0, 0, 0, 0, 0 },
/* U+ee3b */ { 0, 0, 0, 0, 0 },
/* U+ee3c */ { 0, 0, 0, 0, 0 },
/* U+ee3d */ { 0, 0, 0, 0, 0 },
/* U+ee3e */ { 0, 0, 0, 0, 0 },
/* U+ee3f */ { 0, 0, 0, 0, 0 },
/* U+ee40 */ { 0, 0, 0, 0, 0 },
/* U+ee41 */ { 0, 0, 0, 0, 0 },
/* U+ee42 */ { 0, 0, 0, 0, 0 },
/* U+ee43 */ { 0, 0, 0, 0, 0 },
/* U+ee44 */ { 0, 0, 0, 0, 0 },
/* U+ee45 */ { 0, 0, 0, 0, 0 },
/* U+ee46 */ { 0, 0, 0, 0, 0 },
/* U+ee47 */ { 0, 0, 0, 0, 0 },
/* U+ee48 */ { 0, 0, 0, 0, 0 },
/* U+ee49 */ { 0, 0, 0, 0, 0 },
/* U+ee4a */ { 0, 0, 0, 0, 0 },
/* U+ee4b */ { 0, 0, 0, 0, 0 },
/* U+ee4c */ { 0, 0, 0, 0, 0 },
/* U+ee4d */ { 0, 0, 0, 0, 0 },
/* U+ee4e */ { 0, 0, 0, 0, 0 },
/* U+ee4f */ { 0, 0, 0, 0, 0 },
/* U+ee50 */ { 0, 0, 0, 0, 0 },
/* U+ee51 */ { 0, 0, 0, 0, 0 },
/* U+ee52 */ { 0, 0, 0, 0, 0 },
/* U+ee53 */ { 0, 0, 0, 0, 0 },
/* U+ee54 */ { 0, 0, 0, 0, 0 },
/* U+ee55 */ { 0, 0, 0, 0, 0 },
/* U+ee56 */ { 0, 0, 0, 0, 0 },
/* U+ee57 */ { 0, 0, 0, 0, 0 },
/* U+ee58 */ { 0, 0, 0, 0, 0 },
/* U+ee59 */ { 0, 0, 0, 0, 0 },
/* U+ee5a */ { 0, 0, 0, 0, 0 },
/* U+ee5b */ { 0, 0, 0, 0, 0 },
/* U+ee5c */ { 0, 0, 0, 0, 0 },
/* U+ee5d */ { 0, 0, 0, 0, 0 },
/* U+ee5e */ { 0, 0, 0, 0, 0 },
/* U+ee5f */ { 0, 0, 0, 0, 0 },
/* U+ee60 */ { 0, 0, 0, 0, 0 },
/* U+ee61 */ { 0, 0, 0, 0, 0 },
/* U+ee62 */ { 0, 0, 0, 0, 0 },
/* U+ee63 */ { 0, 0, 0, 0, 0 },
/* U+ee64 */ { 0, 0, 0, 0, 0 },
/* U+ee65 */ { 0, 0, 0, 0, 0 },
/* U+ee66 */ { 0, 0, 0, 0, 0 },
/* U+ee67 */ { 0, 0, 0, 0, 0 },
/* U+ee68 */ { 0, 0, 0, 0, 0 },
/* U+ee69 */ { 0, 0, 0, 0, 0 },
/* U+ee6a */ { 0, 0, 0, 0, 0 },
/* U+ee6b */ { 0, 0, 0, 0, 0 },
/* U+ee6c */ { 0, 0, 0, 0, 0 },
/* U+ee6d */ { 0, 0, 0, 0, 0 },
/* U+ee6e */ { 0, 0, 0, 0, 0 },
/* U+ee6f */ { 0, 0, 0, 0, 0 },
/* U+ee70 */ { 0, 0, 0, 0, 0 },
/* U+ee71 */ { 0, 0, 0, 0, 0 },
/* U+ee72 */ { 0, 0, 0, 0, 0 },
/* U+ee73 */ { 0, 0, 0, 0, 0 },
/* U+ee74 */ { 0, 0, 0, 0, 0 },
/* U+ee75 */ { 0, 0, 0, 0, 0 },
/* U+ee76 */ { 0, 0, 0, 0, 0 },
/* U+ee77 */ { 0, 0, 0, 0, 0 },
/* U+ee78 */ { 0, 0, 0, 0, 0 },
/* U+ee79 */ { 0, 0, 0, 0, 0 },
/* U+ee7a */ { 0, 0, 0, 0, 0 },
/* U+ee7b */ { 0, 0, 0, 0, 0 },
/* U+ee7c */ { 0, 0, 0, 0, 0 },
/* U+ee7d */ { 0, 0, 0, 0, 0 },
/* U+ee7e */ { 0, 0, 0, 0, 0 },
/* U+ee7f */ { 0, 0, 0, 0, 0 },
/* U+ee80 */ { 0, 0, 0, 0, 0 },
/* U+ee81 */ { 0, 0, 0, 0, 0 },
/* U+ee82 */ { 0, 0, 0, 0, 0 },
/* U+ee83 */ { 0, 0, 0, 0, 0 },
/* U+ee84 */ { 0, 0, 0, 0, 0 },
/* U+ee85 */ { 0, 0, 0, 0, 0 },
/* U+ee86 */ { 0, 0, 0, 0, 0 },
/* U+ee87 */ { 0, 0, 0, 0, 0 },
/* U+ee88 */ { 0, 0, 0, 0, 0 },
/* U+ee89 */ { 0, 0, 0, 0, 0 },
/* U+ee8a */ { 0, 0, 0, 0, 0 },
/* U+ee8b */ { 0, 0, 0, 0, 0 },
/* U+ee8c */ { 0, 0, 0, 0, 0 },
/* U+ee8d */ { 0, 0, 0, 0, 0 },
/* U+ee8e */ { 0, 0, 0, 0, 0 },
/* U+ee8f */ { 0, 0, 0, 0, 0 },
/* U+ee90 */ { 0, 0, 0, 0, 0 },
/* U+ee91 */ { 0, 0, 0, 0, 0 },
/* U+ee92 */ { 0, 0, 0, 0, 0 },
/* U+ee93 */ { 0, 0, 0, 0, 0 },
/* U+ee94 */ { 0, 0, 0, 0, 0 },
/* U+ee95 */ { 0, 0, 0, 0, 0 },
/* U+ee96 */ { 0, 0, 0, 0, 0 },
/* U+ee97 */ { 0, 0, 0, 0, 0 },
/* U+ee98 */ { 0, 0, 0, 0, 0 },
/* U+ee99 */ { 0, 0, 0, 0, 0 },
/* U+ee9a */ { 0, 0, 0, 0, 0 },
/* U+ee9b */ { 0, 0, 0, 0, 0 },
/* U+ee9c */ { 0, 0, 0, 0, 0 },
/* U+ee9d */ { 0, 0, 0, 0, 0 },
/* U+ee9e */ { 0, 0, 0, 0, 0 },
/* U+ee9f */ { 0, 0, 0, 0, 0 },
/* U+eea0 */ { 0, 0, 0, 0, 0 },
/* U+eea1 */ { 0, 0, 0, 0, 0 },
/* U+eea2 */ { 0, 0, 0, 0, 0 },
/* U+eea3 */ { 0, 0, 0, 0, 0 },
/* U+eea4 */ { 0, 0, 0, 0, 0 },
/* U+eea5 */ { 0, 0, 0, 0, 0 },
/* U+eea6 */ { 0, 0, 0, 0, 0 },
/* U+eea7 */ { 0, 0, 0, 0, 0 },
/* U+eea8 */ { 0, 0, 0, 0, 0 },
/* U+eea9 */ { 0, 0, 0, 0, 0 },
/* U+eeaa */ { 0, 0, 0, 0, 0 },
/* U+eeab */ { 0, 0, 0, 0, 0 },
/* U+eeac */ { 0, 0, 0, 0, 0 },
/* U+eead */ { 0, 0, 0, 0, 0 },
/* U+eeae */ { 0, 0, 0, 0, 0 },
/* U+eeaf */ { 0, 0, 0, 0, 0 },
/* U+eeb0 */ { 0, 0, 0, 0, 0 },
/* U+eeb1 */ { 0, 0, 0, 0, 0 },
/* U+eeb2 */ { 0, 0, 0, 0, 0 },
/* U+eeb3 */ { 0, 0, 0, 0, 0 },
/* U+eeb4 */ { 0, 0, 0, 0, 0 },
/* U+eeb5 */ { 0, 0, 0, 0, 0 },
/* U+eeb6 */ { 0, 0, 0, 0, 0 },
/* U+eeb7 */ { 0, 0, 0, 0, 0 },
/* U+eeb8 */ { 0, 0, 0, 0, 0 },
/* U+eeb9 */ { 0, 0, 0, 0, 0 },
/* U+eeba */ { 0, 0, 0, 0, 0 },
/* U+eebb */ { 0, 0, 0, 0, 0 },
/* U+eebc */ { 0, 0, 0, 0, 0 },
/* U+eebd */ { 0, 0, 0, 0, 0 },
/* U+eebe */ { 0, 0, 0, 0, 0 },
/* U+eebf */ { 0, 0, 0, 0, 0 },
/* U+eec0 */ { 0, 0, 0, 0, 0 },
/* U+eec1 */ { 0, 0, 0, 0, 0 },
/* U+eec2 */ { 0, 0, 0, 0, 0 },
/* U+eec3 */ { 0, 0, 0, 0, 0 },
/* U+eec4 */ { 0, 0, 0, 0, 0 },
/* U+eec5 */ { 0, 0, 0, 0, 0 },
/* U+eec6 */ { 0, 0, 0, 0, 0 },
/* U+eec7 */ { 0, 0, 0, 0, 0 },
/* U+eec8 */ { 0, 0, 0, 0, 0 },
/* U+eec9 */ { 0, 0, 0, 0, 0 },
/* U+eeca */ { 0, 0, 0, 0, 0 },
/* U+eecb */ { 0, 0, 0, 0, 0 },
/* U+eecc */ { 0, 0, 0, 0, 0 },
/* U+eecd */ { 0, 0, 0, 0, 0 },
/* U+eece */ { 0, 0, 0, 0, 0 },
/* U+eecf */ { 0, 0, 0, 0, 0 },
/* U+eed0 */ { 0, 0, 0, 0, 0 },
/* U+eed1 */ { 0, 0, 0, 0, 0 },
/* U+eed2 */ { 0, 0, 0, 0, 0 },
/* U+eed3 */ { 0, 0, 0, 0, 0 },
/* U+eed4 */ { 0, 0, 0, 0, 0 },
/* U+eed5 */ { 0, 0, 0, 0, 0 },
/* U+eed6 */ { 0, 0, 0, 0, 0 },
/* U+eed7 */ { 0, 0, 0, 0, 0 },
/* U+eed8 */ { 0, 0, 0, 0, 0 },
/* U+eed9 */ { 0, 0, 0, 0, 0 },
/* U+eeda */ { 0, 0, 0, 0, 0 },
/* U+eedb */ { 0, 0, 0, 0, 0 },
/* U+eedc */ { 0, 0, 0, 0, 0 },
/* U+eedd */ { 0, 0, 0, 0, 0 },
/* U+eede */ { 0, 0, 0, 0, 0 },
/* U+eedf */ { 0, 0, 0, 0, 0 },
/* U+eee0 */ { 0, 0, 0, 0, 0 },
/* U+eee1 */ { 0, 0, 0, 0, 0 },
/* U+eee2 */ { 0, 0, 0, 0, 0 },
/* U+eee3 */ { 0, 0, 0, 0, 0 },
/* U+eee4 */ { 0, 0, 0, 0, 0 },
/* U+eee5 */ { 0, 0, 0, 0, 0 },
/* U+eee6 */ { 0, 0, 0, 0, 0 },
/* U+eee7 */ { 0, 0, 0, 0, 0 },
/* U+eee8 */ { 0, 0, 0, 0, 0 },
/* U+eee9 */ { 0, 0, 0, 0, 0 },
/* U+eeea */ { 0, 0, 0, 0, 0 },
/* U+eeeb */ { 0, 0, 0, 0, 0 },
/* U+eeec */ { 0, 0, 0, 0, 0 },
/* U+eeed */ { 0, 0, 0, 0, 0 },
/* U+eeee */ { 0, 0, 0, 0, 0 },
/* U+eeef */ { 0, 0, 0, 0, 0 },
/* U+eef0 */ { 0, 0, 0, 0, 0 },
/* U+eef1 */ { 0, 0, 0, 0, 0 },
/* U+eef2 */ { 0, 0, 0, 0, 0 },
/* U+eef3 */ { 0, 0, 0, 0, 0 },
/* U+eef4 */ { 0, 0, 0, 0, 0 },
/* U+eef5 */ { 0, 0, 0, 0, 0 },
/* U+eef6 */ { 0, 0, 0, 0, 0 },
/* U+eef7 */ { 0, 0, 0, 0, 0 },
/* U+eef8 */ { 0, 0, 0, 0, 0 },
/* U+eef9 */ { 0, 0, 0, 0, 0 },
/* U+eefa */ { 0, 0, 0, 0, 0 },
/* U+eefb */ { 0, 0, 0, 0, 0 },
/* U+eefc */ { 0, 0, 0, 0, 0 },
/* U+eefd */ { 0, 0, 0, 0, 0 },
/* U+eefe */ { 0, 0, 0, 0, 0 },
/* U+eeff */ { 0, 0, 0, 0, 0 },
/* U+ef00 */ { 0, 0, 0, 0, 0 },
/* U+ef01 */ { 0, 0, 0, 0, 0 },
/* U+ef02 */ { 0, 0, 0, 0, 0 },
/* U+ef03 */ { 0, 0, 0, 0, 0 },
/* U+ef04 */ { 0, 0, 0, 0, 0 },
/* U+ef05 */ { 0, 0, 0, 0, 0 },
/* U+ef06 */ { 0, 0, 0, 0, 0 },
/* U+ef07 */ { 0, 0, 0, 0, 0 },
/* U+ef08 */ { 0, 0, 0, 0, 0 },
/* U+ef09 */ { 0, 0, 0, 0, 0 },
/* U+ef0a */ { 0, 0, 0, 0, 0 },
/* U+ef0b */ { 0, 0, 0, 0, 0 },
/* U+ef0c */ { 0, 0, 0, 0, 0 },
/* U+ef0d */ { 0, 0, 0, 0, 0 },
/* U+ef0e */ { 0, 0, 0, 0, 0 },
/* U+ef0f */ { 0, 0, 0, 0, 0 },
/* U+ef10 */ { 0, 0, 0, 0, 0 },
/* U+ef11 */ { 0, 0, 0, 0, 0 },
/* U+ef12 */ { 0, 0, 0, 0, 0 },
/* U+ef13 */ { 0, 0, 0, 0, 0 },
/* U+ef14 */ { 0, 0, 0, 0, 0 },
/* U+ef15 */ { 0, 0, 0, 0, 0 },
/* U+ef16 */ { 0, 0, 0, 0, 0 },
/* U+ef17 */ { 0, 0, 0, 0, 0 },
/* U+ef18 */ { 0, 0, 0, 0, 0 },
/* U+ef19 */ { 0, 0, 0, 0, 0 },
/* U+ef1a */ { 0, 0, 0, 0, 0 },
/* U+ef1b */ { 0, 0, 0, 0, 0 },
/* U+ef1c */ { 0, 0, 0, 0, 0 },
/* U+ef1d */ { 0, 0, 0, 0, 0 },
/* U+ef1e */ { 0, 0, 0, 0, 0 },
/* U+ef1f */ { 0, 0, 0, 0, 0 },
/* U+ef20 */ { 0, 0, 0, 0, 0 },
/* U+ef21 */ { 0, 0, 0, 0, 0 },
/* U+ef22 */ { 0, 0, 0, 0, 0 },
/* U+ef23 */ { 0, 0, 0, 0, 0 },
/* U+ef24 */ { 0, 0, 0, 0, 0 },
/* U+ef25 */ { 0, 0, 0, 0, 0 },
/* U+ef26 */ { 0, 0, 0, 0, 0 },
/* U+ef27 */ { 0, 0, 0, 0, 0 },
/* U+ef28 */ { 0, 0, 0, 0, 0 },
/* U+ef29 */ { 0, 0, 0, 0, 0 },
/* U+ef2a */ { 0, 0, 0, 0, 0 },
/* U+ef2b */ { 0, 0, 0, 0, 0 },
/* U+ef2c */ { 0, 0, 0, 0, 0 },
/* U+ef2d */ { 0, 0, 0, 0, 0 },
/* U+ef2e */ { 0, 0, 0, 0, 0 },
/* U+ef2f */ { 0, 0, 0, 0, 0 },
/* U+ef30 */ { 0, 0, 0, 0, 0 },
/* U+ef31 */ { 0, 0, 0, 0, 0 },
/* U+ef32 */ { 0, 0, 0, 0, 0 },
/* U+ef33 */ { 0, 0, 0, 0, 0 },
/* U+ef34 */ { 0, 0, 0, 0, 0 },
/* U+ef35 */ { 0, 0, 0, 0, 0 },
/* U+ef36 */ { 0, 0, 0, 0, 0 },
/* U+ef37 */ { 0, 0, 0, 0, 0 },
/* U+ef38 */ { 0, 0, 0, 0, 0 },
/* U+ef39 */ { 0, 0, 0, 0, 0 },
/* U+ef3a */ { 0, 0, 0, 0, 0 },
/* U+ef3b */ { 0, 0, 0, 0, 0 },
/* U+ef3c */ { 0, 0, 0, 0, 0 },
/* U+ef3d */ { 0, 0, 0, 0, 0 },
/* U+ef3e */ { 0, 0, 0, 0, 0 },
/* U+ef3f */ { 0, 0, 0, 0, 0 },
/* U+ef40 */ { 0, 0, 0, 0, 0 },
/* U+ef41 */ { 0, 0, 0, 0, 0 },
/* U+ef42 */ { 0, 0, 0, 0, 0 },
/* U+ef43 */ { 0, 0, 0, 0, 0 },
/* U+ef44 */ { 0, 0, 0, 0, 0 },
/* U+ef45 */ { 0, 0, 0, 0, 0 },
/* U+ef46 */ { 0, 0, 0, 0, 0 },
/* U+ef47 */ { 0, 0, 0, 0, 0 },
/* U+ef48 */ { 0, 0, 0, 0, 0 },
/* U+ef49 */ { 0, 0, 0, 0, 0 },
/* U+ef4a */ { 0, 0, 0, 0, 0 },
/* U+ef4b */ { 0, 0, 0, 0, 0 },
/* U+ef4c */ { 0, 0, 0, 0, 0 },
/* U+ef4d */ { 0, 0, 0, 0, 0 },
/* U+ef4e */ { 0, 0, 0, 0, 0 },
/* U+ef4f */ { 0, 0, 0, 0, 0 },
/* U+ef50 */ { 0, 0, 0, 0, 0 },
/* U+ef51 */ { 0, 0, 0, 0, 0 },
/* U+ef52 */ { 0, 0, 0, 0, 0 },
/* U+ef53 */ { 0, 0, 0, 0, 0 },
/* U+ef54 */ { 0, 0, 0, 0, 0 },
/* U+ef55 */ { 0, 0, 0, 0, 0 },
/* U+ef56 */ { 0, 0, 0, 0, 0 },
/* U+ef57 */ { 0, 0, 0, 0, 0 },
/* U+ef58 */ { 0, 0, 0, 0, 0 },
/* U+ef59 */ { 0, 0, 0, 0, 0 },
/* U+ef5a */ { 0, 0, 0, 0, 0 },
/* U+ef5b */ { 0, 0, 0, 0, 0 },
/* U+ef5c */ { 0, 0, 0, 0, 0 },
/* U+ef5d */ { 0, 0, 0, 0, 0 },
/* U+ef5e */ { 0, 0, 0, 0, 0 },
/* U+ef5f */ { 0, 0, 0, 0, 0 },
/* U+ef60 */ { 0, 0, 0, 0, 0 },
/* U+ef61 */ { 0, 0, 0, 0, 0 },
/* U+ef62 */ { 0, 0, 0, 0, 0 },
/* U+ef63 */ { 0, 0, 0, 0, 0 },
/* U+ef64 */ { 0, 0, 0, 0, 0 },
/* U+ef65 */ { 0, 0, 0, 0, 0 },
/* U+ef66 */ { 0, 0, 0, 0, 0 },
/* U+ef67 */ { 0, 0, 0, 0, 0 },
/* U+ef68 */ { 0, 0, 0, 0, 0 },
/* U+ef69 */ { 0, 0, 0, 0, 0 },
/* U+ef6a */ { 0, 0, 0, 0, 0 },
/* U+ef6b */ { 0, 0, 0, 0, 0 },
/* U+ef6c */ { 0, 0, 0, 0, 0 },
/* U+ef6d */ { 0, 0, 0, 0, 0 },
/* U+ef6e */ { 0, 0, 0, 0, 0 },
/* U+ef6f */ { 0, 0, 0, 0, 0 },
/* U+ef70 */ { 0, 0, 0, 0, 0 },
/* U+ef71 */ { 0, 0, 0, 0, 0 },
/* U+ef72 */ { 0, 0, 0, 0, 0 },
/* U+ef73 */ { 0, 0, 0, 0, 0 },
/* U+ef74 */ { 0, 0, 0, 0, 0 },
/* U+ef75 */ { 0, 0, 0, 0, 0 },
/* U+ef76 */ { 0, 0, 0, 0, 0 },
/* U+ef77 */ { 0, 0, 0, 0, 0 },
/* U+ef78 */ { 0, 0, 0, 0, 0 },
/* U+ef79 */ { 0, 0, 0, 0, 0 },
/* U+ef7a */ { 0, 0, 0, 0, 0 },
/* U+ef7b */ { 0, 0, 0, 0, 0 },
/* U+ef7c */ { 0, 0, 0, 0, 0 },
/* U+ef7d */ { 0, 0, 0, 0, 0 },
/* U+ef7e */ { 0, 0, 0, 0, 0 },
/* U+ef7f */ { 0, 0, 0, 0, 0 },
/* U+ef80 */ { 0, 0, 0, 0, 0 },
/* U+ef81 */ { 0, 0, 0, 0, 0 },
/* U+ef82 */ { 0, 0, 0, 0, 0 },
/* U+ef83 */ { 0, 0, 0, 0, 0 },
/* U+ef84 */ { 0, 0, 0, 0, 0 },
/* U+ef85 */ { 0, 0, 0, 0, 0 },
/* U+ef86 */ { 0, 0, 0, 0, 0 },
/* U+ef87 */ { 0, 0, 0, 0, 0 },
/* U+ef88 */ { 0, 0, 0, 0, 0 },
/* U+ef89 */ { 0, 0, 0, 0, 0 },
/* U+ef8a */ { 0, 0, 0, 0, 0 },
/* U+ef8b */ { 0, 0, 0, 0, 0 },
/* U+ef8c */ { 0, 0, 0, 0, 0 },
/* U+ef8d */ { 0, 0, 0, 0, 0 },
/* U+ef8e */ { 0, 0, 0, 0, 0 },
/* U+ef8f */ { 0, 0, 0, 0, 0 },
/* U+ef90 */ { 0, 0, 0, 0, 0 },
/* U+ef91 */ { 0, 0, 0, 0, 0 },
/* U+ef92 */ { 0, 0, 0, 0, 0 },
/* U+ef93 */ { 0, 0, 0, 0, 0 },
/* U+ef94 */ { 0, 0, 0, 0, 0 },
/* U+ef95 */ { 0, 0, 0, 0, 0 },
/* U+ef96 */ { 0, 0, 0, 0, 0 },
/* U+ef97 */ { 0, 0, 0, 0, 0 },
/* U+ef98 */ { 0, 0, 0, 0, 0 },
/* U+ef99 */ { 0, 0, 0, 0, 0 },
/* U+ef9a */ { 0, 0, 0, 0, 0 },
/* U+ef9b */ { 0, 0, 0, 0, 0 },
/* U+ef9c */ { 0, 0, 0, 0, 0 },
/* U+ef9d */ { 0, 0, 0, 0, 0 },
/* U+ef9e */ { 0, 0, 0, 0, 0 },
/* U+ef9f */ { 0, 0, 0, 0, 0 },
/* U+efa0 */ { 0, 0, 0, 0, 0 },
/* U+efa1 */ { 0, 0, 0, 0, 0 },
/* U+efa2 */ { 0, 0, 0, 0, 0 },
/* U+efa3 */ { 0, 0, 0, 0, 0 },
/* U+efa4 */ { 0, 0, 0, 0, 0 },
/* U+efa5 */ { 0, 0, 0, 0, 0 },
/* U+efa6 */ { 0, 0, 0, 0, 0 },
/* U+efa7 */ { 0, 0, 0, 0, 0 },
/* U+efa8 */ { 0, 0, 0, 0, 0 },
/* U+efa9 */ { 0, 0, 0, 0, 0 },
/* U+efaa */ { 0, 0, 0, 0, 0 },
/* U+efab */ { 0, 0, 0, 0, 0 },
/* U+efac */ { 0, 0, 0, 0, 0 },
/* U+efad */ { 0, 0, 0, 0, 0 },
/* U+efae */ { 0, 0, 0, 0, 0 },
/* U+efaf */ { 0, 0, 0, 0, 0 },
/* U+efb0 */ { 0, 0, 0, 0, 0 },
/* U+efb1 */ { 0, 0, 0, 0, 0 },
/* U+efb2 */ { 0, 0, 0, 0, 0 },
/* U+efb3 */ { 0, 0, 0, 0, 0 },
/* U+efb4 */ { 0, 0, 0, 0, 0 },
/* U+efb5 */ { 0, 0, 0, 0, 0 },
/* U+efb6 */ { 0, 0, 0, 0, 0 },
/* U+efb7 */ { 0, 0, 0, 0, 0 },
/* U+efb8 */ { 0, 0, 0, 0, 0 },
/* U+efb9 */ { 0, 0, 0, 0, 0 },
/* U+efba */ { 0, 0, 0, 0, 0 },
/* U+efbb */ { 0, 0, 0, 0, 0 },
/* U+efbc */ { 0, 0, 0, 0, 0 },
/* U+efbd */ { 0, 0, 0, 0, 0 },
/* U+efbe */ { 0, 0, 0, 0, 0 },
/* U+efbf */ { 0, 0, 0, 0, 0 },
/* U+efc0 */ { 0, 0, 0, 0, 0 },
/* U+efc1 */ { 0, 0, 0, 0, 0 },
/* U+efc2 */ { 0, 0, 0, 0, 0 },
/* U+efc3 */ { 0, 0, 0, 0, 0 },
/* U+efc4 */ { 0, 0, 0, 0, 0 },
/* U+efc5 */ { 0, 0, 0, 0, 0 },
/* U+efc6 */ { 0, 0, 0, 0, 0 },
/* U+efc7 */ { 0, 0, 0, 0, 0 },
/* U+efc8 */ { 0, 0, 0, 0, 0 },
/* U+efc9 */ { 0, 0, 0, 0, 0 },
/* U+efca */ { 0, 0, 0, 0, 0 },
/* U+efcb */ { 0, 0, 0, 0, 0 },
/* U+efcc */ { 0, 0, 0, 0, 0 },
/* U+efcd */ { 0, 0, 0, 0, 0 },
/* U+efce */ { 0, 0, 0, 0, 0 },
/* U+efcf */ { 0, 0, 0, 0, 0 },
/* U+efd0 */ { 0, 0, 0, 0, 0 },
/* U+efd1 */ { 0, 0, 0, 0, 0 },
/* U+efd2 */ { 0, 0, 0, 0, 0 },
/* U+efd3 */ { 0, 0, 0, 0, 0 },
/* U+efd4 */ { 0, 0, 0, 0, 0 },
/* U+efd5 */ { 0, 0, 0, 0, 0 },
/* U+efd6 */ { 0, 0, 0, 0, 0 },
/* U+efd7 */ { 0, 0, 0, 0, 0 },
/* U+efd8 */ { 0, 0, 0, 0, 0 },
/* U+efd9 */ { 0, 0, 0, 0, 0 },
/* U+efda */ { 0, 0, 0, 0, 0 },
/* U+efdb */ { 0, 0, 0, 0, 0 },
/* U+efdc */ { 0, 0, 0, 0, 0 },
/* U+efdd */ { 0, 0, 0, 0, 0 },
/* U+efde */ { 0, 0, 0, 0, 0 },
/* U+efdf */ { 0, 0, 0, 0, 0 },
/* U+efe0 */ { 0, 0, 0, 0, 0 },
/* U+efe1 */ { 0, 0, 0, 0, 0 },
/* U+efe2 */ { 0, 0, 0, 0, 0 },
/* U+efe3 */ { 0, 0, 0, 0, 0 },
/* U+efe4 */ { 0, 0, 0, 0, 0 },
/* U+efe5 */ { 0, 0, 0, 0, 0 },
/* U+efe6 */ { 0, 0, 0, 0, 0 },
/* U+efe7 */ { 0, 0, 0, 0, 0 },
/* U+efe8 */ { 0, 0, 0, 0, 0 },
/* U+efe9 */ { 0, 0, 0, 0, 0 },
/* U+efea */ { 0, 0, 0, 0, 0 },
/* U+efeb */ { 0, 0, 0, 0, 0 },
/* U+efec */ { 0, 0, 0, 0, 0 },
/* U+efed */ { 0, 0, 0, 0, 0 },
/* U+efee */ { 0, 0, 0, 0, 0 },
/* U+efef */ { 0, 0, 0, 0, 0 },
/* U+eff0 */ { 0, 0, 0, 0, 0 },
/* U+eff1 */ { 0, 0, 0, 0, 0 },
/* U+eff2 */ { 0, 0, 0, 0, 0 },
/* U+eff3 */ { 0, 0, 0, 0, 0 },
/* U+eff4 */ { 0, 0, 0, 0, 0 },
/* U+eff5 */ { 0, 0, 0, 0, 0 },
/* U+eff6 */ { 0, 0, 0, 0, 0 },
/* U+eff7 */ { 0, 0, 0, 0, 0 },
/* U+eff8 */ { 0, 0, 0, 0, 0 },
/* U+eff9 */ { 0, 0, 0, 0, 0 },
/* U+effa */ { 0, 0, 0, 0, 0 },
/* U+effb */ { 0, 0, 0, 0, 0 },
/* U+effc */ { 0, 0, 0, 0, 0 },
/* U+effd */ { 0, 0, 0, 0, 0 },
/* U+effe */ { 0, 0, 0, 0, 0 },
/* U+efff */ { 0, 0, 0, 0, 0 },

};

const _PyUnicode_DatabaseRecord _PyUnicode_Database_15[4096] = {
    
/* U+f000 */ { 0, 0, 0, 0, 0 },
/* U+f001 */ { 0, 0, 0, 0, 0 },
/* U+f002 */ { 0, 0, 0, 0, 0 },
/* U+f003 */ { 0, 0, 0, 0, 0 },
/* U+f004 */ { 0, 0, 0, 0, 0 },
/* U+f005 */ { 0, 0, 0, 0, 0 },
/* U+f006 */ { 0, 0, 0, 0, 0 },
/* U+f007 */ { 0, 0, 0, 0, 0 },
/* U+f008 */ { 0, 0, 0, 0, 0 },
/* U+f009 */ { 0, 0, 0, 0, 0 },
/* U+f00a */ { 0, 0, 0, 0, 0 },
/* U+f00b */ { 0, 0, 0, 0, 0 },
/* U+f00c */ { 0, 0, 0, 0, 0 },
/* U+f00d */ { 0, 0, 0, 0, 0 },
/* U+f00e */ { 0, 0, 0, 0, 0 },
/* U+f00f */ { 0, 0, 0, 0, 0 },
/* U+f010 */ { 0, 0, 0, 0, 0 },
/* U+f011 */ { 0, 0, 0, 0, 0 },
/* U+f012 */ { 0, 0, 0, 0, 0 },
/* U+f013 */ { 0, 0, 0, 0, 0 },
/* U+f014 */ { 0, 0, 0, 0, 0 },
/* U+f015 */ { 0, 0, 0, 0, 0 },
/* U+f016 */ { 0, 0, 0, 0, 0 },
/* U+f017 */ { 0, 0, 0, 0, 0 },
/* U+f018 */ { 0, 0, 0, 0, 0 },
/* U+f019 */ { 0, 0, 0, 0, 0 },
/* U+f01a */ { 0, 0, 0, 0, 0 },
/* U+f01b */ { 0, 0, 0, 0, 0 },
/* U+f01c */ { 0, 0, 0, 0, 0 },
/* U+f01d */ { 0, 0, 0, 0, 0 },
/* U+f01e */ { 0, 0, 0, 0, 0 },
/* U+f01f */ { 0, 0, 0, 0, 0 },
/* U+f020 */ { 0, 0, 0, 0, 0 },
/* U+f021 */ { 0, 0, 0, 0, 0 },
/* U+f022 */ { 0, 0, 0, 0, 0 },
/* U+f023 */ { 0, 0, 0, 0, 0 },
/* U+f024 */ { 0, 0, 0, 0, 0 },
/* U+f025 */ { 0, 0, 0, 0, 0 },
/* U+f026 */ { 0, 0, 0, 0, 0 },
/* U+f027 */ { 0, 0, 0, 0, 0 },
/* U+f028 */ { 0, 0, 0, 0, 0 },
/* U+f029 */ { 0, 0, 0, 0, 0 },
/* U+f02a */ { 0, 0, 0, 0, 0 },
/* U+f02b */ { 0, 0, 0, 0, 0 },
/* U+f02c */ { 0, 0, 0, 0, 0 },
/* U+f02d */ { 0, 0, 0, 0, 0 },
/* U+f02e */ { 0, 0, 0, 0, 0 },
/* U+f02f */ { 0, 0, 0, 0, 0 },
/* U+f030 */ { 0, 0, 0, 0, 0 },
/* U+f031 */ { 0, 0, 0, 0, 0 },
/* U+f032 */ { 0, 0, 0, 0, 0 },
/* U+f033 */ { 0, 0, 0, 0, 0 },
/* U+f034 */ { 0, 0, 0, 0, 0 },
/* U+f035 */ { 0, 0, 0, 0, 0 },
/* U+f036 */ { 0, 0, 0, 0, 0 },
/* U+f037 */ { 0, 0, 0, 0, 0 },
/* U+f038 */ { 0, 0, 0, 0, 0 },
/* U+f039 */ { 0, 0, 0, 0, 0 },
/* U+f03a */ { 0, 0, 0, 0, 0 },
/* U+f03b */ { 0, 0, 0, 0, 0 },
/* U+f03c */ { 0, 0, 0, 0, 0 },
/* U+f03d */ { 0, 0, 0, 0, 0 },
/* U+f03e */ { 0, 0, 0, 0, 0 },
/* U+f03f */ { 0, 0, 0, 0, 0 },
/* U+f040 */ { 0, 0, 0, 0, 0 },
/* U+f041 */ { 0, 0, 0, 0, 0 },
/* U+f042 */ { 0, 0, 0, 0, 0 },
/* U+f043 */ { 0, 0, 0, 0, 0 },
/* U+f044 */ { 0, 0, 0, 0, 0 },
/* U+f045 */ { 0, 0, 0, 0, 0 },
/* U+f046 */ { 0, 0, 0, 0, 0 },
/* U+f047 */ { 0, 0, 0, 0, 0 },
/* U+f048 */ { 0, 0, 0, 0, 0 },
/* U+f049 */ { 0, 0, 0, 0, 0 },
/* U+f04a */ { 0, 0, 0, 0, 0 },
/* U+f04b */ { 0, 0, 0, 0, 0 },
/* U+f04c */ { 0, 0, 0, 0, 0 },
/* U+f04d */ { 0, 0, 0, 0, 0 },
/* U+f04e */ { 0, 0, 0, 0, 0 },
/* U+f04f */ { 0, 0, 0, 0, 0 },
/* U+f050 */ { 0, 0, 0, 0, 0 },
/* U+f051 */ { 0, 0, 0, 0, 0 },
/* U+f052 */ { 0, 0, 0, 0, 0 },
/* U+f053 */ { 0, 0, 0, 0, 0 },
/* U+f054 */ { 0, 0, 0, 0, 0 },
/* U+f055 */ { 0, 0, 0, 0, 0 },
/* U+f056 */ { 0, 0, 0, 0, 0 },
/* U+f057 */ { 0, 0, 0, 0, 0 },
/* U+f058 */ { 0, 0, 0, 0, 0 },
/* U+f059 */ { 0, 0, 0, 0, 0 },
/* U+f05a */ { 0, 0, 0, 0, 0 },
/* U+f05b */ { 0, 0, 0, 0, 0 },
/* U+f05c */ { 0, 0, 0, 0, 0 },
/* U+f05d */ { 0, 0, 0, 0, 0 },
/* U+f05e */ { 0, 0, 0, 0, 0 },
/* U+f05f */ { 0, 0, 0, 0, 0 },
/* U+f060 */ { 0, 0, 0, 0, 0 },
/* U+f061 */ { 0, 0, 0, 0, 0 },
/* U+f062 */ { 0, 0, 0, 0, 0 },
/* U+f063 */ { 0, 0, 0, 0, 0 },
/* U+f064 */ { 0, 0, 0, 0, 0 },
/* U+f065 */ { 0, 0, 0, 0, 0 },
/* U+f066 */ { 0, 0, 0, 0, 0 },
/* U+f067 */ { 0, 0, 0, 0, 0 },
/* U+f068 */ { 0, 0, 0, 0, 0 },
/* U+f069 */ { 0, 0, 0, 0, 0 },
/* U+f06a */ { 0, 0, 0, 0, 0 },
/* U+f06b */ { 0, 0, 0, 0, 0 },
/* U+f06c */ { 0, 0, 0, 0, 0 },
/* U+f06d */ { 0, 0, 0, 0, 0 },
/* U+f06e */ { 0, 0, 0, 0, 0 },
/* U+f06f */ { 0, 0, 0, 0, 0 },
/* U+f070 */ { 0, 0, 0, 0, 0 },
/* U+f071 */ { 0, 0, 0, 0, 0 },
/* U+f072 */ { 0, 0, 0, 0, 0 },
/* U+f073 */ { 0, 0, 0, 0, 0 },
/* U+f074 */ { 0, 0, 0, 0, 0 },
/* U+f075 */ { 0, 0, 0, 0, 0 },
/* U+f076 */ { 0, 0, 0, 0, 0 },
/* U+f077 */ { 0, 0, 0, 0, 0 },
/* U+f078 */ { 0, 0, 0, 0, 0 },
/* U+f079 */ { 0, 0, 0, 0, 0 },
/* U+f07a */ { 0, 0, 0, 0, 0 },
/* U+f07b */ { 0, 0, 0, 0, 0 },
/* U+f07c */ { 0, 0, 0, 0, 0 },
/* U+f07d */ { 0, 0, 0, 0, 0 },
/* U+f07e */ { 0, 0, 0, 0, 0 },
/* U+f07f */ { 0, 0, 0, 0, 0 },
/* U+f080 */ { 0, 0, 0, 0, 0 },
/* U+f081 */ { 0, 0, 0, 0, 0 },
/* U+f082 */ { 0, 0, 0, 0, 0 },
/* U+f083 */ { 0, 0, 0, 0, 0 },
/* U+f084 */ { 0, 0, 0, 0, 0 },
/* U+f085 */ { 0, 0, 0, 0, 0 },
/* U+f086 */ { 0, 0, 0, 0, 0 },
/* U+f087 */ { 0, 0, 0, 0, 0 },
/* U+f088 */ { 0, 0, 0, 0, 0 },
/* U+f089 */ { 0, 0, 0, 0, 0 },
/* U+f08a */ { 0, 0, 0, 0, 0 },
/* U+f08b */ { 0, 0, 0, 0, 0 },
/* U+f08c */ { 0, 0, 0, 0, 0 },
/* U+f08d */ { 0, 0, 0, 0, 0 },
/* U+f08e */ { 0, 0, 0, 0, 0 },
/* U+f08f */ { 0, 0, 0, 0, 0 },
/* U+f090 */ { 0, 0, 0, 0, 0 },
/* U+f091 */ { 0, 0, 0, 0, 0 },
/* U+f092 */ { 0, 0, 0, 0, 0 },
/* U+f093 */ { 0, 0, 0, 0, 0 },
/* U+f094 */ { 0, 0, 0, 0, 0 },
/* U+f095 */ { 0, 0, 0, 0, 0 },
/* U+f096 */ { 0, 0, 0, 0, 0 },
/* U+f097 */ { 0, 0, 0, 0, 0 },
/* U+f098 */ { 0, 0, 0, 0, 0 },
/* U+f099 */ { 0, 0, 0, 0, 0 },
/* U+f09a */ { 0, 0, 0, 0, 0 },
/* U+f09b */ { 0, 0, 0, 0, 0 },
/* U+f09c */ { 0, 0, 0, 0, 0 },
/* U+f09d */ { 0, 0, 0, 0, 0 },
/* U+f09e */ { 0, 0, 0, 0, 0 },
/* U+f09f */ { 0, 0, 0, 0, 0 },
/* U+f0a0 */ { 0, 0, 0, 0, 0 },
/* U+f0a1 */ { 0, 0, 0, 0, 0 },
/* U+f0a2 */ { 0, 0, 0, 0, 0 },
/* U+f0a3 */ { 0, 0, 0, 0, 0 },
/* U+f0a4 */ { 0, 0, 0, 0, 0 },
/* U+f0a5 */ { 0, 0, 0, 0, 0 },
/* U+f0a6 */ { 0, 0, 0, 0, 0 },
/* U+f0a7 */ { 0, 0, 0, 0, 0 },
/* U+f0a8 */ { 0, 0, 0, 0, 0 },
/* U+f0a9 */ { 0, 0, 0, 0, 0 },
/* U+f0aa */ { 0, 0, 0, 0, 0 },
/* U+f0ab */ { 0, 0, 0, 0, 0 },
/* U+f0ac */ { 0, 0, 0, 0, 0 },
/* U+f0ad */ { 0, 0, 0, 0, 0 },
/* U+f0ae */ { 0, 0, 0, 0, 0 },
/* U+f0af */ { 0, 0, 0, 0, 0 },
/* U+f0b0 */ { 0, 0, 0, 0, 0 },
/* U+f0b1 */ { 0, 0, 0, 0, 0 },
/* U+f0b2 */ { 0, 0, 0, 0, 0 },
/* U+f0b3 */ { 0, 0, 0, 0, 0 },
/* U+f0b4 */ { 0, 0, 0, 0, 0 },
/* U+f0b5 */ { 0, 0, 0, 0, 0 },
/* U+f0b6 */ { 0, 0, 0, 0, 0 },
/* U+f0b7 */ { 0, 0, 0, 0, 0 },
/* U+f0b8 */ { 0, 0, 0, 0, 0 },
/* U+f0b9 */ { 0, 0, 0, 0, 0 },
/* U+f0ba */ { 0, 0, 0, 0, 0 },
/* U+f0bb */ { 0, 0, 0, 0, 0 },
/* U+f0bc */ { 0, 0, 0, 0, 0 },
/* U+f0bd */ { 0, 0, 0, 0, 0 },
/* U+f0be */ { 0, 0, 0, 0, 0 },
/* U+f0bf */ { 0, 0, 0, 0, 0 },
/* U+f0c0 */ { 0, 0, 0, 0, 0 },
/* U+f0c1 */ { 0, 0, 0, 0, 0 },
/* U+f0c2 */ { 0, 0, 0, 0, 0 },
/* U+f0c3 */ { 0, 0, 0, 0, 0 },
/* U+f0c4 */ { 0, 0, 0, 0, 0 },
/* U+f0c5 */ { 0, 0, 0, 0, 0 },
/* U+f0c6 */ { 0, 0, 0, 0, 0 },
/* U+f0c7 */ { 0, 0, 0, 0, 0 },
/* U+f0c8 */ { 0, 0, 0, 0, 0 },
/* U+f0c9 */ { 0, 0, 0, 0, 0 },
/* U+f0ca */ { 0, 0, 0, 0, 0 },
/* U+f0cb */ { 0, 0, 0, 0, 0 },
/* U+f0cc */ { 0, 0, 0, 0, 0 },
/* U+f0cd */ { 0, 0, 0, 0, 0 },
/* U+f0ce */ { 0, 0, 0, 0, 0 },
/* U+f0cf */ { 0, 0, 0, 0, 0 },
/* U+f0d0 */ { 0, 0, 0, 0, 0 },
/* U+f0d1 */ { 0, 0, 0, 0, 0 },
/* U+f0d2 */ { 0, 0, 0, 0, 0 },
/* U+f0d3 */ { 0, 0, 0, 0, 0 },
/* U+f0d4 */ { 0, 0, 0, 0, 0 },
/* U+f0d5 */ { 0, 0, 0, 0, 0 },
/* U+f0d6 */ { 0, 0, 0, 0, 0 },
/* U+f0d7 */ { 0, 0, 0, 0, 0 },
/* U+f0d8 */ { 0, 0, 0, 0, 0 },
/* U+f0d9 */ { 0, 0, 0, 0, 0 },
/* U+f0da */ { 0, 0, 0, 0, 0 },
/* U+f0db */ { 0, 0, 0, 0, 0 },
/* U+f0dc */ { 0, 0, 0, 0, 0 },
/* U+f0dd */ { 0, 0, 0, 0, 0 },
/* U+f0de */ { 0, 0, 0, 0, 0 },
/* U+f0df */ { 0, 0, 0, 0, 0 },
/* U+f0e0 */ { 0, 0, 0, 0, 0 },
/* U+f0e1 */ { 0, 0, 0, 0, 0 },
/* U+f0e2 */ { 0, 0, 0, 0, 0 },
/* U+f0e3 */ { 0, 0, 0, 0, 0 },
/* U+f0e4 */ { 0, 0, 0, 0, 0 },
/* U+f0e5 */ { 0, 0, 0, 0, 0 },
/* U+f0e6 */ { 0, 0, 0, 0, 0 },
/* U+f0e7 */ { 0, 0, 0, 0, 0 },
/* U+f0e8 */ { 0, 0, 0, 0, 0 },
/* U+f0e9 */ { 0, 0, 0, 0, 0 },
/* U+f0ea */ { 0, 0, 0, 0, 0 },
/* U+f0eb */ { 0, 0, 0, 0, 0 },
/* U+f0ec */ { 0, 0, 0, 0, 0 },
/* U+f0ed */ { 0, 0, 0, 0, 0 },
/* U+f0ee */ { 0, 0, 0, 0, 0 },
/* U+f0ef */ { 0, 0, 0, 0, 0 },
/* U+f0f0 */ { 0, 0, 0, 0, 0 },
/* U+f0f1 */ { 0, 0, 0, 0, 0 },
/* U+f0f2 */ { 0, 0, 0, 0, 0 },
/* U+f0f3 */ { 0, 0, 0, 0, 0 },
/* U+f0f4 */ { 0, 0, 0, 0, 0 },
/* U+f0f5 */ { 0, 0, 0, 0, 0 },
/* U+f0f6 */ { 0, 0, 0, 0, 0 },
/* U+f0f7 */ { 0, 0, 0, 0, 0 },
/* U+f0f8 */ { 0, 0, 0, 0, 0 },
/* U+f0f9 */ { 0, 0, 0, 0, 0 },
/* U+f0fa */ { 0, 0, 0, 0, 0 },
/* U+f0fb */ { 0, 0, 0, 0, 0 },
/* U+f0fc */ { 0, 0, 0, 0, 0 },
/* U+f0fd */ { 0, 0, 0, 0, 0 },
/* U+f0fe */ { 0, 0, 0, 0, 0 },
/* U+f0ff */ { 0, 0, 0, 0, 0 },
/* U+f100 */ { 0, 0, 0, 0, 0 },
/* U+f101 */ { 0, 0, 0, 0, 0 },
/* U+f102 */ { 0, 0, 0, 0, 0 },
/* U+f103 */ { 0, 0, 0, 0, 0 },
/* U+f104 */ { 0, 0, 0, 0, 0 },
/* U+f105 */ { 0, 0, 0, 0, 0 },
/* U+f106 */ { 0, 0, 0, 0, 0 },
/* U+f107 */ { 0, 0, 0, 0, 0 },
/* U+f108 */ { 0, 0, 0, 0, 0 },
/* U+f109 */ { 0, 0, 0, 0, 0 },
/* U+f10a */ { 0, 0, 0, 0, 0 },
/* U+f10b */ { 0, 0, 0, 0, 0 },
/* U+f10c */ { 0, 0, 0, 0, 0 },
/* U+f10d */ { 0, 0, 0, 0, 0 },
/* U+f10e */ { 0, 0, 0, 0, 0 },
/* U+f10f */ { 0, 0, 0, 0, 0 },
/* U+f110 */ { 0, 0, 0, 0, 0 },
/* U+f111 */ { 0, 0, 0, 0, 0 },
/* U+f112 */ { 0, 0, 0, 0, 0 },
/* U+f113 */ { 0, 0, 0, 0, 0 },
/* U+f114 */ { 0, 0, 0, 0, 0 },
/* U+f115 */ { 0, 0, 0, 0, 0 },
/* U+f116 */ { 0, 0, 0, 0, 0 },
/* U+f117 */ { 0, 0, 0, 0, 0 },
/* U+f118 */ { 0, 0, 0, 0, 0 },
/* U+f119 */ { 0, 0, 0, 0, 0 },
/* U+f11a */ { 0, 0, 0, 0, 0 },
/* U+f11b */ { 0, 0, 0, 0, 0 },
/* U+f11c */ { 0, 0, 0, 0, 0 },
/* U+f11d */ { 0, 0, 0, 0, 0 },
/* U+f11e */ { 0, 0, 0, 0, 0 },
/* U+f11f */ { 0, 0, 0, 0, 0 },
/* U+f120 */ { 0, 0, 0, 0, 0 },
/* U+f121 */ { 0, 0, 0, 0, 0 },
/* U+f122 */ { 0, 0, 0, 0, 0 },
/* U+f123 */ { 0, 0, 0, 0, 0 },
/* U+f124 */ { 0, 0, 0, 0, 0 },
/* U+f125 */ { 0, 0, 0, 0, 0 },
/* U+f126 */ { 0, 0, 0, 0, 0 },
/* U+f127 */ { 0, 0, 0, 0, 0 },
/* U+f128 */ { 0, 0, 0, 0, 0 },
/* U+f129 */ { 0, 0, 0, 0, 0 },
/* U+f12a */ { 0, 0, 0, 0, 0 },
/* U+f12b */ { 0, 0, 0, 0, 0 },
/* U+f12c */ { 0, 0, 0, 0, 0 },
/* U+f12d */ { 0, 0, 0, 0, 0 },
/* U+f12e */ { 0, 0, 0, 0, 0 },
/* U+f12f */ { 0, 0, 0, 0, 0 },
/* U+f130 */ { 0, 0, 0, 0, 0 },
/* U+f131 */ { 0, 0, 0, 0, 0 },
/* U+f132 */ { 0, 0, 0, 0, 0 },
/* U+f133 */ { 0, 0, 0, 0, 0 },
/* U+f134 */ { 0, 0, 0, 0, 0 },
/* U+f135 */ { 0, 0, 0, 0, 0 },
/* U+f136 */ { 0, 0, 0, 0, 0 },
/* U+f137 */ { 0, 0, 0, 0, 0 },
/* U+f138 */ { 0, 0, 0, 0, 0 },
/* U+f139 */ { 0, 0, 0, 0, 0 },
/* U+f13a */ { 0, 0, 0, 0, 0 },
/* U+f13b */ { 0, 0, 0, 0, 0 },
/* U+f13c */ { 0, 0, 0, 0, 0 },
/* U+f13d */ { 0, 0, 0, 0, 0 },
/* U+f13e */ { 0, 0, 0, 0, 0 },
/* U+f13f */ { 0, 0, 0, 0, 0 },
/* U+f140 */ { 0, 0, 0, 0, 0 },
/* U+f141 */ { 0, 0, 0, 0, 0 },
/* U+f142 */ { 0, 0, 0, 0, 0 },
/* U+f143 */ { 0, 0, 0, 0, 0 },
/* U+f144 */ { 0, 0, 0, 0, 0 },
/* U+f145 */ { 0, 0, 0, 0, 0 },
/* U+f146 */ { 0, 0, 0, 0, 0 },
/* U+f147 */ { 0, 0, 0, 0, 0 },
/* U+f148 */ { 0, 0, 0, 0, 0 },
/* U+f149 */ { 0, 0, 0, 0, 0 },
/* U+f14a */ { 0, 0, 0, 0, 0 },
/* U+f14b */ { 0, 0, 0, 0, 0 },
/* U+f14c */ { 0, 0, 0, 0, 0 },
/* U+f14d */ { 0, 0, 0, 0, 0 },
/* U+f14e */ { 0, 0, 0, 0, 0 },
/* U+f14f */ { 0, 0, 0, 0, 0 },
/* U+f150 */ { 0, 0, 0, 0, 0 },
/* U+f151 */ { 0, 0, 0, 0, 0 },
/* U+f152 */ { 0, 0, 0, 0, 0 },
/* U+f153 */ { 0, 0, 0, 0, 0 },
/* U+f154 */ { 0, 0, 0, 0, 0 },
/* U+f155 */ { 0, 0, 0, 0, 0 },
/* U+f156 */ { 0, 0, 0, 0, 0 },
/* U+f157 */ { 0, 0, 0, 0, 0 },
/* U+f158 */ { 0, 0, 0, 0, 0 },
/* U+f159 */ { 0, 0, 0, 0, 0 },
/* U+f15a */ { 0, 0, 0, 0, 0 },
/* U+f15b */ { 0, 0, 0, 0, 0 },
/* U+f15c */ { 0, 0, 0, 0, 0 },
/* U+f15d */ { 0, 0, 0, 0, 0 },
/* U+f15e */ { 0, 0, 0, 0, 0 },
/* U+f15f */ { 0, 0, 0, 0, 0 },
/* U+f160 */ { 0, 0, 0, 0, 0 },
/* U+f161 */ { 0, 0, 0, 0, 0 },
/* U+f162 */ { 0, 0, 0, 0, 0 },
/* U+f163 */ { 0, 0, 0, 0, 0 },
/* U+f164 */ { 0, 0, 0, 0, 0 },
/* U+f165 */ { 0, 0, 0, 0, 0 },
/* U+f166 */ { 0, 0, 0, 0, 0 },
/* U+f167 */ { 0, 0, 0, 0, 0 },
/* U+f168 */ { 0, 0, 0, 0, 0 },
/* U+f169 */ { 0, 0, 0, 0, 0 },
/* U+f16a */ { 0, 0, 0, 0, 0 },
/* U+f16b */ { 0, 0, 0, 0, 0 },
/* U+f16c */ { 0, 0, 0, 0, 0 },
/* U+f16d */ { 0, 0, 0, 0, 0 },
/* U+f16e */ { 0, 0, 0, 0, 0 },
/* U+f16f */ { 0, 0, 0, 0, 0 },
/* U+f170 */ { 0, 0, 0, 0, 0 },
/* U+f171 */ { 0, 0, 0, 0, 0 },
/* U+f172 */ { 0, 0, 0, 0, 0 },
/* U+f173 */ { 0, 0, 0, 0, 0 },
/* U+f174 */ { 0, 0, 0, 0, 0 },
/* U+f175 */ { 0, 0, 0, 0, 0 },
/* U+f176 */ { 0, 0, 0, 0, 0 },
/* U+f177 */ { 0, 0, 0, 0, 0 },
/* U+f178 */ { 0, 0, 0, 0, 0 },
/* U+f179 */ { 0, 0, 0, 0, 0 },
/* U+f17a */ { 0, 0, 0, 0, 0 },
/* U+f17b */ { 0, 0, 0, 0, 0 },
/* U+f17c */ { 0, 0, 0, 0, 0 },
/* U+f17d */ { 0, 0, 0, 0, 0 },
/* U+f17e */ { 0, 0, 0, 0, 0 },
/* U+f17f */ { 0, 0, 0, 0, 0 },
/* U+f180 */ { 0, 0, 0, 0, 0 },
/* U+f181 */ { 0, 0, 0, 0, 0 },
/* U+f182 */ { 0, 0, 0, 0, 0 },
/* U+f183 */ { 0, 0, 0, 0, 0 },
/* U+f184 */ { 0, 0, 0, 0, 0 },
/* U+f185 */ { 0, 0, 0, 0, 0 },
/* U+f186 */ { 0, 0, 0, 0, 0 },
/* U+f187 */ { 0, 0, 0, 0, 0 },
/* U+f188 */ { 0, 0, 0, 0, 0 },
/* U+f189 */ { 0, 0, 0, 0, 0 },
/* U+f18a */ { 0, 0, 0, 0, 0 },
/* U+f18b */ { 0, 0, 0, 0, 0 },
/* U+f18c */ { 0, 0, 0, 0, 0 },
/* U+f18d */ { 0, 0, 0, 0, 0 },
/* U+f18e */ { 0, 0, 0, 0, 0 },
/* U+f18f */ { 0, 0, 0, 0, 0 },
/* U+f190 */ { 0, 0, 0, 0, 0 },
/* U+f191 */ { 0, 0, 0, 0, 0 },
/* U+f192 */ { 0, 0, 0, 0, 0 },
/* U+f193 */ { 0, 0, 0, 0, 0 },
/* U+f194 */ { 0, 0, 0, 0, 0 },
/* U+f195 */ { 0, 0, 0, 0, 0 },
/* U+f196 */ { 0, 0, 0, 0, 0 },
/* U+f197 */ { 0, 0, 0, 0, 0 },
/* U+f198 */ { 0, 0, 0, 0, 0 },
/* U+f199 */ { 0, 0, 0, 0, 0 },
/* U+f19a */ { 0, 0, 0, 0, 0 },
/* U+f19b */ { 0, 0, 0, 0, 0 },
/* U+f19c */ { 0, 0, 0, 0, 0 },
/* U+f19d */ { 0, 0, 0, 0, 0 },
/* U+f19e */ { 0, 0, 0, 0, 0 },
/* U+f19f */ { 0, 0, 0, 0, 0 },
/* U+f1a0 */ { 0, 0, 0, 0, 0 },
/* U+f1a1 */ { 0, 0, 0, 0, 0 },
/* U+f1a2 */ { 0, 0, 0, 0, 0 },
/* U+f1a3 */ { 0, 0, 0, 0, 0 },
/* U+f1a4 */ { 0, 0, 0, 0, 0 },
/* U+f1a5 */ { 0, 0, 0, 0, 0 },
/* U+f1a6 */ { 0, 0, 0, 0, 0 },
/* U+f1a7 */ { 0, 0, 0, 0, 0 },
/* U+f1a8 */ { 0, 0, 0, 0, 0 },
/* U+f1a9 */ { 0, 0, 0, 0, 0 },
/* U+f1aa */ { 0, 0, 0, 0, 0 },
/* U+f1ab */ { 0, 0, 0, 0, 0 },
/* U+f1ac */ { 0, 0, 0, 0, 0 },
/* U+f1ad */ { 0, 0, 0, 0, 0 },
/* U+f1ae */ { 0, 0, 0, 0, 0 },
/* U+f1af */ { 0, 0, 0, 0, 0 },
/* U+f1b0 */ { 0, 0, 0, 0, 0 },
/* U+f1b1 */ { 0, 0, 0, 0, 0 },
/* U+f1b2 */ { 0, 0, 0, 0, 0 },
/* U+f1b3 */ { 0, 0, 0, 0, 0 },
/* U+f1b4 */ { 0, 0, 0, 0, 0 },
/* U+f1b5 */ { 0, 0, 0, 0, 0 },
/* U+f1b6 */ { 0, 0, 0, 0, 0 },
/* U+f1b7 */ { 0, 0, 0, 0, 0 },
/* U+f1b8 */ { 0, 0, 0, 0, 0 },
/* U+f1b9 */ { 0, 0, 0, 0, 0 },
/* U+f1ba */ { 0, 0, 0, 0, 0 },
/* U+f1bb */ { 0, 0, 0, 0, 0 },
/* U+f1bc */ { 0, 0, 0, 0, 0 },
/* U+f1bd */ { 0, 0, 0, 0, 0 },
/* U+f1be */ { 0, 0, 0, 0, 0 },
/* U+f1bf */ { 0, 0, 0, 0, 0 },
/* U+f1c0 */ { 0, 0, 0, 0, 0 },
/* U+f1c1 */ { 0, 0, 0, 0, 0 },
/* U+f1c2 */ { 0, 0, 0, 0, 0 },
/* U+f1c3 */ { 0, 0, 0, 0, 0 },
/* U+f1c4 */ { 0, 0, 0, 0, 0 },
/* U+f1c5 */ { 0, 0, 0, 0, 0 },
/* U+f1c6 */ { 0, 0, 0, 0, 0 },
/* U+f1c7 */ { 0, 0, 0, 0, 0 },
/* U+f1c8 */ { 0, 0, 0, 0, 0 },
/* U+f1c9 */ { 0, 0, 0, 0, 0 },
/* U+f1ca */ { 0, 0, 0, 0, 0 },
/* U+f1cb */ { 0, 0, 0, 0, 0 },
/* U+f1cc */ { 0, 0, 0, 0, 0 },
/* U+f1cd */ { 0, 0, 0, 0, 0 },
/* U+f1ce */ { 0, 0, 0, 0, 0 },
/* U+f1cf */ { 0, 0, 0, 0, 0 },
/* U+f1d0 */ { 0, 0, 0, 0, 0 },
/* U+f1d1 */ { 0, 0, 0, 0, 0 },
/* U+f1d2 */ { 0, 0, 0, 0, 0 },
/* U+f1d3 */ { 0, 0, 0, 0, 0 },
/* U+f1d4 */ { 0, 0, 0, 0, 0 },
/* U+f1d5 */ { 0, 0, 0, 0, 0 },
/* U+f1d6 */ { 0, 0, 0, 0, 0 },
/* U+f1d7 */ { 0, 0, 0, 0, 0 },
/* U+f1d8 */ { 0, 0, 0, 0, 0 },
/* U+f1d9 */ { 0, 0, 0, 0, 0 },
/* U+f1da */ { 0, 0, 0, 0, 0 },
/* U+f1db */ { 0, 0, 0, 0, 0 },
/* U+f1dc */ { 0, 0, 0, 0, 0 },
/* U+f1dd */ { 0, 0, 0, 0, 0 },
/* U+f1de */ { 0, 0, 0, 0, 0 },
/* U+f1df */ { 0, 0, 0, 0, 0 },
/* U+f1e0 */ { 0, 0, 0, 0, 0 },
/* U+f1e1 */ { 0, 0, 0, 0, 0 },
/* U+f1e2 */ { 0, 0, 0, 0, 0 },
/* U+f1e3 */ { 0, 0, 0, 0, 0 },
/* U+f1e4 */ { 0, 0, 0, 0, 0 },
/* U+f1e5 */ { 0, 0, 0, 0, 0 },
/* U+f1e6 */ { 0, 0, 0, 0, 0 },
/* U+f1e7 */ { 0, 0, 0, 0, 0 },
/* U+f1e8 */ { 0, 0, 0, 0, 0 },
/* U+f1e9 */ { 0, 0, 0, 0, 0 },
/* U+f1ea */ { 0, 0, 0, 0, 0 },
/* U+f1eb */ { 0, 0, 0, 0, 0 },
/* U+f1ec */ { 0, 0, 0, 0, 0 },
/* U+f1ed */ { 0, 0, 0, 0, 0 },
/* U+f1ee */ { 0, 0, 0, 0, 0 },
/* U+f1ef */ { 0, 0, 0, 0, 0 },
/* U+f1f0 */ { 0, 0, 0, 0, 0 },
/* U+f1f1 */ { 0, 0, 0, 0, 0 },
/* U+f1f2 */ { 0, 0, 0, 0, 0 },
/* U+f1f3 */ { 0, 0, 0, 0, 0 },
/* U+f1f4 */ { 0, 0, 0, 0, 0 },
/* U+f1f5 */ { 0, 0, 0, 0, 0 },
/* U+f1f6 */ { 0, 0, 0, 0, 0 },
/* U+f1f7 */ { 0, 0, 0, 0, 0 },
/* U+f1f8 */ { 0, 0, 0, 0, 0 },
/* U+f1f9 */ { 0, 0, 0, 0, 0 },
/* U+f1fa */ { 0, 0, 0, 0, 0 },
/* U+f1fb */ { 0, 0, 0, 0, 0 },
/* U+f1fc */ { 0, 0, 0, 0, 0 },
/* U+f1fd */ { 0, 0, 0, 0, 0 },
/* U+f1fe */ { 0, 0, 0, 0, 0 },
/* U+f1ff */ { 0, 0, 0, 0, 0 },
/* U+f200 */ { 0, 0, 0, 0, 0 },
/* U+f201 */ { 0, 0, 0, 0, 0 },
/* U+f202 */ { 0, 0, 0, 0, 0 },
/* U+f203 */ { 0, 0, 0, 0, 0 },
/* U+f204 */ { 0, 0, 0, 0, 0 },
/* U+f205 */ { 0, 0, 0, 0, 0 },
/* U+f206 */ { 0, 0, 0, 0, 0 },
/* U+f207 */ { 0, 0, 0, 0, 0 },
/* U+f208 */ { 0, 0, 0, 0, 0 },
/* U+f209 */ { 0, 0, 0, 0, 0 },
/* U+f20a */ { 0, 0, 0, 0, 0 },
/* U+f20b */ { 0, 0, 0, 0, 0 },
/* U+f20c */ { 0, 0, 0, 0, 0 },
/* U+f20d */ { 0, 0, 0, 0, 0 },
/* U+f20e */ { 0, 0, 0, 0, 0 },
/* U+f20f */ { 0, 0, 0, 0, 0 },
/* U+f210 */ { 0, 0, 0, 0, 0 },
/* U+f211 */ { 0, 0, 0, 0, 0 },
/* U+f212 */ { 0, 0, 0, 0, 0 },
/* U+f213 */ { 0, 0, 0, 0, 0 },
/* U+f214 */ { 0, 0, 0, 0, 0 },
/* U+f215 */ { 0, 0, 0, 0, 0 },
/* U+f216 */ { 0, 0, 0, 0, 0 },
/* U+f217 */ { 0, 0, 0, 0, 0 },
/* U+f218 */ { 0, 0, 0, 0, 0 },
/* U+f219 */ { 0, 0, 0, 0, 0 },
/* U+f21a */ { 0, 0, 0, 0, 0 },
/* U+f21b */ { 0, 0, 0, 0, 0 },
/* U+f21c */ { 0, 0, 0, 0, 0 },
/* U+f21d */ { 0, 0, 0, 0, 0 },
/* U+f21e */ { 0, 0, 0, 0, 0 },
/* U+f21f */ { 0, 0, 0, 0, 0 },
/* U+f220 */ { 0, 0, 0, 0, 0 },
/* U+f221 */ { 0, 0, 0, 0, 0 },
/* U+f222 */ { 0, 0, 0, 0, 0 },
/* U+f223 */ { 0, 0, 0, 0, 0 },
/* U+f224 */ { 0, 0, 0, 0, 0 },
/* U+f225 */ { 0, 0, 0, 0, 0 },
/* U+f226 */ { 0, 0, 0, 0, 0 },
/* U+f227 */ { 0, 0, 0, 0, 0 },
/* U+f228 */ { 0, 0, 0, 0, 0 },
/* U+f229 */ { 0, 0, 0, 0, 0 },
/* U+f22a */ { 0, 0, 0, 0, 0 },
/* U+f22b */ { 0, 0, 0, 0, 0 },
/* U+f22c */ { 0, 0, 0, 0, 0 },
/* U+f22d */ { 0, 0, 0, 0, 0 },
/* U+f22e */ { 0, 0, 0, 0, 0 },
/* U+f22f */ { 0, 0, 0, 0, 0 },
/* U+f230 */ { 0, 0, 0, 0, 0 },
/* U+f231 */ { 0, 0, 0, 0, 0 },
/* U+f232 */ { 0, 0, 0, 0, 0 },
/* U+f233 */ { 0, 0, 0, 0, 0 },
/* U+f234 */ { 0, 0, 0, 0, 0 },
/* U+f235 */ { 0, 0, 0, 0, 0 },
/* U+f236 */ { 0, 0, 0, 0, 0 },
/* U+f237 */ { 0, 0, 0, 0, 0 },
/* U+f238 */ { 0, 0, 0, 0, 0 },
/* U+f239 */ { 0, 0, 0, 0, 0 },
/* U+f23a */ { 0, 0, 0, 0, 0 },
/* U+f23b */ { 0, 0, 0, 0, 0 },
/* U+f23c */ { 0, 0, 0, 0, 0 },
/* U+f23d */ { 0, 0, 0, 0, 0 },
/* U+f23e */ { 0, 0, 0, 0, 0 },
/* U+f23f */ { 0, 0, 0, 0, 0 },
/* U+f240 */ { 0, 0, 0, 0, 0 },
/* U+f241 */ { 0, 0, 0, 0, 0 },
/* U+f242 */ { 0, 0, 0, 0, 0 },
/* U+f243 */ { 0, 0, 0, 0, 0 },
/* U+f244 */ { 0, 0, 0, 0, 0 },
/* U+f245 */ { 0, 0, 0, 0, 0 },
/* U+f246 */ { 0, 0, 0, 0, 0 },
/* U+f247 */ { 0, 0, 0, 0, 0 },
/* U+f248 */ { 0, 0, 0, 0, 0 },
/* U+f249 */ { 0, 0, 0, 0, 0 },
/* U+f24a */ { 0, 0, 0, 0, 0 },
/* U+f24b */ { 0, 0, 0, 0, 0 },
/* U+f24c */ { 0, 0, 0, 0, 0 },
/* U+f24d */ { 0, 0, 0, 0, 0 },
/* U+f24e */ { 0, 0, 0, 0, 0 },
/* U+f24f */ { 0, 0, 0, 0, 0 },
/* U+f250 */ { 0, 0, 0, 0, 0 },
/* U+f251 */ { 0, 0, 0, 0, 0 },
/* U+f252 */ { 0, 0, 0, 0, 0 },
/* U+f253 */ { 0, 0, 0, 0, 0 },
/* U+f254 */ { 0, 0, 0, 0, 0 },
/* U+f255 */ { 0, 0, 0, 0, 0 },
/* U+f256 */ { 0, 0, 0, 0, 0 },
/* U+f257 */ { 0, 0, 0, 0, 0 },
/* U+f258 */ { 0, 0, 0, 0, 0 },
/* U+f259 */ { 0, 0, 0, 0, 0 },
/* U+f25a */ { 0, 0, 0, 0, 0 },
/* U+f25b */ { 0, 0, 0, 0, 0 },
/* U+f25c */ { 0, 0, 0, 0, 0 },
/* U+f25d */ { 0, 0, 0, 0, 0 },
/* U+f25e */ { 0, 0, 0, 0, 0 },
/* U+f25f */ { 0, 0, 0, 0, 0 },
/* U+f260 */ { 0, 0, 0, 0, 0 },
/* U+f261 */ { 0, 0, 0, 0, 0 },
/* U+f262 */ { 0, 0, 0, 0, 0 },
/* U+f263 */ { 0, 0, 0, 0, 0 },
/* U+f264 */ { 0, 0, 0, 0, 0 },
/* U+f265 */ { 0, 0, 0, 0, 0 },
/* U+f266 */ { 0, 0, 0, 0, 0 },
/* U+f267 */ { 0, 0, 0, 0, 0 },
/* U+f268 */ { 0, 0, 0, 0, 0 },
/* U+f269 */ { 0, 0, 0, 0, 0 },
/* U+f26a */ { 0, 0, 0, 0, 0 },
/* U+f26b */ { 0, 0, 0, 0, 0 },
/* U+f26c */ { 0, 0, 0, 0, 0 },
/* U+f26d */ { 0, 0, 0, 0, 0 },
/* U+f26e */ { 0, 0, 0, 0, 0 },
/* U+f26f */ { 0, 0, 0, 0, 0 },
/* U+f270 */ { 0, 0, 0, 0, 0 },
/* U+f271 */ { 0, 0, 0, 0, 0 },
/* U+f272 */ { 0, 0, 0, 0, 0 },
/* U+f273 */ { 0, 0, 0, 0, 0 },
/* U+f274 */ { 0, 0, 0, 0, 0 },
/* U+f275 */ { 0, 0, 0, 0, 0 },
/* U+f276 */ { 0, 0, 0, 0, 0 },
/* U+f277 */ { 0, 0, 0, 0, 0 },
/* U+f278 */ { 0, 0, 0, 0, 0 },
/* U+f279 */ { 0, 0, 0, 0, 0 },
/* U+f27a */ { 0, 0, 0, 0, 0 },
/* U+f27b */ { 0, 0, 0, 0, 0 },
/* U+f27c */ { 0, 0, 0, 0, 0 },
/* U+f27d */ { 0, 0, 0, 0, 0 },
/* U+f27e */ { 0, 0, 0, 0, 0 },
/* U+f27f */ { 0, 0, 0, 0, 0 },
/* U+f280 */ { 0, 0, 0, 0, 0 },
/* U+f281 */ { 0, 0, 0, 0, 0 },
/* U+f282 */ { 0, 0, 0, 0, 0 },
/* U+f283 */ { 0, 0, 0, 0, 0 },
/* U+f284 */ { 0, 0, 0, 0, 0 },
/* U+f285 */ { 0, 0, 0, 0, 0 },
/* U+f286 */ { 0, 0, 0, 0, 0 },
/* U+f287 */ { 0, 0, 0, 0, 0 },
/* U+f288 */ { 0, 0, 0, 0, 0 },
/* U+f289 */ { 0, 0, 0, 0, 0 },
/* U+f28a */ { 0, 0, 0, 0, 0 },
/* U+f28b */ { 0, 0, 0, 0, 0 },
/* U+f28c */ { 0, 0, 0, 0, 0 },
/* U+f28d */ { 0, 0, 0, 0, 0 },
/* U+f28e */ { 0, 0, 0, 0, 0 },
/* U+f28f */ { 0, 0, 0, 0, 0 },
/* U+f290 */ { 0, 0, 0, 0, 0 },
/* U+f291 */ { 0, 0, 0, 0, 0 },
/* U+f292 */ { 0, 0, 0, 0, 0 },
/* U+f293 */ { 0, 0, 0, 0, 0 },
/* U+f294 */ { 0, 0, 0, 0, 0 },
/* U+f295 */ { 0, 0, 0, 0, 0 },
/* U+f296 */ { 0, 0, 0, 0, 0 },
/* U+f297 */ { 0, 0, 0, 0, 0 },
/* U+f298 */ { 0, 0, 0, 0, 0 },
/* U+f299 */ { 0, 0, 0, 0, 0 },
/* U+f29a */ { 0, 0, 0, 0, 0 },
/* U+f29b */ { 0, 0, 0, 0, 0 },
/* U+f29c */ { 0, 0, 0, 0, 0 },
/* U+f29d */ { 0, 0, 0, 0, 0 },
/* U+f29e */ { 0, 0, 0, 0, 0 },
/* U+f29f */ { 0, 0, 0, 0, 0 },
/* U+f2a0 */ { 0, 0, 0, 0, 0 },
/* U+f2a1 */ { 0, 0, 0, 0, 0 },
/* U+f2a2 */ { 0, 0, 0, 0, 0 },
/* U+f2a3 */ { 0, 0, 0, 0, 0 },
/* U+f2a4 */ { 0, 0, 0, 0, 0 },
/* U+f2a5 */ { 0, 0, 0, 0, 0 },
/* U+f2a6 */ { 0, 0, 0, 0, 0 },
/* U+f2a7 */ { 0, 0, 0, 0, 0 },
/* U+f2a8 */ { 0, 0, 0, 0, 0 },
/* U+f2a9 */ { 0, 0, 0, 0, 0 },
/* U+f2aa */ { 0, 0, 0, 0, 0 },
/* U+f2ab */ { 0, 0, 0, 0, 0 },
/* U+f2ac */ { 0, 0, 0, 0, 0 },
/* U+f2ad */ { 0, 0, 0, 0, 0 },
/* U+f2ae */ { 0, 0, 0, 0, 0 },
/* U+f2af */ { 0, 0, 0, 0, 0 },
/* U+f2b0 */ { 0, 0, 0, 0, 0 },
/* U+f2b1 */ { 0, 0, 0, 0, 0 },
/* U+f2b2 */ { 0, 0, 0, 0, 0 },
/* U+f2b3 */ { 0, 0, 0, 0, 0 },
/* U+f2b4 */ { 0, 0, 0, 0, 0 },
/* U+f2b5 */ { 0, 0, 0, 0, 0 },
/* U+f2b6 */ { 0, 0, 0, 0, 0 },
/* U+f2b7 */ { 0, 0, 0, 0, 0 },
/* U+f2b8 */ { 0, 0, 0, 0, 0 },
/* U+f2b9 */ { 0, 0, 0, 0, 0 },
/* U+f2ba */ { 0, 0, 0, 0, 0 },
/* U+f2bb */ { 0, 0, 0, 0, 0 },
/* U+f2bc */ { 0, 0, 0, 0, 0 },
/* U+f2bd */ { 0, 0, 0, 0, 0 },
/* U+f2be */ { 0, 0, 0, 0, 0 },
/* U+f2bf */ { 0, 0, 0, 0, 0 },
/* U+f2c0 */ { 0, 0, 0, 0, 0 },
/* U+f2c1 */ { 0, 0, 0, 0, 0 },
/* U+f2c2 */ { 0, 0, 0, 0, 0 },
/* U+f2c3 */ { 0, 0, 0, 0, 0 },
/* U+f2c4 */ { 0, 0, 0, 0, 0 },
/* U+f2c5 */ { 0, 0, 0, 0, 0 },
/* U+f2c6 */ { 0, 0, 0, 0, 0 },
/* U+f2c7 */ { 0, 0, 0, 0, 0 },
/* U+f2c8 */ { 0, 0, 0, 0, 0 },
/* U+f2c9 */ { 0, 0, 0, 0, 0 },
/* U+f2ca */ { 0, 0, 0, 0, 0 },
/* U+f2cb */ { 0, 0, 0, 0, 0 },
/* U+f2cc */ { 0, 0, 0, 0, 0 },
/* U+f2cd */ { 0, 0, 0, 0, 0 },
/* U+f2ce */ { 0, 0, 0, 0, 0 },
/* U+f2cf */ { 0, 0, 0, 0, 0 },
/* U+f2d0 */ { 0, 0, 0, 0, 0 },
/* U+f2d1 */ { 0, 0, 0, 0, 0 },
/* U+f2d2 */ { 0, 0, 0, 0, 0 },
/* U+f2d3 */ { 0, 0, 0, 0, 0 },
/* U+f2d4 */ { 0, 0, 0, 0, 0 },
/* U+f2d5 */ { 0, 0, 0, 0, 0 },
/* U+f2d6 */ { 0, 0, 0, 0, 0 },
/* U+f2d7 */ { 0, 0, 0, 0, 0 },
/* U+f2d8 */ { 0, 0, 0, 0, 0 },
/* U+f2d9 */ { 0, 0, 0, 0, 0 },
/* U+f2da */ { 0, 0, 0, 0, 0 },
/* U+f2db */ { 0, 0, 0, 0, 0 },
/* U+f2dc */ { 0, 0, 0, 0, 0 },
/* U+f2dd */ { 0, 0, 0, 0, 0 },
/* U+f2de */ { 0, 0, 0, 0, 0 },
/* U+f2df */ { 0, 0, 0, 0, 0 },
/* U+f2e0 */ { 0, 0, 0, 0, 0 },
/* U+f2e1 */ { 0, 0, 0, 0, 0 },
/* U+f2e2 */ { 0, 0, 0, 0, 0 },
/* U+f2e3 */ { 0, 0, 0, 0, 0 },
/* U+f2e4 */ { 0, 0, 0, 0, 0 },
/* U+f2e5 */ { 0, 0, 0, 0, 0 },
/* U+f2e6 */ { 0, 0, 0, 0, 0 },
/* U+f2e7 */ { 0, 0, 0, 0, 0 },
/* U+f2e8 */ { 0, 0, 0, 0, 0 },
/* U+f2e9 */ { 0, 0, 0, 0, 0 },
/* U+f2ea */ { 0, 0, 0, 0, 0 },
/* U+f2eb */ { 0, 0, 0, 0, 0 },
/* U+f2ec */ { 0, 0, 0, 0, 0 },
/* U+f2ed */ { 0, 0, 0, 0, 0 },
/* U+f2ee */ { 0, 0, 0, 0, 0 },
/* U+f2ef */ { 0, 0, 0, 0, 0 },
/* U+f2f0 */ { 0, 0, 0, 0, 0 },
/* U+f2f1 */ { 0, 0, 0, 0, 0 },
/* U+f2f2 */ { 0, 0, 0, 0, 0 },
/* U+f2f3 */ { 0, 0, 0, 0, 0 },
/* U+f2f4 */ { 0, 0, 0, 0, 0 },
/* U+f2f5 */ { 0, 0, 0, 0, 0 },
/* U+f2f6 */ { 0, 0, 0, 0, 0 },
/* U+f2f7 */ { 0, 0, 0, 0, 0 },
/* U+f2f8 */ { 0, 0, 0, 0, 0 },
/* U+f2f9 */ { 0, 0, 0, 0, 0 },
/* U+f2fa */ { 0, 0, 0, 0, 0 },
/* U+f2fb */ { 0, 0, 0, 0, 0 },
/* U+f2fc */ { 0, 0, 0, 0, 0 },
/* U+f2fd */ { 0, 0, 0, 0, 0 },
/* U+f2fe */ { 0, 0, 0, 0, 0 },
/* U+f2ff */ { 0, 0, 0, 0, 0 },
/* U+f300 */ { 0, 0, 0, 0, 0 },
/* U+f301 */ { 0, 0, 0, 0, 0 },
/* U+f302 */ { 0, 0, 0, 0, 0 },
/* U+f303 */ { 0, 0, 0, 0, 0 },
/* U+f304 */ { 0, 0, 0, 0, 0 },
/* U+f305 */ { 0, 0, 0, 0, 0 },
/* U+f306 */ { 0, 0, 0, 0, 0 },
/* U+f307 */ { 0, 0, 0, 0, 0 },
/* U+f308 */ { 0, 0, 0, 0, 0 },
/* U+f309 */ { 0, 0, 0, 0, 0 },
/* U+f30a */ { 0, 0, 0, 0, 0 },
/* U+f30b */ { 0, 0, 0, 0, 0 },
/* U+f30c */ { 0, 0, 0, 0, 0 },
/* U+f30d */ { 0, 0, 0, 0, 0 },
/* U+f30e */ { 0, 0, 0, 0, 0 },
/* U+f30f */ { 0, 0, 0, 0, 0 },
/* U+f310 */ { 0, 0, 0, 0, 0 },
/* U+f311 */ { 0, 0, 0, 0, 0 },
/* U+f312 */ { 0, 0, 0, 0, 0 },
/* U+f313 */ { 0, 0, 0, 0, 0 },
/* U+f314 */ { 0, 0, 0, 0, 0 },
/* U+f315 */ { 0, 0, 0, 0, 0 },
/* U+f316 */ { 0, 0, 0, 0, 0 },
/* U+f317 */ { 0, 0, 0, 0, 0 },
/* U+f318 */ { 0, 0, 0, 0, 0 },
/* U+f319 */ { 0, 0, 0, 0, 0 },
/* U+f31a */ { 0, 0, 0, 0, 0 },
/* U+f31b */ { 0, 0, 0, 0, 0 },
/* U+f31c */ { 0, 0, 0, 0, 0 },
/* U+f31d */ { 0, 0, 0, 0, 0 },
/* U+f31e */ { 0, 0, 0, 0, 0 },
/* U+f31f */ { 0, 0, 0, 0, 0 },
/* U+f320 */ { 0, 0, 0, 0, 0 },
/* U+f321 */ { 0, 0, 0, 0, 0 },
/* U+f322 */ { 0, 0, 0, 0, 0 },
/* U+f323 */ { 0, 0, 0, 0, 0 },
/* U+f324 */ { 0, 0, 0, 0, 0 },
/* U+f325 */ { 0, 0, 0, 0, 0 },
/* U+f326 */ { 0, 0, 0, 0, 0 },
/* U+f327 */ { 0, 0, 0, 0, 0 },
/* U+f328 */ { 0, 0, 0, 0, 0 },
/* U+f329 */ { 0, 0, 0, 0, 0 },
/* U+f32a */ { 0, 0, 0, 0, 0 },
/* U+f32b */ { 0, 0, 0, 0, 0 },
/* U+f32c */ { 0, 0, 0, 0, 0 },
/* U+f32d */ { 0, 0, 0, 0, 0 },
/* U+f32e */ { 0, 0, 0, 0, 0 },
/* U+f32f */ { 0, 0, 0, 0, 0 },
/* U+f330 */ { 0, 0, 0, 0, 0 },
/* U+f331 */ { 0, 0, 0, 0, 0 },
/* U+f332 */ { 0, 0, 0, 0, 0 },
/* U+f333 */ { 0, 0, 0, 0, 0 },
/* U+f334 */ { 0, 0, 0, 0, 0 },
/* U+f335 */ { 0, 0, 0, 0, 0 },
/* U+f336 */ { 0, 0, 0, 0, 0 },
/* U+f337 */ { 0, 0, 0, 0, 0 },
/* U+f338 */ { 0, 0, 0, 0, 0 },
/* U+f339 */ { 0, 0, 0, 0, 0 },
/* U+f33a */ { 0, 0, 0, 0, 0 },
/* U+f33b */ { 0, 0, 0, 0, 0 },
/* U+f33c */ { 0, 0, 0, 0, 0 },
/* U+f33d */ { 0, 0, 0, 0, 0 },
/* U+f33e */ { 0, 0, 0, 0, 0 },
/* U+f33f */ { 0, 0, 0, 0, 0 },
/* U+f340 */ { 0, 0, 0, 0, 0 },
/* U+f341 */ { 0, 0, 0, 0, 0 },
/* U+f342 */ { 0, 0, 0, 0, 0 },
/* U+f343 */ { 0, 0, 0, 0, 0 },
/* U+f344 */ { 0, 0, 0, 0, 0 },
/* U+f345 */ { 0, 0, 0, 0, 0 },
/* U+f346 */ { 0, 0, 0, 0, 0 },
/* U+f347 */ { 0, 0, 0, 0, 0 },
/* U+f348 */ { 0, 0, 0, 0, 0 },
/* U+f349 */ { 0, 0, 0, 0, 0 },
/* U+f34a */ { 0, 0, 0, 0, 0 },
/* U+f34b */ { 0, 0, 0, 0, 0 },
/* U+f34c */ { 0, 0, 0, 0, 0 },
/* U+f34d */ { 0, 0, 0, 0, 0 },
/* U+f34e */ { 0, 0, 0, 0, 0 },
/* U+f34f */ { 0, 0, 0, 0, 0 },
/* U+f350 */ { 0, 0, 0, 0, 0 },
/* U+f351 */ { 0, 0, 0, 0, 0 },
/* U+f352 */ { 0, 0, 0, 0, 0 },
/* U+f353 */ { 0, 0, 0, 0, 0 },
/* U+f354 */ { 0, 0, 0, 0, 0 },
/* U+f355 */ { 0, 0, 0, 0, 0 },
/* U+f356 */ { 0, 0, 0, 0, 0 },
/* U+f357 */ { 0, 0, 0, 0, 0 },
/* U+f358 */ { 0, 0, 0, 0, 0 },
/* U+f359 */ { 0, 0, 0, 0, 0 },
/* U+f35a */ { 0, 0, 0, 0, 0 },
/* U+f35b */ { 0, 0, 0, 0, 0 },
/* U+f35c */ { 0, 0, 0, 0, 0 },
/* U+f35d */ { 0, 0, 0, 0, 0 },
/* U+f35e */ { 0, 0, 0, 0, 0 },
/* U+f35f */ { 0, 0, 0, 0, 0 },
/* U+f360 */ { 0, 0, 0, 0, 0 },
/* U+f361 */ { 0, 0, 0, 0, 0 },
/* U+f362 */ { 0, 0, 0, 0, 0 },
/* U+f363 */ { 0, 0, 0, 0, 0 },
/* U+f364 */ { 0, 0, 0, 0, 0 },
/* U+f365 */ { 0, 0, 0, 0, 0 },
/* U+f366 */ { 0, 0, 0, 0, 0 },
/* U+f367 */ { 0, 0, 0, 0, 0 },
/* U+f368 */ { 0, 0, 0, 0, 0 },
/* U+f369 */ { 0, 0, 0, 0, 0 },
/* U+f36a */ { 0, 0, 0, 0, 0 },
/* U+f36b */ { 0, 0, 0, 0, 0 },
/* U+f36c */ { 0, 0, 0, 0, 0 },
/* U+f36d */ { 0, 0, 0, 0, 0 },
/* U+f36e */ { 0, 0, 0, 0, 0 },
/* U+f36f */ { 0, 0, 0, 0, 0 },
/* U+f370 */ { 0, 0, 0, 0, 0 },
/* U+f371 */ { 0, 0, 0, 0, 0 },
/* U+f372 */ { 0, 0, 0, 0, 0 },
/* U+f373 */ { 0, 0, 0, 0, 0 },
/* U+f374 */ { 0, 0, 0, 0, 0 },
/* U+f375 */ { 0, 0, 0, 0, 0 },
/* U+f376 */ { 0, 0, 0, 0, 0 },
/* U+f377 */ { 0, 0, 0, 0, 0 },
/* U+f378 */ { 0, 0, 0, 0, 0 },
/* U+f379 */ { 0, 0, 0, 0, 0 },
/* U+f37a */ { 0, 0, 0, 0, 0 },
/* U+f37b */ { 0, 0, 0, 0, 0 },
/* U+f37c */ { 0, 0, 0, 0, 0 },
/* U+f37d */ { 0, 0, 0, 0, 0 },
/* U+f37e */ { 0, 0, 0, 0, 0 },
/* U+f37f */ { 0, 0, 0, 0, 0 },
/* U+f380 */ { 0, 0, 0, 0, 0 },
/* U+f381 */ { 0, 0, 0, 0, 0 },
/* U+f382 */ { 0, 0, 0, 0, 0 },
/* U+f383 */ { 0, 0, 0, 0, 0 },
/* U+f384 */ { 0, 0, 0, 0, 0 },
/* U+f385 */ { 0, 0, 0, 0, 0 },
/* U+f386 */ { 0, 0, 0, 0, 0 },
/* U+f387 */ { 0, 0, 0, 0, 0 },
/* U+f388 */ { 0, 0, 0, 0, 0 },
/* U+f389 */ { 0, 0, 0, 0, 0 },
/* U+f38a */ { 0, 0, 0, 0, 0 },
/* U+f38b */ { 0, 0, 0, 0, 0 },
/* U+f38c */ { 0, 0, 0, 0, 0 },
/* U+f38d */ { 0, 0, 0, 0, 0 },
/* U+f38e */ { 0, 0, 0, 0, 0 },
/* U+f38f */ { 0, 0, 0, 0, 0 },
/* U+f390 */ { 0, 0, 0, 0, 0 },
/* U+f391 */ { 0, 0, 0, 0, 0 },
/* U+f392 */ { 0, 0, 0, 0, 0 },
/* U+f393 */ { 0, 0, 0, 0, 0 },
/* U+f394 */ { 0, 0, 0, 0, 0 },
/* U+f395 */ { 0, 0, 0, 0, 0 },
/* U+f396 */ { 0, 0, 0, 0, 0 },
/* U+f397 */ { 0, 0, 0, 0, 0 },
/* U+f398 */ { 0, 0, 0, 0, 0 },
/* U+f399 */ { 0, 0, 0, 0, 0 },
/* U+f39a */ { 0, 0, 0, 0, 0 },
/* U+f39b */ { 0, 0, 0, 0, 0 },
/* U+f39c */ { 0, 0, 0, 0, 0 },
/* U+f39d */ { 0, 0, 0, 0, 0 },
/* U+f39e */ { 0, 0, 0, 0, 0 },
/* U+f39f */ { 0, 0, 0, 0, 0 },
/* U+f3a0 */ { 0, 0, 0, 0, 0 },
/* U+f3a1 */ { 0, 0, 0, 0, 0 },
/* U+f3a2 */ { 0, 0, 0, 0, 0 },
/* U+f3a3 */ { 0, 0, 0, 0, 0 },
/* U+f3a4 */ { 0, 0, 0, 0, 0 },
/* U+f3a5 */ { 0, 0, 0, 0, 0 },
/* U+f3a6 */ { 0, 0, 0, 0, 0 },
/* U+f3a7 */ { 0, 0, 0, 0, 0 },
/* U+f3a8 */ { 0, 0, 0, 0, 0 },
/* U+f3a9 */ { 0, 0, 0, 0, 0 },
/* U+f3aa */ { 0, 0, 0, 0, 0 },
/* U+f3ab */ { 0, 0, 0, 0, 0 },
/* U+f3ac */ { 0, 0, 0, 0, 0 },
/* U+f3ad */ { 0, 0, 0, 0, 0 },
/* U+f3ae */ { 0, 0, 0, 0, 0 },
/* U+f3af */ { 0, 0, 0, 0, 0 },
/* U+f3b0 */ { 0, 0, 0, 0, 0 },
/* U+f3b1 */ { 0, 0, 0, 0, 0 },
/* U+f3b2 */ { 0, 0, 0, 0, 0 },
/* U+f3b3 */ { 0, 0, 0, 0, 0 },
/* U+f3b4 */ { 0, 0, 0, 0, 0 },
/* U+f3b5 */ { 0, 0, 0, 0, 0 },
/* U+f3b6 */ { 0, 0, 0, 0, 0 },
/* U+f3b7 */ { 0, 0, 0, 0, 0 },
/* U+f3b8 */ { 0, 0, 0, 0, 0 },
/* U+f3b9 */ { 0, 0, 0, 0, 0 },
/* U+f3ba */ { 0, 0, 0, 0, 0 },
/* U+f3bb */ { 0, 0, 0, 0, 0 },
/* U+f3bc */ { 0, 0, 0, 0, 0 },
/* U+f3bd */ { 0, 0, 0, 0, 0 },
/* U+f3be */ { 0, 0, 0, 0, 0 },
/* U+f3bf */ { 0, 0, 0, 0, 0 },
/* U+f3c0 */ { 0, 0, 0, 0, 0 },
/* U+f3c1 */ { 0, 0, 0, 0, 0 },
/* U+f3c2 */ { 0, 0, 0, 0, 0 },
/* U+f3c3 */ { 0, 0, 0, 0, 0 },
/* U+f3c4 */ { 0, 0, 0, 0, 0 },
/* U+f3c5 */ { 0, 0, 0, 0, 0 },
/* U+f3c6 */ { 0, 0, 0, 0, 0 },
/* U+f3c7 */ { 0, 0, 0, 0, 0 },
/* U+f3c8 */ { 0, 0, 0, 0, 0 },
/* U+f3c9 */ { 0, 0, 0, 0, 0 },
/* U+f3ca */ { 0, 0, 0, 0, 0 },
/* U+f3cb */ { 0, 0, 0, 0, 0 },
/* U+f3cc */ { 0, 0, 0, 0, 0 },
/* U+f3cd */ { 0, 0, 0, 0, 0 },
/* U+f3ce */ { 0, 0, 0, 0, 0 },
/* U+f3cf */ { 0, 0, 0, 0, 0 },
/* U+f3d0 */ { 0, 0, 0, 0, 0 },
/* U+f3d1 */ { 0, 0, 0, 0, 0 },
/* U+f3d2 */ { 0, 0, 0, 0, 0 },
/* U+f3d3 */ { 0, 0, 0, 0, 0 },
/* U+f3d4 */ { 0, 0, 0, 0, 0 },
/* U+f3d5 */ { 0, 0, 0, 0, 0 },
/* U+f3d6 */ { 0, 0, 0, 0, 0 },
/* U+f3d7 */ { 0, 0, 0, 0, 0 },
/* U+f3d8 */ { 0, 0, 0, 0, 0 },
/* U+f3d9 */ { 0, 0, 0, 0, 0 },
/* U+f3da */ { 0, 0, 0, 0, 0 },
/* U+f3db */ { 0, 0, 0, 0, 0 },
/* U+f3dc */ { 0, 0, 0, 0, 0 },
/* U+f3dd */ { 0, 0, 0, 0, 0 },
/* U+f3de */ { 0, 0, 0, 0, 0 },
/* U+f3df */ { 0, 0, 0, 0, 0 },
/* U+f3e0 */ { 0, 0, 0, 0, 0 },
/* U+f3e1 */ { 0, 0, 0, 0, 0 },
/* U+f3e2 */ { 0, 0, 0, 0, 0 },
/* U+f3e3 */ { 0, 0, 0, 0, 0 },
/* U+f3e4 */ { 0, 0, 0, 0, 0 },
/* U+f3e5 */ { 0, 0, 0, 0, 0 },
/* U+f3e6 */ { 0, 0, 0, 0, 0 },
/* U+f3e7 */ { 0, 0, 0, 0, 0 },
/* U+f3e8 */ { 0, 0, 0, 0, 0 },
/* U+f3e9 */ { 0, 0, 0, 0, 0 },
/* U+f3ea */ { 0, 0, 0, 0, 0 },
/* U+f3eb */ { 0, 0, 0, 0, 0 },
/* U+f3ec */ { 0, 0, 0, 0, 0 },
/* U+f3ed */ { 0, 0, 0, 0, 0 },
/* U+f3ee */ { 0, 0, 0, 0, 0 },
/* U+f3ef */ { 0, 0, 0, 0, 0 },
/* U+f3f0 */ { 0, 0, 0, 0, 0 },
/* U+f3f1 */ { 0, 0, 0, 0, 0 },
/* U+f3f2 */ { 0, 0, 0, 0, 0 },
/* U+f3f3 */ { 0, 0, 0, 0, 0 },
/* U+f3f4 */ { 0, 0, 0, 0, 0 },
/* U+f3f5 */ { 0, 0, 0, 0, 0 },
/* U+f3f6 */ { 0, 0, 0, 0, 0 },
/* U+f3f7 */ { 0, 0, 0, 0, 0 },
/* U+f3f8 */ { 0, 0, 0, 0, 0 },
/* U+f3f9 */ { 0, 0, 0, 0, 0 },
/* U+f3fa */ { 0, 0, 0, 0, 0 },
/* U+f3fb */ { 0, 0, 0, 0, 0 },
/* U+f3fc */ { 0, 0, 0, 0, 0 },
/* U+f3fd */ { 0, 0, 0, 0, 0 },
/* U+f3fe */ { 0, 0, 0, 0, 0 },
/* U+f3ff */ { 0, 0, 0, 0, 0 },
/* U+f400 */ { 0, 0, 0, 0, 0 },
/* U+f401 */ { 0, 0, 0, 0, 0 },
/* U+f402 */ { 0, 0, 0, 0, 0 },
/* U+f403 */ { 0, 0, 0, 0, 0 },
/* U+f404 */ { 0, 0, 0, 0, 0 },
/* U+f405 */ { 0, 0, 0, 0, 0 },
/* U+f406 */ { 0, 0, 0, 0, 0 },
/* U+f407 */ { 0, 0, 0, 0, 0 },
/* U+f408 */ { 0, 0, 0, 0, 0 },
/* U+f409 */ { 0, 0, 0, 0, 0 },
/* U+f40a */ { 0, 0, 0, 0, 0 },
/* U+f40b */ { 0, 0, 0, 0, 0 },
/* U+f40c */ { 0, 0, 0, 0, 0 },
/* U+f40d */ { 0, 0, 0, 0, 0 },
/* U+f40e */ { 0, 0, 0, 0, 0 },
/* U+f40f */ { 0, 0, 0, 0, 0 },
/* U+f410 */ { 0, 0, 0, 0, 0 },
/* U+f411 */ { 0, 0, 0, 0, 0 },
/* U+f412 */ { 0, 0, 0, 0, 0 },
/* U+f413 */ { 0, 0, 0, 0, 0 },
/* U+f414 */ { 0, 0, 0, 0, 0 },
/* U+f415 */ { 0, 0, 0, 0, 0 },
/* U+f416 */ { 0, 0, 0, 0, 0 },
/* U+f417 */ { 0, 0, 0, 0, 0 },
/* U+f418 */ { 0, 0, 0, 0, 0 },
/* U+f419 */ { 0, 0, 0, 0, 0 },
/* U+f41a */ { 0, 0, 0, 0, 0 },
/* U+f41b */ { 0, 0, 0, 0, 0 },
/* U+f41c */ { 0, 0, 0, 0, 0 },
/* U+f41d */ { 0, 0, 0, 0, 0 },
/* U+f41e */ { 0, 0, 0, 0, 0 },
/* U+f41f */ { 0, 0, 0, 0, 0 },
/* U+f420 */ { 0, 0, 0, 0, 0 },
/* U+f421 */ { 0, 0, 0, 0, 0 },
/* U+f422 */ { 0, 0, 0, 0, 0 },
/* U+f423 */ { 0, 0, 0, 0, 0 },
/* U+f424 */ { 0, 0, 0, 0, 0 },
/* U+f425 */ { 0, 0, 0, 0, 0 },
/* U+f426 */ { 0, 0, 0, 0, 0 },
/* U+f427 */ { 0, 0, 0, 0, 0 },
/* U+f428 */ { 0, 0, 0, 0, 0 },
/* U+f429 */ { 0, 0, 0, 0, 0 },
/* U+f42a */ { 0, 0, 0, 0, 0 },
/* U+f42b */ { 0, 0, 0, 0, 0 },
/* U+f42c */ { 0, 0, 0, 0, 0 },
/* U+f42d */ { 0, 0, 0, 0, 0 },
/* U+f42e */ { 0, 0, 0, 0, 0 },
/* U+f42f */ { 0, 0, 0, 0, 0 },
/* U+f430 */ { 0, 0, 0, 0, 0 },
/* U+f431 */ { 0, 0, 0, 0, 0 },
/* U+f432 */ { 0, 0, 0, 0, 0 },
/* U+f433 */ { 0, 0, 0, 0, 0 },
/* U+f434 */ { 0, 0, 0, 0, 0 },
/* U+f435 */ { 0, 0, 0, 0, 0 },
/* U+f436 */ { 0, 0, 0, 0, 0 },
/* U+f437 */ { 0, 0, 0, 0, 0 },
/* U+f438 */ { 0, 0, 0, 0, 0 },
/* U+f439 */ { 0, 0, 0, 0, 0 },
/* U+f43a */ { 0, 0, 0, 0, 0 },
/* U+f43b */ { 0, 0, 0, 0, 0 },
/* U+f43c */ { 0, 0, 0, 0, 0 },
/* U+f43d */ { 0, 0, 0, 0, 0 },
/* U+f43e */ { 0, 0, 0, 0, 0 },
/* U+f43f */ { 0, 0, 0, 0, 0 },
/* U+f440 */ { 0, 0, 0, 0, 0 },
/* U+f441 */ { 0, 0, 0, 0, 0 },
/* U+f442 */ { 0, 0, 0, 0, 0 },
/* U+f443 */ { 0, 0, 0, 0, 0 },
/* U+f444 */ { 0, 0, 0, 0, 0 },
/* U+f445 */ { 0, 0, 0, 0, 0 },
/* U+f446 */ { 0, 0, 0, 0, 0 },
/* U+f447 */ { 0, 0, 0, 0, 0 },
/* U+f448 */ { 0, 0, 0, 0, 0 },
/* U+f449 */ { 0, 0, 0, 0, 0 },
/* U+f44a */ { 0, 0, 0, 0, 0 },
/* U+f44b */ { 0, 0, 0, 0, 0 },
/* U+f44c */ { 0, 0, 0, 0, 0 },
/* U+f44d */ { 0, 0, 0, 0, 0 },
/* U+f44e */ { 0, 0, 0, 0, 0 },
/* U+f44f */ { 0, 0, 0, 0, 0 },
/* U+f450 */ { 0, 0, 0, 0, 0 },
/* U+f451 */ { 0, 0, 0, 0, 0 },
/* U+f452 */ { 0, 0, 0, 0, 0 },
/* U+f453 */ { 0, 0, 0, 0, 0 },
/* U+f454 */ { 0, 0, 0, 0, 0 },
/* U+f455 */ { 0, 0, 0, 0, 0 },
/* U+f456 */ { 0, 0, 0, 0, 0 },
/* U+f457 */ { 0, 0, 0, 0, 0 },
/* U+f458 */ { 0, 0, 0, 0, 0 },
/* U+f459 */ { 0, 0, 0, 0, 0 },
/* U+f45a */ { 0, 0, 0, 0, 0 },
/* U+f45b */ { 0, 0, 0, 0, 0 },
/* U+f45c */ { 0, 0, 0, 0, 0 },
/* U+f45d */ { 0, 0, 0, 0, 0 },
/* U+f45e */ { 0, 0, 0, 0, 0 },
/* U+f45f */ { 0, 0, 0, 0, 0 },
/* U+f460 */ { 0, 0, 0, 0, 0 },
/* U+f461 */ { 0, 0, 0, 0, 0 },
/* U+f462 */ { 0, 0, 0, 0, 0 },
/* U+f463 */ { 0, 0, 0, 0, 0 },
/* U+f464 */ { 0, 0, 0, 0, 0 },
/* U+f465 */ { 0, 0, 0, 0, 0 },
/* U+f466 */ { 0, 0, 0, 0, 0 },
/* U+f467 */ { 0, 0, 0, 0, 0 },
/* U+f468 */ { 0, 0, 0, 0, 0 },
/* U+f469 */ { 0, 0, 0, 0, 0 },
/* U+f46a */ { 0, 0, 0, 0, 0 },
/* U+f46b */ { 0, 0, 0, 0, 0 },
/* U+f46c */ { 0, 0, 0, 0, 0 },
/* U+f46d */ { 0, 0, 0, 0, 0 },
/* U+f46e */ { 0, 0, 0, 0, 0 },
/* U+f46f */ { 0, 0, 0, 0, 0 },
/* U+f470 */ { 0, 0, 0, 0, 0 },
/* U+f471 */ { 0, 0, 0, 0, 0 },
/* U+f472 */ { 0, 0, 0, 0, 0 },
/* U+f473 */ { 0, 0, 0, 0, 0 },
/* U+f474 */ { 0, 0, 0, 0, 0 },
/* U+f475 */ { 0, 0, 0, 0, 0 },
/* U+f476 */ { 0, 0, 0, 0, 0 },
/* U+f477 */ { 0, 0, 0, 0, 0 },
/* U+f478 */ { 0, 0, 0, 0, 0 },
/* U+f479 */ { 0, 0, 0, 0, 0 },
/* U+f47a */ { 0, 0, 0, 0, 0 },
/* U+f47b */ { 0, 0, 0, 0, 0 },
/* U+f47c */ { 0, 0, 0, 0, 0 },
/* U+f47d */ { 0, 0, 0, 0, 0 },
/* U+f47e */ { 0, 0, 0, 0, 0 },
/* U+f47f */ { 0, 0, 0, 0, 0 },
/* U+f480 */ { 0, 0, 0, 0, 0 },
/* U+f481 */ { 0, 0, 0, 0, 0 },
/* U+f482 */ { 0, 0, 0, 0, 0 },
/* U+f483 */ { 0, 0, 0, 0, 0 },
/* U+f484 */ { 0, 0, 0, 0, 0 },
/* U+f485 */ { 0, 0, 0, 0, 0 },
/* U+f486 */ { 0, 0, 0, 0, 0 },
/* U+f487 */ { 0, 0, 0, 0, 0 },
/* U+f488 */ { 0, 0, 0, 0, 0 },
/* U+f489 */ { 0, 0, 0, 0, 0 },
/* U+f48a */ { 0, 0, 0, 0, 0 },
/* U+f48b */ { 0, 0, 0, 0, 0 },
/* U+f48c */ { 0, 0, 0, 0, 0 },
/* U+f48d */ { 0, 0, 0, 0, 0 },
/* U+f48e */ { 0, 0, 0, 0, 0 },
/* U+f48f */ { 0, 0, 0, 0, 0 },
/* U+f490 */ { 0, 0, 0, 0, 0 },
/* U+f491 */ { 0, 0, 0, 0, 0 },
/* U+f492 */ { 0, 0, 0, 0, 0 },
/* U+f493 */ { 0, 0, 0, 0, 0 },
/* U+f494 */ { 0, 0, 0, 0, 0 },
/* U+f495 */ { 0, 0, 0, 0, 0 },
/* U+f496 */ { 0, 0, 0, 0, 0 },
/* U+f497 */ { 0, 0, 0, 0, 0 },
/* U+f498 */ { 0, 0, 0, 0, 0 },
/* U+f499 */ { 0, 0, 0, 0, 0 },
/* U+f49a */ { 0, 0, 0, 0, 0 },
/* U+f49b */ { 0, 0, 0, 0, 0 },
/* U+f49c */ { 0, 0, 0, 0, 0 },
/* U+f49d */ { 0, 0, 0, 0, 0 },
/* U+f49e */ { 0, 0, 0, 0, 0 },
/* U+f49f */ { 0, 0, 0, 0, 0 },
/* U+f4a0 */ { 0, 0, 0, 0, 0 },
/* U+f4a1 */ { 0, 0, 0, 0, 0 },
/* U+f4a2 */ { 0, 0, 0, 0, 0 },
/* U+f4a3 */ { 0, 0, 0, 0, 0 },
/* U+f4a4 */ { 0, 0, 0, 0, 0 },
/* U+f4a5 */ { 0, 0, 0, 0, 0 },
/* U+f4a6 */ { 0, 0, 0, 0, 0 },
/* U+f4a7 */ { 0, 0, 0, 0, 0 },
/* U+f4a8 */ { 0, 0, 0, 0, 0 },
/* U+f4a9 */ { 0, 0, 0, 0, 0 },
/* U+f4aa */ { 0, 0, 0, 0, 0 },
/* U+f4ab */ { 0, 0, 0, 0, 0 },
/* U+f4ac */ { 0, 0, 0, 0, 0 },
/* U+f4ad */ { 0, 0, 0, 0, 0 },
/* U+f4ae */ { 0, 0, 0, 0, 0 },
/* U+f4af */ { 0, 0, 0, 0, 0 },
/* U+f4b0 */ { 0, 0, 0, 0, 0 },
/* U+f4b1 */ { 0, 0, 0, 0, 0 },
/* U+f4b2 */ { 0, 0, 0, 0, 0 },
/* U+f4b3 */ { 0, 0, 0, 0, 0 },
/* U+f4b4 */ { 0, 0, 0, 0, 0 },
/* U+f4b5 */ { 0, 0, 0, 0, 0 },
/* U+f4b6 */ { 0, 0, 0, 0, 0 },
/* U+f4b7 */ { 0, 0, 0, 0, 0 },
/* U+f4b8 */ { 0, 0, 0, 0, 0 },
/* U+f4b9 */ { 0, 0, 0, 0, 0 },
/* U+f4ba */ { 0, 0, 0, 0, 0 },
/* U+f4bb */ { 0, 0, 0, 0, 0 },
/* U+f4bc */ { 0, 0, 0, 0, 0 },
/* U+f4bd */ { 0, 0, 0, 0, 0 },
/* U+f4be */ { 0, 0, 0, 0, 0 },
/* U+f4bf */ { 0, 0, 0, 0, 0 },
/* U+f4c0 */ { 0, 0, 0, 0, 0 },
/* U+f4c1 */ { 0, 0, 0, 0, 0 },
/* U+f4c2 */ { 0, 0, 0, 0, 0 },
/* U+f4c3 */ { 0, 0, 0, 0, 0 },
/* U+f4c4 */ { 0, 0, 0, 0, 0 },
/* U+f4c5 */ { 0, 0, 0, 0, 0 },
/* U+f4c6 */ { 0, 0, 0, 0, 0 },
/* U+f4c7 */ { 0, 0, 0, 0, 0 },
/* U+f4c8 */ { 0, 0, 0, 0, 0 },
/* U+f4c9 */ { 0, 0, 0, 0, 0 },
/* U+f4ca */ { 0, 0, 0, 0, 0 },
/* U+f4cb */ { 0, 0, 0, 0, 0 },
/* U+f4cc */ { 0, 0, 0, 0, 0 },
/* U+f4cd */ { 0, 0, 0, 0, 0 },
/* U+f4ce */ { 0, 0, 0, 0, 0 },
/* U+f4cf */ { 0, 0, 0, 0, 0 },
/* U+f4d0 */ { 0, 0, 0, 0, 0 },
/* U+f4d1 */ { 0, 0, 0, 0, 0 },
/* U+f4d2 */ { 0, 0, 0, 0, 0 },
/* U+f4d3 */ { 0, 0, 0, 0, 0 },
/* U+f4d4 */ { 0, 0, 0, 0, 0 },
/* U+f4d5 */ { 0, 0, 0, 0, 0 },
/* U+f4d6 */ { 0, 0, 0, 0, 0 },
/* U+f4d7 */ { 0, 0, 0, 0, 0 },
/* U+f4d8 */ { 0, 0, 0, 0, 0 },
/* U+f4d9 */ { 0, 0, 0, 0, 0 },
/* U+f4da */ { 0, 0, 0, 0, 0 },
/* U+f4db */ { 0, 0, 0, 0, 0 },
/* U+f4dc */ { 0, 0, 0, 0, 0 },
/* U+f4dd */ { 0, 0, 0, 0, 0 },
/* U+f4de */ { 0, 0, 0, 0, 0 },
/* U+f4df */ { 0, 0, 0, 0, 0 },
/* U+f4e0 */ { 0, 0, 0, 0, 0 },
/* U+f4e1 */ { 0, 0, 0, 0, 0 },
/* U+f4e2 */ { 0, 0, 0, 0, 0 },
/* U+f4e3 */ { 0, 0, 0, 0, 0 },
/* U+f4e4 */ { 0, 0, 0, 0, 0 },
/* U+f4e5 */ { 0, 0, 0, 0, 0 },
/* U+f4e6 */ { 0, 0, 0, 0, 0 },
/* U+f4e7 */ { 0, 0, 0, 0, 0 },
/* U+f4e8 */ { 0, 0, 0, 0, 0 },
/* U+f4e9 */ { 0, 0, 0, 0, 0 },
/* U+f4ea */ { 0, 0, 0, 0, 0 },
/* U+f4eb */ { 0, 0, 0, 0, 0 },
/* U+f4ec */ { 0, 0, 0, 0, 0 },
/* U+f4ed */ { 0, 0, 0, 0, 0 },
/* U+f4ee */ { 0, 0, 0, 0, 0 },
/* U+f4ef */ { 0, 0, 0, 0, 0 },
/* U+f4f0 */ { 0, 0, 0, 0, 0 },
/* U+f4f1 */ { 0, 0, 0, 0, 0 },
/* U+f4f2 */ { 0, 0, 0, 0, 0 },
/* U+f4f3 */ { 0, 0, 0, 0, 0 },
/* U+f4f4 */ { 0, 0, 0, 0, 0 },
/* U+f4f5 */ { 0, 0, 0, 0, 0 },
/* U+f4f6 */ { 0, 0, 0, 0, 0 },
/* U+f4f7 */ { 0, 0, 0, 0, 0 },
/* U+f4f8 */ { 0, 0, 0, 0, 0 },
/* U+f4f9 */ { 0, 0, 0, 0, 0 },
/* U+f4fa */ { 0, 0, 0, 0, 0 },
/* U+f4fb */ { 0, 0, 0, 0, 0 },
/* U+f4fc */ { 0, 0, 0, 0, 0 },
/* U+f4fd */ { 0, 0, 0, 0, 0 },
/* U+f4fe */ { 0, 0, 0, 0, 0 },
/* U+f4ff */ { 0, 0, 0, 0, 0 },
/* U+f500 */ { 0, 0, 0, 0, 0 },
/* U+f501 */ { 0, 0, 0, 0, 0 },
/* U+f502 */ { 0, 0, 0, 0, 0 },
/* U+f503 */ { 0, 0, 0, 0, 0 },
/* U+f504 */ { 0, 0, 0, 0, 0 },
/* U+f505 */ { 0, 0, 0, 0, 0 },
/* U+f506 */ { 0, 0, 0, 0, 0 },
/* U+f507 */ { 0, 0, 0, 0, 0 },
/* U+f508 */ { 0, 0, 0, 0, 0 },
/* U+f509 */ { 0, 0, 0, 0, 0 },
/* U+f50a */ { 0, 0, 0, 0, 0 },
/* U+f50b */ { 0, 0, 0, 0, 0 },
/* U+f50c */ { 0, 0, 0, 0, 0 },
/* U+f50d */ { 0, 0, 0, 0, 0 },
/* U+f50e */ { 0, 0, 0, 0, 0 },
/* U+f50f */ { 0, 0, 0, 0, 0 },
/* U+f510 */ { 0, 0, 0, 0, 0 },
/* U+f511 */ { 0, 0, 0, 0, 0 },
/* U+f512 */ { 0, 0, 0, 0, 0 },
/* U+f513 */ { 0, 0, 0, 0, 0 },
/* U+f514 */ { 0, 0, 0, 0, 0 },
/* U+f515 */ { 0, 0, 0, 0, 0 },
/* U+f516 */ { 0, 0, 0, 0, 0 },
/* U+f517 */ { 0, 0, 0, 0, 0 },
/* U+f518 */ { 0, 0, 0, 0, 0 },
/* U+f519 */ { 0, 0, 0, 0, 0 },
/* U+f51a */ { 0, 0, 0, 0, 0 },
/* U+f51b */ { 0, 0, 0, 0, 0 },
/* U+f51c */ { 0, 0, 0, 0, 0 },
/* U+f51d */ { 0, 0, 0, 0, 0 },
/* U+f51e */ { 0, 0, 0, 0, 0 },
/* U+f51f */ { 0, 0, 0, 0, 0 },
/* U+f520 */ { 0, 0, 0, 0, 0 },
/* U+f521 */ { 0, 0, 0, 0, 0 },
/* U+f522 */ { 0, 0, 0, 0, 0 },
/* U+f523 */ { 0, 0, 0, 0, 0 },
/* U+f524 */ { 0, 0, 0, 0, 0 },
/* U+f525 */ { 0, 0, 0, 0, 0 },
/* U+f526 */ { 0, 0, 0, 0, 0 },
/* U+f527 */ { 0, 0, 0, 0, 0 },
/* U+f528 */ { 0, 0, 0, 0, 0 },
/* U+f529 */ { 0, 0, 0, 0, 0 },
/* U+f52a */ { 0, 0, 0, 0, 0 },
/* U+f52b */ { 0, 0, 0, 0, 0 },
/* U+f52c */ { 0, 0, 0, 0, 0 },
/* U+f52d */ { 0, 0, 0, 0, 0 },
/* U+f52e */ { 0, 0, 0, 0, 0 },
/* U+f52f */ { 0, 0, 0, 0, 0 },
/* U+f530 */ { 0, 0, 0, 0, 0 },
/* U+f531 */ { 0, 0, 0, 0, 0 },
/* U+f532 */ { 0, 0, 0, 0, 0 },
/* U+f533 */ { 0, 0, 0, 0, 0 },
/* U+f534 */ { 0, 0, 0, 0, 0 },
/* U+f535 */ { 0, 0, 0, 0, 0 },
/* U+f536 */ { 0, 0, 0, 0, 0 },
/* U+f537 */ { 0, 0, 0, 0, 0 },
/* U+f538 */ { 0, 0, 0, 0, 0 },
/* U+f539 */ { 0, 0, 0, 0, 0 },
/* U+f53a */ { 0, 0, 0, 0, 0 },
/* U+f53b */ { 0, 0, 0, 0, 0 },
/* U+f53c */ { 0, 0, 0, 0, 0 },
/* U+f53d */ { 0, 0, 0, 0, 0 },
/* U+f53e */ { 0, 0, 0, 0, 0 },
/* U+f53f */ { 0, 0, 0, 0, 0 },
/* U+f540 */ { 0, 0, 0, 0, 0 },
/* U+f541 */ { 0, 0, 0, 0, 0 },
/* U+f542 */ { 0, 0, 0, 0, 0 },
/* U+f543 */ { 0, 0, 0, 0, 0 },
/* U+f544 */ { 0, 0, 0, 0, 0 },
/* U+f545 */ { 0, 0, 0, 0, 0 },
/* U+f546 */ { 0, 0, 0, 0, 0 },
/* U+f547 */ { 0, 0, 0, 0, 0 },
/* U+f548 */ { 0, 0, 0, 0, 0 },
/* U+f549 */ { 0, 0, 0, 0, 0 },
/* U+f54a */ { 0, 0, 0, 0, 0 },
/* U+f54b */ { 0, 0, 0, 0, 0 },
/* U+f54c */ { 0, 0, 0, 0, 0 },
/* U+f54d */ { 0, 0, 0, 0, 0 },
/* U+f54e */ { 0, 0, 0, 0, 0 },
/* U+f54f */ { 0, 0, 0, 0, 0 },
/* U+f550 */ { 0, 0, 0, 0, 0 },
/* U+f551 */ { 0, 0, 0, 0, 0 },
/* U+f552 */ { 0, 0, 0, 0, 0 },
/* U+f553 */ { 0, 0, 0, 0, 0 },
/* U+f554 */ { 0, 0, 0, 0, 0 },
/* U+f555 */ { 0, 0, 0, 0, 0 },
/* U+f556 */ { 0, 0, 0, 0, 0 },
/* U+f557 */ { 0, 0, 0, 0, 0 },
/* U+f558 */ { 0, 0, 0, 0, 0 },
/* U+f559 */ { 0, 0, 0, 0, 0 },
/* U+f55a */ { 0, 0, 0, 0, 0 },
/* U+f55b */ { 0, 0, 0, 0, 0 },
/* U+f55c */ { 0, 0, 0, 0, 0 },
/* U+f55d */ { 0, 0, 0, 0, 0 },
/* U+f55e */ { 0, 0, 0, 0, 0 },
/* U+f55f */ { 0, 0, 0, 0, 0 },
/* U+f560 */ { 0, 0, 0, 0, 0 },
/* U+f561 */ { 0, 0, 0, 0, 0 },
/* U+f562 */ { 0, 0, 0, 0, 0 },
/* U+f563 */ { 0, 0, 0, 0, 0 },
/* U+f564 */ { 0, 0, 0, 0, 0 },
/* U+f565 */ { 0, 0, 0, 0, 0 },
/* U+f566 */ { 0, 0, 0, 0, 0 },
/* U+f567 */ { 0, 0, 0, 0, 0 },
/* U+f568 */ { 0, 0, 0, 0, 0 },
/* U+f569 */ { 0, 0, 0, 0, 0 },
/* U+f56a */ { 0, 0, 0, 0, 0 },
/* U+f56b */ { 0, 0, 0, 0, 0 },
/* U+f56c */ { 0, 0, 0, 0, 0 },
/* U+f56d */ { 0, 0, 0, 0, 0 },
/* U+f56e */ { 0, 0, 0, 0, 0 },
/* U+f56f */ { 0, 0, 0, 0, 0 },
/* U+f570 */ { 0, 0, 0, 0, 0 },
/* U+f571 */ { 0, 0, 0, 0, 0 },
/* U+f572 */ { 0, 0, 0, 0, 0 },
/* U+f573 */ { 0, 0, 0, 0, 0 },
/* U+f574 */ { 0, 0, 0, 0, 0 },
/* U+f575 */ { 0, 0, 0, 0, 0 },
/* U+f576 */ { 0, 0, 0, 0, 0 },
/* U+f577 */ { 0, 0, 0, 0, 0 },
/* U+f578 */ { 0, 0, 0, 0, 0 },
/* U+f579 */ { 0, 0, 0, 0, 0 },
/* U+f57a */ { 0, 0, 0, 0, 0 },
/* U+f57b */ { 0, 0, 0, 0, 0 },
/* U+f57c */ { 0, 0, 0, 0, 0 },
/* U+f57d */ { 0, 0, 0, 0, 0 },
/* U+f57e */ { 0, 0, 0, 0, 0 },
/* U+f57f */ { 0, 0, 0, 0, 0 },
/* U+f580 */ { 0, 0, 0, 0, 0 },
/* U+f581 */ { 0, 0, 0, 0, 0 },
/* U+f582 */ { 0, 0, 0, 0, 0 },
/* U+f583 */ { 0, 0, 0, 0, 0 },
/* U+f584 */ { 0, 0, 0, 0, 0 },
/* U+f585 */ { 0, 0, 0, 0, 0 },
/* U+f586 */ { 0, 0, 0, 0, 0 },
/* U+f587 */ { 0, 0, 0, 0, 0 },
/* U+f588 */ { 0, 0, 0, 0, 0 },
/* U+f589 */ { 0, 0, 0, 0, 0 },
/* U+f58a */ { 0, 0, 0, 0, 0 },
/* U+f58b */ { 0, 0, 0, 0, 0 },
/* U+f58c */ { 0, 0, 0, 0, 0 },
/* U+f58d */ { 0, 0, 0, 0, 0 },
/* U+f58e */ { 0, 0, 0, 0, 0 },
/* U+f58f */ { 0, 0, 0, 0, 0 },
/* U+f590 */ { 0, 0, 0, 0, 0 },
/* U+f591 */ { 0, 0, 0, 0, 0 },
/* U+f592 */ { 0, 0, 0, 0, 0 },
/* U+f593 */ { 0, 0, 0, 0, 0 },
/* U+f594 */ { 0, 0, 0, 0, 0 },
/* U+f595 */ { 0, 0, 0, 0, 0 },
/* U+f596 */ { 0, 0, 0, 0, 0 },
/* U+f597 */ { 0, 0, 0, 0, 0 },
/* U+f598 */ { 0, 0, 0, 0, 0 },
/* U+f599 */ { 0, 0, 0, 0, 0 },
/* U+f59a */ { 0, 0, 0, 0, 0 },
/* U+f59b */ { 0, 0, 0, 0, 0 },
/* U+f59c */ { 0, 0, 0, 0, 0 },
/* U+f59d */ { 0, 0, 0, 0, 0 },
/* U+f59e */ { 0, 0, 0, 0, 0 },
/* U+f59f */ { 0, 0, 0, 0, 0 },
/* U+f5a0 */ { 0, 0, 0, 0, 0 },
/* U+f5a1 */ { 0, 0, 0, 0, 0 },
/* U+f5a2 */ { 0, 0, 0, 0, 0 },
/* U+f5a3 */ { 0, 0, 0, 0, 0 },
/* U+f5a4 */ { 0, 0, 0, 0, 0 },
/* U+f5a5 */ { 0, 0, 0, 0, 0 },
/* U+f5a6 */ { 0, 0, 0, 0, 0 },
/* U+f5a7 */ { 0, 0, 0, 0, 0 },
/* U+f5a8 */ { 0, 0, 0, 0, 0 },
/* U+f5a9 */ { 0, 0, 0, 0, 0 },
/* U+f5aa */ { 0, 0, 0, 0, 0 },
/* U+f5ab */ { 0, 0, 0, 0, 0 },
/* U+f5ac */ { 0, 0, 0, 0, 0 },
/* U+f5ad */ { 0, 0, 0, 0, 0 },
/* U+f5ae */ { 0, 0, 0, 0, 0 },
/* U+f5af */ { 0, 0, 0, 0, 0 },
/* U+f5b0 */ { 0, 0, 0, 0, 0 },
/* U+f5b1 */ { 0, 0, 0, 0, 0 },
/* U+f5b2 */ { 0, 0, 0, 0, 0 },
/* U+f5b3 */ { 0, 0, 0, 0, 0 },
/* U+f5b4 */ { 0, 0, 0, 0, 0 },
/* U+f5b5 */ { 0, 0, 0, 0, 0 },
/* U+f5b6 */ { 0, 0, 0, 0, 0 },
/* U+f5b7 */ { 0, 0, 0, 0, 0 },
/* U+f5b8 */ { 0, 0, 0, 0, 0 },
/* U+f5b9 */ { 0, 0, 0, 0, 0 },
/* U+f5ba */ { 0, 0, 0, 0, 0 },
/* U+f5bb */ { 0, 0, 0, 0, 0 },
/* U+f5bc */ { 0, 0, 0, 0, 0 },
/* U+f5bd */ { 0, 0, 0, 0, 0 },
/* U+f5be */ { 0, 0, 0, 0, 0 },
/* U+f5bf */ { 0, 0, 0, 0, 0 },
/* U+f5c0 */ { 0, 0, 0, 0, 0 },
/* U+f5c1 */ { 0, 0, 0, 0, 0 },
/* U+f5c2 */ { 0, 0, 0, 0, 0 },
/* U+f5c3 */ { 0, 0, 0, 0, 0 },
/* U+f5c4 */ { 0, 0, 0, 0, 0 },
/* U+f5c5 */ { 0, 0, 0, 0, 0 },
/* U+f5c6 */ { 0, 0, 0, 0, 0 },
/* U+f5c7 */ { 0, 0, 0, 0, 0 },
/* U+f5c8 */ { 0, 0, 0, 0, 0 },
/* U+f5c9 */ { 0, 0, 0, 0, 0 },
/* U+f5ca */ { 0, 0, 0, 0, 0 },
/* U+f5cb */ { 0, 0, 0, 0, 0 },
/* U+f5cc */ { 0, 0, 0, 0, 0 },
/* U+f5cd */ { 0, 0, 0, 0, 0 },
/* U+f5ce */ { 0, 0, 0, 0, 0 },
/* U+f5cf */ { 0, 0, 0, 0, 0 },
/* U+f5d0 */ { 0, 0, 0, 0, 0 },
/* U+f5d1 */ { 0, 0, 0, 0, 0 },
/* U+f5d2 */ { 0, 0, 0, 0, 0 },
/* U+f5d3 */ { 0, 0, 0, 0, 0 },
/* U+f5d4 */ { 0, 0, 0, 0, 0 },
/* U+f5d5 */ { 0, 0, 0, 0, 0 },
/* U+f5d6 */ { 0, 0, 0, 0, 0 },
/* U+f5d7 */ { 0, 0, 0, 0, 0 },
/* U+f5d8 */ { 0, 0, 0, 0, 0 },
/* U+f5d9 */ { 0, 0, 0, 0, 0 },
/* U+f5da */ { 0, 0, 0, 0, 0 },
/* U+f5db */ { 0, 0, 0, 0, 0 },
/* U+f5dc */ { 0, 0, 0, 0, 0 },
/* U+f5dd */ { 0, 0, 0, 0, 0 },
/* U+f5de */ { 0, 0, 0, 0, 0 },
/* U+f5df */ { 0, 0, 0, 0, 0 },
/* U+f5e0 */ { 0, 0, 0, 0, 0 },
/* U+f5e1 */ { 0, 0, 0, 0, 0 },
/* U+f5e2 */ { 0, 0, 0, 0, 0 },
/* U+f5e3 */ { 0, 0, 0, 0, 0 },
/* U+f5e4 */ { 0, 0, 0, 0, 0 },
/* U+f5e5 */ { 0, 0, 0, 0, 0 },
/* U+f5e6 */ { 0, 0, 0, 0, 0 },
/* U+f5e7 */ { 0, 0, 0, 0, 0 },
/* U+f5e8 */ { 0, 0, 0, 0, 0 },
/* U+f5e9 */ { 0, 0, 0, 0, 0 },
/* U+f5ea */ { 0, 0, 0, 0, 0 },
/* U+f5eb */ { 0, 0, 0, 0, 0 },
/* U+f5ec */ { 0, 0, 0, 0, 0 },
/* U+f5ed */ { 0, 0, 0, 0, 0 },
/* U+f5ee */ { 0, 0, 0, 0, 0 },
/* U+f5ef */ { 0, 0, 0, 0, 0 },
/* U+f5f0 */ { 0, 0, 0, 0, 0 },
/* U+f5f1 */ { 0, 0, 0, 0, 0 },
/* U+f5f2 */ { 0, 0, 0, 0, 0 },
/* U+f5f3 */ { 0, 0, 0, 0, 0 },
/* U+f5f4 */ { 0, 0, 0, 0, 0 },
/* U+f5f5 */ { 0, 0, 0, 0, 0 },
/* U+f5f6 */ { 0, 0, 0, 0, 0 },
/* U+f5f7 */ { 0, 0, 0, 0, 0 },
/* U+f5f8 */ { 0, 0, 0, 0, 0 },
/* U+f5f9 */ { 0, 0, 0, 0, 0 },
/* U+f5fa */ { 0, 0, 0, 0, 0 },
/* U+f5fb */ { 0, 0, 0, 0, 0 },
/* U+f5fc */ { 0, 0, 0, 0, 0 },
/* U+f5fd */ { 0, 0, 0, 0, 0 },
/* U+f5fe */ { 0, 0, 0, 0, 0 },
/* U+f5ff */ { 0, 0, 0, 0, 0 },
/* U+f600 */ { 0, 0, 0, 0, 0 },
/* U+f601 */ { 0, 0, 0, 0, 0 },
/* U+f602 */ { 0, 0, 0, 0, 0 },
/* U+f603 */ { 0, 0, 0, 0, 0 },
/* U+f604 */ { 0, 0, 0, 0, 0 },
/* U+f605 */ { 0, 0, 0, 0, 0 },
/* U+f606 */ { 0, 0, 0, 0, 0 },
/* U+f607 */ { 0, 0, 0, 0, 0 },
/* U+f608 */ { 0, 0, 0, 0, 0 },
/* U+f609 */ { 0, 0, 0, 0, 0 },
/* U+f60a */ { 0, 0, 0, 0, 0 },
/* U+f60b */ { 0, 0, 0, 0, 0 },
/* U+f60c */ { 0, 0, 0, 0, 0 },
/* U+f60d */ { 0, 0, 0, 0, 0 },
/* U+f60e */ { 0, 0, 0, 0, 0 },
/* U+f60f */ { 0, 0, 0, 0, 0 },
/* U+f610 */ { 0, 0, 0, 0, 0 },
/* U+f611 */ { 0, 0, 0, 0, 0 },
/* U+f612 */ { 0, 0, 0, 0, 0 },
/* U+f613 */ { 0, 0, 0, 0, 0 },
/* U+f614 */ { 0, 0, 0, 0, 0 },
/* U+f615 */ { 0, 0, 0, 0, 0 },
/* U+f616 */ { 0, 0, 0, 0, 0 },
/* U+f617 */ { 0, 0, 0, 0, 0 },
/* U+f618 */ { 0, 0, 0, 0, 0 },
/* U+f619 */ { 0, 0, 0, 0, 0 },
/* U+f61a */ { 0, 0, 0, 0, 0 },
/* U+f61b */ { 0, 0, 0, 0, 0 },
/* U+f61c */ { 0, 0, 0, 0, 0 },
/* U+f61d */ { 0, 0, 0, 0, 0 },
/* U+f61e */ { 0, 0, 0, 0, 0 },
/* U+f61f */ { 0, 0, 0, 0, 0 },
/* U+f620 */ { 0, 0, 0, 0, 0 },
/* U+f621 */ { 0, 0, 0, 0, 0 },
/* U+f622 */ { 0, 0, 0, 0, 0 },
/* U+f623 */ { 0, 0, 0, 0, 0 },
/* U+f624 */ { 0, 0, 0, 0, 0 },
/* U+f625 */ { 0, 0, 0, 0, 0 },
/* U+f626 */ { 0, 0, 0, 0, 0 },
/* U+f627 */ { 0, 0, 0, 0, 0 },
/* U+f628 */ { 0, 0, 0, 0, 0 },
/* U+f629 */ { 0, 0, 0, 0, 0 },
/* U+f62a */ { 0, 0, 0, 0, 0 },
/* U+f62b */ { 0, 0, 0, 0, 0 },
/* U+f62c */ { 0, 0, 0, 0, 0 },
/* U+f62d */ { 0, 0, 0, 0, 0 },
/* U+f62e */ { 0, 0, 0, 0, 0 },
/* U+f62f */ { 0, 0, 0, 0, 0 },
/* U+f630 */ { 0, 0, 0, 0, 0 },
/* U+f631 */ { 0, 0, 0, 0, 0 },
/* U+f632 */ { 0, 0, 0, 0, 0 },
/* U+f633 */ { 0, 0, 0, 0, 0 },
/* U+f634 */ { 0, 0, 0, 0, 0 },
/* U+f635 */ { 0, 0, 0, 0, 0 },
/* U+f636 */ { 0, 0, 0, 0, 0 },
/* U+f637 */ { 0, 0, 0, 0, 0 },
/* U+f638 */ { 0, 0, 0, 0, 0 },
/* U+f639 */ { 0, 0, 0, 0, 0 },
/* U+f63a */ { 0, 0, 0, 0, 0 },
/* U+f63b */ { 0, 0, 0, 0, 0 },
/* U+f63c */ { 0, 0, 0, 0, 0 },
/* U+f63d */ { 0, 0, 0, 0, 0 },
/* U+f63e */ { 0, 0, 0, 0, 0 },
/* U+f63f */ { 0, 0, 0, 0, 0 },
/* U+f640 */ { 0, 0, 0, 0, 0 },
/* U+f641 */ { 0, 0, 0, 0, 0 },
/* U+f642 */ { 0, 0, 0, 0, 0 },
/* U+f643 */ { 0, 0, 0, 0, 0 },
/* U+f644 */ { 0, 0, 0, 0, 0 },
/* U+f645 */ { 0, 0, 0, 0, 0 },
/* U+f646 */ { 0, 0, 0, 0, 0 },
/* U+f647 */ { 0, 0, 0, 0, 0 },
/* U+f648 */ { 0, 0, 0, 0, 0 },
/* U+f649 */ { 0, 0, 0, 0, 0 },
/* U+f64a */ { 0, 0, 0, 0, 0 },
/* U+f64b */ { 0, 0, 0, 0, 0 },
/* U+f64c */ { 0, 0, 0, 0, 0 },
/* U+f64d */ { 0, 0, 0, 0, 0 },
/* U+f64e */ { 0, 0, 0, 0, 0 },
/* U+f64f */ { 0, 0, 0, 0, 0 },
/* U+f650 */ { 0, 0, 0, 0, 0 },
/* U+f651 */ { 0, 0, 0, 0, 0 },
/* U+f652 */ { 0, 0, 0, 0, 0 },
/* U+f653 */ { 0, 0, 0, 0, 0 },
/* U+f654 */ { 0, 0, 0, 0, 0 },
/* U+f655 */ { 0, 0, 0, 0, 0 },
/* U+f656 */ { 0, 0, 0, 0, 0 },
/* U+f657 */ { 0, 0, 0, 0, 0 },
/* U+f658 */ { 0, 0, 0, 0, 0 },
/* U+f659 */ { 0, 0, 0, 0, 0 },
/* U+f65a */ { 0, 0, 0, 0, 0 },
/* U+f65b */ { 0, 0, 0, 0, 0 },
/* U+f65c */ { 0, 0, 0, 0, 0 },
/* U+f65d */ { 0, 0, 0, 0, 0 },
/* U+f65e */ { 0, 0, 0, 0, 0 },
/* U+f65f */ { 0, 0, 0, 0, 0 },
/* U+f660 */ { 0, 0, 0, 0, 0 },
/* U+f661 */ { 0, 0, 0, 0, 0 },
/* U+f662 */ { 0, 0, 0, 0, 0 },
/* U+f663 */ { 0, 0, 0, 0, 0 },
/* U+f664 */ { 0, 0, 0, 0, 0 },
/* U+f665 */ { 0, 0, 0, 0, 0 },
/* U+f666 */ { 0, 0, 0, 0, 0 },
/* U+f667 */ { 0, 0, 0, 0, 0 },
/* U+f668 */ { 0, 0, 0, 0, 0 },
/* U+f669 */ { 0, 0, 0, 0, 0 },
/* U+f66a */ { 0, 0, 0, 0, 0 },
/* U+f66b */ { 0, 0, 0, 0, 0 },
/* U+f66c */ { 0, 0, 0, 0, 0 },
/* U+f66d */ { 0, 0, 0, 0, 0 },
/* U+f66e */ { 0, 0, 0, 0, 0 },
/* U+f66f */ { 0, 0, 0, 0, 0 },
/* U+f670 */ { 0, 0, 0, 0, 0 },
/* U+f671 */ { 0, 0, 0, 0, 0 },
/* U+f672 */ { 0, 0, 0, 0, 0 },
/* U+f673 */ { 0, 0, 0, 0, 0 },
/* U+f674 */ { 0, 0, 0, 0, 0 },
/* U+f675 */ { 0, 0, 0, 0, 0 },
/* U+f676 */ { 0, 0, 0, 0, 0 },
/* U+f677 */ { 0, 0, 0, 0, 0 },
/* U+f678 */ { 0, 0, 0, 0, 0 },
/* U+f679 */ { 0, 0, 0, 0, 0 },
/* U+f67a */ { 0, 0, 0, 0, 0 },
/* U+f67b */ { 0, 0, 0, 0, 0 },
/* U+f67c */ { 0, 0, 0, 0, 0 },
/* U+f67d */ { 0, 0, 0, 0, 0 },
/* U+f67e */ { 0, 0, 0, 0, 0 },
/* U+f67f */ { 0, 0, 0, 0, 0 },
/* U+f680 */ { 0, 0, 0, 0, 0 },
/* U+f681 */ { 0, 0, 0, 0, 0 },
/* U+f682 */ { 0, 0, 0, 0, 0 },
/* U+f683 */ { 0, 0, 0, 0, 0 },
/* U+f684 */ { 0, 0, 0, 0, 0 },
/* U+f685 */ { 0, 0, 0, 0, 0 },
/* U+f686 */ { 0, 0, 0, 0, 0 },
/* U+f687 */ { 0, 0, 0, 0, 0 },
/* U+f688 */ { 0, 0, 0, 0, 0 },
/* U+f689 */ { 0, 0, 0, 0, 0 },
/* U+f68a */ { 0, 0, 0, 0, 0 },
/* U+f68b */ { 0, 0, 0, 0, 0 },
/* U+f68c */ { 0, 0, 0, 0, 0 },
/* U+f68d */ { 0, 0, 0, 0, 0 },
/* U+f68e */ { 0, 0, 0, 0, 0 },
/* U+f68f */ { 0, 0, 0, 0, 0 },
/* U+f690 */ { 0, 0, 0, 0, 0 },
/* U+f691 */ { 0, 0, 0, 0, 0 },
/* U+f692 */ { 0, 0, 0, 0, 0 },
/* U+f693 */ { 0, 0, 0, 0, 0 },
/* U+f694 */ { 0, 0, 0, 0, 0 },
/* U+f695 */ { 0, 0, 0, 0, 0 },
/* U+f696 */ { 0, 0, 0, 0, 0 },
/* U+f697 */ { 0, 0, 0, 0, 0 },
/* U+f698 */ { 0, 0, 0, 0, 0 },
/* U+f699 */ { 0, 0, 0, 0, 0 },
/* U+f69a */ { 0, 0, 0, 0, 0 },
/* U+f69b */ { 0, 0, 0, 0, 0 },
/* U+f69c */ { 0, 0, 0, 0, 0 },
/* U+f69d */ { 0, 0, 0, 0, 0 },
/* U+f69e */ { 0, 0, 0, 0, 0 },
/* U+f69f */ { 0, 0, 0, 0, 0 },
/* U+f6a0 */ { 0, 0, 0, 0, 0 },
/* U+f6a1 */ { 0, 0, 0, 0, 0 },
/* U+f6a2 */ { 0, 0, 0, 0, 0 },
/* U+f6a3 */ { 0, 0, 0, 0, 0 },
/* U+f6a4 */ { 0, 0, 0, 0, 0 },
/* U+f6a5 */ { 0, 0, 0, 0, 0 },
/* U+f6a6 */ { 0, 0, 0, 0, 0 },
/* U+f6a7 */ { 0, 0, 0, 0, 0 },
/* U+f6a8 */ { 0, 0, 0, 0, 0 },
/* U+f6a9 */ { 0, 0, 0, 0, 0 },
/* U+f6aa */ { 0, 0, 0, 0, 0 },
/* U+f6ab */ { 0, 0, 0, 0, 0 },
/* U+f6ac */ { 0, 0, 0, 0, 0 },
/* U+f6ad */ { 0, 0, 0, 0, 0 },
/* U+f6ae */ { 0, 0, 0, 0, 0 },
/* U+f6af */ { 0, 0, 0, 0, 0 },
/* U+f6b0 */ { 0, 0, 0, 0, 0 },
/* U+f6b1 */ { 0, 0, 0, 0, 0 },
/* U+f6b2 */ { 0, 0, 0, 0, 0 },
/* U+f6b3 */ { 0, 0, 0, 0, 0 },
/* U+f6b4 */ { 0, 0, 0, 0, 0 },
/* U+f6b5 */ { 0, 0, 0, 0, 0 },
/* U+f6b6 */ { 0, 0, 0, 0, 0 },
/* U+f6b7 */ { 0, 0, 0, 0, 0 },
/* U+f6b8 */ { 0, 0, 0, 0, 0 },
/* U+f6b9 */ { 0, 0, 0, 0, 0 },
/* U+f6ba */ { 0, 0, 0, 0, 0 },
/* U+f6bb */ { 0, 0, 0, 0, 0 },
/* U+f6bc */ { 0, 0, 0, 0, 0 },
/* U+f6bd */ { 0, 0, 0, 0, 0 },
/* U+f6be */ { 0, 0, 0, 0, 0 },
/* U+f6bf */ { 0, 0, 0, 0, 0 },
/* U+f6c0 */ { 0, 0, 0, 0, 0 },
/* U+f6c1 */ { 0, 0, 0, 0, 0 },
/* U+f6c2 */ { 0, 0, 0, 0, 0 },
/* U+f6c3 */ { 0, 0, 0, 0, 0 },
/* U+f6c4 */ { 0, 0, 0, 0, 0 },
/* U+f6c5 */ { 0, 0, 0, 0, 0 },
/* U+f6c6 */ { 0, 0, 0, 0, 0 },
/* U+f6c7 */ { 0, 0, 0, 0, 0 },
/* U+f6c8 */ { 0, 0, 0, 0, 0 },
/* U+f6c9 */ { 0, 0, 0, 0, 0 },
/* U+f6ca */ { 0, 0, 0, 0, 0 },
/* U+f6cb */ { 0, 0, 0, 0, 0 },
/* U+f6cc */ { 0, 0, 0, 0, 0 },
/* U+f6cd */ { 0, 0, 0, 0, 0 },
/* U+f6ce */ { 0, 0, 0, 0, 0 },
/* U+f6cf */ { 0, 0, 0, 0, 0 },
/* U+f6d0 */ { 0, 0, 0, 0, 0 },
/* U+f6d1 */ { 0, 0, 0, 0, 0 },
/* U+f6d2 */ { 0, 0, 0, 0, 0 },
/* U+f6d3 */ { 0, 0, 0, 0, 0 },
/* U+f6d4 */ { 0, 0, 0, 0, 0 },
/* U+f6d5 */ { 0, 0, 0, 0, 0 },
/* U+f6d6 */ { 0, 0, 0, 0, 0 },
/* U+f6d7 */ { 0, 0, 0, 0, 0 },
/* U+f6d8 */ { 0, 0, 0, 0, 0 },
/* U+f6d9 */ { 0, 0, 0, 0, 0 },
/* U+f6da */ { 0, 0, 0, 0, 0 },
/* U+f6db */ { 0, 0, 0, 0, 0 },
/* U+f6dc */ { 0, 0, 0, 0, 0 },
/* U+f6dd */ { 0, 0, 0, 0, 0 },
/* U+f6de */ { 0, 0, 0, 0, 0 },
/* U+f6df */ { 0, 0, 0, 0, 0 },
/* U+f6e0 */ { 0, 0, 0, 0, 0 },
/* U+f6e1 */ { 0, 0, 0, 0, 0 },
/* U+f6e2 */ { 0, 0, 0, 0, 0 },
/* U+f6e3 */ { 0, 0, 0, 0, 0 },
/* U+f6e4 */ { 0, 0, 0, 0, 0 },
/* U+f6e5 */ { 0, 0, 0, 0, 0 },
/* U+f6e6 */ { 0, 0, 0, 0, 0 },
/* U+f6e7 */ { 0, 0, 0, 0, 0 },
/* U+f6e8 */ { 0, 0, 0, 0, 0 },
/* U+f6e9 */ { 0, 0, 0, 0, 0 },
/* U+f6ea */ { 0, 0, 0, 0, 0 },
/* U+f6eb */ { 0, 0, 0, 0, 0 },
/* U+f6ec */ { 0, 0, 0, 0, 0 },
/* U+f6ed */ { 0, 0, 0, 0, 0 },
/* U+f6ee */ { 0, 0, 0, 0, 0 },
/* U+f6ef */ { 0, 0, 0, 0, 0 },
/* U+f6f0 */ { 0, 0, 0, 0, 0 },
/* U+f6f1 */ { 0, 0, 0, 0, 0 },
/* U+f6f2 */ { 0, 0, 0, 0, 0 },
/* U+f6f3 */ { 0, 0, 0, 0, 0 },
/* U+f6f4 */ { 0, 0, 0, 0, 0 },
/* U+f6f5 */ { 0, 0, 0, 0, 0 },
/* U+f6f6 */ { 0, 0, 0, 0, 0 },
/* U+f6f7 */ { 0, 0, 0, 0, 0 },
/* U+f6f8 */ { 0, 0, 0, 0, 0 },
/* U+f6f9 */ { 0, 0, 0, 0, 0 },
/* U+f6fa */ { 0, 0, 0, 0, 0 },
/* U+f6fb */ { 0, 0, 0, 0, 0 },
/* U+f6fc */ { 0, 0, 0, 0, 0 },
/* U+f6fd */ { 0, 0, 0, 0, 0 },
/* U+f6fe */ { 0, 0, 0, 0, 0 },
/* U+f6ff */ { 0, 0, 0, 0, 0 },
/* U+f700 */ { 0, 0, 0, 0, 0 },
/* U+f701 */ { 0, 0, 0, 0, 0 },
/* U+f702 */ { 0, 0, 0, 0, 0 },
/* U+f703 */ { 0, 0, 0, 0, 0 },
/* U+f704 */ { 0, 0, 0, 0, 0 },
/* U+f705 */ { 0, 0, 0, 0, 0 },
/* U+f706 */ { 0, 0, 0, 0, 0 },
/* U+f707 */ { 0, 0, 0, 0, 0 },
/* U+f708 */ { 0, 0, 0, 0, 0 },
/* U+f709 */ { 0, 0, 0, 0, 0 },
/* U+f70a */ { 0, 0, 0, 0, 0 },
/* U+f70b */ { 0, 0, 0, 0, 0 },
/* U+f70c */ { 0, 0, 0, 0, 0 },
/* U+f70d */ { 0, 0, 0, 0, 0 },
/* U+f70e */ { 0, 0, 0, 0, 0 },
/* U+f70f */ { 0, 0, 0, 0, 0 },
/* U+f710 */ { 0, 0, 0, 0, 0 },
/* U+f711 */ { 0, 0, 0, 0, 0 },
/* U+f712 */ { 0, 0, 0, 0, 0 },
/* U+f713 */ { 0, 0, 0, 0, 0 },
/* U+f714 */ { 0, 0, 0, 0, 0 },
/* U+f715 */ { 0, 0, 0, 0, 0 },
/* U+f716 */ { 0, 0, 0, 0, 0 },
/* U+f717 */ { 0, 0, 0, 0, 0 },
/* U+f718 */ { 0, 0, 0, 0, 0 },
/* U+f719 */ { 0, 0, 0, 0, 0 },
/* U+f71a */ { 0, 0, 0, 0, 0 },
/* U+f71b */ { 0, 0, 0, 0, 0 },
/* U+f71c */ { 0, 0, 0, 0, 0 },
/* U+f71d */ { 0, 0, 0, 0, 0 },
/* U+f71e */ { 0, 0, 0, 0, 0 },
/* U+f71f */ { 0, 0, 0, 0, 0 },
/* U+f720 */ { 0, 0, 0, 0, 0 },
/* U+f721 */ { 0, 0, 0, 0, 0 },
/* U+f722 */ { 0, 0, 0, 0, 0 },
/* U+f723 */ { 0, 0, 0, 0, 0 },
/* U+f724 */ { 0, 0, 0, 0, 0 },
/* U+f725 */ { 0, 0, 0, 0, 0 },
/* U+f726 */ { 0, 0, 0, 0, 0 },
/* U+f727 */ { 0, 0, 0, 0, 0 },
/* U+f728 */ { 0, 0, 0, 0, 0 },
/* U+f729 */ { 0, 0, 0, 0, 0 },
/* U+f72a */ { 0, 0, 0, 0, 0 },
/* U+f72b */ { 0, 0, 0, 0, 0 },
/* U+f72c */ { 0, 0, 0, 0, 0 },
/* U+f72d */ { 0, 0, 0, 0, 0 },
/* U+f72e */ { 0, 0, 0, 0, 0 },
/* U+f72f */ { 0, 0, 0, 0, 0 },
/* U+f730 */ { 0, 0, 0, 0, 0 },
/* U+f731 */ { 0, 0, 0, 0, 0 },
/* U+f732 */ { 0, 0, 0, 0, 0 },
/* U+f733 */ { 0, 0, 0, 0, 0 },
/* U+f734 */ { 0, 0, 0, 0, 0 },
/* U+f735 */ { 0, 0, 0, 0, 0 },
/* U+f736 */ { 0, 0, 0, 0, 0 },
/* U+f737 */ { 0, 0, 0, 0, 0 },
/* U+f738 */ { 0, 0, 0, 0, 0 },
/* U+f739 */ { 0, 0, 0, 0, 0 },
/* U+f73a */ { 0, 0, 0, 0, 0 },
/* U+f73b */ { 0, 0, 0, 0, 0 },
/* U+f73c */ { 0, 0, 0, 0, 0 },
/* U+f73d */ { 0, 0, 0, 0, 0 },
/* U+f73e */ { 0, 0, 0, 0, 0 },
/* U+f73f */ { 0, 0, 0, 0, 0 },
/* U+f740 */ { 0, 0, 0, 0, 0 },
/* U+f741 */ { 0, 0, 0, 0, 0 },
/* U+f742 */ { 0, 0, 0, 0, 0 },
/* U+f743 */ { 0, 0, 0, 0, 0 },
/* U+f744 */ { 0, 0, 0, 0, 0 },
/* U+f745 */ { 0, 0, 0, 0, 0 },
/* U+f746 */ { 0, 0, 0, 0, 0 },
/* U+f747 */ { 0, 0, 0, 0, 0 },
/* U+f748 */ { 0, 0, 0, 0, 0 },
/* U+f749 */ { 0, 0, 0, 0, 0 },
/* U+f74a */ { 0, 0, 0, 0, 0 },
/* U+f74b */ { 0, 0, 0, 0, 0 },
/* U+f74c */ { 0, 0, 0, 0, 0 },
/* U+f74d */ { 0, 0, 0, 0, 0 },
/* U+f74e */ { 0, 0, 0, 0, 0 },
/* U+f74f */ { 0, 0, 0, 0, 0 },
/* U+f750 */ { 0, 0, 0, 0, 0 },
/* U+f751 */ { 0, 0, 0, 0, 0 },
/* U+f752 */ { 0, 0, 0, 0, 0 },
/* U+f753 */ { 0, 0, 0, 0, 0 },
/* U+f754 */ { 0, 0, 0, 0, 0 },
/* U+f755 */ { 0, 0, 0, 0, 0 },
/* U+f756 */ { 0, 0, 0, 0, 0 },
/* U+f757 */ { 0, 0, 0, 0, 0 },
/* U+f758 */ { 0, 0, 0, 0, 0 },
/* U+f759 */ { 0, 0, 0, 0, 0 },
/* U+f75a */ { 0, 0, 0, 0, 0 },
/* U+f75b */ { 0, 0, 0, 0, 0 },
/* U+f75c */ { 0, 0, 0, 0, 0 },
/* U+f75d */ { 0, 0, 0, 0, 0 },
/* U+f75e */ { 0, 0, 0, 0, 0 },
/* U+f75f */ { 0, 0, 0, 0, 0 },
/* U+f760 */ { 0, 0, 0, 0, 0 },
/* U+f761 */ { 0, 0, 0, 0, 0 },
/* U+f762 */ { 0, 0, 0, 0, 0 },
/* U+f763 */ { 0, 0, 0, 0, 0 },
/* U+f764 */ { 0, 0, 0, 0, 0 },
/* U+f765 */ { 0, 0, 0, 0, 0 },
/* U+f766 */ { 0, 0, 0, 0, 0 },
/* U+f767 */ { 0, 0, 0, 0, 0 },
/* U+f768 */ { 0, 0, 0, 0, 0 },
/* U+f769 */ { 0, 0, 0, 0, 0 },
/* U+f76a */ { 0, 0, 0, 0, 0 },
/* U+f76b */ { 0, 0, 0, 0, 0 },
/* U+f76c */ { 0, 0, 0, 0, 0 },
/* U+f76d */ { 0, 0, 0, 0, 0 },
/* U+f76e */ { 0, 0, 0, 0, 0 },
/* U+f76f */ { 0, 0, 0, 0, 0 },
/* U+f770 */ { 0, 0, 0, 0, 0 },
/* U+f771 */ { 0, 0, 0, 0, 0 },
/* U+f772 */ { 0, 0, 0, 0, 0 },
/* U+f773 */ { 0, 0, 0, 0, 0 },
/* U+f774 */ { 0, 0, 0, 0, 0 },
/* U+f775 */ { 0, 0, 0, 0, 0 },
/* U+f776 */ { 0, 0, 0, 0, 0 },
/* U+f777 */ { 0, 0, 0, 0, 0 },
/* U+f778 */ { 0, 0, 0, 0, 0 },
/* U+f779 */ { 0, 0, 0, 0, 0 },
/* U+f77a */ { 0, 0, 0, 0, 0 },
/* U+f77b */ { 0, 0, 0, 0, 0 },
/* U+f77c */ { 0, 0, 0, 0, 0 },
/* U+f77d */ { 0, 0, 0, 0, 0 },
/* U+f77e */ { 0, 0, 0, 0, 0 },
/* U+f77f */ { 0, 0, 0, 0, 0 },
/* U+f780 */ { 0, 0, 0, 0, 0 },
/* U+f781 */ { 0, 0, 0, 0, 0 },
/* U+f782 */ { 0, 0, 0, 0, 0 },
/* U+f783 */ { 0, 0, 0, 0, 0 },
/* U+f784 */ { 0, 0, 0, 0, 0 },
/* U+f785 */ { 0, 0, 0, 0, 0 },
/* U+f786 */ { 0, 0, 0, 0, 0 },
/* U+f787 */ { 0, 0, 0, 0, 0 },
/* U+f788 */ { 0, 0, 0, 0, 0 },
/* U+f789 */ { 0, 0, 0, 0, 0 },
/* U+f78a */ { 0, 0, 0, 0, 0 },
/* U+f78b */ { 0, 0, 0, 0, 0 },
/* U+f78c */ { 0, 0, 0, 0, 0 },
/* U+f78d */ { 0, 0, 0, 0, 0 },
/* U+f78e */ { 0, 0, 0, 0, 0 },
/* U+f78f */ { 0, 0, 0, 0, 0 },
/* U+f790 */ { 0, 0, 0, 0, 0 },
/* U+f791 */ { 0, 0, 0, 0, 0 },
/* U+f792 */ { 0, 0, 0, 0, 0 },
/* U+f793 */ { 0, 0, 0, 0, 0 },
/* U+f794 */ { 0, 0, 0, 0, 0 },
/* U+f795 */ { 0, 0, 0, 0, 0 },
/* U+f796 */ { 0, 0, 0, 0, 0 },
/* U+f797 */ { 0, 0, 0, 0, 0 },
/* U+f798 */ { 0, 0, 0, 0, 0 },
/* U+f799 */ { 0, 0, 0, 0, 0 },
/* U+f79a */ { 0, 0, 0, 0, 0 },
/* U+f79b */ { 0, 0, 0, 0, 0 },
/* U+f79c */ { 0, 0, 0, 0, 0 },
/* U+f79d */ { 0, 0, 0, 0, 0 },
/* U+f79e */ { 0, 0, 0, 0, 0 },
/* U+f79f */ { 0, 0, 0, 0, 0 },
/* U+f7a0 */ { 0, 0, 0, 0, 0 },
/* U+f7a1 */ { 0, 0, 0, 0, 0 },
/* U+f7a2 */ { 0, 0, 0, 0, 0 },
/* U+f7a3 */ { 0, 0, 0, 0, 0 },
/* U+f7a4 */ { 0, 0, 0, 0, 0 },
/* U+f7a5 */ { 0, 0, 0, 0, 0 },
/* U+f7a6 */ { 0, 0, 0, 0, 0 },
/* U+f7a7 */ { 0, 0, 0, 0, 0 },
/* U+f7a8 */ { 0, 0, 0, 0, 0 },
/* U+f7a9 */ { 0, 0, 0, 0, 0 },
/* U+f7aa */ { 0, 0, 0, 0, 0 },
/* U+f7ab */ { 0, 0, 0, 0, 0 },
/* U+f7ac */ { 0, 0, 0, 0, 0 },
/* U+f7ad */ { 0, 0, 0, 0, 0 },
/* U+f7ae */ { 0, 0, 0, 0, 0 },
/* U+f7af */ { 0, 0, 0, 0, 0 },
/* U+f7b0 */ { 0, 0, 0, 0, 0 },
/* U+f7b1 */ { 0, 0, 0, 0, 0 },
/* U+f7b2 */ { 0, 0, 0, 0, 0 },
/* U+f7b3 */ { 0, 0, 0, 0, 0 },
/* U+f7b4 */ { 0, 0, 0, 0, 0 },
/* U+f7b5 */ { 0, 0, 0, 0, 0 },
/* U+f7b6 */ { 0, 0, 0, 0, 0 },
/* U+f7b7 */ { 0, 0, 0, 0, 0 },
/* U+f7b8 */ { 0, 0, 0, 0, 0 },
/* U+f7b9 */ { 0, 0, 0, 0, 0 },
/* U+f7ba */ { 0, 0, 0, 0, 0 },
/* U+f7bb */ { 0, 0, 0, 0, 0 },
/* U+f7bc */ { 0, 0, 0, 0, 0 },
/* U+f7bd */ { 0, 0, 0, 0, 0 },
/* U+f7be */ { 0, 0, 0, 0, 0 },
/* U+f7bf */ { 0, 0, 0, 0, 0 },
/* U+f7c0 */ { 0, 0, 0, 0, 0 },
/* U+f7c1 */ { 0, 0, 0, 0, 0 },
/* U+f7c2 */ { 0, 0, 0, 0, 0 },
/* U+f7c3 */ { 0, 0, 0, 0, 0 },
/* U+f7c4 */ { 0, 0, 0, 0, 0 },
/* U+f7c5 */ { 0, 0, 0, 0, 0 },
/* U+f7c6 */ { 0, 0, 0, 0, 0 },
/* U+f7c7 */ { 0, 0, 0, 0, 0 },
/* U+f7c8 */ { 0, 0, 0, 0, 0 },
/* U+f7c9 */ { 0, 0, 0, 0, 0 },
/* U+f7ca */ { 0, 0, 0, 0, 0 },
/* U+f7cb */ { 0, 0, 0, 0, 0 },
/* U+f7cc */ { 0, 0, 0, 0, 0 },
/* U+f7cd */ { 0, 0, 0, 0, 0 },
/* U+f7ce */ { 0, 0, 0, 0, 0 },
/* U+f7cf */ { 0, 0, 0, 0, 0 },
/* U+f7d0 */ { 0, 0, 0, 0, 0 },
/* U+f7d1 */ { 0, 0, 0, 0, 0 },
/* U+f7d2 */ { 0, 0, 0, 0, 0 },
/* U+f7d3 */ { 0, 0, 0, 0, 0 },
/* U+f7d4 */ { 0, 0, 0, 0, 0 },
/* U+f7d5 */ { 0, 0, 0, 0, 0 },
/* U+f7d6 */ { 0, 0, 0, 0, 0 },
/* U+f7d7 */ { 0, 0, 0, 0, 0 },
/* U+f7d8 */ { 0, 0, 0, 0, 0 },
/* U+f7d9 */ { 0, 0, 0, 0, 0 },
/* U+f7da */ { 0, 0, 0, 0, 0 },
/* U+f7db */ { 0, 0, 0, 0, 0 },
/* U+f7dc */ { 0, 0, 0, 0, 0 },
/* U+f7dd */ { 0, 0, 0, 0, 0 },
/* U+f7de */ { 0, 0, 0, 0, 0 },
/* U+f7df */ { 0, 0, 0, 0, 0 },
/* U+f7e0 */ { 0, 0, 0, 0, 0 },
/* U+f7e1 */ { 0, 0, 0, 0, 0 },
/* U+f7e2 */ { 0, 0, 0, 0, 0 },
/* U+f7e3 */ { 0, 0, 0, 0, 0 },
/* U+f7e4 */ { 0, 0, 0, 0, 0 },
/* U+f7e5 */ { 0, 0, 0, 0, 0 },
/* U+f7e6 */ { 0, 0, 0, 0, 0 },
/* U+f7e7 */ { 0, 0, 0, 0, 0 },
/* U+f7e8 */ { 0, 0, 0, 0, 0 },
/* U+f7e9 */ { 0, 0, 0, 0, 0 },
/* U+f7ea */ { 0, 0, 0, 0, 0 },
/* U+f7eb */ { 0, 0, 0, 0, 0 },
/* U+f7ec */ { 0, 0, 0, 0, 0 },
/* U+f7ed */ { 0, 0, 0, 0, 0 },
/* U+f7ee */ { 0, 0, 0, 0, 0 },
/* U+f7ef */ { 0, 0, 0, 0, 0 },
/* U+f7f0 */ { 0, 0, 0, 0, 0 },
/* U+f7f1 */ { 0, 0, 0, 0, 0 },
/* U+f7f2 */ { 0, 0, 0, 0, 0 },
/* U+f7f3 */ { 0, 0, 0, 0, 0 },
/* U+f7f4 */ { 0, 0, 0, 0, 0 },
/* U+f7f5 */ { 0, 0, 0, 0, 0 },
/* U+f7f6 */ { 0, 0, 0, 0, 0 },
/* U+f7f7 */ { 0, 0, 0, 0, 0 },
/* U+f7f8 */ { 0, 0, 0, 0, 0 },
/* U+f7f9 */ { 0, 0, 0, 0, 0 },
/* U+f7fa */ { 0, 0, 0, 0, 0 },
/* U+f7fb */ { 0, 0, 0, 0, 0 },
/* U+f7fc */ { 0, 0, 0, 0, 0 },
/* U+f7fd */ { 0, 0, 0, 0, 0 },
/* U+f7fe */ { 0, 0, 0, 0, 0 },
/* U+f7ff */ { 0, 0, 0, 0, 0 },
/* U+f800 */ { 0, 0, 0, 0, 0 },
/* U+f801 */ { 0, 0, 0, 0, 0 },
/* U+f802 */ { 0, 0, 0, 0, 0 },
/* U+f803 */ { 0, 0, 0, 0, 0 },
/* U+f804 */ { 0, 0, 0, 0, 0 },
/* U+f805 */ { 0, 0, 0, 0, 0 },
/* U+f806 */ { 0, 0, 0, 0, 0 },
/* U+f807 */ { 0, 0, 0, 0, 0 },
/* U+f808 */ { 0, 0, 0, 0, 0 },
/* U+f809 */ { 0, 0, 0, 0, 0 },
/* U+f80a */ { 0, 0, 0, 0, 0 },
/* U+f80b */ { 0, 0, 0, 0, 0 },
/* U+f80c */ { 0, 0, 0, 0, 0 },
/* U+f80d */ { 0, 0, 0, 0, 0 },
/* U+f80e */ { 0, 0, 0, 0, 0 },
/* U+f80f */ { 0, 0, 0, 0, 0 },
/* U+f810 */ { 0, 0, 0, 0, 0 },
/* U+f811 */ { 0, 0, 0, 0, 0 },
/* U+f812 */ { 0, 0, 0, 0, 0 },
/* U+f813 */ { 0, 0, 0, 0, 0 },
/* U+f814 */ { 0, 0, 0, 0, 0 },
/* U+f815 */ { 0, 0, 0, 0, 0 },
/* U+f816 */ { 0, 0, 0, 0, 0 },
/* U+f817 */ { 0, 0, 0, 0, 0 },
/* U+f818 */ { 0, 0, 0, 0, 0 },
/* U+f819 */ { 0, 0, 0, 0, 0 },
/* U+f81a */ { 0, 0, 0, 0, 0 },
/* U+f81b */ { 0, 0, 0, 0, 0 },
/* U+f81c */ { 0, 0, 0, 0, 0 },
/* U+f81d */ { 0, 0, 0, 0, 0 },
/* U+f81e */ { 0, 0, 0, 0, 0 },
/* U+f81f */ { 0, 0, 0, 0, 0 },
/* U+f820 */ { 0, 0, 0, 0, 0 },
/* U+f821 */ { 0, 0, 0, 0, 0 },
/* U+f822 */ { 0, 0, 0, 0, 0 },
/* U+f823 */ { 0, 0, 0, 0, 0 },
/* U+f824 */ { 0, 0, 0, 0, 0 },
/* U+f825 */ { 0, 0, 0, 0, 0 },
/* U+f826 */ { 0, 0, 0, 0, 0 },
/* U+f827 */ { 0, 0, 0, 0, 0 },
/* U+f828 */ { 0, 0, 0, 0, 0 },
/* U+f829 */ { 0, 0, 0, 0, 0 },
/* U+f82a */ { 0, 0, 0, 0, 0 },
/* U+f82b */ { 0, 0, 0, 0, 0 },
/* U+f82c */ { 0, 0, 0, 0, 0 },
/* U+f82d */ { 0, 0, 0, 0, 0 },
/* U+f82e */ { 0, 0, 0, 0, 0 },
/* U+f82f */ { 0, 0, 0, 0, 0 },
/* U+f830 */ { 0, 0, 0, 0, 0 },
/* U+f831 */ { 0, 0, 0, 0, 0 },
/* U+f832 */ { 0, 0, 0, 0, 0 },
/* U+f833 */ { 0, 0, 0, 0, 0 },
/* U+f834 */ { 0, 0, 0, 0, 0 },
/* U+f835 */ { 0, 0, 0, 0, 0 },
/* U+f836 */ { 0, 0, 0, 0, 0 },
/* U+f837 */ { 0, 0, 0, 0, 0 },
/* U+f838 */ { 0, 0, 0, 0, 0 },
/* U+f839 */ { 0, 0, 0, 0, 0 },
/* U+f83a */ { 0, 0, 0, 0, 0 },
/* U+f83b */ { 0, 0, 0, 0, 0 },
/* U+f83c */ { 0, 0, 0, 0, 0 },
/* U+f83d */ { 0, 0, 0, 0, 0 },
/* U+f83e */ { 0, 0, 0, 0, 0 },
/* U+f83f */ { 0, 0, 0, 0, 0 },
/* U+f840 */ { 0, 0, 0, 0, 0 },
/* U+f841 */ { 0, 0, 0, 0, 0 },
/* U+f842 */ { 0, 0, 0, 0, 0 },
/* U+f843 */ { 0, 0, 0, 0, 0 },
/* U+f844 */ { 0, 0, 0, 0, 0 },
/* U+f845 */ { 0, 0, 0, 0, 0 },
/* U+f846 */ { 0, 0, 0, 0, 0 },
/* U+f847 */ { 0, 0, 0, 0, 0 },
/* U+f848 */ { 0, 0, 0, 0, 0 },
/* U+f849 */ { 0, 0, 0, 0, 0 },
/* U+f84a */ { 0, 0, 0, 0, 0 },
/* U+f84b */ { 0, 0, 0, 0, 0 },
/* U+f84c */ { 0, 0, 0, 0, 0 },
/* U+f84d */ { 0, 0, 0, 0, 0 },
/* U+f84e */ { 0, 0, 0, 0, 0 },
/* U+f84f */ { 0, 0, 0, 0, 0 },
/* U+f850 */ { 0, 0, 0, 0, 0 },
/* U+f851 */ { 0, 0, 0, 0, 0 },
/* U+f852 */ { 0, 0, 0, 0, 0 },
/* U+f853 */ { 0, 0, 0, 0, 0 },
/* U+f854 */ { 0, 0, 0, 0, 0 },
/* U+f855 */ { 0, 0, 0, 0, 0 },
/* U+f856 */ { 0, 0, 0, 0, 0 },
/* U+f857 */ { 0, 0, 0, 0, 0 },
/* U+f858 */ { 0, 0, 0, 0, 0 },
/* U+f859 */ { 0, 0, 0, 0, 0 },
/* U+f85a */ { 0, 0, 0, 0, 0 },
/* U+f85b */ { 0, 0, 0, 0, 0 },
/* U+f85c */ { 0, 0, 0, 0, 0 },
/* U+f85d */ { 0, 0, 0, 0, 0 },
/* U+f85e */ { 0, 0, 0, 0, 0 },
/* U+f85f */ { 0, 0, 0, 0, 0 },
/* U+f860 */ { 0, 0, 0, 0, 0 },
/* U+f861 */ { 0, 0, 0, 0, 0 },
/* U+f862 */ { 0, 0, 0, 0, 0 },
/* U+f863 */ { 0, 0, 0, 0, 0 },
/* U+f864 */ { 0, 0, 0, 0, 0 },
/* U+f865 */ { 0, 0, 0, 0, 0 },
/* U+f866 */ { 0, 0, 0, 0, 0 },
/* U+f867 */ { 0, 0, 0, 0, 0 },
/* U+f868 */ { 0, 0, 0, 0, 0 },
/* U+f869 */ { 0, 0, 0, 0, 0 },
/* U+f86a */ { 0, 0, 0, 0, 0 },
/* U+f86b */ { 0, 0, 0, 0, 0 },
/* U+f86c */ { 0, 0, 0, 0, 0 },
/* U+f86d */ { 0, 0, 0, 0, 0 },
/* U+f86e */ { 0, 0, 0, 0, 0 },
/* U+f86f */ { 0, 0, 0, 0, 0 },
/* U+f870 */ { 0, 0, 0, 0, 0 },
/* U+f871 */ { 0, 0, 0, 0, 0 },
/* U+f872 */ { 0, 0, 0, 0, 0 },
/* U+f873 */ { 0, 0, 0, 0, 0 },
/* U+f874 */ { 0, 0, 0, 0, 0 },
/* U+f875 */ { 0, 0, 0, 0, 0 },
/* U+f876 */ { 0, 0, 0, 0, 0 },
/* U+f877 */ { 0, 0, 0, 0, 0 },
/* U+f878 */ { 0, 0, 0, 0, 0 },
/* U+f879 */ { 0, 0, 0, 0, 0 },
/* U+f87a */ { 0, 0, 0, 0, 0 },
/* U+f87b */ { 0, 0, 0, 0, 0 },
/* U+f87c */ { 0, 0, 0, 0, 0 },
/* U+f87d */ { 0, 0, 0, 0, 0 },
/* U+f87e */ { 0, 0, 0, 0, 0 },
/* U+f87f */ { 0, 0, 0, 0, 0 },
/* U+f880 */ { 0, 0, 0, 0, 0 },
/* U+f881 */ { 0, 0, 0, 0, 0 },
/* U+f882 */ { 0, 0, 0, 0, 0 },
/* U+f883 */ { 0, 0, 0, 0, 0 },
/* U+f884 */ { 0, 0, 0, 0, 0 },
/* U+f885 */ { 0, 0, 0, 0, 0 },
/* U+f886 */ { 0, 0, 0, 0, 0 },
/* U+f887 */ { 0, 0, 0, 0, 0 },
/* U+f888 */ { 0, 0, 0, 0, 0 },
/* U+f889 */ { 0, 0, 0, 0, 0 },
/* U+f88a */ { 0, 0, 0, 0, 0 },
/* U+f88b */ { 0, 0, 0, 0, 0 },
/* U+f88c */ { 0, 0, 0, 0, 0 },
/* U+f88d */ { 0, 0, 0, 0, 0 },
/* U+f88e */ { 0, 0, 0, 0, 0 },
/* U+f88f */ { 0, 0, 0, 0, 0 },
/* U+f890 */ { 0, 0, 0, 0, 0 },
/* U+f891 */ { 0, 0, 0, 0, 0 },
/* U+f892 */ { 0, 0, 0, 0, 0 },
/* U+f893 */ { 0, 0, 0, 0, 0 },
/* U+f894 */ { 0, 0, 0, 0, 0 },
/* U+f895 */ { 0, 0, 0, 0, 0 },
/* U+f896 */ { 0, 0, 0, 0, 0 },
/* U+f897 */ { 0, 0, 0, 0, 0 },
/* U+f898 */ { 0, 0, 0, 0, 0 },
/* U+f899 */ { 0, 0, 0, 0, 0 },
/* U+f89a */ { 0, 0, 0, 0, 0 },
/* U+f89b */ { 0, 0, 0, 0, 0 },
/* U+f89c */ { 0, 0, 0, 0, 0 },
/* U+f89d */ { 0, 0, 0, 0, 0 },
/* U+f89e */ { 0, 0, 0, 0, 0 },
/* U+f89f */ { 0, 0, 0, 0, 0 },
/* U+f8a0 */ { 0, 0, 0, 0, 0 },
/* U+f8a1 */ { 0, 0, 0, 0, 0 },
/* U+f8a2 */ { 0, 0, 0, 0, 0 },
/* U+f8a3 */ { 0, 0, 0, 0, 0 },
/* U+f8a4 */ { 0, 0, 0, 0, 0 },
/* U+f8a5 */ { 0, 0, 0, 0, 0 },
/* U+f8a6 */ { 0, 0, 0, 0, 0 },
/* U+f8a7 */ { 0, 0, 0, 0, 0 },
/* U+f8a8 */ { 0, 0, 0, 0, 0 },
/* U+f8a9 */ { 0, 0, 0, 0, 0 },
/* U+f8aa */ { 0, 0, 0, 0, 0 },
/* U+f8ab */ { 0, 0, 0, 0, 0 },
/* U+f8ac */ { 0, 0, 0, 0, 0 },
/* U+f8ad */ { 0, 0, 0, 0, 0 },
/* U+f8ae */ { 0, 0, 0, 0, 0 },
/* U+f8af */ { 0, 0, 0, 0, 0 },
/* U+f8b0 */ { 0, 0, 0, 0, 0 },
/* U+f8b1 */ { 0, 0, 0, 0, 0 },
/* U+f8b2 */ { 0, 0, 0, 0, 0 },
/* U+f8b3 */ { 0, 0, 0, 0, 0 },
/* U+f8b4 */ { 0, 0, 0, 0, 0 },
/* U+f8b5 */ { 0, 0, 0, 0, 0 },
/* U+f8b6 */ { 0, 0, 0, 0, 0 },
/* U+f8b7 */ { 0, 0, 0, 0, 0 },
/* U+f8b8 */ { 0, 0, 0, 0, 0 },
/* U+f8b9 */ { 0, 0, 0, 0, 0 },
/* U+f8ba */ { 0, 0, 0, 0, 0 },
/* U+f8bb */ { 0, 0, 0, 0, 0 },
/* U+f8bc */ { 0, 0, 0, 0, 0 },
/* U+f8bd */ { 0, 0, 0, 0, 0 },
/* U+f8be */ { 0, 0, 0, 0, 0 },
/* U+f8bf */ { 0, 0, 0, 0, 0 },
/* U+f8c0 */ { 0, 0, 0, 0, 0 },
/* U+f8c1 */ { 0, 0, 0, 0, 0 },
/* U+f8c2 */ { 0, 0, 0, 0, 0 },
/* U+f8c3 */ { 0, 0, 0, 0, 0 },
/* U+f8c4 */ { 0, 0, 0, 0, 0 },
/* U+f8c5 */ { 0, 0, 0, 0, 0 },
/* U+f8c6 */ { 0, 0, 0, 0, 0 },
/* U+f8c7 */ { 0, 0, 0, 0, 0 },
/* U+f8c8 */ { 0, 0, 0, 0, 0 },
/* U+f8c9 */ { 0, 0, 0, 0, 0 },
/* U+f8ca */ { 0, 0, 0, 0, 0 },
/* U+f8cb */ { 0, 0, 0, 0, 0 },
/* U+f8cc */ { 0, 0, 0, 0, 0 },
/* U+f8cd */ { 0, 0, 0, 0, 0 },
/* U+f8ce */ { 0, 0, 0, 0, 0 },
/* U+f8cf */ { 0, 0, 0, 0, 0 },
/* U+f8d0 */ { 0, 0, 0, 0, 0 },
/* U+f8d1 */ { 0, 0, 0, 0, 0 },
/* U+f8d2 */ { 0, 0, 0, 0, 0 },
/* U+f8d3 */ { 0, 0, 0, 0, 0 },
/* U+f8d4 */ { 0, 0, 0, 0, 0 },
/* U+f8d5 */ { 0, 0, 0, 0, 0 },
/* U+f8d6 */ { 0, 0, 0, 0, 0 },
/* U+f8d7 */ { 0, 0, 0, 0, 0 },
/* U+f8d8 */ { 0, 0, 0, 0, 0 },
/* U+f8d9 */ { 0, 0, 0, 0, 0 },
/* U+f8da */ { 0, 0, 0, 0, 0 },
/* U+f8db */ { 0, 0, 0, 0, 0 },
/* U+f8dc */ { 0, 0, 0, 0, 0 },
/* U+f8dd */ { 0, 0, 0, 0, 0 },
/* U+f8de */ { 0, 0, 0, 0, 0 },
/* U+f8df */ { 0, 0, 0, 0, 0 },
/* U+f8e0 */ { 0, 0, 0, 0, 0 },
/* U+f8e1 */ { 0, 0, 0, 0, 0 },
/* U+f8e2 */ { 0, 0, 0, 0, 0 },
/* U+f8e3 */ { 0, 0, 0, 0, 0 },
/* U+f8e4 */ { 0, 0, 0, 0, 0 },
/* U+f8e5 */ { 0, 0, 0, 0, 0 },
/* U+f8e6 */ { 0, 0, 0, 0, 0 },
/* U+f8e7 */ { 0, 0, 0, 0, 0 },
/* U+f8e8 */ { 0, 0, 0, 0, 0 },
/* U+f8e9 */ { 0, 0, 0, 0, 0 },
/* U+f8ea */ { 0, 0, 0, 0, 0 },
/* U+f8eb */ { 0, 0, 0, 0, 0 },
/* U+f8ec */ { 0, 0, 0, 0, 0 },
/* U+f8ed */ { 0, 0, 0, 0, 0 },
/* U+f8ee */ { 0, 0, 0, 0, 0 },
/* U+f8ef */ { 0, 0, 0, 0, 0 },
/* U+f8f0 */ { 0, 0, 0, 0, 0 },
/* U+f8f1 */ { 0, 0, 0, 0, 0 },
/* U+f8f2 */ { 0, 0, 0, 0, 0 },
/* U+f8f3 */ { 0, 0, 0, 0, 0 },
/* U+f8f4 */ { 0, 0, 0, 0, 0 },
/* U+f8f5 */ { 0, 0, 0, 0, 0 },
/* U+f8f6 */ { 0, 0, 0, 0, 0 },
/* U+f8f7 */ { 0, 0, 0, 0, 0 },
/* U+f8f8 */ { 0, 0, 0, 0, 0 },
/* U+f8f9 */ { 0, 0, 0, 0, 0 },
/* U+f8fa */ { 0, 0, 0, 0, 0 },
/* U+f8fb */ { 0, 0, 0, 0, 0 },
/* U+f8fc */ { 0, 0, 0, 0, 0 },
/* U+f8fd */ { 0, 0, 0, 0, 0 },
/* U+f8fe */ { 0, 0, 0, 0, 0 },
/* U+f8ff */ { 16, 0, 1, 0, 0 },
/* U+f900 */ { 19, 0, 1, 0, "8C48" },
/* U+f901 */ { 19, 0, 1, 0, "66F4" },
/* U+f902 */ { 19, 0, 1, 0, "8ECA" },
/* U+f903 */ { 19, 0, 1, 0, "8CC8" },
/* U+f904 */ { 19, 0, 1, 0, "6ED1" },
/* U+f905 */ { 19, 0, 1, 0, "4E32" },
/* U+f906 */ { 19, 0, 1, 0, "53E5" },
/* U+f907 */ { 19, 0, 1, 0, "9F9C" },
/* U+f908 */ { 19, 0, 1, 0, "9F9C" },
/* U+f909 */ { 19, 0, 1, 0, "5951" },
/* U+f90a */ { 19, 0, 1, 0, "91D1" },
/* U+f90b */ { 19, 0, 1, 0, "5587" },
/* U+f90c */ { 19, 0, 1, 0, "5948" },
/* U+f90d */ { 19, 0, 1, 0, "61F6" },
/* U+f90e */ { 19, 0, 1, 0, "7669" },
/* U+f90f */ { 19, 0, 1, 0, "7F85" },
/* U+f910 */ { 19, 0, 1, 0, "863F" },
/* U+f911 */ { 19, 0, 1, 0, "87BA" },
/* U+f912 */ { 19, 0, 1, 0, "88F8" },
/* U+f913 */ { 19, 0, 1, 0, "908F" },
/* U+f914 */ { 19, 0, 1, 0, "6A02" },
/* U+f915 */ { 19, 0, 1, 0, "6D1B" },
/* U+f916 */ { 19, 0, 1, 0, "70D9" },
/* U+f917 */ { 19, 0, 1, 0, "73DE" },
/* U+f918 */ { 19, 0, 1, 0, "843D" },
/* U+f919 */ { 19, 0, 1, 0, "916A" },
/* U+f91a */ { 19, 0, 1, 0, "99F1" },
/* U+f91b */ { 19, 0, 1, 0, "4E82" },
/* U+f91c */ { 19, 0, 1, 0, "5375" },
/* U+f91d */ { 19, 0, 1, 0, "6B04" },
/* U+f91e */ { 19, 0, 1, 0, "721B" },
/* U+f91f */ { 19, 0, 1, 0, "862D" },
/* U+f920 */ { 19, 0, 1, 0, "9E1E" },
/* U+f921 */ { 19, 0, 1, 0, "5D50" },
/* U+f922 */ { 19, 0, 1, 0, "6FEB" },
/* U+f923 */ { 19, 0, 1, 0, "85CD" },
/* U+f924 */ { 19, 0, 1, 0, "8964" },
/* U+f925 */ { 19, 0, 1, 0, "62C9" },
/* U+f926 */ { 19, 0, 1, 0, "81D8" },
/* U+f927 */ { 19, 0, 1, 0, "881F" },
/* U+f928 */ { 19, 0, 1, 0, "5ECA" },
/* U+f929 */ { 19, 0, 1, 0, "6717" },
/* U+f92a */ { 19, 0, 1, 0, "6D6A" },
/* U+f92b */ { 19, 0, 1, 0, "72FC" },
/* U+f92c */ { 19, 0, 1, 0, "90CE" },
/* U+f92d */ { 19, 0, 1, 0, "4F86" },
/* U+f92e */ { 19, 0, 1, 0, "51B7" },
/* U+f92f */ { 19, 0, 1, 0, "52DE" },
/* U+f930 */ { 19, 0, 1, 0, "64C4" },
/* U+f931 */ { 19, 0, 1, 0, "6AD3" },
/* U+f932 */ { 19, 0, 1, 0, "7210" },
/* U+f933 */ { 19, 0, 1, 0, "76E7" },
/* U+f934 */ { 19, 0, 1, 0, "8001" },
/* U+f935 */ { 19, 0, 1, 0, "8606" },
/* U+f936 */ { 19, 0, 1, 0, "865C" },
/* U+f937 */ { 19, 0, 1, 0, "8DEF" },
/* U+f938 */ { 19, 0, 1, 0, "9732" },
/* U+f939 */ { 19, 0, 1, 0, "9B6F" },
/* U+f93a */ { 19, 0, 1, 0, "9DFA" },
/* U+f93b */ { 19, 0, 1, 0, "788C" },
/* U+f93c */ { 19, 0, 1, 0, "797F" },
/* U+f93d */ { 19, 0, 1, 0, "7DA0" },
/* U+f93e */ { 19, 0, 1, 0, "83C9" },
/* U+f93f */ { 19, 0, 1, 0, "9304" },
/* U+f940 */ { 19, 0, 1, 0, "9E7F" },
/* U+f941 */ { 19, 0, 1, 0, "8AD6" },
/* U+f942 */ { 19, 0, 1, 0, "58DF" },
/* U+f943 */ { 19, 0, 1, 0, "5F04" },
/* U+f944 */ { 19, 0, 1, 0, "7C60" },
/* U+f945 */ { 19, 0, 1, 0, "807E" },
/* U+f946 */ { 19, 0, 1, 0, "7262" },
/* U+f947 */ { 19, 0, 1, 0, "78CA" },
/* U+f948 */ { 19, 0, 1, 0, "8CC2" },
/* U+f949 */ { 19, 0, 1, 0, "96F7" },
/* U+f94a */ { 19, 0, 1, 0, "58D8" },
/* U+f94b */ { 19, 0, 1, 0, "5C62" },
/* U+f94c */ { 19, 0, 1, 0, "6A13" },
/* U+f94d */ { 19, 0, 1, 0, "6DDA" },
/* U+f94e */ { 19, 0, 1, 0, "6F0F" },
/* U+f94f */ { 19, 0, 1, 0, "7D2F" },
/* U+f950 */ { 19, 0, 1, 0, "7E37" },
/* U+f951 */ { 19, 0, 1, 0, "96FB" },
/* U+f952 */ { 19, 0, 1, 0, "52D2" },
/* U+f953 */ { 19, 0, 1, 0, "808B" },
/* U+f954 */ { 19, 0, 1, 0, "51DC" },
/* U+f955 */ { 19, 0, 1, 0, "51CC" },
/* U+f956 */ { 19, 0, 1, 0, "7A1C" },
/* U+f957 */ { 19, 0, 1, 0, "7DBE" },
/* U+f958 */ { 19, 0, 1, 0, "83F1" },
/* U+f959 */ { 19, 0, 1, 0, "9675" },
/* U+f95a */ { 19, 0, 1, 0, "8B80" },
/* U+f95b */ { 19, 0, 1, 0, "62CF" },
/* U+f95c */ { 19, 0, 1, 0, "6A02" },
/* U+f95d */ { 19, 0, 1, 0, "8AFE" },
/* U+f95e */ { 19, 0, 1, 0, "4E39" },
/* U+f95f */ { 19, 0, 1, 0, "5BE7" },
/* U+f960 */ { 19, 0, 1, 0, "6012" },
/* U+f961 */ { 19, 0, 1, 0, "7387" },
/* U+f962 */ { 19, 0, 1, 0, "7570" },
/* U+f963 */ { 19, 0, 1, 0, "5317" },
/* U+f964 */ { 19, 0, 1, 0, "78FB" },
/* U+f965 */ { 19, 0, 1, 0, "4FBF" },
/* U+f966 */ { 19, 0, 1, 0, "5FA9" },
/* U+f967 */ { 19, 0, 1, 0, "4E0D" },
/* U+f968 */ { 19, 0, 1, 0, "6CCC" },
/* U+f969 */ { 19, 0, 1, 0, "6578" },
/* U+f96a */ { 19, 0, 1, 0, "7D22" },
/* U+f96b */ { 19, 0, 1, 0, "53C3" },
/* U+f96c */ { 19, 0, 1, 0, "585E" },
/* U+f96d */ { 19, 0, 1, 0, "7701" },
/* U+f96e */ { 19, 0, 1, 0, "8449" },
/* U+f96f */ { 19, 0, 1, 0, "8AAA" },
/* U+f970 */ { 19, 0, 1, 0, "6BBA" },
/* U+f971 */ { 19, 0, 1, 0, "8FB0" },
/* U+f972 */ { 19, 0, 1, 0, "6C88" },
/* U+f973 */ { 19, 0, 1, 0, "62FE" },
/* U+f974 */ { 19, 0, 1, 0, "82E5" },
/* U+f975 */ { 19, 0, 1, 0, "63A0" },
/* U+f976 */ { 19, 0, 1, 0, "7565" },
/* U+f977 */ { 19, 0, 1, 0, "4EAE" },
/* U+f978 */ { 19, 0, 1, 0, "5169" },
/* U+f979 */ { 19, 0, 1, 0, "51C9" },
/* U+f97a */ { 19, 0, 1, 0, "6881" },
/* U+f97b */ { 19, 0, 1, 0, "7CE7" },
/* U+f97c */ { 19, 0, 1, 0, "826F" },
/* U+f97d */ { 19, 0, 1, 0, "8AD2" },
/* U+f97e */ { 19, 0, 1, 0, "91CF" },
/* U+f97f */ { 19, 0, 1, 0, "52F5" },
/* U+f980 */ { 19, 0, 1, 0, "5442" },
/* U+f981 */ { 19, 0, 1, 0, "5973" },
/* U+f982 */ { 19, 0, 1, 0, "5EEC" },
/* U+f983 */ { 19, 0, 1, 0, "65C5" },
/* U+f984 */ { 19, 0, 1, 0, "6FFE" },
/* U+f985 */ { 19, 0, 1, 0, "792A" },
/* U+f986 */ { 19, 0, 1, 0, "95AD" },
/* U+f987 */ { 19, 0, 1, 0, "9A6A" },
/* U+f988 */ { 19, 0, 1, 0, "9E97" },
/* U+f989 */ { 19, 0, 1, 0, "9ECE" },
/* U+f98a */ { 19, 0, 1, 0, "529B" },
/* U+f98b */ { 19, 0, 1, 0, "66C6" },
/* U+f98c */ { 19, 0, 1, 0, "6B77" },
/* U+f98d */ { 19, 0, 1, 0, "8F62" },
/* U+f98e */ { 19, 0, 1, 0, "5E74" },
/* U+f98f */ { 19, 0, 1, 0, "6190" },
/* U+f990 */ { 19, 0, 1, 0, "6200" },
/* U+f991 */ { 19, 0, 1, 0, "649A" },
/* U+f992 */ { 19, 0, 1, 0, "6F23" },
/* U+f993 */ { 19, 0, 1, 0, "7149" },
/* U+f994 */ { 19, 0, 1, 0, "7489" },
/* U+f995 */ { 19, 0, 1, 0, "79CA" },
/* U+f996 */ { 19, 0, 1, 0, "7DF4" },
/* U+f997 */ { 19, 0, 1, 0, "806F" },
/* U+f998 */ { 19, 0, 1, 0, "8F26" },
/* U+f999 */ { 19, 0, 1, 0, "84EE" },
/* U+f99a */ { 19, 0, 1, 0, "9023" },
/* U+f99b */ { 19, 0, 1, 0, "934A" },
/* U+f99c */ { 19, 0, 1, 0, "5217" },
/* U+f99d */ { 19, 0, 1, 0, "52A3" },
/* U+f99e */ { 19, 0, 1, 0, "54BD" },
/* U+f99f */ { 19, 0, 1, 0, "70C8" },
/* U+f9a0 */ { 19, 0, 1, 0, "88C2" },
/* U+f9a1 */ { 19, 0, 1, 0, "8AAA" },
/* U+f9a2 */ { 19, 0, 1, 0, "5EC9" },
/* U+f9a3 */ { 19, 0, 1, 0, "5FF5" },
/* U+f9a4 */ { 19, 0, 1, 0, "637B" },
/* U+f9a5 */ { 19, 0, 1, 0, "6BAE" },
/* U+f9a6 */ { 19, 0, 1, 0, "7C3E" },
/* U+f9a7 */ { 19, 0, 1, 0, "7375" },
/* U+f9a8 */ { 19, 0, 1, 0, "4EE4" },
/* U+f9a9 */ { 19, 0, 1, 0, "56F9" },
/* U+f9aa */ { 19, 0, 1, 0, "5BE7" },
/* U+f9ab */ { 19, 0, 1, 0, "5DBA" },
/* U+f9ac */ { 19, 0, 1, 0, "601C" },
/* U+f9ad */ { 19, 0, 1, 0, "73B2" },
/* U+f9ae */ { 19, 0, 1, 0, "7469" },
/* U+f9af */ { 19, 0, 1, 0, "7F9A" },
/* U+f9b0 */ { 19, 0, 1, 0, "8046" },
/* U+f9b1 */ { 19, 0, 1, 0, "9234" },
/* U+f9b2 */ { 19, 0, 1, 0, "96F6" },
/* U+f9b3 */ { 19, 0, 1, 0, "9748" },
/* U+f9b4 */ { 19, 0, 1, 0, "9818" },
/* U+f9b5 */ { 19, 0, 1, 0, "4F8B" },
/* U+f9b6 */ { 19, 0, 1, 0, "79AE" },
/* U+f9b7 */ { 19, 0, 1, 0, "91B4" },
/* U+f9b8 */ { 19, 0, 1, 0, "96B8" },
/* U+f9b9 */ { 19, 0, 1, 0, "60E1" },
/* U+f9ba */ { 19, 0, 1, 0, "4E86" },
/* U+f9bb */ { 19, 0, 1, 0, "50DA" },
/* U+f9bc */ { 19, 0, 1, 0, "5BEE" },
/* U+f9bd */ { 19, 0, 1, 0, "5C3F" },
/* U+f9be */ { 19, 0, 1, 0, "6599" },
/* U+f9bf */ { 19, 0, 1, 0, "6A02" },
/* U+f9c0 */ { 19, 0, 1, 0, "71CE" },
/* U+f9c1 */ { 19, 0, 1, 0, "7642" },
/* U+f9c2 */ { 19, 0, 1, 0, "84FC" },
/* U+f9c3 */ { 19, 0, 1, 0, "907C" },
/* U+f9c4 */ { 19, 0, 1, 0, "9F8D" },
/* U+f9c5 */ { 19, 0, 1, 0, "6688" },
/* U+f9c6 */ { 19, 0, 1, 0, "962E" },
/* U+f9c7 */ { 19, 0, 1, 0, "5289" },
/* U+f9c8 */ { 19, 0, 1, 0, "677B" },
/* U+f9c9 */ { 19, 0, 1, 0, "67F3" },
/* U+f9ca */ { 19, 0, 1, 0, "6D41" },
/* U+f9cb */ { 19, 0, 1, 0, "6E9C" },
/* U+f9cc */ { 19, 0, 1, 0, "7409" },
/* U+f9cd */ { 19, 0, 1, 0, "7559" },
/* U+f9ce */ { 19, 0, 1, 0, "786B" },
/* U+f9cf */ { 19, 0, 1, 0, "7D10" },
/* U+f9d0 */ { 19, 0, 1, 0, "985E" },
/* U+f9d1 */ { 19, 0, 1, 0, "516D" },
/* U+f9d2 */ { 19, 0, 1, 0, "622E" },
/* U+f9d3 */ { 19, 0, 1, 0, "9678" },
/* U+f9d4 */ { 19, 0, 1, 0, "502B" },
/* U+f9d5 */ { 19, 0, 1, 0, "5D19" },
/* U+f9d6 */ { 19, 0, 1, 0, "6DEA" },
/* U+f9d7 */ { 19, 0, 1, 0, "8F2A" },
/* U+f9d8 */ { 19, 0, 1, 0, "5F8B" },
/* U+f9d9 */ { 19, 0, 1, 0, "6144" },
/* U+f9da */ { 19, 0, 1, 0, "6817" },
/* U+f9db */ { 19, 0, 1, 0, "7387" },
/* U+f9dc */ { 19, 0, 1, 0, "9686" },
/* U+f9dd */ { 19, 0, 1, 0, "5229" },
/* U+f9de */ { 19, 0, 1, 0, "540F" },
/* U+f9df */ { 19, 0, 1, 0, "5C65" },
/* U+f9e0 */ { 19, 0, 1, 0, "6613" },
/* U+f9e1 */ { 19, 0, 1, 0, "674E" },
/* U+f9e2 */ { 19, 0, 1, 0, "68A8" },
/* U+f9e3 */ { 19, 0, 1, 0, "6CE5" },
/* U+f9e4 */ { 19, 0, 1, 0, "7406" },
/* U+f9e5 */ { 19, 0, 1, 0, "75E2" },
/* U+f9e6 */ { 19, 0, 1, 0, "7F79" },
/* U+f9e7 */ { 19, 0, 1, 0, "88CF" },
/* U+f9e8 */ { 19, 0, 1, 0, "88E1" },
/* U+f9e9 */ { 19, 0, 1, 0, "91CC" },
/* U+f9ea */ { 19, 0, 1, 0, "96E2" },
/* U+f9eb */ { 19, 0, 1, 0, "533F" },
/* U+f9ec */ { 19, 0, 1, 0, "6EBA" },
/* U+f9ed */ { 19, 0, 1, 0, "541D" },
/* U+f9ee */ { 19, 0, 1, 0, "71D0" },
/* U+f9ef */ { 19, 0, 1, 0, "7498" },
/* U+f9f0 */ { 19, 0, 1, 0, "85FA" },
/* U+f9f1 */ { 19, 0, 1, 0, "96A3" },
/* U+f9f2 */ { 19, 0, 1, 0, "9C57" },
/* U+f9f3 */ { 19, 0, 1, 0, "9E9F" },
/* U+f9f4 */ { 19, 0, 1, 0, "6797" },
/* U+f9f5 */ { 19, 0, 1, 0, "6DCB" },
/* U+f9f6 */ { 19, 0, 1, 0, "81E8" },
/* U+f9f7 */ { 19, 0, 1, 0, "7ACB" },
/* U+f9f8 */ { 19, 0, 1, 0, "7B20" },
/* U+f9f9 */ { 19, 0, 1, 0, "7C92" },
/* U+f9fa */ { 19, 0, 1, 0, "72C0" },
/* U+f9fb */ { 19, 0, 1, 0, "7099" },
/* U+f9fc */ { 19, 0, 1, 0, "8B58" },
/* U+f9fd */ { 19, 0, 1, 0, "4EC0" },
/* U+f9fe */ { 19, 0, 1, 0, "8336" },
/* U+f9ff */ { 19, 0, 1, 0, "523A" },
/* U+fa00 */ { 19, 0, 1, 0, "5207" },
/* U+fa01 */ { 19, 0, 1, 0, "5EA6" },
/* U+fa02 */ { 19, 0, 1, 0, "62D3" },
/* U+fa03 */ { 19, 0, 1, 0, "7CD6" },
/* U+fa04 */ { 19, 0, 1, 0, "5B85" },
/* U+fa05 */ { 19, 0, 1, 0, "6D1E" },
/* U+fa06 */ { 19, 0, 1, 0, "66B4" },
/* U+fa07 */ { 19, 0, 1, 0, "8F3B" },
/* U+fa08 */ { 19, 0, 1, 0, "884C" },
/* U+fa09 */ { 19, 0, 1, 0, "964D" },
/* U+fa0a */ { 19, 0, 1, 0, "898B" },
/* U+fa0b */ { 19, 0, 1, 0, "5ED3" },
/* U+fa0c */ { 19, 0, 1, 0, "5140" },
/* U+fa0d */ { 19, 0, 1, 0, "55C0" },
/* U+fa0e */ { 19, 0, 1, 0, 0 },
/* U+fa0f */ { 19, 0, 1, 0, 0 },
/* U+fa10 */ { 19, 0, 1, 0, "585A" },
/* U+fa11 */ { 19, 0, 1, 0, 0 },
/* U+fa12 */ { 19, 0, 1, 0, "6674" },
/* U+fa13 */ { 19, 0, 1, 0, 0 },
/* U+fa14 */ { 19, 0, 1, 0, 0 },
/* U+fa15 */ { 19, 0, 1, 0, "51DE" },
/* U+fa16 */ { 19, 0, 1, 0, "732A" },
/* U+fa17 */ { 19, 0, 1, 0, "76CA" },
/* U+fa18 */ { 19, 0, 1, 0, "793C" },
/* U+fa19 */ { 19, 0, 1, 0, "795E" },
/* U+fa1a */ { 19, 0, 1, 0, "7965" },
/* U+fa1b */ { 19, 0, 1, 0, "798F" },
/* U+fa1c */ { 19, 0, 1, 0, "9756" },
/* U+fa1d */ { 19, 0, 1, 0, "7CBE" },
/* U+fa1e */ { 19, 0, 1, 0, "7FBD" },
/* U+fa1f */ { 19, 0, 1, 0, 0 },
/* U+fa20 */ { 19, 0, 1, 0, "8612" },
/* U+fa21 */ { 19, 0, 1, 0, 0 },
/* U+fa22 */ { 19, 0, 1, 0, "8AF8" },
/* U+fa23 */ { 19, 0, 1, 0, 0 },
/* U+fa24 */ { 19, 0, 1, 0, 0 },
/* U+fa25 */ { 19, 0, 1, 0, "9038" },
/* U+fa26 */ { 19, 0, 1, 0, "90FD" },
/* U+fa27 */ { 19, 0, 1, 0, 0 },
/* U+fa28 */ { 19, 0, 1, 0, 0 },
/* U+fa29 */ { 19, 0, 1, 0, 0 },
/* U+fa2a */ { 19, 0, 1, 0, "98EF" },
/* U+fa2b */ { 19, 0, 1, 0, "98FC" },
/* U+fa2c */ { 19, 0, 1, 0, "9928" },
/* U+fa2d */ { 19, 0, 1, 0, "9DB4" },
/* U+fa2e */ { 0, 0, 0, 0, 0 },
/* U+fa2f */ { 0, 0, 0, 0, 0 },
/* U+fa30 */ { 0, 0, 0, 0, 0 },
/* U+fa31 */ { 0, 0, 0, 0, 0 },
/* U+fa32 */ { 0, 0, 0, 0, 0 },
/* U+fa33 */ { 0, 0, 0, 0, 0 },
/* U+fa34 */ { 0, 0, 0, 0, 0 },
/* U+fa35 */ { 0, 0, 0, 0, 0 },
/* U+fa36 */ { 0, 0, 0, 0, 0 },
/* U+fa37 */ { 0, 0, 0, 0, 0 },
/* U+fa38 */ { 0, 0, 0, 0, 0 },
/* U+fa39 */ { 0, 0, 0, 0, 0 },
/* U+fa3a */ { 0, 0, 0, 0, 0 },
/* U+fa3b */ { 0, 0, 0, 0, 0 },
/* U+fa3c */ { 0, 0, 0, 0, 0 },
/* U+fa3d */ { 0, 0, 0, 0, 0 },
/* U+fa3e */ { 0, 0, 0, 0, 0 },
/* U+fa3f */ { 0, 0, 0, 0, 0 },
/* U+fa40 */ { 0, 0, 0, 0, 0 },
/* U+fa41 */ { 0, 0, 0, 0, 0 },
/* U+fa42 */ { 0, 0, 0, 0, 0 },
/* U+fa43 */ { 0, 0, 0, 0, 0 },
/* U+fa44 */ { 0, 0, 0, 0, 0 },
/* U+fa45 */ { 0, 0, 0, 0, 0 },
/* U+fa46 */ { 0, 0, 0, 0, 0 },
/* U+fa47 */ { 0, 0, 0, 0, 0 },
/* U+fa48 */ { 0, 0, 0, 0, 0 },
/* U+fa49 */ { 0, 0, 0, 0, 0 },
/* U+fa4a */ { 0, 0, 0, 0, 0 },
/* U+fa4b */ { 0, 0, 0, 0, 0 },
/* U+fa4c */ { 0, 0, 0, 0, 0 },
/* U+fa4d */ { 0, 0, 0, 0, 0 },
/* U+fa4e */ { 0, 0, 0, 0, 0 },
/* U+fa4f */ { 0, 0, 0, 0, 0 },
/* U+fa50 */ { 0, 0, 0, 0, 0 },
/* U+fa51 */ { 0, 0, 0, 0, 0 },
/* U+fa52 */ { 0, 0, 0, 0, 0 },
/* U+fa53 */ { 0, 0, 0, 0, 0 },
/* U+fa54 */ { 0, 0, 0, 0, 0 },
/* U+fa55 */ { 0, 0, 0, 0, 0 },
/* U+fa56 */ { 0, 0, 0, 0, 0 },
/* U+fa57 */ { 0, 0, 0, 0, 0 },
/* U+fa58 */ { 0, 0, 0, 0, 0 },
/* U+fa59 */ { 0, 0, 0, 0, 0 },
/* U+fa5a */ { 0, 0, 0, 0, 0 },
/* U+fa5b */ { 0, 0, 0, 0, 0 },
/* U+fa5c */ { 0, 0, 0, 0, 0 },
/* U+fa5d */ { 0, 0, 0, 0, 0 },
/* U+fa5e */ { 0, 0, 0, 0, 0 },
/* U+fa5f */ { 0, 0, 0, 0, 0 },
/* U+fa60 */ { 0, 0, 0, 0, 0 },
/* U+fa61 */ { 0, 0, 0, 0, 0 },
/* U+fa62 */ { 0, 0, 0, 0, 0 },
/* U+fa63 */ { 0, 0, 0, 0, 0 },
/* U+fa64 */ { 0, 0, 0, 0, 0 },
/* U+fa65 */ { 0, 0, 0, 0, 0 },
/* U+fa66 */ { 0, 0, 0, 0, 0 },
/* U+fa67 */ { 0, 0, 0, 0, 0 },
/* U+fa68 */ { 0, 0, 0, 0, 0 },
/* U+fa69 */ { 0, 0, 0, 0, 0 },
/* U+fa6a */ { 0, 0, 0, 0, 0 },
/* U+fa6b */ { 0, 0, 0, 0, 0 },
/* U+fa6c */ { 0, 0, 0, 0, 0 },
/* U+fa6d */ { 0, 0, 0, 0, 0 },
/* U+fa6e */ { 0, 0, 0, 0, 0 },
/* U+fa6f */ { 0, 0, 0, 0, 0 },
/* U+fa70 */ { 0, 0, 0, 0, 0 },
/* U+fa71 */ { 0, 0, 0, 0, 0 },
/* U+fa72 */ { 0, 0, 0, 0, 0 },
/* U+fa73 */ { 0, 0, 0, 0, 0 },
/* U+fa74 */ { 0, 0, 0, 0, 0 },
/* U+fa75 */ { 0, 0, 0, 0, 0 },
/* U+fa76 */ { 0, 0, 0, 0, 0 },
/* U+fa77 */ { 0, 0, 0, 0, 0 },
/* U+fa78 */ { 0, 0, 0, 0, 0 },
/* U+fa79 */ { 0, 0, 0, 0, 0 },
/* U+fa7a */ { 0, 0, 0, 0, 0 },
/* U+fa7b */ { 0, 0, 0, 0, 0 },
/* U+fa7c */ { 0, 0, 0, 0, 0 },
/* U+fa7d */ { 0, 0, 0, 0, 0 },
/* U+fa7e */ { 0, 0, 0, 0, 0 },
/* U+fa7f */ { 0, 0, 0, 0, 0 },
/* U+fa80 */ { 0, 0, 0, 0, 0 },
/* U+fa81 */ { 0, 0, 0, 0, 0 },
/* U+fa82 */ { 0, 0, 0, 0, 0 },
/* U+fa83 */ { 0, 0, 0, 0, 0 },
/* U+fa84 */ { 0, 0, 0, 0, 0 },
/* U+fa85 */ { 0, 0, 0, 0, 0 },
/* U+fa86 */ { 0, 0, 0, 0, 0 },
/* U+fa87 */ { 0, 0, 0, 0, 0 },
/* U+fa88 */ { 0, 0, 0, 0, 0 },
/* U+fa89 */ { 0, 0, 0, 0, 0 },
/* U+fa8a */ { 0, 0, 0, 0, 0 },
/* U+fa8b */ { 0, 0, 0, 0, 0 },
/* U+fa8c */ { 0, 0, 0, 0, 0 },
/* U+fa8d */ { 0, 0, 0, 0, 0 },
/* U+fa8e */ { 0, 0, 0, 0, 0 },
/* U+fa8f */ { 0, 0, 0, 0, 0 },
/* U+fa90 */ { 0, 0, 0, 0, 0 },
/* U+fa91 */ { 0, 0, 0, 0, 0 },
/* U+fa92 */ { 0, 0, 0, 0, 0 },
/* U+fa93 */ { 0, 0, 0, 0, 0 },
/* U+fa94 */ { 0, 0, 0, 0, 0 },
/* U+fa95 */ { 0, 0, 0, 0, 0 },
/* U+fa96 */ { 0, 0, 0, 0, 0 },
/* U+fa97 */ { 0, 0, 0, 0, 0 },
/* U+fa98 */ { 0, 0, 0, 0, 0 },
/* U+fa99 */ { 0, 0, 0, 0, 0 },
/* U+fa9a */ { 0, 0, 0, 0, 0 },
/* U+fa9b */ { 0, 0, 0, 0, 0 },
/* U+fa9c */ { 0, 0, 0, 0, 0 },
/* U+fa9d */ { 0, 0, 0, 0, 0 },
/* U+fa9e */ { 0, 0, 0, 0, 0 },
/* U+fa9f */ { 0, 0, 0, 0, 0 },
/* U+faa0 */ { 0, 0, 0, 0, 0 },
/* U+faa1 */ { 0, 0, 0, 0, 0 },
/* U+faa2 */ { 0, 0, 0, 0, 0 },
/* U+faa3 */ { 0, 0, 0, 0, 0 },
/* U+faa4 */ { 0, 0, 0, 0, 0 },
/* U+faa5 */ { 0, 0, 0, 0, 0 },
/* U+faa6 */ { 0, 0, 0, 0, 0 },
/* U+faa7 */ { 0, 0, 0, 0, 0 },
/* U+faa8 */ { 0, 0, 0, 0, 0 },
/* U+faa9 */ { 0, 0, 0, 0, 0 },
/* U+faaa */ { 0, 0, 0, 0, 0 },
/* U+faab */ { 0, 0, 0, 0, 0 },
/* U+faac */ { 0, 0, 0, 0, 0 },
/* U+faad */ { 0, 0, 0, 0, 0 },
/* U+faae */ { 0, 0, 0, 0, 0 },
/* U+faaf */ { 0, 0, 0, 0, 0 },
/* U+fab0 */ { 0, 0, 0, 0, 0 },
/* U+fab1 */ { 0, 0, 0, 0, 0 },
/* U+fab2 */ { 0, 0, 0, 0, 0 },
/* U+fab3 */ { 0, 0, 0, 0, 0 },
/* U+fab4 */ { 0, 0, 0, 0, 0 },
/* U+fab5 */ { 0, 0, 0, 0, 0 },
/* U+fab6 */ { 0, 0, 0, 0, 0 },
/* U+fab7 */ { 0, 0, 0, 0, 0 },
/* U+fab8 */ { 0, 0, 0, 0, 0 },
/* U+fab9 */ { 0, 0, 0, 0, 0 },
/* U+faba */ { 0, 0, 0, 0, 0 },
/* U+fabb */ { 0, 0, 0, 0, 0 },
/* U+fabc */ { 0, 0, 0, 0, 0 },
/* U+fabd */ { 0, 0, 0, 0, 0 },
/* U+fabe */ { 0, 0, 0, 0, 0 },
/* U+fabf */ { 0, 0, 0, 0, 0 },
/* U+fac0 */ { 0, 0, 0, 0, 0 },
/* U+fac1 */ { 0, 0, 0, 0, 0 },
/* U+fac2 */ { 0, 0, 0, 0, 0 },
/* U+fac3 */ { 0, 0, 0, 0, 0 },
/* U+fac4 */ { 0, 0, 0, 0, 0 },
/* U+fac5 */ { 0, 0, 0, 0, 0 },
/* U+fac6 */ { 0, 0, 0, 0, 0 },
/* U+fac7 */ { 0, 0, 0, 0, 0 },
/* U+fac8 */ { 0, 0, 0, 0, 0 },
/* U+fac9 */ { 0, 0, 0, 0, 0 },
/* U+faca */ { 0, 0, 0, 0, 0 },
/* U+facb */ { 0, 0, 0, 0, 0 },
/* U+facc */ { 0, 0, 0, 0, 0 },
/* U+facd */ { 0, 0, 0, 0, 0 },
/* U+face */ { 0, 0, 0, 0, 0 },
/* U+facf */ { 0, 0, 0, 0, 0 },
/* U+fad0 */ { 0, 0, 0, 0, 0 },
/* U+fad1 */ { 0, 0, 0, 0, 0 },
/* U+fad2 */ { 0, 0, 0, 0, 0 },
/* U+fad3 */ { 0, 0, 0, 0, 0 },
/* U+fad4 */ { 0, 0, 0, 0, 0 },
/* U+fad5 */ { 0, 0, 0, 0, 0 },
/* U+fad6 */ { 0, 0, 0, 0, 0 },
/* U+fad7 */ { 0, 0, 0, 0, 0 },
/* U+fad8 */ { 0, 0, 0, 0, 0 },
/* U+fad9 */ { 0, 0, 0, 0, 0 },
/* U+fada */ { 0, 0, 0, 0, 0 },
/* U+fadb */ { 0, 0, 0, 0, 0 },
/* U+fadc */ { 0, 0, 0, 0, 0 },
/* U+fadd */ { 0, 0, 0, 0, 0 },
/* U+fade */ { 0, 0, 0, 0, 0 },
/* U+fadf */ { 0, 0, 0, 0, 0 },
/* U+fae0 */ { 0, 0, 0, 0, 0 },
/* U+fae1 */ { 0, 0, 0, 0, 0 },
/* U+fae2 */ { 0, 0, 0, 0, 0 },
/* U+fae3 */ { 0, 0, 0, 0, 0 },
/* U+fae4 */ { 0, 0, 0, 0, 0 },
/* U+fae5 */ { 0, 0, 0, 0, 0 },
/* U+fae6 */ { 0, 0, 0, 0, 0 },
/* U+fae7 */ { 0, 0, 0, 0, 0 },
/* U+fae8 */ { 0, 0, 0, 0, 0 },
/* U+fae9 */ { 0, 0, 0, 0, 0 },
/* U+faea */ { 0, 0, 0, 0, 0 },
/* U+faeb */ { 0, 0, 0, 0, 0 },
/* U+faec */ { 0, 0, 0, 0, 0 },
/* U+faed */ { 0, 0, 0, 0, 0 },
/* U+faee */ { 0, 0, 0, 0, 0 },
/* U+faef */ { 0, 0, 0, 0, 0 },
/* U+faf0 */ { 0, 0, 0, 0, 0 },
/* U+faf1 */ { 0, 0, 0, 0, 0 },
/* U+faf2 */ { 0, 0, 0, 0, 0 },
/* U+faf3 */ { 0, 0, 0, 0, 0 },
/* U+faf4 */ { 0, 0, 0, 0, 0 },
/* U+faf5 */ { 0, 0, 0, 0, 0 },
/* U+faf6 */ { 0, 0, 0, 0, 0 },
/* U+faf7 */ { 0, 0, 0, 0, 0 },
/* U+faf8 */ { 0, 0, 0, 0, 0 },
/* U+faf9 */ { 0, 0, 0, 0, 0 },
/* U+fafa */ { 0, 0, 0, 0, 0 },
/* U+fafb */ { 0, 0, 0, 0, 0 },
/* U+fafc */ { 0, 0, 0, 0, 0 },
/* U+fafd */ { 0, 0, 0, 0, 0 },
/* U+fafe */ { 0, 0, 0, 0, 0 },
/* U+faff */ { 0, 0, 0, 0, 0 },
/* U+fb00 */ { 2, 0, 1, 0, "<compat> 0066 0066" },
/* U+fb01 */ { 2, 0, 1, 0, "<compat> 0066 0069" },
/* U+fb02 */ { 2, 0, 1, 0, "<compat> 0066 006C" },
/* U+fb03 */ { 2, 0, 1, 0, "<compat> 0066 0066 0069" },
/* U+fb04 */ { 2, 0, 1, 0, "<compat> 0066 0066 006C" },
/* U+fb05 */ { 2, 0, 1, 0, "<compat> 017F 0074" },
/* U+fb06 */ { 2, 0, 1, 0, "<compat> 0073 0074" },
/* U+fb07 */ { 0, 0, 0, 0, 0 },
/* U+fb08 */ { 0, 0, 0, 0, 0 },
/* U+fb09 */ { 0, 0, 0, 0, 0 },
/* U+fb0a */ { 0, 0, 0, 0, 0 },
/* U+fb0b */ { 0, 0, 0, 0, 0 },
/* U+fb0c */ { 0, 0, 0, 0, 0 },
/* U+fb0d */ { 0, 0, 0, 0, 0 },
/* U+fb0e */ { 0, 0, 0, 0, 0 },
/* U+fb0f */ { 0, 0, 0, 0, 0 },
/* U+fb10 */ { 0, 0, 0, 0, 0 },
/* U+fb11 */ { 0, 0, 0, 0, 0 },
/* U+fb12 */ { 0, 0, 0, 0, 0 },
/* U+fb13 */ { 2, 0, 1, 0, "<compat> 0574 0576" },
/* U+fb14 */ { 2, 0, 1, 0, "<compat> 0574 0565" },
/* U+fb15 */ { 2, 0, 1, 0, "<compat> 0574 056B" },
/* U+fb16 */ { 2, 0, 1, 0, "<compat> 057E 0576" },
/* U+fb17 */ { 2, 0, 1, 0, "<compat> 0574 056D" },
/* U+fb18 */ { 0, 0, 0, 0, 0 },
/* U+fb19 */ { 0, 0, 0, 0, 0 },
/* U+fb1a */ { 0, 0, 0, 0, 0 },
/* U+fb1b */ { 0, 0, 0, 0, 0 },
/* U+fb1c */ { 0, 0, 0, 0, 0 },
/* U+fb1d */ { 19, 0, 4, 0, "05D9 05B4" },
/* U+fb1e */ { 4, 26, 14, 0, 0 },
/* U+fb1f */ { 19, 0, 4, 0, "05F2 05B7" },
/* U+fb20 */ { 19, 0, 4, 0, "<font> 05E2" },
/* U+fb21 */ { 19, 0, 4, 0, "<font> 05D0" },
/* U+fb22 */ { 19, 0, 4, 0, "<font> 05D3" },
/* U+fb23 */ { 19, 0, 4, 0, "<font> 05D4" },
/* U+fb24 */ { 19, 0, 4, 0, "<font> 05DB" },
/* U+fb25 */ { 19, 0, 4, 0, "<font> 05DC" },
/* U+fb26 */ { 19, 0, 4, 0, "<font> 05DD" },
/* U+fb27 */ { 19, 0, 4, 0, "<font> 05E8" },
/* U+fb28 */ { 19, 0, 4, 0, "<font> 05EA" },
/* U+fb29 */ { 27, 0, 11, 0, "<font> 002B" },
/* U+fb2a */ { 19, 0, 4, 0, "05E9 05C1" },
/* U+fb2b */ { 19, 0, 4, 0, "05E9 05C2" },
/* U+fb2c */ { 19, 0, 4, 0, "FB49 05C1" },
/* U+fb2d */ { 19, 0, 4, 0, "FB49 05C2" },
/* U+fb2e */ { 19, 0, 4, 0, "05D0 05B7" },
/* U+fb2f */ { 19, 0, 4, 0, "05D0 05B8" },
/* U+fb30 */ { 19, 0, 4, 0, "05D0 05BC" },
/* U+fb31 */ { 19, 0, 4, 0, "05D1 05BC" },
/* U+fb32 */ { 19, 0, 4, 0, "05D2 05BC" },
/* U+fb33 */ { 19, 0, 4, 0, "05D3 05BC" },
/* U+fb34 */ { 19, 0, 4, 0, "05D4 05BC" },
/* U+fb35 */ { 19, 0, 4, 0, "05D5 05BC" },
/* U+fb36 */ { 19, 0, 4, 0, "05D6 05BC" },
/* U+fb37 */ { 0, 0, 0, 0, 0 },
/* U+fb38 */ { 19, 0, 4, 0, "05D8 05BC" },
/* U+fb39 */ { 19, 0, 4, 0, "05D9 05BC" },
/* U+fb3a */ { 19, 0, 4, 0, "05DA 05BC" },
/* U+fb3b */ { 19, 0, 4, 0, "05DB 05BC" },
/* U+fb3c */ { 19, 0, 4, 0, "05DC 05BC" },
/* U+fb3d */ { 0, 0, 0, 0, 0 },
/* U+fb3e */ { 19, 0, 4, 0, "05DE 05BC" },
/* U+fb3f */ { 0, 0, 0, 0, 0 },
/* U+fb40 */ { 19, 0, 4, 0, "05E0 05BC" },
/* U+fb41 */ { 19, 0, 4, 0, "05E1 05BC" },
/* U+fb42 */ { 0, 0, 0, 0, 0 },
/* U+fb43 */ { 19, 0, 4, 0, "05E3 05BC" },
/* U+fb44 */ { 19, 0, 4, 0, "05E4 05BC" },
/* U+fb45 */ { 0, 0, 0, 0, 0 },
/* U+fb46 */ { 19, 0, 4, 0, "05E6 05BC" },
/* U+fb47 */ { 19, 0, 4, 0, "05E7 05BC" },
/* U+fb48 */ { 19, 0, 4, 0, "05E8 05BC" },
/* U+fb49 */ { 19, 0, 4, 0, "05E9 05BC" },
/* U+fb4a */ { 19, 0, 4, 0, "05EA 05BC" },
/* U+fb4b */ { 19, 0, 4, 0, "05D5 05B9" },
/* U+fb4c */ { 19, 0, 4, 0, "05D1 05BF" },
/* U+fb4d */ { 19, 0, 4, 0, "05DB 05BF" },
/* U+fb4e */ { 19, 0, 4, 0, "05E4 05BF" },
/* U+fb4f */ { 19, 0, 4, 0, "<compat> 05D0 05DC" },
/* U+fb50 */ { 19, 0, 5, 0, "<isolated> 0671" },
/* U+fb51 */ { 19, 0, 5, 0, "<final> 0671" },
/* U+fb52 */ { 19, 0, 5, 0, "<isolated> 067B" },
/* U+fb53 */ { 19, 0, 5, 0, "<final> 067B" },
/* U+fb54 */ { 19, 0, 5, 0, "<initial> 067B" },
/* U+fb55 */ { 19, 0, 5, 0, "<medial> 067B" },
/* U+fb56 */ { 19, 0, 5, 0, "<isolated> 067E" },
/* U+fb57 */ { 19, 0, 5, 0, "<final> 067E" },
/* U+fb58 */ { 19, 0, 5, 0, "<initial> 067E" },
/* U+fb59 */ { 19, 0, 5, 0, "<medial> 067E" },
/* U+fb5a */ { 19, 0, 5, 0, "<isolated> 0680" },
/* U+fb5b */ { 19, 0, 5, 0, "<final> 0680" },
/* U+fb5c */ { 19, 0, 5, 0, "<initial> 0680" },
/* U+fb5d */ { 19, 0, 5, 0, "<medial> 0680" },
/* U+fb5e */ { 19, 0, 5, 0, "<isolated> 067A" },
/* U+fb5f */ { 19, 0, 5, 0, "<final> 067A" },
/* U+fb60 */ { 19, 0, 5, 0, "<initial> 067A" },
/* U+fb61 */ { 19, 0, 5, 0, "<medial> 067A" },
/* U+fb62 */ { 19, 0, 5, 0, "<isolated> 067F" },
/* U+fb63 */ { 19, 0, 5, 0, "<final> 067F" },
/* U+fb64 */ { 19, 0, 5, 0, "<initial> 067F" },
/* U+fb65 */ { 19, 0, 5, 0, "<medial> 067F" },
/* U+fb66 */ { 19, 0, 5, 0, "<isolated> 0679" },
/* U+fb67 */ { 19, 0, 5, 0, "<final> 0679" },
/* U+fb68 */ { 19, 0, 5, 0, "<initial> 0679" },
/* U+fb69 */ { 19, 0, 5, 0, "<medial> 0679" },
/* U+fb6a */ { 19, 0, 5, 0, "<isolated> 06A4" },
/* U+fb6b */ { 19, 0, 5, 0, "<final> 06A4" },
/* U+fb6c */ { 19, 0, 5, 0, "<initial> 06A4" },
/* U+fb6d */ { 19, 0, 5, 0, "<medial> 06A4" },
/* U+fb6e */ { 19, 0, 5, 0, "<isolated> 06A6" },
/* U+fb6f */ { 19, 0, 5, 0, "<final> 06A6" },
/* U+fb70 */ { 19, 0, 5, 0, "<initial> 06A6" },
/* U+fb71 */ { 19, 0, 5, 0, "<medial> 06A6" },
/* U+fb72 */ { 19, 0, 5, 0, "<isolated> 0684" },
/* U+fb73 */ { 19, 0, 5, 0, "<final> 0684" },
/* U+fb74 */ { 19, 0, 5, 0, "<initial> 0684" },
/* U+fb75 */ { 19, 0, 5, 0, "<medial> 0684" },
/* U+fb76 */ { 19, 0, 5, 0, "<isolated> 0683" },
/* U+fb77 */ { 19, 0, 5, 0, "<final> 0683" },
/* U+fb78 */ { 19, 0, 5, 0, "<initial> 0683" },
/* U+fb79 */ { 19, 0, 5, 0, "<medial> 0683" },
/* U+fb7a */ { 19, 0, 5, 0, "<isolated> 0686" },
/* U+fb7b */ { 19, 0, 5, 0, "<final> 0686" },
/* U+fb7c */ { 19, 0, 5, 0, "<initial> 0686" },
/* U+fb7d */ { 19, 0, 5, 0, "<medial> 0686" },
/* U+fb7e */ { 19, 0, 5, 0, "<isolated> 0687" },
/* U+fb7f */ { 19, 0, 5, 0, "<final> 0687" },
/* U+fb80 */ { 19, 0, 5, 0, "<initial> 0687" },
/* U+fb81 */ { 19, 0, 5, 0, "<medial> 0687" },
/* U+fb82 */ { 19, 0, 5, 0, "<isolated> 068D" },
/* U+fb83 */ { 19, 0, 5, 0, "<final> 068D" },
/* U+fb84 */ { 19, 0, 5, 0, "<isolated> 068C" },
/* U+fb85 */ { 19, 0, 5, 0, "<final> 068C" },
/* U+fb86 */ { 19, 0, 5, 0, "<isolated> 068E" },
/* U+fb87 */ { 19, 0, 5, 0, "<final> 068E" },
/* U+fb88 */ { 19, 0, 5, 0, "<isolated> 0688" },
/* U+fb89 */ { 19, 0, 5, 0, "<final> 0688" },
/* U+fb8a */ { 19, 0, 5, 0, "<isolated> 0698" },
/* U+fb8b */ { 19, 0, 5, 0, "<final> 0698" },
/* U+fb8c */ { 19, 0, 5, 0, "<isolated> 0691" },
/* U+fb8d */ { 19, 0, 5, 0, "<final> 0691" },
/* U+fb8e */ { 19, 0, 5, 0, "<isolated> 06A9" },
/* U+fb8f */ { 19, 0, 5, 0, "<final> 06A9" },
/* U+fb90 */ { 19, 0, 5, 0, "<initial> 06A9" },
/* U+fb91 */ { 19, 0, 5, 0, "<medial> 06A9" },
/* U+fb92 */ { 19, 0, 5, 0, "<isolated> 06AF" },
/* U+fb93 */ { 19, 0, 5, 0, "<final> 06AF" },
/* U+fb94 */ { 19, 0, 5, 0, "<initial> 06AF" },
/* U+fb95 */ { 19, 0, 5, 0, "<medial> 06AF" },
/* U+fb96 */ { 19, 0, 5, 0, "<isolated> 06B3" },
/* U+fb97 */ { 19, 0, 5, 0, "<final> 06B3" },
/* U+fb98 */ { 19, 0, 5, 0, "<initial> 06B3" },
/* U+fb99 */ { 19, 0, 5, 0, "<medial> 06B3" },
/* U+fb9a */ { 19, 0, 5, 0, "<isolated> 06B1" },
/* U+fb9b */ { 19, 0, 5, 0, "<final> 06B1" },
/* U+fb9c */ { 19, 0, 5, 0, "<initial> 06B1" },
/* U+fb9d */ { 19, 0, 5, 0, "<medial> 06B1" },
/* U+fb9e */ { 19, 0, 5, 0, "<isolated> 06BA" },
/* U+fb9f */ { 19, 0, 5, 0, "<final> 06BA" },
/* U+fba0 */ { 19, 0, 5, 0, "<isolated> 06BB" },
/* U+fba1 */ { 19, 0, 5, 0, "<final> 06BB" },
/* U+fba2 */ { 19, 0, 5, 0, "<initial> 06BB" },
/* U+fba3 */ { 19, 0, 5, 0, "<medial> 06BB" },
/* U+fba4 */ { 19, 0, 5, 0, "<isolated> 06C0" },
/* U+fba5 */ { 19, 0, 5, 0, "<final> 06C0" },
/* U+fba6 */ { 19, 0, 5, 0, "<isolated> 06C1" },
/* U+fba7 */ { 19, 0, 5, 0, "<final> 06C1" },
/* U+fba8 */ { 19, 0, 5, 0, "<initial> 06C1" },
/* U+fba9 */ { 19, 0, 5, 0, "<medial> 06C1" },
/* U+fbaa */ { 19, 0, 5, 0, "<isolated> 06BE" },
/* U+fbab */ { 19, 0, 5, 0, "<final> 06BE" },
/* U+fbac */ { 19, 0, 5, 0, "<initial> 06BE" },
/* U+fbad */ { 19, 0, 5, 0, "<medial> 06BE" },
/* U+fbae */ { 19, 0, 5, 0, "<isolated> 06D2" },
/* U+fbaf */ { 19, 0, 5, 0, "<final> 06D2" },
/* U+fbb0 */ { 19, 0, 5, 0, "<isolated> 06D3" },
/* U+fbb1 */ { 19, 0, 5, 0, "<final> 06D3" },
/* U+fbb2 */ { 0, 0, 0, 0, 0 },
/* U+fbb3 */ { 0, 0, 0, 0, 0 },
/* U+fbb4 */ { 0, 0, 0, 0, 0 },
/* U+fbb5 */ { 0, 0, 0, 0, 0 },
/* U+fbb6 */ { 0, 0, 0, 0, 0 },
/* U+fbb7 */ { 0, 0, 0, 0, 0 },
/* U+fbb8 */ { 0, 0, 0, 0, 0 },
/* U+fbb9 */ { 0, 0, 0, 0, 0 },
/* U+fbba */ { 0, 0, 0, 0, 0 },
/* U+fbbb */ { 0, 0, 0, 0, 0 },
/* U+fbbc */ { 0, 0, 0, 0, 0 },
/* U+fbbd */ { 0, 0, 0, 0, 0 },
/* U+fbbe */ { 0, 0, 0, 0, 0 },
/* U+fbbf */ { 0, 0, 0, 0, 0 },
/* U+fbc0 */ { 0, 0, 0, 0, 0 },
/* U+fbc1 */ { 0, 0, 0, 0, 0 },
/* U+fbc2 */ { 0, 0, 0, 0, 0 },
/* U+fbc3 */ { 0, 0, 0, 0, 0 },
/* U+fbc4 */ { 0, 0, 0, 0, 0 },
/* U+fbc5 */ { 0, 0, 0, 0, 0 },
/* U+fbc6 */ { 0, 0, 0, 0, 0 },
/* U+fbc7 */ { 0, 0, 0, 0, 0 },
/* U+fbc8 */ { 0, 0, 0, 0, 0 },
/* U+fbc9 */ { 0, 0, 0, 0, 0 },
/* U+fbca */ { 0, 0, 0, 0, 0 },
/* U+fbcb */ { 0, 0, 0, 0, 0 },
/* U+fbcc */ { 0, 0, 0, 0, 0 },
/* U+fbcd */ { 0, 0, 0, 0, 0 },
/* U+fbce */ { 0, 0, 0, 0, 0 },
/* U+fbcf */ { 0, 0, 0, 0, 0 },
/* U+fbd0 */ { 0, 0, 0, 0, 0 },
/* U+fbd1 */ { 0, 0, 0, 0, 0 },
/* U+fbd2 */ { 0, 0, 0, 0, 0 },
/* U+fbd3 */ { 19, 0, 5, 0, "<isolated> 06AD" },
/* U+fbd4 */ { 19, 0, 5, 0, "<final> 06AD" },
/* U+fbd5 */ { 19, 0, 5, 0, "<initial> 06AD" },
/* U+fbd6 */ { 19, 0, 5, 0, "<medial> 06AD" },
/* U+fbd7 */ { 19, 0, 5, 0, "<isolated> 06C7" },
/* U+fbd8 */ { 19, 0, 5, 0, "<final> 06C7" },
/* U+fbd9 */ { 19, 0, 5, 0, "<isolated> 06C6" },
/* U+fbda */ { 19, 0, 5, 0, "<final> 06C6" },
/* U+fbdb */ { 19, 0, 5, 0, "<isolated> 06C8" },
/* U+fbdc */ { 19, 0, 5, 0, "<final> 06C8" },
/* U+fbdd */ { 19, 0, 5, 0, "<isolated> 0677" },
/* U+fbde */ { 19, 0, 5, 0, "<isolated> 06CB" },
/* U+fbdf */ { 19, 0, 5, 0, "<final> 06CB" },
/* U+fbe0 */ { 19, 0, 5, 0, "<isolated> 06C5" },
/* U+fbe1 */ { 19, 0, 5, 0, "<final> 06C5" },
/* U+fbe2 */ { 19, 0, 5, 0, "<isolated> 06C9" },
/* U+fbe3 */ { 19, 0, 5, 0, "<final> 06C9" },
/* U+fbe4 */ { 19, 0, 5, 0, "<isolated> 06D0" },
/* U+fbe5 */ { 19, 0, 5, 0, "<final> 06D0" },
/* U+fbe6 */ { 19, 0, 5, 0, "<initial> 06D0" },
/* U+fbe7 */ { 19, 0, 5, 0, "<medial> 06D0" },
/* U+fbe8 */ { 19, 0, 5, 0, "<initial> 0649" },
/* U+fbe9 */ { 19, 0, 5, 0, "<medial> 0649" },
/* U+fbea */ { 19, 0, 5, 0, "<isolated> 0626 0627" },
/* U+fbeb */ { 19, 0, 5, 0, "<final> 0626 0627" },
/* U+fbec */ { 19, 0, 5, 0, "<isolated> 0626 06D5" },
/* U+fbed */ { 19, 0, 5, 0, "<final> 0626 06D5" },
/* U+fbee */ { 19, 0, 5, 0, "<isolated> 0626 0648" },
/* U+fbef */ { 19, 0, 5, 0, "<final> 0626 0648" },
/* U+fbf0 */ { 19, 0, 5, 0, "<isolated> 0626 06C7" },
/* U+fbf1 */ { 19, 0, 5, 0, "<final> 0626 06C7" },
/* U+fbf2 */ { 19, 0, 5, 0, "<isolated> 0626 06C6" },
/* U+fbf3 */ { 19, 0, 5, 0, "<final> 0626 06C6" },
/* U+fbf4 */ { 19, 0, 5, 0, "<isolated> 0626 06C8" },
/* U+fbf5 */ { 19, 0, 5, 0, "<final> 0626 06C8" },
/* U+fbf6 */ { 19, 0, 5, 0, "<isolated> 0626 06D0" },
/* U+fbf7 */ { 19, 0, 5, 0, "<final> 0626 06D0" },
/* U+fbf8 */ { 19, 0, 5, 0, "<initial> 0626 06D0" },
/* U+fbf9 */ { 19, 0, 5, 0, "<isolated> 0626 0649" },
/* U+fbfa */ { 19, 0, 5, 0, "<final> 0626 0649" },
/* U+fbfb */ { 19, 0, 5, 0, "<initial> 0626 0649" },
/* U+fbfc */ { 19, 0, 5, 0, "<isolated> 06CC" },
/* U+fbfd */ { 19, 0, 5, 0, "<final> 06CC" },
/* U+fbfe */ { 19, 0, 5, 0, "<initial> 06CC" },
/* U+fbff */ { 19, 0, 5, 0, "<medial> 06CC" },
/* U+fc00 */ { 19, 0, 5, 0, "<isolated> 0626 062C" },
/* U+fc01 */ { 19, 0, 5, 0, "<isolated> 0626 062D" },
/* U+fc02 */ { 19, 0, 5, 0, "<isolated> 0626 0645" },
/* U+fc03 */ { 19, 0, 5, 0, "<isolated> 0626 0649" },
/* U+fc04 */ { 19, 0, 5, 0, "<isolated> 0626 064A" },
/* U+fc05 */ { 19, 0, 5, 0, "<isolated> 0628 062C" },
/* U+fc06 */ { 19, 0, 5, 0, "<isolated> 0628 062D" },
/* U+fc07 */ { 19, 0, 5, 0, "<isolated> 0628 062E" },
/* U+fc08 */ { 19, 0, 5, 0, "<isolated> 0628 0645" },
/* U+fc09 */ { 19, 0, 5, 0, "<isolated> 0628 0649" },
/* U+fc0a */ { 19, 0, 5, 0, "<isolated> 0628 064A" },
/* U+fc0b */ { 19, 0, 5, 0, "<isolated> 062A 062C" },
/* U+fc0c */ { 19, 0, 5, 0, "<isolated> 062A 062D" },
/* U+fc0d */ { 19, 0, 5, 0, "<isolated> 062A 062E" },
/* U+fc0e */ { 19, 0, 5, 0, "<isolated> 062A 0645" },
/* U+fc0f */ { 19, 0, 5, 0, "<isolated> 062A 0649" },
/* U+fc10 */ { 19, 0, 5, 0, "<isolated> 062A 064A" },
/* U+fc11 */ { 19, 0, 5, 0, "<isolated> 062B 062C" },
/* U+fc12 */ { 19, 0, 5, 0, "<isolated> 062B 0645" },
/* U+fc13 */ { 19, 0, 5, 0, "<isolated> 062B 0649" },
/* U+fc14 */ { 19, 0, 5, 0, "<isolated> 062B 064A" },
/* U+fc15 */ { 19, 0, 5, 0, "<isolated> 062C 062D" },
/* U+fc16 */ { 19, 0, 5, 0, "<isolated> 062C 0645" },
/* U+fc17 */ { 19, 0, 5, 0, "<isolated> 062D 062C" },
/* U+fc18 */ { 19, 0, 5, 0, "<isolated> 062D 0645" },
/* U+fc19 */ { 19, 0, 5, 0, "<isolated> 062E 062C" },
/* U+fc1a */ { 19, 0, 5, 0, "<isolated> 062E 062D" },
/* U+fc1b */ { 19, 0, 5, 0, "<isolated> 062E 0645" },
/* U+fc1c */ { 19, 0, 5, 0, "<isolated> 0633 062C" },
/* U+fc1d */ { 19, 0, 5, 0, "<isolated> 0633 062D" },
/* U+fc1e */ { 19, 0, 5, 0, "<isolated> 0633 062E" },
/* U+fc1f */ { 19, 0, 5, 0, "<isolated> 0633 0645" },
/* U+fc20 */ { 19, 0, 5, 0, "<isolated> 0635 062D" },
/* U+fc21 */ { 19, 0, 5, 0, "<isolated> 0635 0645" },
/* U+fc22 */ { 19, 0, 5, 0, "<isolated> 0636 062C" },
/* U+fc23 */ { 19, 0, 5, 0, "<isolated> 0636 062D" },
/* U+fc24 */ { 19, 0, 5, 0, "<isolated> 0636 062E" },
/* U+fc25 */ { 19, 0, 5, 0, "<isolated> 0636 0645" },
/* U+fc26 */ { 19, 0, 5, 0, "<isolated> 0637 062D" },
/* U+fc27 */ { 19, 0, 5, 0, "<isolated> 0637 0645" },
/* U+fc28 */ { 19, 0, 5, 0, "<isolated> 0638 0645" },
/* U+fc29 */ { 19, 0, 5, 0, "<isolated> 0639 062C" },
/* U+fc2a */ { 19, 0, 5, 0, "<isolated> 0639 0645" },
/* U+fc2b */ { 19, 0, 5, 0, "<isolated> 063A 062C" },
/* U+fc2c */ { 19, 0, 5, 0, "<isolated> 063A 0645" },
/* U+fc2d */ { 19, 0, 5, 0, "<isolated> 0641 062C" },
/* U+fc2e */ { 19, 0, 5, 0, "<isolated> 0641 062D" },
/* U+fc2f */ { 19, 0, 5, 0, "<isolated> 0641 062E" },
/* U+fc30 */ { 19, 0, 5, 0, "<isolated> 0641 0645" },
/* U+fc31 */ { 19, 0, 5, 0, "<isolated> 0641 0649" },
/* U+fc32 */ { 19, 0, 5, 0, "<isolated> 0641 064A" },
/* U+fc33 */ { 19, 0, 5, 0, "<isolated> 0642 062D" },
/* U+fc34 */ { 19, 0, 5, 0, "<isolated> 0642 0645" },
/* U+fc35 */ { 19, 0, 5, 0, "<isolated> 0642 0649" },
/* U+fc36 */ { 19, 0, 5, 0, "<isolated> 0642 064A" },
/* U+fc37 */ { 19, 0, 5, 0, "<isolated> 0643 0627" },
/* U+fc38 */ { 19, 0, 5, 0, "<isolated> 0643 062C" },
/* U+fc39 */ { 19, 0, 5, 0, "<isolated> 0643 062D" },
/* U+fc3a */ { 19, 0, 5, 0, "<isolated> 0643 062E" },
/* U+fc3b */ { 19, 0, 5, 0, "<isolated> 0643 0644" },
/* U+fc3c */ { 19, 0, 5, 0, "<isolated> 0643 0645" },
/* U+fc3d */ { 19, 0, 5, 0, "<isolated> 0643 0649" },
/* U+fc3e */ { 19, 0, 5, 0, "<isolated> 0643 064A" },
/* U+fc3f */ { 19, 0, 5, 0, "<isolated> 0644 062C" },
/* U+fc40 */ { 19, 0, 5, 0, "<isolated> 0644 062D" },
/* U+fc41 */ { 19, 0, 5, 0, "<isolated> 0644 062E" },
/* U+fc42 */ { 19, 0, 5, 0, "<isolated> 0644 0645" },
/* U+fc43 */ { 19, 0, 5, 0, "<isolated> 0644 0649" },
/* U+fc44 */ { 19, 0, 5, 0, "<isolated> 0644 064A" },
/* U+fc45 */ { 19, 0, 5, 0, "<isolated> 0645 062C" },
/* U+fc46 */ { 19, 0, 5, 0, "<isolated> 0645 062D" },
/* U+fc47 */ { 19, 0, 5, 0, "<isolated> 0645 062E" },
/* U+fc48 */ { 19, 0, 5, 0, "<isolated> 0645 0645" },
/* U+fc49 */ { 19, 0, 5, 0, "<isolated> 0645 0649" },
/* U+fc4a */ { 19, 0, 5, 0, "<isolated> 0645 064A" },
/* U+fc4b */ { 19, 0, 5, 0, "<isolated> 0646 062C" },
/* U+fc4c */ { 19, 0, 5, 0, "<isolated> 0646 062D" },
/* U+fc4d */ { 19, 0, 5, 0, "<isolated> 0646 062E" },
/* U+fc4e */ { 19, 0, 5, 0, "<isolated> 0646 0645" },
/* U+fc4f */ { 19, 0, 5, 0, "<isolated> 0646 0649" },
/* U+fc50 */ { 19, 0, 5, 0, "<isolated> 0646 064A" },
/* U+fc51 */ { 19, 0, 5, 0, "<isolated> 0647 062C" },
/* U+fc52 */ { 19, 0, 5, 0, "<isolated> 0647 0645" },
/* U+fc53 */ { 19, 0, 5, 0, "<isolated> 0647 0649" },
/* U+fc54 */ { 19, 0, 5, 0, "<isolated> 0647 064A" },
/* U+fc55 */ { 19, 0, 5, 0, "<isolated> 064A 062C" },
/* U+fc56 */ { 19, 0, 5, 0, "<isolated> 064A 062D" },
/* U+fc57 */ { 19, 0, 5, 0, "<isolated> 064A 062E" },
/* U+fc58 */ { 19, 0, 5, 0, "<isolated> 064A 0645" },
/* U+fc59 */ { 19, 0, 5, 0, "<isolated> 064A 0649" },
/* U+fc5a */ { 19, 0, 5, 0, "<isolated> 064A 064A" },
/* U+fc5b */ { 19, 0, 5, 0, "<isolated> 0630 0670" },
/* U+fc5c */ { 19, 0, 5, 0, "<isolated> 0631 0670" },
/* U+fc5d */ { 19, 0, 5, 0, "<isolated> 0649 0670" },
/* U+fc5e */ { 19, 0, 5, 0, "<isolated> 0020 064C 0651" },
/* U+fc5f */ { 19, 0, 5, 0, "<isolated> 0020 064D 0651" },
/* U+fc60 */ { 19, 0, 5, 0, "<isolated> 0020 064E 0651" },
/* U+fc61 */ { 19, 0, 5, 0, "<isolated> 0020 064F 0651" },
/* U+fc62 */ { 19, 0, 5, 0, "<isolated> 0020 0650 0651" },
/* U+fc63 */ { 19, 0, 5, 0, "<isolated> 0020 0651 0670" },
/* U+fc64 */ { 19, 0, 5, 0, "<final> 0626 0631" },
/* U+fc65 */ { 19, 0, 5, 0, "<final> 0626 0632" },
/* U+fc66 */ { 19, 0, 5, 0, "<final> 0626 0645" },
/* U+fc67 */ { 19, 0, 5, 0, "<final> 0626 0646" },
/* U+fc68 */ { 19, 0, 5, 0, "<final> 0626 0649" },
/* U+fc69 */ { 19, 0, 5, 0, "<final> 0626 064A" },
/* U+fc6a */ { 19, 0, 5, 0, "<final> 0628 0631" },
/* U+fc6b */ { 19, 0, 5, 0, "<final> 0628 0632" },
/* U+fc6c */ { 19, 0, 5, 0, "<final> 0628 0645" },
/* U+fc6d */ { 19, 0, 5, 0, "<final> 0628 0646" },
/* U+fc6e */ { 19, 0, 5, 0, "<final> 0628 0649" },
/* U+fc6f */ { 19, 0, 5, 0, "<final> 0628 064A" },
/* U+fc70 */ { 19, 0, 5, 0, "<final> 062A 0631" },
/* U+fc71 */ { 19, 0, 5, 0, "<final> 062A 0632" },
/* U+fc72 */ { 19, 0, 5, 0, "<final> 062A 0645" },
/* U+fc73 */ { 19, 0, 5, 0, "<final> 062A 0646" },
/* U+fc74 */ { 19, 0, 5, 0, "<final> 062A 0649" },
/* U+fc75 */ { 19, 0, 5, 0, "<final> 062A 064A" },
/* U+fc76 */ { 19, 0, 5, 0, "<final> 062B 0631" },
/* U+fc77 */ { 19, 0, 5, 0, "<final> 062B 0632" },
/* U+fc78 */ { 19, 0, 5, 0, "<final> 062B 0645" },
/* U+fc79 */ { 19, 0, 5, 0, "<final> 062B 0646" },
/* U+fc7a */ { 19, 0, 5, 0, "<final> 062B 0649" },
/* U+fc7b */ { 19, 0, 5, 0, "<final> 062B 064A" },
/* U+fc7c */ { 19, 0, 5, 0, "<final> 0641 0649" },
/* U+fc7d */ { 19, 0, 5, 0, "<final> 0641 064A" },
/* U+fc7e */ { 19, 0, 5, 0, "<final> 0642 0649" },
/* U+fc7f */ { 19, 0, 5, 0, "<final> 0642 064A" },
/* U+fc80 */ { 19, 0, 5, 0, "<final> 0643 0627" },
/* U+fc81 */ { 19, 0, 5, 0, "<final> 0643 0644" },
/* U+fc82 */ { 19, 0, 5, 0, "<final> 0643 0645" },
/* U+fc83 */ { 19, 0, 5, 0, "<final> 0643 0649" },
/* U+fc84 */ { 19, 0, 5, 0, "<final> 0643 064A" },
/* U+fc85 */ { 19, 0, 5, 0, "<final> 0644 0645" },
/* U+fc86 */ { 19, 0, 5, 0, "<final> 0644 0649" },
/* U+fc87 */ { 19, 0, 5, 0, "<final> 0644 064A" },
/* U+fc88 */ { 19, 0, 5, 0, "<final> 0645 0627" },
/* U+fc89 */ { 19, 0, 5, 0, "<final> 0645 0645" },
/* U+fc8a */ { 19, 0, 5, 0, "<final> 0646 0631" },
/* U+fc8b */ { 19, 0, 5, 0, "<final> 0646 0632" },
/* U+fc8c */ { 19, 0, 5, 0, "<final> 0646 0645" },
/* U+fc8d */ { 19, 0, 5, 0, "<final> 0646 0646" },
/* U+fc8e */ { 19, 0, 5, 0, "<final> 0646 0649" },
/* U+fc8f */ { 19, 0, 5, 0, "<final> 0646 064A" },
/* U+fc90 */ { 19, 0, 5, 0, "<final> 0649 0670" },
/* U+fc91 */ { 19, 0, 5, 0, "<final> 064A 0631" },
/* U+fc92 */ { 19, 0, 5, 0, "<final> 064A 0632" },
/* U+fc93 */ { 19, 0, 5, 0, "<final> 064A 0645" },
/* U+fc94 */ { 19, 0, 5, 0, "<final> 064A 0646" },
/* U+fc95 */ { 19, 0, 5, 0, "<final> 064A 0649" },
/* U+fc96 */ { 19, 0, 5, 0, "<final> 064A 064A" },
/* U+fc97 */ { 19, 0, 5, 0, "<initial> 0626 062C" },
/* U+fc98 */ { 19, 0, 5, 0, "<initial> 0626 062D" },
/* U+fc99 */ { 19, 0, 5, 0, "<initial> 0626 062E" },
/* U+fc9a */ { 19, 0, 5, 0, "<initial> 0626 0645" },
/* U+fc9b */ { 19, 0, 5, 0, "<initial> 0626 0647" },
/* U+fc9c */ { 19, 0, 5, 0, "<initial> 0628 062C" },
/* U+fc9d */ { 19, 0, 5, 0, "<initial> 0628 062D" },
/* U+fc9e */ { 19, 0, 5, 0, "<initial> 0628 062E" },
/* U+fc9f */ { 19, 0, 5, 0, "<initial> 0628 0645" },
/* U+fca0 */ { 19, 0, 5, 0, "<initial> 0628 0647" },
/* U+fca1 */ { 19, 0, 5, 0, "<initial> 062A 062C" },
/* U+fca2 */ { 19, 0, 5, 0, "<initial> 062A 062D" },
/* U+fca3 */ { 19, 0, 5, 0, "<initial> 062A 062E" },
/* U+fca4 */ { 19, 0, 5, 0, "<initial> 062A 0645" },
/* U+fca5 */ { 19, 0, 5, 0, "<initial> 062A 0647" },
/* U+fca6 */ { 19, 0, 5, 0, "<initial> 062B 0645" },
/* U+fca7 */ { 19, 0, 5, 0, "<initial> 062C 062D" },
/* U+fca8 */ { 19, 0, 5, 0, "<initial> 062C 0645" },
/* U+fca9 */ { 19, 0, 5, 0, "<initial> 062D 062C" },
/* U+fcaa */ { 19, 0, 5, 0, "<initial> 062D 0645" },
/* U+fcab */ { 19, 0, 5, 0, "<initial> 062E 062C" },
/* U+fcac */ { 19, 0, 5, 0, "<initial> 062E 0645" },
/* U+fcad */ { 19, 0, 5, 0, "<initial> 0633 062C" },
/* U+fcae */ { 19, 0, 5, 0, "<initial> 0633 062D" },
/* U+fcaf */ { 19, 0, 5, 0, "<initial> 0633 062E" },
/* U+fcb0 */ { 19, 0, 5, 0, "<initial> 0633 0645" },
/* U+fcb1 */ { 19, 0, 5, 0, "<initial> 0635 062D" },
/* U+fcb2 */ { 19, 0, 5, 0, "<initial> 0635 062E" },
/* U+fcb3 */ { 19, 0, 5, 0, "<initial> 0635 0645" },
/* U+fcb4 */ { 19, 0, 5, 0, "<initial> 0636 062C" },
/* U+fcb5 */ { 19, 0, 5, 0, "<initial> 0636 062D" },
/* U+fcb6 */ { 19, 0, 5, 0, "<initial> 0636 062E" },
/* U+fcb7 */ { 19, 0, 5, 0, "<initial> 0636 0645" },
/* U+fcb8 */ { 19, 0, 5, 0, "<initial> 0637 062D" },
/* U+fcb9 */ { 19, 0, 5, 0, "<initial> 0638 0645" },
/* U+fcba */ { 19, 0, 5, 0, "<initial> 0639 062C" },
/* U+fcbb */ { 19, 0, 5, 0, "<initial> 0639 0645" },
/* U+fcbc */ { 19, 0, 5, 0, "<initial> 063A 062C" },
/* U+fcbd */ { 19, 0, 5, 0, "<initial> 063A 0645" },
/* U+fcbe */ { 19, 0, 5, 0, "<initial> 0641 062C" },
/* U+fcbf */ { 19, 0, 5, 0, "<initial> 0641 062D" },
/* U+fcc0 */ { 19, 0, 5, 0, "<initial> 0641 062E" },
/* U+fcc1 */ { 19, 0, 5, 0, "<initial> 0641 0645" },
/* U+fcc2 */ { 19, 0, 5, 0, "<initial> 0642 062D" },
/* U+fcc3 */ { 19, 0, 5, 0, "<initial> 0642 0645" },
/* U+fcc4 */ { 19, 0, 5, 0, "<initial> 0643 062C" },
/* U+fcc5 */ { 19, 0, 5, 0, "<initial> 0643 062D" },
/* U+fcc6 */ { 19, 0, 5, 0, "<initial> 0643 062E" },
/* U+fcc7 */ { 19, 0, 5, 0, "<initial> 0643 0644" },
/* U+fcc8 */ { 19, 0, 5, 0, "<initial> 0643 0645" },
/* U+fcc9 */ { 19, 0, 5, 0, "<initial> 0644 062C" },
/* U+fcca */ { 19, 0, 5, 0, "<initial> 0644 062D" },
/* U+fccb */ { 19, 0, 5, 0, "<initial> 0644 062E" },
/* U+fccc */ { 19, 0, 5, 0, "<initial> 0644 0645" },
/* U+fccd */ { 19, 0, 5, 0, "<initial> 0644 0647" },
/* U+fcce */ { 19, 0, 5, 0, "<initial> 0645 062C" },
/* U+fccf */ { 19, 0, 5, 0, "<initial> 0645 062D" },
/* U+fcd0 */ { 19, 0, 5, 0, "<initial> 0645 062E" },
/* U+fcd1 */ { 19, 0, 5, 0, "<initial> 0645 0645" },
/* U+fcd2 */ { 19, 0, 5, 0, "<initial> 0646 062C" },
/* U+fcd3 */ { 19, 0, 5, 0, "<initial> 0646 062D" },
/* U+fcd4 */ { 19, 0, 5, 0, "<initial> 0646 062E" },
/* U+fcd5 */ { 19, 0, 5, 0, "<initial> 0646 0645" },
/* U+fcd6 */ { 19, 0, 5, 0, "<initial> 0646 0647" },
/* U+fcd7 */ { 19, 0, 5, 0, "<initial> 0647 062C" },
/* U+fcd8 */ { 19, 0, 5, 0, "<initial> 0647 0645" },
/* U+fcd9 */ { 19, 0, 5, 0, "<initial> 0647 0670" },
/* U+fcda */ { 19, 0, 5, 0, "<initial> 064A 062C" },
/* U+fcdb */ { 19, 0, 5, 0, "<initial> 064A 062D" },
/* U+fcdc */ { 19, 0, 5, 0, "<initial> 064A 062E" },
/* U+fcdd */ { 19, 0, 5, 0, "<initial> 064A 0645" },
/* U+fcde */ { 19, 0, 5, 0, "<initial> 064A 0647" },
/* U+fcdf */ { 19, 0, 5, 0, "<medial> 0626 0645" },
/* U+fce0 */ { 19, 0, 5, 0, "<medial> 0626 0647" },
/* U+fce1 */ { 19, 0, 5, 0, "<medial> 0628 0645" },
/* U+fce2 */ { 19, 0, 5, 0, "<medial> 0628 0647" },
/* U+fce3 */ { 19, 0, 5, 0, "<medial> 062A 0645" },
/* U+fce4 */ { 19, 0, 5, 0, "<medial> 062A 0647" },
/* U+fce5 */ { 19, 0, 5, 0, "<medial> 062B 0645" },
/* U+fce6 */ { 19, 0, 5, 0, "<medial> 062B 0647" },
/* U+fce7 */ { 19, 0, 5, 0, "<medial> 0633 0645" },
/* U+fce8 */ { 19, 0, 5, 0, "<medial> 0633 0647" },
/* U+fce9 */ { 19, 0, 5, 0, "<medial> 0634 0645" },
/* U+fcea */ { 19, 0, 5, 0, "<medial> 0634 0647" },
/* U+fceb */ { 19, 0, 5, 0, "<medial> 0643 0644" },
/* U+fcec */ { 19, 0, 5, 0, "<medial> 0643 0645" },
/* U+fced */ { 19, 0, 5, 0, "<medial> 0644 0645" },
/* U+fcee */ { 19, 0, 5, 0, "<medial> 0646 0645" },
/* U+fcef */ { 19, 0, 5, 0, "<medial> 0646 0647" },
/* U+fcf0 */ { 19, 0, 5, 0, "<medial> 064A 0645" },
/* U+fcf1 */ { 19, 0, 5, 0, "<medial> 064A 0647" },
/* U+fcf2 */ { 19, 0, 5, 0, "<medial> 0640 064E 0651" },
/* U+fcf3 */ { 19, 0, 5, 0, "<medial> 0640 064F 0651" },
/* U+fcf4 */ { 19, 0, 5, 0, "<medial> 0640 0650 0651" },
/* U+fcf5 */ { 19, 0, 5, 0, "<isolated> 0637 0649" },
/* U+fcf6 */ { 19, 0, 5, 0, "<isolated> 0637 064A" },
/* U+fcf7 */ { 19, 0, 5, 0, "<isolated> 0639 0649" },
/* U+fcf8 */ { 19, 0, 5, 0, "<isolated> 0639 064A" },
/* U+fcf9 */ { 19, 0, 5, 0, "<isolated> 063A 0649" },
/* U+fcfa */ { 19, 0, 5, 0, "<isolated> 063A 064A" },
/* U+fcfb */ { 19, 0, 5, 0, "<isolated> 0633 0649" },
/* U+fcfc */ { 19, 0, 5, 0, "<isolated> 0633 064A" },
/* U+fcfd */ { 19, 0, 5, 0, "<isolated> 0634 0649" },
/* U+fcfe */ { 19, 0, 5, 0, "<isolated> 0634 064A" },
/* U+fcff */ { 19, 0, 5, 0, "<isolated> 062D 0649" },
/* U+fd00 */ { 19, 0, 5, 0, "<isolated> 062D 064A" },
/* U+fd01 */ { 19, 0, 5, 0, "<isolated> 062C 0649" },
/* U+fd02 */ { 19, 0, 5, 0, "<isolated> 062C 064A" },
/* U+fd03 */ { 19, 0, 5, 0, "<isolated> 062E 0649" },
/* U+fd04 */ { 19, 0, 5, 0, "<isolated> 062E 064A" },
/* U+fd05 */ { 19, 0, 5, 0, "<isolated> 0635 0649" },
/* U+fd06 */ { 19, 0, 5, 0, "<isolated> 0635 064A" },
/* U+fd07 */ { 19, 0, 5, 0, "<isolated> 0636 0649" },
/* U+fd08 */ { 19, 0, 5, 0, "<isolated> 0636 064A" },
/* U+fd09 */ { 19, 0, 5, 0, "<isolated> 0634 062C" },
/* U+fd0a */ { 19, 0, 5, 0, "<isolated> 0634 062D" },
/* U+fd0b */ { 19, 0, 5, 0, "<isolated> 0634 062E" },
/* U+fd0c */ { 19, 0, 5, 0, "<isolated> 0634 0645" },
/* U+fd0d */ { 19, 0, 5, 0, "<isolated> 0634 0631" },
/* U+fd0e */ { 19, 0, 5, 0, "<isolated> 0633 0631" },
/* U+fd0f */ { 19, 0, 5, 0, "<isolated> 0635 0631" },
/* U+fd10 */ { 19, 0, 5, 0, "<isolated> 0636 0631" },
/* U+fd11 */ { 19, 0, 5, 0, "<final> 0637 0649" },
/* U+fd12 */ { 19, 0, 5, 0, "<final> 0637 064A" },
/* U+fd13 */ { 19, 0, 5, 0, "<final> 0639 0649" },
/* U+fd14 */ { 19, 0, 5, 0, "<final> 0639 064A" },
/* U+fd15 */ { 19, 0, 5, 0, "<final> 063A 0649" },
/* U+fd16 */ { 19, 0, 5, 0, "<final> 063A 064A" },
/* U+fd17 */ { 19, 0, 5, 0, "<final> 0633 0649" },
/* U+fd18 */ { 19, 0, 5, 0, "<final> 0633 064A" },
/* U+fd19 */ { 19, 0, 5, 0, "<final> 0634 0649" },
/* U+fd1a */ { 19, 0, 5, 0, "<final> 0634 064A" },
/* U+fd1b */ { 19, 0, 5, 0, "<final> 062D 0649" },
/* U+fd1c */ { 19, 0, 5, 0, "<final> 062D 064A" },
/* U+fd1d */ { 19, 0, 5, 0, "<final> 062C 0649" },
/* U+fd1e */ { 19, 0, 5, 0, "<final> 062C 064A" },
/* U+fd1f */ { 19, 0, 5, 0, "<final> 062E 0649" },
/* U+fd20 */ { 19, 0, 5, 0, "<final> 062E 064A" },
/* U+fd21 */ { 19, 0, 5, 0, "<final> 0635 0649" },
/* U+fd22 */ { 19, 0, 5, 0, "<final> 0635 064A" },
/* U+fd23 */ { 19, 0, 5, 0, "<final> 0636 0649" },
/* U+fd24 */ { 19, 0, 5, 0, "<final> 0636 064A" },
/* U+fd25 */ { 19, 0, 5, 0, "<final> 0634 062C" },
/* U+fd26 */ { 19, 0, 5, 0, "<final> 0634 062D" },
/* U+fd27 */ { 19, 0, 5, 0, "<final> 0634 062E" },
/* U+fd28 */ { 19, 0, 5, 0, "<final> 0634 0645" },
/* U+fd29 */ { 19, 0, 5, 0, "<final> 0634 0631" },
/* U+fd2a */ { 19, 0, 5, 0, "<final> 0633 0631" },
/* U+fd2b */ { 19, 0, 5, 0, "<final> 0635 0631" },
/* U+fd2c */ { 19, 0, 5, 0, "<final> 0636 0631" },
/* U+fd2d */ { 19, 0, 5, 0, "<initial> 0634 062C" },
/* U+fd2e */ { 19, 0, 5, 0, "<initial> 0634 062D" },
/* U+fd2f */ { 19, 0, 5, 0, "<initial> 0634 062E" },
/* U+fd30 */ { 19, 0, 5, 0, "<initial> 0634 0645" },
/* U+fd31 */ { 19, 0, 5, 0, "<initial> 0633 0647" },
/* U+fd32 */ { 19, 0, 5, 0, "<initial> 0634 0647" },
/* U+fd33 */ { 19, 0, 5, 0, "<initial> 0637 0645" },
/* U+fd34 */ { 19, 0, 5, 0, "<medial> 0633 062C" },
/* U+fd35 */ { 19, 0, 5, 0, "<medial> 0633 062D" },
/* U+fd36 */ { 19, 0, 5, 0, "<medial> 0633 062E" },
/* U+fd37 */ { 19, 0, 5, 0, "<medial> 0634 062C" },
/* U+fd38 */ { 19, 0, 5, 0, "<medial> 0634 062D" },
/* U+fd39 */ { 19, 0, 5, 0, "<medial> 0634 062E" },
/* U+fd3a */ { 19, 0, 5, 0, "<medial> 0637 0645" },
/* U+fd3b */ { 19, 0, 5, 0, "<medial> 0638 0645" },
/* U+fd3c */ { 19, 0, 5, 0, "<final> 0627 064B" },
/* U+fd3d */ { 19, 0, 5, 0, "<isolated> 0627 064B" },
/* U+fd3e */ { 22, 0, 19, 0, 0 },
/* U+fd3f */ { 23, 0, 19, 0, 0 },
/* U+fd40 */ { 0, 0, 0, 0, 0 },
/* U+fd41 */ { 0, 0, 0, 0, 0 },
/* U+fd42 */ { 0, 0, 0, 0, 0 },
/* U+fd43 */ { 0, 0, 0, 0, 0 },
/* U+fd44 */ { 0, 0, 0, 0, 0 },
/* U+fd45 */ { 0, 0, 0, 0, 0 },
/* U+fd46 */ { 0, 0, 0, 0, 0 },
/* U+fd47 */ { 0, 0, 0, 0, 0 },
/* U+fd48 */ { 0, 0, 0, 0, 0 },
/* U+fd49 */ { 0, 0, 0, 0, 0 },
/* U+fd4a */ { 0, 0, 0, 0, 0 },
/* U+fd4b */ { 0, 0, 0, 0, 0 },
/* U+fd4c */ { 0, 0, 0, 0, 0 },
/* U+fd4d */ { 0, 0, 0, 0, 0 },
/* U+fd4e */ { 0, 0, 0, 0, 0 },
/* U+fd4f */ { 0, 0, 0, 0, 0 },
/* U+fd50 */ { 19, 0, 5, 0, "<initial> 062A 062C 0645" },
/* U+fd51 */ { 19, 0, 5, 0, "<final> 062A 062D 062C" },
/* U+fd52 */ { 19, 0, 5, 0, "<initial> 062A 062D 062C" },
/* U+fd53 */ { 19, 0, 5, 0, "<initial> 062A 062D 0645" },
/* U+fd54 */ { 19, 0, 5, 0, "<initial> 062A 062E 0645" },
/* U+fd55 */ { 19, 0, 5, 0, "<initial> 062A 0645 062C" },
/* U+fd56 */ { 19, 0, 5, 0, "<initial> 062A 0645 062D" },
/* U+fd57 */ { 19, 0, 5, 0, "<initial> 062A 0645 062E" },
/* U+fd58 */ { 19, 0, 5, 0, "<final> 062C 0645 062D" },
/* U+fd59 */ { 19, 0, 5, 0, "<initial> 062C 0645 062D" },
/* U+fd5a */ { 19, 0, 5, 0, "<final> 062D 0645 064A" },
/* U+fd5b */ { 19, 0, 5, 0, "<final> 062D 0645 0649" },
/* U+fd5c */ { 19, 0, 5, 0, "<initial> 0633 062D 062C" },
/* U+fd5d */ { 19, 0, 5, 0, "<initial> 0633 062C 062D" },
/* U+fd5e */ { 19, 0, 5, 0, "<final> 0633 062C 0649" },
/* U+fd5f */ { 19, 0, 5, 0, "<final> 0633 0645 062D" },
/* U+fd60 */ { 19, 0, 5, 0, "<initial> 0633 0645 062D" },
/* U+fd61 */ { 19, 0, 5, 0, "<initial> 0633 0645 062C" },
/* U+fd62 */ { 19, 0, 5, 0, "<final> 0633 0645 0645" },
/* U+fd63 */ { 19, 0, 5, 0, "<initial> 0633 0645 0645" },
/* U+fd64 */ { 19, 0, 5, 0, "<final> 0635 062D 062D" },
/* U+fd65 */ { 19, 0, 5, 0, "<initial> 0635 062D 062D" },
/* U+fd66 */ { 19, 0, 5, 0, "<final> 0635 0645 0645" },
/* U+fd67 */ { 19, 0, 5, 0, "<final> 0634 062D 0645" },
/* U+fd68 */ { 19, 0, 5, 0, "<initial> 0634 062D 0645" },
/* U+fd69 */ { 19, 0, 5, 0, "<final> 0634 062C 064A" },
/* U+fd6a */ { 19, 0, 5, 0, "<final> 0634 0645 062E" },
/* U+fd6b */ { 19, 0, 5, 0, "<initial> 0634 0645 062E" },
/* U+fd6c */ { 19, 0, 5, 0, "<final> 0634 0645 0645" },
/* U+fd6d */ { 19, 0, 5, 0, "<initial> 0634 0645 0645" },
/* U+fd6e */ { 19, 0, 5, 0, "<final> 0636 062D 0649" },
/* U+fd6f */ { 19, 0, 5, 0, "<final> 0636 062E 0645" },
/* U+fd70 */ { 19, 0, 5, 0, "<initial> 0636 062E 0645" },
/* U+fd71 */ { 19, 0, 5, 0, "<final> 0637 0645 062D" },
/* U+fd72 */ { 19, 0, 5, 0, "<initial> 0637 0645 062D" },
/* U+fd73 */ { 19, 0, 5, 0, "<initial> 0637 0645 0645" },
/* U+fd74 */ { 19, 0, 5, 0, "<final> 0637 0645 064A" },
/* U+fd75 */ { 19, 0, 5, 0, "<final> 0639 062C 0645" },
/* U+fd76 */ { 19, 0, 5, 0, "<final> 0639 0645 0645" },
/* U+fd77 */ { 19, 0, 5, 0, "<initial> 0639 0645 0645" },
/* U+fd78 */ { 19, 0, 5, 0, "<final> 0639 0645 0649" },
/* U+fd79 */ { 19, 0, 5, 0, "<final> 063A 0645 0645" },
/* U+fd7a */ { 19, 0, 5, 0, "<final> 063A 0645 064A" },
/* U+fd7b */ { 19, 0, 5, 0, "<final> 063A 0645 0649" },
/* U+fd7c */ { 19, 0, 5, 0, "<final> 0641 062E 0645" },
/* U+fd7d */ { 19, 0, 5, 0, "<initial> 0641 062E 0645" },
/* U+fd7e */ { 19, 0, 5, 0, "<final> 0642 0645 062D" },
/* U+fd7f */ { 19, 0, 5, 0, "<final> 0642 0645 0645" },
/* U+fd80 */ { 19, 0, 5, 0, "<final> 0644 062D 0645" },
/* U+fd81 */ { 19, 0, 5, 0, "<final> 0644 062D 064A" },
/* U+fd82 */ { 19, 0, 5, 0, "<final> 0644 062D 0649" },
/* U+fd83 */ { 19, 0, 5, 0, "<initial> 0644 062C 062C" },
/* U+fd84 */ { 19, 0, 5, 0, "<final> 0644 062C 062C" },
/* U+fd85 */ { 19, 0, 5, 0, "<final> 0644 062E 0645" },
/* U+fd86 */ { 19, 0, 5, 0, "<initial> 0644 062E 0645" },
/* U+fd87 */ { 19, 0, 5, 0, "<final> 0644 0645 062D" },
/* U+fd88 */ { 19, 0, 5, 0, "<initial> 0644 0645 062D" },
/* U+fd89 */ { 19, 0, 5, 0, "<initial> 0645 062D 062C" },
/* U+fd8a */ { 19, 0, 5, 0, "<initial> 0645 062D 0645" },
/* U+fd8b */ { 19, 0, 5, 0, "<final> 0645 062D 064A" },
/* U+fd8c */ { 19, 0, 5, 0, "<initial> 0645 062C 062D" },
/* U+fd8d */ { 19, 0, 5, 0, "<initial> 0645 062C 0645" },
/* U+fd8e */ { 19, 0, 5, 0, "<initial> 0645 062E 062C" },
/* U+fd8f */ { 19, 0, 5, 0, "<initial> 0645 062E 0645" },
/* U+fd90 */ { 0, 0, 0, 0, 0 },
/* U+fd91 */ { 0, 0, 0, 0, 0 },
/* U+fd92 */ { 19, 0, 5, 0, "<initial> 0645 062C 062E" },
/* U+fd93 */ { 19, 0, 5, 0, "<initial> 0647 0645 062C" },
/* U+fd94 */ { 19, 0, 5, 0, "<initial> 0647 0645 0645" },
/* U+fd95 */ { 19, 0, 5, 0, "<initial> 0646 062D 0645" },
/* U+fd96 */ { 19, 0, 5, 0, "<final> 0646 062D 0649" },
/* U+fd97 */ { 19, 0, 5, 0, "<final> 0646 062C 0645" },
/* U+fd98 */ { 19, 0, 5, 0, "<initial> 0646 062C 0645" },
/* U+fd99 */ { 19, 0, 5, 0, "<final> 0646 062C 0649" },
/* U+fd9a */ { 19, 0, 5, 0, "<final> 0646 0645 064A" },
/* U+fd9b */ { 19, 0, 5, 0, "<final> 0646 0645 0649" },
/* U+fd9c */ { 19, 0, 5, 0, "<final> 064A 0645 0645" },
/* U+fd9d */ { 19, 0, 5, 0, "<initial> 064A 0645 0645" },
/* U+fd9e */ { 19, 0, 5, 0, "<final> 0628 062E 064A" },
/* U+fd9f */ { 19, 0, 5, 0, "<final> 062A 062C 064A" },
/* U+fda0 */ { 19, 0, 5, 0, "<final> 062A 062C 0649" },
/* U+fda1 */ { 19, 0, 5, 0, "<final> 062A 062E 064A" },
/* U+fda2 */ { 19, 0, 5, 0, "<final> 062A 062E 0649" },
/* U+fda3 */ { 19, 0, 5, 0, "<final> 062A 0645 064A" },
/* U+fda4 */ { 19, 0, 5, 0, "<final> 062A 0645 0649" },
/* U+fda5 */ { 19, 0, 5, 0, "<final> 062C 0645 064A" },
/* U+fda6 */ { 19, 0, 5, 0, "<final> 062C 062D 0649" },
/* U+fda7 */ { 19, 0, 5, 0, "<final> 062C 0645 0649" },
/* U+fda8 */ { 19, 0, 5, 0, "<final> 0633 062E 0649" },
/* U+fda9 */ { 19, 0, 5, 0, "<final> 0635 062D 064A" },
/* U+fdaa */ { 19, 0, 5, 0, "<final> 0634 062D 064A" },
/* U+fdab */ { 19, 0, 5, 0, "<final> 0636 062D 064A" },
/* U+fdac */ { 19, 0, 5, 0, "<final> 0644 062C 064A" },
/* U+fdad */ { 19, 0, 5, 0, "<final> 0644 0645 064A" },
/* U+fdae */ { 19, 0, 5, 0, "<final> 064A 062D 064A" },
/* U+fdaf */ { 19, 0, 5, 0, "<final> 064A 062C 064A" },
/* U+fdb0 */ { 19, 0, 5, 0, "<final> 064A 0645 064A" },
/* U+fdb1 */ { 19, 0, 5, 0, "<final> 0645 0645 064A" },
/* U+fdb2 */ { 19, 0, 5, 0, "<final> 0642 0645 064A" },
/* U+fdb3 */ { 19, 0, 5, 0, "<final> 0646 062D 064A" },
/* U+fdb4 */ { 19, 0, 5, 0, "<initial> 0642 0645 062D" },
/* U+fdb5 */ { 19, 0, 5, 0, "<initial> 0644 062D 0645" },
/* U+fdb6 */ { 19, 0, 5, 0, "<final> 0639 0645 064A" },
/* U+fdb7 */ { 19, 0, 5, 0, "<final> 0643 0645 064A" },
/* U+fdb8 */ { 19, 0, 5, 0, "<initial> 0646 062C 062D" },
/* U+fdb9 */ { 19, 0, 5, 0, "<final> 0645 062E 064A" },
/* U+fdba */ { 19, 0, 5, 0, "<initial> 0644 062C 0645" },
/* U+fdbb */ { 19, 0, 5, 0, "<final> 0643 0645 0645" },
/* U+fdbc */ { 19, 0, 5, 0, "<final> 0644 062C 0645" },
/* U+fdbd */ { 19, 0, 5, 0, "<final> 0646 062C 062D" },
/* U+fdbe */ { 19, 0, 5, 0, "<final> 062C 062D 064A" },
/* U+fdbf */ { 19, 0, 5, 0, "<final> 062D 062C 064A" },
/* U+fdc0 */ { 19, 0, 5, 0, "<final> 0645 062C 064A" },
/* U+fdc1 */ { 19, 0, 5, 0, "<final> 0641 0645 064A" },
/* U+fdc2 */ { 19, 0, 5, 0, "<final> 0628 062D 064A" },
/* U+fdc3 */ { 19, 0, 5, 0, "<initial> 0643 0645 0645" },
/* U+fdc4 */ { 19, 0, 5, 0, "<initial> 0639 062C 0645" },
/* U+fdc5 */ { 19, 0, 5, 0, "<initial> 0635 0645 0645" },
/* U+fdc6 */ { 19, 0, 5, 0, "<final> 0633 062E 064A" },
/* U+fdc7 */ { 19, 0, 5, 0, "<final> 0646 062C 064A" },
/* U+fdc8 */ { 0, 0, 0, 0, 0 },
/* U+fdc9 */ { 0, 0, 0, 0, 0 },
/* U+fdca */ { 0, 0, 0, 0, 0 },
/* U+fdcb */ { 0, 0, 0, 0, 0 },
/* U+fdcc */ { 0, 0, 0, 0, 0 },
/* U+fdcd */ { 0, 0, 0, 0, 0 },
/* U+fdce */ { 0, 0, 0, 0, 0 },
/* U+fdcf */ { 0, 0, 0, 0, 0 },
/* U+fdd0 */ { 0, 0, 0, 0, 0 },
/* U+fdd1 */ { 0, 0, 0, 0, 0 },
/* U+fdd2 */ { 0, 0, 0, 0, 0 },
/* U+fdd3 */ { 0, 0, 0, 0, 0 },
/* U+fdd4 */ { 0, 0, 0, 0, 0 },
/* U+fdd5 */ { 0, 0, 0, 0, 0 },
/* U+fdd6 */ { 0, 0, 0, 0, 0 },
/* U+fdd7 */ { 0, 0, 0, 0, 0 },
/* U+fdd8 */ { 0, 0, 0, 0, 0 },
/* U+fdd9 */ { 0, 0, 0, 0, 0 },
/* U+fdda */ { 0, 0, 0, 0, 0 },
/* U+fddb */ { 0, 0, 0, 0, 0 },
/* U+fddc */ { 0, 0, 0, 0, 0 },
/* U+fddd */ { 0, 0, 0, 0, 0 },
/* U+fdde */ { 0, 0, 0, 0, 0 },
/* U+fddf */ { 0, 0, 0, 0, 0 },
/* U+fde0 */ { 0, 0, 0, 0, 0 },
/* U+fde1 */ { 0, 0, 0, 0, 0 },
/* U+fde2 */ { 0, 0, 0, 0, 0 },
/* U+fde3 */ { 0, 0, 0, 0, 0 },
/* U+fde4 */ { 0, 0, 0, 0, 0 },
/* U+fde5 */ { 0, 0, 0, 0, 0 },
/* U+fde6 */ { 0, 0, 0, 0, 0 },
/* U+fde7 */ { 0, 0, 0, 0, 0 },
/* U+fde8 */ { 0, 0, 0, 0, 0 },
/* U+fde9 */ { 0, 0, 0, 0, 0 },
/* U+fdea */ { 0, 0, 0, 0, 0 },
/* U+fdeb */ { 0, 0, 0, 0, 0 },
/* U+fdec */ { 0, 0, 0, 0, 0 },
/* U+fded */ { 0, 0, 0, 0, 0 },
/* U+fdee */ { 0, 0, 0, 0, 0 },
/* U+fdef */ { 0, 0, 0, 0, 0 },
/* U+fdf0 */ { 19, 0, 5, 0, "<isolated> 0635 0644 06D2" },
/* U+fdf1 */ { 19, 0, 5, 0, "<isolated> 0642 0644 06D2" },
/* U+fdf2 */ { 19, 0, 5, 0, "<isolated> 0627 0644 0644 0647" },
/* U+fdf3 */ { 19, 0, 5, 0, "<isolated> 0627 0643 0628 0631" },
/* U+fdf4 */ { 19, 0, 5, 0, "<isolated> 0645 062D 0645 062F" },
/* U+fdf5 */ { 19, 0, 5, 0, "<isolated> 0635 0644 0639 0645" },
/* U+fdf6 */ { 19, 0, 5, 0, "<isolated> 0631 0633 0648 0644" },
/* U+fdf7 */ { 19, 0, 5, 0, "<isolated> 0639 0644 064A 0647" },
/* U+fdf8 */ { 19, 0, 5, 0, "<isolated> 0648 0633 0644 0645" },
/* U+fdf9 */ { 19, 0, 5, 0, "<isolated> 0635 0644 0649" },
/* U+fdfa */ { 19, 0, 5, 0, "<isolated> 0635 0644 0649 0020 0627 0644 0644 0647 0020 0639 0644 064A 0647 0020 0648 0633 0644 0645" },
/* U+fdfb */ { 19, 0, 5, 0, "<isolated> 062C 0644 0020 062C 0644 0627 0644 0647" },
/* U+fdfc */ { 0, 0, 0, 0, 0 },
/* U+fdfd */ { 0, 0, 0, 0, 0 },
/* U+fdfe */ { 0, 0, 0, 0, 0 },
/* U+fdff */ { 0, 0, 0, 0, 0 },
/* U+fe00 */ { 0, 0, 0, 0, 0 },
/* U+fe01 */ { 0, 0, 0, 0, 0 },
/* U+fe02 */ { 0, 0, 0, 0, 0 },
/* U+fe03 */ { 0, 0, 0, 0, 0 },
/* U+fe04 */ { 0, 0, 0, 0, 0 },
/* U+fe05 */ { 0, 0, 0, 0, 0 },
/* U+fe06 */ { 0, 0, 0, 0, 0 },
/* U+fe07 */ { 0, 0, 0, 0, 0 },
/* U+fe08 */ { 0, 0, 0, 0, 0 },
/* U+fe09 */ { 0, 0, 0, 0, 0 },
/* U+fe0a */ { 0, 0, 0, 0, 0 },
/* U+fe0b */ { 0, 0, 0, 0, 0 },
/* U+fe0c */ { 0, 0, 0, 0, 0 },
/* U+fe0d */ { 0, 0, 0, 0, 0 },
/* U+fe0e */ { 0, 0, 0, 0, 0 },
/* U+fe0f */ { 0, 0, 0, 0, 0 },
/* U+fe10 */ { 0, 0, 0, 0, 0 },
/* U+fe11 */ { 0, 0, 0, 0, 0 },
/* U+fe12 */ { 0, 0, 0, 0, 0 },
/* U+fe13 */ { 0, 0, 0, 0, 0 },
/* U+fe14 */ { 0, 0, 0, 0, 0 },
/* U+fe15 */ { 0, 0, 0, 0, 0 },
/* U+fe16 */ { 0, 0, 0, 0, 0 },
/* U+fe17 */ { 0, 0, 0, 0, 0 },
/* U+fe18 */ { 0, 0, 0, 0, 0 },
/* U+fe19 */ { 0, 0, 0, 0, 0 },
/* U+fe1a */ { 0, 0, 0, 0, 0 },
/* U+fe1b */ { 0, 0, 0, 0, 0 },
/* U+fe1c */ { 0, 0, 0, 0, 0 },
/* U+fe1d */ { 0, 0, 0, 0, 0 },
/* U+fe1e */ { 0, 0, 0, 0, 0 },
/* U+fe1f */ { 0, 0, 0, 0, 0 },
/* U+fe20 */ { 4, 230, 14, 0, 0 },
/* U+fe21 */ { 4, 230, 14, 0, 0 },
/* U+fe22 */ { 4, 230, 14, 0, 0 },
/* U+fe23 */ { 4, 230, 14, 0, 0 },
/* U+fe24 */ { 0, 0, 0, 0, 0 },
/* U+fe25 */ { 0, 0, 0, 0, 0 },
/* U+fe26 */ { 0, 0, 0, 0, 0 },
/* U+fe27 */ { 0, 0, 0, 0, 0 },
/* U+fe28 */ { 0, 0, 0, 0, 0 },
/* U+fe29 */ { 0, 0, 0, 0, 0 },
/* U+fe2a */ { 0, 0, 0, 0, 0 },
/* U+fe2b */ { 0, 0, 0, 0, 0 },
/* U+fe2c */ { 0, 0, 0, 0, 0 },
/* U+fe2d */ { 0, 0, 0, 0, 0 },
/* U+fe2e */ { 0, 0, 0, 0, 0 },
/* U+fe2f */ { 0, 0, 0, 0, 0 },
/* U+fe30 */ { 26, 0, 19, 0, "<vertical> 2025" },
/* U+fe31 */ { 21, 0, 19, 0, "<vertical> 2014" },
/* U+fe32 */ { 21, 0, 19, 0, "<vertical> 2013" },
/* U+fe33 */ { 20, 0, 19, 0, "<vertical> 005F" },
/* U+fe34 */ { 20, 0, 19, 0, "<vertical> 005F" },
/* U+fe35 */ { 22, 0, 19, 0, "<vertical> 0028" },
/* U+fe36 */ { 23, 0, 19, 0, "<vertical> 0029" },
/* U+fe37 */ { 22, 0, 19, 0, "<vertical> 007B" },
/* U+fe38 */ { 23, 0, 19, 0, "<vertical> 007D" },
/* U+fe39 */ { 22, 0, 19, 0, "<vertical> 3014" },
/* U+fe3a */ { 23, 0, 19, 0, "<vertical> 3015" },
/* U+fe3b */ { 22, 0, 19, 0, "<vertical> 3010" },
/* U+fe3c */ { 23, 0, 19, 0, "<vertical> 3011" },
/* U+fe3d */ { 22, 0, 19, 0, "<vertical> 300A" },
/* U+fe3e */ { 23, 0, 19, 0, "<vertical> 300B" },
/* U+fe3f */ { 22, 0, 19, 0, "<vertical> 3008" },
/* U+fe40 */ { 23, 0, 19, 0, "<vertical> 3009" },
/* U+fe41 */ { 22, 0, 19, 0, "<vertical> 300C" },
/* U+fe42 */ { 23, 0, 19, 0, "<vertical> 300D" },
/* U+fe43 */ { 22, 0, 19, 0, "<vertical> 300E" },
/* U+fe44 */ { 23, 0, 19, 0, "<vertical> 300F" },
/* U+fe45 */ { 0, 0, 0, 0, 0 },
/* U+fe46 */ { 0, 0, 0, 0, 0 },
/* U+fe47 */ { 0, 0, 0, 0, 0 },
/* U+fe48 */ { 0, 0, 0, 0, 0 },
/* U+fe49 */ { 26, 0, 19, 0, "<compat> 203E" },
/* U+fe4a */ { 26, 0, 19, 0, "<compat> 203E" },
/* U+fe4b */ { 26, 0, 19, 0, "<compat> 203E" },
/* U+fe4c */ { 26, 0, 19, 0, "<compat> 203E" },
/* U+fe4d */ { 20, 0, 19, 0, "<compat> 005F" },
/* U+fe4e */ { 20, 0, 19, 0, "<compat> 005F" },
/* U+fe4f */ { 20, 0, 19, 0, "<compat> 005F" },
/* U+fe50 */ { 26, 0, 13, 0, "<small> 002C" },
/* U+fe51 */ { 26, 0, 19, 0, "<small> 3001" },
/* U+fe52 */ { 26, 0, 13, 0, "<small> 002E" },
/* U+fe53 */ { 0, 0, 0, 0, 0 },
/* U+fe54 */ { 26, 0, 19, 0, "<small> 003B" },
/* U+fe55 */ { 26, 0, 13, 0, "<small> 003A" },
/* U+fe56 */ { 26, 0, 19, 0, "<small> 003F" },
/* U+fe57 */ { 26, 0, 19, 0, "<small> 0021" },
/* U+fe58 */ { 21, 0, 19, 0, "<small> 2014" },
/* U+fe59 */ { 22, 0, 19, 0, "<small> 0028" },
/* U+fe5a */ { 23, 0, 19, 0, "<small> 0029" },
/* U+fe5b */ { 22, 0, 19, 0, "<small> 007B" },
/* U+fe5c */ { 23, 0, 19, 0, "<small> 007D" },
/* U+fe5d */ { 22, 0, 19, 0, "<small> 3014" },
/* U+fe5e */ { 23, 0, 19, 0, "<small> 3015" },
/* U+fe5f */ { 26, 0, 11, 0, "<small> 0023" },
/* U+fe60 */ { 26, 0, 19, 0, "<small> 0026" },
/* U+fe61 */ { 26, 0, 19, 0, "<small> 002A" },
/* U+fe62 */ { 27, 0, 11, 0, "<small> 002B" },
/* U+fe63 */ { 21, 0, 11, 0, "<small> 002D" },
/* U+fe64 */ { 27, 0, 19, 0, "<small> 003C" },
/* U+fe65 */ { 27, 0, 19, 0, "<small> 003E" },
/* U+fe66 */ { 27, 0, 19, 0, "<small> 003D" },
/* U+fe67 */ { 0, 0, 0, 0, 0 },
/* U+fe68 */ { 26, 0, 19, 0, "<small> 005C" },
/* U+fe69 */ { 28, 0, 11, 0, "<small> 0024" },
/* U+fe6a */ { 26, 0, 11, 0, "<small> 0025" },
/* U+fe6b */ { 26, 0, 19, 0, "<small> 0040" },
/* U+fe6c */ { 0, 0, 0, 0, 0 },
/* U+fe6d */ { 0, 0, 0, 0, 0 },
/* U+fe6e */ { 0, 0, 0, 0, 0 },
/* U+fe6f */ { 0, 0, 0, 0, 0 },
/* U+fe70 */ { 19, 0, 5, 0, "<isolated> 0020 064B" },
/* U+fe71 */ { 19, 0, 5, 0, "<medial> 0640 064B" },
/* U+fe72 */ { 19, 0, 5, 0, "<isolated> 0020 064C" },
/* U+fe73 */ { 0, 0, 0, 0, 0 },
/* U+fe74 */ { 19, 0, 5, 0, "<isolated> 0020 064D" },
/* U+fe75 */ { 0, 0, 0, 0, 0 },
/* U+fe76 */ { 19, 0, 5, 0, "<isolated> 0020 064E" },
/* U+fe77 */ { 19, 0, 5, 0, "<medial> 0640 064E" },
/* U+fe78 */ { 19, 0, 5, 0, "<isolated> 0020 064F" },
/* U+fe79 */ { 19, 0, 5, 0, "<medial> 0640 064F" },
/* U+fe7a */ { 19, 0, 5, 0, "<isolated> 0020 0650" },
/* U+fe7b */ { 19, 0, 5, 0, "<medial> 0640 0650" },
/* U+fe7c */ { 19, 0, 5, 0, "<isolated> 0020 0651" },
/* U+fe7d */ { 19, 0, 5, 0, "<medial> 0640 0651" },
/* U+fe7e */ { 19, 0, 5, 0, "<isolated> 0020 0652" },
/* U+fe7f */ { 19, 0, 5, 0, "<medial> 0640 0652" },
/* U+fe80 */ { 19, 0, 5, 0, "<isolated> 0621" },
/* U+fe81 */ { 19, 0, 5, 0, "<isolated> 0622" },
/* U+fe82 */ { 19, 0, 5, 0, "<final> 0622" },
/* U+fe83 */ { 19, 0, 5, 0, "<isolated> 0623" },
/* U+fe84 */ { 19, 0, 5, 0, "<final> 0623" },
/* U+fe85 */ { 19, 0, 5, 0, "<isolated> 0624" },
/* U+fe86 */ { 19, 0, 5, 0, "<final> 0624" },
/* U+fe87 */ { 19, 0, 5, 0, "<isolated> 0625" },
/* U+fe88 */ { 19, 0, 5, 0, "<final> 0625" },
/* U+fe89 */ { 19, 0, 5, 0, "<isolated> 0626" },
/* U+fe8a */ { 19, 0, 5, 0, "<final> 0626" },
/* U+fe8b */ { 19, 0, 5, 0, "<initial> 0626" },
/* U+fe8c */ { 19, 0, 5, 0, "<medial> 0626" },
/* U+fe8d */ { 19, 0, 5, 0, "<isolated> 0627" },
/* U+fe8e */ { 19, 0, 5, 0, "<final> 0627" },
/* U+fe8f */ { 19, 0, 5, 0, "<isolated> 0628" },
/* U+fe90 */ { 19, 0, 5, 0, "<final> 0628" },
/* U+fe91 */ { 19, 0, 5, 0, "<initial> 0628" },
/* U+fe92 */ { 19, 0, 5, 0, "<medial> 0628" },
/* U+fe93 */ { 19, 0, 5, 0, "<isolated> 0629" },
/* U+fe94 */ { 19, 0, 5, 0, "<final> 0629" },
/* U+fe95 */ { 19, 0, 5, 0, "<isolated> 062A" },
/* U+fe96 */ { 19, 0, 5, 0, "<final> 062A" },
/* U+fe97 */ { 19, 0, 5, 0, "<initial> 062A" },
/* U+fe98 */ { 19, 0, 5, 0, "<medial> 062A" },
/* U+fe99 */ { 19, 0, 5, 0, "<isolated> 062B" },
/* U+fe9a */ { 19, 0, 5, 0, "<final> 062B" },
/* U+fe9b */ { 19, 0, 5, 0, "<initial> 062B" },
/* U+fe9c */ { 19, 0, 5, 0, "<medial> 062B" },
/* U+fe9d */ { 19, 0, 5, 0, "<isolated> 062C" },
/* U+fe9e */ { 19, 0, 5, 0, "<final> 062C" },
/* U+fe9f */ { 19, 0, 5, 0, "<initial> 062C" },
/* U+fea0 */ { 19, 0, 5, 0, "<medial> 062C" },
/* U+fea1 */ { 19, 0, 5, 0, "<isolated> 062D" },
/* U+fea2 */ { 19, 0, 5, 0, "<final> 062D" },
/* U+fea3 */ { 19, 0, 5, 0, "<initial> 062D" },
/* U+fea4 */ { 19, 0, 5, 0, "<medial> 062D" },
/* U+fea5 */ { 19, 0, 5, 0, "<isolated> 062E" },
/* U+fea6 */ { 19, 0, 5, 0, "<final> 062E" },
/* U+fea7 */ { 19, 0, 5, 0, "<initial> 062E" },
/* U+fea8 */ { 19, 0, 5, 0, "<medial> 062E" },
/* U+fea9 */ { 19, 0, 5, 0, "<isolated> 062F" },
/* U+feaa */ { 19, 0, 5, 0, "<final> 062F" },
/* U+feab */ { 19, 0, 5, 0, "<isolated> 0630" },
/* U+feac */ { 19, 0, 5, 0, "<final> 0630" },
/* U+fead */ { 19, 0, 5, 0, "<isolated> 0631" },
/* U+feae */ { 19, 0, 5, 0, "<final> 0631" },
/* U+feaf */ { 19, 0, 5, 0, "<isolated> 0632" },
/* U+feb0 */ { 19, 0, 5, 0, "<final> 0632" },
/* U+feb1 */ { 19, 0, 5, 0, "<isolated> 0633" },
/* U+feb2 */ { 19, 0, 5, 0, "<final> 0633" },
/* U+feb3 */ { 19, 0, 5, 0, "<initial> 0633" },
/* U+feb4 */ { 19, 0, 5, 0, "<medial> 0633" },
/* U+feb5 */ { 19, 0, 5, 0, "<isolated> 0634" },
/* U+feb6 */ { 19, 0, 5, 0, "<final> 0634" },
/* U+feb7 */ { 19, 0, 5, 0, "<initial> 0634" },
/* U+feb8 */ { 19, 0, 5, 0, "<medial> 0634" },
/* U+feb9 */ { 19, 0, 5, 0, "<isolated> 0635" },
/* U+feba */ { 19, 0, 5, 0, "<final> 0635" },
/* U+febb */ { 19, 0, 5, 0, "<initial> 0635" },
/* U+febc */ { 19, 0, 5, 0, "<medial> 0635" },
/* U+febd */ { 19, 0, 5, 0, "<isolated> 0636" },
/* U+febe */ { 19, 0, 5, 0, "<final> 0636" },
/* U+febf */ { 19, 0, 5, 0, "<initial> 0636" },
/* U+fec0 */ { 19, 0, 5, 0, "<medial> 0636" },
/* U+fec1 */ { 19, 0, 5, 0, "<isolated> 0637" },
/* U+fec2 */ { 19, 0, 5, 0, "<final> 0637" },
/* U+fec3 */ { 19, 0, 5, 0, "<initial> 0637" },
/* U+fec4 */ { 19, 0, 5, 0, "<medial> 0637" },
/* U+fec5 */ { 19, 0, 5, 0, "<isolated> 0638" },
/* U+fec6 */ { 19, 0, 5, 0, "<final> 0638" },
/* U+fec7 */ { 19, 0, 5, 0, "<initial> 0638" },
/* U+fec8 */ { 19, 0, 5, 0, "<medial> 0638" },
/* U+fec9 */ { 19, 0, 5, 0, "<isolated> 0639" },
/* U+feca */ { 19, 0, 5, 0, "<final> 0639" },
/* U+fecb */ { 19, 0, 5, 0, "<initial> 0639" },
/* U+fecc */ { 19, 0, 5, 0, "<medial> 0639" },
/* U+fecd */ { 19, 0, 5, 0, "<isolated> 063A" },
/* U+fece */ { 19, 0, 5, 0, "<final> 063A" },
/* U+fecf */ { 19, 0, 5, 0, "<initial> 063A" },
/* U+fed0 */ { 19, 0, 5, 0, "<medial> 063A" },
/* U+fed1 */ { 19, 0, 5, 0, "<isolated> 0641" },
/* U+fed2 */ { 19, 0, 5, 0, "<final> 0641" },
/* U+fed3 */ { 19, 0, 5, 0, "<initial> 0641" },
/* U+fed4 */ { 19, 0, 5, 0, "<medial> 0641" },
/* U+fed5 */ { 19, 0, 5, 0, "<isolated> 0642" },
/* U+fed6 */ { 19, 0, 5, 0, "<final> 0642" },
/* U+fed7 */ { 19, 0, 5, 0, "<initial> 0642" },
/* U+fed8 */ { 19, 0, 5, 0, "<medial> 0642" },
/* U+fed9 */ { 19, 0, 5, 0, "<isolated> 0643" },
/* U+feda */ { 19, 0, 5, 0, "<final> 0643" },
/* U+fedb */ { 19, 0, 5, 0, "<initial> 0643" },
/* U+fedc */ { 19, 0, 5, 0, "<medial> 0643" },
/* U+fedd */ { 19, 0, 5, 0, "<isolated> 0644" },
/* U+fede */ { 19, 0, 5, 0, "<final> 0644" },
/* U+fedf */ { 19, 0, 5, 0, "<initial> 0644" },
/* U+fee0 */ { 19, 0, 5, 0, "<medial> 0644" },
/* U+fee1 */ { 19, 0, 5, 0, "<isolated> 0645" },
/* U+fee2 */ { 19, 0, 5, 0, "<final> 0645" },
/* U+fee3 */ { 19, 0, 5, 0, "<initial> 0645" },
/* U+fee4 */ { 19, 0, 5, 0, "<medial> 0645" },
/* U+fee5 */ { 19, 0, 5, 0, "<isolated> 0646" },
/* U+fee6 */ { 19, 0, 5, 0, "<final> 0646" },
/* U+fee7 */ { 19, 0, 5, 0, "<initial> 0646" },
/* U+fee8 */ { 19, 0, 5, 0, "<medial> 0646" },
/* U+fee9 */ { 19, 0, 5, 0, "<isolated> 0647" },
/* U+feea */ { 19, 0, 5, 0, "<final> 0647" },
/* U+feeb */ { 19, 0, 5, 0, "<initial> 0647" },
/* U+feec */ { 19, 0, 5, 0, "<medial> 0647" },
/* U+feed */ { 19, 0, 5, 0, "<isolated> 0648" },
/* U+feee */ { 19, 0, 5, 0, "<final> 0648" },
/* U+feef */ { 19, 0, 5, 0, "<isolated> 0649" },
/* U+fef0 */ { 19, 0, 5, 0, "<final> 0649" },
/* U+fef1 */ { 19, 0, 5, 0, "<isolated> 064A" },
/* U+fef2 */ { 19, 0, 5, 0, "<final> 064A" },
/* U+fef3 */ { 19, 0, 5, 0, "<initial> 064A" },
/* U+fef4 */ { 19, 0, 5, 0, "<medial> 064A" },
/* U+fef5 */ { 19, 0, 5, 0, "<isolated> 0644 0622" },
/* U+fef6 */ { 19, 0, 5, 0, "<final> 0644 0622" },
/* U+fef7 */ { 19, 0, 5, 0, "<isolated> 0644 0623" },
/* U+fef8 */ { 19, 0, 5, 0, "<final> 0644 0623" },
/* U+fef9 */ { 19, 0, 5, 0, "<isolated> 0644 0625" },
/* U+fefa */ { 19, 0, 5, 0, "<final> 0644 0625" },
/* U+fefb */ { 19, 0, 5, 0, "<isolated> 0644 0627" },
/* U+fefc */ { 19, 0, 5, 0, "<final> 0644 0627" },
/* U+fefd */ { 0, 0, 0, 0, 0 },
/* U+fefe */ { 0, 0, 0, 0, 0 },
/* U+feff */ { 14, 0, 15, 0, 0 },
/* U+ff00 */ { 0, 0, 0, 0, 0 },
/* U+ff01 */ { 26, 0, 19, 0, "<wide> 0021" },
/* U+ff02 */ { 26, 0, 19, 0, "<wide> 0022" },
/* U+ff03 */ { 26, 0, 11, 0, "<wide> 0023" },
/* U+ff04 */ { 28, 0, 11, 0, "<wide> 0024" },
/* U+ff05 */ { 26, 0, 11, 0, "<wide> 0025" },
/* U+ff06 */ { 26, 0, 19, 0, "<wide> 0026" },
/* U+ff07 */ { 26, 0, 19, 0, "<wide> 0027" },
/* U+ff08 */ { 22, 0, 19, 0, "<wide> 0028" },
/* U+ff09 */ { 23, 0, 19, 0, "<wide> 0029" },
/* U+ff0a */ { 26, 0, 19, 0, "<wide> 002A" },
/* U+ff0b */ { 27, 0, 11, 0, "<wide> 002B" },
/* U+ff0c */ { 26, 0, 13, 0, "<wide> 002C" },
/* U+ff0d */ { 21, 0, 11, 0, "<wide> 002D" },
/* U+ff0e */ { 26, 0, 13, 0, "<wide> 002E" },
/* U+ff0f */ { 26, 0, 10, 0, "<wide> 002F" },
/* U+ff10 */ { 7, 0, 9, 0, "<wide> 0030" },
/* U+ff11 */ { 7, 0, 9, 0, "<wide> 0031" },
/* U+ff12 */ { 7, 0, 9, 0, "<wide> 0032" },
/* U+ff13 */ { 7, 0, 9, 0, "<wide> 0033" },
/* U+ff14 */ { 7, 0, 9, 0, "<wide> 0034" },
/* U+ff15 */ { 7, 0, 9, 0, "<wide> 0035" },
/* U+ff16 */ { 7, 0, 9, 0, "<wide> 0036" },
/* U+ff17 */ { 7, 0, 9, 0, "<wide> 0037" },
/* U+ff18 */ { 7, 0, 9, 0, "<wide> 0038" },
/* U+ff19 */ { 7, 0, 9, 0, "<wide> 0039" },
/* U+ff1a */ { 26, 0, 13, 0, "<wide> 003A" },
/* U+ff1b */ { 26, 0, 19, 0, "<wide> 003B" },
/* U+ff1c */ { 27, 0, 19, 0, "<wide> 003C" },
/* U+ff1d */ { 27, 0, 19, 0, "<wide> 003D" },
/* U+ff1e */ { 27, 0, 19, 0, "<wide> 003E" },
/* U+ff1f */ { 26, 0, 19, 0, "<wide> 003F" },
/* U+ff20 */ { 26, 0, 19, 0, "<wide> 0040" },
/* U+ff21 */ { 1, 0, 1, 0, "<wide> 0041" },
/* U+ff22 */ { 1, 0, 1, 0, "<wide> 0042" },
/* U+ff23 */ { 1, 0, 1, 0, "<wide> 0043" },
/* U+ff24 */ { 1, 0, 1, 0, "<wide> 0044" },
/* U+ff25 */ { 1, 0, 1, 0, "<wide> 0045" },
/* U+ff26 */ { 1, 0, 1, 0, "<wide> 0046" },
/* U+ff27 */ { 1, 0, 1, 0, "<wide> 0047" },
/* U+ff28 */ { 1, 0, 1, 0, "<wide> 0048" },
/* U+ff29 */ { 1, 0, 1, 0, "<wide> 0049" },
/* U+ff2a */ { 1, 0, 1, 0, "<wide> 004A" },
/* U+ff2b */ { 1, 0, 1, 0, "<wide> 004B" },
/* U+ff2c */ { 1, 0, 1, 0, "<wide> 004C" },
/* U+ff2d */ { 1, 0, 1, 0, "<wide> 004D" },
/* U+ff2e */ { 1, 0, 1, 0, "<wide> 004E" },
/* U+ff2f */ { 1, 0, 1, 0, "<wide> 004F" },
/* U+ff30 */ { 1, 0, 1, 0, "<wide> 0050" },
/* U+ff31 */ { 1, 0, 1, 0, "<wide> 0051" },
/* U+ff32 */ { 1, 0, 1, 0, "<wide> 0052" },
/* U+ff33 */ { 1, 0, 1, 0, "<wide> 0053" },
/* U+ff34 */ { 1, 0, 1, 0, "<wide> 0054" },
/* U+ff35 */ { 1, 0, 1, 0, "<wide> 0055" },
/* U+ff36 */ { 1, 0, 1, 0, "<wide> 0056" },
/* U+ff37 */ { 1, 0, 1, 0, "<wide> 0057" },
/* U+ff38 */ { 1, 0, 1, 0, "<wide> 0058" },
/* U+ff39 */ { 1, 0, 1, 0, "<wide> 0059" },
/* U+ff3a */ { 1, 0, 1, 0, "<wide> 005A" },
/* U+ff3b */ { 22, 0, 19, 0, "<wide> 005B" },
/* U+ff3c */ { 26, 0, 19, 0, "<wide> 005C" },
/* U+ff3d */ { 23, 0, 19, 0, "<wide> 005D" },
/* U+ff3e */ { 29, 0, 19, 0, "<wide> 005E" },
/* U+ff3f */ { 20, 0, 19, 0, "<wide> 005F" },
/* U+ff40 */ { 29, 0, 19, 0, "<wide> 0060" },
/* U+ff41 */ { 2, 0, 1, 0, "<wide> 0061" },
/* U+ff42 */ { 2, 0, 1, 0, "<wide> 0062" },
/* U+ff43 */ { 2, 0, 1, 0, "<wide> 0063" },
/* U+ff44 */ { 2, 0, 1, 0, "<wide> 0064" },
/* U+ff45 */ { 2, 0, 1, 0, "<wide> 0065" },
/* U+ff46 */ { 2, 0, 1, 0, "<wide> 0066" },
/* U+ff47 */ { 2, 0, 1, 0, "<wide> 0067" },
/* U+ff48 */ { 2, 0, 1, 0, "<wide> 0068" },
/* U+ff49 */ { 2, 0, 1, 0, "<wide> 0069" },
/* U+ff4a */ { 2, 0, 1, 0, "<wide> 006A" },
/* U+ff4b */ { 2, 0, 1, 0, "<wide> 006B" },
/* U+ff4c */ { 2, 0, 1, 0, "<wide> 006C" },
/* U+ff4d */ { 2, 0, 1, 0, "<wide> 006D" },
/* U+ff4e */ { 2, 0, 1, 0, "<wide> 006E" },
/* U+ff4f */ { 2, 0, 1, 0, "<wide> 006F" },
/* U+ff50 */ { 2, 0, 1, 0, "<wide> 0070" },
/* U+ff51 */ { 2, 0, 1, 0, "<wide> 0071" },
/* U+ff52 */ { 2, 0, 1, 0, "<wide> 0072" },
/* U+ff53 */ { 2, 0, 1, 0, "<wide> 0073" },
/* U+ff54 */ { 2, 0, 1, 0, "<wide> 0074" },
/* U+ff55 */ { 2, 0, 1, 0, "<wide> 0075" },
/* U+ff56 */ { 2, 0, 1, 0, "<wide> 0076" },
/* U+ff57 */ { 2, 0, 1, 0, "<wide> 0077" },
/* U+ff58 */ { 2, 0, 1, 0, "<wide> 0078" },
/* U+ff59 */ { 2, 0, 1, 0, "<wide> 0079" },
/* U+ff5a */ { 2, 0, 1, 0, "<wide> 007A" },
/* U+ff5b */ { 22, 0, 19, 0, "<wide> 007B" },
/* U+ff5c */ { 27, 0, 19, 0, "<wide> 007C" },
/* U+ff5d */ { 23, 0, 19, 0, "<wide> 007D" },
/* U+ff5e */ { 27, 0, 19, 0, "<wide> 007E" },
/* U+ff5f */ { 0, 0, 0, 0, 0 },
/* U+ff60 */ { 0, 0, 0, 0, 0 },
/* U+ff61 */ { 26, 0, 19, 0, "<narrow> 3002" },
/* U+ff62 */ { 22, 0, 19, 0, "<narrow> 300C" },
/* U+ff63 */ { 23, 0, 19, 0, "<narrow> 300D" },
/* U+ff64 */ { 26, 0, 19, 0, "<narrow> 3001" },
/* U+ff65 */ { 20, 0, 19, 0, "<narrow> 30FB" },
/* U+ff66 */ { 19, 0, 1, 0, "<narrow> 30F2" },
/* U+ff67 */ { 19, 0, 1, 0, "<narrow> 30A1" },
/* U+ff68 */ { 19, 0, 1, 0, "<narrow> 30A3" },
/* U+ff69 */ { 19, 0, 1, 0, "<narrow> 30A5" },
/* U+ff6a */ { 19, 0, 1, 0, "<narrow> 30A7" },
/* U+ff6b */ { 19, 0, 1, 0, "<narrow> 30A9" },
/* U+ff6c */ { 19, 0, 1, 0, "<narrow> 30E3" },
/* U+ff6d */ { 19, 0, 1, 0, "<narrow> 30E5" },
/* U+ff6e */ { 19, 0, 1, 0, "<narrow> 30E7" },
/* U+ff6f */ { 19, 0, 1, 0, "<narrow> 30C3" },
/* U+ff70 */ { 18, 0, 1, 0, "<narrow> 30FC" },
/* U+ff71 */ { 19, 0, 1, 0, "<narrow> 30A2" },
/* U+ff72 */ { 19, 0, 1, 0, "<narrow> 30A4" },
/* U+ff73 */ { 19, 0, 1, 0, "<narrow> 30A6" },
/* U+ff74 */ { 19, 0, 1, 0, "<narrow> 30A8" },
/* U+ff75 */ { 19, 0, 1, 0, "<narrow> 30AA" },
/* U+ff76 */ { 19, 0, 1, 0, "<narrow> 30AB" },
/* U+ff77 */ { 19, 0, 1, 0, "<narrow> 30AD" },
/* U+ff78 */ { 19, 0, 1, 0, "<narrow> 30AF" },
/* U+ff79 */ { 19, 0, 1, 0, "<narrow> 30B1" },
/* U+ff7a */ { 19, 0, 1, 0, "<narrow> 30B3" },
/* U+ff7b */ { 19, 0, 1, 0, "<narrow> 30B5" },
/* U+ff7c */ { 19, 0, 1, 0, "<narrow> 30B7" },
/* U+ff7d */ { 19, 0, 1, 0, "<narrow> 30B9" },
/* U+ff7e */ { 19, 0, 1, 0, "<narrow> 30BB" },
/* U+ff7f */ { 19, 0, 1, 0, "<narrow> 30BD" },
/* U+ff80 */ { 19, 0, 1, 0, "<narrow> 30BF" },
/* U+ff81 */ { 19, 0, 1, 0, "<narrow> 30C1" },
/* U+ff82 */ { 19, 0, 1, 0, "<narrow> 30C4" },
/* U+ff83 */ { 19, 0, 1, 0, "<narrow> 30C6" },
/* U+ff84 */ { 19, 0, 1, 0, "<narrow> 30C8" },
/* U+ff85 */ { 19, 0, 1, 0, "<narrow> 30CA" },
/* U+ff86 */ { 19, 0, 1, 0, "<narrow> 30CB" },
/* U+ff87 */ { 19, 0, 1, 0, "<narrow> 30CC" },
/* U+ff88 */ { 19, 0, 1, 0, "<narrow> 30CD" },
/* U+ff89 */ { 19, 0, 1, 0, "<narrow> 30CE" },
/* U+ff8a */ { 19, 0, 1, 0, "<narrow> 30CF" },
/* U+ff8b */ { 19, 0, 1, 0, "<narrow> 30D2" },
/* U+ff8c */ { 19, 0, 1, 0, "<narrow> 30D5" },
/* U+ff8d */ { 19, 0, 1, 0, "<narrow> 30D8" },
/* U+ff8e */ { 19, 0, 1, 0, "<narrow> 30DB" },
/* U+ff8f */ { 19, 0, 1, 0, "<narrow> 30DE" },
/* U+ff90 */ { 19, 0, 1, 0, "<narrow> 30DF" },
/* U+ff91 */ { 19, 0, 1, 0, "<narrow> 30E0" },
/* U+ff92 */ { 19, 0, 1, 0, "<narrow> 30E1" },
/* U+ff93 */ { 19, 0, 1, 0, "<narrow> 30E2" },
/* U+ff94 */ { 19, 0, 1, 0, "<narrow> 30E4" },
/* U+ff95 */ { 19, 0, 1, 0, "<narrow> 30E6" },
/* U+ff96 */ { 19, 0, 1, 0, "<narrow> 30E8" },
/* U+ff97 */ { 19, 0, 1, 0, "<narrow> 30E9" },
/* U+ff98 */ { 19, 0, 1, 0, "<narrow> 30EA" },
/* U+ff99 */ { 19, 0, 1, 0, "<narrow> 30EB" },
/* U+ff9a */ { 19, 0, 1, 0, "<narrow> 30EC" },
/* U+ff9b */ { 19, 0, 1, 0, "<narrow> 30ED" },
/* U+ff9c */ { 19, 0, 1, 0, "<narrow> 30EF" },
/* U+ff9d */ { 19, 0, 1, 0, "<narrow> 30F3" },
/* U+ff9e */ { 18, 0, 1, 0, "<narrow> 3099" },
/* U+ff9f */ { 18, 0, 1, 0, "<narrow> 309A" },
/* U+ffa0 */ { 19, 0, 1, 0, "<narrow> 3164" },
/* U+ffa1 */ { 19, 0, 1, 0, "<narrow> 3131" },
/* U+ffa2 */ { 19, 0, 1, 0, "<narrow> 3132" },
/* U+ffa3 */ { 19, 0, 1, 0, "<narrow> 3133" },
/* U+ffa4 */ { 19, 0, 1, 0, "<narrow> 3134" },
/* U+ffa5 */ { 19, 0, 1, 0, "<narrow> 3135" },
/* U+ffa6 */ { 19, 0, 1, 0, "<narrow> 3136" },
/* U+ffa7 */ { 19, 0, 1, 0, "<narrow> 3137" },
/* U+ffa8 */ { 19, 0, 1, 0, "<narrow> 3138" },
/* U+ffa9 */ { 19, 0, 1, 0, "<narrow> 3139" },
/* U+ffaa */ { 19, 0, 1, 0, "<narrow> 313A" },
/* U+ffab */ { 19, 0, 1, 0, "<narrow> 313B" },
/* U+ffac */ { 19, 0, 1, 0, "<narrow> 313C" },
/* U+ffad */ { 19, 0, 1, 0, "<narrow> 313D" },
/* U+ffae */ { 19, 0, 1, 0, "<narrow> 313E" },
/* U+ffaf */ { 19, 0, 1, 0, "<narrow> 313F" },
/* U+ffb0 */ { 19, 0, 1, 0, "<narrow> 3140" },
/* U+ffb1 */ { 19, 0, 1, 0, "<narrow> 3141" },
/* U+ffb2 */ { 19, 0, 1, 0, "<narrow> 3142" },
/* U+ffb3 */ { 19, 0, 1, 0, "<narrow> 3143" },
/* U+ffb4 */ { 19, 0, 1, 0, "<narrow> 3144" },
/* U+ffb5 */ { 19, 0, 1, 0, "<narrow> 3145" },
/* U+ffb6 */ { 19, 0, 1, 0, "<narrow> 3146" },
/* U+ffb7 */ { 19, 0, 1, 0, "<narrow> 3147" },
/* U+ffb8 */ { 19, 0, 1, 0, "<narrow> 3148" },
/* U+ffb9 */ { 19, 0, 1, 0, "<narrow> 3149" },
/* U+ffba */ { 19, 0, 1, 0, "<narrow> 314A" },
/* U+ffbb */ { 19, 0, 1, 0, "<narrow> 314B" },
/* U+ffbc */ { 19, 0, 1, 0, "<narrow> 314C" },
/* U+ffbd */ { 19, 0, 1, 0, "<narrow> 314D" },
/* U+ffbe */ { 19, 0, 1, 0, "<narrow> 314E" },
/* U+ffbf */ { 0, 0, 0, 0, 0 },
/* U+ffc0 */ { 0, 0, 0, 0, 0 },
/* U+ffc1 */ { 0, 0, 0, 0, 0 },
/* U+ffc2 */ { 19, 0, 1, 0, "<narrow> 314F" },
/* U+ffc3 */ { 19, 0, 1, 0, "<narrow> 3150" },
/* U+ffc4 */ { 19, 0, 1, 0, "<narrow> 3151" },
/* U+ffc5 */ { 19, 0, 1, 0, "<narrow> 3152" },
/* U+ffc6 */ { 19, 0, 1, 0, "<narrow> 3153" },
/* U+ffc7 */ { 19, 0, 1, 0, "<narrow> 3154" },
/* U+ffc8 */ { 0, 0, 0, 0, 0 },
/* U+ffc9 */ { 0, 0, 0, 0, 0 },
/* U+ffca */ { 19, 0, 1, 0, "<narrow> 3155" },
/* U+ffcb */ { 19, 0, 1, 0, "<narrow> 3156" },
/* U+ffcc */ { 19, 0, 1, 0, "<narrow> 3157" },
/* U+ffcd */ { 19, 0, 1, 0, "<narrow> 3158" },
/* U+ffce */ { 19, 0, 1, 0, "<narrow> 3159" },
/* U+ffcf */ { 19, 0, 1, 0, "<narrow> 315A" },
/* U+ffd0 */ { 0, 0, 0, 0, 0 },
/* U+ffd1 */ { 0, 0, 0, 0, 0 },
/* U+ffd2 */ { 19, 0, 1, 0, "<narrow> 315B" },
/* U+ffd3 */ { 19, 0, 1, 0, "<narrow> 315C" },
/* U+ffd4 */ { 19, 0, 1, 0, "<narrow> 315D" },
/* U+ffd5 */ { 19, 0, 1, 0, "<narrow> 315E" },
/* U+ffd6 */ { 19, 0, 1, 0, "<narrow> 315F" },
/* U+ffd7 */ { 19, 0, 1, 0, "<narrow> 3160" },
/* U+ffd8 */ { 0, 0, 0, 0, 0 },
/* U+ffd9 */ { 0, 0, 0, 0, 0 },
/* U+ffda */ { 19, 0, 1, 0, "<narrow> 3161" },
/* U+ffdb */ { 19, 0, 1, 0, "<narrow> 3162" },
/* U+ffdc */ { 19, 0, 1, 0, "<narrow> 3163" },
/* U+ffdd */ { 0, 0, 0, 0, 0 },
/* U+ffde */ { 0, 0, 0, 0, 0 },
/* U+ffdf */ { 0, 0, 0, 0, 0 },
/* U+ffe0 */ { 28, 0, 11, 0, "<wide> 00A2" },
/* U+ffe1 */ { 28, 0, 11, 0, "<wide> 00A3" },
/* U+ffe2 */ { 27, 0, 19, 0, "<wide> 00AC" },
/* U+ffe3 */ { 29, 0, 19, 0, "<wide> 00AF" },
/* U+ffe4 */ { 30, 0, 19, 0, "<wide> 00A6" },
/* U+ffe5 */ { 28, 0, 11, 0, "<wide> 00A5" },
/* U+ffe6 */ { 28, 0, 11, 0, "<wide> 20A9" },
/* U+ffe7 */ { 0, 0, 0, 0, 0 },
/* U+ffe8 */ { 30, 0, 19, 0, "<narrow> 2502" },
/* U+ffe9 */ { 27, 0, 19, 0, "<narrow> 2190" },
/* U+ffea */ { 27, 0, 19, 0, "<narrow> 2191" },
/* U+ffeb */ { 27, 0, 19, 0, "<narrow> 2192" },
/* U+ffec */ { 27, 0, 19, 0, "<narrow> 2193" },
/* U+ffed */ { 30, 0, 19, 0, "<narrow> 25A0" },
/* U+ffee */ { 30, 0, 19, 0, "<narrow> 25CB" },
/* U+ffef */ { 0, 0, 0, 0, 0 },
/* U+fff0 */ { 0, 0, 0, 0, 0 },
/* U+fff1 */ { 0, 0, 0, 0, 0 },
/* U+fff2 */ { 0, 0, 0, 0, 0 },
/* U+fff3 */ { 0, 0, 0, 0, 0 },
/* U+fff4 */ { 0, 0, 0, 0, 0 },
/* U+fff5 */ { 0, 0, 0, 0, 0 },
/* U+fff6 */ { 0, 0, 0, 0, 0 },
/* U+fff7 */ { 0, 0, 0, 0, 0 },
/* U+fff8 */ { 0, 0, 0, 0, 0 },
/* U+fff9 */ { 14, 0, 15, 0, 0 },
/* U+fffa */ { 14, 0, 15, 0, 0 },
/* U+fffb */ { 14, 0, 15, 0, 0 },
/* U+fffc */ { 30, 0, 19, 0, 0 },
/* U+fffd */ { 30, 0, 19, 0, 0 },
/* U+fffe */ { 0, 0, 0, 0, 0 },
/* U+ffff */ { 0, 0, 0, 0, 0 },

};

/* --- Unicode Database --------------------------------------------------- */

const _PyUnicode_DatabaseRecord *_PyUnicode_Database[16] = {
    _PyUnicode_Database_0,
    _PyUnicode_Database_1,
    _PyUnicode_Database_2,
    _PyUnicode_Database_3,
    _PyUnicode_Database_4,
    _PyUnicode_Database_5,
    _PyUnicode_Database_6,
    _PyUnicode_Database_7,
    _PyUnicode_Database_8,
    _PyUnicode_Database_9,
    _PyUnicode_Database_10,
    _PyUnicode_Database_11,
    _PyUnicode_Database_12,
    _PyUnicode_Database_13,
    _PyUnicode_Database_14,
    _PyUnicode_Database_15,
};

